from dataclasses import dataclass, field
from enum import Enum
from typing import ForwardRef, Optional

__NAMESPACE__ = "http://autosar.org/schema/r4.0"


class AbstractAccessPointSubtypesEnum(Enum):
    ABSTRACT_ACCESS_POINT = "ABSTRACT-ACCESS-POINT"
    ASYNCHRONOUS_SERVER_CALL_POINT = "ASYNCHRONOUS-SERVER-CALL-POINT"
    ASYNCHRONOUS_SERVER_CALL_RESULT_POINT = "ASYNCHRONOUS-SERVER-CALL-RESULT-POINT"
    EXTERNAL_TRIGGERING_POINT_IDENT = "EXTERNAL-TRIGGERING-POINT-IDENT"
    INTERNAL_TRIGGERING_POINT = "INTERNAL-TRIGGERING-POINT"
    MODE_ACCESS_POINT_IDENT = "MODE-ACCESS-POINT-IDENT"
    MODE_SWITCH_POINT = "MODE-SWITCH-POINT"
    PARAMETER_ACCESS = "PARAMETER-ACCESS"
    SERVER_CALL_POINT = "SERVER-CALL-POINT"
    SYNCHRONOUS_SERVER_CALL_POINT = "SYNCHRONOUS-SERVER-CALL-POINT"
    VARIABLE_ACCESS = "VARIABLE-ACCESS"


class AbstractCanCommunicationControllerSubtypesEnum(Enum):
    ABSTRACT_CAN_COMMUNICATION_CONTROLLER = "ABSTRACT-CAN-COMMUNICATION-CONTROLLER"
    CAN_COMMUNICATION_CONTROLLER = "CAN-COMMUNICATION-CONTROLLER"
    TTCAN_COMMUNICATION_CONTROLLER = "TTCAN-COMMUNICATION-CONTROLLER"


class AbstractEventSubtypesEnum(Enum):
    ABSTRACT_EVENT = "ABSTRACT-EVENT"
    ASYNCHRONOUS_SERVER_CALL_RETURNS_EVENT = "ASYNCHRONOUS-SERVER-CALL-RETURNS-EVENT"
    BACKGROUND_EVENT = "BACKGROUND-EVENT"
    BSW_ASYNCHRONOUS_SERVER_CALL_RETURNS_EVENT = "BSW-ASYNCHRONOUS-SERVER-CALL-RETURNS-EVENT"
    BSW_BACKGROUND_EVENT = "BSW-BACKGROUND-EVENT"
    BSW_DATA_RECEIVED_EVENT = "BSW-DATA-RECEIVED-EVENT"
    BSW_EVENT = "BSW-EVENT"
    BSW_EXTERNAL_TRIGGER_OCCURRED_EVENT = "BSW-EXTERNAL-TRIGGER-OCCURRED-EVENT"
    BSW_INTERNAL_TRIGGER_OCCURRED_EVENT = "BSW-INTERNAL-TRIGGER-OCCURRED-EVENT"
    BSW_MODE_MANAGER_ERROR_EVENT = "BSW-MODE-MANAGER-ERROR-EVENT"
    BSW_MODE_SWITCH_EVENT = "BSW-MODE-SWITCH-EVENT"
    BSW_MODE_SWITCHED_ACK_EVENT = "BSW-MODE-SWITCHED-ACK-EVENT"
    BSW_OPERATION_INVOKED_EVENT = "BSW-OPERATION-INVOKED-EVENT"
    BSW_OS_TASK_EXECUTION_EVENT = "BSW-OS-TASK-EXECUTION-EVENT"
    BSW_SCHEDULE_EVENT = "BSW-SCHEDULE-EVENT"
    BSW_TIMING_EVENT = "BSW-TIMING-EVENT"
    DATA_RECEIVE_ERROR_EVENT = "DATA-RECEIVE-ERROR-EVENT"
    DATA_RECEIVED_EVENT = "DATA-RECEIVED-EVENT"
    DATA_SEND_COMPLETED_EVENT = "DATA-SEND-COMPLETED-EVENT"
    DATA_WRITE_COMPLETED_EVENT = "DATA-WRITE-COMPLETED-EVENT"
    EXTERNAL_TRIGGER_OCCURRED_EVENT = "EXTERNAL-TRIGGER-OCCURRED-EVENT"
    INIT_EVENT = "INIT-EVENT"
    INTERNAL_TRIGGER_OCCURRED_EVENT = "INTERNAL-TRIGGER-OCCURRED-EVENT"
    MODE_SWITCHED_ACK_EVENT = "MODE-SWITCHED-ACK-EVENT"
    OPERATION_INVOKED_EVENT = "OPERATION-INVOKED-EVENT"
    OS_TASK_EXECUTION_EVENT = "OS-TASK-EXECUTION-EVENT"
    RTE_EVENT = "RTE-EVENT"
    SWC_MODE_MANAGER_ERROR_EVENT = "SWC-MODE-MANAGER-ERROR-EVENT"
    SWC_MODE_SWITCH_EVENT = "SWC-MODE-SWITCH-EVENT"
    TIMING_EVENT = "TIMING-EVENT"
    TRANSFORMER_HARD_ERROR_EVENT = "TRANSFORMER-HARD-ERROR-EVENT"


class AbstractIamRemoteSubjectSubtypesEnum(Enum):
    ABSTRACT_IAM_REMOTE_SUBJECT = "ABSTRACT-IAM-REMOTE-SUBJECT"
    IP_IAM_REMOTE_SUBJECT = "IP-IAM-REMOTE-SUBJECT"
    IP_SEC_IAM_REMOTE_SUBJECT = "IP-SEC-IAM-REMOTE-SUBJECT"
    TLS_IAM_REMOTE_SUBJECT = "TLS-IAM-REMOTE-SUBJECT"


class AbstractImplementationDataTypeSubtypesEnum(Enum):
    ABSTRACT_IMPLEMENTATION_DATA_TYPE = "ABSTRACT-IMPLEMENTATION-DATA-TYPE"
    CPP_IMPLEMENTATION_DATA_TYPE = "CPP-IMPLEMENTATION-DATA-TYPE"
    CUSTOM_CPP_IMPLEMENTATION_DATA_TYPE = "CUSTOM-CPP-IMPLEMENTATION-DATA-TYPE"
    IMPLEMENTATION_DATA_TYPE = "IMPLEMENTATION-DATA-TYPE"
    STD_CPP_IMPLEMENTATION_DATA_TYPE = "STD-CPP-IMPLEMENTATION-DATA-TYPE"


class AbstractImplementationDataTypeElementSubtypesEnum(Enum):
    ABSTRACT_IMPLEMENTATION_DATA_TYPE_ELEMENT = "ABSTRACT-IMPLEMENTATION-DATA-TYPE-ELEMENT"
    CPP_IMPLEMENTATION_DATA_TYPE_ELEMENT = "CPP-IMPLEMENTATION-DATA-TYPE-ELEMENT"
    IMPLEMENTATION_DATA_TYPE_ELEMENT = "IMPLEMENTATION-DATA-TYPE-ELEMENT"


class AbstractProvidedPortPrototypeSubtypesEnum(Enum):
    ABSTRACT_PROVIDED_PORT_PROTOTYPE = "ABSTRACT-PROVIDED-PORT-PROTOTYPE"
    P_PORT_PROTOTYPE = "P-PORT-PROTOTYPE"
    PR_PORT_PROTOTYPE = "PR-PORT-PROTOTYPE"


class AbstractRawDataStreamInterfaceSubtypesEnum(Enum):
    ABSTRACT_RAW_DATA_STREAM_INTERFACE = "ABSTRACT-RAW-DATA-STREAM-INTERFACE"
    RAW_DATA_STREAM_CLIENT_INTERFACE = "RAW-DATA-STREAM-CLIENT-INTERFACE"
    RAW_DATA_STREAM_SERVER_INTERFACE = "RAW-DATA-STREAM-SERVER-INTERFACE"


class AbstractRequiredPortPrototypeSubtypesEnum(Enum):
    ABSTRACT_REQUIRED_PORT_PROTOTYPE = "ABSTRACT-REQUIRED-PORT-PROTOTYPE"
    PR_PORT_PROTOTYPE = "PR-PORT-PROTOTYPE"
    R_PORT_PROTOTYPE = "R-PORT-PROTOTYPE"


class AbstractServiceInstanceSubtypesEnum(Enum):
    ABSTRACT_SERVICE_INSTANCE = "ABSTRACT-SERVICE-INSTANCE"
    CONSUMED_SERVICE_INSTANCE = "CONSUMED-SERVICE-INSTANCE"
    PROVIDED_SERVICE_INSTANCE = "PROVIDED-SERVICE-INSTANCE"


class AbstractSignalBasedToISignalTriggeringMappingSubtypesEnum(Enum):
    ABSTRACT_SIGNAL_BASED_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "ABSTRACT-SIGNAL-BASED-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_BASED_EVENT_ELEMENT_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-EVENT-ELEMENT-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_BASED_FIELD_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-FIELD-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_BASED_FIRE_AND_FORGET_METHOD_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-FIRE-AND-FORGET-METHOD-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_BASED_METHOD_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-METHOD-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_BASED_TRIGGER_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-TRIGGER-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )


class AccessControlEnumSimple(Enum):
    """
    :cvar CUSTOM: The access restriction to the resource is defined by a
        non-AUTOSAR process.
    :cvar MODELED: The access restriction to the resource is modeled in
        the AUTOSAR Application Design model or the AUTOSAR Deployment
        model.
    """

    CUSTOM = "CUSTOM"
    MODELED = "MODELED"


class AclObjectSetSubtypesEnum(Enum):
    ACL_OBJECT_SET = "ACL-OBJECT-SET"


class AclOperationSubtypesEnum(Enum):
    ACL_OPERATION = "ACL-OPERATION"


class AclRoleSubtypesEnum(Enum):
    ACL_ROLE = "ACL-ROLE"


class AclScopeEnumSimple(Enum):
    """
    :cvar DEPENDANT: This specifies that the AclPermission applies to
        dependant (in particular referenced) operations / objects as
        well. Note that this includes the descendant ones.
    :cvar DESCENDANT: This specifies that the AclPermission applies to
        descendant  operations / objects as well.
    :cvar EXPLICIT: This is indicates that the AclPermission applies to
        explicit objects / operations only.
    """

    DEPENDANT = "DEPENDANT"
    DESCENDANT = "DESCENDANT"
    EXPLICIT = "EXPLICIT"


class AdaptiveFirewallModuleInstantiationSubtypesEnum(Enum):
    ADAPTIVE_FIREWALL_MODULE_INSTANTIATION = "ADAPTIVE-FIREWALL-MODULE-INSTANTIATION"


class AdaptiveModuleInstantiationSubtypesEnum(Enum):
    ADAPTIVE_FIREWALL_MODULE_INSTANTIATION = "ADAPTIVE-FIREWALL-MODULE-INSTANTIATION"
    ADAPTIVE_MODULE_INSTANTIATION = "ADAPTIVE-MODULE-INSTANTIATION"
    CRYPTO_MODULE_INSTANTIATION = "CRYPTO-MODULE-INSTANTIATION"
    DETERMINISTIC_CLIENT = "DETERMINISTIC-CLIENT"
    DETERMINISTIC_SYNC_INSTANTIATION = "DETERMINISTIC-SYNC-INSTANTIATION"
    DETERMINISTIC_SYNC_MASTER = "DETERMINISTIC-SYNC-MASTER"
    DO_IP_INSTANTIATION = "DO-IP-INSTANTIATION"
    GENERIC_MODULE_INSTANTIATION = "GENERIC-MODULE-INSTANTIATION"
    IAM_MODULE_INSTANTIATION = "IAM-MODULE-INSTANTIATION"
    IDS_PLATFORM_INSTANTIATION = "IDS-PLATFORM-INSTANTIATION"
    IDSM_MODULE_INSTANTIATION = "IDSM-MODULE-INSTANTIATION"
    LOG_AND_TRACE_INSTANTIATION = "LOG-AND-TRACE-INSTANTIATION"
    NM_INSTANTIATION = "NM-INSTANTIATION"
    NON_OS_MODULE_INSTANTIATION = "NON-OS-MODULE-INSTANTIATION"
    OS_MODULE_INSTANTIATION = "OS-MODULE-INSTANTIATION"
    SOVD_GATEWAY_INSTANTIATION = "SOVD-GATEWAY-INSTANTIATION"
    SOVD_MODULE_INSTANTIATION = "SOVD-MODULE-INSTANTIATION"
    SOVD_SERVER_INSTANTIATION = "SOVD-SERVER-INSTANTIATION"
    STATE_MANAGEMENT_MODULE_INSTANTIATION = "STATE-MANAGEMENT-MODULE-INSTANTIATION"
    TIME_SYNC_MODULE_INSTANTIATION = "TIME-SYNC-MODULE-INSTANTIATION"
    UCM_MASTER_MODULE_INSTANTIATION = "UCM-MASTER-MODULE-INSTANTIATION"
    UCM_MODULE_INSTANTIATION = "UCM-MODULE-INSTANTIATION"
    UCM_SUBORDINATE_MODULE_INSTANTIATION = "UCM-SUBORDINATE-MODULE-INSTANTIATION"


class AdaptivePlatformServiceInstanceSubtypesEnum(Enum):
    ADAPTIVE_PLATFORM_SERVICE_INSTANCE = "ADAPTIVE-PLATFORM-SERVICE-INSTANCE"
    DDS_PROVIDED_SERVICE_INSTANCE = "DDS-PROVIDED-SERVICE-INSTANCE"
    DDS_REQUIRED_SERVICE_INSTANCE = "DDS-REQUIRED-SERVICE-INSTANCE"
    PROVIDED_AP_SERVICE_INSTANCE = "PROVIDED-AP-SERVICE-INSTANCE"
    PROVIDED_SOMEIP_SERVICE_INSTANCE = "PROVIDED-SOMEIP-SERVICE-INSTANCE"
    PROVIDED_USER_DEFINED_SERVICE_INSTANCE = "PROVIDED-USER-DEFINED-SERVICE-INSTANCE"
    REQUIRED_AP_SERVICE_INSTANCE = "REQUIRED-AP-SERVICE-INSTANCE"
    REQUIRED_SOMEIP_SERVICE_INSTANCE = "REQUIRED-SOMEIP-SERVICE-INSTANCE"
    REQUIRED_USER_DEFINED_SERVICE_INSTANCE = "REQUIRED-USER-DEFINED-SERVICE-INSTANCE"


class AdditionalBindingTimeEnumSimple(Enum):
    """
    :cvar BLUEPRINT_DERIVATION_TIME: The point in time when an object is
        created from a blueprint.
    :cvar POST_BUILD: After the executable has been built.
    """

    BLUEPRINT_DERIVATION_TIME = "BLUEPRINT-DERIVATION-TIME"
    POST_BUILD = "POST-BUILD"


@dataclass(slots=True, kw_only=True)
class Address:
    """
    This is used to specify an address within the CPU.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ADDRESS"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"0x[0-9a-z]*",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class AggregationTailoringSubtypesEnum(Enum):
    AGGREGATION_TAILORING = "AGGREGATION-TAILORING"


class AlignEnumSimple(Enum):
    """
    :cvar CENTER: The content of the table is horizontally centered.
    :cvar JUSTIFY: This indicates that the content of table cell shall
        be justified (rendered as a block where white-space is expanded
        such that all lines are filled up).
    :cvar LEFT: This indicates that the content of a table cell is left
        justified.
    :cvar RIGHT: This indicates that the content of a table cell is left
        justified.
    """

    CENTER = "CENTER"
    JUSTIFY = "JUSTIFY"
    LEFT = "LEFT"
    RIGHT = "RIGHT"


@dataclass(slots=True, kw_only=True)
class AlignmentType:
    """This primitive represents the alignment of objects within a memory section.

    The value is in number of bits or UNKNOWN (deprecated), 8 , 16, 32,
    64 UNSPECIFIED, BOOLEAN, or PTR. Typical values for numbers are 8,
    16, 32, 64.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ALIGNMENT-TYPE"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"[1-9][0-9]*|0[xX][0-9a-fA-F]*|0[bB][0-1]+|0[0-7]*|UNSPECIFIED|UNKNOWN|BOOLEAN|PTR",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class AllocatorSubtypesEnum(Enum):
    ALLOCATOR = "ALLOCATOR"


@dataclass(slots=True, kw_only=True)
class AnyServiceInstanceId:
    """This is a positive integer or the literal ALL (the value ANY is technically
    supported but deprecated) which can be denoted in decimal, octal and
    hexadecimal.

    The value is between 0 and 65535.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ANY-SERVICE-INSTANCE-ID"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"[1-9][0-9]*|0[xX][0-9a-fA-F]+|0[0-7]*|0[bB][0-1]+|ANY|ALL",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class AnyVersionString:
    """
    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ANY-VERSION-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"[0-9]+|ANY",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class ApApplicationEndpointSubtypesEnum(Enum):
    AP_APPLICATION_ENDPOINT = "AP-APPLICATION-ENDPOINT"


class ApApplicationErrorSubtypesEnum(Enum):
    AP_APPLICATION_ERROR = "AP-APPLICATION-ERROR"


class ApApplicationErrorDomainSubtypesEnum(Enum):
    AP_APPLICATION_ERROR_DOMAIN = "AP-APPLICATION-ERROR-DOMAIN"


class ApApplicationErrorSetSubtypesEnum(Enum):
    AP_APPLICATION_ERROR_SET = "AP-APPLICATION-ERROR-SET"


class ApSomeipTransformationPropsSubtypesEnum(Enum):
    AP_SOMEIP_TRANSFORMATION_PROPS = "AP-SOMEIP-TRANSFORMATION-PROPS"


class ApiPrincipleEnumSimple(Enum):
    """
    :cvar COMMON: The Rte or SchM API is provided for the whole software
        component / BSW Module
    :cvar PER_EXECUTABLE: The Rte or SchM API is provided for a specific
        ExecutableEntity of a software component / BSW Module
    """

    COMMON = "COMMON"
    PER_EXECUTABLE = "PER-EXECUTABLE"


class ApplicationArrayElementSubtypesEnum(Enum):
    APPLICATION_ARRAY_ELEMENT = "APPLICATION-ARRAY-ELEMENT"


class ApplicationCompositeElementDataPrototypeSubtypesEnum(Enum):
    APPLICATION_ARRAY_ELEMENT = "APPLICATION-ARRAY-ELEMENT"
    APPLICATION_ASSOC_MAP_ELEMENT = "APPLICATION-ASSOC-MAP-ELEMENT"
    APPLICATION_COMPOSITE_ELEMENT_DATA_PROTOTYPE = "APPLICATION-COMPOSITE-ELEMENT-DATA-PROTOTYPE"
    APPLICATION_RECORD_ELEMENT = "APPLICATION-RECORD-ELEMENT"


class ApplicationDataTypeSubtypesEnum(Enum):
    APPLICATION_ARRAY_DATA_TYPE = "APPLICATION-ARRAY-DATA-TYPE"
    APPLICATION_ASSOC_MAP_DATA_TYPE = "APPLICATION-ASSOC-MAP-DATA-TYPE"
    APPLICATION_COMPOSITE_DATA_TYPE = "APPLICATION-COMPOSITE-DATA-TYPE"
    APPLICATION_DATA_TYPE = "APPLICATION-DATA-TYPE"
    APPLICATION_DEFERRED_DATA_TYPE = "APPLICATION-DEFERRED-DATA-TYPE"
    APPLICATION_PRIMITIVE_DATA_TYPE = "APPLICATION-PRIMITIVE-DATA-TYPE"
    APPLICATION_RECORD_DATA_TYPE = "APPLICATION-RECORD-DATA-TYPE"


class ApplicationEndpointSubtypesEnum(Enum):
    APPLICATION_ENDPOINT = "APPLICATION-ENDPOINT"


class ApplicationErrorSubtypesEnum(Enum):
    APPLICATION_ERROR = "APPLICATION-ERROR"


class ApplicationPartitionSubtypesEnum(Enum):
    APPLICATION_PARTITION = "APPLICATION-PARTITION"


class ApplicationPrimitiveDataTypeSubtypesEnum(Enum):
    APPLICATION_PRIMITIVE_DATA_TYPE = "APPLICATION-PRIMITIVE-DATA-TYPE"


class ApplicationRecordElementSubtypesEnum(Enum):
    APPLICATION_RECORD_ELEMENT = "APPLICATION-RECORD-ELEMENT"


class ArElementSubtypesEnum(Enum):
    ABSTRACT_EXECUTION_CONTEXT = "ABSTRACT-EXECUTION-CONTEXT"
    ABSTRACT_IAM_REMOTE_SUBJECT = "ABSTRACT-IAM-REMOTE-SUBJECT"
    ABSTRACT_IMPLEMENTATION_DATA_TYPE = "ABSTRACT-IMPLEMENTATION-DATA-TYPE"
    ABSTRACT_RAW_DATA_STREAM_INTERFACE = "ABSTRACT-RAW-DATA-STREAM-INTERFACE"
    ABSTRACT_SYNCHRONIZED_TIME_BASE_INTERFACE = "ABSTRACT-SYNCHRONIZED-TIME-BASE-INTERFACE"
    ACL_OBJECT_SET = "ACL-OBJECT-SET"
    ACL_OPERATION = "ACL-OPERATION"
    ACL_PERMISSION = "ACL-PERMISSION"
    ACL_ROLE = "ACL-ROLE"
    ADAPTIVE_APPLICATION_SW_COMPONENT_TYPE = "ADAPTIVE-APPLICATION-SW-COMPONENT-TYPE"
    ADAPTIVE_FIREWALL_TO_PORT_PROTOTYPE_MAPPING = "ADAPTIVE-FIREWALL-TO-PORT-PROTOTYPE-MAPPING"
    ADAPTIVE_PLATFORM_SERVICE_INSTANCE = "ADAPTIVE-PLATFORM-SERVICE-INSTANCE"
    ALIAS_NAME_SET = "ALIAS-NAME-SET"
    ALLOCATOR = "ALLOCATOR"
    AP_APPLICATION_ERROR = "AP-APPLICATION-ERROR"
    AP_APPLICATION_ERROR_DOMAIN = "AP-APPLICATION-ERROR-DOMAIN"
    AP_APPLICATION_ERROR_SET = "AP-APPLICATION-ERROR-SET"
    APPLICATION_ARRAY_DATA_TYPE = "APPLICATION-ARRAY-DATA-TYPE"
    APPLICATION_ASSOC_MAP_DATA_TYPE = "APPLICATION-ASSOC-MAP-DATA-TYPE"
    APPLICATION_COMPOSITE_DATA_TYPE = "APPLICATION-COMPOSITE-DATA-TYPE"
    APPLICATION_DATA_TYPE = "APPLICATION-DATA-TYPE"
    APPLICATION_DEFERRED_DATA_TYPE = "APPLICATION-DEFERRED-DATA-TYPE"
    APPLICATION_INTERFACE = "APPLICATION-INTERFACE"
    APPLICATION_PARTITION = "APPLICATION-PARTITION"
    APPLICATION_PRIMITIVE_DATA_TYPE = "APPLICATION-PRIMITIVE-DATA-TYPE"
    APPLICATION_RECORD_DATA_TYPE = "APPLICATION-RECORD-DATA-TYPE"
    APPLICATION_SW_COMPONENT_TYPE = "APPLICATION-SW-COMPONENT-TYPE"
    AR_ELEMENT = "AR-ELEMENT"
    ARTIFACT_CHECKSUM_TO_CRYPTO_PROVIDER_MAPPING = "ARTIFACT-CHECKSUM-TO-CRYPTO-PROVIDER-MAPPING"
    ATOMIC_SW_COMPONENT_TYPE = "ATOMIC-SW-COMPONENT-TYPE"
    AUTOSAR_DATA_TYPE = "AUTOSAR-DATA-TYPE"
    BASE_TYPE = "BASE-TYPE"
    BLUEPRINT_MAPPING_SET = "BLUEPRINT-MAPPING-SET"
    BSW_COMPOSITION_TIMING = "BSW-COMPOSITION-TIMING"
    BSW_ENTRY_RELATIONSHIP_SET = "BSW-ENTRY-RELATIONSHIP-SET"
    BSW_IMPLEMENTATION = "BSW-IMPLEMENTATION"
    BSW_MODULE_DESCRIPTION = "BSW-MODULE-DESCRIPTION"
    BSW_MODULE_ENTRY = "BSW-MODULE-ENTRY"
    BSW_MODULE_TIMING = "BSW-MODULE-TIMING"
    BUILD_ACTION_MANIFEST = "BUILD-ACTION-MANIFEST"
    CALIBRATION_PARAMETER_VALUE_SET = "CALIBRATION-PARAMETER-VALUE-SET"
    CAN_XL_PROPS = "CAN-XL-PROPS"
    CLIENT_ID_DEFINITION_SET = "CLIENT-ID-DEFINITION-SET"
    CLIENT_SERVER_INTERFACE = "CLIENT-SERVER-INTERFACE"
    CLIENT_SERVER_INTERFACE_TO_BSW_MODULE_ENTRY_BLUEPRINT_MAPPING = (
        "CLIENT-SERVER-INTERFACE-TO-BSW-MODULE-ENTRY-BLUEPRINT-MAPPING"
    )
    COLLECTION = "COLLECTION"
    COM_CERTIFICATE_TO_CRYPTO_CERTIFICATE_MAPPING = "COM-CERTIFICATE-TO-CRYPTO-CERTIFICATE-MAPPING"
    COM_EVENT_GRANT = "COM-EVENT-GRANT"
    COM_EVENT_GRANT_DESIGN = "COM-EVENT-GRANT-DESIGN"
    COM_FIELD_GRANT = "COM-FIELD-GRANT"
    COM_FIELD_GRANT_DESIGN = "COM-FIELD-GRANT-DESIGN"
    COM_FIND_SERVICE_GRANT = "COM-FIND-SERVICE-GRANT"
    COM_FIND_SERVICE_GRANT_DESIGN = "COM-FIND-SERVICE-GRANT-DESIGN"
    COM_GRANT = "COM-GRANT"
    COM_GRANT_DESIGN = "COM-GRANT-DESIGN"
    COM_KEY_TO_CRYPTO_KEY_SLOT_MAPPING = "COM-KEY-TO-CRYPTO-KEY-SLOT-MAPPING"
    COM_METHOD_GRANT = "COM-METHOD-GRANT"
    COM_METHOD_GRANT_DESIGN = "COM-METHOD-GRANT-DESIGN"
    COM_OFFER_SERVICE_GRANT = "COM-OFFER-SERVICE-GRANT"
    COM_OFFER_SERVICE_GRANT_DESIGN = "COM-OFFER-SERVICE-GRANT-DESIGN"
    COM_SEC_OC_TO_CRYPTO_KEY_SLOT_MAPPING = "COM-SEC-OC-TO-CRYPTO-KEY-SLOT-MAPPING"
    COM_TRIGGER_GRANT_DESIGN = "COM-TRIGGER-GRANT-DESIGN"
    COMPLEX_DEVICE_DRIVER_SW_COMPONENT_TYPE = "COMPLEX-DEVICE-DRIVER-SW-COMPONENT-TYPE"
    COMPOSITION_P_PORT_TO_EXECUTABLE_P_PORT_MAPPING = (
        "COMPOSITION-P-PORT-TO-EXECUTABLE-P-PORT-MAPPING"
    )
    COMPOSITION_PORT_TO_EXECUTABLE_PORT_MAPPING = "COMPOSITION-PORT-TO-EXECUTABLE-PORT-MAPPING"
    COMPOSITION_R_PORT_TO_EXECUTABLE_R_PORT_MAPPING = (
        "COMPOSITION-R-PORT-TO-EXECUTABLE-R-PORT-MAPPING"
    )
    COMPOSITION_SW_COMPONENT_TYPE = "COMPOSITION-SW-COMPONENT-TYPE"
    COMPU_METHOD = "COMPU-METHOD"
    CONSISTENCY_NEEDS_BLUEPRINT_SET = "CONSISTENCY-NEEDS-BLUEPRINT-SET"
    CONSTANT_SPECIFICATION = "CONSTANT-SPECIFICATION"
    CONSTANT_SPECIFICATION_MAPPING_SET = "CONSTANT-SPECIFICATION-MAPPING-SET"
    CP_SOFTWARE_CLUSTER = "CP-SOFTWARE-CLUSTER"
    CP_SOFTWARE_CLUSTER_BINARY_MANIFEST_DESCRIPTOR = (
        "CP-SOFTWARE-CLUSTER-BINARY-MANIFEST-DESCRIPTOR"
    )
    CP_SOFTWARE_CLUSTER_MAPPING_SET = "CP-SOFTWARE-CLUSTER-MAPPING-SET"
    CP_SOFTWARE_CLUSTER_RESOURCE_POOL = "CP-SOFTWARE-CLUSTER-RESOURCE-POOL"
    CP_SW_CLUSTER_RESOURCE_TO_DIAG_DATA_ELEM_MAPPING = (
        "CP-SW-CLUSTER-RESOURCE-TO-DIAG-DATA-ELEM-MAPPING"
    )
    CP_SW_CLUSTER_RESOURCE_TO_DIAG_FUNCTION_ID_MAPPING = (
        "CP-SW-CLUSTER-RESOURCE-TO-DIAG-FUNCTION-ID-MAPPING"
    )
    CP_SW_CLUSTER_TO_DIAG_EVENT_MAPPING = "CP-SW-CLUSTER-TO-DIAG-EVENT-MAPPING"
    CP_SW_CLUSTER_TO_DIAG_ROUTINE_SUBFUNCTION_MAPPING = (
        "CP-SW-CLUSTER-TO-DIAG-ROUTINE-SUBFUNCTION-MAPPING"
    )
    CPP_IMPLEMENTATION_DATA_TYPE = "CPP-IMPLEMENTATION-DATA-TYPE"
    CRYPTO_CERTIFICATE_INTERFACE = "CRYPTO-CERTIFICATE-INTERFACE"
    CRYPTO_CERTIFICATE_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-CERTIFICATE-TO-PORT-PROTOTYPE-MAPPING"
    CRYPTO_ELLIPTIC_CURVE_PROPS = "CRYPTO-ELLIPTIC-CURVE-PROPS"
    CRYPTO_INTERFACE = "CRYPTO-INTERFACE"
    CRYPTO_KEY_SLOT_INTERFACE = "CRYPTO-KEY-SLOT-INTERFACE"
    CRYPTO_KEY_SLOT_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-KEY-SLOT-TO-PORT-PROTOTYPE-MAPPING"
    CRYPTO_PROVIDER_INTERFACE = "CRYPTO-PROVIDER-INTERFACE"
    CRYPTO_PROVIDER_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-PROVIDER-TO-PORT-PROTOTYPE-MAPPING"
    CRYPTO_SERVICE_CERTIFICATE = "CRYPTO-SERVICE-CERTIFICATE"
    CRYPTO_SERVICE_KEY = "CRYPTO-SERVICE-KEY"
    CRYPTO_SERVICE_PRIMITIVE = "CRYPTO-SERVICE-PRIMITIVE"
    CRYPTO_SERVICE_QUEUE = "CRYPTO-SERVICE-QUEUE"
    CRYPTO_SIGNATURE_SCHEME = "CRYPTO-SIGNATURE-SCHEME"
    CRYPTO_TRUST_MASTER_INTERFACE = "CRYPTO-TRUST-MASTER-INTERFACE"
    CUSTOM_CPP_IMPLEMENTATION_DATA_TYPE = "CUSTOM-CPP-IMPLEMENTATION-DATA-TYPE"
    DATA_CONSTR = "DATA-CONSTR"
    DATA_EXCHANGE_POINT = "DATA-EXCHANGE-POINT"
    DATA_INTERFACE = "DATA-INTERFACE"
    DATA_TRANSFORMATION_SET = "DATA-TRANSFORMATION-SET"
    DATA_TYPE_MAPPING_SET = "DATA-TYPE-MAPPING-SET"
    DDS_PROVIDED_SERVICE_INSTANCE = "DDS-PROVIDED-SERVICE-INSTANCE"
    DDS_REQUIRED_SERVICE_INSTANCE = "DDS-REQUIRED-SERVICE-INSTANCE"
    DDS_SECURE_COM_PROPS = "DDS-SECURE-COM-PROPS"
    DDS_SECURE_GOVERNANCE = "DDS-SECURE-GOVERNANCE"
    DDS_SERVICE_INSTANCE_TO_MACHINE_MAPPING = "DDS-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    DDS_SERVICE_INTERFACE_DEPLOYMENT = "DDS-SERVICE-INTERFACE-DEPLOYMENT"
    DDS_TOPIC_ACCESS_RULE = "DDS-TOPIC-ACCESS-RULE"
    DETERMINISTIC_CLIENT = "DETERMINISTIC-CLIENT"
    DETERMINISTIC_SYNC_MASTER_TO_TIME_BASE_CONSUMER_MAPPING = (
        "DETERMINISTIC-SYNC-MASTER-TO-TIME-BASE-CONSUMER-MAPPING"
    )
    DIAGNOSTIC_ABSTRACT_ALIAS_EVENT = "DIAGNOSTIC-ABSTRACT-ALIAS-EVENT"
    DIAGNOSTIC_ABSTRACT_DATA_IDENTIFIER = "DIAGNOSTIC-ABSTRACT-DATA-IDENTIFIER"
    DIAGNOSTIC_ABSTRACT_DATA_IDENTIFIER_INTERFACE = "DIAGNOSTIC-ABSTRACT-DATA-IDENTIFIER-INTERFACE"
    DIAGNOSTIC_ABSTRACT_ROUTINE_INTERFACE = "DIAGNOSTIC-ABSTRACT-ROUTINE-INTERFACE"
    DIAGNOSTIC_ACCESS_PERMISSION = "DIAGNOSTIC-ACCESS-PERMISSION"
    DIAGNOSTIC_AGING = "DIAGNOSTIC-AGING"
    DIAGNOSTIC_AUTH_ROLE = "DIAGNOSTIC-AUTH-ROLE"
    DIAGNOSTIC_AUTHENTICATION = "DIAGNOSTIC-AUTHENTICATION"
    DIAGNOSTIC_AUTHENTICATION_CLASS = "DIAGNOSTIC-AUTHENTICATION-CLASS"
    DIAGNOSTIC_AUTHENTICATION_CONFIGURATION = "DIAGNOSTIC-AUTHENTICATION-CONFIGURATION"
    DIAGNOSTIC_AUTHENTICATION_INTERFACE = "DIAGNOSTIC-AUTHENTICATION-INTERFACE"
    DIAGNOSTIC_AUTHENTICATION_PORT_MAPPING = "DIAGNOSTIC-AUTHENTICATION-PORT-MAPPING"
    DIAGNOSTIC_CLEAR_CONDITION = "DIAGNOSTIC-CLEAR-CONDITION"
    DIAGNOSTIC_CLEAR_CONDITION_GROUP = "DIAGNOSTIC-CLEAR-CONDITION-GROUP"
    DIAGNOSTIC_CLEAR_CONDITION_PORT_MAPPING = "DIAGNOSTIC-CLEAR-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_CLEAR_DIAGNOSTIC_INFORMATION = "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION"
    DIAGNOSTIC_CLEAR_DIAGNOSTIC_INFORMATION_CLASS = "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION-CLASS"
    DIAGNOSTIC_CLEAR_RESET_EMISSION_RELATED_INFO = "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO"
    DIAGNOSTIC_CLEAR_RESET_EMISSION_RELATED_INFO_CLASS = (
        "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO-CLASS"
    )
    DIAGNOSTIC_COM_CONTROL = "DIAGNOSTIC-COM-CONTROL"
    DIAGNOSTIC_COM_CONTROL_CLASS = "DIAGNOSTIC-COM-CONTROL-CLASS"
    DIAGNOSTIC_COM_CONTROL_INTERFACE = "DIAGNOSTIC-COM-CONTROL-INTERFACE"
    DIAGNOSTIC_COMMON_ELEMENT = "DIAGNOSTIC-COMMON-ELEMENT"
    DIAGNOSTIC_CONDITION = "DIAGNOSTIC-CONDITION"
    DIAGNOSTIC_CONDITION_GROUP = "DIAGNOSTIC-CONDITION-GROUP"
    DIAGNOSTIC_CONDITION_INTERFACE = "DIAGNOSTIC-CONDITION-INTERFACE"
    DIAGNOSTIC_CONNECTION = "DIAGNOSTIC-CONNECTION"
    DIAGNOSTIC_CONTRIBUTION_SET = "DIAGNOSTIC-CONTRIBUTION-SET"
    DIAGNOSTIC_CONTROL_DTC_SETTING = "DIAGNOSTIC-CONTROL-DTC-SETTING"
    DIAGNOSTIC_CONTROL_DTC_SETTING_CLASS = "DIAGNOSTIC-CONTROL-DTC-SETTING-CLASS"
    DIAGNOSTIC_CUSTOM_SERVICE_CLASS = "DIAGNOSTIC-CUSTOM-SERVICE-CLASS"
    DIAGNOSTIC_CUSTOM_SERVICE_INSTANCE = "DIAGNOSTIC-CUSTOM-SERVICE-INSTANCE"
    DIAGNOSTIC_DATA_BY_IDENTIFIER = "DIAGNOSTIC-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_DATA_ELEMENT_INTERFACE = "DIAGNOSTIC-DATA-ELEMENT-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER = "DIAGNOSTIC-DATA-IDENTIFIER"
    DIAGNOSTIC_DATA_IDENTIFIER_GENERIC_INTERFACE = "DIAGNOSTIC-DATA-IDENTIFIER-GENERIC-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER_INTERFACE = "DIAGNOSTIC-DATA-IDENTIFIER-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER_SET = "DIAGNOSTIC-DATA-IDENTIFIER-SET"
    DIAGNOSTIC_DATA_PORT_MAPPING = "DIAGNOSTIC-DATA-PORT-MAPPING"
    DIAGNOSTIC_DATA_TRANSFER = "DIAGNOSTIC-DATA-TRANSFER"
    DIAGNOSTIC_DATA_TRANSFER_CLASS = "DIAGNOSTIC-DATA-TRANSFER-CLASS"
    DIAGNOSTIC_DE_AUTHENTICATION = "DIAGNOSTIC-DE-AUTHENTICATION"
    DIAGNOSTIC_DEM_PROVIDED_DATA_MAPPING = "DIAGNOSTIC-DEM-PROVIDED-DATA-MAPPING"
    DIAGNOSTIC_DO_IP_ACTIVATION_LINE_INTERFACE = "DIAGNOSTIC-DO-IP-ACTIVATION-LINE-INTERFACE"
    DIAGNOSTIC_DO_IP_ENTITY_IDENTIFICATION_INTERFACE = (
        "DIAGNOSTIC-DO-IP-ENTITY-IDENTIFICATION-INTERFACE"
    )
    DIAGNOSTIC_DO_IP_GROUP_IDENTIFICATION_INTERFACE = (
        "DIAGNOSTIC-DO-IP-GROUP-IDENTIFICATION-INTERFACE"
    )
    DIAGNOSTIC_DO_IP_POWER_MODE_INTERFACE = "DIAGNOSTIC-DO-IP-POWER-MODE-INTERFACE"
    DIAGNOSTIC_DO_IP_TRIGGER_VEHICLE_ANNOUNCEMENT_INTERFACE = (
        "DIAGNOSTIC-DO-IP-TRIGGER-VEHICLE-ANNOUNCEMENT-INTERFACE"
    )
    DIAGNOSTIC_DOWNLOAD_INTERFACE = "DIAGNOSTIC-DOWNLOAD-INTERFACE"
    DIAGNOSTIC_DTC_INFORMATION_INTERFACE = "DIAGNOSTIC-DTC-INFORMATION-INTERFACE"
    DIAGNOSTIC_DYNAMIC_DATA_IDENTIFIER = "DIAGNOSTIC-DYNAMIC-DATA-IDENTIFIER"
    DIAGNOSTIC_DYNAMICALLY_DEFINE_DATA_IDENTIFIER = "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER"
    DIAGNOSTIC_DYNAMICALLY_DEFINE_DATA_IDENTIFIER_CLASS = (
        "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER-CLASS"
    )
    DIAGNOSTIC_ECU_INSTANCE_PROPS = "DIAGNOSTIC-ECU-INSTANCE-PROPS"
    DIAGNOSTIC_ECU_RESET = "DIAGNOSTIC-ECU-RESET"
    DIAGNOSTIC_ECU_RESET_CLASS = "DIAGNOSTIC-ECU-RESET-CLASS"
    DIAGNOSTIC_ECU_RESET_INTERFACE = "DIAGNOSTIC-ECU-RESET-INTERFACE"
    DIAGNOSTIC_ENABLE_CONDITION = "DIAGNOSTIC-ENABLE-CONDITION"
    DIAGNOSTIC_ENABLE_CONDITION_GROUP = "DIAGNOSTIC-ENABLE-CONDITION-GROUP"
    DIAGNOSTIC_ENABLE_CONDITION_PORT_MAPPING = "DIAGNOSTIC-ENABLE-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_ENVIRONMENTAL_CONDITION = "DIAGNOSTIC-ENVIRONMENTAL-CONDITION"
    DIAGNOSTIC_EVENT = "DIAGNOSTIC-EVENT"
    DIAGNOSTIC_EVENT_INTERFACE = "DIAGNOSTIC-EVENT-INTERFACE"
    DIAGNOSTIC_EVENT_PORT_MAPPING = "DIAGNOSTIC-EVENT-PORT-MAPPING"
    DIAGNOSTIC_EVENT_TO_DEBOUNCE_ALGORITHM_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-DEBOUNCE-ALGORITHM-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_ENABLE_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-ENABLE-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_OPERATION_CYCLE_MAPPING = "DIAGNOSTIC-EVENT-TO-OPERATION-CYCLE-MAPPING"
    DIAGNOSTIC_EVENT_TO_SECURITY_EVENT_MAPPING = "DIAGNOSTIC-EVENT-TO-SECURITY-EVENT-MAPPING"
    DIAGNOSTIC_EVENT_TO_STORAGE_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-STORAGE-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_TROUBLE_CODE_J_1939_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-TROUBLE-CODE-J-1939-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_TROUBLE_CODE_UDS_MAPPING = "DIAGNOSTIC-EVENT-TO-TROUBLE-CODE-UDS-MAPPING"
    DIAGNOSTIC_EXTENDED_DATA_RECORD = "DIAGNOSTIC-EXTENDED-DATA-RECORD"
    DIAGNOSTIC_EXTERNAL_AUTHENTICATION_INTERFACE = "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-INTERFACE"
    DIAGNOSTIC_EXTERNAL_AUTHENTICATION_PORT_MAPPING = (
        "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-PORT-MAPPING"
    )
    DIAGNOSTIC_FIM_ALIAS_EVENT = "DIAGNOSTIC-FIM-ALIAS-EVENT"
    DIAGNOSTIC_FIM_ALIAS_EVENT_GROUP = "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP"
    DIAGNOSTIC_FIM_ALIAS_EVENT_GROUP_MAPPING = "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP-MAPPING"
    DIAGNOSTIC_FIM_ALIAS_EVENT_MAPPING = "DIAGNOSTIC-FIM-ALIAS-EVENT-MAPPING"
    DIAGNOSTIC_FIM_EVENT_GROUP = "DIAGNOSTIC-FIM-EVENT-GROUP"
    DIAGNOSTIC_FIM_FUNCTION_MAPPING = "DIAGNOSTIC-FIM-FUNCTION-MAPPING"
    DIAGNOSTIC_FREEZE_FRAME = "DIAGNOSTIC-FREEZE-FRAME"
    DIAGNOSTIC_FUNCTION_IDENTIFIER = "DIAGNOSTIC-FUNCTION-IDENTIFIER"
    DIAGNOSTIC_FUNCTION_IDENTIFIER_INHIBIT = "DIAGNOSTIC-FUNCTION-IDENTIFIER-INHIBIT"
    DIAGNOSTIC_GENERIC_UDS_INTERFACE = "DIAGNOSTIC-GENERIC-UDS-INTERFACE"
    DIAGNOSTIC_INDICATOR = "DIAGNOSTIC-INDICATOR"
    DIAGNOSTIC_INDICATOR_INTERFACE = "DIAGNOSTIC-INDICATOR-INTERFACE"
    DIAGNOSTIC_INDICATOR_PORT_MAPPING = "DIAGNOSTIC-INDICATOR-PORT-MAPPING"
    DIAGNOSTIC_INFO_TYPE = "DIAGNOSTIC-INFO-TYPE"
    DIAGNOSTIC_INHIBIT_SOURCE_EVENT_MAPPING = "DIAGNOSTIC-INHIBIT-SOURCE-EVENT-MAPPING"
    DIAGNOSTIC_IO_CONTROL = "DIAGNOSTIC-IO-CONTROL"
    DIAGNOSTIC_IO_CONTROL_CLASS = "DIAGNOSTIC-IO-CONTROL-CLASS"
    DIAGNOSTIC_IUMPR = "DIAGNOSTIC-IUMPR"
    DIAGNOSTIC_IUMPR_DENOMINATOR_GROUP = "DIAGNOSTIC-IUMPR-DENOMINATOR-GROUP"
    DIAGNOSTIC_IUMPR_GROUP = "DIAGNOSTIC-IUMPR-GROUP"
    DIAGNOSTIC_IUMPR_TO_FUNCTION_IDENTIFIER_MAPPING = (
        "DIAGNOSTIC-IUMPR-TO-FUNCTION-IDENTIFIER-MAPPING"
    )
    DIAGNOSTIC_J_1939_EXPANDED_FREEZE_FRAME = "DIAGNOSTIC-J-1939-EXPANDED-FREEZE-FRAME"
    DIAGNOSTIC_J_1939_FREEZE_FRAME = "DIAGNOSTIC-J-1939-FREEZE-FRAME"
    DIAGNOSTIC_J_1939_NODE = "DIAGNOSTIC-J-1939-NODE"
    DIAGNOSTIC_J_1939_SPN = "DIAGNOSTIC-J-1939-SPN"
    DIAGNOSTIC_J_1939_SPN_MAPPING = "DIAGNOSTIC-J-1939-SPN-MAPPING"
    DIAGNOSTIC_J_1939_SW_MAPPING = "DIAGNOSTIC-J-1939-SW-MAPPING"
    DIAGNOSTIC_MAPPING = "DIAGNOSTIC-MAPPING"
    DIAGNOSTIC_MASTER_TO_SLAVE_EVENT_MAPPING = "DIAGNOSTIC-MASTER-TO-SLAVE-EVENT-MAPPING"
    DIAGNOSTIC_MASTER_TO_SLAVE_EVENT_MAPPING_SET = "DIAGNOSTIC-MASTER-TO-SLAVE-EVENT-MAPPING-SET"
    DIAGNOSTIC_MEASUREMENT_IDENTIFIER = "DIAGNOSTIC-MEASUREMENT-IDENTIFIER"
    DIAGNOSTIC_MEMORY_ADDRESSABLE_RANGE_ACCESS = "DIAGNOSTIC-MEMORY-ADDRESSABLE-RANGE-ACCESS"
    DIAGNOSTIC_MEMORY_BY_ADDRESS = "DIAGNOSTIC-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_MEMORY_DESTINATION = "DIAGNOSTIC-MEMORY-DESTINATION"
    DIAGNOSTIC_MEMORY_DESTINATION_MIRROR = "DIAGNOSTIC-MEMORY-DESTINATION-MIRROR"
    DIAGNOSTIC_MEMORY_DESTINATION_PORT_MAPPING = "DIAGNOSTIC-MEMORY-DESTINATION-PORT-MAPPING"
    DIAGNOSTIC_MEMORY_DESTINATION_PRIMARY = "DIAGNOSTIC-MEMORY-DESTINATION-PRIMARY"
    DIAGNOSTIC_MEMORY_DESTINATION_USER_DEFINED = "DIAGNOSTIC-MEMORY-DESTINATION-USER-DEFINED"
    DIAGNOSTIC_MEMORY_IDENTIFIER = "DIAGNOSTIC-MEMORY-IDENTIFIER"
    DIAGNOSTIC_MONITOR_INTERFACE = "DIAGNOSTIC-MONITOR-INTERFACE"
    DIAGNOSTIC_MONITOR_PORT_MAPPING = "DIAGNOSTIC-MONITOR-PORT-MAPPING"
    DIAGNOSTIC_OPERATION_CYCLE = "DIAGNOSTIC-OPERATION-CYCLE"
    DIAGNOSTIC_OPERATION_CYCLE_INTERFACE = "DIAGNOSTIC-OPERATION-CYCLE-INTERFACE"
    DIAGNOSTIC_OPERATION_CYCLE_PORT_MAPPING = "DIAGNOSTIC-OPERATION-CYCLE-PORT-MAPPING"
    DIAGNOSTIC_PARAMETER_IDENTIFIER = "DIAGNOSTIC-PARAMETER-IDENTIFIER"
    DIAGNOSTIC_PORT_INTERFACE = "DIAGNOSTIC-PORT-INTERFACE"
    DIAGNOSTIC_POWERTRAIN_FREEZE_FRAME = "DIAGNOSTIC-POWERTRAIN-FREEZE-FRAME"
    DIAGNOSTIC_PROOF_OF_OWNERSHIP = "DIAGNOSTIC-PROOF-OF-OWNERSHIP"
    DIAGNOSTIC_PROTOCOL = "DIAGNOSTIC-PROTOCOL"
    DIAGNOSTIC_PROVIDED_DATA_MAPPING = "DIAGNOSTIC-PROVIDED-DATA-MAPPING"
    DIAGNOSTIC_READ_DATA_BY_IDENTIFIER = "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_READ_DATA_BY_IDENTIFIER_CLASS = "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER-CLASS"
    DIAGNOSTIC_READ_DATA_BY_PERIODIC_ID = "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID"
    DIAGNOSTIC_READ_DATA_BY_PERIODIC_ID_CLASS = "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID-CLASS"
    DIAGNOSTIC_READ_DTC_INFORMATION = "DIAGNOSTIC-READ-DTC-INFORMATION"
    DIAGNOSTIC_READ_DTC_INFORMATION_CLASS = "DIAGNOSTIC-READ-DTC-INFORMATION-CLASS"
    DIAGNOSTIC_READ_MEMORY_BY_ADDRESS = "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_READ_MEMORY_BY_ADDRESS_CLASS = "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS-CLASS"
    DIAGNOSTIC_READ_SCALING_DATA_BY_IDENTIFIER = "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_READ_SCALING_DATA_BY_IDENTIFIER_CLASS = (
        "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER-CLASS"
    )
    DIAGNOSTIC_REQUEST_CONTROL_OF_ON_BOARD_DEVICE = "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE"
    DIAGNOSTIC_REQUEST_CONTROL_OF_ON_BOARD_DEVICE_CLASS = (
        "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE-CLASS"
    )
    DIAGNOSTIC_REQUEST_CURRENT_POWERTRAIN_DATA = "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA"
    DIAGNOSTIC_REQUEST_CURRENT_POWERTRAIN_DATA_CLASS = (
        "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA-CLASS"
    )
    DIAGNOSTIC_REQUEST_DOWNLOAD = "DIAGNOSTIC-REQUEST-DOWNLOAD"
    DIAGNOSTIC_REQUEST_DOWNLOAD_CLASS = "DIAGNOSTIC-REQUEST-DOWNLOAD-CLASS"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_CLASS = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-CLASS"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_PERMANENT_STATUS = (
        "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS"
    )
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_PERMANENT_STATUS_CLASS = (
        "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS-CLASS"
    )
    DIAGNOSTIC_REQUEST_FILE_TRANSFER = "DIAGNOSTIC-REQUEST-FILE-TRANSFER"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_CLASS = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-CLASS"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_INTERFACE = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-INTERFACE"
    DIAGNOSTIC_REQUEST_ON_BOARD_MONITORING_TEST_RESULTS = (
        "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS"
    )
    DIAGNOSTIC_REQUEST_ON_BOARD_MONITORING_TEST_RESULTS_CLASS = (
        "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS-CLASS"
    )
    DIAGNOSTIC_REQUEST_POWERTRAIN_FREEZE_FRAME_DATA = (
        "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA"
    )
    DIAGNOSTIC_REQUEST_POWERTRAIN_FREEZE_FRAME_DATA_CLASS = (
        "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA-CLASS"
    )
    DIAGNOSTIC_REQUEST_UPLOAD = "DIAGNOSTIC-REQUEST-UPLOAD"
    DIAGNOSTIC_REQUEST_UPLOAD_CLASS = "DIAGNOSTIC-REQUEST-UPLOAD-CLASS"
    DIAGNOSTIC_REQUEST_VEHICLE_INFO = "DIAGNOSTIC-REQUEST-VEHICLE-INFO"
    DIAGNOSTIC_REQUEST_VEHICLE_INFO_CLASS = "DIAGNOSTIC-REQUEST-VEHICLE-INFO-CLASS"
    DIAGNOSTIC_RESPONSE_ON_EVENT = "DIAGNOSTIC-RESPONSE-ON-EVENT"
    DIAGNOSTIC_RESPONSE_ON_EVENT_CLASS = "DIAGNOSTIC-RESPONSE-ON-EVENT-CLASS"
    DIAGNOSTIC_ROUTINE = "DIAGNOSTIC-ROUTINE"
    DIAGNOSTIC_ROUTINE_CONTROL = "DIAGNOSTIC-ROUTINE-CONTROL"
    DIAGNOSTIC_ROUTINE_CONTROL_CLASS = "DIAGNOSTIC-ROUTINE-CONTROL-CLASS"
    DIAGNOSTIC_ROUTINE_GENERIC_INTERFACE = "DIAGNOSTIC-ROUTINE-GENERIC-INTERFACE"
    DIAGNOSTIC_ROUTINE_INTERFACE = "DIAGNOSTIC-ROUTINE-INTERFACE"
    DIAGNOSTIC_SECURITY_ACCESS = "DIAGNOSTIC-SECURITY-ACCESS"
    DIAGNOSTIC_SECURITY_ACCESS_CLASS = "DIAGNOSTIC-SECURITY-ACCESS-CLASS"
    DIAGNOSTIC_SECURITY_EVENT_REPORTING_MODE_MAPPING = (
        "DIAGNOSTIC-SECURITY-EVENT-REPORTING-MODE-MAPPING"
    )
    DIAGNOSTIC_SECURITY_LEVEL = "DIAGNOSTIC-SECURITY-LEVEL"
    DIAGNOSTIC_SECURITY_LEVEL_INTERFACE = "DIAGNOSTIC-SECURITY-LEVEL-INTERFACE"
    DIAGNOSTIC_SECURITY_LEVEL_PORT_MAPPING = "DIAGNOSTIC-SECURITY-LEVEL-PORT-MAPPING"
    DIAGNOSTIC_SERVICE_CLASS = "DIAGNOSTIC-SERVICE-CLASS"
    DIAGNOSTIC_SERVICE_DATA_MAPPING = "DIAGNOSTIC-SERVICE-DATA-MAPPING"
    DIAGNOSTIC_SERVICE_GENERIC_MAPPING = "DIAGNOSTIC-SERVICE-GENERIC-MAPPING"
    DIAGNOSTIC_SERVICE_INSTANCE = "DIAGNOSTIC-SERVICE-INSTANCE"
    DIAGNOSTIC_SERVICE_SW_MAPPING = "DIAGNOSTIC-SERVICE-SW-MAPPING"
    DIAGNOSTIC_SERVICE_TABLE = "DIAGNOSTIC-SERVICE-TABLE"
    DIAGNOSTIC_SERVICE_VALIDATION_INTERFACE = "DIAGNOSTIC-SERVICE-VALIDATION-INTERFACE"
    DIAGNOSTIC_SERVICE_VALIDATION_MAPPING = "DIAGNOSTIC-SERVICE-VALIDATION-MAPPING"
    DIAGNOSTIC_SESSION = "DIAGNOSTIC-SESSION"
    DIAGNOSTIC_SESSION_CONTROL = "DIAGNOSTIC-SESSION-CONTROL"
    DIAGNOSTIC_SESSION_CONTROL_CLASS = "DIAGNOSTIC-SESSION-CONTROL-CLASS"
    DIAGNOSTIC_SOVD_AUTHORIZATION_INTERFACE = "DIAGNOSTIC-SOVD-AUTHORIZATION-INTERFACE"
    DIAGNOSTIC_SOVD_AUTHORIZATION_PORT_MAPPING = "DIAGNOSTIC-SOVD-AUTHORIZATION-PORT-MAPPING"
    DIAGNOSTIC_SOVD_LOCK = "DIAGNOSTIC-SOVD-LOCK"
    DIAGNOSTIC_SOVD_PORT_INTERFACE = "DIAGNOSTIC-SOVD-PORT-INTERFACE"
    DIAGNOSTIC_SOVD_PROXIMITY_CHALLENGE_INTERFACE = "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-INTERFACE"
    DIAGNOSTIC_SOVD_PROXIMITY_CHALLENGE_PORT_MAPPING = (
        "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-PORT-MAPPING"
    )
    DIAGNOSTIC_STORAGE_CONDITION = "DIAGNOSTIC-STORAGE-CONDITION"
    DIAGNOSTIC_STORAGE_CONDITION_GROUP = "DIAGNOSTIC-STORAGE-CONDITION-GROUP"
    DIAGNOSTIC_STORAGE_CONDITION_PORT_MAPPING = "DIAGNOSTIC-STORAGE-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_SW_MAPPING = "DIAGNOSTIC-SW-MAPPING"
    DIAGNOSTIC_TEST_RESULT = "DIAGNOSTIC-TEST-RESULT"
    DIAGNOSTIC_TEST_ROUTINE_IDENTIFIER = "DIAGNOSTIC-TEST-ROUTINE-IDENTIFIER"
    DIAGNOSTIC_TRANSFER_EXIT = "DIAGNOSTIC-TRANSFER-EXIT"
    DIAGNOSTIC_TRANSFER_EXIT_CLASS = "DIAGNOSTIC-TRANSFER-EXIT-CLASS"
    DIAGNOSTIC_TROUBLE_CODE = "DIAGNOSTIC-TROUBLE-CODE"
    DIAGNOSTIC_TROUBLE_CODE_GROUP = "DIAGNOSTIC-TROUBLE-CODE-GROUP"
    DIAGNOSTIC_TROUBLE_CODE_J_1939 = "DIAGNOSTIC-TROUBLE-CODE-J-1939"
    DIAGNOSTIC_TROUBLE_CODE_OBD = "DIAGNOSTIC-TROUBLE-CODE-OBD"
    DIAGNOSTIC_TROUBLE_CODE_PROPS = "DIAGNOSTIC-TROUBLE-CODE-PROPS"
    DIAGNOSTIC_TROUBLE_CODE_UDS = "DIAGNOSTIC-TROUBLE-CODE-UDS"
    DIAGNOSTIC_TROUBLE_CODE_UDS_TO_CLEAR_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-TROUBLE-CODE-UDS-TO-CLEAR-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_TROUBLE_CODE_UDS_TO_TROUBLE_CODE_OBD_MAPPING = (
        "DIAGNOSTIC-TROUBLE-CODE-UDS-TO-TROUBLE-CODE-OBD-MAPPING"
    )
    DIAGNOSTIC_UPLOAD_INTERFACE = "DIAGNOSTIC-UPLOAD-INTERFACE"
    DIAGNOSTIC_VERIFY_CERTIFICATE_BIDIRECTIONAL = "DIAGNOSTIC-VERIFY-CERTIFICATE-BIDIRECTIONAL"
    DIAGNOSTIC_VERIFY_CERTIFICATE_UNIDIRECTIONAL = "DIAGNOSTIC-VERIFY-CERTIFICATE-UNIDIRECTIONAL"
    DIAGNOSTIC_WRITE_DATA_BY_IDENTIFIER = "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_WRITE_DATA_BY_IDENTIFIER_CLASS = "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER-CLASS"
    DIAGNOSTIC_WRITE_MEMORY_BY_ADDRESS = "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_WRITE_MEMORY_BY_ADDRESS_CLASS = "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS-CLASS"
    DLT_APPLICATION_TO_PROCESS_MAPPING = "DLT-APPLICATION-TO-PROCESS-MAPPING"
    DLT_CONTEXT = "DLT-CONTEXT"
    DLT_ECU = "DLT-ECU"
    DLT_LOG_SINK = "DLT-LOG-SINK"
    DLT_LOG_SINK_TO_PORT_PROTOTYPE_MAPPING = "DLT-LOG-SINK-TO-PORT-PROTOTYPE-MAPPING"
    DOCUMENTATION = "DOCUMENTATION"
    E_2_E_PROFILE_COMPATIBILITY_PROPS = "E-2-E-PROFILE-COMPATIBILITY-PROPS"
    E_2_E_PROFILE_CONFIGURATION_SET = "E-2-E-PROFILE-CONFIGURATION-SET"
    ECU_ABSTRACTION_SW_COMPONENT_TYPE = "ECU-ABSTRACTION-SW-COMPONENT-TYPE"
    ECU_TIMING = "ECU-TIMING"
    ECUC_DEFINITION_COLLECTION = "ECUC-DEFINITION-COLLECTION"
    ECUC_DESTINATION_URI_DEF_SET = "ECUC-DESTINATION-URI-DEF-SET"
    ECUC_MODULE_CONFIGURATION_VALUES = "ECUC-MODULE-CONFIGURATION-VALUES"
    ECUC_MODULE_DEF = "ECUC-MODULE-DEF"
    ECUC_VALUE_COLLECTION = "ECUC-VALUE-COLLECTION"
    END_TO_END_PROTECTION_SET = "END-TO-END-PROTECTION-SET"
    ETH_IP_PROPS = "ETH-IP-PROPS"
    ETH_TCP_IP_ICMP_PROPS = "ETH-TCP-IP-ICMP-PROPS"
    ETH_TCP_IP_PROPS = "ETH-TCP-IP-PROPS"
    ETHERNET_RAW_DATA_STREAM_CLIENT_MAPPING = "ETHERNET-RAW-DATA-STREAM-CLIENT-MAPPING"
    ETHERNET_RAW_DATA_STREAM_GRANT = "ETHERNET-RAW-DATA-STREAM-GRANT"
    ETHERNET_RAW_DATA_STREAM_MAPPING = "ETHERNET-RAW-DATA-STREAM-MAPPING"
    ETHERNET_RAW_DATA_STREAM_SERVER_MAPPING = "ETHERNET-RAW-DATA-STREAM-SERVER-MAPPING"
    EVALUATED_VARIANT_SET = "EVALUATED-VARIANT-SET"
    EXECUTABLE = "EXECUTABLE"
    EXECUTABLE_TIMING = "EXECUTABLE-TIMING"
    FIREWALL_RULE = "FIREWALL-RULE"
    FIREWALL_STATE_SWITCH_INTERFACE = "FIREWALL-STATE-SWITCH-INTERFACE"
    FLAT_MAP = "FLAT-MAP"
    FM_FEATURE = "FM-FEATURE"
    FM_FEATURE_MAP = "FM-FEATURE-MAP"
    FM_FEATURE_MODEL = "FM-FEATURE-MODEL"
    FM_FEATURE_SELECTION_SET = "FM-FEATURE-SELECTION-SET"
    FUNCTION_GROUP_SET = "FUNCTION-GROUP-SET"
    FUNCTIONAL_CLUSTER_INTERACTS_WITH_FUNCTIONAL_CLUSTER_MAPPING = (
        "FUNCTIONAL-CLUSTER-INTERACTS-WITH-FUNCTIONAL-CLUSTER-MAPPING"
    )
    FUNCTIONAL_CLUSTER_INTERACTS_WITH_PERSISTENCY_DEPLOYMENT_MAPPING = (
        "FUNCTIONAL-CLUSTER-INTERACTS-WITH-PERSISTENCY-DEPLOYMENT-MAPPING"
    )
    GENERAL_PURPOSE_CONNECTION = "GENERAL-PURPOSE-CONNECTION"
    GRANT = "GRANT"
    GRANT_DESIGN = "GRANT-DESIGN"
    HW_CATEGORY = "HW-CATEGORY"
    HW_ELEMENT = "HW-ELEMENT"
    HW_TYPE = "HW-TYPE"
    I_PV_6_EXT_HEADER_FILTER_SET = "I-PV-6-EXT-HEADER-FILTER-SET"
    IDS_COMMON_ELEMENT = "IDS-COMMON-ELEMENT"
    IDS_DESIGN = "IDS-DESIGN"
    IDS_MAPPING = "IDS-MAPPING"
    IDSM_INSTANCE = "IDSM-INSTANCE"
    IDSM_PROPERTIES = "IDSM-PROPERTIES"
    IMPLEMENTATION = "IMPLEMENTATION"
    IMPLEMENTATION_DATA_TYPE = "IMPLEMENTATION-DATA-TYPE"
    INTERFACE_MAPPING = "INTERFACE-MAPPING"
    INTERPOLATION_ROUTINE_MAPPING_SET = "INTERPOLATION-ROUTINE-MAPPING-SET"
    IP_IAM_REMOTE_SUBJECT = "IP-IAM-REMOTE-SUBJECT"
    IP_SEC_CONFIG_PROPS = "IP-SEC-CONFIG-PROPS"
    IP_SEC_IAM_REMOTE_SUBJECT = "IP-SEC-IAM-REMOTE-SUBJECT"
    J_1939_CONTROLLER_APPLICATION = "J-1939-CONTROLLER-APPLICATION"
    KEYWORD_SET = "KEYWORD-SET"
    LIFE_CYCLE_INFO_SET = "LIFE-CYCLE-INFO-SET"
    LIFE_CYCLE_STATE_DEFINITION_GROUP = "LIFE-CYCLE-STATE-DEFINITION-GROUP"
    LOG_AND_TRACE_INTERFACE = "LOG-AND-TRACE-INTERFACE"
    LOG_AND_TRACE_MESSAGE_COLLECTION_SET = "LOG-AND-TRACE-MESSAGE-COLLECTION-SET"
    LT_MESSAGE_COLLECTION_TO_PORT_PROTOTYPE_MAPPING = (
        "LT-MESSAGE-COLLECTION-TO-PORT-PROTOTYPE-MAPPING"
    )
    MAC_SEC_GLOBAL_KAY_PROPS = "MAC-SEC-GLOBAL-KAY-PROPS"
    MAC_SEC_PARTICIPANT_SET = "MAC-SEC-PARTICIPANT-SET"
    MACHINE = "MACHINE"
    MACHINE_TIMING = "MACHINE-TIMING"
    MC_FUNCTION = "MC-FUNCTION"
    MC_GROUP = "MC-GROUP"
    MODE_DECLARATION_GROUP = "MODE-DECLARATION-GROUP"
    MODE_DECLARATION_MAPPING_SET = "MODE-DECLARATION-MAPPING-SET"
    MODE_SWITCH_INTERFACE = "MODE-SWITCH-INTERFACE"
    NM_HANDLE_TO_FUNCTION_GROUP_STATE_MAPPING = "NM-HANDLE-TO-FUNCTION-GROUP-STATE-MAPPING"
    NV_BLOCK_SW_COMPONENT_TYPE = "NV-BLOCK-SW-COMPONENT-TYPE"
    NV_DATA_INTERFACE = "NV-DATA-INTERFACE"
    OS_TASK_PROXY = "OS-TASK-PROXY"
    PARAMETER_INTERFACE = "PARAMETER-INTERFACE"
    PARAMETER_SW_COMPONENT_TYPE = "PARAMETER-SW-COMPONENT-TYPE"
    PERSISTENCY_DEPLOYMENT = "PERSISTENCY-DEPLOYMENT"
    PERSISTENCY_DEPLOYMENT_ELEMENT_TO_CRYPTO_KEY_SLOT_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-ELEMENT-TO-CRYPTO-KEY-SLOT-MAPPING"
    )
    PERSISTENCY_DEPLOYMENT_TO_CRYPTO_KEY_SLOT_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-TO-CRYPTO-KEY-SLOT-MAPPING"
    )
    PERSISTENCY_DEPLOYMENT_TO_DLT_LOG_SINK_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-TO-DLT-LOG-SINK-MAPPING"
    )
    PERSISTENCY_FILE_STORAGE = "PERSISTENCY-FILE-STORAGE"
    PERSISTENCY_FILE_STORAGE_INTERFACE = "PERSISTENCY-FILE-STORAGE-INTERFACE"
    PERSISTENCY_INTERFACE = "PERSISTENCY-INTERFACE"
    PERSISTENCY_KEY_VALUE_STORAGE = "PERSISTENCY-KEY-VALUE-STORAGE"
    PERSISTENCY_KEY_VALUE_STORAGE_INTERFACE = "PERSISTENCY-KEY-VALUE-STORAGE-INTERFACE"
    PERSISTENCY_PORT_PROTOTYPE_TO_DEPLOYMENT_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-DEPLOYMENT-MAPPING"
    )
    PERSISTENCY_PORT_PROTOTYPE_TO_FILE_STORAGE_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-FILE-STORAGE-MAPPING"
    )
    PERSISTENCY_PORT_PROTOTYPE_TO_KEY_VALUE_STORAGE_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-KEY-VALUE-STORAGE-MAPPING"
    )
    PHM_ABSTRACT_RECOVERY_NOTIFICATION_INTERFACE = "PHM-ABSTRACT-RECOVERY-NOTIFICATION-INTERFACE"
    PHM_CONTRIBUTION_TO_MACHINE_MAPPING = "PHM-CONTRIBUTION-TO-MACHINE-MAPPING"
    PHM_HEALTH_CHANNEL_INTERFACE = "PHM-HEALTH-CHANNEL-INTERFACE"
    PHM_HEALTH_CHANNEL_RECOVERY_NOTIFICATION_INTERFACE = (
        "PHM-HEALTH-CHANNEL-RECOVERY-NOTIFICATION-INTERFACE"
    )
    PHM_RECOVERY_ACTION_INTERFACE = "PHM-RECOVERY-ACTION-INTERFACE"
    PHM_SUPERVISED_ENTITY_INTERFACE = "PHM-SUPERVISED-ENTITY-INTERFACE"
    PHM_SUPERVISION_RECOVERY_NOTIFICATION_INTERFACE = (
        "PHM-SUPERVISION-RECOVERY-NOTIFICATION-INTERFACE"
    )
    PHYSICAL_DIMENSION = "PHYSICAL-DIMENSION"
    PHYSICAL_DIMENSION_MAPPING_SET = "PHYSICAL-DIMENSION-MAPPING-SET"
    PLATFORM_HEALTH_MANAGEMENT_CONTRIBUTION = "PLATFORM-HEALTH-MANAGEMENT-CONTRIBUTION"
    PLATFORM_HEALTH_MANAGEMENT_INTERFACE = "PLATFORM-HEALTH-MANAGEMENT-INTERFACE"
    PLATFORM_MODULE_ENDPOINT_CONFIGURATION = "PLATFORM-MODULE-ENDPOINT-CONFIGURATION"
    PLATFORM_MODULE_ETHERNET_ENDPOINT_CONFIGURATION = (
        "PLATFORM-MODULE-ETHERNET-ENDPOINT-CONFIGURATION"
    )
    PORT_INTERFACE = "PORT-INTERFACE"
    PORT_INTERFACE_MAPPING_SET = "PORT-INTERFACE-MAPPING-SET"
    PORT_INTERFACE_TO_DATA_TYPE_MAPPING = "PORT-INTERFACE-TO-DATA-TYPE-MAPPING"
    PORT_PROTOTYPE_BLUEPRINT = "PORT-PROTOTYPE-BLUEPRINT"
    POST_BUILD_VARIANT_CRITERION = "POST-BUILD-VARIANT-CRITERION"
    POST_BUILD_VARIANT_CRITERION_VALUE_SET = "POST-BUILD-VARIANT-CRITERION-VALUE-SET"
    PREDEFINED_VARIANT = "PREDEFINED-VARIANT"
    PROCESS = "PROCESS"
    PROCESS_DESIGN = "PROCESS-DESIGN"
    PROCESS_DESIGN_TO_MACHINE_DESIGN_MAPPING = "PROCESS-DESIGN-TO-MACHINE-DESIGN-MAPPING"
    PROCESS_EXECUTION_ERROR = "PROCESS-EXECUTION-ERROR"
    PROCESS_TO_MACHINE_MAPPING_SET = "PROCESS-TO-MACHINE-MAPPING-SET"
    PROVIDED_AP_SERVICE_INSTANCE = "PROVIDED-AP-SERVICE-INSTANCE"
    PROVIDED_SERVICE_INSTANCE_TO_SW_CLUSTER_DESIGN_P_PORT_PROTOTYPE_MAPPING = (
        "PROVIDED-SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-P-PORT-PROTOTYPE-MAPPING"
    )
    PROVIDED_SOMEIP_SERVICE_INSTANCE = "PROVIDED-SOMEIP-SERVICE-INSTANCE"
    PROVIDED_USER_DEFINED_SERVICE_INSTANCE = "PROVIDED-USER-DEFINED-SERVICE-INSTANCE"
    RAPID_PROTOTYPING_SCENARIO = "RAPID-PROTOTYPING-SCENARIO"
    RAW_DATA_STREAM_CLIENT_INTERFACE = "RAW-DATA-STREAM-CLIENT-INTERFACE"
    RAW_DATA_STREAM_DEPLOYMENT = "RAW-DATA-STREAM-DEPLOYMENT"
    RAW_DATA_STREAM_GRANT = "RAW-DATA-STREAM-GRANT"
    RAW_DATA_STREAM_GRANT_DESIGN = "RAW-DATA-STREAM-GRANT-DESIGN"
    RAW_DATA_STREAM_MAPPING = "RAW-DATA-STREAM-MAPPING"
    RAW_DATA_STREAM_SERVER_INTERFACE = "RAW-DATA-STREAM-SERVER-INTERFACE"
    RECOVERY_NOTIFICATION = "RECOVERY-NOTIFICATION"
    RECOVERY_NOTIFICATION_TO_P_PORT_PROTOTYPE_MAPPING = (
        "RECOVERY-NOTIFICATION-TO-P-PORT-PROTOTYPE-MAPPING"
    )
    REQUIRED_AP_SERVICE_INSTANCE = "REQUIRED-AP-SERVICE-INSTANCE"
    REQUIRED_SERVICE_INSTANCE_TO_SW_CLUSTER_DESIGN_R_PORT_PROTOTYPE_MAPPING = (
        "REQUIRED-SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-R-PORT-PROTOTYPE-MAPPING"
    )
    REQUIRED_SOMEIP_SERVICE_INSTANCE = "REQUIRED-SOMEIP-SERVICE-INSTANCE"
    REQUIRED_USER_DEFINED_SERVICE_INSTANCE = "REQUIRED-USER-DEFINED-SERVICE-INSTANCE"
    SDG_DEF = "SDG-DEF"
    SEC_OC_SECURE_COM_PROPS = "SEC-OC-SECURE-COM-PROPS"
    SECURE_COM_PROPS = "SECURE-COM-PROPS"
    SECURITY_EVENT_CONTEXT_MAPPING = "SECURITY-EVENT-CONTEXT-MAPPING"
    SECURITY_EVENT_CONTEXT_MAPPING_APPLICATION = "SECURITY-EVENT-CONTEXT-MAPPING-APPLICATION"
    SECURITY_EVENT_CONTEXT_MAPPING_BSW_MODULE = "SECURITY-EVENT-CONTEXT-MAPPING-BSW-MODULE"
    SECURITY_EVENT_CONTEXT_MAPPING_COMM_CONNECTOR = "SECURITY-EVENT-CONTEXT-MAPPING-COMM-CONNECTOR"
    SECURITY_EVENT_CONTEXT_MAPPING_FUNCTIONAL_CLUSTER = (
        "SECURITY-EVENT-CONTEXT-MAPPING-FUNCTIONAL-CLUSTER"
    )
    SECURITY_EVENT_DEFINITION = "SECURITY-EVENT-DEFINITION"
    SECURITY_EVENT_FILTER_CHAIN = "SECURITY-EVENT-FILTER-CHAIN"
    SECURITY_EVENT_MAPPING = "SECURITY-EVENT-MAPPING"
    SECURITY_EVENT_REPORT_INTERFACE = "SECURITY-EVENT-REPORT-INTERFACE"
    SECURITY_EVENT_REPORT_TO_SECURITY_EVENT_DEFINITION_MAPPING = (
        "SECURITY-EVENT-REPORT-TO-SECURITY-EVENT-DEFINITION-MAPPING"
    )
    SENDER_RECEIVER_INTERFACE = "SENDER-RECEIVER-INTERFACE"
    SENSOR_ACTUATOR_SW_COMPONENT_TYPE = "SENSOR-ACTUATOR-SW-COMPONENT-TYPE"
    SERIALIZATION_TECHNOLOGY = "SERIALIZATION-TECHNOLOGY"
    SERVICE_INSTANCE_TO_MACHINE_MAPPING = "SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    SERVICE_INSTANCE_TO_PORT_PROTOTYPE_MAPPING = "SERVICE-INSTANCE-TO-PORT-PROTOTYPE-MAPPING"
    SERVICE_INSTANCE_TO_SIGNAL_MAPPING = "SERVICE-INSTANCE-TO-SIGNAL-MAPPING"
    SERVICE_INSTANCE_TO_SW_CLUSTER_DESIGN_PORT_PROTOTYPE_MAPPING = (
        "SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-PORT-PROTOTYPE-MAPPING"
    )
    SERVICE_INTERFACE = "SERVICE-INTERFACE"
    SERVICE_INTERFACE_DEPLOYMENT = "SERVICE-INTERFACE-DEPLOYMENT"
    SERVICE_INTERFACE_ELEMENT_MAPPING = "SERVICE-INTERFACE-ELEMENT-MAPPING"
    SERVICE_INTERFACE_EVENT_MAPPING = "SERVICE-INTERFACE-EVENT-MAPPING"
    SERVICE_INTERFACE_FIELD_MAPPING = "SERVICE-INTERFACE-FIELD-MAPPING"
    SERVICE_INTERFACE_METHOD_MAPPING = "SERVICE-INTERFACE-METHOD-MAPPING"
    SERVICE_INTERFACE_PEDIGREE = "SERVICE-INTERFACE-PEDIGREE"
    SERVICE_INTERFACE_TRIGGER_MAPPING = "SERVICE-INTERFACE-TRIGGER-MAPPING"
    SERVICE_PROXY_SW_COMPONENT_TYPE = "SERVICE-PROXY-SW-COMPONENT-TYPE"
    SERVICE_SW_COMPONENT_TYPE = "SERVICE-SW-COMPONENT-TYPE"
    SERVICE_TIMING = "SERVICE-TIMING"
    SIGNAL_SERVICE_TRANSLATION_PROPS_SET = "SIGNAL-SERVICE-TRANSLATION-PROPS-SET"
    SOFTWARE_CLUSTER = "SOFTWARE-CLUSTER"
    SOFTWARE_CLUSTER_DESIGN = "SOFTWARE-CLUSTER-DESIGN"
    SOFTWARE_CLUSTER_DIAGNOSTIC_DEPLOYMENT_PROPS = "SOFTWARE-CLUSTER-DIAGNOSTIC-DEPLOYMENT-PROPS"
    SOFTWARE_PACKAGE = "SOFTWARE-PACKAGE"
    SOMEIP_DATA_PROTOTYPE_TRANSFORMATION_PROPS = "SOMEIP-DATA-PROTOTYPE-TRANSFORMATION-PROPS"
    SOMEIP_REMOTE_MULTICAST_CONFIG = "SOMEIP-REMOTE-MULTICAST-CONFIG"
    SOMEIP_REMOTE_UNICAST_CONFIG = "SOMEIP-REMOTE-UNICAST-CONFIG"
    SOMEIP_SD_CLIENT_EVENT_GROUP_TIMING_CONFIG = "SOMEIP-SD-CLIENT-EVENT-GROUP-TIMING-CONFIG"
    SOMEIP_SD_CLIENT_SERVICE_INSTANCE_CONFIG = "SOMEIP-SD-CLIENT-SERVICE-INSTANCE-CONFIG"
    SOMEIP_SD_SERVER_EVENT_GROUP_TIMING_CONFIG = "SOMEIP-SD-SERVER-EVENT-GROUP-TIMING-CONFIG"
    SOMEIP_SD_SERVER_SERVICE_INSTANCE_CONFIG = "SOMEIP-SD-SERVER-SERVICE-INSTANCE-CONFIG"
    SOMEIP_SERVICE_INSTANCE_TO_MACHINE_MAPPING = "SOMEIP-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    SOMEIP_SERVICE_INTERFACE_DEPLOYMENT = "SOMEIP-SERVICE-INTERFACE-DEPLOYMENT"
    STARTUP_CONFIG = "STARTUP-CONFIG"
    STATE_DEPENDENT_FIREWALL = "STATE-DEPENDENT-FIREWALL"
    STATE_MANAGEMEN_PHM_ERROR_INTERFACE = "STATE-MANAGEMEN-PHM-ERROR-INTERFACE"
    STATE_MANAGEMENT_DIAG_TRIGGER_INTERFACE = "STATE-MANAGEMENT-DIAG-TRIGGER-INTERFACE"
    STATE_MANAGEMENT_EM_ERROR_INTERFACE = "STATE-MANAGEMENT-EM-ERROR-INTERFACE"
    STATE_MANAGEMENT_ERROR_INTERFACE = "STATE-MANAGEMENT-ERROR-INTERFACE"
    STATE_MANAGEMENT_FUNCTION_GROUP_SWITCH_NOTIFICATION_INTERFACE = (
        "STATE-MANAGEMENT-FUNCTION-GROUP-SWITCH-NOTIFICATION-INTERFACE"
    )
    STATE_MANAGEMENT_NOTIFICATION_INTERFACE = "STATE-MANAGEMENT-NOTIFICATION-INTERFACE"
    STATE_MANAGEMENT_PORT_INTERFACE = "STATE-MANAGEMENT-PORT-INTERFACE"
    STATE_MANAGEMENT_REQUEST_INTERFACE = "STATE-MANAGEMENT-REQUEST-INTERFACE"
    STATE_MANAGEMENT_TRIGGER_INTERFACE = "STATE-MANAGEMENT-TRIGGER-INTERFACE"
    STD_CPP_IMPLEMENTATION_DATA_TYPE = "STD-CPP-IMPLEMENTATION-DATA-TYPE"
    SW_ADDR_METHOD = "SW-ADDR-METHOD"
    SW_AXIS_TYPE = "SW-AXIS-TYPE"
    SW_BASE_TYPE = "SW-BASE-TYPE"
    SW_COMPONENT_MAPPING_CONSTRAINTS = "SW-COMPONENT-MAPPING-CONSTRAINTS"
    SW_COMPONENT_TYPE = "SW-COMPONENT-TYPE"
    SW_RECORD_LAYOUT = "SW-RECORD-LAYOUT"
    SW_SYSTEMCONST = "SW-SYSTEMCONST"
    SW_SYSTEMCONSTANT_VALUE_SET = "SW-SYSTEMCONSTANT-VALUE-SET"
    SWC_BSW_MAPPING = "SWC-BSW-MAPPING"
    SWC_IMPLEMENTATION = "SWC-IMPLEMENTATION"
    SWC_TIMING = "SWC-TIMING"
    SYNCHRONIZED_TIME_BASE_CONSUMER_INTERFACE = "SYNCHRONIZED-TIME-BASE-CONSUMER-INTERFACE"
    SYNCHRONIZED_TIME_BASE_PROVIDER_INTERFACE = "SYNCHRONIZED-TIME-BASE-PROVIDER-INTERFACE"
    SYSTEM = "SYSTEM"
    SYSTEM_SIGNAL = "SYSTEM-SIGNAL"
    SYSTEM_SIGNAL_GROUP = "SYSTEM-SIGNAL-GROUP"
    SYSTEM_TIMING = "SYSTEM-TIMING"
    TCP_OPTION_FILTER_SET = "TCP-OPTION-FILTER-SET"
    TD_CP_SOFTWARE_CLUSTER_MAPPING_SET = "TD-CP-SOFTWARE-CLUSTER-MAPPING-SET"
    TIME_BASE_PROVIDER_TO_PERSISTENCY_MAPPING = "TIME-BASE-PROVIDER-TO-PERSISTENCY-MAPPING"
    TIME_SYNC_PORT_PROTOTYPE_TO_TIME_BASE_MAPPING = "TIME-SYNC-PORT-PROTOTYPE-TO-TIME-BASE-MAPPING"
    TIMING_EXTENSION = "TIMING-EXTENSION"
    TLS_CONNECTION_GROUP = "TLS-CONNECTION-GROUP"
    TLS_IAM_REMOTE_SUBJECT = "TLS-IAM-REMOTE-SUBJECT"
    TLS_SECURE_COM_PROPS = "TLS-SECURE-COM-PROPS"
    TLV_DATA_ID_DEFINITION_SET = "TLV-DATA-ID-DEFINITION-SET"
    TRANSFORMATION_PROPS_SET = "TRANSFORMATION-PROPS-SET"
    TRANSFORMATION_PROPS_TO_SERVICE_INTERFACE_ELEMENT_MAPPING = (
        "TRANSFORMATION-PROPS-TO-SERVICE-INTERFACE-ELEMENT-MAPPING"
    )
    TRIGGER_INTERFACE = "TRIGGER-INTERFACE"
    UCM_TO_TIME_BASE_RESOURCE_MAPPING = "UCM-TO-TIME-BASE-RESOURCE-MAPPING"
    UNIT = "UNIT"
    UNIT_GROUP = "UNIT-GROUP"
    UPLOADABLE_EXCLUSIVE_PACKAGE_ELEMENT = "UPLOADABLE-EXCLUSIVE-PACKAGE-ELEMENT"
    UPLOADABLE_PACKAGE_ELEMENT = "UPLOADABLE-PACKAGE-ELEMENT"
    USER_DEFINED_SERVICE_INSTANCE_TO_MACHINE_MAPPING = (
        "USER-DEFINED-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    )
    USER_DEFINED_SERVICE_INTERFACE_DEPLOYMENT = "USER-DEFINED-SERVICE-INTERFACE-DEPLOYMENT"
    VEHICLE_PACKAGE = "VEHICLE-PACKAGE"
    VFB_TIMING = "VFB-TIMING"
    VIEW_MAP_SET = "VIEW-MAP-SET"


class ArPackageSubtypesEnum(Enum):
    AR_PACKAGE = "AR-PACKAGE"


class AreaEnumNohrefSimple(Enum):
    """
    :cvar NOHREF: This indicates that the area has no active link.
    """

    NOHREF = "NOHREF"


class AreaEnumShapeSimple(Enum):
    """
    :cvar CIRCLE: The shape is a circle.
    :cvar DEFAULT: This specifies the fact that the area covers the rest
        of the figure.
    :cvar POLY: The area is specified as polygon.
    :cvar RECT: The shape is specified as rectangle.
    """

    CIRCLE = "CIRCLE"
    DEFAULT = "DEFAULT"
    POLY = "POLY"
    RECT = "RECT"


class ArgumentDataPrototypeSubtypesEnum(Enum):
    ARGUMENT_DATA_PROTOTYPE = "ARGUMENT-DATA-PROTOTYPE"


class ArgumentDirectionEnumSimple(Enum):
    """
    :cvar IN: The argument value is passed to the callee.
    :cvar INOUT: The argument value is passed to the callee but also
        passed back from the callee to the caller.
    :cvar OUT: The argument value is passed from the callee  to the
        caller.
    """

    IN = "IN"
    INOUT = "INOUT"
    OUT = "OUT"


class ArrayImplPolicyEnumSimple(Enum):
    """
    :cvar PAYLOAD_AS_ARRAY: This configuration demands the
        implementation of the payload as an array.
    :cvar PAYLOAD_AS_POINTER_TO_ARRAY: This configuration demands the
        implementation of the payload as a pointer to an array.
    """

    PAYLOAD_AS_ARRAY = "PAYLOAD-AS-ARRAY"
    PAYLOAD_AS_POINTER_TO_ARRAY = "PAYLOAD-AS-POINTER-TO-ARRAY"


class ArraySizeHandlingEnumSimple(Enum):
    """
    :cvar ALL_INDICES_DIFFERENT_ARRAY_SIZE: All elements of the variable
        size array may have different sizes.
    :cvar ALL_INDICES_SAME_ARRAY_SIZE: All elements of the variable size
        array have the same size.
    :cvar INHERITED_FROM_ARRAY_ELEMENT_TYPE_SIZE: The size of all
        dimensions of the variable size array is determined by the size
        of the contained array element.
    """

    ALL_INDICES_DIFFERENT_ARRAY_SIZE = "ALL-INDICES-DIFFERENT-ARRAY-SIZE"
    ALL_INDICES_SAME_ARRAY_SIZE = "ALL-INDICES-SAME-ARRAY-SIZE"
    INHERITED_FROM_ARRAY_ELEMENT_TYPE_SIZE = "INHERITED-FROM-ARRAY-ELEMENT-TYPE-SIZE"


class ArraySizeSemanticsEnumSimple(Enum):
    """
    :cvar FIXED_SIZE: This means that the ApplicationArrayDataType will
        always have a fixed number of elements.
    :cvar VARIABLE_SIZE: This implies that the actual number of elements
        in the ApplicationArrayDataType might vary at run-time. The
        value of arraySize represents the maximum number of elements in
        the array.
    """

    FIXED_SIZE = "FIXED-SIZE"
    VARIABLE_SIZE = "VARIABLE-SIZE"


class ArtifactChecksumSubtypesEnum(Enum):
    ARTIFACT_CHECKSUM = "ARTIFACT-CHECKSUM"


@dataclass(slots=True, kw_only=True)
class AsamRecordLayoutSemantics:
    """This meta-class is used to denote the semantics in particular in terms of
    the corresponding A2L-Keyword.

    This is to support the mapping of the more general record layouts in
    AUTOSAR/MSR to the specific A2L keywords. It is possible to express
    the specific semantics of A2l RecordLayout keywords in
    SwRecordlayoutGroup but not always vice versa. Therefore the mapping
    is provided in this optional attribute. It is specified as NMTOKEN
    to reduce the direct dependency of ASAM an AUTOSAR standards.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ASAM-RECORD-LAYOUT-SEMANTICS"

    value: str = field(
        default="",
        metadata={
            "required": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class AsynchronousServerCallPointSubtypesEnum(Enum):
    ASYNCHRONOUS_SERVER_CALL_POINT = "ASYNCHRONOUS-SERVER-CALL-POINT"


class AsynchronousServerCallResultPointSubtypesEnum(Enum):
    ASYNCHRONOUS_SERVER_CALL_RESULT_POINT = "ASYNCHRONOUS-SERVER-CALL-RESULT-POINT"


class AtpBlueprintSubtypesEnum(Enum):
    ABSTRACT_IMPLEMENTATION_DATA_TYPE = "ABSTRACT-IMPLEMENTATION-DATA-TYPE"
    ABSTRACT_RAW_DATA_STREAM_INTERFACE = "ABSTRACT-RAW-DATA-STREAM-INTERFACE"
    ABSTRACT_SYNCHRONIZED_TIME_BASE_INTERFACE = "ABSTRACT-SYNCHRONIZED-TIME-BASE-INTERFACE"
    ACL_OBJECT_SET = "ACL-OBJECT-SET"
    ACL_OPERATION = "ACL-OPERATION"
    ACL_PERMISSION = "ACL-PERMISSION"
    ACL_ROLE = "ACL-ROLE"
    ADAPTIVE_APPLICATION_SW_COMPONENT_TYPE = "ADAPTIVE-APPLICATION-SW-COMPONENT-TYPE"
    ALIAS_NAME_SET = "ALIAS-NAME-SET"
    APPLICATION_ARRAY_DATA_TYPE = "APPLICATION-ARRAY-DATA-TYPE"
    APPLICATION_ASSOC_MAP_DATA_TYPE = "APPLICATION-ASSOC-MAP-DATA-TYPE"
    APPLICATION_COMPOSITE_DATA_TYPE = "APPLICATION-COMPOSITE-DATA-TYPE"
    APPLICATION_DATA_TYPE = "APPLICATION-DATA-TYPE"
    APPLICATION_DEFERRED_DATA_TYPE = "APPLICATION-DEFERRED-DATA-TYPE"
    APPLICATION_INTERFACE = "APPLICATION-INTERFACE"
    APPLICATION_PRIMITIVE_DATA_TYPE = "APPLICATION-PRIMITIVE-DATA-TYPE"
    APPLICATION_RECORD_DATA_TYPE = "APPLICATION-RECORD-DATA-TYPE"
    APPLICATION_SW_COMPONENT_TYPE = "APPLICATION-SW-COMPONENT-TYPE"
    AR_PACKAGE = "AR-PACKAGE"
    ATOMIC_SW_COMPONENT_TYPE = "ATOMIC-SW-COMPONENT-TYPE"
    ATP_BLUEPRINT = "ATP-BLUEPRINT"
    BSW_ENTRY_RELATIONSHIP_SET = "BSW-ENTRY-RELATIONSHIP-SET"
    BSW_MODULE_DESCRIPTION = "BSW-MODULE-DESCRIPTION"
    BSW_MODULE_ENTRY = "BSW-MODULE-ENTRY"
    BUILD_ACTION = "BUILD-ACTION"
    BUILD_ACTION_ENTITY = "BUILD-ACTION-ENTITY"
    BUILD_ACTION_ENVIRONMENT = "BUILD-ACTION-ENVIRONMENT"
    BUILD_ACTION_MANIFEST = "BUILD-ACTION-MANIFEST"
    CLIENT_SERVER_INTERFACE = "CLIENT-SERVER-INTERFACE"
    CLIENT_SERVER_INTERFACE_MAPPING = "CLIENT-SERVER-INTERFACE-MAPPING"
    CLIENT_SERVER_INTERFACE_TO_BSW_MODULE_ENTRY_BLUEPRINT_MAPPING = (
        "CLIENT-SERVER-INTERFACE-TO-BSW-MODULE-ENTRY-BLUEPRINT-MAPPING"
    )
    COMPLEX_DEVICE_DRIVER_SW_COMPONENT_TYPE = "COMPLEX-DEVICE-DRIVER-SW-COMPONENT-TYPE"
    COMPOSITION_SW_COMPONENT_TYPE = "COMPOSITION-SW-COMPONENT-TYPE"
    COMPU_METHOD = "COMPU-METHOD"
    CONSISTENCY_NEEDS = "CONSISTENCY-NEEDS"
    CPP_IMPLEMENTATION_DATA_TYPE = "CPP-IMPLEMENTATION-DATA-TYPE"
    CRYPTO_CERTIFICATE_INTERFACE = "CRYPTO-CERTIFICATE-INTERFACE"
    CRYPTO_INTERFACE = "CRYPTO-INTERFACE"
    CRYPTO_KEY_SLOT_INTERFACE = "CRYPTO-KEY-SLOT-INTERFACE"
    CRYPTO_PROVIDER_INTERFACE = "CRYPTO-PROVIDER-INTERFACE"
    CRYPTO_TRUST_MASTER_INTERFACE = "CRYPTO-TRUST-MASTER-INTERFACE"
    CUSTOM_CPP_IMPLEMENTATION_DATA_TYPE = "CUSTOM-CPP-IMPLEMENTATION-DATA-TYPE"
    DATA_CONSTR = "DATA-CONSTR"
    DATA_INTERFACE = "DATA-INTERFACE"
    DATA_TYPE_MAPPING_SET = "DATA-TYPE-MAPPING-SET"
    DIAGNOSTIC_ABSTRACT_DATA_IDENTIFIER_INTERFACE = "DIAGNOSTIC-ABSTRACT-DATA-IDENTIFIER-INTERFACE"
    DIAGNOSTIC_ABSTRACT_ROUTINE_INTERFACE = "DIAGNOSTIC-ABSTRACT-ROUTINE-INTERFACE"
    DIAGNOSTIC_AUTHENTICATION_INTERFACE = "DIAGNOSTIC-AUTHENTICATION-INTERFACE"
    DIAGNOSTIC_COM_CONTROL_INTERFACE = "DIAGNOSTIC-COM-CONTROL-INTERFACE"
    DIAGNOSTIC_CONDITION_INTERFACE = "DIAGNOSTIC-CONDITION-INTERFACE"
    DIAGNOSTIC_DATA_ELEMENT_INTERFACE = "DIAGNOSTIC-DATA-ELEMENT-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER_GENERIC_INTERFACE = "DIAGNOSTIC-DATA-IDENTIFIER-GENERIC-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER_INTERFACE = "DIAGNOSTIC-DATA-IDENTIFIER-INTERFACE"
    DIAGNOSTIC_DO_IP_ACTIVATION_LINE_INTERFACE = "DIAGNOSTIC-DO-IP-ACTIVATION-LINE-INTERFACE"
    DIAGNOSTIC_DO_IP_ENTITY_IDENTIFICATION_INTERFACE = (
        "DIAGNOSTIC-DO-IP-ENTITY-IDENTIFICATION-INTERFACE"
    )
    DIAGNOSTIC_DO_IP_GROUP_IDENTIFICATION_INTERFACE = (
        "DIAGNOSTIC-DO-IP-GROUP-IDENTIFICATION-INTERFACE"
    )
    DIAGNOSTIC_DO_IP_POWER_MODE_INTERFACE = "DIAGNOSTIC-DO-IP-POWER-MODE-INTERFACE"
    DIAGNOSTIC_DO_IP_TRIGGER_VEHICLE_ANNOUNCEMENT_INTERFACE = (
        "DIAGNOSTIC-DO-IP-TRIGGER-VEHICLE-ANNOUNCEMENT-INTERFACE"
    )
    DIAGNOSTIC_DOWNLOAD_INTERFACE = "DIAGNOSTIC-DOWNLOAD-INTERFACE"
    DIAGNOSTIC_DTC_INFORMATION_INTERFACE = "DIAGNOSTIC-DTC-INFORMATION-INTERFACE"
    DIAGNOSTIC_ECU_RESET_INTERFACE = "DIAGNOSTIC-ECU-RESET-INTERFACE"
    DIAGNOSTIC_EVENT_INTERFACE = "DIAGNOSTIC-EVENT-INTERFACE"
    DIAGNOSTIC_EXTERNAL_AUTHENTICATION_INTERFACE = "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-INTERFACE"
    DIAGNOSTIC_GENERIC_UDS_INTERFACE = "DIAGNOSTIC-GENERIC-UDS-INTERFACE"
    DIAGNOSTIC_INDICATOR_INTERFACE = "DIAGNOSTIC-INDICATOR-INTERFACE"
    DIAGNOSTIC_MONITOR_INTERFACE = "DIAGNOSTIC-MONITOR-INTERFACE"
    DIAGNOSTIC_OPERATION_CYCLE_INTERFACE = "DIAGNOSTIC-OPERATION-CYCLE-INTERFACE"
    DIAGNOSTIC_PORT_INTERFACE = "DIAGNOSTIC-PORT-INTERFACE"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_INTERFACE = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-INTERFACE"
    DIAGNOSTIC_ROUTINE_GENERIC_INTERFACE = "DIAGNOSTIC-ROUTINE-GENERIC-INTERFACE"
    DIAGNOSTIC_ROUTINE_INTERFACE = "DIAGNOSTIC-ROUTINE-INTERFACE"
    DIAGNOSTIC_SECURITY_LEVEL_INTERFACE = "DIAGNOSTIC-SECURITY-LEVEL-INTERFACE"
    DIAGNOSTIC_SERVICE_VALIDATION_INTERFACE = "DIAGNOSTIC-SERVICE-VALIDATION-INTERFACE"
    DIAGNOSTIC_SOVD_AUTHORIZATION_INTERFACE = "DIAGNOSTIC-SOVD-AUTHORIZATION-INTERFACE"
    DIAGNOSTIC_SOVD_PORT_INTERFACE = "DIAGNOSTIC-SOVD-PORT-INTERFACE"
    DIAGNOSTIC_SOVD_PROXIMITY_CHALLENGE_INTERFACE = "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-INTERFACE"
    DIAGNOSTIC_UPLOAD_INTERFACE = "DIAGNOSTIC-UPLOAD-INTERFACE"
    ECU_ABSTRACTION_SW_COMPONENT_TYPE = "ECU-ABSTRACTION-SW-COMPONENT-TYPE"
    ECUC_DEFINITION_COLLECTION = "ECUC-DEFINITION-COLLECTION"
    ECUC_DESTINATION_URI_DEF_SET = "ECUC-DESTINATION-URI-DEF-SET"
    ECUC_MODULE_DEF = "ECUC-MODULE-DEF"
    FIREWALL_STATE_SWITCH_INTERFACE = "FIREWALL-STATE-SWITCH-INTERFACE"
    FLAT_MAP = "FLAT-MAP"
    IMPLEMENTATION_DATA_TYPE = "IMPLEMENTATION-DATA-TYPE"
    KEYWORD_SET = "KEYWORD-SET"
    LIFE_CYCLE_STATE = "LIFE-CYCLE-STATE"
    LIFE_CYCLE_STATE_DEFINITION_GROUP = "LIFE-CYCLE-STATE-DEFINITION-GROUP"
    LOG_AND_TRACE_INTERFACE = "LOG-AND-TRACE-INTERFACE"
    MODE_DECLARATION_GROUP = "MODE-DECLARATION-GROUP"
    MODE_INTERFACE_MAPPING = "MODE-INTERFACE-MAPPING"
    MODE_SWITCH_INTERFACE = "MODE-SWITCH-INTERFACE"
    NV_BLOCK_SW_COMPONENT_TYPE = "NV-BLOCK-SW-COMPONENT-TYPE"
    NV_DATA_INTERFACE = "NV-DATA-INTERFACE"
    PARAMETER_INTERFACE = "PARAMETER-INTERFACE"
    PARAMETER_SW_COMPONENT_TYPE = "PARAMETER-SW-COMPONENT-TYPE"
    PERSISTENCY_FILE_STORAGE_INTERFACE = "PERSISTENCY-FILE-STORAGE-INTERFACE"
    PERSISTENCY_INTERFACE = "PERSISTENCY-INTERFACE"
    PERSISTENCY_KEY_VALUE_STORAGE_INTERFACE = "PERSISTENCY-KEY-VALUE-STORAGE-INTERFACE"
    PHM_ABSTRACT_RECOVERY_NOTIFICATION_INTERFACE = "PHM-ABSTRACT-RECOVERY-NOTIFICATION-INTERFACE"
    PHM_HEALTH_CHANNEL_INTERFACE = "PHM-HEALTH-CHANNEL-INTERFACE"
    PHM_HEALTH_CHANNEL_RECOVERY_NOTIFICATION_INTERFACE = (
        "PHM-HEALTH-CHANNEL-RECOVERY-NOTIFICATION-INTERFACE"
    )
    PHM_RECOVERY_ACTION_INTERFACE = "PHM-RECOVERY-ACTION-INTERFACE"
    PHM_SUPERVISED_ENTITY_INTERFACE = "PHM-SUPERVISED-ENTITY-INTERFACE"
    PHM_SUPERVISION_RECOVERY_NOTIFICATION_INTERFACE = (
        "PHM-SUPERVISION-RECOVERY-NOTIFICATION-INTERFACE"
    )
    PLATFORM_HEALTH_MANAGEMENT_INTERFACE = "PLATFORM-HEALTH-MANAGEMENT-INTERFACE"
    PORT_INTERFACE = "PORT-INTERFACE"
    PORT_INTERFACE_MAPPING = "PORT-INTERFACE-MAPPING"
    PORT_INTERFACE_MAPPING_SET = "PORT-INTERFACE-MAPPING-SET"
    PORT_PROTOTYPE_BLUEPRINT = "PORT-PROTOTYPE-BLUEPRINT"
    RAW_DATA_STREAM_CLIENT_INTERFACE = "RAW-DATA-STREAM-CLIENT-INTERFACE"
    RAW_DATA_STREAM_SERVER_INTERFACE = "RAW-DATA-STREAM-SERVER-INTERFACE"
    SECURITY_EVENT_REPORT_INTERFACE = "SECURITY-EVENT-REPORT-INTERFACE"
    SENDER_RECEIVER_INTERFACE = "SENDER-RECEIVER-INTERFACE"
    SENSOR_ACTUATOR_SW_COMPONENT_TYPE = "SENSOR-ACTUATOR-SW-COMPONENT-TYPE"
    SERVICE_INTERFACE = "SERVICE-INTERFACE"
    SERVICE_INTERFACE_MAPPING = "SERVICE-INTERFACE-MAPPING"
    SERVICE_PROXY_SW_COMPONENT_TYPE = "SERVICE-PROXY-SW-COMPONENT-TYPE"
    SERVICE_SW_COMPONENT_TYPE = "SERVICE-SW-COMPONENT-TYPE"
    STATE_MANAGEMEN_PHM_ERROR_INTERFACE = "STATE-MANAGEMEN-PHM-ERROR-INTERFACE"
    STATE_MANAGEMENT_DIAG_TRIGGER_INTERFACE = "STATE-MANAGEMENT-DIAG-TRIGGER-INTERFACE"
    STATE_MANAGEMENT_EM_ERROR_INTERFACE = "STATE-MANAGEMENT-EM-ERROR-INTERFACE"
    STATE_MANAGEMENT_ERROR_INTERFACE = "STATE-MANAGEMENT-ERROR-INTERFACE"
    STATE_MANAGEMENT_FUNCTION_GROUP_SWITCH_NOTIFICATION_INTERFACE = (
        "STATE-MANAGEMENT-FUNCTION-GROUP-SWITCH-NOTIFICATION-INTERFACE"
    )
    STATE_MANAGEMENT_NOTIFICATION_INTERFACE = "STATE-MANAGEMENT-NOTIFICATION-INTERFACE"
    STATE_MANAGEMENT_PORT_INTERFACE = "STATE-MANAGEMENT-PORT-INTERFACE"
    STATE_MANAGEMENT_REQUEST_INTERFACE = "STATE-MANAGEMENT-REQUEST-INTERFACE"
    STATE_MANAGEMENT_TRIGGER_INTERFACE = "STATE-MANAGEMENT-TRIGGER-INTERFACE"
    STD_CPP_IMPLEMENTATION_DATA_TYPE = "STD-CPP-IMPLEMENTATION-DATA-TYPE"
    SW_ADDR_METHOD = "SW-ADDR-METHOD"
    SW_BASE_TYPE = "SW-BASE-TYPE"
    SW_COMPONENT_TYPE = "SW-COMPONENT-TYPE"
    SYNCHRONIZED_TIME_BASE_CONSUMER_INTERFACE = "SYNCHRONIZED-TIME-BASE-CONSUMER-INTERFACE"
    SYNCHRONIZED_TIME_BASE_PROVIDER_INTERFACE = "SYNCHRONIZED-TIME-BASE-PROVIDER-INTERFACE"
    TRIGGER_INTERFACE = "TRIGGER-INTERFACE"
    TRIGGER_INTERFACE_MAPPING = "TRIGGER-INTERFACE-MAPPING"
    VARIABLE_AND_PARAMETER_INTERFACE_MAPPING = "VARIABLE-AND-PARAMETER-INTERFACE-MAPPING"
    VFB_TIMING = "VFB-TIMING"


class AtpBlueprintableSubtypesEnum(Enum):
    ABSTRACT_IMPLEMENTATION_DATA_TYPE = "ABSTRACT-IMPLEMENTATION-DATA-TYPE"
    ABSTRACT_PROVIDED_PORT_PROTOTYPE = "ABSTRACT-PROVIDED-PORT-PROTOTYPE"
    ABSTRACT_RAW_DATA_STREAM_INTERFACE = "ABSTRACT-RAW-DATA-STREAM-INTERFACE"
    ABSTRACT_REQUIRED_PORT_PROTOTYPE = "ABSTRACT-REQUIRED-PORT-PROTOTYPE"
    ABSTRACT_SYNCHRONIZED_TIME_BASE_INTERFACE = "ABSTRACT-SYNCHRONIZED-TIME-BASE-INTERFACE"
    ACL_OBJECT_SET = "ACL-OBJECT-SET"
    ACL_OPERATION = "ACL-OPERATION"
    ACL_PERMISSION = "ACL-PERMISSION"
    ACL_ROLE = "ACL-ROLE"
    ADAPTIVE_APPLICATION_SW_COMPONENT_TYPE = "ADAPTIVE-APPLICATION-SW-COMPONENT-TYPE"
    ALIAS_NAME_SET = "ALIAS-NAME-SET"
    APPLICATION_ARRAY_DATA_TYPE = "APPLICATION-ARRAY-DATA-TYPE"
    APPLICATION_ASSOC_MAP_DATA_TYPE = "APPLICATION-ASSOC-MAP-DATA-TYPE"
    APPLICATION_COMPOSITE_DATA_TYPE = "APPLICATION-COMPOSITE-DATA-TYPE"
    APPLICATION_DATA_TYPE = "APPLICATION-DATA-TYPE"
    APPLICATION_DEFERRED_DATA_TYPE = "APPLICATION-DEFERRED-DATA-TYPE"
    APPLICATION_INTERFACE = "APPLICATION-INTERFACE"
    APPLICATION_PRIMITIVE_DATA_TYPE = "APPLICATION-PRIMITIVE-DATA-TYPE"
    APPLICATION_RECORD_DATA_TYPE = "APPLICATION-RECORD-DATA-TYPE"
    APPLICATION_SW_COMPONENT_TYPE = "APPLICATION-SW-COMPONENT-TYPE"
    AR_PACKAGE = "AR-PACKAGE"
    ATOMIC_SW_COMPONENT_TYPE = "ATOMIC-SW-COMPONENT-TYPE"
    ATP_BLUEPRINTABLE = "ATP-BLUEPRINTABLE"
    BSW_ENTRY_RELATIONSHIP_SET = "BSW-ENTRY-RELATIONSHIP-SET"
    BSW_MODULE_DESCRIPTION = "BSW-MODULE-DESCRIPTION"
    BSW_MODULE_ENTRY = "BSW-MODULE-ENTRY"
    BUILD_ACTION = "BUILD-ACTION"
    BUILD_ACTION_ENTITY = "BUILD-ACTION-ENTITY"
    BUILD_ACTION_ENVIRONMENT = "BUILD-ACTION-ENVIRONMENT"
    BUILD_ACTION_MANIFEST = "BUILD-ACTION-MANIFEST"
    CLIENT_SERVER_INTERFACE = "CLIENT-SERVER-INTERFACE"
    CLIENT_SERVER_INTERFACE_MAPPING = "CLIENT-SERVER-INTERFACE-MAPPING"
    COMPLEX_DEVICE_DRIVER_SW_COMPONENT_TYPE = "COMPLEX-DEVICE-DRIVER-SW-COMPONENT-TYPE"
    COMPOSITION_SW_COMPONENT_TYPE = "COMPOSITION-SW-COMPONENT-TYPE"
    COMPU_METHOD = "COMPU-METHOD"
    CONSISTENCY_NEEDS = "CONSISTENCY-NEEDS"
    CPP_IMPLEMENTATION_DATA_TYPE = "CPP-IMPLEMENTATION-DATA-TYPE"
    CRYPTO_CERTIFICATE_INTERFACE = "CRYPTO-CERTIFICATE-INTERFACE"
    CRYPTO_INTERFACE = "CRYPTO-INTERFACE"
    CRYPTO_KEY_SLOT_INTERFACE = "CRYPTO-KEY-SLOT-INTERFACE"
    CRYPTO_PROVIDER_INTERFACE = "CRYPTO-PROVIDER-INTERFACE"
    CRYPTO_TRUST_MASTER_INTERFACE = "CRYPTO-TRUST-MASTER-INTERFACE"
    CUSTOM_CPP_IMPLEMENTATION_DATA_TYPE = "CUSTOM-CPP-IMPLEMENTATION-DATA-TYPE"
    DATA_CONSTR = "DATA-CONSTR"
    DATA_INTERFACE = "DATA-INTERFACE"
    DATA_TYPE_MAPPING_SET = "DATA-TYPE-MAPPING-SET"
    DIAGNOSTIC_ABSTRACT_DATA_IDENTIFIER_INTERFACE = "DIAGNOSTIC-ABSTRACT-DATA-IDENTIFIER-INTERFACE"
    DIAGNOSTIC_ABSTRACT_ROUTINE_INTERFACE = "DIAGNOSTIC-ABSTRACT-ROUTINE-INTERFACE"
    DIAGNOSTIC_AUTHENTICATION_INTERFACE = "DIAGNOSTIC-AUTHENTICATION-INTERFACE"
    DIAGNOSTIC_COM_CONTROL_INTERFACE = "DIAGNOSTIC-COM-CONTROL-INTERFACE"
    DIAGNOSTIC_CONDITION_INTERFACE = "DIAGNOSTIC-CONDITION-INTERFACE"
    DIAGNOSTIC_DATA_ELEMENT_INTERFACE = "DIAGNOSTIC-DATA-ELEMENT-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER_GENERIC_INTERFACE = "DIAGNOSTIC-DATA-IDENTIFIER-GENERIC-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER_INTERFACE = "DIAGNOSTIC-DATA-IDENTIFIER-INTERFACE"
    DIAGNOSTIC_DO_IP_ACTIVATION_LINE_INTERFACE = "DIAGNOSTIC-DO-IP-ACTIVATION-LINE-INTERFACE"
    DIAGNOSTIC_DO_IP_ENTITY_IDENTIFICATION_INTERFACE = (
        "DIAGNOSTIC-DO-IP-ENTITY-IDENTIFICATION-INTERFACE"
    )
    DIAGNOSTIC_DO_IP_GROUP_IDENTIFICATION_INTERFACE = (
        "DIAGNOSTIC-DO-IP-GROUP-IDENTIFICATION-INTERFACE"
    )
    DIAGNOSTIC_DO_IP_POWER_MODE_INTERFACE = "DIAGNOSTIC-DO-IP-POWER-MODE-INTERFACE"
    DIAGNOSTIC_DO_IP_TRIGGER_VEHICLE_ANNOUNCEMENT_INTERFACE = (
        "DIAGNOSTIC-DO-IP-TRIGGER-VEHICLE-ANNOUNCEMENT-INTERFACE"
    )
    DIAGNOSTIC_DOWNLOAD_INTERFACE = "DIAGNOSTIC-DOWNLOAD-INTERFACE"
    DIAGNOSTIC_DTC_INFORMATION_INTERFACE = "DIAGNOSTIC-DTC-INFORMATION-INTERFACE"
    DIAGNOSTIC_ECU_RESET_INTERFACE = "DIAGNOSTIC-ECU-RESET-INTERFACE"
    DIAGNOSTIC_EVENT_INTERFACE = "DIAGNOSTIC-EVENT-INTERFACE"
    DIAGNOSTIC_EXTERNAL_AUTHENTICATION_INTERFACE = "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-INTERFACE"
    DIAGNOSTIC_GENERIC_UDS_INTERFACE = "DIAGNOSTIC-GENERIC-UDS-INTERFACE"
    DIAGNOSTIC_INDICATOR_INTERFACE = "DIAGNOSTIC-INDICATOR-INTERFACE"
    DIAGNOSTIC_MONITOR_INTERFACE = "DIAGNOSTIC-MONITOR-INTERFACE"
    DIAGNOSTIC_OPERATION_CYCLE_INTERFACE = "DIAGNOSTIC-OPERATION-CYCLE-INTERFACE"
    DIAGNOSTIC_PORT_INTERFACE = "DIAGNOSTIC-PORT-INTERFACE"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_INTERFACE = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-INTERFACE"
    DIAGNOSTIC_ROUTINE_GENERIC_INTERFACE = "DIAGNOSTIC-ROUTINE-GENERIC-INTERFACE"
    DIAGNOSTIC_ROUTINE_INTERFACE = "DIAGNOSTIC-ROUTINE-INTERFACE"
    DIAGNOSTIC_SECURITY_LEVEL_INTERFACE = "DIAGNOSTIC-SECURITY-LEVEL-INTERFACE"
    DIAGNOSTIC_SERVICE_VALIDATION_INTERFACE = "DIAGNOSTIC-SERVICE-VALIDATION-INTERFACE"
    DIAGNOSTIC_SOVD_AUTHORIZATION_INTERFACE = "DIAGNOSTIC-SOVD-AUTHORIZATION-INTERFACE"
    DIAGNOSTIC_SOVD_PORT_INTERFACE = "DIAGNOSTIC-SOVD-PORT-INTERFACE"
    DIAGNOSTIC_SOVD_PROXIMITY_CHALLENGE_INTERFACE = "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-INTERFACE"
    DIAGNOSTIC_UPLOAD_INTERFACE = "DIAGNOSTIC-UPLOAD-INTERFACE"
    ECU_ABSTRACTION_SW_COMPONENT_TYPE = "ECU-ABSTRACTION-SW-COMPONENT-TYPE"
    ECUC_DEFINITION_COLLECTION = "ECUC-DEFINITION-COLLECTION"
    ECUC_DESTINATION_URI_DEF_SET = "ECUC-DESTINATION-URI-DEF-SET"
    ECUC_MODULE_DEF = "ECUC-MODULE-DEF"
    FIREWALL_STATE_SWITCH_INTERFACE = "FIREWALL-STATE-SWITCH-INTERFACE"
    FLAT_MAP = "FLAT-MAP"
    IMPLEMENTATION_DATA_TYPE = "IMPLEMENTATION-DATA-TYPE"
    KEYWORD_SET = "KEYWORD-SET"
    LIFE_CYCLE_STATE = "LIFE-CYCLE-STATE"
    LIFE_CYCLE_STATE_DEFINITION_GROUP = "LIFE-CYCLE-STATE-DEFINITION-GROUP"
    LOG_AND_TRACE_INTERFACE = "LOG-AND-TRACE-INTERFACE"
    MODE_DECLARATION_GROUP = "MODE-DECLARATION-GROUP"
    MODE_INTERFACE_MAPPING = "MODE-INTERFACE-MAPPING"
    MODE_SWITCH_INTERFACE = "MODE-SWITCH-INTERFACE"
    NV_BLOCK_SW_COMPONENT_TYPE = "NV-BLOCK-SW-COMPONENT-TYPE"
    NV_DATA_INTERFACE = "NV-DATA-INTERFACE"
    P_PORT_PROTOTYPE = "P-PORT-PROTOTYPE"
    PARAMETER_INTERFACE = "PARAMETER-INTERFACE"
    PARAMETER_SW_COMPONENT_TYPE = "PARAMETER-SW-COMPONENT-TYPE"
    PERSISTENCY_FILE_STORAGE_INTERFACE = "PERSISTENCY-FILE-STORAGE-INTERFACE"
    PERSISTENCY_INTERFACE = "PERSISTENCY-INTERFACE"
    PERSISTENCY_KEY_VALUE_STORAGE_INTERFACE = "PERSISTENCY-KEY-VALUE-STORAGE-INTERFACE"
    PHM_ABSTRACT_RECOVERY_NOTIFICATION_INTERFACE = "PHM-ABSTRACT-RECOVERY-NOTIFICATION-INTERFACE"
    PHM_HEALTH_CHANNEL_INTERFACE = "PHM-HEALTH-CHANNEL-INTERFACE"
    PHM_HEALTH_CHANNEL_RECOVERY_NOTIFICATION_INTERFACE = (
        "PHM-HEALTH-CHANNEL-RECOVERY-NOTIFICATION-INTERFACE"
    )
    PHM_RECOVERY_ACTION_INTERFACE = "PHM-RECOVERY-ACTION-INTERFACE"
    PHM_SUPERVISED_ENTITY_INTERFACE = "PHM-SUPERVISED-ENTITY-INTERFACE"
    PHM_SUPERVISION_RECOVERY_NOTIFICATION_INTERFACE = (
        "PHM-SUPERVISION-RECOVERY-NOTIFICATION-INTERFACE"
    )
    PLATFORM_HEALTH_MANAGEMENT_INTERFACE = "PLATFORM-HEALTH-MANAGEMENT-INTERFACE"
    PORT_INTERFACE = "PORT-INTERFACE"
    PORT_INTERFACE_MAPPING = "PORT-INTERFACE-MAPPING"
    PORT_INTERFACE_MAPPING_SET = "PORT-INTERFACE-MAPPING-SET"
    PORT_PROTOTYPE = "PORT-PROTOTYPE"
    PR_PORT_PROTOTYPE = "PR-PORT-PROTOTYPE"
    R_PORT_PROTOTYPE = "R-PORT-PROTOTYPE"
    RAW_DATA_STREAM_CLIENT_INTERFACE = "RAW-DATA-STREAM-CLIENT-INTERFACE"
    RAW_DATA_STREAM_SERVER_INTERFACE = "RAW-DATA-STREAM-SERVER-INTERFACE"
    SECURITY_EVENT_REPORT_INTERFACE = "SECURITY-EVENT-REPORT-INTERFACE"
    SENDER_RECEIVER_INTERFACE = "SENDER-RECEIVER-INTERFACE"
    SENSOR_ACTUATOR_SW_COMPONENT_TYPE = "SENSOR-ACTUATOR-SW-COMPONENT-TYPE"
    SERVICE_INTERFACE = "SERVICE-INTERFACE"
    SERVICE_INTERFACE_MAPPING = "SERVICE-INTERFACE-MAPPING"
    SERVICE_PROXY_SW_COMPONENT_TYPE = "SERVICE-PROXY-SW-COMPONENT-TYPE"
    SERVICE_SW_COMPONENT_TYPE = "SERVICE-SW-COMPONENT-TYPE"
    STATE_MANAGEMEN_PHM_ERROR_INTERFACE = "STATE-MANAGEMEN-PHM-ERROR-INTERFACE"
    STATE_MANAGEMENT_DIAG_TRIGGER_INTERFACE = "STATE-MANAGEMENT-DIAG-TRIGGER-INTERFACE"
    STATE_MANAGEMENT_EM_ERROR_INTERFACE = "STATE-MANAGEMENT-EM-ERROR-INTERFACE"
    STATE_MANAGEMENT_ERROR_INTERFACE = "STATE-MANAGEMENT-ERROR-INTERFACE"
    STATE_MANAGEMENT_FUNCTION_GROUP_SWITCH_NOTIFICATION_INTERFACE = (
        "STATE-MANAGEMENT-FUNCTION-GROUP-SWITCH-NOTIFICATION-INTERFACE"
    )
    STATE_MANAGEMENT_NOTIFICATION_INTERFACE = "STATE-MANAGEMENT-NOTIFICATION-INTERFACE"
    STATE_MANAGEMENT_PORT_INTERFACE = "STATE-MANAGEMENT-PORT-INTERFACE"
    STATE_MANAGEMENT_REQUEST_INTERFACE = "STATE-MANAGEMENT-REQUEST-INTERFACE"
    STATE_MANAGEMENT_TRIGGER_INTERFACE = "STATE-MANAGEMENT-TRIGGER-INTERFACE"
    STD_CPP_IMPLEMENTATION_DATA_TYPE = "STD-CPP-IMPLEMENTATION-DATA-TYPE"
    SW_ADDR_METHOD = "SW-ADDR-METHOD"
    SW_BASE_TYPE = "SW-BASE-TYPE"
    SW_COMPONENT_TYPE = "SW-COMPONENT-TYPE"
    SYNCHRONIZED_TIME_BASE_CONSUMER_INTERFACE = "SYNCHRONIZED-TIME-BASE-CONSUMER-INTERFACE"
    SYNCHRONIZED_TIME_BASE_PROVIDER_INTERFACE = "SYNCHRONIZED-TIME-BASE-PROVIDER-INTERFACE"
    TRIGGER_INTERFACE = "TRIGGER-INTERFACE"
    TRIGGER_INTERFACE_MAPPING = "TRIGGER-INTERFACE-MAPPING"
    VARIABLE_AND_PARAMETER_INTERFACE_MAPPING = "VARIABLE-AND-PARAMETER-INTERFACE-MAPPING"
    VFB_TIMING = "VFB-TIMING"


class AtpDefinitionSubtypesEnum(Enum):
    ATP_DEFINITION = "ATP-DEFINITION"
    ECUC_ABSTRACT_EXTERNAL_REFERENCE_DEF = "ECUC-ABSTRACT-EXTERNAL-REFERENCE-DEF"
    ECUC_ABSTRACT_INTERNAL_REFERENCE_DEF = "ECUC-ABSTRACT-INTERNAL-REFERENCE-DEF"
    ECUC_ABSTRACT_REFERENCE_DEF = "ECUC-ABSTRACT-REFERENCE-DEF"
    ECUC_ABSTRACT_STRING_PARAM_DEF = "ECUC-ABSTRACT-STRING-PARAM-DEF"
    ECUC_ADD_INFO_PARAM_DEF = "ECUC-ADD-INFO-PARAM-DEF"
    ECUC_BOOLEAN_PARAM_DEF = "ECUC-BOOLEAN-PARAM-DEF"
    ECUC_CHOICE_CONTAINER_DEF = "ECUC-CHOICE-CONTAINER-DEF"
    ECUC_CHOICE_REFERENCE_DEF = "ECUC-CHOICE-REFERENCE-DEF"
    ECUC_COMMON_ATTRIBUTES = "ECUC-COMMON-ATTRIBUTES"
    ECUC_CONTAINER_DEF = "ECUC-CONTAINER-DEF"
    ECUC_DEFINITION_ELEMENT = "ECUC-DEFINITION-ELEMENT"
    ECUC_ENUMERATION_PARAM_DEF = "ECUC-ENUMERATION-PARAM-DEF"
    ECUC_FLOAT_PARAM_DEF = "ECUC-FLOAT-PARAM-DEF"
    ECUC_FOREIGN_REFERENCE_DEF = "ECUC-FOREIGN-REFERENCE-DEF"
    ECUC_FUNCTION_NAME_DEF = "ECUC-FUNCTION-NAME-DEF"
    ECUC_INSTANCE_REFERENCE_DEF = "ECUC-INSTANCE-REFERENCE-DEF"
    ECUC_INTEGER_PARAM_DEF = "ECUC-INTEGER-PARAM-DEF"
    ECUC_LINKER_SYMBOL_DEF = "ECUC-LINKER-SYMBOL-DEF"
    ECUC_MODULE_DEF = "ECUC-MODULE-DEF"
    ECUC_MULTILINE_STRING_PARAM_DEF = "ECUC-MULTILINE-STRING-PARAM-DEF"
    ECUC_PARAM_CONF_CONTAINER_DEF = "ECUC-PARAM-CONF-CONTAINER-DEF"
    ECUC_PARAMETER_DEF = "ECUC-PARAMETER-DEF"
    ECUC_REFERENCE_DEF = "ECUC-REFERENCE-DEF"
    ECUC_STRING_PARAM_DEF = "ECUC-STRING-PARAM-DEF"
    ECUC_SYMBOLIC_NAME_REFERENCE_DEF = "ECUC-SYMBOLIC-NAME-REFERENCE-DEF"
    ECUC_URI_REFERENCE_DEF = "ECUC-URI-REFERENCE-DEF"
    HW_CATEGORY = "HW-CATEGORY"
    POST_BUILD_VARIANT_CRITERION = "POST-BUILD-VARIANT-CRITERION"
    SW_SYSTEMCONST = "SW-SYSTEMCONST"


class AtpFeatureSubtypesEnum(Enum):
    ABSTRACT_ACCESS_POINT = "ABSTRACT-ACCESS-POINT"
    ABSTRACT_IMPLEMENTATION_DATA_TYPE_ELEMENT = "ABSTRACT-IMPLEMENTATION-DATA-TYPE-ELEMENT"
    ABSTRACT_PROVIDED_PORT_PROTOTYPE = "ABSTRACT-PROVIDED-PORT-PROTOTYPE"
    ABSTRACT_REQUIRED_PORT_PROTOTYPE = "ABSTRACT-REQUIRED-PORT-PROTOTYPE"
    ADAPTIVE_FIREWALL_MODULE_INSTANTIATION = "ADAPTIVE-FIREWALL-MODULE-INSTANTIATION"
    ADAPTIVE_MODULE_INSTANTIATION = "ADAPTIVE-MODULE-INSTANTIATION"
    APPLICATION_ARRAY_ELEMENT = "APPLICATION-ARRAY-ELEMENT"
    APPLICATION_ASSOC_MAP_ELEMENT = "APPLICATION-ASSOC-MAP-ELEMENT"
    APPLICATION_COMPOSITE_ELEMENT_DATA_PROTOTYPE = "APPLICATION-COMPOSITE-ELEMENT-DATA-PROTOTYPE"
    APPLICATION_RECORD_ELEMENT = "APPLICATION-RECORD-ELEMENT"
    ARGUMENT_DATA_PROTOTYPE = "ARGUMENT-DATA-PROTOTYPE"
    ASSEMBLY_SW_CONNECTOR = "ASSEMBLY-SW-CONNECTOR"
    ASYNCHRONOUS_SERVER_CALL_POINT = "ASYNCHRONOUS-SERVER-CALL-POINT"
    ASYNCHRONOUS_SERVER_CALL_RESULT_POINT = "ASYNCHRONOUS-SERVER-CALL-RESULT-POINT"
    ASYNCHRONOUS_SERVER_CALL_RETURNS_EVENT = "ASYNCHRONOUS-SERVER-CALL-RETURNS-EVENT"
    ATP_FEATURE = "ATP-FEATURE"
    ATP_PROTOTYPE = "ATP-PROTOTYPE"
    ATP_STRUCTURE_ELEMENT = "ATP-STRUCTURE-ELEMENT"
    AUTOSAR_DATA_PROTOTYPE = "AUTOSAR-DATA-PROTOTYPE"
    BACKGROUND_EVENT = "BACKGROUND-EVENT"
    BSW_INTERNAL_BEHAVIOR = "BSW-INTERNAL-BEHAVIOR"
    BSW_MODULE_DESCRIPTION = "BSW-MODULE-DESCRIPTION"
    BSW_SERVICE_DEPENDENCY_IDENT = "BSW-SERVICE-DEPENDENCY-IDENT"
    BULK_NV_DATA_DESCRIPTOR = "BULK-NV-DATA-DESCRIPTOR"
    CLIENT_SERVER_OPERATION = "CLIENT-SERVER-OPERATION"
    CPP_IMPLEMENTATION_DATA_TYPE_ELEMENT = "CPP-IMPLEMENTATION-DATA-TYPE-ELEMENT"
    CRYPTO_MODULE_INSTANTIATION = "CRYPTO-MODULE-INSTANTIATION"
    DATA_PROTOTYPE = "DATA-PROTOTYPE"
    DATA_PROTOTYPE_GROUP = "DATA-PROTOTYPE-GROUP"
    DATA_RECEIVE_ERROR_EVENT = "DATA-RECEIVE-ERROR-EVENT"
    DATA_RECEIVED_EVENT = "DATA-RECEIVED-EVENT"
    DATA_SEND_COMPLETED_EVENT = "DATA-SEND-COMPLETED-EVENT"
    DATA_WRITE_COMPLETED_EVENT = "DATA-WRITE-COMPLETED-EVENT"
    DELEGATION_SW_CONNECTOR = "DELEGATION-SW-CONNECTOR"
    DETERMINISTIC_CLIENT = "DETERMINISTIC-CLIENT"
    DETERMINISTIC_SYNC_INSTANTIATION = "DETERMINISTIC-SYNC-INSTANTIATION"
    DETERMINISTIC_SYNC_MASTER = "DETERMINISTIC-SYNC-MASTER"
    DIAGNOSTIC_PARAMETER_IDENT = "DIAGNOSTIC-PARAMETER-IDENT"
    DO_IP_INSTANTIATION = "DO-IP-INSTANTIATION"
    EXTERNAL_TRIGGER_OCCURRED_EVENT = "EXTERNAL-TRIGGER-OCCURRED-EVENT"
    EXTERNAL_TRIGGERING_POINT_IDENT = "EXTERNAL-TRIGGERING-POINT-IDENT"
    FIELD = "FIELD"
    GENERIC_MODULE_INSTANTIATION = "GENERIC-MODULE-INSTANTIATION"
    IAM_MODULE_INSTANTIATION = "IAM-MODULE-INSTANTIATION"
    IDENT_CAPTION = "IDENT-CAPTION"
    IDS_PLATFORM_INSTANTIATION = "IDS-PLATFORM-INSTANTIATION"
    IDSM_MODULE_INSTANTIATION = "IDSM-MODULE-INSTANTIATION"
    IMPLEMENTATION_DATA_TYPE_ELEMENT = "IMPLEMENTATION-DATA-TYPE-ELEMENT"
    INIT_EVENT = "INIT-EVENT"
    INTERNAL_BEHAVIOR = "INTERNAL-BEHAVIOR"
    INTERNAL_TRIGGER_OCCURRED_EVENT = "INTERNAL-TRIGGER-OCCURRED-EVENT"
    INTERNAL_TRIGGERING_POINT = "INTERNAL-TRIGGERING-POINT"
    LOG_AND_TRACE_INSTANTIATION = "LOG-AND-TRACE-INSTANTIATION"
    MACHINE = "MACHINE"
    MACHINE_DESIGN = "MACHINE-DESIGN"
    MODE_ACCESS_POINT_IDENT = "MODE-ACCESS-POINT-IDENT"
    MODE_DECLARATION = "MODE-DECLARATION"
    MODE_DECLARATION_GROUP_PROTOTYPE = "MODE-DECLARATION-GROUP-PROTOTYPE"
    MODE_DECLARATION_MAPPING = "MODE-DECLARATION-MAPPING"
    MODE_SWITCH_POINT = "MODE-SWITCH-POINT"
    MODE_SWITCHED_ACK_EVENT = "MODE-SWITCHED-ACK-EVENT"
    MODE_TRANSITION = "MODE-TRANSITION"
    NM_INSTANTIATION = "NM-INSTANTIATION"
    NON_OS_MODULE_INSTANTIATION = "NON-OS-MODULE-INSTANTIATION"
    NV_BLOCK_DESCRIPTOR = "NV-BLOCK-DESCRIPTOR"
    OPERATION_INVOKED_EVENT = "OPERATION-INVOKED-EVENT"
    OS_MODULE_INSTANTIATION = "OS-MODULE-INSTANTIATION"
    OS_TASK_EXECUTION_EVENT = "OS-TASK-EXECUTION-EVENT"
    P_PORT_PROTOTYPE = "P-PORT-PROTOTYPE"
    PARAMETER_ACCESS = "PARAMETER-ACCESS"
    PARAMETER_DATA_PROTOTYPE = "PARAMETER-DATA-PROTOTYPE"
    PASS_THROUGH_SW_CONNECTOR = "PASS-THROUGH-SW-CONNECTOR"
    PER_INSTANCE_MEMORY = "PER-INSTANCE-MEMORY"
    PERSISTENCY_DATA_ELEMENT = "PERSISTENCY-DATA-ELEMENT"
    PHM_CHECKPOINT = "PHM-CHECKPOINT"
    PHM_HEALTH_CHANNEL_STATUS = "PHM-HEALTH-CHANNEL-STATUS"
    PORT_GROUP = "PORT-GROUP"
    PORT_PROTOTYPE = "PORT-PROTOTYPE"
    PORT_PROTOTYPE_BLUEPRINT = "PORT-PROTOTYPE-BLUEPRINT"
    PR_PORT_PROTOTYPE = "PR-PORT-PROTOTYPE"
    R_PORT_PROTOTYPE = "R-PORT-PROTOTYPE"
    ROOT_SW_CLUSTER_DESIGN_COMPONENT_PROTOTYPE = "ROOT-SW-CLUSTER-DESIGN-COMPONENT-PROTOTYPE"
    ROOT_SW_COMPONENT_PROTOTYPE = "ROOT-SW-COMPONENT-PROTOTYPE"
    ROOT_SW_COMPOSITION_PROTOTYPE = "ROOT-SW-COMPOSITION-PROTOTYPE"
    RTE_EVENT = "RTE-EVENT"
    RUNNABLE_ENTITY = "RUNNABLE-ENTITY"
    RUNNABLE_ENTITY_GROUP = "RUNNABLE-ENTITY-GROUP"
    SERVER_CALL_POINT = "SERVER-CALL-POINT"
    SOVD_GATEWAY_INSTANTIATION = "SOVD-GATEWAY-INSTANTIATION"
    SOVD_MODULE_INSTANTIATION = "SOVD-MODULE-INSTANTIATION"
    SOVD_SERVER_INSTANTIATION = "SOVD-SERVER-INSTANTIATION"
    STATE_MANAGEMENT_MODULE_INSTANTIATION = "STATE-MANAGEMENT-MODULE-INSTANTIATION"
    SW_COMPONENT_PROTOTYPE = "SW-COMPONENT-PROTOTYPE"
    SW_CONNECTOR = "SW-CONNECTOR"
    SWC_BSW_MAPPING = "SWC-BSW-MAPPING"
    SWC_INTERNAL_BEHAVIOR = "SWC-INTERNAL-BEHAVIOR"
    SWC_MODE_MANAGER_ERROR_EVENT = "SWC-MODE-MANAGER-ERROR-EVENT"
    SWC_MODE_SWITCH_EVENT = "SWC-MODE-SWITCH-EVENT"
    SWC_SERVICE_DEPENDENCY = "SWC-SERVICE-DEPENDENCY"
    SYNCHRONOUS_SERVER_CALL_POINT = "SYNCHRONOUS-SERVER-CALL-POINT"
    SYSTEM = "SYSTEM"
    TIME_SYNC_MODULE_INSTANTIATION = "TIME-SYNC-MODULE-INSTANTIATION"
    TIMING_EVENT = "TIMING-EVENT"
    TRANSFORMER_HARD_ERROR_EVENT = "TRANSFORMER-HARD-ERROR-EVENT"
    TRIGGER = "TRIGGER"
    UCM_MASTER_MODULE_INSTANTIATION = "UCM-MASTER-MODULE-INSTANTIATION"
    UCM_MODULE_INSTANTIATION = "UCM-MODULE-INSTANTIATION"
    UCM_SUBORDINATE_MODULE_INSTANTIATION = "UCM-SUBORDINATE-MODULE-INSTANTIATION"
    VARIABLE_ACCESS = "VARIABLE-ACCESS"
    VARIABLE_DATA_PROTOTYPE = "VARIABLE-DATA-PROTOTYPE"


class AutoCollectEnumSimple(Enum):
    """
    :cvar REF_ALL: All objects being referenced (recursively) from the
        objects mentioned directly in the collection are also considered
        as part of the collection.
    :cvar REF_NON_STANDARD: This indicates that non standard objects
        ([TPS_GST_00088]) referenced (recursively) by the objects
        mentioned directly in the collection are also considered to be
        part of the collection.
    :cvar REF_NONE: This indicates that only those objects mentioned
        directly in the collection are part of the collection. No other
        objects are considered further.
    """

    REF_ALL = "REF-ALL"
    REF_NON_STANDARD = "REF-NON-STANDARD"
    REF_NONE = "REF-NONE"


class AutosarDataPrototypeSubtypesEnum(Enum):
    ARGUMENT_DATA_PROTOTYPE = "ARGUMENT-DATA-PROTOTYPE"
    AUTOSAR_DATA_PROTOTYPE = "AUTOSAR-DATA-PROTOTYPE"
    FIELD = "FIELD"
    PARAMETER_DATA_PROTOTYPE = "PARAMETER-DATA-PROTOTYPE"
    PERSISTENCY_DATA_ELEMENT = "PERSISTENCY-DATA-ELEMENT"
    VARIABLE_DATA_PROTOTYPE = "VARIABLE-DATA-PROTOTYPE"


class AutosarDataTypeSubtypesEnum(Enum):
    ABSTRACT_IMPLEMENTATION_DATA_TYPE = "ABSTRACT-IMPLEMENTATION-DATA-TYPE"
    APPLICATION_ARRAY_DATA_TYPE = "APPLICATION-ARRAY-DATA-TYPE"
    APPLICATION_ASSOC_MAP_DATA_TYPE = "APPLICATION-ASSOC-MAP-DATA-TYPE"
    APPLICATION_COMPOSITE_DATA_TYPE = "APPLICATION-COMPOSITE-DATA-TYPE"
    APPLICATION_DATA_TYPE = "APPLICATION-DATA-TYPE"
    APPLICATION_DEFERRED_DATA_TYPE = "APPLICATION-DEFERRED-DATA-TYPE"
    APPLICATION_PRIMITIVE_DATA_TYPE = "APPLICATION-PRIMITIVE-DATA-TYPE"
    APPLICATION_RECORD_DATA_TYPE = "APPLICATION-RECORD-DATA-TYPE"
    AUTOSAR_DATA_TYPE = "AUTOSAR-DATA-TYPE"
    CPP_IMPLEMENTATION_DATA_TYPE = "CPP-IMPLEMENTATION-DATA-TYPE"
    CUSTOM_CPP_IMPLEMENTATION_DATA_TYPE = "CUSTOM-CPP-IMPLEMENTATION-DATA-TYPE"
    IMPLEMENTATION_DATA_TYPE = "IMPLEMENTATION-DATA-TYPE"
    STD_CPP_IMPLEMENTATION_DATA_TYPE = "STD-CPP-IMPLEMENTATION-DATA-TYPE"


class AutosarOperationArgumentInstanceSubtypesEnum(Enum):
    AUTOSAR_OPERATION_ARGUMENT_INSTANCE = "AUTOSAR-OPERATION-ARGUMENT-INSTANCE"


class AutosarVariableInstanceSubtypesEnum(Enum):
    AUTOSAR_VARIABLE_INSTANCE = "AUTOSAR-VARIABLE-INSTANCE"


@dataclass(slots=True, kw_only=True)
class AxisIndexType:
    """This meta-class specifies an axis in a curve/map data object.

    The index satisfies  the following convention:
    * 0 output "axis"
    * 1 input axis 1 (X input axis e.g. of a CURVE)
    * 2 input axis 2 (Y input axis e.g. of a MAP)
    * 3 input axis 3 (Z input axis e.g. of a CUBOID)
    * 4 input axis 3 (Z4 input axis e.g. of a CUBE_4)
    * 5 input axis 3 (Z5 input axis e.g. of a CUBE_5)
    * 6..9 etc.
    The output "axis" provides access to the output value of the parameter. Note that this access is usually performed via an index according to the input axis.
    In addition to this, the Values STRING and ARRAY support specific iterations.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AXIS-INDEX-TYPE"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"[0-9]+|STRING|ARRAY",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BaseTypeEncodingString:
    """This is the string denotion of a BaseType encoding.

    It may be refined by specific use-cases.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BASE-TYPE-ENCODING-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class BinaryManifestResourceDefinitionSubtypesEnum(Enum):
    BINARY_MANIFEST_RESOURCE_DEFINITION = "BINARY-MANIFEST-RESOURCE-DEFINITION"


class BindingTimeEnumSimple(Enum):
    """
    :cvar CODE_GENERATION_TIME: * Coding by hand, based on requirements
        document. * Tool based code generation, e.g. from a model. * The
        model may contain variants. * Only code for the selected
        variant(s) is actually generated.
    :cvar LINK_TIME: Configure what is included in object code, and what
        is omitted Based on which variant(s) are selected E.g. for
        modules that are delivered as object code (as opposed to those
        that are delivered as source code)
    :cvar PRE_COMPILE_TIME: This is typically the C-Preprocessor.
        Exclude parts of the code from the compilation process, e.g.,
        because they are not required for the selected variant, because
        they are incompatible with the selected variant, because they
        require resources that are not present in the selected variant.
        Object code is only generated for the selected variant(s). The
        code that is excluded at this stage code will not be available
        at later stages.
    :cvar SYSTEM_DESIGN_TIME: * Designing the VFB. * Software Component
        types (PortInterfaces). * SWC Prototypes and the Connections
        between SWCprototypes. * Designing the Topology * ECUs and
        interconnecting Networks * Designing the Communication Matrix
        and Data Mapping
    """

    CODE_GENERATION_TIME = "CODE-GENERATION-TIME"
    LINK_TIME = "LINK-TIME"
    PRE_COMPILE_TIME = "PRE-COMPILE-TIME"
    SYSTEM_DESIGN_TIME = "SYSTEM-DESIGN-TIME"


class BlockStateSubtypesEnum(Enum):
    BLOCK_STATE = "BLOCK-STATE"


@dataclass(slots=True, kw_only=True)
class Boolean:
    """A Boolean value denotes a logical condition that is either 'true' or
    'false'.

    It can be one of "0", "1", "true", "false"

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BOOLEAN"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"0|1|true|false",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Br:
    """
    This element is the same as function here as in a HTML document i.e. it forces
    a line break.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BR"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class BswAsynchronousServerCallPointSubtypesEnum(Enum):
    BSW_ASYNCHRONOUS_SERVER_CALL_POINT = "BSW-ASYNCHRONOUS-SERVER-CALL-POINT"


class BswAsynchronousServerCallResultPointSubtypesEnum(Enum):
    BSW_ASYNCHRONOUS_SERVER_CALL_RESULT_POINT = "BSW-ASYNCHRONOUS-SERVER-CALL-RESULT-POINT"


class BswCallTypeSimple(Enum):
    """
    :cvar CALLBACK: Callback (i.e. the caller specifies the signature)
    :cvar CALLOUT: Callout - provide defined means to extend the
        functionality of an existing module.  In this case caller
        specifies the signature.
    :cvar INTERRUPT: Interrupt routine
    :cvar REGULAR: Regular API call
    :cvar SCHEDULED: Called by the scheduler
    """

    CALLBACK = "CALLBACK"
    CALLOUT = "CALLOUT"
    INTERRUPT = "INTERRUPT"
    REGULAR = "REGULAR"
    SCHEDULED = "SCHEDULED"


class BswDistinguishedPartitionSubtypesEnum(Enum):
    BSW_DISTINGUISHED_PARTITION = "BSW-DISTINGUISHED-PARTITION"


class BswEntryKindEnumSimple(Enum):
    """
    :cvar ABSTRACT: This BswModuleEntry specifies an abstract signature
        of C-functions. The signature needs to be implemented by
        concrete BswModuleEntrys
    :cvar CONCRETE: This BswModuleEntry specifies a concrete C-function
        with its signature.
    """

    ABSTRACT = "ABSTRACT"
    CONCRETE = "CONCRETE"


class BswEntryRelationshipEnumSimple(Enum):
    """
    :cvar DERIVED_FROM: Describes that the BswModuleEntry referenced as
        "to" needs to have the same signature as the "abstract"
        BswModuleEntry referenced as "from".
    """

    DERIVED_FROM = "DERIVED-FROM"


class BswExecutionContextSimple(Enum):
    """
    :cvar HOOK: Context of an OS "hook" routine always
    :cvar INTERRUPT_CAT_1: CAT1 interrupt context always
    :cvar INTERRUPT_CAT_2: CAT2 interrupt context always
    :cvar TASK: Task context always
    :cvar UNSPECIFIED: The execution context is not specified by the API
    """

    HOOK = "HOOK"
    INTERRUPT_CAT_1 = "INTERRUPT-CAT-1"
    INTERRUPT_CAT_2 = "INTERRUPT-CAT-2"
    TASK = "TASK"
    UNSPECIFIED = "UNSPECIFIED"


class BswImplementationSubtypesEnum(Enum):
    BSW_IMPLEMENTATION = "BSW-IMPLEMENTATION"


class BswInternalBehaviorSubtypesEnum(Enum):
    BSW_INTERNAL_BEHAVIOR = "BSW-INTERNAL-BEHAVIOR"


class BswInternalTriggeringPointSubtypesEnum(Enum):
    BSW_INTERNAL_TRIGGERING_POINT = "BSW-INTERNAL-TRIGGERING-POINT"


class BswInterruptCategorySimple(Enum):
    """
    :cvar CAT_1: Cat1 interrupt routines are not controlled by the OS
        and are only allowed to make a very limited selection of OS
        calls to enable and disable all interrupts. The
        BswInterruptEntity  is implemented by the interrupt service
        routine, which is directly called from the interrupt vector (not
        via the OS).
    :cvar CAT_2: Cat2 interrupt routines are controlled by the OS and
        they are allowed to make OS calls. The BswInterruptEntity  is
        implemented by the interrupt handler, which is called from the
        OS.
    """

    CAT_1 = "CAT-1"
    CAT_2 = "CAT-2"


class BswModuleClientServerEntrySubtypesEnum(Enum):
    BSW_MODULE_CLIENT_SERVER_ENTRY = "BSW-MODULE-CLIENT-SERVER-ENTRY"


class BswModuleDescriptionSubtypesEnum(Enum):
    BSW_MODULE_DESCRIPTION = "BSW-MODULE-DESCRIPTION"


class BswModuleEntitySubtypesEnum(Enum):
    BSW_CALLED_ENTITY = "BSW-CALLED-ENTITY"
    BSW_INTERRUPT_ENTITY = "BSW-INTERRUPT-ENTITY"
    BSW_MODULE_ENTITY = "BSW-MODULE-ENTITY"
    BSW_SCHEDULABLE_ENTITY = "BSW-SCHEDULABLE-ENTITY"


class BswModuleEntrySubtypesEnum(Enum):
    BSW_MODULE_ENTRY = "BSW-MODULE-ENTRY"


class BswSchedulerNamePrefixSubtypesEnum(Enum):
    BSW_SCHEDULER_NAME_PREFIX = "BSW-SCHEDULER-NAME-PREFIX"


class BswServiceDependencyIdentSubtypesEnum(Enum):
    BSW_SERVICE_DEPENDENCY_IDENT = "BSW-SERVICE-DEPENDENCY-IDENT"


class BuildActionSubtypesEnum(Enum):
    BUILD_ACTION = "BUILD-ACTION"


class BuildActionEnvironmentSubtypesEnum(Enum):
    BUILD_ACTION_ENVIRONMENT = "BUILD-ACTION-ENVIRONMENT"


class BuildActionManifestSubtypesEnum(Enum):
    BUILD_ACTION_MANIFEST = "BUILD-ACTION-MANIFEST"


class BuildTypeEnumSimple(Enum):
    """
    :cvar BUILD_TYPE_DEBUG: Used for debugging.
    :cvar BUILD_TYPE_RELEASE: Used for releasing.
    """

    BUILD_TYPE_DEBUG = "BUILD-TYPE-DEBUG"
    BUILD_TYPE_RELEASE = "BUILD-TYPE-RELEASE"


class ByteOrderEnumSimple(Enum):
    """
    :cvar MOST_SIGNIFICANT_BYTE_FIRST: Most significant byte shall come
        at the lowest address (also known as BigEndian or as Motorola-
        Format)
    :cvar MOST_SIGNIFICANT_BYTE_LAST: Most significant byte shall come
        highest address (also known as LittleEndian or as Intel-Format)
    :cvar OPAQUE: For opaque data endianness conversion has to be
        configured to Opaque. See AUTOSAR COM Specification for more
        details.
    """

    MOST_SIGNIFICANT_BYTE_FIRST = "MOST-SIGNIFICANT-BYTE-FIRST"
    MOST_SIGNIFICANT_BYTE_LAST = "MOST-SIGNIFICANT-BYTE-LAST"
    OPAQUE = "OPAQUE"


@dataclass(slots=True, kw_only=True)
class CIdentifier:
    """
    This datatype represents a string, that follows the rules of C-identifiers.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar name_pattern: This attribute represents a pattern which shall
        be used to define the value of the identifier if the CIdentifier
        in question is part of a blueprint. For more details refer to
        TPS_StandardizationTemplate.
    """

    class Meta:
        name = "C-IDENTIFIER"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"[a-zA-Z_][a-zA-Z0-9_]*",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    name_pattern: str | None = field(
        default=None,
        metadata={
            "name": "NAME-PATTERN",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class CIdentifierWithIndex:
    """
    This datatype represents a string, that follows the rules of C-identifiers with
    an index.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "C-IDENTIFIER-WITH-INDEX"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"[a-zA-Z_][a-zA-Z0-9_]*\[[0-9]+\]",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class CalibrationParameterValueSetSubtypesEnum(Enum):
    CALIBRATION_PARAMETER_VALUE_SET = "CALIBRATION-PARAMETER-VALUE-SET"


class CalprmAxisCategoryEnumSimple(Enum):
    """
    :cvar COM_AXIS: COM-AXIS is equal to an STD_AXIS, the difference is,
        that a COM-AXIS is an shared axis, that means this axis can be
        used multiple times by different curves or maps. This value is
        obsolete.
    :cvar COM_AXIS_1: COM_AXIS is equal to an STD_AXIS, the difference
        is, that a COM_AXIS is an shared axis, that means this axis can
        be used multiple times by different CURVEs,  MAPs, CUBOIDs,
        CUBE_4s, and CUBE_5s.
    :cvar CURVE_AXIS: CURVE-AXIS uses a separate CURVE to rescale the
        axis. The referenced CURVE is used to lookup an axis index, and
        the index value is used by the controller to determine the
        operating point in the CURVE or MAP. This value is obsolete.
    :cvar CURVE_AXIS_1: CURVE_AXIS uses a separate CURVE to rescale the
        axis. The referenced CURVE is used to lookup an axis index, and
        the index value is used by the controller to determine the
        operating point in the CURVE, MAP, CUBOID, CUBE_4, or CUBE_5.
    :cvar FIX_AXIS: FIX-AXIS means that the input axis is not stored.
        The axis is calculated using parameters  and so on it is also
        not possible to modify the axis points. This value is obsolete.
    :cvar FIX_AXIS_1: FIX_AXIS means that the input axis is not stored.
        The axis is calculated using parameters  and so on it is also
        not possible to modify the axis points.
    :cvar RES_AXIS: RES-AXIS is also an shared axis like COM_AXIS, the
        difference is that this kind of axis can be used for rescaling.
        This value is obsolete.
    :cvar RES_AXIS_1: RES_AXIS is also an shared axis like COM_AXIS, the
        difference is that this kind of axis can be used for rescaling.
    :cvar STD_AXIS: STD-AXIS means that input and output axis definition
        are stored within this CURVE. There is no shared or calculated
        axis. This value is obsolete.
    :cvar STD_AXIS_1: STD_AXIS means that input and output axis
        definition are stored within this CURVE, MAP, CUBOID, CUBE_4,
        and CUBE_5. There is no shared or calculated axis.
    """

    COM_AXIS = "COM-AXIS"
    COM_AXIS_1 = "COM_AXIS"
    CURVE_AXIS = "CURVE-AXIS"
    CURVE_AXIS_1 = "CURVE_AXIS"
    FIX_AXIS = "FIX-AXIS"
    FIX_AXIS_1 = "FIX_AXIS"
    RES_AXIS = "RES-AXIS"
    RES_AXIS_1 = "RES_AXIS"
    STD_AXIS = "STD-AXIS"
    STD_AXIS_1 = "STD_AXIS"


class CanAddressingModeTypeSimple(Enum):
    """
    :cvar EXTENDED: Extended 29-bit-identifiers are used (CAN 2.0B)
    :cvar STANDARD: Standard 11-bit-identifiers are used (CAN 2.0A)
    """

    EXTENDED = "EXTENDED"
    STANDARD = "STANDARD"


class CanFrameRxBehaviorEnumSimple(Enum):
    """
    :cvar ANY: This CAN frame may be received as both, CAN 2.0 and CAN
        FD.
    :cvar CAN_20: This CAN frame shall be received as CAN 2.0 only. In
        case the CAN frame is received as CAN FD it is discarded during
        reception.
    :cvar CAN_FD: This CAN frame shall be received as CAN FD only. In
        case the CAN frame is received as CAN 2.0 it is discarded during
        reception.
    """

    ANY = "ANY"
    CAN_20 = "CAN-20"
    CAN_FD = "CAN-FD"


class CanFrameTriggeringSubtypesEnum(Enum):
    CAN_FRAME_TRIGGERING = "CAN-FRAME-TRIGGERING"


class CanFrameTxBehaviorEnumSimple(Enum):
    """
    :cvar CAN_20: This CAN frame shall be sent as CAN 2.0 only.
    :cvar CAN_FD: This CAN frame shall be sent as CAN FD.
    """

    CAN_20 = "CAN-20"
    CAN_FD = "CAN-FD"


class CanNmClusterSubtypesEnum(Enum):
    CAN_NM_CLUSTER = "CAN-NM-CLUSTER"


class CanTpAddressSubtypesEnum(Enum):
    CAN_TP_ADDRESS = "CAN-TP-ADDRESS"


class CanTpAddressingFormatTypeSimple(Enum):
    """
    :cvar EXTENDED: To use extended addressing format.
    :cvar MIXED: To use mixed 11bit addressing format.
    :cvar MIXED_29_BIT: To use mixed 29bit addressing format
    :cvar NORMALFIXED: To use normal fixed addressing format
    :cvar STANDARD: To use normal addressing format.
    """

    EXTENDED = "EXTENDED"
    MIXED = "MIXED"
    MIXED_29_BIT = "MIXED-29-BIT"
    NORMALFIXED = "NORMALFIXED"
    STANDARD = "STANDARD"


class CanTpChannelSubtypesEnum(Enum):
    CAN_TP_CHANNEL = "CAN-TP-CHANNEL"


class CanTpChannelModeTypeSimple(Enum):
    """
    :cvar FULL_DUPLEX_MODE: full duplex channel mode
    :cvar HALF_DUPLEX_MODE: half duplex channel mode
    """

    FULL_DUPLEX_MODE = "FULL-DUPLEX-MODE"
    HALF_DUPLEX_MODE = "HALF-DUPLEX-MODE"


class CanTpNodeSubtypesEnum(Enum):
    CAN_TP_NODE = "CAN-TP-NODE"


class CanXlPropsSubtypesEnum(Enum):
    CAN_XL_PROPS = "CAN-XL-PROPS"


@dataclass(slots=True, kw_only=True)
class CategoryString:
    """This represents the pattern applicable to categories.

    It is basically the same as Identifier but has a different
    semantics. Therefore it is modeled as a primitive of its own.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CATEGORY-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"[a-zA-Z][a-zA-Z0-9_]*",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class ChapterEnumBreakSimple(Enum):
    """
    :cvar BREAK: This indicates the a page break shall be applied before
        the current block.
    :cvar NO_BREAK: This indicates that there is no need to force a page
        break before this block.
    """

    BREAK = "BREAK"
    NO_BREAK = "NO-BREAK"


class CheckpointTransitionSubtypesEnum(Enum):
    CHECKPOINT_TRANSITION = "CHECKPOINT-TRANSITION"


class ClientIdDefinitionSetSubtypesEnum(Enum):
    CLIENT_ID_DEFINITION_SET = "CLIENT-ID-DEFINITION-SET"


class ClientIntentEnumSimple(Enum):
    """
    :cvar WILL_CALL: The client will call this method.
    :cvar WONT_CALL: The client won't call this method.
    """

    WILL_CALL = "WILL-CALL"
    WONT_CALL = "WONT-CALL"


class ClientServerInterfaceSubtypesEnum(Enum):
    CLIENT_SERVER_INTERFACE = "CLIENT-SERVER-INTERFACE"


class ClientServerOperationSubtypesEnum(Enum):
    CLIENT_SERVER_OPERATION = "CLIENT-SERVER-OPERATION"


class CollectableElementSubtypesEnum(Enum):
    ABSTRACT_CAN_CLUSTER = "ABSTRACT-CAN-CLUSTER"
    ABSTRACT_ETHERNET_FRAME = "ABSTRACT-ETHERNET-FRAME"
    ABSTRACT_EXECUTION_CONTEXT = "ABSTRACT-EXECUTION-CONTEXT"
    ABSTRACT_IAM_REMOTE_SUBJECT = "ABSTRACT-IAM-REMOTE-SUBJECT"
    ABSTRACT_IMPLEMENTATION_DATA_TYPE = "ABSTRACT-IMPLEMENTATION-DATA-TYPE"
    ABSTRACT_RAW_DATA_STREAM_INTERFACE = "ABSTRACT-RAW-DATA-STREAM-INTERFACE"
    ABSTRACT_SYNCHRONIZED_TIME_BASE_INTERFACE = "ABSTRACT-SYNCHRONIZED-TIME-BASE-INTERFACE"
    ACL_OBJECT_SET = "ACL-OBJECT-SET"
    ACL_OPERATION = "ACL-OPERATION"
    ACL_PERMISSION = "ACL-PERMISSION"
    ACL_ROLE = "ACL-ROLE"
    ADAPTIVE_APPLICATION_SW_COMPONENT_TYPE = "ADAPTIVE-APPLICATION-SW-COMPONENT-TYPE"
    ADAPTIVE_FIREWALL_TO_PORT_PROTOTYPE_MAPPING = "ADAPTIVE-FIREWALL-TO-PORT-PROTOTYPE-MAPPING"
    ADAPTIVE_PLATFORM_SERVICE_INSTANCE = "ADAPTIVE-PLATFORM-SERVICE-INSTANCE"
    ALIAS_NAME_SET = "ALIAS-NAME-SET"
    ALLOCATOR = "ALLOCATOR"
    AP_APPLICATION_ERROR = "AP-APPLICATION-ERROR"
    AP_APPLICATION_ERROR_DOMAIN = "AP-APPLICATION-ERROR-DOMAIN"
    AP_APPLICATION_ERROR_SET = "AP-APPLICATION-ERROR-SET"
    APPLICATION_ARRAY_DATA_TYPE = "APPLICATION-ARRAY-DATA-TYPE"
    APPLICATION_ASSOC_MAP_DATA_TYPE = "APPLICATION-ASSOC-MAP-DATA-TYPE"
    APPLICATION_COMPOSITE_DATA_TYPE = "APPLICATION-COMPOSITE-DATA-TYPE"
    APPLICATION_DATA_TYPE = "APPLICATION-DATA-TYPE"
    APPLICATION_DEFERRED_DATA_TYPE = "APPLICATION-DEFERRED-DATA-TYPE"
    APPLICATION_INTERFACE = "APPLICATION-INTERFACE"
    APPLICATION_PARTITION = "APPLICATION-PARTITION"
    APPLICATION_PRIMITIVE_DATA_TYPE = "APPLICATION-PRIMITIVE-DATA-TYPE"
    APPLICATION_RECORD_DATA_TYPE = "APPLICATION-RECORD-DATA-TYPE"
    APPLICATION_SW_COMPONENT_TYPE = "APPLICATION-SW-COMPONENT-TYPE"
    AR_ELEMENT = "AR-ELEMENT"
    AR_PACKAGE = "AR-PACKAGE"
    ARTIFACT_CHECKSUM_TO_CRYPTO_PROVIDER_MAPPING = "ARTIFACT-CHECKSUM-TO-CRYPTO-PROVIDER-MAPPING"
    ATOMIC_SW_COMPONENT_TYPE = "ATOMIC-SW-COMPONENT-TYPE"
    AUTOSAR_DATA_TYPE = "AUTOSAR-DATA-TYPE"
    BASE_TYPE = "BASE-TYPE"
    BLUEPRINT_MAPPING_SET = "BLUEPRINT-MAPPING-SET"
    BSW_COMPOSITION_TIMING = "BSW-COMPOSITION-TIMING"
    BSW_ENTRY_RELATIONSHIP_SET = "BSW-ENTRY-RELATIONSHIP-SET"
    BSW_IMPLEMENTATION = "BSW-IMPLEMENTATION"
    BSW_MODULE_DESCRIPTION = "BSW-MODULE-DESCRIPTION"
    BSW_MODULE_ENTRY = "BSW-MODULE-ENTRY"
    BSW_MODULE_TIMING = "BSW-MODULE-TIMING"
    BUILD_ACTION_MANIFEST = "BUILD-ACTION-MANIFEST"
    BUS_MIRROR_CHANNEL_MAPPING = "BUS-MIRROR-CHANNEL-MAPPING"
    BUS_MIRROR_CHANNEL_MAPPING_CAN = "BUS-MIRROR-CHANNEL-MAPPING-CAN"
    BUS_MIRROR_CHANNEL_MAPPING_FLEXRAY = "BUS-MIRROR-CHANNEL-MAPPING-FLEXRAY"
    BUS_MIRROR_CHANNEL_MAPPING_IP = "BUS-MIRROR-CHANNEL-MAPPING-IP"
    BUS_MIRROR_CHANNEL_MAPPING_USER_DEFINED = "BUS-MIRROR-CHANNEL-MAPPING-USER-DEFINED"
    CALIBRATION_PARAMETER_VALUE_SET = "CALIBRATION-PARAMETER-VALUE-SET"
    CAN_CLUSTER = "CAN-CLUSTER"
    CAN_FRAME = "CAN-FRAME"
    CAN_TP_CONFIG = "CAN-TP-CONFIG"
    CAN_XL_PROPS = "CAN-XL-PROPS"
    CLIENT_ID_DEFINITION_SET = "CLIENT-ID-DEFINITION-SET"
    CLIENT_SERVER_INTERFACE = "CLIENT-SERVER-INTERFACE"
    CLIENT_SERVER_INTERFACE_TO_BSW_MODULE_ENTRY_BLUEPRINT_MAPPING = (
        "CLIENT-SERVER-INTERFACE-TO-BSW-MODULE-ENTRY-BLUEPRINT-MAPPING"
    )
    COLLECTABLE_ELEMENT = "COLLECTABLE-ELEMENT"
    COLLECTION = "COLLECTION"
    COM_CERTIFICATE_TO_CRYPTO_CERTIFICATE_MAPPING = "COM-CERTIFICATE-TO-CRYPTO-CERTIFICATE-MAPPING"
    COM_EVENT_GRANT = "COM-EVENT-GRANT"
    COM_EVENT_GRANT_DESIGN = "COM-EVENT-GRANT-DESIGN"
    COM_FIELD_GRANT = "COM-FIELD-GRANT"
    COM_FIELD_GRANT_DESIGN = "COM-FIELD-GRANT-DESIGN"
    COM_FIND_SERVICE_GRANT = "COM-FIND-SERVICE-GRANT"
    COM_FIND_SERVICE_GRANT_DESIGN = "COM-FIND-SERVICE-GRANT-DESIGN"
    COM_GRANT = "COM-GRANT"
    COM_GRANT_DESIGN = "COM-GRANT-DESIGN"
    COM_KEY_TO_CRYPTO_KEY_SLOT_MAPPING = "COM-KEY-TO-CRYPTO-KEY-SLOT-MAPPING"
    COM_METHOD_GRANT = "COM-METHOD-GRANT"
    COM_METHOD_GRANT_DESIGN = "COM-METHOD-GRANT-DESIGN"
    COM_OFFER_SERVICE_GRANT = "COM-OFFER-SERVICE-GRANT"
    COM_OFFER_SERVICE_GRANT_DESIGN = "COM-OFFER-SERVICE-GRANT-DESIGN"
    COM_SEC_OC_TO_CRYPTO_KEY_SLOT_MAPPING = "COM-SEC-OC-TO-CRYPTO-KEY-SLOT-MAPPING"
    COM_TRIGGER_GRANT_DESIGN = "COM-TRIGGER-GRANT-DESIGN"
    COMMUNICATION_CLUSTER = "COMMUNICATION-CLUSTER"
    COMPLEX_DEVICE_DRIVER_SW_COMPONENT_TYPE = "COMPLEX-DEVICE-DRIVER-SW-COMPONENT-TYPE"
    COMPOSITION_P_PORT_TO_EXECUTABLE_P_PORT_MAPPING = (
        "COMPOSITION-P-PORT-TO-EXECUTABLE-P-PORT-MAPPING"
    )
    COMPOSITION_PORT_TO_EXECUTABLE_PORT_MAPPING = "COMPOSITION-PORT-TO-EXECUTABLE-PORT-MAPPING"
    COMPOSITION_R_PORT_TO_EXECUTABLE_R_PORT_MAPPING = (
        "COMPOSITION-R-PORT-TO-EXECUTABLE-R-PORT-MAPPING"
    )
    COMPOSITION_SW_COMPONENT_TYPE = "COMPOSITION-SW-COMPONENT-TYPE"
    COMPU_METHOD = "COMPU-METHOD"
    CONSISTENCY_NEEDS_BLUEPRINT_SET = "CONSISTENCY-NEEDS-BLUEPRINT-SET"
    CONSTANT_SPECIFICATION = "CONSTANT-SPECIFICATION"
    CONSTANT_SPECIFICATION_MAPPING_SET = "CONSTANT-SPECIFICATION-MAPPING-SET"
    CONSUMED_PROVIDED_SERVICE_INSTANCE_GROUP = "CONSUMED-PROVIDED-SERVICE-INSTANCE-GROUP"
    CONTAINER_I_PDU = "CONTAINER-I-PDU"
    COUPLING_ELEMENT = "COUPLING-ELEMENT"
    CP_SOFTWARE_CLUSTER = "CP-SOFTWARE-CLUSTER"
    CP_SOFTWARE_CLUSTER_BINARY_MANIFEST_DESCRIPTOR = (
        "CP-SOFTWARE-CLUSTER-BINARY-MANIFEST-DESCRIPTOR"
    )
    CP_SOFTWARE_CLUSTER_MAPPING_SET = "CP-SOFTWARE-CLUSTER-MAPPING-SET"
    CP_SOFTWARE_CLUSTER_RESOURCE_POOL = "CP-SOFTWARE-CLUSTER-RESOURCE-POOL"
    CP_SW_CLUSTER_RESOURCE_TO_DIAG_DATA_ELEM_MAPPING = (
        "CP-SW-CLUSTER-RESOURCE-TO-DIAG-DATA-ELEM-MAPPING"
    )
    CP_SW_CLUSTER_RESOURCE_TO_DIAG_FUNCTION_ID_MAPPING = (
        "CP-SW-CLUSTER-RESOURCE-TO-DIAG-FUNCTION-ID-MAPPING"
    )
    CP_SW_CLUSTER_TO_DIAG_EVENT_MAPPING = "CP-SW-CLUSTER-TO-DIAG-EVENT-MAPPING"
    CP_SW_CLUSTER_TO_DIAG_ROUTINE_SUBFUNCTION_MAPPING = (
        "CP-SW-CLUSTER-TO-DIAG-ROUTINE-SUBFUNCTION-MAPPING"
    )
    CPP_IMPLEMENTATION_DATA_TYPE = "CPP-IMPLEMENTATION-DATA-TYPE"
    CRYPTO_CERTIFICATE_INTERFACE = "CRYPTO-CERTIFICATE-INTERFACE"
    CRYPTO_CERTIFICATE_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-CERTIFICATE-TO-PORT-PROTOTYPE-MAPPING"
    CRYPTO_ELLIPTIC_CURVE_PROPS = "CRYPTO-ELLIPTIC-CURVE-PROPS"
    CRYPTO_INTERFACE = "CRYPTO-INTERFACE"
    CRYPTO_KEY_SLOT_INTERFACE = "CRYPTO-KEY-SLOT-INTERFACE"
    CRYPTO_KEY_SLOT_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-KEY-SLOT-TO-PORT-PROTOTYPE-MAPPING"
    CRYPTO_PROVIDER_INTERFACE = "CRYPTO-PROVIDER-INTERFACE"
    CRYPTO_PROVIDER_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-PROVIDER-TO-PORT-PROTOTYPE-MAPPING"
    CRYPTO_SERVICE_CERTIFICATE = "CRYPTO-SERVICE-CERTIFICATE"
    CRYPTO_SERVICE_KEY = "CRYPTO-SERVICE-KEY"
    CRYPTO_SERVICE_PRIMITIVE = "CRYPTO-SERVICE-PRIMITIVE"
    CRYPTO_SERVICE_QUEUE = "CRYPTO-SERVICE-QUEUE"
    CRYPTO_SIGNATURE_SCHEME = "CRYPTO-SIGNATURE-SCHEME"
    CRYPTO_TRUST_MASTER_INTERFACE = "CRYPTO-TRUST-MASTER-INTERFACE"
    CUSTOM_CPP_IMPLEMENTATION_DATA_TYPE = "CUSTOM-CPP-IMPLEMENTATION-DATA-TYPE"
    DATA_CONSTR = "DATA-CONSTR"
    DATA_EXCHANGE_POINT = "DATA-EXCHANGE-POINT"
    DATA_INTERFACE = "DATA-INTERFACE"
    DATA_TRANSFORMATION_SET = "DATA-TRANSFORMATION-SET"
    DATA_TYPE_MAPPING_SET = "DATA-TYPE-MAPPING-SET"
    DCM_I_PDU = "DCM-I-PDU"
    DDS_PROVIDED_SERVICE_INSTANCE = "DDS-PROVIDED-SERVICE-INSTANCE"
    DDS_REQUIRED_SERVICE_INSTANCE = "DDS-REQUIRED-SERVICE-INSTANCE"
    DDS_SECURE_COM_PROPS = "DDS-SECURE-COM-PROPS"
    DDS_SECURE_GOVERNANCE = "DDS-SECURE-GOVERNANCE"
    DDS_SERVICE_INSTANCE_TO_MACHINE_MAPPING = "DDS-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    DDS_SERVICE_INTERFACE_DEPLOYMENT = "DDS-SERVICE-INTERFACE-DEPLOYMENT"
    DDS_TOPIC_ACCESS_RULE = "DDS-TOPIC-ACCESS-RULE"
    DETERMINISTIC_CLIENT = "DETERMINISTIC-CLIENT"
    DETERMINISTIC_SYNC_MASTER_TO_TIME_BASE_CONSUMER_MAPPING = (
        "DETERMINISTIC-SYNC-MASTER-TO-TIME-BASE-CONSUMER-MAPPING"
    )
    DIAGNOSTIC_ABSTRACT_ALIAS_EVENT = "DIAGNOSTIC-ABSTRACT-ALIAS-EVENT"
    DIAGNOSTIC_ABSTRACT_DATA_IDENTIFIER = "DIAGNOSTIC-ABSTRACT-DATA-IDENTIFIER"
    DIAGNOSTIC_ABSTRACT_DATA_IDENTIFIER_INTERFACE = "DIAGNOSTIC-ABSTRACT-DATA-IDENTIFIER-INTERFACE"
    DIAGNOSTIC_ABSTRACT_ROUTINE_INTERFACE = "DIAGNOSTIC-ABSTRACT-ROUTINE-INTERFACE"
    DIAGNOSTIC_ACCESS_PERMISSION = "DIAGNOSTIC-ACCESS-PERMISSION"
    DIAGNOSTIC_AGING = "DIAGNOSTIC-AGING"
    DIAGNOSTIC_AUTH_ROLE = "DIAGNOSTIC-AUTH-ROLE"
    DIAGNOSTIC_AUTHENTICATION = "DIAGNOSTIC-AUTHENTICATION"
    DIAGNOSTIC_AUTHENTICATION_CLASS = "DIAGNOSTIC-AUTHENTICATION-CLASS"
    DIAGNOSTIC_AUTHENTICATION_CONFIGURATION = "DIAGNOSTIC-AUTHENTICATION-CONFIGURATION"
    DIAGNOSTIC_AUTHENTICATION_INTERFACE = "DIAGNOSTIC-AUTHENTICATION-INTERFACE"
    DIAGNOSTIC_AUTHENTICATION_PORT_MAPPING = "DIAGNOSTIC-AUTHENTICATION-PORT-MAPPING"
    DIAGNOSTIC_CLEAR_CONDITION = "DIAGNOSTIC-CLEAR-CONDITION"
    DIAGNOSTIC_CLEAR_CONDITION_GROUP = "DIAGNOSTIC-CLEAR-CONDITION-GROUP"
    DIAGNOSTIC_CLEAR_CONDITION_PORT_MAPPING = "DIAGNOSTIC-CLEAR-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_CLEAR_DIAGNOSTIC_INFORMATION = "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION"
    DIAGNOSTIC_CLEAR_DIAGNOSTIC_INFORMATION_CLASS = "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION-CLASS"
    DIAGNOSTIC_CLEAR_RESET_EMISSION_RELATED_INFO = "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO"
    DIAGNOSTIC_CLEAR_RESET_EMISSION_RELATED_INFO_CLASS = (
        "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO-CLASS"
    )
    DIAGNOSTIC_COM_CONTROL = "DIAGNOSTIC-COM-CONTROL"
    DIAGNOSTIC_COM_CONTROL_CLASS = "DIAGNOSTIC-COM-CONTROL-CLASS"
    DIAGNOSTIC_COM_CONTROL_INTERFACE = "DIAGNOSTIC-COM-CONTROL-INTERFACE"
    DIAGNOSTIC_COMMON_ELEMENT = "DIAGNOSTIC-COMMON-ELEMENT"
    DIAGNOSTIC_CONDITION = "DIAGNOSTIC-CONDITION"
    DIAGNOSTIC_CONDITION_GROUP = "DIAGNOSTIC-CONDITION-GROUP"
    DIAGNOSTIC_CONDITION_INTERFACE = "DIAGNOSTIC-CONDITION-INTERFACE"
    DIAGNOSTIC_CONNECTION = "DIAGNOSTIC-CONNECTION"
    DIAGNOSTIC_CONTRIBUTION_SET = "DIAGNOSTIC-CONTRIBUTION-SET"
    DIAGNOSTIC_CONTROL_DTC_SETTING = "DIAGNOSTIC-CONTROL-DTC-SETTING"
    DIAGNOSTIC_CONTROL_DTC_SETTING_CLASS = "DIAGNOSTIC-CONTROL-DTC-SETTING-CLASS"
    DIAGNOSTIC_CUSTOM_SERVICE_CLASS = "DIAGNOSTIC-CUSTOM-SERVICE-CLASS"
    DIAGNOSTIC_CUSTOM_SERVICE_INSTANCE = "DIAGNOSTIC-CUSTOM-SERVICE-INSTANCE"
    DIAGNOSTIC_DATA_BY_IDENTIFIER = "DIAGNOSTIC-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_DATA_ELEMENT_INTERFACE = "DIAGNOSTIC-DATA-ELEMENT-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER = "DIAGNOSTIC-DATA-IDENTIFIER"
    DIAGNOSTIC_DATA_IDENTIFIER_GENERIC_INTERFACE = "DIAGNOSTIC-DATA-IDENTIFIER-GENERIC-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER_INTERFACE = "DIAGNOSTIC-DATA-IDENTIFIER-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER_SET = "DIAGNOSTIC-DATA-IDENTIFIER-SET"
    DIAGNOSTIC_DATA_PORT_MAPPING = "DIAGNOSTIC-DATA-PORT-MAPPING"
    DIAGNOSTIC_DATA_TRANSFER = "DIAGNOSTIC-DATA-TRANSFER"
    DIAGNOSTIC_DATA_TRANSFER_CLASS = "DIAGNOSTIC-DATA-TRANSFER-CLASS"
    DIAGNOSTIC_DE_AUTHENTICATION = "DIAGNOSTIC-DE-AUTHENTICATION"
    DIAGNOSTIC_DEM_PROVIDED_DATA_MAPPING = "DIAGNOSTIC-DEM-PROVIDED-DATA-MAPPING"
    DIAGNOSTIC_DO_IP_ACTIVATION_LINE_INTERFACE = "DIAGNOSTIC-DO-IP-ACTIVATION-LINE-INTERFACE"
    DIAGNOSTIC_DO_IP_ENTITY_IDENTIFICATION_INTERFACE = (
        "DIAGNOSTIC-DO-IP-ENTITY-IDENTIFICATION-INTERFACE"
    )
    DIAGNOSTIC_DO_IP_GROUP_IDENTIFICATION_INTERFACE = (
        "DIAGNOSTIC-DO-IP-GROUP-IDENTIFICATION-INTERFACE"
    )
    DIAGNOSTIC_DO_IP_POWER_MODE_INTERFACE = "DIAGNOSTIC-DO-IP-POWER-MODE-INTERFACE"
    DIAGNOSTIC_DO_IP_TRIGGER_VEHICLE_ANNOUNCEMENT_INTERFACE = (
        "DIAGNOSTIC-DO-IP-TRIGGER-VEHICLE-ANNOUNCEMENT-INTERFACE"
    )
    DIAGNOSTIC_DOWNLOAD_INTERFACE = "DIAGNOSTIC-DOWNLOAD-INTERFACE"
    DIAGNOSTIC_DTC_INFORMATION_INTERFACE = "DIAGNOSTIC-DTC-INFORMATION-INTERFACE"
    DIAGNOSTIC_DYNAMIC_DATA_IDENTIFIER = "DIAGNOSTIC-DYNAMIC-DATA-IDENTIFIER"
    DIAGNOSTIC_DYNAMICALLY_DEFINE_DATA_IDENTIFIER = "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER"
    DIAGNOSTIC_DYNAMICALLY_DEFINE_DATA_IDENTIFIER_CLASS = (
        "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER-CLASS"
    )
    DIAGNOSTIC_ECU_INSTANCE_PROPS = "DIAGNOSTIC-ECU-INSTANCE-PROPS"
    DIAGNOSTIC_ECU_RESET = "DIAGNOSTIC-ECU-RESET"
    DIAGNOSTIC_ECU_RESET_CLASS = "DIAGNOSTIC-ECU-RESET-CLASS"
    DIAGNOSTIC_ECU_RESET_INTERFACE = "DIAGNOSTIC-ECU-RESET-INTERFACE"
    DIAGNOSTIC_ENABLE_CONDITION = "DIAGNOSTIC-ENABLE-CONDITION"
    DIAGNOSTIC_ENABLE_CONDITION_GROUP = "DIAGNOSTIC-ENABLE-CONDITION-GROUP"
    DIAGNOSTIC_ENABLE_CONDITION_PORT_MAPPING = "DIAGNOSTIC-ENABLE-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_ENVIRONMENTAL_CONDITION = "DIAGNOSTIC-ENVIRONMENTAL-CONDITION"
    DIAGNOSTIC_EVENT = "DIAGNOSTIC-EVENT"
    DIAGNOSTIC_EVENT_INTERFACE = "DIAGNOSTIC-EVENT-INTERFACE"
    DIAGNOSTIC_EVENT_PORT_MAPPING = "DIAGNOSTIC-EVENT-PORT-MAPPING"
    DIAGNOSTIC_EVENT_TO_DEBOUNCE_ALGORITHM_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-DEBOUNCE-ALGORITHM-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_ENABLE_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-ENABLE-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_OPERATION_CYCLE_MAPPING = "DIAGNOSTIC-EVENT-TO-OPERATION-CYCLE-MAPPING"
    DIAGNOSTIC_EVENT_TO_SECURITY_EVENT_MAPPING = "DIAGNOSTIC-EVENT-TO-SECURITY-EVENT-MAPPING"
    DIAGNOSTIC_EVENT_TO_STORAGE_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-STORAGE-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_TROUBLE_CODE_J_1939_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-TROUBLE-CODE-J-1939-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_TROUBLE_CODE_UDS_MAPPING = "DIAGNOSTIC-EVENT-TO-TROUBLE-CODE-UDS-MAPPING"
    DIAGNOSTIC_EXTENDED_DATA_RECORD = "DIAGNOSTIC-EXTENDED-DATA-RECORD"
    DIAGNOSTIC_EXTERNAL_AUTHENTICATION_INTERFACE = "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-INTERFACE"
    DIAGNOSTIC_EXTERNAL_AUTHENTICATION_PORT_MAPPING = (
        "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-PORT-MAPPING"
    )
    DIAGNOSTIC_FIM_ALIAS_EVENT = "DIAGNOSTIC-FIM-ALIAS-EVENT"
    DIAGNOSTIC_FIM_ALIAS_EVENT_GROUP = "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP"
    DIAGNOSTIC_FIM_ALIAS_EVENT_GROUP_MAPPING = "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP-MAPPING"
    DIAGNOSTIC_FIM_ALIAS_EVENT_MAPPING = "DIAGNOSTIC-FIM-ALIAS-EVENT-MAPPING"
    DIAGNOSTIC_FIM_EVENT_GROUP = "DIAGNOSTIC-FIM-EVENT-GROUP"
    DIAGNOSTIC_FIM_FUNCTION_MAPPING = "DIAGNOSTIC-FIM-FUNCTION-MAPPING"
    DIAGNOSTIC_FREEZE_FRAME = "DIAGNOSTIC-FREEZE-FRAME"
    DIAGNOSTIC_FUNCTION_IDENTIFIER = "DIAGNOSTIC-FUNCTION-IDENTIFIER"
    DIAGNOSTIC_FUNCTION_IDENTIFIER_INHIBIT = "DIAGNOSTIC-FUNCTION-IDENTIFIER-INHIBIT"
    DIAGNOSTIC_GENERIC_UDS_INTERFACE = "DIAGNOSTIC-GENERIC-UDS-INTERFACE"
    DIAGNOSTIC_INDICATOR = "DIAGNOSTIC-INDICATOR"
    DIAGNOSTIC_INDICATOR_INTERFACE = "DIAGNOSTIC-INDICATOR-INTERFACE"
    DIAGNOSTIC_INDICATOR_PORT_MAPPING = "DIAGNOSTIC-INDICATOR-PORT-MAPPING"
    DIAGNOSTIC_INFO_TYPE = "DIAGNOSTIC-INFO-TYPE"
    DIAGNOSTIC_INHIBIT_SOURCE_EVENT_MAPPING = "DIAGNOSTIC-INHIBIT-SOURCE-EVENT-MAPPING"
    DIAGNOSTIC_IO_CONTROL = "DIAGNOSTIC-IO-CONTROL"
    DIAGNOSTIC_IO_CONTROL_CLASS = "DIAGNOSTIC-IO-CONTROL-CLASS"
    DIAGNOSTIC_IUMPR = "DIAGNOSTIC-IUMPR"
    DIAGNOSTIC_IUMPR_DENOMINATOR_GROUP = "DIAGNOSTIC-IUMPR-DENOMINATOR-GROUP"
    DIAGNOSTIC_IUMPR_GROUP = "DIAGNOSTIC-IUMPR-GROUP"
    DIAGNOSTIC_IUMPR_TO_FUNCTION_IDENTIFIER_MAPPING = (
        "DIAGNOSTIC-IUMPR-TO-FUNCTION-IDENTIFIER-MAPPING"
    )
    DIAGNOSTIC_J_1939_EXPANDED_FREEZE_FRAME = "DIAGNOSTIC-J-1939-EXPANDED-FREEZE-FRAME"
    DIAGNOSTIC_J_1939_FREEZE_FRAME = "DIAGNOSTIC-J-1939-FREEZE-FRAME"
    DIAGNOSTIC_J_1939_NODE = "DIAGNOSTIC-J-1939-NODE"
    DIAGNOSTIC_J_1939_SPN = "DIAGNOSTIC-J-1939-SPN"
    DIAGNOSTIC_J_1939_SPN_MAPPING = "DIAGNOSTIC-J-1939-SPN-MAPPING"
    DIAGNOSTIC_J_1939_SW_MAPPING = "DIAGNOSTIC-J-1939-SW-MAPPING"
    DIAGNOSTIC_MAPPING = "DIAGNOSTIC-MAPPING"
    DIAGNOSTIC_MASTER_TO_SLAVE_EVENT_MAPPING = "DIAGNOSTIC-MASTER-TO-SLAVE-EVENT-MAPPING"
    DIAGNOSTIC_MASTER_TO_SLAVE_EVENT_MAPPING_SET = "DIAGNOSTIC-MASTER-TO-SLAVE-EVENT-MAPPING-SET"
    DIAGNOSTIC_MEASUREMENT_IDENTIFIER = "DIAGNOSTIC-MEASUREMENT-IDENTIFIER"
    DIAGNOSTIC_MEMORY_ADDRESSABLE_RANGE_ACCESS = "DIAGNOSTIC-MEMORY-ADDRESSABLE-RANGE-ACCESS"
    DIAGNOSTIC_MEMORY_BY_ADDRESS = "DIAGNOSTIC-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_MEMORY_DESTINATION = "DIAGNOSTIC-MEMORY-DESTINATION"
    DIAGNOSTIC_MEMORY_DESTINATION_MIRROR = "DIAGNOSTIC-MEMORY-DESTINATION-MIRROR"
    DIAGNOSTIC_MEMORY_DESTINATION_PORT_MAPPING = "DIAGNOSTIC-MEMORY-DESTINATION-PORT-MAPPING"
    DIAGNOSTIC_MEMORY_DESTINATION_PRIMARY = "DIAGNOSTIC-MEMORY-DESTINATION-PRIMARY"
    DIAGNOSTIC_MEMORY_DESTINATION_USER_DEFINED = "DIAGNOSTIC-MEMORY-DESTINATION-USER-DEFINED"
    DIAGNOSTIC_MEMORY_IDENTIFIER = "DIAGNOSTIC-MEMORY-IDENTIFIER"
    DIAGNOSTIC_MONITOR_INTERFACE = "DIAGNOSTIC-MONITOR-INTERFACE"
    DIAGNOSTIC_MONITOR_PORT_MAPPING = "DIAGNOSTIC-MONITOR-PORT-MAPPING"
    DIAGNOSTIC_OPERATION_CYCLE = "DIAGNOSTIC-OPERATION-CYCLE"
    DIAGNOSTIC_OPERATION_CYCLE_INTERFACE = "DIAGNOSTIC-OPERATION-CYCLE-INTERFACE"
    DIAGNOSTIC_OPERATION_CYCLE_PORT_MAPPING = "DIAGNOSTIC-OPERATION-CYCLE-PORT-MAPPING"
    DIAGNOSTIC_PARAMETER_IDENTIFIER = "DIAGNOSTIC-PARAMETER-IDENTIFIER"
    DIAGNOSTIC_PORT_INTERFACE = "DIAGNOSTIC-PORT-INTERFACE"
    DIAGNOSTIC_POWERTRAIN_FREEZE_FRAME = "DIAGNOSTIC-POWERTRAIN-FREEZE-FRAME"
    DIAGNOSTIC_PROOF_OF_OWNERSHIP = "DIAGNOSTIC-PROOF-OF-OWNERSHIP"
    DIAGNOSTIC_PROTOCOL = "DIAGNOSTIC-PROTOCOL"
    DIAGNOSTIC_PROVIDED_DATA_MAPPING = "DIAGNOSTIC-PROVIDED-DATA-MAPPING"
    DIAGNOSTIC_READ_DATA_BY_IDENTIFIER = "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_READ_DATA_BY_IDENTIFIER_CLASS = "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER-CLASS"
    DIAGNOSTIC_READ_DATA_BY_PERIODIC_ID = "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID"
    DIAGNOSTIC_READ_DATA_BY_PERIODIC_ID_CLASS = "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID-CLASS"
    DIAGNOSTIC_READ_DTC_INFORMATION = "DIAGNOSTIC-READ-DTC-INFORMATION"
    DIAGNOSTIC_READ_DTC_INFORMATION_CLASS = "DIAGNOSTIC-READ-DTC-INFORMATION-CLASS"
    DIAGNOSTIC_READ_MEMORY_BY_ADDRESS = "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_READ_MEMORY_BY_ADDRESS_CLASS = "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS-CLASS"
    DIAGNOSTIC_READ_SCALING_DATA_BY_IDENTIFIER = "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_READ_SCALING_DATA_BY_IDENTIFIER_CLASS = (
        "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER-CLASS"
    )
    DIAGNOSTIC_REQUEST_CONTROL_OF_ON_BOARD_DEVICE = "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE"
    DIAGNOSTIC_REQUEST_CONTROL_OF_ON_BOARD_DEVICE_CLASS = (
        "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE-CLASS"
    )
    DIAGNOSTIC_REQUEST_CURRENT_POWERTRAIN_DATA = "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA"
    DIAGNOSTIC_REQUEST_CURRENT_POWERTRAIN_DATA_CLASS = (
        "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA-CLASS"
    )
    DIAGNOSTIC_REQUEST_DOWNLOAD = "DIAGNOSTIC-REQUEST-DOWNLOAD"
    DIAGNOSTIC_REQUEST_DOWNLOAD_CLASS = "DIAGNOSTIC-REQUEST-DOWNLOAD-CLASS"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_CLASS = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-CLASS"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_PERMANENT_STATUS = (
        "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS"
    )
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_PERMANENT_STATUS_CLASS = (
        "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS-CLASS"
    )
    DIAGNOSTIC_REQUEST_FILE_TRANSFER = "DIAGNOSTIC-REQUEST-FILE-TRANSFER"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_CLASS = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-CLASS"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_INTERFACE = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-INTERFACE"
    DIAGNOSTIC_REQUEST_ON_BOARD_MONITORING_TEST_RESULTS = (
        "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS"
    )
    DIAGNOSTIC_REQUEST_ON_BOARD_MONITORING_TEST_RESULTS_CLASS = (
        "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS-CLASS"
    )
    DIAGNOSTIC_REQUEST_POWERTRAIN_FREEZE_FRAME_DATA = (
        "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA"
    )
    DIAGNOSTIC_REQUEST_POWERTRAIN_FREEZE_FRAME_DATA_CLASS = (
        "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA-CLASS"
    )
    DIAGNOSTIC_REQUEST_UPLOAD = "DIAGNOSTIC-REQUEST-UPLOAD"
    DIAGNOSTIC_REQUEST_UPLOAD_CLASS = "DIAGNOSTIC-REQUEST-UPLOAD-CLASS"
    DIAGNOSTIC_REQUEST_VEHICLE_INFO = "DIAGNOSTIC-REQUEST-VEHICLE-INFO"
    DIAGNOSTIC_REQUEST_VEHICLE_INFO_CLASS = "DIAGNOSTIC-REQUEST-VEHICLE-INFO-CLASS"
    DIAGNOSTIC_RESPONSE_ON_EVENT = "DIAGNOSTIC-RESPONSE-ON-EVENT"
    DIAGNOSTIC_RESPONSE_ON_EVENT_CLASS = "DIAGNOSTIC-RESPONSE-ON-EVENT-CLASS"
    DIAGNOSTIC_ROUTINE = "DIAGNOSTIC-ROUTINE"
    DIAGNOSTIC_ROUTINE_CONTROL = "DIAGNOSTIC-ROUTINE-CONTROL"
    DIAGNOSTIC_ROUTINE_CONTROL_CLASS = "DIAGNOSTIC-ROUTINE-CONTROL-CLASS"
    DIAGNOSTIC_ROUTINE_GENERIC_INTERFACE = "DIAGNOSTIC-ROUTINE-GENERIC-INTERFACE"
    DIAGNOSTIC_ROUTINE_INTERFACE = "DIAGNOSTIC-ROUTINE-INTERFACE"
    DIAGNOSTIC_SECURITY_ACCESS = "DIAGNOSTIC-SECURITY-ACCESS"
    DIAGNOSTIC_SECURITY_ACCESS_CLASS = "DIAGNOSTIC-SECURITY-ACCESS-CLASS"
    DIAGNOSTIC_SECURITY_EVENT_REPORTING_MODE_MAPPING = (
        "DIAGNOSTIC-SECURITY-EVENT-REPORTING-MODE-MAPPING"
    )
    DIAGNOSTIC_SECURITY_LEVEL = "DIAGNOSTIC-SECURITY-LEVEL"
    DIAGNOSTIC_SECURITY_LEVEL_INTERFACE = "DIAGNOSTIC-SECURITY-LEVEL-INTERFACE"
    DIAGNOSTIC_SECURITY_LEVEL_PORT_MAPPING = "DIAGNOSTIC-SECURITY-LEVEL-PORT-MAPPING"
    DIAGNOSTIC_SERVICE_CLASS = "DIAGNOSTIC-SERVICE-CLASS"
    DIAGNOSTIC_SERVICE_DATA_MAPPING = "DIAGNOSTIC-SERVICE-DATA-MAPPING"
    DIAGNOSTIC_SERVICE_GENERIC_MAPPING = "DIAGNOSTIC-SERVICE-GENERIC-MAPPING"
    DIAGNOSTIC_SERVICE_INSTANCE = "DIAGNOSTIC-SERVICE-INSTANCE"
    DIAGNOSTIC_SERVICE_SW_MAPPING = "DIAGNOSTIC-SERVICE-SW-MAPPING"
    DIAGNOSTIC_SERVICE_TABLE = "DIAGNOSTIC-SERVICE-TABLE"
    DIAGNOSTIC_SERVICE_VALIDATION_INTERFACE = "DIAGNOSTIC-SERVICE-VALIDATION-INTERFACE"
    DIAGNOSTIC_SERVICE_VALIDATION_MAPPING = "DIAGNOSTIC-SERVICE-VALIDATION-MAPPING"
    DIAGNOSTIC_SESSION = "DIAGNOSTIC-SESSION"
    DIAGNOSTIC_SESSION_CONTROL = "DIAGNOSTIC-SESSION-CONTROL"
    DIAGNOSTIC_SESSION_CONTROL_CLASS = "DIAGNOSTIC-SESSION-CONTROL-CLASS"
    DIAGNOSTIC_SOVD_AUTHORIZATION_INTERFACE = "DIAGNOSTIC-SOVD-AUTHORIZATION-INTERFACE"
    DIAGNOSTIC_SOVD_AUTHORIZATION_PORT_MAPPING = "DIAGNOSTIC-SOVD-AUTHORIZATION-PORT-MAPPING"
    DIAGNOSTIC_SOVD_LOCK = "DIAGNOSTIC-SOVD-LOCK"
    DIAGNOSTIC_SOVD_PORT_INTERFACE = "DIAGNOSTIC-SOVD-PORT-INTERFACE"
    DIAGNOSTIC_SOVD_PROXIMITY_CHALLENGE_INTERFACE = "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-INTERFACE"
    DIAGNOSTIC_SOVD_PROXIMITY_CHALLENGE_PORT_MAPPING = (
        "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-PORT-MAPPING"
    )
    DIAGNOSTIC_STORAGE_CONDITION = "DIAGNOSTIC-STORAGE-CONDITION"
    DIAGNOSTIC_STORAGE_CONDITION_GROUP = "DIAGNOSTIC-STORAGE-CONDITION-GROUP"
    DIAGNOSTIC_STORAGE_CONDITION_PORT_MAPPING = "DIAGNOSTIC-STORAGE-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_SW_MAPPING = "DIAGNOSTIC-SW-MAPPING"
    DIAGNOSTIC_TEST_RESULT = "DIAGNOSTIC-TEST-RESULT"
    DIAGNOSTIC_TEST_ROUTINE_IDENTIFIER = "DIAGNOSTIC-TEST-ROUTINE-IDENTIFIER"
    DIAGNOSTIC_TRANSFER_EXIT = "DIAGNOSTIC-TRANSFER-EXIT"
    DIAGNOSTIC_TRANSFER_EXIT_CLASS = "DIAGNOSTIC-TRANSFER-EXIT-CLASS"
    DIAGNOSTIC_TROUBLE_CODE = "DIAGNOSTIC-TROUBLE-CODE"
    DIAGNOSTIC_TROUBLE_CODE_GROUP = "DIAGNOSTIC-TROUBLE-CODE-GROUP"
    DIAGNOSTIC_TROUBLE_CODE_J_1939 = "DIAGNOSTIC-TROUBLE-CODE-J-1939"
    DIAGNOSTIC_TROUBLE_CODE_OBD = "DIAGNOSTIC-TROUBLE-CODE-OBD"
    DIAGNOSTIC_TROUBLE_CODE_PROPS = "DIAGNOSTIC-TROUBLE-CODE-PROPS"
    DIAGNOSTIC_TROUBLE_CODE_UDS = "DIAGNOSTIC-TROUBLE-CODE-UDS"
    DIAGNOSTIC_TROUBLE_CODE_UDS_TO_CLEAR_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-TROUBLE-CODE-UDS-TO-CLEAR-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_TROUBLE_CODE_UDS_TO_TROUBLE_CODE_OBD_MAPPING = (
        "DIAGNOSTIC-TROUBLE-CODE-UDS-TO-TROUBLE-CODE-OBD-MAPPING"
    )
    DIAGNOSTIC_UPLOAD_INTERFACE = "DIAGNOSTIC-UPLOAD-INTERFACE"
    DIAGNOSTIC_VERIFY_CERTIFICATE_BIDIRECTIONAL = "DIAGNOSTIC-VERIFY-CERTIFICATE-BIDIRECTIONAL"
    DIAGNOSTIC_VERIFY_CERTIFICATE_UNIDIRECTIONAL = "DIAGNOSTIC-VERIFY-CERTIFICATE-UNIDIRECTIONAL"
    DIAGNOSTIC_WRITE_DATA_BY_IDENTIFIER = "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_WRITE_DATA_BY_IDENTIFIER_CLASS = "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER-CLASS"
    DIAGNOSTIC_WRITE_MEMORY_BY_ADDRESS = "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_WRITE_MEMORY_BY_ADDRESS_CLASS = "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS-CLASS"
    DLT_APPLICATION_TO_PROCESS_MAPPING = "DLT-APPLICATION-TO-PROCESS-MAPPING"
    DLT_CONTEXT = "DLT-CONTEXT"
    DLT_ECU = "DLT-ECU"
    DLT_LOG_SINK = "DLT-LOG-SINK"
    DLT_LOG_SINK_TO_PORT_PROTOTYPE_MAPPING = "DLT-LOG-SINK-TO-PORT-PROTOTYPE-MAPPING"
    DLT_MESSAGE_COLLECTION_SET = "DLT-MESSAGE-COLLECTION-SET"
    DO_IP_TP_CONFIG = "DO-IP-TP-CONFIG"
    DOCUMENTATION = "DOCUMENTATION"
    E_2_E_PROFILE_COMPATIBILITY_PROPS = "E-2-E-PROFILE-COMPATIBILITY-PROPS"
    E_2_E_PROFILE_CONFIGURATION_SET = "E-2-E-PROFILE-CONFIGURATION-SET"
    ECU_ABSTRACTION_SW_COMPONENT_TYPE = "ECU-ABSTRACTION-SW-COMPONENT-TYPE"
    ECU_INSTANCE = "ECU-INSTANCE"
    ECU_TIMING = "ECU-TIMING"
    ECUC_DEFINITION_COLLECTION = "ECUC-DEFINITION-COLLECTION"
    ECUC_DESTINATION_URI_DEF_SET = "ECUC-DESTINATION-URI-DEF-SET"
    ECUC_MODULE_CONFIGURATION_VALUES = "ECUC-MODULE-CONFIGURATION-VALUES"
    ECUC_MODULE_DEF = "ECUC-MODULE-DEF"
    ECUC_VALUE_COLLECTION = "ECUC-VALUE-COLLECTION"
    END_TO_END_PROTECTION_SET = "END-TO-END-PROTECTION-SET"
    ENUMERATION_MAPPING_TABLE = "ENUMERATION-MAPPING-TABLE"
    ETH_IP_PROPS = "ETH-IP-PROPS"
    ETH_TCP_IP_ICMP_PROPS = "ETH-TCP-IP-ICMP-PROPS"
    ETH_TCP_IP_PROPS = "ETH-TCP-IP-PROPS"
    ETH_TP_CONFIG = "ETH-TP-CONFIG"
    ETHERNET_CLUSTER = "ETHERNET-CLUSTER"
    ETHERNET_FRAME = "ETHERNET-FRAME"
    ETHERNET_RAW_DATA_STREAM_CLIENT_MAPPING = "ETHERNET-RAW-DATA-STREAM-CLIENT-MAPPING"
    ETHERNET_RAW_DATA_STREAM_GRANT = "ETHERNET-RAW-DATA-STREAM-GRANT"
    ETHERNET_RAW_DATA_STREAM_MAPPING = "ETHERNET-RAW-DATA-STREAM-MAPPING"
    ETHERNET_RAW_DATA_STREAM_SERVER_MAPPING = "ETHERNET-RAW-DATA-STREAM-SERVER-MAPPING"
    ETHERNET_WAKEUP_SLEEP_ON_DATALINE_CONFIG_SET = "ETHERNET-WAKEUP-SLEEP-ON-DATALINE-CONFIG-SET"
    EVALUATED_VARIANT_SET = "EVALUATED-VARIANT-SET"
    EXECUTABLE = "EXECUTABLE"
    EXECUTABLE_TIMING = "EXECUTABLE-TIMING"
    FIBEX_ELEMENT = "FIBEX-ELEMENT"
    FIREWALL_RULE = "FIREWALL-RULE"
    FIREWALL_STATE_SWITCH_INTERFACE = "FIREWALL-STATE-SWITCH-INTERFACE"
    FLAT_MAP = "FLAT-MAP"
    FLEXRAY_AR_TP_CONFIG = "FLEXRAY-AR-TP-CONFIG"
    FLEXRAY_CLUSTER = "FLEXRAY-CLUSTER"
    FLEXRAY_FRAME = "FLEXRAY-FRAME"
    FLEXRAY_TP_CONFIG = "FLEXRAY-TP-CONFIG"
    FM_FEATURE = "FM-FEATURE"
    FM_FEATURE_MAP = "FM-FEATURE-MAP"
    FM_FEATURE_MODEL = "FM-FEATURE-MODEL"
    FM_FEATURE_SELECTION_SET = "FM-FEATURE-SELECTION-SET"
    FRAME = "FRAME"
    FUNCTION_GROUP_SET = "FUNCTION-GROUP-SET"
    FUNCTIONAL_CLUSTER_INTERACTS_WITH_FUNCTIONAL_CLUSTER_MAPPING = (
        "FUNCTIONAL-CLUSTER-INTERACTS-WITH-FUNCTIONAL-CLUSTER-MAPPING"
    )
    FUNCTIONAL_CLUSTER_INTERACTS_WITH_PERSISTENCY_DEPLOYMENT_MAPPING = (
        "FUNCTIONAL-CLUSTER-INTERACTS-WITH-PERSISTENCY-DEPLOYMENT-MAPPING"
    )
    GATEWAY = "GATEWAY"
    GENERAL_PURPOSE_CONNECTION = "GENERAL-PURPOSE-CONNECTION"
    GENERAL_PURPOSE_I_PDU = "GENERAL-PURPOSE-I-PDU"
    GENERAL_PURPOSE_PDU = "GENERAL-PURPOSE-PDU"
    GENERIC_ETHERNET_FRAME = "GENERIC-ETHERNET-FRAME"
    GLOBAL_TIME_DOMAIN = "GLOBAL-TIME-DOMAIN"
    GRANT = "GRANT"
    GRANT_DESIGN = "GRANT-DESIGN"
    HW_CATEGORY = "HW-CATEGORY"
    HW_ELEMENT = "HW-ELEMENT"
    HW_TYPE = "HW-TYPE"
    I_PDU = "I-PDU"
    I_PV_6_EXT_HEADER_FILTER_SET = "I-PV-6-EXT-HEADER-FILTER-SET"
    I_SIGNAL = "I-SIGNAL"
    I_SIGNAL_GROUP = "I-SIGNAL-GROUP"
    I_SIGNAL_I_PDU = "I-SIGNAL-I-PDU"
    I_SIGNAL_I_PDU_GROUP = "I-SIGNAL-I-PDU-GROUP"
    IDS_COMMON_ELEMENT = "IDS-COMMON-ELEMENT"
    IDS_DESIGN = "IDS-DESIGN"
    IDS_MAPPING = "IDS-MAPPING"
    IDSM_INSTANCE = "IDSM-INSTANCE"
    IDSM_PROPERTIES = "IDSM-PROPERTIES"
    IEEE_1722_TP_ETHERNET_FRAME = "IEEE-1722-TP-ETHERNET-FRAME"
    IMPLEMENTATION = "IMPLEMENTATION"
    IMPLEMENTATION_DATA_TYPE = "IMPLEMENTATION-DATA-TYPE"
    INTERFACE_MAPPING = "INTERFACE-MAPPING"
    INTERPOLATION_ROUTINE_MAPPING_SET = "INTERPOLATION-ROUTINE-MAPPING-SET"
    IP_IAM_REMOTE_SUBJECT = "IP-IAM-REMOTE-SUBJECT"
    IP_SEC_CONFIG_PROPS = "IP-SEC-CONFIG-PROPS"
    IP_SEC_IAM_REMOTE_SUBJECT = "IP-SEC-IAM-REMOTE-SUBJECT"
    J_1939_CLUSTER = "J-1939-CLUSTER"
    J_1939_CONTROLLER_APPLICATION = "J-1939-CONTROLLER-APPLICATION"
    J_1939_DCM_I_PDU = "J-1939-DCM-I-PDU"
    J_1939_TP_CONFIG = "J-1939-TP-CONFIG"
    KEYWORD_SET = "KEYWORD-SET"
    LIFE_CYCLE_INFO_SET = "LIFE-CYCLE-INFO-SET"
    LIFE_CYCLE_STATE_DEFINITION_GROUP = "LIFE-CYCLE-STATE-DEFINITION-GROUP"
    LIN_CLUSTER = "LIN-CLUSTER"
    LIN_EVENT_TRIGGERED_FRAME = "LIN-EVENT-TRIGGERED-FRAME"
    LIN_FRAME = "LIN-FRAME"
    LIN_SPORADIC_FRAME = "LIN-SPORADIC-FRAME"
    LIN_TP_CONFIG = "LIN-TP-CONFIG"
    LIN_UNCONDITIONAL_FRAME = "LIN-UNCONDITIONAL-FRAME"
    LOG_AND_TRACE_INTERFACE = "LOG-AND-TRACE-INTERFACE"
    LOG_AND_TRACE_MESSAGE_COLLECTION_SET = "LOG-AND-TRACE-MESSAGE-COLLECTION-SET"
    LT_MESSAGE_COLLECTION_TO_PORT_PROTOTYPE_MAPPING = (
        "LT-MESSAGE-COLLECTION-TO-PORT-PROTOTYPE-MAPPING"
    )
    MAC_SEC_GLOBAL_KAY_PROPS = "MAC-SEC-GLOBAL-KAY-PROPS"
    MAC_SEC_PARTICIPANT_SET = "MAC-SEC-PARTICIPANT-SET"
    MACHINE = "MACHINE"
    MACHINE_DESIGN = "MACHINE-DESIGN"
    MACHINE_TIMING = "MACHINE-TIMING"
    MC_FUNCTION = "MC-FUNCTION"
    MC_GROUP = "MC-GROUP"
    MODE_DECLARATION_GROUP = "MODE-DECLARATION-GROUP"
    MODE_DECLARATION_MAPPING_SET = "MODE-DECLARATION-MAPPING-SET"
    MODE_SWITCH_INTERFACE = "MODE-SWITCH-INTERFACE"
    MULTIPLEXED_I_PDU = "MULTIPLEXED-I-PDU"
    N_PDU = "N-PDU"
    NM_CONFIG = "NM-CONFIG"
    NM_HANDLE_TO_FUNCTION_GROUP_STATE_MAPPING = "NM-HANDLE-TO-FUNCTION-GROUP-STATE-MAPPING"
    NM_PDU = "NM-PDU"
    NV_BLOCK_SW_COMPONENT_TYPE = "NV-BLOCK-SW-COMPONENT-TYPE"
    NV_DATA_INTERFACE = "NV-DATA-INTERFACE"
    OS_TASK_PROXY = "OS-TASK-PROXY"
    PACKAGEABLE_ELEMENT = "PACKAGEABLE-ELEMENT"
    PARAMETER_INTERFACE = "PARAMETER-INTERFACE"
    PARAMETER_SW_COMPONENT_TYPE = "PARAMETER-SW-COMPONENT-TYPE"
    PDU = "PDU"
    PDUR_I_PDU_GROUP = "PDUR-I-PDU-GROUP"
    PERSISTENCY_DEPLOYMENT = "PERSISTENCY-DEPLOYMENT"
    PERSISTENCY_DEPLOYMENT_ELEMENT_TO_CRYPTO_KEY_SLOT_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-ELEMENT-TO-CRYPTO-KEY-SLOT-MAPPING"
    )
    PERSISTENCY_DEPLOYMENT_TO_CRYPTO_KEY_SLOT_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-TO-CRYPTO-KEY-SLOT-MAPPING"
    )
    PERSISTENCY_DEPLOYMENT_TO_DLT_LOG_SINK_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-TO-DLT-LOG-SINK-MAPPING"
    )
    PERSISTENCY_FILE_STORAGE = "PERSISTENCY-FILE-STORAGE"
    PERSISTENCY_FILE_STORAGE_INTERFACE = "PERSISTENCY-FILE-STORAGE-INTERFACE"
    PERSISTENCY_INTERFACE = "PERSISTENCY-INTERFACE"
    PERSISTENCY_KEY_VALUE_STORAGE = "PERSISTENCY-KEY-VALUE-STORAGE"
    PERSISTENCY_KEY_VALUE_STORAGE_INTERFACE = "PERSISTENCY-KEY-VALUE-STORAGE-INTERFACE"
    PERSISTENCY_PORT_PROTOTYPE_TO_DEPLOYMENT_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-DEPLOYMENT-MAPPING"
    )
    PERSISTENCY_PORT_PROTOTYPE_TO_FILE_STORAGE_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-FILE-STORAGE-MAPPING"
    )
    PERSISTENCY_PORT_PROTOTYPE_TO_KEY_VALUE_STORAGE_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-KEY-VALUE-STORAGE-MAPPING"
    )
    PHM_ABSTRACT_RECOVERY_NOTIFICATION_INTERFACE = "PHM-ABSTRACT-RECOVERY-NOTIFICATION-INTERFACE"
    PHM_CONTRIBUTION_TO_MACHINE_MAPPING = "PHM-CONTRIBUTION-TO-MACHINE-MAPPING"
    PHM_HEALTH_CHANNEL_INTERFACE = "PHM-HEALTH-CHANNEL-INTERFACE"
    PHM_HEALTH_CHANNEL_RECOVERY_NOTIFICATION_INTERFACE = (
        "PHM-HEALTH-CHANNEL-RECOVERY-NOTIFICATION-INTERFACE"
    )
    PHM_RECOVERY_ACTION_INTERFACE = "PHM-RECOVERY-ACTION-INTERFACE"
    PHM_SUPERVISED_ENTITY_INTERFACE = "PHM-SUPERVISED-ENTITY-INTERFACE"
    PHM_SUPERVISION_RECOVERY_NOTIFICATION_INTERFACE = (
        "PHM-SUPERVISION-RECOVERY-NOTIFICATION-INTERFACE"
    )
    PHYSICAL_DIMENSION = "PHYSICAL-DIMENSION"
    PHYSICAL_DIMENSION_MAPPING_SET = "PHYSICAL-DIMENSION-MAPPING-SET"
    PLATFORM_HEALTH_MANAGEMENT_CONTRIBUTION = "PLATFORM-HEALTH-MANAGEMENT-CONTRIBUTION"
    PLATFORM_HEALTH_MANAGEMENT_INTERFACE = "PLATFORM-HEALTH-MANAGEMENT-INTERFACE"
    PLATFORM_MODULE_ENDPOINT_CONFIGURATION = "PLATFORM-MODULE-ENDPOINT-CONFIGURATION"
    PLATFORM_MODULE_ETHERNET_ENDPOINT_CONFIGURATION = (
        "PLATFORM-MODULE-ETHERNET-ENDPOINT-CONFIGURATION"
    )
    PORT_INTERFACE = "PORT-INTERFACE"
    PORT_INTERFACE_MAPPING_SET = "PORT-INTERFACE-MAPPING-SET"
    PORT_INTERFACE_TO_DATA_TYPE_MAPPING = "PORT-INTERFACE-TO-DATA-TYPE-MAPPING"
    PORT_PROTOTYPE_BLUEPRINT = "PORT-PROTOTYPE-BLUEPRINT"
    POST_BUILD_VARIANT_CRITERION = "POST-BUILD-VARIANT-CRITERION"
    POST_BUILD_VARIANT_CRITERION_VALUE_SET = "POST-BUILD-VARIANT-CRITERION-VALUE-SET"
    PREDEFINED_VARIANT = "PREDEFINED-VARIANT"
    PROCESS = "PROCESS"
    PROCESS_DESIGN = "PROCESS-DESIGN"
    PROCESS_DESIGN_TO_MACHINE_DESIGN_MAPPING = "PROCESS-DESIGN-TO-MACHINE-DESIGN-MAPPING"
    PROCESS_EXECUTION_ERROR = "PROCESS-EXECUTION-ERROR"
    PROCESS_TO_MACHINE_MAPPING_SET = "PROCESS-TO-MACHINE-MAPPING-SET"
    PROVIDED_AP_SERVICE_INSTANCE = "PROVIDED-AP-SERVICE-INSTANCE"
    PROVIDED_SERVICE_INSTANCE_TO_SW_CLUSTER_DESIGN_P_PORT_PROTOTYPE_MAPPING = (
        "PROVIDED-SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-P-PORT-PROTOTYPE-MAPPING"
    )
    PROVIDED_SOMEIP_SERVICE_INSTANCE = "PROVIDED-SOMEIP-SERVICE-INSTANCE"
    PROVIDED_USER_DEFINED_SERVICE_INSTANCE = "PROVIDED-USER-DEFINED-SERVICE-INSTANCE"
    RAPID_PROTOTYPING_SCENARIO = "RAPID-PROTOTYPING-SCENARIO"
    RAW_DATA_STREAM_CLIENT_INTERFACE = "RAW-DATA-STREAM-CLIENT-INTERFACE"
    RAW_DATA_STREAM_DEPLOYMENT = "RAW-DATA-STREAM-DEPLOYMENT"
    RAW_DATA_STREAM_GRANT = "RAW-DATA-STREAM-GRANT"
    RAW_DATA_STREAM_GRANT_DESIGN = "RAW-DATA-STREAM-GRANT-DESIGN"
    RAW_DATA_STREAM_MAPPING = "RAW-DATA-STREAM-MAPPING"
    RAW_DATA_STREAM_SERVER_INTERFACE = "RAW-DATA-STREAM-SERVER-INTERFACE"
    RECOVERY_NOTIFICATION = "RECOVERY-NOTIFICATION"
    RECOVERY_NOTIFICATION_TO_P_PORT_PROTOTYPE_MAPPING = (
        "RECOVERY-NOTIFICATION-TO-P-PORT-PROTOTYPE-MAPPING"
    )
    REQUIRED_AP_SERVICE_INSTANCE = "REQUIRED-AP-SERVICE-INSTANCE"
    REQUIRED_SERVICE_INSTANCE_TO_SW_CLUSTER_DESIGN_R_PORT_PROTOTYPE_MAPPING = (
        "REQUIRED-SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-R-PORT-PROTOTYPE-MAPPING"
    )
    REQUIRED_SOMEIP_SERVICE_INSTANCE = "REQUIRED-SOMEIP-SERVICE-INSTANCE"
    REQUIRED_USER_DEFINED_SERVICE_INSTANCE = "REQUIRED-USER-DEFINED-SERVICE-INSTANCE"
    SDG_DEF = "SDG-DEF"
    SEC_OC_SECURE_COM_PROPS = "SEC-OC-SECURE-COM-PROPS"
    SECURE_COM_PROPS = "SECURE-COM-PROPS"
    SECURE_COMMUNICATION_PROPS_SET = "SECURE-COMMUNICATION-PROPS-SET"
    SECURED_I_PDU = "SECURED-I-PDU"
    SECURITY_EVENT_CONTEXT_MAPPING = "SECURITY-EVENT-CONTEXT-MAPPING"
    SECURITY_EVENT_CONTEXT_MAPPING_APPLICATION = "SECURITY-EVENT-CONTEXT-MAPPING-APPLICATION"
    SECURITY_EVENT_CONTEXT_MAPPING_BSW_MODULE = "SECURITY-EVENT-CONTEXT-MAPPING-BSW-MODULE"
    SECURITY_EVENT_CONTEXT_MAPPING_COMM_CONNECTOR = "SECURITY-EVENT-CONTEXT-MAPPING-COMM-CONNECTOR"
    SECURITY_EVENT_CONTEXT_MAPPING_FUNCTIONAL_CLUSTER = (
        "SECURITY-EVENT-CONTEXT-MAPPING-FUNCTIONAL-CLUSTER"
    )
    SECURITY_EVENT_DEFINITION = "SECURITY-EVENT-DEFINITION"
    SECURITY_EVENT_FILTER_CHAIN = "SECURITY-EVENT-FILTER-CHAIN"
    SECURITY_EVENT_MAPPING = "SECURITY-EVENT-MAPPING"
    SECURITY_EVENT_REPORT_INTERFACE = "SECURITY-EVENT-REPORT-INTERFACE"
    SECURITY_EVENT_REPORT_TO_SECURITY_EVENT_DEFINITION_MAPPING = (
        "SECURITY-EVENT-REPORT-TO-SECURITY-EVENT-DEFINITION-MAPPING"
    )
    SENDER_RECEIVER_INTERFACE = "SENDER-RECEIVER-INTERFACE"
    SENSOR_ACTUATOR_SW_COMPONENT_TYPE = "SENSOR-ACTUATOR-SW-COMPONENT-TYPE"
    SERIALIZATION_TECHNOLOGY = "SERIALIZATION-TECHNOLOGY"
    SERVICE_INSTANCE_COLLECTION_SET = "SERVICE-INSTANCE-COLLECTION-SET"
    SERVICE_INSTANCE_TO_MACHINE_MAPPING = "SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    SERVICE_INSTANCE_TO_PORT_PROTOTYPE_MAPPING = "SERVICE-INSTANCE-TO-PORT-PROTOTYPE-MAPPING"
    SERVICE_INSTANCE_TO_SIGNAL_MAPPING = "SERVICE-INSTANCE-TO-SIGNAL-MAPPING"
    SERVICE_INSTANCE_TO_SW_CLUSTER_DESIGN_PORT_PROTOTYPE_MAPPING = (
        "SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-PORT-PROTOTYPE-MAPPING"
    )
    SERVICE_INTERFACE = "SERVICE-INTERFACE"
    SERVICE_INTERFACE_DEPLOYMENT = "SERVICE-INTERFACE-DEPLOYMENT"
    SERVICE_INTERFACE_ELEMENT_MAPPING = "SERVICE-INTERFACE-ELEMENT-MAPPING"
    SERVICE_INTERFACE_EVENT_MAPPING = "SERVICE-INTERFACE-EVENT-MAPPING"
    SERVICE_INTERFACE_FIELD_MAPPING = "SERVICE-INTERFACE-FIELD-MAPPING"
    SERVICE_INTERFACE_METHOD_MAPPING = "SERVICE-INTERFACE-METHOD-MAPPING"
    SERVICE_INTERFACE_PEDIGREE = "SERVICE-INTERFACE-PEDIGREE"
    SERVICE_INTERFACE_TRIGGER_MAPPING = "SERVICE-INTERFACE-TRIGGER-MAPPING"
    SERVICE_PROXY_SW_COMPONENT_TYPE = "SERVICE-PROXY-SW-COMPONENT-TYPE"
    SERVICE_SW_COMPONENT_TYPE = "SERVICE-SW-COMPONENT-TYPE"
    SERVICE_TIMING = "SERVICE-TIMING"
    SIGNAL_SERVICE_TRANSLATION_PROPS_SET = "SIGNAL-SERVICE-TRANSLATION-PROPS-SET"
    SO_AD_ROUTING_GROUP = "SO-AD-ROUTING-GROUP"
    SOCKET_CONNECTION_IPDU_IDENTIFIER_SET = "SOCKET-CONNECTION-IPDU-IDENTIFIER-SET"
    SOFTWARE_CLUSTER = "SOFTWARE-CLUSTER"
    SOFTWARE_CLUSTER_DESIGN = "SOFTWARE-CLUSTER-DESIGN"
    SOFTWARE_CLUSTER_DIAGNOSTIC_DEPLOYMENT_PROPS = "SOFTWARE-CLUSTER-DIAGNOSTIC-DEPLOYMENT-PROPS"
    SOFTWARE_PACKAGE = "SOFTWARE-PACKAGE"
    SOMEIP_DATA_PROTOTYPE_TRANSFORMATION_PROPS = "SOMEIP-DATA-PROTOTYPE-TRANSFORMATION-PROPS"
    SOMEIP_REMOTE_MULTICAST_CONFIG = "SOMEIP-REMOTE-MULTICAST-CONFIG"
    SOMEIP_REMOTE_UNICAST_CONFIG = "SOMEIP-REMOTE-UNICAST-CONFIG"
    SOMEIP_SD_CLIENT_EVENT_GROUP_TIMING_CONFIG = "SOMEIP-SD-CLIENT-EVENT-GROUP-TIMING-CONFIG"
    SOMEIP_SD_CLIENT_SERVICE_INSTANCE_CONFIG = "SOMEIP-SD-CLIENT-SERVICE-INSTANCE-CONFIG"
    SOMEIP_SD_SERVER_EVENT_GROUP_TIMING_CONFIG = "SOMEIP-SD-SERVER-EVENT-GROUP-TIMING-CONFIG"
    SOMEIP_SD_SERVER_SERVICE_INSTANCE_CONFIG = "SOMEIP-SD-SERVER-SERVICE-INSTANCE-CONFIG"
    SOMEIP_SERVICE_INSTANCE_TO_MACHINE_MAPPING = "SOMEIP-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    SOMEIP_SERVICE_INTERFACE_DEPLOYMENT = "SOMEIP-SERVICE-INTERFACE-DEPLOYMENT"
    SOMEIP_TP_CONFIG = "SOMEIP-TP-CONFIG"
    STARTUP_CONFIG = "STARTUP-CONFIG"
    STATE_DEPENDENT_FIREWALL = "STATE-DEPENDENT-FIREWALL"
    STATE_MANAGEMEN_PHM_ERROR_INTERFACE = "STATE-MANAGEMEN-PHM-ERROR-INTERFACE"
    STATE_MANAGEMENT_DIAG_TRIGGER_INTERFACE = "STATE-MANAGEMENT-DIAG-TRIGGER-INTERFACE"
    STATE_MANAGEMENT_EM_ERROR_INTERFACE = "STATE-MANAGEMENT-EM-ERROR-INTERFACE"
    STATE_MANAGEMENT_ERROR_INTERFACE = "STATE-MANAGEMENT-ERROR-INTERFACE"
    STATE_MANAGEMENT_FUNCTION_GROUP_SWITCH_NOTIFICATION_INTERFACE = (
        "STATE-MANAGEMENT-FUNCTION-GROUP-SWITCH-NOTIFICATION-INTERFACE"
    )
    STATE_MANAGEMENT_NOTIFICATION_INTERFACE = "STATE-MANAGEMENT-NOTIFICATION-INTERFACE"
    STATE_MANAGEMENT_PORT_INTERFACE = "STATE-MANAGEMENT-PORT-INTERFACE"
    STATE_MANAGEMENT_REQUEST_INTERFACE = "STATE-MANAGEMENT-REQUEST-INTERFACE"
    STATE_MANAGEMENT_TRIGGER_INTERFACE = "STATE-MANAGEMENT-TRIGGER-INTERFACE"
    STD_CPP_IMPLEMENTATION_DATA_TYPE = "STD-CPP-IMPLEMENTATION-DATA-TYPE"
    SW_ADDR_METHOD = "SW-ADDR-METHOD"
    SW_AXIS_TYPE = "SW-AXIS-TYPE"
    SW_BASE_TYPE = "SW-BASE-TYPE"
    SW_COMPONENT_MAPPING_CONSTRAINTS = "SW-COMPONENT-MAPPING-CONSTRAINTS"
    SW_COMPONENT_TYPE = "SW-COMPONENT-TYPE"
    SW_RECORD_LAYOUT = "SW-RECORD-LAYOUT"
    SW_SYSTEMCONST = "SW-SYSTEMCONST"
    SW_SYSTEMCONSTANT_VALUE_SET = "SW-SYSTEMCONSTANT-VALUE-SET"
    SWC_BSW_MAPPING = "SWC-BSW-MAPPING"
    SWC_IMPLEMENTATION = "SWC-IMPLEMENTATION"
    SWC_TIMING = "SWC-TIMING"
    SYNCHRONIZED_TIME_BASE_CONSUMER_INTERFACE = "SYNCHRONIZED-TIME-BASE-CONSUMER-INTERFACE"
    SYNCHRONIZED_TIME_BASE_PROVIDER_INTERFACE = "SYNCHRONIZED-TIME-BASE-PROVIDER-INTERFACE"
    SYSTEM = "SYSTEM"
    SYSTEM_SIGNAL = "SYSTEM-SIGNAL"
    SYSTEM_SIGNAL_GROUP = "SYSTEM-SIGNAL-GROUP"
    SYSTEM_TIMING = "SYSTEM-TIMING"
    TCP_OPTION_FILTER_SET = "TCP-OPTION-FILTER-SET"
    TD_CP_SOFTWARE_CLUSTER_MAPPING_SET = "TD-CP-SOFTWARE-CLUSTER-MAPPING-SET"
    TIME_BASE_PROVIDER_TO_PERSISTENCY_MAPPING = "TIME-BASE-PROVIDER-TO-PERSISTENCY-MAPPING"
    TIME_SYNC_PORT_PROTOTYPE_TO_TIME_BASE_MAPPING = "TIME-SYNC-PORT-PROTOTYPE-TO-TIME-BASE-MAPPING"
    TIMING_EXTENSION = "TIMING-EXTENSION"
    TLS_CONNECTION_GROUP = "TLS-CONNECTION-GROUP"
    TLS_IAM_REMOTE_SUBJECT = "TLS-IAM-REMOTE-SUBJECT"
    TLS_SECURE_COM_PROPS = "TLS-SECURE-COM-PROPS"
    TLV_DATA_ID_DEFINITION_SET = "TLV-DATA-ID-DEFINITION-SET"
    TP_CONFIG = "TP-CONFIG"
    TRANSFORMATION_PROPS_SET = "TRANSFORMATION-PROPS-SET"
    TRANSFORMATION_PROPS_TO_SERVICE_INTERFACE_ELEMENT_MAPPING = (
        "TRANSFORMATION-PROPS-TO-SERVICE-INTERFACE-ELEMENT-MAPPING"
    )
    TRIGGER_INTERFACE = "TRIGGER-INTERFACE"
    TTCAN_CLUSTER = "TTCAN-CLUSTER"
    UCM_TO_TIME_BASE_RESOURCE_MAPPING = "UCM-TO-TIME-BASE-RESOURCE-MAPPING"
    UNIT = "UNIT"
    UNIT_GROUP = "UNIT-GROUP"
    UPLOADABLE_EXCLUSIVE_PACKAGE_ELEMENT = "UPLOADABLE-EXCLUSIVE-PACKAGE-ELEMENT"
    UPLOADABLE_PACKAGE_ELEMENT = "UPLOADABLE-PACKAGE-ELEMENT"
    USER_DEFINED_CLUSTER = "USER-DEFINED-CLUSTER"
    USER_DEFINED_ETHERNET_FRAME = "USER-DEFINED-ETHERNET-FRAME"
    USER_DEFINED_I_PDU = "USER-DEFINED-I-PDU"
    USER_DEFINED_PDU = "USER-DEFINED-PDU"
    USER_DEFINED_SERVICE_INSTANCE_TO_MACHINE_MAPPING = (
        "USER-DEFINED-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    )
    USER_DEFINED_SERVICE_INTERFACE_DEPLOYMENT = "USER-DEFINED-SERVICE-INTERFACE-DEPLOYMENT"
    VEHICLE_PACKAGE = "VEHICLE-PACKAGE"
    VFB_TIMING = "VFB-TIMING"
    VIEW_MAP_SET = "VIEW-MAP-SET"
    XCP_PDU = "XCP-PDU"


class CollectionSubtypesEnum(Enum):
    COLLECTION = "COLLECTION"


class ComEventGrantDesignSubtypesEnum(Enum):
    COM_EVENT_GRANT_DESIGN = "COM-EVENT-GRANT-DESIGN"


class ComFieldGrantDesignSubtypesEnum(Enum):
    COM_FIELD_GRANT_DESIGN = "COM-FIELD-GRANT-DESIGN"


class ComFindServiceGrantDesignSubtypesEnum(Enum):
    COM_FIND_SERVICE_GRANT_DESIGN = "COM-FIND-SERVICE-GRANT-DESIGN"


class ComMethodGrantDesignSubtypesEnum(Enum):
    COM_METHOD_GRANT_DESIGN = "COM-METHOD-GRANT-DESIGN"


class ComOfferServiceGrantDesignSubtypesEnum(Enum):
    COM_OFFER_SERVICE_GRANT_DESIGN = "COM-OFFER-SERVICE-GRANT-DESIGN"


class CommunicationClusterSubtypesEnum(Enum):
    ABSTRACT_CAN_CLUSTER = "ABSTRACT-CAN-CLUSTER"
    CAN_CLUSTER = "CAN-CLUSTER"
    COMMUNICATION_CLUSTER = "COMMUNICATION-CLUSTER"
    ETHERNET_CLUSTER = "ETHERNET-CLUSTER"
    FLEXRAY_CLUSTER = "FLEXRAY-CLUSTER"
    J_1939_CLUSTER = "J-1939-CLUSTER"
    LIN_CLUSTER = "LIN-CLUSTER"
    TTCAN_CLUSTER = "TTCAN-CLUSTER"
    USER_DEFINED_CLUSTER = "USER-DEFINED-CLUSTER"


class CommunicationConnectorSubtypesEnum(Enum):
    ABSTRACT_CAN_COMMUNICATION_CONNECTOR = "ABSTRACT-CAN-COMMUNICATION-CONNECTOR"
    CAN_COMMUNICATION_CONNECTOR = "CAN-COMMUNICATION-CONNECTOR"
    COMMUNICATION_CONNECTOR = "COMMUNICATION-CONNECTOR"
    ETHERNET_COMMUNICATION_CONNECTOR = "ETHERNET-COMMUNICATION-CONNECTOR"
    FLEXRAY_COMMUNICATION_CONNECTOR = "FLEXRAY-COMMUNICATION-CONNECTOR"
    LIN_COMMUNICATION_CONNECTOR = "LIN-COMMUNICATION-CONNECTOR"
    TTCAN_COMMUNICATION_CONNECTOR = "TTCAN-COMMUNICATION-CONNECTOR"
    USER_DEFINED_COMMUNICATION_CONNECTOR = "USER-DEFINED-COMMUNICATION-CONNECTOR"


class CommunicationControllerSubtypesEnum(Enum):
    ABSTRACT_CAN_COMMUNICATION_CONTROLLER = "ABSTRACT-CAN-COMMUNICATION-CONTROLLER"
    CAN_COMMUNICATION_CONTROLLER = "CAN-COMMUNICATION-CONTROLLER"
    COMMUNICATION_CONTROLLER = "COMMUNICATION-CONTROLLER"
    ETHERNET_COMMUNICATION_CONTROLLER = "ETHERNET-COMMUNICATION-CONTROLLER"
    FLEXRAY_COMMUNICATION_CONTROLLER = "FLEXRAY-COMMUNICATION-CONTROLLER"
    LIN_COMMUNICATION_CONTROLLER = "LIN-COMMUNICATION-CONTROLLER"
    LIN_MASTER = "LIN-MASTER"
    LIN_SLAVE = "LIN-SLAVE"
    TTCAN_COMMUNICATION_CONTROLLER = "TTCAN-COMMUNICATION-CONTROLLER"
    USER_DEFINED_COMMUNICATION_CONTROLLER = "USER-DEFINED-COMMUNICATION-CONTROLLER"


class CommunicationDirectionTypeSimple(Enum):
    """
    :cvar IN: Reception (Input)
    :cvar OUT: Transmission (Output)
    """

    IN = "IN"
    OUT = "OUT"


class CompositionSwComponentTypeSubtypesEnum(Enum):
    COMPOSITION_SW_COMPONENT_TYPE = "COMPOSITION-SW-COMPONENT-TYPE"


@dataclass(slots=True, kw_only=True)
class CompuGenericMath:
    """
    This meta-class represents the ability to specify a generic formula expression.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar level: Placeholder to describe an indicator of a language
        level for the mathematics e.g. INFORMAL, ASAMHDO. May be refined
        by particular use-cases.
    :ivar content:
    """

    class Meta:
        name = "COMPU-GENERIC-MATH"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    level: str | None = field(
        default=None,
        metadata={
            "name": "LEVEL",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
        },
    )


class CompuMethodSubtypesEnum(Enum):
    COMPU_METHOD = "COMPU-METHOD"


class ConstantSpecificationSubtypesEnum(Enum):
    CONSTANT_SPECIFICATION = "CONSTANT-SPECIFICATION"


class ConstantSpecificationMappingSetSubtypesEnum(Enum):
    CONSTANT_SPECIFICATION_MAPPING_SET = "CONSTANT-SPECIFICATION-MAPPING-SET"


class ConsumedEventGroupSubtypesEnum(Enum):
    CONSUMED_EVENT_GROUP = "CONSUMED-EVENT-GROUP"


class ConsumedProvidedServiceInstanceGroupSubtypesEnum(Enum):
    CONSUMED_PROVIDED_SERVICE_INSTANCE_GROUP = "CONSUMED-PROVIDED-SERVICE-INSTANCE-GROUP"


class ConsumedServiceInstanceSubtypesEnum(Enum):
    CONSUMED_SERVICE_INSTANCE = "CONSUMED-SERVICE-INSTANCE"


class ContainedIPduCollectionSemanticsEnumSimple(Enum):
    """
    :cvar LAST_IS_BEST: The ContainedIPdu data will be fetched via
        TriggerTransmit just before the transmission executes.
    :cvar QUEUED: The ContainedIPdu data will instantly be stored to the
        ContainerIPdu in the context of the Transmit API.
    """

    LAST_IS_BEST = "LAST-IS-BEST"
    QUEUED = "QUEUED"


class ContainerIPduHeaderTypeEnumSimple(Enum):
    """
    :cvar LONG_HEADER: Header size is 64 bit: * Header Id 32 bit * Dlc
        32 bit
    :cvar NO_HEADER: No Header is used and the location of each
        containedPdu in the ContainerPdu is statically configured.
    :cvar SHORT_HEADER: Header size is 32 bit: * Header Id 24 bit * Dlc
        8 bit.
    """

    LONG_HEADER = "LONG-HEADER"
    NO_HEADER = "NO-HEADER"
    SHORT_HEADER = "SHORT-HEADER"


class ContainerIPduTriggerEnumSimple(Enum):
    """
    :cvar DEFAULT_TRIGGER: Defines that the transmission of the
        ContainerIPdu shall be requested when the default trigger
        conditions apply (e.g. timeout of threshold).
    :cvar FIRST_CONTAINED_TRIGGER: Defines that the transmission of the
        ContainerIPdu shall be requested right after the first
        ContainedIPdu was put into the ContainerIPdu.
    """

    DEFAULT_TRIGGER = "DEFAULT-TRIGGER"
    FIRST_CONTAINED_TRIGGER = "FIRST-CONTAINED-TRIGGER"


class CouplingElementEnumSimple(Enum):
    """
    :cvar HUB: A device that is used to connect segments of a LAN. In
        Hubs frames are "broadcasted" to every one of its ports.
    :cvar ROUTER: A device that routes frames between different
        networks.
    :cvar SWITCH: A device that filters and forwards frames between
        different LAN segments.
    """

    HUB = "HUB"
    ROUTER = "ROUTER"
    SWITCH = "SWITCH"


class CouplingPortSubtypesEnum(Enum):
    COUPLING_PORT = "COUPLING-PORT"


class CouplingPortFifoSubtypesEnum(Enum):
    COUPLING_PORT_FIFO = "COUPLING-PORT-FIFO"


class CouplingPortRatePolicyActionEnumSimple(Enum):
    """
    :cvar BLOCK_SOURCE: If the rate policy is violated the CouplingPort
        this CouplingPortRatePolicy is defined on shall block all frames
        from the MAC-Address the violation was caused by.
    :cvar DROP_FRAME: If the rate policy is violated the frame shall be
        dropped.
    """

    BLOCK_SOURCE = "BLOCK-SOURCE"
    DROP_FRAME = "DROP-FRAME"


class CouplingPortRoleEnumSimple(Enum):
    """
    :cvar HOST_PORT: The hostPort is connected to an ECU (host ecu). The
        host ECU controls the connected CouplingElement (e.g. Ethernet
        switch).
    :cvar STANDARD_PORT: A CoupingPort can be a standardPort that is
        used to connect the CouplingElement with CouplingPorts outside
        the ECU.
    :cvar UP_LINK_PORT: A CouplingPort can be connected to another
        CouplingPort of a CouplingElement located on the same ECU
        (CouplingElement.ecuInstance) using the CouplingPortConnection.
        This is used to model a cascaded switch.
    """

    HOST_PORT = "HOST-PORT"
    STANDARD_PORT = "STANDARD-PORT"
    UP_LINK_PORT = "UP-LINK-PORT"


class CouplingPortSchedulerSubtypesEnum(Enum):
    COUPLING_PORT_SCHEDULER = "COUPLING-PORT-SCHEDULER"


class CouplingPortStructuralElementSubtypesEnum(Enum):
    COUPLING_PORT_FIFO = "COUPLING-PORT-FIFO"
    COUPLING_PORT_SCHEDULER = "COUPLING-PORT-SCHEDULER"
    COUPLING_PORT_SHAPER = "COUPLING-PORT-SHAPER"
    COUPLING_PORT_STRUCTURAL_ELEMENT = "COUPLING-PORT-STRUCTURAL-ELEMENT"


class CpSoftwareClusterSubtypesEnum(Enum):
    CP_SOFTWARE_CLUSTER = "CP-SOFTWARE-CLUSTER"


class CpSoftwareClusterCommunicationResourceSubtypesEnum(Enum):
    CP_SOFTWARE_CLUSTER_COMMUNICATION_RESOURCE = "CP-SOFTWARE-CLUSTER-COMMUNICATION-RESOURCE"


class CpSoftwareClusterResourceSubtypesEnum(Enum):
    CP_SOFTWARE_CLUSTER_COMMUNICATION_RESOURCE = "CP-SOFTWARE-CLUSTER-COMMUNICATION-RESOURCE"
    CP_SOFTWARE_CLUSTER_RESOURCE = "CP-SOFTWARE-CLUSTER-RESOURCE"
    CP_SOFTWARE_CLUSTER_SERVICE_RESOURCE = "CP-SOFTWARE-CLUSTER-SERVICE-RESOURCE"


class CpSoftwareClusterServiceResourceSubtypesEnum(Enum):
    CP_SOFTWARE_CLUSTER_SERVICE_RESOURCE = "CP-SOFTWARE-CLUSTER-SERVICE-RESOURCE"


class CppImplementationDataTypeSubtypesEnum(Enum):
    CPP_IMPLEMENTATION_DATA_TYPE = "CPP-IMPLEMENTATION-DATA-TYPE"
    CUSTOM_CPP_IMPLEMENTATION_DATA_TYPE = "CUSTOM-CPP-IMPLEMENTATION-DATA-TYPE"
    STD_CPP_IMPLEMENTATION_DATA_TYPE = "STD-CPP-IMPLEMENTATION-DATA-TYPE"


class CppImplementationDataTypeContextTargetSubtypesEnum(Enum):
    CPP_IMPLEMENTATION_DATA_TYPE = "CPP-IMPLEMENTATION-DATA-TYPE"
    CPP_IMPLEMENTATION_DATA_TYPE_CONTEXT_TARGET = "CPP-IMPLEMENTATION-DATA-TYPE-CONTEXT-TARGET"
    CPP_IMPLEMENTATION_DATA_TYPE_ELEMENT = "CPP-IMPLEMENTATION-DATA-TYPE-ELEMENT"
    CUSTOM_CPP_IMPLEMENTATION_DATA_TYPE = "CUSTOM-CPP-IMPLEMENTATION-DATA-TYPE"
    STD_CPP_IMPLEMENTATION_DATA_TYPE = "STD-CPP-IMPLEMENTATION-DATA-TYPE"


class CryptoCertificateSubtypesEnum(Enum):
    CRYPTO_CERTIFICATE = "CRYPTO-CERTIFICATE"


class CryptoCertificateAlgorithmFamilyEnumSimple(Enum):
    """
    :cvar ECC: The cryptographic operations in the certificate are
        executed using elliptic curves (ecc)
    :cvar RSA: The cryptographic operations in the certificate are
        executed using the RSA approach.
    """

    ECC = "ECC"
    RSA = "RSA"


class CryptoCertificateFormatEnumSimple(Enum):
    """
    :cvar CVC: The certificate has been created in Card Verifiable
        Certificate (CVC) format
    :cvar X_509: The certificate is created in X.509 format.
    """

    CVC = "CVC"
    X_509 = "X-509"


class CryptoEllipticCurvePropsSubtypesEnum(Enum):
    CRYPTO_ELLIPTIC_CURVE_PROPS = "CRYPTO-ELLIPTIC-CURVE-PROPS"


class CryptoKeySlotSubtypesEnum(Enum):
    CRYPTO_KEY_SLOT = "CRYPTO-KEY-SLOT"


class CryptoKeySlotTypeEnumSimple(Enum):
    """
    :cvar APPLICATION: KeySlot is used and modified exclusively by the
        Application.
    :cvar MACHINE: Key slot is used by platform modules only. The
        application manages the key but is not able to use the key.
    """

    APPLICATION = "APPLICATION"
    MACHINE = "MACHINE"


class CryptoKeySlotUsageEnumSimple(Enum):
    """
    :cvar ENCRYPTION: Key slot usage for encryption
    :cvar VERIFICATION: Key slot usage for verification
    """

    ENCRYPTION = "ENCRYPTION"
    VERIFICATION = "VERIFICATION"


class CryptoObjectTypeEnumSimple(Enum):
    """
    :cvar PRIVATE_KEY: cryp::PrivateKey object
    :cvar PUBLIC_KEY: cryp::PublicKey object
    :cvar SECRET_SEED: cryp::SecretSeed object
    :cvar SIGNATURE: cryp::Signature object (asymmetric digital
        signature or symmetric MAC/HMAC)
    :cvar SYMMETRIC_KEY: cryp::SymmetricKey object
    :cvar UNDEFINED: Object type unknown
    """

    PRIVATE_KEY = "PRIVATE-KEY"
    PUBLIC_KEY = "PUBLIC-KEY"
    SECRET_SEED = "SECRET-SEED"
    SIGNATURE = "SIGNATURE"
    SYMMETRIC_KEY = "SYMMETRIC-KEY"
    UNDEFINED = "UNDEFINED"


class CryptoProviderSubtypesEnum(Enum):
    CRYPTO_PROVIDER = "CRYPTO-PROVIDER"


class CryptoServiceCertificateSubtypesEnum(Enum):
    CRYPTO_SERVICE_CERTIFICATE = "CRYPTO-SERVICE-CERTIFICATE"


class CryptoServiceKeySubtypesEnum(Enum):
    CRYPTO_SERVICE_KEY = "CRYPTO-SERVICE-KEY"


class CryptoServiceKeyGenerationEnumSimple(Enum):
    """
    :cvar KEY_DERIVATION: This means that the crypto key is created by
        derivation from a master key.
    :cvar KEY_STORAGE: This means that the crypto key is obtained from
        an external entity, e.g. a diagnostic tester.
    """

    KEY_DERIVATION = "KEY-DERIVATION"
    KEY_STORAGE = "KEY-STORAGE"


class CryptoServicePrimitiveSubtypesEnum(Enum):
    CRYPTO_SERVICE_PRIMITIVE = "CRYPTO-SERVICE-PRIMITIVE"


class CryptoServiceQueueSubtypesEnum(Enum):
    CRYPTO_SERVICE_QUEUE = "CRYPTO-SERVICE-QUEUE"


class CryptoSignatureSchemeSubtypesEnum(Enum):
    CRYPTO_SIGNATURE_SCHEME = "CRYPTO-SIGNATURE-SCHEME"


class CsTransformerErrorReactionEnumSimple(Enum):
    """
    :cvar APPLICATION_ONLY: The application is responsible for any error
        reaction. No autonomous error reaction of RTE and transformer.
    :cvar AUTONOMOUS: RTE and Transformer coordinate an autonomous error
        reaction on their own.
    """

    APPLICATION_ONLY = "APPLICATION-ONLY"
    AUTONOMOUS = "AUTONOMOUS"


@dataclass(slots=True, kw_only=True)
class CseCodeTypeString:
    """This primitive represents an ASAM CSE (Codes for Scaling Units) based on the
    definition in the ASAM-MCD-2MC-ASAP2  specification.

    The particular semantics is specified in [TPS_GST_00354].

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CSE-CODE-TYPE-STRING"

    value: int = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class CycleRepetitionTypeSimple(Enum):
    """
    :cvar CYCLE_REPETITION_1: Attribute cycleRepetition value="1" valid
        only for FlexRay Protocol 2.1 Rev A
    :cvar CYCLE_REPETITION_10: Attribute cycleRepetition value="10" to
        support FlexRay 3.0
    :cvar CYCLE_REPETITION_16: Attribute cycleRepetition value="16"
        valid only for FlexRay Protocol 2.1 Rev A
    :cvar CYCLE_REPETITION_2: Attribute cycleRepetition value="2" valid
        only for FlexRay Protocol 2.1 Rev A
    :cvar CYCLE_REPETITION_20: Attribute cycleRepetition value="20" to
        support FlexRay 3.0
    :cvar CYCLE_REPETITION_32: Attribute cycleRepetition value="32"
        valid only for FlexRay Protocol 2.1 Rev A
    :cvar CYCLE_REPETITION_4: Attribute cycleRepetition value="4" valid
        only for FlexRay Protocol 2.1 Rev A
    :cvar CYCLE_REPETITION_40: Attribute cycleRepetition value="40" to
        support FlexRay 3.0
    :cvar CYCLE_REPETITION_5: Attribute cycleRepetition value="5" to
        support FlexRay 3.0
    :cvar CYCLE_REPETITION_50: Attribute cycleRepetition value="50" to
        support FlexRay 3.0
    :cvar CYCLE_REPETITION_64: Attribute cycleRepetition value="64"
        valid only for FlexRay Protocol 2.1 Rev A
    :cvar CYCLE_REPETITION_8: Attribute cycleRepetition value="8" valid
        only for FlexRay Protocol 2.1 Rev A
    """

    CYCLE_REPETITION_1 = "CYCLE-REPETITION-1"
    CYCLE_REPETITION_10 = "CYCLE-REPETITION-10"
    CYCLE_REPETITION_16 = "CYCLE-REPETITION-16"
    CYCLE_REPETITION_2 = "CYCLE-REPETITION-2"
    CYCLE_REPETITION_20 = "CYCLE-REPETITION-20"
    CYCLE_REPETITION_32 = "CYCLE-REPETITION-32"
    CYCLE_REPETITION_4 = "CYCLE-REPETITION-4"
    CYCLE_REPETITION_40 = "CYCLE-REPETITION-40"
    CYCLE_REPETITION_5 = "CYCLE-REPETITION-5"
    CYCLE_REPETITION_50 = "CYCLE-REPETITION-50"
    CYCLE_REPETITION_64 = "CYCLE-REPETITION-64"
    CYCLE_REPETITION_8 = "CYCLE-REPETITION-8"


class DataConsistencyPolicyEnumSimple(Enum):
    """
    :cvar CONSISTENCY_MECHANISM_REQUIRED: In this case the data
        consistency is ensured by the implementation of the SwClucC
        module.
    :cvar NO_CONSISTENCY_MECHANISM: In this case the data consistency is
        not ensured by the SwClucC module. In this case it has to be
        ensured by scheduling.
    """

    CONSISTENCY_MECHANISM_REQUIRED = "CONSISTENCY-MECHANISM-REQUIRED"
    NO_CONSISTENCY_MECHANISM = "NO-CONSISTENCY-MECHANISM"


class DataConstrSubtypesEnum(Enum):
    DATA_CONSTR = "DATA-CONSTR"


class DataExchangePointKindSimple(Enum):
    """
    :cvar AGREED: the data exchange point description represents the
        agreed data exchange point that should be used during data
        exchange
    :cvar CONSUMER: the data exchange point description represents the
        input of a consuming tool.
    :cvar PRODUCER: the data exchange point description represents the
        output of a producing tool.
    """

    AGREED = "AGREED"
    CONSUMER = "CONSUMER"
    PRODUCER = "PRODUCER"


class DataFilterTypeEnumSimple(Enum):
    """
    :cvar ALWAYS: No filtering is performed so that the message always
        passes.
    :cvar MASKED_NEW_DIFFERS_MASKED_OLD: Pass messages where the masked
        value has changed. (new_value&amp;mask) !=(old_value&amp;mask)
        new_value: current value of the message old_value: last value of
        the message (initialized with the initial value of the message,
        updated with new_value if the new message value is not filtered
        out)
    :cvar MASKED_NEW_DIFFERS_X: Pass messages whose masked value is not
        equal to a specific value x (new_value&amp;mask) != x new_value:
        current value of the message
    :cvar MASKED_NEW_EQUALS_X: Pass messages whose masked value is equal
        to a specific value x (new_value&amp;mask) == x new_value:
        current value of the message
    :cvar NEVER: The filter removes all messages.
    :cvar NEW_IS_OUTSIDE: Pass a message if its value is outside a
        predefined boundary. (min &gt; new_value) OR (new_value &gt;
        max)
    :cvar NEW_IS_WITHIN: Pass a message if its value is within a
        predefined boundary. min &lt;= new_value &lt;= max
    :cvar ONE_EVERY_N: Pass a message once every N message occurrences.
        Algorithm: occurrence % period == offset Start: occurrence = 0.
        Each time the message is received or transmitted, occurrence is
        incremented by 1 after filtering. Length of occurrence is 8 bit
        (minimum).
    """

    ALWAYS = "ALWAYS"
    MASKED_NEW_DIFFERS_MASKED_OLD = "MASKED-NEW-DIFFERS-MASKED-OLD"
    MASKED_NEW_DIFFERS_X = "MASKED-NEW-DIFFERS-X"
    MASKED_NEW_EQUALS_X = "MASKED-NEW-EQUALS-X"
    NEVER = "NEVER"
    NEW_IS_OUTSIDE = "NEW-IS-OUTSIDE"
    NEW_IS_WITHIN = "NEW-IS-WITHIN"
    ONE_EVERY_N = "ONE-EVERY-N"


class DataFormatElementReferenceSubtypesEnum(Enum):
    ABSTRACT_CLASS_TAILORING = "ABSTRACT-CLASS-TAILORING"
    AGGREGATION_TAILORING = "AGGREGATION-TAILORING"
    ATTRIBUTE_TAILORING = "ATTRIBUTE-TAILORING"
    CONCRETE_CLASS_TAILORING = "CONCRETE-CLASS-TAILORING"
    CONSTRAINT_TAILORING = "CONSTRAINT-TAILORING"
    DATA_FORMAT_ELEMENT_REFERENCE = "DATA-FORMAT-ELEMENT-REFERENCE"
    DATA_FORMAT_ELEMENT_SCOPE = "DATA-FORMAT-ELEMENT-SCOPE"
    PRIMITIVE_ATTRIBUTE_TAILORING = "PRIMITIVE-ATTRIBUTE-TAILORING"
    REFERENCE_TAILORING = "REFERENCE-TAILORING"
    SDG_TAILORING = "SDG-TAILORING"


class DataIdModeEnumSimple(Enum):
    """
    :cvar ALL_16_BIT: Two bytes are included in the CRC (double ID
        configuration).
    :cvar ALTERNATING_8_BIT: One of the two bytes byte is included,
        alternating high and low byte, depending on parity of the
        counter (alternating ID configuration). For even counter low
        byte is included; For odd counters the high byte is included.
    :cvar LOWER_12_BIT: The low byte is included in the implicit CRC
        calculation, the low nibble of the high byte is transmitted
        along with the data (i.e. it is explicitly included), the high
        nibble of the high byte is not used. This is applicable for the
        IDs up to 12 bits.
    :cvar LOWER_8_BIT: Only low byte is included, high byte is never
        used. This is applicable if the IDs in a particular system are 8
        bits.
    """

    ALL_16_BIT = "ALL-16-BIT"
    ALTERNATING_8_BIT = "ALTERNATING-8-BIT"
    LOWER_12_BIT = "LOWER-12-BIT"
    LOWER_8_BIT = "LOWER-8-BIT"


class DataLimitKindEnumSimple(Enum):
    """
    :cvar MAX: Limitation to maximum value
    :cvar MIN: Limitation to minimum value
    :cvar NONE: No limitation applicable
    """

    MAX = "MAX"
    MIN = "MIN"
    NONE = "NONE"


class DataPrototypeSubtypesEnum(Enum):
    APPLICATION_ARRAY_ELEMENT = "APPLICATION-ARRAY-ELEMENT"
    APPLICATION_ASSOC_MAP_ELEMENT = "APPLICATION-ASSOC-MAP-ELEMENT"
    APPLICATION_COMPOSITE_ELEMENT_DATA_PROTOTYPE = "APPLICATION-COMPOSITE-ELEMENT-DATA-PROTOTYPE"
    APPLICATION_RECORD_ELEMENT = "APPLICATION-RECORD-ELEMENT"
    ARGUMENT_DATA_PROTOTYPE = "ARGUMENT-DATA-PROTOTYPE"
    AUTOSAR_DATA_PROTOTYPE = "AUTOSAR-DATA-PROTOTYPE"
    DATA_PROTOTYPE = "DATA-PROTOTYPE"
    FIELD = "FIELD"
    PARAMETER_DATA_PROTOTYPE = "PARAMETER-DATA-PROTOTYPE"
    PERSISTENCY_DATA_ELEMENT = "PERSISTENCY-DATA-ELEMENT"
    VARIABLE_DATA_PROTOTYPE = "VARIABLE-DATA-PROTOTYPE"


class DataPrototypeGroupSubtypesEnum(Enum):
    DATA_PROTOTYPE_GROUP = "DATA-PROTOTYPE-GROUP"


class DataTransformationSubtypesEnum(Enum):
    DATA_TRANSFORMATION = "DATA-TRANSFORMATION"


class DataTransformationErrorHandlingEnumSimple(Enum):
    """
    :cvar NO_TRANSFORMER_ERROR_HANDLING: A runnable does not handle
        transformer errors.
    :cvar TRANSFORMER_ERROR_HANDLING: The runnable implements the
        handling of transformer errors.
    """

    NO_TRANSFORMER_ERROR_HANDLING = "NO-TRANSFORMER-ERROR-HANDLING"
    TRANSFORMER_ERROR_HANDLING = "TRANSFORMER-ERROR-HANDLING"


class DataTransformationKindEnumSimple(Enum):
    """
    :cvar ASYMMETRIC_FROM_BYTE_ARRAY: The DataTransformation shall only
        be applied to the receiving end only, i.e. transform from byte
        array to data type.
    :cvar ASYMMETRIC_TO_BYTE_ARRAY: The DataTransformation shall be
        applied to the sending end only, i.e. from data type to byte
        array.
    :cvar SYMMETRIC: The DataTransformation shall be applied at both the
        sending and the receiving end of the communication.
    """

    ASYMMETRIC_FROM_BYTE_ARRAY = "ASYMMETRIC-FROM-BYTE-ARRAY"
    ASYMMETRIC_TO_BYTE_ARRAY = "ASYMMETRIC-TO-BYTE-ARRAY"
    SYMMETRIC = "SYMMETRIC"


class DataTransformationStatusForwardingEnumSimple(Enum):
    """
    :cvar NO_TRANSFORMER_STATUS_FORWARDING: The RunnableEntity is not
        able to forward a transformer status code.
    :cvar TRANSFORMER_STATUS_FORWARDING: The RunnableEntity is able to
        forward a transformer status code.
    """

    NO_TRANSFORMER_STATUS_FORWARDING = "NO-TRANSFORMER-STATUS-FORWARDING"
    TRANSFORMER_STATUS_FORWARDING = "TRANSFORMER-STATUS-FORWARDING"


class DataTypeMappingSetSubtypesEnum(Enum):
    DATA_TYPE_MAPPING_SET = "DATA-TYPE-MAPPING-SET"


class DataTypePolicyEnumSimple(Enum):
    """
    :cvar LEGACY: In case the System Description doesn't use a complete
        Software Component Description (VFB View) this value can be
        chosen. This supports the inclusion of legacy signals. The
        aggregation of SwDataDefProps shall be used to configure the
        "ComSignalDataInvalidValue" and the Data Semantics.
    :cvar NETWORK_REPRESENTATION_FROM_COM_SPEC: Ignore any
        networkRepresentationProps of this ISignal and use the
        networkRepresentation from the ComSpec. Please note that the
        usage does not imply the existence of the SwDataDefProps in the
        role networkRepresentation aggregated by the SenderComSpec or
        ReceiverComSpec if an ImplementationDataType is defined.
    :cvar OVERRIDE: If this value is chosen the requirements specified
        in the ComSpec (networkRepresentationFromComSpec) are not
        fullfilled by the aggregated SwDataDefProps. In this case the
        networkRepresentation is specified by the aggregated
        swDataDefProps.
    :cvar PORT_INTERFACE_DEFINITION: This enumeration literal is
        deprecated and will be removed in future. Old description:
        Ignore any networkRepresentationProps of this ISignal and use
        the networkRepresentation specified in the
        VariableDataPrototypes owned by PortInterface
        (portInterfaceDefinition).
    :cvar TRANSFORMING_I_SIGNAL: This literal indicates that a
        transformer chain shall be used to communicate the ISignal as
        UINT8_N over the bus.
    """

    LEGACY = "LEGACY"
    NETWORK_REPRESENTATION_FROM_COM_SPEC = "NETWORK-REPRESENTATION-FROM-COM-SPEC"
    OVERRIDE = "OVERRIDE"
    PORT_INTERFACE_DEFINITION = "PORT-INTERFACE-DEFINITION"
    TRANSFORMING_I_SIGNAL = "TRANSFORMING-I-SIGNAL"


@dataclass(slots=True, kw_only=True)
class Date:
    """A datatype representing a timestamp.

    The smallest granularity is 1 second.
    This datatype represents a timestamp in the format yyyy-mm-dd followed by an optional time. The lead-in character for the time is "T" and the format is hh:mm:ss. In addition, a time zone designator shall be specified. The time zone designator can either be "Z" (for UTC) or the time offset to UTC, i.e. (+|-)hh:mm.
    Examples:
    2009-07-23
    2009-07-23T14:38:00+01:00
    2009-07-23T13:38:00Z

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATE"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class DdsProtectionKindEnumSimple(Enum):
    """
    :cvar ENCRYPT_AND_SIGN: encryption and MAC transformations (in that
        precise order) are applied
    :cvar ENCRYPT_AND_SIGN_WITH_ORIGIN_AUTHENTICATION: similar to
        "EncryptAndSign" but with additional authentication codes
        produced under different secret keys, which prevents receiving
        peers from impersonating a specific sender
    :cvar NONE: no transformation is applied
    :cvar SIGN: Message Authentication Code (MAC) is applied, no
        encryption
    :cvar SIGN_WITH_ORIGIN_AUTHENTICATION: similar to "sign" but with
        additional authentication codes produced under different secret
        keys, which prevents receiving peers from impersonating a
        specific sender
    """

    ENCRYPT_AND_SIGN = "ENCRYPT-AND-SIGN"
    ENCRYPT_AND_SIGN_WITH_ORIGIN_AUTHENTICATION = "ENCRYPT-AND-SIGN-WITH-ORIGIN-AUTHENTICATION"
    NONE = "NONE"
    SIGN = "SIGN"
    SIGN_WITH_ORIGIN_AUTHENTICATION = "SIGN-WITH-ORIGIN-AUTHENTICATION"


class DdsSecureComPropsSubtypesEnum(Enum):
    DDS_SECURE_COM_PROPS = "DDS-SECURE-COM-PROPS"


class DdsSecureGovernanceSubtypesEnum(Enum):
    DDS_SECURE_GOVERNANCE = "DDS-SECURE-GOVERNANCE"


class DdsServiceInstanceDiscoveryTypeEnumSimple(Enum):
    """
    :cvar DOMAIN_PARTICIPANT_USER_DATA_QOS: The USER_DATA QoS policy is
        used to advertise and discover available Service Instances
        hosted by each Domain Participant.
    :cvar TOPIC: A purpose-specific Topic is used to convey availability
        of Service Instances and how to bind against them.
    """

    DOMAIN_PARTICIPANT_USER_DATA_QOS = "DOMAIN-PARTICIPANT-USER-DATA-QOS"
    TOPIC = "TOPIC"


class DdsServiceInstanceResourceIdentifierTypeEnumSimple(Enum):
    """
    :cvar INSTANCE_ID: In-band instance identification fields are used
        to discriminate samples related to specific Service Instances
        sharing the same DDS Topics * Partitions: - * Topics:
        ara.com://services/&lt;InterfaceId&gt;/&lt;Major&gt;.&lt;&lt;Minor&gt;/&lt;TopicName&gt;
    :cvar PARTITION: The DDS PARTITION QoS policy is used to isolate DDS
        Topics related to specific Service Instances * Partitions:
        ara.com://services/&lt;InterfaceId&gt;/&lt;InstanceId&gt; *
        Topics:
        ara.com://services/&lt;InterfaceId&gt;/&lt;Major&gt;.&lt;Minor&gt;/&lt;TopicName&gt;
    :cvar TOPIC_PREFIX: Unique prefixes are assigned to DDS Topics
        related to specific Service Instances * Partitions: - * Topics:
        ara.com://services/&lt;InterfaceId&gt;/&lt;InstanceId&gt;/&lt;TopicName&gt;
    """

    INSTANCE_ID = "INSTANCE-ID"
    PARTITION = "PARTITION"
    TOPIC_PREFIX = "TOPIC-PREFIX"


class DdsTopicAccessRuleSubtypesEnum(Enum):
    DDS_TOPIC_ACCESS_RULE = "DDS-TOPIC-ACCESS-RULE"


class DefaultValueApplicationStrategyEnumSimple(Enum):
    """
    :cvar DEFAULT_IF_REVISION_UPDATE: If the AUTOSAR model is older than
        the Baseline of the Data Exchange Point and the older version
        did not yet support the attribute, then the AUTOSAR defined
        default value SHALL be applied before further validation or
        processing.
    :cvar DEFAULT_IF_UNDEFINED: If the AUTOSAR model does not explicitly
        specify a value, then the apply the AUTOSAR defined default
        value  before further validation or processing.
    :cvar NO_DEFAULT: do not apply the AUTOSAR defined default value
    """

    DEFAULT_IF_REVISION_UPDATE = "DEFAULT-IF-REVISION-UPDATE"
    DEFAULT_IF_UNDEFINED = "DEFAULT-IF-UNDEFINED"
    NO_DEFAULT = "NO-DEFAULT"


class DependencyOnArtifactSubtypesEnum(Enum):
    DEPENDENCY_ON_ARTIFACT = "DEPENDENCY-ON-ARTIFACT"


class DependencyUsageEnumSimple(Enum):
    """
    :cvar BUILD: The object referred by the dependency is required
        during the build process.
    :cvar CODEGENERATION: The object referred by the dependency is
        required during code generation
    :cvar COMPILE: The object referred by the dependency is required
        during compilation.
    :cvar EXECUTE: The object referred by the dependency is required at
        execution time.
    :cvar LINK: The object referred by the dependency is required during
        linking.
    """

    BUILD = "BUILD"
    CODEGENERATION = "CODEGENERATION"
    COMPILE = "COMPILE"
    EXECUTE = "EXECUTE"
    LINK = "LINK"


class DeterministicSyncMasterSubtypesEnum(Enum):
    DETERMINISTIC_SYNC_MASTER = "DETERMINISTIC-SYNC-MASTER"


class DiagPduTypeSimple(Enum):
    """
    :cvar DIAG_REQUEST: Diagnostic Request
    :cvar DIAG_RESPONSE: Diagnostic Response
    """

    DIAG_REQUEST = "DIAG-REQUEST"
    DIAG_RESPONSE = "DIAG-RESPONSE"


@dataclass(slots=True, kw_only=True)
class DiagRequirementIdString:
    """
    This string denotes an Identifier for a requirement.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAG-REQUIREMENT-ID-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"[0-9a-zA-Z_\-]+",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class DiagnosticAbstractDataIdentifierSubtypesEnum(Enum):
    DIAGNOSTIC_ABSTRACT_DATA_IDENTIFIER = "DIAGNOSTIC-ABSTRACT-DATA-IDENTIFIER"
    DIAGNOSTIC_DATA_IDENTIFIER = "DIAGNOSTIC-DATA-IDENTIFIER"
    DIAGNOSTIC_DYNAMIC_DATA_IDENTIFIER = "DIAGNOSTIC-DYNAMIC-DATA-IDENTIFIER"


class DiagnosticAccessPermissionSubtypesEnum(Enum):
    DIAGNOSTIC_ACCESS_PERMISSION = "DIAGNOSTIC-ACCESS-PERMISSION"


class DiagnosticAccessPermissionValidityEnumSimple(Enum):
    """
    :cvar ACCES_PERRMISSION_SERVICE_CLASS: This means that the
        DiagnosticServiceClass is in charge to define the
        accessPermission.
    :cvar ACCESS_PERMISSION_INSTANCE_OVERRIDES_CLASS: This means that
        accessPermission set at the DiagnosticServiceInstance will
        override the accessPermission defined at the
        DiagnosticServiceClass.
    :cvar ACCESS_PERMISSION_SERVICE_CLASS: This means that the
        DiagnosticServiceClass is in charge to define the
        accessPermission.
    :cvar ACCESS_PERMISSION_SERVICE_INSTANCE: This means that the
        DiagnosticServiceInstance is in charge of defining the
        accessPermission
    """

    ACCES_PERRMISSION_SERVICE_CLASS = "ACCES-PERRMISSION-SERVICE-CLASS"
    ACCESS_PERMISSION_INSTANCE_OVERRIDES_CLASS = "ACCESS-PERMISSION-INSTANCE-OVERRIDES-CLASS"
    ACCESS_PERMISSION_SERVICE_CLASS = "ACCESS-PERMISSION-SERVICE-CLASS"
    ACCESS_PERMISSION_SERVICE_INSTANCE = "ACCESS-PERMISSION-SERVICE-INSTANCE"


class DiagnosticAgingSubtypesEnum(Enum):
    DIAGNOSTIC_AGING = "DIAGNOSTIC-AGING"


class DiagnosticAudienceEnumSimple(Enum):
    """
    :cvar AFTER_SALES: The object is relevant for the OEM after-sales
        organization.
    :cvar AFTERMAKET: The object is for free aftermarket service
        organizations.
    :cvar AFTERMARKET: The object is for free aftermarket service
        organizations.
    :cvar DEVELOPMENT: The object is relevant for engineering only.
    :cvar MANUFACTURING: The object is relevant for manufacturing.
    :cvar SUPPLIER: The object is relevant for the ECU-supplier
        aftermarket organization.
    """

    AFTER_SALES = "AFTER-SALES"
    AFTERMAKET = "AFTERMAKET"
    AFTERMARKET = "AFTERMARKET"
    DEVELOPMENT = "DEVELOPMENT"
    MANUFACTURING = "MANUFACTURING"
    SUPPLIER = "SUPPLIER"


class DiagnosticAuthRoleSubtypesEnum(Enum):
    DIAGNOSTIC_AUTH_ROLE = "DIAGNOSTIC-AUTH-ROLE"


class DiagnosticAuthenticationSubtypesEnum(Enum):
    DIAGNOSTIC_AUTHENTICATION = "DIAGNOSTIC-AUTHENTICATION"
    DIAGNOSTIC_AUTHENTICATION_CONFIGURATION = "DIAGNOSTIC-AUTHENTICATION-CONFIGURATION"
    DIAGNOSTIC_DE_AUTHENTICATION = "DIAGNOSTIC-DE-AUTHENTICATION"
    DIAGNOSTIC_PROOF_OF_OWNERSHIP = "DIAGNOSTIC-PROOF-OF-OWNERSHIP"
    DIAGNOSTIC_VERIFY_CERTIFICATE_BIDIRECTIONAL = "DIAGNOSTIC-VERIFY-CERTIFICATE-BIDIRECTIONAL"
    DIAGNOSTIC_VERIFY_CERTIFICATE_UNIDIRECTIONAL = "DIAGNOSTIC-VERIFY-CERTIFICATE-UNIDIRECTIONAL"


class DiagnosticAuthenticationClassSubtypesEnum(Enum):
    DIAGNOSTIC_AUTHENTICATION_CLASS = "DIAGNOSTIC-AUTHENTICATION-CLASS"


class DiagnosticClearConditionSubtypesEnum(Enum):
    DIAGNOSTIC_CLEAR_CONDITION = "DIAGNOSTIC-CLEAR-CONDITION"


class DiagnosticClearConditionGroupSubtypesEnum(Enum):
    DIAGNOSTIC_CLEAR_CONDITION_GROUP = "DIAGNOSTIC-CLEAR-CONDITION-GROUP"


class DiagnosticClearDiagnosticInformationClassSubtypesEnum(Enum):
    DIAGNOSTIC_CLEAR_DIAGNOSTIC_INFORMATION_CLASS = "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION-CLASS"


class DiagnosticClearDtcLimitationEnumSimple(Enum):
    """
    :cvar ALL_SUPPORTED_DTCS: DEM_ClearDtc API accepts all supported DTC
        values.
    :cvar CLEAR_ALL_DTCS: DEM_ClearDtc API accepts ClearAllDTCs only.
    """

    ALL_SUPPORTED_DTCS = "ALL-SUPPORTED-DTCS"
    CLEAR_ALL_DTCS = "CLEAR-ALL-DTCS"


class DiagnosticClearDtcNotificationEnumSimple(Enum):
    """
    :cvar FINISH: The ClearDtcCallback shall be executed when the DTC
        operation finishes.
    :cvar START: The ClearDtcCallback shall be executed when the DTC
        operation starts.
    """

    FINISH = "FINISH"
    START = "START"


class DiagnosticClearEventAllowedBehaviorEnumSimple(Enum):
    """
    :cvar NO_STATUS_BYTE_CHANGE: The event status byte keeps unchanged.
    :cvar ONLY_THIS_CYCLE_AND_READINESS: The OperationCycle and
        readiness bits of the event status byte are reset.
    """

    NO_STATUS_BYTE_CHANGE = "NO-STATUS-BYTE-CHANGE"
    ONLY_THIS_CYCLE_AND_READINESS = "ONLY-THIS-CYCLE-AND-READINESS"


class DiagnosticClearEventBehaviorEnumSimple(Enum):
    """
    :cvar NO_STATUS_BYTE_CHANGE: The event status byte keeps unchanged.
    :cvar ONLY_THIS_CYCLE_AND_READINESS: The OperationCycle and
        readiness bits of the event status byte are reset.
    """

    NO_STATUS_BYTE_CHANGE = "NO-STATUS-BYTE-CHANGE"
    ONLY_THIS_CYCLE_AND_READINESS = "ONLY-THIS-CYCLE-AND-READINESS"


class DiagnosticClearResetEmissionRelatedInfoClassSubtypesEnum(Enum):
    DIAGNOSTIC_CLEAR_RESET_EMISSION_RELATED_INFO_CLASS = (
        "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO-CLASS"
    )


class DiagnosticComControlClassSubtypesEnum(Enum):
    DIAGNOSTIC_COM_CONTROL_CLASS = "DIAGNOSTIC-COM-CONTROL-CLASS"


class DiagnosticCommonElementSubtypesEnum(Enum):
    CP_SW_CLUSTER_RESOURCE_TO_DIAG_DATA_ELEM_MAPPING = (
        "CP-SW-CLUSTER-RESOURCE-TO-DIAG-DATA-ELEM-MAPPING"
    )
    CP_SW_CLUSTER_RESOURCE_TO_DIAG_FUNCTION_ID_MAPPING = (
        "CP-SW-CLUSTER-RESOURCE-TO-DIAG-FUNCTION-ID-MAPPING"
    )
    CP_SW_CLUSTER_TO_DIAG_EVENT_MAPPING = "CP-SW-CLUSTER-TO-DIAG-EVENT-MAPPING"
    CP_SW_CLUSTER_TO_DIAG_ROUTINE_SUBFUNCTION_MAPPING = (
        "CP-SW-CLUSTER-TO-DIAG-ROUTINE-SUBFUNCTION-MAPPING"
    )
    DIAGNOSTIC_ABSTRACT_ALIAS_EVENT = "DIAGNOSTIC-ABSTRACT-ALIAS-EVENT"
    DIAGNOSTIC_ABSTRACT_DATA_IDENTIFIER = "DIAGNOSTIC-ABSTRACT-DATA-IDENTIFIER"
    DIAGNOSTIC_ACCESS_PERMISSION = "DIAGNOSTIC-ACCESS-PERMISSION"
    DIAGNOSTIC_AGING = "DIAGNOSTIC-AGING"
    DIAGNOSTIC_AUTH_ROLE = "DIAGNOSTIC-AUTH-ROLE"
    DIAGNOSTIC_AUTHENTICATION = "DIAGNOSTIC-AUTHENTICATION"
    DIAGNOSTIC_AUTHENTICATION_CLASS = "DIAGNOSTIC-AUTHENTICATION-CLASS"
    DIAGNOSTIC_AUTHENTICATION_CONFIGURATION = "DIAGNOSTIC-AUTHENTICATION-CONFIGURATION"
    DIAGNOSTIC_AUTHENTICATION_PORT_MAPPING = "DIAGNOSTIC-AUTHENTICATION-PORT-MAPPING"
    DIAGNOSTIC_CLEAR_CONDITION = "DIAGNOSTIC-CLEAR-CONDITION"
    DIAGNOSTIC_CLEAR_CONDITION_GROUP = "DIAGNOSTIC-CLEAR-CONDITION-GROUP"
    DIAGNOSTIC_CLEAR_CONDITION_PORT_MAPPING = "DIAGNOSTIC-CLEAR-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_CLEAR_DIAGNOSTIC_INFORMATION = "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION"
    DIAGNOSTIC_CLEAR_DIAGNOSTIC_INFORMATION_CLASS = "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION-CLASS"
    DIAGNOSTIC_CLEAR_RESET_EMISSION_RELATED_INFO = "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO"
    DIAGNOSTIC_CLEAR_RESET_EMISSION_RELATED_INFO_CLASS = (
        "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO-CLASS"
    )
    DIAGNOSTIC_COM_CONTROL = "DIAGNOSTIC-COM-CONTROL"
    DIAGNOSTIC_COM_CONTROL_CLASS = "DIAGNOSTIC-COM-CONTROL-CLASS"
    DIAGNOSTIC_COMMON_ELEMENT = "DIAGNOSTIC-COMMON-ELEMENT"
    DIAGNOSTIC_CONDITION = "DIAGNOSTIC-CONDITION"
    DIAGNOSTIC_CONDITION_GROUP = "DIAGNOSTIC-CONDITION-GROUP"
    DIAGNOSTIC_CONTROL_DTC_SETTING = "DIAGNOSTIC-CONTROL-DTC-SETTING"
    DIAGNOSTIC_CONTROL_DTC_SETTING_CLASS = "DIAGNOSTIC-CONTROL-DTC-SETTING-CLASS"
    DIAGNOSTIC_CUSTOM_SERVICE_CLASS = "DIAGNOSTIC-CUSTOM-SERVICE-CLASS"
    DIAGNOSTIC_CUSTOM_SERVICE_INSTANCE = "DIAGNOSTIC-CUSTOM-SERVICE-INSTANCE"
    DIAGNOSTIC_DATA_BY_IDENTIFIER = "DIAGNOSTIC-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_DATA_IDENTIFIER = "DIAGNOSTIC-DATA-IDENTIFIER"
    DIAGNOSTIC_DATA_IDENTIFIER_SET = "DIAGNOSTIC-DATA-IDENTIFIER-SET"
    DIAGNOSTIC_DATA_PORT_MAPPING = "DIAGNOSTIC-DATA-PORT-MAPPING"
    DIAGNOSTIC_DATA_TRANSFER = "DIAGNOSTIC-DATA-TRANSFER"
    DIAGNOSTIC_DATA_TRANSFER_CLASS = "DIAGNOSTIC-DATA-TRANSFER-CLASS"
    DIAGNOSTIC_DE_AUTHENTICATION = "DIAGNOSTIC-DE-AUTHENTICATION"
    DIAGNOSTIC_DEM_PROVIDED_DATA_MAPPING = "DIAGNOSTIC-DEM-PROVIDED-DATA-MAPPING"
    DIAGNOSTIC_DYNAMIC_DATA_IDENTIFIER = "DIAGNOSTIC-DYNAMIC-DATA-IDENTIFIER"
    DIAGNOSTIC_DYNAMICALLY_DEFINE_DATA_IDENTIFIER = "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER"
    DIAGNOSTIC_DYNAMICALLY_DEFINE_DATA_IDENTIFIER_CLASS = (
        "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER-CLASS"
    )
    DIAGNOSTIC_ECU_INSTANCE_PROPS = "DIAGNOSTIC-ECU-INSTANCE-PROPS"
    DIAGNOSTIC_ECU_RESET = "DIAGNOSTIC-ECU-RESET"
    DIAGNOSTIC_ECU_RESET_CLASS = "DIAGNOSTIC-ECU-RESET-CLASS"
    DIAGNOSTIC_ENABLE_CONDITION = "DIAGNOSTIC-ENABLE-CONDITION"
    DIAGNOSTIC_ENABLE_CONDITION_GROUP = "DIAGNOSTIC-ENABLE-CONDITION-GROUP"
    DIAGNOSTIC_ENABLE_CONDITION_PORT_MAPPING = "DIAGNOSTIC-ENABLE-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_ENVIRONMENTAL_CONDITION = "DIAGNOSTIC-ENVIRONMENTAL-CONDITION"
    DIAGNOSTIC_EVENT = "DIAGNOSTIC-EVENT"
    DIAGNOSTIC_EVENT_PORT_MAPPING = "DIAGNOSTIC-EVENT-PORT-MAPPING"
    DIAGNOSTIC_EVENT_TO_DEBOUNCE_ALGORITHM_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-DEBOUNCE-ALGORITHM-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_ENABLE_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-ENABLE-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_OPERATION_CYCLE_MAPPING = "DIAGNOSTIC-EVENT-TO-OPERATION-CYCLE-MAPPING"
    DIAGNOSTIC_EVENT_TO_SECURITY_EVENT_MAPPING = "DIAGNOSTIC-EVENT-TO-SECURITY-EVENT-MAPPING"
    DIAGNOSTIC_EVENT_TO_STORAGE_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-STORAGE-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_TROUBLE_CODE_J_1939_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-TROUBLE-CODE-J-1939-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_TROUBLE_CODE_UDS_MAPPING = "DIAGNOSTIC-EVENT-TO-TROUBLE-CODE-UDS-MAPPING"
    DIAGNOSTIC_EXTENDED_DATA_RECORD = "DIAGNOSTIC-EXTENDED-DATA-RECORD"
    DIAGNOSTIC_EXTERNAL_AUTHENTICATION_PORT_MAPPING = (
        "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-PORT-MAPPING"
    )
    DIAGNOSTIC_FIM_ALIAS_EVENT = "DIAGNOSTIC-FIM-ALIAS-EVENT"
    DIAGNOSTIC_FIM_ALIAS_EVENT_GROUP = "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP"
    DIAGNOSTIC_FIM_ALIAS_EVENT_GROUP_MAPPING = "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP-MAPPING"
    DIAGNOSTIC_FIM_ALIAS_EVENT_MAPPING = "DIAGNOSTIC-FIM-ALIAS-EVENT-MAPPING"
    DIAGNOSTIC_FIM_EVENT_GROUP = "DIAGNOSTIC-FIM-EVENT-GROUP"
    DIAGNOSTIC_FIM_FUNCTION_MAPPING = "DIAGNOSTIC-FIM-FUNCTION-MAPPING"
    DIAGNOSTIC_FREEZE_FRAME = "DIAGNOSTIC-FREEZE-FRAME"
    DIAGNOSTIC_FUNCTION_IDENTIFIER = "DIAGNOSTIC-FUNCTION-IDENTIFIER"
    DIAGNOSTIC_FUNCTION_IDENTIFIER_INHIBIT = "DIAGNOSTIC-FUNCTION-IDENTIFIER-INHIBIT"
    DIAGNOSTIC_INDICATOR = "DIAGNOSTIC-INDICATOR"
    DIAGNOSTIC_INDICATOR_PORT_MAPPING = "DIAGNOSTIC-INDICATOR-PORT-MAPPING"
    DIAGNOSTIC_INFO_TYPE = "DIAGNOSTIC-INFO-TYPE"
    DIAGNOSTIC_INHIBIT_SOURCE_EVENT_MAPPING = "DIAGNOSTIC-INHIBIT-SOURCE-EVENT-MAPPING"
    DIAGNOSTIC_IO_CONTROL = "DIAGNOSTIC-IO-CONTROL"
    DIAGNOSTIC_IO_CONTROL_CLASS = "DIAGNOSTIC-IO-CONTROL-CLASS"
    DIAGNOSTIC_IUMPR = "DIAGNOSTIC-IUMPR"
    DIAGNOSTIC_IUMPR_DENOMINATOR_GROUP = "DIAGNOSTIC-IUMPR-DENOMINATOR-GROUP"
    DIAGNOSTIC_IUMPR_GROUP = "DIAGNOSTIC-IUMPR-GROUP"
    DIAGNOSTIC_IUMPR_TO_FUNCTION_IDENTIFIER_MAPPING = (
        "DIAGNOSTIC-IUMPR-TO-FUNCTION-IDENTIFIER-MAPPING"
    )
    DIAGNOSTIC_J_1939_EXPANDED_FREEZE_FRAME = "DIAGNOSTIC-J-1939-EXPANDED-FREEZE-FRAME"
    DIAGNOSTIC_J_1939_FREEZE_FRAME = "DIAGNOSTIC-J-1939-FREEZE-FRAME"
    DIAGNOSTIC_J_1939_NODE = "DIAGNOSTIC-J-1939-NODE"
    DIAGNOSTIC_J_1939_SPN = "DIAGNOSTIC-J-1939-SPN"
    DIAGNOSTIC_J_1939_SPN_MAPPING = "DIAGNOSTIC-J-1939-SPN-MAPPING"
    DIAGNOSTIC_J_1939_SW_MAPPING = "DIAGNOSTIC-J-1939-SW-MAPPING"
    DIAGNOSTIC_MAPPING = "DIAGNOSTIC-MAPPING"
    DIAGNOSTIC_MASTER_TO_SLAVE_EVENT_MAPPING = "DIAGNOSTIC-MASTER-TO-SLAVE-EVENT-MAPPING"
    DIAGNOSTIC_MEASUREMENT_IDENTIFIER = "DIAGNOSTIC-MEASUREMENT-IDENTIFIER"
    DIAGNOSTIC_MEMORY_ADDRESSABLE_RANGE_ACCESS = "DIAGNOSTIC-MEMORY-ADDRESSABLE-RANGE-ACCESS"
    DIAGNOSTIC_MEMORY_BY_ADDRESS = "DIAGNOSTIC-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_MEMORY_DESTINATION = "DIAGNOSTIC-MEMORY-DESTINATION"
    DIAGNOSTIC_MEMORY_DESTINATION_MIRROR = "DIAGNOSTIC-MEMORY-DESTINATION-MIRROR"
    DIAGNOSTIC_MEMORY_DESTINATION_PORT_MAPPING = "DIAGNOSTIC-MEMORY-DESTINATION-PORT-MAPPING"
    DIAGNOSTIC_MEMORY_DESTINATION_PRIMARY = "DIAGNOSTIC-MEMORY-DESTINATION-PRIMARY"
    DIAGNOSTIC_MEMORY_DESTINATION_USER_DEFINED = "DIAGNOSTIC-MEMORY-DESTINATION-USER-DEFINED"
    DIAGNOSTIC_MEMORY_IDENTIFIER = "DIAGNOSTIC-MEMORY-IDENTIFIER"
    DIAGNOSTIC_MONITOR_PORT_MAPPING = "DIAGNOSTIC-MONITOR-PORT-MAPPING"
    DIAGNOSTIC_OPERATION_CYCLE = "DIAGNOSTIC-OPERATION-CYCLE"
    DIAGNOSTIC_OPERATION_CYCLE_PORT_MAPPING = "DIAGNOSTIC-OPERATION-CYCLE-PORT-MAPPING"
    DIAGNOSTIC_PARAMETER_IDENTIFIER = "DIAGNOSTIC-PARAMETER-IDENTIFIER"
    DIAGNOSTIC_POWERTRAIN_FREEZE_FRAME = "DIAGNOSTIC-POWERTRAIN-FREEZE-FRAME"
    DIAGNOSTIC_PROOF_OF_OWNERSHIP = "DIAGNOSTIC-PROOF-OF-OWNERSHIP"
    DIAGNOSTIC_PROTOCOL = "DIAGNOSTIC-PROTOCOL"
    DIAGNOSTIC_PROVIDED_DATA_MAPPING = "DIAGNOSTIC-PROVIDED-DATA-MAPPING"
    DIAGNOSTIC_READ_DATA_BY_IDENTIFIER = "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_READ_DATA_BY_IDENTIFIER_CLASS = "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER-CLASS"
    DIAGNOSTIC_READ_DATA_BY_PERIODIC_ID = "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID"
    DIAGNOSTIC_READ_DATA_BY_PERIODIC_ID_CLASS = "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID-CLASS"
    DIAGNOSTIC_READ_DTC_INFORMATION = "DIAGNOSTIC-READ-DTC-INFORMATION"
    DIAGNOSTIC_READ_DTC_INFORMATION_CLASS = "DIAGNOSTIC-READ-DTC-INFORMATION-CLASS"
    DIAGNOSTIC_READ_MEMORY_BY_ADDRESS = "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_READ_MEMORY_BY_ADDRESS_CLASS = "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS-CLASS"
    DIAGNOSTIC_READ_SCALING_DATA_BY_IDENTIFIER = "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_READ_SCALING_DATA_BY_IDENTIFIER_CLASS = (
        "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER-CLASS"
    )
    DIAGNOSTIC_REQUEST_CONTROL_OF_ON_BOARD_DEVICE = "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE"
    DIAGNOSTIC_REQUEST_CONTROL_OF_ON_BOARD_DEVICE_CLASS = (
        "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE-CLASS"
    )
    DIAGNOSTIC_REQUEST_CURRENT_POWERTRAIN_DATA = "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA"
    DIAGNOSTIC_REQUEST_CURRENT_POWERTRAIN_DATA_CLASS = (
        "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA-CLASS"
    )
    DIAGNOSTIC_REQUEST_DOWNLOAD = "DIAGNOSTIC-REQUEST-DOWNLOAD"
    DIAGNOSTIC_REQUEST_DOWNLOAD_CLASS = "DIAGNOSTIC-REQUEST-DOWNLOAD-CLASS"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_CLASS = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-CLASS"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_PERMANENT_STATUS = (
        "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS"
    )
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_PERMANENT_STATUS_CLASS = (
        "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS-CLASS"
    )
    DIAGNOSTIC_REQUEST_FILE_TRANSFER = "DIAGNOSTIC-REQUEST-FILE-TRANSFER"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_CLASS = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-CLASS"
    DIAGNOSTIC_REQUEST_ON_BOARD_MONITORING_TEST_RESULTS = (
        "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS"
    )
    DIAGNOSTIC_REQUEST_ON_BOARD_MONITORING_TEST_RESULTS_CLASS = (
        "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS-CLASS"
    )
    DIAGNOSTIC_REQUEST_POWERTRAIN_FREEZE_FRAME_DATA = (
        "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA"
    )
    DIAGNOSTIC_REQUEST_POWERTRAIN_FREEZE_FRAME_DATA_CLASS = (
        "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA-CLASS"
    )
    DIAGNOSTIC_REQUEST_UPLOAD = "DIAGNOSTIC-REQUEST-UPLOAD"
    DIAGNOSTIC_REQUEST_UPLOAD_CLASS = "DIAGNOSTIC-REQUEST-UPLOAD-CLASS"
    DIAGNOSTIC_REQUEST_VEHICLE_INFO = "DIAGNOSTIC-REQUEST-VEHICLE-INFO"
    DIAGNOSTIC_REQUEST_VEHICLE_INFO_CLASS = "DIAGNOSTIC-REQUEST-VEHICLE-INFO-CLASS"
    DIAGNOSTIC_RESPONSE_ON_EVENT = "DIAGNOSTIC-RESPONSE-ON-EVENT"
    DIAGNOSTIC_RESPONSE_ON_EVENT_CLASS = "DIAGNOSTIC-RESPONSE-ON-EVENT-CLASS"
    DIAGNOSTIC_ROUTINE = "DIAGNOSTIC-ROUTINE"
    DIAGNOSTIC_ROUTINE_CONTROL = "DIAGNOSTIC-ROUTINE-CONTROL"
    DIAGNOSTIC_ROUTINE_CONTROL_CLASS = "DIAGNOSTIC-ROUTINE-CONTROL-CLASS"
    DIAGNOSTIC_SECURITY_ACCESS = "DIAGNOSTIC-SECURITY-ACCESS"
    DIAGNOSTIC_SECURITY_ACCESS_CLASS = "DIAGNOSTIC-SECURITY-ACCESS-CLASS"
    DIAGNOSTIC_SECURITY_EVENT_REPORTING_MODE_MAPPING = (
        "DIAGNOSTIC-SECURITY-EVENT-REPORTING-MODE-MAPPING"
    )
    DIAGNOSTIC_SECURITY_LEVEL = "DIAGNOSTIC-SECURITY-LEVEL"
    DIAGNOSTIC_SECURITY_LEVEL_PORT_MAPPING = "DIAGNOSTIC-SECURITY-LEVEL-PORT-MAPPING"
    DIAGNOSTIC_SERVICE_CLASS = "DIAGNOSTIC-SERVICE-CLASS"
    DIAGNOSTIC_SERVICE_DATA_MAPPING = "DIAGNOSTIC-SERVICE-DATA-MAPPING"
    DIAGNOSTIC_SERVICE_GENERIC_MAPPING = "DIAGNOSTIC-SERVICE-GENERIC-MAPPING"
    DIAGNOSTIC_SERVICE_INSTANCE = "DIAGNOSTIC-SERVICE-INSTANCE"
    DIAGNOSTIC_SERVICE_SW_MAPPING = "DIAGNOSTIC-SERVICE-SW-MAPPING"
    DIAGNOSTIC_SERVICE_TABLE = "DIAGNOSTIC-SERVICE-TABLE"
    DIAGNOSTIC_SERVICE_VALIDATION_MAPPING = "DIAGNOSTIC-SERVICE-VALIDATION-MAPPING"
    DIAGNOSTIC_SESSION = "DIAGNOSTIC-SESSION"
    DIAGNOSTIC_SESSION_CONTROL = "DIAGNOSTIC-SESSION-CONTROL"
    DIAGNOSTIC_SESSION_CONTROL_CLASS = "DIAGNOSTIC-SESSION-CONTROL-CLASS"
    DIAGNOSTIC_SOVD_AUTHORIZATION_PORT_MAPPING = "DIAGNOSTIC-SOVD-AUTHORIZATION-PORT-MAPPING"
    DIAGNOSTIC_SOVD_LOCK = "DIAGNOSTIC-SOVD-LOCK"
    DIAGNOSTIC_SOVD_PROXIMITY_CHALLENGE_PORT_MAPPING = (
        "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-PORT-MAPPING"
    )
    DIAGNOSTIC_STORAGE_CONDITION = "DIAGNOSTIC-STORAGE-CONDITION"
    DIAGNOSTIC_STORAGE_CONDITION_GROUP = "DIAGNOSTIC-STORAGE-CONDITION-GROUP"
    DIAGNOSTIC_STORAGE_CONDITION_PORT_MAPPING = "DIAGNOSTIC-STORAGE-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_SW_MAPPING = "DIAGNOSTIC-SW-MAPPING"
    DIAGNOSTIC_TEST_RESULT = "DIAGNOSTIC-TEST-RESULT"
    DIAGNOSTIC_TEST_ROUTINE_IDENTIFIER = "DIAGNOSTIC-TEST-ROUTINE-IDENTIFIER"
    DIAGNOSTIC_TRANSFER_EXIT = "DIAGNOSTIC-TRANSFER-EXIT"
    DIAGNOSTIC_TRANSFER_EXIT_CLASS = "DIAGNOSTIC-TRANSFER-EXIT-CLASS"
    DIAGNOSTIC_TROUBLE_CODE = "DIAGNOSTIC-TROUBLE-CODE"
    DIAGNOSTIC_TROUBLE_CODE_GROUP = "DIAGNOSTIC-TROUBLE-CODE-GROUP"
    DIAGNOSTIC_TROUBLE_CODE_J_1939 = "DIAGNOSTIC-TROUBLE-CODE-J-1939"
    DIAGNOSTIC_TROUBLE_CODE_OBD = "DIAGNOSTIC-TROUBLE-CODE-OBD"
    DIAGNOSTIC_TROUBLE_CODE_PROPS = "DIAGNOSTIC-TROUBLE-CODE-PROPS"
    DIAGNOSTIC_TROUBLE_CODE_UDS = "DIAGNOSTIC-TROUBLE-CODE-UDS"
    DIAGNOSTIC_TROUBLE_CODE_UDS_TO_CLEAR_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-TROUBLE-CODE-UDS-TO-CLEAR-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_TROUBLE_CODE_UDS_TO_TROUBLE_CODE_OBD_MAPPING = (
        "DIAGNOSTIC-TROUBLE-CODE-UDS-TO-TROUBLE-CODE-OBD-MAPPING"
    )
    DIAGNOSTIC_VERIFY_CERTIFICATE_BIDIRECTIONAL = "DIAGNOSTIC-VERIFY-CERTIFICATE-BIDIRECTIONAL"
    DIAGNOSTIC_VERIFY_CERTIFICATE_UNIDIRECTIONAL = "DIAGNOSTIC-VERIFY-CERTIFICATE-UNIDIRECTIONAL"
    DIAGNOSTIC_WRITE_DATA_BY_IDENTIFIER = "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_WRITE_DATA_BY_IDENTIFIER_CLASS = "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER-CLASS"
    DIAGNOSTIC_WRITE_MEMORY_BY_ADDRESS = "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_WRITE_MEMORY_BY_ADDRESS_CLASS = "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS-CLASS"


class DiagnosticCompareTypeEnumSimple(Enum):
    """
    :cvar IS_EQUAL: equal
    :cvar IS_GREATER_OR_EQUAL: greater than or equal
    :cvar IS_GREATER_THAN: greater than
    :cvar IS_LESS_OR_EQUAL: less than or equal
    :cvar IS_LESS_THAN: less than
    :cvar IS_NOT_EQUAL: not equal
    """

    IS_EQUAL = "IS-EQUAL"
    IS_GREATER_OR_EQUAL = "IS-GREATER-OR-EQUAL"
    IS_GREATER_THAN = "IS-GREATER-THAN"
    IS_LESS_OR_EQUAL = "IS-LESS-OR-EQUAL"
    IS_LESS_THAN = "IS-LESS-THAN"
    IS_NOT_EQUAL = "IS-NOT-EQUAL"


class DiagnosticConnectedIndicatorBehaviorEnumSimple(Enum):
    """
    :cvar BLINK_MODE: The indicator blinks when the event has status
        FAILED.
    :cvar BLINK_OR_CONTINUOUS_ON_MODE: The indicator is active and
        blinks when the event has status FAILED.
    :cvar CONTINUOUS_ON_MODE: The indicator is active when the event has
        status FAILED.
    :cvar FAST_FLASHING_MODE: Flash Indicator Lamp should be set to
        "Fast Flash".
    :cvar SLOW_FLASHING_MODE: Flash Indicator Lamp should be set to
        "Slow Flash".
    """

    BLINK_MODE = "BLINK-MODE"
    BLINK_OR_CONTINUOUS_ON_MODE = "BLINK-OR-CONTINUOUS-ON-MODE"
    CONTINUOUS_ON_MODE = "CONTINUOUS-ON-MODE"
    FAST_FLASHING_MODE = "FAST-FLASHING-MODE"
    SLOW_FLASHING_MODE = "SLOW-FLASHING-MODE"


class DiagnosticConnectionSubtypesEnum(Enum):
    DIAGNOSTIC_CONNECTION = "DIAGNOSTIC-CONNECTION"


class DiagnosticContributionSetSubtypesEnum(Enum):
    DIAGNOSTIC_CONTRIBUTION_SET = "DIAGNOSTIC-CONTRIBUTION-SET"


class DiagnosticControlDtcSettingClassSubtypesEnum(Enum):
    DIAGNOSTIC_CONTROL_DTC_SETTING_CLASS = "DIAGNOSTIC-CONTROL-DTC-SETTING-CLASS"


class DiagnosticCustomServiceClassSubtypesEnum(Enum):
    DIAGNOSTIC_CUSTOM_SERVICE_CLASS = "DIAGNOSTIC-CUSTOM-SERVICE-CLASS"


class DiagnosticDataCaptureEnumSimple(Enum):
    """
    :cvar CAPTURE_ASYNCHRONOUSLY_TO_REPORTING: This represents the
        intention to capture the environment data asynchronously after
        the actual capture API function terminated.
    :cvar CAPTURE_SYNCHRONOUSLY_TO_REPORTING: This represents the
        intention to capture the environment data synchronously within
        the capture API function.
    """

    CAPTURE_ASYNCHRONOUSLY_TO_REPORTING = "CAPTURE-ASYNCHRONOUSLY-TO-REPORTING"
    CAPTURE_SYNCHRONOUSLY_TO_REPORTING = "CAPTURE-SYNCHRONOUSLY-TO-REPORTING"


class DiagnosticDataElementSubtypesEnum(Enum):
    DIAGNOSTIC_DATA_ELEMENT = "DIAGNOSTIC-DATA-ELEMENT"


class DiagnosticDataIdentifierSubtypesEnum(Enum):
    DIAGNOSTIC_DATA_IDENTIFIER = "DIAGNOSTIC-DATA-IDENTIFIER"


class DiagnosticDataIdentifierSetSubtypesEnum(Enum):
    DIAGNOSTIC_DATA_IDENTIFIER_SET = "DIAGNOSTIC-DATA-IDENTIFIER-SET"


class DiagnosticDataTransferClassSubtypesEnum(Enum):
    DIAGNOSTIC_DATA_TRANSFER_CLASS = "DIAGNOSTIC-DATA-TRANSFER-CLASS"


class DiagnosticDebounceAlgorithmPropsSubtypesEnum(Enum):
    DIAGNOSTIC_DEBOUNCE_ALGORITHM_PROPS = "DIAGNOSTIC-DEBOUNCE-ALGORITHM-PROPS"


class DiagnosticDebounceBehaviorEnumSimple(Enum):
    """
    :cvar FREEZE: The event debounce counter will be frozen with the
        current value and will not change while a related enable
        condition is not fulfilled or ControlDTCSetting of the related
        event is disabled. After all related enable conditions are
        fulfilled and ControlDTCSetting of the related event is enabled
        again, the event qualification will continue with the next
        report of the event (i.e. SetEventStatus).
    :cvar RESET: The event debounce counter will be reset to initial
        value if a related enable condition is not fulfilled or
        ControlDTCSetting of the related event is disabled. The
        qualification of the event will be restarted with the next valid
        event report.
    """

    FREEZE = "FREEZE"
    RESET = "RESET"


class DiagnosticDenominatorConditionEnumSimple(Enum):
    """
    :cvar VALUE_500_MILES: Condition based on definition of 500miles
        conditions as defined for OBD2.
    :cvar COLDSTART: Condition based on definition of "cold start" as
        defined for EU5+
    :cvar CSERS: Conditions based on the "Cold start emission reduction
        strategy" denominator
    :cvar EVAP: Condition based on definition of "EVAP" conditions as
        defined for OBD2.
    :cvar INDIVIDUAL: condition based on definition of individual
        requirements.
    :cvar OBD: Condition based on definition of OBD requirements.
    """

    VALUE_500_MILES = "-500-MILES"
    COLDSTART = "COLDSTART"
    CSERS = "CSERS"
    EVAP = "EVAP"
    INDIVIDUAL = "INDIVIDUAL"
    OBD = "OBD"


class DiagnosticDynamicDataIdentifierSubtypesEnum(Enum):
    DIAGNOSTIC_DYNAMIC_DATA_IDENTIFIER = "DIAGNOSTIC-DYNAMIC-DATA-IDENTIFIER"


class DiagnosticDynamicallyDefineDataIdentifierClassSubtypesEnum(Enum):
    DIAGNOSTIC_DYNAMICALLY_DEFINE_DATA_IDENTIFIER_CLASS = (
        "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER-CLASS"
    )


class DiagnosticDynamicallyDefineDataIdentifierSubfunctionEnumSimple(Enum):
    """
    :cvar CLEAR_DYNAMICALLY_DEFINE_DATA_IDENTIFIER: Clear the specified
        dynamic data identifier.
    :cvar DEFINE_BY_IDENTIFIER: The definition of dynamic data
        identifier shall be done via a reference to a diagnostic data
        identifier.
    :cvar DEFINE_BY_MEMORY_ADDRESS: The definition of dynamic data
        identifier shall be done via a reference to a memory address.
    """

    CLEAR_DYNAMICALLY_DEFINE_DATA_IDENTIFIER = "CLEAR-DYNAMICALLY-DEFINE-DATA-IDENTIFIER"
    DEFINE_BY_IDENTIFIER = "DEFINE-BY-IDENTIFIER"
    DEFINE_BY_MEMORY_ADDRESS = "DEFINE-BY-MEMORY-ADDRESS"


class DiagnosticEcuResetClassSubtypesEnum(Enum):
    DIAGNOSTIC_ECU_RESET_CLASS = "DIAGNOSTIC-ECU-RESET-CLASS"


class DiagnosticEnableConditionSubtypesEnum(Enum):
    DIAGNOSTIC_ENABLE_CONDITION = "DIAGNOSTIC-ENABLE-CONDITION"


class DiagnosticEnableConditionGroupSubtypesEnum(Enum):
    DIAGNOSTIC_ENABLE_CONDITION_GROUP = "DIAGNOSTIC-ENABLE-CONDITION-GROUP"


class DiagnosticEnvModeElementSubtypesEnum(Enum):
    DIAGNOSTIC_ENV_BSW_MODE_ELEMENT = "DIAGNOSTIC-ENV-BSW-MODE-ELEMENT"
    DIAGNOSTIC_ENV_MODE_ELEMENT = "DIAGNOSTIC-ENV-MODE-ELEMENT"
    DIAGNOSTIC_ENV_SWC_MODE_ELEMENT = "DIAGNOSTIC-ENV-SWC-MODE-ELEMENT"


class DiagnosticEnvironmentalConditionSubtypesEnum(Enum):
    DIAGNOSTIC_ENVIRONMENTAL_CONDITION = "DIAGNOSTIC-ENVIRONMENTAL-CONDITION"


class DiagnosticEventSubtypesEnum(Enum):
    DIAGNOSTIC_EVENT = "DIAGNOSTIC-EVENT"


class DiagnosticEventClearAllowedEnumSimple(Enum):
    """
    :cvar ALWAYS: The clearing is allowed unconditionally.
    :cvar NEVER: The clearing is never allowed.
    :cvar REQUIRES_CALLBACK_EXECUTION: In case the clearing of a
        Diagnostic Event has to be allowed or prohibited through the SWC
        interface CallbackClearEventAllowed, the SWC has to indicate
        this by defining appropriate ServiceNeeds (i.e.
        DiagnosticEventNeeds).
    """

    ALWAYS = "ALWAYS"
    NEVER = "NEVER"
    REQUIRES_CALLBACK_EXECUTION = "REQUIRES-CALLBACK-EXECUTION"


class DiagnosticEventCombinationBehaviorEnumSimple(Enum):
    """
    :cvar EVENT_COMBINATION_ON_RETRIEVAL: Event combination on retrieval
        is used to combine events. For each event an individual event
        memory entry is created, while reporting the data via UDS, the
        data is combined.
    :cvar EVENT_COMBINATION_ON_STORAGE: Event combination on storage is
        used to combine events. Only one memory entry exists for each
        DTC which is also reported via UDS.
    """

    EVENT_COMBINATION_ON_RETRIEVAL = "EVENT-COMBINATION-ON-RETRIEVAL"
    EVENT_COMBINATION_ON_STORAGE = "EVENT-COMBINATION-ON-STORAGE"


class DiagnosticEventCombinationReportingBehaviorEnumSimple(Enum):
    """
    :cvar REPORTING_IN_CHRONLOGICAL_ORDER_OLDEST_FIRST: The reporting
        order for event combination on retrieval is the chronological
        storage order of the events
    """

    REPORTING_IN_CHRONLOGICAL_ORDER_OLDEST_FIRST = "REPORTING-IN-CHRONLOGICAL-ORDER-OLDEST-FIRST"


class DiagnosticEventDisplacementStrategyEnumSimple(Enum):
    """
    :cvar FULL: Event memory entry displacement is enabled, by
        consideration of priority active/passive status, and occurrence.
    :cvar NONE: Event memory entry displacement is disabled.
    :cvar PRIO_OCC: Event memory entry displacement is enabled, by
        consideration of priority and occurrence (but without
        active/passive status).
    """

    FULL = "FULL"
    NONE = "NONE"
    PRIO_OCC = "PRIO-OCC"


class DiagnosticEventKindEnumSimple(Enum):
    """
    :cvar BSW: The event is assigned to a BSW module.
    :cvar SWC: The event is assigned to a SWC.
    """

    BSW = "BSW"
    SWC = "SWC"


class DiagnosticEventNeedsSubtypesEnum(Enum):
    DIAGNOSTIC_EVENT_NEEDS = "DIAGNOSTIC-EVENT-NEEDS"


class DiagnosticEventWindowTimeEnumSimple(Enum):
    """
    :cvar EVENT_WINDOW_CURRENT_AND_FOLLOWING_CYCLE: This means that the
        window extends to this and the following cycle.
    :cvar EVENT_WINDOW_CURRENT_CYCLE: This means that the window extents
        without a border.
    :cvar EVENT_WINDOW_INFINITE: This means that the window extents
        without a border.
    :cvar INFINITE_TIME_TO_RESPONSE: This value specifies that the event
        window shall stay active for an infinite amount of time (e.g.
        open window until power off).
    :cvar POWER_WINDOW_TIME: This enumeration value specifies that the
        server shall send response on event messages until the server is
        powered down. The server stops sending response on event
        messages with the power down and will send no more response on
        event messages after server is up again.
    """

    EVENT_WINDOW_CURRENT_AND_FOLLOWING_CYCLE = "EVENT-WINDOW-CURRENT-AND-FOLLOWING-CYCLE"
    EVENT_WINDOW_CURRENT_CYCLE = "EVENT-WINDOW-CURRENT-CYCLE"
    EVENT_WINDOW_INFINITE = "EVENT-WINDOW-INFINITE"
    INFINITE_TIME_TO_RESPONSE = "INFINITE-TIME-TO-RESPONSE"
    POWER_WINDOW_TIME = "POWER-WINDOW-TIME"


class DiagnosticExtendedDataRecordSubtypesEnum(Enum):
    DIAGNOSTIC_EXTENDED_DATA_RECORD = "DIAGNOSTIC-EXTENDED-DATA-RECORD"


class DiagnosticFimAliasEventSubtypesEnum(Enum):
    DIAGNOSTIC_FIM_ALIAS_EVENT = "DIAGNOSTIC-FIM-ALIAS-EVENT"


class DiagnosticFimAliasEventGroupSubtypesEnum(Enum):
    DIAGNOSTIC_FIM_ALIAS_EVENT_GROUP = "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP"


class DiagnosticFimEventGroupSubtypesEnum(Enum):
    DIAGNOSTIC_FIM_EVENT_GROUP = "DIAGNOSTIC-FIM-EVENT-GROUP"


class DiagnosticFreezeFrameSubtypesEnum(Enum):
    DIAGNOSTIC_FREEZE_FRAME = "DIAGNOSTIC-FREEZE-FRAME"


class DiagnosticFunctionIdentifierSubtypesEnum(Enum):
    DIAGNOSTIC_FUNCTION_IDENTIFIER = "DIAGNOSTIC-FUNCTION-IDENTIFIER"


class DiagnosticFunctionInhibitSourceSubtypesEnum(Enum):
    DIAGNOSTIC_FUNCTION_INHIBIT_SOURCE = "DIAGNOSTIC-FUNCTION-INHIBIT-SOURCE"


class DiagnosticHandleDddiConfigurationEnumSimple(Enum):
    """
    :cvar NON_VOLATILE: This indicates that the configuration of
        DynamicallyDefineDataIdentifier shall be stored as non-volatile
        data.
    :cvar VOLATILE: This indicates that the configuration of
        DynamicallyDefineDataIdentifier shall be handled as volatile
        data.
    """

    NON_VOLATILE = "NON-VOLATILE"
    VOLATILE = "VOLATILE"


class DiagnosticIndicatorSubtypesEnum(Enum):
    DIAGNOSTIC_INDICATOR = "DIAGNOSTIC-INDICATOR"


class DiagnosticIndicatorTypeEnumSimple(Enum):
    """
    :cvar AMBER_WARNING: Amber Warning Lamp
    :cvar MALFUNCTION: Malfunction Indicator Lamp
    :cvar PROTECT_LAMP: Protect Lamp
    :cvar RED_STOP_LAMP: Red Stop Lamp
    :cvar WARNING: Warning
    """

    AMBER_WARNING = "AMBER-WARNING"
    MALFUNCTION = "MALFUNCTION"
    PROTECT_LAMP = "PROTECT-LAMP"
    RED_STOP_LAMP = "RED-STOP-LAMP"
    WARNING = "WARNING"


class DiagnosticInfoTypeSubtypesEnum(Enum):
    DIAGNOSTIC_INFO_TYPE = "DIAGNOSTIC-INFO-TYPE"


class DiagnosticInhibitionMaskEnumSimple(Enum):
    """
    :cvar LAST_FAILED: This represents the inhibition mask behavior
        "last failed".
    :cvar NOT_TESTED: This represents the inhibition mask behavior "not
        tested".
    :cvar TESTED: This represents the inhibition mask behavior "tested".
    :cvar TESTED_AND_FAILED: This represents the inhibition mask
        behavior "tested and failed".
    """

    LAST_FAILED = "LAST-FAILED"
    NOT_TESTED = "NOT-TESTED"
    TESTED = "TESTED"
    TESTED_AND_FAILED = "TESTED-AND-FAILED"


class DiagnosticInitialEventStatusEnumSimple(Enum):
    """
    :cvar RETURN_ON_EVENT_CLEARED: This means that the ResponseOnEvent
        is initially cleared.
    :cvar RETURN_ON_EVENT_STOPPED: This means that the ResponseOnEvent
        is initially stopped.
    """

    RETURN_ON_EVENT_CLEARED = "RETURN-ON-EVENT-CLEARED"
    RETURN_ON_EVENT_STOPPED = "RETURN-ON-EVENT-STOPPED"


class DiagnosticIoControlClassSubtypesEnum(Enum):
    DIAGNOSTIC_IO_CONTROL_CLASS = "DIAGNOSTIC-IO-CONTROL-CLASS"


class DiagnosticIumprSubtypesEnum(Enum):
    DIAGNOSTIC_IUMPR = "DIAGNOSTIC-IUMPR"


class DiagnosticIumprKindEnumSimple(Enum):
    """
    :cvar API_BASED: The calculation is based on the usage of an API.
    :cvar OBSERVER_BASED: The calculation is based on the usage of an
        observer.
    """

    API_BASED = "API-BASED"
    OBSERVER_BASED = "OBSERVER-BASED"


class DiagnosticJ1939NodeSubtypesEnum(Enum):
    DIAGNOSTIC_J_1939_NODE = "DIAGNOSTIC-J-1939-NODE"


class DiagnosticJ1939SpnSubtypesEnum(Enum):
    DIAGNOSTIC_J_1939_SPN = "DIAGNOSTIC-J-1939-SPN"


class DiagnosticJumpToBootLoaderEnumSimple(Enum):
    """
    :cvar NO_BOOT: This diagnostic session doesn't allow to jump to
        Bootloader.
    :cvar OEM_BOOT: This diagnostic session allows to jump to OEM
        Bootloader. In this case the bootloader send the final response.
    :cvar OEM_BOOT_RESP_APP: This diagnostic session allows to jump to
        OEM Bootloader and application sends final response.
    :cvar SYSTEM_SUPPLIER_BOOT: This diagnostic session allows to jump
        to System Supplier Bootloader.  In this case the bootloader send
        the final response.
    :cvar SYSTEM_SUPPLIER_BOOT_RESP_APP: This diagnostic session allows
        to jump to System Supplier Bootloader and application sends
        final response.
    """

    NO_BOOT = "NO-BOOT"
    OEM_BOOT = "OEM-BOOT"
    OEM_BOOT_RESP_APP = "OEM-BOOT-RESP-APP"
    SYSTEM_SUPPLIER_BOOT = "SYSTEM-SUPPLIER-BOOT"
    SYSTEM_SUPPLIER_BOOT_RESP_APP = "SYSTEM-SUPPLIER-BOOT-RESP-APP"


class DiagnosticLogicalOperatorEnumSimple(Enum):
    """
    :cvar LOGICAL_AND: Logical AND
    :cvar LOGICAL_OR: Logical OR
    """

    LOGICAL_AND = "LOGICAL-AND"
    LOGICAL_OR = "LOGICAL-OR"


class DiagnosticMeasurementIdentifierSubtypesEnum(Enum):
    DIAGNOSTIC_MEASUREMENT_IDENTIFIER = "DIAGNOSTIC-MEASUREMENT-IDENTIFIER"


class DiagnosticMemoryDestinationSubtypesEnum(Enum):
    DIAGNOSTIC_MEMORY_DESTINATION = "DIAGNOSTIC-MEMORY-DESTINATION"
    DIAGNOSTIC_MEMORY_DESTINATION_MIRROR = "DIAGNOSTIC-MEMORY-DESTINATION-MIRROR"
    DIAGNOSTIC_MEMORY_DESTINATION_PRIMARY = "DIAGNOSTIC-MEMORY-DESTINATION-PRIMARY"
    DIAGNOSTIC_MEMORY_DESTINATION_USER_DEFINED = "DIAGNOSTIC-MEMORY-DESTINATION-USER-DEFINED"


class DiagnosticMemoryEntryStorageTriggerEnumSimple(Enum):
    """
    :cvar CONFIRMED: Status information of UDS DTC status bit 3
    :cvar FDC_THRESHOLD: Threshold to allocate an event memory entry and
        to capture the Freeze Frame.
    :cvar PENDING: Status information of UDS DTC status bit 2.
    :cvar TEST_FAILED: Status information of UDS DTC status bit 0.
    """

    CONFIRMED = "CONFIRMED"
    FDC_THRESHOLD = "FDC-THRESHOLD"
    PENDING = "PENDING"
    TEST_FAILED = "TEST-FAILED"


class DiagnosticMemoryIdentifierSubtypesEnum(Enum):
    DIAGNOSTIC_MEMORY_IDENTIFIER = "DIAGNOSTIC-MEMORY-IDENTIFIER"


class DiagnosticMonitorUpdateKindEnumSimple(Enum):
    """
    :cvar ALWAYS: Dem shall accept every update.
    :cvar STEADY: Dem shall only accept if debouncing is at the limit.
    """

    ALWAYS = "ALWAYS"
    STEADY = "STEADY"


class DiagnosticObdSupportEnumSimple(Enum):
    """
    :cvar MASTER_ECU: This represent the role "master ECU".
    :cvar NO_OBD_SUPPORT: This represents the ability to explicitly
        specify that no participation in OBD is foreseen.
    :cvar PRIMARY_ECU: This represents the role "primary ECU".
    :cvar SECONDARY_ECU: This represents the role "secondary ECU".
    """

    MASTER_ECU = "MASTER-ECU"
    NO_OBD_SUPPORT = "NO-OBD-SUPPORT"
    PRIMARY_ECU = "PRIMARY-ECU"
    SECONDARY_ECU = "SECONDARY-ECU"


class DiagnosticOccurrenceCounterProcessingEnumSimple(Enum):
    """
    :cvar CONFIRMED_DTC_BIT: The occurrence counter is incremented when
        TestFailed bit transitions from 0 to 1 if the fault confirmation
        was successful (ConfirmedDTC bit is already set).
    :cvar TEST_FAILED_BIT: The occurrence counter is incremented when
        TestFailed bit transitions from 0 to 1 (and the fault
        confirmation is not considered).
    """

    CONFIRMED_DTC_BIT = "CONFIRMED-DTC-BIT"
    TEST_FAILED_BIT = "TEST-FAILED-BIT"


class DiagnosticOperationCycleSubtypesEnum(Enum):
    DIAGNOSTIC_OPERATION_CYCLE = "DIAGNOSTIC-OPERATION-CYCLE"


class DiagnosticOperationCycleTypeEnumSimple(Enum):
    """
    :cvar IGNITION: Ignition ON / OFF cycle
    :cvar OBD_DRIVING_CYCLE: OBD Driving cycle
    :cvar OTHER: further operation cycle
    :cvar POWER: Power ON / OFF cycle
    :cvar TIME: Time based operation cycle
    :cvar WARMUP: OBD Warm up cycle
    """

    IGNITION = "IGNITION"
    OBD_DRIVING_CYCLE = "OBD-DRIVING-CYCLE"
    OTHER = "OTHER"
    POWER = "POWER"
    TIME = "TIME"
    WARMUP = "WARMUP"


class DiagnosticParameterElementSubtypesEnum(Enum):
    DIAGNOSTIC_PARAMETER_ELEMENT = "DIAGNOSTIC-PARAMETER-ELEMENT"


class DiagnosticParameterIdentSubtypesEnum(Enum):
    DIAGNOSTIC_PARAMETER_IDENT = "DIAGNOSTIC-PARAMETER-IDENT"


class DiagnosticParameterIdentifierSubtypesEnum(Enum):
    DIAGNOSTIC_PARAMETER_IDENTIFIER = "DIAGNOSTIC-PARAMETER-IDENTIFIER"


class DiagnosticPeriodicRateCategoryEnumSimple(Enum):
    """
    :cvar PERIODIC_RATE_FAST: This value represents a fast periodic
        rate.
    :cvar PERIODIC_RATE_MEDIUM: This value represents a medium periodic
        rate.
    :cvar PERIODIC_RATE_SLOW: This value represents a slow periodic
        rate.
    """

    PERIODIC_RATE_FAST = "PERIODIC-RATE-FAST"
    PERIODIC_RATE_MEDIUM = "PERIODIC-RATE-MEDIUM"
    PERIODIC_RATE_SLOW = "PERIODIC-RATE-SLOW"


class DiagnosticPowertrainFreezeFrameSubtypesEnum(Enum):
    DIAGNOSTIC_POWERTRAIN_FREEZE_FRAME = "DIAGNOSTIC-POWERTRAIN-FREEZE-FRAME"


class DiagnosticProcessingStyleEnumSimple(Enum):
    """
    :cvar PROCESSING_STYLE_ASYNCHRONOUS: The software-component
        processes the request in background but still the Dcm has to
        issue the call again to eventually obtain the result of the
        request.
    :cvar PROCESSING_STYLE_ASYNCHRONOUS_WITH_ERROR: The software-
        component processes the request in background but still the Dcm
        has to issue the call again to eventually obtain the result of
        the request or handle error code.
    :cvar PROCESSING_STYLE_SYNCHRONOUS: The software-component is
        supposed to react synchronously on the request.
    """

    PROCESSING_STYLE_ASYNCHRONOUS = "PROCESSING-STYLE-ASYNCHRONOUS"
    PROCESSING_STYLE_ASYNCHRONOUS_WITH_ERROR = "PROCESSING-STYLE-ASYNCHRONOUS-WITH-ERROR"
    PROCESSING_STYLE_SYNCHRONOUS = "PROCESSING-STYLE-SYNCHRONOUS"


class DiagnosticReadDataByIdentifierClassSubtypesEnum(Enum):
    DIAGNOSTIC_READ_DATA_BY_IDENTIFIER_CLASS = "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER-CLASS"


class DiagnosticReadDataByPeriodicIdClassSubtypesEnum(Enum):
    DIAGNOSTIC_READ_DATA_BY_PERIODIC_ID_CLASS = "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID-CLASS"


class DiagnosticReadDtcInformationClassSubtypesEnum(Enum):
    DIAGNOSTIC_READ_DTC_INFORMATION_CLASS = "DIAGNOSTIC-READ-DTC-INFORMATION-CLASS"


class DiagnosticReadMemoryByAddressClassSubtypesEnum(Enum):
    DIAGNOSTIC_READ_MEMORY_BY_ADDRESS_CLASS = "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS-CLASS"


class DiagnosticReadScalingDataByIdentifierClassSubtypesEnum(Enum):
    DIAGNOSTIC_READ_SCALING_DATA_BY_IDENTIFIER_CLASS = (
        "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER-CLASS"
    )


class DiagnosticRecordTriggerEnumSimple(Enum):
    """
    :cvar CONFIRMED: capture on "Confirmed"
    :cvar CUSTOM: implement custom capture
    :cvar FDC_THRESHOLD: capture on "FDC Threshold"
    :cvar PENDING: capture on "Pending"
    :cvar TEST_FAILED: capture on "Test Failed"
    :cvar TEST_FAILED_THIS_OPERATION_CYCLE: Test Failed This Operation
        Cycle.
    :cvar TEST_PASSED: Capture on testFailed bit transition 1 --&gt; 0.
    """

    CONFIRMED = "CONFIRMED"
    CUSTOM = "CUSTOM"
    FDC_THRESHOLD = "FDC-THRESHOLD"
    PENDING = "PENDING"
    TEST_FAILED = "TEST-FAILED"
    TEST_FAILED_THIS_OPERATION_CYCLE = "TEST-FAILED-THIS-OPERATION-CYCLE"
    TEST_PASSED = "TEST-PASSED"


class DiagnosticRequestControlOfOnBoardDeviceClassSubtypesEnum(Enum):
    DIAGNOSTIC_REQUEST_CONTROL_OF_ON_BOARD_DEVICE_CLASS = (
        "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE-CLASS"
    )


class DiagnosticRequestCurrentPowertrainDataClassSubtypesEnum(Enum):
    DIAGNOSTIC_REQUEST_CURRENT_POWERTRAIN_DATA_CLASS = (
        "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA-CLASS"
    )


class DiagnosticRequestDownloadClassSubtypesEnum(Enum):
    DIAGNOSTIC_REQUEST_DOWNLOAD_CLASS = "DIAGNOSTIC-REQUEST-DOWNLOAD-CLASS"


class DiagnosticRequestEmissionRelatedDtcClassSubtypesEnum(Enum):
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_CLASS = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-CLASS"


class DiagnosticRequestEmissionRelatedDtcPermanentStatusClassSubtypesEnum(Enum):
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_PERMANENT_STATUS_CLASS = (
        "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS-CLASS"
    )


class DiagnosticRequestFileTransferClassSubtypesEnum(Enum):
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_CLASS = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-CLASS"


class DiagnosticRequestOnBoardMonitoringTestResultsClassSubtypesEnum(Enum):
    DIAGNOSTIC_REQUEST_ON_BOARD_MONITORING_TEST_RESULTS_CLASS = (
        "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS-CLASS"
    )


class DiagnosticRequestPowertrainFreezeFrameDataClassSubtypesEnum(Enum):
    DIAGNOSTIC_REQUEST_POWERTRAIN_FREEZE_FRAME_DATA_CLASS = (
        "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA-CLASS"
    )


class DiagnosticRequestUploadClassSubtypesEnum(Enum):
    DIAGNOSTIC_REQUEST_UPLOAD_CLASS = "DIAGNOSTIC-REQUEST-UPLOAD-CLASS"


class DiagnosticRequestVehicleInfoClassSubtypesEnum(Enum):
    DIAGNOSTIC_REQUEST_VEHICLE_INFO_CLASS = "DIAGNOSTIC-REQUEST-VEHICLE-INFO-CLASS"


class DiagnosticResponseOnEventActionEnumSimple(Enum):
    """
    :cvar CLEAR: Clears the configured events.
    :cvar ON_CHANGE_OF_DATA_IDENTIFIER: Reports based on change of data
        identifier.
    :cvar ON_COMPARISON_OF_VALUES: Triggered if data condition is met
        (e.g. RPM over 5000 1/min).
    :cvar ON_DTC_STATUS_CHANGE: Reports based on change of DTC status.
    :cvar REPORT: Reports the activated events.
    :cvar REPORT_DTC_RECORD_INFORMATION_ON_DTC_STATUS_CHANGE: Reports
        the DTC record-related information based on a DTC status change.
        (Subfunction 0x09)
    :cvar REPORT_MOST_RECENT_DTC_ON_STATUS_CHANGE: Triggers the report
        of the most recent failed or confirmed DTC (Subfunction 0x08).
    :cvar START: Starts the response on event service.
    :cvar STOP: Stops the response on event service.
    """

    CLEAR = "CLEAR"
    ON_CHANGE_OF_DATA_IDENTIFIER = "ON-CHANGE-OF-DATA-IDENTIFIER"
    ON_COMPARISON_OF_VALUES = "ON-COMPARISON-OF-VALUES"
    ON_DTC_STATUS_CHANGE = "ON-DTC-STATUS-CHANGE"
    REPORT = "REPORT"
    REPORT_DTC_RECORD_INFORMATION_ON_DTC_STATUS_CHANGE = (
        "REPORT-DTC-RECORD-INFORMATION-ON-DTC-STATUS-CHANGE"
    )
    REPORT_MOST_RECENT_DTC_ON_STATUS_CHANGE = "REPORT-MOST-RECENT-DTC-ON-STATUS-CHANGE"
    START = "START"
    STOP = "STOP"


class DiagnosticResponseOnEventClassSubtypesEnum(Enum):
    DIAGNOSTIC_RESPONSE_ON_EVENT_CLASS = "DIAGNOSTIC-RESPONSE-ON-EVENT-CLASS"


class DiagnosticResponseToEcuResetEnumSimple(Enum):
    """
    :cvar RESPOND_AFTER_RESET: Answer to EcuReset service should come
        after the reset.
    :cvar RESPOND_BEFORE_RESET: Answer to EcuReset service should come
        before the reset.
    """

    RESPOND_AFTER_RESET = "RESPOND-AFTER-RESET"
    RESPOND_BEFORE_RESET = "RESPOND-BEFORE-RESET"


class DiagnosticRoutineSubtypesEnum(Enum):
    DIAGNOSTIC_ROUTINE = "DIAGNOSTIC-ROUTINE"


class DiagnosticRoutineControlClassSubtypesEnum(Enum):
    DIAGNOSTIC_ROUTINE_CONTROL_CLASS = "DIAGNOSTIC-ROUTINE-CONTROL-CLASS"


class DiagnosticRoutineSubfunctionSubtypesEnum(Enum):
    DIAGNOSTIC_REQUEST_ROUTINE_RESULTS = "DIAGNOSTIC-REQUEST-ROUTINE-RESULTS"
    DIAGNOSTIC_ROUTINE_SUBFUNCTION = "DIAGNOSTIC-ROUTINE-SUBFUNCTION"
    DIAGNOSTIC_START_ROUTINE = "DIAGNOSTIC-START-ROUTINE"
    DIAGNOSTIC_STOP_ROUTINE = "DIAGNOSTIC-STOP-ROUTINE"


class DiagnosticRoutineTypeEnumSimple(Enum):
    """
    :cvar ASYNCHRONOUS: This indicates that the diagnostic server is not
        blocked while the diagnostic routine is running.
    :cvar SYNCHRONOUS: This indicates that the diagnostic routine blocks
        the diagnostic server in the ECU while the routine is running.
    """

    ASYNCHRONOUS = "ASYNCHRONOUS"
    SYNCHRONOUS = "SYNCHRONOUS"


class DiagnosticSecurityAccessClassSubtypesEnum(Enum):
    DIAGNOSTIC_SECURITY_ACCESS_CLASS = "DIAGNOSTIC-SECURITY-ACCESS-CLASS"


class DiagnosticSecurityLevelSubtypesEnum(Enum):
    DIAGNOSTIC_SECURITY_LEVEL = "DIAGNOSTIC-SECURITY-LEVEL"


class DiagnosticServiceInstanceSubtypesEnum(Enum):
    DIAGNOSTIC_AUTHENTICATION = "DIAGNOSTIC-AUTHENTICATION"
    DIAGNOSTIC_AUTHENTICATION_CONFIGURATION = "DIAGNOSTIC-AUTHENTICATION-CONFIGURATION"
    DIAGNOSTIC_CLEAR_DIAGNOSTIC_INFORMATION = "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION"
    DIAGNOSTIC_CLEAR_RESET_EMISSION_RELATED_INFO = "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO"
    DIAGNOSTIC_COM_CONTROL = "DIAGNOSTIC-COM-CONTROL"
    DIAGNOSTIC_CONTROL_DTC_SETTING = "DIAGNOSTIC-CONTROL-DTC-SETTING"
    DIAGNOSTIC_CUSTOM_SERVICE_INSTANCE = "DIAGNOSTIC-CUSTOM-SERVICE-INSTANCE"
    DIAGNOSTIC_DATA_BY_IDENTIFIER = "DIAGNOSTIC-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_DATA_TRANSFER = "DIAGNOSTIC-DATA-TRANSFER"
    DIAGNOSTIC_DE_AUTHENTICATION = "DIAGNOSTIC-DE-AUTHENTICATION"
    DIAGNOSTIC_DYNAMICALLY_DEFINE_DATA_IDENTIFIER = "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER"
    DIAGNOSTIC_ECU_RESET = "DIAGNOSTIC-ECU-RESET"
    DIAGNOSTIC_IO_CONTROL = "DIAGNOSTIC-IO-CONTROL"
    DIAGNOSTIC_MEMORY_ADDRESSABLE_RANGE_ACCESS = "DIAGNOSTIC-MEMORY-ADDRESSABLE-RANGE-ACCESS"
    DIAGNOSTIC_MEMORY_BY_ADDRESS = "DIAGNOSTIC-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_PROOF_OF_OWNERSHIP = "DIAGNOSTIC-PROOF-OF-OWNERSHIP"
    DIAGNOSTIC_READ_DATA_BY_IDENTIFIER = "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_READ_DATA_BY_PERIODIC_ID = "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID"
    DIAGNOSTIC_READ_DTC_INFORMATION = "DIAGNOSTIC-READ-DTC-INFORMATION"
    DIAGNOSTIC_READ_MEMORY_BY_ADDRESS = "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_READ_SCALING_DATA_BY_IDENTIFIER = "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_REQUEST_CONTROL_OF_ON_BOARD_DEVICE = "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE"
    DIAGNOSTIC_REQUEST_CURRENT_POWERTRAIN_DATA = "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA"
    DIAGNOSTIC_REQUEST_DOWNLOAD = "DIAGNOSTIC-REQUEST-DOWNLOAD"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_PERMANENT_STATUS = (
        "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS"
    )
    DIAGNOSTIC_REQUEST_FILE_TRANSFER = "DIAGNOSTIC-REQUEST-FILE-TRANSFER"
    DIAGNOSTIC_REQUEST_ON_BOARD_MONITORING_TEST_RESULTS = (
        "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS"
    )
    DIAGNOSTIC_REQUEST_POWERTRAIN_FREEZE_FRAME_DATA = (
        "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA"
    )
    DIAGNOSTIC_REQUEST_UPLOAD = "DIAGNOSTIC-REQUEST-UPLOAD"
    DIAGNOSTIC_REQUEST_VEHICLE_INFO = "DIAGNOSTIC-REQUEST-VEHICLE-INFO"
    DIAGNOSTIC_RESPONSE_ON_EVENT = "DIAGNOSTIC-RESPONSE-ON-EVENT"
    DIAGNOSTIC_ROUTINE_CONTROL = "DIAGNOSTIC-ROUTINE-CONTROL"
    DIAGNOSTIC_SECURITY_ACCESS = "DIAGNOSTIC-SECURITY-ACCESS"
    DIAGNOSTIC_SERVICE_INSTANCE = "DIAGNOSTIC-SERVICE-INSTANCE"
    DIAGNOSTIC_SESSION_CONTROL = "DIAGNOSTIC-SESSION-CONTROL"
    DIAGNOSTIC_TRANSFER_EXIT = "DIAGNOSTIC-TRANSFER-EXIT"
    DIAGNOSTIC_VERIFY_CERTIFICATE_BIDIRECTIONAL = "DIAGNOSTIC-VERIFY-CERTIFICATE-BIDIRECTIONAL"
    DIAGNOSTIC_VERIFY_CERTIFICATE_UNIDIRECTIONAL = "DIAGNOSTIC-VERIFY-CERTIFICATE-UNIDIRECTIONAL"
    DIAGNOSTIC_WRITE_DATA_BY_IDENTIFIER = "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_WRITE_MEMORY_BY_ADDRESS = "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS"


class DiagnosticServiceRequestCallbackTypeEnumSimple(Enum):
    """
    :cvar REQUEST_CALLBACK_TYPE_MANUFACTURER: This represents the case
        that the usage of PortInterface ServiceRequestNotification has
        the characteristics of being used by a manufacturer.
    :cvar REQUEST_CALLBACK_TYPE_SUPPLIER: This represents the case that
        the usage of PortInterface ServiceRequestNotification has the
        characteristics of being used by a supplier.
    """

    REQUEST_CALLBACK_TYPE_MANUFACTURER = "REQUEST-CALLBACK-TYPE-MANUFACTURER"
    REQUEST_CALLBACK_TYPE_SUPPLIER = "REQUEST-CALLBACK-TYPE-SUPPLIER"


class DiagnosticServiceTableSubtypesEnum(Enum):
    DIAGNOSTIC_SERVICE_TABLE = "DIAGNOSTIC-SERVICE-TABLE"


class DiagnosticServiceValidationMappingSubtypesEnum(Enum):
    DIAGNOSTIC_SERVICE_VALIDATION_MAPPING = "DIAGNOSTIC-SERVICE-VALIDATION-MAPPING"


class DiagnosticSessionSubtypesEnum(Enum):
    DIAGNOSTIC_SESSION = "DIAGNOSTIC-SESSION"


class DiagnosticSessionControlClassSubtypesEnum(Enum):
    DIAGNOSTIC_SESSION_CONTROL_CLASS = "DIAGNOSTIC-SESSION-CONTROL-CLASS"


class DiagnosticSignificanceEnumSimple(Enum):
    """
    :cvar FAULT: Failure, which affects the component/ECU itself.
    :cvar OCCURENCE: Issue, which indicates additional information
        concerning insufficient system behavior.
    """

    FAULT = "FAULT"
    OCCURENCE = "OCCURENCE"


class DiagnosticSovdLockSubtypesEnum(Enum):
    DIAGNOSTIC_SOVD_LOCK = "DIAGNOSTIC-SOVD-LOCK"


class DiagnosticStatusBitHandlingTestFailedSinceLastClearEnumSimple(Enum):
    """
    :cvar STATUS_BIT_AGING_AND_DISPLACEMENT: The
        "TestFailedSinceLastClear" status bits are reset to 0, if aging
        or displacement applies.
    :cvar STATUS_BIT_NORMAL: Aging and displacement has no impact on the
        "TestFailedSinceLastClear" status bits.
    """

    STATUS_BIT_AGING_AND_DISPLACEMENT = "STATUS-BIT-AGING-AND-DISPLACEMENT"
    STATUS_BIT_NORMAL = "STATUS-BIT-NORMAL"


class DiagnosticStorageConditionSubtypesEnum(Enum):
    DIAGNOSTIC_STORAGE_CONDITION = "DIAGNOSTIC-STORAGE-CONDITION"


class DiagnosticStorageConditionGroupSubtypesEnum(Enum):
    DIAGNOSTIC_STORAGE_CONDITION_GROUP = "DIAGNOSTIC-STORAGE-CONDITION-GROUP"


class DiagnosticStoreEventSupportEnumSimple(Enum):
    """
    :cvar ALL: The server supports both, storing and not storing the
        event.
    :cvar NO_STORE_EVENT: The event terminates when the server is
        powered down.
    :cvar STORE_EVENT: The event is persisted over a power down cycle.
    """

    ALL = "ALL"
    NO_STORE_EVENT = "NO-STORE-EVENT"
    STORE_EVENT = "STORE-EVENT"


class DiagnosticTestResultSubtypesEnum(Enum):
    DIAGNOSTIC_TEST_RESULT = "DIAGNOSTIC-TEST-RESULT"


class DiagnosticTestResultUpdateEnumSimple(Enum):
    """
    :cvar ALWAYS: Any DTR result reported by the monitor is used by the
        Dem.
    :cvar STEADY: The Dem accepts reported DTRs only when the configured
        debouncing mechanism is stable at the FAIL or PASS limit.
    """

    ALWAYS = "ALWAYS"
    STEADY = "STEADY"


class DiagnosticTestRoutineIdentifierSubtypesEnum(Enum):
    DIAGNOSTIC_TEST_ROUTINE_IDENTIFIER = "DIAGNOSTIC-TEST-ROUTINE-IDENTIFIER"


class DiagnosticTransferExitClassSubtypesEnum(Enum):
    DIAGNOSTIC_TRANSFER_EXIT_CLASS = "DIAGNOSTIC-TRANSFER-EXIT-CLASS"


class DiagnosticTroubleCodeSubtypesEnum(Enum):
    DIAGNOSTIC_TROUBLE_CODE = "DIAGNOSTIC-TROUBLE-CODE"
    DIAGNOSTIC_TROUBLE_CODE_J_1939 = "DIAGNOSTIC-TROUBLE-CODE-J-1939"
    DIAGNOSTIC_TROUBLE_CODE_OBD = "DIAGNOSTIC-TROUBLE-CODE-OBD"
    DIAGNOSTIC_TROUBLE_CODE_UDS = "DIAGNOSTIC-TROUBLE-CODE-UDS"


class DiagnosticTroubleCodeJ1939SubtypesEnum(Enum):
    DIAGNOSTIC_TROUBLE_CODE_J_1939 = "DIAGNOSTIC-TROUBLE-CODE-J-1939"


class DiagnosticTroubleCodeJ1939DtcKindEnumSimple(Enum):
    """
    :cvar SERVICE_ONLY: this represents a DTC that is only relevant for
        service in a garage, reported by e.g. DM53.
    :cvar STANDARD: This represents a non-specific DTC reported by e.g.
        DM1.
    """

    SERVICE_ONLY = "SERVICE-ONLY"
    STANDARD = "STANDARD"


class DiagnosticTroubleCodeObdSubtypesEnum(Enum):
    DIAGNOSTIC_TROUBLE_CODE_OBD = "DIAGNOSTIC-TROUBLE-CODE-OBD"


class DiagnosticTroubleCodePropsSubtypesEnum(Enum):
    DIAGNOSTIC_TROUBLE_CODE_PROPS = "DIAGNOSTIC-TROUBLE-CODE-PROPS"


class DiagnosticTroubleCodeUdsSubtypesEnum(Enum):
    DIAGNOSTIC_TROUBLE_CODE_UDS = "DIAGNOSTIC-TROUBLE-CODE-UDS"


class DiagnosticTypeOfDtcSupportedEnumSimple(Enum):
    """
    :cvar ISO_11992_4: ISO11992-4 DTC format
    :cvar ISO_14229_1: ISO14229-1 DTC format (3 byte format)
    :cvar ISO_15031_6: ISO15031-6 DTC format (2 byte format)
    :cvar SAE_J_1939_73: SAEJ1939-73 DTC format
    :cvar SAE_J_2012_DA: SAE_J2012-DA_DTCFormat_00 (3 byte format)
    """

    ISO_11992_4 = "ISO-11992--4"
    ISO_14229_1 = "ISO-14229--1"
    ISO_15031_6 = "ISO-15031--6"
    SAE_J_1939_73 = "SAE-J-1939--73"
    SAE_J_2012_DA = "SAE-J-2012--DA"


class DiagnosticTypeOfFreezeFrameRecordNumerationEnumSimple(Enum):
    """
    :cvar CALCULATED: Freeze frame records will be numbered consecutive
        starting by 1 in their chronological order.
    :cvar CONFIGURED: Freeze frame records will be numbered based on the
        given configuration in their chronological order.
    """

    CALCULATED = "CALCULATED"
    CONFIGURED = "CONFIGURED"


class DiagnosticUdsSeverityEnumSimple(Enum):
    """
    :cvar CHECK_AT_NEXT_HALT: Check at next halt.
    :cvar IMMEDIATELY: Check immediately.
    :cvar MAINTENANCE_ONLY: Maintenance required.
    :cvar NO_SEVERITY: No severity information available.
    """

    CHECK_AT_NEXT_HALT = "CHECK-AT-NEXT-HALT"
    IMMEDIATELY = "IMMEDIATELY"
    MAINTENANCE_ONLY = "MAINTENANCE-ONLY"
    NO_SEVERITY = "NO-SEVERITY"


class DiagnosticValueAccessEnumSimple(Enum):
    """
    :cvar READ_ONLY: The access to the data element is limited to read-
        only. This is typically used to read-out diagnostic information
        (e.g. current values).
    :cvar READ_WRITE: The value of the diagnostic data element is
        classified as configurable (read and write access is possible).
    :cvar WRITE_ONLY: The access to the data element is limited to
        write-only. This supports the use case where the Dcm just writes
        data to the application software without the intention to read
        it back,
    """

    READ_ONLY = "READ-ONLY"
    READ_WRITE = "READ-WRITE"
    WRITE_ONLY = "WRITE-ONLY"


class DiagnosticValueNeedsSubtypesEnum(Enum):
    DIAGNOSTIC_VALUE_NEEDS = "DIAGNOSTIC-VALUE-NEEDS"


class DiagnosticWriteDataByIdentifierClassSubtypesEnum(Enum):
    DIAGNOSTIC_WRITE_DATA_BY_IDENTIFIER_CLASS = "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER-CLASS"


class DiagnosticWriteMemoryByAddressClassSubtypesEnum(Enum):
    DIAGNOSTIC_WRITE_MEMORY_BY_ADDRESS_CLASS = "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS-CLASS"


class DiagnosticWwhObdDtcClassEnumSimple(Enum):
    """
    :cvar DEM_DTC_WWH_OBD_CLASS_A: This attribute represents the
        severity class A.
    :cvar DEM_DTC_WWH_OBD_CLASS_B_1: This attribute represents the
        severity class B1.
    :cvar DEM_DTC_WWH_OBD_CLASS_B_2: This attribute represents the
        severity class B2.
    :cvar DEM_DTC_WWH_OBD_CLASS_C: This attribute represents the
        severity class C.
    :cvar DEM_DTC_WWH_OBD_CLASS_NO_INFORMATION: This attribute
        represents the option to intentionally not describe a dedicated
        severity class of an WWH-OBD DTC.
    """

    DEM_DTC_WWH_OBD_CLASS_A = "DEM-DTC-WWH-OBD-CLASS-A"
    DEM_DTC_WWH_OBD_CLASS_B_1 = "DEM-DTC-WWH-OBD-CLASS-B-1"
    DEM_DTC_WWH_OBD_CLASS_B_2 = "DEM-DTC-WWH-OBD-CLASS-B-2"
    DEM_DTC_WWH_OBD_CLASS_C = "DEM-DTC-WWH-OBD-CLASS-C"
    DEM_DTC_WWH_OBD_CLASS_NO_INFORMATION = "DEM-DTC-WWH-OBD-CLASS-NO-INFORMATION"


class DiscoveryTechnologyEnumSimple(Enum):
    """
    :cvar BONJOUR: Bonjour Service Discovery
    :cvar DLNA: DLNA UPnP Device Control Protocol Framework
    :cvar SLP: Service Location Protocol
    :cvar SOMEIP: Header format to be used with Remote Procedure Call
        (RPC) Messages in Client/Server-Communication as well as
        Sender/Receiver Messages.
    :cvar SSDP: Simple Service Discovery Protocol (SSDP)
    """

    BONJOUR = "BONJOUR"
    DLNA = "DLNA"
    SLP = "SLP"
    SOMEIP = "SOMEIP"
    SSDP = "SSDP"


@dataclass(slots=True, kw_only=True)
class DisplayFormatString:
    """This is a display format specifier for the display of values  e.g. in
    documents or in measurement and calibration systems.

    The display format specifier is a subset of the ANSI C printf specifiers with the following
    form:
    % [flags] [width] [.prec] type character
    Due to the numerical nature of value settings, only the following type characters are allowed:
    * d:  Signed decimal integer
    * i:  Signed decimal integer
    * o:  Unsigned octal integer
    * u:  Unsigned decimal integer
    * x:  Unsigned hexadecimal integer, using "abcdef"
    * X:  Unsigned hexadecimal integer, using "ABCDEF"
    * e:  Signed value having the form [-]d.dddd e [sign]ddd where d is a single decimal digit, dddd is one or more decimal digits, ddd is exactly three decimal digits, and sign is + or -
    * E:  Identical to the e format except that E rather than e introduces the exponent
    * f:  Signed value having the form [-]dddd.dddd, where dddd is one or more decimal digits; the number of digits before the decimal point depends on the magnitude of the number, and the number of digits after the decimal point depends on the requested precision
    * g:  Signed value printed in f or e format, whichever is more compact for the given value and precision; trailing zeros are truncated, and the decimal point appears only if one or more digits follow it
    * G:  Identical to the g format, except that E, rather than e, introduces the exponent (where appropriate)
    * b: binary number without prefix or suffix, e.g. 110
    * B: binary number with suffix capital B, e.g. 110B

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DISPLAY-FORMAT-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"%[ \-+#]?[0-9]*(\.[0-9]+)?[bBdiouxXfeEgGcs]",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class DisplayPresentationEnumSimple(Enum):
    """
    :cvar PRESENTATION_CONTINUOUS: The presentation of data shall form a
        continuous graph between data points.
    :cvar PRESENTATION_DISCRETE: The presentation of data shall be step-
        shaped between data points.
    """

    PRESENTATION_CONTINUOUS = "PRESENTATION-CONTINUOUS"
    PRESENTATION_DISCRETE = "PRESENTATION-DISCRETE"


class DltApplicationSubtypesEnum(Enum):
    DLT_APPLICATION = "DLT-APPLICATION"


class DltContextSubtypesEnum(Enum):
    DLT_CONTEXT = "DLT-CONTEXT"


class DltDefaultTraceStateEnumSimple(Enum):
    """
    :cvar DEFAULT_TRACE_STATE_DISABLED: The default trace state is
        disabled
    :cvar DEFAULT_TRACE_STATE_ENABLED: The default trace state is
        enabled
    """

    DEFAULT_TRACE_STATE_DISABLED = "DEFAULT-TRACE-STATE-DISABLED"
    DEFAULT_TRACE_STATE_ENABLED = "DEFAULT-TRACE-STATE-ENABLED"


class DltEcuSubtypesEnum(Enum):
    DLT_ECU = "DLT-ECU"


class DltLogSinkSubtypesEnum(Enum):
    DLT_LOG_SINK = "DLT-LOG-SINK"


class DltMessageSubtypesEnum(Enum):
    DLT_MESSAGE = "DLT-MESSAGE"


class DoIpEidRetrievalEnumSimple(Enum):
    """
    :cvar EID_USE_API: API DiagnosticDoIPEntityIdentification is used to
        retrieve eid
    :cvar EID_USE_CONFIG_VALUE: eid is configured manually by
        DoIpInstantiation.eid
    :cvar EID_USE_MAC: MAC of the network interface is used as eid
    """

    EID_USE_API = "EID-USE-API"
    EID_USE_CONFIG_VALUE = "EID-USE-CONFIG-VALUE"
    EID_USE_MAC = "EID-USE-MAC"


class DoIpEntityRoleEnumSimple(Enum):
    """
    :cvar EDGE_NODE: Network node is a DoIP gateway that accepts
        external connections.
    :cvar GATEWAY: Network node is a Gateway between the DoIP network
        and other networks.
    :cvar NODE: Network node is a DoIp node.
    """

    EDGE_NODE = "EDGE-NODE"
    GATEWAY = "GATEWAY"
    NODE = "NODE"


class DoIpLogicAddressSubtypesEnum(Enum):
    DO_IP_LOGIC_ADDRESS = "DO-IP-LOGIC-ADDRESS"


class DoIpLogicTargetAddressPropsSubtypesEnum(Enum):
    DO_IP_LOGIC_TARGET_ADDRESS_PROPS = "DO-IP-LOGIC-TARGET-ADDRESS-PROPS"


class DoIpRoutingActivationSubtypesEnum(Enum):
    DO_IP_ROUTING_ACTIVATION = "DO-IP-ROUTING-ACTIVATION"


class DoIpTpConfigSubtypesEnum(Enum):
    DO_IP_TP_CONFIG = "DO-IP-TP-CONFIG"


class DocumentationSubtypesEnum(Enum):
    DOCUMENTATION = "DOCUMENTATION"


class DtcFormatTypeEnumSimple(Enum):
    """
    :cvar J_1939: Defines the J1939 DTC format.
    :cvar OBD: Defines the OBD DTC format.
    :cvar UDS: Defines the UDS DTC format.
    """

    J_1939 = "J-1939"
    OBD = "OBD"
    UDS = "UDS"


class DtcKindEnumSimple(Enum):
    """
    :cvar EMISSION_RELATED_DTC: This indicates that the monitor reports
        a OBD-relevant malfunction.
    :cvar NON_EMMISSION_RELATED_DTC: This indicates that the monitor
        reports a non-OBD-relevant malfunction.
    """

    EMISSION_RELATED_DTC = "EMISSION-RELATED-DTC"
    NON_EMMISSION_RELATED_DTC = "NON-EMMISSION-RELATED-DTC"


class E2EProfileCompatibilityPropsSubtypesEnum(Enum):
    E_2_E_PROFILE_COMPATIBILITY_PROPS = "E-2-E-PROFILE-COMPATIBILITY-PROPS"


class E2EProfileConfigurationSubtypesEnum(Enum):
    E_2_E_PROFILE_CONFIGURATION = "E-2-E-PROFILE-CONFIGURATION"


class EEnumSimple(Enum):
    """
    :cvar BOLD: The emphasis is preferably represented in boldface font.
    :cvar BOLDITALIC: The emphasis is preferably represented in boldface
        plus italic font.
    :cvar ITALIC: The emphasis is preferably represented in italic font.
    :cvar PLAIN: The emphasis has no specific rendering. It is used if
        e.g. semantic information is applied to the emphasis text.
    """

    BOLD = "BOLD"
    BOLDITALIC = "BOLDITALIC"
    ITALIC = "ITALIC"
    PLAIN = "PLAIN"


class EEnumFontSimple(Enum):
    """
    :cvar DEFAULT: The emphasis uses the default font.
    :cvar MONO: The emphasis uses a monospaced font.
    """

    DEFAULT = "DEFAULT"
    MONO = "MONO"


class EcuInstanceSubtypesEnum(Enum):
    ECU_INSTANCE = "ECU-INSTANCE"


class EcuPartitionSubtypesEnum(Enum):
    ECU_PARTITION = "ECU-PARTITION"


class EcucAbstractReferenceDefSubtypesEnum(Enum):
    ECUC_ABSTRACT_EXTERNAL_REFERENCE_DEF = "ECUC-ABSTRACT-EXTERNAL-REFERENCE-DEF"
    ECUC_ABSTRACT_INTERNAL_REFERENCE_DEF = "ECUC-ABSTRACT-INTERNAL-REFERENCE-DEF"
    ECUC_ABSTRACT_REFERENCE_DEF = "ECUC-ABSTRACT-REFERENCE-DEF"
    ECUC_CHOICE_REFERENCE_DEF = "ECUC-CHOICE-REFERENCE-DEF"
    ECUC_FOREIGN_REFERENCE_DEF = "ECUC-FOREIGN-REFERENCE-DEF"
    ECUC_INSTANCE_REFERENCE_DEF = "ECUC-INSTANCE-REFERENCE-DEF"
    ECUC_REFERENCE_DEF = "ECUC-REFERENCE-DEF"
    ECUC_SYMBOLIC_NAME_REFERENCE_DEF = "ECUC-SYMBOLIC-NAME-REFERENCE-DEF"
    ECUC_URI_REFERENCE_DEF = "ECUC-URI-REFERENCE-DEF"


class EcucAffectionEnumSimple(Enum):
    """
    :cvar LT_AFFECTS_PB: A link time parameter affecting one or several
        post-build time parameter(s).
    :cvar NO_AFFECT: no affect on any other parameter.
    :cvar PC_AFFECTS_LT: A pre-compile time parameter affecting one or
        several link time parameter(s).
    :cvar PC_AFFECTS_LT_AND_PB: A pre-compile time parameter affecting
        one or several link time and post-build time parameter(s)).
    :cvar PC_AFFECTS_PB: A pre-compile time parameter affecting one or
        several post build time parameter(s).
    """

    LT_AFFECTS_PB = "LT-AFFECTS-PB"
    NO_AFFECT = "NO-AFFECT"
    PC_AFFECTS_LT = "PC-AFFECTS-LT"
    PC_AFFECTS_LT_AND_PB = "PC-AFFECTS-LT-AND-PB"
    PC_AFFECTS_PB = "PC-AFFECTS-PB"


class EcucCommonAttributesSubtypesEnum(Enum):
    ECUC_ABSTRACT_EXTERNAL_REFERENCE_DEF = "ECUC-ABSTRACT-EXTERNAL-REFERENCE-DEF"
    ECUC_ABSTRACT_INTERNAL_REFERENCE_DEF = "ECUC-ABSTRACT-INTERNAL-REFERENCE-DEF"
    ECUC_ABSTRACT_REFERENCE_DEF = "ECUC-ABSTRACT-REFERENCE-DEF"
    ECUC_ABSTRACT_STRING_PARAM_DEF = "ECUC-ABSTRACT-STRING-PARAM-DEF"
    ECUC_ADD_INFO_PARAM_DEF = "ECUC-ADD-INFO-PARAM-DEF"
    ECUC_BOOLEAN_PARAM_DEF = "ECUC-BOOLEAN-PARAM-DEF"
    ECUC_CHOICE_REFERENCE_DEF = "ECUC-CHOICE-REFERENCE-DEF"
    ECUC_COMMON_ATTRIBUTES = "ECUC-COMMON-ATTRIBUTES"
    ECUC_ENUMERATION_PARAM_DEF = "ECUC-ENUMERATION-PARAM-DEF"
    ECUC_FLOAT_PARAM_DEF = "ECUC-FLOAT-PARAM-DEF"
    ECUC_FOREIGN_REFERENCE_DEF = "ECUC-FOREIGN-REFERENCE-DEF"
    ECUC_FUNCTION_NAME_DEF = "ECUC-FUNCTION-NAME-DEF"
    ECUC_INSTANCE_REFERENCE_DEF = "ECUC-INSTANCE-REFERENCE-DEF"
    ECUC_INTEGER_PARAM_DEF = "ECUC-INTEGER-PARAM-DEF"
    ECUC_LINKER_SYMBOL_DEF = "ECUC-LINKER-SYMBOL-DEF"
    ECUC_MULTILINE_STRING_PARAM_DEF = "ECUC-MULTILINE-STRING-PARAM-DEF"
    ECUC_PARAMETER_DEF = "ECUC-PARAMETER-DEF"
    ECUC_REFERENCE_DEF = "ECUC-REFERENCE-DEF"
    ECUC_STRING_PARAM_DEF = "ECUC-STRING-PARAM-DEF"
    ECUC_SYMBOLIC_NAME_REFERENCE_DEF = "ECUC-SYMBOLIC-NAME-REFERENCE-DEF"
    ECUC_URI_REFERENCE_DEF = "ECUC-URI-REFERENCE-DEF"


class EcucConfigurationClassEnumSimple(Enum):
    """
    :cvar LINK: Link Time: parts of configuration are delivered from
        another object code file
    :cvar POST_BUILD: PostBuildTime: after compilation a configuration
        parameter can be changed.
    :cvar PRE_COMPILE: PreCompile Time: after compilation a
        configuration parameter can not be changed any more.
    :cvar PUBLISHED_INFORMATION: PublishedInformation is used to specify
        the fact that certain information is fixed even before the pre-
        compile stage.
    """

    LINK = "LINK"
    POST_BUILD = "POST-BUILD"
    PRE_COMPILE = "PRE-COMPILE"
    PUBLISHED_INFORMATION = "PUBLISHED-INFORMATION"


class EcucConfigurationVariantEnumSimple(Enum):
    """
    :cvar PRECONFIGURED_CONFIGURATION: Preconfigured (i.e. fixed)
        configuration which cannot be changed.
    :cvar RECOMMENDED_CONFIGURATION: Recommended configuration for a
        module.
    :cvar VARIANT_LINK_TIME: Specifies that the BSW Module
        implementation may use PreCompileTime and LinkTime configuration
        parameters.
    :cvar VARIANT_POST_BUILD: Specifies that the BSW Module
        implementation may use PreCompileTime, LinkTime and PostBuild
        configuration parameters.
    :cvar VARIANT_POST_BUILD_LOADABLE: Specifies that the BSW Module
        implementation may use PreCompileTime, LinkTime and PostBuild
        loadable configuration parameters (supported in the VSMD). This
        attribute is removed from the specifications and shall not be
        used.
    :cvar VARIANT_POST_BUILD_SELECTABLE: Specifies that the BSW Module
        implementation may use PreCompileTime, LinkTime and PostBuild
        selectable configuration parameters (supported in the VSMD).
        This attribute is removed from the specifications and shall not
        be used.
    :cvar VARIANT_PRE_COMPILE: Specifies that the BSW Module
        implementation uses only PreCompileTime configuration
        parameters.
    """

    PRECONFIGURED_CONFIGURATION = "PRECONFIGURED-CONFIGURATION"
    RECOMMENDED_CONFIGURATION = "RECOMMENDED-CONFIGURATION"
    VARIANT_LINK_TIME = "VARIANT-LINK-TIME"
    VARIANT_POST_BUILD = "VARIANT-POST-BUILD"
    VARIANT_POST_BUILD_LOADABLE = "VARIANT-POST-BUILD-LOADABLE"
    VARIANT_POST_BUILD_SELECTABLE = "VARIANT-POST-BUILD-SELECTABLE"
    VARIANT_PRE_COMPILE = "VARIANT-PRE-COMPILE"


class EcucContainerDefSubtypesEnum(Enum):
    ECUC_CHOICE_CONTAINER_DEF = "ECUC-CHOICE-CONTAINER-DEF"
    ECUC_CONTAINER_DEF = "ECUC-CONTAINER-DEF"
    ECUC_PARAM_CONF_CONTAINER_DEF = "ECUC-PARAM-CONF-CONTAINER-DEF"


class EcucContainerValueSubtypesEnum(Enum):
    ECUC_CONTAINER_VALUE = "ECUC-CONTAINER-VALUE"


class EcucDefinitionElementSubtypesEnum(Enum):
    ECUC_ABSTRACT_EXTERNAL_REFERENCE_DEF = "ECUC-ABSTRACT-EXTERNAL-REFERENCE-DEF"
    ECUC_ABSTRACT_INTERNAL_REFERENCE_DEF = "ECUC-ABSTRACT-INTERNAL-REFERENCE-DEF"
    ECUC_ABSTRACT_REFERENCE_DEF = "ECUC-ABSTRACT-REFERENCE-DEF"
    ECUC_ABSTRACT_STRING_PARAM_DEF = "ECUC-ABSTRACT-STRING-PARAM-DEF"
    ECUC_ADD_INFO_PARAM_DEF = "ECUC-ADD-INFO-PARAM-DEF"
    ECUC_BOOLEAN_PARAM_DEF = "ECUC-BOOLEAN-PARAM-DEF"
    ECUC_CHOICE_CONTAINER_DEF = "ECUC-CHOICE-CONTAINER-DEF"
    ECUC_CHOICE_REFERENCE_DEF = "ECUC-CHOICE-REFERENCE-DEF"
    ECUC_COMMON_ATTRIBUTES = "ECUC-COMMON-ATTRIBUTES"
    ECUC_CONTAINER_DEF = "ECUC-CONTAINER-DEF"
    ECUC_DEFINITION_ELEMENT = "ECUC-DEFINITION-ELEMENT"
    ECUC_ENUMERATION_PARAM_DEF = "ECUC-ENUMERATION-PARAM-DEF"
    ECUC_FLOAT_PARAM_DEF = "ECUC-FLOAT-PARAM-DEF"
    ECUC_FOREIGN_REFERENCE_DEF = "ECUC-FOREIGN-REFERENCE-DEF"
    ECUC_FUNCTION_NAME_DEF = "ECUC-FUNCTION-NAME-DEF"
    ECUC_INSTANCE_REFERENCE_DEF = "ECUC-INSTANCE-REFERENCE-DEF"
    ECUC_INTEGER_PARAM_DEF = "ECUC-INTEGER-PARAM-DEF"
    ECUC_LINKER_SYMBOL_DEF = "ECUC-LINKER-SYMBOL-DEF"
    ECUC_MODULE_DEF = "ECUC-MODULE-DEF"
    ECUC_MULTILINE_STRING_PARAM_DEF = "ECUC-MULTILINE-STRING-PARAM-DEF"
    ECUC_PARAM_CONF_CONTAINER_DEF = "ECUC-PARAM-CONF-CONTAINER-DEF"
    ECUC_PARAMETER_DEF = "ECUC-PARAMETER-DEF"
    ECUC_REFERENCE_DEF = "ECUC-REFERENCE-DEF"
    ECUC_STRING_PARAM_DEF = "ECUC-STRING-PARAM-DEF"
    ECUC_SYMBOLIC_NAME_REFERENCE_DEF = "ECUC-SYMBOLIC-NAME-REFERENCE-DEF"
    ECUC_URI_REFERENCE_DEF = "ECUC-URI-REFERENCE-DEF"


class EcucDestinationUriDefSubtypesEnum(Enum):
    ECUC_DESTINATION_URI_DEF = "ECUC-DESTINATION-URI-DEF"


class EcucDestinationUriNestingContractEnumSimple(Enum):
    """
    :cvar LEAF_OF_TARGET_CONTAINER: EcucDestinationUriPolicy describes
        elements (subContainers, Parameters, References) that are
        directly owned by the target container.
    :cvar TARGET_CONTAINER: EcucDestinationUriPolicy describes the
        target container of EcucUriReferenceDef.
    :cvar VERTEX_OF_TARGET_CONTAINER: EcucDestinationUriPolicy describes
        elements (subContainers, Parameters, References) of the target
        container which can be defined in arbitrary nested subContainer
        structure.
    """

    LEAF_OF_TARGET_CONTAINER = "LEAF-OF-TARGET-CONTAINER"
    TARGET_CONTAINER = "TARGET-CONTAINER"
    VERTEX_OF_TARGET_CONTAINER = "VERTEX-OF-TARGET-CONTAINER"


class EcucModuleConfigurationValuesSubtypesEnum(Enum):
    ECUC_MODULE_CONFIGURATION_VALUES = "ECUC-MODULE-CONFIGURATION-VALUES"


class EcucModuleDefSubtypesEnum(Enum):
    ECUC_MODULE_DEF = "ECUC-MODULE-DEF"


class EcucParamConfContainerDefSubtypesEnum(Enum):
    ECUC_PARAM_CONF_CONTAINER_DEF = "ECUC-PARAM-CONF-CONTAINER-DEF"


class EcucParameterDefSubtypesEnum(Enum):
    ECUC_ABSTRACT_STRING_PARAM_DEF = "ECUC-ABSTRACT-STRING-PARAM-DEF"
    ECUC_ADD_INFO_PARAM_DEF = "ECUC-ADD-INFO-PARAM-DEF"
    ECUC_BOOLEAN_PARAM_DEF = "ECUC-BOOLEAN-PARAM-DEF"
    ECUC_ENUMERATION_PARAM_DEF = "ECUC-ENUMERATION-PARAM-DEF"
    ECUC_FLOAT_PARAM_DEF = "ECUC-FLOAT-PARAM-DEF"
    ECUC_FUNCTION_NAME_DEF = "ECUC-FUNCTION-NAME-DEF"
    ECUC_INTEGER_PARAM_DEF = "ECUC-INTEGER-PARAM-DEF"
    ECUC_LINKER_SYMBOL_DEF = "ECUC-LINKER-SYMBOL-DEF"
    ECUC_MULTILINE_STRING_PARAM_DEF = "ECUC-MULTILINE-STRING-PARAM-DEF"
    ECUC_PARAMETER_DEF = "ECUC-PARAMETER-DEF"
    ECUC_STRING_PARAM_DEF = "ECUC-STRING-PARAM-DEF"


class EcucQuerySubtypesEnum(Enum):
    ECUC_QUERY = "ECUC-QUERY"


class EcucScopeEnumSimple(Enum):
    """
    :cvar ECU: An element may be shared with other modules.
    :cvar LOCAL: An element is only be applicable for the module it is
        defined in.
    """

    ECU = "ECU"
    LOCAL = "LOCAL"


class EcucValueCollectionSubtypesEnum(Enum):
    ECUC_VALUE_COLLECTION = "ECUC-VALUE-COLLECTION"


class EndToEndProfileBehaviorEnumSimple(Enum):
    """
    :cvar PRE_R_4_2: Check has the legacy behavior, before AUTOSAR
        Release 4.2.
    :cvar R_4_2: Check behaves like new P4/P5/P6 profiles introduced in
        AUTOSAR Release 4.2.
    """

    PRE_R_4_2 = "PRE--R-4--2"
    R_4_2 = "R-4--2"


class EnvironmentCaptureToReportingEnumSimple(Enum):
    """
    :cvar CAPTURE_ASYNCHRONOUS_TO_REPORTING: The data capturing is
        postponed to the next cycle of the Dem_Mainfunction. (This means
        that there is a minimum delay between report of the failure and
        capturing the data.
    :cvar CAPTURE_SYNCHRONOUS_TO_REPORTING: The data is captured
        immediately within the reporting function (i.e. in the context
        of the setEventStatus/reportErrorStatus function).
    """

    CAPTURE_ASYNCHRONOUS_TO_REPORTING = "CAPTURE-ASYNCHRONOUS-TO-REPORTING"
    CAPTURE_SYNCHRONOUS_TO_REPORTING = "CAPTURE-SYNCHRONOUS-TO-REPORTING"


class EocExecutableEntityRefAbstractSubtypesEnum(Enum):
    EOC_EVENT_REF = "EOC-EVENT-REF"
    EOC_EXECUTABLE_ENTITY_REF = "EOC-EXECUTABLE-ENTITY-REF"
    EOC_EXECUTABLE_ENTITY_REF_ABSTRACT = "EOC-EXECUTABLE-ENTITY-REF-ABSTRACT"
    EOC_EXECUTABLE_ENTITY_REF_GROUP = "EOC-EXECUTABLE-ENTITY-REF-GROUP"


class EocExecutableEntityRefGroupSubtypesEnum(Enum):
    EOC_EXECUTABLE_ENTITY_REF_GROUP = "EOC-EXECUTABLE-ENTITY-REF-GROUP"


class EthGlobalTimeMessageFormatEnumSimple(Enum):
    """
    :cvar IEEE802_1_AS: Message format according to IEEE 802.1AS
        standard.
    :cvar IEEE802_1_AS_AUTOSAR: Message format according to IEEE 802.1AS
        standard with AUTOSAR extensions.
    """

    IEEE802_1_AS = "IEEE802-1AS"
    IEEE802_1_AS_AUTOSAR = "IEEE802-1AS-AUTOSAR"


class EthIpPropsSubtypesEnum(Enum):
    ETH_IP_PROPS = "ETH-IP-PROPS"


class EthTcpIpIcmpPropsSubtypesEnum(Enum):
    ETH_TCP_IP_ICMP_PROPS = "ETH-TCP-IP-ICMP-PROPS"


class EthTcpIpPropsSubtypesEnum(Enum):
    ETH_TCP_IP_PROPS = "ETH-TCP-IP-PROPS"


class EthernetClusterSubtypesEnum(Enum):
    ETHERNET_CLUSTER = "ETHERNET-CLUSTER"


class EthernetCommunicationConnectorSubtypesEnum(Enum):
    ETHERNET_COMMUNICATION_CONNECTOR = "ETHERNET-COMMUNICATION-CONNECTOR"


class EthernetConnectionNegotiationEnumSimple(Enum):
    """
    :cvar AUTO: Automatic Negotiation
    :cvar MASTER: Master
    :cvar SLAVE: Slave
    """

    AUTO = "AUTO"
    MASTER = "MASTER"
    SLAVE = "SLAVE"


class EthernetCouplingPortSchedulerEnumSimple(Enum):
    """
    :cvar DEFICIT_ROUND_ROBIN: Schedule algorithm "deficit round robin"
    :cvar STRICT_PRIORITY: Schedule algorithm "strict priority"
    :cvar WEIGHTED_ROUND_ROBIN: Schedule algorithm "weighted round
        robin"
    """

    DEFICIT_ROUND_ROBIN = "DEFICIT-ROUND-ROBIN"
    STRICT_PRIORITY = "STRICT-PRIORITY"
    WEIGHTED_ROUND_ROBIN = "WEIGHTED-ROUND-ROBIN"


class EthernetMacLayerTypeEnumSimple(Enum):
    """
    :cvar X_MII: Mac layer interface (data) bandwith class 100Mbit/s and
        10Mbit/s (e.g. RMII, RvMII, SMII, RvMII)
    :cvar XG_MII: Mac layer interface (data) bandwith class 1Gbit/s
        (e.g. GMII, RGMII, SGMII, RvGMII, USGMII)
    :cvar XXG_MII: Mac layer interface (data) bandwith class 10Gbit/s
    """

    X_MII = "X-MII"
    XG_MII = "XG-MII"
    XXG_MII = "XXG-MII"


class EthernetPhysicalChannelSubtypesEnum(Enum):
    ETHERNET_PHYSICAL_CHANNEL = "ETHERNET-PHYSICAL-CHANNEL"


class EthernetPhysicalLayerTypeEnumSimple(Enum):
    """
    :cvar VALUE_1000_BASE_T: Ethernet Standard (IEEE 802.3ab) to support
        1Gbit/s over 4 twisted pairs.
    :cvar VALUE_1000_BASE_T1: Ethernet Standard (IEEE 802.3bp) to
        support 1Gbit/s over a single twisted pair cable.
    :cvar VALUE_100_BASE_T1: Ethernet Standard (IEEE 802.3bw) to support
        100Mbit/s over a single twisted pair cable.  100BASE-T1 is the
        IEEE Standardized version of BroadRReach.
    :cvar VALUE_100_BASE_TX: Ethernet Standard (IEEE 802.3u) to support
        100Mbit/s over two twisted pairs.
    :cvar VALUE_10_BASE_T1_S: Physical layer interface 10BASE-T1S
        (10Mbit/s, 2 pairs). Used for automotive.
    :cvar BASE_T: BaseT physical layer (10BaseT, 100BaseT, 1000BaseT)
    :cvar BROAD_R_REACH: BroadR-Reach physical layer
    :cvar IEEE802_11_P: Ethernet Standard (IEEE 802.11p) to support
        wireless communication in vehicular environments.
    :cvar RTPGE: Reduced Twisted Pair Gigabit Ethernet (RTPGE) physical
        layer
    :cvar X_MII: Media Independent Interface (MII) physical layer
    :cvar X_MMI: This enumeration literal is set to obsolete and will be
        removed in future. Please use xMII instead. Old description:
        Media Independent Interface (MII) physical layer
    """

    VALUE_1000_BASE_T = "1000BASE-T"
    VALUE_1000_BASE_T1 = "1000BASE-T1"
    VALUE_100_BASE_T1 = "100BASE-T1"
    VALUE_100_BASE_TX = "100BASE-TX"
    VALUE_10_BASE_T1_S = "10BASE-T1S"
    BASE_T = "BASE-T"
    BROAD_R_REACH = "BROAD-R-REACH"
    IEEE802_11_P = "IEEE802-11P"
    RTPGE = "RTPGE"
    X_MII = "X-MII"
    X_MMI = "X-MMI"


class EthernetRawDataStreamMappingSubtypesEnum(Enum):
    ETHERNET_RAW_DATA_STREAM_CLIENT_MAPPING = "ETHERNET-RAW-DATA-STREAM-CLIENT-MAPPING"
    ETHERNET_RAW_DATA_STREAM_MAPPING = "ETHERNET-RAW-DATA-STREAM-MAPPING"
    ETHERNET_RAW_DATA_STREAM_SERVER_MAPPING = "ETHERNET-RAW-DATA-STREAM-SERVER-MAPPING"


class EthernetSwitchVlanEgressTaggingEnumSimple(Enum):
    """
    :cvar NOT_SENT: will not be sent
    :cvar SENT_TAGGED: sent with its VLAN tag
    :cvar SENT_UNTAGGED: sent without a VLAN tag
    """

    NOT_SENT = "NOT-SENT"
    SENT_TAGGED = "SENT-TAGGED"
    SENT_UNTAGGED = "SENT-UNTAGGED"


class EthernetSwitchVlanIngressTagEnumSimple(Enum):
    """
    :cvar DROP_UNTAGGED: Drop if untagged.
    :cvar FORWARD_AS_IS: Forward with the same VLAN as received. Also
        untagged frames will be forwarded as untagged.
    """

    DROP_UNTAGGED = "DROP-UNTAGGED"
    FORWARD_AS_IS = "FORWARD-AS-IS"


class EthernetWakeupSleepOnDatalineConfigSubtypesEnum(Enum):
    ETHERNET_WAKEUP_SLEEP_ON_DATALINE_CONFIG = "ETHERNET-WAKEUP-SLEEP-ON-DATALINE-CONFIG"


class EventAcceptanceStatusEnumSimple(Enum):
    """
    :cvar EVENT_ACCEPTANCE_DISABLED: Acceptance of a diagnostic event is
        disabled.
    :cvar EVENT_ACCEPTANCE_ENABLED: Acceptance of a diagnostic event is
        enabled.
    """

    EVENT_ACCEPTANCE_DISABLED = "EVENT-ACCEPTANCE-DISABLED"
    EVENT_ACCEPTANCE_ENABLED = "EVENT-ACCEPTANCE-ENABLED"


class EventGroupControlTypeEnumSimple(Enum):
    """
    :cvar ACTIVATION_AND_TRIGGER_UNICAST: Activate the data path for
        unicast events and triggered unicast events that are sent out
        after a client got subscribed.
    :cvar ACTIVATION_MULTICAST: Activate the data path for multicast
        events of an EventGroup.
    :cvar ACTIVATION_UNICAST: Activate the data path for unicast events
        of an EventGroup.
    :cvar TRIGGER_UNICAST: Activate the data path for triggered unicast
        events that are sent out after a client got subscribed.
    """

    ACTIVATION_AND_TRIGGER_UNICAST = "ACTIVATION-AND-TRIGGER-UNICAST"
    ACTIVATION_MULTICAST = "ACTIVATION-MULTICAST"
    ACTIVATION_UNICAST = "ACTIVATION-UNICAST"
    TRIGGER_UNICAST = "TRIGGER-UNICAST"


class EventHandlerSubtypesEnum(Enum):
    EVENT_HANDLER = "EVENT-HANDLER"


class EventOccurrenceKindEnumSimple(Enum):
    """
    :cvar MULTIPLE_OCCURRENCES: Specifies that an event may occur more
        than once in a given time interval.
    :cvar SINGLE_OCCURRENCE: Specifies that an event shall occur only
        once in a given time interval.
    """

    MULTIPLE_OCCURRENCES = "MULTIPLE-OCCURRENCES"
    SINGLE_OCCURRENCE = "SINGLE-OCCURRENCE"


class ExclusiveAreaSubtypesEnum(Enum):
    EXCLUSIVE_AREA = "EXCLUSIVE-AREA"


class ExclusiveAreaNestingOrderSubtypesEnum(Enum):
    EXCLUSIVE_AREA_NESTING_ORDER = "EXCLUSIVE-AREA-NESTING-ORDER"


class ExecutableSubtypesEnum(Enum):
    EXECUTABLE = "EXECUTABLE"


class ExecutableEntitySubtypesEnum(Enum):
    BSW_CALLED_ENTITY = "BSW-CALLED-ENTITY"
    BSW_INTERRUPT_ENTITY = "BSW-INTERRUPT-ENTITY"
    BSW_MODULE_ENTITY = "BSW-MODULE-ENTITY"
    BSW_SCHEDULABLE_ENTITY = "BSW-SCHEDULABLE-ENTITY"
    EXECUTABLE_ENTITY = "EXECUTABLE-ENTITY"
    RUNNABLE_ENTITY = "RUNNABLE-ENTITY"


class ExecutableEntityActivationReasonSubtypesEnum(Enum):
    EXECUTABLE_ENTITY_ACTIVATION_REASON = "EXECUTABLE-ENTITY-ACTIVATION-REASON"


class ExecutionOrderConstraintTypeEnumSimple(Enum):
    """
    :cvar HIERARCHICAL_EOC: Specifies that the Execution Order
        Constraint specifies a hierarchical execution order constraint.
    :cvar ORDINARY_EOC: Specifies that the Execution Order Constraint
        specifies an ordinary execution order constraint.
    :cvar REPETITIVE_EOC: Specifies that the Execution Order Constraint
        specifies a repetitive execution order constraint.
    """

    HIERARCHICAL_EOC = "HIERARCHICAL-EOC"
    ORDINARY_EOC = "ORDINARY-EOC"
    REPETITIVE_EOC = "REPETITIVE-EOC"


class ExecutionStateReportingBehaviorEnumSimple(Enum):
    """
    :cvar DOES_NOT_REPORT_EXECUTION_STATE: The Executable shall not
        report its execution state to the Execution Management.
    :cvar REPORTS_EXECUTION_STATE: The Executable shall report its
        execution state to the Execution Management.
    """

    DOES_NOT_REPORT_EXECUTION_STATE = "DOES-NOT-REPORT-EXECUTION-STATE"
    REPORTS_EXECUTION_STATE = "REPORTS-EXECUTION-STATE"


class ExecutionTimeTypeEnumSimple(Enum):
    """
    :cvar GROSS: Indicates that the given execution time is the time
        used to execute the ExecutableEntity without any interruption
        and and including external calls.
    :cvar NET: Indicates that the given execution time is the time used
        to execute the ExecutableEntity without any interruption and
        without any external calls.
    """

    GROSS = "GROSS"
    NET = "NET"


@dataclass(slots=True, kw_only=True)
class ExtIdClassEnum:
    """This is in fact an enumerator.

    The possible values are all legal XML names of identifiable objects
    even those of other XML files. If the schemas of all questionable
    files are generated from a common meta-model, this is something like
    an IdentifiableSubtypesEnum. Maybe a future version of the Schema
    generator can generate such an enum. As of now it is specified as
    string.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXT-ID-CLASS-ENUM"

    value: str = field(
        default="",
        metadata={
            "required": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class FibexElementSubtypesEnum(Enum):
    ABSTRACT_CAN_CLUSTER = "ABSTRACT-CAN-CLUSTER"
    ABSTRACT_ETHERNET_FRAME = "ABSTRACT-ETHERNET-FRAME"
    BUS_MIRROR_CHANNEL_MAPPING = "BUS-MIRROR-CHANNEL-MAPPING"
    BUS_MIRROR_CHANNEL_MAPPING_CAN = "BUS-MIRROR-CHANNEL-MAPPING-CAN"
    BUS_MIRROR_CHANNEL_MAPPING_FLEXRAY = "BUS-MIRROR-CHANNEL-MAPPING-FLEXRAY"
    BUS_MIRROR_CHANNEL_MAPPING_IP = "BUS-MIRROR-CHANNEL-MAPPING-IP"
    BUS_MIRROR_CHANNEL_MAPPING_USER_DEFINED = "BUS-MIRROR-CHANNEL-MAPPING-USER-DEFINED"
    CAN_CLUSTER = "CAN-CLUSTER"
    CAN_FRAME = "CAN-FRAME"
    CAN_TP_CONFIG = "CAN-TP-CONFIG"
    COMMUNICATION_CLUSTER = "COMMUNICATION-CLUSTER"
    CONSUMED_PROVIDED_SERVICE_INSTANCE_GROUP = "CONSUMED-PROVIDED-SERVICE-INSTANCE-GROUP"
    CONTAINER_I_PDU = "CONTAINER-I-PDU"
    COUPLING_ELEMENT = "COUPLING-ELEMENT"
    DCM_I_PDU = "DCM-I-PDU"
    DLT_MESSAGE_COLLECTION_SET = "DLT-MESSAGE-COLLECTION-SET"
    DO_IP_TP_CONFIG = "DO-IP-TP-CONFIG"
    ECU_INSTANCE = "ECU-INSTANCE"
    ETH_TP_CONFIG = "ETH-TP-CONFIG"
    ETHERNET_CLUSTER = "ETHERNET-CLUSTER"
    ETHERNET_FRAME = "ETHERNET-FRAME"
    ETHERNET_WAKEUP_SLEEP_ON_DATALINE_CONFIG_SET = "ETHERNET-WAKEUP-SLEEP-ON-DATALINE-CONFIG-SET"
    FIBEX_ELEMENT = "FIBEX-ELEMENT"
    FLEXRAY_AR_TP_CONFIG = "FLEXRAY-AR-TP-CONFIG"
    FLEXRAY_CLUSTER = "FLEXRAY-CLUSTER"
    FLEXRAY_FRAME = "FLEXRAY-FRAME"
    FLEXRAY_TP_CONFIG = "FLEXRAY-TP-CONFIG"
    FRAME = "FRAME"
    GATEWAY = "GATEWAY"
    GENERAL_PURPOSE_I_PDU = "GENERAL-PURPOSE-I-PDU"
    GENERAL_PURPOSE_PDU = "GENERAL-PURPOSE-PDU"
    GENERIC_ETHERNET_FRAME = "GENERIC-ETHERNET-FRAME"
    GLOBAL_TIME_DOMAIN = "GLOBAL-TIME-DOMAIN"
    I_PDU = "I-PDU"
    I_SIGNAL = "I-SIGNAL"
    I_SIGNAL_GROUP = "I-SIGNAL-GROUP"
    I_SIGNAL_I_PDU = "I-SIGNAL-I-PDU"
    I_SIGNAL_I_PDU_GROUP = "I-SIGNAL-I-PDU-GROUP"
    IEEE_1722_TP_ETHERNET_FRAME = "IEEE-1722-TP-ETHERNET-FRAME"
    J_1939_CLUSTER = "J-1939-CLUSTER"
    J_1939_DCM_I_PDU = "J-1939-DCM-I-PDU"
    J_1939_TP_CONFIG = "J-1939-TP-CONFIG"
    LIN_CLUSTER = "LIN-CLUSTER"
    LIN_EVENT_TRIGGERED_FRAME = "LIN-EVENT-TRIGGERED-FRAME"
    LIN_FRAME = "LIN-FRAME"
    LIN_SPORADIC_FRAME = "LIN-SPORADIC-FRAME"
    LIN_TP_CONFIG = "LIN-TP-CONFIG"
    LIN_UNCONDITIONAL_FRAME = "LIN-UNCONDITIONAL-FRAME"
    MACHINE_DESIGN = "MACHINE-DESIGN"
    MULTIPLEXED_I_PDU = "MULTIPLEXED-I-PDU"
    N_PDU = "N-PDU"
    NM_CONFIG = "NM-CONFIG"
    NM_PDU = "NM-PDU"
    PDU = "PDU"
    PDUR_I_PDU_GROUP = "PDUR-I-PDU-GROUP"
    SECURE_COMMUNICATION_PROPS_SET = "SECURE-COMMUNICATION-PROPS-SET"
    SECURED_I_PDU = "SECURED-I-PDU"
    SERVICE_INSTANCE_COLLECTION_SET = "SERVICE-INSTANCE-COLLECTION-SET"
    SO_AD_ROUTING_GROUP = "SO-AD-ROUTING-GROUP"
    SOCKET_CONNECTION_IPDU_IDENTIFIER_SET = "SOCKET-CONNECTION-IPDU-IDENTIFIER-SET"
    SOMEIP_TP_CONFIG = "SOMEIP-TP-CONFIG"
    TP_CONFIG = "TP-CONFIG"
    TTCAN_CLUSTER = "TTCAN-CLUSTER"
    USER_DEFINED_CLUSTER = "USER-DEFINED-CLUSTER"
    USER_DEFINED_ETHERNET_FRAME = "USER-DEFINED-ETHERNET-FRAME"
    USER_DEFINED_I_PDU = "USER-DEFINED-I-PDU"
    USER_DEFINED_PDU = "USER-DEFINED-PDU"
    XCP_PDU = "XCP-PDU"


class FieldSubtypesEnum(Enum):
    FIELD = "FIELD"


class FieldAccessEnumSimple(Enum):
    """
    :cvar GETTER: Access to the getter of the Field.
    :cvar GETTER_SETTER: Access to getter and setter of the field
    :cvar SETTER: Access to the setter of the Field.
    """

    GETTER = "GETTER"
    GETTER_SETTER = "GETTER-SETTER"
    SETTER = "SETTER"


class FilterDebouncingEnumSimple(Enum):
    """
    :cvar DEBOUNCE_DATA: The signal is a mean value
    :cvar RAW_DATA: Means that no modification of the signal has been
        applied. This is the default value
    :cvar WAIT_TIME_DATE: The signal is delivered by a GET operation
        after a certain amount of time
    """

    DEBOUNCE_DATA = "DEBOUNCE-DATA"
    RAW_DATA = "RAW-DATA"
    WAIT_TIME_DATE = "WAIT-TIME-DATE"


class FirewallActionEnumSimple(Enum):
    """
    :cvar ALLOW: Firewall allows the communication
    :cvar BLOCK: Firewall blocks the communication
    """

    ALLOW = "ALLOW"
    BLOCK = "BLOCK"


class FirewallRuleSubtypesEnum(Enum):
    FIREWALL_RULE = "FIREWALL-RULE"


class FlatInstanceDescriptorSubtypesEnum(Enum):
    FLAT_INSTANCE_DESCRIPTOR = "FLAT-INSTANCE-DESCRIPTOR"


class FlatMapSubtypesEnum(Enum):
    FLAT_MAP = "FLAT-MAP"


class FlexrayArTpNodeSubtypesEnum(Enum):
    FLEXRAY_AR_TP_NODE = "FLEXRAY-AR-TP-NODE"


class FlexrayChannelNameSimple(Enum):
    """
    :cvar CHANNEL_A: Channel A
    :cvar CHANNEL_B: Channel B
    """

    CHANNEL_A = "CHANNEL-A"
    CHANNEL_B = "CHANNEL-B"


class FlexrayClusterSubtypesEnum(Enum):
    FLEXRAY_CLUSTER = "FLEXRAY-CLUSTER"


class FlexrayCommunicationConnectorSubtypesEnum(Enum):
    FLEXRAY_COMMUNICATION_CONNECTOR = "FLEXRAY-COMMUNICATION-CONNECTOR"


class FlexrayNmClusterSubtypesEnum(Enum):
    FLEXRAY_NM_CLUSTER = "FLEXRAY-NM-CLUSTER"


class FlexrayNmScheduleVariantSimple(Enum):
    """
    :cvar SCHEDULE_VARIANT_1: NM-Vote and NM Data transmitted within one
        PDU in static segment. The NM-Vote has to be realized as
        separate bit within the PDU.
    :cvar SCHEDULE_VARIANT_2: NM-Vote and NM-Data transmitted within one
        PDU in dynamic segment. The presence (or non-presence) of the
        PDU corresponds to the NM-Vote
    :cvar SCHEDULE_VARIANT_3: NM-Vote and NM-Data are transmitted in the
        static segment in separate PDUs. This alternative is not
        recommended =&gt; Alternative 1 should be used instead.
    :cvar SCHEDULE_VARIANT_4: NM-Vote transmitted in static and NM-Data
        transmitted in dynamic segment.
    :cvar SCHEDULE_VARIANT_5: NM-Vote is transmitted in dynamic and NM-
        Data is transmitted in static segment. This alternative is not
        recommended =&gt; Variants 2 or 6 should be used instead.
    :cvar SCHEDULE_VARIANT_6: NM-Vote and NM-Data are transmitted in
        dynamic segment in separate PDUs.
    :cvar SCHEDULE_VARIANT_7: NM-Vote and a copy of the CBV are
        transmitted in the static segment (using the FlexRay NM Vector
        support) and NM-Data is transmitted in the dynamic segment
    """

    SCHEDULE_VARIANT_1 = "SCHEDULE-VARIANT-1"
    SCHEDULE_VARIANT_2 = "SCHEDULE-VARIANT-2"
    SCHEDULE_VARIANT_3 = "SCHEDULE-VARIANT-3"
    SCHEDULE_VARIANT_4 = "SCHEDULE-VARIANT-4"
    SCHEDULE_VARIANT_5 = "SCHEDULE-VARIANT-5"
    SCHEDULE_VARIANT_6 = "SCHEDULE-VARIANT-6"
    SCHEDULE_VARIANT_7 = "SCHEDULE-VARIANT-7"


class FlexrayPhysicalChannelSubtypesEnum(Enum):
    FLEXRAY_PHYSICAL_CHANNEL = "FLEXRAY-PHYSICAL-CHANNEL"


class FlexrayTpConnectionControlSubtypesEnum(Enum):
    FLEXRAY_TP_CONNECTION_CONTROL = "FLEXRAY-TP-CONNECTION-CONTROL"


class FlexrayTpNodeSubtypesEnum(Enum):
    FLEXRAY_TP_NODE = "FLEXRAY-TP-NODE"


class FlexrayTpPduPoolSubtypesEnum(Enum):
    FLEXRAY_TP_PDU_POOL = "FLEXRAY-TP-PDU-POOL"


@dataclass(slots=True, kw_only=True)
class Float:
    """
    An instance of Float is an element from the set of real numbers.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLOAT"

    value: float = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class FloatEnumSimple(Enum):
    """
    :cvar FLOAT: This indicates that a page formatter is allowed to
        float the table to optimize the pagination. This is for example
        supported by TeX.
    :cvar NO_FLOAT: This indicates that a page formatter is not allowed
        to float the object to optimize the pagination.
    """

    FLOAT = "FLOAT"
    NO_FLOAT = "NO-FLOAT"


class FmAttributeDefSubtypesEnum(Enum):
    FM_ATTRIBUTE_DEF = "FM-ATTRIBUTE-DEF"


class FmFeatureSubtypesEnum(Enum):
    FM_FEATURE = "FM-FEATURE"


class FmFeatureModelSubtypesEnum(Enum):
    FM_FEATURE_MODEL = "FM-FEATURE-MODEL"


class FmFeatureSelectionSetSubtypesEnum(Enum):
    FM_FEATURE_SELECTION_SET = "FM-FEATURE-SELECTION-SET"


class FmFeatureSelectionStateSimple(Enum):
    """
    :cvar DESELECTED: The feature is excluded from the selection.
    :cvar SELECTED: The feature is included in the selection.
    :cvar UNDECIDED: It is not yet decided whether the feature shall be
        included into or excluded from the selection.
    """

    DESELECTED = "DESELECTED"
    SELECTED = "SELECTED"
    UNDECIDED = "UNDECIDED"


@dataclass(slots=True, kw_only=True)
class ForeignModelReference:
    """This meta-class represents the ability to express a late binding reference
    to a foreign model element.

    The foreign model element can be from every model. Even if it is
    modeled according to the association representation, it is not
    limited to refer to AUTOSAR model elements.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar base: This establishes the reference base.
    :ivar dest: This attribute represents the class of the referenced
        model element. It is a String, since the model element can be in
        any model. Therefore we cannot have any assumption here.
    """

    class Meta:
        name = "FOREIGN-MODEL-REFERENCE"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"/?[a-zA-Z][a-zA-Z0-9_]{0,127}(/[a-zA-Z][a-zA-Z0-9_]{0,127})*",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    base: str | None = field(
        default=None,
        metadata={
            "name": "BASE",
            "type": "Attribute",
        },
    )
    dest: str | None = field(
        default=None,
        metadata={
            "name": "DEST",
            "type": "Attribute",
        },
    )


class FrArTpAckTypeSimple(Enum):
    """
    :cvar ACK_WITH_RT: Acknowledgement with retry.
    :cvar ACK_WITHOUT_RT: Acknowledgement without retry.
    :cvar NO_ACK: No acknowledgement.
    """

    ACK_WITH_RT = "ACK-WITH-RT"
    ACK_WITHOUT_RT = "ACK-WITHOUT-RT"
    NO_ACK = "NO-ACK"


class FrameSubtypesEnum(Enum):
    ABSTRACT_ETHERNET_FRAME = "ABSTRACT-ETHERNET-FRAME"
    CAN_FRAME = "CAN-FRAME"
    ETHERNET_FRAME = "ETHERNET-FRAME"
    FLEXRAY_FRAME = "FLEXRAY-FRAME"
    FRAME = "FRAME"
    GENERIC_ETHERNET_FRAME = "GENERIC-ETHERNET-FRAME"
    IEEE_1722_TP_ETHERNET_FRAME = "IEEE-1722-TP-ETHERNET-FRAME"
    LIN_EVENT_TRIGGERED_FRAME = "LIN-EVENT-TRIGGERED-FRAME"
    LIN_FRAME = "LIN-FRAME"
    LIN_SPORADIC_FRAME = "LIN-SPORADIC-FRAME"
    LIN_UNCONDITIONAL_FRAME = "LIN-UNCONDITIONAL-FRAME"
    USER_DEFINED_ETHERNET_FRAME = "USER-DEFINED-ETHERNET-FRAME"


class FrameEnumSimple(Enum):
    """
    :cvar ALL: Borders all around the table
    :cvar BOTTOM: Border at the bottom of the table
    :cvar NONE: No borders around the table
    :cvar SIDES: Borders at the sides of the table
    :cvar TOP: Border at the top of the table
    :cvar TOPBOT: Borders at the top and bottom of  the table
    """

    ALL = "ALL"
    BOTTOM = "BOTTOM"
    NONE = "NONE"
    SIDES = "SIDES"
    TOP = "TOP"
    TOPBOT = "TOPBOT"


class FramePortSubtypesEnum(Enum):
    FRAME_PORT = "FRAME-PORT"


class FrameTriggeringSubtypesEnum(Enum):
    CAN_FRAME_TRIGGERING = "CAN-FRAME-TRIGGERING"
    ETHERNET_FRAME_TRIGGERING = "ETHERNET-FRAME-TRIGGERING"
    FLEXRAY_FRAME_TRIGGERING = "FLEXRAY-FRAME-TRIGGERING"
    FRAME_TRIGGERING = "FRAME-TRIGGERING"
    LIN_FRAME_TRIGGERING = "LIN-FRAME-TRIGGERING"


class FullBindingTimeEnumSimple(Enum):
    """
    :cvar BLUEPRINT_DERIVATION_TIME: The point in time when an object is
        created from a blueprint.
    :cvar CODE_GENERATION_TIME: * Coding by hand, based on requirements
        document. * Tool based code generation, e.g. from a model. * The
        model may contain variants. * Only code for the selected
        variant(s) is actually generated.
    :cvar LINK_TIME: Configure what is included in object code, and what
        is omitted Based on which variant(s) are selected E.g. for
        modules that are delivered as object code (as opposed to those
        that are delivered as source code)
    :cvar POST_BUILD: PostBuild is the binding time which is bound
        latest at startup of the ECU. In other words this is everything
        between creation of the executable program and startup of the
        ECU.
    :cvar PRE_COMPILE_TIME: This is typically the C-Preprocessor.
        Exclude parts of the code from the compilation process, e.g.,
        because they are not required for the selected variant, because
        they are incompatible with the selected variant, because they
        require resources that are not present in the selected variant.
        Object code is only generated for the selected variant(s). The
        code that is excluded at this stage code will not be available
        at later stages.
    :cvar SYSTEM_DESIGN_TIME: * Designing the VFB. * Software Component
        types (PortInterfaces). * SWC Prototypes and the Connections
        between SWCprototypes. * Designing the Topology * ECUs and
        interconnecting Networks * Designing the Communication Matrix
        and Data Mapping
    """

    BLUEPRINT_DERIVATION_TIME = "BLUEPRINT-DERIVATION-TIME"
    CODE_GENERATION_TIME = "CODE-GENERATION-TIME"
    LINK_TIME = "LINK-TIME"
    POST_BUILD = "POST-BUILD"
    PRE_COMPILE_TIME = "PRE-COMPILE-TIME"
    SYSTEM_DESIGN_TIME = "SYSTEM-DESIGN-TIME"


class FunctionInhibitionNeedsSubtypesEnum(Enum):
    FUNCTION_INHIBITION_NEEDS = "FUNCTION-INHIBITION-NEEDS"


class FunctionalClusterPersistencyAccessEnumSimple(Enum):
    """
    :cvar READ: Functional Cluster wants to access persistency with a
        read semantics.
    :cvar READ_WRITE: Functional Cluster wants to access persistency
        with a read and write semantics.
    :cvar WRITE: Functional Cluster wants to access persistency with a
        write semantics.
    """

    READ = "READ"
    READ_WRITE = "READ-WRITE"
    WRITE = "WRITE"


class GeneralPurposePduSubtypesEnum(Enum):
    GENERAL_PURPOSE_PDU = "GENERAL-PURPOSE-PDU"


class GlobalSupervisionSubtypesEnum(Enum):
    GLOBAL_SUPERVISION = "GLOBAL-SUPERVISION"


class GlobalTimeCrcSupportEnumSimple(Enum):
    """
    :cvar CRC_NOT_SUPPORTED: This indicates that CRC is not supported
    :cvar CRC_SUPPORTED: This indicates that CRC is supported
    """

    CRC_NOT_SUPPORTED = "CRC-NOT-SUPPORTED"
    CRC_SUPPORTED = "CRC-SUPPORTED"


class GlobalTimeCrcValidationEnumSimple(Enum):
    """
    :cvar CRC_IGNORED: The CRC is supposed to be ignored
    :cvar CRC_NOT_VALIDATED: The CRC is not supposed to be present. If
        CRC is present the message is ignored.
    :cvar CRC_OPTIONAL: Either the CRC is present and then shall be
        validated or the CRC is not present and no CRC check is done.
    :cvar CRC_VALIDATED: This CRC is supposed to be validated.
    """

    CRC_IGNORED = "CRC-IGNORED"
    CRC_NOT_VALIDATED = "CRC-NOT-VALIDATED"
    CRC_OPTIONAL = "CRC-OPTIONAL"
    CRC_VALIDATED = "CRC-VALIDATED"


class GlobalTimeDomainSubtypesEnum(Enum):
    GLOBAL_TIME_DOMAIN = "GLOBAL-TIME-DOMAIN"


class GlobalTimeIcvSupportEnumSimple(Enum):
    """
    :cvar ICV_NOT_SUPPORTED: The ICV is not supported
    :cvar ICV_SUPPORTED: The ICV is supported
    """

    ICV_NOT_SUPPORTED = "ICV-NOT-SUPPORTED"
    ICV_SUPPORTED = "ICV-SUPPORTED"


class GlobalTimeIcvVerificationEnumSimple(Enum):
    """
    :cvar ICV_IGNORED: If the ICV is present, then it is ignored
    :cvar ICV_NOT_VERIFIED: The ICV is not supposed to be present. If
        the ICV is present, then the message is ignored.
    :cvar ICV_OPTIONAL: If the ICV is present, then it will be verified.
        If the ICV is not present, then this is also a valid reception
        (no verification required).
    :cvar ICV_VERIFIED: The ICV is required and will be verified.
    """

    ICV_IGNORED = "ICV-IGNORED"
    ICV_NOT_VERIFIED = "ICV-NOT-VERIFIED"
    ICV_OPTIONAL = "ICV-OPTIONAL"
    ICV_VERIFIED = "ICV-VERIFIED"


class GlobalTimeMasterSubtypesEnum(Enum):
    GLOBAL_TIME_CAN_MASTER = "GLOBAL-TIME-CAN-MASTER"
    GLOBAL_TIME_ETH_MASTER = "GLOBAL-TIME-ETH-MASTER"
    GLOBAL_TIME_FR_MASTER = "GLOBAL-TIME-FR-MASTER"
    GLOBAL_TIME_MASTER = "GLOBAL-TIME-MASTER"
    USER_DEFINED_GLOBAL_TIME_MASTER = "USER-DEFINED-GLOBAL-TIME-MASTER"


class GlobalTimeSlaveSubtypesEnum(Enum):
    GLOBAL_TIME_CAN_SLAVE = "GLOBAL-TIME-CAN-SLAVE"
    GLOBAL_TIME_ETH_SLAVE = "GLOBAL-TIME-ETH-SLAVE"
    GLOBAL_TIME_FR_SLAVE = "GLOBAL-TIME-FR-SLAVE"
    GLOBAL_TIME_SLAVE = "GLOBAL-TIME-SLAVE"
    USER_DEFINED_GLOBAL_TIME_SLAVE = "USER-DEFINED-GLOBAL-TIME-SLAVE"


class GrantSubtypesEnum(Enum):
    COM_EVENT_GRANT = "COM-EVENT-GRANT"
    COM_FIELD_GRANT = "COM-FIELD-GRANT"
    COM_FIND_SERVICE_GRANT = "COM-FIND-SERVICE-GRANT"
    COM_GRANT = "COM-GRANT"
    COM_METHOD_GRANT = "COM-METHOD-GRANT"
    COM_OFFER_SERVICE_GRANT = "COM-OFFER-SERVICE-GRANT"
    ETHERNET_RAW_DATA_STREAM_GRANT = "ETHERNET-RAW-DATA-STREAM-GRANT"
    GRANT = "GRANT"
    RAW_DATA_STREAM_GRANT = "RAW-DATA-STREAM-GRANT"


class GraphicFitEnumSimple(Enum):
    """
    :cvar AS_IS: This indicates that the image shall be incorporated as
        is without scaling, rotation etc.
    :cvar FIT_TO_PAGE: Fit to the page
    :cvar FIT_TO_TEXT: fit to the text containing the graphic.
    :cvar LIMIT_TO_PAGE: This indicates that the width of the graphic
        shall be limited to the '''page width'''. The image shall not be
        scaled down but cropped.
    :cvar LIMIT_TO_TEXT: This indicates that the width of the graphic
        shall be limited to the width of the current '''text flow'''.
        The image shall not be scaled down but cropped.
    :cvar ROTATE_180: Rotate 180 degree
    :cvar ROTATE_180_LIMIT_TO_TEXT: Rotate 180 degree
    :cvar ROTATE_90_CCW: Rotate 90 degree counter clockwise
    :cvar ROTATE_90_CCW_FIT_TO_TEXT: Rotate by 90 degree counter clock
        wise and then fit to text
    :cvar ROTATE_90_CCW_LIMIT_TO_TEXT: Rotate by 90 degree counter clock
        wise and then fit to text
    :cvar ROTATE_90_CW: Rotate 90 degree clockwise
    :cvar ROTATE_90_CW_FIT_TO_TEXT: Rotate by 90 degree and then fit to
        text
    :cvar ROTATE_90_CW_LIMIT_TO_TEXT: Rotate by 90 degree and then fit
        to text
    """

    AS_IS = "AS-IS"
    FIT_TO_PAGE = "FIT-TO-PAGE"
    FIT_TO_TEXT = "FIT-TO-TEXT"
    LIMIT_TO_PAGE = "LIMIT-TO-PAGE"
    LIMIT_TO_TEXT = "LIMIT-TO-TEXT"
    ROTATE_180 = "ROTATE-180"
    ROTATE_180_LIMIT_TO_TEXT = "ROTATE-180-LIMIT-TO-TEXT"
    ROTATE_90_CCW = "ROTATE-90-CCW"
    ROTATE_90_CCW_FIT_TO_TEXT = "ROTATE-90-CCW-FIT-TO-TEXT"
    ROTATE_90_CCW_LIMIT_TO_TEXT = "ROTATE-90-CCW-LIMIT-TO-TEXT"
    ROTATE_90_CW = "ROTATE-90-CW"
    ROTATE_90_CW_FIT_TO_TEXT = "ROTATE-90-CW-FIT-TO-TEXT"
    ROTATE_90_CW_LIMIT_TO_TEXT = "ROTATE-90-CW-LIMIT-TO-TEXT"


class GraphicNotationEnumSimple(Enum):
    """
    :cvar BMP: bitmap image
    :cvar EPS: Encapsulated Postscript
    :cvar GIF: Graphics Interchange Format
    :cvar JPG: "Joint Photographic Experts Group"  format
    :cvar PDF: Portable Document Format
    :cvar PNG: Portable Network Graphics
    :cvar SVG: scalable vector graphic
    :cvar TIFF: Tagged Image File Format
    """

    BMP = "BMP"
    EPS = "EPS"
    GIF = "GIF"
    JPG = "JPG"
    PDF = "PDF"
    PNG = "PNG"
    SVG = "SVG"
    TIFF = "TIFF"


class HandleInvalidEnumSimple(Enum):
    """
    :cvar DONT_INVALIDATE: Invalidation is switched off.
    :cvar EXTERNAL_REPLACEMENT: Replace a received invalidValue. The
        replacement value is sourced from the aggregation in the role
        replaceWith.
    :cvar KEEP: The application software is supposed to  handle signal
        invalidation on RTE API level either by DataReceiveErrorEvent or
        check of error code on read access.
    :cvar REPLACE: Replace a received invalidValue. The replacement
        value is specified by the initValue.
    """

    DONT_INVALIDATE = "DONT-INVALIDATE"
    EXTERNAL_REPLACEMENT = "EXTERNAL-REPLACEMENT"
    KEEP = "KEEP"
    REPLACE = "REPLACE"


class HandleOutOfRangeEnumSimple(Enum):
    """
    :cvar DEFAULT: The RTE will use the initValue if the actual value is
        out of the specified bounds.
    :cvar EXTERNAL_REPLACEMENT: This indicates that the value
        replacement is sourced from the attribute replaceWith.
    :cvar IGNORE: The RTE will ignore any attempt to send or receive the
        corresponding dataElement if the value is out of the specified
        range.
    :cvar INVALID: The RTE will use the invalidValue if the value is out
        of the specified bounds.
    :cvar NONE: A range check is not required.
    :cvar SATURATE: The RTE will saturate the value of the dataElement
        such that it is limited to the applicable upper bound if it is
        greater than the upper bound. Consequently, it is limited to the
        applicable lower bound if the value is less than the lower
        bound.
    """

    DEFAULT = "DEFAULT"
    EXTERNAL_REPLACEMENT = "EXTERNAL-REPLACEMENT"
    IGNORE = "IGNORE"
    INVALID = "INVALID"
    NONE = "NONE"
    SATURATE = "SATURATE"


class HandleOutOfRangeStatusEnumSimple(Enum):
    """
    :cvar INDICATE: The RTE sets the return status to RTE_E_OUT_OF_RANGE
        if the received value is out of range and the attribute
        handleOutOfRange is not set to "none" or "invalid".
    :cvar SILENT: The RTE sets the return status to RTE_E_OK
    """

    INDICATE = "INDICATE"
    SILENT = "SILENT"


class HandleTerminationAndRestartEnumSimple(Enum):
    """
    :cvar CAN_BE_TERMINATED: Supports termination.
    :cvar CAN_BE_TERMINATED_AND_RESTARTED: Supports termination and
        restarting.
    :cvar NO_SUPPORT: Stop and restart is not supported at all.
    """

    CAN_BE_TERMINATED = "CAN-BE-TERMINATED"
    CAN_BE_TERMINATED_AND_RESTARTED = "CAN-BE-TERMINATED-AND-RESTARTED"
    NO_SUPPORT = "NO-SUPPORT"


class HandleTimeoutEnumSimple(Enum):
    """
    :cvar NONE: If set to none no replacement shall take place.
    :cvar REPLACE: If set to replace, the replacement value shall be the
        ComInitValue.
    :cvar REPLACE_BY_TIMEOUT_SUBSTITUTION_VALUE: If set to replace, the
        replacement value shall be the timeout substitution value.
    """

    NONE = "NONE"
    REPLACE = "REPLACE"
    REPLACE_BY_TIMEOUT_SUBSTITUTION_VALUE = "REPLACE-BY-TIMEOUT-SUBSTITUTION-VALUE"


class HwAttributeDefSubtypesEnum(Enum):
    HW_ATTRIBUTE_DEF = "HW-ATTRIBUTE-DEF"


class HwCategorySubtypesEnum(Enum):
    HW_CATEGORY = "HW-CATEGORY"


class HwDescriptionEntitySubtypesEnum(Enum):
    HW_DESCRIPTION_ENTITY = "HW-DESCRIPTION-ENTITY"
    HW_ELEMENT = "HW-ELEMENT"
    HW_PIN = "HW-PIN"
    HW_PIN_GROUP = "HW-PIN-GROUP"
    HW_TYPE = "HW-TYPE"


class HwElementSubtypesEnum(Enum):
    HW_ELEMENT = "HW-ELEMENT"


class HwPinSubtypesEnum(Enum):
    HW_PIN = "HW-PIN"


class HwPinGroupSubtypesEnum(Enum):
    HW_PIN_GROUP = "HW-PIN-GROUP"


class HwTypeSubtypesEnum(Enum):
    HW_TYPE = "HW-TYPE"


class IPduSubtypesEnum(Enum):
    CONTAINER_I_PDU = "CONTAINER-I-PDU"
    DCM_I_PDU = "DCM-I-PDU"
    GENERAL_PURPOSE_I_PDU = "GENERAL-PURPOSE-I-PDU"
    I_PDU = "I-PDU"
    I_SIGNAL_I_PDU = "I-SIGNAL-I-PDU"
    J_1939_DCM_I_PDU = "J-1939-DCM-I-PDU"
    MULTIPLEXED_I_PDU = "MULTIPLEXED-I-PDU"
    N_PDU = "N-PDU"
    SECURED_I_PDU = "SECURED-I-PDU"
    USER_DEFINED_I_PDU = "USER-DEFINED-I-PDU"
    XCP_PDU = "XCP-PDU"


class IPduPortSubtypesEnum(Enum):
    I_PDU_PORT = "I-PDU-PORT"


class IPduSignalProcessingEnumSimple(Enum):
    """
    :cvar DEFERRED: The signal indications / confirmations are deferred.
    :cvar IMMEDIATE: The signal indications / confirmations are
        performed.
    """

    DEFERRED = "DEFERRED"
    IMMEDIATE = "IMMEDIATE"


class IPsecDpdActionEnumSimple(Enum):
    """
    :cvar CLEAR: Deletes the SA.
    :cvar RESTART: Immediately tries to establish the connection.
    :cvar TRAP: tries to establish the connection after traffic is sent
        to the peer.
    """

    CLEAR = "CLEAR"
    RESTART = "RESTART"
    TRAP = "TRAP"


class IPsecHeaderTypeEnumSimple(Enum):
    """
    :cvar AH: Authentication Header (AH)
    :cvar ESP: Encapsulating Security Payloads (ESP)
    :cvar NONE: No header
    """

    AH = "AH"
    ESP = "ESP"
    NONE = "NONE"


class IPsecIpProtocolEnumSimple(Enum):
    """
    :cvar ANY: ANY protocol
    :cvar ICMP: Internet Control Message Protocol (ICMP)
    :cvar TCP: TCP Protocol
    :cvar UDP: UDP Protocol
    """

    ANY = "ANY"
    ICMP = "ICMP"
    TCP = "TCP"
    UDP = "UDP"


class IPsecModeEnumSimple(Enum):
    """
    :cvar TRANSPORT: Signifying that the IPSec transport mode is used.
        With the transport mode the original IP header is retained and
        only the IP payload and ESP trailer is encrypted.
    :cvar TUNNEL: Signifying that the IPSec tunnel mode is used. With
        tunnel mode, the entire original IP packet is protected by
        IPSec. This means IPSec wraps the original packet, encrypts it,
        adds a new IP header and sends it to the other side.
    """

    TRANSPORT = "TRANSPORT"
    TUNNEL = "TUNNEL"


class IPsecPolicyEnumSimple(Enum):
    """
    :cvar DROP: Signifying that packets should be discarded
    :cvar IPSEC: Signifying that packets should be protected.
    :cvar PASSTHROUGH: Signifying that no IPsec processing should be
        done at all.
    :cvar REJECT: Signifying that packets should be discarded and a
        diagnostic ICMP returned.
    """

    DROP = "DROP"
    IPSEC = "IPSEC"
    PASSTHROUGH = "PASSTHROUGH"
    REJECT = "REJECT"


class IPv6ExtHeaderFilterListSubtypesEnum(Enum):
    I_PV_6_EXT_HEADER_FILTER_LIST = "I-PV-6-EXT-HEADER-FILTER-LIST"


class ISignalSubtypesEnum(Enum):
    I_SIGNAL = "I-SIGNAL"


class ISignalGroupSubtypesEnum(Enum):
    I_SIGNAL_GROUP = "I-SIGNAL-GROUP"


class ISignalIPduSubtypesEnum(Enum):
    I_SIGNAL_I_PDU = "I-SIGNAL-I-PDU"


class ISignalIPduGroupSubtypesEnum(Enum):
    I_SIGNAL_I_PDU_GROUP = "I-SIGNAL-I-PDU-GROUP"


class ISignalPortSubtypesEnum(Enum):
    I_SIGNAL_PORT = "I-SIGNAL-PORT"


class ISignalToIPduMappingSubtypesEnum(Enum):
    I_SIGNAL_TO_I_PDU_MAPPING = "I-SIGNAL-TO-I-PDU-MAPPING"


class ISignalTriggeringSubtypesEnum(Enum):
    I_SIGNAL_TRIGGERING = "I-SIGNAL-TRIGGERING"


class ISignalTypeEnumSimple(Enum):
    """
    :cvar ARRAY: ISignal shall be interpreted as an array (UINT8_N,
        UINT8_DYN)
    :cvar PRIMITIVE: ISignal shall be interpreted as a primitive type
        (e.g. UINT_8, SINT_32)
    """

    ARRAY = "ARRAY"
    PRIMITIVE = "PRIMITIVE"


class IdentifiableSubtypesEnum(Enum):
    ABSTRACT_ACCESS_POINT = "ABSTRACT-ACCESS-POINT"
    ABSTRACT_CAN_CLUSTER = "ABSTRACT-CAN-CLUSTER"
    ABSTRACT_CAN_COMMUNICATION_CONNECTOR = "ABSTRACT-CAN-COMMUNICATION-CONNECTOR"
    ABSTRACT_CAN_COMMUNICATION_CONTROLLER = "ABSTRACT-CAN-COMMUNICATION-CONTROLLER"
    ABSTRACT_CAN_PHYSICAL_CHANNEL = "ABSTRACT-CAN-PHYSICAL-CHANNEL"
    ABSTRACT_CLASS_TAILORING = "ABSTRACT-CLASS-TAILORING"
    ABSTRACT_DO_IP_LOGIC_ADDRESS_PROPS = "ABSTRACT-DO-IP-LOGIC-ADDRESS-PROPS"
    ABSTRACT_ETHERNET_FRAME = "ABSTRACT-ETHERNET-FRAME"
    ABSTRACT_EVENT = "ABSTRACT-EVENT"
    ABSTRACT_EXECUTION_CONTEXT = "ABSTRACT-EXECUTION-CONTEXT"
    ABSTRACT_IAM_REMOTE_SUBJECT = "ABSTRACT-IAM-REMOTE-SUBJECT"
    ABSTRACT_IMPLEMENTATION_DATA_TYPE = "ABSTRACT-IMPLEMENTATION-DATA-TYPE"
    ABSTRACT_IMPLEMENTATION_DATA_TYPE_ELEMENT = "ABSTRACT-IMPLEMENTATION-DATA-TYPE-ELEMENT"
    ABSTRACT_PROVIDED_PORT_PROTOTYPE = "ABSTRACT-PROVIDED-PORT-PROTOTYPE"
    ABSTRACT_RAW_DATA_STREAM_INTERFACE = "ABSTRACT-RAW-DATA-STREAM-INTERFACE"
    ABSTRACT_REQUIRED_PORT_PROTOTYPE = "ABSTRACT-REQUIRED-PORT-PROTOTYPE"
    ABSTRACT_SECURITY_EVENT_FILTER = "ABSTRACT-SECURITY-EVENT-FILTER"
    ABSTRACT_SECURITY_IDSM_INSTANCE_FILTER = "ABSTRACT-SECURITY-IDSM-INSTANCE-FILTER"
    ABSTRACT_SERVICE_INSTANCE = "ABSTRACT-SERVICE-INSTANCE"
    ABSTRACT_SIGNAL_BASED_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "ABSTRACT-SIGNAL-BASED-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    ABSTRACT_SYNCHRONIZED_TIME_BASE_INTERFACE = "ABSTRACT-SYNCHRONIZED-TIME-BASE-INTERFACE"
    ACL_OBJECT_SET = "ACL-OBJECT-SET"
    ACL_OPERATION = "ACL-OPERATION"
    ACL_PERMISSION = "ACL-PERMISSION"
    ACL_ROLE = "ACL-ROLE"
    ADAPTIVE_APPLICATION_SW_COMPONENT_TYPE = "ADAPTIVE-APPLICATION-SW-COMPONENT-TYPE"
    ADAPTIVE_FIREWALL_MODULE_INSTANTIATION = "ADAPTIVE-FIREWALL-MODULE-INSTANTIATION"
    ADAPTIVE_FIREWALL_TO_PORT_PROTOTYPE_MAPPING = "ADAPTIVE-FIREWALL-TO-PORT-PROTOTYPE-MAPPING"
    ADAPTIVE_MODULE_INSTANTIATION = "ADAPTIVE-MODULE-INSTANTIATION"
    ADAPTIVE_PLATFORM_SERVICE_INSTANCE = "ADAPTIVE-PLATFORM-SERVICE-INSTANCE"
    ADAPTIVE_SWC_INTERNAL_BEHAVIOR = "ADAPTIVE-SWC-INTERNAL-BEHAVIOR"
    AGE_CONSTRAINT = "AGE-CONSTRAINT"
    AGGREGATION_TAILORING = "AGGREGATION-TAILORING"
    ALIAS_NAME_SET = "ALIAS-NAME-SET"
    ALIVE_SUPERVISION = "ALIVE-SUPERVISION"
    ALLOCATOR = "ALLOCATOR"
    ANALYZED_EXECUTION_TIME = "ANALYZED-EXECUTION-TIME"
    AP_APPLICATION_ENDPOINT = "AP-APPLICATION-ENDPOINT"
    AP_APPLICATION_ERROR = "AP-APPLICATION-ERROR"
    AP_APPLICATION_ERROR_DOMAIN = "AP-APPLICATION-ERROR-DOMAIN"
    AP_APPLICATION_ERROR_SET = "AP-APPLICATION-ERROR-SET"
    AP_SOMEIP_TRANSFORMATION_PROPS = "AP-SOMEIP-TRANSFORMATION-PROPS"
    APP_OS_TASK_PROXY_TO_ECU_TASK_PROXY_MAPPING = "APP-OS-TASK-PROXY-TO-ECU-TASK-PROXY-MAPPING"
    APPLICATION_ARRAY_DATA_TYPE = "APPLICATION-ARRAY-DATA-TYPE"
    APPLICATION_ARRAY_ELEMENT = "APPLICATION-ARRAY-ELEMENT"
    APPLICATION_ASSOC_MAP_DATA_TYPE = "APPLICATION-ASSOC-MAP-DATA-TYPE"
    APPLICATION_ASSOC_MAP_ELEMENT = "APPLICATION-ASSOC-MAP-ELEMENT"
    APPLICATION_COMPOSITE_DATA_TYPE = "APPLICATION-COMPOSITE-DATA-TYPE"
    APPLICATION_COMPOSITE_ELEMENT_DATA_PROTOTYPE = "APPLICATION-COMPOSITE-ELEMENT-DATA-PROTOTYPE"
    APPLICATION_DATA_TYPE = "APPLICATION-DATA-TYPE"
    APPLICATION_DEFERRED_DATA_TYPE = "APPLICATION-DEFERRED-DATA-TYPE"
    APPLICATION_ENDPOINT = "APPLICATION-ENDPOINT"
    APPLICATION_ERROR = "APPLICATION-ERROR"
    APPLICATION_INTERFACE = "APPLICATION-INTERFACE"
    APPLICATION_PARTITION = "APPLICATION-PARTITION"
    APPLICATION_PARTITION_TO_ECU_PARTITION_MAPPING = (
        "APPLICATION-PARTITION-TO-ECU-PARTITION-MAPPING"
    )
    APPLICATION_PRIMITIVE_DATA_TYPE = "APPLICATION-PRIMITIVE-DATA-TYPE"
    APPLICATION_RECORD_DATA_TYPE = "APPLICATION-RECORD-DATA-TYPE"
    APPLICATION_RECORD_ELEMENT = "APPLICATION-RECORD-ELEMENT"
    APPLICATION_SW_COMPONENT_TYPE = "APPLICATION-SW-COMPONENT-TYPE"
    AR_ELEMENT = "AR-ELEMENT"
    AR_PACKAGE = "AR-PACKAGE"
    ARBITRARY_EVENT_TRIGGERING = "ARBITRARY-EVENT-TRIGGERING"
    ARGUMENT_DATA_PROTOTYPE = "ARGUMENT-DATA-PROTOTYPE"
    ARTIFACT_CHECKSUM = "ARTIFACT-CHECKSUM"
    ARTIFACT_CHECKSUM_TO_CRYPTO_PROVIDER_MAPPING = "ARTIFACT-CHECKSUM-TO-CRYPTO-PROVIDER-MAPPING"
    ARTIFACT_LOCATOR = "ARTIFACT-LOCATOR"
    ASSEMBLY_SW_CONNECTOR = "ASSEMBLY-SW-CONNECTOR"
    ASYNCHRONOUS_SERVER_CALL_POINT = "ASYNCHRONOUS-SERVER-CALL-POINT"
    ASYNCHRONOUS_SERVER_CALL_RESULT_POINT = "ASYNCHRONOUS-SERVER-CALL-RESULT-POINT"
    ASYNCHRONOUS_SERVER_CALL_RETURNS_EVENT = "ASYNCHRONOUS-SERVER-CALL-RETURNS-EVENT"
    ATOMIC_SW_COMPONENT_TYPE = "ATOMIC-SW-COMPONENT-TYPE"
    ATP_BLUEPRINT = "ATP-BLUEPRINT"
    ATP_BLUEPRINTABLE = "ATP-BLUEPRINTABLE"
    ATP_CLASSIFIER = "ATP-CLASSIFIER"
    ATP_FEATURE = "ATP-FEATURE"
    ATP_PROTOTYPE = "ATP-PROTOTYPE"
    ATP_STRUCTURE_ELEMENT = "ATP-STRUCTURE-ELEMENT"
    ATP_TYPE = "ATP-TYPE"
    ATTRIBUTE_TAILORING = "ATTRIBUTE-TAILORING"
    AUTOSAR_DATA_PROTOTYPE = "AUTOSAR-DATA-PROTOTYPE"
    AUTOSAR_DATA_TYPE = "AUTOSAR-DATA-TYPE"
    AUTOSAR_OPERATION_ARGUMENT_INSTANCE = "AUTOSAR-OPERATION-ARGUMENT-INSTANCE"
    AUTOSAR_VARIABLE_INSTANCE = "AUTOSAR-VARIABLE-INSTANCE"
    BACKGROUND_EVENT = "BACKGROUND-EVENT"
    BASE_TYPE = "BASE-TYPE"
    BINARY_MANIFEST_ADDRESSABLE_OBJECT = "BINARY-MANIFEST-ADDRESSABLE-OBJECT"
    BINARY_MANIFEST_ITEM = "BINARY-MANIFEST-ITEM"
    BINARY_MANIFEST_ITEM_DEFINITION = "BINARY-MANIFEST-ITEM-DEFINITION"
    BINARY_MANIFEST_META_DATA_FIELD = "BINARY-MANIFEST-META-DATA-FIELD"
    BINARY_MANIFEST_PROVIDE_RESOURCE = "BINARY-MANIFEST-PROVIDE-RESOURCE"
    BINARY_MANIFEST_REQUIRE_RESOURCE = "BINARY-MANIFEST-REQUIRE-RESOURCE"
    BINARY_MANIFEST_RESOURCE = "BINARY-MANIFEST-RESOURCE"
    BINARY_MANIFEST_RESOURCE_DEFINITION = "BINARY-MANIFEST-RESOURCE-DEFINITION"
    BLOCK_STATE = "BLOCK-STATE"
    BLUEPRINT_MAPPING_SET = "BLUEPRINT-MAPPING-SET"
    BSW_ASYNCHRONOUS_SERVER_CALL_RETURNS_EVENT = "BSW-ASYNCHRONOUS-SERVER-CALL-RETURNS-EVENT"
    BSW_BACKGROUND_EVENT = "BSW-BACKGROUND-EVENT"
    BSW_CALLED_ENTITY = "BSW-CALLED-ENTITY"
    BSW_COMPOSITION_TIMING = "BSW-COMPOSITION-TIMING"
    BSW_DATA_RECEIVED_EVENT = "BSW-DATA-RECEIVED-EVENT"
    BSW_DEBUG_INFO = "BSW-DEBUG-INFO"
    BSW_ENTRY_RELATIONSHIP_SET = "BSW-ENTRY-RELATIONSHIP-SET"
    BSW_EVENT = "BSW-EVENT"
    BSW_EXTERNAL_TRIGGER_OCCURRED_EVENT = "BSW-EXTERNAL-TRIGGER-OCCURRED-EVENT"
    BSW_IMPLEMENTATION = "BSW-IMPLEMENTATION"
    BSW_INTERNAL_BEHAVIOR = "BSW-INTERNAL-BEHAVIOR"
    BSW_INTERNAL_TRIGGER_OCCURRED_EVENT = "BSW-INTERNAL-TRIGGER-OCCURRED-EVENT"
    BSW_INTERNAL_TRIGGERING_POINT = "BSW-INTERNAL-TRIGGERING-POINT"
    BSW_INTERRUPT_ENTITY = "BSW-INTERRUPT-ENTITY"
    BSW_MGR_NEEDS = "BSW-MGR-NEEDS"
    BSW_MODE_MANAGER_ERROR_EVENT = "BSW-MODE-MANAGER-ERROR-EVENT"
    BSW_MODE_SWITCH_EVENT = "BSW-MODE-SWITCH-EVENT"
    BSW_MODE_SWITCHED_ACK_EVENT = "BSW-MODE-SWITCHED-ACK-EVENT"
    BSW_MODULE_DEPENDENCY = "BSW-MODULE-DEPENDENCY"
    BSW_MODULE_DESCRIPTION = "BSW-MODULE-DESCRIPTION"
    BSW_MODULE_ENTITY = "BSW-MODULE-ENTITY"
    BSW_MODULE_ENTRY = "BSW-MODULE-ENTRY"
    BSW_MODULE_TIMING = "BSW-MODULE-TIMING"
    BSW_OPERATION_INVOKED_EVENT = "BSW-OPERATION-INVOKED-EVENT"
    BSW_OS_TASK_EXECUTION_EVENT = "BSW-OS-TASK-EXECUTION-EVENT"
    BSW_SCHEDULABLE_ENTITY = "BSW-SCHEDULABLE-ENTITY"
    BSW_SCHEDULE_EVENT = "BSW-SCHEDULE-EVENT"
    BSW_SERVICE_DEPENDENCY_IDENT = "BSW-SERVICE-DEPENDENCY-IDENT"
    BSW_TIMING_EVENT = "BSW-TIMING-EVENT"
    BUILD_ACTION = "BUILD-ACTION"
    BUILD_ACTION_ENTITY = "BUILD-ACTION-ENTITY"
    BUILD_ACTION_ENVIRONMENT = "BUILD-ACTION-ENVIRONMENT"
    BUILD_ACTION_MANIFEST = "BUILD-ACTION-MANIFEST"
    BULK_NV_DATA_DESCRIPTOR = "BULK-NV-DATA-DESCRIPTOR"
    BURST_PATTERN_EVENT_TRIGGERING = "BURST-PATTERN-EVENT-TRIGGERING"
    BUS_MIRROR_CHANNEL_MAPPING = "BUS-MIRROR-CHANNEL-MAPPING"
    BUS_MIRROR_CHANNEL_MAPPING_CAN = "BUS-MIRROR-CHANNEL-MAPPING-CAN"
    BUS_MIRROR_CHANNEL_MAPPING_FLEXRAY = "BUS-MIRROR-CHANNEL-MAPPING-FLEXRAY"
    BUS_MIRROR_CHANNEL_MAPPING_IP = "BUS-MIRROR-CHANNEL-MAPPING-IP"
    BUS_MIRROR_CHANNEL_MAPPING_USER_DEFINED = "BUS-MIRROR-CHANNEL-MAPPING-USER-DEFINED"
    CALIBRATION_PARAMETER_VALUE_SET = "CALIBRATION-PARAMETER-VALUE-SET"
    CAN_CLUSTER = "CAN-CLUSTER"
    CAN_COMMUNICATION_CONNECTOR = "CAN-COMMUNICATION-CONNECTOR"
    CAN_COMMUNICATION_CONTROLLER = "CAN-COMMUNICATION-CONTROLLER"
    CAN_FRAME = "CAN-FRAME"
    CAN_FRAME_TRIGGERING = "CAN-FRAME-TRIGGERING"
    CAN_NM_CLUSTER = "CAN-NM-CLUSTER"
    CAN_NM_NODE = "CAN-NM-NODE"
    CAN_PHYSICAL_CHANNEL = "CAN-PHYSICAL-CHANNEL"
    CAN_TP_ADDRESS = "CAN-TP-ADDRESS"
    CAN_TP_CHANNEL = "CAN-TP-CHANNEL"
    CAN_TP_CONFIG = "CAN-TP-CONFIG"
    CAN_TP_NODE = "CAN-TP-NODE"
    CAN_XL_PROPS = "CAN-XL-PROPS"
    CHAPTER = "CHAPTER"
    CHECKPOINT_TRANSITION = "CHECKPOINT-TRANSITION"
    CLASS_CONTENT_CONDITIONAL = "CLASS-CONTENT-CONDITIONAL"
    CLIENT_ID_DEFINITION = "CLIENT-ID-DEFINITION"
    CLIENT_ID_DEFINITION_SET = "CLIENT-ID-DEFINITION-SET"
    CLIENT_SERVER_INTERFACE = "CLIENT-SERVER-INTERFACE"
    CLIENT_SERVER_INTERFACE_MAPPING = "CLIENT-SERVER-INTERFACE-MAPPING"
    CLIENT_SERVER_INTERFACE_TO_BSW_MODULE_ENTRY_BLUEPRINT_MAPPING = (
        "CLIENT-SERVER-INTERFACE-TO-BSW-MODULE-ENTRY-BLUEPRINT-MAPPING"
    )
    CLIENT_SERVER_OPERATION = "CLIENT-SERVER-OPERATION"
    CODE = "CODE"
    COLLECTABLE_ELEMENT = "COLLECTABLE-ELEMENT"
    COLLECTION = "COLLECTION"
    COM_CERTIFICATE_TO_CRYPTO_CERTIFICATE_MAPPING = "COM-CERTIFICATE-TO-CRYPTO-CERTIFICATE-MAPPING"
    COM_EVENT_GRANT = "COM-EVENT-GRANT"
    COM_EVENT_GRANT_DESIGN = "COM-EVENT-GRANT-DESIGN"
    COM_FIELD_GRANT = "COM-FIELD-GRANT"
    COM_FIELD_GRANT_DESIGN = "COM-FIELD-GRANT-DESIGN"
    COM_FIND_SERVICE_GRANT = "COM-FIND-SERVICE-GRANT"
    COM_FIND_SERVICE_GRANT_DESIGN = "COM-FIND-SERVICE-GRANT-DESIGN"
    COM_GRANT = "COM-GRANT"
    COM_GRANT_DESIGN = "COM-GRANT-DESIGN"
    COM_KEY_TO_CRYPTO_KEY_SLOT_MAPPING = "COM-KEY-TO-CRYPTO-KEY-SLOT-MAPPING"
    COM_MANAGEMENT_MAPPING = "COM-MANAGEMENT-MAPPING"
    COM_METHOD_GRANT = "COM-METHOD-GRANT"
    COM_METHOD_GRANT_DESIGN = "COM-METHOD-GRANT-DESIGN"
    COM_MGR_USER_NEEDS = "COM-MGR-USER-NEEDS"
    COM_OFFER_SERVICE_GRANT = "COM-OFFER-SERVICE-GRANT"
    COM_OFFER_SERVICE_GRANT_DESIGN = "COM-OFFER-SERVICE-GRANT-DESIGN"
    COM_SEC_OC_TO_CRYPTO_KEY_SLOT_MAPPING = "COM-SEC-OC-TO-CRYPTO-KEY-SLOT-MAPPING"
    COM_TRIGGER_GRANT_DESIGN = "COM-TRIGGER-GRANT-DESIGN"
    COMM_CONNECTOR_PORT = "COMM-CONNECTOR-PORT"
    COMMUNICATION_CLUSTER = "COMMUNICATION-CLUSTER"
    COMMUNICATION_CONNECTOR = "COMMUNICATION-CONNECTOR"
    COMMUNICATION_CONTROLLER = "COMMUNICATION-CONTROLLER"
    COMPILER = "COMPILER"
    COMPLEX_DEVICE_DRIVER_SW_COMPONENT_TYPE = "COMPLEX-DEVICE-DRIVER-SW-COMPONENT-TYPE"
    COMPOSITION_P_PORT_TO_EXECUTABLE_P_PORT_MAPPING = (
        "COMPOSITION-P-PORT-TO-EXECUTABLE-P-PORT-MAPPING"
    )
    COMPOSITION_PORT_TO_EXECUTABLE_PORT_MAPPING = "COMPOSITION-PORT-TO-EXECUTABLE-PORT-MAPPING"
    COMPOSITION_R_PORT_TO_EXECUTABLE_R_PORT_MAPPING = (
        "COMPOSITION-R-PORT-TO-EXECUTABLE-R-PORT-MAPPING"
    )
    COMPOSITION_SW_COMPONENT_TYPE = "COMPOSITION-SW-COMPONENT-TYPE"
    COMPU_METHOD = "COMPU-METHOD"
    CONCRETE_CLASS_TAILORING = "CONCRETE-CLASS-TAILORING"
    CONCRETE_PATTERN_EVENT_TRIGGERING = "CONCRETE-PATTERN-EVENT-TRIGGERING"
    CONSISTENCY_NEEDS = "CONSISTENCY-NEEDS"
    CONSISTENCY_NEEDS_BLUEPRINT_SET = "CONSISTENCY-NEEDS-BLUEPRINT-SET"
    CONSTANT_SPECIFICATION = "CONSTANT-SPECIFICATION"
    CONSTANT_SPECIFICATION_MAPPING_SET = "CONSTANT-SPECIFICATION-MAPPING-SET"
    CONSTRAINT_TAILORING = "CONSTRAINT-TAILORING"
    CONSUMED_EVENT_GROUP = "CONSUMED-EVENT-GROUP"
    CONSUMED_PROVIDED_SERVICE_INSTANCE_GROUP = "CONSUMED-PROVIDED-SERVICE-INSTANCE-GROUP"
    CONSUMED_SERVICE_INSTANCE = "CONSUMED-SERVICE-INSTANCE"
    CONTAINER_I_PDU = "CONTAINER-I-PDU"
    COUPLING_ELEMENT = "COUPLING-ELEMENT"
    COUPLING_PORT = "COUPLING-PORT"
    COUPLING_PORT_FIFO = "COUPLING-PORT-FIFO"
    COUPLING_PORT_SCHEDULER = "COUPLING-PORT-SCHEDULER"
    COUPLING_PORT_SHAPER = "COUPLING-PORT-SHAPER"
    COUPLING_PORT_STRUCTURAL_ELEMENT = "COUPLING-PORT-STRUCTURAL-ELEMENT"
    CP_SOFTWARE_CLUSTER = "CP-SOFTWARE-CLUSTER"
    CP_SOFTWARE_CLUSTER_BINARY_MANIFEST_DESCRIPTOR = (
        "CP-SOFTWARE-CLUSTER-BINARY-MANIFEST-DESCRIPTOR"
    )
    CP_SOFTWARE_CLUSTER_COMMUNICATION_RESOURCE = "CP-SOFTWARE-CLUSTER-COMMUNICATION-RESOURCE"
    CP_SOFTWARE_CLUSTER_MAPPING_SET = "CP-SOFTWARE-CLUSTER-MAPPING-SET"
    CP_SOFTWARE_CLUSTER_RESOURCE = "CP-SOFTWARE-CLUSTER-RESOURCE"
    CP_SOFTWARE_CLUSTER_RESOURCE_POOL = "CP-SOFTWARE-CLUSTER-RESOURCE-POOL"
    CP_SOFTWARE_CLUSTER_RESOURCE_TO_APPLICATION_PARTITION_MAPPING = (
        "CP-SOFTWARE-CLUSTER-RESOURCE-TO-APPLICATION-PARTITION-MAPPING"
    )
    CP_SOFTWARE_CLUSTER_SERVICE_RESOURCE = "CP-SOFTWARE-CLUSTER-SERVICE-RESOURCE"
    CP_SOFTWARE_CLUSTER_TO_ECU_INSTANCE_MAPPING = "CP-SOFTWARE-CLUSTER-TO-ECU-INSTANCE-MAPPING"
    CP_SOFTWARE_CLUSTER_TO_RESOURCE_MAPPING = "CP-SOFTWARE-CLUSTER-TO-RESOURCE-MAPPING"
    CP_SW_CLUSTER_RESOURCE_TO_DIAG_DATA_ELEM_MAPPING = (
        "CP-SW-CLUSTER-RESOURCE-TO-DIAG-DATA-ELEM-MAPPING"
    )
    CP_SW_CLUSTER_RESOURCE_TO_DIAG_FUNCTION_ID_MAPPING = (
        "CP-SW-CLUSTER-RESOURCE-TO-DIAG-FUNCTION-ID-MAPPING"
    )
    CP_SW_CLUSTER_TO_DIAG_EVENT_MAPPING = "CP-SW-CLUSTER-TO-DIAG-EVENT-MAPPING"
    CP_SW_CLUSTER_TO_DIAG_ROUTINE_SUBFUNCTION_MAPPING = (
        "CP-SW-CLUSTER-TO-DIAG-ROUTINE-SUBFUNCTION-MAPPING"
    )
    CPP_IMPLEMENTATION_DATA_TYPE = "CPP-IMPLEMENTATION-DATA-TYPE"
    CPP_IMPLEMENTATION_DATA_TYPE_ELEMENT = "CPP-IMPLEMENTATION-DATA-TYPE-ELEMENT"
    CRYPTO_CERTIFICATE = "CRYPTO-CERTIFICATE"
    CRYPTO_CERTIFICATE_INTERFACE = "CRYPTO-CERTIFICATE-INTERFACE"
    CRYPTO_CERTIFICATE_KEY_SLOT_NEEDS = "CRYPTO-CERTIFICATE-KEY-SLOT-NEEDS"
    CRYPTO_CERTIFICATE_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-CERTIFICATE-TO-PORT-PROTOTYPE-MAPPING"
    CRYPTO_ELLIPTIC_CURVE_PROPS = "CRYPTO-ELLIPTIC-CURVE-PROPS"
    CRYPTO_INTERFACE = "CRYPTO-INTERFACE"
    CRYPTO_KEY_MANAGEMENT_NEEDS = "CRYPTO-KEY-MANAGEMENT-NEEDS"
    CRYPTO_KEY_SLOT = "CRYPTO-KEY-SLOT"
    CRYPTO_KEY_SLOT_INTERFACE = "CRYPTO-KEY-SLOT-INTERFACE"
    CRYPTO_KEY_SLOT_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-KEY-SLOT-TO-PORT-PROTOTYPE-MAPPING"
    CRYPTO_MODULE_INSTANTIATION = "CRYPTO-MODULE-INSTANTIATION"
    CRYPTO_NEEDS = "CRYPTO-NEEDS"
    CRYPTO_PROVIDER = "CRYPTO-PROVIDER"
    CRYPTO_PROVIDER_INTERFACE = "CRYPTO-PROVIDER-INTERFACE"
    CRYPTO_PROVIDER_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-PROVIDER-TO-PORT-PROTOTYPE-MAPPING"
    CRYPTO_SERVICE_CERTIFICATE = "CRYPTO-SERVICE-CERTIFICATE"
    CRYPTO_SERVICE_JOB_NEEDS = "CRYPTO-SERVICE-JOB-NEEDS"
    CRYPTO_SERVICE_KEY = "CRYPTO-SERVICE-KEY"
    CRYPTO_SERVICE_MAPPING = "CRYPTO-SERVICE-MAPPING"
    CRYPTO_SERVICE_NEEDS = "CRYPTO-SERVICE-NEEDS"
    CRYPTO_SERVICE_PRIMITIVE = "CRYPTO-SERVICE-PRIMITIVE"
    CRYPTO_SERVICE_QUEUE = "CRYPTO-SERVICE-QUEUE"
    CRYPTO_SIGNATURE_SCHEME = "CRYPTO-SIGNATURE-SCHEME"
    CRYPTO_TRUST_MASTER_INTERFACE = "CRYPTO-TRUST-MASTER-INTERFACE"
    CUSTOM_CPP_IMPLEMENTATION_DATA_TYPE = "CUSTOM-CPP-IMPLEMENTATION-DATA-TYPE"
    DATA_CONSTR = "DATA-CONSTR"
    DATA_EXCHANGE_POINT = "DATA-EXCHANGE-POINT"
    DATA_FORMAT_ELEMENT_REFERENCE = "DATA-FORMAT-ELEMENT-REFERENCE"
    DATA_FORMAT_ELEMENT_SCOPE = "DATA-FORMAT-ELEMENT-SCOPE"
    DATA_INTERFACE = "DATA-INTERFACE"
    DATA_PROTOTYPE = "DATA-PROTOTYPE"
    DATA_PROTOTYPE_GROUP = "DATA-PROTOTYPE-GROUP"
    DATA_RECEIVE_ERROR_EVENT = "DATA-RECEIVE-ERROR-EVENT"
    DATA_RECEIVED_EVENT = "DATA-RECEIVED-EVENT"
    DATA_SEND_COMPLETED_EVENT = "DATA-SEND-COMPLETED-EVENT"
    DATA_TRANSFORMATION = "DATA-TRANSFORMATION"
    DATA_TRANSFORMATION_SET = "DATA-TRANSFORMATION-SET"
    DATA_TYPE_MAPPING_SET = "DATA-TYPE-MAPPING-SET"
    DATA_WRITE_COMPLETED_EVENT = "DATA-WRITE-COMPLETED-EVENT"
    DCM_I_PDU = "DCM-I-PDU"
    DDS_DOMAIN_RANGE = "DDS-DOMAIN-RANGE"
    DDS_EVENT_DEPLOYMENT = "DDS-EVENT-DEPLOYMENT"
    DDS_FIELD_DEPLOYMENT = "DDS-FIELD-DEPLOYMENT"
    DDS_PROVIDED_SERVICE_INSTANCE = "DDS-PROVIDED-SERVICE-INSTANCE"
    DDS_REQUIRED_SERVICE_INSTANCE = "DDS-REQUIRED-SERVICE-INSTANCE"
    DDS_SECURE_COM_PROPS = "DDS-SECURE-COM-PROPS"
    DDS_SECURE_GOVERNANCE = "DDS-SECURE-GOVERNANCE"
    DDS_SERVICE_INSTANCE_TO_MACHINE_MAPPING = "DDS-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    DDS_SERVICE_INTERFACE_DEPLOYMENT = "DDS-SERVICE-INTERFACE-DEPLOYMENT"
    DDS_TOPIC_ACCESS_RULE = "DDS-TOPIC-ACCESS-RULE"
    DEADLINE_SUPERVISION = "DEADLINE-SUPERVISION"
    DELEGATION_SW_CONNECTOR = "DELEGATION-SW-CONNECTOR"
    DEPENDENCY_ON_ARTIFACT = "DEPENDENCY-ON-ARTIFACT"
    DETERMINISTIC_CLIENT = "DETERMINISTIC-CLIENT"
    DETERMINISTIC_CLIENT_RESOURCE_NEEDS = "DETERMINISTIC-CLIENT-RESOURCE-NEEDS"
    DETERMINISTIC_SYNC_INSTANTIATION = "DETERMINISTIC-SYNC-INSTANTIATION"
    DETERMINISTIC_SYNC_MASTER = "DETERMINISTIC-SYNC-MASTER"
    DETERMINISTIC_SYNC_MASTER_TO_TIME_BASE_CONSUMER_MAPPING = (
        "DETERMINISTIC-SYNC-MASTER-TO-TIME-BASE-CONSUMER-MAPPING"
    )
    DEVELOPMENT_ERROR = "DEVELOPMENT-ERROR"
    DIAG_EVENT_DEBOUNCE_ALGORITHM = "DIAG-EVENT-DEBOUNCE-ALGORITHM"
    DIAG_EVENT_DEBOUNCE_COUNTER_BASED = "DIAG-EVENT-DEBOUNCE-COUNTER-BASED"
    DIAG_EVENT_DEBOUNCE_MONITOR_INTERNAL = "DIAG-EVENT-DEBOUNCE-MONITOR-INTERNAL"
    DIAG_EVENT_DEBOUNCE_TIME_BASED = "DIAG-EVENT-DEBOUNCE-TIME-BASED"
    DIAGNOSTIC_ABSTRACT_ALIAS_EVENT = "DIAGNOSTIC-ABSTRACT-ALIAS-EVENT"
    DIAGNOSTIC_ABSTRACT_DATA_IDENTIFIER = "DIAGNOSTIC-ABSTRACT-DATA-IDENTIFIER"
    DIAGNOSTIC_ABSTRACT_DATA_IDENTIFIER_INTERFACE = "DIAGNOSTIC-ABSTRACT-DATA-IDENTIFIER-INTERFACE"
    DIAGNOSTIC_ABSTRACT_ROUTINE_INTERFACE = "DIAGNOSTIC-ABSTRACT-ROUTINE-INTERFACE"
    DIAGNOSTIC_ACCESS_PERMISSION = "DIAGNOSTIC-ACCESS-PERMISSION"
    DIAGNOSTIC_AGING = "DIAGNOSTIC-AGING"
    DIAGNOSTIC_AUTH_ROLE = "DIAGNOSTIC-AUTH-ROLE"
    DIAGNOSTIC_AUTHENTICATION = "DIAGNOSTIC-AUTHENTICATION"
    DIAGNOSTIC_AUTHENTICATION_CLASS = "DIAGNOSTIC-AUTHENTICATION-CLASS"
    DIAGNOSTIC_AUTHENTICATION_CONFIGURATION = "DIAGNOSTIC-AUTHENTICATION-CONFIGURATION"
    DIAGNOSTIC_AUTHENTICATION_INTERFACE = "DIAGNOSTIC-AUTHENTICATION-INTERFACE"
    DIAGNOSTIC_AUTHENTICATION_PORT_MAPPING = "DIAGNOSTIC-AUTHENTICATION-PORT-MAPPING"
    DIAGNOSTIC_CAPABILITY_ELEMENT = "DIAGNOSTIC-CAPABILITY-ELEMENT"
    DIAGNOSTIC_CLEAR_CONDITION = "DIAGNOSTIC-CLEAR-CONDITION"
    DIAGNOSTIC_CLEAR_CONDITION_GROUP = "DIAGNOSTIC-CLEAR-CONDITION-GROUP"
    DIAGNOSTIC_CLEAR_CONDITION_NEEDS = "DIAGNOSTIC-CLEAR-CONDITION-NEEDS"
    DIAGNOSTIC_CLEAR_CONDITION_PORT_MAPPING = "DIAGNOSTIC-CLEAR-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_CLEAR_DIAGNOSTIC_INFORMATION = "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION"
    DIAGNOSTIC_CLEAR_DIAGNOSTIC_INFORMATION_CLASS = "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION-CLASS"
    DIAGNOSTIC_CLEAR_RESET_EMISSION_RELATED_INFO = "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO"
    DIAGNOSTIC_CLEAR_RESET_EMISSION_RELATED_INFO_CLASS = (
        "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO-CLASS"
    )
    DIAGNOSTIC_COM_CONTROL = "DIAGNOSTIC-COM-CONTROL"
    DIAGNOSTIC_COM_CONTROL_CLASS = "DIAGNOSTIC-COM-CONTROL-CLASS"
    DIAGNOSTIC_COM_CONTROL_INTERFACE = "DIAGNOSTIC-COM-CONTROL-INTERFACE"
    DIAGNOSTIC_COMMON_ELEMENT = "DIAGNOSTIC-COMMON-ELEMENT"
    DIAGNOSTIC_COMMUNICATION_MANAGER_NEEDS = "DIAGNOSTIC-COMMUNICATION-MANAGER-NEEDS"
    DIAGNOSTIC_COMPONENT_NEEDS = "DIAGNOSTIC-COMPONENT-NEEDS"
    DIAGNOSTIC_CONDITION = "DIAGNOSTIC-CONDITION"
    DIAGNOSTIC_CONDITION_GROUP = "DIAGNOSTIC-CONDITION-GROUP"
    DIAGNOSTIC_CONDITION_INTERFACE = "DIAGNOSTIC-CONDITION-INTERFACE"
    DIAGNOSTIC_CONNECTED_INDICATOR = "DIAGNOSTIC-CONNECTED-INDICATOR"
    DIAGNOSTIC_CONNECTION = "DIAGNOSTIC-CONNECTION"
    DIAGNOSTIC_CONTRIBUTION_SET = "DIAGNOSTIC-CONTRIBUTION-SET"
    DIAGNOSTIC_CONTROL_DTC_SETTING = "DIAGNOSTIC-CONTROL-DTC-SETTING"
    DIAGNOSTIC_CONTROL_DTC_SETTING_CLASS = "DIAGNOSTIC-CONTROL-DTC-SETTING-CLASS"
    DIAGNOSTIC_CONTROL_NEEDS = "DIAGNOSTIC-CONTROL-NEEDS"
    DIAGNOSTIC_CUSTOM_SERVICE_CLASS = "DIAGNOSTIC-CUSTOM-SERVICE-CLASS"
    DIAGNOSTIC_CUSTOM_SERVICE_INSTANCE = "DIAGNOSTIC-CUSTOM-SERVICE-INSTANCE"
    DIAGNOSTIC_DATA_BY_IDENTIFIER = "DIAGNOSTIC-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_DATA_ELEMENT = "DIAGNOSTIC-DATA-ELEMENT"
    DIAGNOSTIC_DATA_ELEMENT_INTERFACE = "DIAGNOSTIC-DATA-ELEMENT-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER = "DIAGNOSTIC-DATA-IDENTIFIER"
    DIAGNOSTIC_DATA_IDENTIFIER_GENERIC_INTERFACE = "DIAGNOSTIC-DATA-IDENTIFIER-GENERIC-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER_INTERFACE = "DIAGNOSTIC-DATA-IDENTIFIER-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER_SET = "DIAGNOSTIC-DATA-IDENTIFIER-SET"
    DIAGNOSTIC_DATA_PORT_MAPPING = "DIAGNOSTIC-DATA-PORT-MAPPING"
    DIAGNOSTIC_DATA_TRANSFER = "DIAGNOSTIC-DATA-TRANSFER"
    DIAGNOSTIC_DATA_TRANSFER_CLASS = "DIAGNOSTIC-DATA-TRANSFER-CLASS"
    DIAGNOSTIC_DE_AUTHENTICATION = "DIAGNOSTIC-DE-AUTHENTICATION"
    DIAGNOSTIC_DEBOUNCE_ALGORITHM_PROPS = "DIAGNOSTIC-DEBOUNCE-ALGORITHM-PROPS"
    DIAGNOSTIC_DEM_PROVIDED_DATA_MAPPING = "DIAGNOSTIC-DEM-PROVIDED-DATA-MAPPING"
    DIAGNOSTIC_DO_IP_ACTIVATION_LINE_INTERFACE = "DIAGNOSTIC-DO-IP-ACTIVATION-LINE-INTERFACE"
    DIAGNOSTIC_DO_IP_ENTITY_IDENTIFICATION_INTERFACE = (
        "DIAGNOSTIC-DO-IP-ENTITY-IDENTIFICATION-INTERFACE"
    )
    DIAGNOSTIC_DO_IP_GROUP_IDENTIFICATION_INTERFACE = (
        "DIAGNOSTIC-DO-IP-GROUP-IDENTIFICATION-INTERFACE"
    )
    DIAGNOSTIC_DO_IP_POWER_MODE_INTERFACE = "DIAGNOSTIC-DO-IP-POWER-MODE-INTERFACE"
    DIAGNOSTIC_DO_IP_TRIGGER_VEHICLE_ANNOUNCEMENT_INTERFACE = (
        "DIAGNOSTIC-DO-IP-TRIGGER-VEHICLE-ANNOUNCEMENT-INTERFACE"
    )
    DIAGNOSTIC_DOWNLOAD_INTERFACE = "DIAGNOSTIC-DOWNLOAD-INTERFACE"
    DIAGNOSTIC_DTC_INFORMATION_INTERFACE = "DIAGNOSTIC-DTC-INFORMATION-INTERFACE"
    DIAGNOSTIC_DYNAMIC_DATA_IDENTIFIER = "DIAGNOSTIC-DYNAMIC-DATA-IDENTIFIER"
    DIAGNOSTIC_DYNAMICALLY_DEFINE_DATA_IDENTIFIER = "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER"
    DIAGNOSTIC_DYNAMICALLY_DEFINE_DATA_IDENTIFIER_CLASS = (
        "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER-CLASS"
    )
    DIAGNOSTIC_ECU_INSTANCE_PROPS = "DIAGNOSTIC-ECU-INSTANCE-PROPS"
    DIAGNOSTIC_ECU_RESET = "DIAGNOSTIC-ECU-RESET"
    DIAGNOSTIC_ECU_RESET_CLASS = "DIAGNOSTIC-ECU-RESET-CLASS"
    DIAGNOSTIC_ECU_RESET_INTERFACE = "DIAGNOSTIC-ECU-RESET-INTERFACE"
    DIAGNOSTIC_ENABLE_CONDITION = "DIAGNOSTIC-ENABLE-CONDITION"
    DIAGNOSTIC_ENABLE_CONDITION_GROUP = "DIAGNOSTIC-ENABLE-CONDITION-GROUP"
    DIAGNOSTIC_ENABLE_CONDITION_NEEDS = "DIAGNOSTIC-ENABLE-CONDITION-NEEDS"
    DIAGNOSTIC_ENABLE_CONDITION_PORT_MAPPING = "DIAGNOSTIC-ENABLE-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_ENVIRONMENTAL_CONDITION = "DIAGNOSTIC-ENVIRONMENTAL-CONDITION"
    DIAGNOSTIC_EVENT = "DIAGNOSTIC-EVENT"
    DIAGNOSTIC_EVENT_INFO_NEEDS = "DIAGNOSTIC-EVENT-INFO-NEEDS"
    DIAGNOSTIC_EVENT_INTERFACE = "DIAGNOSTIC-EVENT-INTERFACE"
    DIAGNOSTIC_EVENT_MANAGER_NEEDS = "DIAGNOSTIC-EVENT-MANAGER-NEEDS"
    DIAGNOSTIC_EVENT_NEEDS = "DIAGNOSTIC-EVENT-NEEDS"
    DIAGNOSTIC_EVENT_PORT_MAPPING = "DIAGNOSTIC-EVENT-PORT-MAPPING"
    DIAGNOSTIC_EVENT_TO_DEBOUNCE_ALGORITHM_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-DEBOUNCE-ALGORITHM-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_ENABLE_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-ENABLE-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_OPERATION_CYCLE_MAPPING = "DIAGNOSTIC-EVENT-TO-OPERATION-CYCLE-MAPPING"
    DIAGNOSTIC_EVENT_TO_SECURITY_EVENT_MAPPING = "DIAGNOSTIC-EVENT-TO-SECURITY-EVENT-MAPPING"
    DIAGNOSTIC_EVENT_TO_STORAGE_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-STORAGE-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_TROUBLE_CODE_J_1939_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-TROUBLE-CODE-J-1939-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_TROUBLE_CODE_UDS_MAPPING = "DIAGNOSTIC-EVENT-TO-TROUBLE-CODE-UDS-MAPPING"
    DIAGNOSTIC_EXTENDED_DATA_RECORD = "DIAGNOSTIC-EXTENDED-DATA-RECORD"
    DIAGNOSTIC_EXTERNAL_AUTHENTICATION_INTERFACE = "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-INTERFACE"
    DIAGNOSTIC_EXTERNAL_AUTHENTICATION_PORT_MAPPING = (
        "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-PORT-MAPPING"
    )
    DIAGNOSTIC_FIM_ALIAS_EVENT = "DIAGNOSTIC-FIM-ALIAS-EVENT"
    DIAGNOSTIC_FIM_ALIAS_EVENT_GROUP = "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP"
    DIAGNOSTIC_FIM_ALIAS_EVENT_GROUP_MAPPING = "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP-MAPPING"
    DIAGNOSTIC_FIM_ALIAS_EVENT_MAPPING = "DIAGNOSTIC-FIM-ALIAS-EVENT-MAPPING"
    DIAGNOSTIC_FIM_EVENT_GROUP = "DIAGNOSTIC-FIM-EVENT-GROUP"
    DIAGNOSTIC_FIM_FUNCTION_MAPPING = "DIAGNOSTIC-FIM-FUNCTION-MAPPING"
    DIAGNOSTIC_FREEZE_FRAME = "DIAGNOSTIC-FREEZE-FRAME"
    DIAGNOSTIC_FUNCTION_IDENTIFIER = "DIAGNOSTIC-FUNCTION-IDENTIFIER"
    DIAGNOSTIC_FUNCTION_IDENTIFIER_INHIBIT = "DIAGNOSTIC-FUNCTION-IDENTIFIER-INHIBIT"
    DIAGNOSTIC_FUNCTION_INHIBIT_SOURCE = "DIAGNOSTIC-FUNCTION-INHIBIT-SOURCE"
    DIAGNOSTIC_GENERIC_UDS_INTERFACE = "DIAGNOSTIC-GENERIC-UDS-INTERFACE"
    DIAGNOSTIC_GENERIC_UDS_NEEDS = "DIAGNOSTIC-GENERIC-UDS-NEEDS"
    DIAGNOSTIC_INDICATOR = "DIAGNOSTIC-INDICATOR"
    DIAGNOSTIC_INDICATOR_INTERFACE = "DIAGNOSTIC-INDICATOR-INTERFACE"
    DIAGNOSTIC_INDICATOR_NEEDS = "DIAGNOSTIC-INDICATOR-NEEDS"
    DIAGNOSTIC_INDICATOR_PORT_MAPPING = "DIAGNOSTIC-INDICATOR-PORT-MAPPING"
    DIAGNOSTIC_INFO_TYPE = "DIAGNOSTIC-INFO-TYPE"
    DIAGNOSTIC_INHIBIT_SOURCE_EVENT_MAPPING = "DIAGNOSTIC-INHIBIT-SOURCE-EVENT-MAPPING"
    DIAGNOSTIC_IO_CONTROL = "DIAGNOSTIC-IO-CONTROL"
    DIAGNOSTIC_IO_CONTROL_CLASS = "DIAGNOSTIC-IO-CONTROL-CLASS"
    DIAGNOSTIC_IO_CONTROL_NEEDS = "DIAGNOSTIC-IO-CONTROL-NEEDS"
    DIAGNOSTIC_IUMPR = "DIAGNOSTIC-IUMPR"
    DIAGNOSTIC_IUMPR_DENOMINATOR_GROUP = "DIAGNOSTIC-IUMPR-DENOMINATOR-GROUP"
    DIAGNOSTIC_IUMPR_GROUP = "DIAGNOSTIC-IUMPR-GROUP"
    DIAGNOSTIC_IUMPR_TO_FUNCTION_IDENTIFIER_MAPPING = (
        "DIAGNOSTIC-IUMPR-TO-FUNCTION-IDENTIFIER-MAPPING"
    )
    DIAGNOSTIC_J_1939_EXPANDED_FREEZE_FRAME = "DIAGNOSTIC-J-1939-EXPANDED-FREEZE-FRAME"
    DIAGNOSTIC_J_1939_FREEZE_FRAME = "DIAGNOSTIC-J-1939-FREEZE-FRAME"
    DIAGNOSTIC_J_1939_NODE = "DIAGNOSTIC-J-1939-NODE"
    DIAGNOSTIC_J_1939_SPN = "DIAGNOSTIC-J-1939-SPN"
    DIAGNOSTIC_J_1939_SPN_MAPPING = "DIAGNOSTIC-J-1939-SPN-MAPPING"
    DIAGNOSTIC_J_1939_SW_MAPPING = "DIAGNOSTIC-J-1939-SW-MAPPING"
    DIAGNOSTIC_MAPPING = "DIAGNOSTIC-MAPPING"
    DIAGNOSTIC_MASTER_TO_SLAVE_EVENT_MAPPING = "DIAGNOSTIC-MASTER-TO-SLAVE-EVENT-MAPPING"
    DIAGNOSTIC_MASTER_TO_SLAVE_EVENT_MAPPING_SET = "DIAGNOSTIC-MASTER-TO-SLAVE-EVENT-MAPPING-SET"
    DIAGNOSTIC_MEASUREMENT_IDENTIFIER = "DIAGNOSTIC-MEASUREMENT-IDENTIFIER"
    DIAGNOSTIC_MEMORY_ADDRESSABLE_RANGE_ACCESS = "DIAGNOSTIC-MEMORY-ADDRESSABLE-RANGE-ACCESS"
    DIAGNOSTIC_MEMORY_BY_ADDRESS = "DIAGNOSTIC-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_MEMORY_DESTINATION = "DIAGNOSTIC-MEMORY-DESTINATION"
    DIAGNOSTIC_MEMORY_DESTINATION_MIRROR = "DIAGNOSTIC-MEMORY-DESTINATION-MIRROR"
    DIAGNOSTIC_MEMORY_DESTINATION_PORT_MAPPING = "DIAGNOSTIC-MEMORY-DESTINATION-PORT-MAPPING"
    DIAGNOSTIC_MEMORY_DESTINATION_PRIMARY = "DIAGNOSTIC-MEMORY-DESTINATION-PRIMARY"
    DIAGNOSTIC_MEMORY_DESTINATION_USER_DEFINED = "DIAGNOSTIC-MEMORY-DESTINATION-USER-DEFINED"
    DIAGNOSTIC_MEMORY_IDENTIFIER = "DIAGNOSTIC-MEMORY-IDENTIFIER"
    DIAGNOSTIC_MONITOR_INTERFACE = "DIAGNOSTIC-MONITOR-INTERFACE"
    DIAGNOSTIC_MONITOR_PORT_MAPPING = "DIAGNOSTIC-MONITOR-PORT-MAPPING"
    DIAGNOSTIC_OPERATION_CYCLE = "DIAGNOSTIC-OPERATION-CYCLE"
    DIAGNOSTIC_OPERATION_CYCLE_INTERFACE = "DIAGNOSTIC-OPERATION-CYCLE-INTERFACE"
    DIAGNOSTIC_OPERATION_CYCLE_NEEDS = "DIAGNOSTIC-OPERATION-CYCLE-NEEDS"
    DIAGNOSTIC_OPERATION_CYCLE_PORT_MAPPING = "DIAGNOSTIC-OPERATION-CYCLE-PORT-MAPPING"
    DIAGNOSTIC_PARAMETER_ELEMENT = "DIAGNOSTIC-PARAMETER-ELEMENT"
    DIAGNOSTIC_PARAMETER_IDENT = "DIAGNOSTIC-PARAMETER-IDENT"
    DIAGNOSTIC_PARAMETER_IDENTIFIER = "DIAGNOSTIC-PARAMETER-IDENTIFIER"
    DIAGNOSTIC_PORT_INTERFACE = "DIAGNOSTIC-PORT-INTERFACE"
    DIAGNOSTIC_POWERTRAIN_FREEZE_FRAME = "DIAGNOSTIC-POWERTRAIN-FREEZE-FRAME"
    DIAGNOSTIC_PROOF_OF_OWNERSHIP = "DIAGNOSTIC-PROOF-OF-OWNERSHIP"
    DIAGNOSTIC_PROTOCOL = "DIAGNOSTIC-PROTOCOL"
    DIAGNOSTIC_PROVIDED_DATA_MAPPING = "DIAGNOSTIC-PROVIDED-DATA-MAPPING"
    DIAGNOSTIC_READ_DATA_BY_IDENTIFIER = "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_READ_DATA_BY_IDENTIFIER_CLASS = "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER-CLASS"
    DIAGNOSTIC_READ_DATA_BY_PERIODIC_ID = "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID"
    DIAGNOSTIC_READ_DATA_BY_PERIODIC_ID_CLASS = "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID-CLASS"
    DIAGNOSTIC_READ_DTC_INFORMATION = "DIAGNOSTIC-READ-DTC-INFORMATION"
    DIAGNOSTIC_READ_DTC_INFORMATION_CLASS = "DIAGNOSTIC-READ-DTC-INFORMATION-CLASS"
    DIAGNOSTIC_READ_MEMORY_BY_ADDRESS = "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_READ_MEMORY_BY_ADDRESS_CLASS = "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS-CLASS"
    DIAGNOSTIC_READ_SCALING_DATA_BY_IDENTIFIER = "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_READ_SCALING_DATA_BY_IDENTIFIER_CLASS = (
        "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER-CLASS"
    )
    DIAGNOSTIC_REQUEST_CONTROL_OF_ON_BOARD_DEVICE = "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE"
    DIAGNOSTIC_REQUEST_CONTROL_OF_ON_BOARD_DEVICE_CLASS = (
        "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE-CLASS"
    )
    DIAGNOSTIC_REQUEST_CURRENT_POWERTRAIN_DATA = "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA"
    DIAGNOSTIC_REQUEST_CURRENT_POWERTRAIN_DATA_CLASS = (
        "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA-CLASS"
    )
    DIAGNOSTIC_REQUEST_DOWNLOAD = "DIAGNOSTIC-REQUEST-DOWNLOAD"
    DIAGNOSTIC_REQUEST_DOWNLOAD_CLASS = "DIAGNOSTIC-REQUEST-DOWNLOAD-CLASS"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_CLASS = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-CLASS"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_PERMANENT_STATUS = (
        "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS"
    )
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_PERMANENT_STATUS_CLASS = (
        "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS-CLASS"
    )
    DIAGNOSTIC_REQUEST_FILE_TRANSFER = "DIAGNOSTIC-REQUEST-FILE-TRANSFER"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_CLASS = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-CLASS"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_INTERFACE = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-INTERFACE"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_NEEDS = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-NEEDS"
    DIAGNOSTIC_REQUEST_ON_BOARD_MONITORING_TEST_RESULTS = (
        "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS"
    )
    DIAGNOSTIC_REQUEST_ON_BOARD_MONITORING_TEST_RESULTS_CLASS = (
        "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS-CLASS"
    )
    DIAGNOSTIC_REQUEST_POWERTRAIN_FREEZE_FRAME_DATA = (
        "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA"
    )
    DIAGNOSTIC_REQUEST_POWERTRAIN_FREEZE_FRAME_DATA_CLASS = (
        "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA-CLASS"
    )
    DIAGNOSTIC_REQUEST_ROUTINE_RESULTS = "DIAGNOSTIC-REQUEST-ROUTINE-RESULTS"
    DIAGNOSTIC_REQUEST_UPLOAD = "DIAGNOSTIC-REQUEST-UPLOAD"
    DIAGNOSTIC_REQUEST_UPLOAD_CLASS = "DIAGNOSTIC-REQUEST-UPLOAD-CLASS"
    DIAGNOSTIC_REQUEST_VEHICLE_INFO = "DIAGNOSTIC-REQUEST-VEHICLE-INFO"
    DIAGNOSTIC_REQUEST_VEHICLE_INFO_CLASS = "DIAGNOSTIC-REQUEST-VEHICLE-INFO-CLASS"
    DIAGNOSTIC_RESPONSE_ON_EVENT = "DIAGNOSTIC-RESPONSE-ON-EVENT"
    DIAGNOSTIC_RESPONSE_ON_EVENT_CLASS = "DIAGNOSTIC-RESPONSE-ON-EVENT-CLASS"
    DIAGNOSTIC_RESPONSE_ON_EVENT_NEEDS = "DIAGNOSTIC-RESPONSE-ON-EVENT-NEEDS"
    DIAGNOSTIC_ROUTINE = "DIAGNOSTIC-ROUTINE"
    DIAGNOSTIC_ROUTINE_CONTROL = "DIAGNOSTIC-ROUTINE-CONTROL"
    DIAGNOSTIC_ROUTINE_CONTROL_CLASS = "DIAGNOSTIC-ROUTINE-CONTROL-CLASS"
    DIAGNOSTIC_ROUTINE_GENERIC_INTERFACE = "DIAGNOSTIC-ROUTINE-GENERIC-INTERFACE"
    DIAGNOSTIC_ROUTINE_INTERFACE = "DIAGNOSTIC-ROUTINE-INTERFACE"
    DIAGNOSTIC_ROUTINE_NEEDS = "DIAGNOSTIC-ROUTINE-NEEDS"
    DIAGNOSTIC_ROUTINE_SUBFUNCTION = "DIAGNOSTIC-ROUTINE-SUBFUNCTION"
    DIAGNOSTIC_SECURITY_ACCESS = "DIAGNOSTIC-SECURITY-ACCESS"
    DIAGNOSTIC_SECURITY_ACCESS_CLASS = "DIAGNOSTIC-SECURITY-ACCESS-CLASS"
    DIAGNOSTIC_SECURITY_EVENT_REPORTING_MODE_MAPPING = (
        "DIAGNOSTIC-SECURITY-EVENT-REPORTING-MODE-MAPPING"
    )
    DIAGNOSTIC_SECURITY_LEVEL = "DIAGNOSTIC-SECURITY-LEVEL"
    DIAGNOSTIC_SECURITY_LEVEL_INTERFACE = "DIAGNOSTIC-SECURITY-LEVEL-INTERFACE"
    DIAGNOSTIC_SECURITY_LEVEL_PORT_MAPPING = "DIAGNOSTIC-SECURITY-LEVEL-PORT-MAPPING"
    DIAGNOSTIC_SERVICE_CLASS = "DIAGNOSTIC-SERVICE-CLASS"
    DIAGNOSTIC_SERVICE_DATA_MAPPING = "DIAGNOSTIC-SERVICE-DATA-MAPPING"
    DIAGNOSTIC_SERVICE_GENERIC_MAPPING = "DIAGNOSTIC-SERVICE-GENERIC-MAPPING"
    DIAGNOSTIC_SERVICE_INSTANCE = "DIAGNOSTIC-SERVICE-INSTANCE"
    DIAGNOSTIC_SERVICE_SW_MAPPING = "DIAGNOSTIC-SERVICE-SW-MAPPING"
    DIAGNOSTIC_SERVICE_TABLE = "DIAGNOSTIC-SERVICE-TABLE"
    DIAGNOSTIC_SERVICE_VALIDATION_INTERFACE = "DIAGNOSTIC-SERVICE-VALIDATION-INTERFACE"
    DIAGNOSTIC_SERVICE_VALIDATION_MAPPING = "DIAGNOSTIC-SERVICE-VALIDATION-MAPPING"
    DIAGNOSTIC_SESSION = "DIAGNOSTIC-SESSION"
    DIAGNOSTIC_SESSION_CONTROL = "DIAGNOSTIC-SESSION-CONTROL"
    DIAGNOSTIC_SESSION_CONTROL_CLASS = "DIAGNOSTIC-SESSION-CONTROL-CLASS"
    DIAGNOSTIC_SOVD_AUTHORIZATION_INTERFACE = "DIAGNOSTIC-SOVD-AUTHORIZATION-INTERFACE"
    DIAGNOSTIC_SOVD_AUTHORIZATION_PORT_MAPPING = "DIAGNOSTIC-SOVD-AUTHORIZATION-PORT-MAPPING"
    DIAGNOSTIC_SOVD_LOCK = "DIAGNOSTIC-SOVD-LOCK"
    DIAGNOSTIC_SOVD_PORT_INTERFACE = "DIAGNOSTIC-SOVD-PORT-INTERFACE"
    DIAGNOSTIC_SOVD_PROXIMITY_CHALLENGE_INTERFACE = "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-INTERFACE"
    DIAGNOSTIC_SOVD_PROXIMITY_CHALLENGE_PORT_MAPPING = (
        "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-PORT-MAPPING"
    )
    DIAGNOSTIC_START_ROUTINE = "DIAGNOSTIC-START-ROUTINE"
    DIAGNOSTIC_STOP_ROUTINE = "DIAGNOSTIC-STOP-ROUTINE"
    DIAGNOSTIC_STORAGE_CONDITION = "DIAGNOSTIC-STORAGE-CONDITION"
    DIAGNOSTIC_STORAGE_CONDITION_GROUP = "DIAGNOSTIC-STORAGE-CONDITION-GROUP"
    DIAGNOSTIC_STORAGE_CONDITION_NEEDS = "DIAGNOSTIC-STORAGE-CONDITION-NEEDS"
    DIAGNOSTIC_STORAGE_CONDITION_PORT_MAPPING = "DIAGNOSTIC-STORAGE-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_SW_MAPPING = "DIAGNOSTIC-SW-MAPPING"
    DIAGNOSTIC_TEST_RESULT = "DIAGNOSTIC-TEST-RESULT"
    DIAGNOSTIC_TEST_ROUTINE_IDENTIFIER = "DIAGNOSTIC-TEST-ROUTINE-IDENTIFIER"
    DIAGNOSTIC_TRANSFER_EXIT = "DIAGNOSTIC-TRANSFER-EXIT"
    DIAGNOSTIC_TRANSFER_EXIT_CLASS = "DIAGNOSTIC-TRANSFER-EXIT-CLASS"
    DIAGNOSTIC_TROUBLE_CODE = "DIAGNOSTIC-TROUBLE-CODE"
    DIAGNOSTIC_TROUBLE_CODE_GROUP = "DIAGNOSTIC-TROUBLE-CODE-GROUP"
    DIAGNOSTIC_TROUBLE_CODE_J_1939 = "DIAGNOSTIC-TROUBLE-CODE-J-1939"
    DIAGNOSTIC_TROUBLE_CODE_OBD = "DIAGNOSTIC-TROUBLE-CODE-OBD"
    DIAGNOSTIC_TROUBLE_CODE_PROPS = "DIAGNOSTIC-TROUBLE-CODE-PROPS"
    DIAGNOSTIC_TROUBLE_CODE_UDS = "DIAGNOSTIC-TROUBLE-CODE-UDS"
    DIAGNOSTIC_TROUBLE_CODE_UDS_TO_CLEAR_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-TROUBLE-CODE-UDS-TO-CLEAR-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_TROUBLE_CODE_UDS_TO_TROUBLE_CODE_OBD_MAPPING = (
        "DIAGNOSTIC-TROUBLE-CODE-UDS-TO-TROUBLE-CODE-OBD-MAPPING"
    )
    DIAGNOSTIC_UPLOAD_DOWNLOAD_NEEDS = "DIAGNOSTIC-UPLOAD-DOWNLOAD-NEEDS"
    DIAGNOSTIC_UPLOAD_INTERFACE = "DIAGNOSTIC-UPLOAD-INTERFACE"
    DIAGNOSTIC_VALUE_NEEDS = "DIAGNOSTIC-VALUE-NEEDS"
    DIAGNOSTIC_VERIFY_CERTIFICATE_BIDIRECTIONAL = "DIAGNOSTIC-VERIFY-CERTIFICATE-BIDIRECTIONAL"
    DIAGNOSTIC_VERIFY_CERTIFICATE_UNIDIRECTIONAL = "DIAGNOSTIC-VERIFY-CERTIFICATE-UNIDIRECTIONAL"
    DIAGNOSTIC_WRITE_DATA_BY_IDENTIFIER = "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_WRITE_DATA_BY_IDENTIFIER_CLASS = "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER-CLASS"
    DIAGNOSTIC_WRITE_MEMORY_BY_ADDRESS = "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_WRITE_MEMORY_BY_ADDRESS_CLASS = "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS-CLASS"
    DIAGNOSTICS_COMMUNICATION_SECURITY_NEEDS = "DIAGNOSTICS-COMMUNICATION-SECURITY-NEEDS"
    DLT_APPLICATION = "DLT-APPLICATION"
    DLT_APPLICATION_TO_PROCESS_MAPPING = "DLT-APPLICATION-TO-PROCESS-MAPPING"
    DLT_ARGUMENT = "DLT-ARGUMENT"
    DLT_CONTEXT = "DLT-CONTEXT"
    DLT_ECU = "DLT-ECU"
    DLT_LOG_CHANNEL = "DLT-LOG-CHANNEL"
    DLT_LOG_SINK = "DLT-LOG-SINK"
    DLT_LOG_SINK_TO_PORT_PROTOTYPE_MAPPING = "DLT-LOG-SINK-TO-PORT-PROTOTYPE-MAPPING"
    DLT_MESSAGE = "DLT-MESSAGE"
    DLT_MESSAGE_COLLECTION_SET = "DLT-MESSAGE-COLLECTION-SET"
    DLT_USER_NEEDS = "DLT-USER-NEEDS"
    DO_IP_ACTIVATION_LINE_NEEDS = "DO-IP-ACTIVATION-LINE-NEEDS"
    DO_IP_GID_NEEDS = "DO-IP-GID-NEEDS"
    DO_IP_GID_SYNCHRONIZATION_NEEDS = "DO-IP-GID-SYNCHRONIZATION-NEEDS"
    DO_IP_INSTANTIATION = "DO-IP-INSTANTIATION"
    DO_IP_INTERFACE = "DO-IP-INTERFACE"
    DO_IP_LOGIC_ADDRESS = "DO-IP-LOGIC-ADDRESS"
    DO_IP_LOGIC_TARGET_ADDRESS_PROPS = "DO-IP-LOGIC-TARGET-ADDRESS-PROPS"
    DO_IP_LOGIC_TESTER_ADDRESS_PROPS = "DO-IP-LOGIC-TESTER-ADDRESS-PROPS"
    DO_IP_POWER_MODE_STATUS_NEEDS = "DO-IP-POWER-MODE-STATUS-NEEDS"
    DO_IP_ROUTING_ACTIVATION = "DO-IP-ROUTING-ACTIVATION"
    DO_IP_ROUTING_ACTIVATION_AUTHENTICATION_NEEDS = "DO-IP-ROUTING-ACTIVATION-AUTHENTICATION-NEEDS"
    DO_IP_ROUTING_ACTIVATION_CONFIRMATION_NEEDS = "DO-IP-ROUTING-ACTIVATION-CONFIRMATION-NEEDS"
    DO_IP_SERVICE_NEEDS = "DO-IP-SERVICE-NEEDS"
    DO_IP_TP_CONFIG = "DO-IP-TP-CONFIG"
    DOCUMENT_ELEMENT_SCOPE = "DOCUMENT-ELEMENT-SCOPE"
    DOCUMENTATION = "DOCUMENTATION"
    DTC_STATUS_CHANGE_NOTIFICATION_NEEDS = "DTC-STATUS-CHANGE-NOTIFICATION-NEEDS"
    E_2_E_PROFILE_COMPATIBILITY_PROPS = "E-2-E-PROFILE-COMPATIBILITY-PROPS"
    E_2_E_PROFILE_CONFIGURATION = "E-2-E-PROFILE-CONFIGURATION"
    E_2_E_PROFILE_CONFIGURATION_SET = "E-2-E-PROFILE-CONFIGURATION-SET"
    ECU_ABSTRACTION_SW_COMPONENT_TYPE = "ECU-ABSTRACTION-SW-COMPONENT-TYPE"
    ECU_INSTANCE = "ECU-INSTANCE"
    ECU_MAPPING = "ECU-MAPPING"
    ECU_PARTITION = "ECU-PARTITION"
    ECU_STATE_MGR_USER_NEEDS = "ECU-STATE-MGR-USER-NEEDS"
    ECU_TIMING = "ECU-TIMING"
    ECUC_ABSTRACT_EXTERNAL_REFERENCE_DEF = "ECUC-ABSTRACT-EXTERNAL-REFERENCE-DEF"
    ECUC_ABSTRACT_INTERNAL_REFERENCE_DEF = "ECUC-ABSTRACT-INTERNAL-REFERENCE-DEF"
    ECUC_ABSTRACT_REFERENCE_DEF = "ECUC-ABSTRACT-REFERENCE-DEF"
    ECUC_ABSTRACT_STRING_PARAM_DEF = "ECUC-ABSTRACT-STRING-PARAM-DEF"
    ECUC_ADD_INFO_PARAM_DEF = "ECUC-ADD-INFO-PARAM-DEF"
    ECUC_BOOLEAN_PARAM_DEF = "ECUC-BOOLEAN-PARAM-DEF"
    ECUC_CHOICE_CONTAINER_DEF = "ECUC-CHOICE-CONTAINER-DEF"
    ECUC_CHOICE_REFERENCE_DEF = "ECUC-CHOICE-REFERENCE-DEF"
    ECUC_COMMON_ATTRIBUTES = "ECUC-COMMON-ATTRIBUTES"
    ECUC_CONTAINER_DEF = "ECUC-CONTAINER-DEF"
    ECUC_CONTAINER_VALUE = "ECUC-CONTAINER-VALUE"
    ECUC_DEFINITION_COLLECTION = "ECUC-DEFINITION-COLLECTION"
    ECUC_DEFINITION_ELEMENT = "ECUC-DEFINITION-ELEMENT"
    ECUC_DESTINATION_URI_DEF = "ECUC-DESTINATION-URI-DEF"
    ECUC_DESTINATION_URI_DEF_SET = "ECUC-DESTINATION-URI-DEF-SET"
    ECUC_ENUMERATION_LITERAL_DEF = "ECUC-ENUMERATION-LITERAL-DEF"
    ECUC_ENUMERATION_PARAM_DEF = "ECUC-ENUMERATION-PARAM-DEF"
    ECUC_FLOAT_PARAM_DEF = "ECUC-FLOAT-PARAM-DEF"
    ECUC_FOREIGN_REFERENCE_DEF = "ECUC-FOREIGN-REFERENCE-DEF"
    ECUC_FUNCTION_NAME_DEF = "ECUC-FUNCTION-NAME-DEF"
    ECUC_INSTANCE_REFERENCE_DEF = "ECUC-INSTANCE-REFERENCE-DEF"
    ECUC_INTEGER_PARAM_DEF = "ECUC-INTEGER-PARAM-DEF"
    ECUC_LINKER_SYMBOL_DEF = "ECUC-LINKER-SYMBOL-DEF"
    ECUC_MODULE_CONFIGURATION_VALUES = "ECUC-MODULE-CONFIGURATION-VALUES"
    ECUC_MODULE_DEF = "ECUC-MODULE-DEF"
    ECUC_MULTILINE_STRING_PARAM_DEF = "ECUC-MULTILINE-STRING-PARAM-DEF"
    ECUC_PARAM_CONF_CONTAINER_DEF = "ECUC-PARAM-CONF-CONTAINER-DEF"
    ECUC_PARAMETER_DEF = "ECUC-PARAMETER-DEF"
    ECUC_QUERY = "ECUC-QUERY"
    ECUC_REFERENCE_DEF = "ECUC-REFERENCE-DEF"
    ECUC_STRING_PARAM_DEF = "ECUC-STRING-PARAM-DEF"
    ECUC_SYMBOLIC_NAME_REFERENCE_DEF = "ECUC-SYMBOLIC-NAME-REFERENCE-DEF"
    ECUC_URI_REFERENCE_DEF = "ECUC-URI-REFERENCE-DEF"
    ECUC_VALIDATION_CONDITION = "ECUC-VALIDATION-CONDITION"
    ECUC_VALUE_COLLECTION = "ECUC-VALUE-COLLECTION"
    END_2_END_EVENT_PROTECTION_PROPS = "END-2-END-EVENT-PROTECTION-PROPS"
    END_2_END_METHOD_PROTECTION_PROPS = "END-2-END-METHOD-PROTECTION-PROPS"
    END_TO_END_PROTECTION = "END-TO-END-PROTECTION"
    END_TO_END_PROTECTION_SET = "END-TO-END-PROTECTION-SET"
    ENUMERATION_MAPPING_TABLE = "ENUMERATION-MAPPING-TABLE"
    EOC_EVENT_REF = "EOC-EVENT-REF"
    EOC_EXECUTABLE_ENTITY_REF = "EOC-EXECUTABLE-ENTITY-REF"
    EOC_EXECUTABLE_ENTITY_REF_ABSTRACT = "EOC-EXECUTABLE-ENTITY-REF-ABSTRACT"
    EOC_EXECUTABLE_ENTITY_REF_GROUP = "EOC-EXECUTABLE-ENTITY-REF-GROUP"
    ERROR_TRACER_NEEDS = "ERROR-TRACER-NEEDS"
    ETH_IP_PROPS = "ETH-IP-PROPS"
    ETH_TCP_IP_ICMP_PROPS = "ETH-TCP-IP-ICMP-PROPS"
    ETH_TCP_IP_PROPS = "ETH-TCP-IP-PROPS"
    ETH_TP_CONFIG = "ETH-TP-CONFIG"
    ETHERNET_CLUSTER = "ETHERNET-CLUSTER"
    ETHERNET_COMMUNICATION_CONNECTOR = "ETHERNET-COMMUNICATION-CONNECTOR"
    ETHERNET_COMMUNICATION_CONTROLLER = "ETHERNET-COMMUNICATION-CONTROLLER"
    ETHERNET_FRAME = "ETHERNET-FRAME"
    ETHERNET_FRAME_TRIGGERING = "ETHERNET-FRAME-TRIGGERING"
    ETHERNET_PHYSICAL_CHANNEL = "ETHERNET-PHYSICAL-CHANNEL"
    ETHERNET_RAW_DATA_STREAM_CLIENT_MAPPING = "ETHERNET-RAW-DATA-STREAM-CLIENT-MAPPING"
    ETHERNET_RAW_DATA_STREAM_GRANT = "ETHERNET-RAW-DATA-STREAM-GRANT"
    ETHERNET_RAW_DATA_STREAM_MAPPING = "ETHERNET-RAW-DATA-STREAM-MAPPING"
    ETHERNET_RAW_DATA_STREAM_SERVER_MAPPING = "ETHERNET-RAW-DATA-STREAM-SERVER-MAPPING"
    ETHERNET_WAKEUP_SLEEP_ON_DATALINE_CONFIG = "ETHERNET-WAKEUP-SLEEP-ON-DATALINE-CONFIG"
    ETHERNET_WAKEUP_SLEEP_ON_DATALINE_CONFIG_SET = "ETHERNET-WAKEUP-SLEEP-ON-DATALINE-CONFIG-SET"
    EVALUATED_VARIANT_SET = "EVALUATED-VARIANT-SET"
    EVENT_HANDLER = "EVENT-HANDLER"
    EVENT_MAPPING = "EVENT-MAPPING"
    EVENT_TRIGGERING_CONSTRAINT = "EVENT-TRIGGERING-CONSTRAINT"
    EXCLUSIVE_AREA = "EXCLUSIVE-AREA"
    EXECUTABLE = "EXECUTABLE"
    EXECUTABLE_ENTITY = "EXECUTABLE-ENTITY"
    EXECUTABLE_TIMING = "EXECUTABLE-TIMING"
    EXECUTION_ORDER_CONSTRAINT = "EXECUTION-ORDER-CONSTRAINT"
    EXECUTION_TIME = "EXECUTION-TIME"
    EXECUTION_TIME_CONSTRAINT = "EXECUTION-TIME-CONSTRAINT"
    EXTERNAL_TRIGGER_OCCURRED_EVENT = "EXTERNAL-TRIGGER-OCCURRED-EVENT"
    EXTERNAL_TRIGGERING_POINT_IDENT = "EXTERNAL-TRIGGERING-POINT-IDENT"
    FIBEX_ELEMENT = "FIBEX-ELEMENT"
    FIELD = "FIELD"
    FIELD_MAPPING = "FIELD-MAPPING"
    FIRE_AND_FORGET_METHOD_MAPPING = "FIRE-AND-FORGET-METHOD-MAPPING"
    FIREWALL_RULE = "FIREWALL-RULE"
    FIREWALL_STATE_SWITCH_INTERFACE = "FIREWALL-STATE-SWITCH-INTERFACE"
    FLAT_INSTANCE_DESCRIPTOR = "FLAT-INSTANCE-DESCRIPTOR"
    FLAT_MAP = "FLAT-MAP"
    FLEXRAY_AR_TP_CONFIG = "FLEXRAY-AR-TP-CONFIG"
    FLEXRAY_AR_TP_NODE = "FLEXRAY-AR-TP-NODE"
    FLEXRAY_CLUSTER = "FLEXRAY-CLUSTER"
    FLEXRAY_COMMUNICATION_CONNECTOR = "FLEXRAY-COMMUNICATION-CONNECTOR"
    FLEXRAY_COMMUNICATION_CONTROLLER = "FLEXRAY-COMMUNICATION-CONTROLLER"
    FLEXRAY_FRAME = "FLEXRAY-FRAME"
    FLEXRAY_FRAME_TRIGGERING = "FLEXRAY-FRAME-TRIGGERING"
    FLEXRAY_NM_CLUSTER = "FLEXRAY-NM-CLUSTER"
    FLEXRAY_NM_NODE = "FLEXRAY-NM-NODE"
    FLEXRAY_PHYSICAL_CHANNEL = "FLEXRAY-PHYSICAL-CHANNEL"
    FLEXRAY_TP_CONFIG = "FLEXRAY-TP-CONFIG"
    FLEXRAY_TP_CONNECTION_CONTROL = "FLEXRAY-TP-CONNECTION-CONTROL"
    FLEXRAY_TP_NODE = "FLEXRAY-TP-NODE"
    FLEXRAY_TP_PDU_POOL = "FLEXRAY-TP-PDU-POOL"
    FM_ATTRIBUTE_DEF = "FM-ATTRIBUTE-DEF"
    FM_FEATURE = "FM-FEATURE"
    FM_FEATURE_MAP = "FM-FEATURE-MAP"
    FM_FEATURE_MAP_ASSERTION = "FM-FEATURE-MAP-ASSERTION"
    FM_FEATURE_MAP_CONDITION = "FM-FEATURE-MAP-CONDITION"
    FM_FEATURE_MAP_ELEMENT = "FM-FEATURE-MAP-ELEMENT"
    FM_FEATURE_MODEL = "FM-FEATURE-MODEL"
    FM_FEATURE_RELATION = "FM-FEATURE-RELATION"
    FM_FEATURE_RESTRICTION = "FM-FEATURE-RESTRICTION"
    FM_FEATURE_SELECTION = "FM-FEATURE-SELECTION"
    FM_FEATURE_SELECTION_SET = "FM-FEATURE-SELECTION-SET"
    FRAME = "FRAME"
    FRAME_PORT = "FRAME-PORT"
    FRAME_TRIGGERING = "FRAME-TRIGGERING"
    FUNCTION_GROUP_SET = "FUNCTION-GROUP-SET"
    FUNCTION_INHIBITION_AVAILABILITY_NEEDS = "FUNCTION-INHIBITION-AVAILABILITY-NEEDS"
    FUNCTION_INHIBITION_NEEDS = "FUNCTION-INHIBITION-NEEDS"
    FUNCTIONAL_CLUSTER_INTERACTS_WITH_FUNCTIONAL_CLUSTER_MAPPING = (
        "FUNCTIONAL-CLUSTER-INTERACTS-WITH-FUNCTIONAL-CLUSTER-MAPPING"
    )
    FUNCTIONAL_CLUSTER_INTERACTS_WITH_PERSISTENCY_DEPLOYMENT_MAPPING = (
        "FUNCTIONAL-CLUSTER-INTERACTS-WITH-PERSISTENCY-DEPLOYMENT-MAPPING"
    )
    FURTHER_ACTION_BYTE_NEEDS = "FURTHER-ACTION-BYTE-NEEDS"
    GATEWAY = "GATEWAY"
    GENERAL_PARAMETER = "GENERAL-PARAMETER"
    GENERAL_PURPOSE_CONNECTION = "GENERAL-PURPOSE-CONNECTION"
    GENERAL_PURPOSE_I_PDU = "GENERAL-PURPOSE-I-PDU"
    GENERAL_PURPOSE_PDU = "GENERAL-PURPOSE-PDU"
    GENERIC_ETHERNET_FRAME = "GENERIC-ETHERNET-FRAME"
    GENERIC_MODULE_INSTANTIATION = "GENERIC-MODULE-INSTANTIATION"
    GLOBAL_SUPERVISION = "GLOBAL-SUPERVISION"
    GLOBAL_SUPERVISION_NEEDS = "GLOBAL-SUPERVISION-NEEDS"
    GLOBAL_TIME_CAN_MASTER = "GLOBAL-TIME-CAN-MASTER"
    GLOBAL_TIME_CAN_SLAVE = "GLOBAL-TIME-CAN-SLAVE"
    GLOBAL_TIME_DOMAIN = "GLOBAL-TIME-DOMAIN"
    GLOBAL_TIME_ETH_MASTER = "GLOBAL-TIME-ETH-MASTER"
    GLOBAL_TIME_ETH_SLAVE = "GLOBAL-TIME-ETH-SLAVE"
    GLOBAL_TIME_FR_MASTER = "GLOBAL-TIME-FR-MASTER"
    GLOBAL_TIME_FR_SLAVE = "GLOBAL-TIME-FR-SLAVE"
    GLOBAL_TIME_GATEWAY = "GLOBAL-TIME-GATEWAY"
    GLOBAL_TIME_MASTER = "GLOBAL-TIME-MASTER"
    GLOBAL_TIME_SLAVE = "GLOBAL-TIME-SLAVE"
    GRANT = "GRANT"
    GRANT_DESIGN = "GRANT-DESIGN"
    HARDWARE_TEST_NEEDS = "HARDWARE-TEST-NEEDS"
    HEALTH_CHANNEL = "HEALTH-CHANNEL"
    HEALTH_CHANNEL_EXTERNAL_STATUS = "HEALTH-CHANNEL-EXTERNAL-STATUS"
    HEALTH_CHANNEL_SUPERVISION = "HEALTH-CHANNEL-SUPERVISION"
    HEAP_USAGE = "HEAP-USAGE"
    HW_ATTRIBUTE_DEF = "HW-ATTRIBUTE-DEF"
    HW_ATTRIBUTE_LITERAL_DEF = "HW-ATTRIBUTE-LITERAL-DEF"
    HW_CATEGORY = "HW-CATEGORY"
    HW_ELEMENT = "HW-ELEMENT"
    HW_PIN = "HW-PIN"
    HW_PIN_GROUP = "HW-PIN-GROUP"
    HW_TYPE = "HW-TYPE"
    I_PDU = "I-PDU"
    I_PDU_PORT = "I-PDU-PORT"
    I_PV_6_EXT_HEADER_FILTER_LIST = "I-PV-6-EXT-HEADER-FILTER-LIST"
    I_PV_6_EXT_HEADER_FILTER_SET = "I-PV-6-EXT-HEADER-FILTER-SET"
    I_SIGNAL = "I-SIGNAL"
    I_SIGNAL_GROUP = "I-SIGNAL-GROUP"
    I_SIGNAL_I_PDU = "I-SIGNAL-I-PDU"
    I_SIGNAL_I_PDU_GROUP = "I-SIGNAL-I-PDU-GROUP"
    I_SIGNAL_PORT = "I-SIGNAL-PORT"
    I_SIGNAL_TO_I_PDU_MAPPING = "I-SIGNAL-TO-I-PDU-MAPPING"
    I_SIGNAL_TRIGGERING = "I-SIGNAL-TRIGGERING"
    IAM_MODULE_INSTANTIATION = "IAM-MODULE-INSTANTIATION"
    IDENT_CAPTION = "IDENT-CAPTION"
    IDENTIFIABLE = "IDENTIFIABLE"
    IDS_COMMON_ELEMENT = "IDS-COMMON-ELEMENT"
    IDS_DESIGN = "IDS-DESIGN"
    IDS_MAPPING = "IDS-MAPPING"
    IDS_MGR_CUSTOM_TIMESTAMP_NEEDS = "IDS-MGR-CUSTOM-TIMESTAMP-NEEDS"
    IDS_MGR_NEEDS = "IDS-MGR-NEEDS"
    IDS_PLATFORM_INSTANTIATION = "IDS-PLATFORM-INSTANTIATION"
    IDSM_INSTANCE = "IDSM-INSTANCE"
    IDSM_MODULE_INSTANTIATION = "IDSM-MODULE-INSTANTIATION"
    IDSM_PROPERTIES = "IDSM-PROPERTIES"
    IDSM_RATE_LIMITATION = "IDSM-RATE-LIMITATION"
    IDSM_TRAFFIC_LIMITATION = "IDSM-TRAFFIC-LIMITATION"
    IEEE_1722_TP_ETHERNET_FRAME = "IEEE-1722-TP-ETHERNET-FRAME"
    IMPLEMENTATION = "IMPLEMENTATION"
    IMPLEMENTATION_DATA_TYPE = "IMPLEMENTATION-DATA-TYPE"
    IMPLEMENTATION_DATA_TYPE_ELEMENT = "IMPLEMENTATION-DATA-TYPE-ELEMENT"
    INDICATOR_STATUS_NEEDS = "INDICATOR-STATUS-NEEDS"
    INIT_EVENT = "INIT-EVENT"
    INTERFACE_MAPPING = "INTERFACE-MAPPING"
    INTERNAL_BEHAVIOR = "INTERNAL-BEHAVIOR"
    INTERNAL_TRIGGER_OCCURRED_EVENT = "INTERNAL-TRIGGER-OCCURRED-EVENT"
    INTERNAL_TRIGGERING_POINT = "INTERNAL-TRIGGERING-POINT"
    INTERPOLATION_ROUTINE_MAPPING_SET = "INTERPOLATION-ROUTINE-MAPPING-SET"
    IP_IAM_REMOTE_SUBJECT = "IP-IAM-REMOTE-SUBJECT"
    IP_SEC_CONFIG_PROPS = "IP-SEC-CONFIG-PROPS"
    IP_SEC_IAM_REMOTE_SUBJECT = "IP-SEC-IAM-REMOTE-SUBJECT"
    IP_SEC_RULE = "IP-SEC-RULE"
    J_1939_CLUSTER = "J-1939-CLUSTER"
    J_1939_CONTROLLER_APPLICATION = "J-1939-CONTROLLER-APPLICATION"
    J_1939_DCM_DM_19_SUPPORT = "J-1939-DCM-DM-19-SUPPORT"
    J_1939_DCM_I_PDU = "J-1939-DCM-I-PDU"
    J_1939_NM_CLUSTER = "J-1939-NM-CLUSTER"
    J_1939_NM_NODE = "J-1939-NM-NODE"
    J_1939_RM_INCOMING_REQUEST_SERVICE_NEEDS = "J-1939-RM-INCOMING-REQUEST-SERVICE-NEEDS"
    J_1939_RM_OUTGOING_REQUEST_SERVICE_NEEDS = "J-1939-RM-OUTGOING-REQUEST-SERVICE-NEEDS"
    J_1939_SHARED_ADDRESS_CLUSTER = "J-1939-SHARED-ADDRESS-CLUSTER"
    J_1939_TP_CONFIG = "J-1939-TP-CONFIG"
    J_1939_TP_NODE = "J-1939-TP-NODE"
    KEYWORD = "KEYWORD"
    KEYWORD_SET = "KEYWORD-SET"
    LATENCY_TIMING_CONSTRAINT = "LATENCY-TIMING-CONSTRAINT"
    LIFE_CYCLE_INFO_SET = "LIFE-CYCLE-INFO-SET"
    LIFE_CYCLE_STATE = "LIFE-CYCLE-STATE"
    LIFE_CYCLE_STATE_DEFINITION_GROUP = "LIFE-CYCLE-STATE-DEFINITION-GROUP"
    LIN_CLUSTER = "LIN-CLUSTER"
    LIN_COMMUNICATION_CONNECTOR = "LIN-COMMUNICATION-CONNECTOR"
    LIN_COMMUNICATION_CONTROLLER = "LIN-COMMUNICATION-CONTROLLER"
    LIN_EVENT_TRIGGERED_FRAME = "LIN-EVENT-TRIGGERED-FRAME"
    LIN_FRAME = "LIN-FRAME"
    LIN_FRAME_TRIGGERING = "LIN-FRAME-TRIGGERING"
    LIN_MASTER = "LIN-MASTER"
    LIN_NM_CLUSTER = "LIN-NM-CLUSTER"
    LIN_PHYSICAL_CHANNEL = "LIN-PHYSICAL-CHANNEL"
    LIN_SCHEDULE_TABLE = "LIN-SCHEDULE-TABLE"
    LIN_SLAVE = "LIN-SLAVE"
    LIN_SPORADIC_FRAME = "LIN-SPORADIC-FRAME"
    LIN_TP_CONFIG = "LIN-TP-CONFIG"
    LIN_TP_NODE = "LIN-TP-NODE"
    LIN_UNCONDITIONAL_FRAME = "LIN-UNCONDITIONAL-FRAME"
    LINKER = "LINKER"
    LOG_AND_TRACE_INSTANTIATION = "LOG-AND-TRACE-INSTANTIATION"
    LOG_AND_TRACE_INTERFACE = "LOG-AND-TRACE-INTERFACE"
    LOG_AND_TRACE_MESSAGE_COLLECTION_SET = "LOG-AND-TRACE-MESSAGE-COLLECTION-SET"
    LOGIC_ADDRESS = "LOGIC-ADDRESS"
    LOGICAL_SUPERVISION = "LOGICAL-SUPERVISION"
    LT_MESSAGE_COLLECTION_TO_PORT_PROTOTYPE_MAPPING = (
        "LT-MESSAGE-COLLECTION-TO-PORT-PROTOTYPE-MAPPING"
    )
    MAC_MULTICAST_GROUP = "MAC-MULTICAST-GROUP"
    MAC_SEC_GLOBAL_KAY_PROPS = "MAC-SEC-GLOBAL-KAY-PROPS"
    MAC_SEC_KAY_PARTICIPANT = "MAC-SEC-KAY-PARTICIPANT"
    MAC_SEC_PARTICIPANT_SET = "MAC-SEC-PARTICIPANT-SET"
    MACHINE = "MACHINE"
    MACHINE_DESIGN = "MACHINE-DESIGN"
    MACHINE_TIMING = "MACHINE-TIMING"
    MC_DATA_INSTANCE = "MC-DATA-INSTANCE"
    MC_FUNCTION = "MC-FUNCTION"
    MC_GROUP = "MC-GROUP"
    MEASURED_EXECUTION_TIME = "MEASURED-EXECUTION-TIME"
    MEASURED_HEAP_USAGE = "MEASURED-HEAP-USAGE"
    MEASURED_STACK_USAGE = "MEASURED-STACK-USAGE"
    MEMORY_SECTION = "MEMORY-SECTION"
    MEMORY_USAGE = "MEMORY-USAGE"
    METHOD_MAPPING = "METHOD-MAPPING"
    MODE_ACCESS_POINT_IDENT = "MODE-ACCESS-POINT-IDENT"
    MODE_DECLARATION = "MODE-DECLARATION"
    MODE_DECLARATION_GROUP = "MODE-DECLARATION-GROUP"
    MODE_DECLARATION_GROUP_PROTOTYPE = "MODE-DECLARATION-GROUP-PROTOTYPE"
    MODE_DECLARATION_MAPPING = "MODE-DECLARATION-MAPPING"
    MODE_DECLARATION_MAPPING_SET = "MODE-DECLARATION-MAPPING-SET"
    MODE_INTERFACE_MAPPING = "MODE-INTERFACE-MAPPING"
    MODE_SWITCH_INTERFACE = "MODE-SWITCH-INTERFACE"
    MODE_SWITCH_POINT = "MODE-SWITCH-POINT"
    MODE_SWITCHED_ACK_EVENT = "MODE-SWITCHED-ACK-EVENT"
    MODE_TRANSITION = "MODE-TRANSITION"
    MULTIPLEXED_I_PDU = "MULTIPLEXED-I-PDU"
    N_PDU = "N-PDU"
    NETWORK_ENDPOINT = "NETWORK-ENDPOINT"
    NM_CLUSTER = "NM-CLUSTER"
    NM_CONFIG = "NM-CONFIG"
    NM_ECU = "NM-ECU"
    NM_HANDLE_TO_FUNCTION_GROUP_STATE_MAPPING = "NM-HANDLE-TO-FUNCTION-GROUP-STATE-MAPPING"
    NM_INSTANTIATION = "NM-INSTANTIATION"
    NM_NODE = "NM-NODE"
    NM_PDU = "NM-PDU"
    NO_CHECKPOINT_SUPERVISION = "NO-CHECKPOINT-SUPERVISION"
    NO_SUPERVISION = "NO-SUPERVISION"
    NON_OS_MODULE_INSTANTIATION = "NON-OS-MODULE-INSTANTIATION"
    NV_BLOCK_DESCRIPTOR = "NV-BLOCK-DESCRIPTOR"
    NV_BLOCK_NEEDS = "NV-BLOCK-NEEDS"
    NV_BLOCK_SW_COMPONENT_TYPE = "NV-BLOCK-SW-COMPONENT-TYPE"
    NV_DATA_INTERFACE = "NV-DATA-INTERFACE"
    OBD_CONTROL_SERVICE_NEEDS = "OBD-CONTROL-SERVICE-NEEDS"
    OBD_INFO_SERVICE_NEEDS = "OBD-INFO-SERVICE-NEEDS"
    OBD_MONITOR_SERVICE_NEEDS = "OBD-MONITOR-SERVICE-NEEDS"
    OBD_PID_SERVICE_NEEDS = "OBD-PID-SERVICE-NEEDS"
    OBD_RATIO_DENOMINATOR_NEEDS = "OBD-RATIO-DENOMINATOR-NEEDS"
    OBD_RATIO_SERVICE_NEEDS = "OBD-RATIO-SERVICE-NEEDS"
    OFFSET_TIMING_CONSTRAINT = "OFFSET-TIMING-CONSTRAINT"
    OPERATION_INVOKED_EVENT = "OPERATION-INVOKED-EVENT"
    OS_MODULE_INSTANTIATION = "OS-MODULE-INSTANTIATION"
    OS_TASK_EXECUTION_EVENT = "OS-TASK-EXECUTION-EVENT"
    OS_TASK_PROXY = "OS-TASK-PROXY"
    P_PORT_PROTOTYPE = "P-PORT-PROTOTYPE"
    PACKAGEABLE_ELEMENT = "PACKAGEABLE-ELEMENT"
    PARAMETER_ACCESS = "PARAMETER-ACCESS"
    PARAMETER_DATA_PROTOTYPE = "PARAMETER-DATA-PROTOTYPE"
    PARAMETER_INTERFACE = "PARAMETER-INTERFACE"
    PARAMETER_SW_COMPONENT_TYPE = "PARAMETER-SW-COMPONENT-TYPE"
    PASS_THROUGH_SW_CONNECTOR = "PASS-THROUGH-SW-CONNECTOR"
    PDU = "PDU"
    PDU_ACTIVATION_ROUTING_GROUP = "PDU-ACTIVATION-ROUTING-GROUP"
    PDU_TO_FRAME_MAPPING = "PDU-TO-FRAME-MAPPING"
    PDU_TRIGGERING = "PDU-TRIGGERING"
    PDUR_I_PDU_GROUP = "PDUR-I-PDU-GROUP"
    PER_INSTANCE_MEMORY = "PER-INSTANCE-MEMORY"
    PERIODIC_EVENT_TRIGGERING = "PERIODIC-EVENT-TRIGGERING"
    PERSISTENCY_DATA_ELEMENT = "PERSISTENCY-DATA-ELEMENT"
    PERSISTENCY_DEPLOYMENT = "PERSISTENCY-DEPLOYMENT"
    PERSISTENCY_DEPLOYMENT_ELEMENT = "PERSISTENCY-DEPLOYMENT-ELEMENT"
    PERSISTENCY_DEPLOYMENT_ELEMENT_TO_CRYPTO_KEY_SLOT_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-ELEMENT-TO-CRYPTO-KEY-SLOT-MAPPING"
    )
    PERSISTENCY_DEPLOYMENT_TO_CRYPTO_KEY_SLOT_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-TO-CRYPTO-KEY-SLOT-MAPPING"
    )
    PERSISTENCY_DEPLOYMENT_TO_DLT_LOG_SINK_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-TO-DLT-LOG-SINK-MAPPING"
    )
    PERSISTENCY_FILE = "PERSISTENCY-FILE"
    PERSISTENCY_FILE_ELEMENT = "PERSISTENCY-FILE-ELEMENT"
    PERSISTENCY_FILE_STORAGE = "PERSISTENCY-FILE-STORAGE"
    PERSISTENCY_FILE_STORAGE_INTERFACE = "PERSISTENCY-FILE-STORAGE-INTERFACE"
    PERSISTENCY_INTERFACE = "PERSISTENCY-INTERFACE"
    PERSISTENCY_INTERFACE_ELEMENT = "PERSISTENCY-INTERFACE-ELEMENT"
    PERSISTENCY_KEY_VALUE_PAIR = "PERSISTENCY-KEY-VALUE-PAIR"
    PERSISTENCY_KEY_VALUE_STORAGE = "PERSISTENCY-KEY-VALUE-STORAGE"
    PERSISTENCY_KEY_VALUE_STORAGE_INTERFACE = "PERSISTENCY-KEY-VALUE-STORAGE-INTERFACE"
    PERSISTENCY_PORT_PROTOTYPE_TO_DEPLOYMENT_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-DEPLOYMENT-MAPPING"
    )
    PERSISTENCY_PORT_PROTOTYPE_TO_FILE_STORAGE_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-FILE-STORAGE-MAPPING"
    )
    PERSISTENCY_PORT_PROTOTYPE_TO_KEY_VALUE_STORAGE_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-KEY-VALUE-STORAGE-MAPPING"
    )
    PHM_ABSTRACT_RECOVERY_NOTIFICATION_INTERFACE = "PHM-ABSTRACT-RECOVERY-NOTIFICATION-INTERFACE"
    PHM_CHECKPOINT = "PHM-CHECKPOINT"
    PHM_CONTRIBUTION_TO_MACHINE_MAPPING = "PHM-CONTRIBUTION-TO-MACHINE-MAPPING"
    PHM_HEALTH_CHANNEL_INTERFACE = "PHM-HEALTH-CHANNEL-INTERFACE"
    PHM_HEALTH_CHANNEL_RECOVERY_NOTIFICATION_INTERFACE = (
        "PHM-HEALTH-CHANNEL-RECOVERY-NOTIFICATION-INTERFACE"
    )
    PHM_HEALTH_CHANNEL_STATUS = "PHM-HEALTH-CHANNEL-STATUS"
    PHM_RECOVERY_ACTION_INTERFACE = "PHM-RECOVERY-ACTION-INTERFACE"
    PHM_SUPERVISED_ENTITY_INTERFACE = "PHM-SUPERVISED-ENTITY-INTERFACE"
    PHM_SUPERVISION = "PHM-SUPERVISION"
    PHM_SUPERVISION_RECOVERY_NOTIFICATION_INTERFACE = (
        "PHM-SUPERVISION-RECOVERY-NOTIFICATION-INTERFACE"
    )
    PHYSICAL_CHANNEL = "PHYSICAL-CHANNEL"
    PHYSICAL_DIMENSION = "PHYSICAL-DIMENSION"
    PHYSICAL_DIMENSION_MAPPING_SET = "PHYSICAL-DIMENSION-MAPPING-SET"
    PLATFORM_HEALTH_MANAGEMENT_CONTRIBUTION = "PLATFORM-HEALTH-MANAGEMENT-CONTRIBUTION"
    PLATFORM_HEALTH_MANAGEMENT_INTERFACE = "PLATFORM-HEALTH-MANAGEMENT-INTERFACE"
    PLATFORM_MODULE_ENDPOINT_CONFIGURATION = "PLATFORM-MODULE-ENDPOINT-CONFIGURATION"
    PLATFORM_MODULE_ETHERNET_ENDPOINT_CONFIGURATION = (
        "PLATFORM-MODULE-ETHERNET-ENDPOINT-CONFIGURATION"
    )
    PORT_ELEMENT_TO_COMMUNICATION_RESOURCE_MAPPING = (
        "PORT-ELEMENT-TO-COMMUNICATION-RESOURCE-MAPPING"
    )
    PORT_GROUP = "PORT-GROUP"
    PORT_INTERFACE = "PORT-INTERFACE"
    PORT_INTERFACE_MAPPING = "PORT-INTERFACE-MAPPING"
    PORT_INTERFACE_MAPPING_SET = "PORT-INTERFACE-MAPPING-SET"
    PORT_INTERFACE_TO_DATA_TYPE_MAPPING = "PORT-INTERFACE-TO-DATA-TYPE-MAPPING"
    PORT_PROTOTYPE = "PORT-PROTOTYPE"
    PORT_PROTOTYPE_BLUEPRINT = "PORT-PROTOTYPE-BLUEPRINT"
    POSSIBLE_ERROR_REACTION = "POSSIBLE-ERROR-REACTION"
    POST_BUILD_VARIANT_CRITERION = "POST-BUILD-VARIANT-CRITERION"
    POST_BUILD_VARIANT_CRITERION_VALUE_SET = "POST-BUILD-VARIANT-CRITERION-VALUE-SET"
    PR_PORT_PROTOTYPE = "PR-PORT-PROTOTYPE"
    PREDEFINED_VARIANT = "PREDEFINED-VARIANT"
    PRIMITIVE_ATTRIBUTE_TAILORING = "PRIMITIVE-ATTRIBUTE-TAILORING"
    PROCESS = "PROCESS"
    PROCESS_DESIGN = "PROCESS-DESIGN"
    PROCESS_DESIGN_TO_MACHINE_DESIGN_MAPPING = "PROCESS-DESIGN-TO-MACHINE-DESIGN-MAPPING"
    PROCESS_EXECUTION_ERROR = "PROCESS-EXECUTION-ERROR"
    PROCESS_TO_MACHINE_MAPPING = "PROCESS-TO-MACHINE-MAPPING"
    PROCESS_TO_MACHINE_MAPPING_SET = "PROCESS-TO-MACHINE-MAPPING-SET"
    PROCESSOR = "PROCESSOR"
    PROCESSOR_CORE = "PROCESSOR-CORE"
    PROVIDED_AP_SERVICE_INSTANCE = "PROVIDED-AP-SERVICE-INSTANCE"
    PROVIDED_SERVICE_INSTANCE = "PROVIDED-SERVICE-INSTANCE"
    PROVIDED_SERVICE_INSTANCE_TO_SW_CLUSTER_DESIGN_P_PORT_PROTOTYPE_MAPPING = (
        "PROVIDED-SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-P-PORT-PROTOTYPE-MAPPING"
    )
    PROVIDED_SOMEIP_SERVICE_INSTANCE = "PROVIDED-SOMEIP-SERVICE-INSTANCE"
    PROVIDED_USER_DEFINED_SERVICE_INSTANCE = "PROVIDED-USER-DEFINED-SERVICE-INSTANCE"
    PSK_IDENTITY_TO_KEY_SLOT_MAPPING = "PSK-IDENTITY-TO-KEY-SLOT-MAPPING"
    R_PORT_PROTOTYPE = "R-PORT-PROTOTYPE"
    RAPID_PROTOTYPING_SCENARIO = "RAPID-PROTOTYPING-SCENARIO"
    RAW_DATA_STREAM_CLIENT_INTERFACE = "RAW-DATA-STREAM-CLIENT-INTERFACE"
    RAW_DATA_STREAM_DEPLOYMENT = "RAW-DATA-STREAM-DEPLOYMENT"
    RAW_DATA_STREAM_GRANT = "RAW-DATA-STREAM-GRANT"
    RAW_DATA_STREAM_GRANT_DESIGN = "RAW-DATA-STREAM-GRANT-DESIGN"
    RAW_DATA_STREAM_MAPPING = "RAW-DATA-STREAM-MAPPING"
    RAW_DATA_STREAM_SERVER_INTERFACE = "RAW-DATA-STREAM-SERVER-INTERFACE"
    RECOVERY_NOTIFICATION = "RECOVERY-NOTIFICATION"
    RECOVERY_NOTIFICATION_TO_P_PORT_PROTOTYPE_MAPPING = (
        "RECOVERY-NOTIFICATION-TO-P-PORT-PROTOTYPE-MAPPING"
    )
    REFERENCE_TAILORING = "REFERENCE-TAILORING"
    REQUIRED_AP_SERVICE_INSTANCE = "REQUIRED-AP-SERVICE-INSTANCE"
    REQUIRED_SERVICE_INSTANCE_TO_SW_CLUSTER_DESIGN_R_PORT_PROTOTYPE_MAPPING = (
        "REQUIRED-SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-R-PORT-PROTOTYPE-MAPPING"
    )
    REQUIRED_SOMEIP_SERVICE_INSTANCE = "REQUIRED-SOMEIP-SERVICE-INSTANCE"
    REQUIRED_USER_DEFINED_SERVICE_INSTANCE = "REQUIRED-USER-DEFINED-SERVICE-INSTANCE"
    RESOURCE_CONSUMPTION = "RESOURCE-CONSUMPTION"
    RESOURCE_GROUP = "RESOURCE-GROUP"
    ROOT_SW_CLUSTER_DESIGN_COMPONENT_PROTOTYPE = "ROOT-SW-CLUSTER-DESIGN-COMPONENT-PROTOTYPE"
    ROOT_SW_COMPONENT_PROTOTYPE = "ROOT-SW-COMPONENT-PROTOTYPE"
    ROOT_SW_COMPOSITION_PROTOTYPE = "ROOT-SW-COMPOSITION-PROTOTYPE"
    ROUGH_ESTIMATE_HEAP_USAGE = "ROUGH-ESTIMATE-HEAP-USAGE"
    ROUGH_ESTIMATE_OF_EXECUTION_TIME = "ROUGH-ESTIMATE-OF-EXECUTION-TIME"
    ROUGH_ESTIMATE_STACK_USAGE = "ROUGH-ESTIMATE-STACK-USAGE"
    RPT_COMPONENT = "RPT-COMPONENT"
    RPT_CONTAINER = "RPT-CONTAINER"
    RPT_EXECUTABLE_ENTITY = "RPT-EXECUTABLE-ENTITY"
    RPT_EXECUTABLE_ENTITY_EVENT = "RPT-EXECUTABLE-ENTITY-EVENT"
    RPT_EXECUTION_CONTEXT = "RPT-EXECUTION-CONTEXT"
    RPT_PROFILE = "RPT-PROFILE"
    RPT_SERVICE_POINT = "RPT-SERVICE-POINT"
    RTE_EVENT = "RTE-EVENT"
    RTE_EVENT_IN_COMPOSITION_SEPARATION = "RTE-EVENT-IN-COMPOSITION-SEPARATION"
    RTE_EVENT_IN_COMPOSITION_TO_OS_TASK_PROXY_MAPPING = (
        "RTE-EVENT-IN-COMPOSITION-TO-OS-TASK-PROXY-MAPPING"
    )
    RTE_EVENT_IN_SYSTEM_SEPARATION = "RTE-EVENT-IN-SYSTEM-SEPARATION"
    RTE_EVENT_IN_SYSTEM_TO_OS_TASK_PROXY_MAPPING = "RTE-EVENT-IN-SYSTEM-TO-OS-TASK-PROXY-MAPPING"
    RUNNABLE_ENTITY = "RUNNABLE-ENTITY"
    RUNNABLE_ENTITY_GROUP = "RUNNABLE-ENTITY-GROUP"
    RUNTIME_ERROR = "RUNTIME-ERROR"
    SDG_ABSTRACT_FOREIGN_REFERENCE = "SDG-ABSTRACT-FOREIGN-REFERENCE"
    SDG_ABSTRACT_PRIMITIVE_ATTRIBUTE = "SDG-ABSTRACT-PRIMITIVE-ATTRIBUTE"
    SDG_AGGREGATION_WITH_VARIATION = "SDG-AGGREGATION-WITH-VARIATION"
    SDG_ATTRIBUTE = "SDG-ATTRIBUTE"
    SDG_CLASS = "SDG-CLASS"
    SDG_DEF = "SDG-DEF"
    SDG_FOREIGN_REFERENCE = "SDG-FOREIGN-REFERENCE"
    SDG_FOREIGN_REFERENCE_WITH_VARIATION = "SDG-FOREIGN-REFERENCE-WITH-VARIATION"
    SDG_PRIMITIVE_ATTRIBUTE = "SDG-PRIMITIVE-ATTRIBUTE"
    SDG_PRIMITIVE_ATTRIBUTE_WITH_VARIATION = "SDG-PRIMITIVE-ATTRIBUTE-WITH-VARIATION"
    SDG_REFERENCE = "SDG-REFERENCE"
    SDG_TAILORING = "SDG-TAILORING"
    SEC_OC_CRYPTO_SERVICE_MAPPING = "SEC-OC-CRYPTO-SERVICE-MAPPING"
    SEC_OC_DEPLOYMENT = "SEC-OC-DEPLOYMENT"
    SEC_OC_JOB_MAPPING = "SEC-OC-JOB-MAPPING"
    SEC_OC_JOB_REQUIREMENT = "SEC-OC-JOB-REQUIREMENT"
    SEC_OC_SECURE_COM_PROPS = "SEC-OC-SECURE-COM-PROPS"
    SECURE_COM_PROPS = "SECURE-COM-PROPS"
    SECURE_COMMUNICATION_AUTHENTICATION_PROPS = "SECURE-COMMUNICATION-AUTHENTICATION-PROPS"
    SECURE_COMMUNICATION_DEPLOYMENT = "SECURE-COMMUNICATION-DEPLOYMENT"
    SECURE_COMMUNICATION_FRESHNESS_PROPS = "SECURE-COMMUNICATION-FRESHNESS-PROPS"
    SECURE_COMMUNICATION_PROPS_SET = "SECURE-COMMUNICATION-PROPS-SET"
    SECURE_ON_BOARD_COMMUNICATION_NEEDS = "SECURE-ON-BOARD-COMMUNICATION-NEEDS"
    SECURED_I_PDU = "SECURED-I-PDU"
    SECURITY_EVENT_AGGREGATION_FILTER = "SECURITY-EVENT-AGGREGATION-FILTER"
    SECURITY_EVENT_CONTEXT_MAPPING = "SECURITY-EVENT-CONTEXT-MAPPING"
    SECURITY_EVENT_CONTEXT_MAPPING_APPLICATION = "SECURITY-EVENT-CONTEXT-MAPPING-APPLICATION"
    SECURITY_EVENT_CONTEXT_MAPPING_BSW_MODULE = "SECURITY-EVENT-CONTEXT-MAPPING-BSW-MODULE"
    SECURITY_EVENT_CONTEXT_MAPPING_COMM_CONNECTOR = "SECURITY-EVENT-CONTEXT-MAPPING-COMM-CONNECTOR"
    SECURITY_EVENT_CONTEXT_MAPPING_FUNCTIONAL_CLUSTER = (
        "SECURITY-EVENT-CONTEXT-MAPPING-FUNCTIONAL-CLUSTER"
    )
    SECURITY_EVENT_CONTEXT_PROPS = "SECURITY-EVENT-CONTEXT-PROPS"
    SECURITY_EVENT_DEFINITION = "SECURITY-EVENT-DEFINITION"
    SECURITY_EVENT_FILTER_CHAIN = "SECURITY-EVENT-FILTER-CHAIN"
    SECURITY_EVENT_MAPPING = "SECURITY-EVENT-MAPPING"
    SECURITY_EVENT_ONE_EVERY_N_FILTER = "SECURITY-EVENT-ONE-EVERY-N-FILTER"
    SECURITY_EVENT_REPORT_INTERFACE = "SECURITY-EVENT-REPORT-INTERFACE"
    SECURITY_EVENT_REPORT_TO_SECURITY_EVENT_DEFINITION_MAPPING = (
        "SECURITY-EVENT-REPORT-TO-SECURITY-EVENT-DEFINITION-MAPPING"
    )
    SECURITY_EVENT_STATE_FILTER = "SECURITY-EVENT-STATE-FILTER"
    SECURITY_EVENT_THRESHOLD_FILTER = "SECURITY-EVENT-THRESHOLD-FILTER"
    SENDER_RECEIVER_INTERFACE = "SENDER-RECEIVER-INTERFACE"
    SENSOR_ACTUATOR_SW_COMPONENT_TYPE = "SENSOR-ACTUATOR-SW-COMPONENT-TYPE"
    SERIALIZATION_TECHNOLOGY = "SERIALIZATION-TECHNOLOGY"
    SERVER_CALL_POINT = "SERVER-CALL-POINT"
    SERVICE_EVENT_DEPLOYMENT = "SERVICE-EVENT-DEPLOYMENT"
    SERVICE_FIELD_DEPLOYMENT = "SERVICE-FIELD-DEPLOYMENT"
    SERVICE_INSTANCE_COLLECTION_SET = "SERVICE-INSTANCE-COLLECTION-SET"
    SERVICE_INSTANCE_TO_MACHINE_MAPPING = "SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    SERVICE_INSTANCE_TO_PORT_PROTOTYPE_MAPPING = "SERVICE-INSTANCE-TO-PORT-PROTOTYPE-MAPPING"
    SERVICE_INSTANCE_TO_SIGNAL_MAPPING = "SERVICE-INSTANCE-TO-SIGNAL-MAPPING"
    SERVICE_INSTANCE_TO_SW_CLUSTER_DESIGN_PORT_PROTOTYPE_MAPPING = (
        "SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-PORT-PROTOTYPE-MAPPING"
    )
    SERVICE_INTERFACE = "SERVICE-INTERFACE"
    SERVICE_INTERFACE_DEPLOYMENT = "SERVICE-INTERFACE-DEPLOYMENT"
    SERVICE_INTERFACE_ELEMENT_MAPPING = "SERVICE-INTERFACE-ELEMENT-MAPPING"
    SERVICE_INTERFACE_ELEMENT_SECURE_COM_CONFIG = "SERVICE-INTERFACE-ELEMENT-SECURE-COM-CONFIG"
    SERVICE_INTERFACE_EVENT_MAPPING = "SERVICE-INTERFACE-EVENT-MAPPING"
    SERVICE_INTERFACE_FIELD_MAPPING = "SERVICE-INTERFACE-FIELD-MAPPING"
    SERVICE_INTERFACE_MAPPING = "SERVICE-INTERFACE-MAPPING"
    SERVICE_INTERFACE_METHOD_MAPPING = "SERVICE-INTERFACE-METHOD-MAPPING"
    SERVICE_INTERFACE_PEDIGREE = "SERVICE-INTERFACE-PEDIGREE"
    SERVICE_INTERFACE_TRIGGER_MAPPING = "SERVICE-INTERFACE-TRIGGER-MAPPING"
    SERVICE_METHOD_DEPLOYMENT = "SERVICE-METHOD-DEPLOYMENT"
    SERVICE_NEEDS = "SERVICE-NEEDS"
    SERVICE_PROXY_SW_COMPONENT_TYPE = "SERVICE-PROXY-SW-COMPONENT-TYPE"
    SERVICE_SW_COMPONENT_TYPE = "SERVICE-SW-COMPONENT-TYPE"
    SERVICE_TIMING = "SERVICE-TIMING"
    SIGNAL_BASED_EVENT_ELEMENT_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-EVENT-ELEMENT-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_BASED_FIELD_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-FIELD-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_BASED_FIRE_AND_FORGET_METHOD_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-FIRE-AND-FORGET-METHOD-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_BASED_METHOD_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-METHOD-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_BASED_TRIGGER_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-TRIGGER-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_SERVICE_TRANSLATION_ELEMENT_PROPS = "SIGNAL-SERVICE-TRANSLATION-ELEMENT-PROPS"
    SIGNAL_SERVICE_TRANSLATION_EVENT_PROPS = "SIGNAL-SERVICE-TRANSLATION-EVENT-PROPS"
    SIGNAL_SERVICE_TRANSLATION_PROPS = "SIGNAL-SERVICE-TRANSLATION-PROPS"
    SIGNAL_SERVICE_TRANSLATION_PROPS_SET = "SIGNAL-SERVICE-TRANSLATION-PROPS-SET"
    SIMULATED_EXECUTION_TIME = "SIMULATED-EXECUTION-TIME"
    SO_AD_ROUTING_GROUP = "SO-AD-ROUTING-GROUP"
    SOCKET_ADDRESS = "SOCKET-ADDRESS"
    SOCKET_CONNECTION_IPDU_IDENTIFIER_SET = "SOCKET-CONNECTION-IPDU-IDENTIFIER-SET"
    SOFTWARE_CLUSTER = "SOFTWARE-CLUSTER"
    SOFTWARE_CLUSTER_DESIGN = "SOFTWARE-CLUSTER-DESIGN"
    SOFTWARE_CLUSTER_DIAGNOSTIC_DEPLOYMENT_PROPS = "SOFTWARE-CLUSTER-DIAGNOSTIC-DEPLOYMENT-PROPS"
    SOFTWARE_PACKAGE = "SOFTWARE-PACKAGE"
    SOFTWARE_PACKAGE_STEP = "SOFTWARE-PACKAGE-STEP"
    SOMEIP_DATA_PROTOTYPE_TRANSFORMATION_PROPS = "SOMEIP-DATA-PROTOTYPE-TRANSFORMATION-PROPS"
    SOMEIP_EVENT_DEPLOYMENT = "SOMEIP-EVENT-DEPLOYMENT"
    SOMEIP_EVENT_GROUP = "SOMEIP-EVENT-GROUP"
    SOMEIP_FIELD_DEPLOYMENT = "SOMEIP-FIELD-DEPLOYMENT"
    SOMEIP_METHOD_DEPLOYMENT = "SOMEIP-METHOD-DEPLOYMENT"
    SOMEIP_PROVIDED_EVENT_GROUP = "SOMEIP-PROVIDED-EVENT-GROUP"
    SOMEIP_REMOTE_MULTICAST_CONFIG = "SOMEIP-REMOTE-MULTICAST-CONFIG"
    SOMEIP_REMOTE_UNICAST_CONFIG = "SOMEIP-REMOTE-UNICAST-CONFIG"
    SOMEIP_SD_CLIENT_EVENT_GROUP_TIMING_CONFIG = "SOMEIP-SD-CLIENT-EVENT-GROUP-TIMING-CONFIG"
    SOMEIP_SD_CLIENT_SERVICE_INSTANCE_CONFIG = "SOMEIP-SD-CLIENT-SERVICE-INSTANCE-CONFIG"
    SOMEIP_SD_SERVER_EVENT_GROUP_TIMING_CONFIG = "SOMEIP-SD-SERVER-EVENT-GROUP-TIMING-CONFIG"
    SOMEIP_SD_SERVER_SERVICE_INSTANCE_CONFIG = "SOMEIP-SD-SERVER-SERVICE-INSTANCE-CONFIG"
    SOMEIP_SERVICE_INSTANCE_TO_MACHINE_MAPPING = "SOMEIP-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    SOMEIP_SERVICE_INTERFACE_DEPLOYMENT = "SOMEIP-SERVICE-INTERFACE-DEPLOYMENT"
    SOMEIP_TP_CHANNEL = "SOMEIP-TP-CHANNEL"
    SOMEIP_TP_CONFIG = "SOMEIP-TP-CONFIG"
    SOMEIP_TRANSFORMATION_PROPS = "SOMEIP-TRANSFORMATION-PROPS"
    SOVD_GATEWAY_INSTANTIATION = "SOVD-GATEWAY-INSTANTIATION"
    SOVD_MODULE_INSTANTIATION = "SOVD-MODULE-INSTANTIATION"
    SOVD_SERVER_INSTANTIATION = "SOVD-SERVER-INSTANTIATION"
    SPEC_ELEMENT_REFERENCE = "SPEC-ELEMENT-REFERENCE"
    SPEC_ELEMENT_SCOPE = "SPEC-ELEMENT-SCOPE"
    SPECIFICATION_DOCUMENT_SCOPE = "SPECIFICATION-DOCUMENT-SCOPE"
    SPORADIC_EVENT_TRIGGERING = "SPORADIC-EVENT-TRIGGERING"
    STACK_USAGE = "STACK-USAGE"
    STARTUP_CONFIG = "STARTUP-CONFIG"
    STATE_DEPENDENT_FIREWALL = "STATE-DEPENDENT-FIREWALL"
    STATE_MANAGEMEN_PHM_ERROR_INTERFACE = "STATE-MANAGEMEN-PHM-ERROR-INTERFACE"
    STATE_MANAGEMENT_ACTION_ITEM = "STATE-MANAGEMENT-ACTION-ITEM"
    STATE_MANAGEMENT_ACTION_LIST = "STATE-MANAGEMENT-ACTION-LIST"
    STATE_MANAGEMENT_DIAG_TRIGGER_INTERFACE = "STATE-MANAGEMENT-DIAG-TRIGGER-INTERFACE"
    STATE_MANAGEMENT_EM_ERROR_INTERFACE = "STATE-MANAGEMENT-EM-ERROR-INTERFACE"
    STATE_MANAGEMENT_ERROR_INTERFACE = "STATE-MANAGEMENT-ERROR-INTERFACE"
    STATE_MANAGEMENT_FUNCTION_GROUP_SWITCH_NOTIFICATION_INTERFACE = (
        "STATE-MANAGEMENT-FUNCTION-GROUP-SWITCH-NOTIFICATION-INTERFACE"
    )
    STATE_MANAGEMENT_MODULE_INSTANTIATION = "STATE-MANAGEMENT-MODULE-INSTANTIATION"
    STATE_MANAGEMENT_NOTIFICATION_INTERFACE = "STATE-MANAGEMENT-NOTIFICATION-INTERFACE"
    STATE_MANAGEMENT_PORT_INTERFACE = "STATE-MANAGEMENT-PORT-INTERFACE"
    STATE_MANAGEMENT_REQUEST_ERROR = "STATE-MANAGEMENT-REQUEST-ERROR"
    STATE_MANAGEMENT_REQUEST_INTERFACE = "STATE-MANAGEMENT-REQUEST-INTERFACE"
    STATE_MANAGEMENT_REQUEST_TRIGGER = "STATE-MANAGEMENT-REQUEST-TRIGGER"
    STATE_MANAGEMENT_SET_FUNCTION_GROUP_STATE_ACTION_ITEM = (
        "STATE-MANAGEMENT-SET-FUNCTION-GROUP-STATE-ACTION-ITEM"
    )
    STATE_MANAGEMENT_STATE_MACHINE_ACTION_ITEM = "STATE-MANAGEMENT-STATE-MACHINE-ACTION-ITEM"
    STATE_MANAGEMENT_STATE_NOTIFICATION = "STATE-MANAGEMENT-STATE-NOTIFICATION"
    STATE_MANAGEMENT_STATE_REQUEST = "STATE-MANAGEMENT-STATE-REQUEST"
    STATE_MANAGEMENT_SYNC_ACTION_ITEM = "STATE-MANAGEMENT-SYNC-ACTION-ITEM"
    STATE_MANAGEMENT_TRIGGER_INTERFACE = "STATE-MANAGEMENT-TRIGGER-INTERFACE"
    STATIC_SOCKET_CONNECTION = "STATIC-SOCKET-CONNECTION"
    STD_CPP_IMPLEMENTATION_DATA_TYPE = "STD-CPP-IMPLEMENTATION-DATA-TYPE"
    STRUCTURED_REQ = "STRUCTURED-REQ"
    SUPERVISED_ENTITY_CHECKPOINT_NEEDS = "SUPERVISED-ENTITY-CHECKPOINT-NEEDS"
    SUPERVISED_ENTITY_NEEDS = "SUPERVISED-ENTITY-NEEDS"
    SUPERVISION_CHECKPOINT = "SUPERVISION-CHECKPOINT"
    SUPERVISION_MODE = "SUPERVISION-MODE"
    SUPERVISION_MODE_CONDITION = "SUPERVISION-MODE-CONDITION"
    SW_ADDR_METHOD = "SW-ADDR-METHOD"
    SW_AXIS_TYPE = "SW-AXIS-TYPE"
    SW_BASE_TYPE = "SW-BASE-TYPE"
    SW_COMPONENT_MAPPING_CONSTRAINTS = "SW-COMPONENT-MAPPING-CONSTRAINTS"
    SW_COMPONENT_PROTOTYPE = "SW-COMPONENT-PROTOTYPE"
    SW_COMPONENT_TYPE = "SW-COMPONENT-TYPE"
    SW_CONNECTOR = "SW-CONNECTOR"
    SW_GENERIC_AXIS_PARAM_TYPE = "SW-GENERIC-AXIS-PARAM-TYPE"
    SW_RECORD_LAYOUT = "SW-RECORD-LAYOUT"
    SW_SERVICE_ARG = "SW-SERVICE-ARG"
    SW_SYSTEMCONST = "SW-SYSTEMCONST"
    SW_SYSTEMCONSTANT_VALUE_SET = "SW-SYSTEMCONSTANT-VALUE-SET"
    SWC_BSW_MAPPING = "SWC-BSW-MAPPING"
    SWC_IMPLEMENTATION = "SWC-IMPLEMENTATION"
    SWC_INTERNAL_BEHAVIOR = "SWC-INTERNAL-BEHAVIOR"
    SWC_MODE_MANAGER_ERROR_EVENT = "SWC-MODE-MANAGER-ERROR-EVENT"
    SWC_MODE_SWITCH_EVENT = "SWC-MODE-SWITCH-EVENT"
    SWC_SERVICE_DEPENDENCY = "SWC-SERVICE-DEPENDENCY"
    SWC_TIMING = "SWC-TIMING"
    SWC_TO_APPLICATION_PARTITION_MAPPING = "SWC-TO-APPLICATION-PARTITION-MAPPING"
    SWC_TO_ECU_MAPPING = "SWC-TO-ECU-MAPPING"
    SWC_TO_IMPL_MAPPING = "SWC-TO-IMPL-MAPPING"
    SYNC_TIME_BASE_MGR_USER_NEEDS = "SYNC-TIME-BASE-MGR-USER-NEEDS"
    SYNCHRONIZATION_POINT_CONSTRAINT = "SYNCHRONIZATION-POINT-CONSTRAINT"
    SYNCHRONIZATION_TIMING_CONSTRAINT = "SYNCHRONIZATION-TIMING-CONSTRAINT"
    SYNCHRONIZED_TIME_BASE_CONSUMER = "SYNCHRONIZED-TIME-BASE-CONSUMER"
    SYNCHRONIZED_TIME_BASE_CONSUMER_INTERFACE = "SYNCHRONIZED-TIME-BASE-CONSUMER-INTERFACE"
    SYNCHRONIZED_TIME_BASE_PROVIDER = "SYNCHRONIZED-TIME-BASE-PROVIDER"
    SYNCHRONIZED_TIME_BASE_PROVIDER_INTERFACE = "SYNCHRONIZED-TIME-BASE-PROVIDER-INTERFACE"
    SYNCHRONOUS_SERVER_CALL_POINT = "SYNCHRONOUS-SERVER-CALL-POINT"
    SYSTEM = "SYSTEM"
    SYSTEM_MAPPING = "SYSTEM-MAPPING"
    SYSTEM_SIGNAL = "SYSTEM-SIGNAL"
    SYSTEM_SIGNAL_GROUP = "SYSTEM-SIGNAL-GROUP"
    SYSTEM_TIMING = "SYSTEM-TIMING"
    TCP_OPTION_FILTER_LIST = "TCP-OPTION-FILTER-LIST"
    TCP_OPTION_FILTER_SET = "TCP-OPTION-FILTER-SET"
    TD_CP_SOFTWARE_CLUSTER_MAPPING = "TD-CP-SOFTWARE-CLUSTER-MAPPING"
    TD_CP_SOFTWARE_CLUSTER_MAPPING_SET = "TD-CP-SOFTWARE-CLUSTER-MAPPING-SET"
    TD_CP_SOFTWARE_CLUSTER_RESOURCE_MAPPING = "TD-CP-SOFTWARE-CLUSTER-RESOURCE-MAPPING"
    TD_EVENT_BSW = "TD-EVENT-BSW"
    TD_EVENT_BSW_INTERNAL_BEHAVIOR = "TD-EVENT-BSW-INTERNAL-BEHAVIOR"
    TD_EVENT_BSW_MODE_DECLARATION = "TD-EVENT-BSW-MODE-DECLARATION"
    TD_EVENT_BSW_MODULE = "TD-EVENT-BSW-MODULE"
    TD_EVENT_COM = "TD-EVENT-COM"
    TD_EVENT_COMPLEX = "TD-EVENT-COMPLEX"
    TD_EVENT_CYCLE_START = "TD-EVENT-CYCLE-START"
    TD_EVENT_FR_CLUSTER_CYCLE_START = "TD-EVENT-FR-CLUSTER-CYCLE-START"
    TD_EVENT_FRAME = "TD-EVENT-FRAME"
    TD_EVENT_FRAME_ETHERNET = "TD-EVENT-FRAME-ETHERNET"
    TD_EVENT_I_PDU = "TD-EVENT-I-PDU"
    TD_EVENT_I_SIGNAL = "TD-EVENT-I-SIGNAL"
    TD_EVENT_MODE_DECLARATION = "TD-EVENT-MODE-DECLARATION"
    TD_EVENT_OPERATION = "TD-EVENT-OPERATION"
    TD_EVENT_SERVICE_INSTANCE = "TD-EVENT-SERVICE-INSTANCE"
    TD_EVENT_SERVICE_INSTANCE_DISCOVERY = "TD-EVENT-SERVICE-INSTANCE-DISCOVERY"
    TD_EVENT_SERVICE_INSTANCE_EVENT = "TD-EVENT-SERVICE-INSTANCE-EVENT"
    TD_EVENT_SERVICE_INSTANCE_FIELD = "TD-EVENT-SERVICE-INSTANCE-FIELD"
    TD_EVENT_SERVICE_INSTANCE_METHOD = "TD-EVENT-SERVICE-INSTANCE-METHOD"
    TD_EVENT_SLLET = "TD-EVENT-SLLET"
    TD_EVENT_SLLET_PORT = "TD-EVENT-SLLET-PORT"
    TD_EVENT_SWC = "TD-EVENT-SWC"
    TD_EVENT_SWC_INTERNAL_BEHAVIOR = "TD-EVENT-SWC-INTERNAL-BEHAVIOR"
    TD_EVENT_SWC_INTERNAL_BEHAVIOR_REFERENCE = "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE"
    TD_EVENT_TRIGGER = "TD-EVENT-TRIGGER"
    TD_EVENT_TT_CAN_CYCLE_START = "TD-EVENT-TT-CAN-CYCLE-START"
    TD_EVENT_VARIABLE_DATA_PROTOTYPE = "TD-EVENT-VARIABLE-DATA-PROTOTYPE"
    TD_EVENT_VFB = "TD-EVENT-VFB"
    TD_EVENT_VFB_PORT = "TD-EVENT-VFB-PORT"
    TD_EVENT_VFB_REFERENCE = "TD-EVENT-VFB-REFERENCE"
    TDLET_ZONE_CLOCK = "TDLET-ZONE-CLOCK"
    TIME_BASE_PROVIDER_TO_PERSISTENCY_MAPPING = "TIME-BASE-PROVIDER-TO-PERSISTENCY-MAPPING"
    TIME_BASE_RESOURCE = "TIME-BASE-RESOURCE"
    TIME_SYNC_MODULE_INSTANTIATION = "TIME-SYNC-MODULE-INSTANTIATION"
    TIME_SYNC_PORT_PROTOTYPE_TO_TIME_BASE_MAPPING = "TIME-SYNC-PORT-PROTOTYPE-TO-TIME-BASE-MAPPING"
    TIMING_CLOCK = "TIMING-CLOCK"
    TIMING_CLOCK_SYNC_ACCURACY = "TIMING-CLOCK-SYNC-ACCURACY"
    TIMING_CONDITION = "TIMING-CONDITION"
    TIMING_CONSTRAINT = "TIMING-CONSTRAINT"
    TIMING_DESCRIPTION = "TIMING-DESCRIPTION"
    TIMING_DESCRIPTION_EVENT = "TIMING-DESCRIPTION-EVENT"
    TIMING_DESCRIPTION_EVENT_CHAIN = "TIMING-DESCRIPTION-EVENT-CHAIN"
    TIMING_EVENT = "TIMING-EVENT"
    TIMING_EXTENSION = "TIMING-EXTENSION"
    TIMING_EXTENSION_RESOURCE = "TIMING-EXTENSION-RESOURCE"
    TIMING_MODE_INSTANCE = "TIMING-MODE-INSTANCE"
    TLS_CONNECTION_GROUP = "TLS-CONNECTION-GROUP"
    TLS_CRYPTO_CIPHER_SUITE = "TLS-CRYPTO-CIPHER-SUITE"
    TLS_CRYPTO_CIPHER_SUITE_PROPS = "TLS-CRYPTO-CIPHER-SUITE-PROPS"
    TLS_CRYPTO_SERVICE_MAPPING = "TLS-CRYPTO-SERVICE-MAPPING"
    TLS_DEPLOYMENT = "TLS-DEPLOYMENT"
    TLS_IAM_REMOTE_SUBJECT = "TLS-IAM-REMOTE-SUBJECT"
    TLS_JOB_MAPPING = "TLS-JOB-MAPPING"
    TLS_SECURE_COM_PROPS = "TLS-SECURE-COM-PROPS"
    TLV_DATA_ID_DEFINITION_SET = "TLV-DATA-ID-DEFINITION-SET"
    TOPIC_1 = "TOPIC-1"
    TP_ADDRESS = "TP-ADDRESS"
    TP_CONFIG = "TP-CONFIG"
    TRACEABLE_TABLE = "TRACEABLE-TABLE"
    TRACEABLE_TEXT = "TRACEABLE-TEXT"
    TRACED_FAILURE = "TRACED-FAILURE"
    TRANSFORMATION_PROPS = "TRANSFORMATION-PROPS"
    TRANSFORMATION_PROPS_SET = "TRANSFORMATION-PROPS-SET"
    TRANSFORMATION_PROPS_TO_SERVICE_INTERFACE_ELEMENT_MAPPING = (
        "TRANSFORMATION-PROPS-TO-SERVICE-INTERFACE-ELEMENT-MAPPING"
    )
    TRANSFORMATION_TECHNOLOGY = "TRANSFORMATION-TECHNOLOGY"
    TRANSFORMER_HARD_ERROR_EVENT = "TRANSFORMER-HARD-ERROR-EVENT"
    TRANSIENT_FAULT = "TRANSIENT-FAULT"
    TRIGGER = "TRIGGER"
    TRIGGER_INTERFACE = "TRIGGER-INTERFACE"
    TRIGGER_INTERFACE_MAPPING = "TRIGGER-INTERFACE-MAPPING"
    TTCAN_CLUSTER = "TTCAN-CLUSTER"
    TTCAN_COMMUNICATION_CONNECTOR = "TTCAN-COMMUNICATION-CONNECTOR"
    TTCAN_COMMUNICATION_CONTROLLER = "TTCAN-COMMUNICATION-CONTROLLER"
    TTCAN_PHYSICAL_CHANNEL = "TTCAN-PHYSICAL-CHANNEL"
    UCM_DESCRIPTION = "UCM-DESCRIPTION"
    UCM_MASTER_MODULE_INSTANTIATION = "UCM-MASTER-MODULE-INSTANTIATION"
    UCM_MODULE_INSTANTIATION = "UCM-MODULE-INSTANTIATION"
    UCM_RETRY_STRATEGY = "UCM-RETRY-STRATEGY"
    UCM_STEP = "UCM-STEP"
    UCM_SUBORDINATE_MODULE_INSTANTIATION = "UCM-SUBORDINATE-MODULE-INSTANTIATION"
    UCM_TO_TIME_BASE_RESOURCE_MAPPING = "UCM-TO-TIME-BASE-RESOURCE-MAPPING"
    UDP_NM_CLUSTER = "UDP-NM-CLUSTER"
    UDP_NM_NODE = "UDP-NM-NODE"
    UNIT = "UNIT"
    UNIT_GROUP = "UNIT-GROUP"
    UPLOADABLE_EXCLUSIVE_PACKAGE_ELEMENT = "UPLOADABLE-EXCLUSIVE-PACKAGE-ELEMENT"
    UPLOADABLE_PACKAGE_ELEMENT = "UPLOADABLE-PACKAGE-ELEMENT"
    USER_DEFINED_CLUSTER = "USER-DEFINED-CLUSTER"
    USER_DEFINED_COMMUNICATION_CONNECTOR = "USER-DEFINED-COMMUNICATION-CONNECTOR"
    USER_DEFINED_COMMUNICATION_CONTROLLER = "USER-DEFINED-COMMUNICATION-CONTROLLER"
    USER_DEFINED_ETHERNET_FRAME = "USER-DEFINED-ETHERNET-FRAME"
    USER_DEFINED_EVENT_DEPLOYMENT = "USER-DEFINED-EVENT-DEPLOYMENT"
    USER_DEFINED_FIELD_DEPLOYMENT = "USER-DEFINED-FIELD-DEPLOYMENT"
    USER_DEFINED_GLOBAL_TIME_MASTER = "USER-DEFINED-GLOBAL-TIME-MASTER"
    USER_DEFINED_GLOBAL_TIME_SLAVE = "USER-DEFINED-GLOBAL-TIME-SLAVE"
    USER_DEFINED_I_PDU = "USER-DEFINED-I-PDU"
    USER_DEFINED_METHOD_DEPLOYMENT = "USER-DEFINED-METHOD-DEPLOYMENT"
    USER_DEFINED_PDU = "USER-DEFINED-PDU"
    USER_DEFINED_PHYSICAL_CHANNEL = "USER-DEFINED-PHYSICAL-CHANNEL"
    USER_DEFINED_SERVICE_INSTANCE_TO_MACHINE_MAPPING = (
        "USER-DEFINED-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    )
    USER_DEFINED_SERVICE_INTERFACE_DEPLOYMENT = "USER-DEFINED-SERVICE-INTERFACE-DEPLOYMENT"
    USER_DEFINED_TRANSFORMATION_PROPS = "USER-DEFINED-TRANSFORMATION-PROPS"
    V_2_X_DATA_MANAGER_NEEDS = "V-2-X-DATA-MANAGER-NEEDS"
    V_2_X_FAC_USER_NEEDS = "V-2-X-FAC-USER-NEEDS"
    V_2_X_M_USER_NEEDS = "V-2-X-M-USER-NEEDS"
    VARIABLE_ACCESS = "VARIABLE-ACCESS"
    VARIABLE_AND_PARAMETER_INTERFACE_MAPPING = "VARIABLE-AND-PARAMETER-INTERFACE-MAPPING"
    VARIABLE_DATA_PROTOTYPE = "VARIABLE-DATA-PROTOTYPE"
    VARIATION_POINT_PROXY = "VARIATION-POINT-PROXY"
    VEHICLE_PACKAGE = "VEHICLE-PACKAGE"
    VEHICLE_ROLLOUT_STEP = "VEHICLE-ROLLOUT-STEP"
    VENDOR_SPECIFIC_SERVICE_NEEDS = "VENDOR-SPECIFIC-SERVICE-NEEDS"
    VFB_TIMING = "VFB-TIMING"
    VIEW_MAP = "VIEW-MAP"
    VIEW_MAP_SET = "VIEW-MAP-SET"
    VLAN_CONFIG = "VLAN-CONFIG"
    WAIT_POINT = "WAIT-POINT"
    WARNING_INDICATOR_REQUESTED_BIT_NEEDS = "WARNING-INDICATOR-REQUESTED-BIT-NEEDS"
    WORST_CASE_HEAP_USAGE = "WORST-CASE-HEAP-USAGE"
    WORST_CASE_STACK_USAGE = "WORST-CASE-STACK-USAGE"
    XCP_PDU = "XCP-PDU"


@dataclass(slots=True, kw_only=True)
class Identifier:
    """An Identifier is a string with a number of constraints on its appearance,
    satisfying the requirements typical programming languages define for their
    Identifiers.

    This datatype represents a string, that can be used as a
    c-Identifier. It shall start with a letter, may consist of letters,
    digits and underscores.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar name_pattern: This attribute represents a pattern which shall
        be used to define the value of the identifier if the identifier
        in question is part of a blueprint. For more details refer to
        TPS_StandardizationTemplate.
    """

    class Meta:
        name = "IDENTIFIER"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "max_length": 128,
            "pattern": r"[a-zA-Z][a-zA-Z0-9_]*",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    name_pattern: str | None = field(
        default=None,
        metadata={
            "name": "NAME-PATTERN",
            "type": "Attribute",
        },
    )


class IdsCommonElementSubtypesEnum(Enum):
    IDS_COMMON_ELEMENT = "IDS-COMMON-ELEMENT"
    IDS_MAPPING = "IDS-MAPPING"
    IDSM_INSTANCE = "IDSM-INSTANCE"
    IDSM_PROPERTIES = "IDSM-PROPERTIES"
    SECURITY_EVENT_CONTEXT_MAPPING = "SECURITY-EVENT-CONTEXT-MAPPING"
    SECURITY_EVENT_CONTEXT_MAPPING_APPLICATION = "SECURITY-EVENT-CONTEXT-MAPPING-APPLICATION"
    SECURITY_EVENT_CONTEXT_MAPPING_BSW_MODULE = "SECURITY-EVENT-CONTEXT-MAPPING-BSW-MODULE"
    SECURITY_EVENT_CONTEXT_MAPPING_COMM_CONNECTOR = "SECURITY-EVENT-CONTEXT-MAPPING-COMM-CONNECTOR"
    SECURITY_EVENT_CONTEXT_MAPPING_FUNCTIONAL_CLUSTER = (
        "SECURITY-EVENT-CONTEXT-MAPPING-FUNCTIONAL-CLUSTER"
    )
    SECURITY_EVENT_DEFINITION = "SECURITY-EVENT-DEFINITION"
    SECURITY_EVENT_FILTER_CHAIN = "SECURITY-EVENT-FILTER-CHAIN"


class IdsmInstanceSubtypesEnum(Enum):
    IDSM_INSTANCE = "IDSM-INSTANCE"


class IdsmModuleInstantiationSubtypesEnum(Enum):
    IDSM_MODULE_INSTANTIATION = "IDSM-MODULE-INSTANTIATION"


class IdsmRateLimitationSubtypesEnum(Enum):
    IDSM_RATE_LIMITATION = "IDSM-RATE-LIMITATION"


class IdsmTrafficLimitationSubtypesEnum(Enum):
    IDSM_TRAFFIC_LIMITATION = "IDSM-TRAFFIC-LIMITATION"


class IkeAuthenticationMethodEnumSimple(Enum):
    """
    :cvar DSA: Digital Signature Authentication
    :cvar PSK: Pre-shared key authentication
    """

    DSA = "DSA"
    PSK = "PSK"


class ImplementationDataTypeSubtypesEnum(Enum):
    IMPLEMENTATION_DATA_TYPE = "IMPLEMENTATION-DATA-TYPE"


class ImplementationDataTypeElementSubtypesEnum(Enum):
    IMPLEMENTATION_DATA_TYPE_ELEMENT = "IMPLEMENTATION-DATA-TYPE-ELEMENT"


@dataclass(slots=True, kw_only=True)
class Integer:
    """An instance of Integer is an element in the set of integer numbers ( ...,
    -2, -1, 0, 1, 2, ...).

    The value can be expressed in decimal, octal, hexadecimal and binary
    representation. Negative numbers can only be expressed in decimal
    notation Range is from -2147483648 and 2147483647.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INTEGER"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"0|[\+\-]?[1-9][0-9]*|0[xX][0-9a-fA-F]+|0[bB][0-1]+|0[0-7]+",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class InternalTriggeringPointSubtypesEnum(Enum):
    INTERNAL_TRIGGERING_POINT = "INTERNAL-TRIGGERING-POINT"


class InterpolationRoutineMappingSetSubtypesEnum(Enum):
    INTERPOLATION_ROUTINE_MAPPING_SET = "INTERPOLATION-ROUTINE-MAPPING-SET"


class IntervalTypeEnumSimple(Enum):
    """
    :cvar CLOSED: The area is limited by the value given. The value
        itself is included.
    :cvar INFINITE: This indicates that the limit is infinite. Note, it
        is obsolete. Use INF / -INF as value of the limit.
    :cvar OPEN: The area is limited by the value given. The value itself
        is not included.
    """

    CLOSED = "CLOSED"
    INFINITE = "INFINITE"
    OPEN = "OPEN"


class IpAddressKeepEnumSimple(Enum):
    """
    :cvar FORGET: After a dynamic IP address has been assigned just use
        it for this session.
    :cvar STORE_PERSISTENTLY: After a dynamic IP address has been
        assigned store the address persistently.
    """

    FORGET = "FORGET"
    STORE_PERSISTENTLY = "STORE-PERSISTENTLY"


class IpSecConfigPropsSubtypesEnum(Enum):
    IP_SEC_CONFIG_PROPS = "IP-SEC-CONFIG-PROPS"


class IpSecRuleSubtypesEnum(Enum):
    IP_SEC_RULE = "IP-SEC-RULE"


class IpTransportProtocolEnumSimple(Enum):
    """
    :cvar TCP: Transmission Control Protocol (TCP)
    :cvar UDP: User Datagram Protocol (UDP).
    """

    TCP = "TCP"
    UDP = "UDP"


@dataclass(slots=True, kw_only=True)
class Ip4AddressString:
    """This is used to specify an IP4 address.

    Notation: 255.255.255.255

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IP4-ADDRESS-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)|ANY",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Ip6AddressString:
    """This is used to specify an IP6 address.

    Notation:  FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF
    Alternative notations, short-cuts with duplicate colons like ::, etc. or mixtures using colons and dots, are not allowed.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IP6-ADDRESS-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"[0-9A-Fa-f]{1,4}(:[0-9A-Fa-f]{1,4}){7,7}|ANY",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class Ipv4AddressSourceEnumSimple(Enum):
    """
    :cvar AUTO_IP: AutoIP is used to dynamically assign IP addresses at
        device startup.
    :cvar AUTO_IP_DOIP: Linklocal IPv4 Address Assignment using DoIP
        Parameters
    :cvar AUTO_IPDHCPV_4: This enum literal is deprecated and will be
        removed in future. Old description: The IpAddress is declared
        via AutoIp or dhcp.
    :cvar DHCPV_4: DHCP is a service for the automatic IP configuration
        of a client.
    :cvar FIXED: The IP Address shall be declared manually.
    """

    AUTO_IP = "AUTO-IP"
    AUTO_IP_DOIP = "AUTO-IP--DOIP"
    AUTO_IPDHCPV_4 = "AUTO-IPDHCPV-4"
    DHCPV_4 = "DHCPV-4"
    FIXED = "FIXED"


class Ipv6AddressSourceEnumSimple(Enum):
    """
    :cvar DHCPV_6: DHCP is a service for the automatic IP configuration
        of a client.
    :cvar FIXED: The IP Address shall be declared manually.
    :cvar LINK_LOCAL: LinkLocal is intended only for communications
        within the segment of a local network (a link) or a point-to-
        point connection that a host is connected to.
    :cvar LINK_LOCAL_DOIP: Linklocal IPv6 Address Assignment using DoIP
        Parameters
    :cvar ROUTER_ADVERTISEMENT: IPv6 Stateless Autoconfiguration.
    """

    DHCPV_6 = "DHCPV-6"
    FIXED = "FIXED"
    LINK_LOCAL = "LINK-LOCAL"
    LINK_LOCAL_DOIP = "LINK-LOCAL--DOIP"
    ROUTER_ADVERTISEMENT = "ROUTER-ADVERTISEMENT"


class ItemLabelPosEnumSimple(Enum):
    """
    :cvar NEWLINE: The label is renders in a new line.
    :cvar NEWLINE_IF_NECESSARY: The label is rendered in a new line if
        it is longer than the indentation.
    :cvar NO_NEWLINE: The label is rendered in one line with the item
        even if it is longer than the indentation.
    """

    NEWLINE = "NEWLINE"
    NEWLINE_IF_NECESSARY = "NEWLINE-IF-NECESSARY"
    NO_NEWLINE = "NO-NEWLINE"


class J1939ClusterSubtypesEnum(Enum):
    J_1939_CLUSTER = "J-1939-CLUSTER"


class J1939ControllerApplicationSubtypesEnum(Enum):
    J_1939_CONTROLLER_APPLICATION = "J-1939-CONTROLLER-APPLICATION"


@dataclass(slots=True, kw_only=True)
class J1939NmEcu:
    """
    J1939 NmEcu specific attributes.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-NM-ECU"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class J1939NmNodeSubtypesEnum(Enum):
    J_1939_NM_NODE = "J-1939-NM-NODE"


class J1939TpNodeSubtypesEnum(Enum):
    J_1939_TP_NODE = "J-1939-TP-NODE"


class KeepWithPreviousEnumSimple(Enum):
    """
    :cvar KEEP: This indicates that the block shall be kept together
        with the previous block.
    :cvar NO_KEEP: This indicates that there is no need to keep the
        block with the previous one. This is the same as if the
        attribute itself is missing.
    """

    KEEP = "KEEP"
    NO_KEEP = "NO-KEEP"


class KeyUsageRestrictionEnumSimple(Enum):
    """
    :cvar GENERATE: Key is used for generation.
    :cvar GENERATE_AND_VERIFY: Key is used for generation and
        verification.
    :cvar VERIFY: Key is used for verification.
    """

    GENERATE = "GENERATE"
    GENERATE_AND_VERIFY = "GENERATE-AND-VERIFY"
    VERIFY = "VERIFY"


class LEnumSimple(Enum):
    """
    :cvar AA: Afar
    :cvar AB: Abkhazian
    :cvar AF: Afrikaans
    :cvar AM: Amharic
    :cvar AR: Arabic
    :cvar AS: Assamese
    :cvar AY: Aymara
    :cvar AZ: Azerbaijani
    :cvar BA: Bashkir
    :cvar BE: Byelorussian
    :cvar BG: Bulgarian
    :cvar BH: Bihari
    :cvar BI: Bislama
    :cvar BN: Bengali
    :cvar BO: Tibetian
    :cvar BR: Breton
    :cvar CA: Catalan
    :cvar CO: Corsican
    :cvar CS: Czech
    :cvar CY: Welsh
    :cvar DA: Danish
    :cvar DE: German
    :cvar DZ: Bhutani
    :cvar EL: Greek
    :cvar EN: English
    :cvar EO: Esperanto
    :cvar ES: Spanish
    :cvar ET: Estonian
    :cvar EU: Basque
    :cvar FA: Persian
    :cvar FI: Finnish
    :cvar FJ: Fiji
    :cvar FO: Faeroese
    :cvar FOR_ALL: The content applies to all languages
    :cvar FR: French
    :cvar FY: Frisian
    :cvar GA: Irish
    :cvar GD: Scots Gaelic
    :cvar GL: Galician
    :cvar GN: Guarani
    :cvar GU: Gjarati
    :cvar HA: Hausa
    :cvar HI: Hindi
    :cvar HR: Croatian
    :cvar HU: Hungarian
    :cvar HY: Armenian
    :cvar IA: Interlingua
    :cvar IE: Interlingue
    :cvar IK: Inupiak
    :cvar IN: Indonesian
    :cvar IS: Icelandic
    :cvar IT: Italian
    :cvar IW: Hebrew
    :cvar JA: Japanese
    :cvar JI: Yiddish
    :cvar JW: Javanese
    :cvar KA: Georgian
    :cvar KK: Kazakh
    :cvar KL: Greenlandic
    :cvar KM: Cambodian
    :cvar KN: Kannada
    :cvar KO: Korean
    :cvar KS: Kashmiri
    :cvar KU: Kurdish
    :cvar KY: Kirghiz
    :cvar LA: Latin
    :cvar LN: Lingala
    :cvar LO: Laothian
    :cvar LT: Lithuanian
    :cvar LV: Lavian, Lettish
    :cvar MG: Malagasy
    :cvar MI: Maori
    :cvar MK: Macedonian
    :cvar ML: Malayalam
    :cvar MN: Mongolian
    :cvar MO: Moldavian
    :cvar MR: Marathi
    :cvar MS: Malay
    :cvar MT: Maltese
    :cvar MY: Burmese
    :cvar NA: Nauru
    :cvar NE: Nepali
    :cvar NL: Dutch
    :cvar NO: Norwegian
    :cvar OC: Occitan
    :cvar OM: (Afan) Oromo
    :cvar OR: Oriya
    :cvar PA: Punjabi
    :cvar PL: Polish
    :cvar PS: Pashto, Pushto
    :cvar PT: Portuguese
    :cvar QU: Quechua
    :cvar RM: Rhaeto-Romance
    :cvar RN: Kirundi
    :cvar RO: Romanian
    :cvar RU: Russian
    :cvar RW: Kinyarwanda
    :cvar SA: Sanskrit
    :cvar SD: Sindhi
    :cvar SG: Sangro
    :cvar SH: Serbo-Croatian
    :cvar SI: Singhalese
    :cvar SK: Slovak
    :cvar SL: Slovenian
    :cvar SM: Samoan
    :cvar SN: Shona
    :cvar SO: Somali
    :cvar SQ: Albanian
    :cvar SR: Serbian
    :cvar SS: Siswati
    :cvar ST: Sesotho
    :cvar SU: Sundanese
    :cvar SV: Swedish
    :cvar SW: Swahili
    :cvar TA: Tamil
    :cvar TE: Tegulu
    :cvar TG: Tajik
    :cvar TH: Thai
    :cvar TI: Tigrinya
    :cvar TK: Turkmen
    :cvar TL: Tagalog
    :cvar TN: Setswana
    :cvar TO: Tonga
    :cvar TR: Turkish
    :cvar TS: Tsonga
    :cvar TT: Tatar
    :cvar TW: Twi
    :cvar UK: Ukrainian
    :cvar UR: Urdu
    :cvar UZ: Uzbek
    :cvar VI: Vietnamese
    :cvar VO: Volapuk
    :cvar WO: Wolof
    :cvar XH: Xhosa
    :cvar YO: Yoruba
    :cvar ZH: Chinese
    :cvar ZU: Zulu
    """

    AA = "AA"
    AB = "AB"
    AF = "AF"
    AM = "AM"
    AR = "AR"
    AS = "AS"
    AY = "AY"
    AZ = "AZ"
    BA = "BA"
    BE = "BE"
    BG = "BG"
    BH = "BH"
    BI = "BI"
    BN = "BN"
    BO = "BO"
    BR = "BR"
    CA = "CA"
    CO = "CO"
    CS = "CS"
    CY = "CY"
    DA = "DA"
    DE = "DE"
    DZ = "DZ"
    EL = "EL"
    EN = "EN"
    EO = "EO"
    ES = "ES"
    ET = "ET"
    EU = "EU"
    FA = "FA"
    FI = "FI"
    FJ = "FJ"
    FO = "FO"
    FOR_ALL = "FOR-ALL"
    FR = "FR"
    FY = "FY"
    GA = "GA"
    GD = "GD"
    GL = "GL"
    GN = "GN"
    GU = "GU"
    HA = "HA"
    HI = "HI"
    HR = "HR"
    HU = "HU"
    HY = "HY"
    IA = "IA"
    IE = "IE"
    IK = "IK"
    IN = "IN"
    IS = "IS"
    IT = "IT"
    IW = "IW"
    JA = "JA"
    JI = "JI"
    JW = "JW"
    KA = "KA"
    KK = "KK"
    KL = "KL"
    KM = "KM"
    KN = "KN"
    KO = "KO"
    KS = "KS"
    KU = "KU"
    KY = "KY"
    LA = "LA"
    LN = "LN"
    LO = "LO"
    LT = "LT"
    LV = "LV"
    MG = "MG"
    MI = "MI"
    MK = "MK"
    ML = "ML"
    MN = "MN"
    MO = "MO"
    MR = "MR"
    MS = "MS"
    MT = "MT"
    MY = "MY"
    NA = "NA"
    NE = "NE"
    NL = "NL"
    NO = "NO"
    OC = "OC"
    OM = "OM"
    OR = "OR"
    PA = "PA"
    PL = "PL"
    PS = "PS"
    PT = "PT"
    QU = "QU"
    RM = "RM"
    RN = "RN"
    RO = "RO"
    RU = "RU"
    RW = "RW"
    SA = "SA"
    SD = "SD"
    SG = "SG"
    SH = "SH"
    SI = "SI"
    SK = "SK"
    SL = "SL"
    SM = "SM"
    SN = "SN"
    SO = "SO"
    SQ = "SQ"
    SR = "SR"
    SS = "SS"
    ST = "ST"
    SU = "SU"
    SV = "SV"
    SW = "SW"
    TA = "TA"
    TE = "TE"
    TG = "TG"
    TH = "TH"
    TI = "TI"
    TK = "TK"
    TL = "TL"
    TN = "TN"
    TO = "TO"
    TR = "TR"
    TS = "TS"
    TT = "TT"
    TW = "TW"
    UK = "UK"
    UR = "UR"
    UZ = "UZ"
    VI = "VI"
    VO = "VO"
    WO = "WO"
    XH = "XH"
    YO = "YO"
    ZH = "ZH"
    ZU = "ZU"


class LatencyConstraintTypeEnumSimple(Enum):
    """
    :cvar AGE: In this case, the latency constraint is seen from the
        perspective of the response event of the associated event chain.
        Given a certain response event, the age interval of the latest
        stimulus is constrained.
    :cvar REACTION: In this case, the latency constraint is seen from
        the perspective of the stimulus event of the associated event
        chain. Given a certain stimulus event, the reaction interval of
        the first response is constrained.
    """

    AGE = "AGE"
    REACTION = "REACTION"


class LifeCycleStateSubtypesEnum(Enum):
    LIFE_CYCLE_STATE = "LIFE-CYCLE-STATE"


class LifeCycleStateDefinitionGroupSubtypesEnum(Enum):
    LIFE_CYCLE_STATE_DEFINITION_GROUP = "LIFE-CYCLE-STATE-DEFINITION-GROUP"


class LinChecksumTypeSimple(Enum):
    """
    :cvar CLASSIC: Classic in communication with LIN 1.3 slave nodes
    :cvar ENHANCED: Enhanced in communication with LIN 2.0 slave nodes.
    """

    CLASSIC = "CLASSIC"
    ENHANCED = "ENHANCED"


class LinFrameSubtypesEnum(Enum):
    LIN_EVENT_TRIGGERED_FRAME = "LIN-EVENT-TRIGGERED-FRAME"
    LIN_FRAME = "LIN-FRAME"
    LIN_SPORADIC_FRAME = "LIN-SPORADIC-FRAME"
    LIN_UNCONDITIONAL_FRAME = "LIN-UNCONDITIONAL-FRAME"


class LinFrameTriggeringSubtypesEnum(Enum):
    LIN_FRAME_TRIGGERING = "LIN-FRAME-TRIGGERING"


class LinScheduleTableSubtypesEnum(Enum):
    LIN_SCHEDULE_TABLE = "LIN-SCHEDULE-TABLE"


class LinSlaveSubtypesEnum(Enum):
    LIN_SLAVE = "LIN-SLAVE"


class LinSlaveConfigIdentSubtypesEnum(Enum):
    LIN_SLAVE_CONFIG_IDENT = "LIN-SLAVE-CONFIG-IDENT"


class LinTpNodeSubtypesEnum(Enum):
    LIN_TP_NODE = "LIN-TP-NODE"


class LinUnconditionalFrameSubtypesEnum(Enum):
    LIN_UNCONDITIONAL_FRAME = "LIN-UNCONDITIONAL-FRAME"


class ListEnumSimple(Enum):
    """
    :cvar NUMBER: This indicates that the list is an numerated list.
    :cvar UNNUMBER: This indicates that it is an enumeration (bulleted
        list)
    """

    NUMBER = "NUMBER"
    UNNUMBER = "UNNUMBER"


class LogAndTraceMessageCollectionSetSubtypesEnum(Enum):
    LOG_AND_TRACE_MESSAGE_COLLECTION_SET = "LOG-AND-TRACE-MESSAGE-COLLECTION-SET"


class LogTraceDefaultLogLevelEnumSimple(Enum):
    """
    :cvar DEBUG: Detailed information for programmers
    :cvar ERROR: Error with impact to correct functionality
    :cvar FATAL: Fatal error
    :cvar INFO: High level information
    :cvar OFF: logging is turned off
    :cvar VERBOSE: Verbose debug message
    :cvar WARN: Warning if correct behavior cannot be ensured
    """

    DEBUG = "DEBUG"
    ERROR = "ERROR"
    FATAL = "FATAL"
    INFO = "INFO"
    OFF = "OFF"
    VERBOSE = "VERBOSE"
    WARN = "WARN"


class LogicAddressSubtypesEnum(Enum):
    LOGIC_ADDRESS = "LOGIC-ADDRESS"


@dataclass(slots=True, kw_only=True)
class MacAddressString:
    """This primitive specifies a Mac Address.

    Notation: FF:FF:FF:FF:FF:FF
    Alternative notations, e.g. using dash instead of colon, or another grouping of numbers, is not allowed.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAC-ADDRESS-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"([0-9a-fA-F]{2}:){5}[0-9a-fA-F]{2}",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class MacMulticastGroupSubtypesEnum(Enum):
    MAC_MULTICAST_GROUP = "MAC-MULTICAST-GROUP"


class MacSecCapabilityEnumSimple(Enum):
    """
    :cvar INTERGRITY_AND_CONFIDENTIALITY: Option that ensures
        confidentiality and integrity
    :cvar INTERGRITY_WITHOUT_CONFIDENTIALITY: Option that ensures
        integrity without confidentiality
    """

    INTERGRITY_AND_CONFIDENTIALITY = "INTERGRITY-AND-CONFIDENTIALITY"
    INTERGRITY_WITHOUT_CONFIDENTIALITY = "INTERGRITY-WITHOUT-CONFIDENTIALITY"


class MacSecConfidentialityOffsetEnumSimple(Enum):
    """
    :cvar CONFIDENTIALITY_OFFSET_0: confidentiality offset of 0.
    :cvar CONFIDENTIALITY_OFFSET_30: confidentiality offset of 30.
    :cvar CONFIDENTIALITY_OFFSET_50: confidentiality offset of 50.
    """

    CONFIDENTIALITY_OFFSET_0 = "CONFIDENTIALITY-OFFSET--0"
    CONFIDENTIALITY_OFFSET_30 = "CONFIDENTIALITY-OFFSET--30"
    CONFIDENTIALITY_OFFSET_50 = "CONFIDENTIALITY-OFFSET--50"


class MacSecFailPermissiveModeEnumSimple(Enum):
    """
    :cvar NEVER: The controlled port will never be set to enabled if the
        participants cannot establish and successfully use a MACsec
        Secure Channel.
    :cvar TIMEOUT: The controlled port will be set to enabled and MACsec
        will not be used in the port if the timeout value
        (onFailPermissiveModeTimeout) is reached and the following
        conditions apply: - A participant belonging to the same CA was
        recognized and authenticated. - A secure channel could be
        established. - Both participants can transmit and receive MACsec
        protected traffic through the SC.
    """

    NEVER = "NEVER"
    TIMEOUT = "TIMEOUT"


class MacSecGlobalKayPropsSubtypesEnum(Enum):
    MAC_SEC_GLOBAL_KAY_PROPS = "MAC-SEC-GLOBAL-KAY-PROPS"


class MacSecKayParticipantSubtypesEnum(Enum):
    MAC_SEC_KAY_PARTICIPANT = "MAC-SEC-KAY-PARTICIPANT"


class MacSecRoleEnumSimple(Enum):
    """
    :cvar KEY_SERVER: Port acts in the KeyServer role
    :cvar PEER: Port acts in the peer role
    """

    KEY_SERVER = "KEY-SERVER"
    PEER = "PEER"


class MachineSubtypesEnum(Enum):
    MACHINE = "MACHINE"


class MachineDesignSubtypesEnum(Enum):
    MACHINE_DESIGN = "MACHINE-DESIGN"


class MappingDirectionEnumSimple(Enum):
    """
    :cvar BIDIRECTIONAL: The TextTableMapping is applicable in both
        directions.
    :cvar FIRST_TO_SECOND: The TextTableMapping is applicable in the
        direction from firstDataPrototype / firstOperationArgument
        referring into the PortInterface of the PPortPrototype to
        secondDataPrototype / secondOperationArgument referring into the
        PortInterface of the RPortPrototype.
    :cvar SECOND_TO_FIRST: The TextTableMapping is applicable in the
        direction from secondDataPrototype / secondOperationArgument
        referring into the PortInterface of the PPortPrototype to
        firstDataPrototype / firstOperationArgument referring into the
        PortInterface of the RPortPrototype.
    """

    BIDIRECTIONAL = "BIDIRECTIONAL"
    FIRST_TO_SECOND = "FIRST-TO-SECOND"
    SECOND_TO_FIRST = "SECOND-TO-FIRST"


class MappingScopeEnumSimple(Enum):
    """
    :cvar MAPPING_SCOPE_CORE: The mapping constraint applies to
        different Cores.
    :cvar MAPPING_SCOPE_ECU: The mapping constraint applies to different
        Ecus.
    :cvar MAPPING_SCOPE_PARTITION: The mapping constraint applies to
        different Partitions.
    """

    MAPPING_SCOPE_CORE = "MAPPING-SCOPE-CORE"
    MAPPING_SCOPE_ECU = "MAPPING-SCOPE-ECU"
    MAPPING_SCOPE_PARTITION = "MAPPING-SCOPE-PARTITION"


class MaxCommModeEnumSimple(Enum):
    """
    :cvar FULL: Full communication is requested.
    :cvar NONE: No communication is requested.
    :cvar SILENT: Silent communication is requested: Only listening but
        not "talking".
    """

    FULL = "FULL"
    NONE = "NONE"
    SILENT = "SILENT"


class MaximumMessageLengthTypeSimple(Enum):
    """
    :cvar I_4_G: SF-E allowed (SF of arbitrary length depending on
        FrTpPduLength), up to (2**32)-1 byte message length (all FF-x
        allowed).
    :cvar ISO: Up to (2**12)-1 Byte message length (No FF-Ex or SF-E or
        AF shall be used and recognized).
    :cvar ISO_6: As ISO, but the maximum payload length is limited to 6
        byte (SF-I, FF-I, CF). This is necessary to route TP on CAN when
        using Extended Addressing or Mixed Addressing on CAN.
    """

    I_4_G = "I-4-G"
    ISO = "ISO"
    ISO_6 = "ISO-6"


class McDataInstanceSubtypesEnum(Enum):
    MC_DATA_INSTANCE = "MC-DATA-INSTANCE"


class McFunctionSubtypesEnum(Enum):
    MC_FUNCTION = "MC-FUNCTION"


class McGroupSubtypesEnum(Enum):
    MC_GROUP = "MC-GROUP"


@dataclass(slots=True, kw_only=True)
class McdIdentifier:
    """This primitive denotes a name used for measurement and calibration systems
    and shall follow the restrictions for an ASAM ASAP2 ident.

    For detailed syntax see the xsd.pattern. The size limitations are
    not captured. McdIdentifiers are random names which may contain
    characters A through Z, a through z, underscore (_), numerals 0
    through 9, points ('.') and brackets ( '[',']' ). However, the
    following limitations apply: the first character shall be a letter
    or an underscore, brackets shall occur in pairs at the end of a
    partial string and shall contain a number or an alpha-numerical
    string (description of the index of an array element).

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MCD-IDENTIFIER"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"[a-zA-Z_][a-zA-Z0-9_]*(\[([a-zA-Z_][a-zA-Z0-9_]*|[0-9]+)\])*(\.[a-zA-Z_][a-zA-Z0-9_]*(\[([a-zA-Z_][a-zA-Z0-9_]*|[0-9]+)\])*)*",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class MemoryAllocationKeywordPolicyTypeSimple(Enum):
    """
    :cvar ADDR_METHOD_SHORT_NAME: The MemorySection shortNames of
        referring MemorySections and therefore the belonging Memory
        Allocation Keywords in the code are build with the shortName of
        the SwAddrMethod. This is the default value if the attribute
        does not exist.
    :cvar ADDR_METHOD_SHORT_NAME_AND_ALIGNMENT: The MemorySection
        shortNames of referring MemorySections and therefore the
        belonging Memory Allocation Keywords in the code are build with
        the shortName of the SwAddrMethod and a variable alignment
        postfix. Thereby the alignment postfix needs to be consistent
        with the alignment attribute of the related MemorySection.
    """

    ADDR_METHOD_SHORT_NAME = "ADDR-METHOD-SHORT-NAME"
    ADDR_METHOD_SHORT_NAME_AND_ALIGNMENT = "ADDR-METHOD-SHORT-NAME-AND-ALIGNMENT"


class MemorySectionSubtypesEnum(Enum):
    MEMORY_SECTION = "MEMORY-SECTION"


class MemorySectionTypeSimple(Enum):
    """
    :cvar CALIBRATION_OFFLINE: Program data which can only be used for
        offline calibration. '''Note''': This value is deprecated and
        shall be substituted by calPrm.
    :cvar CALIBRATION_ONLINE: Program data which can be used for online
        calibration. '''Note''': This value is deprecated and shall be
        substituted by calPrm.
    :cvar CALIBRATION_VARIABLES: This memory section is reserved for
        "virtual variables" that are computed by an MCD system during a
        measurement session but do not exist in the ECU memory.
    :cvar CALPRM: To be used for calibratable constants of ECU-
        functions.
    :cvar CODE: To be used for mapping code to application block, boot
        block, external flash etc.
    :cvar CONFIG_DATA: Constants with attributes that show that they
        reside in one segment for module configuration.
    :cvar CONST: To be used for global or static constants.
    :cvar EXCLUDE_FROM_FLASH: This memory section is reserved for
        "virtual parameters" that are taken for computing the values of
        so-called dependent parameter of an MCD system. Dependent
        Parameters that are not at the same time "virtual parameters"
        are allocated in the ECU memory. Virtual parameters, on the
        other hand, are not allocated in the ECU memory. Virtual
        parameters exist in the ECU Hex file for the purpose of being
        considered (for computing the values of dependent parameters)
        during an offline-calibration session.
    :cvar USER_DEFINED: No specific categorization of sectionType
        possible. '''Note''': This value is deprecated and shall be
        substituted by var, code, const, calprm, configData,
        excludeFromFlash and the appropriate values of the orthogonal
        attributes sectionInitializationPolicy,
        memoryAllocationKeywordPolicy and option.
    :cvar VAR: To be used for global or static variables. The expected
        initialization is specified with the attribute
        sectionInitializationPolicy.
    :cvar VAR_FAST: To be used for all global or static variables that
        have at least one of the following properties: - accessed bit-
        wise - frequently used - high number of accesses in source code
        Some platforms allow the use of bit instructions for variables
        located in this specific RAM area as well as shorter addressing
        instructions. This saves code and runtime. '''Note''': This
        value is deprecated and shall be substituted by var and the
        appropriate values of the orthogonal attributes
        sectionInitializationPolicy, memoryAllocationKeywordPolicy and
        option.
    :cvar VAR_NO_INIT: To be used for all global or static variables
        that are never initialized. '''Note''': This value is deprecated
        and shall be substituted by var and the appropriate values of
        the orthogonal attributes sectionInitializationPolicy,
        memoryAllocationKeywordPolicy and option.
    :cvar VAR_POWER_ON_INIT: To be used for all global or static
        variables that are initialized only after power on reset.
        '''Note''': This value is deprecated and shall be substituted by
        var and the appropriate values of the orthogonal attributes
        sectionInitializationPolicy, memoryAllocationKeywordPolicy and
        option.
    """

    CALIBRATION_OFFLINE = "CALIBRATION-OFFLINE"
    CALIBRATION_ONLINE = "CALIBRATION-ONLINE"
    CALIBRATION_VARIABLES = "CALIBRATION-VARIABLES"
    CALPRM = "CALPRM"
    CODE = "CODE"
    CONFIG_DATA = "CONFIG-DATA"
    CONST = "CONST"
    EXCLUDE_FROM_FLASH = "EXCLUDE-FROM-FLASH"
    USER_DEFINED = "USER-DEFINED"
    VAR = "VAR"
    VAR_FAST = "VAR-FAST"
    VAR_NO_INIT = "VAR-NO-INIT"
    VAR_POWER_ON_INIT = "VAR-POWER-ON-INIT"


@dataclass(slots=True, kw_only=True)
class MetaClassName:
    """
    Name of a class in the AUTOSAR Meta-Model.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "META-CLASS-NAME"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"[A-Z][a-zA-Z0-9_]*",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MimeTypeString:
    """
    This primitive denotes the an Internet media type, originally called a MIME
    type after MIME and sometimes a Content-type after the name of a header in
    several protocols whose value is such a type, is a two-part identifier for file
    formats on the Internet.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MIME-TYPE-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class ModeActivationKindSimple(Enum):
    """
    :cvar ON_ENTRY: On entering the referred mode.
    :cvar ON_EXIT: On exiting the referred mode.
    :cvar ON_TRANSITION: On transition of the 1st referred mode to the
        2nd referred mode.
    """

    ON_ENTRY = "ON-ENTRY"
    ON_EXIT = "ON-EXIT"
    ON_TRANSITION = "ON-TRANSITION"


class ModeDeclarationSubtypesEnum(Enum):
    MODE_DECLARATION = "MODE-DECLARATION"


class ModeDeclarationGroupSubtypesEnum(Enum):
    MODE_DECLARATION_GROUP = "MODE-DECLARATION-GROUP"


class ModeDeclarationGroupPrototypeSubtypesEnum(Enum):
    MODE_DECLARATION_GROUP_PROTOTYPE = "MODE-DECLARATION-GROUP-PROTOTYPE"


class ModeDeclarationMappingSetSubtypesEnum(Enum):
    MODE_DECLARATION_MAPPING_SET = "MODE-DECLARATION-MAPPING-SET"


class ModeErrorReactionPolicyEnumSimple(Enum):
    """
    :cvar DEFAULT_MODE: This represents the ability to switch to the
        defaultMode in case of a mode error.
    :cvar LAST_MODE: This represents the ability to keep the last mode
        in case of a mode error.
    """

    DEFAULT_MODE = "DEFAULT-MODE"
    LAST_MODE = "LAST-MODE"


class ModeSwitchPointSubtypesEnum(Enum):
    MODE_SWITCH_POINT = "MODE-SWITCH-POINT"


class ModificationTypeEnumSimple(Enum):
    """
    :cvar CONTENT_RELATED: The attribute contentRelated expresses, that
        a substantial change of the content was performed in the object.
        Usually this means e.g. that the derived artifacts need to be
        regenerated (e.g. code generation).
    :cvar DOC_RELATED: The attribute docRelated expresses, that a change
        was applied to the documentation or other informal aspects of
        the object. Usually this means e.g. that not all derived
        artifacts need to be regenerated (e.g. code generation).
    """

    CONTENT_RELATED = "CONTENT-RELATED"
    DOC_RELATED = "DOC-RELATED"


class MonotonyEnumSimple(Enum):
    """
    :cvar DECREASING: This indicates that the related curve needs to be
        monotony decreasing.
    :cvar INCREASING: This indicates that the related curve needs to be
        monotony increasing.
    :cvar MONOTONOUS: This indicates that the values shall be
        monotonously decreasing or increasing, depending on the trend
        set by the first values of the series.
    :cvar NO_MONOTONY: This indicates that the related curve needs not
        to be monotony.
    :cvar STRICT_MONOTONOUS: This indicates that the values shall be
        strict monotonously decreasing or increasing, depending on the
        trend set by the first values of the series.
    :cvar STRICTLY_DECREASING: This indicates that the related curve
        needs to be strictly monotony decreasing.
    :cvar STRICTLY_INCREASING: This indicates that the related curve
        needs to be strictly monotony increasing.
    """

    DECREASING = "DECREASING"
    INCREASING = "INCREASING"
    MONOTONOUS = "MONOTONOUS"
    NO_MONOTONY = "NO-MONOTONY"
    STRICT_MONOTONOUS = "STRICT-MONOTONOUS"
    STRICTLY_DECREASING = "STRICTLY-DECREASING"
    STRICTLY_INCREASING = "STRICTLY-INCREASING"


@dataclass(slots=True, kw_only=True)
class MsrQueryArg:
    """This represents an argument to the query.

    Note that the arguments are not standardized and therefore subject
    to mutual agreement.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This denotes the name of the query argument (semantic
        information)
    """

    class Meta:
        name = "MSR-QUERY-ARG"

    value: str = field(
        default="",
        metadata={
            "required": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: str | None = field(
        default=None,
        metadata={
            "name": "SI",
            "type": "Attribute",
        },
    )


class NPduSubtypesEnum(Enum):
    N_PDU = "N-PDU"


@dataclass(slots=True, kw_only=True)
class NativeDeclarationString:
    """This string contains a native data declaration of a data type in a
    programming language.

    It is basically a string, but white-space shall be preserved.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NATIVE-DECLARATION-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "white_space": "preserve",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class NetworkEndpointSubtypesEnum(Enum):
    NETWORK_ENDPOINT = "NETWORK-ENDPOINT"


class NetworkTargetAddressTypeSimple(Enum):
    """
    :cvar FUNCTIONAL: Functional request type
    :cvar FUNCTIONAL_CAN_FD: Functional request type via CAN FD
    :cvar PHYSICAL: Physical request type
    :cvar PHYSICAL_CAN_FD: Physical request type via CAN FD
    """

    FUNCTIONAL = "FUNCTIONAL"
    FUNCTIONAL_CAN_FD = "FUNCTIONAL-CAN-FD"
    PHYSICAL = "PHYSICAL"
    PHYSICAL_CAN_FD = "PHYSICAL-CAN-FD"


class NmCoordinatorRoleEnumSimple(Enum):
    """
    :cvar ACTIVE: Coordinator which "actively" performs NmCoordinator
        functionality at this channel
    :cvar PASSIVE: Coordinator which "passively" performs NmCoordinator
        functionality at this channel - used at NmCoordinatorSync use
        case.
    """

    ACTIVE = "ACTIVE"
    PASSIVE = "PASSIVE"


class NmEcuSubtypesEnum(Enum):
    NM_ECU = "NM-ECU"


class NmHandleMappingDirectionEnumSimple(Enum):
    """
    :cvar FUNCTION_GROUP_STATE_TO_NM_HANDLE: The purpose of the mapping
        is to indicate which function group state requires network
        access.
    :cvar NM_HANDLE_ACTIVE_TO_FUNCTION_GROUP_STATE: The purpose of the
        mapping is to indicate that the function group shall be switched
        to a given state if the network handle becomes active.
    :cvar NM_HANDLE_INACTIVE_TO_FUNCTION_GROUP_STATE: The purpose of the
        mapping is to indicate that the function group shall be switched
        to a given state if the network handle becomes inactive.
    """

    FUNCTION_GROUP_STATE_TO_NM_HANDLE = "FUNCTION-GROUP-STATE-TO-NM-HANDLE"
    NM_HANDLE_ACTIVE_TO_FUNCTION_GROUP_STATE = "NM-HANDLE-ACTIVE-TO-FUNCTION-GROUP-STATE"
    NM_HANDLE_INACTIVE_TO_FUNCTION_GROUP_STATE = "NM-HANDLE-INACTIVE-TO-FUNCTION-GROUP-STATE"


class NmNetworkHandleSubtypesEnum(Enum):
    NM_NETWORK_HANDLE = "NM-NETWORK-HANDLE"


class NmNodeSubtypesEnum(Enum):
    CAN_NM_NODE = "CAN-NM-NODE"
    FLEXRAY_NM_NODE = "FLEXRAY-NM-NODE"
    J_1939_NM_NODE = "J-1939-NM-NODE"
    NM_NODE = "NM-NODE"
    UDP_NM_NODE = "UDP-NM-NODE"


class NmPduSubtypesEnum(Enum):
    NM_PDU = "NM-PDU"


@dataclass(slots=True, kw_only=True)
class NmtokenString:
    """This is an identifier as used in xml, e.g. xml-names.

    Typical usages are, for example, the names of type emitters, protocols, or profiles. For details see NMTOKEN definition on the W3C website (https://www.w3.org/TR/xml/#NT-Nmtoken).
    Note: Although NameToken supports a wide range of characters, the actually allowed patterns for a certain attribute typed by NameToken may be further restricted by the specification of that attribute.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NMTOKEN-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class NmtokensString:
    """
    This is a white-space separated list of name tokens.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NMTOKENS-STRING"

    value: list[str] = field(
        default_factory=list,
        metadata={
            "tokens": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class NonOsModuleInstantiationSubtypesEnum(Enum):
    ADAPTIVE_FIREWALL_MODULE_INSTANTIATION = "ADAPTIVE-FIREWALL-MODULE-INSTANTIATION"
    CRYPTO_MODULE_INSTANTIATION = "CRYPTO-MODULE-INSTANTIATION"
    DETERMINISTIC_CLIENT = "DETERMINISTIC-CLIENT"
    DETERMINISTIC_SYNC_INSTANTIATION = "DETERMINISTIC-SYNC-INSTANTIATION"
    DETERMINISTIC_SYNC_MASTER = "DETERMINISTIC-SYNC-MASTER"
    DO_IP_INSTANTIATION = "DO-IP-INSTANTIATION"
    GENERIC_MODULE_INSTANTIATION = "GENERIC-MODULE-INSTANTIATION"
    IAM_MODULE_INSTANTIATION = "IAM-MODULE-INSTANTIATION"
    IDS_PLATFORM_INSTANTIATION = "IDS-PLATFORM-INSTANTIATION"
    IDSM_MODULE_INSTANTIATION = "IDSM-MODULE-INSTANTIATION"
    LOG_AND_TRACE_INSTANTIATION = "LOG-AND-TRACE-INSTANTIATION"
    NM_INSTANTIATION = "NM-INSTANTIATION"
    NON_OS_MODULE_INSTANTIATION = "NON-OS-MODULE-INSTANTIATION"
    SOVD_GATEWAY_INSTANTIATION = "SOVD-GATEWAY-INSTANTIATION"
    SOVD_MODULE_INSTANTIATION = "SOVD-MODULE-INSTANTIATION"
    SOVD_SERVER_INSTANTIATION = "SOVD-SERVER-INSTANTIATION"
    STATE_MANAGEMENT_MODULE_INSTANTIATION = "STATE-MANAGEMENT-MODULE-INSTANTIATION"
    TIME_SYNC_MODULE_INSTANTIATION = "TIME-SYNC-MODULE-INSTANTIATION"
    UCM_MASTER_MODULE_INSTANTIATION = "UCM-MASTER-MODULE-INSTANTIATION"
    UCM_MODULE_INSTANTIATION = "UCM-MODULE-INSTANTIATION"
    UCM_SUBORDINATE_MODULE_INSTANTIATION = "UCM-SUBORDINATE-MODULE-INSTANTIATION"


@dataclass(slots=True, kw_only=True)
class NormalizedInstruction:
    """This meta-class is used to describe runtime budget needs on the target system within DeterministicClient::WaitForActivation cycles. NormalizedInstructions does not reflect the actual number of code instructions, but allows the description of comparative resource needs. NormalizedInstructions is used for configuration of computing resources at integration time.
    NormalizedInstruction = runtime in sec * clock frequency in Hz

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NORMALIZED-INSTRUCTION"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"[1-9][0-9]*",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class NoteTypeEnumSimple(Enum):
    """
    :cvar CAUTION: This indicates that the note is an alert which shall
        be considered carefully.
    :cvar EXAMPLE: This indicates that the note represents an example,
        e.g. a code example etc.
    :cvar EXERCISE: This indicates that the note represents an exercise
        for the reader.
    :cvar HINT: This indicates that the note represents a hint which
        helps the user for better understanding.
    :cvar INSTRUCTION: This indicates that the note represents an
        instruction, e.g. a step by step procedure.
    :cvar OTHER: This indicates that the note is something else. The
        particular type of the note shall then be specified in the label
        of the note.
    :cvar TIP: This indicates that the note represents which is good to
        know. It is similar to a hint, but focuses more to good practice
        than to better understanding.
    """

    CAUTION = "CAUTION"
    EXAMPLE = "EXAMPLE"
    EXERCISE = "EXERCISE"
    HINT = "HINT"
    INSTRUCTION = "INSTRUCTION"
    OTHER = "OTHER"
    TIP = "TIP"


@dataclass(slots=True, kw_only=True)
class NumericalValue:
    """This primitive specifies a numerical value.

    It can be denoted in different formats such as Decimal, Octal,
    Hexadecimal, Float. See the xsd pattern for details. The value can
    be expressed in octal, hexadecimal, binary representation. Negative
    numbers can only be expressed in decimal or float notation.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NUMERICAL-VALUE"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"(0[xX][0-9a-fA-F]+)|(0[0-7]+)|(0[bB][0-1]+)|(([+\-]?[1-9][0-9]+(\.[0-9]+)?|[+\-]?[0-9](\.[0-9]+)?)([eE]([+\-]?)[0-9]+)?)|\.0|INF|-INF|NaN",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class NvBlockNeedsReliabilityEnumSimple(Enum):
    """
    :cvar ERROR_CORRECTION: Errors shall be corrected
    :cvar ERROR_DETECTION: Errors shall be detected
    :cvar NO_PROTECTION: Data need not to be handled with protection
    """

    ERROR_CORRECTION = "ERROR-CORRECTION"
    ERROR_DETECTION = "ERROR-DETECTION"
    NO_PROTECTION = "NO-PROTECTION"


class NvBlockNeedsWritingPriorityEnumSimple(Enum):
    """
    :cvar HIGH: Writing priority is high.
    :cvar LOW: Writing priority is low.
    :cvar MEDIUM: Writing priority is medium.
    """

    HIGH = "HIGH"
    LOW = "LOW"
    MEDIUM = "MEDIUM"


class ObdRatioConnectionKindEnumSimple(Enum):
    """
    :cvar API_USE: The IUMPR service (of the DEM) uses an explicit API
        to connect to the component or module.
    :cvar OBSERVER: The IUMPR service (of the Dem) uses no API but
        "observes"  the associated diagnostic event.
    """

    API_USE = "API-USE"
    OBSERVER = "OBSERVER"


class OperationCycleTypeEnumSimple(Enum):
    """
    :cvar IGNITION: Ignition ON / OFF cycle.
    :cvar OBD_DCY: OBD Driving cycle.
    :cvar OTHER: Further operation cycle.
    :cvar POWER: Power ON / OFF cycle.
    :cvar TIME: Time based operation cycle.
    :cvar WARMUP: OBD Warm up cycle.
    """

    IGNITION = "IGNITION"
    OBD_DCY = "OBD-DCY"
    OTHER = "OTHER"
    POWER = "POWER"
    TIME = "TIME"
    WARMUP = "WARMUP"


class OrientEnumSimple(Enum):
    """
    :cvar LAND: This indicates that the table is rendered in landscape
        which results in turning the table 90 degree clockwise.
    :cvar PORT: This indicates that the table is rendered in portrait,
        which is the regular text flow.
    """

    LAND = "LAND"
    PORT = "PORT"


class OsTaskPreemptabilityEnumSimple(Enum):
    """
    :cvar FULL: Task is preemptable.
    :cvar NONE: Task is not preemptable.
    """

    FULL = "FULL"
    NONE = "NONE"


class OsTaskProxySubtypesEnum(Enum):
    OS_TASK_PROXY = "OS-TASK-PROXY"


class PPortPrototypeSubtypesEnum(Enum):
    P_PORT_PROTOTYPE = "P-PORT-PROTOTYPE"


class ParameterDataPrototypeSubtypesEnum(Enum):
    PARAMETER_DATA_PROTOTYPE = "PARAMETER-DATA-PROTOTYPE"


class PduSubtypesEnum(Enum):
    CONTAINER_I_PDU = "CONTAINER-I-PDU"
    DCM_I_PDU = "DCM-I-PDU"
    GENERAL_PURPOSE_I_PDU = "GENERAL-PURPOSE-I-PDU"
    GENERAL_PURPOSE_PDU = "GENERAL-PURPOSE-PDU"
    I_PDU = "I-PDU"
    I_SIGNAL_I_PDU = "I-SIGNAL-I-PDU"
    J_1939_DCM_I_PDU = "J-1939-DCM-I-PDU"
    MULTIPLEXED_I_PDU = "MULTIPLEXED-I-PDU"
    N_PDU = "N-PDU"
    NM_PDU = "NM-PDU"
    PDU = "PDU"
    SECURED_I_PDU = "SECURED-I-PDU"
    USER_DEFINED_I_PDU = "USER-DEFINED-I-PDU"
    USER_DEFINED_PDU = "USER-DEFINED-PDU"
    XCP_PDU = "XCP-PDU"


class PduCollectionSemanticsEnumSimple(Enum):
    """
    :cvar LAST_IS_BEST: Only the latest PDU instances are transmitted.
    :cvar QUEUED: All instances of PDUs are transmitted.
    """

    LAST_IS_BEST = "LAST-IS-BEST"
    QUEUED = "QUEUED"


class PduCollectionTriggerEnumSimple(Enum):
    """
    :cvar ALWAYS: Pdu will trigger the transmission of the data.
    :cvar NEVER: Pdu will be buffered and will not trigger the
        transmission of the data.
    """

    ALWAYS = "ALWAYS"
    NEVER = "NEVER"


class PduTriggeringSubtypesEnum(Enum):
    PDU_TRIGGERING = "PDU-TRIGGERING"


class PdurIPduGroupSubtypesEnum(Enum):
    PDUR_I_PDU_GROUP = "PDUR-I-PDU-GROUP"


class PerInstanceMemorySubtypesEnum(Enum):
    PER_INSTANCE_MEMORY = "PER-INSTANCE-MEMORY"


class PersistencyCollectionLevelUpdateStrategyEnumSimple(Enum):
    """
    :cvar DELETE: The update strategy is to delete all values on the
        level of the respective collection.
    :cvar KEEP_EXISTING: The update strategy is to keep the existing
        values on the level of the respective collection.
    """

    DELETE = "DELETE"
    KEEP_EXISTING = "KEEP-EXISTING"


class PersistencyDataElementSubtypesEnum(Enum):
    PERSISTENCY_DATA_ELEMENT = "PERSISTENCY-DATA-ELEMENT"


class PersistencyDeploymentSubtypesEnum(Enum):
    PERSISTENCY_DEPLOYMENT = "PERSISTENCY-DEPLOYMENT"
    PERSISTENCY_FILE_STORAGE = "PERSISTENCY-FILE-STORAGE"
    PERSISTENCY_KEY_VALUE_STORAGE = "PERSISTENCY-KEY-VALUE-STORAGE"


class PersistencyDeploymentElementSubtypesEnum(Enum):
    PERSISTENCY_DEPLOYMENT_ELEMENT = "PERSISTENCY-DEPLOYMENT-ELEMENT"
    PERSISTENCY_FILE = "PERSISTENCY-FILE"
    PERSISTENCY_KEY_VALUE_PAIR = "PERSISTENCY-KEY-VALUE-PAIR"


class PersistencyElementLevelUpdateStrategyEnumSimple(Enum):
    """
    :cvar DELETE: The update strategy is to delete the value of the
        respective data item.
    :cvar KEEP_EXISTING: The update strategy is to keep the existing
        value of the respective data item.
    :cvar OVERWRITE: The update strategy is to overwrite the respective
        data item.
    """

    DELETE = "DELETE"
    KEEP_EXISTING = "KEEP-EXISTING"
    OVERWRITE = "OVERWRITE"


class PersistencyFileStorageSubtypesEnum(Enum):
    PERSISTENCY_FILE_STORAGE = "PERSISTENCY-FILE-STORAGE"


class PersistencyKeyValueStorageSubtypesEnum(Enum):
    PERSISTENCY_KEY_VALUE_STORAGE = "PERSISTENCY-KEY-VALUE-STORAGE"


class PersistencyRedundancyEnumSimple(Enum):
    """
    :cvar NONE: This value represents the requirement that redundancy
        measures are not applied on persistency storage level.
    :cvar REDUNDANT: This value represents the requirement that
        redundancy measures are applied on persistency storage level.
        The nature of the redundant persistent storage is not further
        qualified and subject to integrator decisions.
    :cvar REDUNDANT_PER_ELEMENT: This value represents the requirement
        that redundancy measures are applied on key-value level of a
        key-value storage or on file level of a file storage. The nature
        of the redundancy used on the persistent storage is not further
        qualified and subject to integrator decisions.
    """

    NONE = "NONE"
    REDUNDANT = "REDUNDANT"
    REDUNDANT_PER_ELEMENT = "REDUNDANT-PER-ELEMENT"


class PersistencyRedundancyHandlingScopeEnumSimple(Enum):
    """
    :cvar PERSISTENCY_REDUNDANCY_HANDLING_SCOPE_ELEMENT: The redundancy
        handling shall be applied on element level (key-value pair and
        file).
    :cvar PERSISTENCY_REDUNDANCY_HANDLING_SCOPE_STORAGE: The redundancy
        handling shall be applied on storage (key-value storage and file
        storage) level.
    """

    PERSISTENCY_REDUNDANCY_HANDLING_SCOPE_ELEMENT = "PERSISTENCY-REDUNDANCY-HANDLING-SCOPE-ELEMENT"
    PERSISTENCY_REDUNDANCY_HANDLING_SCOPE_STORAGE = "PERSISTENCY-REDUNDANCY-HANDLING-SCOPE-STORAGE"


class PgwideEnumSimple(Enum):
    """
    :cvar NO_PGWIDE: This indicates that the table shall be fit in the
        current text flow.
    :cvar PGWIDE: This indicates that the table may use the entire page
        width. This is in particular important in case of so called
        "side-head layouts" but also if the table is in a list or in a
        note.
    """

    NO_PGWIDE = "NO-PGWIDE"
    PGWIDE = "PGWIDE"


class PhmCheckpointSubtypesEnum(Enum):
    PHM_CHECKPOINT = "PHM-CHECKPOINT"


class PhmHealthChannelStatusSubtypesEnum(Enum):
    PHM_HEALTH_CHANNEL_STATUS = "PHM-HEALTH-CHANNEL-STATUS"


class PhmSupervisionSubtypesEnum(Enum):
    ALIVE_SUPERVISION = "ALIVE-SUPERVISION"
    DEADLINE_SUPERVISION = "DEADLINE-SUPERVISION"
    LOGICAL_SUPERVISION = "LOGICAL-SUPERVISION"
    NO_CHECKPOINT_SUPERVISION = "NO-CHECKPOINT-SUPERVISION"
    NO_SUPERVISION = "NO-SUPERVISION"
    PHM_SUPERVISION = "PHM-SUPERVISION"


class PhysicalChannelSubtypesEnum(Enum):
    ABSTRACT_CAN_PHYSICAL_CHANNEL = "ABSTRACT-CAN-PHYSICAL-CHANNEL"
    CAN_PHYSICAL_CHANNEL = "CAN-PHYSICAL-CHANNEL"
    ETHERNET_PHYSICAL_CHANNEL = "ETHERNET-PHYSICAL-CHANNEL"
    FLEXRAY_PHYSICAL_CHANNEL = "FLEXRAY-PHYSICAL-CHANNEL"
    LIN_PHYSICAL_CHANNEL = "LIN-PHYSICAL-CHANNEL"
    PHYSICAL_CHANNEL = "PHYSICAL-CHANNEL"
    TTCAN_PHYSICAL_CHANNEL = "TTCAN-PHYSICAL-CHANNEL"
    USER_DEFINED_PHYSICAL_CHANNEL = "USER-DEFINED-PHYSICAL-CHANNEL"


class PhysicalDimensionSubtypesEnum(Enum):
    PHYSICAL_DIMENSION = "PHYSICAL-DIMENSION"


class PlatformHealthManagementContributionSubtypesEnum(Enum):
    PLATFORM_HEALTH_MANAGEMENT_CONTRIBUTION = "PLATFORM-HEALTH-MANAGEMENT-CONTRIBUTION"


class PlatformModuleEthernetEndpointConfigurationSubtypesEnum(Enum):
    PLATFORM_MODULE_ETHERNET_ENDPOINT_CONFIGURATION = (
        "PLATFORM-MODULE-ETHERNET-ENDPOINT-CONFIGURATION"
    )


class PncGatewayTypeEnumSimple(Enum):
    """
    :cvar ACTIVE: The active PncGateway functionality shall be performed
    :cvar NONE: No PncGateway functionality shall be performed
    :cvar PASSIVE: The passive PncGateway functionality shall be
        performed
    """

    ACTIVE = "ACTIVE"
    NONE = "NONE"
    PASSIVE = "PASSIVE"


class PncMappingIdentSubtypesEnum(Enum):
    PNC_MAPPING_IDENT = "PNC-MAPPING-IDENT"


class PortGroupSubtypesEnum(Enum):
    PORT_GROUP = "PORT-GROUP"


class PortInterfaceSubtypesEnum(Enum):
    ABSTRACT_RAW_DATA_STREAM_INTERFACE = "ABSTRACT-RAW-DATA-STREAM-INTERFACE"
    ABSTRACT_SYNCHRONIZED_TIME_BASE_INTERFACE = "ABSTRACT-SYNCHRONIZED-TIME-BASE-INTERFACE"
    APPLICATION_INTERFACE = "APPLICATION-INTERFACE"
    CLIENT_SERVER_INTERFACE = "CLIENT-SERVER-INTERFACE"
    CRYPTO_CERTIFICATE_INTERFACE = "CRYPTO-CERTIFICATE-INTERFACE"
    CRYPTO_INTERFACE = "CRYPTO-INTERFACE"
    CRYPTO_KEY_SLOT_INTERFACE = "CRYPTO-KEY-SLOT-INTERFACE"
    CRYPTO_PROVIDER_INTERFACE = "CRYPTO-PROVIDER-INTERFACE"
    CRYPTO_TRUST_MASTER_INTERFACE = "CRYPTO-TRUST-MASTER-INTERFACE"
    DATA_INTERFACE = "DATA-INTERFACE"
    DIAGNOSTIC_ABSTRACT_DATA_IDENTIFIER_INTERFACE = "DIAGNOSTIC-ABSTRACT-DATA-IDENTIFIER-INTERFACE"
    DIAGNOSTIC_ABSTRACT_ROUTINE_INTERFACE = "DIAGNOSTIC-ABSTRACT-ROUTINE-INTERFACE"
    DIAGNOSTIC_AUTHENTICATION_INTERFACE = "DIAGNOSTIC-AUTHENTICATION-INTERFACE"
    DIAGNOSTIC_COM_CONTROL_INTERFACE = "DIAGNOSTIC-COM-CONTROL-INTERFACE"
    DIAGNOSTIC_CONDITION_INTERFACE = "DIAGNOSTIC-CONDITION-INTERFACE"
    DIAGNOSTIC_DATA_ELEMENT_INTERFACE = "DIAGNOSTIC-DATA-ELEMENT-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER_GENERIC_INTERFACE = "DIAGNOSTIC-DATA-IDENTIFIER-GENERIC-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER_INTERFACE = "DIAGNOSTIC-DATA-IDENTIFIER-INTERFACE"
    DIAGNOSTIC_DO_IP_ACTIVATION_LINE_INTERFACE = "DIAGNOSTIC-DO-IP-ACTIVATION-LINE-INTERFACE"
    DIAGNOSTIC_DO_IP_ENTITY_IDENTIFICATION_INTERFACE = (
        "DIAGNOSTIC-DO-IP-ENTITY-IDENTIFICATION-INTERFACE"
    )
    DIAGNOSTIC_DO_IP_GROUP_IDENTIFICATION_INTERFACE = (
        "DIAGNOSTIC-DO-IP-GROUP-IDENTIFICATION-INTERFACE"
    )
    DIAGNOSTIC_DO_IP_POWER_MODE_INTERFACE = "DIAGNOSTIC-DO-IP-POWER-MODE-INTERFACE"
    DIAGNOSTIC_DO_IP_TRIGGER_VEHICLE_ANNOUNCEMENT_INTERFACE = (
        "DIAGNOSTIC-DO-IP-TRIGGER-VEHICLE-ANNOUNCEMENT-INTERFACE"
    )
    DIAGNOSTIC_DOWNLOAD_INTERFACE = "DIAGNOSTIC-DOWNLOAD-INTERFACE"
    DIAGNOSTIC_DTC_INFORMATION_INTERFACE = "DIAGNOSTIC-DTC-INFORMATION-INTERFACE"
    DIAGNOSTIC_ECU_RESET_INTERFACE = "DIAGNOSTIC-ECU-RESET-INTERFACE"
    DIAGNOSTIC_EVENT_INTERFACE = "DIAGNOSTIC-EVENT-INTERFACE"
    DIAGNOSTIC_EXTERNAL_AUTHENTICATION_INTERFACE = "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-INTERFACE"
    DIAGNOSTIC_GENERIC_UDS_INTERFACE = "DIAGNOSTIC-GENERIC-UDS-INTERFACE"
    DIAGNOSTIC_INDICATOR_INTERFACE = "DIAGNOSTIC-INDICATOR-INTERFACE"
    DIAGNOSTIC_MONITOR_INTERFACE = "DIAGNOSTIC-MONITOR-INTERFACE"
    DIAGNOSTIC_OPERATION_CYCLE_INTERFACE = "DIAGNOSTIC-OPERATION-CYCLE-INTERFACE"
    DIAGNOSTIC_PORT_INTERFACE = "DIAGNOSTIC-PORT-INTERFACE"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_INTERFACE = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-INTERFACE"
    DIAGNOSTIC_ROUTINE_GENERIC_INTERFACE = "DIAGNOSTIC-ROUTINE-GENERIC-INTERFACE"
    DIAGNOSTIC_ROUTINE_INTERFACE = "DIAGNOSTIC-ROUTINE-INTERFACE"
    DIAGNOSTIC_SECURITY_LEVEL_INTERFACE = "DIAGNOSTIC-SECURITY-LEVEL-INTERFACE"
    DIAGNOSTIC_SERVICE_VALIDATION_INTERFACE = "DIAGNOSTIC-SERVICE-VALIDATION-INTERFACE"
    DIAGNOSTIC_SOVD_AUTHORIZATION_INTERFACE = "DIAGNOSTIC-SOVD-AUTHORIZATION-INTERFACE"
    DIAGNOSTIC_SOVD_PORT_INTERFACE = "DIAGNOSTIC-SOVD-PORT-INTERFACE"
    DIAGNOSTIC_SOVD_PROXIMITY_CHALLENGE_INTERFACE = "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-INTERFACE"
    DIAGNOSTIC_UPLOAD_INTERFACE = "DIAGNOSTIC-UPLOAD-INTERFACE"
    FIREWALL_STATE_SWITCH_INTERFACE = "FIREWALL-STATE-SWITCH-INTERFACE"
    LOG_AND_TRACE_INTERFACE = "LOG-AND-TRACE-INTERFACE"
    MODE_SWITCH_INTERFACE = "MODE-SWITCH-INTERFACE"
    NV_DATA_INTERFACE = "NV-DATA-INTERFACE"
    PARAMETER_INTERFACE = "PARAMETER-INTERFACE"
    PERSISTENCY_FILE_STORAGE_INTERFACE = "PERSISTENCY-FILE-STORAGE-INTERFACE"
    PERSISTENCY_INTERFACE = "PERSISTENCY-INTERFACE"
    PERSISTENCY_KEY_VALUE_STORAGE_INTERFACE = "PERSISTENCY-KEY-VALUE-STORAGE-INTERFACE"
    PHM_ABSTRACT_RECOVERY_NOTIFICATION_INTERFACE = "PHM-ABSTRACT-RECOVERY-NOTIFICATION-INTERFACE"
    PHM_HEALTH_CHANNEL_INTERFACE = "PHM-HEALTH-CHANNEL-INTERFACE"
    PHM_HEALTH_CHANNEL_RECOVERY_NOTIFICATION_INTERFACE = (
        "PHM-HEALTH-CHANNEL-RECOVERY-NOTIFICATION-INTERFACE"
    )
    PHM_RECOVERY_ACTION_INTERFACE = "PHM-RECOVERY-ACTION-INTERFACE"
    PHM_SUPERVISED_ENTITY_INTERFACE = "PHM-SUPERVISED-ENTITY-INTERFACE"
    PHM_SUPERVISION_RECOVERY_NOTIFICATION_INTERFACE = (
        "PHM-SUPERVISION-RECOVERY-NOTIFICATION-INTERFACE"
    )
    PLATFORM_HEALTH_MANAGEMENT_INTERFACE = "PLATFORM-HEALTH-MANAGEMENT-INTERFACE"
    PORT_INTERFACE = "PORT-INTERFACE"
    RAW_DATA_STREAM_CLIENT_INTERFACE = "RAW-DATA-STREAM-CLIENT-INTERFACE"
    RAW_DATA_STREAM_SERVER_INTERFACE = "RAW-DATA-STREAM-SERVER-INTERFACE"
    SECURITY_EVENT_REPORT_INTERFACE = "SECURITY-EVENT-REPORT-INTERFACE"
    SENDER_RECEIVER_INTERFACE = "SENDER-RECEIVER-INTERFACE"
    SERVICE_INTERFACE = "SERVICE-INTERFACE"
    STATE_MANAGEMEN_PHM_ERROR_INTERFACE = "STATE-MANAGEMEN-PHM-ERROR-INTERFACE"
    STATE_MANAGEMENT_DIAG_TRIGGER_INTERFACE = "STATE-MANAGEMENT-DIAG-TRIGGER-INTERFACE"
    STATE_MANAGEMENT_EM_ERROR_INTERFACE = "STATE-MANAGEMENT-EM-ERROR-INTERFACE"
    STATE_MANAGEMENT_ERROR_INTERFACE = "STATE-MANAGEMENT-ERROR-INTERFACE"
    STATE_MANAGEMENT_FUNCTION_GROUP_SWITCH_NOTIFICATION_INTERFACE = (
        "STATE-MANAGEMENT-FUNCTION-GROUP-SWITCH-NOTIFICATION-INTERFACE"
    )
    STATE_MANAGEMENT_NOTIFICATION_INTERFACE = "STATE-MANAGEMENT-NOTIFICATION-INTERFACE"
    STATE_MANAGEMENT_PORT_INTERFACE = "STATE-MANAGEMENT-PORT-INTERFACE"
    STATE_MANAGEMENT_REQUEST_INTERFACE = "STATE-MANAGEMENT-REQUEST-INTERFACE"
    STATE_MANAGEMENT_TRIGGER_INTERFACE = "STATE-MANAGEMENT-TRIGGER-INTERFACE"
    SYNCHRONIZED_TIME_BASE_CONSUMER_INTERFACE = "SYNCHRONIZED-TIME-BASE-CONSUMER-INTERFACE"
    SYNCHRONIZED_TIME_BASE_PROVIDER_INTERFACE = "SYNCHRONIZED-TIME-BASE-PROVIDER-INTERFACE"
    TRIGGER_INTERFACE = "TRIGGER-INTERFACE"


class PortInterfaceMappingSubtypesEnum(Enum):
    CLIENT_SERVER_INTERFACE_MAPPING = "CLIENT-SERVER-INTERFACE-MAPPING"
    MODE_INTERFACE_MAPPING = "MODE-INTERFACE-MAPPING"
    PORT_INTERFACE_MAPPING = "PORT-INTERFACE-MAPPING"
    SERVICE_INTERFACE_MAPPING = "SERVICE-INTERFACE-MAPPING"
    TRIGGER_INTERFACE_MAPPING = "TRIGGER-INTERFACE-MAPPING"
    VARIABLE_AND_PARAMETER_INTERFACE_MAPPING = "VARIABLE-AND-PARAMETER-INTERFACE-MAPPING"


class PortPrototypeSubtypesEnum(Enum):
    ABSTRACT_PROVIDED_PORT_PROTOTYPE = "ABSTRACT-PROVIDED-PORT-PROTOTYPE"
    ABSTRACT_REQUIRED_PORT_PROTOTYPE = "ABSTRACT-REQUIRED-PORT-PROTOTYPE"
    P_PORT_PROTOTYPE = "P-PORT-PROTOTYPE"
    PORT_PROTOTYPE = "PORT-PROTOTYPE"
    PR_PORT_PROTOTYPE = "PR-PORT-PROTOTYPE"
    R_PORT_PROTOTYPE = "R-PORT-PROTOTYPE"


class PortPrototypeBlueprintSubtypesEnum(Enum):
    PORT_PROTOTYPE_BLUEPRINT = "PORT-PROTOTYPE-BLUEPRINT"


@dataclass(slots=True, kw_only=True)
class PositiveInteger:
    """This is a positive integer which can be denoted in decimal, binary, octal
    and hexadecimal.

    The value is between 0 and 4294967295.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "POSITIVE-INTEGER"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"0|[\+]?[1-9][0-9]*|0[xX][0-9a-fA-F]+|0[bB][0-1]+|0[0-7]+",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PositiveUnlimitedInteger:
    """
    This is a positive unlimited integer which can be denoted in decimal, binary,
    octal and hexadecimal.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "POSITIVE-UNLIMITED-INTEGER"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"0|[\+]?[1-9][0-9]*|0[xX][0-9a-fA-F]+|0[bB][0-1]+|0[0-7]+",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class PostBuildVariantCriterionSubtypesEnum(Enum):
    POST_BUILD_VARIANT_CRITERION = "POST-BUILD-VARIANT-CRITERION"


class PostBuildVariantCriterionValueSetSubtypesEnum(Enum):
    POST_BUILD_VARIANT_CRITERION_VALUE_SET = "POST-BUILD-VARIANT-CRITERION-VALUE-SET"


class PredefinedVariantSubtypesEnum(Enum):
    PREDEFINED_VARIANT = "PREDEFINED-VARIANT"


class PrimitiveAttributeTailoringSubtypesEnum(Enum):
    PRIMITIVE_ATTRIBUTE_TAILORING = "PRIMITIVE-ATTRIBUTE-TAILORING"


@dataclass(slots=True, kw_only=True)
class PrimitiveIdentifier:
    """This meta-class has the ability to contain a string.

    Please note that this meta-class has only been introduced to fix an
    issue with the generation of attributes on primitives in context
    with [TR_APRXML_00024].

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PRIMITIVE-IDENTIFIER"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class ProcessSubtypesEnum(Enum):
    PROCESS = "PROCESS"


class ProcessDesignSubtypesEnum(Enum):
    PROCESS_DESIGN = "PROCESS-DESIGN"


class ProcessDesignToMachineDesignMappingSubtypesEnum(Enum):
    PROCESS_DESIGN_TO_MACHINE_DESIGN_MAPPING = "PROCESS-DESIGN-TO-MACHINE-DESIGN-MAPPING"


class ProcessExecutionErrorSubtypesEnum(Enum):
    PROCESS_EXECUTION_ERROR = "PROCESS-EXECUTION-ERROR"


class ProcessingKindEnumSimple(Enum):
    """
    :cvar FILTERED: Indicates that a raw signal has been manipulated by
        some application software components by using filters.
    :cvar NONE: Indicates that none of the other option apply.
    :cvar RAW: Specifies that a signal is taken directly from the basic
        software modules, i.e. from the ECU abstraction layer. It
        indicates to a developer that the control algorithm in the
        software has to provide filters.
    """

    FILTERED = "FILTERED"
    NONE = "NONE"
    RAW = "RAW"


class ProcessorCoreSubtypesEnum(Enum):
    PROCESSOR_CORE = "PROCESSOR-CORE"


class ProgramminglanguageEnumSimple(Enum):
    """
    :cvar C: C language
    :cvar CPP: C++ language
    :cvar JAVA: Java language
    """

    C = "C"
    CPP = "CPP"
    JAVA = "JAVA"


class ProvidedApServiceInstanceSubtypesEnum(Enum):
    DDS_PROVIDED_SERVICE_INSTANCE = "DDS-PROVIDED-SERVICE-INSTANCE"
    PROVIDED_AP_SERVICE_INSTANCE = "PROVIDED-AP-SERVICE-INSTANCE"
    PROVIDED_SOMEIP_SERVICE_INSTANCE = "PROVIDED-SOMEIP-SERVICE-INSTANCE"
    PROVIDED_USER_DEFINED_SERVICE_INSTANCE = "PROVIDED-USER-DEFINED-SERVICE-INSTANCE"


class ProvidedServiceInstanceSubtypesEnum(Enum):
    PROVIDED_SERVICE_INSTANCE = "PROVIDED-SERVICE-INSTANCE"


class PulseTestEnumSimple(Enum):
    """
    :cvar DISABLE: Disables the pulse test
    :cvar ENABLE: Enables the pulse test
    """

    DISABLE = "DISABLE"
    ENABLE = "ENABLE"


class RPortPrototypeSubtypesEnum(Enum):
    R_PORT_PROTOTYPE = "R-PORT-PROTOTYPE"


class RamBlockStatusControlEnumSimple(Enum):
    """
    :cvar API: The ramBlock status is controlled via service interface
        by usage of the SetRamBlockStatus operation.
    :cvar NV_RAM_MANAGER: The ramBlock status is controlled exclusively
        by the Nv Ram Manager.
    """

    API = "API"
    NV_RAM_MANAGER = "NV-RAM-MANAGER"


class RawDataStreamClientInterfaceSubtypesEnum(Enum):
    RAW_DATA_STREAM_CLIENT_INTERFACE = "RAW-DATA-STREAM-CLIENT-INTERFACE"


class RawDataStreamDeploymentSubtypesEnum(Enum):
    RAW_DATA_STREAM_DEPLOYMENT = "RAW-DATA-STREAM-DEPLOYMENT"


class RawDataStreamGrantDesignSubtypesEnum(Enum):
    RAW_DATA_STREAM_GRANT_DESIGN = "RAW-DATA-STREAM-GRANT-DESIGN"


class ReceiverIntentEnumSimple(Enum):
    """
    :cvar WILL_RECEIVE: The receiver will receive the event or field
        notifier.
    :cvar WONT_RECEIVE: The receiver won't receive the event or field
        notifier.
    """

    WILL_RECEIVE = "WILL-RECEIVE"
    WONT_RECEIVE = "WONT-RECEIVE"


@dataclass(slots=True, kw_only=True)
class RecordLayoutIteratorPoint:
    """This meta-class denotes a start / endpoint for the iteration of a
    SwRecordLayoutGroup.

    It can be an integer or one of the keywords MAX-TEXT-SIZE|ARRAY-
    SIZE. Note that negative numbers are counted backwards. Therefore
    e.g. -1 refers to the last value.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RECORD-LAYOUT-ITERATOR-POINT"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"-?([0-9]+|MAX-TEXT-SIZE|ARRAY-SIZE)",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class RecoveryNotificationSubtypesEnum(Enum):
    RECOVERY_NOTIFICATION = "RECOVERY-NOTIFICATION"


class ReentrancyLevelEnumSimple(Enum):
    """
    :cvar MULTICORE_REENTRANT: Unlimited concurrent execution of this
        entity is possible, including preemption and parallel execution
        on multi core systems.
    :cvar NON_REENTRANT: Concurrent execution of this entity is not
        possible.
    :cvar SINGLE_CORE_REENTRANT: Pseudo-concurrent execution (i.e.
        preemption) of this entity is possible on single core systems.
    """

    MULTICORE_REENTRANT = "MULTICORE-REENTRANT"
    NON_REENTRANT = "NON-REENTRANT"
    SINGLE_CORE_REENTRANT = "SINGLE-CORE-REENTRANT"


@dataclass(slots=True, kw_only=True)
class Ref:
    """This primitive denotes a name based reference.

    For detailed syntax see the xsd.pattern.
    * first slash (relative or absolute reference) [optional]
    * Identifier  [required]
    * a sequence of slashes and Identifiers [optional]
    This primitive is used by the meta-model tools to create the references.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar base: This attribute reflects the base to be used for this
        reference.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar index: This attribute supports the use case to point on
        specific elements in an array. This is in particular required if
        arrays are used to implement particular data objects. The
        counting of array indices starts with the value 0, i.e. the
        index of the first array element is 0.
    """

    class Meta:
        name = "REF"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"/?[a-zA-Z][a-zA-Z0-9_]{0,127}(/[a-zA-Z][a-zA-Z0-9_]{0,127})*",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    base: str | None = field(
        default=None,
        metadata={
            "name": "BASE",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z][a-zA-Z0-9_]*",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    index: str | None = field(
        default=None,
        metadata={
            "name": "INDEX",
            "type": "Attribute",
            "pattern": r"0|[\+]?[1-9][0-9]*|0[xX][0-9a-fA-F]+|0[bB][0-1]+|0[0-7]+",
        },
    )


class ReferenceTailoringSubtypesEnum(Enum):
    REFERENCE_TAILORING = "REFERENCE-TAILORING"


class ReferrableSubtypesEnum(Enum):
    ABSTRACT_ACCESS_POINT = "ABSTRACT-ACCESS-POINT"
    ABSTRACT_CAN_CLUSTER = "ABSTRACT-CAN-CLUSTER"
    ABSTRACT_CAN_COMMUNICATION_CONNECTOR = "ABSTRACT-CAN-COMMUNICATION-CONNECTOR"
    ABSTRACT_CAN_COMMUNICATION_CONTROLLER = "ABSTRACT-CAN-COMMUNICATION-CONTROLLER"
    ABSTRACT_CAN_PHYSICAL_CHANNEL = "ABSTRACT-CAN-PHYSICAL-CHANNEL"
    ABSTRACT_CLASS_TAILORING = "ABSTRACT-CLASS-TAILORING"
    ABSTRACT_DO_IP_LOGIC_ADDRESS_PROPS = "ABSTRACT-DO-IP-LOGIC-ADDRESS-PROPS"
    ABSTRACT_ETHERNET_FRAME = "ABSTRACT-ETHERNET-FRAME"
    ABSTRACT_EVENT = "ABSTRACT-EVENT"
    ABSTRACT_EXECUTION_CONTEXT = "ABSTRACT-EXECUTION-CONTEXT"
    ABSTRACT_IAM_REMOTE_SUBJECT = "ABSTRACT-IAM-REMOTE-SUBJECT"
    ABSTRACT_IMPLEMENTATION_DATA_TYPE = "ABSTRACT-IMPLEMENTATION-DATA-TYPE"
    ABSTRACT_IMPLEMENTATION_DATA_TYPE_ELEMENT = "ABSTRACT-IMPLEMENTATION-DATA-TYPE-ELEMENT"
    ABSTRACT_PROVIDED_PORT_PROTOTYPE = "ABSTRACT-PROVIDED-PORT-PROTOTYPE"
    ABSTRACT_RAW_DATA_STREAM_INTERFACE = "ABSTRACT-RAW-DATA-STREAM-INTERFACE"
    ABSTRACT_REQUIRED_PORT_PROTOTYPE = "ABSTRACT-REQUIRED-PORT-PROTOTYPE"
    ABSTRACT_SECURITY_EVENT_FILTER = "ABSTRACT-SECURITY-EVENT-FILTER"
    ABSTRACT_SECURITY_IDSM_INSTANCE_FILTER = "ABSTRACT-SECURITY-IDSM-INSTANCE-FILTER"
    ABSTRACT_SERVICE_INSTANCE = "ABSTRACT-SERVICE-INSTANCE"
    ABSTRACT_SIGNAL_BASED_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "ABSTRACT-SIGNAL-BASED-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    ABSTRACT_SYNCHRONIZED_TIME_BASE_INTERFACE = "ABSTRACT-SYNCHRONIZED-TIME-BASE-INTERFACE"
    ACL_OBJECT_SET = "ACL-OBJECT-SET"
    ACL_OPERATION = "ACL-OPERATION"
    ACL_PERMISSION = "ACL-PERMISSION"
    ACL_ROLE = "ACL-ROLE"
    ADAPTIVE_APPLICATION_SW_COMPONENT_TYPE = "ADAPTIVE-APPLICATION-SW-COMPONENT-TYPE"
    ADAPTIVE_FIREWALL_MODULE_INSTANTIATION = "ADAPTIVE-FIREWALL-MODULE-INSTANTIATION"
    ADAPTIVE_FIREWALL_TO_PORT_PROTOTYPE_MAPPING = "ADAPTIVE-FIREWALL-TO-PORT-PROTOTYPE-MAPPING"
    ADAPTIVE_MODULE_INSTANTIATION = "ADAPTIVE-MODULE-INSTANTIATION"
    ADAPTIVE_PLATFORM_SERVICE_INSTANCE = "ADAPTIVE-PLATFORM-SERVICE-INSTANCE"
    ADAPTIVE_SWC_INTERNAL_BEHAVIOR = "ADAPTIVE-SWC-INTERNAL-BEHAVIOR"
    AGE_CONSTRAINT = "AGE-CONSTRAINT"
    AGGREGATION_TAILORING = "AGGREGATION-TAILORING"
    ALIAS_NAME_SET = "ALIAS-NAME-SET"
    ALIVE_SUPERVISION = "ALIVE-SUPERVISION"
    ALLOCATOR = "ALLOCATOR"
    ANALYZED_EXECUTION_TIME = "ANALYZED-EXECUTION-TIME"
    AP_APPLICATION_ENDPOINT = "AP-APPLICATION-ENDPOINT"
    AP_APPLICATION_ERROR = "AP-APPLICATION-ERROR"
    AP_APPLICATION_ERROR_DOMAIN = "AP-APPLICATION-ERROR-DOMAIN"
    AP_APPLICATION_ERROR_SET = "AP-APPLICATION-ERROR-SET"
    AP_SOMEIP_TRANSFORMATION_PROPS = "AP-SOMEIP-TRANSFORMATION-PROPS"
    APP_OS_TASK_PROXY_TO_ECU_TASK_PROXY_MAPPING = "APP-OS-TASK-PROXY-TO-ECU-TASK-PROXY-MAPPING"
    APPLICATION_ARRAY_DATA_TYPE = "APPLICATION-ARRAY-DATA-TYPE"
    APPLICATION_ARRAY_ELEMENT = "APPLICATION-ARRAY-ELEMENT"
    APPLICATION_ASSOC_MAP_DATA_TYPE = "APPLICATION-ASSOC-MAP-DATA-TYPE"
    APPLICATION_ASSOC_MAP_ELEMENT = "APPLICATION-ASSOC-MAP-ELEMENT"
    APPLICATION_COMPOSITE_DATA_TYPE = "APPLICATION-COMPOSITE-DATA-TYPE"
    APPLICATION_COMPOSITE_ELEMENT_DATA_PROTOTYPE = "APPLICATION-COMPOSITE-ELEMENT-DATA-PROTOTYPE"
    APPLICATION_DATA_TYPE = "APPLICATION-DATA-TYPE"
    APPLICATION_DEFERRED_DATA_TYPE = "APPLICATION-DEFERRED-DATA-TYPE"
    APPLICATION_ENDPOINT = "APPLICATION-ENDPOINT"
    APPLICATION_ERROR = "APPLICATION-ERROR"
    APPLICATION_INTERFACE = "APPLICATION-INTERFACE"
    APPLICATION_PARTITION = "APPLICATION-PARTITION"
    APPLICATION_PARTITION_TO_ECU_PARTITION_MAPPING = (
        "APPLICATION-PARTITION-TO-ECU-PARTITION-MAPPING"
    )
    APPLICATION_PRIMITIVE_DATA_TYPE = "APPLICATION-PRIMITIVE-DATA-TYPE"
    APPLICATION_RECORD_DATA_TYPE = "APPLICATION-RECORD-DATA-TYPE"
    APPLICATION_RECORD_ELEMENT = "APPLICATION-RECORD-ELEMENT"
    APPLICATION_SW_COMPONENT_TYPE = "APPLICATION-SW-COMPONENT-TYPE"
    AR_ELEMENT = "AR-ELEMENT"
    AR_PACKAGE = "AR-PACKAGE"
    ARBITRARY_EVENT_TRIGGERING = "ARBITRARY-EVENT-TRIGGERING"
    ARGUMENT_DATA_PROTOTYPE = "ARGUMENT-DATA-PROTOTYPE"
    ARTIFACT_CHECKSUM = "ARTIFACT-CHECKSUM"
    ARTIFACT_CHECKSUM_TO_CRYPTO_PROVIDER_MAPPING = "ARTIFACT-CHECKSUM-TO-CRYPTO-PROVIDER-MAPPING"
    ARTIFACT_LOCATOR = "ARTIFACT-LOCATOR"
    ASSEMBLY_SW_CONNECTOR = "ASSEMBLY-SW-CONNECTOR"
    ASYNCHRONOUS_SERVER_CALL_POINT = "ASYNCHRONOUS-SERVER-CALL-POINT"
    ASYNCHRONOUS_SERVER_CALL_RESULT_POINT = "ASYNCHRONOUS-SERVER-CALL-RESULT-POINT"
    ASYNCHRONOUS_SERVER_CALL_RETURNS_EVENT = "ASYNCHRONOUS-SERVER-CALL-RETURNS-EVENT"
    ATOMIC_SW_COMPONENT_TYPE = "ATOMIC-SW-COMPONENT-TYPE"
    ATP_BLUEPRINT = "ATP-BLUEPRINT"
    ATP_BLUEPRINTABLE = "ATP-BLUEPRINTABLE"
    ATP_CLASSIFIER = "ATP-CLASSIFIER"
    ATP_DEFINITION = "ATP-DEFINITION"
    ATP_FEATURE = "ATP-FEATURE"
    ATP_PROTOTYPE = "ATP-PROTOTYPE"
    ATP_STRUCTURE_ELEMENT = "ATP-STRUCTURE-ELEMENT"
    ATP_TYPE = "ATP-TYPE"
    ATTRIBUTE_TAILORING = "ATTRIBUTE-TAILORING"
    AUTOSAR_DATA_PROTOTYPE = "AUTOSAR-DATA-PROTOTYPE"
    AUTOSAR_DATA_TYPE = "AUTOSAR-DATA-TYPE"
    AUTOSAR_OPERATION_ARGUMENT_INSTANCE = "AUTOSAR-OPERATION-ARGUMENT-INSTANCE"
    AUTOSAR_VARIABLE_INSTANCE = "AUTOSAR-VARIABLE-INSTANCE"
    BACKGROUND_EVENT = "BACKGROUND-EVENT"
    BASE_TYPE = "BASE-TYPE"
    BINARY_MANIFEST_ADDRESSABLE_OBJECT = "BINARY-MANIFEST-ADDRESSABLE-OBJECT"
    BINARY_MANIFEST_ITEM = "BINARY-MANIFEST-ITEM"
    BINARY_MANIFEST_ITEM_DEFINITION = "BINARY-MANIFEST-ITEM-DEFINITION"
    BINARY_MANIFEST_META_DATA_FIELD = "BINARY-MANIFEST-META-DATA-FIELD"
    BINARY_MANIFEST_PROVIDE_RESOURCE = "BINARY-MANIFEST-PROVIDE-RESOURCE"
    BINARY_MANIFEST_REQUIRE_RESOURCE = "BINARY-MANIFEST-REQUIRE-RESOURCE"
    BINARY_MANIFEST_RESOURCE = "BINARY-MANIFEST-RESOURCE"
    BINARY_MANIFEST_RESOURCE_DEFINITION = "BINARY-MANIFEST-RESOURCE-DEFINITION"
    BLOCK_STATE = "BLOCK-STATE"
    BLUEPRINT_MAPPING_SET = "BLUEPRINT-MAPPING-SET"
    BSW_ASYNCHRONOUS_SERVER_CALL_POINT = "BSW-ASYNCHRONOUS-SERVER-CALL-POINT"
    BSW_ASYNCHRONOUS_SERVER_CALL_RESULT_POINT = "BSW-ASYNCHRONOUS-SERVER-CALL-RESULT-POINT"
    BSW_ASYNCHRONOUS_SERVER_CALL_RETURNS_EVENT = "BSW-ASYNCHRONOUS-SERVER-CALL-RETURNS-EVENT"
    BSW_BACKGROUND_EVENT = "BSW-BACKGROUND-EVENT"
    BSW_CALLED_ENTITY = "BSW-CALLED-ENTITY"
    BSW_COMPOSITION_TIMING = "BSW-COMPOSITION-TIMING"
    BSW_DATA_RECEIVED_EVENT = "BSW-DATA-RECEIVED-EVENT"
    BSW_DEBUG_INFO = "BSW-DEBUG-INFO"
    BSW_DIRECT_CALL_POINT = "BSW-DIRECT-CALL-POINT"
    BSW_DISTINGUISHED_PARTITION = "BSW-DISTINGUISHED-PARTITION"
    BSW_ENTRY_RELATIONSHIP_SET = "BSW-ENTRY-RELATIONSHIP-SET"
    BSW_EVENT = "BSW-EVENT"
    BSW_EXTERNAL_TRIGGER_OCCURRED_EVENT = "BSW-EXTERNAL-TRIGGER-OCCURRED-EVENT"
    BSW_IMPLEMENTATION = "BSW-IMPLEMENTATION"
    BSW_INTERNAL_BEHAVIOR = "BSW-INTERNAL-BEHAVIOR"
    BSW_INTERNAL_TRIGGER_OCCURRED_EVENT = "BSW-INTERNAL-TRIGGER-OCCURRED-EVENT"
    BSW_INTERNAL_TRIGGERING_POINT = "BSW-INTERNAL-TRIGGERING-POINT"
    BSW_INTERRUPT_ENTITY = "BSW-INTERRUPT-ENTITY"
    BSW_MGR_NEEDS = "BSW-MGR-NEEDS"
    BSW_MODE_MANAGER_ERROR_EVENT = "BSW-MODE-MANAGER-ERROR-EVENT"
    BSW_MODE_SWITCH_EVENT = "BSW-MODE-SWITCH-EVENT"
    BSW_MODE_SWITCHED_ACK_EVENT = "BSW-MODE-SWITCHED-ACK-EVENT"
    BSW_MODULE_CALL_POINT = "BSW-MODULE-CALL-POINT"
    BSW_MODULE_CLIENT_SERVER_ENTRY = "BSW-MODULE-CLIENT-SERVER-ENTRY"
    BSW_MODULE_DEPENDENCY = "BSW-MODULE-DEPENDENCY"
    BSW_MODULE_DESCRIPTION = "BSW-MODULE-DESCRIPTION"
    BSW_MODULE_ENTITY = "BSW-MODULE-ENTITY"
    BSW_MODULE_ENTRY = "BSW-MODULE-ENTRY"
    BSW_MODULE_TIMING = "BSW-MODULE-TIMING"
    BSW_OPERATION_INVOKED_EVENT = "BSW-OPERATION-INVOKED-EVENT"
    BSW_OS_TASK_EXECUTION_EVENT = "BSW-OS-TASK-EXECUTION-EVENT"
    BSW_SCHEDULABLE_ENTITY = "BSW-SCHEDULABLE-ENTITY"
    BSW_SCHEDULE_EVENT = "BSW-SCHEDULE-EVENT"
    BSW_SCHEDULER_NAME_PREFIX = "BSW-SCHEDULER-NAME-PREFIX"
    BSW_SERVICE_DEPENDENCY_IDENT = "BSW-SERVICE-DEPENDENCY-IDENT"
    BSW_SYNCHRONOUS_SERVER_CALL_POINT = "BSW-SYNCHRONOUS-SERVER-CALL-POINT"
    BSW_TIMING_EVENT = "BSW-TIMING-EVENT"
    BSW_VARIABLE_ACCESS = "BSW-VARIABLE-ACCESS"
    BUILD_ACTION = "BUILD-ACTION"
    BUILD_ACTION_ENTITY = "BUILD-ACTION-ENTITY"
    BUILD_ACTION_ENVIRONMENT = "BUILD-ACTION-ENVIRONMENT"
    BUILD_ACTION_MANIFEST = "BUILD-ACTION-MANIFEST"
    BULK_NV_DATA_DESCRIPTOR = "BULK-NV-DATA-DESCRIPTOR"
    BURST_PATTERN_EVENT_TRIGGERING = "BURST-PATTERN-EVENT-TRIGGERING"
    BUS_MIRROR_CHANNEL_MAPPING = "BUS-MIRROR-CHANNEL-MAPPING"
    BUS_MIRROR_CHANNEL_MAPPING_CAN = "BUS-MIRROR-CHANNEL-MAPPING-CAN"
    BUS_MIRROR_CHANNEL_MAPPING_FLEXRAY = "BUS-MIRROR-CHANNEL-MAPPING-FLEXRAY"
    BUS_MIRROR_CHANNEL_MAPPING_IP = "BUS-MIRROR-CHANNEL-MAPPING-IP"
    BUS_MIRROR_CHANNEL_MAPPING_USER_DEFINED = "BUS-MIRROR-CHANNEL-MAPPING-USER-DEFINED"
    CALIBRATION_PARAMETER_VALUE_SET = "CALIBRATION-PARAMETER-VALUE-SET"
    CAN_CLUSTER = "CAN-CLUSTER"
    CAN_COMMUNICATION_CONNECTOR = "CAN-COMMUNICATION-CONNECTOR"
    CAN_COMMUNICATION_CONTROLLER = "CAN-COMMUNICATION-CONTROLLER"
    CAN_FRAME = "CAN-FRAME"
    CAN_FRAME_TRIGGERING = "CAN-FRAME-TRIGGERING"
    CAN_NM_CLUSTER = "CAN-NM-CLUSTER"
    CAN_NM_NODE = "CAN-NM-NODE"
    CAN_PHYSICAL_CHANNEL = "CAN-PHYSICAL-CHANNEL"
    CAN_TP_ADDRESS = "CAN-TP-ADDRESS"
    CAN_TP_CHANNEL = "CAN-TP-CHANNEL"
    CAN_TP_CONFIG = "CAN-TP-CONFIG"
    CAN_TP_NODE = "CAN-TP-NODE"
    CAN_XL_PROPS = "CAN-XL-PROPS"
    CAPTION = "CAPTION"
    CHAPTER = "CHAPTER"
    CHECKPOINT_TRANSITION = "CHECKPOINT-TRANSITION"
    CLASS_CONTENT_CONDITIONAL = "CLASS-CONTENT-CONDITIONAL"
    CLIENT_ID_DEFINITION = "CLIENT-ID-DEFINITION"
    CLIENT_ID_DEFINITION_SET = "CLIENT-ID-DEFINITION-SET"
    CLIENT_SERVER_INTERFACE = "CLIENT-SERVER-INTERFACE"
    CLIENT_SERVER_INTERFACE_MAPPING = "CLIENT-SERVER-INTERFACE-MAPPING"
    CLIENT_SERVER_INTERFACE_TO_BSW_MODULE_ENTRY_BLUEPRINT_MAPPING = (
        "CLIENT-SERVER-INTERFACE-TO-BSW-MODULE-ENTRY-BLUEPRINT-MAPPING"
    )
    CLIENT_SERVER_OPERATION = "CLIENT-SERVER-OPERATION"
    CODE = "CODE"
    COLLECTABLE_ELEMENT = "COLLECTABLE-ELEMENT"
    COLLECTION = "COLLECTION"
    COM_CERTIFICATE_TO_CRYPTO_CERTIFICATE_MAPPING = "COM-CERTIFICATE-TO-CRYPTO-CERTIFICATE-MAPPING"
    COM_EVENT_GRANT = "COM-EVENT-GRANT"
    COM_EVENT_GRANT_DESIGN = "COM-EVENT-GRANT-DESIGN"
    COM_FIELD_GRANT = "COM-FIELD-GRANT"
    COM_FIELD_GRANT_DESIGN = "COM-FIELD-GRANT-DESIGN"
    COM_FIND_SERVICE_GRANT = "COM-FIND-SERVICE-GRANT"
    COM_FIND_SERVICE_GRANT_DESIGN = "COM-FIND-SERVICE-GRANT-DESIGN"
    COM_GRANT = "COM-GRANT"
    COM_GRANT_DESIGN = "COM-GRANT-DESIGN"
    COM_KEY_TO_CRYPTO_KEY_SLOT_MAPPING = "COM-KEY-TO-CRYPTO-KEY-SLOT-MAPPING"
    COM_MANAGEMENT_MAPPING = "COM-MANAGEMENT-MAPPING"
    COM_METHOD_GRANT = "COM-METHOD-GRANT"
    COM_METHOD_GRANT_DESIGN = "COM-METHOD-GRANT-DESIGN"
    COM_MGR_USER_NEEDS = "COM-MGR-USER-NEEDS"
    COM_OFFER_SERVICE_GRANT = "COM-OFFER-SERVICE-GRANT"
    COM_OFFER_SERVICE_GRANT_DESIGN = "COM-OFFER-SERVICE-GRANT-DESIGN"
    COM_SEC_OC_TO_CRYPTO_KEY_SLOT_MAPPING = "COM-SEC-OC-TO-CRYPTO-KEY-SLOT-MAPPING"
    COM_TRIGGER_GRANT_DESIGN = "COM-TRIGGER-GRANT-DESIGN"
    COMM_CONNECTOR_PORT = "COMM-CONNECTOR-PORT"
    COMMUNICATION_CLUSTER = "COMMUNICATION-CLUSTER"
    COMMUNICATION_CONNECTOR = "COMMUNICATION-CONNECTOR"
    COMMUNICATION_CONTROLLER = "COMMUNICATION-CONTROLLER"
    COMPILER = "COMPILER"
    COMPLEX_DEVICE_DRIVER_SW_COMPONENT_TYPE = "COMPLEX-DEVICE-DRIVER-SW-COMPONENT-TYPE"
    COMPOSITION_P_PORT_TO_EXECUTABLE_P_PORT_MAPPING = (
        "COMPOSITION-P-PORT-TO-EXECUTABLE-P-PORT-MAPPING"
    )
    COMPOSITION_PORT_TO_EXECUTABLE_PORT_MAPPING = "COMPOSITION-PORT-TO-EXECUTABLE-PORT-MAPPING"
    COMPOSITION_R_PORT_TO_EXECUTABLE_R_PORT_MAPPING = (
        "COMPOSITION-R-PORT-TO-EXECUTABLE-R-PORT-MAPPING"
    )
    COMPOSITION_SW_COMPONENT_TYPE = "COMPOSITION-SW-COMPONENT-TYPE"
    COMPU_METHOD = "COMPU-METHOD"
    CONCRETE_CLASS_TAILORING = "CONCRETE-CLASS-TAILORING"
    CONCRETE_PATTERN_EVENT_TRIGGERING = "CONCRETE-PATTERN-EVENT-TRIGGERING"
    CONSISTENCY_NEEDS = "CONSISTENCY-NEEDS"
    CONSISTENCY_NEEDS_BLUEPRINT_SET = "CONSISTENCY-NEEDS-BLUEPRINT-SET"
    CONSTANT_SPECIFICATION = "CONSTANT-SPECIFICATION"
    CONSTANT_SPECIFICATION_MAPPING_SET = "CONSTANT-SPECIFICATION-MAPPING-SET"
    CONSTRAINT_TAILORING = "CONSTRAINT-TAILORING"
    CONSUMED_EVENT_GROUP = "CONSUMED-EVENT-GROUP"
    CONSUMED_PROVIDED_SERVICE_INSTANCE_GROUP = "CONSUMED-PROVIDED-SERVICE-INSTANCE-GROUP"
    CONSUMED_SERVICE_INSTANCE = "CONSUMED-SERVICE-INSTANCE"
    CONTAINER_I_PDU = "CONTAINER-I-PDU"
    COUPLING_ELEMENT = "COUPLING-ELEMENT"
    COUPLING_PORT = "COUPLING-PORT"
    COUPLING_PORT_FIFO = "COUPLING-PORT-FIFO"
    COUPLING_PORT_SCHEDULER = "COUPLING-PORT-SCHEDULER"
    COUPLING_PORT_SHAPER = "COUPLING-PORT-SHAPER"
    COUPLING_PORT_STRUCTURAL_ELEMENT = "COUPLING-PORT-STRUCTURAL-ELEMENT"
    COUPLING_PORT_TRAFFIC_CLASS_ASSIGNMENT = "COUPLING-PORT-TRAFFIC-CLASS-ASSIGNMENT"
    CP_SOFTWARE_CLUSTER = "CP-SOFTWARE-CLUSTER"
    CP_SOFTWARE_CLUSTER_BINARY_MANIFEST_DESCRIPTOR = (
        "CP-SOFTWARE-CLUSTER-BINARY-MANIFEST-DESCRIPTOR"
    )
    CP_SOFTWARE_CLUSTER_COMMUNICATION_RESOURCE = "CP-SOFTWARE-CLUSTER-COMMUNICATION-RESOURCE"
    CP_SOFTWARE_CLUSTER_MAPPING_SET = "CP-SOFTWARE-CLUSTER-MAPPING-SET"
    CP_SOFTWARE_CLUSTER_RESOURCE = "CP-SOFTWARE-CLUSTER-RESOURCE"
    CP_SOFTWARE_CLUSTER_RESOURCE_POOL = "CP-SOFTWARE-CLUSTER-RESOURCE-POOL"
    CP_SOFTWARE_CLUSTER_RESOURCE_TO_APPLICATION_PARTITION_MAPPING = (
        "CP-SOFTWARE-CLUSTER-RESOURCE-TO-APPLICATION-PARTITION-MAPPING"
    )
    CP_SOFTWARE_CLUSTER_SERVICE_RESOURCE = "CP-SOFTWARE-CLUSTER-SERVICE-RESOURCE"
    CP_SOFTWARE_CLUSTER_TO_ECU_INSTANCE_MAPPING = "CP-SOFTWARE-CLUSTER-TO-ECU-INSTANCE-MAPPING"
    CP_SOFTWARE_CLUSTER_TO_RESOURCE_MAPPING = "CP-SOFTWARE-CLUSTER-TO-RESOURCE-MAPPING"
    CP_SW_CLUSTER_RESOURCE_TO_DIAG_DATA_ELEM_MAPPING = (
        "CP-SW-CLUSTER-RESOURCE-TO-DIAG-DATA-ELEM-MAPPING"
    )
    CP_SW_CLUSTER_RESOURCE_TO_DIAG_FUNCTION_ID_MAPPING = (
        "CP-SW-CLUSTER-RESOURCE-TO-DIAG-FUNCTION-ID-MAPPING"
    )
    CP_SW_CLUSTER_TO_DIAG_EVENT_MAPPING = "CP-SW-CLUSTER-TO-DIAG-EVENT-MAPPING"
    CP_SW_CLUSTER_TO_DIAG_ROUTINE_SUBFUNCTION_MAPPING = (
        "CP-SW-CLUSTER-TO-DIAG-ROUTINE-SUBFUNCTION-MAPPING"
    )
    CPP_IMPLEMENTATION_DATA_TYPE = "CPP-IMPLEMENTATION-DATA-TYPE"
    CPP_IMPLEMENTATION_DATA_TYPE_CONTEXT_TARGET = "CPP-IMPLEMENTATION-DATA-TYPE-CONTEXT-TARGET"
    CPP_IMPLEMENTATION_DATA_TYPE_ELEMENT = "CPP-IMPLEMENTATION-DATA-TYPE-ELEMENT"
    CRYPTO_CERTIFICATE = "CRYPTO-CERTIFICATE"
    CRYPTO_CERTIFICATE_INTERFACE = "CRYPTO-CERTIFICATE-INTERFACE"
    CRYPTO_CERTIFICATE_KEY_SLOT_NEEDS = "CRYPTO-CERTIFICATE-KEY-SLOT-NEEDS"
    CRYPTO_CERTIFICATE_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-CERTIFICATE-TO-PORT-PROTOTYPE-MAPPING"
    CRYPTO_ELLIPTIC_CURVE_PROPS = "CRYPTO-ELLIPTIC-CURVE-PROPS"
    CRYPTO_INTERFACE = "CRYPTO-INTERFACE"
    CRYPTO_KEY_MANAGEMENT_NEEDS = "CRYPTO-KEY-MANAGEMENT-NEEDS"
    CRYPTO_KEY_SLOT = "CRYPTO-KEY-SLOT"
    CRYPTO_KEY_SLOT_INTERFACE = "CRYPTO-KEY-SLOT-INTERFACE"
    CRYPTO_KEY_SLOT_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-KEY-SLOT-TO-PORT-PROTOTYPE-MAPPING"
    CRYPTO_MODULE_INSTANTIATION = "CRYPTO-MODULE-INSTANTIATION"
    CRYPTO_NEEDS = "CRYPTO-NEEDS"
    CRYPTO_PROVIDER = "CRYPTO-PROVIDER"
    CRYPTO_PROVIDER_INTERFACE = "CRYPTO-PROVIDER-INTERFACE"
    CRYPTO_PROVIDER_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-PROVIDER-TO-PORT-PROTOTYPE-MAPPING"
    CRYPTO_SERVICE_CERTIFICATE = "CRYPTO-SERVICE-CERTIFICATE"
    CRYPTO_SERVICE_JOB_NEEDS = "CRYPTO-SERVICE-JOB-NEEDS"
    CRYPTO_SERVICE_KEY = "CRYPTO-SERVICE-KEY"
    CRYPTO_SERVICE_MAPPING = "CRYPTO-SERVICE-MAPPING"
    CRYPTO_SERVICE_NEEDS = "CRYPTO-SERVICE-NEEDS"
    CRYPTO_SERVICE_PRIMITIVE = "CRYPTO-SERVICE-PRIMITIVE"
    CRYPTO_SERVICE_QUEUE = "CRYPTO-SERVICE-QUEUE"
    CRYPTO_SIGNATURE_SCHEME = "CRYPTO-SIGNATURE-SCHEME"
    CRYPTO_TRUST_MASTER_INTERFACE = "CRYPTO-TRUST-MASTER-INTERFACE"
    CUSTOM_CPP_IMPLEMENTATION_DATA_TYPE = "CUSTOM-CPP-IMPLEMENTATION-DATA-TYPE"
    DATA_CONSTR = "DATA-CONSTR"
    DATA_EXCHANGE_POINT = "DATA-EXCHANGE-POINT"
    DATA_FORMAT_ELEMENT_REFERENCE = "DATA-FORMAT-ELEMENT-REFERENCE"
    DATA_FORMAT_ELEMENT_SCOPE = "DATA-FORMAT-ELEMENT-SCOPE"
    DATA_INTERFACE = "DATA-INTERFACE"
    DATA_PROTOTYPE = "DATA-PROTOTYPE"
    DATA_PROTOTYPE_GROUP = "DATA-PROTOTYPE-GROUP"
    DATA_RECEIVE_ERROR_EVENT = "DATA-RECEIVE-ERROR-EVENT"
    DATA_RECEIVED_EVENT = "DATA-RECEIVED-EVENT"
    DATA_SEND_COMPLETED_EVENT = "DATA-SEND-COMPLETED-EVENT"
    DATA_TRANSFORMATION = "DATA-TRANSFORMATION"
    DATA_TRANSFORMATION_SET = "DATA-TRANSFORMATION-SET"
    DATA_TYPE_MAPPING_SET = "DATA-TYPE-MAPPING-SET"
    DATA_WRITE_COMPLETED_EVENT = "DATA-WRITE-COMPLETED-EVENT"
    DCM_I_PDU = "DCM-I-PDU"
    DDS_DOMAIN_RANGE = "DDS-DOMAIN-RANGE"
    DDS_EVENT_DEPLOYMENT = "DDS-EVENT-DEPLOYMENT"
    DDS_FIELD_DEPLOYMENT = "DDS-FIELD-DEPLOYMENT"
    DDS_PROVIDED_SERVICE_INSTANCE = "DDS-PROVIDED-SERVICE-INSTANCE"
    DDS_REQUIRED_SERVICE_INSTANCE = "DDS-REQUIRED-SERVICE-INSTANCE"
    DDS_SECURE_COM_PROPS = "DDS-SECURE-COM-PROPS"
    DDS_SECURE_GOVERNANCE = "DDS-SECURE-GOVERNANCE"
    DDS_SERVICE_INSTANCE_TO_MACHINE_MAPPING = "DDS-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    DDS_SERVICE_INTERFACE_DEPLOYMENT = "DDS-SERVICE-INTERFACE-DEPLOYMENT"
    DDS_TOPIC_ACCESS_RULE = "DDS-TOPIC-ACCESS-RULE"
    DEADLINE_SUPERVISION = "DEADLINE-SUPERVISION"
    DEF_ITEM = "DEF-ITEM"
    DELEGATION_SW_CONNECTOR = "DELEGATION-SW-CONNECTOR"
    DEPENDENCY_ON_ARTIFACT = "DEPENDENCY-ON-ARTIFACT"
    DETERMINISTIC_CLIENT = "DETERMINISTIC-CLIENT"
    DETERMINISTIC_CLIENT_RESOURCE_NEEDS = "DETERMINISTIC-CLIENT-RESOURCE-NEEDS"
    DETERMINISTIC_SYNC_INSTANTIATION = "DETERMINISTIC-SYNC-INSTANTIATION"
    DETERMINISTIC_SYNC_MASTER = "DETERMINISTIC-SYNC-MASTER"
    DETERMINISTIC_SYNC_MASTER_TO_TIME_BASE_CONSUMER_MAPPING = (
        "DETERMINISTIC-SYNC-MASTER-TO-TIME-BASE-CONSUMER-MAPPING"
    )
    DEVELOPMENT_ERROR = "DEVELOPMENT-ERROR"
    DIAG_EVENT_DEBOUNCE_ALGORITHM = "DIAG-EVENT-DEBOUNCE-ALGORITHM"
    DIAG_EVENT_DEBOUNCE_COUNTER_BASED = "DIAG-EVENT-DEBOUNCE-COUNTER-BASED"
    DIAG_EVENT_DEBOUNCE_MONITOR_INTERNAL = "DIAG-EVENT-DEBOUNCE-MONITOR-INTERNAL"
    DIAG_EVENT_DEBOUNCE_TIME_BASED = "DIAG-EVENT-DEBOUNCE-TIME-BASED"
    DIAGNOSTIC_ABSTRACT_ALIAS_EVENT = "DIAGNOSTIC-ABSTRACT-ALIAS-EVENT"
    DIAGNOSTIC_ABSTRACT_DATA_IDENTIFIER = "DIAGNOSTIC-ABSTRACT-DATA-IDENTIFIER"
    DIAGNOSTIC_ABSTRACT_DATA_IDENTIFIER_INTERFACE = "DIAGNOSTIC-ABSTRACT-DATA-IDENTIFIER-INTERFACE"
    DIAGNOSTIC_ABSTRACT_ROUTINE_INTERFACE = "DIAGNOSTIC-ABSTRACT-ROUTINE-INTERFACE"
    DIAGNOSTIC_ACCESS_PERMISSION = "DIAGNOSTIC-ACCESS-PERMISSION"
    DIAGNOSTIC_AGING = "DIAGNOSTIC-AGING"
    DIAGNOSTIC_AUTH_ROLE = "DIAGNOSTIC-AUTH-ROLE"
    DIAGNOSTIC_AUTHENTICATION = "DIAGNOSTIC-AUTHENTICATION"
    DIAGNOSTIC_AUTHENTICATION_CLASS = "DIAGNOSTIC-AUTHENTICATION-CLASS"
    DIAGNOSTIC_AUTHENTICATION_CONFIGURATION = "DIAGNOSTIC-AUTHENTICATION-CONFIGURATION"
    DIAGNOSTIC_AUTHENTICATION_INTERFACE = "DIAGNOSTIC-AUTHENTICATION-INTERFACE"
    DIAGNOSTIC_AUTHENTICATION_PORT_MAPPING = "DIAGNOSTIC-AUTHENTICATION-PORT-MAPPING"
    DIAGNOSTIC_CAPABILITY_ELEMENT = "DIAGNOSTIC-CAPABILITY-ELEMENT"
    DIAGNOSTIC_CLEAR_CONDITION = "DIAGNOSTIC-CLEAR-CONDITION"
    DIAGNOSTIC_CLEAR_CONDITION_GROUP = "DIAGNOSTIC-CLEAR-CONDITION-GROUP"
    DIAGNOSTIC_CLEAR_CONDITION_NEEDS = "DIAGNOSTIC-CLEAR-CONDITION-NEEDS"
    DIAGNOSTIC_CLEAR_CONDITION_PORT_MAPPING = "DIAGNOSTIC-CLEAR-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_CLEAR_DIAGNOSTIC_INFORMATION = "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION"
    DIAGNOSTIC_CLEAR_DIAGNOSTIC_INFORMATION_CLASS = "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION-CLASS"
    DIAGNOSTIC_CLEAR_RESET_EMISSION_RELATED_INFO = "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO"
    DIAGNOSTIC_CLEAR_RESET_EMISSION_RELATED_INFO_CLASS = (
        "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO-CLASS"
    )
    DIAGNOSTIC_COM_CONTROL = "DIAGNOSTIC-COM-CONTROL"
    DIAGNOSTIC_COM_CONTROL_CLASS = "DIAGNOSTIC-COM-CONTROL-CLASS"
    DIAGNOSTIC_COM_CONTROL_INTERFACE = "DIAGNOSTIC-COM-CONTROL-INTERFACE"
    DIAGNOSTIC_COMMON_ELEMENT = "DIAGNOSTIC-COMMON-ELEMENT"
    DIAGNOSTIC_COMMUNICATION_MANAGER_NEEDS = "DIAGNOSTIC-COMMUNICATION-MANAGER-NEEDS"
    DIAGNOSTIC_COMPONENT_NEEDS = "DIAGNOSTIC-COMPONENT-NEEDS"
    DIAGNOSTIC_CONDITION = "DIAGNOSTIC-CONDITION"
    DIAGNOSTIC_CONDITION_GROUP = "DIAGNOSTIC-CONDITION-GROUP"
    DIAGNOSTIC_CONDITION_INTERFACE = "DIAGNOSTIC-CONDITION-INTERFACE"
    DIAGNOSTIC_CONNECTED_INDICATOR = "DIAGNOSTIC-CONNECTED-INDICATOR"
    DIAGNOSTIC_CONNECTION = "DIAGNOSTIC-CONNECTION"
    DIAGNOSTIC_CONTRIBUTION_SET = "DIAGNOSTIC-CONTRIBUTION-SET"
    DIAGNOSTIC_CONTROL_DTC_SETTING = "DIAGNOSTIC-CONTROL-DTC-SETTING"
    DIAGNOSTIC_CONTROL_DTC_SETTING_CLASS = "DIAGNOSTIC-CONTROL-DTC-SETTING-CLASS"
    DIAGNOSTIC_CONTROL_NEEDS = "DIAGNOSTIC-CONTROL-NEEDS"
    DIAGNOSTIC_CUSTOM_SERVICE_CLASS = "DIAGNOSTIC-CUSTOM-SERVICE-CLASS"
    DIAGNOSTIC_CUSTOM_SERVICE_INSTANCE = "DIAGNOSTIC-CUSTOM-SERVICE-INSTANCE"
    DIAGNOSTIC_DATA_BY_IDENTIFIER = "DIAGNOSTIC-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_DATA_ELEMENT = "DIAGNOSTIC-DATA-ELEMENT"
    DIAGNOSTIC_DATA_ELEMENT_INTERFACE = "DIAGNOSTIC-DATA-ELEMENT-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER = "DIAGNOSTIC-DATA-IDENTIFIER"
    DIAGNOSTIC_DATA_IDENTIFIER_GENERIC_INTERFACE = "DIAGNOSTIC-DATA-IDENTIFIER-GENERIC-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER_INTERFACE = "DIAGNOSTIC-DATA-IDENTIFIER-INTERFACE"
    DIAGNOSTIC_DATA_IDENTIFIER_SET = "DIAGNOSTIC-DATA-IDENTIFIER-SET"
    DIAGNOSTIC_DATA_PORT_MAPPING = "DIAGNOSTIC-DATA-PORT-MAPPING"
    DIAGNOSTIC_DATA_TRANSFER = "DIAGNOSTIC-DATA-TRANSFER"
    DIAGNOSTIC_DATA_TRANSFER_CLASS = "DIAGNOSTIC-DATA-TRANSFER-CLASS"
    DIAGNOSTIC_DE_AUTHENTICATION = "DIAGNOSTIC-DE-AUTHENTICATION"
    DIAGNOSTIC_DEBOUNCE_ALGORITHM_PROPS = "DIAGNOSTIC-DEBOUNCE-ALGORITHM-PROPS"
    DIAGNOSTIC_DEM_PROVIDED_DATA_MAPPING = "DIAGNOSTIC-DEM-PROVIDED-DATA-MAPPING"
    DIAGNOSTIC_DO_IP_ACTIVATION_LINE_INTERFACE = "DIAGNOSTIC-DO-IP-ACTIVATION-LINE-INTERFACE"
    DIAGNOSTIC_DO_IP_ENTITY_IDENTIFICATION_INTERFACE = (
        "DIAGNOSTIC-DO-IP-ENTITY-IDENTIFICATION-INTERFACE"
    )
    DIAGNOSTIC_DO_IP_GROUP_IDENTIFICATION_INTERFACE = (
        "DIAGNOSTIC-DO-IP-GROUP-IDENTIFICATION-INTERFACE"
    )
    DIAGNOSTIC_DO_IP_POWER_MODE_INTERFACE = "DIAGNOSTIC-DO-IP-POWER-MODE-INTERFACE"
    DIAGNOSTIC_DO_IP_TRIGGER_VEHICLE_ANNOUNCEMENT_INTERFACE = (
        "DIAGNOSTIC-DO-IP-TRIGGER-VEHICLE-ANNOUNCEMENT-INTERFACE"
    )
    DIAGNOSTIC_DOWNLOAD_INTERFACE = "DIAGNOSTIC-DOWNLOAD-INTERFACE"
    DIAGNOSTIC_DTC_INFORMATION_INTERFACE = "DIAGNOSTIC-DTC-INFORMATION-INTERFACE"
    DIAGNOSTIC_DYNAMIC_DATA_IDENTIFIER = "DIAGNOSTIC-DYNAMIC-DATA-IDENTIFIER"
    DIAGNOSTIC_DYNAMICALLY_DEFINE_DATA_IDENTIFIER = "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER"
    DIAGNOSTIC_DYNAMICALLY_DEFINE_DATA_IDENTIFIER_CLASS = (
        "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER-CLASS"
    )
    DIAGNOSTIC_ECU_INSTANCE_PROPS = "DIAGNOSTIC-ECU-INSTANCE-PROPS"
    DIAGNOSTIC_ECU_RESET = "DIAGNOSTIC-ECU-RESET"
    DIAGNOSTIC_ECU_RESET_CLASS = "DIAGNOSTIC-ECU-RESET-CLASS"
    DIAGNOSTIC_ECU_RESET_INTERFACE = "DIAGNOSTIC-ECU-RESET-INTERFACE"
    DIAGNOSTIC_ENABLE_CONDITION = "DIAGNOSTIC-ENABLE-CONDITION"
    DIAGNOSTIC_ENABLE_CONDITION_GROUP = "DIAGNOSTIC-ENABLE-CONDITION-GROUP"
    DIAGNOSTIC_ENABLE_CONDITION_NEEDS = "DIAGNOSTIC-ENABLE-CONDITION-NEEDS"
    DIAGNOSTIC_ENABLE_CONDITION_PORT_MAPPING = "DIAGNOSTIC-ENABLE-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_ENV_BSW_MODE_ELEMENT = "DIAGNOSTIC-ENV-BSW-MODE-ELEMENT"
    DIAGNOSTIC_ENV_MODE_ELEMENT = "DIAGNOSTIC-ENV-MODE-ELEMENT"
    DIAGNOSTIC_ENV_SWC_MODE_ELEMENT = "DIAGNOSTIC-ENV-SWC-MODE-ELEMENT"
    DIAGNOSTIC_ENVIRONMENTAL_CONDITION = "DIAGNOSTIC-ENVIRONMENTAL-CONDITION"
    DIAGNOSTIC_EVENT = "DIAGNOSTIC-EVENT"
    DIAGNOSTIC_EVENT_INFO_NEEDS = "DIAGNOSTIC-EVENT-INFO-NEEDS"
    DIAGNOSTIC_EVENT_INTERFACE = "DIAGNOSTIC-EVENT-INTERFACE"
    DIAGNOSTIC_EVENT_MANAGER_NEEDS = "DIAGNOSTIC-EVENT-MANAGER-NEEDS"
    DIAGNOSTIC_EVENT_NEEDS = "DIAGNOSTIC-EVENT-NEEDS"
    DIAGNOSTIC_EVENT_PORT_MAPPING = "DIAGNOSTIC-EVENT-PORT-MAPPING"
    DIAGNOSTIC_EVENT_TO_DEBOUNCE_ALGORITHM_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-DEBOUNCE-ALGORITHM-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_ENABLE_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-ENABLE-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_OPERATION_CYCLE_MAPPING = "DIAGNOSTIC-EVENT-TO-OPERATION-CYCLE-MAPPING"
    DIAGNOSTIC_EVENT_TO_SECURITY_EVENT_MAPPING = "DIAGNOSTIC-EVENT-TO-SECURITY-EVENT-MAPPING"
    DIAGNOSTIC_EVENT_TO_STORAGE_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-STORAGE-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_TROUBLE_CODE_J_1939_MAPPING = (
        "DIAGNOSTIC-EVENT-TO-TROUBLE-CODE-J-1939-MAPPING"
    )
    DIAGNOSTIC_EVENT_TO_TROUBLE_CODE_UDS_MAPPING = "DIAGNOSTIC-EVENT-TO-TROUBLE-CODE-UDS-MAPPING"
    DIAGNOSTIC_EXTENDED_DATA_RECORD = "DIAGNOSTIC-EXTENDED-DATA-RECORD"
    DIAGNOSTIC_EXTERNAL_AUTHENTICATION_INTERFACE = "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-INTERFACE"
    DIAGNOSTIC_EXTERNAL_AUTHENTICATION_PORT_MAPPING = (
        "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-PORT-MAPPING"
    )
    DIAGNOSTIC_FIM_ALIAS_EVENT = "DIAGNOSTIC-FIM-ALIAS-EVENT"
    DIAGNOSTIC_FIM_ALIAS_EVENT_GROUP = "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP"
    DIAGNOSTIC_FIM_ALIAS_EVENT_GROUP_MAPPING = "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP-MAPPING"
    DIAGNOSTIC_FIM_ALIAS_EVENT_MAPPING = "DIAGNOSTIC-FIM-ALIAS-EVENT-MAPPING"
    DIAGNOSTIC_FIM_EVENT_GROUP = "DIAGNOSTIC-FIM-EVENT-GROUP"
    DIAGNOSTIC_FIM_FUNCTION_MAPPING = "DIAGNOSTIC-FIM-FUNCTION-MAPPING"
    DIAGNOSTIC_FREEZE_FRAME = "DIAGNOSTIC-FREEZE-FRAME"
    DIAGNOSTIC_FUNCTION_IDENTIFIER = "DIAGNOSTIC-FUNCTION-IDENTIFIER"
    DIAGNOSTIC_FUNCTION_IDENTIFIER_INHIBIT = "DIAGNOSTIC-FUNCTION-IDENTIFIER-INHIBIT"
    DIAGNOSTIC_FUNCTION_INHIBIT_SOURCE = "DIAGNOSTIC-FUNCTION-INHIBIT-SOURCE"
    DIAGNOSTIC_GENERIC_UDS_INTERFACE = "DIAGNOSTIC-GENERIC-UDS-INTERFACE"
    DIAGNOSTIC_GENERIC_UDS_NEEDS = "DIAGNOSTIC-GENERIC-UDS-NEEDS"
    DIAGNOSTIC_INDICATOR = "DIAGNOSTIC-INDICATOR"
    DIAGNOSTIC_INDICATOR_INTERFACE = "DIAGNOSTIC-INDICATOR-INTERFACE"
    DIAGNOSTIC_INDICATOR_NEEDS = "DIAGNOSTIC-INDICATOR-NEEDS"
    DIAGNOSTIC_INDICATOR_PORT_MAPPING = "DIAGNOSTIC-INDICATOR-PORT-MAPPING"
    DIAGNOSTIC_INFO_TYPE = "DIAGNOSTIC-INFO-TYPE"
    DIAGNOSTIC_INHIBIT_SOURCE_EVENT_MAPPING = "DIAGNOSTIC-INHIBIT-SOURCE-EVENT-MAPPING"
    DIAGNOSTIC_IO_CONTROL = "DIAGNOSTIC-IO-CONTROL"
    DIAGNOSTIC_IO_CONTROL_CLASS = "DIAGNOSTIC-IO-CONTROL-CLASS"
    DIAGNOSTIC_IO_CONTROL_NEEDS = "DIAGNOSTIC-IO-CONTROL-NEEDS"
    DIAGNOSTIC_IUMPR = "DIAGNOSTIC-IUMPR"
    DIAGNOSTIC_IUMPR_DENOMINATOR_GROUP = "DIAGNOSTIC-IUMPR-DENOMINATOR-GROUP"
    DIAGNOSTIC_IUMPR_GROUP = "DIAGNOSTIC-IUMPR-GROUP"
    DIAGNOSTIC_IUMPR_TO_FUNCTION_IDENTIFIER_MAPPING = (
        "DIAGNOSTIC-IUMPR-TO-FUNCTION-IDENTIFIER-MAPPING"
    )
    DIAGNOSTIC_J_1939_EXPANDED_FREEZE_FRAME = "DIAGNOSTIC-J-1939-EXPANDED-FREEZE-FRAME"
    DIAGNOSTIC_J_1939_FREEZE_FRAME = "DIAGNOSTIC-J-1939-FREEZE-FRAME"
    DIAGNOSTIC_J_1939_NODE = "DIAGNOSTIC-J-1939-NODE"
    DIAGNOSTIC_J_1939_SPN = "DIAGNOSTIC-J-1939-SPN"
    DIAGNOSTIC_J_1939_SPN_MAPPING = "DIAGNOSTIC-J-1939-SPN-MAPPING"
    DIAGNOSTIC_J_1939_SW_MAPPING = "DIAGNOSTIC-J-1939-SW-MAPPING"
    DIAGNOSTIC_MAPPING = "DIAGNOSTIC-MAPPING"
    DIAGNOSTIC_MASTER_TO_SLAVE_EVENT_MAPPING = "DIAGNOSTIC-MASTER-TO-SLAVE-EVENT-MAPPING"
    DIAGNOSTIC_MASTER_TO_SLAVE_EVENT_MAPPING_SET = "DIAGNOSTIC-MASTER-TO-SLAVE-EVENT-MAPPING-SET"
    DIAGNOSTIC_MEASUREMENT_IDENTIFIER = "DIAGNOSTIC-MEASUREMENT-IDENTIFIER"
    DIAGNOSTIC_MEMORY_ADDRESSABLE_RANGE_ACCESS = "DIAGNOSTIC-MEMORY-ADDRESSABLE-RANGE-ACCESS"
    DIAGNOSTIC_MEMORY_BY_ADDRESS = "DIAGNOSTIC-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_MEMORY_DESTINATION = "DIAGNOSTIC-MEMORY-DESTINATION"
    DIAGNOSTIC_MEMORY_DESTINATION_MIRROR = "DIAGNOSTIC-MEMORY-DESTINATION-MIRROR"
    DIAGNOSTIC_MEMORY_DESTINATION_PORT_MAPPING = "DIAGNOSTIC-MEMORY-DESTINATION-PORT-MAPPING"
    DIAGNOSTIC_MEMORY_DESTINATION_PRIMARY = "DIAGNOSTIC-MEMORY-DESTINATION-PRIMARY"
    DIAGNOSTIC_MEMORY_DESTINATION_USER_DEFINED = "DIAGNOSTIC-MEMORY-DESTINATION-USER-DEFINED"
    DIAGNOSTIC_MEMORY_IDENTIFIER = "DIAGNOSTIC-MEMORY-IDENTIFIER"
    DIAGNOSTIC_MONITOR_INTERFACE = "DIAGNOSTIC-MONITOR-INTERFACE"
    DIAGNOSTIC_MONITOR_PORT_MAPPING = "DIAGNOSTIC-MONITOR-PORT-MAPPING"
    DIAGNOSTIC_OPERATION_CYCLE = "DIAGNOSTIC-OPERATION-CYCLE"
    DIAGNOSTIC_OPERATION_CYCLE_INTERFACE = "DIAGNOSTIC-OPERATION-CYCLE-INTERFACE"
    DIAGNOSTIC_OPERATION_CYCLE_NEEDS = "DIAGNOSTIC-OPERATION-CYCLE-NEEDS"
    DIAGNOSTIC_OPERATION_CYCLE_PORT_MAPPING = "DIAGNOSTIC-OPERATION-CYCLE-PORT-MAPPING"
    DIAGNOSTIC_PARAMETER_ELEMENT = "DIAGNOSTIC-PARAMETER-ELEMENT"
    DIAGNOSTIC_PARAMETER_IDENT = "DIAGNOSTIC-PARAMETER-IDENT"
    DIAGNOSTIC_PARAMETER_IDENTIFIER = "DIAGNOSTIC-PARAMETER-IDENTIFIER"
    DIAGNOSTIC_PORT_INTERFACE = "DIAGNOSTIC-PORT-INTERFACE"
    DIAGNOSTIC_POWERTRAIN_FREEZE_FRAME = "DIAGNOSTIC-POWERTRAIN-FREEZE-FRAME"
    DIAGNOSTIC_PROOF_OF_OWNERSHIP = "DIAGNOSTIC-PROOF-OF-OWNERSHIP"
    DIAGNOSTIC_PROTOCOL = "DIAGNOSTIC-PROTOCOL"
    DIAGNOSTIC_PROVIDED_DATA_MAPPING = "DIAGNOSTIC-PROVIDED-DATA-MAPPING"
    DIAGNOSTIC_READ_DATA_BY_IDENTIFIER = "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_READ_DATA_BY_IDENTIFIER_CLASS = "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER-CLASS"
    DIAGNOSTIC_READ_DATA_BY_PERIODIC_ID = "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID"
    DIAGNOSTIC_READ_DATA_BY_PERIODIC_ID_CLASS = "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID-CLASS"
    DIAGNOSTIC_READ_DTC_INFORMATION = "DIAGNOSTIC-READ-DTC-INFORMATION"
    DIAGNOSTIC_READ_DTC_INFORMATION_CLASS = "DIAGNOSTIC-READ-DTC-INFORMATION-CLASS"
    DIAGNOSTIC_READ_MEMORY_BY_ADDRESS = "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_READ_MEMORY_BY_ADDRESS_CLASS = "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS-CLASS"
    DIAGNOSTIC_READ_SCALING_DATA_BY_IDENTIFIER = "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_READ_SCALING_DATA_BY_IDENTIFIER_CLASS = (
        "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER-CLASS"
    )
    DIAGNOSTIC_REQUEST_CONTROL_OF_ON_BOARD_DEVICE = "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE"
    DIAGNOSTIC_REQUEST_CONTROL_OF_ON_BOARD_DEVICE_CLASS = (
        "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE-CLASS"
    )
    DIAGNOSTIC_REQUEST_CURRENT_POWERTRAIN_DATA = "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA"
    DIAGNOSTIC_REQUEST_CURRENT_POWERTRAIN_DATA_CLASS = (
        "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA-CLASS"
    )
    DIAGNOSTIC_REQUEST_DOWNLOAD = "DIAGNOSTIC-REQUEST-DOWNLOAD"
    DIAGNOSTIC_REQUEST_DOWNLOAD_CLASS = "DIAGNOSTIC-REQUEST-DOWNLOAD-CLASS"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_CLASS = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-CLASS"
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_PERMANENT_STATUS = (
        "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS"
    )
    DIAGNOSTIC_REQUEST_EMISSION_RELATED_DTC_PERMANENT_STATUS_CLASS = (
        "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS-CLASS"
    )
    DIAGNOSTIC_REQUEST_FILE_TRANSFER = "DIAGNOSTIC-REQUEST-FILE-TRANSFER"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_CLASS = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-CLASS"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_INTERFACE = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-INTERFACE"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_NEEDS = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-NEEDS"
    DIAGNOSTIC_REQUEST_ON_BOARD_MONITORING_TEST_RESULTS = (
        "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS"
    )
    DIAGNOSTIC_REQUEST_ON_BOARD_MONITORING_TEST_RESULTS_CLASS = (
        "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS-CLASS"
    )
    DIAGNOSTIC_REQUEST_POWERTRAIN_FREEZE_FRAME_DATA = (
        "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA"
    )
    DIAGNOSTIC_REQUEST_POWERTRAIN_FREEZE_FRAME_DATA_CLASS = (
        "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA-CLASS"
    )
    DIAGNOSTIC_REQUEST_ROUTINE_RESULTS = "DIAGNOSTIC-REQUEST-ROUTINE-RESULTS"
    DIAGNOSTIC_REQUEST_UPLOAD = "DIAGNOSTIC-REQUEST-UPLOAD"
    DIAGNOSTIC_REQUEST_UPLOAD_CLASS = "DIAGNOSTIC-REQUEST-UPLOAD-CLASS"
    DIAGNOSTIC_REQUEST_VEHICLE_INFO = "DIAGNOSTIC-REQUEST-VEHICLE-INFO"
    DIAGNOSTIC_REQUEST_VEHICLE_INFO_CLASS = "DIAGNOSTIC-REQUEST-VEHICLE-INFO-CLASS"
    DIAGNOSTIC_RESPONSE_ON_EVENT = "DIAGNOSTIC-RESPONSE-ON-EVENT"
    DIAGNOSTIC_RESPONSE_ON_EVENT_CLASS = "DIAGNOSTIC-RESPONSE-ON-EVENT-CLASS"
    DIAGNOSTIC_RESPONSE_ON_EVENT_NEEDS = "DIAGNOSTIC-RESPONSE-ON-EVENT-NEEDS"
    DIAGNOSTIC_ROUTINE = "DIAGNOSTIC-ROUTINE"
    DIAGNOSTIC_ROUTINE_CONTROL = "DIAGNOSTIC-ROUTINE-CONTROL"
    DIAGNOSTIC_ROUTINE_CONTROL_CLASS = "DIAGNOSTIC-ROUTINE-CONTROL-CLASS"
    DIAGNOSTIC_ROUTINE_GENERIC_INTERFACE = "DIAGNOSTIC-ROUTINE-GENERIC-INTERFACE"
    DIAGNOSTIC_ROUTINE_INTERFACE = "DIAGNOSTIC-ROUTINE-INTERFACE"
    DIAGNOSTIC_ROUTINE_NEEDS = "DIAGNOSTIC-ROUTINE-NEEDS"
    DIAGNOSTIC_ROUTINE_SUBFUNCTION = "DIAGNOSTIC-ROUTINE-SUBFUNCTION"
    DIAGNOSTIC_SECURITY_ACCESS = "DIAGNOSTIC-SECURITY-ACCESS"
    DIAGNOSTIC_SECURITY_ACCESS_CLASS = "DIAGNOSTIC-SECURITY-ACCESS-CLASS"
    DIAGNOSTIC_SECURITY_EVENT_REPORTING_MODE_MAPPING = (
        "DIAGNOSTIC-SECURITY-EVENT-REPORTING-MODE-MAPPING"
    )
    DIAGNOSTIC_SECURITY_LEVEL = "DIAGNOSTIC-SECURITY-LEVEL"
    DIAGNOSTIC_SECURITY_LEVEL_INTERFACE = "DIAGNOSTIC-SECURITY-LEVEL-INTERFACE"
    DIAGNOSTIC_SECURITY_LEVEL_PORT_MAPPING = "DIAGNOSTIC-SECURITY-LEVEL-PORT-MAPPING"
    DIAGNOSTIC_SERVICE_CLASS = "DIAGNOSTIC-SERVICE-CLASS"
    DIAGNOSTIC_SERVICE_DATA_MAPPING = "DIAGNOSTIC-SERVICE-DATA-MAPPING"
    DIAGNOSTIC_SERVICE_GENERIC_MAPPING = "DIAGNOSTIC-SERVICE-GENERIC-MAPPING"
    DIAGNOSTIC_SERVICE_INSTANCE = "DIAGNOSTIC-SERVICE-INSTANCE"
    DIAGNOSTIC_SERVICE_SW_MAPPING = "DIAGNOSTIC-SERVICE-SW-MAPPING"
    DIAGNOSTIC_SERVICE_TABLE = "DIAGNOSTIC-SERVICE-TABLE"
    DIAGNOSTIC_SERVICE_VALIDATION_INTERFACE = "DIAGNOSTIC-SERVICE-VALIDATION-INTERFACE"
    DIAGNOSTIC_SERVICE_VALIDATION_MAPPING = "DIAGNOSTIC-SERVICE-VALIDATION-MAPPING"
    DIAGNOSTIC_SESSION = "DIAGNOSTIC-SESSION"
    DIAGNOSTIC_SESSION_CONTROL = "DIAGNOSTIC-SESSION-CONTROL"
    DIAGNOSTIC_SESSION_CONTROL_CLASS = "DIAGNOSTIC-SESSION-CONTROL-CLASS"
    DIAGNOSTIC_SOVD_AUTHORIZATION_INTERFACE = "DIAGNOSTIC-SOVD-AUTHORIZATION-INTERFACE"
    DIAGNOSTIC_SOVD_AUTHORIZATION_PORT_MAPPING = "DIAGNOSTIC-SOVD-AUTHORIZATION-PORT-MAPPING"
    DIAGNOSTIC_SOVD_LOCK = "DIAGNOSTIC-SOVD-LOCK"
    DIAGNOSTIC_SOVD_PORT_INTERFACE = "DIAGNOSTIC-SOVD-PORT-INTERFACE"
    DIAGNOSTIC_SOVD_PROXIMITY_CHALLENGE_INTERFACE = "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-INTERFACE"
    DIAGNOSTIC_SOVD_PROXIMITY_CHALLENGE_PORT_MAPPING = (
        "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-PORT-MAPPING"
    )
    DIAGNOSTIC_START_ROUTINE = "DIAGNOSTIC-START-ROUTINE"
    DIAGNOSTIC_STOP_ROUTINE = "DIAGNOSTIC-STOP-ROUTINE"
    DIAGNOSTIC_STORAGE_CONDITION = "DIAGNOSTIC-STORAGE-CONDITION"
    DIAGNOSTIC_STORAGE_CONDITION_GROUP = "DIAGNOSTIC-STORAGE-CONDITION-GROUP"
    DIAGNOSTIC_STORAGE_CONDITION_NEEDS = "DIAGNOSTIC-STORAGE-CONDITION-NEEDS"
    DIAGNOSTIC_STORAGE_CONDITION_PORT_MAPPING = "DIAGNOSTIC-STORAGE-CONDITION-PORT-MAPPING"
    DIAGNOSTIC_SW_MAPPING = "DIAGNOSTIC-SW-MAPPING"
    DIAGNOSTIC_TEST_RESULT = "DIAGNOSTIC-TEST-RESULT"
    DIAGNOSTIC_TEST_ROUTINE_IDENTIFIER = "DIAGNOSTIC-TEST-ROUTINE-IDENTIFIER"
    DIAGNOSTIC_TRANSFER_EXIT = "DIAGNOSTIC-TRANSFER-EXIT"
    DIAGNOSTIC_TRANSFER_EXIT_CLASS = "DIAGNOSTIC-TRANSFER-EXIT-CLASS"
    DIAGNOSTIC_TROUBLE_CODE = "DIAGNOSTIC-TROUBLE-CODE"
    DIAGNOSTIC_TROUBLE_CODE_GROUP = "DIAGNOSTIC-TROUBLE-CODE-GROUP"
    DIAGNOSTIC_TROUBLE_CODE_J_1939 = "DIAGNOSTIC-TROUBLE-CODE-J-1939"
    DIAGNOSTIC_TROUBLE_CODE_OBD = "DIAGNOSTIC-TROUBLE-CODE-OBD"
    DIAGNOSTIC_TROUBLE_CODE_PROPS = "DIAGNOSTIC-TROUBLE-CODE-PROPS"
    DIAGNOSTIC_TROUBLE_CODE_UDS = "DIAGNOSTIC-TROUBLE-CODE-UDS"
    DIAGNOSTIC_TROUBLE_CODE_UDS_TO_CLEAR_CONDITION_GROUP_MAPPING = (
        "DIAGNOSTIC-TROUBLE-CODE-UDS-TO-CLEAR-CONDITION-GROUP-MAPPING"
    )
    DIAGNOSTIC_TROUBLE_CODE_UDS_TO_TROUBLE_CODE_OBD_MAPPING = (
        "DIAGNOSTIC-TROUBLE-CODE-UDS-TO-TROUBLE-CODE-OBD-MAPPING"
    )
    DIAGNOSTIC_UPLOAD_DOWNLOAD_NEEDS = "DIAGNOSTIC-UPLOAD-DOWNLOAD-NEEDS"
    DIAGNOSTIC_UPLOAD_INTERFACE = "DIAGNOSTIC-UPLOAD-INTERFACE"
    DIAGNOSTIC_VALUE_NEEDS = "DIAGNOSTIC-VALUE-NEEDS"
    DIAGNOSTIC_VERIFY_CERTIFICATE_BIDIRECTIONAL = "DIAGNOSTIC-VERIFY-CERTIFICATE-BIDIRECTIONAL"
    DIAGNOSTIC_VERIFY_CERTIFICATE_UNIDIRECTIONAL = "DIAGNOSTIC-VERIFY-CERTIFICATE-UNIDIRECTIONAL"
    DIAGNOSTIC_WRITE_DATA_BY_IDENTIFIER = "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER"
    DIAGNOSTIC_WRITE_DATA_BY_IDENTIFIER_CLASS = "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER-CLASS"
    DIAGNOSTIC_WRITE_MEMORY_BY_ADDRESS = "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS"
    DIAGNOSTIC_WRITE_MEMORY_BY_ADDRESS_CLASS = "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS-CLASS"
    DIAGNOSTICS_COMMUNICATION_SECURITY_NEEDS = "DIAGNOSTICS-COMMUNICATION-SECURITY-NEEDS"
    DLT_APPLICATION = "DLT-APPLICATION"
    DLT_APPLICATION_TO_PROCESS_MAPPING = "DLT-APPLICATION-TO-PROCESS-MAPPING"
    DLT_ARGUMENT = "DLT-ARGUMENT"
    DLT_CONTEXT = "DLT-CONTEXT"
    DLT_ECU = "DLT-ECU"
    DLT_LOG_CHANNEL = "DLT-LOG-CHANNEL"
    DLT_LOG_SINK = "DLT-LOG-SINK"
    DLT_LOG_SINK_TO_PORT_PROTOTYPE_MAPPING = "DLT-LOG-SINK-TO-PORT-PROTOTYPE-MAPPING"
    DLT_MESSAGE = "DLT-MESSAGE"
    DLT_MESSAGE_COLLECTION_SET = "DLT-MESSAGE-COLLECTION-SET"
    DLT_USER_NEEDS = "DLT-USER-NEEDS"
    DO_IP_ACTIVATION_LINE_NEEDS = "DO-IP-ACTIVATION-LINE-NEEDS"
    DO_IP_GID_NEEDS = "DO-IP-GID-NEEDS"
    DO_IP_GID_SYNCHRONIZATION_NEEDS = "DO-IP-GID-SYNCHRONIZATION-NEEDS"
    DO_IP_INSTANTIATION = "DO-IP-INSTANTIATION"
    DO_IP_INTERFACE = "DO-IP-INTERFACE"
    DO_IP_LOGIC_ADDRESS = "DO-IP-LOGIC-ADDRESS"
    DO_IP_LOGIC_TARGET_ADDRESS_PROPS = "DO-IP-LOGIC-TARGET-ADDRESS-PROPS"
    DO_IP_LOGIC_TESTER_ADDRESS_PROPS = "DO-IP-LOGIC-TESTER-ADDRESS-PROPS"
    DO_IP_POWER_MODE_STATUS_NEEDS = "DO-IP-POWER-MODE-STATUS-NEEDS"
    DO_IP_ROUTING_ACTIVATION = "DO-IP-ROUTING-ACTIVATION"
    DO_IP_ROUTING_ACTIVATION_AUTHENTICATION_NEEDS = "DO-IP-ROUTING-ACTIVATION-AUTHENTICATION-NEEDS"
    DO_IP_ROUTING_ACTIVATION_CONFIRMATION_NEEDS = "DO-IP-ROUTING-ACTIVATION-CONFIRMATION-NEEDS"
    DO_IP_SERVICE_NEEDS = "DO-IP-SERVICE-NEEDS"
    DO_IP_TP_CONFIG = "DO-IP-TP-CONFIG"
    DOCUMENT_ELEMENT_SCOPE = "DOCUMENT-ELEMENT-SCOPE"
    DOCUMENTATION = "DOCUMENTATION"
    DOCUMENTATION_CONTEXT = "DOCUMENTATION-CONTEXT"
    DTC_STATUS_CHANGE_NOTIFICATION_NEEDS = "DTC-STATUS-CHANGE-NOTIFICATION-NEEDS"
    E_2_E_PROFILE_COMPATIBILITY_PROPS = "E-2-E-PROFILE-COMPATIBILITY-PROPS"
    E_2_E_PROFILE_CONFIGURATION = "E-2-E-PROFILE-CONFIGURATION"
    E_2_E_PROFILE_CONFIGURATION_SET = "E-2-E-PROFILE-CONFIGURATION-SET"
    ECU_ABSTRACTION_SW_COMPONENT_TYPE = "ECU-ABSTRACTION-SW-COMPONENT-TYPE"
    ECU_INSTANCE = "ECU-INSTANCE"
    ECU_MAPPING = "ECU-MAPPING"
    ECU_PARTITION = "ECU-PARTITION"
    ECU_STATE_MGR_USER_NEEDS = "ECU-STATE-MGR-USER-NEEDS"
    ECU_TIMING = "ECU-TIMING"
    ECUC_ABSTRACT_EXTERNAL_REFERENCE_DEF = "ECUC-ABSTRACT-EXTERNAL-REFERENCE-DEF"
    ECUC_ABSTRACT_INTERNAL_REFERENCE_DEF = "ECUC-ABSTRACT-INTERNAL-REFERENCE-DEF"
    ECUC_ABSTRACT_REFERENCE_DEF = "ECUC-ABSTRACT-REFERENCE-DEF"
    ECUC_ABSTRACT_STRING_PARAM_DEF = "ECUC-ABSTRACT-STRING-PARAM-DEF"
    ECUC_ADD_INFO_PARAM_DEF = "ECUC-ADD-INFO-PARAM-DEF"
    ECUC_BOOLEAN_PARAM_DEF = "ECUC-BOOLEAN-PARAM-DEF"
    ECUC_CHOICE_CONTAINER_DEF = "ECUC-CHOICE-CONTAINER-DEF"
    ECUC_CHOICE_REFERENCE_DEF = "ECUC-CHOICE-REFERENCE-DEF"
    ECUC_COMMON_ATTRIBUTES = "ECUC-COMMON-ATTRIBUTES"
    ECUC_CONTAINER_DEF = "ECUC-CONTAINER-DEF"
    ECUC_CONTAINER_VALUE = "ECUC-CONTAINER-VALUE"
    ECUC_DEFINITION_COLLECTION = "ECUC-DEFINITION-COLLECTION"
    ECUC_DEFINITION_ELEMENT = "ECUC-DEFINITION-ELEMENT"
    ECUC_DESTINATION_URI_DEF = "ECUC-DESTINATION-URI-DEF"
    ECUC_DESTINATION_URI_DEF_SET = "ECUC-DESTINATION-URI-DEF-SET"
    ECUC_ENUMERATION_LITERAL_DEF = "ECUC-ENUMERATION-LITERAL-DEF"
    ECUC_ENUMERATION_PARAM_DEF = "ECUC-ENUMERATION-PARAM-DEF"
    ECUC_FLOAT_PARAM_DEF = "ECUC-FLOAT-PARAM-DEF"
    ECUC_FOREIGN_REFERENCE_DEF = "ECUC-FOREIGN-REFERENCE-DEF"
    ECUC_FUNCTION_NAME_DEF = "ECUC-FUNCTION-NAME-DEF"
    ECUC_INSTANCE_REFERENCE_DEF = "ECUC-INSTANCE-REFERENCE-DEF"
    ECUC_INTEGER_PARAM_DEF = "ECUC-INTEGER-PARAM-DEF"
    ECUC_LINKER_SYMBOL_DEF = "ECUC-LINKER-SYMBOL-DEF"
    ECUC_MODULE_CONFIGURATION_VALUES = "ECUC-MODULE-CONFIGURATION-VALUES"
    ECUC_MODULE_DEF = "ECUC-MODULE-DEF"
    ECUC_MULTILINE_STRING_PARAM_DEF = "ECUC-MULTILINE-STRING-PARAM-DEF"
    ECUC_PARAM_CONF_CONTAINER_DEF = "ECUC-PARAM-CONF-CONTAINER-DEF"
    ECUC_PARAMETER_DEF = "ECUC-PARAMETER-DEF"
    ECUC_QUERY = "ECUC-QUERY"
    ECUC_REFERENCE_DEF = "ECUC-REFERENCE-DEF"
    ECUC_STRING_PARAM_DEF = "ECUC-STRING-PARAM-DEF"
    ECUC_SYMBOLIC_NAME_REFERENCE_DEF = "ECUC-SYMBOLIC-NAME-REFERENCE-DEF"
    ECUC_URI_REFERENCE_DEF = "ECUC-URI-REFERENCE-DEF"
    ECUC_VALIDATION_CONDITION = "ECUC-VALIDATION-CONDITION"
    ECUC_VALUE_COLLECTION = "ECUC-VALUE-COLLECTION"
    END_2_END_EVENT_PROTECTION_PROPS = "END-2-END-EVENT-PROTECTION-PROPS"
    END_2_END_METHOD_PROTECTION_PROPS = "END-2-END-METHOD-PROTECTION-PROPS"
    END_TO_END_PROTECTION = "END-TO-END-PROTECTION"
    END_TO_END_PROTECTION_SET = "END-TO-END-PROTECTION-SET"
    ENUMERATION_MAPPING_TABLE = "ENUMERATION-MAPPING-TABLE"
    EOC_EVENT_REF = "EOC-EVENT-REF"
    EOC_EXECUTABLE_ENTITY_REF = "EOC-EXECUTABLE-ENTITY-REF"
    EOC_EXECUTABLE_ENTITY_REF_ABSTRACT = "EOC-EXECUTABLE-ENTITY-REF-ABSTRACT"
    EOC_EXECUTABLE_ENTITY_REF_GROUP = "EOC-EXECUTABLE-ENTITY-REF-GROUP"
    ERROR_TRACER_NEEDS = "ERROR-TRACER-NEEDS"
    ETH_IP_PROPS = "ETH-IP-PROPS"
    ETH_TCP_IP_ICMP_PROPS = "ETH-TCP-IP-ICMP-PROPS"
    ETH_TCP_IP_PROPS = "ETH-TCP-IP-PROPS"
    ETH_TP_CONFIG = "ETH-TP-CONFIG"
    ETHERNET_CLUSTER = "ETHERNET-CLUSTER"
    ETHERNET_COMMUNICATION_CONNECTOR = "ETHERNET-COMMUNICATION-CONNECTOR"
    ETHERNET_COMMUNICATION_CONTROLLER = "ETHERNET-COMMUNICATION-CONTROLLER"
    ETHERNET_FRAME = "ETHERNET-FRAME"
    ETHERNET_FRAME_TRIGGERING = "ETHERNET-FRAME-TRIGGERING"
    ETHERNET_PHYSICAL_CHANNEL = "ETHERNET-PHYSICAL-CHANNEL"
    ETHERNET_PRIORITY_REGENERATION = "ETHERNET-PRIORITY-REGENERATION"
    ETHERNET_RAW_DATA_STREAM_CLIENT_MAPPING = "ETHERNET-RAW-DATA-STREAM-CLIENT-MAPPING"
    ETHERNET_RAW_DATA_STREAM_GRANT = "ETHERNET-RAW-DATA-STREAM-GRANT"
    ETHERNET_RAW_DATA_STREAM_MAPPING = "ETHERNET-RAW-DATA-STREAM-MAPPING"
    ETHERNET_RAW_DATA_STREAM_SERVER_MAPPING = "ETHERNET-RAW-DATA-STREAM-SERVER-MAPPING"
    ETHERNET_WAKEUP_SLEEP_ON_DATALINE_CONFIG = "ETHERNET-WAKEUP-SLEEP-ON-DATALINE-CONFIG"
    ETHERNET_WAKEUP_SLEEP_ON_DATALINE_CONFIG_SET = "ETHERNET-WAKEUP-SLEEP-ON-DATALINE-CONFIG-SET"
    EVALUATED_VARIANT_SET = "EVALUATED-VARIANT-SET"
    EVENT_HANDLER = "EVENT-HANDLER"
    EVENT_MAPPING = "EVENT-MAPPING"
    EVENT_TRIGGERING_CONSTRAINT = "EVENT-TRIGGERING-CONSTRAINT"
    EXCLUSIVE_AREA = "EXCLUSIVE-AREA"
    EXCLUSIVE_AREA_NESTING_ORDER = "EXCLUSIVE-AREA-NESTING-ORDER"
    EXECUTABLE = "EXECUTABLE"
    EXECUTABLE_ENTITY = "EXECUTABLE-ENTITY"
    EXECUTABLE_ENTITY_ACTIVATION_REASON = "EXECUTABLE-ENTITY-ACTIVATION-REASON"
    EXECUTABLE_TIMING = "EXECUTABLE-TIMING"
    EXECUTION_ORDER_CONSTRAINT = "EXECUTION-ORDER-CONSTRAINT"
    EXECUTION_TIME = "EXECUTION-TIME"
    EXECUTION_TIME_CONSTRAINT = "EXECUTION-TIME-CONSTRAINT"
    EXTERNAL_TRIGGER_OCCURRED_EVENT = "EXTERNAL-TRIGGER-OCCURRED-EVENT"
    EXTERNAL_TRIGGERING_POINT_IDENT = "EXTERNAL-TRIGGERING-POINT-IDENT"
    FIBEX_ELEMENT = "FIBEX-ELEMENT"
    FIELD = "FIELD"
    FIELD_MAPPING = "FIELD-MAPPING"
    FIRE_AND_FORGET_METHOD_MAPPING = "FIRE-AND-FORGET-METHOD-MAPPING"
    FIREWALL_RULE = "FIREWALL-RULE"
    FIREWALL_STATE_SWITCH_INTERFACE = "FIREWALL-STATE-SWITCH-INTERFACE"
    FLAT_INSTANCE_DESCRIPTOR = "FLAT-INSTANCE-DESCRIPTOR"
    FLAT_MAP = "FLAT-MAP"
    FLEXRAY_AR_TP_CONFIG = "FLEXRAY-AR-TP-CONFIG"
    FLEXRAY_AR_TP_NODE = "FLEXRAY-AR-TP-NODE"
    FLEXRAY_CLUSTER = "FLEXRAY-CLUSTER"
    FLEXRAY_COMMUNICATION_CONNECTOR = "FLEXRAY-COMMUNICATION-CONNECTOR"
    FLEXRAY_COMMUNICATION_CONTROLLER = "FLEXRAY-COMMUNICATION-CONTROLLER"
    FLEXRAY_FRAME = "FLEXRAY-FRAME"
    FLEXRAY_FRAME_TRIGGERING = "FLEXRAY-FRAME-TRIGGERING"
    FLEXRAY_NM_CLUSTER = "FLEXRAY-NM-CLUSTER"
    FLEXRAY_NM_NODE = "FLEXRAY-NM-NODE"
    FLEXRAY_PHYSICAL_CHANNEL = "FLEXRAY-PHYSICAL-CHANNEL"
    FLEXRAY_TP_CONFIG = "FLEXRAY-TP-CONFIG"
    FLEXRAY_TP_CONNECTION_CONTROL = "FLEXRAY-TP-CONNECTION-CONTROL"
    FLEXRAY_TP_NODE = "FLEXRAY-TP-NODE"
    FLEXRAY_TP_PDU_POOL = "FLEXRAY-TP-PDU-POOL"
    FM_ATTRIBUTE_DEF = "FM-ATTRIBUTE-DEF"
    FM_FEATURE = "FM-FEATURE"
    FM_FEATURE_MAP = "FM-FEATURE-MAP"
    FM_FEATURE_MAP_ASSERTION = "FM-FEATURE-MAP-ASSERTION"
    FM_FEATURE_MAP_CONDITION = "FM-FEATURE-MAP-CONDITION"
    FM_FEATURE_MAP_ELEMENT = "FM-FEATURE-MAP-ELEMENT"
    FM_FEATURE_MODEL = "FM-FEATURE-MODEL"
    FM_FEATURE_RELATION = "FM-FEATURE-RELATION"
    FM_FEATURE_RESTRICTION = "FM-FEATURE-RESTRICTION"
    FM_FEATURE_SELECTION = "FM-FEATURE-SELECTION"
    FM_FEATURE_SELECTION_SET = "FM-FEATURE-SELECTION-SET"
    FRAME = "FRAME"
    FRAME_PORT = "FRAME-PORT"
    FRAME_TRIGGERING = "FRAME-TRIGGERING"
    FUNCTION_GROUP_SET = "FUNCTION-GROUP-SET"
    FUNCTION_INHIBITION_AVAILABILITY_NEEDS = "FUNCTION-INHIBITION-AVAILABILITY-NEEDS"
    FUNCTION_INHIBITION_NEEDS = "FUNCTION-INHIBITION-NEEDS"
    FUNCTIONAL_CLUSTER_INTERACTS_WITH_FUNCTIONAL_CLUSTER_MAPPING = (
        "FUNCTIONAL-CLUSTER-INTERACTS-WITH-FUNCTIONAL-CLUSTER-MAPPING"
    )
    FUNCTIONAL_CLUSTER_INTERACTS_WITH_PERSISTENCY_DEPLOYMENT_MAPPING = (
        "FUNCTIONAL-CLUSTER-INTERACTS-WITH-PERSISTENCY-DEPLOYMENT-MAPPING"
    )
    FURTHER_ACTION_BYTE_NEEDS = "FURTHER-ACTION-BYTE-NEEDS"
    GATEWAY = "GATEWAY"
    GENERAL_PARAMETER = "GENERAL-PARAMETER"
    GENERAL_PURPOSE_CONNECTION = "GENERAL-PURPOSE-CONNECTION"
    GENERAL_PURPOSE_I_PDU = "GENERAL-PURPOSE-I-PDU"
    GENERAL_PURPOSE_PDU = "GENERAL-PURPOSE-PDU"
    GENERIC_ETHERNET_FRAME = "GENERIC-ETHERNET-FRAME"
    GENERIC_MODULE_INSTANTIATION = "GENERIC-MODULE-INSTANTIATION"
    GLOBAL_SUPERVISION = "GLOBAL-SUPERVISION"
    GLOBAL_SUPERVISION_NEEDS = "GLOBAL-SUPERVISION-NEEDS"
    GLOBAL_TIME_CAN_MASTER = "GLOBAL-TIME-CAN-MASTER"
    GLOBAL_TIME_CAN_SLAVE = "GLOBAL-TIME-CAN-SLAVE"
    GLOBAL_TIME_DOMAIN = "GLOBAL-TIME-DOMAIN"
    GLOBAL_TIME_ETH_MASTER = "GLOBAL-TIME-ETH-MASTER"
    GLOBAL_TIME_ETH_SLAVE = "GLOBAL-TIME-ETH-SLAVE"
    GLOBAL_TIME_FR_MASTER = "GLOBAL-TIME-FR-MASTER"
    GLOBAL_TIME_FR_SLAVE = "GLOBAL-TIME-FR-SLAVE"
    GLOBAL_TIME_GATEWAY = "GLOBAL-TIME-GATEWAY"
    GLOBAL_TIME_MASTER = "GLOBAL-TIME-MASTER"
    GLOBAL_TIME_SLAVE = "GLOBAL-TIME-SLAVE"
    GRANT = "GRANT"
    GRANT_DESIGN = "GRANT-DESIGN"
    HARDWARE_TEST_NEEDS = "HARDWARE-TEST-NEEDS"
    HEALTH_CHANNEL = "HEALTH-CHANNEL"
    HEALTH_CHANNEL_EXTERNAL_STATUS = "HEALTH-CHANNEL-EXTERNAL-STATUS"
    HEALTH_CHANNEL_SUPERVISION = "HEALTH-CHANNEL-SUPERVISION"
    HEAP_USAGE = "HEAP-USAGE"
    HW_ATTRIBUTE_DEF = "HW-ATTRIBUTE-DEF"
    HW_ATTRIBUTE_LITERAL_DEF = "HW-ATTRIBUTE-LITERAL-DEF"
    HW_CATEGORY = "HW-CATEGORY"
    HW_DESCRIPTION_ENTITY = "HW-DESCRIPTION-ENTITY"
    HW_ELEMENT = "HW-ELEMENT"
    HW_PIN = "HW-PIN"
    HW_PIN_GROUP = "HW-PIN-GROUP"
    HW_TYPE = "HW-TYPE"
    I_PDU = "I-PDU"
    I_PDU_PORT = "I-PDU-PORT"
    I_PV_6_EXT_HEADER_FILTER_LIST = "I-PV-6-EXT-HEADER-FILTER-LIST"
    I_PV_6_EXT_HEADER_FILTER_SET = "I-PV-6-EXT-HEADER-FILTER-SET"
    I_SIGNAL = "I-SIGNAL"
    I_SIGNAL_GROUP = "I-SIGNAL-GROUP"
    I_SIGNAL_I_PDU = "I-SIGNAL-I-PDU"
    I_SIGNAL_I_PDU_GROUP = "I-SIGNAL-I-PDU-GROUP"
    I_SIGNAL_PORT = "I-SIGNAL-PORT"
    I_SIGNAL_TO_I_PDU_MAPPING = "I-SIGNAL-TO-I-PDU-MAPPING"
    I_SIGNAL_TRIGGERING = "I-SIGNAL-TRIGGERING"
    IAM_MODULE_INSTANTIATION = "IAM-MODULE-INSTANTIATION"
    IDENT_CAPTION = "IDENT-CAPTION"
    IDENTIFIABLE = "IDENTIFIABLE"
    IDS_COMMON_ELEMENT = "IDS-COMMON-ELEMENT"
    IDS_DESIGN = "IDS-DESIGN"
    IDS_MAPPING = "IDS-MAPPING"
    IDS_MGR_CUSTOM_TIMESTAMP_NEEDS = "IDS-MGR-CUSTOM-TIMESTAMP-NEEDS"
    IDS_MGR_NEEDS = "IDS-MGR-NEEDS"
    IDS_PLATFORM_INSTANTIATION = "IDS-PLATFORM-INSTANTIATION"
    IDSM_INSTANCE = "IDSM-INSTANCE"
    IDSM_MODULE_INSTANTIATION = "IDSM-MODULE-INSTANTIATION"
    IDSM_PROPERTIES = "IDSM-PROPERTIES"
    IDSM_RATE_LIMITATION = "IDSM-RATE-LIMITATION"
    IDSM_TRAFFIC_LIMITATION = "IDSM-TRAFFIC-LIMITATION"
    IEEE_1722_TP_ETHERNET_FRAME = "IEEE-1722-TP-ETHERNET-FRAME"
    IMPLEMENTATION = "IMPLEMENTATION"
    IMPLEMENTATION_DATA_TYPE = "IMPLEMENTATION-DATA-TYPE"
    IMPLEMENTATION_DATA_TYPE_ELEMENT = "IMPLEMENTATION-DATA-TYPE-ELEMENT"
    IMPLEMENTATION_PROPS = "IMPLEMENTATION-PROPS"
    INDICATOR_STATUS_NEEDS = "INDICATOR-STATUS-NEEDS"
    INIT_EVENT = "INIT-EVENT"
    INTERFACE_MAPPING = "INTERFACE-MAPPING"
    INTERNAL_BEHAVIOR = "INTERNAL-BEHAVIOR"
    INTERNAL_TRIGGER_OCCURRED_EVENT = "INTERNAL-TRIGGER-OCCURRED-EVENT"
    INTERNAL_TRIGGERING_POINT = "INTERNAL-TRIGGERING-POINT"
    INTERPOLATION_ROUTINE_MAPPING_SET = "INTERPOLATION-ROUTINE-MAPPING-SET"
    IP_IAM_REMOTE_SUBJECT = "IP-IAM-REMOTE-SUBJECT"
    IP_SEC_CONFIG_PROPS = "IP-SEC-CONFIG-PROPS"
    IP_SEC_IAM_REMOTE_SUBJECT = "IP-SEC-IAM-REMOTE-SUBJECT"
    IP_SEC_RULE = "IP-SEC-RULE"
    J_1939_CLUSTER = "J-1939-CLUSTER"
    J_1939_CONTROLLER_APPLICATION = "J-1939-CONTROLLER-APPLICATION"
    J_1939_DCM_DM_19_SUPPORT = "J-1939-DCM-DM-19-SUPPORT"
    J_1939_DCM_I_PDU = "J-1939-DCM-I-PDU"
    J_1939_NM_CLUSTER = "J-1939-NM-CLUSTER"
    J_1939_NM_NODE = "J-1939-NM-NODE"
    J_1939_RM_INCOMING_REQUEST_SERVICE_NEEDS = "J-1939-RM-INCOMING-REQUEST-SERVICE-NEEDS"
    J_1939_RM_OUTGOING_REQUEST_SERVICE_NEEDS = "J-1939-RM-OUTGOING-REQUEST-SERVICE-NEEDS"
    J_1939_SHARED_ADDRESS_CLUSTER = "J-1939-SHARED-ADDRESS-CLUSTER"
    J_1939_TP_CONFIG = "J-1939-TP-CONFIG"
    J_1939_TP_NODE = "J-1939-TP-NODE"
    KEYWORD = "KEYWORD"
    KEYWORD_SET = "KEYWORD-SET"
    LATENCY_TIMING_CONSTRAINT = "LATENCY-TIMING-CONSTRAINT"
    LIFE_CYCLE_INFO_SET = "LIFE-CYCLE-INFO-SET"
    LIFE_CYCLE_STATE = "LIFE-CYCLE-STATE"
    LIFE_CYCLE_STATE_DEFINITION_GROUP = "LIFE-CYCLE-STATE-DEFINITION-GROUP"
    LIN_CLUSTER = "LIN-CLUSTER"
    LIN_COMMUNICATION_CONNECTOR = "LIN-COMMUNICATION-CONNECTOR"
    LIN_COMMUNICATION_CONTROLLER = "LIN-COMMUNICATION-CONTROLLER"
    LIN_EVENT_TRIGGERED_FRAME = "LIN-EVENT-TRIGGERED-FRAME"
    LIN_FRAME = "LIN-FRAME"
    LIN_FRAME_TRIGGERING = "LIN-FRAME-TRIGGERING"
    LIN_MASTER = "LIN-MASTER"
    LIN_NM_CLUSTER = "LIN-NM-CLUSTER"
    LIN_PHYSICAL_CHANNEL = "LIN-PHYSICAL-CHANNEL"
    LIN_SCHEDULE_TABLE = "LIN-SCHEDULE-TABLE"
    LIN_SLAVE = "LIN-SLAVE"
    LIN_SLAVE_CONFIG_IDENT = "LIN-SLAVE-CONFIG-IDENT"
    LIN_SPORADIC_FRAME = "LIN-SPORADIC-FRAME"
    LIN_TP_CONFIG = "LIN-TP-CONFIG"
    LIN_TP_NODE = "LIN-TP-NODE"
    LIN_UNCONDITIONAL_FRAME = "LIN-UNCONDITIONAL-FRAME"
    LINKER = "LINKER"
    LOG_AND_TRACE_INSTANTIATION = "LOG-AND-TRACE-INSTANTIATION"
    LOG_AND_TRACE_INTERFACE = "LOG-AND-TRACE-INTERFACE"
    LOG_AND_TRACE_MESSAGE_COLLECTION_SET = "LOG-AND-TRACE-MESSAGE-COLLECTION-SET"
    LOGIC_ADDRESS = "LOGIC-ADDRESS"
    LOGICAL_SUPERVISION = "LOGICAL-SUPERVISION"
    LT_MESSAGE_COLLECTION_TO_PORT_PROTOTYPE_MAPPING = (
        "LT-MESSAGE-COLLECTION-TO-PORT-PROTOTYPE-MAPPING"
    )
    MAC_MULTICAST_GROUP = "MAC-MULTICAST-GROUP"
    MAC_SEC_GLOBAL_KAY_PROPS = "MAC-SEC-GLOBAL-KAY-PROPS"
    MAC_SEC_KAY_PARTICIPANT = "MAC-SEC-KAY-PARTICIPANT"
    MAC_SEC_PARTICIPANT_SET = "MAC-SEC-PARTICIPANT-SET"
    MACHINE = "MACHINE"
    MACHINE_DESIGN = "MACHINE-DESIGN"
    MACHINE_TIMING = "MACHINE-TIMING"
    MC_DATA_INSTANCE = "MC-DATA-INSTANCE"
    MC_FUNCTION = "MC-FUNCTION"
    MC_GROUP = "MC-GROUP"
    MEASURED_EXECUTION_TIME = "MEASURED-EXECUTION-TIME"
    MEASURED_HEAP_USAGE = "MEASURED-HEAP-USAGE"
    MEASURED_STACK_USAGE = "MEASURED-STACK-USAGE"
    MEMORY_SECTION = "MEMORY-SECTION"
    MEMORY_USAGE = "MEMORY-USAGE"
    METHOD_MAPPING = "METHOD-MAPPING"
    MODE_ACCESS_POINT_IDENT = "MODE-ACCESS-POINT-IDENT"
    MODE_DECLARATION = "MODE-DECLARATION"
    MODE_DECLARATION_GROUP = "MODE-DECLARATION-GROUP"
    MODE_DECLARATION_GROUP_PROTOTYPE = "MODE-DECLARATION-GROUP-PROTOTYPE"
    MODE_DECLARATION_MAPPING = "MODE-DECLARATION-MAPPING"
    MODE_DECLARATION_MAPPING_SET = "MODE-DECLARATION-MAPPING-SET"
    MODE_INTERFACE_MAPPING = "MODE-INTERFACE-MAPPING"
    MODE_SWITCH_INTERFACE = "MODE-SWITCH-INTERFACE"
    MODE_SWITCH_POINT = "MODE-SWITCH-POINT"
    MODE_SWITCHED_ACK_EVENT = "MODE-SWITCHED-ACK-EVENT"
    MODE_TRANSITION = "MODE-TRANSITION"
    MULTILANGUAGE_REFERRABLE = "MULTILANGUAGE-REFERRABLE"
    MULTIPLEXED_I_PDU = "MULTIPLEXED-I-PDU"
    N_PDU = "N-PDU"
    NETWORK_ENDPOINT = "NETWORK-ENDPOINT"
    NM_CLUSTER = "NM-CLUSTER"
    NM_CONFIG = "NM-CONFIG"
    NM_ECU = "NM-ECU"
    NM_HANDLE_TO_FUNCTION_GROUP_STATE_MAPPING = "NM-HANDLE-TO-FUNCTION-GROUP-STATE-MAPPING"
    NM_INSTANTIATION = "NM-INSTANTIATION"
    NM_NETWORK_HANDLE = "NM-NETWORK-HANDLE"
    NM_NODE = "NM-NODE"
    NM_PDU = "NM-PDU"
    NO_CHECKPOINT_SUPERVISION = "NO-CHECKPOINT-SUPERVISION"
    NO_SUPERVISION = "NO-SUPERVISION"
    NON_OS_MODULE_INSTANTIATION = "NON-OS-MODULE-INSTANTIATION"
    NV_BLOCK_DESCRIPTOR = "NV-BLOCK-DESCRIPTOR"
    NV_BLOCK_NEEDS = "NV-BLOCK-NEEDS"
    NV_BLOCK_SW_COMPONENT_TYPE = "NV-BLOCK-SW-COMPONENT-TYPE"
    NV_DATA_INTERFACE = "NV-DATA-INTERFACE"
    OBD_CONTROL_SERVICE_NEEDS = "OBD-CONTROL-SERVICE-NEEDS"
    OBD_INFO_SERVICE_NEEDS = "OBD-INFO-SERVICE-NEEDS"
    OBD_MONITOR_SERVICE_NEEDS = "OBD-MONITOR-SERVICE-NEEDS"
    OBD_PID_SERVICE_NEEDS = "OBD-PID-SERVICE-NEEDS"
    OBD_RATIO_DENOMINATOR_NEEDS = "OBD-RATIO-DENOMINATOR-NEEDS"
    OBD_RATIO_SERVICE_NEEDS = "OBD-RATIO-SERVICE-NEEDS"
    OFFSET_TIMING_CONSTRAINT = "OFFSET-TIMING-CONSTRAINT"
    OPERATION_INVOKED_EVENT = "OPERATION-INVOKED-EVENT"
    OS_MODULE_INSTANTIATION = "OS-MODULE-INSTANTIATION"
    OS_TASK_EXECUTION_EVENT = "OS-TASK-EXECUTION-EVENT"
    OS_TASK_PROXY = "OS-TASK-PROXY"
    P_PORT_PROTOTYPE = "P-PORT-PROTOTYPE"
    PACKAGEABLE_ELEMENT = "PACKAGEABLE-ELEMENT"
    PARAMETER_ACCESS = "PARAMETER-ACCESS"
    PARAMETER_DATA_PROTOTYPE = "PARAMETER-DATA-PROTOTYPE"
    PARAMETER_INTERFACE = "PARAMETER-INTERFACE"
    PARAMETER_SW_COMPONENT_TYPE = "PARAMETER-SW-COMPONENT-TYPE"
    PASS_THROUGH_SW_CONNECTOR = "PASS-THROUGH-SW-CONNECTOR"
    PDU = "PDU"
    PDU_ACTIVATION_ROUTING_GROUP = "PDU-ACTIVATION-ROUTING-GROUP"
    PDU_TO_FRAME_MAPPING = "PDU-TO-FRAME-MAPPING"
    PDU_TRIGGERING = "PDU-TRIGGERING"
    PDUR_I_PDU_GROUP = "PDUR-I-PDU-GROUP"
    PER_INSTANCE_MEMORY = "PER-INSTANCE-MEMORY"
    PERIODIC_EVENT_TRIGGERING = "PERIODIC-EVENT-TRIGGERING"
    PERSISTENCY_DATA_ELEMENT = "PERSISTENCY-DATA-ELEMENT"
    PERSISTENCY_DEPLOYMENT = "PERSISTENCY-DEPLOYMENT"
    PERSISTENCY_DEPLOYMENT_ELEMENT = "PERSISTENCY-DEPLOYMENT-ELEMENT"
    PERSISTENCY_DEPLOYMENT_ELEMENT_TO_CRYPTO_KEY_SLOT_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-ELEMENT-TO-CRYPTO-KEY-SLOT-MAPPING"
    )
    PERSISTENCY_DEPLOYMENT_TO_CRYPTO_KEY_SLOT_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-TO-CRYPTO-KEY-SLOT-MAPPING"
    )
    PERSISTENCY_DEPLOYMENT_TO_DLT_LOG_SINK_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-TO-DLT-LOG-SINK-MAPPING"
    )
    PERSISTENCY_FILE = "PERSISTENCY-FILE"
    PERSISTENCY_FILE_ELEMENT = "PERSISTENCY-FILE-ELEMENT"
    PERSISTENCY_FILE_STORAGE = "PERSISTENCY-FILE-STORAGE"
    PERSISTENCY_FILE_STORAGE_INTERFACE = "PERSISTENCY-FILE-STORAGE-INTERFACE"
    PERSISTENCY_INTERFACE = "PERSISTENCY-INTERFACE"
    PERSISTENCY_INTERFACE_ELEMENT = "PERSISTENCY-INTERFACE-ELEMENT"
    PERSISTENCY_KEY_VALUE_PAIR = "PERSISTENCY-KEY-VALUE-PAIR"
    PERSISTENCY_KEY_VALUE_STORAGE = "PERSISTENCY-KEY-VALUE-STORAGE"
    PERSISTENCY_KEY_VALUE_STORAGE_INTERFACE = "PERSISTENCY-KEY-VALUE-STORAGE-INTERFACE"
    PERSISTENCY_PORT_PROTOTYPE_TO_DEPLOYMENT_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-DEPLOYMENT-MAPPING"
    )
    PERSISTENCY_PORT_PROTOTYPE_TO_FILE_STORAGE_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-FILE-STORAGE-MAPPING"
    )
    PERSISTENCY_PORT_PROTOTYPE_TO_KEY_VALUE_STORAGE_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-KEY-VALUE-STORAGE-MAPPING"
    )
    PHM_ABSTRACT_RECOVERY_NOTIFICATION_INTERFACE = "PHM-ABSTRACT-RECOVERY-NOTIFICATION-INTERFACE"
    PHM_CHECKPOINT = "PHM-CHECKPOINT"
    PHM_CONTRIBUTION_TO_MACHINE_MAPPING = "PHM-CONTRIBUTION-TO-MACHINE-MAPPING"
    PHM_HEALTH_CHANNEL_INTERFACE = "PHM-HEALTH-CHANNEL-INTERFACE"
    PHM_HEALTH_CHANNEL_RECOVERY_NOTIFICATION_INTERFACE = (
        "PHM-HEALTH-CHANNEL-RECOVERY-NOTIFICATION-INTERFACE"
    )
    PHM_HEALTH_CHANNEL_STATUS = "PHM-HEALTH-CHANNEL-STATUS"
    PHM_RECOVERY_ACTION_INTERFACE = "PHM-RECOVERY-ACTION-INTERFACE"
    PHM_SUPERVISED_ENTITY_INTERFACE = "PHM-SUPERVISED-ENTITY-INTERFACE"
    PHM_SUPERVISION = "PHM-SUPERVISION"
    PHM_SUPERVISION_RECOVERY_NOTIFICATION_INTERFACE = (
        "PHM-SUPERVISION-RECOVERY-NOTIFICATION-INTERFACE"
    )
    PHYSICAL_CHANNEL = "PHYSICAL-CHANNEL"
    PHYSICAL_DIMENSION = "PHYSICAL-DIMENSION"
    PHYSICAL_DIMENSION_MAPPING_SET = "PHYSICAL-DIMENSION-MAPPING-SET"
    PLATFORM_HEALTH_MANAGEMENT_CONTRIBUTION = "PLATFORM-HEALTH-MANAGEMENT-CONTRIBUTION"
    PLATFORM_HEALTH_MANAGEMENT_INTERFACE = "PLATFORM-HEALTH-MANAGEMENT-INTERFACE"
    PLATFORM_MODULE_ENDPOINT_CONFIGURATION = "PLATFORM-MODULE-ENDPOINT-CONFIGURATION"
    PLATFORM_MODULE_ETHERNET_ENDPOINT_CONFIGURATION = (
        "PLATFORM-MODULE-ETHERNET-ENDPOINT-CONFIGURATION"
    )
    PNC_MAPPING_IDENT = "PNC-MAPPING-IDENT"
    PORT_ELEMENT_TO_COMMUNICATION_RESOURCE_MAPPING = (
        "PORT-ELEMENT-TO-COMMUNICATION-RESOURCE-MAPPING"
    )
    PORT_GROUP = "PORT-GROUP"
    PORT_INTERFACE = "PORT-INTERFACE"
    PORT_INTERFACE_MAPPING = "PORT-INTERFACE-MAPPING"
    PORT_INTERFACE_MAPPING_SET = "PORT-INTERFACE-MAPPING-SET"
    PORT_INTERFACE_TO_DATA_TYPE_MAPPING = "PORT-INTERFACE-TO-DATA-TYPE-MAPPING"
    PORT_PROTOTYPE = "PORT-PROTOTYPE"
    PORT_PROTOTYPE_BLUEPRINT = "PORT-PROTOTYPE-BLUEPRINT"
    POSSIBLE_ERROR_REACTION = "POSSIBLE-ERROR-REACTION"
    POST_BUILD_VARIANT_CRITERION = "POST-BUILD-VARIANT-CRITERION"
    POST_BUILD_VARIANT_CRITERION_VALUE_SET = "POST-BUILD-VARIANT-CRITERION-VALUE-SET"
    PR_PORT_PROTOTYPE = "PR-PORT-PROTOTYPE"
    PREDEFINED_VARIANT = "PREDEFINED-VARIANT"
    PRIMITIVE_ATTRIBUTE_TAILORING = "PRIMITIVE-ATTRIBUTE-TAILORING"
    PROCESS = "PROCESS"
    PROCESS_DESIGN = "PROCESS-DESIGN"
    PROCESS_DESIGN_TO_MACHINE_DESIGN_MAPPING = "PROCESS-DESIGN-TO-MACHINE-DESIGN-MAPPING"
    PROCESS_EXECUTION_ERROR = "PROCESS-EXECUTION-ERROR"
    PROCESS_TO_MACHINE_MAPPING = "PROCESS-TO-MACHINE-MAPPING"
    PROCESS_TO_MACHINE_MAPPING_SET = "PROCESS-TO-MACHINE-MAPPING-SET"
    PROCESSOR = "PROCESSOR"
    PROCESSOR_CORE = "PROCESSOR-CORE"
    PROVIDED_AP_SERVICE_INSTANCE = "PROVIDED-AP-SERVICE-INSTANCE"
    PROVIDED_SERVICE_INSTANCE = "PROVIDED-SERVICE-INSTANCE"
    PROVIDED_SERVICE_INSTANCE_TO_SW_CLUSTER_DESIGN_P_PORT_PROTOTYPE_MAPPING = (
        "PROVIDED-SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-P-PORT-PROTOTYPE-MAPPING"
    )
    PROVIDED_SOMEIP_SERVICE_INSTANCE = "PROVIDED-SOMEIP-SERVICE-INSTANCE"
    PROVIDED_USER_DEFINED_SERVICE_INSTANCE = "PROVIDED-USER-DEFINED-SERVICE-INSTANCE"
    PSK_IDENTITY_TO_KEY_SLOT_MAPPING = "PSK-IDENTITY-TO-KEY-SLOT-MAPPING"
    R_PORT_PROTOTYPE = "R-PORT-PROTOTYPE"
    RAPID_PROTOTYPING_SCENARIO = "RAPID-PROTOTYPING-SCENARIO"
    RAW_DATA_STREAM_CLIENT_INTERFACE = "RAW-DATA-STREAM-CLIENT-INTERFACE"
    RAW_DATA_STREAM_DEPLOYMENT = "RAW-DATA-STREAM-DEPLOYMENT"
    RAW_DATA_STREAM_GRANT = "RAW-DATA-STREAM-GRANT"
    RAW_DATA_STREAM_GRANT_DESIGN = "RAW-DATA-STREAM-GRANT-DESIGN"
    RAW_DATA_STREAM_MAPPING = "RAW-DATA-STREAM-MAPPING"
    RAW_DATA_STREAM_SERVER_INTERFACE = "RAW-DATA-STREAM-SERVER-INTERFACE"
    RECOVERY_NOTIFICATION = "RECOVERY-NOTIFICATION"
    RECOVERY_NOTIFICATION_TO_P_PORT_PROTOTYPE_MAPPING = (
        "RECOVERY-NOTIFICATION-TO-P-PORT-PROTOTYPE-MAPPING"
    )
    REFERENCE_TAILORING = "REFERENCE-TAILORING"
    REFERRABLE = "REFERRABLE"
    REQUIRED_AP_SERVICE_INSTANCE = "REQUIRED-AP-SERVICE-INSTANCE"
    REQUIRED_SERVICE_INSTANCE_TO_SW_CLUSTER_DESIGN_R_PORT_PROTOTYPE_MAPPING = (
        "REQUIRED-SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-R-PORT-PROTOTYPE-MAPPING"
    )
    REQUIRED_SOMEIP_SERVICE_INSTANCE = "REQUIRED-SOMEIP-SERVICE-INSTANCE"
    REQUIRED_USER_DEFINED_SERVICE_INSTANCE = "REQUIRED-USER-DEFINED-SERVICE-INSTANCE"
    RESOURCE_CONSUMPTION = "RESOURCE-CONSUMPTION"
    RESOURCE_GROUP = "RESOURCE-GROUP"
    ROOT_SW_CLUSTER_DESIGN_COMPONENT_PROTOTYPE = "ROOT-SW-CLUSTER-DESIGN-COMPONENT-PROTOTYPE"
    ROOT_SW_COMPONENT_PROTOTYPE = "ROOT-SW-COMPONENT-PROTOTYPE"
    ROOT_SW_COMPOSITION_PROTOTYPE = "ROOT-SW-COMPOSITION-PROTOTYPE"
    ROUGH_ESTIMATE_HEAP_USAGE = "ROUGH-ESTIMATE-HEAP-USAGE"
    ROUGH_ESTIMATE_OF_EXECUTION_TIME = "ROUGH-ESTIMATE-OF-EXECUTION-TIME"
    ROUGH_ESTIMATE_STACK_USAGE = "ROUGH-ESTIMATE-STACK-USAGE"
    RPT_COMPONENT = "RPT-COMPONENT"
    RPT_CONTAINER = "RPT-CONTAINER"
    RPT_EXECUTABLE_ENTITY = "RPT-EXECUTABLE-ENTITY"
    RPT_EXECUTABLE_ENTITY_EVENT = "RPT-EXECUTABLE-ENTITY-EVENT"
    RPT_EXECUTION_CONTEXT = "RPT-EXECUTION-CONTEXT"
    RPT_PROFILE = "RPT-PROFILE"
    RPT_SERVICE_POINT = "RPT-SERVICE-POINT"
    RTE_EVENT = "RTE-EVENT"
    RTE_EVENT_IN_COMPOSITION_SEPARATION = "RTE-EVENT-IN-COMPOSITION-SEPARATION"
    RTE_EVENT_IN_COMPOSITION_TO_OS_TASK_PROXY_MAPPING = (
        "RTE-EVENT-IN-COMPOSITION-TO-OS-TASK-PROXY-MAPPING"
    )
    RTE_EVENT_IN_SYSTEM_SEPARATION = "RTE-EVENT-IN-SYSTEM-SEPARATION"
    RTE_EVENT_IN_SYSTEM_TO_OS_TASK_PROXY_MAPPING = "RTE-EVENT-IN-SYSTEM-TO-OS-TASK-PROXY-MAPPING"
    RUNNABLE_ENTITY = "RUNNABLE-ENTITY"
    RUNNABLE_ENTITY_GROUP = "RUNNABLE-ENTITY-GROUP"
    RUNTIME_ERROR = "RUNTIME-ERROR"
    SDG_ABSTRACT_FOREIGN_REFERENCE = "SDG-ABSTRACT-FOREIGN-REFERENCE"
    SDG_ABSTRACT_PRIMITIVE_ATTRIBUTE = "SDG-ABSTRACT-PRIMITIVE-ATTRIBUTE"
    SDG_AGGREGATION_WITH_VARIATION = "SDG-AGGREGATION-WITH-VARIATION"
    SDG_ATTRIBUTE = "SDG-ATTRIBUTE"
    SDG_CAPTION = "SDG-CAPTION"
    SDG_CLASS = "SDG-CLASS"
    SDG_DEF = "SDG-DEF"
    SDG_FOREIGN_REFERENCE = "SDG-FOREIGN-REFERENCE"
    SDG_FOREIGN_REFERENCE_WITH_VARIATION = "SDG-FOREIGN-REFERENCE-WITH-VARIATION"
    SDG_PRIMITIVE_ATTRIBUTE = "SDG-PRIMITIVE-ATTRIBUTE"
    SDG_PRIMITIVE_ATTRIBUTE_WITH_VARIATION = "SDG-PRIMITIVE-ATTRIBUTE-WITH-VARIATION"
    SDG_REFERENCE = "SDG-REFERENCE"
    SDG_TAILORING = "SDG-TAILORING"
    SEC_OC_CRYPTO_SERVICE_MAPPING = "SEC-OC-CRYPTO-SERVICE-MAPPING"
    SEC_OC_DEPLOYMENT = "SEC-OC-DEPLOYMENT"
    SEC_OC_JOB_MAPPING = "SEC-OC-JOB-MAPPING"
    SEC_OC_JOB_REQUIREMENT = "SEC-OC-JOB-REQUIREMENT"
    SEC_OC_SECURE_COM_PROPS = "SEC-OC-SECURE-COM-PROPS"
    SECTION_NAME_PREFIX = "SECTION-NAME-PREFIX"
    SECURE_COM_PROPS = "SECURE-COM-PROPS"
    SECURE_COMMUNICATION_AUTHENTICATION_PROPS = "SECURE-COMMUNICATION-AUTHENTICATION-PROPS"
    SECURE_COMMUNICATION_DEPLOYMENT = "SECURE-COMMUNICATION-DEPLOYMENT"
    SECURE_COMMUNICATION_FRESHNESS_PROPS = "SECURE-COMMUNICATION-FRESHNESS-PROPS"
    SECURE_COMMUNICATION_PROPS_SET = "SECURE-COMMUNICATION-PROPS-SET"
    SECURE_ON_BOARD_COMMUNICATION_NEEDS = "SECURE-ON-BOARD-COMMUNICATION-NEEDS"
    SECURED_I_PDU = "SECURED-I-PDU"
    SECURITY_EVENT_AGGREGATION_FILTER = "SECURITY-EVENT-AGGREGATION-FILTER"
    SECURITY_EVENT_CONTEXT_MAPPING = "SECURITY-EVENT-CONTEXT-MAPPING"
    SECURITY_EVENT_CONTEXT_MAPPING_APPLICATION = "SECURITY-EVENT-CONTEXT-MAPPING-APPLICATION"
    SECURITY_EVENT_CONTEXT_MAPPING_BSW_MODULE = "SECURITY-EVENT-CONTEXT-MAPPING-BSW-MODULE"
    SECURITY_EVENT_CONTEXT_MAPPING_COMM_CONNECTOR = "SECURITY-EVENT-CONTEXT-MAPPING-COMM-CONNECTOR"
    SECURITY_EVENT_CONTEXT_MAPPING_FUNCTIONAL_CLUSTER = (
        "SECURITY-EVENT-CONTEXT-MAPPING-FUNCTIONAL-CLUSTER"
    )
    SECURITY_EVENT_CONTEXT_PROPS = "SECURITY-EVENT-CONTEXT-PROPS"
    SECURITY_EVENT_DEFINITION = "SECURITY-EVENT-DEFINITION"
    SECURITY_EVENT_FILTER_CHAIN = "SECURITY-EVENT-FILTER-CHAIN"
    SECURITY_EVENT_MAPPING = "SECURITY-EVENT-MAPPING"
    SECURITY_EVENT_ONE_EVERY_N_FILTER = "SECURITY-EVENT-ONE-EVERY-N-FILTER"
    SECURITY_EVENT_REPORT_INTERFACE = "SECURITY-EVENT-REPORT-INTERFACE"
    SECURITY_EVENT_REPORT_TO_SECURITY_EVENT_DEFINITION_MAPPING = (
        "SECURITY-EVENT-REPORT-TO-SECURITY-EVENT-DEFINITION-MAPPING"
    )
    SECURITY_EVENT_STATE_FILTER = "SECURITY-EVENT-STATE-FILTER"
    SECURITY_EVENT_THRESHOLD_FILTER = "SECURITY-EVENT-THRESHOLD-FILTER"
    SENDER_RECEIVER_INTERFACE = "SENDER-RECEIVER-INTERFACE"
    SENSOR_ACTUATOR_SW_COMPONENT_TYPE = "SENSOR-ACTUATOR-SW-COMPONENT-TYPE"
    SERIALIZATION_TECHNOLOGY = "SERIALIZATION-TECHNOLOGY"
    SERVER_CALL_POINT = "SERVER-CALL-POINT"
    SERVICE_EVENT_DEPLOYMENT = "SERVICE-EVENT-DEPLOYMENT"
    SERVICE_FIELD_DEPLOYMENT = "SERVICE-FIELD-DEPLOYMENT"
    SERVICE_INSTANCE_COLLECTION_SET = "SERVICE-INSTANCE-COLLECTION-SET"
    SERVICE_INSTANCE_TO_MACHINE_MAPPING = "SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    SERVICE_INSTANCE_TO_PORT_PROTOTYPE_MAPPING = "SERVICE-INSTANCE-TO-PORT-PROTOTYPE-MAPPING"
    SERVICE_INSTANCE_TO_SIGNAL_MAPPING = "SERVICE-INSTANCE-TO-SIGNAL-MAPPING"
    SERVICE_INSTANCE_TO_SW_CLUSTER_DESIGN_PORT_PROTOTYPE_MAPPING = (
        "SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-PORT-PROTOTYPE-MAPPING"
    )
    SERVICE_INTERFACE = "SERVICE-INTERFACE"
    SERVICE_INTERFACE_DEPLOYMENT = "SERVICE-INTERFACE-DEPLOYMENT"
    SERVICE_INTERFACE_ELEMENT_MAPPING = "SERVICE-INTERFACE-ELEMENT-MAPPING"
    SERVICE_INTERFACE_ELEMENT_SECURE_COM_CONFIG = "SERVICE-INTERFACE-ELEMENT-SECURE-COM-CONFIG"
    SERVICE_INTERFACE_EVENT_MAPPING = "SERVICE-INTERFACE-EVENT-MAPPING"
    SERVICE_INTERFACE_FIELD_MAPPING = "SERVICE-INTERFACE-FIELD-MAPPING"
    SERVICE_INTERFACE_MAPPING = "SERVICE-INTERFACE-MAPPING"
    SERVICE_INTERFACE_METHOD_MAPPING = "SERVICE-INTERFACE-METHOD-MAPPING"
    SERVICE_INTERFACE_PEDIGREE = "SERVICE-INTERFACE-PEDIGREE"
    SERVICE_INTERFACE_TRIGGER_MAPPING = "SERVICE-INTERFACE-TRIGGER-MAPPING"
    SERVICE_METHOD_DEPLOYMENT = "SERVICE-METHOD-DEPLOYMENT"
    SERVICE_NEEDS = "SERVICE-NEEDS"
    SERVICE_PROXY_SW_COMPONENT_TYPE = "SERVICE-PROXY-SW-COMPONENT-TYPE"
    SERVICE_SW_COMPONENT_TYPE = "SERVICE-SW-COMPONENT-TYPE"
    SERVICE_TIMING = "SERVICE-TIMING"
    SIGNAL_BASED_EVENT_ELEMENT_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-EVENT-ELEMENT-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_BASED_FIELD_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-FIELD-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_BASED_FIRE_AND_FORGET_METHOD_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-FIRE-AND-FORGET-METHOD-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_BASED_METHOD_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-METHOD-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_BASED_TRIGGER_TO_I_SIGNAL_TRIGGERING_MAPPING = (
        "SIGNAL-BASED-TRIGGER-TO-I-SIGNAL-TRIGGERING-MAPPING"
    )
    SIGNAL_SERVICE_TRANSLATION_ELEMENT_PROPS = "SIGNAL-SERVICE-TRANSLATION-ELEMENT-PROPS"
    SIGNAL_SERVICE_TRANSLATION_EVENT_PROPS = "SIGNAL-SERVICE-TRANSLATION-EVENT-PROPS"
    SIGNAL_SERVICE_TRANSLATION_PROPS = "SIGNAL-SERVICE-TRANSLATION-PROPS"
    SIGNAL_SERVICE_TRANSLATION_PROPS_SET = "SIGNAL-SERVICE-TRANSLATION-PROPS-SET"
    SIMULATED_EXECUTION_TIME = "SIMULATED-EXECUTION-TIME"
    SINGLE_LANGUAGE_REFERRABLE = "SINGLE-LANGUAGE-REFERRABLE"
    SO_AD_ROUTING_GROUP = "SO-AD-ROUTING-GROUP"
    SO_CON_I_PDU_IDENTIFIER = "SO-CON-I-PDU-IDENTIFIER"
    SOCKET_ADDRESS = "SOCKET-ADDRESS"
    SOCKET_CONNECTION_BUNDLE = "SOCKET-CONNECTION-BUNDLE"
    SOCKET_CONNECTION_IPDU_IDENTIFIER_SET = "SOCKET-CONNECTION-IPDU-IDENTIFIER-SET"
    SOFTWARE_CLUSTER = "SOFTWARE-CLUSTER"
    SOFTWARE_CLUSTER_DESIGN = "SOFTWARE-CLUSTER-DESIGN"
    SOFTWARE_CLUSTER_DIAGNOSTIC_DEPLOYMENT_PROPS = "SOFTWARE-CLUSTER-DIAGNOSTIC-DEPLOYMENT-PROPS"
    SOFTWARE_PACKAGE = "SOFTWARE-PACKAGE"
    SOFTWARE_PACKAGE_STEP = "SOFTWARE-PACKAGE-STEP"
    SOMEIP_DATA_PROTOTYPE_TRANSFORMATION_PROPS = "SOMEIP-DATA-PROTOTYPE-TRANSFORMATION-PROPS"
    SOMEIP_EVENT_DEPLOYMENT = "SOMEIP-EVENT-DEPLOYMENT"
    SOMEIP_EVENT_GROUP = "SOMEIP-EVENT-GROUP"
    SOMEIP_FIELD_DEPLOYMENT = "SOMEIP-FIELD-DEPLOYMENT"
    SOMEIP_METHOD_DEPLOYMENT = "SOMEIP-METHOD-DEPLOYMENT"
    SOMEIP_PROVIDED_EVENT_GROUP = "SOMEIP-PROVIDED-EVENT-GROUP"
    SOMEIP_REMOTE_MULTICAST_CONFIG = "SOMEIP-REMOTE-MULTICAST-CONFIG"
    SOMEIP_REMOTE_UNICAST_CONFIG = "SOMEIP-REMOTE-UNICAST-CONFIG"
    SOMEIP_REQUIRED_EVENT_GROUP = "SOMEIP-REQUIRED-EVENT-GROUP"
    SOMEIP_SD_CLIENT_EVENT_GROUP_TIMING_CONFIG = "SOMEIP-SD-CLIENT-EVENT-GROUP-TIMING-CONFIG"
    SOMEIP_SD_CLIENT_SERVICE_INSTANCE_CONFIG = "SOMEIP-SD-CLIENT-SERVICE-INSTANCE-CONFIG"
    SOMEIP_SD_SERVER_EVENT_GROUP_TIMING_CONFIG = "SOMEIP-SD-SERVER-EVENT-GROUP-TIMING-CONFIG"
    SOMEIP_SD_SERVER_SERVICE_INSTANCE_CONFIG = "SOMEIP-SD-SERVER-SERVICE-INSTANCE-CONFIG"
    SOMEIP_SERVICE_INSTANCE_TO_MACHINE_MAPPING = "SOMEIP-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    SOMEIP_SERVICE_INTERFACE_DEPLOYMENT = "SOMEIP-SERVICE-INTERFACE-DEPLOYMENT"
    SOMEIP_TP_CHANNEL = "SOMEIP-TP-CHANNEL"
    SOMEIP_TP_CONFIG = "SOMEIP-TP-CONFIG"
    SOMEIP_TRANSFORMATION_PROPS = "SOMEIP-TRANSFORMATION-PROPS"
    SOVD_GATEWAY_INSTANTIATION = "SOVD-GATEWAY-INSTANTIATION"
    SOVD_MODULE_INSTANTIATION = "SOVD-MODULE-INSTANTIATION"
    SOVD_SERVER_INSTANTIATION = "SOVD-SERVER-INSTANTIATION"
    SPEC_ELEMENT_REFERENCE = "SPEC-ELEMENT-REFERENCE"
    SPEC_ELEMENT_SCOPE = "SPEC-ELEMENT-SCOPE"
    SPECIFICATION_DOCUMENT_SCOPE = "SPECIFICATION-DOCUMENT-SCOPE"
    SPORADIC_EVENT_TRIGGERING = "SPORADIC-EVENT-TRIGGERING"
    STACK_USAGE = "STACK-USAGE"
    STARTUP_CONFIG = "STARTUP-CONFIG"
    STATE_DEPENDENT_FIREWALL = "STATE-DEPENDENT-FIREWALL"
    STATE_MANAGEMEN_PHM_ERROR_INTERFACE = "STATE-MANAGEMEN-PHM-ERROR-INTERFACE"
    STATE_MANAGEMENT_ACTION_ITEM = "STATE-MANAGEMENT-ACTION-ITEM"
    STATE_MANAGEMENT_ACTION_LIST = "STATE-MANAGEMENT-ACTION-LIST"
    STATE_MANAGEMENT_DIAG_TRIGGER_INTERFACE = "STATE-MANAGEMENT-DIAG-TRIGGER-INTERFACE"
    STATE_MANAGEMENT_EM_ERROR_INTERFACE = "STATE-MANAGEMENT-EM-ERROR-INTERFACE"
    STATE_MANAGEMENT_ERROR_INTERFACE = "STATE-MANAGEMENT-ERROR-INTERFACE"
    STATE_MANAGEMENT_FUNCTION_GROUP_SWITCH_NOTIFICATION_INTERFACE = (
        "STATE-MANAGEMENT-FUNCTION-GROUP-SWITCH-NOTIFICATION-INTERFACE"
    )
    STATE_MANAGEMENT_MODULE_INSTANTIATION = "STATE-MANAGEMENT-MODULE-INSTANTIATION"
    STATE_MANAGEMENT_NOTIFICATION_INTERFACE = "STATE-MANAGEMENT-NOTIFICATION-INTERFACE"
    STATE_MANAGEMENT_PORT_INTERFACE = "STATE-MANAGEMENT-PORT-INTERFACE"
    STATE_MANAGEMENT_REQUEST_ERROR = "STATE-MANAGEMENT-REQUEST-ERROR"
    STATE_MANAGEMENT_REQUEST_INTERFACE = "STATE-MANAGEMENT-REQUEST-INTERFACE"
    STATE_MANAGEMENT_REQUEST_TRIGGER = "STATE-MANAGEMENT-REQUEST-TRIGGER"
    STATE_MANAGEMENT_SET_FUNCTION_GROUP_STATE_ACTION_ITEM = (
        "STATE-MANAGEMENT-SET-FUNCTION-GROUP-STATE-ACTION-ITEM"
    )
    STATE_MANAGEMENT_STATE_MACHINE_ACTION_ITEM = "STATE-MANAGEMENT-STATE-MACHINE-ACTION-ITEM"
    STATE_MANAGEMENT_STATE_NOTIFICATION = "STATE-MANAGEMENT-STATE-NOTIFICATION"
    STATE_MANAGEMENT_STATE_REQUEST = "STATE-MANAGEMENT-STATE-REQUEST"
    STATE_MANAGEMENT_SYNC_ACTION_ITEM = "STATE-MANAGEMENT-SYNC-ACTION-ITEM"
    STATE_MANAGEMENT_TRIGGER_INTERFACE = "STATE-MANAGEMENT-TRIGGER-INTERFACE"
    STATIC_SOCKET_CONNECTION = "STATIC-SOCKET-CONNECTION"
    STD = "STD"
    STD_CPP_IMPLEMENTATION_DATA_TYPE = "STD-CPP-IMPLEMENTATION-DATA-TYPE"
    STRUCTURED_REQ = "STRUCTURED-REQ"
    SUPERVISED_ENTITY_CHECKPOINT_NEEDS = "SUPERVISED-ENTITY-CHECKPOINT-NEEDS"
    SUPERVISED_ENTITY_NEEDS = "SUPERVISED-ENTITY-NEEDS"
    SUPERVISION_CHECKPOINT = "SUPERVISION-CHECKPOINT"
    SUPERVISION_MODE = "SUPERVISION-MODE"
    SUPERVISION_MODE_CONDITION = "SUPERVISION-MODE-CONDITION"
    SW_ADDR_METHOD = "SW-ADDR-METHOD"
    SW_AXIS_TYPE = "SW-AXIS-TYPE"
    SW_BASE_TYPE = "SW-BASE-TYPE"
    SW_COMPONENT_MAPPING_CONSTRAINTS = "SW-COMPONENT-MAPPING-CONSTRAINTS"
    SW_COMPONENT_PROTOTYPE = "SW-COMPONENT-PROTOTYPE"
    SW_COMPONENT_TYPE = "SW-COMPONENT-TYPE"
    SW_CONNECTOR = "SW-CONNECTOR"
    SW_GENERIC_AXIS_PARAM_TYPE = "SW-GENERIC-AXIS-PARAM-TYPE"
    SW_RECORD_LAYOUT = "SW-RECORD-LAYOUT"
    SW_SERVICE_ARG = "SW-SERVICE-ARG"
    SW_SYSTEMCONST = "SW-SYSTEMCONST"
    SW_SYSTEMCONSTANT_VALUE_SET = "SW-SYSTEMCONSTANT-VALUE-SET"
    SWC_BSW_MAPPING = "SWC-BSW-MAPPING"
    SWC_IMPLEMENTATION = "SWC-IMPLEMENTATION"
    SWC_INTERNAL_BEHAVIOR = "SWC-INTERNAL-BEHAVIOR"
    SWC_MODE_MANAGER_ERROR_EVENT = "SWC-MODE-MANAGER-ERROR-EVENT"
    SWC_MODE_SWITCH_EVENT = "SWC-MODE-SWITCH-EVENT"
    SWC_SERVICE_DEPENDENCY = "SWC-SERVICE-DEPENDENCY"
    SWC_TIMING = "SWC-TIMING"
    SWC_TO_APPLICATION_PARTITION_MAPPING = "SWC-TO-APPLICATION-PARTITION-MAPPING"
    SWC_TO_ECU_MAPPING = "SWC-TO-ECU-MAPPING"
    SWC_TO_IMPL_MAPPING = "SWC-TO-IMPL-MAPPING"
    SYMBOL_PROPS = "SYMBOL-PROPS"
    SYMBOLIC_NAME_PROPS = "SYMBOLIC-NAME-PROPS"
    SYNC_TIME_BASE_MGR_USER_NEEDS = "SYNC-TIME-BASE-MGR-USER-NEEDS"
    SYNCHRONIZATION_POINT_CONSTRAINT = "SYNCHRONIZATION-POINT-CONSTRAINT"
    SYNCHRONIZATION_TIMING_CONSTRAINT = "SYNCHRONIZATION-TIMING-CONSTRAINT"
    SYNCHRONIZED_TIME_BASE_CONSUMER = "SYNCHRONIZED-TIME-BASE-CONSUMER"
    SYNCHRONIZED_TIME_BASE_CONSUMER_INTERFACE = "SYNCHRONIZED-TIME-BASE-CONSUMER-INTERFACE"
    SYNCHRONIZED_TIME_BASE_PROVIDER = "SYNCHRONIZED-TIME-BASE-PROVIDER"
    SYNCHRONIZED_TIME_BASE_PROVIDER_INTERFACE = "SYNCHRONIZED-TIME-BASE-PROVIDER-INTERFACE"
    SYNCHRONOUS_SERVER_CALL_POINT = "SYNCHRONOUS-SERVER-CALL-POINT"
    SYSTEM = "SYSTEM"
    SYSTEM_MAPPING = "SYSTEM-MAPPING"
    SYSTEM_SIGNAL = "SYSTEM-SIGNAL"
    SYSTEM_SIGNAL_GROUP = "SYSTEM-SIGNAL-GROUP"
    SYSTEM_TIMING = "SYSTEM-TIMING"
    TCP_OPTION_FILTER_LIST = "TCP-OPTION-FILTER-LIST"
    TCP_OPTION_FILTER_SET = "TCP-OPTION-FILTER-SET"
    TD_CP_SOFTWARE_CLUSTER_MAPPING = "TD-CP-SOFTWARE-CLUSTER-MAPPING"
    TD_CP_SOFTWARE_CLUSTER_MAPPING_SET = "TD-CP-SOFTWARE-CLUSTER-MAPPING-SET"
    TD_CP_SOFTWARE_CLUSTER_RESOURCE_MAPPING = "TD-CP-SOFTWARE-CLUSTER-RESOURCE-MAPPING"
    TD_EVENT_BSW = "TD-EVENT-BSW"
    TD_EVENT_BSW_INTERNAL_BEHAVIOR = "TD-EVENT-BSW-INTERNAL-BEHAVIOR"
    TD_EVENT_BSW_MODE_DECLARATION = "TD-EVENT-BSW-MODE-DECLARATION"
    TD_EVENT_BSW_MODULE = "TD-EVENT-BSW-MODULE"
    TD_EVENT_COM = "TD-EVENT-COM"
    TD_EVENT_COMPLEX = "TD-EVENT-COMPLEX"
    TD_EVENT_CYCLE_START = "TD-EVENT-CYCLE-START"
    TD_EVENT_FR_CLUSTER_CYCLE_START = "TD-EVENT-FR-CLUSTER-CYCLE-START"
    TD_EVENT_FRAME = "TD-EVENT-FRAME"
    TD_EVENT_FRAME_ETHERNET = "TD-EVENT-FRAME-ETHERNET"
    TD_EVENT_I_PDU = "TD-EVENT-I-PDU"
    TD_EVENT_I_SIGNAL = "TD-EVENT-I-SIGNAL"
    TD_EVENT_MODE_DECLARATION = "TD-EVENT-MODE-DECLARATION"
    TD_EVENT_OPERATION = "TD-EVENT-OPERATION"
    TD_EVENT_SERVICE_INSTANCE = "TD-EVENT-SERVICE-INSTANCE"
    TD_EVENT_SERVICE_INSTANCE_DISCOVERY = "TD-EVENT-SERVICE-INSTANCE-DISCOVERY"
    TD_EVENT_SERVICE_INSTANCE_EVENT = "TD-EVENT-SERVICE-INSTANCE-EVENT"
    TD_EVENT_SERVICE_INSTANCE_FIELD = "TD-EVENT-SERVICE-INSTANCE-FIELD"
    TD_EVENT_SERVICE_INSTANCE_METHOD = "TD-EVENT-SERVICE-INSTANCE-METHOD"
    TD_EVENT_SLLET = "TD-EVENT-SLLET"
    TD_EVENT_SLLET_PORT = "TD-EVENT-SLLET-PORT"
    TD_EVENT_SWC = "TD-EVENT-SWC"
    TD_EVENT_SWC_INTERNAL_BEHAVIOR = "TD-EVENT-SWC-INTERNAL-BEHAVIOR"
    TD_EVENT_SWC_INTERNAL_BEHAVIOR_REFERENCE = "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE"
    TD_EVENT_TRIGGER = "TD-EVENT-TRIGGER"
    TD_EVENT_TT_CAN_CYCLE_START = "TD-EVENT-TT-CAN-CYCLE-START"
    TD_EVENT_VARIABLE_DATA_PROTOTYPE = "TD-EVENT-VARIABLE-DATA-PROTOTYPE"
    TD_EVENT_VFB = "TD-EVENT-VFB"
    TD_EVENT_VFB_PORT = "TD-EVENT-VFB-PORT"
    TD_EVENT_VFB_REFERENCE = "TD-EVENT-VFB-REFERENCE"
    TDLET_ZONE_CLOCK = "TDLET-ZONE-CLOCK"
    TIME_BASE_PROVIDER_TO_PERSISTENCY_MAPPING = "TIME-BASE-PROVIDER-TO-PERSISTENCY-MAPPING"
    TIME_BASE_RESOURCE = "TIME-BASE-RESOURCE"
    TIME_SYNC_MODULE_INSTANTIATION = "TIME-SYNC-MODULE-INSTANTIATION"
    TIME_SYNC_PORT_PROTOTYPE_TO_TIME_BASE_MAPPING = "TIME-SYNC-PORT-PROTOTYPE-TO-TIME-BASE-MAPPING"
    TIME_SYNC_SERVER_CONFIGURATION = "TIME-SYNC-SERVER-CONFIGURATION"
    TIMING_CLOCK = "TIMING-CLOCK"
    TIMING_CLOCK_SYNC_ACCURACY = "TIMING-CLOCK-SYNC-ACCURACY"
    TIMING_CONDITION = "TIMING-CONDITION"
    TIMING_CONSTRAINT = "TIMING-CONSTRAINT"
    TIMING_DESCRIPTION = "TIMING-DESCRIPTION"
    TIMING_DESCRIPTION_EVENT = "TIMING-DESCRIPTION-EVENT"
    TIMING_DESCRIPTION_EVENT_CHAIN = "TIMING-DESCRIPTION-EVENT-CHAIN"
    TIMING_EVENT = "TIMING-EVENT"
    TIMING_EXTENSION = "TIMING-EXTENSION"
    TIMING_EXTENSION_RESOURCE = "TIMING-EXTENSION-RESOURCE"
    TIMING_MODE_INSTANCE = "TIMING-MODE-INSTANCE"
    TLS_CONNECTION_GROUP = "TLS-CONNECTION-GROUP"
    TLS_CRYPTO_CIPHER_SUITE = "TLS-CRYPTO-CIPHER-SUITE"
    TLS_CRYPTO_CIPHER_SUITE_PROPS = "TLS-CRYPTO-CIPHER-SUITE-PROPS"
    TLS_CRYPTO_SERVICE_MAPPING = "TLS-CRYPTO-SERVICE-MAPPING"
    TLS_DEPLOYMENT = "TLS-DEPLOYMENT"
    TLS_IAM_REMOTE_SUBJECT = "TLS-IAM-REMOTE-SUBJECT"
    TLS_JOB_MAPPING = "TLS-JOB-MAPPING"
    TLS_SECURE_COM_PROPS = "TLS-SECURE-COM-PROPS"
    TLV_DATA_ID_DEFINITION_SET = "TLV-DATA-ID-DEFINITION-SET"
    TOPIC_1 = "TOPIC-1"
    TP_ADDRESS = "TP-ADDRESS"
    TP_CONFIG = "TP-CONFIG"
    TP_CONNECTION_IDENT = "TP-CONNECTION-IDENT"
    TRACE_REFERRABLE = "TRACE-REFERRABLE"
    TRACEABLE = "TRACEABLE"
    TRACEABLE_TABLE = "TRACEABLE-TABLE"
    TRACEABLE_TEXT = "TRACEABLE-TEXT"
    TRACED_FAILURE = "TRACED-FAILURE"
    TRANSFORMATION_PROPS = "TRANSFORMATION-PROPS"
    TRANSFORMATION_PROPS_SET = "TRANSFORMATION-PROPS-SET"
    TRANSFORMATION_PROPS_TO_SERVICE_INTERFACE_ELEMENT_MAPPING = (
        "TRANSFORMATION-PROPS-TO-SERVICE-INTERFACE-ELEMENT-MAPPING"
    )
    TRANSFORMATION_TECHNOLOGY = "TRANSFORMATION-TECHNOLOGY"
    TRANSFORMER_HARD_ERROR_EVENT = "TRANSFORMER-HARD-ERROR-EVENT"
    TRANSIENT_FAULT = "TRANSIENT-FAULT"
    TRIGGER = "TRIGGER"
    TRIGGER_INTERFACE = "TRIGGER-INTERFACE"
    TRIGGER_INTERFACE_MAPPING = "TRIGGER-INTERFACE-MAPPING"
    TTCAN_CLUSTER = "TTCAN-CLUSTER"
    TTCAN_COMMUNICATION_CONNECTOR = "TTCAN-COMMUNICATION-CONNECTOR"
    TTCAN_COMMUNICATION_CONTROLLER = "TTCAN-COMMUNICATION-CONTROLLER"
    TTCAN_PHYSICAL_CHANNEL = "TTCAN-PHYSICAL-CHANNEL"
    UCM_DESCRIPTION = "UCM-DESCRIPTION"
    UCM_MASTER_MODULE_INSTANTIATION = "UCM-MASTER-MODULE-INSTANTIATION"
    UCM_MODULE_INSTANTIATION = "UCM-MODULE-INSTANTIATION"
    UCM_RETRY_STRATEGY = "UCM-RETRY-STRATEGY"
    UCM_STEP = "UCM-STEP"
    UCM_SUBORDINATE_MODULE_INSTANTIATION = "UCM-SUBORDINATE-MODULE-INSTANTIATION"
    UCM_TO_TIME_BASE_RESOURCE_MAPPING = "UCM-TO-TIME-BASE-RESOURCE-MAPPING"
    UDP_NM_CLUSTER = "UDP-NM-CLUSTER"
    UDP_NM_NODE = "UDP-NM-NODE"
    UNIT = "UNIT"
    UNIT_GROUP = "UNIT-GROUP"
    UPLOADABLE_EXCLUSIVE_PACKAGE_ELEMENT = "UPLOADABLE-EXCLUSIVE-PACKAGE-ELEMENT"
    UPLOADABLE_PACKAGE_ELEMENT = "UPLOADABLE-PACKAGE-ELEMENT"
    USER_DEFINED_CLUSTER = "USER-DEFINED-CLUSTER"
    USER_DEFINED_COMMUNICATION_CONNECTOR = "USER-DEFINED-COMMUNICATION-CONNECTOR"
    USER_DEFINED_COMMUNICATION_CONTROLLER = "USER-DEFINED-COMMUNICATION-CONTROLLER"
    USER_DEFINED_ETHERNET_FRAME = "USER-DEFINED-ETHERNET-FRAME"
    USER_DEFINED_EVENT_DEPLOYMENT = "USER-DEFINED-EVENT-DEPLOYMENT"
    USER_DEFINED_FIELD_DEPLOYMENT = "USER-DEFINED-FIELD-DEPLOYMENT"
    USER_DEFINED_GLOBAL_TIME_MASTER = "USER-DEFINED-GLOBAL-TIME-MASTER"
    USER_DEFINED_GLOBAL_TIME_SLAVE = "USER-DEFINED-GLOBAL-TIME-SLAVE"
    USER_DEFINED_I_PDU = "USER-DEFINED-I-PDU"
    USER_DEFINED_METHOD_DEPLOYMENT = "USER-DEFINED-METHOD-DEPLOYMENT"
    USER_DEFINED_PDU = "USER-DEFINED-PDU"
    USER_DEFINED_PHYSICAL_CHANNEL = "USER-DEFINED-PHYSICAL-CHANNEL"
    USER_DEFINED_SERVICE_INSTANCE_TO_MACHINE_MAPPING = (
        "USER-DEFINED-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    )
    USER_DEFINED_SERVICE_INTERFACE_DEPLOYMENT = "USER-DEFINED-SERVICE-INTERFACE-DEPLOYMENT"
    USER_DEFINED_TRANSFORMATION_PROPS = "USER-DEFINED-TRANSFORMATION-PROPS"
    V_2_X_DATA_MANAGER_NEEDS = "V-2-X-DATA-MANAGER-NEEDS"
    V_2_X_FAC_USER_NEEDS = "V-2-X-FAC-USER-NEEDS"
    V_2_X_M_USER_NEEDS = "V-2-X-M-USER-NEEDS"
    VARIABLE_ACCESS = "VARIABLE-ACCESS"
    VARIABLE_AND_PARAMETER_INTERFACE_MAPPING = "VARIABLE-AND-PARAMETER-INTERFACE-MAPPING"
    VARIABLE_DATA_PROTOTYPE = "VARIABLE-DATA-PROTOTYPE"
    VARIATION_POINT_PROXY = "VARIATION-POINT-PROXY"
    VEHICLE_PACKAGE = "VEHICLE-PACKAGE"
    VEHICLE_ROLLOUT_STEP = "VEHICLE-ROLLOUT-STEP"
    VENDOR_SPECIFIC_SERVICE_NEEDS = "VENDOR-SPECIFIC-SERVICE-NEEDS"
    VFB_TIMING = "VFB-TIMING"
    VIEW_MAP = "VIEW-MAP"
    VIEW_MAP_SET = "VIEW-MAP-SET"
    VLAN_CONFIG = "VLAN-CONFIG"
    WAIT_POINT = "WAIT-POINT"
    WARNING_INDICATOR_REQUESTED_BIT_NEEDS = "WARNING-INDICATOR-REQUESTED-BIT-NEEDS"
    WORST_CASE_HEAP_USAGE = "WORST-CASE-HEAP-USAGE"
    WORST_CASE_STACK_USAGE = "WORST-CASE-STACK-USAGE"
    XCP_PDU = "XCP-PDU"
    XDOC = "XDOC"
    XFILE = "XFILE"
    XREF_TARGET = "XREF-TARGET"


@dataclass(slots=True, kw_only=True)
class RegularExpression:
    """This is a regular expression as defined in
    http://www.w3.org/TR/xmlschema-2
    As of now it is still produced as a string in XSD.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REGULAR-EXPRESSION"

    value: str = field(
        default="",
        metadata={
            "required": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class RemotingTechnologyEnumSimple(Enum):
    """
    :cvar AR_CLIENT_SERVER: AUTOSAR Client Server is used as remote
        technology.
    :cvar SOMEIP: SOME/IP is used as remote technology.
    """

    AR_CLIENT_SERVER = "AR--CLIENT--SERVER"
    SOMEIP = "SOMEIP"


class ReportBehaviorEnumSimple(Enum):
    """
    :cvar REPORT_AFTER_INIT: This allows reporting related events after
        initialization
    :cvar REPORT_BEFORE_INIT: This allows reporting related events
        before initialization
    """

    REPORT_AFTER_INIT = "REPORT-AFTER-INIT"
    REPORT_BEFORE_INIT = "REPORT-BEFORE-INIT"


class RequestMethodEnumSimple(Enum):
    """
    :cvar CONNECT: The request method CONNECT establishes a tunnel to
        the server identified by the target resource.
    :cvar DELETE: The request method DELETE deletes the specified
        resource.
    :cvar GET: The request method GET requests a representation of the
        specified resource.
    :cvar HEAD: The request method HEAD asks for a response identical to
        that of a GET request, but without the response body.
    :cvar OPTIONS: The request method OPTIONS is used to describe the
        communication options for the target resource.
    :cvar POST: The request method POST is used to submit an entity to
        the specified resource.
    :cvar PUT: The request method PUT replaces all current
        representations of the target resource with the request payload.
    :cvar TRACE: The request method TRACE performs a message loopback
        test along the path to the target resource.
    """

    CONNECT = "CONNECT"
    DELETE = "DELETE"
    GET = "GET"
    HEAD = "HEAD"
    OPTIONS = "OPTIONS"
    POST = "POST"
    PUT = "PUT"
    TRACE = "TRACE"


class RequestTypeEnumSimple(Enum):
    """
    :cvar FUNCTIONAL: This enum literal defines a FUNCTIONAL
        DiagnosticMessage request.
    :cvar PHYSICAL: This enum literal defines a PHYSICAL
        DiagnosticMessage request.
    """

    FUNCTIONAL = "FUNCTIONAL"
    PHYSICAL = "PHYSICAL"


class RequiredApServiceInstanceSubtypesEnum(Enum):
    DDS_REQUIRED_SERVICE_INSTANCE = "DDS-REQUIRED-SERVICE-INSTANCE"
    REQUIRED_AP_SERVICE_INSTANCE = "REQUIRED-AP-SERVICE-INSTANCE"
    REQUIRED_SOMEIP_SERVICE_INSTANCE = "REQUIRED-SOMEIP-SERVICE-INSTANCE"
    REQUIRED_USER_DEFINED_SERVICE_INSTANCE = "REQUIRED-USER-DEFINED-SERVICE-INSTANCE"


class ResolutionPolicyEnumSimple(Enum):
    """
    :cvar NO_SLOPPY: The content of the xref element is '''not''' linked
        by a sloppy reference.
    :cvar SLOPPY: The content of the xref element is linked by a sloppy
        reference.
    """

    NO_SLOPPY = "NO-SLOPPY"
    SLOPPY = "SLOPPY"


class ResourceGroupSubtypesEnum(Enum):
    RESOURCE_GROUP = "RESOURCE-GROUP"


class ResumePositionSimple(Enum):
    """
    :cvar CONTINUE_AT_IT_POSITION: Continue at IT Point.
    :cvar START_FROM_BEGINNING: Start from the beginning
    """

    CONTINUE_AT_IT_POSITION = "CONTINUE-AT-IT-POSITION"
    START_FROM_BEGINNING = "START-FROM-BEGINNING"


@dataclass(slots=True, kw_only=True)
class RevisionLabelString:
    """This primitive represents an internal AUTOSAR revision label which
    identifies an engineering object.

    It represents a pattern which
    * supports three integers representing from left to right MajorVersion, MinorVersion, PatchVersion.
    * may add an application specific suffix separated by one of ".", "_", ";".
    Legal patterns are for example:
    * 4.0.0
    * 4.0.0.1234565
    * 4.0.0_vendor specific;13
    * 4.0.0;12

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REVISION-LABEL-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"[0-9]+\.[0-9]+\.[0-9]+([\._;].*)?",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class RootSwClusterDesignComponentPrototypeSubtypesEnum(Enum):
    ROOT_SW_CLUSTER_DESIGN_COMPONENT_PROTOTYPE = "ROOT-SW-CLUSTER-DESIGN-COMPONENT-PROTOTYPE"


class RootSwComponentPrototypeSubtypesEnum(Enum):
    ROOT_SW_COMPONENT_PROTOTYPE = "ROOT-SW-COMPONENT-PROTOTYPE"


class RootSwCompositionPrototypeSubtypesEnum(Enum):
    ROOT_SW_COMPOSITION_PROTOTYPE = "ROOT-SW-COMPOSITION-PROTOTYPE"


class RptAccessEnumSimple(Enum):
    """
    :cvar ENABLED: The related data element is accessible by RP tool.
    :cvar NONE: The related data element is not accessible by RP tool.
    :cvar PROTECTED: The data element is known to the RP tool however
        its usage for RP can be restricted. Use case: limitation based
        on access rights
    """

    ENABLED = "ENABLED"
    NONE = "NONE"
    PROTECTED = "PROTECTED"


class RptEnablerImplTypeEnumSimple(Enum):
    """
    :cvar NONE: No "RP enabler" is implemented.
    :cvar RPT_ENABLER_RAM: "RP enabler" is implemented as a RAM variable
    :cvar RPT_ENABLER_RAM_AND_ROM: The RTE generator implements both the
        RAM and ROM "RP enabler".
    :cvar RPT_ENABLER_ROM: "RP enabler" is implemented as a
        calibrateable ROM variable.
    """

    NONE = "NONE"
    RPT_ENABLER_RAM = "RPT-ENABLER-RAM"
    RPT_ENABLER_RAM_AND_ROM = "RPT-ENABLER-RAM-AND-ROM"
    RPT_ENABLER_ROM = "RPT-ENABLER-ROM"


class RptExecutionContextSubtypesEnum(Enum):
    RPT_EXECUTION_CONTEXT = "RPT-EXECUTION-CONTEXT"


class RptExecutionControlEnumSimple(Enum):
    """
    :cvar CONDITIONAL: The ExecutableEntity is only executed when the
        rapid prototyping disable flag is NOT set.
    :cvar NONE: The ExecutableEntity is executed without specific rapid
        prototyping condition.
    """

    CONDITIONAL = "CONDITIONAL"
    NONE = "NONE"


class RptPreparationEnumSimple(Enum):
    """
    :cvar NONE: No RP preparation for VariableDataPrototype.
    :cvar RPT_LEVEL_1: The RTE implementation uses an „RP global buffer"
        for measurement and post-build hooking purposes.
    :cvar RPT_LEVEL_2: As rpLevel1 but the RTE implementation also uses
        both „RP enabler flag" to permit RP overwrite at run-time.
    :cvar RPT_LEVEL_3: As rpLevel2 but the RTE implementation also uses
        "RP global measurement buffer" to record the original ECU-
        generated value in addition to the RP value.
    """

    NONE = "NONE"
    RPT_LEVEL_1 = "RPT-LEVEL-1"
    RPT_LEVEL_2 = "RPT-LEVEL-2"
    RPT_LEVEL_3 = "RPT-LEVEL-3"


class RptProfileSubtypesEnum(Enum):
    RPT_PROFILE = "RPT-PROFILE"


class RptServicePointSubtypesEnum(Enum):
    RPT_SERVICE_POINT = "RPT-SERVICE-POINT"


class RptServicePointEnumSimple(Enum):
    """
    :cvar ENABLED: Enables generation of service points by the RTE
        generator.
    :cvar NONE: No Service Points are requested.
    """

    ENABLED = "ENABLED"
    NONE = "NONE"


class RteApiReturnValueProvisionEnumSimple(Enum):
    """
    :cvar NO_RETURN_VALUE_PROVIDED: The RTE API shall not provide a
        return value.
    :cvar RETURN_VALUE_PROVIDED: The RTE API shall provide a return
        value.
    """

    NO_RETURN_VALUE_PROVIDED = "NO-RETURN-VALUE-PROVIDED"
    RETURN_VALUE_PROVIDED = "RETURN-VALUE-PROVIDED"


class RteEventSubtypesEnum(Enum):
    ASYNCHRONOUS_SERVER_CALL_RETURNS_EVENT = "ASYNCHRONOUS-SERVER-CALL-RETURNS-EVENT"
    BACKGROUND_EVENT = "BACKGROUND-EVENT"
    DATA_RECEIVE_ERROR_EVENT = "DATA-RECEIVE-ERROR-EVENT"
    DATA_RECEIVED_EVENT = "DATA-RECEIVED-EVENT"
    DATA_SEND_COMPLETED_EVENT = "DATA-SEND-COMPLETED-EVENT"
    DATA_WRITE_COMPLETED_EVENT = "DATA-WRITE-COMPLETED-EVENT"
    EXTERNAL_TRIGGER_OCCURRED_EVENT = "EXTERNAL-TRIGGER-OCCURRED-EVENT"
    INIT_EVENT = "INIT-EVENT"
    INTERNAL_TRIGGER_OCCURRED_EVENT = "INTERNAL-TRIGGER-OCCURRED-EVENT"
    MODE_SWITCHED_ACK_EVENT = "MODE-SWITCHED-ACK-EVENT"
    OPERATION_INVOKED_EVENT = "OPERATION-INVOKED-EVENT"
    OS_TASK_EXECUTION_EVENT = "OS-TASK-EXECUTION-EVENT"
    RTE_EVENT = "RTE-EVENT"
    SWC_MODE_MANAGER_ERROR_EVENT = "SWC-MODE-MANAGER-ERROR-EVENT"
    SWC_MODE_SWITCH_EVENT = "SWC-MODE-SWITCH-EVENT"
    TIMING_EVENT = "TIMING-EVENT"
    TRANSFORMER_HARD_ERROR_EVENT = "TRANSFORMER-HARD-ERROR-EVENT"


class RunModeSimple(Enum):
    """
    :cvar RUN_CONTINUOUS: RUN_CONTINUOUS run mode
    :cvar RUN_ONCE: RUN_ONCE run mode
    """

    RUN_CONTINUOUS = "RUN-CONTINUOUS"
    RUN_ONCE = "RUN-ONCE"


class RunnableEntitySubtypesEnum(Enum):
    RUNNABLE_ENTITY = "RUNNABLE-ENTITY"


class RunnableEntityGroupSubtypesEnum(Enum):
    RUNNABLE_ENTITY_GROUP = "RUNNABLE-ENTITY-GROUP"


class RuntimeAddressConfigurationEnumSimple(Enum):
    """
    :cvar NONE: Static configuration is used to obtain the address
        information.
    :cvar SD: AUTOSAR Service Discovery is used to obtain the address
        information.
    """

    NONE = "NONE"
    SD = "SD"


class RxAcceptContainedIPduEnumSimple(Enum):
    """
    :cvar ACCEPT_ALL: No fixed set of containedIPdus is defined for
        reception, any known containedIPdu (based on headerId) shall be
        expected within this ContainerIPdu.
    :cvar ACCEPT_CONFIGURED: A fixed set of containedIPdus is defined
        for reception. Only these assigned containedIPdus (based on
        headerId) are expected in this ContainerIPdu. If a not assigned
        containedIPdu is received within this ContainerIPdu this
        containedIPdu is discarded.
    """

    ACCEPT_ALL = "ACCEPT-ALL"
    ACCEPT_CONFIGURED = "ACCEPT-CONFIGURED"


class ScaleConstrValidityEnumSimple(Enum):
    """
    :cvar NOT_AVAILABLE: Currently invalid area The value usually is
        presented by the ECU but can currently not be performed due to
        e.g. initialization or temporary problems. Please note, that
        this behavior appears during runtime and cannot be handled while
        data is edited.
    :cvar NOT_DEFINED: Indicates an area which is marked in a
        specification (e.g. as reserved) Shall usually not be set by the
        ECU but is used by a tester to verify correct ECU.
    :cvar NOT_VALID: The ECU cannot process the requested data.
    :cvar VALID: Current value is within a valid range and can be
        presented to user as is.
    """

    NOT_AVAILABLE = "NOT-AVAILABLE"
    NOT_DEFINED = "NOT-DEFINED"
    NOT_VALID = "NOT-VALID"
    VALID = "VALID"


@dataclass(slots=True, kw_only=True)
class Sd:
    """
    This class represents a primitive element in a special data group.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar gid: This attributes specifies an identifier. Gid comes from
        the SGML/XML-Term "Generic Identifier" which is the element name
        in XML. The role of this attribute is the same as the name of an
        XML - element.
    :ivar space: This attribute is used to signal an intention that in
        that element, white space should be preserved by applications.
        It is defined according to xml:space as declared by W3C.
    """

    class Meta:
        name = "SD"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "white_space": "preserve",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    gid: str | None = field(
        default=None,
        metadata={
            "name": "GID",
            "type": "Attribute",
        },
    )
    space: str | None = field(
        default=None,
        metadata={
            "type": "Attribute",
            "namespace": "http://www.w3.org/XML/1998/namespace",
        },
    )


class SdgCaptionSubtypesEnum(Enum):
    SDG_CAPTION = "SDG-CAPTION"


class SdgClassSubtypesEnum(Enum):
    SDG_CLASS = "SDG-CLASS"


class SdgDefSubtypesEnum(Enum):
    SDG_DEF = "SDG-DEF"


class SearchIntentionEnumSimple(Enum):
    """
    :cvar SEARCH_FOR_ALL_INSTANCES: This value represents the intention
        to search for all instances of the given service.
    :cvar SEARCH_FOR_SPECIFIC_INSTANCE: This value represents the
        intention to search for a specific instance of the given
        service.
    """

    SEARCH_FOR_ALL_INSTANCES = "SEARCH-FOR-ALL-INSTANCES"
    SEARCH_FOR_SPECIFIC_INSTANCE = "SEARCH-FOR-SPECIFIC-INSTANCE"


class SecOcCryptoServiceMappingSubtypesEnum(Enum):
    SEC_OC_CRYPTO_SERVICE_MAPPING = "SEC-OC-CRYPTO-SERVICE-MAPPING"


class SecOcJobRequirementSubtypesEnum(Enum):
    SEC_OC_JOB_REQUIREMENT = "SEC-OC-JOB-REQUIREMENT"


class SecOcJobSemanticEnumSimple(Enum):
    """
    :cvar AUTHENTICATE: Authentication algorithm for Authenticator
        generation/verification.
    :cvar VERIFY: Asymmetric cryptographic algorithm to generate/verify
        a signature
    """

    AUTHENTICATE = "AUTHENTICATE"
    VERIFY = "VERIFY"


class SecOcSecureComPropsSubtypesEnum(Enum):
    SEC_OC_SECURE_COM_PROPS = "SEC-OC-SECURE-COM-PROPS"


@dataclass(slots=True, kw_only=True)
class SectionInitializationPolicyType:
    """SectionInitializationPolicyType describes the intended initialization of
    MemorySections.

    The following values are standardized in AUTOSAR Methodology:
    * '''INIT''': To be used for (explicitly or not explicitly) initialized variables.
    * '''CLEARED''': To be used for not explicitly initialized variables.
    * '''POWER-ON-CLEARED''': To be used for variables that are not explicitly initialized (cleared) during normal start-up. Instead these are cleared only after power on reset.
    Please note that the values are defined similar to the representation of enumeration types in the XML schema to ensure backward compatibility.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECTION-INITIALIZATION-POLICY-TYPE"

    value: str = field(
        default="",
        metadata={
            "required": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class SectionNamePrefixSubtypesEnum(Enum):
    SECTION_NAME_PREFIX = "SECTION-NAME-PREFIX"


class SecureComPropsSubtypesEnum(Enum):
    DDS_SECURE_COM_PROPS = "DDS-SECURE-COM-PROPS"
    SEC_OC_SECURE_COM_PROPS = "SEC-OC-SECURE-COM-PROPS"
    SECURE_COM_PROPS = "SECURE-COM-PROPS"
    TLS_SECURE_COM_PROPS = "TLS-SECURE-COM-PROPS"


class SecureCommunicationAuthenticationPropsSubtypesEnum(Enum):
    SECURE_COMMUNICATION_AUTHENTICATION_PROPS = "SECURE-COMMUNICATION-AUTHENTICATION-PROPS"


class SecureCommunicationFreshnessPropsSubtypesEnum(Enum):
    SECURE_COMMUNICATION_FRESHNESS_PROPS = "SECURE-COMMUNICATION-FRESHNESS-PROPS"


class SecuredPduHeaderEnumSimple(Enum):
    """
    :cvar NO_HEADER: No header included in the SecuredPdu.
    :cvar SECURED_PDU_HEADER_08_BIT: 8 Bit Secured I-PDU Header included
        in the Secured I-PDU.
    :cvar SECURED_PDU_HEADER_16_BIT: 16 Bit Secured I-PDU Header
        included in the Secured I-PDU.
    :cvar SECURED_PDU_HEADER_32_BIT: 32 Bit Secured I-PDU Header
        included in the Secured I-PDU.
    """

    NO_HEADER = "NO-HEADER"
    SECURED_PDU_HEADER_08_BIT = "SECURED-PDU-HEADER-08-BIT"
    SECURED_PDU_HEADER_16_BIT = "SECURED-PDU-HEADER-16-BIT"
    SECURED_PDU_HEADER_32_BIT = "SECURED-PDU-HEADER-32-BIT"


class SecurityEventContextDataSourceEnumSimple(Enum):
    """
    :cvar USE_FIRST_CONTEXT_DATA: Context data of first received
        security event shall be used for resulting qualified security
        event.
    :cvar USE_LAST_CONTEXT_DATA: Context data of last received security
        event shall be used for resulting qualified security event.
    """

    USE_FIRST_CONTEXT_DATA = "USE-FIRST-CONTEXT-DATA"
    USE_LAST_CONTEXT_DATA = "USE-LAST-CONTEXT-DATA"


class SecurityEventContextPropsSubtypesEnum(Enum):
    SECURITY_EVENT_CONTEXT_PROPS = "SECURITY-EVENT-CONTEXT-PROPS"


class SecurityEventDefinitionSubtypesEnum(Enum):
    SECURITY_EVENT_DEFINITION = "SECURITY-EVENT-DEFINITION"


class SecurityEventFilterChainSubtypesEnum(Enum):
    SECURITY_EVENT_FILTER_CHAIN = "SECURITY-EVENT-FILTER-CHAIN"


class SecurityEventMappingSubtypesEnum(Enum):
    SECURITY_EVENT_MAPPING = "SECURITY-EVENT-MAPPING"


class SecurityEventReportingModeEnumSimple(Enum):
    """
    :cvar BRIEF: Only the main security event properties such as its ID
        are processed. Any additional context data (if existing) is
        discarded.
    :cvar BRIEF_BYPASSING_FILTERS: The reported security event without
        its context data (if existing) is processed further but the
        filter chain is bypassed.
    :cvar DETAILED: The main properties and the context data (if
        existing) of the reported security event are processed further.
    :cvar DETAILED_BYPASSING_FILTERS: The reported security event
        including its context data (if existing) is processed further
        but the filter chain is bypassed.
    :cvar OFF: The reported security event is not further processed by
        the IdsM and therefore discarded.
    """

    BRIEF = "BRIEF"
    BRIEF_BYPASSING_FILTERS = "BRIEF-BYPASSING-FILTERS"
    DETAILED = "DETAILED"
    DETAILED_BYPASSING_FILTERS = "DETAILED-BYPASSING-FILTERS"
    OFF = "OFF"


class SendIndicationEnumSimple(Enum):
    """
    :cvar ANY_SEND_OPERATION: This value represents the requirement that
        any send operation of the Software Cluster is indicated.
    :cvar NONE: This value represents the requirement that send
        operations of the Software Cluster are not indicated.
    """

    ANY_SEND_OPERATION = "ANY-SEND-OPERATION"
    NONE = "NONE"


class SenderIntentEnumSimple(Enum):
    """
    :cvar WILL_SEND: The sender will send the event or field notifier.
    :cvar WONT_SEND: The sender won't send the event or field notifier.
    """

    WILL_SEND = "WILL-SEND"
    WONT_SEND = "WONT-SEND"


class SerializationTechnologySubtypesEnum(Enum):
    SERIALIZATION_TECHNOLOGY = "SERIALIZATION-TECHNOLOGY"


class SerializationTechnologyEnumSimple(Enum):
    """
    :cvar SIGNAL_BASED: Signal-Based serializer.
    :cvar SOMEIP: SOME/IP Serializer
    """

    SIGNAL_BASED = "SIGNAL-BASED"
    SOMEIP = "SOMEIP"


class ServerArgumentImplPolicyEnumSimple(Enum):
    """
    :cvar USE_ARGUMENT_TYPE: The argument type of the RunnableEntity is
        derived from the AutosarDataType of the ArgumentPrototype.
    :cvar USE_ARRAY_BASE_TYPE: The argument type of the RunnableEntity
        is derived from the AutosarDataType of the elements of the array
        that corresponds to the ArgumentPrototype. This represents the
        base type of the array in C.
    :cvar USE_VOID: The argument type of the RunnableEntity is void.
    """

    USE_ARGUMENT_TYPE = "USE-ARGUMENT-TYPE"
    USE_ARRAY_BASE_TYPE = "USE-ARRAY-BASE-TYPE"
    USE_VOID = "USE-VOID"


class ServiceDiagnosticRelevanceEnumSimple(Enum):
    """
    :cvar IS_NOT_RELEVANT: This value indicates that a relevance for
        diagnostics does not exist.
    :cvar IS_RELEVANT: This value indicates a relevance for diagnostics.
    """

    IS_NOT_RELEVANT = "IS-NOT-RELEVANT"
    IS_RELEVANT = "IS-RELEVANT"


class ServiceEventDeploymentSubtypesEnum(Enum):
    DDS_EVENT_DEPLOYMENT = "DDS-EVENT-DEPLOYMENT"
    SERVICE_EVENT_DEPLOYMENT = "SERVICE-EVENT-DEPLOYMENT"
    SOMEIP_EVENT_DEPLOYMENT = "SOMEIP-EVENT-DEPLOYMENT"
    USER_DEFINED_EVENT_DEPLOYMENT = "USER-DEFINED-EVENT-DEPLOYMENT"


class ServiceFieldDeploymentSubtypesEnum(Enum):
    DDS_FIELD_DEPLOYMENT = "DDS-FIELD-DEPLOYMENT"
    SERVICE_FIELD_DEPLOYMENT = "SERVICE-FIELD-DEPLOYMENT"
    SOMEIP_FIELD_DEPLOYMENT = "SOMEIP-FIELD-DEPLOYMENT"
    USER_DEFINED_FIELD_DEPLOYMENT = "USER-DEFINED-FIELD-DEPLOYMENT"


class ServiceInstanceToPortPrototypeMappingSubtypesEnum(Enum):
    SERVICE_INSTANCE_TO_PORT_PROTOTYPE_MAPPING = "SERVICE-INSTANCE-TO-PORT-PROTOTYPE-MAPPING"


class ServiceInterfaceSubtypesEnum(Enum):
    SERVICE_INTERFACE = "SERVICE-INTERFACE"


class ServiceInterfaceDeploymentSubtypesEnum(Enum):
    DDS_SERVICE_INTERFACE_DEPLOYMENT = "DDS-SERVICE-INTERFACE-DEPLOYMENT"
    SERVICE_INTERFACE_DEPLOYMENT = "SERVICE-INTERFACE-DEPLOYMENT"
    SOMEIP_SERVICE_INTERFACE_DEPLOYMENT = "SOMEIP-SERVICE-INTERFACE-DEPLOYMENT"
    USER_DEFINED_SERVICE_INTERFACE_DEPLOYMENT = "USER-DEFINED-SERVICE-INTERFACE-DEPLOYMENT"


class ServiceInterfaceElementMappingSubtypesEnum(Enum):
    SERVICE_INTERFACE_ELEMENT_MAPPING = "SERVICE-INTERFACE-ELEMENT-MAPPING"
    SERVICE_INTERFACE_EVENT_MAPPING = "SERVICE-INTERFACE-EVENT-MAPPING"
    SERVICE_INTERFACE_FIELD_MAPPING = "SERVICE-INTERFACE-FIELD-MAPPING"
    SERVICE_INTERFACE_METHOD_MAPPING = "SERVICE-INTERFACE-METHOD-MAPPING"
    SERVICE_INTERFACE_TRIGGER_MAPPING = "SERVICE-INTERFACE-TRIGGER-MAPPING"


class ServiceInterfaceElementSecureComConfigSubtypesEnum(Enum):
    SERVICE_INTERFACE_ELEMENT_SECURE_COM_CONFIG = "SERVICE-INTERFACE-ELEMENT-SECURE-COM-CONFIG"


class ServiceMethodDeploymentSubtypesEnum(Enum):
    SERVICE_METHOD_DEPLOYMENT = "SERVICE-METHOD-DEPLOYMENT"
    SOMEIP_METHOD_DEPLOYMENT = "SOMEIP-METHOD-DEPLOYMENT"
    USER_DEFINED_METHOD_DEPLOYMENT = "USER-DEFINED-METHOD-DEPLOYMENT"


class ServiceNeedsSubtypesEnum(Enum):
    BSW_MGR_NEEDS = "BSW-MGR-NEEDS"
    COM_MGR_USER_NEEDS = "COM-MGR-USER-NEEDS"
    CRYPTO_CERTIFICATE_KEY_SLOT_NEEDS = "CRYPTO-CERTIFICATE-KEY-SLOT-NEEDS"
    CRYPTO_KEY_MANAGEMENT_NEEDS = "CRYPTO-KEY-MANAGEMENT-NEEDS"
    CRYPTO_NEEDS = "CRYPTO-NEEDS"
    CRYPTO_SERVICE_JOB_NEEDS = "CRYPTO-SERVICE-JOB-NEEDS"
    CRYPTO_SERVICE_NEEDS = "CRYPTO-SERVICE-NEEDS"
    DIAGNOSTIC_CAPABILITY_ELEMENT = "DIAGNOSTIC-CAPABILITY-ELEMENT"
    DIAGNOSTIC_CLEAR_CONDITION_NEEDS = "DIAGNOSTIC-CLEAR-CONDITION-NEEDS"
    DIAGNOSTIC_COMMUNICATION_MANAGER_NEEDS = "DIAGNOSTIC-COMMUNICATION-MANAGER-NEEDS"
    DIAGNOSTIC_COMPONENT_NEEDS = "DIAGNOSTIC-COMPONENT-NEEDS"
    DIAGNOSTIC_CONTROL_NEEDS = "DIAGNOSTIC-CONTROL-NEEDS"
    DIAGNOSTIC_ENABLE_CONDITION_NEEDS = "DIAGNOSTIC-ENABLE-CONDITION-NEEDS"
    DIAGNOSTIC_EVENT_INFO_NEEDS = "DIAGNOSTIC-EVENT-INFO-NEEDS"
    DIAGNOSTIC_EVENT_MANAGER_NEEDS = "DIAGNOSTIC-EVENT-MANAGER-NEEDS"
    DIAGNOSTIC_EVENT_NEEDS = "DIAGNOSTIC-EVENT-NEEDS"
    DIAGNOSTIC_GENERIC_UDS_NEEDS = "DIAGNOSTIC-GENERIC-UDS-NEEDS"
    DIAGNOSTIC_INDICATOR_NEEDS = "DIAGNOSTIC-INDICATOR-NEEDS"
    DIAGNOSTIC_IO_CONTROL_NEEDS = "DIAGNOSTIC-IO-CONTROL-NEEDS"
    DIAGNOSTIC_OPERATION_CYCLE_NEEDS = "DIAGNOSTIC-OPERATION-CYCLE-NEEDS"
    DIAGNOSTIC_REQUEST_FILE_TRANSFER_NEEDS = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-NEEDS"
    DIAGNOSTIC_RESPONSE_ON_EVENT_NEEDS = "DIAGNOSTIC-RESPONSE-ON-EVENT-NEEDS"
    DIAGNOSTIC_ROUTINE_NEEDS = "DIAGNOSTIC-ROUTINE-NEEDS"
    DIAGNOSTIC_STORAGE_CONDITION_NEEDS = "DIAGNOSTIC-STORAGE-CONDITION-NEEDS"
    DIAGNOSTIC_UPLOAD_DOWNLOAD_NEEDS = "DIAGNOSTIC-UPLOAD-DOWNLOAD-NEEDS"
    DIAGNOSTIC_VALUE_NEEDS = "DIAGNOSTIC-VALUE-NEEDS"
    DIAGNOSTICS_COMMUNICATION_SECURITY_NEEDS = "DIAGNOSTICS-COMMUNICATION-SECURITY-NEEDS"
    DLT_USER_NEEDS = "DLT-USER-NEEDS"
    DO_IP_ACTIVATION_LINE_NEEDS = "DO-IP-ACTIVATION-LINE-NEEDS"
    DO_IP_GID_NEEDS = "DO-IP-GID-NEEDS"
    DO_IP_GID_SYNCHRONIZATION_NEEDS = "DO-IP-GID-SYNCHRONIZATION-NEEDS"
    DO_IP_POWER_MODE_STATUS_NEEDS = "DO-IP-POWER-MODE-STATUS-NEEDS"
    DO_IP_ROUTING_ACTIVATION_AUTHENTICATION_NEEDS = "DO-IP-ROUTING-ACTIVATION-AUTHENTICATION-NEEDS"
    DO_IP_ROUTING_ACTIVATION_CONFIRMATION_NEEDS = "DO-IP-ROUTING-ACTIVATION-CONFIRMATION-NEEDS"
    DO_IP_SERVICE_NEEDS = "DO-IP-SERVICE-NEEDS"
    DTC_STATUS_CHANGE_NOTIFICATION_NEEDS = "DTC-STATUS-CHANGE-NOTIFICATION-NEEDS"
    ECU_STATE_MGR_USER_NEEDS = "ECU-STATE-MGR-USER-NEEDS"
    ERROR_TRACER_NEEDS = "ERROR-TRACER-NEEDS"
    FUNCTION_INHIBITION_AVAILABILITY_NEEDS = "FUNCTION-INHIBITION-AVAILABILITY-NEEDS"
    FUNCTION_INHIBITION_NEEDS = "FUNCTION-INHIBITION-NEEDS"
    FURTHER_ACTION_BYTE_NEEDS = "FURTHER-ACTION-BYTE-NEEDS"
    GLOBAL_SUPERVISION_NEEDS = "GLOBAL-SUPERVISION-NEEDS"
    HARDWARE_TEST_NEEDS = "HARDWARE-TEST-NEEDS"
    IDS_MGR_CUSTOM_TIMESTAMP_NEEDS = "IDS-MGR-CUSTOM-TIMESTAMP-NEEDS"
    IDS_MGR_NEEDS = "IDS-MGR-NEEDS"
    INDICATOR_STATUS_NEEDS = "INDICATOR-STATUS-NEEDS"
    J_1939_DCM_DM_19_SUPPORT = "J-1939-DCM-DM-19-SUPPORT"
    J_1939_RM_INCOMING_REQUEST_SERVICE_NEEDS = "J-1939-RM-INCOMING-REQUEST-SERVICE-NEEDS"
    J_1939_RM_OUTGOING_REQUEST_SERVICE_NEEDS = "J-1939-RM-OUTGOING-REQUEST-SERVICE-NEEDS"
    NV_BLOCK_NEEDS = "NV-BLOCK-NEEDS"
    OBD_CONTROL_SERVICE_NEEDS = "OBD-CONTROL-SERVICE-NEEDS"
    OBD_INFO_SERVICE_NEEDS = "OBD-INFO-SERVICE-NEEDS"
    OBD_MONITOR_SERVICE_NEEDS = "OBD-MONITOR-SERVICE-NEEDS"
    OBD_PID_SERVICE_NEEDS = "OBD-PID-SERVICE-NEEDS"
    OBD_RATIO_DENOMINATOR_NEEDS = "OBD-RATIO-DENOMINATOR-NEEDS"
    OBD_RATIO_SERVICE_NEEDS = "OBD-RATIO-SERVICE-NEEDS"
    SECURE_ON_BOARD_COMMUNICATION_NEEDS = "SECURE-ON-BOARD-COMMUNICATION-NEEDS"
    SERVICE_NEEDS = "SERVICE-NEEDS"
    SUPERVISED_ENTITY_CHECKPOINT_NEEDS = "SUPERVISED-ENTITY-CHECKPOINT-NEEDS"
    SUPERVISED_ENTITY_NEEDS = "SUPERVISED-ENTITY-NEEDS"
    SYNC_TIME_BASE_MGR_USER_NEEDS = "SYNC-TIME-BASE-MGR-USER-NEEDS"
    V_2_X_DATA_MANAGER_NEEDS = "V-2-X-DATA-MANAGER-NEEDS"
    V_2_X_FAC_USER_NEEDS = "V-2-X-FAC-USER-NEEDS"
    V_2_X_M_USER_NEEDS = "V-2-X-M-USER-NEEDS"
    VENDOR_SPECIFIC_SERVICE_NEEDS = "VENDOR-SPECIFIC-SERVICE-NEEDS"
    WARNING_INDICATOR_REQUESTED_BIT_NEEDS = "WARNING-INDICATOR-REQUESTED-BIT-NEEDS"


class ServiceProviderEnumSimple(Enum):
    """
    :cvar ANY_STANDARDIZED: This value means that the specific nature is
        either unknown or it is not important for the given purpose.
        This is also the default value for any attribute of type
        ServiceProviderEnum
    :cvar BASIC_SOFTWARE_MODE_MANAGER: The service relates to the Basic
        Software Mode Manager (BswM)
    :cvar COM_MANAGER: The service relates to the COM Manager (ComM).
    :cvar CRYPTO_KEY_MANAGEMENT: The service relates to the Key Manager
        (KeyM).
    :cvar CRYPTO_SERVICE_MANAGER: The service relates to the Crypto
        Service Manager (CsM).
    :cvar DEFAULT_ERROR_TRACER: The service relates to the Default Error
        Tracer (DET)
    :cvar DEVELOPMENT_ERROR_TRACER: The service relates to the
        Development Error Tracer (DET).
    :cvar DIAGNOSTIC_COMMUNICATION_MANAGER: The service relates to the
        Diagnostic Communication Manager (DCM).
    :cvar DIAGNOSTIC_EVENT_MANAGER: The service relates to the
        Diagnostic Event Manager (DEM).
    :cvar DIAGNOSTIC_LOG_AND_TRACE: The service relates to the
        Diagnostic Log and Trace (DLT).
    :cvar ECU_MANAGER: The service relates to the ECU Manager (EcuM).
    :cvar ERROR_TRACER: This service relates to the error tracer.
    :cvar FUNCTION_INHIBITION_MANAGER: The service relates to the
        Function Inhibition Manager (FIM).
    :cvar HARDWARE_TEST_MANAGER: This service relates to the hardware
        test manager.
    :cvar INTRUSION_DETECTION_SECURITY_MANAGEMENT: The service relates
        to the intrusion detection security management (IdsM).
    :cvar J_1939_DCM: This service relates to the J1939 Dcm.
    :cvar J_1939_REQUEST_MANAGER: The service relates to the J1939Rm.
    :cvar NON_VOLATILE_RAM_MANAGER: The service relates to the Non-
        Volatile RAM Manager (NvM).
    :cvar OPERATING_SYSTEM: The service relates to the Operating System
        (OS).
    :cvar SECURE_ON_BOARD_COMMUNICATION: The service relates to the
        SecOc module.
    :cvar SYNC_BASE_TIME_MANAGER: The service relates to the Sync Time
        Base Manager (StbM).
    :cvar V_2_X_FACILITIES: This service relates to the Vehicle to X
        facilities.
    :cvar V_2_X_MANAGEMENT: This service relates to the Vehicle to X
        management.
    :cvar VENDOR_SPECIFIC: This value denotes a vendor-specific service.
    :cvar WATCH_DOG_MANAGER: The service relates to the Watchdog Manager
        (WdgM).
    """

    ANY_STANDARDIZED = "ANY-STANDARDIZED"
    BASIC_SOFTWARE_MODE_MANAGER = "BASIC-SOFTWARE-MODE-MANAGER"
    COM_MANAGER = "COM-MANAGER"
    CRYPTO_KEY_MANAGEMENT = "CRYPTO-KEY-MANAGEMENT"
    CRYPTO_SERVICE_MANAGER = "CRYPTO-SERVICE-MANAGER"
    DEFAULT_ERROR_TRACER = "DEFAULT-ERROR-TRACER"
    DEVELOPMENT_ERROR_TRACER = "DEVELOPMENT-ERROR-TRACER"
    DIAGNOSTIC_COMMUNICATION_MANAGER = "DIAGNOSTIC-COMMUNICATION-MANAGER"
    DIAGNOSTIC_EVENT_MANAGER = "DIAGNOSTIC-EVENT-MANAGER"
    DIAGNOSTIC_LOG_AND_TRACE = "DIAGNOSTIC-LOG-AND-TRACE"
    ECU_MANAGER = "ECU-MANAGER"
    ERROR_TRACER = "ERROR-TRACER"
    FUNCTION_INHIBITION_MANAGER = "FUNCTION-INHIBITION-MANAGER"
    HARDWARE_TEST_MANAGER = "HARDWARE-TEST-MANAGER"
    INTRUSION_DETECTION_SECURITY_MANAGEMENT = "INTRUSION-DETECTION-SECURITY-MANAGEMENT"
    J_1939_DCM = "J-1939-DCM"
    J_1939_REQUEST_MANAGER = "J-1939-REQUEST-MANAGER"
    NON_VOLATILE_RAM_MANAGER = "NON-VOLATILE-RAM-MANAGER"
    OPERATING_SYSTEM = "OPERATING-SYSTEM"
    SECURE_ON_BOARD_COMMUNICATION = "SECURE-ON-BOARD-COMMUNICATION"
    SYNC_BASE_TIME_MANAGER = "SYNC-BASE-TIME-MANAGER"
    V_2_X_FACILITIES = "V-2-X-FACILITIES"
    V_2_X_MANAGEMENT = "V-2-X-MANAGEMENT"
    VENDOR_SPECIFIC = "VENDOR-SPECIFIC"
    WATCH_DOG_MANAGER = "WATCH-DOG-MANAGER"


class ServiceVersionAcceptanceKindEnumSimple(Enum):
    """
    :cvar EXACT_OR_ANY_MINOR_VERSION: Search for ANY or specific minor
        version service instance and select either ALL returned service
        instances (in case of ANY) or exactly the specific minor version
        service instances defined in requiredMinorVersion.
    :cvar MINIMUM_MINOR_VERSION: Search for ANY minor version service
        instance and select only those service instances which have an
        equal or greater minor version than given in
        requiredMinorVersion.
    """

    EXACT_OR_ANY_MINOR_VERSION = "EXACT-OR-ANY-MINOR-VERSION"
    MINIMUM_MINOR_VERSION = "MINIMUM-MINOR-VERSION"


class SeverityEnumSimple(Enum):
    """
    :cvar ERROR: Something is not right. High risk of interoperability
        issues.
    :cvar INFO: Something was found that is worth mentioning. Low risk
        of interoperability issues.
    :cvar WARNING: Something might be wrong depending on the context.
        Medium risk of interoperability issues.
    """

    ERROR = "ERROR"
    INFO = "INFO"
    WARNING = "WARNING"


class ShowContentEnumSimple(Enum):
    """
    :cvar NO_SHOW_CONTENT: The content of the Xref.label is '''not'''
        rendered at the place of the reference.
    :cvar SHOW_CONTENT: The content of the element is rendered at the
        place of the reference.
    """

    NO_SHOW_CONTENT = "NO-SHOW-CONTENT"
    SHOW_CONTENT = "SHOW-CONTENT"


class ShowResourceAliasNameEnumSimple(Enum):
    """
    :cvar NO_SHOW_ALIAS_NAME: This indicates that alias names of the
        referenced object shall '''not''' be rendered at the place of
        the reference.
    :cvar SHOW_ALIAS_NAME: This indicates that the alias names of the
        referenced object shall be rendered at the place of the
        reference.
    """

    NO_SHOW_ALIAS_NAME = "NO-SHOW-ALIAS-NAME"
    SHOW_ALIAS_NAME = "SHOW-ALIAS-NAME"


class ShowResourceCategoryEnumSimple(Enum):
    """
    :cvar NO_SHOW_CATEGORY: The category of the target is '''not'''
        rendered at the place of the reference.
    :cvar SHOW_CATEGORY: The category of the target is  rendered at the
        place of the reference.
    """

    NO_SHOW_CATEGORY = "NO-SHOW-CATEGORY"
    SHOW_CATEGORY = "SHOW-CATEGORY"


class ShowResourceLongNameEnumSimple(Enum):
    """
    :cvar NO_SHOW_LONG_NAME: The long name of the target is '''not'''
        rendered at the place of the reference.
    :cvar SHOW_LONG_NAME: The long name of the target is rendered at the
        place of the reference.
    """

    NO_SHOW_LONG_NAME = "NO-SHOW-LONG-NAME"
    SHOW_LONG_NAME = "SHOW-LONG-NAME"


class ShowResourceNumberEnumSimple(Enum):
    """
    :cvar NO_SHOW_NUMBER: The number of the target is '''not''' rendered
        at the place of the reference.
    :cvar SHOW_NUMBER: The number of the target is rendered at the place
        of the reference.
    """

    NO_SHOW_NUMBER = "NO-SHOW-NUMBER"
    SHOW_NUMBER = "SHOW-NUMBER"


class ShowResourcePageEnumSimple(Enum):
    """
    :cvar NO_SHOW_PAGE: The page number  of the target is '''not'''
        rendered at the place of the reference.
    :cvar SHOW_PAGE: The page number  of the target is rendered at the
        place of the reference.
    """

    NO_SHOW_PAGE = "NO-SHOW-PAGE"
    SHOW_PAGE = "SHOW-PAGE"


class ShowResourceShortNameEnumSimple(Enum):
    """
    :cvar NO_SHOW_SHORT_NAME: The short name of the target is '''not'''
        rendered at the place of the reference.
    :cvar SHOW_SHORT_NAME: The short name of the target is rendered at
        the place of the reference.
    """

    NO_SHOW_SHORT_NAME = "NO-SHOW-SHORT-NAME"
    SHOW_SHORT_NAME = "SHOW-SHORT-NAME"


class ShowResourceTypeEnumSimple(Enum):
    """
    :cvar NO_SHOW_TYPE: The type of the target is '''not''' rendered at
        the place of the reference.
    :cvar SHOW_TYPE: The type of the target is rendered at the place of
        the reference.
    """

    NO_SHOW_TYPE = "NO-SHOW-TYPE"
    SHOW_TYPE = "SHOW-TYPE"


class ShowSeeEnumSimple(Enum):
    """
    :cvar NO_SHOW_SEE: The word "see" is '''not''' rendered before  the
        reference.
    :cvar SHOW_SEE: The word "see"is rendered before the reference.
    """

    NO_SHOW_SEE = "NO-SHOW-SEE"
    SHOW_SEE = "SHOW-SEE"


class SignalFanEnumSimple(Enum):
    """
    :cvar NFOLD: The connections internally in the
        CompositionSwComponentType via DelegationSwConnectors and
        AssemblySwConnectors are defined in a way that at least one data
        element present in the S/R interface or one
        ClientServerOperation in the C/S interface of the outer
        PortPrototype is involved in a 1:n or n:1 communication pattern.
    :cvar SINGLE: The connections internally in the
        CompositionSwComponentType via DelegationSwConnectors and
        AssemblySwConnectors are defined in a way that each
        VariableDataPrototype  present in the S/R interface or
        ClientServerOperation in the C/S interface of the outer
        PortPrototype is involved in a 1:1 communication pattern only.
    """

    NFOLD = "NFOLD"
    SINGLE = "SINGLE"


class SignalServiceTranslationControlEnumSimple(Enum):
    """
    :cvar ALL_PARTIAL_NETWORKS_ACTIVE: Defines the start of service
        control when all specified partial networks are active.
    :cvar ANY_PARTIAL_NETWORK_ACTIVE: Defines the start of service
        control when any specified partial network is active.
    :cvar PARTIAL_NETWORK: Defines the start of service control when
        specific partial networks are active.
    :cvar SERVICE_DISCOVERY: Defines the start of service control when
        other service is available.
    :cvar TRANSLATION_START: Defines the start of service control at
        translation start.
    """

    ALL_PARTIAL_NETWORKS_ACTIVE = "ALL-PARTIAL-NETWORKS-ACTIVE"
    ANY_PARTIAL_NETWORK_ACTIVE = "ANY-PARTIAL-NETWORK-ACTIVE"
    PARTIAL_NETWORK = "PARTIAL-NETWORK"
    SERVICE_DISCOVERY = "SERVICE-DISCOVERY"
    TRANSLATION_START = "TRANSLATION-START"


class SoAdConnectorTypeSimple(Enum):
    """
    :cvar DO_IP: Diagnosis over IP
    :cvar PDU_R: Pdu Router
    :cvar UDP_NM: Udp Nm
    :cvar XCP: Universal Measurement and Calibration Protocol
    """

    DO_IP = "DO-IP"
    PDU_R = "PDU-R"
    UDP_NM = "UDP-NM"
    XCP = "XCP"


class SoAdProtocolTypeSimple(Enum):
    """
    :cvar TCP: Transmission Control Protocol (TCP) enables two hosts to
        establish a connection and exchange streams of data.
    :cvar UDP: User Datagram Protocol (UDP) offers a connectionless way
        to send and receive datagrams over an IP network. It's used
        primarily for broadcasting messages over a network.
    """

    TCP = "TCP"
    UDP = "UDP"


class SoAdRoutingGroupSubtypesEnum(Enum):
    SO_AD_ROUTING_GROUP = "SO-AD-ROUTING-GROUP"


class SoConIPduIdentifierSubtypesEnum(Enum):
    SO_CON_I_PDU_IDENTIFIER = "SO-CON-I-PDU-IDENTIFIER"


class SocketAddressSubtypesEnum(Enum):
    SOCKET_ADDRESS = "SOCKET-ADDRESS"


class SocketConnectionBundleSubtypesEnum(Enum):
    SOCKET_CONNECTION_BUNDLE = "SOCKET-CONNECTION-BUNDLE"


class SoftwareClusterSubtypesEnum(Enum):
    SOFTWARE_CLUSTER = "SOFTWARE-CLUSTER"


class SoftwareClusterDependencyLogicalOperatorEnumSimple(Enum):
    """
    :cvar LOGICAL_AND: logical and
    :cvar LOGICAL_OR: logical or
    """

    LOGICAL_AND = "LOGICAL-AND"
    LOGICAL_OR = "LOGICAL-OR"


class SoftwareClusterDependencyOperatorEnumSimple(Enum):
    """
    :cvar IS_EQUAL: equal
    :cvar IS_GREATER_THAN: greater than
    :cvar IS_GREATER_THAN_OR_EQUAL: greater than or equal
    :cvar IS_LESS_THAN: less than
    :cvar IS_LESS_THAN_OR_EQUAL: less than or equal
    """

    IS_EQUAL = "IS-EQUAL"
    IS_GREATER_THAN = "IS-GREATER-THAN"
    IS_GREATER_THAN_OR_EQUAL = "IS-GREATER-THAN-OR-EQUAL"
    IS_LESS_THAN = "IS-LESS-THAN"
    IS_LESS_THAN_OR_EQUAL = "IS-LESS-THAN-OR-EQUAL"


class SoftwareClusterDesignSubtypesEnum(Enum):
    SOFTWARE_CLUSTER_DESIGN = "SOFTWARE-CLUSTER-DESIGN"


class SoftwareClusterDiagnosticAddressSemanticsEnumSimple(Enum):
    """
    :cvar FUNCTIONAL_ADDRESS: This address represents a functional
        address.
    :cvar PHYSICAL_ADDRESS: This address represents a physical address.
    """

    FUNCTIONAL_ADDRESS = "FUNCTIONAL-ADDRESS"
    PHYSICAL_ADDRESS = "PHYSICAL-ADDRESS"


class SoftwareClusterDiagnosticDeploymentPropsSubtypesEnum(Enum):
    SOFTWARE_CLUSTER_DIAGNOSTIC_DEPLOYMENT_PROPS = "SOFTWARE-CLUSTER-DIAGNOSTIC-DEPLOYMENT-PROPS"


class SoftwareClusterInstallationBehaviorEnumSimple(Enum):
    """
    :cvar CAN_BE_REMOVED: The enclosing SoftwareCluster can be removed
        from the target Machine or updated with a newer version.
    :cvar CANNOT_BE_REMOVED: The enclosing SoftwareCluster cannot be
        removed from the target Machine. It can only be updated with a
        newer version.
    """

    CAN_BE_REMOVED = "CAN-BE-REMOVED"
    CANNOT_BE_REMOVED = "CANNOT-BE-REMOVED"


class SoftwarePackageSubtypesEnum(Enum):
    SOFTWARE_PACKAGE = "SOFTWARE-PACKAGE"


class SoftwarePackageActionTypeEnumSimple(Enum):
    """
    :cvar INSTALL: Do a clean installation of a SoftwareCluster.
    :cvar REMOVE: Remove a SoftwareCluster.
    :cvar UPDATE: Update a previously installed SoftwareCluster.
    """

    INSTALL = "INSTALL"
    REMOVE = "REMOVE"
    UPDATE = "UPDATE"


class SoftwarePackageActivationActionEnumSimple(Enum):
    """
    :cvar NOTHING: The installation has no immediate consequences in
        terms of other software on the target.
    :cvar REBOOT: Reboot the whole Machine.
    :cvar RESTART_APPLICATION: Restart the application software on the
        target Machine.
    """

    NOTHING = "NOTHING"
    REBOOT = "REBOOT"
    RESTART_APPLICATION = "RESTART-APPLICATION"


class SoftwarePackageStoringEnumSimple(Enum):
    """
    :cvar NONE: No storing in vehicle.
    :cvar UCM: Storing in UCM (subordinate).
    :cvar UCM_MASTER: Storing in Ucm Master.
    """

    NONE = "NONE"
    UCM = "UCM"
    UCM_MASTER = "UCM-MASTER"


class SomeipEventDeploymentSubtypesEnum(Enum):
    SOMEIP_EVENT_DEPLOYMENT = "SOMEIP-EVENT-DEPLOYMENT"


class SomeipEventGroupSubtypesEnum(Enum):
    SOMEIP_EVENT_GROUP = "SOMEIP-EVENT-GROUP"


class SomeipMessageTypeEnumSimple(Enum):
    """
    :cvar ERROR: The response containing an error.
    :cvar NOTIFICATION: A request of a notification expecting no
        response.
    :cvar REQUEST: A request expecting a response.
    :cvar REQUEST_NO_RETURN: A fire&amp;forget request.
    :cvar RESPONSE: The response message.
    """

    ERROR = "ERROR"
    NOTIFICATION = "NOTIFICATION"
    REQUEST = "REQUEST"
    REQUEST_NO_RETURN = "REQUEST-NO-RETURN"
    RESPONSE = "RESPONSE"


class SomeipMethodDeploymentSubtypesEnum(Enum):
    SOMEIP_METHOD_DEPLOYMENT = "SOMEIP-METHOD-DEPLOYMENT"


class SomeipRemoteMulticastConfigSubtypesEnum(Enum):
    SOMEIP_REMOTE_MULTICAST_CONFIG = "SOMEIP-REMOTE-MULTICAST-CONFIG"


class SomeipRemoteUnicastConfigSubtypesEnum(Enum):
    SOMEIP_REMOTE_UNICAST_CONFIG = "SOMEIP-REMOTE-UNICAST-CONFIG"


class SomeipSdClientEventGroupTimingConfigSubtypesEnum(Enum):
    SOMEIP_SD_CLIENT_EVENT_GROUP_TIMING_CONFIG = "SOMEIP-SD-CLIENT-EVENT-GROUP-TIMING-CONFIG"


class SomeipSdClientServiceInstanceConfigSubtypesEnum(Enum):
    SOMEIP_SD_CLIENT_SERVICE_INSTANCE_CONFIG = "SOMEIP-SD-CLIENT-SERVICE-INSTANCE-CONFIG"


class SomeipSdServerEventGroupTimingConfigSubtypesEnum(Enum):
    SOMEIP_SD_SERVER_EVENT_GROUP_TIMING_CONFIG = "SOMEIP-SD-SERVER-EVENT-GROUP-TIMING-CONFIG"


class SomeipSdServerServiceInstanceConfigSubtypesEnum(Enum):
    SOMEIP_SD_SERVER_SERVICE_INSTANCE_CONFIG = "SOMEIP-SD-SERVER-SERVICE-INSTANCE-CONFIG"


class SomeipTpChannelSubtypesEnum(Enum):
    SOMEIP_TP_CHANNEL = "SOMEIP-TP-CHANNEL"


class SomeipTransformerSessionHandlingEnumSimple(Enum):
    """
    :cvar SESSION_HANDLING_ACTIVE: The SOME/IP Transformer shall use
        session handling
    :cvar SESSION_HANDLING_INACTIVE: The SOME/IP Transformer doesn't use
        session handling
    """

    SESSION_HANDLING_ACTIVE = "SESSION-HANDLING-ACTIVE"
    SESSION_HANDLING_INACTIVE = "SESSION-HANDLING-INACTIVE"


class StandardNameEnumSimple(Enum):
    """
    :cvar AP: This values represents the Adaptive Platform.
    :cvar CP: This Value represents the Classic Platform.
    :cvar FO: This values represents the Foundation.
    :cvar TA: This Values represents the Testing of the Adaptive
        Platform.
    :cvar TC: This values represents the Testing of the Classic
        Platform.
    """

    AP = "AP"
    CP = "CP"
    FO = "FO"
    TA = "TA"
    TC = "TC"


class StartupConfigSubtypesEnum(Enum):
    STARTUP_CONFIG = "STARTUP-CONFIG"


class StateDependentFirewallSubtypesEnum(Enum):
    STATE_DEPENDENT_FIREWALL = "STATE-DEPENDENT-FIREWALL"


class StateManagementCompareEnumSimple(Enum):
    """
    :cvar IS_EQUAL: Equal
    """

    IS_EQUAL = "IS-EQUAL"


class StateManagementLogicalOperatorEnumSimple(Enum):
    """
    :cvar LOGICAL_AND: This value represents the semantics of a  logical
        "and"
    :cvar LOGICAL_OR: This value represents the semantics of a logical
        "or"
    """

    LOGICAL_AND = "LOGICAL-AND"
    LOGICAL_OR = "LOGICAL-OR"


class StaticSocketConnectionSubtypesEnum(Enum):
    STATIC_SOCKET_CONNECTION = "STATIC-SOCKET-CONNECTION"


class StorageConditionStatusEnumSimple(Enum):
    """
    :cvar EVENT_STORAGE_DISABLED: Storage of a diagnostic event is
        disabled.
    :cvar EVENT_STORAGE_ENABLED: Storage of a diagnostic event is
        enabled.
    """

    EVENT_STORAGE_DISABLED = "EVENT-STORAGE-DISABLED"
    EVENT_STORAGE_ENABLED = "EVENT-STORAGE-ENABLED"


@dataclass(slots=True, kw_only=True)
class String:
    """This represents a String in which white-space shall be normalized before
    processing.

    For example: in order to compare two Strings:
    * leading and trailing white-space needs to be removed
    * consecutive white-space (blank, cr, lf, tab) needs to be replaced by one blank.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class StrongRevisionLabelString:
    """This primitive represents a revision label which identifies an object under
    version control.

    It represents a pattern which requires three integer numbers separated by a dot, representing from left to right MajorVersion, MinorVersion, PatchVersion and additional labels for pre-release version and build metadata.
    Legal patterns are for example:
    1.0.0-alpha+001
    1.0.0+20130313144700
    1.0.0-beta+exp.sha.5114f85

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STRONG-REVISION-LABEL-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)(-((0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*)(\.(0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*))*))?(\+([0-9a-zA-Z-]+(\.[0-9a-zA-Z-]+)*))?",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class SupervisedEntityCheckpointNeedsSubtypesEnum(Enum):
    SUPERVISED_ENTITY_CHECKPOINT_NEEDS = "SUPERVISED-ENTITY-CHECKPOINT-NEEDS"


class SupervisionCheckpointSubtypesEnum(Enum):
    SUPERVISION_CHECKPOINT = "SUPERVISION-CHECKPOINT"


class SupervisionModeConditionSubtypesEnum(Enum):
    SUPERVISION_MODE_CONDITION = "SUPERVISION-MODE-CONDITION"


class SupportBufferLockingEnumSimple(Enum):
    """
    :cvar DOES_NOT_SUPPORT_BUFFER_LOCKING: Buffer locking is not
        supported.
    :cvar SUPPORTS_BUFFER_LOCKING: Buffer locking is supported.
    """

    DOES_NOT_SUPPORT_BUFFER_LOCKING = "DOES-NOT-SUPPORT-BUFFER-LOCKING"
    SUPPORTS_BUFFER_LOCKING = "SUPPORTS-BUFFER-LOCKING"


@dataclass(slots=True, kw_only=True)
class Supscript:
    """
    This is text which is rendered superscript or subscript depending on the role.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SUPSCRIPT"

    value: str = field(
        default="",
        metadata={
            "required": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class SwAddrMethodSubtypesEnum(Enum):
    SW_ADDR_METHOD = "SW-ADDR-METHOD"


class SwAxisTypeSubtypesEnum(Enum):
    SW_AXIS_TYPE = "SW-AXIS-TYPE"


class SwBaseTypeSubtypesEnum(Enum):
    SW_BASE_TYPE = "SW-BASE-TYPE"


class SwCalibrationAccessEnumSimple(Enum):
    """
    :cvar NOT_ACCESSIBLE: The element will not be accessible via MCD
        tools, i.e. will not appear in the ASAP file.
    :cvar READ_ONLY: The element will only appear as read-only in an
        ASAP file.
    :cvar READ_WRITE: The element will appear in the ASAP file with both
        read and write access.
    """

    NOT_ACCESSIBLE = "NOT-ACCESSIBLE"
    READ_ONLY = "READ-ONLY"
    READ_WRITE = "READ-WRITE"


class SwComponentMappingConstraintsSubtypesEnum(Enum):
    SW_COMPONENT_MAPPING_CONSTRAINTS = "SW-COMPONENT-MAPPING-CONSTRAINTS"


class SwComponentPrototypeSubtypesEnum(Enum):
    SW_COMPONENT_PROTOTYPE = "SW-COMPONENT-PROTOTYPE"


class SwComponentTypeSubtypesEnum(Enum):
    ADAPTIVE_APPLICATION_SW_COMPONENT_TYPE = "ADAPTIVE-APPLICATION-SW-COMPONENT-TYPE"
    APPLICATION_SW_COMPONENT_TYPE = "APPLICATION-SW-COMPONENT-TYPE"
    ATOMIC_SW_COMPONENT_TYPE = "ATOMIC-SW-COMPONENT-TYPE"
    COMPLEX_DEVICE_DRIVER_SW_COMPONENT_TYPE = "COMPLEX-DEVICE-DRIVER-SW-COMPONENT-TYPE"
    COMPOSITION_SW_COMPONENT_TYPE = "COMPOSITION-SW-COMPONENT-TYPE"
    ECU_ABSTRACTION_SW_COMPONENT_TYPE = "ECU-ABSTRACTION-SW-COMPONENT-TYPE"
    NV_BLOCK_SW_COMPONENT_TYPE = "NV-BLOCK-SW-COMPONENT-TYPE"
    PARAMETER_SW_COMPONENT_TYPE = "PARAMETER-SW-COMPONENT-TYPE"
    SENSOR_ACTUATOR_SW_COMPONENT_TYPE = "SENSOR-ACTUATOR-SW-COMPONENT-TYPE"
    SERVICE_PROXY_SW_COMPONENT_TYPE = "SERVICE-PROXY-SW-COMPONENT-TYPE"
    SERVICE_SW_COMPONENT_TYPE = "SERVICE-SW-COMPONENT-TYPE"
    SW_COMPONENT_TYPE = "SW-COMPONENT-TYPE"


@dataclass(slots=True, kw_only=True)
class SwDataDefProps:
    """This class is a collection of properties relevant for data objects under
    various aspects.

    One could consider this class as a "pattern of inheritance by aggregation". The properties can be applied to all objects of all classes in which SwDataDefProps is aggregated.
    '''begin restrict to CP AP'''
    Note that not all of the attributes or associated elements are useful all of the time. Hence, the process definition (e.g. expressed with an OCL or a Document Control Instance MSR-DCI) has the task of implementing limitations.
    SwDataDefProps covers various aspects:
    * Structure of the data element for calibration use cases: is it a single value, a curve, or a map, but also the recordLayouts which specify how such elements are mapped/converted to the DataTypes in the programming language (or in AUTOSAR). This is mainly expressed by properties like swRecordLayout and swCalprmAxisSet
    * Implementation aspects, mainly expressed by swImplPolicy, swVariableAccessImplPolicy, swAddrMethod, swPointerTagetProps, baseType, implementationDataType and additionalNativeTypeQualifier
    * Access policy for the MCD system, mainly expressed by swCalibrationAccess
    * Semantics of the data element, mainly expressed by compuMethod and/or unit, dataConstr, invalidValue
    * Code generation policy provided by swRecordLayout
    '''end restrict to CP AP'''

    :ivar sw_data_def_props_variants: This element was
        generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-DATA-DEF-PROPS"

    sw_data_def_props_variants: Optional["SwDataDefProps.SwDataDefPropsVariants"] = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SwDataDefPropsVariants:
        sw_data_def_props_conditional: list["SwDataDefPropsConditional"] = field(
            default_factory=list,
            metadata={
                "name": "SW-DATA-DEF-PROPS-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


class SwGenericAxisParamTypeSubtypesEnum(Enum):
    SW_GENERIC_AXIS_PARAM_TYPE = "SW-GENERIC-AXIS-PARAM-TYPE"


class SwImplPolicyEnumSimple(Enum):
    """
    :cvar CONST: forced implementation such that the  running software
        within the ECU  shall not modify it. For example implemented
        with the "const" modifier in C.  This can be applied for
        parameters (not for those in NVRAM) as well as argument  data
        prototypes.
    :cvar FIXED: This data element is fixed. In particular this
        indicates, that it  might also be implemented  e.g. as in place
        data, (#DEFINE).
    :cvar MEASUREMENT_POINT: The data element is created for measurement
        purposes only.  The data element is never read directly within
        the ECU software. In contrast to  a "standard" data element in
        an unconnected provide port is, this unconnection  is guaranteed
        for  measurementPoint data elements.
    :cvar QUEUED: The content of the data element is queued and the data
        element has 'event' semantics, i.e. data elements are stored in
        a queue and all data  elements are processed in 'first in first
        out' order. The queuing is intended to be implemented by RTE
        Generator. This value is not applicable for parameters.
    :cvar STANDARD: This is applicable for all kinds of data elements.
        For variable  data prototypes the 'last is best' semantics
        applies. For parameter there is no  specific implementation
        directive.
    """

    CONST = "CONST"
    FIXED = "FIXED"
    MEASUREMENT_POINT = "MEASUREMENT-POINT"
    QUEUED = "QUEUED"
    STANDARD = "STANDARD"


class SwRecordLayoutSubtypesEnum(Enum):
    SW_RECORD_LAYOUT = "SW-RECORD-LAYOUT"


class SwServiceImplPolicyEnumSimple(Enum):
    """
    :cvar INLINE: inline service definition.
    :cvar INLINE_CONDITIONAL: The service (in AUTOSAR: BswModuleEntry)
        is implemented in a way that it either resolves to an inline
        function or to a standard function depending on conditions set
        at a later point in time. The following two values are
        standardized (to be used for code sections only and exclusively
        to each other): * INLINE - The code section is declared with the
        keyword "inline". * LOCAL_INLINE  - The code section is declared
        with the keyword "static inline". In both cases (INLINE and
        LOCAL_INLINE) the inline expansion depends on the compiler.
        Depending on this, the code section either corresponds to an
        actual section in memory or is put into the section of the
        caller.
    :cvar MACRO: macro service definition.
    :cvar STANDARD: Standard service and default value, if nothing is
        defined.
    """

    INLINE = "INLINE"
    INLINE_CONDITIONAL = "INLINE-CONDITIONAL"
    MACRO = "MACRO"
    STANDARD = "STANDARD"


class SwServiceReentranceEnumSimple(Enum):
    """
    :cvar REENTRANCE: If this element is not defined the service cannot
        be invoked when it is executing.
    """

    REENTRANCE = "REENTRANCE"


class SwSystemconstSubtypesEnum(Enum):
    SW_SYSTEMCONST = "SW-SYSTEMCONST"


class SwSystemconstantValueSetSubtypesEnum(Enum):
    SW_SYSTEMCONSTANT_VALUE_SET = "SW-SYSTEMCONSTANT-VALUE-SET"


class SwVariableAccessImplPolicyEnumSimple(Enum):
    """
    :cvar DIRECT: Messages with DIRECT access are read but ignored by
        data consistency tool. Data consistency is not guaranteed.
    :cvar OPTIMIZED: A Tool handles data consistency. In SwService,
        where a message is referenced, only OPTIMIZED access (also
        default value inside SwServcie) is possible.
    :cvar SELECTABLE: The user can decide inside each single service,
        where these message is referenced, if access to that shall be
        OPTIMIZED or DIRECT.
    """

    DIRECT = "DIRECT"
    OPTIMIZED = "OPTIMIZED"
    SELECTABLE = "SELECTABLE"


class SwcBswMappingSubtypesEnum(Enum):
    SWC_BSW_MAPPING = "SWC-BSW-MAPPING"


class SwcImplementationSubtypesEnum(Enum):
    SWC_IMPLEMENTATION = "SWC-IMPLEMENTATION"


class SwcInternalBehaviorSubtypesEnum(Enum):
    SWC_INTERNAL_BEHAVIOR = "SWC-INTERNAL-BEHAVIOR"


class SwcModeSwitchEventSubtypesEnum(Enum):
    SWC_MODE_SWITCH_EVENT = "SWC-MODE-SWITCH-EVENT"


class SwcServiceDependencySubtypesEnum(Enum):
    SWC_SERVICE_DEPENDENCY = "SWC-SERVICE-DEPENDENCY"


class SwcToEcuMappingSubtypesEnum(Enum):
    SWC_TO_ECU_MAPPING = "SWC-TO-ECU-MAPPING"


class SwcToEcuMappingConstraintTypeSimple(Enum):
    """
    :cvar DEDICATED: Dedicated mapping means that the SW-C can only be
        mapped to the ECUs it is dedicated to.
    :cvar EXCLUSIVE: Exclusive mapping means that the SW-C cannot be
        mapped to the ECUs it is excluded from.
    """

    DEDICATED = "DEDICATED"
    EXCLUSIVE = "EXCLUSIVE"


class SwcToSwcOperationArgumentsDirectionEnumSimple(Enum):
    """
    :cvar IN: IN (all IN and INOUT arguments)
    :cvar OUT: OUT (all OUT and INOUT arguments) .
    """

    IN = "IN"
    OUT = "OUT"


@dataclass(slots=True, kw_only=True)
class SymbolString:
    """This meta-class has the ability to contain a string plus an additional
    namePattern.

    Please note that this meta-class has only been introduced to fix an
    issue with the backwards compatibility between R4.0.3 and R4.1.1 in
    the context of McDataInstance

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar name_pattern: This attribute represents a pattern which shall
        be used to define the value of the identifier if the CIdentifier
        in question is part of a blueprint. For more details refer to
        TPS_StandardizationTemplate.
    """

    class Meta:
        name = "SYMBOL-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    name_pattern: str | None = field(
        default=None,
        metadata={
            "name": "NAME-PATTERN",
            "type": "Attribute",
        },
    )


class SynchronizationTypeEnumSimple(Enum):
    """
    :cvar RESPONSE_SYNCHRONIZATION: In case that the Synchronization
        Timing Constraint is specified for event chains, the response
        events of the associated event chains shall occur synchronously
        with respect to the specified tolerance. All associated event
        chains shall have the same stimulus event. In case that the
        Synchronization Timing Constraint is specified for events, the
        associated events shall occur synchronously with respect to the
        specified tolerance. All associated events represent the
        response events of a common stimulus event, even such a stimulus
        event is not known yet or not available in the scope of the
        model.
    :cvar STIMULUS_SYNCHRONIZATION: In case that the Synchronization
        Timing Constraint is specified for event chains, the stimulus
        events of the associated event chains shall occur synchronously
        with respect to the specified tolerance. All associated event
        chains shall have the same response event. In case that the
        Synchronization Timing Constraint is specified for events, the
        associated events shall occur synchronously with respect to the
        specified tolerance. All associated events represent the
        stimulus events of a common response event, even such a response
        event is not known yet or not available in the scope of the
        model.
    """

    RESPONSE_SYNCHRONIZATION = "RESPONSE-SYNCHRONIZATION"
    STIMULUS_SYNCHRONIZATION = "STIMULUS-SYNCHRONIZATION"


class SynchronizedTimeBaseConsumerSubtypesEnum(Enum):
    SYNCHRONIZED_TIME_BASE_CONSUMER = "SYNCHRONIZED-TIME-BASE-CONSUMER"


class SynchronizedTimeBaseProviderSubtypesEnum(Enum):
    SYNCHRONIZED_TIME_BASE_PROVIDER = "SYNCHRONIZED-TIME-BASE-PROVIDER"


class SystemSubtypesEnum(Enum):
    SYSTEM = "SYSTEM"


class SystemSignalSubtypesEnum(Enum):
    SYSTEM_SIGNAL = "SYSTEM-SIGNAL"


class SystemSignalGroupSubtypesEnum(Enum):
    SYSTEM_SIGNAL_GROUP = "SYSTEM-SIGNAL-GROUP"


@dataclass(slots=True, kw_only=True)
class TableSeparatorString:
    """This represents the ability to denote a separator string within an OASIS
    exchange table.

    * '''0''': no line is displayed
    * '''1''': line is displayed

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TABLE-SEPARATOR-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"[0-1]",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class TcpOptionFilterListSubtypesEnum(Enum):
    TCP_OPTION_FILTER_LIST = "TCP-OPTION-FILTER-LIST"


class TcpRoleEnumSimple(Enum):
    """
    :cvar CONNECT: Connects the client to a remote TCP host.
    :cvar LISTEN: Socket is put into the server mode (listen for
        connections).
    """

    CONNECT = "CONNECT"
    LISTEN = "LISTEN"


class TdEventBswInternalBehaviorTypeEnumSimple(Enum):
    """
    :cvar BSW_MODULE_ENTITY_ACTIVATED: A point in time where the
        associated BswModuleEntity has been activated, which means that
        it has entered the state "to be started".
    :cvar BSW_MODULE_ENTITY_STARTED: A point in time where the
        associated BswModuleEntity has entered the state "started" after
        its activation.
    :cvar BSW_MODULE_ENTITY_TERMINATED: A point in time where the
        associated BswModuleEntity has terminated and entered the state
        "suspended"
    """

    BSW_MODULE_ENTITY_ACTIVATED = "BSW-MODULE-ENTITY-ACTIVATED"
    BSW_MODULE_ENTITY_STARTED = "BSW-MODULE-ENTITY-STARTED"
    BSW_MODULE_ENTITY_TERMINATED = "BSW-MODULE-ENTITY-TERMINATED"


class TdEventBswModeDeclarationTypeEnumSimple(Enum):
    """
    :cvar MODE_DECLARATION_REQUESTED: A point in time where the
        associated ModeDeclarationGroupPrototype has been requested.
    :cvar MODE_DECLARATION_SWITCH_COMPLETED: A point in time where the
        switch to the associated ModeDeclarationGroupPrototype has been
        completed.
    :cvar MODE_DECLARATION_SWITCH_INITIATED: A point in time where the
        switch to the associated ModeDeclarationGroupPrototype has been
        initiated by the BswM.
    """

    MODE_DECLARATION_REQUESTED = "MODE-DECLARATION-REQUESTED"
    MODE_DECLARATION_SWITCH_COMPLETED = "MODE-DECLARATION-SWITCH-COMPLETED"
    MODE_DECLARATION_SWITCH_INITIATED = "MODE-DECLARATION-SWITCH-INITIATED"


class TdEventBswModuleTypeEnumSimple(Enum):
    """
    :cvar BSW_M_ENTRY_CALL_RETURNED: A point in time where the call of
        the associated BswModuleEntry has returned.
    :cvar BSW_M_ENTRY_CALLED: A point in time where the associated
        BswModuleEntry has been called.
    """

    BSW_M_ENTRY_CALL_RETURNED = "BSW-M-ENTRY-CALL-RETURNED"
    BSW_M_ENTRY_CALLED = "BSW-M-ENTRY-CALLED"


class TdEventFrameEthernetTypeEnumSimple(Enum):
    """
    :cvar FRAME_ETHERNET_QUEUED_FOR_TRANSMISSION: A point in time where
        the Ethernet frame containing the specified PDUs is queued for
        transmission within the corresponding Ethernet Communication
        Driver.
    :cvar FRAME_ETHERNET_RECEIVED_BY_IF: A point in time where the frame
        is pushed from the corresponding Ethernet communication
        controller to the BSW Ethernet communication interface.
    :cvar FRAME_ETHERNET_RECEIVED_ON_BUS: A point in time where the
        receipt of the Ethernet frame/packet completes successfully on
        the recipient's Ethernet communication controller. In other
        words, the Ethernet frame/packet has entered the recipient's
        Ethernet communication controller which means the last bit of
        the Ethernet frame/packet has been received.
    :cvar FRAME_ETHERNET_SENT_ON_BUS: A point in time where the
        transmission of the Ethernet frame/packet completes successfully
        on the physical Ethernet communication network. In other words,
        the Ethernet frame/packet has left the sender's Ethernet
        communication controller, which means that the last bit of the
        Ethernet frame/packet has been sent.
    """

    FRAME_ETHERNET_QUEUED_FOR_TRANSMISSION = "FRAME-ETHERNET-QUEUED-FOR-TRANSMISSION"
    FRAME_ETHERNET_RECEIVED_BY_IF = "FRAME-ETHERNET-RECEIVED-BY-IF"
    FRAME_ETHERNET_RECEIVED_ON_BUS = "FRAME-ETHERNET-RECEIVED-ON-BUS"
    FRAME_ETHERNET_SENT_ON_BUS = "FRAME-ETHERNET-SENT-ON-BUS"


class TdEventFrameTypeEnumSimple(Enum):
    """
    :cvar FRAME_QUEUED_FOR_TRANSMISSION: A point in time where the frame
        containing the named signal / I-PDU is queued for transmission
        within the related Communication Driver.
    :cvar FRAME_RECEIVED_BY_IF: A point in time where the frame is
        pushed from the subscriber's communication controller to the
        corresponding (FlexRay / CAN / LIN) Interface BSW module.
    :cvar FRAME_TRANSMITTED_ON_BUS: A point in time where the
        transmission of the frame completes successfully, and the
        subscriber's communication controller receives the frame from
        the bus.
    """

    FRAME_QUEUED_FOR_TRANSMISSION = "FRAME-QUEUED-FOR-TRANSMISSION"
    FRAME_RECEIVED_BY_IF = "FRAME-RECEIVED-BY-IF"
    FRAME_TRANSMITTED_ON_BUS = "FRAME-TRANSMITTED-ON-BUS"


class TdEventIPduTypeEnumSimple(Enum):
    """
    :cvar I_PDU_RECEIVED_BY_COM: A point in time where the received
        frame is processed by the corresponding (FlexRay / CAN / LIN)
        Interface BSW module, routed through the PDUR and the contained
        PDUs are pushed to the COM module.
    :cvar I_PDU_SENT_TO_IF: A point in time where the carrier COM I-PDU
        is routed through the PDUR and is pushed to the bus specific
        (FlexRay / CAN / LIN) Interface BSW module.
    """

    I_PDU_RECEIVED_BY_COM = "I-PDU-RECEIVED-BY-COM"
    I_PDU_SENT_TO_IF = "I-PDU-SENT-TO-IF"


class TdEventISignalTypeEnumSimple(Enum):
    """
    :cvar I_SIGNAL_AVAILABLE_FOR_RTE: A point in time, where the COM
        module makes the contained signal / signal group available for
        the RTE and the corresponding Rx Indication callout is generated
        (if configured).
    :cvar I_SIGNAL_SENT_TO_COM: A point in time, where a transmission
        request call is issued by the RTE on a named COM signal / signal
        group and the new value is stored to the carrier COM I-PDU
        buffer.
    """

    I_SIGNAL_AVAILABLE_FOR_RTE = "I-SIGNAL-AVAILABLE-FOR-RTE"
    I_SIGNAL_SENT_TO_COM = "I-SIGNAL-SENT-TO-COM"


class TdEventModeDeclarationTypeEnumSimple(Enum):
    """
    :cvar MODE_DECLARATION_SWITCH_COMPLETED: A point in time where the
        switch to the associated ModeDeclarationGroupPrototype has been
        completed.
    :cvar MODE_DECLARATION_SWITCH_INITIATED: A point in time where the
        switch to the associated ModeDeclarationGroupPrototype has been
        initiated.
    """

    MODE_DECLARATION_SWITCH_COMPLETED = "MODE-DECLARATION-SWITCH-COMPLETED"
    MODE_DECLARATION_SWITCH_INITIATED = "MODE-DECLARATION-SWITCH-INITIATED"


class TdEventOperationTypeEnumSimple(Enum):
    """
    :cvar OPERATION_CALL_RECEIVED: A point in time where the call of the
        referenced operation is received by the server SWC.
    :cvar OPERATION_CALL_RESPONSE_RECEIVED: A point in time where the
        client SWC has received the response of the referenced operation
        call.
    :cvar OPERATION_CALL_RESPONSE_SENT: A point in time where the server
        SWC has terminated with the execution of the referenced
        operation, and has sent out a response.
    :cvar OPERATION_CALLED: A point in time where the referenced
        operation is called by the client SWC.
    """

    OPERATION_CALL_RECEIVED = "OPERATION-CALL-RECEIVED"
    OPERATION_CALL_RESPONSE_RECEIVED = "OPERATION-CALL-RESPONSE-RECEIVED"
    OPERATION_CALL_RESPONSE_SENT = "OPERATION-CALL-RESPONSE-SENT"
    OPERATION_CALLED = "OPERATION-CALLED"


class TdEventServiceInstanceDiscoveryTypeEnumSimple(Enum):
    """
    :cvar ADAPTIVE_SERVICE_FIND_COMPLETED: A point in time where a
        service subscriber completes to find a needed service.
    :cvar ADAPTIVE_SERVICE_FIND_STARTED: A point in time where a service
        subscriber starts to find a needed service.
    :cvar ADAPTIVE_SERVICE_OFFER_COMPLETED: A point in time where a
        service provider completes to offer a needed service.
    :cvar ADAPTIVE_SERVICE_OFFER_STARTED: A point in time where a
        service provider starts to offer a needed service.
    :cvar ADAPTIVE_SERVICE_STOP_SUBSCRIPTION_COMPLETED: A point in time
        where a service subscriber completes to stop subscribing to a
        needed service.
    :cvar ADAPTIVE_SERVICE_STOP_SUBSCRIPTION_STARTED: A point in time
        where a service subscriber starts to stop subscribing to a
        needed service.
    :cvar ADAPTIVE_SERVICE_SUBSCRIPTION_ACKNOWLEDGE_COMPLETED: A point
        in time where a service provider completes to acknowledge
        subscription to a needed service.
    :cvar ADAPTIVE_SERVICE_SUBSCRIPTION_ACKNOWLEDGE_STARTED: A point in
        time where a service provider starts to acknowledge subscription
        to a needed service.
    :cvar ADAPTIVE_SERVICE_SUBSCRIPTION_COMPLETED: A point in time where
        a service subscriber completes to subscribe to a needed service.
    :cvar ADAPTIVE_SERVICE_SUBSCRIPTION_STARTED: A point in time where a
        service subscriber starts to subscribe to a needed service.
    """

    ADAPTIVE_SERVICE_FIND_COMPLETED = "ADAPTIVE-SERVICE-FIND-COMPLETED"
    ADAPTIVE_SERVICE_FIND_STARTED = "ADAPTIVE-SERVICE-FIND-STARTED"
    ADAPTIVE_SERVICE_OFFER_COMPLETED = "ADAPTIVE-SERVICE-OFFER-COMPLETED"
    ADAPTIVE_SERVICE_OFFER_STARTED = "ADAPTIVE-SERVICE-OFFER-STARTED"
    ADAPTIVE_SERVICE_STOP_SUBSCRIPTION_COMPLETED = "ADAPTIVE-SERVICE-STOP-SUBSCRIPTION-COMPLETED"
    ADAPTIVE_SERVICE_STOP_SUBSCRIPTION_STARTED = "ADAPTIVE-SERVICE-STOP-SUBSCRIPTION-STARTED"
    ADAPTIVE_SERVICE_SUBSCRIPTION_ACKNOWLEDGE_COMPLETED = (
        "ADAPTIVE-SERVICE-SUBSCRIPTION-ACKNOWLEDGE-COMPLETED"
    )
    ADAPTIVE_SERVICE_SUBSCRIPTION_ACKNOWLEDGE_STARTED = (
        "ADAPTIVE-SERVICE-SUBSCRIPTION-ACKNOWLEDGE-STARTED"
    )
    ADAPTIVE_SERVICE_SUBSCRIPTION_COMPLETED = "ADAPTIVE-SERVICE-SUBSCRIPTION-COMPLETED"
    ADAPTIVE_SERVICE_SUBSCRIPTION_STARTED = "ADAPTIVE-SERVICE-SUBSCRIPTION-STARTED"


class TdEventServiceInstanceEventTypeEnumSimple(Enum):
    """
    :cvar ADAPTIVE_EVENT_RECEIVED: A point in time where an event
        required by a service subscriber is received through the service
        port of the service subscriber.
    :cvar ADAPTIVE_EVENT_SENT: A point in time where an event provided
        by a service is sent through the service port of the service
        provider.
    """

    ADAPTIVE_EVENT_RECEIVED = "ADAPTIVE-EVENT-RECEIVED"
    ADAPTIVE_EVENT_SENT = "ADAPTIVE-EVENT-SENT"


class TdEventServiceInstanceFieldTypeEnumSimple(Enum):
    """
    :cvar ADAPTIVE_FIELD_GETTER_CALLED: A point in time where a field
        getter of a service is called by a service subscriber through
        the service port of the service subscriber.
    :cvar ADAPTIVE_FIELD_GETTER_COMPLETED: A point in time where a field
        getter of a service is completed and the result of the field
        getter is received through the service subscriber's service
        port.
    :cvar ADAPTIVE_FIELD_NOTIFICATION_RECEIVED: A point in time where a
        field notification required by a service subscriber is received
        through the service port of the service subscriber.
    :cvar ADAPTIVE_FIELD_NOTIFICATION_SENT: A point in time where a
        field notification provided by a service is sent through the
        service port of the service provider.
    :cvar ADAPTIVE_FIELD_SETTER_CALLED: A point in time where a field
        setter of a service is called by a service subscriber through
        the service port of the service subscriber.
    :cvar ADAPTIVE_FIELD_SETTER_COMPLETED: A point in time where a field
        setter of a service is completed and the result of the field
        setter is received through the service subscriber's service
        port.
    """

    ADAPTIVE_FIELD_GETTER_CALLED = "ADAPTIVE-FIELD-GETTER-CALLED"
    ADAPTIVE_FIELD_GETTER_COMPLETED = "ADAPTIVE-FIELD-GETTER-COMPLETED"
    ADAPTIVE_FIELD_NOTIFICATION_RECEIVED = "ADAPTIVE-FIELD-NOTIFICATION-RECEIVED"
    ADAPTIVE_FIELD_NOTIFICATION_SENT = "ADAPTIVE-FIELD-NOTIFICATION-SENT"
    ADAPTIVE_FIELD_SETTER_CALLED = "ADAPTIVE-FIELD-SETTER-CALLED"
    ADAPTIVE_FIELD_SETTER_COMPLETED = "ADAPTIVE-FIELD-SETTER-COMPLETED"


class TdEventServiceInstanceMethodTypeEnumSimple(Enum):
    """
    :cvar ADAPTIVE_METHOD_CALL_RECEIVED: A point in time where a method
        call of a service is received through the service provider's
        service port.
    :cvar ADAPTIVE_METHOD_CALLED: A point in time where a method of a
        service is called through the service subscriber's service port.
    :cvar ADAPTIVE_METHOD_RESPONSE_RECEIVED: A point in time where a
        response of a method call of a service is received through the
        service subscribers's service port.
    :cvar ADAPTIVE_METHOD_RESPONSE_SENT: A point in time where a
        response of a method call of a service is sent through the
        service provider's service port.
    """

    ADAPTIVE_METHOD_CALL_RECEIVED = "ADAPTIVE-METHOD-CALL-RECEIVED"
    ADAPTIVE_METHOD_CALLED = "ADAPTIVE-METHOD-CALLED"
    ADAPTIVE_METHOD_RESPONSE_RECEIVED = "ADAPTIVE-METHOD-RESPONSE-RECEIVED"
    ADAPTIVE_METHOD_RESPONSE_SENT = "ADAPTIVE-METHOD-RESPONSE-SENT"


class TdEventSwcSubtypesEnum(Enum):
    TD_EVENT_SWC = "TD-EVENT-SWC"
    TD_EVENT_SWC_INTERNAL_BEHAVIOR = "TD-EVENT-SWC-INTERNAL-BEHAVIOR"
    TD_EVENT_SWC_INTERNAL_BEHAVIOR_REFERENCE = "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE"


class TdEventSwcInternalBehaviorTypeEnumSimple(Enum):
    """
    :cvar RUNNABLE_ENTITY_ACTIVATED: A point in time where the
        associated RunnableEntity has been activated, which means that
        it has entered the state "to be started".
    :cvar RUNNABLE_ENTITY_STARTED: A point in time where the associated
        RunnableEntity has entered the state "started" after its
        activation.
    :cvar RUNNABLE_ENTITY_TERMINATED: A point in time where the
        associated RunnableEntity has terminated and entered the state
        "suspended".
    :cvar RUNNABLE_ENTITY_VARIABLE_ACCESS: A point in time where the
        associated variable is accessed.
    """

    RUNNABLE_ENTITY_ACTIVATED = "RUNNABLE-ENTITY-ACTIVATED"
    RUNNABLE_ENTITY_STARTED = "RUNNABLE-ENTITY-STARTED"
    RUNNABLE_ENTITY_TERMINATED = "RUNNABLE-ENTITY-TERMINATED"
    RUNNABLE_ENTITY_VARIABLE_ACCESS = "RUNNABLE-ENTITY-VARIABLE-ACCESS"


class TdEventTriggerTypeEnumSimple(Enum):
    """
    :cvar TRIGGER_ACTIVATED: A point in time where the referenced
        trigger has been successfully released and is activating
        runnable entities of the receiving SW-C.
    :cvar TRIGGER_RELEASED: A point in time where the referenced trigger
        has been successfully released by the emitting SW-C.
    """

    TRIGGER_ACTIVATED = "TRIGGER-ACTIVATED"
    TRIGGER_RELEASED = "TRIGGER-RELEASED"


class TdEventVariableDataPrototypeTypeEnumSimple(Enum):
    """
    :cvar VARIABLE_DATA_PROTOTYPE_RECEIVED: A point in time where the
        referenced variable data prototype has been successfully
        transmitted and is available in the related communication buffer
        (of the RTE) for the receiving SWC.
    :cvar VARIABLE_DATA_PROTOTYPE_SENT: A point in time where the
        referenced variable data prototype has been successfully sent
        out by the sending SWC, so that it is available in the related
        communication buffer (of the RTE) for transmission.
    """

    VARIABLE_DATA_PROTOTYPE_RECEIVED = "VARIABLE-DATA-PROTOTYPE-RECEIVED"
    VARIABLE_DATA_PROTOTYPE_SENT = "VARIABLE-DATA-PROTOTYPE-SENT"


class TdEventVfbSubtypesEnum(Enum):
    TD_EVENT_MODE_DECLARATION = "TD-EVENT-MODE-DECLARATION"
    TD_EVENT_OPERATION = "TD-EVENT-OPERATION"
    TD_EVENT_TRIGGER = "TD-EVENT-TRIGGER"
    TD_EVENT_VARIABLE_DATA_PROTOTYPE = "TD-EVENT-VARIABLE-DATA-PROTOTYPE"
    TD_EVENT_VFB = "TD-EVENT-VFB"
    TD_EVENT_VFB_PORT = "TD-EVENT-VFB-PORT"
    TD_EVENT_VFB_REFERENCE = "TD-EVENT-VFB-REFERENCE"


class TerminationBehaviorEnumSimple(Enum):
    """
    :cvar PROCESS_IS_NOT_SELF_TERMINATING: The Process terminates only
        on request from Execution Management.
    :cvar PROCESS_IS_SELF_TERMINATING: The Process is allowed to
        terminate without request from Execution Management.
    """

    PROCESS_IS_NOT_SELF_TERMINATING = "PROCESS-IS-NOT-SELF-TERMINATING"
    PROCESS_IS_SELF_TERMINATING = "PROCESS-IS-SELF-TERMINATING"


class TimeBaseResourceSubtypesEnum(Enum):
    SYNCHRONIZED_TIME_BASE_CONSUMER = "SYNCHRONIZED-TIME-BASE-CONSUMER"
    SYNCHRONIZED_TIME_BASE_PROVIDER = "SYNCHRONIZED-TIME-BASE-PROVIDER"
    TIME_BASE_RESOURCE = "TIME-BASE-RESOURCE"


class TimeSyncServerConfigurationSubtypesEnum(Enum):
    TIME_SYNC_SERVER_CONFIGURATION = "TIME-SYNC-SERVER-CONFIGURATION"


class TimeSyncTechnologyEnumSimple(Enum):
    """
    :cvar AVB_IEEE_802_1_AS: Ethernet AVB compliant IEEE802.1AS
        Precision Time Protocol
    :cvar NTP_RFC_958: Network Time Protocol (NTP)
    :cvar PTP_IEEE_1588_2002: Precision Time Protocol (PTP) IEEE
        1588-2002
    :cvar PTP_IEEE_1588_2008: Precision Time Protocol (PTP) IEEE
        1588-2008
    """

    AVB_IEEE_802_1_AS = "AVB--IEEE-802--1-AS"
    NTP_RFC_958 = "NTP--RFC-958"
    PTP_IEEE_1588_2002 = "PTP--IEEE-1588--2002"
    PTP_IEEE_1588_2008 = "PTP--IEEE-1588--2008"


class TimeSynchronizationKindEnumSimple(Enum):
    """
    :cvar OFFSET: Defines that the requested time base shall be an
        offset time based.
    :cvar SYNCHRONIZED: Defines that the requested time base shall be a
        synchronized time based.
    """

    OFFSET = "OFFSET"
    SYNCHRONIZED = "SYNCHRONIZED"


@dataclass(slots=True, kw_only=True)
class TimeValue:
    """This primitive type is taken for expressing time values.

    The numerical value is supposed to be interpreted in the physical
    unit second.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIME-VALUE"

    value: float = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class TimingClockSubtypesEnum(Enum):
    TDLET_ZONE_CLOCK = "TDLET-ZONE-CLOCK"
    TIMING_CLOCK = "TIMING-CLOCK"


class TimingConditionSubtypesEnum(Enum):
    TIMING_CONDITION = "TIMING-CONDITION"


class TimingDescriptionSubtypesEnum(Enum):
    TD_EVENT_BSW = "TD-EVENT-BSW"
    TD_EVENT_BSW_INTERNAL_BEHAVIOR = "TD-EVENT-BSW-INTERNAL-BEHAVIOR"
    TD_EVENT_BSW_MODE_DECLARATION = "TD-EVENT-BSW-MODE-DECLARATION"
    TD_EVENT_BSW_MODULE = "TD-EVENT-BSW-MODULE"
    TD_EVENT_COM = "TD-EVENT-COM"
    TD_EVENT_COMPLEX = "TD-EVENT-COMPLEX"
    TD_EVENT_CYCLE_START = "TD-EVENT-CYCLE-START"
    TD_EVENT_FR_CLUSTER_CYCLE_START = "TD-EVENT-FR-CLUSTER-CYCLE-START"
    TD_EVENT_FRAME = "TD-EVENT-FRAME"
    TD_EVENT_FRAME_ETHERNET = "TD-EVENT-FRAME-ETHERNET"
    TD_EVENT_I_PDU = "TD-EVENT-I-PDU"
    TD_EVENT_I_SIGNAL = "TD-EVENT-I-SIGNAL"
    TD_EVENT_MODE_DECLARATION = "TD-EVENT-MODE-DECLARATION"
    TD_EVENT_OPERATION = "TD-EVENT-OPERATION"
    TD_EVENT_SERVICE_INSTANCE = "TD-EVENT-SERVICE-INSTANCE"
    TD_EVENT_SERVICE_INSTANCE_DISCOVERY = "TD-EVENT-SERVICE-INSTANCE-DISCOVERY"
    TD_EVENT_SERVICE_INSTANCE_EVENT = "TD-EVENT-SERVICE-INSTANCE-EVENT"
    TD_EVENT_SERVICE_INSTANCE_FIELD = "TD-EVENT-SERVICE-INSTANCE-FIELD"
    TD_EVENT_SERVICE_INSTANCE_METHOD = "TD-EVENT-SERVICE-INSTANCE-METHOD"
    TD_EVENT_SLLET = "TD-EVENT-SLLET"
    TD_EVENT_SLLET_PORT = "TD-EVENT-SLLET-PORT"
    TD_EVENT_SWC = "TD-EVENT-SWC"
    TD_EVENT_SWC_INTERNAL_BEHAVIOR = "TD-EVENT-SWC-INTERNAL-BEHAVIOR"
    TD_EVENT_SWC_INTERNAL_BEHAVIOR_REFERENCE = "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE"
    TD_EVENT_TRIGGER = "TD-EVENT-TRIGGER"
    TD_EVENT_TT_CAN_CYCLE_START = "TD-EVENT-TT-CAN-CYCLE-START"
    TD_EVENT_VARIABLE_DATA_PROTOTYPE = "TD-EVENT-VARIABLE-DATA-PROTOTYPE"
    TD_EVENT_VFB = "TD-EVENT-VFB"
    TD_EVENT_VFB_PORT = "TD-EVENT-VFB-PORT"
    TD_EVENT_VFB_REFERENCE = "TD-EVENT-VFB-REFERENCE"
    TIMING_DESCRIPTION = "TIMING-DESCRIPTION"
    TIMING_DESCRIPTION_EVENT = "TIMING-DESCRIPTION-EVENT"
    TIMING_DESCRIPTION_EVENT_CHAIN = "TIMING-DESCRIPTION-EVENT-CHAIN"


class TimingDescriptionEventSubtypesEnum(Enum):
    TD_EVENT_BSW = "TD-EVENT-BSW"
    TD_EVENT_BSW_INTERNAL_BEHAVIOR = "TD-EVENT-BSW-INTERNAL-BEHAVIOR"
    TD_EVENT_BSW_MODE_DECLARATION = "TD-EVENT-BSW-MODE-DECLARATION"
    TD_EVENT_BSW_MODULE = "TD-EVENT-BSW-MODULE"
    TD_EVENT_COM = "TD-EVENT-COM"
    TD_EVENT_COMPLEX = "TD-EVENT-COMPLEX"
    TD_EVENT_CYCLE_START = "TD-EVENT-CYCLE-START"
    TD_EVENT_FR_CLUSTER_CYCLE_START = "TD-EVENT-FR-CLUSTER-CYCLE-START"
    TD_EVENT_FRAME = "TD-EVENT-FRAME"
    TD_EVENT_FRAME_ETHERNET = "TD-EVENT-FRAME-ETHERNET"
    TD_EVENT_I_PDU = "TD-EVENT-I-PDU"
    TD_EVENT_I_SIGNAL = "TD-EVENT-I-SIGNAL"
    TD_EVENT_MODE_DECLARATION = "TD-EVENT-MODE-DECLARATION"
    TD_EVENT_OPERATION = "TD-EVENT-OPERATION"
    TD_EVENT_SERVICE_INSTANCE = "TD-EVENT-SERVICE-INSTANCE"
    TD_EVENT_SERVICE_INSTANCE_DISCOVERY = "TD-EVENT-SERVICE-INSTANCE-DISCOVERY"
    TD_EVENT_SERVICE_INSTANCE_EVENT = "TD-EVENT-SERVICE-INSTANCE-EVENT"
    TD_EVENT_SERVICE_INSTANCE_FIELD = "TD-EVENT-SERVICE-INSTANCE-FIELD"
    TD_EVENT_SERVICE_INSTANCE_METHOD = "TD-EVENT-SERVICE-INSTANCE-METHOD"
    TD_EVENT_SLLET = "TD-EVENT-SLLET"
    TD_EVENT_SLLET_PORT = "TD-EVENT-SLLET-PORT"
    TD_EVENT_SWC = "TD-EVENT-SWC"
    TD_EVENT_SWC_INTERNAL_BEHAVIOR = "TD-EVENT-SWC-INTERNAL-BEHAVIOR"
    TD_EVENT_SWC_INTERNAL_BEHAVIOR_REFERENCE = "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE"
    TD_EVENT_TRIGGER = "TD-EVENT-TRIGGER"
    TD_EVENT_TT_CAN_CYCLE_START = "TD-EVENT-TT-CAN-CYCLE-START"
    TD_EVENT_VARIABLE_DATA_PROTOTYPE = "TD-EVENT-VARIABLE-DATA-PROTOTYPE"
    TD_EVENT_VFB = "TD-EVENT-VFB"
    TD_EVENT_VFB_PORT = "TD-EVENT-VFB-PORT"
    TD_EVENT_VFB_REFERENCE = "TD-EVENT-VFB-REFERENCE"
    TIMING_DESCRIPTION_EVENT = "TIMING-DESCRIPTION-EVENT"


class TimingDescriptionEventChainSubtypesEnum(Enum):
    TIMING_DESCRIPTION_EVENT_CHAIN = "TIMING-DESCRIPTION-EVENT-CHAIN"


class TimingEventSubtypesEnum(Enum):
    TIMING_EVENT = "TIMING-EVENT"


class TimingModeInstanceSubtypesEnum(Enum):
    TIMING_MODE_INSTANCE = "TIMING-MODE-INSTANCE"


class TlsCryptoCipherSuiteSubtypesEnum(Enum):
    TLS_CRYPTO_CIPHER_SUITE = "TLS-CRYPTO-CIPHER-SUITE"


class TlsCryptoServiceMappingSubtypesEnum(Enum):
    TLS_CRYPTO_SERVICE_MAPPING = "TLS-CRYPTO-SERVICE-MAPPING"


class TlsSecureComPropsSubtypesEnum(Enum):
    TLS_SECURE_COM_PROPS = "TLS-SECURE-COM-PROPS"


class TlsVersionEnumSimple(Enum):
    """
    :cvar LTS_13: TLS version 1.3
    :cvar TLS_12: TLS version 1.2
    :cvar TLS_13: TLS version 1.3
    """

    LTS_13 = "LTS-13"
    TLS_12 = "TLS-12"
    TLS_13 = "TLS-13"


class TlvDataIdDefinitionSetSubtypesEnum(Enum):
    TLV_DATA_ID_DEFINITION_SET = "TLV-DATA-ID-DEFINITION-SET"


class TpAckTypeSimple(Enum):
    """
    :cvar ACK_WITH_RT: Acknowledgement with retry.
    :cvar NO_ACK: No acknowledgement.
    """

    ACK_WITH_RT = "ACK-WITH-RT"
    NO_ACK = "NO-ACK"


class TpAddressSubtypesEnum(Enum):
    TP_ADDRESS = "TP-ADDRESS"


class TpConnectionIdentSubtypesEnum(Enum):
    TP_CONNECTION_IDENT = "TP-CONNECTION-IDENT"


class TraceableSubtypesEnum(Enum):
    AGE_CONSTRAINT = "AGE-CONSTRAINT"
    ARBITRARY_EVENT_TRIGGERING = "ARBITRARY-EVENT-TRIGGERING"
    BURST_PATTERN_EVENT_TRIGGERING = "BURST-PATTERN-EVENT-TRIGGERING"
    CONCRETE_PATTERN_EVENT_TRIGGERING = "CONCRETE-PATTERN-EVENT-TRIGGERING"
    EVENT_TRIGGERING_CONSTRAINT = "EVENT-TRIGGERING-CONSTRAINT"
    EXECUTION_ORDER_CONSTRAINT = "EXECUTION-ORDER-CONSTRAINT"
    EXECUTION_TIME_CONSTRAINT = "EXECUTION-TIME-CONSTRAINT"
    LATENCY_TIMING_CONSTRAINT = "LATENCY-TIMING-CONSTRAINT"
    OFFSET_TIMING_CONSTRAINT = "OFFSET-TIMING-CONSTRAINT"
    PERIODIC_EVENT_TRIGGERING = "PERIODIC-EVENT-TRIGGERING"
    SPORADIC_EVENT_TRIGGERING = "SPORADIC-EVENT-TRIGGERING"
    STRUCTURED_REQ = "STRUCTURED-REQ"
    SYNCHRONIZATION_POINT_CONSTRAINT = "SYNCHRONIZATION-POINT-CONSTRAINT"
    SYNCHRONIZATION_TIMING_CONSTRAINT = "SYNCHRONIZATION-TIMING-CONSTRAINT"
    TIMING_CONSTRAINT = "TIMING-CONSTRAINT"
    TRACEABLE = "TRACEABLE"
    TRACEABLE_TABLE = "TRACEABLE-TABLE"
    TRACEABLE_TEXT = "TRACEABLE-TEXT"


class TraceableTextSubtypesEnum(Enum):
    TRACEABLE_TEXT = "TRACEABLE-TEXT"


class TransferPropertyEnumSimple(Enum):
    """
    :cvar PENDING: If the signal has the TransferProperty pending, then
        the function Com_SendSignal shall not perform a transmission of
        the IPdu associated with the signal.
    :cvar TRIGGERED: The signal in the assigned IPdu is updated and a
        request for the IPdu's transmission is made.
    :cvar TRIGGERED_ON_CHANGE: The signal in the assigned IPdu is
        updated and a request for the IPdus transmission is made only if
        the signal value is different from the already stored signal
        value.
    :cvar TRIGGERED_ON_CHANGE_WITHOUT_REPETITION: The signal in the
        assigned IPdu is updated and a request for the IPdus
        transmission is made only if the signal value is different from
        the already stored signal value.  In the DIRECT/N-TIMES or MIXED
        transmission mode (EventControlledTiming) the IPdu will be
        transmitted just once without a repetition, independent of the
        defined NumberOfRepeats.
    :cvar TRIGGERED_WITHOUT_REPETITION: The signal in the assigned IPdu
        is updated and a request for the IPdu's transmission is made. In
        the DIRECT/N-TIMES or MIXED transmission mode
        (EventControlledTiming) the IPdu will be transmitted just once
        without a repetition, independent of the defined
        NumberOfRepeats.
    """

    PENDING = "PENDING"
    TRIGGERED = "TRIGGERED"
    TRIGGERED_ON_CHANGE = "TRIGGERED-ON-CHANGE"
    TRIGGERED_ON_CHANGE_WITHOUT_REPETITION = "TRIGGERED-ON-CHANGE-WITHOUT-REPETITION"
    TRIGGERED_WITHOUT_REPETITION = "TRIGGERED-WITHOUT-REPETITION"


class TransformationPropsSubtypesEnum(Enum):
    AP_SOMEIP_TRANSFORMATION_PROPS = "AP-SOMEIP-TRANSFORMATION-PROPS"
    SOMEIP_TRANSFORMATION_PROPS = "SOMEIP-TRANSFORMATION-PROPS"
    TRANSFORMATION_PROPS = "TRANSFORMATION-PROPS"
    USER_DEFINED_TRANSFORMATION_PROPS = "USER-DEFINED-TRANSFORMATION-PROPS"


class TransformationTechnologySubtypesEnum(Enum):
    TRANSFORMATION_TECHNOLOGY = "TRANSFORMATION-TECHNOLOGY"


class TransformerClassEnumSimple(Enum):
    """
    :cvar CUSTOM: The transformer is a custom transformer.
    :cvar SAFETY: The transformer is a safety transformer.
    :cvar SECURITY: The transformer is a security transformer.
    :cvar SERIALIZER: The transformer is a serializing transformer.
    """

    CUSTOM = "CUSTOM"
    SAFETY = "SAFETY"
    SECURITY = "SECURITY"
    SERIALIZER = "SERIALIZER"


class TransmissionModeDefinitionEnumSimple(Enum):
    """
    :cvar CYCLIC: The data is assumed to be transmitted in a cyclic
        manner. The cycle is defined by dataUpdatePeriod.
    :cvar CYCLIC_AND_ON_CHANGE: The data is assumed to be transmitted in
        a cyclic manner (with cycle time dataUpdatePeriod) and
        additionally there may be arbitrary transmission if the data
        value changes (minimumSendInterval to be respected, if defined).
    :cvar TRIGGERED: The data is assumed to be transmitted in an
        arbitrary manner (minimumSendInterval to be respected, if
        defined).
    """

    CYCLIC = "CYCLIC"
    CYCLIC_AND_ON_CHANGE = "CYCLIC-AND-ON-CHANGE"
    TRIGGERED = "TRIGGERED"


class TransportLayerProtocolEnumSimple(Enum):
    """
    :cvar TCP: Transmission control protocol
    :cvar UDP: User datagram protocol
    """

    TCP = "TCP"
    UDP = "UDP"


class TriggerSubtypesEnum(Enum):
    TRIGGER = "TRIGGER"


class TriggerModeSimple(Enum):
    """
    :cvar DYNAMIC_PART_TRIGGER: IPduM sends a transmission request to
        the PduR if a dynamic part is received.
    :cvar NONE: IPduM does not trigger transmission because of receiving
        anything of this IPdu in case of TriggerTransmit.
    :cvar STATIC_OR_DYNAMIC_PART_TRIGGER: IPduM sends a transmission
        request to the PduR if a static or dynamic part is received.
    :cvar STATIC_PART_TRIGGER: IPduM sends a transmission request to the
        PduR if a static part is received.
    """

    DYNAMIC_PART_TRIGGER = "DYNAMIC-PART-TRIGGER"
    NONE = "NONE"
    STATIC_OR_DYNAMIC_PART_TRIGGER = "STATIC-OR-DYNAMIC-PART-TRIGGER"
    STATIC_PART_TRIGGER = "STATIC-PART-TRIGGER"


class TrustedPlatformExecutableLaunchBehaviorEnumSimple(Enum):
    """
    :cvar MONITOR_MODE: An Executable shall always launch, even if the
        corresponding authentication fails
    :cvar NO_TRUSTED_PLATFORM_SUPPORT: This value shall be used if there
        is no TrustedPlatform support on the Machine
    :cvar STRICT_MODE: An Executable shall not launch if the
        corresponding authentication fails.
    """

    MONITOR_MODE = "MONITOR-MODE"
    NO_TRUSTED_PLATFORM_SUPPORT = "NO-TRUSTED-PLATFORM-SUPPORT"
    STRICT_MODE = "STRICT-MODE"


@dataclass(slots=True, kw_only=True)
class Tt:
    """This meta-class represents the ability to express specific technical terms.

    The kind of term is denoted in the attribute "type".

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar tex_render: This attribute holds information how the content
        (represented by attribute "term") of the particular technical
        term is rendered using LaTeX. This allows to inject specific
        LaTeX commands such as \\sep{}.  An example is to render
        "MyClass" as "My\\sep{}Class". Default is the value of the
        attribute "term".
    :ivar type_value: This attribute specifies the type of the technical
        term. Values are such as "VARIABLE" "CALPRM". It is no longer an
        enum in order to support process specific extensions.
    """

    class Meta:
        name = "TT"

    value: str = field(
        default="",
        metadata={
            "required": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    tex_render: str | None = field(
        default=None,
        metadata={
            "name": "TEX-RENDER",
            "type": "Attribute",
        },
    )
    type_value: str | None = field(
        default=None,
        metadata={
            "name": "TYPE",
            "type": "Attribute",
        },
    )


class TtcanClusterSubtypesEnum(Enum):
    TTCAN_CLUSTER = "TTCAN-CLUSTER"


class TtcanTriggerTypeSimple(Enum):
    """
    :cvar RX_TRIGGER: Check for message reception
    :cvar TX_REF_TRIGGER: Send reference message in periodic case
    :cvar TX_REF_TRIGGER_GAP: Send reference message in event-
        synchronised case
    :cvar TX_TRIGGER_MERGED: Send message in a merged arbitration window
    :cvar TX_TRIGGER_SINGLE: Send message in an exclusive time window
    :cvar WATCH_TRIGGER: Check for missing reference message in periodic
        case
    :cvar WATCH_TRIGGER_GAP: Check for missing reference message in
        event-synchronised case
    """

    RX_TRIGGER = "RX-TRIGGER"
    TX_REF_TRIGGER = "TX-REF-TRIGGER"
    TX_REF_TRIGGER_GAP = "TX-REF-TRIGGER-GAP"
    TX_TRIGGER_MERGED = "TX-TRIGGER-MERGED"
    TX_TRIGGER_SINGLE = "TX-TRIGGER-SINGLE"
    WATCH_TRIGGER = "WATCH-TRIGGER"
    WATCH_TRIGGER_GAP = "WATCH-TRIGGER-GAP"


class UcmDescriptionSubtypesEnum(Enum):
    UCM_DESCRIPTION = "UCM-DESCRIPTION"


class UcmModuleInstantiationSubtypesEnum(Enum):
    UCM_MASTER_MODULE_INSTANTIATION = "UCM-MASTER-MODULE-INSTANTIATION"
    UCM_MODULE_INSTANTIATION = "UCM-MODULE-INSTANTIATION"
    UCM_SUBORDINATE_MODULE_INSTANTIATION = "UCM-SUBORDINATE-MODULE-INSTANTIATION"


class UdpChecksumCalculationEnumSimple(Enum):
    """
    :cvar UDP_CHECKSUM_DISABLED: Udp checksum handling shall be disabled
    :cvar UDP_CHECKSUM_ENABLED: Udp checksum handling shall be enabled
    """

    UDP_CHECKSUM_DISABLED = "UDP-CHECKSUM-DISABLED"
    UDP_CHECKSUM_ENABLED = "UDP-CHECKSUM-ENABLED"


class UdpCollectionTriggerEnumSimple(Enum):
    """
    :cvar ALWAYS: ServiceInterface element will trigger the transmission
        of the data.
    :cvar NEVER: ServiceInterface element will be buffered and will not
        trigger the transmission of the data.
    """

    ALWAYS = "ALWAYS"
    NEVER = "NEVER"


class UdpNmClusterSubtypesEnum(Enum):
    UDP_NM_CLUSTER = "UDP-NM-CLUSTER"


class UnitSubtypesEnum(Enum):
    UNIT = "UNIT"


class UnitGroupSubtypesEnum(Enum):
    UNIT_GROUP = "UNIT-GROUP"


@dataclass(slots=True, kw_only=True)
class UnlimitedInteger:
    """An instance of UnlimitedInteger is an element in the set of integer numbers
    ( ..., -2, -1, 0, 1, 2, ...).

    The range is limited by constraint 2534. The value can be expressed
    in decimal, octal, hexadecimal and binary representation. Negative
    numbers can only be expressed in decimal notation.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UNLIMITED-INTEGER"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"0|[\+\-]?[1-9][0-9]*|0[xX][0-9a-fA-F]+|0[bB][0-1]+|0[0-7]+",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class UploadablePackageElementSubtypesEnum(Enum):
    ABSTRACT_EXECUTION_CONTEXT = "ABSTRACT-EXECUTION-CONTEXT"
    ADAPTIVE_FIREWALL_TO_PORT_PROTOTYPE_MAPPING = "ADAPTIVE-FIREWALL-TO-PORT-PROTOTYPE-MAPPING"
    ADAPTIVE_PLATFORM_SERVICE_INSTANCE = "ADAPTIVE-PLATFORM-SERVICE-INSTANCE"
    ARTIFACT_CHECKSUM_TO_CRYPTO_PROVIDER_MAPPING = "ARTIFACT-CHECKSUM-TO-CRYPTO-PROVIDER-MAPPING"
    COM_CERTIFICATE_TO_CRYPTO_CERTIFICATE_MAPPING = "COM-CERTIFICATE-TO-CRYPTO-CERTIFICATE-MAPPING"
    COM_KEY_TO_CRYPTO_KEY_SLOT_MAPPING = "COM-KEY-TO-CRYPTO-KEY-SLOT-MAPPING"
    COM_SEC_OC_TO_CRYPTO_KEY_SLOT_MAPPING = "COM-SEC-OC-TO-CRYPTO-KEY-SLOT-MAPPING"
    CRYPTO_CERTIFICATE_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-CERTIFICATE-TO-PORT-PROTOTYPE-MAPPING"
    CRYPTO_KEY_SLOT_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-KEY-SLOT-TO-PORT-PROTOTYPE-MAPPING"
    CRYPTO_PROVIDER_TO_PORT_PROTOTYPE_MAPPING = "CRYPTO-PROVIDER-TO-PORT-PROTOTYPE-MAPPING"
    DDS_PROVIDED_SERVICE_INSTANCE = "DDS-PROVIDED-SERVICE-INSTANCE"
    DDS_REQUIRED_SERVICE_INSTANCE = "DDS-REQUIRED-SERVICE-INSTANCE"
    DDS_SECURE_GOVERNANCE = "DDS-SECURE-GOVERNANCE"
    DDS_SERVICE_INSTANCE_TO_MACHINE_MAPPING = "DDS-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    DDS_SERVICE_INTERFACE_DEPLOYMENT = "DDS-SERVICE-INTERFACE-DEPLOYMENT"
    DDS_TOPIC_ACCESS_RULE = "DDS-TOPIC-ACCESS-RULE"
    DETERMINISTIC_CLIENT = "DETERMINISTIC-CLIENT"
    DETERMINISTIC_SYNC_MASTER_TO_TIME_BASE_CONSUMER_MAPPING = (
        "DETERMINISTIC-SYNC-MASTER-TO-TIME-BASE-CONSUMER-MAPPING"
    )
    DLT_APPLICATION_TO_PROCESS_MAPPING = "DLT-APPLICATION-TO-PROCESS-MAPPING"
    DLT_LOG_SINK = "DLT-LOG-SINK"
    DLT_LOG_SINK_TO_PORT_PROTOTYPE_MAPPING = "DLT-LOG-SINK-TO-PORT-PROTOTYPE-MAPPING"
    ETHERNET_RAW_DATA_STREAM_CLIENT_MAPPING = "ETHERNET-RAW-DATA-STREAM-CLIENT-MAPPING"
    ETHERNET_RAW_DATA_STREAM_MAPPING = "ETHERNET-RAW-DATA-STREAM-MAPPING"
    ETHERNET_RAW_DATA_STREAM_SERVER_MAPPING = "ETHERNET-RAW-DATA-STREAM-SERVER-MAPPING"
    FUNCTIONAL_CLUSTER_INTERACTS_WITH_FUNCTIONAL_CLUSTER_MAPPING = (
        "FUNCTIONAL-CLUSTER-INTERACTS-WITH-FUNCTIONAL-CLUSTER-MAPPING"
    )
    FUNCTIONAL_CLUSTER_INTERACTS_WITH_PERSISTENCY_DEPLOYMENT_MAPPING = (
        "FUNCTIONAL-CLUSTER-INTERACTS-WITH-PERSISTENCY-DEPLOYMENT-MAPPING"
    )
    NM_HANDLE_TO_FUNCTION_GROUP_STATE_MAPPING = "NM-HANDLE-TO-FUNCTION-GROUP-STATE-MAPPING"
    PERSISTENCY_DEPLOYMENT = "PERSISTENCY-DEPLOYMENT"
    PERSISTENCY_DEPLOYMENT_ELEMENT_TO_CRYPTO_KEY_SLOT_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-ELEMENT-TO-CRYPTO-KEY-SLOT-MAPPING"
    )
    PERSISTENCY_DEPLOYMENT_TO_CRYPTO_KEY_SLOT_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-TO-CRYPTO-KEY-SLOT-MAPPING"
    )
    PERSISTENCY_DEPLOYMENT_TO_DLT_LOG_SINK_MAPPING = (
        "PERSISTENCY-DEPLOYMENT-TO-DLT-LOG-SINK-MAPPING"
    )
    PERSISTENCY_FILE_STORAGE = "PERSISTENCY-FILE-STORAGE"
    PERSISTENCY_KEY_VALUE_STORAGE = "PERSISTENCY-KEY-VALUE-STORAGE"
    PERSISTENCY_PORT_PROTOTYPE_TO_DEPLOYMENT_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-DEPLOYMENT-MAPPING"
    )
    PERSISTENCY_PORT_PROTOTYPE_TO_FILE_STORAGE_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-FILE-STORAGE-MAPPING"
    )
    PERSISTENCY_PORT_PROTOTYPE_TO_KEY_VALUE_STORAGE_MAPPING = (
        "PERSISTENCY-PORT-PROTOTYPE-TO-KEY-VALUE-STORAGE-MAPPING"
    )
    PLATFORM_HEALTH_MANAGEMENT_CONTRIBUTION = "PLATFORM-HEALTH-MANAGEMENT-CONTRIBUTION"
    PROCESS = "PROCESS"
    PROCESS_EXECUTION_ERROR = "PROCESS-EXECUTION-ERROR"
    PROCESS_TO_MACHINE_MAPPING_SET = "PROCESS-TO-MACHINE-MAPPING-SET"
    PROVIDED_AP_SERVICE_INSTANCE = "PROVIDED-AP-SERVICE-INSTANCE"
    PROVIDED_SOMEIP_SERVICE_INSTANCE = "PROVIDED-SOMEIP-SERVICE-INSTANCE"
    PROVIDED_USER_DEFINED_SERVICE_INSTANCE = "PROVIDED-USER-DEFINED-SERVICE-INSTANCE"
    RAW_DATA_STREAM_DEPLOYMENT = "RAW-DATA-STREAM-DEPLOYMENT"
    RAW_DATA_STREAM_MAPPING = "RAW-DATA-STREAM-MAPPING"
    RECOVERY_NOTIFICATION = "RECOVERY-NOTIFICATION"
    RECOVERY_NOTIFICATION_TO_P_PORT_PROTOTYPE_MAPPING = (
        "RECOVERY-NOTIFICATION-TO-P-PORT-PROTOTYPE-MAPPING"
    )
    REQUIRED_AP_SERVICE_INSTANCE = "REQUIRED-AP-SERVICE-INSTANCE"
    REQUIRED_SOMEIP_SERVICE_INSTANCE = "REQUIRED-SOMEIP-SERVICE-INSTANCE"
    REQUIRED_USER_DEFINED_SERVICE_INSTANCE = "REQUIRED-USER-DEFINED-SERVICE-INSTANCE"
    SECURITY_EVENT_MAPPING = "SECURITY-EVENT-MAPPING"
    SERVICE_INSTANCE_TO_MACHINE_MAPPING = "SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    SERVICE_INSTANCE_TO_PORT_PROTOTYPE_MAPPING = "SERVICE-INSTANCE-TO-PORT-PROTOTYPE-MAPPING"
    SERVICE_INTERFACE_DEPLOYMENT = "SERVICE-INTERFACE-DEPLOYMENT"
    SOFTWARE_CLUSTER_DIAGNOSTIC_DEPLOYMENT_PROPS = "SOFTWARE-CLUSTER-DIAGNOSTIC-DEPLOYMENT-PROPS"
    SOMEIP_SERVICE_INSTANCE_TO_MACHINE_MAPPING = "SOMEIP-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    SOMEIP_SERVICE_INTERFACE_DEPLOYMENT = "SOMEIP-SERVICE-INTERFACE-DEPLOYMENT"
    TIME_BASE_PROVIDER_TO_PERSISTENCY_MAPPING = "TIME-BASE-PROVIDER-TO-PERSISTENCY-MAPPING"
    TIME_SYNC_PORT_PROTOTYPE_TO_TIME_BASE_MAPPING = "TIME-SYNC-PORT-PROTOTYPE-TO-TIME-BASE-MAPPING"
    UCM_TO_TIME_BASE_RESOURCE_MAPPING = "UCM-TO-TIME-BASE-RESOURCE-MAPPING"
    UPLOADABLE_EXCLUSIVE_PACKAGE_ELEMENT = "UPLOADABLE-EXCLUSIVE-PACKAGE-ELEMENT"
    UPLOADABLE_PACKAGE_ELEMENT = "UPLOADABLE-PACKAGE-ELEMENT"
    USER_DEFINED_SERVICE_INSTANCE_TO_MACHINE_MAPPING = (
        "USER-DEFINED-SERVICE-INSTANCE-TO-MACHINE-MAPPING"
    )
    USER_DEFINED_SERVICE_INTERFACE_DEPLOYMENT = "USER-DEFINED-SERVICE-INTERFACE-DEPLOYMENT"


@dataclass(slots=True, kw_only=True)
class UriString:
    """
    A Uniform Resource Identifier (URI), is a compact string of characters used to
    identify or name a resource.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "URI-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Url:
    """
    This meta-class specifies an Uniform Resource Locator (URL).

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar mime_type: this denotes the mime type of the resource located
        by the url.
    """

    class Meta:
        name = "URL"

    value: str = field(
        default="",
        metadata={
            "required": True,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    mime_type: str | None = field(
        default=None,
        metadata={
            "name": "MIME-TYPE",
            "type": "Attribute",
        },
    )


class V2XSupportEnumSimple(Enum):
    """
    :cvar V_2_X_ACTIVE_SUPPORTED: This means that the EcuInstance
        supports V2X communication as both the sender and the receiver
        of communication.
    :cvar V_2_X_NOT_SUPPORTED: This EcuInstance does not support V2X
        communication
    """

    V_2_X_ACTIVE_SUPPORTED = "V-2-X-ACTIVE-SUPPORTED"
    V_2_X_NOT_SUPPORTED = "V-2-X-NOT-SUPPORTED"


class ValignEnumSimple(Enum):
    """
    :cvar BOTTOM: The contents of the table cell is bottom aligned.
    :cvar MIDDLE: The contents of the table is vertically centered.
    :cvar TOP: The contents of the table cell is top aligned.
    """

    BOTTOM = "BOTTOM"
    MIDDLE = "MIDDLE"
    TOP = "TOP"


class VariableAccessSubtypesEnum(Enum):
    VARIABLE_ACCESS = "VARIABLE-ACCESS"


class VariableAccessScopeEnumSimple(Enum):
    """
    :cvar COMMUNICATION_INTER_ECU: This case is foreseen to express that
        the corresponding communication shall be considered inter-ECU,
        i.e. it will cross the ECU boundary. This is considered the
        default case.
    :cvar COMMUNICATION_INTRA_PARTITION: This case is foreseen to
        express that the corresponding communication shall '''not'''
        cross the boundary of a partition.
    :cvar INTER_PARTITION_INTRA_ECU: In this case the communication
        shall cross the boundaries of partitions within one ECU but it
        shall not cross the boundaries of the ECU itself.
    """

    COMMUNICATION_INTER_ECU = "COMMUNICATION-INTER-ECU"
    COMMUNICATION_INTRA_PARTITION = "COMMUNICATION-INTRA-PARTITION"
    INTER_PARTITION_INTRA_ECU = "INTER-PARTITION-INTRA-ECU"


class VariableDataPrototypeSubtypesEnum(Enum):
    VARIABLE_DATA_PROTOTYPE = "VARIABLE-DATA-PROTOTYPE"


class VehicleDriverNotificationEnumSimple(Enum):
    """
    :cvar ACTIVATE: Software package shall be activated.
    :cvar CANCEL: Cancellation of the campaign.
    :cvar FINISH: Finish notification
    :cvar PROCESS: Processing of software package shall be executed
    :cvar ROLL_BACK: Software package shall be rolled back.
    :cvar TRANSFER: Software shall be transferred to the vehicle.
    """

    ACTIVATE = "ACTIVATE"
    CANCEL = "CANCEL"
    FINISH = "FINISH"
    PROCESS = "PROCESS"
    ROLL_BACK = "ROLL-BACK"
    TRANSFER = "TRANSFER"


@dataclass(slots=True, kw_only=True)
class VerbatimString:
    """
    This primitive represents a string in which white-space needs to be preserved.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar space: This attribute is used to signal an intention that in
        that element, white space should be preserved by applications.
        It is defined according to xml:space as declared by W3C.
    """

    class Meta:
        name = "VERBATIM-STRING"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "white_space": "preserve",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    space: str | None = field(
        default=None,
        metadata={
            "type": "Attribute",
            "namespace": "http://www.w3.org/XML/1998/namespace",
        },
    )


@dataclass(slots=True, kw_only=True)
class VerbatimStringPlain:
    """This primitive represents a string in which white-space needs to be
    preserved.

    This primitive is applied in cases where xml:space attribute cannot
    be provided by the primitive type but needs to be provided by the
    container class. This is in particular the case in applications of
    TR_APRXML_00024.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VERBATIM-STRING-PLAIN"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "white_space": "preserve",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class VerificationStatusIndicationModeEnumSimple(Enum):
    """
    :cvar FAILURE_AND_SUCCESS: Verification attempts that came out
        "false" or "true" shall be forwarded to the application
        software.
    :cvar FAILURE_ONLY: Only verification attempts that came out "false"
        shall be forwarded to the application software.
    """

    FAILURE_AND_SUCCESS = "FAILURE-AND-SUCCESS"
    FAILURE_ONLY = "FAILURE-ONLY"


@dataclass(slots=True, kw_only=True)
class ViewTokens:
    """
    This primitive specifies the tokens to specify a documentation view.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VIEW-TOKENS"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


class XmlSpaceEnumSimple(Enum):
    """
    :cvar DEFAULT: The value "default" signals that applications'
        default white-space processing modes are acceptable for this
        element.
    :cvar PRESERVE: the value "preserve" indicates the intent that
        applications preserve all the white space.
    """

    DEFAULT = "default"
    PRESERVE = "preserve"


@dataclass(slots=True, kw_only=True)
class AbsoluteTolerance:
    """
    Maximum allowable deviation.

    :ivar absolute: Maximum allowable deviation in duration (in seconds)
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ABSOLUTE-TOLERANCE"

    absolute: TimeValue | None = field(
        default=None,
        metadata={
            "name": "ABSOLUTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class AccessControlEnum:
    """
    This enumeration describes the options for the definition of access restriction
    to resources.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ACCESS-CONTROL-ENUM"

    value: AccessControlEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class AclScopeEnum:
    """
    This enumerator represents the scope of a definition in context of access
    control.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ACL-SCOPE-ENUM"

    value: AclScopeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class AdditionalBindingTimeEnum:
    """
    This enumeration specifies the additional binding times applicable for
    vh.latestBindingTime of variation points.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ADDITIONAL-BINDING-TIME-ENUM"

    value: AdditionalBindingTimeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class AggregationCondition:
    """
    The AggregationCondition evaluates to true, if the referenced aggregation is
    accepted by all rules of this condition.

    :ivar lower_multiplicity: Specifies the minimal number of times an
        object shall occur. If this primitive attribute is not set, then
        the object is optional.
    :ivar upper_multiplicity: Specifies the maximum number of times an
        object may occur.  If this primitive attribute is not set, then
        there is no limit with respect to the maximum occurrence.
    :ivar upper_multiplicity_infinite: This explicitly specifies, that
        the upper multiplicity is NOT restricted. Note: The use of
        'upperMultiplicityInfinite' and 'upperMultiplicity' is mutual
        exclusive.
    :ivar aggregation_ref: The aggregation that has to be accepted by
        the restrictions of this AggregationCondition
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AGGREGATION-CONDITION"

    lower_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: Boolean | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    aggregation_ref: Optional["AggregationCondition.AggregationRef"] = field(
        default=None,
        metadata={
            "name": "AGGREGATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AggregationRef(Ref):
        dest: AggregationTailoringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AlignEnum:
    """
    This enumerator specifies horizontal alignment.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ALIGN-ENUM"

    value: AlignEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ApiPrincipleEnum:
    """
    This enumeration represents the ability to control the granularity of API
    generation.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "API-PRINCIPLE-ENUM"

    value: ApiPrincipleEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ApplicationCompositeElementInPortInterfaceInstanceRef:
    """
    :ivar root_data_prototype_ref: This refers to the dataPrototype
        which is typed by theApplicationDatatype in which which the
        target can be found.
    :ivar context_data_prototype_ref: This represents a context
        ApplicationCompositeDataPrototype
    :ivar target_data_prototype_ref: This represents the referenced
        ApplicationCompositeDataPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-COMPOSITE-ELEMENT-IN-PORT-INTERFACE-INSTANCE-REF"

    root_data_prototype_ref: Optional[
        "ApplicationCompositeElementInPortInterfaceInstanceRef.RootDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROOT-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_data_prototype_ref: list[
        "ApplicationCompositeElementInPortInterfaceInstanceRef.ContextDataPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_data_prototype_ref: Optional[
        "ApplicationCompositeElementInPortInterfaceInstanceRef.TargetDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class RootDataPrototypeRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextDataPrototypeRef(Ref):
        dest: ApplicationCompositeElementDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataPrototypeRef(Ref):
        dest: ApplicationCompositeElementDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ApplicationDataPrototypeInSystemInstanceRef:
    """
    :ivar context_composition_ref:
    :ivar context_component_ref:
    :ivar context_port_ref:
    :ivar root_data_prototype_ref:
    :ivar context_data_prototype_ref:
    :ivar target_data_prototype_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-DATA-PROTOTYPE-IN-SYSTEM-INSTANCE-REF"

    context_composition_ref: Optional[
        "ApplicationDataPrototypeInSystemInstanceRef.ContextCompositionRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-COMPOSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_ref: list[
        "ApplicationDataPrototypeInSystemInstanceRef.ContextComponentRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_port_ref: Optional["ApplicationDataPrototypeInSystemInstanceRef.ContextPortRef"] = (
        field(
            default=None,
            metadata={
                "name": "CONTEXT-PORT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    root_data_prototype_ref: Optional[
        "ApplicationDataPrototypeInSystemInstanceRef.RootDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROOT-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_data_prototype_ref: list[
        "ApplicationDataPrototypeInSystemInstanceRef.ContextDataPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_data_prototype_ref: Optional[
        "ApplicationDataPrototypeInSystemInstanceRef.TargetDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextCompositionRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextPortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RootDataPrototypeRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextDataPrototypeRef(Ref):
        dest: ApplicationCompositeElementDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataPrototypeRef(Ref):
        dest: DataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ApplicationErrorMapping:
    """In client server communication, the server may return any value within the
    application error range.

    The ApplicationError is mapped to the responseGroup.

    :ivar system_signal_ref: Reference to the SystemSignal with the
        ApplicationError.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-ERROR-MAPPING"

    system_signal_ref: Optional["ApplicationErrorMapping.SystemSignalRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ArParameterInImplementationDataInstanceRef:
    """This class represents the ability to navigate into an element inside of an
    ParameterDataPrototype typed  by an ImplementationDatatype.

    Note that it shall not be used if the target is the
    ParameterDataPrototype itself (e.g. if the target is a primitive
    data type). Note that this class follows the pattern of an
    InstanceRef but is not implemented based on the abstract classes
    because the ImplementationDataType isn't either, especially because
    ImplementationDataTypeElement (intentionally) isn't derived from
    AtpPrototype.

    :ivar context_data_prototype_refs: This is a context in case there
        are subelements with explicit types. The reference has to be
        ordered to properly reflect the nested structure.
    :ivar port_prototype_ref: This reference points to the PortPrototype
        providing/receiving the root of the parameter.
    :ivar root_parameter_data_prototype_ref: This refers to the
        ParameterDataPrototype typed by the implementationDataType in
        which the target can be found.
    :ivar target_data_prototype_ref: This reference points to the target
        ImplementationDataTypeElement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AR-PARAMETER-IN-IMPLEMENTATION-DATA-INSTANCE-REF"

    context_data_prototype_refs: Optional[
        "ArParameterInImplementationDataInstanceRef.ContextDataPrototypeRefs"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-DATA-PROTOTYPE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_ref: Optional["ArParameterInImplementationDataInstanceRef.PortPrototypeRef"] = (
        field(
            default=None,
            metadata={
                "name": "PORT-PROTOTYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    root_parameter_data_prototype_ref: Optional[
        "ArParameterInImplementationDataInstanceRef.RootParameterDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROOT-PARAMETER-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_data_prototype_ref: Optional[
        "ArParameterInImplementationDataInstanceRef.TargetDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextDataPrototypeRefs:
        context_data_prototype_ref: list[
            "ArParameterInImplementationDataInstanceRef.ContextDataPrototypeRefs.ContextDataPrototypeRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-DATA-PROTOTYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextDataPrototypeRef(Ref):
            dest: AbstractImplementationDataTypeElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PortPrototypeRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RootParameterDataPrototypeRef(Ref):
        dest: ParameterDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataPrototypeRef(Ref):
        dest: AbstractImplementationDataTypeElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ArVariableInImplementationDataInstanceRef:
    """This class represents the ability to navigate into a data element inside of
    an VariableDataPrototype which is typed  by an ImplementationDatatype.

    Note that it shall not be used if the target is the
    VariableDataPrototype itself (e.g. if its a primitive). Note that
    this class follows the pattern of an InstanceRef but is not
    implemented based on the abstract classes because the
    ImplementationDataType isn't either, especially because
    ImplementationDataTypeElement isn't derived from AtpPrototype.

    :ivar port_prototype_ref: This is the port providing/receiving the
        root of the variable
    :ivar root_variable_data_prototype_ref: This refers to the
        VariableDataPrototype typed by the ImplementationDatatype in
        which the target can be found.
    :ivar context_data_prototype_refs: This is a context in case there
        are subelements with explicit types. The reference has to be
        ordered to properly reflect the nested structure.
    :ivar target_data_prototype_ref: This reference points to the target
        ImplementationDataTypeElement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AR-VARIABLE-IN-IMPLEMENTATION-DATA-INSTANCE-REF"

    port_prototype_ref: Optional["ArVariableInImplementationDataInstanceRef.PortPrototypeRef"] = (
        field(
            default=None,
            metadata={
                "name": "PORT-PROTOTYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    root_variable_data_prototype_ref: Optional[
        "ArVariableInImplementationDataInstanceRef.RootVariableDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROOT-VARIABLE-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_data_prototype_refs: Optional[
        "ArVariableInImplementationDataInstanceRef.ContextDataPrototypeRefs"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-DATA-PROTOTYPE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_data_prototype_ref: Optional[
        "ArVariableInImplementationDataInstanceRef.TargetDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PortPrototypeRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RootVariableDataPrototypeRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextDataPrototypeRefs:
        context_data_prototype_ref: list[
            "ArVariableInImplementationDataInstanceRef.ContextDataPrototypeRefs.ContextDataPrototypeRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-DATA-PROTOTYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextDataPrototypeRef(Ref):
            dest: AbstractImplementationDataTypeElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TargetDataPrototypeRef(Ref):
        dest: AbstractImplementationDataTypeElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Area:
    """This element specifies a region in an image map.

    Image maps enable authors to specify regions in an object (e.g. a
    graphic) and to assign a specific activity to each region (e.g. load
    a document, launch a program etc.). For more details refer to the
    specification of HTML.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar accesskey: This attribute assigns an access key to an element.
        An access key is an individual character (e.g. "B") within the
        document character range. If an access key with an element
        assigned to it is pressed, the element comes into focus. The
        activity performed when an element comes into focus, is
        dependent on the element itself
    :ivar alt: This attribute specifies the text to be inserted as an
        alternative to illustrations, shapes or applets, where these
        cannot be displayed by user agents.
    :ivar class_value: Blank separated list of classes
    :ivar coords: This attribute specifies the position and shape on the
        screen. The number of values and their order depend on the
        geometrical figure defined.
    :ivar href: This attribute specifies the memory location of a web
        resource. It is therefore able to specify a link between the
        current element and the target element.
    :ivar nohref: If this attribute is set, the Area has no associated
        link.
    :ivar onblur: The ONBLUR-Event occurs, when focus is switched away
        from an element. A script can be stored in this attribute to be
        performed in the Event.
    :ivar onclick: The ONCLICK-Event occurs, if the current element is
        clicked-on. A script can be stored in this attribute to be
        performed in the Event.
    :ivar ondblclick: The ONCLICK-Event occurs, if the current element
        is "double" clicked-on. A script can be stored in this attribute
        to be performed in the Event.
    :ivar onfocus: The ONFOCUS-Event occurs, if an element comes into
        focus (e.g., through navigation using the tab button). A script
        can be stored in this attribute to be performed in the Event.
    :ivar onkeydown: The ONKEYDOWN-Event occurs, if a button on the
        current element is pressed down. A script can be stored in this
        attribute to be performed in the event.
    :ivar onkeypress: The ONKEYPRESS-Event occurs, if a button on the
        current element is pressed down and released. A script can be
        stored in this attribute to be performed in the Event.
    :ivar onkeyup: The ONKEYUP-Event occurs, if a button on the current
        element is released. A script can be stored in this attribute to
        be performed in the Event.
    :ivar onmousedown: The ONMOUSEDOWN-Event occurs, if the mouse button
        used for clicking is held down on the current element. A script
        can be stored in this attribute to be performed in the Event.
    :ivar onmousemove: The ONMOUSEMOVE-Event occurs, if the mouse
        pointer is moved on the current element (i.e. it is located on
        the current element). A script can be stored in this attribute
        to be performed in the Event.
    :ivar onmouseout: The ONMOUSEOUT-Event occurs, if the mouse pointer
        is moved from the current element. A script can be stored in
        this attribute to be performed in the Event.
    :ivar onmouseover: The ONMOUSEOVER-Event occurs, if the mouse
        pointer is moved to the current element from another location
        outside it. A script can be stored in this attribute to be
        performed in the Event.
    :ivar onmouseup: The ONMOUSEUP-Event occurs if the mouse button used
        for clicking is released on the current element. A script can be
        stored in this attribute to be performed in the Event.
    :ivar shape: The shape of the area. Note that in HTML this is
        defaulted to RECT.
    :ivar style: Information on the associated style
    :ivar tabindex: This attribute specifies the position of the current
        element in tabbing-order for the corresponding document. The
        value shall lie between 0 and 32767. The Tabbing Order defines
        the sequence in which elements are focused on, when the user
        navigates using the keyboard.
    :ivar title: Title information of the Area element
    """

    class Meta:
        name = "AREA"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    accesskey: str | None = field(
        default=None,
        metadata={
            "name": "ACCESSKEY",
            "type": "Attribute",
        },
    )
    alt: str | None = field(
        default=None,
        metadata={
            "name": "ALT",
            "type": "Attribute",
        },
    )
    class_value: str | None = field(
        default=None,
        metadata={
            "name": "CLASS",
            "type": "Attribute",
        },
    )
    coords: str | None = field(
        default=None,
        metadata={
            "name": "COORDS",
            "type": "Attribute",
        },
    )
    href: str | None = field(
        default=None,
        metadata={
            "name": "HREF",
            "type": "Attribute",
        },
    )
    nohref: AreaEnumNohrefSimple | None = field(
        default=None,
        metadata={
            "name": "NOHREF",
            "type": "Attribute",
        },
    )
    onblur: str | None = field(
        default=None,
        metadata={
            "name": "ONBLUR",
            "type": "Attribute",
        },
    )
    onclick: str | None = field(
        default=None,
        metadata={
            "name": "ONCLICK",
            "type": "Attribute",
        },
    )
    ondblclick: str | None = field(
        default=None,
        metadata={
            "name": "ONDBLCLICK",
            "type": "Attribute",
        },
    )
    onfocus: str | None = field(
        default=None,
        metadata={
            "name": "ONFOCUS",
            "type": "Attribute",
        },
    )
    onkeydown: str | None = field(
        default=None,
        metadata={
            "name": "ONKEYDOWN",
            "type": "Attribute",
        },
    )
    onkeypress: str | None = field(
        default=None,
        metadata={
            "name": "ONKEYPRESS",
            "type": "Attribute",
        },
    )
    onkeyup: str | None = field(
        default=None,
        metadata={
            "name": "ONKEYUP",
            "type": "Attribute",
        },
    )
    onmousedown: str | None = field(
        default=None,
        metadata={
            "name": "ONMOUSEDOWN",
            "type": "Attribute",
        },
    )
    onmousemove: str | None = field(
        default=None,
        metadata={
            "name": "ONMOUSEMOVE",
            "type": "Attribute",
        },
    )
    onmouseout: str | None = field(
        default=None,
        metadata={
            "name": "ONMOUSEOUT",
            "type": "Attribute",
        },
    )
    onmouseover: str | None = field(
        default=None,
        metadata={
            "name": "ONMOUSEOVER",
            "type": "Attribute",
        },
    )
    onmouseup: str | None = field(
        default=None,
        metadata={
            "name": "ONMOUSEUP",
            "type": "Attribute",
        },
    )
    shape: AreaEnumShapeSimple | None = field(
        default=None,
        metadata={
            "name": "SHAPE",
            "type": "Attribute",
        },
    )
    style: str | None = field(
        default=None,
        metadata={
            "name": "STYLE",
            "type": "Attribute",
        },
    )
    tabindex: str | None = field(
        default=None,
        metadata={
            "name": "TABINDEX",
            "type": "Attribute",
        },
    )
    title: str | None = field(
        default=None,
        metadata={
            "name": "TITLE",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class AreaEnumNohref:
    """
    This enumerator specifies the fact that the area has no reference.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AREA-ENUM-NOHREF"

    value: AreaEnumNohrefSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class AreaEnumShape:
    """
    This enumerator specifies the shape of the area.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AREA-ENUM-SHAPE"

    value: AreaEnumShapeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ArgumentDirectionEnum:
    """Use cases:
    * Arguments in ClientServerOperation can have different directions that need to be formally indicated because they have an impact on how the function signature looks like eventually.
    * Arguments in BswModuleEntry already determine a function signature, but the direction is used to specify the semantics, especially of pointer arguments.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ARGUMENT-DIRECTION-ENUM"

    value: ArgumentDirectionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ArrayImplPolicyEnum:
    """
    This meta-class provides values to configure the implementation of the payload
    part of an array.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ARRAY-IMPL-POLICY-ENUM"

    value: ArrayImplPolicyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ArraySizeHandlingEnum:
    """
    This enumeration defines different ways to handle the sizes of variable size
    arrays.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ARRAY-SIZE-HANDLING-ENUM"

    value: ArraySizeHandlingEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ArraySizeSemanticsEnum:
    """
    This type controls how the information about the number of elements in an
    ApplicationArrayDataType is to be interpreted.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ARRAY-SIZE-SEMANTICS-ENUM"

    value: ArraySizeSemanticsEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class AutoCollectEnum:
    """
    This enumerator defines the possible approaches to determine the final set of
    elements in a collection.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AUTO-COLLECT-ENUM"

    value: AutoCollectEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class AutosarEngineeringObject:
    """This denotes an engineering object being part of the process.

    It is a specialization of the abstract class EngineeringObject for
    usage within AUTOSAR.

    :ivar short_label: This is the short name of the engineering object.
        Note that it is modeled as NameToken and not as Identifier since
        in ASAM-CC it is also a NameToken.
    :ivar category: This denotes the role of the engineering object in
        the development cycle. Categories are such as * SWSRC for source
        code * SWOBJ for object code * SWHDR for a C-header file Further
        roles need to be defined via Methodology.
    :ivar revision_labels: This is a revision label denoting a
        particular version of the engineering object.
    :ivar domain: This denotes the domain in which the engineering
        object is stored. This allows to indicate various segments in
        the repository keeping the engineering objects. The domain may
        segregate companies, as well as automotive domains. Details need
        to be defined by the Methodology. Attribute is optional to
        support a default domain.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AUTOSAR-ENGINEERING-OBJECT"

    short_label: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    revision_labels: Optional["AutosarEngineeringObject.RevisionLabels"] = field(
        default=None,
        metadata={
            "name": "REVISION-LABELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    domain: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "DOMAIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class RevisionLabels:
        revision_label: list[RevisionLabelString] = field(
            default_factory=list,
            metadata={
                "name": "REVISION-LABEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Baseline:
    """Specification of the baseline of the AUTOSAR standard this Data Exchange
    Point relates to.

    The baseline is specified by listing the AUTOSAR products and their
    revisions. Custom defined functionality and deviations to the
    standard can be provided as well. All references to specification
    elements in this Data Exchange Point refer to specification elements
    that are part of this specification baseline.

    :ivar standard_revisions: Specifies a combination of revisions of
        AUTOSAR standards that are used as the specification baseline of
        this Data Exchange Point. All standard specification elements
        that are referenced by this Profile of Data Exchange Point have
        to be part of specifications that belong to the defined AUTOSAR
        standards.
    :ivar custom_specification_refs: Reference to custom specifications
        that extend this baseline,
    :ivar custom_sdg_def_refs: Reference to custom SdgDefs that extend
        the data format of this baseline,
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BASELINE"

    standard_revisions: Optional["Baseline.StandardRevisions"] = field(
        default=None,
        metadata={
            "name": "STANDARD-REVISIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    custom_specification_refs: Optional["Baseline.CustomSpecificationRefs"] = field(
        default=None,
        metadata={
            "name": "CUSTOM-SPECIFICATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    custom_sdg_def_refs: Optional["Baseline.CustomSdgDefRefs"] = field(
        default=None,
        metadata={
            "name": "CUSTOM-SDG-DEF-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class StandardRevisions:
        standard_revision: list[String] = field(
            default_factory=list,
            metadata={
                "name": "STANDARD-REVISION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CustomSpecificationRefs:
        custom_specification_ref: list[
            "Baseline.CustomSpecificationRefs.CustomSpecificationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CUSTOM-SPECIFICATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CustomSpecificationRef(Ref):
            dest: DocumentationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class CustomSdgDefRefs:
        custom_sdg_def_ref: list["Baseline.CustomSdgDefRefs.CustomSdgDefRef"] = field(
            default_factory=list,
            metadata={
                "name": "CUSTOM-SDG-DEF-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CustomSdgDefRef(Ref):
            dest: SdgDefSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class BinaryManifestItemNumericalValue:
    """
    This meta-class has the ability to provide a numerical value for a binary
    manifest item.

    :ivar value: This attribute specifies the actual numerical value to
        be used in the binary manifest handle.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BINARY-MANIFEST-ITEM-NUMERICAL-VALUE"

    value: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BinaryManifestItemPointerValue:
    """
    This meta-class has the ability to provide a value for a pointer in the context
    of a binary manifest item.

    :ivar address: This attribute represents the address value of the
        enclosing pointer value.
    :ivar symbol: This attribute represents the symbol associated with
        the binary manifest handle.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BINARY-MANIFEST-ITEM-POINTER-VALUE"

    address: Address | None = field(
        default=None,
        metadata={
            "name": "ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol: SymbolString | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BindingTimeEnum:
    """
    This enumerator specifies the applicable binding times for the pre build
    variation points.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BINDING-TIME-ENUM"

    value: BindingTimeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BlueprintFormula:
    """This class express the extension of the Formula Language to provide
    formalized blueprint-Value resp.

    blueprintCondition.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar content:
    """

    class Meta:
        name = "BLUEPRINT-FORMULA"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef("BlueprintFormula.SyscStringRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("BlueprintFormula.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "ECUC-QUERY-REF",
                    "type": ForwardRef("BlueprintFormula.EcucQueryRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "ECUC-REF",
                    "type": ForwardRef("BlueprintFormula.EcucRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "VERBATIM",
                    "type": ForwardRef("MultiLanguageVerbatim"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucQueryRef(Ref):
        dest: EcucQuerySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucRef(Ref):
        dest: EcucDefinitionElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BlueprintGenerator:
    """
    This class express the Extended Language to generate blueprint derivates in
    complex descriptions.

    :ivar introduction: This represents a description that documents how
        the blueprint generator shall be resolved when deriving objects
        from blueprints.
    :ivar expression: This represents a formal term in the expression
        based on the extended language.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BLUEPRINT-GENERATOR"

    introduction: Optional["DocumentationBlock"] = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    expression: VerbatimString | None = field(
        default=None,
        metadata={
            "name": "EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BlueprintMapping:
    """
    This meta-class represents the ability to map two an object and its blueprint.

    :ivar blueprint_ref: This represents the mapped blueprint.
    :ivar derived_object_ref: This represents the object which was
        derived from the blueprint.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BLUEPRINT-MAPPING"

    blueprint_ref: Optional["BlueprintMapping.BlueprintRef"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    derived_object_ref: Optional["BlueprintMapping.DerivedObjectRef"] = field(
        default=None,
        metadata={
            "name": "DERIVED-OBJECT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BlueprintRef(Ref):
        dest: AtpBlueprintSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DerivedObjectRef(Ref):
        dest: AtpBlueprintableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BlueprintPolicyNotModifiable:
    """
    The class represents that the related attribute is not modifiable during the
    blueprinting.

    :ivar attribute_name: This identifies the related attribute of a
        BlueprintPolicy. For navigation over the model a subset of xpath
        expressions is used.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BLUEPRINT-POLICY-NOT-MODIFIABLE"

    attribute_name: String | None = field(
        default=None,
        metadata={
            "name": "ATTRIBUTE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BooleanValueVariationPoint:
    """This class represents an attribute value variation point for Boolean
    attributes.

    Note that this class might be used in the extended meta-model on

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar binding_time: This is the binding time in which the attribute
        value needs to be bound. If this attribute is missing, the
        attribute is not a variation point. In particular this means
        that It needs to be a single value according to the type
        specified in the pure model. It is an error if it is still a
        formula.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar sd: This special data is provided to allow synchronization of
        Attribute value variation points with variant management
        systems. The usage is subject of agreement between the involved
        parties.
    :ivar short_label: This allows to identify the variation point. It
        is also intended to allow RTE support for CompileTime Variation
        points.
    :ivar content:
    """

    class Meta:
        name = "BOOLEAN-VALUE-VARIATION-POINT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    binding_time: BindingTimeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "BINDING-TIME",
            "type": "Attribute",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    sd: str | None = field(
        default=None,
        metadata={
            "name": "SD",
            "type": "Attribute",
        },
    )
    short_label: str | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef("BooleanValueVariationPoint.SyscStringRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("BooleanValueVariationPoint.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswCallType:
    """
    Denotes the mechanism by which the entry into the Bsw module shall be called.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-CALL-TYPE"

    value: BswCallTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BswEntryKindEnum:
    """
    Denotes the mechanism by which the entry into the Bsw module shall be called.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-ENTRY-KIND-ENUM"

    value: BswEntryKindEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BswEntryRelationshipEnum:
    """
    Define the type of relationship between two BswModuleEntrys.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-ENTRY-RELATIONSHIP-ENUM"

    value: BswEntryRelationshipEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BswExecutionContext:
    """
    Specifies the execution context required or guaranteed for the call associated
    with this service.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-EXECUTION-CONTEXT"

    value: BswExecutionContextSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BswInterruptCategory:
    """
    Category of the interrupt service.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-INTERRUPT-CATEGORY"

    value: BswInterruptCategorySimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BswModeSwitchAckRequest:
    """
    Requests acknowledgements that a mode switch has been processed  successfully.

    :ivar timeout: Number of seconds before an error is reported.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-MODE-SWITCH-ACK-REQUEST"

    timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BuildEngineeringObject:
    """
    This meta-class represents the ability to denote an artifact which is processed
    within a particular build action.

    :ivar short_label: This is the short name of the engineering object.
        Note that it is modeled as NameToken and not as Identifier since
        in ASAM-CC it is also a NameToken.
    :ivar category: This denotes the role of the engineering object in
        the development cycle. Categories are such as * SWSRC for source
        code * SWOBJ for object code * SWHDR for a C-header file Further
        roles need to be defined via Methodology.
    :ivar revision_labels: This is a revision label denoting a
        particular version of the engineering object.
    :ivar domain: This denotes the domain in which the engineering
        object is stored. This allows to indicate various segments in
        the repository keeping the engineering objects. The domain may
        segregate companies, as well as automotive domains. Details need
        to be defined by the Methodology. Attribute is optional to
        support a default domain.
    :ivar file_type: This attribute indicates the file type which shall
        used for the engineering object. Note that an engineering object
        may deliver multiple representations of the same artifact. This
        attribute can select one of the provided representations.
    :ivar intended_filename: This attribute represents the name of the
        file if it is created newly. Note that engineering object
        resolves category + ShortLabel indicate mainly to refer to an
        existing file. If the file is created newly, the filename can
        either be determined by built in policy or predefined here. Note
        that extensions shall part of file name even if it could be
        derived from fileType.
    :ivar parent_category: This represents the category of the parent
        object.
    :ivar parent_short_label: This represents the shortLabel of the
        parent object. This allows to specify the output position in a
        hierarchically organized system.
    :ivar short_label_pattern: This attribute allows to define a set of
        engineering objects as pattern based search applied to the
        shortLabel of the individual Engineering objects.
    :ivar file_type_pattern: This attribute allows to define a set of
        engineering objects as pattern based search applied to the
        filetype of the individual Engineering objects.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUILD-ENGINEERING-OBJECT"

    short_label: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    revision_labels: Optional["BuildEngineeringObject.RevisionLabels"] = field(
        default=None,
        metadata={
            "name": "REVISION-LABELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    domain: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "DOMAIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    file_type: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "FILE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    intended_filename: UriString | None = field(
        default=None,
        metadata={
            "name": "INTENDED-FILENAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parent_category: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "PARENT-CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parent_short_label: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "PARENT-SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_label_pattern: RegularExpression | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    file_type_pattern: RegularExpression | None = field(
        default=None,
        metadata={
            "name": "FILE-TYPE-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class RevisionLabels:
        revision_label: list[RevisionLabelString] = field(
            default_factory=list,
            metadata={
                "name": "REVISION-LABEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BuildTypeEnum:
    """
    This enumeration defines the possible buildTypes a software module may be
    implemented.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUILD-TYPE-ENUM"

    value: BuildTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BusMirrorCanIdRangeMapping:
    """
    This element defines a rule for remapping a set of CAN IDs.

    :ivar destination_base_id: Base ID merged with the masked parts of
        the original CAN ID to form the mapped CAN ID.
    :ivar source_can_id_code: Value to match masked original CAN IDs.
    :ivar source_can_id_mask: Mask applied to original CAN IDs before
        comparison.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUS-MIRROR-CAN-ID-RANGE-MAPPING"

    destination_base_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-BASE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_can_id_code: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SOURCE-CAN-ID-CODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_can_id_mask: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SOURCE-CAN-ID-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BusMirrorCanIdToCanIdMapping:
    """
    This element defines a rule for remapping a single CAN ID.

    :ivar remapped_can_id: This attribute defines the CanId on the
        targetChannel.
    :ivar souce_can_id_ref: This reference points to the sourceFrame
        with sourceCanId on the sourceChannel.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUS-MIRROR-CAN-ID-TO-CAN-ID-MAPPING"

    remapped_can_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "REMAPPED-CAN-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    souce_can_id_ref: Optional["BusMirrorCanIdToCanIdMapping.SouceCanIdRef"] = field(
        default=None,
        metadata={
            "name": "SOUCE-CAN-ID-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SouceCanIdRef(Ref):
        dest: CanFrameTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BusMirrorLinPidToCanIdMapping:
    """
    This element defines a rule for remapping a single LIN Frame.

    :ivar remapped_can_id: This attribute defines the CanId on the
        targetChannel.
    :ivar source_lin_pid_ref: This reference points to the sourceFrame
        with sourceCanId on the sourceChannel.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUS-MIRROR-LIN-PID-TO-CAN-ID-MAPPING"

    remapped_can_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "REMAPPED-CAN-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_lin_pid_ref: Optional["BusMirrorLinPidToCanIdMapping.SourceLinPidRef"] = field(
        default=None,
        metadata={
            "name": "SOURCE-LIN-PID-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SourceLinPidRef(Ref):
        dest: LinFrameTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ByteOrderEnum:
    """When more than one byte is stored in the memory the order of those bytes may
    differ depending on the architecture of the processing unit.

    If the least significant byte is stored at the lowest address, this
    architecture is called little endian and otherwise it is called big
    endian. ByteOrder is very important in case of communication between
    different PUs or ECUs.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BYTE-ORDER-ENUM"

    value: ByteOrderEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CalprmAxisCategoryEnum:
    """
    This enum specifies the possible values of the category property within
    SwCalprmAxis.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CALPRM-AXIS-CATEGORY-ENUM"

    value: CalprmAxisCategoryEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanAddressingModeType:
    """
    Indicates whether standard or extended CAN identifiers are used.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-ADDRESSING-MODE-TYPE"

    value: CanAddressingModeTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanClusterBusOffRecovery:
    """
    This element contains the attributes that are used to configure the CAN bus off
    monitoring / recovery at system level.

    :ivar bor_counter_l_1_to_l_2: This threshold defines the count of
        bus-offs until the bus-off recovery switches from level 1 (short
        recovery time) to level 2 (long recovery time).
    :ivar bor_time_l_1: This attribute defines the duration of the bus-
        off recovery time in level 1 (short recovery time) in seconds.
    :ivar bor_time_l_2: This attribute defines the duration of the bus-
        off recovery time in level 2 (long recovery time) in seconds.
    :ivar bor_time_tx_ensured: This attribute defines the duration of
        the bus-off event check in seconds.
    :ivar main_function_period: This attribute defines the cycle time of
        the function CanSM_MainFunction in seconds.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-CLUSTER-BUS-OFF-RECOVERY"

    bor_counter_l_1_to_l_2: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BOR-COUNTER-L-1-TO-L-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bor_time_l_1: TimeValue | None = field(
        default=None,
        metadata={
            "name": "BOR-TIME-L-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bor_time_l_2: TimeValue | None = field(
        default=None,
        metadata={
            "name": "BOR-TIME-L-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bor_time_tx_ensured: TimeValue | None = field(
        default=None,
        metadata={
            "name": "BOR-TIME-TX-ENSURED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    main_function_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MAIN-FUNCTION-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanControllerFdConfiguration:
    """
    Bit timing related configuration of a CAN controller for payload and CRC of a
    CAN FD frame.

    :ivar padding_value: Specifies the value which is used to pad unused
        data in CAN FD frames which are bigger than 8 byte if the length
        of a Pdu which was requested to be sent does not match the
        allowed DLC values of CAN FD.
    :ivar prop_seg: Specifies propagation delay in time quantas.
    :ivar ssp_offset: Specifies the Transmitter Delay Compensation
        Offset in minimum time quanta. Transmitter Delay Compensation
        Offset is used to adjust the position of the Secondary Sample
        Point (SSP), relative to the beginning of the received bit. If
        this parameter is configured, the Transmitter Delay Compensation
        is done by measurement of the CAN controller. If not specified
        Transmitter Delay Compensation is disabled.
    :ivar sync_jump_width: Specifies the synchronization jump width for
        the controller in time quantas.
    :ivar time_seg_1: Specifies phase segment 1 in time quantas.
    :ivar time_seg_2: Specifies phase segment 2 in time quantas.
    :ivar trcv_delay_compensation_offset: Specifies the Transceiver
        Delay Compensation Offset in seconds. If not specified
        Transceiver Delay Compensation is disabled.
    :ivar tx_bit_rate_switch: Specifies if the bit rate switching shall
        be used for transmissions. TRUE: CAN FD frames shall be sent
        with bit rate switching. FALSE: CAN FD frames shall be sent
        without bit rate switching.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-CONTROLLER-FD-CONFIGURATION"

    padding_value: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PADDING-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prop_seg: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PROP-SEG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ssp_offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SSP-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_jump_width: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SYNC-JUMP-WIDTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_seg_1: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TIME-SEG-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_seg_2: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TIME-SEG-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trcv_delay_compensation_offset: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TRCV-DELAY-COMPENSATION-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tx_bit_rate_switch: Boolean | None = field(
        default=None,
        metadata={
            "name": "TX-BIT-RATE-SWITCH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanControllerFdConfigurationRequirements:
    """This element allows the specification of ranges for the CanFD bit timing
    configuration parameters.

    These ranges are taken as requirements and shall be respected by the
    ECU developer.

    :ivar max_number_of_time_quanta_per_bit: Maximum number of time
        quanta in the bit time.
    :ivar max_sample_point: The max. value of the sample point as a
        percentage of the total bit time.
    :ivar max_sync_jump_width: The max. Synchronization Jump Width value
        as a percentage of the total bit time. The (Re-)Synchronization
        Jump Width (SJW) defines how far a resynchronization may move
        the Sample Point inside the limits defined by the Phase Buffer
        Segments to compensate for edge phase errors.
    :ivar max_trcv_delay_compensation_offset: Specifies the maximum
        Transceiver Delay Compensation Offset in seconds. If not
        specified Transceiver Delay Compensation is disabled.
    :ivar min_number_of_time_quanta_per_bit: Minimum number of time
        quanta in the bit time.
    :ivar min_sample_point: The min. value of the sample point as a
        percentage of the total bit time.
    :ivar min_sync_jump_width: The min. Synchronization Jump Width value
        as a percentage of the total bit time. The (Re-)Synchronization
        Jump Width (SJW) defines how far a resynchronization may move
        the Sample Point inside the limits defined by the Phase Buffer
        Segments to compensate for edge phase errors.
    :ivar min_trcv_delay_compensation_offset: Specifies the minimum
        Transceiver Delay Compensation Offset in seconds. If not
        specified Transceiver Delay Compensation is disabled.
    :ivar padding_value: Specifies the value which is used to pad unused
        data in CAN FD frames which are bigger than 8 byte if the length
        of a Pdu which was requested to be sent does not match the
        allowed DLC values of CAN FD.
    :ivar tx_bit_rate_switch: Specifies if the bit rate switching shall
        be used for transmissions. TRUE: CAN FD frames shall be sent
        with bit rate switching. FALSE: CAN FD frames shall be sent
        without bit rate switching.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-CONTROLLER-FD-CONFIGURATION-REQUIREMENTS"

    max_number_of_time_quanta_per_bit: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-TIME-QUANTA-PER-BIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_sample_point: Float | None = field(
        default=None,
        metadata={
            "name": "MAX-SAMPLE-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_sync_jump_width: Float | None = field(
        default=None,
        metadata={
            "name": "MAX-SYNC-JUMP-WIDTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_trcv_delay_compensation_offset: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MAX-TRCV-DELAY-COMPENSATION-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_number_of_time_quanta_per_bit: Integer | None = field(
        default=None,
        metadata={
            "name": "MIN-NUMBER-OF-TIME-QUANTA-PER-BIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_sample_point: Float | None = field(
        default=None,
        metadata={
            "name": "MIN-SAMPLE-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_sync_jump_width: Float | None = field(
        default=None,
        metadata={
            "name": "MIN-SYNC-JUMP-WIDTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_trcv_delay_compensation_offset: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MIN-TRCV-DELAY-COMPENSATION-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    padding_value: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PADDING-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tx_bit_rate_switch: Boolean | None = field(
        default=None,
        metadata={
            "name": "TX-BIT-RATE-SWITCH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanControllerXlConfiguration:
    """
    This meta-class represents the CAN XL-specific controller attributes.

    :ivar error_signaling_enabled: Specifies if error signaling shall be
        enabled. This is not possible when the transceiver is switched
        to PWM mode (trcvPwmModeEnabled set to TRUE). TRUE: Error
        signaling shall be enabled. FALSE: Error signaling shall be
        disabled.
    :ivar prop_seg: Specifies propagation delay in time quantas.
    :ivar pwm_l: Specifies the PWM long phase length.
    :ivar pwm_o: Specifies the PWM time offset.
    :ivar pwm_s: Specifies the PWM short phase length.
    :ivar ssp_offset: Specifies the Transmitter Delay Compensation
        Offset in minimum time quanta. Transmitter Delay Compensation
        Offset is used to adjust the position of the Secondary Sample
        Point (SSP), relative to the beginning of the received bit. If
        this parameter is configured, the Transmitter Delay Compensation
        is done by measurement of the CAN controller. If not specified
        Transmitter Delay Compensation is disabled.
    :ivar sync_jump_width: Specifies the synchronization jump width for
        the controller in time quantas.
    :ivar time_seg_1: Specifies phase segment 1 in time quantas.
    :ivar time_seg_2: Specifies phase segment 2 in time quantas.
    :ivar trcv_pwm_mode_enabled: Specifies if the transceiver shall be
        set to the PWM mode. TRUE: The transceiver shall be switched to
        PWM mode. FALSE: The transceiver shall work in classic CAN mode.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-CONTROLLER-XL-CONFIGURATION"

    error_signaling_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "ERROR-SIGNALING-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prop_seg: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PROP-SEG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pwm_l: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PWM-L",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pwm_o: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PWM-O",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pwm_s: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PWM-S",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ssp_offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SSP-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_jump_width: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SYNC-JUMP-WIDTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_seg_1: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TIME-SEG-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_seg_2: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TIME-SEG-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trcv_pwm_mode_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TRCV-PWM-MODE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanControllerXlConfigurationRequirements:
    """This element allows the specification of ranges for the CAN XL configuration
    parameters.

    These ranges are taken as requirements and have to be respected by
    the ECU developer.

    :ivar error_signaling_enabled: Specifies if error signaling shall be
        enabled. This is not possible when the transceiver is switched
        to PWM mode (trcvPwmModeEnabled set to TRUE). TRUE: Error
        signaling shall be enabled. FALSE: Error signaling shall be
        disabled.
    :ivar max_number_of_time_quanta_per_bit: Maximum number of time
        quanta in the bit time.
    :ivar max_pwm_l: Specifies the maximum PWM long phase length.
    :ivar max_pwm_o: Specifies the minimum PWM time offset.
    :ivar max_pwm_s: Specifies the maximum PWM short phase length.
    :ivar max_sample_point: The max. value of the sample point as a
        percentage of the total bit time.
    :ivar max_sync_jump_width: The max. Synchronization Jump Width value
        as a percentage of the total bit time. The (Re-)Synchronization
        Jump Width (SJW) defines how far a resynchronization may move
        the Sample Point inside the limits defined by the Phase Buffer
        Segments to compensate for edge phase errors.
    :ivar max_trcv_delay_compensation_offset: Specifies the maximum
        Transceiver Delay Compensation Offset in seconds. If not
        specified Transceiver Delay Compensation is disabled.
    :ivar min_number_of_time_quanta_per_bit: Minimum number of time
        quanta in the bit time.
    :ivar min_pwm_l: Specifies the minimum PWM long phase length.
    :ivar min_pwm_o: Specifies the maximum PWM time offset.
    :ivar min_pwm_s: Specifies the minimum PWM short phase length.
    :ivar min_sample_point: The min. value of the sample point as a
        percentage of the total bit time.
    :ivar min_sync_jump_width: The min. Synchronization Jump Width value
        as a percentage of the total bit time. The (Re-)Synchronization
        Jump Width (SJW) defines how far a resynchronization may move
        the Sample Point inside the limits defined by the Phase Buffer
        Segments to compensate for edge phase errors.
    :ivar min_trcv_delay_compensation_offset: Specifies the minimum
        Transceiver Delay Compensation Offset in seconds. If not
        specified Transceiver Delay Compensation is disabled.
    :ivar trcv_pwm_mode_enabled: Specifies if the transceiver shall be
        set to the PWM mode. TRUE: The transceiver shall be switched to
        PWM mode. FALSE: The transceiver shall work in classic CAN mode.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-CONTROLLER-XL-CONFIGURATION-REQUIREMENTS"

    error_signaling_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "ERROR-SIGNALING-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_time_quanta_per_bit: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-TIME-QUANTA-PER-BIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_pwm_l: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-PWM-L",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_pwm_o: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-PWM-O",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_pwm_s: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-PWM-S",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_sample_point: Float | None = field(
        default=None,
        metadata={
            "name": "MAX-SAMPLE-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_sync_jump_width: Float | None = field(
        default=None,
        metadata={
            "name": "MAX-SYNC-JUMP-WIDTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_trcv_delay_compensation_offset: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MAX-TRCV-DELAY-COMPENSATION-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_number_of_time_quanta_per_bit: Integer | None = field(
        default=None,
        metadata={
            "name": "MIN-NUMBER-OF-TIME-QUANTA-PER-BIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_pwm_l: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-PWM-L",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_pwm_o: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-PWM-O",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_pwm_s: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-PWM-S",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_sample_point: Float | None = field(
        default=None,
        metadata={
            "name": "MIN-SAMPLE-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_sync_jump_width: Float | None = field(
        default=None,
        metadata={
            "name": "MIN-SYNC-JUMP-WIDTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_trcv_delay_compensation_offset: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MIN-TRCV-DELAY-COMPENSATION-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trcv_pwm_mode_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TRCV-PWM-MODE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanFrameRxBehaviorEnum:
    """
    Defines different CAN protocols for frame reception behavior.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-FRAME-RX-BEHAVIOR-ENUM"

    value: CanFrameRxBehaviorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanFrameTxBehaviorEnum:
    """
    Defines different CAN protocols for frame transmission behavior.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-FRAME-TX-BEHAVIOR-ENUM"

    value: CanFrameTxBehaviorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanNmEcu:
    """
    CAN specific attributes.

    :ivar nm_repeat_msg_indication_enabled: Enable/disable the
        notification that a RepeatMessageRequest bit has been received.
        This attribute is deprecated and shall be not used. It will be
        removed in the future. The nmRepeatMsgIndEnabled attribute in
        NmEcu shall be used instead.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-NM-ECU"

    nm_repeat_msg_indication_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-REPEAT-MSG-INDICATION-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanNmRangeConfig:
    """Defines the CANID ranges that are used for Nm.

    This range definition is redundant to the attribute
    "rxIdentifierRange" of CanFrameTriggering. For backward
    compatibility reasons this redundancy shall be preserved and both
    shall be defined. In future this element will be removed from the
    model.

    :ivar lower_can_id: Lower CAN Identifier of a receive CAN L-PDU for
        identifier range definition.
    :ivar upper_can_id: Upper CAN Identifier of a receive CAN L-PDU for
        identifier range definition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-NM-RANGE-CONFIG"

    lower_can_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOWER-CAN-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_can_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UPPER-CAN-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanTpAddressingFormatType:
    """
    Declares which communication addressing mode is supported.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-TP-ADDRESSING-FORMAT-TYPE"

    value: CanTpAddressingFormatTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanTpChannelModeType:
    """
    The CAN Transport Layer supports half and full duplex channel modes.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-TP-CHANNEL-MODE-TYPE"

    value: CanTpChannelModeTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanXlFrameTriggeringProps:
    """
    This element indicates the frame being CAN XL and contains further CAN XL
    specific attributes.

    :ivar acceptance_field: Acceptance field of a CAN XL message.
    :ivar priority_id: Priority ID of a CAN XL message.
    :ivar sdu_type: SDU type of a CAN XL message.
    :ivar vcid: Virtual CAN network ID of a CAN XL message.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-XL-FRAME-TRIGGERING-PROPS"

    acceptance_field: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ACCEPTANCE-FIELD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdu_type: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SDU-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vcid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VCID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ChapterEnumBreak:
    """
    This allows to specify the page break policy of a paginatable element.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CHAPTER-ENUM-BREAK"

    value: ChapterEnumBreakSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ClientIdMapping:
    """In case of a server on one ECU with multiple clients on other ECUs, the
    client server communication shall use different unique COM signals and signal
    groups for each client to allow the identification of the client associated
    with each system signal.

    The ClientId is mapped to the requestGroup and to the responseGroup.

    :ivar system_signal_ref: Reference to the SystemSignal with the
        ClientID.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-ID-MAPPING"

    system_signal_ref: Optional["ClientIdMapping.SystemSignalRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ClientIntentEnum:
    """
    This meta-class represents the intent to specify how a given ServiceInterface
    is used from the perspective of a given client.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-INTENT-ENUM"

    value: ClientIntentEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ClientServerApplicationErrorMapping:
    """
    This meta-class represents the ability to map ApplicationErrors onto each
    other.

    :ivar first_application_error_ref: This represents the first
        ApplicationError in the context of the
        ClientServerApplicationErrorMapping.
    :ivar second_application_error_ref: This represents the second
        ApplicationError in the context of the
        ClientServerApplicationErrorMapping.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-APPLICATION-ERROR-MAPPING"

    first_application_error_ref: Optional[
        "ClientServerApplicationErrorMapping.FirstApplicationErrorRef"
    ] = field(
        default=None,
        metadata={
            "name": "FIRST-APPLICATION-ERROR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    second_application_error_ref: Optional[
        "ClientServerApplicationErrorMapping.SecondApplicationErrorRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECOND-APPLICATION-ERROR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FirstApplicationErrorRef(Ref):
        dest: ApplicationErrorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecondApplicationErrorRef(Ref):
        dest: ApplicationErrorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ClientServerOperationComProps:
    """
    Defines additional attributes for the implementation of Client Server
    communication between software clusters.

    :ivar queue_length: Length of call request queue on the server side.
        The queue is implemented by the SwCluC. The value shall be
        greater or equal to 1. Setting the value of queueLength to 1
        implies that incoming requests are rejected while another
        request that arrived earlier is being processed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-OPERATION-COM-PROPS"

    queue_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "QUEUE-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ClientServerPrimitiveTypeMapping:
    """
    Mapping of an argument with a primitive datatype to a signal.

    :ivar argument_ref: Reference to an argument in the context of the
        mappedOperation.
    :ivar system_signal_ref: Reference to the system signal used to
        carry the argument
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-PRIMITIVE-TYPE-MAPPING"

    argument_ref: Optional["ClientServerPrimitiveTypeMapping.ArgumentRef"] = field(
        default=None,
        metadata={
            "name": "ARGUMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_signal_ref: Optional["ClientServerPrimitiveTypeMapping.SystemSignalRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ArgumentRef(Ref):
        dest: ArgumentDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Colspec:
    """
    This meta-class represents the ability to specify the properties of a column in
    a  table.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar align: Specifies how the cell entries shall be horizontally
        aligned within the specified column. Default is "LEFT"
    :ivar colname: Specifies the name of the column.
    :ivar colnum: column number (allows to sort the columns).
    :ivar colsep: Indicates whether a line should be displayed right of
        this column in the column specification.
    :ivar colwidth: Width of the column. You can enter absolute values
        such as 4 cm, or relative values marked with * (e.g.,  2* for
        column widths double those of other columns with 1*). The unit
        can be added to the number in the string. Possible units are:
        cm, mm, px, pt.
    :ivar rowsep: Indicates whether a line should be displayed at the
        bottom end of the cells of the column defined in the Colspec.
    """

    class Meta:
        name = "COLSPEC"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    align: AlignEnumSimple | None = field(
        default=None,
        metadata={
            "name": "ALIGN",
            "type": "Attribute",
        },
    )
    colname: str | None = field(
        default=None,
        metadata={
            "name": "COLNAME",
            "type": "Attribute",
        },
    )
    colnum: str | None = field(
        default=None,
        metadata={
            "name": "COLNUM",
            "type": "Attribute",
        },
    )
    colsep: str | None = field(
        default=None,
        metadata={
            "name": "COLSEP",
            "type": "Attribute",
            "pattern": r"[0-1]",
        },
    )
    colwidth: str | None = field(
        default=None,
        metadata={
            "name": "COLWIDTH",
            "type": "Attribute",
        },
    )
    rowsep: str | None = field(
        default=None,
        metadata={
            "name": "ROWSEP",
            "type": "Attribute",
            "pattern": r"[0-1]",
        },
    )


@dataclass(slots=True, kw_only=True)
class CommunicationControllerMapping:
    """
    CommunicationControllerMapping specifies the CommunicationPeripheral hardware
    (defined in the ECU Resource Template) to realize the specified
    CommunicationController in a physical topology.

    :ivar communication_controller_ref: Reference to the
        CommunicationController in the System Template
    :ivar hw_communication_controller_ref: Reference to a HwElement of
        category CommunicationController in the ECU Resource Template.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMMUNICATION-CONTROLLER-MAPPING"

    communication_controller_ref: Optional[
        "CommunicationControllerMapping.CommunicationControllerRef"
    ] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_communication_controller_ref: Optional[
        "CommunicationControllerMapping.HwCommunicationControllerRef"
    ] = field(
        default=None,
        metadata={
            "name": "HW-COMMUNICATION-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CommunicationControllerRef(Ref):
        dest: CommunicationControllerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class HwCommunicationControllerRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CommunicationDirectionType:
    """
    Describes the communication direction.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMMUNICATION-DIRECTION-TYPE"

    value: CommunicationDirectionTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ComponentInCompositionInstanceRef:
    """
    The ComponentInCompositionInstanceRef points to a concrete SwComponentPrototype
    within a CompositionSwComponentType.

    :ivar context_component_ref: The context for the scope of this
        timing event.
    :ivar target_component_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPONENT-IN-COMPOSITION-INSTANCE-REF"

    context_component_ref: list["ComponentInCompositionInstanceRef.ContextComponentRef"] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_component_ref: Optional["ComponentInCompositionInstanceRef.TargetComponentRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ComponentInSystemInstanceRef:
    """
    :ivar context_composition_ref:
    :ivar context_component_ref:
    :ivar target_component_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPONENT-IN-SYSTEM-INSTANCE-REF"

    context_composition_ref: Optional["ComponentInSystemInstanceRef.ContextCompositionRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-COMPOSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_ref: list["ComponentInSystemInstanceRef.ContextComponentRef"] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_component_ref: Optional["ComponentInSystemInstanceRef.TargetComponentRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextCompositionRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CompuConstNumericContent:
    """This meta-class represents the fact that the constant value of the
    computation method is a numerical value.

    It is separated from CompuConstFormulaContent to support
    compatibility with ASAM HDO.

    :ivar v: This represents the numerical value.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPU-CONST-NUMERIC-CONTENT"

    v: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "V",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CompuConstTextContent:
    """
    This meta-class represents the textual content of a scale.

    :ivar vt: This represents a textual constant in the computation
        method.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPU-CONST-TEXT-CONTENT"

    vt: VerbatimString | None = field(
        default=None,
        metadata={
            "name": "VT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ConditionByFormula:
    """This class represents a condition which is computed based on system
    constants according to the specified expression.

    The expected result is considered as boolean value.
    The result of the expression is interpreted as a condition.
    * "0" represents "false";
    * a value other than zero is considered "true"

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar binding_time: This attribute specifies the point in time when
        condition may be evaluated at earliest. At this point in time
        all referenced system constants shall have a value.
    :ivar content:
    """

    class Meta:
        name = "CONDITION-BY-FORMULA"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    binding_time: BindingTimeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "BINDING-TIME",
            "type": "Attribute",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef("ConditionByFormula.SyscStringRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("ConditionByFormula.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ConstantSpecificationMapping:
    """This meta-class is used to create an association of two
    ConstantSpecifications.

    One ConstantSpecification is supposed to be defined in the
    application domain while the other should be defined in the
    implementation domain. Hence the ConstantSpecificationMapping needs
    to be used where a ConstantSpecification defined in one domain needs
    to be associated to a ConstantSpecification in the other domain.
    This information is crucial for the RTE generator.

    :ivar appl_constant_ref: A ConstantSpecification defined in the
        application domain.
    :ivar impl_constant_ref: A ConstantSpecification defined in the
        implementation domain.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONSTANT-SPECIFICATION-MAPPING"

    appl_constant_ref: Optional["ConstantSpecificationMapping.ApplConstantRef"] = field(
        default=None,
        metadata={
            "name": "APPL-CONSTANT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    impl_constant_ref: Optional["ConstantSpecificationMapping.ImplConstantRef"] = field(
        default=None,
        metadata={
            "name": "IMPL-CONSTANT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ApplConstantRef(Ref):
        dest: ConstantSpecificationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ImplConstantRef(Ref):
        dest: ConstantSpecificationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ContainedIPduCollectionSemanticsEnum:
    """
    Defines the collection semantics for ContainedIPdus.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONTAINED-I-PDU-COLLECTION-SEMANTICS-ENUM"

    value: ContainedIPduCollectionSemanticsEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ContainerIPduHeaderTypeEnum:
    """Is used to define the header type and size of ContainerIPdus.

    The header size includes the header id and the length information.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONTAINER-I-PDU-HEADER-TYPE-ENUM"

    value: ContainerIPduHeaderTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ContainerIPduTriggerEnum:
    """
    Defines when the transmission of the ContainerIPdu shall be requested.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONTAINER-I-PDU-TRIGGER-ENUM"

    value: ContainerIPduTriggerEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CouplingElementEnum:
    """
    Identifies the Coupling type.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COUPLING-ELEMENT-ENUM"

    value: CouplingElementEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CouplingPortRatePolicyActionEnum:
    """
    Defines the action to be performed when a rate policy is violated.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COUPLING-PORT-RATE-POLICY-ACTION-ENUM"

    value: CouplingPortRatePolicyActionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CouplingPortRoleEnum:
    """
    Defines the role a CouplingPort takes in the context of a CouplingElement.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COUPLING-PORT-ROLE-ENUM"

    value: CouplingPortRoleEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CppImplementationDataTypeElementQualifier:
    """
    This element qualifies the typeReference of the
    CppImplementationDataTypeElement to the CppImplementationDataType.

    :ivar inplace: This attribute defines whether the member type of the
        CppImplementationDataTypeElement in C++ is an embedded type
        element inside of the enclosing struct (true) or whether the
        type declaration is defined outside of the struct.
    :ivar type_reference_ref: This reference defines a type reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CPP-IMPLEMENTATION-DATA-TYPE-ELEMENT-QUALIFIER"

    inplace: Boolean | None = field(
        default=None,
        metadata={
            "name": "INPLACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_reference_ref: Optional["CppImplementationDataTypeElementQualifier.TypeReferenceRef"] = (
        field(
            default=None,
            metadata={
                "name": "TYPE-REFERENCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TypeReferenceRef(Ref):
        dest: CppImplementationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CppTemplateArgument:
    """
    This meta-class has the ability to define properties for template arguments.

    :ivar allocator_ref: This reference identifies the applicable
        allocator.
    :ivar category: This attribute shall be used to contribute further
        clarification regarding the semantics of the enclosing
        CppTemplateArgument.
    :ivar inplace: This attribute specifies whether the shortName of the
        referenced templateType is used in the code generation and the
        type declaration is defined outside of the enclosing
        CppImplementationDataType (true) or whether the type definition
        is embedded inside of the enclosing CppImplementationDataType
        and the shortName is ignored (false).
    :ivar template_type_ref: This reference identifies the data type of
        the specific template argument required for the language
        binding.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CPP-TEMPLATE-ARGUMENT"

    allocator_ref: Optional["CppTemplateArgument.AllocatorRef"] = field(
        default=None,
        metadata={
            "name": "ALLOCATOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    inplace: Boolean | None = field(
        default=None,
        metadata={
            "name": "INPLACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    template_type_ref: Optional["CppTemplateArgument.TemplateTypeRef"] = field(
        default=None,
        metadata={
            "name": "TEMPLATE-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AllocatorRef(Ref):
        dest: AllocatorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TemplateTypeRef(Ref):
        dest: CppImplementationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CryptoCertificateAlgorithmFamilyEnum:
    """
    This meta-class defies possible cryptographic algorithm families used to create
    public keys and  signatures within the certificate.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-CERTIFICATE-ALGORITHM-FAMILY-ENUM"

    value: CryptoCertificateAlgorithmFamilyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CryptoCertificateFormatEnum:
    """
    This meta-class defines possible formats of cryptographic certificates.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-CERTIFICATE-FORMAT-ENUM"

    value: CryptoCertificateFormatEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CryptoCertificateToCryptoKeySlotMapping:
    """
    This meta-class represents the ability to define a mapping between a
    CryptoKeySlot and a CryptoCertificate.

    :ivar crypto_certificate_ref: This reference represents the mapped
        cryptoCertificate.
    :ivar crypto_key_slot_refs: This reference represents the mapped
        cryptoKeySlot.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-CERTIFICATE-TO-CRYPTO-KEY-SLOT-MAPPING"

    crypto_certificate_ref: Optional[
        "CryptoCertificateToCryptoKeySlotMapping.CryptoCertificateRef"
    ] = field(
        default=None,
        metadata={
            "name": "CRYPTO-CERTIFICATE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_key_slot_refs: Optional["CryptoCertificateToCryptoKeySlotMapping.CryptoKeySlotRefs"] = (
        field(
            default=None,
            metadata={
                "name": "CRYPTO-KEY-SLOT-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CryptoCertificateRef(Ref):
        dest: CryptoCertificateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoKeySlotRefs:
        crypto_key_slot_ref: list[
            "CryptoCertificateToCryptoKeySlotMapping.CryptoKeySlotRefs.CryptoKeySlotRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-KEY-SLOT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 2,
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CryptoKeySlotRef(Ref):
            dest: CryptoKeySlotSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class CryptoKeySlotAllowedModification:
    """
    This meta-class restricts the allowed modification of a key stored in the key
    slot.

    :ivar allow_content_type_change: This attribute describes whether
        the key content type can be changed (true) or not (false), e.g.
        changing the key from symmetric to RSA.
    :ivar exportability: This attribute describes whether the key slot
        content is allowed to be exported or not.
    :ivar max_number_of_allowed_updates: This attribute describes the
        maximum updates that are allowed to the slot.
    :ivar restrict_update: This attribute defines whether restrictions
        on the number of updates are defined or not. False: no
        restriction is placed on the number of updates. True:
        restrictions are placed on the number of updates with the
        attribute maxNumberOfAllowedUpdates.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-KEY-SLOT-ALLOWED-MODIFICATION"

    allow_content_type_change: Boolean | None = field(
        default=None,
        metadata={
            "name": "ALLOW-CONTENT-TYPE-CHANGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exportability: Boolean | None = field(
        default=None,
        metadata={
            "name": "EXPORTABILITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_allowed_updates: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-ALLOWED-UPDATES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    restrict_update: Boolean | None = field(
        default=None,
        metadata={
            "name": "RESTRICT-UPDATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CryptoKeySlotContentAllowedUsage:
    """
    This meta-class restricts the allowed usage of a key stored in the key slot.

    :ivar allowed_keyslot_usage: This attribute defines for which
        operations the KeySlot may be used.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-KEY-SLOT-CONTENT-ALLOWED-USAGE"

    allowed_keyslot_usage: String | None = field(
        default=None,
        metadata={
            "name": "ALLOWED-KEYSLOT-USAGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CryptoKeySlotTypeEnum:
    """
    This enumeration defines the options for the usage of a Key Slot in the
    platform.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-KEY-SLOT-TYPE-ENUM"

    value: CryptoKeySlotTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CryptoKeySlotUsageEnum:
    """
    This enum defines the possible roles of the keySlotUsage.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-KEY-SLOT-USAGE-ENUM"

    value: CryptoKeySlotUsageEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CryptoObjectTypeEnum:
    """
    Enumeration of all types of crypto objects, i.e. types of content that can be
    stored to a key slot.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-OBJECT-TYPE-ENUM"

    value: CryptoObjectTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CryptoServiceKeyGenerationEnum:
    """
    This enumeration shall be taken to express the handling of a crypto key in
    terms of whether it is obtained from e.g. a diagnostic tester or whether it is
    created by derivation from a master key.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-SERVICE-KEY-GENERATION-ENUM"

    value: CryptoServiceKeyGenerationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CsTransformerErrorReactionEnum:
    """
    Possible kinds of error reaction in case of a hard transformer error.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CS-TRANSFORMER-ERROR-REACTION-ENUM"

    value: CsTransformerErrorReactionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CycleCounter:
    """
    The communication cycle where the frame is send is described by the attribute
    "cycleCounter".

    :ivar cycle_counter: The communication cycle where the frame
        described by this timing is sent. If a timing is given in this
        way the referencing FlexrayCluster shall specify the
        cycleCountMax as upper bound and point of total repetition. This
        value is incremented at the beginning of each new cycle, ranging
        from 0 to cycleCountMax, and is reset to 0 after a sequence of
        cycleCountMax+1 cycles.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CYCLE-COUNTER"

    cycle_counter: Integer | None = field(
        default=None,
        metadata={
            "name": "CYCLE-COUNTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CycleRepetitionType:
    """The number of communication cycles (after the first cycle) whenever the
    frame is sent again.

    The FlexRay communication controller allows only determined values.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CYCLE-REPETITION-TYPE"

    value: CycleRepetitionTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataConsistencyPolicyEnum:
    """
    Defines how data consistency is ensured in the cross cluster communication.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-CONSISTENCY-POLICY-ENUM"

    value: DataConsistencyPolicyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataExchangePointKind:
    """
    Specifies the kind of a DataExchangePoint.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-EXCHANGE-POINT-KIND"

    value: DataExchangePointKindSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataFilterTypeEnum:
    """
    This enum specifies the supported DataFilterTypes.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-FILTER-TYPE-ENUM"

    value: DataFilterTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataIdModeEnum:
    """
    Supported inclusion modes to include the implicit two-byte Data ID in the one-
    byte CRC.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-ID-MODE-ENUM"

    value: DataIdModeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataLimitKindEnum:
    """
    Indicates whether the data element carries a minimum or maximum value, thereby
    limiting the current range of another value.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-LIMIT-KIND-ENUM"

    value: DataLimitKindEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataLinkLayerRule:
    """
    Configuration of filter rules on the DataLink layer.

    :ivar destination_mac_address: Filter to match packets with the
        destination MAC address.
    :ivar destination_mac_address_mask: Filter to match packets with the
        destination MAC address range. The destinationMacAddress with
        the destinationMacAddressMask defines the MAC address range.
    :ivar ether_type: Filter to match packets based on the EtherType
        field in the Ethernet frame. The EtherType is used to indicate
        which protocol is encapsulated in the payload of the frame.
    :ivar source_mac_address: Filter to match packets with the source
        MAC address.
    :ivar source_mac_address_mask: Filter to match packets with the
        source MAC address range. The sourceMacAddress with the
        sourceMacAddressMask defines the MAC address range.
    :ivar vlan_id: Filter of packets with a specific VlanId.
    :ivar vlan_priority: Filter of packets with a specific Vlan
        priority.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-LINK-LAYER-RULE"

    destination_mac_address: MacAddressString | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-MAC-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_mac_address_mask: MacAddressString | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-MAC-ADDRESS-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ether_type: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ETHER-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_mac_address: MacAddressString | None = field(
        default=None,
        metadata={
            "name": "SOURCE-MAC-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_mac_address_mask: MacAddressString | None = field(
        default=None,
        metadata={
            "name": "SOURCE-MAC-ADDRESS-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vlan_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VLAN-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vlan_priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VLAN-PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataPrototypeInClientServerInterfaceInstanceRef:
    """
    :ivar root_data_prototype_in_cs_ref:
    :ivar context_data_prototype_in_cs_ref:
    :ivar target_data_prototype_in_cs_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-PROTOTYPE-IN-CLIENT-SERVER-INTERFACE-INSTANCE-REF"

    root_data_prototype_in_cs_ref: Optional[
        "DataPrototypeInClientServerInterfaceInstanceRef.RootDataPrototypeInCsRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROOT-DATA-PROTOTYPE-IN-CS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_data_prototype_in_cs_ref: list[
        "DataPrototypeInClientServerInterfaceInstanceRef.ContextDataPrototypeInCsRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-DATA-PROTOTYPE-IN-CS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_data_prototype_in_cs_ref: Optional[
        "DataPrototypeInClientServerInterfaceInstanceRef.TargetDataPrototypeInCsRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-DATA-PROTOTYPE-IN-CS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class RootDataPrototypeInCsRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextDataPrototypeInCsRef(Ref):
        dest: ApplicationCompositeElementDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataPrototypeInCsRef(Ref):
        dest: DataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DataPrototypeInSenderReceiverInterfaceInstanceRef:
    """
    :ivar root_data_prototype_in_sr_ref:
    :ivar context_data_prototype_in_sr_ref:
    :ivar target_data_prototype_in_sr_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-PROTOTYPE-IN-SENDER-RECEIVER-INTERFACE-INSTANCE-REF"

    root_data_prototype_in_sr_ref: Optional[
        "DataPrototypeInSenderReceiverInterfaceInstanceRef.RootDataPrototypeInSrRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROOT-DATA-PROTOTYPE-IN-SR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_data_prototype_in_sr_ref: list[
        "DataPrototypeInSenderReceiverInterfaceInstanceRef.ContextDataPrototypeInSrRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-DATA-PROTOTYPE-IN-SR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_data_prototype_in_sr_ref: Optional[
        "DataPrototypeInSenderReceiverInterfaceInstanceRef.TargetDataPrototypeInSrRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-DATA-PROTOTYPE-IN-SR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class RootDataPrototypeInSrRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextDataPrototypeInSrRef(Ref):
        dest: ApplicationCompositeElementDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataPrototypeInSrRef(Ref):
        dest: DataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DataPrototypeInServiceInterfaceInstanceRef:
    """
    :ivar root_data_prototype_ref:
    :ivar context_data_prototype_ref:
    :ivar target_data_prototype_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-PROTOTYPE-IN-SERVICE-INTERFACE-INSTANCE-REF"

    root_data_prototype_ref: Optional[
        "DataPrototypeInServiceInterfaceInstanceRef.RootDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROOT-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_data_prototype_ref: list[
        "DataPrototypeInServiceInterfaceInstanceRef.ContextDataPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_data_prototype_ref: Optional[
        "DataPrototypeInServiceInterfaceInstanceRef.TargetDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class RootDataPrototypeRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextDataPrototypeRef(Ref):
        dest: ApplicationCompositeElementDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataPrototypeRef(Ref):
        dest: DataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DataPrototypeInSystemInstanceRef:
    """
    :ivar context_root_composition_ref:
    :ivar context_component_ref:
    :ivar context_port_ref: This represents the PortPrototype that is
        contained in the InstanceRef.
    :ivar root_data_prototype_ref:
    :ivar context_data_prototype_ref:
    :ivar target_data_prototype_ref: This represents the target of the
        InstanceRef
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-PROTOTYPE-IN-SYSTEM-INSTANCE-REF"

    context_root_composition_ref: Optional[
        "DataPrototypeInSystemInstanceRef.ContextRootCompositionRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ROOT-COMPOSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_ref: list["DataPrototypeInSystemInstanceRef.ContextComponentRef"] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_port_ref: Optional["DataPrototypeInSystemInstanceRef.ContextPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    root_data_prototype_ref: Optional["DataPrototypeInSystemInstanceRef.RootDataPrototypeRef"] = (
        field(
            default=None,
            metadata={
                "name": "ROOT-DATA-PROTOTYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    context_data_prototype_ref: list["DataPrototypeInSystemInstanceRef.ContextDataPrototypeRef"] = (
        field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-DATA-PROTOTYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    target_data_prototype_ref: Optional[
        "DataPrototypeInSystemInstanceRef.TargetDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRootCompositionRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextPortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RootDataPrototypeRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextDataPrototypeRef(Ref):
        dest: ApplicationCompositeElementDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataPrototypeRef(Ref):
        dest: DataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DataTransformationErrorHandlingEnum:
    """
    This enumeration defines different ways how a RunnableEntity shall handle
    transformer errors.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-TRANSFORMATION-ERROR-HANDLING-ENUM"

    value: DataTransformationErrorHandlingEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataTransformationKindEnum:
    """
    This enumeration contributes to the definition of the scope of the
    DataTransformation.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-TRANSFORMATION-KIND-ENUM"

    value: DataTransformationKindEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataTransformationStatusForwardingEnum:
    """
    This enumeration defines different ways how a RunnableEntity shall be able to
    forward status code into the transformer chain.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-TRANSFORMATION-STATUS-FORWARDING-ENUM"

    value: DataTransformationStatusForwardingEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataTypeMap:
    """
    This class represents the relationship between ApplicationDataType and its
    implementing AbstractImplementationDataType.

    :ivar application_data_type_ref: This is the corresponding
        ApplicationDataType
    :ivar implementation_data_type_ref: This is the corresponding
        AbstractImplementationDataType.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-TYPE-MAP"

    application_data_type_ref: Optional["DataTypeMap.ApplicationDataTypeRef"] = field(
        default=None,
        metadata={
            "name": "APPLICATION-DATA-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_data_type_ref: Optional["DataTypeMap.ImplementationDataTypeRef"] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-DATA-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ApplicationDataTypeRef(Ref):
        dest: ApplicationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationDataTypeRef(Ref):
        dest: AbstractImplementationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DataTypePolicyEnum:
    """
    This class lists the supported DataTypePolicies.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-TYPE-POLICY-ENUM"

    value: DataTypePolicyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DdsEventQosProps:
    """
    Configuration properties of the Event using DDS as the underlying network
    binding.

    :ivar qos_profile: Identifies a group of QoS Policies that apply to
        the DDS entities associated with the event, method, field, or
        the service instance.
    :ivar event_ref: Reference to an event that is provided.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-EVENT-QOS-PROPS"

    qos_profile: String | None = field(
        default=None,
        metadata={
            "name": "QOS-PROFILE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["DdsEventQosProps.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: ServiceEventDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DdsFieldQosProps:
    """
    Configuration properties of the Field interaction when using DDS as the
    underlying network binding.

    :ivar qos_profile: Identifies a group of QoS Policies that apply to
        the DDS entities associated with the event, method, field, or
        the service instance.
    :ivar field_ref: Reference to the field.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-FIELD-QOS-PROPS"

    qos_profile: String | None = field(
        default=None,
        metadata={
            "name": "QOS-PROFILE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_ref: Optional["DdsFieldQosProps.FieldRef"] = field(
        default=None,
        metadata={
            "name": "FIELD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FieldRef(Ref):
        dest: ServiceFieldDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DdsProtectionKindEnum:
    """
    Supported cryptographic transformations (extended).

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-PROTECTION-KIND-ENUM"

    value: DdsProtectionKindEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DdsRule:
    """
    Configuration of a DDS firewall rule.

    :ivar app_id: Filter for DDSI-RTPS messages in which the appId in
        the DDSI-RTPS header and the INFO_DST (0x0E) submessage matches.
    :ivar host_id: Filter for DDSI-RTPS messages in which the hostId in
        the DDSI-RTPS header and the INFO_DST (0x0E) submessage matches.
    :ivar instance_id: Filter for DDSI-RTPS messages in which the
        instanceId in the DDSI-RTPS header and the INFO_DST (0x0E)
        submessage matches.
    :ivar major_protocol_version: Filter for DDSI-RTPS messages in which
        the majorProtocolVersion in the DDSI-RTPS header matches.
    :ivar minor_protocol_version: Filter for DDSI-RTPS messages in which
        the minorProtocolVersion in the DDSI-RTPS header matches.
    :ivar product_id: Filter for DDSI-RTPS messages in which the
        productId in the DDSI-RTPS header matches.
    :ivar reader_entity_id: Filter for DDSI-RTPS messages in which the
        readerEntityID in a DDSI-RTPS submessage matches
    :ivar submessage_type: Defines the allowed submessage type in the
        DDSI-RTPS message
    :ivar vendor_id: Filter for DDSI-RTPS messages in which the vendorId
        in the DDSI-RTPS header matches.
    :ivar writer_entity_id: Filter for DDSI-RTPS messages in which the
        writerEntityID in a DDSI-RTPS submessage matches
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-RULE"

    app_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "APP-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    host_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "HOST-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    instance_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INSTANCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    major_protocol_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAJOR-PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minor_protocol_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINOR-PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    product_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRODUCT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reader_entity_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "READER-ENTITY-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    submessage_type: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SUBMESSAGE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vendor_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VENDOR-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    writer_entity_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "WRITER-ENTITY-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DdsServiceInstanceDiscoveryTypeEnum:
    """
    Supported discovery schemes for DDS Service Instances.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-SERVICE-INSTANCE-DISCOVERY-TYPE-ENUM"

    value: DdsServiceInstanceDiscoveryTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DdsServiceInstanceResourceIdentifierTypeEnum:
    """
    Supported Resource Identification schemes for DDS Service Instances.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-SERVICE-INSTANCE-RESOURCE-IDENTIFIER-TYPE-ENUM"

    value: DdsServiceInstanceResourceIdentifierTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DdsServiceVersion:
    """
    Definition of a Dds service version.

    :ivar major_version: Service major version.
    :ivar minor_version: Service minor version.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-SERVICE-VERSION"

    major_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAJOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minor_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DefaultValueApplicationStrategyEnum:
    """Enumeration that describes how to handle AUTOSAR defined default values.

    If the strategy requires application of the AUTOSAR defined default
    value, then the value shall be added before further validation or
    processing.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DEFAULT-VALUE-APPLICATION-STRATEGY-ENUM"

    value: DefaultValueApplicationStrategyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DefaultValueElement:
    """The default value consists of a number of elements.

    Each element is one byte long and the number of elements is
    specified by SduLength.

    :ivar element_byte_value: The integer value of a freely defined data
        byte.
    :ivar element_position: This attribute specifies the byte position
        of the element within the default value
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DEFAULT-VALUE-ELEMENT"

    element_byte_value: Integer | None = field(
        default=None,
        metadata={
            "name": "ELEMENT-BYTE-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    element_position: Integer | None = field(
        default=None,
        metadata={
            "name": "ELEMENT-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DependencyUsageEnum:
    """
    Enumeration describing the process steps a dependency is valid in.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DEPENDENCY-USAGE-ENUM"

    value: DependencyUsageEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DeterministicClientResource:
    """
    This meta-class specifies computing resource needs of DeterministicClient
    library functions.

    :ivar number_of_instructions: This attribute represents the
        normalized runtime consumption on the target system within one
        DeterministicClient::WaitForActivation cycle, assuming the
        "worst-case" runtime where the workers would be executed
        sequentially.
    :ivar sequential_instructions_begin: Normalized sequential runtime
        at the beginning of the DeterministicClient::WaitForActivation
        cycle (which mostly cannot be parallelized), before the main
        usage of the worker pool starts.
    :ivar sequential_instructions_end: WaitForActivation cycle (which
        mostly cannot be parallelized), after the main usage of the
        worker pool has ended.
    :ivar speedup: This attribute defines how much faster the
        calculations within one DeterministicClient::WaitForActivation
        cycle can be finished if numberOfWorkers are physically
        available, i.e. if enough cores were available on the machine to
        perform parallel execution of all workers (sequential runtime /
        parallelized runtime).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DETERMINISTIC-CLIENT-RESOURCE"

    number_of_instructions: NormalizedInstruction | None = field(
        default=None,
        metadata={
            "name": "NUMBER-OF-INSTRUCTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sequential_instructions_begin: NormalizedInstruction | None = field(
        default=None,
        metadata={
            "name": "SEQUENTIAL-INSTRUCTIONS-BEGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sequential_instructions_end: NormalizedInstruction | None = field(
        default=None,
        metadata={
            "name": "SEQUENTIAL-INSTRUCTIONS-END",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    speedup: Float | None = field(
        default=None,
        metadata={
            "name": "SPEEDUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DeterministicSyncMOutOfN:
    """
    This meta-class has the ability to configure an N-out--of-M verification in the
    context of a deterministic sync master.

    :ivar minimum_number_of_requests: The minimum number of received
        requests that is sufficient to continue the calculation of next
        cycle. This attribute represents the M in the M-out-of-N
        verification method.
    :ivar number_of_connected_clients: This attribute represents the
        number of deterministic clients that are connected to the
        deterministic sync master. this attribute represents the N in
        the M-out-of-N verification method.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DETERMINISTIC-SYNC-M-OUT-OF-N"

    minimum_number_of_requests: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-NUMBER-OF-REQUESTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    number_of_connected_clients: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NUMBER-OF-CONNECTED-CLIENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Dhcpv6Props:
    """
    This meta-class specifies the configuration options for DHCPv6.

    :ivar tcp_ip_dhcp_v_6_cnf_delay_max: Maximum delay in seconds before
        sending the first Confirm message. If this value is bigger than
        the previous minimum delay value a random delay will be chosen
        from the interval.
    :ivar tcp_ip_dhcp_v_6_cnf_delay_min: Minimum delay in seconds before
        the first Confirm message will be sent.
    :ivar tcp_ip_dhcp_v_6_inf_delay_max: Maximum delay in seconds before
        sending the first Information Request message. If this value is
        bigger than the previous minimum delay value a random delay will
        be chosen from the interval.
    :ivar tcp_ip_dhcp_v_6_inf_delay_min: Minimum delay (s) before the
        first Information Request message will be sent.
    :ivar tcp_ip_dhcp_v_6_sol_delay_max: Maximum delay in seconds before
        sending the first Solicit message. If this value is bigger than
        the previous minimum delay value a random delay will be chosen
        from the interval.
    :ivar tcp_ip_dhcp_v_6_sol_delay_min: Minimum delay (s) before the
        first Solicit message will be sent.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DHCPV-6-PROPS"

    tcp_ip_dhcp_v_6_cnf_delay_max: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-DHCP-V-6-CNF-DELAY-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_dhcp_v_6_cnf_delay_min: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-DHCP-V-6-CNF-DELAY-MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_dhcp_v_6_inf_delay_max: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-DHCP-V-6-INF-DELAY-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_dhcp_v_6_inf_delay_min: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-DHCP-V-6-INF-DELAY-MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_dhcp_v_6_sol_delay_max: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-DHCP-V-6-SOL-DELAY-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_dhcp_v_6_sol_delay_min: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-DHCP-V-6-SOL-DELAY-MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagPduType:
    """
    Used to distinguish a diagnostic request from a response.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAG-PDU-TYPE"

    value: DiagPduTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticAccessPermissionValidityEnum:
    """
    This meta-class provides settings for how the accessPermission shall be
    resolved between DiagnosticServiceInstance and DiagnosticServiceClass.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ACCESS-PERMISSION-VALIDITY-ENUM"

    value: DiagnosticAccessPermissionValidityEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticAudienceEnum:
    """
    The possible values of the intended audience for a diagnostic object.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-AUDIENCE-ENUM"

    value: DiagnosticAudienceEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticClearDtcLimitationEnum:
    """
    Scope of the DEM_ClearDTC Api.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CLEAR-DTC-LIMITATION-ENUM"

    value: DiagnosticClearDtcLimitationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticClearDtcNotificationEnum:
    """
    This enumeration supports the specification of the time when the
    ClearDtcNotification callback is supposed to be executed.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CLEAR-DTC-NOTIFICATION-ENUM"

    value: DiagnosticClearDtcNotificationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticClearEventAllowedBehaviorEnum:
    """
    This enumeration defines the possible behavior for clear event allowed.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CLEAR-EVENT-ALLOWED-BEHAVIOR-ENUM"

    value: DiagnosticClearEventAllowedBehaviorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticClearEventBehaviorEnum:
    """
    Possible behavior for clearing events.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CLEAR-EVENT-BEHAVIOR-ENUM"

    value: DiagnosticClearEventBehaviorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticComControlSpecificChannel:
    """
    This represents the ability to add further attributes to the definition of a
    specific channel that is subject to the diagnostic service "communication
    control".

    :ivar specific_channel_ref: This represents the affected
        CommunicationClusters in the role specificChannel
    :ivar subnet_number: This represents the applicable subnet number
        (which is an arbitrary number ranging from 1..14)
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-COM-CONTROL-SPECIFIC-CHANNEL"

    specific_channel_ref: Optional["DiagnosticComControlSpecificChannel.SpecificChannelRef"] = (
        field(
            default=None,
            metadata={
                "name": "SPECIFIC-CHANNEL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    subnet_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SUBNET-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SpecificChannelRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticComControlSubNodeChannel:
    """
    This represents the ability to add further attributes to the definition of a
    specific sub-node channel that is subject to the diagnostic service
    "communication control".

    :ivar sub_node_channel_ref: This represents the affected
        CommunicationClusters in the role subNodeChannel
    :ivar sub_node_number: This represents the applicable subNode
        number. The value corresponds to the request message parameter
        nodeIdentificationNumber of diagnostic service
        CommunicationControl (0x28).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-COM-CONTROL-SUB-NODE-CHANNEL"

    sub_node_channel_ref: Optional["DiagnosticComControlSubNodeChannel.SubNodeChannelRef"] = field(
        default=None,
        metadata={
            "name": "SUB-NODE-CHANNEL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_node_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SUB-NODE-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SubNodeChannelRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticCompareTypeEnum:
    """Enumeration for the type of a comparison of values usually expressed by the following operators: ==, !=, &lt;, &lt;=, &gt;, &gt;=

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-COMPARE-TYPE-ENUM"

    value: DiagnosticCompareTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticConnectedIndicatorBehaviorEnum:
    """
    Behavior of the indicator.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CONNECTED-INDICATOR-BEHAVIOR-ENUM"

    value: DiagnosticConnectedIndicatorBehaviorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticControlEnableMaskBit:
    """
    This meta-class has the ability to represent one bit in the control enable mask
    record.

    :ivar bit_number: This attribute represents the bit number of the
        bit in the control mask record. Bit number 0 is the most
        significant bit (MSB) in the first byte of the CEMR in the
        network presentation.
    :ivar controlled_data_element_refs: This reference represents the
        collection of DiagnosticDataElements that are controlled by this
        bit of the control mask record.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CONTROL-ENABLE-MASK-BIT"

    bit_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BIT-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    controlled_data_element_refs: Optional[
        "DiagnosticControlEnableMaskBit.ControlledDataElementRefs"
    ] = field(
        default=None,
        metadata={
            "name": "CONTROLLED-DATA-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ControlledDataElementRefs:
        controlled_data_element_ref: list[
            "DiagnosticControlEnableMaskBit.ControlledDataElementRefs.ControlledDataElementRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTROLLED-DATA-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ControlledDataElementRef(Ref):
            dest: DiagnosticDataElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DiagnosticDataCaptureEnum:
    """
    Data triggering types.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DATA-CAPTURE-ENUM"

    value: DiagnosticDataCaptureEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticDebounceBehaviorEnum:
    """
    Event debounce algorithm behavior options.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DEBOUNCE-BEHAVIOR-ENUM"

    value: DiagnosticDebounceBehaviorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticDebounceBehaviorEnumValueVariationPoint:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar binding_time: This is the binding time in which the attribute
        value needs to be bound. If this attribute is missing, the
        attribute is not a variation point. In particular this means
        that It needs to be a single value according to the type
        specified in the pure model. It is an error if it is still a
        formula.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar sd: This special data is provided to allow synchronization of
        Attribute value variation points with variant management
        systems. The usage is subject of agreement between the involved
        parties.
    :ivar short_label: This allows to identify the variation point. It
        is also intended to allow RTE support for CompileTime Variation
        points.
    :ivar base: This attribute reflects the base to be used in context
        of EnumerationMappingTable for this reference.
    :ivar enum_table: This represents the assigned enumeration table.
    :ivar content:
    """

    class Meta:
        name = "DIAGNOSTIC-DEBOUNCE-BEHAVIOR-ENUM-VALUE-VARIATION-POINT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    binding_time: BindingTimeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "BINDING-TIME",
            "type": "Attribute",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    sd: str | None = field(
        default=None,
        metadata={
            "name": "SD",
            "type": "Attribute",
        },
    )
    short_label: str | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    base: str | None = field(
        default=None,
        metadata={
            "name": "BASE",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z][a-zA-Z0-9_]*",
        },
    )
    enum_table: str | None = field(
        default=None,
        metadata={
            "name": "ENUM-TABLE",
            "type": "Attribute",
            "pattern": r"/?[a-zA-Z][a-zA-Z0-9_]{0,127}(/[a-zA-Z][a-zA-Z0-9_]{0,127})*",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef(
                        "DiagnosticDebounceBehaviorEnumValueVariationPoint.SyscStringRef"
                    ),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("DiagnosticDebounceBehaviorEnumValueVariationPoint.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDenominatorConditionEnum:
    """
    This enumeration contains valid denominator types.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DENOMINATOR-CONDITION-ENUM"

    value: DiagnosticDenominatorConditionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticDynamicallyDefineDataIdentifierSubfunctionEnum:
    """
    This meta-class contains a list of possible subfunctions for the UDS service
    0x2C.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER-SUBFUNCTION-ENUM"

    value: DiagnosticDynamicallyDefineDataIdentifierSubfunctionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticEcuProps:
    """
    This meta-class is defined to gather diagnostic-related properties that apply
    in the scope of an entire ECU.

    :ivar is_obd_relevant: This attribute indicates whether the ECU
        makes any contribution to the OBD.
    :ivar send_resp_pend_on_trans_to_boot: The purpose of this attribute
        is to define whether or not the ECU should send a NRC 0x78
        (response pending) before transitioning to the bootloader (in
        this case the attribute shall be set to "true") or if the
        transition shall be initiated without sending NRC 0x78 (in this
        case the attribute shall be set to "false").
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ECU-PROPS"

    is_obd_relevant: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-OBD-RELEVANT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    send_resp_pend_on_trans_to_boot: Boolean | None = field(
        default=None,
        metadata={
            "name": "SEND-RESP-PEND-ON-TRANS-TO-BOOT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventClearAllowedEnum:
    """
    Denotes whether clearing of events is allowed.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-CLEAR-ALLOWED-ENUM"

    value: DiagnosticEventClearAllowedEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventCombinationBehaviorEnum:
    """
    Select type of Event Combination support.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-COMBINATION-BEHAVIOR-ENUM"

    value: DiagnosticEventCombinationBehaviorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventCombinationReportingBehaviorEnum:
    """Select reporting format of events.

    Applicable only for Event Combination on Retrieval.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-COMBINATION-REPORTING-BEHAVIOR-ENUM"

    value: DiagnosticEventCombinationReportingBehaviorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventDisplacementStrategyEnum:
    """
    Defines the displacement strategy.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-DISPLACEMENT-STRATEGY-ENUM"

    value: DiagnosticEventDisplacementStrategyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventKindEnum:
    """
    Applicability of the diagnostic event.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-KIND-ENUM"

    value: DiagnosticEventKindEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventWindowTimeEnum:
    """
    This represents the ability to define the semantics of the event window.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-WINDOW-TIME-ENUM"

    value: DiagnosticEventWindowTimeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticExternalAuthenticationIdentification:
    """
    This meta-class represents the ability to support the authentication of
    diagnostic clients.

    :ivar source_address_code: This attribute represents the value to
        exactly match after applying the mask to the source address of a
        client's request.
    :ivar source_address_mask: This attribute represents the mask to
        apply to the source address of a client's request.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-IDENTIFICATION"

    source_address_code: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SOURCE-ADDRESS-CODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_address_mask: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SOURCE-ADDRESS-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticHandleDddiConfigurationEnum:
    """
    This meta-class represents the options for controlling how the configuration of
    the DynamicallyDefineDataIdentifiers is done in the given context.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-HANDLE-DDDI-CONFIGURATION-ENUM"

    value: DiagnosticHandleDddiConfigurationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticIndicatorTypeEnum:
    """
    Type of an indicator.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-INDICATOR-TYPE-ENUM"

    value: DiagnosticIndicatorTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticIndicatorTypeEnumValueVariationPoint:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar binding_time: This is the binding time in which the attribute
        value needs to be bound. If this attribute is missing, the
        attribute is not a variation point. In particular this means
        that It needs to be a single value according to the type
        specified in the pure model. It is an error if it is still a
        formula.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar sd: This special data is provided to allow synchronization of
        Attribute value variation points with variant management
        systems. The usage is subject of agreement between the involved
        parties.
    :ivar short_label: This allows to identify the variation point. It
        is also intended to allow RTE support for CompileTime Variation
        points.
    :ivar base: This attribute reflects the base to be used in context
        of EnumerationMappingTable for this reference.
    :ivar enum_table: This represents the assigned enumeration table.
    :ivar content:
    """

    class Meta:
        name = "DIAGNOSTIC-INDICATOR-TYPE-ENUM-VALUE-VARIATION-POINT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    binding_time: BindingTimeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "BINDING-TIME",
            "type": "Attribute",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    sd: str | None = field(
        default=None,
        metadata={
            "name": "SD",
            "type": "Attribute",
        },
    )
    short_label: str | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    base: str | None = field(
        default=None,
        metadata={
            "name": "BASE",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z][a-zA-Z0-9_]*",
        },
    )
    enum_table: str | None = field(
        default=None,
        metadata={
            "name": "ENUM-TABLE",
            "type": "Attribute",
            "pattern": r"/?[a-zA-Z][a-zA-Z0-9_]{0,127}(/[a-zA-Z][a-zA-Z0-9_]{0,127})*",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef(
                        "DiagnosticIndicatorTypeEnumValueVariationPoint.SyscStringRef"
                    ),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("DiagnosticIndicatorTypeEnumValueVariationPoint.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticInhibitionMaskEnum:
    """
    This meta-class represents the ability to define different kinds of inhibition
    mask behavior.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-INHIBITION-MASK-ENUM"

    value: DiagnosticInhibitionMaskEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticInitialEventStatusEnum:
    """
    This represents the ability to define an initial status for the ROE service.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-INITIAL-EVENT-STATUS-ENUM"

    value: DiagnosticInitialEventStatusEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticIumprKindEnum:
    """
    This enumeration is used to control the ratio calculation behavior.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-IUMPR-KIND-ENUM"

    value: DiagnosticIumprKindEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticJumpToBootLoaderEnum:
    """
    This enumeration contains the options for jumping to a boot loader.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-JUMP-TO-BOOT-LOADER-ENUM"

    value: DiagnosticJumpToBootLoaderEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticLogicalOperatorEnum:
    """
    Logical AND and OR operation (&amp;&amp;, ||)

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-LOGICAL-OPERATOR-ENUM"

    value: DiagnosticLogicalOperatorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticMemoryEntryStorageTriggerEnum:
    """
    Trigger types to allocate an event memory entry.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-MEMORY-ENTRY-STORAGE-TRIGGER-ENUM"

    value: DiagnosticMemoryEntryStorageTriggerEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticMonitorUpdateKindEnum:
    """
    This enumeration indicates the acceptance criteria for a diagnostic monitor.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-MONITOR-UPDATE-KIND-ENUM"

    value: DiagnosticMonitorUpdateKindEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticObdSupportEnum:
    """This meta-class represents the ability to model the roles in which a
    participation in OBD is foreseen.

    At the moment, this applies exclusively to the Dem. However, future
    extension of the Dcm may require this setting as well.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-OBD-SUPPORT-ENUM"

    value: DiagnosticObdSupportEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticOccurrenceCounterProcessingEnum:
    """
    The occurrence counter triggering types.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-OCCURRENCE-COUNTER-PROCESSING-ENUM"

    value: DiagnosticOccurrenceCounterProcessingEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticOperationCycleTypeEnum:
    """
    Operation cycles types used to identify certain Operation cycles with a certain
    semantics.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-OPERATION-CYCLE-TYPE-ENUM"

    value: DiagnosticOperationCycleTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticParameterElementAccess:
    """
    This meta-class acts as a single point for defining structured references to a
    specific DiagnosticParameterElement.

    :ivar context_element_refs: This represents the context of an
        applicable payload that corresponds to the referenced
        DataPrototype in the role mappedDataElement.
    :ivar target_element_ref: This represents the target reference of an
        applicable payload that corresponds to the referenced
        DataPrototype in the role mappedDataElement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-PARAMETER-ELEMENT-ACCESS"

    context_element_refs: Optional["DiagnosticParameterElementAccess.ContextElementRefs"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_element_ref: Optional["DiagnosticParameterElementAccess.TargetElementRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextElementRefs:
        context_element_ref: list[
            "DiagnosticParameterElementAccess.ContextElementRefs.ContextElementRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextElementRef(Ref):
            dest: DiagnosticParameterElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TargetElementRef(Ref):
        dest: DiagnosticParameterElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticParameterSupportInfo:
    """
    This represents a way to define which bit of the supportInfo is representing
    this part of the PID.

    :ivar support_info_bit: defines the bit in the SupportInfo byte,
        which represents the PID DataElement pidSize / position / size.
        Unit: byte.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-PARAMETER-SUPPORT-INFO"

    support_info_bit: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SUPPORT-INFO-BIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticPeriodicRateCategoryEnum:
    """
    This meta-class provides possible values for the setting of the periodic rate.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-PERIODIC-RATE-CATEGORY-ENUM"

    value: DiagnosticPeriodicRateCategoryEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticProcessingStyleEnum:
    """
    This meta-class represents the ability to define the processing style of
    diagnostic requests.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-PROCESSING-STYLE-ENUM"

    value: DiagnosticProcessingStyleEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticRecordTriggerEnum:
    """
    Triggers to allocate an event memory entry.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-RECORD-TRIGGER-ENUM"

    value: DiagnosticRecordTriggerEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticResponseOnEventActionEnum:
    """
    This meta-class has the ability to define sub-functions of the UDS service
    ResponseOnEvent.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-RESPONSE-ON-EVENT-ACTION-ENUM"

    value: DiagnosticResponseOnEventActionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticResponseToEcuResetEnum:
    """
    This enumeration controls the point in time in which a response to the
    reception of an EcuReset service shall be generated.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-RESPONSE-TO-ECU-RESET-ENUM"

    value: DiagnosticResponseToEcuResetEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticRoutineTypeEnum:
    """
    This enumerator specifies the different types of diagnostic routines.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ROUTINE-TYPE-ENUM"

    value: DiagnosticRoutineTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticServiceRequestCallbackTypeEnum:
    """
    This represents the ability to define whether a Service Request Notification
    was used in the role of a manufacturer or a supplier.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SERVICE-REQUEST-CALLBACK-TYPE-ENUM"

    value: DiagnosticServiceRequestCallbackTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticServiceValidationConfiguration:
    """
    This meta-class has the ability to configure the order of
    manufacturer/supplier-checks.

    :ivar manufacturer_validation_order_refs: This reference defines the
        order in which validations created by manufacturer are executed.
    :ivar supplier_validation_order_refs: This reference defines the
        order in which validations created by supplier are executed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SERVICE-VALIDATION-CONFIGURATION"

    manufacturer_validation_order_refs: Optional[
        "DiagnosticServiceValidationConfiguration.ManufacturerValidationOrderRefs"
    ] = field(
        default=None,
        metadata={
            "name": "MANUFACTURER-VALIDATION-ORDER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    supplier_validation_order_refs: Optional[
        "DiagnosticServiceValidationConfiguration.SupplierValidationOrderRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SUPPLIER-VALIDATION-ORDER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ManufacturerValidationOrderRefs:
        manufacturer_validation_order_ref: list[
            "DiagnosticServiceValidationConfiguration.ManufacturerValidationOrderRefs.ManufacturerValidationOrderRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MANUFACTURER-VALIDATION-ORDER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ManufacturerValidationOrderRef(Ref):
            dest: DiagnosticServiceValidationMappingSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SupplierValidationOrderRefs:
        supplier_validation_order_ref: list[
            "DiagnosticServiceValidationConfiguration.SupplierValidationOrderRefs.SupplierValidationOrderRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SUPPLIER-VALIDATION-ORDER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SupplierValidationOrderRef(Ref):
            dest: DiagnosticServiceValidationMappingSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DiagnosticSignificanceEnum:
    """
    Significance level of a diagnostic event.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SIGNIFICANCE-ENUM"

    value: DiagnosticSignificanceEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticStatusBitHandlingTestFailedSinceLastClearEnum:
    """
    This enumeration controls whether the aging and displacement mechanism shall be
    applied to the 'TestFailedSinceLastClear' status bits.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-STATUS-BIT-HANDLING-TEST-FAILED-SINCE-LAST-CLEAR-ENUM"

    value: DiagnosticStatusBitHandlingTestFailedSinceLastClearEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticStoreEventSupportEnum:
    """
    This meta-class has the ability to define how a specific event in the context
    of the UDS service ResponseOnEvent shall be handled.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-STORE-EVENT-SUPPORT-ENUM"

    value: DiagnosticStoreEventSupportEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticSupportInfoByte:
    """
    This meta-class defines the support information (typically byte A) to declare
    the usability of the DataElements within the so-called packeted PIDs (e.g.
    PID$68).

    :ivar position: This represents the position of the supportInfo in
        the PID. Unit: byte.
    :ivar size: This represents the size of the supportInfo within the
        PID. Unit: byte.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SUPPORT-INFO-BYTE"

    position: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticTestResultUpdateEnum:
    """
    This meta-class represents the ability to define the update behavior of a
    DiagnosticTestResult.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TEST-RESULT-UPDATE-ENUM"

    value: DiagnosticTestResultUpdateEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticTestResultUpdateEnumValueVariationPoint:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar binding_time: This is the binding time in which the attribute
        value needs to be bound. If this attribute is missing, the
        attribute is not a variation point. In particular this means
        that It needs to be a single value according to the type
        specified in the pure model. It is an error if it is still a
        formula.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar sd: This special data is provided to allow synchronization of
        Attribute value variation points with variant management
        systems. The usage is subject of agreement between the involved
        parties.
    :ivar short_label: This allows to identify the variation point. It
        is also intended to allow RTE support for CompileTime Variation
        points.
    :ivar base: This attribute reflects the base to be used in context
        of EnumerationMappingTable for this reference.
    :ivar enum_table: This represents the assigned enumeration table.
    :ivar content:
    """

    class Meta:
        name = "DIAGNOSTIC-TEST-RESULT-UPDATE-ENUM-VALUE-VARIATION-POINT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    binding_time: BindingTimeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "BINDING-TIME",
            "type": "Attribute",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    sd: str | None = field(
        default=None,
        metadata={
            "name": "SD",
            "type": "Attribute",
        },
    )
    short_label: str | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    base: str | None = field(
        default=None,
        metadata={
            "name": "BASE",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z][a-zA-Z0-9_]*",
        },
    )
    enum_table: str | None = field(
        default=None,
        metadata={
            "name": "ENUM-TABLE",
            "type": "Attribute",
            "pattern": r"/?[a-zA-Z][a-zA-Z0-9_]{0,127}(/[a-zA-Z][a-zA-Z0-9_]{0,127})*",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef(
                        "DiagnosticTestResultUpdateEnumValueVariationPoint.SyscStringRef"
                    ),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("DiagnosticTestResultUpdateEnumValueVariationPoint.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticTroubleCodeJ1939DtcKindEnum:
    """
    This meta-class represents the ability to further specify a J1939 DTC in terms
    of its semantics.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TROUBLE-CODE-J-1939-DTC-KIND-ENUM"

    value: DiagnosticTroubleCodeJ1939DtcKindEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticTypeOfDtcSupportedEnum:
    """
    Supported Dtc Types.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TYPE-OF-DTC-SUPPORTED-ENUM"

    value: DiagnosticTypeOfDtcSupportedEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticTypeOfFreezeFrameRecordNumerationEnum:
    """
    FreezeFrame record numeration type.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TYPE-OF-FREEZE-FRAME-RECORD-NUMERATION-ENUM"

    value: DiagnosticTypeOfFreezeFrameRecordNumerationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticUdsSeverityEnum:
    """
    Severity types for a DTC according to ISO 14229-1.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-UDS-SEVERITY-ENUM"

    value: DiagnosticUdsSeverityEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticValueAccessEnum:
    """
    Defines the access of the configured diagnostic current values which will be
    used by the Dem or Dcm module.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-VALUE-ACCESS-ENUM"

    value: DiagnosticValueAccessEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticWwhObdDtcClassEnum:
    """
    This meta-class represents the ability to model severity classes of an WWH-OBD
    DTC.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-WWH-OBD-DTC-CLASS-ENUM"

    value: DiagnosticWwhObdDtcClassEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticWwhObdDtcClassEnumValueVariationPoint:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar binding_time: This is the binding time in which the attribute
        value needs to be bound. If this attribute is missing, the
        attribute is not a variation point. In particular this means
        that It needs to be a single value according to the type
        specified in the pure model. It is an error if it is still a
        formula.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar sd: This special data is provided to allow synchronization of
        Attribute value variation points with variant management
        systems. The usage is subject of agreement between the involved
        parties.
    :ivar short_label: This allows to identify the variation point. It
        is also intended to allow RTE support for CompileTime Variation
        points.
    :ivar base: This attribute reflects the base to be used in context
        of EnumerationMappingTable for this reference.
    :ivar enum_table: This represents the assigned enumeration table.
    :ivar content:
    """

    class Meta:
        name = "DIAGNOSTIC-WWH-OBD-DTC-CLASS-ENUM-VALUE-VARIATION-POINT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    binding_time: BindingTimeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "BINDING-TIME",
            "type": "Attribute",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    sd: str | None = field(
        default=None,
        metadata={
            "name": "SD",
            "type": "Attribute",
        },
    )
    short_label: str | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    base: str | None = field(
        default=None,
        metadata={
            "name": "BASE",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z][a-zA-Z0-9_]*",
        },
    )
    enum_table: str | None = field(
        default=None,
        metadata={
            "name": "ENUM-TABLE",
            "type": "Attribute",
            "pattern": r"/?[a-zA-Z][a-zA-Z0-9_]{0,127}(/[a-zA-Z][a-zA-Z0-9_]{0,127})*",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef(
                        "DiagnosticWwhObdDtcClassEnumValueVariationPoint.SyscStringRef"
                    ),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("DiagnosticWwhObdDtcClassEnumValueVariationPoint.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiscoveryTechnologyEnum:
    """
    Discovery technology information.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DISCOVERY-TECHNOLOGY-ENUM"

    value: DiscoveryTechnologyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DisplayPresentationEnum:
    """
    This meta-class represents the ability to provide values for controlling the
    presentation of data within measurement and calibration tools.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DISPLAY-PRESENTATION-ENUM"

    value: DisplayPresentationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DltDefaultTraceStateEnum:
    """
    This enumeration defines the supported values for the Dlt default trace state.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-DEFAULT-TRACE-STATE-ENUM"

    value: DltDefaultTraceStateEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DoIpEidRetrievalEnum:
    """
    Enumeration with options to retrieve EID.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-EID-RETRIEVAL-ENUM"

    value: DoIpEidRetrievalEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DoIpEntityRoleEnum:
    """
    DoIP role a network-node has.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-ENTITY-ROLE-ENUM"

    value: DoIpEntityRoleEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DoIpRule:
    """
    Configuration of a generic firewall rule.

    :ivar destination_max_address: Filter to match DoIP messages in
        which the destinationAddress is smaller or equal than
        destinationMaxAddress.
    :ivar destination_min_address: Filter to match DoIP messages in
        which the destinationAddress is greater or equal than
        destinationMinAddress.
    :ivar inverse_protocol_version: Filter to match DoIP messages  in
        which the inverseprotocolVersion in the DoIP header matches.
    :ivar payload_length: Filter to match DoIP messages  in which the
        payloadLength in the DoIP header matches.
    :ivar payload_type: Filter to match DoIP messages  in which the
        payloadType in the DoIP header matches.
    :ivar protocol_version: Filter to match DoIP messages  in which the
        protocolVersion in the DoIP header matches.
    :ivar source_max_address: Filter to match DoIP messages in which the
        sourceAddress is smaller or equal than sourceMaxAddress.
    :ivar source_min_address: Filter to match DoIP messages in which the
        sourceAddress is greater or equal than sourceMinAddress..
    :ivar uds_service: Filter to match DoIP messages that contain the
        udsService.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-RULE"

    destination_max_address: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-MAX-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_min_address: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-MIN-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    inverse_protocol_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INVERSE-PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    payload_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PAYLOAD-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    payload_type: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PAYLOAD-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_max_address: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SOURCE-MAX-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_min_address: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SOURCE-MIN-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uds_service: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UDS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DtcFormatTypeEnum:
    """
    This enumeration specifies the DTC format.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DTC-FORMAT-TYPE-ENUM"

    value: DtcFormatTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DtcKindEnum:
    """
    This enumeration defines the possible kinds of diagnostic monitors regarding
    the OBD relevance.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DTC-KIND-ENUM"

    value: DtcKindEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DynamicPartAlternative:
    """One of the Com IPdu alternatives that are transmitted in the Dynamic Part of
    the MultiplexedIPdu.

    The selectorFieldCode specifies which Com IPdu is contained in the
    DynamicPart within a certain transmission of a multiplexed PDU.

    :ivar i_pdu_ref: Reference to a Com IPdu which is routed to the
        IPduM module and is combined to a multiplexedPdu.
    :ivar initial_dynamic_part: Dynamic part that shall be used to
        initialize this multiplexed IPdu. Constraint: Only one
        "DynamicPartAlternative" in a "DynamicPart" shall be the
        initialDynamicPart.
    :ivar selector_field_code: The selector field is part of a
        multiplexed IPdu. It consists of contiguous bits. The value of
        the selector field selects the layout of the multiplexed part of
        the IPdu.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DYNAMIC-PART-ALTERNATIVE"

    i_pdu_ref: Optional["DynamicPartAlternative.IPduRef"] = field(
        default=None,
        metadata={
            "name": "I-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_dynamic_part: Boolean | None = field(
        default=None,
        metadata={
            "name": "INITIAL-DYNAMIC-PART",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    selector_field_code: Integer | None = field(
        default=None,
        metadata={
            "name": "SELECTOR-FIELD-CODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class IPduRef(Ref):
        dest: ISignalIPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EEnum:
    """This specifies the possible kinds of emphasis as proposal how to render it
    on paper or screen.

    Note that it would have been better to use plain, weak (italic), strong (bold), veryStrong (bolditalic) ... But users complained about this.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "E-ENUM"

    value: EEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EEnumFont:
    """
    This specifies the possible kind of fonts to be used for emphasis.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "E-ENUM-FONT"

    value: EEnumFontSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EcucAffectionEnum:
    """Possible affections used by the EcucConfigurationClassAffection.

    This element is removed from the specifications and shall not be
    used.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-AFFECTION-ENUM"

    value: EcucAffectionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EcucConditionFormula:
    """This formula shall yield a boolean expression depending on ecuc queries.

    Note that the EcucConditionFormula is a mixed string. Therefore, the
    properties have the upper multiplicity 1.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar content:
    """

    class Meta:
        name = "ECUC-CONDITION-FORMULA"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "ECUC-QUERY-REF",
                    "type": ForwardRef("EcucConditionFormula.EcucQueryRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "ECUC-QUERY-STRING-REF",
                    "type": ForwardRef("EcucConditionFormula.EcucQueryStringRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EcucQueryRef(Ref):
        dest: EcucQuerySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucQueryStringRef(Ref):
        dest: EcucQuerySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EcucConfigurationClassEnum:
    """
    Possible configuration classes for the AUTOSAR configuration parameters.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-CONFIGURATION-CLASS-ENUM"

    value: EcucConfigurationClassEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EcucConfigurationVariantEnum:
    """
    Specifies the possible Configuration Variants used for AUTOSAR BSW Modules.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-CONFIGURATION-VARIANT-ENUM"

    value: EcucConfigurationVariantEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EcucDestinationUriNestingContractEnum:
    """
    EcucDestinationUriNestingContractEnum is used to determine what is qualified by
    the EcucDestinationUriPolicy.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-DESTINATION-URI-NESTING-CONTRACT-ENUM"

    value: EcucDestinationUriNestingContractEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EcucParameterDerivationFormula:
    """
    This formula is intended to specify how an ecu parameter can be derived from
    other information in the Autosar Templates.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar content:
    """

    class Meta:
        name = "ECUC-PARAMETER-DERIVATION-FORMULA"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "ECUC-QUERY-REF",
                    "type": ForwardRef("EcucParameterDerivationFormula.EcucQueryRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "ECUC-QUERY-STRING-REF",
                    "type": ForwardRef("EcucParameterDerivationFormula.EcucQueryStringRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EcucQueryRef(Ref):
        dest: EcucQuerySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucQueryStringRef(Ref):
        dest: EcucQuerySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EcucQueryExpression:
    """Defines a query expression to the ECUC Description and output the result as
    an numerical value.

    Due to the "mixedString" nature of the formula there can be several
    EcuQueryExpressions used.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar content:
    """

    class Meta:
        name = "ECUC-QUERY-EXPRESSION"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "CONFIG-ELEMENT-DEF-GLOBAL-REF",
                    "type": ForwardRef("EcucQueryExpression.ConfigElementDefGlobalRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "CONFIG-ELEMENT-DEF-LOCAL-REF",
                    "type": ForwardRef("EcucQueryExpression.ConfigElementDefLocalRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ConfigElementDefGlobalRef(Ref):
        dest: EcucDefinitionElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ConfigElementDefLocalRef(Ref):
        dest: EcucDefinitionElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EcucScopeEnum:
    """
    Possible scope settings for a configuration element.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-SCOPE-ENUM"

    value: EcucScopeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EmphasisText:
    """This is an emphasized text.

    As a compromise it contains some rendering oriented attributes such
    as color and font.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar color: This allows to recommend a color of the emphasis. It is
        specified bases on 6 digits RGB hex-code.
    :ivar font: This specifies the font style in which the emphasized
        text shall be rendered.
    :ivar type_value: Indicates how the text may be emphasized. Note
        that this is only a proposal which can be overridden or ignored
        by particular formatting engines. Default is BOLD.
    :ivar content:
    """

    class Meta:
        name = "EMPHASIS-TEXT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    color: str | None = field(
        default=None,
        metadata={
            "name": "COLOR",
            "type": "Attribute",
        },
    )
    font: EEnumFontSimple | None = field(
        default=None,
        metadata={
            "name": "FONT",
            "type": "Attribute",
        },
    )
    type_value: EEnumSimple | None = field(
        default=None,
        metadata={
            "name": "TYPE",
            "type": "Attribute",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SUB",
                    "type": ForwardRef("EmphasisText.Sub"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUP",
                    "type": ForwardRef("EmphasisText.Sup"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "TT",
                    "type": Tt,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Sub(Supscript):
        pass

    @dataclass(slots=True, kw_only=True)
    class Sup(Supscript):
        pass


@dataclass(slots=True, kw_only=True)
class EmptySignalMapping:
    """If no actual data is configured for a client server communication the
    element EmptySignalMapping shall be used.

    An EmptySignalMapping shall only reference a SystemSignal that is
    referenced by an ISignal with length equal to zero. In this case
    there shall be an "update-bit" configured. The EmptySignal can be
    mapped to the response group or to request group.

    :ivar system_signal_ref: Reference to a SystemSignal with
        "signalLength" = 0 and an UpdateBit.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EMPTY-SIGNAL-MAPPING"

    system_signal_ref: Optional["EmptySignalMapping.SystemSignalRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EndToEndDescription:
    """This meta-class contains information about end-to-end protection.

    The set of applicable attributes depends on the actual value of the
    category attribute of EndToEndProtection.

    :ivar category: The category represents the identification of the
        concrete E2E profile. The applicable values are specified in a
        semantic constraint and determine the applicable attributes of
        EndToEndDescription.
    :ivar data_ids: This represents a unique numerical identifier. Note:
        ID is used for protection against masquerading. The details
        concerning the maximum number of values (this information is
        specific for each E2E profile) applicable for this attribute are
        controlled by a semantic constraint that depends on the category
        of the EndToEndProtection.
    :ivar data_id_mode: There are three inclusion modes how the implicit
        two-byte Data ID is included in the one-byte CRC: * dataIDMode =
        0: Two bytes are included in the CRC (double ID configuration)
        This is used in variant 1A. * dataIDMode = 1: One of the two
        bytes byte is included, alternating high and low byte, depending
        on parity of the counter (alternating ID configuration). For
        even counter low byte is included; For odd counters the high
        byte is included. This is used in variant 1B. * dataIDMode = 2:
        Only low byte is included, high byte is never used. This is
        applicable if the IDs in a particular system are 8 bits. *
        dataIdMode = 3: The low byte is included in the implicit CRC
        calculation, the low nibble of the high byte is transmitted
        along with the data (i.e. it is explicitly included), the high
        nibble of the high byte is not used. This is applicable for the
        IDs up to 12 bits.
    :ivar data_length: This attribute represents the length of the Array
        representation of the Signal Group/VariableDataPrototype
        including CRC and Counter in bits.
    :ivar max_delta_counter_init: Initial maximum allowed gap between
        two counter values of two consecutively received valid Data,
        i.e. how many subsequent lost data is accepted. For example, if
        the receiver gets Data with counter 1 and MaxDeltaCounterInit is
        1, then at the next reception the receiver can accept Counters
        with values 2 and 3, but not 4. Note that if the receiver does
        not receive new Data at a consecutive read, then the receiver
        increments the tolerance by 1.
    :ivar crc_offset: Bit offset of CRC from the beginning of the Array
        representation of the Signal Group/VariableDataPrototype (MSB
        order, bit numbering: bit 0 is the least important). The offset
        shall be a multiplicity of 8 and it should be 0 whenever
        possible. For example, offset 8 means that the CRC will take the
        byte 1, i.e. bits 8..15. If crcOffset is not present the value
        is defined by the selected profile.
    :ivar counter_offset: Bit offset of Counter from the beginning of
        the Array representation of the Signal
        Group/VariableDataPrototype (MSB order, bit numbering: bit 0 is
        the least important). The offset shall be a multiplicity of 4
        and it should be 8 whenever possible. For example, offset 8
        means that the counter will take the low nibble of the byte 1,
        i.e. bits 8 .. 11. If counterOffset is not present the value is
        defined by the selected profile.
    :ivar max_no_new_or_repeated_data: The maximum amount of missing or
        repeated Data which the receiver does not expect to exceed under
        normal communication conditions.
    :ivar sync_counter_init: Number of Data required for validating the
        consistency of the counter that shall be received with a valid
        counter (i.e. counter within the allowed lock-in range) after
        the detection of an unexpected behavior of a received counter.
    :ivar data_id_nibble_offset: Bit offset of the low nibble of the
        high byte of Data ID. The applicability of this attribute is
        controlled by [constr_1261].
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "END-TO-END-DESCRIPTION"

    category: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_ids: Optional["EndToEndDescription.DataIds"] = field(
        default=None,
        metadata={
            "name": "DATA-IDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_id_mode: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-ID-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_delta_counter_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-DELTA-COUNTER-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crc_offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CRC-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    counter_offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "COUNTER-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_no_new_or_repeated_data: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NO-NEW-OR-REPEATED-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_counter_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SYNC-COUNTER-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_id_nibble_offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-ID-NIBBLE-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataIds:
        data_id: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "DATA-ID",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EndToEndProfileBehaviorEnum:
    """
    Behavior of the check functionality.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "END-TO-END-PROFILE-BEHAVIOR-ENUM"

    value: EndToEndProfileBehaviorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EnterExitTimeout:
    """
    This meta-class represents the ability to specify a pair of timeouts, one for
    entering, and one for exiting.

    :ivar enter_timeout_value: This attribute represents the value of
        the enter timeout in seconds.
    :ivar exit_timeout_value: This attribute represents the value of the
        exit timeout in seconds.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ENTER-EXIT-TIMEOUT"

    enter_timeout_value: TimeValue | None = field(
        default=None,
        metadata={
            "name": "ENTER-TIMEOUT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exit_timeout_value: TimeValue | None = field(
        default=None,
        metadata={
            "name": "EXIT-TIMEOUT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EnumerationMappingEntry:
    """This class specifies the entry elements of the enumeration mapping table.

    Note that this class might be used in the extended meta-model only.

    :ivar numerical_value: This attribute specifies the numerical value
        (e.g. 0, 1) of the enumeration entry. The numericalValue marks
        an index on M2 level. It is not used in C-Code or at runtime.
        The numericalValue is only given to be able to calculate a value
        that represents the enumerator literal in a numerical
        expression.
    :ivar enumerator_value: This attribute specifies the symbolic value
        (e.g. in, out) of the enumeration entry.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ENUMERATION-MAPPING-ENTRY"

    numerical_value: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NUMERICAL-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    enumerator_value: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "ENUMERATOR-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EnvironmentCaptureToReportingEnum:
    """
    This meta-class represents the ability to define the behavior of the capturing
    behavior.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ENVIRONMENT-CAPTURE-TO-REPORTING-ENUM"

    value: EnvironmentCaptureToReportingEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EthGlobalTimeManagedCouplingPort:
    """
    Specifies a CouplingPort which is managed by an Ethernet Global Time Domain.

    :ivar coupling_port_ref: Defines which CouplingPort is managed by
        this EthGlobalTimeManagedCouplingPort.
    :ivar pdelay_latency_threshold: Threshold for calculated Pdelay. If
        a measured Pdelay exceeds pdelayLatencyThreshold, the measured
        Pdelay value is discarded.
    :ivar pdelay_request_period: Defines the period for the pdelay
        request messages.
    :ivar pdelay_resp_and_resp_follow_up_timeout: Timeout value for
        Pdelay_Resp and Pdelay_Resp_Follow_Up after a Pdelay_Req has
        been transmitted resp. a Pdelay_Resp has been received. A value
        of 0 or not defining this attribute deactivates this timeout
        observation.
    :ivar pdelay_response_enabled: Defines whether PDELAY RESPONSE and
        PDELAY RESPONSE FOLLOW UP shall be sent on this CouplingPort.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETH-GLOBAL-TIME-MANAGED-COUPLING-PORT"

    coupling_port_ref: Optional["EthGlobalTimeManagedCouplingPort.CouplingPortRef"] = field(
        default=None,
        metadata={
            "name": "COUPLING-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdelay_latency_threshold: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PDELAY-LATENCY-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdelay_request_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PDELAY-REQUEST-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdelay_resp_and_resp_follow_up_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PDELAY-RESP-AND-RESP-FOLLOW-UP-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdelay_response_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "PDELAY-RESPONSE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CouplingPortRef(Ref):
        dest: CouplingPortSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EthGlobalTimeMessageFormatEnum:
    """
    Specifies which message formats are available to for the Ethernet time sync
    protocol.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETH-GLOBAL-TIME-MESSAGE-FORMAT-ENUM"

    value: EthGlobalTimeMessageFormatEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EthTSynCrcFlags:
    """
    Defines the fields of the message which shall be taken into account for CRC
    calculation and verification.

    :ivar crc_correction_field: CorrectionField from the Follow_Up
        Message Header shall be included in CRC calculation.
    :ivar crc_domain_number: DomainNumber from the Follow_Up Message
        Header shall be included in CRC calculation.
    :ivar crc_message_length: MessageLength from the Follow_Up Message
        Header shall be included in CRC calculation.
    :ivar crc_precise_origin_timestamp: PreciseOriginTimestamp from the
        Follow_Up Message Field shall be included in CRC calculation.
    :ivar crc_sequence_id: SequenceId from the Follow_Up Message Header
        shall be included in CRC calculation.
    :ivar crc_source_port_identity: SourcePortIdentity from the
        Follow_Up Message Header shall be included in CRC calculation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETH-T-SYN-CRC-FLAGS"

    crc_correction_field: Boolean | None = field(
        default=None,
        metadata={
            "name": "CRC-CORRECTION-FIELD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crc_domain_number: Boolean | None = field(
        default=None,
        metadata={
            "name": "CRC-DOMAIN-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crc_message_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "CRC-MESSAGE-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crc_precise_origin_timestamp: Boolean | None = field(
        default=None,
        metadata={
            "name": "CRC-PRECISE-ORIGIN-TIMESTAMP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crc_sequence_id: Boolean | None = field(
        default=None,
        metadata={
            "name": "CRC-SEQUENCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crc_source_port_identity: Boolean | None = field(
        default=None,
        metadata={
            "name": "CRC-SOURCE-PORT-IDENTITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EthTSynSubTlvConfig:
    """
    Defines the subTLV fields which shall be included in the time sync message.

    :ivar ofs_sub_tlv: Defines whether an AUTOSAR Follow_Up TLV OFS Sub-
        TLV is used.
    :ivar status_sub_tlv: Defines whether an AUTOSAR Follow_Up TLV
        Status Sub-TLV is used.
    :ivar time_sub_tlv: Defines whether an AUTOSAR Follow_Up TLV Time
        Sub-TLV is used.
    :ivar user_data_sub_tlv: Defines whether an AUTOSAR Follow_Up TLV
        UserData Sub-TLV is used.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETH-T-SYN-SUB-TLV-CONFIG"

    ofs_sub_tlv: Boolean | None = field(
        default=None,
        metadata={
            "name": "OFS-SUB-TLV",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    status_sub_tlv: Boolean | None = field(
        default=None,
        metadata={
            "name": "STATUS-SUB-TLV",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_sub_tlv: Boolean | None = field(
        default=None,
        metadata={
            "name": "TIME-SUB-TLV",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    user_data_sub_tlv: Boolean | None = field(
        default=None,
        metadata={
            "name": "USER-DATA-SUB-TLV",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EthernetConnectionNegotiationEnum:
    """
    Specifies connection negotiation types of Ethernet transceiver links.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-CONNECTION-NEGOTIATION-ENUM"

    value: EthernetConnectionNegotiationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EthernetCouplingPortSchedulerEnum:
    """
    Defines the schedule algorithm to be used.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-COUPLING-PORT-SCHEDULER-ENUM"

    value: EthernetCouplingPortSchedulerEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EthernetMacLayerTypeEnum:
    """
    Specifies MAC (Media Access Control) Layer types.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-MAC-LAYER-TYPE-ENUM"

    value: EthernetMacLayerTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EthernetPhysicalLayerTypeEnum:
    """
    Specifies physical layer types of Ethernet transceiver links.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-PHYSICAL-LAYER-TYPE-ENUM"

    value: EthernetPhysicalLayerTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EthernetRawDataStreamLocalEndpointConfig:
    """
    This meta-class has the ability to act as a wrapper for the configuration of
    the remote endpoint in the context of a raw data stream mapping.

    :ivar local_comm_connector_ref: This attribute represents the
        CommunicationConnector taken for socket-based data
        communication.
    :ivar local_tcp_port_ref: This aggregation represents the
        configuration of a local TCP port number.
    :ivar local_udp_port_ref: This aggregation represents the
        configuration of a local unicast UDP port number.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-RAW-DATA-STREAM-LOCAL-ENDPOINT-CONFIG"

    local_comm_connector_ref: Optional[
        "EthernetRawDataStreamLocalEndpointConfig.LocalCommConnectorRef"
    ] = field(
        default=None,
        metadata={
            "name": "LOCAL-COMM-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_tcp_port_ref: Optional["EthernetRawDataStreamLocalEndpointConfig.LocalTcpPortRef"] = (
        field(
            default=None,
            metadata={
                "name": "LOCAL-TCP-PORT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    local_udp_port_ref: Optional["EthernetRawDataStreamLocalEndpointConfig.LocalUdpPortRef"] = (
        field(
            default=None,
            metadata={
                "name": "LOCAL-UDP-PORT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class LocalCommConnectorRef(Ref):
        dest: EthernetCommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class LocalTcpPortRef(Ref):
        dest: ApApplicationEndpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class LocalUdpPortRef(Ref):
        dest: ApApplicationEndpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EthernetSwitchVlanEgressTaggingEnum:
    """
    Defines the VLAN tag sending behavior.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-SWITCH-VLAN-EGRESS-TAGGING-ENUM"

    value: EthernetSwitchVlanEgressTaggingEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EthernetSwitchVlanIngressTagEnum:
    """
    Defines the possible tagging behavior at an ingress port.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-SWITCH-VLAN-INGRESS-TAG-ENUM"

    value: EthernetSwitchVlanIngressTagEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EventAcceptanceStatusEnum:
    """
    This enumerator specifies the initial status for enable or disable of
    acceptance of event reports of a diagnostic event.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EVENT-ACCEPTANCE-STATUS-ENUM"

    value: EventAcceptanceStatusEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EventGroupControlTypeEnum:
    """
    Types of a RoutingGroups for the event communication.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EVENT-GROUP-CONTROL-TYPE-ENUM"

    value: EventGroupControlTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EventInExecutableInstanceRef:
    """
    :ivar context_root_sw_component_prototype_ref:
    :ivar context_sw_component_prototype_ref:
    :ivar context_r_port_prototype_ref:
    :ivar target_event_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EVENT-IN-EXECUTABLE-INSTANCE-REF"

    context_root_sw_component_prototype_ref: Optional[
        "EventInExecutableInstanceRef.ContextRootSwComponentPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ROOT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_sw_component_prototype_ref: list[
        "EventInExecutableInstanceRef.ContextSwComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_r_port_prototype_ref: Optional[
        "EventInExecutableInstanceRef.ContextRPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-R-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_event_ref: Optional["EventInExecutableInstanceRef.TargetEventRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRootSwComponentPrototypeRef(Ref):
        dest: RootSwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextSwComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextRPortPrototypeRef(Ref):
        dest: RPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetEventRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EventOccurrenceKindEnum:
    """
    This is used to describe the type of the occurrence of an event within a given
    time interval.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EVENT-OCCURRENCE-KIND-ENUM"

    value: EventOccurrenceKindEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ExecutionOrderConstraintTypeEnum:
    """
    This is used to describe the specific type of the ExecutionOrderConstraint.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXECUTION-ORDER-CONSTRAINT-TYPE-ENUM"

    value: ExecutionOrderConstraintTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ExecutionStateReportingBehaviorEnum:
    """
    This enumeration provides options for controlling of how an Executable reports
    its execution state to the Execution Management.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXECUTION-STATE-REPORTING-BEHAVIOR-ENUM"

    value: ExecutionStateReportingBehaviorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ExecutionTimeTypeEnum:
    """
    Specifies the type of the execution time constrained by
    ExecutionTimeConstraint.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXECUTION-TIME-TYPE-ENUM"

    value: ExecutionTimeTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FieldAccessEnum:
    """
    This meta-class provides values that qualify access to a field.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FIELD-ACCESS-ENUM"

    value: FieldAccessEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FieldInExecutableInstanceRef:
    """
    :ivar context_root_sw_component_prototype_ref:
    :ivar context_sw_component_prototype_ref:
    :ivar context_r_port_prototype_ref:
    :ivar target_field_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FIELD-IN-EXECUTABLE-INSTANCE-REF"

    context_root_sw_component_prototype_ref: Optional[
        "FieldInExecutableInstanceRef.ContextRootSwComponentPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ROOT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_sw_component_prototype_ref: list[
        "FieldInExecutableInstanceRef.ContextSwComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_r_port_prototype_ref: Optional[
        "FieldInExecutableInstanceRef.ContextRPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-R-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_field_ref: Optional["FieldInExecutableInstanceRef.TargetFieldRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-FIELD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRootSwComponentPrototypeRef(Ref):
        dest: RootSwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextSwComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextRPortPrototypeRef(Ref):
        dest: RPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetFieldRef(Ref):
        dest: FieldSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FilterDebouncingEnum:
    """
    This enumeration defines possible values for the filter debouncing strategy.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FILTER-DEBOUNCING-ENUM"

    value: FilterDebouncingEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FirewallActionEnum:
    """
    List of actions that the Firewall is able to perform.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FIREWALL-ACTION-ENUM"

    value: FirewallActionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FirewallStateInFirwallStateSwitchInterfaceInstanceRef:
    """
    :ivar context_mode_declaration_group_prototype_ref:
    :ivar target_mode_declaration_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FIREWALL-STATE-IN-FIRWALL-STATE-SWITCH-INTERFACE-INSTANCE-REF"

    context_mode_declaration_group_prototype_ref: Optional[
        "FirewallStateInFirwallStateSwitchInterfaceInstanceRef.ContextModeDeclarationGroupPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-MODE-DECLARATION-GROUP-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_mode_declaration_ref: Optional[
        "FirewallStateInFirwallStateSwitchInterfaceInstanceRef.TargetModeDeclarationRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-MODE-DECLARATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextModeDeclarationGroupPrototypeRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetModeDeclarationRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FlexrayChannelName:
    """
    Name of the channel.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-CHANNEL-NAME"

    value: FlexrayChannelNameSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FlexrayFifoRange:
    """
    FIFO Frame Id range acceptance criteria.

    :ivar range_max: Max Range.
    :ivar range_min: Min Range.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-FIFO-RANGE"

    range_max: Integer | None = field(
        default=None,
        metadata={
            "name": "RANGE-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    range_min: Integer | None = field(
        default=None,
        metadata={
            "name": "RANGE-MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FlexrayNmEcu:
    """
    FlexRay specific attributes.

    :ivar nm_hw_vote_enabled: Switch for enabling the processing of
        FlexRay Hardware aggregated NM-Votes.
    :ivar nm_main_function_across_fr_cycle: Parameter describing if the
        execution of the FrNm_Main function crosses theFlexRay cycle
        boundary or not.
    :ivar nm_repeat_message_bit_enable: Enables/disables the repeat
        message bit support
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-NM-ECU"

    nm_hw_vote_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-HW-VOTE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_main_function_across_fr_cycle: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-MAIN-FUNCTION-ACROSS-FR-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_repeat_message_bit_enable: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-REPEAT-MESSAGE-BIT-ENABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FlexrayNmScheduleVariant:
    """
    FrNm schedule variant according to FrNm SWS.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-NM-SCHEDULE-VARIANT"

    value: FlexrayNmScheduleVariantSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FloatEnum:
    """
    This enumerator specifies the policy how an objects floats on a page.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLOAT-ENUM"

    value: FloatEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FloatValueVariationPoint:
    """This class represents an attribute value variation point for Float
    attributes.

    Note that this class might be used in the extended meta-model only

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar binding_time: This is the binding time in which the attribute
        value needs to be bound. If this attribute is missing, the
        attribute is not a variation point. In particular this means
        that It needs to be a single value according to the type
        specified in the pure model. It is an error if it is still a
        formula.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar sd: This special data is provided to allow synchronization of
        Attribute value variation points with variant management
        systems. The usage is subject of agreement between the involved
        parties.
    :ivar short_label: This allows to identify the variation point. It
        is also intended to allow RTE support for CompileTime Variation
        points.
    :ivar content:
    """

    class Meta:
        name = "FLOAT-VALUE-VARIATION-POINT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    binding_time: BindingTimeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "BINDING-TIME",
            "type": "Attribute",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    sd: str | None = field(
        default=None,
        metadata={
            "name": "SD",
            "type": "Attribute",
        },
    )
    short_label: str | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef("FloatValueVariationPoint.SyscStringRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("FloatValueVariationPoint.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FmAttributeValue:
    """
    This defines a value for the attribute that is referred to in the role
    definition.

    :ivar definition_ref: This refers to the definition of this
        attribute.
    :ivar value: This represents the value of this attribute.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FM-ATTRIBUTE-VALUE"

    definition_ref: Optional["FmAttributeValue.DefinitionRef"] = field(
        default=None,
        metadata={
            "name": "DEFINITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DefinitionRef(Ref):
        dest: FmAttributeDefSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FmConditionByFeaturesAndAttributes:
    """
    A boolean expression that has the syntax of the AUTOSAR formula language but
    uses only references to features or feature attributes (not system constants)
    as operands.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar content:
    """

    class Meta:
        name = "FM-CONDITION-BY-FEATURES-AND-ATTRIBUTES"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "ATTRIBUTE-REF",
                    "type": ForwardRef("FmConditionByFeaturesAndAttributes.AttributeRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "FEATURE-REF",
                    "type": ForwardRef("FmConditionByFeaturesAndAttributes.FeatureRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AttributeRef(Ref):
        dest: FmAttributeDefSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FeatureRef(Ref):
        dest: FmFeatureSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FmConditionByFeaturesAndSwSystemconsts:
    """
    A boolean expression that has the syntax of the AUTOSAR formula language and
    may use references to features or system constants as operands.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar content:
    """

    class Meta:
        name = "FM-CONDITION-BY-FEATURES-AND-SW-SYSTEMCONSTS"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef("FmConditionByFeaturesAndSwSystemconsts.SyscStringRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("FmConditionByFeaturesAndSwSystemconsts.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "FEATURE-REF",
                    "type": ForwardRef("FmConditionByFeaturesAndSwSystemconsts.FeatureRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FeatureRef(Ref):
        dest: FmFeatureSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FmFeatureDecomposition:
    """A FMFeatureDecomposition describes dependencies between a list of features
    and their parent feature (i.e., the FMFeature that aggregates the
    FMFeatureDecomposition).

    The kind of dependency is defined by the attribute category.

    :ivar category: The category of a FMFeatureDecomposition defines the
        type of dependency that is defined by the
        FMFeatureDecomposition. There are four different categories:
        MANDATORYFEATURE, OPTIONALFEATURE, ALTERNATIVEFEATURE, and
        MULTIPLEFEATURE.
    :ivar feature_refs: The features that are affected by the dependency
        defined by the FMFeatureDecomposition.
    :ivar max: For a dependency of category MULTIPLEFEATURE, this
        defines the maximum number of features allowed.
    :ivar min: For a dependency of category MULTIPLEFEATURE, this
        defines the minimum number of features allowed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FM-FEATURE-DECOMPOSITION"

    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    feature_refs: Optional["FmFeatureDecomposition.FeatureRefs"] = field(
        default=None,
        metadata={
            "name": "FEATURE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FeatureRefs:
        feature_ref: list["FmFeatureDecomposition.FeatureRefs.FeatureRef"] = field(
            default_factory=list,
            metadata={
                "name": "FEATURE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FeatureRef(Ref):
            dest: FmFeatureSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class FmFeatureSelectionState:
    """
    Defines how a particular FMFeature contributes to a FMFSelectionSet.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FM-FEATURE-SELECTION-STATE"

    value: FmFeatureSelectionStateSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FrArTpAckType:
    """
    Type of Acknowledgement.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FR-AR-TP-ACK-TYPE"

    value: FrArTpAckTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FrameEnum:
    """
    This enumerator specifies the policy, where to place a frame border around the
    table.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FRAME-ENUM"

    value: FrameEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FramePid:
    """Frame_PIDs that are included in the request.

    The "pid" attribute describes the value and the "index" attribute
    the position of the frame_PID in the request.

    :ivar index: This attribute is used to order the frame_PIDs. The
        values of index shall be unique within one AssignFrameIdRange.
    :ivar pid: Frame_PID value.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FRAME-PID"

    index: Integer | None = field(
        default=None,
        metadata={
            "name": "INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FullBindingTimeEnum:
    """
    This enumeration specifies the BindingTimes that can be used in AUTOSAR models.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FULL-BINDING-TIME-ENUM"

    value: FullBindingTimeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FunctionGroupStateInFunctionGroupSetInstanceRef:
    """
    :ivar context_mode_declaration_group_prototype_ref:
    :ivar target_mode_declaration_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FUNCTION-GROUP-STATE-IN-FUNCTION-GROUP-SET-INSTANCE-REF"

    context_mode_declaration_group_prototype_ref: Optional[
        "FunctionGroupStateInFunctionGroupSetInstanceRef.ContextModeDeclarationGroupPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-MODE-DECLARATION-GROUP-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_mode_declaration_ref: Optional[
        "FunctionGroupStateInFunctionGroupSetInstanceRef.TargetModeDeclarationRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-MODE-DECLARATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextModeDeclarationGroupPrototypeRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetModeDeclarationRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FunctionalClusterPersistencyAccessEnum:
    """
    This meta-class provides possible values about how functional clusters may use
    persistency with respect to the direction of access.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FUNCTIONAL-CLUSTER-PERSISTENCY-ACCESS-ENUM"

    value: FunctionalClusterPersistencyAccessEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class GenericModelReference:
    """This meta-class represents the ability to express a late binding reference
    to a model element.

    The model element can be from every model. Even if it is modeled
    according to the association representation, it is not limited to
    refer to AUTOSAR model elements.

    :ivar ref: This is the full qualified name of the model element
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar base: This establishes the reference base.
    :ivar dest: This attribute represents the class of the referenced
        model element. It is a String, since the model element can be in
        any model. Therefore we cannot have any assumption here.
    """

    class Meta:
        name = "GENERIC-MODEL-REFERENCE"

    ref: Ref | None = field(
        default=None,
        metadata={
            "name": "REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    base: str | None = field(
        default=None,
        metadata={
            "name": "BASE",
            "type": "Attribute",
        },
    )
    dest: str | None = field(
        default=None,
        metadata={
            "name": "DEST",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class GenericTp:
    """
    Content Model for a generic transport protocol.

    :ivar tp_address: Transport Protocol dependent Address.
    :ivar tp_technology: Name of the used Transport Protocol.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GENERIC-TP"

    tp_address: String | None = field(
        default=None,
        metadata={
            "name": "TP-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_technology: String | None = field(
        default=None,
        metadata={
            "name": "TP-TECHNOLOGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class GlobalTimeCorrectionProps:
    """
    This meta-class defines the attributes for rate and offset correction.

    :ivar offset_correction_adaption_interval: Defines the interval
        during which the adaptive rate correction cancels out the rate-
        and time deviation.
    :ivar offset_correction_jump_threshold: Threshold for the correction
        method. Deviations below this value will be corrected by a
        linear reduction over a defined timespan. Values equal- and
        greater than this value will be corrected by immediately setting
        the correct time- and rate in form of a jump.
    :ivar rate_correction_measurement_duration: Definition of the time
        span which is used to calculate the rate deviation.
    :ivar rate_corrections_per_measurement_duration: Defines the number
        of simultaneous rate measurements to determine the current rate
        deviation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-CORRECTION-PROPS"

    offset_correction_adaption_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "OFFSET-CORRECTION-ADAPTION-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offset_correction_jump_threshold: TimeValue | None = field(
        default=None,
        metadata={
            "name": "OFFSET-CORRECTION-JUMP-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rate_correction_measurement_duration: TimeValue | None = field(
        default=None,
        metadata={
            "name": "RATE-CORRECTION-MEASUREMENT-DURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rate_corrections_per_measurement_duration: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "RATE-CORRECTIONS-PER-MEASUREMENT-DURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class GlobalTimeCouplingPortProps:
    """
    Defines properties for the usage of the CouplingPort in the scope of Global
    Time Sync.

    :ivar propagation_delay: If cyclic propagation delay measurement is
        enabled, this parameter represents the default value of the
        propagation delay until the first actually measured propagation
        delay is available. If cyclic propagation delay measurement is
        disabled, this parameter defines a fixed value for the
        propagation delay.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-COUPLING-PORT-PROPS"

    propagation_delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PROPAGATION-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class GlobalTimeCrcSupportEnum:
    """
    This enumeration is used to define whether and how CRC on the TX side shall be
    utilized.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-CRC-SUPPORT-ENUM"

    value: GlobalTimeCrcSupportEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class GlobalTimeCrcValidationEnum:
    """
    This enumeration provides values for the evaluation of the CRC.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-CRC-VALIDATION-ENUM"

    value: GlobalTimeCrcValidationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class GlobalTimeIcvSupportEnum:
    """
    Defines whether an Integrity Check Value (ICV) shall be added to the sent time
    sync messages.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-ICV-SUPPORT-ENUM"

    value: GlobalTimeIcvSupportEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class GlobalTimeIcvVerificationEnum:
    """
    This enumeration is used to define how an Integrity Check Value (ICV) shall be
    handled at the receiver.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-ICV-VERIFICATION-ENUM"

    value: GlobalTimeIcvVerificationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Graphic:
    """
    This class represents an artifact containing the image to be inserted in the
    document.

    :ivar short_label: This is the short name of the engineering object.
        Note that it is modeled as NameToken and not as Identifier since
        in ASAM-CC it is also a NameToken.
    :ivar category: This denotes the role of the engineering object in
        the development cycle. Categories are such as * SWSRC for source
        code * SWOBJ for object code * SWHDR for a C-header file Further
        roles need to be defined via Methodology.
    :ivar revision_labels: This is a revision label denoting a
        particular version of the engineering object.
    :ivar domain: This denotes the domain in which the engineering
        object is stored. This allows to indicate various segments in
        the repository keeping the engineering objects. The domain may
        segregate companies, as well as automotive domains. Details need
        to be defined by the Methodology. Attribute is optional to
        support a default domain.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar edit_height: Specifies the height of the graphic when it is
        displayed in an editor. The unit can be added to the number in
        the string. Possible units are: cm, mm, px, pt. The default unit
        is px.
    :ivar edit_width: Specifies the width of the graphic when it is
        displayed in an editor. The unit can be added to the number in
        the string. Possible units are: cm, mm, px, pt. The default unit
        is px.
    :ivar editfit: Specifies how the graphic shall be displayed in an
        editor. If the attribute is missing,
    :ivar editscale: Set the proportional scale when displayed in an
        editor.
    :ivar filename: Name of the file that should be displayed. This
        attribute is supported in ASAM FSX and kept in AUTOSAR in order
        to support cut and paste.
    :ivar fit: It determines the way in which the graphic should be
        inserted. Enter the attribute value "AS-IS" , to insert a
        graphic in its original dimensions. The graphic is adapted, if
        it is too big for the space for which it was intended. Default
        is "AS-IS"
    :ivar generator: This attribute specifies the generator which is
        used to generate the image. Use case is that when editing a
        documentation, a figure (to be delivered by the  modeling tool)
        is inserted by the authoring tool as reference (this is the role
        of graphic). But the real figure maybe injected during document
        processing. To  be able to recognize this situation, this
        attribute can be applied.
    :ivar height: Define the displayed height of the figure. The unit
        can be added to the number in the string. Possible units are:
        cm, mm, px, pt. The default unit is px.
    :ivar html_fit: How to fit the graphic in an online media. Default
        is AS-IS.
    :ivar html_height: Specifies the height of the graphic when it is
        displayed online. The unit can be added to the number in the
        string. Possible units are: cm, mm, px, pt. The default unit is
        px.
    :ivar html_scale: Set the proportional scale when displayed online.
    :ivar html_width: Specifies the width of the graphic when it is
        displayed online. The unit can be added to the number in the
        string. Possible units are: cm, mm, px, pt. The default unit is
        px.
    :ivar notation: This attribute captures the format used to represent
        the graphic.
    :ivar scale: In this element the dimensions of the graphic can be
        altered proportionally.
    :ivar width: Define the displayed width of the figure. The unit can
        be added to the number in the string. Possible units are: cm,
        mm, px, pt. The default unit is px.
    """

    class Meta:
        name = "GRAPHIC"

    short_label: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    revision_labels: Optional["Graphic.RevisionLabels"] = field(
        default=None,
        metadata={
            "name": "REVISION-LABELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    domain: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "DOMAIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    edit_height: str | None = field(
        default=None,
        metadata={
            "name": "EDIT-HEIGHT",
            "type": "Attribute",
        },
    )
    edit_width: str | None = field(
        default=None,
        metadata={
            "name": "EDIT-WIDTH",
            "type": "Attribute",
        },
    )
    editfit: GraphicFitEnumSimple | None = field(
        default=None,
        metadata={
            "name": "EDITFIT",
            "type": "Attribute",
        },
    )
    editscale: str | None = field(
        default=None,
        metadata={
            "name": "EDITSCALE",
            "type": "Attribute",
        },
    )
    filename: str | None = field(
        default=None,
        metadata={
            "name": "FILENAME",
            "type": "Attribute",
        },
    )
    fit: GraphicFitEnumSimple | None = field(
        default=None,
        metadata={
            "name": "FIT",
            "type": "Attribute",
        },
    )
    generator: str | None = field(
        default=None,
        metadata={
            "name": "GENERATOR",
            "type": "Attribute",
        },
    )
    height: str | None = field(
        default=None,
        metadata={
            "name": "HEIGHT",
            "type": "Attribute",
        },
    )
    html_fit: GraphicFitEnumSimple | None = field(
        default=None,
        metadata={
            "name": "HTML-FIT",
            "type": "Attribute",
        },
    )
    html_height: str | None = field(
        default=None,
        metadata={
            "name": "HTML-HEIGHT",
            "type": "Attribute",
        },
    )
    html_scale: str | None = field(
        default=None,
        metadata={
            "name": "HTML-SCALE",
            "type": "Attribute",
        },
    )
    html_width: str | None = field(
        default=None,
        metadata={
            "name": "HTML-WIDTH",
            "type": "Attribute",
        },
    )
    notation: GraphicNotationEnumSimple | None = field(
        default=None,
        metadata={
            "name": "NOTATION",
            "type": "Attribute",
        },
    )
    scale: str | None = field(
        default=None,
        metadata={
            "name": "SCALE",
            "type": "Attribute",
        },
    )
    width: str | None = field(
        default=None,
        metadata={
            "name": "WIDTH",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class RevisionLabels:
        revision_label: list[RevisionLabelString] = field(
            default_factory=list,
            metadata={
                "name": "REVISION-LABEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class GraphicFitEnum:
    """
    This enumerator specifies the policy how to place and scale the figure on the
    page.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GRAPHIC-FIT-ENUM"

    value: GraphicFitEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class GraphicNotationEnum:
    """
    This enumerator specifies the various notations (finally file types) used to
    represent the figure.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GRAPHIC-NOTATION-ENUM"

    value: GraphicNotationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class HandleInvalidEnum:
    """
    Strategies of handling the reception of invalidValue.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HANDLE-INVALID-ENUM"

    value: HandleInvalidEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class HandleOutOfRangeEnum:
    """
    A value of this type is taken for controlling the range checking behavior of
    the AUTOSAR RTE.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HANDLE-OUT-OF-RANGE-ENUM"

    value: HandleOutOfRangeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class HandleOutOfRangeStatusEnum:
    """
    This enumeration defines how the RTE handles values that are out of range.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HANDLE-OUT-OF-RANGE-STATUS-ENUM"

    value: HandleOutOfRangeStatusEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class HandleTerminationAndRestartEnum:
    """
    Controls the behavior of an AtomicSwComponentType with respect to stop and
    restart.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HANDLE-TERMINATION-AND-RESTART-ENUM"

    value: HandleTerminationAndRestartEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class HandleTimeoutEnum:
    """
    Strategies of handling a reception timeout violation.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HANDLE-TIMEOUT-ENUM"

    value: HandleTimeoutEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class HardwareConfiguration:
    """
    Describes in which mode the hardware is operating while needing this resource
    consumption.

    :ivar additional_information: Specifies additional information on
        the HardwareConfiguration.
    :ivar processor_mode: Specifies in which mode the processor is
        operating.
    :ivar processor_speed: Specifies the speed the processor is
        operating.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HARDWARE-CONFIGURATION"

    additional_information: String | None = field(
        default=None,
        metadata={
            "name": "ADDITIONAL-INFORMATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    processor_mode: String | None = field(
        default=None,
        metadata={
            "name": "PROCESSOR-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    processor_speed: String | None = field(
        default=None,
        metadata={
            "name": "PROCESSOR-SPEED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class HealthChannelExternalReportedStatus:
    """
    This element defines a health channel representing the status of an external
    health channel.

    :ivar status_id: Defines the numeric value which is used to identify
        the reporting of this HealthChannelExternalReportedStatus to the
        Phm.
    :ivar status_ref: Reference to one status of a PhmHealthChannel.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HEALTH-CHANNEL-EXTERNAL-REPORTED-STATUS"

    status_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "STATUS-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    status_ref: Optional["HealthChannelExternalReportedStatus.StatusRef"] = field(
        default=None,
        metadata={
            "name": "STATUS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class StatusRef(Ref):
        dest: PhmHealthChannelStatusSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class HwPortMapping:
    """
    HWPortMapping specifies the hwCommunicationPort (defined in the ECU Resource
    Template) to realize the specified CommunicationConnector in a physical
    topology.

    :ivar communication_connector_ref: Reference to the
        CommunicationConnector in the System Template
    :ivar hw_communication_port_ref: Reference to the HwPinPortGroup of
        category CommunicationPort. The connection to the
        HwCommunicationController is described in the Ecu Resource
        Description.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HW-PORT-MAPPING"

    communication_connector_ref: Optional["HwPortMapping.CommunicationConnectorRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_communication_port_ref: Optional["HwPortMapping.HwCommunicationPortRef"] = field(
        default=None,
        metadata={
            "name": "HW-COMMUNICATION-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class HwCommunicationPortRef(Ref):
        dest: HwPinGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class IPduSignalProcessingEnum:
    """
    Definition of signal processing modes.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-PDU-SIGNAL-PROCESSING-ENUM"

    value: IPduSignalProcessingEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class IPsecDpdActionEnum:
    """
    Potential Dead Peer Detection (Dpd) Actions.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-PSEC-DPD-ACTION-ENUM"

    value: IPsecDpdActionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class IPsecHeaderTypeEnum:
    """
    IPsec Header Type options.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-PSEC-HEADER-TYPE-ENUM"

    value: IPsecHeaderTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class IPsecIpProtocolEnum:
    """
    Definition of supported TcpIp protocols that are supported in Security Policy
    Database (SPD) entries in IPSec configurations.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-PSEC-IP-PROTOCOL-ENUM"

    value: IPsecIpProtocolEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class IPsecModeEnum:
    """
    This enumeration describes the supported IPSec modes.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-PSEC-MODE-ENUM"

    value: IPsecModeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class IPsecPolicyEnum:
    """
    Defines the filter actions that are supported by IPsec.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-PSEC-POLICY-ENUM"

    value: IPsecPolicyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ISignalTypeEnum:
    """
    This enumeration defines ISignal types that are used for derivation of the
    ComSignalType in the COM configuration.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-SIGNAL-TYPE-ENUM"

    value: ISignalTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class IcmpRule:
    """
    Configuration of filter rules for ICMP (Internet Control Message Protocol).

    :ivar checksum_verification: Defines whether a Icmp header checksum
        verification is performed or not.
    :ivar code: Filter to match packets with the Icmp code.
    :ivar type_value: Filter to match packets with the Icmp type.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ICMP-RULE"

    checksum_verification: Boolean | None = field(
        default=None,
        metadata={
            "name": "CHECKSUM-VERIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    code: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_value: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class IdsmSignatureSupportAp:
    """
    This meta-class defines, for the Adaptive Platform, the cryptographic algorithm
    and key to be used by the IdsM instance for providing signature information in
    QSEv messages.

    :ivar crypto_primitive: This attribute defines the cryptographic
        algorithm to be used for providing authentication information in
        QSEv messages. The content of this attribute shall comply to the
        "Cryptographic Primitives Naming Convention".
    :ivar key_slot_ref: This reference denotes the cryptographic key to
        be used by the cryptographic algorithm for providing
        authentication information in QSEv messages.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IDSM-SIGNATURE-SUPPORT-AP"

    crypto_primitive: String | None = field(
        default=None,
        metadata={
            "name": "CRYPTO-PRIMITIVE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_slot_ref: Optional["IdsmSignatureSupportAp.KeySlotRef"] = field(
        default=None,
        metadata={
            "name": "KEY-SLOT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class KeySlotRef(Ref):
        dest: CryptoKeySlotSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class IdsmSignatureSupportCp:
    """
    This meta-class defines, for the Classic Platform, the cryptographic algorithm
    and key to be used by the IdsM instance for providing signature information in
    QSEv messages.

    :ivar authentication_ref: This reference dennotes the cryptographic
        primitives for providing authentication information in QSEv
        messages.
    :ivar crypto_service_key_ref: This reference denotes the
        cryptographic key to be used by the cryptographic algorithm for
        providing authentication information in QSEv messages.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IDSM-SIGNATURE-SUPPORT-CP"

    authentication_ref: Optional["IdsmSignatureSupportCp.AuthenticationRef"] = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_service_key_ref: Optional["IdsmSignatureSupportCp.CryptoServiceKeyRef"] = field(
        default=None,
        metadata={
            "name": "CRYPTO-SERVICE-KEY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AuthenticationRef(Ref):
        dest: CryptoServicePrimitiveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoServiceKeyRef(Ref):
        dest: CryptoServiceKeySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Ieee1722Tp:
    """
    Content Model for IEEE 1722 configuration.

    :ivar relative_representation_time: Defines the time when content
        shall be presented (in seconds). The actual absolute time is
        creation time plus relative presentation time.
    :ivar stream_identifier: IEEE 1722 stream identifier
    :ivar sub_type: Protocol type.
    :ivar version: Revision of Ieee1722 standard
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IEEE-1722-TP"

    relative_representation_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "RELATIVE-REPRESENTATION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    stream_identifier: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "STREAM-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_type: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SUB-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class IkeAuthenticationMethodEnum:
    """
    This enumeration describes the supported IKE authentication methods.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IKE-AUTHENTICATION-METHOD-ENUM"

    value: IkeAuthenticationMethodEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ImplementationDataTypeElementInPortInterfaceRef:
    """This meta-class represents the ability to refer to the internal structure of
    an AutosarDataPrototype which is typed by an ImplementationDatatype in the
    context of a PortInterface.

    In other words, this meta-class shall not be used to model a
    reference to the AutosarDataPrototype as a target itself, even if
    the AutosarDataPrototype is typed by an ImplementationDataType and
    even if that ImplementationDataType represents a composite data
    type.

    :ivar tag_id: This attribute represents the ability to specify a
        tag-id for the serialization of a specific DataPrototype in the
        context of a (potentially deeply-nested) composite  data
        structure.
    :ivar root_data_prototype_ref: This refers to the
        AutosarDataPrototype which is typed by the
        ImplementationDatatype. The targetDataPrototype and all defined
        contextDataPrototypes can be found within this
        rootDataPrototype.
    :ivar context_implementation_data_element_refs: This is a context in
        case there are subelements with explicit types. The reference
        has to be ordered to properly reflect the nested structure.
    :ivar target_implementation_data_type_element_ref: This is a target
        ImplementationDataTypeElement in case that the rootDataPrototype
        is composite and the target is a subElement of the
        rootDataPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IMPLEMENTATION-DATA-TYPE-ELEMENT-IN-PORT-INTERFACE-REF"

    tag_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TAG-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    root_data_prototype_ref: Optional[
        "ImplementationDataTypeElementInPortInterfaceRef.RootDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROOT-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_implementation_data_element_refs: Optional[
        "ImplementationDataTypeElementInPortInterfaceRef.ContextImplementationDataElementRefs"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-IMPLEMENTATION-DATA-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_implementation_data_type_element_ref: Optional[
        "ImplementationDataTypeElementInPortInterfaceRef.TargetImplementationDataTypeElementRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-IMPLEMENTATION-DATA-TYPE-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class RootDataPrototypeRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextImplementationDataElementRefs:
        context_implementation_data_element_ref: list[
            "ImplementationDataTypeElementInPortInterfaceRef.ContextImplementationDataElementRefs.ContextImplementationDataElementRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-IMPLEMENTATION-DATA-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextImplementationDataElementRef(Ref):
            dest: AbstractImplementationDataTypeElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TargetImplementationDataTypeElementRef(Ref):
        dest: AbstractImplementationDataTypeElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ImplementationDataTypeElementInSystemRef:
    """This meta-class represents the ability to refer to the internal structure of
    an AutosarDataPrototype which is typed by an ImplementationDatatype in the
    context of a CompositionSwComponentType.

    In other words, this meta-class shall not be used to model a
    reference to the AutosarDataPrototype as a target itself, even if
    the AutosarDataPrototype is typed by an ImplementationDataType and
    even if that ImplementationDataType represents a composite data
    type.

    :ivar tag_id: This attribute represents the ability to specify a
        tag-id for the serialization of a specific DataPrototype in the
        context of a (potentially deeply-nested) composite  data
        structure.
    :ivar base_ref: System that defines the context in which the
        ImplementationDataTypeElement is defined.
    :ivar context_swc_prototype_refs: This is the Software Component
        Prototype providing/receiving the referenced DataPrototype.
    :ivar context_port_prototype_ref: This is the port
        providing/receiving the referenced DataPrototype.
    :ivar root_data_prototype_ref: This refers to the
        AutosarDataPrototype which is typed by the
        ImplementationDatatype. The targetDataPrototype and all defined
        contextDataPrototypes can be found within this
        rootDataPrototype.
    :ivar context_implementation_data_element_refs: This is a context in
        case there are subelements with explicit types. The reference
        has to be ordered to properly reflect the nested structure.
    :ivar target_implementation_data_type_element_ref: This is a target
        ImplementationDataTypeElement in case that the rootDataPrototype
        is composite and the target of
        ImplementationCompositeDataTypeSubElementInSwcRef is a
        subElement of the rootDataPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IMPLEMENTATION-DATA-TYPE-ELEMENT-IN-SYSTEM-REF"

    tag_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TAG-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    base_ref: Optional["ImplementationDataTypeElementInSystemRef.BaseRef"] = field(
        default=None,
        metadata={
            "name": "BASE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_swc_prototype_refs: Optional[
        "ImplementationDataTypeElementInSystemRef.ContextSwcPrototypeRefs"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-SWC-PROTOTYPE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_port_prototype_ref: Optional[
        "ImplementationDataTypeElementInSystemRef.ContextPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    root_data_prototype_ref: Optional[
        "ImplementationDataTypeElementInSystemRef.RootDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROOT-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_implementation_data_element_refs: Optional[
        "ImplementationDataTypeElementInSystemRef.ContextImplementationDataElementRefs"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-IMPLEMENTATION-DATA-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_implementation_data_type_element_ref: Optional[
        "ImplementationDataTypeElementInSystemRef.TargetImplementationDataTypeElementRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-IMPLEMENTATION-DATA-TYPE-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BaseRef(Ref):
        dest: SystemSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextSwcPrototypeRefs:
        context_swc_prototype_ref: list[
            "ImplementationDataTypeElementInSystemRef.ContextSwcPrototypeRefs.ContextSwcPrototypeRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-SWC-PROTOTYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextSwcPrototypeRef(Ref):
            dest: SwComponentPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ContextPortPrototypeRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RootDataPrototypeRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextImplementationDataElementRefs:
        context_implementation_data_element_ref: list[
            "ImplementationDataTypeElementInSystemRef.ContextImplementationDataElementRefs.ContextImplementationDataElementRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-IMPLEMENTATION-DATA-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextImplementationDataElementRef(Ref):
            dest: AbstractImplementationDataTypeElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TargetImplementationDataTypeElementRef(Ref):
        dest: AbstractImplementationDataTypeElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ImplementationElementInParameterInstanceRef:
    """Describes a reference to a particular ImplementationDataTypeElement instance
    in the context of a given ParameterDataPrototype.

    Thus it refers to a particular element in the implementation description of a software data structure.
    Use Case:
    The RTE generator publishes its generated structure of calibration parameters in its BSW module description using the "constantMemory" role of ParameterDataPrototypes. Each ParameterDataPrototype describes a group of single calibration parameters. In order to point to these single parameters, this "instance ref" is needed.
    Note that this class follows the pattern of an InstanceRef but is not implemented based on the abstract classes because the ImplementationDataType isn't either, especially because ImplementationDataTypeElement isn't derived from AtpPrototype.

    :ivar context_ref: The context for the referred element.
    :ivar target_ref: The referred data element.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IMPLEMENTATION-ELEMENT-IN-PARAMETER-INSTANCE-REF"

    context_ref: Optional["ImplementationElementInParameterInstanceRef.ContextRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_ref: Optional["ImplementationElementInParameterInstanceRef.TargetRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRef(Ref):
        dest: ParameterDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRef(Ref):
        dest: AbstractImplementationDataTypeElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class IncludedDataTypeSet:
    """An includedDataTypeSet declares that a set of AutosarDataType is used by a
    basic software module or a software component for its implementation and the
    AutosarDataType becomes part of the contract.

    This information is required if the AutosarDataType is not used for
    any DataPrototype owned by this software component or if the
    enumeration literals, lowerLimit and upperLimit constants shall be
    generated with a literalPrefix. The optional literalPrefix is used
    to add a common prefix on enumeration literals, lowerLimit and
    upperLimit constants created by the RTE.

    :ivar data_type_refs: AutosarDataType belonging to the
        includedDataTypeSet
    :ivar literal_prefix: LiteralPrefix defines a common prefix for all
        AutosarDataTypes of the includedDataTypeSet to be added on
        enumeration literals, lowerLimit and upperLimit constants
        created by the RTE.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INCLUDED-DATA-TYPE-SET"

    data_type_refs: Optional["IncludedDataTypeSet.DataTypeRefs"] = field(
        default=None,
        metadata={
            "name": "DATA-TYPE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    literal_prefix: Identifier | None = field(
        default=None,
        metadata={
            "name": "LITERAL-PREFIX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataTypeRefs:
        data_type_ref: list["IncludedDataTypeSet.DataTypeRefs.DataTypeRef"] = field(
            default_factory=list,
            metadata={
                "name": "DATA-TYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DataTypeRef(Ref):
            dest: AutosarDataTypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class IncludedModeDeclarationGroupSet:
    """
    An IncludedModeDeclarationGroupSet declares that a set of ModeDeclarationGroups
    used by the software component for its implementation and consequently these
    ModeDeclarationGroups become part of the contract.

    :ivar mode_declaration_group_refs: This represents the referenced
        ModeDeclarationGroup.
    :ivar prefix: The prefix shall be used by the RTE generator as a
        prefix for the creation of symbols related to the referenced
        ModeDeclarationGroups, e.g
        RTE_TRANSITION_&lt;ModeDeclarationGroup&gt;.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INCLUDED-MODE-DECLARATION-GROUP-SET"

    mode_declaration_group_refs: Optional[
        "IncludedModeDeclarationGroupSet.ModeDeclarationGroupRefs"
    ] = field(
        default=None,
        metadata={
            "name": "MODE-DECLARATION-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prefix: Identifier | None = field(
        default=None,
        metadata={
            "name": "PREFIX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ModeDeclarationGroupRefs:
        mode_declaration_group_ref: list[
            "IncludedModeDeclarationGroupSet.ModeDeclarationGroupRefs.ModeDeclarationGroupRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ModeDeclarationGroupRef(Ref):
            dest: ModeDeclarationGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class IndexEntry:
    """
    This class represents an index entry.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar content:
    """

    class Meta:
        name = "INDEX-ENTRY"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SUP",
                    "type": ForwardRef("IndexEntry.Sup"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUB",
                    "type": ForwardRef("IndexEntry.Sub"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Sup(Supscript):
        pass

    @dataclass(slots=True, kw_only=True)
    class Sub(Supscript):
        pass


@dataclass(slots=True, kw_only=True)
class IndexedArrayElement:
    """This element represents exactly one indexed element in the array.

    Either the applicationArrayElement or implementationArrayElement
    reference shall be used.

    :ivar application_array_element_ref: Reference to an
        ApplicationArrayElement in an array.
    :ivar implementation_array_element_ref: Reference to an
        ImplementationDataTypeElement in an array.
    :ivar index: Position of an element in an array. Starting position
        is 0.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INDEXED-ARRAY-ELEMENT"

    application_array_element_ref: Optional["IndexedArrayElement.ApplicationArrayElementRef"] = (
        field(
            default=None,
            metadata={
                "name": "APPLICATION-ARRAY-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    implementation_array_element_ref: Optional[
        "IndexedArrayElement.ImplementationArrayElementRef"
    ] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-ARRAY-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    index: Integer | None = field(
        default=None,
        metadata={
            "name": "INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ApplicationArrayElementRef(Ref):
        dest: ApplicationArrayElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationArrayElementRef(Ref):
        dest: ImplementationDataTypeElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class InitialSdDelayConfig:
    """
    This element is used to configure the offer behavior of the server and the find
    behavior on the client.

    :ivar initial_delay_max_value: '''begin restrict to CP''' Max Value
        in seconds to delay randomly the first offer (if aggregated by
        SdServerConfig) or the transmission of a find message (if
        aggregated by SdClientConfig). '''end restrict to CP''' '''begin
        restrict to AP''' Max Value in seconds to delay randomly the
        first offer (if aggregated in role initialOfferBehavior by
        SomeipSdServerServiceInstanceConfig) or the transmission of a
        find message (if aggregated in role initialFindBehavior by
        SomeipSdClientServiceInstanceConfig). '''end restrict to AP'''
    :ivar initial_delay_min_value: '''begin restrict to CP''' Min Value
        in seconds to delay randomly the first offer  or the
        transmission of a find message (if aggregated by
        SdClientConfig). '''end restrict to CP''' '''begin restrict to
        AP''' Min Value in seconds to delay randomly the first offer (if
        aggregated in role initialOfferBehavior by
        SomeipSdServerServiceInstanceConfig) or the transmission of a
        find message  (if aggregated in role initialFindBehavior by
        SomeipSdClientServiceInstanceConfig). '''end restrict to AP'''
    :ivar initial_repetitions_base_delay: '''begin restrict to CP''' The
        base delay for offer repetitions (if aggregated by
        SdServerConfig) or find repetitions (if aggregated by
        SdClientConfig). Successive find messages have an exponential
        back off delay. '''end restrict to CP''' '''begin restrict to
        AP''' The base delay for offer repetitions (if aggregated in
        role initialOfferBehavior by
        SomeipSdServerServiceInstanceConfig) or find repetitions (if
        aggregated in role initialFindBehavior by
        SomeipSdClientServiceInstanceConfig). Successive find messages
        have an exponential back off delay. '''end restrict to AP'''
    :ivar initial_repetitions_max: '''begin restrict to CP''' Describes
        the maximum amount of offer repetitions (if aggregated by
        SdServerConfig) or the maximum amount of find repetitions (if
        aggregated by SdClientConfig). '''end restrict to CP''' '''begin
        restrict to AP''' Describes the maximum amount of offer
        repetitions  (if aggregated in role initialOfferBehavior by
        SomeipSdServerServiceInstanceConfig) or the maximum amount of
        find repetitions (if aggregated in role initialFindBehavior by
        SomeipSdClientServiceInstanceConfig). '''end restrict to AP'''
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INITIAL-SD-DELAY-CONFIG"

    initial_delay_max_value: TimeValue | None = field(
        default=None,
        metadata={
            "name": "INITIAL-DELAY-MAX-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_delay_min_value: TimeValue | None = field(
        default=None,
        metadata={
            "name": "INITIAL-DELAY-MIN-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_repetitions_base_delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "INITIAL-REPETITIONS-BASE-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_repetitions_max: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INITIAL-REPETITIONS-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class InnerPortGroupInCompositionInstanceRef:
    """
    :ivar context_ref:
    :ivar target_ref: Links a PortGroup in a composition to another
        PortGroup, that is defined in a component which is part of this
        CompositionSwComponentType. There shall be at most one
        innerGroup per contained SwComponentPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INNER-PORT-GROUP-IN-COMPOSITION-INSTANCE-REF"

    context_ref: list["InnerPortGroupInCompositionInstanceRef.ContextRef"] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_ref: Optional["InnerPortGroupInCompositionInstanceRef.TargetRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRef(Ref):
        dest: PortGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class InstanceEventInCompositionInstanceRef:
    """
    :ivar context_component_prototype_ref:
    :ivar target_event_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INSTANCE-EVENT-IN-COMPOSITION-INSTANCE-REF"

    context_component_prototype_ref: list[
        "InstanceEventInCompositionInstanceRef.ContextComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_event_ref: Optional["InstanceEventInCompositionInstanceRef.TargetEventRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetEventRef(Ref):
        dest: RteEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class IntegerValueVariationPoint:
    """This class represents an attribute value variation point for Integer
    attributes.

    Note that this class might be used in the extended meta-model only.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar binding_time: This is the binding time in which the attribute
        value needs to be bound. If this attribute is missing, the
        attribute is not a variation point. In particular this means
        that It needs to be a single value according to the type
        specified in the pure model. It is an error if it is still a
        formula.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar sd: This special data is provided to allow synchronization of
        Attribute value variation points with variant management
        systems. The usage is subject of agreement between the involved
        parties.
    :ivar short_label: This allows to identify the variation point. It
        is also intended to allow RTE support for CompileTime Variation
        points.
    :ivar content:
    """

    class Meta:
        name = "INTEGER-VALUE-VARIATION-POINT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    binding_time: BindingTimeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "BINDING-TIME",
            "type": "Attribute",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    sd: str | None = field(
        default=None,
        metadata={
            "name": "SD",
            "type": "Attribute",
        },
    )
    short_label: str | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef("IntegerValueVariationPoint.SyscStringRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("IntegerValueVariationPoint.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class InterpolationRoutine:
    """
    This represents an interpolation routine taken to evaluate the contents of a
    curve or map against a specific input value.

    :ivar short_label: This is the name of the interpolation method
        which is implemented by the referenced bswModuleEntry. It
        corresponds to swInterpolationMethod in SwDataDefProps.
    :ivar is_default: This attribute specifies whether the enclosing
        InterpolationRoutine is considered the default in the context
        (defined by the System Template) of a given collection
        InterpolationRoutineMapping that owns the enclosing
        InterpolationRoutine.
    :ivar interpolation_routine_ref: This specifies a BswModuleEntry
        which implements the current interpolation method for the given
        record layout.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INTERPOLATION-ROUTINE"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_default: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-DEFAULT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    interpolation_routine_ref: Optional["InterpolationRoutine.InterpolationRoutineRef"] = field(
        default=None,
        metadata={
            "name": "INTERPOLATION-ROUTINE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class InterpolationRoutineRef(Ref):
        dest: BswModuleEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class IntervalTypeEnum:
    """
    This enumerator specifies the type of an interval.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INTERVAL-TYPE-ENUM"

    value: IntervalTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class IpAddressKeepEnum:
    """
    Defines the behavior after a dynamic IP address has been assigned.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IP-ADDRESS-KEEP-ENUM"

    value: IpAddressKeepEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class IpTransportProtocolEnum:
    """
    Transport Layer protocols in the Internet protocol suite.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IP-TRANSPORT-PROTOCOL-ENUM"

    value: IpTransportProtocolEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Ipv4AddressSourceEnum:
    """
    Defines how the node obtains its IPv4-Address.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-4-ADDRESS-SOURCE-ENUM"

    value: Ipv4AddressSourceEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Ipv4ArpProps:
    """
    Specifies the configuration options for the ARP (Address Resolution Protocol).

    :ivar tcp_ip_arp_num_gratuitous_arp_on_startup: This attribute
        specifies the number of gratuitous ARP replies which shall be
        sent on assignment of a new IP address.
    :ivar tcp_ip_arp_packet_queue_enabled: This attribute enables (TRUE)
        or disables (FALSE) support of the ARP Packet Queue according to
        IETF RFC 1122, section 2.3.2.2.
    :ivar tcp_ip_arp_request_timeout: This attribute specifies a timeout
        in seconds for the validity of ARP requests. After the
        transmission of an ARP request the TcpIp shall skip the
        transmission of any further ARP requests to the same destination
        within a duration of tcpIpArpRequestTimeout seconds. (IETF RFC
        1122, section 2.3.2.1).
    :ivar tcp_ip_arp_table_entry_timeout: This attribute specifies the
        timeout in seconds after which an unused ARP entry is removed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-4-ARP-PROPS"

    tcp_ip_arp_num_gratuitous_arp_on_startup: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-ARP-NUM-GRATUITOUS-ARP-ON-STARTUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_arp_packet_queue_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-ARP-PACKET-QUEUE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_arp_request_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-ARP-REQUEST-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_arp_table_entry_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-ARP-TABLE-ENTRY-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Ipv4AutoIpProps:
    """
    Specifies the configuration options for Auto-IP (automatic private IP
    addressing).

    :ivar tcp_ip_auto_ip_init_timeout: This attribute specifies the
        time in seconds Auto-IP waits at startup, before beginning with
        ARP probing. This delay is used to give DHCP time to acquire a
        lease in case a DHCP server is present.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-4-AUTO-IP-PROPS"

    tcp_ip_auto_ip_init_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-AUTO-IP-INIT-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Ipv4FragmentationProps:
    """
    Specifies the configuration options for IPv4 packet fragmentation/reassembly.

    :ivar tcp_ip_ip_fragmentation_rx_enabled: Enables (TRUE) or disables
        (FALSE) support for reassembling of incoming datagrams that are
        fragmented according to IETF RFC 815 (IP Datagram Reassembly
        Algorithms).
    :ivar tcp_ip_ip_num_fragments: Specifies the maximum number of IP
        fragments per datagram.
    :ivar tcp_ip_ip_num_reass_dgrams: Specifies the maximum number of
        fragmented IP datagrams that can be reassembled in parallel.
    :ivar tcp_ip_ip_reass_timeout: Specifies the timeout in [s] after
        which an incomplete datagram gets discarded.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-4-FRAGMENTATION-PROPS"

    tcp_ip_ip_fragmentation_rx_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-IP-FRAGMENTATION-RX-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ip_num_fragments: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-IP-NUM-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ip_num_reass_dgrams: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-IP-NUM-REASS-DGRAMS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ip_reass_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-IP-REASS-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Ipv6AddressSourceEnum:
    """
    Defines how the node obtains its IPv6-Address.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-6-ADDRESS-SOURCE-ENUM"

    value: Ipv6AddressSourceEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Ipv6FragmentationProps:
    """
    This meta-class specifies the configuration options for IPv6 packet
    fragmentation/reassembly.

    :ivar tcp_ip_ip_reassembly_buffer_count: Number of buffers that can
        be used for fragment reassembly. In case of a reassembly error
        or if not all fragments are received in time this buffer will be
        blocked until the specified "Fragment Reassembly Timeout" has
        been exceeded. A value of 0 disables fragment reassembly.
    :ivar tcp_ip_ip_reassembly_buffer_size: Size of each fragment tx
        buffer in bytes.
    :ivar tcp_ip_ip_reassembly_segment_count: Specifies the maximum
        number of consecutive data segments that can be managed in each
        reassembly buffer. If all fragments are received in order, only
        one segment will be needed. To deal with fragments received out
        of order this value should be configured bigger than 1.
    :ivar tcp_ip_ip_reassembly_timeout: Specifies the timeout in seconds
        after which an incomplete datagram gets discarded.
    :ivar tcp_ip_ip_tx_fragment_buffer_count: These buffers will be used
        if the IpV6 receives packets from the upper layer that do not
        fit into the MTU and thus must be fragmented. A value of 0
        disables tx fragmentation.
    :ivar tcp_ip_ip_tx_fragment_buffer_size: Size of each fragment tx
        buffer in bytes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-6-FRAGMENTATION-PROPS"

    tcp_ip_ip_reassembly_buffer_count: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-IP-REASSEMBLY-BUFFER-COUNT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ip_reassembly_buffer_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-IP-REASSEMBLY-BUFFER-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ip_reassembly_segment_count: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-IP-REASSEMBLY-SEGMENT-COUNT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ip_reassembly_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-IP-REASSEMBLY-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ip_tx_fragment_buffer_count: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-IP-TX-FRAGMENT-BUFFER-COUNT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ip_tx_fragment_buffer_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-IP-TX-FRAGMENT-BUFFER-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Ipv6NdpProps:
    """
    This meta-class specifies the configuration options for the Neighbor Discovery
    Protocol for IPv6.

    :ivar tcp_ip_ndp_default_reachable_time: Configuration of the
        ReachableTime (s) specified in [RFC4861 6.3.2. Host Variables].
    :ivar tcp_ip_ndp_default_retrans_timer: Configures the default value
        (s) for the RetransTimer variable specified in [RFC4861 6.3.2.
        Host Variables].
    :ivar tcp_ip_ndp_default_router_list_size: Maximum number of default
        router entries.
    :ivar tcp_ip_ndp_defensive_processing: If enabled the NDP shall only
        process Neighbor Advertisements which are received in reaction
        to a previously transmitted Neighbor Solicitation as well as
        skipping updates to the Neighbor Cache based on received
        Neighbor Solicitations. If disabled all Neighbor Advertisements
        and Solicitations shall be processed as specified in RFC4861.
    :ivar tcp_ip_ndp_delay_first_probe_time: Delay before sending the
        first NUD probe in (s).
    :ivar tcp_ip_ndp_destination_cache_size: Maximum number of entries
        in the destination cache.
    :ivar tcp_ip_ndp_dynamic_hop_limit_enabled: If enabled the default
        hop limit may be reconfigured based on received Router
        Advertisements.
    :ivar tcp_ip_ndp_dynamic_mtu_enabled: Allow dynamic reconfiguration
        of link MTU via Router Advertisements.
    :ivar tcp_ip_ndp_dynamic_reachable_time_enabled: If enabled the
        default Reachable Time value may be reconfigured based on
        received Router Advertisements.
    :ivar tcp_ip_ndp_dynamic_retrans_time_enabled: If enabled the
        default Retransmit Timer value may be reconfigured based on
        received Router Advertisements.
    :ivar tcp_ip_ndp_max_random_factor: Maximum random factor used for
        randomization
    :ivar tcp_ip_ndp_max_rtr_solicitation_delay: Maximum delay before
        the first Router Solicitation will be sent after interface
        initialization in (s).
    :ivar tcp_ip_ndp_max_rtr_solicitations: Maximum number of Router
        Solicitations that will be sent before the first Router
        Advertisement has been received.
    :ivar tcp_ip_ndp_min_random_factor: Minimum random factor used for
        randomization
    :ivar tcp_ip_ndp_neighbor_unreachability_detection_enabled: Neighbor
        Unreachability Detection is used to remove unused entries from
        the neighbor cache. This feature is a basic feature of NDP and
        should be turned on.
    :ivar tcp_ip_ndp_num_multicast_solicitations: Maximum number of
        multicast solicitations that will be sent when performing
        address resolution.
    :ivar tcp_ip_ndp_num_unicast_solicitations: Maximum number of
        unicast solicitations that will be sent when performig Neighbor
        Unreachability Detection.
    :ivar tcp_ip_ndp_packet_queue_enabled: Enables (TRUE) or disables
        (FALSE) support of a NDP Packet Queue according to IETF RFC
        4861, section 7.2.2.
    :ivar tcp_ip_ndp_prefix_list_size: Maximum number of entries in the
        on-link prefix list.
    :ivar tcp_ip_ndp_random_reachable_time_enabled: If enabled the value
        of ReachableTime will be multiplied with a random value between
        MIN_RANDOM_FACTOR and MAX_RANDOM_FACTOR in order to prevent
        multiple nodes from transmitting at exactly the same time.
    :ivar tcp_ip_ndp_rnd_rtr_solicitation_delay_enabled: If enabled the
        first router solicitation will be delayed randomly from
        [0...MAX_RTR_SOLICITATION_DELAY]. Otherwise the first router
        solicitation will be sent after exactly
        MAX_RTR_SOLICITATION_DELAY milliseconds.
    :ivar tcp_ip_ndp_rtr_solicitation_interval: Interval between
        consecutive Router Solicitations in (s).
    :ivar tcp_ip_ndp_slaac_dad_number_of_transmissions: Number of
        Neighbor Solicitations that have to be unanswered in order to
        set an autoconfigurated address to PREFERRED (usable) state.
    :ivar tcp_ip_ndp_slaac_dad_retransmission_delay: Sets the maximum
        value for the address configuration delay (s).
    :ivar tcp_ip_ndp_slaac_delay_enabled: If enabled transmission of the
        first DAD Neighbor Solicitation will be delayed by a random
        value from [0...MAX_DAD_DELAY].
    :ivar tcp_ip_ndp_slaac_optimistic_dad_enabled: Enable Optimistic
        Duplicate Address Detection (DAD) according to RFC4429.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-6-NDP-PROPS"

    tcp_ip_ndp_default_reachable_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-DEFAULT-REACHABLE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_default_retrans_timer: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-DEFAULT-RETRANS-TIMER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_default_router_list_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-DEFAULT-ROUTER-LIST-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_defensive_processing: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-DEFENSIVE-PROCESSING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_delay_first_probe_time: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-DELAY-FIRST-PROBE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_destination_cache_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-DESTINATION-CACHE-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_dynamic_hop_limit_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-DYNAMIC-HOP-LIMIT-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_dynamic_mtu_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-DYNAMIC-MTU-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_dynamic_reachable_time_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-DYNAMIC-REACHABLE-TIME-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_dynamic_retrans_time_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-DYNAMIC-RETRANS-TIME-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_max_random_factor: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-MAX-RANDOM-FACTOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_max_rtr_solicitation_delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-MAX-RTR-SOLICITATION-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_max_rtr_solicitations: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-MAX-RTR-SOLICITATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_min_random_factor: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-MIN-RANDOM-FACTOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_neighbor_unreachability_detection_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-NEIGHBOR-UNREACHABILITY-DETECTION-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_num_multicast_solicitations: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-NUM-MULTICAST-SOLICITATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_num_unicast_solicitations: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-NUM-UNICAST-SOLICITATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_packet_queue_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-PACKET-QUEUE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_prefix_list_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-PREFIX-LIST-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_random_reachable_time_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-RANDOM-REACHABLE-TIME-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_rnd_rtr_solicitation_delay_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-RND-RTR-SOLICITATION-DELAY-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_rtr_solicitation_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-RTR-SOLICITATION-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_slaac_dad_number_of_transmissions: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-SLAAC-DAD-NUMBER-OF-TRANSMISSIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_slaac_dad_retransmission_delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-SLAAC-DAD-RETRANSMISSION-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_slaac_delay_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-SLAAC-DELAY-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_ndp_slaac_optimistic_dad_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-NDP-SLAAC-OPTIMISTIC-DAD-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ItemLabelPosEnum:
    """
    This enumerator specifies, how the label of a labeled list shall be rendered.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ITEM-LABEL-POS-ENUM"

    value: ItemLabelPosEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class J1939ControllerApplicationToJ1939NmNodeMapping:
    """This meta-class represents the ability to map a J1939ControllerApplication
    to a J1939NmNode.

    Note that this is similar but not identical to the mapping of
    SwComponentPrototypes to EcuInstances; for J1939 the semantics of an
    EcuInstance itself is basically replaced by a J1939NmNode.

    :ivar j_1939_controller_application_ref: Reference to the J1939
        Controller Application that is mapped to the referenced
        J1939NmNode.
    :ivar j_1939_nm_node_ref: J1939NmNode that is the target of the
        J1939ControllerApplicationTo1939NmNodeMapping.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-CONTROLLER-APPLICATION-TO-J-1939-NM-NODE-MAPPING"

    j_1939_controller_application_ref: Optional[
        "J1939ControllerApplicationToJ1939NmNodeMapping.J1939ControllerApplicationRef"
    ] = field(
        default=None,
        metadata={
            "name": "J-1939-CONTROLLER-APPLICATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    j_1939_nm_node_ref: Optional[
        "J1939ControllerApplicationToJ1939NmNodeMapping.J1939NmNodeRef"
    ] = field(
        default=None,
        metadata={
            "name": "J-1939-NM-NODE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class J1939ControllerApplicationRef(Ref):
        dest: J1939ControllerApplicationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class J1939NmNodeRef(Ref):
        dest: J1939NmNodeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class J1939NodeName:
    """
    This element contains attributes to configure the J1939NmNode NAME.

    :ivar arbitrary_address_capable: Arbitrary Address Capable field of
        the NAME of this node.
    :ivar ecu_instance: ECU Instance field of the NAME of this node.
    :ivar function: Function field of the NAME of this node.
    :ivar function_instance: Function Instance field of the NAME of this
        node.
    :ivar identitiy_number: Identity Number field of the NAME of this
        node.
    :ivar industry_group: Industry Group field of the NAME of this node.
    :ivar manufacturer_code: Manufacturer Code field of the NAME of this
        node.
    :ivar vehicle_system: Vehicle System field of the NAME of this node.
    :ivar vehicle_system_instance: Vehicle System Instance field of the
        NAME of this node.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-NODE-NAME"

    arbitrary_address_capable: Boolean | None = field(
        default=None,
        metadata={
            "name": "ARBITRARY-ADDRESS-CAPABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance: Integer | None = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    function: Integer | None = field(
        default=None,
        metadata={
            "name": "FUNCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    function_instance: Integer | None = field(
        default=None,
        metadata={
            "name": "FUNCTION-INSTANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    identitiy_number: Integer | None = field(
        default=None,
        metadata={
            "name": "IDENTITIY-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    industry_group: Integer | None = field(
        default=None,
        metadata={
            "name": "INDUSTRY-GROUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    manufacturer_code: Integer | None = field(
        default=None,
        metadata={
            "name": "MANUFACTURER-CODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vehicle_system: Integer | None = field(
        default=None,
        metadata={
            "name": "VEHICLE-SYSTEM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vehicle_system_instance: Integer | None = field(
        default=None,
        metadata={
            "name": "VEHICLE-SYSTEM-INSTANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class J1939TpPg:
    """
    A J1939TpPg represents one J1939 message (parameter group, PG) identified by
    the PGN (parameter group number) that can be received or transmitted via
    J1939Tp.

    :ivar direct_pdu_ref: In case of variable length IPdus (with system
        signals of variable length), an additional NPdu (with the PGN in
        the CAN ID) is used for messages with up to 8 bytes.
    :ivar pgn: Parameter group number (PGN) of a J1939 message
        (parameter group, PG) that can be received or transmitted via
        J1939Tp. The PGN may be omitted when the a directPdu is
        referenced and is mapped into a CanFrameTriggering with an
        identifier.
    :ivar requestable: Parameter Group can be triggered by the J1939
        request message.
    :ivar sdu_refs: Reference to IPdus that are segmented by the
        Transport Protocol. If more than one IPdu is referenced, the
        IPdus are used when the same PGN is received in parallel via
        different transport protocols (BAM, CMDT, direct) on the same
        J1939TpConnection.
    :ivar tp_sdu_ref: Reference to IPdus that are segmented by the
        Transport Protocol. To support the low-level routing of NPdu's
        the NPdu is a specialization of an IPdu. More details can be
        found in the NPdu class description. Nevertheless the
        J1939TpConnection must not reference a NPdu with this tpSdu
        reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-TP-PG"

    direct_pdu_ref: Optional["J1939TpPg.DirectPduRef"] = field(
        default=None,
        metadata={
            "name": "DIRECT-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pgn: Integer | None = field(
        default=None,
        metadata={
            "name": "PGN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requestable: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUESTABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdu_refs: Optional["J1939TpPg.SduRefs"] = field(
        default=None,
        metadata={
            "name": "SDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_sdu_ref: Optional["J1939TpPg.TpSduRef"] = field(
        default=None,
        metadata={
            "name": "TP-SDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DirectPduRef(Ref):
        dest: NPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SduRefs:
        sdu_ref: list["J1939TpPg.SduRefs.SduRef"] = field(
            default_factory=list,
            metadata={
                "name": "SDU-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SduRef(Ref):
            dest: IPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TpSduRef(Ref):
        dest: IPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class KeepWithPreviousEnum:
    """
    This enumerator specifies a page break policy by controlling blocks which shall
    be kept together.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "KEEP-WITH-PREVIOUS-ENUM"

    value: KeepWithPreviousEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class KeyUsageRestrictionEnum:
    """
    Defines how the Key is used.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "KEY-USAGE-RESTRICTION-ENUM"

    value: KeyUsageRestrictionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class LEnum:
    """
    This denotes the possible language designators according to the two letter code
    of ISO 639.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "L-ENUM"

    value: LEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class LPlainText:
    """This represents plain string in one particular language.

    The language is denoted in the attribute l.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar l: 'This attribute denotes the language in which the language
        specific document entity is given. Note that "FOR-ALL" means,
        that the entity is applicable to all languages. It is language
        neutral. It follows ISO 639-1:2002 and is specified in upper
        case.
    :ivar space: This attribute is used to signal an intention that in
        that element, white space should be preserved by applications.
        It is defined according to xml:space as declared by W3C.
    :ivar content:
    """

    class Meta:
        name = "L-PLAIN-TEXT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    l: LEnumSimple = field(
        metadata={
            "name": "L",
            "type": "Attribute",
            "required": True,
        }
    )
    space: str = field(
        metadata={
            "type": "Attribute",
            "namespace": "http://www.w3.org/XML/1998/namespace",
            "required": True,
        }
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
        },
    )


@dataclass(slots=True, kw_only=True)
class LatencyConstraintTypeEnum:
    """
    This is used to describe the type of the latency timing constraint.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LATENCY-CONSTRAINT-TYPE-ENUM"

    value: LatencyConstraintTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class LifeCyclePeriod:
    """
    This meta class represents the ability to specify a point of time within a
    specified period, e.g. the starting or end point, in which a specific life
    cycle state is valid/applies to.

    :ivar date: Date within period.
    :ivar ar_release_version: Version of the AUTOSAR Release the element
        referred to is part of. The numbering contains three levels
        (major, minor, revision) which are defined by AUTOSAR.
    :ivar product_release: Version of the product within the period.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIFE-CYCLE-PERIOD"

    date: Date | None = field(
        default=None,
        metadata={
            "name": "DATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ar_release_version: RevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "AR-RELEASE-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    product_release: RevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "PRODUCT-RELEASE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Limit:
    """This class represents the ability to express a numerical limit.

    Note that this is in fact a NumericalValuationPoint but has the
    additional attribute intervalType. Note that the xml.name is "LIMIT"
    for backward compatibility reasons.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar binding_time: This is the binding time in which the attribute
        value needs to be bound. If this attribute is missing, the
        attribute is not a variation point. In particular this means
        that It needs to be a single value according to the type
        specified in the pure model. It is an error if it is still a
        formula.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar sd: This special data is provided to allow synchronization of
        Attribute value variation points with variant management
        systems. The usage is subject of agreement between the involved
        parties.
    :ivar short_label: This allows to identify the variation point. It
        is also intended to allow RTE support for CompileTime Variation
        points.
    :ivar interval_type: This specifies the type of the interval. If the
        attribute is missing the interval shall be considered as
        "CLOSED".
    :ivar content:
    """

    class Meta:
        name = "LIMIT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    binding_time: BindingTimeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "BINDING-TIME",
            "type": "Attribute",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    sd: str | None = field(
        default=None,
        metadata={
            "name": "SD",
            "type": "Attribute",
        },
    )
    short_label: str | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    interval_type: IntervalTypeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "INTERVAL-TYPE",
            "type": "Attribute",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef("Limit.SyscStringRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("Limit.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class LimitValue:
    """This class represents the ability to express a numerical limit.

    Note that this is in fact a NumericalVariationPoint but has the
    additional attribute intervalType.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar interval_type: This specifies the type of the interval. If the
        attribute is missing the interval shall be considered as
        "CLOSED".
    """

    class Meta:
        name = "LIMIT-VALUE"

    value: str = field(
        default="",
        metadata={
            "required": True,
            "pattern": r"(0[xX][0-9a-fA-F]+)|(0[0-7]+)|(0[bB][0-1]+)|(([+\-]?[1-9][0-9]+(\.[0-9]+)?|[+\-]?[0-9](\.[0-9]+)?)([eE]([+\-]?)[0-9]+)?)|\.0|INF|-INF|NaN",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    interval_type: IntervalTypeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "INTERVAL-TYPE",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class LinChecksumType:
    """
    Use of classic or enhanced checksum is managed by the master node and it is
    determined per frame identifier;

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-CHECKSUM-TYPE"

    value: LinChecksumTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class LinConfigurableFrame:
    """Assignment of messageIds to Frames.

    This element shall be used for the LIN 2.0 Assign-Frame command.

    :ivar frame_ref: Reference to a Frame that is processed by the slave
        node.
    :ivar message_id: MessageId for the referenced frame
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-CONFIGURABLE-FRAME"

    frame_ref: Optional["LinConfigurableFrame.FrameRef"] = field(
        default=None,
        metadata={
            "name": "FRAME-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    message_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MESSAGE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FrameRef(Ref):
        dest: LinFrameSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class LinErrorResponse:
    """Each slave node shall publish a one bit signal, named response_error, to the
    master node in one of its transmitted unconditional frames.

    The response_error signal shall be set whenever a frame (except for
    event triggered frame responses) that is transmitted or received by
    the slave node contains an error in the frame response. The
    response_error signal shall be cleared when the unconditional frame
    containing the response_error signal is successfully transmitted.

    :ivar frame_triggering_ref: Reference to an unconditional frame
        that transmits the response error. The referenced
        LinFrameTriggering shall contain a reference to an
        unconditionalFrame.
    :ivar response_error_position: Specifies the position of the
        ResponseError bit in the frame. Each slave node shall publish
        one response error in one of its transmitted unconditional
        frames.
    :ivar response_error_ref: This ISignal shall be taken to transport
        the responseError bit.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-ERROR-RESPONSE"

    frame_triggering_ref: Optional["LinErrorResponse.FrameTriggeringRef"] = field(
        default=None,
        metadata={
            "name": "FRAME-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    response_error_position: Integer | None = field(
        default=None,
        metadata={
            "name": "RESPONSE-ERROR-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    response_error_ref: Optional["LinErrorResponse.ResponseErrorRef"] = field(
        default=None,
        metadata={
            "name": "RESPONSE-ERROR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FrameTriggeringRef(Ref):
        dest: LinFrameTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ResponseErrorRef(Ref):
        dest: ISignalTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class LinOrderedConfigurableFrame:
    """With the assignment of the index to a frame a mapping of Pids to Frames is
    possible.

    This element shall be used for the LIN 2.1 Assign-Frame-PID-Range
    command.

    :ivar frame_ref: Reference to a Frame that is processed by the slave
        node.
    :ivar index: This attribute is used to order the elements and allows
        an assignment of Pids to ConfigurableFrames that are defined in
        the slave.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-ORDERED-CONFIGURABLE-FRAME"

    frame_ref: Optional["LinOrderedConfigurableFrame.FrameRef"] = field(
        default=None,
        metadata={
            "name": "FRAME-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    index: Integer | None = field(
        default=None,
        metadata={
            "name": "INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FrameRef(Ref):
        dest: LinFrameSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ListEnum:
    """
    This meta-class represents the notation of the various types of lists.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIST-ENUM"

    value: ListEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class LogTraceDefaultLogLevelEnum:
    """
    This enum defines available log&amp;trace log levels that may be used to define
    the severity level of a log message.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LOG-TRACE-DEFAULT-LOG-LEVEL-ENUM"

    value: LogTraceDefaultLogLevelEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MacMulticastConfiguration:
    """
    References a per cluster globally defined MAC-Multicast-Group.

    :ivar mac_multicast_group_ref: Reference to a macMulticastGroup.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAC-MULTICAST-CONFIGURATION"

    mac_multicast_group_ref: Optional["MacMulticastConfiguration.MacMulticastGroupRef"] = field(
        default=None,
        metadata={
            "name": "MAC-MULTICAST-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class MacMulticastGroupRef(Ref):
        dest: MacMulticastGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class MacSecCapabilityEnum:
    """
    This enum defines the MACsec capability options.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAC-SEC-CAPABILITY-ENUM"

    value: MacSecCapabilityEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MacSecCipherSuiteConfig:
    """This meta-class defines the cipher suite configuration to use with MACsec.

    cipherSuitePriority is present in case the MKA instance acts as a
    Key Server to select the cipher suite to use for MACsec.

    :ivar cipher_suite: Cipher Suite to use for MACsec.
    :ivar cipher_suite_priority: In case the MKA instance acts as a Key
        Server, the priority is used to select the Cipher Suite to use
        with MACsec from the supported Ciphers.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAC-SEC-CIPHER-SUITE-CONFIG"

    cipher_suite: String | None = field(
        default=None,
        metadata={
            "name": "CIPHER-SUITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cipher_suite_priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CIPHER-SUITE-PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MacSecConfidentialityOffsetEnum:
    """
    This enum defines the MACsec capability options.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAC-SEC-CONFIDENTIALITY-OFFSET-ENUM"

    value: MacSecConfidentialityOffsetEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MacSecFailPermissiveModeEnum:
    """
    Behavior options of the Port Access Entity in case MACsec does not succeed.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAC-SEC-FAIL-PERMISSIVE-MODE-ENUM"

    value: MacSecFailPermissiveModeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MacSecRoleEnum:
    """
    This enum defines the MACsec Role options.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAC-SEC-ROLE-ENUM"

    value: MacSecRoleEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MappingDirectionEnum:
    """
    Specifies the conversion direction for which the mapping is applicable.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAPPING-DIRECTION-ENUM"

    value: MappingDirectionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MappingScopeEnum:
    """
    Defines the scope for the mapping constraints.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAPPING-SCOPE-ENUM"

    value: MappingScopeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MaxCommModeEnum:
    """
    Maximum bus communication mode required by a user of the Communication Manager
    Service.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAX-COMM-MODE-ENUM"

    value: MaxCommModeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MaximumMessageLengthType:
    """
    Type of Acknowledgement.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAXIMUM-MESSAGE-LENGTH-TYPE"

    value: MaximumMessageLengthTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class McParameterElementGroup:
    """
    Denotes a group of calibration parameters which are handled by the RTE as one
    data structure.

    :ivar short_label: Assigns a name to this element.
    :ivar ram_location_ref: Refers to the RAM location of this parameter
        group. To be used for the init-RAM method.
    :ivar rom_location_ref: Refers to the ROM location of this parameter
        group. To be used for the init-RAM method.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MC-PARAMETER-ELEMENT-GROUP"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ram_location_ref: Optional["McParameterElementGroup.RamLocationRef"] = field(
        default=None,
        metadata={
            "name": "RAM-LOCATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rom_location_ref: Optional["McParameterElementGroup.RomLocationRef"] = field(
        default=None,
        metadata={
            "name": "ROM-LOCATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class RamLocationRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RomLocationRef(Ref):
        dest: ParameterDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class MemoryAllocationKeywordPolicyType:
    """
    Enumeration to specify the name pattern of the Memory Allocation Keyword.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MEMORY-ALLOCATION-KEYWORD-POLICY-TYPE"

    value: MemoryAllocationKeywordPolicyTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MemorySectionLocation:
    """
    Specifies in which hardware ProvidedMemorySegment the softwareMemorySection is
    located.

    :ivar provided_memory_ref: Reference to the hardware
        ProvidedMemorySegment.
    :ivar software_memory_section_ref: Reference to the MemorySection
        which is mapped on a certain hardware memory segment.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MEMORY-SECTION-LOCATION"

    provided_memory_ref: Optional["MemorySectionLocation.ProvidedMemoryRef"] = field(
        default=None,
        metadata={
            "name": "PROVIDED-MEMORY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_memory_section_ref: Optional["MemorySectionLocation.SoftwareMemorySectionRef"] = field(
        default=None,
        metadata={
            "name": "SOFTWARE-MEMORY-SECTION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ProvidedMemoryRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SoftwareMemorySectionRef(Ref):
        dest: MemorySectionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class MemorySectionType:
    """
    Enumeration to specify the essential nature of the data which can be allocated
    in a common memory class by the means of the AUTOSAR Memory Mapping.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MEMORY-SECTION-TYPE"

    value: MemorySectionTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ModeActivationKind:
    """
    Kind of mode switch condition used for activation of an event, as further
    described for each enumeration field.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-ACTIVATION-KIND"

    value: ModeActivationKindSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ModeDeclarationGroupPrototypeInExecutableInstanceRef:
    """
    :ivar context_root_sw_component_prototype_ref:
    :ivar sw_component_prototype_ref:
    :ivar context_port_prototype_ref:
    :ivar target_mode_declaration_group_prototype_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-DECLARATION-GROUP-PROTOTYPE-IN-EXECUTABLE-INSTANCE-REF"

    context_root_sw_component_prototype_ref: Optional[
        "ModeDeclarationGroupPrototypeInExecutableInstanceRef.ContextRootSwComponentPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ROOT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_prototype_ref: list[
        "ModeDeclarationGroupPrototypeInExecutableInstanceRef.SwComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_port_prototype_ref: Optional[
        "ModeDeclarationGroupPrototypeInExecutableInstanceRef.ContextPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_mode_declaration_group_prototype_ref: Optional[
        "ModeDeclarationGroupPrototypeInExecutableInstanceRef.TargetModeDeclarationGroupPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-MODE-DECLARATION-GROUP-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRootSwComponentPrototypeRef(Ref):
        dest: RootSwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SwComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextPortPrototypeRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetModeDeclarationGroupPrototypeRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeDeclarationGroupPrototypeInSystemInstanceRef:
    """
    :ivar context_composition_ref:
    :ivar context_component_ref:
    :ivar context_port_ref:
    :ivar target_mode_declaration_group_prototype_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-DECLARATION-GROUP-PROTOTYPE-IN-SYSTEM-INSTANCE-REF"

    context_composition_ref: Optional[
        "ModeDeclarationGroupPrototypeInSystemInstanceRef.ContextCompositionRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-COMPOSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_ref: list[
        "ModeDeclarationGroupPrototypeInSystemInstanceRef.ContextComponentRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_port_ref: Optional[
        "ModeDeclarationGroupPrototypeInSystemInstanceRef.ContextPortRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_mode_declaration_group_prototype_ref: Optional[
        "ModeDeclarationGroupPrototypeInSystemInstanceRef.TargetModeDeclarationGroupPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-MODE-DECLARATION-GROUP-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextCompositionRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextPortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetModeDeclarationGroupPrototypeRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeDeclarationGroupPrototypeMapping:
    """
    Defines the mapping of two particular ModeDeclarationGroupPrototypes (in the
    given context) that are unequally named and/or require a reference to a
    ModeDeclarationMappingSet in order to become compatible by definition of
    ModeDeclarationMappings.

    :ivar first_mode_group_ref: ModeDeclarationGroupPrototype to be
        mapped.
    :ivar mode_declaration_mapping_set_ref: This represents the
        available mappings of ModeDeclarations in the context ot this
        ModeDeclarationGroupPrototype.
    :ivar second_mode_group_ref: ModeDeclarationGroupPrototype to be
        mapped.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-DECLARATION-GROUP-PROTOTYPE-MAPPING"

    first_mode_group_ref: Optional["ModeDeclarationGroupPrototypeMapping.FirstModeGroupRef"] = (
        field(
            default=None,
            metadata={
                "name": "FIRST-MODE-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    mode_declaration_mapping_set_ref: Optional[
        "ModeDeclarationGroupPrototypeMapping.ModeDeclarationMappingSetRef"
    ] = field(
        default=None,
        metadata={
            "name": "MODE-DECLARATION-MAPPING-SET-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    second_mode_group_ref: Optional["ModeDeclarationGroupPrototypeMapping.SecondModeGroupRef"] = (
        field(
            default=None,
            metadata={
                "name": "SECOND-MODE-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FirstModeGroupRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ModeDeclarationMappingSetRef(Ref):
        dest: ModeDeclarationMappingSetSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecondModeGroupRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeDeclarationInStateManagementStateNotificationInstanceRef:
    """
    :ivar context_mode_declaration_group_prototype_ref:
    :ivar target_mode_declaration_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-DECLARATION-IN-STATE-MANAGEMENT-STATE-NOTIFICATION-INSTANCE-REF"

    context_mode_declaration_group_prototype_ref: Optional[
        "ModeDeclarationInStateManagementStateNotificationInstanceRef.ContextModeDeclarationGroupPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-MODE-DECLARATION-GROUP-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_mode_declaration_ref: Optional[
        "ModeDeclarationInStateManagementStateNotificationInstanceRef.TargetModeDeclarationRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-MODE-DECLARATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextModeDeclarationGroupPrototypeRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetModeDeclarationRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeDrivenTransmissionModeCondition:
    """The condition defined by this class evaluates to true if one of the
    referenced modeDeclarations (OR associated) is active.

    All referenced modeDeclarations shall be from the same
    ModeDeclarationGroup. The condition is used to define which
    TransmissionMode shall be activated using Com_SwitchIpduTxMode.

    :ivar mode_declaration_refs: Reference to one modeDeclaration which
        is OR associated in the context of the
        ModeDrivenTransmissionModeCondition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-DRIVEN-TRANSMISSION-MODE-CONDITION"

    mode_declaration_refs: Optional["ModeDrivenTransmissionModeCondition.ModeDeclarationRefs"] = (
        field(
            default=None,
            metadata={
                "name": "MODE-DECLARATION-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ModeDeclarationRefs:
        mode_declaration_ref: list[
            "ModeDrivenTransmissionModeCondition.ModeDeclarationRefs.ModeDeclarationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ModeDeclarationRef(Ref):
            dest: ModeDeclarationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class ModeErrorReactionPolicyEnum:
    """
    This represents the ability to specify the reaction on a mode error.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-ERROR-REACTION-POLICY-ENUM"

    value: ModeErrorReactionPolicyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ModeInBswInstanceRef:
    """
    Instance reference to be capable of referencing a specific ModeDeclaration of a
    ModeDeclarationGroupPrototype utilized in a BSW module.

    :ivar context_bsw_implementation_ref: Specifies the BSW
        implementation that manifests the context.
    :ivar context_mode_declaration_group_prototype_ref: Specifies the
        mode declaration group prototype that manifests the context.
    :ivar target_mode_declaration_ref: Specifies the specific mode
        declaration in the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-IN-BSW-INSTANCE-REF"

    context_bsw_implementation_ref: Optional["ModeInBswInstanceRef.ContextBswImplementationRef"] = (
        field(
            default=None,
            metadata={
                "name": "CONTEXT-BSW-IMPLEMENTATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    context_mode_declaration_group_prototype_ref: Optional[
        "ModeInBswInstanceRef.ContextModeDeclarationGroupPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-MODE-DECLARATION-GROUP-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_mode_declaration_ref: Optional["ModeInBswInstanceRef.TargetModeDeclarationRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-MODE-DECLARATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextBswImplementationRef(Ref):
        dest: BswImplementationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextModeDeclarationGroupPrototypeRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetModeDeclarationRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeInBswModuleDescriptionInstanceRef:
    """
    :ivar context_mode_declaration_group_ref:
    :ivar target_mode_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-IN-BSW-MODULE-DESCRIPTION-INSTANCE-REF"

    context_mode_declaration_group_ref: Optional[
        "ModeInBswModuleDescriptionInstanceRef.ContextModeDeclarationGroupRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-MODE-DECLARATION-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_mode_ref: Optional["ModeInBswModuleDescriptionInstanceRef.TargetModeRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-MODE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextModeDeclarationGroupRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetModeRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeInProcessInstanceRef:
    """
    :ivar context_mode_declaration_group_prototype_ref:
    :ivar target_mode_declaration_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-IN-PROCESS-INSTANCE-REF"

    context_mode_declaration_group_prototype_ref: Optional[
        "ModeInProcessInstanceRef.ContextModeDeclarationGroupPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-MODE-DECLARATION-GROUP-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_mode_declaration_ref: Optional["ModeInProcessInstanceRef.TargetModeDeclarationRef"] = (
        field(
            default=None,
            metadata={
                "name": "TARGET-MODE-DECLARATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextModeDeclarationGroupPrototypeRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetModeDeclarationRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeInSwcInstanceRef:
    """
    Instance reference to be capable of referencing a ModeDeclaration at a specific
    Mode Switch Port of a SW-C.

    :ivar context_component_ref: Specifies the SW component prototype
        representing the context.
    :ivar context_port_ref: Specifies the port prototype representing
        the context.
    :ivar context_mode_declaration_group_prototype_ref: Specifies the
        mode declaration group prototype that manifests the context.
    :ivar target_mode_declaration_ref: Specifies the specific mode
        declaration in the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-IN-SWC-INSTANCE-REF"

    context_component_ref: list["ModeInSwcInstanceRef.ContextComponentRef"] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_port_ref: Optional["ModeInSwcInstanceRef.ContextPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_mode_declaration_group_prototype_ref: Optional[
        "ModeInSwcInstanceRef.ContextModeDeclarationGroupPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-MODE-DECLARATION-GROUP-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_mode_declaration_ref: Optional["ModeInSwcInstanceRef.TargetModeDeclarationRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-MODE-DECLARATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextPortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextModeDeclarationGroupPrototypeRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetModeDeclarationRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeRequestTypeMap:
    """Specifies a mapping between a ModeDeclarationGroup and an
    ImplementationDataType.

    This ImplementationDataType shall be used to implement the
    ModeDeclarationGroup.

    :ivar implementation_data_type_ref: This is the corresponding
        AbstractImplementationDataType. It shall be modeled along the
        idea of an "unsigned integer-like" data type.
    :ivar mode_group_ref: This is the corresponding
        ModeDeclarationGroup.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-REQUEST-TYPE-MAP"

    implementation_data_type_ref: Optional["ModeRequestTypeMap.ImplementationDataTypeRef"] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-DATA-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_group_ref: Optional["ModeRequestTypeMap.ModeGroupRef"] = field(
        default=None,
        metadata={
            "name": "MODE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ImplementationDataTypeRef(Ref):
        dest: AbstractImplementationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ModeGroupRef(Ref):
        dest: ModeDeclarationGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeSwitchReceiverComSpec:
    """
    Communication attributes of RPortPrototypes with respect to mode communication.

    :ivar enhanced_mode_api: This controls the creation of the enhanced
        mode API that returns information about the previous mode and
        the next mode. If set to "true" the enhanced mode API is
        supposed to be generated. For more details please refer to the
        SWS_RTE.
    :ivar mode_group_ref: ModeDeclarationGroupPrototype (of the same
        PortInterface) to which these communication attributes apply.
    :ivar supports_asynchronous_mode_switch: This attribute controls the
        behavior of the corresponding RPortPrototype with respect to the
        question whether it can deal with asynchronous mode switch
        requests, i.e. if set to true, the RPortPrototype is able to
        deal with an asynchronous mode switch request.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-SWITCH-RECEIVER-COM-SPEC"

    enhanced_mode_api: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENHANCED-MODE-API",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_group_ref: Optional["ModeSwitchReceiverComSpec.ModeGroupRef"] = field(
        default=None,
        metadata={
            "name": "MODE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    supports_asynchronous_mode_switch: Boolean | None = field(
        default=None,
        metadata={
            "name": "SUPPORTS-ASYNCHRONOUS-MODE-SWITCH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ModeGroupRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeSwitchedAckRequest:
    """
    Requests acknowledgements that a mode switch has been proceeded successfully.

    :ivar timeout: Number of seconds before an error is reported or in
        case of allowed redundancy, the value is sent again.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-SWITCHED-ACK-REQUEST"

    timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ModificationTypeEnum:
    """
    This enumerator expresses if an object has been changed in its content or in
    its documentation.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODIFICATION-TYPE-ENUM"

    value: ModificationTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MonotonyEnum:
    """
    This enumerator denotes the values for specification of  monotony for e.g.
    curves.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MONOTONY-ENUM"

    value: MonotonyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MsrQueryProps:
    """This metaclass represents the ability to specificy a query which yields some
    documentation text.

    The qualities of the result are determined by the context in which
    the query is used.

    :ivar msr_query_name: This element specifies the name of the MSR-
        QUERY triggered.
    :ivar msr_query_arg: This element specifies an argument within an
        MsrQuery.
    :ivar comment: This element contains a commentary in text form.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MSR-QUERY-PROPS"

    msr_query_name: String | None = field(
        default=None,
        metadata={
            "name": "MSR-QUERY-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_arg: list[MsrQueryArg] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-ARG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comment: String | None = field(
        default=None,
        metadata={
            "name": "COMMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MultidimensionalTime:
    """This is used to specify a multidimensional time value based on ASAM CSE
    codes.

    It is specified by a code which defined the basis of the time and a
    scaling factor which finally determines the time value. If for
    example the cseCode is 100 and the cseCodeFactor is 360, it
    represents 360 angular degrees. If the cseCode is 0 and the
    cseCodeFactor is 50 it represents 50 microseconds.

    :ivar cse_code: Specifies the time base by means of CSE codes.
    :ivar cse_code_factor: The scaling factor for the time value based
        on the specified CSE code.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MULTIDIMENSIONAL-TIME"

    cse_code: CseCodeTypeString | None = field(
        default=None,
        metadata={
            "name": "CSE-CODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cse_code_factor: Integer | None = field(
        default=None,
        metadata={
            "name": "CSE-CODE-FACTOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class NameTokenValueVariationPoint:
    """
    This class represents the ability to express a formula for a name token.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar binding_time: This is the binding time in which the attribute
        value needs to be bound. If this attribute is missing, the
        attribute is not a variation point. In particular this means
        that It needs to be a single value according to the type
        specified in the pure model. It is an error if it is still a
        formula.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar sd: This special data is provided to allow synchronization of
        Attribute value variation points with variant management
        systems. The usage is subject of agreement between the involved
        parties.
    :ivar short_label: This allows to identify the variation point. It
        is also intended to allow RTE support for CompileTime Variation
        points.
    :ivar content:
    """

    class Meta:
        name = "NAME-TOKEN-VALUE-VARIATION-POINT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    binding_time: BindingTimeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "BINDING-TIME",
            "type": "Attribute",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    sd: str | None = field(
        default=None,
        metadata={
            "name": "SD",
            "type": "Attribute",
        },
    )
    short_label: str | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef("NameTokenValueVariationPoint.SyscStringRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("NameTokenValueVariationPoint.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class NetworkSegmentIdentification:
    """This meta-class represents the ability to identify the PhysicalChannel on a
    system scope in a numerical way.

    One possible application of this approach is the Time Validation.

    :ivar network_segment_id: This attribute represents the numerical
        identifier of a PhysicalChannel on system level scope.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NETWORK-SEGMENT-IDENTIFICATION"

    network_segment_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NETWORK-SEGMENT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class NetworkTargetAddressType:
    """
    Network Target Address type (see ISO 15765-2).

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NETWORK-TARGET-ADDRESS-TYPE"

    value: NetworkTargetAddressTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class NmCoordinator:
    """
    A NM coordinator is an ECU, which is connected to at least two busses, and
    where the requirement exists that shutdown of NM of at least two of these
    busses (also referred to as coordinated busses) has to be performed
    synchronously.

    :ivar index: Identification of the NMCoordinator.
    :ivar nm_active_coordinator: Please note that this attribute is
        obsolete and is no longer supported. It is replaced by the
        attribute NmCoordinatorRole in NmNode. Old description: This
        attribute indicates whether a NM Coordinator is an active
        gateway (true) or a passive gateway (false).
    :ivar nm_coord_sync_support: Switch for enabling NmCoordinatorSync
        (coordination of nested busses) support.
    :ivar nm_global_coordinator_time: This attribute defines the maximum
        shutdown time (in seconds) of a connected and coordinated NM-
        Cluster.
    :ivar nm_node_refs: reference to busses (via NmNodes) that are
        coordinated by the NmCoordinator.
    :ivar nm_shutdown_delay_timer: Please note that this attribute is
        obsolete and is no longer supported. Old description: This
        parameter defines the time in seconds which the NM Coordination
        algorithm shall delay the release of the referenced cluster.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NM-COORDINATOR"

    index: Integer | None = field(
        default=None,
        metadata={
            "name": "INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_active_coordinator: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-ACTIVE-COORDINATOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_coord_sync_support: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-COORD-SYNC-SUPPORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_global_coordinator_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-GLOBAL-COORDINATOR-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_refs: Optional["NmCoordinator.NmNodeRefs"] = field(
        default=None,
        metadata={
            "name": "NM-NODE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_shutdown_delay_timer: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-SHUTDOWN-DELAY-TIMER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class NmNodeRefs:
        nm_node_ref: list["NmCoordinator.NmNodeRefs.NmNodeRef"] = field(
            default_factory=list,
            metadata={
                "name": "NM-NODE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class NmNodeRef(Ref):
            dest: NmNodeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class NmCoordinatorRoleEnum:
    """
    Supported NmCoordinator roles.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NM-COORDINATOR-ROLE-ENUM"

    value: NmCoordinatorRoleEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class NmHandleMappingDirectionEnum:
    """
    This enumeration provides direction values for the mapping of NM handles to
    function group states.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NM-HANDLE-MAPPING-DIRECTION-ENUM"

    value: NmHandleMappingDirectionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class NoteTypeEnum:
    """This enumerator specifies the type of the note.

    It can be used to render a note label or even a note icon.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NOTE-TYPE-ENUM"

    value: NoteTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class NumericalValueVariationPoint:
    """This class represents an attribute value variation point for Numerical
    attributes.

    Note that this class might be used in the extended meta-model only.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar binding_time: This is the binding time in which the attribute
        value needs to be bound. If this attribute is missing, the
        attribute is not a variation point. In particular this means
        that It needs to be a single value according to the type
        specified in the pure model. It is an error if it is still a
        formula.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar sd: This special data is provided to allow synchronization of
        Attribute value variation points with variant management
        systems. The usage is subject of agreement between the involved
        parties.
    :ivar short_label: This allows to identify the variation point. It
        is also intended to allow RTE support for CompileTime Variation
        points.
    :ivar content:
    """

    class Meta:
        name = "NUMERICAL-VALUE-VARIATION-POINT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    binding_time: BindingTimeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "BINDING-TIME",
            "type": "Attribute",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    sd: str | None = field(
        default=None,
        metadata={
            "name": "SD",
            "type": "Attribute",
        },
    )
    short_label: str | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef("NumericalValueVariationPoint.SyscStringRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("NumericalValueVariationPoint.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class NvBlockNeedsReliabilityEnum:
    """Reliability against data loss on the non-volatile medium.

    These requirements give only a relative indication, for example on
    the required degree of redundancy for storage. They do, however, not
    specify by which means (e.g. software or hardware) the reliability
    is actually achieved.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NV-BLOCK-NEEDS-RELIABILITY-ENUM"

    value: NvBlockNeedsReliabilityEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class NvBlockNeedsWritingPriorityEnum:
    """
    Specifies the priority of writing this block in case of concurrent requests to
    write other blocks.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NV-BLOCK-NEEDS-WRITING-PRIORITY-ENUM"

    value: NvBlockNeedsWritingPriorityEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ObdRatioConnectionKindEnum:
    """
    Defines the way how the IUMPR service connection between the Dem and the client
    component or module is handled (for details see the DEM Specification).

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OBD-RATIO-CONNECTION-KIND-ENUM"

    value: ObdRatioConnectionKindEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class OperationArgumentInComponentInstanceRef:
    """
    :ivar base_ref:
    :ivar context_component_ref:
    :ivar context_port_prototype_ref:
    :ivar context_operation_ref:
    :ivar root_argument_data_prototype_ref:
    :ivar context_data_prototype_ref:
    :ivar target_data_prototype_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OPERATION-ARGUMENT-IN-COMPONENT-INSTANCE-REF"

    base_ref: Optional["OperationArgumentInComponentInstanceRef.BaseRef"] = field(
        default=None,
        metadata={
            "name": "BASE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_ref: list["OperationArgumentInComponentInstanceRef.ContextComponentRef"] = (
        field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-COMPONENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    context_port_prototype_ref: Optional[
        "OperationArgumentInComponentInstanceRef.ContextPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_operation_ref: Optional[
        "OperationArgumentInComponentInstanceRef.ContextOperationRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-OPERATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    root_argument_data_prototype_ref: Optional[
        "OperationArgumentInComponentInstanceRef.RootArgumentDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROOT-ARGUMENT-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_data_prototype_ref: list[
        "OperationArgumentInComponentInstanceRef.ContextDataPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_data_prototype_ref: Optional[
        "OperationArgumentInComponentInstanceRef.TargetDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BaseRef(Ref):
        dest: SwComponentTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextPortPrototypeRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextOperationRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RootArgumentDataPrototypeRef(Ref):
        dest: ArgumentDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextDataPrototypeRef(Ref):
        dest: ApplicationCompositeElementDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataPrototypeRef(Ref):
        dest: DataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class OperationCycleTypeEnum:
    """
    The possible values of the operation cycles types for the Dem.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OPERATION-CYCLE-TYPE-ENUM"

    value: OperationCycleTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class OperationInSystemInstanceRef:
    """
    :ivar context_composition_ref:
    :ivar context_component_ref:
    :ivar context_port_ref:
    :ivar target_operation_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OPERATION-IN-SYSTEM-INSTANCE-REF"

    context_composition_ref: Optional["OperationInSystemInstanceRef.ContextCompositionRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-COMPOSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_ref: list["OperationInSystemInstanceRef.ContextComponentRef"] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_port_ref: Optional["OperationInSystemInstanceRef.ContextPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_operation_ref: Optional["OperationInSystemInstanceRef.TargetOperationRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-OPERATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextCompositionRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextPortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetOperationRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class OrderedMaster:
    """
    Element in the network endpoint list.

    :ivar index: Defines the order of the network endpoint list (e.g. 0,
        1, 2, ...).
    :ivar time_sync_server_ref: Reference to a master (Time Sync
        Server).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ORDERED-MASTER"

    index: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_sync_server_ref: Optional["OrderedMaster.TimeSyncServerRef"] = field(
        default=None,
        metadata={
            "name": "TIME-SYNC-SERVER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TimeSyncServerRef(Ref):
        dest: TimeSyncServerConfigurationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class OrientEnum:
    """
    This enumerator specifies how the table shall be oriented.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ORIENT-ENUM"

    value: OrientEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class OsTaskPreemptabilityEnum:
    """
    Enumeration that defines the possible preemptability values for OsTask.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OS-TASK-PREEMPTABILITY-ENUM"

    value: OsTaskPreemptabilityEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PModeGroupInAtomicSwcInstanceRef:
    """
    :ivar context_p_port_ref:
    :ivar target_mode_group_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "P-MODE-GROUP-IN-ATOMIC-SWC-INSTANCE-REF"

    context_p_port_ref: Optional["PModeGroupInAtomicSwcInstanceRef.ContextPPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-P-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_mode_group_ref: Optional["PModeGroupInAtomicSwcInstanceRef.TargetModeGroupRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-MODE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextPPortRef(Ref):
        dest: AbstractProvidedPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetModeGroupRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PModeInSystemInstanceRef:
    """
    :ivar context_composition_ref:
    :ivar context_component_ref:
    :ivar context_p_port_ref:
    :ivar context_mode_declaration_group_ref:
    :ivar target_mode_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "P-MODE-IN-SYSTEM-INSTANCE-REF"

    context_composition_ref: Optional["PModeInSystemInstanceRef.ContextCompositionRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-COMPOSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_ref: list["PModeInSystemInstanceRef.ContextComponentRef"] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_p_port_ref: Optional["PModeInSystemInstanceRef.ContextPPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-P-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_mode_declaration_group_ref: Optional[
        "PModeInSystemInstanceRef.ContextModeDeclarationGroupRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-MODE-DECLARATION-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_mode_ref: Optional["PModeInSystemInstanceRef.TargetModeRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-MODE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextCompositionRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextPPortRef(Ref):
        dest: AbstractProvidedPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextModeDeclarationGroupRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetModeRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class POperationInAtomicSwcInstanceRef:
    """
    :ivar context_p_port_ref:
    :ivar target_provided_operation_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "P-OPERATION-IN-ATOMIC-SWC-INSTANCE-REF"

    context_p_port_ref: Optional["POperationInAtomicSwcInstanceRef.ContextPPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-P-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_provided_operation_ref: Optional[
        "POperationInAtomicSwcInstanceRef.TargetProvidedOperationRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-PROVIDED-OPERATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextPPortRef(Ref):
        dest: AbstractProvidedPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetProvidedOperationRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PPortInCompositionInstanceRef:
    """
    :ivar context_component_ref:
    :ivar target_p_port_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "P-PORT-IN-COMPOSITION-INSTANCE-REF"

    context_component_ref: Optional["PPortInCompositionInstanceRef.ContextComponentRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_p_port_ref: Optional["PPortInCompositionInstanceRef.TargetPPortRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-P-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetPPortRef(Ref):
        dest: AbstractProvidedPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PPortPrototypeInExecutableInstanceRef:
    """
    :ivar context_root_sw_component_prototype_ref:
    :ivar context_component_prototype_ref:
    :ivar target_p_port_prototype_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "P-PORT-PROTOTYPE-IN-EXECUTABLE-INSTANCE-REF"

    context_root_sw_component_prototype_ref: Optional[
        "PPortPrototypeInExecutableInstanceRef.ContextRootSwComponentPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ROOT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_prototype_ref: list[
        "PPortPrototypeInExecutableInstanceRef.ContextComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_p_port_prototype_ref: Optional[
        "PPortPrototypeInExecutableInstanceRef.TargetPPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-P-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRootSwComponentPrototypeRef(Ref):
        dest: RootSwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetPPortPrototypeRef(Ref):
        dest: PPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PPortPrototypeInSoftwareClusterDesignInstanceRef:
    """
    :ivar context_root_sw_cluster_design_component_prototype_ref:
    :ivar context_sw_component_prototype_ref:
    :ivar target_p_port_prototype_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "P-PORT-PROTOTYPE-IN-SOFTWARE-CLUSTER-DESIGN-INSTANCE-REF"

    context_root_sw_cluster_design_component_prototype_ref: Optional[
        "PPortPrototypeInSoftwareClusterDesignInstanceRef.ContextRootSwClusterDesignComponentPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ROOT-SW-CLUSTER-DESIGN-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_sw_component_prototype_ref: list[
        "PPortPrototypeInSoftwareClusterDesignInstanceRef.ContextSwComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_p_port_prototype_ref: Optional[
        "PPortPrototypeInSoftwareClusterDesignInstanceRef.TargetPPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-P-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRootSwClusterDesignComponentPrototypeRef(Ref):
        dest: RootSwClusterDesignComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextSwComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetPPortPrototypeRef(Ref):
        dest: PPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PTriggerInAtomicSwcTypeInstanceRef:
    """
    :ivar context_p_port_ref:
    :ivar target_trigger_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "P-TRIGGER-IN-ATOMIC-SWC-TYPE-INSTANCE-REF"

    context_p_port_ref: Optional["PTriggerInAtomicSwcTypeInstanceRef.ContextPPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-P-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_trigger_ref: Optional["PTriggerInAtomicSwcTypeInstanceRef.TargetTriggerRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextPPortRef(Ref):
        dest: AbstractProvidedPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetTriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ParameterDataPrototypeInSystemInstanceRef:
    """
    :ivar context_composition_ref:
    :ivar context_component_ref:
    :ivar context_port_ref:
    :ivar target_parameter_data_prototype_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PARAMETER-DATA-PROTOTYPE-IN-SYSTEM-INSTANCE-REF"

    context_composition_ref: Optional[
        "ParameterDataPrototypeInSystemInstanceRef.ContextCompositionRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-COMPOSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_ref: list["ParameterDataPrototypeInSystemInstanceRef.ContextComponentRef"] = (
        field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-COMPONENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    context_port_ref: Optional["ParameterDataPrototypeInSystemInstanceRef.ContextPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_parameter_data_prototype_ref: Optional[
        "ParameterDataPrototypeInSystemInstanceRef.TargetParameterDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-PARAMETER-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextCompositionRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextPortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetParameterDataPrototypeRef(Ref):
        dest: ParameterDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ParameterInAtomicSwcTypeInstanceRef:
    """
    This class implements an instance reference which can be applied for variables
    as well as for parameters.

    :ivar port_prototype_ref: This is the port providing the variable or
        the entry point to the variable structure.
    :ivar root_parameter_data_prototype_ref: This represents the entry
        point for references into a CompositeDataType.
    :ivar context_data_prototype_ref: This ist the context in a
        compositeDataType.
    :ivar target_data_prototype_ref: This is the target parameter
        element. Note that this must be nested in
        ParameterDataPrototype. The target must be one of
        ParameterDataPrototype,
        ApplicationCompositeElementDataPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PARAMETER-IN-ATOMIC-SWC-TYPE-INSTANCE-REF"

    port_prototype_ref: Optional["ParameterInAtomicSwcTypeInstanceRef.PortPrototypeRef"] = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    root_parameter_data_prototype_ref: Optional[
        "ParameterInAtomicSwcTypeInstanceRef.RootParameterDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROOT-PARAMETER-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_data_prototype_ref: list[
        "ParameterInAtomicSwcTypeInstanceRef.ContextDataPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_data_prototype_ref: Optional[
        "ParameterInAtomicSwcTypeInstanceRef.TargetDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PortPrototypeRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RootParameterDataPrototypeRef(Ref):
        dest: DataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextDataPrototypeRef(Ref):
        dest: ApplicationCompositeElementDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataPrototypeRef(Ref):
        dest: DataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PayloadBytePatternRulePart:
    """
    Configuration of one byte in the datagram,

    :ivar offset: This attribute defines the byte offset in the datagram
        (start byte of the Ethernet frame, i.e. offset 0 corresponds to
        the first byte of the destination MAC address).
    :ivar value: This attribute defines the byteValue (0..255) in the
        datagram.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PAYLOAD-BYTE-PATTERN-RULE-PART"

    offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PduCollectionSemanticsEnum:
    """
    Defines the collection semantics for the PDU collection feature.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PDU-COLLECTION-SEMANTICS-ENUM"

    value: PduCollectionSemanticsEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PduCollectionTriggerEnum:
    """
    Defines whether a Pdu contributes to the triggering of the data transmission if
    Pdu collection is enabled.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PDU-COLLECTION-TRIGGER-ENUM"

    value: PduCollectionTriggerEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PersistencyCollectionLevelUpdateStrategyEnum:
    """
    This enumeration provides possible values for the update strategy on
    interface/storage level.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-COLLECTION-LEVEL-UPDATE-STRATEGY-ENUM"

    value: PersistencyCollectionLevelUpdateStrategyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PersistencyDeploymentUri:
    """
    This meta-class represents the ability to contain URIs relevant for the
    persistency deployment.

    :ivar uri: This attribute holds the storage location for the
        concrete subclass of PersistencyDeployment, e.g. file on the
        file system.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-DEPLOYMENT-URI"

    uri: UriString | None = field(
        default=None,
        metadata={
            "name": "URI",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PersistencyElementLevelUpdateStrategyEnum:
    """
    This enumeration provides possible values for the update strategy on element
    level.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-ELEMENT-LEVEL-UPDATE-STRATEGY-ENUM"

    value: PersistencyElementLevelUpdateStrategyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PersistencyRedundancyEnum:
    """
    This meta-class provides a way to specify in which way redundancy shall be
    applied on collection level.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-REDUNDANCY-ENUM"

    value: PersistencyRedundancyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PersistencyRedundancyHandlingScopeEnum:
    """
    This meta-class provides values to control the scope of redundancy measures in
    the persistency deployment.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-REDUNDANCY-HANDLING-SCOPE-ENUM"

    value: PersistencyRedundancyHandlingScopeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PgwideEnum:
    """
    This enumerator specifies, if the table shall be rendered across the entire
    page, even if it is placed in side-head layouts.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PGWIDE-ENUM"

    value: PgwideEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PhmCheckpointInExecutableInstanceRef:
    """
    :ivar context_root_sw_component_prototype_ref:
    :ivar context_component_prototype_ref:
    :ivar context_r_port_prototype_ref:
    :ivar target_phm_checkpoint_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PHM-CHECKPOINT-IN-EXECUTABLE-INSTANCE-REF"

    context_root_sw_component_prototype_ref: Optional[
        "PhmCheckpointInExecutableInstanceRef.ContextRootSwComponentPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ROOT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_prototype_ref: list[
        "PhmCheckpointInExecutableInstanceRef.ContextComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_r_port_prototype_ref: Optional[
        "PhmCheckpointInExecutableInstanceRef.ContextRPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-R-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_phm_checkpoint_ref: Optional[
        "PhmCheckpointInExecutableInstanceRef.TargetPhmCheckpointRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-PHM-CHECKPOINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRootSwComponentPrototypeRef(Ref):
        dest: RootSwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextRPortPrototypeRef(Ref):
        dest: RPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetPhmCheckpointRef(Ref):
        dest: PhmCheckpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PhysicalDimensionMapping:
    """
    This class represents a specific mapping between two PhysicalDimensions.

    :ivar first_physical_dimension_ref: This represents the first
        PhysicalDimension of the enclosing PhysicalDimensionMapping.
    :ivar second_physical_dimension_ref: This represents the first
        PhysicalDimension of the enclosing PhysicalDimensionMapping.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PHYSICAL-DIMENSION-MAPPING"

    first_physical_dimension_ref: Optional["PhysicalDimensionMapping.FirstPhysicalDimensionRef"] = (
        field(
            default=None,
            metadata={
                "name": "FIRST-PHYSICAL-DIMENSION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    second_physical_dimension_ref: Optional[
        "PhysicalDimensionMapping.SecondPhysicalDimensionRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECOND-PHYSICAL-DIMENSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FirstPhysicalDimensionRef(Ref):
        dest: PhysicalDimensionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecondPhysicalDimensionRef(Ref):
        dest: PhysicalDimensionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PlcaProps:
    """
    This meta-class allows to configure the PLCA (Physical Layer Collision
    Avoidance) in case 10-BASE-T1S Ethernet is used and PLCA is enabled on the
    CouplingPort (PHY).

    :ivar plca_local_node_id: This attribute defines the node ID when
        the PLCA mode for 10BASE-T1S is used.
    :ivar plca_max_burst_count: Defines maximum packets allowed to be
        transmitted within a TO. This configuration can be different
        from one ECU to another within the PLCA mixed segment.
    :ivar plca_max_burst_timer: Limits the burst frames in bit time.
        This configuration can be different from one ECU to another
        within the PLCA mixed segment. For PLCA burst mode to work
        properly this timer should be set greater than one IPG.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PLCA-PROPS"

    plca_local_node_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PLCA-LOCAL-NODE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    plca_max_burst_count: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PLCA-MAX-BURST-COUNT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    plca_max_burst_timer: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PLCA-MAX-BURST-TIMER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PncGatewayTypeEnum:
    """
    Defines the PncGateway roles.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PNC-GATEWAY-TYPE-ENUM"

    value: PncGatewayTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PortGroupInSystemInstanceRef:
    """
    :ivar context_composition_ref:
    :ivar context_component_ref:
    :ivar target_ref: Link to a PortGroup that is defined in a component
        which is part of this CompositionSwComponentType.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-GROUP-IN-SYSTEM-INSTANCE-REF"

    context_composition_ref: Optional["PortGroupInSystemInstanceRef.ContextCompositionRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-COMPOSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_ref: list["PortGroupInSystemInstanceRef.ContextComponentRef"] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_ref: Optional["PortGroupInSystemInstanceRef.TargetRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextCompositionRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRef(Ref):
        dest: PortGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PortInterfaceBlueprintMapping:
    """
    This meta-class represents the ability to map two PortInterfaces of which one
    acts as the blueprint for the other.

    :ivar port_interface_blueprint_ref: This represents the interface
        blueprint. Note that this interface needs to live in a package
        of category BLUEPRINT.
    :ivar derived_port_interface_ref: This represents the derived
        interface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-INTERFACE-BLUEPRINT-MAPPING"

    port_interface_blueprint_ref: Optional[
        "PortInterfaceBlueprintMapping.PortInterfaceBlueprintRef"
    ] = field(
        default=None,
        metadata={
            "name": "PORT-INTERFACE-BLUEPRINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    derived_port_interface_ref: Optional[
        "PortInterfaceBlueprintMapping.DerivedPortInterfaceRef"
    ] = field(
        default=None,
        metadata={
            "name": "DERIVED-PORT-INTERFACE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PortInterfaceBlueprintRef(Ref):
        dest: PortInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DerivedPortInterfaceRef(Ref):
        dest: PortInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PortInterfaceElementInImplementationDatatypeRef:
    """This meta-class represents the ability to refer to the internal structure of
    an AutosarDataPrototype  which is typed by an implementationDatatype in the
    context of a PortInterface.

    In other words, this meta-class shall not be used to model a
    reference to the '''AutosarDataPrototype as a target itself''',
    '''even''' if the AutosarDataPrototype is typed by an
    ImplementationDataType '''and even''' if that ImplementationDataType
    represents a composite data type.

    :ivar context_data_prototype_refs: This is a context in case there
        are subelements with explicit types. The reference has to be
        ordered to properly reflect the nested structure.
    :ivar port_interface_ref: This is the PortInterface that contains
        the rootDataPrototype.
    :ivar root_data_prototype_ref: This rootDataPrototype defines the
        AutosarDataPrototype in which the target can be found.
    :ivar target_data_prototype_ref: This is the target reference to a
        subElement that is defined inside of the rootDataPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-INTERFACE-ELEMENT-IN-IMPLEMENTATION-DATATYPE-REF"

    context_data_prototype_refs: Optional[
        "PortInterfaceElementInImplementationDatatypeRef.ContextDataPrototypeRefs"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-DATA-PROTOTYPE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_interface_ref: Optional[
        "PortInterfaceElementInImplementationDatatypeRef.PortInterfaceRef"
    ] = field(
        default=None,
        metadata={
            "name": "PORT-INTERFACE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    root_data_prototype_ref: Optional[
        "PortInterfaceElementInImplementationDatatypeRef.RootDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROOT-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_data_prototype_ref: Optional[
        "PortInterfaceElementInImplementationDatatypeRef.TargetDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextDataPrototypeRefs:
        context_data_prototype_ref: list[
            "PortInterfaceElementInImplementationDatatypeRef.ContextDataPrototypeRefs.ContextDataPrototypeRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-DATA-PROTOTYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextDataPrototypeRef(Ref):
            dest: CppImplementationDataTypeContextTargetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PortInterfaceRef(Ref):
        dest: PortInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RootDataPrototypeRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataPrototypeRef(Ref):
        dest: CppImplementationDataTypeContextTargetSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PortPrototypeBlueprintMapping:
    """
    This meta-class represents the ability to map a PortPrototypeBlueprint to a
    PortProtoype of which one acts as the blueprint for the other.

    :ivar port_prototype_blueprint_ref: The PortPrototypeBlueprint in
        the context of the mapping.
    :ivar derived_port_prototype_ref: The PortPrototype in the context
        of the mapping.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-PROTOTYPE-BLUEPRINT-MAPPING"

    port_prototype_blueprint_ref: Optional[
        "PortPrototypeBlueprintMapping.PortPrototypeBlueprintRef"
    ] = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-BLUEPRINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    derived_port_prototype_ref: Optional[
        "PortPrototypeBlueprintMapping.DerivedPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "DERIVED-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PortPrototypeBlueprintRef(Ref):
        dest: PortPrototypeBlueprintSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DerivedPortPrototypeRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PortPrototypeInExecutableInstanceRef:
    """
    :ivar context_component_prototype_ref:
    :ivar target_port_prototype_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-PROTOTYPE-IN-EXECUTABLE-INSTANCE-REF"

    context_component_prototype_ref: list[
        "PortPrototypeInExecutableInstanceRef.ContextComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_port_prototype_ref: Optional[
        "PortPrototypeInExecutableInstanceRef.TargetPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetPortPrototypeRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PositiveIntegerValueVariationPoint:
    """This class represents an attribute value variation point for positive
    Integer attributes.

    Note that this class might be used in the extended meta-model only.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar binding_time: This is the binding time in which the attribute
        value needs to be bound. If this attribute is missing, the
        attribute is not a variation point. In particular this means
        that It needs to be a single value according to the type
        specified in the pure model. It is an error if it is still a
        formula.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar sd: This special data is provided to allow synchronization of
        Attribute value variation points with variant management
        systems. The usage is subject of agreement between the involved
        parties.
    :ivar short_label: This allows to identify the variation point. It
        is also intended to allow RTE support for CompileTime Variation
        points.
    :ivar content:
    """

    class Meta:
        name = "POSITIVE-INTEGER-VALUE-VARIATION-POINT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    binding_time: BindingTimeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "BINDING-TIME",
            "type": "Attribute",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    sd: str | None = field(
        default=None,
        metadata={
            "name": "SD",
            "type": "Attribute",
        },
    )
    short_label: str | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef("PositiveIntegerValueVariationPoint.SyscStringRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("PositiveIntegerValueVariationPoint.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PrivacyLevel:
    """
    This meta-class defines the Privacy Level for a Log and Trace content.

    :ivar compu_method_ref: Reference to CompuMethod of category
        TEXTTABLE that defines the supported user-defined privacy
        levels.
    :ivar privacy_level: The value that represents the privacy level and
        is transported in the Extension Header.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PRIVACY-LEVEL"

    compu_method_ref: Optional["PrivacyLevel.CompuMethodRef"] = field(
        default=None,
        metadata={
            "name": "COMPU-METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    privacy_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIVACY-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CompuMethodRef(Ref):
        dest: CompuMethodSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PrmCharAbsTol:
    """
    The parameter is specified as ablolute value with a tolerance.

    :ivar abs: This represnts the absolute value of the parameter.
    :ivar tol: This represnts the tolerance of the parameter in the same
        units as the paramter: E.g. Tmperature= 50 +- 0.5 grad.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PRM-CHAR-ABS-TOL"

    abs: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "ABS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tol: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "TOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PrmCharMinTypMax:
    """
    This metaclass represents the characteristics of a parameter as minimal,
    typical maximum value.

    :ivar min: This represnts the minimum value of the parameter.
    :ivar typ: This represnts the typical value of the parameter.
    :ivar max: This represnts the maximum value of the parameter.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PRM-CHAR-MIN-TYP-MAX"

    min: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    typ: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "TYP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PrmCharTextualContents:
    """
    This metaclass represents the fact that it is a textual parameter.

    :ivar text: This is the value of a textual parameter
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PRM-CHAR-TEXTUAL-CONTENTS"

    text: String | None = field(
        default=None,
        metadata={
            "name": "TEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ProcessArgument:
    """
    This meta-class has the ability to define command line arguments for processing
    by the Main function.

    :ivar argument: This represents one command-line argument to be
        processed by the executable software.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROCESS-ARGUMENT"

    argument: String | None = field(
        default=None,
        metadata={
            "name": "ARGUMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ProcessingKindEnum:
    """
    Kind of processing which has been applied to a data element.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROCESSING-KIND-ENUM"

    value: ProcessingKindEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ProgramminglanguageEnum:
    """
    Programming language the implementation was created in.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROGRAMMINGLANGUAGE-ENUM"

    value: ProgramminglanguageEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PulseTestEnum:
    """
    This element indicates to the connected Actuator Software component whether the
    data-element can be used to generate pulse test sequences using the
    IoHwAbstraction layer.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PULSE-TEST-ENUM"

    value: PulseTestEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RModeGroupInAtomicSwcInstanceRef:
    """
    :ivar context_r_port_ref:
    :ivar target_mode_group_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "R-MODE-GROUP-IN-ATOMIC-SWC-INSTANCE-REF"

    context_r_port_ref: Optional["RModeGroupInAtomicSwcInstanceRef.ContextRPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-R-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_mode_group_ref: Optional["RModeGroupInAtomicSwcInstanceRef.TargetModeGroupRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-MODE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRPortRef(Ref):
        dest: AbstractRequiredPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetModeGroupRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RModeInAtomicSwcInstanceRef:
    """
    :ivar context_port_ref:
    :ivar context_mode_declaration_group_prototype_ref:
    :ivar target_mode_declaration_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "R-MODE-IN-ATOMIC-SWC-INSTANCE-REF"

    context_port_ref: Optional["RModeInAtomicSwcInstanceRef.ContextPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_mode_declaration_group_prototype_ref: Optional[
        "RModeInAtomicSwcInstanceRef.ContextModeDeclarationGroupPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-MODE-DECLARATION-GROUP-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_mode_declaration_ref: Optional[
        "RModeInAtomicSwcInstanceRef.TargetModeDeclarationRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-MODE-DECLARATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextPortRef(Ref):
        dest: AbstractRequiredPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextModeDeclarationGroupPrototypeRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetModeDeclarationRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ROperationInAtomicSwcInstanceRef:
    """
    :ivar context_r_port_ref:
    :ivar target_required_operation_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "R-OPERATION-IN-ATOMIC-SWC-INSTANCE-REF"

    context_r_port_ref: Optional["ROperationInAtomicSwcInstanceRef.ContextRPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-R-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_required_operation_ref: Optional[
        "ROperationInAtomicSwcInstanceRef.TargetRequiredOperationRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-REQUIRED-OPERATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRPortRef(Ref):
        dest: AbstractRequiredPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRequiredOperationRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RPortInCompositionInstanceRef:
    """
    :ivar context_component_ref:
    :ivar target_r_port_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "R-PORT-IN-COMPOSITION-INSTANCE-REF"

    context_component_ref: Optional["RPortInCompositionInstanceRef.ContextComponentRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_r_port_ref: Optional["RPortInCompositionInstanceRef.TargetRPortRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-R-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRPortRef(Ref):
        dest: AbstractRequiredPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RPortPrototypeInExecutableInstanceRef:
    """
    :ivar context_root_sw_component_prototype_ref:
    :ivar context_component_prototype_ref:
    :ivar target_r_port_prototype_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "R-PORT-PROTOTYPE-IN-EXECUTABLE-INSTANCE-REF"

    context_root_sw_component_prototype_ref: Optional[
        "RPortPrototypeInExecutableInstanceRef.ContextRootSwComponentPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ROOT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_prototype_ref: list[
        "RPortPrototypeInExecutableInstanceRef.ContextComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_r_port_prototype_ref: Optional[
        "RPortPrototypeInExecutableInstanceRef.TargetRPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-R-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRootSwComponentPrototypeRef(Ref):
        dest: RootSwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRPortPrototypeRef(Ref):
        dest: RPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RPortPrototypeInSoftwareClusterDesignInstanceRef:
    """
    :ivar context_root_sw_cluster_design_component_prototype_ref:
    :ivar context_sw_component_prototype_ref:
    :ivar target_r_port_prototype_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "R-PORT-PROTOTYPE-IN-SOFTWARE-CLUSTER-DESIGN-INSTANCE-REF"

    context_root_sw_cluster_design_component_prototype_ref: Optional[
        "RPortPrototypeInSoftwareClusterDesignInstanceRef.ContextRootSwClusterDesignComponentPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ROOT-SW-CLUSTER-DESIGN-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_sw_component_prototype_ref: list[
        "RPortPrototypeInSoftwareClusterDesignInstanceRef.ContextSwComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_r_port_prototype_ref: Optional[
        "RPortPrototypeInSoftwareClusterDesignInstanceRef.TargetRPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-R-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRootSwClusterDesignComponentPrototypeRef(Ref):
        dest: RootSwClusterDesignComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextSwComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRPortPrototypeRef(Ref):
        dest: RPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RTriggerInAtomicSwcInstanceRef:
    """
    :ivar context_r_port_ref:
    :ivar target_trigger_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "R-TRIGGER-IN-ATOMIC-SWC-INSTANCE-REF"

    context_r_port_ref: Optional["RTriggerInAtomicSwcInstanceRef.ContextRPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-R-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_trigger_ref: Optional["RTriggerInAtomicSwcInstanceRef.TargetTriggerRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRPortRef(Ref):
        dest: AbstractRequiredPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetTriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RVariableInAtomicSwcInstanceRef:
    """
    :ivar context_r_port_ref:
    :ivar target_data_element_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "R-VARIABLE-IN-ATOMIC-SWC-INSTANCE-REF"

    context_r_port_ref: Optional["RVariableInAtomicSwcInstanceRef.ContextRPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-R-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_data_element_ref: Optional["RVariableInAtomicSwcInstanceRef.TargetDataElementRef"] = (
        field(
            default=None,
            metadata={
                "name": "TARGET-DATA-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRPortRef(Ref):
        dest: AbstractRequiredPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataElementRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RamBlockStatusControlEnum:
    """
    This enumeration type defines options for how the management of the ramBlock
    status is controlled.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RAM-BLOCK-STATUS-CONTROL-ENUM"

    value: RamBlockStatusControlEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ReceiverIntentEnum:
    """
    This meta-class represents the intent to specify how a given ServiceInterface
    is used from the perspective of a given event receiver.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RECEIVER-INTENT-ENUM"

    value: ReceiverIntentEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ReceptionComSpecProps:
    """
    This meta-class defines a set of reception attributes which the application
    software is assumed to implement.

    :ivar data_update_period: This attribute defines the period in which
        the application shall check for updated data. This attribute is
        used for the configuration of the E2E protection, but may also
        indicate a general data reception period.
    :ivar timeout: This attribute defines the time interval after which
        the application shall assume that the to be received data
        reception has timed out, i.e. the respective data has not been
        received for that amount of time.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RECEPTION-COM-SPEC-PROPS"

    data_update_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DATA-UPDATE-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ReentrancyLevelEnum:
    """
    Specifies if and in which kinds of environments an entity is reentrant.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REENTRANCY-LEVEL-ENUM"

    value: ReentrancyLevelEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ReferenceBase:
    """This meta-class establishes a basis for relative references.

    Reference bases are identified by the shortLabel which shall be
    unique in the current package.

    :ivar short_label: This is the name of the reference base. By this
        name, particular references can denote the applicable base.
    :ivar is_default: This attribute denotes if the current
        ReferenceBase is the default. Note that there can only be one
        default reference base within a package.
    :ivar is_global: This indicates that the target of the applicable
        reference can be resolved via the non-qualified shortName. This
        requires that the shortName of the target is unique within the
        package referenced in the reference base. The default is false.
        Note that the reference base also maintains a list of elements
        which may be referenced using a "global Reference".
    :ivar base_is_this_package: This indicates that this base is
        established by the current package. In this case  the
        association "package" can be derived as the qualified shortName
        of the enclosing package. If  the value of baseIsThisPackage is
        set to true then one of the following shall be true: * target of
        the association "package" shall be the enclosing package. *
        association "package" is omitted.
    :ivar global_in_package_refs: This represents the ability to express
        that global elements live in various packages which do not have
        a common ancestor package. Packages mentioned by
        ReferenceBase.globalInPackage are used in addition to the one in
        ReferenceBase.package.
    :ivar global_elements: This attribute represents a meta-class for
        which the global referencing is supported via this reference
        base.
    :ivar package_ref: This association specifies the basis of all
        relative references with the base equals shortLabel.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REFERENCE-BASE"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_default: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-DEFAULT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_global: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-GLOBAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    base_is_this_package: Boolean | None = field(
        default=None,
        metadata={
            "name": "BASE-IS-THIS-PACKAGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_in_package_refs: Optional["ReferenceBase.GlobalInPackageRefs"] = field(
        default=None,
        metadata={
            "name": "GLOBAL-IN-PACKAGE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_elements: Optional["ReferenceBase.GlobalElements"] = field(
        default=None,
        metadata={
            "name": "GLOBAL-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    package_ref: Optional["ReferenceBase.PackageRef"] = field(
        default=None,
        metadata={
            "name": "PACKAGE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class GlobalInPackageRefs:
        global_in_package_ref: list["ReferenceBase.GlobalInPackageRefs.GlobalInPackageRef"] = field(
            default_factory=list,
            metadata={
                "name": "GLOBAL-IN-PACKAGE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class GlobalInPackageRef(Ref):
            dest: ArPackageSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class GlobalElements:
        global_element: list[ReferrableSubtypesEnum] = field(
            default_factory=list,
            metadata={
                "name": "GLOBAL-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PackageRef(Ref):
        dest: ArPackageSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ReferenceCondition:
    """
    The ReferenceCondition evaluates to true, if the referenced reference is
    accepted by all rules of this condition.

    :ivar lower_multiplicity: Specifies the minimal number of times an
        object shall occur. If this primitive attribute is not set, then
        the object is optional.
    :ivar upper_multiplicity: Specifies the maximum number of times an
        object may occur.  If this primitive attribute is not set, then
        there is no limit with respect to the maximum occurrence.
    :ivar upper_multiplicity_infinite: This explicitly specifies, that
        the upper multiplicity is NOT restricted. Note: The use of
        'upperMultiplicityInfinite' and 'upperMultiplicity' is mutual
        exclusive.
    :ivar reference_ref: The reference that has to be accepted by the
        restrictions of this ReferenceCondition
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REFERENCE-CONDITION"

    lower_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: Boolean | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reference_ref: Optional["ReferenceCondition.ReferenceRef"] = field(
        default=None,
        metadata={
            "name": "REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ReferenceRef(Ref):
        dest: ReferenceTailoringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ReferrableRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar referrable_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REFERRABLE-REF-CONDITIONAL"

    referrable_ref: Optional["ReferrableRefConditional.ReferrableRef"] = field(
        default=None,
        metadata={
            "name": "REFERRABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: Optional["VariationPoint"] = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ReferrableRef(Ref):
        dest: ReferrableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RelativeTolerance:
    """
    Maximum allowable deviation.

    :ivar relative: Maximum allowable deviation in percent (percent of
        the corresponding TimeValue).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RELATIVE-TOLERANCE"

    relative: Integer | None = field(
        default=None,
        metadata={
            "name": "RELATIVE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RemotingTechnologyEnum:
    """
    Remoting technology identifier.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REMOTING-TECHNOLOGY-ENUM"

    value: RemotingTechnologyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ReportBehaviorEnum:
    """
    This enumeration specifies the report status of related events before or after
    diagnostic event initialization.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REPORT-BEHAVIOR-ENUM"

    value: ReportBehaviorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RequestMethodEnum:
    """
    Available request methods for HTTPs.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REQUEST-METHOD-ENUM"

    value: RequestMethodEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RequestResponseDelay:
    """
    Time to wait before answering the query.

    :ivar max_value: Maximum allowable response delay to entries
        received by multicast in seconds.
    :ivar min_value: Minimum allowable response delay to entries
        received by multicast in seconds.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REQUEST-RESPONSE-DELAY"

    max_value: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MAX-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_value: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MIN-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RequestTypeEnum:
    """
    This enumeration defines the DiagnosticMessage request types.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REQUEST-TYPE-ENUM"

    value: RequestTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RequiredMethodInExecutableInstanceRef:
    """
    :ivar context_root_sw_component_prototype_ref:
    :ivar context_component_prototype_ref:
    :ivar context_r_port_prototype_ref:
    :ivar target_method_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REQUIRED-METHOD-IN-EXECUTABLE-INSTANCE-REF"

    context_root_sw_component_prototype_ref: Optional[
        "RequiredMethodInExecutableInstanceRef.ContextRootSwComponentPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ROOT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_prototype_ref: list[
        "RequiredMethodInExecutableInstanceRef.ContextComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_r_port_prototype_ref: Optional[
        "RequiredMethodInExecutableInstanceRef.ContextRPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-R-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_method_ref: Optional["RequiredMethodInExecutableInstanceRef.TargetMethodRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRootSwComponentPrototypeRef(Ref):
        dest: RootSwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextRPortPrototypeRef(Ref):
        dest: RPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetMethodRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ResolutionPolicyEnum:
    """
    This specifies if the content of the xref element follow a dedicated resolution
    policy.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RESOLUTION-POLICY-ENUM"

    value: ResolutionPolicyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ResumePosition:
    """
    Defines, where a schedule table shall be proceeded in case if it has been
    interrupted by a run-once table or MRF/SRF.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RESUME-POSITION"

    value: ResumePositionSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RoleBasedResourceDependency:
    """
    This class specifies a dependency between CpSoftwareClusterResources.

    :ivar resource_ref: Reference to resource for which the dependency
        is depicted.
    :ivar role: This is attributes characterizes the kind of dependency
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ROLE-BASED-RESOURCE-DEPENDENCY"

    resource_ref: Optional["RoleBasedResourceDependency.ResourceRef"] = field(
        default=None,
        metadata={
            "name": "RESOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    role: Identifier | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ResourceRef(Ref):
        dest: CpSoftwareClusterResourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RptAccessEnum:
    """
    Determines the access rights to a data object with respect to rapid
    prototyping.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-ACCESS-ENUM"

    value: RptAccessEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RptEnablerImplTypeEnum:
    """
    Describes the required / implemented usage of enabler flags for data access in
    the code.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-ENABLER-IMPL-TYPE-ENUM"

    value: RptEnablerImplTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RptExecutionControlEnum:
    """
    Determines rapid prototyping preparation of an ExecutableEntity.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-EXECUTION-CONTROL-ENUM"

    value: RptExecutionControlEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RptPreparationEnum:
    """
    Determines the RP preparation level for access to VariableDataPrototypes within
    the generated RTE implementation.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-PREPARATION-ENUM"

    value: RptPreparationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RptServicePointEnum:
    """
    Specifies whether the invocation of ExecutableEntitys due to activation of
    specific RteEvents/BswEvents requires the insertion of Service Points.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-SERVICE-POINT-ENUM"

    value: RptServicePointEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RteApiReturnValueProvisionEnum:
    """
    This meta-class provides values to control how return values from RTE APIs are
    provided.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RTE-API-RETURN-VALUE-PROVISION-ENUM"

    value: RteApiReturnValueProvisionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RteEventInCompositionInstanceRef:
    """
    :ivar context_sw_component_ref:
    :ivar target_rte_event_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RTE-EVENT-IN-COMPOSITION-INSTANCE-REF"

    context_sw_component_ref: list["RteEventInCompositionInstanceRef.ContextSwComponentRef"] = (
        field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-SW-COMPONENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    target_rte_event_ref: Optional["RteEventInCompositionInstanceRef.TargetRteEventRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-RTE-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextSwComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRteEventRef(Ref):
        dest: RteEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RteEventInEcuInstanceRef:
    """
    :ivar context_root_composition_ref:
    :ivar context_atomic_component_ref:
    :ivar target_rte_event_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RTE-EVENT-IN-ECU-INSTANCE-REF"

    context_root_composition_ref: Optional["RteEventInEcuInstanceRef.ContextRootCompositionRef"] = (
        field(
            default=None,
            metadata={
                "name": "CONTEXT-ROOT-COMPOSITION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    context_atomic_component_ref: Optional["RteEventInEcuInstanceRef.ContextAtomicComponentRef"] = (
        field(
            default=None,
            metadata={
                "name": "CONTEXT-ATOMIC-COMPONENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    target_rte_event_ref: Optional["RteEventInEcuInstanceRef.TargetRteEventRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-RTE-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRootCompositionRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextAtomicComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRteEventRef(Ref):
        dest: RteEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RteEventInSystemInstanceRef:
    """
    :ivar context_root_composition_ref:
    :ivar context_sw_component_ref:
    :ivar target_rte_event_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RTE-EVENT-IN-SYSTEM-INSTANCE-REF"

    context_root_composition_ref: Optional[
        "RteEventInSystemInstanceRef.ContextRootCompositionRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ROOT-COMPOSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_sw_component_ref: list["RteEventInSystemInstanceRef.ContextSwComponentRef"] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-SW-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_rte_event_ref: Optional["RteEventInSystemInstanceRef.TargetRteEventRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-RTE-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRootCompositionRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextSwComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRteEventRef(Ref):
        dest: RteEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RtePluginProps:
    """
    The properties of a communication graph with respect to the utilization of RTE
    Implementation Plug-in.

    :ivar associated_cross_sw_cluster_com_rte_plugin_ref: This
        associates a communication graph to a specific RTE
        Implementation Plug-in handling cross Software Cluster
        communication.
    :ivar associated_rte_plugin_ref: This associates a communication
        graph to a specific RTE Implementation Plug-in handling local
        Software Cluster communication or communication in a non-cluster
        ECU.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RTE-PLUGIN-PROPS"

    associated_cross_sw_cluster_com_rte_plugin_ref: Optional[
        "RtePluginProps.AssociatedCrossSwClusterComRtePluginRef"
    ] = field(
        default=None,
        metadata={
            "name": "ASSOCIATED-CROSS-SW-CLUSTER-COM-RTE-PLUGIN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    associated_rte_plugin_ref: Optional["RtePluginProps.AssociatedRtePluginRef"] = field(
        default=None,
        metadata={
            "name": "ASSOCIATED-RTE-PLUGIN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AssociatedCrossSwClusterComRtePluginRef(Ref):
        dest: EcucContainerValueSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AssociatedRtePluginRef(Ref):
        dest: EcucContainerValueSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RunMode:
    """
    The schedule table can be executed in two different modes.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RUN-MODE"

    value: RunModeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RunnableEntityArgument:
    """
    This meta-class represents the ability to provide specific information
    regarding the arguments to a RunnableEntity.

    :ivar symbol: This represents the symbol to be generated into the
        actual signature on the level of the C programming language.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RUNNABLE-ENTITY-ARGUMENT"

    symbol: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RuntimeAddressConfigurationEnum:
    """
    This enumeration defines the protocol to be used to obtain the address
    information.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RUNTIME-ADDRESS-CONFIGURATION-ENUM"

    value: RuntimeAddressConfigurationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RxAcceptContainedIPduEnum:
    """
    Defines whether this ContainerIPdu has a fixed set of containedIPdus assigned
    for reception.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RX-ACCEPT-CONTAINED-I-PDU-ENUM"

    value: RxAcceptContainedIPduEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RxIdentifierRange:
    """Optional definition of a CanId range to reduce the effort of specifying
    every possible FrameTriggering within the defined Id range during reception.

    All frames received within a range are mapped to the same Pdu that
    is passed to a upper layer module (e.g. Nm, CDD, PduR).

    :ivar lower_can_id: This attribute can be used together with the
        upperCanId attribute to define a range of CanIds.
    :ivar upper_can_id: This attribute can be used together with the
        lowerCanId attribute to define a range of CanIds.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RX-IDENTIFIER-RANGE"

    lower_can_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOWER-CAN-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_can_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UPPER-CAN-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ScaleConstrValidityEnum:
    """
    This enumerator specifies the possible values of a scale.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SCALE-CONSTR-VALIDITY-ENUM"

    value: ScaleConstrValidityEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SearchIntentionEnum:
    """
    This meta-class allows for the definition of a dedicated search intention from
    the application's point of view.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SEARCH-INTENTION-ENUM"

    value: SearchIntentionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SecOcJobSemanticEnum:
    """
    List of cryptographic routines supported by SecOC.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SEC-OC-JOB-SEMANTIC-ENUM"

    value: SecOcJobSemanticEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SecureCommunicationProps:
    """
    This meta-class contains configuration settings that are specific for an
    individual SecuredIPdu.

    :ivar auth_algorithm: This attribute defines the authentication
        algorithm used for MAC generation and verification.
    :ivar auth_data_freshness_length: This attribute defines the length
        in bits of the authentic PDU data that is passed to the SWC that
        verifies and generates the Freshness.
    :ivar auth_data_freshness_start_position: This value determines the
        start position in bits of the Authentic PDU that shall be passed
        on to the SWC that verifies and generates the Freshness. The bit
        counting is done according to TPS_SYST_01068.
    :ivar auth_info_tx_length: This attribute defines the length in bits
        of the authentication code to be included in the payload of the
        authenticated Pdu.
    :ivar authentication_build_attempts: This attribute specifies the
        number of authentication build attempts.
    :ivar authentication_retries: This attribute defines the additional
        number of authentication attempts that are to be carried out
        when the generation of the authentication information failed for
        a given SecuredIPdu. If zero is set than only one authentication
        attempt is done.
    :ivar data_id: This attribute defines a numerical identifier for the
        Secured I-PDU.
    :ivar freshness_counter_sync_attempts: This attribute defines the
        number of Freshness Counter re-synchronization attempts when a
        verification failed for a Secured I-PDU. If the value is zero,
        there will be no additional verification attempt to synchronize
        with a potentially better fitting Freshness Counter value. This
        attribute is only applicable if useFreshnessTimestamp is FALSE.
    :ivar freshness_timestamp_time_period_factor: This attribute defines
        a factor that specifies the time period for the Freshness
        Timestamp. It holds a multiplication factor that specifies the
        concrete meaning of a Freshness Timestamp increment by one on
        basis of microseconds.
    :ivar freshness_value_id: This attribute defines the Id of the
        Freshness Value. The Freshness Value might be a normal counter
        or a time value.
    :ivar freshness_value_length: This attribute defines the complete
        length in bits of the Freshness Value. As long as the key
        doesn't change the counter shall not overflow. The length of the
        counter shall be determined based on the expected life time of
        the corresponding key and frequency of usage of the counter.
    :ivar freshness_value_tx_length: This attribute defines the length
        in bits of the Freshness Value to be included in the payload of
        the Secured I-PDU. This length is specific to the least
        significant bits of the complete Freshness Counter. If the
        attribute is 0 no Freshness Value is included in the Secured
        I-PDU.
    :ivar message_link_length: SecOC links an AuthenticIPdu and
        CryptographicIPdu together by repeating a specific part (Message
        Linker) of the AuthenticIPdu in the CryptographicIPdu. This
        attribute defines the length in bits of the messageLinker.
    :ivar message_link_position: SecOC links an AuthenticIPdu and
        CryptographicIPdu together by repeating a specific part (Message
        Linker) of the AuthenticIPdu in the CryptographicIPdu. This
        attribute defines the startPosition in bits of the
        messageLinker.
    :ivar secondary_freshness_value_id: This attribute defines the Id of
        the Secondary Freshness Value. The Secondary Freshness Value
        might be a normal counter or a time value. Please note that this
        attribute is for documentation only to allow the configuration
        of required freshness value manager and no upstream mapping is
        defined for it.
    :ivar secured_area_length: This attribute defines the length in
        bytes of the area within the payload Pdu which will be secured.
    :ivar secured_area_offset: This attribute defines the start position
        (offset in byte) of the area within the payload Pdu which will
        be secured.
    :ivar use_freshness_timestamp: This attribute specifies whether the
        Freshness Value is generated through individual Freshness
        Counters or by a Timestamps. The value is set to TRUE when
        Timestamps are used.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURE-COMMUNICATION-PROPS"

    auth_algorithm: String | None = field(
        default=None,
        metadata={
            "name": "AUTH-ALGORITHM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    auth_data_freshness_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "AUTH-DATA-FRESHNESS-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    auth_data_freshness_start_position: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "AUTH-DATA-FRESHNESS-START-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    auth_info_tx_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "AUTH-INFO-TX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_build_attempts: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-BUILD-ATTEMPTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_retries: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-RETRIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freshness_counter_sync_attempts: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FRESHNESS-COUNTER-SYNC-ATTEMPTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freshness_timestamp_time_period_factor: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FRESHNESS-TIMESTAMP-TIME-PERIOD-FACTOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freshness_value_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FRESHNESS-VALUE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freshness_value_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FRESHNESS-VALUE-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freshness_value_tx_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FRESHNESS-VALUE-TX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    message_link_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MESSAGE-LINK-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    message_link_position: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MESSAGE-LINK-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secondary_freshness_value_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECONDARY-FRESHNESS-VALUE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secured_area_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURED-AREA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secured_area_offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURED-AREA-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    use_freshness_timestamp: Boolean | None = field(
        default=None,
        metadata={
            "name": "USE-FRESHNESS-TIMESTAMP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SecuredPduHeaderEnum:
    """
    Defines the header which will be inserted into the SecuredIPdu.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURED-PDU-HEADER-ENUM"

    value: SecuredPduHeaderEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SecurityEventContextDataSourceEnum:
    """
    This enumeration controls the elements used to creating the resulting qualified
    security event.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-CONTEXT-DATA-SOURCE-ENUM"

    value: SecurityEventContextDataSourceEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SecurityEventReportingModeEnum:
    """
    This enumeration controls the reporting mode of a security event.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-REPORTING-MODE-ENUM"

    value: SecurityEventReportingModeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SendIndicationEnum:
    """
    This meta-class provides a way to specify in which way redundancy shall be
    applied on collection level.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SEND-INDICATION-ENUM"

    value: SendIndicationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SenderIntentEnum:
    """
    This meta-class represents the intent to specify how a given ServiceInterface
    is used from the perspective of a given event sender.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SENDER-INTENT-ENUM"

    value: SenderIntentEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SequenceCounterMapping:
    """The purpose of sequence counters is to map a response to the correct request
    of a known client.

    The SequenceCounter is mapped to the requestGroup and to the
    responseGroup.

    :ivar system_signal_ref: Reference to the SystemSignal with the
        SequenceCounter.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SEQUENCE-COUNTER-MAPPING"

    system_signal_ref: Optional["SequenceCounterMapping.SystemSignalRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SerializationTechnologyEnum:
    """
    This enumeration allows to choose a Serialization Technology.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERIALIZATION-TECHNOLOGY-ENUM"

    value: SerializationTechnologyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ServerArgumentImplPolicyEnum:
    """
    This defines how the argument type of the servers RunnableEntity is
    implemented.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVER-ARGUMENT-IMPL-POLICY-ENUM"

    value: ServerArgumentImplPolicyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ServiceDiagnosticRelevanceEnum:
    """
    This enumeration provides values to describe the diagnostic relevance of a
    SwcServiceDependency (specifically if the aggregated ServiceNeeds itself does
    not indicate a relevance for diagnostics).

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-DIAGNOSTIC-RELEVANCE-ENUM"

    value: ServiceDiagnosticRelevanceEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ServiceProviderEnum:
    """
    This represents a list of possible service providers.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-PROVIDER-ENUM"

    value: ServiceProviderEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ServiceVersionAcceptanceKindEnum:
    """
    Defined the possible acceptance kinds for required service instances.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-VERSION-ACCEPTANCE-KIND-ENUM"

    value: ServiceVersionAcceptanceKindEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SeverityEnum:
    """
    Definition of severity levels.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SEVERITY-ENUM"

    value: SeverityEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ShortNameFragment:
    """
    This class describes how the Referrable.shortName is composed of several
    shortNameFragments.

    :ivar role: This specifies the role of fragment to define e.g. the
        order of the fragments.
    :ivar fragment: This specifies a single shortName (fragment) which
        is part of the composed shortName.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SHORT-NAME-FRAGMENT"

    role: String | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fragment: Identifier | None = field(
        default=None,
        metadata={
            "name": "FRAGMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ShowContentEnum:
    """
    This specifies if the content of the xref element shall be rendered.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SHOW-CONTENT-ENUM"

    value: ShowContentEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ShowResourceAliasNameEnum:
    """
    This enumerator specifies if the alias names of the reference target shall be
    rendered with the xref.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SHOW-RESOURCE-ALIAS-NAME-ENUM"

    value: ShowResourceAliasNameEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ShowResourceCategoryEnum:
    """
    This enumerator specifies if the category of the reference target shall be
    rendered with the xref.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SHOW-RESOURCE-CATEGORY-ENUM"

    value: ShowResourceCategoryEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ShowResourceLongNameEnum:
    """
    This enumerator specifies if the long name of the reference target shall be
    rendered with the xref.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SHOW-RESOURCE-LONG-NAME-ENUM"

    value: ShowResourceLongNameEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ShowResourceNumberEnum:
    """
    This enumerator specifies if the number (e.g. chapter number) of the reference
    target shall be rendered with the xref.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SHOW-RESOURCE-NUMBER-ENUM"

    value: ShowResourceNumberEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ShowResourcePageEnum:
    """
    This enumerator specifies if the page number of the reference target shall be
    rendered with the xref.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SHOW-RESOURCE-PAGE-ENUM"

    value: ShowResourcePageEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ShowResourceShortNameEnum:
    """
    This enumerator specifies if the short name of the reference target shall be
    rendered with the xref.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SHOW-RESOURCE-SHORT-NAME-ENUM"

    value: ShowResourceShortNameEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ShowResourceTypeEnum:
    """
    This enumerator specifies if the type (e.g. derived from the class) of the
    reference target shall be rendered with the xref.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SHOW-RESOURCE-TYPE-ENUM"

    value: ShowResourceTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ShowSeeEnum:
    """
    This enumerator specifies if the word "see" shall be rendered before the xref.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SHOW-SEE-ENUM"

    value: ShowSeeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SignalFanEnum:
    """
    Signal Fan inside the Composition Component Type.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SIGNAL-FAN-ENUM"

    value: SignalFanEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SignalServiceTranslationControlEnum:
    """
    This enumeration allows to define how the service instance offer/subscribe
    control shall behave.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SIGNAL-SERVICE-TRANSLATION-CONTROL-ENUM"

    value: SignalServiceTranslationControlEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SingleLanguageUnitNames:
    """
    This represents the ability to express a display name.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar content:
    """

    class Meta:
        name = "SINGLE-LANGUAGE-UNIT-NAMES"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SUP",
                    "type": ForwardRef("SingleLanguageUnitNames.Sup"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUB",
                    "type": ForwardRef("SingleLanguageUnitNames.Sub"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Sup(Supscript):
        pass

    @dataclass(slots=True, kw_only=True)
    class Sub(Supscript):
        pass


@dataclass(slots=True, kw_only=True)
class SoAdConnectorType:
    """Availability of protocol plug-ins.

    Entries in the Socket and PDU Routing Tables.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SO-AD-CONNECTOR-TYPE"

    value: SoAdConnectorTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SoAdProtocolType:
    """
    Transport Protocols above IP.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SO-AD-PROTOCOL-TYPE"

    value: SoAdProtocolTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SoftwareClusterDependencyLogicalOperatorEnum:
    """
    This enumeration provides a set of operators to be used in a
    SoftwareClusterDependencyFormula.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-CLUSTER-DEPENDENCY-LOGICAL-OPERATOR-ENUM"

    value: SoftwareClusterDependencyLogicalOperatorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SoftwareClusterDependencyOperatorEnum:
    """
    This enumeration provides a choice of operators for comparison within a
    SoftwareClusterDependencyCompareCondition.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-CLUSTER-DEPENDENCY-OPERATOR-ENUM"

    value: SoftwareClusterDependencyOperatorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SoftwareClusterDiagnosticAddressSemanticsEnum:
    """
    This meta-class defines a list of semantics for the interpretation of
    diagnostic addresses in the context of a SoftwareCluster.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-CLUSTER-DIAGNOSTIC-ADDRESS-SEMANTICS-ENUM"

    value: SoftwareClusterDiagnosticAddressSemanticsEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SoftwareClusterInstallationBehaviorEnum:
    """
    This enumeration defines possible approaches for the installation behavior of a
    SoftwareCluster.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-CLUSTER-INSTALLATION-BEHAVIOR-ENUM"

    value: SoftwareClusterInstallationBehaviorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SoftwareContext:
    """
    Specifies the context of the software for this resource consumption.

    :ivar input: Specifies the input vector which is used to provide the
        ExecutionTime.
    :ivar state: Specifies the state the software is in when the
        ExecutionTime is provided.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-CONTEXT"

    input: String | None = field(
        default=None,
        metadata={
            "name": "INPUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    state: String | None = field(
        default=None,
        metadata={
            "name": "STATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SoftwarePackageActionTypeEnum:
    """
    This enumeration provides a choice of possible actions for the handling of a
    software package.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-PACKAGE-ACTION-TYPE-ENUM"

    value: SoftwarePackageActionTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SoftwarePackageActivationActionEnum:
    """
    This enumeration provides a choice of possible actions to be executed on
    installing a SoftwarePackage to a target Machine.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-PACKAGE-ACTIVATION-ACTION-ENUM"

    value: SoftwarePackageActivationActionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SoftwarePackageStoringEnum:
    """
    This enumeration controls where software packages are stored.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-PACKAGE-STORING-ENUM"

    value: SoftwarePackageStoringEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SomeipMessageTypeEnum:
    """
    Depending on the style of the communication different message types shall be
    set in the header of a SOME/IP message.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-MESSAGE-TYPE-ENUM"

    value: SomeipMessageTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SomeipProtocolRule:
    """
    Configuration of SOME/IP firewall rules.

    :ivar client_id: Filter for SOME/IP messages in which the clientId
        in the SOME/IP header matches.
    :ivar length_verification: Defines whether length verification is
        performed or not.
    :ivar major_version: Filter for SOME/IP messages in which the
        majorVersion  in the SOME/IP header matches.
    :ivar message_type: Filter for SOME/IP messages in which the
        messageType in the SOME/IP header matches.
    :ivar method_id: Filter for SOME/IP messages in which the methodId
        in the SOME/IP header matches.
    :ivar protocol_version: Filter for SOME/IP messages in which the
        protocolVersion  in the SOME/IP header matches.
    :ivar return_code: Filter for SOME/IP messages in which the
        returnCode  in the SOME/IP header matches.
    :ivar service_interface_id: Filter for SOME/IP messages in which the
        serviceInterfaceId in the SOME/IP header matches.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-PROTOCOL-RULE"

    client_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CLIENT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length_verification: Boolean | None = field(
        default=None,
        metadata={
            "name": "LENGTH-VERIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    major_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAJOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    message_type: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MESSAGE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "METHOD-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    return_code: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "RETURN-CODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SomeipSdRule:
    """
    Configuration of SOME/IP Service Discovery firewall rules.

    :ivar entry_type: Filter for SOME/IP SD messages in which the
        entryType in the SOME/IP header matches.
    :ivar event_group_id: Filter for SOME/IP SD messages in which the
        eventGroupId in the SOME/IP header matches.
    :ivar max_major_version: Filter for SOME/IP SD messages in which the
        MajorVersion in the SOME/IP header is smaller or equal than
        maxMajorVersion.
    :ivar max_minor_version: Filter for SOME/IP SD messages in which the
        MinorVersion in the SOME/IP header is smaller or equal than
        maxMinorVersion.
    :ivar min_major_version: Filter for SOME/IP SD messages in which the
        MajorVersion in the SOME/IP header is greater or equal than
        minMajorVersion.
    :ivar min_minor_version: Filter for SOME/IP SD messages in which the
        MinorVersion in the SOME/IP header is greater or equal than
        minMinorVersion.
    :ivar service_instance_id: Filter for SOME/IP SD messages in which
        the serviceInstanceId in the SOME/IP header matches.
    :ivar service_interface_id: Filter for SOME/IP SD messages in which
        the serviceInterfaceId in the SOME/IP header matches.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-SD-RULE"

    entry_type: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ENTRY-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_major_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-MAJOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_minor_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-MINOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_major_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-MAJOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_minor_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-MINOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SomeipServiceDiscovery:
    """
    This meta-class represents a specialization of the generic service discovery
    for the SOME/IP case.

    :ivar multicast_sd_ip_address_ref: This reference identifies the
        multicast IP address used for service discovery.
    :ivar multicast_secure_com_props_ref: Reference to a communication
        security protocol and its configuration settings that will
        provide communication security for Service Discovery messages
        that are transmitted using multicast, e.g. FindService message.
    :ivar someip_service_discovery_port: This attribute represents the
        port number reserved for service discovery.
    :ivar unicast_secure_com_props_refs: Reference to a communication
        security protocol and its configuration settings that will
        provide communication security for Service Discovery messages
        that are transmitted using unicast, e.g. OfferService as answer
        to a FindService message. .
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-SERVICE-DISCOVERY"

    multicast_sd_ip_address_ref: Optional["SomeipServiceDiscovery.MulticastSdIpAddressRef"] = field(
        default=None,
        metadata={
            "name": "MULTICAST-SD-IP-ADDRESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multicast_secure_com_props_ref: Optional[
        "SomeipServiceDiscovery.MulticastSecureComPropsRef"
    ] = field(
        default=None,
        metadata={
            "name": "MULTICAST-SECURE-COM-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    someip_service_discovery_port: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SOMEIP-SERVICE-DISCOVERY-PORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unicast_secure_com_props_refs: Optional["SomeipServiceDiscovery.UnicastSecureComPropsRefs"] = (
        field(
            default=None,
            metadata={
                "name": "UNICAST-SECURE-COM-PROPS-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class MulticastSdIpAddressRef(Ref):
        dest: NetworkEndpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MulticastSecureComPropsRef(Ref):
        dest: SecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class UnicastSecureComPropsRefs:
        unicast_secure_com_props_ref: list[
            "SomeipServiceDiscovery.UnicastSecureComPropsRefs.UnicastSecureComPropsRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "UNICAST-SECURE-COM-PROPS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class UnicastSecureComPropsRef(Ref):
            dest: SecureComPropsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SomeipServiceVersion:
    """
    This meta-class represents the ability to describe a version of a SOME/IP
    Service.

    :ivar major_version: Major Version of the ServiceInterface.
    :ivar minor_version: Minor Version of the ServiceInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-SERVICE-VERSION"

    major_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAJOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minor_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SomeipTpConnection:
    """A connection identifies the sender and the receiver of this particular
    communication.

    The SOME/IP TP module routes a Pdu through this connection.

    :ivar separation_time: Sets the duration of the minimum time in
        seconds the SOME/IP TP module shall wait between the
        transmissions of NPdus.
    :ivar tp_channel_ref: Assignment of configuration properties valid
        for this SomeipTpConnection.
    :ivar tp_sdu_ref: Reference to an IPdu that is segmented by the
        Transport Protocol.
    :ivar transport_pdu_ref: Reference to the segmented IPdu.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-TP-CONNECTION"

    separation_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SEPARATION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_channel_ref: Optional["SomeipTpConnection.TpChannelRef"] = field(
        default=None,
        metadata={
            "name": "TP-CHANNEL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_sdu_ref: Optional["SomeipTpConnection.TpSduRef"] = field(
        default=None,
        metadata={
            "name": "TP-SDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transport_pdu_ref: Optional["SomeipTpConnection.TransportPduRef"] = field(
        default=None,
        metadata={
            "name": "TRANSPORT-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TpChannelRef(Ref):
        dest: SomeipTpChannelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TpSduRef(Ref):
        dest: PduTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TransportPduRef(Ref):
        dest: PduTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SomeipTransformerSessionHandlingEnum:
    """
    Enables or disable session handling for SOME/IP transformer.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-TRANSFORMER-SESSION-HANDLING-ENUM"

    value: SomeipTransformerSessionHandlingEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SovdGatewayLocalEndpointTcpConfig:
    """
    This meta-class provides the ability to define the TCP configuration of a local
    endpoint for external communication of an SOVD gateway.

    :ivar ipv_4_address: This attribute represents the IPv4 address for
        the case that IPv4 is used for communication between the SOVD
        gateway and a client.
    :ivar ipv_6_address: This attribute represents the IPv6 address for
        the case that IPv6 is used for communication between the SOVD
        gateway and a client.
    :ivar udp_port: This attribute describes the port number of the port
        used for UDP communication.
    :ivar tcp_port: This attribute describes the port number of the port
        used for TCP communication.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOVD-GATEWAY-LOCAL-ENDPOINT-TCP-CONFIG"

    ipv_4_address: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "IPV-4-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_6_address: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "IPV-6-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    udp_port: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UDP-PORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_port: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-PORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class StandardNameEnum:
    """
    This enumeration lists all allowed standard abbreviations.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STANDARD-NAME-ENUM"

    value: StandardNameEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class StateManagementCompareEnum:
    """Enumeration for the type of a comparison of values usually expressed by the following operators: ==, !=, &lt;, &lt;=, &gt;, &gt;=

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-COMPARE-ENUM"

    value: StateManagementCompareEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class StateManagementLogicalOperatorEnum:
    """
    Logical AND and OR operation for the evaluation of rules in state management.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-LOGICAL-OPERATOR-ENUM"

    value: StateManagementLogicalOperatorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class StorageConditionStatusEnum:
    """
    This enumeration specifies the initial status for enable or disable of storage
    of a diagnostic event.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STORAGE-CONDITION-STATUS-ENUM"

    value: StorageConditionStatusEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SupportBufferLockingEnum:
    """
    This enumeration represents the ability to define the buffer locking behavior.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SUPPORT-BUFFER-LOCKING-ENUM"

    value: SupportBufferLockingEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SwBitRepresentation:
    """Description of the structure of a bit variable: Comprises of the bitPosition in a memory object (e.g. swHostVariable, which stands parallel to swBitRepresentation) and the numberOfBits . In this way, interrelated memory areas can be described. Non-related memory areas are not supported.

    :ivar bit_position: If the "bit data object" is hosted within
        another data object (e.g. if the memory can be accessed via byte
        as well as bit address), this attribute specifies the position
        of the data object. The count starts at zero (0).
    :ivar number_of_bits: Number of bits allocated by a "bit data
        object" within its host data object.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-BIT-REPRESENTATION"

    bit_position: Integer | None = field(
        default=None,
        metadata={
            "name": "BIT-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    number_of_bits: Integer | None = field(
        default=None,
        metadata={
            "name": "NUMBER-OF-BITS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SwCalibrationAccessEnum:
    """Determines the access rights to a data object w.r.t.

    measurement and calibration.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-CALIBRATION-ACCESS-ENUM"

    value: SwCalibrationAccessEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SwImplPolicyEnum:
    """
    Specifies the implementation strategy with respect to consistency mechanisms of
    variables.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-IMPL-POLICY-ENUM"

    value: SwImplPolicyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SwPointerTargetProps:
    """This element defines, that the data object (which is specified by the
    aggregating element) contains a reference to another data object or to a
    function in the CPU code.

    This corresponds to a pointer in the C-language. The attributes of
    this element describe the category and the detailed properties of
    the target which is either a data description or a function
    signature.

    :ivar target_category: This specifies the category of the target: *
        In case of a data pointer, it shall specify the category of the
        referenced data. * In case of a function pointer, it could be
        used to denote the category of the referenced BswModuleEntry.
    :ivar sw_data_def_props: The properties of the target data type.
    :ivar function_pointer_signature_ref: The referenced BswModuleEntry
        serves as the signature of a function pointer definition.
        Primary use case: function pointer passed as argument to other
        function.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-POINTER-TARGET-PROPS"

    target_category: Identifier | None = field(
        default=None,
        metadata={
            "name": "TARGET-CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    function_pointer_signature_ref: Optional["SwPointerTargetProps.FunctionPointerSignatureRef"] = (
        field(
            default=None,
            metadata={
                "name": "FUNCTION-POINTER-SIGNATURE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FunctionPointerSignatureRef(Ref):
        dest: BswModuleEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwServiceImplPolicyEnum:
    """
    This specifies the legal values for the implementation policies for services
    (in AUTOSAR: BswModuleEntry-s).

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-SERVICE-IMPL-POLICY-ENUM"

    value: SwServiceImplPolicyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SwServiceReentranceEnum:
    """
    Specifies the legal values for reentrancy of services.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-SERVICE-REENTRANCE-ENUM"

    value: SwServiceReentranceEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SwVariableAccessImplPolicyEnum:
    """
    Detailed access policy for variables, for which data consistency is implemented
    via messages.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-VARIABLE-ACCESS-IMPL-POLICY-ENUM"

    value: SwVariableAccessImplPolicyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SwcServiceDependencyInCompositionInstanceRef:
    """
    :ivar base_ref:
    :ivar root_context_ref: This identifies the rootSoftwareComposition
        if the instanceRef is modelled in the System context.
    :ivar context_sw_component_prototype_ref:
    :ivar target_swc_service_dependency_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-SERVICE-DEPENDENCY-IN-COMPOSITION-INSTANCE-REF"

    base_ref: Optional["SwcServiceDependencyInCompositionInstanceRef.BaseRef"] = field(
        default=None,
        metadata={
            "name": "BASE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    root_context_ref: Optional["SwcServiceDependencyInCompositionInstanceRef.RootContextRef"] = (
        field(
            default=None,
            metadata={
                "name": "ROOT-CONTEXT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    context_sw_component_prototype_ref: list[
        "SwcServiceDependencyInCompositionInstanceRef.ContextSwComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_swc_service_dependency_ref: Optional[
        "SwcServiceDependencyInCompositionInstanceRef.TargetSwcServiceDependencyRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-SWC-SERVICE-DEPENDENCY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BaseRef(Ref):
        dest: CompositionSwComponentTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RootContextRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextSwComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetSwcServiceDependencyRef(Ref):
        dest: SwcServiceDependencySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwcServiceDependencyInSystemInstanceRef:
    """
    :ivar base_ref:
    :ivar context_root_sw_composition_ref:
    :ivar context_sw_component_prototype_ref:
    :ivar target_swc_service_dependency_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-SERVICE-DEPENDENCY-IN-SYSTEM-INSTANCE-REF"

    base_ref: Optional["SwcServiceDependencyInSystemInstanceRef.BaseRef"] = field(
        default=None,
        metadata={
            "name": "BASE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_root_sw_composition_ref: Optional[
        "SwcServiceDependencyInSystemInstanceRef.ContextRootSwCompositionRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ROOT-SW-COMPOSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_sw_component_prototype_ref: list[
        "SwcServiceDependencyInSystemInstanceRef.ContextSwComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_swc_service_dependency_ref: Optional[
        "SwcServiceDependencyInSystemInstanceRef.TargetSwcServiceDependencyRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-SWC-SERVICE-DEPENDENCY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BaseRef(Ref):
        dest: SystemSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextRootSwCompositionRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextSwComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetSwcServiceDependencyRef(Ref):
        dest: SwcServiceDependencySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwcToEcuMappingConstraintType:
    """There are two different SwcToEcuMapping constraints: dedicated mapping and exclusive mapping.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-TO-ECU-MAPPING-CONSTRAINT-TYPE"

    value: SwcToEcuMappingConstraintTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SwcToSwcOperationArgumentsDirectionEnum:
    """
    Direction addressed by this  element.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-TO-SWC-OPERATION-ARGUMENTS-DIRECTION-ENUM"

    value: SwcToSwcOperationArgumentsDirectionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SynchronizationTypeEnum:
    """
    This is used to describe the type of the synchronization timing constraint.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYNCHRONIZATION-TYPE-ENUM"

    value: SynchronizationTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TcpIpIcmpv4Props:
    """
    This meta-class specifies the configuration options for ICMPv4 (Internet
    Control Message Protocol).

    :ivar tcp_ip_icmp_v_4_echo_reply_enabled: This attribute enables or
        disables transmission of ICMP echo reply message in case of a
        ICMP echo reception.
    :ivar tcp_ip_icmp_v_4_ttl: This attribute is only relevant in case
        that ICMP (Internet Control Message Protocol) is used. It
        specifies the default Time-to-live value of outgoing ICMP
        packets.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TCP-IP-ICMPV-4-PROPS"

    tcp_ip_icmp_v_4_echo_reply_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-ICMP-V-4-ECHO-REPLY-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_icmp_v_4_ttl: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-ICMP-V-4-TTL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TcpIpIcmpv6Props:
    """
    This meta-class specifies the configuration options for ICMPv6 (Internet
    Control Message Protocol).

    :ivar tcp_ip_icmp_v_6_echo_reply_avoid_fragmentation: This attribute
        defines whether the echo reply is only transmitted in case that
        the incoming ICMPv6 Echo Request (Pings) fits the MTU of the
        respective interface, i.e. can be transmitted without IPv6
        fragmentation.
    :ivar tcp_ip_icmp_v_6_echo_reply_enabled: This attribute enables or
        disables transmission of ICMP echo reply message in case of a
        ICMP echo reception.
    :ivar tcp_ip_icmp_v_6_hop_limit: Default Hop-Limit value of outgoing
        ICMPv6 packets.
    :ivar tcp_ip_icmp_v_6_msg_destination_unreachable_enabled: This
        attribute Enables/Disables the transmission of Destination
        Unreachable Messages.
    :ivar tcp_ip_icmp_v_6_msg_parameter_problem_enabled: If enabled an
        ICMPv6 parameter problem message will be sent if a received
        packet has been dropped due to unknown options or headers that
        are found in the packet.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TCP-IP-ICMPV-6-PROPS"

    tcp_ip_icmp_v_6_echo_reply_avoid_fragmentation: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-ICMP-V-6-ECHO-REPLY-AVOID-FRAGMENTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_icmp_v_6_echo_reply_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-ICMP-V-6-ECHO-REPLY-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_icmp_v_6_hop_limit: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-ICMP-V-6-HOP-LIMIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_icmp_v_6_msg_destination_unreachable_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-ICMP-V-6-MSG-DESTINATION-UNREACHABLE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_icmp_v_6_msg_parameter_problem_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-ICMP-V-6-MSG-PARAMETER-PROBLEM-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TcpProps:
    """
    This meta-class specifies the configuration options for TCP (Transmission
    Control Protocol).

    :ivar tcp_congestion_avoidance_enabled: Enables (TRUE) or disables
        (FALSE) support of TCP congestion avoidance algorithm according
        to IETF RFC 5681.
    :ivar tcp_delayed_ack_timeout: The maximal time an acknowledgement
        is delayed for transmission in seconds.
    :ivar tcp_fast_recovery_enabled: Enables (TRUE) or disables (FALSE)
        support of TCP Fast Recovery according to IETF RFC 5681.
    :ivar tcp_fast_retransmit_enabled: Enables (TRUE) or disables
        (FALSE) support of TCP Fast Retransmission according to IETF RFC
        5681.
    :ivar tcp_fin_wait_2_timeout: Timeout in [s] to receive a FIN from
        the remote node (after this node has initiated connection
        termination), i.e. maximum time waiting in FINWAIT-2 for a
        connection termination request from the remote TCP.
    :ivar tcp_keep_alive_enabled: Enables (TRUE) or disables (FALSE) TCP
        Keep Alive Probes according to IETF RFC 1122 chapter 4.2.3.6.
    :ivar tcp_keep_alive_interval: Specifies the interval in seconds
        between subsequent keepalive probes.
    :ivar tcp_keep_alive_probes_max: Maximum number of times that a TCP
        Keep Alive is retransmitted before the connection is closed.
    :ivar tcp_keep_alive_time: Specifies the time in [s] between the
        last data packet sent (simple ACKs are not considered data) and
        the first keepalive probe.
    :ivar tcp_max_rtx: Maximum number of times that a TCP segment is
        retransmitted before the TCP connection is closed. This
        parameter is only valid if tcpRetransmissionTimeout is
        configured. Note: This parameter also applies for FIN
        retransmissions.
    :ivar tcp_msl: Maximum segment lifetime in [s].
    :ivar tcp_nagle_enabled: Enables (TRUE) or disables (FALSE) support
        of Nagle's algorithm according to IETF RFC 1122 (chapter 4.2.3.4
        When to Send Data). If enabled the Nagle's algorithm is
        activated per default for all TCP sockets, but can be
        deactivated per Socket (with the attribute
        TcpTp.nagleAlgorithm).
    :ivar tcp_receive_window_max: Default value of maximum receive
        window in bytes.
    :ivar tcp_retransmission_timeout: Timeout in [s] before an
        unacknowledged TCP segment is sent again. If the timeout is
        disabled, no TCP segments shall be retransmitted.
    :ivar tcp_slow_start_enabled: Enables (TRUE) or disables (FALSE)
        support of TCP slow start algorithm according to IETF RFC 5681.
    :ivar tcp_syn_max_rtx: Maximum number of times that a TCP SYN is
        retransmitted.
    :ivar tcp_syn_received_timeout: Timeout in [s] to complete a
        remotely initiated TCP connection establishment, i.e. maximum
        time waiting in SYN-RECEIVED for a confirming connection request
        acknowledgement after having both received and sent a connection
        request.
    :ivar tcp_ttl: Default Time-to-live value of outgoing TCP packets.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TCP-PROPS"

    tcp_congestion_avoidance_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-CONGESTION-AVOIDANCE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_delayed_ack_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-DELAYED-ACK-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_fast_recovery_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-FAST-RECOVERY-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_fast_retransmit_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-FAST-RETRANSMIT-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_fin_wait_2_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-FIN-WAIT-2-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_keep_alive_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-KEEP-ALIVE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_keep_alive_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-KEEP-ALIVE-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_keep_alive_probes_max: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-KEEP-ALIVE-PROBES-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_keep_alive_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-KEEP-ALIVE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_max_rtx: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-MAX-RTX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_msl: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-MSL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_nagle_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-NAGLE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_receive_window_max: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-RECEIVE-WINDOW-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_retransmission_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-RETRANSMISSION-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_slow_start_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-SLOW-START-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_syn_max_rtx: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-SYN-MAX-RTX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_syn_received_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-SYN-RECEIVED-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ttl: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-TTL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TcpRoleEnum:
    """
    This enumeration defines whether a TCP node has the tcp server role or the
    client role.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TCP-ROLE-ENUM"

    value: TcpRoleEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TcpRule:
    """
    Configuration of TCP filter rules.

    :ivar checksum_verification: Defines whether checksum verification
        is performed or not.
    :ivar max_destination_port_number: Filter to match packets with the
        maximum destination UDP/TCP port  number.
    :ivar max_source_port_number: Filter to match packets with the
        maximum source UDP/TCP port  number.
    :ivar min_destination_port_number: Filter to match packets with the
        minimum destination UDP/TCP port  number.
    :ivar min_source_port_number: Filter to match packets with the
        minimum source UDP/TCP port  number.
    :ivar number_of_parallel_tcp_sessions: This attribute defines the
        maximal number of TCP Sessions that are allowed to be
        established.
    :ivar state_management_based_on_tcp_flags: This attribute defines
        whether the StateManagement is based on TCP flags or not.
    :ivar timeout_check: This attribute defines the TCP Session timeout
        in seconds
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TCP-RULE"

    checksum_verification: Boolean | None = field(
        default=None,
        metadata={
            "name": "CHECKSUM-VERIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_destination_port_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-DESTINATION-PORT-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_source_port_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-SOURCE-PORT-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_destination_port_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-DESTINATION-PORT-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_source_port_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-SOURCE-PORT-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    number_of_parallel_tcp_sessions: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NUMBER-OF-PARALLEL-TCP-SESSIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    state_management_based_on_tcp_flags: Boolean | None = field(
        default=None,
        metadata={
            "name": "STATE-MANAGEMENT-BASED-ON-TCP-FLAGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_check: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-CHECK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventBswInternalBehaviorTypeEnum:
    """
    This is used to describe the specific event type of a
    TDEventBswInternalBehavior.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-BSW-INTERNAL-BEHAVIOR-TYPE-ENUM"

    value: TdEventBswInternalBehaviorTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventBswModeDeclarationTypeEnum:
    """
    This is used to describe the specific event type of a
    TDEventBswModeDeclaration.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-BSW-MODE-DECLARATION-TYPE-ENUM"

    value: TdEventBswModeDeclarationTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventBswModuleTypeEnum:
    """
    This is used to describe the specific event type of a TDEventBswModule.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-BSW-MODULE-TYPE-ENUM"

    value: TdEventBswModuleTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventFrameEthernetTypeEnum:
    """
    This is used to describe the specific event type of a TDEventFrameEthernet.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-FRAME-ETHERNET-TYPE-ENUM"

    value: TdEventFrameEthernetTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventFrameTypeEnum:
    """
    This is used to describe the specific event type of a TDEventFrame.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-FRAME-TYPE-ENUM"

    value: TdEventFrameTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventIPduTypeEnum:
    """
    This is used to describe the specific event type of a TDEventIPdu.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-I-PDU-TYPE-ENUM"

    value: TdEventIPduTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventISignalTypeEnum:
    """
    This is used to describe the specific event type of a TDEventISignal.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-I-SIGNAL-TYPE-ENUM"

    value: TdEventISignalTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventModeDeclarationTypeEnum:
    """
    This is used to describe the specific event type of a TDEventModeDeclaration.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-MODE-DECLARATION-TYPE-ENUM"

    value: TdEventModeDeclarationTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventOccurrenceExpressionFormula:
    """This is an extension of the FormulaExpression for the AUTOSAR Timing
    Extensions.

    A TDEventOccurrenceExpressionFormula provides the means to express
    the temporal characteristics of timing event occurrences in
    correlation with specific variable and argument values. The formal
    definition of the extended functions (ExtUnaryFunctions) is
    described in detail in the AUTOSAR Timing Extensions.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar content:
    """

    class Meta:
        name = "TD-EVENT-OCCURRENCE-EXPRESSION-FORMULA"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "ARGUMENT-REF",
                    "type": ForwardRef("TdEventOccurrenceExpressionFormula.ArgumentRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "EVENT-REF",
                    "type": ForwardRef("TdEventOccurrenceExpressionFormula.EventRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "MODE-REF",
                    "type": ForwardRef("TdEventOccurrenceExpressionFormula.ModeRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "VARIABLE-REF",
                    "type": ForwardRef("TdEventOccurrenceExpressionFormula.VariableRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ArgumentRef(Ref):
        dest: AutosarOperationArgumentInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: TimingDescriptionEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ModeRef(Ref):
        dest: TimingModeInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class VariableRef(Ref):
        dest: AutosarVariableInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventOperationTypeEnum:
    """
    This is used to describe the specific event type of a TDEventOperation.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-OPERATION-TYPE-ENUM"

    value: TdEventOperationTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventServiceInstanceDiscoveryTypeEnum:
    """
    This is used to describe the specific event type of a
    TDEventServiceInstanceDiscovery.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-SERVICE-INSTANCE-DISCOVERY-TYPE-ENUM"

    value: TdEventServiceInstanceDiscoveryTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventServiceInstanceEventTypeEnum:
    """
    This is used to describe the specific event type of a
    TDEventServiceInstanceEvent.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-SERVICE-INSTANCE-EVENT-TYPE-ENUM"

    value: TdEventServiceInstanceEventTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventServiceInstanceFieldTypeEnum:
    """
    This is used to describe the specific event type of a
    TDEventServiceInstanceField.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-SERVICE-INSTANCE-FIELD-TYPE-ENUM"

    value: TdEventServiceInstanceFieldTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventServiceInstanceMethodTypeEnum:
    """
    This is used to describe the specific event type of a
    TDEventServiceInstanceMethod.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-SERVICE-INSTANCE-METHOD-TYPE-ENUM"

    value: TdEventServiceInstanceMethodTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventSwcInternalBehaviorTypeEnum:
    """
    This is used to describe the specific event type of a
    TDEventSwcInternalBehavior.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-SWC-INTERNAL-BEHAVIOR-TYPE-ENUM"

    value: TdEventSwcInternalBehaviorTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventTriggerTypeEnum:
    """
    This is used to describe the specific event type of a TDEventTrigger.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-TRIGGER-TYPE-ENUM"

    value: TdEventTriggerTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventVariableDataPrototypeTypeEnum:
    """
    This is used to describe the specific event type of a
    TDEventVariableDataPrototype.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-VARIABLE-DATA-PROTOTYPE-TYPE-ENUM"

    value: TdEventVariableDataPrototypeTypeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdHeaderIdRange:
    """Specifies a range of PDU header identifiers.

    This range is specified by a minimum and maximum header identifier;
    and the maximum header identifier shall be greater than or equal the
    minimum header identifier.

    :ivar max_header_id: Specifies the maximum PDU header identifier, in
        other words the upper bound of a range of PDU header
        identifiers.
    :ivar min_header_id: Specifies the minimum PDU header identifier, in
        other words the lower bound of a range of PDU header
        identifiers.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-HEADER-ID-RANGE"

    max_header_id: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-HEADER-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_header_id: Integer | None = field(
        default=None,
        metadata={
            "name": "MIN-HEADER-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TerminationBehaviorEnum:
    """
    This enumeration provides options for controlling of how a Process terminates.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TERMINATION-BEHAVIOR-ENUM"

    value: TerminationBehaviorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TextualCondition:
    """Specifies additional conditions for one or more model elements.

    The condition is described using human language.

    :ivar text: Human language description of the condition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TEXTUAL-CONDITION"

    text: String | None = field(
        default=None,
        metadata={
            "name": "TEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TimeSyncCorrection:
    """
    This meta-class represents the attributes used for the correction of time
    synchronization.

    :ivar allow_provider_rate_correction: Defines whether the rate
        correction value of a Time Base can be set by means of the
        method setRateCorrection(). false: rate correction cannot be set
        by method setRateCorrection(). true: rate correction can be set
        by method setRateCorrection().
    :ivar offset_correction_adaption_interval: Defines the interval
        during which the adaptive rate correction cancels out the rate
        and time deviation. Unit: seconds.
    :ivar offset_correction_jump_threshold: Threshold for the correction
        method. Deviations below this value will be corrected by a
        linear reduction over a defined timespan. Values equal and
        greater than this value will be corrected by immediately setting
        the correct time and rate in form of a jump. Unit: seconds.
    :ivar rate_corrections_per_measurement_duration: Number of
        simultaneous rate measurements to determine the current rate
        deviation.
    :ivar rate_deviation_measurement_duration: Time span used to
        calculate the rate deviation. Unit: seconds.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIME-SYNC-CORRECTION"

    allow_provider_rate_correction: Boolean | None = field(
        default=None,
        metadata={
            "name": "ALLOW-PROVIDER-RATE-CORRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offset_correction_adaption_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "OFFSET-CORRECTION-ADAPTION-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offset_correction_jump_threshold: TimeValue | None = field(
        default=None,
        metadata={
            "name": "OFFSET-CORRECTION-JUMP-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rate_corrections_per_measurement_duration: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "RATE-CORRECTIONS-PER-MEASUREMENT-DURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rate_deviation_measurement_duration: TimeValue | None = field(
        default=None,
        metadata={
            "name": "RATE-DEVIATION-MEASUREMENT-DURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TimeSyncTechnologyEnum:
    """Timesynchronization.

    Server/Client configuration.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIME-SYNC-TECHNOLOGY-ENUM"

    value: TimeSyncTechnologyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TimeSynchronizationKindEnum:
    """
    Defines the possible kinds of TimeSynchronizationInterfaces.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIME-SYNCHRONIZATION-KIND-ENUM"

    value: TimeSynchronizationKindEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TimeValueValueVariationPoint:
    """
    This class represents the ability to express a formula for a numerical time
    value.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar binding_time: This is the binding time in which the attribute
        value needs to be bound. If this attribute is missing, the
        attribute is not a variation point. In particular this means
        that It needs to be a single value according to the type
        specified in the pure model. It is an error if it is still a
        formula.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar sd: This special data is provided to allow synchronization of
        Attribute value variation points with variant management
        systems. The usage is subject of agreement between the involved
        parties.
    :ivar short_label: This allows to identify the variation point. It
        is also intended to allow RTE support for CompileTime Variation
        points.
    :ivar content:
    """

    class Meta:
        name = "TIME-VALUE-VALUE-VARIATION-POINT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    binding_time: BindingTimeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "BINDING-TIME",
            "type": "Attribute",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    sd: str | None = field(
        default=None,
        metadata={
            "name": "SD",
            "type": "Attribute",
        },
    )
    short_label: str | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef("TimeValueValueVariationPoint.SyscStringRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("TimeValueValueVariationPoint.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TimingConditionFormula:
    """A TimingConditionFormula describes a specific dependency.

    The expression shall be a boolean expression addressing modes,
    variables, arguments, and/or events.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar content:
    """

    class Meta:
        name = "TIMING-CONDITION-FORMULA"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "TIMING-ARGUMENT-REF",
                    "type": ForwardRef("TimingConditionFormula.TimingArgumentRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "TIMING-CONDITION-REF",
                    "type": ForwardRef("TimingConditionFormula.TimingConditionRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "TIMING-EVENT-REF",
                    "type": ForwardRef("TimingConditionFormula.TimingEventRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "TIMING-MODE-REF",
                    "type": ForwardRef("TimingConditionFormula.TimingModeRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "TIMING-VARIABLE-REF",
                    "type": ForwardRef("TimingConditionFormula.TimingVariableRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TimingArgumentRef(Ref):
        dest: AutosarOperationArgumentInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TimingConditionRef(Ref):
        dest: TimingConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TimingEventRef(Ref):
        dest: TimingDescriptionEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TimingModeRef(Ref):
        dest: TimingModeInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TimingVariableRef(Ref):
        dest: AutosarVariableInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TlsPskIdentity:
    """
    This element is used to describe the pre-shared key shared during the handshake
    among the communication parties, to establish a TLS connection if the handshake
    is based on the existence of a pre-shared key.

    :ivar pre_shared_key_ref: This reference identifies the applicable
        cryptographic key.
    :ivar psk_identity: This attribute provides the key identification.
    :ivar psk_identity_hint: This attribute provides the identity hint
        for a pre-shared key.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TLS-PSK-IDENTITY"

    pre_shared_key_ref: Optional["TlsPskIdentity.PreSharedKeyRef"] = field(
        default=None,
        metadata={
            "name": "PRE-SHARED-KEY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    psk_identity: String | None = field(
        default=None,
        metadata={
            "name": "PSK-IDENTITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    psk_identity_hint: String | None = field(
        default=None,
        metadata={
            "name": "PSK-IDENTITY-HINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PreSharedKeyRef(Ref):
        dest: CryptoServiceKeySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TlsVersionEnum:
    """
    This meta-class has the ability to identify a specific version of the
    transport-layer security (TLS) protocol.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TLS-VERSION-ENUM"

    value: TlsVersionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TlvDataIdDefinition:
    """
    This meta-class represents the ability to define the tlvDataId.

    :ivar id: This attribute represents the definition of the value of
        the TlvDataId
    :ivar tlv_argument_ref: This reference assigns a tlvDataId to a
        given argument of a ClientServerOperation.
    :ivar tlv_implementation_data_type_element_ref: This reference
        associates the definition of a TLV data id with a given
        AbstractImplementationDataTypeElement.
    :ivar tlv_record_element_ref: This reference associates the
        definition of a TLV data id with a given
        ApplicationRecordElement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TLV-DATA-ID-DEFINITION"

    id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tlv_argument_ref: Optional["TlvDataIdDefinition.TlvArgumentRef"] = field(
        default=None,
        metadata={
            "name": "TLV-ARGUMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tlv_implementation_data_type_element_ref: Optional[
        "TlvDataIdDefinition.TlvImplementationDataTypeElementRef"
    ] = field(
        default=None,
        metadata={
            "name": "TLV-IMPLEMENTATION-DATA-TYPE-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tlv_record_element_ref: Optional["TlvDataIdDefinition.TlvRecordElementRef"] = field(
        default=None,
        metadata={
            "name": "TLV-RECORD-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TlvArgumentRef(Ref):
        dest: ArgumentDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TlvImplementationDataTypeElementRef(Ref):
        dest: AbstractImplementationDataTypeElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TlvRecordElementRef(Ref):
        dest: ApplicationRecordElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TpAckType:
    """
    Type of Acknowledgement.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TP-ACK-TYPE"

    value: TpAckTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TpPort:
    """
    Dynamic or direct assignment of a PortNumber.

    :ivar dynamically_assigned: Indicates whether the source port is
        dynamically assigned.
    :ivar port_number: Port Number.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TP-PORT"

    dynamically_assigned: Boolean | None = field(
        default=None,
        metadata={
            "name": "DYNAMICALLY-ASSIGNED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PORT-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TransferPropertyEnum:
    """
    Transfer Properties of a Signal.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRANSFER-PROPERTY-ENUM"

    value: TransferPropertyEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TransformerClassEnum:
    """
    Specifies the transformer class of a transformer.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRANSFORMER-CLASS-ENUM"

    value: TransformerClassEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TransmissionAcknowledgementRequest:
    """Requests transmission acknowledgement that data has been sent successfully.

    Success/failure is reported via a SendPoint of a RunnableEntity.

    :ivar timeout: Number of seconds before an error is reported or in
        case of allowed redundancy, the value is sent again.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRANSMISSION-ACKNOWLEDGEMENT-REQUEST"

    timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TransmissionModeDefinitionEnum:
    """
    This meta-class defines possible settings for the transmission mode.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRANSMISSION-MODE-DEFINITION-ENUM"

    value: TransmissionModeDefinitionEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TransportLayerProtocolEnum:
    """
    This enumeration allows to choose a TCP/IP transport layer protocol.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRANSPORT-LAYER-PROTOCOL-ENUM"

    value: TransportLayerProtocolEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TriggerIPduSendCondition:
    """The condition defined by this class evaluates to true if one of the
    referenced modeDeclarations (OR associated) is active.

    The condition is used to define when the Pdu is triggered with the
    Com_TriggerIPDUSend API call.

    :ivar mode_declaration_refs: Reference to one modeDeclaration which
        is OR associated in the context of the TriggerIPduSendCondition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRIGGER-I-PDU-SEND-CONDITION"

    mode_declaration_refs: Optional["TriggerIPduSendCondition.ModeDeclarationRefs"] = field(
        default=None,
        metadata={
            "name": "MODE-DECLARATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ModeDeclarationRefs:
        mode_declaration_ref: list[
            "TriggerIPduSendCondition.ModeDeclarationRefs.ModeDeclarationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ModeDeclarationRef(Ref):
            dest: ModeDeclarationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class TriggerInExecutableInstanceRef:
    """
    :ivar context_root_sw_component_prototype_ref:
    :ivar context_component_prototype_ref:
    :ivar context_r_port_prototype_ref:
    :ivar target_trigger_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRIGGER-IN-EXECUTABLE-INSTANCE-REF"

    context_root_sw_component_prototype_ref: Optional[
        "TriggerInExecutableInstanceRef.ContextRootSwComponentPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ROOT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_prototype_ref: list[
        "TriggerInExecutableInstanceRef.ContextComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_r_port_prototype_ref: Optional[
        "TriggerInExecutableInstanceRef.ContextRPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-R-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_trigger_ref: Optional["TriggerInExecutableInstanceRef.TargetTriggerRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRootSwComponentPrototypeRef(Ref):
        dest: RootSwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextRPortPrototypeRef(Ref):
        dest: RPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetTriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TriggerInSystemInstanceRef:
    """
    :ivar context_composition_ref: This represents the reference to the
        RootSwCompositiontype representing a context of the InstanceRef.
    :ivar context_component_ref: This represents the set of context
        components. The association is ordered because it needs to
        respect the nesting order.
    :ivar context_port_ref: This represents the PortPrototype in which
        the target Trigger is located.
    :ivar target_trigger_ref: This represents the target Trigger.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRIGGER-IN-SYSTEM-INSTANCE-REF"

    context_composition_ref: Optional["TriggerInSystemInstanceRef.ContextCompositionRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-COMPOSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_component_ref: list["TriggerInSystemInstanceRef.ContextComponentRef"] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_port_ref: Optional["TriggerInSystemInstanceRef.ContextPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_trigger_ref: Optional["TriggerInSystemInstanceRef.TargetTriggerRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextCompositionRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextPortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetTriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TriggerMapping:
    """
    Defines the mapping of two particular unequally named Triggers in the given
    context.

    :ivar first_trigger_ref: A Trigger to be mapped.
    :ivar second_trigger_ref: A Trigger to be mapped.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRIGGER-MAPPING"

    first_trigger_ref: Optional["TriggerMapping.FirstTriggerRef"] = field(
        default=None,
        metadata={
            "name": "FIRST-TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    second_trigger_ref: Optional["TriggerMapping.SecondTriggerRef"] = field(
        default=None,
        metadata={
            "name": "SECOND-TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FirstTriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecondTriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TriggerMode:
    """
    IPduM can be configured to send a transmission request for the new multiplexed
    I-PDU to the PDU-Router because of conditions/ modes.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRIGGER-MODE"

    value: TriggerModeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TrustedPlatformExecutableLaunchBehaviorEnum:
    """
    This enumeration provides options for controlling the behavior of how
    authentication affects the ability to launch an Executable.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRUSTED-PLATFORM-EXECUTABLE-LAUNCH-BEHAVIOR-ENUM"

    value: TrustedPlatformExecutableLaunchBehaviorEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TtcanTriggerType:
    """
    This type lists all trigger types for a time window.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TTCAN-TRIGGER-TYPE"

    value: TtcanTriggerTypeSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class UdpChecksumCalculationEnum:
    """
    This enumeration defines the UDP checksum calculation.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UDP-CHECKSUM-CALCULATION-ENUM"

    value: UdpChecksumCalculationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class UdpCollectionTriggerEnum:
    """
    Defines whether the ServiceInterface element (event or method) contributes to
    the triggering of the udp data transmission if data collection is enabled.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UDP-COLLECTION-TRIGGER-ENUM"

    value: UdpCollectionTriggerEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class UdpNmEcu:
    """
    Udp NM specific ECU attributes.

    :ivar nm_repeat_msg_indication_enabled: Enable/disable the
        notification that a RepeatMessageRequest bit has been received.
    :ivar nm_synchronization_point_enabled: Enable/disable the NM
        Coordination algorithm to being able to initiate the
        synchronization algorithm.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UDP-NM-ECU"

    nm_repeat_msg_indication_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-REPEAT-MSG-INDICATION-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_synchronization_point_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-SYNCHRONIZATION-POINT-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class UdpNmNetworkConfiguration:
    """
    This meta-class defines the attributes for the configuration of a UDP port and
    UDP multicast IP address of the Nm communication on a VLAN.

    :ivar ipv_4_multicast_ip_address: Multicast IPv4 Address to which
        the message will be transmitted.
    :ivar ipv_6_multicast_ip_address: Multicast IPv6 Address to which
        the message will be transmitted
    :ivar priority: This attribute defines the VLAN frame priority for
        messages on the Socket defined by the udpPort and the multicast
        IP address. Values from 0 (best effort) to 7 (highest) are
        allowed.
    :ivar udp_port: This attribute allows to configure a udp port number
        that is used for reception and transmission of UdpNm messages.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UDP-NM-NETWORK-CONFIGURATION"

    ipv_4_multicast_ip_address: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "IPV-4-MULTICAST-IP-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_6_multicast_ip_address: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "IPV-6-MULTICAST-IP-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    udp_port: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UDP-PORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class UdpProps:
    """
    This meta-class specifies the configuration options for UDP (User Datagram
    Protocol).

    :ivar udp_ttl: Default Time-to-live value of outgoing UDP packets.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UDP-PROPS"

    udp_ttl: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UDP-TTL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class UdpRule:
    """
    Configuration of UDP filter rules.

    :ivar checksum_verification: Defines whether checksum verification
        is performed or not.
    :ivar max_destination_port_number: Filter to match packets with the
        maximum destination UDP/TCP port  number.
    :ivar max_source_port_number: Filter to match packets with the
        maximum source UDP/TCP port  number.
    :ivar min_destination_port_number: Filter to match packets with the
        minimum destination UDP/TCP port  number.
    :ivar min_source_port_number: Filter to match packets with the
        minimum source UDP/TCP port  number.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UDP-RULE"

    checksum_verification: Boolean | None = field(
        default=None,
        metadata={
            "name": "CHECKSUM-VERIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_destination_port_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-DESTINATION-PORT-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_source_port_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-SOURCE-PORT-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_destination_port_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-DESTINATION-PORT-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_source_port_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-SOURCE-PORT-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class UnlimitedIntegerValueVariationPoint:
    """This class represents an attribute value variation point for unlimited
    Integer attributes.

    Note that this class might be used in the extended meta-model only.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar binding_time: This is the binding time in which the attribute
        value needs to be bound. If this attribute is missing, the
        attribute is not a variation point. In particular this means
        that It needs to be a single value according to the type
        specified in the pure model. It is an error if it is still a
        formula.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar sd: This special data is provided to allow synchronization of
        Attribute value variation points with variant management
        systems. The usage is subject of agreement between the involved
        parties.
    :ivar short_label: This allows to identify the variation point. It
        is also intended to allow RTE support for CompileTime Variation
        points.
    :ivar content:
    """

    class Meta:
        name = "UNLIMITED-INTEGER-VALUE-VARIATION-POINT"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    binding_time: BindingTimeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "BINDING-TIME",
            "type": "Attribute",
        },
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    sd: str | None = field(
        default=None,
        metadata={
            "name": "SD",
            "type": "Attribute",
        },
    )
    short_label: str | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Attribute",
            "max_length": 128,
            "pattern": r"[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "SYSC-STRING-REF",
                    "type": ForwardRef("UnlimitedIntegerValueVariationPoint.SyscStringRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SYSC-REF",
                    "type": ForwardRef("UnlimitedIntegerValueVariationPoint.SyscRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SyscStringRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SyscRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class V2XSupportEnum:
    """
    V2X control options on an EcuInstance.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "V-2-X-SUPPORT-ENUM"

    value: V2XSupportEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ValignEnum:
    """
    This enumerator specifies vertical alignment.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VALIGN-ENUM"

    value: ValignEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class VariableAccessInEcuInstanceRef:
    """
    :ivar context_root_composition_ref:
    :ivar context_atomic_component_ref:
    :ivar target_variable_access_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VARIABLE-ACCESS-IN-ECU-INSTANCE-REF"

    context_root_composition_ref: Optional[
        "VariableAccessInEcuInstanceRef.ContextRootCompositionRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ROOT-COMPOSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_atomic_component_ref: Optional[
        "VariableAccessInEcuInstanceRef.ContextAtomicComponentRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-ATOMIC-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_variable_access_ref: Optional[
        "VariableAccessInEcuInstanceRef.TargetVariableAccessRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-VARIABLE-ACCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextRootCompositionRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextAtomicComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetVariableAccessRef(Ref):
        dest: VariableAccessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class VariableAccessScopeEnum:
    """
    This enumeration defines scopes for communication.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VARIABLE-ACCESS-SCOPE-ENUM"

    value: VariableAccessScopeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class VariableDataPrototypeInSystemInstanceRef:
    """
    :ivar context_component_ref:
    :ivar context_composition_ref:
    :ivar context_port_ref:
    :ivar target_data_prototype_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VARIABLE-DATA-PROTOTYPE-IN-SYSTEM-INSTANCE-REF"

    context_component_ref: list["VariableDataPrototypeInSystemInstanceRef.ContextComponentRef"] = (
        field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-COMPONENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    context_composition_ref: Optional[
        "VariableDataPrototypeInSystemInstanceRef.ContextCompositionRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-COMPOSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_port_ref: Optional["VariableDataPrototypeInSystemInstanceRef.ContextPortRef"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_data_prototype_ref: Optional[
        "VariableDataPrototypeInSystemInstanceRef.TargetDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextCompositionRef(Ref):
        dest: RootSwCompositionPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextPortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataPrototypeRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class VariableInAtomicSwcTypeInstanceRef:
    """
    :ivar port_prototype_ref: This is the port providing the parameter
        or the entry point to the parameter structure.
    :ivar root_variable_data_prototype_ref:
    :ivar context_data_prototype_ref: This is the context in a
        compositeDataType.
    :ivar target_data_prototype_ref: This is the target of the instance
        ref. Note that it shall be one of
        ApplicationCompositeElementDataPrototype of
        VariableDataPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VARIABLE-IN-ATOMIC-SWC-TYPE-INSTANCE-REF"

    port_prototype_ref: Optional["VariableInAtomicSwcTypeInstanceRef.PortPrototypeRef"] = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    root_variable_data_prototype_ref: Optional[
        "VariableInAtomicSwcTypeInstanceRef.RootVariableDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROOT-VARIABLE-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_data_prototype_ref: list[
        "VariableInAtomicSwcTypeInstanceRef.ContextDataPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_data_prototype_ref: Optional[
        "VariableInAtomicSwcTypeInstanceRef.TargetDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PortPrototypeRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RootVariableDataPrototypeRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextDataPrototypeRef(Ref):
        dest: ApplicationCompositeElementDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataPrototypeRef(Ref):
        dest: DataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class VariableInComponentInstanceRef:
    """
    :ivar context_component_ref:
    :ivar context_port_prototype_ref:
    :ivar root_variable_data_prototype_ref:
    :ivar context_data_prototype_ref:
    :ivar target_data_protoype_ref:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VARIABLE-IN-COMPONENT-INSTANCE-REF"

    context_component_ref: list["VariableInComponentInstanceRef.ContextComponentRef"] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_port_prototype_ref: Optional[
        "VariableInComponentInstanceRef.ContextPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    root_variable_data_prototype_ref: Optional[
        "VariableInComponentInstanceRef.RootVariableDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROOT-VARIABLE-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_data_prototype_ref: list["VariableInComponentInstanceRef.ContextDataPrototypeRef"] = (
        field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-DATA-PROTOTYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    target_data_protoype_ref: Optional["VariableInComponentInstanceRef.TargetDataProtoypeRef"] = (
        field(
            default=None,
            metadata={
                "name": "TARGET-DATA-PROTOYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextComponentRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextPortPrototypeRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RootVariableDataPrototypeRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextDataPrototypeRef(Ref):
        dest: ApplicationCompositeElementDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataProtoypeRef(Ref):
        dest: DataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class VehicleDriverNotificationEnum:
    """
    This meta-class provides available options for vehicle driver notification.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VEHICLE-DRIVER-NOTIFICATION-ENUM"

    value: VehicleDriverNotificationEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class VerificationStatusIndicationModeEnum:
    """
    This enumeration provides options for setting the mode of a verification status
    indication.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VERIFICATION-STATUS-INDICATION-MODE-ENUM"

    value: VerificationStatusIndicationModeEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class XmlSpaceEnum:
    """
    This enumerator specifies the fact that white-space shall be preserved.

    :ivar value:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "XML-SPACE-ENUM"

    value: XmlSpaceEnumSimple = field(
        metadata={
            "required": True,
        }
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class AutosarParameterRef:
    """This class represents a reference to a parameter within AUTOSAR which can be one of the following use cases:
    localParameter:
    * localParameter which is used as whole (e.g.  sharedAxis for curve)
    autosarVariable:
    * a parameter provided via PortPrototype which is used as whole (e.g. parameterAccess)
    * an element inside of a composite local parameter typed by ApplicationDatatype (e.g. sharedAxis for a curve)
    * an element inside of a composite parameter provided via Port and typed by ApplicationDatatype (e.g. sharedAxis for a curve)
    autosarParameterInImplDatatype:
    * an element inside of a composite local parameter typed by ImplementationDatatype
    * an element inside of a composite parameter provided via PortPrototype and typed by ImplementationDatatype

    :ivar autosar_parameter_iref: This instance reference is used if the
        calibration parameter is either imported via a port or is part
        of a composite data structure.
    :ivar local_parameter_ref: In the majority of cases this reference
        goes to ParameterDataPrototypes rather than
        VariableDataPrototypes. Pointing the reference to a
        VariableDataPrototype is limited to special use cases, e.g. if
        the AutosarParameterRef is used in the context of an
        SwAxisGrouped. This reference is used if the arParameter is
        local to the current component. Of course, it would technically
        also be feasible to use an InstanceRef for this case. However,
        the InstanceRef would not have a contextElement (because the
        current instance is the context). Hence, the local instance is a
        special case which may provide further optimization. Therefore
        an explicit reference is provided for this case.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AUTOSAR-PARAMETER-REF"

    autosar_parameter_iref: ParameterInAtomicSwcTypeInstanceRef | None = field(
        default=None,
        metadata={
            "name": "AUTOSAR-PARAMETER-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_parameter_ref: Optional["AutosarParameterRef.LocalParameterRef"] = field(
        default=None,
        metadata={
            "name": "LOCAL-PARAMETER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class LocalParameterRef(Ref):
        dest: DataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AutosarVariableRef:
    """This class represents a reference to a variable within AUTOSAR which can be one of the following use cases:
    localVariable:
    * localVariable which is used as whole (e.g. InterRunnableVariable, inputValue for curve)
    autosarVariable:
    * a variable provided via Port which is used as whole (e.g. dataAccesspoints)
    * an element inside of a composite local variable typed by ApplicationDatatype (e.g. inputValue for a curve)
    * an element inside of a composite variable provided via Port and typed by ApplicationDatatype (e.g. inputValue for a curve)
    autosarVariableInImplDatatype:
    * an element inside of a composite local variable typed by ImplementationDatatype  (e.g. nvramData mapping)
    * an element inside of a composite variable provided via Port and typed by ImplementationDatatype (e.g. inputValue for a curve)

    :ivar autosar_variable_in_impl_datatype: This is used if the target
        variable is inside of variableDataPrototype typed by an
        ImplementationDataType.
    :ivar autosar_variable_iref: This references a variable which is
        provided by a port and/or which is part of a CompositeDataType.
    :ivar local_variable_ref: This reference is used if the variable is
        local to the current component. It would also be possible to use
        the instance refence here. Such an instance ref would not have a
        contextElement, since the current instance is the context. But
        the local instance is a special case which may provide further
        optimization. Therefore an explicit reference is provided for
        this case.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AUTOSAR-VARIABLE-REF"

    autosar_variable_in_impl_datatype: ArVariableInImplementationDataInstanceRef | None = field(
        default=None,
        metadata={
            "name": "AUTOSAR-VARIABLE-IN-IMPL-DATATYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    autosar_variable_iref: VariableInAtomicSwcTypeInstanceRef | None = field(
        default=None,
        metadata={
            "name": "AUTOSAR-VARIABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_variable_ref: Optional["AutosarVariableRef.LocalVariableRef"] = field(
        default=None,
        metadata={
            "name": "LOCAL-VARIABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class LocalVariableRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BaseTypeDirectDefinition:
    """
    This BaseType is defined directly (as opposite to a derived BaseType)

    :ivar base_type_size: Describes the length of the data type
        specified in the container in bits.
    :ivar max_base_type_size: Describes the maximum length of the
        BaseType in bits.
    :ivar base_type_encoding: This specifies, how an object of the
        current BaseType is encoded, e.g. in an ECU within a message
        sequence.
    :ivar mem_alignment: This attribute describes the alignment of the
        memory object in bits. E.g. "8" specifies, that the object in
        question is aligned to a byte while "32" specifies that it is
        aligned four byte. If the value is set to "0" the meaning shall
        be interpreted as "unspecified".
    :ivar byte_order: This attribute specifies the byte order of the
        base type.
    :ivar native_declaration: This attribute describes the declaration
        of such a base type in the native programming language,
        primarily in the Programming language C. This can then be used
        by a code generator to include the necessary declarations into a
        header file. For example BaseType with shortName:
        "MyUnsignedInt" nativeDeclaration: "unsigned short" Results in
        typedef unsigned short MyUnsignedInt; If the attribute is not
        defined the referring ImplementationDataTypes will not be
        generated as a typedef by RTE. If a nativeDeclaration type is
        given it shall fulfill the characteristic given by
        basetypeEncoding and baseTypeSize. This is required to ensure
        the consistent handling and interpretation by software
        components, RTE, COM and MCM systems.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BASE-TYPE-DIRECT-DEFINITION"

    base_type_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BASE-TYPE-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_base_type_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-BASE-TYPE-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    base_type_encoding: BaseTypeEncodingString | None = field(
        default=None,
        metadata={
            "name": "BASE-TYPE-ENCODING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mem_alignment: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MEM-ALIGNMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    byte_order: ByteOrderEnum | None = field(
        default=None,
        metadata={
            "name": "BYTE-ORDER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    native_declaration: NativeDeclarationString | None = field(
        default=None,
        metadata={
            "name": "NATIVE-DECLARATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BswEntryRelationship:
    """
    Describes a relationship between two BswModuleEntrys and the type of
    relationship.

    :ivar from_ref: Type of relationship that refers to the abstract
        BswModuleEntry. Please notice that in this case the
        bswEntryRelationshipType shall be set to drivedFrom.
    :ivar to_ref: Type of relationship that refers to the concrete
        BswModuleEntry
    :ivar bsw_entry_relationship_type: Denotes the type of the
        relationship.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-ENTRY-RELATIONSHIP"

    from_ref: Optional["BswEntryRelationship.FromRef"] = field(
        default=None,
        metadata={
            "name": "FROM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    to_ref: Optional["BswEntryRelationship.ToRef"] = field(
        default=None,
        metadata={
            "name": "TO-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_entry_relationship_type: BswEntryRelationshipEnum | None = field(
        default=None,
        metadata={
            "name": "BSW-ENTRY-RELATIONSHIP-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FromRef(Ref):
        dest: BswModuleEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ToRef(Ref):
        dest: BswModuleEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CanControllerConfiguration:
    """
    This element is used for the specification of the exact CAN Bit Timing
    configuration parameter values.

    :ivar can_controller_fd_attributes: Bit timing related configuration
        of a CAN controller for payload and CRC of a CanFD frame. If
        this element exists the controller supports CanFD frames and the
        ECU developer shall take these values for the configuration of
        the CanFD controller.
    :ivar can_controller_fd_requirements: Additional CanFD ranges of the
        bit timing related configuration of a CanFD controller. If this
        element exists the controller supports CanFD frames and the ECU
        developer shall take these ranges as requirements for the
        configuration of the CanFD controller.
    :ivar can_controller_xl_attributes: Bit timing related configuration
        of a CAN controller for payload and CRC of a CanXL frame. If
        this element exists the controller supports CanXL frames and the
        ECU developer shall take these values for the configuration of
        the CanXL controller.
    :ivar can_controller_xl_requirements: Additional CanXL ranges of the
        bit timing related configuration of a CanXL controller. If this
        element exists the controller supports CanXL frames and the ECU
        developer shall take these ranges as requirements for the
        configuration of the CanXL controller.
    :ivar prop_seg: Specifies propagation delay in time quantas.
    :ivar sync_jump_width: The number of quanta in the Synchronization
        Jump Width, SJW. The (Re-)Synchronization Jump Width (SJW)
        defines how far a resynchronization may move the Sample Point
        inside the limits defined by the Phase Buffer Segments to
        compensate for edge phase errors.
    :ivar time_seg_1: Specifies phase segment 1 in time quantas.
        timeSeg1 = Phase_Seg1
    :ivar time_seg_2: Specifies phase segment 2 in time quantas.
        timeSeg2 = Phase_Seg2
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-CONTROLLER-CONFIGURATION"

    can_controller_fd_attributes: CanControllerFdConfiguration | None = field(
        default=None,
        metadata={
            "name": "CAN-CONTROLLER-FD-ATTRIBUTES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_controller_fd_requirements: CanControllerFdConfigurationRequirements | None = field(
        default=None,
        metadata={
            "name": "CAN-CONTROLLER-FD-REQUIREMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_controller_xl_attributes: CanControllerXlConfiguration | None = field(
        default=None,
        metadata={
            "name": "CAN-CONTROLLER-XL-ATTRIBUTES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_controller_xl_requirements: CanControllerXlConfigurationRequirements | None = field(
        default=None,
        metadata={
            "name": "CAN-CONTROLLER-XL-REQUIREMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prop_seg: Integer | None = field(
        default=None,
        metadata={
            "name": "PROP-SEG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_jump_width: Integer | None = field(
        default=None,
        metadata={
            "name": "SYNC-JUMP-WIDTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_seg_1: Integer | None = field(
        default=None,
        metadata={
            "name": "TIME-SEG-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_seg_2: Integer | None = field(
        default=None,
        metadata={
            "name": "TIME-SEG-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanControllerConfigurationRequirements:
    """This element allows the specification of ranges for the CAN Bit Timing
    configuration parameters.

    These ranges are taken as requirements and have to be respected by
    the ECU developer.

    :ivar can_controller_fd_attributes: Bit timing related configuration
        of a CAN controller for payload and CRC of a CanFD frame. If
        this element exists the controller supports CanFD frames and the
        ECU developer shall take these values for the configuration of
        the CanFD controller.
    :ivar can_controller_fd_requirements: Additional CanFD ranges of the
        bit timing related configuration of a CanFD controller. If this
        element exists the controller supports CanFD frames and the ECU
        developer shall take these ranges as requirements for the
        configuration of the CanFD controller.
    :ivar can_controller_xl_attributes: Bit timing related configuration
        of a CAN controller for payload and CRC of a CanXL frame. If
        this element exists the controller supports CanXL frames and the
        ECU developer shall take these values for the configuration of
        the CanXL controller.
    :ivar can_controller_xl_requirements: Additional CanXL ranges of the
        bit timing related configuration of a CanXL controller. If this
        element exists the controller supports CanXL frames and the ECU
        developer shall take these ranges as requirements for the
        configuration of the CanXL controller.
    :ivar max_number_of_time_quanta_per_bit: Maximum number of time
        quanta in the bit time.
    :ivar max_sample_point: The max. value of the sample point as a
        percentage of the total bit time.
    :ivar max_sync_jump_width: The max. Synchronization Jump Width value
        as a percentage of the total bit time. The (Re-)Synchronization
        Jump Width (SJW) defines how far a resynchronization may move
        the Sample Point inside the limits defined by the Phase Buffer
        Segments to compensate for edge phase errors.
    :ivar min_number_of_time_quanta_per_bit: Minimum number of time
        quanta in the bit time.
    :ivar min_sample_point: The min. value of the sample point as a
        percentage of the total bit time.
    :ivar min_sync_jump_width: The min. Synchronization Jump Width value
        as a percentage of the total bit time. The (Re-)Synchronization
        Jump Width (SJW) defines how far a resynchronization may move
        the Sample Point inside the limits defined by the Phase Buffer
        Segments to compensate for edge phase errors.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-CONTROLLER-CONFIGURATION-REQUIREMENTS"

    can_controller_fd_attributes: CanControllerFdConfiguration | None = field(
        default=None,
        metadata={
            "name": "CAN-CONTROLLER-FD-ATTRIBUTES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_controller_fd_requirements: CanControllerFdConfigurationRequirements | None = field(
        default=None,
        metadata={
            "name": "CAN-CONTROLLER-FD-REQUIREMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_controller_xl_attributes: CanControllerXlConfiguration | None = field(
        default=None,
        metadata={
            "name": "CAN-CONTROLLER-XL-ATTRIBUTES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_controller_xl_requirements: CanControllerXlConfigurationRequirements | None = field(
        default=None,
        metadata={
            "name": "CAN-CONTROLLER-XL-REQUIREMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_time_quanta_per_bit: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-TIME-QUANTA-PER-BIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_sample_point: Float | None = field(
        default=None,
        metadata={
            "name": "MAX-SAMPLE-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_sync_jump_width: Float | None = field(
        default=None,
        metadata={
            "name": "MAX-SYNC-JUMP-WIDTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_number_of_time_quanta_per_bit: Integer | None = field(
        default=None,
        metadata={
            "name": "MIN-NUMBER-OF-TIME-QUANTA-PER-BIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_sample_point: Float | None = field(
        default=None,
        metadata={
            "name": "MIN-SAMPLE-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_sync_jump_width: Float | None = field(
        default=None,
        metadata={
            "name": "MIN-SYNC-JUMP-WIDTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CanXlNmNodeProps:
    """
    Definition of CAN attributes in the context of CanXL usage on the adaptive
    platform.

    :ivar can_nm_tx_can_id: This attribute is used to define the
        identifier the CAN NM frame shall use on the CAN network.
    :ivar rx_identifier_range: Optional definition of a CanId range.
    :ivar rx_mask: Identifier mask which denotes the relevant bits in
        the CAN Identifier. Together with the identifier, this parameter
        defines a CAN identifier range.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-XL-NM-NODE-PROPS"

    can_nm_tx_can_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CAN-NM-TX-CAN-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rx_identifier_range: RxIdentifierRange | None = field(
        default=None,
        metadata={
            "name": "RX-IDENTIFIER-RANGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rx_mask: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "RX-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ClientIdRange:
    """
    With this element it is possible to restrict the Client Identifier of the
    transaction handle that is generated by the client RTE for inter-Ecu
    Client/Server communication to an allowed range of numerical values.

    :ivar lower_limit: This specifies the lower limit of the
        ClientIdRange.
    :ivar upper_limit: This specifies the upper limit of the
        ClientIdRange.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-ID-RANGE"

    lower_limit: Limit | None = field(
        default=None,
        metadata={
            "name": "LOWER-LIMIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_limit: Limit | None = field(
        default=None,
        metadata={
            "name": "UPPER-LIMIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ClientServerArrayElementMapping:
    """The ApplicationArrayElement may be a primitive one or a composite one.

    If the element is primitive, it will be mapped to the "SystemSignal"
    (multiplicity 1). If the ArgumentDataPrototype that is referenced by
    ClientServerCompositeTypeMapping is typed by an ApplicationDataType
    the reference to the ApplicationArrayElement shall be used. If the
    VariableDataPrototype is typed by the ImplementationDataType the
    reference to the ImplementationArrayElement shall be used. If the
    element is composite, there will be no mapping to the "SystemSignal"
    (multiplicity 0). In this case the "ArrayElementMapping" Element
    will aggregate the "TypeMapping" Element. In that way also the
    composite datatypes can be mapped to SystemSignals. Regardless
    whether composite or primitive array element is mapped the indexed
    array element always needs to be specified.

    :ivar complex_type_mapping: This aggregation will be used if the
        element is  composite.
    :ivar indexed_array_element: Reference to an indexed array element
        in the context of the mappedOperation or in the context of a
        composite element.
    :ivar system_signal_ref: Reference to the system signal used to
        carry the primitive ApplicationArrayElement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-ARRAY-ELEMENT-MAPPING"

    complex_type_mapping: Optional["ClientServerArrayElementMapping.ComplexTypeMapping"] = field(
        default=None,
        metadata={
            "name": "COMPLEX-TYPE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    indexed_array_element: IndexedArrayElement | None = field(
        default=None,
        metadata={
            "name": "INDEXED-ARRAY-ELEMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_signal_ref: Optional["ClientServerArrayElementMapping.SystemSignalRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ComplexTypeMapping:
        client_server_array_type_mapping: Optional["ClientServerArrayTypeMapping"] = field(
            default=None,
            metadata={
                "name": "CLIENT-SERVER-ARRAY-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        client_server_record_type_mapping: Optional["ClientServerRecordTypeMapping"] = field(
            default=None,
            metadata={
                "name": "CLIENT-SERVER-RECORD-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CommunicationBufferLocking:
    """The aggregation of this meta-class specifies that a RunnableEntity supports
    locked communication buffers supplied by the RTE.

    It is able to cope with the error RTE_E_COM_BUSY.

    :ivar support_buffer_locking: This attribute is used to indicate the
        intended buffer locking behavior.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMMUNICATION-BUFFER-LOCKING"

    support_buffer_locking: SupportBufferLockingEnum | None = field(
        default=None,
        metadata={
            "name": "SUPPORT-BUFFER-LOCKING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CompositeNetworkRepresentation:
    """
    This meta-class is used to define the network representation of leaf elements
    of composite application data types.

    :ivar leaf_element_iref: This represents that leaf element of an
        application composite data type.
    :ivar network_representation: The SwDataDefProps owned by the
        CompositeNetworkRepresentation are used to define the network
        representation of the leaf element of an
        ApplicationCompositeDataType.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPOSITE-NETWORK-REPRESENTATION"

    leaf_element_iref: ApplicationCompositeElementInPortInterfaceInstanceRef | None = field(
        default=None,
        metadata={
            "name": "LEAF-ELEMENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_representation: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "NETWORK-REPRESENTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CompuConst:
    """
    This meta-class represents the fact that the value of a computation method
    scale is constant.

    :ivar vf: Value calculated via a system constant. This element is
        included in every case where parameters should be generated from
        numerical values during compile time (not runtime!). Thus for
        example, the influence of the cylinder number on conversion
        formulae can be introduced in a repeatable manner.
    :ivar v: This represents the numerical value.
    :ivar vt: This represents a textual constant in the computation
        method.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPU-CONST"

    vf: NumericalValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "VF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    v: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "V",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vt: VerbatimString | None = field(
        default=None,
        metadata={
            "name": "VT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CompuConstFormulaContent:
    """This meta-class represents the fact that the constant value of the
    computation method is represented by a variation point.

    This difference is due to compatibility with ASAM HDO.

    :ivar vf: Value calculated via a system constant. This element is
        included in every case where parameters should be generated from
        numerical values during compile time (not runtime!). Thus for
        example, the influence of the cylinder number on conversion
        formulae can be introduced in a repeatable manner.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPU-CONST-FORMULA-CONTENT"

    vf: NumericalValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "VF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CompuNominatorDenominator:
    """
    This class represents the ability to express a polynomial either as Nominator
    or as Denominator.

    :ivar v: this is the list of polynomial factors. Note that the first
        vf represents the power=0.  The polynomial is v[0] * x^0 + v[1]
        * x^1 ...
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPU-NOMINATOR-DENOMINATOR"

    v: list[NumericalValueVariationPoint] = field(
        default_factory=list,
        metadata={
            "name": "V",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ConfidenceInterval:
    """
    Additionally to the list of measured distances of event occurrences, a
    confidence interval can be specified for the expected distance of two
    consecutive event occurrences with a given probability.

    :ivar lower_bound: The lower bound of the expected distance of two
        consecutive event occurrences.
    :ivar propability: The probability for the measured lower and upper
        bound of the confidence interval.
    :ivar upper_bound: The upper bound of the expected distance of two
        consecutive event occurrences.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONFIDENCE-INTERVAL"

    lower_bound: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "LOWER-BOUND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    propability: Float | None = field(
        default=None,
        metadata={
            "name": "PROPABILITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_bound: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "UPPER-BOUND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ContainedIPduProps:
    """
    Defines the aspects of an IPdu which can be collected inside a ContainerIPdu.

    :ivar collection_semantics: Defines whether this ContainedIPdu shall
        be collected using a last-is-best or queued semantics.
    :ivar contained_pdu_triggering_ref: Reference to Pdu for which the
        ContainedIPduProps are valid.
    :ivar header_id_long_header: Defines the header id this IPdu shall
        have in case this IPdu is put inside a ContainerIPdu with
        headerType = longHeader.
    :ivar header_id_short_header: Defines the header id this IPdu shall
        have in case this IPdu is put inside a ContainerIPdu with
        headerType = shortHeader.
    :ivar offset: Byte offset that describes the location of the
        ContainedPdu in the ContainerPdu if no header is used.
    :ivar priority: Defines a priority of a ContainedTxPdu. 255
        represents the lowest priority and 0 represent the highest
        priority.
    :ivar timeout: Defines a IPdu specific sender timeout which can
        reduce the ContainerIPdu timer when this containedIPdu is put
        inside the ContainerIPdu. This attribute is ignored on receiver
        side.
    :ivar trigger: Defines whether this IPdu does trigger the sending of
        the ContainerIPdu. This attribute is ignored on receiver side.
    :ivar update_indication_bit_position: The updateIndicationBit
        specifies the bit location of ContainedIPdu Update-Bit in the
        Container PDU. It indicates to the receivers that the
        ContainedIPdu in the ContainerIPdu was updated.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONTAINED-I-PDU-PROPS"

    collection_semantics: ContainedIPduCollectionSemanticsEnum | None = field(
        default=None,
        metadata={
            "name": "COLLECTION-SEMANTICS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_pdu_triggering_ref: Optional["ContainedIPduProps.ContainedPduTriggeringRef"] = field(
        default=None,
        metadata={
            "name": "CONTAINED-PDU-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    header_id_long_header: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "HEADER-ID-LONG-HEADER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    header_id_short_header: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "HEADER-ID-SHORT-HEADER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger: PduCollectionTriggerEnum | None = field(
        default=None,
        metadata={
            "name": "TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update_indication_bit_position: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UPDATE-INDICATION-BIT-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContainedPduTriggeringRef(Ref):
        dest: PduTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CouplingPortRatePolicy:
    """
    Defines a rate policy on a CouplingPort.

    :ivar data_length: Amount of data in bytes (excluding header
        information) that can be received to define the rate policy.
    :ivar policy_action: Defines the action to be performed when this
        rate policy is violated.
    :ivar priority: Defines the priority which this rate policy shall be
        limited on. If no priority is given this rate policy is not
        considering priority.
    :ivar time_interval: Time interval used to define the base of the
        rate policy.
    :ivar v_lan_refs: Defines the VLANs this rate policy shall be
        limited on. If no VLAN is given this rate policy is not
        considering VLAN tags.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COUPLING-PORT-RATE-POLICY"

    data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    policy_action: CouplingPortRatePolicyActionEnum | None = field(
        default=None,
        metadata={
            "name": "POLICY-ACTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    v_lan_refs: Optional["CouplingPortRatePolicy.VLanRefs"] = field(
        default=None,
        metadata={
            "name": "V-LAN-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class VLanRefs:
        v_lan_ref: list["CouplingPortRatePolicy.VLanRefs.VLanRef"] = field(
            default_factory=list,
            metadata={
                "name": "V-LAN-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class VLanRef(Ref):
            dest: EthernetPhysicalChannelSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class CouplingPortTrafficClassAssignment:
    """
    Defines the assignment of Traffic Class to a frame.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar prioritys: Defines a priority which is mapped onto a Traffic
        Class.
    :ivar traffic_class: Defines the Traffic Class which is assigned.
        range: 0-7
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COUPLING-PORT-TRAFFIC-CLASS-ASSIGNMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CouplingPortTrafficClassAssignment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prioritys: Optional["CouplingPortTrafficClassAssignment.Prioritys"] = field(
        default=None,
        metadata={
            "name": "PRIORITYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    traffic_class: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TRAFFIC-CLASS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Prioritys:
        priority: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "PRIORITY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 8,
            },
        )


@dataclass(slots=True, kw_only=True)
class CycleRepetition:
    """
    The communication cycle where the frame is send is described by the attributes
    baseCycle and cycleRepetition.

    :ivar base_cycle: The first communication cycle where the frame is
        sent. This value is incremented at the beginning of each new
        cycle, ranging from 0 to 63, and is reset to 0 after a sequence
        of 64 cycles.
    :ivar cycle_repetition: The number of communication cycles (after
        the first cycle) whenever the frame described by this timing is
        sent again.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CYCLE-REPETITION"

    base_cycle: Integer | None = field(
        default=None,
        metadata={
            "name": "BASE-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cycle_repetition: CycleRepetitionType | None = field(
        default=None,
        metadata={
            "name": "CYCLE-REPETITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataComProps:
    """
    Represents a single resource required or provided by a CP Software Cluster
    which relates to the port based communication on VFB level.

    :ivar data_consistency_policy: This attribute defines requirements
        on the data consistency mechanism in the cross cluster
        communication. If the attribute is not set, the default value
        consistencyMechanismRequired applies.
    :ivar send_indication: Send indication behavior for last-is-the best
        data communication.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-COM-PROPS"

    data_consistency_policy: DataConsistencyPolicyEnum | None = field(
        default=None,
        metadata={
            "name": "DATA-CONSISTENCY-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    send_indication: SendIndicationEnum | None = field(
        default=None,
        metadata={
            "name": "SEND-INDICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataFilter:
    """Base class for data filters.

    The type of the filter is specified in attribute dataFilterType.
    Some of the filter types require additional arguments which are
    specified as attributes of this class.

    :ivar data_filter_type: This attribute specifies the type of the
        filter.
    :ivar mask: Mask for old and new value.
    :ivar max: Value to specify the upper boundary
    :ivar min: Value to specify the lower boundary
    :ivar offset: Specifies the initial number of messages to occur
        before the first message is passed
    :ivar period: Specifies number of messages to occur before the
        message is passed again
    :ivar x: Value to compare with
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-FILTER"

    data_filter_type: DataFilterTypeEnum | None = field(
        default=None,
        metadata={
            "name": "DATA-FILTER-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mask: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    period: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    x: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "X",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataPrototypeInPortInterfaceRef:
    """
    This class represents a RootDataPrototype that is typed by an
    ApplicationDataType or ImplementationDataType or a DataTypeElement that is
    aggregated within a composite application data type (record or array).

    :ivar tag_id: This attribute represents the ability to specify a
        tag-id for the serialization of a specific DataPrototype in the
        context of a (potentially deeply-nested) composite  data
        structure.
    :ivar data_prototype_in_client_server_interface_iref: This element
        defines a reference to a DataPrototype in the context of a
        ClientServerInterface.
    :ivar data_prototype_in_sender_receiver_interface_iref: This element
        defines a reference to a DataPrototype in the context of a
        SenderReceiverInterface.
    :ivar data_prototype_in_service_interface_iref: This element defines
        a reference to a DataPrototype in the context of a
        ServiceInterface.
    :ivar data_prototype_iref: This element defines a reference to a
        DataPrototype in the context of a PortInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-PROTOTYPE-IN-PORT-INTERFACE-REF"

    tag_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TAG-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototype_in_client_server_interface_iref: (
        DataPrototypeInClientServerInterfaceInstanceRef | None
    ) = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-IN-CLIENT-SERVER-INTERFACE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototype_in_sender_receiver_interface_iref: (
        DataPrototypeInSenderReceiverInterfaceInstanceRef | None
    ) = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-IN-SENDER-RECEIVER-INTERFACE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototype_in_service_interface_iref: DataPrototypeInServiceInterfaceInstanceRef | None = (
        field(
            default=None,
            metadata={
                "name": "DATA-PROTOTYPE-IN-SERVICE-INTERFACE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    data_prototype_iref: Optional["DataPrototypeInPortInterfaceRef.DataPrototypeIref"] = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataPrototypeIref:
        root_data_prototype_in_cs_ref: Optional[
            "DataPrototypeInPortInterfaceRef.DataPrototypeIref.RootDataPrototypeInCsRef"
        ] = field(
            default=None,
            metadata={
                "name": "ROOT-DATA-PROTOTYPE-IN-CS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        context_data_prototype_in_cs_ref: list[
            "DataPrototypeInPortInterfaceRef.DataPrototypeIref.ContextDataPrototypeInCsRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-DATA-PROTOTYPE-IN-CS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        target_data_prototype_in_cs_ref: Optional[
            "DataPrototypeInPortInterfaceRef.DataPrototypeIref.TargetDataPrototypeInCsRef"
        ] = field(
            default=None,
            metadata={
                "name": "TARGET-DATA-PROTOTYPE-IN-CS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        root_data_prototype_in_sr_ref: Optional[
            "DataPrototypeInPortInterfaceRef.DataPrototypeIref.RootDataPrototypeInSrRef"
        ] = field(
            default=None,
            metadata={
                "name": "ROOT-DATA-PROTOTYPE-IN-SR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        context_data_prototype_in_sr_ref: list[
            "DataPrototypeInPortInterfaceRef.DataPrototypeIref.ContextDataPrototypeInSrRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-DATA-PROTOTYPE-IN-SR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        target_data_prototype_in_sr_ref: Optional[
            "DataPrototypeInPortInterfaceRef.DataPrototypeIref.TargetDataPrototypeInSrRef"
        ] = field(
            default=None,
            metadata={
                "name": "TARGET-DATA-PROTOTYPE-IN-SR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        root_data_prototype_ref: Optional[
            "DataPrototypeInPortInterfaceRef.DataPrototypeIref.RootDataPrototypeRef"
        ] = field(
            default=None,
            metadata={
                "name": "ROOT-DATA-PROTOTYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        context_data_prototype_ref: list[
            "DataPrototypeInPortInterfaceRef.DataPrototypeIref.ContextDataPrototypeRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-DATA-PROTOTYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        target_data_prototype_ref: Optional[
            "DataPrototypeInPortInterfaceRef.DataPrototypeIref.TargetDataPrototypeRef"
        ] = field(
            default=None,
            metadata={
                "name": "TARGET-DATA-PROTOTYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RootDataPrototypeInCsRef(Ref):
            dest: AutosarDataPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

        @dataclass(slots=True, kw_only=True)
        class ContextDataPrototypeInCsRef(Ref):
            dest: ApplicationCompositeElementDataPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

        @dataclass(slots=True, kw_only=True)
        class TargetDataPrototypeInCsRef(Ref):
            dest: DataPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

        @dataclass(slots=True, kw_only=True)
        class RootDataPrototypeInSrRef(Ref):
            dest: AutosarDataPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

        @dataclass(slots=True, kw_only=True)
        class ContextDataPrototypeInSrRef(Ref):
            dest: ApplicationCompositeElementDataPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

        @dataclass(slots=True, kw_only=True)
        class TargetDataPrototypeInSrRef(Ref):
            dest: DataPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

        @dataclass(slots=True, kw_only=True)
        class RootDataPrototypeRef(Ref):
            dest: AutosarDataPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

        @dataclass(slots=True, kw_only=True)
        class ContextDataPrototypeRef(Ref):
            dest: ApplicationCompositeElementDataPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

        @dataclass(slots=True, kw_only=True)
        class TargetDataPrototypeRef(Ref):
            dest: DataPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DataPrototypeInServiceInterfaceRef:
    """
    This meta-class represents the ability to refer to an AUTOSAR DataPrototype in
    the context of a ServiceInterface.

    :ivar data_prototype_iref: This element represents the ability to: *
        refer to a DataPrototype in the context of a ServiceInterface. *
        refer to the internal structure of a DataPrototype in which is
        typed by an ApplicationDatatype the context of a
        ServiceInterface.
    :ivar element_in_impl_datatype: This element represents the ability
        to refer to the internal structure of an AutosarDataPrototype
        which is typed by an ImplementationDatatype in the context of a
        ServiceInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-PROTOTYPE-IN-SERVICE-INTERFACE-REF"

    data_prototype_iref: DataPrototypeInServiceInterfaceInstanceRef | None = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    element_in_impl_datatype: PortInterfaceElementInImplementationDatatypeRef | None = field(
        default=None,
        metadata={
            "name": "ELEMENT-IN-IMPL-DATATYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataPrototypeWithApplicationDataTypeInSystemRef:
    """
    This class represents a DataPrototype that is typed by an ApplicationDataType
    and may be aggregated within a composite application data type (record or
    array).

    :ivar tag_id: This attribute represents the ability to specify a
        tag-id for the serialization of a specific DataPrototype in the
        context of a (potentially deeply-nested) composite  data
        structure.
    :ivar data_prototype_iref: This represents the referenced
        ApplicationCompositeDataPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-PROTOTYPE-WITH-APPLICATION-DATA-TYPE-IN-SYSTEM-REF"

    tag_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TAG-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototype_iref: ApplicationDataPrototypeInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticDataChangeTrigger:
    """
    This represents the ability to define a trigger based on the change of a given
    DiagnosticDataIdentifier.

    :ivar initial_event_status: This represents the initial status of
        the enclosing DiagnosticResponseOnEventTrigger.
    :ivar data_identifier_ref: This represents the corresponding
        DiagnosticDataIdentifier.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DATA-CHANGE-TRIGGER"

    initial_event_status: DiagnosticInitialEventStatusEnum | None = field(
        default=None,
        metadata={
            "name": "INITIAL-EVENT-STATUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_identifier_ref: Optional["DiagnosticDataChangeTrigger.DataIdentifierRef"] = field(
        default=None,
        metadata={
            "name": "DATA-IDENTIFIER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataIdentifierRef(Ref):
        dest: DiagnosticDataIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDtcChangeTrigger:
    """
    This represents the ability to define a trigger that executes on the change of
    any DiagnosticTroubleCode.

    :ivar initial_event_status: This represents the initial status of
        the enclosing DiagnosticResponseOnEventTrigger.
    :ivar dtc_status_mask: This attribute represents the ability to
        define a status mask for the triggering of an ROE response on
        the change of a DTC.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DTC-CHANGE-TRIGGER"

    initial_event_status: DiagnosticInitialEventStatusEnum | None = field(
        default=None,
        metadata={
            "name": "INITIAL-EVENT-STATUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_status_mask: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DTC-STATUS-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticEnvBswModeElement:
    """
    This meta-class represents the ability to refer to a specific ModeDeclaration
    in the scope of a BswModuleDescription.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar mode_iref: This reference identifies both the
        ModeDeclarationGroupPrototype and the ModeDeclaration for the
        specific mode comparison.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ENV-BSW-MODE-ELEMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEnvBswModeElement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_iref: ModeInBswModuleDescriptionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "MODE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEnvModeCondition:
    """DiagnosticEnvModeCondition are atomic condition based on the comparison of
    the active ModeDeclaration in a ModeDeclarationGroupProtoype with the constant
    value of a ModeDeclaration.

    The formulation of this condition uses only one
    DiagnosticEnvElement, which contains enough information to deduce
    the variable part (i.e. the part that changes at runtime) as well as
    the constant part of the comparison. Only
    DiagnosticCompareTypeEnum.isEqual or
    DiagnosticCompareTypeEnum.isNotEqual are eligible values for
    DiagnosticAtomicCondition.compareType.

    :ivar compare_type: This attributes represents the concrete type of
        the comparison.
    :ivar mode_element_ref: This reference represents both the
        ModeDeclarationGroupPrototype and the ModeDeclaration relevant
        for the mode comparison.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ENV-MODE-CONDITION"

    compare_type: DiagnosticCompareTypeEnum | None = field(
        default=None,
        metadata={
            "name": "COMPARE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_element_ref: Optional["DiagnosticEnvModeCondition.ModeElementRef"] = field(
        default=None,
        metadata={
            "name": "MODE-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ModeElementRef(Ref):
        dest: DiagnosticEnvModeElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEnvSwcModeElement:
    """
    This meta-class represents the ability to refer to a ModeDeclaration in a
    concrete System context.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar mode_iref: This reference identifies both the
        ModeDeclarationGroupPrototype and the ModeDeclaration for the
        specific mode comparison.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ENV-SWC-MODE-ELEMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEnvSwcModeElement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_iref: PModeInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "MODE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventWindow:
    """
    This represents the ability to define the characteristics of the applicable
    event window.

    :ivar event_window_time: This attribute clarifies the validity of
        the eventWindow
    :ivar storage_state_evaluation: If this attribute is set to TRUE the
        StorageStateBit will be evaluated if this EventWindowTime is
        requested.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-WINDOW"

    event_window_time: DiagnosticEventWindowTimeEnum | None = field(
        default=None,
        metadata={
            "name": "EVENT-WINDOW-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    storage_state_evaluation: Boolean | None = field(
        default=None,
        metadata={
            "name": "STORAGE-STATE-EVALUATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticPeriodicRate:
    """
    This represents the ability to define a periodic rate for the specification of
    the "read data by periodic ID" diagnostic service.

    :ivar period: This represents the period of the
        DiagnosticPeriodicRate in seconds.
    :ivar periodic_rate_category: This attribute represents the category
        of the periodic rate.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-PERIODIC-RATE"

    period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    periodic_rate_category: DiagnosticPeriodicRateCategoryEnum | None = field(
        default=None,
        metadata={
            "name": "PERIODIC-RATE-CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticTestIdentifier:
    """
    This meta-class represents the ability to create a diagnostic test identifier.

    :ivar id: This represents the numerical id associated with the
        diagnostic test identifier.
    :ivar uas_id: This represents the unit and scaling Id of the
        diagnostic test result.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TEST-IDENTIFIER"

    id: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uas_id: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UAS-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiscoveryTechnology:
    """This element is deprecated and will be removed in future.

    This information is replaced by the runtimePortConfiguration and runtimeIpAddressConfiguration attributes in the SocketConnection.
    Old description:
    Discovery technology information.

    :ivar name: Discovery technology used.
    :ivar version: Version of the used Discovery protocol.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DISCOVERY-TECHNOLOGY"

    name: DiscoveryTechnologyEnum | None = field(
        default=None,
        metadata={
            "name": "NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: String | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DoIpEntity:
    """
    ECU providing this infrastructure service is a DoIP-Entity.

    :ivar do_ip_entity_role: Identifies the role in terms of DoIP this
        network-node has.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-ENTITY"

    do_ip_entity_role: DoIpEntityRoleEnum | None = field(
        default=None,
        metadata={
            "name": "DO-IP-ENTITY-ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DoIpNetworkConfiguration:
    """
    This element collects DoIP properties that are network interface specific.

    :ivar eid_retrieval: This attribute defines how DoIp Entitiy
        Identification is retrieved.
    :ivar is_activation_line_dependent: This attribute defines whether
        the network interface * is started "on-demand" when an
        activation line is sensed or * is always available.
    :ivar max_initial_vehicle_announcement_time: Upper bound for the
        time to wait in [s] for sending first vehicle anouncement
        message after IP address assignment. Represents parameter
        A_DoIP_Announce_Wait of ISO 13400-2:2012. The value of this
        timing shall be determined randomly in the closed interval
        [0..maxInitialVehicleAnnouncementTime].
    :ivar max_tester_connections: Maximum amount of tester connections
        that shall be maintained at one time before alive check is
        performed.
    :ivar network_configuration_refs: Network configuration (Protocol,
        Port, IP Address) for transmission of DoIP messages on a
        specific VLAN.
    :ivar network_interface_id: This attribute defines the identifier
        for the DoIPInterface.
    :ivar tcp_alive_check_response_timeout: Timeout in [s] for waiting
        for a response to an Alive Check request before the connection
        is considered to be disconnected. Represents parameter
        T_TCP_AliveCheck of ISO 13400-2:2012.
    :ivar tcp_general_inactivity_time: Timeout in [s] for maximum
        inactivity of a TCP socket connection before the DoIP module
        will close the according socket connection. Represents parameter
        T_TCP_General_Inactivity of ISO 13400-2:2012.
    :ivar tcp_initial_inactivity_time: Timeout in [s] used for initial
        inactivity of a connected TCP socket connection directly after
        socket connection. Represents parameter T_TCP_Initial_Inactivity
        of ISO 13400-2:2012.
    :ivar vehicle_announcement_count: Number of vehicle announcement
        messages on IP address assignment. Represents parameter
        A_DoIP_Announce_Num of ISO 13400-2:2012.
    :ivar vehicle_announcement_interval: Time to wait in [s] for sending
        subsequent vehicle anouncement messages. Represents parameter
        A_DoIP_Announce_Interval of ISO 13400-2:2012.
    :ivar vehicle_identification_sync_status: Defines if the optional
        VIN/GID synchronization status is used additionally in the
        vehicle identification/announcement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-NETWORK-CONFIGURATION"

    eid_retrieval: DoIpEidRetrievalEnum | None = field(
        default=None,
        metadata={
            "name": "EID-RETRIEVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_activation_line_dependent: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-ACTIVATION-LINE-DEPENDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_initial_vehicle_announcement_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MAX-INITIAL-VEHICLE-ANNOUNCEMENT-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_tester_connections: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-TESTER-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_configuration_refs: Optional["DoIpNetworkConfiguration.NetworkConfigurationRefs"] = (
        field(
            default=None,
            metadata={
                "name": "NETWORK-CONFIGURATION-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    network_interface_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NETWORK-INTERFACE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_alive_check_response_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-ALIVE-CHECK-RESPONSE-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_general_inactivity_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-GENERAL-INACTIVITY-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_initial_inactivity_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-INITIAL-INACTIVITY-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vehicle_announcement_count: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VEHICLE-ANNOUNCEMENT-COUNT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vehicle_announcement_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "VEHICLE-ANNOUNCEMENT-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vehicle_identification_sync_status: Boolean | None = field(
        default=None,
        metadata={
            "name": "VEHICLE-IDENTIFICATION-SYNC-STATUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class NetworkConfigurationRefs:
        network_configuration_ref: list[
            "DoIpNetworkConfiguration.NetworkConfigurationRefs.NetworkConfigurationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "NETWORK-CONFIGURATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class NetworkConfigurationRef(Ref):
            dest: PlatformModuleEthernetEndpointConfigurationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DoIpRequestConfiguration:
    """
    This meta-class specifies a range of target addresses and its interpretation as
    either physical or functional request.

    :ivar end_address: End address for range of target-addresses
        (including this address).
    :ivar request_type: Determines the type of request.
    :ivar start_address: Start address for range of target-addresses
        (including this address).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-REQUEST-CONFIGURATION"

    end_address: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "END-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_type: RequestTypeEnum | None = field(
        default=None,
        metadata={
            "name": "REQUEST-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_address: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "START-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EcucConfigurationClassAffection:
    """Specifies in the "VendorSpecificModuleDefinition" whether changes on this
    parameter do affect other parameters in a later configuration step.

    This element is removed from the specifications and shall not be
    used.

    :ivar affected_refs: Optional reference to parameters or references
        which are affected by the ConfigurationClassAffection.
    :ivar affection_kind: Specifies which affect do changes in this
        parameter have on other parameters.  This attribute is
        deprecated and will be removed in future versions.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-CONFIGURATION-CLASS-AFFECTION"

    affected_refs: Optional["EcucConfigurationClassAffection.AffectedRefs"] = field(
        default=None,
        metadata={
            "name": "AFFECTED-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    affection_kind: EcucAffectionEnum | None = field(
        default=None,
        metadata={
            "name": "AFFECTION-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AffectedRefs:
        affected_ref: list["EcucConfigurationClassAffection.AffectedRefs.AffectedRef"] = field(
            default_factory=list,
            metadata={
                "name": "AFFECTED-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class AffectedRef(Ref):
            dest: EcucCommonAttributesSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class EcucImplementationConfigurationClass:
    """Specifies which ConfigurationClass this parameter has in the individual
    ConfigurationVariants.

    This element is removed from the specifications and therefore it
    shall not be used.

    :ivar config_class: Specifies the ConfigurationClass for the given
        ConfigurationVariant.
    :ivar config_variant: Specifies the ConfigurationVariant the
        ConfigurationClass is specified for.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS"

    config_class: EcucConfigurationClassEnum | None = field(
        default=None,
        metadata={
            "name": "CONFIG-CLASS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    config_variant: EcucConfigurationVariantEnum | None = field(
        default=None,
        metadata={
            "name": "CONFIG-VARIANT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EcucMultiplicityConfigurationClass:
    """
    Specifies the MultiplicityConfigurationClass of a parameter/reference or a
    container for each ConfigurationVariant of the EcucModuleDef.

    :ivar config_class: Specifies the ConfigurationClass for the given
        ConfigurationVariant.
    :ivar config_variant: Specifies the ConfigurationVariant the
        ConfigurationClass is specified for.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-MULTIPLICITY-CONFIGURATION-CLASS"

    config_class: EcucConfigurationClassEnum | None = field(
        default=None,
        metadata={
            "name": "CONFIG-CLASS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    config_variant: EcucConfigurationVariantEnum | None = field(
        default=None,
        metadata={
            "name": "CONFIG-VARIANT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EcucValueConfigurationClass:
    """
    Specifies the ValueConfigurationClass of a parameter/reference for each
    ConfigurationVariant of the EcucModuleDef.

    :ivar config_class: Specifies the ConfigurationClass for the given
        ConfigurationVariant.
    :ivar config_variant: Specifies the ConfigurationVariant the
        ConfigurationClass is specified for.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-VALUE-CONFIGURATION-CLASS"

    config_class: EcucConfigurationClassEnum | None = field(
        default=None,
        metadata={
            "name": "CONFIG-CLASS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    config_variant: EcucConfigurationVariantEnum | None = field(
        default=None,
        metadata={
            "name": "CONFIG-VARIANT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EthernetPriorityRegeneration:
    """Defines a priority regeneration where the ingressPriority is replaced by
    regeneratedPriority.

    The ethernetPriorityRegeneration is optional in case no priority
    regeneration shall be performed. In case a
    ethernetPriorityRegeneration is defined it shall have 8 mappings,
    one for each priority.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar ingress_priority: Message priority of the incoming message.
        range: 0-7
    :ivar regenerated_priority: Regenerated message priority. range: 0-7
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-PRIORITY-REGENERATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthernetPriorityRegeneration.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ingress_priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INGRESS-PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    regenerated_priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "REGENERATED-PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ExecutableEntityActivationReason:
    """
    This meta-class represents the ability to define the reason for the activation
    of the enclosing ExecutableEntity.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar symbol: The symbol to be used as (depending on the concrete
        case) either a complete replacement or a prefix.
    :ivar bit_position: This attribute allows for defining the position
        of the enclosing ExecutableEntityActivationReason in the
        activation vector.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXECUTABLE-ENTITY-ACTIVATION-REASON"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ExecutableEntityActivationReason.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bit_position: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BIT-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ExecutionDependency:
    """
    This element defines a ProcessState in which a dependent process needs to be
    before the process that aggregates the ExecutionDependency element can be
    started.

    :ivar process_state_iref: This represent the applicable
        modeDeclaration that represents an ProcessState.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXECUTION-DEPENDENCY"

    process_state_iref: ModeInProcessInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PROCESS-STATE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FirewallRuleProps:
    """
    Firewall rule that is defined by an action that is performed if the referenced
    pattern matches.

    :ivar action: Action that is performed by the firewall if the
        matchingRule is fulfilled.
    :ivar matching_rule_refs: This element defines a rule expression
        against which the network traffic is matched.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FIREWALL-RULE-PROPS"

    action: FirewallActionEnum | None = field(
        default=None,
        metadata={
            "name": "ACTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    matching_rule_refs: Optional["FirewallRuleProps.MatchingRuleRefs"] = field(
        default=None,
        metadata={
            "name": "MATCHING-RULE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class MatchingRuleRefs:
        matching_rule_ref: list["FirewallRuleProps.MatchingRuleRefs.MatchingRuleRef"] = field(
            default_factory=list,
            metadata={
                "name": "MATCHING-RULE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class MatchingRuleRef(Ref):
            dest: FirewallRuleSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class FlexrayFifoConfiguration:
    """
    One First In First Out (FIFO) queued receive structure, defining the admittance
    criteria to the FIFO, and mandating the ability to admit messages into the FIFO
    based on Message Id filtering criteria.

    :ivar admit_without_message_id: Boolean configuration which
        determines whether or not frames received in the dynamic segment
        that don't contain a message ID will be admitted into the FIFO.
    :ivar base_cycle: FIFO cycle counter acceptance criteria.
    :ivar channel_ref: Fifo channel admittance criteria.
    :ivar cycle_repetition: FIFO cycle counter acceptance criteria.
    :ivar fifo_depth: FrFifoDepth configures the maximum number of rx-
        frames which can be contained in the FIFO.
    :ivar fifo_ranges: FIFO Frame Id range acceptance criteria.
    :ivar msg_id_mask: FIFO message identifier acceptance criteria (Mask
        filter).
    :ivar msg_id_match: FIFO message identifier acceptance criteria
        (Match filter).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-FIFO-CONFIGURATION"

    admit_without_message_id: Boolean | None = field(
        default=None,
        metadata={
            "name": "ADMIT-WITHOUT-MESSAGE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    base_cycle: Integer | None = field(
        default=None,
        metadata={
            "name": "BASE-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    channel_ref: Optional["FlexrayFifoConfiguration.ChannelRef"] = field(
        default=None,
        metadata={
            "name": "CHANNEL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cycle_repetition: Integer | None = field(
        default=None,
        metadata={
            "name": "CYCLE-REPETITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fifo_depth: Integer | None = field(
        default=None,
        metadata={
            "name": "FIFO-DEPTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fifo_ranges: Optional["FlexrayFifoConfiguration.FifoRanges"] = field(
        default=None,
        metadata={
            "name": "FIFO-RANGES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msg_id_mask: Integer | None = field(
        default=None,
        metadata={
            "name": "MSG-ID-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msg_id_match: Integer | None = field(
        default=None,
        metadata={
            "name": "MSG-ID-MATCH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ChannelRef(Ref):
        dest: FlexrayPhysicalChannelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FifoRanges:
        flexray_fifo_range: list[FlexrayFifoRange] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-FIFO-RANGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FunctionGroupPhmStateReference:
    """
    Function Group state dependency.

    :ivar function_group_state_iref: This represent the applicable
        functionGroupState.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FUNCTION-GROUP-PHM-STATE-REFERENCE"

    function_group_state_iref: FunctionGroupStateInFunctionGroupSetInstanceRef | None = field(
        default=None,
        metadata={
            "name": "FUNCTION-GROUP-STATE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ISignalProps:
    """
    Additional ISignal properties that may be stored in different files.

    :ivar handle_out_of_range: This attribute defines the
        outOfRangeHandling for received and sent signals.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-SIGNAL-PROPS"

    handle_out_of_range: HandleOutOfRangeEnum | None = field(
        default=None,
        metadata={
            "name": "HANDLE-OUT-OF-RANGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class InterpolationRoutineMapping:
    """This meta-class provides a mapping between one record layout and its
    matching interpolation routines.

    This allows to formally specify the semantics of the interpolation
    routines. The use case is such that the curves/Maps define an
    interpolation method. This mapping table specifies which
    interpolation routine implements methods for a particular record
    layout. Using this information, the implementer of a software-
    component can select the appropriate interpolation routine.

    :ivar interpolation_routines: This is one particular interpolation
        routine which is mapped to the record layout.
    :ivar sw_record_layout_ref: This refers to the record layout which
        is mapped to interpolation routines.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INTERPOLATION-ROUTINE-MAPPING"

    interpolation_routines: Optional["InterpolationRoutineMapping.InterpolationRoutines"] = field(
        default=None,
        metadata={
            "name": "INTERPOLATION-ROUTINES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_ref: Optional["InterpolationRoutineMapping.SwRecordLayoutRef"] = field(
        default=None,
        metadata={
            "name": "SW-RECORD-LAYOUT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class InterpolationRoutines:
        interpolation_routine: list[InterpolationRoutine] = field(
            default_factory=list,
            metadata={
                "name": "INTERPOLATION-ROUTINE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwRecordLayoutRef(Ref):
        dest: SwRecordLayoutSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class InvalidationPolicy:
    """Specifies whether the component can actively invalidate a particular
    dataElement.

    If no invalidationPolicy points to a dataElement this is considered
    to yield the identical result as if the handleInvalid attribute was
    set to dontInvalidate.

    :ivar data_element_ref: Reference to the dataElement for which the
        InvalidationPolicy applies.
    :ivar handle_invalid: This attribute controls how invalidation is
        applied to the dataElement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INVALIDATION-POLICY"

    data_element_ref: Optional["InvalidationPolicy.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    handle_invalid: HandleInvalidEnum | None = field(
        default=None,
        metadata={
            "name": "HANDLE-INVALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class IpIamAuthenticConnectionProps:
    """
    This meta-class defines a set of properties for IP connections in the context
    of IAM configuration.

    :ivar ip_protocol: This attribute defines the relevant IP protocol.
    :ivar local_network_endpoint_ref: This reference defines an
        authentic local NetworkEndpoint in terms of IAM configuration.
    :ivar local_port_range_end: This attribute restricts the traffic
        monitoring and defines an end value for the local port range.
    :ivar local_port_range_start: This attribute restricts the traffic
        monitoring and defines a start value for the local port range.
    :ivar remote_network_endpoint_ref: This reference defines an
        authentic remote NetworkEndpoint in terms of IAM configuration.
    :ivar remote_port_range_end: This attribute restricts the traffic
        monitoring and defines an end value for the remote port range.
    :ivar remote_port_range_start: This attribute restricts the traffic
        monitoring and defines a start value for the remote port range.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IP-IAM-AUTHENTIC-CONNECTION-PROPS"

    ip_protocol: IpTransportProtocolEnum | None = field(
        default=None,
        metadata={
            "name": "IP-PROTOCOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_network_endpoint_ref: Optional[
        "IpIamAuthenticConnectionProps.LocalNetworkEndpointRef"
    ] = field(
        default=None,
        metadata={
            "name": "LOCAL-NETWORK-ENDPOINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_port_range_end: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOCAL-PORT-RANGE-END",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_port_range_start: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOCAL-PORT-RANGE-START",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_network_endpoint_ref: Optional[
        "IpIamAuthenticConnectionProps.RemoteNetworkEndpointRef"
    ] = field(
        default=None,
        metadata={
            "name": "REMOTE-NETWORK-ENDPOINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_port_range_end: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "REMOTE-PORT-RANGE-END",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_port_range_start: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "REMOTE-PORT-RANGE-START",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class LocalNetworkEndpointRef(Ref):
        dest: EthernetPhysicalChannelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RemoteNetworkEndpointRef(Ref):
        dest: EthernetPhysicalChannelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Ipv4Configuration:
    """
    Internet Protocol version 4 (IPv4) configuration.

    :ivar assignment_priority: Priority of assignment (1 is highest). If
        a new address from an assignment method with a higher priority
        is available, it overwrites the IP address previously assigned
        by an assignment method with a lower priority.
    :ivar default_gateway: IP address of the default gateway.
    :ivar dns_server_addresses: IP addresses of preconfigured DNS
        servers.
    :ivar ip_address_keep_behavior: Defines the lifetime of a
        dynamically fetched IP address.
    :ivar ipv_4_address: IPv4 Address. Notation: 255.255.255.255. The IP
        Address shall be declared in case the ipv4AddressSource is FIXED
        and thus no auto-configuration mechanism is used.
    :ivar ipv_4_address_source: Defines how the node obtains its IP
        address.
    :ivar network_mask: Network mask. Notation 255.255.255.255
    :ivar ttl: Lifespan of data (0..255). The purpose of the TimeToLive
        field is to avoid a situation in which an undeliverable datagram
        keeps circulating on a system.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-4-CONFIGURATION"

    assignment_priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ASSIGNMENT-PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_gateway: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-GATEWAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dns_server_addresses: Optional["Ipv4Configuration.DnsServerAddresses"] = field(
        default=None,
        metadata={
            "name": "DNS-SERVER-ADDRESSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ip_address_keep_behavior: IpAddressKeepEnum | None = field(
        default=None,
        metadata={
            "name": "IP-ADDRESS-KEEP-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_4_address: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "IPV-4-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_4_address_source: Ipv4AddressSourceEnum | None = field(
        default=None,
        metadata={
            "name": "IPV-4-ADDRESS-SOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_mask: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "NETWORK-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ttl: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TTL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DnsServerAddresses:
        dns_server_address: list[Ip4AddressString] = field(
            default_factory=list,
            metadata={
                "name": "DNS-SERVER-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Ipv4Props:
    """
    This meta-class specifies the configuration options for IPv4.

    :ivar arp_props: Configuration properties for the ARP (Address
        Resolution Protocol).
    :ivar auto_ip_props: Configuration options for Auto-IP (automatic
        private IP addressing).
    :ivar fragmentation_props: Configuration options for IPv4 packet
        fragmentation/reassembly.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-4-PROPS"

    arp_props: Ipv4ArpProps | None = field(
        default=None,
        metadata={
            "name": "ARP-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    auto_ip_props: Ipv4AutoIpProps | None = field(
        default=None,
        metadata={
            "name": "AUTO-IP-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fragmentation_props: Ipv4FragmentationProps | None = field(
        default=None,
        metadata={
            "name": "FRAGMENTATION-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Ipv4Rule:
    """
    Configuration of filter rules on IPv4 level.

    :ivar checksum_verification: Defines whether a Ipv4 header checksum
        verification is performed or not.
    :ivar destination_ip_address: Filter to match packets with the
        destination IPv4 address.
    :ivar destination_network_mask: Filter to match packets with the
        destination IPv4 address range. The destinationIpAddress with
        the destinationNetworkMask defines the IP address range.
    :ivar differentiated_service_code_point: Filter to match packets
        with a DSCP value.
    :ivar do_not_fragment: Filter to match packets that have the
        doNotFragment bit in the Header set.
    :ivar explicit_congestion_notification: Filter to match packets with
        a ECN code point.
    :ivar icmp_rule: Configuration of filter rules for ICMP (Internet
        Control Message Protocol).
    :ivar internet_header_length: Filter to match packets with a minimum
        ipv4 header length.
    :ivar more_fragments: Filter to match packets that have the
        moreFragments flag in the Header set.
    :ivar protocol: Filter to match packets with a IP protocol number .
    :ivar source_ip_address: Filter to match packets with the source
        IPv4 address.
    :ivar source_network_mask: Filter to match packets with the source
        IPv4 address range. The sourceIpAddress with the
        sourceNetworkMask defines the IP address range.
    :ivar ttl_max: Filter to match packets with a maximum ttl value
        (TimeToLive defines the lifetime of data on the network).
    :ivar ttl_min: Filter to match packets with a minimum ttl value
        (TimeToLive defines the lifetime of data on the network).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-4-RULE"

    checksum_verification: Boolean | None = field(
        default=None,
        metadata={
            "name": "CHECKSUM-VERIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_ip_address: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-IP-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_network_mask: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-NETWORK-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    differentiated_service_code_point: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DIFFERENTIATED-SERVICE-CODE-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    do_not_fragment: Boolean | None = field(
        default=None,
        metadata={
            "name": "DO-NOT-FRAGMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    explicit_congestion_notification: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "EXPLICIT-CONGESTION-NOTIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    icmp_rule: IcmpRule | None = field(
        default=None,
        metadata={
            "name": "ICMP-RULE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    internet_header_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INTERNET-HEADER-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    more_fragments: Boolean | None = field(
        default=None,
        metadata={
            "name": "MORE-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_ip_address: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "SOURCE-IP-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_network_mask: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "SOURCE-NETWORK-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ttl_max: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TTL-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ttl_min: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TTL-MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Ipv6Configuration:
    """
    Internet Protocol version 6 (IPv6) configuration.

    :ivar assignment_priority: Priority of assignment (1 is highest). If
        a new address from an assignment method with a higher priority
        is available, it overwrites the IP address previously assigned
        by an assignment method with a lower priority.
    :ivar default_router: IP address of the default router.
    :ivar dns_server_addresses: IP addresses of pre configured DNS
        servers.
    :ivar enable_anycast: This attribute is used to enable anycast
        addressing (i.e. to one of multiple receivers).
    :ivar hop_count: The distance between two hosts. The hop count n
        means that n gateways separate the source host from the
        destination host (Range 0..255)
    :ivar ip_address_keep_behavior: Defines the lifetime of a
        dynamically fetched IP address.
    :ivar ip_address_prefix_length: IPv6 prefix length defines the part
        of the IPv6 address that is the network prefix.
    :ivar ipv_6_address: IPv6 Address. Notation: FFFF:...:FFFF. The IP
        Address shall be declared in case the ipv6AddressSource is FIXED
        and thus no auto-configuration mechanism is used.
    :ivar ipv_6_address_source: Defines how the node obtains its IP
        address.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-6-CONFIGURATION"

    assignment_priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ASSIGNMENT-PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_router: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-ROUTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dns_server_addresses: Optional["Ipv6Configuration.DnsServerAddresses"] = field(
        default=None,
        metadata={
            "name": "DNS-SERVER-ADDRESSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    enable_anycast: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-ANYCAST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hop_count: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "HOP-COUNT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ip_address_keep_behavior: IpAddressKeepEnum | None = field(
        default=None,
        metadata={
            "name": "IP-ADDRESS-KEEP-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ip_address_prefix_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "IP-ADDRESS-PREFIX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_6_address: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "IPV-6-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_6_address_source: Ipv6AddressSourceEnum | None = field(
        default=None,
        metadata={
            "name": "IPV-6-ADDRESS-SOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DnsServerAddresses:
        dns_server_address: list[Ip6AddressString] = field(
            default_factory=list,
            metadata={
                "name": "DNS-SERVER-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Ipv6Props:
    """
    This meta-class specifies the configuration options for IPv6.

    :ivar dhcp_props: Configuration properties for DHCPv6.
    :ivar fragmentation_props: Configuration properties for IPv6 packet
        fragmentation/reassembly.
    :ivar ndp_props: Configuration properties for the Neighbor Discovery
        Protocol for IPv6.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-6-PROPS"

    dhcp_props: Dhcpv6Props | None = field(
        default=None,
        metadata={
            "name": "DHCP-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fragmentation_props: Ipv6FragmentationProps | None = field(
        default=None,
        metadata={
            "name": "FRAGMENTATION-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ndp_props: Ipv6NdpProps | None = field(
        default=None,
        metadata={
            "name": "NDP-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Ipv6Rule:
    """
    Configuration of filter rules on IPv6 level.

    :ivar destination_ip_address: Filter to match packets with the
        destination IPv6 address.
    :ivar destination_network_mask: Filter to match packets with the
        destination IPv6 address range. The destinationIpAddress with
        the destinationNetworkMask defines the MAC address range.
    :ivar flow_label: Filter to match packets with a defined flow label.
    :ivar hop_limit: Filter to match packets with a minimum hop limit.
    :ivar icmp_rule: Configuration of filter rules for ICMP (Internet
        Control Message Protocol).
    :ivar next_header: Filter to match packets with a defined type of an
        extension header.
    :ivar source_ip_address: Filter to match packets with the source
        IPv6 address.
    :ivar source_network_mask: Filter to match packets with the source
        IPv6 address range. The sourceIpAddress with the
        sourceNetworkMask defines the IP address range.
    :ivar traffic_class: Filter to match packets with a defined traffic
        class or priority.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-6-RULE"

    destination_ip_address: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-IP-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_network_mask: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-NETWORK-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    flow_label: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FLOW-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hop_limit: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "HOP-LIMIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    icmp_rule: IcmpRule | None = field(
        default=None,
        metadata={
            "name": "ICMP-RULE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    next_header: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NEXT-HEADER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_ip_address: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "SOURCE-IP-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_network_mask: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "SOURCE-NETWORK-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    traffic_class: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TRAFFIC-CLASS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class LLongName:
    """MixedContentForLongNames  in one particular language.

    The language is denoted in the attribute l.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar l: 'This attribute denotes the language in which the language
        specific document entity is given. Note that "FOR-ALL" means,
        that the entity is applicable to all languages. It is language
        neutral. It follows ISO 639-1:2002 and is specified in upper
        case.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar content:
    """

    class Meta:
        name = "L-LONG-NAME"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    l: LEnumSimple = field(
        metadata={
            "name": "L",
            "type": "Attribute",
            "required": True,
        }
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "TT",
                    "type": Tt,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "E",
                    "type": EmphasisText,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUP",
                    "type": ForwardRef("LLongName.Sup"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUB",
                    "type": ForwardRef("LLongName.Sub"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "IE",
                    "type": IndexEntry,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Sup(Supscript):
        pass

    @dataclass(slots=True, kw_only=True)
    class Sub(Supscript):
        pass


@dataclass(slots=True, kw_only=True)
class LinSlaveConfigIdent:
    """
    This meta-class is created to add the ability to become the target of a
    reference to the non-Referrable LinSlaveConfig.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-SLAVE-CONFIG-IDENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LinSlaveConfigIdent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class MacSecCryptoAlgoConfig:
    """
    This meta-class defines the cryptography configuration for MACsec.

    :ivar capability: This attribute defines the MACsec capability.
    :ivar cipher_suite_configs: Cipher suite configuration to use with
        MACsec.
    :ivar confidentiality_offset: The MACsec confidentiality offset
        specifies the number of bytes starting from the frame header.
        MACsec encrypts only the bytes after the offset in a frame.
    :ivar replay_protection: This attribute is used to configure the
        MACsec replay protection.
    :ivar replay_protection_window: In case replay protection is active,
        this attribute defines the replay protection window.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAC-SEC-CRYPTO-ALGO-CONFIG"

    capability: MacSecCapabilityEnum | None = field(
        default=None,
        metadata={
            "name": "CAPABILITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cipher_suite_configs: Optional["MacSecCryptoAlgoConfig.CipherSuiteConfigs"] = field(
        default=None,
        metadata={
            "name": "CIPHER-SUITE-CONFIGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    confidentiality_offset: MacSecConfidentialityOffsetEnum | None = field(
        default=None,
        metadata={
            "name": "CONFIDENTIALITY-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    replay_protection: Boolean | None = field(
        default=None,
        metadata={
            "name": "REPLAY-PROTECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    replay_protection_window: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "REPLAY-PROTECTION-WINDOW",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CipherSuiteConfigs:
        mac_sec_cipher_suite_config: list[MacSecCipherSuiteConfig] = field(
            default_factory=list,
            metadata={
                "name": "MAC-SEC-CIPHER-SUITE-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 4,
            },
        )


@dataclass(slots=True, kw_only=True)
class MacSecLocalKayProps:
    """
    Configuration of the MAC Security Key Agreement Entity (KaY).

    :ivar destination_mac_address: This attribute defines the
        destination MAC Address that is used to calculate the ICV
        (Integrity Check Value).
    :ivar global_kay_props_ref: Reference to properties that are shared
        between MAC Security Key Agreement Entities.
    :ivar key_server_priority: This attribute defines the  key-server
        priority.
    :ivar mka_participant_refs: Reference to MKA participant settings
        supported on the CouplingPort.
    :ivar role: Role of the MAC Security Key Agreement Entity
    :ivar source_mac_address: This attribute defines the source MAC
        Address that is used to calculate the ICV (Integrity Check
        Value).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAC-SEC-LOCAL-KAY-PROPS"

    destination_mac_address: MacAddressString | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-MAC-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_kay_props_ref: Optional["MacSecLocalKayProps.GlobalKayPropsRef"] = field(
        default=None,
        metadata={
            "name": "GLOBAL-KAY-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_server_priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "KEY-SERVER-PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mka_participant_refs: Optional["MacSecLocalKayProps.MkaParticipantRefs"] = field(
        default=None,
        metadata={
            "name": "MKA-PARTICIPANT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    role: MacSecRoleEnum | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_mac_address: MacAddressString | None = field(
        default=None,
        metadata={
            "name": "SOURCE-MAC-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class GlobalKayPropsRef(Ref):
        dest: MacSecGlobalKayPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MkaParticipantRefs:
        mka_participant_ref: list["MacSecLocalKayProps.MkaParticipantRefs.MkaParticipantRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "MKA-PARTICIPANT-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class MkaParticipantRef(Ref):
            dest: MacSecKayParticipantSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class Map:
    """Image maps enable authors to specify regions of an image or object and
    assign a specific action to each region (e.g., retrieve a document, run a
    program, etc.) When the region is activated by the user, the action is
    executed.

    The class follows the html approach and is intended to support
    interactive documents.

    :ivar area: This element specifies a region in an image map. Image
        maps enable authors to specify regions in an object (e.g. a
        graphic) and to assign a specific activity to each region (e.g.
        load a document, launch a program etc.).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar class_value: This attribute assigns a class name or set of
        class names to an element. Any number of elements may be
        assigned the same class name or set of class names. Multiple
        class names shall be separated by white space characters. Class
        names are typically used to apply CSS formatting rules to an
        element.
    :ivar name: This attribute assigns a name to the image map in the
        MAP element. This name can be used to be referenced in an HTML
        image through the attribute USEMAP. Although this is not
        actually necessary in the MSR model, it was inserted in order to
        support the MAPs which were created for HTML.
    :ivar onclick: The ONCLICK-Event occurs, if the current element is
        clicked on. A script can be stored in this attribute to be
        performed in the Event.
    :ivar ondblclick: The ONDBLCLICK-Event occurs, if the current Event
        is "double" clicked-on. A script can be stored in this attribute
        to be performed in the Event.
    :ivar onkeydown: The ONKEYDOWN-Event occurs, if a button on the
        current element is pressed down. A script can be stored in this
        attribute to be performed in the event.
    :ivar onkeypress: The ONKEYPRESS-Event occurs, if a button on the
        current element is pressed down and released. A script can be
        stored in this attribute to be performed in the Event.
    :ivar onkeyup: The ONKEYUP-Event occurs, if a button on the current
        element is released. A script can be stored in this attribute to
        be performed in the Event.
    :ivar onmousedown: The ONMOUSEDOWN-Event occurs, if the mouse button
        used for clicking is held down on the current element. A script
        can be stored in this attribute to be performed in the Event.
    :ivar onmousemove: The ONMOUSEMOVE-Event occurs, if the mouse
        pointer is moved on the current element (i.e. it is located on
        the current element). A script can be stored in this attribute
        to be performed in the Event.
    :ivar onmouseout: The ONMOUSEOUT-Event occurs, if the mouse pointer
        is moved from the current element. A script can be stored in
        this attribute to be performed in the Event.
    :ivar onmouseover: The ONMOUSEOVER-Event occurs, if the mouse
        pointer is moved to the current element from another location
        outside it. A script can be stored in this attribute to be
        performed in the Event.
    :ivar onmouseup: The ONMOUSEUP-Event occurs if the mouse button used
        for clicking is released on the current element. A script can be
        stored in this attribute to be performed in the Event.
    :ivar style: This attribute specifies formatting style information
        for the current element. The content of this attribute is called
        inline CSS. The style attribute is deprecated (considered
        outdated), because it fuses together content and formatting.
    :ivar title: This attribute offers advisory information. Some Web
        browsers will display this information as tooltips. Authoring
        tools may make this information available to users as additional
        information about the element.
    """

    class Meta:
        name = "MAP"

    area: list[Area] = field(
        default_factory=list,
        metadata={
            "name": "AREA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    class_value: str | None = field(
        default=None,
        metadata={
            "name": "CLASS",
            "type": "Attribute",
        },
    )
    name: str | None = field(
        default=None,
        metadata={
            "name": "NAME",
            "type": "Attribute",
        },
    )
    onclick: str | None = field(
        default=None,
        metadata={
            "name": "ONCLICK",
            "type": "Attribute",
        },
    )
    ondblclick: str | None = field(
        default=None,
        metadata={
            "name": "ONDBLCLICK",
            "type": "Attribute",
        },
    )
    onkeydown: str | None = field(
        default=None,
        metadata={
            "name": "ONKEYDOWN",
            "type": "Attribute",
        },
    )
    onkeypress: str | None = field(
        default=None,
        metadata={
            "name": "ONKEYPRESS",
            "type": "Attribute",
        },
    )
    onkeyup: str | None = field(
        default=None,
        metadata={
            "name": "ONKEYUP",
            "type": "Attribute",
        },
    )
    onmousedown: str | None = field(
        default=None,
        metadata={
            "name": "ONMOUSEDOWN",
            "type": "Attribute",
        },
    )
    onmousemove: str | None = field(
        default=None,
        metadata={
            "name": "ONMOUSEMOVE",
            "type": "Attribute",
        },
    )
    onmouseout: str | None = field(
        default=None,
        metadata={
            "name": "ONMOUSEOUT",
            "type": "Attribute",
        },
    )
    onmouseover: str | None = field(
        default=None,
        metadata={
            "name": "ONMOUSEOVER",
            "type": "Attribute",
        },
    )
    onmouseup: str | None = field(
        default=None,
        metadata={
            "name": "ONMOUSEUP",
            "type": "Attribute",
        },
    )
    style: str | None = field(
        default=None,
        metadata={
            "name": "STYLE",
            "type": "Attribute",
        },
    )
    title: str | None = field(
        default=None,
        metadata={
            "name": "TITLE",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class McDataAccessDetails:
    """This meta-class allows to attach detailed information about the usage of a
    data buffer by the RTE to a corresponding McDataInstance.

    Use Case:  Direct memory access to RTE internal buffers for rapid prototyping. In case of implicit communication, the various task local buffers need to be identified in relation to RTE events and variable access points.
    Note that the SwComponentPrototype, the RunnableEntity and the VariableDataPrototype are implicitly given be the referred instances of RTEEvent and VariableAccess.

    :ivar rte_event_irefs: The RTE event used to receive the data via
        this buffer.
    :ivar variable_access_irefs: The VariableAccess for which the data
        buffer is used.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MC-DATA-ACCESS-DETAILS"

    rte_event_irefs: Optional["McDataAccessDetails.RteEventIrefs"] = field(
        default=None,
        metadata={
            "name": "RTE-EVENT-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variable_access_irefs: Optional["McDataAccessDetails.VariableAccessIrefs"] = field(
        default=None,
        metadata={
            "name": "VARIABLE-ACCESS-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class RteEventIrefs:
        rte_event_iref: list[RteEventInEcuInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "RTE-EVENT-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class VariableAccessIrefs:
        variable_access_iref: list[VariableAccessInEcuInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-ACCESS-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ModeErrorBehavior:
    """
    This represents the ability to define the error behavior in the context of mode
    handling.

    :ivar default_mode_ref: This represents the ModeDeclaration that is
        considered the error mode in the context of the enclosing
        ModeDeclarationGroup.
    :ivar error_reaction_policy: This represents the ability to define
        the policy in terms of which default model shall apply in case
        an error occurs.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-ERROR-BEHAVIOR"

    default_mode_ref: Optional["ModeErrorBehavior.DefaultModeRef"] = field(
        default=None,
        metadata={
            "name": "DEFAULT-MODE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    error_reaction_policy: ModeErrorReactionPolicyEnum | None = field(
        default=None,
        metadata={
            "name": "ERROR-REACTION-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DefaultModeRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeSwitchSenderComSpec:
    """
    Communication attributes of PPortPrototypes with respect to mode communication.

    :ivar enhanced_mode_api: This controls the creation of the enhanced
        mode API that returns information about the previous mode and
        the next mode. If set to "true" the enhanced mode API is
        supposed to be generated. For more details please refer to the
        SWS_RTE.
    :ivar mode_group_ref: ModeDeclarationGroupPrototype (of the same
        PortInterface) to which these communication attributes apply.
    :ivar mode_switched_ack: If this aggregation exists an
        acknowledgement for the successful processing of the mode switch
        request is required.
    :ivar queue_length: Length of call queue on the mode user side. The
        queue is implemented by the RTE. The value shall be greater or
        equal to 1. Setting the value of queueLength to 1 implies that
        incoming requests are rejected while another request that
        arrived earlier is being processed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-SWITCH-SENDER-COM-SPEC"

    enhanced_mode_api: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENHANCED-MODE-API",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_group_ref: Optional["ModeSwitchSenderComSpec.ModeGroupRef"] = field(
        default=None,
        metadata={
            "name": "MODE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_switched_ack: ModeSwitchedAckRequest | None = field(
        default=None,
        metadata={
            "name": "MODE-SWITCHED-ACK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    queue_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "QUEUE-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ModeGroupRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class MultiLanguagePlainText:
    """
    This is a multilingual plaint Text.It is intended to be rendered as a
    paragraph.

    :ivar l_10: This is the plain text in one particular language.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MULTI-LANGUAGE-PLAIN-TEXT"

    l_10: list[LPlainText] = field(
        default_factory=list,
        metadata={
            "name": "L-10",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MultiplicityRestrictionWithSeverity:
    """
    Restriction that specifies the valid number of occurrences of an element in the
    current context.

    :ivar severity: Severity level that is reported in case the
        restriction is violated.
    :ivar lower_multiplicity: Specifies the minimal number of times an
        object shall occur. If this primitive attribute is not set, then
        the object is optional.
    :ivar upper_multiplicity: Specifies the maximum number of times an
        object may occur.  If this primitive attribute is not set, then
        there is no limit with respect to the maximum occurrence.
    :ivar upper_multiplicity_infinite: This explicitly specifies, that
        the upper multiplicity is NOT restricted. Note: The use of
        'upperMultiplicityInfinite' and 'upperMultiplicity' is mutual
        exclusive.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MULTIPLICITY-RESTRICTION-WITH-SEVERITY"

    severity: SeverityEnum | None = field(
        default=None,
        metadata={
            "name": "SEVERITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: Boolean | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class NmNetworkHandle:
    """
    Group of partialNetworks and/or VLANs that can be controlled collectively.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar partial_network_refs: Reference to a Partial Network that is
        included in the NmNetworkHandle.
    :ivar vlan_refs: Reference to a VLAN that is included in the
        NmNetworkHandle.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NM-NETWORK-HANDLE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["NmNetworkHandle.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    partial_network_refs: Optional["NmNetworkHandle.PartialNetworkRefs"] = field(
        default=None,
        metadata={
            "name": "PARTIAL-NETWORK-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vlan_refs: Optional["NmNetworkHandle.VlanRefs"] = field(
        default=None,
        metadata={
            "name": "VLAN-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PartialNetworkRefs:
        partial_network_ref: list["NmNetworkHandle.PartialNetworkRefs.PartialNetworkRef"] = field(
            default_factory=list,
            metadata={
                "name": "PARTIAL-NETWORK-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PartialNetworkRef(Ref):
            dest: PncMappingIdentSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class VlanRefs:
        vlan_ref: list["NmNetworkHandle.VlanRefs.VlanRef"] = field(
            default_factory=list,
            metadata={
                "name": "VLAN-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class VlanRef(Ref):
            dest: EthernetCommunicationConnectorSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class PayloadBytePatternRule:
    """
    Configuration of a generic firewall rule that defines the individual bytes of a
    message that shall match.

    :ivar payload_byte_pattern_rule_parts: Configuration of bytes in the
        message,
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PAYLOAD-BYTE-PATTERN-RULE"

    payload_byte_pattern_rule_parts: Optional[
        "PayloadBytePatternRule.PayloadBytePatternRuleParts"
    ] = field(
        default=None,
        metadata={
            "name": "PAYLOAD-BYTE-PATTERN-RULE-PARTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PayloadBytePatternRuleParts:
        payload_byte_pattern_rule_part: list[PayloadBytePatternRulePart] = field(
            default_factory=list,
            metadata={
                "name": "PAYLOAD-BYTE-PATTERN-RULE-PART",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PduMappingDefaultValue:
    """
    Default Value which will be distributed if no I-Pdu has been received since
    last sending.

    :ivar default_value_elements: The default value consists of a number
        of elements. Each default value element is represented by the
        element and the position in an array.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PDU-MAPPING-DEFAULT-VALUE"

    default_value_elements: Optional["PduMappingDefaultValue.DefaultValueElements"] = field(
        default=None,
        metadata={
            "name": "DEFAULT-VALUE-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DefaultValueElements:
        default_value_element: list[DefaultValueElement] = field(
            default_factory=list,
            metadata={
                "name": "DEFAULT-VALUE-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PersistencyRedundancyCrc:
    """
    This meta-class formally describes the usage of a CRC for the implementation of
    redundancy.

    :ivar scope: This attribute controls the scope in which the
        redundancy handling is applied.
    :ivar algorithm_family: This attribute identifies the algorithm
        family that is used to execute the CRC/Hash.
    :ivar length: This attribute describes the length of the CRC/Hash in
        the unit bits.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-REDUNDANCY-CRC"

    scope: PersistencyRedundancyHandlingScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    algorithm_family: String | None = field(
        default=None,
        metadata={
            "name": "ALGORITHM-FAMILY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PersistencyRedundancyHash:
    """
    This meta-class formally describes the usage of a Hash for the implementation
    of redundancy.

    :ivar scope: This attribute controls the scope in which the
        redundancy handling is applied.
    :ivar algorithm_family: This attribute identifies the algorithm
        family that is used to execute the CRC/Hash.
    :ivar length: This attribute describes the length of the CRC/Hash in
        the unit bits.
    :ivar initialization_vector_length: Length of the initialization
        vector.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-REDUNDANCY-HASH"

    scope: PersistencyRedundancyHandlingScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    algorithm_family: String | None = field(
        default=None,
        metadata={
            "name": "ALGORITHM-FAMILY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initialization_vector_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INITIALIZATION-VECTOR-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PersistencyRedundancyMOutOfN:
    """This meta-class provides the ability to describe redundancy via an "M out of
    N" approach.

    In this case N is the number of copies created and M is the minimum
    number of identical copies to justify a reliable read access to the
    data.

    :ivar scope: This attribute controls the scope in which the
        redundancy handling is applied.
    :ivar m: This attribute represents the "M" coordinate in the "M out
        of N" scheme.
    :ivar n: This attribute represents the "N" coordinate in the "M out
        of N" scheme.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-REDUNDANCY-M-OUT-OF-N"

    scope: PersistencyRedundancyHandlingScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    m: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "M",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    n: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "N",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PncMappingIdent:
    """
    This meta-class is created to add the ability to become the target of a
    reference to the non-Referrable PncMapping.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PNC-MAPPING-IDENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PncMappingIdent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PostBuildVariantCondition:
    """This class specifies the value which shall be assigned to a particular
    variant criterion in order to bind the variation point.

    If multiple criterion/value pairs are specified, they shall all match to bind the variation point.
    In other words binding can be represented by
    (criterion1 == value1) &amp;&amp; (condition2 == value2) ...

    :ivar matching_criterion_ref: This is the criterion which needs to
        match the value in order to make the PostbuildVariantCondition
        to be true.
    :ivar value: This is the particular value of the post-build variant
        criterion.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "POST-BUILD-VARIANT-CONDITION"

    matching_criterion_ref: Optional["PostBuildVariantCondition.MatchingCriterionRef"] = field(
        default=None,
        metadata={
            "name": "MATCHING-CRITERION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: IntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class MatchingCriterionRef(Ref):
        dest: PostBuildVariantCriterionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PrimitiveAttributeCondition:
    """
    The PrimitiveAttributeCondition evaluates to true, if the referenced primitive
    attribute is accepted by all rules of this condition.

    :ivar lower_multiplicity: Specifies the minimal number of times an
        object shall occur. If this primitive attribute is not set, then
        the object is optional.
    :ivar upper_multiplicity: Specifies the maximum number of times an
        object may occur.  If this primitive attribute is not set, then
        there is no limit with respect to the maximum occurrence.
    :ivar upper_multiplicity_infinite: This explicitly specifies, that
        the upper multiplicity is NOT restricted. Note: The use of
        'upperMultiplicityInfinite' and 'upperMultiplicity' is mutual
        exclusive.
    :ivar max: Specifies the upper bounds for numeric values.
    :ivar max_length: Specifies the maximum number of characters of
        textual values.
    :ivar min: Specifies the lower bounds for numeric values.
    :ivar min_length: Specifies the minimal number of characters of
        textual values.
    :ivar pattern: Defines the exact sequence of characters that are
        acceptable.
    :ivar attribute_ref: The primitive attribute that has to be accepted
        by the restrictions of this PrimitiveAttributeCondition
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PRIMITIVE-ATTRIBUTE-CONDITION"

    lower_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: Boolean | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max: LimitValue | None = field(
        default=None,
        metadata={
            "name": "MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min: LimitValue | None = field(
        default=None,
        metadata={
            "name": "MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pattern: RegularExpression | None = field(
        default=None,
        metadata={
            "name": "PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    attribute_ref: Optional["PrimitiveAttributeCondition.AttributeRef"] = field(
        default=None,
        metadata={
            "name": "ATTRIBUTE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AttributeRef(Ref):
        dest: PrimitiveAttributeTailoringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PrmCharNumericalContents:
    """
    This metaclass represents the fact that it is a numerical parameter.

    :ivar abs: This represnts the absolute value of the parameter.
    :ivar tol: This represnts the tolerance of the parameter in the same
        units as the paramter: E.g. Tmperature= 50 +- 0.5 grad.
    :ivar min: This represnts the minimum value of the parameter.
    :ivar typ: This represnts the typical value of the parameter.
    :ivar max: This represnts the maximum value of the parameter.
    :ivar prm_unit: This is the measurement unit. Note that due to the
        fact that Prm is also available outside of MSRSW / AUTOSAR, this
        is not a formal reference  to a unit.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PRM-CHAR-NUMERICAL-CONTENTS"

    abs: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "ABS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tol: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "TOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    typ: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "TYP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prm_unit: SingleLanguageUnitNames | None = field(
        default=None,
        metadata={
            "name": "PRM-UNIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RPortPrototypeProps:
    """
    PortPrototypeProps for a RPort.

    :ivar search_intention: This attribute is used to specify the
        intention of the developer of the enclosing software-component
        in terms of whether the respective PortPrototype shall be use to
        search for a specific service instance or all instances of the
        given service. Please note that the value of this attribute does
        not create a binding contract. The actual search behavior is
        defined as part of the service instance manifest.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "R-PORT-PROTOTYPE-PROPS"

    search_intention: SearchIntentionEnum | None = field(
        default=None,
        metadata={
            "name": "SEARCH-INTENTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RemotingTechnology:
    """This element is deprecated and will be removed in future.

    Old description: Defines the used remoting Technology.

    :ivar name: Remoting technology used.
    :ivar version: Version of the used remoting Technology.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REMOTING-TECHNOLOGY"

    name: RemotingTechnologyEnum | None = field(
        default=None,
        metadata={
            "name": "NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: String | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RptExecutableEntityProperties:
    """
    Describes the code preparation for rapid prototyping at ExecutableEntity
    invocation.

    :ivar max_rpt_event_id: Highest RPT event id usable for RTE
        generated service points. This attribute is relevant, if
        dedicated id range shall be applied to the ExecutableEntitys of
        a software component or specific ExecutableEntitys.
    :ivar min_rpt_event_id: Lowest RPT event id usable for RTE generated
        service points. This attribute is relevant, if dedicated id
        range shall be applied to the ExecutableEntitys of a software
        component or specific ExecutableEntitys.
    :ivar rpt_execution_control: This attribute specifies the rapid
        prototyping control of the executable
    :ivar rpt_service_point: Enables generation of service points by the
        RTE generator.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-EXECUTABLE-ENTITY-PROPERTIES"

    max_rpt_event_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-RPT-EVENT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_rpt_event_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-RPT-EVENT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_execution_control: RptExecutionControlEnum | None = field(
        default=None,
        metadata={
            "name": "RPT-EXECUTION-CONTROL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_service_point: RptServicePointEnum | None = field(
        default=None,
        metadata={
            "name": "RPT-SERVICE-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RptImplPolicy:
    """
    Describes the code preparation for rapid prototyping at data accesses.

    :ivar rpt_enabler_impl_type: For Level 2 or Level3 this property
        determines how the RTE implements the additional „RP enabler"
        flag.
    :ivar rpt_preparation_level: Mandates RP preparation level for
        access to VariableDataPrototype within generated RTE
        implementation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-IMPL-POLICY"

    rpt_enabler_impl_type: RptEnablerImplTypeEnum | None = field(
        default=None,
        metadata={
            "name": "RPT-ENABLER-IMPL-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_preparation_level: RptPreparationEnum | None = field(
        default=None,
        metadata={
            "name": "RPT-PREPARATION-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RptSwPrototypingAccess:
    """
    Describes the accessibility of data and modes by the rapid prototyping tooling.

    :ivar rpt_hook_access: The related data element can be modified
        using a post-build hooking tool. An ENABLED
        VariableDataPrototype is implicitly READABLE/WRITABLE.
    :ivar rpt_read_access: The related data element can be used as input
        for bypass functionality by RP tool. If rptImplPolicy is not
        specified then RTE generation shall ensure  at least suitable MC
        read points are created.
    :ivar rpt_write_access: The related data element can be used as
        output for bypass functionality by RP tool. The data element
        shall be prepared to rptLevel2 and related write service points
        are present.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-SW-PROTOTYPING-ACCESS"

    rpt_hook_access: RptAccessEnum | None = field(
        default=None,
        metadata={
            "name": "RPT-HOOK-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_read_access: RptAccessEnum | None = field(
        default=None,
        metadata={
            "name": "RPT-READ-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_write_access: RptAccessEnum | None = field(
        default=None,
        metadata={
            "name": "RPT-WRITE-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Sdf:
    """
    This class represents a numerical value in a special data group which may be
    subject to variability.

    :ivar value: This is the value of the special data.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar gid: This attributes specifies an identifier. Gid comes from
        the SGML/XML-Term "Generic Identifier" which is the element name
        in XML. The role of this attribute is the same as the name of an
        XML - element.
    """

    class Meta:
        name = "SDF"

    value: NumericalValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    gid: str | None = field(
        default=None,
        metadata={
            "name": "GID",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class SegmentPosition:
    """The StaticPart and the DynamicPart can be separated in multiple segments
    within the multiplexed PDU.

    The ISignalIPdus are copied bit by bit into the MultiplexedIPdu. If
    the space of the first segment is 5 bits large than the first 5 bits
    of the ISignalIPdu are copied into this first segment and so on.

    :ivar segment_byte_order: This attribute defines the order of the
        bytes of the segment and the packing into the MultiplexedIPdu.
        Please consider that [constr_3247] and [constr_3224] are
        restricting the usage of this attribute.
    :ivar segment_length: Data Length of the segment in bits.
    :ivar segment_position: Segments bit position relatively to the
        beginning of a multiplexed IPdu. Note that the absolute position
        of the segment in the MultiplexedIPdu is determined by the
        definition of the segmentByteOrder attribute of the
        SegmentPosition. If Big Endian is specified, the start position
        indicates the bit position of the most significant bit in the
        IPdu. If Little Endian is specified, the start position
        indicates the bit position of the least significant bit in the
        IPdu. In AUTOSAR the bit counting is always set to "sawtooth"
        and the bit order is set to "Decreasing". The bit counting in
        byte 0 starts with bit 0 (least significant bit). The most
        significant bit in byte 0 is bit 7.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SEGMENT-POSITION"

    segment_byte_order: ByteOrderEnum | None = field(
        default=None,
        metadata={
            "name": "SEGMENT-BYTE-ORDER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    segment_length: Integer | None = field(
        default=None,
        metadata={
            "name": "SEGMENT-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    segment_position: Integer | None = field(
        default=None,
        metadata={
            "name": "SEGMENT-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SenderRecArrayElementMapping:
    """The SenderRecArrayElement may be a primitive one or a composite one.

    If the element is primitive, it will be mapped to the SystemSignal
    (multiplicity 1). If the VariableDataPrototype that is referenced by
    SenderReceiverToSignalGroupMapping is typed by an
    ApplicationDataType the reference to the ApplicationArrayElement
    shall be used. If the VariableDataPrototype is typed by the
    ImplementationDataType the reference to the
    ImplementationArrayElement shall be used. If the element is
    composite, there will be no mapping to the SystemSignal
    (multiplicity 0). In this case the ArrayElementMapping element will
    aggregate the TypeMapping element. In that way also the composite
    datatypes can be mapped to SystemSignals. Regardless whether
    composite or primitive array element is mapped the indexed element
    always needs to be specified.

    :ivar complex_type_mapping: This aggregation will be used if the
        element is composite.
    :ivar indexed_array_element: Reference to an indexed array element
        in the context of the dataElement or in the context of a
        composite element.
    :ivar system_signal_ref: Reference to the system signal used to
        carry the primitive ApplicationArrayElement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SENDER-REC-ARRAY-ELEMENT-MAPPING"

    complex_type_mapping: Optional["SenderRecArrayElementMapping.ComplexTypeMapping"] = field(
        default=None,
        metadata={
            "name": "COMPLEX-TYPE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    indexed_array_element: IndexedArrayElement | None = field(
        default=None,
        metadata={
            "name": "INDEXED-ARRAY-ELEMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_signal_ref: Optional["SenderRecArrayElementMapping.SystemSignalRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ComplexTypeMapping:
        sender_rec_array_type_mapping: Optional["SenderRecArrayTypeMapping"] = field(
            default=None,
            metadata={
                "name": "SENDER-REC-ARRAY-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sender_rec_record_type_mapping: Optional["SenderRecRecordTypeMapping"] = field(
            default=None,
            metadata={
                "name": "SENDER-REC-RECORD-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SingleLanguageLongName:
    """
    SingleLanguageLongName.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar content:
    """

    class Meta:
        name = "SINGLE-LANGUAGE-LONG-NAME"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "TT",
                    "type": Tt,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "E",
                    "type": EmphasisText,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUP",
                    "type": ForwardRef("SingleLanguageLongName.Sup"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUB",
                    "type": ForwardRef("SingleLanguageLongName.Sub"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "IE",
                    "type": IndexEntry,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Sup(Supscript):
        pass

    @dataclass(slots=True, kw_only=True)
    class Sub(Supscript):
        pass


@dataclass(slots=True, kw_only=True)
class SoConIPduIdentifier:
    """Identification of Pdu content on a socket connection.

    This Identifier is required in case that multiple Pdus are
    transmitted over the same socket connection.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar header_id: If multiple Pdus are transmitted over the same
        connection this headerId can be used to distinguish between the
        different Pdus. For the constraints on constructing the headerId
        for SOME/IP also see PRS_SOMEIP_00245.
    :ivar pdu_collection_pdu_timeout: Defines the timeout in seconds the
        PDU collection shall be transmitted at the latest after this PDU
        has been put into the buffer.
    :ivar pdu_collection_semantics: Specifies if the referenced
        PduTriggering shall be collected using a queued (i.e. all PDU
        instances) or last-is-best (i.e. only the last PDU instance)
        semantics. If this attribute is not present the behavior of
        "queued" is assumed.
    :ivar pdu_collection_trigger: Defines whether the referenced Pdu
        contributes to the triggering of the socket transmission if Pdu
        collection is enabled for this socket.
    :ivar pdu_triggering_ref: Reference to a Pdu that is transmitted
        over a socket connection.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SO-CON-I-PDU-IDENTIFIER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SoConIPduIdentifier.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    header_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "HEADER-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_collection_pdu_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PDU-COLLECTION-PDU-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_collection_semantics: PduCollectionSemanticsEnum | None = field(
        default=None,
        metadata={
            "name": "PDU-COLLECTION-SEMANTICS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_collection_trigger: PduCollectionTriggerEnum | None = field(
        default=None,
        metadata={
            "name": "PDU-COLLECTION-TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_triggering_ref: Optional["SoConIPduIdentifier.PduTriggeringRef"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduTriggeringRef(Ref):
        dest: PduTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SocketConnectionIpduIdentifier:
    """An Identifier is required in case of one port per ECU communication where
    multiple Pdus are transmitted over the same connection.

    If only one IPdu is transmitted over the connetion this attribute
    can be ignored.

    :ivar header_id: If multiple Pdus are transmitted over the same
        connection this headerId can be used to distinguish between the
        different Pdus.
    :ivar pdu_collection_pdu_timeout: Defines the timeout in seconds the
        PDU collection shall be transmitted at the latest after this PDU
        has been put into the buffer.
    :ivar pdu_collection_semantics: Specifies if the referenced
        PduTriggering shall be collected using a queued (i.e. all PDU
        instances) or last-is-best (i.e. only the last PDU instance)
        semantics. If this attribute is not present the behavior of
        "queued" is assumed.
    :ivar pdu_collection_trigger: Defines whether the referenced Pdu
        contributes to the triggering of the socket transmission if Pdu
        collection is enabled for this socket.
    :ivar pdu_ref: This reference is deprecated and will be removed in
        future. Old description: Reference to an IPdu that is mapped to
        a socket connection.
    :ivar pdu_triggering_ref: Reference to a Pdu that is mapped to a
        socket connection.
    :ivar routing_group_refs: Reference to RoutingGroups that can be
        enabled or disabled.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOCKET-CONNECTION-IPDU-IDENTIFIER"

    header_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "HEADER-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_collection_pdu_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PDU-COLLECTION-PDU-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_collection_semantics: PduCollectionSemanticsEnum | None = field(
        default=None,
        metadata={
            "name": "PDU-COLLECTION-SEMANTICS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_collection_trigger: PduCollectionTriggerEnum | None = field(
        default=None,
        metadata={
            "name": "PDU-COLLECTION-TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_ref: Optional["SocketConnectionIpduIdentifier.PduRef"] = field(
        default=None,
        metadata={
            "name": "PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_triggering_ref: Optional["SocketConnectionIpduIdentifier.PduTriggeringRef"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    routing_group_refs: Optional["SocketConnectionIpduIdentifier.RoutingGroupRefs"] = field(
        default=None,
        metadata={
            "name": "ROUTING-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PduRef(Ref):
        dest: PduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PduTriggeringRef(Ref):
        dest: PduTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RoutingGroupRefs:
        routing_group_ref: list[
            "SocketConnectionIpduIdentifier.RoutingGroupRefs.RoutingGroupRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "ROUTING-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RoutingGroupRef(Ref):
            dest: SoAdRoutingGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SoftwareClusterDependencyCompareCondition:
    """
    This meta-class represents the ability to specify a concrete dependency
    condition in the context of a SoftwareClusterDependencyFormula.

    :ivar compare_type: This attribute identifies the semantics of the
        compare operator.
    :ivar consider_build_number: If this attribute is set to true then
        the build number shall be taken into account for the comparison.
        Build numbers don't have to be consecutive but could be created
        by some kind of hashing algorithm. In such a case it might make
        sense to include the build number in a test for equality but it
        is probably not reasonable to apply e.g. a less-than comparison.
    :ivar software_cluster_ref: This reference identifies the
        SoftwareCluster to which the dependency/conflict applies.
    :ivar version: This attribute represents the value of a version
        against which the comparison shall be executed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-CLUSTER-DEPENDENCY-COMPARE-CONDITION"

    compare_type: SoftwareClusterDependencyOperatorEnum | None = field(
        default=None,
        metadata={
            "name": "COMPARE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consider_build_number: Boolean | None = field(
        default=None,
        metadata={
            "name": "CONSIDER-BUILD-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_cluster_ref: Optional[
        "SoftwareClusterDependencyCompareCondition.SoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: StrongRevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SoftwareClusterRef(Ref):
        dest: SoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SoftwareClusterDoipDiagnosticAddress:
    """
    This meta-class represents the ability to define a diagnostic address
    specifically for the DoIP case.

    :ivar address_semantics: This attribute clarifies whether the
        address value shall be interpreted as a physical or a functional
        address.
    :ivar diagnostic_address: This attribute represents the collection
        of diagnostic addresses the SoftwareCluster occupies.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-CLUSTER-DOIP-DIAGNOSTIC-ADDRESS"

    address_semantics: SoftwareClusterDiagnosticAddressSemanticsEnum | None = field(
        default=None,
        metadata={
            "name": "ADDRESS-SEMANTICS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_address: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SoftwareClusterSovdAddress:
    """
    This meta-class represents the ability to define a diagnostic address
    specifically for the SOVD case.

    :ivar address_semantics: This attribute clarifies whether the
        address value shall be interpreted as a physical or a functional
        address.
    :ivar component_qualifier: This attribute is used to specify the
        component qualifier for the usage in an SOVD query.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-CLUSTER-SOVD-ADDRESS"

    address_semantics: SoftwareClusterDiagnosticAddressSemanticsEnum | None = field(
        default=None,
        metadata={
            "name": "ADDRESS-SEMANTICS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_qualifier: String | None = field(
        default=None,
        metadata={
            "name": "COMPONENT-QUALIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SoftwarePackageStoring:
    """
    This meta-class provides the ability to specify whether and where the
    referenced SoftwarePackage is stored.

    :ivar storing: This attribute clarifies whether and where the
        referenced SoftwarePackage is stored.
    :ivar transfer_refs: This reference identifies the
        SoftwarePackage(s) to be transferred in the enclosing
        SoftwarePackageStep.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-PACKAGE-STORING"

    storing: SoftwarePackageStoringEnum | None = field(
        default=None,
        metadata={
            "name": "STORING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transfer_refs: Optional["SoftwarePackageStoring.TransferRefs"] = field(
        default=None,
        metadata={
            "name": "TRANSFER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TransferRefs:
        transfer_ref: list["SoftwarePackageStoring.TransferRefs.TransferRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRANSFER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TransferRef(Ref):
            dest: SoftwarePackageSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SomeipCollectionProps:
    """
    Collection of attributes that are configurable for an event that is provided by
    a ServiceInstance or for a method that is provided or requested by a
    ServiceInstance.

    :ivar udp_collection_buffer_timeout: Maximum time, an outgoing
        message (event, method call or method response) may be delayed,
        due to data collection.
    :ivar udp_collection_trigger: Defines whether the ServiceInterface
        element (event or method) contributes to the triggering of the
        udp data transmission if data collection is enabled.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-COLLECTION-PROPS"

    udp_collection_buffer_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "UDP-COLLECTION-BUFFER-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    udp_collection_trigger: UdpCollectionTriggerEnum | None = field(
        default=None,
        metadata={
            "name": "UDP-COLLECTION-TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SomeipRequiredEventGroup:
    """
    The meta-class represents the ability to configure ServiceInstance related
    communication settings on the required side for each EventGroup separately.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar event_group_ref: Reference to the SomeipEventGroup in the
        System Manifest for which the ServiceInstance related EventGroup
        settings are valid.
    :ivar sd_client_event_group_timing_config_ref: Client Timing
        configuration settings that are EventGroup specific.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-REQUIRED-EVENT-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipRequiredEventGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_ref: Optional["SomeipRequiredEventGroup.EventGroupRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sd_client_event_group_timing_config_ref: Optional[
        "SomeipRequiredEventGroup.SdClientEventGroupTimingConfigRef"
    ] = field(
        default=None,
        metadata={
            "name": "SD-CLIENT-EVENT-GROUP-TIMING-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventGroupRef(Ref):
        dest: SomeipEventGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SdClientEventGroupTimingConfigRef(Ref):
        dest: SomeipSdClientEventGroupTimingConfigSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwGenericAxisParam:
    """This meta-class describes a specific parameter of a generic axis.

    The name of the parameter is defined through a reference to a
    parameter type defined on a corresponding axis type. The value of
    the parameter is given here in case that it is not changeable during
    calibration. Example is shift / offset in a fixed axis.

    :ivar sw_generic_axis_param_type_ref: Parameter type defined on a
        corresponding axis type. References can only be made to axis
        parameters types which are defined within the referenced axis
        type.
    :ivar vf: This attribute represents the value of the generic axis
        parameter.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-GENERIC-AXIS-PARAM"

    sw_generic_axis_param_type_ref: Optional["SwGenericAxisParam.SwGenericAxisParamTypeRef"] = (
        field(
            default=None,
            metadata={
                "name": "SW-GENERIC-AXIS-PARAM-TYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    vf: list[NumericalValueVariationPoint] = field(
        default_factory=list,
        metadata={
            "name": "VF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SwGenericAxisParamTypeRef(Ref):
        dest: SwGenericAxisParamTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwTextProps:
    """
    This meta-class expresses particular properties applicable to strings in
    variables or calibration parameters.

    :ivar array_size_semantics: This attribute controls the semantics of
        the arraysize for the array representing the string in an
        ImplementationDataType. It is there to support a safe conversion
        between ApplicationDatatype and ImplementationDatatype, even for
        variable length strings as required e.g. for Support of SAE
        J1939.
    :ivar sw_max_text_size: Specifies the maximum text size in
        characters. Note the size in bytes depends on the encoding in
        the corresponding baseType.
    :ivar base_type_ref: This is the base type of one character in the
        string. In particular this baseType denotes the intended
        encoding of the characters in the string  on level of
        ApplicationDataType.
    :ivar sw_fill_character: Filler character for text parameter to pad
        up to the maximum length swMaxTextSize. The value will be
        interpreted according to the encoding specified in the
        associated base type of the data object, e.g. 0x30 (hex)
        represents the ASCII character zero as filler character and 0
        (dec) represents an end of string as filler character. The usage
        of the fill character depends on the arraySizeSemantics.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-TEXT-PROPS"

    array_size_semantics: ArraySizeSemanticsEnum | None = field(
        default=None,
        metadata={
            "name": "ARRAY-SIZE-SEMANTICS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_max_text_size: IntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "SW-MAX-TEXT-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    base_type_ref: Optional["SwTextProps.BaseTypeRef"] = field(
        default=None,
        metadata={
            "name": "BASE-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_fill_character: Integer | None = field(
        default=None,
        metadata={
            "name": "SW-FILL-CHARACTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BaseTypeRef(Ref):
        dest: SwBaseTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwcToSwcOperationArguments:
    """The SwcToSwcOperationArguments describes the information (client server
    operation arguments, plus the operation identification, if required) that are
    exchanged between two SW Components from exactly one client to one server, or
    from one server back to one client.

    The direction attribute defines which direction is described. If
    direction == IN, all arguments sent from the client to the server
    are described by the SwcToSwcOperationArguments, in direction ==
    OUT, it's the arguments sent back from server to client.

    :ivar direction: Direction addressed by this
        SwcToSwcClientServerOperation element.
    :ivar operation_irefs: Reference to the operation at the client and
        at the server side whose arguments are described by
        SwcToSwcOperationArguments. The two ports referenced shall be
        connected by a connector in the software component description.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-TO-SWC-OPERATION-ARGUMENTS"

    direction: SwcToSwcOperationArgumentsDirectionEnum | None = field(
        default=None,
        metadata={
            "name": "DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_irefs: Optional["SwcToSwcOperationArguments.OperationIrefs"] = field(
        default=None,
        metadata={
            "name": "OPERATION-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class OperationIrefs:
        operation_iref: list[OperationInSystemInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "OPERATION-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 2,
            },
        )


@dataclass(slots=True, kw_only=True)
class SwcToSwcSignal:
    """The SwcToSwcSignal describes the information (data element) that is
    exchanged between two SW Components.

    On the SWC Level it is possible that a SW Component sends one data
    element from one P-Port to two different SW Components (1:n
    Communication). The SwcToSwcSignal describes exactly the information
    which is exchanged between one P-Port of a SW Component and one
    R-Port of another SW Component.

    :ivar data_element_irefs: Reference to a data element on the
        PPortPrototype and to the same data element on the
        RPortPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-TO-SWC-SIGNAL"

    data_element_irefs: Optional["SwcToSwcSignal.DataElementIrefs"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataElementIrefs:
        data_element_iref: list[VariableDataPrototypeInSystemInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DATA-ELEMENT-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 2,
            },
        )


@dataclass(slots=True, kw_only=True)
class SymbolProps:
    """'''begin restrict to CP''' This meta-class represents the ability to attach
    with the symbol attribute a symbolic name that is conform to C language
    requirements to another meta-class, e.g. AtomicSwComponentType, that is a
    potential subject to a name clash on the level of RTE source code.

    '''end restrict to CP'''
    '''begin restrict to AP'''
    This meta-class represents the ability to contribute a part of a namespace.
    '''end restrict to AP'''
    '''begin restrict to FO'''
    If applied to Classic Platform:
    This meta-class represents the ability to attach with the symbol attribute a symbolic name that is conform to C language requirements to another meta-class, e.g. AtomicSwComponentType, that is a potential subject to a name clash on the level of RTE source code.
    If applied to Adaptive Platform:
    This meta-class represents the ability to contribute a part of a namespace.
    '''end restrict to FO'''

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar symbol: The symbol to be used as (depending on the concrete
        case) either a complete replacement or a prefix.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYMBOL-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SymbolProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SymbolicNameProps:
    """
    This meta-class can be taken to contribute to the creation of symbolic name
    values.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar symbol: The symbol to be used as (depending on the concrete
        case) either a complete replacement or a prefix.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYMBOLIC-NAME-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SymbolicNameProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TcpTp:
    """
    Content Model for TCP configuration.

    :ivar keep_alive_interval: Specifies the interval in seconds between
        subsequent keepalive probes.
    :ivar keep_alive_probes_max: Maximum number of times that TCP
        retransmits an individual data segment before aborting the
        connection.
    :ivar keep_alive_time: Specifies the time in seconds between the
        last data packet sent and the first keepalive probe.
    :ivar keep_alives: Indicates if Keep-Alive messages are sent.
    :ivar nagles_algorithm: Indicates if Nagle's Algorithm is used.
    :ivar receive_window_min: Minimum size of the TCP receive window in
        bytes.
    :ivar tcp_retransmission_timeout: Defines the timeout in seconds
        before an unacknowledged TCP segment is sent again. If the
        tcpRetransmissionTimeout is not defined or set to "INF", no TCP
        segments shall be re-transmitted.
    :ivar tcp_tp_port: TCP Port configuration.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TCP-TP"

    keep_alive_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "KEEP-ALIVE-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    keep_alive_probes_max: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "KEEP-ALIVE-PROBES-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    keep_alive_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "KEEP-ALIVE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    keep_alives: Boolean | None = field(
        default=None,
        metadata={
            "name": "KEEP-ALIVES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nagles_algorithm: Boolean | None = field(
        default=None,
        metadata={
            "name": "NAGLES-ALGORITHM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    receive_window_min: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "RECEIVE-WINDOW-MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_retransmission_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-RETRANSMISSION-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_tp_port: TpPort | None = field(
        default=None,
        metadata={
            "name": "TCP-TP-PORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TextTableValuePair:
    """
    Defines a pair of text values which are translated into each other.

    :ivar first_value: Value of first DataPrototype provided similar to
        a numerical ValueSpecification which is intended to be assigned
        to a Primitive data element. Note that the numerical value is a
        variant, it can be computed by a formula.
    :ivar second_value: Value of second DataPrototype provided similar
        to a numerical  ValueSpecification which is intended to be
        assigned to a Primitive data element. Note that the numerical
        value is a variant, it can be computed by a formula.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TEXT-TABLE-VALUE-PAIR"

    first_value: NumericalValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "FIRST-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    second_value: NumericalValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "SECOND-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TimeRangeType:
    """The timeRange can be specified with the value attribute.

    Optionally a tolerance can be defined.

    :ivar tolerance: Optional specification of a tolerance.
    :ivar value: Average value of a date (in seconds)
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIME-RANGE-TYPE"

    tolerance: Optional["TimeRangeType.Tolerance"] = field(
        default=None,
        metadata={
            "name": "TOLERANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: TimeValue | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Tolerance:
        absolute_tolerance: AbsoluteTolerance | None = field(
            default=None,
            metadata={
                "name": "ABSOLUTE-TOLERANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        relative_tolerance: RelativeTolerance | None = field(
            default=None,
            metadata={
                "name": "RELATIVE-TOLERANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TimeSyncClientConfiguration:
    """
    Defines the configuration of the time synchronisation client.

    :ivar ordered_master_list: Defines a list of ordered
        NetworkEndpoints.
    :ivar time_sync_technology: Defines the time synchronisation
        technology used.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIME-SYNC-CLIENT-CONFIGURATION"

    ordered_master_list: Optional["TimeSyncClientConfiguration.OrderedMasterList"] = field(
        default=None,
        metadata={
            "name": "ORDERED-MASTER-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_sync_technology: TimeSyncTechnologyEnum | None = field(
        default=None,
        metadata={
            "name": "TIME-SYNC-TECHNOLOGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class OrderedMasterList:
        ordered_master: list[OrderedMaster] = field(
            default_factory=list,
            metadata={
                "name": "ORDERED-MASTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TimeSyncServerConfiguration:
    """
    Defines the configuration of the time synchronisation server.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar priority: Server Priority.
    :ivar sync_interval: Synchronisation interval used by the time
        synchronisation server (in seconds).
    :ivar time_sync_server_identifier: Identifier of the TimeSyncServer.
    :ivar time_sync_technology: Defines the time synchronisation
        technology used. Possible values are: NTP_RFC958,
        PTP_IEEE1588_2002, PTP_IEEE1588_2008, AVB_IEEE802_1AS and
        others.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIME-SYNC-SERVER-CONFIGURATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TimeSyncServerConfiguration.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SYNC-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_sync_server_identifier: String | None = field(
        default=None,
        metadata={
            "name": "TIME-SYNC-SERVER-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_sync_technology: TimeSyncTechnologyEnum | None = field(
        default=None,
        metadata={
            "name": "TIME-SYNC-TECHNOLOGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TpConnectionIdent:
    """
    This meta-class is created to add the ability to become the target of a
    reference to the non-Referrable TpConnection.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TP-CONNECTION-IDENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TpConnectionIdent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TransmissionComSpecProps:
    """
    This meta-class defines a set of transmission attributes which the application
    software is assumed to implement.

    :ivar data_update_period: This attribute defines the period in which
        the application is assumed to transmit the respective data.
    :ivar minimum_send_interval: This attribute defines the minimum
        interval between two consecutive transmissions of the respective
        data the application is assumed to ensure.
    :ivar transmission_mode: The attribute defines the mode in which the
        application is assumed to transmit the respective data.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRANSMISSION-COM-SPEC-PROPS"

    data_update_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DATA-UPDATE-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_send_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-SEND-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_mode: TransmissionModeDefinitionEnum | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class UdpTp:
    """
    Content Model for UDP configuration.

    :ivar udp_tp_port: Udp Port configuration.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UDP-TP"

    udp_tp_port: TpPort | None = field(
        default=None,
        metadata={
            "name": "UDP-TP-PORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class UnresolvedReferenceRestrictionWithSeverity:
    """
    This restriction defines the severity level of unresolved references.

    :ivar severity: Severity level that is reported in case the
        restriction is violated.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UNRESOLVED-REFERENCE-RESTRICTION-WITH-SEVERITY"

    severity: SeverityEnum | None = field(
        default=None,
        metadata={
            "name": "SEVERITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ValueList:
    """
    This is a generic list of numerical values.

    :ivar vf: This is one entry in the list of numerical values
    :ivar v: This is a particular numerical value without variation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VALUE-LIST"

    vf: list[NumericalValueVariationPoint] = field(
        default_factory=list,
        metadata={
            "name": "VF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    v: list[NumericalValue] = field(
        default_factory=list,
        metadata={
            "name": "V",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ValueRestrictionWithSeverity:
    """Specifies valid values of primitive data types.

    A value is valid if all rules defined by this ValueRestriction
    evaluate to true.

    :ivar severity: Severity level that is reported in case the
        restriction is violated.
    :ivar max: Specifies the upper bounds for numeric values.
    :ivar max_length: Specifies the maximum number of characters of
        textual values.
    :ivar min: Specifies the lower bounds for numeric values.
    :ivar min_length: Specifies the minimal number of characters of
        textual values.
    :ivar pattern: Defines the exact sequence of characters that are
        acceptable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VALUE-RESTRICTION-WITH-SEVERITY"

    severity: SeverityEnum | None = field(
        default=None,
        metadata={
            "name": "SEVERITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max: LimitValue | None = field(
        default=None,
        metadata={
            "name": "MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min: LimitValue | None = field(
        default=None,
        metadata={
            "name": "MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pattern: RegularExpression | None = field(
        default=None,
        metadata={
            "name": "PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class VariationRestrictionWithSeverity:
    """
    Defines constraints on the usage of variation and on the valid binding times.

    :ivar severity: Severity level that is reported in case the
        restriction is violated.
    :ivar variation: Defines if the AUTOSAR model may define a
        VariationPoint at this location.
    :ivar valid_binding_times: List of valid binding times.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VARIATION-RESTRICTION-WITH-SEVERITY"

    severity: SeverityEnum | None = field(
        default=None,
        metadata={
            "name": "SEVERITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation: Boolean | None = field(
        default=None,
        metadata={
            "name": "VARIATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    valid_binding_times: Optional["VariationRestrictionWithSeverity.ValidBindingTimes"] = field(
        default=None,
        metadata={
            "name": "VALID-BINDING-TIMES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ValidBindingTimes:
        valid_binding_time: list[FullBindingTimeEnum] = field(
            default_factory=list,
            metadata={
                "name": "VALID-BINDING-TIME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class VehicleDriverNotification:
    """
    This meta-class provides the ability to configure a notification of the vehicle
    driver with respect to the update of vehicle software.

    :ivar approval_required: This attribute controls whether approval is
        required for the driver notification.
    :ivar notification_state: This attribute is used to configure the
        notification state.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VEHICLE-DRIVER-NOTIFICATION"

    approval_required: Boolean | None = field(
        default=None,
        metadata={
            "name": "APPROVAL-REQUIRED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    notification_state: VehicleDriverNotificationEnum | None = field(
        default=None,
        metadata={
            "name": "NOTIFICATION-STATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ClientServerArrayTypeMapping:
    """
    If the ApplicationCompositeDataType is an Array, the "ArrayTypeMapping" will be
    used.

    :ivar argument_ref: Reference to an argument in the context of the
        mappedOperation. Only ClientServerCompositeTypeMapping elements
        that are directly aggregated by the
        ClientServerToSignalGroupMapping shall contain this reference.
    :ivar array_element_mappings: Each ApplicationArrayElement must be
        mapped on a SystemSignal.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-ARRAY-TYPE-MAPPING"

    argument_ref: Optional["ClientServerArrayTypeMapping.ArgumentRef"] = field(
        default=None,
        metadata={
            "name": "ARGUMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    array_element_mappings: Optional["ClientServerArrayTypeMapping.ArrayElementMappings"] = field(
        default=None,
        metadata={
            "name": "ARRAY-ELEMENT-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ArgumentRef(Ref):
        dest: ArgumentDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ArrayElementMappings:
        client_server_array_element_mapping: list[ClientServerArrayElementMapping] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-ARRAY-ELEMENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CompuRationalCoeffs:
    """
    This meta-class represents the ability to express a rational function by
    specifying the coefficients of nominator and denominator.

    :ivar compu_numerator: This is the numerator of the rational
        expression.
    :ivar compu_denominator: This is the denominator of the expression.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPU-RATIONAL-COEFFS"

    compu_numerator: CompuNominatorDenominator | None = field(
        default=None,
        metadata={
            "name": "COMPU-NUMERATOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compu_denominator: CompuNominatorDenominator | None = field(
        default=None,
        metadata={
            "name": "COMPU-DENOMINATOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class CompuScaleConstantContents:
    """
    This meta-class represents the fact that a particular scale of the computation
    method is constant.

    :ivar compu_const: This represents the fact that the scale is a
        constant. The use case is mainly a non interpolated scale. It is
        a simplification of the fact that a constant scale can also be
        expressed as rational function of order 0.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPU-SCALE-CONSTANT-CONTENTS"

    compu_const: CompuConst | None = field(
        default=None,
        metadata={
            "name": "COMPU-CONST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataPrototypeTransformationProps:
    """
    DataPrototypeTransformationProps allows to set the attributes for the different
    TransformationTechnologies that are DataPrototype specific.

    :ivar data_protototype_in_port_interface_ref: Reference to a
        DataPrototype that is transported in the serialized ISignal.
    :ivar data_prototype_in_port_interface_ref: Reference to a
        DataPrototype that is transported in the serialized ISignal.
    :ivar data_prototype_ref: Reference to a DataPrototype that is
        transported in the serialized ISignal.
    :ivar network_representation_props: Specification of the actual
        network representation for the referenced primitive
        DataPrototype. If a network representation is provided then the
        baseType shall be used by the Transformer as input for the
        serialization/deserilaization.
    :ivar transformation_props_ref: Collection of AutosarDataPrototype
        related configuration settings for a transformer.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-PROTOTYPE-TRANSFORMATION-PROPS"

    data_protototype_in_port_interface_ref: Optional[
        "DataPrototypeTransformationProps.DataProtototypeInPortInterfaceRef"
    ] = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTOTYPE-IN-PORT-INTERFACE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototype_in_port_interface_ref: Optional[
        "DataPrototypeTransformationProps.DataPrototypeInPortInterfaceRef"
    ] = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-IN-PORT-INTERFACE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototype_ref: Optional["DataPrototypeTransformationProps.DataPrototypeRef"] = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_representation_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "NETWORK-REPRESENTATION-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformation_props_ref: Optional[
        "DataPrototypeTransformationProps.TransformationPropsRef"
    ] = field(
        default=None,
        metadata={
            "name": "TRANSFORMATION-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataProtototypeInPortInterfaceRef:
        data_prototype_in_port_interface_ref: DataPrototypeInPortInterfaceRef | None = field(
            default=None,
            metadata={
                "name": "DATA-PROTOTYPE-IN-PORT-INTERFACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        implementation_data_type_element_in_port_interface_ref: (
            ImplementationDataTypeElementInPortInterfaceRef | None
        ) = field(
            default=None,
            metadata={
                "name": "IMPLEMENTATION-DATA-TYPE-ELEMENT-IN-PORT-INTERFACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataPrototypeInPortInterfaceRef:
        data_prototype_in_port_interface_ref: DataPrototypeInPortInterfaceRef | None = field(
            default=None,
            metadata={
                "name": "DATA-PROTOTYPE-IN-PORT-INTERFACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        implementation_data_type_element_in_port_interface_ref: (
            ImplementationDataTypeElementInPortInterfaceRef | None
        ) = field(
            default=None,
            metadata={
                "name": "IMPLEMENTATION-DATA-TYPE-ELEMENT-IN-PORT-INTERFACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataPrototypeRef:
        data_prototype_with_application_data_type_in_system_ref: (
            DataPrototypeWithApplicationDataTypeInSystemRef | None
        ) = field(
            default=None,
            metadata={
                "name": "DATA-PROTOTYPE-WITH-APPLICATION-DATA-TYPE-IN-SYSTEM-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        implementation_data_type_element_in_system_ref: (
            ImplementationDataTypeElementInSystemRef | None
        ) = field(
            default=None,
            metadata={
                "name": "IMPLEMENTATION-DATA-TYPE-ELEMENT-IN-SYSTEM-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TransformationPropsRef(Ref):
        dest: TransformationPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DoIpTpConnection:
    """A connection identifies the sender and the receiver of this particular
    communication.

    The DoIp module routes a tpSdu through this connection.

    :ivar ident: This adds the ability to become referrable to
        TpConnection.
    :ivar do_ip_source_address_ref: Reference to the address of the
        sender of the tpSdu.
    :ivar do_ip_target_address_ref: Reference to the address of the
        receiver of the tpSdu.
    :ivar tp_sdu_ref: This reference is used to describe the data
        exchange between DoIp and the PduR.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-TP-CONNECTION"

    ident: TpConnectionIdent | None = field(
        default=None,
        metadata={
            "name": "IDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    do_ip_source_address_ref: Optional["DoIpTpConnection.DoIpSourceAddressRef"] = field(
        default=None,
        metadata={
            "name": "DO-IP-SOURCE-ADDRESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    do_ip_target_address_ref: Optional["DoIpTpConnection.DoIpTargetAddressRef"] = field(
        default=None,
        metadata={
            "name": "DO-IP-TARGET-ADDRESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_sdu_ref: Optional["DoIpTpConnection.TpSduRef"] = field(
        default=None,
        metadata={
            "name": "TP-SDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DoIpSourceAddressRef(Ref):
        dest: DoIpLogicAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DoIpTargetAddressRef(Ref):
        dest: DoIpLogicAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TpSduRef(Ref):
        dest: PduTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EthTpConnection:
    """
    A connection identifies which PduTriggerings shall be handled using the "TP"
    semantics.

    :ivar ident: This adds the ability to become referrable to
        TpConnection.
    :ivar tp_sdu_refs: Reference to a PduTriggering that shall be
        transported using the "TP" semantics.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETH-TP-CONNECTION"

    ident: TpConnectionIdent | None = field(
        default=None,
        metadata={
            "name": "IDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_sdu_refs: Optional["EthTpConnection.TpSduRefs"] = field(
        default=None,
        metadata={
            "name": "TP-SDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TpSduRefs:
        tp_sdu_ref: list["EthTpConnection.TpSduRefs.TpSduRef"] = field(
            default_factory=list,
            metadata={
                "name": "TP-SDU-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TpSduRef(Ref):
            dest: PduTriggeringSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class FlexrayAbsolutelyScheduledTiming:
    """Each frame in FlexRay is identified by its slot id and communication cycle.

    A description is provided by the usage of AbsolutelyScheduledTiming.
    In the static segment a frame can be sent multiple times within one
    communication cycle. For describing this case multiple
    AbsolutelyScheduledTimings have to be used. The main use case would
    be that a frame is sent twice within one communication cycle.

    :ivar communication_cycle: The communication cycle where the frame
        is sent.
    :ivar slot_id: In the static part the SlotID defines the slot in
        which the frame is transmitted. The SlotID also determines, in
        combination with FlexrayCluster::numberOfStaticSlots, whether
        the frame is sent in static or dynamic segment. In the dynamic
        part, the slot id is equivalent to a priority. Lower dynamic
        slot ids are all sent until the end of the dynamic segment.
        Higher numbers, which were ignored that time, have to wait one
        cycle and then shall try again. minValue: 1 maxValue: 2047
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-ABSOLUTELY-SCHEDULED-TIMING"

    communication_cycle: Optional["FlexrayAbsolutelyScheduledTiming.CommunicationCycle"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    slot_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SLOT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CommunicationCycle:
        cycle_counter: CycleCounter | None = field(
            default=None,
            metadata={
                "name": "CYCLE-COUNTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        cycle_repetition: CycleRepetition | None = field(
            default=None,
            metadata={
                "name": "CYCLE-REPETITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayArTpConnection:
    """A connection within a channel identifies the sender and the receiver of this
    particular communication.

    The FlexRay Autosar Tp module routes a Pdu through this connection.

    :ivar ident: This adds the ability to become referrable to
        TpConnection.
    :ivar connection_prio_pdus: This parameter defines the number of
        PDUs that shall be reserved for this connection when it is
        active. The range is 1-255.
    :ivar direct_tp_sdu_ref: Reference to the IPdu that is segmented by
        the Transport Protocol. The source address of the transmitted
        NPdu is determined by the configured source
        CommunicationConnector. The target address of the transmitted
        NPdu is determined by the configured target
        CommunicationConnector.
    :ivar flow_control_pdu_ref: Please note that this reference is
        deprecated and will be removed in future. The PDU pool
        referenced by the FlexRayArTpChannel as nPdu will be used
        instead.
    :ivar multicast_ref: TP address for 1:n connections.
    :ivar reversed_tp_sdu_ref: Reference to the IPdu that is segmented
        by the Transport Protocol. If support of both sending and
        receiving is used, this association references the IPdu used for
        the additional second direction. The source address of the
        transmitted NPdu is determined by the configured target
        CommunicationConnector. The target address of the transmitted
        NPdu is determined by the configured source
        CommunicationConnector.
    :ivar source_ref: The source of the TP connection.
    :ivar target_refs: The target of the TP connection.
    :ivar transmit_pdu_refs: Please note that this reference is
        deprecated and will be removed in future. The PDU pool
        referenced by the FlexRayArTpChannel as nPdu will be used
        instead.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-AR-TP-CONNECTION"

    ident: TpConnectionIdent | None = field(
        default=None,
        metadata={
            "name": "IDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    connection_prio_pdus: Integer | None = field(
        default=None,
        metadata={
            "name": "CONNECTION-PRIO-PDUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    direct_tp_sdu_ref: Optional["FlexrayArTpConnection.DirectTpSduRef"] = field(
        default=None,
        metadata={
            "name": "DIRECT-TP-SDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    flow_control_pdu_ref: Optional["FlexrayArTpConnection.FlowControlPduRef"] = field(
        default=None,
        metadata={
            "name": "FLOW-CONTROL-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multicast_ref: Optional["FlexrayArTpConnection.MulticastRef"] = field(
        default=None,
        metadata={
            "name": "MULTICAST-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reversed_tp_sdu_ref: Optional["FlexrayArTpConnection.ReversedTpSduRef"] = field(
        default=None,
        metadata={
            "name": "REVERSED-TP-SDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_ref: Optional["FlexrayArTpConnection.SourceRef"] = field(
        default=None,
        metadata={
            "name": "SOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_refs: Optional["FlexrayArTpConnection.TargetRefs"] = field(
        default=None,
        metadata={
            "name": "TARGET-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmit_pdu_refs: Optional["FlexrayArTpConnection.TransmitPduRefs"] = field(
        default=None,
        metadata={
            "name": "TRANSMIT-PDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DirectTpSduRef(Ref):
        dest: IPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FlowControlPduRef(Ref):
        dest: NPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MulticastRef(Ref):
        dest: TpAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ReversedTpSduRef(Ref):
        dest: IPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SourceRef(Ref):
        dest: FlexrayArTpNodeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRefs:
        target_ref: list["FlexrayArTpConnection.TargetRefs.TargetRef"] = field(
            default_factory=list,
            metadata={
                "name": "TARGET-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TargetRef(Ref):
            dest: FlexrayArTpNodeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TransmitPduRefs:
        transmit_pdu_ref: list["FlexrayArTpConnection.TransmitPduRefs.TransmitPduRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRANSMIT-PDU-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TransmitPduRef(Ref):
            dest: NPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class HttpTp:
    """
    Http over TCP as transport protocol.

    :ivar content_type: Descriptor for the transported content.
    :ivar protocol_version: HTTP Protocol version (e.g. 1.1)
    :ivar request_method: HTTP request method to be used.
    :ivar tcp_tp_config: TcpTp Configuration.
    :ivar uri: URI to be called.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HTTP-TP"

    content_type: String | None = field(
        default=None,
        metadata={
            "name": "CONTENT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_version: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_method: RequestMethodEnum | None = field(
        default=None,
        metadata={
            "name": "REQUEST-METHOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_tp_config: TcpTp | None = field(
        default=None,
        metadata={
            "name": "TCP-TP-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uri: UriString | None = field(
        default=None,
        metadata={
            "name": "URI",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class InvertCondition:
    """
    Inverts the nested condition.

    :ivar condition: The inverted condition
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INVERT-CONDITION"

    condition: Optional["InvertCondition.Condition"] = field(
        default=None,
        metadata={
            "name": "CONDITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Condition:
        aggregation_condition: AggregationCondition | None = field(
            default=None,
            metadata={
                "name": "AGGREGATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        invert_condition: Optional["InvertCondition"] = field(
            default=None,
            metadata={
                "name": "INVERT-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        primitive_attribute_condition: PrimitiveAttributeCondition | None = field(
            default=None,
            metadata={
                "name": "PRIMITIVE-ATTRIBUTE-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_condition: ReferenceCondition | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        textual_condition: TextualCondition | None = field(
            default=None,
            metadata={
                "name": "TEXTUAL-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LGraphic:
    """
    This meta-class represents the figure in one particular language.

    :ivar graphic: Reference to the actual graphic represented in the
        figure.
    :ivar map: Image maps enable authors to specify regions of an image
        or object and assign a specific action to each region.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar l: 'This attribute denotes the language in which the language
        specific document entity is given. Note that "FOR-ALL" means,
        that the entity is applicable to all languages. It is language
        neutral. It follows ISO 639-1:2002 and is specified in upper
        case.
    """

    class Meta:
        name = "L-GRAPHIC"

    graphic: Graphic | None = field(
        default=None,
        metadata={
            "name": "GRAPHIC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    map: Map | None = field(
        default=None,
        metadata={
            "name": "MAP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    l: LEnumSimple = field(
        metadata={
            "name": "L",
            "type": "Attribute",
            "required": True,
        }
    )


@dataclass(slots=True, kw_only=True)
class LinSlaveConfig:
    """Node attributes of LIN slaves that are handled by the LinMaster.

    In the System Description LIN slaves may be described in the context
    of the Lin Master. In an ECU Extract of the LinMaster the LinSlave
    Ecus shall not be available. The information that is described here
    is necessary in the ECU Extract for the configuration of the
    LinMaster. The values of attributes of LinSlaveConfig and the
    corresponding LinSlave shall be identical (if both are defined in a
    System Description).

    :ivar configured_nad: To distinguish LIN slaves that are used twice
        or more within the same cluster.
    :ivar function_id: LIN function ID.
    :ivar ident: This adds the ability to become referrable to
        LinSlaveConfig.
    :ivar initial_nad: Initial NAD of the LIN slave.
    :ivar lin_configurable_frames: List of all frames that are processed
        by the slave node
    :ivar lin_error_response: Each slave node shall publish one response
        error in one of its transmitted unconditional frames.
    :ivar lin_ordered_configurable_frames: List of all frames
        (unconditional frames, event-triggered frames and sporadic
        frames) processed by the slave node. This element is necessary
        for the LIN 2.1 Assign-Frame-PID-Range command.
    :ivar lin_slave_ecu_ref: Reference to the LinSlaveEcu.
    :ivar protocol_version: Version specifier for a communication
        protocol. Protocol version of the LinMaster and the LinSlaves
        may be different.
    :ivar supplier_id: LIN Supplier ID.
    :ivar variant_id: Specifies the Variant ID.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-SLAVE-CONFIG"

    configured_nad: Integer | None = field(
        default=None,
        metadata={
            "name": "CONFIGURED-NAD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    function_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FUNCTION-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ident: LinSlaveConfigIdent | None = field(
        default=None,
        metadata={
            "name": "IDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_nad: Integer | None = field(
        default=None,
        metadata={
            "name": "INITIAL-NAD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lin_configurable_frames: Optional["LinSlaveConfig.LinConfigurableFrames"] = field(
        default=None,
        metadata={
            "name": "LIN-CONFIGURABLE-FRAMES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lin_error_response: LinErrorResponse | None = field(
        default=None,
        metadata={
            "name": "LIN-ERROR-RESPONSE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lin_ordered_configurable_frames: Optional["LinSlaveConfig.LinOrderedConfigurableFrames"] = (
        field(
            default=None,
            metadata={
                "name": "LIN-ORDERED-CONFIGURABLE-FRAMES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    lin_slave_ecu_ref: Optional["LinSlaveConfig.LinSlaveEcuRef"] = field(
        default=None,
        metadata={
            "name": "LIN-SLAVE-ECU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_version: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    supplier_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SUPPLIER-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variant_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VARIANT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class LinConfigurableFrames:
        lin_configurable_frame: list[LinConfigurableFrame] = field(
            default_factory=list,
            metadata={
                "name": "LIN-CONFIGURABLE-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LinOrderedConfigurableFrames:
        lin_ordered_configurable_frame: list[LinOrderedConfigurableFrame] = field(
            default_factory=list,
            metadata={
                "name": "LIN-ORDERED-CONFIGURABLE-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LinSlaveEcuRef(Ref):
        dest: LinSlaveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class MacSecProps:
    """
    This meta-class allows to configure MACsec (Media access control security) and
    the MKA (MACsec Key Agreement) for the CouplingPort (PHY).

    :ivar auto_start: This attribute defines how the Port Access Entity
        (PAE) is started: True := Autostart False := Manual Start
    :ivar mac_sec_kay_config: Properties to configure the MKA instance
        (KaY) for a controlled CouplingPort (PaE).
    :ivar on_fail_permissive_mode: This attribute sets the behavior of
        the Port Access Entity in case MACsec does not succeed.
    :ivar on_fail_permissive_mode_timeout: Timeout in seconds to enable
        the controlled port in case onFailPermissiveMode is set to
        Timeout.
    :ivar sak_rekey_time_span: Time in seconds to trigger the rekey of
        an in use SAK (Static Secure Association key). If set to 0, the
        rekey will not be triggered after a time span.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAC-SEC-PROPS"

    auto_start: Boolean | None = field(
        default=None,
        metadata={
            "name": "AUTO-START",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mac_sec_kay_config: MacSecLocalKayProps | None = field(
        default=None,
        metadata={
            "name": "MAC-SEC-KAY-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    on_fail_permissive_mode: MacSecFailPermissiveModeEnum | None = field(
        default=None,
        metadata={
            "name": "ON-FAIL-PERMISSIVE-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    on_fail_permissive_mode_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "ON-FAIL-PERMISSIVE-MODE-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sak_rekey_time_span: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SAK-REKEY-TIME-SPAN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MultilanguageLongName:
    """This meta-class represents the ability to specify a long name which acts in
    the role of a headline.

    It is intended for human readers. Per language it should be around
    max 80 characters.

    :ivar l_4: This is the long name in one particular language.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MULTILANGUAGE-LONG-NAME"

    l_4: list[LLongName] = field(
        default_factory=list,
        metadata={
            "name": "L-4",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class QueuedSenderComSpec:
    """
    Communication attributes specific to distribution of  events (PPortPrototype,
    SenderReceiverInterface and dataElement carries an "event").

    :ivar composite_network_representations: This represents a
        CompositeNetworkRepresentation defined in the context of a
        SenderComSpec.
    :ivar data_element_ref: Data element these quality of service
        attributes apply to.
    :ivar data_update_period: This attribute describes the period in
        which the applications are assumed to transmit the respective
        data.
    :ivar handle_out_of_range: This attribute controls how out-of-range
        values shall be dealt with.
    :ivar network_representation: A networkRepresentation is used to
        define how the dataElement is mapped to a communication bus.
    :ivar sender_intent: This attribute represents the expressed intent
        of the sender. The sender may decide to claim that existing
        resources of a ServiceInterface are expressly not used by this
        specific sender. The conceptual background of this claim may be
        driven by security, safety, etc.
    :ivar transmission_acknowledge: Requested transmission
        acknowledgement for data element.
    :ivar transmission_props: This aggregation represents the definition
        transmission props in the context of the enclosing
        SenderComSpec.
    :ivar uses_end_to_end_protection: This indicates whether the
        corresponding dataElement shall be transmitted using end-to-end
        protection.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "QUEUED-SENDER-COM-SPEC"

    composite_network_representations: Optional[
        "QueuedSenderComSpec.CompositeNetworkRepresentations"
    ] = field(
        default=None,
        metadata={
            "name": "COMPOSITE-NETWORK-REPRESENTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["QueuedSenderComSpec.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_update_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DATA-UPDATE-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    handle_out_of_range: HandleOutOfRangeEnum | None = field(
        default=None,
        metadata={
            "name": "HANDLE-OUT-OF-RANGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_representation: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "NETWORK-REPRESENTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sender_intent: SenderIntentEnum | None = field(
        default=None,
        metadata={
            "name": "SENDER-INTENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_acknowledge: TransmissionAcknowledgementRequest | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-ACKNOWLEDGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_props: TransmissionComSpecProps | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uses_end_to_end_protection: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "USES-END-TO-END-PROTECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CompositeNetworkRepresentations:
        composite_network_representation: list[CompositeNetworkRepresentation] = field(
            default_factory=list,
            metadata={
                "name": "COMPOSITE-NETWORK-REPRESENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RtpTp:
    """
    RTP over UDP or over TCP as transport protocol.

    :ivar ssrc: Synchronization source identifier uniquely identifies
        the source of a stream. The synchronization sources within the
        same RTP session will be unique.
    :ivar tcp_udp_config: Tcp or Udp Configuration.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RTP-TP"

    ssrc: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SSRC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_udp_config: Optional["RtpTp.TcpUdpConfig"] = field(
        default=None,
        metadata={
            "name": "TCP-UDP-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TcpUdpConfig:
        tcp_tp: TcpTp | None = field(
            default=None,
            metadata={
                "name": "TCP-TP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        udp_tp: UdpTp | None = field(
            default=None,
            metadata={
                "name": "UDP-TP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SoftwareClusterDependencyFormula:
    """
    This meta-class represents the ability to define a dependency among
    SoftwareClusters.

    :ivar category: This attribute specializes the semantics of the
        enclosing SoftwareClusterDependencyFormula.
    :ivar operator: This logical operator can be used to relate the
        results of different SoftwareClusterDependencyParts.
    :ivar parts: This aggregation represents the ordered collection of
        the parts of the SoftwareClusterDependencyFormula.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-CLUSTER-DEPENDENCY-FORMULA"

    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operator: SoftwareClusterDependencyLogicalOperatorEnum | None = field(
        default=None,
        metadata={
            "name": "OPERATOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parts: Optional["SoftwareClusterDependencyFormula.Parts"] = field(
        default=None,
        metadata={
            "name": "PARTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Parts:
        software_cluster_dependency_compare_condition: list[
            SoftwareClusterDependencyCompareCondition
        ] = field(
            default_factory=list,
            metadata={
                "name": "SOFTWARE-CLUSTER-DEPENDENCY-COMPARE-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        software_cluster_dependency_formula: list["SoftwareClusterDependencyFormula"] = field(
            default_factory=list,
            metadata={
                "name": "SOFTWARE-CLUSTER-DEPENDENCY-FORMULA",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SomeipEventProps:
    """
    This meta-class allows to set configuration options for an event in the
    provided service instance.

    :ivar collection_props: Collection of timing attributes configurable
        for an event that is provided by a Service Instance.
    :ivar event_ref: Reference to the event for which the
        SomeipEventProps are applicable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-EVENT-PROPS"

    collection_props: SomeipCollectionProps | None = field(
        default=None,
        metadata={
            "name": "COLLECTION-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["SomeipEventProps.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: SomeipEventDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SomeipMethodProps:
    """
    This meta-class allows to set configuration options for a method in the service
    instance.

    :ivar collection_props: Collection of timing attributes configurable
        for a method that is provided or requested by a Service
        Instance.
    :ivar method_ref: Reference to the method for which the
        SomeipMethodProps are applicable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-METHOD-PROPS"

    collection_props: SomeipCollectionProps | None = field(
        default=None,
        metadata={
            "name": "COLLECTION-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_ref: Optional["SomeipMethodProps.MethodRef"] = field(
        default=None,
        metadata={
            "name": "METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class MethodRef(Ref):
        dest: SomeipMethodDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Std:
    """
    This represents a reference to external standards.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name_1: This specifies the long name of the object. The
        role is longName1 for compatibiilty to ASAM FSX
    :ivar subtitle: This represents the subtitle of the standard.
    :ivar state: This represents  version and state of a standard. Kept
        as a string.
    :ivar date: This element specifies the release date of the external
        standard if applicable.
    :ivar url: This represents the URL of the standard.
    :ivar position: This represents the reference to the relevant
        positions of a standard. Kept as a string.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STD"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Std.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name_1: SingleLanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    subtitle: String | None = field(
        default=None,
        metadata={
            "name": "SUBTITLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    state: String | None = field(
        default=None,
        metadata={
            "name": "STATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    date: Date | None = field(
        default=None,
        metadata={
            "name": "DATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    url: Url | None = field(
        default=None,
        metadata={
            "name": "URL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    position: String | None = field(
        default=None,
        metadata={
            "name": "POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwAxisGeneric:
    """This meta-class defines a generic axis.

    In a generic axis the axispoints points are calculated in the ECU.
    The ECU is equipped with a fixed calculation algorithm. Parameters
    for the algorithm can be stored in the data component of the ECU.
    Therefore these parameters are specified in the data declaration,
    not in the calibration data.

    :ivar sw_axis_type_ref: Associated axis calculation strategy.
    :ivar sw_number_of_axis_points: The number of base points to be
        calculated for this axis. This element exists to enable the
        number of axis points to be stored explicitly, although it could
        also be described as swGenericAxisParam. This attribute has been
        deprecated, note that the value of
        SwAxisIndividual.swMaxAxisPoints shall be taken instead. In case
        of a generated axis, the number of axis points to be  generated
        shall be taken from SwAxisIndividual.swMaxAxisPoints.
    :ivar sw_generic_axis_params: Specific parameter of a generic axis.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-AXIS-GENERIC"

    sw_axis_type_ref: Optional["SwAxisGeneric.SwAxisTypeRef"] = field(
        default=None,
        metadata={
            "name": "SW-AXIS-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_number_of_axis_points: IntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "SW-NUMBER-OF-AXIS-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_generic_axis_params: Optional["SwAxisGeneric.SwGenericAxisParams"] = field(
        default=None,
        metadata={
            "name": "SW-GENERIC-AXIS-PARAMS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SwAxisTypeRef(Ref):
        dest: SwAxisTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SwGenericAxisParams:
        sw_generic_axis_param: list[SwGenericAxisParam] = field(
            default_factory=list,
            metadata={
                "name": "SW-GENERIC-AXIS-PARAM",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwAxisGrouped:
    """
    An SwAxisGrouped is an axis which is shared between multiple calibration
    parameters.

    :ivar max_gradient: This attribute defines the maximum permissible
        gradient for an adjustable object (curve, map or cuboid) with
        respect to a specific axis. MaxGrad  =  maximum( absolute((Value
        i,k - Value i-1,k)/(Axis Point i - Axis Point i-1)) )
    :ivar monotony: This attribute specifies the monotony constraint for
        an adjustable object (curve, map or cuboid) with respect to a
        specific axis. This information can be used by MCD  system to
        verify whether the monotony constraint is fulfilled and to
        prevent from changes violating the constraint.
    :ivar shared_axis_type_ref: This is the datatype of the calibration
        parameter providing the shared axis.
    :ivar sw_axis_index: Describes which axis of the referenced
        calibration parameter provides the values for the group axis.
        The index satisfies the following convention: * 0 = value axis.
        in this case, the interpolation result of the referenced
        parameter is used as a base point index. * The index should only
        be specified if the parameter under swCalprm contains more than
        one axis. It is standard practice for the axis index of
        parameters with more than one axis, to be set to 1, if data has
        not been assigned to swAxisIndex.
    :ivar ar_parameter: This represents a Parameter within AUTOSAR. Note
        that the Datatype of the referenced ParameterDataPrototype shall
        be an ApplicationDataType of category VALUE.
    :ivar mc_data_instance_ref: This reference is used in the McSupport
        file to express the final instance of group axis etc. It is not
        allowed to use this outside of an McDataInstance. The referenced
        mcDataInstance shall be originated from a
        ParameterDataPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-AXIS-GROUPED"

    max_gradient: Float | None = field(
        default=None,
        metadata={
            "name": "MAX-GRADIENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    monotony: MonotonyEnum | None = field(
        default=None,
        metadata={
            "name": "MONOTONY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    shared_axis_type_ref: Optional["SwAxisGrouped.SharedAxisTypeRef"] = field(
        default=None,
        metadata={
            "name": "SHARED-AXIS-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_axis_index: AxisIndexType | None = field(
        default=None,
        metadata={
            "name": "SW-AXIS-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ar_parameter: AutosarParameterRef | None = field(
        default=None,
        metadata={
            "name": "AR-PARAMETER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_data_instance_ref: Optional["SwAxisGrouped.McDataInstanceRef"] = field(
        default=None,
        metadata={
            "name": "MC-DATA-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SharedAxisTypeRef(Ref):
        dest: ApplicationPrimitiveDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class McDataInstanceRef(Ref):
        dest: McDataInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwCalprmRefProxy:
    """
    Wrapper class for different kinds of references to a calibration parameter.

    :ivar ar_parameter: This represents a Parameter within AUTOSAR. Note
        that the Datatype of the referenced ParameterDataPrototype shall
        be an ApplicationDataType of category VALUE.
    :ivar mc_data_instance_ref: This reference is used in the McSupport
        file to express the final instance of group axis etc. It is not
        allowed to use this outside of an McDataInstance. The referenced
        mcDataInstance shall be originated from a
        ParameterDataPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-CALPRM-REF-PROXY"

    ar_parameter: AutosarParameterRef | None = field(
        default=None,
        metadata={
            "name": "AR-PARAMETER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_data_instance_ref: Optional["SwCalprmRefProxy.McDataInstanceRef"] = field(
        default=None,
        metadata={
            "name": "MC-DATA-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class McDataInstanceRef(Ref):
        dest: McDataInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwDataDependencyArgs:
    """
    This element specifies the elements used in a SwDataDependency.

    :ivar ar_parameter: This represents a Parameter within AUTOSAR. Note
        that the Datatype of the referenced ParameterDataPrototype shall
        be an ApplicationDataType of category VALUE.
    :ivar mc_data_instance_ref: This reference is used in the McSupport
        file to express the final instance of group axis etc. It is not
        allowed to use this outside of an McDataInstance. The referenced
        mcDataInstance shall be originated from a
        ParameterDataPrototype.
    :ivar autosar_variable: This represents the reference to a Variable
        in an Autosar system. Note that the target of the reference
        within AutosarVariableRef shall be typed by a  primitive data
        type
    :ivar mc_data_instance_var_ref: This reference is used in the
        McSupport file to express the final instance of input values
        etc. It is not allowed to use this outside of an McDataInstance.
        The referenced mcDataInstance shall be originated from a
        VariableDataPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-DATA-DEPENDENCY-ARGS"

    ar_parameter: list[AutosarParameterRef] = field(
        default_factory=list,
        metadata={
            "name": "AR-PARAMETER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "sequence": 1,
        },
    )
    mc_data_instance_ref: list["SwDataDependencyArgs.McDataInstanceRef"] = field(
        default_factory=list,
        metadata={
            "name": "MC-DATA-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "sequence": 1,
        },
    )
    autosar_variable: list[AutosarVariableRef] = field(
        default_factory=list,
        metadata={
            "name": "AUTOSAR-VARIABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "sequence": 2,
        },
    )
    mc_data_instance_var_ref: list["SwDataDependencyArgs.McDataInstanceVarRef"] = field(
        default_factory=list,
        metadata={
            "name": "MC-DATA-INSTANCE-VAR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "sequence": 2,
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class McDataInstanceRef(Ref):
        dest: McDataInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class McDataInstanceVarRef(Ref):
        dest: McDataInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwVariableRefProxy:
    """
    Proxy class for several kinds of references to a variable.

    :ivar autosar_variable: This represents the reference to a Variable
        in an Autosar system. Note that the target of the reference
        within AutosarVariableRef shall be typed by a  primitive data
        type
    :ivar mc_data_instance_var_ref: This reference is used in the
        McSupport file to express the final instance of input values
        etc. It is not allowed to use this outside of an McDataInstance.
        The referenced mcDataInstance shall be originated from a
        VariableDataPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-VARIABLE-REF-PROXY"

    autosar_variable: AutosarVariableRef | None = field(
        default=None,
        metadata={
            "name": "AUTOSAR-VARIABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_data_instance_var_ref: Optional["SwVariableRefProxy.McDataInstanceVarRef"] = field(
        default=None,
        metadata={
            "name": "MC-DATA-INSTANCE-VAR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class McDataInstanceVarRef(Ref):
        dest: McDataInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TargetIPduRef:
    """
    Target destination of the referencing mapping.

    :ivar default_value: If no I-Pdu has been received a default value
        will be distributed.
    :ivar target_i_pdu_ref: IPdu Reference
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TARGET-I-PDU-REF"

    default_value: PduMappingDefaultValue | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_i_pdu_ref: Optional["TargetIPduRef.TargetIPduRefInner"] = field(
        default=None,
        metadata={
            "name": "TARGET-I-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TargetIPduRefInner(Ref):
        dest: PduTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TextTableMapping:
    """
    Defines the mapping of two DataPrototypes typed by AutosarDataTypes that refer
    to CompuMethods of category TEXTTABLE, SCALE_LINEAR_AND_TEXTTABLE or
    BITFIELD_TEXTTABLE.

    :ivar bitfield_text_table_mask_first: This attribute can be used to
        support the mapping of bit field to bit field, boolean values to
        bit fields, and vice versa. The attribute defines the bit mask
        for the first element of the TextTableMapping.
    :ivar bitfield_text_table_mask_second: This attribute can be used to
        support the mapping of bit field to bit field, boolean values to
        bit fields, and vice versa. The attribute defines the bit mask
        for the second element of the TextTableMapping.
    :ivar identical_mapping: If identicalMapping is set == true the
        values of the two referenced DataPrototypes do not need any
        conversion of the values.
    :ivar mapping_direction: Specifies the conversion direction for
        which the TextTableMapping is applicable.
    :ivar value_pairs: Defines a pair of values which are translated
        into each other.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TEXT-TABLE-MAPPING"

    bitfield_text_table_mask_first: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "BITFIELD-TEXT-TABLE-MASK-FIRST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bitfield_text_table_mask_second: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "BITFIELD-TEXT-TABLE-MASK-SECOND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    identical_mapping: Boolean | None = field(
        default=None,
        metadata={
            "name": "IDENTICAL-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapping_direction: MappingDirectionEnum | None = field(
        default=None,
        metadata={
            "name": "MAPPING-DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_pairs: Optional["TextTableMapping.ValuePairs"] = field(
        default=None,
        metadata={
            "name": "VALUE-PAIRS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ValuePairs:
        text_table_value_pair: list[TextTableValuePair] = field(
            default_factory=list,
            metadata={
                "name": "TEXT-TABLE-VALUE-PAIR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TimeSynchronization:
    """
    Defines the servers / clients in a time synchronised network.

    :ivar time_sync_client: Configuration of the time synchronisation
        client.
    :ivar time_sync_server: Configuration of the time synchronisation
        server.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIME-SYNCHRONIZATION"

    time_sync_client: TimeSyncClientConfiguration | None = field(
        default=None,
        metadata={
            "name": "TIME-SYNC-CLIENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_sync_server: TimeSyncServerConfiguration | None = field(
        default=None,
        metadata={
            "name": "TIME-SYNC-SERVER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TransmissionModeCondition:
    """Possibility to attach a condition to each signal within an I-PDU.

    If at least one condition evaluates to true, TRANSMISSION MODE True
    shall be used for this I-Pdu. In all other cases, the TRANSMISSION
    MODE FALSE shall be used.

    :ivar data_filter: Possibilities to define conditions
    :ivar i_signal_in_i_pdu_ref: Reference to a signal to which a
        condition is attached.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRANSMISSION-MODE-CONDITION"

    data_filter: DataFilter | None = field(
        default=None,
        metadata={
            "name": "DATA-FILTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_in_i_pdu_ref: Optional["TransmissionModeCondition.ISignalInIPduRef"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-IN-I-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ISignalInIPduRef(Ref):
        dest: ISignalToIPduMappingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TtcanAbsolutelyScheduledTiming:
    """Each frame in TTCAN is identified by its slot id and communication cycle.

    A description is provided by the usage of AbsolutelyScheduledTiming.
    A frame can be sent multiple times within one communication cycle.
    For describing this case multiple AbsolutelyScheduledTimings have to
    be used. The main use case would be that a frame is sent twice
    within one communication cycle.

    :ivar communication_cycle: The communication cycle where the frame
        is sent.
    :ivar time_mark: Where FlexRay counts the slots in the static
        segment, TTCAN requires explicit Tx and Rx time marks.
    :ivar trigger: Trigger type for this time window.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TTCAN-ABSOLUTELY-SCHEDULED-TIMING"

    communication_cycle: Optional["TtcanAbsolutelyScheduledTiming.CommunicationCycle"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_mark: Integer | None = field(
        default=None,
        metadata={
            "name": "TIME-MARK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger: TtcanTriggerType | None = field(
        default=None,
        metadata={
            "name": "TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CommunicationCycle:
        cycle_counter: CycleCounter | None = field(
            default=None,
            metadata={
                "name": "CYCLE-COUNTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        cycle_repetition: CycleRepetition | None = field(
            default=None,
            metadata={
                "name": "CYCLE-REPETITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Xdoc:
    """
    This meta-class represents the ability to refer to an external document which
    can be rendered as printed matter.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name_1: This specifies the long name of the object. The
        role is longName1 for compatibiilty to ASAM FSX
    :ivar number: This represents document number of an external
        document that is referenced. Kept as a string.
    :ivar state: This represents version and state of the external
        document. Kept as a string.
    :ivar date: This element specifies the release date of the external
        document if applicable.
    :ivar publisher: This represents the publisher of an external
        document that is being referenced. Kept as a string.
    :ivar url: This specifies the URL of the external document.
    :ivar position: This represents the reference to the relevant
        positions of a standard. Kept as a string.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "XDOC"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Xdoc.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name_1: SingleLanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    number: String | None = field(
        default=None,
        metadata={
            "name": "NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    state: String | None = field(
        default=None,
        metadata={
            "name": "STATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    date: Date | None = field(
        default=None,
        metadata={
            "name": "DATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    publisher: String | None = field(
        default=None,
        metadata={
            "name": "PUBLISHER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    url: Url | None = field(
        default=None,
        metadata={
            "name": "URL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    position: String | None = field(
        default=None,
        metadata={
            "name": "POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Xfile:
    """
    This represents to reference an external file within a documentation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name_1: This specifies the long name of the object. The
        role is longName1 for compatibiilty to ASAM FSX
    :ivar url: This represents the URL of the external file.
    :ivar tool: This element describes the tool which was used to
        generate the corresponding Xfile . Kept as a string since no
        specific syntax can be provided to denote a tool.
    :ivar tool_version: This element describes the tool version which
        was used to generate the corresponding xfile. Kept as a string,
        since no specific syntax can be specified.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "XFILE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Xfile.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name_1: SingleLanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    url: Url | None = field(
        default=None,
        metadata={
            "name": "URL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tool: String | None = field(
        default=None,
        metadata={
            "name": "TOOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tool_version: String | None = field(
        default=None,
        metadata={
            "name": "TOOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Xref:
    """
    This represents a cross-reference within documentation.

    :ivar label_1: This allows to specify a replacement text which shall
        be rendered if showContent is selected.
    :ivar referrable_ref: This establishes the reference in Autosar
        style
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar resolution_policy: Indicates if the content of the xref
        element follow a dedicated resolution policy. The default is
        "NO-SLOPPY".
    :ivar show_content: Indicates if the content of the xref element
        shall be rendered. The default is "NO-SHOW-CONTENT".
    :ivar show_resource_alias_name: This indicates if the alias names of
        the referenced objects shall be rendered. This means this is
        some kind of backward searching: look whether there is an  alias
        for the referenced object, if yes, print it. If there is more
        than one AliasNameSet, Xref might render all of those. If no
        alias is found and showResourceShortName is set to
        NoShowShortName, then the shortName of the reference target
        shall be displayed. By this showResourceAliasName is similar to
        showResourceShortName but shows the aliasName instead of the
        shortName. Default is NO-SHOW-ALIAS-NAME.
    :ivar show_resource_category: Indicates if the category of the
        referenced resource shall be rendered. Default is "NO-SHOW-
        CATEGORY".
    :ivar show_resource_long_name: Indicates if the longName of the
        referenced resource shall be rendered. Default is "SHOW-LONG-
        NAME".
    :ivar show_resource_number: Indicates if the Number of the
        referenced resource shall be shown. Default is "SHOW--NUMBER"
    :ivar show_resource_page: Indicates if the page number of the
        referenced resource shall be shown. Default is "SHOW-PAGE"
    :ivar show_resource_short_name: Indicates if the shortJName of the
        referenced resource shall be shown. Default is "SHOW-SHORT-NAME"
    :ivar show_resource_type: Indicates if the type of the referenced
        Resource shall be shown. Default is "SHOW-TYPE"
    :ivar show_see: Indicates if the word "see " shall be shown before
        the reference. Default is "NO-SHOW-SEE". Note that this is there
        for compatibility reasons only.
    """

    class Meta:
        name = "XREF"

    label_1: SingleLanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    referrable_ref: Optional["Xref.ReferrableRef"] = field(
        default=None,
        metadata={
            "name": "REFERRABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    resolution_policy: ResolutionPolicyEnumSimple | None = field(
        default=None,
        metadata={
            "name": "RESOLUTION-POLICY",
            "type": "Attribute",
        },
    )
    show_content: ShowContentEnumSimple | None = field(
        default=None,
        metadata={
            "name": "SHOW-CONTENT",
            "type": "Attribute",
        },
    )
    show_resource_alias_name: ShowResourceAliasNameEnumSimple | None = field(
        default=None,
        metadata={
            "name": "SHOW-RESOURCE-ALIAS-NAME",
            "type": "Attribute",
        },
    )
    show_resource_category: ShowResourceCategoryEnumSimple | None = field(
        default=None,
        metadata={
            "name": "SHOW-RESOURCE-CATEGORY",
            "type": "Attribute",
        },
    )
    show_resource_long_name: ShowResourceLongNameEnumSimple | None = field(
        default=None,
        metadata={
            "name": "SHOW-RESOURCE-LONG-NAME",
            "type": "Attribute",
        },
    )
    show_resource_number: ShowResourceNumberEnumSimple | None = field(
        default=None,
        metadata={
            "name": "SHOW-RESOURCE-NUMBER",
            "type": "Attribute",
        },
    )
    show_resource_page: ShowResourcePageEnumSimple | None = field(
        default=None,
        metadata={
            "name": "SHOW-RESOURCE-PAGE",
            "type": "Attribute",
        },
    )
    show_resource_short_name: ShowResourceShortNameEnumSimple | None = field(
        default=None,
        metadata={
            "name": "SHOW-RESOURCE-SHORT-NAME",
            "type": "Attribute",
        },
    )
    show_resource_type: ShowResourceTypeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "SHOW-RESOURCE-TYPE",
            "type": "Attribute",
        },
    )
    show_see: ShowSeeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "SHOW-SEE",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ReferrableRef(Ref):
        dest: ReferrableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class XrefTarget:
    """
    This element specifies a reference target which can be scattered throughout the
    text.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name_1: This specifies the long name of the object. The
        role is longName1 for compatibiilty to ASAM FSX
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "XREF-TARGET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["XrefTarget.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name_1: SingleLanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Annotation:
    """
    This is a plain annotation which does not have further formal data.

    :ivar label: This is the headline for the annotation.
    :ivar annotation_origin: This attribute identifies the origin of the
        annotation. It is an arbitrary string since it can be an
        individual's name as well as the name of a tool or even the name
        of a process step.
    :ivar annotation_text: This is the text of the annotation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ANNOTATION"

    label: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_origin: String | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_text: Optional["DocumentationBlock"] = field(
        default=None,
        metadata={
            "name": "ANNOTATION-TEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ClientServerRecordElementMapping:
    """Mapping of a primitive record element to a SystemSignal.

    If the ArgumentDataPrototype that is referenced by
    ClientServerCompositeTypeMapping is typed by an ApplicationDataType
    the reference to the ApplicationRecordElement shall be used. If the
    VariableDataPrototype is typed by the ImplementationDataType the
    reference to the ImplementationRecordElement shall be used. If the
    element is composite, there will be no mapping (multiplicity 0). In
    this case the "RecordElementMapping" Element will aggregate the
    "TypeMapping" Element. In that way also the composite datatypes can
    be mapped to SystemSignals. Regardless whether composite or
    primitive record element is mapped the record element always needs
    to be specified.

    :ivar application_record_element_ref: Reference to a
        applicationRecordElement in the context of the mappedOperation
        or in the context of a composite element. This reference shall
        only be used if the ArgumentDataPrototype that is referenced by
        the ClientServerCompositeTypeMapping is typed by an
        ApplicationDataType.
    :ivar complex_type_mapping: This aggregation will be used if the
        element is  composite.
    :ivar implementation_record_element_ref: Reference to a
        ImplementationRecordElement in the context of the
        mappedOperation or in the context of a composite element. This
        reference shall only be used if the ArgumentDataPrototype that
        is referenced by the ClientServerCompositeTypeMapping is typed
        by an ImplementationDataType.
    :ivar system_signal_ref: Reference to the system signal used to
        carry the primitive ApplicationRecordElement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-RECORD-ELEMENT-MAPPING"

    application_record_element_ref: Optional[
        "ClientServerRecordElementMapping.ApplicationRecordElementRef"
    ] = field(
        default=None,
        metadata={
            "name": "APPLICATION-RECORD-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    complex_type_mapping: Optional["ClientServerRecordElementMapping.ComplexTypeMapping"] = field(
        default=None,
        metadata={
            "name": "COMPLEX-TYPE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_record_element_ref: Optional[
        "ClientServerRecordElementMapping.ImplementationRecordElementRef"
    ] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-RECORD-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_signal_ref: Optional["ClientServerRecordElementMapping.SystemSignalRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ApplicationRecordElementRef(Ref):
        dest: ApplicationRecordElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ComplexTypeMapping:
        client_server_array_type_mapping: ClientServerArrayTypeMapping | None = field(
            default=None,
            metadata={
                "name": "CLIENT-SERVER-ARRAY-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        client_server_record_type_mapping: Optional["ClientServerRecordTypeMapping"] = field(
            default=None,
            metadata={
                "name": "CLIENT-SERVER-RECORD-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationRecordElementRef(Ref):
        dest: ImplementationDataTypeElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CompuScaleRationalFormula:
    """
    This meta-class represents the fact that the computation in this scale is
    represented as rational term.

    :ivar compu_rational_coeffs: This specifies the coefficients of the
        rational formula.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPU-SCALE-RATIONAL-FORMULA"

    compu_rational_coeffs: CompuRationalCoeffs | None = field(
        default=None,
        metadata={
            "name": "COMPU-RATIONAL-COEFFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DefItem:
    """This represents an entry in a definition list.

    The defined item is specified using shortName and longName.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar def_value: This represents the definition part of the DefItem.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: DefList.defItem
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    :ivar help_entry: This specifies an entry point in an online help
        system to be linked with the parent class. The syntax shall be
        defined by the applied help system respectively help system
        generator.
    """

    class Meta:
        name = "DEF-ITEM"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DefItem.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_value: Optional["DocumentationBlock"] = field(
        default=None,
        metadata={
            "name": "DEF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: Optional["VariationPoint"] = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )
    help_entry: str | None = field(
        default=None,
        metadata={
            "name": "HELP-ENTRY",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LVerbatim:
    """MixedContentForVerbatim in one particular language.

    The language is denoted in the attribute l.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar l: 'This attribute denotes the language in which the language
        specific document entity is given. Note that "FOR-ALL" means,
        that the entity is applicable to all languages. It is language
        neutral. It follows ISO 639-1:2002 and is specified in upper
        case.
    :ivar space: This attribute is used to signal an intention that in
        that element, white space should be preserved by applications.
        It is defined according to xml:space as declared by W3C.
    :ivar content:
    """

    class Meta:
        name = "L-VERBATIM"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    l: LEnumSimple = field(
        metadata={
            "name": "L",
            "type": "Attribute",
            "required": True,
        }
    )
    space: str = field(
        metadata={
            "type": "Attribute",
            "namespace": "http://www.w3.org/XML/1998/namespace",
            "required": True,
        }
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "TT",
                    "type": Tt,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "E",
                    "type": EmphasisText,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "XREF",
                    "type": Xref,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "BR",
                    "type": Br,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )


@dataclass(slots=True, kw_only=True)
class SenderRecArrayTypeMapping:
    """
    If the ApplicationCompositeDataType is an Array, the "ArrayTypeMapping" will be
    used.

    :ivar array_element_mappings: Each ApplicationArrayElement shall be
        mapped on a SystemSignal.
    :ivar sender_to_signal_text_table_mapping: This mapping allows for
        the text-table translation between the sending DataPrototype
        that is defined in the PortPrototype and the physicalProps
        defined for the SystemSignal.
    :ivar signal_to_receiver_text_table_mapping: This mapping allows for
        the text-table translation between the physicalProps defined for
        the SystemSignal and a receiving DataPrototype that is defined
        in the PortPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SENDER-REC-ARRAY-TYPE-MAPPING"

    array_element_mappings: Optional["SenderRecArrayTypeMapping.ArrayElementMappings"] = field(
        default=None,
        metadata={
            "name": "ARRAY-ELEMENT-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sender_to_signal_text_table_mapping: TextTableMapping | None = field(
        default=None,
        metadata={
            "name": "SENDER-TO-SIGNAL-TEXT-TABLE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signal_to_receiver_text_table_mapping: TextTableMapping | None = field(
        default=None,
        metadata={
            "name": "SIGNAL-TO-RECEIVER-TEXT-TABLE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ArrayElementMappings:
        sender_rec_array_element_mapping: list[SenderRecArrayElementMapping] = field(
            default_factory=list,
            metadata={
                "name": "SENDER-REC-ARRAY-ELEMENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SlOverviewParagraph:
    """MixedContentForOverviewParagraph in one particular language.

    The language is defined by the context. The attribute l is there
    only for backwards compatibility and shall be ignored.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar l: The attribute l is there only for backwards compatibility
        and shall be ignored.
    :ivar content:
    """

    class Meta:
        name = "SL-OVERVIEW-PARAGRAPH"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    l: LEnumSimple | None = field(
        default=None,
        metadata={
            "name": "L",
            "type": "Attribute",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "BR",
                    "type": Br,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "FT",
                    "type": ForwardRef("SlOverviewParagraph"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "TRACE-REF",
                    "type": ForwardRef("SlOverviewParagraph.TraceRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "TT",
                    "type": Tt,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "XREF",
                    "type": Xref,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "XREF-TARGET",
                    "type": XrefTarget,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "E",
                    "type": EmphasisText,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUP",
                    "type": ForwardRef("SlOverviewParagraph.Sup"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUB",
                    "type": ForwardRef("SlOverviewParagraph.Sub"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "IE",
                    "type": IndexEntry,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TraceRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Sub(Supscript):
        pass

    @dataclass(slots=True, kw_only=True)
    class Sup(Supscript):
        pass


@dataclass(slots=True, kw_only=True)
class SlParagraph:
    """This is the text for a paragraph in one particular language.

    The language is defined by the context. The attribute l is there
    only for backwards compatibility and shall be ignored.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar l: The attribute l is there only for backwards compatibility
        and shall be ignored.
    :ivar content:
    """

    class Meta:
        name = "SL-PARAGRAPH"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    l: LEnumSimple | None = field(
        default=None,
        metadata={
            "name": "L",
            "type": "Attribute",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "FT",
                    "type": ForwardRef("SlParagraph"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "TRACE-REF",
                    "type": ForwardRef("SlParagraph.TraceRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "TT",
                    "type": Tt,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "BR",
                    "type": Br,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "XREF",
                    "type": Xref,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "XREF-TARGET",
                    "type": XrefTarget,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "E",
                    "type": EmphasisText,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUP",
                    "type": ForwardRef("SlParagraph.Sup"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUB",
                    "type": ForwardRef("SlParagraph.Sub"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "IE",
                    "type": IndexEntry,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "STD",
                    "type": Std,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "XDOC",
                    "type": Xdoc,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "XFILE",
                    "type": Xfile,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TraceRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Sub(Supscript):
        pass

    @dataclass(slots=True, kw_only=True)
    class Sup(Supscript):
        pass


@dataclass(slots=True, kw_only=True)
class SwAxisIndividual:
    """This meta-class describes an axis integrated into a parameter (field etc.).

    The integration makes this individual to each parameter. The so-
    called grouped axis represents the counterpart to this. It is
    conceived as an independent parameter (see class SwAxisGrouped).

    :ivar max_gradient: This attribute defines the maximum permissible
        gradient for an adjustable object (curve, map or cuboid) with
        respect to a specific axis. MaxGrad  =  maximum( absolute((Value
        i,k - Value i-1,k)/(Axis Point i - Axis Point i-1)) )
    :ivar monotony: This attribute specifies the monotony constraint for
        an adjustable object (curve, map or cuboid) with respect to a
        specific axis. This information can be used by MCD  system to
        verify whether the monotony constraint is fulfilled and to
        prevent from changes violating the constraint.
    :ivar input_variable_type_ref: This is the datatype of the input
        value for the axis. This allows to define e.g. a type of curve,
        where the input value is finalized at the access point.
    :ivar sw_variable_refs: Refers to input variables of the axis. It is
        possible to specify more than one variable. Here the following
        is valid: * The variable with the highest priority shall be
        given first. It is used in the generation of the code and is
        also displayed first in the application system. * All variables
        referenced shall be of the same physical nature. This is usually
        detected in that the conversion formulae affected refer back to
        the same SI-units. In AUTOSAR this ensured by the constraint,
        that the referenced input variables shall use a type compatible
        to "inputVariableType". * This multiple referencing allows a
        base point distribution for more than one input variable to be
        used. One example of this are the temperature curves which can
        depend both on the induction air temperature and the engine
        temperature. These variables can be displayed simultaneously by
        MCD systems (adjustment systems), enabling operating points to
        be shown in the curves.
    :ivar compu_method_ref: This is the compuMethod which is expected
        for the axis. It is used in early stages if the particular
        input-value is not yet available.
    :ivar unit_ref: This represents the physical unit of the input value
        of the axis. It is provided to support the case that the
        particular input variable is not yet known.
    :ivar sw_max_axis_points: Maximum number of base points contained in
        the axis of a map or curve.
    :ivar sw_min_axis_points: Minimum number of base points contained in
        the axis of a map or curve.
    :ivar data_constr_ref: Refers to constraints, e.g. for plausibility
        checks.
    :ivar sw_axis_generic: this specifies the properties of a generic
        axis if applicable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-AXIS-INDIVIDUAL"

    max_gradient: Float | None = field(
        default=None,
        metadata={
            "name": "MAX-GRADIENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    monotony: MonotonyEnum | None = field(
        default=None,
        metadata={
            "name": "MONOTONY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    input_variable_type_ref: Optional["SwAxisIndividual.InputVariableTypeRef"] = field(
        default=None,
        metadata={
            "name": "INPUT-VARIABLE-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_variable_refs: Optional["SwAxisIndividual.SwVariableRefs"] = field(
        default=None,
        metadata={
            "name": "SW-VARIABLE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compu_method_ref: Optional["SwAxisIndividual.CompuMethodRef"] = field(
        default=None,
        metadata={
            "name": "COMPU-METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_ref: Optional["SwAxisIndividual.UnitRef"] = field(
        default=None,
        metadata={
            "name": "UNIT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_max_axis_points: IntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "SW-MAX-AXIS-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_min_axis_points: IntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "SW-MIN-AXIS-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_constr_ref: Optional["SwAxisIndividual.DataConstrRef"] = field(
        default=None,
        metadata={
            "name": "DATA-CONSTR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_axis_generic: SwAxisGeneric | None = field(
        default=None,
        metadata={
            "name": "SW-AXIS-GENERIC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class InputVariableTypeRef(Ref):
        dest: ApplicationPrimitiveDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SwVariableRefs:
        """
        :ivar autosar_variable: This represents the reference to a
            Variable in an Autosar system. Note that the target of the
            reference within AutosarVariableRef shall be typed by a
            primitive data type
        :ivar mc_data_instance_var_ref: This reference is used in the
            McSupport file to express the final instance of input values
            etc. It is not allowed to use this outside of an
            McDataInstance. The referenced mcDataInstance shall be
            originated from a VariableDataPrototype.
        """

        autosar_variable: list[AutosarVariableRef] = field(
            default_factory=list,
            metadata={
                "name": "AUTOSAR-VARIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "sequence": 1,
            },
        )
        mc_data_instance_var_ref: list["SwAxisIndividual.SwVariableRefs.McDataInstanceVarRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "MC-DATA-INSTANCE-VAR-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                    "sequence": 1,
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class McDataInstanceVarRef(Ref):
            dest: McDataInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class CompuMethodRef(Ref):
        dest: CompuMethodSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class UnitRef(Ref):
        dest: UnitSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataConstrRef(Ref):
        dest: DataConstrSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwDataDependency:
    """This element describes the interdependencies of data objects, e.g. variables and parameters.
    Use cases:
    * Calculate the value of a calibration parameter (by the MCD system) from the value(s) of other calibration parameters.
    * Virtual data - that means the data object is not directly in the ecu and this property describes how the "virtual variable" can be computed from the real ones (by the MCD system).

    :ivar sw_data_dependency_formula: This element describes the formula
        with which the dependencies between the participating objects
        are defined.
    :ivar sw_data_dependency_args: Specifies the arguments used in the
        data dependency. Note that this is 0..1 since the aggregated
        class is a container (atpMixed).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-DATA-DEPENDENCY"

    sw_data_dependency_formula: CompuGenericMath | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEPENDENCY-FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_dependency_args: SwDataDependencyArgs | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEPENDENCY-ARGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ClientServerRecordTypeMapping:
    """
    If the ApplicationCompositeDataType is a Record, the "RecordTypeMapping" will
    be used.

    :ivar argument_ref: Reference to an argument in the context of the
        mappedOperation. Only ClientServerCompositeTypeMapping elements
        that are directly aggregated by the
        ClientServerToSignalGroupMapping shall contain this reference.
    :ivar record_element_mappings: Each ApplicationRecordElement must be
        mapped on a SystemSignal.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-RECORD-TYPE-MAPPING"

    argument_ref: Optional["ClientServerRecordTypeMapping.ArgumentRef"] = field(
        default=None,
        metadata={
            "name": "ARGUMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    record_element_mappings: Optional["ClientServerRecordTypeMapping.RecordElementMappings"] = (
        field(
            default=None,
            metadata={
                "name": "RECORD-ELEMENT-MAPPINGS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ArgumentRef(Ref):
        dest: ArgumentDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RecordElementMappings:
        client_server_record_element_mapping: list[ClientServerRecordElementMapping] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-RECORD-ELEMENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DefList:
    """This meta-class represents the ability to express a list of definitions.

    Note that a definition list might be rendered similar to a labeled
    list but has a particular semantics to denote definitions.

    :ivar def_item: This is one entry in the definition list.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DocumentationBlock.defList
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    """

    class Meta:
        name = "DEF-LIST"

    def_item: list[DefItem] = field(
        default_factory=list,
        metadata={
            "name": "DEF-ITEM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: Optional["VariationPoint"] = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class LOverviewParagraph:
    """MixedContentForOverviewParagraph in one particular language.

    The language is denoted in the attribute l.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar l: 'This attribute denotes the language in which the language
        specific document entity is given. Note that "FOR-ALL" means,
        that the entity is applicable to all languages. It is language
        neutral. It follows ISO 639-1:2002 and is specified in upper
        case.
    :ivar blueprint_value: This represents a description that documents
        how the value shall be defined when deriving objects from the
        blueprint.
    :ivar content:
    """

    class Meta:
        name = "L-OVERVIEW-PARAGRAPH"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    l: LEnumSimple = field(
        metadata={
            "name": "L",
            "type": "Attribute",
            "required": True,
        }
    )
    blueprint_value: str | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-VALUE",
            "type": "Attribute",
        },
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "BR",
                    "type": Br,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "FT",
                    "type": SlOverviewParagraph,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "TRACE-REF",
                    "type": ForwardRef("LOverviewParagraph.TraceRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "TT",
                    "type": Tt,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "XREF",
                    "type": Xref,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "XREF-TARGET",
                    "type": XrefTarget,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "E",
                    "type": EmphasisText,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUP",
                    "type": ForwardRef("LOverviewParagraph.Sup"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUB",
                    "type": ForwardRef("LOverviewParagraph.Sub"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "IE",
                    "type": IndexEntry,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TraceRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Sub(Supscript):
        pass

    @dataclass(slots=True, kw_only=True)
    class Sup(Supscript):
        pass


@dataclass(slots=True, kw_only=True)
class LParagraph:
    """This is the text for a paragraph in one particular language.

    The language is denoted in the attribute l.

    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar l: 'This attribute denotes the language in which the language
        specific document entity is given. Note that "FOR-ALL" means,
        that the entity is applicable to all languages. It is language
        neutral. It follows ISO 639-1:2002 and is specified in upper
        case.
    :ivar content:
    """

    class Meta:
        name = "L-PARAGRAPH"

    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    l: LEnumSimple = field(
        metadata={
            "name": "L",
            "type": "Attribute",
            "required": True,
        }
    )
    content: list[object] = field(
        default_factory=list,
        metadata={
            "type": "Wildcard",
            "namespace": "##any",
            "mixed": True,
            "choices": (
                {
                    "name": "FT",
                    "type": SlParagraph,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "TRACE-REF",
                    "type": ForwardRef("LParagraph.TraceRef"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "TT",
                    "type": Tt,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "BR",
                    "type": Br,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "XREF",
                    "type": Xref,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "XREF-TARGET",
                    "type": XrefTarget,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "E",
                    "type": EmphasisText,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUP",
                    "type": ForwardRef("LParagraph.Sup"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "SUB",
                    "type": ForwardRef("LParagraph.Sub"),
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "IE",
                    "type": IndexEntry,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "STD",
                    "type": Std,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "XDOC",
                    "type": Xdoc,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
                {
                    "name": "XFILE",
                    "type": Xfile,
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            ),
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TraceRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Sub(Supscript):
        pass

    @dataclass(slots=True, kw_only=True)
    class Sup(Supscript):
        pass


@dataclass(slots=True, kw_only=True)
class PostBuildVariantCriterionValue:
    """This class specifies the value which shall be assigned to a particular
    variant criterion in order to bind the variation point.

    If multiple criterion/value pairs are specified, they all shall
    match to bind the variation point.

    :ivar variant_criterion_ref: This association selects the variant
        criterion whose value is specified.
    :ivar value: This is the particular value of the post-build variant
        criterion.
    :ivar annotations: This provides the ability to add information why
        the value is set like it is.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "POST-BUILD-VARIANT-CRITERION-VALUE"

    variant_criterion_ref: Optional["PostBuildVariantCriterionValue.VariantCriterionRef"] = field(
        default=None,
        metadata={
            "name": "VARIANT-CRITERION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: IntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PostBuildVariantCriterionValue.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class VariantCriterionRef(Ref):
        dest: PostBuildVariantCriterionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SenderRecRecordElementMapping:
    """Mapping of a primitive record element to a SystemSignal.

    If the VariableDataPrototype that is referenced by
    SenderReceiverToSignalGroupMapping is typed by an
    ApplicationDataType the reference applicationRecordElement shall be
    used. If the VariableDataPrototype is typed by the
    ImplementationDataType the reference implementationRecordElement
    shall be used. Either the implementationRecordElement or
    applicationRecordElement reference shall be used. If the element is
    composite, there will be no mapping to the SystemSignal
    (multiplicity 0). In this case the RecordElementMapping element will
    aggregate the complexTypeMapping element. In that way also the
    composite datatypes can be mapped to SystemSignals.

    :ivar application_record_element_ref: Reference to an
        ApplicationRecordElement in the context of the dataElement or in
        the context of a composite element.
    :ivar complex_type_mapping: This aggregation will be used if the
        element is composite.
    :ivar implementation_record_element_ref: Reference to an
        ImplementationRecordElement in the context of the dataElement or
        in the context of a composite element.
    :ivar sender_to_signal_text_table_mapping: This mapping allows for
        the text-table translation between the sending DataPrototype
        that is defined in the PortPrototype and the physicalProps
        defined for the SystemSignal.
    :ivar signal_to_receiver_text_table_mapping: This mapping allows for
        the text-table translation between the physicalProps defined for
        the SystemSignal and a receiving DataPrototype that is defined
        in the PortPrototype.
    :ivar system_signal_ref: Reference to the system signal used to
        carry the primitive ApplicationRecordElement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SENDER-REC-RECORD-ELEMENT-MAPPING"

    application_record_element_ref: Optional[
        "SenderRecRecordElementMapping.ApplicationRecordElementRef"
    ] = field(
        default=None,
        metadata={
            "name": "APPLICATION-RECORD-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    complex_type_mapping: Optional["SenderRecRecordElementMapping.ComplexTypeMapping"] = field(
        default=None,
        metadata={
            "name": "COMPLEX-TYPE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_record_element_ref: Optional[
        "SenderRecRecordElementMapping.ImplementationRecordElementRef"
    ] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-RECORD-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sender_to_signal_text_table_mapping: TextTableMapping | None = field(
        default=None,
        metadata={
            "name": "SENDER-TO-SIGNAL-TEXT-TABLE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signal_to_receiver_text_table_mapping: TextTableMapping | None = field(
        default=None,
        metadata={
            "name": "SIGNAL-TO-RECEIVER-TEXT-TABLE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_signal_ref: Optional["SenderRecRecordElementMapping.SystemSignalRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ApplicationRecordElementRef(Ref):
        dest: ApplicationRecordElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ComplexTypeMapping:
        sender_rec_array_type_mapping: SenderRecArrayTypeMapping | None = field(
            default=None,
            metadata={
                "name": "SENDER-REC-ARRAY-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sender_rec_record_type_mapping: Optional["SenderRecRecordTypeMapping"] = field(
            default=None,
            metadata={
                "name": "SENDER-REC-RECORD-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationRecordElementRef(Ref):
        dest: ImplementationDataTypeElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwCalprmAxis:
    """
    This element specifies an individual input parameter axis (abscissa).

    :ivar sw_axis_index: This attribute specifies which axis is
        specified by the containing SwCalprmAxis. For example in a curve
        this is usually "1". In a map this is "1" or "2".
    :ivar category: This property specifies the category of a particular
        axis.
    :ivar sw_axis_grouped:
    :ivar sw_axis_individual:
    :ivar sw_calibration_access: Describes the applicability of
        parameters and variables.
    :ivar display_format: This property specifies how the axis values
        shall be displayed e.g. in documents or in measurement and
        calibration tools.
    :ivar base_type_ref: The SwBaseType to be used for the axis. Note
        that this is not applicable for ApplicationDataTypes. The value
        shall be ignored.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-CALPRM-AXIS"

    sw_axis_index: AxisIndexType | None = field(
        default=None,
        metadata={
            "name": "SW-AXIS-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CalprmAxisCategoryEnum | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_axis_grouped: SwAxisGrouped | None = field(
        default=None,
        metadata={
            "name": "SW-AXIS-GROUPED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_axis_individual: SwAxisIndividual | None = field(
        default=None,
        metadata={
            "name": "SW-AXIS-INDIVIDUAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_calibration_access: SwCalibrationAccessEnum | None = field(
        default=None,
        metadata={
            "name": "SW-CALIBRATION-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    display_format: DisplayFormatString | None = field(
        default=None,
        metadata={
            "name": "DISPLAY-FORMAT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    base_type_ref: Optional["SwCalprmAxis.BaseTypeRef"] = field(
        default=None,
        metadata={
            "name": "BASE-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BaseTypeRef(Ref):
        dest: SwBaseTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwSystemconstValue:
    """
    This meta-class assigns a particular value to a system constant.

    :ivar sw_systemconst_ref: This is the system constant to which the
        value applies.
    :ivar value: This is the particular value of a system constant. It
        is specified as Numerical. Further restrictions may apply by the
        definition of the system constant. The value attribute defines
        the internal value of the SwSystemconst as it is processed  in
        the Formula Language.
    :ivar annotations: This provides the ability to add information why
        the value is set like it is.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-SYSTEMCONST-VALUE"

    sw_systemconst_ref: Optional["SwSystemconstValue.SwSystemconstRef"] = field(
        default=None,
        metadata={
            "name": "SW-SYSTEMCONST-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: NumericalValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwSystemconstValue.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SwSystemconstRef(Ref):
        dest: SwSystemconstSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DocumentationBlock:
    """This class represents a documentation block.

    It is made of basic text structure elements which can be displayed
    in a table cell.

    :ivar msr_query_p_2: This represents automatically contributed
        contents provided by an msrquery in the context of
        DocumentationBlock.
    :ivar p: This is one particular paragraph. The upper multiplicity of
        this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar verbatim: This represents one particular verbatim text. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar list_value: This represents numbered or unnumbered list. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar def_list: This represents a definition list in the
        documentation block. The upper multiplicity of this role has
        been increased to * due to resolving an atpVariation stereotype.
        The previous value was 1.
    :ivar labeled_list: This represents a labeled list. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar formula: This is a formula in the definition block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar figure: This represents a figure in the documentation block.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar note: This represents a note in the text flow. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar trace: This represents traceable text in the documentation
        block. This allows to specify requirements/constraints in any
        documentation block. The kind of the trace is specified in the
        category. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar structured_req: This aggregation supports structured
        requirements embedded in a documentation block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DOCUMENTATION-BLOCK"

    msr_query_p_2: list["MsrQueryP2"] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p: list["MultiLanguageParagraph"] = field(
        default_factory=list,
        metadata={
            "name": "P",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: list["MultiLanguageVerbatim"] = field(
        default_factory=list,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    list_value: list["ListType"] = field(
        default_factory=list,
        metadata={
            "name": "LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_list: list[DefList] = field(
        default_factory=list,
        metadata={
            "name": "DEF-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    labeled_list: list["LabeledList"] = field(
        default_factory=list,
        metadata={
            "name": "LABELED-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: list["MlFormula"] = field(
        default_factory=list,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    figure: list["MlFigure"] = field(
        default_factory=list,
        metadata={
            "name": "FIGURE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    note: list["Note"] = field(
        default_factory=list,
        metadata={
            "name": "NOTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace: list["TraceableText"] = field(
        default_factory=list,
        metadata={
            "name": "TRACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    structured_req: list["StructuredReq"] = field(
        default_factory=list,
        metadata={
            "name": "STRUCTURED-REQ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class IndentSample:
    """This represents the ability to specify indentation of a labeled list by
    providing a sample content.

    This content can be measured by the rendering system in order to
    determine the width of indentation.

    :ivar l_2: This represents the indent sample in one particular
        language.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar item_label_pos: The position of the label in case the label is
        too long. The default is  "NO-NEWLINE"
    """

    class Meta:
        name = "INDENT-SAMPLE"

    l_2: list[LOverviewParagraph] = field(
        default_factory=list,
        metadata={
            "name": "L-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    item_label_pos: ItemLabelPosEnumSimple | None = field(
        default=None,
        metadata={
            "name": "ITEM-LABEL-POS",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class MultiLanguageOverviewParagraph:
    """
    This is the content of a multilingual paragraph in an overview item.

    :ivar l_2: This represents the text in one particular language.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MULTI-LANGUAGE-OVERVIEW-PARAGRAPH"

    l_2: list[LOverviewParagraph] = field(
        default_factory=list,
        metadata={
            "name": "L-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SenderRecRecordTypeMapping:
    """
    If the ApplicationCompositeDataType is a Record, the "RecordTypeMapping" will
    be used.

    :ivar record_element_mappings: Each ApplicationRecordElement shall
        be mapped on a SystemSignal.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SENDER-REC-RECORD-TYPE-MAPPING"

    record_element_mappings: Optional["SenderRecRecordTypeMapping.RecordElementMappings"] = field(
        default=None,
        metadata={
            "name": "RECORD-ELEMENT-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class RecordElementMappings:
        sender_rec_record_element_mapping: list[SenderRecRecordElementMapping] = field(
            default_factory=list,
            metadata={
                "name": "SENDER-REC-RECORD-ELEMENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwCalprmAxisSet:
    """
    This element specifies the input parameter axes (abscissas) of parameters (and
    variables, if these are used adaptively).

    :ivar sw_calprm_axis: One axis belonging to this SwCalprmAxisSet
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-CALPRM-AXIS-SET"

    sw_calprm_axis: list[SwCalprmAxis] = field(
        default_factory=list,
        metadata={
            "name": "SW-CALPRM-AXIS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ApplicationEntry:
    """
    Schedule table entry for application messages.

    :ivar introduction: This represents introductory documentation about
        the schedule table entry.
    :ivar delay: Relative delay between this tableEntry and the start of
        the successor in the schedule table in seconds.
    :ivar position_in_table: Relative position in the schedule table.
        The first entry index in the schedule table is 0.
    :ivar frame_triggering_ref: Specifies the LinFrame that will be
        transmitted in this frame slot.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-ENTRY"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    position_in_table: Integer | None = field(
        default=None,
        metadata={
            "name": "POSITION-IN-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_triggering_ref: Optional["ApplicationEntry.FrameTriggeringRef"] = field(
        default=None,
        metadata={
            "name": "FRAME-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FrameTriggeringRef(Ref):
        dest: LinFrameTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AssignFrameId:
    """
    Schedule entry for an  Assign Frame Id master request.

    :ivar introduction: This represents introductory documentation about
        the schedule table entry.
    :ivar delay: Relative delay between this tableEntry and the start of
        the successor in the schedule table in seconds.
    :ivar position_in_table: Relative position in the schedule table.
        The first entry index in the schedule table is 0.
    :ivar assigned_controller_ref: The LIN slaves controller who is
        target of this assignment. Optional in case
        LinConfigurationEntry.assignedLinSlaveConfig exists.
    :ivar assigned_lin_slave_config_ref: The LIN slave that is target of
        this assignment. Please note that this reference is redundant to
        the assignedController reference. In an Ecu Extract of the
        LinMaster the LinSlave Ecus shall not be available. The
        information that is described here is necessary in the ECU
        Extract for the configuration of the LinMaster.
    :ivar assigned_frame_triggering_ref: The frame whose identifier is
        set by this assignment.
    :ivar message_id: MessageId of the referenced frame.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ASSIGN-FRAME-ID"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    position_in_table: Integer | None = field(
        default=None,
        metadata={
            "name": "POSITION-IN-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_controller_ref: Optional["AssignFrameId.AssignedControllerRef"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_lin_slave_config_ref: Optional["AssignFrameId.AssignedLinSlaveConfigRef"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-LIN-SLAVE-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_frame_triggering_ref: Optional["AssignFrameId.AssignedFrameTriggeringRef"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-FRAME-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    message_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MESSAGE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AssignedControllerRef(Ref):
        dest: LinSlaveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AssignedLinSlaveConfigRef(Ref):
        dest: LinSlaveConfigIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AssignedFrameTriggeringRef(Ref):
        dest: LinFrameTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AssignFrameIdRange:
    """
    AssignFrameIdRange generates an assign frame PID range request.

    :ivar introduction: This represents introductory documentation about
        the schedule table entry.
    :ivar delay: Relative delay between this tableEntry and the start of
        the successor in the schedule table in seconds.
    :ivar position_in_table: Relative position in the schedule table.
        The first entry index in the schedule table is 0.
    :ivar assigned_controller_ref: The LIN slaves controller who is
        target of this assignment. Optional in case
        LinConfigurationEntry.assignedLinSlaveConfig exists.
    :ivar assigned_lin_slave_config_ref: The LIN slave that is target of
        this assignment. Please note that this reference is redundant to
        the assignedController reference. In an Ecu Extract of the
        LinMaster the LinSlave Ecus shall not be available. The
        information that is described here is necessary in the ECU
        Extract for the configuration of the LinMaster.
    :ivar frame_pids: Optional assignment of frame_PID values that are
        included in the request. The frame_PIDs are ordered.
    :ivar start_index: The startIndex sets the index to the first frame
        to assign a PID.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ASSIGN-FRAME-ID-RANGE"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    position_in_table: Integer | None = field(
        default=None,
        metadata={
            "name": "POSITION-IN-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_controller_ref: Optional["AssignFrameIdRange.AssignedControllerRef"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_lin_slave_config_ref: Optional["AssignFrameIdRange.AssignedLinSlaveConfigRef"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-LIN-SLAVE-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_pids: Optional["AssignFrameIdRange.FramePids"] = field(
        default=None,
        metadata={
            "name": "FRAME-PIDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_index: Integer | None = field(
        default=None,
        metadata={
            "name": "START-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AssignedControllerRef(Ref):
        dest: LinSlaveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AssignedLinSlaveConfigRef(Ref):
        dest: LinSlaveConfigIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FramePids:
        frame_pid: list[FramePid] = field(
            default_factory=list,
            metadata={
                "name": "FRAME-PID",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 4,
            },
        )


@dataclass(slots=True, kw_only=True)
class AssignNad:
    """
    Schedule entry for an Assign NAD master request.

    :ivar introduction: This represents introductory documentation about
        the schedule table entry.
    :ivar delay: Relative delay between this tableEntry and the start of
        the successor in the schedule table in seconds.
    :ivar position_in_table: Relative position in the schedule table.
        The first entry index in the schedule table is 0.
    :ivar assigned_controller_ref: The LIN slaves controller who is
        target of this assignment. Optional in case
        LinConfigurationEntry.assignedLinSlaveConfig exists.
    :ivar assigned_lin_slave_config_ref: The LIN slave that is target of
        this assignment. Please note that this reference is redundant to
        the assignedController reference. In an Ecu Extract of the
        LinMaster the LinSlave Ecus shall not be available. The
        information that is described here is necessary in the ECU
        Extract for the configuration of the LinMaster.
    :ivar new_nad: The newly assigned NAD value.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ASSIGN-NAD"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    position_in_table: Integer | None = field(
        default=None,
        metadata={
            "name": "POSITION-IN-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_controller_ref: Optional["AssignNad.AssignedControllerRef"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_lin_slave_config_ref: Optional["AssignNad.AssignedLinSlaveConfigRef"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-LIN-SLAVE-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    new_nad: Integer | None = field(
        default=None,
        metadata={
            "name": "NEW-NAD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AssignedControllerRef(Ref):
        dest: LinSlaveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AssignedLinSlaveConfigRef(Ref):
        dest: LinSlaveConfigIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BlueprintPolicyList:
    """The class represents that the related attribute is modifiable during the
    blueprinting.

    It applies only to attribute with upper multiplicity greater than 1.

    :ivar attribute_name: This identifies the related attribute of a
        BlueprintPolicy. For navigation over the model a subset of xpath
        expressions is used.
    :ivar blueprint_derivation_guide: This role offers the possibility
        to give additional information to the policy.
    :ivar max_number_of_elements: Maximum number of elements in list. If
        the maximum number is not constraint it shall be set to
        "undefined".
    :ivar min_number_of_elements: Minimum number of elements in the
        list. If the minimum number is not constraint it shall be set to
        "undefined".
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BLUEPRINT-POLICY-LIST"

    attribute_name: String | None = field(
        default=None,
        metadata={
            "name": "ATTRIBUTE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_derivation_guide: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-DERIVATION-GUIDE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_elements: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_number_of_elements: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "MIN-NUMBER-OF-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BlueprintPolicySingle:
    """The class represents that the related attribute is modifiable during the
    blueprinting.

    It applies only to attribute with upper multiplicity equal 1.

    :ivar attribute_name: This identifies the related attribute of a
        BlueprintPolicy. For navigation over the model a subset of xpath
        expressions is used.
    :ivar blueprint_derivation_guide: This role offers the possibility
        to give additional information to the policy.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BLUEPRINT-POLICY-SINGLE"

    attribute_name: String | None = field(
        default=None,
        metadata={
            "name": "ATTRIBUTE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_derivation_guide: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-DERIVATION-GUIDE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Caption:
    """
    This meta-class represents the ability to express a caption which is a title,
    and a shortName.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! This property helps a human reader to identify the
        object in question.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAPTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Caption.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ClientServerAnnotation:
    """
    Annotation to a port regarding a certain Operation.

    :ivar label: This is the headline for the annotation.
    :ivar annotation_origin: This attribute identifies the origin of the
        annotation. It is an arbitrary string since it can be an
        individual's name as well as the name of a tool or even the name
        of a process step.
    :ivar annotation_text: This is the text of the annotation.
    :ivar operation_ref: This represents the ClientServerOperation that
        the ClientServerAnnotation corresponds to.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-ANNOTATION"

    label: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_origin: String | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_text: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-TEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_ref: Optional["ClientServerAnnotation.OperationRef"] = field(
        default=None,
        metadata={
            "name": "OPERATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class OperationRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ConditionalChangeNad:
    """Generates an conditional change NAD request.

    See ISO 17987 protocol specification for more information.

    :ivar introduction: This represents introductory documentation about
        the schedule table entry.
    :ivar delay: Relative delay between this tableEntry and the start of
        the successor in the schedule table in seconds.
    :ivar position_in_table: Relative position in the schedule table.
        The first entry index in the schedule table is 0.
    :ivar assigned_controller_ref: The LIN slaves controller who is
        target of this assignment. Optional in case
        LinConfigurationEntry.assignedLinSlaveConfig exists.
    :ivar assigned_lin_slave_config_ref: The LIN slave that is target of
        this assignment. Please note that this reference is redundant to
        the assignedController reference. In an Ecu Extract of the
        LinMaster the LinSlave Ecus shall not be available. The
        information that is described here is necessary in the ECU
        Extract for the configuration of the LinMaster.
    :ivar byte: Byte Position of Data Byte that should be used for the
        bitwise XOR with Invert and the bitwise AND with Mask.
    :ivar id: Byte Position of Id.
    :ivar invert: Byte Position of Invert.
    :ivar mask: Byte Position of Mask.
    :ivar new_nad: The newly assigned NAD value (Byte Position).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONDITIONAL-CHANGE-NAD"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    position_in_table: Integer | None = field(
        default=None,
        metadata={
            "name": "POSITION-IN-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_controller_ref: Optional["ConditionalChangeNad.AssignedControllerRef"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_lin_slave_config_ref: Optional["ConditionalChangeNad.AssignedLinSlaveConfigRef"] = (
        field(
            default=None,
            metadata={
                "name": "ASSIGNED-LIN-SLAVE-CONFIG-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    byte: Integer | None = field(
        default=None,
        metadata={
            "name": "BYTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    invert: Integer | None = field(
        default=None,
        metadata={
            "name": "INVERT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mask: Integer | None = field(
        default=None,
        metadata={
            "name": "MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    new_nad: Integer | None = field(
        default=None,
        metadata={
            "name": "NEW-NAD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AssignedControllerRef(Ref):
        dest: LinSlaveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AssignedLinSlaveConfigRef(Ref):
        dest: LinSlaveConfigIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DataDumpEntry:
    """
    This service is reserved for initial configuration of a slave node by the slave
    node supplier and the format of this message is supplier specific.

    :ivar introduction: This represents introductory documentation about
        the schedule table entry.
    :ivar delay: Relative delay between this tableEntry and the start of
        the successor in the schedule table in seconds.
    :ivar position_in_table: Relative position in the schedule table.
        The first entry index in the schedule table is 0.
    :ivar assigned_controller_ref: The LIN slaves controller who is
        target of this assignment. Optional in case
        LinConfigurationEntry.assignedLinSlaveConfig exists.
    :ivar assigned_lin_slave_config_ref: The LIN slave that is target of
        this assignment. Please note that this reference is redundant to
        the assignedController reference. In an Ecu Extract of the
        LinMaster the LinSlave Ecus shall not be available. The
        information that is described here is necessary in the ECU
        Extract for the configuration of the LinMaster.
    :ivar byte_values: Supplier specific format.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-DUMP-ENTRY"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    position_in_table: Integer | None = field(
        default=None,
        metadata={
            "name": "POSITION-IN-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_controller_ref: Optional["DataDumpEntry.AssignedControllerRef"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_lin_slave_config_ref: Optional["DataDumpEntry.AssignedLinSlaveConfigRef"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-LIN-SLAVE-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    byte_values: Optional["DataDumpEntry.ByteValues"] = field(
        default=None,
        metadata={
            "name": "BYTE-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AssignedControllerRef(Ref):
        dest: LinSlaveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AssignedLinSlaveConfigRef(Ref):
        dest: LinSlaveConfigIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ByteValues:
        byte_value: list[Integer] = field(
            default_factory=list,
            metadata={
                "name": "BYTE-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 5,
            },
        )


@dataclass(slots=True, kw_only=True)
class DelegatedPortAnnotation:
    """
    Annotation to a "delegated port" to specify the Signal Fan In or Signal Fan Out
    inside the CompositionSwComponentType.

    :ivar label: This is the headline for the annotation.
    :ivar annotation_origin: This attribute identifies the origin of the
        annotation. It is an arbitrary string since it can be an
        individual's name as well as the name of a tool or even the name
        of a process step.
    :ivar annotation_text: This is the text of the annotation.
    :ivar signal_fan: Specifies the Signal Fan In or Signal Fan Out
        inside the Composition Type.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DELEGATED-PORT-ANNOTATION"

    label: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_origin: String | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_text: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-TEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signal_fan: SignalFanEnum | None = field(
        default=None,
        metadata={
            "name": "SIGNAL-FAN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FreeFormat:
    """
    Representing freely defined data.

    :ivar introduction: This represents introductory documentation about
        the schedule table entry.
    :ivar delay: Relative delay between this tableEntry and the start of
        the successor in the schedule table in seconds.
    :ivar position_in_table: Relative position in the schedule table.
        The first entry index in the schedule table is 0.
    :ivar byte_values: The integer Value of a freely defined data byte.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FREE-FORMAT"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    position_in_table: Integer | None = field(
        default=None,
        metadata={
            "name": "POSITION-IN-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    byte_values: Optional["FreeFormat.ByteValues"] = field(
        default=None,
        metadata={
            "name": "BYTE-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ByteValues:
        byte_value: list[Integer] = field(
            default_factory=list,
            metadata={
                "name": "BYTE-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 8,
            },
        )


@dataclass(slots=True, kw_only=True)
class IoHwAbstractionServerAnnotation:
    """The IoHwAbstractionServerAnnotation will only be used from a sensor- or an
    actuator component while interacting with the IoHwAbstraction layer.

    Note that the "server" in the name of this meta-class is not meant
    to restrict the usage to ClientServerInterfaces.

    :ivar label: This is the headline for the annotation.
    :ivar annotation_origin: This attribute identifies the origin of the
        annotation. It is an arbitrary string since it can be an
        individual's name as well as the name of a tool or even the name
        of a process step.
    :ivar annotation_text: This is the text of the annotation.
    :ivar age: In case of a SET operation, the age will be interpreted
        as Delay while in a GET operation (input) it specifies the
        Lifetime of the signal within the IoHwAbstraction Layer
    :ivar argument_ref: Reference to the corresponding
        ArgumentDataPrototype.
    :ivar bsw_resolution: This value is determined by an appropriate
        combination of the range, the unit as well as the data-elements
        type, i.e. (ecuSignalRange.upperLimit-ecuSignalRange.lowerLimit)
        / (2^datatypelength - 1)
    :ivar data_element_ref: Reference to the corresponding
        VariableDataPrototype.
    :ivar failure_monitoring_ref: This is only applicable in SET
        operations. If it is enabled, the IoHwAbstraction layer will
        monitor the result of the operation and issue an diagnostic
        signal. This means especially, that an additional client-server
        port has to be created. Tools can use this information to cross-
        check whether for each data-element in a SET operation with
        FailureMonitoring enabled an additional port is created The
        referenced port monitors a failure in the to be monitored
        VariableDataPrototype of the IoHwAbstraction layer. The
        referenced port has to be another port of the same Actuator or
        Sensor Component.
    :ivar filtering_debouncing: This attribute is used to indicate what
        kind of filtering/debouncing has been put to the signal in the
        IoHwAbstraction layer. rawData means that no modification of the
        signal has been applied. This is the default value debounceData
        means that the signal is a mean value waitTimeData means that
        the signal is delivered by a GET operation after a certain
        amount of time
    :ivar pulse_test: This attribute indicates to the connected
        SensorActuatorSwComponentType whether the VariableDataPrototype
        can be used to generate pulse test sequences using the
        IoHwAbstraction layer
    :ivar trigger_ref: Reference to the corresponding Trigger.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IO-HW-ABSTRACTION-SERVER-ANNOTATION"

    label: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_origin: String | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_text: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-TEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    age: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "AGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    argument_ref: Optional["IoHwAbstractionServerAnnotation.ArgumentRef"] = field(
        default=None,
        metadata={
            "name": "ARGUMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_resolution: Float | None = field(
        default=None,
        metadata={
            "name": "BSW-RESOLUTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["IoHwAbstractionServerAnnotation.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    failure_monitoring_ref: Optional["IoHwAbstractionServerAnnotation.FailureMonitoringRef"] = (
        field(
            default=None,
            metadata={
                "name": "FAILURE-MONITORING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    filtering_debouncing: FilterDebouncingEnum | None = field(
        default=None,
        metadata={
            "name": "FILTERING-DEBOUNCING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pulse_test: PulseTestEnum | None = field(
        default=None,
        metadata={
            "name": "PULSE-TEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_ref: Optional["IoHwAbstractionServerAnnotation.TriggerRef"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ArgumentRef(Ref):
        dest: ArgumentDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FailureMonitoringRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class LifeCycleInfo:
    """
    LifeCycleInfo describes the life cycle state of an element together with
    additional information like what to use instead.

    :ivar lc_object_ref: Element(s) have the life cycle as described in
        lcState.
    :ivar lc_state_ref: This denotes the particular state assigned to
        the object. If no lcState is given then the default life cycle
        state of LifeCycleInfoSet is assumed.
    :ivar period_begin: Starting point of period in which the element
        has the denoted life cycle state lcState. If no periodBegin is
        given then the default period begin of LifeCycleInfoSet is
        assumed.
    :ivar period_end: Expiry date, i.e. end point of period the element
        does not have the denoted life cycle state lcState any more. If
        no periodEnd is given then the default period begin of
        LifeCycleInfoSet is assumed.
    :ivar remark: Remark describing for example * why the element was
        given the specified life cycle * the semantics of useInstead
    :ivar use_instead_refs: Element(s) that should be used instead of
        the one denoted in  referrable. Only relevant in case of life
        cycle states lcState unlike "valid". In case there are multiple
        references the exact semantics shall be individually described
        in the remark.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIFE-CYCLE-INFO"

    lc_object_ref: Optional["LifeCycleInfo.LcObjectRef"] = field(
        default=None,
        metadata={
            "name": "LC-OBJECT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lc_state_ref: Optional["LifeCycleInfo.LcStateRef"] = field(
        default=None,
        metadata={
            "name": "LC-STATE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    period_begin: LifeCyclePeriod | None = field(
        default=None,
        metadata={
            "name": "PERIOD-BEGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    period_end: LifeCyclePeriod | None = field(
        default=None,
        metadata={
            "name": "PERIOD-END",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remark: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "REMARK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    use_instead_refs: Optional["LifeCycleInfo.UseInsteadRefs"] = field(
        default=None,
        metadata={
            "name": "USE-INSTEAD-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class LcObjectRef(Ref):
        dest: ReferrableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class LcStateRef(Ref):
        dest: LifeCycleStateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class UseInsteadRefs:
        use_instead_ref: list["LifeCycleInfo.UseInsteadRefs.UseInsteadRef"] = field(
            default_factory=list,
            metadata={
                "name": "USE-INSTEAD-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class UseInsteadRef(Ref):
            dest: ReferrableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class ModePortAnnotation:
    """
    Annotation to a port used for calibration regarding a certain
    ModeDeclarationGroupPrototype.

    :ivar label: This is the headline for the annotation.
    :ivar annotation_origin: This attribute identifies the origin of the
        annotation. It is an arbitrary string since it can be an
        individual's name as well as the name of a tool or even the name
        of a process step.
    :ivar annotation_text: This is the text of the annotation.
    :ivar mode_group_ref: The instance of annotated
        ModeDeclarationGroupPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-PORT-ANNOTATION"

    label: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_origin: String | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_text: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-TEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_group_ref: Optional["ModePortAnnotation.ModeGroupRef"] = field(
        default=None,
        metadata={
            "name": "MODE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ModeGroupRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Modification:
    """
    This meta-class represents the ability  to record what has changed in a
    document in comparison to its predecessor.

    :ivar change: This property denotes the one particular change which
        was performed on the object.
    :ivar reason: This property represents the rationale for the
        particular change.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODIFICATION"

    change: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "CHANGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reason: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "REASON",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MsrQueryP2:
    """
    This meta-class represents the ability to express a query which yields the
    content of a DocumentationBlock as a result.

    :ivar msr_query_props: This is argument and properties of the
        DocumentationBlock query.
    :ivar msr_query_result_p_2: This represents the result of the query.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MSR-QUERY-P-2"

    msr_query_props: MsrQueryProps | None = field(
        default=None,
        metadata={
            "name": "MSR-QUERY-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_result_p_2: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "MSR-QUERY-RESULT-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class NvDataPortAnnotation:
    """
    Annotation to a port regarding a certain VariableDataPrototype.

    :ivar label: This is the headline for the annotation.
    :ivar annotation_origin: This attribute identifies the origin of the
        annotation. It is an arbitrary string since it can be an
        individual's name as well as the name of a tool or even the name
        of a process step.
    :ivar annotation_text: This is the text of the annotation.
    :ivar variable_ref: The instance of nv data annotated.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NV-DATA-PORT-ANNOTATION"

    label: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_origin: String | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_text: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-TEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variable_ref: Optional["NvDataPortAnnotation.VariableRef"] = field(
        default=None,
        metadata={
            "name": "VARIABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class VariableRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ParameterPortAnnotation:
    """
    Annotation to a port used for calibration regarding a certain
    ParameterDataPrototype.

    :ivar label: This is the headline for the annotation.
    :ivar annotation_origin: This attribute identifies the origin of the
        annotation. It is an arbitrary string since it can be an
        individual's name as well as the name of a tool or even the name
        of a process step.
    :ivar annotation_text: This is the text of the annotation.
    :ivar parameter_ref: The instance of annotated
        ParameterDataPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PARAMETER-PORT-ANNOTATION"

    label: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_origin: String | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_text: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-TEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_ref: Optional["ParameterPortAnnotation.ParameterRef"] = field(
        default=None,
        metadata={
            "name": "PARAMETER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ParameterRef(Ref):
        dest: ParameterDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PrmChar:
    """This metaclass represents the ability to express the characteristics of one
    particular parameter.

    It can be exressed as numerical or as text parameter (provided as
    subclasses of PrmCharContents)

    :ivar cond: This represents the particular conditions under which
        the parameter characteristic is valid.
    :ivar abs: This represnts the absolute value of the parameter.
    :ivar tol: This represnts the tolerance of the parameter in the same
        units as the paramter: E.g. Tmperature= 50 +- 0.5 grad.
    :ivar min: This represnts the minimum value of the parameter.
    :ivar typ: This represnts the typical value of the parameter.
    :ivar max: This represnts the maximum value of the parameter.
    :ivar prm_unit: This is the measurement unit. Note that due to the
        fact that Prm is also available outside of MSRSW / AUTOSAR, this
        is not a formal reference  to a unit.
    :ivar text: This is the value of a textual parameter
    :ivar remark: This represents further remarks about the particular
        parameter characteristics.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PRM-CHAR"

    cond: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    abs: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "ABS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tol: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "TOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    typ: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "TYP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prm_unit: SingleLanguageUnitNames | None = field(
        default=None,
        metadata={
            "name": "PRM-UNIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    text: String | None = field(
        default=None,
        metadata={
            "name": "TEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remark: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "REMARK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ReceiverAnnotation:
    """Annotation of a receiver port, specifying properties of data elements that
    don't affect communication or generation of the RTE.

    The given attributes are requirements on the required data.

    :ivar label: This is the headline for the annotation.
    :ivar annotation_origin: This attribute identifies the origin of the
        annotation. It is an arbitrary string since it can be an
        individual's name as well as the name of a tool or even the name
        of a process step.
    :ivar annotation_text: This is the text of the annotation.
    :ivar computed: Flag whether this data element was not measured
        directly but instead was calculated from possibly several other
        measured or calculated values.
    :ivar data_element_ref: The instance of VariableDataPrototype
        annotated.
    :ivar limit_kind: This min or max has not to be mismatched with the
        min- and max for data-value in a compu-method. For example, this
        annotation shows when the result of the calculation performed in
        a RunnableEntity owned by one AtomicSwComponentType is
        transmitted to another AtomicSwComponentType whose
        RunnableEntity will use this value as a limit, e.g. the
        max.power which can be used by that software-component, or the
        current min. slip.
    :ivar processing_kind: This attribute controls how data is processed
        according to the possible values of ProcessingKindEnum.
    :ivar signal_age: The maximum allowed age of the signal since it was
        originally read by a sensor. This is a requirement specified on
        the receiver side.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RECEIVER-ANNOTATION"

    label: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_origin: String | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_text: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-TEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    computed: Boolean | None = field(
        default=None,
        metadata={
            "name": "COMPUTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["ReceiverAnnotation.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    limit_kind: DataLimitKindEnum | None = field(
        default=None,
        metadata={
            "name": "LIMIT-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    processing_kind: ProcessingKindEnum | None = field(
        default=None,
        metadata={
            "name": "PROCESSING-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signal_age: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "SIGNAL-AGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SaveConfigurationEntry:
    """
    This service is used to notify a slave node to store its configuration.

    :ivar introduction: This represents introductory documentation about
        the schedule table entry.
    :ivar delay: Relative delay between this tableEntry and the start of
        the successor in the schedule table in seconds.
    :ivar position_in_table: Relative position in the schedule table.
        The first entry index in the schedule table is 0.
    :ivar assigned_controller_ref: The LIN slaves controller who is
        target of this assignment. Optional in case
        LinConfigurationEntry.assignedLinSlaveConfig exists.
    :ivar assigned_lin_slave_config_ref: The LIN slave that is target of
        this assignment. Please note that this reference is redundant to
        the assignedController reference. In an Ecu Extract of the
        LinMaster the LinSlave Ecus shall not be available. The
        information that is described here is necessary in the ECU
        Extract for the configuration of the LinMaster.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SAVE-CONFIGURATION-ENTRY"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    position_in_table: Integer | None = field(
        default=None,
        metadata={
            "name": "POSITION-IN-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_controller_ref: Optional["SaveConfigurationEntry.AssignedControllerRef"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_lin_slave_config_ref: Optional["SaveConfigurationEntry.AssignedLinSlaveConfigRef"] = (
        field(
            default=None,
            metadata={
                "name": "ASSIGNED-LIN-SLAVE-CONFIG-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AssignedControllerRef(Ref):
        dest: LinSlaveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AssignedLinSlaveConfigRef(Ref):
        dest: LinSlaveConfigIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ScaleConstr:
    """
    This meta-class represents the ability to specify constraints as a list of
    intervals (called scales).

    :ivar short_label: This element specifies a short name for the
        scaleConstr. This can for example be used to create more
        specific messages of a constraint checker. The constraints
        cannot be associated in the meta-model, therefore shortLabel is
        somehow a substitute for shortName.
    :ivar desc: &lt;desc&gt; represents a general but brief description
        of the object in question.
    :ivar lower_limit: This specifies the lower limit of the scale.
    :ivar upper_limit: This specifies the upper limit of a the scale.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar validity: Specifies if the values defined by the scales are
        considered to be valid. If the attribute is missing then the
        default value is "VALID".
    """

    class Meta:
        name = "SCALE-CONSTR"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_limit: Limit | None = field(
        default=None,
        metadata={
            "name": "LOWER-LIMIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_limit: Limit | None = field(
        default=None,
        metadata={
            "name": "UPPER-LIMIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    validity: ScaleConstrValidityEnumSimple | None = field(
        default=None,
        metadata={
            "name": "VALIDITY",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class SdgCaption:
    """This meta-class represents the caption of a special data group.

    This allows to have some parts of special data as identifiable.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the special data in question is about. It is
        only one paragraph! Desc is intended to be collected into
        overview tables. This property helps a human reader to identify
        the special data in question.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SDG-CAPTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SdgCaption.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SenderAnnotation:
    """
    Annotation of a sender port, specifying properties of data elements that don't
    affect communication or generation of the RTE.

    :ivar label: This is the headline for the annotation.
    :ivar annotation_origin: This attribute identifies the origin of the
        annotation. It is an arbitrary string since it can be an
        individual's name as well as the name of a tool or even the name
        of a process step.
    :ivar annotation_text: This is the text of the annotation.
    :ivar computed: Flag whether this data element was not measured
        directly but instead was calculated from possibly several other
        measured or calculated values.
    :ivar data_element_ref: The instance of VariableDataPrototype
        annotated.
    :ivar limit_kind: This min or max has not to be mismatched with the
        min- and max for data-value in a compu-method. For example, this
        annotation shows when the result of the calculation performed in
        a RunnableEntity owned by one AtomicSwComponentType is
        transmitted to another AtomicSwComponentType whose
        RunnableEntity will use this value as a limit, e.g. the
        max.power which can be used by that software-component, or the
        current min. slip.
    :ivar processing_kind: This attribute controls how data is processed
        according to the possible values of ProcessingKindEnum.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SENDER-ANNOTATION"

    label: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_origin: String | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_text: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-TEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    computed: Boolean | None = field(
        default=None,
        metadata={
            "name": "COMPUTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["SenderAnnotation.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    limit_kind: DataLimitKindEnum | None = field(
        default=None,
        metadata={
            "name": "LIMIT-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    processing_kind: ProcessingKindEnum | None = field(
        default=None,
        metadata={
            "name": "PROCESSING-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwRecordLayoutV:
    """This element specifies which values are stored for the current
    SwRecordLayoutGroup.

    If no baseType is present, the SwBaseType referenced initially in
    the parent SwRecordLayoutGroup is valid. The specification of
    swRecordLayoutVAxis gives the axis of the values which shall be
    stored in accordance with the current record layout
    SwRecordLayoutGroup. In swRecordLayoutVProp one can specify the
    information which shall be stored.

    :ivar short_label: This attribute specifies a name which can be used
        e.g. when ECU code is generated from the record layout value.
    :ivar category: This attribute denotes the semantics in particular
        in terms of the corresponding A2L-Keyword. This is to support
        the mapping of the more general record layouts in AUTOSAR/MSR to
        the specific A2l keywords. It is possible to express the
        specific semantics of A2l RecordLayout keywords in
        swRecordlayoutGroup but not always vice versa. Therefore the
        mapping is provided in this optional attribute.
    :ivar desc: This aggregation allows for a brief description about
        the particular record layout value which can help to identify
        the entry. In-depth documentation should be added to the
        introduction of the surrounding record layout.
    :ivar base_type_ref: This association allows to refer to a base type
        in case a specific encoding is intended. If no base type is
        referred, the base type referenced initially in the
        corresponding DataPrototype is to be used.
    :ivar sw_record_layout_v_axis: This attribute gives the index of the
        axis of which values that are stored in the record.
        swRecordVIndex refers to the symbolic names of the iterators for
        which the axis value shall be stored in the record. In case of
        nested iterators (mainly for multidimensional objects) the
        iterator names are specified as whitespace-separated names.
        These symbolic names relate to swRecordLayoutGroupIndex. The
        iterators are processed from left to right in such a manner that
        they symbolize the loop index from the outside to the inside. It
        is considered an error if more components are specified than
        axes exist in the related ApplicationDataType.
    :ivar sw_record_layout_v_prop: This attribute describes the kind of
        values to be stored. More details see below. The standardized
        values foreseen for this attribute are defined in
        [TPS_SWCT_01489].
    :ivar sw_record_layout_v_index: The symbolic value for iteration, or
        the symbolic values separated by whitespaces, refer to the
        symbolic values given in swRecordLayoutGroupIndex . The
        iterators are processed from left to right, in such a manner
        that they symbolize the loop index from the outside to the
        inside. It is considered an error if the record layout is
        referenced by an entity which has less number of axes than index
        names referenced here.
    :ivar sw_generic_axis_param_type_ref: This association supports the
        case that a value from a generic axis definition shall be
        stored. This value is denoted by a particular generic axis
        parameter type.
    :ivar sw_record_layout_v_fix_value: This attribute specifies the
        filler character for the current record layout, in the form of
        hex digits. It is also used to specify the fix value for e.g.
        FIXRIGHTDIFF.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-RECORD-LAYOUT-V"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: AsamRecordLayoutSemantics | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    base_type_ref: Optional["SwRecordLayoutV.BaseTypeRef"] = field(
        default=None,
        metadata={
            "name": "BASE-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_v_axis: AxisIndexType | None = field(
        default=None,
        metadata={
            "name": "SW-RECORD-LAYOUT-V-AXIS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_v_prop: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "SW-RECORD-LAYOUT-V-PROP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_v_index: NmtokensString | None = field(
        default=None,
        metadata={
            "name": "SW-RECORD-LAYOUT-V-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_generic_axis_param_type_ref: Optional["SwRecordLayoutV.SwGenericAxisParamTypeRef"] = field(
        default=None,
        metadata={
            "name": "SW-GENERIC-AXIS-PARAM-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_v_fix_value: Integer | None = field(
        default=None,
        metadata={
            "name": "SW-RECORD-LAYOUT-V-FIX-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BaseTypeRef(Ref):
        dest: SwBaseTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SwGenericAxisParamTypeRef(Ref):
        dest: SwGenericAxisParamTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TriggerPortAnnotation:
    """
    Annotation to a port used for calibration regarding a certain Trigger.

    :ivar label: This is the headline for the annotation.
    :ivar annotation_origin: This attribute identifies the origin of the
        annotation. It is an arbitrary string since it can be an
        individual's name as well as the name of a tool or even the name
        of a process step.
    :ivar annotation_text: This is the text of the annotation.
    :ivar trigger_ref: The instance of annotated trigger.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRIGGER-PORT-ANNOTATION"

    label: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_origin: String | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotation_text: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION-TEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_ref: Optional["TriggerPortAnnotation.TriggerRef"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class UnassignFrameId:
    """Schedule entry for an Unassign Frame Id master request where the protected
    identifier is assigned the value 0x40.

    This will disable reception/transmission of a previously dynamically
    assigned frame identifier.

    :ivar introduction: This represents introductory documentation about
        the schedule table entry.
    :ivar delay: Relative delay between this tableEntry and the start of
        the successor in the schedule table in seconds.
    :ivar position_in_table: Relative position in the schedule table.
        The first entry index in the schedule table is 0.
    :ivar assigned_controller_ref: The LIN slaves controller who is
        target of this assignment. Optional in case
        LinConfigurationEntry.assignedLinSlaveConfig exists.
    :ivar assigned_lin_slave_config_ref: The LIN slave that is target of
        this assignment. Please note that this reference is redundant to
        the assignedController reference. In an Ecu Extract of the
        LinMaster the LinSlave Ecus shall not be available. The
        information that is described here is necessary in the ECU
        Extract for the configuration of the LinMaster.
    :ivar message_id: MessageId of the referenced frame.
    :ivar unassigned_frame_triggering_ref: The frame whose identifier is
        reset by this assignment.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UNASSIGN-FRAME-ID"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    position_in_table: Integer | None = field(
        default=None,
        metadata={
            "name": "POSITION-IN-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_controller_ref: Optional["UnassignFrameId.AssignedControllerRef"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_lin_slave_config_ref: Optional["UnassignFrameId.AssignedLinSlaveConfigRef"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-LIN-SLAVE-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    message_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MESSAGE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unassigned_frame_triggering_ref: Optional["UnassignFrameId.UnassignedFrameTriggeringRef"] = (
        field(
            default=None,
            metadata={
                "name": "UNASSIGNED-FRAME-TRIGGERING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AssignedControllerRef(Ref):
        dest: LinSlaveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AssignedLinSlaveConfigRef(Ref):
        dest: LinSlaveConfigIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class UnassignedFrameTriggeringRef(Ref):
        dest: LinFrameTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DocRevision:
    """
    This meta-class represents the ability to maintain information which relates to
    revision management of documents or objects.

    :ivar revision_label: This attribute represents the version number
        of the object.
    :ivar revision_label_p_1: This attribute represents the version
        number of the first predecessor  of the object.
    :ivar revision_label_p_2: This attribute represents the version
        number of the second predecessor of the object. This attribute
        is used if the object is the result of a merge process in which
        two branches are merged in to one new revision.
    :ivar state: The attribute state represents the current state of the
        current file according to the configuration management plan. It
        is a NameToken until possible states are  standardized.
    :ivar issued_by: This is the name of an individual or an
        organization who issued the current revision of the document or
        document fragment.
    :ivar date: This specifies the date and time, when the object in
        question was released
    :ivar modifications: This property represents one particular
        modification in comparison to its predecessor.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DOC-REVISION"

    revision_label: RevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "REVISION-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    revision_label_p_1: RevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "REVISION-LABEL-P-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    revision_label_p_2: RevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "REVISION-LABEL-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    state: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "STATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    issued_by: String | None = field(
        default=None,
        metadata={
            "name": "ISSUED-BY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    date: Date | None = field(
        default=None,
        metadata={
            "name": "DATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    modifications: Optional["DocRevision.Modifications"] = field(
        default=None,
        metadata={
            "name": "MODIFICATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Modifications:
        modification: list[Modification] = field(
            default_factory=list,
            metadata={
                "name": "MODIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class InternalConstrs:
    """
    This meta-class represents the ability to express internal constraints.

    :ivar lower_limit: This specifies the lower limit of the constraint.
    :ivar upper_limit: This specifies the upper limit defined by the
        constraint.
    :ivar scale_constrs: This is one particular scale which contributes
        to the data constraints.
    :ivar max_gradient: This element specifies the maximum slope that
        may be used in maps and curves.
    :ivar max_diff: Maximum difference that is permitted between two
        consecutive values if the constraint is applied to an axis.
    :ivar monotony: This element specifies the monotony characteristics
        of the current internal or physical limits. The following table
        shows the monotony characteristics which are to be filled
        through the corresponding values. If the element has no contents
        or if it is omitted, "noMonotony" is the default content.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INTERNAL-CONSTRS"

    lower_limit: Limit | None = field(
        default=None,
        metadata={
            "name": "LOWER-LIMIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_limit: Limit | None = field(
        default=None,
        metadata={
            "name": "UPPER-LIMIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scale_constrs: Optional["InternalConstrs.ScaleConstrs"] = field(
        default=None,
        metadata={
            "name": "SCALE-CONSTRS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_gradient: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "MAX-GRADIENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_diff: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "MAX-DIFF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    monotony: MonotonyEnum | None = field(
        default=None,
        metadata={
            "name": "MONOTONY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ScaleConstrs:
        scale_constr: list[ScaleConstr] = field(
            default_factory=list,
            metadata={
                "name": "SCALE-CONSTR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PhysConstrs:
    """This meta-class represents the ability to express physical constraints.

    Therefore it has (in opposite to InternalConstrs) a reference to a
    Unit.

    :ivar lower_limit: This specifies the lower limit of the constraint.
    :ivar upper_limit: This specifies the upper limit of the constraint.
    :ivar scale_constrs: This is one particular scale which contributes
        to the data constraints.
    :ivar max_gradient: This element specifies the maximum slope that
        may be used in curves and maps.
    :ivar max_diff: Maximum difference that is permitted between two
        consecutive values if the constraint is applied to an axis.
    :ivar monotony: This specifies the monotony constraints on the data
        object. Note that this applies only to curves and maps.
    :ivar unit_ref: This is the unit to which the physical constraints
        relate to. In particular, it is the physical unit of the
        specified limits.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PHYS-CONSTRS"

    lower_limit: Limit | None = field(
        default=None,
        metadata={
            "name": "LOWER-LIMIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_limit: Limit | None = field(
        default=None,
        metadata={
            "name": "UPPER-LIMIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scale_constrs: Optional["PhysConstrs.ScaleConstrs"] = field(
        default=None,
        metadata={
            "name": "SCALE-CONSTRS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_gradient: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "MAX-GRADIENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_diff: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "MAX-DIFF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    monotony: MonotonyEnum | None = field(
        default=None,
        metadata={
            "name": "MONOTONY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_ref: Optional["PhysConstrs.UnitRef"] = field(
        default=None,
        metadata={
            "name": "UNIT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ScaleConstrs:
        scale_constr: list[ScaleConstr] = field(
            default_factory=list,
            metadata={
                "name": "SCALE-CONSTR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class UnitRef(Ref):
        dest: UnitSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Sdg:
    """Sdg (SpecialDataGroup) is a generic model which can be used to keep
    arbitrary information which is not explicitly modeled in the meta-model.

    Sdg can have various contents as defined by sdgContentsType. Special
    Data should only be used moderately since all elements should be
    defined in the meta-model. Thereby SDG should be considered as a
    temporary solution when no explicit model is available. If an
    sdgCaption is available, it is possible to establish a reference to
    the sdg structure.

    :ivar sdg_caption: This aggregation allows to assign the properties
        of Identifiable to the sdg. By this, a shortName etc. can be
        assigned to the Sdg.
    :ivar sdg_caption_ref: This association allows to reuse an already
        existing caption.
    :ivar sdx_ref: Reference to any identifiable element. This allows to
        use Sdg even to establish arbitrary relationships.
    :ivar sdxf: Additional reference with variant support. This property
        was modified due to atpVariation (DirectedAssociationPattern).
    :ivar sd: This is one particular special data element.
    :ivar sdg: This aggregation allows to express nested special data
        groups. By this, any structure can be represented in
        SpeicalData. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar sdf: This is one particular special data element.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: SdgContents.sdg Not
        Applicable for: FileInfoComment.sdg Not Applicable for:
        BuildActionEnvironment.sdg Not Applicable for:
        BuildActionInvocator.sdg Not Applicable for:
        BuildActionIoElement.sdg Not Applicable for: VariationPoint.sdg
        Not Applicable for: RptHook.sdg Not Applicable for:
        AdminData.sdg
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar gid: This attributes specifies an identifier. Gid comes from
        the SGML/XML-Term "Generic Identifier" which is the element name
        in XML. The role of this attribute is the same as the name of an
        XML - element.
    """

    class Meta:
        name = "SDG"

    sdg_caption: SdgCaption | None = field(
        default=None,
        metadata={
            "name": "SDG-CAPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdg_caption_ref: Optional["Sdg.SdgCaptionRef"] = field(
        default=None,
        metadata={
            "name": "SDG-CAPTION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdx_ref: list["Sdg.SdxRef"] = field(
        default_factory=list,
        metadata={
            "name": "SDX-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdxf: list[ReferrableRefConditional] = field(
        default_factory=list,
        metadata={
            "name": "SDXF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sd: list[Sd] = field(
        default_factory=list,
        metadata={
            "name": "SD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdg: list["Sdg"] = field(
        default_factory=list,
        metadata={
            "name": "SDG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdf: list[Sdf] = field(
        default_factory=list,
        metadata={
            "name": "SDF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: Optional["VariationPoint"] = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    gid: str | None = field(
        default=None,
        metadata={
            "name": "GID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SdgCaptionRef(Ref):
        dest: SdgCaptionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SdxRef(Ref):
        dest: ReferrableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwRecordLayoutGroup:
    """Specifies how a record layout is set up.

    Using SwRecordLayoutGroup it recursively models iterations through
    axis values. The subelement swRecordLayoutGroupContentType may
    reference other SwRecordLayouts, SwRecordLayoutVs and
    SwRecordLayoutGroups for the modeled record layout.

    :ivar short_label: This attribute specifies a name which can be used
        e.g. when ECU code is generated from the record layout group.
    :ivar category: This attribute denotes the semantics in particular
        in terms of the corresponding A2L-Keyword. This is to support
        the mapping of the more general record layouts in AUTOSAR/MSR to
        the specific A2l keywords. It is possible to express the
        specific semantics of A2l recordlayout keywords in
        swRecordlayoutGroup but not always vice versa. Therefore the
        mapping is provided in this optional attribute.
    :ivar desc: This aggregation allows a brief description about the
        particular record layout group which can help to identify the
        entry. In-depth documentation should be added  to the
        introduction of the surrounding record layout.
    :ivar sw_record_layout_group_axis: This attribute specifies the
        iteration axis number for a SwRecordLayoutGroup. The current
        record layout group then refers exactly to the axis with this
        number. This means that the values are taken by iterating along
        the thus referenced axis.
    :ivar sw_record_layout_group_index: This attribute attributes a
        symbolic name to the iterator of the superimposed record layout
        group. This can be referenced as a loop index in contained
        SwRecordLayoutV elements.
    :ivar sw_generic_axis_param_type_ref: This association allows to
        specify record layout groups to iterate over generic axis
        parameters. For example, if the generic axis parameter is an
        array, the record layout group will iterate over this array.
        Obviously, the axis referred to by swRecordLayoutGroupAxis shall
        be a generic axis in which the referenced SwGenericAxisType is
        aggregated.
    :ivar sw_record_layout_group_from: This attribute specifies the
        iterator index for the point in the axis from which a record
        layout group is commenced. Negative values are also possible,
        i.e. the value -4 counts from the fourth value from the end. If
        this property is missing, the iteration starts with '1'.
    :ivar sw_record_layout_group_to: This attribute specifies the end
        point for the iteration. Negative values are also possible, i.e.
        the value -4 counts up to the fourth value from the end. If this
        property is not there, the iteration ends at "-1" which is the
        last element. Note that depending on the arraySizeSemantics of
        SwTextProps the iteration ends at the value specified in
        swMaxTextSize.
    :ivar sw_record_layout_group_step: This attribute specifies the step
        width for the iterator index that is used for the current record
        layout group. Note that negative values are also possible, in
        case of the starting point is higher than the endpoint. If the
        property is missing, the step width is "1".
    :ivar sw_record_layout_component: This attribute is used to denote
        the component to which the group in question applies. Thus, the
        record layout supports structured objects. This secures
        independence from the sequence of components, because they can
        be referred to via name.
    :ivar sw_record_layout_ref: This association allows to support
        reusable "sub"-record layouts. In particular, the contents of
        the referenced record layout shall be used as if the record
        layout group in the referenced record layout was aggregated in
        the current record layout group. So, semantically it would be
        equivalent to replace the particular association with an
        aggregation of the  swRecordLayoutGroup of the referenced
        SwRecordLayout.
    :ivar sw_record_layout_v: Particular Value specification for this
        record layout group.
    :ivar sw_record_layout_group: This aggregation provides support for
        nested iterations. For example, if a map is to be handled, then
        we might have two nested SwRecordLayoutGroups, one for the
        x-axis and one for the y-axis. The inner iteration runs faster.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-RECORD-LAYOUT-GROUP"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: AsamRecordLayoutSemantics | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_group_axis: AxisIndexType | None = field(
        default=None,
        metadata={
            "name": "SW-RECORD-LAYOUT-GROUP-AXIS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_group_index: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "SW-RECORD-LAYOUT-GROUP-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_generic_axis_param_type_ref: Optional["SwRecordLayoutGroup.SwGenericAxisParamTypeRef"] = (
        field(
            default=None,
            metadata={
                "name": "SW-GENERIC-AXIS-PARAM-TYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    sw_record_layout_group_from: RecordLayoutIteratorPoint | None = field(
        default=None,
        metadata={
            "name": "SW-RECORD-LAYOUT-GROUP-FROM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_group_to: RecordLayoutIteratorPoint | None = field(
        default=None,
        metadata={
            "name": "SW-RECORD-LAYOUT-GROUP-TO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_group_step: Integer | None = field(
        default=None,
        metadata={
            "name": "SW-RECORD-LAYOUT-GROUP-STEP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_component: Identifier | None = field(
        default=None,
        metadata={
            "name": "SW-RECORD-LAYOUT-COMPONENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_ref: list["SwRecordLayoutGroup.SwRecordLayoutRef"] = field(
        default_factory=list,
        metadata={
            "name": "SW-RECORD-LAYOUT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_v: list[SwRecordLayoutV] = field(
        default_factory=list,
        metadata={
            "name": "SW-RECORD-LAYOUT-V",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_group: list["SwRecordLayoutGroup"] = field(
        default_factory=list,
        metadata={
            "name": "SW-RECORD-LAYOUT-GROUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SwGenericAxisParamTypeRef(Ref):
        dest: SwGenericAxisParamTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SwRecordLayoutRef(Ref):
        dest: SwRecordLayoutSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AdminData:
    """AdminData represents the ability to express administrative information and
    custom extensions for an element.

    This administration information is to be treated as meta-data such as revision id or state of the file. There are basically the following kinds of meta-data
    * The language and/or used languages.
    * Revision information covering e.g. revision number, state, release date, changes. Note that this information can be given in general as well as related to a particular company.
    * Document meta-data specific for a company
    Beside that a custom extension of model-data is possible by
    * Special data

    :ivar language: This attribute  specifies the master language of the
        document or the document fragment. The master language is the
        one in which the document is maintained and from which the other
        languages are derived from. In particular in case of
        inconsistencies, the information in the master language is
        priority.
    :ivar used_languages: This property specifies the languages which
        are provided in the document. Therefore it should only be
        specified in the top level admin data. For each language
        provided in the document there is one entry in
        MultilanguagePlainText. The content of each entry can be used
        for illustration of the language. The used language itself
        depends on the language attribute in the entry.
    :ivar doc_revisions: This allows to denote information about the
        current revision of the object. Note that information about
        previous revisions can also be logged here. The entries shall be
        sorted descendant by date in order to reflect the history.
        Therefore the most recent entry representing the current version
        is denoted first.
    :ivar sdgs: This property allows to keep special data which is not
        represented by the standard model. It can be utilized to keep
        e.g. tool specific data. This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ADMIN-DATA"

    language: LEnum | None = field(
        default=None,
        metadata={
            "name": "LANGUAGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    used_languages: MultiLanguagePlainText | None = field(
        default=None,
        metadata={
            "name": "USED-LANGUAGES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    doc_revisions: Optional["AdminData.DocRevisions"] = field(
        default=None,
        metadata={
            "name": "DOC-REVISIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdgs: Optional["AdminData.Sdgs"] = field(
        default=None,
        metadata={
            "name": "SDGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DocRevisions:
        doc_revision: list[DocRevision] = field(
            default_factory=list,
            metadata={
                "name": "DOC-REVISION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Sdgs:
        sdg: list["Sdg"] = field(
            default_factory=list,
            metadata={
                "name": "SDG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BuildActionInvocator:
    """
    This meta-class represents the ability to specify the invocation of a task in a
    build action.

    :ivar command: This represents the command to invocate the
        processor. Note that this is a generic string which can be
        interpreted properly in the processor environment. Note that it
        is optional due to the fact that some actions are hardwired in
        the environment and do not need an explicit command. On the
        other hand the properties of an invocator can be complex and not
        standardized.
    :ivar sdgs: This represents a general data structure  intended to
        denote parameters for the BuildAction. This aggregation contains
        a variation point although it is not variant. Therefore, this
        variation point shall not exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUILD-ACTION-INVOCATOR"

    command: VerbatimString | None = field(
        default=None,
        metadata={
            "name": "COMMAND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdgs: Optional["BuildActionInvocator.Sdgs"] = field(
        default=None,
        metadata={
            "name": "SDGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Sdgs:
        sdg: list[Sdg] = field(
            default_factory=list,
            metadata={
                "name": "SDG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BuildActionIoElement:
    """
    This meta-class represents the ability to specify the input/output entities of
    a BuildAction.

    :ivar category: This element assigns a category to the parent
        element. It is intended to specialize the usage and/or the
        content of the object. Such a specialization may also impose
        particular semantic constraints on the entire substructure. See
        also Identifiable.
    :ivar sdgs: This special data group allows to denote specific data.
        The structure is subject of mutual agreement. This aggregation
        contains a variation point although it is not variant.
        Therefore, this variation point shall not exist in models. See
        constr_2638.
    :ivar ecuc_definition_ref: This association denotes an ECUC
        parameter definition. The such referenced parameters are subject
        of the build action input/output. Note that the reference to the
        definition denotes the right for a build action to read and/or
        write values for the given definition and all contained
        definitions.
    :ivar engineering_object: This represents an artifact applicable to
        the build action.
    :ivar foreign_model_reference: This is a reference to a foreign
        model element. Note that it is not modeled as an association
        because it should also be able to refer also to non AUTOSAR
        models.
    :ivar model_object_reference: This is a reference to a generic model
        element. Note that it is not modeled as an association because
        it should also be able to refer also to non AUTOSAR models.
    :ivar role: This attribute allows to denote a particular role of the
        collection. Note that the applicable semantics shall be mutually
        agreed between the two parties.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUILD-ACTION-IO-ELEMENT"

    category: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdgs: Optional["BuildActionIoElement.Sdgs"] = field(
        default=None,
        metadata={
            "name": "SDGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_definition_ref: Optional["BuildActionIoElement.EcucDefinitionRef"] = field(
        default=None,
        metadata={
            "name": "ECUC-DEFINITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    engineering_object: BuildEngineeringObject | None = field(
        default=None,
        metadata={
            "name": "ENGINEERING-OBJECT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    foreign_model_reference: ForeignModelReference | None = field(
        default=None,
        metadata={
            "name": "FOREIGN-MODEL-REFERENCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    model_object_reference: GenericModelReference | None = field(
        default=None,
        metadata={
            "name": "MODEL-OBJECT-REFERENCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    role: Identifier | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Sdgs:
        sdg: list[Sdg] = field(
            default_factory=list,
            metadata={
                "name": "SDG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcucDefinitionRef(Ref):
        dest: EcucDefinitionElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DataConstrRule:
    """
    This meta-class represents the ability to express one specific data constraint
    rule.

    :ivar constr_level: This attribute describes the category of a
        constraint. One of its functions is in the area of constraint
        violation, where it can be used from a certain level, to produce
        error messages. The lower the level, the more stringent the
        check. Used to distinguish hard or soft limits.
    :ivar phys_constrs: Describes the limitations applicable on the
        physical domain (as opposed to the internal domain).
    :ivar internal_constrs: Describes the limitations applicable on the
        internal domain (as opposed to the physical domain).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-CONSTR-RULE"

    constr_level: Integer | None = field(
        default=None,
        metadata={
            "name": "CONSTR-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    phys_constrs: PhysConstrs | None = field(
        default=None,
        metadata={
            "name": "PHYS-CONSTRS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    internal_constrs: InternalConstrs | None = field(
        default=None,
        metadata={
            "name": "INTERNAL-CONSTRS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class FileInfoComment:
    """
    This class supports StructuredComment to provide auxiliary information with the
    goal to create a comment.

    :ivar sdgs: This property allows to keep special data which is not
        represented by the standard model. It can be utilized to keep
        e.g. tool specific data. This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FILE-INFO-COMMENT"

    sdgs: Optional["FileInfoComment.Sdgs"] = field(
        default=None,
        metadata={
            "name": "SDGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Sdgs:
        sdg: list[Sdg] = field(
            default_factory=list,
            metadata={
                "name": "SDG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SdgContents:
    """This meta-class represents the possible contents of a special data group.

    It can be an arbitrary mix of references, of primitive special data
    and nested special data groups.

    :ivar sdx_ref: Reference to any identifiable element. This allows to
        use Sdg even to establish arbitrary relationships.
    :ivar sdxf: Additional reference with variant support. This property
        was modified due to atpVariation (DirectedAssociationPattern).
    :ivar sd: This is one particular special data element.
    :ivar sdg: This aggregation allows to express nested special data
        groups. By this, any structure can be represented in
        SpeicalData. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar sdf: This is one particular special data element.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SDG-CONTENTS"

    sdx_ref: list["SdgContents.SdxRef"] = field(
        default_factory=list,
        metadata={
            "name": "SDX-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdxf: list[ReferrableRefConditional] = field(
        default_factory=list,
        metadata={
            "name": "SDXF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sd: list[Sd] = field(
        default_factory=list,
        metadata={
            "name": "SD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdg: list[Sdg] = field(
        default_factory=list,
        metadata={
            "name": "SDG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdf: list[Sdf] = field(
        default_factory=list,
        metadata={
            "name": "SDF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SdxRef(Ref):
        dest: ReferrableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwRecordLayoutGroupContent:
    """This is the contents of a RecordLayout which is inserted for every
    iteration.

    Note that since this is atpMixed, multiple properties can be
    inserted for each iteration.

    :ivar sw_record_layout_ref: This association allows to support
        reusable "sub"-record layouts. In particular, the contents of
        the referenced record layout shall be used as if the record
        layout group in the referenced record layout was aggregated in
        the current record layout group. So, semantically it would be
        equivalent to replace the particular association with an
        aggregation of the  swRecordLayoutGroup of the referenced
        SwRecordLayout.
    :ivar sw_record_layout_v: Particular Value specification for this
        record layout group.
    :ivar sw_record_layout_group: This aggregation provides support for
        nested iterations. For example, if a map is to be handled, then
        we might have two nested SwRecordLayoutGroups, one for the
        x-axis and one for the y-axis. The inner iteration runs faster.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-RECORD-LAYOUT-GROUP-CONTENT"

    sw_record_layout_ref: list["SwRecordLayoutGroupContent.SwRecordLayoutRef"] = field(
        default_factory=list,
        metadata={
            "name": "SW-RECORD-LAYOUT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_v: list[SwRecordLayoutV] = field(
        default_factory=list,
        metadata={
            "name": "SW-RECORD-LAYOUT-V",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_group: list[SwRecordLayoutGroup] = field(
        default_factory=list,
        metadata={
            "name": "SW-RECORD-LAYOUT-GROUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SwRecordLayoutRef(Ref):
        dest: SwRecordLayoutSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class VariationPoint:
    """This meta-class represents the ability to express a "structural variation
    point".

    The container of the variation point is part of the selected variant
    if swSyscond evaluates to true and each postBuildVariantCriterion is
    fulfilled.

    :ivar short_label: This provides a name to the particular variation
        point to support the RTE generator. It is necessary for
        supporting splitable aggregations and if binding time is later
        than codeGenerationTime, as well as some RTE conditions. It
        needs to be unique with in the enclosing Identifiables with the
        same ShortName.
    :ivar desc: This allows to describe shortly the purpose of the
        variation point.
    :ivar blueprint_condition: This represents a description that
        documents how the variation point shall be resolved when
        deriving objects from the blueprint. Note that variationPoints
        are not allowed within a blueprintCondition.
    :ivar formal_blueprint_condition: This denotes a formal
        blueprintCondition. This shall be not in contradiction with
        blueprintCondition or formalBlueprintGenerator. It is
        recommended only to use one of the two.
    :ivar formal_blueprint_generator: This represents a description that
        documents how the variation point shall be resolved when
        deriving objects from the blueprint by using ARMQL. Note that
        variationPoints are not allowed within a
        formalBlueprintGenerator.
    :ivar sw_syscond: This condition acts as Binding Function for the
        VariationPoint. Note that the multiplicity is 0..1 in order to
        support pure postBuild variants.
    :ivar post_build_variant_conditions: This is the set of post build
        variant conditions which all  shall be fulfilled in order to
        (postbuild) bind the variation point.
    :ivar sdg: An optional special data group is attached to every
        variation point. These data can be used by external software
        systems to attach application specific data. For example, a
        variant management system might add an identifier, an URL or a
        specific classifier. This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VARIATION-POINT"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_condition: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-CONDITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formal_blueprint_condition: BlueprintFormula | None = field(
        default=None,
        metadata={
            "name": "FORMAL-BLUEPRINT-CONDITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formal_blueprint_generator: BlueprintGenerator | None = field(
        default=None,
        metadata={
            "name": "FORMAL-BLUEPRINT-GENERATOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_syscond: ConditionByFormula | None = field(
        default=None,
        metadata={
            "name": "SW-SYSCOND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_conditions: Optional["VariationPoint.PostBuildVariantConditions"] = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdg: Sdg | None = field(
        default=None,
        metadata={
            "name": "SDG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PostBuildVariantConditions:
        post_build_variant_condition: list[PostBuildVariantCondition] = field(
            default_factory=list,
            metadata={
                "name": "POST-BUILD-VARIANT-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class AbstractClassTailoring:
    """
    Tailoring of abstract classes in the AUTOSAR meta-model.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alternative_name: Alternative name of a specification element
        if its name doesn't fit into the shortName. E.g. because the
        name contains spaces.
    :ivar multiplicity_restriction: Specifies the multiplicity of the
        class in the current context.
    :ivar variation_restriction: Specifies restrictions on the usage of
        variant handling.
    :ivar class_contents: Specifies the accepted / not accepted content
        of the class. All rules apply that fullfill the condition of the
        ClassContentConditional
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ABSTRACT-CLASS-TAILORING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AbstractClassTailoring.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AbstractClassTailoring.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alternative_name: String | None = field(
        default=None,
        metadata={
            "name": "ALTERNATIVE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiplicity_restriction: MultiplicityRestrictionWithSeverity | None = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-RESTRICTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_restriction: VariationRestrictionWithSeverity | None = field(
        default=None,
        metadata={
            "name": "VARIATION-RESTRICTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    class_contents: Optional["AbstractClassTailoring.ClassContents"] = field(
        default=None,
        metadata={
            "name": "CLASS-CONTENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClassContents:
        class_content_conditional: list["ClassContentConditional"] = field(
            default_factory=list,
            metadata={
                "name": "CLASS-CONTENT-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class AccessCount:
    """
    This meta-class provides one count value for a AbstractAccessPoint.

    :ivar access_point_ref: AbstractAccessPoint for which the count
        value is applicable.
    :ivar value: This attribute represents the number of determined
        accesses
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        AccessCountSet.accessCount
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ACCESS-COUNT"

    access_point_ref: Optional["AccessCount.AccessPointRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-POINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AccessPointRef(Ref):
        dest: AbstractAccessPointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AclObjectSet:
    """This meta class represents the ability to denote a set of objects for which roles and rights (access control lists) shall be defined. It basically can define the objects based on
    * the nature of objects
    * the involved blueprints
    * the artifact in which the objects are serialized
    * the definition of the object (in a definition - value pattern)
    * individual reference objects

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar acl_object_classs: This specifies that the considered objects
        as instances of the denoted meta class.
    :ivar acl_scope: this indicates the scope of the referenced objects.
    :ivar collection_ref: This indicates that the relevant objects are
        specified via a collection.
    :ivar derived_from_blueprint_refs: This association indicates that
        the considered objects are the ones being derived from the
        associated blueprint.
    :ivar engineering_objects: This indicates an engineering object. The
        AclPermission relates to all objects in this partial model. This
        also implies that the other objects in this set shall be placed
        in the specified engineering object. Note that semantic
        constraints apply with respect to &lt;&lt;atpSplitable&gt;&gt;
    :ivar object_definition_refs: This denotes an object by its
        definition. For example the right to manipulate the value of a
        particular ecuc parameter is denoted by reference to the
        definition of the parameter. Note that this can also be a
        reference to a Standard Module Definition. Therefore it is
        stereotyped by atpUriDef.
    :ivar object_defintion_refs: Due to miss spell, this element was set
        to obsolete. use instead: objectDefinition.
    :ivar object_refs: This association applies a particular (usually
        small) set of objects (e.g. a singular package). Main usage is,
        if one does not want to create a collection specifically for
        access control.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ACL-OBJECT-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AclObjectSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AclObjectSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["AclObjectSet.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    acl_object_classs: Optional["AclObjectSet.AclObjectClasss"] = field(
        default=None,
        metadata={
            "name": "ACL-OBJECT-CLASSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    acl_scope: AclScopeEnum | None = field(
        default=None,
        metadata={
            "name": "ACL-SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    collection_ref: Optional["AclObjectSet.CollectionRef"] = field(
        default=None,
        metadata={
            "name": "COLLECTION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    derived_from_blueprint_refs: Optional["AclObjectSet.DerivedFromBlueprintRefs"] = field(
        default=None,
        metadata={
            "name": "DERIVED-FROM-BLUEPRINT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    engineering_objects: Optional["AclObjectSet.EngineeringObjects"] = field(
        default=None,
        metadata={
            "name": "ENGINEERING-OBJECTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    object_definition_refs: Optional["AclObjectSet.ObjectDefinitionRefs"] = field(
        default=None,
        metadata={
            "name": "OBJECT-DEFINITION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    object_defintion_refs: Optional["AclObjectSet.ObjectDefintionRefs"] = field(
        default=None,
        metadata={
            "name": "OBJECT-DEFINTION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    object_refs: Optional["AclObjectSet.ObjectRefs"] = field(
        default=None,
        metadata={
            "name": "OBJECT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AclObjectClasss:
        acl_object_class: list[ReferrableSubtypesEnum] = field(
            default_factory=list,
            metadata={
                "name": "ACL-OBJECT-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CollectionRef(Ref):
        dest: CollectionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DerivedFromBlueprintRefs:
        derived_from_blueprint_ref: list[
            "AclObjectSet.DerivedFromBlueprintRefs.DerivedFromBlueprintRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DERIVED-FROM-BLUEPRINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DerivedFromBlueprintRef(Ref):
            dest: AtpBlueprintSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class EngineeringObjects:
        autosar_engineering_object: list[AutosarEngineeringObject] = field(
            default_factory=list,
            metadata={
                "name": "AUTOSAR-ENGINEERING-OBJECT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ObjectDefinitionRefs:
        object_definition_ref: list["AclObjectSet.ObjectDefinitionRefs.ObjectDefinitionRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "OBJECT-DEFINITION-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class ObjectDefinitionRef(Ref):
            dest: AtpDefinitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ObjectDefintionRefs:
        object_defintion_ref: list["AclObjectSet.ObjectDefintionRefs.ObjectDefintionRef"] = field(
            default_factory=list,
            metadata={
                "name": "OBJECT-DEFINTION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ObjectDefintionRef(Ref):
            dest: AtpDefinitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ObjectRefs:
        object_ref: list["AclObjectSet.ObjectRefs.ObjectRef"] = field(
            default_factory=list,
            metadata={
                "name": "OBJECT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ObjectRef(Ref):
            dest: ReferrableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class AclOperation:
    """
    This meta class represents the ability to denote a particular operation which
    may be performed on objects in an AUTOSAR model.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar implied_operation_refs: This indicates that the related
        operations are also implied. Therefore the permission is also
        granted for this operation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ACL-OPERATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AclOperation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AclOperation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["AclOperation.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implied_operation_refs: Optional["AclOperation.ImpliedOperationRefs"] = field(
        default=None,
        metadata={
            "name": "IMPLIED-OPERATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImpliedOperationRefs:
        implied_operation_ref: list["AclOperation.ImpliedOperationRefs.ImpliedOperationRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "IMPLIED-OPERATION-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class ImpliedOperationRef(Ref):
            dest: AclOperationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class AclPermission:
    """
    This meta class represents the ability to represent permissions granted on
    objects in an AUTOSAR model.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar acl_contexts: This attribute is intended to specify the
        context under which the AclPemission is applicable. The values
        are subject to mutual agreement between the involved
        stakeholders. For examples the values can be the names of
        binding times.
    :ivar acl_object_refs: This denotes an object to which the
        AclPermission applies.
    :ivar acl_operation_refs: This denotes an operation which is granted
        by the given AclPermission.
    :ivar acl_role_refs: This denotes the role (individual or even
        organization) for which the AclPermission. is granted.
    :ivar acl_scope: This indicates the scope of applied permissions:
        explicit, descendant, dependent;
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ACL-PERMISSION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AclPermission.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AclPermission.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["AclPermission.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    acl_contexts: Optional["AclPermission.AclContexts"] = field(
        default=None,
        metadata={
            "name": "ACL-CONTEXTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    acl_object_refs: Optional["AclPermission.AclObjectRefs"] = field(
        default=None,
        metadata={
            "name": "ACL-OBJECT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    acl_operation_refs: Optional["AclPermission.AclOperationRefs"] = field(
        default=None,
        metadata={
            "name": "ACL-OPERATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    acl_role_refs: Optional["AclPermission.AclRoleRefs"] = field(
        default=None,
        metadata={
            "name": "ACL-ROLE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    acl_scope: AclScopeEnum | None = field(
        default=None,
        metadata={
            "name": "ACL-SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AclContexts:
        acl_context: list[NmtokenString] = field(
            default_factory=list,
            metadata={
                "name": "ACL-CONTEXT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AclObjectRefs:
        acl_object_ref: list["AclPermission.AclObjectRefs.AclObjectRef"] = field(
            default_factory=list,
            metadata={
                "name": "ACL-OBJECT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class AclObjectRef(Ref):
            dest: AclObjectSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class AclOperationRefs:
        acl_operation_ref: list["AclPermission.AclOperationRefs.AclOperationRef"] = field(
            default_factory=list,
            metadata={
                "name": "ACL-OPERATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class AclOperationRef(Ref):
            dest: AclOperationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class AclRoleRefs:
        acl_role_ref: list["AclPermission.AclRoleRefs.AclRoleRef"] = field(
            default_factory=list,
            metadata={
                "name": "ACL-ROLE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class AclRoleRef(Ref):
            dest: AclRoleSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class AclRole:
    """This meta class represents the ability to specify a particular role which is
    used to grant access rights to AUTOSAR model.

    The purpose of this meta-class is to support the mutual agreements
    between the involved parties.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar ldap_url: This is an URL which allows to represent users or
        organizations taking the particular role.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ACL-ROLE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AclRole.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AclRole.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["AclRole.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ldap_url: UriString | None = field(
        default=None,
        metadata={
            "name": "LDAP-URL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class AdaptiveFirewallModuleInstantiation:
    """
    This meta-class defines the attributes for the Firewall configuration on a
    specific machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar state_dependent_firewall_ref: Firewall rules that are defined
        in a firewall state
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ADAPTIVE-FIREWALL-MODULE-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AdaptiveFirewallModuleInstantiation.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AdaptiveFirewallModuleInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    state_dependent_firewall_ref: Optional[
        "AdaptiveFirewallModuleInstantiation.StateDependentFirewallRef"
    ] = field(
        default=None,
        metadata={
            "name": "STATE-DEPENDENT-FIREWALL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StateDependentFirewallRef(Ref):
        dest: StateDependentFirewallSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AdaptiveFirewallToPortPrototypeMapping:
    """
    This meta-class maps the AdaptiveFirewall moduleInstantiation to the
    RPortPrototype that is typed by a FirewallModeSwitchInterface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar firewall_ref: Reference to the Firewall module
    :ivar r_port_prototype_ref: Reference to RPortPrototype typed by a
        FirewallModeSwitchInterface
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ADAPTIVE-FIREWALL-TO-PORT-PROTOTYPE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AdaptiveFirewallToPortPrototypeMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AdaptiveFirewallToPortPrototypeMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    firewall_ref: Optional["AdaptiveFirewallToPortPrototypeMapping.FirewallRef"] = field(
        default=None,
        metadata={
            "name": "FIREWALL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    r_port_prototype_ref: Optional["AdaptiveFirewallToPortPrototypeMapping.RPortPrototypeRef"] = (
        field(
            default=None,
            metadata={
                "name": "R-PORT-PROTOTYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FirewallRef(Ref):
        dest: AdaptiveFirewallModuleInstantiationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RPortPrototypeRef(Ref):
        dest: RPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AgeConstraint:
    """The AgeConstraint is used to impose a constraint on an Timing Description
    Event referenced by the scope.

    A minimum and a maximum age can be specified.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar timing_condition_ref: A timing condition the timing constraint
        depends on. In other words it specifies the condition the timing
        constraint holds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingRequirement Applicable for:
        TimingExtension.timingGuarantee
    :ivar maximum: The maximum age.
    :ivar minimum: The minimum age.
    :ivar scope_ref: The scope of an AgeConstraint is any
        TimingDescriptionEvent that indicates any receipt of data.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AGE-CONSTRAINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AgeConstraint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AgeConstraint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["AgeConstraint.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_condition_ref: Optional["AgeConstraint.TimingConditionRef"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MINIMUM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope_ref: Optional["AgeConstraint.ScopeRef"] = field(
        default=None,
        metadata={
            "name": "SCOPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["AgeConstraint.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimingConditionRef(Ref):
        dest: TimingConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ScopeRef(Ref):
        dest: TimingDescriptionEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AliasNameAssignment:
    """This meta-class represents the ability to associate an alternative name to a
    flat representations or an Identifiable.

    The usage of this name is defined outside of AUTOSAR. For example
    this name can be used by MCD tools or as a name for component
    instances in the ECU extract. Note that flatInstance and
    identifiable are mutually exclusive.

    :ivar short_label: This attribute represents the alias name. It is
        modeled as string because the alias name is used outside of
        AUTOSAR and therefore no naming conventions can be applied
        within AUTOSAR.
    :ivar label: This represents an "Alias LongName".
    :ivar identifiable_ref: Assignment of a unique name to an
        Identifiable.
    :ivar flat_instance_ref: Assignment of a unique name to a flat
        representation.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: AliasNameSet.aliasName
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ALIAS-NAME-ASSIGNMENT"

    short_label: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    label: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    identifiable_ref: Optional["AliasNameAssignment.IdentifiableRef"] = field(
        default=None,
        metadata={
            "name": "IDENTIFIABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    flat_instance_ref: Optional["AliasNameAssignment.FlatInstanceRef"] = field(
        default=None,
        metadata={
            "name": "FLAT-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class IdentifiableRef(Ref):
        dest: IdentifiableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FlatInstanceRef(Ref):
        dest: FlatInstanceDescriptorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AliveSupervision:
    """
    Defines an AliveSupervision for one checkpoint.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alive_reference_cycle: Time period at which the Alive
        Supervision mechanism compares the amount of received Alive
        Indications for the SupervisionCheckpoint against the
        expectedAliveIndications.
    :ivar checkpoint_ref: Reference to a checkpoint in the context of
        AliveSupervision.
    :ivar expected_alive_indications: Defines the amount of expected
        Alive Indications of the SupervisionCheckpoint within the
        aliveReferenceCycle.
    :ivar failed_reference_cycles_tolerance: This attribute defines the
        acceptable amount of aliveReferenceCycles with incorrect/failed
        AliveSupervision.
    :ivar max_margin: Defines the amount of Alive Indications of the
        SupervisionCheckpoint that are acceptable to be additional to
        the expectedAliveIndications within the aliveReferenceCycle.
    :ivar min_margin: Defines the amount of Alive Indications of the
        SupervisionCheckpoint that are acceptable to be missing to the
        expectedAliveIndications within the aliveReferenceCycle.
    :ivar terminating_checkpoint_ref: Reference to the
        SupervisionCheckpoint which is defined as the terminating
        checkpoint of this AliveSupervision.
    :ivar terminating_checkpoint_timeout_until_termination: Defines the
        time a process shall terminate after it has announced its start
        of  termination by reporting terminatingCheckpoint.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ALIVE-SUPERVISION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AliveSupervision.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AliveSupervision.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alive_reference_cycle: TimeValue | None = field(
        default=None,
        metadata={
            "name": "ALIVE-REFERENCE-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    checkpoint_ref: Optional["AliveSupervision.CheckpointRef"] = field(
        default=None,
        metadata={
            "name": "CHECKPOINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    expected_alive_indications: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "EXPECTED-ALIVE-INDICATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    failed_reference_cycles_tolerance: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FAILED-REFERENCE-CYCLES-TOLERANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_margin: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-MARGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_margin: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-MARGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    terminating_checkpoint_ref: Optional["AliveSupervision.TerminatingCheckpointRef"] = field(
        default=None,
        metadata={
            "name": "TERMINATING-CHECKPOINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    terminating_checkpoint_timeout_until_termination: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TERMINATING-CHECKPOINT-TIMEOUT-UNTIL-TERMINATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CheckpointRef(Ref):
        dest: SupervisionCheckpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TerminatingCheckpointRef(Ref):
        dest: SupervisionCheckpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Allocator:
    """This meta-class represents the ability to specify an optional custom C++
    allocator for a C++ type which may dynamically grow beyond it's initial
    allocated size during it's lifetime.

    Any storage principles are defined in the implementation of the allocator itself, which should implement the ISO C++ std::allocator_traits interface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar header_file: Configuration of the Header File with the custom
        class declaration
    :ivar namespaces: This aggregation allows for the definition of a
        namespace of an Allocator.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ALLOCATOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Allocator.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Allocator.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    header_file: String | None = field(
        default=None,
        metadata={
            "name": "HEADER-FILE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["Allocator.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class AnalyzedExecutionTime:
    """
    AnalyzedExecutionTime provides an analytic method for specifying the best and
    worst case execution time.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar exclusive_area_ref: Reference to the ExclusiveArea this
        execution time is provided for.
    :ivar executable_entity_ref: The executable entity for which this
        execution time is described.
    :ivar hardware_configuration: Provides information on the
        HardwareConfiguration used to specify this ExecutionTime.
    :ivar hw_element_ref: The hardware element (e.g. type of ECU) for
        which the execution time is specified.
    :ivar included_library_refs: If this dependency is specified, the
        execution time of the library code is included in the execution
        time data for the runnable.
    :ivar memory_section_locations: Provides information on the
        MemorySectionLocation which is involved in the ExecutionTime
        description.
    :ivar software_context: Provides information on the detailed
        SoftwareContext used to provide the ExecutionTime description.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ResourceConsumption.executionTime
    :ivar best_case_execution_time: The best case execution time (BCET)
        defines the minimum amount of time the related executable entity
        requires for its execution.
    :ivar worst_case_execution_time: The worst case execution time
        (WCET) defines the maximum amount of time the related executable
        entity requires for its execution.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ANALYZED-EXECUTION-TIME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AnalyzedExecutionTime.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AnalyzedExecutionTime.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_area_ref: Optional["AnalyzedExecutionTime.ExclusiveAreaRef"] = field(
        default=None,
        metadata={
            "name": "EXCLUSIVE-AREA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    executable_entity_ref: Optional["AnalyzedExecutionTime.ExecutableEntityRef"] = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-ENTITY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hardware_configuration: HardwareConfiguration | None = field(
        default=None,
        metadata={
            "name": "HARDWARE-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_element_ref: Optional["AnalyzedExecutionTime.HwElementRef"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    included_library_refs: Optional["AnalyzedExecutionTime.IncludedLibraryRefs"] = field(
        default=None,
        metadata={
            "name": "INCLUDED-LIBRARY-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_section_locations: Optional["AnalyzedExecutionTime.MemorySectionLocations"] = field(
        default=None,
        metadata={
            "name": "MEMORY-SECTION-LOCATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_context: SoftwareContext | None = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CONTEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    best_case_execution_time: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "BEST-CASE-EXECUTION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    worst_case_execution_time: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "WORST-CASE-EXECUTION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaRef(Ref):
        dest: ExclusiveAreaSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutableEntityRef(Ref):
        dest: ExecutableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class HwElementRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IncludedLibraryRefs:
        included_library_ref: list[
            "AnalyzedExecutionTime.IncludedLibraryRefs.IncludedLibraryRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "INCLUDED-LIBRARY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class IncludedLibraryRef(Ref):
            dest: DependencyOnArtifactSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class MemorySectionLocations:
        memory_section_location: list[MemorySectionLocation] = field(
            default_factory=list,
            metadata={
                "name": "MEMORY-SECTION-LOCATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class AnyInstanceRef:
    """Describes a reference to any instance in an AUTOSAR model.

    This is the most generic form of an instance ref. Refer to the
    superclass notes for more details.

    :ivar context_element_ref: This is one step in the navigation path
        specified by the instance ref.
    :ivar target_ref: This is the target of the instance ref.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RptContainer.byPassPoint Not Applicable for:
        Collection.sourceInstance Not Applicable for:
        Collection.collectedInstance Not Applicable for:
        DocumentationContext.feature Not Applicable for:
        ViewMap.secondElementInstance Not Applicable for:
        ViewMap.firstElementInstance Not Applicable for:
        FlatInstanceDescriptor.upstreamReference Not Applicable for:
        FlatInstanceDescriptor.ecuExtractReference Not Applicable for:
        RptHook.rptArHook Not Applicable for:
        EcucInstanceReferenceValue.value
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ANY-INSTANCE-REF"

    context_element_ref: list["AnyInstanceRef.ContextElementRef"] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_ref: Optional["AnyInstanceRef.TargetRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextElementRef(Ref):
        dest: AtpFeatureSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRef(Ref):
        dest: AtpFeatureSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ApApplicationEndpoint:
    """
    An application endpoint is the endpoint on an Ecu in terms of application
    addressing (e.g. UDP or TCP Port).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar priority: This attribute defines the VLAN frame priority where
        values from 0 (best effort) to 7 (highest) are allowed.
    :ivar tp_configuration: Configuration of the used transport
        protocol.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AP-APPLICATION-ENDPOINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApApplicationEndpoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApApplicationEndpoint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_configuration: Optional["ApApplicationEndpoint.TpConfiguration"] = field(
        default=None,
        metadata={
            "name": "TP-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpConfiguration:
        tcp_tp: TcpTp | None = field(
            default=None,
            metadata={
                "name": "TCP-TP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        udp_tp: UdpTp | None = field(
            default=None,
            metadata={
                "name": "UDP-TP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApApplicationError:
    """
    This meta-class represents the ability to formally specify the semantics of an
    application error on the AUTOSAR adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar error_code: This attribute has the ability to specify the
        error code value within the enclosing
        AdaptivePlatformApplicationError.
    :ivar error_domain_ref: This reference represents the error domain
        of the ApApplicationError.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AP-APPLICATION-ERROR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApApplicationError.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApApplicationError.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    error_code: Integer | None = field(
        default=None,
        metadata={
            "name": "ERROR-CODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    error_domain_ref: Optional["ApApplicationError.ErrorDomainRef"] = field(
        default=None,
        metadata={
            "name": "ERROR-DOMAIN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ErrorDomainRef(Ref):
        dest: ApApplicationErrorDomainSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ApApplicationErrorDomain:
    """
    This meta-class represents the ability to define a global error domain for an
    ApApplicationError.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar namespaces: This aggregation defines the namespace of the
        ApApplicationErrorDomain
    :ivar value: This attribute identifies the error category.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AP-APPLICATION-ERROR-DOMAIN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApApplicationErrorDomain.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApApplicationErrorDomain.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["ApApplicationErrorDomain.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApApplicationErrorSet:
    """This meta-class acts as a reference target that represents an entire
    collection of APApplicationErrors.

    This takes the burden from ClientServerOperations that reference a
    larger number of ApApplicationErrors.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar ap_application_error_refs: This reference represents the
        collection of ApApplicationError represented by the enclosing
        ApApplicationErrorSet
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AP-APPLICATION-ERROR-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApApplicationErrorSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApApplicationErrorSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ap_application_error_refs: Optional["ApApplicationErrorSet.ApApplicationErrorRefs"] = field(
        default=None,
        metadata={
            "name": "AP-APPLICATION-ERROR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ApApplicationErrorRefs:
        ap_application_error_ref: list[
            "ApApplicationErrorSet.ApApplicationErrorRefs.ApApplicationErrorRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "AP-APPLICATION-ERROR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ApApplicationErrorRef(Ref):
            dest: ApApplicationErrorSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class ApSomeipTransformationProps:
    """
    SOME/IP serialization properties.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alignment: Defines the padding for alignment purposes that
        will be added by the SOME/IP transformer after the serialized
        data of the variable data length data element. The alignment
        shall be specified in Bits.
    :ivar byte_order: Specifies the byte order of data in the serialized
        data stream.
    :ivar implements_legacy_string_serialization: This attribute
        indicates that Strings in the SOME/IP message shall NOT be
        serialized according to the SOME/IP specification for Strings.
        If this attribute is set to true, BOM and null-termination shall
        NOT be added in the serialization for Strings in the payload. If
        this attribute is set to false (or not set)  BOM and null-
        termination shall be added in the serialization for Strings in
        the payload according to the SOME/IP specification for Strings.
        NOTE! This attribute is not future safe, and will be removed in
        an upcoming AUTOSAR release!
    :ivar is_dynamic_length_field_size: This attribute represents the
        ability to control the setting of the wire type for TLV
        encoding. If the attribute is set to True then wire type 5-7
        shall be used. If the attribute does not exist or is set to
        False then wire type 4 shall be used.
    :ivar session_handling: Defines whether the SOME/IP transformer
        shall use session handling for Sender/Receiver communication.
    :ivar size_of_array_length_field: Configures the SOME/IP
        serialization for the referenced dataPrototype in case of a
        variable size Array (Vector), fixed-size Array or an
        Associative_Map. It describes the size of the length field (in
        Bytes) that will be put in front of the Array or Associative_Map
        in the SOME/IP message.
    :ivar size_of_string_length_field: Configures the SOME/IP
        serialization for the referenced dataPrototype in case of a
        String. It describes the size of the length field (in Bytes)
        that will be put in front of the String in the SOME/IP message.
    :ivar size_of_struct_length_field: Configures the SOME/IP
        serialization for the referenced dataPrototype in case of an
        Struct. It describes the size of the length field (in Bytes)
        that will be put in front of the Struct in the SOME/IP message.
    :ivar size_of_union_length_field: Configures the SOME/IP
        serialization for the referenced dataPrototype in case of a
        Union. It describes the size of the length field (in Bytes) that
        will be put in front of the Union in the SOME/IP message.
    :ivar size_of_union_type_selector_field: Configures the SOME/IP
        serialization for the referenced dataPrototype in case of a
        Union. It describes the size of the type selector field (in
        Bytes) that will be put in front of the Union in the SOME/IP
        message.
    :ivar string_encoding: Configures the encoding for SOME/IP
        serialization for the referenced dataPrototype in case of an
        String.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AP-SOMEIP-TRANSFORMATION-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApSomeipTransformationProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApSomeipTransformationProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alignment: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ALIGNMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    byte_order: ByteOrderEnum | None = field(
        default=None,
        metadata={
            "name": "BYTE-ORDER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implements_legacy_string_serialization: Boolean | None = field(
        default=None,
        metadata={
            "name": "IMPLEMENTS-LEGACY-STRING-SERIALIZATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_dynamic_length_field_size: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-DYNAMIC-LENGTH-FIELD-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    session_handling: SomeipTransformerSessionHandlingEnum | None = field(
        default=None,
        metadata={
            "name": "SESSION-HANDLING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size_of_array_length_field: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE-OF-ARRAY-LENGTH-FIELD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size_of_string_length_field: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE-OF-STRING-LENGTH-FIELD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size_of_struct_length_field: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE-OF-STRUCT-LENGTH-FIELD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size_of_union_length_field: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE-OF-UNION-LENGTH-FIELD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size_of_union_type_selector_field: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE-OF-UNION-TYPE-SELECTOR-FIELD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    string_encoding: BaseTypeEncodingString | None = field(
        default=None,
        metadata={
            "name": "STRING-ENCODING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class AppOsTaskProxyToEcuTaskProxyMapping:
    """
    This meta-class is used to map an OsTaskProxy that was created in the context
    of a SwComponent to an OsTaskProxy that was created in the context of an Ecu.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar app_task_proxy_ref: Reference to an OsTaskProxy that is
        created in the context of a SwComponent.
    :ivar ecu_task_proxy_ref: Reference to an OsTaskProxy that is
        created in the context of an EcuInstance.
    :ivar offset: This attribute is used to describe the position of the
        appTaskProxy in an ecuTaskProxy as a relative value, i.e. the
        values show only the relative position of the appTaskProxy in
        the ecuTaskProxy.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APP-OS-TASK-PROXY-TO-ECU-TASK-PROXY-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AppOsTaskProxyToEcuTaskProxyMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AppOsTaskProxyToEcuTaskProxyMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    app_task_proxy_ref: Optional["AppOsTaskProxyToEcuTaskProxyMapping.AppTaskProxyRef"] = field(
        default=None,
        metadata={
            "name": "APP-TASK-PROXY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_task_proxy_ref: Optional["AppOsTaskProxyToEcuTaskProxyMapping.EcuTaskProxyRef"] = field(
        default=None,
        metadata={
            "name": "ECU-TASK-PROXY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offset: Integer | None = field(
        default=None,
        metadata={
            "name": "OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AppTaskProxyRef(Ref):
        dest: OsTaskProxySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuTaskProxyRef(Ref):
        dest: OsTaskProxySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ApplicationArrayElement:
    """
    Describes the properties of the elements of an application array data type.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sw_data_def_props: This property allows to specify data
        definition properties which apply on data prototype level.
    :ivar type_tref: This represents the corresponding data type.
    :ivar array_size_handling: The way how the size of the array is
        handled.
    :ivar array_size_semantics: This attribute controls how the
        information about the array size shall be interpreted.
    :ivar index_data_type_ref: This reference can be taken to assign a
        CompuMethod of category TEXTTABLE  to the array. The texttable
        entries associate a textual value to an index number such that
        the element with that index number is represented by a symbolic
        name.
    :ivar max_number_of_elements: The maximum number of elements that
        the array can contain.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-ARRAY-ELEMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApplicationArrayElement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApplicationArrayElement.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_tref: Optional["ApplicationArrayElement.TypeTref"] = field(
        default=None,
        metadata={
            "name": "TYPE-TREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    array_size_handling: ArraySizeHandlingEnum | None = field(
        default=None,
        metadata={
            "name": "ARRAY-SIZE-HANDLING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    array_size_semantics: ArraySizeSemanticsEnum | None = field(
        default=None,
        metadata={
            "name": "ARRAY-SIZE-SEMANTICS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    index_data_type_ref: Optional["ApplicationArrayElement.IndexDataTypeRef"] = field(
        default=None,
        metadata={
            "name": "INDEX-DATA-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_elements: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TypeTref(Ref):
        dest: ApplicationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IndexDataTypeRef(Ref):
        dest: ApplicationPrimitiveDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ApplicationAssocMapElement:
    """
    Describes the properties of the elements of an application map data type.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sw_data_def_props: This property allows to specify data
        definition properties which apply on data prototype level.
    :ivar type_tref: This represents the corresponding data type.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-ASSOC-MAP-ELEMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApplicationAssocMapElement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApplicationAssocMapElement.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_tref: Optional["ApplicationAssocMapElement.TypeTref"] = field(
        default=None,
        metadata={
            "name": "TYPE-TREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TypeTref(Ref):
        dest: ApplicationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ApplicationCompositeDataTypeSubElementRef:
    """
    This meta-class represents the specialization of SubElementMapping with respect
    to ApplicationCompositeDataTypes.

    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SubElementMapping.secondElement Applicable for:
        SubElementMapping.firstElement
    :ivar application_composite_element_iref: This represents the
        referenced ApplicationCompositeDataPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-COMPOSITE-DATA-TYPE-SUB-ELEMENT-REF"

    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_composite_element_iref: (
        ApplicationCompositeElementInPortInterfaceInstanceRef | None
    ) = field(
        default=None,
        metadata={
            "name": "APPLICATION-COMPOSITE-ELEMENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ApplicationDeferredDataType:
    """
    An placeholder data type in which the precise application data type is deferred
    to a later stage.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar sw_data_def_props: The properties of this AutosarDataType.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-DEFERRED-DATA-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApplicationDeferredDataType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApplicationDeferredDataType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ApplicationDeferredDataType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApplicationEndpointRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar application_endpoint_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-ENDPOINT-REF-CONDITIONAL"

    application_endpoint_ref: Optional[
        "ApplicationEndpointRefConditional.ApplicationEndpointRef"
    ] = field(
        default=None,
        metadata={
            "name": "APPLICATION-ENDPOINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ApplicationEndpointRef(Ref):
        dest: ApplicationEndpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ApplicationError:
    """This is a user-defined error that is associated with an element of an
    AUTOSAR interface.

    It is specific for the particular functionality or service provided
    by the AUTOSAR software component.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar error_code: The RTE generator is forced to assign this value
        to the corresponding error symbol. Note that for error codes
        certain ranges are predefined (see RTE specification).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-ERROR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApplicationError.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApplicationError.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    error_code: Integer | None = field(
        default=None,
        metadata={
            "name": "ERROR-CODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApplicationPartition:
    """ApplicationPartition to which SwComponentPrototypes are mapped at a point in
    time when the corresponding EcuInstance is not yet known or defined.

    In a later methodology step the ApplicationPartition can be assigned
    to an EcuPartition.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-PARTITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApplicationPartition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApplicationPartition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApplicationPartitionToEcuPartitionMapping:
    """Maps ApplicationPartitions to EcuPartitions.

    With this mapping an OEM has the option to predefine an allocation
    of Software Components to EcuPartitions in the System Design phase.
    The final and complete assignment is described in the OS
    Configuration.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar application_partition_refs: Reference to ApplicationPartitions
        that are mapped to an EcuPartition.
    :ivar ecu_partition_ref: Reference to EcuPartition to which the
        ApplicationPartitions are assigned.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.applicationPartitionToEcuPartitionMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-PARTITION-TO-ECU-PARTITION-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "ApplicationPartitionToEcuPartitionMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApplicationPartitionToEcuPartitionMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_partition_refs: Optional[
        "ApplicationPartitionToEcuPartitionMapping.ApplicationPartitionRefs"
    ] = field(
        default=None,
        metadata={
            "name": "APPLICATION-PARTITION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_partition_ref: Optional["ApplicationPartitionToEcuPartitionMapping.EcuPartitionRef"] = (
        field(
            default=None,
            metadata={
                "name": "ECU-PARTITION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ApplicationPartitionRefs:
        application_partition_ref: list[
            "ApplicationPartitionToEcuPartitionMapping.ApplicationPartitionRefs.ApplicationPartitionRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-PARTITION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ApplicationPartitionRef(Ref):
            dest: ApplicationPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class EcuPartitionRef(Ref):
        dest: EcuPartitionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ApplicationPrimitiveDataType:
    """
    A primitive data type defines a set of allowed values.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar sw_data_def_props: The properties of this AutosarDataType.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-PRIMITIVE-DATA-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApplicationPrimitiveDataType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApplicationPrimitiveDataType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ApplicationPrimitiveDataType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApplicationRecordElement:
    """
    Describes the properties of one particular element of an application record
    data type.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sw_data_def_props: This property allows to specify data
        definition properties which apply on data prototype level.
    :ivar type_tref: This represents the corresponding data type.
    :ivar is_optional: This attribute represents the ability to declare
        the enclosing ApplicationRecordElement as optional. This means
        the that, at runtime, the ApplicationRecordElement may or may
        not have a valid value and shall therefore be ignored. The
        underlying runtime software provides means to set the
        ApplicationRecordElement as not valid at the sending end of a
        communication and determine its validity at the receiving end.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ApplicationRecordDataType.element
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-RECORD-ELEMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApplicationRecordElement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApplicationRecordElement.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_tref: Optional["ApplicationRecordElement.TypeTref"] = field(
        default=None,
        metadata={
            "name": "TYPE-TREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_optional: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-OPTIONAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TypeTref(Ref):
        dest: ApplicationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ArbitraryEventTriggering:
    """The ArbitraryEventTriggering describes that an event occurs occasionally,
    singly, irregularly or randomly.

    The primary purpose of this event triggering is to abstract event
    occurrences captured by data acquisition tools (background debugger,
    trace analyzer, etc.) during system runtime.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar timing_condition_ref: A timing condition the timing constraint
        depends on. In other words it specifies the condition the timing
        constraint holds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingRequirement Applicable for:
        TimingExtension.timingGuarantee
    :ivar event_ref: The referenced timing event
    :ivar minimum_distances: The nth array element describes the minimum
        distance that can be observed for a sample of n+1 event
        occurrences. This is an array with an identical number of
        elements as for the maximumDistance.
    :ivar maximum_distances: The nth array element describes the maximum
        distance that can be observed for a sample of n+1 event
        occurrences. This is an array with an identical number of
        elements as for the minimumDistance.
    :ivar confidence_intervals: List of confidence intervals.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ARBITRARY-EVENT-TRIGGERING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ArbitraryEventTriggering.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ArbitraryEventTriggering.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["ArbitraryEventTriggering.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_condition_ref: Optional["ArbitraryEventTriggering.TimingConditionRef"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["ArbitraryEventTriggering.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_distances: Optional["ArbitraryEventTriggering.MinimumDistances"] = field(
        default=None,
        metadata={
            "name": "MINIMUM-DISTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_distances: Optional["ArbitraryEventTriggering.MaximumDistances"] = field(
        default=None,
        metadata={
            "name": "MAXIMUM-DISTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    confidence_intervals: Optional["ArbitraryEventTriggering.ConfidenceIntervals"] = field(
        default=None,
        metadata={
            "name": "CONFIDENCE-INTERVALS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["ArbitraryEventTriggering.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimingConditionRef(Ref):
        dest: TimingConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: TimingDescriptionEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MinimumDistances:
        time_value: list[MultidimensionalTime] = field(
            default_factory=list,
            metadata={
                "name": "TIME-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MaximumDistances:
        time_value: list[MultidimensionalTime] = field(
            default_factory=list,
            metadata={
                "name": "TIME-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConfidenceIntervals:
        confidence_interval: list[ConfidenceInterval] = field(
            default_factory=list,
            metadata={
                "name": "CONFIDENCE-INTERVAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ArtifactChecksum:
    """
    This meta-class provides the ability to associate a checksum with a given
    artifact identified by its URI.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar checksum_value: This attributes carries the serialized
        checksum of the corresponding artifact.
    :ivar uri: This attribute represents the URI of the artifact on
        which the checksum shall be computed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ARTIFACT-CHECKSUM"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ArtifactChecksum.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ArtifactChecksum.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    checksum_value: String | None = field(
        default=None,
        metadata={
            "name": "CHECKSUM-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uri: UriString | None = field(
        default=None,
        metadata={
            "name": "URI",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ArtifactChecksumToCryptoProviderMapping:
    """
    This meta-class provides the ability to associate a CryptoProvider with a
    collection of the checksums computed for artifacts.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar artifact_checksum_refs: This reference identifies the
        collection of ArtifactChecksums associated with the
        corresponding CryptoProvider.
    :ivar crypto_provider_ref: This reference identifies the applicable
        CryptoProvider.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ARTIFACT-CHECKSUM-TO-CRYPTO-PROVIDER-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ArtifactChecksumToCryptoProviderMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ArtifactChecksumToCryptoProviderMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    artifact_checksum_refs: Optional[
        "ArtifactChecksumToCryptoProviderMapping.ArtifactChecksumRefs"
    ] = field(
        default=None,
        metadata={
            "name": "ARTIFACT-CHECKSUM-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_provider_ref: Optional["ArtifactChecksumToCryptoProviderMapping.CryptoProviderRef"] = (
        field(
            default=None,
            metadata={
                "name": "CRYPTO-PROVIDER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ArtifactChecksumRefs:
        artifact_checksum_ref: list[
            "ArtifactChecksumToCryptoProviderMapping.ArtifactChecksumRefs.ArtifactChecksumRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "ARTIFACT-CHECKSUM-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ArtifactChecksumRef(Ref):
            dest: ArtifactChecksumSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class CryptoProviderRef(Ref):
        dest: CryptoProviderSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ArtifactLocator:
    """
    This meta-class has the ability to define the location of an artifact that is
    represented by a model element, e.g. Executable.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar represented_model_element_ref: This reference identifies the
        model element that is represented by the artifact.
    :ivar uri: This attribute describes the location of the artifact.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ARTIFACT-LOCATOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ArtifactLocator.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ArtifactLocator.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    represented_model_element_ref: Optional["ArtifactLocator.RepresentedModelElementRef"] = field(
        default=None,
        metadata={
            "name": "REPRESENTED-MODEL-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uri: String | None = field(
        default=None,
        metadata={
            "name": "URI",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RepresentedModelElementRef(Ref):
        dest: IdentifiableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AssemblySwConnector:
    """
    AssemblySwConnectors are exclusively used to connect SwComponentPrototypes in
    the context of a CompositionSwComponentType.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar mapping_ref: Reference to a PortInterfaceMapping specifying
        the mapping of unequal named PortInterface elements of the two
        different PortInterfaces typing the two PortPrototypes which are
        referenced by the ConnectorPrototype.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CompositionSwComponentType.connector
    :ivar provider_iref: Instance of providing port.
    :ivar requester_iref: Instance of requiring port.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ASSEMBLY-SW-CONNECTOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AssemblySwConnector.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AssemblySwConnector.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapping_ref: Optional["AssemblySwConnector.MappingRef"] = field(
        default=None,
        metadata={
            "name": "MAPPING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_iref: PPortInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PROVIDER-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_iref: RPortInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "REQUESTER-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MappingRef(Ref):
        dest: PortInterfaceMappingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AsynchronousServerCallPoint:
    """An AsynchronousServerCallPoint is used for asynchronous invocation of a
    ClientServerOperation.

    IMPORTANT: a ServerCallPoint cannot be used concurrently. Once the client RunnableEntity has made the invocation, the ServerCallPoint cannot be used until the call returns (or an error occurs!) at which point the ServerCallPoint becomes available again.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar return_value_provision: This attribute controls the provision
        of return values for RTE APIs that correspond to the enclosing
        access point.
    :ivar operation_iref: The operation that is called by this runnable.
    :ivar timeout: Time in seconds before the server call times out and
        returns with an error message. It depends on the call type
        (synchronous or asynchronous) how this is reported.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RunnableEntity.serverCallPoint
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ASYNCHRONOUS-SERVER-CALL-POINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AsynchronousServerCallPoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AsynchronousServerCallPoint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    return_value_provision: RteApiReturnValueProvisionEnum | None = field(
        default=None,
        metadata={
            "name": "RETURN-VALUE-PROVISION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_iref: ROperationInAtomicSwcInstanceRef | None = field(
        default=None,
        metadata={
            "name": "OPERATION-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class AsynchronousServerCallResultPoint:
    """If a RunnableEntity owns a AsynchronousServerCallResultPoint it is entitled
    to get the result of the referenced AsynchronousServerCallPoint.

    If it is associated with AsynchronousServerCallReturnsEvent, this
    RTEEvent notifies the completion of the required
    ClientServerOperation or a timeout. The occurrence of this event can
    either unblock a WaitPoint or can lead to the invocation of a
    RunnableEntity.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar return_value_provision: This attribute controls the provision
        of return values for RTE APIs that correspond to the enclosing
        access point.
    :ivar asynchronous_server_call_point_ref: The referenced
        Asynchronous Server Call Point defines the asynchronous server
        call from which the results are returned.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RunnableEntity.asynchronousServerCallResultPoint
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ASYNCHRONOUS-SERVER-CALL-RESULT-POINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AsynchronousServerCallResultPoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AsynchronousServerCallResultPoint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    return_value_provision: RteApiReturnValueProvisionEnum | None = field(
        default=None,
        metadata={
            "name": "RETURN-VALUE-PROVISION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    asynchronous_server_call_point_ref: Optional[
        "AsynchronousServerCallResultPoint.AsynchronousServerCallPointRef"
    ] = field(
        default=None,
        metadata={
            "name": "ASYNCHRONOUS-SERVER-CALL-POINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AsynchronousServerCallPointRef(Ref):
        dest: AsynchronousServerCallPointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AsynchronousServerCallReturnsEvent:
    """
    This event is raised when an asynchronous server call is finished.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar event_source_ref: The referenced
        AsynchronousServerCallResultPoint raises this
        AsynchronousServerCallReturnsEvent when the asynchronous server
        call returns.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ASYNCHRONOUS-SERVER-CALL-RETURNS-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AsynchronousServerCallReturnsEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AsynchronousServerCallReturnsEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "AsynchronousServerCallReturnsEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["AsynchronousServerCallReturnsEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["AsynchronousServerCallReturnsEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_source_ref: Optional["AsynchronousServerCallReturnsEvent.EventSourceRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-SOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventSourceRef(Ref):
        dest: AsynchronousServerCallResultPointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AutosarDataTypeRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar autosar_data_type_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AUTOSAR-DATA-TYPE-REF-CONDITIONAL"

    autosar_data_type_ref: Optional["AutosarDataTypeRefConditional.AutosarDataTypeRef"] = field(
        default=None,
        metadata={
            "name": "AUTOSAR-DATA-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AutosarDataTypeRef(Ref):
        dest: AutosarDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AutosarOperationArgumentInstance:
    """This class represents a reference to an argument instance.

    This way it is possible to reference an argument instance in the occurrence expression formula. The argument instance can target to one of the following arguments:
    * a whole argument used in an operation of a PortPrototype with ClientServerInterface
    * an element inside of a composite argument used in an operation of a PortPrototype with ClientServerInterface

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar operation_argument_instance_iref: This is the reference to the
        instanceRef definition.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtensionResource.timingArgument Not Applicable for:
        TDEventOccurrenceExpression.argument
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AUTOSAR-OPERATION-ARGUMENT-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AutosarOperationArgumentInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AutosarOperationArgumentInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_argument_instance_iref: OperationArgumentInComponentInstanceRef | None = field(
        default=None,
        metadata={
            "name": "OPERATION-ARGUMENT-INSTANCE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class AutosarVariableInstance:
    """This class represents a reference to a variable instance within AUTOSAR.

    This way it is possible to reference a variable instance in the occurrence expression formula. The variable instance can target to one of the following variables:
    * a variable provided via a PortPrototype as whole
    * an element inside of a composite variable provided via a PortPrototype

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variable_instance_iref: This is the reference to the
        instanceRef definition.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtensionResource.timingVariable Not Applicable for:
        TDEventOccurrenceExpression.variable
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AUTOSAR-VARIABLE-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AutosarVariableInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AutosarVariableInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variable_instance_iref: VariableInComponentInstanceRef | None = field(
        default=None,
        metadata={
            "name": "VARIABLE-INSTANCE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BackgroundEvent:
    """
    This event is used to start RunnableEntities that are supposed to be executed
    in the background.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BACKGROUND-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BackgroundEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BackgroundEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "BackgroundEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["BackgroundEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["BackgroundEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BinaryManifestItem:
    """
    This meta-class represents the ability to describe a specific handle or
    auxiliary field in the context of  binary manifest resource.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar address: This attribute specifies the address of the enclosing
        addressable object.
    :ivar symbol: This attribute specifies the symbol of the addressable
        object.
    :ivar is_unused: If true, the handle or auxiliary field in the
        context of binary manifest resource relates to an optional
        BinaryManifestItemDefinition and is not used.
    :ivar value: This aggregation represents the definition of a value
        for a binary manifest handle or an auxiliaryField. This value
        shall be taken to establish a connection.
    :ivar default_value: This aggregation represents the definition of a
        default value for a binary manifest handle or an auxiliaryField.
        This value shall be taken if no connection for this resource is
        possible.
    :ivar auxiliary_fields: This aggregation is used to define
        structured BinaryManifestItems.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BINARY-MANIFEST-ITEM"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BinaryManifestItem.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BinaryManifestItem.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    address: Address | None = field(
        default=None,
        metadata={
            "name": "ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol: SymbolString | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_unused: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-UNUSED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: Optional["BinaryManifestItem.Value"] = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_value: Optional["BinaryManifestItem.DefaultValue"] = field(
        default=None,
        metadata={
            "name": "DEFAULT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    auxiliary_fields: Optional["BinaryManifestItem.AuxiliaryFields"] = field(
        default=None,
        metadata={
            "name": "AUXILIARY-FIELDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Value:
        binary_manifest_item_numerical_value: BinaryManifestItemNumericalValue | None = field(
            default=None,
            metadata={
                "name": "BINARY-MANIFEST-ITEM-NUMERICAL-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        binary_manifest_item_pointer_value: BinaryManifestItemPointerValue | None = field(
            default=None,
            metadata={
                "name": "BINARY-MANIFEST-ITEM-POINTER-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DefaultValue:
        binary_manifest_item_numerical_value: BinaryManifestItemNumericalValue | None = field(
            default=None,
            metadata={
                "name": "BINARY-MANIFEST-ITEM-NUMERICAL-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        binary_manifest_item_pointer_value: BinaryManifestItemPointerValue | None = field(
            default=None,
            metadata={
                "name": "BINARY-MANIFEST-ITEM-POINTER-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AuxiliaryFields:
        binary_manifest_item: list["BinaryManifestItem"] = field(
            default_factory=list,
            metadata={
                "name": "BINARY-MANIFEST-ITEM",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BinaryManifestItemDefinition:
    """
    This meta-class provides the ability to define the handle definition or an
    auxiliary field of a binary manifest resource.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar auxiliary_field_definitions: This aggregation is used to
        define structured BinaryManifestItemDefinitions.
    :ivar is_optional: If true, the handle definition or auxiliary field
        of a binary manifest resource is optional and may not be used in
        all BinaryManifestResources referring to this
        BinaryManifestResourceDefinition.
    :ivar size: This attribute provides the ability to specify the size
        of the enclosing BinaryManifestResourceDefinition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BINARY-MANIFEST-ITEM-DEFINITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BinaryManifestItemDefinition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BinaryManifestItemDefinition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    auxiliary_field_definitions: Optional[
        "BinaryManifestItemDefinition.AuxiliaryFieldDefinitions"
    ] = field(
        default=None,
        metadata={
            "name": "AUXILIARY-FIELD-DEFINITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_optional: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-OPTIONAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AuxiliaryFieldDefinitions:
        binary_manifest_item_definition: list["BinaryManifestItemDefinition"] = field(
            default_factory=list,
            metadata={
                "name": "BINARY-MANIFEST-ITEM-DEFINITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BinaryManifestMetaDataField:
    """
    This meta-class provides the ability to define a meta-data field for the binary
    manifest descriptor.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar address: This attribute specifies the address of the enclosing
        addressable object.
    :ivar symbol: This attribute specifies the symbol of the addressable
        object.
    :ivar size: The value of this attribute represents the size of the
        meta-data field in bytes.
    :ivar value: This attribute specifies the value of the meta-data
        field.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BINARY-MANIFEST-META-DATA-FIELD"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BinaryManifestMetaDataField.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BinaryManifestMetaDataField.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    address: Address | None = field(
        default=None,
        metadata={
            "name": "ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol: SymbolString | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: VerbatimString | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BlockState:
    """This meta-class defines a block state that is part of the collection of
    block states belonging to a specific IdsmInstance.

    The IdsM shall discard any reported security event that is mapped to
    a filter chain containing a SecurityEventStateFilter that references
    the block state which is currently active in the IdsM.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BLOCK-STATE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BlockState.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BlockState.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BlueprintMappingSet:
    """
    This represents a container of mappings between "actual" model elements and the
    "blueprint" that has been taken for their creation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_maps: This represents a particular blueprint map in
        the set.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BLUEPRINT-MAPPING-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BlueprintMappingSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BlueprintMappingSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_maps: Optional["BlueprintMappingSet.BlueprintMaps"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-MAPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintMaps:
        blueprint_mapping: list[BlueprintMapping] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        port_interface_blueprint_mapping: list[PortInterfaceBlueprintMapping] = field(
            default_factory=list,
            metadata={
                "name": "PORT-INTERFACE-BLUEPRINT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        port_prototype_blueprint_mapping: list[PortPrototypeBlueprintMapping] = field(
            default_factory=list,
            metadata={
                "name": "PORT-PROTOTYPE-BLUEPRINT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BswAsynchronousServerCallPoint:
    """
    Represents an asynchronous procedure call point via the BSW Scheduler.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the call point is used only in the context of the
        referred BswDistinguishedPartitions.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswModuleEntity.callPoint
    :ivar called_entry_ref: The entry to be called.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-ASYNCHRONOUS-SERVER-CALL-POINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswAsynchronousServerCallPoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional["BswAsynchronousServerCallPoint.ContextLimitationRefs"] = (
        field(
            default=None,
            metadata={
                "name": "CONTEXT-LIMITATION-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    called_entry_ref: Optional["BswAsynchronousServerCallPoint.CalledEntryRef"] = field(
        default=None,
        metadata={
            "name": "CALLED-ENTRY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswAsynchronousServerCallPoint.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class CalledEntryRef(Ref):
        dest: BswModuleClientServerEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswAsynchronousServerCallResultPoint:
    """
    The callback point for an BswAsynchronousServerCallPoint i.e. the point at
    which the result can be retrieved from the BSW Scheduler.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the call point is used only in the context of the
        referred BswDistinguishedPartitions.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswModuleEntity.callPoint
    :ivar asynchronous_server_call_point_ref: The call point invoking
        the call to which the result belongs.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-ASYNCHRONOUS-SERVER-CALL-RESULT-POINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswAsynchronousServerCallResultPoint.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    context_limitation_refs: Optional[
        "BswAsynchronousServerCallResultPoint.ContextLimitationRefs"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-LIMITATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    asynchronous_server_call_point_ref: Optional[
        "BswAsynchronousServerCallResultPoint.AsynchronousServerCallPointRef"
    ] = field(
        default=None,
        metadata={
            "name": "ASYNCHRONOUS-SERVER-CALL-POINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswAsynchronousServerCallResultPoint.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class AsynchronousServerCallPointRef(Ref):
        dest: BswAsynchronousServerCallPointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswAsynchronousServerCallReturnsEvent:
    """This is the "callback" event for asynchronous Client-Server-Communication
    via the BSW Scheduler which is thrown after completion of the asynchronous
    Client-Server call.

    Its eventSource specifies the call point to be used for retrieving
    the result.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the usage of the event is limited to the context
        of the referred BswDistinguishedPartitions.
    :ivar disabled_in_mode_irefs: The modes, in which this event is
        disabled.
    :ivar starts_on_event_ref: The entity which is started by the event.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.event
    :ivar event_source_ref: The call point to be used for retrieving the
        result.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-ASYNCHRONOUS-SERVER-CALL-RETURNS-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswAsynchronousServerCallReturnsEvent.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswAsynchronousServerCallReturnsEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "BswAsynchronousServerCallReturnsEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional[
        "BswAsynchronousServerCallReturnsEvent.ContextLimitationRefs"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-LIMITATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_in_mode_irefs: Optional[
        "BswAsynchronousServerCallReturnsEvent.DisabledInModeIrefs"
    ] = field(
        default=None,
        metadata={
            "name": "DISABLED-IN-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    starts_on_event_ref: Optional["BswAsynchronousServerCallReturnsEvent.StartsOnEventRef"] = field(
        default=None,
        metadata={
            "name": "STARTS-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_source_ref: Optional["BswAsynchronousServerCallReturnsEvent.EventSourceRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-SOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswAsynchronousServerCallReturnsEvent.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DisabledInModeIrefs:
        disabled_in_mode_iref: list[ModeInBswModuleDescriptionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-IN-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartsOnEventRef(Ref):
        dest: BswModuleEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventSourceRef(Ref):
        dest: BswAsynchronousServerCallResultPointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswBackgroundEvent:
    """A recurring BswEvent which is used to perform background activities.

    It is similar to a BswTimingEvent but has no fixed time period and
    is activated only with low priority.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the usage of the event is limited to the context
        of the referred BswDistinguishedPartitions.
    :ivar disabled_in_mode_irefs: The modes, in which this event is
        disabled.
    :ivar starts_on_event_ref: The entity which is started by the event.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.event
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-BACKGROUND-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswBackgroundEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswBackgroundEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "BswBackgroundEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional["BswBackgroundEvent.ContextLimitationRefs"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-LIMITATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_in_mode_irefs: Optional["BswBackgroundEvent.DisabledInModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-IN-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    starts_on_event_ref: Optional["BswBackgroundEvent.StartsOnEventRef"] = field(
        default=None,
        metadata={
            "name": "STARTS-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswBackgroundEvent.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DisabledInModeIrefs:
        disabled_in_mode_iref: list[ModeInBswModuleDescriptionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-IN-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartsOnEventRef(Ref):
        dest: BswModuleEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswClientPolicy:
    """
    The requiredClientServerEntry for which the BSW Scheduler using this policy.

    :ivar enable_take_address: If set to true, the BSW Module is able to
        use the API reference for deriving a pointer to an object
    :ivar required_client_server_entry_ref: The
        requiredClientServerEntry for which the BSW Scheduler using this
        policy.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.clientPolicy
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-CLIENT-POLICY"

    enable_take_address: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-TAKE-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_client_server_entry_ref: Optional["BswClientPolicy.RequiredClientServerEntryRef"] = (
        field(
            default=None,
            metadata={
                "name": "REQUIRED-CLIENT-SERVER-ENTRY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class RequiredClientServerEntryRef(Ref):
        dest: BswModuleClientServerEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswDataReceivedEvent:
    """
    This event is thrown on reception of the referenced data via Sender-Receiver-
    Communication over the BSW Scheduler.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the usage of the event is limited to the context
        of the referred BswDistinguishedPartitions.
    :ivar disabled_in_mode_irefs: The modes, in which this event is
        disabled.
    :ivar starts_on_event_ref: The entity which is started by the event.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.event
    :ivar data_ref: The received data.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-DATA-RECEIVED-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswDataReceivedEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswDataReceivedEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "BswDataReceivedEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional["BswDataReceivedEvent.ContextLimitationRefs"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-LIMITATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_in_mode_irefs: Optional["BswDataReceivedEvent.DisabledInModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-IN-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    starts_on_event_ref: Optional["BswDataReceivedEvent.StartsOnEventRef"] = field(
        default=None,
        metadata={
            "name": "STARTS-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_ref: Optional["BswDataReceivedEvent.DataRef"] = field(
        default=None,
        metadata={
            "name": "DATA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswDataReceivedEvent.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DisabledInModeIrefs:
        disabled_in_mode_iref: list[ModeInBswModuleDescriptionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-IN-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartsOnEventRef(Ref):
        dest: BswModuleEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswDataSendPolicy:
    """
    The data sent over the BSW Scheduler using this policy.

    :ivar enable_take_address: If set to true, the BSW Module is able to
        use the API reference for deriving a pointer to an object
    :ivar provided_data_ref: The data sent over the BSW Scheduler using
        this policy.
    :ivar proviede_data_ref: The data sent over the BSW Scheduler using
        this policy.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.sendPolicy
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-DATA-SEND-POLICY"

    enable_take_address: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-TAKE-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_data_ref: Optional["BswDataSendPolicy.ProvidedDataRef"] = field(
        default=None,
        metadata={
            "name": "PROVIDED-DATA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    proviede_data_ref: Optional["BswDataSendPolicy.ProviedeDataRef"] = field(
        default=None,
        metadata={
            "name": "PROVIEDE-DATA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ProvidedDataRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProviedeDataRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswDirectCallPoint:
    """Represents a concrete point in the code from where a BswModuleEntry is
    called directly, i.e. not via the BSW Scheduler.

    This information can be used to analyze call tree and resource
    locking scenarios. It is not needed to configure the BSW Scheduler.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the call point is used only in the context of the
        referred BswDistinguishedPartitions.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswModuleEntity.callPoint
    :ivar called_entry_ref: The BswModuleEntry called at this point.
    :ivar called_from_within_exclusive_area_ref: This indicates that the
        call point is located at the deepest level inside one or more
        ExclusiveAreas that are nested in the given order.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-DIRECT-CALL-POINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswDirectCallPoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional["BswDirectCallPoint.ContextLimitationRefs"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-LIMITATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    called_entry_ref: Optional["BswDirectCallPoint.CalledEntryRef"] = field(
        default=None,
        metadata={
            "name": "CALLED-ENTRY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    called_from_within_exclusive_area_ref: Optional[
        "BswDirectCallPoint.CalledFromWithinExclusiveAreaRef"
    ] = field(
        default=None,
        metadata={
            "name": "CALLED-FROM-WITHIN-EXCLUSIVE-AREA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswDirectCallPoint.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class CalledEntryRef(Ref):
        dest: BswModuleEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CalledFromWithinExclusiveAreaRef(Ref):
        dest: ExclusiveAreaNestingOrderSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswDistinguishedPartition:
    """Each instance of this meta-class represents an abstract partition in which
    context the code of the enclosing  BswModuleBehavior can be executed.

    The intended use case is to distinguish between several partitions
    in order to implement different behavior per partition, for example
    to behave either as a master or satellite in a multicore ECU with
    shared BSW code.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.distinguishedPartition
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-DISTINGUISHED-PARTITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswDistinguishedPartition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BswEntryRelationshipSet:
    """
    Describes a set of relationships between two BswModuleEntrys.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar bsw_entry_relationships: Relationship between two
        BswModuleEntrys.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-ENTRY-RELATIONSHIP-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswEntryRelationshipSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswEntryRelationshipSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["BswEntryRelationshipSet.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_entry_relationships: Optional["BswEntryRelationshipSet.BswEntryRelationships"] = field(
        default=None,
        metadata={
            "name": "BSW-ENTRY-RELATIONSHIPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BswEntryRelationships:
        bsw_entry_relationship: list[BswEntryRelationship] = field(
            default_factory=list,
            metadata={
                "name": "BSW-ENTRY-RELATIONSHIP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BswExclusiveAreaPolicy:
    """
    The ExclusiveArea for which the BSW Scheduler using this policy.

    :ivar enable_take_address: If set to true, the BSW Module is able to
        use the API reference for deriving a pointer to an object
    :ivar api_principle: Specifies for this ExclusiveArea if either one
        common set of Enter and Exit APIs for the whole BSW module is
        requested from the SchM or if the set of Enter and Exit APIs is
        expected per BswModuleEntity. The default value is "common".
    :ivar exclusive_area_ref: The ExclusiveArea for which the BSW
        Scheduler using this policy.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.exclusiveAreaPolicy
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-EXCLUSIVE-AREA-POLICY"

    enable_take_address: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-TAKE-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    api_principle: ApiPrincipleEnum | None = field(
        default=None,
        metadata={
            "name": "API-PRINCIPLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_area_ref: Optional["BswExclusiveAreaPolicy.ExclusiveAreaRef"] = field(
        default=None,
        metadata={
            "name": "EXCLUSIVE-AREA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaRef(Ref):
        dest: ExclusiveAreaSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswExternalTriggerOccurredEvent:
    """
    A BswEvent resulting from a trigger released by another module or cluster.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the usage of the event is limited to the context
        of the referred BswDistinguishedPartitions.
    :ivar disabled_in_mode_irefs: The modes, in which this event is
        disabled.
    :ivar starts_on_event_ref: The entity which is started by the event.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.event
    :ivar trigger_ref: The trigger associated with this event. The
        trigger is external to this module.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-EXTERNAL-TRIGGER-OCCURRED-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswExternalTriggerOccurredEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswExternalTriggerOccurredEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "BswExternalTriggerOccurredEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional["BswExternalTriggerOccurredEvent.ContextLimitationRefs"] = (
        field(
            default=None,
            metadata={
                "name": "CONTEXT-LIMITATION-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    disabled_in_mode_irefs: Optional["BswExternalTriggerOccurredEvent.DisabledInModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-IN-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    starts_on_event_ref: Optional["BswExternalTriggerOccurredEvent.StartsOnEventRef"] = field(
        default=None,
        metadata={
            "name": "STARTS-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_ref: Optional["BswExternalTriggerOccurredEvent.TriggerRef"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswExternalTriggerOccurredEvent.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DisabledInModeIrefs:
        disabled_in_mode_iref: list[ModeInBswModuleDescriptionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-IN-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartsOnEventRef(Ref):
        dest: BswModuleEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswInternalTriggerOccurredEvent:
    """A BswEvent, which can happen sporadically.

    The event is activated by explicit calls from the module to the BSW
    Scheduler. The main purpose for such an event is to cause a context
    switch, e.g. from an ISR context into a task context. Activation and
    switching are handled within the same module or cluster only.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the usage of the event is limited to the context
        of the referred BswDistinguishedPartitions.
    :ivar disabled_in_mode_irefs: The modes, in which this event is
        disabled.
    :ivar starts_on_event_ref: The entity which is started by the event.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.event
    :ivar event_source_ref: The activation point is the source of this
        event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-INTERNAL-TRIGGER-OCCURRED-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswInternalTriggerOccurredEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswInternalTriggerOccurredEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "BswInternalTriggerOccurredEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional["BswInternalTriggerOccurredEvent.ContextLimitationRefs"] = (
        field(
            default=None,
            metadata={
                "name": "CONTEXT-LIMITATION-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    disabled_in_mode_irefs: Optional["BswInternalTriggerOccurredEvent.DisabledInModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-IN-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    starts_on_event_ref: Optional["BswInternalTriggerOccurredEvent.StartsOnEventRef"] = field(
        default=None,
        metadata={
            "name": "STARTS-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_source_ref: Optional["BswInternalTriggerOccurredEvent.EventSourceRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-SOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswInternalTriggerOccurredEvent.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DisabledInModeIrefs:
        disabled_in_mode_iref: list[ModeInBswModuleDescriptionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-IN-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartsOnEventRef(Ref):
        dest: BswModuleEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventSourceRef(Ref):
        dest: BswInternalTriggeringPointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswInternalTriggeringPoint:
    """
    Represents the activation point for one or more
    BswInternalTriggerOccurredEvents.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sw_impl_policy: This attribute, when set to value queued,
        specifies a queued processing of the internal trigger event.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.internalTriggeringPoint
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-INTERNAL-TRIGGERING-POINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswInternalTriggeringPoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswInternalTriggeringPoint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_impl_policy: SwImplPolicyEnum | None = field(
        default=None,
        metadata={
            "name": "SW-IMPL-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BswInternalTriggeringPointPolicy:
    """
    The internal triggering point for which the BSW Scheduler using this policy.

    :ivar enable_take_address: If set to true, the BSW Module is able to
        use the API reference for deriving a pointer to an object
    :ivar bsw_internal_triggering_point_ref: The
        BswInternalTriggeringPoint for which the BSW Scheduler using
        this policy.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.internalTriggeringPointPolicy
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-INTERNAL-TRIGGERING-POINT-POLICY"

    enable_take_address: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-TAKE-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_internal_triggering_point_ref: Optional[
        "BswInternalTriggeringPointPolicy.BswInternalTriggeringPointRef"
    ] = field(
        default=None,
        metadata={
            "name": "BSW-INTERNAL-TRIGGERING-POINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BswInternalTriggeringPointRef(Ref):
        dest: BswInternalTriggeringPointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswInternalTriggeringPointRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar bsw_internal_triggering_point_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-INTERNAL-TRIGGERING-POINT-REF-CONDITIONAL"

    bsw_internal_triggering_point_ref: Optional[
        "BswInternalTriggeringPointRefConditional.BswInternalTriggeringPointRef"
    ] = field(
        default=None,
        metadata={
            "name": "BSW-INTERNAL-TRIGGERING-POINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BswInternalTriggeringPointRef(Ref):
        dest: BswInternalTriggeringPointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswMgrNeeds:
    """
    Specifies the abstract needs on the configuration of the Basic Software Manager
    for one "user".

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-MGR-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswMgrNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswMgrNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BswModeManagerErrorEvent:
    """
    This represents the ability to react on errors occurring during mode handling.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the usage of the event is limited to the context
        of the referred BswDistinguishedPartitions.
    :ivar disabled_in_mode_irefs: The modes, in which this event is
        disabled.
    :ivar starts_on_event_ref: The entity which is started by the event.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.event
    :ivar mode_group_ref: This represents the
        ModeDeclarationGroupPrototype for which the error behavior of
        the mode manager applies.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-MODE-MANAGER-ERROR-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswModeManagerErrorEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswModeManagerErrorEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "BswModeManagerErrorEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional["BswModeManagerErrorEvent.ContextLimitationRefs"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-LIMITATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_in_mode_irefs: Optional["BswModeManagerErrorEvent.DisabledInModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-IN-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    starts_on_event_ref: Optional["BswModeManagerErrorEvent.StartsOnEventRef"] = field(
        default=None,
        metadata={
            "name": "STARTS-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_group_ref: Optional["BswModeManagerErrorEvent.ModeGroupRef"] = field(
        default=None,
        metadata={
            "name": "MODE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswModeManagerErrorEvent.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DisabledInModeIrefs:
        disabled_in_mode_iref: list[ModeInBswModuleDescriptionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-IN-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartsOnEventRef(Ref):
        dest: BswModuleEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ModeGroupRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswModeReceiverPolicy:
    """
    Specifies the details for the reception of a mode switch for the referred mode
    group.

    :ivar enhanced_mode_api: This controls the creation of the enhanced
        mode API that returns information about the previous mode and
        the next mode. If set to TRUE the enhanced mode API is supposed
        to be generated. For more details please refer to the SWS_RTE.
    :ivar required_mode_group_ref: The required mode group for which the
        policy is specified.
    :ivar supports_asynchronous_mode_switch: Specifies whether the
        module can handle the reception of an asynchronous mode switch
        (true) or not (false).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.modeReceiverPolicy
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-MODE-RECEIVER-POLICY"

    enhanced_mode_api: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENHANCED-MODE-API",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_mode_group_ref: Optional["BswModeReceiverPolicy.RequiredModeGroupRef"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-MODE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    supports_asynchronous_mode_switch: Boolean | None = field(
        default=None,
        metadata={
            "name": "SUPPORTS-ASYNCHRONOUS-MODE-SWITCH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class RequiredModeGroupRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswModeSenderPolicy:
    """
    Specifies the details for the sending of a mode switch for the referred mode
    group.

    :ivar ack_request: Request for acknowledgement
    :ivar enhanced_mode_api: This controls the creation of the enhanced
        mode API that returns information about the previous mode and
        the next mode. If set to TRUE the enhanced mode API is supposed
        to be generated. For more details please refer to the SWS_RTE.
    :ivar provided_mode_group_ref: The provided mode group for which the
        policy is specified.
    :ivar queue_length: Length of call queue on the sender side. The
        queue is implemented by the RTE resp.BswScheduler. The value
        shall be greater or equal to 0. Setting the value of queueLength
        to 0 implies non-queued communication.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.modeSenderPolicy
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-MODE-SENDER-POLICY"

    ack_request: BswModeSwitchAckRequest | None = field(
        default=None,
        metadata={
            "name": "ACK-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    enhanced_mode_api: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENHANCED-MODE-API",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_mode_group_ref: Optional["BswModeSenderPolicy.ProvidedModeGroupRef"] = field(
        default=None,
        metadata={
            "name": "PROVIDED-MODE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    queue_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "QUEUE-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ProvidedModeGroupRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswModeSwitchEvent:
    """
    A BswEvent resulting from a mode switch.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the usage of the event is limited to the context
        of the referred BswDistinguishedPartitions.
    :ivar disabled_in_mode_irefs: The modes, in which this event is
        disabled.
    :ivar starts_on_event_ref: The entity which is started by the event.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.event
    :ivar activation: Kind of activation w.r.t. to the referred mode.
    :ivar mode_irefs: Reference to one or two Modes that initiate the
        Mode Switch Event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-MODE-SWITCH-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswModeSwitchEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswModeSwitchEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "BswModeSwitchEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional["BswModeSwitchEvent.ContextLimitationRefs"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-LIMITATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_in_mode_irefs: Optional["BswModeSwitchEvent.DisabledInModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-IN-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    starts_on_event_ref: Optional["BswModeSwitchEvent.StartsOnEventRef"] = field(
        default=None,
        metadata={
            "name": "STARTS-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation: ModeActivationKind | None = field(
        default=None,
        metadata={
            "name": "ACTIVATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_irefs: Optional["BswModeSwitchEvent.ModeIrefs"] = field(
        default=None,
        metadata={
            "name": "MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswModeSwitchEvent.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DisabledInModeIrefs:
        disabled_in_mode_iref: list[ModeInBswModuleDescriptionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-IN-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartsOnEventRef(Ref):
        dest: BswModuleEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ModeIrefs:
        mode_iref: list[ModeInBswModuleDescriptionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 2,
            },
        )


@dataclass(slots=True, kw_only=True)
class BswModeSwitchedAckEvent:
    """The event is raised after a switch of the referenced mode group has been
    acknowledged or an error occurs.

    The referenced mode group shall be provided by this module.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the usage of the event is limited to the context
        of the referred BswDistinguishedPartitions.
    :ivar disabled_in_mode_irefs: The modes, in which this event is
        disabled.
    :ivar starts_on_event_ref: The entity which is started by the event.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.event
    :ivar mode_group_ref: A mode group provided by this module. The
        acknowledgement of a switch of this group raises this event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-MODE-SWITCHED-ACK-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswModeSwitchedAckEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswModeSwitchedAckEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "BswModeSwitchedAckEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional["BswModeSwitchedAckEvent.ContextLimitationRefs"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-LIMITATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_in_mode_irefs: Optional["BswModeSwitchedAckEvent.DisabledInModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-IN-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    starts_on_event_ref: Optional["BswModeSwitchedAckEvent.StartsOnEventRef"] = field(
        default=None,
        metadata={
            "name": "STARTS-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_group_ref: Optional["BswModeSwitchedAckEvent.ModeGroupRef"] = field(
        default=None,
        metadata={
            "name": "MODE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswModeSwitchedAckEvent.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DisabledInModeIrefs:
        disabled_in_mode_iref: list[ModeInBswModuleDescriptionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-IN-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartsOnEventRef(Ref):
        dest: BswModuleEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ModeGroupRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswModuleClientServerEntry:
    """This meta-class represents a single API entry into the BSW module or cluster
    that has the ability to be called in client-server fashion via the BSW
    Scheduler.

    In this regard it is more special than BswModuleEntry and can be
    seen as a wrapper around the BswModuleEntry to which it refers
    (property encapsulatedEntry).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar encapsulated_entry_ref: The underlying BswModuleEntry.
    :ivar is_reentrant: Reentrancy from the viewpoint of clients
        invoking the service via the BSW Scheduler: * True: Enables the
        service to be invoked again, before the service has finished. *
        False: It is prohibited to invoke the service again before is
        has finished.
    :ivar is_synchronous: Synchronicity from the viewpoint of clients
        invoking the service via the BSW Scheduler: * True: This calls a
        synchronous service, i.e. the service is completed when the call
        returns. * False: The service (on semantical level) may not be
        complete when the call returns.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswModuleDescription.providedClientServerEntry Applicable for:
        BswModuleDescription.requiredClientServerEntry
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-MODULE-CLIENT-SERVER-ENTRY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswModuleClientServerEntry.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    encapsulated_entry_ref: Optional["BswModuleClientServerEntry.EncapsulatedEntryRef"] = field(
        default=None,
        metadata={
            "name": "ENCAPSULATED-ENTRY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_reentrant: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-REENTRANT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_synchronous: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-SYNCHRONOUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EncapsulatedEntryRef(Ref):
        dest: BswModuleEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswModuleDescriptionRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar bsw_module_description_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-MODULE-DESCRIPTION-REF-CONDITIONAL"

    bsw_module_description_ref: Optional[
        "BswModuleDescriptionRefConditional.BswModuleDescriptionRef"
    ] = field(
        default=None,
        metadata={
            "name": "BSW-MODULE-DESCRIPTION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BswModuleDescriptionRef(Ref):
        dest: BswModuleDescriptionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswModuleEntryRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar bsw_module_entry_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-MODULE-ENTRY-REF-CONDITIONAL"

    bsw_module_entry_ref: Optional["BswModuleEntryRefConditional.BswModuleEntryRef"] = field(
        default=None,
        metadata={
            "name": "BSW-MODULE-ENTRY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BswModuleEntryRef(Ref):
        dest: BswModuleEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswOperationInvokedEvent:
    """This event is thrown on operation invocation in Client-Server-Communication
    via the BSW Scheduler.

    Its "entry" reference provides the BswClientServerEntry that is
    called subsequently. Note this event is not needed in case of direct
    function calls.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the usage of the event is limited to the context
        of the referred BswDistinguishedPartitions.
    :ivar disabled_in_mode_irefs: The modes, in which this event is
        disabled.
    :ivar starts_on_event_ref: The entity which is started by the event.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.event
    :ivar entry_ref: The providedClientServerEntry invoked by this
        event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-OPERATION-INVOKED-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswOperationInvokedEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswOperationInvokedEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "BswOperationInvokedEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional["BswOperationInvokedEvent.ContextLimitationRefs"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-LIMITATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_in_mode_irefs: Optional["BswOperationInvokedEvent.DisabledInModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-IN-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    starts_on_event_ref: Optional["BswOperationInvokedEvent.StartsOnEventRef"] = field(
        default=None,
        metadata={
            "name": "STARTS-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    entry_ref: Optional["BswOperationInvokedEvent.EntryRef"] = field(
        default=None,
        metadata={
            "name": "ENTRY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswOperationInvokedEvent.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DisabledInModeIrefs:
        disabled_in_mode_iref: list[ModeInBswModuleDescriptionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-IN-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartsOnEventRef(Ref):
        dest: BswModuleEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EntryRef(Ref):
        dest: BswModuleClientServerEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswOsTaskExecutionEvent:
    """This BswEvent is supposed to execute BswSchedulableEntitys which have to
    react on the execution of specific OsTasks.

    Therefore, this event is unconditionally raised whenever the OsTask
    on which it is mapped is executed. The main use case for this event
    is scheduling of Runnables of Complex Drivers which have to react on
    task executions.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the usage of the event is limited to the context
        of the referred BswDistinguishedPartitions.
    :ivar disabled_in_mode_irefs: The modes, in which this event is
        disabled.
    :ivar starts_on_event_ref: The entity which is started by the event.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.event
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-OS-TASK-EXECUTION-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswOsTaskExecutionEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswOsTaskExecutionEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "BswOsTaskExecutionEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional["BswOsTaskExecutionEvent.ContextLimitationRefs"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-LIMITATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_in_mode_irefs: Optional["BswOsTaskExecutionEvent.DisabledInModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-IN-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    starts_on_event_ref: Optional["BswOsTaskExecutionEvent.StartsOnEventRef"] = field(
        default=None,
        metadata={
            "name": "STARTS-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswOsTaskExecutionEvent.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DisabledInModeIrefs:
        disabled_in_mode_iref: list[ModeInBswModuleDescriptionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-IN-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartsOnEventRef(Ref):
        dest: BswModuleEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswParameterPolicy:
    """
    The perInstanceParameter for which the BSW Scheduler using this policy.

    :ivar enable_take_address: If set to true, the BSW Module is able to
        use the API reference for deriving a pointer to an object
    :ivar per_instance_parameter_ref: The perInstanceParameter for which
        the BSW Scheduler using this policy.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.parameterPolicy
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-PARAMETER-POLICY"

    enable_take_address: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-TAKE-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    per_instance_parameter_ref: Optional["BswParameterPolicy.PerInstanceParameterRef"] = field(
        default=None,
        metadata={
            "name": "PER-INSTANCE-PARAMETER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PerInstanceParameterRef(Ref):
        dest: ParameterDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswPerInstanceMemoryPolicy:
    """
    The per-instance memory for which the BSW Scheduler using this policy.

    :ivar enable_take_address: If set to true, the BSW Module is able to
        use the API reference for deriving a pointer to an object
    :ivar ar_typed_per_instance_memory_ref: The arTypedPerInstanceMemory
        for which the BSW Scheduler using this policy
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.bswPerInstanceMemoryPolicy
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-PER-INSTANCE-MEMORY-POLICY"

    enable_take_address: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-TAKE-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ar_typed_per_instance_memory_ref: Optional[
        "BswPerInstanceMemoryPolicy.ArTypedPerInstanceMemoryRef"
    ] = field(
        default=None,
        metadata={
            "name": "AR-TYPED-PER-INSTANCE-MEMORY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ArTypedPerInstanceMemoryRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswQueuedDataReceptionPolicy:
    """
    Reception policy attributes specific for queued receiving.

    :ivar enable_take_address: If set to true, the BSW Module is able to
        use the API reference for deriving a pointer to an object
    :ivar received_data_ref: The data received over the BSW Scheduler
        using this policy.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.receptionPolicy
    :ivar queue_length: Length of queue for received events.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-QUEUED-DATA-RECEPTION-POLICY"

    enable_take_address: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-TAKE-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    received_data_ref: Optional["BswQueuedDataReceptionPolicy.ReceivedDataRef"] = field(
        default=None,
        metadata={
            "name": "RECEIVED-DATA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    queue_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "QUEUE-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ReceivedDataRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswReleasedTriggerPolicy:
    """
    The Trigger for which the BSW Scheduler using this policy.

    :ivar enable_take_address: If set to true, the BSW Module is able to
        use the API reference for deriving a pointer to an object
    :ivar released_trigger_ref: The Trigger for which the BSW Scheduler
        using this policy.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.releasedTriggerPolicy
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-RELEASED-TRIGGER-POLICY"

    enable_take_address: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-TAKE-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    released_trigger_ref: Optional["BswReleasedTriggerPolicy.ReleasedTriggerRef"] = field(
        default=None,
        metadata={
            "name": "RELEASED-TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ReleasedTriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswSchedulerNamePrefix:
    """
    A prefix to be used in names of generated code artifacts which make up the
    interface of a BSW module to the BswScheduler.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar symbol: The symbol to be used as (depending on the concrete
        case) either a complete replacement or a prefix.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.schedulerNamePrefix
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-SCHEDULER-NAME-PREFIX"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswSchedulerNamePrefix.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BswServiceDependencyIdent:
    """
    This meta-class is created to add the ability to become the target of a
    reference to the non-Referrable BswServiceDependency.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-SERVICE-DEPENDENCY-IDENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswServiceDependencyIdent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswServiceDependencyIdent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BswSynchronousServerCallPoint:
    """
    Represents a synchronous procedure call point via the BSW Scheduler.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the call point is used only in the context of the
        referred BswDistinguishedPartitions.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswModuleEntity.callPoint
    :ivar called_entry_ref: The entry to be called.
    :ivar called_from_within_exclusive_area_ref: This indicates that the
        call point is located at the deepest level inside one or more
        ExclusiveAreas that are nested in the given order.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-SYNCHRONOUS-SERVER-CALL-POINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswSynchronousServerCallPoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional["BswSynchronousServerCallPoint.ContextLimitationRefs"] = (
        field(
            default=None,
            metadata={
                "name": "CONTEXT-LIMITATION-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    called_entry_ref: Optional["BswSynchronousServerCallPoint.CalledEntryRef"] = field(
        default=None,
        metadata={
            "name": "CALLED-ENTRY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    called_from_within_exclusive_area_ref: Optional[
        "BswSynchronousServerCallPoint.CalledFromWithinExclusiveAreaRef"
    ] = field(
        default=None,
        metadata={
            "name": "CALLED-FROM-WITHIN-EXCLUSIVE-AREA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswSynchronousServerCallPoint.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class CalledEntryRef(Ref):
        dest: BswModuleClientServerEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CalledFromWithinExclusiveAreaRef(Ref):
        dest: ExclusiveAreaNestingOrderSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswTimingEvent:
    """
    A recurring BswEvent driven by a time period.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the usage of the event is limited to the context
        of the referred BswDistinguishedPartitions.
    :ivar disabled_in_mode_irefs: The modes, in which this event is
        disabled.
    :ivar starts_on_event_ref: The entity which is started by the event.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.event
    :ivar period: Requirement for the time period (in seconds) by which
        this event is triggered.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-TIMING-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswTimingEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswTimingEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "BswTimingEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional["BswTimingEvent.ContextLimitationRefs"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-LIMITATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_in_mode_irefs: Optional["BswTimingEvent.DisabledInModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-IN-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    starts_on_event_ref: Optional["BswTimingEvent.StartsOnEventRef"] = field(
        default=None,
        metadata={
            "name": "STARTS-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswTimingEvent.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DisabledInModeIrefs:
        disabled_in_mode_iref: list[ModeInBswModuleDescriptionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-IN-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartsOnEventRef(Ref):
        dest: BswModuleEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswTriggerDirectImplementation:
    """
    Specifies a released trigger to be directly implemented via OS calls, for
    example in a Complex Driver module.

    :ivar cat_2_isr: The name of the OS category 2 ISR, which is
        controlled by the referred trigger. This means, that the module
        manages the category 2 ISR (e.g. according hardware
        initialization and enabling of ISR). Instead of calling an RTE /
        SchM API to raise the appropriate events in components or
        modules receiving the trigger, this ISR directly schedules the
        triggered ExecutableEntitys. The ISR name is required by the
        integrator to map the BswEvents and RTEEvents to  this ISR.
    :ivar mastered_trigger_ref: The trigger which is directly mastered
        by this module. There may be several different
        BswTriggerDirectImplementations mastering the same Trigger. This
        may be required e.g. due to memory partitioning.
    :ivar task: The name of the OS task, which is controlled by the
        referred trigger. This means, that the module uses the trigger
        condition to directly activate an OS task instead of calling an
        API of the BswScheduler. The task name is required by the RTE
        generator resp. BswScheduler to raise the appropriate events in
        components or modules receiving the trigger.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.triggerDirectImplementation
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-TRIGGER-DIRECT-IMPLEMENTATION"

    cat_2_isr: Identifier | None = field(
        default=None,
        metadata={
            "name": "CAT-2-ISR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mastered_trigger_ref: Optional["BswTriggerDirectImplementation.MasteredTriggerRef"] = field(
        default=None,
        metadata={
            "name": "MASTERED-TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    task: Identifier | None = field(
        default=None,
        metadata={
            "name": "TASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class MasteredTriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswVariableAccess:
    """The presence of a BswVariableAccess implies that a BswModuleEntity needs
    access to a VariableDataPrototype via the BSW Scheduler.

    The kind of access is specified by the role in which the class is
    used.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar accessed_variable_ref: The data accessed via the BSW
        Scheduler.
    :ivar context_limitation_refs: The existence of this reference
        indicates that the variable is received resp. sent only in the
        context of the referred BswDistinguishedPartitions.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswModuleEntity.dataReceivePoint Applicable for:
        BswModuleEntity.dataSendPoint
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-VARIABLE-ACCESS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswVariableAccess.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    accessed_variable_ref: Optional["BswVariableAccess.AccessedVariableRef"] = field(
        default=None,
        metadata={
            "name": "ACCESSED-VARIABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_limitation_refs: Optional["BswVariableAccess.ContextLimitationRefs"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-LIMITATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessedVariableRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextLimitationRefs:
        context_limitation_ref: list[
            "BswVariableAccess.ContextLimitationRefs.ContextLimitationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTEXT-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContextLimitationRef(Ref):
            dest: BswDistinguishedPartitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class BuildAction:
    """
    This meta-class represents the ability to specify a build action.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar delivery_artifacts: This denotes the delivery artifacts for
        the entity for reference purposes.
    :ivar invocation: This specifies how to invoke a build action in the
        given environment.
    :ivar predecessor_action_refs: This association specifies a set of
        predecessors. These actions shall be finished before but
        necessarily immediately after the given action.. These actions
        need to be performed in the specified order.
    :ivar follow_up_action_refs: This association specifies a set of
        follow up actions.
    :ivar created_datas: This represents the artifacts which are created
        by the processor.
    :ivar input_datas: This represents the artifacts which are read by
        the processor.
    :ivar modified_datas: This denotes the data which are modified by
        the action.
    :ivar required_environment_ref: This represents the environment
        which is required to use the specified Processor.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BuildActionManifest.buildAction
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUILD-ACTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BuildAction.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BuildAction.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["BuildAction.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delivery_artifacts: Optional["BuildAction.DeliveryArtifacts"] = field(
        default=None,
        metadata={
            "name": "DELIVERY-ARTIFACTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    invocation: BuildActionInvocator | None = field(
        default=None,
        metadata={
            "name": "INVOCATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    predecessor_action_refs: Optional["BuildAction.PredecessorActionRefs"] = field(
        default=None,
        metadata={
            "name": "PREDECESSOR-ACTION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    follow_up_action_refs: Optional["BuildAction.FollowUpActionRefs"] = field(
        default=None,
        metadata={
            "name": "FOLLOW-UP-ACTION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    created_datas: Optional["BuildAction.CreatedDatas"] = field(
        default=None,
        metadata={
            "name": "CREATED-DATAS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    input_datas: Optional["BuildAction.InputDatas"] = field(
        default=None,
        metadata={
            "name": "INPUT-DATAS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    modified_datas: Optional["BuildAction.ModifiedDatas"] = field(
        default=None,
        metadata={
            "name": "MODIFIED-DATAS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_environment_ref: Optional["BuildAction.RequiredEnvironmentRef"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-ENVIRONMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DeliveryArtifacts:
        autosar_engineering_object: list[AutosarEngineeringObject] = field(
            default_factory=list,
            metadata={
                "name": "AUTOSAR-ENGINEERING-OBJECT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PredecessorActionRefs:
        predecessor_action_ref: list["BuildAction.PredecessorActionRefs.PredecessorActionRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "PREDECESSOR-ACTION-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class PredecessorActionRef(Ref):
            dest: BuildActionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class FollowUpActionRefs:
        follow_up_action_ref: list["BuildAction.FollowUpActionRefs.FollowUpActionRef"] = field(
            default_factory=list,
            metadata={
                "name": "FOLLOW-UP-ACTION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FollowUpActionRef(Ref):
            dest: BuildActionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class CreatedDatas:
        build_action_io_element: list[BuildActionIoElement] = field(
            default_factory=list,
            metadata={
                "name": "BUILD-ACTION-IO-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InputDatas:
        build_action_io_element: list[BuildActionIoElement] = field(
            default_factory=list,
            metadata={
                "name": "BUILD-ACTION-IO-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModifiedDatas:
        build_action_io_element: list[BuildActionIoElement] = field(
            default_factory=list,
            metadata={
                "name": "BUILD-ACTION-IO-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredEnvironmentRef(Ref):
        dest: BuildActionEnvironmentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BuildActionEnvironment:
    """
    This meta-class represents the ability to specify a build action environment.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar sdgs: This represents a general data structure  intended to
        denote parameters for the BuildActionEnvironment. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BuildActionManifest.buildActionEnvironment
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUILD-ACTION-ENVIRONMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BuildActionEnvironment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BuildActionEnvironment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["BuildActionEnvironment.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdgs: Optional["BuildActionEnvironment.Sdgs"] = field(
        default=None,
        metadata={
            "name": "SDGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Sdgs:
        sdg: list[Sdg] = field(
            default_factory=list,
            metadata={
                "name": "SDG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BuildActionManifestRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar build_action_manifest_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUILD-ACTION-MANIFEST-REF-CONDITIONAL"

    build_action_manifest_ref: Optional[
        "BuildActionManifestRefConditional.BuildActionManifestRef"
    ] = field(
        default=None,
        metadata={
            "name": "BUILD-ACTION-MANIFEST-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BuildActionManifestRef(Ref):
        dest: BuildActionManifestSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BurstPatternEventTriggering:
    """A BurstPatternEventTriggering describes the maximum number of occurrences of
    the same event in a given time interval.

    This is typically used to model a worst case activation scenario.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar timing_condition_ref: A timing condition the timing constraint
        depends on. In other words it specifies the condition the timing
        constraint holds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingRequirement Applicable for:
        TimingExtension.timingGuarantee
    :ivar event_ref: The referenced timing event
    :ivar max_number_of_occurrences: The maximum number of event
        occurrences within the given time interval.
    :ivar minimum_inter_arrival_time: Specifies the minimum distance
        between subsequent occurrences of the event within the given
        time interval.
    :ivar pattern_jitter: The optional parameter "Pattern Jitter"
        specifies the deviation of the time interval's starting point
        from the beginning of the given period. This parameter is only
        applicable in conjunction with the parameter "Pattern Period".
    :ivar pattern_length: Specifies the duration of the time interval
        within which the event repeatedly occurs. The event occurs at
        arbitrary points in time within the given time interval.
    :ivar pattern_period: The optional parameter "Pattern Period"
        specifies the time distance between the beginnings of subsequent
        repetitions of the given burst pattern.
    :ivar min_number_of_occurrences: The minimum number of event
        occurrences within the given time interval.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BURST-PATTERN-EVENT-TRIGGERING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BurstPatternEventTriggering.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BurstPatternEventTriggering.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["BurstPatternEventTriggering.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_condition_ref: Optional["BurstPatternEventTriggering.TimingConditionRef"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["BurstPatternEventTriggering.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_occurrences: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-OCCURRENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_inter_arrival_time: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-INTER-ARRIVAL-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pattern_jitter: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "PATTERN-JITTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pattern_length: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "PATTERN-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pattern_period: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "PATTERN-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_number_of_occurrences: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-NUMBER-OF-OCCURRENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["BurstPatternEventTriggering.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimingConditionRef(Ref):
        dest: TimingConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: TimingDescriptionEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CanCommunicationControllerConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar wake_up_by_controller_supported: Defines whether the ECU shall
        be woken up by this CommunicationController. TRUE: wake up is
        possible FALSE: wake up is not supported Note: If
        wakeUpByControllerSupported is set to TRUE the feature shall be
        supported by both hardware and basic software.
    :ivar can_controller_attributes: CAN Bit Timing configuration
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-COMMUNICATION-CONTROLLER-CONDITIONAL"

    wake_up_by_controller_supported: Boolean | None = field(
        default=None,
        metadata={
            "name": "WAKE-UP-BY-CONTROLLER-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_controller_attributes: Optional[
        "CanCommunicationControllerConditional.CanControllerAttributes"
    ] = field(
        default=None,
        metadata={
            "name": "CAN-CONTROLLER-ATTRIBUTES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CanControllerAttributes:
        can_controller_configuration: CanControllerConfiguration | None = field(
            default=None,
            metadata={
                "name": "CAN-CONTROLLER-CONFIGURATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        can_controller_configuration_requirements: CanControllerConfigurationRequirements | None = (
            field(
                default=None,
                metadata={
                    "name": "CAN-CONTROLLER-CONFIGURATION-REQUIREMENTS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class CanGlobalTimeDomainProps:
    """
    Enables the definition of Can Global Time specific properties.

    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        GlobalTimeDomain.globalTimeDomainProperty Not Applicable for:
        GlobalTimeDomain.globalTimeDomainProps
    :ivar fup_data_id_lists: The DataIDList for FUP messages to
        calculate CRC.
    :ivar ofns_data_id_lists: The DataIDList for OFNS messages to
        calculate CRC.
    :ivar ofs_data_id_lists: The DataIDList for OFS messages to
        calculate CRC.
    :ivar sync_data_id_lists: The DataIDList for SYNC messages to
        calculate CRC.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-GLOBAL-TIME-DOMAIN-PROPS"

    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fup_data_id_lists: Optional["CanGlobalTimeDomainProps.FupDataIdLists"] = field(
        default=None,
        metadata={
            "name": "FUP-DATA-ID-LISTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ofns_data_id_lists: Optional["CanGlobalTimeDomainProps.OfnsDataIdLists"] = field(
        default=None,
        metadata={
            "name": "OFNS-DATA-ID-LISTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ofs_data_id_lists: Optional["CanGlobalTimeDomainProps.OfsDataIdLists"] = field(
        default=None,
        metadata={
            "name": "OFS-DATA-ID-LISTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_data_id_lists: Optional["CanGlobalTimeDomainProps.SyncDataIdLists"] = field(
        default=None,
        metadata={
            "name": "SYNC-DATA-ID-LISTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FupDataIdLists:
        fup_data_id_list: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "FUP-DATA-ID-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 16,
            },
        )

    @dataclass(slots=True, kw_only=True)
    class OfnsDataIdLists:
        ofns_data_id_list: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "OFNS-DATA-ID-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 16,
            },
        )

    @dataclass(slots=True, kw_only=True)
    class OfsDataIdLists:
        ofs_data_id_list: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "OFS-DATA-ID-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 16,
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SyncDataIdLists:
        sync_data_id_list: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "SYNC-DATA-ID-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 16,
            },
        )


@dataclass(slots=True, kw_only=True)
class CanNmClusterCoupling:
    """
    CAN attributes that are valid for each of the referenced (coupled) CAN
    clusters.

    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        NmConfig.nmClusterCoupling
    :ivar coupled_cluster_refs: Reference to coupled CAN Clusters.
    :ivar nm_busload_reduction_enabled: Enables busload reduction
        support
    :ivar nm_immediate_restart_enabled: Enables the asynchronous
        transmission of a CanNm PDU upon bus-communication request in
        Prepare-Bus-Sleep mode.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-NM-CLUSTER-COUPLING"

    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    coupled_cluster_refs: Optional["CanNmClusterCoupling.CoupledClusterRefs"] = field(
        default=None,
        metadata={
            "name": "COUPLED-CLUSTER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_busload_reduction_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-BUSLOAD-REDUCTION-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_immediate_restart_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-IMMEDIATE-RESTART-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CoupledClusterRefs:
        coupled_cluster_ref: list["CanNmClusterCoupling.CoupledClusterRefs.CoupledClusterRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "COUPLED-CLUSTER-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class CoupledClusterRef(Ref):
            dest: CanNmClusterSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class CanNmNode:
    """
    CAN specific NM Node attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar controller_ref: Association to an CommunicationController in
        the topology description.
    :ivar machine_ref: Reference to the machine that contains the
        NmNode.
    :ivar nm_coord_cluster: NmCoordinationCluster identification number.
    :ivar nm_coordinator_role: This attribute indicates the role the NM
        Coordinator will have on this channel.
    :ivar nm_if_ecu_ref: Reference to the NmEcu that contains this
        NmNode. (CommunicationController that is referenced by the
        NmNode shall be contained in the EcuInstance that is referenced
        by the NmEcu).
    :ivar nm_node_id: Node identifier of local NmNode. Shall be unique
        in the NmCluster.
    :ivar nm_passive_mode_enabled: Enables support of the Passive Mode.
        The passive mode is configurable per channel.
    :ivar rx_nm_pdu_refs: receive NM Pdu.
    :ivar tx_nm_pdu_refs: transmit NM Pdu
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: NmCluster.nmNode
    :ivar all_nm_messages_keep_awake: Specifies if Nm drops irrelevant
        NM PDUs. false: Only NM PDUs with a Partial Network Information
        Bit (PNI) = true and containing a Partial Network request for
        this ECU trigger the standard RX indication handling and thus
        keep the ECU awake true: Every NM PDU triggers the standard RX
        indication handling and keeps the ECU awake
    :ivar can_xl_nm_props: This aggregation contributes the CAN IDs for
        the execution of CAN NM on the adaptive platform.
    :ivar nm_car_wake_up_filter_enabled: If this attribute is set to
        true the CareWakeUp filtering is supported.
    :ivar nm_car_wake_up_rx_enabled: If set to true this attribute
        enables the support of CarWakeUp bit evaluation in received
        NmPdus.
    :ivar nm_msg_cycle_offset: Node specific time offset in the periodic
        transmission node. It determines the start delay of the
        transmission. Specified in seconds.
    :ivar nm_msg_reduced_time: Node specific bus cycle time in the
        periodic transmission mode with bus load reduction. Specified in
        seconds.
    :ivar nm_range_config: Defines the CANID ranges that are used for
        Nm. This range definition is redundant to the attribute
        "rxIdentifierRange" of CanFrameTriggering. For backward
        compatibility reasons this redundancy shall be preserved and
        both shall be defined. In future this element will be removed
        from the model.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-NM-NODE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CanNmNode.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CanNmNode.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    controller_ref: Optional["CanNmNode.ControllerRef"] = field(
        default=None,
        metadata={
            "name": "CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    machine_ref: Optional["CanNmNode.MachineRef"] = field(
        default=None,
        metadata={
            "name": "MACHINE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_coord_cluster: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-COORD-CLUSTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_coordinator_role: NmCoordinatorRoleEnum | None = field(
        default=None,
        metadata={
            "name": "NM-COORDINATOR-ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_if_ecu_ref: Optional["CanNmNode.NmIfEcuRef"] = field(
        default=None,
        metadata={
            "name": "NM-IF-ECU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_id: Integer | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_passive_mode_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-PASSIVE-MODE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rx_nm_pdu_refs: Optional["CanNmNode.RxNmPduRefs"] = field(
        default=None,
        metadata={
            "name": "RX-NM-PDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tx_nm_pdu_refs: Optional["CanNmNode.TxNmPduRefs"] = field(
        default=None,
        metadata={
            "name": "TX-NM-PDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    all_nm_messages_keep_awake: Boolean | None = field(
        default=None,
        metadata={
            "name": "ALL-NM-MESSAGES-KEEP-AWAKE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_xl_nm_props: CanXlNmNodeProps | None = field(
        default=None,
        metadata={
            "name": "CAN-XL-NM-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_car_wake_up_filter_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CAR-WAKE-UP-FILTER-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_car_wake_up_rx_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CAR-WAKE-UP-RX-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_msg_cycle_offset: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-MSG-CYCLE-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_msg_reduced_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-MSG-REDUCED-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_range_config: CanNmRangeConfig | None = field(
        default=None,
        metadata={
            "name": "NM-RANGE-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ControllerRef(Ref):
        dest: CommunicationControllerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MachineRef(Ref):
        dest: MachineDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NmIfEcuRef(Ref):
        dest: NmEcuSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RxNmPduRefs:
        rx_nm_pdu_ref: list["CanNmNode.RxNmPduRefs.RxNmPduRef"] = field(
            default_factory=list,
            metadata={
                "name": "RX-NM-PDU-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RxNmPduRef(Ref):
            dest: NmPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TxNmPduRefs:
        tx_nm_pdu_ref: list["CanNmNode.TxNmPduRefs.TxNmPduRef"] = field(
            default_factory=list,
            metadata={
                "name": "TX-NM-PDU-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TxNmPduRef(Ref):
            dest: NmPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class CanTpAddress:
    """An ECUs TP address on the referenced channel.

    This represents the diagnostic Address.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar tp_address: An ECUs TP address on the referenced channel. This
        represents the diagnostic Address.
    :ivar tp_address_extension_value: If the mixed addressing format is
        used, this parameter contains the transport protocol address
        extension value.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: CanTpConfig.tpAddress
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-TP-ADDRESS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CanTpAddress.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CanTpAddress.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_address: Integer | None = field(
        default=None,
        metadata={
            "name": "TP-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_address_extension_value: Integer | None = field(
        default=None,
        metadata={
            "name": "TP-ADDRESS-EXTENSION-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CanTpChannel:
    """
    Configuration parameters of the CanTp channel.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar channel_id: The id of the channel. The value shall be unique
        for each channel.
    :ivar channel_mode: The CAN Transport Layer supports half and full
        duplex channel modes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: CanTpConfig.tpChannel
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-TP-CHANNEL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CanTpChannel.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CanTpChannel.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    channel_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CHANNEL-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    channel_mode: CanTpChannelModeType | None = field(
        default=None,
        metadata={
            "name": "CHANNEL-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CanTpConnection:
    """A connection identifies the sender and the receiver of this particular
    communication.

    The CanTp module routes a Pdu through this connection.
    atpVariation: Derived, because TpNode can vary.

    :ivar ident: This adds the ability to become referrable to
        TpConnection.
    :ivar addressing_format: Declares which communication addressing
        mode is supported.
    :ivar can_tp_channel_ref: Reference to the CanTpChannel on which
        this CanTpConnection is realized.
    :ivar cancellation: With this switch Tx Cancellation can be turned
        on or off. Please note that the Rx Cancellation is always
        enabled.
    :ivar data_pdu_ref: Reference to an Data NPdu.
    :ivar flow_control_pdu_ref: Reference to the Flow Control NPdu.
    :ivar max_block_size: The maximum number of N-PDUs the CanTp
        receiver allows the sender to send, before waiting for an
        authorization to continue transmission of the following N-PDUs.
        For further details on this parameter value see ISO 15765-2
        specification. Note: For reasons of buffer length, the CAN
        Transport Layer can adapt the BS value within the limit of this
        maximum BS
    :ivar multicast_ref: TP address for 1:n connections.
    :ivar padding_activation: This specifies whether or not Sfs, FCs and
        the last CF shall be padded to 8 bytes length in case it
        contains less payload. true: The N-PDU received uses padding for
        SF, FC and the last CF. (N-PDU length is always 8 bytes) false:
        The N-PDU received does not use padding for SF, CF and the last
        CF. (N-PDU length is dynamic)
    :ivar receiver_refs: The target of the TP connection.
    :ivar ta_type: Network Target Address type.
    :ivar timeout_br: Value in seconds of the performance requirement
        for (N_Br + N_Ar). N_Br is the elapsed time between the
        receiving indication of a FF or CF or the transmit confirmation
        of a FC, until the transmit request of the next FC.
    :ivar timeout_bs: This parameter defines the timeout for waiting for
        an FC or AF on the sender side in an 1:1 connection. Specified
        in seconds.
    :ivar timeout_cr: This parameter defines the timeout value for
        waiting for a CF or FF-x (in case of retry) after receiving the
        last CF or after sending an FC or AF on the receiver side.
        Specified in seconds.
    :ivar timeout_cs: The attribute timeoutCs represents the time (in
        seconds) which elapses between the transmit request of a CF
        N-PDU until the transmit request of the next CF N-PDU.
    :ivar tp_sdu_ref: Reference to an IPdu that is segmented by the
        Transport Protocol.
    :ivar transmit_cancellation: With this switch Transmit Cancellation
        can be turned on or off for this channel. Please note that this
        attribute is deprecated and will be removed in future.
    :ivar transmitter_ref: The source of the TP connection.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CanTpConfig.tpConnection
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-TP-CONNECTION"

    ident: TpConnectionIdent | None = field(
        default=None,
        metadata={
            "name": "IDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    addressing_format: CanTpAddressingFormatType | None = field(
        default=None,
        metadata={
            "name": "ADDRESSING-FORMAT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_tp_channel_ref: Optional["CanTpConnection.CanTpChannelRef"] = field(
        default=None,
        metadata={
            "name": "CAN-TP-CHANNEL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cancellation: Boolean | None = field(
        default=None,
        metadata={
            "name": "CANCELLATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_pdu_ref: Optional["CanTpConnection.DataPduRef"] = field(
        default=None,
        metadata={
            "name": "DATA-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    flow_control_pdu_ref: Optional["CanTpConnection.FlowControlPduRef"] = field(
        default=None,
        metadata={
            "name": "FLOW-CONTROL-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_block_size: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-BLOCK-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multicast_ref: Optional["CanTpConnection.MulticastRef"] = field(
        default=None,
        metadata={
            "name": "MULTICAST-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    padding_activation: Boolean | None = field(
        default=None,
        metadata={
            "name": "PADDING-ACTIVATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    receiver_refs: Optional["CanTpConnection.ReceiverRefs"] = field(
        default=None,
        metadata={
            "name": "RECEIVER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ta_type: NetworkTargetAddressType | None = field(
        default=None,
        metadata={
            "name": "TA-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_br: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-BR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_bs: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-BS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_cr: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-CR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_cs: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-CS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_sdu_ref: Optional["CanTpConnection.TpSduRef"] = field(
        default=None,
        metadata={
            "name": "TP-SDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmit_cancellation: Boolean | None = field(
        default=None,
        metadata={
            "name": "TRANSMIT-CANCELLATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmitter_ref: Optional["CanTpConnection.TransmitterRef"] = field(
        default=None,
        metadata={
            "name": "TRANSMITTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CanTpChannelRef(Ref):
        dest: CanTpChannelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataPduRef(Ref):
        dest: NPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FlowControlPduRef(Ref):
        dest: NPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MulticastRef(Ref):
        dest: CanTpAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ReceiverRefs:
        receiver_ref: list["CanTpConnection.ReceiverRefs.ReceiverRef"] = field(
            default_factory=list,
            metadata={
                "name": "RECEIVER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ReceiverRef(Ref):
            dest: CanTpNodeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TpSduRef(Ref):
        dest: IPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TransmitterRef(Ref):
        dest: CanTpNodeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CanTpEcu:
    """ECU specific TP configuration parameters.

    Each TpEcu element has a reference to exactly one ECUInstance in the
    topology.

    :ivar cycle_time_main_function: The period between successive calls
        to the Main Function of the AUTOSAR TP. Specified in seconds.
    :ivar ecu_instance_ref: Connection to the ECUInstance in the
        Topology
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: CanTpConfig.tpEcu
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-TP-ECU"

    cycle_time_main_function: TimeValue | None = field(
        default=None,
        metadata={
            "name": "CYCLE-TIME-MAIN-FUNCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["CanTpEcu.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CanTpNode:
    """
    TP Node (Sender or Receiver) provides the TP Address and the connection to the
    Topology description.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar connector_ref: Association to a CommunicationConnector in the
        topology description. In a System Description this reference is
        mandatory. In an ECU Extract this reference is optional
        (references to ECUs that are not part of the ECU Extract shall
        be avoided).
    :ivar max_fc_wait: This attribute defines the maximum number of flow
        control PDUs that can be consecutively be transmitted by a
        receiver.
    :ivar st_min: Sets the duration of the minimum time the CanTp sender
        shall wait between the transmissions of two CF N-PDUs.
    :ivar timeout_ar: This attribute states the timeout between the PDU
        transmit request of the Transport Layer to the Can Interface and
        the corresponding confirmation of the Can Interface on the
        receiver side (for FC or AF). Specified in seconds.
    :ivar timeout_as: This attribute states the timeout between the PDU
        transmit request for the first PDU of the group used in the
        current connection of the Transport Layer to the Can Interface
        and the corresponding confirmation of the Can Interface (when
        having sent the last PDU of the group used in this connection)
        on the sender side (SF-x, FF-x, CF or FC (in case of Transmit
        Cancellation)). Specified in seconds.
    :ivar tp_address_ref: Reference to the TP Address that is used by
        the TpNode. This reference is optional in case that the
        multicast TP Address is used (reference from TpConnection).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: CanTpConfig.tpNode
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-TP-NODE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CanTpNode.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CanTpNode.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    connector_ref: Optional["CanTpNode.ConnectorRef"] = field(
        default=None,
        metadata={
            "name": "CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_fc_wait: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-FC-WAIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    st_min: TimeValue | None = field(
        default=None,
        metadata={
            "name": "ST-MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_ar: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-AR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_as: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-AS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_address_ref: Optional["CanTpNode.TpAddressRef"] = field(
        default=None,
        metadata={
            "name": "TP-ADDRESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TpAddressRef(Ref):
        dest: CanTpAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CanXlProps:
    """'''begin restrict to AP''' This meta-class is used to configure Machine
    specific CAN XL attributes.

    '''end restrict to AP'''

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar can_baudrate: Specifies the data segment CAN 2.0 baud rate of
        the CAN XL controller in bits/s.
    :ivar can_config: CAN 2.0 configuration parameters for the CAN XL
        controller.
    :ivar can_fd_baudrate: Specifies the data segment CAN FD baud rate
        of the CAN XL controller in bits/s.
    :ivar can_fd_config: CAN FD configuration parameters for the CAN XL
        controller.
    :ivar can_xl_baudrate: Specifies the data segment CAN XL baud rate
        of the CAN XL controller in bits/s.
    :ivar can_xl_config: CAN XL configuration parameters for the CAN XL
        controller.
    :ivar can_xl_config_reqs: CAN XL configuration parameter
        requirements for the CAN XL controller.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-XL-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CanXlProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CanXlProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_baudrate: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CAN-BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_config: CanControllerConfiguration | None = field(
        default=None,
        metadata={
            "name": "CAN-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_fd_baudrate: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CAN-FD-BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_fd_config: CanControllerFdConfiguration | None = field(
        default=None,
        metadata={
            "name": "CAN-FD-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_xl_baudrate: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CAN-XL-BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_xl_config: CanControllerXlConfiguration | None = field(
        default=None,
        metadata={
            "name": "CAN-XL-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_xl_config_reqs: CanControllerXlConfigurationRequirements | None = field(
        default=None,
        metadata={
            "name": "CAN-XL-CONFIG-REQS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CheckpointTransition:
    """
    Defines one transition between two checkpoints.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar source_ref: Reference to the source checkpoint for this
        transition.
    :ivar target_ref: Reference to the target checkpoint for this
        transition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CHECKPOINT-TRANSITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CheckpointTransition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CheckpointTransition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_ref: Optional["CheckpointTransition.SourceRef"] = field(
        default=None,
        metadata={
            "name": "SOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_ref: Optional["CheckpointTransition.TargetRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SourceRef(Ref):
        dest: SupervisionCheckpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRef(Ref):
        dest: SupervisionCheckpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ClientIdDefinition:
    """Several clients in one client-ECU can communicate via inter-ECU client-
    server communication with a server on a different ECU, if a client identifier
    is used to distinguish the different clients.

    The Client Identifier of the transaction handle that is used by the
    RTE can be defined by this element.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar client_id: The Client Identifier of the transaction handle
        used for an inter-ECU client server communication is defined by
        this attribute. If defined the RTE generator shall use this
        clientId.
    :ivar client_server_operation_iref: Reference to the
        ClientServerOperation that is called by the client.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ClientIdDefinitionSet.clientIdDefinition
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-ID-DEFINITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ClientIdDefinition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ClientIdDefinition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_id: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "CLIENT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_server_operation_iref: OperationInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "CLIENT-SERVER-OPERATION-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ClientServerOperationBlueprintMapping:
    """
    This class describes a specific mapping between a ClientServerOperation in a
    ClientServerInterface blueprint and a BswModuleEntry blueprint.

    :ivar blueprint_mapping_guide: This attribute offers the possibility
        to provide additional information with respect to the mapping.
    :ivar bsw_module_entry_ref: The referenced BswModuleEntry represents
        the BswModuleEntry the mapping is dedicated to.
    :ivar client_server_operation_ref: The referenced
        ClientServerOperation represents the client server operation the
        mapping is dedicated to.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ClientServerInterfaceToBswModuleEntryBlueprintMapping.operationMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-OPERATION-BLUEPRINT-MAPPING"

    blueprint_mapping_guide: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-MAPPING-GUIDE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_module_entry_ref: Optional["ClientServerOperationBlueprintMapping.BswModuleEntryRef"] = (
        field(
            default=None,
            metadata={
                "name": "BSW-MODULE-ENTRY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    client_server_operation_ref: Optional[
        "ClientServerOperationBlueprintMapping.ClientServerOperationRef"
    ] = field(
        default=None,
        metadata={
            "name": "CLIENT-SERVER-OPERATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BswModuleEntryRef(Ref):
        dest: BswModuleEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ClientServerOperationRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ClientServerToSignalGroupMapping:
    """This mapping is deprecated and will be removed in future.

    It is replaced by the ClientServerToSignalMapping.
    Old description:
    Mapping of client server operation arguments to signals of a signal group. Arguments with a primitive datatype will be mapped via the "ClientServerPrimitiveTypeMapping" element.
    Arguments with composite datatypes will be mapped via the "CompositeTypeMapping" element.

    :ivar communication_direction: This attribute controls the direction
        into which the mapped SystemSignal is communicated with respect
        to the kind of PortPrototype used as the context element of the
        DataMapping.
    :ivar event_group_refs: Via this reference a connection between the
        VFB View and the Ethernet EventGroups can be created.
    :ivar event_handler_refs: Via this reference a connection between
        the VFB View and the Ethernet EventHandlers can be created.
    :ivar introduction: This represents introductory documentation about
        the data mapping.
    :ivar service_instance_refs: Via this reference a connection between
        the VFB View and the Ethernet Services can be created.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.dataMapping
    :ivar application_error: In client server communication, the server
        may return any value within the application error range.
    :ivar client_id: In case of a server on one ECU with multiple
        clients on other ECUs, the client server communication shall use
        different unique COM signals and signal groups for each client
        to allow the identification of the client associated with each
        system signal.
    :ivar composite_type_mappings: Mapping of arguments with composite
        datatypes.
    :ivar empty_signal: An emptySignal is created if no actual data is
        configured for a client-server communication, but if the RTE
        shall send a SignalGroup to initiate the communication. An
        EmptySignalMapping shall only reference a SystemSignal that is
        referenced by an ISignal with length equal to zero.
    :ivar mapped_operation_iref: Reference to a Operation, which is
        mapped to a signal group.
    :ivar primitive_type_mappings: Mapping of an argument with a
        primitive datatype to a signal.
    :ivar request_group_ref: Reference to the signal group which
        contains the references to request signals used to transport the
        IN and INOUT arguments of the operation.
    :ivar response_group_ref: Reference to the signal group which
        contains the references to response signals used to transport
        the OUT and INOUT arguments of the operation.
    :ivar sequence_counter: The purpose of sequence counters is to map a
        response to the correct request of a known client.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-TO-SIGNAL-GROUP-MAPPING"

    communication_direction: CommunicationDirectionType | None = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_refs: Optional["ClientServerToSignalGroupMapping.EventGroupRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_handler_refs: Optional["ClientServerToSignalGroupMapping.EventHandlerRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-HANDLER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_refs: Optional["ClientServerToSignalGroupMapping.ServiceInstanceRefs"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_error: ApplicationErrorMapping | None = field(
        default=None,
        metadata={
            "name": "APPLICATION-ERROR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_id: ClientIdMapping | None = field(
        default=None,
        metadata={
            "name": "CLIENT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    composite_type_mappings: Optional["ClientServerToSignalGroupMapping.CompositeTypeMappings"] = (
        field(
            default=None,
            metadata={
                "name": "COMPOSITE-TYPE-MAPPINGS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    empty_signal: EmptySignalMapping | None = field(
        default=None,
        metadata={
            "name": "EMPTY-SIGNAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapped_operation_iref: OperationInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "MAPPED-OPERATION-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    primitive_type_mappings: Optional["ClientServerToSignalGroupMapping.PrimitiveTypeMappings"] = (
        field(
            default=None,
            metadata={
                "name": "PRIMITIVE-TYPE-MAPPINGS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    request_group_ref: Optional["ClientServerToSignalGroupMapping.RequestGroupRef"] = field(
        default=None,
        metadata={
            "name": "REQUEST-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    response_group_ref: Optional["ClientServerToSignalGroupMapping.ResponseGroupRef"] = field(
        default=None,
        metadata={
            "name": "RESPONSE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sequence_counter: SequenceCounterMapping | None = field(
        default=None,
        metadata={
            "name": "SEQUENCE-COUNTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EventGroupRefs:
        event_group_ref: list["ClientServerToSignalGroupMapping.EventGroupRefs.EventGroupRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "EVENT-GROUP-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class EventGroupRef(Ref):
            dest: ConsumedEventGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class EventHandlerRefs:
        event_handler_ref: list[
            "ClientServerToSignalGroupMapping.EventHandlerRefs.EventHandlerRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-HANDLER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EventHandlerRef(Ref):
            dest: EventHandlerSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRefs:
        service_instance_ref: list[
            "ClientServerToSignalGroupMapping.ServiceInstanceRefs.ServiceInstanceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceInstanceRef(Ref):
            dest: AbstractServiceInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class CompositeTypeMappings:
        client_server_array_type_mapping: list[ClientServerArrayTypeMapping] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-ARRAY-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        client_server_record_type_mapping: list[ClientServerRecordTypeMapping] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-RECORD-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PrimitiveTypeMappings:
        client_server_primitive_type_mapping: list[ClientServerPrimitiveTypeMapping] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-PRIMITIVE-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequestGroupRef(Ref):
        dest: SystemSignalGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ResponseGroupRef(Ref):
        dest: SystemSignalGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ClientServerToSignalMapping:
    """
    This element maps the ClientServerOperation to call- and return-SystemSignals.

    :ivar communication_direction: This attribute controls the direction
        into which the mapped SystemSignal is communicated with respect
        to the kind of PortPrototype used as the context element of the
        DataMapping.
    :ivar event_group_refs: Via this reference a connection between the
        VFB View and the Ethernet EventGroups can be created.
    :ivar event_handler_refs: Via this reference a connection between
        the VFB View and the Ethernet EventHandlers can be created.
    :ivar introduction: This represents introductory documentation about
        the data mapping.
    :ivar service_instance_refs: Via this reference a connection between
        the VFB View and the Ethernet Services can be created.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.dataMapping
    :ivar call_signal_ref: Reference to the callSignal to which the IN
        and INOUT ArgumentDataPrototypes are mapped.
    :ivar client_server_operation_iref: Reference to a
        ClientServerOperation, which is mapped to a call SystemSignal
        and a return SystemSignal.
    :ivar length_client_id: This attribute defines the length of the
        used client identifier in bits.  If the attribute does not exist
        or its value is set to 0 this means that the client identifier
        is not used. Please note that this attribute is deprecated and
        will be removed in future (Value is fixed to UInt16).
    :ivar length_sequence_counter: The purpose of a sequence counter is
        to map a response to the correct request of a known client. This
        attribute describes the length of the used sequence counter in
        bits. If the attribute does not exist or its value is set to 0
        this means that the sequence counter is not used. Please note
        that this attribute is deprecated and will be removed in future
        (Value is fixed to UInt16).
    :ivar return_signal_ref: Reference to the returnSignal to which the
        OUT and INOUT ArgumentDataPrototypes are mapped.
    :ivar serializer_ref: The reference is set to obsolete. Use
        ISignal.dataTransformation instead.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-TO-SIGNAL-MAPPING"

    communication_direction: CommunicationDirectionType | None = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_refs: Optional["ClientServerToSignalMapping.EventGroupRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_handler_refs: Optional["ClientServerToSignalMapping.EventHandlerRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-HANDLER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_refs: Optional["ClientServerToSignalMapping.ServiceInstanceRefs"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    call_signal_ref: Optional["ClientServerToSignalMapping.CallSignalRef"] = field(
        default=None,
        metadata={
            "name": "CALL-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_server_operation_iref: OperationInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "CLIENT-SERVER-OPERATION-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length_client_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH-CLIENT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length_sequence_counter: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH-SEQUENCE-COUNTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    return_signal_ref: Optional["ClientServerToSignalMapping.ReturnSignalRef"] = field(
        default=None,
        metadata={
            "name": "RETURN-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    serializer_ref: Optional["ClientServerToSignalMapping.SerializerRef"] = field(
        default=None,
        metadata={
            "name": "SERIALIZER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EventGroupRefs:
        event_group_ref: list["ClientServerToSignalMapping.EventGroupRefs.EventGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EventGroupRef(Ref):
            dest: ConsumedEventGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class EventHandlerRefs:
        event_handler_ref: list["ClientServerToSignalMapping.EventHandlerRefs.EventHandlerRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "EVENT-HANDLER-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class EventHandlerRef(Ref):
            dest: EventHandlerSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRefs:
        service_instance_ref: list[
            "ClientServerToSignalMapping.ServiceInstanceRefs.ServiceInstanceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceInstanceRef(Ref):
            dest: AbstractServiceInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class CallSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ReturnSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SerializerRef(Ref):
        dest: SerializationTechnologySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Code:
    """A generic code descriptor.

    The type of the code (source or object) is defined via the category
    attribute of the associated engineering object.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar artifact_descriptors: Refers to the artifact belonging to this
        code descriptor.
    :ivar callback_header_refs: The association callbackHeader describes
        in which header files the function declarations of callback
        functions are provided to a service module. With this
        information the service module can include the appropriate
        header files in its configuration files.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CODE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Code.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Code.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    artifact_descriptors: Optional["Code.ArtifactDescriptors"] = field(
        default=None,
        metadata={
            "name": "ARTIFACT-DESCRIPTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    callback_header_refs: Optional["Code.CallbackHeaderRefs"] = field(
        default=None,
        metadata={
            "name": "CALLBACK-HEADER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ArtifactDescriptors:
        autosar_engineering_object: list[AutosarEngineeringObject] = field(
            default_factory=list,
            metadata={
                "name": "AUTOSAR-ENGINEERING-OBJECT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CallbackHeaderRefs:
        callback_header_ref: list["Code.CallbackHeaderRefs.CallbackHeaderRef"] = field(
            default_factory=list,
            metadata={
                "name": "CALLBACK-HEADER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CallbackHeaderRef(Ref):
            dest: ServiceNeedsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class ComCertificateToCryptoCertificateMapping:
    """
    This meta-class maps the CryptoServiceCertificate defined in the COM deployment
    to the CryptoCertificate defined in the Crypto Stack.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar crypto_certificate_ref: Reference to the CryptoCertifcate in
        the Crypto Stack.
    :ivar crypto_service_certificate_ref: Reference to the
        cryptoServiceCertificate in the Com deployment
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-CERTIFICATE-TO-CRYPTO-CERTIFICATE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "ComCertificateToCryptoCertificateMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComCertificateToCryptoCertificateMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_certificate_ref: Optional[
        "ComCertificateToCryptoCertificateMapping.CryptoCertificateRef"
    ] = field(
        default=None,
        metadata={
            "name": "CRYPTO-CERTIFICATE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_service_certificate_ref: Optional[
        "ComCertificateToCryptoCertificateMapping.CryptoServiceCertificateRef"
    ] = field(
        default=None,
        metadata={
            "name": "CRYPTO-SERVICE-CERTIFICATE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoCertificateRef(Ref):
        dest: CryptoCertificateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoServiceCertificateRef(Ref):
        dest: CryptoServiceCertificateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ComEventGrant:
    """
    This meta-class represents the ability to grant access to a
    ServiceInterface.event.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar remote_subject_refs: This optional reference defines the
        remoteSubject that is allowed to access the defined Object via
        the Grant.
    :ivar service_instance_ref: This reference identifies the applicable
        AdaptivePlatformServiceInstance for which the grant applies.
    :ivar design_ref: This reference identifies the ComEventGrantDesign
        that the enclosing ComEventGrant was created from.
    :ivar service_deployment_ref: This reference identifies the
        applicable deployment within the context of an
        AdaptivePlatformServiceInstance for which the grant applies.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-EVENT-GRANT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComEventGrant.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComEventGrant.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_subject_refs: Optional["ComEventGrant.RemoteSubjectRefs"] = field(
        default=None,
        metadata={
            "name": "REMOTE-SUBJECT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_ref: Optional["ComEventGrant.ServiceInstanceRef"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    design_ref: Optional["ComEventGrant.DesignRef"] = field(
        default=None,
        metadata={
            "name": "DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_deployment_ref: Optional["ComEventGrant.ServiceDeploymentRef"] = field(
        default=None,
        metadata={
            "name": "SERVICE-DEPLOYMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RemoteSubjectRefs:
        remote_subject_ref: list["ComEventGrant.RemoteSubjectRefs.RemoteSubjectRef"] = field(
            default_factory=list,
            metadata={
                "name": "REMOTE-SUBJECT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RemoteSubjectRef(Ref):
            dest: AbstractIamRemoteSubjectSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRef(Ref):
        dest: AdaptivePlatformServiceInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DesignRef(Ref):
        dest: ComEventGrantDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceDeploymentRef(Ref):
        dest: ServiceEventDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ComEventGrantDesign:
    """
    This meta-class represents the ability to define a Grant for a
    ServiceInterface.event.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar process_design_ref: This reference identifies the
        corresponding ProcessDesign that gives context to the
        GrantDesing.
    :ivar remote_subject_refs: This optional reference defines the
        remoteSubject that is allowed to access the defined Object via
        the Grant.
    :ivar event_iref: This reference represents the affected event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-EVENT-GRANT-DESIGN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComEventGrantDesign.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComEventGrantDesign.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_design_ref: Optional["ComEventGrantDesign.ProcessDesignRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_subject_refs: Optional["ComEventGrantDesign.RemoteSubjectRefs"] = field(
        default=None,
        metadata={
            "name": "REMOTE-SUBJECT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_iref: EventInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "EVENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessDesignRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RemoteSubjectRefs:
        remote_subject_ref: list["ComEventGrantDesign.RemoteSubjectRefs.RemoteSubjectRef"] = field(
            default_factory=list,
            metadata={
                "name": "REMOTE-SUBJECT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RemoteSubjectRef(Ref):
            dest: AbstractIamRemoteSubjectSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class ComFieldGrant:
    """
    This meta-class represents the ability to grant access to a
    ServiceInterface.field.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar remote_subject_refs: This optional reference defines the
        remoteSubject that is allowed to access the defined Object via
        the Grant.
    :ivar service_instance_ref: This reference identifies the applicable
        AdaptivePlatformServiceInstance for which the grant applies.
    :ivar design_ref: This reference identifies the ComFieldGrantDesign
        that the enclosing ComFieldGrant was created from.
    :ivar role: This attribute provides the ability to further specify
        the access to the ServiceInterface.field.
    :ivar service_deployment_ref: This reference identifies the
        applicable deployment within the context of an
        AdaptivePlatformServiceInstance for which the grant applies.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-FIELD-GRANT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComFieldGrant.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComFieldGrant.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_subject_refs: Optional["ComFieldGrant.RemoteSubjectRefs"] = field(
        default=None,
        metadata={
            "name": "REMOTE-SUBJECT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_ref: Optional["ComFieldGrant.ServiceInstanceRef"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    design_ref: Optional["ComFieldGrant.DesignRef"] = field(
        default=None,
        metadata={
            "name": "DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    role: FieldAccessEnum | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_deployment_ref: Optional["ComFieldGrant.ServiceDeploymentRef"] = field(
        default=None,
        metadata={
            "name": "SERVICE-DEPLOYMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RemoteSubjectRefs:
        remote_subject_ref: list["ComFieldGrant.RemoteSubjectRefs.RemoteSubjectRef"] = field(
            default_factory=list,
            metadata={
                "name": "REMOTE-SUBJECT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RemoteSubjectRef(Ref):
            dest: AbstractIamRemoteSubjectSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRef(Ref):
        dest: AdaptivePlatformServiceInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DesignRef(Ref):
        dest: ComFieldGrantDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceDeploymentRef(Ref):
        dest: ServiceFieldDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ComFieldGrantDesign:
    """
    This meta-class represents the ability to define a Grant for a
    ServiceInterface.field.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar process_design_ref: This reference identifies the
        corresponding ProcessDesign that gives context to the
        GrantDesing.
    :ivar remote_subject_refs: This optional reference defines the
        remoteSubject that is allowed to access the defined Object via
        the Grant.
    :ivar field_iref: Reference to the affected Field in the context of
        an Executable.
    :ivar role: This attribute provides the ability to further specify
        the access to the ServiceInterface.field from a design
        perspective.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-FIELD-GRANT-DESIGN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComFieldGrantDesign.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComFieldGrantDesign.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_design_ref: Optional["ComFieldGrantDesign.ProcessDesignRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_subject_refs: Optional["ComFieldGrantDesign.RemoteSubjectRefs"] = field(
        default=None,
        metadata={
            "name": "REMOTE-SUBJECT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_iref: FieldInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "FIELD-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    role: FieldAccessEnum | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessDesignRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RemoteSubjectRefs:
        remote_subject_ref: list["ComFieldGrantDesign.RemoteSubjectRefs.RemoteSubjectRef"] = field(
            default_factory=list,
            metadata={
                "name": "REMOTE-SUBJECT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RemoteSubjectRef(Ref):
            dest: AbstractIamRemoteSubjectSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class ComFindServiceGrant:
    """
    This meta-class represents the ability to grant the finding a service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar design_ref: This reference identifies the
        ComFindServiceGrantDesign that the enclosing ComFindServiceGrant
        was created from.
    :ivar service_instance_ref: This reference identifies the
        AdaptivePlatformServiceInstances for which the grant applies.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-FIND-SERVICE-GRANT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComFindServiceGrant.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComFindServiceGrant.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    design_ref: Optional["ComFindServiceGrant.DesignRef"] = field(
        default=None,
        metadata={
            "name": "DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_ref: Optional["ComFindServiceGrant.ServiceInstanceRef"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DesignRef(Ref):
        dest: ComFindServiceGrantDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRef(Ref):
        dest: AdaptivePlatformServiceInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ComFindServiceGrantDesign:
    """
    This meta-class represents the ability to define a Grant for finding a service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar process_design_ref: This reference identifies the
        corresponding ProcessDesign that gives context to the
        GrantDesing.
    :ivar required_service_port_iref: This instanceRef identifies the
        RPortPrototype on which the service shall be found.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-FIND-SERVICE-GRANT-DESIGN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComFindServiceGrantDesign.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComFindServiceGrantDesign.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_design_ref: Optional["ComFindServiceGrantDesign.ProcessDesignRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_service_port_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "REQUIRED-SERVICE-PORT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessDesignRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ComKeyToCryptoKeySlotMapping:
    """
    This meta-class maps the CryptoServiceKey defined in the COM deployment to the
    CryptoKeySlot defined in the Crypto Stack.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar crypto_service_key_ref: Reference to the cryptoServiceKey in
        the Com deployment
    :ivar key_slot_ref: Reference to the CryptoKeySlot in the Crypto
        Stack.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-KEY-TO-CRYPTO-KEY-SLOT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComKeyToCryptoKeySlotMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComKeyToCryptoKeySlotMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_service_key_ref: Optional["ComKeyToCryptoKeySlotMapping.CryptoServiceKeyRef"] = field(
        default=None,
        metadata={
            "name": "CRYPTO-SERVICE-KEY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_slot_ref: Optional["ComKeyToCryptoKeySlotMapping.KeySlotRef"] = field(
        default=None,
        metadata={
            "name": "KEY-SLOT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoServiceKeyRef(Ref):
        dest: CryptoServiceKeySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class KeySlotRef(Ref):
        dest: CryptoKeySlotSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ComManagementMapping:
    """
    Describes a mapping between one or several Mode Management PortGroups and
    communication channels.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar com_management_group_refs: IPduGroup participating in a Mode
        Management PortGroup.
    :ivar com_management_port_group_irefs: Mode Management PortGroup to
        be mapped onto a communication channel. This reference is
        optional in case that the System Description doesn't use a
        complete Software Component Description (VFB View). This
        supports the inclusion of legacy systems.
    :ivar physical_channel_refs: This reference maps the Mode Management
        PortGroup partial network to communication channels.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.comManagementMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-MANAGEMENT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComManagementMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComManagementMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    com_management_group_refs: Optional["ComManagementMapping.ComManagementGroupRefs"] = field(
        default=None,
        metadata={
            "name": "COM-MANAGEMENT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    com_management_port_group_irefs: Optional[
        "ComManagementMapping.ComManagementPortGroupIrefs"
    ] = field(
        default=None,
        metadata={
            "name": "COM-MANAGEMENT-PORT-GROUP-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_channel_refs: Optional["ComManagementMapping.PhysicalChannelRefs"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNEL-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ComManagementGroupRefs:
        com_management_group_ref: list[
            "ComManagementMapping.ComManagementGroupRefs.ComManagementGroupRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "COM-MANAGEMENT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ComManagementGroupRef(Ref):
            dest: ISignalIPduGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ComManagementPortGroupIrefs:
        com_management_port_group_iref: list[PortGroupInSystemInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "COM-MANAGEMENT-PORT-GROUP-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannelRefs:
        physical_channel_ref: list[
            "ComManagementMapping.PhysicalChannelRefs.PhysicalChannelRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "PHYSICAL-CHANNEL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PhysicalChannelRef(Ref):
            dest: PhysicalChannelSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class ComMethodGrant:
    """
    This meta-class represents the ability to grant access to a
    ServiceInterface.method.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar remote_subject_refs: This optional reference defines the
        remoteSubject that is allowed to access the defined Object via
        the Grant.
    :ivar service_instance_ref: This reference identifies the applicable
        AdaptivePlatformServiceInstance for which the grant applies.
    :ivar design_ref: This reference identifies the ComMethodGrantDesign
        that the enclosing ComMethodGrant was created from.
    :ivar service_deployment_ref: This reference identifies the
        applicable deployment within the context of an
        AdaptivePlatformServiceInstance for which the grant applies.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-METHOD-GRANT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComMethodGrant.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComMethodGrant.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_subject_refs: Optional["ComMethodGrant.RemoteSubjectRefs"] = field(
        default=None,
        metadata={
            "name": "REMOTE-SUBJECT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_ref: Optional["ComMethodGrant.ServiceInstanceRef"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    design_ref: Optional["ComMethodGrant.DesignRef"] = field(
        default=None,
        metadata={
            "name": "DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_deployment_ref: Optional["ComMethodGrant.ServiceDeploymentRef"] = field(
        default=None,
        metadata={
            "name": "SERVICE-DEPLOYMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RemoteSubjectRefs:
        remote_subject_ref: list["ComMethodGrant.RemoteSubjectRefs.RemoteSubjectRef"] = field(
            default_factory=list,
            metadata={
                "name": "REMOTE-SUBJECT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RemoteSubjectRef(Ref):
            dest: AbstractIamRemoteSubjectSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRef(Ref):
        dest: AdaptivePlatformServiceInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DesignRef(Ref):
        dest: ComMethodGrantDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceDeploymentRef(Ref):
        dest: ServiceMethodDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ComMethodGrantDesign:
    """
    This meta-class represents the ability to define a Grant for a
    ServiceInterface.method.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar process_design_ref: This reference identifies the
        corresponding ProcessDesign that gives context to the
        GrantDesing.
    :ivar remote_subject_refs: This optional reference defines the
        remoteSubject that is allowed to access the defined Object via
        the Grant.
    :ivar method_iref: This reference identifies the corresponding
        method.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-METHOD-GRANT-DESIGN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComMethodGrantDesign.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComMethodGrantDesign.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_design_ref: Optional["ComMethodGrantDesign.ProcessDesignRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_subject_refs: Optional["ComMethodGrantDesign.RemoteSubjectRefs"] = field(
        default=None,
        metadata={
            "name": "REMOTE-SUBJECT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_iref: RequiredMethodInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "METHOD-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessDesignRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RemoteSubjectRefs:
        remote_subject_ref: list["ComMethodGrantDesign.RemoteSubjectRefs.RemoteSubjectRef"] = field(
            default_factory=list,
            metadata={
                "name": "REMOTE-SUBJECT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RemoteSubjectRef(Ref):
            dest: AbstractIamRemoteSubjectSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class ComMgrUserNeeds:
    """
    Specifies the abstract needs on the configuration of the Communication Manager
    for one "user".

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar max_comm_mode: Maximum communication mode requested by this
        ComM user.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-MGR-USER-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComMgrUserNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComMgrUserNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_comm_mode: MaxCommModeEnum | None = field(
        default=None,
        metadata={
            "name": "MAX-COMM-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ComOfferServiceGrant:
    """
    This meta-class represents the ability to grant the offering of a service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar design_ref: This reference identifies the
        ComOfferServiceGrantDesign that the enclosing
        ComOfferServiceGrant was created from.
    :ivar service_instance_ref: This reference identifies the
        AdaptivePlatformServiceInstances for which the grant applies.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-OFFER-SERVICE-GRANT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComOfferServiceGrant.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComOfferServiceGrant.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    design_ref: Optional["ComOfferServiceGrant.DesignRef"] = field(
        default=None,
        metadata={
            "name": "DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_ref: Optional["ComOfferServiceGrant.ServiceInstanceRef"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DesignRef(Ref):
        dest: ComOfferServiceGrantDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRef(Ref):
        dest: AdaptivePlatformServiceInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ComOfferServiceGrantDesign:
    """
    This meta-class represents the ability to define a Grant for offering a
    service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar process_design_ref: This reference identifies the
        corresponding ProcessDesign that gives context to the
        GrantDesing.
    :ivar provided_service_port_iref: This instanceRef identifies the
        PPortPrototype on which the service shall be offered.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-OFFER-SERVICE-GRANT-DESIGN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComOfferServiceGrantDesign.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComOfferServiceGrantDesign.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_design_ref: Optional["ComOfferServiceGrantDesign.ProcessDesignRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_service_port_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PROVIDED-SERVICE-PORT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessDesignRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ComSecOcToCryptoKeySlotMapping:
    """
    This meta-class maps the ServiceElementSecureComConfig defined in the COM
    deployment to the CryptoKeySlot defined in the Crypto Stack.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar crypto_key_slot_ref: Reference to the CryptoKeySlot in the
        Crypto Stack.
    :ivar service_element_secure_com_config_ref: Reference to the
        ServiceInterfaceElementSecureComConfig element in the COM
        config.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-SEC-OC-TO-CRYPTO-KEY-SLOT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComSecOcToCryptoKeySlotMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComSecOcToCryptoKeySlotMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_key_slot_ref: Optional["ComSecOcToCryptoKeySlotMapping.CryptoKeySlotRef"] = field(
        default=None,
        metadata={
            "name": "CRYPTO-KEY-SLOT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_element_secure_com_config_ref: Optional[
        "ComSecOcToCryptoKeySlotMapping.ServiceElementSecureComConfigRef"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-ELEMENT-SECURE-COM-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoKeySlotRef(Ref):
        dest: CryptoKeySlotSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceElementSecureComConfigRef(Ref):
        dest: ServiceInterfaceElementSecureComConfigSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ComTriggerGrantDesign:
    """
    This meta-class represents the ability to define a Grant for a
    ServiceInterface.trigger.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar process_design_ref: This reference identifies the
        corresponding ProcessDesign that gives context to the
        GrantDesing.
    :ivar remote_subject_refs: This optional reference defines the
        remoteSubject that is allowed to access the defined Object via
        the Grant.
    :ivar trigger_iref: This reference represents the affected trigger.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COM-TRIGGER-GRANT-DESIGN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComTriggerGrantDesign.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComTriggerGrantDesign.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_design_ref: Optional["ComTriggerGrantDesign.ProcessDesignRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_subject_refs: Optional["ComTriggerGrantDesign.RemoteSubjectRefs"] = field(
        default=None,
        metadata={
            "name": "REMOTE-SUBJECT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_iref: TriggerInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "TRIGGER-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessDesignRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RemoteSubjectRefs:
        remote_subject_ref: list["ComTriggerGrantDesign.RemoteSubjectRefs.RemoteSubjectRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "REMOTE-SUBJECT-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class RemoteSubjectRef(Ref):
            dest: AbstractIamRemoteSubjectSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class CommonSignalPath:
    """
    The CommonSignalPath describes that two or more SwcToSwcSignals and/or
    SwcToSwcOperationArguments shall take the same way (Signal Path) in the
    topology.

    :ivar introduction: This represents introductory documentation about
        the signal path constraint.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.signalPathConstraint
    :ivar operations: The arguments sent in one direction (either from
        client to server or server to client) of the operations that
        shall take the same signal path.
    :ivar signals: The SwcToSwcSignals that shall take the same way
        (Signal Path) in the topology.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMMON-SIGNAL-PATH"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operations: Optional["CommonSignalPath.Operations"] = field(
        default=None,
        metadata={
            "name": "OPERATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signals: Optional["CommonSignalPath.Signals"] = field(
        default=None,
        metadata={
            "name": "SIGNALS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Operations:
        swc_to_swc_operation_arguments: list[SwcToSwcOperationArguments] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TO-SWC-OPERATION-ARGUMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Signals:
        swc_to_swc_signal: list[SwcToSwcSignal] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TO-SWC-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CommunicationConnectorRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar communication_connector_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMMUNICATION-CONNECTOR-REF-CONDITIONAL"

    communication_connector_ref: Optional[
        "CommunicationConnectorRefConditional.CommunicationConnectorRef"
    ] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Compiler:
    """Specifies the compiler attributes.

    In case of source code this specifies requirements how the compiler
    shall be invoked. In case of object code this documents the used
    compiler settings.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar name: Compiler name (like gcc).
    :ivar options: Specifies the compiler options.
    :ivar vendor: Vendor of compiler.
    :ivar version: Exact version of compiler executable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPILER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Compiler.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Compiler.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    name: String | None = field(
        default=None,
        metadata={
            "name": "NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    options: String | None = field(
        default=None,
        metadata={
            "name": "OPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vendor: String | None = field(
        default=None,
        metadata={
            "name": "VENDOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: String | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ComponentClustering:
    """Constraint that forces the mapping of all referenced SW component instances
    to the same ECU, Core, Partition depending on the defined mappingScope
    attribute.

    If mappingScope is not specified then mappingScopeEcu shall be
    assumed.

    :ivar introduction: This represents introductory documentation about
        the mapping constraint.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.mappingConstraint
    :ivar clustered_component_irefs: Reference to the components that
        have to be mapped together.
    :ivar mapping_scope: This attribute indicates whether the
        ComponentClustering mapping constraint applies to different
        ECUs, partitions or cores. If this attribute is not specified
        then mappingScopeEcu shall be assumed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPONENT-CLUSTERING"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clustered_component_irefs: Optional["ComponentClustering.ClusteredComponentIrefs"] = field(
        default=None,
        metadata={
            "name": "CLUSTERED-COMPONENT-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapping_scope: MappingScopeEnum | None = field(
        default=None,
        metadata={
            "name": "MAPPING-SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ClusteredComponentIrefs:
        clustered_component_iref: list[ComponentInSystemInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "CLUSTERED-COMPONENT-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ComponentSeparation:
    """Constraint that forces the two referenced SW components (called A and B in
    the following) not to be mapped to the same ECU, Core, Partition depending on
    the defined mappingScope attribute.

    If mappingScope is not specified then mappingScopeEcu shall be
    assumed. If a SW component (e.g. A) is a composition, none of the
    atomic SW components making up the A composition shall be mapped
    together with any of the atomic SW components making up the B
    composition. Furthermore, A and B shall be disjoint.

    :ivar introduction: This represents introductory documentation about
        the mapping constraint.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.mappingConstraint
    :ivar mapping_scope: This attribute indicates whether the
        ComponentSeparation mapping constraint applies to different
        ECUs, partitions or cores. If this attribute is not specified
        then mappingScopeEcu shall be assumed.
    :ivar separated_component_irefs: The two components that have to be
        mapped to different ECUs
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPONENT-SEPARATION"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapping_scope: MappingScopeEnum | None = field(
        default=None,
        metadata={
            "name": "MAPPING-SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    separated_component_irefs: Optional["ComponentSeparation.SeparatedComponentIrefs"] = field(
        default=None,
        metadata={
            "name": "SEPARATED-COMPONENT-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SeparatedComponentIrefs:
        separated_component_iref: list[ComponentInSystemInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "SEPARATED-COMPONENT-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 2,
            },
        )


@dataclass(slots=True, kw_only=True)
class CompositionPPortToExecutablePPortMapping:
    """
    This meta-class has the ability to associate a PPortPrototype defined in the
    context of a SwClusterDesign to a PPortPrototype in the context of an
    Executable.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar process_design_ref: This reference identifies the impacted
        ProcessDesign for this mapping. This allows for mapping multiple
        services to the same PortPrototype on an Executable by also
        referencing different ProcessDesigns.
    :ivar executable_provided_port_iref: This reference identifies the
        applicable PortPrototype in the context on an Executable.
    :ivar sw_cluster_design_provided_port_iref: This reference
        identifies the applicable PPortPrototype in the context of the
        SwClusterDesign.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPOSITION-P-PORT-TO-EXECUTABLE-P-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "CompositionPPortToExecutablePPortMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CompositionPPortToExecutablePPortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_design_ref: Optional["CompositionPPortToExecutablePPortMapping.ProcessDesignRef"] = (
        field(
            default=None,
            metadata={
                "name": "PROCESS-DESIGN-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    executable_provided_port_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-PROVIDED-PORT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_cluster_design_provided_port_iref: (
        PPortPrototypeInSoftwareClusterDesignInstanceRef | None
    ) = field(
        default=None,
        metadata={
            "name": "SW-CLUSTER-DESIGN-PROVIDED-PORT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessDesignRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CompositionRPortToExecutableRPortMapping:
    """
    This meta-class has the ability to associate an RPortPrototype defined in the
    context of a SwClusterDesign to an RPortPrototype in the context of an
    Executable.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar process_design_ref: This reference identifies the impacted
        ProcessDesign for this mapping. This allows for mapping multiple
        services to the same PortPrototype on an Executable by also
        referencing different ProcessDesigns.
    :ivar executable_required_port_iref: This reference identifies the
        applicable PortPrototype in the context on an Executable.
    :ivar sw_cluster_design_required_port_iref: This reference
        identifies the applicable RPortPrototype in the context of the
        SwClusterDesign.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPOSITION-R-PORT-TO-EXECUTABLE-R-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "CompositionRPortToExecutableRPortMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CompositionRPortToExecutableRPortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_design_ref: Optional["CompositionRPortToExecutableRPortMapping.ProcessDesignRef"] = (
        field(
            default=None,
            metadata={
                "name": "PROCESS-DESIGN-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    executable_required_port_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-REQUIRED-PORT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_cluster_design_required_port_iref: (
        RPortPrototypeInSoftwareClusterDesignInstanceRef | None
    ) = field(
        default=None,
        metadata={
            "name": "SW-CLUSTER-DESIGN-REQUIRED-PORT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessDesignRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CompositionSwComponentTypeRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar composition_sw_component_type_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPOSITION-SW-COMPONENT-TYPE-REF-CONDITIONAL"

    composition_sw_component_type_ref: Optional[
        "CompositionSwComponentTypeRefConditional.CompositionSwComponentTypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "COMPOSITION-SW-COMPONENT-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CompositionSwComponentTypeRef(Ref):
        dest: CompositionSwComponentTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CompuScale:
    """
    This meta-class represents the ability to specify one segment of a segmented
    computation method.

    :ivar short_label: This element specifies a short name for the
        particular scale. The name can for example be used to derive a
        programming language identifier.
    :ivar symbol: The symbol, if provided, is used by code generators to
        get a C identifier for the CompuScale. The name will be used as
        is for the code generation, therefore it needs to be unique
        within the generation context.
    :ivar desc: &lt;desc&gt; represents a general but brief description
        of the object in question.
    :ivar mask: In difference to all the other computational methods
        every COMPU-SCALE will be applied including the bit MASK.
        Therefore it is allowed for this type of COMPU-METHOD, that
        COMPU-SCALES overlap. To calculate the string reverse to a
        value, the string has to be split and the according value for
        each substring has to be summed up. The sum is finally
        transmitted. The processing has to be done in order of the
        COMPU-SCALE elements.
    :ivar lower_limit: This specifies the lower limit of the scale.
    :ivar upper_limit: This specifies the upper limit of a of the scale.
    :ivar compu_inverse_value: This is the inverse value of the
        constraint. This supports the case that the scale is not
        reversible per se.
    :ivar compu_const: This represents the fact that the scale is a
        constant. The use case is mainly a non interpolated scale. It is
        a simplification of the fact that a constant scale can also be
        expressed as rational function of order 0.
    :ivar compu_rational_coeffs: This specifies the coefficients of the
        rational formula.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: CompuScales.compuScale
        Not Applicable for: BufferProperties.bufferComputation
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPU-SCALE"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mask: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_limit: Limit | None = field(
        default=None,
        metadata={
            "name": "LOWER-LIMIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_limit: Limit | None = field(
        default=None,
        metadata={
            "name": "UPPER-LIMIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compu_inverse_value: CompuConst | None = field(
        default=None,
        metadata={
            "name": "COMPU-INVERSE-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compu_const: CompuConst | None = field(
        default=None,
        metadata={
            "name": "COMPU-CONST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compu_rational_coeffs: CompuRationalCoeffs | None = field(
        default=None,
        metadata={
            "name": "COMPU-RATIONAL-COEFFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ConcretePatternEventTriggering:
    """
    The ConcretePatternEventTriggering describes the behavior of an event, which
    occurs following a precisely known pattern.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar timing_condition_ref: A timing condition the timing constraint
        depends on. In other words it specifies the condition the timing
        constraint holds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingRequirement Applicable for:
        TimingExtension.timingGuarantee
    :ivar event_ref: The referenced timing event
    :ivar pattern_jitter: The optional parameter "Pattern Jitter"
        specifies the deviation of the time interval's starting point
        from the beginning of the given period. This parameter is only
        applicable in conjunction with the parameter "Pattern Period".
    :ivar pattern_period: The optional parameter "Pattern Period"
        specifies the time distance between the beginnings of subsequent
        repetitions of the given concrete pattern.
    :ivar offsets: The offset for each occurrence of the event in the
        specified time interval.
    :ivar pattern_length: The length of the observed time interval.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONCRETE-PATTERN-EVENT-TRIGGERING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ConcretePatternEventTriggering.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ConcretePatternEventTriggering.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["ConcretePatternEventTriggering.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_condition_ref: Optional["ConcretePatternEventTriggering.TimingConditionRef"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["ConcretePatternEventTriggering.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pattern_jitter: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "PATTERN-JITTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pattern_period: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "PATTERN-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offsets: Optional["ConcretePatternEventTriggering.Offsets"] = field(
        default=None,
        metadata={
            "name": "OFFSETS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pattern_length: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "PATTERN-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["ConcretePatternEventTriggering.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimingConditionRef(Ref):
        dest: TimingConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: TimingDescriptionEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Offsets:
        time_value: list[MultidimensionalTime] = field(
            default_factory=list,
            metadata={
                "name": "TIME-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ConstantReference:
    """
    Instead of defining this value inline, a constant is referenced.

    :ivar short_label: This can be used to identify particular value
        specifications for human readers, for example elements of a
        record type.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ArrayValueSpecification.element Applicable for:
        RecordValueSpecification.field Not Applicable for:
        CompositeRuleBasedValueSpecification.argument Not Applicable
        for: ConstantSpecification.valueSpec Not Applicable for:
        PortPrototypeBlueprintInitValue.value Not Applicable for:
        DiagnosticEnvDataCondition.compareValue Not Applicable for:
        DiagnosticEnvDataElementCondition.compareValue Not Applicable
        for: ParameterDataPrototype.initValue Not Applicable for:
        VariableDataPrototype.initValue Not Applicable for:
        CalibrationParameterValue.applInitValue Not Applicable for:
        CalibrationParameterValue.implInitValue Not Applicable for:
        MetaDataItem.metaDataItemType Not Applicable for:
        NvProvideComSpec.romBlockInitValue Not Applicable for:
        NvProvideComSpec.ramBlockInitValue Not Applicable for:
        NvRequireComSpec.initValue Not Applicable for:
        ParameterProvideComSpec.initValue Not Applicable for:
        ParameterRequireComSpec.initValue Not Applicable for:
        NonqueuedSenderComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.timeoutSubstitutionValue Not Applicable
        for: PortDefinedArgumentValue.value Not Applicable for:
        CryptoServiceKey.developmentValue Not Applicable for:
        ISignal.timeoutSubstitutionValue Not Applicable for:
        ISignal.initValue Not Applicable for:
        FieldSenderComSpec.initValue Not Applicable for:
        PersistencyDataRequiredComSpec.initValue Not Applicable for:
        ApplicationAssocMapElementValueSpecification.value Not
        Applicable for: ApplicationAssocMapElementValueSpecification.key
        Not Applicable for: StateManagementCompareCondition.compareValue
        Not Applicable for: PersistencyKeyValuePair.initValue Not
        Applicable for: SwDataDefPropsContent.invalidValue
    :ivar constant_ref: The referenced constant.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONSTANT-REFERENCE"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    constant_ref: Optional["ConstantReference.ConstantRef"] = field(
        default=None,
        metadata={
            "name": "CONSTANT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ConstantRef(Ref):
        dest: ConstantSpecificationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ConstantSpecificationMappingSet:
    """This meta-class represents the ability to map two ConstantSpecifications to
    each others.

    One ConstantSpecification is supposed to be described in the
    application domain and the other should be described in the
    implementation domain.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar mappings: ConstantSpecificationMappings owned by the
        ConstantSpecificationMappingSet.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONSTANT-SPECIFICATION-MAPPING-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ConstantSpecificationMappingSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ConstantSpecificationMappingSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mappings: Optional["ConstantSpecificationMappingSet.Mappings"] = field(
        default=None,
        metadata={
            "name": "MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Mappings:
        constant_specification_mapping: list[ConstantSpecificationMapping] = field(
            default_factory=list,
            metadata={
                "name": "CONSTANT-SPECIFICATION-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ConstraintTailoring:
    """Tailoring of constraints.

    If a constraint is in scope, then the severity defines its Error
    Severity Level. If it is not in scope, then the constraint is
    disabled.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alternative_name: Alternative name of a specification element
        if its name doesn't fit into the shortName. E.g. because the
        name contains spaces.
    :ivar in_scope: indicates, if a specification element is relevant
        for this data exchange point. It is relevant if inScope==true.
        It is not relevant or don't care if inScope=false.
    :ivar severity: Severity level that is reported in case the
        restriction is violated.
    :ivar constraint_ref: Reference to custom specification of
        constraint.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONSTRAINT-TAILORING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ConstraintTailoring.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ConstraintTailoring.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alternative_name: String | None = field(
        default=None,
        metadata={
            "name": "ALTERNATIVE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    in_scope: Boolean | None = field(
        default=None,
        metadata={
            "name": "IN-SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    severity: SeverityEnum | None = field(
        default=None,
        metadata={
            "name": "SEVERITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    constraint_ref: Optional["ConstraintTailoring.ConstraintRef"] = field(
        default=None,
        metadata={
            "name": "CONSTRAINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConstraintRef(Ref):
        dest: TraceableTextSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ConsumedProvidedServiceInstanceGroupRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar consumed_provided_service_instance_group_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONSUMED-PROVIDED-SERVICE-INSTANCE-GROUP-REF-CONDITIONAL"

    consumed_provided_service_instance_group_ref: Optional[
        "ConsumedProvidedServiceInstanceGroupRefConditional.ConsumedProvidedServiceInstanceGroupRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONSUMED-PROVIDED-SERVICE-INSTANCE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ConsumedProvidedServiceInstanceGroupRef(Ref):
        dest: ConsumedProvidedServiceInstanceGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ConsumedServiceInstanceRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar consumed_service_instance_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONSUMED-SERVICE-INSTANCE-REF-CONDITIONAL"

    consumed_service_instance_ref: Optional[
        "ConsumedServiceInstanceRefConditional.ConsumedServiceInstanceRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONSUMED-SERVICE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ConsumedServiceInstanceRef(Ref):
        dest: ConsumedServiceInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ContainerIPdu:
    """
    Allows to collect several IPdus in one ContainerIPdu based on the headerType.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar has_dynamic_length: This attribute defines whether the Pdu has
        dynamic length (true) or not (false). Please note that the usage
        of this attribute is restricted by [constr_3448].
    :ivar length: Pdu length in bytes. In case of dynamic length IPdus
        (containing a dynamical length signal), this value indicates the
        maximum data length. It should be noted that in former AUTOSAR
        releases (Rel 2.1, Rel 3.0, Rel 3.1, Rel 4.0 Rev. 1) this
        parameter was defined in bits. The Pdu length of zero bytes is
        allowed.
    :ivar meta_data_length: Number of additional bytes of MetaData in
        the PDU data field. The MetaData contains auxiliary information
        for the PDU, e.g. the CAN ID.
    :ivar contained_i_pdu_props: Defines whether this IPdu may be
        collected inside a ContainerIPdu.
    :ivar contained_i_pdu_triggering_propss: Defines properties for an
        IPdu that is part of the ContainerIPdu.
    :ivar contained_pdu_triggering_refs: This PduTriggering shall be
        collected inside the ContainerIPdu.
    :ivar container_timeout: When this timeout expires the ContainerIPdu
        is sent out. The respective timer is started when the first Ipdu
        is put into the ContainerIPdu. This attribute is ignored on
        receiver side.
    :ivar container_trigger: Defines if the transmission of the
        ContainerIPdu shall be requested right after the first
        ContainedIPdu was put into it. This attribute shall be ignored
        on receiver side.
    :ivar header_type: Defines whether and which header type is used
        (header id and length).
    :ivar minimum_rx_container_queue_size: This attribute defines the
        minimum queue size for received containers.
    :ivar minimum_tx_container_queue_size: This attribute defines the
        minimum queue size for transmitted containers.
    :ivar rx_accept_contained_i_pdu: Defines whether this ContainerIPdu
        has a fixed set of containedIPdus assigned for reception.
    :ivar threshold_size: Defines the size threshold which, when
        exceeded, triggers the sending of the ContainerIPdu although the
        maximum Pdu size has not been reached yet. Unit: byte.
    :ivar unused_bit_pattern: IPduM fills not updated areas of the
        ContainerPdu with this byte-pattern.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONTAINER-I-PDU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ContainerIPdu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ContainerIPdu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_dynamic_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-DYNAMIC-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "META-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_i_pdu_props: ContainedIPduProps | None = field(
        default=None,
        metadata={
            "name": "CONTAINED-I-PDU-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_i_pdu_triggering_propss: Optional["ContainerIPdu.ContainedIPduTriggeringPropss"] = (
        field(
            default=None,
            metadata={
                "name": "CONTAINED-I-PDU-TRIGGERING-PROPSS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    contained_pdu_triggering_refs: Optional["ContainerIPdu.ContainedPduTriggeringRefs"] = field(
        default=None,
        metadata={
            "name": "CONTAINED-PDU-TRIGGERING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    container_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "CONTAINER-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    container_trigger: ContainerIPduTriggerEnum | None = field(
        default=None,
        metadata={
            "name": "CONTAINER-TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    header_type: ContainerIPduHeaderTypeEnum | None = field(
        default=None,
        metadata={
            "name": "HEADER-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_rx_container_queue_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-RX-CONTAINER-QUEUE-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_tx_container_queue_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-TX-CONTAINER-QUEUE-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rx_accept_contained_i_pdu: RxAcceptContainedIPduEnum | None = field(
        default=None,
        metadata={
            "name": "RX-ACCEPT-CONTAINED-I-PDU",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    threshold_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "THRESHOLD-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unused_bit_pattern: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UNUSED-BIT-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ContainedIPduTriggeringPropss:
        contained_i_pdu_props: list[ContainedIPduProps] = field(
            default_factory=list,
            metadata={
                "name": "CONTAINED-I-PDU-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ContainedPduTriggeringRefs:
        contained_pdu_triggering_ref: list[
            "ContainerIPdu.ContainedPduTriggeringRefs.ContainedPduTriggeringRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTAINED-PDU-TRIGGERING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContainedPduTriggeringRef(Ref):
            dest: PduTriggeringSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class CouplingPortFifo:
    """
    Defines a Fifo for the CouplingPort egress structure.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar assigned_traffic_classs: Defines a set of Traffic Classes
        which shall be handled by this Fifo. range: 0-7
    :ivar minimum_fifo_length: FIFO minimum length in Byte. An actual
        configuration/hardware may use a bigger value.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COUPLING-PORT-FIFO"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CouplingPortFifo.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CouplingPortFifo.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_traffic_classs: Optional["CouplingPortFifo.AssignedTrafficClasss"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-TRAFFIC-CLASSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_fifo_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-FIFO-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AssignedTrafficClasss:
        assigned_traffic_class: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "ASSIGNED-TRAFFIC-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 8,
            },
        )


@dataclass(slots=True, kw_only=True)
class CouplingPortRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar coupling_port_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COUPLING-PORT-REF-CONDITIONAL"

    coupling_port_ref: Optional["CouplingPortRefConditional.CouplingPortRef"] = field(
        default=None,
        metadata={
            "name": "COUPLING-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CouplingPortRef(Ref):
        dest: CouplingPortSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CouplingPortScheduler:
    """
    Defines a scheduler for the CouplingPort egress structure.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar port_scheduler: Defines the schedule algorithm to be used.
    :ivar predecessor_refs: Ordered List of predecessor inputs. The
        first element has the highest priority. The following elements
        have decreasing priorities.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COUPLING-PORT-SCHEDULER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CouplingPortScheduler.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CouplingPortScheduler.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_scheduler: EthernetCouplingPortSchedulerEnum | None = field(
        default=None,
        metadata={
            "name": "PORT-SCHEDULER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    predecessor_refs: Optional["CouplingPortScheduler.PredecessorRefs"] = field(
        default=None,
        metadata={
            "name": "PREDECESSOR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PredecessorRefs:
        predecessor_ref: list["CouplingPortScheduler.PredecessorRefs.PredecessorRef"] = field(
            default_factory=list,
            metadata={
                "name": "PREDECESSOR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PredecessorRef(Ref):
            dest: CouplingPortStructuralElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class CouplingPortShaper:
    """
    Defines a shaper for the CouplingPort egress structure.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar idle_slope: Defines the increase of credit in bits per second
        for the AVB shaper.
    :ivar predecessor_fifo_ref: Defines the CouplingPortFifo which
        provides the input to this shaper.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COUPLING-PORT-SHAPER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CouplingPortShaper.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CouplingPortShaper.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    idle_slope: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "IDLE-SLOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    predecessor_fifo_ref: Optional["CouplingPortShaper.PredecessorFifoRef"] = field(
        default=None,
        metadata={
            "name": "PREDECESSOR-FIFO-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PredecessorFifoRef(Ref):
        dest: CouplingPortFifoSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CpSoftwareClusterCommunicationResource:
    """
    Represents a single resource required or provided by a CP Software Cluster
    which relates to the port based communication on VFB level.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar dependent_resources: Link to a resource which depends on this
        resource to implement them.
    :ivar global_resource_id: A unique identifiers per resource used for
        the connection process. The identifier is required to be unique
        in the scope of a single machine. If software clusters are
        designed to be reused on multiple machines the uniqueness
        requirements applies for all the intended machines.
    :ivar is_mandatory: This attribute indicates, that the resource is
        mandatory to operate the Software Cluster. If the resource is
        not provided on the machine the connection process of any
        Software Cluster requiring this resource gets aborted.
    :ivar com_props: This aggregation supports the further qualification
        of the enclosing CpSoftwareClusterCommunicationRecource by means
        of additional attributes depending on the nature of the
        CpSoftwareClusterCommunicationRecource.
    :ivar communication_resource_props: This aggregation supports the
        further qualification of the enclosing
        CpSoftwareClusterCommunicationRecource by means of additional
        attributes depending on the nature of the
        CpSoftwareClusterCommunicationRecource.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CP-SOFTWARE-CLUSTER-COMMUNICATION-RESOURCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CpSoftwareClusterCommunicationResource.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CpSoftwareClusterCommunicationResource.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dependent_resources: Optional["CpSoftwareClusterCommunicationResource.DependentResources"] = (
        field(
            default=None,
            metadata={
                "name": "DEPENDENT-RESOURCES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    global_resource_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "GLOBAL-RESOURCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_mandatory: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-MANDATORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    com_props: DataComProps | None = field(
        default=None,
        metadata={
            "name": "COM-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_resource_props: Optional[
        "CpSoftwareClusterCommunicationResource.CommunicationResourceProps"
    ] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-RESOURCE-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DependentResources:
        role_based_resource_dependency: list[RoleBasedResourceDependency] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-RESOURCE-DEPENDENCY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationResourceProps:
        client_server_operation_com_props: ClientServerOperationComProps | None = field(
            default=None,
            metadata={
                "name": "CLIENT-SERVER-OPERATION-COM-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        data_com_props: DataComProps | None = field(
            default=None,
            metadata={
                "name": "DATA-COM-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CpSoftwareClusterRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar cp_software_cluster_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CP-SOFTWARE-CLUSTER-REF-CONDITIONAL"

    cp_software_cluster_ref: Optional["CpSoftwareClusterRefConditional.CpSoftwareClusterRef"] = (
        field(
            default=None,
            metadata={
                "name": "CP-SOFTWARE-CLUSTER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CpSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CpSoftwareClusterResourceToApplicationPartitionMapping:
    """
    This meta class maps a Software Cluster resource to an Application Partition to
    restrict the usage.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar application_partition_ref: ApplicationPartition for which the
        mapping applies.
    :ivar resource_ref: Software Cluster Resource for which the mapping
        applies.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CpSoftwareClusterMappingSet.resourceToApplicationPartitionMapping
        Applicable for:
        SystemMapping.resourceToApplicationPartitionMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CP-SOFTWARE-CLUSTER-RESOURCE-TO-APPLICATION-PARTITION-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "CpSoftwareClusterResourceToApplicationPartitionMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CpSoftwareClusterResourceToApplicationPartitionMapping.Annotations"] = (
        field(
            default=None,
            metadata={
                "name": "ANNOTATIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    application_partition_ref: Optional[
        "CpSoftwareClusterResourceToApplicationPartitionMapping.ApplicationPartitionRef"
    ] = field(
        default=None,
        metadata={
            "name": "APPLICATION-PARTITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resource_ref: Optional["CpSoftwareClusterResourceToApplicationPartitionMapping.ResourceRef"] = (
        field(
            default=None,
            metadata={
                "name": "RESOURCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ApplicationPartitionRef(Ref):
        dest: ApplicationPartitionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ResourceRef(Ref):
        dest: CpSoftwareClusterResourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CpSoftwareClusterServiceResource:
    """
    Represents a single resource required or provided by a CP Software Cluster
    which relates to the BSW.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar dependent_resources: Link to a resource which depends on this
        resource to implement them.
    :ivar global_resource_id: A unique identifiers per resource used for
        the connection process. The identifier is required to be unique
        in the scope of a single machine. If software clusters are
        designed to be reused on multiple machines the uniqueness
        requirements applies for all the intended machines.
    :ivar is_mandatory: This attribute indicates, that the resource is
        mandatory to operate the Software Cluster. If the resource is
        not provided on the machine the connection process of any
        Software Cluster requiring this resource gets aborted.
    :ivar resource_needs_refs: Refernce(s) to one or multiple
        EcucContainerValue(s) qualifying the characteristics of the
        resource.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CP-SOFTWARE-CLUSTER-SERVICE-RESOURCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CpSoftwareClusterServiceResource.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CpSoftwareClusterServiceResource.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dependent_resources: Optional["CpSoftwareClusterServiceResource.DependentResources"] = field(
        default=None,
        metadata={
            "name": "DEPENDENT-RESOURCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_resource_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "GLOBAL-RESOURCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_mandatory: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-MANDATORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resource_needs_refs: Optional["CpSoftwareClusterServiceResource.ResourceNeedsRefs"] = field(
        default=None,
        metadata={
            "name": "RESOURCE-NEEDS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DependentResources:
        role_based_resource_dependency: list[RoleBasedResourceDependency] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-RESOURCE-DEPENDENCY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ResourceNeedsRefs:
        resource_needs_ref: list[
            "CpSoftwareClusterServiceResource.ResourceNeedsRefs.ResourceNeedsRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "RESOURCE-NEEDS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ResourceNeedsRef(Ref):
            dest: EcucContainerValueSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class CpSoftwareClusterToResourceMapping:
    """This meta class maps a service resource to CP Software Clusters.

    By this mapping it's specified whether the Software Cluster has to
    provide or to require the resource.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar provider_ref: CP Software Cluster providing the resource
    :ivar requester_refs: CP Software Cluster requesting the resource
    :ivar service_resource_ref: Service resource for which the mapping
        applies.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CpSoftwareClusterMappingSet.softwareClusterToResourceMapping
        Applicable for: SystemMapping.softwareClusterToResourceMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CP-SOFTWARE-CLUSTER-TO-RESOURCE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CpSoftwareClusterToResourceMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CpSoftwareClusterToResourceMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_ref: Optional["CpSoftwareClusterToResourceMapping.ProviderRef"] = field(
        default=None,
        metadata={
            "name": "PROVIDER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_refs: Optional["CpSoftwareClusterToResourceMapping.RequesterRefs"] = field(
        default=None,
        metadata={
            "name": "REQUESTER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_resource_ref: Optional["CpSoftwareClusterToResourceMapping.ServiceResourceRef"] = field(
        default=None,
        metadata={
            "name": "SERVICE-RESOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterRefs:
        requester_ref: list["CpSoftwareClusterToResourceMapping.RequesterRefs.RequesterRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "REQUESTER-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class RequesterRef(Ref):
            dest: CpSoftwareClusterSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ServiceResourceRef(Ref):
        dest: CpSoftwareClusterServiceResourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CpSwClusterResourceToDiagDataElemMapping:
    """This meta-class represents the ability to associate a
    CpSoftwareClusterResource with a DiagnosticDataElement.

    This allows for indicating that the CpSoftwareClusterResource is
    used to convey the DiagnosticDataElement.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar cp_software_cluster_resource_ref: This represents the affected
        CpSoftwareClusterResource.
    :ivar diagnostic_data_element_ref: This reference represents the
        affected DiagnosticDataElement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CP-SW-CLUSTER-RESOURCE-TO-DIAG-DATA-ELEM-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "CpSwClusterResourceToDiagDataElemMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CpSwClusterResourceToDiagDataElemMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "CpSwClusterResourceToDiagDataElemMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "CpSwClusterResourceToDiagDataElemMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cp_software_cluster_resource_ref: Optional[
        "CpSwClusterResourceToDiagDataElemMapping.CpSoftwareClusterResourceRef"
    ] = field(
        default=None,
        metadata={
            "name": "CP-SOFTWARE-CLUSTER-RESOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_data_element_ref: Optional[
        "CpSwClusterResourceToDiagDataElemMapping.DiagnosticDataElementRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CpSoftwareClusterResourceRef(Ref):
        dest: CpSoftwareClusterResourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticDataElementRef(Ref):
        dest: DiagnosticDataElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CpSwClusterResourceToDiagFunctionIdMapping:
    """This meta-class represents the ability to associate a
    CpSoftwareClusterResource with a subfunction of a DiagnosticFunctionIdentifier.

    This allows for indicating that the CpSoftwareClusterResource is
    used to convey the execution permission associated with the mapped
    function identifier.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar cp_software_cluster_resource_ref: This reference identifies
        the mapped CpSoftwareClusterResource.
    :ivar function_identifier_ref: This reference identifies the mapped
        DiagnosticFunctionIdentifier.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CP-SW-CLUSTER-RESOURCE-TO-DIAG-FUNCTION-ID-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "CpSwClusterResourceToDiagFunctionIdMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CpSwClusterResourceToDiagFunctionIdMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "CpSwClusterResourceToDiagFunctionIdMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "CpSwClusterResourceToDiagFunctionIdMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cp_software_cluster_resource_ref: Optional[
        "CpSwClusterResourceToDiagFunctionIdMapping.CpSoftwareClusterResourceRef"
    ] = field(
        default=None,
        metadata={
            "name": "CP-SOFTWARE-CLUSTER-RESOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    function_identifier_ref: Optional[
        "CpSwClusterResourceToDiagFunctionIdMapping.FunctionIdentifierRef"
    ] = field(
        default=None,
        metadata={
            "name": "FUNCTION-IDENTIFIER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CpSoftwareClusterResourceRef(Ref):
        dest: CpSoftwareClusterResourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FunctionIdentifierRef(Ref):
        dest: DiagnosticFunctionIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CpSwClusterToDiagEventMapping:
    """This meta-class represents the ability to associate a
    CpSoftwareClusterResource with a DiagnosticEvent.

    This allows for indicating that the CpSoftwareClusterResource is
    used to convey the reporting or status query of the mapped
    DiagnosticEvent.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar cp_software_cluster_resource_ref: This reference identifies
        the mapped CpSoftwareClusterResource.
    :ivar diagnostic_event_ref: This reference identifies the mapped
        DiagnosticEvent.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CP-SW-CLUSTER-TO-DIAG-EVENT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CpSwClusterToDiagEventMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CpSwClusterToDiagEventMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "CpSwClusterToDiagEventMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "CpSwClusterToDiagEventMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cp_software_cluster_resource_ref: Optional[
        "CpSwClusterToDiagEventMapping.CpSoftwareClusterResourceRef"
    ] = field(
        default=None,
        metadata={
            "name": "CP-SOFTWARE-CLUSTER-RESOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_event_ref: Optional["CpSwClusterToDiagEventMapping.DiagnosticEventRef"] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CpSoftwareClusterResourceRef(Ref):
        dest: CpSoftwareClusterResourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CpSwClusterToDiagRoutineSubfunctionMapping:
    """This meta-class represents the ability to associate a
    CpSoftwareClusterResource with a subfunction of a DiagnosticRoutine.

    This allows for indicating that the CpSoftwareClusterResource is
    used to convey the calling or result return of the mapped
    DiagnosticRoutine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar cp_software_cluster_resource_ref: This reference identifies
        the mapped CpSoftwareClusterResource.
    :ivar routine_subfunction_ref: This reference identifies the mapped
        subfunction of a DiagnosticRoutine.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CP-SW-CLUSTER-TO-DIAG-ROUTINE-SUBFUNCTION-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "CpSwClusterToDiagRoutineSubfunctionMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CpSwClusterToDiagRoutineSubfunctionMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "CpSwClusterToDiagRoutineSubfunctionMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "CpSwClusterToDiagRoutineSubfunctionMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cp_software_cluster_resource_ref: Optional[
        "CpSwClusterToDiagRoutineSubfunctionMapping.CpSoftwareClusterResourceRef"
    ] = field(
        default=None,
        metadata={
            "name": "CP-SOFTWARE-CLUSTER-RESOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    routine_subfunction_ref: Optional[
        "CpSwClusterToDiagRoutineSubfunctionMapping.RoutineSubfunctionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ROUTINE-SUBFUNCTION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CpSoftwareClusterResourceRef(Ref):
        dest: CpSoftwareClusterResourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RoutineSubfunctionRef(Ref):
        dest: DiagnosticRoutineSubfunctionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CppImplementationDataTypeElement:
    """Declares a data object which is locally aggregated.

    Such an element can only be used within the scope where it is
    aggregated. A CppImplementationDataTypeElement is used to represent
    an element of a structure, defining its type.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar is_optional: This attribute represents the ability to declare
        the enclosing CppImplementationDataTypeElement as optional. This
        means the that, at runtime, the CppImplementationDataTypeElement
        may or may not have a valid value and shall therefore be
        ignored. The underlying runtime software provides means to set
        the CppImplementationDataTypeElement as not valid at the sending
        end of a communication and determine its validity at the
        receiving end.
    :ivar type_reference: This aggregation defines the type of the
        CppImplementationDataTypeElement and determines whether in C++
        the CppImplementationDataTypeElement is defined inside or
        outside of the enclosing CppImplementationDataType.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CPP-IMPLEMENTATION-DATA-TYPE-ELEMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CppImplementationDataTypeElement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CppImplementationDataTypeElement.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_optional: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-OPTIONAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_reference: CppImplementationDataTypeElementQualifier | None = field(
        default=None,
        metadata={
            "name": "TYPE-REFERENCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoCertificate:
    """
    This meta-class represents the ability to model a cryptographic certificate.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar is_private: This attribute controls the possibility to access
        the content of the CryptoCertificateSlot by Find() interfaces of
        the X509 Provider.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-CERTIFICATE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoCertificate.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoCertificate.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_private: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-PRIVATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoCertificateInterface:
    """
    This meta-class provides the ability to define a PortInterface for a
    CryptoCertificate.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar is_private: This attribute controls the possibility to access
        the content of the CryptoCertificateSlot by Find() interfaces of
        the X509 Provider.
    :ivar write_access: This attribute defines whether the application
        has write-access to the CryptoCertificate (True) or only read-
        access (False).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-CERTIFICATE-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoCertificateInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoCertificateInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["CryptoCertificateInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["CryptoCertificateInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_private: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-PRIVATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    write_access: Boolean | None = field(
        default=None,
        metadata={
            "name": "WRITE-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoCertificateKeySlotNeeds:
    """
    This meta-class shall be taken to indicate that the SwcServiceDependecy modeled
    with this kind of ServiceNeeds defines a relationship between a CryptoKeySlot
    and a CryptoCertificate.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-CERTIFICATE-KEY-SLOT-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoCertificateKeySlotNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoCertificateKeySlotNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoCertificateToPortPrototypeMapping:
    """
    This meta-class represents the ability to define a mapping between a
    CryptoCertificate on deployment level to a given PortPrototype that is typed by
    a CryptoCertificateInterface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar crypto_certificate_ref: This reference represents the mapped
        cryptoCertificate.
    :ivar port_prototype_iref: This reference represents the mapped
        PortPrototype.
    :ivar process_ref: This reference represents the process required as
        context for the mapping.
    :ivar write_access: This attribute defines whether the application
        has write-access to the CryptoCertificate (True) or only read-
        access (False).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-CERTIFICATE-TO-PORT-PROTOTYPE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoCertificateToPortPrototypeMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoCertificateToPortPrototypeMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_certificate_ref: Optional[
        "CryptoCertificateToPortPrototypeMapping.CryptoCertificateRef"
    ] = field(
        default=None,
        metadata={
            "name": "CRYPTO-CERTIFICATE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["CryptoCertificateToPortPrototypeMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    write_access: Boolean | None = field(
        default=None,
        metadata={
            "name": "WRITE-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoCertificateRef(Ref):
        dest: CryptoCertificateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CryptoEllipticCurveProps:
    """
    This meta-class provides attributes to specify the properties of elliptic
    curves.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar named_curve_id: Defines the value of one specific NamedCurve
        Id.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-ELLIPTIC-CURVE-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoEllipticCurveProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoEllipticCurveProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    named_curve_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NAMED-CURVE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoKeyManagementNeeds:
    """
    This meta-class can be used to indicate a service use case for key management.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-KEY-MANAGEMENT-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoKeyManagementNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoKeyManagementNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoKeySlot:
    """
    This meta-class represents the ability to define a concrete key to be used for
    a crypto operation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar allocate_shadow_copy: This attribute defines whether a shadow
        copy of this Key Slot shall be allocated to enable rollback of a
        failed Key Slot update campaign (see interface
        BeginTransaction).
    :ivar crypto_alg_id: This attribute defines a crypto algorithm
        restriction (kAlgIdAny means without restriction). The algorithm
        can be specified partially: family &amp; length, mode, padding.
        Future Crypto Providers can support some crypto algorithms that
        are not well known/ standardized today, therefore AUTOSAR
        doesn't provide a concrete list of crypto algorithms'
        identifiers and doesn't suppose usage of numerical identifiers.
        Instead of this a provider supplier should provide string names
        of supported algorithms in accompanying documentation. The name
        of a crypto algorithm shall follow the rules defined in the
        specification of cryptography for Adaptive Platform.
    :ivar crypto_object_type: Object type that can be stored in the
        slot. If this field contains "Undefined" then mSlotCapacity must
        be provided and larger then 0.
    :ivar key_slot_allowed_modification: Restricts how this keySlot may
        be used
    :ivar key_slot_content_allowed_usages: Restriction of allowed usage
        of a key stored to the slot.
    :ivar slot_capacity: Capacity of the slot in bytes to be reserved by
        the stack vendor. One use case is to define this value in case
        that the cryptoObjectType is undefined and the slot size can not
        be deduced from cryptoObjectType and cryptoAlgId. "0" means slot
        size can be deduced from cryptoObjectType and cryptoAlgId.
    :ivar slot_type: This attribute defines whether the keySlot is
        exclusively used by the Application; or whether it is used by
        Stack Services and managed by a Key Manager Application.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-KEY-SLOT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoKeySlot.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoKeySlot.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    allocate_shadow_copy: Boolean | None = field(
        default=None,
        metadata={
            "name": "ALLOCATE-SHADOW-COPY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_alg_id: String | None = field(
        default=None,
        metadata={
            "name": "CRYPTO-ALG-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_object_type: CryptoObjectTypeEnum | None = field(
        default=None,
        metadata={
            "name": "CRYPTO-OBJECT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_slot_allowed_modification: CryptoKeySlotAllowedModification | None = field(
        default=None,
        metadata={
            "name": "KEY-SLOT-ALLOWED-MODIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_slot_content_allowed_usages: Optional["CryptoKeySlot.KeySlotContentAllowedUsages"] = field(
        default=None,
        metadata={
            "name": "KEY-SLOT-CONTENT-ALLOWED-USAGES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    slot_capacity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SLOT-CAPACITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    slot_type: CryptoKeySlotTypeEnum | None = field(
        default=None,
        metadata={
            "name": "SLOT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class KeySlotContentAllowedUsages:
        crypto_key_slot_content_allowed_usage: list[CryptoKeySlotContentAllowedUsage] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-KEY-SLOT-CONTENT-ALLOWED-USAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoKeySlotInterface:
    """
    This meta-class provides the ability to define a PortInterface for Crypto Key
    Slots.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar allocate_shadow_copy: This attribute defines whether a shadow
        copy of this KeySlot shall be allocated to enable rollback of a
        failed KeySlot update campaign (see interface BeginTransaction).
    :ivar crypto_alg_id: This attribute defines a crypto algorithm
        restriction (kAlgIdAny means without restriction). The algorithm
        can be specified partially: family &amp; length, mode, padding.
        Future Crypto Providers can support some crypto algorithms that
        are not well known/ standardized today, therefore AUTOSAR
        doesn't provide a concrete list of crypto algorithms'
        identifiers and doesn't suppose usage of numerical identifiers.
        Instead of this a provider supplier should provide string names
        of supported algorithms in accompanying documentation. The name
        of a crypto algorithm shall follow the rules defined in the
        specification of cryptography for Adaptive Platform.
    :ivar crypto_object_type: Object type that can be stored in the
        slot. If this field contains "Undefined" then mSlotCapacity must
        be provided and larger then 0
    :ivar key_slot_allowed_modification: Restricts how this keySlot may
        be used
    :ivar key_slot_content_allowed_usages: Restriction of allowed usage
        of a key stored to the slot.
    :ivar slot_capacity: Capacity of the slot in bytes to be reserved by
        the stack vendor. One use case is to define this value in case
        that the cryptoObjectType is undefined and the slot size can not
        be deduced from cryptoObjectType and cryptoAlgId. "0" means slot
        size can be deduced from cryptoObjectType and cryptoAlgId.
    :ivar slot_type: This attribute defines whether the keySlot is
        exclusively used by the Application; or whether it is used by
        Stack Services and managed by a Key Manager Application.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-KEY-SLOT-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoKeySlotInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoKeySlotInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["CryptoKeySlotInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["CryptoKeySlotInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    allocate_shadow_copy: Boolean | None = field(
        default=None,
        metadata={
            "name": "ALLOCATE-SHADOW-COPY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_alg_id: String | None = field(
        default=None,
        metadata={
            "name": "CRYPTO-ALG-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_object_type: CryptoObjectTypeEnum | None = field(
        default=None,
        metadata={
            "name": "CRYPTO-OBJECT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_slot_allowed_modification: CryptoKeySlotAllowedModification | None = field(
        default=None,
        metadata={
            "name": "KEY-SLOT-ALLOWED-MODIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_slot_content_allowed_usages: Optional[
        "CryptoKeySlotInterface.KeySlotContentAllowedUsages"
    ] = field(
        default=None,
        metadata={
            "name": "KEY-SLOT-CONTENT-ALLOWED-USAGES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    slot_capacity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SLOT-CAPACITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    slot_type: CryptoKeySlotTypeEnum | None = field(
        default=None,
        metadata={
            "name": "SLOT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class KeySlotContentAllowedUsages:
        crypto_key_slot_content_allowed_usage: list[CryptoKeySlotContentAllowedUsage] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-KEY-SLOT-CONTENT-ALLOWED-USAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoKeySlotToPortPrototypeMapping:
    """
    This meta-class represents the ability to define a mapping between a
    CryptoKeySlot on deployment level to a given PortPrototype that is typed by a
    CryptoKeySlotInterface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar key_slot_ref: This reference represents the mapped
        CryptoKeySlot.
    :ivar port_prototype_iref: This reference represents the mapped
        PortPrototype.
    :ivar process_ref: This reference represents the process required as
        context for the mapping.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-KEY-SLOT-TO-PORT-PROTOTYPE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoKeySlotToPortPrototypeMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoKeySlotToPortPrototypeMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_slot_ref: Optional["CryptoKeySlotToPortPrototypeMapping.KeySlotRef"] = field(
        default=None,
        metadata={
            "name": "KEY-SLOT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["CryptoKeySlotToPortPrototypeMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class KeySlotRef(Ref):
        dest: CryptoKeySlotSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CryptoProviderInterface:
    """
    This meta-class provides the ability to define a PortInterface for a
    CryptoProvider.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-PROVIDER-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoProviderInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoProviderInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["CryptoProviderInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["CryptoProviderInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoProviderToPortPrototypeMapping:
    """
    This meta-class represents the ability to define a mapping between a
    CryptoProvider on deployment level to a given PortPrototype that is typed by a
    CryptoProviderInterface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar crypto_provider_ref: This reference represents the mapped
        cryptoProvider.
    :ivar port_prototype_iref: This reference represents the mapped
        PortPrototype.
    :ivar process_ref: This reference represents the process required as
        context for the mapping.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-PROVIDER-TO-PORT-PROTOTYPE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoProviderToPortPrototypeMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoProviderToPortPrototypeMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_provider_ref: Optional["CryptoProviderToPortPrototypeMapping.CryptoProviderRef"] = field(
        default=None,
        metadata={
            "name": "CRYPTO-PROVIDER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["CryptoProviderToPortPrototypeMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoProviderRef(Ref):
        dest: CryptoProviderSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CryptoServiceCertificate:
    """
    This meta-class represents the ability to model a cryptographic certificate.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar algorithm_family: This attribute represents a description of
        the family of crypto algorithm used to generate public key and
        signature of the cryptographic certificate.
    :ivar format: This attribute can be used to provide information
        about the format used to create the certificate
    :ivar maximum_length: This attribute represents the ability to
        define the maximum length of the certificate in bytes.
    :ivar next_higher_certificate_ref: The reference identifies the next
        higher certificate in the certificate chain.
    :ivar server_name_identification: Server Name Indication (SNI) is
        needed if the IP address hosts multiple servers (on the same
        port), each of them using a different certificate. If the client
        sends the SNI to the Server in the client hello, the server
        looks the SNI up in its certificate list and uses the
        certificate identified by the SNI.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-SERVICE-CERTIFICATE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoServiceCertificate.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoServiceCertificate.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    algorithm_family: CryptoCertificateAlgorithmFamilyEnum | None = field(
        default=None,
        metadata={
            "name": "ALGORITHM-FAMILY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    format: CryptoCertificateFormatEnum | None = field(
        default=None,
        metadata={
            "name": "FORMAT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    next_higher_certificate_ref: Optional["CryptoServiceCertificate.NextHigherCertificateRef"] = (
        field(
            default=None,
            metadata={
                "name": "NEXT-HIGHER-CERTIFICATE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    server_name_identification: String | None = field(
        default=None,
        metadata={
            "name": "SERVER-NAME-IDENTIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NextHigherCertificateRef(Ref):
        dest: CryptoServiceCertificateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CryptoServiceJobNeeds:
    """
    This meta-class shall be taken to indicate that the service use case modeled
    with this kind of ServiceNeeds assumes the usage of the crypto job API.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-SERVICE-JOB-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoServiceJobNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoServiceJobNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoServiceNeeds:
    """Specifies the needs on the configuration of the CryptoServiceManager for one
    ConfigID (see Specification AUTOSAR_SWS_CSM.doc).

    An instance of this class is used to find out which ports of a
    software-component belong to this ConfigID.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar algorithm_family: This attribute represents a description of
        the family (e.g. AES) of crypto algorithm implemented by the
        crypto service use case.
    :ivar algorithm_mode: This meta-class has the ability to represent a
        crypto service use case.
    :ivar crypto_key_description: This attribute allows for a verbal
        description of the applicable cryptographic key. The goal is to
        pass a hint for the integrator about how to treat the
        corresponding service use case.
    :ivar maximum_key_length: The maximum length of a cryptographic key,
        that is used by the software-component or module for this
        configuration.  Unit: bit.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-SERVICE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoServiceNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoServiceNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    algorithm_family: String | None = field(
        default=None,
        metadata={
            "name": "ALGORITHM-FAMILY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    algorithm_mode: String | None = field(
        default=None,
        metadata={
            "name": "ALGORITHM-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_key_description: String | None = field(
        default=None,
        metadata={
            "name": "CRYPTO-KEY-DESCRIPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_key_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-KEY-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoServicePrimitive:
    """
    This meta-class has the ability to represent a crypto primitive.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar algorithm_family: This attribute represents a description of
        the family (e.g. AES) of crypto algorithm implemented by the
        crypto primitive.
    :ivar algorithm_mode: This attribute represents a description of the
        mode of the crypto algorithm implemented by the crypto
        primitive.
    :ivar algorithm_secondary_family: This attribute represents a
        further description of the secondary family of crypto algorithm
        implemented by the crypto primitive. The secondary family is
        needed for the specification of the hash algorithm for a
        signature check, e.g. using RSA.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-SERVICE-PRIMITIVE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoServicePrimitive.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoServicePrimitive.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    algorithm_family: String | None = field(
        default=None,
        metadata={
            "name": "ALGORITHM-FAMILY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    algorithm_mode: String | None = field(
        default=None,
        metadata={
            "name": "ALGORITHM-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    algorithm_secondary_family: String | None = field(
        default=None,
        metadata={
            "name": "ALGORITHM-SECONDARY-FAMILY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoServiceQueue:
    """
    This meta-class has the ability to represent a crypto queue.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar queue_size: Defines the queue size of the CryptoServiceQueue.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-SERVICE-QUEUE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoServiceQueue.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoServiceQueue.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    queue_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "QUEUE-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoSignatureScheme:
    """
    This meta-class provides attributes to specify the TLS Signature Scheme.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar signature_scheme_id: Defines the value of one specific TLS
        Signature Scheme.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-SIGNATURE-SCHEME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoSignatureScheme.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoSignatureScheme.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signature_scheme_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIGNATURE-SCHEME-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoTrustMasterInterface:
    """
    This meta-class provides the ability to define a PortInterface for TrustMaster.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-TRUST-MASTER-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoTrustMasterInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoTrustMasterInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["CryptoTrustMasterInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["CryptoTrustMasterInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CyclicTiming:
    """
    Specification of a cyclic sending behavior.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar time_offset: This attribute specifies the time until first
        transmission of this I-PDU. This attribute defines the time
        between Com_IpduGroupStart and the first transmission of the
        cyclic part of this transmission request for this I-PDU.
    :ivar time_period: Period of the repetition of cyclic transmissions.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CYCLIC-TIMING"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_offset: TimeRangeType | None = field(
        default=None,
        metadata={
            "name": "TIME-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_period: TimeRangeType | None = field(
        default=None,
        metadata={
            "name": "TIME-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DataConstr:
    """
    This meta-class represents the ability to specify constraints on data.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar data_constr_rules: This is one particular rule within the data
        constraints.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-CONSTR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DataConstr.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DataConstr.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DataConstr.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_constr_rules: Optional["DataConstr.DataConstrRules"] = field(
        default=None,
        metadata={
            "name": "DATA-CONSTR-RULES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataConstrRules:
        data_constr_rule: list[DataConstrRule] = field(
            default_factory=list,
            metadata={
                "name": "DATA-CONSTR-RULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DataReceiveErrorEvent:
    """
    This event is raised when the Com layer detects and notifies an error
    concerning the reception of the referenced ValiableDataPrototype.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar data_iref: The referenced VariableDataPrototype raises this
        DataReceiveErrorEvent when there was an error during the
        reception.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-RECEIVE-ERROR-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DataReceiveErrorEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DataReceiveErrorEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "DataReceiveErrorEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["DataReceiveErrorEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["DataReceiveErrorEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_iref: RVariableInAtomicSwcInstanceRef | None = field(
        default=None,
        metadata={
            "name": "DATA-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DataReceivedEvent:
    """
    This event is raised when the referenced data element is received.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar data_iref: The referenced VariableDataPrototype raises this
        DataReceivedEvent when the data has been received.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-RECEIVED-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DataReceivedEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DataReceivedEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "DataReceivedEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["DataReceivedEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["DataReceivedEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_iref: RVariableInAtomicSwcInstanceRef | None = field(
        default=None,
        metadata={
            "name": "DATA-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DataSendCompletedEvent:
    """
    This event is raised when the referenced explicit data element has been sent or
    an error occurred.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar event_source_ref: The referenced VariableAccess raises this
        DataSendCompletedEvent when the explicit write access was
        successful or an error occurred.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-SEND-COMPLETED-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DataSendCompletedEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DataSendCompletedEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "DataSendCompletedEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["DataSendCompletedEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["DataSendCompletedEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_source_ref: Optional["DataSendCompletedEvent.EventSourceRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-SOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventSourceRef(Ref):
        dest: VariableAccessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DataTransformation:
    """A DataTransformation represents a transformer chain.

    It is an ordered list of transformers.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar data_transformation_kind: This attribute controls the kind of
        DataTransformation to be applied.
    :ivar execute_despite_data_unavailability: Specifies whether the
        transformer chain is executed even if no input data are
        available.
    :ivar transformer_chain_refs: This attribute represents the
        definition of a chain of transformers that are supposed to be
        executed according to the order of being referenced from
        DataTransformation.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DataTransformationSet.dataTransformation
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-TRANSFORMATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DataTransformation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DataTransformation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_transformation_kind: DataTransformationKindEnum | None = field(
        default=None,
        metadata={
            "name": "DATA-TRANSFORMATION-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    execute_despite_data_unavailability: Boolean | None = field(
        default=None,
        metadata={
            "name": "EXECUTE-DESPITE-DATA-UNAVAILABILITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformer_chain_refs: Optional["DataTransformation.TransformerChainRefs"] = field(
        default=None,
        metadata={
            "name": "TRANSFORMER-CHAIN-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TransformerChainRefs:
        transformer_chain_ref: list[
            "DataTransformation.TransformerChainRefs.TransformerChainRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "TRANSFORMER-CHAIN-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TransformerChainRef(Ref):
            dest: TransformationTechnologySubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DataTransformationRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar data_transformation_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-TRANSFORMATION-REF-CONDITIONAL"

    data_transformation_ref: Optional["DataTransformationRefConditional.DataTransformationRef"] = (
        field(
            default=None,
            metadata={
                "name": "DATA-TRANSFORMATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataTransformationRef(Ref):
        dest: DataTransformationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DataTypeMappingSet:
    """This class represents a list of mappings between ApplicationDataTypes and
    ImplementationDataTypes.

    In addition, it can contain mappings between ImplementationDataTypes
    and ModeDeclarationGroups.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar data_type_maps: This is one particular association between an
        ApplicationDataType and its AbstractImplementationDataType.
    :ivar mode_request_type_maps: This is one particular association
        between an ModeDeclarationGroup and its
        AbstractImplementationDataType.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-TYPE-MAPPING-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DataTypeMappingSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DataTypeMappingSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DataTypeMappingSet.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_type_maps: Optional["DataTypeMappingSet.DataTypeMaps"] = field(
        default=None,
        metadata={
            "name": "DATA-TYPE-MAPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_request_type_maps: Optional["DataTypeMappingSet.ModeRequestTypeMaps"] = field(
        default=None,
        metadata={
            "name": "MODE-REQUEST-TYPE-MAPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataTypeMaps:
        data_type_map: list[DataTypeMap] = field(
            default_factory=list,
            metadata={
                "name": "DATA-TYPE-MAP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModeRequestTypeMaps:
        mode_request_type_map: list[ModeRequestTypeMap] = field(
            default_factory=list,
            metadata={
                "name": "MODE-REQUEST-TYPE-MAP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DataWriteCompletedEvent:
    """
    This event is raised when an implicit write access was successful or an error
    occurred.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar event_source_ref: The referenced VariableAccess raises this
        DataWriteCompletedEvent when the implicit write access was
        successful or an error occurred.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-WRITE-COMPLETED-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DataWriteCompletedEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DataWriteCompletedEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "DataWriteCompletedEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["DataWriteCompletedEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["DataWriteCompletedEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_source_ref: Optional["DataWriteCompletedEvent.EventSourceRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-SOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventSourceRef(Ref):
        dest: VariableAccessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DcmIPdu:
    """
    Represents the IPdus handled by Dcm.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar has_dynamic_length: This attribute defines whether the Pdu has
        dynamic length (true) or not (false). Please note that the usage
        of this attribute is restricted by [constr_3448].
    :ivar length: Pdu length in bytes. In case of dynamic length IPdus
        (containing a dynamical length signal), this value indicates the
        maximum data length. It should be noted that in former AUTOSAR
        releases (Rel 2.1, Rel 3.0, Rel 3.1, Rel 4.0 Rev. 1) this
        parameter was defined in bits. The Pdu length of zero bytes is
        allowed.
    :ivar meta_data_length: Number of additional bytes of MetaData in
        the PDU data field. The MetaData contains auxiliary information
        for the PDU, e.g. the CAN ID.
    :ivar contained_i_pdu_props: Defines whether this IPdu may be
        collected inside a ContainerIPdu.
    :ivar diag_pdu_type: Attribute is used to distinguish a request from
        a response.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DCM-I-PDU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DcmIPdu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DcmIPdu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_dynamic_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-DYNAMIC-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "META-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_i_pdu_props: ContainedIPduProps | None = field(
        default=None,
        metadata={
            "name": "CONTAINED-I-PDU-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_pdu_type: DiagPduType | None = field(
        default=None,
        metadata={
            "name": "DIAG-PDU-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DdsDomainRange:
    """
    DDS Domain ID range.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar max: Upper bound of the DdsDomainRange.
    :ivar min: Lower bound of the DdsDomainRange.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-DOMAIN-RANGE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DdsDomainRange.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DdsDomainRange.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DdsEventDeployment:
    """
    DDS configuration settings for an Event.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar event_ref: Reference to an Event that is deployed to a
        middleware transport layer.
    :ivar trigger_ref: Reference to a Trigger that is deployed to a
        middleware transport layer.
    :ivar event_topic_access_rule_ref: DDS Security access rule
        applicable to the DDS Topics used for the service interface
        event.
    :ivar topic_name: Name of the DDS Topic associated with the Event.
    :ivar transport_protocols: This attribute defines over which
        Transport Layer Protocol(s) this event is intended to be sent.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-EVENT-DEPLOYMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DdsEventDeployment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DdsEventDeployment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["DdsEventDeployment.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_ref: Optional["DdsEventDeployment.TriggerRef"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_topic_access_rule_ref: Optional["DdsEventDeployment.EventTopicAccessRuleRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-TOPIC-ACCESS-RULE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    topic_name: String | None = field(
        default=None,
        metadata={
            "name": "TOPIC-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transport_protocols: Optional["DdsEventDeployment.TransportProtocols"] = field(
        default=None,
        metadata={
            "name": "TRANSPORT-PROTOCOLS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventTopicAccessRuleRef(Ref):
        dest: DdsTopicAccessRuleSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TransportProtocols:
        transport_protocol: list[String] = field(
            default_factory=list,
            metadata={
                "name": "TRANSPORT-PROTOCOL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DdsSecureComProps:
    """
    Identity and governance information of participants in case of DDS Security.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar governance_ref: This attribute defines general DDS Security
        communication properties applicable to the DDS domain(s) in
        which the subject operates.
    :ivar identity_ref: This attribute defines the cryptographic
        identity of the subject.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-SECURE-COM-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DdsSecureComProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DdsSecureComProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    governance_ref: Optional["DdsSecureComProps.GovernanceRef"] = field(
        default=None,
        metadata={
            "name": "GOVERNANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    identity_ref: Optional["DdsSecureComProps.IdentityRef"] = field(
        default=None,
        metadata={
            "name": "IDENTITY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class GovernanceRef(Ref):
        dest: DdsSecureGovernanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IdentityRef(Ref):
        dest: CryptoCertificateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DdsServiceInstanceToMachineMapping:
    """
    This meta-class allows to map DdsServiceInstances to a CommunicationConnector
    of a Machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_connector_ref: Reference to the Machine to which
        the ServiceInstance is mapped.
    :ivar sec_oc_com_props_for_multicast_refs: Reference to
        communication security configuration settings that are valid for
        the udp multicast endpoint (Port + Multicast IP Address) defined
        by the ServiceInstanceToMachineMapping.
    :ivar secure_com_props_for_tcp_ref: Reference to communication
        security configuration settings that are valid for the tcp
        unicast endpoint (Tcp Port + Unicast IP Address) defined by the
        ServiceInstanceToMachineMapping.
    :ivar secure_com_props_for_udp_ref: Reference to communication
        security configuration settings that are valid for the udp
        unicast endpoint (Udp Port + Unicast IP Address) defined by the
        ServiceInstanceToMachineMapping.
    :ivar service_instance_refs: Reference to a ServiceInstance that is
        mapped to the Machine.
    :ivar secure_com_props_for_dds_ref: Reference to SecureComProps
        applicable to the service instance.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-SERVICE-INSTANCE-TO-MACHINE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DdsServiceInstanceToMachineMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DdsServiceInstanceToMachineMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_ref: Optional[
        "DdsServiceInstanceToMachineMapping.CommunicationConnectorRef"
    ] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sec_oc_com_props_for_multicast_refs: Optional[
        "DdsServiceInstanceToMachineMapping.SecOcComPropsForMulticastRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SEC-OC-COM-PROPS-FOR-MULTICAST-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_com_props_for_tcp_ref: Optional[
        "DdsServiceInstanceToMachineMapping.SecureComPropsForTcpRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECURE-COM-PROPS-FOR-TCP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_com_props_for_udp_ref: Optional[
        "DdsServiceInstanceToMachineMapping.SecureComPropsForUdpRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECURE-COM-PROPS-FOR-UDP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_refs: Optional["DdsServiceInstanceToMachineMapping.ServiceInstanceRefs"] = (
        field(
            default=None,
            metadata={
                "name": "SERVICE-INSTANCE-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    secure_com_props_for_dds_ref: Optional[
        "DdsServiceInstanceToMachineMapping.SecureComPropsForDdsRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECURE-COM-PROPS-FOR-DDS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecOcComPropsForMulticastRefs:
        sec_oc_com_props_for_multicast_ref: list[
            "DdsServiceInstanceToMachineMapping.SecOcComPropsForMulticastRefs.SecOcComPropsForMulticastRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SEC-OC-COM-PROPS-FOR-MULTICAST-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SecOcComPropsForMulticastRef(Ref):
            dest: SecOcSecureComPropsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SecureComPropsForTcpRef(Ref):
        dest: SecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecureComPropsForUdpRef(Ref):
        dest: SecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRefs:
        service_instance_ref: list[
            "DdsServiceInstanceToMachineMapping.ServiceInstanceRefs.ServiceInstanceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceInstanceRef(Ref):
            dest: AdaptivePlatformServiceInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SecureComPropsForDdsRef(Ref):
        dest: DdsSecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DdsTopicAccessRule:
    """
    DDS Topic access rule definition.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar data_protection_kind: Defines the data protection policy
        applicable to metadata related to the DDS Topic(s).
    :ivar enable_discovery_protection: Defines whether discovery
        protection mechanisms should apply to the DDS Topic(s).
    :ivar enable_liveliness_protection: Defines whether liveliness
        protection mechanisms should apply to the DDS Topic(s).
    :ivar enable_read_access_control: Defines whether read access
        control mechanisms should apply to the DDS Topic(s).
    :ivar enable_write_access_control: Defines whether write access
        control mechanisms should apply to the DDS Topic(s).
    :ivar metadata_protection_kind: Defines the data protection policy
        applicable to metadata related to the DDS Topic(s).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-TOPIC-ACCESS-RULE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DdsTopicAccessRule.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DdsTopicAccessRule.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_protection_kind: DdsProtectionKindEnum | None = field(
        default=None,
        metadata={
            "name": "DATA-PROTECTION-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    enable_discovery_protection: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-DISCOVERY-PROTECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    enable_liveliness_protection: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-LIVELINESS-PROTECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    enable_read_access_control: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-READ-ACCESS-CONTROL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    enable_write_access_control: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-WRITE-ACCESS-CONTROL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    metadata_protection_kind: DdsProtectionKindEnum | None = field(
        default=None,
        metadata={
            "name": "METADATA-PROTECTION-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DeadlineSupervision:
    """
    Defines an DeadlineSupervision for one transition.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar max_deadline: Defines the longest time span before which the
        deadline is considered to be met for transition.
    :ivar min_deadline: Defines the shortest time span after which the
        deadline is considered to be met for transition.
    :ivar transition_ref: Reference to the transition in the context of
        a DeadlineSupervision.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DEADLINE-SUPERVISION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DeadlineSupervision.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DeadlineSupervision.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_deadline: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MAX-DEADLINE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_deadline: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MIN-DEADLINE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transition_ref: Optional["DeadlineSupervision.TransitionRef"] = field(
        default=None,
        metadata={
            "name": "TRANSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TransitionRef(Ref):
        dest: CheckpointTransitionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DelegationSwConnector:
    """
    A delegation connector delegates one inner PortPrototype  (a port of a
    component that is used inside the composition) to a outer PortPrototype of
    compatible type that belongs directly to the composition (a port that is owned
    by the composition).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar mapping_ref: Reference to a PortInterfaceMapping specifying
        the mapping of unequal named PortInterface elements of the two
        different PortInterfaces typing the two PortPrototypes which are
        referenced by the ConnectorPrototype.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CompositionSwComponentType.connector
    :ivar inner_port_iref: The port that belongs to the
        ComponentPrototype in the composition
    :ivar outer_port_ref: The port that is located on the outside of the
        CompositionType
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DELEGATION-SW-CONNECTOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DelegationSwConnector.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DelegationSwConnector.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapping_ref: Optional["DelegationSwConnector.MappingRef"] = field(
        default=None,
        metadata={
            "name": "MAPPING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    inner_port_iref: Optional["DelegationSwConnector.InnerPortIref"] = field(
        default=None,
        metadata={
            "name": "INNER-PORT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    outer_port_ref: Optional["DelegationSwConnector.OuterPortRef"] = field(
        default=None,
        metadata={
            "name": "OUTER-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MappingRef(Ref):
        dest: PortInterfaceMappingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class InnerPortIref:
        p_port_in_composition_instance_ref: PPortInCompositionInstanceRef | None = field(
            default=None,
            metadata={
                "name": "P-PORT-IN-COMPOSITION-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        r_port_in_composition_instance_ref: RPortInCompositionInstanceRef | None = field(
            default=None,
            metadata={
                "name": "R-PORT-IN-COMPOSITION-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class OuterPortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DependencyOnArtifact:
    """
    Dependency on the existence of another artifact, e.g. a library.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar artifact_descriptor: The specified artifact needs to exist.
    :ivar usages: Specification for which process step(s) this
        dependency is required.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        Implementation.generatedArtifact Applicable for:
        Implementation.requiredArtifact Applicable for:
        Implementation.requiredGeneratorTool
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DEPENDENCY-ON-ARTIFACT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DependencyOnArtifact.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DependencyOnArtifact.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    artifact_descriptor: AutosarEngineeringObject | None = field(
        default=None,
        metadata={
            "name": "ARTIFACT-DESCRIPTOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    usages: Optional["DependencyOnArtifact.Usages"] = field(
        default=None,
        metadata={
            "name": "USAGES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Usages:
        usage: list[DependencyUsageEnum] = field(
            default_factory=list,
            metadata={
                "name": "USAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DeterministicClient:
    """
    The meta-class DeterministicClient provides the ability to support the
    deterministic execution of one or more processes with specific configuration
    parameters for DeterministicClient library functions.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar cycle_time_value: This attribute represents the cycle time for
        execution of a DeterministicClient activation cycle.
    :ivar deterministic_sync_master_ref: This reference identifies the
        applicable DeterministicSyncMaster.
    :ivar number_of_workers: Number of independent workers that process
        data-sets. Size of the worker pool shall be decided based on
        availability of resources like processor cores or memory.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DETERMINISTIC-CLIENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DeterministicClient.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DeterministicClient.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cycle_time_value: TimeValue | None = field(
        default=None,
        metadata={
            "name": "CYCLE-TIME-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    deterministic_sync_master_ref: Optional["DeterministicClient.DeterministicSyncMasterRef"] = (
        field(
            default=None,
            metadata={
                "name": "DETERMINISTIC-SYNC-MASTER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    number_of_workers: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NUMBER-OF-WORKERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DeterministicSyncMasterRef(Ref):
        dest: DeterministicSyncMasterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DeterministicClientResourceNeeds:
    """
    This meta-class specifies process and cycle specific computing resource needs
    of DeterministicClient library functions.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar hardware_platform: This attribute represents a textual
        identification of the target platform.
    :ivar init_resource: This represents the computing resource needs of
        a DeterministicClient::WaitForActivation kInit cycle.
    :ivar run_resource: This represents the computing resource needs of
        a DeterministicClient::WaitForActivation kRun cycle.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DETERMINISTIC-CLIENT-RESOURCE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DeterministicClientResourceNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DeterministicClientResourceNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hardware_platform: String | None = field(
        default=None,
        metadata={
            "name": "HARDWARE-PLATFORM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    init_resource: DeterministicClientResource | None = field(
        default=None,
        metadata={
            "name": "INIT-RESOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    run_resource: DeterministicClientResource | None = field(
        default=None,
        metadata={
            "name": "RUN-RESOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DeterministicSyncMaster:
    """
    The meta-class DeterministicSyncMaster provides the synchronization ability to
    support the deterministic execution of one or more processes with specific
    configuration parameters for DeterministicSyncMaster library functions.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar max_run_cycle_loop: The maximum number of loops of the kRun
        cycle.
    :ivar verification_method: This aggregation is used to configure the
        applicable verification method implemented in the
        DeterministicSyncMaster.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DETERMINISTIC-SYNC-MASTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DeterministicSyncMaster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DeterministicSyncMaster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_run_cycle_loop: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-RUN-CYCLE-LOOP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verification_method: Optional["DeterministicSyncMaster.VerificationMethod"] = field(
        default=None,
        metadata={
            "name": "VERIFICATION-METHOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class VerificationMethod:
        deterministic_sync_m_out_of_n: DeterministicSyncMOutOfN | None = field(
            default=None,
            metadata={
                "name": "DETERMINISTIC-SYNC-M-OUT-OF-N",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DeterministicSyncMasterToTimeBaseConsumerMapping:
    """
    This meta-class has the ability to create an association between a
    deterministic sync master and the time-base consumer that is used to provide
    the sync master with a time base for creating time stamps for certain use
    cases.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar deterministic_sync_master_ref: This reference identifies the
        deterministic sync master in the scope of the mapping.
    :ivar time_base_consumer_ref: This reference identifies the time
        base consumer in the scope of the mapping.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DETERMINISTIC-SYNC-MASTER-TO-TIME-BASE-CONSUMER-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DeterministicSyncMasterToTimeBaseConsumerMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DeterministicSyncMasterToTimeBaseConsumerMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    deterministic_sync_master_ref: Optional[
        "DeterministicSyncMasterToTimeBaseConsumerMapping.DeterministicSyncMasterRef"
    ] = field(
        default=None,
        metadata={
            "name": "DETERMINISTIC-SYNC-MASTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_base_consumer_ref: Optional[
        "DeterministicSyncMasterToTimeBaseConsumerMapping.TimeBaseConsumerRef"
    ] = field(
        default=None,
        metadata={
            "name": "TIME-BASE-CONSUMER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DeterministicSyncMasterRef(Ref):
        dest: DeterministicSyncMasterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TimeBaseConsumerRef(Ref):
        dest: SynchronizedTimeBaseConsumerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DevelopmentError:
    """
    The reported failure is classified as development error.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar id: ID of detected failure used in reporting API as error or
        fault id.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ErrorTracerNeeds.tracedFailure
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DEVELOPMENT-ERROR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DevelopmentError.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DevelopmentError.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagEventDebounceCounterBased:
    """This meta-class represents the ability to indicate that the counter-based
    debounce algorithm shall be used by the DEM for this diagnostic monitor.

    This is related to set the ECUC choice container
    DemDebounceAlgorithmClass to DemDebounceCounterBased.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar counter_based_fdc_threshold_storage_value: Threshold to
        allocate an event memory entry and to capture the Freeze Frame.
    :ivar counter_decrement_step_size: This value shall be taken to
        decrement the internal debounce counter.
    :ivar counter_failed_threshold: This value defines the event-
        specific limit that indicates the "failed" counter status.
    :ivar counter_increment_step_size: This value shall be taken to
        increment the internal debounce counter.
    :ivar counter_jump_down: This value activates or deactivates the
        counter jump-down behavior.
    :ivar counter_jump_down_value: This value represents the initial
        value of the internal debounce counter if the counting direction
        changes from incrementing to decrementing.
    :ivar counter_jump_up: This value activates or deactivates the
        counter jump-up behavior.
    :ivar counter_jump_up_value: This value represents the initial value
        of the internal debounce counter if the counting direction
        changes from decrementing to incrementing.
    :ivar counter_passed_threshold: This value defines the event-
        specific limit that indicates the "passed" counter status.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAG-EVENT-DEBOUNCE-COUNTER-BASED"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagEventDebounceCounterBased.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagEventDebounceCounterBased.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    counter_based_fdc_threshold_storage_value: Integer | None = field(
        default=None,
        metadata={
            "name": "COUNTER-BASED-FDC-THRESHOLD-STORAGE-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    counter_decrement_step_size: IntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "COUNTER-DECREMENT-STEP-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    counter_failed_threshold: IntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "COUNTER-FAILED-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    counter_increment_step_size: IntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "COUNTER-INCREMENT-STEP-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    counter_jump_down: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "COUNTER-JUMP-DOWN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    counter_jump_down_value: IntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "COUNTER-JUMP-DOWN-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    counter_jump_up: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "COUNTER-JUMP-UP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    counter_jump_up_value: IntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "COUNTER-JUMP-UP-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    counter_passed_threshold: IntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "COUNTER-PASSED-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagEventDebounceMonitorInternal:
    """ "This meta-class represents the ability to indicate that no Dem pre-debounce
    algorithm shall be used for this diagnostic monitor.

    The SWC might implement an internal debouncing algorithm and report
    qualified (debounced) results to the Dem/DM.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAG-EVENT-DEBOUNCE-MONITOR-INTERNAL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagEventDebounceMonitorInternal.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagEventDebounceMonitorInternal.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagEventDebounceTimeBased:
    """This meta-class represents the ability to indicate that the time-based pre-
    debounce algorithm shall be used by the Dem for this diagnostic monitor.

    This is related to set the EcuC choice container
    DemDebounceAlgorithmClass to DemDebounceTimeBase.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar time_based_fdc_threshold_storage_value: Threshold to allocate
        an event memory entry and to capture the Freeze Frame.
    :ivar time_failed_threshold: This value represents the event-
        specific delay indicating the "failed" status.
    :ivar time_passed_threshold: This value represents the event-
        specific delay indicating the "passed" status.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAG-EVENT-DEBOUNCE-TIME-BASED"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagEventDebounceTimeBased.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagEventDebounceTimeBased.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_based_fdc_threshold_storage_value: TimeValueValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "TIME-BASED-FDC-THRESHOLD-STORAGE-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_failed_threshold: TimeValueValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "TIME-FAILED-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_passed_threshold: TimeValueValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "TIME-PASSED-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticAccessPermission:
    """This represents the specification of whether a given service can be accessed
    according to the existence of meta-classes referenced by a particular
    DiagnosticAccessPermission.

    In other words, this meta-class acts as a mapping element between
    several (otherwise unrelated) pieces of information that are put
    into context for the purpose of checking for access rights.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar authentication_role_refs: This reference identifies the
        authenticationRole applicable for the enclosing
        DiagnosticMemoryDestinationUserDefined.
    :ivar diagnostic_session_refs: This represents the associated
        DiagnosticSessions
    :ivar environmental_condition_ref: This represents the environmental
        conditions associated with the access permission.
    :ivar security_level_refs: This represents the associated
        DiagnosticSecurityLevels
    :ivar sovd_lock_ref: This represents the associated SOVD lock.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ACCESS-PERMISSION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticAccessPermission.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticAccessPermission.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_role_refs: Optional["DiagnosticAccessPermission.AuthenticationRoleRefs"] = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-ROLE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_session_refs: Optional["DiagnosticAccessPermission.DiagnosticSessionRefs"] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-SESSION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    environmental_condition_ref: Optional[
        "DiagnosticAccessPermission.EnvironmentalConditionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ENVIRONMENTAL-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_level_refs: Optional["DiagnosticAccessPermission.SecurityLevelRefs"] = field(
        default=None,
        metadata={
            "name": "SECURITY-LEVEL-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sovd_lock_ref: Optional["DiagnosticAccessPermission.SovdLockRef"] = field(
        default=None,
        metadata={
            "name": "SOVD-LOCK-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AuthenticationRoleRefs:
        authentication_role_ref: list[
            "DiagnosticAccessPermission.AuthenticationRoleRefs.AuthenticationRoleRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "AUTHENTICATION-ROLE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class AuthenticationRoleRef(Ref):
            dest: DiagnosticAuthRoleSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticSessionRefs:
        diagnostic_session_ref: list[
            "DiagnosticAccessPermission.DiagnosticSessionRefs.DiagnosticSessionRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SESSION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DiagnosticSessionRef(Ref):
            dest: DiagnosticSessionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class EnvironmentalConditionRef(Ref):
        dest: DiagnosticEnvironmentalConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecurityLevelRefs:
        security_level_ref: list[
            "DiagnosticAccessPermission.SecurityLevelRefs.SecurityLevelRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-LEVEL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SecurityLevelRef(Ref):
            dest: DiagnosticSecurityLevelSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SovdLockRef(Ref):
        dest: DiagnosticSovdLockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticAuthRole:
    """
    This meta-class represents the ability to specify an authentication role that
    can be used to deliver fine-grained access rights.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar bit_position: This attribute allows for the specification of
        the position of the enclosing role in a bitfield of roles.
    :ivar is_default: This attribute indicates whether the enclosing
        role is considered a default role.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-AUTH-ROLE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticAuthRole.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticAuthRole.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bit_position: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BIT-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_default: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-DEFAULT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticAuthenticationClass:
    """
    This meta-class contains configuration shared by all instances of the
    Authentication diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-AUTHENTICATION-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticAuthenticationClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticAuthenticationClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticAuthenticationClass.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticAuthenticationConfiguration:
    """
    This meta-class represents the subfunction to configure the authentication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar authentication_class_ref: This represents the corresponding
        "class", i.e. this meta-class provides properties that are
        shared among all instances of applicable sub-classes of
        DiagnosticServiceInstance. The subclasses that affected by this
        pattern implement references to the applicable "class"-role that
        substantiate this abstract reference.
    :ivar authentication_timeout: This attribute defines the time that
        the authentication state is maintained in default-session if
        there is no communication from the authenticated client.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-AUTHENTICATION-CONFIGURATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticAuthenticationConfiguration.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticAuthenticationConfiguration.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticAuthenticationConfiguration.AccessPermissionRef"] = (
        field(
            default=None,
            metadata={
                "name": "ACCESS-PERMISSION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    authentication_class_ref: Optional[
        "DiagnosticAuthenticationConfiguration.AuthenticationClassRef"
    ] = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AuthenticationClassRef(Ref):
        dest: DiagnosticAuthenticationClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticAuthenticationInterface:
    """
    This meta-class represents the ability to implement a focused PortInterface for
    handling the diagnostic service "authentication" on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-AUTHENTICATION-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticAuthenticationInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticAuthenticationInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticAuthenticationInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticAuthenticationInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticAuthenticationPortMapping:
    """
    This mapping class identifies the PortPrototype in the application software
    that handles the client authentication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar diagnostic_authentication_ref: Reference to the
        DiagnosticAuthentication that is assigned to a SWC service port.
    :ivar p_port_prototype_in_executable_iref: This aggregation allows
        for the usage of the DiagnosticAuthenticationPortMapping on the
        AUTOSAR adaptive platform.
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-AUTHENTICATION-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticAuthenticationPortMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticAuthenticationPortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticAuthenticationPortMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticAuthenticationPortMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_authentication_ref: Optional[
        "DiagnosticAuthenticationPortMapping.DiagnosticAuthenticationRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-AUTHENTICATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_port_prototype_in_executable_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "P-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticAuthenticationPortMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticAuthenticationRef(Ref):
        dest: DiagnosticAuthenticationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticClearCondition:
    """
    This meta-class describes a clear condition for diagnostic purposes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar init_value: Defines the initial status for enable or disable
        of acceptance/storage of event reports of a diagnostic event.
        The value is the initialization after power up (before this
        condition is reported the first time). true: acceptance/storage
        of a diagnostic event enabled false: acceptance/storage of a
        diagnostic event disabled
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CLEAR-CONDITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticClearCondition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticClearCondition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    init_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticClearConditionGroup:
    """
    Clear condition group which includes one or several clear conditions.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar clear_condition_refs: This aggregation represents the
        collection of DiagnosticClearConditions that belong to the
        DiagnosticClearConditionGroup.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CLEAR-CONDITION-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticClearConditionGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticClearConditionGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clear_condition_refs: Optional["DiagnosticClearConditionGroup.ClearConditionRefs"] = field(
        default=None,
        metadata={
            "name": "CLEAR-CONDITION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClearConditionRefs:
        clear_condition_ref: list[
            "DiagnosticClearConditionGroup.ClearConditionRefs.ClearConditionRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CLEAR-CONDITION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ClearConditionRef(Ref):
            dest: DiagnosticClearConditionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DiagnosticClearConditionNeeds:
    """
    This meta-class represents the needs of a software-component to provide the
    capability to set a clear condition.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CLEAR-CONDITION-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticClearConditionNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticClearConditionNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticClearConditionNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticClearConditionPortMapping:
    """
    Defines to which SWC service ports with DiagnosticsClearConditionNeeds the
    DiagnosticClearCondition is mapped.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar clear_condition_ref: Reference to the ClearCondition which is
        mapped to a SWC service port with DiagnosticClearConditionNeeds.
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar r_port_prototype_in_executable_iref: This aggregation allows
        for the usage of the DiagnosticClearConditionMapping on the
        AUTOSAR adaptive platform.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CLEAR-CONDITION-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticClearConditionPortMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticClearConditionPortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticClearConditionPortMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticClearConditionPortMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clear_condition_ref: Optional["DiagnosticClearConditionPortMapping.ClearConditionRef"] = field(
        default=None,
        metadata={
            "name": "CLEAR-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticClearConditionPortMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    r_port_prototype_in_executable_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "R-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ClearConditionRef(Ref):
        dest: DiagnosticClearConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticClearDiagnosticInformation:
    """
    This represents an instance of the "Clear Diagnostic Information" diagnostic
    service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar clear_diagnostic_information_class_ref: This reference
        substantiates that abstract reference in the role serviceClass
        for this specific concrete class. Thereby, the reference
        represents the ability to access shared attributes among all
        DiagnosticClearDiagnosticInformation in the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticClearDiagnosticInformation.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticClearDiagnosticInformation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticClearDiagnosticInformation.AccessPermissionRef"] = (
        field(
            default=None,
            metadata={
                "name": "ACCESS-PERMISSION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    clear_diagnostic_information_class_ref: Optional[
        "DiagnosticClearDiagnosticInformation.ClearDiagnosticInformationClassRef"
    ] = field(
        default=None,
        metadata={
            "name": "CLEAR-DIAGNOSTIC-INFORMATION-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ClearDiagnosticInformationClassRef(Ref):
        dest: DiagnosticClearDiagnosticInformationClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticClearDiagnosticInformationClass:
    """
    This meta-class contains attributes shared by all instances of the "Clear
    Diagnostic Information" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticClearDiagnosticInformationClass.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticClearDiagnosticInformationClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticClearDiagnosticInformationClass.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticClearResetEmissionRelatedInfo:
    """
    This meta-class represents the ability to model an instance of the OBD mode
    0x04 service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar clear_reset_emission_related_diagnostic_info_class_ref: This
        reference substantiates that abstract reference in the role
        serviceClass for this specific concrete class. Thereby, the
        reference represents the ability to access shared attributes
        among all DiagnosticClearResteEmissionRelatedInfo in the given
        context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticClearResetEmissionRelatedInfo.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticClearResetEmissionRelatedInfo.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticClearResetEmissionRelatedInfo.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clear_reset_emission_related_diagnostic_info_class_ref: Optional[
        "DiagnosticClearResetEmissionRelatedInfo.ClearResetEmissionRelatedDiagnosticInfoClassRef"
    ] = field(
        default=None,
        metadata={
            "name": "CLEAR-RESET-EMISSION-RELATED-DIAGNOSTIC-INFO-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ClearResetEmissionRelatedDiagnosticInfoClassRef(Ref):
        dest: DiagnosticClearResetEmissionRelatedInfoClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticClearResetEmissionRelatedInfoClass:
    """
    This meta-class represents the ability to define common properties for all
    instances of the "Clear Reset Emission Related Data" OBD diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticClearResetEmissionRelatedInfoClass.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticClearResetEmissionRelatedInfoClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticClearResetEmissionRelatedInfoClass.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticComControl:
    """
    This represents an instance of the "Communication Control" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar com_control_class_ref: This reference substantiates that
        abstract reference in the role serviceClass for this specific
        concrete class. Thereby, the reference represents the ability to
        access shared attributes among all DiagnosticComControl in the
        given context.
    :ivar custom_sub_function_number: This attribute shall be used to
        define a custom sub-function number if none of the standardized
        values of category shall be used.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-COM-CONTROL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticComControl.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticComControl.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticComControl.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    com_control_class_ref: Optional["DiagnosticComControl.ComControlClassRef"] = field(
        default=None,
        metadata={
            "name": "COM-CONTROL-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    custom_sub_function_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CUSTOM-SUB-FUNCTION-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ComControlClassRef(Ref):
        dest: DiagnosticComControlClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticComControlClass:
    """
    This meta-class contains attributes shared by all instances of the
    "Communication Control" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar all_channels_refs: This reference represents the semantics
        that all available channels shall be affected. It is still
        necessary to refer to individual CommunicatuionClusters because
        there could be private CommunicationClusters in the System
        Extract that are not subject to the service "communication
        control". By referring to the applicable CommunicationClusters
        it can be made sure that only the affected CommunicationClusters
        are accessed.
    :ivar specific_channels: This represents the ability to add
        additional attributes to the case that only specific channels
        are supposed to be considered,
    :ivar sub_node_channels: This attribute represents the ability to
        add further attributes to the definition of a specific sub-node
        channel that is subject to the diagnostic service "communication
        control".
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-COM-CONTROL-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticComControlClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticComControlClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticComControlClass.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    all_channels_refs: Optional["DiagnosticComControlClass.AllChannelsRefs"] = field(
        default=None,
        metadata={
            "name": "ALL-CHANNELS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    specific_channels: Optional["DiagnosticComControlClass.SpecificChannels"] = field(
        default=None,
        metadata={
            "name": "SPECIFIC-CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_node_channels: Optional["DiagnosticComControlClass.SubNodeChannels"] = field(
        default=None,
        metadata={
            "name": "SUB-NODE-CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AllChannelsRefs:
        all_channels_ref: list["DiagnosticComControlClass.AllChannelsRefs.AllChannelsRef"] = field(
            default_factory=list,
            metadata={
                "name": "ALL-CHANNELS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class AllChannelsRef(Ref):
            dest: CommunicationClusterSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SpecificChannels:
        diagnostic_com_control_specific_channel: list[DiagnosticComControlSpecificChannel] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-COM-CONTROL-SPECIFIC-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubNodeChannels:
        diagnostic_com_control_sub_node_channel: list[DiagnosticComControlSubNodeChannel] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-COM-CONTROL-SUB-NODE-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticComControlInterface:
    """
    This meta-class represents the ability to implement a focused PortInterface for
    handling the diagnostic service communication control on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-COM-CONTROL-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticComControlInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticComControlInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticComControlInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticComControlInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticCommonElementRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar diagnostic_common_element_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-COMMON-ELEMENT-REF-CONDITIONAL"

    diagnostic_common_element_ref: Optional[
        "DiagnosticCommonElementRefConditional.DiagnosticCommonElementRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-COMMON-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticCommonElementRef(Ref):
        dest: DiagnosticCommonElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticCommunicationManagerNeeds:
    """Specifies the general needs on the configuration of the  Diagnostic
    Communication Manager (Dcm) which are not related to a particular item (e.g. a
    PID or DiagnosticRoutineNeeds).

    The main use case is the mapping of service ports to the Dcm which
    are not related to a particular item.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar service_request_callback_type: This represents the ability to
        define whether the usage of PortInterface
        ServiceRequestNotification has the characteristics of being
        initiated by a manufacturer or by a supplier.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-COMMUNICATION-MANAGER-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticCommunicationManagerNeeds.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticCommunicationManagerNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticCommunicationManagerNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_request_callback_type: DiagnosticServiceRequestCallbackTypeEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-REQUEST-CALLBACK-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticComponentNeeds:
    """
    This meta-class represents the ability to specify the service needs for the
    configuration of component events.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-COMPONENT-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticComponentNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticComponentNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticComponentNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticConditionInterface:
    """
    This meta-class represents the ability to implement a PortInterface to process
    requests for diagnostic conditions on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CONDITION-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticConditionInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticConditionInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticConditionInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticConditionInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticConnectedIndicator:
    """
    Description of indicators that are defined per DiagnosticEvent.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar behavior: Behavior of the linked indicator.
    :ivar healing_cycle_counter_threshold: This attribute defines the
        number of healing cycles for the WarningIndicatorOffCriteria
    :ivar healing_cycle_ref: The deactivation of indicators per event is
        defined as healing of a diagnostic event. The operation cycle in
        which the warning indicator will be switched off is defined
        here.
    :ivar indicator_failure_cycle_counter_threshold: This attribute
        defines the number of failure cycles for the
        WarningIndicatorOnCriteria. Please note that this attribute is
        not relevant for the Adaptive Platform.
    :ivar indicator_ref: Reference to the used indicator.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DiagnosticEvent.connectedIndicator
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CONNECTED-INDICATOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticConnectedIndicator.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticConnectedIndicator.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    behavior: DiagnosticConnectedIndicatorBehaviorEnum | None = field(
        default=None,
        metadata={
            "name": "BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    healing_cycle_counter_threshold: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "HEALING-CYCLE-COUNTER-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    healing_cycle_ref: Optional["DiagnosticConnectedIndicator.HealingCycleRef"] = field(
        default=None,
        metadata={
            "name": "HEALING-CYCLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    indicator_failure_cycle_counter_threshold: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INDICATOR-FAILURE-CYCLE-COUNTER-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    indicator_ref: Optional["DiagnosticConnectedIndicator.IndicatorRef"] = field(
        default=None,
        metadata={
            "name": "INDICATOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HealingCycleRef(Ref):
        dest: DiagnosticOperationCycleSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IndicatorRef(Ref):
        dest: DiagnosticIndicatorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticConnection:
    """
    DiagnosticConncection that is used to describe the relationship between several
    TP connections.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar functional_request_refs: Reference to functional request
        messages.
    :ivar periodic_response_uudt_refs: Reference to UUDT responses.
    :ivar physical_request_ref: Reference to a physical request message.
    :ivar response_on_event_ref: Reference to a ROE message.
    :ivar response_ref: In the vast majority of cases a response is
        required. However, there are also cases where providing the
        response is not possible and/or not allowed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CONNECTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticConnection.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticConnection.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    functional_request_refs: Optional["DiagnosticConnection.FunctionalRequestRefs"] = field(
        default=None,
        metadata={
            "name": "FUNCTIONAL-REQUEST-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    periodic_response_uudt_refs: Optional["DiagnosticConnection.PeriodicResponseUudtRefs"] = field(
        default=None,
        metadata={
            "name": "PERIODIC-RESPONSE-UUDT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_request_ref: Optional["DiagnosticConnection.PhysicalRequestRef"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-REQUEST-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    response_on_event_ref: Optional["DiagnosticConnection.ResponseOnEventRef"] = field(
        default=None,
        metadata={
            "name": "RESPONSE-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    response_ref: Optional["DiagnosticConnection.ResponseRef"] = field(
        default=None,
        metadata={
            "name": "RESPONSE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FunctionalRequestRefs:
        functional_request_ref: list[
            "DiagnosticConnection.FunctionalRequestRefs.FunctionalRequestRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "FUNCTIONAL-REQUEST-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FunctionalRequestRef(Ref):
            dest: TpConnectionIdentSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PeriodicResponseUudtRefs:
        periodic_response_uudt_ref: list[
            "DiagnosticConnection.PeriodicResponseUudtRefs.PeriodicResponseUudtRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-RESPONSE-UUDT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PeriodicResponseUudtRef(Ref):
            dest: PduTriggeringSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PhysicalRequestRef(Ref):
        dest: TpConnectionIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ResponseOnEventRef(Ref):
        dest: TpConnectionIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ResponseRef(Ref):
        dest: TpConnectionIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticConnectionRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar diagnostic_connection_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CONNECTION-REF-CONDITIONAL"

    diagnostic_connection_ref: Optional[
        "DiagnosticConnectionRefConditional.DiagnosticConnectionRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-CONNECTION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticConnectionRef(Ref):
        dest: DiagnosticConnectionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticControlDtcSetting:
    """
    This represents an instance of the "Control DTC Setting" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar dtc_setting_class_ref: This reference substantiates that
        abstract reference in the role serviceClass for this specific
        concrete class. Thereby, the reference represents the ability to
        access shared attributes among all DiagnosticControlDTCSetting
        in the given context.
    :ivar dtc_setting_parameter: This represents the DTCSettingType
        defined by ISO 14229-1. The pre-defined values are 1 (ON) and 2
        (OFF).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CONTROL-DTC-SETTING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticControlDtcSetting.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticControlDtcSetting.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticControlDtcSetting.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_setting_class_ref: Optional["DiagnosticControlDtcSetting.DtcSettingClassRef"] = field(
        default=None,
        metadata={
            "name": "DTC-SETTING-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_setting_parameter: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DTC-SETTING-PARAMETER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DtcSettingClassRef(Ref):
        dest: DiagnosticControlDtcSettingClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticControlDtcSettingClass:
    """
    This meta-class contains attributes shared by all instances of the "Control DTC
    Setting" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar control_option_record_present: This represents the decision
        whether the DTCSettingControlOptionRecord (see ISO 14229-1) is
        in general supported in the request message.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CONTROL-DTC-SETTING-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticControlDtcSettingClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticControlDtcSettingClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticControlDtcSettingClass.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    control_option_record_present: Boolean | None = field(
        default=None,
        metadata={
            "name": "CONTROL-OPTION-RECORD-PRESENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticControlNeeds:
    """
    This meta-class indicates a service use-case for reporting the controlled
    status by diagnostic services.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CONTROL-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticControlNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticControlNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticControlNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticCustomServiceClass:
    """This represents the ability to define a custom diagnostic service class and
    assign an ID to it.

    Further configuration is not foreseen from the point of view of the
    diagnostic extract and consequently needs to be done on the level of
    ECUC.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar custom_service_id: This attribute may only be used for the
        definition of custom services. The values shall not overlap with
        existing standardized service IDs.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CUSTOM-SERVICE-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticCustomServiceClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticCustomServiceClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticCustomServiceClass.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    custom_service_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CUSTOM-SERVICE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticCustomServiceInstance:
    """
    This meta-class has the ability to define an instance of a custom diagnostic
    service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar custom_service_class_ref: Reference to the corresponding
        DiagnosticCustomServiceClass.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CUSTOM-SERVICE-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticCustomServiceInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticCustomServiceInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticCustomServiceInstance.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    custom_service_class_ref: Optional["DiagnosticCustomServiceInstance.CustomServiceClassRef"] = (
        field(
            default=None,
            metadata={
                "name": "CUSTOM-SERVICE-CLASS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CustomServiceClassRef(Ref):
        dest: DiagnosticCustomServiceClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDataElement:
    """
    This meta-class represents the ability to describe a concrete piece of data to
    be taken into account for diagnostic purposes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar array_size_semantics: This attribute controls the meaning of
        the value of the array size.
    :ivar max_number_of_elements: The existence of this attribute turns
        the data instance into an array of data. The attribute
        determines the size of the array in terms of how many elements
        the array can take.
    :ivar scaling_info_size: Size in bytes of scaling information for
        the DiagnosticDataElement if used with
        DiagnosticReadScalingDataByIdentifier
    :ivar sw_data_def_props: This property allows to specify data
        definition properties in order to support the definition of e.g.
        computation formulae and data constraints.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DiagnosticAbstractParameter.dataElement
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DATA-ELEMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDataElement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDataElement.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    array_size_semantics: ArraySizeSemanticsEnum | None = field(
        default=None,
        metadata={
            "name": "ARRAY-SIZE-SEMANTICS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_elements: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scaling_info_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SCALING-INFO-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDataIdentifierGenericInterface:
    """
    This meta-class represents the ability to implement a generic DID-focused
    PortInterface for diagnostics on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DATA-IDENTIFIER-GENERIC-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticDataIdentifierGenericInterface.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDataIdentifierGenericInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticDataIdentifierGenericInterface.BlueprintPolicys"] = (
        field(
            default=None,
            metadata={
                "name": "BLUEPRINT-POLICYS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticDataIdentifierGenericInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDataIdentifierSet:
    """
    This represents the ability to define a list of DiagnosticDataIdentifiers that
    can be reused in different contexts.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar data_identifier_refs: Reference to an ordered list of Data
        Identifiers.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DATA-IDENTIFIER-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDataIdentifierSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDataIdentifierSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_identifier_refs: Optional["DiagnosticDataIdentifierSet.DataIdentifierRefs"] = field(
        default=None,
        metadata={
            "name": "DATA-IDENTIFIER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataIdentifierRefs:
        data_identifier_ref: list[
            "DiagnosticDataIdentifierSet.DataIdentifierRefs.DataIdentifierRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DATA-IDENTIFIER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DataIdentifierRef(Ref):
            dest: DiagnosticDataIdentifierSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DiagnosticDataIdentifierSetRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar diagnostic_data_identifier_set_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DATA-IDENTIFIER-SET-REF-CONDITIONAL"

    diagnostic_data_identifier_set_ref: Optional[
        "DiagnosticDataIdentifierSetRefConditional.DiagnosticDataIdentifierSetRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-DATA-IDENTIFIER-SET-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticDataIdentifierSetRef(Ref):
        dest: DiagnosticDataIdentifierSetSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDataPortMapping:
    """
    This meta-class provides the ability to define a diagnostic access to an entire
    DID.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar diagnostic_data_element_ref: This reference represents the
        applicable DiagnosticDataElement.
    :ivar diagnostic_data_identifier_ref: This reference represents the
        applicable DiagnosticDataIdentfiier.
    :ivar p_port_prototype_in_executable_iref: This reference identifies
        the applicable PPortPrototype from which that data is obtained.
        The reference has the ability to point into the component
        hierarchy (under possible consideration of the
        rootSoftwareComposition).
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DATA-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDataPortMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDataPortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticDataPortMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticDataPortMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_data_element_ref: Optional["DiagnosticDataPortMapping.DiagnosticDataElementRef"] = (
        field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-DATA-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    diagnostic_data_identifier_ref: Optional[
        "DiagnosticDataPortMapping.DiagnosticDataIdentifierRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-DATA-IDENTIFIER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_port_prototype_in_executable_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "P-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticDataPortMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticDataElementRef(Ref):
        dest: DiagnosticDataElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticDataIdentifierRef(Ref):
        dest: DiagnosticDataIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDataTransfer:
    """
    This represents an instance of the "Data Transfer" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar data_transfer_class_ref: This reference substantiates that
        abstract reference in the role serviceClass for this specific
        concrete class. Thereby, the reference represents the ability to
        access shared attributes among all DiagnosticDataTransfer in the
        given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DATA-TRANSFER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDataTransfer.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDataTransfer.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticDataTransfer.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_transfer_class_ref: Optional["DiagnosticDataTransfer.DataTransferClassRef"] = field(
        default=None,
        metadata={
            "name": "DATA-TRANSFER-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataTransferClassRef(Ref):
        dest: DiagnosticDataTransferClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDataTransferClass:
    """
    This meta-class contains attributes shared by all instances of the "Data
    Transfer" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DATA-TRANSFER-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDataTransferClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDataTransferClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticDataTransferClass.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDeAuthentication:
    """
    This meta-class represents the subfunction to remove the authentication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar authentication_class_ref: This represents the corresponding
        "class", i.e. this meta-class provides properties that are
        shared among all instances of applicable sub-classes of
        DiagnosticServiceInstance. The subclasses that affected by this
        pattern implement references to the applicable "class"-role that
        substantiate this abstract reference.
    :ivar authentication_timeout: This attribute defines the time that
        the authentication state is maintained in default-session if
        there is no communication from the authenticated client.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DE-AUTHENTICATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDeAuthentication.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDeAuthentication.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticDeAuthentication.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_class_ref: Optional["DiagnosticDeAuthentication.AuthenticationClassRef"] = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AuthenticationClassRef(Ref):
        dest: DiagnosticAuthenticationClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDemProvidedDataMapping:
    """
    This represents the ability to define the nature of a data access for a
    DiagnosticDataElement in the Dem.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar data_element_ref: This represents the DiagnosticDataElement
        for which the access is further qualified by the
        DiagnosticDemProvidedDataMapping.
    :ivar data_provider: This represents the ability to further specify
        the access within the Dem.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DEM-PROVIDED-DATA-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDemProvidedDataMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDemProvidedDataMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticDemProvidedDataMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticDemProvidedDataMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["DiagnosticDemProvidedDataMapping.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_provider: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "DATA-PROVIDER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: DiagnosticDataElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDoIpActivationLineInterface:
    """
    This meta-class represents the ability to implement a PortInterface to
    implement the DoIPActivationLine on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DO-IP-ACTIVATION-LINE-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDoIpActivationLineInterface.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDoIpActivationLineInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticDoIpActivationLineInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticDoIpActivationLineInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDoIpEntityIdentificationInterface:
    """
    This meta-class represents the ability to implement a PortInterface to
    implement the DoIP Entity Identification on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DO-IP-ENTITY-IDENTIFICATION-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticDoIpEntityIdentificationInterface.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDoIpEntityIdentificationInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticDoIpEntityIdentificationInterface.BlueprintPolicys"] = (
        field(
            default=None,
            metadata={
                "name": "BLUEPRINT-POLICYS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticDoIpEntityIdentificationInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDoIpGroupIdentificationInterface:
    """
    This meta-class represents the ability to implement a PortInterface to
    implement the DoIP Group Identification on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DO-IP-GROUP-IDENTIFICATION-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticDoIpGroupIdentificationInterface.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDoIpGroupIdentificationInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticDoIpGroupIdentificationInterface.BlueprintPolicys"] = (
        field(
            default=None,
            metadata={
                "name": "BLUEPRINT-POLICYS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticDoIpGroupIdentificationInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDoIpPowerModeInterface:
    """
    This meta-class represents the ability to implement a PortInterface to
    implement the DoIP Power Mode on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DO-IP-POWER-MODE-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDoIpPowerModeInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDoIpPowerModeInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticDoIpPowerModeInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticDoIpPowerModeInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDoIpTriggerVehicleAnnouncementInterface:
    """
    This meta-class represents the ability to implement a PortInterface to
    implement the DoIPTriggerVehicleAnnouncement on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DO-IP-TRIGGER-VEHICLE-ANNOUNCEMENT-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticDoIpTriggerVehicleAnnouncementInterface.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDoIpTriggerVehicleAnnouncementInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional[
        "DiagnosticDoIpTriggerVehicleAnnouncementInterface.BlueprintPolicys"
    ] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticDoIpTriggerVehicleAnnouncementInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDownloadInterface:
    """
    This meta-class represents the ability to implement a PortInterface to process
    requests for downloading data using diagnostic channels on the adaptive
    platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DOWNLOAD-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDownloadInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDownloadInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticDownloadInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticDownloadInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDtcInformationInterface:
    """
    This meta-class represents the ability to implement a PortInterface to access
    the properties of DTCs  on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DTC-INFORMATION-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDtcInformationInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDtcInformationInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticDtcInformationInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticDtcInformationInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDynamicDataIdentifier:
    """
    This meta-class represents the ability to define a diagnostic data identifier
    (DID) at run-time.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar id: This is the numerical identifier used to identify the
        DiagnosticAbstractDataIdentifier in the scope of diagnostic
        workflow
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DYNAMIC-DATA-IDENTIFIER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDynamicDataIdentifier.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDynamicDataIdentifier.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    id: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDynamicallyDefineDataIdentifier:
    """
    This represents an instance of the "Dynamically Define Data Identifier"
    diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar data_identifier_ref: This represents the applicable
        DiagnosticDynamicDataIdentfier.
    :ivar dynamically_define_data_identifier_class_ref: This reference
        substantiates that abstract reference in the role serviceClass
        for this specific concrete class. Thereby, the reference
        represents the ability to access shared attributes among all
        DiagnosticDynamicallyDefineDataIdentifier in the given context.
    :ivar max_source_element: This represents the maximum number of
        source elements of the dynamically created DID.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticDynamicallyDefineDataIdentifier.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDynamicallyDefineDataIdentifier.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticDynamicallyDefineDataIdentifier.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_identifier_ref: Optional["DiagnosticDynamicallyDefineDataIdentifier.DataIdentifierRef"] = (
        field(
            default=None,
            metadata={
                "name": "DATA-IDENTIFIER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    dynamically_define_data_identifier_class_ref: Optional[
        "DiagnosticDynamicallyDefineDataIdentifier.DynamicallyDefineDataIdentifierClassRef"
    ] = field(
        default=None,
        metadata={
            "name": "DYNAMICALLY-DEFINE-DATA-IDENTIFIER-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_source_element: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-SOURCE-ELEMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataIdentifierRef(Ref):
        dest: DiagnosticDynamicDataIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DynamicallyDefineDataIdentifierClassRef(Ref):
        dest: DiagnosticDynamicallyDefineDataIdentifierClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDynamicallyDefineDataIdentifierClass:
    """
    This meta-class contains attributes shared by all instances of the "Dynamically
    Define Data Identifier" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar check_per_source_id: If set to TRUE, the Dcm module shall
        check the session, security and mode dependencies per source
        DIDs with a ReadDataByIdentifier (0x22) with DID in the range
        0xF200 to 0xF3FF. If set to FALSE. the Dcm module shall not
        check the session, security and mode dependencies per source
        DIDs with a ReadDataByIdentifier (0x22) with DID in the range
        0xF200 to 0xF3FF.
    :ivar configuration_handling: This configuration switch defines
        whether DDDID definition is handled as non-volatile information
        or not.
    :ivar subfunctions: This attribute contains a list of applicable
        subfunctions for all DiagnosticDynamicallyDefineDataIdentifier
        that reference the
        DiagnosticDynamicallyDefineDataIdentifierClass.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticDynamicallyDefineDataIdentifierClass.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDynamicallyDefineDataIdentifierClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticDynamicallyDefineDataIdentifierClass.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    check_per_source_id: Boolean | None = field(
        default=None,
        metadata={
            "name": "CHECK-PER-SOURCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_handling: DiagnosticHandleDddiConfigurationEnum | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-HANDLING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    subfunctions: Optional["DiagnosticDynamicallyDefineDataIdentifierClass.Subfunctions"] = field(
        default=None,
        metadata={
            "name": "SUBFUNCTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Subfunctions:
        subfunction: list[DiagnosticDynamicallyDefineDataIdentifierSubfunctionEnum] = field(
            default_factory=list,
            metadata={
                "name": "SUBFUNCTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEcuInstanceProps:
    """This meta-class represents the ability to model properties that are specific
    for a given EcuInstance but on the other hand represent purely diagnostic-
    related information.

    In the spirit of decentralized configuration it is therefore
    possible to specify the diagnostic-related information related to a
    given EcuInstance even if the EcuInstance does not yet exist.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar dtc_status_availability_mask: This attribute contains the
        value of the DTC status availability mask.
    :ivar ecu_instance_refs: This represents the actual EcuInstance to
        which the information contained in the DiagnosticEcuInstance
        contribute.
    :ivar obd_support: This attribute is used to specify the role (if
        applicable) in which the DiagnosticEcuInstance supports OBD.
    :ivar send_resp_pend_on_trans_to_boot: The purpose of this attribute
        is to define whether or not the ECU should send a NRC 0x78
        (response pending) before transitioning to the bootloader (in
        this case the attribute shall be set to "true") or if the
        transition shall be initiated without sending NRC 0x78 (in this
        case the attribute shall be set to "false").
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ECU-INSTANCE-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEcuInstanceProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEcuInstanceProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_status_availability_mask: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DTC-STATUS-AVAILABILITY-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_refs: Optional["DiagnosticEcuInstanceProps.EcuInstanceRefs"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    obd_support: DiagnosticObdSupportEnum | None = field(
        default=None,
        metadata={
            "name": "OBD-SUPPORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    send_resp_pend_on_trans_to_boot: Boolean | None = field(
        default=None,
        metadata={
            "name": "SEND-RESP-PEND-ON-TRANS-TO-BOOT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRefs:
        ecu_instance_ref: list["DiagnosticEcuInstanceProps.EcuInstanceRefs.EcuInstanceRef"] = field(
            default_factory=list,
            metadata={
                "name": "ECU-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EcuInstanceRef(Ref):
            dest: EcuInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DiagnosticEcuReset:
    """
    This represents an instance of the "ECU Reset" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar custom_sub_function_number: This attribute shall be used to
        define a custom sub-function number if none of the standardized
        values of category shall be used.
    :ivar ecu_reset_class_ref: This reference substantiates that
        abstract reference in the role serviceClass for this specific
        concrete class. Thereby, the reference represents the ability to
        access shared attributes among all DiagnosticEcuReset in the
        given context.
    :ivar respond_to_reset: This attribute defines whether the response
        to the EcuReset service shall be transmitted before or after the
        actual reset.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ECU-RESET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEcuReset.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEcuReset.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticEcuReset.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    custom_sub_function_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CUSTOM-SUB-FUNCTION-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_reset_class_ref: Optional["DiagnosticEcuReset.EcuResetClassRef"] = field(
        default=None,
        metadata={
            "name": "ECU-RESET-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    respond_to_reset: DiagnosticResponseToEcuResetEnum | None = field(
        default=None,
        metadata={
            "name": "RESPOND-TO-RESET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuResetClassRef(Ref):
        dest: DiagnosticEcuResetClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEcuResetClass:
    """
    This meta-class contains attributes shared by all instances of the "Ecu Reset"
    diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar respond_to_reset: This attribute defines whether the response
        to the EcuReset service shall be transmitted before or after the
        actual reset.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ECU-RESET-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEcuResetClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEcuResetClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticEcuResetClass.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    respond_to_reset: DiagnosticResponseToEcuResetEnum | None = field(
        default=None,
        metadata={
            "name": "RESPOND-TO-RESET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEcuResetInterface:
    """
    This meta-class represents the ability to implement a focused PortInterface for
    handling the diagnostic service EcuReset on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ECU-RESET-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEcuResetInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEcuResetInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticEcuResetInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticEcuResetInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEnableCondition:
    """
    Specification of an enable condition.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar init_value: Defines the initial status for enable or disable
        of acceptance/storage of event reports of a diagnostic event.
        The value is the initialization after power up (before this
        condition is reported the first time). true: acceptance/storage
        of a diagnostic event enabled false: acceptance/storage of a
        diagnostic event disabled
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ENABLE-CONDITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEnableCondition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEnableCondition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    init_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEnableConditionNeeds:
    """
    This meta-class represents the needs of a software-component to provide the
    capability to set an enable condition.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar initial_status: Defines the initial status for enable or
        disable of acceptance of event reports of a diagnostic event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ENABLE-CONDITION-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEnableConditionNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEnableConditionNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticEnableConditionNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_status: EventAcceptanceStatusEnum | None = field(
        default=None,
        metadata={
            "name": "INITIAL-STATUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEnableConditionPortMapping:
    """
    Defines to which SWC service ports with DiagnosticEnableConditionNeeds the
    DiagnosticEnableCondition is mapped.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar enable_condition_ref: Reference to the EnableCondition which
        is mapped to a SWC service port with
        DiagnosticEnableConditionNeeds.
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar r_port_prototype_in_executable_iref: This aggregation allows
        for the usage of the DiagnosticEnableConditionPortMapping on the
        AUTOSAR adaptive platform.
    :ivar swc_flat_service_dependency_ref: Reference to a
        SwcServiceDependencyType that links ServiceNeeds to SWC service
        ports. This reference can be used in early stages of the
        development in order to identify the SwcServiceDependency
        without a full System Context.
    :ivar swc_service_dependency_in_system_iref: Instance reference to a
        SwcServiceDependency that links ServiceNeeds to SWC service
        ports.
    :ivar swc_service_dependency_iref: Instance reference to a
        SwcServiceDependency that links ServiceNeeds to SWC service
        ports.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ENABLE-CONDITION-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEnableConditionPortMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEnableConditionPortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticEnableConditionPortMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticEnableConditionPortMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    enable_condition_ref: Optional["DiagnosticEnableConditionPortMapping.EnableConditionRef"] = (
        field(
            default=None,
            metadata={
                "name": "ENABLE-CONDITION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    process_ref: Optional["DiagnosticEnableConditionPortMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    r_port_prototype_in_executable_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "R-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_flat_service_dependency_ref: Optional[
        "DiagnosticEnableConditionPortMapping.SwcFlatServiceDependencyRef"
    ] = field(
        default=None,
        metadata={
            "name": "SWC-FLAT-SERVICE-DEPENDENCY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_service_dependency_in_system_iref: SwcServiceDependencyInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SWC-SERVICE-DEPENDENCY-IN-SYSTEM-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_service_dependency_iref: SwcServiceDependencyInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SWC-SERVICE-DEPENDENCY-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EnableConditionRef(Ref):
        dest: DiagnosticEnableConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SwcFlatServiceDependencyRef(Ref):
        dest: SwcServiceDependencySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEnableConditionRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar diagnostic_enable_condition_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ENABLE-CONDITION-REF-CONDITIONAL"

    diagnostic_enable_condition_ref: Optional[
        "DiagnosticEnableConditionRefConditional.DiagnosticEnableConditionRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-ENABLE-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticEnableConditionRef(Ref):
        dest: DiagnosticEnableConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventInfoNeeds:
    """
    This meta-class represents the needs of a software-component interested to get
    information regarding specific DTCs.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar dtc_kind: This attribute indicates the kind of the diagnostic
        event according to the SWS Diagnostic Event Manger for which the
        DiagnosticInfo is requested. This attribute applies for the UDS
        diagnostics use case.
    :ivar dtc_number: This represents a reasonable Diagnostic Trouble
        Code for which the DiagnosticInfo is requested.
    :ivar obd_dtc_number: This represents a reasonable Diagnostic
        Trouble Code. This allows to predefine the Diagnostic Trouble
        Code, e.g. if the function developer has received a particular
        requirement from the OEM or from a standardization body. This
        attribute applies for the OBD diagnostics use case.
    :ivar uds_dtc_number: This represents a reasonable Diagnostic
        Trouble Code. This allows to predefine the Diagnostic Trouble
        Code, e.g. if the function developer has received a particular
        requirement from the OEM or from a standardization body. This
        attribute applies for the UDS diagnostics use case.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-INFO-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEventInfoNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEventInfoNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticEventInfoNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_kind: DtcKindEnum | None = field(
        default=None,
        metadata={
            "name": "DTC-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DTC-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    obd_dtc_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "OBD-DTC-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uds_dtc_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UDS-DTC-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventInterface:
    """
    This meta-class represents the ability to implement a PortInterface to access
    the properties of diagnostic events  on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEventInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEventInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticEventInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticEventInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventManagerNeeds:
    """
    Specifies the general needs on the configuration of the  Diagnostic Event
    Manager (Dem) which are not related to a particular item.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-MANAGER-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEventManagerNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEventManagerNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticEventManagerNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventPortMapping:
    """
    Defines to which SWC service ports with DiagnosticEventInfoNeeds the
    DiagnosticEvent is mapped.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar bsw_service_dependency_ref: Reference to a
        BswServiceDependency that links ServiceNeeds to
        BswModuleEntries.
    :ivar diagnostic_event_ref: Reference to the DiagnosticEvent that is
        assigned to SWC service ports with DiagnosticEventInfoNeeds.
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar r_port_prototype_in_executable_iref: This aggregation allows
        for the usage of the DiagnosticEventPortMapping on the AUTOSAR
        adaptive platform.
    :ivar swc_flat_service_dependency_ref: Reference to a
        SwcServiceDependencyType that links ServiceNeeds to SWC service
        ports.
    :ivar swc_service_dependency_in_system_iref: Instance reference to a
        SwcServiceDependency that links ServiceNeeds to SWC service
        ports.
    :ivar swc_service_dependency_iref: Instance reference to a
        SwcServiceDependency that links ServiceNeeds to SWC service
        ports.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEventPortMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEventPortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticEventPortMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticEventPortMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_service_dependency_ref: Optional["DiagnosticEventPortMapping.BswServiceDependencyRef"] = (
        field(
            default=None,
            metadata={
                "name": "BSW-SERVICE-DEPENDENCY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    diagnostic_event_ref: Optional["DiagnosticEventPortMapping.DiagnosticEventRef"] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticEventPortMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    r_port_prototype_in_executable_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "R-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_flat_service_dependency_ref: Optional[
        "DiagnosticEventPortMapping.SwcFlatServiceDependencyRef"
    ] = field(
        default=None,
        metadata={
            "name": "SWC-FLAT-SERVICE-DEPENDENCY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_service_dependency_in_system_iref: SwcServiceDependencyInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SWC-SERVICE-DEPENDENCY-IN-SYSTEM-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_service_dependency_iref: SwcServiceDependencyInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SWC-SERVICE-DEPENDENCY-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class BswServiceDependencyRef(Ref):
        dest: BswServiceDependencyIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SwcFlatServiceDependencyRef(Ref):
        dest: SwcServiceDependencySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar diagnostic_event_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-REF-CONDITIONAL"

    diagnostic_event_ref: Optional["DiagnosticEventRefConditional.DiagnosticEventRef"] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventToDebounceAlgorithmMapping:
    """
    Defines which Debounce Algorithm is applicable for a DiagnosticEvent.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar debounce_algorithm_ref: Reference to a DebounceAlgorithm
        assigned to a DiagnosticEvent.
    :ivar diagnostic_event_ref: Reference to a DiagnosticEvent to which
        a DebounceAlgorithm is assigned.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-TO-DEBOUNCE-ALGORITHM-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticEventToDebounceAlgorithmMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEventToDebounceAlgorithmMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticEventToDebounceAlgorithmMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticEventToDebounceAlgorithmMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    debounce_algorithm_ref: Optional[
        "DiagnosticEventToDebounceAlgorithmMapping.DebounceAlgorithmRef"
    ] = field(
        default=None,
        metadata={
            "name": "DEBOUNCE-ALGORITHM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_event_ref: Optional[
        "DiagnosticEventToDebounceAlgorithmMapping.DiagnosticEventRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DebounceAlgorithmRef(Ref):
        dest: DiagnosticDebounceAlgorithmPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventToEnableConditionGroupMapping:
    """
    Defines which EnableConditionGroup is applicable for a DiagnosticEvent.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar diagnostic_event_ref: Reference to a DiagnosticEvent to which
        an EnableConditionGroup is assigned.
    :ivar enable_condition_group_ref: Reference to an
        EnableConditionGroup assigned to a DiagnosticEvent.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-TO-ENABLE-CONDITION-GROUP-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticEventToEnableConditionGroupMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEventToEnableConditionGroupMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticEventToEnableConditionGroupMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticEventToEnableConditionGroupMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_event_ref: Optional[
        "DiagnosticEventToEnableConditionGroupMapping.DiagnosticEventRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    enable_condition_group_ref: Optional[
        "DiagnosticEventToEnableConditionGroupMapping.EnableConditionGroupRef"
    ] = field(
        default=None,
        metadata={
            "name": "ENABLE-CONDITION-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EnableConditionGroupRef(Ref):
        dest: DiagnosticEnableConditionGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventToOperationCycleMapping:
    """
    Defines which OperationCycle is applicable for a DiagnosticEvent.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar diagnostic_event_ref: Reference to a DiagnosticEvent to which
        an OperationCycle is assigned.
    :ivar operation_cycle_ref: Reference to an OperationCycle assigned
        to a DiagnosticEvent.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-TO-OPERATION-CYCLE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEventToOperationCycleMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEventToOperationCycleMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticEventToOperationCycleMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticEventToOperationCycleMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_event_ref: Optional["DiagnosticEventToOperationCycleMapping.DiagnosticEventRef"] = (
        field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-EVENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    operation_cycle_ref: Optional["DiagnosticEventToOperationCycleMapping.OperationCycleRef"] = (
        field(
            default=None,
            metadata={
                "name": "OPERATION-CYCLE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class OperationCycleRef(Ref):
        dest: DiagnosticOperationCycleSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventToSecurityEventMapping:
    """
    This meta-class represents the ability to map a security event that is defined
    in the context of the Security Extract to a diagnostic event defined on the
    context of the DiagnosticExtract.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar diagnostic_event_ref: This reference identifies the applicable
        diagnostic event.
    :ivar security_event_props_ref: This reference identifies the
        qualification of the applicable security event
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-TO-SECURITY-EVENT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEventToSecurityEventMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEventToSecurityEventMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticEventToSecurityEventMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticEventToSecurityEventMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_event_ref: Optional["DiagnosticEventToSecurityEventMapping.DiagnosticEventRef"] = (
        field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-EVENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    security_event_props_ref: Optional[
        "DiagnosticEventToSecurityEventMapping.SecurityEventPropsRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECURITY-EVENT-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecurityEventPropsRef(Ref):
        dest: SecurityEventContextPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventToStorageConditionGroupMapping:
    """
    Defines which StorageConditionGroup is applicable for a DiagnosticEvent.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar diagnostic_event_ref: Reference to a DiagnosticEvent to which
        a StorageConditionGroup is assigned.
    :ivar storage_condition_group_ref: Reference to a
        StorageConditionGroup assigned to a DiagnosticEvent.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-TO-STORAGE-CONDITION-GROUP-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticEventToStorageConditionGroupMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEventToStorageConditionGroupMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticEventToStorageConditionGroupMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticEventToStorageConditionGroupMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_event_ref: Optional[
        "DiagnosticEventToStorageConditionGroupMapping.DiagnosticEventRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    storage_condition_group_ref: Optional[
        "DiagnosticEventToStorageConditionGroupMapping.StorageConditionGroupRef"
    ] = field(
        default=None,
        metadata={
            "name": "STORAGE-CONDITION-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class StorageConditionGroupRef(Ref):
        dest: DiagnosticStorageConditionGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventToTroubleCodeJ1939Mapping:
    """
    By means of this meta-class it is possible to associate a DiagnosticEvent to a
    DiagnosticTroubleCodeJ1939.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar diagnostic_event_ref: Reference to a DiagnosticEvent to which
        a J1939 Diagnostic Trouble Code is assigned.
    :ivar trouble_code_j_1939_ref: Reference to a J1939 Diagnostic
        Trouble Code to which a DiagnosticEvent is assigned.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-TO-TROUBLE-CODE-J-1939-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticEventToTroubleCodeJ1939Mapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEventToTroubleCodeJ1939Mapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticEventToTroubleCodeJ1939Mapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticEventToTroubleCodeJ1939Mapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_event_ref: Optional[
        "DiagnosticEventToTroubleCodeJ1939Mapping.DiagnosticEventRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trouble_code_j_1939_ref: Optional[
        "DiagnosticEventToTroubleCodeJ1939Mapping.TroubleCodeJ1939Ref"
    ] = field(
        default=None,
        metadata={
            "name": "TROUBLE-CODE-J-1939-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TroubleCodeJ1939Ref(Ref):
        dest: DiagnosticTroubleCodeJ1939SubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventToTroubleCodeUdsMapping:
    """
    Defines which UDS Diagnostic Trouble Code is applicable for a DiagnosticEvent.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar diagnostic_event_ref: Reference to a DiagnosticEvent to which
        a UDS Diagnostic Trouble Code  is assigned.
    :ivar trouble_code_uds_ref: Reference to an UDS Diagnostic Trouble
        Code  assigned to a DiagnosticEvent.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-TO-TROUBLE-CODE-UDS-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEventToTroubleCodeUdsMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEventToTroubleCodeUdsMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticEventToTroubleCodeUdsMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticEventToTroubleCodeUdsMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_event_ref: Optional["DiagnosticEventToTroubleCodeUdsMapping.DiagnosticEventRef"] = (
        field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-EVENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    trouble_code_uds_ref: Optional["DiagnosticEventToTroubleCodeUdsMapping.TroubleCodeUdsRef"] = (
        field(
            default=None,
            metadata={
                "name": "TROUBLE-CODE-UDS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TroubleCodeUdsRef(Ref):
        dest: DiagnosticTroubleCodeUdsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticExtendedDataRecordRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar diagnostic_extended_data_record_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EXTENDED-DATA-RECORD-REF-CONDITIONAL"

    diagnostic_extended_data_record_ref: Optional[
        "DiagnosticExtendedDataRecordRefConditional.DiagnosticExtendedDataRecordRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-EXTENDED-DATA-RECORD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticExtendedDataRecordRef(Ref):
        dest: DiagnosticExtendedDataRecordSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticExternalAuthenticationInterface:
    """
    This meta-class represents the ability to implement a focused PortInterface for
    handling the diagnostic client authentication (i.e. convey the Authentication
    state to the Diagnostic Server instance of the DM) on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticExternalAuthenticationInterface.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticExternalAuthenticationInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticExternalAuthenticationInterface.BlueprintPolicys"] = (
        field(
            default=None,
            metadata={
                "name": "BLUEPRINT-POLICYS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticExternalAuthenticationInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticExternalAuthenticationPortMapping:
    """
    This mapping class identifies the PortPrototype in the application software
    that handles the external authentication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar diagnostic_authentication_ref: Reference to the
        DiagnosticAuthentication that is assigned to a SWC service port.
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar r_port_prototype_in_executable_iref: This aggregation allows
        for the usage of the DiagnosticClientAuthenticationPortMapping
        on the AUTOSAR adaptive platform.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticExternalAuthenticationPortMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticExternalAuthenticationPortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticExternalAuthenticationPortMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticExternalAuthenticationPortMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_authentication_ref: Optional[
        "DiagnosticExternalAuthenticationPortMapping.DiagnosticAuthenticationRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-AUTHENTICATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticExternalAuthenticationPortMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    r_port_prototype_in_executable_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "R-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticAuthenticationRef(Ref):
        dest: DiagnosticAuthenticationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticFimAliasEvent:
    """This meta-class is used to represent a given event semantics.

    However, the name of the actual events used in a specific project is
    sometimes not defined yet, not known or not in the responsibility of
    the author. Therefore, the DiagnosticFimAliasEvent has a reference
    to the actual DiagnosticEvent and by this the final connection is
    created.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-FIM-ALIAS-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticFimAliasEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticFimAliasEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticFimAliasEventGroup:
    """This meta-class represents the ability to define an alias for a Fim
    summarized event.

    This alias can be used in early phases of the configuration process
    until a further refinement is possible.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar grouped_alias_event_refs: By means of this reference the
        grouping of DiagnosticAliasEvents within the
        DiagnosticFimSummaryEvent can be specified.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticFimAliasEventGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticFimAliasEventGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    grouped_alias_event_refs: Optional["DiagnosticFimAliasEventGroup.GroupedAliasEventRefs"] = (
        field(
            default=None,
            metadata={
                "name": "GROUPED-ALIAS-EVENT-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class GroupedAliasEventRefs:
        grouped_alias_event_ref: list[
            "DiagnosticFimAliasEventGroup.GroupedAliasEventRefs.GroupedAliasEventRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "GROUPED-ALIAS-EVENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class GroupedAliasEventRef(Ref):
            dest: DiagnosticFimAliasEventSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DiagnosticFimAliasEventGroupMapping:
    """This meta-class represents the ability to map a DiagnosticFimEventGroup to a
    DiagnosticFimAliasEventGroup.

    By this means the "preliminary" modeling by way of a
    DiagnosticFimAliasEventGroup is further substantiated.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar actual_event_ref: This represents the reference to the actual
        summary event.
    :ivar alias_event_ref: This represents the reference to the alias
        summary event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticFimAliasEventGroupMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticFimAliasEventGroupMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticFimAliasEventGroupMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticFimAliasEventGroupMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    actual_event_ref: Optional["DiagnosticFimAliasEventGroupMapping.ActualEventRef"] = field(
        default=None,
        metadata={
            "name": "ACTUAL-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alias_event_ref: Optional["DiagnosticFimAliasEventGroupMapping.AliasEventRef"] = field(
        default=None,
        metadata={
            "name": "ALIAS-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ActualEventRef(Ref):
        dest: DiagnosticFimEventGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AliasEventRef(Ref):
        dest: DiagnosticFimAliasEventGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticFimAliasEventMapping:
    """This meta-class represents the ability to model the mapping of a
    DiagnosticEvent to a DiagnosticAliasEvent.

    By this means the "preliminary" modeling by way of a
    DiagnosticAliasEvent is further substantiated.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar actual_event_ref: This represents the reference to the actual
        diagnostic event.
    :ivar alias_event_ref: This represents the reference to the alias
        event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-FIM-ALIAS-EVENT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticFimAliasEventMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticFimAliasEventMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticFimAliasEventMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticFimAliasEventMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    actual_event_ref: Optional["DiagnosticFimAliasEventMapping.ActualEventRef"] = field(
        default=None,
        metadata={
            "name": "ACTUAL-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alias_event_ref: Optional["DiagnosticFimAliasEventMapping.AliasEventRef"] = field(
        default=None,
        metadata={
            "name": "ALIAS-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ActualEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AliasEventRef(Ref):
        dest: DiagnosticFimAliasEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticFimEventGroup:
    """This meta-class represents the ability to model a Fim event group, also
    known as a summary event in Fim terminology.

    This represents a group of single diagnostic events.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar event_refs: This reference represents the way of grouping
        diagnostic events into a summary event in the context of the
        Fim.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-FIM-EVENT-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticFimEventGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticFimEventGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_refs: Optional["DiagnosticFimEventGroup.EventRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventRefs:
        event_ref: list["DiagnosticFimEventGroup.EventRefs.EventRef"] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EventRef(Ref):
            dest: DiagnosticEventSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DiagnosticFimFunctionMapping:
    """This meta-class represents the ability to define a mapping between a
    function identifier (FID) and the corresponding SwcServiceDependency in the
    application software resp.

    basic software.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar mapped_bsw_service_dependency_ref: This is supposed to
        represent a reference to a BswServiceDependency. the latter is
        not derived from Referrable and therefore this detour needs to
        be implemented to still let BswServiceDependency become the
        target of a reference.
    :ivar mapped_flat_swc_service_dependency_ref: This represents the
        ability to refer to an AtomicSwComponentType that is available
        without the definition of how it will be embedded into the
        component hierarchy.
    :ivar mapped_function_ref: This represents the mapped FID.
    :ivar mapped_swc_service_dependency_iref: This represents the
        ability to point into the component hierarchy (under possible
        consideration of the rootSoftwareComposition).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-FIM-FUNCTION-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticFimFunctionMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticFimFunctionMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticFimFunctionMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticFimFunctionMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapped_bsw_service_dependency_ref: Optional[
        "DiagnosticFimFunctionMapping.MappedBswServiceDependencyRef"
    ] = field(
        default=None,
        metadata={
            "name": "MAPPED-BSW-SERVICE-DEPENDENCY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapped_flat_swc_service_dependency_ref: Optional[
        "DiagnosticFimFunctionMapping.MappedFlatSwcServiceDependencyRef"
    ] = field(
        default=None,
        metadata={
            "name": "MAPPED-FLAT-SWC-SERVICE-DEPENDENCY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapped_function_ref: Optional["DiagnosticFimFunctionMapping.MappedFunctionRef"] = field(
        default=None,
        metadata={
            "name": "MAPPED-FUNCTION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapped_swc_service_dependency_iref: SwcServiceDependencyInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "MAPPED-SWC-SERVICE-DEPENDENCY-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MappedBswServiceDependencyRef(Ref):
        dest: BswServiceDependencyIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MappedFlatSwcServiceDependencyRef(Ref):
        dest: SwcServiceDependencySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MappedFunctionRef(Ref):
        dest: DiagnosticFunctionIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticFreezeFrame:
    """
    This element describes combinations of DIDs for a non OBD relevant freeze
    frame.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar custom_trigger: This attribute shall be taken to verbally
        describe the nature of the custom trigger.
    :ivar record_number: This attribute defines a record number for a
        freeze frame record.
    :ivar trigger: This attribute defines the primary trigger to
        allocate an event memory entry.
    :ivar update: This attribute defines the approach when the freeze
        frame record is stored/updated. True: FreezeFrame record is
        captured every time. False: FreezeFrame record is only captured
        for new event memory entries.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-FREEZE-FRAME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticFreezeFrame.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticFreezeFrame.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    custom_trigger: String | None = field(
        default=None,
        metadata={
            "name": "CUSTOM-TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    record_number: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "RECORD-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger: DiagnosticRecordTriggerEnum | None = field(
        default=None,
        metadata={
            "name": "TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update: Boolean | None = field(
        default=None,
        metadata={
            "name": "UPDATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticFreezeFrameRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar diagnostic_freeze_frame_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-FREEZE-FRAME-REF-CONDITIONAL"

    diagnostic_freeze_frame_ref: Optional[
        "DiagnosticFreezeFrameRefConditional.DiagnosticFreezeFrameRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-FREEZE-FRAME-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticFreezeFrameRef(Ref):
        dest: DiagnosticFreezeFrameSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticFunctionIdentifier:
    """This meta-class represents a diagnostic function identifier (a.k.a.

    FID).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-FUNCTION-IDENTIFIER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticFunctionIdentifier.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticFunctionIdentifier.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticFunctionInhibitSource:
    """
    This meta-class represents the ability to define an inhibition source in the
    context of the Fim configuration.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar event_group_ref: This represents the event group applicable
        for the referencing inhibition source.
    :ivar event_ref: This represents the alias event applicable for the
        referencing inhibition source.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-FUNCTION-INHIBIT-SOURCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticFunctionInhibitSource.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticFunctionInhibitSource.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_ref: Optional["DiagnosticFunctionInhibitSource.EventGroupRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["DiagnosticFunctionInhibitSource.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventGroupRef(Ref):
        dest: DiagnosticFimAliasEventGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: DiagnosticFimAliasEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticGenericUdsInterface:
    """
    This meta-class represents the ability to implement a generic UDS PortInterface
    for diagnostics on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-GENERIC-UDS-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticGenericUdsInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticGenericUdsInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticGenericUdsInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticGenericUdsInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticGenericUdsNeeds:
    """
    This meta-class represents the needs of a software-component to provide the
    capability to process a generic UDS service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-GENERIC-UDS-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticGenericUdsNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticGenericUdsNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticGenericUdsNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticIndicator:
    """
    Definition of an indicator.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar healing_cycle_counter_threshold: This attribute defines the
        number of healing cycles for the WarningIndicatorOffCriteria
    :ivar type_value: Defines the type of the indicator.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-INDICATOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticIndicator.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticIndicator.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    healing_cycle_counter_threshold: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "HEALING-CYCLE-COUNTER-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_value: DiagnosticIndicatorTypeEnumValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticIndicatorInterface:
    """
    This meta-class represents the ability to implement a PortInterface to
    implement indicator functionality on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-INDICATOR-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticIndicatorInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticIndicatorInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticIndicatorInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticIndicatorInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticIndicatorNeeds:
    """
    This meta-class represents the needs of a software-component to provide the
    capability to implement an indicator.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-INDICATOR-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticIndicatorNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticIndicatorNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticIndicatorNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticIndicatorPortMapping:
    """
    Defines to which SWC service ports with DiagnosticsIndicatorNeeds the
    DiagnosticIndicator is mapped.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar indicator_ref: Reference to the DiagnosticIndicator which is
        mapped to a SWC service port with DiagnosticIndicatorNeeds.
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar r_port_prototype_in_executable_iref: This aggregation allows
        for the usage of the DiagnosticIndicatorMapping on the AUTOSAR
        adaptive platform.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-INDICATOR-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticIndicatorPortMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticIndicatorPortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticIndicatorPortMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticIndicatorPortMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    indicator_ref: Optional["DiagnosticIndicatorPortMapping.IndicatorRef"] = field(
        default=None,
        metadata={
            "name": "INDICATOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticIndicatorPortMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    r_port_prototype_in_executable_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "R-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IndicatorRef(Ref):
        dest: DiagnosticIndicatorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticInhibitSourceEventMapping:
    """This meta-class represents the ability to map a
    DiagnosticFunctionInhibitSource directly to alternatively one DiagnosticEvent
    or one DiagnosticFimSummaryEvent.

    This model element shall be used if the approach via the alias
    events is not applicable, i.e. when diagnostic events defined by the
    Dem are already available at the time the Fim configuration within
    the diagnostic extract is created.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar diagnostic_event_ref: This represents the reference to the
        diagnostic event.
    :ivar event_group_ref: This represents the reference to the event
        group
    :ivar inhibition_source_ref: This represents the reference to the
        inhibition source.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-INHIBIT-SOURCE-EVENT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticInhibitSourceEventMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticInhibitSourceEventMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticInhibitSourceEventMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticInhibitSourceEventMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_event_ref: Optional["DiagnosticInhibitSourceEventMapping.DiagnosticEventRef"] = (
        field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-EVENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    event_group_ref: Optional["DiagnosticInhibitSourceEventMapping.EventGroupRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    inhibition_source_ref: Optional["DiagnosticInhibitSourceEventMapping.InhibitionSourceRef"] = (
        field(
            default=None,
            metadata={
                "name": "INHIBITION-SOURCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventGroupRef(Ref):
        dest: DiagnosticFimEventGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class InhibitionSourceRef(Ref):
        dest: DiagnosticFunctionInhibitSourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticIoControl:
    """
    This represents an instance of the "I/O Control" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar control_enable_mask_bits: This aggregation represents the
        control mask record consisting of single bits.
    :ivar data_identifier_ref: This represents the corresponding
        DiagnosticDataIdentifier
    :ivar freeze_current_state: Setting this attribute to true
        represents the ability of the Dcm to execute a
        freezeCurrentState.
    :ivar io_control_class_ref: This reference substantiates that
        abstract reference in the role serviceClass for this specific
        concrete class. Thereby, the reference represents the ability to
        access shared attributes among all DiagnosticIOControl in the
        given context.
    :ivar reset_to_default: Setting this attribute to true represents
        the ability of the Dcm to execute a resetToDefault.
    :ivar short_term_adjustment: Setting this attribute to true
        represents the ability of the Dcm to execute a
        shortTermAdjustment.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-IO-CONTROL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticIoControl.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticIoControl.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticIoControl.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    control_enable_mask_bits: Optional["DiagnosticIoControl.ControlEnableMaskBits"] = field(
        default=None,
        metadata={
            "name": "CONTROL-ENABLE-MASK-BITS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_identifier_ref: Optional["DiagnosticIoControl.DataIdentifierRef"] = field(
        default=None,
        metadata={
            "name": "DATA-IDENTIFIER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freeze_current_state: Boolean | None = field(
        default=None,
        metadata={
            "name": "FREEZE-CURRENT-STATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    io_control_class_ref: Optional["DiagnosticIoControl.IoControlClassRef"] = field(
        default=None,
        metadata={
            "name": "IO-CONTROL-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reset_to_default: Boolean | None = field(
        default=None,
        metadata={
            "name": "RESET-TO-DEFAULT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_term_adjustment: Boolean | None = field(
        default=None,
        metadata={
            "name": "SHORT-TERM-ADJUSTMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ControlEnableMaskBits:
        diagnostic_control_enable_mask_bit: list[DiagnosticControlEnableMaskBit] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CONTROL-ENABLE-MASK-BIT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataIdentifierRef(Ref):
        dest: DiagnosticDataIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IoControlClassRef(Ref):
        dest: DiagnosticIoControlClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticIoControlClass:
    """
    This meta-class contains attributes shared by all instances of the "IO Control"
    diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-IO-CONTROL-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticIoControlClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticIoControlClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticIoControlClass.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticIoControlNeeds:
    """Specifies the general needs on the configuration of the  Diagnostic
    Communication Manager (DCM) which are not related to a particular item (e.g. a
    PID).

    The main use case is the mapping of service ports to the Dcm which
    are not related to a particular item.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar current_value_ref: Reference to the DiagnosticValueNeeds
        indicating the access to the current value via
        signalBasedDiagnostics.
    :ivar did_number: This represents a Data identifier for the
        diagnostic value. This allows to predefine the DID number if the
        a function developer has received a particular requirement from
        the OEM or from a standardization body.
    :ivar freeze_current_state_supported: This attribute determines, if
        the referenced port  supports temporary freezing of  I/O value.
    :ivar reset_to_default_supported: This represents a flag for the
        existence of the ResetToDefault operation in the service
        interface.
    :ivar short_term_adjustment_supported: This attribute determines, if
        the referenced port  supports temporarily setting  of  I/O value
        to a specific value provided by the diagnostic tester.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-IO-CONTROL-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticIoControlNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticIoControlNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticIoControlNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    current_value_ref: Optional["DiagnosticIoControlNeeds.CurrentValueRef"] = field(
        default=None,
        metadata={
            "name": "CURRENT-VALUE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    did_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DID-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freeze_current_state_supported: Boolean | None = field(
        default=None,
        metadata={
            "name": "FREEZE-CURRENT-STATE-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reset_to_default_supported: Boolean | None = field(
        default=None,
        metadata={
            "name": "RESET-TO-DEFAULT-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_term_adjustment_supported: Boolean | None = field(
        default=None,
        metadata={
            "name": "SHORT-TERM-ADJUSTMENT-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CurrentValueRef(Ref):
        dest: DiagnosticValueNeedsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticIumpr:
    """This meta-class represents the ability to model the in-use monitor
    performance ratio.

    The latter computes to the number of times a fault could have been
    found divided by the number of times the vehicle conditions have
    been properly fulfilled.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar event_ref: This reference represents the DiagnosticEvent that
        corresponds to the IUMPR computation.
    :ivar ratio_kind: This attribute controls the behavior of how the
        ratio is calculated.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-IUMPR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticIumpr.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticIumpr.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["DiagnosticIumpr.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ratio_kind: DiagnosticIumprKindEnum | None = field(
        default=None,
        metadata={
            "name": "RATIO-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticIumprDenominatorGroup:
    """
    This meta-class represents the ability to model a IUMPR denominator groups.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar iumpr_refs: This reference collects DiagnosticIumpr to a
        DiagnosticIumprDenominatorGroup.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-IUMPR-DENOMINATOR-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticIumprDenominatorGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticIumprDenominatorGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    iumpr_refs: Optional["DiagnosticIumprDenominatorGroup.IumprRefs"] = field(
        default=None,
        metadata={
            "name": "IUMPR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IumprRefs:
        iumpr_ref: list["DiagnosticIumprDenominatorGroup.IumprRefs.IumprRef"] = field(
            default_factory=list,
            metadata={
                "name": "IUMPR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class IumprRef(Ref):
            dest: DiagnosticIumprSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DiagnosticIumprGroupIdentifier:
    """
    This meta-class provides the ability to the define the group identifier for an
    IumprGroup.

    :ivar group_id: This attribute shall be taken to define an
        identifier for the IUMPR group. Please note that the value of
        this identifier is driven by regulations outside the scope of
        AUTOSAR and can therefore not be limited to the set of
        characters suitable for a shortName.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DiagnosticIumprGroup.iumprGroupIdentifier
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-IUMPR-GROUP-IDENTIFIER"

    group_id: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "GROUP-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticIumprToFunctionIdentifierMapping:
    """
    This meta-class represents the ability to associate a
    DiagnosticFunctionIdentifier with a DiagnosticIumpr.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar function_identifier_ref: This reference identifies the
        applicable DiagnosticFunctionIdentifier.
    :ivar iumpr_ref: This reference identifies the applicable
        DiagnosticIumpr.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-IUMPR-TO-FUNCTION-IDENTIFIER-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticIumprToFunctionIdentifierMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticIumprToFunctionIdentifierMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticIumprToFunctionIdentifierMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticIumprToFunctionIdentifierMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    function_identifier_ref: Optional[
        "DiagnosticIumprToFunctionIdentifierMapping.FunctionIdentifierRef"
    ] = field(
        default=None,
        metadata={
            "name": "FUNCTION-IDENTIFIER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    iumpr_ref: Optional["DiagnosticIumprToFunctionIdentifierMapping.IumprRef"] = field(
        default=None,
        metadata={
            "name": "IUMPR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FunctionIdentifierRef(Ref):
        dest: DiagnosticFunctionIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IumprRef(Ref):
        dest: DiagnosticIumprSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticJ1939ExpandedFreezeFrame:
    """
    This meta-class represents the ability to model an expanded J1939 Freeze Frame.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar node_ref: This represents the DiagnosticJ1939Node to which the
        J1939 expanded freeze frame is associated.
    :ivar spn_refs: This represents the collection of SPNs that make the
        expanded J1939 Freeze Frame.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-J-1939-EXPANDED-FREEZE-FRAME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticJ1939ExpandedFreezeFrame.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticJ1939ExpandedFreezeFrame.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    node_ref: Optional["DiagnosticJ1939ExpandedFreezeFrame.NodeRef"] = field(
        default=None,
        metadata={
            "name": "NODE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    spn_refs: Optional["DiagnosticJ1939ExpandedFreezeFrame.SpnRefs"] = field(
        default=None,
        metadata={
            "name": "SPN-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NodeRef(Ref):
        dest: DiagnosticJ1939NodeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SpnRefs:
        spn_ref: list["DiagnosticJ1939ExpandedFreezeFrame.SpnRefs.SpnRef"] = field(
            default_factory=list,
            metadata={
                "name": "SPN-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SpnRef(Ref):
            dest: DiagnosticJ1939SpnSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DiagnosticJ1939FreezeFrame:
    """
    This meta-class represents the ability to model a J1939 Freeze Frame.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar node_ref: This represents the DiagnosticJ1939Node to which the
        J1939 freeze frame is associated.
    :ivar spn_refs: This represents the collection of SPNs that make the
        J1939 Freeze Frame.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-J-1939-FREEZE-FRAME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticJ1939FreezeFrame.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticJ1939FreezeFrame.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    node_ref: Optional["DiagnosticJ1939FreezeFrame.NodeRef"] = field(
        default=None,
        metadata={
            "name": "NODE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    spn_refs: Optional["DiagnosticJ1939FreezeFrame.SpnRefs"] = field(
        default=None,
        metadata={
            "name": "SPN-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NodeRef(Ref):
        dest: DiagnosticJ1939NodeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SpnRefs:
        spn_ref: list["DiagnosticJ1939FreezeFrame.SpnRefs.SpnRef"] = field(
            default_factory=list,
            metadata={
                "name": "SPN-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SpnRef(Ref):
            dest: DiagnosticJ1939SpnSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DiagnosticJ1939Node:
    """
    This meta-class represents the diagnostic configuration of a J1939 Nm node,
    which in turn represents a "virtual Ecu" on the J1939 communication bus.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar nm_node_ref: This represents the reference to the "virtual
        Ecu" to which the enclosing DiagnosticJ1939Node is associated.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-J-1939-NODE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticJ1939Node.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticJ1939Node.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_ref: Optional["DiagnosticJ1939Node.NmNodeRef"] = field(
        default=None,
        metadata={
            "name": "NM-NODE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NmNodeRef(Ref):
        dest: J1939NmNodeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticJ1939Spn:
    """
    This meta-class represents the ability to model a J1939 Suspect Parameter
    Number (SPN).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar spn: This attribute represents the concrete numerical
        identification for the enclosing SPN.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-J-1939-SPN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticJ1939Spn.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticJ1939Spn.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    spn: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SPN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticJ1939SpnMapping:
    """This meta-class represents the ability to define a mapping between an SPN
    and a SystemSignal.

    The existence of a mapping means that neither the SPN nor the
    SystemSignal need to be updated if the relation between the two
    changes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar sending_node_refs: This additional reference has a supporting
        role in that it identifies all sending nodes of a given SPN. It
        is positively possible that a given SPN is sent by more than one
        node. Even tough the reference targets the DiagnosticJ1939Node
        the semantics of the reference is bound to the J1939NmNode that
        is in turn referenced by the DiagnosticJ1939Node.
    :ivar spn_ref: This reference goes to the SPN that shall be
        associated with a SystemSignal.
    :ivar system_signal_ref: This reference goes to the SystemSignal
        that shall be associated with an SPN.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-J-1939-SPN-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticJ1939SpnMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticJ1939SpnMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticJ1939SpnMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticJ1939SpnMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sending_node_refs: Optional["DiagnosticJ1939SpnMapping.SendingNodeRefs"] = field(
        default=None,
        metadata={
            "name": "SENDING-NODE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    spn_ref: Optional["DiagnosticJ1939SpnMapping.SpnRef"] = field(
        default=None,
        metadata={
            "name": "SPN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_signal_ref: Optional["DiagnosticJ1939SpnMapping.SystemSignalRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SendingNodeRefs:
        sending_node_ref: list["DiagnosticJ1939SpnMapping.SendingNodeRefs.SendingNodeRef"] = field(
            default_factory=list,
            metadata={
                "name": "SENDING-NODE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SendingNodeRef(Ref):
            dest: DiagnosticJ1939NodeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SpnRef(Ref):
        dest: DiagnosticJ1939SpnSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticJ1939SwMapping:
    """This meta-class represents the ability to map a piece of application
    software to a J1939DiagnosticNode.

    By this means the diagnostic configuration can be associated with
    the application software.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar node_ref: This represents the mapped DiagnosticJ1939Node.
    :ivar sw_component_prototype_iref: This represents the mapped
        SwComponentPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-J-1939-SW-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticJ1939SwMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticJ1939SwMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticJ1939SwMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticJ1939SwMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    node_ref: Optional["DiagnosticJ1939SwMapping.NodeRef"] = field(
        default=None,
        metadata={
            "name": "NODE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_prototype_iref: ComponentInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SW-COMPONENT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NodeRef(Ref):
        dest: DiagnosticJ1939NodeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticMasterToSlaveEventMapping:
    """
    This meta-class provides the ability to map a master diagnostic event with a
    slave diagnostic event such that reporting of the master event with a given
    value also reports the slave event with the same value.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar master_event_ref: This represents the master diagnostic event.
    :ivar slave_event_ref: This represents the slave diagnostic event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-MASTER-TO-SLAVE-EVENT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticMasterToSlaveEventMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticMasterToSlaveEventMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticMasterToSlaveEventMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticMasterToSlaveEventMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    master_event_ref: Optional["DiagnosticMasterToSlaveEventMapping.MasterEventRef"] = field(
        default=None,
        metadata={
            "name": "MASTER-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    slave_event_ref: Optional["DiagnosticMasterToSlaveEventMapping.SlaveEventRef"] = field(
        default=None,
        metadata={
            "name": "SLAVE-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MasterEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SlaveEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticMeasurementIdentifier:
    """
    This meta-class represents the ability to describe a measurement identifier.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar obd_mid: This represents the numerical measurement Id
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-MEASUREMENT-IDENTIFIER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticMeasurementIdentifier.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticMeasurementIdentifier.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    obd_mid: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "OBD-MID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticMemoryDestinationMirror:
    """
    This represents a mirror memory for a diagnostic event.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar aging_requires_tested_cycle: Defines whether the aging cycle
        counter is processed every aging cycles or else only tested
        aging cycle are considered. If the attribute is set to TRUE:
        only tested aging cycle are considered for aging cycle counter.
        If the attribute is set to FALSE: aging cycle counter is
        processed every aging cycle.
    :ivar clear_dtc_limitation: Defines the scope of the DEM_ClearDTC
        Api.
    :ivar dtc_status_availability_mask: Mask for the supported DTC
        status bits by the Dem.
    :ivar event_displacement_strategy: This attribute defines, whether
        support for event displacement is enabled or not, and which
        displacement strategy is followed.
    :ivar max_number_of_event_entries: This attribute fixes the maximum
        number of event entries in the fault memory.
    :ivar memory_entry_storage_trigger: Describes the trigger to
        allocate an event memory entry.
    :ivar status_bit_handling_test_failed_since_last_clear: This
        attribute defines, whether the aging and displacement mechanism
        shall be applied to the "TestFailedSinceLastClear" status bits.
    :ivar status_bit_storage_test_failed: This parameter is used to
        activate/deactivate the permanent storage of the "TestFailed"
        status bits. true: storage activated false: storage deactivated
    :ivar type_of_freeze_frame_record_numeration: This attribute defines
        the type of assigning freeze frame record numbers for event-
        specific freeze frame records.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-MEMORY-DESTINATION-MIRROR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticMemoryDestinationMirror.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticMemoryDestinationMirror.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    aging_requires_tested_cycle: Boolean | None = field(
        default=None,
        metadata={
            "name": "AGING-REQUIRES-TESTED-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clear_dtc_limitation: DiagnosticClearDtcLimitationEnum | None = field(
        default=None,
        metadata={
            "name": "CLEAR-DTC-LIMITATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_status_availability_mask: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DTC-STATUS-AVAILABILITY-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_displacement_strategy: DiagnosticEventDisplacementStrategyEnum | None = field(
        default=None,
        metadata={
            "name": "EVENT-DISPLACEMENT-STRATEGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_event_entries: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-EVENT-ENTRIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_entry_storage_trigger: DiagnosticMemoryEntryStorageTriggerEnum | None = field(
        default=None,
        metadata={
            "name": "MEMORY-ENTRY-STORAGE-TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    status_bit_handling_test_failed_since_last_clear: (
        DiagnosticStatusBitHandlingTestFailedSinceLastClearEnum | None
    ) = field(
        default=None,
        metadata={
            "name": "STATUS-BIT-HANDLING-TEST-FAILED-SINCE-LAST-CLEAR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    status_bit_storage_test_failed: Boolean | None = field(
        default=None,
        metadata={
            "name": "STATUS-BIT-STORAGE-TEST-FAILED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_of_freeze_frame_record_numeration: (
        DiagnosticTypeOfFreezeFrameRecordNumerationEnum | None
    ) = field(
        default=None,
        metadata={
            "name": "TYPE-OF-FREEZE-FRAME-RECORD-NUMERATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticMemoryDestinationPortMapping:
    """
    Defines to which SWC service ports with DiagnosticsEventInfoNeeds the
    DiagnosticMemoryDestination is mapped.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar memory_destination_ref: Reference to the MemoryDestination
        which is mapped to a SWC service port with
        DiagnosticEventInfoNeeds.
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar r_port_prototype_in_executable_iref: This aggregation allows
        for the usage of the DiagnosticMemoryDestinationMapping on the
        AUTOSAR adaptive platform.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-MEMORY-DESTINATION-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticMemoryDestinationPortMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticMemoryDestinationPortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticMemoryDestinationPortMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticMemoryDestinationPortMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_destination_ref: Optional[
        "DiagnosticMemoryDestinationPortMapping.MemoryDestinationRef"
    ] = field(
        default=None,
        metadata={
            "name": "MEMORY-DESTINATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticMemoryDestinationPortMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    r_port_prototype_in_executable_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "R-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MemoryDestinationRef(Ref):
        dest: DiagnosticMemoryDestinationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticMemoryDestinationPrimary:
    """
    This represents a primary memory for a diagnostic event.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar aging_requires_tested_cycle: Defines whether the aging cycle
        counter is processed every aging cycles or else only tested
        aging cycle are considered. If the attribute is set to TRUE:
        only tested aging cycle are considered for aging cycle counter.
        If the attribute is set to FALSE: aging cycle counter is
        processed every aging cycle.
    :ivar clear_dtc_limitation: Defines the scope of the DEM_ClearDTC
        Api.
    :ivar dtc_status_availability_mask: Mask for the supported DTC
        status bits by the Dem.
    :ivar event_displacement_strategy: This attribute defines, whether
        support for event displacement is enabled or not, and which
        displacement strategy is followed.
    :ivar max_number_of_event_entries: This attribute fixes the maximum
        number of event entries in the fault memory.
    :ivar memory_entry_storage_trigger: Describes the trigger to
        allocate an event memory entry.
    :ivar status_bit_handling_test_failed_since_last_clear: This
        attribute defines, whether the aging and displacement mechanism
        shall be applied to the "TestFailedSinceLastClear" status bits.
    :ivar status_bit_storage_test_failed: This parameter is used to
        activate/deactivate the permanent storage of the "TestFailed"
        status bits. true: storage activated false: storage deactivated
    :ivar type_of_freeze_frame_record_numeration: This attribute defines
        the type of assigning freeze frame record numbers for event-
        specific freeze frame records.
    :ivar type_of_dtc_supported: This attribute defines the format
        returned by Dem_DcmGetTranslationType and does not relate
        to/influence the supported Dem functionality.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-MEMORY-DESTINATION-PRIMARY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticMemoryDestinationPrimary.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticMemoryDestinationPrimary.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    aging_requires_tested_cycle: Boolean | None = field(
        default=None,
        metadata={
            "name": "AGING-REQUIRES-TESTED-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clear_dtc_limitation: DiagnosticClearDtcLimitationEnum | None = field(
        default=None,
        metadata={
            "name": "CLEAR-DTC-LIMITATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_status_availability_mask: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DTC-STATUS-AVAILABILITY-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_displacement_strategy: DiagnosticEventDisplacementStrategyEnum | None = field(
        default=None,
        metadata={
            "name": "EVENT-DISPLACEMENT-STRATEGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_event_entries: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-EVENT-ENTRIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_entry_storage_trigger: DiagnosticMemoryEntryStorageTriggerEnum | None = field(
        default=None,
        metadata={
            "name": "MEMORY-ENTRY-STORAGE-TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    status_bit_handling_test_failed_since_last_clear: (
        DiagnosticStatusBitHandlingTestFailedSinceLastClearEnum | None
    ) = field(
        default=None,
        metadata={
            "name": "STATUS-BIT-HANDLING-TEST-FAILED-SINCE-LAST-CLEAR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    status_bit_storage_test_failed: Boolean | None = field(
        default=None,
        metadata={
            "name": "STATUS-BIT-STORAGE-TEST-FAILED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_of_freeze_frame_record_numeration: (
        DiagnosticTypeOfFreezeFrameRecordNumerationEnum | None
    ) = field(
        default=None,
        metadata={
            "name": "TYPE-OF-FREEZE-FRAME-RECORD-NUMERATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_of_dtc_supported: DiagnosticTypeOfDtcSupportedEnum | None = field(
        default=None,
        metadata={
            "name": "TYPE-OF-DTC-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticMemoryDestinationUserDefined:
    """
    This represents a user-defined memory for a diagnostic event.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar aging_requires_tested_cycle: Defines whether the aging cycle
        counter is processed every aging cycles or else only tested
        aging cycle are considered. If the attribute is set to TRUE:
        only tested aging cycle are considered for aging cycle counter.
        If the attribute is set to FALSE: aging cycle counter is
        processed every aging cycle.
    :ivar clear_dtc_limitation: Defines the scope of the DEM_ClearDTC
        Api.
    :ivar dtc_status_availability_mask: Mask for the supported DTC
        status bits by the Dem.
    :ivar event_displacement_strategy: This attribute defines, whether
        support for event displacement is enabled or not, and which
        displacement strategy is followed.
    :ivar max_number_of_event_entries: This attribute fixes the maximum
        number of event entries in the fault memory.
    :ivar memory_entry_storage_trigger: Describes the trigger to
        allocate an event memory entry.
    :ivar status_bit_handling_test_failed_since_last_clear: This
        attribute defines, whether the aging and displacement mechanism
        shall be applied to the "TestFailedSinceLastClear" status bits.
    :ivar status_bit_storage_test_failed: This parameter is used to
        activate/deactivate the permanent storage of the "TestFailed"
        status bits. true: storage activated false: storage deactivated
    :ivar type_of_freeze_frame_record_numeration: This attribute defines
        the type of assigning freeze frame record numbers for event-
        specific freeze frame records.
    :ivar authentication_role_ref: This reference identifies the
        authenticationRole applicable for the enclosing
        DiagnosticMemoryDestinationUserDefined.
    :ivar memory_id: This represents the identifier of the user-defined
        memory.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-MEMORY-DESTINATION-USER-DEFINED"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticMemoryDestinationUserDefined.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticMemoryDestinationUserDefined.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    aging_requires_tested_cycle: Boolean | None = field(
        default=None,
        metadata={
            "name": "AGING-REQUIRES-TESTED-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clear_dtc_limitation: DiagnosticClearDtcLimitationEnum | None = field(
        default=None,
        metadata={
            "name": "CLEAR-DTC-LIMITATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_status_availability_mask: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DTC-STATUS-AVAILABILITY-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_displacement_strategy: DiagnosticEventDisplacementStrategyEnum | None = field(
        default=None,
        metadata={
            "name": "EVENT-DISPLACEMENT-STRATEGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_event_entries: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-EVENT-ENTRIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_entry_storage_trigger: DiagnosticMemoryEntryStorageTriggerEnum | None = field(
        default=None,
        metadata={
            "name": "MEMORY-ENTRY-STORAGE-TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    status_bit_handling_test_failed_since_last_clear: (
        DiagnosticStatusBitHandlingTestFailedSinceLastClearEnum | None
    ) = field(
        default=None,
        metadata={
            "name": "STATUS-BIT-HANDLING-TEST-FAILED-SINCE-LAST-CLEAR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    status_bit_storage_test_failed: Boolean | None = field(
        default=None,
        metadata={
            "name": "STATUS-BIT-STORAGE-TEST-FAILED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_of_freeze_frame_record_numeration: (
        DiagnosticTypeOfFreezeFrameRecordNumerationEnum | None
    ) = field(
        default=None,
        metadata={
            "name": "TYPE-OF-FREEZE-FRAME-RECORD-NUMERATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_role_ref: Optional[
        "DiagnosticMemoryDestinationUserDefined.AuthenticationRoleRef"
    ] = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-ROLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MEMORY-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AuthenticationRoleRef(Ref):
        dest: DiagnosticAuthRoleSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticMemoryIdentifier:
    """
    This meta-class represents the ability to define memory properties from the
    diagnostics point of view.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents that access permission
        defined for the specific DiagnosticMemoryIdentifier.
    :ivar id: This represents the identification of the memory segment.
    :ivar memory_high_address: This represents the upper bound for
        addresses of the memory segment.
    :ivar memory_high_address_label: This represents a symbolic label
        for the upper bound for addresses of the memory segment.
    :ivar memory_low_address: This represents the lower bound for
        addresses of the memory segment.
    :ivar memory_low_address_label: This represents a symbolic label for
        the lower bound for addresses of the memory segment.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-MEMORY-IDENTIFIER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticMemoryIdentifier.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticMemoryIdentifier.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticMemoryIdentifier.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_high_address: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MEMORY-HIGH-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_high_address_label: String | None = field(
        default=None,
        metadata={
            "name": "MEMORY-HIGH-ADDRESS-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_low_address: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MEMORY-LOW-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_low_address_label: String | None = field(
        default=None,
        metadata={
            "name": "MEMORY-LOW-ADDRESS-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticMonitorInterface:
    """
    This meta-class represents the ability to implement a monitor-focused
    PortInterface for diagnostics on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-MONITOR-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticMonitorInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticMonitorInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticMonitorInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticMonitorInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticMonitorPortMapping:
    """
    Defines to which SWC service port the Diagnostic Monitor is mapped.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar diagnostic_event_ref: Reference to the DiagnosticEvent that is
        assigned to SWC service ports.
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar r_port_prototype_in_executable_iref: This aggregation allows
        for the usage of the DiagnosticMonitorPortMapping on the AUTOSAR
        adaptive platform.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-MONITOR-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticMonitorPortMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticMonitorPortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticMonitorPortMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticMonitorPortMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_event_ref: Optional["DiagnosticMonitorPortMapping.DiagnosticEventRef"] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticMonitorPortMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    r_port_prototype_in_executable_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "R-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticEventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticOperationCycle:
    """
    Definition of an operation cycle that is the base of the event qualifying and
    for Dem scheduling.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar automatic_end: If set to true the driving cycle shall
        automatically end at either Dem_Shutdown() or Dem_Init(). This
        attribute is only relevant for the AUTOSAR adaptive platform. It
        no longer has a meaning on the AUTOSAR classic platform.
    :ivar cycle_autostart: This attribute defines if the operation
        cycles is automatically re-started during Dem_PreInit.
    :ivar cycle_status_storage: Defines if the operation cycle state is
        available over the power cycle (stored non-volatile) or not. *
        true: the operation cycle state is stored non-volatile * false:
        the operation cycle state is only stored volatile This attribute
        is only relevant for the AUTOSAR adaptive platform. It no longer
        has a meaning on the AUTOSAR classic platform.
    :ivar type_value: Operation cycles types for the Dem.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-OPERATION-CYCLE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticOperationCycle.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticOperationCycle.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    automatic_end: Boolean | None = field(
        default=None,
        metadata={
            "name": "AUTOMATIC-END",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cycle_autostart: Boolean | None = field(
        default=None,
        metadata={
            "name": "CYCLE-AUTOSTART",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cycle_status_storage: Boolean | None = field(
        default=None,
        metadata={
            "name": "CYCLE-STATUS-STORAGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_value: DiagnosticOperationCycleTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticOperationCycleInterface:
    """
    This meta-class represents the ability to implement a PortInterface to process
    requests for operation cycles on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-OPERATION-CYCLE-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticOperationCycleInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticOperationCycleInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticOperationCycleInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticOperationCycleInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticOperationCycleNeeds:
    """
    This meta-class represents the needs of a software-component to provide
    information regarding the operation cycle management to the Dem module.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar operation_cycle: Operation cycles types for the Dem to be
        supported by cycle-state APIs.
    :ivar operation_cycle_automatic_end: If this attribute is set to
        true the Dem shall automatically end the driving cycle at either
        Dem_Shutdown() or Dem_Init().
    :ivar operation_cycle_autostart: If this attribute is set to true
        the operation cycles is automatically (re-)started during
        Dem_PreInit().
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-OPERATION-CYCLE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticOperationCycleNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticOperationCycleNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticOperationCycleNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_cycle: OperationCycleTypeEnum | None = field(
        default=None,
        metadata={
            "name": "OPERATION-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_cycle_automatic_end: Boolean | None = field(
        default=None,
        metadata={
            "name": "OPERATION-CYCLE-AUTOMATIC-END",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_cycle_autostart: Boolean | None = field(
        default=None,
        metadata={
            "name": "OPERATION-CYCLE-AUTOSTART",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticOperationCyclePortMapping:
    """
    Defines to which SWC service ports with DiagnosticOperationCycleNeeds the
    DiagnosticOperationCycle is mapped.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar operation_cycle_ref: Reference to the DiagnosticOperationCycle
        that is assigned to SWC service ports with
        DiagnosticOperationCycleNeeds.
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar r_port_prototype_in_executable_iref: This aggregation allows
        for the usage of the DiagnosticOperationCyclePortMapping on the
        AUTOSAR adaptive platform.
    :ivar swc_flat_service_dependency_ref: Reference to a
        SwcServiceDependencyType that links ServiceNeeds to SWC service
        ports.
    :ivar swc_service_dependency_in_system_iref: Instance reference to a
        SwcServiceDependency that links ServiceNeeds to SWC service
        ports.
    :ivar swc_service_dependency_iref: Instance reference to a
        SwcServiceDependency that links ServiceNeeds to SWC service
        ports.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-OPERATION-CYCLE-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticOperationCyclePortMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticOperationCyclePortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticOperationCyclePortMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticOperationCyclePortMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_cycle_ref: Optional["DiagnosticOperationCyclePortMapping.OperationCycleRef"] = field(
        default=None,
        metadata={
            "name": "OPERATION-CYCLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticOperationCyclePortMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    r_port_prototype_in_executable_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "R-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_flat_service_dependency_ref: Optional[
        "DiagnosticOperationCyclePortMapping.SwcFlatServiceDependencyRef"
    ] = field(
        default=None,
        metadata={
            "name": "SWC-FLAT-SERVICE-DEPENDENCY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_service_dependency_in_system_iref: SwcServiceDependencyInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SWC-SERVICE-DEPENDENCY-IN-SYSTEM-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_service_dependency_iref: SwcServiceDependencyInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SWC-SERVICE-DEPENDENCY-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class OperationCycleRef(Ref):
        dest: DiagnosticOperationCycleSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SwcFlatServiceDependencyRef(Ref):
        dest: SwcServiceDependencySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticOperationCycleRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar diagnostic_operation_cycle_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-OPERATION-CYCLE-REF-CONDITIONAL"

    diagnostic_operation_cycle_ref: Optional[
        "DiagnosticOperationCycleRefConditional.DiagnosticOperationCycleRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-OPERATION-CYCLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticOperationCycleRef(Ref):
        dest: DiagnosticOperationCycleSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticPowertrainFreezeFrame:
    """This meta-class represents a powertrain-related freeze-frame.

    In theory, this meta-class would need an additional id attribute.
    However, legal regulations requires only a single value for this
    attribute anyway.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar pid_refs: This represents the PID associated with this
        instance of the OBD mode 0x02 service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-POWERTRAIN-FREEZE-FRAME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticPowertrainFreezeFrame.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticPowertrainFreezeFrame.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pid_refs: Optional["DiagnosticPowertrainFreezeFrame.PidRefs"] = field(
        default=None,
        metadata={
            "name": "PID-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PidRefs:
        pid_ref: list["DiagnosticPowertrainFreezeFrame.PidRefs.PidRef"] = field(
            default_factory=list,
            metadata={
                "name": "PID-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PidRef(Ref):
            dest: DiagnosticParameterIdentifierSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DiagnosticProofOfOwnership:
    """
    This meta-class represents the subfunction to provide proof of ownership.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar authentication_class_ref: This represents the corresponding
        "class", i.e. this meta-class provides properties that are
        shared among all instances of applicable sub-classes of
        DiagnosticServiceInstance. The subclasses that affected by this
        pattern implement references to the applicable "class"-role that
        substantiate this abstract reference.
    :ivar authentication_timeout: This attribute defines the time that
        the authentication state is maintained in default-session if
        there is no communication from the authenticated client.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-PROOF-OF-OWNERSHIP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticProofOfOwnership.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticProofOfOwnership.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticProofOfOwnership.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_class_ref: Optional["DiagnosticProofOfOwnership.AuthenticationClassRef"] = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AuthenticationClassRef(Ref):
        dest: DiagnosticAuthenticationClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticProvidedDataMapping:
    """
    This represents the ability to define the nature of a data access for a
    DiagnosticDataElement based on a data provider that cannot be modeled
    explicitly.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar data_element_ref: This represents the DiagnosticDataElement
        for which the access is further qualified by the
        DiagnosticProvidedDataMapping.dataProvider.
    :ivar data_provider: This represents the ability to further specify
        the data provider.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-PROVIDED-DATA-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticProvidedDataMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticProvidedDataMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticProvidedDataMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticProvidedDataMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["DiagnosticProvidedDataMapping.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_provider: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "DATA-PROVIDER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: DiagnosticDataElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticReadDataByIdentifier:
    """
    This represents an instance of the "Read Data by Identifier" diagnostic
    service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar data_identifier_ref: This represents the linked
        DiagnosticDataIdentifier.
    :ivar read_class_ref: This reference substantiates that abstract
        reference in the role serviceClass for this specific concrete
        class. Thereby,  the reference represents the ability to access
        shared attributes among all DiagnosticReadDataByIdentifier in
        the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticReadDataByIdentifier.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticReadDataByIdentifier.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticReadDataByIdentifier.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_identifier_ref: Optional["DiagnosticReadDataByIdentifier.DataIdentifierRef"] = field(
        default=None,
        metadata={
            "name": "DATA-IDENTIFIER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    read_class_ref: Optional["DiagnosticReadDataByIdentifier.ReadClassRef"] = field(
        default=None,
        metadata={
            "name": "READ-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataIdentifierRef(Ref):
        dest: DiagnosticAbstractDataIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ReadClassRef(Ref):
        dest: DiagnosticReadDataByIdentifierClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticReadDataByIdentifierClass:
    """
    This meta-class contains attributes shared by all instances of the "Read Data
    by Identifier" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar max_did_to_read: This attribute represents the maximum number
        of allowed DIDs in a single instance of
        DiagnosticReadDataByIdentifier.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticReadDataByIdentifierClass.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticReadDataByIdentifierClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticReadDataByIdentifierClass.AccessPermissionRef"] = (
        field(
            default=None,
            metadata={
                "name": "ACCESS-PERMISSION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_did_to_read: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-DID-TO-READ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticReadDataByPeriodicId:
    """
    This represents an instance of the "Read Data by periodic Identifier"
    diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar data_identifier_ref: This represents the corresponding
        DiagnosticDataIdentifier.
    :ivar read_data_class_ref: This reference substantiates that
        abstract reference in the role serviceClass for this specific
        concrete class. Thereby, the reference represents the ability to
        access shared attributes among all
        DiagnosticReadDataByPeriodicID in the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticReadDataByPeriodicId.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticReadDataByPeriodicId.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticReadDataByPeriodicId.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_identifier_ref: Optional["DiagnosticReadDataByPeriodicId.DataIdentifierRef"] = field(
        default=None,
        metadata={
            "name": "DATA-IDENTIFIER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    read_data_class_ref: Optional["DiagnosticReadDataByPeriodicId.ReadDataClassRef"] = field(
        default=None,
        metadata={
            "name": "READ-DATA-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataIdentifierRef(Ref):
        dest: DiagnosticAbstractDataIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ReadDataClassRef(Ref):
        dest: DiagnosticReadDataByPeriodicIdClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticReadDataByPeriodicIdClass:
    """
    This meta-class contains attributes shared by all instances of the "Read Data
    by periodic Identifier" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar max_periodic_did_to_read: This represents the maximum number
        of data identifiers that can be included in one request.
    :ivar periodic_rates: This represents the description of a
        collection of periodic rates in which the service can be
        executed.
    :ivar scheduler_max_number: This represents the maximum number of
        periodic data identifiers that can be scheduled in parallel.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticReadDataByPeriodicIdClass.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticReadDataByPeriodicIdClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticReadDataByPeriodicIdClass.AccessPermissionRef"] = (
        field(
            default=None,
            metadata={
                "name": "ACCESS-PERMISSION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_periodic_did_to_read: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-PERIODIC-DID-TO-READ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    periodic_rates: Optional["DiagnosticReadDataByPeriodicIdClass.PeriodicRates"] = field(
        default=None,
        metadata={
            "name": "PERIODIC-RATES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scheduler_max_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SCHEDULER-MAX-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PeriodicRates:
        diagnostic_periodic_rate: list[DiagnosticPeriodicRate] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PERIODIC-RATE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticReadDtcInformation:
    """
    This represents an instance of the "Read DTC Information" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar read_dtc_information_class_ref: This reference substantiates
        that abstract reference in the role serviceClass for this
        specific concrete class. Thereby, the reference represents the
        ability to access shared attributes among all
        DiagnosticReadDTCInformation in the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-READ-DTC-INFORMATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticReadDtcInformation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticReadDtcInformation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticReadDtcInformation.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    read_dtc_information_class_ref: Optional[
        "DiagnosticReadDtcInformation.ReadDtcInformationClassRef"
    ] = field(
        default=None,
        metadata={
            "name": "READ-DTC-INFORMATION-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ReadDtcInformationClassRef(Ref):
        dest: DiagnosticReadDtcInformationClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticReadDtcInformationClass:
    """
    This meta-class contains attributes shared by all instances of the
    "ReadDTCInformation" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-READ-DTC-INFORMATION-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticReadDtcInformationClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticReadDtcInformationClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticReadDtcInformationClass.AccessPermissionRef"] = (
        field(
            default=None,
            metadata={
                "name": "ACCESS-PERMISSION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticReadMemoryByAddress:
    """
    This represents an instance of the "Read Memory by Address" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar memory_range_refs: This represents the formal description of
        the memory segment to which the DiagnosticMemoryByAddress
        applies.
    :ivar read_class_ref: This reference substantiates that abstract
        reference in the role serviceClass for this specific concrete
        class. Thereby, the reference represents the ability to access
        shared attributes among all DiagnosticReadMemoryByAddresst in
        the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticReadMemoryByAddress.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticReadMemoryByAddress.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticReadMemoryByAddress.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_range_refs: Optional["DiagnosticReadMemoryByAddress.MemoryRangeRefs"] = field(
        default=None,
        metadata={
            "name": "MEMORY-RANGE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    read_class_ref: Optional["DiagnosticReadMemoryByAddress.ReadClassRef"] = field(
        default=None,
        metadata={
            "name": "READ-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MemoryRangeRefs:
        memory_range_ref: list["DiagnosticReadMemoryByAddress.MemoryRangeRefs.MemoryRangeRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "MEMORY-RANGE-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class MemoryRangeRef(Ref):
            dest: DiagnosticMemoryIdentifierSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ReadClassRef(Ref):
        dest: DiagnosticReadMemoryByAddressClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticReadMemoryByAddressClass:
    """
    This meta-class contains attributes shared by all instances of the "Read Memory
    by Address" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticReadMemoryByAddressClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticReadMemoryByAddressClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticReadMemoryByAddressClass.AccessPermissionRef"] = (
        field(
            default=None,
            metadata={
                "name": "ACCESS-PERMISSION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticReadScalingDataByIdentifier:
    """
    This represents an instance of the "Read Scaling Data by Identifier" diagnostic
    service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar data_identifier_ref: This represents the linked
        DiagnosticDataIdentifier.
    :ivar read_scaling_data_class_ref: This reference substantiates that
        abstract reference in the role serviceClass for this specific
        concrete class. Thereby, the reference represents the ability to
        access shared attributes among all
        DiagnosticReadScalingDataByIdentifier in the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticReadScalingDataByIdentifier.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticReadScalingDataByIdentifier.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticReadScalingDataByIdentifier.AccessPermissionRef"] = (
        field(
            default=None,
            metadata={
                "name": "ACCESS-PERMISSION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    data_identifier_ref: Optional["DiagnosticReadScalingDataByIdentifier.DataIdentifierRef"] = (
        field(
            default=None,
            metadata={
                "name": "DATA-IDENTIFIER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    read_scaling_data_class_ref: Optional[
        "DiagnosticReadScalingDataByIdentifier.ReadScalingDataClassRef"
    ] = field(
        default=None,
        metadata={
            "name": "READ-SCALING-DATA-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataIdentifierRef(Ref):
        dest: DiagnosticAbstractDataIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ReadScalingDataClassRef(Ref):
        dest: DiagnosticReadScalingDataByIdentifierClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticReadScalingDataByIdentifierClass:
    """
    This meta-class contains attributes shared by all instances of the "Read
    Scaling Data by Identifier" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticReadScalingDataByIdentifierClass.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticReadScalingDataByIdentifierClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticReadScalingDataByIdentifierClass.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestControlOfOnBoardDevice:
    """
    This meta-class represents the ability to model an instance of the OBD mode
    0x08 service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar request_control_of_on_board_device_class_ref: This reference
        substantiates that abstract reference in the role serviceClass
        for this specific concrete class. Thereby, the reference
        represents the ability to access shared attributes among all
        DiagnosticRequestControlOfOnBoardDevice in the given context.
    :ivar test_id_ref: This represents the test Id for the mode 0x08.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRequestControlOfOnBoardDevice.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestControlOfOnBoardDevice.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticRequestControlOfOnBoardDevice.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_control_of_on_board_device_class_ref: Optional[
        "DiagnosticRequestControlOfOnBoardDevice.RequestControlOfOnBoardDeviceClassRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUEST-CONTROL-OF-ON-BOARD-DEVICE-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    test_id_ref: Optional["DiagnosticRequestControlOfOnBoardDevice.TestIdRef"] = field(
        default=None,
        metadata={
            "name": "TEST-ID-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequestControlOfOnBoardDeviceClassRef(Ref):
        dest: DiagnosticRequestControlOfOnBoardDeviceClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TestIdRef(Ref):
        dest: DiagnosticTestRoutineIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestControlOfOnBoardDeviceClass:
    """
    This meta-class represents the ability to define common properties for all
    instances of the "Request Control Of On-Board Device" OBD diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticRequestControlOfOnBoardDeviceClass.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestControlOfOnBoardDeviceClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticRequestControlOfOnBoardDeviceClass.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestCurrentPowertrainData:
    """
    This meta-class represents the ability to model an instance of the OBD mode
    0x01 service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar pid_ref: This represents the PID associated with this instance
        of the OBD mode 0x01 service.
    :ivar request_current_powertrain_diagnostic_data_class_ref: This
        reference substantiates that abstract reference in the role
        serviceClass for this specific concrete class. Thereby, the
        reference represents the ability to access shared attributes
        among all DiagnosticRequestCurrentPowertrainData in the given
        context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRequestCurrentPowertrainData.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestCurrentPowertrainData.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticRequestCurrentPowertrainData.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pid_ref: Optional["DiagnosticRequestCurrentPowertrainData.PidRef"] = field(
        default=None,
        metadata={
            "name": "PID-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_current_powertrain_diagnostic_data_class_ref: Optional[
        "DiagnosticRequestCurrentPowertrainData.RequestCurrentPowertrainDiagnosticDataClassRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUEST-CURRENT-POWERTRAIN-DIAGNOSTIC-DATA-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PidRef(Ref):
        dest: DiagnosticParameterIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequestCurrentPowertrainDiagnosticDataClassRef(Ref):
        dest: DiagnosticRequestCurrentPowertrainDataClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestCurrentPowertrainDataClass:
    """
    This meta-class represents the ability to define common properties for all
    instances of the "Request current Powertrain Data" OBD diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticRequestCurrentPowertrainDataClass.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestCurrentPowertrainDataClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticRequestCurrentPowertrainDataClass.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestDownload:
    """
    This represents an instance of the "Request Download" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar memory_range_refs: This represents the formal description of
        the memory segment to which the DiagnosticMemoryByAddress
        applies.
    :ivar request_download_class_ref: This reference substantiates that
        abstract reference in the role serviceClass for this specific
        concrete class. Thereby, the reference represents the ability to
        access shared attributes among all DiagnosticRequestDownload in
        the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-DOWNLOAD"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRequestDownload.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestDownload.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticRequestDownload.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_range_refs: Optional["DiagnosticRequestDownload.MemoryRangeRefs"] = field(
        default=None,
        metadata={
            "name": "MEMORY-RANGE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_download_class_ref: Optional["DiagnosticRequestDownload.RequestDownloadClassRef"] = (
        field(
            default=None,
            metadata={
                "name": "REQUEST-DOWNLOAD-CLASS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MemoryRangeRefs:
        memory_range_ref: list["DiagnosticRequestDownload.MemoryRangeRefs.MemoryRangeRef"] = field(
            default_factory=list,
            metadata={
                "name": "MEMORY-RANGE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class MemoryRangeRef(Ref):
            dest: DiagnosticMemoryIdentifierSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RequestDownloadClassRef(Ref):
        dest: DiagnosticRequestDownloadClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestDownloadClass:
    """
    This meta-class contains attributes shared by all instances of the "Request
    Download" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-DOWNLOAD-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRequestDownloadClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestDownloadClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticRequestDownloadClass.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestEmissionRelatedDtc:
    """
    This meta-class represents the ability to model an instance of the OBD mode
    0x03/0x07 service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar request_emission_related_dtc_class_ref: This reference
        substantiates that abstract reference in the role serviceClass
        for this specific concrete class. Thereby, the reference
        represents the ability to access shared attributes among all
        DiagnosticRequestEmissionRelatedDTC in the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRequestEmissionRelatedDtc.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestEmissionRelatedDtc.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticRequestEmissionRelatedDtc.AccessPermissionRef"] = (
        field(
            default=None,
            metadata={
                "name": "ACCESS-PERMISSION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    request_emission_related_dtc_class_ref: Optional[
        "DiagnosticRequestEmissionRelatedDtc.RequestEmissionRelatedDtcClassRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUEST-EMISSION-RELATED-DTC-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequestEmissionRelatedDtcClassRef(Ref):
        dest: DiagnosticRequestEmissionRelatedDtcClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestEmissionRelatedDtcClass:
    """
    This meta-class represents the ability to define common properties for all
    instances of the "Request Emission Related DTC" OBD diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticRequestEmissionRelatedDtcClass.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestEmissionRelatedDtcClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticRequestEmissionRelatedDtcClass.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestEmissionRelatedDtcPermanentStatus:
    """
    This meta-class represents the ability to model an instance of the OBD mode
    0x0A service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar request_emission_related_dtc_class_permanent_status_ref: This
        reference substantiates that abstract reference in the role
        serviceClass for this specific concrete class. Thereby, the
        reference represents the ability to access shared attributes
        among all DiagnosticRequestEmissionRelatedDTCPermanentStatus in
        the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticRequestEmissionRelatedDtcPermanentStatus.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestEmissionRelatedDtcPermanentStatus.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticRequestEmissionRelatedDtcPermanentStatus.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_emission_related_dtc_class_permanent_status_ref: Optional[
        "DiagnosticRequestEmissionRelatedDtcPermanentStatus.RequestEmissionRelatedDtcClassPermanentStatusRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUEST-EMISSION-RELATED-DTC-CLASS-PERMANENT-STATUS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequestEmissionRelatedDtcClassPermanentStatusRef(Ref):
        dest: DiagnosticRequestEmissionRelatedDtcPermanentStatusClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestEmissionRelatedDtcPermanentStatusClass:
    """
    This meta-class represents the ability to define common properties for all
    instances of the "Request Emission Related DTC Permanent Status" OBD diagnostic
    service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticRequestEmissionRelatedDtcPermanentStatusClass.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestEmissionRelatedDtcPermanentStatusClass.Annotations"] = (
        field(
            default=None,
            metadata={
                "name": "ANNOTATIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticRequestEmissionRelatedDtcPermanentStatusClass.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestFileTransfer:
    """
    This diagnostic service instance implements the UDS service 0x38.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar request_file_transfer_class_ref: This reference substantiates
        that abstract reference in the role serviceClass for this
        specific concrete class. Thereby, the reference represents the
        ability to access shared attributes among all
        DiagnosticRequestFileTransfer in the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-FILE-TRANSFER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRequestFileTransfer.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestFileTransfer.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticRequestFileTransfer.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_file_transfer_class_ref: Optional[
        "DiagnosticRequestFileTransfer.RequestFileTransferClassRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUEST-FILE-TRANSFER-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequestFileTransferClassRef(Ref):
        dest: DiagnosticRequestFileTransferClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestFileTransferClass:
    """
    This meta-class contains attributes shared by all instances of the "Request
    File transfer" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRequestFileTransferClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestFileTransferClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticRequestFileTransferClass.AccessPermissionRef"] = (
        field(
            default=None,
            metadata={
                "name": "ACCESS-PERMISSION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestFileTransferInterface:
    """
    This meta-class represents the ability to implement a PortInterface to process
    requests for file transfer using diagnostic channels on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRequestFileTransferInterface.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestFileTransferInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticRequestFileTransferInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticRequestFileTransferInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestFileTransferNeeds:
    """
    This meta-class indicates the existence of a service use case that involves UDS
    service 0x38, Request File Transfer.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-FILE-TRANSFER-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRequestFileTransferNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestFileTransferNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticRequestFileTransferNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestOnBoardMonitoringTestResults:
    """
    This meta-class represents the ability to model an instance of the OBD mode
    0x06 service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar diagnostic_test_result_refs: This reference identifies the
        applicable collection of test identifiers for setting up a
        request message for mode 0x06.
    :ivar request_on_board_monitoring_test_results_class_ref: This
        reference substantiates that abstract reference in the role
        serviceClass for this specific concrete class. Thereby, the
        reference represents the ability to access shared attributes
        among all DiagnosticRequestOnBoardMonitoringTestResults in the
        given context.
    :ivar test_result_ref: This reference identifies the applicable test
        identifier for setting up a request message for mode 0x06.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticRequestOnBoardMonitoringTestResults.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestOnBoardMonitoringTestResults.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticRequestOnBoardMonitoringTestResults.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_test_result_refs: Optional[
        "DiagnosticRequestOnBoardMonitoringTestResults.DiagnosticTestResultRefs"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-TEST-RESULT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_on_board_monitoring_test_results_class_ref: Optional[
        "DiagnosticRequestOnBoardMonitoringTestResults.RequestOnBoardMonitoringTestResultsClassRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUEST-ON-BOARD-MONITORING-TEST-RESULTS-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    test_result_ref: Optional["DiagnosticRequestOnBoardMonitoringTestResults.TestResultRef"] = (
        field(
            default=None,
            metadata={
                "name": "TEST-RESULT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticTestResultRefs:
        diagnostic_test_result_ref: list[
            "DiagnosticRequestOnBoardMonitoringTestResults.DiagnosticTestResultRefs.DiagnosticTestResultRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-TEST-RESULT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DiagnosticTestResultRef(Ref):
            dest: DiagnosticTestResultSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RequestOnBoardMonitoringTestResultsClassRef(Ref):
        dest: DiagnosticRequestOnBoardMonitoringTestResultsClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TestResultRef(Ref):
        dest: DiagnosticTestResultSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestOnBoardMonitoringTestResultsClass:
    """
    This meta-class represents the ability to define common properties for all
    instances of the "Request On-Board Monitoring Test Results" OBD diagnostic
    service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticRequestOnBoardMonitoringTestResultsClass.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestOnBoardMonitoringTestResultsClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticRequestOnBoardMonitoringTestResultsClass.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestPowertrainFreezeFrameData:
    """
    This meta-class represents the ability to model an instance of the OBD mode
    0x02 service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar freeze_frame_ref: This represents the associated freeze-frame.
    :ivar request_powertrain_freeze_frame_data_ref: This reference
        substantiates that abstract reference in the role serviceClass
        for this specific concrete class. Thereby, the reference
        represents the ability to access shared attributes among all
        DiagnosticRequestPowertrainFreezeFrameData in the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticRequestPowertrainFreezeFrameData.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestPowertrainFreezeFrameData.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticRequestPowertrainFreezeFrameData.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freeze_frame_ref: Optional["DiagnosticRequestPowertrainFreezeFrameData.FreezeFrameRef"] = field(
        default=None,
        metadata={
            "name": "FREEZE-FRAME-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_powertrain_freeze_frame_data_ref: Optional[
        "DiagnosticRequestPowertrainFreezeFrameData.RequestPowertrainFreezeFrameDataRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUEST-POWERTRAIN-FREEZE-FRAME-DATA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FreezeFrameRef(Ref):
        dest: DiagnosticPowertrainFreezeFrameSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequestPowertrainFreezeFrameDataRef(Ref):
        dest: DiagnosticRequestPowertrainFreezeFrameDataClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestPowertrainFreezeFrameDataClass:
    """
    This meta-class represents the ability to define common properties for all
    instances of the "Request Powertrain Freeze Frame Data" OBD diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticRequestPowertrainFreezeFrameDataClass.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestPowertrainFreezeFrameDataClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticRequestPowertrainFreezeFrameDataClass.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestUpload:
    """
    This represents an instance of the "Request Upload" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar memory_range_refs: This represents the formal description of
        the memory segment to which the DiagnosticMemoryByAddress
        applies.
    :ivar request_upload_class_ref: This reference substantiates that
        abstract reference in the role serviceClass for this specific
        concrete class. Thereby, the reference represents the ability to
        access shared attributes among all DiagnosticRequestUpload in
        the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-UPLOAD"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRequestUpload.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestUpload.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticRequestUpload.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_range_refs: Optional["DiagnosticRequestUpload.MemoryRangeRefs"] = field(
        default=None,
        metadata={
            "name": "MEMORY-RANGE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_upload_class_ref: Optional["DiagnosticRequestUpload.RequestUploadClassRef"] = field(
        default=None,
        metadata={
            "name": "REQUEST-UPLOAD-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MemoryRangeRefs:
        memory_range_ref: list["DiagnosticRequestUpload.MemoryRangeRefs.MemoryRangeRef"] = field(
            default_factory=list,
            metadata={
                "name": "MEMORY-RANGE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class MemoryRangeRef(Ref):
            dest: DiagnosticMemoryIdentifierSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RequestUploadClassRef(Ref):
        dest: DiagnosticRequestUploadClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestUploadClass:
    """
    This meta-class contains attributes shared by all instances of the "Request
    Upload" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-UPLOAD-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRequestUploadClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestUploadClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticRequestUploadClass.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestVehicleInfo:
    """
    This meta-class represents the ability to model an instance of the OBD mode
    0x09 service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar info_type_ref: This represents the info type associated with
        the mode 0x09 service.
    :ivar request_vehicle_information_class_ref: This reference
        substantiates that abstract reference in the role serviceClass
        for this specific concrete class. Thereby, the reference
        represents the ability to access shared attributes among all
        DiagnosticRequesVehicleInfo in the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-VEHICLE-INFO"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRequestVehicleInfo.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestVehicleInfo.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticRequestVehicleInfo.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    info_type_ref: Optional["DiagnosticRequestVehicleInfo.InfoTypeRef"] = field(
        default=None,
        metadata={
            "name": "INFO-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_vehicle_information_class_ref: Optional[
        "DiagnosticRequestVehicleInfo.RequestVehicleInformationClassRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUEST-VEHICLE-INFORMATION-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class InfoTypeRef(Ref):
        dest: DiagnosticInfoTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequestVehicleInformationClassRef(Ref):
        dest: DiagnosticRequestVehicleInfoClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestVehicleInfoClass:
    """
    This meta-class represents the ability to define common properties for all
    instances of the "Request Vehicle Info" OBD diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-VEHICLE-INFO-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRequestVehicleInfoClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestVehicleInfoClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticRequestVehicleInfoClass.AccessPermissionRef"] = (
        field(
            default=None,
            metadata={
                "name": "ACCESS-PERMISSION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticResponseOnEvent:
    """
    This represents an instance of the "Response on Event" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar events: This represents the collection of
        DiagnosticResponseOnEventTriggers defined in the context of the
        enclosing DiagnosticResponseOnEvent.
    :ivar event_windows: This represents the applicable
        DiagnosticEventWindows
    :ivar response_on_event_action: Defines sub-functions of the service
        ResponseOnEvent.
    :ivar response_on_event_class_ref: This reference substantiates that
        abstract reference in the role serviceClass for this specific
        concrete class. Thereby,  the reference represents the ability
        to access shared attributes among all DiagnosticResponseOnEvent
        in the given context.
    :ivar store_event_support:
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-RESPONSE-ON-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticResponseOnEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticResponseOnEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticResponseOnEvent.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    events: Optional["DiagnosticResponseOnEvent.Events"] = field(
        default=None,
        metadata={
            "name": "EVENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_windows: Optional["DiagnosticResponseOnEvent.EventWindows"] = field(
        default=None,
        metadata={
            "name": "EVENT-WINDOWS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    response_on_event_action: DiagnosticResponseOnEventActionEnum | None = field(
        default=None,
        metadata={
            "name": "RESPONSE-ON-EVENT-ACTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    response_on_event_class_ref: Optional["DiagnosticResponseOnEvent.ResponseOnEventClassRef"] = (
        field(
            default=None,
            metadata={
                "name": "RESPONSE-ON-EVENT-CLASS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    store_event_support: DiagnosticStoreEventSupportEnum | None = field(
        default=None,
        metadata={
            "name": "STORE-EVENT-SUPPORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Events:
        diagnostic_data_change_trigger: list[DiagnosticDataChangeTrigger] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DATA-CHANGE-TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_dtc_change_trigger: list[DiagnosticDtcChangeTrigger] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DTC-CHANGE-TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventWindows:
        diagnostic_event_window: list[DiagnosticEventWindow] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EVENT-WINDOW",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ResponseOnEventClassRef(Ref):
        dest: DiagnosticResponseOnEventClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticResponseOnEventClass:
    """
    This represents the ability to define common properties for all instances of
    the "Response on Event" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar inter_message_time: Provide the minimum time in seconds
        between two consecutive  transmissions of an ROE event.
    :ivar max_num_change_of_data_identfier_events: The maximum number of
        events that can be simultaneously configured with sub function
        onChangeOfDataIdentifier.
    :ivar max_num_comparision_of_value_events: The maximum number of
        events that can be simultaneously configured with sub function
        onComparisonOfValues.
    :ivar max_number_of_stored_dtc_status_changed_events: The maximum
        number of DTCs that can be stored as DTCs with change status
        within one ResponseOnEventSchedulerRate interval.
    :ivar max_supported_did_length: The maximum number of measurable
        data bytes allowed for each DID that is used for comparison or
        data change.
    :ivar response_on_event_scheduler_rate: The call rate of the
        periodic scheduler to compare the values of the DataIdentifier
        (DID) or to detect DTC status changes.
    :ivar store_event_enabled: Specifies if the storeEvent functionality
        of the ResponseOnEvent diagnostic service shall be supported or
        not. If set to true, the storeEvent functionality is available.
        If set to false the storeEvent functionality is not available.
    :ivar store_event_support: Defines how a specific event shall be
        handled.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-RESPONSE-ON-EVENT-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticResponseOnEventClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticResponseOnEventClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticResponseOnEventClass.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    inter_message_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "INTER-MESSAGE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_num_change_of_data_identfier_events: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUM-CHANGE-OF-DATA-IDENTFIER-EVENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_num_comparision_of_value_events: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUM-COMPARISION-OF-VALUE-EVENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_stored_dtc_status_changed_events: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-STORED-DTC-STATUS-CHANGED-EVENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_supported_did_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-SUPPORTED-DID-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    response_on_event_scheduler_rate: TimeValue | None = field(
        default=None,
        metadata={
            "name": "RESPONSE-ON-EVENT-SCHEDULER-RATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    store_event_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "STORE-EVENT-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    store_event_support: DiagnosticStoreEventSupportEnum | None = field(
        default=None,
        metadata={
            "name": "STORE-EVENT-SUPPORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticResponseOnEventNeeds:
    """
    This meta-class indicates a service use-case for the diagnostic service
    ResponseOnEvent.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-RESPONSE-ON-EVENT-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticResponseOnEventNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticResponseOnEventNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticResponseOnEventNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRoutineControl:
    """
    This represents an instance of the "Routine Control" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar routine_control_class_ref: This reference substantiates that
        abstract reference in the role serviceClass for this specific
        concrete class. Thereby, the reference represents the ability to
        access shared attributes among all DiagnosticRoutineControl in
        the given context.
    :ivar routine_ref: This refers to the applicable DiagnosticRoutine.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ROUTINE-CONTROL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRoutineControl.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRoutineControl.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticRoutineControl.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    routine_control_class_ref: Optional["DiagnosticRoutineControl.RoutineControlClassRef"] = field(
        default=None,
        metadata={
            "name": "ROUTINE-CONTROL-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    routine_ref: Optional["DiagnosticRoutineControl.RoutineRef"] = field(
        default=None,
        metadata={
            "name": "ROUTINE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RoutineControlClassRef(Ref):
        dest: DiagnosticRoutineControlClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RoutineRef(Ref):
        dest: DiagnosticRoutineSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRoutineControlClass:
    """
    This meta-class contains attributes shared by all instances of the "Routine
    Control" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ROUTINE-CONTROL-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRoutineControlClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRoutineControlClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticRoutineControlClass.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRoutineGenericInterface:
    """
    This meta-class represents the ability to implement a generic Routine-focused
    PortInterface for diagnostics on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ROUTINE-GENERIC-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRoutineGenericInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRoutineGenericInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticRoutineGenericInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticRoutineGenericInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRoutineNeeds:
    """Specifies the general needs on the configuration of the  Diagnostic
    Communication Manager (Dcm) which are not related to a particular item (e.g. a
    PID).

    The main use case is the mapping of service ports to the Dcm which
    are not related to a particular item.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar diag_routine_type: This denotes the type of diagnostic routine
        which is implemented by the referenced server port.
    :ivar rid_number: This represents a routine identifier for the
        diagnostic routine. This allows to predefine the RID number if
        the a function developer has received a particular requirement
        from the OEM or from a standardization body.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ROUTINE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRoutineNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRoutineNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticRoutineNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_routine_type: DiagnosticRoutineTypeEnum | None = field(
        default=None,
        metadata={
            "name": "DIAG-ROUTINE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rid_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "RID-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticSecurityAccess:
    """
    This represents an instance of the "Security Access" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar request_seed_id: This would be 0x01, 0x03, 0x05, ... The
        sendKey id can be computed by adding 1 to the requestSeedId
    :ivar security_access_class_ref: This reference substantiates that
        abstract reference in the role serviceClass for this specific
        concrete class. Thereby, the reference represents the ability to
        access shared attributes among all DiagnosticSecurityAccess in
        the given context.
    :ivar security_delay_time_on_boot: Start delay timer on power on in
        seconds. This delay indicates the time at ECU boot power-on time
        where the Dcm remains in the default session and does not accept
        a security access.
    :ivar security_level_ref: This reference identifies the applicable
        security level for the security access.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SECURITY-ACCESS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticSecurityAccess.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticSecurityAccess.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticSecurityAccess.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_seed_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "REQUEST-SEED-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_class_ref: Optional["DiagnosticSecurityAccess.SecurityAccessClassRef"] = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_delay_time_on_boot: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SECURITY-DELAY-TIME-ON-BOOT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_level_ref: Optional["DiagnosticSecurityAccess.SecurityLevelRef"] = field(
        default=None,
        metadata={
            "name": "SECURITY-LEVEL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecurityAccessClassRef(Ref):
        dest: DiagnosticSecurityAccessClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecurityLevelRef(Ref):
        dest: DiagnosticSecurityLevelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticSecurityAccessClass:
    """
    This meta-class contains attributes shared by all instances of the "Security
    Access" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar shared_timer: Switch between separate or single shared timer
        instance and timer value. * True: use shared timer instance and
        timer value for all security access levels combined. * False:
        use separate timer instance and timer values for each security
        level.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SECURITY-ACCESS-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticSecurityAccessClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticSecurityAccessClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticSecurityAccessClass.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    shared_timer: Boolean | None = field(
        default=None,
        metadata={
            "name": "SHARED-TIMER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticSecurityEventReportingModeMapping:
    """This meta-class represents the ability to associate a location in a DID with
    a security event.

    The purpose of this mapping is that the location in the DID contains
    the setting of the reporting mode for the specific security event.
    This means that the reporting mode of the security event can be set
    via the diagnostic service WriteDataByIdentifier.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar data_element_ref: This reference identifies the data element
        that carries the information about the reporting mode.
    :ivar security_event_ref: This reference identifies the mapped
        security event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SECURITY-EVENT-REPORTING-MODE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticSecurityEventReportingModeMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticSecurityEventReportingModeMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticSecurityEventReportingModeMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticSecurityEventReportingModeMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["DiagnosticSecurityEventReportingModeMapping.DataElementRef"] = (
        field(
            default=None,
            metadata={
                "name": "DATA-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    security_event_ref: Optional["DiagnosticSecurityEventReportingModeMapping.SecurityEventRef"] = (
        field(
            default=None,
            metadata={
                "name": "SECURITY-EVENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: DiagnosticDataElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecurityEventRef(Ref):
        dest: SecurityEventContextPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticSecurityLevel:
    """
    This meta-class represents the ability to define a security level considered
    for diagnostic purposes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_data_record_size: This represents the size of the
        AccessDataRecord used in GetSeed. Unit:byte.
    :ivar key_size: This represents the size of the security key. Unit:
        byte.
    :ivar num_failed_security_access: This represents the number of
        failed security accesses after which the delay time is
        activated.
    :ivar security_delay_time: This represents the delay time after a
        failed security access. Unit: second.
    :ivar seed_size: This represents the size of the security seed.
        Unit: byte.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SECURITY-LEVEL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticSecurityLevel.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticSecurityLevel.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_data_record_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ACCESS-DATA-RECORD-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "KEY-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    num_failed_security_access: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NUM-FAILED-SECURITY-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_delay_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SECURITY-DELAY-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    seed_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SEED-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticSecurityLevelInterface:
    """
    This meta-class represents the ability to implement a security-level-focused
    PortInterface for diagnostics on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SECURITY-LEVEL-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticSecurityLevelInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticSecurityLevelInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticSecurityLevelInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticSecurityLevelInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticSecurityLevelPortMapping:
    """
    Defines to which SWC service ports with DiagnosticsCommunicationSecurityNeeds
    the DiagnosticSecurityLevel is mapped.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar p_port_prototype_in_executable_iref: This aggregation allows
        for the usage of the DiagnosticSecurityLevelMapping on the
        AUTOSAR adaptive platform.
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar security_level_ref: Reference to the SecurityLevelwhich is
        mapped to a SWC service port with
        DiagnosticCommunicationSecurityNeeds.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SECURITY-LEVEL-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticSecurityLevelPortMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticSecurityLevelPortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticSecurityLevelPortMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticSecurityLevelPortMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_port_prototype_in_executable_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "P-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticSecurityLevelPortMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_level_ref: Optional["DiagnosticSecurityLevelPortMapping.SecurityLevelRef"] = field(
        default=None,
        metadata={
            "name": "SECURITY-LEVEL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecurityLevelRef(Ref):
        dest: DiagnosticSecurityLevelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticServiceDataMapping:
    """This represents the ability to define a mapping of a diagnostic service to a
    software-component.

    This kind of service mapping is applicable for the usage of
    SenderReceiverInterfaces or event/notifier semantics in
    ServiceInterfaces on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar diagnostic_data_element_ref: This represents the applicable
        payload that corresponds to the referenced DataPrototype in the
        role mappedDataElement or (in case of a usage on the adaptive
        platform) mappedApDataElement.
    :ivar mapped_data_element_iref: This represents the dataElement in
        the application software that is accessed for diagnostic
        purpose. This role is applicable on the classic platform.
    :ivar parameter_element_access: This aggregation represents the
        single point of access to the reference to one specific
        DiagnosticParameterElement.
    :ivar diagnostic_parameter_ref: This represents the applicable
        payload that corresponds to the referenced DataPrototype in the
        role mappedDataElement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SERVICE-DATA-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticServiceDataMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticServiceDataMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticServiceDataMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticServiceDataMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_data_element_ref: Optional[
        "DiagnosticServiceDataMapping.DiagnosticDataElementRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapped_data_element_iref: DataPrototypeInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "MAPPED-DATA-ELEMENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_element_access: DiagnosticParameterElementAccess | None = field(
        default=None,
        metadata={
            "name": "PARAMETER-ELEMENT-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_parameter_ref: Optional["DiagnosticServiceDataMapping.DiagnosticParameterRef"] = (
        field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-PARAMETER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticDataElementRef(Ref):
        dest: DiagnosticDataElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticParameterRef(Ref):
        dest: DiagnosticParameterIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticServiceGenericMapping:
    """
    This meta-class represents the ability to implement a generic generic mapping
    for select diagnostics services on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar diagnostic_service_instance_ref: Reference to the
        ServiceInstance  mapped to a SWC service port.
    :ivar p_port_prototype_in_executable_iref: This aggregation allows
        for the usage of the DiagnosticServiceGenericMapping on the
        AUTOSAR adaptive platform.
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SERVICE-GENERIC-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticServiceGenericMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticServiceGenericMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticServiceGenericMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticServiceGenericMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_service_instance_ref: Optional[
        "DiagnosticServiceGenericMapping.DiagnosticServiceInstanceRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-SERVICE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_port_prototype_in_executable_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "P-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticServiceGenericMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticServiceInstanceRef(Ref):
        dest: DiagnosticServiceInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticServiceSwMapping:
    """This represents the ability to define a mapping of a diagnostic service to a
    software-component or a basic-software module.

    If the former is used then this kind of service mapping is
    applicable for the usage of ClientServerInterfaces.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar accessed_data_prototype_iref: Thi instanceRef identifies the
        DataPrototype that is supposed to be accessed in the context of
        the operation argument.
    :ivar diagnostic_data_element_ref: This represents a
        DiagnosticDataElement required to execute the respective
        diagnostic service in the context of the diagnostic service
        mapping,
    :ivar diagnostic_parameter_ref: This represents the applicable
        payload that corresponds to the referenced DataPrototype in the
        role mappedData Element.
    :ivar mapped_bsw_service_dependency_ref: This is supposed to
        represent a reference to a BswServiceDependency. the latter is
        not derived from Referrable and therefore this detour needs to
        be implemented to still let BswServiceDependency become the
        target of a reference.
    :ivar mapped_flat_swc_service_dependency_ref: This represents the
        ability to refer to an AtomicSwComponentType that is available
        without the definition of how it will be embedded into the
        component hierarchy.
    :ivar mapped_swc_service_dependency_in_system_iref: This represents
        the ability to point into the component hierarchy (under
        possible consideration of the rootSoftwareComposition)
    :ivar mapped_swc_service_dependency_iref: This represents the
        ability to point into the component hiearchy (under possible
        consideration of the rootSoftwareComposition)
    :ivar parameter_element_access: This aggregation represents the
        single point of access to the reference to one specific
        DiagnosticParameterElement.
    :ivar service_instance_ref: This represents the service instance
        that needs to be considered in this diagnostics service mapping.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SERVICE-SW-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticServiceSwMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticServiceSwMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticServiceSwMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticServiceSwMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    accessed_data_prototype_iref: DataPrototypeInClientServerInterfaceInstanceRef | None = field(
        default=None,
        metadata={
            "name": "ACCESSED-DATA-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_data_element_ref: Optional["DiagnosticServiceSwMapping.DiagnosticDataElementRef"] = (
        field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-DATA-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    diagnostic_parameter_ref: Optional["DiagnosticServiceSwMapping.DiagnosticParameterRef"] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-PARAMETER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapped_bsw_service_dependency_ref: Optional[
        "DiagnosticServiceSwMapping.MappedBswServiceDependencyRef"
    ] = field(
        default=None,
        metadata={
            "name": "MAPPED-BSW-SERVICE-DEPENDENCY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapped_flat_swc_service_dependency_ref: Optional[
        "DiagnosticServiceSwMapping.MappedFlatSwcServiceDependencyRef"
    ] = field(
        default=None,
        metadata={
            "name": "MAPPED-FLAT-SWC-SERVICE-DEPENDENCY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapped_swc_service_dependency_in_system_iref: SwcServiceDependencyInSystemInstanceRef | None = (
        field(
            default=None,
            metadata={
                "name": "MAPPED-SWC-SERVICE-DEPENDENCY-IN-SYSTEM-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    mapped_swc_service_dependency_iref: SwcServiceDependencyInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "MAPPED-SWC-SERVICE-DEPENDENCY-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_element_access: DiagnosticParameterElementAccess | None = field(
        default=None,
        metadata={
            "name": "PARAMETER-ELEMENT-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_ref: Optional["DiagnosticServiceSwMapping.ServiceInstanceRef"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticDataElementRef(Ref):
        dest: DiagnosticDataElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticParameterRef(Ref):
        dest: DiagnosticParameterIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MappedBswServiceDependencyRef(Ref):
        dest: BswServiceDependencyIdentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MappedFlatSwcServiceDependencyRef(Ref):
        dest: SwcServiceDependencySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRef(Ref):
        dest: DiagnosticServiceInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticServiceTableRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar diagnostic_service_table_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SERVICE-TABLE-REF-CONDITIONAL"

    diagnostic_service_table_ref: Optional[
        "DiagnosticServiceTableRefConditional.DiagnosticServiceTableRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-SERVICE-TABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticServiceTableRef(Ref):
        dest: DiagnosticServiceTableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticServiceValidationInterface:
    """
    This meta-class represents the ability to implement a PortInterface to process
    requests for service validation on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SERVICE-VALIDATION-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticServiceValidationInterface.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticServiceValidationInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticServiceValidationInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticServiceValidationInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticServiceValidationMapping:
    """
    This meta-class provides the ability to specify manufacturer/supplier checks to
    be executed before diagnostic services can be processed.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar p_port_prototype_in_executable_iref: This mapping identifies a
        PortPrototype typed by a DiagnosticValidationInterface in which
        a manufacturer/supplier-specific check is executed.
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SERVICE-VALIDATION-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticServiceValidationMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticServiceValidationMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticServiceValidationMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticServiceValidationMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_port_prototype_in_executable_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "P-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticServiceValidationMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticSession:
    """
    This meta-class represents the ability to define a diagnostic session.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar id: This is the numerical identifier used to identify the
        DiagnosticSession in the scope of diagnostic workflow
    :ivar jump_to_boot_loader: This attribute represents the ability to
        define whether this diagnostic session allows to jump to
        Bootloader (OEM Bootloader or System Supplier Bootloader). If
        this diagnostic session doesn't allow to jump to Bootloader the
        value JumpToBootLoaderEnum.noBoot shall be chosen.
    :ivar p_2_server_max: This is the session value for P2ServerMax in
        seconds (per Session Control). The AUTOSAR configuration
        standard is to use SI units, so this parameter is defined as a
        float value in seconds.
    :ivar p_2_star_server_max: This is the session value for
        P2*ServerMax in seconds (per Session Control). The AUTOSAR
        configuration standard is to use SI units, so this parameter is
        defined as a float value in seconds.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SESSION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticSession.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticSession.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    jump_to_boot_loader: DiagnosticJumpToBootLoaderEnum | None = field(
        default=None,
        metadata={
            "name": "JUMP-TO-BOOT-LOADER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_2_server_max: TimeValue | None = field(
        default=None,
        metadata={
            "name": "P-2-SERVER-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_2_star_server_max: TimeValue | None = field(
        default=None,
        metadata={
            "name": "P-2-STAR-SERVER-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticSessionControl:
    """
    This represents an instance of the "Session Control" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar diagnostic_session_ref: This represents the applicable
        DiagnosticSessions
    :ivar session_control_class_ref: This reference substantiates that
        abstract reference in the role serviceClass for this specific
        concrete class. Thereby, the reference represents the ability to
        access shared attributes among all DiagnosticSessionControl in
        the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SESSION-CONTROL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticSessionControl.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticSessionControl.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticSessionControl.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_session_ref: Optional["DiagnosticSessionControl.DiagnosticSessionRef"] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-SESSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    session_control_class_ref: Optional["DiagnosticSessionControl.SessionControlClassRef"] = field(
        default=None,
        metadata={
            "name": "SESSION-CONTROL-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticSessionRef(Ref):
        dest: DiagnosticSessionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SessionControlClassRef(Ref):
        dest: DiagnosticSessionControlClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticSessionControlClass:
    """
    This meta-class contains attributes shared by all instances of the "Session
    Control" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SESSION-CONTROL-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticSessionControlClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticSessionControlClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticSessionControlClass.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticSovdAuthorizationInterface:
    """
    This meta-class is used to type a PPortPrototype for implementing the SOVD
    authorization.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SOVD-AUTHORIZATION-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticSovdAuthorizationInterface.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticSovdAuthorizationInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticSovdAuthorizationInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticSovdAuthorizationInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticSovdAuthorizationPortMapping:
    """
    This mapping class identifies the PortPrototype in the application software
    that handles the SOVD authorization.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar p_port_prototype_in_executable_iref: This aggregation allows
        for the usage of the DiagnosticSovdAuthorizationPortMapping on
        the AUTOSAR adaptive platform.
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SOVD-AUTHORIZATION-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticSovdAuthorizationPortMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticSovdAuthorizationPortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticSovdAuthorizationPortMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticSovdAuthorizationPortMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_port_prototype_in_executable_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "P-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticSovdAuthorizationPortMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticSovdLock:
    """
    This meta-class represents the ability to define an SOVD lock to be considered
    for the computation of a diagnostic access permission.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SOVD-LOCK"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticSovdLock.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticSovdLock.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticSovdProximityChallengeInterface:
    """
    This meta-class is used to type a PPortPrototype for implementing the SOVD
    proximity challenge.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticSovdProximityChallengeInterface.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticSovdProximityChallengeInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticSovdProximityChallengeInterface.BlueprintPolicys"] = (
        field(
            default=None,
            metadata={
                "name": "BLUEPRINT-POLICYS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticSovdProximityChallengeInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticSovdProximityChallengePortMapping:
    """
    This mapping class identifies the PortPrototype in the application software
    that handles the SOVD proximity challenge.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar p_port_prototype_in_executable_iref: This aggregation allows
        for the usage of the DiagnosticSovdProximityChallengePortMapping
        on the AUTOSAR adaptive platform.
    :ivar process_ref: Reference to the representation of a Process that
        is required because the mapping could be different for different
        Processes referring to a specific Executable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticSovdProximityChallengePortMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticSovdProximityChallengePortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticSovdProximityChallengePortMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticSovdProximityChallengePortMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_port_prototype_in_executable_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "P-PORT-PROTOTYPE-IN-EXECUTABLE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticSovdProximityChallengePortMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticStorageCondition:
    """
    Specification of a storage condition.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar init_value: Defines the initial status for enable or disable
        of acceptance/storage of event reports of a diagnostic event.
        The value is the initialization after power up (before this
        condition is reported the first time). true: acceptance/storage
        of a diagnostic event enabled false: acceptance/storage of a
        diagnostic event disabled
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-STORAGE-CONDITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticStorageCondition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticStorageCondition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    init_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticStorageConditionNeeds:
    """
    This meta-class represents the needs of a software-component to provide the
    capability to set a storage condition.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar initial_status: Defines the initial status for enable or
        disable of storage of a diagnostic event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-STORAGE-CONDITION-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticStorageConditionNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticStorageConditionNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticStorageConditionNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_status: StorageConditionStatusEnum | None = field(
        default=None,
        metadata={
            "name": "INITIAL-STATUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticStorageConditionPortMapping:
    """
    Defines to which SWC service ports with DiagnosticStorageConditionNeeds the
    DiagnosticStorageCondition is mapped.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar diagnostic_storage_condition_ref: Reference to the
        StorageCondition which is mapped to a SWC service port with
        DiagnosticStorageConditionNeeds.
    :ivar swc_flat_service_dependency_ref: Reference to a
        SwcServiceDependencyType that links ServiceNeeds to SWC service
        ports.
    :ivar swc_service_dependency_in_system_iref: Instance reference to a
        SwcServiceDependency that links ServiceNeeds to SWC service
        ports.
    :ivar swc_service_dependency_iref: Instance reference to a
        SwcServiceDependency that links ServiceNeeds to SWC service
        ports.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-STORAGE-CONDITION-PORT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticStorageConditionPortMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticStorageConditionPortMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticStorageConditionPortMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticStorageConditionPortMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_storage_condition_ref: Optional[
        "DiagnosticStorageConditionPortMapping.DiagnosticStorageConditionRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-STORAGE-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_flat_service_dependency_ref: Optional[
        "DiagnosticStorageConditionPortMapping.SwcFlatServiceDependencyRef"
    ] = field(
        default=None,
        metadata={
            "name": "SWC-FLAT-SERVICE-DEPENDENCY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_service_dependency_in_system_iref: SwcServiceDependencyInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SWC-SERVICE-DEPENDENCY-IN-SYSTEM-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_service_dependency_iref: SwcServiceDependencyInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SWC-SERVICE-DEPENDENCY-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticStorageConditionRef(Ref):
        dest: DiagnosticStorageConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SwcFlatServiceDependencyRef(Ref):
        dest: SwcServiceDependencySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticStorageConditionRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar diagnostic_storage_condition_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-STORAGE-CONDITION-REF-CONDITIONAL"

    diagnostic_storage_condition_ref: Optional[
        "DiagnosticStorageConditionRefConditional.DiagnosticStorageConditionRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-STORAGE-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticStorageConditionRef(Ref):
        dest: DiagnosticStorageConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticTestRoutineIdentifier:
    """
    This represents the test id of the DiagnosticTestIdentifier.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar id: This represents the numerical id of the
        DiagnosticTestIdentifier (see SAE J1979-DA).
    :ivar request_data_size: This represents the specified data size for
        the request message. Unit: byte.
    :ivar response_data_size: This represents the specified data size
        for the response message. Unit:byte.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TEST-ROUTINE-IDENTIFIER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticTestRoutineIdentifier.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticTestRoutineIdentifier.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_data_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "REQUEST-DATA-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    response_data_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "RESPONSE-DATA-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticTransferExit:
    """
    This represents an instance of the "Transfer Exit" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar transfer_exit_class_ref: This reference substantiates that
        abstract reference in the role serviceClass for this specific
        concrete class. Thereby, the reference represents the ability to
        access shared attributes among all DiagnosticTransferExit in the
        given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TRANSFER-EXIT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticTransferExit.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticTransferExit.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticTransferExit.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transfer_exit_class_ref: Optional["DiagnosticTransferExit.TransferExitClassRef"] = field(
        default=None,
        metadata={
            "name": "TRANSFER-EXIT-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TransferExitClassRef(Ref):
        dest: DiagnosticTransferExitClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticTransferExitClass:
    """
    This meta-class contains attributes shared by all instances of the "Transfer
    Exit" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TRANSFER-EXIT-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticTransferExitClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticTransferExitClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticTransferExitClass.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticTroubleCodeJ1939:
    """
    This meta-class represents the ability to model specific trouble-code related
    properties for J1939.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar dtc_props_ref: Defined properties associated with the J1939
        DTC.
    :ivar fmi: This attribute represents the behavior of the Failure
        Mode Indicator.
    :ivar j_1939_dtc_value: This attribute represents the Unique
        Diagnostic Trouble Code value for J1939 (consisting of SPN and
        FMI).
    :ivar kind: This attribute further specifies the DTC in terms of its
        semantics.
    :ivar node_ref: This represents the related DiagnosticJ1939Node.
    :ivar spn_ref: This represents the releated SPN.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TROUBLE-CODE-J-1939"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticTroubleCodeJ1939.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticTroubleCodeJ1939.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_props_ref: Optional["DiagnosticTroubleCodeJ1939.DtcPropsRef"] = field(
        default=None,
        metadata={
            "name": "DTC-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fmi: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FMI",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    j_1939_dtc_value: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "J-1939-DTC-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    kind: DiagnosticTroubleCodeJ1939DtcKindEnum | None = field(
        default=None,
        metadata={
            "name": "KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    node_ref: Optional["DiagnosticTroubleCodeJ1939.NodeRef"] = field(
        default=None,
        metadata={
            "name": "NODE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    spn_ref: Optional["DiagnosticTroubleCodeJ1939.SpnRef"] = field(
        default=None,
        metadata={
            "name": "SPN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DtcPropsRef(Ref):
        dest: DiagnosticTroubleCodePropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NodeRef(Ref):
        dest: DiagnosticJ1939NodeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SpnRef(Ref):
        dest: DiagnosticJ1939SpnSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticTroubleCodeRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar diagnostic_trouble_code_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TROUBLE-CODE-REF-CONDITIONAL"

    diagnostic_trouble_code_ref: Optional[
        "DiagnosticTroubleCodeRefConditional.DiagnosticTroubleCodeRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-TROUBLE-CODE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticTroubleCodeRef(Ref):
        dest: DiagnosticTroubleCodeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticTroubleCodeUds:
    """
    This element is used to describe non OBD-relevant DTCs.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar consider_pto_status: This attribute describes the affection of
        the event by the Dem PTO handling. True: the event is affected
        by the Dem PTO handling. False: the event is not affected by the
        Dem PTO handling.
    :ivar dtc_props_ref: Defined properties associated with the DemDTC.
    :ivar event_obd_readiness_group: This attribute specifies the Event
        OBD Readiness group for PID $01 and PID $41 computation. This
        attribute is only applicable for emission-related ECUs.
    :ivar functional_unit: This attribute specifies a 1-byte value which
        identifies the corresponding basic vehicle / system function
        which reports the DTC. This parameter is necessary for the
        report of severity information.
    :ivar severity: DTC severity according to ISO 14229-1.
    :ivar uds_dtc_value: Unique Diagnostic Trouble Code value for UDS.
    :ivar wwh_obd_dtc_class: This attribute is used to identify (if
        applicable) the corresponding severity class of an WWH-OBD DTC.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TROUBLE-CODE-UDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticTroubleCodeUds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticTroubleCodeUds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consider_pto_status: Boolean | None = field(
        default=None,
        metadata={
            "name": "CONSIDER-PTO-STATUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_props_ref: Optional["DiagnosticTroubleCodeUds.DtcPropsRef"] = field(
        default=None,
        metadata={
            "name": "DTC-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_obd_readiness_group: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "EVENT-OBD-READINESS-GROUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    functional_unit: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FUNCTIONAL-UNIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    severity: DiagnosticUdsSeverityEnum | None = field(
        default=None,
        metadata={
            "name": "SEVERITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uds_dtc_value: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UDS-DTC-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wwh_obd_dtc_class: DiagnosticWwhObdDtcClassEnumValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "WWH-OBD-DTC-CLASS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DtcPropsRef(Ref):
        dest: DiagnosticTroubleCodePropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticTroubleCodeUdsToClearConditionGroupMapping:
    """
    This meta-class provides the ability to map a DiagnosticClearConditionGroup to
    a collection of DiagnosticTroubleCodeUds.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar clear_condition_group_ref: Thi reference identifies the
        applicable DiagnosticClearConditionGroup.
    :ivar trouble_code_uds_ref: This reference identifies the
        DiagnosticTroubleCodeUds that are relevant for the mapping.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TROUBLE-CODE-UDS-TO-CLEAR-CONDITION-GROUP-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticTroubleCodeUdsToClearConditionGroupMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticTroubleCodeUdsToClearConditionGroupMapping.Annotations"] = (
        field(
            default=None,
            metadata={
                "name": "ANNOTATIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticTroubleCodeUdsToClearConditionGroupMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticTroubleCodeUdsToClearConditionGroupMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clear_condition_group_ref: Optional[
        "DiagnosticTroubleCodeUdsToClearConditionGroupMapping.ClearConditionGroupRef"
    ] = field(
        default=None,
        metadata={
            "name": "CLEAR-CONDITION-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trouble_code_uds_ref: Optional[
        "DiagnosticTroubleCodeUdsToClearConditionGroupMapping.TroubleCodeUdsRef"
    ] = field(
        default=None,
        metadata={
            "name": "TROUBLE-CODE-UDS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ClearConditionGroupRef(Ref):
        dest: DiagnosticClearConditionGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TroubleCodeUdsRef(Ref):
        dest: DiagnosticTroubleCodeUdsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticTroubleCodeUdsToTroubleCodeObdMapping:
    """
    This meta-class represents the ability to associate a UDS trouble code to an
    OBD trouble code.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provider_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing provided CPSoftwareCluster.
    :ivar requester_software_cluster_ref: This reference can be used in
        an early design phase to associate an element of a diagnostic
        extract with an existing requested CPSoftwareCluster.
    :ivar trouble_code_obd_ref: This represents the OBD DTC referenced
        in the mapping between UDS and OBD DTCs.
    :ivar trouble_code_uds_ref: This represents the UDS DTC referenced
        in the mapping between UDS and OBD DTCs.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TROUBLE-CODE-UDS-TO-TROUBLE-CODE-OBD-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticTroubleCodeUdsToTroubleCodeObdMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticTroubleCodeUdsToTroubleCodeObdMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_software_cluster_ref: Optional[
        "DiagnosticTroubleCodeUdsToTroubleCodeObdMapping.ProviderSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requester_software_cluster_ref: Optional[
        "DiagnosticTroubleCodeUdsToTroubleCodeObdMapping.RequesterSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUESTER-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trouble_code_obd_ref: Optional[
        "DiagnosticTroubleCodeUdsToTroubleCodeObdMapping.TroubleCodeObdRef"
    ] = field(
        default=None,
        metadata={
            "name": "TROUBLE-CODE-OBD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trouble_code_uds_ref: Optional[
        "DiagnosticTroubleCodeUdsToTroubleCodeObdMapping.TroubleCodeUdsRef"
    ] = field(
        default=None,
        metadata={
            "name": "TROUBLE-CODE-UDS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequesterSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TroubleCodeObdRef(Ref):
        dest: DiagnosticTroubleCodeObdSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TroubleCodeUdsRef(Ref):
        dest: DiagnosticTroubleCodeUdsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticUploadDownloadNeeds:
    """
    This meta-class represents the ability to specify needs regarding upload and
    download by means of diagnostic services.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-UPLOAD-DOWNLOAD-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticUploadDownloadNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticUploadDownloadNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticUploadDownloadNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticUploadInterface:
    """
    This meta-class represents the ability to implement a PortInterface to process
    requests for uploading data using diagnostic channels on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-UPLOAD-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticUploadInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticUploadInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticUploadInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticUploadInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticValueNeeds:
    """Specifies the general needs on the configuration of the  Diagnostic
    Communication Manager (DCM) which are not related to a particular item (e.g. a
    PID).

    The main use case is the mapping of service ports to the DCM which
    are not related to a particular item. In the case of using a sender
    receiver communicated value, the related value shall be taken via
    assignedData in the role "signalBasedDiagnostics". In case of using
    a client/server communicated value, the related value shall be
    communicated via the port referenced by assignedPort. The details of
    this communication (e.g. appropriate naming conventions) are
    specified in the related software specifications (SWS).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar data_length: This attribute is applicable only if the
        DiagnosticValueNeeds is aggregated within a BswModuleDependency.
        This attribute represents the length of data (in bytes) provided
        for this particular PID signal.
    :ivar diagnostic_value_access: This attribute is applicable only if
        the DiagnosticValueNeeds is aggregated within a
        BswModuleDependency. This attribute controls whether the data
        can be read and written or whether it is to be handled read-
        only.
    :ivar did_number: This represents a Data identifier for the
        diagnostic value. This allows to predefine the DID number if the
        responsible function developer has received a particular
        requirement from the OEM or from a standardization body.
    :ivar fixed_length: This attribute is applicable only if the
        DiagnosticValueNeeds is aggregated within a BswModuleDependency.
        This attribute controls whether the data length of the data is
        fixed.
    :ivar processing_style: This attribute controls whether interaction
        requires the software-component to react synchronously on a
        request or whether it processes the request in background but
        still the DCM has to issue the call again to eventually obtain
        the result of the request.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-VALUE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticValueNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticValueNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticValueNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_value_access: DiagnosticValueAccessEnum | None = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-VALUE-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    did_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DID-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fixed_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "FIXED-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    processing_style: DiagnosticProcessingStyleEnum | None = field(
        default=None,
        metadata={
            "name": "PROCESSING-STYLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticVerifyCertificateBidirectional:
    """
    This meta-class represents the subfunction to do a bidirectional verification
    of the certificate.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar authentication_class_ref: This represents the corresponding
        "class", i.e. this meta-class provides properties that are
        shared among all instances of applicable sub-classes of
        DiagnosticServiceInstance. The subclasses that affected by this
        pattern implement references to the applicable "class"-role that
        substantiate this abstract reference.
    :ivar authentication_timeout: This attribute defines the time that
        the authentication state is maintained in default-session if
        there is no communication from the authenticated client.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-VERIFY-CERTIFICATE-BIDIRECTIONAL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticVerifyCertificateBidirectional.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticVerifyCertificateBidirectional.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticVerifyCertificateBidirectional.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_class_ref: Optional[
        "DiagnosticVerifyCertificateBidirectional.AuthenticationClassRef"
    ] = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AuthenticationClassRef(Ref):
        dest: DiagnosticAuthenticationClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticVerifyCertificateUnidirectional:
    """
    This meta-class represents the subfunction to do a unidirectional verification
    of the certificate.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar authentication_class_ref: This represents the corresponding
        "class", i.e. this meta-class provides properties that are
        shared among all instances of applicable sub-classes of
        DiagnosticServiceInstance. The subclasses that affected by this
        pattern implement references to the applicable "class"-role that
        substantiate this abstract reference.
    :ivar authentication_timeout: This attribute defines the time that
        the authentication state is maintained in default-session if
        there is no communication from the authenticated client.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-VERIFY-CERTIFICATE-UNIDIRECTIONAL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DiagnosticVerifyCertificateUnidirectional.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticVerifyCertificateUnidirectional.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional[
        "DiagnosticVerifyCertificateUnidirectional.AccessPermissionRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_class_ref: Optional[
        "DiagnosticVerifyCertificateUnidirectional.AuthenticationClassRef"
    ] = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AuthenticationClassRef(Ref):
        dest: DiagnosticAuthenticationClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticWriteDataByIdentifier:
    """
    This represents an instance of the "Write Data by Identifier" diagnostic
    service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar data_identifier_ref: This represents the linked
        DiagnosticDataIdentifier.
    :ivar write_class_ref: This reference substantiates that abstract
        reference in the role serviceClass for this specific concrete
        class. Thereby,  the reference represents the ability to access
        shared attributes among all DiagnosticWriteDataByIdentifier in
        the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticWriteDataByIdentifier.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticWriteDataByIdentifier.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticWriteDataByIdentifier.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_identifier_ref: Optional["DiagnosticWriteDataByIdentifier.DataIdentifierRef"] = field(
        default=None,
        metadata={
            "name": "DATA-IDENTIFIER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    write_class_ref: Optional["DiagnosticWriteDataByIdentifier.WriteClassRef"] = field(
        default=None,
        metadata={
            "name": "WRITE-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataIdentifierRef(Ref):
        dest: DiagnosticAbstractDataIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class WriteClassRef(Ref):
        dest: DiagnosticWriteDataByIdentifierClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticWriteDataByIdentifierClass:
    """
    This meta-class contains attributes shared by all instances of the "Write Data
    by Identifier" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticWriteDataByIdentifierClass.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticWriteDataByIdentifierClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticWriteDataByIdentifierClass.AccessPermissionRef"] = (
        field(
            default=None,
            metadata={
                "name": "ACCESS-PERMISSION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticWriteMemoryByAddress:
    """
    This represents an instance of the "Write Memory by Address" diagnostic
    service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceInstance..
    :ivar memory_range_refs: This represents the formal description of
        the memory segment to which the DiagnosticMemoryByAddress
        applies.
    :ivar write_class_ref: This reference substantiates that abstract
        reference in the role serviceClass for this specific concrete
        class. Thereby, the reference represents the ability to access
        shared attributes among all DiagnosticWritememoryByAddress in
        the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticWriteMemoryByAddress.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticWriteMemoryByAddress.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticWriteMemoryByAddress.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_range_refs: Optional["DiagnosticWriteMemoryByAddress.MemoryRangeRefs"] = field(
        default=None,
        metadata={
            "name": "MEMORY-RANGE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    write_class_ref: Optional["DiagnosticWriteMemoryByAddress.WriteClassRef"] = field(
        default=None,
        metadata={
            "name": "WRITE-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MemoryRangeRefs:
        memory_range_ref: list["DiagnosticWriteMemoryByAddress.MemoryRangeRefs.MemoryRangeRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "MEMORY-RANGE-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class MemoryRangeRef(Ref):
            dest: DiagnosticMemoryIdentifierSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class WriteClassRef(Ref):
        dest: DiagnosticWriteMemoryByAddressClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticWriteMemoryByAddressClass:
    """
    This meta-class contains attributes shared by all instances of the "Write
    Memory by Address" diagnostic service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_permission_ref: This represents the collection of
        DiagnosticAccessPermissions that allow for the execution of the
        referencing DiagnosticServiceClass.
    :ivar access_permission_validity: This attribute is responsible for
        clarifying the validity of the accessPermission reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticWriteMemoryByAddressClass.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticWriteMemoryByAddressClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticWriteMemoryByAddressClass.AccessPermissionRef"] = (
        field(
            default=None,
            metadata={
                "name": "ACCESS-PERMISSION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    access_permission_validity: DiagnosticAccessPermissionValidityEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-VALIDITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticsCommunicationSecurityNeeds:
    """
    This meta-class represents the needs of a software-component to verify the
    access to security level via diagnostic services.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTICS-COMMUNICATION-SECURITY-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticsCommunicationSecurityNeeds.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticsCommunicationSecurityNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticsCommunicationSecurityNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DltApplicationToProcessMapping:
    """
    This element assigns a DltApplicationId to a Process.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar dlt_application_ref: Reference to a DltApplication that
        defines the applicationId
    :ivar process_ref: Reference to the process that is assigned to a
        Log And Trace applicationId.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-APPLICATION-TO-PROCESS-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DltApplicationToProcessMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DltApplicationToProcessMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_application_ref: Optional["DltApplicationToProcessMapping.DltApplicationRef"] = field(
        default=None,
        metadata={
            "name": "DLT-APPLICATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DltApplicationToProcessMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DltApplicationRef(Ref):
        dest: DltApplicationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DltArgument:
    """
    This element defines an Argument in a DltMessage.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar dlt_argument_entrys: This aggregation is used to describe
        subElements of a DltArgument that defines a Structure.
    :ivar length: Describes the DltArgument length in case of Arrays and
        Strings in number of BaseTypes.
    :ivar network_representation: Definition of the
        networkRepresentation of the DltArgument.
    :ivar optional: This attribute defines whether the argument is
        optional or not. If set to true, the argument can be omitted
        from the payload of a DLT message.
    :ivar predefined_text: This attribute defines whether the
        DltArgument is a predefinedText (Static Data).
    :ivar variable_length: This attribute defines whether the length of
        the DltArgument is variable (determined at runtime) or not.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-ARGUMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DltArgument.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DltArgument.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_argument_entrys: Optional["DltArgument.DltArgumentEntrys"] = field(
        default=None,
        metadata={
            "name": "DLT-ARGUMENT-ENTRYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_representation: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "NETWORK-REPRESENTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    optional: Boolean | None = field(
        default=None,
        metadata={
            "name": "OPTIONAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    predefined_text: Boolean | None = field(
        default=None,
        metadata={
            "name": "PREDEFINED-TEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variable_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "VARIABLE-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DltArgumentEntrys:
        dlt_argument: list["DltArgument"] = field(
            default_factory=list,
            metadata={
                "name": "DLT-ARGUMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DltContextRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar dlt_context_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-CONTEXT-REF-CONDITIONAL"

    dlt_context_ref: Optional["DltContextRefConditional.DltContextRef"] = field(
        default=None,
        metadata={
            "name": "DLT-CONTEXT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DltContextRef(Ref):
        dest: DltContextSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DltLogChannel:
    """
    This element contains the settings for the log/trace message output for a tuple
    of ApplicationId and ContextId (verbose mode) or a SessionId (non-verbose
    mode).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar application_context_refs: Reference to the Swc that produces
        the log or trace message. Please note that this reference shall
        not be set in case that the Bsw module produces the associated
        log or trace messages.
    :ivar application_description: This attribute can be used to
        describe the applicationId that is used in the log and trace
        message in more detail.
    :ivar application_id: This attribute identifies the SW-C/BSW module
        in the log and trace message.
    :ivar context_description: This attribute can be used to describe
        the contextId that is used in the log and trace message in more
        detail.
    :ivar context_id: This attribute is used to group log and trace
        messages produced by a SW-C/BSW modules to distinguish
        functionality (representing e.g. a library of the adaptive
        foundation linked into the application).
    :ivar default_trace_state: This attributes defines the default trace
        status.
    :ivar dlt_message_refs: Reference to DltMessages that can be
        transported over the DltLogChannel in the DltPdu.
    :ivar log_channel_id: This attribute identifies the Channel for
        usage within the Log And Trace protocol.
    :ivar log_trace_default_log_threshold: This attribute allows to set
        a log level Threshold for Log Level filtering.
    :ivar non_verbose_mode: This attribute defines whether this channel
        supports non-Verbose Dlt messages. If disabled only verbose mode
        messages  shall be used.
    :ivar rx_pdu_triggering_ref: Reference to DltPdu that is received by
        the DltLogChannel
    :ivar segmentation_supported: If enabled, segmentation will be used
        if a DLT message is larger than Pdu.length referenced via
        DltLogChannel.txPduTriggering.
    :ivar session_id: This attribute allows distinguishing log/trace
        messages from different instances of the same SW-C. It is
        required if sessionIdSupport of the aggregating DltConfig is
        True.
    :ivar tx_pdu_triggering_ref: Reference to DltPdu that is transmitted
        by the DltLogChannel.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-LOG-CHANNEL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DltLogChannel.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DltLogChannel.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_context_refs: Optional["DltLogChannel.ApplicationContextRefs"] = field(
        default=None,
        metadata={
            "name": "APPLICATION-CONTEXT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_description: String | None = field(
        default=None,
        metadata={
            "name": "APPLICATION-DESCRIPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_id: String | None = field(
        default=None,
        metadata={
            "name": "APPLICATION-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_description: String | None = field(
        default=None,
        metadata={
            "name": "CONTEXT-DESCRIPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_id: String | None = field(
        default=None,
        metadata={
            "name": "CONTEXT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_trace_state: DltDefaultTraceStateEnum | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-TRACE-STATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_message_refs: Optional["DltLogChannel.DltMessageRefs"] = field(
        default=None,
        metadata={
            "name": "DLT-MESSAGE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    log_channel_id: String | None = field(
        default=None,
        metadata={
            "name": "LOG-CHANNEL-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    log_trace_default_log_threshold: LogTraceDefaultLogLevelEnum | None = field(
        default=None,
        metadata={
            "name": "LOG-TRACE-DEFAULT-LOG-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    non_verbose_mode: Boolean | None = field(
        default=None,
        metadata={
            "name": "NON-VERBOSE-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rx_pdu_triggering_ref: Optional["DltLogChannel.RxPduTriggeringRef"] = field(
        default=None,
        metadata={
            "name": "RX-PDU-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    segmentation_supported: Boolean | None = field(
        default=None,
        metadata={
            "name": "SEGMENTATION-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    session_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SESSION-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tx_pdu_triggering_ref: Optional["DltLogChannel.TxPduTriggeringRef"] = field(
        default=None,
        metadata={
            "name": "TX-PDU-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ApplicationContextRefs:
        application_context_ref: list[
            "DltLogChannel.ApplicationContextRefs.ApplicationContextRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-CONTEXT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ApplicationContextRef(Ref):
            dest: DltContextSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DltMessageRefs:
        dlt_message_ref: list["DltLogChannel.DltMessageRefs.DltMessageRef"] = field(
            default_factory=list,
            metadata={
                "name": "DLT-MESSAGE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DltMessageRef(Ref):
            dest: DltMessageSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RxPduTriggeringRef(Ref):
        dest: PduTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TxPduTriggeringRef(Ref):
        dest: PduTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DltLogSink:
    """
    The meta-class defines the output sink for DltLogMessages.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar buffer_output: This attribute defines whether a buffer is used
        in case that the output sink is the console.
    :ivar default_log_threshold: This attribute allows to set a log
        level Threshold for Log Level filtering.
    :ivar default_trace_state: This attributes defines the default trace
        status.
    :ivar endpoint_configuration_ref: Network configuration (Protocol,
        Port, IP Address) for transmission of  dlt messages on a
        specific VLAN.
    :ivar log_channel_id: This attribute identifies the LogChannel for
        usage within the Log And Trace protocol.
    :ivar non_verbose_mode: This attribute defines whether this
        DltLogSink supports non-Verbose Dlt messages. If disabled only
        verbose mode messages shall be used.
    :ivar path: This attribute defines the path to the file that is used
        as output sink.
    :ivar queue_size: Length of the queue (in which messages can be
        stored before processing) in the unit "Log message".
    :ivar segmentation_supported: If enabled, segmentation will be used
        for DLT messages that are larger than
        EthernetCommunicationConnector.maximumTransmissionUnit
        referenced via DltLogSink.endpointConfiguration.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-LOG-SINK"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DltLogSink.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DltLogSink.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    buffer_output: Boolean | None = field(
        default=None,
        metadata={
            "name": "BUFFER-OUTPUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_log_threshold: LogTraceDefaultLogLevelEnum | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-LOG-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_trace_state: Boolean | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-TRACE-STATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    endpoint_configuration_ref: Optional["DltLogSink.EndpointConfigurationRef"] = field(
        default=None,
        metadata={
            "name": "ENDPOINT-CONFIGURATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    log_channel_id: String | None = field(
        default=None,
        metadata={
            "name": "LOG-CHANNEL-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    non_verbose_mode: Boolean | None = field(
        default=None,
        metadata={
            "name": "NON-VERBOSE-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    path: UriString | None = field(
        default=None,
        metadata={
            "name": "PATH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    queue_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "QUEUE-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    segmentation_supported: Boolean | None = field(
        default=None,
        metadata={
            "name": "SEGMENTATION-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EndpointConfigurationRef(Ref):
        dest: PlatformModuleEthernetEndpointConfigurationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DltLogSinkToPortPrototypeMapping:
    """
    This meta-class maps a PortPrototype to an output sink of a log and trace
    message.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar dlt_context_ref: Assignement of the DltContext that groups log
        and trace messages that will be transmitted to the DltLogSink.
    :ivar dlt_log_sink_refs: Reference to the output sink to which the
        log or trace message will be transmitted,
    :ivar dlt_session_id: This attribute allows distinguishing log/trace
        messages from different instances of the same SW-C.
    :ivar p_port_prototype_iref: Reference to PPortPrototype that is
        mapped to the DltLogSink.
    :ivar process_ref: This reference represents the process required as
        context for the mapping.
    :ivar r_port_prototype_iref: Reference to RPortPrototype that is
        mapped to a DltLogSink
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-LOG-SINK-TO-PORT-PROTOTYPE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DltLogSinkToPortPrototypeMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DltLogSinkToPortPrototypeMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_context_ref: Optional["DltLogSinkToPortPrototypeMapping.DltContextRef"] = field(
        default=None,
        metadata={
            "name": "DLT-CONTEXT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_log_sink_refs: Optional["DltLogSinkToPortPrototypeMapping.DltLogSinkRefs"] = field(
        default=None,
        metadata={
            "name": "DLT-LOG-SINK-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_session_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DLT-SESSION-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_port_prototype_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "P-PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DltLogSinkToPortPrototypeMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    r_port_prototype_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "R-PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DltContextRef(Ref):
        dest: DltContextSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DltLogSinkRefs:
        dlt_log_sink_ref: list["DltLogSinkToPortPrototypeMapping.DltLogSinkRefs.DltLogSinkRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DLT-LOG-SINK-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class DltLogSinkRef(Ref):
            dest: DltLogSinkSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DltMessageRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar dlt_message_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-MESSAGE-REF-CONDITIONAL"

    dlt_message_ref: Optional["DltMessageRefConditional.DltMessageRef"] = field(
        default=None,
        metadata={
            "name": "DLT-MESSAGE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DltMessageRef(Ref):
        dest: DltMessageSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DltUserNeeds:
    """This meta-class specifies the needs on the configuration of the Diagnostic
    Log and Trace module for one SessionId.

    This class currently contains no attributes. An instance of this
    class is used to find out which PortPrototypes of an
    AtomicSwComponentType belong to this SessionId in order to group the
    request and response PortPrototypes of the same SessionId. The
    actual SessionId value is stored in the PortDefinedArgumentValue of
    the respective PortPrototype specification.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-USER-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DltUserNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DltUserNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DoIpActivationLineNeeds:
    """A DoIP entity needs to be informed when an external tester is attached or
    activated.

    The DoIpActivationServiceNeeds specifies the trigger for such an
    event. Examples would be a Pdu via a regular communication bus, a
    PWM signal, or an I/O. For details please refer to the ISO 13400.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-ACTIVATION-LINE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DoIpActivationLineNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DoIpActivationLineNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DoIpGidNeeds:
    """The DoIpGidNeeds indicates that the software-component owning this
    ServiceNeeds is providing the GID number either after a GID Synchronisation or
    by other means like e.g. flashed EEPROM parameter.

    This need can be used independent from DoIpGidSynchronizationNeeds
    and is necessary if the GID can not be provided out of the DoIP
    configuration options.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-GID-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DoIpGidNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DoIpGidNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DoIpGidSynchronizationNeeds:
    """The DoIpGidSynchronizationNeeds indicates that the software-component owning
    this ServiceNeeds is triggered by the DoIP entity to start a synchronization of
    the GID (Group Identification) on the DoIP service 0x0001, 0x0002, 0x0003 or
    before announcement via service 0x0004 according to ISO 13400-2:2012 if
    necessary.

    Note that this need is only relevant for DoIP synchronization
    masters.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-GID-SYNCHRONIZATION-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DoIpGidSynchronizationNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DoIpGidSynchronizationNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DoIpInstantiation:
    """
    This meta-class defines the attributes for the DoIP configuration on a specific
    machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar eid: Configured EID (Entity ID) used for VehicleIdentification
        Request.
    :ivar entity_status_max_byte_field_use: This attribute is used to
        distinguish the optional support of the Max data size element of
        a diagnostic entity status response.
    :ivar gid: Configured GID (Group ID) used for
        VehicleIdentificationRequest. If configured, take this value
        (and set "Further action required" byte to 0x00="No further
        action required"), if not configured use ServiceInterface
        DoIPGroupIdentification to retrieve GID and 'further action
        required' values.
    :ivar gid_invalidity_pattern: Specifies the Byte pattern that is
        used for response messages if no valid GID could be retrieved.
        Only the value '0' or '255' is allowed.
    :ivar logical_address: Describes the logical address of the DoIP
        entity, which is used for VehicleAnnouncement and
        RoutingActivation responses.
    :ivar max_request_bytes: Specifies the maximum allowed bytes of a
        DoIP message request without the DoIP header.
    :ivar network_interfaces: Network interface specific DoIP
        properties.
    :ivar request_configurations: Request configuration that is used to
        determine whether an incoming DiagnosticMessage request needs to
        be interpreted as PHYSICAL or FUNCTIONAL. Any request with
        target address not within the configured target address range
        will be rejected.
    :ivar vin_invalidity_pattern: Specifies the Byte pattern that is
        used for response messages if no valid VIN could be retrieved.
        Only the value '0' or '255' is allowed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DoIpInstantiation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DoIpInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    eid: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "EID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    entity_status_max_byte_field_use: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENTITY-STATUS-MAX-BYTE-FIELD-USE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    gid: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "GID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    gid_invalidity_pattern: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "GID-INVALIDITY-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    logical_address: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOGICAL-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_request_bytes: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-REQUEST-BYTES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_interfaces: Optional["DoIpInstantiation.NetworkInterfaces"] = field(
        default=None,
        metadata={
            "name": "NETWORK-INTERFACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_configurations: Optional["DoIpInstantiation.RequestConfigurations"] = field(
        default=None,
        metadata={
            "name": "REQUEST-CONFIGURATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vin_invalidity_pattern: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VIN-INVALIDITY-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NetworkInterfaces:
        do_ip_network_configuration: list[DoIpNetworkConfiguration] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-NETWORK-CONFIGURATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequestConfigurations:
        do_ip_request_configuration: list[DoIpRequestConfiguration] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-REQUEST-CONFIGURATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DoIpLogicTargetAddressProps:
    """
    This meta-class acts as a target for references to the DoIpLogicTargetAddress
    and collects DoIpLogicTargetAddress specific settings.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-LOGIC-TARGET-ADDRESS-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DoIpLogicTargetAddressProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DoIpLogicTargetAddressProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DoIpLogicTesterAddressProps:
    """
    This meta-class acts as a target for references to the DoIpLogicTesterAddress
    and collects DoIpLogicTesterAddress specific settings.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar do_ip_tester_routing_activation_refs: Reference to a
        DoIPRoutingActivation describing the possible routing
        activations of the DoIPTester.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-LOGIC-TESTER-ADDRESS-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DoIpLogicTesterAddressProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DoIpLogicTesterAddressProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    do_ip_tester_routing_activation_refs: Optional[
        "DoIpLogicTesterAddressProps.DoIpTesterRoutingActivationRefs"
    ] = field(
        default=None,
        metadata={
            "name": "DO-IP-TESTER-ROUTING-ACTIVATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DoIpTesterRoutingActivationRefs:
        do_ip_tester_routing_activation_ref: list[
            "DoIpLogicTesterAddressProps.DoIpTesterRoutingActivationRefs.DoIpTesterRoutingActivationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-TESTER-ROUTING-ACTIVATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DoIpTesterRoutingActivationRef(Ref):
            dest: DoIpRoutingActivationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DoIpPowerModeStatusNeeds:
    """
    The DoIpPowerModeStatusNeeds indicates that the software-component owning this
    ServiceNeeds is providing the PowerModeStatus for the DoIP service 0x4003
    according to ISO 13400-2:2012.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-POWER-MODE-STATUS-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DoIpPowerModeStatusNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DoIpPowerModeStatusNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DoIpRoutingActivation:
    """This meta-class defines a DoIP routing activation possibility that activates
    the routing to the referenced doIPTargetAddress.

    This means that the diagnostic request messages related to the
    specified doIPTargetAddress received by socketConnections that are
    referenced by the same DoIpInterface that aggregates this
    DoIpRoutingActivation are activated.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar do_ip_target_address_refs: Reference to DoIPTargetAddress
        which is activated on this DoIpRoutingActivation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-ROUTING-ACTIVATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DoIpRoutingActivation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DoIpRoutingActivation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    do_ip_target_address_refs: Optional["DoIpRoutingActivation.DoIpTargetAddressRefs"] = field(
        default=None,
        metadata={
            "name": "DO-IP-TARGET-ADDRESS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DoIpTargetAddressRefs:
        do_ip_target_address_ref: list[
            "DoIpRoutingActivation.DoIpTargetAddressRefs.DoIpTargetAddressRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-TARGET-ADDRESS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DoIpTargetAddressRef(Ref):
            dest: DoIpLogicTargetAddressPropsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DoIpRoutingActivationAuthenticationNeeds:
    """
    DoIPRoutingActivationAuthenticationNeeds indicates that the software-component
    owning this ServiceNeeds will have an authentication required for a DoIP
    routing activation service (0x0005) according to ISO 13400-2:2012.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar data_length_request: Describes the length in byte of the
        additional information for RA authentication that is needed by
        the software entity. If the software entity is a software-
        component the attribute does not need to exist as the
        information is available via the length of the uint8 Array type.
        Otherwise (i.e the  software entity is a Complex Driver) this
        attribute needs to be filled out if additional information is
        needed.
    :ivar data_length_response: Describes the length in byte of the
        additional information for RA authentication that is provided by
        the software entity. If the software entity is a software-
        component the attribute does not need to exist as the
        information is available via the length of the uint8 Array type.
        Otherwise (i.e the  software entity is a Complex Driver) this
        attribute needs to be filled in if additional information is
        provided.
    :ivar routing_activation_type: Describes the ISO 13400-2:2012
        "routing activation request activation type" which is received
        via DoIP service 0x0005. 0x00 is DEFAULT, 0x01 is WWH-OBD. If
        neither of the specified values (0x00 or 0x01) is needed the
        token shall contain RA_ + hex value representation of the
        integer value shall be used (i.e: RA_0xE1).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-ROUTING-ACTIVATION-AUTHENTICATION-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "DoIpRoutingActivationAuthenticationNeeds.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DoIpRoutingActivationAuthenticationNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_length_request: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-LENGTH-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_length_response: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-LENGTH-RESPONSE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    routing_activation_type: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "ROUTING-ACTIVATION-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DoIpRoutingActivationConfirmationNeeds:
    """
    DoIpRoutingActivationConfirmationNeeds indicates that the software-component
    that owns this ServiceNeeds will have a confirmation required for a DoIP
    routing activation service (0x0005) according to ISO 13400-2:2012.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar data_length_request: Describes the length in byte of the
        additional information for RA confirmation that is needed by the
        software entity. If the software entity is a software-component
        the attribute does not need to exist as the information is
        available via the length of the uint8 Array type. Otherwise (i.e
        the  software entity is a Complex Driver) this attribute needs
        to be filled out if additional information is needed.
    :ivar data_length_response: Describes the length in byte of the
        additional information for RA confirmation that is provided by
        the software entity. If the software entity is a software-
        component the attribute does not need to exist as the
        information is available via the length of the uint8 Array type.
        Otherwise (i.e the  software entity is a Complex Driver) this
        attribute needs to be filled out if additional information is
        provided.
    :ivar routing_activation_type: Describes the ISO 13400-2:2012
        "routing activation request activation type" which is received
        via DoIP service 0x0005. 0x00 is DEFAULT, 0x01 is WWH-OBD. If
        neither of the specified values (0x00 or 0x01) is needed the
        token shall contain RA_ + hex value representation of the
        integer value shall be used (i.e: RA_0xE1).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-ROUTING-ACTIVATION-CONFIRMATION-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DoIpRoutingActivationConfirmationNeeds.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DoIpRoutingActivationConfirmationNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_length_request: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-LENGTH-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_length_response: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-LENGTH-RESPONSE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    routing_activation_type: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "ROUTING-ACTIVATION-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DocumentElementScope:
    """Specifies if a specification element such as a requirement, specification,
    deliverable, artifact, task definition or activity is in scope of this data
    exchange point.

    The DocumentElementScope may reference all specification elements
    that have a name or ID. The only exception are Meta Classes, Meta
    Attribute and constraints which are handled in the Data Format
    Tailoring section of the Profile of Data Exchange Point. Elements of
    Autosar specification documents are referenced via their ID
    (requirement, specification items) or name (deliverable, artifact,
    task definition or activity)

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alternative_name: Alternative name of a specification element
        if its name doesn't fit into the shortName. E.g. because the
        name contains spaces.
    :ivar in_scope: indicates, if a specification element is relevant
        for this data exchange point. It is relevant if inScope==true.
        It is not relevant or don't care if inScope=false.
    :ivar custom_document_element_ref: Reference to a custom defined
        specification element.
    :ivar tailoring_refs: Data Format Element that is implied by this
        element in the specification. Used to share one rationale for
        more tailorings.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DOCUMENT-ELEMENT-SCOPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DocumentElementScope.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DocumentElementScope.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alternative_name: String | None = field(
        default=None,
        metadata={
            "name": "ALTERNATIVE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    in_scope: Boolean | None = field(
        default=None,
        metadata={
            "name": "IN-SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    custom_document_element_ref: Optional["DocumentElementScope.CustomDocumentElementRef"] = field(
        default=None,
        metadata={
            "name": "CUSTOM-DOCUMENT-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tailoring_refs: Optional["DocumentElementScope.TailoringRefs"] = field(
        default=None,
        metadata={
            "name": "TAILORING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CustomDocumentElementRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TailoringRefs:
        tailoring_ref: list["DocumentElementScope.TailoringRefs.TailoringRef"] = field(
            default_factory=list,
            metadata={
                "name": "TAILORING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TailoringRef(Ref):
            dest: DataFormatElementReferenceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DtcStatusChangeNotificationNeeds:
    """
    This meta-class represents the needs of a software-component interested to get
    information regarding any DTC status change.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar dtc_format_type: This attribute specifies the DTC format.
    :ivar notification_time: This attribute determines the time when the
        notification about the DTC operation shall be executed. This
        attribute is only relevant for the configuration of the
        ClearDtcNotification.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DTC-STATUS-CHANGE-NOTIFICATION-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DtcStatusChangeNotificationNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DtcStatusChangeNotificationNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DtcStatusChangeNotificationNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_format_type: DtcFormatTypeEnum | None = field(
        default=None,
        metadata={
            "name": "DTC-FORMAT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    notification_time: DiagnosticClearDtcNotificationEnum | None = field(
        default=None,
        metadata={
            "name": "NOTIFICATION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DynamicPart:
    """Dynamic part of a multiplexed I-Pdu.

    Reserved space which is used to transport varying SignalIPdus at the
    same position, controlled by the corresponding selectorFieldCode.

    :ivar segment_positions: The StaticPart and the DynamicPart can be
        separated in multiple segments within the multiplexed PDU.
        Therefore the StaticPart and the DynamicPart can contain
        multiple SegmentPositions.
    :ivar dynamic_part_alternatives: Com IPdu alternatives that are
        transmitted  in the Dynamic Part of the MultiplexedIPdu.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        MultiplexedIPdu.dynamicPart
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DYNAMIC-PART"

    segment_positions: Optional["DynamicPart.SegmentPositions"] = field(
        default=None,
        metadata={
            "name": "SEGMENT-POSITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_part_alternatives: Optional["DynamicPart.DynamicPartAlternatives"] = field(
        default=None,
        metadata={
            "name": "DYNAMIC-PART-ALTERNATIVES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SegmentPositions:
        segment_position: list[SegmentPosition] = field(
            default_factory=list,
            metadata={
                "name": "SEGMENT-POSITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DynamicPartAlternatives:
        dynamic_part_alternative: list[DynamicPartAlternative] = field(
            default_factory=list,
            metadata={
                "name": "DYNAMIC-PART-ALTERNATIVE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class E2EProfileCompatibilityProps:
    """
    This meta-class collects settings for configuration of the E2E state machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar transit_to_invalid_extended: E2E State machine behavior
        concerning transition from NODATA/INIT to INVALID value=0
        (false): no direct transition from NODATA to INVALID, no
        transition from INIT to INVALID due to counter-related faults
        (Autosar R19-11 or former behavior) value=1 (true): direct
        transition from NODATA to INVALID covered, transition from INIT
        to INVALID due to counter-related faults covered (state machine
        extended)
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "E-2-E-PROFILE-COMPATIBILITY-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["E2EProfileCompatibilityProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["E2EProfileCompatibilityProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transit_to_invalid_extended: Boolean | None = field(
        default=None,
        metadata={
            "name": "TRANSIT-TO-INVALID-EXTENDED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class E2EProfileConfiguration:
    """
    This element holds E2E profile specific configuration settings.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar clear_from_valid_to_invalid: Clear monitoring window on
        transition from state Valid to state Invalid.
    :ivar data_id_mode: This attribute describes the inclusion mode that
        is used to include the implicit Data ID in the one-byte CRC.
    :ivar e_2_e_profile_compatibility_props_ref: Reference to additional
        settings for the E2E state machine.
    :ivar max_delta_counter: Maximum allowed difference between two
        counter values of two consecutively received valid messages. For
        example, if the receiver gets data with counter 1 and
        MaxDeltaCounter is 3, then at the next reception the receiver
        can accept Counters with values 2, 3 or 4.
    :ivar max_error_state_init: Maximal number of checks in which
        ProfileStatus equal to E2E_P_ERROR was determined, within the
        last WindowSize checks, for the state E2E_SM_INIT.
    :ivar max_error_state_invalid: Maximal number of checks in which
        ProfileStatus equal to E2E_P_ERROR was determined, within the
        last WindowSize checks, for the state E2E_SM_INVALID.
    :ivar max_error_state_valid: Maximal number of checks in which
        ProfileStatus equal to E2E_P_ERROR was determined, within the
        last WindowSize checks, for the state E2E_SM_VALID.
    :ivar min_ok_state_init: Minimal number of checks in which
        ProfileStatus equal to E2E_P_OK was determined, within the last
        WindowSize checks, for the state E2E_SM_INIT.
    :ivar min_ok_state_invalid: Minimal number of checks in which
        ProfileStatus equal to E2E_P_OK was determined, within the last
        WindowSize checks, for the state E2E_SM_INVALID.
    :ivar min_ok_state_valid: Minimal number of checks in which
        ProfileStatus equal to E2E_P_OK was determined, within the last
        WindowSize checks, for the state E2E_SM_VALID.
    :ivar profile_name: Definition of the E2E profile.
    :ivar window_size_init: Size of the monitoring window of state Init
        for the E2E state machine.
    :ivar window_size_invalid: Size of the monitoring window of state
        Invalid for the E2E state machine.
    :ivar window_size_valid: Size of the monitoring window of state
        Valid for the E2E state machine.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "E-2-E-PROFILE-CONFIGURATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["E2EProfileConfiguration.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["E2EProfileConfiguration.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clear_from_valid_to_invalid: Boolean | None = field(
        default=None,
        metadata={
            "name": "CLEAR-FROM-VALID-TO-INVALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_id_mode: DataIdModeEnum | None = field(
        default=None,
        metadata={
            "name": "DATA-ID-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_profile_compatibility_props_ref: Optional[
        "E2EProfileConfiguration.E2EProfileCompatibilityPropsRef"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-PROFILE-COMPATIBILITY-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_delta_counter: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-DELTA-COUNTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_error_state_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-ERROR-STATE-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_error_state_invalid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-ERROR-STATE-INVALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_error_state_valid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-ERROR-STATE-VALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_ok_state_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-OK-STATE-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_ok_state_invalid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-OK-STATE-INVALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_ok_state_valid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-OK-STATE-VALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    profile_name: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "PROFILE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    window_size_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "WINDOW-SIZE-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    window_size_invalid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "WINDOW-SIZE-INVALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    window_size_valid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "WINDOW-SIZE-VALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EProfileCompatibilityPropsRef(Ref):
        dest: E2EProfileCompatibilityPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EcuInstanceProps:
    """
    This element describes additional properties of the EcuInstance that may vary
    in different Variants of the Ecu.

    :ivar diagnostic_address: An ECU specific ID for responses of
        diagnostic routines.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EcuInstance.ecuInstanceProps
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECU-INSTANCE-PROPS"

    diagnostic_address: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EcuInstanceRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar ecu_instance_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECU-INSTANCE-REF-CONDITIONAL"

    ecu_instance_ref: Optional["EcuInstanceRefConditional.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EcuMapping:
    """
    ECUMapping allows to assign an ECU hardware type (defined in the ECU Resource
    Template) to an ECUInstance used in a physical topology.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar comm_controller_mappings: The ECUMapping contains the mapping
        of all CommunicationControllers of the ECU.
    :ivar ecu_instance_ref: Reference to the EcuInstance in the System
        Template
    :ivar ecu_ref: Reference to a HwElement of category ECU in the ECU
        Resource Template.
    :ivar hw_port_mappings: The ECUMapping contains the mapping of all
        HW Communication Ports of the ECU.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.ecuResourceMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECU-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcuMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcuMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_controller_mappings: Optional["EcuMapping.CommControllerMappings"] = field(
        default=None,
        metadata={
            "name": "COMM-CONTROLLER-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["EcuMapping.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_ref: Optional["EcuMapping.EcuRef"] = field(
        default=None,
        metadata={
            "name": "ECU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_port_mappings: Optional["EcuMapping.HwPortMappings"] = field(
        default=None,
        metadata={
            "name": "HW-PORT-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommControllerMappings:
        communication_controller_mapping: list[CommunicationControllerMapping] = field(
            default_factory=list,
            metadata={
                "name": "COMMUNICATION-CONTROLLER-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class HwPortMappings:
        hw_port_mapping: list[HwPortMapping] = field(
            default_factory=list,
            metadata={
                "name": "HW-PORT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcuPartition:
    """Partitions are used as error containment regions.

    They permit the grouping of SWCs and resources and allow to describe
    recovery policies individually for each partition. Partitions can be
    terminated or restarted during run-time as a result of a detected
    error.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar exec_in_user_mode: A partition can execute either in CPU user
        mode (execInUserMode = TRUE) or supervisor mode (execInUserMode
        = FALSE). In user mode, the partition has a limited access to
        memory, to memory mapped hardware and to CPU. In user mode, the
        partition is mapped to a non-trusted OS-Application.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECU-PARTITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcuPartition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcuPartition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exec_in_user_mode: Boolean | None = field(
        default=None,
        metadata={
            "name": "EXEC-IN-USER-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcuStateMgrUserNeeds:
    """Specifies the abstract needs on the configuration of the ECU State  Manager
    for one "user".

    This class currently contains no attributes. Its name can be
    regarded as a symbol identifying the user  from the viewpoint of the
    component or module which owns this class.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECU-STATE-MGR-USER-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcuStateMgrUserNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcuStateMgrUserNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucAddInfoParamValue:
    """
    This parameter corresponds to EcucAddInfoParamDef.

    :ivar index: Used to support the specification of ordering of
        parameter values.
    :ivar definition_ref: Reference to the definition of this
        EcucParameterValue subclasses in the ECU Configuration Parameter
        Definition.
    :ivar annotations: Possibility to provide additional notes while
        defining the ECU Configuration Parameter Values. These are not
        intended as documentation but are mere design notes.
    :ivar is_auto_value: If withAuto is set to "true" for this parameter
        definition the isAutoValue can be set to "true". If isAutoValue
        is set to "true" the actual value will not be considered during
        ECU Configuration but will be (re-)calculated by the code
        generator and stored in the value attribute afterwards. These
        implicit updated values might require a re-generation of other
        modules which reference these values. If isAutoValue is not
        present the default is "false".
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EcucContainerValue.parameterValue
    :ivar value: Holds the content of the formated text.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-ADD-INFO-PARAM-VALUE"

    index: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    definition_ref: Optional["EcucAddInfoParamValue.DefinitionRef"] = field(
        default=None,
        metadata={
            "name": "DEFINITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucAddInfoParamValue.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_auto_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-AUTO-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DefinitionRef(Ref):
        dest: EcucParameterDefSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucDefinitionCollection:
    """
    This represents the anchor point of an ECU Configuration Parameter Definition
    within the AUTOSAR templates structure.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar module_refs: References to  the module definitions of
        individual software modules.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-DEFINITION-COLLECTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucDefinitionCollection.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucDefinitionCollection.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["EcucDefinitionCollection.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    module_refs: Optional["EcucDefinitionCollection.ModuleRefs"] = field(
        default=None,
        metadata={
            "name": "MODULE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModuleRefs:
        module_ref: list["EcucDefinitionCollection.ModuleRefs.ModuleRef"] = field(
            default_factory=list,
            metadata={
                "name": "MODULE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ModuleRef(Ref):
            dest: EcucModuleDefSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class EcucFunctionNameDefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar default_value: Default value of the string configuration
        parameter.
    :ivar max_length: Max length allowed for this string.
    :ivar min_length: Min length allowed for this string.
    :ivar regular_expression: This represents the regular expression
        which shall be used to validate the string parameter value.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-FUNCTION-NAME-DEF-CONDITIONAL"

    default_value: VerbatimString | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    regular_expression: RegularExpression | None = field(
        default=None,
        metadata={
            "name": "REGULAR-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EcucLinkerSymbolDefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar default_value: Default value of the string configuration
        parameter.
    :ivar max_length: Max length allowed for this string.
    :ivar min_length: Min length allowed for this string.
    :ivar regular_expression: This represents the regular expression
        which shall be used to validate the string parameter value.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-LINKER-SYMBOL-DEF-CONDITIONAL"

    default_value: VerbatimString | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    regular_expression: RegularExpression | None = field(
        default=None,
        metadata={
            "name": "REGULAR-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EcucModuleConfigurationValuesRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar ecuc_module_configuration_values_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-MODULE-CONFIGURATION-VALUES-REF-CONDITIONAL"

    ecuc_module_configuration_values_ref: Optional[
        "EcucModuleConfigurationValuesRefConditional.EcucModuleConfigurationValuesRef"
    ] = field(
        default=None,
        metadata={
            "name": "ECUC-MODULE-CONFIGURATION-VALUES-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EcucModuleConfigurationValuesRef(Ref):
        dest: EcucModuleConfigurationValuesSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EcucMultilineStringParamDefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar default_value: Default value of the string configuration
        parameter.
    :ivar max_length: Max length allowed for this string.
    :ivar min_length: Min length allowed for this string.
    :ivar regular_expression: This represents the regular expression
        which shall be used to validate the string parameter value.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-MULTILINE-STRING-PARAM-DEF-CONDITIONAL"

    default_value: VerbatimString | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    regular_expression: RegularExpression | None = field(
        default=None,
        metadata={
            "name": "REGULAR-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EcucNumericalParamValue:
    """
    Holding the value which is subject to variant handling.

    :ivar index: Used to support the specification of ordering of
        parameter values.
    :ivar definition_ref: Reference to the definition of this
        EcucParameterValue subclasses in the ECU Configuration Parameter
        Definition.
    :ivar annotations: Possibility to provide additional notes while
        defining the ECU Configuration Parameter Values. These are not
        intended as documentation but are mere design notes.
    :ivar is_auto_value: If withAuto is set to "true" for this parameter
        definition the isAutoValue can be set to "true". If isAutoValue
        is set to "true" the actual value will not be considered during
        ECU Configuration but will be (re-)calculated by the code
        generator and stored in the value attribute afterwards. These
        implicit updated values might require a re-generation of other
        modules which reference these values. If isAutoValue is not
        present the default is "false".
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EcucContainerValue.parameterValue
    :ivar value: Value which is subject to variant handling.
        atpVariation: [RS_ECUC_00080]
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-NUMERICAL-PARAM-VALUE"

    index: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    definition_ref: Optional["EcucNumericalParamValue.DefinitionRef"] = field(
        default=None,
        metadata={
            "name": "DEFINITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucNumericalParamValue.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_auto_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-AUTO-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: NumericalValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DefinitionRef(Ref):
        dest: EcucParameterDefSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucQuery:
    """
    Defines a query to the ECUC Description.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar ecuc_query_expression: This is the EcucQuery used in the
        calculation formula or the condition formula.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-QUERY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucQuery.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucQuery.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_query_expression: EcucQueryExpression | None = field(
        default=None,
        metadata={
            "name": "ECUC-QUERY-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucReferenceValue:
    """
    Used to represent a configuration value that has a parameter definition of type
    EcucAbstractReferenceDef (used for all of its specializations excluding
    EcucInstanceReferenceDef).

    :ivar index: Used to support the specification of ordering of
        parameter values.
    :ivar definition_ref: Reference to the definition of this
        EcucAbstractReferenceValue subclasses in the ECU Configuration
        Parameter Definition.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar is_auto_value: If withAuto is set to "true" for this parameter
        definition the isAutoValue can be set to "true". If isAutoValue
        is set to "true" the actual value will not be considered during
        ECU Configuration but will be (re-)calculated by the code
        generator and stored in the value attribute afterwards. These
        implicit updated values might require a re-generation of other
        modules which reference these values. If isAutoValue is not
        present the default is "false".
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EcucContainerValue.referenceValue
    :ivar value_ref: Specifies the destination of the reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-REFERENCE-VALUE"

    index: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    definition_ref: Optional["EcucReferenceValue.DefinitionRef"] = field(
        default=None,
        metadata={
            "name": "DEFINITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucReferenceValue.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_auto_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-AUTO-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_ref: Optional["EcucReferenceValue.ValueRef"] = field(
        default=None,
        metadata={
            "name": "VALUE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DefinitionRef(Ref):
        dest: EcucAbstractReferenceDefSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueRef(Ref):
        dest: ReferrableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EcucStringParamDefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar default_value: Default value of the string configuration
        parameter.
    :ivar max_length: Max length allowed for this string.
    :ivar min_length: Min length allowed for this string.
    :ivar regular_expression: This represents the regular expression
        which shall be used to validate the string parameter value.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-STRING-PARAM-DEF-CONDITIONAL"

    default_value: VerbatimString | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    regular_expression: RegularExpression | None = field(
        default=None,
        metadata={
            "name": "REGULAR-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EcucTextualParamValue:
    """
    Holding a value which is not subject to variation.

    :ivar index: Used to support the specification of ordering of
        parameter values.
    :ivar definition_ref: Reference to the definition of this
        EcucParameterValue subclasses in the ECU Configuration Parameter
        Definition.
    :ivar annotations: Possibility to provide additional notes while
        defining the ECU Configuration Parameter Values. These are not
        intended as documentation but are mere design notes.
    :ivar is_auto_value: If withAuto is set to "true" for this parameter
        definition the isAutoValue can be set to "true". If isAutoValue
        is set to "true" the actual value will not be considered during
        ECU Configuration but will be (re-)calculated by the code
        generator and stored in the value attribute afterwards. These
        implicit updated values might require a re-generation of other
        modules which reference these values. If isAutoValue is not
        present the default is "false".
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EcucContainerValue.parameterValue
    :ivar value: Value of the parameter, not subject to variant
        handling.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-TEXTUAL-PARAM-VALUE"

    index: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    definition_ref: Optional["EcucTextualParamValue.DefinitionRef"] = field(
        default=None,
        metadata={
            "name": "DEFINITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucTextualParamValue.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_auto_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-AUTO-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: VerbatimString | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DefinitionRef(Ref):
        dest: EcucParameterDefSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class End2EndEventProtectionProps:
    """
    This element allows to protect an event or a field notifier with an E2E
    profile.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar data_ids: This represents a unique numerical identifier for
        the referenced event or field notifier that is included in the
        CRC calculation. Note: ID is used for protection against
        masquerading. The details concerning the maximum number of
        values (this information is specific for each E2E profile)
        applicable for this attribute are controlled by a semantic
        constraint that depends on the category of the
        EndToEndProtection.
    :ivar data_length: Length of payload including E2E header in bits.
    :ivar data_update_period: This attribute describes the period in
        which the applications are assumed to process E2E-protected
        messages. The middleware does not use this attribute at all.
    :ivar e_2_e_profile_configuration_ref: Reference to E2E profile
        configuration settings that are valid to protect the referenced
        event or field notifier.
    :ivar event_ref: Reference to an event that is protected by the E2E
        profile.
    :ivar max_data_length: Maximum length of payload including E2E
        header in bits.
    :ivar min_data_length: Minimum length of payload including E2E
        header in bits.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "END-2-END-EVENT-PROTECTION-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["End2EndEventProtectionProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["End2EndEventProtectionProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_ids: Optional["End2EndEventProtectionProps.DataIds"] = field(
        default=None,
        metadata={
            "name": "DATA-IDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_update_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DATA-UPDATE-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_profile_configuration_ref: Optional[
        "End2EndEventProtectionProps.E2EProfileConfigurationRef"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-PROFILE-CONFIGURATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["End2EndEventProtectionProps.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataIds:
        data_id: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "DATA-ID",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EProfileConfigurationRef(Ref):
        dest: E2EProfileConfigurationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: ServiceEventDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class End2EndMethodProtectionProps:
    """
    This element allows to protect a method, a field setter or a field getter with
    an E2E profile.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar data_ids: This represents a numerical identifier that is
        included in the CRC calculation. This dataId is used for call
        and response. Note: ID is used for protection against
        masquerading. The details concerning the maximum number of
        values (this information is specific for each E2E profile)
        applicable for this attribute are controlled by a semantic
        constraint that depends on the category of the
        EndToEndProtection.
    :ivar data_length: Length of payload including E2E header in bits.
    :ivar data_update_period: This attribute describes the period in
        which the applications are assumed to process E2E-protected
        messages. The middleware does not use this attribute at all.
    :ivar e_2_e_profile_configuration_ref: Reference to E2E profile
        configuration settings that are valid to protect the referenced
        method, field getter or field setter.
    :ivar max_data_length: Maximum length of payload including E2E
        header in bits.
    :ivar method_ref: Reference to a method, a field getter or a field
        setter that is protected by the E2E profile.
    :ivar min_data_length: Minimum length of payload including E2E
        header in bits.
    :ivar source_id: This represents a unique numerical identifier
        identifying the source of a certain transmission. In case of C/S
        communication, this ID uniquely identifies the client. Note: ID
        is used for protection against masquerading. The details
        concerning the maximum number of values (this information is
        specific for each E2E profile) applicable for this attribute are
        controlled by a semantic constraint that depends on the category
        of the EndToEndProtection.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "END-2-END-METHOD-PROTECTION-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["End2EndMethodProtectionProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["End2EndMethodProtectionProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_ids: Optional["End2EndMethodProtectionProps.DataIds"] = field(
        default=None,
        metadata={
            "name": "DATA-IDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_update_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DATA-UPDATE-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_profile_configuration_ref: Optional[
        "End2EndMethodProtectionProps.E2EProfileConfigurationRef"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-PROFILE-CONFIGURATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_ref: Optional["End2EndMethodProtectionProps.MethodRef"] = field(
        default=None,
        metadata={
            "name": "METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SOURCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataIds:
        data_id: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "DATA-ID",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EProfileConfigurationRef(Ref):
        dest: E2EProfileConfigurationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MethodRef(Ref):
        dest: ServiceMethodDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EndToEndProtectionISignalIPdu:
    """It is possible to protect the inter-ECU data exchange of safety-related
    ISignalGroups at the level of COM IPdus using protection mechanisms provided by
    E2E Library.

    For each ISignalGroup to be protected, a separate
    EndToEndProtectionISignalIPdu element shall be created within the
    EndToEndProtectionSet. The EndToEndProtectionISignalIPdu element
    refers to the ISignalGroup that is to be protected and to the
    ISignalIPdu that transmits the protected ISignalGroup. The
    information how the referenced ISignalGroup shall be protected
    (through which E2E Profile and with which E2E settings) is defined
    in the EndToEndDescription element.

    :ivar data_offset: This attribute defines the beginning offset (in
        bits) of the Array representation of the Signal Group (including
        CRC, counter and application signal group) in the IPdu. This
        attribute is mandatory and the dataOffset shall always be
        defined.
    :ivar i_signal_group_ref: Reference to the ISignalGroup that is to
        be protected.
    :ivar i_signal_i_pdu_ref: Reference to the ISignalIPdu that
        transmits the protected ISignalGroup.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EndToEndProtection.endToEndProtectionISignalIPdu
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "END-TO-END-PROTECTION-I-SIGNAL-I-PDU"

    data_offset: Integer | None = field(
        default=None,
        metadata={
            "name": "DATA-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_group_ref: Optional["EndToEndProtectionISignalIPdu.ISignalGroupRef"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_i_pdu_ref: Optional["EndToEndProtectionISignalIPdu.ISignalIPduRef"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-I-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ISignalGroupRef(Ref):
        dest: ISignalGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalIPduRef(Ref):
        dest: ISignalIPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EndToEndProtectionVariablePrototype:
    """It is possible to protect the data exchanged between software components.

    For this purpose, for each communication to be protected,  the user defines a separate EndToEndProtection (specifying a set of protection settings) and refers to a variableDataPrototype in the role of sender and to one or many variableDataPrototypes in the role of receiver. For details, see EndToEnd Library.
    Caveat: The E2E wrapper approach involves technologies that are not subjected to the AUTOSAR standard and is superseded by the superior E2E transformer approach (which is fully standardized by AUTOSAR). Hence, new projects (without legacy constraints due to carry-over parts) shall use the fully standardized E2E transformer approach.

    :ivar receiver_irefs: This represents the receiver. Note that 1:n
        communication is supported for this use case.
    :ivar sender_iref: This represents the sender. Can be optional if an
        ecu extract is provided and the sender is part of the extract.
    :ivar short_label: This serves as part of the split key in case of
        more than one EndToEndProtectionVariablePrototype is aggregated
        in the bound model.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EndToEndProtection.endToEndProtectionVariablePrototype
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "END-TO-END-PROTECTION-VARIABLE-PROTOTYPE"

    receiver_irefs: Optional["EndToEndProtectionVariablePrototype.ReceiverIrefs"] = field(
        default=None,
        metadata={
            "name": "RECEIVER-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sender_iref: VariableDataPrototypeInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SENDER-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ReceiverIrefs:
        receiver_iref: list[VariableDataPrototypeInSystemInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "RECEIVER-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EndToEndTransformationComSpecProps:
    """
    The class EndToEndTransformationIComSpecProps specifies port specific
    configuration properties for EndToEnd transformer attributes.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar clear_from_valid_to_invalid: Clear monitoring window on
        transition from state Valid to state Invalid.
    :ivar disable_end_to_end_check: Disables/Enables the E2E check. The
        E2Eheader is removed from the payload independent from the
        setting of this attribute.
    :ivar disable_end_to_end_state_machine: Disables the E2EStateMachine
        (only E2E check functionality is performed)
    :ivar e_2_e_profile_compatibility_props_ref: Reference to additional
        settings for the E2E state machine.
    :ivar max_delta_counter: Maximum allowed difference between two
        counter values of two consecutively received valid messages. For
        example, if the receiver gets data with counter 1 and
        MaxDeltaCounter is 3, then at the next reception the receiver
        can accept Counters with values 2, 3 or 4.
    :ivar max_error_state_init: Maximal number of checks in which
        ProfileStatus equal to E2E_P_ERROR was determined, within the
        last WindowSize checks, for the state E2E_SM_INIT. The minimum
        value is 0.
    :ivar max_error_state_invalid: Maximal number of checks in which
        ProfileStatus equal to E2E_P_ERROR was determined, within the
        last WindowSize checks, for the state E2E_SM_INVALID. The
        minimum value is 0.
    :ivar max_error_state_valid: Maximal number of checks in which
        ProfileStatus equal to E2E_P_ERROR was determined, within the
        last WindowSize checks, for the state E2E_SM_VALID. The minimum
        value is 0.
    :ivar max_no_new_or_repeated_data: EndToEndTransformationDescription
        holds these attributes which are profile specific and have the
        same value for all E2E transformers.
    :ivar min_ok_state_init: Minimal number of checks in which
        ProfileStatus equal to E2E_P_OK was determined, within the last
        WindowSize checks, for the state E2E_SM_INIT. The minimum value
        is 1.
    :ivar min_ok_state_invalid: Minimal number of checks in which
        ProfileStatus equal to E2E_P_OK was determined, within the last
        WindowSize checks, for the state E2E_SM_INVALID. The minimum
        value is 1.
    :ivar min_ok_state_valid: Minimal number of checks in which
        ProfileStatus equal to E2E_P_OK was determined, within the last
        WindowSize checks, for the state E2E_SM_VALID. The minimum value
        is 1.
    :ivar sync_counter_init: EndToEndTransformationDescription holds
        these attributes which are profile specific and have the same
        value for all E2E transformers.
    :ivar window_size: Size of the monitoring window for the E2E state
        machine. The meaning is the number of correct cycles (E2E_P_OK)
        that are required in E2E_SM_INITCOM before the transition to
        E2E_SM_VALID. The minimum allowed value is 1.
    :ivar window_size_init: Size of the monitoring window of state Init
        for the E2E state machine.
    :ivar window_size_invalid: Size of the monitoring window of state
        Invalid for the E2E state machine.
    :ivar window_size_valid: Size of the monitoring window of state
        Valid for the E2E state machine.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "END-TO-END-TRANSFORMATION-COM-SPEC-PROPS"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clear_from_valid_to_invalid: Boolean | None = field(
        default=None,
        metadata={
            "name": "CLEAR-FROM-VALID-TO-INVALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disable_end_to_end_check: Boolean | None = field(
        default=None,
        metadata={
            "name": "DISABLE-END-TO-END-CHECK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disable_end_to_end_state_machine: Boolean | None = field(
        default=None,
        metadata={
            "name": "DISABLE-END-TO-END-STATE-MACHINE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_profile_compatibility_props_ref: Optional[
        "EndToEndTransformationComSpecProps.E2EProfileCompatibilityPropsRef"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-PROFILE-COMPATIBILITY-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_delta_counter: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-DELTA-COUNTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_error_state_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-ERROR-STATE-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_error_state_invalid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-ERROR-STATE-INVALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_error_state_valid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-ERROR-STATE-VALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_no_new_or_repeated_data: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NO-NEW-OR-REPEATED-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_ok_state_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-OK-STATE-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_ok_state_invalid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-OK-STATE-INVALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_ok_state_valid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-OK-STATE-VALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_counter_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SYNC-COUNTER-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    window_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "WINDOW-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    window_size_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "WINDOW-SIZE-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    window_size_invalid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "WINDOW-SIZE-INVALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    window_size_valid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "WINDOW-SIZE-VALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class E2EProfileCompatibilityPropsRef(Ref):
        dest: E2EProfileCompatibilityPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EndToEndTransformationDescription:
    """
    EndToEndTransformationDescription holds these attributes which are profile
    specific and have the same value for all E2E transformers.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TransformationTechnology.transformationDescription
    :ivar clear_from_valid_to_invalid: Clear monitoring window on
        transition from state Valid to state Invalid.
    :ivar counter_offset: Offset of the counter in the Data[] array in
        bits.
    :ivar crc_offset: Offset of the CRC in the Data[] array in bits.
    :ivar data_id_mode: This attribute describes the inclusion mode that
        is used to include the implicit two-byte Data ID in the one-byte
        CRC.
    :ivar data_id_nibble_offset: Offset of the Data ID nibble in the
        Data[] array in bits.
    :ivar e_2_e_profile_compatibility_props_ref: Reference to additional
        settings for the E2E state machine.
    :ivar max_delta_counter: Maximum allowed difference between two
        counter values of two consecutively received valid messages. For
        example, if the receiver gets data with counter 1 and
        MaxDeltaCounter is 3, then at the next reception the receiver
        can accept Counters with values 2, 3 or 4.
    :ivar max_error_state_init: Maximal number of checks in which
        ProfileStatus equal to E2E_P_ERROR was determined, within the
        last WindowSize checks, for the state E2E_SM_INIT.
    :ivar max_error_state_invalid: Maximal number of checks in which
        ProfileStatus equal to E2E_P_ERROR was determined, within the
        last WindowSize checks, for the state E2E_SM_INVALID.
    :ivar max_error_state_valid: Maximal number of checks in which
        ProfileStatus equal to E2E_P_ERROR was determined, within the
        last WindowSize checks, for the state E2E_SM_VALID.
    :ivar max_no_new_or_repeated_data: The maximum allowed amount of
        consecutive failed counter checks.
    :ivar min_ok_state_init: Minimal number of checks in which
        ProfileStatus equal to E2E_P_OK was determined, within the last
        WindowSize checks, for the state E2E_SM_INIT.
    :ivar min_ok_state_invalid: Minimal number of checks in which
        ProfileStatus equal to E2E_P_OK was determined, within the last
        WindowSize checks, for the state E2E_SM_INVALID.
    :ivar min_ok_state_valid: Minimal number of checks in which
        ProfileStatus equal to E2E_P_OK was determined, within the last
        WindowSize checks, for the state E2E_SM_VALID.
    :ivar offset: Offset of the E2E header in the Data[] array in bits.
    :ivar profile_behavior: Behavior of the check functionality
    :ivar profile_name: Definition of the E2E profile.
    :ivar sync_counter_init: Number of checks required for validating
        the consistency of the counter that shall be received with a
        valid counter (i.e. counter within the allowed lock-in range)
        after the detection of an unexpected behavior of a received
        counter.
    :ivar upper_header_bits_to_shift: This attribute describes the
        number of upper-header bits to be shifted. value = 0 or not
        present: shift of upper header is NOT performed. value &gt; 0:
        the E2E Transformer on the protect-side, takes the first
        upperHeaderBitsToShift bits from the upper buffer (e.g. SOME/IP
        header part generated by SOME/IP transformer) and shifts them
        towards the lower bytes and bits within the Data[] for the
        length of the E2E header (e.g. 12 bytes in case of E2E Profile
        4). This means the shift distance is fixed - it depends on the
        E2E header size - what is configured here is the number of bits
        that are to be shifted. This option is defined because the
        Some/IP header generated by SOME/IP transformer shall be, due to
        compatibility between non-protected and E2E-protected
        communication, at the same position, which is before E2E header.
    :ivar window_size: Size of the monitoring window for the E2E state
        machine.
    :ivar window_size_init: Size of the monitoring window of state Init
        for the E2E state machine.
    :ivar window_size_invalid: Size of the monitoring window of state
        Invalid for the E2E state machine.
    :ivar window_size_valid: Size of the monitoring window of state
        Valid for the E2E state machine.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "END-TO-END-TRANSFORMATION-DESCRIPTION"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clear_from_valid_to_invalid: Boolean | None = field(
        default=None,
        metadata={
            "name": "CLEAR-FROM-VALID-TO-INVALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    counter_offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "COUNTER-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crc_offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CRC-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_id_mode: DataIdModeEnum | None = field(
        default=None,
        metadata={
            "name": "DATA-ID-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_id_nibble_offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-ID-NIBBLE-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_profile_compatibility_props_ref: Optional[
        "EndToEndTransformationDescription.E2EProfileCompatibilityPropsRef"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-PROFILE-COMPATIBILITY-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_delta_counter: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-DELTA-COUNTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_error_state_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-ERROR-STATE-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_error_state_invalid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-ERROR-STATE-INVALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_error_state_valid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-ERROR-STATE-VALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_no_new_or_repeated_data: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NO-NEW-OR-REPEATED-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_ok_state_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-OK-STATE-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_ok_state_invalid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-OK-STATE-INVALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_ok_state_valid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-OK-STATE-VALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    profile_behavior: EndToEndProfileBehaviorEnum | None = field(
        default=None,
        metadata={
            "name": "PROFILE-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    profile_name: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "PROFILE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_counter_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SYNC-COUNTER-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_header_bits_to_shift: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UPPER-HEADER-BITS-TO-SHIFT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    window_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "WINDOW-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    window_size_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "WINDOW-SIZE-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    window_size_invalid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "WINDOW-SIZE-INVALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    window_size_valid: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "WINDOW-SIZE-VALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class E2EProfileCompatibilityPropsRef(Ref):
        dest: E2EProfileCompatibilityPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EndToEndTransformationISignalPropsConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar cs_error_reaction: Defines whether the transformer chain of
        client/server communication coordinates an autonomous error
        reaction together with the RTE or whether any error reaction is
        the responsibility of the application.
    :ivar data_prototype_transformation_propss: Fine granular modeling
        of TransfromationProps on the level of DataPrototypes.
    :ivar transformer_ref: Reference to the TransformationTechnology
        description that contains transformer specific and ISignal
        independent configuration properties.
    :ivar data_ids: This represents a unique numerical identifier. Note:
        ID is used for protection against masquerading. The details
        concerning the maximum number of values (this information is
        specific for each E2E profile) applicable for this attribute are
        controlled by a semantic constraint that depends on the category
        of the EndToEndProtection.
    :ivar data_length: Length of payload and E2E header in bits.
    :ivar max_data_length: Maximum length of payload and E2E header in
        bits.
    :ivar min_data_length: Minimum length of payload and E2E header in
        bits.
    :ivar source_id: This attribute represents a unique numerical
        identifier identifying the source of a certain transmission. In
        case of C/S communication, this ID uniquely identifies the
        client. Note: ID is used for protection against masquerading.
        The details concerning the maximum number of values (this
        information is specific for each E2E profile) applicable for
        this attribute are controlled by a semantic constraint that
        depends on the category of the EndToEndProtection.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "END-TO-END-TRANSFORMATION-I-SIGNAL-PROPS-CONDITIONAL"

    cs_error_reaction: CsTransformerErrorReactionEnum | None = field(
        default=None,
        metadata={
            "name": "CS-ERROR-REACTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototype_transformation_propss: Optional[
        "EndToEndTransformationISignalPropsConditional.DataPrototypeTransformationPropss"
    ] = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-TRANSFORMATION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformer_ref: Optional["EndToEndTransformationISignalPropsConditional.TransformerRef"] = (
        field(
            default=None,
            metadata={
                "name": "TRANSFORMER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    data_ids: Optional["EndToEndTransformationISignalPropsConditional.DataIds"] = field(
        default=None,
        metadata={
            "name": "DATA-IDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SOURCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataPrototypeTransformationPropss:
        data_prototype_transformation_props: list[DataPrototypeTransformationProps] = field(
            default_factory=list,
            metadata={
                "name": "DATA-PROTOTYPE-TRANSFORMATION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TransformerRef(Ref):
        dest: TransformationTechnologySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataIds:
        data_id: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "DATA-ID",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EnumerationMappingTable:
    """This class represents an attribute value variation point for Enumeration
    attributes.

    Note that this class might be used in the extended meta-model only.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar entrys: Key-value pair mapping enumeration values to unique
        integers.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ENUMERATION-MAPPING-TABLE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EnumerationMappingTable.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EnumerationMappingTable.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    entrys: Optional["EnumerationMappingTable.Entrys"] = field(
        default=None,
        metadata={
            "name": "ENTRYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Entrys:
        entry: list[EnumerationMappingEntry] = field(
            default_factory=list,
            metadata={
                "name": "ENTRY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EocEventRef:
    """
    This is used to define a reference to an RTE or BSW Event.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar direct_successor_refs: The direct successor of an executable
        entity or a group of executable entities.
    :ivar bsw_module_instance_ref: Specifies the BSW module instance the
        BSW event is related to.
    :ivar component_iref: This association references the specific
        instance of the SW-C prototype.
    :ivar event_ref: The AbstractEvent (event) whose execution order is
        restricted by the contraint.
    :ivar successor_refs: The logical successor of an executable entity
        or a group of executable entities.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EOC-EVENT-REF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EocEventRef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EocEventRef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    direct_successor_refs: Optional["EocEventRef.DirectSuccessorRefs"] = field(
        default=None,
        metadata={
            "name": "DIRECT-SUCCESSOR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_module_instance_ref: Optional["EocEventRef.BswModuleInstanceRef"] = field(
        default=None,
        metadata={
            "name": "BSW-MODULE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_iref: ComponentInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "COMPONENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["EocEventRef.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    successor_refs: Optional["EocEventRef.SuccessorRefs"] = field(
        default=None,
        metadata={
            "name": "SUCCESSOR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DirectSuccessorRefs:
        direct_successor_ref: list["EocEventRef.DirectSuccessorRefs.DirectSuccessorRef"] = field(
            default_factory=list,
            metadata={
                "name": "DIRECT-SUCCESSOR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DirectSuccessorRef(Ref):
            dest: EocExecutableEntityRefAbstractSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class BswModuleInstanceRef(Ref):
        dest: BswImplementationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: AbstractEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SuccessorRefs:
        successor_ref: list["EocEventRef.SuccessorRefs.SuccessorRef"] = field(
            default_factory=list,
            metadata={
                "name": "SUCCESSOR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SuccessorRef(Ref):
            dest: EocExecutableEntityRefAbstractSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class EocExecutableEntityRef:
    """
    This is used to define a reference to an ExecutableEntity If the
    ExecutionOrderConstraint is defined on VFB, System or ECU level, a reference to
    the SwComponentPrototype, via the ComponentInCompositionInstanceRef, the
    referenced ExecutableEntity belongs to, shall be provided as context
    information.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar direct_successor_refs: The direct successor of an executable
        entity or a group of executable entities.
    :ivar bsw_module_instance_ref: Specifies the BSW module instance the
        BSW module entity belongs to.
    :ivar component_iref: This association references the specific
        instance of the SW-C prototype.
    :ivar executable_ref: The ExecutableEntity whose execution order is
        restricted by the contraint.
    :ivar successor_refs: The logical successor of an executable entity
        or a group of executable entities.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EOC-EXECUTABLE-ENTITY-REF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EocExecutableEntityRef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EocExecutableEntityRef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    direct_successor_refs: Optional["EocExecutableEntityRef.DirectSuccessorRefs"] = field(
        default=None,
        metadata={
            "name": "DIRECT-SUCCESSOR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_module_instance_ref: Optional["EocExecutableEntityRef.BswModuleInstanceRef"] = field(
        default=None,
        metadata={
            "name": "BSW-MODULE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_iref: ComponentInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "COMPONENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    executable_ref: Optional["EocExecutableEntityRef.ExecutableRef"] = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    successor_refs: Optional["EocExecutableEntityRef.SuccessorRefs"] = field(
        default=None,
        metadata={
            "name": "SUCCESSOR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DirectSuccessorRefs:
        direct_successor_ref: list[
            "EocExecutableEntityRef.DirectSuccessorRefs.DirectSuccessorRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIRECT-SUCCESSOR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DirectSuccessorRef(Ref):
            dest: EocExecutableEntityRefAbstractSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class BswModuleInstanceRef(Ref):
        dest: BswImplementationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutableRef(Ref):
        dest: ExecutableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SuccessorRefs:
        successor_ref: list["EocExecutableEntityRef.SuccessorRefs.SuccessorRef"] = field(
            default_factory=list,
            metadata={
                "name": "SUCCESSOR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SuccessorRef(Ref):
            dest: EocExecutableEntityRefAbstractSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class EocExecutableEntityRefGroup:
    """
    This is used to specify a group (composite) consisting of Execution Order
    Constraint Executable Entity References (leaves) and/or further Execution Order
    Constraint Executable Entity Reference Groups (composite).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar direct_successor_refs: The direct successor of an executable
        entity or a group of executable entities.
    :ivar let_interval_refs: This association references the
        TimingDescriptionEventChain that plays the role of a LET
        interval the executable entities in the group are assigned to.
    :ivar max_cycles: In case of a Repetitive Execution Order Constraint
        this attribute specifies the number of cycles the Execution
        Order Constraint is considering.
    :ivar max_slots: In case of a Repetitive Execution Order Constraint
        this attribute specifies the number of slots every cycle of the
        Execution Order Constraint is consisting of.
    :ivar nested_element_refs: This association is used to establish
        hierarchies of EOCEER Groups and References.
    :ivar successor_refs: The logical successor of an executable entity
        or a group of executable entities.
    :ivar triggering_event_ref: In case of a Repetitive Execution Order
        Constraint this association references the timing description
        event triggering every cycle.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EOC-EXECUTABLE-ENTITY-REF-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EocExecutableEntityRefGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EocExecutableEntityRefGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    direct_successor_refs: Optional["EocExecutableEntityRefGroup.DirectSuccessorRefs"] = field(
        default=None,
        metadata={
            "name": "DIRECT-SUCCESSOR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    let_interval_refs: Optional["EocExecutableEntityRefGroup.LetIntervalRefs"] = field(
        default=None,
        metadata={
            "name": "LET-INTERVAL-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_cycles: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-CYCLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_slots: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-SLOTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nested_element_refs: Optional["EocExecutableEntityRefGroup.NestedElementRefs"] = field(
        default=None,
        metadata={
            "name": "NESTED-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    successor_refs: Optional["EocExecutableEntityRefGroup.SuccessorRefs"] = field(
        default=None,
        metadata={
            "name": "SUCCESSOR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    triggering_event_ref: Optional["EocExecutableEntityRefGroup.TriggeringEventRef"] = field(
        default=None,
        metadata={
            "name": "TRIGGERING-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DirectSuccessorRefs:
        direct_successor_ref: list[
            "EocExecutableEntityRefGroup.DirectSuccessorRefs.DirectSuccessorRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIRECT-SUCCESSOR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DirectSuccessorRef(Ref):
            dest: EocExecutableEntityRefAbstractSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class LetIntervalRefs:
        let_interval_ref: list["EocExecutableEntityRefGroup.LetIntervalRefs.LetIntervalRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "LET-INTERVAL-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class LetIntervalRef(Ref):
            dest: TimingDescriptionEventChainSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class NestedElementRefs:
        nested_element_ref: list[
            "EocExecutableEntityRefGroup.NestedElementRefs.NestedElementRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "NESTED-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class NestedElementRef(Ref):
            dest: EocExecutableEntityRefAbstractSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SuccessorRefs:
        successor_ref: list["EocExecutableEntityRefGroup.SuccessorRefs.SuccessorRef"] = field(
            default_factory=list,
            metadata={
                "name": "SUCCESSOR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SuccessorRef(Ref):
            dest: EocExecutableEntityRefAbstractSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TriggeringEventRef(Ref):
        dest: TimingDescriptionEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EthGlobalTimeDomainProps:
    """
    Enables the definition of Ethernet Global Time specific properties.

    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        GlobalTimeDomain.globalTimeDomainProperty Not Applicable for:
        GlobalTimeDomain.globalTimeDomainProps
    :ivar crc_flags: Defines the fields of the message which shall be
        taken into account for CRC calculation and verification.
    :ivar destination_physical_address: Defines the MAC multicast
        address the Ethernet time sync messages are communicated on.
    :ivar fup_data_id_lists: The DataIDList for FUP messages to
        calculate CRC.
    :ivar managed_coupling_ports: Collection of CouplingPorts which are
        managed in the scope of this Ethernet GlobalTimeDomain.
    :ivar message_compliance: Defines the compliance of the Ethernet
        time sync messages to specific standards.
    :ivar vlan_priority: Defines which VLAN priority shall be assigned
        to a time sync message in case the message is sent using a VLAN
        tag.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETH-GLOBAL-TIME-DOMAIN-PROPS"

    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crc_flags: EthTSynCrcFlags | None = field(
        default=None,
        metadata={
            "name": "CRC-FLAGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_physical_address: MacAddressString | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-PHYSICAL-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fup_data_id_lists: Optional["EthGlobalTimeDomainProps.FupDataIdLists"] = field(
        default=None,
        metadata={
            "name": "FUP-DATA-ID-LISTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    managed_coupling_ports: Optional["EthGlobalTimeDomainProps.ManagedCouplingPorts"] = field(
        default=None,
        metadata={
            "name": "MANAGED-COUPLING-PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    message_compliance: EthGlobalTimeMessageFormatEnum | None = field(
        default=None,
        metadata={
            "name": "MESSAGE-COMPLIANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vlan_priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VLAN-PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FupDataIdLists:
        fup_data_id_list: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "FUP-DATA-ID-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 16,
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ManagedCouplingPorts:
        eth_global_time_managed_coupling_port: list[EthGlobalTimeManagedCouplingPort] = field(
            default_factory=list,
            metadata={
                "name": "ETH-GLOBAL-TIME-MANAGED-COUPLING-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EthIpProps:
    """'''begin restrict to CP''' This meta-class is used to configure the
    EcuInstance specific IP attributes.

    '''end restrict to CP''' '''begin restrict to AP''' This meta-class
    is used to configure the Machine specific IP attributes. '''end
    restrict to AP'''

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar ipv_4_props: Configuration options for IPv4.
    :ivar ipv_6_props: Configuration options for IPv6.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETH-IP-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthIpProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthIpProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_4_props: Ipv4Props | None = field(
        default=None,
        metadata={
            "name": "IPV-4-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_6_props: Ipv6Props | None = field(
        default=None,
        metadata={
            "name": "IPV-6-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EthTcpIpIcmpProps:
    """
    '''begin restrict to CP''' This meta-class is used to configure the EcuInstance
    specific ICMP (Internet Control Message Protocol) attributes '''end restrict to
    CP''' '''begin restrict to AP''' This meta-class is used to configure the
    Machine specific ICMP (Internet Control Message Protocol) attributes '''end
    restrict to AP'''.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar icmp_v_4_props: ICMPv4 configuration properties
    :ivar icmp_v_6_props: ICMPv6 configuration properties
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETH-TCP-IP-ICMP-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthTcpIpIcmpProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthTcpIpIcmpProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    icmp_v_4_props: TcpIpIcmpv4Props | None = field(
        default=None,
        metadata={
            "name": "ICMP-V-4-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    icmp_v_6_props: TcpIpIcmpv6Props | None = field(
        default=None,
        metadata={
            "name": "ICMP-V-6-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EthTcpIpProps:
    """'''begin restrict to CP''' This meta-class is used to configure the
    EcuInstance specific TcpIp Stack attributes.

    '''end restrict to CP''' '''begin restrict to AP''' This meta-class
    is used to configure the Machine specific TcpIp Stack attributes.
    '''end restrict to AP'''

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar tcp_props: TCP configuration properties
    :ivar udp_props: UDP configuration properties
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETH-TCP-IP-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthTcpIpProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthTcpIpProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_props: TcpProps | None = field(
        default=None,
        metadata={
            "name": "TCP-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    udp_props: UdpProps | None = field(
        default=None,
        metadata={
            "name": "UDP-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EthTpConfig:
    """
    This element defines which PduTriggerings shall be handled using "TP"
    semantics.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_cluster_ref: A TpConfig is existing always in
        the context of exactly one CommunicationCluster.
    :ivar tp_connections: Senders and receivers of SOME/IP TP messages.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETH-TP-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthTpConfig.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthTpConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_ref: Optional["EthTpConfig.CommunicationClusterRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_connections: Optional["EthTpConfig.TpConnections"] = field(
        default=None,
        metadata={
            "name": "TP-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TpConnections:
        eth_tp_connection: list[EthTpConnection] = field(
            default_factory=list,
            metadata={
                "name": "ETH-TP-CONNECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EthernetRawDataStreamGrant:
    """
    This meta-class represents the ability to define the IAM configuration for a
    EthernetRawDataStream on deployment level.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar design_ref: This reference identifies the
        RawDataStreamGrantDesign that the enclosing
        RawDataStreamEventGrant was created from.
    :ivar ethernet_raw_data_stream_mapping_ref: This reference
        identifies the applicable EthernetRawDataStream to which the
        enclosing EthernetRawDataStreamGrant shall apply.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-RAW-DATA-STREAM-GRANT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthernetRawDataStreamGrant.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthernetRawDataStreamGrant.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    design_ref: Optional["EthernetRawDataStreamGrant.DesignRef"] = field(
        default=None,
        metadata={
            "name": "DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ethernet_raw_data_stream_mapping_ref: Optional[
        "EthernetRawDataStreamGrant.EthernetRawDataStreamMappingRef"
    ] = field(
        default=None,
        metadata={
            "name": "ETHERNET-RAW-DATA-STREAM-MAPPING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DesignRef(Ref):
        dest: RawDataStreamGrantDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EthernetRawDataStreamMappingRef(Ref):
        dest: EthernetRawDataStreamMappingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EthernetWakeupSleepOnDatalineConfig:
    """EthernetWakeupSleepOnDatalineConfigSet is the main element that aggregates
    different config set regarding the wakeup and sleep on data line.

    An EthernetWakeupSleepOnDatalineConfigSet could aggregate multiple
    different configurations regarding the wakeup and sleep on dataline
    (EthernetWakeupSleepOnDatalineConfig).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sleep_mode_execution_delay: Delay in seconds to perform a
        sleep request if the Ethernet hardware (PHY) detect a pending
        wake-up. This is used to avoid the race condition, if a sleep
        was requested while a wake-up of a neighboring PHY was received
        via a local wake-up connection (e.g. I/O pin).
    :ivar sleep_repetition_delay_of_sleep_request: Delay in seconds for
        a repetition of a sleep request. This is used to retry a
        synchronized shutdown of the connected Ethernet hardware (PHY)
        of the link partner.
    :ivar sleep_repetitions_of_sleep_request: Count of repetitions for a
        sleep on dataline. If a sleep is rejected by the linked
        communication partner, the sleep is repeated until the count of
        repetitions exceed. If count of repetitions exceed, the Ethernet
        hardware (PHY) transit to sleep without acknowledgement of the
        connected link partner.
    :ivar wakeup_forward_local_enabled: If enabled, then a remote wake-
        up received on the physical dataline (e.g. 100BASE-T1) is
        forwarded as local wake-up (e.g. via an I/O pin). If disabled,
        then a remote wake-up is not forwarded as local wake-up.
    :ivar wakeup_forward_remote_enabled: If enabled, then a local wake-
        up is forwarded to the physical dataline (e.g. 100BASE-T1). If
        disabled, then a local wake-up is not forwarded to the physical
        dataline.
    :ivar wakeup_local_detection_time: Specify the detection time if a
        local wake-up in seconds is present on the local wake-up
        connection (e.g. I/O pin). A local wake-up has to be present at
        least for wakeupLocalDetectionTime to be detected a valid local
        wake-up.
    :ivar wakeup_local_duration_time: Specify the duration of a local
        wake-up in seconds to be present on the local wake-up connection
        (e.g. I/O pin).
    :ivar wakeup_local_enabled: If enabled, then a local wake-up
        received via a local connection (e.g. I/O pin) shall be detected
        by the Ethernet hardware (PHY). If disabled, Ethernet hardware
        is not reacting on a local wake-up.
    :ivar wakeup_remote_enabled: If enabled, then a remote wake-up
        received via the physical dataline (e.g. 100BASE-T1) shall be
        detected by the Ethernet hardware (PHY). If disabled, Ethernet
        hardware is not reaction on a remote wake-up.
    :ivar wakeup_repetition_delay_of_wakeup_request: Delay in seconds
        for a repetition of a wake-up. This is used to increase the
        reliability in the network, such that an ECU which initiates the
        wake-up does repeat the wake-up and increase the probability
        that affected ECUs receive the wake-up.
    :ivar wakeup_repetitions_of_wakeup_request: Count of repetitions for
        a wake-up. This is used to increase the reliability in the
        network, such that an ECU which initiates the wake-up does
        repeat the wake-up and increase the probability that affected
        ECUs receive the wake-up.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-WAKEUP-SLEEP-ON-DATALINE-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthernetWakeupSleepOnDatalineConfig.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthernetWakeupSleepOnDatalineConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sleep_mode_execution_delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SLEEP-MODE-EXECUTION-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sleep_repetition_delay_of_sleep_request: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SLEEP-REPETITION-DELAY-OF-SLEEP-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sleep_repetitions_of_sleep_request: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SLEEP-REPETITIONS-OF-SLEEP-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_forward_local_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "WAKEUP-FORWARD-LOCAL-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_forward_remote_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "WAKEUP-FORWARD-REMOTE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_local_detection_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "WAKEUP-LOCAL-DETECTION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_local_duration_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "WAKEUP-LOCAL-DURATION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_local_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "WAKEUP-LOCAL-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_remote_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "WAKEUP-REMOTE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_repetition_delay_of_wakeup_request: TimeValue | None = field(
        default=None,
        metadata={
            "name": "WAKEUP-REPETITION-DELAY-OF-WAKEUP-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_repetitions_of_wakeup_request: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "WAKEUP-REPETITIONS-OF-WAKEUP-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EvaluatedVariantSet:
    """This meta class represents the ability to express if a set of ARElements is
    able to support one or more particular variants.

    In other words, for a given set of evaluatedElements this meta class
    represents a table of evaluated variants, where each
    PredefinedVariant represents one column. In this column each
    descendant swSystemconstantValue resp.
    postbuildVariantCriterionValue represents one entry. In a graphical
    representation each swSystemconstantValueSet /
    postBuildVariantCriterionValueSet could be used as an intermediate
    headline in the table column. If the approvalStatus is "APPROVED" it
    expresses that the collection of CollectableElements is known be
    valid for the given evaluatedVariants. Note that the
    EvaluatedVariantSet is a CollectableElement. This allows to
    establish a hierarchy of EvaluatedVariantSets.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar approval_status: Defines the approval status of a predefined
        variant. Two values are predefined: "APPROVED" and "REJECTED": *
        Approved variants are known to work. * Rejected variants are
        known NOT to work. Further values can be approved on a per-
        company basis; within AUTOSAR only "APPROVED" and "REJECTED"
        should be recognized.
    :ivar evaluated_element_refs: This represents a particular element
        which is evaluated in context of the EvaluatedVariants. The
        approvalStatus applies to this element (and all of its
        descendants). In other words, the referenced elements are those
        that were considered when the predefined variant was evaluated.
    :ivar evaluated_variant_refs: This metaclass represents one
        particular variant which was evaluated. LowerMultiplicity is set
        to 0 to support a stepwise approach.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EVALUATED-VARIANT-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EvaluatedVariantSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EvaluatedVariantSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    approval_status: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "APPROVAL-STATUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    evaluated_element_refs: Optional["EvaluatedVariantSet.EvaluatedElementRefs"] = field(
        default=None,
        metadata={
            "name": "EVALUATED-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    evaluated_variant_refs: Optional["EvaluatedVariantSet.EvaluatedVariantRefs"] = field(
        default=None,
        metadata={
            "name": "EVALUATED-VARIANT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EvaluatedElementRefs:
        evaluated_element_ref: list[
            "EvaluatedVariantSet.EvaluatedElementRefs.EvaluatedElementRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EVALUATED-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EvaluatedElementRef(Ref):
            dest: CollectableElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class EvaluatedVariantRefs:
        evaluated_variant_ref: list[
            "EvaluatedVariantSet.EvaluatedVariantRefs.EvaluatedVariantRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EVALUATED-VARIANT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EvaluatedVariantRef(Ref):
            dest: PredefinedVariantSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class EventControlledTiming:
    """Specification of a event driven sending behavior.

    The PDU is sent n (numberOfRepeat + 1) times separated by the
    repetitionPeriod. If numberOfRepeats = 0, then the Pdu is sent just
    once.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar number_of_repetitions: Defines the number of repetitions for
        the Direct/N-Times transmission mode and the event driven part
        of Mixed transmission mode.
    :ivar repetition_period: The repetitionPeriod specifies the time in
        seconds that elapses before the pdu can be sent the next time
        (Minimum repeat gap between two pdus). The repetitionPeriod is
        optional in case that no repetitions are configured.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EVENT-CONTROLLED-TIMING"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    number_of_repetitions: Integer | None = field(
        default=None,
        metadata={
            "name": "NUMBER-OF-REPETITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    repetition_period: TimeRangeType | None = field(
        default=None,
        metadata={
            "name": "REPETITION-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EventMapping:
    """
    Mapping of a VariableDataPrototype that is located in a SenderReceiverInterface
    to an Event that is located in a ServiceInterface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar data_element_ref: Reference to a VariableDataPrototype that is
        located in a SenderReceiverInterface.
    :ivar event_ref: Reference to an Event that is located in a
        ServiceInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EVENT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EventMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EventMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["EventMapping.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["EventMapping.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EventObdReadinessGroup:
    """This meta-class represents the ability to define the value of attribute
    eventObdReadinessGroup.

    It is only introduced to allow for a variant modeling of this
    attribute.

    :ivar event_obd_readiness_group: This attribute specifies the Event
        OBD Readiness group for PID $01 and PID $41 computation. This
        attribute is only applicable for emission-related ECUs.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DiagnosticTroubleCodeObd.eventReadinessGroup
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EVENT-OBD-READINESS-GROUP"

    event_obd_readiness_group: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "EVENT-OBD-READINESS-GROUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ExclusiveArea:
    """
    Prevents an executable entity running in the area from being preempted.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        InternalBehavior.exclusiveArea
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXCLUSIVE-AREA"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ExclusiveArea.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ExclusiveArea.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ExclusiveAreaNestingOrder:
    """This meta-class represents the ability to define a nesting order of
    ExclusiveAreas.

    A nesting order (that may occur in the executable code) is formally
    defined to be able to analyze the resource locking behavior.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar exclusive_area_refs: This represents a specific scenario of
        how ExclusiveAreas can be used in terms of the nesting order.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        InternalBehavior.exclusiveAreaNestingOrder
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXCLUSIVE-AREA-NESTING-ORDER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ExclusiveAreaNestingOrder.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_area_refs: Optional["ExclusiveAreaNestingOrder.ExclusiveAreaRefs"] = field(
        default=None,
        metadata={
            "name": "EXCLUSIVE-AREA-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaRefs:
        exclusive_area_ref: list["ExclusiveAreaNestingOrder.ExclusiveAreaRefs.ExclusiveAreaRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "EXCLUSIVE-AREA-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class ExclusiveAreaRef(Ref):
            dest: ExclusiveAreaSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class ExclusiveAreaRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar exclusive_area_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXCLUSIVE-AREA-REF-CONDITIONAL"

    exclusive_area_ref: Optional["ExclusiveAreaRefConditional.ExclusiveAreaRef"] = field(
        default=None,
        metadata={
            "name": "EXCLUSIVE-AREA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaRef(Ref):
        dest: ExclusiveAreaSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ExecutableLoggingImplementationProps:
    """
    This meta-class contains configuration relevant for the implementation of an
    Executable used in the context of the LogAndTraceInstantiation.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar uses_time_base_resource: This attribute indicates that the
        implementation of the enclosing Executable is required to access
        resources provided by the synchronized time base functional
        cluster.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXECUTABLE-LOGGING-IMPLEMENTATION-PROPS"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uses_time_base_resource: Boolean | None = field(
        default=None,
        metadata={
            "name": "USES-TIME-BASE-RESOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ExecutionTimeConstraint:
    """An ExecutionTimeConstraint is used to specify the execution time of the
    referenced ExecutableEntity in the referenced component.

    A minimum and maximum execution time can be defined.
    Two types of execution time semantics can be used. The desired semantics can be set by the attribute executionTimeType:
    * The "net" execution time is the time used to execute the ExecutableEntity without interruption and without external calls.
    * The "gross" execution time is the time used to execute the ExecutableEntity without interruption including external calls to other entities.
    The time to execute the ExecutableEntity including interruptions by other entities and including external calls is commonly called "response time". The TimingExtensions provide the concept of event chains and latency constraints for that purpose. An event chain from the start of the entity to the termination of the entity with according latency constraint represents a response time constraint for that executable entity.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar timing_condition_ref: A timing condition the timing constraint
        depends on. In other words it specifies the condition the timing
        constraint holds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingRequirement Applicable for:
        TimingExtension.timingGuarantee
    :ivar component_iref: The component that containts the referenced
        ExecutableEntity for the ExecutionTimeConstraint. If the entity
        is in a basic software module no component shall be provided.
    :ivar executable_ref: The referenced ExecutableEntity for the
        ExecutionTimeConstraint.
    :ivar execution_time_type: Specifies the type of the execution time
        constrained by ExecutionTimeConstraint,
    :ivar maximum: The maximum execution time.
    :ivar minimum: The minimum execution time.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXECUTION-TIME-CONSTRAINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ExecutionTimeConstraint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ExecutionTimeConstraint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["ExecutionTimeConstraint.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_condition_ref: Optional["ExecutionTimeConstraint.TimingConditionRef"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_iref: ComponentInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "COMPONENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    executable_ref: Optional["ExecutionTimeConstraint.ExecutableRef"] = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    execution_time_type: ExecutionTimeTypeEnum | None = field(
        default=None,
        metadata={
            "name": "EXECUTION-TIME-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MINIMUM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["ExecutionTimeConstraint.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimingConditionRef(Ref):
        dest: TimingConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutableRef(Ref):
        dest: ExecutableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ExternalTriggerOccurredEvent:
    """
    This event is raised when the referenced Trigger has occurred.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar trigger_iref: The referenced Trigger raises this
        ExternalTriggerOccurredEvent.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXTERNAL-TRIGGER-OCCURRED-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ExternalTriggerOccurredEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ExternalTriggerOccurredEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "ExternalTriggerOccurredEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["ExternalTriggerOccurredEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["ExternalTriggerOccurredEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_iref: RTriggerInAtomicSwcInstanceRef | None = field(
        default=None,
        metadata={
            "name": "TRIGGER-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ExternalTriggeringPointIdent:
    """
    This meta-class has been created to introduce the ability to become referenced
    into the meta-class ExternalTriggeringPoint without breaking backwards
    compatibility.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar return_value_provision: This attribute controls the provision
        of return values for RTE APIs that correspond to the enclosing
        access point.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXTERNAL-TRIGGERING-POINT-IDENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ExternalTriggeringPointIdent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ExternalTriggeringPointIdent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    return_value_provision: RteApiReturnValueProvisionEnum | None = field(
        default=None,
        metadata={
            "name": "RETURN-VALUE-PROVISION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FibexElementRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar fibex_element_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FIBEX-ELEMENT-REF-CONDITIONAL"

    fibex_element_ref: Optional["FibexElementRefConditional.FibexElementRef"] = field(
        default=None,
        metadata={
            "name": "FIBEX-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FibexElementRef(Ref):
        dest: FibexElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FieldType:
    """This meta-class represents the ability to define a piece of data that can be
    accessed with read and/or write semantics.

    It is also possible to generate a notification if the value of the
    data changes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sw_data_def_props: This property allows to specify data
        definition properties which apply on data prototype level.
    :ivar type_tref: This represents the corresponding data type.
    :ivar has_getter: This attribute controls whether read access is
        foreseen to this field.
    :ivar has_notifier: This attribute controls whether a notification
        semantics is foreseen to this field.
    :ivar has_setter: This attribute controls whether write access is
        foreseen to this field.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ServiceInterface.field
        Applicable for: ApplicationInterface.attribute
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FIELD"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FieldType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FieldType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_tref: Optional["FieldType.TypeTref"] = field(
        default=None,
        metadata={
            "name": "TYPE-TREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_getter: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-GETTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_notifier: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-NOTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_setter: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-SETTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TypeTref(Ref):
        dest: AutosarDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FieldMapping:
    """
    Mapping of a Field that is located in a ServiceInterface to
    ClientServerOperations that represent the getter and setter methods and to a
    VariableDataPrototype that represents the notifier in the Field.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar field_ref: Reference to a field that is located in a
        ServiceInterface.
    :ivar getter_operation_ref: Reference to a ClientServerOperation
        that represents the getter Method in the Field.
    :ivar notifier_data_element_ref: Reference to a
        VariableDataPrototype that represents the notifier in the Field.
    :ivar setter_operation_ref: Reference to a ClientServerOperation
        that represents the setter Method in the Field.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FIELD-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FieldMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FieldMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_ref: Optional["FieldMapping.FieldRef"] = field(
        default=None,
        metadata={
            "name": "FIELD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    getter_operation_ref: Optional["FieldMapping.GetterOperationRef"] = field(
        default=None,
        metadata={
            "name": "GETTER-OPERATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    notifier_data_element_ref: Optional["FieldMapping.NotifierDataElementRef"] = field(
        default=None,
        metadata={
            "name": "NOTIFIER-DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    setter_operation_ref: Optional["FieldMapping.SetterOperationRef"] = field(
        default=None,
        metadata={
            "name": "SETTER-OPERATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FieldRef(Ref):
        dest: FieldSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class GetterOperationRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NotifierDataElementRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SetterOperationRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FireAndForgetMethodMapping:
    """
    Mapping of a Fire&amp;Forget Method that is located in a ServiceInterface to a
    VariableDataPrototype in a SenderReceiverInterface or to a Trigger in a
    TriggerInterface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar data_element_ref: Reference to a VariableDataPrototype that is
        located in a SenderReceiverInterface in case that the
        Fire&amp;Forget Method is represented by this
        VariableDataPrototype.
    :ivar method_ref: Reference to a Fire&amp;Forget Method that is
        located in a ServiceInterface.
    :ivar trigger_ref: Reference to a Trigger that is located in a
        TriggerInterface in case that the Fire&amp;Forget Method is
        represented by this Trigger.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FIRE-AND-FORGET-METHOD-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FireAndForgetMethodMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FireAndForgetMethodMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["FireAndForgetMethodMapping.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_ref: Optional["FireAndForgetMethodMapping.MethodRef"] = field(
        default=None,
        metadata={
            "name": "METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_ref: Optional["FireAndForgetMethodMapping.TriggerRef"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MethodRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FirewallRule:
    """
    Firewall Rule that defines the control information in individual packets.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar bucket_size: This attribute defines the capacity of the queue
        for rate limitation (leaky-bucket Algorithm).
    :ivar data_link_layer_rule: Configuration of rules on the Data Link
        Layer
    :ivar dds_rule: Configuration of firewall rules for DDS.
    :ivar do_ip_rule: Configuration of firewall rules for DoIP messages
    :ivar network_layer_rule: Configuration of rules on the Network
        Layer
    :ivar payload_byte_pattern_rules: Configuration of generic firewall
        rules
    :ivar refill_amount: This attribute defines the output rate that
        describes how many packets leave the queue per second (leaky-
        bucket Algorithm).
    :ivar someip_rule: Configuration of firewall rules for SOME/IP
        messages
    :ivar someip_sd_rule: Configuration of firewall rules for SOME/IP
        Service Discovery messages
    :ivar transport_layer_rule: Configuration of rules on the Transport
        Layer
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FIREWALL-RULE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FirewallRule.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FirewallRule.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bucket_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BUCKET-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_link_layer_rule: DataLinkLayerRule | None = field(
        default=None,
        metadata={
            "name": "DATA-LINK-LAYER-RULE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dds_rule: DdsRule | None = field(
        default=None,
        metadata={
            "name": "DDS-RULE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    do_ip_rule: DoIpRule | None = field(
        default=None,
        metadata={
            "name": "DO-IP-RULE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_layer_rule: Optional["FirewallRule.NetworkLayerRule"] = field(
        default=None,
        metadata={
            "name": "NETWORK-LAYER-RULE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    payload_byte_pattern_rules: Optional["FirewallRule.PayloadBytePatternRules"] = field(
        default=None,
        metadata={
            "name": "PAYLOAD-BYTE-PATTERN-RULES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    refill_amount: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "REFILL-AMOUNT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    someip_rule: SomeipProtocolRule | None = field(
        default=None,
        metadata={
            "name": "SOMEIP-RULE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    someip_sd_rule: SomeipSdRule | None = field(
        default=None,
        metadata={
            "name": "SOMEIP-SD-RULE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transport_layer_rule: Optional["FirewallRule.TransportLayerRule"] = field(
        default=None,
        metadata={
            "name": "TRANSPORT-LAYER-RULE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NetworkLayerRule:
        ipv_4_rule: Ipv4Rule | None = field(
            default=None,
            metadata={
                "name": "IPV-4-RULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ipv_6_rule: Ipv6Rule | None = field(
            default=None,
            metadata={
                "name": "IPV-6-RULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PayloadBytePatternRules:
        payload_byte_pattern_rule: list[PayloadBytePatternRule] = field(
            default_factory=list,
            metadata={
                "name": "PAYLOAD-BYTE-PATTERN-RULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TransportLayerRule:
        tcp_rule: TcpRule | None = field(
            default=None,
            metadata={
                "name": "TCP-RULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        udp_rule: UdpRule | None = field(
            default=None,
            metadata={
                "name": "UDP-RULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayArTpNode:
    """
    TP Node (Sender or Receiver) provides the TP Address and the connection to the
    Topology description.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar connector_refs: Association  to one or more physical
        connectors (max number of connectors for FlexRay: 2). In a
        System Description this reference is mandatory. In an ECU
        Extract this reference is optional (references to ECUs that are
        not part of the ECU Extract shall be avoided).
    :ivar tp_address_ref: Reference to the TP Address that is used by
        the TpNode. This reference is optional in case that the
        multicast TP Address is used (reference from TpConnection).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        FlexrayArTpConfig.tpNode
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-AR-TP-NODE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlexrayArTpNode.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlexrayArTpNode.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    connector_refs: Optional["FlexrayArTpNode.ConnectorRefs"] = field(
        default=None,
        metadata={
            "name": "CONNECTOR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_address_ref: Optional["FlexrayArTpNode.TpAddressRef"] = field(
        default=None,
        metadata={
            "name": "TP-ADDRESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConnectorRefs:
        connector_ref: list["FlexrayArTpNode.ConnectorRefs.ConnectorRef"] = field(
            default_factory=list,
            metadata={
                "name": "CONNECTOR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ConnectorRef(Ref):
            dest: FlexrayCommunicationConnectorSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TpAddressRef(Ref):
        dest: TpAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FlexrayCommunicationControllerConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar wake_up_by_controller_supported: Defines whether the ECU shall
        be woken up by this CommunicationController. TRUE: wake up is
        possible FALSE: wake up is not supported Note: If
        wakeUpByControllerSupported is set to TRUE the feature shall be
        supported by both hardware and basic software.
    :ivar accepted_startup_range: Expanded range of measured clock
        deviation allowed for startup frames during integration.
        Unit:microtick
    :ivar allow_halt_due_to_clock: Boolean flag that controls the
        transition to the POC:halt state due to a clock synchronization
        errors. If set to true, the Communication Controller is allowed
        to transition to POC:halt. If set to false, the Communication
        Controller will not transition to the POC:halt state but will
        enter or remain in the normal POC (passive State).
    :ivar allow_passive_to_active: Number of consecutive even/odd cycle
        pairs that shall have valid clock correction terms before the
        Communication Controller will be allowed to transition from the
        POC:normal passive state to POC:normal active state. If set to
        0, the Communication Controller is not allowed to transition
        from POC:norm
    :ivar cluster_drift_damping: The cluster drift damping factor used
        in clock synchronization rate correction in microticks
    :ivar decoding_correction: Value used by the receiver to calculate
        the difference between primary time reference point and
        secondary time reference point. Unit: Microticks
        (pDecodingCorrection)
    :ivar delay_compensation_a: Value used to compensate for reception
        delays on channel A Unit: Microticks. This optional parameter
        shall only be filled out if channel A is used.
    :ivar delay_compensation_b: Value used to compensate for reception
        delays on channel B. Unit: Microticks. This optional parameter
        shall only be filled out if channel B is used.
    :ivar extern_offset_correction: Fixed amount added or subtracted to
        the calculated offset correction term to facilitate external
        offset correction, expressed in node-local microticks.
    :ivar extern_rate_correction: Fixed amount added or subtracted to
        the calculated rate correction term to facilitate external rate
        correction, expressed in node-local microticks.
    :ivar external_sync: Flag indicating whether the node is externally
        synchronized (operating as Time Gateway Sink in an TT-E Time
        Triggered External Sync cluster) or locally synchronized.
    :ivar fall_back_internal: Flag indicating whether a Time Gateway
        Sink node will switch to local clock operation when
        synchronization with the Time Gateway Source node is lost
        (pFallBackInternal = true) or will instead go to POC:ready
        (pFallBackInternal = false).
    :ivar flexray_fifos: One First In First Out (FIFO) queued receive
        structure, defining the admittance criteria to the FIFO.
    :ivar key_slot_id: ID of the slot used to transmit the startup
        frame, sync frame, or designated single slot frame. If the
        attributes keySlotUsedForStartUp, keySlotUsedForSync, or
        keySlotOnlyEnabled are set to true the key slot value is
        mandatory.
    :ivar key_slot_only_enabled: Flag indicating whether or not the node
        shall enter key slot only mode following startup.
    :ivar key_slot_used_for_start_up: Flag indicating whether the Key
        Slot is used to transmit a startup frame.
    :ivar key_slot_used_for_sync: Flag indicating whether the Key Slot
        is used to transmit a sync frame.
    :ivar latest_tx: The number of the last minislot in which a
        transmission can start in the dynamic segment for the respective
        node
    :ivar listen_timeout: Value for the startup listen timeout and
        wakeup listen timeout. Although this is a node local parameter,
        the real time equivalent of this value should be the same for
        all nodes in the cluster. Unit: Microticks
    :ivar macro_initial_offset_a: Integer number of macroticks between
        the static slot boundary and the closest macrotick boundary of
        the secondary time reference point based on the nominal
        macrotick duration. (pMacroInitialOffset). This optional
        parameter shall only be filled out if channel A is used.
    :ivar macro_initial_offset_b: Integer number of macroticks between
        the static slot boundary and the closest macrotick boundary of
        the secondary time reference point based on the nominal
        macrotick duration. (pMacroInitialOffset). This optional
        parameter shall only be filled out if channel B is used.
    :ivar maximum_dynamic_payload_length: Maximum payload length for the
        dynamic channel of a frame in 16 bit WORDS.
    :ivar micro_initial_offset_a: Number of microticks between the
        closest macrotick boundary described by gMacroInitialOffset and
        the secondary time reference point.  The parameter depends on
        pDelayCompensationA and therefore it has to be set independently
        for each channel. This optional parameter shall only be filled
        out if channel A is used.
    :ivar micro_initial_offset_b: Number of microticks between the
        closest macrotick boundary described by gMacroInitialOffset and
        the secondary time reference point.  The parameter depends on
        pDelayCompensationB and therefore it has to be set independently
        for each channel. This optional parameter shall only be filled
        out if channel B is used.
    :ivar micro_per_cycle: The nominal number of microticks in a
        communication cycle
    :ivar microtick_duration: Duration of a microtick. This attribute
        can be derived from samplePerMicrotick and gdSampleClockPeriod.
        Unit: seconds
    :ivar nm_vector_early_update: Flag indicating when the update of the
        Network Management Vector in the CHI shall take place. If set to
        false, the update shall take place after the NIT. If set to
        true, the update shall take place after the end of the static
        segment.
    :ivar offset_correction_out: Magnitude of the maximum permissible
        offset correction value. Unit:microtick (pOffsetCorrectionOut)
    :ivar rate_correction_out: Magnitude of the maximum permissible rate
        correction value and the maximum drift offset between two nodes
        operating with unsynchronized clocks for one communication
        cycle. Unit:Microticks (pRateCorrectionOut) Remarks: This
        parameter maps to FlexRay Protocol 2.1 Rev. A parameter
        pdMaxDrift.
    :ivar samples_per_microtick: Number of samples per microtick
    :ivar second_key_slot_id: ID of the second Key slot, in which a
        second startup frame shall be sent in TT-L Time Triggered Local
        Master Sync or TT-E Time Triggered External Sync mode. If this
        parameter is set to zero the node does not have a second key
        slot.
    :ivar two_key_slot_mode: Flag indicating whether node operates as a
        startup node in a TT-E Time Triggered External Sync or TT-L Time
        Triggered Local Master Sync cluster.
    :ivar wake_up_pattern: Number of repetitions of the Tx-wakeup symbol
        to be sent during the CC_WakeupSend state of this Node in the
        cluster
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-COMMUNICATION-CONTROLLER-CONDITIONAL"

    wake_up_by_controller_supported: Boolean | None = field(
        default=None,
        metadata={
            "name": "WAKE-UP-BY-CONTROLLER-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    accepted_startup_range: Integer | None = field(
        default=None,
        metadata={
            "name": "ACCEPTED-STARTUP-RANGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    allow_halt_due_to_clock: Boolean | None = field(
        default=None,
        metadata={
            "name": "ALLOW-HALT-DUE-TO-CLOCK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    allow_passive_to_active: Integer | None = field(
        default=None,
        metadata={
            "name": "ALLOW-PASSIVE-TO-ACTIVE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cluster_drift_damping: Integer | None = field(
        default=None,
        metadata={
            "name": "CLUSTER-DRIFT-DAMPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    decoding_correction: Integer | None = field(
        default=None,
        metadata={
            "name": "DECODING-CORRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delay_compensation_a: Integer | None = field(
        default=None,
        metadata={
            "name": "DELAY-COMPENSATION-A",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delay_compensation_b: Integer | None = field(
        default=None,
        metadata={
            "name": "DELAY-COMPENSATION-B",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    extern_offset_correction: Integer | None = field(
        default=None,
        metadata={
            "name": "EXTERN-OFFSET-CORRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    extern_rate_correction: Integer | None = field(
        default=None,
        metadata={
            "name": "EXTERN-RATE-CORRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    external_sync: Boolean | None = field(
        default=None,
        metadata={
            "name": "EXTERNAL-SYNC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fall_back_internal: Boolean | None = field(
        default=None,
        metadata={
            "name": "FALL-BACK-INTERNAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    flexray_fifos: Optional["FlexrayCommunicationControllerConditional.FlexrayFifos"] = field(
        default=None,
        metadata={
            "name": "FLEXRAY-FIFOS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_slot_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "KEY-SLOT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_slot_only_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "KEY-SLOT-ONLY-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_slot_used_for_start_up: Boolean | None = field(
        default=None,
        metadata={
            "name": "KEY-SLOT-USED-FOR-START-UP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_slot_used_for_sync: Boolean | None = field(
        default=None,
        metadata={
            "name": "KEY-SLOT-USED-FOR-SYNC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    latest_tx: Integer | None = field(
        default=None,
        metadata={
            "name": "LATEST-TX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    listen_timeout: Integer | None = field(
        default=None,
        metadata={
            "name": "LISTEN-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    macro_initial_offset_a: Integer | None = field(
        default=None,
        metadata={
            "name": "MACRO-INITIAL-OFFSET-A",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    macro_initial_offset_b: Integer | None = field(
        default=None,
        metadata={
            "name": "MACRO-INITIAL-OFFSET-B",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_dynamic_payload_length: Integer | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-DYNAMIC-PAYLOAD-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    micro_initial_offset_a: Integer | None = field(
        default=None,
        metadata={
            "name": "MICRO-INITIAL-OFFSET-A",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    micro_initial_offset_b: Integer | None = field(
        default=None,
        metadata={
            "name": "MICRO-INITIAL-OFFSET-B",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    micro_per_cycle: Integer | None = field(
        default=None,
        metadata={
            "name": "MICRO-PER-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    microtick_duration: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MICROTICK-DURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_vector_early_update: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-VECTOR-EARLY-UPDATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offset_correction_out: Integer | None = field(
        default=None,
        metadata={
            "name": "OFFSET-CORRECTION-OUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rate_correction_out: Integer | None = field(
        default=None,
        metadata={
            "name": "RATE-CORRECTION-OUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    samples_per_microtick: Integer | None = field(
        default=None,
        metadata={
            "name": "SAMPLES-PER-MICROTICK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    second_key_slot_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECOND-KEY-SLOT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    two_key_slot_mode: Boolean | None = field(
        default=None,
        metadata={
            "name": "TWO-KEY-SLOT-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wake_up_pattern: Integer | None = field(
        default=None,
        metadata={
            "name": "WAKE-UP-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FlexrayFifos:
        flexray_fifo_configuration: list[FlexrayFifoConfiguration] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-FIFO-CONFIGURATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayNmClusterCoupling:
    """
    FlexRay attributes that are valid for each of the referenced (coupled) FlexRay
    clusters.

    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        NmConfig.nmClusterCoupling
    :ivar coupled_cluster_refs: Reference to coupled FlexRay Clusters.
    :ivar nm_control_bit_vector_enabled: Enables control bit vector
        support.
    :ivar nm_data_disabled: Disables the transmission of NM-Data.
    :ivar nm_schedule_variant: FrNm schedule variant according to FrNm
        SWS.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-NM-CLUSTER-COUPLING"

    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    coupled_cluster_refs: Optional["FlexrayNmClusterCoupling.CoupledClusterRefs"] = field(
        default=None,
        metadata={
            "name": "COUPLED-CLUSTER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_control_bit_vector_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CONTROL-BIT-VECTOR-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_data_disabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-DATA-DISABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_schedule_variant: FlexrayNmScheduleVariant | None = field(
        default=None,
        metadata={
            "name": "NM-SCHEDULE-VARIANT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CoupledClusterRefs:
        coupled_cluster_ref: list[
            "FlexrayNmClusterCoupling.CoupledClusterRefs.CoupledClusterRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "COUPLED-CLUSTER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CoupledClusterRef(Ref):
            dest: FlexrayNmClusterSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class FlexrayNmNode:
    """
    FlexRay specific NM Node attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar controller_ref: Association to an CommunicationController in
        the topology description.
    :ivar machine_ref: Reference to the machine that contains the
        NmNode.
    :ivar nm_coord_cluster: NmCoordinationCluster identification number.
    :ivar nm_coordinator_role: This attribute indicates the role the NM
        Coordinator will have on this channel.
    :ivar nm_if_ecu_ref: Reference to the NmEcu that contains this
        NmNode. (CommunicationController that is referenced by the
        NmNode shall be contained in the EcuInstance that is referenced
        by the NmEcu).
    :ivar nm_node_id: Node identifier of local NmNode. Shall be unique
        in the NmCluster.
    :ivar nm_passive_mode_enabled: Enables support of the Passive Mode.
        The passive mode is configurable per channel.
    :ivar rx_nm_pdu_refs: receive NM Pdu.
    :ivar tx_nm_pdu_refs: transmit NM Pdu
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: NmCluster.nmNode
    :ivar nm_instance_id: The NM instance identifier is used for
        reporting of development errors to DET. It must be unique for
        each NM instance within one ECU.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-NM-NODE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlexrayNmNode.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlexrayNmNode.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    controller_ref: Optional["FlexrayNmNode.ControllerRef"] = field(
        default=None,
        metadata={
            "name": "CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    machine_ref: Optional["FlexrayNmNode.MachineRef"] = field(
        default=None,
        metadata={
            "name": "MACHINE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_coord_cluster: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-COORD-CLUSTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_coordinator_role: NmCoordinatorRoleEnum | None = field(
        default=None,
        metadata={
            "name": "NM-COORDINATOR-ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_if_ecu_ref: Optional["FlexrayNmNode.NmIfEcuRef"] = field(
        default=None,
        metadata={
            "name": "NM-IF-ECU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_id: Integer | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_passive_mode_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-PASSIVE-MODE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rx_nm_pdu_refs: Optional["FlexrayNmNode.RxNmPduRefs"] = field(
        default=None,
        metadata={
            "name": "RX-NM-PDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tx_nm_pdu_refs: Optional["FlexrayNmNode.TxNmPduRefs"] = field(
        default=None,
        metadata={
            "name": "TX-NM-PDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_instance_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-INSTANCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ControllerRef(Ref):
        dest: CommunicationControllerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MachineRef(Ref):
        dest: MachineDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NmIfEcuRef(Ref):
        dest: NmEcuSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RxNmPduRefs:
        rx_nm_pdu_ref: list["FlexrayNmNode.RxNmPduRefs.RxNmPduRef"] = field(
            default_factory=list,
            metadata={
                "name": "RX-NM-PDU-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RxNmPduRef(Ref):
            dest: NmPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TxNmPduRefs:
        tx_nm_pdu_ref: list["FlexrayNmNode.TxNmPduRefs.TxNmPduRef"] = field(
            default_factory=list,
            metadata={
                "name": "TX-NM-PDU-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TxNmPduRef(Ref):
            dest: NmPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class FlexrayTpConnection:
    """A connection identifies the sender and the receiver of this particular
    communication.

    The FlexRayTp module routes a Pdu through this connection. In a
    System Description the references to the PduPools are mandatory. In
    an ECU Extract these references can be optional: On unicast
    connections these references are always mandatory. On multicast the
    txPduPool is mandatory on the sender side. The rxPduPool is
    mandatory on the receiver side. On Gateway ECUs both references are
    mandatory.

    :ivar ident: This adds the ability to become referrable to
        TpConnection.
    :ivar bandwidth_limitation: Specifies whether the connection
        requires a  bandwidth limitation or not.
    :ivar direct_tp_sdu_ref: Reference to the IPdu that is segmented by
        the Transport Protocol.
    :ivar multicast_ref: TP address for 1:n connections.
    :ivar receiver_refs: The target of the TP connection.
    :ivar reversed_tp_sdu_ref: Reference to the IPdu that is segmented
        by the Transport Protocol. If support of both sending and
        receiving is used, this association references the IPdu used for
        the additional second direction.
    :ivar rx_pdu_pool_ref: A connection has a reference to a set of
        NPdus (FrTpRxPduPool) which are defined for receiving data via
        this particular connection. The following constraint is valid
        only for the System Extract/ECU Extract: In case this connection
        is applied to the transmitter the rxPduPool holds the actually
        received NPdus. In case this connection is applied to the
        receiver the rxPduPool holds the actually sent NPdus.
    :ivar tp_connection_control_ref: Reference to the connection
        control.
    :ivar transmitter_ref: The source of the TP connection.
    :ivar tx_pdu_pool_ref: A connection has a reference to a set of
        NPdus (FrTpTxPduPool) which are defined for sending data via
        this particular connection. The following constraint is valid
        only for the System Extract/ECU Extract: In case this connection
        is applied to the transmitter the txPduPool holds the actually
        sent NPdus. In case this connection is applied to the receiver
        the txPduPool holds the actually received NPdus.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        FlexrayTpConfig.tpConnection
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-TP-CONNECTION"

    ident: TpConnectionIdent | None = field(
        default=None,
        metadata={
            "name": "IDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bandwidth_limitation: Boolean | None = field(
        default=None,
        metadata={
            "name": "BANDWIDTH-LIMITATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    direct_tp_sdu_ref: Optional["FlexrayTpConnection.DirectTpSduRef"] = field(
        default=None,
        metadata={
            "name": "DIRECT-TP-SDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multicast_ref: Optional["FlexrayTpConnection.MulticastRef"] = field(
        default=None,
        metadata={
            "name": "MULTICAST-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    receiver_refs: Optional["FlexrayTpConnection.ReceiverRefs"] = field(
        default=None,
        metadata={
            "name": "RECEIVER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reversed_tp_sdu_ref: Optional["FlexrayTpConnection.ReversedTpSduRef"] = field(
        default=None,
        metadata={
            "name": "REVERSED-TP-SDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rx_pdu_pool_ref: Optional["FlexrayTpConnection.RxPduPoolRef"] = field(
        default=None,
        metadata={
            "name": "RX-PDU-POOL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_connection_control_ref: Optional["FlexrayTpConnection.TpConnectionControlRef"] = field(
        default=None,
        metadata={
            "name": "TP-CONNECTION-CONTROL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmitter_ref: Optional["FlexrayTpConnection.TransmitterRef"] = field(
        default=None,
        metadata={
            "name": "TRANSMITTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tx_pdu_pool_ref: Optional["FlexrayTpConnection.TxPduPoolRef"] = field(
        default=None,
        metadata={
            "name": "TX-PDU-POOL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DirectTpSduRef(Ref):
        dest: IPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MulticastRef(Ref):
        dest: TpAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ReceiverRefs:
        receiver_ref: list["FlexrayTpConnection.ReceiverRefs.ReceiverRef"] = field(
            default_factory=list,
            metadata={
                "name": "RECEIVER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ReceiverRef(Ref):
            dest: FlexrayTpNodeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ReversedTpSduRef(Ref):
        dest: IPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RxPduPoolRef(Ref):
        dest: FlexrayTpPduPoolSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TpConnectionControlRef(Ref):
        dest: FlexrayTpConnectionControlSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TransmitterRef(Ref):
        dest: FlexrayTpNodeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TxPduPoolRef(Ref):
        dest: FlexrayTpPduPoolSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FlexrayTpConnectionControl:
    """
    Configuration parameters to control a FlexRay TP connection.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar ack_type: This parameter defines the type of acknowledgement
        which is used for the specific channel.
    :ivar max_ar: This parameter defines the maximum number of trying to
        send a frame when a TIMEOUT AR occurs (depending on whether
        retry is configured).
    :ivar max_as: This parameter defines the maximum number of trying to
        send a frame when a TIMEOUT AS occurs (depending on whether
        retry is configured)
    :ivar max_buffer_size: This attribute has the status "removed" and
        shall not be used any longer. Old description: This parameter is
        only relevant when having retry activated. It limits the maximal
        buffer size the FrTp can choose in order to limit the amount of
        Tx buffer that will be requested at the sender side in a
        segmented transfer. Unit: byte.
    :ivar max_fc_wait: This attribute defines the maximum number of
        FlowControl N-PDUs with FlowState "WAIT".
    :ivar max_fr_if: This parameter defines the maximum number of trying
        to send a frame when the FrIf returns an error
    :ivar max_number_of_npdu_per_cycle: This parameter limits the number
        of N-Pdus the sender is allowed to transmit within a FlexRay
        cycle.
    :ivar max_retries: This parameter defines the maximum number of
        retries (if retry is configured for the particular channel).
    :ivar separation_cycle_exponent: Exponent to calculate the minimum
        number of "Separation Cycles" the sender has to wait for the
        next transmission of an FrTp N-Pdu.
    :ivar time_br: Time (in seconds) until transmission of the next
        FlowControl N-PDU.
    :ivar time_buffer: This parameter defines the time of waiting for
        the next try to get a Tx or Rx buffer. This parameter is
        equivalent to the temporal distance between two FC.WT N-Pdus in
        case the buffer request returns busy. Specified in seconds.
    :ivar time_cs: Time (in seconds) until transmission of the next
        ConsecutiveFrame NPdu / LastFrame NPdu.
    :ivar time_fr_if: This parameter defines the time of waiting for the
        next try to send. Specified in seconds.
    :ivar timeout_ar: This parameter states the timeout between the PDU
        transmit request of the Transport Layer to the FlexRay Interface
        and the corresponding confirmation of the FlexRay Interface on
        the receiver side (for FC or AF). Specified in seconds.
    :ivar timeout_as: This attribute states the timeout between the PDU
        transmit request for the first PDU of the group used in the
        current connection of the Transport Layer to the FlexRay
        Interface and the corresponding confirmation of the FlexRay
        Interface (when having sent the last PDU of the group used in
        this connection) on the sender side (SF-x, FF-x, CF or FC (in
        case of Transmit Cancellation)). Specified in seconds.
    :ivar timeout_br: This attribute specifies the timeout in seconds
        between the Pdu receive indication of the Transport Layer to the
        FlexRay Interface and the corresponding Pdu transmission of the
        FlexRay Interface on the receiver side.
    :ivar timeout_bs: This parameter defines the timeout in seconds for
        waiting for an FC or AF on the sender side in a 1:1 connection.
    :ivar timeout_cr: This parameter defines the timeout value in
        seconds for waiting for a CF or FF-x (in case of retry) after
        receiving the last CF or after sending an FC or AF on the
        receiver side. Specified in seconds.
    :ivar timeout_cs: This attribute specifies the timeout in seconds to
        transmit the next ConsecutiveFrame NPdu or the last frame NPdu
        after receiving the flow control frame (CTS) from the sender
        side.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        FlexrayTpConfig.tpConnectionControl
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-TP-CONNECTION-CONTROL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlexrayTpConnectionControl.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlexrayTpConnectionControl.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ack_type: TpAckType | None = field(
        default=None,
        metadata={
            "name": "ACK-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_ar: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-AR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_as: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-AS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_buffer_size: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-BUFFER-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_fc_wait: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-FC-WAIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_fr_if: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-FR-IF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_npdu_per_cycle: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-NPDU-PER-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_retries: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-RETRIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    separation_cycle_exponent: Integer | None = field(
        default=None,
        metadata={
            "name": "SEPARATION-CYCLE-EXPONENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_br: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-BR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_buffer: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-BUFFER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_cs: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-CS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_fr_if: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-FR-IF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_ar: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-AR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_as: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-AS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_br: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-BR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_bs: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-BS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_cr: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-CR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_cs: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-CS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayTpEcu:
    """ECU specific TP configuration parameters.

    Each TpEcu element has a reference to exactly one ECUInstance in the
    topology.

    :ivar cancellation: With this switch Tx and Rx Cancellation can be
        turned on or off.
    :ivar cycle_time_main_function: The period between successive calls
        to the Main Function of the AUTOSAR TP. Specified in seconds.
    :ivar ecu_instance_ref: Connection to the ECUInstance in the
        Topology
    :ivar full_duplex_enabled: The full duplex mechanisms is enabled if
        this attribute is set to true. Otherwise half duplex is enabled.
    :ivar transmit_cancellation: This attribute states whether Transmit
        Cancellation is supported on this ECU. Please note that this
        attribute is deprecated and will be removed in future.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: FlexrayTpConfig.tpEcu
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-TP-ECU"

    cancellation: Boolean | None = field(
        default=None,
        metadata={
            "name": "CANCELLATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cycle_time_main_function: TimeValue | None = field(
        default=None,
        metadata={
            "name": "CYCLE-TIME-MAIN-FUNCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["FlexrayTpEcu.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    full_duplex_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "FULL-DUPLEX-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmit_cancellation: Boolean | None = field(
        default=None,
        metadata={
            "name": "TRANSMIT-CANCELLATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FlexrayTpNode:
    """
    TP Node (Sender or Receiver) provides the TP Address and the connection to the
    Topology description.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar connector_refs: Association  to one or more physical
        connectors (max number of connectors for FlexRay: 2). In a
        System Description this reference is mandatory. In an ECU
        Extract this reference is optional (references to ECUs that are
        not part of the ECU Extract shall be avoided).
    :ivar tp_address_ref: Reference to the TP Address that is used by
        the TpNode. This reference is optional in case that the
        multicast TP Address is used (reference from TpConnection).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: FlexrayTpConfig.tpNode
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-TP-NODE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlexrayTpNode.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlexrayTpNode.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    connector_refs: Optional["FlexrayTpNode.ConnectorRefs"] = field(
        default=None,
        metadata={
            "name": "CONNECTOR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_address_ref: Optional["FlexrayTpNode.TpAddressRef"] = field(
        default=None,
        metadata={
            "name": "TP-ADDRESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConnectorRefs:
        connector_ref: list["FlexrayTpNode.ConnectorRefs.ConnectorRef"] = field(
            default_factory=list,
            metadata={
                "name": "CONNECTOR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ConnectorRef(Ref):
            dest: CommunicationConnectorSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TpAddressRef(Ref):
        dest: TpAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FlexrayTpPduPool:
    """
    FlexrayTpPduPool is a set of N-PDUs which are defined for FrTp sending or
    receiving purpose.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar n_pdu_refs: Reference to NPdus that are part of the PduPool.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: FlexrayTpConfig.pduPool
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-TP-PDU-POOL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlexrayTpPduPool.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlexrayTpPduPool.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    n_pdu_refs: Optional["FlexrayTpPduPool.NPduRefs"] = field(
        default=None,
        metadata={
            "name": "N-PDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NPduRefs:
        n_pdu_ref: list["FlexrayTpPduPool.NPduRefs.NPduRef"] = field(
            default_factory=list,
            metadata={
                "name": "N-PDU-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class NPduRef(Ref):
            dest: NPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class FmAttributeDef:
    """
    This metaclass represents the ability to define attributes for a feature.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar default_value: This represents the default value of the
        attribute.
    :ivar max: Maximum possible value for the value of this attribute
    :ivar min: Minimum possible value for the value of this attribute
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FM-ATTRIBUTE-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FmAttributeDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FmAttributeDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_value: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max: LimitValue | None = field(
        default=None,
        metadata={
            "name": "MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min: LimitValue | None = field(
        default=None,
        metadata={
            "name": "MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FmFeatureMapAssertion:
    """Defines a boolean expression which shall evaluate to true for this mapping
    to become active.

    The expression is a formula that is based on features and system
    constants, and is defined by fmSyscond.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar fm_syscond: The formula that implements the assertion.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FM-FEATURE-MAP-ASSERTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FmFeatureMapAssertion.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FmFeatureMapAssertion.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fm_syscond: FmConditionByFeaturesAndSwSystemconsts | None = field(
        default=None,
        metadata={
            "name": "FM-SYSCOND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FmFeatureMapCondition:
    """Defines a condition which needs to be fulfilled for this mapping to become
    active.

    The condition is implemented as formula that is based on features
    and attributes and is defined by fmCond.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar fm_cond: The formula that implements the condition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FM-FEATURE-MAP-CONDITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FmFeatureMapCondition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FmFeatureMapCondition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fm_cond: FmConditionByFeaturesAndAttributes | None = field(
        default=None,
        metadata={
            "name": "FM-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FmFeatureModel:
    """A Feature model describes the features of a product line and their
    dependencies.

    Feature models are an optional part of an AUTOSAR model.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar feature_refs: "feature" holds the list of features of the
        feature model. No FMFeature may be contained twice in this list.
        Also, each FMFeature may be contained on only one feature model.
    :ivar root_ref: The features of a feature model define a tree. The
        attribute root points to the root of this tree.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FM-FEATURE-MODEL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FmFeatureModel.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FmFeatureModel.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    feature_refs: Optional["FmFeatureModel.FeatureRefs"] = field(
        default=None,
        metadata={
            "name": "FEATURE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    root_ref: Optional["FmFeatureModel.RootRef"] = field(
        default=None,
        metadata={
            "name": "ROOT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FeatureRefs:
        feature_ref: list["FmFeatureModel.FeatureRefs.FeatureRef"] = field(
            default_factory=list,
            metadata={
                "name": "FEATURE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FeatureRef(Ref):
            dest: FmFeatureSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RootRef(Ref):
        dest: FmFeatureSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FmFeatureRelation:
    """Defines relations for FMFeatures, for example dependencies on other
    FMFeatures, or conflicts with other FMFeatures.

    A FMFeature can only be part of a FMFeatureSelectionSet if all its
    relations are fulfilled.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar feature_refs: The FMFeature that is targeted by this
        FMFeatureRelation.
    :ivar restriction: If given, the condition shall evaluate to true,
        in order for the FMFeatureRelation to be active.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FM-FEATURE-RELATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FmFeatureRelation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FmFeatureRelation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    feature_refs: Optional["FmFeatureRelation.FeatureRefs"] = field(
        default=None,
        metadata={
            "name": "FEATURE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    restriction: FmConditionByFeaturesAndAttributes | None = field(
        default=None,
        metadata={
            "name": "RESTRICTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FeatureRefs:
        feature_ref: list["FmFeatureRelation.FeatureRefs.FeatureRef"] = field(
            default_factory=list,
            metadata={
                "name": "FEATURE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FeatureRef(Ref):
            dest: FmFeatureSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class FmFeatureRestriction:
    """Defines restrictions for FMFeatures.

    A FMFeature can only be part of a FMFeatureSelectionSet if at least
    one of its restrictions evaluate to true.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar restriction: A formula that contains the actual restriction.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FM-FEATURE-RESTRICTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FmFeatureRestriction.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FmFeatureRestriction.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    restriction: FmConditionByFeaturesAndAttributes | None = field(
        default=None,
        metadata={
            "name": "RESTRICTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FmFeatureSelection:
    """
    A FMFeatureSelection represents the state of a particular FMFeature within a
    FMFeatureSelectionSet.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar feature_ref: The FMFeature whose state is defined by this
        FMFeatureSelection.
    :ivar state: Defines how the FMFeature that is described by this
        FMFeatureSelection contributes to the FMFeatureSelectionSet. A
        FMFeature may have the state selected, deselected or undecided.
    :ivar minimum_selected_binding_time: Defines a lower bound for the
        binding time of the variation points that are associated with
        the FMFeature, and refines its minimumIntendedBindingTime. This
        attribute is meant as a hint for the development process.
    :ivar maximum_selected_binding_time: Defines an upper bound for the
        binding time of the variation points that are associated with
        the FMFeature, and refines its maximumIntendedBindingTime. This
        attribute is meant as a hint for the development process.
    :ivar attribute_values: This defines a value for the attribute that
        is referred to in the role definition. Note that a
        FMFeatureSelection cannot include two FMAttributeValues that
        refer to the same FMAttributeDef in the role definition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FM-FEATURE-SELECTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FmFeatureSelection.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FmFeatureSelection.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    feature_ref: Optional["FmFeatureSelection.FeatureRef"] = field(
        default=None,
        metadata={
            "name": "FEATURE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    state: FmFeatureSelectionState | None = field(
        default=None,
        metadata={
            "name": "STATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_selected_binding_time: BindingTimeEnum | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-SELECTED-BINDING-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_selected_binding_time: BindingTimeEnum | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-SELECTED-BINDING-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    attribute_values: Optional["FmFeatureSelection.AttributeValues"] = field(
        default=None,
        metadata={
            "name": "ATTRIBUTE-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FeatureRef(Ref):
        dest: FmFeatureSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AttributeValues:
        fm_attribute_value: list[FmAttributeValue] = field(
            default_factory=list,
            metadata={
                "name": "FM-ATTRIBUTE-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ForbiddenSignalPath:
    """The ForbiddenSignalPath describes the physical channels which an element
    shall not take in the topology.

    Such a signal path can be a constraint for the communication matrix,
    because such a path has an effect on the frame generation and the
    frame path.

    :ivar introduction: This represents introductory documentation about
        the signal path constraint.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.signalPathConstraint
    :ivar operations: Reference to the operation arguments of one
        operation which shall not take the predefined way in the
        topology.
    :ivar physical_channel_refs: The SwcToSwcSignal shall not be
        transmitted on one of these physical channels.
    :ivar signals: The data element which shall not take the predefined
        way in the topology.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FORBIDDEN-SIGNAL-PATH"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operations: Optional["ForbiddenSignalPath.Operations"] = field(
        default=None,
        metadata={
            "name": "OPERATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_channel_refs: Optional["ForbiddenSignalPath.PhysicalChannelRefs"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNEL-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signals: Optional["ForbiddenSignalPath.Signals"] = field(
        default=None,
        metadata={
            "name": "SIGNALS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Operations:
        swc_to_swc_operation_arguments: list[SwcToSwcOperationArguments] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TO-SWC-OPERATION-ARGUMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannelRefs:
        physical_channel_ref: list["ForbiddenSignalPath.PhysicalChannelRefs.PhysicalChannelRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "PHYSICAL-CHANNEL-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class PhysicalChannelRef(Ref):
            dest: PhysicalChannelSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class Signals:
        swc_to_swc_signal: list[SwcToSwcSignal] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TO-SWC-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FrGlobalTimeDomainProps:
    """
    Enables the definition of Flexray GlobalTime specific properties.

    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        GlobalTimeDomain.globalTimeDomainProperty Not Applicable for:
        GlobalTimeDomain.globalTimeDomainProps
    :ivar ofs_data_id_lists: The DataIDList for OFS messages to
        calculate CRC.
    :ivar sync_data_id_lists: The DataIDList for SYNC messages to
        calculate CRC.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FR-GLOBAL-TIME-DOMAIN-PROPS"

    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ofs_data_id_lists: Optional["FrGlobalTimeDomainProps.OfsDataIdLists"] = field(
        default=None,
        metadata={
            "name": "OFS-DATA-ID-LISTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_data_id_lists: Optional["FrGlobalTimeDomainProps.SyncDataIdLists"] = field(
        default=None,
        metadata={
            "name": "SYNC-DATA-ID-LISTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class OfsDataIdLists:
        ofs_data_id_list: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "OFS-DATA-ID-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 16,
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SyncDataIdLists:
        sync_data_id_list: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "SYNC-DATA-ID-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 16,
            },
        )


@dataclass(slots=True, kw_only=True)
class FrameMapping:
    """The entire source frame is mapped as it is onto the target frame (what in
    general is only possible inside of a common platform).

    In this case source and target frame should be the identical object.
    Each pair consists in a SOURCE and a TARGET referencing to a
    FrameTriggering. The Frame Mapping is not supported by the Autosar
    BSW. The existence is optional and has been incorporated into the
    System Template mainly for compatibility in order to allow
    interchange between FIBEX and AUTOSAR descriptions.

    :ivar introduction: This represents introductory documentation about
        the frame mapping.
    :ivar source_frame_ref: Source destination of the referencing
        mapping.
    :ivar target_frame_ref: Target destination of the referencing
        mapping.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: Gateway.frameMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FRAME-MAPPING"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_frame_ref: Optional["FrameMapping.SourceFrameRef"] = field(
        default=None,
        metadata={
            "name": "SOURCE-FRAME-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_frame_ref: Optional["FrameMapping.TargetFrameRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-FRAME-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SourceFrameRef(Ref):
        dest: FrameTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetFrameRef(Ref):
        dest: FrameTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FramePort:
    """
    Connectors reception or send port on the referenced channel referenced by a
    FrameTriggering.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_direction: Communication Direction of the
        Connector Port (input or output Port).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CommunicationConnector.ecuCommPortInstance
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FRAME-PORT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FramePort.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FramePort.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_direction: CommunicationDirectionType | None = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FunctionInhibitionAvailabilityNeeds:
    """
    Specifies the abstract needs on the configuration of the Function Inhibition
    Manager to provide the control function for one Function Identifier (FID).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar controlled_fid_ref: This reference represents the controlled
        FID
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FUNCTION-INHIBITION-AVAILABILITY-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FunctionInhibitionAvailabilityNeeds.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FunctionInhibitionAvailabilityNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    controlled_fid_ref: Optional["FunctionInhibitionAvailabilityNeeds.ControlledFidRef"] = field(
        default=None,
        metadata={
            "name": "CONTROLLED-FID-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ControlledFidRef(Ref):
        dest: FunctionInhibitionNeedsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FunctionInhibitionNeeds:
    """Specifies the abstract needs on the configuration of the Function Inhibition
    Manager for one Function Identifier (FID).

    This class currently contains no attributes. Its name can be
    regarded as a symbol identifying the FID  from the viewpoint of the
    component or module which owns this class.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FUNCTION-INHIBITION-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FunctionInhibitionNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FunctionInhibitionNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FunctionalClusterInteractsWithPersistencyDeploymentMapping:
    """
    This meta-class represents the ability to define a mapping between any
    functional cluster modeled as a subclass of NonOsModuleInstantiation and a
    PersistencyDeployment.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar functional_cluster_ref: This reference identifies the client
        functional cluster that wants to use persistency.
    :ivar max_number_of_files: This attribute represents the definition
        of an upper bound for the handling of files at run-time in the
        context of the enclosing
        FunctionalClusterInteractsWithPersistencyDeploymentMapping.
    :ivar persistency_access: This attribute represents the definition
        of the persistency access of all kinds of persisted data at run-
        time in the context of the enclosing
        FunctionalClusterInteractsWithPersistencyDeploymentMapping.
    :ivar persistency_deployment_ref: This reference identifies the
        applicable PersistencyDeployment.
    :ivar process_ref: "This reference identifies the applicable
        process.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FUNCTIONAL-CLUSTER-INTERACTS-WITH-PERSISTENCY-DEPLOYMENT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "FunctionalClusterInteractsWithPersistencyDeploymentMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional[
        "FunctionalClusterInteractsWithPersistencyDeploymentMapping.Annotations"
    ] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    functional_cluster_ref: Optional[
        "FunctionalClusterInteractsWithPersistencyDeploymentMapping.FunctionalClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "FUNCTIONAL-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_files: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-FILES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    persistency_access: FunctionalClusterPersistencyAccessEnum | None = field(
        default=None,
        metadata={
            "name": "PERSISTENCY-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    persistency_deployment_ref: Optional[
        "FunctionalClusterInteractsWithPersistencyDeploymentMapping.PersistencyDeploymentRef"
    ] = field(
        default=None,
        metadata={
            "name": "PERSISTENCY-DEPLOYMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional[
        "FunctionalClusterInteractsWithPersistencyDeploymentMapping.ProcessRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FunctionalClusterRef(Ref):
        dest: NonOsModuleInstantiationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PersistencyDeploymentRef(Ref):
        dest: PersistencyDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FurtherActionByteNeeds:
    """
    The FurtherActionByteNeeds indicates that the software-component is able to
    provide the "further action byte" to the DoIp Service Component.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FURTHER-ACTION-BYTE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FurtherActionByteNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FurtherActionByteNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class GeneralParameter:
    """
    This represents a parameter in general e.g. an entry in a data sheet.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar prm_char: This represents the characteristics of one parameter
        under one particular condition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GENERAL-PARAMETER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GeneralParameter.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GeneralParameter.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prm_char: list[PrmChar] = field(
        default_factory=list,
        metadata={
            "name": "PRM-CHAR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class GeneralPurposeConnection:
    """
    This meta-class allows to describe the relationship between several
    PduTriggerings that are defined on the same PhysicalChannel, e.g. to create a
    link between Rx and Tx Pdu that are used for request/response.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar pdu_triggering_refs: Reference to PduTriggerings that are
        connected to each other by a GeneralPurposeConnection.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GENERAL-PURPOSE-CONNECTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GeneralPurposeConnection.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GeneralPurposeConnection.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_triggering_refs: Optional["GeneralPurposeConnection.PduTriggeringRefs"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduTriggeringRefs:
        pdu_triggering_ref: list["GeneralPurposeConnection.PduTriggeringRefs.PduTriggeringRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "PDU-TRIGGERING-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class PduTriggeringRef(Ref):
            dest: PduTriggeringSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class GeneralPurposeIPdu:
    """This element is used for AUTOSAR Pdus without attributes that are routed by
    the PduR.

    Please note that the category name of such Pdus is standardized in
    the AUTOSAR System Template.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar has_dynamic_length: This attribute defines whether the Pdu has
        dynamic length (true) or not (false). Please note that the usage
        of this attribute is restricted by [constr_3448].
    :ivar length: Pdu length in bytes. In case of dynamic length IPdus
        (containing a dynamical length signal), this value indicates the
        maximum data length. It should be noted that in former AUTOSAR
        releases (Rel 2.1, Rel 3.0, Rel 3.1, Rel 4.0 Rev. 1) this
        parameter was defined in bits. The Pdu length of zero bytes is
        allowed.
    :ivar meta_data_length: Number of additional bytes of MetaData in
        the PDU data field. The MetaData contains auxiliary information
        for the PDU, e.g. the CAN ID.
    :ivar contained_i_pdu_props: Defines whether this IPdu may be
        collected inside a ContainerIPdu.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GENERAL-PURPOSE-I-PDU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GeneralPurposeIPdu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GeneralPurposeIPdu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_dynamic_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-DYNAMIC-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "META-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_i_pdu_props: ContainedIPduProps | None = field(
        default=None,
        metadata={
            "name": "CONTAINED-I-PDU-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class GeneralPurposePdu:
    """This element is used for AUTOSAR Pdus without additional attributes that are
    routed by a bus interface.

    Please note that the category name of such Pdus is standardized in
    the AUTOSAR System Template.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar has_dynamic_length: This attribute defines whether the Pdu has
        dynamic length (true) or not (false). Please note that the usage
        of this attribute is restricted by [constr_3448].
    :ivar length: Pdu length in bytes. In case of dynamic length IPdus
        (containing a dynamical length signal), this value indicates the
        maximum data length. It should be noted that in former AUTOSAR
        releases (Rel 2.1, Rel 3.0, Rel 3.1, Rel 4.0 Rev. 1) this
        parameter was defined in bits. The Pdu length of zero bytes is
        allowed.
    :ivar meta_data_length: Number of additional bytes of MetaData in
        the PDU data field. The MetaData contains auxiliary information
        for the PDU, e.g. the CAN ID.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GENERAL-PURPOSE-PDU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GeneralPurposePdu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GeneralPurposePdu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_dynamic_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-DYNAMIC-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "META-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class GenericModuleInstantiation:
    """This meta-class defines the attributes for the generic module configuration
    on a specific machine.

    Different modules are distinguishable by the category attribute.
    This element can also be used to describe modules that are not
    standardized by AUTOSAR.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GENERIC-MODULE-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GenericModuleInstantiation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GenericModuleInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class GlobalSupervisionNeeds:
    """
    Specifies the abstract needs on the configuration of the Watchdog Manager to
    get access on the Global Supervision control and status interface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-SUPERVISION-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GlobalSupervisionNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GlobalSupervisionNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class GlobalTimeCanMaster:
    """
    This represents the specialization of the GlobalTimeMaster for the CAN
    communication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_connector_ref: The GlobalTimeMaster is bound to
        the CommunicationConnector.
    :ivar icv_secured: Defines whether an Integrity Check Value (ICV)
        shall be added to the sent time sync messages.
    :ivar immediate_resume_time: Defines the minimum time between an
        "immediate" message and the next periodic message.
    :ivar is_system_wide_global_time_master: If set to TRUE, the
        GlobalTimeMaster is supposed to act as the root of global time
        information.
    :ivar sync_period: This represents the period. Unit: seconds
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        GlobalTimeDomain.globalTimeMaster Not Applicable for:
        GlobalTimeDomain.master
    :ivar crc_secured: Definition of whether or not CRC is supported.
        This is only relevant for selected bus systems.
    :ivar follow_up_offset: This represents the offset of the Follow-Up
        message with respect to the SYNC message
    :ivar sync_confirmation_timeout: This represents the value for the
        confirmation timeout. Unit: seconds.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-CAN-MASTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GlobalTimeCanMaster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GlobalTimeCanMaster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_ref: Optional["GlobalTimeCanMaster.CommunicationConnectorRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    icv_secured: GlobalTimeIcvSupportEnum | None = field(
        default=None,
        metadata={
            "name": "ICV-SECURED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    immediate_resume_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "IMMEDIATE-RESUME-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_system_wide_global_time_master: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-SYSTEM-WIDE-GLOBAL-TIME-MASTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SYNC-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crc_secured: GlobalTimeCrcSupportEnum | None = field(
        default=None,
        metadata={
            "name": "CRC-SECURED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    follow_up_offset: TimeValue | None = field(
        default=None,
        metadata={
            "name": "FOLLOW-UP-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_confirmation_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SYNC-CONFIRMATION-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class GlobalTimeCanSlave:
    """
    This represents the specialization of the GlobalTimeSlave for the CAN
    communication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_connector_ref: The GlobalTimeSlave is bound to
        the CommunicationConnector.
    :ivar follow_up_timeout_value: Rx timeout for the follow-up message.
    :ivar icv_verification: Defines how an Integrity Check Value (ICV)
        shall be handled at the receiver.
    :ivar time_leap_future_threshold: Defines the maximum allowed
        positive difference between the current Local Time Base value
        and a newly received Global Time Base value.
    :ivar time_leap_healing_counter: Defines the required number of
        updates to the Time Base where the time difference to the
        previous received value has to remain within the bounds of
        timeLeapFutureThreshold and timeLeapPastThreshold until that
        Time Base is considered healed.
    :ivar time_leap_past_threshold: Defines the maximum allowed negative
        difference between the current Local Time Base value and a newly
        received Global Time Base value.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: GlobalTimeDomain.slave
    :ivar crc_validated: Definition of whether or not validation of the
        CRC is supported.
    :ivar sequence_counter_jump_width: Specifies the maximum allowed gap
        of the sequence counter between two SYNC resp. two OFS messages.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-CAN-SLAVE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GlobalTimeCanSlave.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GlobalTimeCanSlave.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_ref: Optional["GlobalTimeCanSlave.CommunicationConnectorRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    follow_up_timeout_value: TimeValue | None = field(
        default=None,
        metadata={
            "name": "FOLLOW-UP-TIMEOUT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    icv_verification: GlobalTimeIcvVerificationEnum | None = field(
        default=None,
        metadata={
            "name": "ICV-VERIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_leap_future_threshold: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-LEAP-FUTURE-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_leap_healing_counter: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TIME-LEAP-HEALING-COUNTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_leap_past_threshold: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-LEAP-PAST-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crc_validated: GlobalTimeCrcValidationEnum | None = field(
        default=None,
        metadata={
            "name": "CRC-VALIDATED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sequence_counter_jump_width: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SEQUENCE-COUNTER-JUMP-WIDTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class GlobalTimeDomainRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar global_time_domain_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-DOMAIN-REF-CONDITIONAL"

    global_time_domain_ref: Optional["GlobalTimeDomainRefConditional.GlobalTimeDomainRef"] = field(
        default=None,
        metadata={
            "name": "GLOBAL-TIME-DOMAIN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class GlobalTimeDomainRef(Ref):
        dest: GlobalTimeDomainSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class GlobalTimeEthMaster:
    """
    This represents the specialization of the GlobalTimeMaster for Ethernet
    communication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_connector_ref: The GlobalTimeMaster is bound to
        the CommunicationConnector.
    :ivar icv_secured: Defines whether an Integrity Check Value (ICV)
        shall be added to the sent time sync messages.
    :ivar immediate_resume_time: Defines the minimum time between an
        "immediate" message and the next periodic message.
    :ivar is_system_wide_global_time_master: If set to TRUE, the
        GlobalTimeMaster is supposed to act as the root of global time
        information.
    :ivar sync_period: This represents the period. Unit: seconds
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        GlobalTimeDomain.globalTimeMaster Not Applicable for:
        GlobalTimeDomain.master
    :ivar crc_secured: Definition of whether or not CRC is supported.
        This is only relevant for selected bus systems.
    :ivar sub_tlv_config: Defines the subTLV fields which shall be
        included in the time sync message.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-ETH-MASTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GlobalTimeEthMaster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GlobalTimeEthMaster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_ref: Optional["GlobalTimeEthMaster.CommunicationConnectorRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    icv_secured: GlobalTimeIcvSupportEnum | None = field(
        default=None,
        metadata={
            "name": "ICV-SECURED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    immediate_resume_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "IMMEDIATE-RESUME-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_system_wide_global_time_master: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-SYSTEM-WIDE-GLOBAL-TIME-MASTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SYNC-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crc_secured: GlobalTimeCrcSupportEnum | None = field(
        default=None,
        metadata={
            "name": "CRC-SECURED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_tlv_config: EthTSynSubTlvConfig | None = field(
        default=None,
        metadata={
            "name": "SUB-TLV-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class GlobalTimeEthSlave:
    """
    This represents the specialization of the GlobalTimeSlave for Ethernet
    communication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_connector_ref: The GlobalTimeSlave is bound to
        the CommunicationConnector.
    :ivar follow_up_timeout_value: Rx timeout for the follow-up message.
    :ivar icv_verification: Defines how an Integrity Check Value (ICV)
        shall be handled at the receiver.
    :ivar time_leap_future_threshold: Defines the maximum allowed
        positive difference between the current Local Time Base value
        and a newly received Global Time Base value.
    :ivar time_leap_healing_counter: Defines the required number of
        updates to the Time Base where the time difference to the
        previous received value has to remain within the bounds of
        timeLeapFutureThreshold and timeLeapPastThreshold until that
        Time Base is considered healed.
    :ivar time_leap_past_threshold: Defines the maximum allowed negative
        difference between the current Local Time Base value and a newly
        received Global Time Base value.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: GlobalTimeDomain.slave
    :ivar crc_validated: Definition of whether or not validation of the
        CRC is supported.
    :ivar time_hardware_correction_threshold: This attribute can be
        taken to define the maximum deviation between the local time and
        the time obtained from SYNC message that triggers a correction
        of the time drift caused by the hardware on the local node.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-ETH-SLAVE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GlobalTimeEthSlave.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GlobalTimeEthSlave.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_ref: Optional["GlobalTimeEthSlave.CommunicationConnectorRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    follow_up_timeout_value: TimeValue | None = field(
        default=None,
        metadata={
            "name": "FOLLOW-UP-TIMEOUT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    icv_verification: GlobalTimeIcvVerificationEnum | None = field(
        default=None,
        metadata={
            "name": "ICV-VERIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_leap_future_threshold: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-LEAP-FUTURE-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_leap_healing_counter: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TIME-LEAP-HEALING-COUNTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_leap_past_threshold: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-LEAP-PAST-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crc_validated: GlobalTimeCrcValidationEnum | None = field(
        default=None,
        metadata={
            "name": "CRC-VALIDATED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_hardware_correction_threshold: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-HARDWARE-CORRECTION-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class GlobalTimeFrMaster:
    """
    This represents the specialization of the GlobalTimeMaster for Flexray
    communication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_connector_ref: The GlobalTimeMaster is bound to
        the CommunicationConnector.
    :ivar icv_secured: Defines whether an Integrity Check Value (ICV)
        shall be added to the sent time sync messages.
    :ivar immediate_resume_time: Defines the minimum time between an
        "immediate" message and the next periodic message.
    :ivar is_system_wide_global_time_master: If set to TRUE, the
        GlobalTimeMaster is supposed to act as the root of global time
        information.
    :ivar sync_period: This represents the period. Unit: seconds
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        GlobalTimeDomain.globalTimeMaster Not Applicable for:
        GlobalTimeDomain.master
    :ivar crc_secured: Definition of whether or not CRC is supported.
        This is only relevant for selected bus systems.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-FR-MASTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GlobalTimeFrMaster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GlobalTimeFrMaster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_ref: Optional["GlobalTimeFrMaster.CommunicationConnectorRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    icv_secured: GlobalTimeIcvSupportEnum | None = field(
        default=None,
        metadata={
            "name": "ICV-SECURED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    immediate_resume_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "IMMEDIATE-RESUME-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_system_wide_global_time_master: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-SYSTEM-WIDE-GLOBAL-TIME-MASTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SYNC-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crc_secured: GlobalTimeCrcSupportEnum | None = field(
        default=None,
        metadata={
            "name": "CRC-SECURED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class GlobalTimeFrSlave:
    """
    This represents the specialization of the GlobalTimeSlave for Flexray
    communication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_connector_ref: The GlobalTimeSlave is bound to
        the CommunicationConnector.
    :ivar follow_up_timeout_value: Rx timeout for the follow-up message.
    :ivar icv_verification: Defines how an Integrity Check Value (ICV)
        shall be handled at the receiver.
    :ivar time_leap_future_threshold: Defines the maximum allowed
        positive difference between the current Local Time Base value
        and a newly received Global Time Base value.
    :ivar time_leap_healing_counter: Defines the required number of
        updates to the Time Base where the time difference to the
        previous received value has to remain within the bounds of
        timeLeapFutureThreshold and timeLeapPastThreshold until that
        Time Base is considered healed.
    :ivar time_leap_past_threshold: Defines the maximum allowed negative
        difference between the current Local Time Base value and a newly
        received Global Time Base value.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: GlobalTimeDomain.slave
    :ivar crc_validated: Definition of whether or not validation of the
        CRC is supported.
    :ivar sequence_counter_jump_width: Specifies the maximum allowed gap
        of the sequence counter between two SYNC resp. two OFS messages.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-FR-SLAVE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GlobalTimeFrSlave.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GlobalTimeFrSlave.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_ref: Optional["GlobalTimeFrSlave.CommunicationConnectorRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    follow_up_timeout_value: TimeValue | None = field(
        default=None,
        metadata={
            "name": "FOLLOW-UP-TIMEOUT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    icv_verification: GlobalTimeIcvVerificationEnum | None = field(
        default=None,
        metadata={
            "name": "ICV-VERIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_leap_future_threshold: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-LEAP-FUTURE-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_leap_healing_counter: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TIME-LEAP-HEALING-COUNTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_leap_past_threshold: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-LEAP-PAST-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crc_validated: GlobalTimeCrcValidationEnum | None = field(
        default=None,
        metadata={
            "name": "CRC-VALIDATED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sequence_counter_jump_width: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SEQUENCE-COUNTER-JUMP-WIDTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class GlobalTimeGateway:
    """
    This represents the ability to define a time gateway for establishing a global
    time domain over several communication clusters.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar host_ref: The GlobalTimeGateway is hosted by the referenced
        EcuInstance.
    :ivar master_ref: This represents the master of the global time
        gateway.
    :ivar slave_ref: This represents the slave of the GlobalTimeGateway.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        GlobalTimeDomain.gateway
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-GATEWAY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GlobalTimeGateway.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GlobalTimeGateway.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    host_ref: Optional["GlobalTimeGateway.HostRef"] = field(
        default=None,
        metadata={
            "name": "HOST-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    master_ref: Optional["GlobalTimeGateway.MasterRef"] = field(
        default=None,
        metadata={
            "name": "MASTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    slave_ref: Optional["GlobalTimeGateway.SlaveRef"] = field(
        default=None,
        metadata={
            "name": "SLAVE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HostRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MasterRef(Ref):
        dest: GlobalTimeMasterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SlaveRef(Ref):
        dest: GlobalTimeSlaveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class HardwareTestNeeds:
    """
    This meta-class represents the ability to indicate that a software-component is
    interested in the results of the hardware test and will establish a
    PortPrototype to query the hardware test manager.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HARDWARE-TEST-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["HardwareTestNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["HardwareTestNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class HealthChannelExternalStatus:
    """
    This element defines a health channel representing the status of an external
    health channel.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar recovery_notification_refs: Defines the RecoveryNotification
        for this HealthChannel.
    :ivar health_channel_iref: Refers to the HealthChannel.
    :ivar notified_statuss: This is a list of statuses which shall
        trigger the RecoveryNotification of this
        HealthChannelExternalStatus.
    :ivar process_ref: Defines the Process this Health Channel shall be
        monitored.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HEALTH-CHANNEL-EXTERNAL-STATUS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["HealthChannelExternalStatus.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["HealthChannelExternalStatus.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    recovery_notification_refs: Optional["HealthChannelExternalStatus.RecoveryNotificationRefs"] = (
        field(
            default=None,
            metadata={
                "name": "RECOVERY-NOTIFICATION-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    health_channel_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "HEALTH-CHANNEL-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    notified_statuss: Optional["HealthChannelExternalStatus.NotifiedStatuss"] = field(
        default=None,
        metadata={
            "name": "NOTIFIED-STATUSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["HealthChannelExternalStatus.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RecoveryNotificationRefs:
        recovery_notification_ref: list[
            "HealthChannelExternalStatus.RecoveryNotificationRefs.RecoveryNotificationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "RECOVERY-NOTIFICATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RecoveryNotificationRef(Ref):
            dest: RecoveryNotificationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class NotifiedStatuss:
        health_channel_external_reported_status: list[HealthChannelExternalReportedStatus] = field(
            default_factory=list,
            metadata={
                "name": "HEALTH-CHANNEL-EXTERNAL-REPORTED-STATUS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class HealthChannelSupervision:
    """
    This element defines a health channel representing the status of a
    PhmSupervision.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar recovery_notification_refs: Defines the RecoveryNotification
        for this HealthChannel.
    :ivar supervision_ref: Reference to the GlobalSupervision as source
        for the health channel.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HEALTH-CHANNEL-SUPERVISION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["HealthChannelSupervision.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["HealthChannelSupervision.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    recovery_notification_refs: Optional["HealthChannelSupervision.RecoveryNotificationRefs"] = (
        field(
            default=None,
            metadata={
                "name": "RECOVERY-NOTIFICATION-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    supervision_ref: Optional["HealthChannelSupervision.SupervisionRef"] = field(
        default=None,
        metadata={
            "name": "SUPERVISION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RecoveryNotificationRefs:
        recovery_notification_ref: list[
            "HealthChannelSupervision.RecoveryNotificationRefs.RecoveryNotificationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "RECOVERY-NOTIFICATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RecoveryNotificationRef(Ref):
            dest: RecoveryNotificationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SupervisionRef(Ref):
        dest: GlobalSupervisionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class HwAttributeLiteralDef:
    """One available EnumerationLiteral of the Enumeration definition.

    Only applicable if the category of the HwAttributeDef equals
    Enumeration.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HW-ATTRIBUTE-LITERAL-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["HwAttributeLiteralDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["HwAttributeLiteralDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class HwAttributeValue:
    """This metaclass represents the ability to assign a hardware attribute value.

    Note that v and vt are mutually exclusive.

    :ivar annotation: Optional annotation that can be added to each
        HwAttributeValue.
    :ivar hw_attribute_def_ref: This association represents the
        definition of the particular hardware attribute value.
    :ivar v: This represents a numerical hardware attribute value.
    :ivar vt: This represents a textual hardware attribute value.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        HwDescriptionEntity.hwAttributeValue
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HW-ATTRIBUTE-VALUE"

    annotation: Annotation | None = field(
        default=None,
        metadata={
            "name": "ANNOTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_attribute_def_ref: Optional["HwAttributeValue.HwAttributeDefRef"] = field(
        default=None,
        metadata={
            "name": "HW-ATTRIBUTE-DEF-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    v: NumericalValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "V",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vt: VerbatimString | None = field(
        default=None,
        metadata={
            "name": "VT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class HwAttributeDefRef(Ref):
        dest: HwAttributeDefSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class HwElementRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar hw_element_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HW-ELEMENT-REF-CONDITIONAL"

    hw_element_ref: Optional["HwElementRefConditional.HwElementRef"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class HwElementRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class HwPinConnector:
    """
    This meta-class represents the ability to connect two pins.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar hw_pin_refs: This association connects two hardware pins.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        HwElementConnector.hwPinConnection Applicable for:
        HwPinGroupConnector.hwPinConnection
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HW-PIN-CONNECTOR"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_pin_refs: Optional["HwPinConnector.HwPinRefs"] = field(
        default=None,
        metadata={
            "name": "HW-PIN-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class HwPinRefs:
        hw_pin_ref: list["HwPinConnector.HwPinRefs.HwPinRef"] = field(
            default_factory=list,
            metadata={
                "name": "HW-PIN-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class HwPinRef(Ref):
            dest: HwPinSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class IPduMapping:
    """
    Arranges those IPdus that are transferred by the gateway from one channel to
    the other in pairs and defines the mapping between them.

    :ivar introduction: This represents introductory documentation about
        the IPdu mapping.
    :ivar pdu_max_length: Define the maximum length in bytes which
        limits the length of the Pdu during gateway operation if the
        runtime length of the received Pdu exceeds this limit.
    :ivar pdur_tp_chunk_size: Optionally defines the to be configured
        Pdu Router TpChunkSize for this routing relation.
    :ivar source_i_pdu_ref: Source destination of the referencing
        mapping.
    :ivar target_i_pdu: Target destination of the referencing mapping.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: Gateway.iPduMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-PDU-MAPPING"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_max_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PDU-MAX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdur_tp_chunk_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PDUR-TP-CHUNK-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_i_pdu_ref: Optional["IPduMapping.SourceIPduRef"] = field(
        default=None,
        metadata={
            "name": "SOURCE-I-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_i_pdu: TargetIPduRef | None = field(
        default=None,
        metadata={
            "name": "TARGET-I-PDU",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SourceIPduRef(Ref):
        dest: PduTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class IPduPort:
    """
    Connectors reception or send port on the referenced channel referenced by a
    PduTriggering.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_direction: Communication Direction of the
        Connector Port (input or output Port).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CommunicationConnector.ecuCommPortInstance
    :ivar i_pdu_signal_processing: Definition of the two signal
        processing modes Immediate and Deferred for both Tx and Rx
        IPdus.
    :ivar key_id: This attribute specifies the local Key identifier of
        the stored Key used to generate or verify a MAC. The keyId shall
        be unique per Ecu.
    :ivar rx_security_verification: This attribute defines the bypassing
        of signature authentication or MAC verification in the receiving
        ECU. If not defined or set to true the signature authentication
        or MAC verification shall be performed for the SecuredIPdu. If
        set to false the signature authentication or MAC verification
        shall not be performed for the SecuredIPdu.
    :ivar timestamp_rx_acceptance_window: This attribute is used to
        define the maximum allowed deviation in seconds from the
        expected timestamp for which a SecuredIPdu is still deemed
        authentic. Please note that this attribute is for documentation
        only to allow the configuration of required freshness value
        manager and no upstream mapping is defined for it.
    :ivar use_auth_data_freshness: This attribute describes whether a
        part of AuthenticPdu contained in a SecuredIPdu shall be passed
        on to the SWC that verifies and generates the Freshness. The
        part of the Authentic-PDU is defined by the
        authDataFreshnessStartPosition and authDataFreshnessLength.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-PDU-PORT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IPduPort.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IPduPort.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_direction: CommunicationDirectionType | None = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_pdu_signal_processing: IPduSignalProcessingEnum | None = field(
        default=None,
        metadata={
            "name": "I-PDU-SIGNAL-PROCESSING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "KEY-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rx_security_verification: Boolean | None = field(
        default=None,
        metadata={
            "name": "RX-SECURITY-VERIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timestamp_rx_acceptance_window: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMESTAMP-RX-ACCEPTANCE-WINDOW",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    use_auth_data_freshness: Boolean | None = field(
        default=None,
        metadata={
            "name": "USE-AUTH-DATA-FRESHNESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class IPv6ExtHeaderFilterList:
    """
    Permitted list for the filtering of IPv6 extension headers.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar allowed_i_pv_6_ext_headers: IPv6 Extension Header type allowed
        by this filter.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-PV-6-EXT-HEADER-FILTER-LIST"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IPv6ExtHeaderFilterList.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IPv6ExtHeaderFilterList.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    allowed_i_pv_6_ext_headers: Optional["IPv6ExtHeaderFilterList.AllowedIPv6ExtHeaders"] = field(
        default=None,
        metadata={
            "name": "ALLOWED-I-PV-6-EXT-HEADERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AllowedIPv6ExtHeaders:
        allowed_i_pv_6_ext_header: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "ALLOWED-I-PV-6-EXT-HEADER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ISignalIPduRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar i_signal_i_pdu_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-SIGNAL-I-PDU-REF-CONDITIONAL"

    i_signal_i_pdu_ref: Optional["ISignalIPduRefConditional.ISignalIPduRef"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-I-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ISignalIPduRef(Ref):
        dest: ISignalIPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ISignalMapping:
    """Arranges those signals (or SignalGroups) that are transferred by the gateway
    from one channel to the other in pairs and defines the mapping between them.

    Each pair consists in a source and a target referencing to a
    ISignalTriggering.

    :ivar introduction: This represents introductory documentation about
        the ISignal mapping.
    :ivar source_signal_ref: Source destination of the referencing
        mapping.
    :ivar target_signal_ref: Target destination of the referencing
        mapping.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: Gateway.signalMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-SIGNAL-MAPPING"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_signal_ref: Optional["ISignalMapping.SourceSignalRef"] = field(
        default=None,
        metadata={
            "name": "SOURCE-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_signal_ref: Optional["ISignalMapping.TargetSignalRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SourceSignalRef(Ref):
        dest: ISignalTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetSignalRef(Ref):
        dest: ISignalTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ISignalPort:
    """Connectors reception or send port on the referenced channel referenced by an
    ISignalTriggering.

    If different timeouts or DataFilters for ISignals need to be
    specified several ISignalPorts may be created.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_direction: Communication Direction of the
        Connector Port (input or output Port).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CommunicationConnector.ecuCommPortInstance
    :ivar data_filter: Optional specification of  a signal COM filter at
        the receiver side in case that  the System Description doesn't
        use a complete Software Component Description (VFB View). This
        supports the inclusion of legacy system signals. If a full
        DataMapping exist for the SystemSignal this information may be
        available from a configured ReceiverComSpec. In this case the
        ReceiverComSpec overrides this optional specification.
    :ivar first_timeout: *ISignalPort with communicationDirection = in:
        Optional first timeout value in seconds for the reception of the
        ISignal. *ISignalPort with communicationDirection = out:
        Optional first timeout value in seconds for transmission
        deadline monitoring.
    :ivar handle_invalid: This attribute defines how invalidation is
        applied to the ISignals received in the context of this
        ISignalPort.
    :ivar timeout: * ISignalPort with communicationDirection = in:
        Optional timeout value in seconds for the reception of the
        ISignal. The attribute value is used to configure the ComTimeout
        in the COM module. The RTE ignores this attribute. The timeout
        can also be specified with the
        NonqueuedReceiverComSpec.aliveTimeout attribute. If a full
        DataMapping exists for the SystemSignal and the value is
        available in the configured ReceiverComSpec, then the timeout
        value in the ReceiverComSpec overrides this optional timeout
        specification during the creation of the Base Ecu Configuration
        of the COM module. * ISignalPort with communicationDirection =
        out: Optional timeout value in seconds for the transmission of
        the ISignal. The attribute value is used to configure the
        ComTimeout in the COM module. The RTE ignores this attribute.
        The timeout can also be specified with the
        enderComSpec.transmissionAcknowledge.timeout attribute. If a
        full DataMapping exists for the SystemSignal and the value is
        available in the configured SenderComSpec, then the timeout
        value in the SenderComSpec overrides this optional timeout
        specification during the creation of the Base Ecu Configuration
        of the COM module. This attribute can be used in the following
        cases: * legacy signal where the System Description doesn't use
        a complete Software Component Description (VFB View) and where
        the DataMapping is missing. * bus monitoring use cases in which
        the DataMapping is ignored.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-SIGNAL-PORT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ISignalPort.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ISignalPort.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_direction: CommunicationDirectionType | None = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_filter: DataFilter | None = field(
        default=None,
        metadata={
            "name": "DATA-FILTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    first_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "FIRST-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    handle_invalid: HandleInvalidEnum | None = field(
        default=None,
        metadata={
            "name": "HANDLE-INVALID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ISignalToIPduMapping:
    """
    An ISignalToIPduMapping describes the mapping of ISignals to ISignalIPdus and
    defines the position of the ISignal within an ISignalIPdu.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar i_signal_group_ref: Reference to an ISignalGroup that is
        mapped into the SignalIPdu. If an ISignalToIPduMapping for an
        ISignalGroup is defined, only the UpdateIndicationBitPosition
        and the transferProperty is relevant. The startPosition and the
        packingByteOrder shall be ignored. Each ISignal contained in the
        ISignalGroup shall be mapped into an IPdu by an own
        ISignalToIPduMapping. The references to the ISignal and to the
        ISignalGroup in an ISignalToIPduMapping are mutually exclusive.
    :ivar i_signal_ref: Reference to a ISignal that is mapped into the
        ISignalIPdu. Each ISignal contained in the ISignalGroup shall be
        mapped into an IPdu by an own ISignalToIPduMapping. The
        references to the ISignal and to the ISignalGroup in an
        ISignalToIPduMapping are mutually exclusive.
    :ivar packing_byte_order: This parameter defines the order of the
        bytes of the signal and the packing into the SignalIPdu. The
        byte ordering "Little Endian" (MostSignificantByteLast), "Big
        Endian" (MostSignificantByteFirst) and "Opaque" can be selected.
        For opaque data endianness conversion shall be configured to
        Opaque. The value of this attribute impacts the absolute
        position of the signal into the SignalIPdu (see the
        startPosition attribute description). For an ISignalGroup the
        packingByteOrder is irrelevant and shall be ignored.
    :ivar start_position: This parameter is necessary to describe the
        bitposition of a signal within an SignalIPdu. It denotes the
        least significant bit for "Little Endian" and the most
        significant bit for "Big Endian" packed signals within the IPdu
        (see the description of the packingByteOrder attribute). In
        AUTOSAR the bit counting is always set to "sawtooth" and the bit
        order is set to "Decreasing". The bit counting in byte 0 starts
        with bit 0 (least significant bit). The most significant bit in
        byte 0 is bit 7. Please note that the way the bytes will be
        actually sent on the bus does not impact this representation:
        they will always be seen by the software as a byte array. If a
        mapping for the ISignalGroup is defined, this attribute is
        irrelevant and shall be ignored.
    :ivar transfer_property: Defines how the referenced ISignal
        contributes to the send triggering of the ISignalIPdu.
    :ivar update_indication_bit_position: The UpdateIndicationBit
        indicates to the receivers that the signal (or the signal group)
        was updated by the sender. Length is always one bit. The
        UpdateIndicationBitPosition attribute describes the position of
        the update bit within the SignalIPdu. For Signals of a
        ISignalGroup this attribute is irrelevant and shall be ignored.
        Note that the exact bit position of the
        updateIndicationBitPosition is linked to the value of the
        attribute packingByteOrder because the method of finding the bit
        position is different for the values mostSignificantByteFirst
        and mostSignificantByteLast. This means that if the value of
        packingByteOrder is changed while the value of
        updateIndicationBitPosition remains unchanged the exact bit
        position of updateIndicationBitPosition within the enclosing
        ISignalIPdu still undergoes a change. This attribute denotes the
        least significant bit for "Little Endian" and the most
        significant bit for "Big Endian" packed signals within the IPdu
        (see the description of the packingByteOrder attribute). In
        AUTOSAR the bit counting is always set to "sawtooth" and the bit
        order is set to "Decreasing". The bit counting in byte 0 starts
        with bit 0 (least significant bit). The most significant bit in
        byte 0 is bit 7.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ISignalIPdu.iSignalToPduMapping Not Applicable for:
        NmPdu.iSignalToIPduMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-SIGNAL-TO-I-PDU-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ISignalToIPduMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ISignalToIPduMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_group_ref: Optional["ISignalToIPduMapping.ISignalGroupRef"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_ref: Optional["ISignalToIPduMapping.ISignalRef"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    packing_byte_order: ByteOrderEnum | None = field(
        default=None,
        metadata={
            "name": "PACKING-BYTE-ORDER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_position: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "START-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transfer_property: TransferPropertyEnum | None = field(
        default=None,
        metadata={
            "name": "TRANSFER-PROPERTY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update_indication_bit_position: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "UPDATE-INDICATION-BIT-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalGroupRef(Ref):
        dest: ISignalGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalRef(Ref):
        dest: ISignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ISignalTriggering:
    """
    A ISignalTriggering allows an assignment of ISignals to physical channels.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar i_signal_group_ref: This reference shall be used if an
        ISignalGroup is transported on the PhysicalChannel. This
        reference forms an XOR relationship with the ISignalTriggering-
        ISignal reference.
    :ivar i_signal_port_refs: References to the ISignalPort on every ECU
        of the system which sends and/or receives the ISignal.
        References for both the sender and the receiver side shall be
        included when the system is completely defined.
    :ivar i_signal_ref: This reference shall be used if an ISignal is
        transported on the PhysicalChannel. This reference forms an XOR
        relationship with the ISignalTriggering-ISignalGroup reference.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        PhysicalChannel.iSignalTriggering
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-SIGNAL-TRIGGERING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ISignalTriggering.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ISignalTriggering.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_group_ref: Optional["ISignalTriggering.ISignalGroupRef"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_port_refs: Optional["ISignalTriggering.ISignalPortRefs"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-PORT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_ref: Optional["ISignalTriggering.ISignalRef"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalGroupRef(Ref):
        dest: ISignalGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalPortRefs:
        i_signal_port_ref: list["ISignalTriggering.ISignalPortRefs.ISignalPortRef"] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-PORT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ISignalPortRef(Ref):
            dest: ISignalPortSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ISignalRef(Ref):
        dest: ISignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ISignalTriggeringRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar i_signal_triggering_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-SIGNAL-TRIGGERING-REF-CONDITIONAL"

    i_signal_triggering_ref: Optional["ISignalTriggeringRefConditional.ISignalTriggeringRef"] = (
        field(
            default=None,
            metadata={
                "name": "I-SIGNAL-TRIGGERING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ISignalTriggeringRef(Ref):
        dest: ISignalTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class IamModuleInstantiation:
    """
    This meta-class represents the ability to define a definition of an IAM
    instantiation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar grant_refs: This reference identifies the applicable Grants
        for this IamModuleInstantiation.
    :ivar local_com_access_control_enabled: This switch activates the
        policy enforcement in Communication Management on local
        applications.
    :ivar remote_access_control_enabled: This switch activates  the
        check of the remote subject.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IAM-MODULE-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IamModuleInstantiation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IamModuleInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    grant_refs: Optional["IamModuleInstantiation.GrantRefs"] = field(
        default=None,
        metadata={
            "name": "GRANT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_com_access_control_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "LOCAL-COM-ACCESS-CONTROL-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_access_control_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "REMOTE-ACCESS-CONTROL-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class GrantRefs:
        grant_ref: list["IamModuleInstantiation.GrantRefs.GrantRef"] = field(
            default_factory=list,
            metadata={
                "name": "GRANT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class GrantRef(Ref):
            dest: GrantSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class IdsCommonElementRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar ids_common_element_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IDS-COMMON-ELEMENT-REF-CONDITIONAL"

    ids_common_element_ref: Optional["IdsCommonElementRefConditional.IdsCommonElementRef"] = field(
        default=None,
        metadata={
            "name": "IDS-COMMON-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class IdsCommonElementRef(Ref):
        dest: IdsCommonElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class IdsMgrCustomTimestampNeeds:
    """
    This meta-class is used to indicate that the enclosing SwcServiceDependency
    represents a service use case for the retrieval of a custom timestamp by the
    Intrusion Detection System Manager.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IDS-MGR-CUSTOM-TIMESTAMP-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IdsMgrCustomTimestampNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IdsMgrCustomTimestampNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class IdsMgrNeeds:
    """
    This meta-class is used to indicate that the enclosing SwcServiceDependency
    represents a service use case for the Intrusion Detection System Manager.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar use_smart_sensor_api: This attribute controls whether the
        reporting of the security event shall be done by means of the
        smart sensor API.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IDS-MGR-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IdsMgrNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IdsMgrNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    use_smart_sensor_api: Boolean | None = field(
        default=None,
        metadata={
            "name": "USE-SMART-SENSOR-API",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class IdsmInstanceRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar idsm_instance_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IDSM-INSTANCE-REF-CONDITIONAL"

    idsm_instance_ref: Optional["IdsmInstanceRefConditional.IdsmInstanceRef"] = field(
        default=None,
        metadata={
            "name": "IDSM-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class IdsmInstanceRef(Ref):
        dest: IdsmInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class IdsmRateLimitation:
    """This meta-class represents the configuration of a rate limitation filter for
    security events.

    This means that security events are dropped if the number of events
    (of any type) processed within a configurable time window is greater
    than a configurable threshold.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar max_events_in_interval: This attribute configures the
        threshold for dropping security events if the number of all
        processed security events exceeds the threshold in the
        respective time interval.
    :ivar time_interval: This attribute configures the length of the
        time interval in seconds for dropping security events if the
        number of all processed security events exceeds the configurable
        threshold within the respective time interval.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IDSM-RATE-LIMITATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IdsmRateLimitation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IdsmRateLimitation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_events_in_interval: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-EVENTS-IN-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_interval: Float | None = field(
        default=None,
        metadata={
            "name": "TIME-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class IdsmRateLimitationRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar idsm_rate_limitation_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IDSM-RATE-LIMITATION-REF-CONDITIONAL"

    idsm_rate_limitation_ref: Optional["IdsmRateLimitationRefConditional.IdsmRateLimitationRef"] = (
        field(
            default=None,
            metadata={
                "name": "IDSM-RATE-LIMITATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class IdsmRateLimitationRef(Ref):
        dest: IdsmRateLimitationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class IdsmTrafficLimitation:
    """This meta-class represents the configuration of a traffic limitation filter
    for Security Events.

    This means that security events are dropped if the size (in terms of
    bandwidth) of security events (of any type) processed within a
    configurable time window is greater than a configurable threshold.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar max_bytes_in_interval: This attribute configures the threshold
        for dropping security events if the size of all processed
        security events exceeds the threshold in the respective time
        interval.
    :ivar time_interval: This attribute configures the length of the
        time interval in seconds for dropping security events if the
        size of all processed security events exceeds the configurable
        threshold within the respective time interval.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IDSM-TRAFFIC-LIMITATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IdsmTrafficLimitation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IdsmTrafficLimitation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_bytes_in_interval: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-BYTES-IN-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_interval: Float | None = field(
        default=None,
        metadata={
            "name": "TIME-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class IdsmTrafficLimitationRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar idsm_traffic_limitation_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IDSM-TRAFFIC-LIMITATION-REF-CONDITIONAL"

    idsm_traffic_limitation_ref: Optional[
        "IdsmTrafficLimitationRefConditional.IdsmTrafficLimitationRef"
    ] = field(
        default=None,
        metadata={
            "name": "IDSM-TRAFFIC-LIMITATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class IdsmTrafficLimitationRef(Ref):
        dest: IdsmTrafficLimitationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ImplementationDataTypeElement:
    """Declares a data object which is locally aggregated.

    Such an element can only be used within the scope where it is aggregated.
    This element either consists of further subElements or it is further defined via its swDataDefProps.
    There are several use cases within the system of ImplementationDataTypes fur such a local declaration:
    * It can represent the elements of an array, defining the element type and array size
    * It can represent an element of a struct, defining its type
    * It can be the local declaration of a debug element.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar array_impl_policy: This attribute controls the implementation
        of the payload of an array. It shall only be used if the
        enclosing ImplementationDataType constitutes an array.
    :ivar array_size: The existence of this attributes (if bigger than
        0) defines the size of an array and declares that this
        ImplementationDataTypeElement represents the type of each single
        array element.
    :ivar array_size_handling: The way how the size of the array is
        handled in case of a variable size array.
    :ivar array_size_semantics: This attribute controls the meaning of
        the value of the array size.
    :ivar is_optional: This attribute represents the ability to declare
        the enclosing ImplementationDataTypeElement as optional. This
        means that, at runtime, the ImplementationDataTypeElement may or
        may not have a valid value and shall therefore be ignored. The
        underlying runtime software provides means to set the
        CppImplementationDataTypeElement as not valid at the sending end
        of a communication and determine its validity at the receiving
        end.
    :ivar sub_elements: Element of an array, struct, or union in case of
        a nested declaration (i.e. without using "typedefs"). The
        aggregation of ImplementionDataTypeElement is subject to
        variability with the purpose to support the conditional
        existence of elements inside a ImplementationDataType
        representing a structure.
    :ivar sw_data_def_props: The properties of this
        ImplementationDataTypeElement.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ImplementationDataType.subElement Applicable for:
        ImplementationDataTypeElement.subElement Not Applicable for:
        BswDebugInfo.localDebugData
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IMPLEMENTATION-DATA-TYPE-ELEMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ImplementationDataTypeElement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ImplementationDataTypeElement.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    array_impl_policy: ArrayImplPolicyEnum | None = field(
        default=None,
        metadata={
            "name": "ARRAY-IMPL-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    array_size: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "ARRAY-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    array_size_handling: ArraySizeHandlingEnum | None = field(
        default=None,
        metadata={
            "name": "ARRAY-SIZE-HANDLING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    array_size_semantics: ArraySizeSemanticsEnum | None = field(
        default=None,
        metadata={
            "name": "ARRAY-SIZE-SEMANTICS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_optional: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-OPTIONAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_elements: Optional["ImplementationDataTypeElement.SubElements"] = field(
        default=None,
        metadata={
            "name": "SUB-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubElements:
        implementation_data_type_element: list["ImplementationDataTypeElement"] = field(
            default_factory=list,
            metadata={
                "name": "IMPLEMENTATION-DATA-TYPE-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ImplementationDataTypeSubElementRef:
    """
    This meta-class represents the specialization of SubElementMapping with respect
    to ImplementationDataTypes.

    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SubElementMapping.secondElement Applicable for:
        SubElementMapping.firstElement
    :ivar implementation_data_type_element: This represents the
        referenced implementationDataTypeElement.
    :ivar parameter_implementation_data_type_element: This represents
        the referenced ImplementationDataTypeElement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IMPLEMENTATION-DATA-TYPE-SUB-ELEMENT-REF"

    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_data_type_element: ArVariableInImplementationDataInstanceRef | None = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-DATA-TYPE-ELEMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_implementation_data_type_element: (
        ArParameterInImplementationDataInstanceRef | None
    ) = field(
        default=None,
        metadata={
            "name": "PARAMETER-IMPLEMENTATION-DATA-TYPE-ELEMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class IndicatorStatusNeeds:
    """
    This meta-class shall be taken to signal a service use case that affects the
    indicator status.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar type_value: Defines the type of the indicator.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INDICATOR-STATUS-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IndicatorStatusNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IndicatorStatusNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_value: DiagnosticIndicatorTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class InitEvent:
    """This RTEEvent is supposed to be used for initialization purposes, i.e. for
    starting and restarting a partition.

    It is not guaranteed that all RunnableEntities referenced by this
    InitEvent are executed before the 'regular' RunnableEntities are
    executed for the first time. The execution order depends on the task
    mapping.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INIT-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["InitEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["InitEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "InitEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["InitEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["InitEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class InnerDataPrototypeGroupInCompositionInstanceRef:
    """
    This meta-class represents the ability to define an InstanceRef to a nested
    DataPrototypeGroup.

    :ivar context_sw_component_prototype_ref: This represents the nested
        structure of SwComponentPrototypes.
    :ivar target_data_prototype_group_ref: This represents the target of
        the InstanceRef
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DataPrototypeGroup.dataPrototypeGroup
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INNER-DATA-PROTOTYPE-GROUP-IN-COMPOSITION-INSTANCE-REF"

    context_sw_component_prototype_ref: list[
        "InnerDataPrototypeGroupInCompositionInstanceRef.ContextSwComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_data_prototype_group_ref: Optional[
        "InnerDataPrototypeGroupInCompositionInstanceRef.TargetDataPrototypeGroupRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-DATA-PROTOTYPE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextSwComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetDataPrototypeGroupRef(Ref):
        dest: DataPrototypeGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class InnerRunnableEntityGroupInCompositionInstanceRef:
    """
    This meta-class represents the ability to define an InstanceRef to a nested
    RunnableEntityGroup.

    :ivar context_sw_component_prototype_ref: This represents the nested
        structure of SwComponentPrototypes.
    :ivar target_runnable_entity_group_ref: This represents the target
        association of the InstanceRef.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RunnableEntityGroup.runnableEntityGroup
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INNER-RUNNABLE-ENTITY-GROUP-IN-COMPOSITION-INSTANCE-REF"

    context_sw_component_prototype_ref: list[
        "InnerRunnableEntityGroupInCompositionInstanceRef.ContextSwComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_runnable_entity_group_ref: Optional[
        "InnerRunnableEntityGroupInCompositionInstanceRef.TargetRunnableEntityGroupRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-RUNNABLE-ENTITY-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextSwComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRunnableEntityGroupRef(Ref):
        dest: RunnableEntityGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class InstantiationDataDefProps:
    """This is a general class allowing to apply additional SwDataDefProps to
    particular instantiations of a DataPrototype.

    Typically the accessibility and further information like alias names
    for a  particular data is modeled on the level of DataPrototypes
    (especially  VariableDataPrototypes, ParameterDataPrototypes). But
    due to the recursive  structure of the meta-model concerning data
    types (a composite (data) type consists  out of data prototypes) a
    part of the MCD information is described in the data  type (in case
    of ApplicationCompositeDataType). This is a strong restriction in
    the reuse of data typed because the data type should be re-used  for
    different VariableDataPrototypes and ParameterDataPrototypes to
    guarantee type  compatibility on C-implementation level (e.g. data
    of a Port is stored in PIM  or a ParameterDataPrototype used as ROM
    Block and shall be typed by the same data type as NVRAM Block). This
    class overcomes such a restriction if applied properly.

    :ivar parameter_instance: This reference identifies the particular
        DataPrototype (defined in the context of a composite
        ParameterDataPrototype) on which the swDataDefProps shall be
        applied.
    :ivar sw_data_def_props: These are the particular data definition
        properties which shall be applied
    :ivar variable_instance: This reference identifies the particular
        DataPrototype (defined in the context of a composite
        VariableDataPrototype) on which the swDataDefProps shall be
        applied.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ParameterSwComponentType.instantiationDataDefProps Applicable
        for: SwcInternalBehavior.instantiationDataDefProps Applicable
        for: NvBlockDescriptor.instantiationDataDefProps
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INSTANTIATION-DATA-DEF-PROPS"

    parameter_instance: AutosarParameterRef | None = field(
        default=None,
        metadata={
            "name": "PARAMETER-INSTANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variable_instance: AutosarVariableRef | None = field(
        default=None,
        metadata={
            "name": "VARIABLE-INSTANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class InstantiationTimingEventProps:
    """This meta-class represents the ability to refine a timing event for
    particular instances of a software component.

    This approach supports an instance specific timing.

    :ivar refined_event_iref: This instance ref denotes the Timing Event
        for which the period shall be refined on an instance level.
    :ivar short_label: The main purpose of the shortLabel is to
        contribute to the splitkey of aggregations that are
        &lt;&lt;atpSplitable&gt;&gt;.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CompositionSwComponentType.instantiationRTEEventProps
    :ivar period: This attribute represents the value of the refined
        activation period.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INSTANTIATION-TIMING-EVENT-PROPS"

    refined_event_iref: InstanceEventInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "REFINED-EVENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class InternalTriggerOccurredEvent:
    """
    This event is raised when the referenced InternalTriggeringPoint has occurred.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar event_source_ref: The referenced InternalTriggeringPoint
        raises this InternalTriggerOccurredEvent.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INTERNAL-TRIGGER-OCCURRED-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["InternalTriggerOccurredEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["InternalTriggerOccurredEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "InternalTriggerOccurredEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["InternalTriggerOccurredEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["InternalTriggerOccurredEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_source_ref: Optional["InternalTriggerOccurredEvent.EventSourceRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-SOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventSourceRef(Ref):
        dest: InternalTriggeringPointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class InternalTriggeringPoint:
    """
    If a RunnableEntity owns an InternalTriggeringPoint it is entitled to trigger
    the execution of RunnableEntities of the corresponding software-component.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar return_value_provision: This attribute controls the provision
        of return values for RTE APIs that correspond to the enclosing
        access point.
    :ivar sw_impl_policy: This attribute, when set to value queued,
        allows for a queued processing of Triggers.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RunnableEntity.internalTriggeringPoint
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INTERNAL-TRIGGERING-POINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["InternalTriggeringPoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["InternalTriggeringPoint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    return_value_provision: RteApiReturnValueProvisionEnum | None = field(
        default=None,
        metadata={
            "name": "RETURN-VALUE-PROVISION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_impl_policy: SwImplPolicyEnum | None = field(
        default=None,
        metadata={
            "name": "SW-IMPL-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class InterpolationRoutineMappingSet:
    """
    This meta-class specifies a set of interpolation routine mappings.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar interpolation_routine_mappings: This specifies one particular
        mapping of recordlayout and its matching interpolationRoutines.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INTERPOLATION-ROUTINE-MAPPING-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["InterpolationRoutineMappingSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["InterpolationRoutineMappingSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    interpolation_routine_mappings: Optional[
        "InterpolationRoutineMappingSet.InterpolationRoutineMappings"
    ] = field(
        default=None,
        metadata={
            "name": "INTERPOLATION-ROUTINE-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InterpolationRoutineMappings:
        interpolation_routine_mapping: list[InterpolationRoutineMapping] = field(
            default_factory=list,
            metadata={
                "name": "INTERPOLATION-ROUTINE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class IpIamRemoteSubject:
    """
    This meta-class defines the proxy information about the remote node in case of
    general IP communication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar authentic_connection_propss: Definition of IP rules assigned
        to the IpIamRemoteSubject.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IP-IAM-REMOTE-SUBJECT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IpIamRemoteSubject.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IpIamRemoteSubject.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentic_connection_propss: Optional["IpIamRemoteSubject.AuthenticConnectionPropss"] = field(
        default=None,
        metadata={
            "name": "AUTHENTIC-CONNECTION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AuthenticConnectionPropss:
        ip_iam_authentic_connection_props: list[IpIamAuthenticConnectionProps] = field(
            default_factory=list,
            metadata={
                "name": "IP-IAM-AUTHENTIC-CONNECTION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class IpSecConfigProps:
    """
    This element holds all the attributes for configuration of IPsec that are
    independent of specific IPsec rules.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar ah_cipher_suite_names: AH (Authentication Header) algorithm to
        be used for the connection, e.g. HMAC/SHA2-256
    :ivar dpd_action: This attribute defines what to do if the peer is
        considered dead. If not configured "restart" shall be assumed.
    :ivar dpd_delay: This attribute describes the interval to check the
        liveness of a peer actively using IKEv2 INFORMATIONAL exchanges.
        Active DPD checking is only enforced if no IKE or ESP/AH packet
        has been received for the configured DPD delay. In not
        configured the value "5 minutes" shall be assumed.
    :ivar esp_cipher_suite_names: ESP (Encapsulating Security Payload)
        algorithm that provides encryption and optional authentication
        for the connection, e.g. AES-128+SHA2-256.
    :ivar ike_cipher_suite_name: IKE encryption/authentication
        algorithms to be used for the connection.
    :ivar ike_over_time: This attribute describes the hard deadline when
        an SA becomes invalid in percentage. Example: ikeOverTime of
        max(ikeReauthTime, ikeRekeyTime). Default: 10 %
    :ivar ike_rand_time: This attribute defines in percentage by how
        long before the expiration of ikeReauthTime and ikeRekeyTime
        will be rekeyed/reauthenticated. Default: 10%
    :ivar ike_reauth_time: This attribute defines the absolute time
        after which an IKE SA will be reauthenticated. 0 means
        reauthentication is disabled.
    :ivar ike_rekey_time: This attribute defines the absolute time after
        which an IKE SA will be rekeyed. 0 means rekey is disabled.
    :ivar sa_over_time: This attribute describes the hard deadline when
        an IPsec SA becomes invalid in percentage. Example: saOverTime *
        saRekeyTime. Default: 110%
    :ivar sa_rand_time: This attribute defines by how long before the
        expiration of saRekeyTime will be rekeyed.
    :ivar sa_rekey_time: This attribute defines the absolute time after
        which an IPsec SA will be rekeyed. 0 means rekey is disabled.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IP-SEC-CONFIG-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IpSecConfigProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IpSecConfigProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ah_cipher_suite_names: Optional["IpSecConfigProps.AhCipherSuiteNames"] = field(
        default=None,
        metadata={
            "name": "AH-CIPHER-SUITE-NAMES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dpd_action: IPsecDpdActionEnum | None = field(
        default=None,
        metadata={
            "name": "DPD-ACTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dpd_delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DPD-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    esp_cipher_suite_names: Optional["IpSecConfigProps.EspCipherSuiteNames"] = field(
        default=None,
        metadata={
            "name": "ESP-CIPHER-SUITE-NAMES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ike_cipher_suite_name: String | None = field(
        default=None,
        metadata={
            "name": "IKE-CIPHER-SUITE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ike_over_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "IKE-OVER-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ike_rand_time: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "IKE-RAND-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ike_reauth_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "IKE-REAUTH-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ike_rekey_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "IKE-REKEY-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sa_over_time: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SA-OVER-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sa_rand_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SA-RAND-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sa_rekey_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SA-REKEY-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AhCipherSuiteNames:
        ah_cipher_suite_name: list[String] = field(
            default_factory=list,
            metadata={
                "name": "AH-CIPHER-SUITE-NAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EspCipherSuiteNames:
        esp_cipher_suite_name: list[String] = field(
            default_factory=list,
            metadata={
                "name": "ESP-CIPHER-SUITE-NAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class IpSecIamRemoteSubject:
    """
    This meta-class defines the proxy information about the remote node in case of
    IPsec.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar local_ip_sec_rule_refs: This reference is used to describe
        theRemoteSubjects local IPSecRules.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IP-SEC-IAM-REMOTE-SUBJECT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IpSecIamRemoteSubject.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IpSecIamRemoteSubject.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_ip_sec_rule_refs: Optional["IpSecIamRemoteSubject.LocalIpSecRuleRefs"] = field(
        default=None,
        metadata={
            "name": "LOCAL-IP-SEC-RULE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LocalIpSecRuleRefs:
        local_ip_sec_rule_ref: list[
            "IpSecIamRemoteSubject.LocalIpSecRuleRefs.LocalIpSecRuleRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "LOCAL-IP-SEC-RULE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class LocalIpSecRuleRef(Ref):
            dest: IpSecRuleSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class IpSecRule:
    """
    This element defines an IPsec rule that describes communication traffic that is
    monitored, protected and filtered.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar direction: This attribute defines the direction in which the
        traffic is monitored. If this attribute is not set a
        bidirectional traffic monitoring is assumed.
    :ivar header_type: Header type specifying the IPsec security
        mechanism.
    :ivar ike_authentication_method: This attribute defines the IKE
        authentication method that is used locally and is expected on
        the remote side.
    :ivar ip_protocol: This attribute defines the relevant IP protocol
        used in the Security Policy Database (SPD) entry.
    :ivar local_certificate_refs: This reference identifies the
        applicable certificate used for a local authentication.
    :ivar local_id: This attribute defines how the local participant
        should be identified for authentication.
    :ivar local_port_range_end: This attribute restricts the traffic
        monitoring and defines an end value for the local port range. If
        this attribute is not set then this rule shall be effective for
        all local ports. Please note that port ranges are currently not
        supported in the AUTOSAR AP's operating system backend. If AP
        systems are involved, each IPsec rule may only contain a single
        port.
    :ivar local_port_range_start: This attribute restricts the traffic
        monitoring and defines a start value for the local port range.
        If this attribute is not set then this rule shall be effective
        for all local ports. Please note that port ranges are currently
        not supported in the AUTOSAR AP's operating system backend. If
        AP systems are involved, each IPsec rule may only contain a
        single port.
    :ivar mode: This attribute defines the type of the connection.
    :ivar policy: An IPsec policy defines the rules that determine which
        type of IP traffic needs to be secured using IPsec and how that
        traffic is secured.
    :ivar pre_shared_key_ref: This reference identifies the applicable
        cryptograhic key used for authentication.
    :ivar priority: This attribute defines the priority of the IPSecRule
        (SPD entry). The processing of entries is based on priority,
        starting with the highest priority "0".
    :ivar remote_certificate_refs: This reference identifies the
        applicable certificate used for a remote authentication.
    :ivar remote_id: This attribute defines how the remote participant
        should be identified for authentication.
    :ivar remote_ip_address_refs: Definition of the remote
        NetworkEndpoint. With this reference the connection between the
        local NetworkEndpoint and the remote NetworkEndpoint is
        described on which the traffic is monitored.
    :ivar remote_port_range_end: This attribute restricts the traffic
        monitoring and defines an end value for the remote port range.
        If this attribute is not set then this rule shall be effective
        for all local ports. Please note that port ranges are currently
        not supported in the AUTOSAR AP's operating system backend. If
        AP systems are involved, each IPsec rule may only contain a
        single port.
    :ivar remote_port_range_start: This attribute restricts the traffic
        monitoring and defines a start value for the remote port range.
        If this attribute is not set then this rule shall be effective
        for all local ports. Please note that port ranges are currently
        not supported in the AUTOSAR AP's operating system backend. If
        AP systems are involved, each IPsec rule may only contain a
        single port.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IP-SEC-RULE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IpSecRule.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IpSecRule.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    direction: CommunicationDirectionType | None = field(
        default=None,
        metadata={
            "name": "DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    header_type: IPsecHeaderTypeEnum | None = field(
        default=None,
        metadata={
            "name": "HEADER-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ike_authentication_method: IkeAuthenticationMethodEnum | None = field(
        default=None,
        metadata={
            "name": "IKE-AUTHENTICATION-METHOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ip_protocol: IPsecIpProtocolEnum | None = field(
        default=None,
        metadata={
            "name": "IP-PROTOCOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_certificate_refs: Optional["IpSecRule.LocalCertificateRefs"] = field(
        default=None,
        metadata={
            "name": "LOCAL-CERTIFICATE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_id: String | None = field(
        default=None,
        metadata={
            "name": "LOCAL-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_port_range_end: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOCAL-PORT-RANGE-END",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_port_range_start: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOCAL-PORT-RANGE-START",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode: IPsecModeEnum | None = field(
        default=None,
        metadata={
            "name": "MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    policy: IPsecPolicyEnum | None = field(
        default=None,
        metadata={
            "name": "POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pre_shared_key_ref: Optional["IpSecRule.PreSharedKeyRef"] = field(
        default=None,
        metadata={
            "name": "PRE-SHARED-KEY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_certificate_refs: Optional["IpSecRule.RemoteCertificateRefs"] = field(
        default=None,
        metadata={
            "name": "REMOTE-CERTIFICATE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_id: String | None = field(
        default=None,
        metadata={
            "name": "REMOTE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_ip_address_refs: Optional["IpSecRule.RemoteIpAddressRefs"] = field(
        default=None,
        metadata={
            "name": "REMOTE-IP-ADDRESS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_port_range_end: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "REMOTE-PORT-RANGE-END",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_port_range_start: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "REMOTE-PORT-RANGE-START",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LocalCertificateRefs:
        local_certificate_ref: list["IpSecRule.LocalCertificateRefs.LocalCertificateRef"] = field(
            default_factory=list,
            metadata={
                "name": "LOCAL-CERTIFICATE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class LocalCertificateRef(Ref):
            dest: CryptoServiceCertificateSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PreSharedKeyRef(Ref):
        dest: CryptoServiceKeySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RemoteCertificateRefs:
        remote_certificate_ref: list["IpSecRule.RemoteCertificateRefs.RemoteCertificateRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "REMOTE-CERTIFICATE-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class RemoteCertificateRef(Ref):
            dest: CryptoServiceCertificateSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RemoteIpAddressRefs:
        remote_ip_address_ref: list["IpSecRule.RemoteIpAddressRefs.RemoteIpAddressRef"] = field(
            default_factory=list,
            metadata={
                "name": "REMOTE-IP-ADDRESS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RemoteIpAddressRef(Ref):
            dest: NetworkEndpointSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class Ipv4DhcpServerConfiguration:
    """
    Defines the configuration of a IPv4 DHCP server that runs on the network
    endpoint.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar address_range_lower_bound: Lower range of IP addresses to be
        issued to DHCP clients. IPv4 Address. Notation: 255.255.255.255.
    :ivar address_range_upper_bound: Upper range of IP addresses to be
        issued to DHCP clients. Pv4 Address. Notation: 255.255.255.255.
    :ivar default_gateway: IP address of the default gateway. Notation
        255.255.255.255
    :ivar default_lease_time: Amount of time in seconds that a client
        may keep the IP address.
    :ivar dns_server_addresses: IP addresses of preconfigured DNS
        servers. Notation 255.255.255.255
    :ivar network_mask: Default network mask to be used by DHCP clients.
        Notation 255.255.255.255
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-4-DHCP-SERVER-CONFIGURATION"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    address_range_lower_bound: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "ADDRESS-RANGE-LOWER-BOUND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    address_range_upper_bound: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "ADDRESS-RANGE-UPPER-BOUND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_gateway: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-GATEWAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_lease_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-LEASE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dns_server_addresses: Optional["Ipv4DhcpServerConfiguration.DnsServerAddresses"] = field(
        default=None,
        metadata={
            "name": "DNS-SERVER-ADDRESSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_mask: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "NETWORK-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DnsServerAddresses:
        dns_server_address: list[Ip4AddressString] = field(
            default_factory=list,
            metadata={
                "name": "DNS-SERVER-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Ipv6DhcpServerConfiguration:
    """
    Defines the configuration of a IPv6 DHCP server that runs on the network
    endpoint.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar address_range_lower_bound: Lower range of IP addresses to be
        issued to DHCP clients.  IPv6 Address. Notation: FFFF:...:FFFF.
    :ivar address_range_upper_bound: Upper range of IP addresses to be
        issued to DHCP clients. IPv6 Address. Notation: FFFF:...:FFFF.
    :ivar default_gateway: IP address of the default gateway. Notation
        255.255.255.255
    :ivar default_lease_time: Amount of time in seconds that a client
        may keep the IP address.
    :ivar dns_server_addresses: IP addresses of preconfigured DNS
        servers. Notation: FFFF:...:FFFF.
    :ivar network_mask: Default network mask to be used by DHCP clients.
        Notation 255.255.255.255
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IPV-6-DHCP-SERVER-CONFIGURATION"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    address_range_lower_bound: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "ADDRESS-RANGE-LOWER-BOUND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    address_range_upper_bound: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "ADDRESS-RANGE-UPPER-BOUND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_gateway: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-GATEWAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_lease_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-LEASE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dns_server_addresses: Optional["Ipv6DhcpServerConfiguration.DnsServerAddresses"] = field(
        default=None,
        metadata={
            "name": "DNS-SERVER-ADDRESSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_mask: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "NETWORK-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DnsServerAddresses:
        dns_server_address: list[Ip6AddressString] = field(
            default_factory=list,
            metadata={
                "name": "DNS-SERVER-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class J1939ControllerApplication:
    """
    This element represents a J1939 controller application.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar function_id: This attribute represents the numerical function
        id of the J1939 controller application.
    :ivar sw_component_prototype_iref: This represents the
        SwComponentPrototype (which is typically typed by a
        CompositionSwComponentType) that corresponds to the
        J1939ControllerApplication.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-CONTROLLER-APPLICATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["J1939ControllerApplication.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["J1939ControllerApplication.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    function_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FUNCTION-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_prototype_iref: ComponentInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SW-COMPONENT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class J1939DcmDm19Support:
    """
    The software-component provides information about calibration verification
    numbers for inclusion in DM19.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-DCM-DM-19-SUPPORT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["J1939DcmDm19Support.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["J1939DcmDm19Support.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class J1939DcmIPdu:
    """
    Represents the IPdus handled by J1939Dcm.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar has_dynamic_length: This attribute defines whether the Pdu has
        dynamic length (true) or not (false). Please note that the usage
        of this attribute is restricted by [constr_3448].
    :ivar length: Pdu length in bytes. In case of dynamic length IPdus
        (containing a dynamical length signal), this value indicates the
        maximum data length. It should be noted that in former AUTOSAR
        releases (Rel 2.1, Rel 3.0, Rel 3.1, Rel 4.0 Rev. 1) this
        parameter was defined in bits. The Pdu length of zero bytes is
        allowed.
    :ivar meta_data_length: Number of additional bytes of MetaData in
        the PDU data field. The MetaData contains auxiliary information
        for the PDU, e.g. the CAN ID.
    :ivar contained_i_pdu_props: Defines whether this IPdu may be
        collected inside a ContainerIPdu.
    :ivar diagnostic_message_type: This attribute is used to identify
        the actual DMx message, e.g 1 means DM01, etc.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-DCM-I-PDU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["J1939DcmIPdu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["J1939DcmIPdu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_dynamic_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-DYNAMIC-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "META-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_i_pdu_props: ContainedIPduProps | None = field(
        default=None,
        metadata={
            "name": "CONTAINED-I-PDU-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_message_type: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-MESSAGE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class J1939NmNode:
    """
    J1939 specific NM Node attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar controller_ref: Association to an CommunicationController in
        the topology description.
    :ivar machine_ref: Reference to the machine that contains the
        NmNode.
    :ivar nm_coord_cluster: NmCoordinationCluster identification number.
    :ivar nm_coordinator_role: This attribute indicates the role the NM
        Coordinator will have on this channel.
    :ivar nm_if_ecu_ref: Reference to the NmEcu that contains this
        NmNode. (CommunicationController that is referenced by the
        NmNode shall be contained in the EcuInstance that is referenced
        by the NmEcu).
    :ivar nm_node_id: Node identifier of local NmNode. Shall be unique
        in the NmCluster.
    :ivar nm_passive_mode_enabled: Enables support of the Passive Mode.
        The passive mode is configurable per channel.
    :ivar rx_nm_pdu_refs: receive NM Pdu.
    :ivar tx_nm_pdu_refs: transmit NM Pdu
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: NmCluster.nmNode
    :ivar node_name: NodeName configuration
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-NM-NODE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["J1939NmNode.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["J1939NmNode.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    controller_ref: Optional["J1939NmNode.ControllerRef"] = field(
        default=None,
        metadata={
            "name": "CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    machine_ref: Optional["J1939NmNode.MachineRef"] = field(
        default=None,
        metadata={
            "name": "MACHINE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_coord_cluster: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-COORD-CLUSTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_coordinator_role: NmCoordinatorRoleEnum | None = field(
        default=None,
        metadata={
            "name": "NM-COORDINATOR-ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_if_ecu_ref: Optional["J1939NmNode.NmIfEcuRef"] = field(
        default=None,
        metadata={
            "name": "NM-IF-ECU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_id: Integer | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_passive_mode_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-PASSIVE-MODE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rx_nm_pdu_refs: Optional["J1939NmNode.RxNmPduRefs"] = field(
        default=None,
        metadata={
            "name": "RX-NM-PDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tx_nm_pdu_refs: Optional["J1939NmNode.TxNmPduRefs"] = field(
        default=None,
        metadata={
            "name": "TX-NM-PDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    node_name: J1939NodeName | None = field(
        default=None,
        metadata={
            "name": "NODE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ControllerRef(Ref):
        dest: CommunicationControllerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MachineRef(Ref):
        dest: MachineDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NmIfEcuRef(Ref):
        dest: NmEcuSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RxNmPduRefs:
        rx_nm_pdu_ref: list["J1939NmNode.RxNmPduRefs.RxNmPduRef"] = field(
            default_factory=list,
            metadata={
                "name": "RX-NM-PDU-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RxNmPduRef(Ref):
            dest: NmPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TxNmPduRefs:
        tx_nm_pdu_ref: list["J1939NmNode.TxNmPduRefs.TxNmPduRef"] = field(
            default_factory=list,
            metadata={
                "name": "TX-NM-PDU-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TxNmPduRef(Ref):
            dest: NmPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class J1939RmIncomingRequestServiceNeeds:
    """
    "This meta-class shall be used to specify needs with respect to the
    configuration of the J1939Rm, in particular for the case where an
    ApplicationSwComponentType needs to accept a request from another J1939 node.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-RM-INCOMING-REQUEST-SERVICE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["J1939RmIncomingRequestServiceNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["J1939RmIncomingRequestServiceNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class J1939RmOutgoingRequestServiceNeeds:
    """
    This meta-class shall be used to specify needs with respect to the
    configuration of the J1939Rm, in particular for the case where an
    ApplicationSwComponentType needs to send a request to another J1939 node.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-RM-OUTGOING-REQUEST-SERVICE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["J1939RmOutgoingRequestServiceNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["J1939RmOutgoingRequestServiceNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class J1939SharedAddressCluster:
    """
    This meta-class represents the ability to identify several J1939Clusters that
    share a common address space for the routing of messages.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar participating_j_1939_cluster_refs: This identifies the
        J1939Clusters that share a common address space
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        System.j1939SharedAddressCluster
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-SHARED-ADDRESS-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["J1939SharedAddressCluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["J1939SharedAddressCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    participating_j_1939_cluster_refs: Optional[
        "J1939SharedAddressCluster.ParticipatingJ1939ClusterRefs"
    ] = field(
        default=None,
        metadata={
            "name": "PARTICIPATING-J-1939-CLUSTER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ParticipatingJ1939ClusterRefs:
        participating_j_1939_cluster_ref: list[
            "J1939SharedAddressCluster.ParticipatingJ1939ClusterRefs.ParticipatingJ1939ClusterRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "PARTICIPATING-J-1939-CLUSTER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ParticipatingJ1939ClusterRef(Ref):
            dest: J1939ClusterSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class J1939TpConnection:
    """A J1939TpConnection represents an internal path for the transmission or
    reception of a Pdu via J1939Tp and describes the sender and the receiver of
    this particular communication.

    The J1939Tp module routes a Pdu (J1939 PGN) through the connection.

    :ivar ident: This adds the ability to become referrable to
        TpConnection.
    :ivar broadcast: BAM (Broadcast Announce Message)  is a broadcast
        protocol. If this attribute is set to true broadcast is used.
        Since address FF is the only broadcast address, there's no
        reason to configure it.
    :ivar buffer_ratio: Defines usage of available data for dynamic
        block size calculation when protocol retry is enabled. This
        attribute describes in percent of available buffer that shall be
        used for retry.
    :ivar cancellation: Enable support for Tx/Rx cancellation.
    :ivar data_pdu_ref: Data Message (TP.DT) used by CMDT and BAM. The
        DataNPdu has a fixed length of 8 bytes.
    :ivar direct_pdu_ref: Please note that this reference is deprecated
        and will be removed in the future. This reference is replaced by
        the J1939TpPg.directPdu reference. Old description: In case of
        variable length IPdus (with system signals of variable length),
        an additional NPdu (with the PGN in the CAN ID) is used for
        messages with up to 8 bytes.
    :ivar dynamic_bs: Enable support for dynamic block size calculation.
    :ivar flow_control_pdu_refs: Reference to the Command NPdus (TP.CM)
        that are used in the CMDT (Connection Mode Data Transfer) in
        both directions. BAM uses one TP.CM (Transport Protocol
        Command). The flowControlNPdu has a fixed length of 8 bytes.
        Please note that the role name "flowControlIPdu" is misleading
        and is kept for backward compatibilty reasons.
    :ivar max_bs: Set maximum block size (number of packets in
        TP.CM_CTS).
    :ivar max_exp_bs: Set maximum for expected block size (maximum
        number of packets in TP.CM_RTS).
    :ivar receiver_refs: The target of the TP connection.
    :ivar retry: Enable support for protocol retry.
    :ivar tp_pgs: J1939 messages (parameter groups, PGs) that can be
        transferred via this connection.
    :ivar tp_sdu_refs: Please note that this reference is deprecated and
        will be removed in the future. This reference is replaced by the
        J1939TpPg.tpSdu reference. Old description: Reference to IPdus
        that are segmented by the Transport Protocol. To support the
        low-level routing of NPdu's the NPdu is a specialization of an
        IPdu. More details can be found in the NPdu class description.
        Nevertheless the J1939TpConnection must not reference a NPdu
        with this tpSdu reference.
    :ivar transmitter_ref: The source of the TP connection.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        J1939TpConfig.tpConnection
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-TP-CONNECTION"

    ident: TpConnectionIdent | None = field(
        default=None,
        metadata={
            "name": "IDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    broadcast: Boolean | None = field(
        default=None,
        metadata={
            "name": "BROADCAST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    buffer_ratio: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BUFFER-RATIO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cancellation: Boolean | None = field(
        default=None,
        metadata={
            "name": "CANCELLATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_pdu_ref: Optional["J1939TpConnection.DataPduRef"] = field(
        default=None,
        metadata={
            "name": "DATA-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    direct_pdu_ref: Optional["J1939TpConnection.DirectPduRef"] = field(
        default=None,
        metadata={
            "name": "DIRECT-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_bs: Boolean | None = field(
        default=None,
        metadata={
            "name": "DYNAMIC-BS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    flow_control_pdu_refs: Optional["J1939TpConnection.FlowControlPduRefs"] = field(
        default=None,
        metadata={
            "name": "FLOW-CONTROL-PDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_bs: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-BS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_exp_bs: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-EXP-BS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    receiver_refs: Optional["J1939TpConnection.ReceiverRefs"] = field(
        default=None,
        metadata={
            "name": "RECEIVER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    retry: Boolean | None = field(
        default=None,
        metadata={
            "name": "RETRY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_pgs: Optional["J1939TpConnection.TpPgs"] = field(
        default=None,
        metadata={
            "name": "TP-PGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_sdu_refs: Optional["J1939TpConnection.TpSduRefs"] = field(
        default=None,
        metadata={
            "name": "TP-SDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmitter_ref: Optional["J1939TpConnection.TransmitterRef"] = field(
        default=None,
        metadata={
            "name": "TRANSMITTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataPduRef(Ref):
        dest: NPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DirectPduRef(Ref):
        dest: NPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FlowControlPduRefs:
        flow_control_pdu_ref: list["J1939TpConnection.FlowControlPduRefs.FlowControlPduRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "FLOW-CONTROL-PDU-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                    "max_occurs": 2,
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class FlowControlPduRef(Ref):
            dest: NPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ReceiverRefs:
        receiver_ref: list["J1939TpConnection.ReceiverRefs.ReceiverRef"] = field(
            default_factory=list,
            metadata={
                "name": "RECEIVER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ReceiverRef(Ref):
            dest: J1939TpNodeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TpPgs:
        j_1939_tp_pg: list[J1939TpPg] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-TP-PG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpSduRefs:
        tp_sdu_ref: list["J1939TpConnection.TpSduRefs.TpSduRef"] = field(
            default_factory=list,
            metadata={
                "name": "TP-SDU-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TpSduRef(Ref):
            dest: IPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TransmitterRef(Ref):
        dest: J1939TpNodeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class J1939TpNode:
    """
    TP Node (Sender or Receiver) provides the TP Address and the connection to the
    Topology description.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar connector_ref: Association to a CommunicationConnector in the
        topology description. In a System Description this reference is
        mandatory. In an ECU Extract this reference is optional
        (references to ECUs that are not part of the ECU Extract shall
        be avoided).
    :ivar tp_address_ref: Reference to the TP Address that is used by
        the TpNode. This reference is optional only when no TP is sent
        and only BAM is received.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: J1939TpConfig.tpNode
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-TP-NODE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["J1939TpNode.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["J1939TpNode.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    connector_ref: Optional["J1939TpNode.ConnectorRef"] = field(
        default=None,
        metadata={
            "name": "CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_address_ref: Optional["J1939TpNode.TpAddressRef"] = field(
        default=None,
        metadata={
            "name": "TP-ADDRESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TpAddressRef(Ref):
        dest: TpAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Keyword:
    """This meta-class represents the ability to predefine keywords which may
    subsequently be used to construct names following a given naming convention,
    e.g. the AUTOSAR naming conventions.

    Note that such names is not only shortName. It could be symbol, or
    even longName. Application of keywords is not limited to particular
    names.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar abbr_name: This attribute specifies an abbreviated name of a
        keyword. This abbreviation may e.g. be used for constructing
        valid shortNames according to  the AUTOSAR naming conventions.
        Unlike shortName, it may contain any name token. E.g. it may
        consist of digits only.
    :ivar classifications: This attribute allows to attach
        classification to the Keyword such as MEAN, ACTION, CONDITION,
        INDEX, PREPOSITION
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "KEYWORD"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Keyword.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Keyword.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    abbr_name: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "ABBR-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    classifications: Optional["Keyword.Classifications"] = field(
        default=None,
        metadata={
            "name": "CLASSIFICATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Classifications:
        classification: list[NmtokenString] = field(
            default_factory=list,
            metadata={
                "name": "CLASSIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LatencyTimingConstraint:
    """This constraint type restricts the time duration between the occurrence of
    the stimulus and the occurrence of the corresponding response of that chain.

    Two latency constraint types are of interest for automotive systems.
    These are the age of a certain response and the reaction to a
    certain stimulus. In contrast to OffsetTimingConstraint, a causal
    dependency between the stimulus and response event of the associated
    event chain is required.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar timing_condition_ref: A timing condition the timing constraint
        depends on. In other words it specifies the condition the timing
        constraint holds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingRequirement Applicable for:
        TimingExtension.timingGuarantee
    :ivar latency_constraint_type: The specific type of this latency
        constraint.
    :ivar scope_ref: The event chain that defines the scope of the
        constraint.
    :ivar minimum: The minimum latency between the occurrence of the
        stimulus and the occurrence of the corresponding response of the
        associated event chain.
    :ivar maximum: The maximum latency between the occurrence of the
        stimulus and the occurrence of the corresponding response of the
        associated event chain.
    :ivar nominal: The nominal latency between the occurrence of the
        stimulus and the occurrence of the corresponding response of the
        associated event chain.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LATENCY-TIMING-CONSTRAINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LatencyTimingConstraint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LatencyTimingConstraint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["LatencyTimingConstraint.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_condition_ref: Optional["LatencyTimingConstraint.TimingConditionRef"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    latency_constraint_type: LatencyConstraintTypeEnum | None = field(
        default=None,
        metadata={
            "name": "LATENCY-CONSTRAINT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope_ref: Optional["LatencyTimingConstraint.ScopeRef"] = field(
        default=None,
        metadata={
            "name": "SCOPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MINIMUM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nominal: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "NOMINAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["LatencyTimingConstraint.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimingConditionRef(Ref):
        dest: TimingConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ScopeRef(Ref):
        dest: TimingDescriptionEventChainSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class LifeCycleInfoSet:
    """This meta class represents the ability to attach a life cycle  information
    to a particular set of elements.

    The information can be defined for a particular period. This
    supports the definition of transition plans. If no period is
    specified, the life cycle state applies forever.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar default_lc_state_ref: This denotes the default life cycle
        state. To be used in all LifeCycleInfo elements within the
        LifeCycleInfoSet if no life cycle state is stated there
        explicitly. I.e. the defaultLcState can be overwritten in
        LifeCycleInfo elements.
    :ivar default_period_begin: Default starting point of period in
        which all the specified lifeCycleInfo apply. Note that the
        default period can be overridden for each lifeCycleInfo
        individually.
    :ivar default_period_end: Default expiry date, i.e. default end
        point of period for which all specified lifeCycleInfo apply.
        Note that the default period can be overridden for each
        lifeCycleInfo individually.
    :ivar life_cycle_infos: This represents one particular life cycle
        information.
    :ivar used_life_cycle_state_definition_group_ref: This denotes the
        life cycle states applicable to the current life cycle info set.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIFE-CYCLE-INFO-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LifeCycleInfoSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LifeCycleInfoSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_lc_state_ref: Optional["LifeCycleInfoSet.DefaultLcStateRef"] = field(
        default=None,
        metadata={
            "name": "DEFAULT-LC-STATE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_period_begin: LifeCyclePeriod | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-PERIOD-BEGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_period_end: LifeCyclePeriod | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-PERIOD-END",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    life_cycle_infos: Optional["LifeCycleInfoSet.LifeCycleInfos"] = field(
        default=None,
        metadata={
            "name": "LIFE-CYCLE-INFOS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    used_life_cycle_state_definition_group_ref: Optional[
        "LifeCycleInfoSet.UsedLifeCycleStateDefinitionGroupRef"
    ] = field(
        default=None,
        metadata={
            "name": "USED-LIFE-CYCLE-STATE-DEFINITION-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DefaultLcStateRef(Ref):
        dest: LifeCycleStateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class LifeCycleInfos:
        life_cycle_info: list[LifeCycleInfo] = field(
            default_factory=list,
            metadata={
                "name": "LIFE-CYCLE-INFO",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class UsedLifeCycleStateDefinitionGroupRef(Ref):
        dest: LifeCycleStateDefinitionGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class LifeCycleState:
    """
    This meta class represents one particular state in the LifeCycle.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIFE-CYCLE-STATE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LifeCycleState.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LifeCycleState.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["LifeCycleState.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LinMasterConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar wake_up_by_controller_supported: Defines whether the ECU shall
        be woken up by this CommunicationController. TRUE: wake up is
        possible FALSE: wake up is not supported Note: If
        wakeUpByControllerSupported is set to TRUE the feature shall be
        supported by both hardware and basic software.
    :ivar protocol_version: Version specifier for a communication
        protocol.
    :ivar lin_slaves: LinSlaves that are handled by the LinMaster.
    :ivar time_base: Time base is mandatory for the master. It is not
        used for slaves. LIN 2.0 Spec states: "The time_base value
        specifies the used time base in the master node to generate the
        maximum allowed frame transfer time." The time base shall be
        specified AUTOSAR conform in seconds.
    :ivar time_base_jitter: The attribute timeBaseJitter is a mandatory
        attribute for the master and not used for slaves. LIN 2.0 Spec
        states: "The jitter value specifies the differences between the
        maximum and minimum delay from time base start point to the
        frame header sending start point (falling edge of BREAK
        signal)." The jitter shall be specified AUTOSAR conform in
        seconds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-MASTER-CONDITIONAL"

    wake_up_by_controller_supported: Boolean | None = field(
        default=None,
        metadata={
            "name": "WAKE-UP-BY-CONTROLLER-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_version: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lin_slaves: Optional["LinMasterConditional.LinSlaves"] = field(
        default=None,
        metadata={
            "name": "LIN-SLAVES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_base: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-BASE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_base_jitter: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-BASE-JITTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class LinSlaves:
        lin_slave_config: list[LinSlaveConfig] = field(
            default_factory=list,
            metadata={
                "name": "LIN-SLAVE-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LinScheduleTable:
    """The master task (in the master node) transmits frame headers based on a
    schedule table.

    The schedule table specifies the identifiers for each header and the
    interval between the start of a frame and the start of the following
    frame.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar resume_position: Defines, where a schedule table shall be
        proceeded in case if it has been interrupted by a run-once table
        or MRF/SRF.
    :ivar run_mode: The schedule table can be executed in two different
        modes.
    :ivar table_entrys: The scheduling table consists of table entries,
        which contain Frame slots.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        LinPhysicalChannel.scheduleTable
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-SCHEDULE-TABLE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LinScheduleTable.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LinScheduleTable.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resume_position: ResumePosition | None = field(
        default=None,
        metadata={
            "name": "RESUME-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    run_mode: RunMode | None = field(
        default=None,
        metadata={
            "name": "RUN-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    table_entrys: Optional["LinScheduleTable.TableEntrys"] = field(
        default=None,
        metadata={
            "name": "TABLE-ENTRYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TableEntrys:
        application_entry: list[ApplicationEntry] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-ENTRY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        assign_frame_id: list[AssignFrameId] = field(
            default_factory=list,
            metadata={
                "name": "ASSIGN-FRAME-ID",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        assign_frame_id_range: list[AssignFrameIdRange] = field(
            default_factory=list,
            metadata={
                "name": "ASSIGN-FRAME-ID-RANGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        assign_nad: list[AssignNad] = field(
            default_factory=list,
            metadata={
                "name": "ASSIGN-NAD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        conditional_change_nad: list[ConditionalChangeNad] = field(
            default_factory=list,
            metadata={
                "name": "CONDITIONAL-CHANGE-NAD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        data_dump_entry: list[DataDumpEntry] = field(
            default_factory=list,
            metadata={
                "name": "DATA-DUMP-ENTRY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        free_format: list[FreeFormat] = field(
            default_factory=list,
            metadata={
                "name": "FREE-FORMAT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        save_configuration_entry: list[SaveConfigurationEntry] = field(
            default_factory=list,
            metadata={
                "name": "SAVE-CONFIGURATION-ENTRY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        unassign_frame_id: list[UnassignFrameId] = field(
            default_factory=list,
            metadata={
                "name": "UNASSIGN-FRAME-ID",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LinSlaveConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar wake_up_by_controller_supported: Defines whether the ECU shall
        be woken up by this CommunicationController. TRUE: wake up is
        possible FALSE: wake up is not supported Note: If
        wakeUpByControllerSupported is set to TRUE the feature shall be
        supported by both hardware and basic software.
    :ivar protocol_version: Version specifier for a communication
        protocol.
    :ivar assign_nad: This attribute has the ability to control whether
        the node configuration command 'Assign NAD' is supported.
    :ivar configured_nad: To distinguish LIN slaves that are used twice
        or more within the same cluster.
    :ivar function_id: LIN function ID
    :ivar initial_nad: This attribute represents the initial NAD.
    :ivar lin_error_response: Each slave node shall publish one response
        error in one of its transmitted unconditional frames.
    :ivar nas_timeout: Value of the N_AS timeout. Unit: seconds.
    :ivar save_configuration: This attribute has the ability to decide
        whether the node configuration command 'Save Configuration' is
        supported.
    :ivar supplier_id: LIN Supplier ID
    :ivar variant_id: Specifies the Variant ID
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-SLAVE-CONDITIONAL"

    wake_up_by_controller_supported: Boolean | None = field(
        default=None,
        metadata={
            "name": "WAKE-UP-BY-CONTROLLER-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_version: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assign_nad: Boolean | None = field(
        default=None,
        metadata={
            "name": "ASSIGN-NAD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configured_nad: Integer | None = field(
        default=None,
        metadata={
            "name": "CONFIGURED-NAD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    function_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FUNCTION-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_nad: Integer | None = field(
        default=None,
        metadata={
            "name": "INITIAL-NAD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lin_error_response: LinErrorResponse | None = field(
        default=None,
        metadata={
            "name": "LIN-ERROR-RESPONSE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nas_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NAS-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    save_configuration: Boolean | None = field(
        default=None,
        metadata={
            "name": "SAVE-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    supplier_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SUPPLIER-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variant_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VARIANT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class LinTpConnection:
    """A LinTP channel represents an internal path for the transmission or
    reception of a Pdu via LinTp and describes the sender and the receiver of this
    particular communication.

    LinTp supports (per Lin Cluster) the configuration of one Rx Tp-SDU
    and one Tx Tp-SDU per NAD the LinMaster uses to address one or more
    of its Lin Slaves. To support this an arbitrary number of
    LinTpConnections shall be described.

    :ivar ident: This adds the ability to become referrable to
        TpConnection.
    :ivar data_pdu_ref: Reference to an NPdu (Single Frame, First Frame
        or Consecutive Frame). The Single Frame network protocol data
        unit (SF N_PDU) shall be sent out by the sending network entity
        and can be received by one or multiple receiving network
        entities. The Single Frame (SF N_PDU) shall be sent out to
        transfer a service data unit that can be transferred via a
        single service request to the data link layer. This network
        protocol data unit shall be sent to transfer unsegmented
        messages. The First Frame network protocol data unit (FF N_PDU)
        identifies the first network protocol data unit (N_PDU) of a
        segmented message transmitted by a network sending entity and
        received by a receiving network entity. The Consecutive Frame
        network protocol data unit (CF N_PDU) transfers segments
        (N_Data) of the service data unit message data
        (&lt;MessageData&gt;). All network protocol data units (N_PDUs)
        transmitted by the sending entity after the First Frame network
        protocol data unit (FF N_PDU) shall be encoded as Consecutive
        Frames network protocol data units (CF N_PDUs).
    :ivar drop_not_requested_nad: Configures if TP Frames of not
        requested LIN-Slaves are dropped or not. Please note that this
        attribute is replaced by LinTpNode.dropNotRequestedNad and shall
        no longer be used.
    :ivar flow_control_ref: Reference to the  Flow Control NPdu. The
        Flow Control network protocol data unit (FC N_PDU) is identified
        by the Flow Control protocol control information (FC N_PCI). The
        Flow Control network protocol data unit (FC N_PDU) instructs a
        sending network entity to start, stop or resume transmission of
        CF N_PDUs. The Flow Control network protocol data unit shall be
        sent by the receiving network layer entity to the sending
        network layer entity, when ready to receive more data, after
        correct reception of: a) First Frame network protocol data unit
        (FF N_PDU) b) the last Consecutive Frame network protocol data
        unit (CF N_PDU) of a block of Consecutive Frames (CF N_PDU) if
        further Consecutive Frame network protocol data unit (CF N_PDU)
        need(s) to be sent.
    :ivar lin_tp_n_sdu_ref: Reference to the IPdu that is segmented by
        the Transport Protocol.
    :ivar max_number_of_resp_pending_frames: Configures the maximum
        number of allowed response pending frames. Please note that this
        attribute is replaced by LinTpNode.maxNumberOfRespPendingFrames
        and shall no longer be used.
    :ivar multicast_ref: TP address for 1:n connections.
    :ivar p_2_max: After reception of a response pending frame the P2
        timeout counter is reloaded with the timeout time P2max. Please
        note that this attribute is replaced by LinTpNode.p2Max and
        shall no longer be used.
    :ivar p_2_timing: P2 timeout observation parameter. Please note that
        this attribute is replaced by LinTpNode.p2Timing and shall no
        longer be used.
    :ivar receiver_refs: The target of the TP connection.
    :ivar timeout_as: Time for transmission of the LIN frame (any N-PDU)
        on the sender side. Specified in seconds.
    :ivar timeout_cr: This attribute defines the timeout value for
        waiting for a CF or FF-x (in case of retry) after receiving the
        last CF or after sending an FC or AF on the receiver side.
        Specified in seconds.
    :ivar timeout_cs: The attribute timeoutCs represents the time (in
        seconds) which elapses between the transmit request of a CF
        N-PDU until the transmit request of the next CF N-PDU.
    :ivar transmitter_ref: The source of the TP connection.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        LinTpConfig.tpConnection
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-TP-CONNECTION"

    ident: TpConnectionIdent | None = field(
        default=None,
        metadata={
            "name": "IDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_pdu_ref: Optional["LinTpConnection.DataPduRef"] = field(
        default=None,
        metadata={
            "name": "DATA-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    drop_not_requested_nad: Boolean | None = field(
        default=None,
        metadata={
            "name": "DROP-NOT-REQUESTED-NAD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    flow_control_ref: Optional["LinTpConnection.FlowControlRef"] = field(
        default=None,
        metadata={
            "name": "FLOW-CONTROL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lin_tp_n_sdu_ref: Optional["LinTpConnection.LinTpNSduRef"] = field(
        default=None,
        metadata={
            "name": "LIN-TP-N-SDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_resp_pending_frames: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-RESP-PENDING-FRAMES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multicast_ref: Optional["LinTpConnection.MulticastRef"] = field(
        default=None,
        metadata={
            "name": "MULTICAST-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_2_max: TimeValue | None = field(
        default=None,
        metadata={
            "name": "P-2-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_2_timing: TimeValue | None = field(
        default=None,
        metadata={
            "name": "P-2-TIMING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    receiver_refs: Optional["LinTpConnection.ReceiverRefs"] = field(
        default=None,
        metadata={
            "name": "RECEIVER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_as: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-AS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_cr: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-CR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_cs: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-CS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmitter_ref: Optional["LinTpConnection.TransmitterRef"] = field(
        default=None,
        metadata={
            "name": "TRANSMITTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataPduRef(Ref):
        dest: NPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FlowControlRef(Ref):
        dest: NPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class LinTpNSduRef(Ref):
        dest: IPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MulticastRef(Ref):
        dest: TpAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ReceiverRefs:
        receiver_ref: list["LinTpConnection.ReceiverRefs.ReceiverRef"] = field(
            default_factory=list,
            metadata={
                "name": "RECEIVER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ReceiverRef(Ref):
            dest: LinTpNodeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TransmitterRef(Ref):
        dest: LinTpNodeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class LinTpNode:
    """
    TP Node (Sender or Receiver) provides the TP Address and the connection to the
    Topology description.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar connector_ref: Association to a CommunicationConnector in the
        topology description. In a System Description this reference is
        mandatory. In an ECU Extract this reference is optional
        (references to ECUs that are not part of the ECU Extract shall
        be avoided).
    :ivar drop_not_requested_nad: Configures if TP Frames of not
        requested LIN-Slaves are dropped or not.
    :ivar max_number_of_resp_pending_frames: Configures the maximum
        number of allowed response pending frames.
    :ivar p_2_max: After reception of a response pending frame the P2
        timeout counter is reloaded with the timeout time P2max.
    :ivar p_2_timing: P2 timeout observation parameter.
    :ivar tp_address_ref: Reference to the TP Address that is used by
        the TpNode. This reference is optional in case that the
        multicast TP Address is used (reference from TpConnection).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: LinTpConfig.tpNode
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-TP-NODE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LinTpNode.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LinTpNode.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    connector_ref: Optional["LinTpNode.ConnectorRef"] = field(
        default=None,
        metadata={
            "name": "CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    drop_not_requested_nad: Boolean | None = field(
        default=None,
        metadata={
            "name": "DROP-NOT-REQUESTED-NAD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_resp_pending_frames: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-RESP-PENDING-FRAMES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_2_max: TimeValue | None = field(
        default=None,
        metadata={
            "name": "P-2-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_2_timing: TimeValue | None = field(
        default=None,
        metadata={
            "name": "P-2-TIMING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_address_ref: Optional["LinTpNode.TpAddressRef"] = field(
        default=None,
        metadata={
            "name": "TP-ADDRESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TpAddressRef(Ref):
        dest: TpAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Linker:
    """
    Specifies the linker attributes used to describe how the linker shall be
    invoked.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar name: Linker name.
    :ivar options: Specifies the linker options.
    :ivar vendor: Vendor of linker.
    :ivar version: Exact version of linker executable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LINKER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Linker.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Linker.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    name: String | None = field(
        default=None,
        metadata={
            "name": "NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    options: String | None = field(
        default=None,
        metadata={
            "name": "OPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vendor: String | None = field(
        default=None,
        metadata={
            "name": "VENDOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: String | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LogAndTraceInstantiation:
    """
    This meta-class defines the attributes for the Log&amp;Trace configuration on a
    specific machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar dlt_ecu_ref: Reference to the Ecu representation in the Log
        And Trace Extract.
    :ivar log_sink_refs: Reference to output sinks for log or trace
        messages that are produced on the Machine.
    :ivar session_id_support: This attribute defines whether the
        sessionId is used or not.
    :ivar time_base_resource_refs: This reference is used to describe to
        which time base the Log and Trace module has access. From the
        Time Base Resource the Log and Trace module gets the needed
        information to generate the time stamp.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LOG-AND-TRACE-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LogAndTraceInstantiation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LogAndTraceInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_ecu_ref: Optional["LogAndTraceInstantiation.DltEcuRef"] = field(
        default=None,
        metadata={
            "name": "DLT-ECU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    log_sink_refs: Optional["LogAndTraceInstantiation.LogSinkRefs"] = field(
        default=None,
        metadata={
            "name": "LOG-SINK-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    session_id_support: Boolean | None = field(
        default=None,
        metadata={
            "name": "SESSION-ID-SUPPORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_base_resource_refs: Optional["LogAndTraceInstantiation.TimeBaseResourceRefs"] = field(
        default=None,
        metadata={
            "name": "TIME-BASE-RESOURCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DltEcuRef(Ref):
        dest: DltEcuSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class LogSinkRefs:
        log_sink_ref: list["LogAndTraceInstantiation.LogSinkRefs.LogSinkRef"] = field(
            default_factory=list,
            metadata={
                "name": "LOG-SINK-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class LogSinkRef(Ref):
            dest: DltLogSinkSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimeBaseResourceRefs:
        time_base_resource_ref: list[
            "LogAndTraceInstantiation.TimeBaseResourceRefs.TimeBaseResourceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "TIME-BASE-RESOURCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TimeBaseResourceRef(Ref):
            dest: TimeBaseResourceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class LogAndTraceInterface:
    """
    This meta-class provides the ability to implement a PortInterface for support
    of Logging or Tracing.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LOG-AND-TRACE-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LogAndTraceInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LogAndTraceInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["LogAndTraceInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["LogAndTraceInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LogicAddress:
    """The logical DoIP address.

    This element shall only be used for DoIP (Diagnosis over IP).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar address: The logical DoIP address.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: SoAdConfig.logicAddress
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LOGIC-ADDRESS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LogicAddress.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LogicAddress.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    address: Integer | None = field(
        default=None,
        metadata={
            "name": "ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LogicalSupervision:
    """
    Defines a LogicalSupervision graph consisting of transitions, initial- and
    final checkpoints.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar initial_checkpoint_refs: Reference to the initial
        Checkpoint(s) for this LogicalSupervision.
    :ivar final_checkpoint_refs: Reference to the final Checkpoint(s)
        for this LogicalSupervision.
    :ivar transition_refs: Reference to the transitions for this
        LogicalSupervision.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LOGICAL-SUPERVISION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LogicalSupervision.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LogicalSupervision.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_checkpoint_refs: Optional["LogicalSupervision.InitialCheckpointRefs"] = field(
        default=None,
        metadata={
            "name": "INITIAL-CHECKPOINT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    final_checkpoint_refs: Optional["LogicalSupervision.FinalCheckpointRefs"] = field(
        default=None,
        metadata={
            "name": "FINAL-CHECKPOINT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transition_refs: Optional["LogicalSupervision.TransitionRefs"] = field(
        default=None,
        metadata={
            "name": "TRANSITION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InitialCheckpointRefs:
        initial_checkpoint_ref: list[
            "LogicalSupervision.InitialCheckpointRefs.InitialCheckpointRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "INITIAL-CHECKPOINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class InitialCheckpointRef(Ref):
            dest: SupervisionCheckpointSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class FinalCheckpointRefs:
        final_checkpoint_ref: list["LogicalSupervision.FinalCheckpointRefs.FinalCheckpointRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "FINAL-CHECKPOINT-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class FinalCheckpointRef(Ref):
            dest: SupervisionCheckpointSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TransitionRefs:
        transition_ref: list["LogicalSupervision.TransitionRefs.TransitionRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRANSITION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TransitionRef(Ref):
            dest: CheckpointTransitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class LtMessageCollectionToPortPrototypeMapping:
    """
    This mapping element assigns a collection of Log or Trace messages to a
    PortPrototype of an application.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar log_and_trace_message_collection_set_ref: Reference to a
        Collection of Log or Trace messages
    :ivar r_port_prototype_ref: Reference to the RPortPrototype to which
        Log or Trace messages are assigned.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LT-MESSAGE-COLLECTION-TO-PORT-PROTOTYPE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "LtMessageCollectionToPortPrototypeMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LtMessageCollectionToPortPrototypeMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    log_and_trace_message_collection_set_ref: Optional[
        "LtMessageCollectionToPortPrototypeMapping.LogAndTraceMessageCollectionSetRef"
    ] = field(
        default=None,
        metadata={
            "name": "LOG-AND-TRACE-MESSAGE-COLLECTION-SET-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    r_port_prototype_ref: Optional[
        "LtMessageCollectionToPortPrototypeMapping.RPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "R-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LogAndTraceMessageCollectionSetRef(Ref):
        dest: LogAndTraceMessageCollectionSetSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RPortPrototypeRef(Ref):
        dest: RPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class MacMulticastGroup:
    """Per EthernetCluster globally defined MacMulticastGroup.

    One sender can handle many receivers simultaneously if the receivers
    have all the same macMulticastAddress. The addresses need to be
    unique for the particular EthernetCluster.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar mac_multicast_address: A multicast MAC address (Media Access
        Control address) is a identifier for a group of hosts in a
        network.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAC-MULTICAST-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["MacMulticastGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["MacMulticastGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mac_multicast_address: MacAddressString | None = field(
        default=None,
        metadata={
            "name": "MAC-MULTICAST-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class MacSecGlobalKayProps:
    """
    Configuration of the MAC Security Key Agreement Entity properties that are
    shared by different KaY configurations.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar bypass_ether_types: This attribute is used to define
        EtherTypes that are bypassed by MACsec. The providedEtherType
        will not be MACsec protected.
    :ivar bypass_vlans: This attribute is used to define VLAN-IDs that
        are bypassed by MACsec. The provided VLAN-IDs will not be MACsec
        protected. (VLAN-ID 0 is interpreted as no-VLAN --&gt; Bypass
        untagged traffic)
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAC-SEC-GLOBAL-KAY-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["MacSecGlobalKayProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["MacSecGlobalKayProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bypass_ether_types: Optional["MacSecGlobalKayProps.BypassEtherTypes"] = field(
        default=None,
        metadata={
            "name": "BYPASS-ETHER-TYPES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bypass_vlans: Optional["MacSecGlobalKayProps.BypassVlans"] = field(
        default=None,
        metadata={
            "name": "BYPASS-VLANS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BypassEtherTypes:
        bypass_ether_type: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "BYPASS-ETHER-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 255,
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BypassVlans:
        bypass_vlan: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "BYPASS-VLAN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 255,
            },
        )


@dataclass(slots=True, kw_only=True)
class MacSecKayParticipant:
    """
    This meta-class configures a MKA participant.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar ckn_ref: Reference to the key where the ckn (Connectivity
        Association key) is stored.
    :ivar crypto_algo_config: Cryptography that is used by the MKA
        Participant.
    :ivar sak_ref: Reference to the key where SAK shall be stored.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAC-SEC-KAY-PARTICIPANT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["MacSecKayParticipant.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["MacSecKayParticipant.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ckn_ref: Optional["MacSecKayParticipant.CknRef"] = field(
        default=None,
        metadata={
            "name": "CKN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_algo_config: MacSecCryptoAlgoConfig | None = field(
        default=None,
        metadata={
            "name": "CRYPTO-ALGO-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sak_ref: Optional["MacSecKayParticipant.SakRef"] = field(
        default=None,
        metadata={
            "name": "SAK-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CknRef(Ref):
        dest: CryptoServiceKeySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SakRef(Ref):
        dest: CryptoServiceKeySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class McFunctionDataRefSetConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar flat_map_entry_refs: Refers to an entry in a FlatMap that is
        part of the set, for example a calibration parameter or measured
        variable.
    :ivar mc_data_instance_refs: Refers to a data instance within MC
        support data that is part of the set, i.e. a calibration
        parameter or measured variable.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MC-FUNCTION-DATA-REF-SET-CONDITIONAL"

    flat_map_entry_refs: Optional["McFunctionDataRefSetConditional.FlatMapEntryRefs"] = field(
        default=None,
        metadata={
            "name": "FLAT-MAP-ENTRY-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_data_instance_refs: Optional["McFunctionDataRefSetConditional.McDataInstanceRefs"] = field(
        default=None,
        metadata={
            "name": "MC-DATA-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FlatMapEntryRefs:
        flat_map_entry_ref: list[
            "McFunctionDataRefSetConditional.FlatMapEntryRefs.FlatMapEntryRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "FLAT-MAP-ENTRY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FlatMapEntryRef(Ref):
            dest: FlatInstanceDescriptorSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class McDataInstanceRefs:
        mc_data_instance_ref: list[
            "McFunctionDataRefSetConditional.McDataInstanceRefs.McDataInstanceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MC-DATA-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class McDataInstanceRef(Ref):
            dest: McDataInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class McGroupDataRefSetConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar flat_map_entry_refs: Refers to an entry in a FlatMap that is
        part of the set, for example a calibration parameter or measured
        variable.
    :ivar mc_data_instance_refs: Refers to a data instance within MC
        support data that is part of the set, i.e. a calibration
        parameter or measured variable.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MC-GROUP-DATA-REF-SET-CONDITIONAL"

    flat_map_entry_refs: Optional["McGroupDataRefSetConditional.FlatMapEntryRefs"] = field(
        default=None,
        metadata={
            "name": "FLAT-MAP-ENTRY-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_data_instance_refs: Optional["McGroupDataRefSetConditional.McDataInstanceRefs"] = field(
        default=None,
        metadata={
            "name": "MC-DATA-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FlatMapEntryRefs:
        flat_map_entry_ref: list[
            "McGroupDataRefSetConditional.FlatMapEntryRefs.FlatMapEntryRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "FLAT-MAP-ENTRY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FlatMapEntryRef(Ref):
            dest: FlatInstanceDescriptorSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class McDataInstanceRefs:
        mc_data_instance_ref: list[
            "McGroupDataRefSetConditional.McDataInstanceRefs.McDataInstanceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MC-DATA-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class McDataInstanceRef(Ref):
            dest: McDataInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class McSwEmulationMethodSupport:
    """This denotes the method used by the RTE to handle the calibration data.

    It is published by the RTE generator and can be used e.g. to generate the corresponding emulation method in a Complex Driver.
    According to the actual method given by the category attribute,  not all attributes are always needed:
    * double pointered method: only baseReference is mandatory
    * single pointered method: only referenceTable is mandatory
    * initRam method: only elementGroup(s) are mandatory
    Note: For single/double pointered method the group locations are implicitly accessed via the reference table and their location can be found from the initial values in the M1 model of the respective pointers. Therefore, the description of elementGroups is not needed in these cases.  Likewise, for double pointered method the reference table description can be accessed via the M1 model under baseReference.

    :ivar short_label: Assigns a name to this element.
    :ivar category: Identifies the actual method. The possible names
        shall correspond to the symbols of the ECU configuration
        parameter for the calibration method of the RTE, and can include
        vendor specific methods.
    :ivar base_reference_ref: Refers to the base pointer in case of the
        double-pointered method.
    :ivar element_groups: Denotes the grouping of calibration parameters
        in the actual RTE code. Depending on the category, this
        information maybe required to set up the emulation code.
    :ivar reference_table_ref: Refers to the pointer table in case of
        the single-pointered method.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        McSupportData.emulationSupport
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MC-SW-EMULATION-METHOD-SUPPORT"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: Identifier | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    base_reference_ref: Optional["McSwEmulationMethodSupport.BaseReferenceRef"] = field(
        default=None,
        metadata={
            "name": "BASE-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    element_groups: Optional["McSwEmulationMethodSupport.ElementGroups"] = field(
        default=None,
        metadata={
            "name": "ELEMENT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reference_table_ref: Optional["McSwEmulationMethodSupport.ReferenceTableRef"] = field(
        default=None,
        metadata={
            "name": "REFERENCE-TABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BaseReferenceRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ElementGroups:
        mc_parameter_element_group: list[McParameterElementGroup] = field(
            default_factory=list,
            metadata={
                "name": "MC-PARAMETER-ELEMENT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ReferenceTableRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class MeasuredExecutionTime:
    """
    Specifies the ExecutionTime which has been gathered using measurement means.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar exclusive_area_ref: Reference to the ExclusiveArea this
        execution time is provided for.
    :ivar executable_entity_ref: The executable entity for which this
        execution time is described.
    :ivar hardware_configuration: Provides information on the
        HardwareConfiguration used to specify this ExecutionTime.
    :ivar hw_element_ref: The hardware element (e.g. type of ECU) for
        which the execution time is specified.
    :ivar included_library_refs: If this dependency is specified, the
        execution time of the library code is included in the execution
        time data for the runnable.
    :ivar memory_section_locations: Provides information on the
        MemorySectionLocation which is involved in the ExecutionTime
        description.
    :ivar software_context: Provides information on the detailed
        SoftwareContext used to provide the ExecutionTime description.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ResourceConsumption.executionTime
    :ivar maximum_execution_time: The maximum measured execution time.
    :ivar minimum_execution_time: The minimum measured execution time.
    :ivar nominal_execution_time: The nominal measured execution time.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MEASURED-EXECUTION-TIME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["MeasuredExecutionTime.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["MeasuredExecutionTime.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_area_ref: Optional["MeasuredExecutionTime.ExclusiveAreaRef"] = field(
        default=None,
        metadata={
            "name": "EXCLUSIVE-AREA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    executable_entity_ref: Optional["MeasuredExecutionTime.ExecutableEntityRef"] = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-ENTITY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hardware_configuration: HardwareConfiguration | None = field(
        default=None,
        metadata={
            "name": "HARDWARE-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_element_ref: Optional["MeasuredExecutionTime.HwElementRef"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    included_library_refs: Optional["MeasuredExecutionTime.IncludedLibraryRefs"] = field(
        default=None,
        metadata={
            "name": "INCLUDED-LIBRARY-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_section_locations: Optional["MeasuredExecutionTime.MemorySectionLocations"] = field(
        default=None,
        metadata={
            "name": "MEMORY-SECTION-LOCATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_context: SoftwareContext | None = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CONTEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_execution_time: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-EXECUTION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_execution_time: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-EXECUTION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nominal_execution_time: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "NOMINAL-EXECUTION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaRef(Ref):
        dest: ExclusiveAreaSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutableEntityRef(Ref):
        dest: ExecutableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class HwElementRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IncludedLibraryRefs:
        included_library_ref: list[
            "MeasuredExecutionTime.IncludedLibraryRefs.IncludedLibraryRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "INCLUDED-LIBRARY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class IncludedLibraryRef(Ref):
            dest: DependencyOnArtifactSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class MemorySectionLocations:
        memory_section_location: list[MemorySectionLocation] = field(
            default_factory=list,
            metadata={
                "name": "MEMORY-SECTION-LOCATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class MeasuredHeapUsage:
    """
    The heap usage has been measured.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar hardware_configuration: Contains information about the
        hardware context this heap usage is describing.
    :ivar hw_element_ref: Specifies for which hardware element (e.g.
        ECU) this heap usage  usage is given.
    :ivar software_context: Contains details about the software context
        this heap usage is provided for.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ResourceConsumption.heapUsage
    :ivar average_memory_consumption: The average heap usage measured.
        Unit: byte.
    :ivar maximum_memory_consumption: The maximum heap usage measured.
        Unit: byte.
    :ivar minimum_memory_consumption: The minimum heap usage measured.
        Unit: byte.
    :ivar test_pattern: Description of the test pattern used to acquire
        the measured values.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MEASURED-HEAP-USAGE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["MeasuredHeapUsage.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["MeasuredHeapUsage.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hardware_configuration: HardwareConfiguration | None = field(
        default=None,
        metadata={
            "name": "HARDWARE-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_element_ref: Optional["MeasuredHeapUsage.HwElementRef"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_context: SoftwareContext | None = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CONTEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    average_memory_consumption: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "AVERAGE-MEMORY-CONSUMPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_memory_consumption: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-MEMORY-CONSUMPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_memory_consumption: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-MEMORY-CONSUMPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    test_pattern: String | None = field(
        default=None,
        metadata={
            "name": "TEST-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwElementRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class MeasuredStackUsage:
    """
    The stack usage has been measured.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar executable_entity_ref: The executable entity for which this
        stack usage is described.
    :ivar hardware_configuration: Contains information about the
        hardware context this stack usage is describing.
    :ivar hw_element_ref: Specifies for which hardware element (e.g.
        ECU) this stack usage is given.
    :ivar software_context: Contains details about the software context
        this stack usage is provided for.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ResourceConsumption.stackUsage
    :ivar average_memory_consumption: The average stack usage measured.
        Unit: byte.
    :ivar maximum_memory_consumption: The maximum stack usage measured.
        Unit: byte.
    :ivar minimum_memory_consumption: The minimum stack usage measured.
        Unit: byte.
    :ivar test_pattern: Description of the test pattern used to acquire
        the measured values.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MEASURED-STACK-USAGE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["MeasuredStackUsage.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["MeasuredStackUsage.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    executable_entity_ref: Optional["MeasuredStackUsage.ExecutableEntityRef"] = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-ENTITY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hardware_configuration: HardwareConfiguration | None = field(
        default=None,
        metadata={
            "name": "HARDWARE-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_element_ref: Optional["MeasuredStackUsage.HwElementRef"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_context: SoftwareContext | None = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CONTEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    average_memory_consumption: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "AVERAGE-MEMORY-CONSUMPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_memory_consumption: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-MEMORY-CONSUMPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_memory_consumption: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-MEMORY-CONSUMPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    test_pattern: String | None = field(
        default=None,
        metadata={
            "name": "TEST-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutableEntityRef(Ref):
        dest: ExecutableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class HwElementRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class MemorySection:
    """Provides a description of an abstract memory section used in the
    Implementation for code or data.

    It shall be declared by the Implementation Description of the module or component, which actually allocates the memory in its code. This means in case of data prototypes which are allocated by the RTE, that the generated Implementation Description of the RTE shall contain the corresponding MemorySections.
    The attribute "symbol" (if symbol is missing: "shortName") defines the module or component specific section name used in the code. For details see the document "Specification of Memory Mapping".
    Typically the section name is build according the pattern:
    &lt;SwAddrMethod shortName&gt;[_&lt;further specialization nominator&gt;][_&lt;alignment&gt;]
    where
    * '''[&lt;SwAddrMethod shortName&gt;]''' is the shortName of the referenced SwAddrMethod
    * '''[_&lt;further specialization nominator&gt;]''' is an optional infix to indicate the specialization in the case that several MemorySections for different purpose of the same Implementation Description referring to the same or equally named SwAddrMethods.
    * '''[_&lt;alignment&gt;]''' is the alignment attributes value and is only applicable in the case that the memoryAllocationKeywordPolicy value of the referenced SwAddrMethod is set to addrMethodShortNameAndAlignment
    MemorySection used to Implement the code of RunnableEntitys and BswSchedulableEntitys shall have a symbol (if missing: shortName) identical to the referred SwAddrMethod to conform to the generated RTE header files.
    In addition to the section name described above, a prefix is used in the corresponding macro code in order to define a name space. This prefix is by default given by the shortName of the BswModuleDescription resp. the SwComponentType. It can be superseded by  the prefix attribute.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alignment: The attribute describes the typical alignment of
        objects within this memory section.
    :ivar executable_entity_refs: Reference to the ExecutableEntitites
        located in this section. This allows to locate different
        ExecutableEntitities in different sections even if the
        associated SwAddrmethod is the same. This is applicable to code
        sections only.
    :ivar mem_class_symbol: Defines a specific  symbol in order to
        generate the compiler abstraction  "memclass" code for this
        MemorySection. The existence of this attribute supersedes the
        usage of swAddrmethod.shortName for this purpose. The complete
        name of the  "memclass" preprocessor symbol is constructed as
        &lt;prefix&gt;_&lt;memClassSymbol&gt; where prefix is defined in
        the same way as for the enclosing MemorySection. See also
        AUTOSAR_SWS_CompilerAbstraction SWS_COMPILER_00040.
    :ivar options: The service (in AUTOSAR: BswModuleEntry) is
        implemented in a way that it either resolves to aninline
        function or to a standard function depending on conditions set
        at a later point in time. The following two values are
        standardized (to be used for code sections only and exclusively
        to each other): * INLINE - The code section is declared with the
        keyword "inline". * LOCAL_INLINE  - The code section is declared
        with the keyword "static inline". In both cases (INLINE and
        LOCAL_INLINE) the inline expansion depends on the compiler.
        Depending on this, the code section either corresponds to an
        actual section in memory or is put into the section of the
        caller.
    :ivar prefix_ref: The prefix used to set the memory section's
        namespace in the code. The existence of a prefix element
        supersedes rules for a default prefix (such as the
        BswModuleDescription's shortName). This allows the user to
        define several name spaces for memory sections within the scope
        of one module, cluster or SWC.
    :ivar size: The size in bytes of the section.
    :ivar sw_addrmethod_ref: This association indicates that this module
        specific (abstract) memory section is part of an overall
        SwAddrMethod, referred by the upstream declarations (e.g.
        calibration parameters, data element prototypes, code entities)
        which share a common addressing strategy. This can be evaluated
        for the ECU configuration of the build support. This association
        shall always be declared by the Implementation description of
        the module or component, which allocates the memory in its code.
        This means in case of data prototypes which are allocated by the
        RTE, that the software components only declare the grouping of
        its data prototypes to SwAddrMethods, and the generated
        Implementation Description of the RTE actually sets up this
        association.
    :ivar symbol: Defines the section name as explained in the main
        description. By using this attribute for code generation
        (instead of the shortName) it is possible to define several
        different MemorySections having the same name - e.g. symbol =
        CODE - but using different sectionNamePrefixes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ResourceConsumption.memorySection
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MEMORY-SECTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["MemorySection.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["MemorySection.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alignment: AlignmentType | None = field(
        default=None,
        metadata={
            "name": "ALIGNMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    executable_entity_refs: Optional["MemorySection.ExecutableEntityRefs"] = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-ENTITY-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mem_class_symbol: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "MEM-CLASS-SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    options: Optional["MemorySection.Options"] = field(
        default=None,
        metadata={
            "name": "OPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prefix_ref: Optional["MemorySection.PrefixRef"] = field(
        default=None,
        metadata={
            "name": "PREFIX-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_addrmethod_ref: Optional["MemorySection.SwAddrmethodRef"] = field(
        default=None,
        metadata={
            "name": "SW-ADDRMETHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol: Identifier | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutableEntityRefs:
        executable_entity_ref: list["MemorySection.ExecutableEntityRefs.ExecutableEntityRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "EXECUTABLE-ENTITY-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class ExecutableEntityRef(Ref):
            dest: ExecutableEntitySubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class Options:
        option: list[Identifier] = field(
            default_factory=list,
            metadata={
                "name": "OPTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PrefixRef(Ref):
        dest: SectionNamePrefixSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SwAddrmethodRef(Ref):
        dest: SwAddrMethodSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class MemoryUsage:
    """
    This meta-class is used to describe the memory  consumption.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar memory_consumption: Provides a formal worst case system usage.
        The unit is byte.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MEMORY-USAGE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["MemoryUsage.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["MemoryUsage.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_consumption: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MEMORY-CONSUMPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class MethodMapping:
    """
    Mapping of a ClientServerOperation that is located in a ClientServerInterface
    to a Method that is located in a ServiceInterface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar client_server_operation_ref: Reference to a
        ClientSeverOperation that is located in a ClientSeverInterface.
    :ivar method_ref: Reference to a Method that is located in a
        ServiceInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "METHOD-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["MethodMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["MethodMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_server_operation_ref: Optional["MethodMapping.ClientServerOperationRef"] = field(
        default=None,
        metadata={
            "name": "CLIENT-SERVER-OPERATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_ref: Optional["MethodMapping.MethodRef"] = field(
        default=None,
        metadata={
            "name": "METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClientServerOperationRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MethodRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeAccessPointIdent:
    """
    This meta-class has been created to introduce the ability to become referenced
    into the meta-class ModeAccessPoint without breaking backwards compatibility.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar return_value_provision: This attribute controls the provision
        of return values for RTE APIs that correspond to the enclosing
        access point.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-ACCESS-POINT-IDENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ModeAccessPointIdent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ModeAccessPointIdent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    return_value_provision: RteApiReturnValueProvisionEnum | None = field(
        default=None,
        metadata={
            "name": "RETURN-VALUE-PROVISION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ModeDeclaration:
    """Declaration of one Mode.

    The name and semantics of a specific mode is not defined in the
    meta-model.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar value: The RTE shall take the value of this attribute for
        generating the source code representation of this
        ModeDeclaration.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ModeDeclarationGroup.modeDeclaration
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-DECLARATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ModeDeclaration.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ModeDeclaration.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ModeDeclarationGroupPrototype:
    """
    The ModeDeclarationGroupPrototype specifies a set of Modes
    (ModeDeclarationGroup) which is provided or required in the given context.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sw_calibration_access: This allows for specifying whether or
        not the enclosing ModeDeclarationGroupPrototype can be measured
        at run-time.
    :ivar type_tref: The "collection of ModeDeclarations" ( =
        ModeDeclarationGroup) supported by a component
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswModuleDescription.providedModeGroup Applicable for:
        BswModuleDescription.requiredModeGroup Not Applicable for:
        ModeSwitchInterface.modeGroup Not Applicable for:
        FunctionGroupSet.functionGroup Not Applicable for:
        FirewallStateSwitchInterface.firewallStateMachine Not Applicable
        for: Process.processStateMachine Not Applicable for:
        StateManagementStateNotification.stateMachine
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-DECLARATION-GROUP-PROTOTYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ModeDeclarationGroupPrototype.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ModeDeclarationGroupPrototype.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_calibration_access: SwCalibrationAccessEnum | None = field(
        default=None,
        metadata={
            "name": "SW-CALIBRATION-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_tref: Optional["ModeDeclarationGroupPrototype.TypeTref"] = field(
        default=None,
        metadata={
            "name": "TYPE-TREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TypeTref(Ref):
        dest: ModeDeclarationGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeDeclarationGroupPrototypeRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar mode_declaration_group_prototype_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-DECLARATION-GROUP-PROTOTYPE-REF-CONDITIONAL"

    mode_declaration_group_prototype_ref: Optional[
        "ModeDeclarationGroupPrototypeRefConditional.ModeDeclarationGroupPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "MODE-DECLARATION-GROUP-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ModeDeclarationGroupPrototypeRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeDeclarationMapping:
    """
    This meta-class implements a concrete mapping of two ModeDeclarations.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar first_mode_refs: This represents the first ModeDeclaration of
        the ModeDeclarationMapping. This reference has the multiplicity
        1 .. * to support use cases where e.g. one mode of the mode user
        is mapped to several modes of the mode manager.
    :ivar second_mode_ref: This represents the second ModeDeclaration of
        the ModeDeclarationMapping.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-DECLARATION-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ModeDeclarationMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ModeDeclarationMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    first_mode_refs: Optional["ModeDeclarationMapping.FirstModeRefs"] = field(
        default=None,
        metadata={
            "name": "FIRST-MODE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    second_mode_ref: Optional["ModeDeclarationMapping.SecondModeRef"] = field(
        default=None,
        metadata={
            "name": "SECOND-MODE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FirstModeRefs:
        first_mode_ref: list["ModeDeclarationMapping.FirstModeRefs.FirstModeRef"] = field(
            default_factory=list,
            metadata={
                "name": "FIRST-MODE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FirstModeRef(Ref):
            dest: ModeDeclarationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SecondModeRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeInterfaceMapping:
    """
    Defines the mapping of ModeDeclarationGroupPrototypes in context of two
    different ModeInterfaces.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        PortInterfaceMappingSet.portInterfaceMapping
    :ivar mode_mapping: Mapping of two ModeDeclarationGroupPrototypes in
        two different ModeInterfaces
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-INTERFACE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ModeInterfaceMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ModeInterfaceMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ModeInterfaceMapping.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_mapping: ModeDeclarationGroupPrototypeMapping | None = field(
        default=None,
        metadata={
            "name": "MODE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ModeSwitchEventTriggeredActivity:
    """
    This meta-class defines an activity of the NvBlockSwComponentType for a
    specific NvBlock which is triggered by a ModeSwitchEvent.

    :ivar role: This attribute indicates which service of the NvM for
        the NvBlock shall be requested.
    :ivar swc_mode_switch_event_ref: This reference identifies the
        SwcModeSwitchEvent that triggers the activity.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        NvBlockDescriptor.modeSwitchEventTriggeredActivity
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-SWITCH-EVENT-TRIGGERED-ACTIVITY"

    role: Identifier | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_mode_switch_event_ref: Optional[
        "ModeSwitchEventTriggeredActivity.SwcModeSwitchEventRef"
    ] = field(
        default=None,
        metadata={
            "name": "SWC-MODE-SWITCH-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SwcModeSwitchEventRef(Ref):
        dest: SwcModeSwitchEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeSwitchPoint:
    """A ModeSwitchPoint is required by a RunnableEntity owned a Mode Manager.

    Its semantics implies the ability to initiate a mode switch.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar return_value_provision: This attribute controls the provision
        of return values for RTE APIs that correspond to the enclosing
        access point.
    :ivar mode_group_iref: The mode declaration group that is switched
        by this runnable.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RunnableEntity.modeSwitchPoint
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-SWITCH-POINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ModeSwitchPoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ModeSwitchPoint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    return_value_provision: RteApiReturnValueProvisionEnum | None = field(
        default=None,
        metadata={
            "name": "RETURN-VALUE-PROVISION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_group_iref: PModeGroupInAtomicSwcInstanceRef | None = field(
        default=None,
        metadata={
            "name": "MODE-GROUP-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ModeSwitchedAckEvent:
    """
    This event is raised when the referenced ModeSwitchPoint has been processed or
    an error occurred.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar event_source_ref: The referenced ModeSwitchPoint raises this
        ModeSwitchedAckEvent when the ModeSwitchPoint has been
        processed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-SWITCHED-ACK-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ModeSwitchedAckEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ModeSwitchedAckEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "ModeSwitchedAckEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["ModeSwitchedAckEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["ModeSwitchedAckEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_source_ref: Optional["ModeSwitchedAckEvent.EventSourceRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-SOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventSourceRef(Ref):
        dest: ModeSwitchPointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ModeTransition:
    """
    This meta-class represents the ability to describe possible ModeTransitions in
    the context of a ModeDeclarationGroup.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar entered_mode_ref: This represents the entered model of the
        ModeTransition.
    :ivar exited_mode_ref: This represents the exited mode of the
        ModeTransition
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-TRANSITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ModeTransition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ModeTransition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    entered_mode_ref: Optional["ModeTransition.EnteredModeRef"] = field(
        default=None,
        metadata={
            "name": "ENTERED-MODE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exited_mode_ref: Optional["ModeTransition.ExitedModeRef"] = field(
        default=None,
        metadata={
            "name": "EXITED-MODE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EnteredModeRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ExitedModeRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class MultiLanguageParagraph:
    """
    This is the content model of a multilingual paragraph in a documentation.

    :ivar l_1: This is the paragraph content in one partiucular
        language.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: DocumentationBlock.p
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    :ivar help_entry: This specifies an entry point in an online help
        system to be linked with the parent class. The syntax shall be
        defined by the applied help system respectively help system
        generator.
    """

    class Meta:
        name = "MULTI-LANGUAGE-PARAGRAPH"

    l_1: list[LParagraph] = field(
        default_factory=list,
        metadata={
            "name": "L-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )
    help_entry: str | None = field(
        default=None,
        metadata={
            "name": "HELP-ENTRY",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class MultiLanguageVerbatim:
    """This class represents multilingual Verbatim.

    Verbatim means, that white-space is maintained. When Verbatim is
    rendered in PDF or Online media, white-space is obeyed. Blanks are
    rendered as well as newline characters.

    :ivar l_5: This the text in one particular language.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DocumentationBlock.verbatim Not Applicable for:
        BlueprintFormula.verbatim Not Applicable for: MlFigure.verbatim
        Not Applicable for: MlFormula.verbatim
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    :ivar allow_break: This indicates if the verbatim text might be
        split on multiple pages. Default is "1".
    :ivar float_value: Indicate whether it is allowed to break the
        element. The following values are allowed:
    :ivar help_entry: This specifies an entry point in an online help
        system to be linked with the parent class. The syntax shall be
        defined by the applied help system respectively help system
        generator.
    :ivar pgwide: Used to indicate wether the figure should take the
        complete page width (value = "pgwide") or not (value =
        "noPgwide").
    """

    class Meta:
        name = "MULTI-LANGUAGE-VERBATIM"

    l_5: list[LVerbatim] = field(
        default_factory=list,
        metadata={
            "name": "L-5",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )
    allow_break: str | None = field(
        default=None,
        metadata={
            "name": "ALLOW-BREAK",
            "type": "Attribute",
        },
    )
    float_value: FloatEnumSimple | None = field(
        default=None,
        metadata={
            "name": "FLOAT",
            "type": "Attribute",
        },
    )
    help_entry: str | None = field(
        default=None,
        metadata={
            "name": "HELP-ENTRY",
            "type": "Attribute",
        },
    )
    pgwide: PgwideEnumSimple | None = field(
        default=None,
        metadata={
            "name": "PGWIDE",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class NPdu:
    """This is a Pdu of the Transport Layer.

    The main purpose of the TP Layer is to segment and reassemble IPdus.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar has_dynamic_length: This attribute defines whether the Pdu has
        dynamic length (true) or not (false). Please note that the usage
        of this attribute is restricted by [constr_3448].
    :ivar length: Pdu length in bytes. In case of dynamic length IPdus
        (containing a dynamical length signal), this value indicates the
        maximum data length. It should be noted that in former AUTOSAR
        releases (Rel 2.1, Rel 3.0, Rel 3.1, Rel 4.0 Rev. 1) this
        parameter was defined in bits. The Pdu length of zero bytes is
        allowed.
    :ivar meta_data_length: Number of additional bytes of MetaData in
        the PDU data field. The MetaData contains auxiliary information
        for the PDU, e.g. the CAN ID.
    :ivar contained_i_pdu_props: Defines whether this IPdu may be
        collected inside a ContainerIPdu.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "N-PDU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["NPdu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["NPdu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_dynamic_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-DYNAMIC-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "META-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_i_pdu_props: ContainedIPduProps | None = field(
        default=None,
        metadata={
            "name": "CONTAINED-I-PDU-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class NmEcu:
    """
    ECU on which NM is running.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar bus_dependent_nm_ecus: Cluster specific NmEcu attributes
    :ivar bus_specific_nm_ecu: Busspecific NmEcu attributes. Please note
        that this aggregation is deprecated and is replaced by the
        busDependentNmEcu aggregation.
    :ivar ecu_instance_ref: Association to an ECUInstance in the
        topology description.
    :ivar nm_bus_synchronization_enabled: Enables bus synchronization
        support.
    :ivar nm_com_control_enabled: Enables the Communication Control
        support.
    :ivar nm_coordinator: Nm ECU may coordinate different clusters.
    :ivar nm_cycletime_main_function: The period between successive
        calls to the Main Function of the NM Interface in seconds.
    :ivar nm_multiple_channels_enabled: Enables channel multiplicity
        support.
    :ivar nm_node_detection_enabled: Enables the Request Repeat Message
        Request support. Only valid if nmNodeIdEnabled is set to true.
        Please note that this attribute is deprecated and will be
        removed in future. It is replaced by the channel specific
        attribute located in NmCluster.
    :ivar nm_node_id_enabled: Enables the source node identifier. Please
        note that this attribute is deprecated and will be removed in
        future. It is replaced by the channel specific attribute located
        in NmCluster.
    :ivar nm_passive_mode_enabled: This attribute enables the support of
        the Passive Mode.
    :ivar nm_pdu_rx_indication_enabled: Switch for enabling the PDU Rx
        Indication.
    :ivar nm_remote_sleep_ind_enabled: Switch for enabling remote sleep
        indication support.
    :ivar nm_repeat_msg_ind_enabled: Switch for enabling the Repeat
        Message Bit Indication. Please note that this attribute is
        deprecated and will be removed in future. It is replaced by the
        channel specific attribute located in NmCluster.
    :ivar nm_state_change_ind_enabled: Enables the CAN Network
        Management state change notification.
    :ivar nm_user_data_enabled: Switch for enabling user data support.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: NmConfig.nmIfEcu
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NM-ECU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["NmEcu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["NmEcu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bus_dependent_nm_ecus: Optional["NmEcu.BusDependentNmEcus"] = field(
        default=None,
        metadata={
            "name": "BUS-DEPENDENT-NM-ECUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bus_specific_nm_ecu: Optional["NmEcu.BusSpecificNmEcu"] = field(
        default=None,
        metadata={
            "name": "BUS-SPECIFIC-NM-ECU",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["NmEcu.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_bus_synchronization_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-BUS-SYNCHRONIZATION-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_com_control_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-COM-CONTROL-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_coordinator: NmCoordinator | None = field(
        default=None,
        metadata={
            "name": "NM-COORDINATOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_cycletime_main_function: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-CYCLETIME-MAIN-FUNCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_multiple_channels_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-MULTIPLE-CHANNELS-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_detection_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-DETECTION-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_id_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-ID-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_passive_mode_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-PASSIVE-MODE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_pdu_rx_indication_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-PDU-RX-INDICATION-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_remote_sleep_ind_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-REMOTE-SLEEP-IND-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_repeat_msg_ind_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-REPEAT-MSG-IND-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_state_change_ind_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-STATE-CHANGE-IND-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_user_data_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-USER-DATA-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BusDependentNmEcus:
        can_nm_ecu: list[CanNmEcu] = field(
            default_factory=list,
            metadata={
                "name": "CAN-NM-ECU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_nm_ecu: list[FlexrayNmEcu] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-NM-ECU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_nm_ecu: list[J1939NmEcu] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-NM-ECU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        udp_nm_ecu: list[UdpNmEcu] = field(
            default_factory=list,
            metadata={
                "name": "UDP-NM-ECU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BusSpecificNmEcu:
        can_nm_ecu: CanNmEcu | None = field(
            default=None,
            metadata={
                "name": "CAN-NM-ECU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_nm_ecu: FlexrayNmEcu | None = field(
            default=None,
            metadata={
                "name": "FLEXRAY-NM-ECU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_nm_ecu: J1939NmEcu | None = field(
            default=None,
            metadata={
                "name": "J-1939-NM-ECU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        udp_nm_ecu: UdpNmEcu | None = field(
            default=None,
            metadata={
                "name": "UDP-NM-ECU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class NmHandleToFunctionGroupStateMapping:
    """This meta-class represents the ability to create a mapping between an
    NmNetworkHandle and a collection of function group states.

    This way, the impact of function groups on the network management
    can be specified.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar function_group_state_irefs: This reference identifies the
        collection of function group states in the context of the
        mapping.
    :ivar mapping_direction: This attribute describes the direction of
        the mapping.
    :ivar nm_handle_ref: This reference identifies the applicable
        NmNetworkHandle in the context of the mapping.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NM-HANDLE-TO-FUNCTION-GROUP-STATE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["NmHandleToFunctionGroupStateMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["NmHandleToFunctionGroupStateMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    function_group_state_irefs: Optional[
        "NmHandleToFunctionGroupStateMapping.FunctionGroupStateIrefs"
    ] = field(
        default=None,
        metadata={
            "name": "FUNCTION-GROUP-STATE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapping_direction: NmHandleMappingDirectionEnum | None = field(
        default=None,
        metadata={
            "name": "MAPPING-DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_handle_ref: Optional["NmHandleToFunctionGroupStateMapping.NmHandleRef"] = field(
        default=None,
        metadata={
            "name": "NM-HANDLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FunctionGroupStateIrefs:
        function_group_state_iref: list[FunctionGroupStateInFunctionGroupSetInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "FUNCTION-GROUP-STATE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NmHandleRef(Ref):
        dest: NmNetworkHandleSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class NmInstantiation:
    """
    This meta-class defines the attributes for the Nm configuration on a specific
    machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar network_handles: Supported NmNetworkHandles used to control
        Partial Network Clusters/VLANs.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NM-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["NmInstantiation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["NmInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_handles: Optional["NmInstantiation.NetworkHandles"] = field(
        default=None,
        metadata={
            "name": "NETWORK-HANDLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NetworkHandles:
        nm_network_handle: list[NmNetworkHandle] = field(
            default_factory=list,
            metadata={
                "name": "NM-NETWORK-HANDLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class NmPduRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar nm_pdu_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NM-PDU-REF-CONDITIONAL"

    nm_pdu_ref: Optional["NmPduRefConditional.NmPduRef"] = field(
        default=None,
        metadata={
            "name": "NM-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class NmPduRef(Ref):
        dest: NmPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class NoCheckpointSupervision:
    """
    Defines explicitly that NO supervision shall be applied for a set of
    SupervisionCheckpoints.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar checkpoint_refs: Reference to the set of
        SupervisionCheckpoints which shall not be considered for any
        kind of supervision.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NO-CHECKPOINT-SUPERVISION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["NoCheckpointSupervision.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["NoCheckpointSupervision.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    checkpoint_refs: Optional["NoCheckpointSupervision.CheckpointRefs"] = field(
        default=None,
        metadata={
            "name": "CHECKPOINT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CheckpointRefs:
        checkpoint_ref: list["NoCheckpointSupervision.CheckpointRefs.CheckpointRef"] = field(
            default_factory=list,
            metadata={
                "name": "CHECKPOINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CheckpointRef(Ref):
            dest: SupervisionCheckpointSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class NoSupervision:
    """
    Defines explicitly that NO supervision shall be applied for a specific
    Supervised Entity instance.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar process_ref: Reference to the Process this NoSupervision
        applies to.
    :ivar target_phm_supervised_entity_iref: Instance reference to the
        RPortPrototype which represents the Supervised Entity instance.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NO-SUPERVISION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["NoSupervision.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["NoSupervision.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["NoSupervision.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_phm_supervised_entity_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "TARGET-PHM-SUPERVISED-ENTITY-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class NotAvailableValueSpecification:
    """This meta-class provides the ability to specify a ValueSpecification to
    state that the respective element is not available.

    This ability is needed to support the existence of
    ApplicationRecordElements where attribute isOptional ist set to the
    value true.

    :ivar short_label: This can be used to identify particular value
        specifications for human readers, for example elements of a
        record type.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ArrayValueSpecification.element Applicable for:
        RecordValueSpecification.field Not Applicable for:
        CompositeRuleBasedValueSpecification.argument Not Applicable
        for: ConstantSpecification.valueSpec Not Applicable for:
        PortPrototypeBlueprintInitValue.value Not Applicable for:
        DiagnosticEnvDataCondition.compareValue Not Applicable for:
        DiagnosticEnvDataElementCondition.compareValue Not Applicable
        for: ParameterDataPrototype.initValue Not Applicable for:
        VariableDataPrototype.initValue Not Applicable for:
        CalibrationParameterValue.applInitValue Not Applicable for:
        CalibrationParameterValue.implInitValue Not Applicable for:
        MetaDataItem.metaDataItemType Not Applicable for:
        NvProvideComSpec.romBlockInitValue Not Applicable for:
        NvProvideComSpec.ramBlockInitValue Not Applicable for:
        NvRequireComSpec.initValue Not Applicable for:
        ParameterProvideComSpec.initValue Not Applicable for:
        ParameterRequireComSpec.initValue Not Applicable for:
        NonqueuedSenderComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.timeoutSubstitutionValue Not Applicable
        for: PortDefinedArgumentValue.value Not Applicable for:
        CryptoServiceKey.developmentValue Not Applicable for:
        ISignal.timeoutSubstitutionValue Not Applicable for:
        ISignal.initValue Not Applicable for:
        FieldSenderComSpec.initValue Not Applicable for:
        PersistencyDataRequiredComSpec.initValue Not Applicable for:
        ApplicationAssocMapElementValueSpecification.value Not
        Applicable for: ApplicationAssocMapElementValueSpecification.key
        Not Applicable for: StateManagementCompareCondition.compareValue
        Not Applicable for: PersistencyKeyValuePair.initValue Not
        Applicable for: SwDataDefPropsContent.invalidValue
    :ivar default_pattern: The content of this attribute shall be used
        to initialize gaps in the memory occupied by a structured data
        type in the case that an NotAvailableValueSpecification is used.
        Note that this pattern is only applied during initialization!
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NOT-AVAILABLE-VALUE-SPECIFICATION"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_pattern: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class NumericalOrText:
    """This meta-class represents the ability to yield either a numerical or a
    string.

    A typical use case is that two or more instances of this meta-class
    are aggregated with a VariationPoint where some instances yield
    strings while other instances yield numerical depending on the
    resolution of the binding expression.

    :ivar vf: This attribute represents the ability to provide a
        numerical value. The latest binding time of the VariationPoint
        shall be preCompileTime.
    :ivar vt: This attribute represents the ability to provide a textual
        value.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: RuleArguments.vtf
        Applicable for: SwValues.vtf
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NUMERICAL-OR-TEXT"

    vf: NumericalValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "VF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vt: String | None = field(
        default=None,
        metadata={
            "name": "VT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class NumericalValueSpecification:
    """A numerical  ValueSpecification which is intended to be assigned to a
    Primitive data element.

    Note that the numerical value is a variant, it can be computed by a
    formula.

    :ivar short_label: This can be used to identify particular value
        specifications for human readers, for example elements of a
        record type.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ArrayValueSpecification.element Applicable for:
        RecordValueSpecification.field Not Applicable for:
        CompositeRuleBasedValueSpecification.argument Not Applicable
        for: ConstantSpecification.valueSpec Not Applicable for:
        PortPrototypeBlueprintInitValue.value Not Applicable for:
        DiagnosticEnvDataCondition.compareValue Not Applicable for:
        DiagnosticEnvDataElementCondition.compareValue Not Applicable
        for: ParameterDataPrototype.initValue Not Applicable for:
        VariableDataPrototype.initValue Not Applicable for:
        CalibrationParameterValue.applInitValue Not Applicable for:
        CalibrationParameterValue.implInitValue Not Applicable for:
        MetaDataItem.metaDataItemType Not Applicable for:
        NvProvideComSpec.romBlockInitValue Not Applicable for:
        NvProvideComSpec.ramBlockInitValue Not Applicable for:
        NvRequireComSpec.initValue Not Applicable for:
        ParameterProvideComSpec.initValue Not Applicable for:
        ParameterRequireComSpec.initValue Not Applicable for:
        NonqueuedSenderComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.timeoutSubstitutionValue Not Applicable
        for: PortDefinedArgumentValue.value Not Applicable for:
        CryptoServiceKey.developmentValue Not Applicable for:
        ISignal.timeoutSubstitutionValue Not Applicable for:
        ISignal.initValue Not Applicable for:
        FieldSenderComSpec.initValue Not Applicable for:
        PersistencyDataRequiredComSpec.initValue Not Applicable for:
        ApplicationAssocMapElementValueSpecification.value Not
        Applicable for: ApplicationAssocMapElementValueSpecification.key
        Not Applicable for: StateManagementCompareCondition.compareValue
        Not Applicable for: PersistencyKeyValuePair.initValue Not
        Applicable for: SwDataDefPropsContent.invalidValue
    :ivar value: This is the value itself.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NUMERICAL-VALUE-SPECIFICATION"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: NumericalValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class NvBlockDataMapping:
    """Defines the mapping between the VariableDataPrototypes in the
    NvBlockComponents ports and the VariableDataPrototypes of the RAM Block.

    The data types of the referenced VariableDataPrototypes in the ports
    and the referenced sub-element (inside a CompositeDataType) of the
    VariableDataPrototype representing the RAM Block shall be
    compatible.

    :ivar bitfield_text_table_mask_nv_block_descriptor: This attribute
        identifies the applicable bit mask on the side of the Nv Block.
    :ivar bitfield_text_table_mask_port_prototype: This attribute
        identifies the applicable bit mask on the side of the
        PortPrototype.
    :ivar nv_ram_block_element: Reference to a VariableDataPrototype of
        a RAM Block.
    :ivar read_nv_data: Reference to a VariableDataPrototype of a pPort
        of the NvBlockComponent providing read access to the RAM
        Block.If there is no PortPrototype providing read access (write-
        only) the reference can be omitted.
    :ivar written_nv_data: Reference to a VariableDataPrototype of a
        rPort of the NvBlockComponent providing write access to the RAM
        Block. If there is no port providing write access (read-only)
        the reference can be omitted.
    :ivar written_read_nv_data: Reference to a VariableDataPrototype of
        a PRPortPrototype of the NvBlockSwComponentType providing write
        and read access to the RAM Block.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        NvBlockDescriptor.nvBlockDataMapping Applicable for:
        BulkNvDataDescriptor.nvBlockDataMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NV-BLOCK-DATA-MAPPING"

    bitfield_text_table_mask_nv_block_descriptor: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BITFIELD-TEXT-TABLE-MASK-NV-BLOCK-DESCRIPTOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bitfield_text_table_mask_port_prototype: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BITFIELD-TEXT-TABLE-MASK-PORT-PROTOTYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nv_ram_block_element: AutosarVariableRef | None = field(
        default=None,
        metadata={
            "name": "NV-RAM-BLOCK-ELEMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    read_nv_data: AutosarVariableRef | None = field(
        default=None,
        metadata={
            "name": "READ-NV-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    written_nv_data: AutosarVariableRef | None = field(
        default=None,
        metadata={
            "name": "WRITTEN-NV-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    written_read_nv_data: AutosarVariableRef | None = field(
        default=None,
        metadata={
            "name": "WRITTEN-READ-NV-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class NvBlockNeeds:
    """
    Specifies the abstract needs on the configuration of a single NVRAM Block.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar calc_ram_block_crc: Defines if CRC (re)calculation for the
        permanent RAM Block is required.
    :ivar check_static_block_id: Defines if the Static Block Id check
        shall be enabled.
    :ivar cyclic_writing_period: This represents the period for cyclic
        writing of NvData to store the associated RAM Block.
    :ivar n_data_sets: Number of data sets to be provided by the NVRAM
        manager for this block. This is the total number of ROM Blocks
        and RAM Blocks.
    :ivar n_rom_blocks: Number of ROM Blocks to be provided by the NVRAM
        manager for this block. Please note that these multiple ROM
        Blocks are given in a contiguous area.
    :ivar ram_block_status_control: This attribute defines how the
        management of the RAM Block status is controlled.
    :ivar readonly: true: data of this NVRAM Block are write protected
        for normal operation (but protection can be disabled) false: no
        restriction
    :ivar reliability: Reliability against data loss on the non-volatile
        medium.
    :ivar resistant_to_changed_sw: Defines whether an NVRAM Block shall
        be treated resistant to configuration changes (true) or not
        (false). For details how to handle initialization in the latter
        case, please refer to the NVRAM specification.
    :ivar restore_at_start: Defines whether the associated RAM Block
        shall be implicitly restored during startup by the basic
        software.
    :ivar select_block_for_first_init_all: If this attribute is set to
        true the NvM shall process this block in the NvM_FirstInitAll()
        function.
    :ivar store_at_shutdown: Defines whether or not the associated RAM
        Block shall be implicitly stored during shutdown by the basic
        software.
    :ivar store_cyclic: Defines whether or not the associated RAM Block
        shall be implicitly stored periodically by the basic software.
    :ivar store_emergency: Defines whether or not the associated RAM
        Block shall be implicitly stored in case of ECU failure (e.g.
        loss of power) by the basic software. If the attribute
        storeEmergency is set to true the associated RAM Block shall be
        configured to have immediate priority.
    :ivar store_immediate: Defines whether or not the associated RAM
        Block shall be implicitly stored immediately during or after
        execution of the according SW-C RunnableEntity by the basic
        software.
    :ivar store_on_change: This attribute defines whether the associated
        RAM Block shall be stored immediately if the written value is
        different to the value stored in the associated RAM Block(s)
        during or after execution of the according SW-C RunnableEntity.
    :ivar use_auto_validation_at_shut_down: If set to true the RAM Block
        shall be auto validated during shutdown phase.
    :ivar use_crc_comp_mechanism: If set to true the CRC of the RAM
        Block shall be compared during a write job with the CRC which
        was calculated during the last successful read or write job in
        order to skip unnecessary NVRAM writings.
    :ivar write_only_once: Defines write protection after first write:
        true: This block is prevented from being changed/erased or being
        replaced with the default ROM data after first initialization by
        the software-component. false: No such restriction.
    :ivar write_verification: Defines if Write Verification shall be
        enabled for this NVRAM Block.
    :ivar writing_frequency: Provides the amount of updates to this
        block from the application point of view. It has to be provided
        in "number of write access per year".
    :ivar writing_priority: Requires the priority of writing this block
        in case of concurrent requests to write other blocks.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NV-BLOCK-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["NvBlockNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["NvBlockNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    calc_ram_block_crc: Boolean | None = field(
        default=None,
        metadata={
            "name": "CALC-RAM-BLOCK-CRC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    check_static_block_id: Boolean | None = field(
        default=None,
        metadata={
            "name": "CHECK-STATIC-BLOCK-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cyclic_writing_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "CYCLIC-WRITING-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    n_data_sets: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "N-DATA-SETS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    n_rom_blocks: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "N-ROM-BLOCKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ram_block_status_control: RamBlockStatusControlEnum | None = field(
        default=None,
        metadata={
            "name": "RAM-BLOCK-STATUS-CONTROL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    readonly: Boolean | None = field(
        default=None,
        metadata={
            "name": "READONLY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reliability: NvBlockNeedsReliabilityEnum | None = field(
        default=None,
        metadata={
            "name": "RELIABILITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resistant_to_changed_sw: Boolean | None = field(
        default=None,
        metadata={
            "name": "RESISTANT-TO-CHANGED-SW",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    restore_at_start: Boolean | None = field(
        default=None,
        metadata={
            "name": "RESTORE-AT-START",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    select_block_for_first_init_all: Boolean | None = field(
        default=None,
        metadata={
            "name": "SELECT-BLOCK-FOR-FIRST-INIT-ALL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    store_at_shutdown: Boolean | None = field(
        default=None,
        metadata={
            "name": "STORE-AT-SHUTDOWN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    store_cyclic: Boolean | None = field(
        default=None,
        metadata={
            "name": "STORE-CYCLIC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    store_emergency: Boolean | None = field(
        default=None,
        metadata={
            "name": "STORE-EMERGENCY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    store_immediate: Boolean | None = field(
        default=None,
        metadata={
            "name": "STORE-IMMEDIATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    store_on_change: Boolean | None = field(
        default=None,
        metadata={
            "name": "STORE-ON-CHANGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    use_auto_validation_at_shut_down: Boolean | None = field(
        default=None,
        metadata={
            "name": "USE-AUTO-VALIDATION-AT-SHUT-DOWN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    use_crc_comp_mechanism: Boolean | None = field(
        default=None,
        metadata={
            "name": "USE-CRC-COMP-MECHANISM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    write_only_once: Boolean | None = field(
        default=None,
        metadata={
            "name": "WRITE-ONLY-ONCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    write_verification: Boolean | None = field(
        default=None,
        metadata={
            "name": "WRITE-VERIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    writing_frequency: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "WRITING-FREQUENCY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    writing_priority: NvBlockNeedsWritingPriorityEnum | None = field(
        default=None,
        metadata={
            "name": "WRITING-PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ObdControlServiceNeeds:
    """
    Specifies the abstract needs of a component or module on the configuration of
    OBD Service 08 (request control of on-board system) in relation to a particular
    test-Identifier (TID) supported by this component or module.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar test_id: Test Identifier (TID) according to ISO 15031-5.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OBD-CONTROL-SERVICE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ObdControlServiceNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ObdControlServiceNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["ObdControlServiceNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    test_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TEST-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ObdInfoServiceNeeds:
    """
    Specifies the abstract needs of a component or module on the configuration of
    OBD Services in relation to a given InfoType (OBD Service 09) which is
    supported by this component or module.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar data_length: This attribute is applicable only if the
        ServiceNeeds is aggregated within BswModuleDependency. This
        attribute represents the length of data (in bytes) provided for
        this InfoType.
    :ivar info_type: The InfoType according to ISO 15031-5
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OBD-INFO-SERVICE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ObdInfoServiceNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ObdInfoServiceNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["ObdInfoServiceNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    info_type: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INFO-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ObdMonitorServiceNeeds:
    """Specifies the abstract needs of a component or module on the configuration
    of OBD Services in relation to a particular on-board monitoring test supported
    by this component or module.

    (OBD Service 06).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar application_data_type_ref: reference to an ApplicationDataType
        that describes the scaling of the data reported by the software-
        component to the Dem.
    :ivar event_needs_ref: This reference identifies the corresponding
        diagnostic event.
    :ivar on_board_monitor_id: On-board monitor ID according to ISO
        15031-5.
    :ivar test_id: Test Identifier (TID) according to ISO 15031-5.
    :ivar unit_and_scaling_id: Unit and scaling ID according to ISO
        15031-5.
    :ivar update_kind: This attribute indicates the settings for the
        acceptance of updates.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OBD-MONITOR-SERVICE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ObdMonitorServiceNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ObdMonitorServiceNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["ObdMonitorServiceNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_data_type_ref: Optional["ObdMonitorServiceNeeds.ApplicationDataTypeRef"] = field(
        default=None,
        metadata={
            "name": "APPLICATION-DATA-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_needs_ref: Optional["ObdMonitorServiceNeeds.EventNeedsRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-NEEDS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    on_board_monitor_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ON-BOARD-MONITOR-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    test_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TEST-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_and_scaling_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UNIT-AND-SCALING-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update_kind: DiagnosticMonitorUpdateKindEnum | None = field(
        default=None,
        metadata={
            "name": "UPDATE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ApplicationDataTypeRef(Ref):
        dest: ApplicationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventNeedsRef(Ref):
        dest: DiagnosticEventNeedsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ObdPidServiceNeeds:
    """Specifies the abstract needs of a component or module on the configuration
    of OBD Services in relation to a particular PID (parameter identifier) which is
    supported by this component or module.

    In case of using a client/server communicated value, the related
    value shall be communicated via the port referenced by assignedPort.
    The details of this communication (e.g. appropriate naming
    conventions) are specified in the related software specifications
    (SWS).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar data_length: This attribute is applicable only if the
        ServiceNeeds is aggregated within BswModuleDependency. This
        attribute represents the length of data (in bytes) provided for
        this particular PID signal.
    :ivar parameter_id: Standardized parameter identifier (PID)
        according to the OBD standard specified in attribute "standard".
    :ivar standard: Annotates the standard according to which the PID is
        given, e.g. "ISO15031-5" or "SAE J1979 Rev May 2007".
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OBD-PID-SERVICE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ObdPidServiceNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ObdPidServiceNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["ObdPidServiceNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PARAMETER-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    standard: String | None = field(
        default=None,
        metadata={
            "name": "STANDARD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ObdRatioDenominatorNeeds:
    """
    This meta-class shall be used to indicate that a software-component wants to
    access the in-use-monitoring performance ration denominator.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar denominator_condition: This attribute indicates the applicable
        denominator condition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OBD-RATIO-DENOMINATOR-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ObdRatioDenominatorNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ObdRatioDenominatorNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["ObdRatioDenominatorNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    denominator_condition: DiagnosticDenominatorConditionEnum | None = field(
        default=None,
        metadata={
            "name": "DENOMINATOR-CONDITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ObdRatioServiceNeeds:
    """
    Specifies the abstract needs of a component or module on the configuration of
    OBD Services in relation to a particular "ratio monitoring" which is supported
    by this component or module.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar connection_type: Defines how the DEM is connected to the
        component or module to perform the IUMPR (In use monitor
        performance ratio) service.
    :ivar denominator_group: The denominator Dem shall use to compute
        the ratio.
    :ivar iumpr_group: Defines the IUMPR (In use monitor performance
        ratio) Group of the SAE standard. Note that possible values are
        not predefined by an enumeration meta-type in order to make the
        meta-model independent of the details of the SAE standard.
    :ivar rate_based_monitored_event_ref: The rate based monitored
        Diagnostic Event.
    :ivar used_fid_ref: This represents the primary Function Inhibition
        Identifier used for the rate based monitor. This is an optional
        attribute.
    :ivar used_secondary_fid_refs: This represents the secondary
        Function Inhibition Identifier used for the rate based monitor.
        This is an optional attribute. Any of the FID inhibitions leads
        to an inhibition of the IUMPR calculation
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OBD-RATIO-SERVICE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ObdRatioServiceNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ObdRatioServiceNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["ObdRatioServiceNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    connection_type: ObdRatioConnectionKindEnum | None = field(
        default=None,
        metadata={
            "name": "CONNECTION-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    denominator_group: DiagnosticDenominatorConditionEnum | None = field(
        default=None,
        metadata={
            "name": "DENOMINATOR-GROUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    iumpr_group: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "IUMPR-GROUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rate_based_monitored_event_ref: Optional["ObdRatioServiceNeeds.RateBasedMonitoredEventRef"] = (
        field(
            default=None,
            metadata={
                "name": "RATE-BASED-MONITORED-EVENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    used_fid_ref: Optional["ObdRatioServiceNeeds.UsedFidRef"] = field(
        default=None,
        metadata={
            "name": "USED-FID-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    used_secondary_fid_refs: Optional["ObdRatioServiceNeeds.UsedSecondaryFidRefs"] = field(
        default=None,
        metadata={
            "name": "USED-SECONDARY-FID-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RateBasedMonitoredEventRef(Ref):
        dest: DiagnosticEventNeedsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class UsedFidRef(Ref):
        dest: FunctionInhibitionNeedsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class UsedSecondaryFidRefs:
        used_secondary_fid_ref: list[
            "ObdRatioServiceNeeds.UsedSecondaryFidRefs.UsedSecondaryFidRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "USED-SECONDARY-FID-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class UsedSecondaryFidRef(Ref):
            dest: FunctionInhibitionNeedsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class OffsetTimingConstraint:
    """Bounds the time offset between the occurrence of two timing events, without
    requiring a direct functional dependency between the source and the target.

    If the target event occurs, it is expected to occur earliest with
    the minimum, and latest with the maximum offset relatively after the
    occurrence of the source event. Note: not every source event
    occurrence shall be followed by a target event occurrence. In
    contrast to LatencyTimingConstraint, there shall not necessarily be
    a causal dependency between the source and target event.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar timing_condition_ref: A timing condition the timing constraint
        depends on. In other words it specifies the condition the timing
        constraint holds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingRequirement Applicable for:
        TimingExtension.timingGuarantee
    :ivar source_ref: The timing event that the target event is to be
        synchronized with.
    :ivar target_ref: The timing event which is expected to occur timely
        after the source event.
    :ivar minimum: The mimum offset the target event occurs relatively
        after the occurrence of the source event.
    :ivar maximum: The maximum offset the target event occurs relatively
        after the occurrence of the source event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OFFSET-TIMING-CONSTRAINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["OffsetTimingConstraint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["OffsetTimingConstraint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["OffsetTimingConstraint.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_condition_ref: Optional["OffsetTimingConstraint.TimingConditionRef"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_ref: Optional["OffsetTimingConstraint.SourceRef"] = field(
        default=None,
        metadata={
            "name": "SOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_ref: Optional["OffsetTimingConstraint.TargetRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MINIMUM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["OffsetTimingConstraint.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimingConditionRef(Ref):
        dest: TimingConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SourceRef(Ref):
        dest: TimingDescriptionEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRef(Ref):
        dest: TimingDescriptionEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class OperationInvokedEvent:
    """
    This event is raised when the ClientServerOperation referenced in
    OperationInvokedEvent.operation shall be invoked.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar operation_iref: This represents the ClientServerOperation
        which shall be invoked.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OPERATION-INVOKED-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["OperationInvokedEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["OperationInvokedEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "OperationInvokedEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["OperationInvokedEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["OperationInvokedEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_iref: POperationInAtomicSwcInstanceRef | None = field(
        default=None,
        metadata={
            "name": "OPERATION-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class OsTaskExecutionEvent:
    """This RTEEvent is supposed to execute RunnableEntities which have to react on
    the execution of specific OsTasks.

    Therefore, this event is unconditionally raised whenever the OsTask
    on which it is mapped is executed. The main use case for this event
    is scheduling of Runnables of Complex Drivers which have to react on
    task executions.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OS-TASK-EXECUTION-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["OsTaskExecutionEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["OsTaskExecutionEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "OsTaskExecutionEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["OsTaskExecutionEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["OsTaskExecutionEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class OsTaskProxy:
    """
    This meta-class represents a proxy for an OsTask in the System Description.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar period: This attribute specifies the period in seconds of this
        task in case of a cyclically activated task. Please note that
        this attribute is informative and not directly relevant for the
        AUTOSAR OS. But the attribute value can be mapped into the OS
        configuration to support configuration work flows using a fixed
        set of OsTasks.
    :ivar preemptability: This attribute defines the preemptability of
        the task.
    :ivar priority: This attribute defines the priority of a task as a
        relative value, i.e. the values show only the relative ordering
        of the tasks.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OS-TASK-PROXY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["OsTaskProxy.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["OsTaskProxy.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    preemptability: OsTaskPreemptabilityEnum | None = field(
        default=None,
        metadata={
            "name": "PREEMPTABILITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ParameterAccess:
    """
    The presence of a ParameterAccess implies that a RunnableEntity needs access to
    a ParameterDataPrototype.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar return_value_provision: This attribute controls the provision
        of return values for RTE APIs that correspond to the enclosing
        access point.
    :ivar accessed_parameter: Reference to the accessed calibration
        parameter.
    :ivar sw_data_def_props: This allows denote instance and access
        specific properties, mainly input values and common axis.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RunnableEntity.parameterAccess
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PARAMETER-ACCESS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ParameterAccess.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ParameterAccess.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    return_value_provision: RteApiReturnValueProvisionEnum | None = field(
        default=None,
        metadata={
            "name": "RETURN-VALUE-PROVISION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    accessed_parameter: AutosarParameterRef | None = field(
        default=None,
        metadata={
            "name": "ACCESSED-PARAMETER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PassThroughSwConnector:
    """
    This kind of SwConnector can be used inside a CompositionSwComponentType to
    connect two delegation PortPrototypes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar mapping_ref: Reference to a PortInterfaceMapping specifying
        the mapping of unequal named PortInterface elements of the two
        different PortInterfaces typing the two PortPrototypes which are
        referenced by the ConnectorPrototype.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CompositionSwComponentType.connector
    :ivar provided_outer_port_ref: This represents the provided outer
        delegation PortPrototype of the PassThroughSwConnector.
    :ivar required_outer_port_ref: This represents the required outer
        delegation PortPrototype of the PassThroughSwConnector.
    :ivar service_interface_element_mapping_refs: Reference to a
        ServiceInterfaceElementMapping specifying the mapping of unequal
        named ServiceInterface elements of the two different
        ServiceInterfaces typing the two PortPrototypes which are
        referenced by the PassThroughSwConnector.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PASS-THROUGH-SW-CONNECTOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PassThroughSwConnector.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PassThroughSwConnector.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapping_ref: Optional["PassThroughSwConnector.MappingRef"] = field(
        default=None,
        metadata={
            "name": "MAPPING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_outer_port_ref: Optional["PassThroughSwConnector.ProvidedOuterPortRef"] = field(
        default=None,
        metadata={
            "name": "PROVIDED-OUTER-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_outer_port_ref: Optional["PassThroughSwConnector.RequiredOuterPortRef"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-OUTER-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_element_mapping_refs: Optional[
        "PassThroughSwConnector.ServiceInterfaceElementMappingRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-ELEMENT-MAPPING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MappingRef(Ref):
        dest: PortInterfaceMappingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedOuterPortRef(Ref):
        dest: AbstractProvidedPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredOuterPortRef(Ref):
        dest: AbstractRequiredPortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInterfaceElementMappingRefs:
        service_interface_element_mapping_ref: list[
            "PassThroughSwConnector.ServiceInterfaceElementMappingRefs.ServiceInterfaceElementMappingRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE-ELEMENT-MAPPING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceInterfaceElementMappingRef(Ref):
            dest: ServiceInterfaceElementMappingSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class PduActivationRoutingGroup:
    """
    Group of Pdus that can be activated or deactivated for transmission over a
    socket connection.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar event_group_control_type: This attribute defines the type of a
        RoutingGroup. There are RoutingGroups that activate the data
        path for unicast or multicast events of an event group. And
        there are RoutingGroups that activate the data path for initial
        events that are triggered, namely events that are sent out on
        the server side after a client got subscribed. Please note that
        this attribute is only valid for event communication (Sender
        Receiver communication) and shall be omitted in
        MethodActivationRoutingGroups.
    :ivar i_pdu_identifier_tcp_refs: PduIdentifiers assigned for
        transmission over Tcp in case that the referencing
        PduActivationRoutingGroup is activated.
    :ivar i_pdu_identifier_udp_refs: PduIdentifiers assigned for
        transmission over Udp in case that the referencing
        PduActivationRoutingGroup is activated.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        AbstractServiceInstance.methodActivationRoutingGroup Not
        Applicable for: ConsumedEventGroup.pduActivationRoutingGroup Not
        Applicable for: EventHandler.pduActivationRoutingGroup
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PDU-ACTIVATION-ROUTING-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PduActivationRoutingGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PduActivationRoutingGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_control_type: EventGroupControlTypeEnum | None = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-CONTROL-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_pdu_identifier_tcp_refs: Optional["PduActivationRoutingGroup.IPduIdentifierTcpRefs"] = field(
        default=None,
        metadata={
            "name": "I-PDU-IDENTIFIER-TCP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_pdu_identifier_udp_refs: Optional["PduActivationRoutingGroup.IPduIdentifierUdpRefs"] = field(
        default=None,
        metadata={
            "name": "I-PDU-IDENTIFIER-UDP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IPduIdentifierTcpRefs:
        i_pdu_identifier_tcp_ref: list[
            "PduActivationRoutingGroup.IPduIdentifierTcpRefs.IPduIdentifierTcpRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "I-PDU-IDENTIFIER-TCP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class IPduIdentifierTcpRef(Ref):
            dest: SoConIPduIdentifierSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class IPduIdentifierUdpRefs:
        i_pdu_identifier_udp_ref: list[
            "PduActivationRoutingGroup.IPduIdentifierUdpRefs.IPduIdentifierUdpRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "I-PDU-IDENTIFIER-UDP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class IPduIdentifierUdpRef(Ref):
            dest: SoConIPduIdentifierSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class PduToFrameMapping:
    """
    A PduToFrameMapping defines the composition of Pdus in each frame.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar packing_byte_order: This attribute defines the order of the
        bytes of the Pdu and the packing into the Frame. Please consider
        that [constr_3246] and [constr_3222] are restricting the usage
        of this attribute.
    :ivar pdu_ref: Reference to a I-Pdu, N-Pdu or NmPdu that is
        transmitted in the Frame.
    :ivar start_position: This attribute describes the bitposition of a
        Pdu within a Frame. Please note that the absolute position of
        the Pdu in the Frame is determined by the definition of the
        packingByteOrder attribute. If Big Endian is specified, the
        start position indicates the bit position of the most
        significant bit in the Frame. If Little Endian is specified, the
        start position indicates the bit position of the least
        significant bit in the Frame. The bit counting in byte 0 starts
        with bit 0 (least significant bit). The most significant bit in
        byte 0 is bit 7. The Pdus are byte aligned in a Frame and only
        the values  0, 8, 16, 24,... (for little endian) and  7, 15, 23,
        ... (for big endian) are allowed.
    :ivar update_indication_bit_position: Indication to the receivers
        that the corresponding Pdu was updated by the sender. This
        attribute describes the position of the update bit in the frame
        that aggregates this PDUToFrameMapping. Length is always one
        bit. Note that the exact bit position of the
        updateIndicationBitPosition is linked to the value of the
        attribute packingByteOrder because the method of finding the bit
        position is different for the values mostSignificantByteFirst
        and mostSignificantByteLast. This means that if the value of
        packingByteOrder is changed while the value of
        updateIndicationBitPosition remains unchanged the exact bit
        position of updateIndicationBitPosition within the enclosing
        Frame still undergoes a change. This attribute denotes the least
        significant bit for "Little Endian" and the most significant bit
        for "Big Endian" packed signals within the IPdu (see the
        description of the packingByteOrder attribute). In AUTOSAR the
        bit counting is always set to "sawtooth" and the bit order is
        set to "Decreasing". The bit counting in byte 0 starts with bit
        0 (least significant bit). The most significant bit in byte 0 is
        bit 7.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: Frame.pduToFrameMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PDU-TO-FRAME-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PduToFrameMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PduToFrameMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    packing_byte_order: ByteOrderEnum | None = field(
        default=None,
        metadata={
            "name": "PACKING-BYTE-ORDER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_ref: Optional["PduToFrameMapping.PduRef"] = field(
        default=None,
        metadata={
            "name": "PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_position: Integer | None = field(
        default=None,
        metadata={
            "name": "START-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update_indication_bit_position: Integer | None = field(
        default=None,
        metadata={
            "name": "UPDATE-INDICATION-BIT-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduRef(Ref):
        dest: PduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PduTriggeringRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar pdu_triggering_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PDU-TRIGGERING-REF-CONDITIONAL"

    pdu_triggering_ref: Optional["PduTriggeringRefConditional.PduTriggeringRef"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PduTriggeringRef(Ref):
        dest: PduTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PerInstanceMemory:
    """Defines a 'C' typed memory-block that needs to be available for each
    instance of the SW-component.

    This is typically only useful if supportsMultipleInstantiation is
    set to "true" or if the software-component defines NVRAM access via
    permanent blocks.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar init_value: Specifies initial value(s) of the
        PerInstanceMemory
    :ivar sw_data_def_props: This represents the ability to to allocate
        RAM at specific memory sections, for example, to support the RAM
        Block recovery strategy by mapping to uninitialized RAM.
    :ivar type_value: The name of the "C"-type
    :ivar type_definition: A definition of the type with the syntax of a
        'C' typedef.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.perInstanceMemory
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PER-INSTANCE-MEMORY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PerInstanceMemory.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PerInstanceMemory.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    init_value: String | None = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_value: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_definition: String | None = field(
        default=None,
        metadata={
            "name": "TYPE-DEFINITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PerInstanceMemorySize:
    """Resources needed by the allocation of PerInstanceMemory for each SWC
    instance.

    Note that these resources are not covered by an ObjectFileSection,
    because they are supposed to be allocated by the RTE.

    :ivar alignment: Required alignment (1,2,4,...) of the referenced
        PerInstanceMemory.  Unit: byte.
    :ivar per_instance_memory_ref: This represents the referenced
        PerInstanceMemory.
    :ivar size: Size (in bytes) of the reference perInstanceMemory. The
        aggregation of PerInstanceMemorySize is subject to variability
        with the purpose to support variability in the software
        components implementations. Different algorithms in the
        implementation might require a different PerInstanceMemorySize.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcImplementation.perInstanceMemorySize
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PER-INSTANCE-MEMORY-SIZE"

    alignment: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ALIGNMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    per_instance_memory_ref: Optional["PerInstanceMemorySize.PerInstanceMemoryRef"] = field(
        default=None,
        metadata={
            "name": "PER-INSTANCE-MEMORY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PerInstanceMemoryRef(Ref):
        dest: PerInstanceMemorySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PeriodicEventTriggering:
    """The PeriodicEventTriggering describes the behavior of an event with a strict
    periodic occurrence pattern, given by the period attribute.

    Additionally, it is possible to soften the strictness of the
    periodic occurrence behavior by specifying a jitter, so that there
    can be a deviation from the period up to the size of the jitter.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar timing_condition_ref: A timing condition the timing constraint
        depends on. In other words it specifies the condition the timing
        constraint holds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingRequirement Applicable for:
        TimingExtension.timingGuarantee
    :ivar event_ref: The referenced timing event
    :ivar minimum_inter_arrival_time: The minimum time distance between
        two consecutive occurrences of the associated event.
    :ivar jitter: The maximum jitter of the periodic event occurrence.
    :ivar period: The period of the event occurrence.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERIODIC-EVENT-TRIGGERING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PeriodicEventTriggering.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PeriodicEventTriggering.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["PeriodicEventTriggering.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_condition_ref: Optional["PeriodicEventTriggering.TimingConditionRef"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["PeriodicEventTriggering.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_inter_arrival_time: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-INTER-ARRIVAL-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    jitter: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "JITTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    period: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["PeriodicEventTriggering.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimingConditionRef(Ref):
        dest: TimingConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: TimingDescriptionEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PermissibleSignalPath:
    """The PermissibleSignalPath describes the way a data element shall take in the
    topology.

    The path is described by ordered references to PhysicalChannels. If
    more than one PermissibleSignalPath is defined for the same
    signal/operation attributes, any of them can be chosen. Such a
    signal path can be a constraint for the communication matrix . This
    path describes that one data element should take path A (e.g. 1. CAN
    channel, 2. LIN channel) and not path B (1. CAN channel, FlexRay
    channel A). This has an effect on the frame generation and the frame
    path.

    :ivar introduction: This represents introductory documentation about
        the signal path constraint.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.signalPathConstraint
    :ivar operations: The arguments of an operation that can take the
        predefined way in the topology.
    :ivar physical_channel_refs: The SwcToSwcSignal can be transmitted
        on one of these physical channels.
    :ivar signals: The data element which can take the predefined way in
        the topology.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERMISSIBLE-SIGNAL-PATH"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operations: Optional["PermissibleSignalPath.Operations"] = field(
        default=None,
        metadata={
            "name": "OPERATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_channel_refs: Optional["PermissibleSignalPath.PhysicalChannelRefs"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNEL-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signals: Optional["PermissibleSignalPath.Signals"] = field(
        default=None,
        metadata={
            "name": "SIGNALS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Operations:
        swc_to_swc_operation_arguments: list[SwcToSwcOperationArguments] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TO-SWC-OPERATION-ARGUMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannelRefs:
        physical_channel_ref: list[
            "PermissibleSignalPath.PhysicalChannelRefs.PhysicalChannelRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "PHYSICAL-CHANNEL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PhysicalChannelRef(Ref):
            dest: PhysicalChannelSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class Signals:
        swc_to_swc_signal: list[SwcToSwcSignal] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TO-SWC-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PersistencyDataElement:
    """This meta-class represents the ability to formally specify a piece of data
    that is subject to persistency in the context of the enclosing
    PersistencyKeyValueStorageInterface.

    PersistencyDataElement represents also a key-value pair of the
    deployed PersistencyKeyValueStorage and provides an initial value.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sw_data_def_props: This property allows to specify data
        definition properties which apply on data prototype level.
    :ivar type_tref: This represents the corresponding data type.
    :ivar update_strategy: This attribute can be used to specify the
        update strategy of the respective PersistencyInterfaceElement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-DATA-ELEMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PersistencyDataElement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PersistencyDataElement.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_tref: Optional["PersistencyDataElement.TypeTref"] = field(
        default=None,
        metadata={
            "name": "TYPE-TREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update_strategy: PersistencyElementLevelUpdateStrategyEnum | None = field(
        default=None,
        metadata={
            "name": "UPDATE-STRATEGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TypeTref(Ref):
        dest: AutosarDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PersistencyDeploymentElementToCryptoKeySlotMapping:
    """
    This meta-class represents the ability to define a mapping between the
    PersistencyDeploymentElement and a CryptoKeySlot.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar crypto_algorithm_string: This attribute defines the
        cryptographic algorithm used for hashing, encryption,
        decryption, signature/MAC verification, or MAC generation.
    :ivar crypto_key_slot_ref: This reference represents the mapped
        CryptoKeySlot.
    :ivar key_slot_usage: This attribute defines the role of the keySlot
        assignment.
    :ivar persistency_deployment_element_ref: This reference represents
        the mapped PersistencyDeployment.
    :ivar verification_hash: This attribute defines the hash of the
        storage used in case of verification.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-DEPLOYMENT-ELEMENT-TO-CRYPTO-KEY-SLOT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "PersistencyDeploymentElementToCryptoKeySlotMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PersistencyDeploymentElementToCryptoKeySlotMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_algorithm_string: String | None = field(
        default=None,
        metadata={
            "name": "CRYPTO-ALGORITHM-STRING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_key_slot_ref: Optional[
        "PersistencyDeploymentElementToCryptoKeySlotMapping.CryptoKeySlotRef"
    ] = field(
        default=None,
        metadata={
            "name": "CRYPTO-KEY-SLOT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_slot_usage: CryptoKeySlotUsageEnum | None = field(
        default=None,
        metadata={
            "name": "KEY-SLOT-USAGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    persistency_deployment_element_ref: Optional[
        "PersistencyDeploymentElementToCryptoKeySlotMapping.PersistencyDeploymentElementRef"
    ] = field(
        default=None,
        metadata={
            "name": "PERSISTENCY-DEPLOYMENT-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verification_hash: String | None = field(
        default=None,
        metadata={
            "name": "VERIFICATION-HASH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoKeySlotRef(Ref):
        dest: CryptoKeySlotSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PersistencyDeploymentElementRef(Ref):
        dest: PersistencyDeploymentElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PersistencyDeploymentToCryptoKeySlotMapping:
    """
    This meta-class represents the ability to define a mapping between the
    PersistencyDeployment and a CryptoKeySlot.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar crypto_algorithm_string: This attribute defines the
        cryptographic algorithm used for hashing, encryption,
        decryption, signature/MAC verification, or MAC generation.
    :ivar crypto_key_slot_ref: This reference represents the mapped
        CryptoKeySlot.
    :ivar key_slot_usage: This attribute defines the role of the keySlot
        assignment.
    :ivar persistency_deployment_ref: This reference represents the
        mapped PersistencyDeployment.
    :ivar verification_hash: This attribute defines the hash of the
        storage used in case of verification.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-DEPLOYMENT-TO-CRYPTO-KEY-SLOT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "PersistencyDeploymentToCryptoKeySlotMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PersistencyDeploymentToCryptoKeySlotMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_algorithm_string: String | None = field(
        default=None,
        metadata={
            "name": "CRYPTO-ALGORITHM-STRING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_key_slot_ref: Optional[
        "PersistencyDeploymentToCryptoKeySlotMapping.CryptoKeySlotRef"
    ] = field(
        default=None,
        metadata={
            "name": "CRYPTO-KEY-SLOT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_slot_usage: CryptoKeySlotUsageEnum | None = field(
        default=None,
        metadata={
            "name": "KEY-SLOT-USAGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    persistency_deployment_ref: Optional[
        "PersistencyDeploymentToCryptoKeySlotMapping.PersistencyDeploymentRef"
    ] = field(
        default=None,
        metadata={
            "name": "PERSISTENCY-DEPLOYMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verification_hash: String | None = field(
        default=None,
        metadata={
            "name": "VERIFICATION-HASH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoKeySlotRef(Ref):
        dest: CryptoKeySlotSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PersistencyDeploymentRef(Ref):
        dest: PersistencyDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PersistencyDeploymentToDltLogSinkMapping:
    """
    This meta-class represents the ability to define a mapping between the
    PersistencyDeployment and a DltLogSink.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar dlt_context_ref: Reference to the DltContext to which this
        mapping belongs.
    :ivar log_sink_ref: Reference to the DltLogSink to which the
        PersistencyDeployment is mapped
    :ivar persistency_deployment_ref: This reference represents the
        mapped PersistencyDeployment.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-DEPLOYMENT-TO-DLT-LOG-SINK-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "PersistencyDeploymentToDltLogSinkMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PersistencyDeploymentToDltLogSinkMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_context_ref: Optional["PersistencyDeploymentToDltLogSinkMapping.DltContextRef"] = field(
        default=None,
        metadata={
            "name": "DLT-CONTEXT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    log_sink_ref: Optional["PersistencyDeploymentToDltLogSinkMapping.LogSinkRef"] = field(
        default=None,
        metadata={
            "name": "LOG-SINK-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    persistency_deployment_ref: Optional[
        "PersistencyDeploymentToDltLogSinkMapping.PersistencyDeploymentRef"
    ] = field(
        default=None,
        metadata={
            "name": "PERSISTENCY-DEPLOYMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DltContextRef(Ref):
        dest: DltContextSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class LogSinkRef(Ref):
        dest: DltLogSinkSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PersistencyDeploymentRef(Ref):
        dest: PersistencyDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PersistencyFile:
    """
    This meta-class represents the model of a file as part of the persistency on
    deployment level.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar update_strategy: This attribute can be used to specify the
        update strategy of the respective PersistencyDeploymentElement.
    :ivar content_uri: This attribute represents the URI that identifies
        the initial content of the PersistencyFile.
    :ivar file_name: This attribute holds filename part of the storage
        location for the PersistencyFile, e.g. file on the file system.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-FILE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PersistencyFile.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PersistencyFile.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update_strategy: PersistencyElementLevelUpdateStrategyEnum | None = field(
        default=None,
        metadata={
            "name": "UPDATE-STRATEGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    content_uri: UriString | None = field(
        default=None,
        metadata={
            "name": "CONTENT-URI",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    file_name: String | None = field(
        default=None,
        metadata={
            "name": "FILE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PersistencyFileElement:
    """
    This meta-class has the ability to represent a file at design time such that it
    is possible to configure the behavior for accessing the represented file at
    run-time.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar update_strategy: This attribute can be used to specify the
        update strategy of the respective PersistencyInterfaceElement.
    :ivar content_uri: This attribute represents the URI that identifies
        the initial content of the PersistencyFile.
    :ivar file_name: This attribute holds the filename part of the
        storage location, e.g. file on the file system.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-FILE-ELEMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PersistencyFileElement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PersistencyFileElement.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update_strategy: PersistencyElementLevelUpdateStrategyEnum | None = field(
        default=None,
        metadata={
            "name": "UPDATE-STRATEGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    content_uri: UriString | None = field(
        default=None,
        metadata={
            "name": "CONTENT-URI",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    file_name: String | None = field(
        default=None,
        metadata={
            "name": "FILE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PersistencyKeyValueDataTypeMapping:
    """
    This meta-class represents the ability to define a mapping between an existing
    data type in a key-value-storage stored by a previous version to a new data
    type used on application software level in the current version.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar current_data_type_ref: This reference identifies the current
        data type for an existing key-value-pair in the context of the
        enclosing PersistencyKeyValueStorageInterface.
    :ivar previous_data_type_ref: This reference identifies the previous
        data type in a key-value-pair existing in the context of the
        enclosing PersistencyKeyValueStorageInterface.
    :ivar previous_executable_version: This attribute identifies the
        version of the Executable in which the previousDataType was
        used.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-KEY-VALUE-DATA-TYPE-MAPPING"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    current_data_type_ref: Optional["PersistencyKeyValueDataTypeMapping.CurrentDataTypeRef"] = (
        field(
            default=None,
            metadata={
                "name": "CURRENT-DATA-TYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    previous_data_type_ref: Optional["PersistencyKeyValueDataTypeMapping.PreviousDataTypeRef"] = (
        field(
            default=None,
            metadata={
                "name": "PREVIOUS-DATA-TYPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    previous_executable_version: StrongRevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "PREVIOUS-EXECUTABLE-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CurrentDataTypeRef(Ref):
        dest: AutosarDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PreviousDataTypeRef(Ref):
        dest: AutosarDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PersistencyPortPrototypeToFileStorageMapping:
    """
    This meta-class represents the ability to define a mapping between a collection
    of files on deployment level to a given PortPrototype.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar port_prototype_iref: This reference represents the mapped
        PortPrototype.
    :ivar process_ref: This reference represents the process required as
        context for the mapping.
    :ivar file_storage_ref: This reference represents the mapped file
        storage.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-PORT-PROTOTYPE-TO-FILE-STORAGE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "PersistencyPortPrototypeToFileStorageMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PersistencyPortPrototypeToFileStorageMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_iref: PortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["PersistencyPortPrototypeToFileStorageMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    file_storage_ref: Optional["PersistencyPortPrototypeToFileStorageMapping.FileStorageRef"] = (
        field(
            default=None,
            metadata={
                "name": "FILE-STORAGE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FileStorageRef(Ref):
        dest: PersistencyFileStorageSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PersistencyPortPrototypeToKeyValueStorageMapping:
    """
    This meta-class represents the ability to define a mapping between a
    PortPrototype and a key-value storage.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar port_prototype_iref: This reference represents the mapped
        PortPrototype.
    :ivar process_ref: This reference represents the process required as
        context for the mapping.
    :ivar key_value_storage_ref: This reference represents the mapped
        key-value storage.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-PORT-PROTOTYPE-TO-KEY-VALUE-STORAGE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "PersistencyPortPrototypeToKeyValueStorageMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PersistencyPortPrototypeToKeyValueStorageMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_iref: PortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["PersistencyPortPrototypeToKeyValueStorageMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_value_storage_ref: Optional[
        "PersistencyPortPrototypeToKeyValueStorageMapping.KeyValueStorageRef"
    ] = field(
        default=None,
        metadata={
            "name": "KEY-VALUE-STORAGE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class KeyValueStorageRef(Ref):
        dest: PersistencyKeyValueStorageSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PhmCheckpoint:
    """
    This meta-class provides the ability to implement a checkpoint for interaction
    with the Platform Health Management Supervised Entity.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar checkpoint_id: Defines the numeric value which is used to
        indicate the reporting of this Checkpoint to the Phm.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PHM-CHECKPOINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PhmCheckpoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PhmCheckpoint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    checkpoint_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CHECKPOINT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PhmContributionToMachineMapping:
    """
    This element associates one or more PlatformHealthManagementContributions with
    a Machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar machine_ref: This reference identifies the Machine in the
        context of the PhmContributionToMachineMapping.
    :ivar phm_contribution_refs: This reference identifies one or more
        PlatformHealthManagementContributions in the context of a
        PhmContributionToMachineMapping.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PHM-CONTRIBUTION-TO-MACHINE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PhmContributionToMachineMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PhmContributionToMachineMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    machine_ref: Optional["PhmContributionToMachineMapping.MachineRef"] = field(
        default=None,
        metadata={
            "name": "MACHINE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    phm_contribution_refs: Optional["PhmContributionToMachineMapping.PhmContributionRefs"] = field(
        default=None,
        metadata={
            "name": "PHM-CONTRIBUTION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MachineRef(Ref):
        dest: MachineSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PhmContributionRefs:
        phm_contribution_ref: list[
            "PhmContributionToMachineMapping.PhmContributionRefs.PhmContributionRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "PHM-CONTRIBUTION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PhmContributionRef(Ref):
            dest: PlatformHealthManagementContributionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class PhmHealthChannelRecoveryNotificationInterface:
    """
    This meta-class represents a PortInterface that can be taken for implementing a
    PHM HealthChannel notification.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PHM-HEALTH-CHANNEL-RECOVERY-NOTIFICATION-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "PhmHealthChannelRecoveryNotificationInterface.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PhmHealthChannelRecoveryNotificationInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional[
        "PhmHealthChannelRecoveryNotificationInterface.BlueprintPolicys"
    ] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["PhmHealthChannelRecoveryNotificationInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PhmHealthChannelStatus:
    """
    The PhmHealthChannelStatus specifies one possible status of the health channel.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar status_id: Defines the numeric value which is used to indicate
        the indication of this status the Phm.
    :ivar triggers_recovery_notification: Defines whether this
        PhmHealthChannelStatus shall cause the Phm to trigger the Health
        Channel recovery notification. True: Indicates unhealthy state.
        Phm to trigger the Health Channel recovery notification when the
        Health channel status changes to this state. False: Indicates
        healthy state. Phm not to trigger the Health Channel recovery
        notification when the Health channel status changes to this
        state.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PHM-HEALTH-CHANNEL-STATUS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PhmHealthChannelStatus.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PhmHealthChannelStatus.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    status_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "STATUS-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    triggers_recovery_notification: Boolean | None = field(
        default=None,
        metadata={
            "name": "TRIGGERS-RECOVERY-NOTIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PhmSupervisionRecoveryNotificationInterface:
    """
    This meta-class represents a PortInterface that can be taken for implementing a
    PHM Supervision notification.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PHM-SUPERVISION-RECOVERY-NOTIFICATION-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "PhmSupervisionRecoveryNotificationInterface.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PhmSupervisionRecoveryNotificationInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["PhmSupervisionRecoveryNotificationInterface.BlueprintPolicys"] = (
        field(
            default=None,
            metadata={
                "name": "BLUEPRINT-POLICYS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["PhmSupervisionRecoveryNotificationInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PhysicalChannelRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar physical_channel_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PHYSICAL-CHANNEL-REF-CONDITIONAL"

    physical_channel_ref: Optional["PhysicalChannelRefConditional.PhysicalChannelRef"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNEL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannelRef(Ref):
        dest: PhysicalChannelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PhysicalDimension:
    """This class represents a physical dimension.

    If the physical dimension of two units is identical, then a
    conversion between them is possible. The conversion between units is
    related to the definition of the physical dimension. Note that the
    equivalence of the exponents does not per se define the
    convertibility. For example Energy and Torque share the same
    exponents (Nm). Please note further the value of an exponent does
    not necessarily have to be an integer number. It is also possible
    that the value yields a rational number, e.g. to compute the square
    root of a given physical quantity. In this case the exponent value
    would be a rational number where the numerator value is 1 and the
    denominator value is 2.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar length_exp: The exponent of the physical dimension "length".
    :ivar mass_exp: The exponent of the physical dimension "mass".
    :ivar time_exp: The exponent of the physical dimension "time".
    :ivar current_exp: This attribute represents the exponent of the
        physical dimension "electric current".
    :ivar temperature_exp: The exponent of the physical dimension
        "temperature".
    :ivar molar_amount_exp: The exponent of the physical dimension
        "quantity of substance".
    :ivar luminous_intensity_exp: The exponent of the physical dimension
        "luminous intensity".
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PHYSICAL-DIMENSION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PhysicalDimension.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PhysicalDimension.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length_exp: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "LENGTH-EXP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mass_exp: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "MASS-EXP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_exp: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "TIME-EXP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    current_exp: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "CURRENT-EXP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    temperature_exp: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "TEMPERATURE-EXP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    molar_amount_exp: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "MOLAR-AMOUNT-EXP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    luminous_intensity_exp: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "LUMINOUS-INTENSITY-EXP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PhysicalDimensionMappingSet:
    """
    This class represents a container for a list of mappings between
    PhysicalDimensions.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar physical_dimension_mappings: This aggregation represents a
        concrete collections of PhysicalDimensionMappings in the context
        of one PhysicalDimensionMappingSet.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PHYSICAL-DIMENSION-MAPPING-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PhysicalDimensionMappingSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PhysicalDimensionMappingSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_dimension_mappings: Optional[
        "PhysicalDimensionMappingSet.PhysicalDimensionMappings"
    ] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-DIMENSION-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PhysicalDimensionMappings:
        physical_dimension_mapping: list[PhysicalDimensionMapping] = field(
            default_factory=list,
            metadata={
                "name": "PHYSICAL-DIMENSION-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PlatformModuleEthernetEndpointConfiguration:
    """
    This meta-class defines the attributes for the configuration of a port,
    protocol type and IP address of the communication on a VLAN.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_connector_ref: Reference to the
        CommunicationConnector (VLAN) for which the network
        configuration is defined.
    :ivar ipv_4_multicast_ip_address: Multicast IPv4 Address to which
        the message will be transmitted.
    :ivar ipv_6_multicast_ip_address: Multicast IPv6 Address to which
        the message will be transmitted.
    :ivar tcp_port_ref: This reference allows to configure a tcp port
        number.
    :ivar udp_port_ref: This reference allows to configure a udp port
        number.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PLATFORM-MODULE-ETHERNET-ENDPOINT-CONFIGURATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "PlatformModuleEthernetEndpointConfiguration.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PlatformModuleEthernetEndpointConfiguration.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_ref: Optional[
        "PlatformModuleEthernetEndpointConfiguration.CommunicationConnectorRef"
    ] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_4_multicast_ip_address: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "IPV-4-MULTICAST-IP-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_6_multicast_ip_address: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "IPV-6-MULTICAST-IP-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_port_ref: Optional["PlatformModuleEthernetEndpointConfiguration.TcpPortRef"] = field(
        default=None,
        metadata={
            "name": "TCP-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    udp_port_ref: Optional["PlatformModuleEthernetEndpointConfiguration.UdpPortRef"] = field(
        default=None,
        metadata={
            "name": "UDP-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: EthernetCommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TcpPortRef(Ref):
        dest: ApApplicationEndpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class UdpPortRef(Ref):
        dest: ApApplicationEndpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PortDefinedArgumentBlueprint:
    """
    This class describes a Blueprint of a PortDefinedArgument which needs to be
    defined in the SwcInternalBehavior of the component implementing the server of
    the ClientServerInterface.

    :ivar blueprint_mapping_guide: This attribute offers the possibility
        to provide additional information with respect to the mapping.
    :ivar value_type_ref: The implementation type of this argument
        value.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ClientServerInterfaceToBswModuleEntryBlueprintMapping.portDefinedArgumentBlueprint
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-DEFINED-ARGUMENT-BLUEPRINT"

    blueprint_mapping_guide: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-MAPPING-GUIDE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_type_ref: Optional["PortDefinedArgumentBlueprint.ValueTypeRef"] = field(
        default=None,
        metadata={
            "name": "VALUE-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ValueTypeRef(Ref):
        dest: ImplementationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PortElementToCommunicationResourceMapping:
    """This meta class maps a communication resource to CP Software Clusters.

    In this case the kind of PortPrototype specified whether the
    Software Cluster has to provide or to require the resource.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar client_server_operation_iref: ClientServerOperation instance
        qualifying the communication resource
    :ivar communication_resource_ref: Communication resource for which
        the mapping applies.
    :ivar mode_declaration_group_prototype_iref:
        ModeDeclarationGroupPrototype instance qualifying the
        communication resource
    :ivar parameter_data_prototype_iref: ParameterDataPrototype instance
        qualifying the communication resource.
    :ivar trigger_iref: Trigger instance qualifying the communication
        resource.
    :ivar variable_data_prototype_iref: VariableDataPrototype instance
        qualifying the communication resource
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CpSoftwareClusterMappingSet.portElementToComResourceMapping
        Applicable for: SystemMapping.portElementToComResourceMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-ELEMENT-TO-COMMUNICATION-RESOURCE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "PortElementToCommunicationResourceMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PortElementToCommunicationResourceMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_server_operation_iref: OperationInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "CLIENT-SERVER-OPERATION-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_resource_ref: Optional[
        "PortElementToCommunicationResourceMapping.CommunicationResourceRef"
    ] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-RESOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_declaration_group_prototype_iref: (
        ModeDeclarationGroupPrototypeInSystemInstanceRef | None
    ) = field(
        default=None,
        metadata={
            "name": "MODE-DECLARATION-GROUP-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_data_prototype_iref: ParameterDataPrototypeInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PARAMETER-DATA-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_iref: TriggerInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "TRIGGER-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variable_data_prototype_iref: VariableDataPrototypeInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "VARIABLE-DATA-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationResourceRef(Ref):
        dest: CpSoftwareClusterCommunicationResourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PortInterfaceToDataTypeMapping:
    """This meta-class represents the ability to associate a PortInterface with a
    DataTypeMappingSet.

    This association is needed for the generation of header files in the
    scope of a single PortInterface. The association is intentionally
    made outside the scope of the PortInterface itself because the
    designers of a PortInterface most likely will not want to add
    details about the level of ImplementationDataType.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar data_type_mapping_set_refs: This represents the reference to
        the applicable dataTypemappingSet
    :ivar port_interface_ref: This represents the reference to the
        applicable PortInterface
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-INTERFACE-TO-DATA-TYPE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PortInterfaceToDataTypeMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PortInterfaceToDataTypeMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_type_mapping_set_refs: Optional[
        "PortInterfaceToDataTypeMapping.DataTypeMappingSetRefs"
    ] = field(
        default=None,
        metadata={
            "name": "DATA-TYPE-MAPPING-SET-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_interface_ref: Optional["PortInterfaceToDataTypeMapping.PortInterfaceRef"] = field(
        default=None,
        metadata={
            "name": "PORT-INTERFACE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataTypeMappingSetRefs:
        data_type_mapping_set_ref: list[
            "PortInterfaceToDataTypeMapping.DataTypeMappingSetRefs.DataTypeMappingSetRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DATA-TYPE-MAPPING-SET-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DataTypeMappingSetRef(Ref):
            dest: DataTypeMappingSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PortInterfaceRef(Ref):
        dest: PortInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PortPrototypeRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar port_prototype_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-PROTOTYPE-REF-CONDITIONAL"

    port_prototype_ref: Optional["PortPrototypeRefConditional.PortPrototypeRef"] = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PortPrototypeRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PossibleErrorReaction:
    """
    Describes a possible error reaction code for the transient fault handler.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar reaction_code: Fault reaction code which can be returned by
        transient fault handler.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "POSSIBLE-ERROR-REACTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PossibleErrorReaction.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PossibleErrorReaction.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reaction_code: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "REACTION-CODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PostBuildVariantCriterion:
    """
    This class specifies one particular PostBuildVariantSelector.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar compu_method_ref: The compuMethod specifies the possible
        values for the variant criterion serving as an enumerator.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "POST-BUILD-VARIANT-CRITERION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PostBuildVariantCriterion.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PostBuildVariantCriterion.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compu_method_ref: Optional["PostBuildVariantCriterion.CompuMethodRef"] = field(
        default=None,
        metadata={
            "name": "COMPU-METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CompuMethodRef(Ref):
        dest: CompuMethodSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PostBuildVariantCriterionValueSet:
    """
    This meta-class represents the ability to denote one set of
    postBuildVariantCriterionValues.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar post_build_variant_criterion_values: This is is one particular
        postbuild variant criterion/value pair being part of the
        PostBuildVariantSet.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "POST-BUILD-VARIANT-CRITERION-VALUE-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PostBuildVariantCriterionValueSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PostBuildVariantCriterionValueSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_criterion_values: Optional[
        "PostBuildVariantCriterionValueSet.PostBuildVariantCriterionValues"
    ] = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-CRITERION-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PostBuildVariantCriterionValues:
        post_build_variant_criterion_value: list[PostBuildVariantCriterionValue] = field(
            default_factory=list,
            metadata={
                "name": "POST-BUILD-VARIANT-CRITERION-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PredefinedVariant:
    """This specifies one predefined variant.

    It is characterized by the union of all system constant values and
    post-build variant criterion values aggregated within all referenced
    system constant value sets and post build variant criterion value
    sets plus the value sets of the included variants.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar included_variant_refs: The associated variants are considered
        part of this PredefinedVariant. This means the settings of the
        included variants are included in the settings of the
        referencing PredefinedVariant. Nevertheless the included
        variants might be included in several predefined variants.
    :ivar post_build_variant_criterion_value_set_refs: This is the
        postBuildVariantCriterionValueSet contributing to the
        predefinded variant.
    :ivar sw_systemconstant_value_set_refs: This ist the set of
        Systemconstant Values contributing to the predefined variant.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PREDEFINED-VARIANT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PredefinedVariant.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PredefinedVariant.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    included_variant_refs: Optional["PredefinedVariant.IncludedVariantRefs"] = field(
        default=None,
        metadata={
            "name": "INCLUDED-VARIANT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_criterion_value_set_refs: Optional[
        "PredefinedVariant.PostBuildVariantCriterionValueSetRefs"
    ] = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-CRITERION-VALUE-SET-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_systemconstant_value_set_refs: Optional["PredefinedVariant.SwSystemconstantValueSetRefs"] = (
        field(
            default=None,
            metadata={
                "name": "SW-SYSTEMCONSTANT-VALUE-SET-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IncludedVariantRefs:
        included_variant_ref: list["PredefinedVariant.IncludedVariantRefs.IncludedVariantRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "INCLUDED-VARIANT-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class IncludedVariantRef(Ref):
            dest: PredefinedVariantSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PostBuildVariantCriterionValueSetRefs:
        post_build_variant_criterion_value_set_ref: list[
            "PredefinedVariant.PostBuildVariantCriterionValueSetRefs.PostBuildVariantCriterionValueSetRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "POST-BUILD-VARIANT-CRITERION-VALUE-SET-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PostBuildVariantCriterionValueSetRef(Ref):
            dest: PostBuildVariantCriterionValueSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SwSystemconstantValueSetRefs:
        sw_systemconstant_value_set_ref: list[
            "PredefinedVariant.SwSystemconstantValueSetRefs.SwSystemconstantValueSetRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SW-SYSTEMCONSTANT-VALUE-SET-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SwSystemconstantValueSetRef(Ref):
            dest: SwSystemconstantValueSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class PrimitiveAttributeTailoring:
    """Tailoring of primitive attributes.

    Primitive attributes are attributes that have a type which is marked
    by the stereotype &lt;&lt;primitive&gt;&gt; or
    &lt;&lt;enumeration&gt;&gt;

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alternative_name: Alternative name of a specification element
        if its name doesn't fit into the shortName. E.g. because the
        name contains spaces.
    :ivar in_scope: indicates, if a specification element is relevant
        for this data exchange point. It is relevant if inScope==true.
        It is not relevant or don't care if inScope=false.
    :ivar multiplicity_restriction: Multiplicity restriction of the
        attribute
    :ivar variation_restriction: Restrictions on the usage of variant
        handling.
    :ivar default_value_handling: Specification of how to handle AUTOSAR
        defined default values.
    :ivar sub_attribute_tailorings: Tailors the attribute of a
        &lt;&lt;primitive&gt;&gt; data type.
    :ivar value_restriction: The restriction of the attribute value.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PRIMITIVE-ATTRIBUTE-TAILORING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PrimitiveAttributeTailoring.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PrimitiveAttributeTailoring.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alternative_name: String | None = field(
        default=None,
        metadata={
            "name": "ALTERNATIVE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    in_scope: Boolean | None = field(
        default=None,
        metadata={
            "name": "IN-SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiplicity_restriction: MultiplicityRestrictionWithSeverity | None = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-RESTRICTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_restriction: VariationRestrictionWithSeverity | None = field(
        default=None,
        metadata={
            "name": "VARIATION-RESTRICTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_value_handling: DefaultValueApplicationStrategyEnum | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-VALUE-HANDLING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_attribute_tailorings: Optional["PrimitiveAttributeTailoring.SubAttributeTailorings"] = (
        field(
            default=None,
            metadata={
                "name": "SUB-ATTRIBUTE-TAILORINGS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    value_restriction: ValueRestrictionWithSeverity | None = field(
        default=None,
        metadata={
            "name": "VALUE-RESTRICTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubAttributeTailorings:
        primitive_attribute_tailoring: list["PrimitiveAttributeTailoring"] = field(
            default_factory=list,
            metadata={
                "name": "PRIMITIVE-ATTRIBUTE-TAILORING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ProcessDesignToMachineDesignMapping:
    """This element is used in the design phase to predefine a mapping of a process
    to a machine.

    Such a mapping may be overruled in the deployment phase.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar machine_design_ref: This reference identifies the
        MachineDesign in the context of the
        ProcessDesignToMachineDesignMapping.
    :ivar process_design_ref: This reference identifies the
        ProcessDesign in the context of the
        ProcessDesignToMachineDesignMapping.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROCESS-DESIGN-TO-MACHINE-DESIGN-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ProcessDesignToMachineDesignMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ProcessDesignToMachineDesignMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    machine_design_ref: Optional["ProcessDesignToMachineDesignMapping.MachineDesignRef"] = field(
        default=None,
        metadata={
            "name": "MACHINE-DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_design_ref: Optional["ProcessDesignToMachineDesignMapping.ProcessDesignRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MachineDesignRef(Ref):
        dest: MachineDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessDesignRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ProcessExecutionError:
    """
    This meta-class has the ability to describe the value of a execution error
    along with a documentation of its semantics.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar execution_error: This attribute defines the numeric value
        which Execution Management and Platform Health Management
        reports to State Management if the Process terminates
        unexpectedly or violates its supervision. It shall give further
        error information for error recovery.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROCESS-EXECUTION-ERROR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ProcessExecutionError.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ProcessExecutionError.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    execution_error: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "EXECUTION-ERROR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ProcessToMachineMapping:
    """This meta-class has the ability to associate a Process with a Machine.

    This relation involves the definition of further properties, e.g.
    timeouts.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar design_ref: This reference represents the identification of
        the design-time representation for the ProcessToMachineMapping
        that owns the reference.
    :ivar machine_ref: This reference identifies the Machine in the
        context of the ProcessToMachineMapping.
    :ivar non_os_module_instantiation_ref: This supports the optional
        case that the process represents a platform module.
    :ivar persistency_central_storage_uri: This attribute identifies a
        central place for the mapped Process to store the list of
        available storages and version information.
    :ivar process_ref: This reference identifies the Process in the
        context of the ProcessToMachineMapping.
    :ivar shall_not_run_on_refs: This reference indicates a collection
        of cores onto which the mapped process shall not be executing.
    :ivar shall_run_on_refs: This reference indicates a collection of
        cores onto which the mapped process shall be executing.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROCESS-TO-MACHINE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ProcessToMachineMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ProcessToMachineMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    design_ref: Optional["ProcessToMachineMapping.DesignRef"] = field(
        default=None,
        metadata={
            "name": "DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    machine_ref: Optional["ProcessToMachineMapping.MachineRef"] = field(
        default=None,
        metadata={
            "name": "MACHINE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    non_os_module_instantiation_ref: Optional[
        "ProcessToMachineMapping.NonOsModuleInstantiationRef"
    ] = field(
        default=None,
        metadata={
            "name": "NON-OS-MODULE-INSTANTIATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    persistency_central_storage_uri: UriString | None = field(
        default=None,
        metadata={
            "name": "PERSISTENCY-CENTRAL-STORAGE-URI",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["ProcessToMachineMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    shall_not_run_on_refs: Optional["ProcessToMachineMapping.ShallNotRunOnRefs"] = field(
        default=None,
        metadata={
            "name": "SHALL-NOT-RUN-ON-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    shall_run_on_refs: Optional["ProcessToMachineMapping.ShallRunOnRefs"] = field(
        default=None,
        metadata={
            "name": "SHALL-RUN-ON-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DesignRef(Ref):
        dest: ProcessDesignToMachineDesignMappingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MachineRef(Ref):
        dest: MachineSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NonOsModuleInstantiationRef(Ref):
        dest: NonOsModuleInstantiationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ShallNotRunOnRefs:
        shall_not_run_on_ref: list["ProcessToMachineMapping.ShallNotRunOnRefs.ShallNotRunOnRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SHALL-NOT-RUN-ON-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class ShallNotRunOnRef(Ref):
            dest: ProcessorCoreSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ShallRunOnRefs:
        shall_run_on_ref: list["ProcessToMachineMapping.ShallRunOnRefs.ShallRunOnRef"] = field(
            default_factory=list,
            metadata={
                "name": "SHALL-RUN-ON-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ShallRunOnRef(Ref):
            dest: ProcessorCoreSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class ProcessorCore:
    """
    This meta-class represents the ability to model a processor core for the
    execution of an AUTOSAR adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar core_id: This attribute represents a numerical value assigned
        to the specific core. The value can be taken e.g. for use in a
        bitmask.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROCESSOR-CORE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ProcessorCore.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ProcessorCore.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    core_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CORE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ProvidedServiceInstanceRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar provided_service_instance_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROVIDED-SERVICE-INSTANCE-REF-CONDITIONAL"

    provided_service_instance_ref: Optional[
        "ProvidedServiceInstanceRefConditional.ProvidedServiceInstanceRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDED-SERVICE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ProvidedServiceInstanceRef(Ref):
        dest: ProvidedServiceInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ProvidedServiceInstanceToSwClusterDesignPPortPrototypeMapping:
    """This concrete meta-class represents the ability to assign a transport-layer-
    dependent ProvidedServiceInstance to a PPortPrototype in the context of the
    SoftwareClusterDesign.

    With this mapping it is possible to define the list of provided and
    required AdaptivePlatformServiceInstances in the scope of the
    SoftwareClusterDesign.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar provided_port_prototype_iref: This reference identifies the
        applicable PortPrototype in the scope of the SwClusterDesign.
    :ivar provided_service_instance_ref: Reference to a
        ProvidedServiceInstance mapped to a given PPortPrototype in the
        scope of the SwClusterDesign.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROVIDED-SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-P-PORT-PROTOTYPE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "ProvidedServiceInstanceToSwClusterDesignPPortPrototypeMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional[
        "ProvidedServiceInstanceToSwClusterDesignPPortPrototypeMapping.Annotations"
    ] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_port_prototype_iref: PPortPrototypeInSoftwareClusterDesignInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PROVIDED-PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_service_instance_ref: Optional[
        "ProvidedServiceInstanceToSwClusterDesignPPortPrototypeMapping.ProvidedServiceInstanceRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDED-SERVICE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedServiceInstanceRef(Ref):
        dest: ProvidedApServiceInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PskIdentityToKeySlotMapping:
    """
    This meta-class allows to map a PresharedKeyIdentity to a concrete key that
    will be used for a crypto operation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PSK-IDENTITY-TO-KEY-SLOT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PskIdentityToKeySlotMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PskIdentityToKeySlotMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RawDataStreamClientInterface:
    """This meta-class represents the necessary capabilities for raw data streaming
    on the client side, i.e. the streaming of data that do not undergo any
    serialization.

    Each RawDataStreamClientInterface supports the following capabilities without further modeling:
    * connect: set up the communication channel
    * shutdown: close the communication channel
    * write: send data down the communication channel
    * read: access incoming data on the communication channel

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RAW-DATA-STREAM-CLIENT-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RawDataStreamClientInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RawDataStreamClientInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["RawDataStreamClientInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["RawDataStreamClientInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RawDataStreamDeployment:
    """
    This meta-class represents the ability to model deployment-level information
    for a raw data stream.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar raw_data_stream_interface_ref: This reference identifies the
        corresponding RawDataStreamInterface,
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RAW-DATA-STREAM-DEPLOYMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RawDataStreamDeployment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RawDataStreamDeployment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    raw_data_stream_interface_ref: Optional["RawDataStreamDeployment.RawDataStreamInterfaceRef"] = (
        field(
            default=None,
            metadata={
                "name": "RAW-DATA-STREAM-INTERFACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RawDataStreamInterfaceRef(Ref):
        dest: AbstractRawDataStreamInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RawDataStreamEthernetTcpUdpCredentials:
    """
    This-meta-class represents the ability to create a configuration of network
    credentials for a raw data stream connection over TCP and UDP (inherited from
    base class).

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar ip_v_4_address: This attribute describes the IP V4 address of
        the remote server.
    :ivar ip_v_6_address: This attribute describes the IP V6 address of
        the remote server.
    :ivar udp_port: This attribute represents the configuration of a UDP
        port number.
    :ivar tcp_port: This attribute represents the configuration of a TCP
        port number.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RAW-DATA-STREAM-ETHERNET-TCP-UDP-CREDENTIALS"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ip_v_4_address: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "IP-V-4-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ip_v_6_address: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "IP-V-6-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    udp_port: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UDP-PORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_port: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-PORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RawDataStreamEthernetUdpCredentials:
    """
    This-meta-class represents the ability to create a configuration of network
    credentials for a raw data stream connection over UDP.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar ip_v_4_address: This attribute describes the IP V4 address of
        the remote server.
    :ivar ip_v_6_address: This attribute describes the IP V6 address of
        the remote server.
    :ivar udp_port: This attribute represents the configuration of a UDP
        port number.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RAW-DATA-STREAM-ETHERNET-UDP-CREDENTIALS"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ip_v_4_address: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "IP-V-4-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ip_v_6_address: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "IP-V-6-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    udp_port: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UDP-PORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RawDataStreamGrantDesign:
    """
    This meta-class represents the ability to define the IAM configuration for a
    RawDataStream on design level.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar process_design_ref: This reference identifies the
        corresponding ProcessDesign that gives context to the
        GrantDesing.
    :ivar raw_data_stream_ref: This reference identifies the applicable
        RawDataStreamInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RAW-DATA-STREAM-GRANT-DESIGN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RawDataStreamGrantDesign.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RawDataStreamGrantDesign.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_design_ref: Optional["RawDataStreamGrantDesign.ProcessDesignRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    raw_data_stream_ref: Optional["RawDataStreamGrantDesign.RawDataStreamRef"] = field(
        default=None,
        metadata={
            "name": "RAW-DATA-STREAM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessDesignRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RawDataStreamRef(Ref):
        dest: RawDataStreamClientInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RawDataStreamServerInterface:
    """This meta-class represents the necessary capabilities for raw data streaming
    on the server side, i.e. the streaming of data that do not undergo any
    serialization.

    Each RawDataStreamServerInterface supports the following capabilities without further modeling:
    * waitForConnection: wait until a communication channel is set up.
    * shutdown: close the communication channel
    * write: send data down the communication channel
    * read: access incoming data on the communication channel

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RAW-DATA-STREAM-SERVER-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RawDataStreamServerInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RawDataStreamServerInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["RawDataStreamServerInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["RawDataStreamServerInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RecoveryNotification:
    """
    This meta-class represents a PHM action that can trigger a recovery operation
    inside a piece of StateManagement software.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar recovery_notification_timeout: The maximum acceptable amount
        of time (in seconds), Platform Health Management waits for an
        acknowledgement by State Management after sending the
        notification.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RECOVERY-NOTIFICATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RecoveryNotification.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RecoveryNotification.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    recovery_notification_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "RECOVERY-NOTIFICATION-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RecoveryNotificationToPPortPrototypeMapping:
    """
    This meta-class represents the ability to associate a RecoveryNotification to a
    PPortPrototype while also being able to identify the respective Process in
    which the actual recovery executes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar process_ref: Reference to the process which represents the
        State Management instance that the recovery notification shall
        be applied to.
    :ivar recovery_action_iref: This reference identifies the
        PortPrototype to be addressed as part of a PHM recovery.
    :ivar recovery_notification_ref: This reference identifies the
        applicable RecoveryNotification to be mapped.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RECOVERY-NOTIFICATION-TO-P-PORT-PROTOTYPE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "RecoveryNotificationToPPortPrototypeMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RecoveryNotificationToPPortPrototypeMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["RecoveryNotificationToPPortPrototypeMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    recovery_action_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "RECOVERY-ACTION-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    recovery_notification_ref: Optional[
        "RecoveryNotificationToPPortPrototypeMapping.RecoveryNotificationRef"
    ] = field(
        default=None,
        metadata={
            "name": "RECOVERY-NOTIFICATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RecoveryNotificationRef(Ref):
        dest: RecoveryNotificationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ReferenceValueSpecification:
    """
    Specifies a reference to a data prototype to be used as an initial value for a
    pointer in the software.

    :ivar short_label: This can be used to identify particular value
        specifications for human readers, for example elements of a
        record type.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ArrayValueSpecification.element Applicable for:
        RecordValueSpecification.field Not Applicable for:
        CompositeRuleBasedValueSpecification.argument Not Applicable
        for: ConstantSpecification.valueSpec Not Applicable for:
        PortPrototypeBlueprintInitValue.value Not Applicable for:
        DiagnosticEnvDataCondition.compareValue Not Applicable for:
        DiagnosticEnvDataElementCondition.compareValue Not Applicable
        for: ParameterDataPrototype.initValue Not Applicable for:
        VariableDataPrototype.initValue Not Applicable for:
        CalibrationParameterValue.applInitValue Not Applicable for:
        CalibrationParameterValue.implInitValue Not Applicable for:
        MetaDataItem.metaDataItemType Not Applicable for:
        NvProvideComSpec.romBlockInitValue Not Applicable for:
        NvProvideComSpec.ramBlockInitValue Not Applicable for:
        NvRequireComSpec.initValue Not Applicable for:
        ParameterProvideComSpec.initValue Not Applicable for:
        ParameterRequireComSpec.initValue Not Applicable for:
        NonqueuedSenderComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.timeoutSubstitutionValue Not Applicable
        for: PortDefinedArgumentValue.value Not Applicable for:
        CryptoServiceKey.developmentValue Not Applicable for:
        ISignal.timeoutSubstitutionValue Not Applicable for:
        ISignal.initValue Not Applicable for:
        FieldSenderComSpec.initValue Not Applicable for:
        PersistencyDataRequiredComSpec.initValue Not Applicable for:
        ApplicationAssocMapElementValueSpecification.value Not
        Applicable for: ApplicationAssocMapElementValueSpecification.key
        Not Applicable for: StateManagementCompareCondition.compareValue
        Not Applicable for: PersistencyKeyValuePair.initValue Not
        Applicable for: SwDataDefPropsContent.invalidValue
    :ivar reference_value_ref: The referenced data prototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REFERENCE-VALUE-SPECIFICATION"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reference_value_ref: Optional["ReferenceValueSpecification.ReferenceValueRef"] = field(
        default=None,
        metadata={
            "name": "REFERENCE-VALUE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ReferenceValueRef(Ref):
        dest: DataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RequiredServiceInstanceToSwClusterDesignRPortPrototypeMapping:
    """This concrete meta-class represents the ability to assign a transport-layer-
    dependent RequiredServiceInstance to an RPortPrototype in the context of the
    SoftwareClusterDesign.

    With this mapping it is possible to define the list of provided and
    required AdaptivePlatformServiceInstances in the scope of the
    SoftwareClusterDesign.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar required_port_prototype_iref: This reference identifies the
        applicable PortPrototype in the scope of the SwClusterDesign.
    :ivar required_service_instance_ref: Reference to a
        RequiredServiceInstance mapped to a given RPortPrototype in the
        scope of the SwClusterDesign.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REQUIRED-SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-R-PORT-PROTOTYPE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "RequiredServiceInstanceToSwClusterDesignRPortPrototypeMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional[
        "RequiredServiceInstanceToSwClusterDesignRPortPrototypeMapping.Annotations"
    ] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_port_prototype_iref: RPortPrototypeInSoftwareClusterDesignInstanceRef | None = field(
        default=None,
        metadata={
            "name": "REQUIRED-PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_service_instance_ref: Optional[
        "RequiredServiceInstanceToSwClusterDesignRPortPrototypeMapping.RequiredServiceInstanceRef"
    ] = field(
        default=None,
        metadata={
            "name": "REQUIRED-SERVICE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredServiceInstanceRef(Ref):
        dest: RequiredApServiceInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ResourceGroup:
    """
    This meta-class represents a resource group that limits the resource usage of a
    collection of processes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar cpu_usage: CPU resource limit in percentage of the total CPU
        capacity on the machine.
    :ivar mem_usage: Memory limit in bytes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RESOURCE-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ResourceGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ResourceGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cpu_usage: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CPU-USAGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mem_usage: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MEM-USAGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RoleBasedBswModuleEntryAssignment:
    """This class specifies an assignment of a role to a particular BswModuleEntry
    (usually a configurable callback).

    With this assignment, the role of the callback is mapped to a
    specific ServiceNeeds element, so that a tool is able to create
    appropriate configuration values for the module that implements the
    AUTOSAR Service.

    :ivar assigned_entry_ref: The assigned entry. It should be an
        implementedEntry or expectedEntry of the module or cluster that
        requires the ServiceNeeds.
    :ivar role: This is the role of the assigned BswModuleEntry in the
        given context. The attribute is required (for example) because
        different kind of callbacks may be associated with the same
        ServiceNeeds (e.g. end-notification vs. error-notification). The
        value shall be the role name of a configurable function call
        (usually a callback) as standardized in the Software
        Specification of the related AUTOSAR Service.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswServiceDependency.assignedEntryRole
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ROLE-BASED-BSW-MODULE-ENTRY-ASSIGNMENT"

    assigned_entry_ref: Optional["RoleBasedBswModuleEntryAssignment.AssignedEntryRef"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-ENTRY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    role: Identifier | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AssignedEntryRef(Ref):
        dest: BswModuleEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RoleBasedDataAssignment:
    """This class specifies an assignment of a role to a particular data object in either
    * the SwcInternalBehavior of a software component (or in the BswInternalBehavior of a BSW module or BSW cluster) in the context of an AUTOSAR Service or
    * an NvBlockDescriptor to sort out the assignment of event-based writing strategies to data elements in a PortPrototype.
    With this assignment, the role of the data can be mapped to a DataPrototype that is used in the context of the definition of a specific ServiceNeeds or NvBlockDescriptor, so that a tool is able to create the correct access or writing strategy.

    :ivar role: This is the role of the assigned data in the given
        context. Possible values need to be specified on M1 level.
        Additionally the TPS Software Component Template provides a list
        of applicable roles for various service dependencies and service
        use cases in chapter 13 "Service Dependencies and Service Use
        Cases" (e.g., ramBlock in case of the needs for a permanent RAM
        block).
    :ivar used_data_element: The VariableDataPrototype used in this
        role, e.g. * Permanent RAM Block of an NVRAM Block which shall
        belong to the same SwcInternalBehavior or BswInternalBehavior. *
        In the role signalBasedDiagnostics it has to refer to a
        VariableDataPrototype in a SenderReceiverInterface or a
        NvDataInterface.
    :ivar used_parameter_element: The ParameterDataPrototype used in
        this role, e.g. * ROM Block of an NVRAM Block. It shall belong
        to the same SwcInternalBehavior or BswInternalbehavior. * In the
        role signalBasedDiagnostics it has to refer to a
        ParameterDataPrototype in a ParameterInterface.
    :ivar used_pim_ref: The (untyped) PerInstanceMemory used in this
        role (e.g. as a Permanent RAM Block for an NVRAM Block).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcServiceDependency.assignedData Applicable for:
        BswServiceDependency.assignedData Not Applicable for:
        NvBlockDescriptor.writingStrategyRole Not Applicable for:
        NvBlockDescriptor.writingStrategy
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ROLE-BASED-DATA-ASSIGNMENT"

    role: Identifier | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    used_data_element: AutosarVariableRef | None = field(
        default=None,
        metadata={
            "name": "USED-DATA-ELEMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    used_parameter_element: AutosarParameterRef | None = field(
        default=None,
        metadata={
            "name": "USED-PARAMETER-ELEMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    used_pim_ref: Optional["RoleBasedDataAssignment.UsedPimRef"] = field(
        default=None,
        metadata={
            "name": "USED-PIM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class UsedPimRef(Ref):
        dest: PerInstanceMemorySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RoleBasedDataTypeAssignment:
    """This class specifies an assignment of a role to a particular data type of a
    software component (or in the BswModuleBehavior of a module or cluster) in the
    context of an AUTOSAR Service.

    With this assignment, the role of the data type can be mapped to a
    specific ServiceNeeds element, so that a tool is able to create the
    correct access.

    :ivar role: This is the role of the associated data type in the
        given context.
    :ivar used_implementation_data_type_ref: This represents the
        associated ImplementationDataType.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ServiceDependency.assignedDataType
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ROLE-BASED-DATA-TYPE-ASSIGNMENT"

    role: Identifier | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    used_implementation_data_type_ref: Optional[
        "RoleBasedDataTypeAssignment.UsedImplementationDataTypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "USED-IMPLEMENTATION-DATA-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class UsedImplementationDataTypeRef(Ref):
        dest: ImplementationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RoleBasedMcDataAssignment:
    """This meta-class allows to define links that specify logical relationships
    between single McDataInstances.

    The details on the existence and semantics of such links are not standardized.
    Possible Use Case:
    Rapid Prototyping solutions in which additional communication buffers and switches are implemented  in the RTE that allow to switch between the usage of the original and the bypass buffers. The different buffers and the switch can be represented by McDataInstances (in order to be accessed by MC tools) which have relationships to each other.

    :ivar execution_context_refs: Determines the executionContext in
        which the McDataInstance describing a local (e.g Task-Local)
        buffer of a global buffer is valid.
    :ivar mc_data_instance_refs: The target of the assignment.
    :ivar role: Shall be used to specify the role of the assigned data
        instance in relation to the instance that owns the assignment.
        The standardized roles of the RoleBasedMcDataAssignment.role
        attribute are: * GlobalMeasurementBuffer * RpEnablerFlag *
        RpRunnableDisablerFlag * BufferOf
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RptExecutableEntity.rptRead Applicable for:
        RptExecutableEntity.rptWrite Not Applicable for:
        RptComponent.mcDataAssignment Not Applicable for:
        RptExecutableEntityEvent.mcDataAssignment Not Applicable for:
        McDataInstance.mcDataAssignment
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ROLE-BASED-MC-DATA-ASSIGNMENT"

    execution_context_refs: Optional["RoleBasedMcDataAssignment.ExecutionContextRefs"] = field(
        default=None,
        metadata={
            "name": "EXECUTION-CONTEXT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_data_instance_refs: Optional["RoleBasedMcDataAssignment.McDataInstanceRefs"] = field(
        default=None,
        metadata={
            "name": "MC-DATA-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    role: Identifier | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ExecutionContextRefs:
        execution_context_ref: list[
            "RoleBasedMcDataAssignment.ExecutionContextRefs.ExecutionContextRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-CONTEXT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ExecutionContextRef(Ref):
            dest: RptExecutionContextSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class McDataInstanceRefs:
        mc_data_instance_ref: list[
            "RoleBasedMcDataAssignment.McDataInstanceRefs.McDataInstanceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MC-DATA-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class McDataInstanceRef(Ref):
            dest: McDataInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class RoleBasedPortAssignment:
    """This class specifies an assignment of a role to a particular service port
    (RPortPrototype or PPortPrototype) of an AtomicSwComponentType.

    With this assignment, the role of the service port can be mapped to
    a specific ServiceNeeds element, so that a tool is able to create
    the correct connector.

    :ivar port_prototype_ref: Service PortPrototype used in the assigned
        role. This PortPrototype shall either belong to the same
        AtomicSwComponentType as the SwcInternalBehavior which owns the
        ServiceDependency or to the same NvBlockSwComponentType as the
        NvBlockDescriptor.
    :ivar role: This is the role of the assigned Port in the given
        context. The value shall be a shortName of the Blueprint of a
        PortInterface as standardized in the Software Specification of
        the related AUTOSAR Service.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcServiceDependency.assignedPort Applicable for:
        NvBlockDescriptor.clientServerPort
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ROLE-BASED-PORT-ASSIGNMENT"

    port_prototype_ref: Optional["RoleBasedPortAssignment.PortPrototypeRef"] = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    role: Identifier | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PortPrototypeRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RootSwClusterDesignComponentPrototype:
    """
    This meta-class represents the ability to define the service endpoints in the
    scope of a SwClusterDesign.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar application_type_tref: This SwComponentType acts as the Type
        of the RootSwClusterDesignComponentPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ROOT-SW-CLUSTER-DESIGN-COMPONENT-PROTOTYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RootSwClusterDesignComponentPrototype.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RootSwClusterDesignComponentPrototype.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_type_tref: Optional["RootSwClusterDesignComponentPrototype.ApplicationTypeTref"] = (
        field(
            default=None,
            metadata={
                "name": "APPLICATION-TYPE-TREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ApplicationTypeTref(Ref):
        dest: SwComponentTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RootSwComponentPrototype:
    """The RootSwCompositionPrototype represents the top-level-composition of
    software components within an Executable.

    The contained SwComponentPrototypes are fully specified by their
    SwComponentTypes (including PortPrototypes, PortInterfaces,
    VariableDataPrototypes, etc.).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar application_type_tref: This SwComponentType acts as the Type
        of the RootSwComponentPrototype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ROOT-SW-COMPONENT-PROTOTYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RootSwComponentPrototype.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RootSwComponentPrototype.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_type_tref: Optional["RootSwComponentPrototype.ApplicationTypeTref"] = field(
        default=None,
        metadata={
            "name": "APPLICATION-TYPE-TREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ApplicationTypeTref(Ref):
        dest: SwComponentTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RootSwCompositionPrototype:
    """The RootSwCompositionPrototype represents the top-level-composition of
    software components within a given System.

    '''begin restrict to CP AP''' According to the use case of the
    System, this may for example be a more or less complete VFB
    description, the software of a System Extract or the software of a
    flat ECU Extract with only atomic SWCs. '''begin restrict to FO'''
    This may for example be a more or less complete VFB++ description.
    '''end restrict to FO''' Therefore the RootSwComposition will only
    occasionally contain all atomic software components that are used in
    a complete VFB System. The OEM is primarily interested in the
    required functionality and the interfaces defining the integration
    of the Software Component into the System. The internal structure of
    such a component contains often substantial intellectual property of
    a supplier. Therefore a top-level software composition will often
    contain empty compositions which represent subsystems. '''begin
    restrict to CP AP''' The contained SwComponentPrototypes are fully
    specified by their SwComponentTypes (including PortPrototypes,
    PortInterfaces, VariableDataPrototypes, SwcInternalBehavior etc.),
    and their ports are interconnected using SwConnectorPrototypes.
    '''begin restrict to FO''' The contained SwComponentPrototypes are
    fully specified by their SwComponentTypes (including PortPrototypes,
    PortInterfaces, VariableDataPrototypes, etc.). '''end restrict to
    FO'''

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar calibration_parameter_value_set_refs: Used
        CalibrationParameterValueSet for instance specific
        initialization of calibration parameters.
    :ivar flat_map_ref: The FlatMap used in the scope of this
        RootSwCompositionPrototype.
    :ivar software_composition_tref: We assume that there is exactly one
        top-level composition that includes all  Component instances  of
        the system.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        System.rootSoftwareComposition
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ROOT-SW-COMPOSITION-PROTOTYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RootSwCompositionPrototype.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RootSwCompositionPrototype.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    calibration_parameter_value_set_refs: Optional[
        "RootSwCompositionPrototype.CalibrationParameterValueSetRefs"
    ] = field(
        default=None,
        metadata={
            "name": "CALIBRATION-PARAMETER-VALUE-SET-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    flat_map_ref: Optional["RootSwCompositionPrototype.FlatMapRef"] = field(
        default=None,
        metadata={
            "name": "FLAT-MAP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_composition_tref: Optional["RootSwCompositionPrototype.SoftwareCompositionTref"] = (
        field(
            default=None,
            metadata={
                "name": "SOFTWARE-COMPOSITION-TREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CalibrationParameterValueSetRefs:
        calibration_parameter_value_set_ref: list[
            "RootSwCompositionPrototype.CalibrationParameterValueSetRefs.CalibrationParameterValueSetRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CALIBRATION-PARAMETER-VALUE-SET-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CalibrationParameterValueSetRef(Ref):
            dest: CalibrationParameterValueSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class FlatMapRef(Ref):
        dest: FlatMapSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SoftwareCompositionTref(Ref):
        dest: CompositionSwComponentTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RoughEstimateHeapUsage:
    """
    Rough estimation of the heap usage.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar hardware_configuration: Contains information about the
        hardware context this heap usage is describing.
    :ivar hw_element_ref: Specifies for which hardware element (e.g.
        ECU) this heap usage  usage is given.
    :ivar software_context: Contains details about the software context
        this heap usage is provided for.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ResourceConsumption.heapUsage
    :ivar memory_consumption: Rough estimate of the heap usage. Unit:
        byte.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ROUGH-ESTIMATE-HEAP-USAGE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RoughEstimateHeapUsage.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RoughEstimateHeapUsage.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hardware_configuration: HardwareConfiguration | None = field(
        default=None,
        metadata={
            "name": "HARDWARE-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_element_ref: Optional["RoughEstimateHeapUsage.HwElementRef"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_context: SoftwareContext | None = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CONTEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_consumption: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MEMORY-CONSUMPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwElementRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RoughEstimateOfExecutionTime:
    """
    Provides a description of a rough estimate on the ExecutionTime.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar exclusive_area_ref: Reference to the ExclusiveArea this
        execution time is provided for.
    :ivar executable_entity_ref: The executable entity for which this
        execution time is described.
    :ivar hardware_configuration: Provides information on the
        HardwareConfiguration used to specify this ExecutionTime.
    :ivar hw_element_ref: The hardware element (e.g. type of ECU) for
        which the execution time is specified.
    :ivar included_library_refs: If this dependency is specified, the
        execution time of the library code is included in the execution
        time data for the runnable.
    :ivar memory_section_locations: Provides information on the
        MemorySectionLocation which is involved in the ExecutionTime
        description.
    :ivar software_context: Provides information on the detailed
        SoftwareContext used to provide the ExecutionTime description.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ResourceConsumption.executionTime
    :ivar additional_information: Provides description on the rough
        estimate of the ExecutionTime.
    :ivar estimated_execution_time: The estimated execution time.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ROUGH-ESTIMATE-OF-EXECUTION-TIME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RoughEstimateOfExecutionTime.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RoughEstimateOfExecutionTime.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_area_ref: Optional["RoughEstimateOfExecutionTime.ExclusiveAreaRef"] = field(
        default=None,
        metadata={
            "name": "EXCLUSIVE-AREA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    executable_entity_ref: Optional["RoughEstimateOfExecutionTime.ExecutableEntityRef"] = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-ENTITY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hardware_configuration: HardwareConfiguration | None = field(
        default=None,
        metadata={
            "name": "HARDWARE-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_element_ref: Optional["RoughEstimateOfExecutionTime.HwElementRef"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    included_library_refs: Optional["RoughEstimateOfExecutionTime.IncludedLibraryRefs"] = field(
        default=None,
        metadata={
            "name": "INCLUDED-LIBRARY-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_section_locations: Optional["RoughEstimateOfExecutionTime.MemorySectionLocations"] = (
        field(
            default=None,
            metadata={
                "name": "MEMORY-SECTION-LOCATIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    software_context: SoftwareContext | None = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CONTEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    additional_information: String | None = field(
        default=None,
        metadata={
            "name": "ADDITIONAL-INFORMATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    estimated_execution_time: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "ESTIMATED-EXECUTION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaRef(Ref):
        dest: ExclusiveAreaSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutableEntityRef(Ref):
        dest: ExecutableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class HwElementRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IncludedLibraryRefs:
        included_library_ref: list[
            "RoughEstimateOfExecutionTime.IncludedLibraryRefs.IncludedLibraryRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "INCLUDED-LIBRARY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class IncludedLibraryRef(Ref):
            dest: DependencyOnArtifactSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class MemorySectionLocations:
        memory_section_location: list[MemorySectionLocation] = field(
            default_factory=list,
            metadata={
                "name": "MEMORY-SECTION-LOCATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RoughEstimateStackUsage:
    """
    Rough estimation of the stack usage.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar executable_entity_ref: The executable entity for which this
        stack usage is described.
    :ivar hardware_configuration: Contains information about the
        hardware context this stack usage is describing.
    :ivar hw_element_ref: Specifies for which hardware element (e.g.
        ECU) this stack usage is given.
    :ivar software_context: Contains details about the software context
        this stack usage is provided for.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ResourceConsumption.stackUsage
    :ivar memory_consumption: Rough estimate of the stack usage. Unit:
        byte.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ROUGH-ESTIMATE-STACK-USAGE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RoughEstimateStackUsage.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RoughEstimateStackUsage.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    executable_entity_ref: Optional["RoughEstimateStackUsage.ExecutableEntityRef"] = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-ENTITY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hardware_configuration: HardwareConfiguration | None = field(
        default=None,
        metadata={
            "name": "HARDWARE-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_element_ref: Optional["RoughEstimateStackUsage.HwElementRef"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_context: SoftwareContext | None = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CONTEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_consumption: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MEMORY-CONSUMPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutableEntityRef(Ref):
        dest: ExecutableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class HwElementRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RptExecutionContext:
    """Defines an environment for the execution of ExecutableEntites which is qualified by
    * OSTask
    * communication buffer usage

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-EXECUTION-CONTEXT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RptExecutionContext.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RptExecutionContext.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RptProfile:
    """
    The RptProfile describes the common properties of a Rapid Prototyping method.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar max_service_point_id: Highest service point id useable for RTE
        generated service points.
    :ivar min_service_point_id: Lowest service point id useable for RTE
        generated service points.
    :ivar service_point_symbol_post: Complete symbol of the function
        implementing the post service point. This symbol is used for
        post-build hooking purposes.
    :ivar service_point_symbol_pre: Complete symbol of the function
        implementing the pre service point. This symbol is used for
        post-build hooking purposes.
    :ivar stim_enabler: Defines if the service points support the
        stimulation enabler. If RptProfile.stimEnabler is "none" then no
        stimulation enabler is passed to the service function. Otherwise
        the stimulation enabler will be passed as a parameter.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-PROFILE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RptProfile.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RptProfile.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_service_point_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-SERVICE-POINT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_service_point_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-SERVICE-POINT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_point_symbol_post: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "SERVICE-POINT-SYMBOL-POST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_point_symbol_pre: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "SERVICE-POINT-SYMBOL-PRE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    stim_enabler: RptEnablerImplTypeEnum | None = field(
        default=None,
        metadata={
            "name": "STIM-ENABLER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RptServicePoint:
    """
    Description of a Service Point implemented for rapid prototyping.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar service_id: Unique ID (Range: 0 ... 65535)  representing the
        service point.
    :ivar symbol: Complete symbol of the function implementing the
        service point. This symbol is used for post-build hooking
        purposes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RptSupportData.rptServicePoint
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-SERVICE-POINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RptServicePoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RptServicePoint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SERVICE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RteEventInCompositionSeparation:
    """This meta-class is used to define a separation constraint in the context of
    a SwComposition.

    The referenced RteEvents are not allowed to be mapped into the same
    OsTask.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar rte_event_irefs: Reference to RteEvents that are not allowed
        to be mapped into the same OsTask.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RTE-EVENT-IN-COMPOSITION-SEPARATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RteEventInCompositionSeparation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RteEventInCompositionSeparation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rte_event_irefs: Optional["RteEventInCompositionSeparation.RteEventIrefs"] = field(
        default=None,
        metadata={
            "name": "RTE-EVENT-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RteEventIrefs:
        rte_event_iref: list[RteEventInCompositionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "RTE-EVENT-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RteEventInCompositionToOsTaskProxyMapping:
    """This meta-class is used to map an RteEvent to an OsTaskProxy in the context
    of a SwComposition.

    Several RteEventInCompositionToOsTaskProxyMappings can be used to
    define a pairing constraint that describes which RteEvents shall be
    mapped together into an OsTask. Optionally the relative position of
    the RteEvents in the OsTask can be defined in the mapping.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar offset: This attribute is used to describe the position of the
        RteEvent in the OsTask as a relative value, i.e. the values show
        only the relative position of the RteEvent in the OsTask.
    :ivar os_task_proxy_ref: Reference to OsTaskProxy to which the
        RteEvent is mapped.
    :ivar rte_event_iref: Reference to RteEvent that is mapped to the
        OsTaskProxy.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RTE-EVENT-IN-COMPOSITION-TO-OS-TASK-PROXY-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "RteEventInCompositionToOsTaskProxyMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RteEventInCompositionToOsTaskProxyMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    os_task_proxy_ref: Optional["RteEventInCompositionToOsTaskProxyMapping.OsTaskProxyRef"] = field(
        default=None,
        metadata={
            "name": "OS-TASK-PROXY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rte_event_iref: RteEventInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "RTE-EVENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class OsTaskProxyRef(Ref):
        dest: OsTaskProxySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RteEventInSystemSeparation:
    """This meta-class is used to define a separation constraint in the context of
    the System.

    The referenced RteEvents are not allowed to be mapped into the same
    OsTask.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar rte_event_irefs: Reference to RteEvents that are not allowed
        to be mapped into the same OsTask.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RTE-EVENT-IN-SYSTEM-SEPARATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RteEventInSystemSeparation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RteEventInSystemSeparation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rte_event_irefs: Optional["RteEventInSystemSeparation.RteEventIrefs"] = field(
        default=None,
        metadata={
            "name": "RTE-EVENT-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RteEventIrefs:
        rte_event_iref: list[RteEventInSystemInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "RTE-EVENT-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RteEventInSystemToOsTaskProxyMapping:
    """This meta-class is used to map an RteEvent to an OsTaskProxy in the context
    of the System.

    Several RteEventToOsTaskProxyMappings can be used to define a
    pairing constraint that describes which RteEvents shall be mapped
    together into an OsTask. Optionally the position of the RteEvents in
    the OsTask can be defined.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar offset: This attribute is used to describe the position of the
        RteEvent in the OsTask as a relative value, i.e. the values show
        only the relative position of the RteEvent in the OsTask.
    :ivar os_task_proxy_ref: Reference to OsTaskProxy to which the
        RteEvent is mapped.
    :ivar rte_event_iref: Reference to RteEvent that is mapped to the
        OsTaskProxy.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RTE-EVENT-IN-SYSTEM-TO-OS-TASK-PROXY-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RteEventInSystemToOsTaskProxyMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RteEventInSystemToOsTaskProxyMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offset: Integer | None = field(
        default=None,
        metadata={
            "name": "OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    os_task_proxy_ref: Optional["RteEventInSystemToOsTaskProxyMapping.OsTaskProxyRef"] = field(
        default=None,
        metadata={
            "name": "OS-TASK-PROXY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rte_event_iref: RteEventInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "RTE-EVENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class OsTaskProxyRef(Ref):
        dest: OsTaskProxySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RunnableEntityInCompositionInstanceRef:
    """
    This meta-class represents the ability to define an InstanceRef to a
    RunnableEntity in the context of a CompositionSwComponentType.

    :ivar context_sw_component_prototype_ref: This represents the nested
        structure of SwComponentPrototypes.
    :ivar target_runnable_entity_ref: This represents the target
        RunnableEntity.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RunnableEntityGroup.runnableEntity
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RUNNABLE-ENTITY-IN-COMPOSITION-INSTANCE-REF"

    context_sw_component_prototype_ref: list[
        "RunnableEntityInCompositionInstanceRef.ContextSwComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_runnable_entity_ref: Optional[
        "RunnableEntityInCompositionInstanceRef.TargetRunnableEntityRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-RUNNABLE-ENTITY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextSwComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetRunnableEntityRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RuntimeError:
    """
    The reported failure is classified as runtime error.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar id: ID of detected failure used in reporting API as error or
        fault id.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ErrorTracerNeeds.tracedFailure
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RUNTIME-ERROR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RuntimeError.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RuntimeError.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SdgAggregationWithVariation:
    """Describes that the Sdg may contain another Sdg.

    The gid of the nested Sdg is defined by subSdg. Represents 'sdg'.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar lower_multiplicity: Specifies the minimal number of times an
        object shall occur. If this primitive attribute is not set, then
        the object is optional.
    :ivar upper_multiplicity: Specifies the maximum number of times an
        object may occur.  If this primitive attribute is not set, then
        there is no limit with respect to the maximum occurrence.
    :ivar upper_multiplicity_infinite: This explicitly specifies, that
        the upper multiplicity is NOT restricted. Note: The use of
        'upperMultiplicityInfinite' and 'upperMultiplicity' is mutual
        exclusive.
    :ivar gid: Specifies the name that identifies the element.
    :ivar variation: Defines if the AUTOSAR model may define a
        VariationPoint at this location.
    :ivar valid_binding_times: List of valid binding times.
    :ivar sub_sdg_ref: Supported sub Sdg Class
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SDG-AGGREGATION-WITH-VARIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SdgAggregationWithVariation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SdgAggregationWithVariation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: Boolean | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    gid: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "GID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation: Boolean | None = field(
        default=None,
        metadata={
            "name": "VARIATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    valid_binding_times: Optional["SdgAggregationWithVariation.ValidBindingTimes"] = field(
        default=None,
        metadata={
            "name": "VALID-BINDING-TIMES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_sdg_ref: Optional["SdgAggregationWithVariation.SubSdgRef"] = field(
        default=None,
        metadata={
            "name": "SUB-SDG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValidBindingTimes:
        valid_binding_time: list[FullBindingTimeEnum] = field(
            default_factory=list,
            metadata={
                "name": "VALID-BINDING-TIME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubSdgRef(Ref):
        dest: SdgClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SdgForeignReference:
    """A reference without variation support that can point to any referrable
    object in an AUTOSAR Model.

    This class accepts the special data "Sdx" reference.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar lower_multiplicity: Specifies the minimal number of times an
        object shall occur. If this primitive attribute is not set, then
        the object is optional.
    :ivar upper_multiplicity: Specifies the maximum number of times an
        object may occur.  If this primitive attribute is not set, then
        there is no limit with respect to the maximum occurrence.
    :ivar upper_multiplicity_infinite: This explicitly specifies, that
        the upper multiplicity is NOT restricted. Note: The use of
        'upperMultiplicityInfinite' and 'upperMultiplicity' is mutual
        exclusive.
    :ivar gid: Specifies the name that identifies the element.
    :ivar dest_meta_class: specifies the destination meta-class of the
        reference.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SDG-FOREIGN-REFERENCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SdgForeignReference.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SdgForeignReference.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: Boolean | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    gid: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "GID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dest_meta_class: MetaClassName | None = field(
        default=None,
        metadata={
            "name": "DEST-META-CLASS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SdgForeignReferenceWithVariation:
    """A reference with variation support that can point to any referrable object
    in an AUTOSAR Model.

    This class accepts the special data "Sdxf" reference.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar lower_multiplicity: Specifies the minimal number of times an
        object shall occur. If this primitive attribute is not set, then
        the object is optional.
    :ivar upper_multiplicity: Specifies the maximum number of times an
        object may occur.  If this primitive attribute is not set, then
        there is no limit with respect to the maximum occurrence.
    :ivar upper_multiplicity_infinite: This explicitly specifies, that
        the upper multiplicity is NOT restricted. Note: The use of
        'upperMultiplicityInfinite' and 'upperMultiplicity' is mutual
        exclusive.
    :ivar gid: Specifies the name that identifies the element.
    :ivar dest_meta_class: specifies the destination meta-class of the
        reference.
    :ivar variation: Defines if the AUTOSAR model may define a
        VariationPoint at this location.
    :ivar valid_binding_times: List of valid binding times.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SDG-FOREIGN-REFERENCE-WITH-VARIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SdgForeignReferenceWithVariation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SdgForeignReferenceWithVariation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: Boolean | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    gid: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "GID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dest_meta_class: MetaClassName | None = field(
        default=None,
        metadata={
            "name": "DEST-META-CLASS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation: Boolean | None = field(
        default=None,
        metadata={
            "name": "VARIATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    valid_binding_times: Optional["SdgForeignReferenceWithVariation.ValidBindingTimes"] = field(
        default=None,
        metadata={
            "name": "VALID-BINDING-TIMES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValidBindingTimes:
        valid_binding_time: list[FullBindingTimeEnum] = field(
            default_factory=list,
            metadata={
                "name": "VALID-BINDING-TIME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SdgPrimitiveAttribute:
    """Describes primitive special data attributes without variation.

    This class accepts a special data "sd" attribute.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar lower_multiplicity: Specifies the minimal number of times an
        object shall occur. If this primitive attribute is not set, then
        the object is optional.
    :ivar upper_multiplicity: Specifies the maximum number of times an
        object may occur.  If this primitive attribute is not set, then
        there is no limit with respect to the maximum occurrence.
    :ivar upper_multiplicity_infinite: This explicitly specifies, that
        the upper multiplicity is NOT restricted. Note: The use of
        'upperMultiplicityInfinite' and 'upperMultiplicity' is mutual
        exclusive.
    :ivar gid: Specifies the name that identifies the element.
    :ivar max: Specifies the upper bounds for numeric values.
    :ivar max_length: Specifies the maximum number of characters of
        textual values.
    :ivar min: Specifies the lower bounds for numeric values.
    :ivar min_length: Specifies the minimal number of characters of
        textual values.
    :ivar pattern: Defines the exact sequence of characters that are
        acceptable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SDG-PRIMITIVE-ATTRIBUTE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SdgPrimitiveAttribute.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SdgPrimitiveAttribute.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: Boolean | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    gid: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "GID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max: LimitValue | None = field(
        default=None,
        metadata={
            "name": "MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min: LimitValue | None = field(
        default=None,
        metadata={
            "name": "MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pattern: RegularExpression | None = field(
        default=None,
        metadata={
            "name": "PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SdgPrimitiveAttributeWithVariation:
    """Describes a primitive numerical special data attribute with variation.

    This class accepts a special data "sdf" element.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar lower_multiplicity: Specifies the minimal number of times an
        object shall occur. If this primitive attribute is not set, then
        the object is optional.
    :ivar upper_multiplicity: Specifies the maximum number of times an
        object may occur.  If this primitive attribute is not set, then
        there is no limit with respect to the maximum occurrence.
    :ivar upper_multiplicity_infinite: This explicitly specifies, that
        the upper multiplicity is NOT restricted. Note: The use of
        'upperMultiplicityInfinite' and 'upperMultiplicity' is mutual
        exclusive.
    :ivar gid: Specifies the name that identifies the element.
    :ivar max: Specifies the upper bounds for numeric values.
    :ivar max_length: Specifies the maximum number of characters of
        textual values.
    :ivar min: Specifies the lower bounds for numeric values.
    :ivar min_length: Specifies the minimal number of characters of
        textual values.
    :ivar pattern: Defines the exact sequence of characters that are
        acceptable.
    :ivar variation: Defines if the AUTOSAR model may define a
        VariationPoint at this location.
    :ivar valid_binding_times: List of valid binding times.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SDG-PRIMITIVE-ATTRIBUTE-WITH-VARIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SdgPrimitiveAttributeWithVariation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SdgPrimitiveAttributeWithVariation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: Boolean | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    gid: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "GID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max: LimitValue | None = field(
        default=None,
        metadata={
            "name": "MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min: LimitValue | None = field(
        default=None,
        metadata={
            "name": "MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIN-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pattern: RegularExpression | None = field(
        default=None,
        metadata={
            "name": "PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation: Boolean | None = field(
        default=None,
        metadata={
            "name": "VARIATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    valid_binding_times: Optional["SdgPrimitiveAttributeWithVariation.ValidBindingTimes"] = field(
        default=None,
        metadata={
            "name": "VALID-BINDING-TIMES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValidBindingTimes:
        valid_binding_time: list[FullBindingTimeEnum] = field(
            default_factory=list,
            metadata={
                "name": "VALID-BINDING-TIME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SdgReference:
    """
    Describes an attribute of a SdgClass which is used on the definition side to
    model a reference from one Sdg to another Sdg on the value side.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar lower_multiplicity: Specifies the minimal number of times an
        object shall occur. If this primitive attribute is not set, then
        the object is optional.
    :ivar upper_multiplicity: Specifies the maximum number of times an
        object may occur.  If this primitive attribute is not set, then
        there is no limit with respect to the maximum occurrence.
    :ivar upper_multiplicity_infinite: This explicitly specifies, that
        the upper multiplicity is NOT restricted. Note: The use of
        'upperMultiplicityInfinite' and 'upperMultiplicity' is mutual
        exclusive.
    :ivar dest_sdg_ref: Refers to a SdgClass which is used on the
        definition side to model the destination type of the referenced
        Sdg. On the value side the reference is realized by means of the
        originating Sdg defining an sdgx attribute which refers to the
        sdgCaption of the referenced Sdg.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SDG-REFERENCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SdgReference.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SdgReference.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: Boolean | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dest_sdg_ref: Optional["SdgReference.DestSdgRef"] = field(
        default=None,
        metadata={
            "name": "DEST-SDG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DestSdgRef(Ref):
        dest: SdgClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SdgTailoring:
    """
    Describes if the referenced Sdg may be attached to the current class.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alternative_name: Alternative name of a specification element
        if its name doesn't fit into the shortName. E.g. because the
        name contains spaces.
    :ivar in_scope: indicates, if a specification element is relevant
        for this data exchange point. It is relevant if inScope==true.
        It is not relevant or don't care if inScope=false.
    :ivar severity: Severity level that is reported in case the
        restriction is violated.
    :ivar sdg_class_ref: Specification of the structure of the Special
        Data Group.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SDG-TAILORING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SdgTailoring.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SdgTailoring.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alternative_name: String | None = field(
        default=None,
        metadata={
            "name": "ALTERNATIVE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    in_scope: Boolean | None = field(
        default=None,
        metadata={
            "name": "IN-SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    severity: SeverityEnum | None = field(
        default=None,
        metadata={
            "name": "SEVERITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdg_class_ref: Optional["SdgTailoring.SdgClassRef"] = field(
        default=None,
        metadata={
            "name": "SDG-CLASS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SdgClassRef(Ref):
        dest: SdgClassSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SecOcCryptoServiceMapping:
    """
    This meta-class has the ability to represent a crypto service mapping for the
    Pdu-based communication via SecOC.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.cryptoServiceMapping
    :ivar authentication_ref: This reference identifies the applicable
        crypto primitive for the authentication.
    :ivar crypto_service_key_ref: This reference identifies the
        applicable crypto key.
    :ivar crypto_service_queue_ref: This reference identifies the
        CryptoServiceQueue the processing of this
        SecOcCryptoServiceMapping shall be performed in.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SEC-OC-CRYPTO-SERVICE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecOcCryptoServiceMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecOcCryptoServiceMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_ref: Optional["SecOcCryptoServiceMapping.AuthenticationRef"] = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_service_key_ref: Optional["SecOcCryptoServiceMapping.CryptoServiceKeyRef"] = field(
        default=None,
        metadata={
            "name": "CRYPTO-SERVICE-KEY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_service_queue_ref: Optional["SecOcCryptoServiceMapping.CryptoServiceQueueRef"] = field(
        default=None,
        metadata={
            "name": "CRYPTO-SERVICE-QUEUE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AuthenticationRef(Ref):
        dest: CryptoServicePrimitiveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoServiceKeyRef(Ref):
        dest: CryptoServiceKeySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoServiceQueueRef(Ref):
        dest: CryptoServiceQueueSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SecOcJobMapping:
    """This meta-class allows to map a SecOcJobRequirement to a concrete crypto job
    that will fulfill the JobRequirement.

    The crypto job represents a call to a specific routine that
    implements a crypto function and that uses a specific key and refers
    to a specific primitive as a formal representation of the crypto
    algorithm.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sec_oc_job_requirement_ref: Reference to a SecOC
        JobRequirement that defines requirements for the cryptographic
        job that need to be executed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SEC-OC-JOB-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecOcJobMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecOcJobMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sec_oc_job_requirement_ref: Optional["SecOcJobMapping.SecOcJobRequirementRef"] = field(
        default=None,
        metadata={
            "name": "SEC-OC-JOB-REQUIREMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecOcJobRequirementRef(Ref):
        dest: SecOcJobRequirementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SecOcJobRequirement:
    """
    Requirements for the cryptographic job that need to be executed.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sec_oc_job_semantic: This attribute defines the cryptographic
        algorithm that needs to be supported.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SEC-OC-JOB-REQUIREMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecOcJobRequirement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecOcJobRequirement.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sec_oc_job_semantic: SecOcJobSemanticEnum | None = field(
        default=None,
        metadata={
            "name": "SEC-OC-JOB-SEMANTIC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SectionNamePrefix:
    """
    A prefix to be used for generated code artifacts defining a memory section name
    in the source code of the using module or SWC.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar symbol: The symbol to be used as (depending on the concrete
        case) either a complete replacement or a prefix.
    :ivar implemented_in_ref: Optional reference that allows to Indicate
        the code artifact (header file) containing the preprocessor
        implementation of memory sections with this prefix. The usage of
        this link supersedes the usage of a memory mapping header with
        the default name (derived from the BswModuleDescription's
        shortName).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ResourceConsumption.sectionNamePrefix
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECTION-NAME-PREFIX"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SectionNamePrefix.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implemented_in_ref: Optional["SectionNamePrefix.ImplementedInRef"] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTED-IN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementedInRef(Ref):
        dest: DependencyOnArtifactSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SecureCommunicationAuthenticationProps:
    """
    Authentication properties used to configure SecuredIPdus.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar auth_algorithm: This attribute defines the authentication
        algorithm used for MAC generation and verification.
    :ivar auth_info_tx_length: This attribute defines the length in bits
        of the authentication code to be included in the payload of the
        authenticated Pdu.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURE-COMMUNICATION-AUTHENTICATION-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecureCommunicationAuthenticationProps.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecureCommunicationAuthenticationProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    auth_algorithm: String | None = field(
        default=None,
        metadata={
            "name": "AUTH-ALGORITHM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    auth_info_tx_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "AUTH-INFO-TX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SecureCommunicationFreshnessProps:
    """
    Freshness properties used to configure SecuredIPdus.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar freshness_counter_sync_attempts: This attribute defines the
        number of Freshness Counter re-synchronization attempts when a
        verification failed for a Secured I-PDU. If the value is zero,
        there will be no additional verification attempt to synchronize
        with a potentially better fitting Freshness Counter value. This
        attribute is only applicable if useFreshnessTimestamp is FALSE.
    :ivar freshness_timestamp_time_period_factor: This attribute defines
        a factor that specifies the time period for the Freshness
        Timestamp. It holds a multiplication factor that specifies the
        concrete meaning of a Freshness Timestamp increment by one on
        basis of microseconds.
    :ivar freshness_value_length: This attribute defines the complete
        length in bits of the Freshness Value. As long as the key
        doesn't change the counter shall not overflow. The length of the
        counter shall be determined based on the expected life time of
        the corresponding key and frequency of usage of the counter.
    :ivar freshness_value_tx_length: This attribute defines the length
        in bits of the Freshness Value to be included in the payload of
        the Secured I-PDU. This length is specific to the least
        significant bits of the complete Freshness Counter. If the
        attribute is 0 no Freshness Value is included in the Secured
        I-PDU.
    :ivar use_freshness_timestamp: This attribute specifies whether the
        Freshness Value is generated through individual Freshness
        Counters or by a Timestamps. The value is set to TRUE when
        Timestamps are used.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURE-COMMUNICATION-FRESHNESS-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecureCommunicationFreshnessProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecureCommunicationFreshnessProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freshness_counter_sync_attempts: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FRESHNESS-COUNTER-SYNC-ATTEMPTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freshness_timestamp_time_period_factor: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FRESHNESS-TIMESTAMP-TIME-PERIOD-FACTOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freshness_value_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FRESHNESS-VALUE-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freshness_value_tx_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FRESHNESS-VALUE-TX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    use_freshness_timestamp: Boolean | None = field(
        default=None,
        metadata={
            "name": "USE-FRESHNESS-TIMESTAMP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SecureOnBoardCommunicationNeeds:
    """Specifies the need for the existence of the SecOc module on the respective
    ECU.

    This class currently contains no attributes. An instance of this
    class is used to find out which ports of a software-component deal
    with the administration of secure communication in order to group
    the request and response ports.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar verification_status_indication_mode: This attribute provides
        the ability to control the mode in which the application
        software is notified about the result of authentication
        attempts.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURE-ON-BOARD-COMMUNICATION-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecureOnBoardCommunicationNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecureOnBoardCommunicationNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verification_status_indication_mode: VerificationStatusIndicationModeEnum | None = field(
        default=None,
        metadata={
            "name": "VERIFICATION-STATUS-INDICATION-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SecuredIPdu:
    """If useAsCryptographicPdu is not set or set to false this IPdu contains the
    payload of an Authentic IPdu supplemented by additional Authentication
    Information (Freshness Counter and an Authenticator).

    If useAsCryptographicPdu is set to true this IPdu contains the
    Authenticator for a payload that is transported in a separate
    message. The separate Authentic IPdu is described by the Pdu that is
    referenced with the payload reference from this SecuredIPdu.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar has_dynamic_length: This attribute defines whether the Pdu has
        dynamic length (true) or not (false). Please note that the usage
        of this attribute is restricted by [constr_3448].
    :ivar length: Pdu length in bytes. In case of dynamic length IPdus
        (containing a dynamical length signal), this value indicates the
        maximum data length. It should be noted that in former AUTOSAR
        releases (Rel 2.1, Rel 3.0, Rel 3.1, Rel 4.0 Rev. 1) this
        parameter was defined in bits. The Pdu length of zero bytes is
        allowed.
    :ivar meta_data_length: Number of additional bytes of MetaData in
        the PDU data field. The MetaData contains auxiliary information
        for the PDU, e.g. the CAN ID.
    :ivar contained_i_pdu_props: Defines whether this IPdu may be
        collected inside a ContainerIPdu.
    :ivar authentication_props_ref: Reference to authentication
        properties that are valid for this SecuredIPdu.
    :ivar dynamic_runtime_length_handling: Defines whether the length
        information for handling this SecuredIPdu with
        SecuredIPdu.useSecuredPduHeader=noHeader is taken from the
        configuration or from the actually provided length information
        during runtime. true: SecuredIPdu length information is taken
        from the actually provided length information during runtime.
        false: SecuredIPdu length information is taken from the
        configuration.
    :ivar freshness_props_ref: Reference to freshness properties that
        are valid for this SecuredIPdu.
    :ivar payload_ref: Reference to a Pdu that will be protected against
        unauthorized manipulation and replay attacks.
    :ivar secure_communication_props: Specific configuration properties
        for this SecuredIPdu.
    :ivar use_as_cryptographic_i_pdu: If this attribute is set to true
        the SecuredIPdu contains the Authentication Information for an
        AuthenticIPdu that is transmitted in a separate message. The
        AuthenticIPdu contains the original payload, i.e. the secured
        data. If this attribute is set to false this SecuredIPdu
        contains the payload of an Authentic IPdu supplemented by
        additional Authentication Information.
    :ivar use_secured_pdu_header: This attribute defines the size of the
        header which is inserted into the SecuredIPdu. If this attribute
        is set to anything but noHeader, the SecuredIPdu contains the
        Secured I-PDU Header to indicate the length of the
        AuthenticIPdu. The AuthenticIPdu contains the original payload,
        i.e. the secured data.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURED-I-PDU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecuredIPdu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecuredIPdu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_dynamic_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-DYNAMIC-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "META-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_i_pdu_props: ContainedIPduProps | None = field(
        default=None,
        metadata={
            "name": "CONTAINED-I-PDU-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_props_ref: Optional["SecuredIPdu.AuthenticationPropsRef"] = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_runtime_length_handling: Boolean | None = field(
        default=None,
        metadata={
            "name": "DYNAMIC-RUNTIME-LENGTH-HANDLING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freshness_props_ref: Optional["SecuredIPdu.FreshnessPropsRef"] = field(
        default=None,
        metadata={
            "name": "FRESHNESS-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    payload_ref: Optional["SecuredIPdu.PayloadRef"] = field(
        default=None,
        metadata={
            "name": "PAYLOAD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_communication_props: SecureCommunicationProps | None = field(
        default=None,
        metadata={
            "name": "SECURE-COMMUNICATION-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    use_as_cryptographic_i_pdu: Boolean | None = field(
        default=None,
        metadata={
            "name": "USE-AS-CRYPTOGRAPHIC-I-PDU",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    use_secured_pdu_header: SecuredPduHeaderEnum | None = field(
        default=None,
        metadata={
            "name": "USE-SECURED-PDU-HEADER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AuthenticationPropsRef(Ref):
        dest: SecureCommunicationAuthenticationPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FreshnessPropsRef(Ref):
        dest: SecureCommunicationFreshnessPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PayloadRef(Ref):
        dest: PduTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventAggregationFilter:
    """
    This meta-class represents the aggregation filter that aggregates all security
    events occurring within a configured time frame into one (i.e. the last
    reported) security event.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar context_data_source: This attributes defines whether the
        context data of the first or last time-aggregated security event
        shall be used for the resulting qualified security event.
    :ivar minimum_interval_length: This attribute represents the
        configuration of the minimum time window in seconds for the
        aggregation filter.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-AGGREGATION-FILTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecurityEventAggregationFilter.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecurityEventAggregationFilter.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_data_source: SecurityEventContextDataSourceEnum | None = field(
        default=None,
        metadata={
            "name": "CONTEXT-DATA-SOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_interval_length: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-INTERVAL-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventContextData:
    """This meta-class represents the possibility that context data can be attached
    to the aggregating SecurityEventDefinition.

    If this meta-class does not exist for a SecurityEventDefinition,
    then no context data shall be provided for this
    SecurityEventDefinition.

    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SecurityEventContextProps.contextData
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-CONTEXT-DATA"

    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SecurityEventDefinition:
    """
    This meta-class defines a security-related event as part of the intrusion
    detection system.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar event_symbol_name: This aggregation defines optionally an
        alternative EventName for the SecurityEventDefinition in case
        there is a collision of shortNames.
    :ivar id: This attribute represents the numerical identification of
        the defined security event. The identification shall be unique
        within the scope of the IDS.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-DEFINITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecurityEventDefinition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecurityEventDefinition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_symbol_name: SymbolProps | None = field(
        default=None,
        metadata={
            "name": "EVENT-SYMBOL-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventDefinitionRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar security_event_definition_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-DEFINITION-REF-CONDITIONAL"

    security_event_definition_ref: Optional[
        "SecurityEventDefinitionRefConditional.SecurityEventDefinitionRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECURITY-EVENT-DEFINITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SecurityEventDefinitionRef(Ref):
        dest: SecurityEventDefinitionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventFilterChainRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar security_event_filter_chain_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-FILTER-CHAIN-REF-CONDITIONAL"

    security_event_filter_chain_ref: Optional[
        "SecurityEventFilterChainRefConditional.SecurityEventFilterChainRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECURITY-EVENT-FILTER-CHAIN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SecurityEventFilterChainRef(Ref):
        dest: SecurityEventFilterChainSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventMapping:
    """
    This meta-class represents a reportable instance of a security event.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar id: This attribute defines the numerical identification of the
        security event subject to deployment.
    :ivar process_ref: This reference identifies the process in which
        context the seurity event is reported.
    :ivar reporting_port_prototype_iref: This instanceRef identifies the
        portPrototype over which the security event is reported.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecurityEventMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecurityEventMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["SecurityEventMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reporting_port_prototype_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "REPORTING-PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventOneEveryNFilter:
    """
    This meta-class represents the configuration of a sampling (i.e. every n-th
    event is sampled) filter for security events.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar n: This attribute represents the configuration of the sampling
        filter, i.e. it configures the parameter "n" that controls how
        many events (n-1) shall be dropped after a sampled event until a
        new sample is created.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-ONE-EVERY-N-FILTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecurityEventOneEveryNFilter.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecurityEventOneEveryNFilter.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    n: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "N",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventReportInterface:
    """
    This meta-class provides the ability to define a PortInterface for the
    reporting of security events in the context of the intrusion detection system.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-REPORT-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecurityEventReportInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecurityEventReportInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["SecurityEventReportInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["SecurityEventReportInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventReportToSecurityEventDefinitionMapping:
    """
    This meta-class represents the ability to map a PortPrototype for reporting a
    security event to the actual security event that shall be reported by this
    PortPrototype.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar reported_security_event_iref: This identifies the mapped
        security event.
    :ivar security_event_definition_ref: This reference identifies the
        definition of the security event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-REPORT-TO-SECURITY-EVENT-DEFINITION-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "SecurityEventReportToSecurityEventDefinitionMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecurityEventReportToSecurityEventDefinitionMapping.Annotations"] = (
        field(
            default=None,
            metadata={
                "name": "ANNOTATIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reported_security_event_iref: RPortInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "REPORTED-SECURITY-EVENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_event_definition_ref: Optional[
        "SecurityEventReportToSecurityEventDefinitionMapping.SecurityEventDefinitionRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECURITY-EVENT-DEFINITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecurityEventDefinitionRef(Ref):
        dest: SecurityEventDefinitionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventStateFilter:
    """This meta-class represents the configuration of a state filter for security
    events.

    The referenced states represent a block list, i.e. the security
    events are dropped if the referenced state is the active state in
    the relevant state machine (which depends on whether the IdsM
    instance runs on the Classic or the Adaptive Platform).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar block_if_state_active_ap_irefs: For the AP, this reference
        defines the machine states of the block list. That means, if a
        security event (mapped to the filter chain to which the
        SecurityEventStateFilter belongs to) is reported when the
        machine is in one of the block listed states, the IdsM shall
        discard the reported security event.
    :ivar block_if_state_active_cp_refs: For the CP, this reference
        defines the states of the block list. That means, if a security
        event (mapped to the filter chain to which the
        SecurityEventStateFilter belongs to) is reported when the
        currently active block state in the IdsM is one of the
        referenced block listed states, the IdsM shall discard the
        reported security event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-STATE-FILTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecurityEventStateFilter.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecurityEventStateFilter.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    block_if_state_active_ap_irefs: Optional[
        "SecurityEventStateFilter.BlockIfStateActiveApIrefs"
    ] = field(
        default=None,
        metadata={
            "name": "BLOCK-IF-STATE-ACTIVE-AP-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    block_if_state_active_cp_refs: Optional["SecurityEventStateFilter.BlockIfStateActiveCpRefs"] = (
        field(
            default=None,
            metadata={
                "name": "BLOCK-IF-STATE-ACTIVE-CP-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlockIfStateActiveApIrefs:
        block_if_state_active_ap_iref: list[FunctionGroupStateInFunctionGroupSetInstanceRef] = (
            field(
                default_factory=list,
                metadata={
                    "name": "BLOCK-IF-STATE-ACTIVE-AP-IREF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

    @dataclass(slots=True, kw_only=True)
    class BlockIfStateActiveCpRefs:
        block_if_state_active_cp_ref: list[
            "SecurityEventStateFilter.BlockIfStateActiveCpRefs.BlockIfStateActiveCpRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "BLOCK-IF-STATE-ACTIVE-CP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class BlockIfStateActiveCpRef(Ref):
            dest: BlockStateSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SecurityEventThresholdFilter:
    """This meta-class represents the threshold filter that drops (repeatedly at
    each beginning of a configurable time interval) a configurable number of
    security events .

    All subsequently arriving security events (within the configured
    time interval) pass the filter.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar interval_length: This attribute configures the time interval
        in seconds for one threshold filter operation.
    :ivar threshold_number: This attribute configures the threshold
        number, i.e. how many security events in the configured time
        frame are dropped before subsequent events start to pass the
        filter.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-THRESHOLD-FILTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecurityEventThresholdFilter.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecurityEventThresholdFilter.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    interval_length: TimeValue | None = field(
        default=None,
        metadata={
            "name": "INTERVAL-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    threshold_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "THRESHOLD-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SenderReceiverCompositeElementToSignalMapping:
    """
    Mapping of an Variable Data Prototype which is aggregated within a composite
    datatype to a SystemSignal (only one element of the composite data type is
    mapped).

    :ivar communication_direction: This attribute controls the direction
        into which the mapped SystemSignal is communicated with respect
        to the kind of PortPrototype used as the context element of the
        DataMapping.
    :ivar event_group_refs: Via this reference a connection between the
        VFB View and the Ethernet EventGroups can be created.
    :ivar event_handler_refs: Via this reference a connection between
        the VFB View and the Ethernet EventHandlers can be created.
    :ivar introduction: This represents introductory documentation about
        the data mapping.
    :ivar service_instance_refs: Via this reference a connection between
        the VFB View and the Ethernet Services can be created.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.dataMapping
    :ivar data_element_iref: Reference to a data element with a
        composite datatype from which one element is mapped to a
        SystemSignal.
    :ivar system_signal_ref: Reference to the SystemSignal to which one
        primitive of the composite type is mapped.
    :ivar type_mapping: The CompositeTypeMapping maps one
        VariableDataPrototype of the composite data type to a
        SystemSignal.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SENDER-RECEIVER-COMPOSITE-ELEMENT-TO-SIGNAL-MAPPING"

    communication_direction: CommunicationDirectionType | None = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_refs: Optional["SenderReceiverCompositeElementToSignalMapping.EventGroupRefs"] = (
        field(
            default=None,
            metadata={
                "name": "EVENT-GROUP-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    event_handler_refs: Optional[
        "SenderReceiverCompositeElementToSignalMapping.EventHandlerRefs"
    ] = field(
        default=None,
        metadata={
            "name": "EVENT-HANDLER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_refs: Optional[
        "SenderReceiverCompositeElementToSignalMapping.ServiceInstanceRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_iref: VariableDataPrototypeInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_signal_ref: Optional["SenderReceiverCompositeElementToSignalMapping.SystemSignalRef"] = (
        field(
            default=None,
            metadata={
                "name": "SYSTEM-SIGNAL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    type_mapping: Optional["SenderReceiverCompositeElementToSignalMapping.TypeMapping"] = field(
        default=None,
        metadata={
            "name": "TYPE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EventGroupRefs:
        event_group_ref: list[
            "SenderReceiverCompositeElementToSignalMapping.EventGroupRefs.EventGroupRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EventGroupRef(Ref):
            dest: ConsumedEventGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class EventHandlerRefs:
        event_handler_ref: list[
            "SenderReceiverCompositeElementToSignalMapping.EventHandlerRefs.EventHandlerRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-HANDLER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EventHandlerRef(Ref):
            dest: EventHandlerSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRefs:
        service_instance_ref: list[
            "SenderReceiverCompositeElementToSignalMapping.ServiceInstanceRefs.ServiceInstanceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceInstanceRef(Ref):
            dest: AbstractServiceInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TypeMapping:
        sender_rec_array_type_mapping: SenderRecArrayTypeMapping | None = field(
            default=None,
            metadata={
                "name": "SENDER-REC-ARRAY-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sender_rec_record_type_mapping: SenderRecRecordTypeMapping | None = field(
            default=None,
            metadata={
                "name": "SENDER-REC-RECORD-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SenderReceiverToSignalGroupMapping:
    """
    Mapping of a sender receiver communication data element with a composite
    datatype to a signal group.

    :ivar communication_direction: This attribute controls the direction
        into which the mapped SystemSignal is communicated with respect
        to the kind of PortPrototype used as the context element of the
        DataMapping.
    :ivar event_group_refs: Via this reference a connection between the
        VFB View and the Ethernet EventGroups can be created.
    :ivar event_handler_refs: Via this reference a connection between
        the VFB View and the Ethernet EventHandlers can be created.
    :ivar introduction: This represents introductory documentation about
        the data mapping.
    :ivar service_instance_refs: Via this reference a connection between
        the VFB View and the Ethernet Services can be created.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.dataMapping
    :ivar data_element_iref: Reference to a data element with a
        composite datatype which is mapped to a signal group.
    :ivar signal_group_ref: Reference to the signal group, which contain
        all primitive datatypes of the composite type
    :ivar type_mapping: The CompositeTypeMapping maps the
        ApplicationArrayElements and ApplicationRecordElements to
        Signals of the SignalGroup.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SENDER-RECEIVER-TO-SIGNAL-GROUP-MAPPING"

    communication_direction: CommunicationDirectionType | None = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_refs: Optional["SenderReceiverToSignalGroupMapping.EventGroupRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_handler_refs: Optional["SenderReceiverToSignalGroupMapping.EventHandlerRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-HANDLER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_refs: Optional["SenderReceiverToSignalGroupMapping.ServiceInstanceRefs"] = (
        field(
            default=None,
            metadata={
                "name": "SERVICE-INSTANCE-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_iref: VariableDataPrototypeInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signal_group_ref: Optional["SenderReceiverToSignalGroupMapping.SignalGroupRef"] = field(
        default=None,
        metadata={
            "name": "SIGNAL-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_mapping: Optional["SenderReceiverToSignalGroupMapping.TypeMapping"] = field(
        default=None,
        metadata={
            "name": "TYPE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EventGroupRefs:
        event_group_ref: list["SenderReceiverToSignalGroupMapping.EventGroupRefs.EventGroupRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "EVENT-GROUP-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class EventGroupRef(Ref):
            dest: ConsumedEventGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class EventHandlerRefs:
        event_handler_ref: list[
            "SenderReceiverToSignalGroupMapping.EventHandlerRefs.EventHandlerRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-HANDLER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EventHandlerRef(Ref):
            dest: EventHandlerSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRefs:
        service_instance_ref: list[
            "SenderReceiverToSignalGroupMapping.ServiceInstanceRefs.ServiceInstanceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceInstanceRef(Ref):
            dest: AbstractServiceInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SignalGroupRef(Ref):
        dest: SystemSignalGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TypeMapping:
        sender_rec_array_type_mapping: SenderRecArrayTypeMapping | None = field(
            default=None,
            metadata={
                "name": "SENDER-REC-ARRAY-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sender_rec_record_type_mapping: SenderRecRecordTypeMapping | None = field(
            default=None,
            metadata={
                "name": "SENDER-REC-RECORD-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SenderReceiverToSignalMapping:
    """
    Mapping of a sender receiver communication data element to a signal.

    :ivar communication_direction: This attribute controls the direction
        into which the mapped SystemSignal is communicated with respect
        to the kind of PortPrototype used as the context element of the
        DataMapping.
    :ivar event_group_refs: Via this reference a connection between the
        VFB View and the Ethernet EventGroups can be created.
    :ivar event_handler_refs: Via this reference a connection between
        the VFB View and the Ethernet EventHandlers can be created.
    :ivar introduction: This represents introductory documentation about
        the data mapping.
    :ivar service_instance_refs: Via this reference a connection between
        the VFB View and the Ethernet Services can be created.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.dataMapping
    :ivar data_element_iref: Reference to the data element.
    :ivar sender_to_signal_text_table_mapping: This mapping allows for
        the text-table translation between the sending DataPrototype
        that is defined in the PortPrototype and the physicalProps
        defined for the SystemSignal.
    :ivar signal_to_receiver_text_table_mapping: This mapping allows for
        the text-table translation between the physicalProps defined for
        the SystemSignal and a receiving DataPrototype that is defined
        in the PortPrototype.
    :ivar system_signal_ref: Reference to the system signal used to
        carry the data element.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SENDER-RECEIVER-TO-SIGNAL-MAPPING"

    communication_direction: CommunicationDirectionType | None = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_refs: Optional["SenderReceiverToSignalMapping.EventGroupRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_handler_refs: Optional["SenderReceiverToSignalMapping.EventHandlerRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-HANDLER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_refs: Optional["SenderReceiverToSignalMapping.ServiceInstanceRefs"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_iref: VariableDataPrototypeInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sender_to_signal_text_table_mapping: TextTableMapping | None = field(
        default=None,
        metadata={
            "name": "SENDER-TO-SIGNAL-TEXT-TABLE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signal_to_receiver_text_table_mapping: TextTableMapping | None = field(
        default=None,
        metadata={
            "name": "SIGNAL-TO-RECEIVER-TEXT-TABLE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_signal_ref: Optional["SenderReceiverToSignalMapping.SystemSignalRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EventGroupRefs:
        event_group_ref: list["SenderReceiverToSignalMapping.EventGroupRefs.EventGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EventGroupRef(Ref):
            dest: ConsumedEventGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class EventHandlerRefs:
        event_handler_ref: list[
            "SenderReceiverToSignalMapping.EventHandlerRefs.EventHandlerRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-HANDLER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EventHandlerRef(Ref):
            dest: EventHandlerSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRefs:
        service_instance_ref: list[
            "SenderReceiverToSignalMapping.ServiceInstanceRefs.ServiceInstanceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceInstanceRef(Ref):
            dest: AbstractServiceInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SeparateSignalPath:
    """The SeparateSignalPath describes that two SwcToSwcSignals and/or
    SwcToSwcOperationArguments shall not take the same way (Signal Path) in the
    topology (e.g. Redundancy).

    This means that the signals are not allowed to share even a single
    physical channel in their path.

    :ivar introduction: This represents introductory documentation about
        the signal path constraint.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.signalPathConstraint
    :ivar operations: The SwcToSwcOperationArguments that shall not take
        the same way (Signal Path) in the topology.
    :ivar signals: The SwcToSwcSignals that shall not take the same way
        (Signal Path) in the topology.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SEPARATE-SIGNAL-PATH"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operations: Optional["SeparateSignalPath.Operations"] = field(
        default=None,
        metadata={
            "name": "OPERATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signals: Optional["SeparateSignalPath.Signals"] = field(
        default=None,
        metadata={
            "name": "SIGNALS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Operations:
        swc_to_swc_operation_arguments: list[SwcToSwcOperationArguments] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TO-SWC-OPERATION-ARGUMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Signals:
        swc_to_swc_signal: list[SwcToSwcSignal] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TO-SWC-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SerializationTechnology:
    """&lt;font color="#0f0f0f"&gt;This element is deprecated and will be removed
    in future.

    This information is replaced by the TransformationTechnology
    element.&lt;/font&gt; &lt;font color="#0f0f0f"&gt;
    &lt;/font&gt;&lt;font color="#0f0f0f"&gt;Old description: Identifies
    the used serialization technology. The corresponding serialization
    plugin has to be provided on each affected ECU by the integrator.
    &lt;/font&gt;

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar protocol: Payload serialization technology.
    :ivar version: Version of the used serialization technology.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERIALIZATION-TECHNOLOGY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SerializationTechnology.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SerializationTechnology.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: String | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ServiceInstanceToPortPrototypeMapping:
    """This meta-class represents the ability to assign a transport layer dependent
    ServiceInstance to a PortPrototype.

    With this mapping it is possible to define how specific
    PortPrototypes are represented in the middleware in terms of service
    configuration.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar port_prototype_iref: Reference to a specific PortPrototype
        that represents the ServiceInstance.
    :ivar process_design_ref: Reference to the ProcessDesign in which
        the Executable that contains the SoftwareComponent and the
        referenced PortPrototype is executed.
    :ivar process_ref: Reference to the Process in which the enclosing
        ServiceInstanceToPortPrototypeMapping is executed.
    :ivar service_instance_ref: Reference to a ServiceInstance that is
        represented in the Software Component by the mapped group of
        PortPrototypes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-INSTANCE-TO-PORT-PROTOTYPE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ServiceInstanceToPortPrototypeMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ServiceInstanceToPortPrototypeMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_iref: PortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_design_ref: Optional["ServiceInstanceToPortPrototypeMapping.ProcessDesignRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["ServiceInstanceToPortPrototypeMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_ref: Optional["ServiceInstanceToPortPrototypeMapping.ServiceInstanceRef"] = (
        field(
            default=None,
            metadata={
                "name": "SERVICE-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessDesignRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRef(Ref):
        dest: AdaptivePlatformServiceInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ServiceInterfaceElementSecureComConfig:
    """
    This element allows to secure the communication of the referenced
    ServiceInterface element.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar data_id: This attribute defines a unique numerical identifier
        for the referenced ServiceInterface element.
    :ivar event_ref: Reference to an event that is protected by a
        security protocol.
    :ivar field_notifier_ref: Reference to a field notifier that is
        protected by a security protocol.
    :ivar freshness_value_id: This attribute defines the Id of the
        Freshness Value.
    :ivar getter_call_ref: Reference to a field getter call message that
        is protected by a security protocol.
    :ivar getter_return_ref: Reference to a field getter return message
        that is protected by a security protocol.
    :ivar method_call_ref: Reference to a method call message that is
        protected by a security protocol.
    :ivar method_return_ref: Reference to a method return message that
        is protected by a security protocol.
    :ivar secured_rx_verification: This attribute defines whether the
        ServiceInterface element shall verify its security credentials
        during reception.
    :ivar setter_call_ref: Reference to a field setter call message that
        is protected by a security protocol.
    :ivar setter_return_ref: Reference to a field setter return message
        that is protected by a security protocol.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-INTERFACE-ELEMENT-SECURE-COM-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ServiceInterfaceElementSecureComConfig.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ServiceInterfaceElementSecureComConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DATA-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["ServiceInterfaceElementSecureComConfig.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_notifier_ref: Optional["ServiceInterfaceElementSecureComConfig.FieldNotifierRef"] = field(
        default=None,
        metadata={
            "name": "FIELD-NOTIFIER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freshness_value_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FRESHNESS-VALUE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    getter_call_ref: Optional["ServiceInterfaceElementSecureComConfig.GetterCallRef"] = field(
        default=None,
        metadata={
            "name": "GETTER-CALL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    getter_return_ref: Optional["ServiceInterfaceElementSecureComConfig.GetterReturnRef"] = field(
        default=None,
        metadata={
            "name": "GETTER-RETURN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_call_ref: Optional["ServiceInterfaceElementSecureComConfig.MethodCallRef"] = field(
        default=None,
        metadata={
            "name": "METHOD-CALL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_return_ref: Optional["ServiceInterfaceElementSecureComConfig.MethodReturnRef"] = field(
        default=None,
        metadata={
            "name": "METHOD-RETURN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secured_rx_verification: Boolean | None = field(
        default=None,
        metadata={
            "name": "SECURED-RX-VERIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    setter_call_ref: Optional["ServiceInterfaceElementSecureComConfig.SetterCallRef"] = field(
        default=None,
        metadata={
            "name": "SETTER-CALL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    setter_return_ref: Optional["ServiceInterfaceElementSecureComConfig.SetterReturnRef"] = field(
        default=None,
        metadata={
            "name": "SETTER-RETURN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: ServiceEventDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FieldNotifierRef(Ref):
        dest: ServiceFieldDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class GetterCallRef(Ref):
        dest: ServiceFieldDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class GetterReturnRef(Ref):
        dest: ServiceFieldDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MethodCallRef(Ref):
        dest: ServiceMethodDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MethodReturnRef(Ref):
        dest: ServiceMethodDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SetterCallRef(Ref):
        dest: ServiceFieldDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SetterReturnRef(Ref):
        dest: ServiceFieldDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ServiceInterfaceEventMapping:
    """
    This meta-class allows to define a mapping between events of ServiceInterfaces
    that are mapped to each other by the ServiceInterfaceMapping.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar source_event_ref: Reference to an event that is contained in
        the source ServiceInterface.
    :ivar target_event_ref: Reference to an event that is contained in
        the composite ServiceInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-INTERFACE-EVENT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ServiceInterfaceEventMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ServiceInterfaceEventMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_event_ref: Optional["ServiceInterfaceEventMapping.SourceEventRef"] = field(
        default=None,
        metadata={
            "name": "SOURCE-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_event_ref: Optional["ServiceInterfaceEventMapping.TargetEventRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SourceEventRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetEventRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ServiceInterfaceFieldMapping:
    """
    This meta-class allows to define a mapping between fields of ServiceInterfaces
    that are mapped to each other by the ServiceInterfaceMapping.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar source_field_ref: Reference to a field that is contained in
        the source ServiceInterface.
    :ivar target_field_ref: Reference to a field that is contained in
        the composite ServiceInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-INTERFACE-FIELD-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ServiceInterfaceFieldMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ServiceInterfaceFieldMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_field_ref: Optional["ServiceInterfaceFieldMapping.SourceFieldRef"] = field(
        default=None,
        metadata={
            "name": "SOURCE-FIELD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_field_ref: Optional["ServiceInterfaceFieldMapping.TargetFieldRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-FIELD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SourceFieldRef(Ref):
        dest: FieldSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetFieldRef(Ref):
        dest: FieldSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ServiceInterfaceMapping:
    """
    Specifies one ServiceInterfaceMapping that allows to define that a
    ServiceInterface is composite of several other ServiceInterfaces.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        PortInterfaceMappingSet.portInterfaceMapping
    :ivar composite_service_interface_ref: This represents the composite
        ServiceInterface.
    :ivar source_service_interface_refs: ServiceInterface that is mapped
        into the composite ServiceInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-INTERFACE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ServiceInterfaceMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ServiceInterfaceMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ServiceInterfaceMapping.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    composite_service_interface_ref: Optional[
        "ServiceInterfaceMapping.CompositeServiceInterfaceRef"
    ] = field(
        default=None,
        metadata={
            "name": "COMPOSITE-SERVICE-INTERFACE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_service_interface_refs: Optional[
        "ServiceInterfaceMapping.SourceServiceInterfaceRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SOURCE-SERVICE-INTERFACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CompositeServiceInterfaceRef(Ref):
        dest: ServiceInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SourceServiceInterfaceRefs:
        source_service_interface_ref: list[
            "ServiceInterfaceMapping.SourceServiceInterfaceRefs.SourceServiceInterfaceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SOURCE-SERVICE-INTERFACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SourceServiceInterfaceRef(Ref):
            dest: ServiceInterfaceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class ServiceInterfaceMethodMapping:
    """
    This meta-class allows to define a mapping between methods of ServiceInterfaces
    that are mapped to each other by the ServiceInterfaceMapping.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar source_method_ref: Reference to a method that is contained in
        the source ServiceInterface.
    :ivar target_method_ref: Reference to a method that is contained in
        the composite ServiceInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-INTERFACE-METHOD-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ServiceInterfaceMethodMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ServiceInterfaceMethodMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_method_ref: Optional["ServiceInterfaceMethodMapping.SourceMethodRef"] = field(
        default=None,
        metadata={
            "name": "SOURCE-METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_method_ref: Optional["ServiceInterfaceMethodMapping.TargetMethodRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SourceMethodRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetMethodRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ServiceInterfacePedigree:
    """
    Collection of ServiceInterfaces that belong to the same versioning.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar service_interface_refs: Reference to the ServiceInterfaces
        which belong to the same versioning.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-INTERFACE-PEDIGREE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ServiceInterfacePedigree.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ServiceInterfacePedigree.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_refs: Optional["ServiceInterfacePedigree.ServiceInterfaceRefs"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInterfaceRefs:
        service_interface_ref: list[
            "ServiceInterfacePedigree.ServiceInterfaceRefs.ServiceInterfaceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceInterfaceRef(Ref):
            dest: ServiceInterfaceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class ServiceInterfaceTriggerMapping:
    """
    This meta-class allows to define a mapping between triggers of
    ServiceInterfaces that are mapped to each other by the ServiceInterfaceMapping.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar source_trigger_ref: Reference to a trigger that is contained
        in the source ServiceInterface.
    :ivar target_trigger_ref: Reference to a trigger that is contained
        in the target ServiceInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-INTERFACE-TRIGGER-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ServiceInterfaceTriggerMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ServiceInterfaceTriggerMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_trigger_ref: Optional["ServiceInterfaceTriggerMapping.SourceTriggerRef"] = field(
        default=None,
        metadata={
            "name": "SOURCE-TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_trigger_ref: Optional["ServiceInterfaceTriggerMapping.TargetTriggerRef"] = field(
        default=None,
        metadata={
            "name": "TARGET-TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SourceTriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetTriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SignalBasedEventElementToISignalTriggeringMapping:
    """
    This meta-class defines the mapping of a ServiceInterface event or an element
    that is defined inside of the event in case that the datatype is composite to
    an ISignalTriggering.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar data_prototype_in_service_interface_ref: Reference to a
        DataPrototype or to an internal structure of a DataPrototype in
        the context of a ServiceInterface.
    :ivar filter: Defines an optional filter to be applied during
        translation.
    :ivar i_signal_triggering_ref: Reference to the ISignalTriggering
        that is used to transport a piece of data of an event that is
        defined in a  ServiceInterface in a signal-based way over a
        communication channel.
    :ivar transmission_trigger: Defines whether the source element
        triggers the sending of the respective payload.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SIGNAL-BASED-EVENT-ELEMENT-TO-I-SIGNAL-TRIGGERING-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "SignalBasedEventElementToISignalTriggeringMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SignalBasedEventElementToISignalTriggeringMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototype_in_service_interface_ref: DataPrototypeInServiceInterfaceRef | None = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-IN-SERVICE-INTERFACE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    filter: DataFilter | None = field(
        default=None,
        metadata={
            "name": "FILTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_triggering_ref: Optional[
        "SignalBasedEventElementToISignalTriggeringMapping.ISignalTriggeringRef"
    ] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_trigger: Boolean | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalTriggeringRef(Ref):
        dest: ISignalTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SignalBasedFieldToISignalTriggeringMapping:
    """This meta-class defines the mapping of a ServiceInterface field to ISignalTriggerings that represent the notifier elements, the getter call and response, the setter call and response on a signal-based communication channel.
    .

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar data_prototype_in_service_interface_ref: Reference to a
        DataPrototype or to an internal structure of a DataPrototype in
        the context of a ServiceInterface.
    :ivar filter: Defines an optional filter to be applied during
        translation.
    :ivar getter_call_signal_ref: Reference to the ISignalTriggering
        that is used to transport the getter method call in a signal-
        based way over a communication channel.
    :ivar getter_return_signal_ref: Reference to the ISignalTriggering
        that is used to transport the getter method response in a
        signal-based way over a communication channel.
    :ivar notifier_signal_triggering_ref: Reference to the
        ISignalTriggering that is used to transport a piece of data of a
        notifier in a signal-based way over a communication channel.
    :ivar setter_call_signal_ref: Reference to the ISignalTriggering
        that is used to transport the setter method call in a signal-
        based way over a communication channel.
    :ivar setter_return_signal_ref: Reference to the ISignalTriggering
        that is used to transport the setter method response in a
        signal-based way over a communication channel.
    :ivar transmission_trigger: Defines whether the source notifier
        element triggers the sending of the respective payload.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SIGNAL-BASED-FIELD-TO-I-SIGNAL-TRIGGERING-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "SignalBasedFieldToISignalTriggeringMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SignalBasedFieldToISignalTriggeringMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototype_in_service_interface_ref: DataPrototypeInServiceInterfaceRef | None = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-IN-SERVICE-INTERFACE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    filter: DataFilter | None = field(
        default=None,
        metadata={
            "name": "FILTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    getter_call_signal_ref: Optional[
        "SignalBasedFieldToISignalTriggeringMapping.GetterCallSignalRef"
    ] = field(
        default=None,
        metadata={
            "name": "GETTER-CALL-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    getter_return_signal_ref: Optional[
        "SignalBasedFieldToISignalTriggeringMapping.GetterReturnSignalRef"
    ] = field(
        default=None,
        metadata={
            "name": "GETTER-RETURN-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    notifier_signal_triggering_ref: Optional[
        "SignalBasedFieldToISignalTriggeringMapping.NotifierSignalTriggeringRef"
    ] = field(
        default=None,
        metadata={
            "name": "NOTIFIER-SIGNAL-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    setter_call_signal_ref: Optional[
        "SignalBasedFieldToISignalTriggeringMapping.SetterCallSignalRef"
    ] = field(
        default=None,
        metadata={
            "name": "SETTER-CALL-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    setter_return_signal_ref: Optional[
        "SignalBasedFieldToISignalTriggeringMapping.SetterReturnSignalRef"
    ] = field(
        default=None,
        metadata={
            "name": "SETTER-RETURN-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_trigger: Boolean | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class GetterCallSignalRef(Ref):
        dest: ISignalTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class GetterReturnSignalRef(Ref):
        dest: ISignalTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NotifierSignalTriggeringRef(Ref):
        dest: ISignalTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SetterCallSignalRef(Ref):
        dest: ISignalTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SetterReturnSignalRef(Ref):
        dest: ISignalTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SignalBasedFireAndForgetMethodToISignalTriggeringMapping:
    """
    This meta-class defines the mapping of a ServiceInterface fire and forget
    method part to an ISignalTriggering.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar data_prototype_in_method_argument_instance_ref_iref: Instance
        reference to a (potentially structured) member of a
        ClientServerOperation.
    :ivar i_signal_triggering_ref: Reference to an ISignalTriggering
        being part of a fire and forget message.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SIGNAL-BASED-FIRE-AND-FORGET-METHOD-TO-I-SIGNAL-TRIGGERING-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "SignalBasedFireAndForgetMethodToISignalTriggeringMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional[
        "SignalBasedFireAndForgetMethodToISignalTriggeringMapping.Annotations"
    ] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototype_in_method_argument_instance_ref_iref: (
        DataPrototypeInServiceInterfaceInstanceRef | None
    ) = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-IN-METHOD-ARGUMENT-INSTANCE-REF-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_triggering_ref: Optional[
        "SignalBasedFireAndForgetMethodToISignalTriggeringMapping.ISignalTriggeringRef"
    ] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalTriggeringRef(Ref):
        dest: ISignalTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SignalBasedMethodToISignalTriggeringMapping:
    """
    This meta-class defines the mapping of a ServiceInterface method to a
    ISignalTriggering.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar call_signal_triggering_ref: Reference to the ISignalTriggering
        that is used to transport the method call in a signal-based way
        over a communication channel.
    :ivar method_ref: Reference to a method defined in the context of a
        ServiceInterface.
    :ivar return_signal_triggering_ref: Reference to the
        ISignalTriggering that is used to transport the method response
        in a signal-based way over a communication channel.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SIGNAL-BASED-METHOD-TO-I-SIGNAL-TRIGGERING-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "SignalBasedMethodToISignalTriggeringMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SignalBasedMethodToISignalTriggeringMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    call_signal_triggering_ref: Optional[
        "SignalBasedMethodToISignalTriggeringMapping.CallSignalTriggeringRef"
    ] = field(
        default=None,
        metadata={
            "name": "CALL-SIGNAL-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_ref: Optional["SignalBasedMethodToISignalTriggeringMapping.MethodRef"] = field(
        default=None,
        metadata={
            "name": "METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    return_signal_triggering_ref: Optional[
        "SignalBasedMethodToISignalTriggeringMapping.ReturnSignalTriggeringRef"
    ] = field(
        default=None,
        metadata={
            "name": "RETURN-SIGNAL-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CallSignalTriggeringRef(Ref):
        dest: ISignalTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MethodRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ReturnSignalTriggeringRef(Ref):
        dest: ISignalTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SignalBasedTriggerToISignalTriggeringMapping:
    """
    This meta-class defines the mapping of a ServiceInterface trigger  to an
    ISignalTriggering.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar i_signal_triggering_ref: Reference to the ISignalTriggering
        that is used to transport the trigger that is defined in a
        ServiceInterface in a signal-based way over a communication
        channel.
    :ivar trigger_ref: Reference to a trigger defined in the context of
        a ServiceInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SIGNAL-BASED-TRIGGER-TO-I-SIGNAL-TRIGGERING-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "SignalBasedTriggerToISignalTriggeringMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SignalBasedTriggerToISignalTriggeringMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_triggering_ref: Optional[
        "SignalBasedTriggerToISignalTriggeringMapping.ISignalTriggeringRef"
    ] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_ref: Optional["SignalBasedTriggerToISignalTriggeringMapping.TriggerRef"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalTriggeringRef(Ref):
        dest: ISignalTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SignalIPduCounter:
    """A PduCounter is included in a predefined set of Pdus and used to ensure that
    a sequence of Pdus is maintained.

    The counter is incremented when a Pdu is transmitted. The receivers
    check if the received Pdu is the next one in sequence.

    :ivar pdu_counter_size: Size of PduCounter expressed in bits. Range:
        1..8
    :ivar pdu_counter_start_position: Position of PduCounter expressed
        in bits. Note that PduCounter is not allowed to cross a byte
        border.
    :ivar pdu_counter_threshold: Threshold value of IPduCounter
        algorithm. See AUTOSAR COM Spec for more details.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ISignalIPdu.pduCounter
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SIGNAL-I-PDU-COUNTER"

    pdu_counter_size: Integer | None = field(
        default=None,
        metadata={
            "name": "PDU-COUNTER-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_counter_start_position: Integer | None = field(
        default=None,
        metadata={
            "name": "PDU-COUNTER-START-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_counter_threshold: Integer | None = field(
        default=None,
        metadata={
            "name": "PDU-COUNTER-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SignalIPduReplication:
    """PduReplication is a form of redundancy where the data content of one
    ISignalIPdu (source) is transmitted inside a set of replica ISignalIPdus.

    These ISignalIPdus (copies) have different Pdu IDs, identical
    PduCounters, identical data content and are transmitted with the
    same frequency.

    :ivar pdu_replication_voting: Number of identical IPdus needed for
        successful voting (1-3).
    :ivar replica_pdus_refs: Reference to replica Pdus of this IPdu.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ISignalIPdu.pduReplication
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SIGNAL-I-PDU-REPLICATION"

    pdu_replication_voting: Integer | None = field(
        default=None,
        metadata={
            "name": "PDU-REPLICATION-VOTING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    replica_pdus_refs: Optional["SignalIPduReplication.ReplicaPdusRefs"] = field(
        default=None,
        metadata={
            "name": "REPLICA-PDUS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ReplicaPdusRefs:
        replica_pdus_ref: list["SignalIPduReplication.ReplicaPdusRefs.ReplicaPdusRef"] = field(
            default_factory=list,
            metadata={
                "name": "REPLICA-PDUS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 2,
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ReplicaPdusRef(Ref):
            dest: ISignalIPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SignalServiceTranslationElementProps:
    """
    Defined translation properties for individual mapped elements.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar element: Reference to the leaf element the
        SignalServiceTranslationElementProps apply to.
    :ivar filter: Defines an optional filter to be applied during
        translation.
    :ivar transmission_trigger: Defines whether the source element
        (which is mapped to the referenced element) triggers the sending
        of the respective payload.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SIGNAL-SERVICE-TRANSLATION-ELEMENT-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SignalServiceTranslationElementProps.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SignalServiceTranslationElementProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    element: Optional["SignalServiceTranslationElementProps.Element"] = field(
        default=None,
        metadata={
            "name": "ELEMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    filter: DataFilter | None = field(
        default=None,
        metadata={
            "name": "FILTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_trigger: Boolean | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Element:
        data_prototype_in_port_interface_ref: DataPrototypeInPortInterfaceRef | None = field(
            default=None,
            metadata={
                "name": "DATA-PROTOTYPE-IN-PORT-INTERFACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        implementation_data_type_element_in_port_interface_ref: (
            ImplementationDataTypeElementInPortInterfaceRef | None
        ) = field(
            default=None,
            metadata={
                "name": "IMPLEMENTATION-DATA-TYPE-ELEMENT-IN-PORT-INTERFACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SimulatedExecutionTime:
    """
    Specifies the ExecutionTime which has been gathered using simulation means.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar exclusive_area_ref: Reference to the ExclusiveArea this
        execution time is provided for.
    :ivar executable_entity_ref: The executable entity for which this
        execution time is described.
    :ivar hardware_configuration: Provides information on the
        HardwareConfiguration used to specify this ExecutionTime.
    :ivar hw_element_ref: The hardware element (e.g. type of ECU) for
        which the execution time is specified.
    :ivar included_library_refs: If this dependency is specified, the
        execution time of the library code is included in the execution
        time data for the runnable.
    :ivar memory_section_locations: Provides information on the
        MemorySectionLocation which is involved in the ExecutionTime
        description.
    :ivar software_context: Provides information on the detailed
        SoftwareContext used to provide the ExecutionTime description.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ResourceConsumption.executionTime
    :ivar maximum_execution_time: The maximum simulated execution time.
    :ivar minimum_execution_time: The minimum simulated execution time.
    :ivar nominal_execution_time: The nominal simulated execution time.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SIMULATED-EXECUTION-TIME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SimulatedExecutionTime.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SimulatedExecutionTime.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_area_ref: Optional["SimulatedExecutionTime.ExclusiveAreaRef"] = field(
        default=None,
        metadata={
            "name": "EXCLUSIVE-AREA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    executable_entity_ref: Optional["SimulatedExecutionTime.ExecutableEntityRef"] = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-ENTITY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hardware_configuration: HardwareConfiguration | None = field(
        default=None,
        metadata={
            "name": "HARDWARE-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_element_ref: Optional["SimulatedExecutionTime.HwElementRef"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    included_library_refs: Optional["SimulatedExecutionTime.IncludedLibraryRefs"] = field(
        default=None,
        metadata={
            "name": "INCLUDED-LIBRARY-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_section_locations: Optional["SimulatedExecutionTime.MemorySectionLocations"] = field(
        default=None,
        metadata={
            "name": "MEMORY-SECTION-LOCATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_context: SoftwareContext | None = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CONTEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_execution_time: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-EXECUTION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_execution_time: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-EXECUTION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nominal_execution_time: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "NOMINAL-EXECUTION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaRef(Ref):
        dest: ExclusiveAreaSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutableEntityRef(Ref):
        dest: ExecutableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class HwElementRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IncludedLibraryRefs:
        included_library_ref: list[
            "SimulatedExecutionTime.IncludedLibraryRefs.IncludedLibraryRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "INCLUDED-LIBRARY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class IncludedLibraryRef(Ref):
            dest: DependencyOnArtifactSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class MemorySectionLocations:
        memory_section_location: list[MemorySectionLocation] = field(
            default_factory=list,
            metadata={
                "name": "MEMORY-SECTION-LOCATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SoAdRoutingGroup:
    """Routing of Pdus in the SoAd can be activated or deactivated.

    The ShortName of this element shall contain the RoutingGroupId.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar event_group_control_type: This attribute defines the type of a
        RoutingGroup. There are RoutingGroups that activate the data
        path for unicast or multicast events of an event group. And
        there are RoutingGroups that activate the data path for initial
        events that are triggered, namely events that are sent out on
        the server side after a client got subscribed. Please note that
        this attribute is only valid for event communication (Sender
        Receiver communication) and shall be omitted in
        MethodActivationRoutingGroups.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SO-AD-ROUTING-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SoAdRoutingGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SoAdRoutingGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_control_type: EventGroupControlTypeEnum | None = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-CONTROL-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SoConIPduIdentifierRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar so_con_i_pdu_identifier_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SO-CON-I-PDU-IDENTIFIER-REF-CONDITIONAL"

    so_con_i_pdu_identifier_ref: Optional[
        "SoConIPduIdentifierRefConditional.SoConIPduIdentifierRef"
    ] = field(
        default=None,
        metadata={
            "name": "SO-CON-I-PDU-IDENTIFIER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SoConIPduIdentifierRef(Ref):
        dest: SoConIPduIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SocketAddressRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar socket_address_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOCKET-ADDRESS-REF-CONDITIONAL"

    socket_address_ref: Optional["SocketAddressRefConditional.SocketAddressRef"] = field(
        default=None,
        metadata={
            "name": "SOCKET-ADDRESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SocketAddressRef(Ref):
        dest: SocketAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SocketConnection:
    """
    The SoAd serves as a (De)Multiplexer between different PDU sources and the
    TCP/IP stack.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar allowed_i_pv_6_ext_headers_ref: Reference to a list of IPv6
        Extension Headers allowed for this SocketConnection. If no list
        is referenced all IPv6 Extension Headers are allowed and
        processed.
    :ivar allowed_tcp_options_ref: Reference to a list of TCP options
        allowed for this SocketConnection.
    :ivar autosar_connector: This attribute is deprecated and will be
        removed in future.
    :ivar client_ip_addr_from_connection_request: If set to true the
        Server "learns" the client IP address on connection request.
        This means that the statically configured IP Address of the
        related client shall be ignored. If set to false the Server only
        accepts statically configured IP address, e.g. 192.168.1.2. This
        means that the statically configured IP Address of the Client
        shall be used.
    :ivar client_port_from_connection_request: If set to true the Server
        "learns" the client Port on connection request. This means that
        the statically configured Port of the related client shall be
        ignored. If set to false the Server only accepts statically
        configured Port. This means that the statically configured Port
        of the Client shall be used.
    :ivar client_port_ref: Client Port for TCP/UDP connection in an
        abstract communication sense. The client is the major requester
        of the communication. Please note that the client may also
        produce data.
    :ivar do_ip_source_address_ref: The logical DoIP address of the
        source entity. This optional reference shall only be used for
        DoIP (Diagnosis over IP).
    :ivar do_ip_target_address_ref: The logical DoIP address of the
        target entity. This optional reference shall only be used for
        DoIP (Diagnosis over IP).
    :ivar ident: This adds the ability to become referrable to
        SocketConnection.
    :ivar local_port_ref: This reference is obsolete and will be removed
        in the future. The serverPort reference in
        SocketConnectionBundle shall be used instead. Old description:
        Local Port for TCP/UDP connection.
    :ivar n_pdu_ref: Reference to data packets that are transmitted over
        Ethernet. Each data packet can contain multiple IPdus. Please
        note that this reference is deprecated.
    :ivar pdus: PDUs handed over by the PDU Router (Transmission over
        the Ethernet) or PDUs handed over by SoAd (Reception over
        Ethernet). Multiple IPdus can be transmitted over one socket
        connection.
    :ivar pdu_collection_max_buffer_size: Defines the maximum buffer
        size in Byte which shall be filled before a socket with Pdu
        collection enabled shall be transmitted to the lower layer.
    :ivar pdu_collection_timeout: Defines the time in seconds which
        shall pass before a socket with Pdu collection enabled shall be
        transmitted to the lower layer after the first Pdu has been put
        into the socket buffer.
    :ivar remote_port_ref: This reference is obsolete and will be
        removed in the future. The clientPort reference shall be used
        instead. Old description: Remote Port for TCP/UDP connection.
        May be different for each Frame or use the same remote port. In
        second case headerId attribute needs to be considered.
    :ivar runtime_ip_address_configuration: This attribute determines
        which protocol is used by the client to obtain the IP Address
        information. If this attribute is not set to none the value
        determines the service used by the client to obtain the IP
        Address information for the SocketConnection. If this attribute
        is set to none the client used the statically configured IP
        Address information.
    :ivar runtime_port_configuration: This attribute determines which
        protocol is used by the client to obtain the Port information.
        If this attribute is not set to none the value determines the
        service used by the client to obtain the Port information for
        the SocketConnection. If this attribute is set to none the
        client uses the statically configured Port information.
    :ivar short_label: This attribute specifies an identifying shortName
        for the SocketConnection. It shall be unique within its context.
    :ivar socket_protocol: This attribute is deprecated and will be
        removed in future.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: SoAdConfig.connection
        Not Applicable for: SocketConnectionBundle.bundledConnection
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOCKET-CONNECTION"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    allowed_i_pv_6_ext_headers_ref: Optional["SocketConnection.AllowedIPv6ExtHeadersRef"] = field(
        default=None,
        metadata={
            "name": "ALLOWED-I-PV-6-EXT-HEADERS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    allowed_tcp_options_ref: Optional["SocketConnection.AllowedTcpOptionsRef"] = field(
        default=None,
        metadata={
            "name": "ALLOWED-TCP-OPTIONS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    autosar_connector: SoAdConnectorType | None = field(
        default=None,
        metadata={
            "name": "AUTOSAR-CONNECTOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_ip_addr_from_connection_request: Boolean | None = field(
        default=None,
        metadata={
            "name": "CLIENT-IP-ADDR-FROM-CONNECTION-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_port_from_connection_request: Boolean | None = field(
        default=None,
        metadata={
            "name": "CLIENT-PORT-FROM-CONNECTION-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_port_ref: Optional["SocketConnection.ClientPortRef"] = field(
        default=None,
        metadata={
            "name": "CLIENT-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    do_ip_source_address_ref: Optional["SocketConnection.DoIpSourceAddressRef"] = field(
        default=None,
        metadata={
            "name": "DO-IP-SOURCE-ADDRESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    do_ip_target_address_ref: Optional["SocketConnection.DoIpTargetAddressRef"] = field(
        default=None,
        metadata={
            "name": "DO-IP-TARGET-ADDRESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ident: TpConnectionIdent | None = field(
        default=None,
        metadata={
            "name": "IDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_port_ref: Optional["SocketConnection.LocalPortRef"] = field(
        default=None,
        metadata={
            "name": "LOCAL-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    n_pdu_ref: Optional["SocketConnection.NPduRef"] = field(
        default=None,
        metadata={
            "name": "N-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdus: Optional["SocketConnection.Pdus"] = field(
        default=None,
        metadata={
            "name": "PDUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_collection_max_buffer_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PDU-COLLECTION-MAX-BUFFER-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_collection_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PDU-COLLECTION-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_port_ref: Optional["SocketConnection.RemotePortRef"] = field(
        default=None,
        metadata={
            "name": "REMOTE-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runtime_ip_address_configuration: RuntimeAddressConfigurationEnum | None = field(
        default=None,
        metadata={
            "name": "RUNTIME-IP-ADDRESS-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runtime_port_configuration: RuntimeAddressConfigurationEnum | None = field(
        default=None,
        metadata={
            "name": "RUNTIME-PORT-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    socket_protocol: SoAdProtocolType | None = field(
        default=None,
        metadata={
            "name": "SOCKET-PROTOCOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AllowedIPv6ExtHeadersRef(Ref):
        dest: IPv6ExtHeaderFilterListSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AllowedTcpOptionsRef(Ref):
        dest: TcpOptionFilterListSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ClientPortRef(Ref):
        dest: SocketAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DoIpSourceAddressRef(Ref):
        dest: LogicAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DoIpTargetAddressRef(Ref):
        dest: LogicAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class LocalPortRef(Ref):
        dest: SocketAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NPduRef(Ref):
        dest: NPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Pdus:
        socket_connection_ipdu_identifier: list[SocketConnectionIpduIdentifier] = field(
            default_factory=list,
            metadata={
                "name": "SOCKET-CONNECTION-IPDU-IDENTIFIER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RemotePortRef(Ref):
        dest: SocketAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SocketConnectionIpduIdentifierSet:
    """
    Collection of PduIdentifiers used for transmission over a Socket Connection
    with the header option.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar i_pdu_identifiers: Collection of IPduIdentifiers that are
        transmitted over Socket Connections.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOCKET-CONNECTION-IPDU-IDENTIFIER-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SocketConnectionIpduIdentifierSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SocketConnectionIpduIdentifierSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_pdu_identifiers: Optional["SocketConnectionIpduIdentifierSet.IPduIdentifiers"] = field(
        default=None,
        metadata={
            "name": "I-PDU-IDENTIFIERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IPduIdentifiers:
        so_con_i_pdu_identifier: list[SoConIPduIdentifier] = field(
            default_factory=list,
            metadata={
                "name": "SO-CON-I-PDU-IDENTIFIER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SoftwareClusterDiagnosticDeploymentProps:
    """
    This meta-class acts as the owner of all deployment-related diagnostic
    properties of a SoftwareCluster.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar diagnostic_addresss: This aggregation represents the
        collection of diagnostic addresses that apply for the
        SoftwareCluster.
    :ivar diagnostic_extract_ref: This reference identifies the
        applicable SoftwareClusterDiagnosticProps for the enclosing
        SoftwareCluster.Note that all SoftwareClusters that share the
        same DiagnosticContributionSet via the reference
        diagnosticExtract shall also share the same
        SoftwareClusterDiagnosticDeploymentProps.
    :ivar external_authentications: This reference supports the
        configuration of the authentication of diagnostic clients.
    :ivar power_down_time: This attribute indicates the minimum time of
        the stand-by sequence the server will remain in the power-down
        sequence. The unit is seconds.
    :ivar validation_configuration: This aggregation represents the
        ability to define the order of manufacturer and supplier
        validations in diagnostic management.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-CLUSTER-DIAGNOSTIC-DEPLOYMENT-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "SoftwareClusterDiagnosticDeploymentProps.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SoftwareClusterDiagnosticDeploymentProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_addresss: Optional["SoftwareClusterDiagnosticDeploymentProps.DiagnosticAddresss"] = (
        field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-ADDRESSS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    diagnostic_extract_ref: Optional[
        "SoftwareClusterDiagnosticDeploymentProps.DiagnosticExtractRef"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-EXTRACT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    external_authentications: Optional[
        "SoftwareClusterDiagnosticDeploymentProps.ExternalAuthentications"
    ] = field(
        default=None,
        metadata={
            "name": "EXTERNAL-AUTHENTICATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    power_down_time: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "POWER-DOWN-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    validation_configuration: DiagnosticServiceValidationConfiguration | None = field(
        default=None,
        metadata={
            "name": "VALIDATION-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticAddresss:
        software_cluster_doip_diagnostic_address: list[SoftwareClusterDoipDiagnosticAddress] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SOFTWARE-CLUSTER-DOIP-DIAGNOSTIC-ADDRESS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        software_cluster_sovd_address: list[SoftwareClusterSovdAddress] = field(
            default_factory=list,
            metadata={
                "name": "SOFTWARE-CLUSTER-SOVD-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticExtractRef(Ref):
        dest: DiagnosticContributionSetSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ExternalAuthentications:
        diagnostic_external_authentication_identification: list[
            DiagnosticExternalAuthenticationIdentification
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-IDENTIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SoftwarePackage:
    """
    This meta-class represents the ability to formalize the content of a software
    package.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar action_type: This attribute defines the action to be taken in
        the step of processing the enclosing SoftwarePackage.
    :ivar activation_action: This attribute governs the action to be
        taken after the installation of the SoftwareCluster completed.
    :ivar compressed_software_package_size: This size represents the
        size of the compressed SoftwarePackage.
    :ivar delta_package_applicable_version: This attribute identifies
        the version of the included SoftwareCluster for which the
        enclosing SoftwarePackage can be used as a delta update
    :ivar estimated_duration_of_operation: This attribute provides an
        estimation about how long the operation of the SoftwarePackage
        is going to take.
    :ivar minimum_supported_ucm_version: This attribute identifies the
        minimum supported version of the UCM for this SoftwarePackage.
    :ivar packager_id: This attribute identifies Id of the organization
        that provides the packager generating the SoftwarePackage.
    :ivar packager_signature_ref: This reference identifies the
        certificate that represents the packager's signature.
    :ivar purpose_of_update_ref: The referenced Documentation is
        supposed to provide a description of the purpose of the update.
    :ivar software_cluster_ref: This reference identifies the
        SoftwareCluster that belongs to the SoftwarePackage. The nature
        of this relation is actually more like an aggregation than a
        reference. But the relation is still modelled as a reference
        because two ARElements cannot aggregate each other.
    :ivar uncompressed_software_cluster_size: This attribute gives an
        indication about the storage that has to be available on the
        target.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-PACKAGE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SoftwarePackage.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SoftwarePackage.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    action_type: SoftwarePackageActionTypeEnum | None = field(
        default=None,
        metadata={
            "name": "ACTION-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_action: SoftwarePackageActivationActionEnum | None = field(
        default=None,
        metadata={
            "name": "ACTIVATION-ACTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compressed_software_package_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "COMPRESSED-SOFTWARE-PACKAGE-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delta_package_applicable_version: StrongRevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "DELTA-PACKAGE-APPLICABLE-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    estimated_duration_of_operation: TimeValue | None = field(
        default=None,
        metadata={
            "name": "ESTIMATED-DURATION-OF-OPERATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_supported_ucm_version: RevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-SUPPORTED-UCM-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    packager_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PACKAGER-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    packager_signature_ref: Optional["SoftwarePackage.PackagerSignatureRef"] = field(
        default=None,
        metadata={
            "name": "PACKAGER-SIGNATURE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    purpose_of_update_ref: Optional["SoftwarePackage.PurposeOfUpdateRef"] = field(
        default=None,
        metadata={
            "name": "PURPOSE-OF-UPDATE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_cluster_ref: Optional["SoftwarePackage.SoftwareClusterRef"] = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uncompressed_software_cluster_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UNCOMPRESSED-SOFTWARE-CLUSTER-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PackagerSignatureRef(Ref):
        dest: CryptoServiceCertificateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PurposeOfUpdateRef(Ref):
        dest: DocumentationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SoftwareClusterRef(Ref):
        dest: SoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SoftwarePackageStep:
    """
    This meta-class represents the configuration of an activation step in the
    context of software package activation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar process_ref: This reference identifies the SoftwarePackage to
        be processed in the enclosing SoftwarePackageStep.
    :ivar transfers: This aggregation clarifies the storing of the
        SoftwarePackage.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-PACKAGE-STEP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SoftwarePackageStep.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SoftwarePackageStep.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["SoftwarePackageStep.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transfers: Optional["SoftwarePackageStep.Transfers"] = field(
        default=None,
        metadata={
            "name": "TRANSFERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: SoftwarePackageSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Transfers:
        software_package_storing: list[SoftwarePackageStoring] = field(
            default_factory=list,
            metadata={
                "name": "SOFTWARE-PACKAGE-STORING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SomeipDataPrototypeTransformationProps:
    """
    This meta-class represents the ability to define data transformation props
    specifically for a SOME/IP serialization for a given DataPrototype.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar data_prototypes: Collection of DataPrototypes for which the
        settings in SomeipDataPrototypeTransformationProps are valid.
        For reuse reasons the SomeipDataPrototypeTransformationProps is
        able to aggregate several DataPrototypes.
    :ivar network_representation: Optional specification of the actual
        network representation for the referenced primitive
        DataPrototype. If a network representation is provided then the
        baseType available in the SwDataDefProps shall be used as input
        for the serialization/deserialization. If the
        networkRepresentation is not provided then the baseType of the
        AbstractImplementationDataType shall be used for the
        serialization/deserialization.
    :ivar someip_transformation_props_ref: This reference represents the
        ability to define data transformation props specifically for a
        SOME/IP serialization.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-DATA-PROTOTYPE-TRANSFORMATION-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipDataPrototypeTransformationProps.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipDataPrototypeTransformationProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototypes: Optional["SomeipDataPrototypeTransformationProps.DataPrototypes"] = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_representation: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "NETWORK-REPRESENTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    someip_transformation_props_ref: Optional[
        "SomeipDataPrototypeTransformationProps.SomeipTransformationPropsRef"
    ] = field(
        default=None,
        metadata={
            "name": "SOMEIP-TRANSFORMATION-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataPrototypes:
        data_prototype_in_service_interface_ref: list[DataPrototypeInServiceInterfaceRef] = field(
            default_factory=list,
            metadata={
                "name": "DATA-PROTOTYPE-IN-SERVICE-INTERFACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SomeipTransformationPropsRef(Ref):
        dest: ApSomeipTransformationPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SomeipEventDeployment:
    """
    SOME/IP configuration settings for an Event.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar event_ref: Reference to an Event that is deployed to a
        middleware transport layer.
    :ivar trigger_ref: Reference to a Trigger that is deployed to a
        middleware transport layer.
    :ivar burst_size: Specifies the number of segments that shall be
        transmitted in a burst ignoring separationTime. SeparationTime
        will then only be applied between bursts. If not configured,
        SeparationTime will be applied between all frames.
    :ivar event_id: Unique Identifier within a ServiceInterface that
        identifies the Event in SOME/IP. This Identifier is sent as part
        of the Message ID in SOME/IP messages.
    :ivar maximum_segment_length: This attribute describes the length in
        bytes of the SOME/IP segment. This includes 8 bytes for the
        Request ID, Protocol Version, Interface Version, Message Type
        and Return Code and 4 additional SOME/IP TP bytes. If this
        attribute is set to a value and the data length is larger than
        maximumSegmentLength then the corresponding SOME/IP message will
        be segmented into smaller parts that are transmitted over the
        network.
    :ivar separation_time: Sets the duration of the minimum time in
        seconds SOME/IP shall wait between the transmissions of
        segments.
    :ivar serializer: Defines which serialization technology shall be
        used.
    :ivar transport_protocol: This attribute defines over which
        Transport Layer Protocol this event is intended to be sent.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-EVENT-DEPLOYMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipEventDeployment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipEventDeployment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["SomeipEventDeployment.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_ref: Optional["SomeipEventDeployment.TriggerRef"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    burst_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BURST-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "EVENT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_segment_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-SEGMENT-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    separation_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SEPARATION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    serializer: SerializationTechnologyEnum | None = field(
        default=None,
        metadata={
            "name": "SERIALIZER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transport_protocol: TransportLayerProtocolEnum | None = field(
        default=None,
        metadata={
            "name": "TRANSPORT-PROTOCOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SomeipEventGroup:
    """
    Grouping of events and notification events inside a ServiceInterface in order
    to allow subscriptions.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar event_group_id: Unique Identifier that identifies the
        EventGroup in SOME/IP. This Identifier is sent as Eventgroup ID
        in SOME/IP Service Discovery messages.
    :ivar event_refs: Reference to an event that is part of the
        EventGroup.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-EVENT-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipEventGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipEventGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_refs: Optional["SomeipEventGroup.EventRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventRefs:
        event_ref: list["SomeipEventGroup.EventRefs.EventRef"] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EventRef(Ref):
            dest: SomeipEventDeploymentSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SomeipMethodDeployment:
    """
    SOME/IP configuration settings for a Method.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar method_ref: Reference to a method that is deployed to a
        middleware transport layer.
    :ivar burst_size_request: Specifies the number of segments for the
        Method Call that shall be transmitted in a burst ignoring
        separationTime. SeparationTime will then only be applied between
        bursts. If not configured, SeparationTime will be applied
        between all frames.
    :ivar burst_size_response: Specifies the number of segments for the
        Method Response that shall be transmitted in a burst ignoring
        separationTime. SeparationTime will then only be applied between
        bursts. If not configured, SeparationTime will be applied
        between all frames.
    :ivar maximum_segment_length_request: This attribute describes the
        length in bytes of one SOME/IP segment into which the Method
        Call Message will be divided. This length field includes 8 bytes
        for the Request ID, Protocol Version, Interface Version, Message
        Type and Return Code and 4 additional SOME/IP TP bytes. If this
        attribute is set to a value and the data length is larger than
        maximumSegmentLengthRequest then the corresponding SOME/IP
        message will be segmented into smaller parts that are
        transmitted over the network.
    :ivar maximum_segment_length_response: This attribute describes the
        length in bytes of one SOME/IP segment into which the Method
        Return Message will be divided. This length field includes 8
        bytes for the Request ID, Protocol Version, Interface Version,
        Message Type and Return Code and 4 additional SOME/IP TP bytes.
        If this attribute is set to a value and the data length is
        larger than maximumSegmentLengthResponse then the corresponding
        SOME/IP message will be segmented into smaller parts that are
        transmitted over the network.
    :ivar method_id: Unique Identifier within a ServiceInterface that
        identifies the Method in SOME/IP. This Identifier is sent as
        part of the Message ID in SOME/IP messages.
    :ivar separation_time_request: Sets the duration of the minimum time
        in seconds SOME/IP shall wait between the transmissions of
        segments into which the Method Call Message will be divided.
    :ivar separation_time_response: Sets the duration of the minimum
        time in seconds SOME/IP shall wait between the transmissions of
        segments into which the Method Return Message will be divided.
    :ivar transport_protocol: This attribute defines over which
        Transport Layer Protocol this method is intended to be sent.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-METHOD-DEPLOYMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipMethodDeployment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipMethodDeployment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_ref: Optional["SomeipMethodDeployment.MethodRef"] = field(
        default=None,
        metadata={
            "name": "METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    burst_size_request: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BURST-SIZE-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    burst_size_response: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BURST-SIZE-RESPONSE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_segment_length_request: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-SEGMENT-LENGTH-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_segment_length_response: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-SEGMENT-LENGTH-RESPONSE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "METHOD-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    separation_time_request: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SEPARATION-TIME-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    separation_time_response: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SEPARATION-TIME-RESPONSE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transport_protocol: TransportLayerProtocolEnum | None = field(
        default=None,
        metadata={
            "name": "TRANSPORT-PROTOCOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MethodRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SomeipProvidedEventGroup:
    """
    The meta-class represents the ability to configure ServiceInstance related
    communication settings on the provided side for each EventGroup separately.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar event_group_ref: Reference to the SomeipEventGroup in the
        System Manifest for which the ServiceInstance related EventGroup
        settings are valid.
    :ivar event_multicast_udp_port: UdpPort configuration that is used
        for Event communication in the IP-Multicast case. During SOME/IP
        Service Discovery: Send in the SD-SubscribeEventGroupAck Message
        to client (answer to SD-SubscribeEventGroup). Event: This is the
        destination-port where the server sends the multicast event
        messages if the multicastThreshold is exceeded.
    :ivar ipv_4_multicast_ip_address: Multicast IPv4 Address that is
        transmitted in the EventGroupSubscribeAck message.
    :ivar ipv_6_multicast_ip_address: Multicast IPv6 Address that is
        transmitted in the EventGroupSubscribeAck message.
    :ivar multicast_threshold: Specifies the number of subscribed
        clients that trigger the server to change the transmission of
        events to multicast. Example: If configured to 0 only unicast
        will be used. If configured to 1 the first client will be
        already served by multicast. If configured to 2 the first client
        will be served with unicast and as soon as the 2nd client
        arrives both will be served by multicast. This does not
        influence the handling of initial events, which are served using
        unicast only.
    :ivar sd_server_event_group_timing_config_ref: Server Timing
        configuration settings that are EventGroup specific.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-PROVIDED-EVENT-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipProvidedEventGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipProvidedEventGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_ref: Optional["SomeipProvidedEventGroup.EventGroupRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_multicast_udp_port: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "EVENT-MULTICAST-UDP-PORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_4_multicast_ip_address: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "IPV-4-MULTICAST-IP-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_6_multicast_ip_address: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "IPV-6-MULTICAST-IP-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multicast_threshold: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MULTICAST-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sd_server_event_group_timing_config_ref: Optional[
        "SomeipProvidedEventGroup.SdServerEventGroupTimingConfigRef"
    ] = field(
        default=None,
        metadata={
            "name": "SD-SERVER-EVENT-GROUP-TIMING-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventGroupRef(Ref):
        dest: SomeipEventGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SdServerEventGroupTimingConfigRef(Ref):
        dest: SomeipSdServerEventGroupTimingConfigSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SomeipRemoteMulticastConfig:
    """
    This  meta-class is used  to statically configure the remote peer's multicast
    address.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar event_group_refs: Reference to the SomeipEventGroups this
        SomeipRemoteMulticastConfig applies to.
    :ivar ipv_4_address: This attribute defines the multicast IPv4
        address to allow a static service connection between Service
        Provider and Service Consumers.
    :ivar ipv_6_address: This attribute defines the multicast IPv6
        address to allow a static service connection between Service
        Provider and Service Consumers.
    :ivar udp_port: This attribute defines the udpPort used for the
        multicast communication.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-REMOTE-MULTICAST-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipRemoteMulticastConfig.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipRemoteMulticastConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_refs: Optional["SomeipRemoteMulticastConfig.EventGroupRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_4_address: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "IPV-4-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_6_address: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "IPV-6-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    udp_port: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UDP-PORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventGroupRefs:
        event_group_ref: list["SomeipRemoteMulticastConfig.EventGroupRefs.EventGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EventGroupRef(Ref):
            dest: SomeipEventGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SomeipRemoteUnicastConfig:
    """
    This meta-class is used  to statically configure the remote peer's unicast
    address in case that a static service connection is used and only a single
    remote peer exists.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar event_group_refs: Reference to the SomeipEventGroups this
        SomeipRemoteUnicatConfig applies to.
    :ivar ipv_4_address: This attribute defines the IPv4 address of the
        remote peer to allow a static service connection between Service
        Provider and Service Consumer.
    :ivar ipv_6_address: This attribute defines the IPv6 address of the
        remote peer to allow a static service connection between Service
        Provider and Service Consumer.
    :ivar tcp_port: This attribute defines the tcpPort of the remote
        peer to allow a static service connection between Service
        Provider and Service Consumer.
    :ivar udp_port: This attribute defines the udpPort of the remote
        peer to allow a static service connection between Service
        Provider and Service Consumer.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-REMOTE-UNICAST-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipRemoteUnicastConfig.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipRemoteUnicastConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_refs: Optional["SomeipRemoteUnicastConfig.EventGroupRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_4_address: Ip4AddressString | None = field(
        default=None,
        metadata={
            "name": "IPV-4-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_6_address: Ip6AddressString | None = field(
        default=None,
        metadata={
            "name": "IPV-6-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_port: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TCP-PORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    udp_port: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UDP-PORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventGroupRefs:
        event_group_ref: list["SomeipRemoteUnicastConfig.EventGroupRefs.EventGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EventGroupRef(Ref):
            dest: SomeipEventGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SomeipSdClientEventGroupTimingConfig:
    """
    This meta-class is used to specify configuration related to service discovery
    in the context of an event group on SOME/IP.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar request_response_delay: The Service Discovery shall delay
        answers to unicast messages triggered by multicast messages
        (e.g. Subscribe Eventgroup after Offer Service).
    :ivar subscribe_eventgroup_retry_delay: This attribute defines the
        interval in seconds to re-trigger a subscription to a
        Eventgroup, if a retry to subscribe to a Eventgroup is
        configured (subscribeEventgroupRetryMax &gt; 0).
    :ivar subscribe_eventgroup_retry_max: This attribute define the
        maximum counts of retries to subscribe to an Eventgroup. If the
        value is set to 0 no retry shall be done. If the value is set to
        255 the retry shall be done as along as the Eventgroup is
        requested and no SubscribeEventGroupAck was received.
    :ivar time_to_live: Defines the time in seconds the subscription of
        this event is expected by the client. this value is sent from
        the client to the server in the SD-subscribeEvent message.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-SD-CLIENT-EVENT-GROUP-TIMING-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipSdClientEventGroupTimingConfig.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipSdClientEventGroupTimingConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_response_delay: RequestResponseDelay | None = field(
        default=None,
        metadata={
            "name": "REQUEST-RESPONSE-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    subscribe_eventgroup_retry_delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SUBSCRIBE-EVENTGROUP-RETRY-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    subscribe_eventgroup_retry_max: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SUBSCRIBE-EVENTGROUP-RETRY-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_to_live: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TIME-TO-LIVE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SomeipSdClientEventGroupTimingConfigRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar someip_sd_client_event_group_timing_config_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-SD-CLIENT-EVENT-GROUP-TIMING-CONFIG-REF-CONDITIONAL"

    someip_sd_client_event_group_timing_config_ref: Optional[
        "SomeipSdClientEventGroupTimingConfigRefConditional.SomeipSdClientEventGroupTimingConfigRef"
    ] = field(
        default=None,
        metadata={
            "name": "SOMEIP-SD-CLIENT-EVENT-GROUP-TIMING-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SomeipSdClientEventGroupTimingConfigRef(Ref):
        dest: SomeipSdClientEventGroupTimingConfigSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SomeipSdClientServiceInstanceConfig:
    """
    Client specific settings that are relevant for the configuration of SOME/IP
    Service-Discovery.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar initial_find_behavior: Controls initial find behavior of
        clients.
    :ivar priority: This attribute defines the VLAN frame priority for
        Service Discovery messages that result  from
        RequiredSomeipServiceInstances that are referncing this
        SomeipSdClientServiceInstanceConfig (Find, SubscribeEventGroup,
        StopSubscribeEventgroup). Values from 0 (best effort) to 7
        (highest) are allowed.
    :ivar service_find_time_to_live: This attribute represents the
        ability to define the time in seconds the service find is valid.
        Note! The TTL value for FindService entries is not used and
        shall be ignored by the server service.  This configuration is
        only kept for backward compatibility. Default value if not
        specified shall be 0xFFFFFF.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-SD-CLIENT-SERVICE-INSTANCE-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipSdClientServiceInstanceConfig.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipSdClientServiceInstanceConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_find_behavior: InitialSdDelayConfig | None = field(
        default=None,
        metadata={
            "name": "INITIAL-FIND-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_find_time_to_live: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SERVICE-FIND-TIME-TO-LIVE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SomeipSdClientServiceInstanceConfigRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar someip_sd_client_service_instance_config_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-SD-CLIENT-SERVICE-INSTANCE-CONFIG-REF-CONDITIONAL"

    someip_sd_client_service_instance_config_ref: Optional[
        "SomeipSdClientServiceInstanceConfigRefConditional.SomeipSdClientServiceInstanceConfigRef"
    ] = field(
        default=None,
        metadata={
            "name": "SOMEIP-SD-CLIENT-SERVICE-INSTANCE-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SomeipSdClientServiceInstanceConfigRef(Ref):
        dest: SomeipSdClientServiceInstanceConfigSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SomeipSdServerEventGroupTimingConfig:
    """
    EventGroup specific timing configuration settings.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar request_response_delay: The Service Discovery shall delay
        answers to unicast messages triggered by multicast messages
        (e.g. Subscribe Eventgroup after Offer Service).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-SD-SERVER-EVENT-GROUP-TIMING-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipSdServerEventGroupTimingConfig.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipSdServerEventGroupTimingConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_response_delay: RequestResponseDelay | None = field(
        default=None,
        metadata={
            "name": "REQUEST-RESPONSE-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SomeipSdServerEventGroupTimingConfigRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar someip_sd_server_event_group_timing_config_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-SD-SERVER-EVENT-GROUP-TIMING-CONFIG-REF-CONDITIONAL"

    someip_sd_server_event_group_timing_config_ref: Optional[
        "SomeipSdServerEventGroupTimingConfigRefConditional.SomeipSdServerEventGroupTimingConfigRef"
    ] = field(
        default=None,
        metadata={
            "name": "SOMEIP-SD-SERVER-EVENT-GROUP-TIMING-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SomeipSdServerEventGroupTimingConfigRef(Ref):
        dest: SomeipSdServerEventGroupTimingConfigSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SomeipSdServerServiceInstanceConfig:
    """
    Server specific settings that are relevant for the configuration of SOME/IP
    Service-Discovery.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar initial_offer_behavior: Controls offer behavior of the server.
    :ivar offer_cyclic_delay: Optional attribute to define cyclic
        offers. Cyclic offer is active, if the delay is set (in seconds)
        and greater then 0.
    :ivar priority: This attribute defines the VLAN frame priority for
        Service Discovery messages that result from
        ProvidedSomeipServiceInstances that are referencing the
        SomeipSdServerServiceInstanceConfig (OfferService,
        StopOfferService, SubscribeEventGroupAck). Values from 0 (best
        effort) to 7 (highest) are allowed.
    :ivar request_response_delay: Maximum/Minimum allowable response
        delay to entries received by multicast in seconds. The Service
        Discovery shall delay answers to entries that were transported
        in a multicast SOME/IP-SD message (e.g. FindService).
    :ivar service_offer_time_to_live: Defines the time in seconds the
        service offer is valid.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-SD-SERVER-SERVICE-INSTANCE-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipSdServerServiceInstanceConfig.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipSdServerServiceInstanceConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_offer_behavior: InitialSdDelayConfig | None = field(
        default=None,
        metadata={
            "name": "INITIAL-OFFER-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offer_cyclic_delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "OFFER-CYCLIC-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_response_delay: RequestResponseDelay | None = field(
        default=None,
        metadata={
            "name": "REQUEST-RESPONSE-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_offer_time_to_live: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SERVICE-OFFER-TIME-TO-LIVE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SomeipSdServerServiceInstanceConfigRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar someip_sd_server_service_instance_config_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-SD-SERVER-SERVICE-INSTANCE-CONFIG-REF-CONDITIONAL"

    someip_sd_server_service_instance_config_ref: Optional[
        "SomeipSdServerServiceInstanceConfigRefConditional.SomeipSdServerServiceInstanceConfigRef"
    ] = field(
        default=None,
        metadata={
            "name": "SOMEIP-SD-SERVER-SERVICE-INSTANCE-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SomeipSdServerServiceInstanceConfigRef(Ref):
        dest: SomeipSdServerServiceInstanceConfigSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SomeipServiceInstanceToMachineMapping:
    """This meta-class allows to map SomeipServiceInstances to a
    CommunicationConnector of a Machine.

    In this step the network configuration (IP Address, Transport
    Protocol, Port Number) for the ServiceInstance is defined.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_connector_ref: Reference to the Machine to which
        the ServiceInstance is mapped.
    :ivar sec_oc_com_props_for_multicast_refs: Reference to
        communication security configuration settings that are valid for
        the udp multicast endpoint (Port + Multicast IP Address) defined
        by the ServiceInstanceToMachineMapping.
    :ivar secure_com_props_for_tcp_ref: Reference to communication
        security configuration settings that are valid for the tcp
        unicast endpoint (Tcp Port + Unicast IP Address) defined by the
        ServiceInstanceToMachineMapping.
    :ivar secure_com_props_for_udp_ref: Reference to communication
        security configuration settings that are valid for the udp
        unicast endpoint (Udp Port + Unicast IP Address) defined by the
        ServiceInstanceToMachineMapping.
    :ivar service_instance_refs: Reference to a ServiceInstance that is
        mapped to the Machine.
    :ivar remote_multicast_config_refs: This reference defines a remote
        multicast Address (IP Address, Port) that is used in a static
        configuration to setup the communication path between a service
        provider and service consumer. This reference shall ONLY be used
        if the remote address is determined from the configuration and
        not at runtime from the Service Discovery.
    :ivar remote_unicast_config_refs: In case that a static service
        connection is used and a single peer exists this element is used
        to statically configure the remote peer's address.
    :ivar tcp_port_ref: local TcpPort that will be used by the
        ServiceInstance for the communication.
    :ivar udp_collection_buffer_size_threshold: Specifies the amount of
        data in bytes that shall be buffered for data transmission over
        the udp connection specified by this
        SomeipServiceInstanceToMachineMapping in case data collection is
        enabled.
    :ivar udp_port_ref: local UdpPort that will be used by the
        ServiceInstance for the communication.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-SERVICE-INSTANCE-TO-MACHINE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipServiceInstanceToMachineMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipServiceInstanceToMachineMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_ref: Optional[
        "SomeipServiceInstanceToMachineMapping.CommunicationConnectorRef"
    ] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sec_oc_com_props_for_multicast_refs: Optional[
        "SomeipServiceInstanceToMachineMapping.SecOcComPropsForMulticastRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SEC-OC-COM-PROPS-FOR-MULTICAST-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_com_props_for_tcp_ref: Optional[
        "SomeipServiceInstanceToMachineMapping.SecureComPropsForTcpRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECURE-COM-PROPS-FOR-TCP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_com_props_for_udp_ref: Optional[
        "SomeipServiceInstanceToMachineMapping.SecureComPropsForUdpRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECURE-COM-PROPS-FOR-UDP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_refs: Optional["SomeipServiceInstanceToMachineMapping.ServiceInstanceRefs"] = (
        field(
            default=None,
            metadata={
                "name": "SERVICE-INSTANCE-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    remote_multicast_config_refs: Optional[
        "SomeipServiceInstanceToMachineMapping.RemoteMulticastConfigRefs"
    ] = field(
        default=None,
        metadata={
            "name": "REMOTE-MULTICAST-CONFIG-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_unicast_config_refs: Optional[
        "SomeipServiceInstanceToMachineMapping.RemoteUnicastConfigRefs"
    ] = field(
        default=None,
        metadata={
            "name": "REMOTE-UNICAST-CONFIG-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_port_ref: Optional["SomeipServiceInstanceToMachineMapping.TcpPortRef"] = field(
        default=None,
        metadata={
            "name": "TCP-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    udp_collection_buffer_size_threshold: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UDP-COLLECTION-BUFFER-SIZE-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    udp_port_ref: Optional["SomeipServiceInstanceToMachineMapping.UdpPortRef"] = field(
        default=None,
        metadata={
            "name": "UDP-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecOcComPropsForMulticastRefs:
        sec_oc_com_props_for_multicast_ref: list[
            "SomeipServiceInstanceToMachineMapping.SecOcComPropsForMulticastRefs.SecOcComPropsForMulticastRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SEC-OC-COM-PROPS-FOR-MULTICAST-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SecOcComPropsForMulticastRef(Ref):
            dest: SecOcSecureComPropsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SecureComPropsForTcpRef(Ref):
        dest: SecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecureComPropsForUdpRef(Ref):
        dest: SecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRefs:
        service_instance_ref: list[
            "SomeipServiceInstanceToMachineMapping.ServiceInstanceRefs.ServiceInstanceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceInstanceRef(Ref):
            dest: AdaptivePlatformServiceInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RemoteMulticastConfigRefs:
        remote_multicast_config_ref: list[
            "SomeipServiceInstanceToMachineMapping.RemoteMulticastConfigRefs.RemoteMulticastConfigRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "REMOTE-MULTICAST-CONFIG-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RemoteMulticastConfigRef(Ref):
            dest: SomeipRemoteMulticastConfigSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RemoteUnicastConfigRefs:
        remote_unicast_config_ref: list[
            "SomeipServiceInstanceToMachineMapping.RemoteUnicastConfigRefs.RemoteUnicastConfigRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "REMOTE-UNICAST-CONFIG-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RemoteUnicastConfigRef(Ref):
            dest: SomeipRemoteUnicastConfigSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TcpPortRef(Ref):
        dest: ApApplicationEndpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class UdpPortRef(Ref):
        dest: ApApplicationEndpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SomeipTpChannel:
    """
    This element is used to assign properties to SomeipTpConnections that are
    referencing this SomeipTpChannel.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar burst_size: Specifies the number of segments that shall be
        transmitted in a burst ignoring separationTime. SeparationTime
        will then only be applied between bursts. If not configured,
        SeparationTime will be applied between all frames.
    :ivar rx_timeout_time: Timer to monitor the successful reception. It
        is started when the first NPdu is received, restarted after
        reception of intermediate NPdus, and is stopped when the last
        NPdu has been received.
    :ivar separation_time: Sets the duration of the minimum time in
        seconds the SOME/IP TP module shall wait between the
        transmissions of NPdus.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-TP-CHANNEL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipTpChannel.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipTpChannel.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    burst_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BURST-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rx_timeout_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "RX-TIMEOUT-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    separation_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SEPARATION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SomeipTransformationDescription:
    """
    The SOMEIPTransformationDescription is used to specify SOME/IP transformer
    specific attributes.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TransformationTechnology.transformationDescription
    :ivar alignment: Defines the padding for alignment purposes that
        will be added by the SOME/IP transformer after the serialized
        data of the variable data length data element. The alignment
        shall be specified in Bits.
    :ivar byte_order: Defines which byte order shall be serialized by
        the SOME/IP transformer
    :ivar interface_version: The interface version the SOME/IP
        transformer shall use.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-TRANSFORMATION-DESCRIPTION"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alignment: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ALIGNMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    byte_order: ByteOrderEnum | None = field(
        default=None,
        metadata={
            "name": "BYTE-ORDER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    interface_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INTERFACE-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SomeipTransformationISignalPropsConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar cs_error_reaction: Defines whether the transformer chain of
        client/server communication coordinates an autonomous error
        reaction together with the RTE or whether any error reaction is
        the responsibility of the application.
    :ivar data_prototype_transformation_propss: Fine granular modeling
        of TransfromationProps on the level of DataPrototypes.
    :ivar transformer_ref: Reference to the TransformationTechnology
        description that contains transformer specific and ISignal
        independent configuration properties.
    :ivar implements_legacy_string_serialization: This attribute
        indicates that Strings in the SOME/IP message shall NOT be
        serialized according to the SOME/IP specification for Strings.
        If this attribute is set to true, BOM and null-termination shall
        NOT be added in the serialization for Strings in the payload. If
        this attribute is set to false (or not set) BOM and null-
        termination shall be added in the serialization for Strings in
        the payload according to the SOME/IP specification for Strings.
        NOTE! This attribute is not future safe, and will be removed in
        an upcoming AUTOSAR release!"
    :ivar implements_someip_string_handling: This attribute indicates
        whether Strings in the SOME/IP message shall be processed
        according to the SOME/IP specification for Strings. This
        attribute has been introduced due to compatibility reasons for
        AUTOSAR before R4.3. If this attribute is set to true Strings in
        the payload shall be handled according to the SOME/IP
        specification on Strings. If this attribute is set to false (or
        not set) no special handling for Strings in the payload shall be
        performed.
    :ivar interface_version: The interface version the SOME/IP
        transformer shall use.
    :ivar is_dynamic_length_field_size: This attribute shall be used to
        determine the wire type in the context of using the TLV
        encoding.
    :ivar message_type: The Message Type which shall be placed into the
        SOME/IP header.
    :ivar session_handling_sr: Defines whether the SOME/IP transformer
        shall use session handling for Sender/Receiver communication.
    :ivar size_of_array_length_fields: The size of all length fields (in
        Bytes) of fixed-size arrays or dynamic size arrays in the
        SOME/IP message. This attribute is valid for all available
        occurrences of fixed-size arrays or dynamic size arrays in the
        SOME/IP message.
    :ivar size_of_string_length_fields: The size of all length fields
        (in Bytes) of dynamic length strings in the SOME/IP message.
        This attribute is valid for all available occurrences of strings
        in the SOME/IP message.
    :ivar size_of_struct_length_fields: The size of all length fields
        (in Bytes) of structs in the SOME/IP message. This attribute is
        valid for all available occurrences of structures in the SOME/IP
        message. For a more fine granular modeling on the level of
        DataPrototypes the DataPrototypeTransformationProps shall be
        used.
    :ivar size_of_union_length_fields: The size of all length fields (in
        Bytes) of unions in the SOME/IP message. This attribute is valid
        for all available occurrences of Unions in the SOME/IP message.
        For a more fine granular modeling on the level of DataPrototypes
        the DataPrototypeTransformationProps shall be used.
    :ivar tlv_data_ids: This aggregation represents the collection of
        tlvDataIds defined in the enclosing context.
    :ivar tlv_data_id_0_refs: This reference identifies the
        TlvDataIdDefinitions relevant for the enclosing
        SOMEIPTransformationISignalProps.
    :ivar tlv_data_id_definition_refs: This reference identifies the
        TlvDataIdDefinitions relevant for the enclosing
        SOMEIPTransformationISignalProps
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-TRANSFORMATION-I-SIGNAL-PROPS-CONDITIONAL"

    cs_error_reaction: CsTransformerErrorReactionEnum | None = field(
        default=None,
        metadata={
            "name": "CS-ERROR-REACTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototype_transformation_propss: Optional[
        "SomeipTransformationISignalPropsConditional.DataPrototypeTransformationPropss"
    ] = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-TRANSFORMATION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformer_ref: Optional["SomeipTransformationISignalPropsConditional.TransformerRef"] = field(
        default=None,
        metadata={
            "name": "TRANSFORMER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implements_legacy_string_serialization: Boolean | None = field(
        default=None,
        metadata={
            "name": "IMPLEMENTS-LEGACY-STRING-SERIALIZATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implements_someip_string_handling: Boolean | None = field(
        default=None,
        metadata={
            "name": "IMPLEMENTS-SOMEIP-STRING-HANDLING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    interface_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INTERFACE-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_dynamic_length_field_size: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-DYNAMIC-LENGTH-FIELD-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    message_type: SomeipMessageTypeEnum | None = field(
        default=None,
        metadata={
            "name": "MESSAGE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    session_handling_sr: SomeipTransformerSessionHandlingEnum | None = field(
        default=None,
        metadata={
            "name": "SESSION-HANDLING-SR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size_of_array_length_fields: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE-OF-ARRAY-LENGTH-FIELDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size_of_string_length_fields: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE-OF-STRING-LENGTH-FIELDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size_of_struct_length_fields: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE-OF-STRUCT-LENGTH-FIELDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size_of_union_length_fields: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE-OF-UNION-LENGTH-FIELDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tlv_data_ids: Optional["SomeipTransformationISignalPropsConditional.TlvDataIds"] = field(
        default=None,
        metadata={
            "name": "TLV-DATA-IDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tlv_data_id_0_refs: Optional["SomeipTransformationISignalPropsConditional.TlvDataId0Refs"] = (
        field(
            default=None,
            metadata={
                "name": "TLV-DATA-ID-0-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    tlv_data_id_definition_refs: Optional[
        "SomeipTransformationISignalPropsConditional.TlvDataIdDefinitionRefs"
    ] = field(
        default=None,
        metadata={
            "name": "TLV-DATA-ID-DEFINITION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataPrototypeTransformationPropss:
        data_prototype_transformation_props: list[DataPrototypeTransformationProps] = field(
            default_factory=list,
            metadata={
                "name": "DATA-PROTOTYPE-TRANSFORMATION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TransformerRef(Ref):
        dest: TransformationTechnologySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TlvDataIds:
        tlv_data_id_definition: list[TlvDataIdDefinition] = field(
            default_factory=list,
            metadata={
                "name": "TLV-DATA-ID-DEFINITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TlvDataId0Refs:
        tlv_data_id_0_ref: list[
            "SomeipTransformationISignalPropsConditional.TlvDataId0Refs.TlvDataId0Ref"
        ] = field(
            default_factory=list,
            metadata={
                "name": "TLV-DATA-ID-0-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TlvDataId0Ref(Ref):
            dest: TlvDataIdDefinitionSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TlvDataIdDefinitionRefs:
        tlv_data_id_definition_ref: list[
            "SomeipTransformationISignalPropsConditional.TlvDataIdDefinitionRefs.TlvDataIdDefinitionRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "TLV-DATA-ID-DEFINITION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TlvDataIdDefinitionRef(Ref):
            dest: TlvDataIdDefinitionSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SomeipTransformationProps:
    """
    The class SOMEIPTransformationProps specifies SOME/IP specific configuration
    properties.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alignment: Defines the padding for alignment purposes that
        will be added by the SOME/IP transformer after the serialized
        data of the variable data length data element. The alignment
        shall be specified in Bits.
    :ivar size_of_array_length_field: This attribute describes the size
        of the length field (in Bytes) that will be put in front of the
        referenced Array in the SOME/IP message.
    :ivar size_of_string_length_field: This attribute describes the size
        of the length field (in Bytes) that will be put in front of the
        referenced String in the SOME/IP message.
    :ivar size_of_struct_length_field: This attribute describes the size
        of the length field (in Bytes) that will be put in front of a
        Structure in the SOME/IP message.
    :ivar size_of_union_length_field: This attribute describes the size
        of the length field (in Bytes) that will be put in front of a
        Union in the SOME/IP message.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-TRANSFORMATION-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipTransformationProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipTransformationProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alignment: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ALIGNMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size_of_array_length_field: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE-OF-ARRAY-LENGTH-FIELD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size_of_string_length_field: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE-OF-STRING-LENGTH-FIELD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size_of_struct_length_field: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE-OF-STRUCT-LENGTH-FIELD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    size_of_union_length_field: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SIZE-OF-UNION-LENGTH-FIELD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SovdGatewayInstantiation:
    """
    This meta-class represents the configuration of an SOVD gateway.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_connector_refs: This reference identifies the
        collection of communication connectors used by the SOVD module
        instantiation for vehicle-internal communication.
    :ivar node_identifier: This attribute represents the local hostname
        of the SOVD server to be used during the execution of the DNS-SD
        protocol.
    :ivar secure_props_for_tcp_ref: This reference is used to identify
        the applicable TCP secure com properties for the external
        communication of the enclosing SOVD server.
    :ivar secure_props_for_udp_ref: This reference is used to identify
        the applicable UDP secure com properties for the external
        communication of the enclosing SOVD server.
    :ivar secure_props_for_external_comm_ref: This reference is used to
        identify the applicable secure com properties for the external
        communication of the enclosing SOVD gateway.
    :ivar unicast_credentials: This aggragtion is used to to describe
        the unicast credentials for external (i.e. with a tester)
        communication of the enclosing SOVD gateway.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOVD-GATEWAY-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SovdGatewayInstantiation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SovdGatewayInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_refs: Optional[
        "SovdGatewayInstantiation.CommunicationConnectorRefs"
    ] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    node_identifier: String | None = field(
        default=None,
        metadata={
            "name": "NODE-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_props_for_tcp_ref: Optional["SovdGatewayInstantiation.SecurePropsForTcpRef"] = field(
        default=None,
        metadata={
            "name": "SECURE-PROPS-FOR-TCP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_props_for_udp_ref: Optional["SovdGatewayInstantiation.SecurePropsForUdpRef"] = field(
        default=None,
        metadata={
            "name": "SECURE-PROPS-FOR-UDP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_props_for_external_comm_ref: Optional[
        "SovdGatewayInstantiation.SecurePropsForExternalCommRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECURE-PROPS-FOR-EXTERNAL-COMM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unicast_credentials: SovdGatewayLocalEndpointTcpConfig | None = field(
        default=None,
        metadata={
            "name": "UNICAST-CREDENTIALS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRefs:
        communication_connector_ref: list[
            "SovdGatewayInstantiation.CommunicationConnectorRefs.CommunicationConnectorRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "COMMUNICATION-CONNECTOR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CommunicationConnectorRef(Ref):
            dest: CommunicationConnectorSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SecurePropsForTcpRef(Ref):
        dest: SecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecurePropsForUdpRef(Ref):
        dest: SecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecurePropsForExternalCommRef(Ref):
        dest: SecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SovdServerInstantiation:
    """
    This meta-class represents the configuration of an SOVD server.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_connector_refs: This reference identifies the
        collection of communication connectors used by the SOVD module
        instantiation for vehicle-internal communication.
    :ivar node_identifier: This attribute represents the local hostname
        of the SOVD server to be used during the execution of the DNS-SD
        protocol.
    :ivar secure_props_for_tcp_ref: This reference is used to identify
        the applicable TCP secure com properties for the external
        communication of the enclosing SOVD server.
    :ivar secure_props_for_udp_ref: This reference is used to identify
        the applicable UDP secure com properties for the external
        communication of the enclosing SOVD server.
    :ivar component_qualifier: This attributes described the component
        qualifier used to compose an SOVD query.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOVD-SERVER-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SovdServerInstantiation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SovdServerInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_refs: Optional["SovdServerInstantiation.CommunicationConnectorRefs"] = (
        field(
            default=None,
            metadata={
                "name": "COMMUNICATION-CONNECTOR-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    node_identifier: String | None = field(
        default=None,
        metadata={
            "name": "NODE-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_props_for_tcp_ref: Optional["SovdServerInstantiation.SecurePropsForTcpRef"] = field(
        default=None,
        metadata={
            "name": "SECURE-PROPS-FOR-TCP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_props_for_udp_ref: Optional["SovdServerInstantiation.SecurePropsForUdpRef"] = field(
        default=None,
        metadata={
            "name": "SECURE-PROPS-FOR-UDP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_qualifier: String | None = field(
        default=None,
        metadata={
            "name": "COMPONENT-QUALIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRefs:
        communication_connector_ref: list[
            "SovdServerInstantiation.CommunicationConnectorRefs.CommunicationConnectorRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "COMMUNICATION-CONNECTOR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CommunicationConnectorRef(Ref):
            dest: CommunicationConnectorSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SecurePropsForTcpRef(Ref):
        dest: SecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecurePropsForUdpRef(Ref):
        dest: SecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SporadicEventTriggering:
    """
    The SporadicEventTriggering describes the behavior of an event which occurs
    occasionally or singly.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar timing_condition_ref: A timing condition the timing constraint
        depends on. In other words it specifies the condition the timing
        constraint holds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingRequirement Applicable for:
        TimingExtension.timingGuarantee
    :ivar event_ref: The referenced timing event
    :ivar minimum_inter_arrival_time: The minimum time distance between
        two consecutive occurrences of the associated event.
    :ivar maximum_inter_arrival_time: The maximum time distance between
        two consecutive occurrences of the associated event.
    :ivar jitter: The maximum jitter of the sporadic event occurrence.
        Jitter=max |nthPeriod - standardPeriod|
    :ivar period: The period of the event occurrence.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SPORADIC-EVENT-TRIGGERING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SporadicEventTriggering.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SporadicEventTriggering.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["SporadicEventTriggering.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_condition_ref: Optional["SporadicEventTriggering.TimingConditionRef"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["SporadicEventTriggering.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_inter_arrival_time: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-INTER-ARRIVAL-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_inter_arrival_time: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-INTER-ARRIVAL-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    jitter: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "JITTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    period: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["SporadicEventTriggering.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimingConditionRef(Ref):
        dest: TimingConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: TimingDescriptionEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class StateDependentFirewall:
    """
    Firewall rules that are defined in a firewall state.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar default_action: This attribute defines a defaultAction in case
        that the VehicleMode is not yet set.
    :ivar firewall_rule_propss: Collection of firewall rules that apply
        in the vehicle mode
    :ivar firewall_state_irefs: Reference to firewall states in which
        the Firewall is active. If one of the referenced
        ModeDeclarations is the current firewall state then the firewall
        rule shall be considered as active.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-DEPENDENT-FIREWALL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StateDependentFirewall.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StateDependentFirewall.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_action: FirewallActionEnum | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-ACTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    firewall_rule_propss: Optional["StateDependentFirewall.FirewallRulePropss"] = field(
        default=None,
        metadata={
            "name": "FIREWALL-RULE-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    firewall_state_irefs: Optional["StateDependentFirewall.FirewallStateIrefs"] = field(
        default=None,
        metadata={
            "name": "FIREWALL-STATE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FirewallRulePropss:
        firewall_rule_props: list[FirewallRuleProps] = field(
            default_factory=list,
            metadata={
                "name": "FIREWALL-RULE-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FirewallStateIrefs:
        firewall_state_iref: list[FirewallStateInFirwallStateSwitchInterfaceInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "FIREWALL-STATE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StateManagemenPhmErrorInterface:
    """
    This meta-class indicates that the PortPrototype that references this class is
    used for accepting a error submissions from the platform health management.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMEN-PHM-ERROR-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StateManagemenPhmErrorInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StateManagemenPhmErrorInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["StateManagemenPhmErrorInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["StateManagemenPhmErrorInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StateManagementDiagTriggerInterface:
    """
    This meta-class indicates that the PortPrototype that references this class is
    used for accepting a state change trigger from the diagnostics management.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-DIAG-TRIGGER-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StateManagementDiagTriggerInterface.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StateManagementDiagTriggerInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["StateManagementDiagTriggerInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["StateManagementDiagTriggerInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StateManagementEmErrorInterface:
    """
    This meta-class indicates that the PortPrototype that references this class is
    used for accepting a error submissions from the execution management.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-EM-ERROR-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StateManagementEmErrorInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StateManagementEmErrorInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["StateManagementEmErrorInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["StateManagementEmErrorInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StateManagementFunctionGroupSwitchNotificationInterface:
    """
    The usage of this meta-class for typing a PortPrototype indicates that the
    PortPrototype is used for sending out a notification of a function group state
    change in the context of state management on the AUTOSAR adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar mode_group_ref: This reference identifies the
        ModeDeclarationGroup that defines the individual states that
        that can be switched to.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-FUNCTION-GROUP-SWITCH-NOTIFICATION-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "StateManagementFunctionGroupSwitchNotificationInterface.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StateManagementFunctionGroupSwitchNotificationInterface.Annotations"] = (
        field(
            default=None,
            metadata={
                "name": "ANNOTATIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional[
        "StateManagementFunctionGroupSwitchNotificationInterface.BlueprintPolicys"
    ] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["StateManagementFunctionGroupSwitchNotificationInterface.Namespaces"] = (
        field(
            default=None,
            metadata={
                "name": "NAMESPACES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_group_ref: Optional[
        "StateManagementFunctionGroupSwitchNotificationInterface.ModeGroupRef"
    ] = field(
        default=None,
        metadata={
            "name": "MODE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModeGroupRef(Ref):
        dest: ModeDeclarationGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class StateManagementSetFunctionGroupStateActionItem:
    """
    This meta-class represents a state management action item to set a specific
    state in a specific function group.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar port_prototype_iref: This reference identifies the
        PortPrototype over which the function group state switch shall
        be communicated.
    :ivar set_function_group_state_iref: This reference identifies the
        funtion group step that shall become active after the action
        step terminates.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-SET-FUNCTION-GROUP-STATE-ACTION-ITEM"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "StateManagementSetFunctionGroupStateActionItem.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StateManagementSetFunctionGroupStateActionItem.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    set_function_group_state_iref: FunctionGroupStateInFunctionGroupSetInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SET-FUNCTION-GROUP-STATE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StateManagementStateMachineActionItem:
    """
    This meta-class represents a state management action item to start or stop a
    state machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar start_iref: This reference identifies the state machine that
        shall be started when the enclosing action list item is
        executed.
    :ivar stop_iref: This reference identifies the state machine that
        shall be stopped when the enclosing action list item is
        executed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-STATE-MACHINE-ACTION-ITEM"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StateManagementStateMachineActionItem.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StateManagementStateMachineActionItem.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_iref: ModeDeclarationGroupPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "START-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    stop_iref: ModeDeclarationGroupPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "STOP-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StateManagementSyncActionItem:
    """
    This meta-class represents a state management action item to synchronize state
    machines.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-SYNC-ACTION-ITEM"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StateManagementSyncActionItem.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StateManagementSyncActionItem.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StaticPart:
    """Some parts/signals of the I-PDU may be the same regardless of the selector
    field.

    Such a part is called static part. The static part is optional.

    :ivar segment_positions: The StaticPart and the DynamicPart can be
        separated in multiple segments within the multiplexed PDU.
        Therefore the StaticPart and the DynamicPart can contain
        multiple SegmentPositions.
    :ivar i_pdu_ref: Reference to a Com IPdu which is routed to the
        IPduM module and is combined to a multiplexedPdu.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        MultiplexedIPdu.staticPart
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATIC-PART"

    segment_positions: Optional["StaticPart.SegmentPositions"] = field(
        default=None,
        metadata={
            "name": "SEGMENT-POSITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_pdu_ref: Optional["StaticPart.IPduRef"] = field(
        default=None,
        metadata={
            "name": "I-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SegmentPositions:
        segment_position: list[SegmentPosition] = field(
            default_factory=list,
            metadata={
                "name": "SEGMENT-POSITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IPduRef(Ref):
        dest: ISignalIPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class StructuredReq:
    """This represents a structured requirement.

    This is intended for a case where specific requirements for features
    are collected. Note that this can be rendered as a labeled list.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar date: This represents the date when the requirement was
        initiated.
    :ivar issued_by: This represents the person, organization or
        authority which issued the requirement.
    :ivar type_value: This attribute allows to denote the type of
        requirement to denote for example is it an "enhancement", "new
        feature" etc.
    :ivar importance: This allows to represent the importance of the
        requirement.
    :ivar description: This represents the general description of the
        requirement.
    :ivar rationale: This represents the rationale of the requirement.
    :ivar applies_to_dependencies: This attribute represents the
        platform the requirement is assigned to.
    :ivar dependencies: This represents an informal specification of
        dependencies. Note that upstream tracing should be formalized in
        the property trace provided by the superclass Traceable.
    :ivar use_case: This describes the relevant use cases. Note that
        formal references to use cases should be done in the trace
        relation.
    :ivar conflicts: This represents an informal specification of
        conflicts.
    :ivar supporting_material: This represents an informal specification
        of the supporting material.
    :ivar remark: This represents an informal remark. Note that this is
        not modeled as annotation, since these remark is still essential
        part of the requirement.
    :ivar tested_item_refs: This association represents the ability to
        trace on the same specification level. This supports for example
        the of acceptance tests.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DocumentationBlock.structuredReq
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    """

    class Meta:
        name = "STRUCTURED-REQ"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StructuredReq.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StructuredReq.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["StructuredReq.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    date: Date | None = field(
        default=None,
        metadata={
            "name": "DATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    issued_by: String | None = field(
        default=None,
        metadata={
            "name": "ISSUED-BY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_value: String | None = field(
        default=None,
        metadata={
            "name": "TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    importance: String | None = field(
        default=None,
        metadata={
            "name": "IMPORTANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    description: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "DESCRIPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rationale: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "RATIONALE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    applies_to_dependencies: Optional["StructuredReq.AppliesToDependencies"] = field(
        default=None,
        metadata={
            "name": "APPLIES-TO-DEPENDENCIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dependencies: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "DEPENDENCIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    use_case: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "USE-CASE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    conflicts: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "CONFLICTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    supporting_material: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "SUPPORTING-MATERIAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remark: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "REMARK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tested_item_refs: Optional["StructuredReq.TestedItemRefs"] = field(
        default=None,
        metadata={
            "name": "TESTED-ITEM-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["StructuredReq.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class AppliesToDependencies:
        applies_to: list[StandardNameEnum] = field(
            default_factory=list,
            metadata={
                "name": "APPLIES-TO",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TestedItemRefs:
        tested_item_ref: list["StructuredReq.TestedItemRefs.TestedItemRef"] = field(
            default_factory=list,
            metadata={
                "name": "TESTED-ITEM-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TestedItemRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SupervisedEntityCheckpointNeeds:
    """
    Specifies the abstract needs on the configuration of the Watchdog Manager to
    support a Checkpoint for a Supervised Entity.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SUPERVISED-ENTITY-CHECKPOINT-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SupervisedEntityCheckpointNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SupervisedEntityCheckpointNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SupervisedEntityCheckpointNeedsRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar supervised_entity_checkpoint_needs_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SUPERVISED-ENTITY-CHECKPOINT-NEEDS-REF-CONDITIONAL"

    supervised_entity_checkpoint_needs_ref: Optional[
        "SupervisedEntityCheckpointNeedsRefConditional.SupervisedEntityCheckpointNeedsRef"
    ] = field(
        default=None,
        metadata={
            "name": "SUPERVISED-ENTITY-CHECKPOINT-NEEDS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SupervisedEntityCheckpointNeedsRef(Ref):
        dest: SupervisedEntityCheckpointNeedsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SupervisionCheckpoint:
    """
    This element contains an instance reference to a RPortPrototype representing a
    checkpoint for Platform Health Management.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar checkpoint_id: Defines the numeric value which is used to
        identify the reporting of this SupervisionCheckpoint to the Phm.
    :ivar phm_checkpoint_iref: Instance reference to the PhmCheckpoint
        defined in the context of a PortInterface.
    :ivar process_ref: Reference to the Process this checkoint shall be
        monitored.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SUPERVISION-CHECKPOINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SupervisionCheckpoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SupervisionCheckpoint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    checkpoint_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CHECKPOINT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    phm_checkpoint_iref: PhmCheckpointInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PHM-CHECKPOINT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["SupervisionCheckpoint.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SupervisionMode:
    """
    This element defines a SupervisionMode.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar active_supervision_refs: The reference defines which
        PhmSupervisions shall be active in this specific
        SupervisionMode.
    :ivar expired_supervision_tolerance: Defines in this SupervisionMode
        the acceptable amount of time with EXPIRED supervision status of
        the enclosing GlobalSupervision before it is considered STOPPED.
    :ivar mode_condition_ref: Reference to SupervisionModeCondition
        (Condition under which the configuration made under this
        SupervisionMode are to be applied).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SUPERVISION-MODE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SupervisionMode.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SupervisionMode.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    active_supervision_refs: Optional["SupervisionMode.ActiveSupervisionRefs"] = field(
        default=None,
        metadata={
            "name": "ACTIVE-SUPERVISION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    expired_supervision_tolerance: TimeValue | None = field(
        default=None,
        metadata={
            "name": "EXPIRED-SUPERVISION-TOLERANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_condition_ref: Optional["SupervisionMode.ModeConditionRef"] = field(
        default=None,
        metadata={
            "name": "MODE-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActiveSupervisionRefs:
        active_supervision_ref: list[
            "SupervisionMode.ActiveSupervisionRefs.ActiveSupervisionRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "ACTIVE-SUPERVISION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ActiveSupervisionRef(Ref):
            dest: PhmSupervisionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ModeConditionRef(Ref):
        dest: SupervisionModeConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SupervisionModeCondition:
    """
    This element defines a SupervisionModeCondition in the context of platform
    health management contribution.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar state_references: Collection of stateReferences.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SUPERVISION-MODE-CONDITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SupervisionModeCondition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SupervisionModeCondition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    state_references: Optional["SupervisionModeCondition.StateReferences"] = field(
        default=None,
        metadata={
            "name": "STATE-REFERENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StateReferences:
        function_group_phm_state_reference: list[FunctionGroupPhmStateReference] = field(
            default_factory=list,
            metadata={
                "name": "FUNCTION-GROUP-PHM-STATE-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwAddrMethod:
    """Used to assign a common addressing method, e.g. common memory section, to
    data or code objects.

    These objects could actually live in different modules or
    components.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar memory_allocation_keyword_policy: Enumeration to specify the
        name pattern of the Memory Allocation Keyword.
    :ivar options: This attribute introduces the ability to specify
        further intended properties of the MemorySection in with the
        related objects shall be placed. These properties are handled as
        to be selected. The intended options are mentioned in the list.
        In the Memory Mapping configuration, this option list is used to
        determine an appropriate MemMapAddressingModeSet.
    :ivar section_initialization_policy: Specifies the expected
        initialization of the variables (inclusive those which are
        implementing VariableDataPrototypes). Therefore this is an
        implementation constraint for initialization code of BSW modules
        (especially RTE) as well as the start-up code which initializes
        the memory segment to which the AutosarDataPrototypes referring
        to the SwAddrMethod's are later on mapped. If the attribute is
        not defined it has the identical semantic as the attribute value
        "INIT"
    :ivar section_type: Defines the type of memory sections which can be
        associated with this addressing method.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-ADDR-METHOD"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwAddrMethod.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwAddrMethod.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["SwAddrMethod.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_allocation_keyword_policy: MemoryAllocationKeywordPolicyType | None = field(
        default=None,
        metadata={
            "name": "MEMORY-ALLOCATION-KEYWORD-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    options: Optional["SwAddrMethod.Options"] = field(
        default=None,
        metadata={
            "name": "OPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    section_initialization_policy: SectionInitializationPolicyType | None = field(
        default=None,
        metadata={
            "name": "SECTION-INITIALIZATION-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    section_type: MemorySectionType | None = field(
        default=None,
        metadata={
            "name": "SECTION-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Options:
        option: list[Identifier] = field(
            default_factory=list,
            metadata={
                "name": "OPTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwBaseType:
    """
    This meta-class represents a base type used within ECU software.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar base_type_size: Describes the length of the data type
        specified in the container in bits.
    :ivar max_base_type_size: Describes the maximum length of the
        BaseType in bits.
    :ivar base_type_encoding: This specifies, how an object of the
        current BaseType is encoded, e.g. in an ECU within a message
        sequence.
    :ivar mem_alignment: This attribute describes the alignment of the
        memory object in bits. E.g. "8" specifies, that the object in
        question is aligned to a byte while "32" specifies that it is
        aligned four byte. If the value is set to "0" the meaning shall
        be interpreted as "unspecified".
    :ivar byte_order: This attribute specifies the byte order of the
        base type.
    :ivar native_declaration: This attribute describes the declaration
        of such a base type in the native programming language,
        primarily in the Programming language C. This can then be used
        by a code generator to include the necessary declarations into a
        header file. For example BaseType with shortName:
        "MyUnsignedInt" nativeDeclaration: "unsigned short" Results in
        typedef unsigned short MyUnsignedInt; If the attribute is not
        defined the referring ImplementationDataTypes will not be
        generated as a typedef by RTE. If a nativeDeclaration type is
        given it shall fulfill the characteristic given by
        basetypeEncoding and baseTypeSize. This is required to ensure
        the consistent handling and interpretation by software
        components, RTE, COM and MCM systems.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-BASE-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwBaseType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwBaseType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["SwBaseType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    base_type_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BASE-TYPE-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_base_type_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-BASE-TYPE-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    base_type_encoding: BaseTypeEncodingString | None = field(
        default=None,
        metadata={
            "name": "BASE-TYPE-ENCODING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mem_alignment: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MEM-ALIGNMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    byte_order: ByteOrderEnum | None = field(
        default=None,
        metadata={
            "name": "BYTE-ORDER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    native_declaration: NativeDeclarationString | None = field(
        default=None,
        metadata={
            "name": "NATIVE-DECLARATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwComponentPrototype:
    """
    Role of a software component within a composition.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar type_tref: Type of the instance.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CompositionSwComponentType.component
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-COMPONENT-PROTOTYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwComponentPrototype.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwComponentPrototype.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_tref: Optional["SwComponentPrototype.TypeTref"] = field(
        default=None,
        metadata={
            "name": "TYPE-TREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TypeTref(Ref):
        dest: SwComponentTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwComponentPrototypeAssignment:
    """
    This meta-class is only required to allow for the variant modeling of an
    instanceRef.

    :ivar sw_component_iref: hierarchical tree(s) of Software Components
        belonging to this CP Software Cluster. This reference is used to
        describe the belonging SWCs if the CP Software Cluster is
        described in the context of a System,
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CpSoftwareCluster.swComponentAssignment
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-COMPONENT-PROTOTYPE-ASSIGNMENT"

    sw_component_iref: ComponentInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SW-COMPONENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SwGenericAxisParamType:
    """This meta-class describes a generic axis parameter type, namely:

    * Plausibility checks can be specified via dataConstr.
    * Textual description (desc), as a formal description is not of any use, due to the large variety of possibilities.
    * If this parameter contains structures, these can be simulated through the recursive use of SwGenericAxisParamTypes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar data_constr_ref: This reference denoted data constraints
        applicable to the generic axis parameter.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-GENERIC-AXIS-PARAM-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwGenericAxisParamType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwGenericAxisParamType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_constr_ref: Optional["SwGenericAxisParamType.DataConstrRef"] = field(
        default=None,
        metadata={
            "name": "DATA-CONSTR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataConstrRef(Ref):
        dest: DataConstrSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwRecordLayout:
    """Defines how the data objects (variables, calibration parameters etc.) are to
    be stored in the ECU memory.

    As an example, this definition specifies the sequence of axis points
    in the ECU memory. Iterations through axis values are stored within
    the sub-elements swRecordLayoutGroup.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar sw_record_layout_group: This is the top level record layout
        group.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-RECORD-LAYOUT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwRecordLayout.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwRecordLayout.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_group: SwRecordLayoutGroup | None = field(
        default=None,
        metadata={
            "name": "SW-RECORD-LAYOUT-GROUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwServiceArg:
    """Specifies the properties of a data object exchanged during the call of an
    SwService, e.g. an argument or a return value.

    The SwServiceArg can also be used in the argument list of a C-macro.
    For this purpose the category shall be set to "MACRO". A reference
    to implementationDataType can optional be added if the actual
    argument has an implementationDataType.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar direction: Specifies the direction of the data transfer. The
        direction shall indicate the direction of the actual information
        that is being consumed by the caller and/or the callee, not the
        direction of formal arguments in C. The attribute is optional
        for backwards compatibility reasons. For example, if a pointer
        is used to pass a memory address for the expected result, the
        direction shall be "out". If a pointer is used to pass a memory
        address with content to be read by the callee, its direction
        shall be "in".
    :ivar sw_arraysize: This turns the argument of the service to an
        array.
    :ivar sw_data_def_props: Data properties of this SwServiceArg.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: BswModuleEntry.argument
        Not Applicable for: BswModuleEntry.returnType
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-SERVICE-ARG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwServiceArg.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwServiceArg.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    direction: ArgumentDirectionEnum | None = field(
        default=None,
        metadata={
            "name": "DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_arraysize: ValueList | None = field(
        default=None,
        metadata={
            "name": "SW-ARRAYSIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwSystemconst:
    """This element defines a system constant which serves an input to select a
    particular variation point.

    In particular a system constant serves as an operand of the binding
    function (swSyscond) in a Variation point. Note that the binding
    process can only happen  if a value was assigned to to the
    referenced system constants.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar sw_data_def_props: This denotes the data definition properties
        of the system constant. This supports to express the limits and
        optionally a conversion within the internal to physical values
        by a compu method.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-SYSTEMCONST"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwSystemconst.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwSystemconst.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwSystemconstantValueSet:
    """
    This meta-class represents the ability to specify a set of system constant
    values.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar sw_systemconstant_values: This is one particular value of a
        system constant.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-SYSTEMCONSTANT-VALUE-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwSystemconstantValueSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwSystemconstantValueSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_systemconstant_values: Optional["SwSystemconstantValueSet.SwSystemconstantValues"] = field(
        default=None,
        metadata={
            "name": "SW-SYSTEMCONSTANT-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwSystemconstantValues:
        sw_systemconst_value: list[SwSystemconstValue] = field(
            default_factory=list,
            metadata={
                "name": "SW-SYSTEMCONST-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwcBswRunnableMapping:
    """Maps a BswModuleEntity to a RunnableEntity if it is implemented as part of a
    BSW module (in the case of an AUTOSAR Service, a Complex Driver or an ECU
    Abstraction).

    The mapping can be used by a tool to find relevant information on
    the behavior, e.g. whether the bswEntity shall be running in
    interrupt context.

    :ivar bsw_entity_ref: The mapped BswModuleEntity
    :ivar swc_runnable_ref: The mapped SWC runnable.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcBswMapping.runnableMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-BSW-RUNNABLE-MAPPING"

    bsw_entity_ref: Optional["SwcBswRunnableMapping.BswEntityRef"] = field(
        default=None,
        metadata={
            "name": "BSW-ENTITY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_runnable_ref: Optional["SwcBswRunnableMapping.SwcRunnableRef"] = field(
        default=None,
        metadata={
            "name": "SWC-RUNNABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BswEntityRef(Ref):
        dest: BswModuleEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SwcRunnableRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwcBswSynchronizedModeGroupPrototype:
    """
    Synchronizes a mode group provided by a component via a port with a mode group
    provided by a BSW module or cluster.

    :ivar bsw_mode_group_ref: The BSW mode group prototype.
    :ivar swc_mode_group_iref: The SWC mode group prototype provided by
        a particular port.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcBswMapping.synchronizedModeGroup
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-BSW-SYNCHRONIZED-MODE-GROUP-PROTOTYPE"

    bsw_mode_group_ref: Optional["SwcBswSynchronizedModeGroupPrototype.BswModeGroupRef"] = field(
        default=None,
        metadata={
            "name": "BSW-MODE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_mode_group_iref: PModeGroupInAtomicSwcInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SWC-MODE-GROUP-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BswModeGroupRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwcBswSynchronizedTrigger:
    """
    Synchronizes a Trigger provided by a component via a port with a Trigger
    provided by a BSW module or cluster.

    :ivar bsw_trigger_ref: The BSW Trigger.
    :ivar swc_trigger_iref: The SWC Trigger provided by a particular
        port.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcBswMapping.synchronizedTrigger
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-BSW-SYNCHRONIZED-TRIGGER"

    bsw_trigger_ref: Optional["SwcBswSynchronizedTrigger.BswTriggerRef"] = field(
        default=None,
        metadata={
            "name": "BSW-TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_trigger_iref: PTriggerInAtomicSwcTypeInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SWC-TRIGGER-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class BswTriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwcExclusiveAreaPolicy:
    """Options how to generate the ExclusiveArea related APIs.

    If no SwcExclusiveAreaPolicy is specified for an ExclusiveArea the
    default values apply.

    :ivar api_principle: Specifies for this ExclusiveArea if either one
        common set of Enter and Exit APIs for the whole software
        component is requested from the Rte or if the set of Enter and
        Exit APIs is expected per RunnableEntity. The default value is
        "common".
    :ivar exclusive_area_ref: This reference represents the
        ExclusiveArea for which the policy applies.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.exclusiveAreaPolicy
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-EXCLUSIVE-AREA-POLICY"

    api_principle: ApiPrincipleEnum | None = field(
        default=None,
        metadata={
            "name": "API-PRINCIPLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_area_ref: Optional["SwcExclusiveAreaPolicy.ExclusiveAreaRef"] = field(
        default=None,
        metadata={
            "name": "EXCLUSIVE-AREA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaRef(Ref):
        dest: ExclusiveAreaSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwcModeManagerErrorEvent:
    """
    This event is raised when an error occurred during the handling of the
    referenced ModeDeclarationGroupPrototype.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar mode_group_iref: This represents the
        ModeDeclarationGroupPrototype for which this
        SwcModeManagerErrorEvent is raised in case of an error.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-MODE-MANAGER-ERROR-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwcModeManagerErrorEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwcModeManagerErrorEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "SwcModeManagerErrorEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["SwcModeManagerErrorEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["SwcModeManagerErrorEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_group_iref: PModeGroupInAtomicSwcInstanceRef | None = field(
        default=None,
        metadata={
            "name": "MODE-GROUP-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwcModeSwitchEvent:
    """
    This event is raised when the specified mode change occurs.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar activation: Specifies if the event is raised on entering or
        exiting a specific mode or is raised on the transition between
        two modes.
    :ivar mode_irefs: The referenced mode or the transition between two
        modes raises this SwcModeSwitchEvent.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-MODE-SWITCH-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwcModeSwitchEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwcModeSwitchEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "SwcModeSwitchEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["SwcModeSwitchEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["SwcModeSwitchEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation: ModeActivationKind | None = field(
        default=None,
        metadata={
            "name": "ACTIVATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_irefs: Optional["SwcModeSwitchEvent.ModeIrefs"] = field(
        default=None,
        metadata={
            "name": "MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ModeIrefs:
        mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 2,
            },
        )


@dataclass(slots=True, kw_only=True)
class SwcToApplicationPartitionMapping:
    """
    Allows to map a given SwComponentPrototype to a formally defined partition at a
    point in time when the corresponding EcuInstance is not yet known or defined.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar application_partition_ref: Reference to an
        ApplicationPartition to which a SwComponentPrototype is mapped.
    :ivar sw_component_prototype_iref: References to the software
        component instances that are mapped to the referenced
        ApplicationPartition. If the component prototype referenced is a
        composition, this indicates that all atomic software components
        within the composition are mapped to the ApplicationPartition.
        If there is additionally a mapping of some SwComponentPrototype
        INSIDE the Composition to another ApplicationPartition the inner
        mapping overrides the outer mapping.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CpSoftwareClusterMappingSet.swcToApplicationPartitionMapping
        Applicable for: SystemMapping.swcToApplicationPartitionMapping
        Not Applicable for:
        SwComponentMappingConstraints.swcToApplicationPartitionMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-TO-APPLICATION-PARTITION-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwcToApplicationPartitionMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwcToApplicationPartitionMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_partition_ref: Optional[
        "SwcToApplicationPartitionMapping.ApplicationPartitionRef"
    ] = field(
        default=None,
        metadata={
            "name": "APPLICATION-PARTITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_prototype_iref: ComponentInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "SW-COMPONENT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ApplicationPartitionRef(Ref):
        dest: ApplicationPartitionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwcToEcuMapping:
    """Map software components to a specific ECU Instance and optionally to a
    processing unit and to an EcuPartition.

    For each combination of ECUInstance and the optional ProcessingUnit
    and the optional EcuPartition and the optional SensorActuator only
    one SwcToEcuMapping shall be used.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar component_irefs: References to the software component
        instances that are mapped to the referenced ECUInstance. If the
        component prototype referenced is a composition, this indicates
        that all atomic software components within the composition are
        mapped to the ECU. If there is aditionally a mapping of some
        SwComponentPrototype INSIDE the Composition to another ECU
        Instance the inner mapping overrides the outer mapping.
    :ivar controlled_hw_element_ref: Optional mapping of
        SwComponentPrototypes that are typed by
        SensorActuatorSwComponentType to a HwElement with category
        SensorActuator.
    :ivar ecu_instance_ref: Reference to a specific ECU Instance
        description.
    :ivar partition_ref: This reference has the status "removed" and is
        replaced by the SwcToApplicationPartitionMapping and
        ApplicationPartitionToEcuPartitionMapping. Old description: An
        optional mapping of SWCs to Partitions. With this mapping an OEM
        has the option to predefine an allocation in the System Design
        phase. The final and complete assignment is described in the OS
        Configuration.
    :ivar processing_unit_ref: Optional mapping of software components
        to individual microcontroller cores residing in one ECU. A
        microcontroller core is described in the ECU Resource Template
        by the HwElement of HwCategory ProcessingUnit.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: SystemMapping.swMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-TO-ECU-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwcToEcuMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwcToEcuMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_irefs: Optional["SwcToEcuMapping.ComponentIrefs"] = field(
        default=None,
        metadata={
            "name": "COMPONENT-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    controlled_hw_element_ref: Optional["SwcToEcuMapping.ControlledHwElementRef"] = field(
        default=None,
        metadata={
            "name": "CONTROLLED-HW-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["SwcToEcuMapping.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    partition_ref: Optional["SwcToEcuMapping.PartitionRef"] = field(
        default=None,
        metadata={
            "name": "PARTITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    processing_unit_ref: Optional["SwcToEcuMapping.ProcessingUnitRef"] = field(
        default=None,
        metadata={
            "name": "PROCESSING-UNIT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ComponentIrefs:
        component_iref: list[ComponentInSystemInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "COMPONENT-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ControlledHwElementRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PartitionRef(Ref):
        dest: EcuPartitionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessingUnitRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwcToEcuMappingConstraint:
    """The System Constraint Description has to describe dedicated and exclusive
    mapping of SW-Cs to one or more ECUs.

    Dedicated mapping means that the SW-C can only be mapped to the ECUs
    it is dedicated to. Exclusive Mapping means that the SW-C cannot be
    mapped to the ECUs it is excluded from.

    :ivar introduction: This represents introductory documentation about
        the mapping constraint.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.mappingConstraint
    :ivar component_iref: Reference to SwComponentPrototypes for which
        the dedicated or exclusive mapping is defined.
    :ivar ecu_instance_refs: If the dedicated mapping is described, the
        SwComponentPrototypes can only be mapped to these referenced
        ECUInstances. If the exclusive mapping is described, the
        SwComponentPrototypes cannot be mapped to these referenced
        ECUInstances.
    :ivar swc_to_ecu_mapping_constraint_type: This attribute determines
        if dedicated or exclusive mapping is used.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-TO-ECU-MAPPING-CONSTRAINT"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_iref: ComponentInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "COMPONENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_refs: Optional["SwcToEcuMappingConstraint.EcuInstanceRefs"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_to_ecu_mapping_constraint_type: SwcToEcuMappingConstraintType | None = field(
        default=None,
        metadata={
            "name": "SWC-TO-ECU-MAPPING-CONSTRAINT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRefs:
        ecu_instance_ref: list["SwcToEcuMappingConstraint.EcuInstanceRefs.EcuInstanceRef"] = field(
            default_factory=list,
            metadata={
                "name": "ECU-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EcuInstanceRef(Ref):
            dest: EcuInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SwcToImplMapping:
    """
    Map instances of an AtomicSwComponentType to a specific Implementation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar component_implementation_ref: Reference to a specific
        Implementation description. Implementation to be used by the
        specified SW component instance. This allows to achieve more
        precise estimates for the resource consumption that results from
        mapping the instance of an atomic SW component onto an ECU.
    :ivar component_irefs: Reference to the software component instances
        that are being mapped to the specified Implementation. The
        targeted SwComponentPrototype needs be of the
        AtomicSwComponentType being implemented by the referenced
        Implementation.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.swImplMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-TO-IMPL-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwcToImplMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwcToImplMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_implementation_ref: Optional["SwcToImplMapping.ComponentImplementationRef"] = field(
        default=None,
        metadata={
            "name": "COMPONENT-IMPLEMENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_irefs: Optional["SwcToImplMapping.ComponentIrefs"] = field(
        default=None,
        metadata={
            "name": "COMPONENT-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ComponentImplementationRef(Ref):
        dest: SwcImplementationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ComponentIrefs:
        component_iref: list[ComponentInSystemInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "COMPONENT-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SyncTimeBaseMgrUserNeeds:
    """Specifies the needs on the configuration of the Synchronized Time-base
    Manager for one time-base.

    This class currently contains no attributes. An instance of this
    class is used to find out which ports of a software-component belong
    to this time-base in order to group the request and response ports
    of the same time-base. The actual time-base value is stored in the
    PortDefinedArgumentValue of the respective port specification.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYNC-TIME-BASE-MGR-USER-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SyncTimeBaseMgrUserNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SyncTimeBaseMgrUserNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SynchronizationPointConstraint:
    """
    This constraint is used to specify a synchronization point either between
    groups of executable entities or individual executable entities referenced via
    their corresponding RTE or BSW events.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar timing_condition_ref: A timing condition the timing constraint
        depends on. In other words it specifies the condition the timing
        constraint holds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingRequirement Applicable for:
        TimingExtension.timingGuarantee
    :ivar source_eec_refs: The source executable entities cluster
        containing the executable entities that shall finish execution
        before the synchronization point.
    :ivar source_event_refs: The executable entities --- referenced by
        their events --- that shall finish execution before the
        synchronization point.
    :ivar target_eec_refs: The target executable entities cluster
        containing the executable entities that shall start execution
        after the synchronization point.
    :ivar target_event_refs: The executable entities --- referenced by
        their events --- that shall start execution after the
        synchronization point.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYNCHRONIZATION-POINT-CONSTRAINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SynchronizationPointConstraint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SynchronizationPointConstraint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["SynchronizationPointConstraint.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_condition_ref: Optional["SynchronizationPointConstraint.TimingConditionRef"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_eec_refs: Optional["SynchronizationPointConstraint.SourceEecRefs"] = field(
        default=None,
        metadata={
            "name": "SOURCE-EEC-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_event_refs: Optional["SynchronizationPointConstraint.SourceEventRefs"] = field(
        default=None,
        metadata={
            "name": "SOURCE-EVENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_eec_refs: Optional["SynchronizationPointConstraint.TargetEecRefs"] = field(
        default=None,
        metadata={
            "name": "TARGET-EEC-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_event_refs: Optional["SynchronizationPointConstraint.TargetEventRefs"] = field(
        default=None,
        metadata={
            "name": "TARGET-EVENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["SynchronizationPointConstraint.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimingConditionRef(Ref):
        dest: TimingConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SourceEecRefs:
        source_eec_ref: list["SynchronizationPointConstraint.SourceEecRefs.SourceEecRef"] = field(
            default_factory=list,
            metadata={
                "name": "SOURCE-EEC-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SourceEecRef(Ref):
            dest: EocExecutableEntityRefGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SourceEventRefs:
        source_event_ref: list["SynchronizationPointConstraint.SourceEventRefs.SourceEventRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SOURCE-EVENT-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class SourceEventRef(Ref):
            dest: AbstractEventSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TargetEecRefs:
        target_eec_ref: list["SynchronizationPointConstraint.TargetEecRefs.TargetEecRef"] = field(
            default_factory=list,
            metadata={
                "name": "TARGET-EEC-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TargetEecRef(Ref):
            dest: EocExecutableEntityRefGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TargetEventRefs:
        target_event_ref: list["SynchronizationPointConstraint.TargetEventRefs.TargetEventRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "TARGET-EVENT-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class TargetEventRef(Ref):
            dest: AbstractEventSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SynchronizationTimingConstraint:
    """This constraint is used to restrict the timing behavior of different, but
    correlated events or event chains, with regard to synchronization.

    Thereby, in case of imposing a synchronization timing constraint on events or event chains the following two scenarios are supported:
    1) [synchronizationConstraintType=responseSynchronization] Events: An arbitrary number of correlated events which play the role of responses shall occur synchronously with respect to a predefined tolerance. Event Chains: An arbitrary number of correlated event chains with a common stimulus, but different responses, where the responses shall occur synchronously with respect to a predefined tolerance.
    2) [synchronizationConstraintType=stimulusSynchronization] Events: An arbitrary number of correlated events which play the role of stimuli shall occur synchronously with respect to a predefined tolerance. Event Chains: An arbitrary number of correlated event chains with a common response, but different stimuli, where the stimuli shall occur synchronously with respect to a predefined tolerance.
    In case of imposing a synchronization timing constraint on events the following two scenarios are supported:
    1) [eventOccurrenceKind=singleOccurrence] Any of the events shall occur only once in the given time interval.
    2) [eventOccurrenceKind=multipleOccurrences] Any of the events may occur more than once in the given time interval. In other words multiple occurrences of an event within the given time interval are permitted.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar timing_condition_ref: A timing condition the timing constraint
        depends on. In other words it specifies the condition the timing
        constraint holds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingRequirement Applicable for:
        TimingExtension.timingGuarantee
    :ivar event_occurrence_kind: The specific occurrence kind of an
        event occurring within the given time interval.
    :ivar scope_event_refs: The events that are in the scope of the
        constraint.
    :ivar scope_refs: The event chains that are in the scope of the
        constraint.
    :ivar synchronization_constraint_type: The specific type of this
        synchronization constraint.
    :ivar tolerance: The maximum time interval, within which the
        synchronized events shall occur.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYNCHRONIZATION-TIMING-CONSTRAINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SynchronizationTimingConstraint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SynchronizationTimingConstraint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["SynchronizationTimingConstraint.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_condition_ref: Optional["SynchronizationTimingConstraint.TimingConditionRef"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_occurrence_kind: EventOccurrenceKindEnum | None = field(
        default=None,
        metadata={
            "name": "EVENT-OCCURRENCE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope_event_refs: Optional["SynchronizationTimingConstraint.ScopeEventRefs"] = field(
        default=None,
        metadata={
            "name": "SCOPE-EVENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope_refs: Optional["SynchronizationTimingConstraint.ScopeRefs"] = field(
        default=None,
        metadata={
            "name": "SCOPE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    synchronization_constraint_type: SynchronizationTypeEnum | None = field(
        default=None,
        metadata={
            "name": "SYNCHRONIZATION-CONSTRAINT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tolerance: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "TOLERANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["SynchronizationTimingConstraint.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimingConditionRef(Ref):
        dest: TimingConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ScopeEventRefs:
        scope_event_ref: list["SynchronizationTimingConstraint.ScopeEventRefs.ScopeEventRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SCOPE-EVENT-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class ScopeEventRef(Ref):
            dest: TimingDescriptionEventSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ScopeRefs:
        scope_ref: list["SynchronizationTimingConstraint.ScopeRefs.ScopeRef"] = field(
            default_factory=list,
            metadata={
                "name": "SCOPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ScopeRef(Ref):
            dest: TimingDescriptionEventChainSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SynchronizedTimeBaseConsumer:
    """
    This meta-class represents a Synchronized Time Base Consumer.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar network_time_consumer_ref: This reference defines the
        GlobalTime Consumer which is synchronized with this Time Base.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYNCHRONIZED-TIME-BASE-CONSUMER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SynchronizedTimeBaseConsumer.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SynchronizedTimeBaseConsumer.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_time_consumer_ref: Optional["SynchronizedTimeBaseConsumer.NetworkTimeConsumerRef"] = (
        field(
            default=None,
            metadata={
                "name": "NETWORK-TIME-CONSUMER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NetworkTimeConsumerRef(Ref):
        dest: GlobalTimeSlaveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SynchronizedTimeBaseConsumerInterface:
    """
    This meta-class provides the ability to define a PortInterface for the
    interaction with a Time Synchronization Consumer.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYNCHRONIZED-TIME-BASE-CONSUMER-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SynchronizedTimeBaseConsumerInterface.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SynchronizedTimeBaseConsumerInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["SynchronizedTimeBaseConsumerInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["SynchronizedTimeBaseConsumerInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SynchronizedTimeBaseProvider:
    """
    This meta-class represents a Synchronized Time Base Provider.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar network_time_provider_ref: This reference defines the
        GlobalTime Provider which is synchronized with this Time Base.
    :ivar time_sync_correction: This aggregation defines the attributes
        used for the correction of time synchronization.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYNCHRONIZED-TIME-BASE-PROVIDER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SynchronizedTimeBaseProvider.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SynchronizedTimeBaseProvider.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_time_provider_ref: Optional["SynchronizedTimeBaseProvider.NetworkTimeProviderRef"] = (
        field(
            default=None,
            metadata={
                "name": "NETWORK-TIME-PROVIDER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    time_sync_correction: TimeSyncCorrection | None = field(
        default=None,
        metadata={
            "name": "TIME-SYNC-CORRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NetworkTimeProviderRef(Ref):
        dest: GlobalTimeMasterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SynchronizedTimeBaseProviderInterface:
    """
    This meta-class provides the ability to define a PortInterface for the
    interaction with a Time Synchronization Provider.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar time_base_kind: Defines which kind of time base is requested
        at this interface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYNCHRONIZED-TIME-BASE-PROVIDER-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SynchronizedTimeBaseProviderInterface.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SynchronizedTimeBaseProviderInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["SynchronizedTimeBaseProviderInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["SynchronizedTimeBaseProviderInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_base_kind: TimeSynchronizationKindEnum | None = field(
        default=None,
        metadata={
            "name": "TIME-BASE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SynchronousServerCallPoint:
    """
    This means that the RunnableEntity is supposed to perform a  blocking wait for
    a response from the server.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar return_value_provision: This attribute controls the provision
        of return values for RTE APIs that correspond to the enclosing
        access point.
    :ivar operation_iref: The operation that is called by this runnable.
    :ivar timeout: Time in seconds before the server call times out and
        returns with an error message. It depends on the call type
        (synchronous or asynchronous) how this is reported.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RunnableEntity.serverCallPoint
    :ivar called_from_within_exclusive_area_ref: This indicates that the
        call point is located at the deepest level inside one or more
        ExclusiveAreas that are nested in the given order.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYNCHRONOUS-SERVER-CALL-POINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SynchronousServerCallPoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SynchronousServerCallPoint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    return_value_provision: RteApiReturnValueProvisionEnum | None = field(
        default=None,
        metadata={
            "name": "RETURN-VALUE-PROVISION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_iref: ROperationInAtomicSwcInstanceRef | None = field(
        default=None,
        metadata={
            "name": "OPERATION-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    called_from_within_exclusive_area_ref: Optional[
        "SynchronousServerCallPoint.CalledFromWithinExclusiveAreaRef"
    ] = field(
        default=None,
        metadata={
            "name": "CALLED-FROM-WITHIN-EXCLUSIVE-AREA-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CalledFromWithinExclusiveAreaRef(Ref):
        dest: ExclusiveAreaNestingOrderSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SystemSignal:
    """The system signal represents the communication system's view of data
    exchanged between SW components which reside on different ECUs.

    The system signals allow to represent this communication in a
    flattened structure, with exactly one system signal defined for each
    data element prototype sent and received by connected SW component
    instances.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar dynamic_length: The length of dynamic length signals is
        variable in run-time. Only a maximum length of such a signal is
        specified in the configuration (attribute length in ISignal
        element).
    :ivar physical_props: Specification of the physical representation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYSTEM-SIGNAL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SystemSignal.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SystemSignal.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "DYNAMIC-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "PHYSICAL-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SystemSignalGroup:
    """A signal group refers to a set of signals that shall always be kept
    together.

    A signal group is used to guarantee the atomic transfer of AUTOSAR
    composite data types. The SystemSignalGroup defines a signal
    grouping on VFB level. On cluster level the Signal grouping is
    described by the ISignalGroup element.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar system_signal_refs: Reference to a set of SystemSignals that
        shall always be kept together.
    :ivar transforming_system_signal_ref: Optional reference to the
        SystemSignal which shall contain the transformed (linear) data.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYSTEM-SIGNAL-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SystemSignalGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SystemSignalGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_signal_refs: Optional["SystemSignalGroup.SystemSignalRefs"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transforming_system_signal_ref: Optional["SystemSignalGroup.TransformingSystemSignalRef"] = (
        field(
            default=None,
            metadata={
                "name": "TRANSFORMING-SYSTEM-SIGNAL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRefs:
        system_signal_ref: list["SystemSignalGroup.SystemSignalRefs.SystemSignalRef"] = field(
            default_factory=list,
            metadata={
                "name": "SYSTEM-SIGNAL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SystemSignalRef(Ref):
            dest: SystemSignalSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TransformingSystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TagWithOptionalValue:
    """A tagged value is a combination of a tag (key) and a value that gives
    supplementary information that is attached to a model element.

    Please note that keys without a value are allowed.

    :ivar key: Defines a key.
    :ivar sequence_offset: The sequenceOffset attribute supports the use
        case where TagWithOptionalValue is aggregated as splitable. If
        multiple aggregations define the same value of attribute key
        then the order in which the value collection is merged might be
        significant. As an example consider the modeling of the $PATH
        environment variable by means of a meta class
        TagWithOptionalValue. The sequenceOffset describes the relative
        position of each contribution in the concatenated value. The
        contributions are sorted in increasing integer order.
    :ivar value: Defines the corresponding value.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        AbstractServiceInstance.capabilityRecord Not Applicable for:
        SdClientConfig.capabilityRecord Not Applicable for:
        SdServerConfig.capabilityRecord Not Applicable for:
        Machine.environmentVariable Not Applicable for:
        StartupConfig.environmentVariable Not Applicable for:
        ProvidedSomeipServiceInstance.capabilityRecord Not Applicable
        for: RequiredSomeipServiceInstance.capabilityRecord
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TAG-WITH-OPTIONAL-VALUE"

    key: String | None = field(
        default=None,
        metadata={
            "name": "KEY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sequence_offset: Integer | None = field(
        default=None,
        metadata={
            "name": "SEQUENCE-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: String | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TcpOptionFilterList:
    """
    Permitted list for the filtering of TCP options.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar allowed_tcp_options: TCP option kind allowed by this filter.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TCP-OPTION-FILTER-LIST"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TcpOptionFilterList.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TcpOptionFilterList.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    allowed_tcp_options: Optional["TcpOptionFilterList.AllowedTcpOptions"] = field(
        default=None,
        metadata={
            "name": "ALLOWED-TCP-OPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AllowedTcpOptions:
        allowed_tcp_option: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "ALLOWED-TCP-OPTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TdCpSoftwareClusterMapping:
    """
    This is used to specify a mapping between a software cluster that provides
    temporal and dynamic resources and the software clusters that need these
    resources.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar provider_ref: This is the software cluster that provides the
        temporal and dynamic resource.
    :ivar requestor_refs: This is the software cluster that requests the
        temporal and dynamic resource.
    :ivar timing_description_ref: The timing description representing
        the temporal and dynamic resource.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TDCpSoftwareClusterMappingSet.tdCpSoftwareClusterToTdMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-CP-SOFTWARE-CLUSTER-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdCpSoftwareClusterMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdCpSoftwareClusterMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provider_ref: Optional["TdCpSoftwareClusterMapping.ProviderRef"] = field(
        default=None,
        metadata={
            "name": "PROVIDER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requestor_refs: Optional["TdCpSoftwareClusterMapping.RequestorRefs"] = field(
        default=None,
        metadata={
            "name": "REQUESTOR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_description_ref: Optional["TdCpSoftwareClusterMapping.TimingDescriptionRef"] = field(
        default=None,
        metadata={
            "name": "TIMING-DESCRIPTION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProviderRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RequestorRefs:
        requestor_ref: list["TdCpSoftwareClusterMapping.RequestorRefs.RequestorRef"] = field(
            default_factory=list,
            metadata={
                "name": "REQUESTOR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RequestorRef(Ref):
            dest: CpSoftwareClusterSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimingDescriptionRef(Ref):
        dest: TimingDescriptionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdCpSoftwareClusterResourceMapping:
    """
    This is used to assign an unequivocal global resource identification to a
    temporal and dynamic resource.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar resource_ref: The specific resource identification assigned to
        the temporal and dynamic resource.
    :ivar timing_description_ref: The timing description representing
        the temporal and dynamic resource.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TDCpSoftwareClusterMappingSet.tdCpSoftwareClusterResourceToTdMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-CP-SOFTWARE-CLUSTER-RESOURCE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdCpSoftwareClusterResourceMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdCpSoftwareClusterResourceMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resource_ref: Optional["TdCpSoftwareClusterResourceMapping.ResourceRef"] = field(
        default=None,
        metadata={
            "name": "RESOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_description_ref: Optional["TdCpSoftwareClusterResourceMapping.TimingDescriptionRef"] = (
        field(
            default=None,
            metadata={
                "name": "TIMING-DESCRIPTION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ResourceRef(Ref):
        dest: CpSoftwareClusterResourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TimingDescriptionRef(Ref):
        dest: TimingDescriptionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TextValueSpecification:
    """
    The purpose of TextValueSpecification is to define the labels that correspond
    to enumeration values.

    :ivar short_label: This can be used to identify particular value
        specifications for human readers, for example elements of a
        record type.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ArrayValueSpecification.element Applicable for:
        RecordValueSpecification.field Not Applicable for:
        CompositeRuleBasedValueSpecification.argument Not Applicable
        for: ConstantSpecification.valueSpec Not Applicable for:
        PortPrototypeBlueprintInitValue.value Not Applicable for:
        DiagnosticEnvDataCondition.compareValue Not Applicable for:
        DiagnosticEnvDataElementCondition.compareValue Not Applicable
        for: ParameterDataPrototype.initValue Not Applicable for:
        VariableDataPrototype.initValue Not Applicable for:
        CalibrationParameterValue.applInitValue Not Applicable for:
        CalibrationParameterValue.implInitValue Not Applicable for:
        MetaDataItem.metaDataItemType Not Applicable for:
        NvProvideComSpec.romBlockInitValue Not Applicable for:
        NvProvideComSpec.ramBlockInitValue Not Applicable for:
        NvRequireComSpec.initValue Not Applicable for:
        ParameterProvideComSpec.initValue Not Applicable for:
        ParameterRequireComSpec.initValue Not Applicable for:
        NonqueuedSenderComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.timeoutSubstitutionValue Not Applicable
        for: PortDefinedArgumentValue.value Not Applicable for:
        CryptoServiceKey.developmentValue Not Applicable for:
        ISignal.timeoutSubstitutionValue Not Applicable for:
        ISignal.initValue Not Applicable for:
        FieldSenderComSpec.initValue Not Applicable for:
        PersistencyDataRequiredComSpec.initValue Not Applicable for:
        ApplicationAssocMapElementValueSpecification.value Not
        Applicable for: ApplicationAssocMapElementValueSpecification.key
        Not Applicable for: StateManagementCompareCondition.compareValue
        Not Applicable for: PersistencyKeyValuePair.initValue Not
        Applicable for: SwDataDefPropsContent.invalidValue
    :ivar value: This is the value itself. Note that vt uses the |
        operator to separate the values for the different bitfield masks
        in case that the semantics of the related DataPrototype is
        described by means of a BITFIELD_TEXTTABLE in the associated
        CompuMethod.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TEXT-VALUE-SPECIFICATION"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: VerbatimString | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TimeBaseProviderToPersistencyMapping:
    """
    This meta-class represents the ability to define a mapping between a
    TimeBaseProvider and a PersistencyDeploymentElement for the purpose of storing
    and retrieving the time value.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar cyclic_backup_interval: Time interval in seconds to store the
        time base value periodically to persistence.
    :ivar persistency_deployment_element_ref: This reference represents
        the PersistencyDeploymentElement where the time value shall be
        stored in and retrieved from.
    :ivar time_base_provider_ref: This reference represents the mapped
        TimeBaseProvider.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIME-BASE-PROVIDER-TO-PERSISTENCY-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TimeBaseProviderToPersistencyMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TimeBaseProviderToPersistencyMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cyclic_backup_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "CYCLIC-BACKUP-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    persistency_deployment_element_ref: Optional[
        "TimeBaseProviderToPersistencyMapping.PersistencyDeploymentElementRef"
    ] = field(
        default=None,
        metadata={
            "name": "PERSISTENCY-DEPLOYMENT-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_base_provider_ref: Optional["TimeBaseProviderToPersistencyMapping.TimeBaseProviderRef"] = (
        field(
            default=None,
            metadata={
                "name": "TIME-BASE-PROVIDER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PersistencyDeploymentElementRef(Ref):
        dest: PersistencyDeploymentElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TimeBaseProviderRef(Ref):
        dest: SynchronizedTimeBaseProviderSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TimeBaseResourceRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar time_base_resource_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIME-BASE-RESOURCE-REF-CONDITIONAL"

    time_base_resource_ref: Optional["TimeBaseResourceRefConditional.TimeBaseResourceRef"] = field(
        default=None,
        metadata={
            "name": "TIME-BASE-RESOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TimeBaseResourceRef(Ref):
        dest: TimeBaseResourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TimeSyncPortPrototypeToTimeBaseMapping:
    """
    This meta-class provides the ability to map a PortPrototype typed by a
    AbstractSynchronizedTimeBaseInterface to a TimeBaseResource in the context of a
    Process.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar process_ref: Reference to the context Process this mapping
        applies to.
    :ivar time_base_resource_ref: Reference to the mapped
        TimeBaseResource.
    :ivar time_sync_p_port_prototype_iref: Instance reference to the
        mapped PPortPrototype typed by a
        AbstractSynchronizedTimeBaseInterface.
    :ivar time_sync_r_port_prototype_iref: Instance reference to the
        mapped RPortPrototype typed by a
        AbstractSynchronizedTimeBaseInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIME-SYNC-PORT-PROTOTYPE-TO-TIME-BASE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TimeSyncPortPrototypeToTimeBaseMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TimeSyncPortPrototypeToTimeBaseMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["TimeSyncPortPrototypeToTimeBaseMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_base_resource_ref: Optional[
        "TimeSyncPortPrototypeToTimeBaseMapping.TimeBaseResourceRef"
    ] = field(
        default=None,
        metadata={
            "name": "TIME-BASE-RESOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_sync_p_port_prototype_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "TIME-SYNC-P-PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_sync_r_port_prototype_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "TIME-SYNC-R-PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TimeBaseResourceRef(Ref):
        dest: TimeBaseResourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TimingClockSyncAccuracy:
    """
    Describes the synchronization accuracy between exactly two TDClocks.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar accuracy: Synchronization accuracy, treated as zero if not
        given.
    :ivar lower_ref: References a target clock
    :ivar upper_ref: References a source clock
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingClockSyncAccuracy
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIMING-CLOCK-SYNC-ACCURACY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TimingClockSyncAccuracy.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TimingClockSyncAccuracy.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    accuracy: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "ACCURACY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_ref: Optional["TimingClockSyncAccuracy.LowerRef"] = field(
        default=None,
        metadata={
            "name": "LOWER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_ref: Optional["TimingClockSyncAccuracy.UpperRef"] = field(
        default=None,
        metadata={
            "name": "UPPER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LowerRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class UpperRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TimingCondition:
    """A TimingCondition describes a dependency on a specific condition.

    The element owns an expression which describes the timing condition
    dependency.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar timing_condition_formula: This is the expression describing
        the dependency on a specific condition.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingCondition
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIMING-CONDITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TimingCondition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TimingCondition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_condition_formula: TimingConditionFormula | None = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITION-FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TimingDescriptionEventChain:
    """An event chain describes the causal order for a set of functionally
    dependent timing events.

    Each event chain has a well defined stimulus and response, which
    describe its start and end point. Furthermore, it can be
    hierarchically decomposed into an arbitrary number of sub-chains, so
    called ''event chain segments''.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar is_pipelining_permitted: States whether the scheduled entities
        in an LET interval shall use pipelined execution or not i.e.
        "permitted pipelining property" If TRUE, then the scheduled
        entities must implement pipelining. If FALSE or undefined, no
        pipelining applies.
    :ivar stimulus_ref: The stimulus event representing the point in
        time where the event chain is activated.
    :ivar response_ref: The response event representing the point in
        time where the event chain is terminated.
    :ivar segment_refs: A composed event chain consists of an arbitrary
        number of sub-chains.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIMING-DESCRIPTION-EVENT-CHAIN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TimingDescriptionEventChain.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TimingDescriptionEventChain.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_pipelining_permitted: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-PIPELINING-PERMITTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    stimulus_ref: Optional["TimingDescriptionEventChain.StimulusRef"] = field(
        default=None,
        metadata={
            "name": "STIMULUS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    response_ref: Optional["TimingDescriptionEventChain.ResponseRef"] = field(
        default=None,
        metadata={
            "name": "RESPONSE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    segment_refs: Optional["TimingDescriptionEventChain.SegmentRefs"] = field(
        default=None,
        metadata={
            "name": "SEGMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StimulusRef(Ref):
        dest: TimingDescriptionEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ResponseRef(Ref):
        dest: TimingDescriptionEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SegmentRefs:
        segment_ref: list["TimingDescriptionEventChain.SegmentRefs.SegmentRef"] = field(
            default_factory=list,
            metadata={
                "name": "SEGMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SegmentRef(Ref):
            dest: TimingDescriptionEventChainSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class TimingEvent:
    """
    This event is used to start RunnableEntities that shall be executed
    periodically.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar offset: The value makes an assumption about the time offset of
        the first activation of the RunnableEntity triggered by the
        mapped TimingEvent relative to the periodic activation of the
        time base of this TimingEvent. Unit: second.
    :ivar period: Period of timing event in seconds. The value of this
        attribute shall be greater than zero.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIMING-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TimingEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TimingEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "TimingEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["TimingEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["TimingEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offset: TimeValue | None = field(
        default=None,
        metadata={
            "name": "OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TimingModeInstance:
    """This class specifies the mode declaration to be checked in a specific
    instance of a mode declaration group.

    This is used in a timing condition formula as an operand of the
    unary timing function TIMEX_modeActive to check whether the mode
    declaration is active at the point in time this expression is
    evaluated.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar mode_instance: This refers to a specific mode declaration in
        the given context.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtensionResource.timingMode Not Applicable for:
        TDEventOccurrenceExpression.mode
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIMING-MODE-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TimingModeInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TimingModeInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_instance: Optional["TimingModeInstance.ModeInstance"] = field(
        default=None,
        metadata={
            "name": "MODE-INSTANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModeInstance:
        mode_in_bsw_instance_ref: ModeInBswInstanceRef | None = field(
            default=None,
            metadata={
                "name": "MODE-IN-BSW-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mode_in_swc_instance_ref: ModeInSwcInstanceRef | None = field(
            default=None,
            metadata={
                "name": "MODE-IN-SWC-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TlsConnectionGroup:
    """
    Defines a collection of TlsCryptoServiceMappings which will not be active at
    the same time during runtime.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar tls_connection_refs: Reference target is member of a
        TlsConnectionGroup.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TLS-CONNECTION-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TlsConnectionGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TlsConnectionGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tls_connection_refs: Optional["TlsConnectionGroup.TlsConnectionRefs"] = field(
        default=None,
        metadata={
            "name": "TLS-CONNECTION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TlsConnectionRefs:
        tls_connection_ref: list["TlsConnectionGroup.TlsConnectionRefs.TlsConnectionRef"] = field(
            default_factory=list,
            metadata={
                "name": "TLS-CONNECTION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TlsConnectionRef(Ref):
            dest: TlsCryptoServiceMappingSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class TlsCryptoCipherSuiteProps:
    """
    This meta-class provides attributes to specify details of TLS Cipher Suites.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar tcp_ip_tls_use_security_extension_force_encrypt_then_mac:
        Defines if the security extension according to IETF RFC 7366
        shall be supported. This is useful for cipher suites using CBC
        mode.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TLS-CRYPTO-CIPHER-SUITE-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TlsCryptoCipherSuiteProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TlsCryptoCipherSuiteProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_tls_use_security_extension_force_encrypt_then_mac: Boolean | None = field(
        default=None,
        metadata={
            "name": "TCP-IP-TLS-USE-SECURITY-EXTENSION-FORCE-ENCRYPT-THEN-MAC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TlsIamRemoteSubject:
    """
    This meta-class defines the proxy information about the remote node in case of
    TLS.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar accepted_crypto_cipher_suite_with_psk_refs: This reference is
        used to identify a remote node by means of the preshared Key.
    :ivar accepted_remote_certificate_refs: This reference is used to
        identify a remote node by means of the certificate.
    :ivar cert_common_name: This attribute defines the common name (CN)
        of the certificate of the remote peer.
    :ivar derived_certificate_accepted: This attribute defines whether a
        derivedCertificate is accepted (true) or not (false).
    :ivar iam_relevant_tls_secure_com_props_refs: This reference defines
        the local TlsSecureComProps that are relevant for IAM.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TLS-IAM-REMOTE-SUBJECT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TlsIamRemoteSubject.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TlsIamRemoteSubject.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    accepted_crypto_cipher_suite_with_psk_refs: Optional[
        "TlsIamRemoteSubject.AcceptedCryptoCipherSuiteWithPskRefs"
    ] = field(
        default=None,
        metadata={
            "name": "ACCEPTED-CRYPTO-CIPHER-SUITE-WITH-PSK-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    accepted_remote_certificate_refs: Optional[
        "TlsIamRemoteSubject.AcceptedRemoteCertificateRefs"
    ] = field(
        default=None,
        metadata={
            "name": "ACCEPTED-REMOTE-CERTIFICATE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cert_common_name: String | None = field(
        default=None,
        metadata={
            "name": "CERT-COMMON-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    derived_certificate_accepted: Boolean | None = field(
        default=None,
        metadata={
            "name": "DERIVED-CERTIFICATE-ACCEPTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    iam_relevant_tls_secure_com_props_refs: Optional[
        "TlsIamRemoteSubject.IamRelevantTlsSecureComPropsRefs"
    ] = field(
        default=None,
        metadata={
            "name": "IAM-RELEVANT-TLS-SECURE-COM-PROPS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AcceptedCryptoCipherSuiteWithPskRefs:
        accepted_crypto_cipher_suite_with_psk_ref: list[
            "TlsIamRemoteSubject.AcceptedCryptoCipherSuiteWithPskRefs.AcceptedCryptoCipherSuiteWithPskRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "ACCEPTED-CRYPTO-CIPHER-SUITE-WITH-PSK-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class AcceptedCryptoCipherSuiteWithPskRef(Ref):
            dest: TlsCryptoCipherSuiteSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class AcceptedRemoteCertificateRefs:
        accepted_remote_certificate_ref: list[
            "TlsIamRemoteSubject.AcceptedRemoteCertificateRefs.AcceptedRemoteCertificateRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "ACCEPTED-REMOTE-CERTIFICATE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class AcceptedRemoteCertificateRef(Ref):
            dest: CryptoServiceCertificateSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class IamRelevantTlsSecureComPropsRefs:
        iam_relevant_tls_secure_com_props_ref: list[
            "TlsIamRemoteSubject.IamRelevantTlsSecureComPropsRefs.IamRelevantTlsSecureComPropsRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "IAM-RELEVANT-TLS-SECURE-COM-PROPS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class IamRelevantTlsSecureComPropsRef(Ref):
            dest: TlsSecureComPropsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class TlsJobMapping:
    """This meta-class allows to map a TlsJobRequirement to a concrete crypto job
    that will fulfill the JobRequirement.

    The crypto job represents a call to a specific routine that
    implements a crypto function and that uses a specific key and refers
    to a specific primitive as a formal representation of the crypto
    algorithm.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TLS-JOB-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TlsJobMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TlsJobMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TlvDataIdDefinitionSet:
    """
    This meta-class acts as a container of TlvDataIdDefinitions to be used in a
    given context.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar tlv_data_id_definitions: This aggregation represents the
        collection of TlVDataTidDefinitions aggregated by the
        TlvDataIdDefinitionSet
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TLV-DATA-ID-DEFINITION-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TlvDataIdDefinitionSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TlvDataIdDefinitionSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tlv_data_id_definitions: Optional["TlvDataIdDefinitionSet.TlvDataIdDefinitions"] = field(
        default=None,
        metadata={
            "name": "TLV-DATA-ID-DEFINITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TlvDataIdDefinitions:
        tlv_data_id_definition: list[TlvDataIdDefinition] = field(
            default_factory=list,
            metadata={
                "name": "TLV-DATA-ID-DEFINITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TpAddress:
    """An ECUs TP address on the referenced channel.

    This represents the diagnostic Address.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar tp_address: An ECUs TP address on the referenced channel. This
        represents the diagnostic Address.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        FlexrayTpConfig.tpAddress Applicable for:
        J1939TpConfig.tpAddress Applicable for: LinTpConfig.tpAddress
        Applicable for: FlexrayArTpConfig.tpAddress
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TP-ADDRESS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TpAddress.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TpAddress.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_address: Integer | None = field(
        default=None,
        metadata={
            "name": "TP-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TransformationPropsToServiceInterfaceElementMapping:
    """This meta-class represents the ability to associate a ServiceInterface
    element with TransformationProps.

    The referenced elements of the Service Interface will be serialized
    according to the settings defined in the TransformationProps.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar event_refs: This represents the reference to one or several
        events of one ServiceInterface.
    :ivar field_refs: This represents the reference to one or several
        fields of one ServiceInterface.
    :ivar method_refs: This represents the reference to one or several
        methods of one ServiceInterface.
    :ivar tlv_data_id_definition_refs: This reference identifies the
        TlvDataIdDefinitions relevant for the enclosing
        TransformationPropsToServiceInterfaceMapping.
    :ivar transformation_props_ref: This represents the reference to the
        applicable Serialization properties.
    :ivar trigger_refs: This represents the reference to one or several
        triggers of one ServiceInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRANSFORMATION-PROPS-TO-SERVICE-INTERFACE-ELEMENT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "TransformationPropsToServiceInterfaceElementMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TransformationPropsToServiceInterfaceElementMapping.Annotations"] = (
        field(
            default=None,
            metadata={
                "name": "ANNOTATIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_refs: Optional["TransformationPropsToServiceInterfaceElementMapping.EventRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_refs: Optional["TransformationPropsToServiceInterfaceElementMapping.FieldRefs"] = field(
        default=None,
        metadata={
            "name": "FIELD-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_refs: Optional["TransformationPropsToServiceInterfaceElementMapping.MethodRefs"] = field(
        default=None,
        metadata={
            "name": "METHOD-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tlv_data_id_definition_refs: Optional[
        "TransformationPropsToServiceInterfaceElementMapping.TlvDataIdDefinitionRefs"
    ] = field(
        default=None,
        metadata={
            "name": "TLV-DATA-ID-DEFINITION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformation_props_ref: Optional[
        "TransformationPropsToServiceInterfaceElementMapping.TransformationPropsRef"
    ] = field(
        default=None,
        metadata={
            "name": "TRANSFORMATION-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_refs: Optional["TransformationPropsToServiceInterfaceElementMapping.TriggerRefs"] = (
        field(
            default=None,
            metadata={
                "name": "TRIGGER-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventRefs:
        event_ref: list[
            "TransformationPropsToServiceInterfaceElementMapping.EventRefs.EventRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EventRef(Ref):
            dest: VariableDataPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class FieldRefs:
        field_ref: list[
            "TransformationPropsToServiceInterfaceElementMapping.FieldRefs.FieldRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "FIELD-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FieldRef(Ref):
            dest: FieldSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class MethodRefs:
        method_ref: list[
            "TransformationPropsToServiceInterfaceElementMapping.MethodRefs.MethodRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "METHOD-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class MethodRef(Ref):
            dest: ClientServerOperationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TlvDataIdDefinitionRefs:
        tlv_data_id_definition_ref: list[
            "TransformationPropsToServiceInterfaceElementMapping.TlvDataIdDefinitionRefs.TlvDataIdDefinitionRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "TLV-DATA-ID-DEFINITION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TlvDataIdDefinitionRef(Ref):
            dest: TlvDataIdDefinitionSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TransformationPropsRef(Ref):
        dest: TransformationPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerRefs:
        trigger_ref: list[
            "TransformationPropsToServiceInterfaceElementMapping.TriggerRefs.TriggerRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TriggerRef(Ref):
            dest: TriggerSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class TransformerHardErrorEvent:
    """
    This event is raised when data are received which should trigger a
    Client/Server operation or an external Trigger but during transformation of the
    data a hard transformer error occurred.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reason_representation_ref: If the
        activationReasonRepresentation is referenced from the enclosing
        AbstractEvent this shall be taken as an indication that the
        latter contributes to the activating vector of this
        ExecutableEntity that owns the referenced
        ExecutableEntityActivationReason.
    :ivar disabled_mode_irefs: Reference to the Modes that disable the
        Event.
    :ivar start_on_event_ref: The referenced RunnableEntity starts when
        the corresponding RTEEvent is raised.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.event
    :ivar operation_iref: This represents the ClientServerOperation for
        which the transformer can raise this TransformerHardErrorEvent.
    :ivar required_trigger_iref: This represents the Trigger for which
        the transformer can raise this TransformerHardErrorEvent.
    :ivar trigger_iref: Trigger for which the transformer can trigger
        this TransformerHardErrorEvent
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRANSFORMER-HARD-ERROR-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TransformerHardErrorEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TransformerHardErrorEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reason_representation_ref: Optional[
        "TransformerHardErrorEvent.ActivationReasonRepresentationRef"
    ] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASON-REPRESENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    disabled_mode_irefs: Optional["TransformerHardErrorEvent.DisabledModeIrefs"] = field(
        default=None,
        metadata={
            "name": "DISABLED-MODE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_on_event_ref: Optional["TransformerHardErrorEvent.StartOnEventRef"] = field(
        default=None,
        metadata={
            "name": "START-ON-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_iref: POperationInAtomicSwcInstanceRef | None = field(
        default=None,
        metadata={
            "name": "OPERATION-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_trigger_iref: RTriggerInAtomicSwcInstanceRef | None = field(
        default=None,
        metadata={
            "name": "REQUIRED-TRIGGER-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_iref: PTriggerInAtomicSwcTypeInstanceRef | None = field(
        default=None,
        metadata={
            "name": "TRIGGER-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasonRepresentationRef(Ref):
        dest: ExecutableEntityActivationReasonSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DisabledModeIrefs:
        disabled_mode_iref: list[RModeInAtomicSwcInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DISABLED-MODE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartOnEventRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Trigger:
    """'''begin restrict to AP''' The Trigger represents a special kind of an event
    (without data) at which occurrence the Service Consumer shall react in a
    particular manner.

    '''end restrict to AP''' '''begin restrict to CP''' A trigger which
    is provided (i.e. released) or required (i.e. used to activate
    something) in the given context. '''end restrict to CP'''

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sw_impl_policy: This attribute, when set to value queued,
        allows for a queued processing of Triggers.
    :ivar trigger_period: Optional definition of a period in case of a
        periodically (time or angle) driven external trigger.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswModuleDescription.releasedTrigger Applicable for:
        BswModuleDescription.requiredTrigger Applicable for:
        ServiceInterface.trigger Not Applicable for:
        TriggerInterface.trigger
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRIGGER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Trigger.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Trigger.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_impl_policy: SwImplPolicyEnum | None = field(
        default=None,
        metadata={
            "name": "SW-IMPL-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_period: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "TRIGGER-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TriggerInterfaceMapping:
    """
    Defines the mapping of unequal named Triggers in context of two different
    TriggerInterfaces.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        PortInterfaceMappingSet.portInterfaceMapping
    :ivar trigger_mappings: Mapping of two Trigger in two different
        TriggerInterface
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRIGGER-INTERFACE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TriggerInterfaceMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TriggerInterfaceMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["TriggerInterfaceMapping.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_mappings: Optional["TriggerInterfaceMapping.TriggerMappings"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerMappings:
        trigger_mapping: list[TriggerMapping] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TriggerRefConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar trigger_ref:
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRIGGER-REF-CONDITIONAL"

    trigger_ref: Optional["TriggerRefConditional.TriggerRef"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TriggerToSignalMapping:
    """This meta-class represents the ability to map a trigger to a SystemSignal of
    size 0.

    The Trigger does not transport any other information than its
    existence, therefore the limitation in terms of signal length.

    :ivar communication_direction: This attribute controls the direction
        into which the mapped SystemSignal is communicated with respect
        to the kind of PortPrototype used as the context element of the
        DataMapping.
    :ivar event_group_refs: Via this reference a connection between the
        VFB View and the Ethernet EventGroups can be created.
    :ivar event_handler_refs: Via this reference a connection between
        the VFB View and the Ethernet EventHandlers can be created.
    :ivar introduction: This represents introductory documentation about
        the data mapping.
    :ivar service_instance_refs: Via this reference a connection between
        the VFB View and the Ethernet Services can be created.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.dataMapping
    :ivar trigger_iref: This represents the Trigger that shall be used
        to trigger RunnableEntities deployed to a remote ECU.
    :ivar system_signal_ref: This is the SystemSignal taken to transport
        the Trigger over the network.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRIGGER-TO-SIGNAL-MAPPING"

    communication_direction: CommunicationDirectionType | None = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_refs: Optional["TriggerToSignalMapping.EventGroupRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_handler_refs: Optional["TriggerToSignalMapping.EventHandlerRefs"] = field(
        default=None,
        metadata={
            "name": "EVENT-HANDLER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_refs: Optional["TriggerToSignalMapping.ServiceInstanceRefs"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_iref: TriggerInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "TRIGGER-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_signal_ref: Optional["TriggerToSignalMapping.SystemSignalRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EventGroupRefs:
        event_group_ref: list["TriggerToSignalMapping.EventGroupRefs.EventGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EventGroupRef(Ref):
            dest: ConsumedEventGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class EventHandlerRefs:
        event_handler_ref: list["TriggerToSignalMapping.EventHandlerRefs.EventHandlerRef"] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-HANDLER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EventHandlerRef(Ref):
            dest: EventHandlerSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRefs:
        service_instance_ref: list[
            "TriggerToSignalMapping.ServiceInstanceRefs.ServiceInstanceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceInstanceRef(Ref):
            dest: AbstractServiceInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TtcanCommunicationControllerConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar wake_up_by_controller_supported: Defines whether the ECU shall
        be woken up by this CommunicationController. TRUE: wake up is
        possible FALSE: wake up is not supported Note: If
        wakeUpByControllerSupported is set to TRUE the feature shall be
        supported by both hardware and basic software.
    :ivar can_controller_attributes: CAN Bit Timing configuration
    :ivar appl_watchdog_limit: The Appl_Watchdog_Limit shall be an 8-bit
        value specifying the period for the application watchdog in
        Appl_Watchdog_Limit times 256 NTUs.
    :ivar expected_tx_trigger: The Expected_Tx_Trigger shall be an eight
        (8) bit value which limits the number of messages the FSE may
        try to transmit in one matrix cycle.
    :ivar external_clock_synchronisation: One bit shall be used to
        configure whether or not external clock synchronisation will be
        allowed during runtime (only Level 2).
    :ivar initial_ref_offset: The Initial_Ref_Offset shall be an eight
        (8) bit value for the initialisation of Ref_Trigger_Offset.
    :ivar master: One bit shall be used to distinguish between
        (potential) time masters and time slaves. This can be derived
        from the frame-triggering's triggers.
    :ivar time_master_priority: The time master priority shall contain a
        three bit value for the priority of the current time master (the
        last three bits of the identifier of the reference message).
        This can be derived from the frame-triggering's triggers.
    :ivar time_triggered_can_level: One bit shall be used to distinguish
        between Level 1 and Level 2.
    :ivar tx_enable_window_length: The length of the Tx_Enable window
        shall be a four (4) bit value specifying the length of the time
        period (1-16 nominal CAN bit times) in which a transmission may
        be started.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TTCAN-COMMUNICATION-CONTROLLER-CONDITIONAL"

    wake_up_by_controller_supported: Boolean | None = field(
        default=None,
        metadata={
            "name": "WAKE-UP-BY-CONTROLLER-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_controller_attributes: Optional[
        "TtcanCommunicationControllerConditional.CanControllerAttributes"
    ] = field(
        default=None,
        metadata={
            "name": "CAN-CONTROLLER-ATTRIBUTES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    appl_watchdog_limit: Integer | None = field(
        default=None,
        metadata={
            "name": "APPL-WATCHDOG-LIMIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    expected_tx_trigger: Integer | None = field(
        default=None,
        metadata={
            "name": "EXPECTED-TX-TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    external_clock_synchronisation: Boolean | None = field(
        default=None,
        metadata={
            "name": "EXTERNAL-CLOCK-SYNCHRONISATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_ref_offset: Integer | None = field(
        default=None,
        metadata={
            "name": "INITIAL-REF-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    master: Boolean | None = field(
        default=None,
        metadata={
            "name": "MASTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_master_priority: Integer | None = field(
        default=None,
        metadata={
            "name": "TIME-MASTER-PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_triggered_can_level: Integer | None = field(
        default=None,
        metadata={
            "name": "TIME-TRIGGERED-CAN-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tx_enable_window_length: Integer | None = field(
        default=None,
        metadata={
            "name": "TX-ENABLE-WINDOW-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CanControllerAttributes:
        can_controller_configuration: CanControllerConfiguration | None = field(
            default=None,
            metadata={
                "name": "CAN-CONTROLLER-CONFIGURATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        can_controller_configuration_requirements: CanControllerConfigurationRequirements | None = (
            field(
                default=None,
                metadata={
                    "name": "CAN-CONTROLLER-CONFIGURATION-REQUIREMENTS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class UcmDescription:
    """
    This meta-class represents the ability to define an identifier for a given UCM.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar identifier: This attribute represents the unique
        identification of the UcmIdentifier.
    :ivar ucm_module_instantiation_ref: This reference identifies the
        applicable UcmModuleInstantiation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UCM-DESCRIPTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UcmDescription.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UcmDescription.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    identifier: String | None = field(
        default=None,
        metadata={
            "name": "IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ucm_module_instantiation_ref: Optional["UcmDescription.UcmModuleInstantiationRef"] = field(
        default=None,
        metadata={
            "name": "UCM-MODULE-INSTANTIATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class UcmModuleInstantiationRef(Ref):
        dest: UcmModuleInstantiationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class UcmRetryStrategy:
    """
    This meta-class describes the configuration of the retry strategy for a sub-
    class of UcmModuleImplementation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar maximum_number_of_retries: This attribute defines the maximum
        number of time the UCM module instantiation shall attempt a
        retry.
    :ivar retry_interval_time: This attribute defines the time (in
        seconds) between two retry attempts.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UCM-RETRY-STRATEGY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UcmRetryStrategy.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UcmRetryStrategy.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_number_of_retries: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-NUMBER-OF-RETRIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    retry_interval_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "RETRY-INTERVAL-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class UcmToTimeBaseResourceMapping:
    """
    This meta-class maps the UCM Module Instantiation to the TimeSync Module
    Instantiation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar time_base_resource_ref: This reference identifies the relevant
        TimeBaseResource.
    :ivar ucm_ref: This reference identifies the relevant
        UcmModuleInstantiation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UCM-TO-TIME-BASE-RESOURCE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UcmToTimeBaseResourceMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UcmToTimeBaseResourceMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_base_resource_ref: Optional["UcmToTimeBaseResourceMapping.TimeBaseResourceRef"] = field(
        default=None,
        metadata={
            "name": "TIME-BASE-RESOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ucm_ref: Optional["UcmToTimeBaseResourceMapping.UcmRef"] = field(
        default=None,
        metadata={
            "name": "UCM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimeBaseResourceRef(Ref):
        dest: TimeBaseResourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class UcmRef(Ref):
        dest: UcmModuleInstantiationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class UdpNmClusterCoupling:
    """
    Udp attributes that are valid for each of the referenced (coupled) UdpNm
    clusters.

    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        NmConfig.nmClusterCoupling
    :ivar coupled_cluster_refs: Reference to coupled UdpNm Clusters.
    :ivar nm_bus_load_reduction_enabled: Enables busload reduction
        support
    :ivar nm_immediate_restart_enabled: Enables the asynchronous
        transmission of a CanNm PDU upon bus-communication request in
        Prepare-Bus-Sleep mode.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UDP-NM-CLUSTER-COUPLING"

    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    coupled_cluster_refs: Optional["UdpNmClusterCoupling.CoupledClusterRefs"] = field(
        default=None,
        metadata={
            "name": "COUPLED-CLUSTER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_bus_load_reduction_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-BUS-LOAD-REDUCTION-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_immediate_restart_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-IMMEDIATE-RESTART-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CoupledClusterRefs:
        coupled_cluster_ref: list["UdpNmClusterCoupling.CoupledClusterRefs.CoupledClusterRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "COUPLED-CLUSTER-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class CoupledClusterRef(Ref):
            dest: UdpNmClusterSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class UdpNmNode:
    """
    Udp specific NM Node attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar controller_ref: Association to an CommunicationController in
        the topology description.
    :ivar machine_ref: Reference to the machine that contains the
        NmNode.
    :ivar nm_coord_cluster: NmCoordinationCluster identification number.
    :ivar nm_coordinator_role: This attribute indicates the role the NM
        Coordinator will have on this channel.
    :ivar nm_if_ecu_ref: Reference to the NmEcu that contains this
        NmNode. (CommunicationController that is referenced by the
        NmNode shall be contained in the EcuInstance that is referenced
        by the NmEcu).
    :ivar nm_node_id: Node identifier of local NmNode. Shall be unique
        in the NmCluster.
    :ivar nm_passive_mode_enabled: Enables support of the Passive Mode.
        The passive mode is configurable per channel.
    :ivar rx_nm_pdu_refs: receive NM Pdu.
    :ivar tx_nm_pdu_refs: transmit NM Pdu
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: NmCluster.nmNode
    :ivar all_nm_messages_keep_awake: Specifies if Nm drops irrelevant
        NM PDUs. false: Only NM PDUs with a Partial Network Information
        Bit (PNI) = true and containing a Partial Network request for
        this ECU trigger the standard RX indication handling and thus
        keep the ECU awake true: Every NM PDU triggers the standard RX
        indication handling and keeps the ECU awake
    :ivar communication_connector_ref: Reference to the
        CommunicationConnector that represents the UdpNmNode in the
        topology description.
    :ivar nm_msg_cycle_offset: Node specific time offset in the periodic
        transmission node. It determines the start delay of the
        transmission. Specified in seconds.
    :ivar nm_pn_handle_multiple_network_requests: Specifies if NM
        performs an additional transition from Network Mode to Repeat
        Message State (true) or not (false).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UDP-NM-NODE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UdpNmNode.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UdpNmNode.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    controller_ref: Optional["UdpNmNode.ControllerRef"] = field(
        default=None,
        metadata={
            "name": "CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    machine_ref: Optional["UdpNmNode.MachineRef"] = field(
        default=None,
        metadata={
            "name": "MACHINE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_coord_cluster: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-COORD-CLUSTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_coordinator_role: NmCoordinatorRoleEnum | None = field(
        default=None,
        metadata={
            "name": "NM-COORDINATOR-ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_if_ecu_ref: Optional["UdpNmNode.NmIfEcuRef"] = field(
        default=None,
        metadata={
            "name": "NM-IF-ECU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_id: Integer | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_passive_mode_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-PASSIVE-MODE-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rx_nm_pdu_refs: Optional["UdpNmNode.RxNmPduRefs"] = field(
        default=None,
        metadata={
            "name": "RX-NM-PDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tx_nm_pdu_refs: Optional["UdpNmNode.TxNmPduRefs"] = field(
        default=None,
        metadata={
            "name": "TX-NM-PDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    all_nm_messages_keep_awake: Boolean | None = field(
        default=None,
        metadata={
            "name": "ALL-NM-MESSAGES-KEEP-AWAKE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_ref: Optional["UdpNmNode.CommunicationConnectorRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_msg_cycle_offset: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-MSG-CYCLE-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_pn_handle_multiple_network_requests: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-PN-HANDLE-MULTIPLE-NETWORK-REQUESTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ControllerRef(Ref):
        dest: CommunicationControllerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MachineRef(Ref):
        dest: MachineDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NmIfEcuRef(Ref):
        dest: NmEcuSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RxNmPduRefs:
        rx_nm_pdu_ref: list["UdpNmNode.RxNmPduRefs.RxNmPduRef"] = field(
            default_factory=list,
            metadata={
                "name": "RX-NM-PDU-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RxNmPduRef(Ref):
            dest: NmPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TxNmPduRefs:
        tx_nm_pdu_ref: list["UdpNmNode.TxNmPduRefs.TxNmPduRef"] = field(
            default_factory=list,
            metadata={
                "name": "TX-NM-PDU-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TxNmPduRef(Ref):
            dest: NmPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: EthernetCommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Unit:
    """This is a physical measurement unit. All units that might be defined should
    stem from SI units. In order to convert one unit into another factor and offset
    are defined. For the calculation from SI-unit to the defined unit the factor
    (factorSiToUnit ) and the offset.

    (offsetSiToUnit ) are applied as follows:
    x  [{unit}]  :=  y * [{siUnit}] * factorSiToUnit [[unit]/{siUnit}] + offsetSiToUnit [{unit}]
    For the calculation from a unit to SI-unit the reciprocal of the factor (factorSiToUnit ) and the negation of the offset (offsetSiToUnit ) are applied.
    y {siUnit} := (x*{unit} - offsetSiToUnit [{unit}]) / (factorSiToUnit [[unit]/{siUnit}]

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar display_name: This specifies how the unit shall be displayed
        in documents or in user interfaces of tools.The displayName
        corresponds to the Unit.Display in an ASAM MCD-2MC file.
    :ivar factor_si_to_unit: This is the factor for the conversion from
        SI Units to units. The inverse is used for conversion from units
        to SI Units.
    :ivar offset_si_to_unit: This is the offset for the conversion from
        and to siUnits.
    :ivar physical_dimension_ref: This association represents the
        physical dimension to which the unit belongs to. Note that only
        values with units of the same physical dimensions might be
        converted.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UNIT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Unit.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Unit.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    display_name: SingleLanguageUnitNames | None = field(
        default=None,
        metadata={
            "name": "DISPLAY-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    factor_si_to_unit: Float | None = field(
        default=None,
        metadata={
            "name": "FACTOR-SI-TO-UNIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offset_si_to_unit: Float | None = field(
        default=None,
        metadata={
            "name": "OFFSET-SI-TO-UNIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_dimension_ref: Optional["Unit.PhysicalDimensionRef"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-DIMENSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PhysicalDimensionRef(Ref):
        dest: PhysicalDimensionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class UnitGroup:
    """This meta-class represents the ability to specify a logical grouping of
    units.The category denotes the unit system that the referenced units are
    associated to.

    In this way, e.g. country-specific unit systems (CATEGORY="COUNTRY")
    can be defined as well as specific unit systems for certain
    application domains. In the same way a group of equivalent units,
    can be defined which are used in different countries, by setting
    CATEGORY="EQUIV_UNITS".  KmPerHour and MilesPerHour could such be
    combined to one group named "vehicle_speed". The unit MeterPerSec
    would not belong to this group because it is normally not used for
    vehicle speed. But all of the mentioned units could be combined to
    one group named "speed". Note that the UnitGroup does not ensure the
    physical compliance of the units. This is maintained by the physical
    dimension.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar unit_refs: This represents one particular unit in the
        UnitGroup.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UNIT-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UnitGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UnitGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_refs: Optional["UnitGroup.UnitRefs"] = field(
        default=None,
        metadata={
            "name": "UNIT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class UnitRefs:
        unit_ref: list["UnitGroup.UnitRefs.UnitRef"] = field(
            default_factory=list,
            metadata={
                "name": "UNIT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class UnitRef(Ref):
            dest: UnitSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class UserDefinedCommunicationControllerConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar wake_up_by_controller_supported: Defines whether the ECU shall
        be woken up by this CommunicationController. TRUE: wake up is
        possible FALSE: wake up is not supported Note: If
        wakeUpByControllerSupported is set to TRUE the feature shall be
        supported by both hardware and basic software.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-COMMUNICATION-CONTROLLER-CONDITIONAL"

    wake_up_by_controller_supported: Boolean | None = field(
        default=None,
        metadata={
            "name": "WAKE-UP-BY-CONTROLLER-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class UserDefinedEventDeployment:
    """
    UserDefined configuration settings for an Event.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar event_ref: Reference to an Event that is deployed to a
        middleware transport layer.
    :ivar trigger_ref: Reference to a Trigger that is deployed to a
        middleware transport layer.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-EVENT-DEPLOYMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UserDefinedEventDeployment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedEventDeployment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["UserDefinedEventDeployment.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_ref: Optional["UserDefinedEventDeployment.TriggerRef"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedGlobalTimeMaster:
    """
    This represents the specialization of the GlobalTimeMaster for user defined
    communication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_connector_ref: The GlobalTimeMaster is bound to
        the CommunicationConnector.
    :ivar icv_secured: Defines whether an Integrity Check Value (ICV)
        shall be added to the sent time sync messages.
    :ivar immediate_resume_time: Defines the minimum time between an
        "immediate" message and the next periodic message.
    :ivar is_system_wide_global_time_master: If set to TRUE, the
        GlobalTimeMaster is supposed to act as the root of global time
        information.
    :ivar sync_period: This represents the period. Unit: seconds
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        GlobalTimeDomain.globalTimeMaster Not Applicable for:
        GlobalTimeDomain.master
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-GLOBAL-TIME-MASTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UserDefinedGlobalTimeMaster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedGlobalTimeMaster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_ref: Optional[
        "UserDefinedGlobalTimeMaster.CommunicationConnectorRef"
    ] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    icv_secured: GlobalTimeIcvSupportEnum | None = field(
        default=None,
        metadata={
            "name": "ICV-SECURED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    immediate_resume_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "IMMEDIATE-RESUME-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_system_wide_global_time_master: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-SYSTEM-WIDE-GLOBAL-TIME-MASTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SYNC-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedGlobalTimeSlave:
    """
    This represents the specialization of the GlobalTimeSlave for user defined
    communication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_connector_ref: The GlobalTimeSlave is bound to
        the CommunicationConnector.
    :ivar follow_up_timeout_value: Rx timeout for the follow-up message.
    :ivar icv_verification: Defines how an Integrity Check Value (ICV)
        shall be handled at the receiver.
    :ivar time_leap_future_threshold: Defines the maximum allowed
        positive difference between the current Local Time Base value
        and a newly received Global Time Base value.
    :ivar time_leap_healing_counter: Defines the required number of
        updates to the Time Base where the time difference to the
        previous received value has to remain within the bounds of
        timeLeapFutureThreshold and timeLeapPastThreshold until that
        Time Base is considered healed.
    :ivar time_leap_past_threshold: Defines the maximum allowed negative
        difference between the current Local Time Base value and a newly
        received Global Time Base value.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: GlobalTimeDomain.slave
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-GLOBAL-TIME-SLAVE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UserDefinedGlobalTimeSlave.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedGlobalTimeSlave.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_ref: Optional[
        "UserDefinedGlobalTimeSlave.CommunicationConnectorRef"
    ] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    follow_up_timeout_value: TimeValue | None = field(
        default=None,
        metadata={
            "name": "FOLLOW-UP-TIMEOUT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    icv_verification: GlobalTimeIcvVerificationEnum | None = field(
        default=None,
        metadata={
            "name": "ICV-VERIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_leap_future_threshold: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-LEAP-FUTURE-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_leap_healing_counter: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TIME-LEAP-HEALING-COUNTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_leap_past_threshold: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-LEAP-PAST-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedIPdu:
    """UserDefinedIPdu allows to describe PDU-based communication over Complex
    Drivers.

    If a new BSW module is added above the PduR (e.g. a Diagnostic
    Service ) then this IPdu element shall be used to describe the
    communication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar has_dynamic_length: This attribute defines whether the Pdu has
        dynamic length (true) or not (false). Please note that the usage
        of this attribute is restricted by [constr_3448].
    :ivar length: Pdu length in bytes. In case of dynamic length IPdus
        (containing a dynamical length signal), this value indicates the
        maximum data length. It should be noted that in former AUTOSAR
        releases (Rel 2.1, Rel 3.0, Rel 3.1, Rel 4.0 Rev. 1) this
        parameter was defined in bits. The Pdu length of zero bytes is
        allowed.
    :ivar meta_data_length: Number of additional bytes of MetaData in
        the PDU data field. The MetaData contains auxiliary information
        for the PDU, e.g. the CAN ID.
    :ivar contained_i_pdu_props: Defines whether this IPdu may be
        collected inside a ContainerIPdu.
    :ivar cdd_type: This attribute defines the CDD that transmits or
        receives the UserDefinedPdu. If several CDDs are defined this
        attribute is used to distinguish between them.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-I-PDU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UserDefinedIPdu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedIPdu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_dynamic_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-DYNAMIC-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "META-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_i_pdu_props: ContainedIPduProps | None = field(
        default=None,
        metadata={
            "name": "CONTAINED-I-PDU-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cdd_type: String | None = field(
        default=None,
        metadata={
            "name": "CDD-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedMethodDeployment:
    """
    UserDefined configuration settings for a Method.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar method_ref: Reference to a method that is deployed to a
        middleware transport layer.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-METHOD-DEPLOYMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UserDefinedMethodDeployment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedMethodDeployment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_ref: Optional["UserDefinedMethodDeployment.MethodRef"] = field(
        default=None,
        metadata={
            "name": "METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MethodRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedPdu:
    """UserDefinedPdu allows to describe PDU-based communication over Complex
    Drivers.

    If a new BSW module is added above the BusIf (e.g. a new Nm module)
    then this Pdu element shall be used to describe the communication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar has_dynamic_length: This attribute defines whether the Pdu has
        dynamic length (true) or not (false). Please note that the usage
        of this attribute is restricted by [constr_3448].
    :ivar length: Pdu length in bytes. In case of dynamic length IPdus
        (containing a dynamical length signal), this value indicates the
        maximum data length. It should be noted that in former AUTOSAR
        releases (Rel 2.1, Rel 3.0, Rel 3.1, Rel 4.0 Rev. 1) this
        parameter was defined in bits. The Pdu length of zero bytes is
        allowed.
    :ivar meta_data_length: Number of additional bytes of MetaData in
        the PDU data field. The MetaData contains auxiliary information
        for the PDU, e.g. the CAN ID.
    :ivar cdd_type: This attribute defines the CDD that transmits or
        receives the UserDefinedIPdu. If several CDDs are defined this
        attribute is used to distinguish between them.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-PDU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UserDefinedPdu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedPdu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_dynamic_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-DYNAMIC-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "META-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cdd_type: String | None = field(
        default=None,
        metadata={
            "name": "CDD-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedServiceInstanceToMachineMapping:
    """
    This meta-class allows to map UserDefinedServiceInstances to a
    CommunicationConnector of a Machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_connector_ref: Reference to the Machine to which
        the ServiceInstance is mapped.
    :ivar sec_oc_com_props_for_multicast_refs: Reference to
        communication security configuration settings that are valid for
        the udp multicast endpoint (Port + Multicast IP Address) defined
        by the ServiceInstanceToMachineMapping.
    :ivar secure_com_props_for_tcp_ref: Reference to communication
        security configuration settings that are valid for the tcp
        unicast endpoint (Tcp Port + Unicast IP Address) defined by the
        ServiceInstanceToMachineMapping.
    :ivar secure_com_props_for_udp_ref: Reference to communication
        security configuration settings that are valid for the udp
        unicast endpoint (Udp Port + Unicast IP Address) defined by the
        ServiceInstanceToMachineMapping.
    :ivar service_instance_refs: Reference to a ServiceInstance that is
        mapped to the Machine.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-SERVICE-INSTANCE-TO-MACHINE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "UserDefinedServiceInstanceToMachineMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedServiceInstanceToMachineMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connector_ref: Optional[
        "UserDefinedServiceInstanceToMachineMapping.CommunicationConnectorRef"
    ] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sec_oc_com_props_for_multicast_refs: Optional[
        "UserDefinedServiceInstanceToMachineMapping.SecOcComPropsForMulticastRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SEC-OC-COM-PROPS-FOR-MULTICAST-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_com_props_for_tcp_ref: Optional[
        "UserDefinedServiceInstanceToMachineMapping.SecureComPropsForTcpRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECURE-COM-PROPS-FOR-TCP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_com_props_for_udp_ref: Optional[
        "UserDefinedServiceInstanceToMachineMapping.SecureComPropsForUdpRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECURE-COM-PROPS-FOR-UDP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_refs: Optional[
        "UserDefinedServiceInstanceToMachineMapping.ServiceInstanceRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectorRef(Ref):
        dest: CommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecOcComPropsForMulticastRefs:
        sec_oc_com_props_for_multicast_ref: list[
            "UserDefinedServiceInstanceToMachineMapping.SecOcComPropsForMulticastRefs.SecOcComPropsForMulticastRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SEC-OC-COM-PROPS-FOR-MULTICAST-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SecOcComPropsForMulticastRef(Ref):
            dest: SecOcSecureComPropsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SecureComPropsForTcpRef(Ref):
        dest: SecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecureComPropsForUdpRef(Ref):
        dest: SecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRefs:
        service_instance_ref: list[
            "UserDefinedServiceInstanceToMachineMapping.ServiceInstanceRefs.ServiceInstanceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceInstanceRef(Ref):
            dest: AdaptivePlatformServiceInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class UserDefinedTransformationComSpecProps:
    """
    The UserDefinedTransformationComSpecProps is used to specify port specific
    configuration properties for custom transformers.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-TRANSFORMATION-COM-SPEC-PROPS"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class UserDefinedTransformationDescription:
    """
    The UserDefinedTransformationDescription is used to specify details and
    documentation for custom transformers.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TransformationTechnology.transformationDescription
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-TRANSFORMATION-DESCRIPTION"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class UserDefinedTransformationISignalPropsConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar cs_error_reaction: Defines whether the transformer chain of
        client/server communication coordinates an autonomous error
        reaction together with the RTE or whether any error reaction is
        the responsibility of the application.
    :ivar data_prototype_transformation_propss: Fine granular modeling
        of TransfromationProps on the level of DataPrototypes.
    :ivar transformer_ref: Reference to the TransformationTechnology
        description that contains transformer specific and ISignal
        independent configuration properties.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-TRANSFORMATION-I-SIGNAL-PROPS-CONDITIONAL"

    cs_error_reaction: CsTransformerErrorReactionEnum | None = field(
        default=None,
        metadata={
            "name": "CS-ERROR-REACTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototype_transformation_propss: Optional[
        "UserDefinedTransformationISignalPropsConditional.DataPrototypeTransformationPropss"
    ] = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-TRANSFORMATION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformer_ref: Optional["UserDefinedTransformationISignalPropsConditional.TransformerRef"] = (
        field(
            default=None,
            metadata={
                "name": "TRANSFORMER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataPrototypeTransformationPropss:
        data_prototype_transformation_props: list[DataPrototypeTransformationProps] = field(
            default_factory=list,
            metadata={
                "name": "DATA-PROTOTYPE-TRANSFORMATION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TransformerRef(Ref):
        dest: TransformationTechnologySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedTransformationProps:
    """
    The class UserDefinedTransformationProps specifies  specific configuration
    properties of a user defined serializer.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-TRANSFORMATION-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UserDefinedTransformationProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedTransformationProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class V2XDataManagerNeeds:
    """
    This meta-class represents the ability to define service needs for V2x Data
    Manager.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "V-2-X-DATA-MANAGER-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["V2XDataManagerNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["V2XDataManagerNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class V2XFacUserNeeds:
    """
    This meta-class represents the ability to define service needs for V2x
    facilities.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "V-2-X-FAC-USER-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["V2XFacUserNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["V2XFacUserNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class V2XMUserNeeds:
    """
    This meta-class represents the ability to express service needs for the V2x
    management.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "V-2-X-M-USER-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["V2XMUserNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["V2XMUserNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class VariableAccess:
    """The presence of a VariableAccess implies that a RunnableEntity needs access
    to a VariableDataPrototype.

    The kind of access is specified by the role in which the class is
    used.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar return_value_provision: This attribute controls the provision
        of return values for RTE APIs that correspond to the enclosing
        access point.
    :ivar accessed_variable: This denotes the accessed variable.
    :ivar scope: This attribute allows for constraining the scope of the
        corresponding communication. For example, it possible to express
        whether the communication is intended to cross the boundary of
        an ECU or whether it is intended not to cross the boundary of a
        single partition.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RunnableEntity.writtenLocalVariable Applicable for:
        RunnableEntity.dataReceivePointByValue Applicable for:
        RunnableEntity.readLocalVariable Applicable for:
        RunnableEntity.dataSendPoint Applicable for:
        RunnableEntity.dataReadAccess Applicable for:
        RunnableEntity.dataWriteAccess Applicable for:
        RunnableEntity.dataReceivePointByArgument Not Applicable for:
        ReceiverComSpec.replaceWith
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VARIABLE-ACCESS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["VariableAccess.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["VariableAccess.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    return_value_provision: RteApiReturnValueProvisionEnum | None = field(
        default=None,
        metadata={
            "name": "RETURN-VALUE-PROVISION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    accessed_variable: AutosarVariableRef | None = field(
        default=None,
        metadata={
            "name": "ACCESSED-VARIABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: VariableAccessScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class VariableDataPrototypeInCompositionInstanceRef:
    """
    This meta-class represents the ability to define an InstanceRef to a
    VariableDataPrototype in the context of a CompositionSwComponentType.

    :ivar context_sw_component_prototype_ref: This represents the nested
        structure of SwComponentPrototypes.
    :ivar context_port_prototype_ref: This represents a reference to a
        context PortPrototype.
    :ivar target_variable_data_prototype_ref: This represents the target
        VariableDataPrototype.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DataPrototypeGroup.implicitDataAccess
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VARIABLE-DATA-PROTOTYPE-IN-COMPOSITION-INSTANCE-REF"

    context_sw_component_prototype_ref: list[
        "VariableDataPrototypeInCompositionInstanceRef.ContextSwComponentPrototypeRef"
    ] = field(
        default_factory=list,
        metadata={
            "name": "CONTEXT-SW-COMPONENT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_port_prototype_ref: Optional[
        "VariableDataPrototypeInCompositionInstanceRef.ContextPortPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "CONTEXT-PORT-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_variable_data_prototype_ref: Optional[
        "VariableDataPrototypeInCompositionInstanceRef.TargetVariableDataPrototypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "TARGET-VARIABLE-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ContextSwComponentPrototypeRef(Ref):
        dest: SwComponentPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ContextPortPrototypeRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TargetVariableDataPrototypeRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class VariationPointProxy:
    """The VariationPointProxy represents variation points of the C/C++
    implementation.

    In case of bindingTime = compileTime the RTE provides defines which
    can be used for Pre Processor directives to implement compileTime
    variability.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar condition_access: This condition acts as Binding Function for
        the VariationPoint.
    :ivar implementation_data_type_ref: This association to
        ImplementationDataType shall be taken as an implementation hint
        by the RTE generator.
    :ivar post_build_value_access_ref: This represents the applicable
        PostBuildVariantCriterion in the context of a
        VariationPointProxy. Note that the technical details how to
        access the particular postBuildValueAccess are still considered
        internal to the RTE and are consequently not standardized.
    :ivar post_build_variant_conditions: This represents that applicable
        PostBuoldVariantCondition in the context of
        aVariationPointProxy.
    :ivar value_access: This value acts as Binding Function for the
        VariationPoint.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VARIATION-POINT-PROXY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["VariationPointProxy.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["VariationPointProxy.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    condition_access: ConditionByFormula | None = field(
        default=None,
        metadata={
            "name": "CONDITION-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_data_type_ref: Optional["VariationPointProxy.ImplementationDataTypeRef"] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-DATA-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_value_access_ref: Optional["VariationPointProxy.PostBuildValueAccessRef"] = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VALUE-ACCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_conditions: Optional["VariationPointProxy.PostBuildVariantConditions"] = (
        field(
            default=None,
            metadata={
                "name": "POST-BUILD-VARIANT-CONDITIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    value_access: Optional["VariationPointProxy.ValueAccess"] = field(
        default=None,
        metadata={
            "name": "VALUE-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationDataTypeRef(Ref):
        dest: AbstractImplementationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PostBuildValueAccessRef(Ref):
        dest: PostBuildVariantCriterionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PostBuildVariantConditions:
        post_build_variant_condition: list[PostBuildVariantCondition] = field(
            default_factory=list,
            metadata={
                "name": "POST-BUILD-VARIANT-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueAccess:
        boolean_value_variation_point: BooleanValueVariationPoint | None = field(
            default=None,
            metadata={
                "name": "BOOLEAN-VALUE-VARIATION-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_debounce_behavior_enum_value_variation_point: (
            DiagnosticDebounceBehaviorEnumValueVariationPoint | None
        ) = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-DEBOUNCE-BEHAVIOR-ENUM-VALUE-VARIATION-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_indicator_type_enum_value_variation_point: (
            DiagnosticIndicatorTypeEnumValueVariationPoint | None
        ) = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-INDICATOR-TYPE-ENUM-VALUE-VARIATION-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_test_result_update_enum_value_variation_point: (
            DiagnosticTestResultUpdateEnumValueVariationPoint | None
        ) = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-TEST-RESULT-UPDATE-ENUM-VALUE-VARIATION-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_wwh_obd_dtc_class_enum_value_variation_point: (
            DiagnosticWwhObdDtcClassEnumValueVariationPoint | None
        ) = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-WWH-OBD-DTC-CLASS-ENUM-VALUE-VARIATION-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        float_value_variation_point: FloatValueVariationPoint | None = field(
            default=None,
            metadata={
                "name": "FLOAT-VALUE-VARIATION-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        integer_value_variation_point: IntegerValueVariationPoint | None = field(
            default=None,
            metadata={
                "name": "INTEGER-VALUE-VARIATION-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        limit: Limit | None = field(
            default=None,
            metadata={
                "name": "LIMIT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        name_token_value_variation_point: NameTokenValueVariationPoint | None = field(
            default=None,
            metadata={
                "name": "NAME-TOKEN-VALUE-VARIATION-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_value_variation_point: NumericalValueVariationPoint | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-VARIATION-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        positive_integer_value_variation_point: PositiveIntegerValueVariationPoint | None = field(
            default=None,
            metadata={
                "name": "POSITIVE-INTEGER-VALUE-VARIATION-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        time_value_value_variation_point: TimeValueValueVariationPoint | None = field(
            default=None,
            metadata={
                "name": "TIME-VALUE-VALUE-VARIATION-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        unlimited_integer_value_variation_point: UnlimitedIntegerValueVariationPoint | None = field(
            default=None,
            metadata={
                "name": "UNLIMITED-INTEGER-VALUE-VARIATION-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class VendorSpecificServiceNeeds:
    """
    This represents the ability to define vendor-specific service needs.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VENDOR-SPECIFIC-SERVICE-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["VendorSpecificServiceNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["VendorSpecificServiceNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class VlanConfig:
    """
    VLAN Configuration attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar vlan_identifier: A VLAN is identified by this attribute
        according to IEEE 802.1Q. The allowed values range is from
        0..4095.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VLAN-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["VlanConfig.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["VlanConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vlan_identifier: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VLAN-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class WaitPoint:
    """
    This defines a wait-point for which the RunnableEntity can wait.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar timeout: Time in seconds before the WaitPoint times out and
        the blocking wait call returns with an error indicating the
        timeout.
    :ivar trigger_ref: This is the RTEEvent this WaitPoint is waiting
        for.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "WAIT-POINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["WaitPoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["WaitPoint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_ref: Optional["WaitPoint.TriggerRef"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerRef(Ref):
        dest: RteEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class WarningIndicatorRequestedBitNeeds:
    """
    This meta-class represents the ability to explicitly request the existence of
    the WarningIndicatorRequestedBit.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "WARNING-INDICATOR-REQUESTED-BIT-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["WarningIndicatorRequestedBitNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["WarningIndicatorRequestedBitNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["WarningIndicatorRequestedBitNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class WorstCaseHeapUsage:
    """
    Provides a formal worst case heap usage.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar hardware_configuration: Contains information about the
        hardware context this heap usage is describing.
    :ivar hw_element_ref: Specifies for which hardware element (e.g.
        ECU) this heap usage  usage is given.
    :ivar software_context: Contains details about the software context
        this heap usage is provided for.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ResourceConsumption.heapUsage
    :ivar memory_consumption: Worst case heap consumption. Unit: byte.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "WORST-CASE-HEAP-USAGE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["WorstCaseHeapUsage.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["WorstCaseHeapUsage.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hardware_configuration: HardwareConfiguration | None = field(
        default=None,
        metadata={
            "name": "HARDWARE-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_element_ref: Optional["WorstCaseHeapUsage.HwElementRef"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_context: SoftwareContext | None = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CONTEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_consumption: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MEMORY-CONSUMPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwElementRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class WorstCaseStackUsage:
    """
    Provides a formal worst case stack usage.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar executable_entity_ref: The executable entity for which this
        stack usage is described.
    :ivar hardware_configuration: Contains information about the
        hardware context this stack usage is describing.
    :ivar hw_element_ref: Specifies for which hardware element (e.g.
        ECU) this stack usage is given.
    :ivar software_context: Contains details about the software context
        this stack usage is provided for.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ResourceConsumption.stackUsage
    :ivar memory_consumption: Worst case stack consumption. Unit: byte.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "WORST-CASE-STACK-USAGE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["WorstCaseStackUsage.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["WorstCaseStackUsage.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    executable_entity_ref: Optional["WorstCaseStackUsage.ExecutableEntityRef"] = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-ENTITY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hardware_configuration: HardwareConfiguration | None = field(
        default=None,
        metadata={
            "name": "HARDWARE-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_element_ref: Optional["WorstCaseStackUsage.HwElementRef"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_context: SoftwareContext | None = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CONTEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_consumption: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MEMORY-CONSUMPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutableEntityRef(Ref):
        dest: ExecutableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class HwElementRef(Ref):
        dest: HwElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class XcpPdu:
    """This element is deprecated and will be removed in future.

    The GeneralPurposeIPdu with the category "XCP" shall be used instead.
    Old description:
    AUTOSAR XCP Pdu.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar has_dynamic_length: This attribute defines whether the Pdu has
        dynamic length (true) or not (false). Please note that the usage
        of this attribute is restricted by [constr_3448].
    :ivar length: Pdu length in bytes. In case of dynamic length IPdus
        (containing a dynamical length signal), this value indicates the
        maximum data length. It should be noted that in former AUTOSAR
        releases (Rel 2.1, Rel 3.0, Rel 3.1, Rel 4.0 Rev. 1) this
        parameter was defined in bits. The Pdu length of zero bytes is
        allowed.
    :ivar meta_data_length: Number of additional bytes of MetaData in
        the PDU data field. The MetaData contains auxiliary information
        for the PDU, e.g. the CAN ID.
    :ivar contained_i_pdu_props: Defines whether this IPdu may be
        collected inside a ContainerIPdu.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "XCP-PDU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["XcpPdu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["XcpPdu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_dynamic_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-DYNAMIC-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "META-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_i_pdu_props: ContainedIPduProps | None = field(
        default=None,
        metadata={
            "name": "CONTAINED-I-PDU-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class AccessCountSet:
    """
    This meta-class provides a set of count values evaluated according to the rules
    of a specific countProfile.

    :ivar access_counts: Count value for a AbstractAccessPoint.
    :ivar count_profile: This attribute defines the name of the count
        profile used to determine the AccessCount.value numbers.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ResourceConsumption.accessCountSet
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ACCESS-COUNT-SET"

    access_counts: Optional["AccessCountSet.AccessCounts"] = field(
        default=None,
        metadata={
            "name": "ACCESS-COUNTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    count_profile: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "COUNT-PROFILE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AccessCounts:
        access_count: list[AccessCount] = field(
            default_factory=list,
            metadata={
                "name": "ACCESS-COUNT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class AggregationTailoring:
    """
    Tailoring of aggregations in the AUTOSAR meta-model.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alternative_name: Alternative name of a specification element
        if its name doesn't fit into the shortName. E.g. because the
        name contains spaces.
    :ivar in_scope: indicates, if a specification element is relevant
        for this data exchange point. It is relevant if inScope==true.
        It is not relevant or don't care if inScope=false.
    :ivar multiplicity_restriction: Multiplicity restriction of the
        attribute
    :ivar variation_restriction: Restrictions on the usage of variant
        handling.
    :ivar type_tailorings: Local class tailoring which is applied if the
        content is contained by this aggregation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AGGREGATION-TAILORING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AggregationTailoring.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AggregationTailoring.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alternative_name: String | None = field(
        default=None,
        metadata={
            "name": "ALTERNATIVE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    in_scope: Boolean | None = field(
        default=None,
        metadata={
            "name": "IN-SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiplicity_restriction: MultiplicityRestrictionWithSeverity | None = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-RESTRICTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_restriction: VariationRestrictionWithSeverity | None = field(
        default=None,
        metadata={
            "name": "VARIATION-RESTRICTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_tailorings: Optional["AggregationTailoring.TypeTailorings"] = field(
        default=None,
        metadata={
            "name": "TYPE-TAILORINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TypeTailorings:
        abstract_class_tailoring: list[AbstractClassTailoring] = field(
            default_factory=list,
            metadata={
                "name": "ABSTRACT-CLASS-TAILORING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_class_tailoring: list["ConcreteClassTailoring"] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-CLASS-TAILORING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class AliasNameSet:
    """This meta-class represents a set of AliasNames.

    The AliasNameSet can for example be an input to the A2L-Generator.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar alias_names: AliasNames contained in the AliasNameSet.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ALIAS-NAME-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AliasNameSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AliasNameSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["AliasNameSet.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alias_names: Optional["AliasNameSet.AliasNames"] = field(
        default=None,
        metadata={
            "name": "ALIAS-NAMES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AliasNames:
        alias_name_assignment: list[AliasNameAssignment] = field(
            default_factory=list,
            metadata={
                "name": "ALIAS-NAME-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApplicationArrayDataType:
    """
    An application data type which is an array, each element is of the same
    application data type.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar sw_data_def_props: The properties of this AutosarDataType.
    :ivar dynamic_array_size_profile: Specifies the profile which the
        array will follow if it is a variable size array.
    :ivar element: This association implements the concept of an array
        element. That is, in some cases it is necessary to be able to
        identify single array elements, e.g. as input values for an
        interpolation routine.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-ARRAY-DATA-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApplicationArrayDataType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApplicationArrayDataType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ApplicationArrayDataType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_array_size_profile: String | None = field(
        default=None,
        metadata={
            "name": "DYNAMIC-ARRAY-SIZE-PROFILE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    element: ApplicationArrayElement | None = field(
        default=None,
        metadata={
            "name": "ELEMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApplicationAssocMapDataType:
    """
    An application data type which is a map and consists of a key and a value.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar sw_data_def_props: The properties of this AutosarDataType.
    :ivar key: Key element of the map that is used to uniquely identify
        the value of the map.
    :ivar value: Value element of the map that stores the content
        associated to a key.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-ASSOC-MAP-DATA-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApplicationAssocMapDataType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApplicationAssocMapDataType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ApplicationAssocMapDataType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key: ApplicationAssocMapElement | None = field(
        default=None,
        metadata={
            "name": "KEY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: ApplicationAssocMapElement | None = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApplicationRecordDataType:
    """
    An application data type which can be decomposed into prototypes of other
    application data types.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar sw_data_def_props: The properties of this AutosarDataType.
    :ivar elements: Specifies an element of a record. The aggregation of
        ApplicationRecordElement is subject to variability with the
        purpose to support the conditional existence of elements inside
        a ApplicationrecordData Type.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-RECORD-DATA-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApplicationRecordDataType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApplicationRecordDataType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ApplicationRecordDataType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    elements: Optional["ApplicationRecordDataType.Elements"] = field(
        default=None,
        metadata={
            "name": "ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Elements:
        application_record_element: list[ApplicationRecordElement] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-RECORD-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ArgumentDataPrototype:
    """
    An argument of an operation, much like a data element, but also carries
    direction information and is owned by a particular ClientServerOperation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sw_data_def_props: This property allows to specify data
        definition properties which apply on data prototype level.
    :ivar type_tref: This represents the corresponding data type.
    :ivar direction: This attribute specifies the direction of the
        argument prototype.
    :ivar server_argument_impl_policy: This defines how the argument
        type of the servers RunnableEntity is implemented. If the
        attribute is not defined this has the same semantics as if the
        attribute is set to the value useArgumentType for primitive
        arguments and structures.
    :ivar type_blueprints: This allows to denote the intended type
        within blueprints. It shall be replaced by a proper type when
        deriving Interfaces from the Blueprint. Use instead
        BluePrintPolicySingle. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ClientServerOperation.argument
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ARGUMENT-DATA-PROTOTYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ArgumentDataPrototype.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ArgumentDataPrototype.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_tref: Optional["ArgumentDataPrototype.TypeTref"] = field(
        default=None,
        metadata={
            "name": "TYPE-TREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    direction: ArgumentDirectionEnum | None = field(
        default=None,
        metadata={
            "name": "DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    server_argument_impl_policy: ServerArgumentImplPolicyEnum | None = field(
        default=None,
        metadata={
            "name": "SERVER-ARGUMENT-IMPL-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_blueprints: Optional["ArgumentDataPrototype.TypeBlueprints"] = field(
        default=None,
        metadata={
            "name": "TYPE-BLUEPRINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TypeTref(Ref):
        dest: AutosarDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TypeBlueprints:
        autosar_data_type_ref_conditional: list[AutosarDataTypeRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "AUTOSAR-DATA-TYPE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BinaryManifestProvideResource:
    """
    This meta-class represents a provided resource in the binary manifest.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar global_resource_id: A unique identifiers per resource used for
        the connection process. The identifier is required to be unique
        in the scope of a single machine. If software clusters are
        designed to be reused on multiple machines the uniqueness
        requirements applies for all the intended machines.
    :ivar items: This aggregation represents the collection of binary
        manifest handles owned by the enclosing binary manifest
        resource.
    :ivar resource_definition_ref: this reference identifies the
        definition of the BinaryManifestResource. The definition
        provides configuration information that is shared among all
        BinaryManifestResources that refer to the
        BinaryManifestResourceDefinition.
    :ivar resource_guard_value: This attribute specifies the guard value
        of the enclosing binary manifest resource.
    :ivar resource_ref: This reference identifies the
        CpSoftwareClusterResource (on design level)  that corresponds to
        the BinaryManifestResource (on integration level).
    :ivar number_of_notifier_sets: This attribute provides an upper
        limit for the number of notifiers for this resource.
    :ivar supports_multiple_notifier_sets: This attribute indicates
        whether the enclosing BinaryManifestResource supports multiple
        notifiers sets.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BINARY-MANIFEST-PROVIDE-RESOURCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BinaryManifestProvideResource.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BinaryManifestProvideResource.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_resource_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "GLOBAL-RESOURCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    items: Optional["BinaryManifestProvideResource.Items"] = field(
        default=None,
        metadata={
            "name": "ITEMS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resource_definition_ref: Optional["BinaryManifestProvideResource.ResourceDefinitionRef"] = (
        field(
            default=None,
            metadata={
                "name": "RESOURCE-DEFINITION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    resource_guard_value: String | None = field(
        default=None,
        metadata={
            "name": "RESOURCE-GUARD-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resource_ref: Optional["BinaryManifestProvideResource.ResourceRef"] = field(
        default=None,
        metadata={
            "name": "RESOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    number_of_notifier_sets: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NUMBER-OF-NOTIFIER-SETS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    supports_multiple_notifier_sets: Boolean | None = field(
        default=None,
        metadata={
            "name": "SUPPORTS-MULTIPLE-NOTIFIER-SETS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Items:
        binary_manifest_item: list[BinaryManifestItem] = field(
            default_factory=list,
            metadata={
                "name": "BINARY-MANIFEST-ITEM",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ResourceDefinitionRef(Ref):
        dest: BinaryManifestResourceDefinitionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ResourceRef(Ref):
        dest: CpSoftwareClusterResourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BinaryManifestRequireResource:
    """
    This meta-class represents a required resource in the binary manifest.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar global_resource_id: A unique identifiers per resource used for
        the connection process. The identifier is required to be unique
        in the scope of a single machine. If software clusters are
        designed to be reused on multiple machines the uniqueness
        requirements applies for all the intended machines.
    :ivar items: This aggregation represents the collection of binary
        manifest handles owned by the enclosing binary manifest
        resource.
    :ivar resource_definition_ref: this reference identifies the
        definition of the BinaryManifestResource. The definition
        provides configuration information that is shared among all
        BinaryManifestResources that refer to the
        BinaryManifestResourceDefinition.
    :ivar resource_guard_value: This attribute specifies the guard value
        of the enclosing binary manifest resource.
    :ivar resource_ref: This reference identifies the
        CpSoftwareClusterResource (on design level)  that corresponds to
        the BinaryManifestResource (on integration level).
    :ivar connection_is_mandatory: This attribute indicates whether the
        connection of the enclosing BinaryManifestResource is mandatory.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BINARY-MANIFEST-REQUIRE-RESOURCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BinaryManifestRequireResource.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BinaryManifestRequireResource.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_resource_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "GLOBAL-RESOURCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    items: Optional["BinaryManifestRequireResource.Items"] = field(
        default=None,
        metadata={
            "name": "ITEMS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resource_definition_ref: Optional["BinaryManifestRequireResource.ResourceDefinitionRef"] = (
        field(
            default=None,
            metadata={
                "name": "RESOURCE-DEFINITION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    resource_guard_value: String | None = field(
        default=None,
        metadata={
            "name": "RESOURCE-GUARD-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resource_ref: Optional["BinaryManifestRequireResource.ResourceRef"] = field(
        default=None,
        metadata={
            "name": "RESOURCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    connection_is_mandatory: Boolean | None = field(
        default=None,
        metadata={
            "name": "CONNECTION-IS-MANDATORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Items:
        binary_manifest_item: list[BinaryManifestItem] = field(
            default_factory=list,
            metadata={
                "name": "BINARY-MANIFEST-ITEM",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ResourceDefinitionRef(Ref):
        dest: BinaryManifestResourceDefinitionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ResourceRef(Ref):
        dest: CpSoftwareClusterResourceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BinaryManifestResourceDefinition:
    """
    This meta-class represents the ability to specify a resource definition that
    provides information that can be shared by all resources that refer to the
    respective resource definition.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar item_definitions: This aggregation specifies the collection of
        handle definitions in the context of the enclosing binary
        manifest resource definitions.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BINARY-MANIFEST-RESOURCE-DEFINITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BinaryManifestResourceDefinition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BinaryManifestResourceDefinition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    item_definitions: Optional["BinaryManifestResourceDefinition.ItemDefinitions"] = field(
        default=None,
        metadata={
            "name": "ITEM-DEFINITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ItemDefinitions:
        binary_manifest_item_definition: list[BinaryManifestItemDefinition] = field(
            default_factory=list,
            metadata={
                "name": "BINARY-MANIFEST-ITEM-DEFINITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BswCalledEntity:
    """
    BSW module entity which is designed to be called from another BSW module or
    cluster.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reasons: If the ExecutableEntity provides at least
        one activationReason element the RTE resp. BSW Scheduler shall
        provide means to read the activation vector of this executable
        entity execution. If no activationReason element is provided the
        feature of being able to determine the activating RTEEvent is
        disabled for this ExecutableEntity.
    :ivar can_enters: This means that the executable entity can
        enter/leave the referenced exclusive area through explicit API
        calls. This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar can_enter_exclusive_area_refs: This means that the executable
        entity can enter/leave the referenced exclusive area through
        explicit API calls.
    :ivar exclusive_area_nesting_order_refs: This represents the set of
        ExclusiveAreaNestingOrders recognized by this ExecutableEntity.
    :ivar minimum_start_interval: Specifies the time in seconds by which
        two consecutive starts of an ExecutableEntity are guaranteed to
        be separated.
    :ivar reentrancy_level: The reentrancy level of this
        ExecutableEntity. See the documentation of the enumeration type
        ReentrancyLevelEnum for details. Please note that nonReentrant
        interfaces can have also reentrant or multicoreReentrant
        implementations, and reentrant interfaces can also have
        multicoreReentrant implementations.
    :ivar runs_insides: The executable entity runs completely inside the
        referenced exclusive area. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar runs_inside_exclusive_area_refs: The executable entity runs
        completely inside the referenced exclusive area.
    :ivar sw_addr_method_ref: Addressing method related to this code
        entity. Via an association to the same SwAddrMethod, it can be
        specified that several code entities (even of different modules
        or components)  shall be located in the same memory without
        already specifying the memory section itself.
    :ivar accessed_mode_groups: A mode group which is accessed via API
        call by this entity. It shall be a ModeDeclarationGroupPrototype
        required by this module or cluster. This property was modified
        due to atpVariation (DirectedAssociationPattern).
    :ivar activation_points: Activation point used by the module entity
        to activate one or more internal triggers. This property was
        modified due to atpVariation (DirectedAssociationPattern).
    :ivar call_points: A call point used in the code of this entity. The
        variability of this association is especially targeted at debug
        scenarios: It is possible to have one variant calling into the
        AUTOSAR debug module and another one which doesn't.
    :ivar called_entrys: The entry of another (or the same) BSW module
        which is called by this entry (usually via C function call).
        This information allows to set up a model of call chains. The
        variablity of this association is especially targeted at debug
        scenarios: It is possible to have one variant calling into the
        AUTOSAR debug module and another one which doesn't. Note that
        this relation has been merked as obsolete, since the more
        powerful definition of a callPoint should be used. This property
        was modified due to atpVariation (DirectedAssociationPattern).
    :ivar data_receive_points: The data is received via the BSW
        Scheduler.
    :ivar data_send_points: The data is sent via the BSW Scheduler.
    :ivar implemented_entry_ref: The entry which is implemented by this
        module entity.
    :ivar issued_triggers: A trigger issued by this entity via BSW
        Scheduler API call. It shall be a BswTrigger released (i.e.
        owned) by this module or cluster. This property was modified due
        to atpVariation (DirectedAssociationPattern).
    :ivar managed_mode_groups: A mode group which is managed by this
        entity. It shall be a ModeDeclarationGroupPrototype provided by
        this module or cluster. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar scheduler_name_prefix_ref: A prefix to be used in generated
        names for the BswModuleScheduler in the context of this
        BswModuleEntity, for example entry point prototypes, macros for
        dealing with exclusive areas, header file names. Details are
        defined in the SWS RTE. The prefix supersedes default rules for
        the prefix of those names.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.entity
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-CALLED-ENTITY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswCalledEntity.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswCalledEntity.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reasons: Optional["BswCalledEntity.ActivationReasons"] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_enters: Optional["BswCalledEntity.CanEnters"] = field(
        default=None,
        metadata={
            "name": "CAN-ENTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_enter_exclusive_area_refs: Optional["BswCalledEntity.CanEnterExclusiveAreaRefs"] = field(
        default=None,
        metadata={
            "name": "CAN-ENTER-EXCLUSIVE-AREA-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_area_nesting_order_refs: Optional["BswCalledEntity.ExclusiveAreaNestingOrderRefs"] = (
        field(
            default=None,
            metadata={
                "name": "EXCLUSIVE-AREA-NESTING-ORDER-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    minimum_start_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-START-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reentrancy_level: ReentrancyLevelEnum | None = field(
        default=None,
        metadata={
            "name": "REENTRANCY-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runs_insides: Optional["BswCalledEntity.RunsInsides"] = field(
        default=None,
        metadata={
            "name": "RUNS-INSIDES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runs_inside_exclusive_area_refs: Optional["BswCalledEntity.RunsInsideExclusiveAreaRefs"] = (
        field(
            default=None,
            metadata={
                "name": "RUNS-INSIDE-EXCLUSIVE-AREA-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    sw_addr_method_ref: Optional["BswCalledEntity.SwAddrMethodRef"] = field(
        default=None,
        metadata={
            "name": "SW-ADDR-METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    accessed_mode_groups: Optional["BswCalledEntity.AccessedModeGroups"] = field(
        default=None,
        metadata={
            "name": "ACCESSED-MODE-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_points: Optional["BswCalledEntity.ActivationPoints"] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    call_points: Optional["BswCalledEntity.CallPoints"] = field(
        default=None,
        metadata={
            "name": "CALL-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    called_entrys: Optional["BswCalledEntity.CalledEntrys"] = field(
        default=None,
        metadata={
            "name": "CALLED-ENTRYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_receive_points: Optional["BswCalledEntity.DataReceivePoints"] = field(
        default=None,
        metadata={
            "name": "DATA-RECEIVE-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_send_points: Optional["BswCalledEntity.DataSendPoints"] = field(
        default=None,
        metadata={
            "name": "DATA-SEND-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implemented_entry_ref: Optional["BswCalledEntity.ImplementedEntryRef"] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTED-ENTRY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    issued_triggers: Optional["BswCalledEntity.IssuedTriggers"] = field(
        default=None,
        metadata={
            "name": "ISSUED-TRIGGERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    managed_mode_groups: Optional["BswCalledEntity.ManagedModeGroups"] = field(
        default=None,
        metadata={
            "name": "MANAGED-MODE-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scheduler_name_prefix_ref: Optional["BswCalledEntity.SchedulerNamePrefixRef"] = field(
        default=None,
        metadata={
            "name": "SCHEDULER-NAME-PREFIX-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasons:
        executable_entity_activation_reason: list[ExecutableEntityActivationReason] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTABLE-ENTITY-ACTIVATION-REASON",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CanEnters:
        exclusive_area_ref_conditional: list[ExclusiveAreaRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CanEnterExclusiveAreaRefs:
        can_enter_exclusive_area_ref: list[
            "BswCalledEntity.CanEnterExclusiveAreaRefs.CanEnterExclusiveAreaRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CAN-ENTER-EXCLUSIVE-AREA-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CanEnterExclusiveAreaRef(Ref):
            dest: ExclusiveAreaSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaNestingOrderRefs:
        exclusive_area_nesting_order_ref: list[
            "BswCalledEntity.ExclusiveAreaNestingOrderRefs.ExclusiveAreaNestingOrderRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA-NESTING-ORDER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ExclusiveAreaNestingOrderRef(Ref):
            dest: ExclusiveAreaNestingOrderSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RunsInsides:
        exclusive_area_ref_conditional: list[ExclusiveAreaRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RunsInsideExclusiveAreaRefs:
        runs_inside_exclusive_area_ref: list[
            "BswCalledEntity.RunsInsideExclusiveAreaRefs.RunsInsideExclusiveAreaRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "RUNS-INSIDE-EXCLUSIVE-AREA-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RunsInsideExclusiveAreaRef(Ref):
            dest: ExclusiveAreaSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SwAddrMethodRef(Ref):
        dest: SwAddrMethodSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AccessedModeGroups:
        mode_declaration_group_prototype_ref_conditional: list[
            ModeDeclarationGroupPrototypeRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-GROUP-PROTOTYPE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationPoints:
        bsw_internal_triggering_point_ref_conditional: list[
            BswInternalTriggeringPointRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "BSW-INTERNAL-TRIGGERING-POINT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CallPoints:
        bsw_asynchronous_server_call_point: list[BswAsynchronousServerCallPoint] = field(
            default_factory=list,
            metadata={
                "name": "BSW-ASYNCHRONOUS-SERVER-CALL-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_asynchronous_server_call_result_point: list[BswAsynchronousServerCallResultPoint] = (
            field(
                default_factory=list,
                metadata={
                    "name": "BSW-ASYNCHRONOUS-SERVER-CALL-RESULT-POINT",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        bsw_direct_call_point: list[BswDirectCallPoint] = field(
            default_factory=list,
            metadata={
                "name": "BSW-DIRECT-CALL-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_synchronous_server_call_point: list[BswSynchronousServerCallPoint] = field(
            default_factory=list,
            metadata={
                "name": "BSW-SYNCHRONOUS-SERVER-CALL-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CalledEntrys:
        bsw_module_entry_ref_conditional: list[BswModuleEntryRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-ENTRY-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataReceivePoints:
        bsw_variable_access: list[BswVariableAccess] = field(
            default_factory=list,
            metadata={
                "name": "BSW-VARIABLE-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataSendPoints:
        bsw_variable_access: list[BswVariableAccess] = field(
            default_factory=list,
            metadata={
                "name": "BSW-VARIABLE-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementedEntryRef(Ref):
        dest: BswModuleEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IssuedTriggers:
        trigger_ref_conditional: list[TriggerRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ManagedModeGroups:
        mode_declaration_group_prototype_ref_conditional: list[
            ModeDeclarationGroupPrototypeRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-GROUP-PROTOTYPE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SchedulerNamePrefixRef(Ref):
        dest: BswSchedulerNamePrefixSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswDebugInfo:
    """
    Collects the information on the data provided to the AUTOSAR debug module.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar local_debug_datas: A data element declared locally to this
        module, cluster or library. It shall be used (within AUTOSAR)
        only for debugging purposes. This aggregation contains a
        variation point although it is not variant. Therefore, this
        variation point shall not exist in models. See constr_2638.
    :ivar parameter_accessed_for_debug_refs: Indicates a parameter as to
        be debugged.
    :ivar variable_accessed_for_debug_refs: Indicates a variable as to
        be debugged.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswImplementation.debugInfo
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-DEBUG-INFO"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswDebugInfo.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswDebugInfo.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_debug_datas: Optional["BswDebugInfo.LocalDebugDatas"] = field(
        default=None,
        metadata={
            "name": "LOCAL-DEBUG-DATAS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_accessed_for_debug_refs: Optional["BswDebugInfo.ParameterAccessedForDebugRefs"] = (
        field(
            default=None,
            metadata={
                "name": "PARAMETER-ACCESSED-FOR-DEBUG-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variable_accessed_for_debug_refs: Optional["BswDebugInfo.VariableAccessedForDebugRefs"] = field(
        default=None,
        metadata={
            "name": "VARIABLE-ACCESSED-FOR-DEBUG-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LocalDebugDatas:
        implementation_data_type_element: list[ImplementationDataTypeElement] = field(
            default_factory=list,
            metadata={
                "name": "IMPLEMENTATION-DATA-TYPE-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ParameterAccessedForDebugRefs:
        parameter_accessed_for_debug_ref: list[
            "BswDebugInfo.ParameterAccessedForDebugRefs.ParameterAccessedForDebugRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-ACCESSED-FOR-DEBUG-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ParameterAccessedForDebugRef(Ref):
            dest: ParameterDataPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class VariableAccessedForDebugRefs:
        variable_accessed_for_debug_ref: list[
            "BswDebugInfo.VariableAccessedForDebugRefs.VariableAccessedForDebugRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-ACCESSED-FOR-DEBUG-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class VariableAccessedForDebugRef(Ref):
            dest: VariableDataPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class BswInterruptEntity:
    """
    BSW module entity, which is designed to be triggered by an interrupt.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reasons: If the ExecutableEntity provides at least
        one activationReason element the RTE resp. BSW Scheduler shall
        provide means to read the activation vector of this executable
        entity execution. If no activationReason element is provided the
        feature of being able to determine the activating RTEEvent is
        disabled for this ExecutableEntity.
    :ivar can_enters: This means that the executable entity can
        enter/leave the referenced exclusive area through explicit API
        calls. This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar can_enter_exclusive_area_refs: This means that the executable
        entity can enter/leave the referenced exclusive area through
        explicit API calls.
    :ivar exclusive_area_nesting_order_refs: This represents the set of
        ExclusiveAreaNestingOrders recognized by this ExecutableEntity.
    :ivar minimum_start_interval: Specifies the time in seconds by which
        two consecutive starts of an ExecutableEntity are guaranteed to
        be separated.
    :ivar reentrancy_level: The reentrancy level of this
        ExecutableEntity. See the documentation of the enumeration type
        ReentrancyLevelEnum for details. Please note that nonReentrant
        interfaces can have also reentrant or multicoreReentrant
        implementations, and reentrant interfaces can also have
        multicoreReentrant implementations.
    :ivar runs_insides: The executable entity runs completely inside the
        referenced exclusive area. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar runs_inside_exclusive_area_refs: The executable entity runs
        completely inside the referenced exclusive area.
    :ivar sw_addr_method_ref: Addressing method related to this code
        entity. Via an association to the same SwAddrMethod, it can be
        specified that several code entities (even of different modules
        or components)  shall be located in the same memory without
        already specifying the memory section itself.
    :ivar accessed_mode_groups: A mode group which is accessed via API
        call by this entity. It shall be a ModeDeclarationGroupPrototype
        required by this module or cluster. This property was modified
        due to atpVariation (DirectedAssociationPattern).
    :ivar activation_points: Activation point used by the module entity
        to activate one or more internal triggers. This property was
        modified due to atpVariation (DirectedAssociationPattern).
    :ivar call_points: A call point used in the code of this entity. The
        variability of this association is especially targeted at debug
        scenarios: It is possible to have one variant calling into the
        AUTOSAR debug module and another one which doesn't.
    :ivar called_entrys: The entry of another (or the same) BSW module
        which is called by this entry (usually via C function call).
        This information allows to set up a model of call chains. The
        variablity of this association is especially targeted at debug
        scenarios: It is possible to have one variant calling into the
        AUTOSAR debug module and another one which doesn't. Note that
        this relation has been merked as obsolete, since the more
        powerful definition of a callPoint should be used. This property
        was modified due to atpVariation (DirectedAssociationPattern).
    :ivar data_receive_points: The data is received via the BSW
        Scheduler.
    :ivar data_send_points: The data is sent via the BSW Scheduler.
    :ivar implemented_entry_ref: The entry which is implemented by this
        module entity.
    :ivar issued_triggers: A trigger issued by this entity via BSW
        Scheduler API call. It shall be a BswTrigger released (i.e.
        owned) by this module or cluster. This property was modified due
        to atpVariation (DirectedAssociationPattern).
    :ivar managed_mode_groups: A mode group which is managed by this
        entity. It shall be a ModeDeclarationGroupPrototype provided by
        this module or cluster. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar scheduler_name_prefix_ref: A prefix to be used in generated
        names for the BswModuleScheduler in the context of this
        BswModuleEntity, for example entry point prototypes, macros for
        dealing with exclusive areas, header file names. Details are
        defined in the SWS RTE. The prefix supersedes default rules for
        the prefix of those names.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.entity
    :ivar interrupt_category: Category of the interrupt
    :ivar interrupt_source: Allows a textual documentation of the
        intended interrupt source.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-INTERRUPT-ENTITY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswInterruptEntity.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswInterruptEntity.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reasons: Optional["BswInterruptEntity.ActivationReasons"] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_enters: Optional["BswInterruptEntity.CanEnters"] = field(
        default=None,
        metadata={
            "name": "CAN-ENTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_enter_exclusive_area_refs: Optional["BswInterruptEntity.CanEnterExclusiveAreaRefs"] = field(
        default=None,
        metadata={
            "name": "CAN-ENTER-EXCLUSIVE-AREA-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_area_nesting_order_refs: Optional[
        "BswInterruptEntity.ExclusiveAreaNestingOrderRefs"
    ] = field(
        default=None,
        metadata={
            "name": "EXCLUSIVE-AREA-NESTING-ORDER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_start_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-START-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reentrancy_level: ReentrancyLevelEnum | None = field(
        default=None,
        metadata={
            "name": "REENTRANCY-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runs_insides: Optional["BswInterruptEntity.RunsInsides"] = field(
        default=None,
        metadata={
            "name": "RUNS-INSIDES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runs_inside_exclusive_area_refs: Optional["BswInterruptEntity.RunsInsideExclusiveAreaRefs"] = (
        field(
            default=None,
            metadata={
                "name": "RUNS-INSIDE-EXCLUSIVE-AREA-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    sw_addr_method_ref: Optional["BswInterruptEntity.SwAddrMethodRef"] = field(
        default=None,
        metadata={
            "name": "SW-ADDR-METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    accessed_mode_groups: Optional["BswInterruptEntity.AccessedModeGroups"] = field(
        default=None,
        metadata={
            "name": "ACCESSED-MODE-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_points: Optional["BswInterruptEntity.ActivationPoints"] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    call_points: Optional["BswInterruptEntity.CallPoints"] = field(
        default=None,
        metadata={
            "name": "CALL-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    called_entrys: Optional["BswInterruptEntity.CalledEntrys"] = field(
        default=None,
        metadata={
            "name": "CALLED-ENTRYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_receive_points: Optional["BswInterruptEntity.DataReceivePoints"] = field(
        default=None,
        metadata={
            "name": "DATA-RECEIVE-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_send_points: Optional["BswInterruptEntity.DataSendPoints"] = field(
        default=None,
        metadata={
            "name": "DATA-SEND-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implemented_entry_ref: Optional["BswInterruptEntity.ImplementedEntryRef"] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTED-ENTRY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    issued_triggers: Optional["BswInterruptEntity.IssuedTriggers"] = field(
        default=None,
        metadata={
            "name": "ISSUED-TRIGGERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    managed_mode_groups: Optional["BswInterruptEntity.ManagedModeGroups"] = field(
        default=None,
        metadata={
            "name": "MANAGED-MODE-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scheduler_name_prefix_ref: Optional["BswInterruptEntity.SchedulerNamePrefixRef"] = field(
        default=None,
        metadata={
            "name": "SCHEDULER-NAME-PREFIX-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    interrupt_category: BswInterruptCategory | None = field(
        default=None,
        metadata={
            "name": "INTERRUPT-CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    interrupt_source: String | None = field(
        default=None,
        metadata={
            "name": "INTERRUPT-SOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasons:
        executable_entity_activation_reason: list[ExecutableEntityActivationReason] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTABLE-ENTITY-ACTIVATION-REASON",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CanEnters:
        exclusive_area_ref_conditional: list[ExclusiveAreaRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CanEnterExclusiveAreaRefs:
        can_enter_exclusive_area_ref: list[
            "BswInterruptEntity.CanEnterExclusiveAreaRefs.CanEnterExclusiveAreaRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CAN-ENTER-EXCLUSIVE-AREA-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CanEnterExclusiveAreaRef(Ref):
            dest: ExclusiveAreaSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaNestingOrderRefs:
        exclusive_area_nesting_order_ref: list[
            "BswInterruptEntity.ExclusiveAreaNestingOrderRefs.ExclusiveAreaNestingOrderRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA-NESTING-ORDER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ExclusiveAreaNestingOrderRef(Ref):
            dest: ExclusiveAreaNestingOrderSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RunsInsides:
        exclusive_area_ref_conditional: list[ExclusiveAreaRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RunsInsideExclusiveAreaRefs:
        runs_inside_exclusive_area_ref: list[
            "BswInterruptEntity.RunsInsideExclusiveAreaRefs.RunsInsideExclusiveAreaRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "RUNS-INSIDE-EXCLUSIVE-AREA-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RunsInsideExclusiveAreaRef(Ref):
            dest: ExclusiveAreaSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SwAddrMethodRef(Ref):
        dest: SwAddrMethodSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AccessedModeGroups:
        mode_declaration_group_prototype_ref_conditional: list[
            ModeDeclarationGroupPrototypeRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-GROUP-PROTOTYPE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationPoints:
        bsw_internal_triggering_point_ref_conditional: list[
            BswInternalTriggeringPointRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "BSW-INTERNAL-TRIGGERING-POINT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CallPoints:
        bsw_asynchronous_server_call_point: list[BswAsynchronousServerCallPoint] = field(
            default_factory=list,
            metadata={
                "name": "BSW-ASYNCHRONOUS-SERVER-CALL-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_asynchronous_server_call_result_point: list[BswAsynchronousServerCallResultPoint] = (
            field(
                default_factory=list,
                metadata={
                    "name": "BSW-ASYNCHRONOUS-SERVER-CALL-RESULT-POINT",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        bsw_direct_call_point: list[BswDirectCallPoint] = field(
            default_factory=list,
            metadata={
                "name": "BSW-DIRECT-CALL-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_synchronous_server_call_point: list[BswSynchronousServerCallPoint] = field(
            default_factory=list,
            metadata={
                "name": "BSW-SYNCHRONOUS-SERVER-CALL-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CalledEntrys:
        bsw_module_entry_ref_conditional: list[BswModuleEntryRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-ENTRY-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataReceivePoints:
        bsw_variable_access: list[BswVariableAccess] = field(
            default_factory=list,
            metadata={
                "name": "BSW-VARIABLE-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataSendPoints:
        bsw_variable_access: list[BswVariableAccess] = field(
            default_factory=list,
            metadata={
                "name": "BSW-VARIABLE-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementedEntryRef(Ref):
        dest: BswModuleEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IssuedTriggers:
        trigger_ref_conditional: list[TriggerRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ManagedModeGroups:
        mode_declaration_group_prototype_ref_conditional: list[
            ModeDeclarationGroupPrototypeRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-GROUP-PROTOTYPE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SchedulerNamePrefixRef(Ref):
        dest: BswSchedulerNamePrefixSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswModuleEntry:
    """This class represents a single API entry (C-function prototype) into the BSW
    module or cluster.

    The name of the C-function is equal to the short name of this element with one exception: In case of multiple instances of a module on the same CPU, special rules for "infixes" apply, see description of class BswImplementation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar function_prototype_emitter: This attribute is used to control
        the generation of function prototypes. If set to "RTE", the RTE
        generates the  function prototypes in the Module Interlink
        Header File.
    :ivar service_id: Refers to the service identifier of the
        Standardized Interfaces of AUTOSAR basic software. For non-
        standardized interfaces, it can optionally be used for
        proprietary identification.
    :ivar role: Specifies the role of the entry in the given context. It
        shall be equal to the standardized name of the service call,
        especially in cases where no ServiceIdentifier is specified,
        e.g. for callbacks. Note that the ShortName is not always
        sufficient because it maybe vendor specific (e.g. for callbacks
        which can have more than one instance).
    :ivar is_reentrant: Reentrancy from the viewpoint of function
        callers: * true: Enables the service to be invoked again, before
        the service has finished. * false: It is prohibited to invoke
        the service again before is has finished.
    :ivar is_synchronous: Synchronicity from the viewpoint of function
        callers: * true: This calls a synchronous service, i.e. the
        service is completed when the call returns. * false: The service
        (on semantical level) may not be complete when the call returns.
    :ivar call_type: The type of call associated with this service.
    :ivar execution_context: Specifies the execution context which is
        required (in case of entries into this module) or guaranteed (in
        case of entries called from this module) for this service.
    :ivar sw_service_impl_policy: Denotes the implementation policy as a
        standard function call, inline function or macro. This has to be
        specified on interface level because it determines the signature
        of the call.
    :ivar bsw_entry_kind: This describes whether the entry is concrete
        or abstract. If the attribute is missing the entry is considered
        as concrete.
    :ivar return_type: The return type belonging to this bswModuleEntry.
        This aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar arguments: An argument belonging to this BswModuleEntry.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-MODULE-ENTRY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswModuleEntry.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswModuleEntry.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["BswModuleEntry.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    function_prototype_emitter: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "FUNCTION-PROTOTYPE-EMITTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SERVICE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    role: Identifier | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_reentrant: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-REENTRANT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_synchronous: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-SYNCHRONOUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    call_type: BswCallType | None = field(
        default=None,
        metadata={
            "name": "CALL-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    execution_context: BswExecutionContext | None = field(
        default=None,
        metadata={
            "name": "EXECUTION-CONTEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_service_impl_policy: SwServiceImplPolicyEnum | None = field(
        default=None,
        metadata={
            "name": "SW-SERVICE-IMPL-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_entry_kind: BswEntryKindEnum | None = field(
        default=None,
        metadata={
            "name": "BSW-ENTRY-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    return_type: SwServiceArg | None = field(
        default=None,
        metadata={
            "name": "RETURN-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    arguments: Optional["BswModuleEntry.Arguments"] = field(
        default=None,
        metadata={
            "name": "ARGUMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Arguments:
        sw_service_arg: list[SwServiceArg] = field(
            default_factory=list,
            metadata={
                "name": "SW-SERVICE-ARG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BswSchedulableEntity:
    """BSW module entity, which is designed for control by the BSW Scheduler.

    It may for example implement a so-called "main" function.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reasons: If the ExecutableEntity provides at least
        one activationReason element the RTE resp. BSW Scheduler shall
        provide means to read the activation vector of this executable
        entity execution. If no activationReason element is provided the
        feature of being able to determine the activating RTEEvent is
        disabled for this ExecutableEntity.
    :ivar can_enters: This means that the executable entity can
        enter/leave the referenced exclusive area through explicit API
        calls. This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar can_enter_exclusive_area_refs: This means that the executable
        entity can enter/leave the referenced exclusive area through
        explicit API calls.
    :ivar exclusive_area_nesting_order_refs: This represents the set of
        ExclusiveAreaNestingOrders recognized by this ExecutableEntity.
    :ivar minimum_start_interval: Specifies the time in seconds by which
        two consecutive starts of an ExecutableEntity are guaranteed to
        be separated.
    :ivar reentrancy_level: The reentrancy level of this
        ExecutableEntity. See the documentation of the enumeration type
        ReentrancyLevelEnum for details. Please note that nonReentrant
        interfaces can have also reentrant or multicoreReentrant
        implementations, and reentrant interfaces can also have
        multicoreReentrant implementations.
    :ivar runs_insides: The executable entity runs completely inside the
        referenced exclusive area. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar runs_inside_exclusive_area_refs: The executable entity runs
        completely inside the referenced exclusive area.
    :ivar sw_addr_method_ref: Addressing method related to this code
        entity. Via an association to the same SwAddrMethod, it can be
        specified that several code entities (even of different modules
        or components)  shall be located in the same memory without
        already specifying the memory section itself.
    :ivar accessed_mode_groups: A mode group which is accessed via API
        call by this entity. It shall be a ModeDeclarationGroupPrototype
        required by this module or cluster. This property was modified
        due to atpVariation (DirectedAssociationPattern).
    :ivar activation_points: Activation point used by the module entity
        to activate one or more internal triggers. This property was
        modified due to atpVariation (DirectedAssociationPattern).
    :ivar call_points: A call point used in the code of this entity. The
        variability of this association is especially targeted at debug
        scenarios: It is possible to have one variant calling into the
        AUTOSAR debug module and another one which doesn't.
    :ivar called_entrys: The entry of another (or the same) BSW module
        which is called by this entry (usually via C function call).
        This information allows to set up a model of call chains. The
        variablity of this association is especially targeted at debug
        scenarios: It is possible to have one variant calling into the
        AUTOSAR debug module and another one which doesn't. Note that
        this relation has been merked as obsolete, since the more
        powerful definition of a callPoint should be used. This property
        was modified due to atpVariation (DirectedAssociationPattern).
    :ivar data_receive_points: The data is received via the BSW
        Scheduler.
    :ivar data_send_points: The data is sent via the BSW Scheduler.
    :ivar implemented_entry_ref: The entry which is implemented by this
        module entity.
    :ivar issued_triggers: A trigger issued by this entity via BSW
        Scheduler API call. It shall be a BswTrigger released (i.e.
        owned) by this module or cluster. This property was modified due
        to atpVariation (DirectedAssociationPattern).
    :ivar managed_mode_groups: A mode group which is managed by this
        entity. It shall be a ModeDeclarationGroupPrototype provided by
        this module or cluster. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar scheduler_name_prefix_ref: A prefix to be used in generated
        names for the BswModuleScheduler in the context of this
        BswModuleEntity, for example entry point prototypes, macros for
        dealing with exclusive areas, header file names. Details are
        defined in the SWS RTE. The prefix supersedes default rules for
        the prefix of those names.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.entity
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-SCHEDULABLE-ENTITY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswSchedulableEntity.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswSchedulableEntity.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reasons: Optional["BswSchedulableEntity.ActivationReasons"] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_enters: Optional["BswSchedulableEntity.CanEnters"] = field(
        default=None,
        metadata={
            "name": "CAN-ENTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_enter_exclusive_area_refs: Optional["BswSchedulableEntity.CanEnterExclusiveAreaRefs"] = (
        field(
            default=None,
            metadata={
                "name": "CAN-ENTER-EXCLUSIVE-AREA-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    exclusive_area_nesting_order_refs: Optional[
        "BswSchedulableEntity.ExclusiveAreaNestingOrderRefs"
    ] = field(
        default=None,
        metadata={
            "name": "EXCLUSIVE-AREA-NESTING-ORDER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_start_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-START-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reentrancy_level: ReentrancyLevelEnum | None = field(
        default=None,
        metadata={
            "name": "REENTRANCY-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runs_insides: Optional["BswSchedulableEntity.RunsInsides"] = field(
        default=None,
        metadata={
            "name": "RUNS-INSIDES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runs_inside_exclusive_area_refs: Optional[
        "BswSchedulableEntity.RunsInsideExclusiveAreaRefs"
    ] = field(
        default=None,
        metadata={
            "name": "RUNS-INSIDE-EXCLUSIVE-AREA-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_addr_method_ref: Optional["BswSchedulableEntity.SwAddrMethodRef"] = field(
        default=None,
        metadata={
            "name": "SW-ADDR-METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    accessed_mode_groups: Optional["BswSchedulableEntity.AccessedModeGroups"] = field(
        default=None,
        metadata={
            "name": "ACCESSED-MODE-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_points: Optional["BswSchedulableEntity.ActivationPoints"] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    call_points: Optional["BswSchedulableEntity.CallPoints"] = field(
        default=None,
        metadata={
            "name": "CALL-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    called_entrys: Optional["BswSchedulableEntity.CalledEntrys"] = field(
        default=None,
        metadata={
            "name": "CALLED-ENTRYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_receive_points: Optional["BswSchedulableEntity.DataReceivePoints"] = field(
        default=None,
        metadata={
            "name": "DATA-RECEIVE-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_send_points: Optional["BswSchedulableEntity.DataSendPoints"] = field(
        default=None,
        metadata={
            "name": "DATA-SEND-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implemented_entry_ref: Optional["BswSchedulableEntity.ImplementedEntryRef"] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTED-ENTRY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    issued_triggers: Optional["BswSchedulableEntity.IssuedTriggers"] = field(
        default=None,
        metadata={
            "name": "ISSUED-TRIGGERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    managed_mode_groups: Optional["BswSchedulableEntity.ManagedModeGroups"] = field(
        default=None,
        metadata={
            "name": "MANAGED-MODE-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scheduler_name_prefix_ref: Optional["BswSchedulableEntity.SchedulerNamePrefixRef"] = field(
        default=None,
        metadata={
            "name": "SCHEDULER-NAME-PREFIX-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasons:
        executable_entity_activation_reason: list[ExecutableEntityActivationReason] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTABLE-ENTITY-ACTIVATION-REASON",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CanEnters:
        exclusive_area_ref_conditional: list[ExclusiveAreaRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CanEnterExclusiveAreaRefs:
        can_enter_exclusive_area_ref: list[
            "BswSchedulableEntity.CanEnterExclusiveAreaRefs.CanEnterExclusiveAreaRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CAN-ENTER-EXCLUSIVE-AREA-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CanEnterExclusiveAreaRef(Ref):
            dest: ExclusiveAreaSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaNestingOrderRefs:
        exclusive_area_nesting_order_ref: list[
            "BswSchedulableEntity.ExclusiveAreaNestingOrderRefs.ExclusiveAreaNestingOrderRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA-NESTING-ORDER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ExclusiveAreaNestingOrderRef(Ref):
            dest: ExclusiveAreaNestingOrderSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RunsInsides:
        exclusive_area_ref_conditional: list[ExclusiveAreaRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RunsInsideExclusiveAreaRefs:
        runs_inside_exclusive_area_ref: list[
            "BswSchedulableEntity.RunsInsideExclusiveAreaRefs.RunsInsideExclusiveAreaRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "RUNS-INSIDE-EXCLUSIVE-AREA-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RunsInsideExclusiveAreaRef(Ref):
            dest: ExclusiveAreaSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SwAddrMethodRef(Ref):
        dest: SwAddrMethodSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AccessedModeGroups:
        mode_declaration_group_prototype_ref_conditional: list[
            ModeDeclarationGroupPrototypeRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-GROUP-PROTOTYPE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationPoints:
        bsw_internal_triggering_point_ref_conditional: list[
            BswInternalTriggeringPointRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "BSW-INTERNAL-TRIGGERING-POINT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CallPoints:
        bsw_asynchronous_server_call_point: list[BswAsynchronousServerCallPoint] = field(
            default_factory=list,
            metadata={
                "name": "BSW-ASYNCHRONOUS-SERVER-CALL-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_asynchronous_server_call_result_point: list[BswAsynchronousServerCallResultPoint] = (
            field(
                default_factory=list,
                metadata={
                    "name": "BSW-ASYNCHRONOUS-SERVER-CALL-RESULT-POINT",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        bsw_direct_call_point: list[BswDirectCallPoint] = field(
            default_factory=list,
            metadata={
                "name": "BSW-DIRECT-CALL-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_synchronous_server_call_point: list[BswSynchronousServerCallPoint] = field(
            default_factory=list,
            metadata={
                "name": "BSW-SYNCHRONOUS-SERVER-CALL-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CalledEntrys:
        bsw_module_entry_ref_conditional: list[BswModuleEntryRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-ENTRY-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataReceivePoints:
        bsw_variable_access: list[BswVariableAccess] = field(
            default_factory=list,
            metadata={
                "name": "BSW-VARIABLE-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataSendPoints:
        bsw_variable_access: list[BswVariableAccess] = field(
            default_factory=list,
            metadata={
                "name": "BSW-VARIABLE-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementedEntryRef(Ref):
        dest: BswModuleEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IssuedTriggers:
        trigger_ref_conditional: list[TriggerRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ManagedModeGroups:
        mode_declaration_group_prototype_ref_conditional: list[
            ModeDeclarationGroupPrototypeRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-GROUP-PROTOTYPE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SchedulerNamePrefixRef(Ref):
        dest: BswSchedulerNamePrefixSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BufferProperties:
    """
    Configuration of the buffer properties the transformer needs to work.

    :ivar buffer_computation: If the transformer changes the size of the
        data, the CompuScale can be used to specify a rule to derive the
        size of the output data based on the size of the input data.
        This aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar header_length: Defines the length of the header (in bits) this
        transformer will add in front of the data.
    :ivar in_place: If set, the transformer uses the input buffer as
        output buffer.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUFFER-PROPERTIES"

    buffer_computation: CompuScale | None = field(
        default=None,
        metadata={
            "name": "BUFFER-COMPUTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    header_length: Integer | None = field(
        default=None,
        metadata={
            "name": "HEADER-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    in_place: Boolean | None = field(
        default=None,
        metadata={
            "name": "IN-PLACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class BuildActionManifest:
    """This meta-class represents the ability to specify a manifest for processing
    artifacts.

    An example use case is the processing of ECUC parameter values.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar start_action_refs: This specifies the list of actions to be
        performed at the beginning of the process.
    :ivar tear_down_action_refs: This specifies the set of action which
        shall be performed after all other actions in the manifest were
        performed.
    :ivar build_actions: This represents a particular action in the
        build chain.
    :ivar build_action_environments: This represents a build action
        environment.
    :ivar dynamic_action_refs: This denotes an Action which is to be
        executed as part of the dynamic action set.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUILD-ACTION-MANIFEST"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BuildActionManifest.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BuildActionManifest.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["BuildActionManifest.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start_action_refs: Optional["BuildActionManifest.StartActionRefs"] = field(
        default=None,
        metadata={
            "name": "START-ACTION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tear_down_action_refs: Optional["BuildActionManifest.TearDownActionRefs"] = field(
        default=None,
        metadata={
            "name": "TEAR-DOWN-ACTION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    build_actions: Optional["BuildActionManifest.BuildActions"] = field(
        default=None,
        metadata={
            "name": "BUILD-ACTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    build_action_environments: Optional["BuildActionManifest.BuildActionEnvironments"] = field(
        default=None,
        metadata={
            "name": "BUILD-ACTION-ENVIRONMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_action_refs: Optional["BuildActionManifest.DynamicActionRefs"] = field(
        default=None,
        metadata={
            "name": "DYNAMIC-ACTION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StartActionRefs:
        start_action_ref: list["BuildActionManifest.StartActionRefs.StartActionRef"] = field(
            default_factory=list,
            metadata={
                "name": "START-ACTION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class StartActionRef(Ref):
            dest: BuildActionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TearDownActionRefs:
        tear_down_action_ref: list["BuildActionManifest.TearDownActionRefs.TearDownActionRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "TEAR-DOWN-ACTION-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class TearDownActionRef(Ref):
            dest: BuildActionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class BuildActions:
        build_action: list[BuildAction] = field(
            default_factory=list,
            metadata={
                "name": "BUILD-ACTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BuildActionEnvironments:
        build_action_environment: list[BuildActionEnvironment] = field(
            default_factory=list,
            metadata={
                "name": "BUILD-ACTION-ENVIRONMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DynamicActionRefs:
        dynamic_action_ref: list["BuildActionManifest.DynamicActionRefs.DynamicActionRef"] = field(
            default_factory=list,
            metadata={
                "name": "DYNAMIC-ACTION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DynamicActionRef(Ref):
            dest: BuildActionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class BusMirrorChannel:
    """
    This element assigns a busMirrorNetworkId to the referenced channel.

    :ivar bus_mirror_network_id: This attribute defines the networkId of
        the communication channel.
    :ivar channels: Reference to PhysicalChannel that is used in the bus
        mirroring as sourceChannel or targetChannel. This property was
        modified due to atpVariation (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUS-MIRROR-CHANNEL"

    bus_mirror_network_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BUS-MIRROR-NETWORK-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    channels: Optional["BusMirrorChannel.Channels"] = field(
        default=None,
        metadata={
            "name": "CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Channels:
        physical_channel_ref_conditional: list[PhysicalChannelRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "PHYSICAL-CHANNEL-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CanCommunicationConnector:
    """
    CAN bus specific communication connector attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar comm_controller_ref: Reference to the communication
        controller. The CommunicationConnector and referenced
        CommunicationController shall be aggregated by the same
        ECUInstance. The communicationController can be referenced by
        several CommunicationConnector elements. This is important for
        the FlexRay Bus. FlexRay communicates via two physical channels.
        But only one controller in an ECU is responsible for both
        channels. Thus, two connectors (for channel A and for channel B)
        shall reference to the same controller.
    :ivar create_ecu_wakeup_source: If this parameter is available and
        set to true then a channel wakeup source shall be created for
        the PhysicalChannel referencing this CommunicationConnector.
    :ivar dynamic_pnc_to_channel_mapping_enabled: Defines if this
        EcuInstance shall implement the dynamic PNC-to-channel-mapping
        functionality on this CommunicationConnector and its respective
        PhysicalChannel.
    :ivar ecu_comm_port_instances: An ECUs reception or send ports.
        atpVariation: If signals/PDUs/frames are variable, the
        corresponding ports shall be variable, too.
    :ivar pnc_filter_array_masks: Bit mask for NM-Pdu Payload used to
        configure the NM filter mask for the Network Management.
    :ivar pnc_gateway_type: Defines if this EcuInstance shall implement
        the PncGateway functionality on this CommunicationConnector and
        its respective PhysicalChannel. Several EcuInstances on the same
        PhysicalChannel can have the PncGateway functionality enabled,
        but only one of them shall have the pncGatewayType "active".
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: EcuInstance.connector
        Not Applicable for: MachineDesign.communicationConnector
    :ivar pnc_wakeup_can_id: CAN Identifier used to configure the CAN
        Transceiver for partial network wakeup.
    :ivar pnc_wakeup_can_id_extended: Defines whether pncWakeupCanId and
        pncWakeupCanIdMask shall be interpreted as extended or standard
        CAN ID.
    :ivar pnc_wakeup_can_id_mask: Bit mask for CAN Identifier used to
        configure the CAN Transceiver for partial network wakeup.
    :ivar pnc_wakeup_data_mask: Bit mask for CAN Payload used to
        configure the CAN Transceiver for partial network wakeup.
    :ivar pnc_wakeup_dlc: Data Length of the remote data frame used to
        configure the CAN Transceiver for partial network wakeup in
        Bytes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-COMMUNICATION-CONNECTOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CanCommunicationConnector.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CanCommunicationConnector.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_controller_ref: Optional["CanCommunicationConnector.CommControllerRef"] = field(
        default=None,
        metadata={
            "name": "COMM-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    create_ecu_wakeup_source: Boolean | None = field(
        default=None,
        metadata={
            "name": "CREATE-ECU-WAKEUP-SOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_pnc_to_channel_mapping_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "DYNAMIC-PNC-TO-CHANNEL-MAPPING-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_comm_port_instances: Optional["CanCommunicationConnector.EcuCommPortInstances"] = field(
        default=None,
        metadata={
            "name": "ECU-COMM-PORT-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_filter_array_masks: Optional["CanCommunicationConnector.PncFilterArrayMasks"] = field(
        default=None,
        metadata={
            "name": "PNC-FILTER-ARRAY-MASKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_gateway_type: PncGatewayTypeEnum | None = field(
        default=None,
        metadata={
            "name": "PNC-GATEWAY-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_wakeup_can_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PNC-WAKEUP-CAN-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_wakeup_can_id_extended: Boolean | None = field(
        default=None,
        metadata={
            "name": "PNC-WAKEUP-CAN-ID-EXTENDED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_wakeup_can_id_mask: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PNC-WAKEUP-CAN-ID-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_wakeup_data_mask: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "PNC-WAKEUP-DATA-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_wakeup_dlc: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PNC-WAKEUP-DLC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommControllerRef(Ref):
        dest: CommunicationControllerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuCommPortInstances:
        frame_port: list[FramePort] = field(
            default_factory=list,
            metadata={
                "name": "FRAME-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_pdu_port: list[IPduPort] = field(
            default_factory=list,
            metadata={
                "name": "I-PDU-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_signal_port: list[ISignalPort] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PncFilterArrayMasks:
        pnc_filter_array_mask: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "PNC-FILTER-ARRAY-MASK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CanCommunicationController:
    """
    CAN bus specific communication port attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EcuInstance.commController Not Applicable for:
        MachineDesign.communicationController
    :ivar can_communication_controller_variants: This element was
        generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-COMMUNICATION-CONTROLLER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CanCommunicationController.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CanCommunicationController.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_communication_controller_variants: Optional[
        "CanCommunicationController.CanCommunicationControllerVariants"
    ] = field(
        default=None,
        metadata={
            "name": "CAN-COMMUNICATION-CONTROLLER-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CanCommunicationControllerVariants:
        can_communication_controller_conditional: list[CanCommunicationControllerConditional] = (
            field(
                default_factory=list,
                metadata={
                    "name": "CAN-COMMUNICATION-CONTROLLER-CONDITIONAL",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class CanFrame:
    """CAN specific Frame element.

    This element shall also be used for TTCan.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar frame_length: The used length (in bytes) of the referencing
        frame. Should not be confused with a static byte length reserved
        for each frame by some platforms (e.g. FlexRay). The frameLength
        of zero bytes is allowed. Please consider also TPS_SYST_02255.
    :ivar pdu_to_frame_mappings: A frames layout as a sequence of Pdus.
        atpVariation: The content of a frame can be variable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-FRAME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CanFrame.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CanFrame.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_length: Integer | None = field(
        default=None,
        metadata={
            "name": "FRAME-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_to_frame_mappings: Optional["CanFrame.PduToFrameMappings"] = field(
        default=None,
        metadata={
            "name": "PDU-TO-FRAME-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduToFrameMappings:
        pdu_to_frame_mapping: list[PduToFrameMapping] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TO-FRAME-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CanFrameTriggering:
    """
    CAN specific attributes to the FrameTriggering.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar frame_port_refs: References to the FramePort on every ECU of
        the system which sends and/or receives the frame. References for
        both the sender and the receiver side shall be included when the
        system is completely defined.
    :ivar frame_ref: One frame can be triggered several times, e.g. on
        different channels. If a frame has no frame triggering, it won't
        be sent at all. A frame triggering has assigned exactly one
        frame, which it triggers.
    :ivar pdu_triggerings: This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        PhysicalChannel.frameTriggering
    :ivar absolutely_scheduled_timings: Each frame in TTCAN is
        identified by its slot id and communication cycle. A description
        is provided by the usage of AbsolutelyScheduledTiming.
    :ivar can_addressing_mode: The CAN protocol supports two types of
        frame formats. The standard frame format uses 11-bit identifiers
        and is defined in the CAN specification 2.0 A. Additionally the
        extended frame format allows 29-bit identifiers and is defined
        in the CAN specification 2.0 B.
    :ivar can_fd_frame_support: This attribute describes whether the CAN
        FD option is activated or not. If this attribute is TRUE this
        frame can be sent/received as CAN FD frame. Otherwise it has to
        be CAN 2.0 compliant.
    :ivar can_frame_rx_behavior: Defines which CAN protocol shall be
        expected for frame reception.
    :ivar can_frame_tx_behavior: Defines which CAN protocol shall be
        used for frame transmission.
    :ivar can_xl_frame_triggering_props: Definition of CAN XL specific
        attributes in case the frame is a CAN XL frame.
    :ivar identifier: This attribute is used to define the identifier
        this frame shall use on the CAN network.
    :ivar j_1939_requestable: Frame can be triggered by the J1939
        request message.
    :ivar rx_identifier_range: Optional definition of a CanId range.
    :ivar rx_mask: Identifier mask which denotes the relevant bits in
        the CAN Identifier. Together with the identifier, this parameter
        defines a CAN identifier range.
    :ivar tx_mask: Identifier mask which denotes static bits in the CAN
        identifier. The other bits can be set dynamically.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-FRAME-TRIGGERING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CanFrameTriggering.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CanFrameTriggering.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_port_refs: Optional["CanFrameTriggering.FramePortRefs"] = field(
        default=None,
        metadata={
            "name": "FRAME-PORT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_ref: Optional["CanFrameTriggering.FrameRef"] = field(
        default=None,
        metadata={
            "name": "FRAME-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_triggerings: Optional["CanFrameTriggering.PduTriggerings"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    absolutely_scheduled_timings: Optional["CanFrameTriggering.AbsolutelyScheduledTimings"] = field(
        default=None,
        metadata={
            "name": "ABSOLUTELY-SCHEDULED-TIMINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_addressing_mode: CanAddressingModeType | None = field(
        default=None,
        metadata={
            "name": "CAN-ADDRESSING-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_fd_frame_support: Boolean | None = field(
        default=None,
        metadata={
            "name": "CAN-FD-FRAME-SUPPORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_frame_rx_behavior: CanFrameRxBehaviorEnum | None = field(
        default=None,
        metadata={
            "name": "CAN-FRAME-RX-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_frame_tx_behavior: CanFrameTxBehaviorEnum | None = field(
        default=None,
        metadata={
            "name": "CAN-FRAME-TX-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_xl_frame_triggering_props: CanXlFrameTriggeringProps | None = field(
        default=None,
        metadata={
            "name": "CAN-XL-FRAME-TRIGGERING-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    identifier: Integer | None = field(
        default=None,
        metadata={
            "name": "IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    j_1939_requestable: Boolean | None = field(
        default=None,
        metadata={
            "name": "J-1939-REQUESTABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rx_identifier_range: RxIdentifierRange | None = field(
        default=None,
        metadata={
            "name": "RX-IDENTIFIER-RANGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rx_mask: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "RX-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tx_mask: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TX-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FramePortRefs:
        frame_port_ref: list["CanFrameTriggering.FramePortRefs.FramePortRef"] = field(
            default_factory=list,
            metadata={
                "name": "FRAME-PORT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FramePortRef(Ref):
            dest: FramePortSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class FrameRef(Ref):
        dest: FrameSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PduTriggerings:
        pdu_triggering_ref_conditional: list[PduTriggeringRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AbsolutelyScheduledTimings:
        ttcan_absolutely_scheduled_timing: list[TtcanAbsolutelyScheduledTiming] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-ABSOLUTELY-SCHEDULED-TIMING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CanNmCluster:
    """
    Can specific NmCluster attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_cluster_ref: Association to a
        CommunicationCluster in the topology description.
    :ivar nm_channel_id: This attribute has the status "removed" and
        shall not be used any longer. Old description: Channel
        identification number of the corresponding channel. Must be
        unique over all NmClusters.
    :ivar nm_channel_sleep_master: This parameter shall be set to
        indicate if the sleep of this network can be absolutely decided
        by the local node only and that no other nodes can oppose that
        decision.
    :ivar nm_nodes: Collection of NmNodes of the NmCluster.
        atpVariation: Derived, because NmNode can be variable.
    :ivar nm_node_detection_enabled: Enables the Request Repeat Message
        Request support. Only valid if nmNodeIdEnabled is set to true.
    :ivar nm_node_id_enabled: Enables the source node identifier.
    :ivar nm_pnc_participation: Defines whether this NmCluster
        contributes to the partial network mechanism.
    :ivar nm_repeat_msg_ind_enabled: Switch for enabling the Repeat
        Message Bit Indication.
    :ivar nm_synchronizing_network: If this parameter is true, then this
        network is a synchronizing network for the NM coordination
        cluster which it belongs to. The network is expected to call
        Nm_SynchronizationPoint() at regular intervals.
    :ivar pnc_cluster_vector_length: Optionally defines the length of
        the PNC Vector per CommunicationCluster (and VLAN in case of
        UdpNm). If not defined then System.pncVectorLength applies.
        Should only make the PNC Vector shorter (or same length as
        defined in System.pncVectorLength).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: NmConfig.nmCluster
    :ivar nm_busload_reduction_active: It determines if bus load
        reduction for the respective CanNm channel is active or not.
    :ivar nm_car_wake_up_bit_position: Specifies the bit position of the
        CarWakeUp within the NmPdu.
    :ivar nm_car_wake_up_filter_enabled: Please note that this parameter
        is deprecated and will be removed in future. Old description: If
        this attribute is set to true the CareWakeUp filtering is
        supported. In this case only the CarWakeUp bit within the NmPdu
        with source node identifier nmCarWakeUpFilterNodeId is
        considered as CarWakeUp request.
    :ivar nm_car_wake_up_filter_node_id: Source node identifier for
        CarWakeUp filtering.
    :ivar nm_car_wake_up_rx_enabled: Please note that this parameter is
        deprecated and will be removed in future. Old description: If
        set to true this attribute enables the support of CarWakeUp bit
        evaluation in received NmPdus.
    :ivar nm_cbv_position: Defines the position of the control bit
        vector within the NmPdu (Byte position). If this attribute is
        not configured, the Control Bit Vector is not used.
    :ivar nm_channel_active: Please note that this attribute is
        deprecated and will be removed in future. This switch determines
        if the respective CanNm channel is active or not. Indicates
        whether a particular CanNm channel shall be initialized (TRUE)
        or not (FALSE). If this parameter is set to FALSE the respective
        NM instance shall not be used during runtime.
    :ivar nm_immediate_nm_cycle_time: Defines the immediate NmPdu cycle
        time in seconds which is used for nmImmediateNmTransmissions
        NmPdu transmissions. This parameter is only valid if
        CanNmImmediateNmTransmissions is greater one.
    :ivar nm_immediate_nm_transmissions: Defines the number of immediate
        NmPdus which shall be transmitted. If the value is zero no
        immediate NmPdus are transmitted. The cycle time of immediate
        NmPdus is defined by nmImmediateNmCycleTime.
    :ivar nm_message_timeout_time: Timeout of an NmPdu in seconds. It
        determines how long the NM shall wait with notification of
        transmission failure while communication errors occur on the
        bus.
    :ivar nm_msg_cycle_time: Period of a NmPdu in seconds. It determines
        the periodic rate in the periodic transmission mode with bus
        load reduction and is the basis for transmit scheduling in the
        periodic transmission mode without bus load reduction.
    :ivar nm_network_timeout: Network Timeout for NmPdus in seconds It
        denotes the time how long the CanNm shall stay in the Network
        Mode before transition into Prepare Bus-Sleep Mode shall take
        place.
    :ivar nm_nid_position: Defines the byte position of the source node
        identifier within the NmPdu. If this attribute is not
        configured, the Node Identification is not used.
    :ivar nm_remote_sleep_indication_time: Timeout for Remote Sleep
        Indication in seconds. It defines the time how long it shall
        take to recognize that all other nodes are ready to sleep.
    :ivar nm_repeat_message_time: Timeout for Repeat Message State in
        seconds. Defines the time how long the NM shall stay in the
        Repeat Message State.
    :ivar nm_user_data_length: Defines the length of the user data
        contained in the NmPdu. Please note that this attribute is
        deprecated and will be removed in future.
    :ivar nm_wait_bus_sleep_time: Timeout for bus calm down phase in
        seconds. It denotes the time how long the CanNm shall stay in
        the Prepare Bus-Sleep Mode before transition into Bus-Sleep Mode
        shall take place.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-NM-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CanNmCluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CanNmCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_ref: Optional["CanNmCluster.CommunicationClusterRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_channel_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-CHANNEL-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_channel_sleep_master: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CHANNEL-SLEEP-MASTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_nodes: Optional["CanNmCluster.NmNodes"] = field(
        default=None,
        metadata={
            "name": "NM-NODES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_detection_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-DETECTION-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_id_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-ID-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_pnc_participation: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-PNC-PARTICIPATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_repeat_msg_ind_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-REPEAT-MSG-IND-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_synchronizing_network: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-SYNCHRONIZING-NETWORK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_cluster_vector_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PNC-CLUSTER-VECTOR-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_busload_reduction_active: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-BUSLOAD-REDUCTION-ACTIVE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_car_wake_up_bit_position: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-CAR-WAKE-UP-BIT-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_car_wake_up_filter_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CAR-WAKE-UP-FILTER-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_car_wake_up_filter_node_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-CAR-WAKE-UP-FILTER-NODE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_car_wake_up_rx_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CAR-WAKE-UP-RX-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_cbv_position: Integer | None = field(
        default=None,
        metadata={
            "name": "NM-CBV-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_channel_active: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CHANNEL-ACTIVE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_immediate_nm_cycle_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-IMMEDIATE-NM-CYCLE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_immediate_nm_transmissions: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-IMMEDIATE-NM-TRANSMISSIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_message_timeout_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-MESSAGE-TIMEOUT-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_msg_cycle_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-MSG-CYCLE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_network_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-NETWORK-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_nid_position: Integer | None = field(
        default=None,
        metadata={
            "name": "NM-NID-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_remote_sleep_indication_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-REMOTE-SLEEP-INDICATION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_repeat_message_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-REPEAT-MESSAGE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_user_data_length: Integer | None = field(
        default=None,
        metadata={
            "name": "NM-USER-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_wait_bus_sleep_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-WAIT-BUS-SLEEP-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NmNodes:
        can_nm_node: list[CanNmNode] = field(
            default_factory=list,
            metadata={
                "name": "CAN-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_nm_node: list[FlexrayNmNode] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_nm_node: list[J1939NmNode] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        udp_nm_node: list[UdpNmNode] = field(
            default_factory=list,
            metadata={
                "name": "UDP-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CanTpConfig:
    """This element defines exactly one CAN TP Configuration.

    One CanTpConfig element shall be created for each CAN Network in the
    System.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_cluster_ref: A TpConfig is existing always in
        the context of exactly one CommunicationCluster.
    :ivar tp_addresss: Collection of TP Addresses. atpVariation:
        Derived, because EcuInstance can vary.
    :ivar tp_channels: Configuration of CAN TP channels.
    :ivar tp_connections: Senders and receivers of CAN TP messages.
        atpVariation: Derived, because TpNode can vary.
    :ivar tp_ecus: Collection of TP Ecus atpVariation: Derived, because
        EcuInstance can vary.
    :ivar tp_nodes: Senders and receivers of Can TP messages.
        atpVariation: Derived, because EcuInstance can vary.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-TP-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CanTpConfig.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CanTpConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_ref: Optional["CanTpConfig.CommunicationClusterRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_addresss: Optional["CanTpConfig.TpAddresss"] = field(
        default=None,
        metadata={
            "name": "TP-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_channels: Optional["CanTpConfig.TpChannels"] = field(
        default=None,
        metadata={
            "name": "TP-CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_connections: Optional["CanTpConfig.TpConnections"] = field(
        default=None,
        metadata={
            "name": "TP-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_ecus: Optional["CanTpConfig.TpEcus"] = field(
        default=None,
        metadata={
            "name": "TP-ECUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_nodes: Optional["CanTpConfig.TpNodes"] = field(
        default=None,
        metadata={
            "name": "TP-NODES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TpAddresss:
        can_tp_address: list[CanTpAddress] = field(
            default_factory=list,
            metadata={
                "name": "CAN-TP-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpChannels:
        can_tp_channel: list[CanTpChannel] = field(
            default_factory=list,
            metadata={
                "name": "CAN-TP-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpConnections:
        can_tp_connection: list[CanTpConnection] = field(
            default_factory=list,
            metadata={
                "name": "CAN-TP-CONNECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpEcus:
        can_tp_ecu: list[CanTpEcu] = field(
            default_factory=list,
            metadata={
                "name": "CAN-TP-ECU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpNodes:
        can_tp_node: list[CanTpNode] = field(
            default_factory=list,
            metadata={
                "name": "CAN-TP-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ClientComSpec:
    """'''begin restrict to CP''' Client-specific communication attributes
    (RPortPrototype typed by ClientServerInterface).

    '''end restrict to CP''' '''begin restrict to AP''' Client-specific
    communication attributes (RPortPrototype typed by ServiceInterface)
    that are relevant for methods and field getters and setters. '''end
    restrict to AP'''

    :ivar client_intent: This attribute represents the expressed intent
        of the client. The client may decide to claim that existing
        resources of a ServiceInterface are expressly not used by this
        specific client. The conceptual background of this claim may be
        driven by security, safety, etc.
    :ivar end_to_end_call_response_timeout: This attribute defines the
        maximum time interval in which the application shall expect the
        servers's response (time between the sending of the call
        invocation until the arrival of the server's response).
    :ivar getter_ref: The existence of this reference indicates that the
        ClientComSpec refers to the getter of a Field.
    :ivar operation_ref: This represents the corresponding
        ClientServerOperation.
    :ivar setter_ref: The existence of this reference indicates that the
        ClientComSpec refers to the setter of a Field.
    :ivar transformation_com_spec_propss: This references the
        TransformationComSpecProps which define port-specific
        configuration for data transformation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-COM-SPEC"

    client_intent: ClientIntentEnum | None = field(
        default=None,
        metadata={
            "name": "CLIENT-INTENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    end_to_end_call_response_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "END-TO-END-CALL-RESPONSE-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    getter_ref: Optional["ClientComSpec.GetterRef"] = field(
        default=None,
        metadata={
            "name": "GETTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_ref: Optional["ClientComSpec.OperationRef"] = field(
        default=None,
        metadata={
            "name": "OPERATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    setter_ref: Optional["ClientComSpec.SetterRef"] = field(
        default=None,
        metadata={
            "name": "SETTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformation_com_spec_propss: Optional["ClientComSpec.TransformationComSpecPropss"] = field(
        default=None,
        metadata={
            "name": "TRANSFORMATION-COM-SPEC-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class GetterRef(Ref):
        dest: FieldSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class OperationRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SetterRef(Ref):
        dest: FieldSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TransformationComSpecPropss:
        end_to_end_transformation_com_spec_props: list[EndToEndTransformationComSpecProps] = field(
            default_factory=list,
            metadata={
                "name": "END-TO-END-TRANSFORMATION-COM-SPEC-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_transformation_com_spec_props: list[UserDefinedTransformationComSpecProps] = (
            field(
                default_factory=list,
                metadata={
                    "name": "USER-DEFINED-TRANSFORMATION-COM-SPEC-PROPS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class ClientIdDefinitionSet:
    """
    Set of Client Identifiers that are used for inter-ECU client-server
    communication in the System.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar client_id_definitions: Definition of a Client Identifier that
        will be used by the RTE in a inter-ECU client-server
        communication.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-ID-DEFINITION-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ClientIdDefinitionSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ClientIdDefinitionSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_id_definitions: Optional["ClientIdDefinitionSet.ClientIdDefinitions"] = field(
        default=None,
        metadata={
            "name": "CLIENT-ID-DEFINITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClientIdDefinitions:
        client_id_definition: list[ClientIdDefinition] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-ID-DEFINITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ClientServerInterfaceToBswModuleEntryBlueprintMapping:
    """This represents a mapping between one ClientServerInterface blueprint and
    BswModuleEntry blueprint in order to express the intended implementation of
    ClientServerOperations by specific BswModuleEntries under consideration of
    PortDefinedArguments.

    Such a mapping enables the formal check whether the number of
    arguments and the data types of arguments of the operation +
    additional PortDefinedArguments matches the signature of the
    BswModuleEntry.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar client_server_interface_ref: The referenced
        ClientServerInterface represents the client server interface the
        mapping is dedicated to.
    :ivar operation_mappings: This specifies the operations used in the
        mapping between the ClientServerInterface and the
        BswModuleEntry.
    :ivar port_defined_argument_blueprints: This specifies the
        PortDefinedArguments used in the mapping between the
        ClientServerInterface and the BswModuleEntry.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-INTERFACE-TO-BSW-MODULE-ENTRY-BLUEPRINT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "ClientServerInterfaceToBswModuleEntryBlueprintMapping.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ClientServerInterfaceToBswModuleEntryBlueprintMapping.Annotations"] = (
        field(
            default=None,
            metadata={
                "name": "ANNOTATIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional[
        "ClientServerInterfaceToBswModuleEntryBlueprintMapping.BlueprintPolicys"
    ] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_server_interface_ref: Optional[
        "ClientServerInterfaceToBswModuleEntryBlueprintMapping.ClientServerInterfaceRef"
    ] = field(
        default=None,
        metadata={
            "name": "CLIENT-SERVER-INTERFACE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_mappings: Optional[
        "ClientServerInterfaceToBswModuleEntryBlueprintMapping.OperationMappings"
    ] = field(
        default=None,
        metadata={
            "name": "OPERATION-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_defined_argument_blueprints: Optional[
        "ClientServerInterfaceToBswModuleEntryBlueprintMapping.PortDefinedArgumentBlueprints"
    ] = field(
        default=None,
        metadata={
            "name": "PORT-DEFINED-ARGUMENT-BLUEPRINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClientServerInterfaceRef(Ref):
        dest: ClientServerInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class OperationMappings:
        client_server_operation_blueprint_mapping: list[ClientServerOperationBlueprintMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "CLIENT-SERVER-OPERATION-BLUEPRINT-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

    @dataclass(slots=True, kw_only=True)
    class PortDefinedArgumentBlueprints:
        port_defined_argument_blueprint: list[PortDefinedArgumentBlueprint] = field(
            default_factory=list,
            metadata={
                "name": "PORT-DEFINED-ARGUMENT-BLUEPRINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Collection:
    """This meta-class specifies a collection of elements.

    A collection can be utilized to express additional aspects for a set
    of elements. Note that Collection is an ARElement. Therefore it is
    applicable e.g. for EvaluatedVariant, even if this is not obvious.
    Usually the category of a Collection is "SET". On the other hand, a
    Collection can also express an arbitrary relationship between
    elements. This is denoted by the category "RELATION" (see also
    [TPS_GST_00347]). In this case the collection represents an
    association from "sourceElement" to "targetElement" in the role
    "role".

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar auto_collect: This attribute reflects how far the referenced
        objects are part of the collection.
    :ivar collection_semantics: Provides the ability to express the
        semantics of a Collection depending on the intended use case.
        The collectionSemantics is specified as a NameToken which must
        be agreed by all stakeholders.
    :ivar element_role: This attribute allows to denote a particular
        role of the collection. Note that the applicable semantics shall
        be mutually agreed between the two parties. In particular it
        denotes the role of element in the context of sourceElement.
    :ivar element_refs: This is an element in the collection. Note that
        Collection itself is collectable. Therefore collections can be
        nested. In case of category="RELATION" this represents the
        target end of the relation.
    :ivar source_element_refs: Only if Category = "RELATION". This
        represents the source of a relation.
    :ivar collected_instance_irefs: This instance ref supports the use
        case that a particular instance is part of the collection.
    :ivar source_instance_irefs: Only if Category = "RELATION". This
        represents the source instance of a relation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COLLECTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Collection.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Collection.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    auto_collect: AutoCollectEnum | None = field(
        default=None,
        metadata={
            "name": "AUTO-COLLECT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    collection_semantics: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "COLLECTION-SEMANTICS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    element_role: Identifier | None = field(
        default=None,
        metadata={
            "name": "ELEMENT-ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    element_refs: Optional["Collection.ElementRefs"] = field(
        default=None,
        metadata={
            "name": "ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_element_refs: Optional["Collection.SourceElementRefs"] = field(
        default=None,
        metadata={
            "name": "SOURCE-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    collected_instance_irefs: Optional["Collection.CollectedInstanceIrefs"] = field(
        default=None,
        metadata={
            "name": "COLLECTED-INSTANCE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_instance_irefs: Optional["Collection.SourceInstanceIrefs"] = field(
        default=None,
        metadata={
            "name": "SOURCE-INSTANCE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ElementRefs:
        element_ref: list["Collection.ElementRefs.ElementRef"] = field(
            default_factory=list,
            metadata={
                "name": "ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ElementRef(Ref):
            dest: IdentifiableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SourceElementRefs:
        source_element_ref: list["Collection.SourceElementRefs.SourceElementRef"] = field(
            default_factory=list,
            metadata={
                "name": "SOURCE-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SourceElementRef(Ref):
            dest: IdentifiableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class CollectedInstanceIrefs:
        collected_instance_iref: list[AnyInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "COLLECTED-INSTANCE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SourceInstanceIrefs:
        source_instance_iref: list[AnyInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "SOURCE-INSTANCE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Compu:
    """
    This meta-class represents the ability to express one particular computation.

    :ivar compu_scales: This represents one scale within the compu
        method. Note that it contains a Variationpoint in order to
        support blueprints of enumerations.
    :ivar compu_default_value: This property can be used to specify an
        output value for a conversion formula, if the value to be
        converted lies outside the plausibility limit. Although this is
        possible for all conversion formulae, it is especially valid for
        variables with tabular conversion formulae.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPU"

    compu_scales: Optional["Compu.CompuScales"] = field(
        default=None,
        metadata={
            "name": "COMPU-SCALES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compu_default_value: CompuConst | None = field(
        default=None,
        metadata={
            "name": "COMPU-DEFAULT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CompuScales:
        compu_scale: list[CompuScale] = field(
            default_factory=list,
            metadata={
                "name": "COMPU-SCALE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CompuScales:
    """
    This meta-class represents the ability to stepwise express a computation
    method.

    :ivar compu_scales: This represents one scale within the compu
        method. Note that it contains a Variationpoint in order to
        support blueprints of enumerations.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPU-SCALES"

    compu_scales: Optional["CompuScales.CompuScalesInner"] = field(
        default=None,
        metadata={
            "name": "COMPU-SCALES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CompuScalesInner:
        compu_scale: list[CompuScale] = field(
            default_factory=list,
            metadata={
                "name": "COMPU-SCALE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ConsumedProvidedServiceInstanceGroup:
    """The AUTOSAR ServiceDiscovery is able to start and to stop ClientServices and
    ServerServices,respectively, at runtime.

    A SdServiceGroup contains several ClientServices and ServerServices,
    respectively.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar consumed_service_instances: This reference assigns a set of
        ProvidedServiceInstances to the
        ConsumedProvidedServiceInstanceGroup. This property was modified
        due to atpVariation (DirectedAssociationPattern).
    :ivar provided_service_instances: This reference assigns a set of
        ConsumedServiceInstances to the
        ConsumedProvidedServiceInstanceGroup. This property was modified
        due to atpVariation (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONSUMED-PROVIDED-SERVICE-INSTANCE-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ConsumedProvidedServiceInstanceGroup.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ConsumedProvidedServiceInstanceGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consumed_service_instances: Optional[
        "ConsumedProvidedServiceInstanceGroup.ConsumedServiceInstances"
    ] = field(
        default=None,
        metadata={
            "name": "CONSUMED-SERVICE-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_service_instances: Optional[
        "ConsumedProvidedServiceInstanceGroup.ProvidedServiceInstances"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDED-SERVICE-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConsumedServiceInstances:
        consumed_service_instance_ref_conditional: list[ConsumedServiceInstanceRefConditional] = (
            field(
                default_factory=list,
                metadata={
                    "name": "CONSUMED-SERVICE-INSTANCE-REF-CONDITIONAL",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedServiceInstances:
        provided_service_instance_ref_conditional: list[ProvidedServiceInstanceRefConditional] = (
            field(
                default_factory=list,
                metadata={
                    "name": "PROVIDED-SERVICE-INSTANCE-REF-CONDITIONAL",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class CouplingPortConnection:
    """
    Connection between two CouplingPorts (firstPort and secondPort) or between a
    collection of Ports that are all referenced by the portCollection reference.

    :ivar first_port_ref: Reference to the first CouplingPort that is
        connected via the CouplingPortConnection.
    :ivar node_ports: This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar plca_local_node_count: Defines the number of communication
        participants in case 10BASE-T1S and the nodePort reference is
        used.
    :ivar plca_transmit_opportunity_timer: Timer for the transmission in
        bit time to evaluate if a Transmission Opportunity is yield or
        not.
    :ivar second_port_ref: Reference to the second CouplingPort that is
        connected via the CouplingPortConnection.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EthernetClusterContent.couplingPortConnection
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COUPLING-PORT-CONNECTION"

    first_port_ref: Optional["CouplingPortConnection.FirstPortRef"] = field(
        default=None,
        metadata={
            "name": "FIRST-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    node_ports: Optional["CouplingPortConnection.NodePorts"] = field(
        default=None,
        metadata={
            "name": "NODE-PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    plca_local_node_count: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PLCA-LOCAL-NODE-COUNT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    plca_transmit_opportunity_timer: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PLCA-TRANSMIT-OPPORTUNITY-TIMER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    second_port_ref: Optional["CouplingPortConnection.SecondPortRef"] = field(
        default=None,
        metadata={
            "name": "SECOND-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FirstPortRef(Ref):
        dest: CouplingPortSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NodePorts:
        coupling_port_ref_conditional: list[CouplingPortRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "COUPLING-PORT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecondPortRef(Ref):
        dest: CouplingPortSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class CouplingPortDetails:
    """Defines details of a CouplingPort.

    May be used to configure the structures of a switch.

    :ivar coupling_port_structural_elements: Collects all the structural
        parts at which a CouplingPort may be configurable.
    :ivar ethernet_priority_regenerations: Defines a priority
        regeneration where the ingress priority is replaced by
        regenerated priority.
    :ivar ethernet_traffic_class_assignments: Defines the ingress port
        to EthernetTrafficClass assignment.
    :ivar global_time_props: Specifies properties for the usage of the
        CouplingPort in the scope of Global Time Sync.
    :ivar last_egress_scheduler_ref: Defines which CouplingPortScheduler
        is the last in the egress port structure.
    :ivar rate_policys: Rate policies to be applied for this
        CouplingPort.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COUPLING-PORT-DETAILS"

    coupling_port_structural_elements: Optional[
        "CouplingPortDetails.CouplingPortStructuralElements"
    ] = field(
        default=None,
        metadata={
            "name": "COUPLING-PORT-STRUCTURAL-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ethernet_priority_regenerations: Optional[
        "CouplingPortDetails.EthernetPriorityRegenerations"
    ] = field(
        default=None,
        metadata={
            "name": "ETHERNET-PRIORITY-REGENERATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ethernet_traffic_class_assignments: Optional[
        "CouplingPortDetails.EthernetTrafficClassAssignments"
    ] = field(
        default=None,
        metadata={
            "name": "ETHERNET-TRAFFIC-CLASS-ASSIGNMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_time_props: GlobalTimeCouplingPortProps | None = field(
        default=None,
        metadata={
            "name": "GLOBAL-TIME-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    last_egress_scheduler_ref: Optional["CouplingPortDetails.LastEgressSchedulerRef"] = field(
        default=None,
        metadata={
            "name": "LAST-EGRESS-SCHEDULER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rate_policys: Optional["CouplingPortDetails.RatePolicys"] = field(
        default=None,
        metadata={
            "name": "RATE-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CouplingPortStructuralElements:
        coupling_port_fifo: list[CouplingPortFifo] = field(
            default_factory=list,
            metadata={
                "name": "COUPLING-PORT-FIFO",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        coupling_port_scheduler: list[CouplingPortScheduler] = field(
            default_factory=list,
            metadata={
                "name": "COUPLING-PORT-SCHEDULER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        coupling_port_shaper: list[CouplingPortShaper] = field(
            default_factory=list,
            metadata={
                "name": "COUPLING-PORT-SHAPER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EthernetPriorityRegenerations:
        ethernet_priority_regeneration: list[EthernetPriorityRegeneration] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-PRIORITY-REGENERATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 8,
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EthernetTrafficClassAssignments:
        coupling_port_traffic_class_assignment: list[CouplingPortTrafficClassAssignment] = field(
            default_factory=list,
            metadata={
                "name": "COUPLING-PORT-TRAFFIC-CLASS-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 8,
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LastEgressSchedulerRef(Ref):
        dest: CouplingPortSchedulerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RatePolicys:
        coupling_port_rate_policy: list[CouplingPortRatePolicy] = field(
            default_factory=list,
            metadata={
                "name": "COUPLING-PORT-RATE-POLICY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CpSoftwareCluster:
    """This meta class provides the ability to define a CP Software Cluster.

    Each CP Software Cluster can be integrated and build individually.
    It defines the sub-set of hierarchical tree(s) of Software
    Components belonging to this CP Software Cluster. Resources required
    or provided by this CP Software Cluster are given in the according
    mappings.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar software_cluster_id: This attribute represents the value of
        the id of the corresponding CP software cluster.
    :ivar sw_component_assignments: This is the collection of
        SwComponentPrototypeAssignments
    :ivar sw_compositions: Software Components in the context of a
        CompositionSwComponentType belonging to this CP Software
        Cluster. This reference can be used to describe the belonging
        SWCs when the CP Software Cluster is described out of the
        context of a System, e.g. reusable CP Software Cluster. This
        property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CP-SOFTWARE-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CpSoftwareCluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CpSoftwareCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_cluster_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CLUSTER-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_assignments: Optional["CpSoftwareCluster.SwComponentAssignments"] = field(
        default=None,
        metadata={
            "name": "SW-COMPONENT-ASSIGNMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_compositions: Optional["CpSoftwareCluster.SwCompositions"] = field(
        default=None,
        metadata={
            "name": "SW-COMPOSITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwComponentAssignments:
        sw_component_prototype_assignment: list[SwComponentPrototypeAssignment] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMPONENT-PROTOTYPE-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwCompositions:
        composition_sw_component_type_ref_conditional: list[
            CompositionSwComponentTypeRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "COMPOSITION-SW-COMPONENT-TYPE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CpSoftwareClusterMappingSet:
    """This meta-class represents the ability to aggregate a collection of CP
    Software Cluster relevant mappings.

    This is applicable if a CP Software Cluster is described besides a
    concrete System, e.g. a reusable CP Software Cluster.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar port_element_to_com_resource_mappings: maps a communication
        resource to CP Software Clusters
    :ivar resource_to_application_partition_mappings: Maps a Software
        Cluster resource to an Application Partition to restrict the
        usage.
    :ivar software_cluster_to_resource_mappings: maps a service resource
        to CP Software Clusters
    :ivar swc_to_application_partition_mappings: maps
        SwComponentPrototypes in a CP Software Cluster to
        ApplicationPartitions
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CP-SOFTWARE-CLUSTER-MAPPING-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CpSoftwareClusterMappingSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CpSoftwareClusterMappingSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_element_to_com_resource_mappings: Optional[
        "CpSoftwareClusterMappingSet.PortElementToComResourceMappings"
    ] = field(
        default=None,
        metadata={
            "name": "PORT-ELEMENT-TO-COM-RESOURCE-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resource_to_application_partition_mappings: Optional[
        "CpSoftwareClusterMappingSet.ResourceToApplicationPartitionMappings"
    ] = field(
        default=None,
        metadata={
            "name": "RESOURCE-TO-APPLICATION-PARTITION-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_cluster_to_resource_mappings: Optional[
        "CpSoftwareClusterMappingSet.SoftwareClusterToResourceMappings"
    ] = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CLUSTER-TO-RESOURCE-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_to_application_partition_mappings: Optional[
        "CpSoftwareClusterMappingSet.SwcToApplicationPartitionMappings"
    ] = field(
        default=None,
        metadata={
            "name": "SWC-TO-APPLICATION-PARTITION-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortElementToComResourceMappings:
        port_element_to_communication_resource_mapping: list[
            PortElementToCommunicationResourceMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "PORT-ELEMENT-TO-COMMUNICATION-RESOURCE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ResourceToApplicationPartitionMappings:
        cp_software_cluster_resource_to_application_partition_mapping: list[
            CpSoftwareClusterResourceToApplicationPartitionMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "CP-SOFTWARE-CLUSTER-RESOURCE-TO-APPLICATION-PARTITION-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SoftwareClusterToResourceMappings:
        cp_software_cluster_to_resource_mapping: list[CpSoftwareClusterToResourceMapping] = field(
            default_factory=list,
            metadata={
                "name": "CP-SOFTWARE-CLUSTER-TO-RESOURCE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcToApplicationPartitionMappings:
        swc_to_application_partition_mapping: list[SwcToApplicationPartitionMapping] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TO-APPLICATION-PARTITION-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CpSoftwareClusterResourcePool:
    """
    Represents the pool of resources which can be provided or required by CP
    Software Clusters.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar ecu_scope_refs: This reference identifies the EcuInstance in
        which the resource pool is defined.
    :ivar resources: This aggregation represents the collection of
        resources in the enclosing resource pool.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CP-SOFTWARE-CLUSTER-RESOURCE-POOL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CpSoftwareClusterResourcePool.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CpSoftwareClusterResourcePool.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_scope_refs: Optional["CpSoftwareClusterResourcePool.EcuScopeRefs"] = field(
        default=None,
        metadata={
            "name": "ECU-SCOPE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resources: Optional["CpSoftwareClusterResourcePool.Resources"] = field(
        default=None,
        metadata={
            "name": "RESOURCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuScopeRefs:
        ecu_scope_ref: list["CpSoftwareClusterResourcePool.EcuScopeRefs.EcuScopeRef"] = field(
            default_factory=list,
            metadata={
                "name": "ECU-SCOPE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EcuScopeRef(Ref):
            dest: EcuInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class Resources:
        cp_software_cluster_communication_resource: list[CpSoftwareClusterCommunicationResource] = (
            field(
                default_factory=list,
                metadata={
                    "name": "CP-SOFTWARE-CLUSTER-COMMUNICATION-RESOURCE",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        cp_software_cluster_service_resource: list[CpSoftwareClusterServiceResource] = field(
            default_factory=list,
            metadata={
                "name": "CP-SOFTWARE-CLUSTER-SERVICE-RESOURCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CpSoftwareClusterToEcuInstanceMapping:
    """
    This meta class maps a CpSoftwareCluster to a EcuInstance.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar ecu_instance_ref: Reference to a specific ECU Instance
        description.
    :ivar machine_id: Unique number of the (virtual or physical) machine
        to which the Software Cluster is mapped.
    :ivar sw_clusters: The mapped CP Software Cluster This property was
        modified due to atpVariation (DirectedAssociationPattern).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.swClusterMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CP-SOFTWARE-CLUSTER-TO-ECU-INSTANCE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CpSoftwareClusterToEcuInstanceMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CpSoftwareClusterToEcuInstanceMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["CpSoftwareClusterToEcuInstanceMapping.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    machine_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MACHINE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_clusters: Optional["CpSoftwareClusterToEcuInstanceMapping.SwClusters"] = field(
        default=None,
        metadata={
            "name": "SW-CLUSTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SwClusters:
        cp_software_cluster_ref_conditional: list[CpSoftwareClusterRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "CP-SOFTWARE-CLUSTER-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoProvider:
    """CryptoProvider implements cryptographic primitives (algorithms) supported by
    the stack.

    Implementation of this component may be software or hardware based
    (HSM/TPM).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar crypto_provider_documentation_ref: Documentation of the
        CryptoProvider that describes the implemented cryptographic
        primitives.
    :ivar key_slots: This aggregation represents the key slots that are
        allocated by the CryptoProvider.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-PROVIDER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoProvider.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoProvider.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_provider_documentation_ref: Optional["CryptoProvider.CryptoProviderDocumentationRef"] = (
        field(
            default=None,
            metadata={
                "name": "CRYPTO-PROVIDER-DOCUMENTATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    key_slots: Optional["CryptoProvider.KeySlots"] = field(
        default=None,
        metadata={
            "name": "KEY-SLOTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoProviderDocumentationRef(Ref):
        dest: DocumentationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class KeySlots:
        crypto_key_slot: list[CryptoKeySlot] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-KEY-SLOT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CustomCppImplementationDataType:
    """This meta-class represents the way to specify a data type definition that is
    taken as the basis for a C++ language binding to a custom implementation that
    is declared in the configured header file.

    The ShortName of this CustomCppImplementationDataType defines the
    Class-Name of the custom implementation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar sw_data_def_props: The properties of this AutosarDataType.
    :ivar array_size: This attribute can be used to specify the array
        size if the enclosing CppImplementationDataType has array
        semantics.
    :ivar header_file: Configuration of the Header File with the custom
        class declaration.
    :ivar namespaces: This aggregation allows for the definition an own
        namespace for the enclosing CppImplementationDataType.
    :ivar sub_elements: This represents the collection of sub-elements
        of the enclosing CppImplementationDataType
    :ivar template_arguments: This aggregation allows for the
        specification of properties of template arguments
    :ivar type_emitter: This attribute can be taken to control how the
        respective CppImplementationDataType is contributed to the
        language binding.
    :ivar type_reference_ref: This reference shall be defined to define
        a type reference (a.k.a. typedef).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CUSTOM-CPP-IMPLEMENTATION-DATA-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CustomCppImplementationDataType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CustomCppImplementationDataType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["CustomCppImplementationDataType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    array_size: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "ARRAY-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    header_file: String | None = field(
        default=None,
        metadata={
            "name": "HEADER-FILE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["CustomCppImplementationDataType.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_elements: Optional["CustomCppImplementationDataType.SubElements"] = field(
        default=None,
        metadata={
            "name": "SUB-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    template_arguments: Optional["CustomCppImplementationDataType.TemplateArguments"] = field(
        default=None,
        metadata={
            "name": "TEMPLATE-ARGUMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_emitter: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "TYPE-EMITTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_reference_ref: Optional["CustomCppImplementationDataType.TypeReferenceRef"] = field(
        default=None,
        metadata={
            "name": "TYPE-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubElements:
        cpp_implementation_data_type_element: list[CppImplementationDataTypeElement] = field(
            default_factory=list,
            metadata={
                "name": "CPP-IMPLEMENTATION-DATA-TYPE-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TemplateArguments:
        cpp_template_argument: list[CppTemplateArgument] = field(
            default_factory=list,
            metadata={
                "name": "CPP-TEMPLATE-ARGUMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TypeReferenceRef(Ref):
        dest: CppImplementationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DataPrototypeGroup:
    """This meta-class represents the ability to define a collection of
    DataPrototypes that are subject to the formal definition of implicit
    communication behavior.

    The definition of the collection can be nested.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar data_prototype_group_irefs: This represents the ability to
        define nested groups of VariableDataPrototypes.
    :ivar implicit_data_access_irefs: This represents a collection of
        VariableDataPrototypes that belong to the enclosing
        DataPrototypeGroup
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ConsistencyNeeds.dpgRequiresCoherency Applicable for:
        ConsistencyNeeds.dpgDoesNotRequireCoherency
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-PROTOTYPE-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DataPrototypeGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DataPrototypeGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototype_group_irefs: Optional["DataPrototypeGroup.DataPrototypeGroupIrefs"] = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-GROUP-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implicit_data_access_irefs: Optional["DataPrototypeGroup.ImplicitDataAccessIrefs"] = field(
        default=None,
        metadata={
            "name": "IMPLICIT-DATA-ACCESS-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataPrototypeGroupIrefs:
        data_prototype_group_iref: list[InnerDataPrototypeGroupInCompositionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "DATA-PROTOTYPE-GROUP-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplicitDataAccessIrefs:
        implicit_data_access_iref: list[VariableDataPrototypeInCompositionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "IMPLICIT-DATA-ACCESS-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DdsFieldDeployment:
    """
    DDS configuration settings for a Field.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar field_ref: Reference to a Field that is deployed to a
        middleware transport layer.
    :ivar notifier: This aggregation represents the settings of the
        notifier.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-FIELD-DEPLOYMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DdsFieldDeployment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DdsFieldDeployment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_ref: Optional["DdsFieldDeployment.FieldRef"] = field(
        default=None,
        metadata={
            "name": "FIELD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    notifier: DdsEventDeployment | None = field(
        default=None,
        metadata={
            "name": "NOTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FieldRef(Ref):
        dest: FieldSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DdsProvidedServiceInstance:
    """
    This meta-class represents the ability to describe the existence and
    configuration of a provided service instance in a concrete implementation on
    top of DDS.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar e_2_e_event_protection_propss: This aggregation allows to
        protect an event or a field notifier that is defined inside of
        the ServiceInterface that is referenced by the ServiceInstance
        in the role serviceInterface.
    :ivar e_2_e_method_protection_propss: This aggregation allows to
        protect a method or a field getter or a field setter that is
        defined inside of the ServiceInterface that is referenced by the
        ServiceInstance in the role serviceInterface
    :ivar secure_com_configs: Configuration settings to secure the
        communication of ServiceInterface elements.
    :ivar service_interface_deployment_ref: Reference to a
        ServiceInterfaceDeployment that identifies the ServiceInterface
        that is represented by the ServiceInstance.
    :ivar qos_profile: Identifies a group of QoS Policies that apply to
        the DDS entities associated with the event, method, field, or
        the service instance.
    :ivar domain_id: This attribute identifies the DDS Domain the
        Service Instance shall join.
    :ivar discovery_type: Discovery protocol.
    :ivar event_qos_propss: List of configuration properties for the
        Events that are provided by the Service Instance.
    :ivar field_notifier_qos_propss: List of configuration properties
        for Field notifiers that are provided by the Service Instance.
    :ivar resource_identifier_type: Type of resource identification
        scheme.
    :ivar service_instance_id: Identification number that is used by DDS
        to identify DomainParticipants associated with an instance of
        the service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-PROVIDED-SERVICE-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DdsProvidedServiceInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DdsProvidedServiceInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_event_protection_propss: Optional[
        "DdsProvidedServiceInstance.E2EEventProtectionPropss"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-EVENT-PROTECTION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_method_protection_propss: Optional[
        "DdsProvidedServiceInstance.E2EMethodProtectionPropss"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-METHOD-PROTECTION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_com_configs: Optional["DdsProvidedServiceInstance.SecureComConfigs"] = field(
        default=None,
        metadata={
            "name": "SECURE-COM-CONFIGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_deployment_ref: Optional[
        "DdsProvidedServiceInstance.ServiceInterfaceDeploymentRef"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-DEPLOYMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    qos_profile: String | None = field(
        default=None,
        metadata={
            "name": "QOS-PROFILE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    domain_id: Integer | None = field(
        default=None,
        metadata={
            "name": "DOMAIN-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    discovery_type: DdsServiceInstanceDiscoveryTypeEnum | None = field(
        default=None,
        metadata={
            "name": "DISCOVERY-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_qos_propss: Optional["DdsProvidedServiceInstance.EventQosPropss"] = field(
        default=None,
        metadata={
            "name": "EVENT-QOS-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_notifier_qos_propss: Optional["DdsProvidedServiceInstance.FieldNotifierQosPropss"] = (
        field(
            default=None,
            metadata={
                "name": "FIELD-NOTIFIER-QOS-PROPSS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    resource_identifier_type: DdsServiceInstanceResourceIdentifierTypeEnum | None = field(
        default=None,
        metadata={
            "name": "RESOURCE-IDENTIFIER-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EEventProtectionPropss:
        end_2_end_event_protection_props: list[End2EndEventProtectionProps] = field(
            default_factory=list,
            metadata={
                "name": "END-2-END-EVENT-PROTECTION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EMethodProtectionPropss:
        end_2_end_method_protection_props: list[End2EndMethodProtectionProps] = field(
            default_factory=list,
            metadata={
                "name": "END-2-END-METHOD-PROTECTION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecureComConfigs:
        service_interface_element_secure_com_config: list[
            ServiceInterfaceElementSecureComConfig
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE-ELEMENT-SECURE-COM-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInterfaceDeploymentRef(Ref):
        dest: ServiceInterfaceDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventQosPropss:
        dds_event_qos_props: list[DdsEventQosProps] = field(
            default_factory=list,
            metadata={
                "name": "DDS-EVENT-QOS-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FieldNotifierQosPropss:
        dds_field_qos_props: list[DdsFieldQosProps] = field(
            default_factory=list,
            metadata={
                "name": "DDS-FIELD-QOS-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DdsRequiredServiceInstance:
    """
    This meta-class represents the ability to describe the existence and
    configuration of a required service instance in a concrete implementation on
    top of DDS.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar e_2_e_event_protection_propss: This aggregation allows to
        protect an event or a field notifier that is defined inside of
        the ServiceInterface that is referenced by the ServiceInstance
        in the role serviceInterface.
    :ivar e_2_e_method_protection_propss: This aggregation allows to
        protect a method or a field getter or a field setter that is
        defined inside of the ServiceInterface that is referenced by the
        ServiceInstance in the role serviceInterface
    :ivar secure_com_configs: Configuration settings to secure the
        communication of ServiceInterface elements.
    :ivar service_interface_deployment_ref: Reference to a
        ServiceInterfaceDeployment that identifies the ServiceInterface
        that is represented by the ServiceInstance.
    :ivar qos_profile: Identifies a group of QoS Policies that apply to
        the DDS entities associated with the event, method, field, or
        the service instance.
    :ivar domain_id: This attribute identifies the DDS Domain the
        Service Instance shall join.
    :ivar blocklisted_versions: Collection of blocklisted versions.
    :ivar discovery_type: Discovery protocol.
    :ivar event_qos_propss: List of configuration properties for the
        Events that are required by the Service Instance.
    :ivar field_notifier_qos_propss: List of configuration properties
        for Field notifiers that are required by the Service Instance.
    :ivar required_service_instance_id: This attribute represents the
        ability to describe the required service instance ID.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-REQUIRED-SERVICE-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DdsRequiredServiceInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DdsRequiredServiceInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_event_protection_propss: Optional[
        "DdsRequiredServiceInstance.E2EEventProtectionPropss"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-EVENT-PROTECTION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_method_protection_propss: Optional[
        "DdsRequiredServiceInstance.E2EMethodProtectionPropss"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-METHOD-PROTECTION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_com_configs: Optional["DdsRequiredServiceInstance.SecureComConfigs"] = field(
        default=None,
        metadata={
            "name": "SECURE-COM-CONFIGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_deployment_ref: Optional[
        "DdsRequiredServiceInstance.ServiceInterfaceDeploymentRef"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-DEPLOYMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    qos_profile: String | None = field(
        default=None,
        metadata={
            "name": "QOS-PROFILE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    domain_id: Integer | None = field(
        default=None,
        metadata={
            "name": "DOMAIN-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blocklisted_versions: Optional["DdsRequiredServiceInstance.BlocklistedVersions"] = field(
        default=None,
        metadata={
            "name": "BLOCKLISTED-VERSIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    discovery_type: DdsServiceInstanceDiscoveryTypeEnum | None = field(
        default=None,
        metadata={
            "name": "DISCOVERY-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_qos_propss: Optional["DdsRequiredServiceInstance.EventQosPropss"] = field(
        default=None,
        metadata={
            "name": "EVENT-QOS-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_notifier_qos_propss: Optional["DdsRequiredServiceInstance.FieldNotifierQosPropss"] = (
        field(
            default=None,
            metadata={
                "name": "FIELD-NOTIFIER-QOS-PROPSS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    required_service_instance_id: AnyServiceInstanceId | None = field(
        default=None,
        metadata={
            "name": "REQUIRED-SERVICE-INSTANCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EEventProtectionPropss:
        end_2_end_event_protection_props: list[End2EndEventProtectionProps] = field(
            default_factory=list,
            metadata={
                "name": "END-2-END-EVENT-PROTECTION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EMethodProtectionPropss:
        end_2_end_method_protection_props: list[End2EndMethodProtectionProps] = field(
            default_factory=list,
            metadata={
                "name": "END-2-END-METHOD-PROTECTION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecureComConfigs:
        service_interface_element_secure_com_config: list[
            ServiceInterfaceElementSecureComConfig
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE-ELEMENT-SECURE-COM-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInterfaceDeploymentRef(Ref):
        dest: ServiceInterfaceDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class BlocklistedVersions:
        dds_service_version: list[DdsServiceVersion] = field(
            default_factory=list,
            metadata={
                "name": "DDS-SERVICE-VERSION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventQosPropss:
        dds_event_qos_props: list[DdsEventQosProps] = field(
            default_factory=list,
            metadata={
                "name": "DDS-EVENT-QOS-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FieldNotifierQosPropss:
        dds_field_qos_props: list[DdsFieldQosProps] = field(
            default_factory=list,
            metadata={
                "name": "DDS-FIELD-QOS-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DdsSecureGovernance:
    """
    Configuration of DDS Security for all applications joining a specific set of
    DDS Domains.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar allow_unauthenticated_participants: Defines whether
        unauthenticated participants can join this domain.
    :ivar discovery_protection_kind: Defines the kind of cryptographic
        transformation to apply in DDS discovery communication.
    :ivar domain_ids: Set of domains to be covered by this property set.
    :ivar enable_join_access_control: Defines whether access control is
        to be enforced upon joining this domain.
    :ivar identity_certificate_authority_ref: Certificate representing
        the identity certificate authority applicable to the domain(s)
        specified by domainsIds.
    :ivar liveliness_protection_kind: Defines the kind of cryptographic
        transformation to apply in DDS liveliness communication.
    :ivar permission_certificate_authority_ref: Certificate representing
        the permissions certificate authority applicable to the
        domain(s) specified by domainsIds.
    :ivar rtps_protection_kind: Defines the kind of cryptographic
        transformation to apply to whole DDS RTPS.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-SECURE-GOVERNANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DdsSecureGovernance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DdsSecureGovernance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    allow_unauthenticated_participants: Boolean | None = field(
        default=None,
        metadata={
            "name": "ALLOW-UNAUTHENTICATED-PARTICIPANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    discovery_protection_kind: DdsProtectionKindEnum | None = field(
        default=None,
        metadata={
            "name": "DISCOVERY-PROTECTION-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    domain_ids: Optional["DdsSecureGovernance.DomainIds"] = field(
        default=None,
        metadata={
            "name": "DOMAIN-IDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    enable_join_access_control: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-JOIN-ACCESS-CONTROL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    identity_certificate_authority_ref: Optional[
        "DdsSecureGovernance.IdentityCertificateAuthorityRef"
    ] = field(
        default=None,
        metadata={
            "name": "IDENTITY-CERTIFICATE-AUTHORITY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    liveliness_protection_kind: DdsProtectionKindEnum | None = field(
        default=None,
        metadata={
            "name": "LIVELINESS-PROTECTION-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    permission_certificate_authority_ref: Optional[
        "DdsSecureGovernance.PermissionCertificateAuthorityRef"
    ] = field(
        default=None,
        metadata={
            "name": "PERMISSION-CERTIFICATE-AUTHORITY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rtps_protection_kind: DdsProtectionKindEnum | None = field(
        default=None,
        metadata={
            "name": "RTPS-PROTECTION-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DomainIds:
        dds_domain_range: list[DdsDomainRange] = field(
            default_factory=list,
            metadata={
                "name": "DDS-DOMAIN-RANGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IdentityCertificateAuthorityRef(Ref):
        dest: CryptoCertificateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PermissionCertificateAuthorityRef(Ref):
        dest: CryptoCertificateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DhcpServerConfiguration:
    """Defines the configuration of DHCP servers that are running on the network
    endpoint.

    It is possible that an Ipv4DhcpServer and an Ipv6DhcpServer run on
    the same Ecu.

    :ivar ipv_4_dhcp_server_configuration: Configuration of a IPv4 DHCP
        server that runs on the network endpoint.
    :ivar ipv_6_dhcp_server_configuration: Configuration of a IPv6 DHCP
        server that runs on the network endpoint.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DHCP-SERVER-CONFIGURATION"

    ipv_4_dhcp_server_configuration: Ipv4DhcpServerConfiguration | None = field(
        default=None,
        metadata={
            "name": "IPV-4-DHCP-SERVER-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ipv_6_dhcp_server_configuration: Ipv6DhcpServerConfiguration | None = field(
        default=None,
        metadata={
            "name": "IPV-6-DHCP-SERVER-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticAging:
    """
    Defines the aging algorithm.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar aging_cycles: This represents the applicable aging cycle. This
        property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar threshold: Number of aging cycles needed to unlearn/delete the
        event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-AGING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticAging.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticAging.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    aging_cycles: Optional["DiagnosticAging.AgingCycles"] = field(
        default=None,
        metadata={
            "name": "AGING-CYCLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    threshold: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AgingCycles:
        diagnostic_operation_cycle_ref_conditional: list[DiagnosticOperationCycleRefConditional] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-OPERATION-CYCLE-REF-CONDITIONAL",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDebounceAlgorithmProps:
    """
    Defines properties for the debounce algorithm class.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar debounce_algorithm: This represents the actual debounce
        algorithm.
    :ivar debounce_behavior: This attribute defines how the event
        debounce algorithm will behave, if a related enable condition is
        not fulfilled or ControlDTCSetting of the related event is
        disabled.
    :ivar debounce_counter_storage: Switch to store the debounce counter
        value non-volatile or not. true: debounce counter value shall be
        stored non-volatile false: debounce counter value is volatile
        Please note that this attribute is not relevant for the adaptive
        platform.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DEBOUNCE-ALGORITHM-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDebounceAlgorithmProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDebounceAlgorithmProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    debounce_algorithm: Optional["DiagnosticDebounceAlgorithmProps.DebounceAlgorithm"] = field(
        default=None,
        metadata={
            "name": "DEBOUNCE-ALGORITHM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    debounce_behavior: DiagnosticDebounceBehaviorEnumValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "DEBOUNCE-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    debounce_counter_storage: Boolean | None = field(
        default=None,
        metadata={
            "name": "DEBOUNCE-COUNTER-STORAGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DebounceAlgorithm:
        diag_event_debounce_counter_based: DiagEventDebounceCounterBased | None = field(
            default=None,
            metadata={
                "name": "DIAG-EVENT-DEBOUNCE-COUNTER-BASED",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diag_event_debounce_monitor_internal: DiagEventDebounceMonitorInternal | None = field(
            default=None,
            metadata={
                "name": "DIAG-EVENT-DEBOUNCE-MONITOR-INTERNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diag_event_debounce_time_based: DiagEventDebounceTimeBased | None = field(
            default=None,
            metadata={
                "name": "DIAG-EVENT-DEBOUNCE-TIME-BASED",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEnableConditionGroup:
    """
    Enable condition group which includes one or several enable conditions.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar enable_conditions: Reference to enableConditions that are part
        of the EnableConditionGroup. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ENABLE-CONDITION-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEnableConditionGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEnableConditionGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    enable_conditions: Optional["DiagnosticEnableConditionGroup.EnableConditions"] = field(
        default=None,
        metadata={
            "name": "ENABLE-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EnableConditions:
        diagnostic_enable_condition_ref_conditional: list[
            DiagnosticEnableConditionRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ENABLE-CONDITION-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEvent:
    """
    This element is used to configure DiagnosticEvents.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar aging_allowed: This represents the decision whether aging is
        allowed for this DiagnosticEvent.
    :ivar associated_event_identification: This attribute represents the
        identification number that is associated with the enclosing
        DiagnosticEvent and allows to identify it when placed into a
        snapshot record or extended data record storage. This value can
        be reported as internal data element in snapshot records or
        extended data records.
    :ivar clear_event_allowed_behavior: This attribute defines the
        resulting UDS status byte for the related event, which shall not
        be cleared according to the ClearEventAllowed callback
    :ivar clear_event_behavior: '''begin restrict to AP''' This
        attribute defines the resulting UDS DTC status byte for the
        related event, which shall not be cleared according to the
        ClearEventAllowed callback. '''end restrict to AP''' '''begin
        restrict to CP''' This attribute defines the resulting UDS
        status byte for the related event, which shall not be cleared
        according to the ClearEventAllowed callback. '''end restrict to
        CP'''
    :ivar confirmation_threshold: This attribute defines the number of
        operation cycles with a failed result before a confirmed DTC is
        set to 1. The semantic of this attribute is a by "1" increased
        value compared to the confirmation threshold of the "trip
        counter" mentioned in ISO 14229-1 in figure D.4. A value of "1"
        defines the immediate confirmation of the DTC along with the
        first reported failed. This is also sometimes called "zero trip
        DTC". A value of "2" defines a DTC confirmation in the operation
        cycle after the first occurred failed. A value of "2" is
        typically used in the US for OBD DTC confirmation.
    :ivar connected_indicators: Event specific description of
        Indicators.
    :ivar event_clear_allowed: This attribute defines whether the Dem
        has access to a "ClearEventAllowed" callback.
    :ivar event_failure_cycle_counter_threshold: This attribute defines
        the number of failure cycles for the event based fault
        confirmation.
    :ivar event_kind: This attribute is used to distinguish between SWC
        and BSW events.
    :ivar prestorage_freeze_frame: This attribute describes whether the
        Prestorage of FreezeFrames is supported by the assigned event or
        not. True: Prestorage of FreezeFrames is supported False:
        Prestorage of FreezeFrames is not supported
    :ivar prestored_freezeframe_stored_in_nvm: If the Event uses a
        prestored freeze-frame (using the operations PrestoreFreezeFrame
        and ClearPrestoredFreezeFrame of the service interface
        DiagnosticMonitor) this attribute indicates if the Event
        requires the data to be stored in non-volatile memory. TRUE =
        Dem shall store the prestored data in non-volatile memory, FALSE
        = Data can be lost at shutdown (not stored in Nvm)
    :ivar recoverable_in_same_operation_cycle: If the attribute is set
        to true then reporting PASSED will reset the indication of a
        failed test in the current operation cycle. If the attribute is
        set to false then reporting PASSED will be ignored and not lead
        to a reset of the indication of a failed test.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    aging_allowed: Boolean | None = field(
        default=None,
        metadata={
            "name": "AGING-ALLOWED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    associated_event_identification: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ASSOCIATED-EVENT-IDENTIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clear_event_allowed_behavior: DiagnosticClearEventAllowedBehaviorEnum | None = field(
        default=None,
        metadata={
            "name": "CLEAR-EVENT-ALLOWED-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clear_event_behavior: DiagnosticClearEventBehaviorEnum | None = field(
        default=None,
        metadata={
            "name": "CLEAR-EVENT-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    confirmation_threshold: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "CONFIRMATION-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    connected_indicators: Optional["DiagnosticEvent.ConnectedIndicators"] = field(
        default=None,
        metadata={
            "name": "CONNECTED-INDICATORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_clear_allowed: DiagnosticEventClearAllowedEnum | None = field(
        default=None,
        metadata={
            "name": "EVENT-CLEAR-ALLOWED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_failure_cycle_counter_threshold: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "EVENT-FAILURE-CYCLE-COUNTER-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_kind: DiagnosticEventKindEnum | None = field(
        default=None,
        metadata={
            "name": "EVENT-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prestorage_freeze_frame: Boolean | None = field(
        default=None,
        metadata={
            "name": "PRESTORAGE-FREEZE-FRAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prestored_freezeframe_stored_in_nvm: Boolean | None = field(
        default=None,
        metadata={
            "name": "PRESTORED-FREEZEFRAME-STORED-IN-NVM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    recoverable_in_same_operation_cycle: Boolean | None = field(
        default=None,
        metadata={
            "name": "RECOVERABLE-IN-SAME-OPERATION-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConnectedIndicators:
        diagnostic_connected_indicator: list[DiagnosticConnectedIndicator] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CONNECTED-INDICATOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEventNeeds:
    """Specifies the abstract needs on the configuration of the Diagnostic Event
    Manager for one diagnostic event.

    Its shortName can be regarded as a symbol identifying the diagnostic
    event from the viewpoint of the component or module which owns this
    element. In case the diagnostic event specifies a production error,
    the shortName shall be the name of the production error.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar audiences: This specifies the intended audience for the
        diagnostic object. Note that this is not only for the
        documentation but also subsequent audience specific
        implementation.
    :ivar diag_requirement: This denotes the requirement identifier to
        which the object can be linked to. Note that with the
        implementation of a generic tracing concept in AUTOSAR this
        attribute might become obsolete.
    :ivar security_access_level: This attribute denotes the level of
        security which is touched by the diagnostic object. The higher
        the level the more relevance for the security exists. This level
        shall be mapped to the security level in the ECU.
    :ivar consider_pto_status: PTO (Power Take Off) has an impact on the
        respective emission-related event (OBD). This information shall
        be provided by SW-C description in order to consider the PTO
        relevance e.g. for readiness (PID $01) computation. For events
        with dtcKind set to 'nonEmmissionRelatedDtc' this attribute is
        typically false.
    :ivar deferring_fid_refs: This reference contains the link to a
        function identifier within the FiM which is used by the monitor
        before delivering a result.
    :ivar diag_event_debounce_algorithm: Specifies the abstract need on
        the Debounce Algorithm applied by the Diagnostic Event Manager.
    :ivar dtc_kind: This attribute indicates the kind of the diagnostic
        monitor according to the SWS Diagnostic Event Manger. This
        attribute applies for the UDS diagnostics use case.
    :ivar dtc_number: This represents a reasonable Diagnostic Trouble
        Code. This allows to predefine the Diagnostic Trouble Code if
        the a function developer has received a particular requirement
        from the OEM or from a standardization body.
    :ivar inhibiting_fid_ref: This represents the primary Function
        Inhibition Identifier used for inhibition of the diagnostic
        monitor. The FID might either inhibit the monitoring of a
        symptom or the reporting of detected faults.
    :ivar inhibiting_secondary_fid_refs: This represents the secondary
        Function Inhibition Identifier used for inhibition of the
        diagnostic monitor. Any of the FID inhibitions leads to an
        inhibition of the monitoring of a symptom or the reporting of
        detected faults.
    :ivar obd_dtc_number: This represents a reasonable Diagnostic
        Trouble Code. This allows to predefine the Diagnostic Trouble
        Code, e.g. if the a function developer has received a particular
        requirement from the OEM or from a standardization body. This
        attribute applies for the OBD diagnostics use case.
    :ivar prestored_freezeframe_stored_in_nvm: If the Event uses a
        prestored freeze-frame (using the operations PrestoreFreezeFrame
        and ClearPrestoredFreezeFrame of the service interface
        DiagnosticMonitor) this attribute indicates if the Event
        requires the data to be stored in non-volatile memory. TRUE =
        Dem shall store the prestored data in non-volatile memory, FALSE
        = Data can be lost at shutdown (not stored in Nvm).
    :ivar report_behavior: This switch indicates whether or not the BSW
        module is allowed to report the related Events before
        Dem_Init().
    :ivar uds_dtc_number: This represents a reasonable Diagnostic
        Trouble Code. This allows to predefine the Diagnostic Trouble
        Code, e.g. if the a function developer has received a particular
        requirement from the OEM or from a standardization body. This
        attribute applies for the UDS diagnostics use case.
    :ivar uses_monitor_data: This attribute defines whether additional
        monitor data shall be added to the reporting of events.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EVENT-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEventNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEventNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    audiences: Optional["DiagnosticEventNeeds.Audiences"] = field(
        default=None,
        metadata={
            "name": "AUDIENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_requirement: DiagRequirementIdString | None = field(
        default=None,
        metadata={
            "name": "DIAG-REQUIREMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_access_level: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SECURITY-ACCESS-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consider_pto_status: Boolean | None = field(
        default=None,
        metadata={
            "name": "CONSIDER-PTO-STATUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    deferring_fid_refs: Optional["DiagnosticEventNeeds.DeferringFidRefs"] = field(
        default=None,
        metadata={
            "name": "DEFERRING-FID-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_event_debounce_algorithm: Optional["DiagnosticEventNeeds.DiagEventDebounceAlgorithm"] = (
        field(
            default=None,
            metadata={
                "name": "DIAG-EVENT-DEBOUNCE-ALGORITHM",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    dtc_kind: DtcKindEnum | None = field(
        default=None,
        metadata={
            "name": "DTC-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DTC-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    inhibiting_fid_ref: Optional["DiagnosticEventNeeds.InhibitingFidRef"] = field(
        default=None,
        metadata={
            "name": "INHIBITING-FID-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    inhibiting_secondary_fid_refs: Optional["DiagnosticEventNeeds.InhibitingSecondaryFidRefs"] = (
        field(
            default=None,
            metadata={
                "name": "INHIBITING-SECONDARY-FID-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    obd_dtc_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "OBD-DTC-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prestored_freezeframe_stored_in_nvm: Boolean | None = field(
        default=None,
        metadata={
            "name": "PRESTORED-FREEZEFRAME-STORED-IN-NVM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    report_behavior: ReportBehaviorEnum | None = field(
        default=None,
        metadata={
            "name": "REPORT-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uds_dtc_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "UDS-DTC-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uses_monitor_data: Boolean | None = field(
        default=None,
        metadata={
            "name": "USES-MONITOR-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Audiences:
        audience: list[DiagnosticAudienceEnum] = field(
            default_factory=list,
            metadata={
                "name": "AUDIENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DeferringFidRefs:
        deferring_fid_ref: list["DiagnosticEventNeeds.DeferringFidRefs.DeferringFidRef"] = field(
            default_factory=list,
            metadata={
                "name": "DEFERRING-FID-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DeferringFidRef(Ref):
            dest: FunctionInhibitionNeedsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DiagEventDebounceAlgorithm:
        diag_event_debounce_counter_based: DiagEventDebounceCounterBased | None = field(
            default=None,
            metadata={
                "name": "DIAG-EVENT-DEBOUNCE-COUNTER-BASED",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diag_event_debounce_monitor_internal: DiagEventDebounceMonitorInternal | None = field(
            default=None,
            metadata={
                "name": "DIAG-EVENT-DEBOUNCE-MONITOR-INTERNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diag_event_debounce_time_based: DiagEventDebounceTimeBased | None = field(
            default=None,
            metadata={
                "name": "DIAG-EVENT-DEBOUNCE-TIME-BASED",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InhibitingFidRef(Ref):
        dest: FunctionInhibitionNeedsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class InhibitingSecondaryFidRefs:
        inhibiting_secondary_fid_ref: list[
            "DiagnosticEventNeeds.InhibitingSecondaryFidRefs.InhibitingSecondaryFidRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "INHIBITING-SECONDARY-FID-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class InhibitingSecondaryFidRef(Ref):
            dest: FunctionInhibitionNeedsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DiagnosticFunctionIdentifierInhibit:
    """
    This meta-class represents the ability to define the inhibition of a specific
    function identifier within the Fim configuration.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar function_identifier_ref: This represents the corresponding
        function identifier.
    :ivar inhibit_sources: This represents a collection of
        DiagnosticFunctionInhibitSource that contribute to the
        configuration of the enclosing
        DiagnosticFunctionIdentiferInhibit.
    :ivar inhibition_mask: This represents the value of the inhibition
        mask behavior.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-FUNCTION-IDENTIFIER-INHIBIT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticFunctionIdentifierInhibit.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticFunctionIdentifierInhibit.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    function_identifier_ref: Optional[
        "DiagnosticFunctionIdentifierInhibit.FunctionIdentifierRef"
    ] = field(
        default=None,
        metadata={
            "name": "FUNCTION-IDENTIFIER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    inhibit_sources: Optional["DiagnosticFunctionIdentifierInhibit.InhibitSources"] = field(
        default=None,
        metadata={
            "name": "INHIBIT-SOURCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    inhibition_mask: DiagnosticInhibitionMaskEnum | None = field(
        default=None,
        metadata={
            "name": "INHIBITION-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FunctionIdentifierRef(Ref):
        dest: DiagnosticFunctionIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class InhibitSources:
        diagnostic_function_inhibit_source: list[DiagnosticFunctionInhibitSource] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-FUNCTION-INHIBIT-SOURCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticIumprGroup:
    """
    This meta-class represents the ability to model a IUMPR groups.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar group_identifier: This attribute shall be taken to define an
        identifier for the IUMPR group. Please note that the value of
        this identifier is driven by regulations outside the scope of
        AUTOSAR and can therefore not be limited to the set of
        characters suitable for a shortName.
    :ivar iumpr_group_identifiers: This aggregation allows for the
        variant modeling of the groupIdentifier. The upper multiplicity
        of this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar iumpr_refs: This reference collects DiagnosticIumpr to a
        DiagnosticIumprGroup.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-IUMPR-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticIumprGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticIumprGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    group_identifier: NameTokenValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "GROUP-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    iumpr_group_identifiers: Optional["DiagnosticIumprGroup.IumprGroupIdentifiers"] = field(
        default=None,
        metadata={
            "name": "IUMPR-GROUP-IDENTIFIERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    iumpr_refs: Optional["DiagnosticIumprGroup.IumprRefs"] = field(
        default=None,
        metadata={
            "name": "IUMPR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IumprGroupIdentifiers:
        diagnostic_iumpr_group_identifier: list[DiagnosticIumprGroupIdentifier] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-IUMPR-GROUP-IDENTIFIER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IumprRefs:
        iumpr_ref: list["DiagnosticIumprGroup.IumprRefs.IumprRef"] = field(
            default_factory=list,
            metadata={
                "name": "IUMPR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class IumprRef(Ref):
            dest: DiagnosticIumprSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DiagnosticMasterToSlaveEventMappingSet:
    """
    This meta-class provides the ability to gather a collection of
    DiagnosticMasterToSlaveEventMappings.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar master_to_slave_event_mappings: This represents the collection
        of DiagnosticMasterToSlaveEventMapping aggregated at the
        enclosing DiagnosticMasterToSlaveEventMappingSet This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-MASTER-TO-SLAVE-EVENT-MAPPING-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticMasterToSlaveEventMappingSet.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticMasterToSlaveEventMappingSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    master_to_slave_event_mappings: Optional[
        "DiagnosticMasterToSlaveEventMappingSet.MasterToSlaveEventMappings"
    ] = field(
        default=None,
        metadata={
            "name": "MASTER-TO-SLAVE-EVENT-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MasterToSlaveEventMappings:
        diagnostic_master_to_slave_event_mapping: list[DiagnosticMasterToSlaveEventMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-MASTER-TO-SLAVE-EVENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticParameterElement:
    """
    This meta-class represents an element of a DiagnosticParameter if the
    DiagnosticParameter represents a structure.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar bit_offset: This represents the bitOffset of the
        DiagnosticParameter. The value of the bitOffset shall always be
        interpreted as relative to the start of the enclosing
        DiagnosticDataIdentifier, DiagnosticParameterIdentifier, or
        DiagnosticRoutineSubfunction.
    :ivar data_elements: This represents the related dataElement of the
        DiagnosticParameter The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar parameter_size: This attribute allows for the specification of
        the parameter size. This information is relevant if there is a
        gap between one diagnostic parameter and the following
        diagnostic parameter (or the tail of the telegram). The unit is
        bit and the values shall be multiples of 8.
    :ivar array_size: This attribute indicates that the enclosing
        DiagnosticParameterElement represents an array and configures
        the array size in terms of the number of elements of the array.
    :ivar sub_elements: This collection represents the sub-elements on
        the next lower level.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-PARAMETER-ELEMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticParameterElement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticParameterElement.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bit_offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BIT-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_elements: Optional["DiagnosticParameterElement.DataElements"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PARAMETER-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    array_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ARRAY-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_elements: Optional["DiagnosticParameterElement.SubElements"] = field(
        default=None,
        metadata={
            "name": "SUB-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataElements:
        diagnostic_data_element: list[DiagnosticDataElement] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DATA-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubElements:
        diagnostic_parameter_element: list["DiagnosticParameterElement"] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PARAMETER-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticProtocol:
    """
    This meta-class represents the ability to define a diagnostic protocol.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar diagnostic_connections: This represents the collection of
        applicable DiagnosticConnections for this DiagnosticProtocol.
        This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar priority: This represents the priority of the diagnostic
        protocol in comparison to other diagnostic protocols. Lower
        numeric values represent higher protocol priority: * 0 - Highest
        protocol priority * 255 - Lowest protocol priority
    :ivar protocol_kind: This identifies the applicable protocol.
    :ivar send_resp_pend_on_trans_to_boot: The purpose of this attribute
        is to define whether or not the ECU should send a NRC 0x78
        (response pending) before transitioning to the bootloader (in
        this case the attribute shall be set to "true") or if the
        transition shall be initiated without sending NRC 0x78 (in this
        case the attribute shall be set to "false").
    :ivar service_tables: This represents the service table applicable
        for the given diagnostic protocol. This property was modified
        due to atpVariation (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-PROTOCOL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticProtocol.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticProtocol.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_connections: Optional["DiagnosticProtocol.DiagnosticConnections"] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_kind: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    send_resp_pend_on_trans_to_boot: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "SEND-RESP-PEND-ON-TRANS-TO-BOOT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_tables: Optional["DiagnosticProtocol.ServiceTables"] = field(
        default=None,
        metadata={
            "name": "SERVICE-TABLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticConnections:
        diagnostic_connection_ref_conditional: list[DiagnosticConnectionRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CONNECTION-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceTables:
        diagnostic_service_table_ref_conditional: list[DiagnosticServiceTableRefConditional] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-SERVICE-TABLE-REF-CONDITIONAL",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticServiceTable:
    """
    This meta-class represents a model of a diagnostic service table, i.e. the UDS
    services applicable for a given ECU.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar diagnostic_connections: This represents the
        DiagnosticConnection that is taken for handling the data
        transmission for the enclosing DiagnosticServiceTable. It is
        possible to refer to more than one diagnosticConnections in
        order to support more than one diagnostic tester. This property
        was modified due to atpVariation (DirectedAssociationPattern).
    :ivar ecu_instance_ref: This represents the applicable EcuInstance
        for this DiagnosticServiceTable.
    :ivar protocol_kind: This identifies the applicable protocol.
    :ivar service_instance_refs: This represents the collection of
        DiagnosticServiceInstances to be considered in the scope of this
        DiagnosticServiceTable,
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-SERVICE-TABLE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticServiceTable.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticServiceTable.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_connections: Optional["DiagnosticServiceTable.DiagnosticConnections"] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["DiagnosticServiceTable.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_kind: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_refs: Optional["DiagnosticServiceTable.ServiceInstanceRefs"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticConnections:
        diagnostic_connection_ref_conditional: list[DiagnosticConnectionRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CONNECTION-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRefs:
        service_instance_ref: list[
            "DiagnosticServiceTable.ServiceInstanceRefs.ServiceInstanceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceInstanceRef(Ref):
            dest: DiagnosticServiceInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DiagnosticStorageConditionGroup:
    """
    Storage condition group which includes one or several storage conditions.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar storage_conditions: Reference to storageConditions that are
        part of the StorageConditionGroup. This property was modified
        due to atpVariation (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-STORAGE-CONDITION-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticStorageConditionGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticStorageConditionGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    storage_conditions: Optional["DiagnosticStorageConditionGroup.StorageConditions"] = field(
        default=None,
        metadata={
            "name": "STORAGE-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StorageConditions:
        diagnostic_storage_condition_ref_conditional: list[
            DiagnosticStorageConditionRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-STORAGE-CONDITION-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticTestResult:
    """
    This meta-class represents the ability to define diagnostic test results.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar diagnostic_events: This attribute represents the diagnostic
        event that is related to the diagnostic test result. This
        property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar event_ref: This attribute represents the diagnostic event that
        is related to the diagnostic test result.
    :ivar monitored_identifier_ref: This attribute represents the
        related diagnostic monitored identifier.
    :ivar test_identifier: This attribute represents the applicable test
        identifier.
    :ivar update_kind: This attribute controls the update behavior of
        the enclosing DiagnosticTestResult.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TEST-RESULT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticTestResult.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticTestResult.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_events: Optional["DiagnosticTestResult.DiagnosticEvents"] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-EVENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["DiagnosticTestResult.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    monitored_identifier_ref: Optional["DiagnosticTestResult.MonitoredIdentifierRef"] = field(
        default=None,
        metadata={
            "name": "MONITORED-IDENTIFIER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    test_identifier: DiagnosticTestIdentifier | None = field(
        default=None,
        metadata={
            "name": "TEST-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update_kind: DiagnosticTestResultUpdateEnumValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPDATE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticEvents:
        diagnostic_event_ref_conditional: list[DiagnosticEventRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EVENT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: DiagnosticEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MonitoredIdentifierRef(Ref):
        dest: DiagnosticMeasurementIdentifierSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticTroubleCodeGroup:
    """
    The diagnostic trouble code group defines the DTCs belonging together and
    thereby forming a group.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar dtcs: This represents the collection of DiagnosticTroubleCodes
        defined by this DiagnosticTroubleCodeGroup. This property was
        modified due to atpVariation (DirectedAssociationPattern).
    :ivar group_number: This represents the base number of the DTC
        group.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TROUBLE-CODE-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticTroubleCodeGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticTroubleCodeGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtcs: Optional["DiagnosticTroubleCodeGroup.Dtcs"] = field(
        default=None,
        metadata={
            "name": "DTCS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    group_number: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "GROUP-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Dtcs:
        diagnostic_trouble_code_ref_conditional: list[DiagnosticTroubleCodeRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-TROUBLE-CODE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticTroubleCodeObd:
    """
    This element is used to define OBD-relevant DTCs.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar consider_pto_status: This attribute describes the affection of
        the event by the Dem PTO handling. True: the event is affected
        by the Dem PTO handling. False: the event is not affected by the
        Dem PTO handling.
    :ivar dtc_props_ref: Defined properties associated with the DemDTC.
    :ivar event_obd_readiness_group: This attribute specifies the Event
        OBD Readiness group for PID $01 and PID $41 computation. This
        attribute is only applicable for emission-related ECUs.
    :ivar event_readiness_groups: This aggregation allows for the
        variant definition of the attribute eventObdReadinessGroup. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar obd_dtc_value: Unique Diagnostic Trouble Code value for OBD.
    :ivar obd_dtc_value_3_byte: 3 Byte OBD DTC value based on the
        definition from SAE J2012. The existence of this attribute is
        only required if separated UDS and OBD DTC values are used for
        SAE J1979-2. If this attribute does not exist, then UDS DTC
        values are used with J1979-2.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TROUBLE-CODE-OBD"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticTroubleCodeObd.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticTroubleCodeObd.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consider_pto_status: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "CONSIDER-PTO-STATUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_props_ref: Optional["DiagnosticTroubleCodeObd.DtcPropsRef"] = field(
        default=None,
        metadata={
            "name": "DTC-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_obd_readiness_group: NameTokenValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "EVENT-OBD-READINESS-GROUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_readiness_groups: Optional["DiagnosticTroubleCodeObd.EventReadinessGroups"] = field(
        default=None,
        metadata={
            "name": "EVENT-READINESS-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    obd_dtc_value: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "OBD-DTC-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    obd_dtc_value_3_byte: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "OBD-DTC-VALUE-3-BYTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DtcPropsRef(Ref):
        dest: DiagnosticTroubleCodePropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventReadinessGroups:
        event_obd_readiness_group: list[EventObdReadinessGroup] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-OBD-READINESS-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticTroubleCodeProps:
    """
    This element defines common Dtc properties that can be reused by different non
    OBD-relevant DTCs.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar aging_allowed: This represents the decision whether aging is
        allowed for this DiagnosticTroubleCodeProps.
    :ivar aging_ref: Reference to an aging algorithm in case that an
        aging/unlearning of the event is allowed.
    :ivar diagnostic_memory_ref: Reference to the applicable
        DiagnosticMemoryDestination.
    :ivar environment_capture_to_reporting: This attribute determines
        the point in time, when the data actually is captured.
    :ivar extended_data_records: Defines the links to an extended data
        class sampler. This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar fdc_threshold_storage_value: Threshold to allocate an event
        memory entry and to capture the Freeze Frame. Unit: none
        (attribute represents a counter value).
    :ivar freeze_frames: Define the links to a freeze frame class
        sampler. This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar freeze_frame_content_ref: This represents the freeze frame
        layout as a set of DIDs.
    :ivar freeze_frame_content_wwh_obd_ref: This reefrence identifies
        the layout of the WWH-OBD freeze frame.
    :ivar immediate_nv_data_storage: Switch to enable immediate storage
        triggering of an according event memory entry persistently to
        NVRAM. true: immediate non-volatile storage triggering enabled
        false: immediate non-volatile storage triggering disabled
    :ivar legislated_freeze_frame_content_uds_obds: This reference
        identifies the layout of legislated freeze frames used for
        emission related diagnostics over the UDS protocol such as
        OBDonUDS or WWH-OBD. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar legislated_freeze_frame_content_wwh_obds: This reference
        identifies the layout of the WWH-OBD freeze frame. This property
        was modified due to atpVariation (DirectedAssociationPattern).
    :ivar max_number_freeze_frame_records: This attribute defines the
        number of according freeze frame records, which can maximal be
        stored for this event. Therefore all these freeze frame records
        have the same freeze frame class.
    :ivar memory_destination_refs: The event destination assigns events
        to none, one or multiple origins.
    :ivar priority: Priority of the event, in view of full event buffer.
        A lower value means higher priority.
    :ivar significance: Significance of the event, which indicates
        additional information concerning fault classification and
        resolution.
    :ivar snapshot_record_contents: This represents the freeze frame
        layout as a set of DIDs. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-TROUBLE-CODE-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticTroubleCodeProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticTroubleCodeProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    aging_allowed: Boolean | None = field(
        default=None,
        metadata={
            "name": "AGING-ALLOWED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    aging_ref: Optional["DiagnosticTroubleCodeProps.AgingRef"] = field(
        default=None,
        metadata={
            "name": "AGING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_memory_ref: Optional["DiagnosticTroubleCodeProps.DiagnosticMemoryRef"] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-MEMORY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    environment_capture_to_reporting: EnvironmentCaptureToReportingEnum | None = field(
        default=None,
        metadata={
            "name": "ENVIRONMENT-CAPTURE-TO-REPORTING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    extended_data_records: Optional["DiagnosticTroubleCodeProps.ExtendedDataRecords"] = field(
        default=None,
        metadata={
            "name": "EXTENDED-DATA-RECORDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fdc_threshold_storage_value: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FDC-THRESHOLD-STORAGE-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freeze_frames: Optional["DiagnosticTroubleCodeProps.FreezeFrames"] = field(
        default=None,
        metadata={
            "name": "FREEZE-FRAMES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freeze_frame_content_ref: Optional["DiagnosticTroubleCodeProps.FreezeFrameContentRef"] = field(
        default=None,
        metadata={
            "name": "FREEZE-FRAME-CONTENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freeze_frame_content_wwh_obd_ref: Optional[
        "DiagnosticTroubleCodeProps.FreezeFrameContentWwhObdRef"
    ] = field(
        default=None,
        metadata={
            "name": "FREEZE-FRAME-CONTENT-WWH-OBD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    immediate_nv_data_storage: Boolean | None = field(
        default=None,
        metadata={
            "name": "IMMEDIATE-NV-DATA-STORAGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    legislated_freeze_frame_content_uds_obds: Optional[
        "DiagnosticTroubleCodeProps.LegislatedFreezeFrameContentUdsObds"
    ] = field(
        default=None,
        metadata={
            "name": "LEGISLATED-FREEZE-FRAME-CONTENT-UDS-OBDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    legislated_freeze_frame_content_wwh_obds: Optional[
        "DiagnosticTroubleCodeProps.LegislatedFreezeFrameContentWwhObds"
    ] = field(
        default=None,
        metadata={
            "name": "LEGISLATED-FREEZE-FRAME-CONTENT-WWH-OBDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_freeze_frame_records: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-FREEZE-FRAME-RECORDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_destination_refs: Optional["DiagnosticTroubleCodeProps.MemoryDestinationRefs"] = field(
        default=None,
        metadata={
            "name": "MEMORY-DESTINATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    significance: DiagnosticSignificanceEnum | None = field(
        default=None,
        metadata={
            "name": "SIGNIFICANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    snapshot_record_contents: Optional["DiagnosticTroubleCodeProps.SnapshotRecordContents"] = field(
        default=None,
        metadata={
            "name": "SNAPSHOT-RECORD-CONTENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AgingRef(Ref):
        dest: DiagnosticAgingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticMemoryRef(Ref):
        dest: DiagnosticMemoryDestinationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ExtendedDataRecords:
        diagnostic_extended_data_record_ref_conditional: list[
            DiagnosticExtendedDataRecordRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EXTENDED-DATA-RECORD-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FreezeFrames:
        diagnostic_freeze_frame_ref_conditional: list[DiagnosticFreezeFrameRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-FREEZE-FRAME-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FreezeFrameContentRef(Ref):
        dest: DiagnosticDataIdentifierSetSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FreezeFrameContentWwhObdRef(Ref):
        dest: DiagnosticDataIdentifierSetSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class LegislatedFreezeFrameContentUdsObds:
        diagnostic_data_identifier_set_ref_conditional: list[
            DiagnosticDataIdentifierSetRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DATA-IDENTIFIER-SET-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LegislatedFreezeFrameContentWwhObds:
        diagnostic_data_identifier_set_ref_conditional: list[
            DiagnosticDataIdentifierSetRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DATA-IDENTIFIER-SET-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MemoryDestinationRefs:
        memory_destination_ref: list[
            "DiagnosticTroubleCodeProps.MemoryDestinationRefs.MemoryDestinationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MEMORY-DESTINATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class MemoryDestinationRef(Ref):
            dest: DiagnosticMemoryDestinationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SnapshotRecordContents:
        diagnostic_data_identifier_set_ref_conditional: list[
            DiagnosticDataIdentifierSetRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DATA-IDENTIFIER-SET-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DltApplication:
    """
    This meta-class represents the application from which the log and trace message
    originates.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar application_description: This attribute can be used to
        describe the applicationId that is used in the log and trace
        message in more detail.
    :ivar application_id: This attribute identifies the SW-C/BSW module
        in the log and trace message.
    :ivar contexts: Definition of ContextIds for the Application. This
        property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: DltEcu.application
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-APPLICATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DltApplication.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DltApplication.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_description: String | None = field(
        default=None,
        metadata={
            "name": "APPLICATION-DESCRIPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_id: String | None = field(
        default=None,
        metadata={
            "name": "APPLICATION-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contexts: Optional["DltApplication.Contexts"] = field(
        default=None,
        metadata={
            "name": "CONTEXTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Contexts:
        dlt_context_ref_conditional: list[DltContextRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "DLT-CONTEXT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DltConfig:
    """
    This element defines a Dlt configuration for a specific Ecu.

    :ivar dlt_ecu_id: This attribute defines the name of the ECU for use
        within the Dlt protocol.
    :ivar dlt_ecu_ref: Reference to the Ecu representation in the Log
        And Trace Extract.
    :ivar dlt_log_channels: Describes the DltLogChannels that are
        configured for the log/trace message output
    :ivar session_id_support: This attribute defines whether the
        sessionId is used or not.
    :ivar timestamp_support: This attribute defines whether a timestamp
        shall be added to the Dlt messages or not.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-CONFIG"

    dlt_ecu_id: String | None = field(
        default=None,
        metadata={
            "name": "DLT-ECU-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_ecu_ref: Optional["DltConfig.DltEcuRef"] = field(
        default=None,
        metadata={
            "name": "DLT-ECU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_log_channels: Optional["DltConfig.DltLogChannels"] = field(
        default=None,
        metadata={
            "name": "DLT-LOG-CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    session_id_support: Boolean | None = field(
        default=None,
        metadata={
            "name": "SESSION-ID-SUPPORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timestamp_support: Boolean | None = field(
        default=None,
        metadata={
            "name": "TIMESTAMP-SUPPORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DltEcuRef(Ref):
        dest: DltEcuSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DltLogChannels:
        dlt_log_channel: list[DltLogChannel] = field(
            default_factory=list,
            metadata={
                "name": "DLT-LOG-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DltContext:
    """
    This meta-class represents the Context that groups Log and Trace Messages that
    are generated by an application.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar context_description: This attribute can be used to describe
        the contextId that is used in the log and trace message in more
        detail.
    :ivar context_id: This attribute is used to group log and trace
        messages produced by an application to distinguish
        functionality.
    :ivar dlt_messages: Group of Log and Trace Messages assigned to the
        DltContext This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-CONTEXT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DltContext.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DltContext.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_description: String | None = field(
        default=None,
        metadata={
            "name": "CONTEXT-DESCRIPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_id: String | None = field(
        default=None,
        metadata={
            "name": "CONTEXT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_messages: Optional["DltContext.DltMessages"] = field(
        default=None,
        metadata={
            "name": "DLT-MESSAGES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DltMessages:
        dlt_message_ref_conditional: list[DltMessageRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "DLT-MESSAGE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DltMessage:
    """
    This element defines a DltMessage.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar dlt_arguments: Ordered collection of DltArguments in the
        DltMessage.
    :ivar message_id: This attribute defines the unique Id for the
        DltMessage.
    :ivar message_line_number: This attribute describes the position in
        the source file in which this log message was called.
    :ivar message_source_file: This attribute describes the source file
        in which this log message was called.
    :ivar message_type_info: This attribute describes the message Type
    :ivar privacy_level: The Privacy Level helps to identify the Log and
        Trace content towards the degree of privacy to it.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        LogAndTraceMessageCollectionSet.dltMessage Not Applicable for:
        DltMessageCollectionSet.dltMessage
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-MESSAGE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DltMessage.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DltMessage.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_arguments: Optional["DltMessage.DltArguments"] = field(
        default=None,
        metadata={
            "name": "DLT-ARGUMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    message_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MESSAGE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    message_line_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MESSAGE-LINE-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    message_source_file: String | None = field(
        default=None,
        metadata={
            "name": "MESSAGE-SOURCE-FILE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    message_type_info: String | None = field(
        default=None,
        metadata={
            "name": "MESSAGE-TYPE-INFO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    privacy_level: PrivacyLevel | None = field(
        default=None,
        metadata={
            "name": "PRIVACY-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DltArguments:
        dlt_argument: list[DltArgument] = field(
            default_factory=list,
            metadata={
                "name": "DLT-ARGUMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DoIpInterface:
    """
    A logical interface over which the DoIP Node is able to communicate via DoIP
    independently from other existing DoIpInterfaces.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alive_check_response_timeout: This attribute defines the
        timeout  in seconds for waiting for response to an Alive Check
        request before the connection is considered to be disconnected.
        Represents parameter T_TCP_AliveCheck of ISO 13400-2:2012.
    :ivar do_ip_routing_activations: Collection of DoIpRoutingActivation
        possibilities defined in the DoIpInterface.
    :ivar doip_channel_collection_ref: Configuration of DoIPChannels
        available in an DoIpInterface. Each DoIPChannel describes a
        connection between a doIpSourceAddress and a doIpTargetAddress
        and the exchange of DcmIPdus between the PduR and DoIP. A DoIP
        channel is constituted by the set of all DoIpTpConnection
        elements via which the configured EcuInstance sends or receives
        SDUs that are sharing the same local diagnosis address and
        tester address.
    :ivar doip_connection_refs: DoIP Connections in the DoIpInterface
        that define the DoIP Pdus that are sent and received via SoAd
        over TCP or UDP.
    :ivar general_inactivity_time: This attribute defines the timeout in
        seconds for maximum inactivity of a TCP socket connection before
        the DoIP module will close the according socket connection.
        Represents parameter T_TCP_General_Inactivity of ISO
        13400-2:2012
    :ivar initial_inactivity_time: This attribute defines the timeout in
        seconds used for initial inactivity of a connected TCP socket
        connection directly after socket connection. Represents
        parameter T_TCP_Initial_Inactivity of ISO 13400-2:2012
    :ivar initial_vehicle_announcement_time: This attribute defines the
        waiting time in seconds for sending first vehicle announcement
        message after IP address assignment. Represents parameter
        A_DoIP_Announce_Wait of ISO 13400-2:2012
    :ivar is_activation_line_dependent: This attribute defines whether
        the network interface * is started "on-demand" when an
        activation line is sensed or * is always available.
    :ivar max_tester_connections: Maximum amount of tester connections
        that shall be maintained at one time before alive check is
        performed.
    :ivar socket_connection_refs: DoIP Connections in the DoIpInterface
        that define the DoIP Pdus that are sent and received via SoAd
        over TCP or UDP.
    :ivar use_mac_address_for_identification: This attribute defines
        whether a configured EID at vehicle identification
        response/vehicle announcement is used or the MAC address. TRUE:
        Use MAC Address instead of EID for Vehicle
        identification/announcement. FALSE: Use configured EID for
        vehicle identification/announcement.
    :ivar use_vehicle_identification_sync_status: This attribute defines
        if the optional VIN/GID synchronization status is used
        additionally in the vehicle identification/announcement.
    :ivar vehicle_announcement_count: This attribute defines the number
        of vehicle announcement messages on IP address assignment.
        Represents parameter A_DoIP_Announce_Num of ISO 13400-2:2012.
    :ivar vehicle_announcement_interval: This attribute defines the
        waiting time in seconds for sending subsequent vehicle
        announcement messages. Represents parameter
        A_DoIP_Announce_Interval of ISO 13400-2:2012
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DoIpInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DoIpInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alive_check_response_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "ALIVE-CHECK-RESPONSE-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    do_ip_routing_activations: Optional["DoIpInterface.DoIpRoutingActivations"] = field(
        default=None,
        metadata={
            "name": "DO-IP-ROUTING-ACTIVATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    doip_channel_collection_ref: Optional["DoIpInterface.DoipChannelCollectionRef"] = field(
        default=None,
        metadata={
            "name": "DOIP-CHANNEL-COLLECTION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    doip_connection_refs: Optional["DoIpInterface.DoipConnectionRefs"] = field(
        default=None,
        metadata={
            "name": "DOIP-CONNECTION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    general_inactivity_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "GENERAL-INACTIVITY-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_inactivity_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "INITIAL-INACTIVITY-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_vehicle_announcement_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "INITIAL-VEHICLE-ANNOUNCEMENT-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_activation_line_dependent: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-ACTIVATION-LINE-DEPENDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_tester_connections: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-TESTER-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    socket_connection_refs: Optional["DoIpInterface.SocketConnectionRefs"] = field(
        default=None,
        metadata={
            "name": "SOCKET-CONNECTION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    use_mac_address_for_identification: Boolean | None = field(
        default=None,
        metadata={
            "name": "USE-MAC-ADDRESS-FOR-IDENTIFICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    use_vehicle_identification_sync_status: Boolean | None = field(
        default=None,
        metadata={
            "name": "USE-VEHICLE-IDENTIFICATION-SYNC-STATUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vehicle_announcement_count: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VEHICLE-ANNOUNCEMENT-COUNT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vehicle_announcement_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "VEHICLE-ANNOUNCEMENT-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DoIpRoutingActivations:
        do_ip_routing_activation: list[DoIpRoutingActivation] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-ROUTING-ACTIVATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DoipChannelCollectionRef(Ref):
        dest: DoIpTpConfigSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DoipConnectionRefs:
        doip_connection_ref: list["DoIpInterface.DoipConnectionRefs.DoipConnectionRef"] = field(
            default_factory=list,
            metadata={
                "name": "DOIP-CONNECTION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DoipConnectionRef(Ref):
            dest: SocketConnectionBundleSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SocketConnectionRefs:
        socket_connection_ref: list["DoIpInterface.SocketConnectionRefs.SocketConnectionRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SOCKET-CONNECTION-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class SocketConnectionRef(Ref):
            dest: StaticSocketConnectionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DoIpLogicAddress:
    """
    The logical DoIP address.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar address: The logical DoIP address.
    :ivar do_ip_logic_address_props: Collection of additional
        LogicAddress properties.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-LOGIC-ADDRESS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DoIpLogicAddress.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DoIpLogicAddress.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    address: Integer | None = field(
        default=None,
        metadata={
            "name": "ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    do_ip_logic_address_props: Optional["DoIpLogicAddress.DoIpLogicAddressProps"] = field(
        default=None,
        metadata={
            "name": "DO-IP-LOGIC-ADDRESS-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DoIpLogicAddressProps:
        do_ip_logic_target_address_props: DoIpLogicTargetAddressProps | None = field(
            default=None,
            metadata={
                "name": "DO-IP-LOGIC-TARGET-ADDRESS-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_logic_tester_address_props: DoIpLogicTesterAddressProps | None = field(
            default=None,
            metadata={
                "name": "DO-IP-LOGIC-TESTER-ADDRESS-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DocumentationContext:
    """This class represents the ability to denote a context of a so called
    standalone  documentation.

    Note that this is an &lt;&lt;atpMixed&gt;&gt;. The contents needs to
    be considered as ordered.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar feature_iref: This refers to a particular  feature (instance
        in the M0 model) to which is the context of the documentation.
        This aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar identifiable_ref: This is an identifiable object which is part
        of the context of the documentation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DOCUMENTATION-CONTEXT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DocumentationContext.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    feature_iref: AnyInstanceRef | None = field(
        default=None,
        metadata={
            "name": "FEATURE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    identifiable_ref: Optional["DocumentationContext.IdentifiableRef"] = field(
        default=None,
        metadata={
            "name": "IDENTIFIABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IdentifiableRef(Ref):
        dest: IdentifiableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class E2EProfileConfigurationSet:
    """
    This meta-class represents the ability to aggregate a collection of
    E2EProfileConfigurations.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar e_2_e_profile_configurations: This represents the collection
        of E2EProfileConfigurations aggregated at the
        E2EProfileConfigurationSet.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "E-2-E-PROFILE-CONFIGURATION-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["E2EProfileConfigurationSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["E2EProfileConfigurationSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_profile_configurations: Optional[
        "E2EProfileConfigurationSet.E2EProfileConfigurations"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-PROFILE-CONFIGURATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EProfileConfigurations:
        e_2_e_profile_configuration: list[E2EProfileConfiguration] = field(
            default_factory=list,
            metadata={
                "name": "E-2-E-PROFILE-CONFIGURATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucInstanceReferenceValue:
    """
    InstanceReference representation in the ECU Configuration.

    :ivar index: Used to support the specification of ordering of
        parameter values.
    :ivar definition_ref: Reference to the definition of this
        EcucAbstractReferenceValue subclasses in the ECU Configuration
        Parameter Definition.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar is_auto_value: If withAuto is set to "true" for this parameter
        definition the isAutoValue can be set to "true". If isAutoValue
        is set to "true" the actual value will not be considered during
        ECU Configuration but will be (re-)calculated by the code
        generator and stored in the value attribute afterwards. These
        implicit updated values might require a re-generation of other
        modules which reference these values. If isAutoValue is not
        present the default is "false".
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EcucContainerValue.referenceValue
    :ivar value_iref: InstanceReference representation in the ECU
        Configuration.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-INSTANCE-REFERENCE-VALUE"

    index: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    definition_ref: Optional["EcucInstanceReferenceValue.DefinitionRef"] = field(
        default=None,
        metadata={
            "name": "DEFINITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucInstanceReferenceValue.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_auto_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-AUTO-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_iref: AnyInstanceRef | None = field(
        default=None,
        metadata={
            "name": "VALUE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DefinitionRef(Ref):
        dest: EcucAbstractReferenceDefSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucValidationCondition:
    """
    Validation condition to perform a formula calculation based on EcucQueries.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar ecuc_querys: Query to the ECU Configuration Description.
    :ivar validation_formula: Definition of the formula used to define
        validation condition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-VALIDATION-CONDITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucValidationCondition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucValidationCondition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_querys: Optional["EcucValidationCondition.EcucQuerys"] = field(
        default=None,
        metadata={
            "name": "ECUC-QUERYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    validation_formula: EcucConditionFormula | None = field(
        default=None,
        metadata={
            "name": "VALIDATION-FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcucQuerys:
        ecuc_query: list[EcucQuery] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-QUERY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucValueCollection:
    """
    This represents the anchor point of the ECU configuration description.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar ecu_extract_ref: Represents the extract of the System
        Configuration that is relevant for the ECU configured with that
        ECU Configuration Description.
    :ivar ecuc_values: References to the configuration of individual
        software modules that are present on this ECU. atpVariation:
        [RS_ECUC_00079] This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-VALUE-COLLECTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucValueCollection.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucValueCollection.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_extract_ref: Optional["EcucValueCollection.EcuExtractRef"] = field(
        default=None,
        metadata={
            "name": "ECU-EXTRACT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_values: Optional["EcucValueCollection.EcucValues"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuExtractRef(Ref):
        dest: SystemSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValues:
        ecuc_module_configuration_values_ref_conditional: list[
            EcucModuleConfigurationValuesRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MODULE-CONFIGURATION-VALUES-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EndToEndProtection:
    """
    This meta-class represents the ability to describe a particular end to end
    protection.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar end_to_end_profile: This represents the particular
        EndToEndDescription.
    :ivar end_to_end_protection_i_signal_i_pdus: Defines to which
        ISignalIPdu - ISignalGroup pair this EndToEndProtection shall
        apply. In case several ISignalGroups are used to transport the
        data (e.g. fan-out in the RTE) there may exist several
        EndToEndProtectionISignalIPdu definitions.
    :ivar end_to_end_protection_variable_prototypes: Defines to which
        VariableDataPrototypes in the roles of one sender and one or
        more receivers this EndToEndprotection applies. It shall be
        possible to aggregate several
        EndToEndProtectionVariablePrototype in case additional
        hierarchical decompositions are introduced subsequently. In this
        case one particular PortPrototype is split into multiple
        PortPrototypes and connectors, all representing the same data
        entity. Caveat: The E2E wrapper approach involves technologies
        that are not subjected to the AUTOSAR standard and is superseded
        by the superior E2E transformer approach (which is fully
        standardized by AUTOSAR). Hence, new projects (without legacy
        constraints due to carry-over parts) shall use the fully
        standardized E2E transformer approach.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EndToEndProtectionSet.endToEndProtection
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "END-TO-END-PROTECTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EndToEndProtection.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EndToEndProtection.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    end_to_end_profile: EndToEndDescription | None = field(
        default=None,
        metadata={
            "name": "END-TO-END-PROFILE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    end_to_end_protection_i_signal_i_pdus: Optional[
        "EndToEndProtection.EndToEndProtectionISignalIPdus"
    ] = field(
        default=None,
        metadata={
            "name": "END-TO-END-PROTECTION-I-SIGNAL-I-PDUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    end_to_end_protection_variable_prototypes: Optional[
        "EndToEndProtection.EndToEndProtectionVariablePrototypes"
    ] = field(
        default=None,
        metadata={
            "name": "END-TO-END-PROTECTION-VARIABLE-PROTOTYPES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EndToEndProtectionISignalIPdus:
        end_to_end_protection_i_signal_i_pdu: list[EndToEndProtectionISignalIPdu] = field(
            default_factory=list,
            metadata={
                "name": "END-TO-END-PROTECTION-I-SIGNAL-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EndToEndProtectionVariablePrototypes:
        end_to_end_protection_variable_prototype: list[EndToEndProtectionVariablePrototype] = field(
            default_factory=list,
            metadata={
                "name": "END-TO-END-PROTECTION-VARIABLE-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EndToEndTransformationISignalProps:
    """
    Holds all the ISignal specific attributes for the EndToEndTransformer.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar end_to_end_transformation_i_signal_props_variants: This
        element was generated/modified due to an atpVariation
        stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "END-TO-END-TRANSFORMATION-I-SIGNAL-PROPS"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    end_to_end_transformation_i_signal_props_variants: Optional[
        "EndToEndTransformationISignalProps.EndToEndTransformationISignalPropsVariants"
    ] = field(
        default=None,
        metadata={
            "name": "END-TO-END-TRANSFORMATION-I-SIGNAL-PROPS-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EndToEndTransformationISignalPropsVariants:
        end_to_end_transformation_i_signal_props_conditional: list[
            EndToEndTransformationISignalPropsConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "END-TO-END-TRANSFORMATION-I-SIGNAL-PROPS-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EthernetCommunicationConnector:
    """
    Ethernet specific attributes to the CommunicationConnector.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar comm_controller_ref: Reference to the communication
        controller. The CommunicationConnector and referenced
        CommunicationController shall be aggregated by the same
        ECUInstance. The communicationController can be referenced by
        several CommunicationConnector elements. This is important for
        the FlexRay Bus. FlexRay communicates via two physical channels.
        But only one controller in an ECU is responsible for both
        channels. Thus, two connectors (for channel A and for channel B)
        shall reference to the same controller.
    :ivar create_ecu_wakeup_source: If this parameter is available and
        set to true then a channel wakeup source shall be created for
        the PhysicalChannel referencing this CommunicationConnector.
    :ivar dynamic_pnc_to_channel_mapping_enabled: Defines if this
        EcuInstance shall implement the dynamic PNC-to-channel-mapping
        functionality on this CommunicationConnector and its respective
        PhysicalChannel.
    :ivar ecu_comm_port_instances: An ECUs reception or send ports.
        atpVariation: If signals/PDUs/frames are variable, the
        corresponding ports shall be variable, too.
    :ivar pnc_filter_array_masks: Bit mask for NM-Pdu Payload used to
        configure the NM filter mask for the Network Management.
    :ivar pnc_gateway_type: Defines if this EcuInstance shall implement
        the PncGateway functionality on this CommunicationConnector and
        its respective PhysicalChannel. Several EcuInstances on the same
        PhysicalChannel can have the PncGateway functionality enabled,
        but only one of them shall have the pncGatewayType "active".
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: EcuInstance.connector
        Not Applicable for: MachineDesign.communicationConnector
    :ivar ap_application_endpoints: Collection of Application Addresses
        that are used on the CommunicationConnector.
    :ivar can_xl_props_refs: If the Ethernet frames handled by this
        EthernetCommunicationConnector are tunneled through CAN XL, then
        this reference shall refer the CanXlProps which contains the
        specific configuration parameters of the CAN XL controller of
        the physical CAN XL connection to be used for tunneling.
    :ivar eth_ip_props_ref: EcuInstance specific IP attributes.
    :ivar ip_v_6_path_mtu_enabled: If enabled the IPv6 processes
        incoming ICMPv6 "Packet Too Big" messages and stores a MTU value
        for each destination address.
    :ivar ip_v_6_path_mtu_timeout: If this value is &gt;0 the IpV6 will
        reset the MTU value stored for each destination after n seconds.
    :ivar maximum_transmission_unit: This attribute specifies the
        maximum transmission unit in bytes.
    :ivar neighbor_cache_size: This attribute specifies the size of
        neighbor cache or ARP table in units of entries.
    :ivar network_endpoint_refs: NetworkEndpoints
    :ivar path_mtu_enabled: If enabled the IPv4/IPv6 processes incoming
        ICMP "Packet Too Big" messages and stores a MTU value for each
        destination address.
    :ivar path_mtu_timeout: If this value is &gt;0 the IPv4/IPv6 will
        reset the MTU value stored for each destination after n seconds.
    :ivar pnc_filter_data_mask: Bit mask for Ethernet Payload used to
        configure the NM filter mask for the Network Management.
    :ivar unicast_network_endpoint_refs: Network Endpoint that defines
        the IPAddress of the machine.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-COMMUNICATION-CONNECTOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthernetCommunicationConnector.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthernetCommunicationConnector.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_controller_ref: Optional["EthernetCommunicationConnector.CommControllerRef"] = field(
        default=None,
        metadata={
            "name": "COMM-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    create_ecu_wakeup_source: Boolean | None = field(
        default=None,
        metadata={
            "name": "CREATE-ECU-WAKEUP-SOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_pnc_to_channel_mapping_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "DYNAMIC-PNC-TO-CHANNEL-MAPPING-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_comm_port_instances: Optional["EthernetCommunicationConnector.EcuCommPortInstances"] = (
        field(
            default=None,
            metadata={
                "name": "ECU-COMM-PORT-INSTANCES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    pnc_filter_array_masks: Optional["EthernetCommunicationConnector.PncFilterArrayMasks"] = field(
        default=None,
        metadata={
            "name": "PNC-FILTER-ARRAY-MASKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_gateway_type: PncGatewayTypeEnum | None = field(
        default=None,
        metadata={
            "name": "PNC-GATEWAY-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ap_application_endpoints: Optional["EthernetCommunicationConnector.ApApplicationEndpoints"] = (
        field(
            default=None,
            metadata={
                "name": "AP-APPLICATION-ENDPOINTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    can_xl_props_refs: Optional["EthernetCommunicationConnector.CanXlPropsRefs"] = field(
        default=None,
        metadata={
            "name": "CAN-XL-PROPS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    eth_ip_props_ref: Optional["EthernetCommunicationConnector.EthIpPropsRef"] = field(
        default=None,
        metadata={
            "name": "ETH-IP-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ip_v_6_path_mtu_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "IP-V-6-PATH-MTU-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ip_v_6_path_mtu_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "IP-V-6-PATH-MTU-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_transmission_unit: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-TRANSMISSION-UNIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    neighbor_cache_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NEIGHBOR-CACHE-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_endpoint_refs: Optional["EthernetCommunicationConnector.NetworkEndpointRefs"] = field(
        default=None,
        metadata={
            "name": "NETWORK-ENDPOINT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    path_mtu_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "PATH-MTU-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    path_mtu_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PATH-MTU-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_filter_data_mask: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "PNC-FILTER-DATA-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unicast_network_endpoint_refs: Optional[
        "EthernetCommunicationConnector.UnicastNetworkEndpointRefs"
    ] = field(
        default=None,
        metadata={
            "name": "UNICAST-NETWORK-ENDPOINT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommControllerRef(Ref):
        dest: CommunicationControllerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuCommPortInstances:
        frame_port: list[FramePort] = field(
            default_factory=list,
            metadata={
                "name": "FRAME-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_pdu_port: list[IPduPort] = field(
            default_factory=list,
            metadata={
                "name": "I-PDU-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_signal_port: list[ISignalPort] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PncFilterArrayMasks:
        pnc_filter_array_mask: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "PNC-FILTER-ARRAY-MASK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ApApplicationEndpoints:
        ap_application_endpoint: list[ApApplicationEndpoint] = field(
            default_factory=list,
            metadata={
                "name": "AP-APPLICATION-ENDPOINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CanXlPropsRefs:
        can_xl_props_ref: list["EthernetCommunicationConnector.CanXlPropsRefs.CanXlPropsRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "CAN-XL-PROPS-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class CanXlPropsRef(Ref):
            dest: CanXlPropsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class EthIpPropsRef(Ref):
        dest: EthIpPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NetworkEndpointRefs:
        network_endpoint_ref: list[
            "EthernetCommunicationConnector.NetworkEndpointRefs.NetworkEndpointRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "NETWORK-ENDPOINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class NetworkEndpointRef(Ref):
            dest: NetworkEndpointSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class UnicastNetworkEndpointRefs:
        unicast_network_endpoint_ref: list[
            "EthernetCommunicationConnector.UnicastNetworkEndpointRefs.UnicastNetworkEndpointRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "UNICAST-NETWORK-ENDPOINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class UnicastNetworkEndpointRef(Ref):
            dest: NetworkEndpointSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class EthernetFrame:
    """Ethernet specific attributes to the Frame.

    This element is removed and shall no longer be used. It is replaced
    by AbstractEthernetFrame.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar frame_length: The used length (in bytes) of the referencing
        frame. Should not be confused with a static byte length reserved
        for each frame by some platforms (e.g. FlexRay). The frameLength
        of zero bytes is allowed. Please consider also TPS_SYST_02255.
    :ivar pdu_to_frame_mappings: A frames layout as a sequence of Pdus.
        atpVariation: The content of a frame can be variable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-FRAME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthernetFrame.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthernetFrame.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_length: Integer | None = field(
        default=None,
        metadata={
            "name": "FRAME-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_to_frame_mappings: Optional["EthernetFrame.PduToFrameMappings"] = field(
        default=None,
        metadata={
            "name": "PDU-TO-FRAME-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduToFrameMappings:
        pdu_to_frame_mapping: list[PduToFrameMapping] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TO-FRAME-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EthernetFrameTriggering:
    """
    Ethernet specific Frame element.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar frame_port_refs: References to the FramePort on every ECU of
        the system which sends and/or receives the frame. References for
        both the sender and the receiver side shall be included when the
        system is completely defined.
    :ivar frame_ref: One frame can be triggered several times, e.g. on
        different channels. If a frame has no frame triggering, it won't
        be sent at all. A frame triggering has assigned exactly one
        frame, which it triggers.
    :ivar pdu_triggerings: This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        PhysicalChannel.frameTriggering
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-FRAME-TRIGGERING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthernetFrameTriggering.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthernetFrameTriggering.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_port_refs: Optional["EthernetFrameTriggering.FramePortRefs"] = field(
        default=None,
        metadata={
            "name": "FRAME-PORT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_ref: Optional["EthernetFrameTriggering.FrameRef"] = field(
        default=None,
        metadata={
            "name": "FRAME-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_triggerings: Optional["EthernetFrameTriggering.PduTriggerings"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FramePortRefs:
        frame_port_ref: list["EthernetFrameTriggering.FramePortRefs.FramePortRef"] = field(
            default_factory=list,
            metadata={
                "name": "FRAME-PORT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FramePortRef(Ref):
            dest: FramePortSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class FrameRef(Ref):
        dest: FrameSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PduTriggerings:
        pdu_triggering_ref_conditional: list[PduTriggeringRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EthernetRawDataStreamRemoteClientConfig:
    """
    This meta-class has the ability to act as a wrapper for the configuration of
    the remote server in the context of a raw data stream client mapping.

    :ivar multicast_credentials: This aggregation represents the
        configuration of multicast credentials for communication with a
        remote raw data stream client.
    :ivar unicast_udp_credentials: This aggregation represents the
        configuration of a remote raw data stream client that
        communicates via unicast over UDP.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-RAW-DATA-STREAM-REMOTE-CLIENT-CONFIG"

    multicast_credentials: RawDataStreamEthernetUdpCredentials | None = field(
        default=None,
        metadata={
            "name": "MULTICAST-CREDENTIALS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unicast_udp_credentials: RawDataStreamEthernetUdpCredentials | None = field(
        default=None,
        metadata={
            "name": "UNICAST-UDP-CREDENTIALS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EthernetRawDataStreamRemoteServerConfig:
    """
    This meta-class has the ability to act as a wrapper for the configuration of
    the remote server in the context of a raw data stream client mapping.

    :ivar multicast_credentials: This aggregation represents the
        configuration of multicast credentials for communication with a
        remote raw data stream server.
    :ivar unicast_credentials: This meta-class represents the ability to
        map a server PortPrototype to a Ethernet-based communication
        channel.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-RAW-DATA-STREAM-REMOTE-SERVER-CONFIG"

    multicast_credentials: RawDataStreamEthernetUdpCredentials | None = field(
        default=None,
        metadata={
            "name": "MULTICAST-CREDENTIALS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unicast_credentials: RawDataStreamEthernetTcpUdpCredentials | None = field(
        default=None,
        metadata={
            "name": "UNICAST-CREDENTIALS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class EthernetWakeupSleepOnDatalineConfigSet:
    """
    This meta-class is the main element that aggregates different config set
    regarding the ethernet wakeup and sleep on data line.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar ethernet_wakeup_sleep_on_dataline_configs: The relationship
        defines a collection of EthernetWakeupSleepOnDatalineConfig
        configurations which are available.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-WAKEUP-SLEEP-ON-DATALINE-CONFIG-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthernetWakeupSleepOnDatalineConfigSet.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthernetWakeupSleepOnDatalineConfigSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ethernet_wakeup_sleep_on_dataline_configs: Optional[
        "EthernetWakeupSleepOnDatalineConfigSet.EthernetWakeupSleepOnDatalineConfigs"
    ] = field(
        default=None,
        metadata={
            "name": "ETHERNET-WAKEUP-SLEEP-ON-DATALINE-CONFIGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EthernetWakeupSleepOnDatalineConfigs:
        ethernet_wakeup_sleep_on_dataline_config: list[EthernetWakeupSleepOnDatalineConfig] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-WAKEUP-SLEEP-ON-DATALINE-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Executable:
    """
    This meta-class represents an executable program.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar build_type: This attribute describes the buildType of a module
        and/or platform implementation.
    :ivar implementation_propss: This aggregation contains the
        collection of implementation-specific properties necessary to
        properly build the enclosing Executable.
    :ivar minimum_timer_granularity: This attribute describes the
        minimum timer resolution (TimeValue of one tick) that is
        required by the Executable.
    :ivar reporting_behavior: this attribute controls the execution
        state reporting behavior of the enclosing Executable.
    :ivar root_sw_component_prototype: This represents the root
        SwCompositionPrototype of the Executable. This aggregation is
        required (in contrast  to a direct reference of a
        SwComponentType) in order to support the definition of
        instanceRefs in Executable context.
    :ivar version: Version of the executable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXECUTABLE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Executable.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Executable.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    build_type: BuildTypeEnum | None = field(
        default=None,
        metadata={
            "name": "BUILD-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_propss: Optional["Executable.ImplementationPropss"] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_timer_granularity: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-TIMER-GRANULARITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reporting_behavior: ExecutionStateReportingBehaviorEnum | None = field(
        default=None,
        metadata={
            "name": "REPORTING-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    root_sw_component_prototype: RootSwComponentPrototype | None = field(
        default=None,
        metadata={
            "name": "ROOT-SW-COMPONENT-PROTOTYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: StrongRevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationPropss:
        executable_logging_implementation_props: list[ExecutableLoggingImplementationProps] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTABLE-LOGGING-IMPLEMENTATION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ExecutionOrderConstraint:
    """This constraint is used to restrict the order of execution for a set of
    ExecutableEntities.

    The ExecutionOrderConstraint can be used in any timing view. The
    various scopes for ExecutionOrderConstraint are described below.
    Generally, each ExecutionOrderConstraint has a scope of software
    components and can reference all executable entities available in
    the corresponding internal behavior (RunnableEntity and
    BswModuleEntity) either directly or by the events activating
    respectively starting them (RteEvent and BswEvent). On VFB level an
    ExecutionOrderConstraint can be specified for RunnableEntities part
    of the composition hierarchy referenced by the VfbTiming. The
    ExecutionOrderConstraint is aggregated by the VfbTiming. On SW-C
    level an ExecutionOrderConstraint can be specified for
    RunnableEntities part of the InternalBehavior referenced by the
    SwcTiming. The ExecutionOrderConstraint is aggregated by the
    SwcTiming. On System level an ExecutionOrderConstraint can be
    specified for RunnableEntities part of the composition hierarchy of
    the system referenced by the SystemTiming. The
    ExecutionOrderConstraint is aggregated by the SystemTiming. On BSW
    Module level, an ExectionOrderConstraint can be specified for
    BswModuleEntities part of an BswInternalBehavior referenced by the
    BswModuleTiming. The ExecutionOrderConstraint is aggregated by the
    BswModuleTiming. On ECU level an ExecutionOrderConstraint can be
    specified for all ExecutableEntities and Events available via the
    EcucValueCollection, covering ECU Extract and BSW Module
    Configuration, referenced by the EcuTiming. The
    ExecutionOrderConstraint is aggregated by the EcuTiming.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar timing_condition_ref: A timing condition the timing constraint
        depends on. In other words it specifies the condition the timing
        constraint holds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingRequirement Applicable for:
        TimingExtension.timingGuarantee
    :ivar base_composition_ref: Specifies the composition SW-C type
        playing the role of a SW-C containing further SW-Cs and
        represents the scope of the Execution Order Constraint.
    :ivar execution_order_constraint_type: Specifies the specific type
        of ExecutionOrderConstraint.
    :ivar ignore_order_allowed: Controls whether the order of execution
        specified by this constraint can be intentionally ignored
        (TRUE), or shall be respected (FALSE).
    :ivar is_event: Indicates whether the ExecutionOrderConstraint is
        only referring to Executable Entities (FALSE) or only to RTE
        and/or BSW Events (TRUE).
    :ivar ordered_elements: This aggregation represents an unordered
        collection of references to RunnableEntities which shall be
        considered in the ExecutionOrderConstraint. The role does not
        imply that the collection of references itself shall be ordered.
    :ivar permit_multiple_references_to_ee: Indicates that the
        ExecutionOrderConstraints permits that an Executable Entity is
        referenced multiple times (TRUE) or only once (FALSE) in the
        constraint.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXECUTION-ORDER-CONSTRAINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ExecutionOrderConstraint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ExecutionOrderConstraint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["ExecutionOrderConstraint.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_condition_ref: Optional["ExecutionOrderConstraint.TimingConditionRef"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    base_composition_ref: Optional["ExecutionOrderConstraint.BaseCompositionRef"] = field(
        default=None,
        metadata={
            "name": "BASE-COMPOSITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    execution_order_constraint_type: ExecutionOrderConstraintTypeEnum | None = field(
        default=None,
        metadata={
            "name": "EXECUTION-ORDER-CONSTRAINT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ignore_order_allowed: Boolean | None = field(
        default=None,
        metadata={
            "name": "IGNORE-ORDER-ALLOWED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_event: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-EVENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ordered_elements: Optional["ExecutionOrderConstraint.OrderedElements"] = field(
        default=None,
        metadata={
            "name": "ORDERED-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    permit_multiple_references_to_ee: Boolean | None = field(
        default=None,
        metadata={
            "name": "PERMIT-MULTIPLE-REFERENCES-TO-EE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["ExecutionOrderConstraint.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimingConditionRef(Ref):
        dest: TimingConditionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class BaseCompositionRef(Ref):
        dest: CompositionSwComponentTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class OrderedElements:
        eoc_event_ref: list[EocEventRef] = field(
            default_factory=list,
            metadata={
                "name": "EOC-EVENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        eoc_executable_entity_ref: list[EocExecutableEntityRef] = field(
            default_factory=list,
            metadata={
                "name": "EOC-EXECUTABLE-ENTITY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        eoc_executable_entity_ref_group: list[EocExecutableEntityRefGroup] = field(
            default_factory=list,
            metadata={
                "name": "EOC-EXECUTABLE-ENTITY-REF-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ExternalTriggeringPoint:
    """
    If a RunnableEntity owns an ExternalTriggeringPoint it is entitled to raise an
    ExternalTriggerOccurredEvent.

    :ivar ident: The aggregation in the role ident provides the ability
        to make the ExternalTriggeringPoint identifiable. From the
        semantical point of view, the ExternalTriggeringPoint is
        considered a first-class Identifiable and therefore the
        aggregation in the role ident shall always exist (until it may
        be possible to let ModeAccessPoint directly inherit from
        Identifiable).
    :ivar trigger_iref: The trigger taken for the
        ExternalTriggeringPoint.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RunnableEntity.externalTriggeringPoint
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXTERNAL-TRIGGERING-POINT"

    ident: ExternalTriggeringPointIdent | None = field(
        default=None,
        metadata={
            "name": "IDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_iref: Optional["ExternalTriggeringPoint.TriggerIref"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class TriggerIref:
        p_trigger_in_atomic_swc_type_instance_ref: PTriggerInAtomicSwcTypeInstanceRef | None = (
            field(
                default=None,
                metadata={
                    "name": "P-TRIGGER-IN-ATOMIC-SWC-TYPE-INSTANCE-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class FirewallStateSwitchInterface:
    """
    This meta-class provides the ability to implement a PortInterface for
    interaction with the Firewall mode.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar firewall_state_machines: The state machine of this firewall
        interface. This aggregation contains a variation point although
        it is not variant. Therefore, this variation point shall not
        exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FIREWALL-STATE-SWITCH-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FirewallStateSwitchInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FirewallStateSwitchInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["FirewallStateSwitchInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["FirewallStateSwitchInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    firewall_state_machines: Optional["FirewallStateSwitchInterface.FirewallStateMachines"] = field(
        default=None,
        metadata={
            "name": "FIREWALL-STATE-MACHINES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FirewallStateMachines:
        mode_declaration_group_prototype: list[ModeDeclarationGroupPrototype] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-GROUP-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlatInstanceDescriptor:
    """Represents exactly one node (e.g. a component instance or data element) of
    the instance tree of a software system.

    The purpose of this element is to map the various nested representations of this instance to a flat representation and assign a unique name (shortName) to it.
    Use cases:
    * Specify unique names of measurable data to be used by MCD tools
    * Specify unique names of calibration data to be used by MCD tool
    * Specify a unique name for an instance of a component prototype in the ECU extract of the system description
    Note that in addition it is possible to assign alias names via AliasNameAssignment.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar role: The role denotes the particular role of the downstream
        memory location described by this FlatInstanceDescriptor. It
        applies to use case where one upstream object results in
        multiple downstream objects, e.g. ModeDeclarationGroupPrototypes
        which are measurable. In this case the RTE will provide
        locations for current mode, previous mode and next mode.
    :ivar rte_plugin_props: The properties of a communication graph with
        respect to the utilization of RTE Implementation Plug-in.
    :ivar sw_data_def_props: The properties of this
        FlatInstanceDescriptor.
    :ivar upstream_reference_iref: Refers to the instance in the context
        of an "upstream" descriptions, wich could be the system or
        system extract description, the basic software module
        description or (if a flat map is used in preliminary context) a
        description of an atomic component or composition. This
        reference is optional in case the flat map is used in ECU
        context. The reference shall be such that it uniquely defines
        the object instance in the given context. For example, if a data
        prototype is declared as a role within an SwcInternalBehavior,
        it is not enough to state the SwcInternalBehavior as context and
        the aggregated data prototype as target. In addition, the
        reference shall also include the complete path identifying the
        instance of the component prototype that contains the particular
        instance of SwcInternalBehavior.
    :ivar ecu_extract_reference_iref: Refers to the instance in the ECU
        extract. This is valid only, if the FlatMap is used in the
        context of an ECU extract. The reference shall be such that it
        uniquely defines the object instance. For example, if a data
        prototype is declared as a role within an SwcInternalBehavior,
        it is not enough to state the SwcInternalBehavior as context and
        the aggregated data prototype as target. In addition, the
        reference shall also include the complete path identifying
        instance of the component prototype and the
        AtomicSoftwareComponentType, which is refered by the particular
        SwcInternalBehavior.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: FlatMap.instance
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLAT-INSTANCE-DESCRIPTOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlatInstanceDescriptor.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlatInstanceDescriptor.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    role: Identifier | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rte_plugin_props: RtePluginProps | None = field(
        default=None,
        metadata={
            "name": "RTE-PLUGIN-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upstream_reference_iref: AnyInstanceRef | None = field(
        default=None,
        metadata={
            "name": "UPSTREAM-REFERENCE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_extract_reference_iref: AnyInstanceRef | None = field(
        default=None,
        metadata={
            "name": "ECU-EXTRACT-REFERENCE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayArTpChannel:
    """A channel is a group of connections sharing several properties.

    The FlexRay AutosarTransport Layer supports several channels. These
    channels can work concurrently, thus each of them requires its own
    state machine and management data structures and its own PDU-IDs.

    :ivar ack_type: Type of Acknowledgement.
    :ivar cancellation: With this switch Tx and Rx Cancellation can be
        turned on or off.
    :ivar extended_addressing: Adressing Type of this connection: true:
        Two Bytes false: One Byte
    :ivar flow_control_pdu_ref: Reference to the  Flow Control NPdu.
        Please note that this reference is deprecated and will be
        removed in future.
    :ivar max_ar: This attribute defines the maximum number of trying to
        send a frame when a TIMEOUT AR occurs (depending on whether
        retry is configured).
    :ivar max_as: This attribute defines the maximum number of trying to
        send a frame when a TIMEOUT AS occurs (depending on whether
        retry is configured).
    :ivar max_bs: This attribute defines the number of consecutive CFs
        between two FCs (block size). Valid values are 1 .. 16 when
        retry is activated, and 0 .. 255 otherwise.
    :ivar max_buffer_request: Please note that this attribute is
        deprecated and will be removed in future. maxFcWait will be used
        instead to configure the maximum number of wait frames on
        receiver side. On the sender side, timeCs defines the maximum
        time for retries.
    :ivar max_fc_wait: This attribute defines the maximal number of wait
        frames to be sent for a pending connection. Range is 0..255.
    :ivar max_fr_if: Please note that this attribute is deprecated and
        will be removed in future. Old description: This attribute
        defines the maximum number of trying to send a frame when the
        FrIf returns an error.
    :ivar max_retries: This attribute defines the maximum number of
        retries (if retry is configured for the particular channel).
    :ivar maximum_message_length: This specifies the maximum message
        length for the particular channel.
    :ivar minimum_multicast_seperation_time: This attribute defines the
        minimum amount of time between two succeeding CFs of a 1:n
        segmented transmission in seconds. Valid values are 0, 100µs,
        200µs ... 900µs, 1ms, 2ms .. 127ms. The value can be changed at
        runtime using the FrArTp_ChangeParameter interface.
        minimumMulticastSeparationTime shall be an integer multiple of
        the cycle length multiplied with the multiplexing factor, i.e.
        minimumMulticastSeparationTime = n * cycle * m, where n is an
        integer &gt;= 0, cycle is FlexrayCluster.cycle, and m is the
        cycle multiplexor of those cycles where PDUs of the PDU pool are
        scheduled. Please note: Due to the scheduling strategies of
        FrTp, minimumMulticastSeparationTime can only be kept to a
        degree defined by the maximum temporal distance of the PDUs of a
        PDU pool within one FlexRay cycle. Range: 0 .. 0.127
    :ivar minimum_separation_time: This attribute defines the minimum
        amount of time between two succeeding CFs of a 1:1 segmented
        transmission in seconds. Valid values are 0, 100µs, 200µs ..
        900µs, 1ms, 2ms .. 127ms. The value can be changed at runtime
        using the FrArTp_ChangeParameter interface. The
        minimumSeparationTime shall be an integer multiple of the cycle
        length multiplied with the multiplexing factor, i.e.
        minimumSeparationTime = n * cycle * m, where n is an integer
        &gt;=0, cycle is FlexrayCluster.cycle, and m is the cycle
        multiplexor of those cycles where PDUs of the PDU pool are
        scheduled. Please note: Due to the scheduling strategies of
        FrTp, minimumSeparationTime can only be kept to a degree defined
        by the maximum temporal distance of the PDUs of a PDU pool
        within one FlexRay cycle. Range: 0 .. 0.127
    :ivar multicast_segmentation: This attribute defines whether
        segmentation within a 1:n connection is allowed or not.
    :ivar n_pdu_refs: A FlexRayTpChannel references a set of NPdus.
        These NPdus are logically assembled into a pool of Rx NPdus and
        another pool of Tx NPdus. It shall be ensured that a second
        channel either references all NPdus of such a pool, or none.
    :ivar pdu_pools: Please note that this aggregation is deprecated and
        will be removed in future. The nPdu reference will be used
        instead. This aggregation contains a variation point although it
        is not variant. Therefore, this variation point shall not exist
        in models. See constr_2638.
    :ivar time_br: This attribute defines the time in seconds between
        receiving the last CF of a block or an FF-x (or SF-x) and
        sending out an FC or AF.
    :ivar time_buffer: Please note that this attribute is deprecated and
        will be removed in future. timeBr will be used instead to
        configure the delay between two wait frames (and thus two buffer
        requests) on receiver side. On sender side, the main task cycle
        will be used.
    :ivar time_cs: This attribute defines the time in seconds between
        the sending of two consecutive frames or between a consecutive
        frame and a flow control (for Transmit Cancellation) or between
        reception of an flow control or Acknowledgement Frame and
        sending of the next consecutive frame or a  flow control (for
        Transmit Cancellation).
    :ivar time_fr_if: Please note that this attribute is deprecated and
        will be removed in future. Old description: This attribute
        defines the time in seconds of waiting for the next try (if
        retry is activated) to send via FrIf_Transmit. Specified in
        seconds.
    :ivar timeout_ar: This attribute states the timeout in seconds
        between the PDU transmit request of the Transport Layer to the
        FlexRay Interface and the corresponding confirmation of the
        FlexRay Interface on the receiver side (for FC or AF).
    :ivar timeout_as: This attribute states the timeout in seconds
        between the PDU transmit request for the first PDU of the group
        used in the current connection of the Transport Layer to the
        FlexRay Interface and the corresponding confirmation of the
        FlexRay Interface (when having sent the last PDU of the group
        used in this connection) on the sender side (SF-x, FF-x, CF).
    :ivar timeout_bs: This attribute defines the timeout in seconds for
        waiting for an FC or AF on the sender side in a 1:1 connection.
    :ivar timeout_cr: This attribute defines the timeout value in
        seconds for waiting for a CF or FF-x (in case of retry) after
        receiving the last CF or after sending an FC or AF on the
        receiver side.
    :ivar tp_connections: Group of connections that can be used in this
        channel.
    :ivar transmit_cancellation: This attribute states whether Transmit
        Cancellation is supported on this channel. When not set, the
        value of this attribute may be specified by the ECU integrator.
        Please note that this attribute is deprecated and will be
        removed in future.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        FlexrayArTpConfig.tpChannel
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-AR-TP-CHANNEL"

    ack_type: FrArTpAckType | None = field(
        default=None,
        metadata={
            "name": "ACK-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cancellation: Boolean | None = field(
        default=None,
        metadata={
            "name": "CANCELLATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    extended_addressing: Boolean | None = field(
        default=None,
        metadata={
            "name": "EXTENDED-ADDRESSING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    flow_control_pdu_ref: Optional["FlexrayArTpChannel.FlowControlPduRef"] = field(
        default=None,
        metadata={
            "name": "FLOW-CONTROL-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_ar: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-AR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_as: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-AS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_bs: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-BS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_buffer_request: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-BUFFER-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_fc_wait: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-FC-WAIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_fr_if: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-FR-IF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_retries: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-RETRIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_message_length: MaximumMessageLengthType | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-MESSAGE-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_multicast_seperation_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-MULTICAST-SEPERATION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_separation_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-SEPARATION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multicast_segmentation: Boolean | None = field(
        default=None,
        metadata={
            "name": "MULTICAST-SEGMENTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    n_pdu_refs: Optional["FlexrayArTpChannel.NPduRefs"] = field(
        default=None,
        metadata={
            "name": "N-PDU-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_pools: Optional["FlexrayArTpChannel.PduPools"] = field(
        default=None,
        metadata={
            "name": "PDU-POOLS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_br: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-BR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_buffer: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-BUFFER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_cs: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-CS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_fr_if: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIME-FR-IF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_ar: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-AR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_as: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-AS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_bs: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-BS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_cr: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT-CR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_connections: Optional["FlexrayArTpChannel.TpConnections"] = field(
        default=None,
        metadata={
            "name": "TP-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmit_cancellation: Boolean | None = field(
        default=None,
        metadata={
            "name": "TRANSMIT-CANCELLATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FlowControlPduRef(Ref):
        dest: NPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NPduRefs:
        n_pdu_ref: list["FlexrayArTpChannel.NPduRefs.NPduRef"] = field(
            default_factory=list,
            metadata={
                "name": "N-PDU-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class NPduRef(Ref):
            dest: NPduSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PduPools:
        n_pdu: list[NPdu] = field(
            default_factory=list,
            metadata={
                "name": "N-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpConnections:
        flexray_ar_tp_connection: list[FlexrayArTpConnection] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-AR-TP-CONNECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayCommunicationConnector:
    """
    FlexRay specific attributes to the CommunicationConnector.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar comm_controller_ref: Reference to the communication
        controller. The CommunicationConnector and referenced
        CommunicationController shall be aggregated by the same
        ECUInstance. The communicationController can be referenced by
        several CommunicationConnector elements. This is important for
        the FlexRay Bus. FlexRay communicates via two physical channels.
        But only one controller in an ECU is responsible for both
        channels. Thus, two connectors (for channel A and for channel B)
        shall reference to the same controller.
    :ivar create_ecu_wakeup_source: If this parameter is available and
        set to true then a channel wakeup source shall be created for
        the PhysicalChannel referencing this CommunicationConnector.
    :ivar dynamic_pnc_to_channel_mapping_enabled: Defines if this
        EcuInstance shall implement the dynamic PNC-to-channel-mapping
        functionality on this CommunicationConnector and its respective
        PhysicalChannel.
    :ivar ecu_comm_port_instances: An ECUs reception or send ports.
        atpVariation: If signals/PDUs/frames are variable, the
        corresponding ports shall be variable, too.
    :ivar pnc_filter_array_masks: Bit mask for NM-Pdu Payload used to
        configure the NM filter mask for the Network Management.
    :ivar pnc_gateway_type: Defines if this EcuInstance shall implement
        the PncGateway functionality on this CommunicationConnector and
        its respective PhysicalChannel. Several EcuInstances on the same
        PhysicalChannel can have the PncGateway functionality enabled,
        but only one of them shall have the pncGatewayType "active".
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: EcuInstance.connector
        Not Applicable for: MachineDesign.communicationConnector
    :ivar nm_ready_sleep_time: The value of this attribute influences
        the shutdown behavior of the FlexRay NM. FrNm switches to bus
        sleep mode nmReadySleepTime seconds after  the completion of the
        last repetition cycle containing a NM vote.
    :ivar pnc_filter_data_mask: Bit mask for FlexRay Payload used to
        configure the NM filter mask for the Network Management.
    :ivar wake_up_channel: Referenced channel used by the node to send a
        wakeup pattern. (pWakeupChannel)
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-COMMUNICATION-CONNECTOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlexrayCommunicationConnector.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlexrayCommunicationConnector.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_controller_ref: Optional["FlexrayCommunicationConnector.CommControllerRef"] = field(
        default=None,
        metadata={
            "name": "COMM-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    create_ecu_wakeup_source: Boolean | None = field(
        default=None,
        metadata={
            "name": "CREATE-ECU-WAKEUP-SOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_pnc_to_channel_mapping_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "DYNAMIC-PNC-TO-CHANNEL-MAPPING-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_comm_port_instances: Optional["FlexrayCommunicationConnector.EcuCommPortInstances"] = field(
        default=None,
        metadata={
            "name": "ECU-COMM-PORT-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_filter_array_masks: Optional["FlexrayCommunicationConnector.PncFilterArrayMasks"] = field(
        default=None,
        metadata={
            "name": "PNC-FILTER-ARRAY-MASKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_gateway_type: PncGatewayTypeEnum | None = field(
        default=None,
        metadata={
            "name": "PNC-GATEWAY-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_ready_sleep_time: Float | None = field(
        default=None,
        metadata={
            "name": "NM-READY-SLEEP-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_filter_data_mask: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "PNC-FILTER-DATA-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wake_up_channel: Boolean | None = field(
        default=None,
        metadata={
            "name": "WAKE-UP-CHANNEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommControllerRef(Ref):
        dest: CommunicationControllerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuCommPortInstances:
        frame_port: list[FramePort] = field(
            default_factory=list,
            metadata={
                "name": "FRAME-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_pdu_port: list[IPduPort] = field(
            default_factory=list,
            metadata={
                "name": "I-PDU-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_signal_port: list[ISignalPort] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PncFilterArrayMasks:
        pnc_filter_array_mask: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "PNC-FILTER-ARRAY-MASK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayCommunicationController:
    """
    FlexRay bus specific communication port attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EcuInstance.commController Not Applicable for:
        MachineDesign.communicationController
    :ivar flexray_communication_controller_variants: This element was
        generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-COMMUNICATION-CONTROLLER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlexrayCommunicationController.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlexrayCommunicationController.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    flexray_communication_controller_variants: Optional[
        "FlexrayCommunicationController.FlexrayCommunicationControllerVariants"
    ] = field(
        default=None,
        metadata={
            "name": "FLEXRAY-COMMUNICATION-CONTROLLER-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FlexrayCommunicationControllerVariants:
        flexray_communication_controller_conditional: list[
            FlexrayCommunicationControllerConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-COMMUNICATION-CONTROLLER-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayFrame:
    """
    FlexRay specific Frame element.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar frame_length: The used length (in bytes) of the referencing
        frame. Should not be confused with a static byte length reserved
        for each frame by some platforms (e.g. FlexRay). The frameLength
        of zero bytes is allowed. Please consider also TPS_SYST_02255.
    :ivar pdu_to_frame_mappings: A frames layout as a sequence of Pdus.
        atpVariation: The content of a frame can be variable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-FRAME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlexrayFrame.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlexrayFrame.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_length: Integer | None = field(
        default=None,
        metadata={
            "name": "FRAME-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_to_frame_mappings: Optional["FlexrayFrame.PduToFrameMappings"] = field(
        default=None,
        metadata={
            "name": "PDU-TO-FRAME-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduToFrameMappings:
        pdu_to_frame_mapping: list[PduToFrameMapping] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TO-FRAME-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayFrameTriggering:
    """
    FlexRay specific attributes to the FrameTriggering.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar frame_port_refs: References to the FramePort on every ECU of
        the system which sends and/or receives the frame. References for
        both the sender and the receiver side shall be included when the
        system is completely defined.
    :ivar frame_ref: One frame can be triggered several times, e.g. on
        different channels. If a frame has no frame triggering, it won't
        be sent at all. A frame triggering has assigned exactly one
        frame, which it triggers.
    :ivar pdu_triggerings: This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        PhysicalChannel.frameTriggering
    :ivar absolutely_scheduled_timings: Specification of a sending
        behaviour where the exact time for the frames transmission is
        guaranteed.
    :ivar allow_dynamic_l_sdu_length: Allows L-PDU length reduction and
        indicates that the related CC buffer has to be reconfigured for
        the actual length and Header-CRC before transmission of the
        L-PDU. If this attribute is set to true than the referenced
        Frame length attribute defines the max. length.
    :ivar message_id: The first two bytes of the payload segment of the
        FlexRay frame format for frames transmitted in the dynamic
        segment can be used as receiver filterable data called the
        message ID.
    :ivar payload_preamble_indicator: Switching the Payload Preamble
        bit.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-FRAME-TRIGGERING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlexrayFrameTriggering.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlexrayFrameTriggering.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_port_refs: Optional["FlexrayFrameTriggering.FramePortRefs"] = field(
        default=None,
        metadata={
            "name": "FRAME-PORT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_ref: Optional["FlexrayFrameTriggering.FrameRef"] = field(
        default=None,
        metadata={
            "name": "FRAME-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_triggerings: Optional["FlexrayFrameTriggering.PduTriggerings"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    absolutely_scheduled_timings: Optional["FlexrayFrameTriggering.AbsolutelyScheduledTimings"] = (
        field(
            default=None,
            metadata={
                "name": "ABSOLUTELY-SCHEDULED-TIMINGS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    allow_dynamic_l_sdu_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "ALLOW-DYNAMIC-L-SDU-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    message_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MESSAGE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    payload_preamble_indicator: Boolean | None = field(
        default=None,
        metadata={
            "name": "PAYLOAD-PREAMBLE-INDICATOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FramePortRefs:
        frame_port_ref: list["FlexrayFrameTriggering.FramePortRefs.FramePortRef"] = field(
            default_factory=list,
            metadata={
                "name": "FRAME-PORT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FramePortRef(Ref):
            dest: FramePortSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class FrameRef(Ref):
        dest: FrameSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PduTriggerings:
        pdu_triggering_ref_conditional: list[PduTriggeringRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AbsolutelyScheduledTimings:
        flexray_absolutely_scheduled_timing: list[FlexrayAbsolutelyScheduledTiming] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-ABSOLUTELY-SCHEDULED-TIMING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayNmCluster:
    """
    FlexRay specific NM cluster attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_cluster_ref: Association to a
        CommunicationCluster in the topology description.
    :ivar nm_channel_id: This attribute has the status "removed" and
        shall not be used any longer. Old description: Channel
        identification number of the corresponding channel. Must be
        unique over all NmClusters.
    :ivar nm_channel_sleep_master: This parameter shall be set to
        indicate if the sleep of this network can be absolutely decided
        by the local node only and that no other nodes can oppose that
        decision.
    :ivar nm_nodes: Collection of NmNodes of the NmCluster.
        atpVariation: Derived, because NmNode can be variable.
    :ivar nm_node_detection_enabled: Enables the Request Repeat Message
        Request support. Only valid if nmNodeIdEnabled is set to true.
    :ivar nm_node_id_enabled: Enables the source node identifier.
    :ivar nm_pnc_participation: Defines whether this NmCluster
        contributes to the partial network mechanism.
    :ivar nm_repeat_msg_ind_enabled: Switch for enabling the Repeat
        Message Bit Indication.
    :ivar nm_synchronizing_network: If this parameter is true, then this
        network is a synchronizing network for the NM coordination
        cluster which it belongs to. The network is expected to call
        Nm_SynchronizationPoint() at regular intervals.
    :ivar pnc_cluster_vector_length: Optionally defines the length of
        the PNC Vector per CommunicationCluster (and VLAN in case of
        UdpNm). If not defined then System.pncVectorLength applies.
        Should only make the PNC Vector shorter (or same length as
        defined in System.pncVectorLength).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: NmConfig.nmCluster
    :ivar nm_car_wake_up_bit_position: Specifies the bit position of the
        CarWakeUp within the NmPdu.
    :ivar nm_car_wake_up_filter_enabled: If this attribute is set to
        true the CareWakeUp filtering is supported. In this case only
        the CarWakeUp bit within the NmPdu with source node identifier
        nmCarWakeUpFilterNodeId is considered as CarWakeUp request.
    :ivar nm_car_wake_up_filter_node_id: Source node identifier for
        CarWakeUp filtering. If CarWakeUp filtering is supported
        (nmCarWakeUpFilterEnabled), only the CarWakeUp bit within the
        NmPdu with source node identifier nmCarWakeUpFilterNodeId is
        considered as CarWakeUp request.
    :ivar nm_car_wake_up_rx_enabled: If set to true this attribute
        enables the support of CarWakeUp bit evaluation in received
        NmPdus.
    :ivar nm_control_bit_vector_active: Used to activate or deactivate
        the control bit vector support for a Fr Nm Channel.
    :ivar nm_data_cycle: Number of FlexRay Communication Cycles needed
        to transmit the Nm Data PDUs of all FlexRay Nm Ecus of this
        FlexRayNmCluster.
    :ivar nm_data_enabled: Switch to enable the separated sending of NM-
        Data. True: enables False: disables
    :ivar nm_detection_lock: The time for which a node will not set the
        repeat message request bit even in the presence of a repeat
        message request (in seconds).
    :ivar nm_main_function_period: Defines the processing cycle of the
        main function of FrNm module.
    :ivar nm_message_timeout_time: Timeout of a NmPdu in seconds. It
        determines how long the NM shall wait with notification of
        transmission failure while communication errors occur on the
        bus.
    :ivar nm_ready_sleep_count: This attribute is deprecated and will be
        removed in future. nmReadySleepTime in the
        FlexrayCommunicationConnector shall be used instead to influence
        the shutdown behavior of the FlexRay Nm. Old description:
        Numbers of repetitions in the ready sleep state before NM
        switches to bus sleep mode. On a value of "1", the NM-State
        Machine will leave the Ready Sleep State after one NM Repetition
        Cycle with no "keep awake" votes.
    :ivar nm_remote_sleep_indication_time: Timeout for Remote Sleep
        Indication in seconds. It defines the time how long it shall
        take to recognize that all other nodes are ready to sleep.
    :ivar nm_repeat_message_bit_active: Used to activate or deactivate
        the repeat message bit support for a Fr Nm Channel.
    :ivar nm_repeat_message_time: Timeout for Repeat Message State in
        seconds. Defines the time how long the NM shall stay in the
        Repeat Message State.
    :ivar nm_repetition_cycle: Number of FlexRay Communication Cycles
        used to repeat the transmission of the Nm vote Pdus of all
        FlexRay NmEcus of this FlexRayNmCluster.  This value shall be an
        integral multiple of nmVotingCycle.
    :ivar nm_voting_cycle: Number of FlexRay CommunicationCycles needed
        to transmit the Nm vote of Pdus of all FlexRay NmEcus of this
        FlexRayNmCluster.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-NM-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlexrayNmCluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlexrayNmCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_ref: Optional["FlexrayNmCluster.CommunicationClusterRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_channel_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-CHANNEL-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_channel_sleep_master: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CHANNEL-SLEEP-MASTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_nodes: Optional["FlexrayNmCluster.NmNodes"] = field(
        default=None,
        metadata={
            "name": "NM-NODES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_detection_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-DETECTION-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_id_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-ID-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_pnc_participation: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-PNC-PARTICIPATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_repeat_msg_ind_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-REPEAT-MSG-IND-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_synchronizing_network: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-SYNCHRONIZING-NETWORK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_cluster_vector_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PNC-CLUSTER-VECTOR-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_car_wake_up_bit_position: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-CAR-WAKE-UP-BIT-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_car_wake_up_filter_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CAR-WAKE-UP-FILTER-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_car_wake_up_filter_node_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-CAR-WAKE-UP-FILTER-NODE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_car_wake_up_rx_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CAR-WAKE-UP-RX-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_control_bit_vector_active: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CONTROL-BIT-VECTOR-ACTIVE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_data_cycle: Integer | None = field(
        default=None,
        metadata={
            "name": "NM-DATA-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_data_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-DATA-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_detection_lock: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-DETECTION-LOCK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_main_function_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-MAIN-FUNCTION-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_message_timeout_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-MESSAGE-TIMEOUT-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_ready_sleep_count: Integer | None = field(
        default=None,
        metadata={
            "name": "NM-READY-SLEEP-COUNT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_remote_sleep_indication_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-REMOTE-SLEEP-INDICATION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_repeat_message_bit_active: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-REPEAT-MESSAGE-BIT-ACTIVE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_repeat_message_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-REPEAT-MESSAGE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_repetition_cycle: Integer | None = field(
        default=None,
        metadata={
            "name": "NM-REPETITION-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_voting_cycle: Integer | None = field(
        default=None,
        metadata={
            "name": "NM-VOTING-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NmNodes:
        can_nm_node: list[CanNmNode] = field(
            default_factory=list,
            metadata={
                "name": "CAN-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_nm_node: list[FlexrayNmNode] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_nm_node: list[J1939NmNode] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        udp_nm_node: list[UdpNmNode] = field(
            default_factory=list,
            metadata={
                "name": "UDP-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayTpConfig:
    """This element defines exactly one FlexRay ISO TP Configuration.

    One FlexRayTpConfig element shall be created for each FlexRay
    Network in the System that uses FlexRay Iso Tp.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_cluster_ref: A TpConfig is existing always in
        the context of exactly one CommunicationCluster.
    :ivar pdu_pools: Configuration of FlexRay TP Pdu Pools.
    :ivar tp_addresss: Collection of TpAddresses. atpVariation: Derived,
        because EcuInstance can vary.
    :ivar tp_connections: Configuration of FlexRay TP Connections.
        atpVariation: Derived, because TpNode can vary.
    :ivar tp_connection_controls: Configuration of FlexRay TP Connection
        Controls.
    :ivar tp_ecus: Collection of TP Ecus atpVariation: Derived, because
        EcuInstance can vary.
    :ivar tp_nodes: Senders and receivers of FlexRay TP messages.
        atpVariation: Derived, because EcuInstance can vary.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-TP-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlexrayTpConfig.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlexrayTpConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_ref: Optional["FlexrayTpConfig.CommunicationClusterRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_pools: Optional["FlexrayTpConfig.PduPools"] = field(
        default=None,
        metadata={
            "name": "PDU-POOLS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_addresss: Optional["FlexrayTpConfig.TpAddresss"] = field(
        default=None,
        metadata={
            "name": "TP-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_connections: Optional["FlexrayTpConfig.TpConnections"] = field(
        default=None,
        metadata={
            "name": "TP-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_connection_controls: Optional["FlexrayTpConfig.TpConnectionControls"] = field(
        default=None,
        metadata={
            "name": "TP-CONNECTION-CONTROLS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_ecus: Optional["FlexrayTpConfig.TpEcus"] = field(
        default=None,
        metadata={
            "name": "TP-ECUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_nodes: Optional["FlexrayTpConfig.TpNodes"] = field(
        default=None,
        metadata={
            "name": "TP-NODES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PduPools:
        flexray_tp_pdu_pool: list[FlexrayTpPduPool] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-TP-PDU-POOL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpAddresss:
        tp_address: list[TpAddress] = field(
            default_factory=list,
            metadata={
                "name": "TP-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpConnections:
        flexray_tp_connection: list[FlexrayTpConnection] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-TP-CONNECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpConnectionControls:
        flexray_tp_connection_control: list[FlexrayTpConnectionControl] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-TP-CONNECTION-CONTROL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpEcus:
        flexray_tp_ecu: list[FlexrayTpEcu] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-TP-ECU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpNodes:
        flexray_tp_node: list[FlexrayTpNode] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-TP-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FmFeature:
    """A FMFeature describes an essential characteristic of a product.

    Each FMFeature is contained in exactly one FMFeatureModel.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar attribute_defs: This defines the attributes of the given
        feature.
    :ivar decompositions: Lists the sub-features of a feature.
    :ivar maximum_intended_binding_time: Defines an upper bound for the
        binding time of the variation points that are associated with
        the FMFeature. This attribute is meant as a hint for the
        development process.
    :ivar minimum_intended_binding_time: Defines a lower bound for the
        binding time of the variation points that are associated with
        the FMFeature. This attribute is meant as a hint for the
        development process.
    :ivar relations: Defines relations for FMFeatures, for example
        dependencies on other FMFeatures, or conflicts with other
        FMFeatures. A FMFeature can only be part of a
        FMFeatureSelectionSet if all its relations are fulfilled.
    :ivar restrictions: Defines restrictions for FMFeatures. A FMFeature
        can only be part of a FMFeatureSelectionSet if at least one of
        its restrictions evaluates to true.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FM-FEATURE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FmFeature.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FmFeature.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    attribute_defs: Optional["FmFeature.AttributeDefs"] = field(
        default=None,
        metadata={
            "name": "ATTRIBUTE-DEFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    decompositions: Optional["FmFeature.Decompositions"] = field(
        default=None,
        metadata={
            "name": "DECOMPOSITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_intended_binding_time: BindingTimeEnum | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-INTENDED-BINDING-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_intended_binding_time: BindingTimeEnum | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-INTENDED-BINDING-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    relations: Optional["FmFeature.Relations"] = field(
        default=None,
        metadata={
            "name": "RELATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    restrictions: Optional["FmFeature.Restrictions"] = field(
        default=None,
        metadata={
            "name": "RESTRICTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AttributeDefs:
        fm_attribute_def: list[FmAttributeDef] = field(
            default_factory=list,
            metadata={
                "name": "FM-ATTRIBUTE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Decompositions:
        fm_feature_decomposition: list[FmFeatureDecomposition] = field(
            default_factory=list,
            metadata={
                "name": "FM-FEATURE-DECOMPOSITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Relations:
        fm_feature_relation: list[FmFeatureRelation] = field(
            default_factory=list,
            metadata={
                "name": "FM-FEATURE-RELATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Restrictions:
        fm_feature_restriction: list[FmFeatureRestriction] = field(
            default_factory=list,
            metadata={
                "name": "FM-FEATURE-RESTRICTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FmFeatureMapElement:
    """
    Defines value sets for system constants and postbuild variant criterions that
    shall be chosen whenever a certain combination of features (and system
    constants) is encountered.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar assertions: Defines a boolean expression based on features and
        system constants which needs to evaluate to true for this
        mapping to become active.
    :ivar conditions: Defines a condition which needs to be fulfilled
        for this mapping to become active.
    :ivar post_build_variant_criterion_value_set_refs: Selects a set of
        values for postbuild variant criterions.
    :ivar sw_systemconstant_value_set_refs: Selects a set of values for
        system constants.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FM-FEATURE-MAP-ELEMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FmFeatureMapElement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FmFeatureMapElement.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assertions: Optional["FmFeatureMapElement.Assertions"] = field(
        default=None,
        metadata={
            "name": "ASSERTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    conditions: Optional["FmFeatureMapElement.Conditions"] = field(
        default=None,
        metadata={
            "name": "CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_criterion_value_set_refs: Optional[
        "FmFeatureMapElement.PostBuildVariantCriterionValueSetRefs"
    ] = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-CRITERION-VALUE-SET-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_systemconstant_value_set_refs: Optional[
        "FmFeatureMapElement.SwSystemconstantValueSetRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SW-SYSTEMCONSTANT-VALUE-SET-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Assertions:
        fm_feature_map_assertion: list[FmFeatureMapAssertion] = field(
            default_factory=list,
            metadata={
                "name": "FM-FEATURE-MAP-ASSERTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Conditions:
        fm_feature_map_condition: list[FmFeatureMapCondition] = field(
            default_factory=list,
            metadata={
                "name": "FM-FEATURE-MAP-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PostBuildVariantCriterionValueSetRefs:
        post_build_variant_criterion_value_set_ref: list[
            "FmFeatureMapElement.PostBuildVariantCriterionValueSetRefs.PostBuildVariantCriterionValueSetRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "POST-BUILD-VARIANT-CRITERION-VALUE-SET-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PostBuildVariantCriterionValueSetRef(Ref):
            dest: PostBuildVariantCriterionValueSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SwSystemconstantValueSetRefs:
        sw_systemconstant_value_set_ref: list[
            "FmFeatureMapElement.SwSystemconstantValueSetRefs.SwSystemconstantValueSetRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SW-SYSTEMCONSTANT-VALUE-SET-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SwSystemconstantValueSetRef(Ref):
            dest: SwSystemconstantValueSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class FmFeatureSelectionSet:
    """
    A FMFeatureSelectionSet is a set of FMFeatures that describes a specific
    product.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar feature_model_refs: All FMFeatures in this
        FMFeatureSelectionSet shall be part of the referenced
        FMFeatureModel.
    :ivar include_refs: Each FMFeatureSelectionSet may include one or
        more FMFeatureSelectionSets. This establishes a hierarchy among
        FMFeatureSelectionSets. See constr_5003 and constr_5025 for
        details.
    :ivar selections: The set of FMFeatureSelections of this
        FMFeatureSelectionSet.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FM-FEATURE-SELECTION-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FmFeatureSelectionSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FmFeatureSelectionSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    feature_model_refs: Optional["FmFeatureSelectionSet.FeatureModelRefs"] = field(
        default=None,
        metadata={
            "name": "FEATURE-MODEL-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    include_refs: Optional["FmFeatureSelectionSet.IncludeRefs"] = field(
        default=None,
        metadata={
            "name": "INCLUDE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    selections: Optional["FmFeatureSelectionSet.Selections"] = field(
        default=None,
        metadata={
            "name": "SELECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FeatureModelRefs:
        feature_model_ref: list["FmFeatureSelectionSet.FeatureModelRefs.FeatureModelRef"] = field(
            default_factory=list,
            metadata={
                "name": "FEATURE-MODEL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FeatureModelRef(Ref):
            dest: FmFeatureModelSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class IncludeRefs:
        include_ref: list["FmFeatureSelectionSet.IncludeRefs.IncludeRef"] = field(
            default_factory=list,
            metadata={
                "name": "INCLUDE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class IncludeRef(Ref):
            dest: FmFeatureSelectionSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class Selections:
        fm_feature_selection: list[FmFeatureSelection] = field(
            default_factory=list,
            metadata={
                "name": "FM-FEATURE-SELECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FunctionGroupSet:
    """
    This meta-class provides the ability to create arbitrary collections of
    function groups.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar function_groups: This aggregation represents the collection of
        function groups. This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FUNCTION-GROUP-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FunctionGroupSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FunctionGroupSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    function_groups: Optional["FunctionGroupSet.FunctionGroups"] = field(
        default=None,
        metadata={
            "name": "FUNCTION-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FunctionGroups:
        mode_declaration_group_prototype: list[ModeDeclarationGroupPrototype] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-GROUP-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Gateway:
    """
    A gateway is an ECU that is connected to two or more clusters (channels, but
    not redundant), and performs a frame, Pdu or signal mapping between them.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar ecu_ref: Reference to one ECU instance that implements the
        gateway.
    :ivar frame_mappings: Frame Gateway: The entire source frame is
        mapped as it is onto the target frame (what in general is only
        possible inside of a common platform). In this case source and
        target frame should be the identical object. atpVariation: If
        frames are variable in clusters, the gateway frame mapping needs
        to be variable, too.
    :ivar i_pdu_mappings: IPdu Gateway: Arranges those IPdus that are
        transferred by the gateway from one channel to the other in
        pairs and defines the mapping between them. atpVariation: If
        PDUs are variable in clusters, the gateway PDU mapping needs to
        be variable, too.
    :ivar signal_mappings: Signal Gateway: Arranges those signals that
        are transferred by the gateway from one channel to the other in
        pairs and defines the mapping between them. atpVariation: If
        signals are variable in clusters, the gateway signal mapping
        needs to be variable, too.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GATEWAY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Gateway.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Gateway.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_ref: Optional["Gateway.EcuRef"] = field(
        default=None,
        metadata={
            "name": "ECU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_mappings: Optional["Gateway.FrameMappings"] = field(
        default=None,
        metadata={
            "name": "FRAME-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_pdu_mappings: Optional["Gateway.IPduMappings"] = field(
        default=None,
        metadata={
            "name": "I-PDU-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signal_mappings: Optional["Gateway.SignalMappings"] = field(
        default=None,
        metadata={
            "name": "SIGNAL-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FrameMappings:
        frame_mapping: list[FrameMapping] = field(
            default_factory=list,
            metadata={
                "name": "FRAME-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IPduMappings:
        i_pdu_mapping: list[IPduMapping] = field(
            default_factory=list,
            metadata={
                "name": "I-PDU-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SignalMappings:
        i_signal_mapping: list[ISignalMapping] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class GenericEthernetFrame:
    """
    This element is used for EthernetFrames without additional attributes that are
    routed by the EthIf.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar frame_length: The used length (in bytes) of the referencing
        frame. Should not be confused with a static byte length reserved
        for each frame by some platforms (e.g. FlexRay). The frameLength
        of zero bytes is allowed. Please consider also TPS_SYST_02255.
    :ivar pdu_to_frame_mappings: A frames layout as a sequence of Pdus.
        atpVariation: The content of a frame can be variable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GENERIC-ETHERNET-FRAME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GenericEthernetFrame.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GenericEthernetFrame.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_length: Integer | None = field(
        default=None,
        metadata={
            "name": "FRAME-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_to_frame_mappings: Optional["GenericEthernetFrame.PduToFrameMappings"] = field(
        default=None,
        metadata={
            "name": "PDU-TO-FRAME-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduToFrameMappings:
        pdu_to_frame_mapping: list[PduToFrameMapping] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TO-FRAME-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class GlobalSupervision:
    """
    This element defines a collection of AliveSupervisions, DeadlineSupervisions,
    and LogicalSupervisions in order to provide an aggregated supervision state.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alive_supervisions: Collection of AliveSupervisions in the
        context of this GlobalSupervision.
    :ivar deadline_supervisions: Collection of DeadlineSupervisions in
        the context of this GlobalSupervision.
    :ivar logical_supervisions: Collection of LogicalSupervisions in the
        context of this GlobalSupervision.
    :ivar no_checkpoint_supervisions: Definition of No Checkpoint
        Supervision.
    :ivar no_supervisions: Collection of NoSupervisions in the context
        of this GlobalSupervision.
    :ivar supervision_modes: Collection of SupervisionModes in the
        context of this GlobalSupervision.
    :ivar transitions: Collection of CheckpointTransitions in the
        context of this GlobalSupervision.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-SUPERVISION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GlobalSupervision.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GlobalSupervision.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alive_supervisions: Optional["GlobalSupervision.AliveSupervisions"] = field(
        default=None,
        metadata={
            "name": "ALIVE-SUPERVISIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    deadline_supervisions: Optional["GlobalSupervision.DeadlineSupervisions"] = field(
        default=None,
        metadata={
            "name": "DEADLINE-SUPERVISIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    logical_supervisions: Optional["GlobalSupervision.LogicalSupervisions"] = field(
        default=None,
        metadata={
            "name": "LOGICAL-SUPERVISIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    no_checkpoint_supervisions: Optional["GlobalSupervision.NoCheckpointSupervisions"] = field(
        default=None,
        metadata={
            "name": "NO-CHECKPOINT-SUPERVISIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    no_supervisions: Optional["GlobalSupervision.NoSupervisions"] = field(
        default=None,
        metadata={
            "name": "NO-SUPERVISIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    supervision_modes: Optional["GlobalSupervision.SupervisionModes"] = field(
        default=None,
        metadata={
            "name": "SUPERVISION-MODES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transitions: Optional["GlobalSupervision.Transitions"] = field(
        default=None,
        metadata={
            "name": "TRANSITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AliveSupervisions:
        alive_supervision: list[AliveSupervision] = field(
            default_factory=list,
            metadata={
                "name": "ALIVE-SUPERVISION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DeadlineSupervisions:
        deadline_supervision: list[DeadlineSupervision] = field(
            default_factory=list,
            metadata={
                "name": "DEADLINE-SUPERVISION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LogicalSupervisions:
        logical_supervision: list[LogicalSupervision] = field(
            default_factory=list,
            metadata={
                "name": "LOGICAL-SUPERVISION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NoCheckpointSupervisions:
        no_checkpoint_supervision: list[NoCheckpointSupervision] = field(
            default_factory=list,
            metadata={
                "name": "NO-CHECKPOINT-SUPERVISION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NoSupervisions:
        no_supervision: list[NoSupervision] = field(
            default_factory=list,
            metadata={
                "name": "NO-SUPERVISION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SupervisionModes:
        supervision_mode: list[SupervisionMode] = field(
            default_factory=list,
            metadata={
                "name": "SUPERVISION-MODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Transitions:
        checkpoint_transition: list[CheckpointTransition] = field(
            default_factory=list,
            metadata={
                "name": "CHECKPOINT-TRANSITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class GlobalTimeDomain:
    """
    This represents the ability to define a global time domain.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_cluster_refs: This represents the collection of
        CommunicationClusters that shall implement the GlobalTimeDomain
        in terms of communication of global time information.
    :ivar debounce_time: Defines the minimum amount of time between two
        time sync messages are transmitted.
    :ivar domain_id: This represents the ID of the GlobalTimeDomain used
        in the network messages sent on behalf of global time
        management.
    :ivar follow_up_timeout_value: Rx timeout for the follow-up message.
        This is only relevant for selected bus systems Unit:seconds
    :ivar gateways: A GlobalTimeGateway may exist in the context of a
        GlobalTimeDomain to actively update the global time information
        as it is routed from one GlobalTimeDomain to another.
    :ivar global_time_correction_props: Defintion of attributes for rate
        and offset correction.
    :ivar global_time_domain_propertys: Additional properties of the
        GlobalTimeDomain. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar global_time_domain_props: Additional properties of the
        GlobalTimeDomain This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar global_time_masters: This represents the single master of a
        GlobalTimeDomain. A GlobalTimeDomain may have no
        GlobalTimeDomain.master, e.g. when it gets its time from a GPS
        receiver. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar global_time_pdu_ref: This PDU will be taken to transmit the
        global time information from a GlobalTimeMaster to a the
        associated GlobalTimeSlaves.
    :ivar global_time_pdu_triggering_ref: This PduTriggering will be
        taken to transmit the global time information from a
        GlobalTimeMaster to a the associated GlobalTimeSlaves.
    :ivar global_time_sub_domains: By this means it is possible to
        create a hierarchy of subDomains where one global time domain
        can declare one or more other global time domains as its
        subDomains. This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar master: This represents the single master of a
        GlobalTimeDomain. A GlobalTimeDomain may have no
        GlobalTimeDomain.master, e.g. when it gets its time from a GPS
        receiver. This aggregation contains a variation point although
        it is not variant. Therefore, this variation point shall not
        exist in models. See constr_2638.
    :ivar network_segment_id: Defines the numerical identification of a
        GlobalTime sub domain.
    :ivar offset_time_domain_ref: Reference to a synchronized time
        domain this offset time domain is based on. The reference source
        is the offset time domain. The reference target is the
        synchronized time domain.
    :ivar pdu_triggerings: This PduTriggering will be taken to transmit
        the global time information from a GlobalTimeMaster to a the
        associated GlobalTimeSlaves. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar slaves: This represents the collections of slaves of the
        GlobalTimeDomain. A GlobalTimeDomain may have no
        GlobalTimeDomain.slaves, e.g. when it propagates its time
        directly to sub domains.
    :ivar sub_domain_refs: By this means it is possible to create a
        hierarchy of subDomains where one global time domain can declare
        one or more other global time domains as its subDomains.
    :ivar sync_loss_threshold: This represents the minimum delta between
        the time value in two sync messages for which the sync loss flag
        is set.
    :ivar sync_loss_timeout: This attribute describes the timeout for
        the situation that the time synchronization gets lost in the
        scope of the time domain.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "GLOBAL-TIME-DOMAIN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["GlobalTimeDomain.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["GlobalTimeDomain.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_refs: Optional["GlobalTimeDomain.CommunicationClusterRefs"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    debounce_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DEBOUNCE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    domain_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DOMAIN-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    follow_up_timeout_value: TimeValue | None = field(
        default=None,
        metadata={
            "name": "FOLLOW-UP-TIMEOUT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    gateways: Optional["GlobalTimeDomain.Gateways"] = field(
        default=None,
        metadata={
            "name": "GATEWAYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_time_correction_props: GlobalTimeCorrectionProps | None = field(
        default=None,
        metadata={
            "name": "GLOBAL-TIME-CORRECTION-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_time_domain_propertys: Optional["GlobalTimeDomain.GlobalTimeDomainPropertys"] = field(
        default=None,
        metadata={
            "name": "GLOBAL-TIME-DOMAIN-PROPERTYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_time_domain_props: Optional["GlobalTimeDomain.GlobalTimeDomainProps"] = field(
        default=None,
        metadata={
            "name": "GLOBAL-TIME-DOMAIN-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_time_masters: Optional["GlobalTimeDomain.GlobalTimeMasters"] = field(
        default=None,
        metadata={
            "name": "GLOBAL-TIME-MASTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_time_pdu_ref: Optional["GlobalTimeDomain.GlobalTimePduRef"] = field(
        default=None,
        metadata={
            "name": "GLOBAL-TIME-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_time_pdu_triggering_ref: Optional["GlobalTimeDomain.GlobalTimePduTriggeringRef"] = field(
        default=None,
        metadata={
            "name": "GLOBAL-TIME-PDU-TRIGGERING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_time_sub_domains: Optional["GlobalTimeDomain.GlobalTimeSubDomains"] = field(
        default=None,
        metadata={
            "name": "GLOBAL-TIME-SUB-DOMAINS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    master: Optional["GlobalTimeDomain.Master"] = field(
        default=None,
        metadata={
            "name": "MASTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_segment_id: NetworkSegmentIdentification | None = field(
        default=None,
        metadata={
            "name": "NETWORK-SEGMENT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offset_time_domain_ref: Optional["GlobalTimeDomain.OffsetTimeDomainRef"] = field(
        default=None,
        metadata={
            "name": "OFFSET-TIME-DOMAIN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_triggerings: Optional["GlobalTimeDomain.PduTriggerings"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    slaves: Optional["GlobalTimeDomain.Slaves"] = field(
        default=None,
        metadata={
            "name": "SLAVES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_domain_refs: Optional["GlobalTimeDomain.SubDomainRefs"] = field(
        default=None,
        metadata={
            "name": "SUB-DOMAIN-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_loss_threshold: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SYNC-LOSS-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_loss_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SYNC-LOSS-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRefs:
        communication_cluster_ref: list[
            "GlobalTimeDomain.CommunicationClusterRefs.CommunicationClusterRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "COMMUNICATION-CLUSTER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CommunicationClusterRef(Ref):
            dest: CommunicationClusterSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class Gateways:
        global_time_gateway: list[GlobalTimeGateway] = field(
            default_factory=list,
            metadata={
                "name": "GLOBAL-TIME-GATEWAY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class GlobalTimeDomainPropertys:
        can_global_time_domain_props: list[CanGlobalTimeDomainProps] = field(
            default_factory=list,
            metadata={
                "name": "CAN-GLOBAL-TIME-DOMAIN-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        eth_global_time_domain_props: list[EthGlobalTimeDomainProps] = field(
            default_factory=list,
            metadata={
                "name": "ETH-GLOBAL-TIME-DOMAIN-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        fr_global_time_domain_props: list[FrGlobalTimeDomainProps] = field(
            default_factory=list,
            metadata={
                "name": "FR-GLOBAL-TIME-DOMAIN-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class GlobalTimeDomainProps:
        can_global_time_domain_props: CanGlobalTimeDomainProps | None = field(
            default=None,
            metadata={
                "name": "CAN-GLOBAL-TIME-DOMAIN-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        eth_global_time_domain_props: EthGlobalTimeDomainProps | None = field(
            default=None,
            metadata={
                "name": "ETH-GLOBAL-TIME-DOMAIN-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        fr_global_time_domain_props: FrGlobalTimeDomainProps | None = field(
            default=None,
            metadata={
                "name": "FR-GLOBAL-TIME-DOMAIN-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class GlobalTimeMasters:
        global_time_can_master: list[GlobalTimeCanMaster] = field(
            default_factory=list,
            metadata={
                "name": "GLOBAL-TIME-CAN-MASTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        global_time_eth_master: list[GlobalTimeEthMaster] = field(
            default_factory=list,
            metadata={
                "name": "GLOBAL-TIME-ETH-MASTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        global_time_fr_master: list[GlobalTimeFrMaster] = field(
            default_factory=list,
            metadata={
                "name": "GLOBAL-TIME-FR-MASTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_global_time_master: list[UserDefinedGlobalTimeMaster] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-GLOBAL-TIME-MASTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class GlobalTimePduRef(Ref):
        dest: GeneralPurposePduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class GlobalTimePduTriggeringRef(Ref):
        dest: PduTriggeringSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class GlobalTimeSubDomains:
        global_time_domain_ref_conditional: list[GlobalTimeDomainRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "GLOBAL-TIME-DOMAIN-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Master:
        global_time_can_master: GlobalTimeCanMaster | None = field(
            default=None,
            metadata={
                "name": "GLOBAL-TIME-CAN-MASTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        global_time_eth_master: GlobalTimeEthMaster | None = field(
            default=None,
            metadata={
                "name": "GLOBAL-TIME-ETH-MASTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        global_time_fr_master: GlobalTimeFrMaster | None = field(
            default=None,
            metadata={
                "name": "GLOBAL-TIME-FR-MASTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_global_time_master: UserDefinedGlobalTimeMaster | None = field(
            default=None,
            metadata={
                "name": "USER-DEFINED-GLOBAL-TIME-MASTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class OffsetTimeDomainRef(Ref):
        dest: GlobalTimeDomainSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PduTriggerings:
        pdu_triggering_ref_conditional: list[PduTriggeringRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Slaves:
        global_time_can_slave: list[GlobalTimeCanSlave] = field(
            default_factory=list,
            metadata={
                "name": "GLOBAL-TIME-CAN-SLAVE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        global_time_eth_slave: list[GlobalTimeEthSlave] = field(
            default_factory=list,
            metadata={
                "name": "GLOBAL-TIME-ETH-SLAVE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        global_time_fr_slave: list[GlobalTimeFrSlave] = field(
            default_factory=list,
            metadata={
                "name": "GLOBAL-TIME-FR-SLAVE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_global_time_slave: list[UserDefinedGlobalTimeSlave] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-GLOBAL-TIME-SLAVE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubDomainRefs:
        sub_domain_ref: list["GlobalTimeDomain.SubDomainRefs.SubDomainRef"] = field(
            default_factory=list,
            metadata={
                "name": "SUB-DOMAIN-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SubDomainRef(Ref):
            dest: GlobalTimeDomainSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class HwAttributeDef:
    """This metaclass represents the ability to define a particular hardware
    attribute.

    The category of this element defines the type of the attributeValue.
    If the category is Enumeration the hwAttributeEnumerationLiterals
    specify the available literals.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar hw_attribute_literals: The available EnumerationLiterals of
        the Enumeration definition. Only applicable if the category of
        the HwAttributeDef equals Enumeration.
    :ivar is_required: This attribute specifies if the defined attribute
        value is required to be provided.
    :ivar unit_ref: This association specifies the physical unit of the
        defined hardware attribute. This is optional due to the fact
        that there are textual attributes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HW-ATTRIBUTE-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["HwAttributeDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["HwAttributeDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_attribute_literals: Optional["HwAttributeDef.HwAttributeLiterals"] = field(
        default=None,
        metadata={
            "name": "HW-ATTRIBUTE-LITERALS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_required: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-REQUIRED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_ref: Optional["HwAttributeDef.UnitRef"] = field(
        default=None,
        metadata={
            "name": "UNIT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwAttributeLiterals:
        hw_attribute_literal_def: list[HwAttributeLiteralDef] = field(
            default_factory=list,
            metadata={
                "name": "HW-ATTRIBUTE-LITERAL-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class UnitRef(Ref):
        dest: UnitSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class HwPin:
    """
    This meta-class represents the possibility to describe a hardware pin.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar hw_type_ref: This association is used to assign an optional
        HwType which contains the common attribute values for all
        occurences of this HwDescriptionEntity. Note that HwTypes can
        not be redefined and therefore shall not have a hwType
        reference.
    :ivar hw_category_refs: One of the associations representing one
        particular category of the hardware entity.
    :ivar hw_attribute_values: This aggregation represents a particular
        hardware attribute value.
    :ivar pin_number: This attribute contains the physical pin number.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: HwPinGroupContent.hwPin
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HW-PIN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["HwPin.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["HwPin.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_type_ref: Optional["HwPin.HwTypeRef"] = field(
        default=None,
        metadata={
            "name": "HW-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_category_refs: Optional["HwPin.HwCategoryRefs"] = field(
        default=None,
        metadata={
            "name": "HW-CATEGORY-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_attribute_values: Optional["HwPin.HwAttributeValues"] = field(
        default=None,
        metadata={
            "name": "HW-ATTRIBUTE-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pin_number: Integer | None = field(
        default=None,
        metadata={
            "name": "PIN-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwTypeRef(Ref):
        dest: HwTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class HwCategoryRefs:
        hw_category_ref: list["HwPin.HwCategoryRefs.HwCategoryRef"] = field(
            default_factory=list,
            metadata={
                "name": "HW-CATEGORY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class HwCategoryRef(Ref):
            dest: HwCategorySubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class HwAttributeValues:
        hw_attribute_value: list[HwAttributeValue] = field(
            default_factory=list,
            metadata={
                "name": "HW-ATTRIBUTE-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class HwPinGroup:
    """This meta-class represents the ability to describe groups of pins which are
    used to connect hardware elements.

    This group acts as a bundle of pins. Thereby they allow to describe
    high level connections. Pin groups can even be nested.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar hw_type_ref: This association is used to assign an optional
        HwType which contains the common attribute values for all
        occurences of this HwDescriptionEntity. Note that HwTypes can
        not be redefined and therefore shall not have a hwType
        reference.
    :ivar hw_category_refs: One of the associations representing one
        particular category of the hardware entity.
    :ivar hw_attribute_values: This aggregation represents a particular
        hardware attribute value.
    :ivar hw_pin_group_content: This aggregation describes the contained
        pins/pin groups.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: HwElement.hwPinGroup
        Applicable for: HwPinGroupContent.hwPinGroup
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HW-PIN-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["HwPinGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["HwPinGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_type_ref: Optional["HwPinGroup.HwTypeRef"] = field(
        default=None,
        metadata={
            "name": "HW-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_category_refs: Optional["HwPinGroup.HwCategoryRefs"] = field(
        default=None,
        metadata={
            "name": "HW-CATEGORY-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_attribute_values: Optional["HwPinGroup.HwAttributeValues"] = field(
        default=None,
        metadata={
            "name": "HW-ATTRIBUTE-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_pin_group_content: Optional["HwPinGroupContent"] = field(
        default=None,
        metadata={
            "name": "HW-PIN-GROUP-CONTENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwTypeRef(Ref):
        dest: HwTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class HwCategoryRefs:
        hw_category_ref: list["HwPinGroup.HwCategoryRefs.HwCategoryRef"] = field(
            default_factory=list,
            metadata={
                "name": "HW-CATEGORY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class HwCategoryRef(Ref):
            dest: HwCategorySubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class HwAttributeValues:
        hw_attribute_value: list[HwAttributeValue] = field(
            default_factory=list,
            metadata={
                "name": "HW-ATTRIBUTE-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class HwPinGroupConnector:
    """
    This meta-class represents the ability to connect two pin groups.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar hw_pin_connections: This represents one particular connection
        between two hardware pins. The connected pins shall match the
        connection provided by the parent hwPinGroup Connection.
    :ivar hw_pin_group_refs: This association connects two hardware pin
        groups.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        HwElementConnector.hwPinGroupConnection
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HW-PIN-GROUP-CONNECTOR"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_pin_connections: Optional["HwPinGroupConnector.HwPinConnections"] = field(
        default=None,
        metadata={
            "name": "HW-PIN-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_pin_group_refs: Optional["HwPinGroupConnector.HwPinGroupRefs"] = field(
        default=None,
        metadata={
            "name": "HW-PIN-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class HwPinConnections:
        hw_pin_connector: list[HwPinConnector] = field(
            default_factory=list,
            metadata={
                "name": "HW-PIN-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwPinGroupRefs:
        hw_pin_group_ref: list["HwPinGroupConnector.HwPinGroupRefs.HwPinGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "HW-PIN-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class HwPinGroupRef(Ref):
            dest: HwPinGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class HwType:
    """This represents the ability to describe Hardware types on an abstract level.

    The particular types of hardware are distinguished by the category.
    This category determines the applicable attributes. The possible
    categories and attributes are defined in HwCategory.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar hw_type_ref: This association is used to assign an optional
        HwType which contains the common attribute values for all
        occurences of this HwDescriptionEntity. Note that HwTypes can
        not be redefined and therefore shall not have a hwType
        reference.
    :ivar hw_category_refs: One of the associations representing one
        particular category of the hardware entity.
    :ivar hw_attribute_values: This aggregation represents a particular
        hardware attribute value.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HW-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["HwType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["HwType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_type_ref: Optional["HwType.HwTypeRef"] = field(
        default=None,
        metadata={
            "name": "HW-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_category_refs: Optional["HwType.HwCategoryRefs"] = field(
        default=None,
        metadata={
            "name": "HW-CATEGORY-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_attribute_values: Optional["HwType.HwAttributeValues"] = field(
        default=None,
        metadata={
            "name": "HW-ATTRIBUTE-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwTypeRef(Ref):
        dest: HwTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class HwCategoryRefs:
        hw_category_ref: list["HwType.HwCategoryRefs.HwCategoryRef"] = field(
            default_factory=list,
            metadata={
                "name": "HW-CATEGORY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class HwCategoryRef(Ref):
            dest: HwCategorySubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class HwAttributeValues:
        hw_attribute_value: list[HwAttributeValue] = field(
            default_factory=list,
            metadata={
                "name": "HW-ATTRIBUTE-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class IPv6ExtHeaderFilterSet:
    """
    Set of IPv6 Extension Header Filters.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar ext_header_filter_lists: In order to permit or deny certain
        types of IPv6 extension headers a permitted list of IPv6
        extension headers can be configured.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-PV-6-EXT-HEADER-FILTER-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IPv6ExtHeaderFilterSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IPv6ExtHeaderFilterSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ext_header_filter_lists: Optional["IPv6ExtHeaderFilterSet.ExtHeaderFilterLists"] = field(
        default=None,
        metadata={
            "name": "EXT-HEADER-FILTER-LISTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExtHeaderFilterLists:
        i_pv_6_ext_header_filter_list: list[IPv6ExtHeaderFilterList] = field(
            default_factory=list,
            metadata={
                "name": "I-PV-6-EXT-HEADER-FILTER-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ISignalIPduGroup:
    """The AUTOSAR COM Layer is able to start and to stop sending and receiving
    configurable groups of I-Pdus during runtime.

    An ISignalIPduGroup contains either ISignalIPdus or
    ISignalIPduGroups.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_direction: This attribute determines in which
        direction IPdus that are contained in this IPduGroup will be
        transmitted (communication direction can be either In or Out).
    :ivar communication_mode: This attribute defines the use-case for
        this ISignalIPduGroup (e.g. diagnostic, debugging etc.). For
        example, in a diagnostic mode all IPdus - which are not involved
        in diagnostic - are disabled. The use cases are not limited to a
        fixed enumeration and can be specified as a string.
    :ivar contained_i_signal_i_pdu_group_refs: An I-Pdu group can be
        included in other I-Pdu groups. Contained I-Pdu groups shall not
        be referenced by the EcuInstance.
    :ivar i_signal_i_pdus: This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar nm_pdus: This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-SIGNAL-I-PDU-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ISignalIPduGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ISignalIPduGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_direction: CommunicationDirectionType | None = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-DIRECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_mode: String | None = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_i_signal_i_pdu_group_refs: Optional[
        "ISignalIPduGroup.ContainedISignalIPduGroupRefs"
    ] = field(
        default=None,
        metadata={
            "name": "CONTAINED-I-SIGNAL-I-PDU-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_i_pdus: Optional["ISignalIPduGroup.ISignalIPdus"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-I-PDUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_pdus: Optional["ISignalIPduGroup.NmPdus"] = field(
        default=None,
        metadata={
            "name": "NM-PDUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ContainedISignalIPduGroupRefs:
        contained_i_signal_i_pdu_group_ref: list[
            "ISignalIPduGroup.ContainedISignalIPduGroupRefs.ContainedISignalIPduGroupRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTAINED-I-SIGNAL-I-PDU-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContainedISignalIPduGroupRef(Ref):
            dest: ISignalIPduGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ISignalIPdus:
        i_signal_i_pdu_ref_conditional: list[ISignalIPduRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-I-PDU-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NmPdus:
        nm_pdu_ref_conditional: list[NmPduRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "NM-PDU-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class IdsDesign:
    """This meta-class represents the root element of a SecurityExtract file for
    IDS development.

    It defines the scope of an IDS to be designed and implemented by
    referencing all SecurityExtract meta-classes that need to be
    included into the IDS development process.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar elements: This reference includes an element with IDS related
        definitions into the IdsDesign. This property was modified due
        to atpVariation (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IDS-DESIGN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IdsDesign.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IdsDesign.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    elements: Optional["IdsDesign.Elements"] = field(
        default=None,
        metadata={
            "name": "ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Elements:
        ids_common_element_ref_conditional: list[IdsCommonElementRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "IDS-COMMON-ELEMENT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class IdsmInstance:
    """
    This meta-class provides the ability to create a relation between an
    EcuInstance and a specific class of filters for security events that apply for
    all security events reported on the referenced EcuInstance.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar block_states: This reference defines the BlockState in the
        collection BlockStateSet.
    :ivar ecu_instances: This reference identifies the EcuInstance whose
        security events (of any type) shall be limited by the specific
        class of filters. This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar idsm_instance_id: This attribute is used to provide a source
        identification in the context of reporting security events..
    :ivar idsm_module_instantiation_ref: This reference identifies the
        meta-class that defines the attributes for the IdsM
        configuration on a specific machine.
    :ivar rate_limitation_filters: This reference identifies the
        applicable rate limitation filter for all security events on the
        related EcuInstance. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar signature_support_ap: The existence of this aggregation
        specifies that the IdsM shall add a signature to the QSEv
        messages it sends onto the network. The cryptographic algorithm
        and key to be used for this signature is further specified by
        the aggregated meta-class specifically for the Adaptive
        Platform.
    :ivar signature_support_cp: The existence of this aggregation
        specifies that the IdsM shall add a signature to the QSEv
        messages it sends onto the network. The cryptographic algorithm
        and key to be used for this signature is further specified by
        the aggregated meta-class specifically for the Classic Platform.
    :ivar timestamp_format: The existence of this attribute specifies
        that the IdsM shall add a timestamp to the QSEv messages it
        sends onto the network. I.e., if this attribute does not exist,
        no timestamp shall be added to the QSEv messages. The content of
        this attribute further specifies the timestamp format as
        follows: - "AUTOSAR" defines AUTOSAR standardized timestamp
        format according to the Synchronized Time-Base Manager - Any
        other string defines a proprietary timestamp format. Note: A
        string defining a proprietary timestamp format shall be prefixed
        by a company-specific name fragment to avoid collisions.
    :ivar traffic_limitation_filters: This reference identifies the
        applicable traffic limitation filter for all security events on
        the related EcuInstance. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IDSM-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IdsmInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IdsmInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    block_states: Optional["IdsmInstance.BlockStates"] = field(
        default=None,
        metadata={
            "name": "BLOCK-STATES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instances: Optional["IdsmInstance.EcuInstances"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    idsm_instance_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "IDSM-INSTANCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    idsm_module_instantiation_ref: Optional["IdsmInstance.IdsmModuleInstantiationRef"] = field(
        default=None,
        metadata={
            "name": "IDSM-MODULE-INSTANTIATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rate_limitation_filters: Optional["IdsmInstance.RateLimitationFilters"] = field(
        default=None,
        metadata={
            "name": "RATE-LIMITATION-FILTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signature_support_ap: IdsmSignatureSupportAp | None = field(
        default=None,
        metadata={
            "name": "SIGNATURE-SUPPORT-AP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signature_support_cp: IdsmSignatureSupportCp | None = field(
        default=None,
        metadata={
            "name": "SIGNATURE-SUPPORT-CP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timestamp_format: String | None = field(
        default=None,
        metadata={
            "name": "TIMESTAMP-FORMAT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    traffic_limitation_filters: Optional["IdsmInstance.TrafficLimitationFilters"] = field(
        default=None,
        metadata={
            "name": "TRAFFIC-LIMITATION-FILTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlockStates:
        block_state: list[BlockState] = field(
            default_factory=list,
            metadata={
                "name": "BLOCK-STATE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstances:
        ecu_instance_ref_conditional: list[EcuInstanceRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "ECU-INSTANCE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IdsmModuleInstantiationRef(Ref):
        dest: IdsmModuleInstantiationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RateLimitationFilters:
        idsm_rate_limitation_ref_conditional: list[IdsmRateLimitationRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "IDSM-RATE-LIMITATION-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TrafficLimitationFilters:
        idsm_traffic_limitation_ref_conditional: list[IdsmTrafficLimitationRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "IDSM-TRAFFIC-LIMITATION-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class IdsmModuleInstantiation:
    """
    This meta-class defines the attributes for the IdsM configuration on a specific
    machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar network_interface_refs: This association contains the network
        configuration that shall be applied to an instance of an IDS
        entity.
    :ivar time_bases: This reference identifies the applicable time base
        resource. This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar reportable_security_event_refs: Collection of reportable
        instances of security events.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IDSM-MODULE-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IdsmModuleInstantiation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IdsmModuleInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_interface_refs: Optional["IdsmModuleInstantiation.NetworkInterfaceRefs"] = field(
        default=None,
        metadata={
            "name": "NETWORK-INTERFACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_bases: Optional["IdsmModuleInstantiation.TimeBases"] = field(
        default=None,
        metadata={
            "name": "TIME-BASES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reportable_security_event_refs: Optional[
        "IdsmModuleInstantiation.ReportableSecurityEventRefs"
    ] = field(
        default=None,
        metadata={
            "name": "REPORTABLE-SECURITY-EVENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NetworkInterfaceRefs:
        network_interface_ref: list[
            "IdsmModuleInstantiation.NetworkInterfaceRefs.NetworkInterfaceRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "NETWORK-INTERFACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class NetworkInterfaceRef(Ref):
            dest: PlatformModuleEthernetEndpointConfigurationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TimeBases:
        time_base_resource_ref_conditional: list[TimeBaseResourceRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "TIME-BASE-RESOURCE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ReportableSecurityEventRefs:
        reportable_security_event_ref: list[
            "IdsmModuleInstantiation.ReportableSecurityEventRefs.ReportableSecurityEventRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "REPORTABLE-SECURITY-EVENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ReportableSecurityEventRef(Ref):
            dest: SecurityEventMappingSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class IdsmProperties:
    """
    This meta-class provides the ability to aggregate filters for security events.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar rate_limitation_filters: This aggregation represents the
        collection of rate limitation filters for security events in the
        enclosing SecurityFilterSet.
    :ivar traffic_limitation_filters: This aggregation represents the
        collection of traffic limitation filters for security events in
        the enclosing SecurityFilterSet.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IDSM-PROPERTIES"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["IdsmProperties.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["IdsmProperties.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rate_limitation_filters: Optional["IdsmProperties.RateLimitationFilters"] = field(
        default=None,
        metadata={
            "name": "RATE-LIMITATION-FILTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    traffic_limitation_filters: Optional["IdsmProperties.TrafficLimitationFilters"] = field(
        default=None,
        metadata={
            "name": "TRAFFIC-LIMITATION-FILTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RateLimitationFilters:
        idsm_rate_limitation: list[IdsmRateLimitation] = field(
            default_factory=list,
            metadata={
                "name": "IDSM-RATE-LIMITATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TrafficLimitationFilters:
        idsm_traffic_limitation: list[IdsmTrafficLimitation] = field(
            default_factory=list,
            metadata={
                "name": "IDSM-TRAFFIC-LIMITATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Ieee1722TpEthernetFrame:
    """
    Ieee1722Tp Ethernet Frame.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar frame_length: The used length (in bytes) of the referencing
        frame. Should not be confused with a static byte length reserved
        for each frame by some platforms (e.g. FlexRay). The frameLength
        of zero bytes is allowed. Please consider also TPS_SYST_02255.
    :ivar pdu_to_frame_mappings: A frames layout as a sequence of Pdus.
        atpVariation: The content of a frame can be variable.
    :ivar relative_representation_time: Defines the time when content
        shall be presented (in seconds). The actual absolute time is
        creation time plus relative presentation time
    :ivar stream_identifier: IEEE 1722 stream identifier.
    :ivar sub_type: Protocol type.
    :ivar version: Revision of Ieee1722 standard.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IEEE-1722-TP-ETHERNET-FRAME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Ieee1722TpEthernetFrame.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Ieee1722TpEthernetFrame.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_length: Integer | None = field(
        default=None,
        metadata={
            "name": "FRAME-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_to_frame_mappings: Optional["Ieee1722TpEthernetFrame.PduToFrameMappings"] = field(
        default=None,
        metadata={
            "name": "PDU-TO-FRAME-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    relative_representation_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "RELATIVE-REPRESENTATION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    stream_identifier: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "STREAM-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_type: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SUB-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduToFrameMappings:
        pdu_to_frame_mapping: list[PduToFrameMapping] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TO-FRAME-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ImplementationDataType:
    """Describes a reusable data type on the implementation level.

    This will typically correspond to a typedef in C-code.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar sw_data_def_props: The properties of this AutosarDataType.
    :ivar dynamic_array_size_profile: Specifies the profile which the
        array will follow in case this data type is a variable size
        array.
    :ivar is_struct_with_optional_element: This attribute is only valid
        if the attribute category is set to STRUCTURE. If set to true,
        this attribute indicates that the ImplementationDataType has
        been created with the intention to define at least one element
        of the structure as optional.
    :ivar sub_elements: Specifies an element of an array, struct, or
        union data type. The aggregation of ImplementionDataTypeElement
        is subject to variability with the purpose to support the
        conditional existence of elements inside a
        ImplementationDataType representing a structure.
    :ivar symbol_props: This represents the SymbolProps for the
        ImplementationDataType.
    :ivar type_emitter: This attribute is used to control which part of
        the AUTOSAR toolchain is supposed to trigger data type
        definitions.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IMPLEMENTATION-DATA-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ImplementationDataType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ImplementationDataType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ImplementationDataType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_array_size_profile: String | None = field(
        default=None,
        metadata={
            "name": "DYNAMIC-ARRAY-SIZE-PROFILE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_struct_with_optional_element: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-STRUCT-WITH-OPTIONAL-ELEMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_elements: Optional["ImplementationDataType.SubElements"] = field(
        default=None,
        metadata={
            "name": "SUB-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol_props: SymbolProps | None = field(
        default=None,
        metadata={
            "name": "SYMBOL-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_emitter: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "TYPE-EMITTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubElements:
        implementation_data_type_element: list[ImplementationDataTypeElement] = field(
            default_factory=list,
            metadata={
                "name": "IMPLEMENTATION-DATA-TYPE-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class InterfaceMapping:
    """
    This meta-class collects the mappings of elements of a single ServiceInterface
    to PortInterface elements of the AUTOSAR Classic Platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar event_mappings: Mapping of a VariableDataPrototype in a
        SenderReceiverInterface to an Event in a ServiceInterface.
    :ivar field_mappings: Mapping of a Field in a ServiceInterface to
        ClientServerOperations that represent the getter and setter
        methods and to a VariableDataPrototype that represents the
        notifier in the Field.
    :ivar fire_and_forget_method_mappings: Mapping of a Fire&amp;Forget
        Method that is located in a ServiceInterface to a
        VariableDataPrototype in a SenderReceiverInterface or to a
        Trigger in a TriggerInterface.
    :ivar method_mappings: Mapping of a ClientServerOperation in a
        ClientServerInterface to a Method in a ServiceInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INTERFACE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["InterfaceMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["InterfaceMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_mappings: Optional["InterfaceMapping.EventMappings"] = field(
        default=None,
        metadata={
            "name": "EVENT-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_mappings: Optional["InterfaceMapping.FieldMappings"] = field(
        default=None,
        metadata={
            "name": "FIELD-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fire_and_forget_method_mappings: Optional["InterfaceMapping.FireAndForgetMethodMappings"] = (
        field(
            default=None,
            metadata={
                "name": "FIRE-AND-FORGET-METHOD-MAPPINGS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    method_mappings: Optional["InterfaceMapping.MethodMappings"] = field(
        default=None,
        metadata={
            "name": "METHOD-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventMappings:
        event_mapping: list[EventMapping] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FieldMappings:
        field_mapping: list[FieldMapping] = field(
            default_factory=list,
            metadata={
                "name": "FIELD-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FireAndForgetMethodMappings:
        fire_and_forget_method_mapping: list[FireAndForgetMethodMapping] = field(
            default_factory=list,
            metadata={
                "name": "FIRE-AND-FORGET-METHOD-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MethodMappings:
        method_mapping: list[MethodMapping] = field(
            default_factory=list,
            metadata={
                "name": "METHOD-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class IpSecConfig:
    """
    IPsec is a protocol that is designed to provide "end-to-end" cryptographically-
    based security for IP network connections.

    :ivar ip_sec_config_props_ref: Global IPsec configuration settings
        that are valid for all IPSecRules that are defined on the
        NetworkEndpoint.
    :ivar ip_sec_rules: IPSec rules and filters that are defined in the
        IPSecConfig for a specific NetworkEndpoint.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "IP-SEC-CONFIG"

    ip_sec_config_props_ref: Optional["IpSecConfig.IpSecConfigPropsRef"] = field(
        default=None,
        metadata={
            "name": "IP-SEC-CONFIG-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ip_sec_rules: Optional["IpSecConfig.IpSecRules"] = field(
        default=None,
        metadata={
            "name": "IP-SEC-RULES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class IpSecConfigPropsRef(Ref):
        dest: IpSecConfigPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IpSecRules:
        ip_sec_rule: list[IpSecRule] = field(
            default_factory=list,
            metadata={
                "name": "IP-SEC-RULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class J1939NmCluster:
    """
    J1939 specific NmCluster attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_cluster_ref: Association to a
        CommunicationCluster in the topology description.
    :ivar nm_channel_id: This attribute has the status "removed" and
        shall not be used any longer. Old description: Channel
        identification number of the corresponding channel. Must be
        unique over all NmClusters.
    :ivar nm_channel_sleep_master: This parameter shall be set to
        indicate if the sleep of this network can be absolutely decided
        by the local node only and that no other nodes can oppose that
        decision.
    :ivar nm_nodes: Collection of NmNodes of the NmCluster.
        atpVariation: Derived, because NmNode can be variable.
    :ivar nm_node_detection_enabled: Enables the Request Repeat Message
        Request support. Only valid if nmNodeIdEnabled is set to true.
    :ivar nm_node_id_enabled: Enables the source node identifier.
    :ivar nm_pnc_participation: Defines whether this NmCluster
        contributes to the partial network mechanism.
    :ivar nm_repeat_msg_ind_enabled: Switch for enabling the Repeat
        Message Bit Indication.
    :ivar nm_synchronizing_network: If this parameter is true, then this
        network is a synchronizing network for the NM coordination
        cluster which it belongs to. The network is expected to call
        Nm_SynchronizationPoint() at regular intervals.
    :ivar pnc_cluster_vector_length: Optionally defines the length of
        the PNC Vector per CommunicationCluster (and VLAN in case of
        UdpNm). If not defined then System.pncVectorLength applies.
        Should only make the PNC Vector shorter (or same length as
        defined in System.pncVectorLength).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: NmConfig.nmCluster
    :ivar address_claim_enabled: This attribute specifies whether the
        J1939Nm Bsw module is used or not. If this attribute is set to
        false then the J1939Nm configuration shall not be derived from
        the system description. But even in this case the nmNodeId might
        still be necessary for the J1939Rm and J1939Tp.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-NM-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["J1939NmCluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["J1939NmCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_ref: Optional["J1939NmCluster.CommunicationClusterRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_channel_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-CHANNEL-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_channel_sleep_master: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CHANNEL-SLEEP-MASTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_nodes: Optional["J1939NmCluster.NmNodes"] = field(
        default=None,
        metadata={
            "name": "NM-NODES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_detection_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-DETECTION-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_id_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-ID-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_pnc_participation: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-PNC-PARTICIPATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_repeat_msg_ind_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-REPEAT-MSG-IND-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_synchronizing_network: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-SYNCHRONIZING-NETWORK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_cluster_vector_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PNC-CLUSTER-VECTOR-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    address_claim_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "ADDRESS-CLAIM-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NmNodes:
        can_nm_node: list[CanNmNode] = field(
            default_factory=list,
            metadata={
                "name": "CAN-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_nm_node: list[FlexrayNmNode] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_nm_node: list[J1939NmNode] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        udp_nm_node: list[UdpNmNode] = field(
            default_factory=list,
            metadata={
                "name": "UDP-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class J1939TpConfig:
    """This element defines exactly one J1939 TP Configuration.

    One J1939TpConfig element shall be created for each J1939 Network in
    the System.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_cluster_ref: A TpConfig is existing always in
        the context of exactly one CommunicationCluster.
    :ivar tp_addresss: Collection of TP Adresses. atpVariation: Derived,
        because EcuInstance can vary.
    :ivar tp_connections: Configuration of J1939 TP connections.
        atpVariation: Derived, because TpNode can vary.
    :ivar tp_nodes: Senders and receivers of J1939 TP messages.
        atpVariation: Derived, because EcuInstance can vary.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-TP-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["J1939TpConfig.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["J1939TpConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_ref: Optional["J1939TpConfig.CommunicationClusterRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_addresss: Optional["J1939TpConfig.TpAddresss"] = field(
        default=None,
        metadata={
            "name": "TP-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_connections: Optional["J1939TpConfig.TpConnections"] = field(
        default=None,
        metadata={
            "name": "TP-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_nodes: Optional["J1939TpConfig.TpNodes"] = field(
        default=None,
        metadata={
            "name": "TP-NODES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TpAddresss:
        tp_address: list[TpAddress] = field(
            default_factory=list,
            metadata={
                "name": "TP-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpConnections:
        j_1939_tp_connection: list[J1939TpConnection] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-TP-CONNECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpNodes:
        j_1939_tp_node: list[J1939TpNode] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-TP-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class KeywordSet:
    """
    This meta--class represents the ability to collect a set of predefined
    keywords.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar keywords: This is one particular keyword in the keyword set.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "KEYWORD-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["KeywordSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["KeywordSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["KeywordSet.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    keywords: Optional["KeywordSet.Keywords"] = field(
        default=None,
        metadata={
            "name": "KEYWORDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Keywords:
        keyword: list[Keyword] = field(
            default_factory=list,
            metadata={
                "name": "KEYWORD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LifeCycleStateDefinitionGroup:
    """
    This meta class represents the ability to define the states and properties of
    one particular life cycle.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar lc_states: Describes a single life cycle state of this life
        cycle state definition group.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIFE-CYCLE-STATE-DEFINITION-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LifeCycleStateDefinitionGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LifeCycleStateDefinitionGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["LifeCycleStateDefinitionGroup.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lc_states: Optional["LifeCycleStateDefinitionGroup.LcStates"] = field(
        default=None,
        metadata={
            "name": "LC-STATES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LcStates:
        life_cycle_state: list[LifeCycleState] = field(
            default_factory=list,
            metadata={
                "name": "LIFE-CYCLE-STATE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LinCommunicationConnector:
    """
    LIN bus specific communication connector attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar comm_controller_ref: Reference to the communication
        controller. The CommunicationConnector and referenced
        CommunicationController shall be aggregated by the same
        ECUInstance. The communicationController can be referenced by
        several CommunicationConnector elements. This is important for
        the FlexRay Bus. FlexRay communicates via two physical channels.
        But only one controller in an ECU is responsible for both
        channels. Thus, two connectors (for channel A and for channel B)
        shall reference to the same controller.
    :ivar create_ecu_wakeup_source: If this parameter is available and
        set to true then a channel wakeup source shall be created for
        the PhysicalChannel referencing this CommunicationConnector.
    :ivar dynamic_pnc_to_channel_mapping_enabled: Defines if this
        EcuInstance shall implement the dynamic PNC-to-channel-mapping
        functionality on this CommunicationConnector and its respective
        PhysicalChannel.
    :ivar ecu_comm_port_instances: An ECUs reception or send ports.
        atpVariation: If signals/PDUs/frames are variable, the
        corresponding ports shall be variable, too.
    :ivar pnc_filter_array_masks: Bit mask for NM-Pdu Payload used to
        configure the NM filter mask for the Network Management.
    :ivar pnc_gateway_type: Defines if this EcuInstance shall implement
        the PncGateway functionality on this CommunicationConnector and
        its respective PhysicalChannel. Several EcuInstances on the same
        PhysicalChannel can have the PncGateway functionality enabled,
        but only one of them shall have the pncGatewayType "active".
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: EcuInstance.connector
        Not Applicable for: MachineDesign.communicationConnector
    :ivar initial_nad: Initial NAD of the LIN slave.
    :ivar lin_configurable_frames: LinConfigurableFrames shall list all
        frames (unconditional frames, event-triggered frames and
        sporadic frames) processed by the slave node. This element is
        necessary for the LIN 2.0 Assign-Frame command.
    :ivar lin_ordered_configurable_frames: LinOrderedConfigurableFrames
        shall list all frames (unconditional frames, event-triggered
        frames and sporadic frames) processed by the slave node. This
        element is necessary for the LIN 2.1 Assign-Frame-PID-Range
        command.
    :ivar schedule_change_next_time_base: This attribute defines the
        point in time where a schedule table switch is performed. If
        this attribute is set to false or not present, the schedule
        table shall be switched after the current entry of the active
        schedule table is ended. If this attribute is enabled, the
        schedule table shall be switched when message transmission or
        reception within an entry has been completed, ensured by status
        checks for transmission and reception.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-COMMUNICATION-CONNECTOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LinCommunicationConnector.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LinCommunicationConnector.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_controller_ref: Optional["LinCommunicationConnector.CommControllerRef"] = field(
        default=None,
        metadata={
            "name": "COMM-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    create_ecu_wakeup_source: Boolean | None = field(
        default=None,
        metadata={
            "name": "CREATE-ECU-WAKEUP-SOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_pnc_to_channel_mapping_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "DYNAMIC-PNC-TO-CHANNEL-MAPPING-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_comm_port_instances: Optional["LinCommunicationConnector.EcuCommPortInstances"] = field(
        default=None,
        metadata={
            "name": "ECU-COMM-PORT-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_filter_array_masks: Optional["LinCommunicationConnector.PncFilterArrayMasks"] = field(
        default=None,
        metadata={
            "name": "PNC-FILTER-ARRAY-MASKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_gateway_type: PncGatewayTypeEnum | None = field(
        default=None,
        metadata={
            "name": "PNC-GATEWAY-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_nad: Integer | None = field(
        default=None,
        metadata={
            "name": "INITIAL-NAD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lin_configurable_frames: Optional["LinCommunicationConnector.LinConfigurableFrames"] = field(
        default=None,
        metadata={
            "name": "LIN-CONFIGURABLE-FRAMES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lin_ordered_configurable_frames: Optional[
        "LinCommunicationConnector.LinOrderedConfigurableFrames"
    ] = field(
        default=None,
        metadata={
            "name": "LIN-ORDERED-CONFIGURABLE-FRAMES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    schedule_change_next_time_base: Boolean | None = field(
        default=None,
        metadata={
            "name": "SCHEDULE-CHANGE-NEXT-TIME-BASE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommControllerRef(Ref):
        dest: CommunicationControllerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuCommPortInstances:
        frame_port: list[FramePort] = field(
            default_factory=list,
            metadata={
                "name": "FRAME-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_pdu_port: list[IPduPort] = field(
            default_factory=list,
            metadata={
                "name": "I-PDU-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_signal_port: list[ISignalPort] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PncFilterArrayMasks:
        pnc_filter_array_mask: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "PNC-FILTER-ARRAY-MASK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LinConfigurableFrames:
        lin_configurable_frame: list[LinConfigurableFrame] = field(
            default_factory=list,
            metadata={
                "name": "LIN-CONFIGURABLE-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LinOrderedConfigurableFrames:
        lin_ordered_configurable_frame: list[LinOrderedConfigurableFrame] = field(
            default_factory=list,
            metadata={
                "name": "LIN-ORDERED-CONFIGURABLE-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LinEventTriggeredFrame:
    """An event triggered frame is used as a placeholder to allow multiple slave
    nodes to provide its response.

    The header of an event triggered frame is transmitted when a frame
    slot allocated to the event triggered frame is processed. The
    publisher of an associated unconditional frame shall only transmit
    the response if at least one of the signals carried in its
    unconditional frame is updated. The LIN Master discovers and purges
    collisions with the collisionResolvingScheduleTable. The event
    controlled frame shall not contain any Pdus.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar frame_length: The used length (in bytes) of the referencing
        frame. Should not be confused with a static byte length reserved
        for each frame by some platforms (e.g. FlexRay). The frameLength
        of zero bytes is allowed. Please consider also TPS_SYST_02255.
    :ivar pdu_to_frame_mappings: A frames layout as a sequence of Pdus.
        atpVariation: The content of a frame can be variable.
    :ivar collision_resolving_schedule_ref: Reference to the schedule
        table, which resolves a collision.
    :ivar lin_unconditional_frame_refs: A list of slaves can respond to
        the master request if at least one of the signals carried in its
        unconditional frame is updated. For each response a
        LinFrameTriggering and a LinUnconditionalFrame shall be defined.
        Within a channel a LIN Frame shall be referenced by only one
        FrameTriggering. This allows a derivation of the identifier of a
        substituted Frame. The identifier is specified in
        FrameTriggering element. The Unconditional frames associated
        with an event triggered frame shall: * have equal length. * use
        the same checksum model (i.e. mixing LIN 1.x and LIN 2.x frames
        is not allowed). * reserve the first data field to its protected
        identifier (even if the associated unconditional frame is
        scheduled as a unconditional frame in the same or another
        schedule table). * be published by different slave nodes. *
        shall not be included directly in the same schedule table as the
        event triggered frame is scheduled.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-EVENT-TRIGGERED-FRAME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LinEventTriggeredFrame.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LinEventTriggeredFrame.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_length: Integer | None = field(
        default=None,
        metadata={
            "name": "FRAME-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_to_frame_mappings: Optional["LinEventTriggeredFrame.PduToFrameMappings"] = field(
        default=None,
        metadata={
            "name": "PDU-TO-FRAME-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    collision_resolving_schedule_ref: Optional[
        "LinEventTriggeredFrame.CollisionResolvingScheduleRef"
    ] = field(
        default=None,
        metadata={
            "name": "COLLISION-RESOLVING-SCHEDULE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lin_unconditional_frame_refs: Optional["LinEventTriggeredFrame.LinUnconditionalFrameRefs"] = (
        field(
            default=None,
            metadata={
                "name": "LIN-UNCONDITIONAL-FRAME-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduToFrameMappings:
        pdu_to_frame_mapping: list[PduToFrameMapping] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TO-FRAME-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CollisionResolvingScheduleRef(Ref):
        dest: LinScheduleTableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class LinUnconditionalFrameRefs:
        lin_unconditional_frame_ref: list[
            "LinEventTriggeredFrame.LinUnconditionalFrameRefs.LinUnconditionalFrameRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "LIN-UNCONDITIONAL-FRAME-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class LinUnconditionalFrameRef(Ref):
            dest: LinUnconditionalFrameSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class LinFrameTriggering:
    """
    LIN specific attributes to the FrameTriggering.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar frame_port_refs: References to the FramePort on every ECU of
        the system which sends and/or receives the frame. References for
        both the sender and the receiver side shall be included when the
        system is completely defined.
    :ivar frame_ref: One frame can be triggered several times, e.g. on
        different channels. If a frame has no frame triggering, it won't
        be sent at all. A frame triggering has assigned exactly one
        frame, which it triggers.
    :ivar pdu_triggerings: This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        PhysicalChannel.frameTriggering
    :ivar identifier: To describe a frames identifier on the
        communication system, usually with a fixed identifierValue. For
        LinSporadicFrames the attribute shall be ignored.
    :ivar lin_checksum: Type of checksum that the frame is using. This
        attribute is optional because in case of sporadic frames it
        should not be set.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-FRAME-TRIGGERING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LinFrameTriggering.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LinFrameTriggering.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_port_refs: Optional["LinFrameTriggering.FramePortRefs"] = field(
        default=None,
        metadata={
            "name": "FRAME-PORT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_ref: Optional["LinFrameTriggering.FrameRef"] = field(
        default=None,
        metadata={
            "name": "FRAME-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_triggerings: Optional["LinFrameTriggering.PduTriggerings"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    identifier: Integer | None = field(
        default=None,
        metadata={
            "name": "IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lin_checksum: LinChecksumType | None = field(
        default=None,
        metadata={
            "name": "LIN-CHECKSUM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FramePortRefs:
        frame_port_ref: list["LinFrameTriggering.FramePortRefs.FramePortRef"] = field(
            default_factory=list,
            metadata={
                "name": "FRAME-PORT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FramePortRef(Ref):
            dest: FramePortSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class FrameRef(Ref):
        dest: FrameSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PduTriggerings:
        pdu_triggering_ref_conditional: list[PduTriggeringRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LinMaster:
    """
    Describing the properties of the refering ecu as a LIN master.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EcuInstance.commController Not Applicable for:
        MachineDesign.communicationController
    :ivar lin_master_variants: This element was generated/modified due
        to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-MASTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LinMaster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LinMaster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lin_master_variants: Optional["LinMaster.LinMasterVariants"] = field(
        default=None,
        metadata={
            "name": "LIN-MASTER-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LinMasterVariants:
        lin_master_conditional: list[LinMasterConditional] = field(
            default_factory=list,
            metadata={
                "name": "LIN-MASTER-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LinNmCluster:
    """
    Lin specific NmCluster attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_cluster_ref: Association to a
        CommunicationCluster in the topology description.
    :ivar nm_channel_id: This attribute has the status "removed" and
        shall not be used any longer. Old description: Channel
        identification number of the corresponding channel. Must be
        unique over all NmClusters.
    :ivar nm_channel_sleep_master: This parameter shall be set to
        indicate if the sleep of this network can be absolutely decided
        by the local node only and that no other nodes can oppose that
        decision.
    :ivar nm_nodes: Collection of NmNodes of the NmCluster.
        atpVariation: Derived, because NmNode can be variable.
    :ivar nm_node_detection_enabled: Enables the Request Repeat Message
        Request support. Only valid if nmNodeIdEnabled is set to true.
    :ivar nm_node_id_enabled: Enables the source node identifier.
    :ivar nm_pnc_participation: Defines whether this NmCluster
        contributes to the partial network mechanism.
    :ivar nm_repeat_msg_ind_enabled: Switch for enabling the Repeat
        Message Bit Indication.
    :ivar nm_synchronizing_network: If this parameter is true, then this
        network is a synchronizing network for the NM coordination
        cluster which it belongs to. The network is expected to call
        Nm_SynchronizationPoint() at regular intervals.
    :ivar pnc_cluster_vector_length: Optionally defines the length of
        the PNC Vector per CommunicationCluster (and VLAN in case of
        UdpNm). If not defined then System.pncVectorLength applies.
        Should only make the PNC Vector shorter (or same length as
        defined in System.pncVectorLength).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: NmConfig.nmCluster
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-NM-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LinNmCluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LinNmCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_ref: Optional["LinNmCluster.CommunicationClusterRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_channel_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-CHANNEL-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_channel_sleep_master: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CHANNEL-SLEEP-MASTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_nodes: Optional["LinNmCluster.NmNodes"] = field(
        default=None,
        metadata={
            "name": "NM-NODES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_detection_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-DETECTION-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_id_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-ID-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_pnc_participation: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-PNC-PARTICIPATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_repeat_msg_ind_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-REPEAT-MSG-IND-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_synchronizing_network: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-SYNCHRONIZING-NETWORK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_cluster_vector_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PNC-CLUSTER-VECTOR-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NmNodes:
        can_nm_node: list[CanNmNode] = field(
            default_factory=list,
            metadata={
                "name": "CAN-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_nm_node: list[FlexrayNmNode] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_nm_node: list[J1939NmNode] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        udp_nm_node: list[UdpNmNode] = field(
            default_factory=list,
            metadata={
                "name": "UDP-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LinSlave:
    """
    Describing the properties of the referring ecu as a LIN slave.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EcuInstance.commController Not Applicable for:
        MachineDesign.communicationController
    :ivar lin_slave_variants: This element was generated/modified due to
        an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-SLAVE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LinSlave.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LinSlave.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lin_slave_variants: Optional["LinSlave.LinSlaveVariants"] = field(
        default=None,
        metadata={
            "name": "LIN-SLAVE-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LinSlaveVariants:
        lin_slave_conditional: list[LinSlaveConditional] = field(
            default_factory=list,
            metadata={
                "name": "LIN-SLAVE-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LinSporadicFrame:
    """A sporadic frame is a group of unconditional frames that share the same
    frame slot.

    The sporadic frame shall not contain any Pdus.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar frame_length: The used length (in bytes) of the referencing
        frame. Should not be confused with a static byte length reserved
        for each frame by some platforms (e.g. FlexRay). The frameLength
        of zero bytes is allowed. Please consider also TPS_SYST_02255.
    :ivar pdu_to_frame_mappings: A frames layout as a sequence of Pdus.
        atpVariation: The content of a frame can be variable.
    :ivar substituted_frame_refs: Reference to a group of unconditional
        frames that share the same frame slot. In case that more than
        one of the declared frames needs to be transferred, the one
        first listed shall be chosen. Within a channel a LIN Frame shall
        be referenced by only one FrameTriggering. This allows a
        derivation of the identifier of a substituted Frame. The
        identifier is specified in FrameTriggering element. A
        LinUnconditionalFrame associated with a LinSporadicFrame may not
        be allocated in the same LinScheduleTable as the sporadic frame.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-SPORADIC-FRAME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LinSporadicFrame.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LinSporadicFrame.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_length: Integer | None = field(
        default=None,
        metadata={
            "name": "FRAME-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_to_frame_mappings: Optional["LinSporadicFrame.PduToFrameMappings"] = field(
        default=None,
        metadata={
            "name": "PDU-TO-FRAME-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    substituted_frame_refs: Optional["LinSporadicFrame.SubstitutedFrameRefs"] = field(
        default=None,
        metadata={
            "name": "SUBSTITUTED-FRAME-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduToFrameMappings:
        pdu_to_frame_mapping: list[PduToFrameMapping] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TO-FRAME-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubstitutedFrameRefs:
        substituted_frame_ref: list["LinSporadicFrame.SubstitutedFrameRefs.SubstitutedFrameRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SUBSTITUTED-FRAME-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class SubstitutedFrameRef(Ref):
            dest: LinUnconditionalFrameSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class LinTpConfig:
    """This element defines exactly one Lin TP Configuration.

    One LinTpConfig element shall be created for each Lin Network in the
    System.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_cluster_ref: A TpConfig is existing always in
        the context of exactly one CommunicationCluster.
    :ivar tp_addresss: Collection of TpAddresses. atpVariation: Derived,
        because EcuInstance can vary.
    :ivar tp_connections: Configuration of LIN TP channels.
        atpVariation: Derived, because TpNode can vary.
    :ivar tp_nodes: Senders and receivers of LIN TP messages.
        atpVariation: Derived, because EcuInstance can vary.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-TP-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LinTpConfig.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LinTpConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_ref: Optional["LinTpConfig.CommunicationClusterRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_addresss: Optional["LinTpConfig.TpAddresss"] = field(
        default=None,
        metadata={
            "name": "TP-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_connections: Optional["LinTpConfig.TpConnections"] = field(
        default=None,
        metadata={
            "name": "TP-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_nodes: Optional["LinTpConfig.TpNodes"] = field(
        default=None,
        metadata={
            "name": "TP-NODES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TpAddresss:
        tp_address: list[TpAddress] = field(
            default_factory=list,
            metadata={
                "name": "TP-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpConnections:
        lin_tp_connection: list[LinTpConnection] = field(
            default_factory=list,
            metadata={
                "name": "LIN-TP-CONNECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpNodes:
        lin_tp_node: list[LinTpNode] = field(
            default_factory=list,
            metadata={
                "name": "LIN-TP-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LinUnconditionalFrame:
    """Unconditional frames carry signals.

    The master sends a frame header in a scheduled frame slot and the
    designated slave node fills the frame with data.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar frame_length: The used length (in bytes) of the referencing
        frame. Should not be confused with a static byte length reserved
        for each frame by some platforms (e.g. FlexRay). The frameLength
        of zero bytes is allowed. Please consider also TPS_SYST_02255.
    :ivar pdu_to_frame_mappings: A frames layout as a sequence of Pdus.
        atpVariation: The content of a frame can be variable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-UNCONDITIONAL-FRAME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LinUnconditionalFrame.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LinUnconditionalFrame.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_length: Integer | None = field(
        default=None,
        metadata={
            "name": "FRAME-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_to_frame_mappings: Optional["LinUnconditionalFrame.PduToFrameMappings"] = field(
        default=None,
        metadata={
            "name": "PDU-TO-FRAME-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduToFrameMappings:
        pdu_to_frame_mapping: list[PduToFrameMapping] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TO-FRAME-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class MacSecParticipantSet:
    """
    Collection of MACsec Kay Participants on an Ethernet Link.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar ethernet_cluster_ref: Reference to the EthernetCluster (Link)
        on which the KaY participants are located
    :ivar mka_participants: Configuration of a MKA Participant.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MAC-SEC-PARTICIPANT-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["MacSecParticipantSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["MacSecParticipantSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ethernet_cluster_ref: Optional["MacSecParticipantSet.EthernetClusterRef"] = field(
        default=None,
        metadata={
            "name": "ETHERNET-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mka_participants: Optional["MacSecParticipantSet.MkaParticipants"] = field(
        default=None,
        metadata={
            "name": "MKA-PARTICIPANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EthernetClusterRef(Ref):
        dest: EthernetClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MkaParticipants:
        mac_sec_kay_participant: list[MacSecKayParticipant] = field(
            default_factory=list,
            metadata={
                "name": "MAC-SEC-KAY-PARTICIPANT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class McDataInstance:
    """Describes the specific properties of one data instance in order to support
    measurement and/or calibration of this data instance.

    The most important attributes are:
    * Its shortName is copied from the ECU Flat map (if applicable) and will be used as identifier and for display by the MC system.
    * The category is copied from the corresponding data type (ApplicationDataType if defined, otherwise ImplementationDataType) as far as applicable.
    * The symbol is the one used in the programming language. It will be used to find out the actual memory address by the final generation tool with the help of linker generated information.
    It is assumed that in the M1 model this part and all the aggregated and referred elements (with the exception of the Flat Map and the references from ImplementationElementInParameterInstanceRef and McAccessDetails) are completely generated from "upstream" information. This means, that even if an element like e.g. a CompuMethod is only used via reference here, it will be copied into the M1 artifact which holds the complete McSupportData for a given Implementation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar array_size: The existence of this attribute turns the data
        instance into an array of data. The attribute determines the
        size of the array in terms of number of elements.
    :ivar display_identifier: An optional attribute to be used to set
        the ASAM ASAP2 DISPLAY_IDENTIFIER attribute.
    :ivar flat_map_entry_ref: Reference to the corresponding entry in
        the ECU Flat Map. This allows to trace back to the original
        specification of the generated data instance. This link shall be
        added by the RTE generator mainly for documentation purposes.
        The reference is optional because * The McDataInstance may
        represent an array or struct in which only the subElements
        correspond to FlatMap entries. * The McDataInstance may
        represent a task local buffer for rapid prototyping access which
        is different from the "main instance" used for measurement
        access.
    :ivar instance_in_memory: Reference to the corresponding data
        instance in the description of calibration data structures
        published by the RTE generator. This is used to support
        emulation methods inside the ECU, it is not required for A2L
        generation.
    :ivar mc_data_access_details: Refers to "upstream" information on
        how the RTE uses this data instance. Use Case: Rapid Prototyping
    :ivar mc_data_assignments: An assignment between McDataInstances.
        This supports the indication of related McDataElement
        implementing the of „RP global buffer", „RP global measurement
        buffer", „RP enabler flag". This aggregation contains a
        variation point although it is not variant. Therefore, this
        variation point shall not exist in models. See constr_2638.
    :ivar resulting_properties: These are the generated properties
        resulting from decisions taken by the RTE  generator for the
        actually implemented data instance. Only those properties are
        relevant here, which are needed for the measurement and
        calibration system.
    :ivar resulting_rpt_sw_prototyping_access: Describes the implemented
        accessibility of data and modes by the rapid prototyping
        tooling.
    :ivar role: An optional attribute to be used for additional
        information on the role of this data instance, for example in
        the context of rapid prototyping.
    :ivar rpt_impl_policy: Describes the implemented code preparation
        for rapid prototyping at data accesses for a hook based
        bypassing.
    :ivar sub_elements: This relation indicates, that the target element
        is part of a "struct" which is given by the source element. This
        information will be used by the final generator to set up the
        correct addressing scheme.
    :ivar symbol: This String is used to determine the memory address
        during final generation of the MC configuration data (e.g. "A2L"
        file) . It shall be the name of the element in the programming
        language such that it can be identified in linker generated
        information. In case the McDataInstance is part of composite
        data in the programming language, the symbol String may include
        parts denoting the element context, unless the context is given
        by the symbol attribute of an enclosing McDataInstance. This
        means in particular for the C language that the "." character
        shall be used as a separator between the name of a "struct"
        variable the name of one of its elements. The symbol can differ
        from the shortName in case of generated C data declarations. It
        is an optional attribute since it may be missing in case the
        instance represents an element (e.g. a single array element)
        which has no name in the linker map.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        McSupportData.mcParameterInstance Applicable for:
        McDataInstance.subElement Applicable for:
        McSupportData.mcVariableInstance
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MC-DATA-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["McDataInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["McDataInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    array_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ARRAY-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    display_identifier: McdIdentifier | None = field(
        default=None,
        metadata={
            "name": "DISPLAY-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    flat_map_entry_ref: Optional["McDataInstance.FlatMapEntryRef"] = field(
        default=None,
        metadata={
            "name": "FLAT-MAP-ENTRY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    instance_in_memory: ImplementationElementInParameterInstanceRef | None = field(
        default=None,
        metadata={
            "name": "INSTANCE-IN-MEMORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_data_access_details: McDataAccessDetails | None = field(
        default=None,
        metadata={
            "name": "MC-DATA-ACCESS-DETAILS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_data_assignments: Optional["McDataInstance.McDataAssignments"] = field(
        default=None,
        metadata={
            "name": "MC-DATA-ASSIGNMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resulting_properties: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "RESULTING-PROPERTIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resulting_rpt_sw_prototyping_access: RptSwPrototypingAccess | None = field(
        default=None,
        metadata={
            "name": "RESULTING-RPT-SW-PROTOTYPING-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    role: Identifier | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_impl_policy: RptImplPolicy | None = field(
        default=None,
        metadata={
            "name": "RPT-IMPL-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_elements: Optional["McDataInstance.SubElements"] = field(
        default=None,
        metadata={
            "name": "SUB-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol: SymbolString | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FlatMapEntryRef(Ref):
        dest: FlatInstanceDescriptorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class McDataAssignments:
        role_based_mc_data_assignment: list[RoleBasedMcDataAssignment] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-MC-DATA-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubElements:
        mc_data_instance: list["McDataInstance"] = field(
            default_factory=list,
            metadata={
                "name": "MC-DATA-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class McFunctionDataRefSet:
    """Refers to a set of data assigned to an McFunction in a particular role.

    The data are given
    * either by entries in a FlatMap
    * or by data instances that are part of MC support data.
    These two possibilities are exclusive within a given McFunctionDataRefSet. Which one to use depends on the process and tool environment.
    The set is subject to variability because the same functional model may be used with various representation of the data.

    :ivar mc_function_data_ref_set_variants: This element was
        generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MC-FUNCTION-DATA-REF-SET"

    mc_function_data_ref_set_variants: Optional[
        "McFunctionDataRefSet.McFunctionDataRefSetVariants"
    ] = field(
        default=None,
        metadata={
            "name": "MC-FUNCTION-DATA-REF-SET-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class McFunctionDataRefSetVariants:
        mc_function_data_ref_set_conditional: list[McFunctionDataRefSetConditional] = field(
            default_factory=list,
            metadata={
                "name": "MC-FUNCTION-DATA-REF-SET-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class McGroupDataRefSet:
    """Refers to a set of data assigned to an McGroup in a particular role.

    The data are given
    * either by entries in a FlatMap
    * or by data instances that are part of MC support data.
    These two possibilities can be mixed within a given McGroupDataRefSet.
    Which one to use depends on the process and tool environment.
    The set is subject to variability because the same functional model may be used with various representation of the data.

    :ivar mc_group_data_ref_set_variants: This element was
        generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MC-GROUP-DATA-REF-SET"

    mc_group_data_ref_set_variants: Optional["McGroupDataRefSet.McGroupDataRefSetVariants"] = field(
        default=None,
        metadata={
            "name": "MC-GROUP-DATA-REF-SET-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class McGroupDataRefSetVariants:
        mc_group_data_ref_set_conditional: list[McGroupDataRefSetConditional] = field(
            default_factory=list,
            metadata={
                "name": "MC-GROUP-DATA-REF-SET-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class MetaDataItem:
    """
    This meta-class represents a single meta-data item.

    :ivar length: This attribute determines the length of the
        MetaDataItem at run-time.
    :ivar meta_data_item_type: This aggregation contributes the
        specification of the concrete meta-data item type. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "META-DATA-ITEM"

    length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_item_type: TextValueSpecification | None = field(
        default=None,
        metadata={
            "name": "META-DATA-ITEM-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MlFigure:
    """
    This metaclass represents the ability to embed a figure.

    :ivar figure_caption: This element specifies the title of an
        illustration.
    :ivar l_graphic:
    :ivar verbatim: &lt;verbatim&gt; is a paragraph in which white-space
        (in particular blanks and line feeds) is obeyed. This enables
        basic preformatting to be carried out, which can even be
        displayed on simple devices. Behavior is the same as PRE in HTML
        . This aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DocumentationBlock.figure
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    :ivar frame: Used to defined the frame line around a figure. It can
        assume the following values: * TOP - Border at the top of the
        figure * BOTTOM - Border at the bottom of the figure * TOPBOT -
        Borders at the top and bottom of  the figure * ALL - Borders all
        around the figure * SIDES - Borders at the sides of the figure *
        NONE - No borders around the figure
    :ivar help_entry: This specifies an entry point in an online help
        system to be linked with the parent class. The syntax shall be
        defined by the applied help system respectively help system
        generator.
    :ivar pgwide: Used to indicate wether the figure should take the
        complete page width (value = "pgwide") or not (value =
        "noPgwide").
    """

    class Meta:
        name = "ML-FIGURE"

    figure_caption: Caption | None = field(
        default=None,
        metadata={
            "name": "FIGURE-CAPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    l_graphic: list[LGraphic] = field(
        default_factory=list,
        metadata={
            "name": "L-GRAPHIC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: MultiLanguageVerbatim | None = field(
        default=None,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )
    frame: FrameEnumSimple | None = field(
        default=None,
        metadata={
            "name": "FRAME",
            "type": "Attribute",
        },
    )
    help_entry: str | None = field(
        default=None,
        metadata={
            "name": "HELP-ENTRY",
            "type": "Attribute",
        },
    )
    pgwide: PgwideEnumSimple | None = field(
        default=None,
        metadata={
            "name": "PGWIDE",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class MlFormula:
    """This meta-class represents the ability to express a formula in a
    documentation.

    The formula can be expressed by various means. If more than one
    representation is available, they need to be consistent. The
    rendering system can use the representation which is most
    appropriate.

    :ivar formula_caption: This element specifies the identification or
        heading of a formula.
    :ivar l_graphic:
    :ivar verbatim: this represents a formula using only text and white-
        space. It can be used to denote the formula in a kind of pseudo
        code or whatever appears approprate. This aggregation contains a
        variation point although it is not variant. Therefore, this
        variation point shall not exist in models. See constr_2638.
    :ivar tex_math: this is the TeX representation of TeX formula. A TeX
        formula can be processed by a TeX or a LaTeX processor.
    :ivar generic_math: this rpresents the semantic and mathematical
        descriptions which are processed by a math-processor.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DocumentationBlock.formula Not Applicable for:
        EcucConditionSpecification.informalFormula Not Applicable for:
        EcucDerivationSpecification.informalFormula
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    """

    class Meta:
        name = "ML-FORMULA"

    formula_caption: Caption | None = field(
        default=None,
        metadata={
            "name": "FORMULA-CAPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    l_graphic: list[LGraphic] = field(
        default_factory=list,
        metadata={
            "name": "L-GRAPHIC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: MultiLanguageVerbatim | None = field(
        default=None,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tex_math: MultiLanguagePlainText | None = field(
        default=None,
        metadata={
            "name": "TEX-MATH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    generic_math: MultiLanguagePlainText | None = field(
        default=None,
        metadata={
            "name": "GENERIC-MATH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class ModeAccessPoint:
    """A ModeAccessPoint is required by a RunnableEntity owned by a Mode Manager or
    Mode User.

    Its semantics implies the ability to access the current mode
    (provided by the RTE)  of a ModeDeclarationGroupPrototype's
    ModeDeclarationGroup.

    :ivar ident: The aggregation in the role ident provides the ability
        to make the ModeAccessPoint identifiable. From the semantical
        point of view, the ModeAccessPoint is considered a first-class
        Identifiable and therefore the aggregation in the role ident
        shall always exist (until it may be possible to let
        ModeAccessPoint directly inherit from Identifiable).
    :ivar mode_group_iref: The mode declaration group that is accessed
        by this runnable.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RunnableEntity.modeAccessPoint
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-ACCESS-POINT"

    ident: ModeAccessPointIdent | None = field(
        default=None,
        metadata={
            "name": "IDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_group_iref: Optional["ModeAccessPoint.ModeGroupIref"] = field(
        default=None,
        metadata={
            "name": "MODE-GROUP-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ModeGroupIref:
        p_mode_group_in_atomic_swc_instance_ref: PModeGroupInAtomicSwcInstanceRef | None = field(
            default=None,
            metadata={
                "name": "P-MODE-GROUP-IN-ATOMIC-SWC-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        r_mode_group_in_atomic_swc_instance_ref: RModeGroupInAtomicSwcInstanceRef | None = field(
            default=None,
            metadata={
                "name": "R-MODE-GROUP-IN-ATOMIC-SWC-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ModeDeclarationGroup:
    """A collection of Mode Declarations.

    Also, the initial mode is explicitly identified.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar initial_mode_ref: The initial mode of the
        ModeDeclarationGroup. This mode is active before any mode
        switches occurred.
    :ivar mode_declarations: The ModeDeclarations collected in this
        ModeDeclarationGroup.
    :ivar mode_manager_error_behavior: This represents the ability to
        define the error behavior expected by the mode manager in case
        of errors on the mode user side (e.g. terminated mode user).
    :ivar mode_transitions: This represents the avaliable
        ModeTransitions of the ModeDeclarationGroup
    :ivar mode_user_error_behavior: This represents the definition of
        the error behavior expected by the mode user in case of errors
        on the mode manager side (e.g. terminated mode manager).
    :ivar on_transition_value: The value of this attribute shall be
        taken into account by the RTE generator for programmatically
        representing a value used for the transition between two
        statuses.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-DECLARATION-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ModeDeclarationGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ModeDeclarationGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ModeDeclarationGroup.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_mode_ref: Optional["ModeDeclarationGroup.InitialModeRef"] = field(
        default=None,
        metadata={
            "name": "INITIAL-MODE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_declarations: Optional["ModeDeclarationGroup.ModeDeclarations"] = field(
        default=None,
        metadata={
            "name": "MODE-DECLARATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_manager_error_behavior: ModeErrorBehavior | None = field(
        default=None,
        metadata={
            "name": "MODE-MANAGER-ERROR-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_transitions: Optional["ModeDeclarationGroup.ModeTransitions"] = field(
        default=None,
        metadata={
            "name": "MODE-TRANSITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_user_error_behavior: ModeErrorBehavior | None = field(
        default=None,
        metadata={
            "name": "MODE-USER-ERROR-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    on_transition_value: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ON-TRANSITION-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InitialModeRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ModeDeclarations:
        mode_declaration: list[ModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModeTransitions:
        mode_transition: list[ModeTransition] = field(
            default_factory=list,
            metadata={
                "name": "MODE-TRANSITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ModeDeclarationMappingSet:
    """
    This meta-class implements a container for ModeDeclarationGroupMappings.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar mode_declaration_mappings: This represents the collection of
        ModeDeclarationMappings owned by the enclosing
        ModeDeclarationMappingSet.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-DECLARATION-MAPPING-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ModeDeclarationMappingSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ModeDeclarationMappingSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_declaration_mappings: Optional["ModeDeclarationMappingSet.ModeDeclarationMappings"] = (
        field(
            default=None,
            metadata={
                "name": "MODE-DECLARATION-MAPPINGS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModeDeclarationMappings:
        mode_declaration_mapping: list[ModeDeclarationMapping] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ModeSwitchInterface:
    """
    A mode switch interface declares a ModeDeclarationGroupPrototype to be sent and
    received.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar mode_group: The ModeDeclarationGroupPrototype of this mode
        interface. This aggregation contains a variation point although
        it is not variant. Therefore, this variation point shall not
        exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MODE-SWITCH-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ModeSwitchInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ModeSwitchInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ModeSwitchInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["ModeSwitchInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_group: ModeDeclarationGroupPrototype | None = field(
        default=None,
        metadata={
            "name": "MODE-GROUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class MultiplexedIPdu:
    """A MultiplexedPdu (i.e. NOT a COM I-PDU) contains a DynamicPart, an optional
    StaticPart and a selectorField.

    In case of multiplexing this IPdu is routed between the Pdu
    Multiplexer and the Interface Layer. A multiplexer is used to define
    variable parts within an IPdu that may carry different signals. The
    receivers of such a IPdu can determine which signalPdus are
    transmitted by evaluating the selector field, which carries a unique
    selector code for each sub-part.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar has_dynamic_length: This attribute defines whether the Pdu has
        dynamic length (true) or not (false). Please note that the usage
        of this attribute is restricted by [constr_3448].
    :ivar length: Pdu length in bytes. In case of dynamic length IPdus
        (containing a dynamical length signal), this value indicates the
        maximum data length. It should be noted that in former AUTOSAR
        releases (Rel 2.1, Rel 3.0, Rel 3.1, Rel 4.0 Rev. 1) this
        parameter was defined in bits. The Pdu length of zero bytes is
        allowed.
    :ivar meta_data_length: Number of additional bytes of MetaData in
        the PDU data field. The MetaData contains auxiliary information
        for the PDU, e.g. the CAN ID.
    :ivar contained_i_pdu_props: Defines whether this IPdu may be
        collected inside a ContainerIPdu.
    :ivar dynamic_parts: According to the value of the selector field
        some parts of the IPdu have a different layout. In a complete
        System Description a MultiplexedIPdu shall contain a
        DynamicPart. The following use cases support the multiplicity to
        be 0..1: * If a MultiplexedIPdu is received by a Pdu Gateway and
        is not delivered to the IPduM but routed directly to a bus
        interface then the content of the MulitplexedIPdu doesn't need
        to be described in the System Extract/Ecu Extract. * If a
        MultiplexedIPdu is received by an ECU which is only interested
        in the static part of the MultiplexedIPdu then the dynamicPart
        does not need to be described in the System Extract/Ecu Extract.
        atpVariation: Content of a multiplexed PDU can vary. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar selector_field_byte_order: This attribute defines the order of
        the bytes of the selectorField and the packing into the
        MultiplexedIPdu. Please consider that [constr_3247] and
        [constr_3223] are restricting the usage of this attribute. In a
        complete System Description this attribute is mandatory. If a
        MultiplexedPdu is received by a Pdu Gateway and is not delivered
        to the IPduM but routed directly to a bus interface then the
        content of the MulitplexedPdu doesn't need to be described in
        the System Extract/Ecu Extract. To support this use case the
        multiplicity is set to 0..1.
    :ivar selector_field_length: The size in bits of the selector field
        shall be configurable in a range of 1-16 bits. In a complete
        System Description this attribute is mandatory. If a
        MultiplexedPdu is received by a Pdu Gateway and is not delivered
        to the IPduM but routed directly to a bus interface then the
        content of the MulitplexedPdu doesn't need to be described in
        the System Extract/Ecu Extract. To support this use case the
        multiplicity is set to 0..1.
    :ivar selector_field_start_position: This parameter is necessary to
        describe the position of the selector field within the IPdu.
        Note that the absolute position of the selectorField in the
        MultiplexedIPdu is determined by the definition of the
        selectorFieldByteOrder attribute of the Multiplexed Pdu. If Big
        Endian is specified, the start position indicates the bit
        position of the most significant bit in the IPdu. If Little
        Endian is specified, the start position indicates the bit
        position of the least significant bit in the IPdu. In AUTOSAR
        the bit counting is always set to "sawtooth" and the bit order
        is set to "Decreasing". The bit counting in byte 0 starts with
        bit 0 (least significant bit). The most significant bit in byte
        0 is bit 7. In a complete System Description this attribute is
        mandatory. If a MultiplexedPdu is received by a Pdu Gateway and
        is not delivered to the IPduM but routed directly to a bus
        interface then the content of the MulitplexedPdu doesn't need to
        be described in the System Extract/Ecu Extract. To support this
        use case the multiplicity is set to 0..1.
    :ivar static_parts: The static part of the multiplexed IPdu is the
        same regardless of the selector field. The static part is
        optional. atpVariation: Content of a multiplexed PDU can vary.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar trigger_mode: IPduM can be configured to send a transmission
        request for the new multiplexed IPdu to the PDU-Router because
        of the trigger conditions/ modes that are described in the
        TriggerMode enumeration. In a complete System Description this
        attribute is mandatory. If a MultiplexedPdu is received by a Pdu
        Gateway and is not delivered to the IPduM but routed directly to
        a bus interface then the content of the MulitplexedPdu doesn't
        need to be described in the System Extract/Ecu Extract. To
        support this use case the multiplicity is set to 0..1.
    :ivar unused_bit_pattern: AUTOSAR COM and AUTOSAR IPDUM are filling
        not used areas of an IPdu with this bit-pattern. This attribute
        is mandatory to avoid undefined behavior. This byte-pattern will
        be repeated throughout the IPdu. In a complete System
        Description this attribute is mandatory. If a MultiplexedPdu is
        received by a Pdu Gateway and is not delivered to the IPduM but
        routed directly to a bus interface then the content of the
        MulitplexedPdu doesn't need to be described in the System
        Extract/Ecu Extract. To support this use case the multiplicity
        is set to 0..1.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MULTIPLEXED-I-PDU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["MultiplexedIPdu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["MultiplexedIPdu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_dynamic_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-DYNAMIC-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "META-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_i_pdu_props: ContainedIPduProps | None = field(
        default=None,
        metadata={
            "name": "CONTAINED-I-PDU-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_parts: Optional["MultiplexedIPdu.DynamicParts"] = field(
        default=None,
        metadata={
            "name": "DYNAMIC-PARTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    selector_field_byte_order: ByteOrderEnum | None = field(
        default=None,
        metadata={
            "name": "SELECTOR-FIELD-BYTE-ORDER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    selector_field_length: Integer | None = field(
        default=None,
        metadata={
            "name": "SELECTOR-FIELD-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    selector_field_start_position: Integer | None = field(
        default=None,
        metadata={
            "name": "SELECTOR-FIELD-START-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    static_parts: Optional["MultiplexedIPdu.StaticParts"] = field(
        default=None,
        metadata={
            "name": "STATIC-PARTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_mode: TriggerMode | None = field(
        default=None,
        metadata={
            "name": "TRIGGER-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unused_bit_pattern: Integer | None = field(
        default=None,
        metadata={
            "name": "UNUSED-BIT-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DynamicParts:
        dynamic_part: list[DynamicPart] = field(
            default_factory=list,
            metadata={
                "name": "DYNAMIC-PART",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StaticParts:
        static_part: list[StaticPart] = field(
            default_factory=list,
            metadata={
                "name": "STATIC-PART",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class NmPdu:
    """
    Network Management Pdu.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar has_dynamic_length: This attribute defines whether the Pdu has
        dynamic length (true) or not (false). Please note that the usage
        of this attribute is restricted by [constr_3448].
    :ivar length: Pdu length in bytes. In case of dynamic length IPdus
        (containing a dynamical length signal), this value indicates the
        maximum data length. It should be noted that in former AUTOSAR
        releases (Rel 2.1, Rel 3.0, Rel 3.1, Rel 4.0 Rev. 1) this
        parameter was defined in bits. The Pdu length of zero bytes is
        allowed.
    :ivar meta_data_length: Number of additional bytes of MetaData in
        the PDU data field. The MetaData contains auxiliary information
        for the PDU, e.g. the CAN ID.
    :ivar i_signal_to_i_pdu_mappings: This optional aggregation is used
        to describe NmUserData that is transmitted in the NmPdu.  The
        counting of the startPosition starts at the beginning of the
        NmPdu regardless whether Cbv or Nid are used. This aggregation
        contains a variation point although it is not variant.
        Therefore, this variation point shall not exist in models. See
        constr_2638.
    :ivar nm_data_information: Defines if the Pdu contains NM Data. If
        the NmPdu does not aggregate any ISignalToIPduMappings it still
        may contain UserData that is set via Nm_SetUserData(). If the
        ISignalToIPduMapping exists then the nmDataInformation attribute
        shall be ignored.
    :ivar nm_vote_information: Defines if the Pdu contains NM Vote
        information.
    :ivar unused_bit_pattern: AUTOSAR COM is filling not used areas of
        an Pdu with this bit-pattern. This attribute can only be used if
        the nmDataInformation attribute is set to true.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NM-PDU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["NmPdu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["NmPdu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_dynamic_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-DYNAMIC-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "META-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_to_i_pdu_mappings: Optional["NmPdu.ISignalToIPduMappings"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-TO-I-PDU-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_data_information: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-DATA-INFORMATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_vote_information: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-VOTE-INFORMATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unused_bit_pattern: Integer | None = field(
        default=None,
        metadata={
            "name": "UNUSED-BIT-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalToIPduMappings:
        i_signal_to_i_pdu_mapping: list[ISignalToIPduMapping] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-TO-I-PDU-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class OsModuleInstantiation:
    """
    This meta-class defines the attributes for the OS configuration on a specific
    machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar resource_groups: This represents the collection of
        ResourceGroups owned by the enclosing OsModuleImplementation.
    :ivar supported_timer_granularity: This attribute describes the
        supported timer granularity (TimeValue of one tick).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "OS-MODULE-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["OsModuleInstantiation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["OsModuleInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resource_groups: Optional["OsModuleInstantiation.ResourceGroups"] = field(
        default=None,
        metadata={
            "name": "RESOURCE-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    supported_timer_granularity: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SUPPORTED-TIMER-GRANULARITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ResourceGroups:
        resource_group: list[ResourceGroup] = field(
            default_factory=list,
            metadata={
                "name": "RESOURCE-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PduTriggering:
    """The PduTriggering describes on which channel the IPdu is transmitted.

    The Pdu routing by the PduR is only allowed for subclasses of IPdu.
    Depending on its relation to entities such channels and clusters it
    can be unambiguously deduced whether a fan-out is handled by the Pdu
    router or the Bus Interface. If the fan-out is specified between
    different clusters it shall be handled by the Pdu Router. If the
    fan-out is specified between different channels of the same cluster
    it shall be handled by the Bus Interface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar i_pdu_port_refs: References to the IPduPort on every ECU of
        the system which sends and/or receives the I-PDU. References for
        both the sender and the receiver side shall be included when the
        system is completely defined.
    :ivar i_pdu_ref: Reference to the Pdu for which the PduTriggering is
        defined. One I-Pdu can be triggered on different channels (PduR
        fan-out). The Pdu routing by the PduR is only allowed for
        subclasses of IPdu. Nevertheless is the reference to the Pdu
        element necessary since the PduTriggering element is also used
        to specify the sending and receiving connections to EcuPorts.
    :ivar i_signal_triggerings: This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar sec_oc_crypto_mapping_ref: This reference identifies the
        crypto profile applicable to  the usage (send, receive) of the
        also referenced SecuredIPdu. Obviously, this reference is only
        applicable if the Pdutriggering also references a SecuredIPdu in
        the role iPdu.
    :ivar trigger_i_pdu_send_conditions: Defines the trigger for the
        Com_TriggerIPDUSend API call. Only if all defined
        TriggerIPduSendConditions evaluate to true (AND associated) the
        Com_TriggerIPDUSend API shall be called.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        PhysicalChannel.pduTriggering
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PDU-TRIGGERING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PduTriggering.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PduTriggering.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_pdu_port_refs: Optional["PduTriggering.IPduPortRefs"] = field(
        default=None,
        metadata={
            "name": "I-PDU-PORT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_pdu_ref: Optional["PduTriggering.IPduRef"] = field(
        default=None,
        metadata={
            "name": "I-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_triggerings: Optional["PduTriggering.ISignalTriggerings"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sec_oc_crypto_mapping_ref: Optional["PduTriggering.SecOcCryptoMappingRef"] = field(
        default=None,
        metadata={
            "name": "SEC-OC-CRYPTO-MAPPING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_i_pdu_send_conditions: Optional["PduTriggering.TriggerIPduSendConditions"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-I-PDU-SEND-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IPduPortRefs:
        i_pdu_port_ref: list["PduTriggering.IPduPortRefs.IPduPortRef"] = field(
            default_factory=list,
            metadata={
                "name": "I-PDU-PORT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class IPduPortRef(Ref):
            dest: IPduPortSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class IPduRef(Ref):
        dest: PduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalTriggerings:
        i_signal_triggering_ref_conditional: list[ISignalTriggeringRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-TRIGGERING-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecOcCryptoMappingRef(Ref):
        dest: SecOcCryptoServiceMappingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerIPduSendConditions:
        trigger_i_pdu_send_condition: list[TriggerIPduSendCondition] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER-I-PDU-SEND-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PdurIPduGroup:
    """
    The AUTOSAR PduR will enable and disable the sending of configurable groups of
    IPdus during runtime according to the AUTOSAR PduR specification.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_mode: This attribute defines the use-case for
        this PduRIPduGroup. For example, in a diagnostic mode all IPdus
        - which are not involved in diagnostic - are disabled. The use
        cases are not limited to a fixed enumeration and can be
        specified as a string.
    :ivar i_pdus: This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PDUR-I-PDU-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PdurIPduGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PdurIPduGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_mode: String | None = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_pdus: Optional["PdurIPduGroup.IPdus"] = field(
        default=None,
        metadata={
            "name": "I-PDUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IPdus:
        pdu_triggering_ref_conditional: list[PduTriggeringRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PersistencyFileStorage:
    """
    This meta-class comes with the ability to define a collection of single files
    (directory) that creates the deployment-side counterpart to a PortPrototype
    typed by a PersistencyFileStorageInterface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar deployment_uris: This aggregation represents the collection of
        URIs relevant for the enclosing PersistencyDeployment.
    :ivar maximum_allowed_size: The value of this attribute represents
        the maximum size (unit: bytes) allowed at deployment time for
        the enclosing PersistencyDeployment.
    :ivar minimum_sustained_size: The value of this attribute represents
        the minimum size (unit: bytes) guaranteed at deployment time for
        the enclosing PersistencyDeployment.
    :ivar redundancy_handlings: This aggregation represents the chosen
        approaches to handle redundancy.
    :ivar update_strategy: This attribute shall be used to specify the
        update strategy of the respective PersistencyDeployment as a
        whole.
    :ivar version: The attribute represents the version of the
        PersistencyFileStorage or PersistencyKeyValueStorage.
    :ivar files: This aggregation represents the collection of files
        aggregated by the PersistencyFileStorage.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-FILE-STORAGE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PersistencyFileStorage.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PersistencyFileStorage.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    deployment_uris: Optional["PersistencyFileStorage.DeploymentUris"] = field(
        default=None,
        metadata={
            "name": "DEPLOYMENT-URIS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_allowed_size: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-ALLOWED-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_sustained_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-SUSTAINED-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    redundancy_handlings: Optional["PersistencyFileStorage.RedundancyHandlings"] = field(
        default=None,
        metadata={
            "name": "REDUNDANCY-HANDLINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update_strategy: PersistencyCollectionLevelUpdateStrategyEnum | None = field(
        default=None,
        metadata={
            "name": "UPDATE-STRATEGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: StrongRevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    files: Optional["PersistencyFileStorage.Files"] = field(
        default=None,
        metadata={
            "name": "FILES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DeploymentUris:
        persistency_deployment_uri: list[PersistencyDeploymentUri] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-DEPLOYMENT-URI",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RedundancyHandlings:
        persistency_redundancy_crc: list[PersistencyRedundancyCrc] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-REDUNDANCY-CRC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_redundancy_hash: list[PersistencyRedundancyHash] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-REDUNDANCY-HASH",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_redundancy_m_out_of_n: list[PersistencyRedundancyMOutOfN] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-REDUNDANCY-M-OUT-OF-N",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Files:
        persistency_file: list[PersistencyFile] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-FILE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PersistencyFileStorageInterface:
    """
    This meta-class provides the ability to implement a PortInterface for
    supporting persistency use cases for files.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar minimum_sustained_size: The value of this attribute represents
        the minimum size (unit: bytes) required at design time for the
        enclosing PersistencyInterface.
    :ivar redundancy: This attribute represents a requirement towards
        the redundancy of storage.
    :ivar redundancy_handlings: This aggregation represents the chosen
        approaches to handle redundancy for the various use cases
        implemented by subclasses
    :ivar update_strategy: This attribute can be used to specify the
        update strategy of the respective PersistencyInterface as a
        whole.
    :ivar file_elements: This aggregation represents the collection of
        PersistencyFileStorages in the context of the enclosing
        PersistencyFileStorageInterface.
    :ivar max_number_of_files: This attribute represents the definition
        of an upper bound for the handling of files at run-time in the
        context of the enclosing PersistencyFileStorageInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-FILE-STORAGE-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PersistencyFileStorageInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PersistencyFileStorageInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["PersistencyFileStorageInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["PersistencyFileStorageInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_sustained_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-SUSTAINED-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    redundancy: PersistencyRedundancyEnum | None = field(
        default=None,
        metadata={
            "name": "REDUNDANCY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    redundancy_handlings: Optional["PersistencyFileStorageInterface.RedundancyHandlings"] = field(
        default=None,
        metadata={
            "name": "REDUNDANCY-HANDLINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update_strategy: PersistencyCollectionLevelUpdateStrategyEnum | None = field(
        default=None,
        metadata={
            "name": "UPDATE-STRATEGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    file_elements: Optional["PersistencyFileStorageInterface.FileElements"] = field(
        default=None,
        metadata={
            "name": "FILE-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_files: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-FILES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RedundancyHandlings:
        persistency_redundancy_crc: list[PersistencyRedundancyCrc] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-REDUNDANCY-CRC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_redundancy_hash: list[PersistencyRedundancyHash] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-REDUNDANCY-HASH",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_redundancy_m_out_of_n: list[PersistencyRedundancyMOutOfN] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-REDUNDANCY-M-OUT-OF-N",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FileElements:
        persistency_file_element: list[PersistencyFileElement] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-FILE-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PersistencyKeyValueStorageInterface:
    """
    This meta-class provides the ability to implement a PortInterface for
    supporting persistency use cases for data.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar minimum_sustained_size: The value of this attribute represents
        the minimum size (unit: bytes) required at design time for the
        enclosing PersistencyInterface.
    :ivar redundancy: This attribute represents a requirement towards
        the redundancy of storage.
    :ivar redundancy_handlings: This aggregation represents the chosen
        approaches to handle redundancy for the various use cases
        implemented by subclasses
    :ivar update_strategy: This attribute can be used to specify the
        update strategy of the respective PersistencyInterface as a
        whole.
    :ivar data_elements: This aggregation represents the collection of
        PersistencyDataElements in the context of the enclosing
        Persistency KeyValueStorageInterface.
    :ivar data_type_for_serialization_refs: This reference identifies
        the AbstractImplementationData Types that shall be supported for
        storing in a key-value storage in addition to the types already
        determined from tha aggregation of PersistencyDataElement.
    :ivar data_type_mapping: This aggregation provides a collection of
        replacement rules for data types used in the context of the
        enclosing PersistencyKeyValueStorageInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-KEY-VALUE-STORAGE-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PersistencyKeyValueStorageInterface.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PersistencyKeyValueStorageInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["PersistencyKeyValueStorageInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["PersistencyKeyValueStorageInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_sustained_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-SUSTAINED-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    redundancy: PersistencyRedundancyEnum | None = field(
        default=None,
        metadata={
            "name": "REDUNDANCY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    redundancy_handlings: Optional["PersistencyKeyValueStorageInterface.RedundancyHandlings"] = (
        field(
            default=None,
            metadata={
                "name": "REDUNDANCY-HANDLINGS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    update_strategy: PersistencyCollectionLevelUpdateStrategyEnum | None = field(
        default=None,
        metadata={
            "name": "UPDATE-STRATEGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_elements: Optional["PersistencyKeyValueStorageInterface.DataElements"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_type_for_serialization_refs: Optional[
        "PersistencyKeyValueStorageInterface.DataTypeForSerializationRefs"
    ] = field(
        default=None,
        metadata={
            "name": "DATA-TYPE-FOR-SERIALIZATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_type_mapping: PersistencyKeyValueDataTypeMapping | None = field(
        default=None,
        metadata={
            "name": "DATA-TYPE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RedundancyHandlings:
        persistency_redundancy_crc: list[PersistencyRedundancyCrc] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-REDUNDANCY-CRC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_redundancy_hash: list[PersistencyRedundancyHash] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-REDUNDANCY-HASH",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_redundancy_m_out_of_n: list[PersistencyRedundancyMOutOfN] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-REDUNDANCY-M-OUT-OF-N",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataElements:
        persistency_data_element: list[PersistencyDataElement] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-DATA-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataTypeForSerializationRefs:
        data_type_for_serialization_ref: list[
            "PersistencyKeyValueStorageInterface.DataTypeForSerializationRefs.DataTypeForSerializationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DATA-TYPE-FOR-SERIALIZATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DataTypeForSerializationRef(Ref):
            dest: AbstractImplementationDataTypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class PhmHealthChannelInterface:
    """
    This meta-class provides the ability to implement a PortInterface for
    interaction with the Platform Health Management Health Channel.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar statuss: Defines the possible set of status information
        available to the health channel.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PHM-HEALTH-CHANNEL-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PhmHealthChannelInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PhmHealthChannelInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["PhmHealthChannelInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["PhmHealthChannelInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    statuss: Optional["PhmHealthChannelInterface.Statuss"] = field(
        default=None,
        metadata={
            "name": "STATUSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Statuss:
        phm_health_channel_status: list[PhmHealthChannelStatus] = field(
            default_factory=list,
            metadata={
                "name": "PHM-HEALTH-CHANNEL-STATUS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PhmSupervisedEntityInterface:
    """
    This meta-class provides the ability to implement a PortInterface for
    interaction with the Platform Health Management Supervised Entity.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar checkpoints: Defines the set of checkpoints which can be
        reported on this supervised entity.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PHM-SUPERVISED-ENTITY-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PhmSupervisedEntityInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PhmSupervisedEntityInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["PhmSupervisedEntityInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["PhmSupervisedEntityInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    checkpoints: Optional["PhmSupervisedEntityInterface.Checkpoints"] = field(
        default=None,
        metadata={
            "name": "CHECKPOINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Checkpoints:
        phm_checkpoint: list[PhmCheckpoint] = field(
            default_factory=list,
            metadata={
                "name": "PHM-CHECKPOINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PncMapping:
    """'''begin restrict to CP''' Describes a mapping between one or several
    Virtual Function Clusters onto Partial Network Clusters.

    A Virtual Function Cluster is realized by a PortGroup. A Partial
    Network Cluster is realized by one or more IPduGroups. '''end
    restrict to CP''' '''begin restrict to AP''' Describes a mapping
    between one or several Virtual Function Clusters onto Partial
    Network Clusters. A Virtual Function Cluster is realized by a
    PortGroup. A Partial Network Cluster is realized by one or more
    ServiceInstances. '''end restrict to AP'''

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar dynamic_pnc_mapping_pdu_group_refs: Reference to an
        ISignalIPduGroup that allows mapping of this PNC without
        statically mapping this PNC directly to a channel. This is
        needed to describe dynamic PNCs that can be learned only at run-
        time and which have also a relation to an ISignalIPduGroup.
    :ivar ident: This adds the ability to become referrable to
        PncMapping.
    :ivar physical_channel_refs: This reference maps the partial network
        to a communication channel.
    :ivar pnc_consumed_provided_service_instance_groups:
        ConsumedProvidedServiceInstanceGroup used in a Partial Network
        Cluster. This reference is optional, since this could be used
        for starting and stopping ConsumedProvidedServiceInstanceGroup
        according the requested partial network, but is not necessarily
        needed. This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar pnc_group_refs: IPduGroup participating in a Partial Network
        Cluster. This reference is optional in case an ecu extract has
        only indirect pnc access, i.e. ecu is not directly connected to
        a network which supports partial network.
    :ivar pnc_identifier: Identifer of the Partial Network Cluster. This
        number represents the absolute bit position of this Partial
        Network Cluster in the NM Pdu.
    :ivar pnc_pdur_group_refs: This reference maps the Partial Network
        Cluster to a set of PdurIpduGroups.
    :ivar pnc_wakeup_enable: If this parameter is available and set to
        true then this PNC will be woken up as soon as a channel wakeup
        occurs on a channel where this PNC is assigned to. This is
        ensured by adding this PNC to the corresponding channel wakeup
        sources during upstream mapping.
    :ivar relevant_for_dynamic_pnc_mapping_refs: Reference to a PNC
        Gateway ECU for PNCs which do not have a static channel mapping.
        This is needed to describe dynamic PNCs that can be learned only
        at run-time and which have no relation to an ISignalIPduGroup.
    :ivar service_instance_refs: Reference to ServiceInstances that are
        participating in a Partial Network Cluster.
    :ivar short_label: This attribute specifies an identifying shortName
        for the PncMapping. It shall be unique in the System scope.
    :ivar vfc_irefs: Virtual Function Cluster to be mapped onto a
        Partial Network Cluster. This reference is optional in case that
        the System Description doesn't use a complete Software Component
        Description (VFB View). This supports the inclusion of legacy
        systems.
    :ivar wakeup_frame_refs: Reference to collection of FrameTriggerings
        that are used for the wakeup of this PNC (Application Frames or
        Nm Frames can be used). This reference is only valid if this
        EcuExtract represents an ECU which has direct PNC access, i.e.
        ECU is directly connected to a network which supports partial
        network.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.pncMapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PNC-MAPPING"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_pnc_mapping_pdu_group_refs: Optional["PncMapping.DynamicPncMappingPduGroupRefs"] = (
        field(
            default=None,
            metadata={
                "name": "DYNAMIC-PNC-MAPPING-PDU-GROUP-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    ident: PncMappingIdent | None = field(
        default=None,
        metadata={
            "name": "IDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_channel_refs: Optional["PncMapping.PhysicalChannelRefs"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNEL-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_consumed_provided_service_instance_groups: Optional[
        "PncMapping.PncConsumedProvidedServiceInstanceGroups"
    ] = field(
        default=None,
        metadata={
            "name": "PNC-CONSUMED-PROVIDED-SERVICE-INSTANCE-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_group_refs: Optional["PncMapping.PncGroupRefs"] = field(
        default=None,
        metadata={
            "name": "PNC-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_identifier: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PNC-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_pdur_group_refs: Optional["PncMapping.PncPdurGroupRefs"] = field(
        default=None,
        metadata={
            "name": "PNC-PDUR-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_wakeup_enable: Boolean | None = field(
        default=None,
        metadata={
            "name": "PNC-WAKEUP-ENABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    relevant_for_dynamic_pnc_mapping_refs: Optional[
        "PncMapping.RelevantForDynamicPncMappingRefs"
    ] = field(
        default=None,
        metadata={
            "name": "RELEVANT-FOR-DYNAMIC-PNC-MAPPING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_refs: Optional["PncMapping.ServiceInstanceRefs"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vfc_irefs: Optional["PncMapping.VfcIrefs"] = field(
        default=None,
        metadata={
            "name": "VFC-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_frame_refs: Optional["PncMapping.WakeupFrameRefs"] = field(
        default=None,
        metadata={
            "name": "WAKEUP-FRAME-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DynamicPncMappingPduGroupRefs:
        dynamic_pnc_mapping_pdu_group_ref: list[
            "PncMapping.DynamicPncMappingPduGroupRefs.DynamicPncMappingPduGroupRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DYNAMIC-PNC-MAPPING-PDU-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DynamicPncMappingPduGroupRef(Ref):
            dest: ISignalIPduGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannelRefs:
        physical_channel_ref: list["PncMapping.PhysicalChannelRefs.PhysicalChannelRef"] = field(
            default_factory=list,
            metadata={
                "name": "PHYSICAL-CHANNEL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PhysicalChannelRef(Ref):
            dest: PhysicalChannelSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PncConsumedProvidedServiceInstanceGroups:
        consumed_provided_service_instance_group_ref_conditional: list[
            ConsumedProvidedServiceInstanceGroupRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONSUMED-PROVIDED-SERVICE-INSTANCE-GROUP-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PncGroupRefs:
        pnc_group_ref: list["PncMapping.PncGroupRefs.PncGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "PNC-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PncGroupRef(Ref):
            dest: ISignalIPduGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PncPdurGroupRefs:
        pnc_pdur_group_ref: list["PncMapping.PncPdurGroupRefs.PncPdurGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "PNC-PDUR-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PncPdurGroupRef(Ref):
            dest: PdurIPduGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RelevantForDynamicPncMappingRefs:
        relevant_for_dynamic_pnc_mapping_ref: list[
            "PncMapping.RelevantForDynamicPncMappingRefs.RelevantForDynamicPncMappingRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "RELEVANT-FOR-DYNAMIC-PNC-MAPPING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RelevantForDynamicPncMappingRef(Ref):
            dest: EcuInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRefs:
        service_instance_ref: list["PncMapping.ServiceInstanceRefs.ServiceInstanceRef"] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceInstanceRef(Ref):
            dest: AdaptivePlatformServiceInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class VfcIrefs:
        vfc_iref: list[PortGroupInSystemInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "VFC-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class WakeupFrameRefs:
        wakeup_frame_ref: list["PncMapping.WakeupFrameRefs.WakeupFrameRef"] = field(
            default_factory=list,
            metadata={
                "name": "WAKEUP-FRAME-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class WakeupFrameRef(Ref):
            dest: FrameTriggeringSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class PortGroup:
    """Group of ports which share a common functionality '''begin restrict to CP
    AP''' , e.g. need specific network resources.

    This information shall be available on the VFB level in order to
    delegate it properly via compositions. When propagated into the ECU
    extract, this information is used as input for the configuration of
    Services like the Communication Manager. '''end restrict to CP AP'''
    '''begin restrict to FO''' . '''end restrict to FO''' A PortGroup is
    defined locally in a component (which can be a composition) and
    refers to the "outer" ports belonging to the group as well as to the
    "inner" groups which propagate  this group into the components which
    are part of a composition. A PortGroup within an atomic SWC cannot
    be linked to inner groups.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar inner_group_irefs: Links a PortGroup in a composition to
        another PortGroup, that is defined in a component which is part
        of this CompositionSwComponentType.
    :ivar outer_ports: Outer PortPrototype of this AtomicSwComponentType
        which belongs to the group. A port can belong to several groups
        or to no group at all. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwComponentType.portGroup
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PortGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PortGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    inner_group_irefs: Optional["PortGroup.InnerGroupIrefs"] = field(
        default=None,
        metadata={
            "name": "INNER-GROUP-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    outer_ports: Optional["PortGroup.OuterPorts"] = field(
        default=None,
        metadata={
            "name": "OUTER-PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InnerGroupIrefs:
        inner_group_iref: list[InnerPortGroupInCompositionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "INNER-GROUP-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class OuterPorts:
        port_prototype_ref_conditional: list[PortPrototypeRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "PORT-PROTOTYPE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Prms:
    """This metaclass represents the ability to specify a parameter table.

    It can be used e.g. to specify parameter tables in a data sheet.

    :ivar label: This represents the caption of the parameter table.
    :ivar prm: This represents one particular parameter in the table.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    """

    class Meta:
        name = "PRMS"

    label: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prm: list[GeneralParameter] = field(
        default_factory=list,
        metadata={
            "name": "PRM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class ProcessDesign:
    """This meta-class has the ability to stand in for a Process at the time when
    the Process does not yet exist.

    But its future existence already needs to be considered during
    design phase and for that a dedicated model element is required..

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar deterministic_client_resource_needss: This aggregation
        represents the collection of applicable resource needs for the
        design of deterministic clients.
    :ivar executable_refs: Reference to executable that is executed in
        the process.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROCESS-DESIGN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ProcessDesign.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ProcessDesign.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    deterministic_client_resource_needss: Optional[
        "ProcessDesign.DeterministicClientResourceNeedss"
    ] = field(
        default=None,
        metadata={
            "name": "DETERMINISTIC-CLIENT-RESOURCE-NEEDSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    executable_refs: Optional["ProcessDesign.ExecutableRefs"] = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DeterministicClientResourceNeedss:
        deterministic_client_resource_needs: list[DeterministicClientResourceNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DETERMINISTIC-CLIENT-RESOURCE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutableRefs:
        executable_ref: list["ProcessDesign.ExecutableRefs.ExecutableRef"] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTABLE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ExecutableRef(Ref):
            dest: ExecutableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class ProcessToMachineMappingSet:
    """
    This meta-class acts as a bucket for collecting ProcessToMachineMappings.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar process_to_machine_mappings: This represents the collection of
        ProcessToMachineMappings of the enclosing
        ProcessToMachineMappingSet.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROCESS-TO-MACHINE-MAPPING-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ProcessToMachineMappingSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ProcessToMachineMappingSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_to_machine_mappings: Optional["ProcessToMachineMappingSet.ProcessToMachineMappings"] = (
        field(
            default=None,
            metadata={
                "name": "PROCESS-TO-MACHINE-MAPPINGS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessToMachineMappings:
        process_to_machine_mapping: list[ProcessToMachineMapping] = field(
            default_factory=list,
            metadata={
                "name": "PROCESS-TO-MACHINE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Processor:
    """
    This represents a processor for the execution of an AUTOSAR adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar cores: This represents the collection of cores owned by the
        enclosing processor.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROCESSOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Processor.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Processor.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cores: Optional["Processor.Cores"] = field(
        default=None,
        metadata={
            "name": "CORES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Cores:
        processor_core: list[ProcessorCore] = field(
            default_factory=list,
            metadata={
                "name": "PROCESSOR-CORE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ProvidedSomeipServiceInstance:
    """
    This meta-class represents the ability to describe the existence and
    configuration of a provided service instance in a concrete implementation on
    top of SOME/IP.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar e_2_e_event_protection_propss: This aggregation allows to
        protect an event or a field notifier that is defined inside of
        the ServiceInterface that is referenced by the ServiceInstance
        in the role serviceInterface.
    :ivar e_2_e_method_protection_propss: This aggregation allows to
        protect a method or a field getter or a field setter that is
        defined inside of the ServiceInterface that is referenced by the
        ServiceInstance in the role serviceInterface
    :ivar secure_com_configs: Configuration settings to secure the
        communication of ServiceInterface elements.
    :ivar service_interface_deployment_ref: Reference to a
        ServiceInterfaceDeployment that identifies the ServiceInterface
        that is represented by the ServiceInstance.
    :ivar capability_records: A sequence of records to store arbitrary
        name/value pairs conveying additional information about the
        named service. This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar event_propss: Configuration settings for individual events
        that are provided by the ServiceInstance.
    :ivar load_balancing_priority: This attribute is used to specify the
        priority in the load balancing option of SOME/IP that is added
        to the OfferService. When a client searches for all service
        instances of a service, the client shall choose the service
        instance with highest priority if one is defined.
    :ivar load_balancing_weight: This attribute is used to specify the
        weight in the load balancing option of SOME/IP that is added to
        the OfferService. When a client searches for all service
        instances of a service, the client shall choose the service
        instance with highest priority if one is defined. If several
        service instances exist with the highest priority the service
        instance shall be chosen based on the weights of the service
        instances.
    :ivar method_response_propss: Configuration settings for individual
        methods that are provided by the ServiceInstance.
    :ivar priority: This attribute defines the VLAN frame priority for
        SOME/IP messages  that are resulting from this
        ProvidedSomeipServiceInstance (Method and Event communication).
        Values from 0 (best effort) to 7 (highest) are allowed.
    :ivar provided_event_groups: List of EventGroups that are provided
        by the Service Instance.
    :ivar sd_server_config_ref: Server specific configuration settings
        relevant for the SOME/IP service discovery.
    :ivar service_instance_id: Identification number that is used by
        SOME/IP service discovery to identify the instance of the
        service. The value 65535 for service instance id is reserved and
        should not be used.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROVIDED-SOMEIP-SERVICE-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ProvidedSomeipServiceInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ProvidedSomeipServiceInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_event_protection_propss: Optional[
        "ProvidedSomeipServiceInstance.E2EEventProtectionPropss"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-EVENT-PROTECTION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_method_protection_propss: Optional[
        "ProvidedSomeipServiceInstance.E2EMethodProtectionPropss"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-METHOD-PROTECTION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_com_configs: Optional["ProvidedSomeipServiceInstance.SecureComConfigs"] = field(
        default=None,
        metadata={
            "name": "SECURE-COM-CONFIGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_deployment_ref: Optional[
        "ProvidedSomeipServiceInstance.ServiceInterfaceDeploymentRef"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-DEPLOYMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    capability_records: Optional["ProvidedSomeipServiceInstance.CapabilityRecords"] = field(
        default=None,
        metadata={
            "name": "CAPABILITY-RECORDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_propss: Optional["ProvidedSomeipServiceInstance.EventPropss"] = field(
        default=None,
        metadata={
            "name": "EVENT-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    load_balancing_priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOAD-BALANCING-PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    load_balancing_weight: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOAD-BALANCING-WEIGHT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_response_propss: Optional["ProvidedSomeipServiceInstance.MethodResponsePropss"] = field(
        default=None,
        metadata={
            "name": "METHOD-RESPONSE-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_event_groups: Optional["ProvidedSomeipServiceInstance.ProvidedEventGroups"] = field(
        default=None,
        metadata={
            "name": "PROVIDED-EVENT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sd_server_config_ref: Optional["ProvidedSomeipServiceInstance.SdServerConfigRef"] = field(
        default=None,
        metadata={
            "name": "SD-SERVER-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EEventProtectionPropss:
        end_2_end_event_protection_props: list[End2EndEventProtectionProps] = field(
            default_factory=list,
            metadata={
                "name": "END-2-END-EVENT-PROTECTION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EMethodProtectionPropss:
        end_2_end_method_protection_props: list[End2EndMethodProtectionProps] = field(
            default_factory=list,
            metadata={
                "name": "END-2-END-METHOD-PROTECTION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecureComConfigs:
        service_interface_element_secure_com_config: list[
            ServiceInterfaceElementSecureComConfig
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE-ELEMENT-SECURE-COM-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInterfaceDeploymentRef(Ref):
        dest: ServiceInterfaceDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CapabilityRecords:
        tag_with_optional_value: list[TagWithOptionalValue] = field(
            default_factory=list,
            metadata={
                "name": "TAG-WITH-OPTIONAL-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventPropss:
        someip_event_props: list[SomeipEventProps] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-EVENT-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MethodResponsePropss:
        someip_method_props: list[SomeipMethodProps] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-METHOD-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedEventGroups:
        someip_provided_event_group: list[SomeipProvidedEventGroup] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-PROVIDED-EVENT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SdServerConfigRef(Ref):
        dest: SomeipSdServerServiceInstanceConfigSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ProvidedUserDefinedServiceInstance:
    """
    This meta-class represents the ability to describe the existence and
    configuration of a provided service instance in a concrete implementation that
    is not standardized by AUTOSAR.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar e_2_e_event_protection_propss: This aggregation allows to
        protect an event or a field notifier that is defined inside of
        the ServiceInterface that is referenced by the ServiceInstance
        in the role serviceInterface.
    :ivar e_2_e_method_protection_propss: This aggregation allows to
        protect a method or a field getter or a field setter that is
        defined inside of the ServiceInterface that is referenced by the
        ServiceInstance in the role serviceInterface
    :ivar secure_com_configs: Configuration settings to secure the
        communication of ServiceInterface elements.
    :ivar service_interface_deployment_ref: Reference to a
        ServiceInterfaceDeployment that identifies the ServiceInterface
        that is represented by the ServiceInstance.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROVIDED-USER-DEFINED-SERVICE-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ProvidedUserDefinedServiceInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ProvidedUserDefinedServiceInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_event_protection_propss: Optional[
        "ProvidedUserDefinedServiceInstance.E2EEventProtectionPropss"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-EVENT-PROTECTION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_method_protection_propss: Optional[
        "ProvidedUserDefinedServiceInstance.E2EMethodProtectionPropss"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-METHOD-PROTECTION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_com_configs: Optional["ProvidedUserDefinedServiceInstance.SecureComConfigs"] = field(
        default=None,
        metadata={
            "name": "SECURE-COM-CONFIGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_deployment_ref: Optional[
        "ProvidedUserDefinedServiceInstance.ServiceInterfaceDeploymentRef"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-DEPLOYMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EEventProtectionPropss:
        end_2_end_event_protection_props: list[End2EndEventProtectionProps] = field(
            default_factory=list,
            metadata={
                "name": "END-2-END-EVENT-PROTECTION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EMethodProtectionPropss:
        end_2_end_method_protection_props: list[End2EndMethodProtectionProps] = field(
            default_factory=list,
            metadata={
                "name": "END-2-END-METHOD-PROTECTION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecureComConfigs:
        service_interface_element_secure_com_config: list[
            ServiceInterfaceElementSecureComConfig
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE-ELEMENT-SECURE-COM-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInterfaceDeploymentRef(Ref):
        dest: ServiceInterfaceDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class QueuedReceiverComSpec:
    """
    Communication attributes specific to queued receiving.

    :ivar composite_network_representations: This represents a
        CompositeNetworkRepresentation defined in the context of a
        ReceiverComSpec. The purpose of this aggregation is to be able
        to specify the network representation of leaf elements of
        ApplicationCompositeDataTypes.
    :ivar data_element_ref: Data element these attributes belong to.
    :ivar data_update_period: This attribute defines the period in which
        the application shall check for updated data. This attribute is
        used for the configuration of the E2E protection, but may also
        indicate a general data reception period.
    :ivar external_replacement_ref: This reference is used to reference
        the AutosarDataPrototype to be taken for sourcing an external
        replacement in the out-of-range handling.
    :ivar handle_out_of_range: This attribute controls how values that
        are out of the specified range are handled according to the
        values of HandleOutOfRangeEnum.
    :ivar handle_out_of_range_status: Control the way how return values
        are created in case of an out-of-range situation.
    :ivar max_delta_counter_init: Initial maximum allowed gap between
        two counter values of two consecutively received valid Data,
        i.e. how many subsequent lost data is accepted. For example, if
        the receiver gets Data with counter 1 and MaxDeltaCounterInit is
        1, then at the next reception the receiver can accept Counters
        with values 2 and 3, but not 4. Note that if the receiver does
        not receive new Data at a consecutive read, then the receiver
        increments the tolerance by 1. Caveat: The E2E wrapper approach
        involves technologies that are not subjected to the AUTOSAR
        standard and is superseded by the superior E2E transformer
        approach (which is fully standardized by AUTOSAR). Hence, new
        projects (without legacy constraints due to carry-over parts)
        shall use the fully standardized E2E transformer approach.
    :ivar max_no_new_or_repeated_data: The maximum amount of missing or
        repeated Data which the receiver does not expect to exceed under
        normal communication conditions. Caveat: The E2E wrapper
        approach involves technologies that are not subjected to the
        AUTOSAR standard and is superseded by the superior E2E
        transformer approach (which is fully standardized by AUTOSAR).
        Hence, new projects (without legacy constraints due to carry-
        over parts) shall use the fully standardized E2E transformer
        approach.
    :ivar network_representation: A networkRepresentation is used to
        define how the dataElement is mapped to a communication bus.
    :ivar receiver_intent: This attribute represents the expressed
        intent of the receiver. The receiver may decide to claim that
        existing resources of a ServiceInterface are expressly not used
        by this specific receiver. The conceptual background of this
        claim may be driven by security, safety, etc.
    :ivar reception_props: "This aggregation represents the definition
        transmission props in the context of the enclosing
        ReceiverComSpec.
    :ivar replace_with: This aggregation is used to identify the
        AutosarDataPrototype to be taken for sourcing an external
        replacement in the out-of-range and invalidValue handling. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar sync_counter_init: Number of Data required for validating the
        consistency of the counter that shall be received with a valid
        counter (i.e. counter within the allowed lock-in range) after
        the detection of an unexpected behavior of a received counter.
        Caveat: The E2E wrapper approach involves technologies that are
        not subjected to the AUTOSAR standard and is superseded by the
        superior E2E transformer approach (which is fully standardized
        by AUTOSAR). Hence, new projects (without legacy constraints due
        to carry-over parts) shall use the fully standardized E2E
        transformer approach.
    :ivar transformation_com_spec_propss: This references the
        TransformationComSpecProps which define  port-specific
        configuration for data transformation.
    :ivar uses_end_to_end_protection: This indicates whether the
        corresponding dataElement shall be transmitted using end-to-end
        protection. Caveat: The E2E wrapper approach involves
        technologies that are not subjected to the AUTOSAR standard and
        is superseded by the superior E2E transformer approach (which is
        fully standardized by AUTOSAR). Hence, new projects (without
        legacy constraints due to carry-over parts) shall use the fully
        standardized E2E transformer approach.
    :ivar queue_length: Length of queue for received events.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "QUEUED-RECEIVER-COM-SPEC"

    composite_network_representations: Optional[
        "QueuedReceiverComSpec.CompositeNetworkRepresentations"
    ] = field(
        default=None,
        metadata={
            "name": "COMPOSITE-NETWORK-REPRESENTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["QueuedReceiverComSpec.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_update_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DATA-UPDATE-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    external_replacement_ref: Optional["QueuedReceiverComSpec.ExternalReplacementRef"] = field(
        default=None,
        metadata={
            "name": "EXTERNAL-REPLACEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    handle_out_of_range: HandleOutOfRangeEnum | None = field(
        default=None,
        metadata={
            "name": "HANDLE-OUT-OF-RANGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    handle_out_of_range_status: HandleOutOfRangeStatusEnum | None = field(
        default=None,
        metadata={
            "name": "HANDLE-OUT-OF-RANGE-STATUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_delta_counter_init: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "MAX-DELTA-COUNTER-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_no_new_or_repeated_data: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NO-NEW-OR-REPEATED-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_representation: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "NETWORK-REPRESENTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    receiver_intent: ReceiverIntentEnum | None = field(
        default=None,
        metadata={
            "name": "RECEIVER-INTENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reception_props: ReceptionComSpecProps | None = field(
        default=None,
        metadata={
            "name": "RECEPTION-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    replace_with: VariableAccess | None = field(
        default=None,
        metadata={
            "name": "REPLACE-WITH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_counter_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SYNC-COUNTER-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformation_com_spec_propss: Optional[
        "QueuedReceiverComSpec.TransformationComSpecPropss"
    ] = field(
        default=None,
        metadata={
            "name": "TRANSFORMATION-COM-SPEC-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uses_end_to_end_protection: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "USES-END-TO-END-PROTECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    queue_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "QUEUE-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CompositeNetworkRepresentations:
        composite_network_representation: list[CompositeNetworkRepresentation] = field(
            default_factory=list,
            metadata={
                "name": "COMPOSITE-NETWORK-REPRESENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ExternalReplacementRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TransformationComSpecPropss:
        end_to_end_transformation_com_spec_props: list[EndToEndTransformationComSpecProps] = field(
            default_factory=list,
            metadata={
                "name": "END-TO-END-TRANSFORMATION-COM-SPEC-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_transformation_com_spec_props: list[UserDefinedTransformationComSpecProps] = (
            field(
                default_factory=list,
                metadata={
                    "name": "USER-DEFINED-TRANSFORMATION-COM-SPEC-PROPS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class RequiredSomeipServiceInstance:
    """
    This meta-class represents the ability to describe the existence and
    configuration of a required service instance in a concrete implementation on
    top of SOME/IP.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar e_2_e_event_protection_propss: This aggregation allows to
        protect an event or a field notifier that is defined inside of
        the ServiceInterface that is referenced by the ServiceInstance
        in the role serviceInterface.
    :ivar e_2_e_method_protection_propss: This aggregation allows to
        protect a method or a field getter or a field setter that is
        defined inside of the ServiceInterface that is referenced by the
        ServiceInstance in the role serviceInterface
    :ivar secure_com_configs: Configuration settings to secure the
        communication of ServiceInterface elements.
    :ivar service_interface_deployment_ref: Reference to a
        ServiceInterfaceDeployment that identifies the ServiceInterface
        that is represented by the ServiceInstance.
    :ivar blocklisted_versions: Collection of blocklisted versions.
    :ivar capability_records: A sequence of records to store arbitrary
        name/value pairs conveying additional information about the
        named service. This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar method_request_propss: Configuration settings for individual
        methods that are requested by the ServiceInstance.
    :ivar required_event_groups: List of EventGroups that are used by
        the RequiredServiceInstance.
    :ivar required_minor_version: This attribute is used to configure
        for which minor version of the SomeIp ServiceInterface the
        Service Discovery will search. Value can be set to a number that
        represents the Minor Version of the searched service or to ANY.
    :ivar required_service_instance_id: This attribute represents the
        ability to describe the required service instance ID.
    :ivar sd_client_config_ref: Client specific configuration settings
        relevant for the SOME/IP service discovery.
    :ivar version_driven_find_behavior: Defines the service discovery
        find behavior.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REQUIRED-SOMEIP-SERVICE-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RequiredSomeipServiceInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RequiredSomeipServiceInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_event_protection_propss: Optional[
        "RequiredSomeipServiceInstance.E2EEventProtectionPropss"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-EVENT-PROTECTION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_method_protection_propss: Optional[
        "RequiredSomeipServiceInstance.E2EMethodProtectionPropss"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-METHOD-PROTECTION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_com_configs: Optional["RequiredSomeipServiceInstance.SecureComConfigs"] = field(
        default=None,
        metadata={
            "name": "SECURE-COM-CONFIGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_deployment_ref: Optional[
        "RequiredSomeipServiceInstance.ServiceInterfaceDeploymentRef"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-DEPLOYMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blocklisted_versions: Optional["RequiredSomeipServiceInstance.BlocklistedVersions"] = field(
        default=None,
        metadata={
            "name": "BLOCKLISTED-VERSIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    capability_records: Optional["RequiredSomeipServiceInstance.CapabilityRecords"] = field(
        default=None,
        metadata={
            "name": "CAPABILITY-RECORDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_request_propss: Optional["RequiredSomeipServiceInstance.MethodRequestPropss"] = field(
        default=None,
        metadata={
            "name": "METHOD-REQUEST-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_event_groups: Optional["RequiredSomeipServiceInstance.RequiredEventGroups"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-EVENT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_minor_version: AnyVersionString | None = field(
        default=None,
        metadata={
            "name": "REQUIRED-MINOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_service_instance_id: AnyServiceInstanceId | None = field(
        default=None,
        metadata={
            "name": "REQUIRED-SERVICE-INSTANCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sd_client_config_ref: Optional["RequiredSomeipServiceInstance.SdClientConfigRef"] = field(
        default=None,
        metadata={
            "name": "SD-CLIENT-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version_driven_find_behavior: ServiceVersionAcceptanceKindEnum | None = field(
        default=None,
        metadata={
            "name": "VERSION-DRIVEN-FIND-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EEventProtectionPropss:
        end_2_end_event_protection_props: list[End2EndEventProtectionProps] = field(
            default_factory=list,
            metadata={
                "name": "END-2-END-EVENT-PROTECTION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EMethodProtectionPropss:
        end_2_end_method_protection_props: list[End2EndMethodProtectionProps] = field(
            default_factory=list,
            metadata={
                "name": "END-2-END-METHOD-PROTECTION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecureComConfigs:
        service_interface_element_secure_com_config: list[
            ServiceInterfaceElementSecureComConfig
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE-ELEMENT-SECURE-COM-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInterfaceDeploymentRef(Ref):
        dest: ServiceInterfaceDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class BlocklistedVersions:
        someip_service_version: list[SomeipServiceVersion] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-SERVICE-VERSION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CapabilityRecords:
        tag_with_optional_value: list[TagWithOptionalValue] = field(
            default_factory=list,
            metadata={
                "name": "TAG-WITH-OPTIONAL-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MethodRequestPropss:
        someip_method_props: list[SomeipMethodProps] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-METHOD-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredEventGroups:
        someip_required_event_group: list[SomeipRequiredEventGroup] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-REQUIRED-EVENT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SdClientConfigRef(Ref):
        dest: SomeipSdClientServiceInstanceConfigSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RequiredUserDefinedServiceInstance:
    """
    This meta-class represents the ability to describe the existence and
    configuration of a required service instance in a concrete implementation that
    is not standardized by AUTOSAR.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar e_2_e_event_protection_propss: This aggregation allows to
        protect an event or a field notifier that is defined inside of
        the ServiceInterface that is referenced by the ServiceInstance
        in the role serviceInterface.
    :ivar e_2_e_method_protection_propss: This aggregation allows to
        protect a method or a field getter or a field setter that is
        defined inside of the ServiceInterface that is referenced by the
        ServiceInstance in the role serviceInterface
    :ivar secure_com_configs: Configuration settings to secure the
        communication of ServiceInterface elements.
    :ivar service_interface_deployment_ref: Reference to a
        ServiceInterfaceDeployment that identifies the ServiceInterface
        that is represented by the ServiceInstance.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REQUIRED-USER-DEFINED-SERVICE-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RequiredUserDefinedServiceInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RequiredUserDefinedServiceInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_event_protection_propss: Optional[
        "RequiredUserDefinedServiceInstance.E2EEventProtectionPropss"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-EVENT-PROTECTION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    e_2_e_method_protection_propss: Optional[
        "RequiredUserDefinedServiceInstance.E2EMethodProtectionPropss"
    ] = field(
        default=None,
        metadata={
            "name": "E-2-E-METHOD-PROTECTION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_com_configs: Optional["RequiredUserDefinedServiceInstance.SecureComConfigs"] = field(
        default=None,
        metadata={
            "name": "SECURE-COM-CONFIGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_deployment_ref: Optional[
        "RequiredUserDefinedServiceInstance.ServiceInterfaceDeploymentRef"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-DEPLOYMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EEventProtectionPropss:
        end_2_end_event_protection_props: list[End2EndEventProtectionProps] = field(
            default_factory=list,
            metadata={
                "name": "END-2-END-EVENT-PROTECTION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class E2EMethodProtectionPropss:
        end_2_end_method_protection_props: list[End2EndMethodProtectionProps] = field(
            default_factory=list,
            metadata={
                "name": "END-2-END-METHOD-PROTECTION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecureComConfigs:
        service_interface_element_secure_com_config: list[
            ServiceInterfaceElementSecureComConfig
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE-ELEMENT-SECURE-COM-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInterfaceDeploymentRef(Ref):
        dest: ServiceInterfaceDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RptExecutableEntityEvent:
    """
    This describes an ExecutableEntity event instance which can be bypassed.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar execution_context_refs: This describes the context in which
        the event of the executable entity is executed.
    :ivar mc_data_assignments: Reference to related McDataElements
        describing the implementation of „RP runnable disabler flag" and
        "stimulation enabler flag" The possible roles of the
        RoleBasedMcDataAssignment.role attribute are: *
        RpRunnableDisablerFlag" This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar rpt_event_id: RPT event id used for service points call.
    :ivar rpt_executable_entity_properties: Describes the implemented
        code preparation for rapid prototyping at ExecutableEntity
        invocation.
    :ivar rpt_impl_policy: Describes the RptImplPolicy of a
        RptExecutableEvent for service based bypassing.
    :ivar rpt_service_point_post_refs: This describes the applicable
        Post Service Points for a RTEEvent / BswEvent of a bypassed
        ExecutableEntity.
    :ivar rpt_service_point_pre_refs: This describes the applicable Pre
        Service Points for a RTEEvent / BswEvent of a bypassed
        ExecutableEntity.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RptExecutableEntity.rptExecutableEntityEvent
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-EXECUTABLE-ENTITY-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RptExecutableEntityEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RptExecutableEntityEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    execution_context_refs: Optional["RptExecutableEntityEvent.ExecutionContextRefs"] = field(
        default=None,
        metadata={
            "name": "EXECUTION-CONTEXT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_data_assignments: Optional["RptExecutableEntityEvent.McDataAssignments"] = field(
        default=None,
        metadata={
            "name": "MC-DATA-ASSIGNMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_event_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "RPT-EVENT-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_executable_entity_properties: RptExecutableEntityProperties | None = field(
        default=None,
        metadata={
            "name": "RPT-EXECUTABLE-ENTITY-PROPERTIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_impl_policy: RptImplPolicy | None = field(
        default=None,
        metadata={
            "name": "RPT-IMPL-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_service_point_post_refs: Optional["RptExecutableEntityEvent.RptServicePointPostRefs"] = (
        field(
            default=None,
            metadata={
                "name": "RPT-SERVICE-POINT-POST-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    rpt_service_point_pre_refs: Optional["RptExecutableEntityEvent.RptServicePointPreRefs"] = field(
        default=None,
        metadata={
            "name": "RPT-SERVICE-POINT-PRE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutionContextRefs:
        execution_context_ref: list[
            "RptExecutableEntityEvent.ExecutionContextRefs.ExecutionContextRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-CONTEXT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ExecutionContextRef(Ref):
            dest: RptExecutionContextSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class McDataAssignments:
        role_based_mc_data_assignment: list[RoleBasedMcDataAssignment] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-MC-DATA-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RptServicePointPostRefs:
        rpt_service_point_post_ref: list[
            "RptExecutableEntityEvent.RptServicePointPostRefs.RptServicePointPostRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "RPT-SERVICE-POINT-POST-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RptServicePointPostRef(Ref):
            dest: RptServicePointSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RptServicePointPreRefs:
        rpt_service_point_pre_ref: list[
            "RptExecutableEntityEvent.RptServicePointPreRefs.RptServicePointPreRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "RPT-SERVICE-POINT-PRE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RptServicePointPreRef(Ref):
            dest: RptServicePointSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class RptHook:
    """This meta-class provide the ability to describe a rapid prototyping hook.

    This can either be described by an other AUTOSAR system with the
    category RPT_SYSTEM or as a non AUTOSAR software.

    :ivar code_label: This attribute provides a code label which is used
        in the implementation of the hook. For example this can be an C
        function name or the name of data definition.
    :ivar mcd_identifier: This attribute provides an identifier which
        shall be used in a MCD System to display the Rpt Hook.
    :ivar rpt_ar_hook_iref: This describes the hook with the means of
        another AUTOSAR system. This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar sdgs: This property allows to keep special data which is not
        represented by the standard model. It can be utilized to keep
        e.g. tool specific data. This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: RptContainer.rptHook
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-HOOK"

    code_label: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "CODE-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mcd_identifier: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "MCD-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_ar_hook_iref: AnyInstanceRef | None = field(
        default=None,
        metadata={
            "name": "RPT-AR-HOOK-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdgs: Optional["RptHook.Sdgs"] = field(
        default=None,
        metadata={
            "name": "SDGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Sdgs:
        sdg: list[Sdg] = field(
            default_factory=list,
            metadata={
                "name": "SDG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RuleArguments:
    """
    This represents the arguments for a rule-based value specification.

    :ivar v: This represents a numerical value for the
        RuleBasedValueSpecification.
    :ivar vf: This represents a numerical value for the
        RuleBasedValueSpecification which may subject to variability.
        The latest binding time of the VariationPoint shall be
        preCompileTime.
    :ivar vt: This represents a textual value for the
        RuleBasedValueSpecification.
    :ivar vtf: This aggregation represents the ability to provide a
        value that is either numerical or text which existence is
        subject to variability. The upper multiplicity of this role has
        been increased to * due to resolving an atpVariation stereotype.
        The previous value was 1.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RuleBasedValueSpecification.arguments
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RULE-ARGUMENTS"

    v: list[NumericalValue] = field(
        default_factory=list,
        metadata={
            "name": "V",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vf: list[NumericalValueVariationPoint] = field(
        default_factory=list,
        metadata={
            "name": "VF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vt: list[VerbatimString] = field(
        default_factory=list,
        metadata={
            "name": "VT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vtf: list[NumericalOrText] = field(
        default_factory=list,
        metadata={
            "name": "VTF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: list[VariationPoint] = field(
        default_factory=list,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class RunnableEntityGroup:
    """This meta-class represents the ability to define a collection of
    RunnableEntities.

    The collection can be nested.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar runnable_entity_group_irefs: This represents the ability to
        define nested groups of RunnableEntitys.
    :ivar runnable_entity_irefs: This represents a collection of
        RunnableEntitys that belong to the enclosing
        RunnableEntityGroup.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ConsistencyNeeds.regRequiresStability Applicable for:
        ConsistencyNeeds.regDoesNotRequireStability
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RUNNABLE-ENTITY-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RunnableEntityGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RunnableEntityGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runnable_entity_group_irefs: Optional["RunnableEntityGroup.RunnableEntityGroupIrefs"] = field(
        default=None,
        metadata={
            "name": "RUNNABLE-ENTITY-GROUP-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runnable_entity_irefs: Optional["RunnableEntityGroup.RunnableEntityIrefs"] = field(
        default=None,
        metadata={
            "name": "RUNNABLE-ENTITY-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RunnableEntityGroupIrefs:
        runnable_entity_group_iref: list[InnerRunnableEntityGroupInCompositionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "RUNNABLE-ENTITY-GROUP-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RunnableEntityIrefs:
        runnable_entity_iref: list[RunnableEntityInCompositionInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "RUNNABLE-ENTITY-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SdClientConfig:
    """
    Client configuration for Service-Discovery.

    :ivar capability_records: A sequence of records to store arbitrary
        name/value pairs conveying additional information about the
        named service. Capability records shall only be existing if the
        respective SdClientConfig is composed by a
        ConsumedServiceInstance (see constr_3260). This aggregation
        contains a variation point although it is not variant.
        Therefore, this variation point shall not exist in models. See
        constr_2638.
    :ivar client_service_major_version: Major version number of the
        Service.
    :ivar client_service_minor_version: Minor version number of the
        Service.
    :ivar initial_find_behavior: Controls initial find behavior of
        clients.
    :ivar request_response_delay: Maximum/Minimum allowable response
        delay to entries received by multicast in seconds.
    :ivar ttl: TTL for Request and Subscribe messages.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SD-CLIENT-CONFIG"

    capability_records: Optional["SdClientConfig.CapabilityRecords"] = field(
        default=None,
        metadata={
            "name": "CAPABILITY-RECORDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_service_major_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CLIENT-SERVICE-MAJOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_service_minor_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CLIENT-SERVICE-MINOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_find_behavior: InitialSdDelayConfig | None = field(
        default=None,
        metadata={
            "name": "INITIAL-FIND-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_response_delay: RequestResponseDelay | None = field(
        default=None,
        metadata={
            "name": "REQUEST-RESPONSE-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ttl: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TTL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CapabilityRecords:
        tag_with_optional_value: list[TagWithOptionalValue] = field(
            default_factory=list,
            metadata={
                "name": "TAG-WITH-OPTIONAL-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SdServerConfig:
    """
    Server configuration for Service-Discovery.

    :ivar capability_records: A sequence of records to store arbitrary
        name/value pairs conveying additional information about the
        named service. Capability records shall only be existing if the
        respective SdServerConfig is composed by a
        ProvidedServiceInstance (see constr_3259). This aggregation
        contains a variation point although it is not variant.
        Therefore, this variation point shall not exist in models. See
        constr_2638.
    :ivar initial_offer_behavior: Controls offer behavior of the server.
    :ivar offer_cyclic_delay: Optional attribute to define cyclic
        offers. Cyclic offer is active, if the delay is set (in
        seconds).
    :ivar request_response_delay: Maximum/Minimum allowable response
        delay to entries received by multicast in seconds.
    :ivar server_service_major_version: Major version number of the
        Service.
    :ivar server_service_minor_version: Minor version number of the
        Service.
    :ivar ttl: Time to live. Shall be a positive value (sInt32).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SD-SERVER-CONFIG"

    capability_records: Optional["SdServerConfig.CapabilityRecords"] = field(
        default=None,
        metadata={
            "name": "CAPABILITY-RECORDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initial_offer_behavior: InitialSdDelayConfig | None = field(
        default=None,
        metadata={
            "name": "INITIAL-OFFER-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offer_cyclic_delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "OFFER-CYCLIC-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_response_delay: RequestResponseDelay | None = field(
        default=None,
        metadata={
            "name": "REQUEST-RESPONSE-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    server_service_major_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SERVER-SERVICE-MAJOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    server_service_minor_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SERVER-SERVICE-MINOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ttl: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TTL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CapabilityRecords:
        tag_with_optional_value: list[TagWithOptionalValue] = field(
            default_factory=list,
            metadata={
                "name": "TAG-WITH-OPTIONAL-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SdgClass:
    """An SdgClass specifies the name and structure of the SDG that may be used to
    store proprietary data in an AUTOSAR model.

    The SdgClass is similar to an UML stereotype.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar gid: Specifies the name that identifies the element.
    :ivar extends_meta_class: The AUTOSAR Meta-Class that may be
        extended by this SdgClass.
    :ivar caption: Specifies if a caption is required. Note: only Sdgs
        that have a caption can be referenced
    :ivar attributes: Defintion of the structure of the Sdg
    :ivar sdg_constraint_refs: Semantic constraints that restrict the
        structure of the special data group.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SDG-CLASS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SdgClass.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SdgClass.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    gid: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "GID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    extends_meta_class: MetaClassName | None = field(
        default=None,
        metadata={
            "name": "EXTENDS-META-CLASS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    caption: Boolean | None = field(
        default=None,
        metadata={
            "name": "CAPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    attributes: Optional["SdgClass.Attributes"] = field(
        default=None,
        metadata={
            "name": "ATTRIBUTES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdg_constraint_refs: Optional["SdgClass.SdgConstraintRefs"] = field(
        default=None,
        metadata={
            "name": "SDG-CONSTRAINT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Attributes:
        sdg_aggregation_with_variation: list[SdgAggregationWithVariation] = field(
            default_factory=list,
            metadata={
                "name": "SDG-AGGREGATION-WITH-VARIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sdg_foreign_reference: list[SdgForeignReference] = field(
            default_factory=list,
            metadata={
                "name": "SDG-FOREIGN-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sdg_foreign_reference_with_variation: list[SdgForeignReferenceWithVariation] = field(
            default_factory=list,
            metadata={
                "name": "SDG-FOREIGN-REFERENCE-WITH-VARIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sdg_primitive_attribute: list[SdgPrimitiveAttribute] = field(
            default_factory=list,
            metadata={
                "name": "SDG-PRIMITIVE-ATTRIBUTE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sdg_primitive_attribute_with_variation: list[SdgPrimitiveAttributeWithVariation] = field(
            default_factory=list,
            metadata={
                "name": "SDG-PRIMITIVE-ATTRIBUTE-WITH-VARIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sdg_reference: list[SdgReference] = field(
            default_factory=list,
            metadata={
                "name": "SDG-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SdgConstraintRefs:
        sdg_constraint_ref: list["SdgClass.SdgConstraintRefs.SdgConstraintRef"] = field(
            default_factory=list,
            metadata={
                "name": "SDG-CONSTRAINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SdgConstraintRef(Ref):
            dest: TraceableTextSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SecOcDeployment:
    """
    The meta-class represents the ability to define a deployment of the SecOc
    communication protocol configuration settings to crypto module entities.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sec_oc_job_mappings: Mapping of the JobRequirement to a
        concrete crypto job.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SEC-OC-DEPLOYMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecOcDeployment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecOcDeployment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sec_oc_job_mappings: Optional["SecOcDeployment.SecOcJobMappings"] = field(
        default=None,
        metadata={
            "name": "SEC-OC-JOB-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecOcJobMappings:
        sec_oc_job_mapping: list[SecOcJobMapping] = field(
            default_factory=list,
            metadata={
                "name": "SEC-OC-JOB-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SecOcSecureComProps:
    """
    Configuration of AUTOSAR SecOC.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar auth_info_tx_length: This attribute defines the length in bits
        of the authentication code to be included in the payload of the
        authenticated Message.
    :ivar authentication_ref: This reference defines the authentication
        algorithm used for MAC generation and verification.
    :ivar authentication_verify_attempts: This attribute defines the
        additional number of authentication attempts that are to be
        carried out when the generation of the authentication
        information failed for a given message. If zero is set than only
        one authentication attempt is done.
    :ivar freshness_value_length: This attribute defines the complete
        length in bits of the Freshness Value.
    :ivar freshness_value_tx_length: This attribute defines the length
        in bits of the Freshness Value to be included in the payload of
        the secured message.
    :ivar job_requirements: Collection of cryptographic job
        requirements.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SEC-OC-SECURE-COM-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecOcSecureComProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecOcSecureComProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    auth_info_tx_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "AUTH-INFO-TX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_ref: Optional["SecOcSecureComProps.AuthenticationRef"] = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_verify_attempts: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-VERIFY-ATTEMPTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freshness_value_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FRESHNESS-VALUE-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freshness_value_tx_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FRESHNESS-VALUE-TX-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    job_requirements: Optional["SecOcSecureComProps.JobRequirements"] = field(
        default=None,
        metadata={
            "name": "JOB-REQUIREMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AuthenticationRef(Ref):
        dest: CryptoServicePrimitiveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class JobRequirements:
        sec_oc_job_requirement: list[SecOcJobRequirement] = field(
            default_factory=list,
            metadata={
                "name": "SEC-OC-JOB-REQUIREMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SecureCommunicationPropsSet:
    """
    Collection of properties used to configure SecuredIPdus.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar authentication_propss: Authentication properties used to
        configure SecuredIPdus.
    :ivar freshness_propss: Freshness properties used to configure
        SecuredIPdus.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURE-COMMUNICATION-PROPS-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecureCommunicationPropsSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecureCommunicationPropsSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_propss: Optional["SecureCommunicationPropsSet.AuthenticationPropss"] = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    freshness_propss: Optional["SecureCommunicationPropsSet.FreshnessPropss"] = field(
        default=None,
        metadata={
            "name": "FRESHNESS-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AuthenticationPropss:
        secure_communication_authentication_props: list[SecureCommunicationAuthenticationProps] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SECURE-COMMUNICATION-AUTHENTICATION-PROPS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

    @dataclass(slots=True, kw_only=True)
    class FreshnessPropss:
        secure_communication_freshness_props: list[SecureCommunicationFreshnessProps] = field(
            default_factory=list,
            metadata={
                "name": "SECURE-COMMUNICATION-FRESHNESS-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventContextProps:
    """
    This meta-class specifies the SecurityEventDefinition to be mapped to an
    IdsmInstance and adds mapping-dependent properties of this security event valid
    only for this specific mapping.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar context_datas: This aggregation represents the definition of
        optional context data for security events. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar default_reporting_mode: This attribute defines the default
        reporting mode for the referenced security event.
    :ivar persistent_storage: This attribute controls whether qualified
        reportings of the referenced security event shall be stored
        persistently by the mapped IdsmInstance or not.
    :ivar security_events: This reference defines the security event
        that is mapped and enriched by SecurityEventMappingProps with
        mapping dependent properties. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar sensor_instance_id: This attribute defines the ID of the
        security sensor that detects the referenced security event.
    :ivar severity: This attribute defines how critical/severe the
        referenced security event is. Please note that currently, the
        severity level meanings of specific integer values is not
        specified by AUTOSAR but left to the party responsible for the
        IDS system design (e.g. the OEM).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SecurityEventContextMapping.mappedSecurityEvent
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-CONTEXT-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecurityEventContextProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecurityEventContextProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    context_datas: Optional["SecurityEventContextProps.ContextDatas"] = field(
        default=None,
        metadata={
            "name": "CONTEXT-DATAS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_reporting_mode: SecurityEventReportingModeEnum | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-REPORTING-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    persistent_storage: Boolean | None = field(
        default=None,
        metadata={
            "name": "PERSISTENT-STORAGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_events: Optional["SecurityEventContextProps.SecurityEvents"] = field(
        default=None,
        metadata={
            "name": "SECURITY-EVENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sensor_instance_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SENSOR-INSTANCE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    severity: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SEVERITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ContextDatas:
        security_event_context_data: list[SecurityEventContextData] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-CONTEXT-DATA",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecurityEvents:
        security_event_definition_ref_conditional: list[SecurityEventDefinitionRefConditional] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SECURITY-EVENT-DEFINITION-REF-CONDITIONAL",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventFilterChain:
    """This meta-class represents a configurable chain of filters used to qualify
    security events.

    The different filters of this filter chain are applied in the follow order: SecurityEventStateFilter, SecurityEventOneEveryNFilter, SecurityEventAggregationFilter, SecurityEventThresholdFilter.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar aggregation: This aggregation represents the aggregation
        filter in the filter chain.
    :ivar one_every_n: This aggregation represents the sampling filter
        in the filter chain.
    :ivar state: This aggregation represents the state filter in the
        event chain.
    :ivar threshold: This aggregation represents the threshold filter in
        the filter chain.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-FILTER-CHAIN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecurityEventFilterChain.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecurityEventFilterChain.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    aggregation: SecurityEventAggregationFilter | None = field(
        default=None,
        metadata={
            "name": "AGGREGATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    one_every_n: SecurityEventOneEveryNFilter | None = field(
        default=None,
        metadata={
            "name": "ONE-EVERY-N",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    state: SecurityEventStateFilter | None = field(
        default=None,
        metadata={
            "name": "STATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    threshold: SecurityEventThresholdFilter | None = field(
        default=None,
        metadata={
            "name": "THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ServerComSpec:
    """'''begin restrict to CP''' Communication attributes for a server port
    (PPortPrototype and ClientServerInterface).

    '''end restrict to CP''' '''begin restrict to AP''' Server-specific
    communication attributes (PPortPrototype typed by ServiceInterface)
    that are relevant for methods and field getters and setters. '''end
    restrict to AP'''

    :ivar getter_ref: The existence of this reference indicates that the
        ServerComSpec refers to the getter of a Field.
    :ivar operation_ref: Operation these communication attributes apply
        to.
    :ivar queue_length: '''begin restrict to CP''' Length of call queue
        on the server side. The queue is implemented by the RTE. The
        value shall be greater or equal to 1. Setting the value of
        queueLength to 1 implies that incoming requests are rejected
        while another request that arrived earlier is being processed.
        '''end restrict to CP''' '''begin restrict to AP''' Length of
        call queue on the server side. '''end restrict to AP'''
    :ivar setter_ref: The existence of this reference indicates that the
        ServerComSpec refers to the setter of a Field.
    :ivar transformation_com_spec_propss: This references the
        TransformationComSpecProps which define port-specific
        configuration for data transformation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVER-COM-SPEC"

    getter_ref: Optional["ServerComSpec.GetterRef"] = field(
        default=None,
        metadata={
            "name": "GETTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_ref: Optional["ServerComSpec.OperationRef"] = field(
        default=None,
        metadata={
            "name": "OPERATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    queue_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "QUEUE-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    setter_ref: Optional["ServerComSpec.SetterRef"] = field(
        default=None,
        metadata={
            "name": "SETTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformation_com_spec_propss: Optional["ServerComSpec.TransformationComSpecPropss"] = field(
        default=None,
        metadata={
            "name": "TRANSFORMATION-COM-SPEC-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class GetterRef(Ref):
        dest: FieldSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class OperationRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SetterRef(Ref):
        dest: FieldSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TransformationComSpecPropss:
        end_to_end_transformation_com_spec_props: list[EndToEndTransformationComSpecProps] = field(
            default_factory=list,
            metadata={
                "name": "END-TO-END-TRANSFORMATION-COM-SPEC-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_transformation_com_spec_props: list[UserDefinedTransformationComSpecProps] = (
            field(
                default_factory=list,
                metadata={
                    "name": "USER-DEFINED-TRANSFORMATION-COM-SPEC-PROPS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class ServiceInstanceToSignalMapping:
    """
    This meta-class is defined for a specific ServiceInstance and contains the
    mappings of elements of a ServiceInterface for which the ServiceInstance is
    defined  to individual ISignalTriggerings.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar event_element_mappings: Mapping of an event or an element
        inside of the event to an ISignalTriggering.
    :ivar field_mappings: Mapping of a field to ISignalTriggerings.
    :ivar fire_and_forget_method_mappings: Mapping of an
        ISignalTriggering being part of a fire and forget message to a
        ClientServerOperation.
    :ivar method_mappings: Mapping of a method to ISignalTriggerings.
    :ivar service_instance_ref: Reference to a ServiceInstance from
        which the corresponding ServiceInterface elements will be
        transported in the signal-based way over a communication medium.
    :ivar trigger_mappings: Mapping of a trigger to an
        ISignalTriggering.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-INSTANCE-TO-SIGNAL-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ServiceInstanceToSignalMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ServiceInstanceToSignalMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_element_mappings: Optional["ServiceInstanceToSignalMapping.EventElementMappings"] = field(
        default=None,
        metadata={
            "name": "EVENT-ELEMENT-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_mappings: Optional["ServiceInstanceToSignalMapping.FieldMappings"] = field(
        default=None,
        metadata={
            "name": "FIELD-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fire_and_forget_method_mappings: Optional[
        "ServiceInstanceToSignalMapping.FireAndForgetMethodMappings"
    ] = field(
        default=None,
        metadata={
            "name": "FIRE-AND-FORGET-METHOD-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_mappings: Optional["ServiceInstanceToSignalMapping.MethodMappings"] = field(
        default=None,
        metadata={
            "name": "METHOD-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_ref: Optional["ServiceInstanceToSignalMapping.ServiceInstanceRef"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_mappings: Optional["ServiceInstanceToSignalMapping.TriggerMappings"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventElementMappings:
        signal_based_event_element_to_i_signal_triggering_mapping: list[
            SignalBasedEventElementToISignalTriggeringMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "SIGNAL-BASED-EVENT-ELEMENT-TO-I-SIGNAL-TRIGGERING-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FieldMappings:
        signal_based_field_to_i_signal_triggering_mapping: list[
            SignalBasedFieldToISignalTriggeringMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "SIGNAL-BASED-FIELD-TO-I-SIGNAL-TRIGGERING-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FireAndForgetMethodMappings:
        signal_based_fire_and_forget_method_to_i_signal_triggering_mapping: list[
            SignalBasedFireAndForgetMethodToISignalTriggeringMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "SIGNAL-BASED-FIRE-AND-FORGET-METHOD-TO-I-SIGNAL-TRIGGERING-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MethodMappings:
        signal_based_method_to_i_signal_triggering_mapping: list[
            SignalBasedMethodToISignalTriggeringMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "SIGNAL-BASED-METHOD-TO-I-SIGNAL-TRIGGERING-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRef(Ref):
        dest: AdaptivePlatformServiceInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerMappings:
        signal_based_trigger_to_i_signal_triggering_mapping: list[
            SignalBasedTriggerToISignalTriggeringMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "SIGNAL-BASED-TRIGGER-TO-I-SIGNAL-TRIGGERING-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SignalServiceTranslationEventProps:
    """
    This element allows to define the properties which are applicable for the
    signal/service translation event.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar element_propss: Defines properties for a single translated
        element.
    :ivar safe_translation: Defined whether the translation shall happen
        in a safe way.
    :ivar secure_translation: Defined whether the translation shall
        happen in a secure way.
    :ivar service_element_mapping_refs: Reference to the collection of
        SignalBased to ISignalTriggerung mappings the properties apply
        to.
    :ivar translation_target_iref: Reference to a VariableDataPrototype
        representing the target of signal/service translation.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SIGNAL-SERVICE-TRANSLATION-EVENT-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SignalServiceTranslationEventProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SignalServiceTranslationEventProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    element_propss: Optional["SignalServiceTranslationEventProps.ElementPropss"] = field(
        default=None,
        metadata={
            "name": "ELEMENT-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    safe_translation: Boolean | None = field(
        default=None,
        metadata={
            "name": "SAFE-TRANSLATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_translation: Boolean | None = field(
        default=None,
        metadata={
            "name": "SECURE-TRANSLATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_element_mapping_refs: Optional[
        "SignalServiceTranslationEventProps.ServiceElementMappingRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-ELEMENT-MAPPING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    translation_target_iref: VariableDataPrototypeInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "TRANSLATION-TARGET-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ElementPropss:
        signal_service_translation_element_props: list[SignalServiceTranslationElementProps] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SIGNAL-SERVICE-TRANSLATION-ELEMENT-PROPS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceElementMappingRefs:
        service_element_mapping_ref: list[
            "SignalServiceTranslationEventProps.ServiceElementMappingRefs.ServiceElementMappingRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-ELEMENT-MAPPING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceElementMappingRef(Ref):
            dest: AbstractSignalBasedToISignalTriggeringMappingSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SocketConnectionBundle:
    """
    This elements groups SocketConnections, i.e. specifies socket connections
    belonging to the bundle and describes properties which are common for all
    socket connections in the bundle.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar bundled_connections: Collection of SocketConnections in the
        connectionGroup. This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar differentiated_service_field: The 6-bit Differentiated Service
        Field in the IP headers may be used for classifying network
        traffic. If not set a value of zero is used to indicate packets
        that have not been classified.
    :ivar flow_label: The 20-bit Flow Label field in the IPv6 header may
        be used by a source to label sequences of packets for which it
        requests special handling by the IPv6 routers, such as non-
        default quality of service. If not set a Flow Label of zero is
        used to indicate packets that have not been labeled.
    :ivar path_mtu_discovery_enabled: Defines whether the Path MTU
        Discovery shall be performed for the related socket.
    :ivar pdus: With this aggregation SocketConnectionIpduIdentifier
        elements are assigned to all SocketConnections that are
        available in this SocketConnetionBundle.
    :ivar server_port_ref: Server Port for TCP/UDP connection in an
        abstract communication sense. The server is the major provider
        of the communication. Please note that the server may also
        consume data.
    :ivar udp_checksum_handling: Specifies if UDP checksum handling
        shall be enabled (udpChecksumEnabled) or skipped
        (udpChecksumDisabled) on the related socket connection.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SoAdConfig.connectionBundle
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOCKET-CONNECTION-BUNDLE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SocketConnectionBundle.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bundled_connections: Optional["SocketConnectionBundle.BundledConnections"] = field(
        default=None,
        metadata={
            "name": "BUNDLED-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    differentiated_service_field: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DIFFERENTIATED-SERVICE-FIELD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    flow_label: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FLOW-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    path_mtu_discovery_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "PATH-MTU-DISCOVERY-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdus: Optional["SocketConnectionBundle.Pdus"] = field(
        default=None,
        metadata={
            "name": "PDUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    server_port_ref: Optional["SocketConnectionBundle.ServerPortRef"] = field(
        default=None,
        metadata={
            "name": "SERVER-PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    udp_checksum_handling: UdpChecksumCalculationEnum | None = field(
        default=None,
        metadata={
            "name": "UDP-CHECKSUM-HANDLING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BundledConnections:
        socket_connection: list[SocketConnection] = field(
            default_factory=list,
            metadata={
                "name": "SOCKET-CONNECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Pdus:
        socket_connection_ipdu_identifier: list[SocketConnectionIpduIdentifier] = field(
            default_factory=list,
            metadata={
                "name": "SOCKET-CONNECTION-IPDU-IDENTIFIER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServerPortRef(Ref):
        dest: SocketAddressSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SoftwareCluster:
    """
    This meta-class represents the ability to define an uploadable software-
    package, i.e. the SoftwareCluster shall contain all software and configuration
    for a given purpose.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar artifact_checksums: This aggregation carries the checksums for
        artifacts contained in the enclosing SoftwareCluster.
    :ivar artifact_locators: This aggregation represents the artifact
        locations that are relevant in the context of the enclosing
        SoftwareCluster
    :ivar claimed_function_group_refs: Each SoftwareCluster can reserve
        the usage of a given functionGroup such that no other
        SoftwareCluster is allowed to use it
    :ivar conflicts_to: This aggregation handles conflicts. If it yields
        true then the SoftwareCluster shall not be installed.
    :ivar contained_ar_element_refs: This reference represents the
        collection of model elements that cannot derive from
        UploadablePackageElement and  that contribute to the
        completeness of the definition of the SoftwareCluster.
    :ivar contained_fibex_element_refs: This allows for referencing
        FibexElements that need to be considered in the context of a
        SoftwareCluster.
    :ivar contained_package_element_refs: This reference identifies
        model elements that are required to complete the manifest
        content.
    :ivar contained_process_refs: This reference represent the processes
        contained in the enclosing SoftwareCluster.
    :ivar depends_on: This aggregation can be taken to identify a
        dependency for the enclosing SoftwareCluster.
    :ivar design_refs: This reference represents the identification of
        all SoftwareClusterDesigns applicable for the enclosing
        SoftwareCluster.
    :ivar diagnostic_deployment_props_ref: This reference identifies the
        applicable SoftwareClusterDiagnosticProps for the enclosing
        SoftwareCluster. Note that all SoftwareClusters that share the
        same DiagnosticContributionSet via the reference
        diagnosticExtract shall also share the same
        SoftwareClusterDiagnosticProps.
    :ivar installation_behavior: This attribute controls the behavior of
        the SoftwareCluster in terms of installation.
    :ivar license_refs: This attribute allows for the inclusion of the
        full text of a license of the enclosing SoftwareCluster. In many
        cases open source licenses require the inclusion of the full
        license text to any software that is released under the
        respective license.
    :ivar module_instantiation_refs: This reference identifies
        AdaptiveModuleInstantiations that need to be included with the
        SoftwareCluster in order to establish infrastructure required
        for the installation of the SoftwareCluster.
    :ivar release_notes_ref: This attribute allows for the explanations
        of changes since the previous version. The list of changes might
        require the creation of multiple paragraphs of test.
    :ivar type_approval: This attribute carries the homologation
        information that may be specific for a given country.
    :ivar vendor_id: Vendor ID of this Implementation according to the
        AUTOSAR vendor list.
    :ivar vendor_signature_ref: This reference identifies the
        certificate that represents the vendor's signature.
    :ivar version: This attribute can be used to describe a version
        information for the enclosing SoftwareCluster.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SoftwareCluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SoftwareCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    artifact_checksums: Optional["SoftwareCluster.ArtifactChecksums"] = field(
        default=None,
        metadata={
            "name": "ARTIFACT-CHECKSUMS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    artifact_locators: Optional["SoftwareCluster.ArtifactLocators"] = field(
        default=None,
        metadata={
            "name": "ARTIFACT-LOCATORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    claimed_function_group_refs: Optional["SoftwareCluster.ClaimedFunctionGroupRefs"] = field(
        default=None,
        metadata={
            "name": "CLAIMED-FUNCTION-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    conflicts_to: SoftwareClusterDependencyFormula | None = field(
        default=None,
        metadata={
            "name": "CONFLICTS-TO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_ar_element_refs: Optional["SoftwareCluster.ContainedArElementRefs"] = field(
        default=None,
        metadata={
            "name": "CONTAINED-AR-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_fibex_element_refs: Optional["SoftwareCluster.ContainedFibexElementRefs"] = field(
        default=None,
        metadata={
            "name": "CONTAINED-FIBEX-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_package_element_refs: Optional["SoftwareCluster.ContainedPackageElementRefs"] = field(
        default=None,
        metadata={
            "name": "CONTAINED-PACKAGE-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_process_refs: Optional["SoftwareCluster.ContainedProcessRefs"] = field(
        default=None,
        metadata={
            "name": "CONTAINED-PROCESS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    depends_on: SoftwareClusterDependencyFormula | None = field(
        default=None,
        metadata={
            "name": "DEPENDS-ON",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    design_refs: Optional["SoftwareCluster.DesignRefs"] = field(
        default=None,
        metadata={
            "name": "DESIGN-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_deployment_props_ref: Optional["SoftwareCluster.DiagnosticDeploymentPropsRef"] = (
        field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-DEPLOYMENT-PROPS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    installation_behavior: SoftwareClusterInstallationBehaviorEnum | None = field(
        default=None,
        metadata={
            "name": "INSTALLATION-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    license_refs: Optional["SoftwareCluster.LicenseRefs"] = field(
        default=None,
        metadata={
            "name": "LICENSE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    module_instantiation_refs: Optional["SoftwareCluster.ModuleInstantiationRefs"] = field(
        default=None,
        metadata={
            "name": "MODULE-INSTANTIATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    release_notes_ref: Optional["SoftwareCluster.ReleaseNotesRef"] = field(
        default=None,
        metadata={
            "name": "RELEASE-NOTES-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_approval: String | None = field(
        default=None,
        metadata={
            "name": "TYPE-APPROVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vendor_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VENDOR-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vendor_signature_ref: Optional["SoftwareCluster.VendorSignatureRef"] = field(
        default=None,
        metadata={
            "name": "VENDOR-SIGNATURE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: StrongRevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ArtifactChecksums:
        artifact_checksum: list[ArtifactChecksum] = field(
            default_factory=list,
            metadata={
                "name": "ARTIFACT-CHECKSUM",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ArtifactLocators:
        artifact_locator: list[ArtifactLocator] = field(
            default_factory=list,
            metadata={
                "name": "ARTIFACT-LOCATOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClaimedFunctionGroupRefs:
        claimed_function_group_ref: list[
            "SoftwareCluster.ClaimedFunctionGroupRefs.ClaimedFunctionGroupRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CLAIMED-FUNCTION-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ClaimedFunctionGroupRef(Ref):
            dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ContainedArElementRefs:
        contained_ar_element_ref: list[
            "SoftwareCluster.ContainedArElementRefs.ContainedArElementRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTAINED-AR-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContainedArElementRef(Ref):
            dest: ArElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ContainedFibexElementRefs:
        contained_fibex_element_ref: list[
            "SoftwareCluster.ContainedFibexElementRefs.ContainedFibexElementRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTAINED-FIBEX-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContainedFibexElementRef(Ref):
            dest: FibexElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ContainedPackageElementRefs:
        contained_package_element_ref: list[
            "SoftwareCluster.ContainedPackageElementRefs.ContainedPackageElementRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTAINED-PACKAGE-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContainedPackageElementRef(Ref):
            dest: UploadablePackageElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ContainedProcessRefs:
        contained_process_ref: list["SoftwareCluster.ContainedProcessRefs.ContainedProcessRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "CONTAINED-PROCESS-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class ContainedProcessRef(Ref):
            dest: ProcessSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DesignRefs:
        design_ref: list["SoftwareCluster.DesignRefs.DesignRef"] = field(
            default_factory=list,
            metadata={
                "name": "DESIGN-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DesignRef(Ref):
            dest: SoftwareClusterDesignSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticDeploymentPropsRef(Ref):
        dest: SoftwareClusterDiagnosticDeploymentPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class LicenseRefs:
        license_ref: list["SoftwareCluster.LicenseRefs.LicenseRef"] = field(
            default_factory=list,
            metadata={
                "name": "LICENSE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class LicenseRef(Ref):
            dest: DocumentationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ModuleInstantiationRefs:
        module_instantiation_ref: list[
            "SoftwareCluster.ModuleInstantiationRefs.ModuleInstantiationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MODULE-INSTANTIATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ModuleInstantiationRef(Ref):
            dest: AdaptiveModuleInstantiationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ReleaseNotesRef(Ref):
        dest: DocumentationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class VendorSignatureRef(Ref):
        dest: CryptoServiceCertificateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SoftwareClusterDesign:
    """
    This meta-class represents the ability for the OEM to design the grouping of
    software uploadable to a specific target Machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar contained_process_refs: This reference represent the
        ProcessDesigns contained in the enclosing SoftwareCluster.
    :ivar diagnostic_contribution_refs: This reference identifies the
        corresponding collection of DiagnosticContributionSet.
    :ivar intended_target_machine_refs: This reference can be taken to
        identify the MachineDesign for which the final SoftwareCluster
        shall be developed.
    :ivar required_ar_element_refs: This reference represents the
        collection of ARElements that are required for the completeness
        of the definition of the SoftwareCluster.
    :ivar required_fibex_element_refs: This reference represents the
        collection of fibexElements that are required for the
        completeness of the definition of the SoftwareCluster.
    :ivar required_package_element_refs: This reference points to
        uploadable elements that have been identified as relevant in the
        context of the enclosing SoftwareClusterDesign.
    :ivar root_composition: This aggregation represents the design of
        the software inside the SwClusterDesign terms of the
        communication endpoints.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOFTWARE-CLUSTER-DESIGN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SoftwareClusterDesign.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SoftwareClusterDesign.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_process_refs: Optional["SoftwareClusterDesign.ContainedProcessRefs"] = field(
        default=None,
        metadata={
            "name": "CONTAINED-PROCESS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_contribution_refs: Optional["SoftwareClusterDesign.DiagnosticContributionRefs"] = (
        field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-CONTRIBUTION-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    intended_target_machine_refs: Optional["SoftwareClusterDesign.IntendedTargetMachineRefs"] = (
        field(
            default=None,
            metadata={
                "name": "INTENDED-TARGET-MACHINE-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    required_ar_element_refs: Optional["SoftwareClusterDesign.RequiredArElementRefs"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-AR-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_fibex_element_refs: Optional["SoftwareClusterDesign.RequiredFibexElementRefs"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-FIBEX-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_package_element_refs: Optional["SoftwareClusterDesign.RequiredPackageElementRefs"] = (
        field(
            default=None,
            metadata={
                "name": "REQUIRED-PACKAGE-ELEMENT-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    root_composition: RootSwClusterDesignComponentPrototype | None = field(
        default=None,
        metadata={
            "name": "ROOT-COMPOSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ContainedProcessRefs:
        contained_process_ref: list[
            "SoftwareClusterDesign.ContainedProcessRefs.ContainedProcessRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTAINED-PROCESS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ContainedProcessRef(Ref):
            dest: ProcessDesignSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticContributionRefs:
        diagnostic_contribution_ref: list[
            "SoftwareClusterDesign.DiagnosticContributionRefs.DiagnosticContributionRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CONTRIBUTION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DiagnosticContributionRef(Ref):
            dest: DiagnosticContributionSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class IntendedTargetMachineRefs:
        intended_target_machine_ref: list[
            "SoftwareClusterDesign.IntendedTargetMachineRefs.IntendedTargetMachineRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "INTENDED-TARGET-MACHINE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class IntendedTargetMachineRef(Ref):
            dest: MachineDesignSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RequiredArElementRefs:
        required_ar_element_ref: list[
            "SoftwareClusterDesign.RequiredArElementRefs.RequiredArElementRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "REQUIRED-AR-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RequiredArElementRef(Ref):
            dest: ArElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RequiredFibexElementRefs:
        required_fibex_element_ref: list[
            "SoftwareClusterDesign.RequiredFibexElementRefs.RequiredFibexElementRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "REQUIRED-FIBEX-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RequiredFibexElementRef(Ref):
            dest: FibexElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RequiredPackageElementRefs:
        required_package_element_ref: list[
            "SoftwareClusterDesign.RequiredPackageElementRefs.RequiredPackageElementRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "REQUIRED-PACKAGE-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RequiredPackageElementRef(Ref):
            dest: UploadablePackageElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SomeipFieldDeployment:
    """
    SOME/IP configuration settings for a Field.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar field_ref: Reference to a Field that is deployed to a
        middleware transport layer.
    :ivar get: This aggregation represents the setting of the get
        method.
    :ivar notifier: This aggregation represents the settings of the
        notifier.
    :ivar set: This aggregation represents the settings of the set
        method
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-FIELD-DEPLOYMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipFieldDeployment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipFieldDeployment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_ref: Optional["SomeipFieldDeployment.FieldRef"] = field(
        default=None,
        metadata={
            "name": "FIELD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    get: SomeipMethodDeployment | None = field(
        default=None,
        metadata={
            "name": "GET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    notifier: SomeipEventDeployment | None = field(
        default=None,
        metadata={
            "name": "NOTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    set: SomeipMethodDeployment | None = field(
        default=None,
        metadata={
            "name": "SET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FieldRef(Ref):
        dest: FieldSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SomeipTpConfig:
    """
    This element defines exactly one SOME/IP TP Configuration.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_cluster_ref: A TpConfig is existing always in
        the context of exactly one CommunicationCluster.
    :ivar tp_channels: Definition of SomeipTpChannels that are
        collecting configuration properties that are valid for a
        collection of SomeipTpConnections.
    :ivar tp_connections: Senders and receivers of SOME/IP TP messages.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-TP-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipTpConfig.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipTpConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_ref: Optional["SomeipTpConfig.CommunicationClusterRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_channels: Optional["SomeipTpConfig.TpChannels"] = field(
        default=None,
        metadata={
            "name": "TP-CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_connections: Optional["SomeipTpConfig.TpConnections"] = field(
        default=None,
        metadata={
            "name": "TP-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TpChannels:
        someip_tp_channel: list[SomeipTpChannel] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-TP-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpConnections:
        someip_tp_connection: list[SomeipTpConnection] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-TP-CONNECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SomeipTransformationISignalProps:
    """
    The class SOMEIPTransformationISignalProps specifies ISignal specific
    configuration properties for SOME/IP transformer attributes.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar someip_transformation_i_signal_props_variants: This element
        was generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-TRANSFORMATION-I-SIGNAL-PROPS"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    someip_transformation_i_signal_props_variants: Optional[
        "SomeipTransformationISignalProps.SomeipTransformationISignalPropsVariants"
    ] = field(
        default=None,
        metadata={
            "name": "SOMEIP-TRANSFORMATION-I-SIGNAL-PROPS-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SomeipTransformationISignalPropsVariants:
        someip_transformation_i_signal_props_conditional: list[
            SomeipTransformationISignalPropsConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-TRANSFORMATION-I-SIGNAL-PROPS-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SpecificationDocumentScope:
    """Represents a standardized or custom specification document such as Software
    Component Template, Main Requirements, Specification of Communication, etc.

    Autosar specifications are referenced via their title.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alternative_name: Alternative name of a specification element
        if its name doesn't fit into the shortName. E.g. because the
        name contains spaces.
    :ivar in_scope: indicates, if a specification element is relevant
        for this data exchange point. It is relevant if inScope==true.
        It is not relevant or don't care if inScope=false.
    :ivar custom_documentation_ref: reference to a custom defined
        specification.
    :ivar document_element_scopes: An element with a name or ID that is
        specified in the Specification Document.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SPECIFICATION-DOCUMENT-SCOPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SpecificationDocumentScope.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SpecificationDocumentScope.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alternative_name: String | None = field(
        default=None,
        metadata={
            "name": "ALTERNATIVE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    in_scope: Boolean | None = field(
        default=None,
        metadata={
            "name": "IN-SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    custom_documentation_ref: Optional["SpecificationDocumentScope.CustomDocumentationRef"] = field(
        default=None,
        metadata={
            "name": "CUSTOM-DOCUMENTATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    document_element_scopes: Optional["SpecificationDocumentScope.DocumentElementScopes"] = field(
        default=None,
        metadata={
            "name": "DOCUMENT-ELEMENT-SCOPES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CustomDocumentationRef(Ref):
        dest: DocumentationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DocumentElementScopes:
        document_element_scope: list[DocumentElementScope] = field(
            default_factory=list,
            metadata={
                "name": "DOCUMENT-ELEMENT-SCOPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StartupConfig:
    """
    This meta-class represents a reusable startup configuration for processes..

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar environment_variables: This aggregation represents the
        collection of environment variables that shall be added to the
        respective Process's environment prior to launch. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar execution_error_ref: this reference is used to identify the
        applicable execution error
    :ivar process_arguments: This aggregation represents the collection
        of command-line arguments applicable to the enclosing
        StartupConfig.
    :ivar scheduling_policy: This attribute represents the ability to
        define the scheduling policy for the initial thread of the
        application.
    :ivar scheduling_priority: This is the scheduling priority requested
        by the application itself.
    :ivar termination_behavior: This attribute defines the termination
        behavior of the Process.
    :ivar timeout: This aggregation can be used to specify the timeouts
        for launching and terminating the process depending on the
        StartupConfig.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STARTUP-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StartupConfig.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StartupConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    environment_variables: Optional["StartupConfig.EnvironmentVariables"] = field(
        default=None,
        metadata={
            "name": "ENVIRONMENT-VARIABLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    execution_error_ref: Optional["StartupConfig.ExecutionErrorRef"] = field(
        default=None,
        metadata={
            "name": "EXECUTION-ERROR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_arguments: Optional["StartupConfig.ProcessArguments"] = field(
        default=None,
        metadata={
            "name": "PROCESS-ARGUMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scheduling_policy: String | None = field(
        default=None,
        metadata={
            "name": "SCHEDULING-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scheduling_priority: Integer | None = field(
        default=None,
        metadata={
            "name": "SCHEDULING-PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    termination_behavior: TerminationBehaviorEnum | None = field(
        default=None,
        metadata={
            "name": "TERMINATION-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout: EnterExitTimeout | None = field(
        default=None,
        metadata={
            "name": "TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EnvironmentVariables:
        tag_with_optional_value: list[TagWithOptionalValue] = field(
            default_factory=list,
            metadata={
                "name": "TAG-WITH-OPTIONAL-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutionErrorRef(Ref):
        dest: ProcessExecutionErrorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessArguments:
        process_argument: list[ProcessArgument] = field(
            default_factory=list,
            metadata={
                "name": "PROCESS-ARGUMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StateManagementActionList:
    """
    This meta-class represents the ability to define an action list that is
    associated with a state of a state machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar action_items: This represents the collection of action items
        in the context of the action item list.
    :ivar affected_state_iref: This reference identifies the state for
        which the referencing action list applies.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-ACTION-LIST"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StateManagementActionList.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StateManagementActionList.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    action_items: Optional["StateManagementActionList.ActionItems"] = field(
        default=None,
        metadata={
            "name": "ACTION-ITEMS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    affected_state_iref: ModeDeclarationInStateManagementStateNotificationInstanceRef | None = (
        field(
            default=None,
            metadata={
                "name": "AFFECTED-STATE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActionItems:
        state_management_set_function_group_state_action_item: list[
            StateManagementSetFunctionGroupStateActionItem
        ] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-SET-FUNCTION-GROUP-STATE-ACTION-ITEM",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        state_management_state_machine_action_item: list[StateManagementStateMachineActionItem] = (
            field(
                default_factory=list,
                metadata={
                    "name": "STATE-MANAGEMENT-STATE-MACHINE-ACTION-ITEM",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        state_management_sync_action_item: list[StateManagementSyncActionItem] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-SYNC-ACTION-ITEM",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StateManagementStateNotification:
    """
    This meta-class represents the ability to formalize state notifications on the
    AUTOSAR adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar notification_port_iref: This instanceRef identifies the
        PPortPrototype over which the notification is to be conveyed.
    :ivar state_machine: This aggregation represents the existence of an
        actual state machine. This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-STATE-NOTIFICATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StateManagementStateNotification.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StateManagementStateNotification.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    notification_port_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "NOTIFICATION-PORT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    state_machine: ModeDeclarationGroupPrototype | None = field(
        default=None,
        metadata={
            "name": "STATE-MACHINE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StaticSocketConnection:
    """
    Definition of static SocketConnection between the Socket that is defined by the
    aggregating SocketAddress and the remoteAddress.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar i_pdu_identifiers: Assignment of IPduIdentifiers that are
        transmitted over the static SocketConnection. This property was
        modified due to atpVariation (DirectedAssociationPattern).
    :ivar remote_addresss: RemoteAddress of the static SocketConnection.
        This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar tcp_connect_timeout: Specifies the time in seconds how long
        TCP connect attempts are repeated to reach SOAD_SOCON_ONLINE.
        This attribute is restricted to socket connection groups which
        are initiating a TCP connection and are under control of SoAd.
    :ivar tcp_role: Defines whether the local Address (that is
        aggregating the StaticSocketConnection) does a listen or a
        connect.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SocketAddress.staticSocketConnection
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATIC-SOCKET-CONNECTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StaticSocketConnection.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StaticSocketConnection.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_pdu_identifiers: Optional["StaticSocketConnection.IPduIdentifiers"] = field(
        default=None,
        metadata={
            "name": "I-PDU-IDENTIFIERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_addresss: Optional["StaticSocketConnection.RemoteAddresss"] = field(
        default=None,
        metadata={
            "name": "REMOTE-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_connect_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TCP-CONNECT-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_role: TcpRoleEnum | None = field(
        default=None,
        metadata={
            "name": "TCP-ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IPduIdentifiers:
        so_con_i_pdu_identifier_ref_conditional: list[SoConIPduIdentifierRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "SO-CON-I-PDU-IDENTIFIER-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RemoteAddresss:
        socket_address_ref_conditional: list[SocketAddressRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "SOCKET-ADDRESS-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StdCppImplementationDataType:
    """
    This meta-class represents the way to specify a data type definition that is
    taken as the basis for a C++ language binding to a C++ Standard Library
    feature.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar sw_data_def_props: The properties of this AutosarDataType.
    :ivar array_size: This attribute can be used to specify the array
        size if the enclosing CppImplementationDataType has array
        semantics.
    :ivar header_file: Configuration of the Header File with the custom
        class declaration.
    :ivar namespaces: This aggregation allows for the definition an own
        namespace for the enclosing CppImplementationDataType.
    :ivar sub_elements: This represents the collection of sub-elements
        of the enclosing CppImplementationDataType
    :ivar template_arguments: This aggregation allows for the
        specification of properties of template arguments
    :ivar type_emitter: This attribute can be taken to control how the
        respective CppImplementationDataType is contributed to the
        language binding.
    :ivar type_reference_ref: This reference shall be defined to define
        a type reference (a.k.a. typedef).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STD-CPP-IMPLEMENTATION-DATA-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StdCppImplementationDataType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StdCppImplementationDataType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["StdCppImplementationDataType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    array_size: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "ARRAY-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    header_file: String | None = field(
        default=None,
        metadata={
            "name": "HEADER-FILE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["StdCppImplementationDataType.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_elements: Optional["StdCppImplementationDataType.SubElements"] = field(
        default=None,
        metadata={
            "name": "SUB-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    template_arguments: Optional["StdCppImplementationDataType.TemplateArguments"] = field(
        default=None,
        metadata={
            "name": "TEMPLATE-ARGUMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_emitter: NmtokenString | None = field(
        default=None,
        metadata={
            "name": "TYPE-EMITTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_reference_ref: Optional["StdCppImplementationDataType.TypeReferenceRef"] = field(
        default=None,
        metadata={
            "name": "TYPE-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubElements:
        cpp_implementation_data_type_element: list[CppImplementationDataTypeElement] = field(
            default_factory=list,
            metadata={
                "name": "CPP-IMPLEMENTATION-DATA-TYPE-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TemplateArguments:
        cpp_template_argument: list[CppTemplateArgument] = field(
            default_factory=list,
            metadata={
                "name": "CPP-TEMPLATE-ARGUMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TypeReferenceRef(Ref):
        dest: CppImplementationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SubElementMapping:
    """
    This meta-class allows for the definition of mappings of elements of a
    composite data type.

    :ivar first_elements: This represents the first element referenced
        in the scope of the mapping. The upper multiplicity of this role
        has been increased to * due to resolving an atpVariation
        stereotype. The previous value was 1.
    :ivar second_elements: This represents the second element referenced
        in the scope of the mapping. The upper multiplicity of this role
        has been increased to * due to resolving an atpVariation
        stereotype. The previous value was 1.
    :ivar text_table_mappings: This allows for the text-table
        translation of individual elements of a composite data type.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SUB-ELEMENT-MAPPING"

    first_elements: Optional["SubElementMapping.FirstElements"] = field(
        default=None,
        metadata={
            "name": "FIRST-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    second_elements: Optional["SubElementMapping.SecondElements"] = field(
        default=None,
        metadata={
            "name": "SECOND-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    text_table_mappings: Optional["SubElementMapping.TextTableMappings"] = field(
        default=None,
        metadata={
            "name": "TEXT-TABLE-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FirstElements:
        application_composite_data_type_sub_element_ref: list[
            ApplicationCompositeDataTypeSubElementRef
        ] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-COMPOSITE-DATA-TYPE-SUB-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        implementation_data_type_sub_element_ref: list[ImplementationDataTypeSubElementRef] = field(
            default_factory=list,
            metadata={
                "name": "IMPLEMENTATION-DATA-TYPE-SUB-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecondElements:
        application_composite_data_type_sub_element_ref: list[
            ApplicationCompositeDataTypeSubElementRef
        ] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-COMPOSITE-DATA-TYPE-SUB-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        implementation_data_type_sub_element_ref: list[ImplementationDataTypeSubElementRef] = field(
            default_factory=list,
            metadata={
                "name": "IMPLEMENTATION-DATA-TYPE-SUB-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TextTableMappings:
        text_table_mapping: list[TextTableMapping] = field(
            default_factory=list,
            metadata={
                "name": "TEXT-TABLE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 2,
            },
        )


@dataclass(slots=True, kw_only=True)
class SupervisedEntityNeeds:
    """
    Specifies the abstract needs on the configuration of the Watchdog Manager for
    one specific Supervised Entity.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activate_at_start: true/false: supervision activation status
        of SupervisedEntity shall be enabled/disabled at start.
    :ivar checkpointss: This reference indicates the checkpoints
        belonging to the Supervised Entity. This property was modified
        due to atpVariation (DirectedAssociationPattern).
    :ivar enable_deactivation: true: software-component shall be allowed
        to deactivate supervision of this SupervisedEntity false:
        software-component shall be not allowed to deactivate
        supervision of this SupervisedEntity
    :ivar expected_alive_cycle: Expected cycle time of alive trigger of
        this SupervisedEntity (in seconds).
    :ivar max_alive_cycle: Maximum cycle time of alive trigger of this
        SupervisedEntity (in seconds).
    :ivar min_alive_cycle: Minimum cycle time of alive trigger of this
        SupervisedEntity (in seconds).
    :ivar tolerated_failed_cycles: Number of consecutive failed alive
        cycles for this SupervisedEntity which shall be tolerated until
        the supervision status of the SupervisedEntity is set to
        WDGM_ALIVE_EXPIRED (see SWS WdgM for more details). Note that
        this value has to be recalculated with respect to the WdgM's own
        cycle time for ECU configuration.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SUPERVISED-ENTITY-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SupervisedEntityNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SupervisedEntityNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activate_at_start: Boolean | None = field(
        default=None,
        metadata={
            "name": "ACTIVATE-AT-START",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    checkpointss: Optional["SupervisedEntityNeeds.Checkpointss"] = field(
        default=None,
        metadata={
            "name": "CHECKPOINTSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    enable_deactivation: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-DEACTIVATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    expected_alive_cycle: TimeValue | None = field(
        default=None,
        metadata={
            "name": "EXPECTED-ALIVE-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_alive_cycle: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MAX-ALIVE-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min_alive_cycle: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MIN-ALIVE-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tolerated_failed_cycles: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TOLERATED-FAILED-CYCLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Checkpointss:
        supervised_entity_checkpoint_needs_ref_conditional: list[
            SupervisedEntityCheckpointNeedsRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "SUPERVISED-ENTITY-CHECKPOINT-NEEDS-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwAxisType:
    """This meta-class represents a specific axis calculation strategy.

    No formal specification is given, due to the fact that it is
    possible to use arbitrary algorithms for calculating axis-points.
    Instead, the algorithm is described verbally but the parameters are
    specified formally with respect to their names and constraints. As a
    result, SwAxisType mainly reserves appropriate keywords.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar sw_generic_axis_desc: Associated axis description in textual
        form.
    :ivar sw_generic_axis_param_types: Parameters for this calculation
        algorithm.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-AXIS-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwAxisType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwAxisType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_generic_axis_desc: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "SW-GENERIC-AXIS-DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_generic_axis_param_types: Optional["SwAxisType.SwGenericAxisParamTypes"] = field(
        default=None,
        metadata={
            "name": "SW-GENERIC-AXIS-PARAM-TYPES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwGenericAxisParamTypes:
        sw_generic_axis_param_type: list[SwGenericAxisParamType] = field(
            default_factory=list,
            metadata={
                "name": "SW-GENERIC-AXIS-PARAM-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwComponentMappingConstraints:
    """
    Collection of constraints that are valid for particular SwComponentTypes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar rte_event_separations: Separation constraint that limits the
        mapping freedom for the mapping of RteEvents to OsTasks in the
        context of a SwComponent.
    :ivar rte_event_to_os_task_proxy_mappings: Constraint that enforces
        a mapping of RteEvent to a particular OsTask in the context of a
        SwComponent.
    :ivar swc_to_application_partition_mappings: Constraint that
        enforces a mapping of a Swc to a particular Application
        Partition. This aggregation contains a variation point although
        it is not variant. Therefore, this variation point shall not
        exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-COMPONENT-MAPPING-CONSTRAINTS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwComponentMappingConstraints.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwComponentMappingConstraints.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rte_event_separations: Optional["SwComponentMappingConstraints.RteEventSeparations"] = field(
        default=None,
        metadata={
            "name": "RTE-EVENT-SEPARATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rte_event_to_os_task_proxy_mappings: Optional[
        "SwComponentMappingConstraints.RteEventToOsTaskProxyMappings"
    ] = field(
        default=None,
        metadata={
            "name": "RTE-EVENT-TO-OS-TASK-PROXY-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_to_application_partition_mappings: Optional[
        "SwComponentMappingConstraints.SwcToApplicationPartitionMappings"
    ] = field(
        default=None,
        metadata={
            "name": "SWC-TO-APPLICATION-PARTITION-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RteEventSeparations:
        rte_event_in_composition_separation: list[RteEventInCompositionSeparation] = field(
            default_factory=list,
            metadata={
                "name": "RTE-EVENT-IN-COMPOSITION-SEPARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RteEventToOsTaskProxyMappings:
        rte_event_in_composition_to_os_task_proxy_mapping: list[
            RteEventInCompositionToOsTaskProxyMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "RTE-EVENT-IN-COMPOSITION-TO-OS-TASK-PROXY-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcToApplicationPartitionMappings:
        swc_to_application_partition_mapping: list[SwcToApplicationPartitionMapping] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TO-APPLICATION-PARTITION-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwcBswMapping:
    """Maps an SwcInternalBehavior to an BswInternalBehavior.

    This is required to coordinate the API generation and the scheduling
    for AUTOSAR Service Components, ECU Abstraction Components and
    Complex Driver Components by the RTE and the BSW scheduling
    mechanisms.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar bsw_behavior_ref: The mapped BswInternalBehavior
    :ivar runnable_mappings: A mapping between a pair of SWC and BSW
        runnables.
    :ivar swc_behavior_ref: The mapped SwcInternalBehavior.
    :ivar synchronized_mode_groups: A pair of SWC and BSW mode group
        prototypes to be synchronized by the scheduler.
    :ivar synchronized_triggers: A pair of SWC and BSW Triggers to be
        synchronized by the scheduler.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-BSW-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwcBswMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwcBswMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_behavior_ref: Optional["SwcBswMapping.BswBehaviorRef"] = field(
        default=None,
        metadata={
            "name": "BSW-BEHAVIOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runnable_mappings: Optional["SwcBswMapping.RunnableMappings"] = field(
        default=None,
        metadata={
            "name": "RUNNABLE-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_behavior_ref: Optional["SwcBswMapping.SwcBehaviorRef"] = field(
        default=None,
        metadata={
            "name": "SWC-BEHAVIOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    synchronized_mode_groups: Optional["SwcBswMapping.SynchronizedModeGroups"] = field(
        default=None,
        metadata={
            "name": "SYNCHRONIZED-MODE-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    synchronized_triggers: Optional["SwcBswMapping.SynchronizedTriggers"] = field(
        default=None,
        metadata={
            "name": "SYNCHRONIZED-TRIGGERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BswBehaviorRef(Ref):
        dest: BswInternalBehaviorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RunnableMappings:
        swc_bsw_runnable_mapping: list[SwcBswRunnableMapping] = field(
            default_factory=list,
            metadata={
                "name": "SWC-BSW-RUNNABLE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcBehaviorRef(Ref):
        dest: SwcInternalBehaviorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SynchronizedModeGroups:
        swc_bsw_synchronized_mode_group_prototype: list[SwcBswSynchronizedModeGroupPrototype] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SWC-BSW-SYNCHRONIZED-MODE-GROUP-PROTOTYPE",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

    @dataclass(slots=True, kw_only=True)
    class SynchronizedTriggers:
        swc_bsw_synchronized_trigger: list[SwcBswSynchronizedTrigger] = field(
            default_factory=list,
            metadata={
                "name": "SWC-BSW-SYNCHRONIZED-TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TcpOptionFilterSet:
    """
    Set of TcpOptionFilterLists.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar tcp_option_filter_lists: Collection of permitted lists for the
        filtering of TCP options.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TCP-OPTION-FILTER-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TcpOptionFilterSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TcpOptionFilterSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_option_filter_lists: Optional["TcpOptionFilterSet.TcpOptionFilterLists"] = field(
        default=None,
        metadata={
            "name": "TCP-OPTION-FILTER-LISTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TcpOptionFilterLists:
        tcp_option_filter_list: list[TcpOptionFilterList] = field(
            default_factory=list,
            metadata={
                "name": "TCP-OPTION-FILTER-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TdCpSoftwareClusterMappingSet:
    """
    This is used to gather of classic platform software cluster mappings.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar td_cp_software_cluster_resource_to_td_mappings: Maps a CP
        software cluster resource to a temporal resource.
    :ivar td_cp_software_cluster_to_td_mappings: Maps a temporal
        resource to a mapping between a providing CP software cluster
        and requesting CP software clusters.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-CP-SOFTWARE-CLUSTER-MAPPING-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdCpSoftwareClusterMappingSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdCpSoftwareClusterMappingSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_cp_software_cluster_resource_to_td_mappings: Optional[
        "TdCpSoftwareClusterMappingSet.TdCpSoftwareClusterResourceToTdMappings"
    ] = field(
        default=None,
        metadata={
            "name": "TD-CP-SOFTWARE-CLUSTER-RESOURCE-TO-TD-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_cp_software_cluster_to_td_mappings: Optional[
        "TdCpSoftwareClusterMappingSet.TdCpSoftwareClusterToTdMappings"
    ] = field(
        default=None,
        metadata={
            "name": "TD-CP-SOFTWARE-CLUSTER-TO-TD-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TdCpSoftwareClusterResourceToTdMappings:
        td_cp_software_cluster_resource_mapping: list[TdCpSoftwareClusterResourceMapping] = field(
            default_factory=list,
            metadata={
                "name": "TD-CP-SOFTWARE-CLUSTER-RESOURCE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TdCpSoftwareClusterToTdMappings:
        td_cp_software_cluster_mapping: list[TdCpSoftwareClusterMapping] = field(
            default_factory=list,
            metadata={
                "name": "TD-CP-SOFTWARE-CLUSTER-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TdEventOccurrenceExpression:
    """This is used to specify a filter on the occurrences of
    TimingDescriptionEvents by means of a TDEventOccurrenceExpressionFormula.

    Filter criteria can be variable and argument values, i.e. the timing
    event only occurs for specific values, as well as the temporal
    characteristics of the occurrences of arbitrary timing events.

    :ivar arguments: An occurrence expression can reference an arbitrary
        number of OperationArgumentPrototypes in its expression. This
        association aggregates instance references to
        OperationArgumentPrototypes which can be referenced in the
        expression. This aggregation contains a variation point although
        it is not variant. Therefore, this variation point shall not
        exist in models. See constr_2638.
    :ivar formula: This is the expression formula which is used to
        describe the occurrence expression.
    :ivar modes: An occurrence expression can reference an arbitrary
        number of TimingModeInstances in its expression. This
        association aggregates instance references to ModeDeclaration
        which can be referenced in the expression. This aggregation
        contains a variation point although it is not variant.
        Therefore, this variation point shall not exist in models. See
        constr_2638.
    :ivar variables: An occurrence expression can reference an arbitrary
        number of VariableDataPrototypes in its expression. This
        association aggregates instance references to
        VariableDataPrototypes which can be referenced in the
        expression. This aggregation contains a variation point although
        it is not variant. Therefore, this variation point shall not
        exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-OCCURRENCE-EXPRESSION"

    arguments: Optional["TdEventOccurrenceExpression.Arguments"] = field(
        default=None,
        metadata={
            "name": "ARGUMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: TdEventOccurrenceExpressionFormula | None = field(
        default=None,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    modes: Optional["TdEventOccurrenceExpression.Modes"] = field(
        default=None,
        metadata={
            "name": "MODES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variables: Optional["TdEventOccurrenceExpression.Variables"] = field(
        default=None,
        metadata={
            "name": "VARIABLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Arguments:
        autosar_operation_argument_instance: list[AutosarOperationArgumentInstance] = field(
            default_factory=list,
            metadata={
                "name": "AUTOSAR-OPERATION-ARGUMENT-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Modes:
        timing_mode_instance: list[TimingModeInstance] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-MODE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Variables:
        autosar_variable_instance: list[AutosarVariableInstance] = field(
            default_factory=list,
            metadata={
                "name": "AUTOSAR-VARIABLE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TdletZoneClock:
    """
    Describes a LET zone clock.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar platform_time_bases: Refers to a physical time base reference
        on the respective platform level This property was modified due
        to atpVariation (DirectedAssociationPattern).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingClock
    :ivar accuracy_ext: External synchronization accuracy within the LET
        Zone/Zone Clock.
    :ivar accuracy_int: Internal synchronization accuracy within the LET
        Zone/Zone Clock.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TDLET-ZONE-CLOCK"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdletZoneClock.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdletZoneClock.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    platform_time_bases: Optional["TdletZoneClock.PlatformTimeBases"] = field(
        default=None,
        metadata={
            "name": "PLATFORM-TIME-BASES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    accuracy_ext: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "ACCURACY-EXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    accuracy_int: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "ACCURACY-INT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PlatformTimeBases:
        global_time_domain_ref_conditional: list[GlobalTimeDomainRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "GLOBAL-TIME-DOMAIN-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TimeSyncModuleInstantiation:
    """
    This meta-class defines the attributes for the Time Synchronization
    configuration on a specific machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar time_bases: This aggregation defines the configured Time Bases
        for Time Synchronization.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIME-SYNC-MODULE-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TimeSyncModuleInstantiation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TimeSyncModuleInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_bases: Optional["TimeSyncModuleInstantiation.TimeBases"] = field(
        default=None,
        metadata={
            "name": "TIME-BASES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimeBases:
        synchronized_time_base_consumer: list[SynchronizedTimeBaseConsumer] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZED-TIME-BASE-CONSUMER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronized_time_base_provider: list[SynchronizedTimeBaseProvider] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZED-TIME-BASE-PROVIDER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TimingExtensionResource:
    """
    A TimingExtensionResource provides the capability to contain instance
    references referred from within a timing condition formula.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar timing_arguments: This refers to an instance reference of an
        argument of an operation call.
    :ivar timing_modes: This refers to an instance reference of a mode
        declaration.
    :ivar timing_variables: This refers to an instance reference of a
        variable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TIMING-EXTENSION-RESOURCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TimingExtensionResource.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TimingExtensionResource.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_arguments: Optional["TimingExtensionResource.TimingArguments"] = field(
        default=None,
        metadata={
            "name": "TIMING-ARGUMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_modes: Optional["TimingExtensionResource.TimingModes"] = field(
        default=None,
        metadata={
            "name": "TIMING-MODES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_variables: Optional["TimingExtensionResource.TimingVariables"] = field(
        default=None,
        metadata={
            "name": "TIMING-VARIABLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingArguments:
        autosar_operation_argument_instance: list[AutosarOperationArgumentInstance] = field(
            default_factory=list,
            metadata={
                "name": "AUTOSAR-OPERATION-ARGUMENT-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingModes:
        timing_mode_instance: list[TimingModeInstance] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-MODE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingVariables:
        autosar_variable_instance: list[AutosarVariableInstance] = field(
            default_factory=list,
            metadata={
                "name": "AUTOSAR-VARIABLE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TlsCryptoCipherSuite:
    """
    This meta-class represents a cipher suite for describing cryptographic
    operations in the context of establishing a connection of ApplicationEndpoints
    that is protected by TLS.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar authentication_ref: This reference identifies the crypto
        service primitive for the generation and verification of MACs.
    :ivar certificate_ref: This reference identifies the applicable
        local certificate.
    :ivar cipher_suite_id: Identification of the CipherSuite according
        to the IANA assignments list.
    :ivar cipher_suite_short_label: Name of the CipherSuite according to
        the IANA assignments list.
    :ivar elliptic_curve_refs: This references point to the properties
        of elliptic curves.
    :ivar encryption_ref: This reference identifies the crypto service
        primitive for the execution of encryption.
    :ivar key_exchange_authentication_refs: This reference identifies
        the crypto service primitives for the generation and
        verification of signatures during the key exchange algorithm.
    :ivar key_exchange_refs: This reference identifies the individual
        (i.e. per cipher suite) crypto service primitive for the
        execution of key exchange during the handshake phase.
    :ivar pre_shared_key_ref: This reference identifies the applicable
        cryptographic key if the handshake is based on the existence of
        a pre-shared key (PSK)
    :ivar priority: This attribute identifies the priority of the cipher
        suite. Range: 1..65535. Lower values represent higher
        priorities.
    :ivar props: The aggregated TlsCryptoCipherSuiteProps provide
        details for the TLS Cipher Suite.
    :ivar psk_identity: Pre-shared key identity shared during the
        handshake among the communication parties, to establish a TLS
        connection if the handshake is based on the existence of a pre-
        shared key.
    :ivar remote_certificate_ref: This reference identifies the
        applicable remote certificate.
    :ivar signature_scheme_refs: This reference points to the properties
        of a TLS Signature Scheme.
    :ivar version: This attribute supports the definition of the
        applicable version of TLS.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TLS-CRYPTO-CIPHER-SUITE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TlsCryptoCipherSuite.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TlsCryptoCipherSuite.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    authentication_ref: Optional["TlsCryptoCipherSuite.AuthenticationRef"] = field(
        default=None,
        metadata={
            "name": "AUTHENTICATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    certificate_ref: Optional["TlsCryptoCipherSuite.CertificateRef"] = field(
        default=None,
        metadata={
            "name": "CERTIFICATE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cipher_suite_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "CIPHER-SUITE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cipher_suite_short_label: String | None = field(
        default=None,
        metadata={
            "name": "CIPHER-SUITE-SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    elliptic_curve_refs: Optional["TlsCryptoCipherSuite.EllipticCurveRefs"] = field(
        default=None,
        metadata={
            "name": "ELLIPTIC-CURVE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    encryption_ref: Optional["TlsCryptoCipherSuite.EncryptionRef"] = field(
        default=None,
        metadata={
            "name": "ENCRYPTION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_exchange_authentication_refs: Optional[
        "TlsCryptoCipherSuite.KeyExchangeAuthenticationRefs"
    ] = field(
        default=None,
        metadata={
            "name": "KEY-EXCHANGE-AUTHENTICATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_exchange_refs: Optional["TlsCryptoCipherSuite.KeyExchangeRefs"] = field(
        default=None,
        metadata={
            "name": "KEY-EXCHANGE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pre_shared_key_ref: Optional["TlsCryptoCipherSuite.PreSharedKeyRef"] = field(
        default=None,
        metadata={
            "name": "PRE-SHARED-KEY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    props: TlsCryptoCipherSuiteProps | None = field(
        default=None,
        metadata={
            "name": "PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    psk_identity: TlsPskIdentity | None = field(
        default=None,
        metadata={
            "name": "PSK-IDENTITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_certificate_ref: Optional["TlsCryptoCipherSuite.RemoteCertificateRef"] = field(
        default=None,
        metadata={
            "name": "REMOTE-CERTIFICATE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signature_scheme_refs: Optional["TlsCryptoCipherSuite.SignatureSchemeRefs"] = field(
        default=None,
        metadata={
            "name": "SIGNATURE-SCHEME-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: TlsVersionEnum | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AuthenticationRef(Ref):
        dest: CryptoServicePrimitiveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CertificateRef(Ref):
        dest: CryptoServiceCertificateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EllipticCurveRefs:
        elliptic_curve_ref: list["TlsCryptoCipherSuite.EllipticCurveRefs.EllipticCurveRef"] = field(
            default_factory=list,
            metadata={
                "name": "ELLIPTIC-CURVE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EllipticCurveRef(Ref):
            dest: CryptoEllipticCurvePropsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class EncryptionRef(Ref):
        dest: CryptoServicePrimitiveSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class KeyExchangeAuthenticationRefs:
        key_exchange_authentication_ref: list[
            "TlsCryptoCipherSuite.KeyExchangeAuthenticationRefs.KeyExchangeAuthenticationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "KEY-EXCHANGE-AUTHENTICATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class KeyExchangeAuthenticationRef(Ref):
            dest: CryptoServicePrimitiveSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class KeyExchangeRefs:
        key_exchange_ref: list["TlsCryptoCipherSuite.KeyExchangeRefs.KeyExchangeRef"] = field(
            default_factory=list,
            metadata={
                "name": "KEY-EXCHANGE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class KeyExchangeRef(Ref):
            dest: CryptoServicePrimitiveSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PreSharedKeyRef(Ref):
        dest: CryptoServiceKeySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RemoteCertificateRef(Ref):
        dest: CryptoServiceCertificateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SignatureSchemeRefs:
        signature_scheme_ref: list[
            "TlsCryptoCipherSuite.SignatureSchemeRefs.SignatureSchemeRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SIGNATURE-SCHEME-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SignatureSchemeRef(Ref):
            dest: CryptoSignatureSchemeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class TlsDeployment:
    """
    The meta-class represents the ability to define a deployment of the TLS
    communication protocol configuration settings to crypto module entities.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar psk_identity_to_key_slot_mappings: Mapping of TLS-PSK to a
        concrete key defined in the CryptoDeployment.
    :ivar tls_job_mappings: Mapping of the JobRequirement to a concrete
        crypto job.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TLS-DEPLOYMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TlsDeployment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TlsDeployment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    psk_identity_to_key_slot_mappings: Optional["TlsDeployment.PskIdentityToKeySlotMappings"] = (
        field(
            default=None,
            metadata={
                "name": "PSK-IDENTITY-TO-KEY-SLOT-MAPPINGS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    tls_job_mappings: Optional["TlsDeployment.TlsJobMappings"] = field(
        default=None,
        metadata={
            "name": "TLS-JOB-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PskIdentityToKeySlotMappings:
        psk_identity_to_key_slot_mapping: list[PskIdentityToKeySlotMapping] = field(
            default_factory=list,
            metadata={
                "name": "PSK-IDENTITY-TO-KEY-SLOT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TlsJobMappings:
        tls_job_mapping: list[TlsJobMapping] = field(
            default_factory=list,
            metadata={
                "name": "TLS-JOB-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TransformationPropsSet:
    """
    Collection of TransformationProps.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar transformation_propss: Transformer specific configuration
        properties.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRANSFORMATION-PROPS-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TransformationPropsSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TransformationPropsSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformation_propss: Optional["TransformationPropsSet.TransformationPropss"] = field(
        default=None,
        metadata={
            "name": "TRANSFORMATION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TransformationPropss:
        ap_someip_transformation_props: list[ApSomeipTransformationProps] = field(
            default_factory=list,
            metadata={
                "name": "AP-SOMEIP-TRANSFORMATION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_transformation_props: list[SomeipTransformationProps] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-TRANSFORMATION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_transformation_props: list[UserDefinedTransformationProps] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-TRANSFORMATION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TransientFault:
    """
    The reported failure is classified as runtime error.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar id: ID of detected failure used in reporting API as error or
        fault id.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ErrorTracerNeeds.tracedFailure
    :ivar possible_error_reactions: Describes a possible error reactions
        for the transient fault handler.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRANSIENT-FAULT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TransientFault.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TransientFault.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    possible_error_reactions: Optional["TransientFault.PossibleErrorReactions"] = field(
        default=None,
        metadata={
            "name": "POSSIBLE-ERROR-REACTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PossibleErrorReactions:
        possible_error_reaction: list[PossibleErrorReaction] = field(
            default_factory=list,
            metadata={
                "name": "POSSIBLE-ERROR-REACTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TransmissionModeTiming:
    """If the COM Transmission Mode is false the timing is aggregated by the
    TransmissionModeTiming element in the role of transmissionModeFalseTiming.

    If the COM Transmission Mode is true the timing is aggregated by the TransmissionModeTiming element in the role of transmissionModeTrueTiming.
    COM supports the following Transmission Modes:
    * Periodic (Cyclic Timing)
    * Direct /n-times (EventControlledTiming)
    * Mixed (Cyclic and EventControlledTiming are assigned)
    * None (no timing is assigned)

    :ivar cyclic_timing: Periodic Transmission Mode.
    :ivar event_controlled_timing: Direct Transmission Mode.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRANSMISSION-MODE-TIMING"

    cyclic_timing: CyclicTiming | None = field(
        default=None,
        metadata={
            "name": "CYCLIC-TIMING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_controlled_timing: EventControlledTiming | None = field(
        default=None,
        metadata={
            "name": "EVENT-CONTROLLED-TIMING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TriggerInterface:
    """
    A trigger interface declares a number of triggers that can be sent by an
    trigger source.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar triggers: The Trigger of this trigger interface. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRIGGER-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TriggerInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TriggerInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["TriggerInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["TriggerInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    triggers: Optional["TriggerInterface.Triggers"] = field(
        default=None,
        metadata={
            "name": "TRIGGERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Triggers:
        trigger: list[Trigger] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TtcanCommunicationConnector:
    """
    TTCAN bus specific communication connector attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar comm_controller_ref: Reference to the communication
        controller. The CommunicationConnector and referenced
        CommunicationController shall be aggregated by the same
        ECUInstance. The communicationController can be referenced by
        several CommunicationConnector elements. This is important for
        the FlexRay Bus. FlexRay communicates via two physical channels.
        But only one controller in an ECU is responsible for both
        channels. Thus, two connectors (for channel A and for channel B)
        shall reference to the same controller.
    :ivar create_ecu_wakeup_source: If this parameter is available and
        set to true then a channel wakeup source shall be created for
        the PhysicalChannel referencing this CommunicationConnector.
    :ivar dynamic_pnc_to_channel_mapping_enabled: Defines if this
        EcuInstance shall implement the dynamic PNC-to-channel-mapping
        functionality on this CommunicationConnector and its respective
        PhysicalChannel.
    :ivar ecu_comm_port_instances: An ECUs reception or send ports.
        atpVariation: If signals/PDUs/frames are variable, the
        corresponding ports shall be variable, too.
    :ivar pnc_filter_array_masks: Bit mask for NM-Pdu Payload used to
        configure the NM filter mask for the Network Management.
    :ivar pnc_gateway_type: Defines if this EcuInstance shall implement
        the PncGateway functionality on this CommunicationConnector and
        its respective PhysicalChannel. Several EcuInstances on the same
        PhysicalChannel can have the PncGateway functionality enabled,
        but only one of them shall have the pncGatewayType "active".
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: EcuInstance.connector
        Not Applicable for: MachineDesign.communicationConnector
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TTCAN-COMMUNICATION-CONNECTOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TtcanCommunicationConnector.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TtcanCommunicationConnector.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_controller_ref: Optional["TtcanCommunicationConnector.CommControllerRef"] = field(
        default=None,
        metadata={
            "name": "COMM-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    create_ecu_wakeup_source: Boolean | None = field(
        default=None,
        metadata={
            "name": "CREATE-ECU-WAKEUP-SOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_pnc_to_channel_mapping_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "DYNAMIC-PNC-TO-CHANNEL-MAPPING-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_comm_port_instances: Optional["TtcanCommunicationConnector.EcuCommPortInstances"] = field(
        default=None,
        metadata={
            "name": "ECU-COMM-PORT-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_filter_array_masks: Optional["TtcanCommunicationConnector.PncFilterArrayMasks"] = field(
        default=None,
        metadata={
            "name": "PNC-FILTER-ARRAY-MASKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_gateway_type: PncGatewayTypeEnum | None = field(
        default=None,
        metadata={
            "name": "PNC-GATEWAY-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommControllerRef(Ref):
        dest: CommunicationControllerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuCommPortInstances:
        frame_port: list[FramePort] = field(
            default_factory=list,
            metadata={
                "name": "FRAME-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_pdu_port: list[IPduPort] = field(
            default_factory=list,
            metadata={
                "name": "I-PDU-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_signal_port: list[ISignalPort] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PncFilterArrayMasks:
        pnc_filter_array_mask: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "PNC-FILTER-ARRAY-MASK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TtcanCommunicationController:
    """
    TTCAN bus specific communication port attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EcuInstance.commController Not Applicable for:
        MachineDesign.communicationController
    :ivar ttcan_communication_controller_variants: This element was
        generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TTCAN-COMMUNICATION-CONTROLLER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TtcanCommunicationController.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TtcanCommunicationController.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ttcan_communication_controller_variants: Optional[
        "TtcanCommunicationController.TtcanCommunicationControllerVariants"
    ] = field(
        default=None,
        metadata={
            "name": "TTCAN-COMMUNICATION-CONTROLLER-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TtcanCommunicationControllerVariants:
        ttcan_communication_controller_conditional: list[
            TtcanCommunicationControllerConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-COMMUNICATION-CONTROLLER-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class UcmMasterModuleInstantiation:
    """
    This meta-class represents the ability to define the deployment of a UCM Master
    instantiation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar identifier: This represents the identification of a UCM.
    :ivar max_block_size: This attribute denotes the maximum block size
        (unit: bytes) used in the UCM implementation.
    :ivar version: This attribute defines the software version of the
        UCM on this platform. Note that the definition of the version is
        required if the ability of the SoftwarePackage to require a
        minimum version of the UCM is utilized.
    :ivar block_inconsistent: This attribute defines the retry strategy
        of the UCM Master for the case that the block is inconsistent.
    :ivar service_busy: This attribute defines the retry strategy of the
        UCM Master for the case that the service is busy.
    :ivar update_session_rejected: This attribute defines the retry
        strategy of the UcmMaster for the case that the update session
        is rejected.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UCM-MASTER-MODULE-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UcmMasterModuleInstantiation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UcmMasterModuleInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    identifier: String | None = field(
        default=None,
        metadata={
            "name": "IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_block_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-BLOCK-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: StrongRevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    block_inconsistent: UcmRetryStrategy | None = field(
        default=None,
        metadata={
            "name": "BLOCK-INCONSISTENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_busy: UcmRetryStrategy | None = field(
        default=None,
        metadata={
            "name": "SERVICE-BUSY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update_session_rejected: UcmRetryStrategy | None = field(
        default=None,
        metadata={
            "name": "UPDATE-SESSION-REJECTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class UcmStep:
    """
    This meta-class represents the ability to define a rollout-condition for a
    vehicle update campaign.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar software_package_steps: This aggregation represents the
        sequence of activities to be carried out in the context of the
        respective UCM.
    :ivar ucm_ref: This reference identifies the UCM for which the
        rollout step applies.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UCM-STEP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UcmStep.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UcmStep.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_package_steps: Optional["UcmStep.SoftwarePackageSteps"] = field(
        default=None,
        metadata={
            "name": "SOFTWARE-PACKAGE-STEPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ucm_ref: Optional["UcmStep.UcmRef"] = field(
        default=None,
        metadata={
            "name": "UCM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SoftwarePackageSteps:
        software_package_step: list[SoftwarePackageStep] = field(
            default_factory=list,
            metadata={
                "name": "SOFTWARE-PACKAGE-STEP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class UcmRef(Ref):
        dest: UcmDescriptionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class UcmSubordinateModuleInstantiation:
    """
    This meta-class represents the ability to define the deployment of a UCM
    Subordinate instantiation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar identifier: This represents the identification of a UCM.
    :ivar max_block_size: This attribute denotes the maximum block size
        (unit: bytes) used in the UCM implementation.
    :ivar version: This attribute defines the software version of the
        UCM on this platform. Note that the definition of the version is
        required if the ability of the SoftwarePackage to require a
        minimum version of the UCM is utilized.
    :ivar prepare_rollback: This attribute identifies the configuration
        of prepare rollback retries initiated by the Ucm Subordinate.
    :ivar prepare_update: This attribute identifies the configuration of
        prepare update retries initiated by the Ucm Subordinate.
    :ivar verify_update: This attribute identifies the configuration of
        verify update retries initiated by the Ucm Subordinate.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UCM-SUBORDINATE-MODULE-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UcmSubordinateModuleInstantiation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UcmSubordinateModuleInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    identifier: String | None = field(
        default=None,
        metadata={
            "name": "IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_block_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-BLOCK-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: StrongRevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prepare_rollback: UcmRetryStrategy | None = field(
        default=None,
        metadata={
            "name": "PREPARE-ROLLBACK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prepare_update: UcmRetryStrategy | None = field(
        default=None,
        metadata={
            "name": "PREPARE-UPDATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verify_update: UcmRetryStrategy | None = field(
        default=None,
        metadata={
            "name": "VERIFY-UPDATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class UdpNmCluster:
    """
    Udp specific NmCluster attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar communication_cluster_ref: Association to a
        CommunicationCluster in the topology description.
    :ivar nm_channel_id: This attribute has the status "removed" and
        shall not be used any longer. Old description: Channel
        identification number of the corresponding channel. Must be
        unique over all NmClusters.
    :ivar nm_channel_sleep_master: This parameter shall be set to
        indicate if the sleep of this network can be absolutely decided
        by the local node only and that no other nodes can oppose that
        decision.
    :ivar nm_nodes: Collection of NmNodes of the NmCluster.
        atpVariation: Derived, because NmNode can be variable.
    :ivar nm_node_detection_enabled: Enables the Request Repeat Message
        Request support. Only valid if nmNodeIdEnabled is set to true.
    :ivar nm_node_id_enabled: Enables the source node identifier.
    :ivar nm_pnc_participation: Defines whether this NmCluster
        contributes to the partial network mechanism.
    :ivar nm_repeat_msg_ind_enabled: Switch for enabling the Repeat
        Message Bit Indication.
    :ivar nm_synchronizing_network: If this parameter is true, then this
        network is a synchronizing network for the NM coordination
        cluster which it belongs to. The network is expected to call
        Nm_SynchronizationPoint() at regular intervals.
    :ivar pnc_cluster_vector_length: Optionally defines the length of
        the PNC Vector per CommunicationCluster (and VLAN in case of
        UdpNm). If not defined then System.pncVectorLength applies.
        Should only make the PNC Vector shorter (or same length as
        defined in System.pncVectorLength).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: NmConfig.nmCluster
    :ivar network_configuration: Configuration of a UDP port and UDP
        multicast IP address of the Nm communication on a VLAN.
    :ivar nm_cbv_position: Defines the position of the control bit
        vector within the Nm Pdu (Byte position). If this attribute is
        not configured, the Control Bit Vector is not used.
    :ivar nm_channel_active: This switch determines if the respective
        UdpNm channel is active or not. Indicates whether a particular
        UdpNm channel shall be initialized (TRUE) or not (FALSE). If
        this parameter is set to FALSE the respective NM instance shall
        not be used during runtime.
    :ivar nm_immediate_nm_cycle_time: Defines the immediate NmPdu cycle
        time in seconds which is used for nmImmediateNmTransmissions
        NmPdu transmissions. This attribute is only valid if
        nmImmediateNmTransmissions is greater one.
    :ivar nm_immediate_nm_transmissions: Defines the number of immediate
        NmPdus which shall be transmitted. If the value is zero no
        immediate NmPdus are transmitted. The cycle time of immediate
        NmPdus is defined by nmImmediateNmCycleTime.
    :ivar nm_message_timeout_time: Timeout of a NmPdu in seconds. It
        determines how long the NM shall wait with notification of
        transmission failure while communication errors occur on the
        bus.
    :ivar nm_msg_cycle_time: Period of a NmPdu in seconds. It determines
        the periodic rate in the periodic transmission mode with bus
        load reduction and is the basis for transmit scheduling in the
        periodic transmission mode without bus load reduction.
    :ivar nm_network_timeout: Network Timeout for NmPdus in seconds. It
        denotes the time how long the UdpNm shall stay in the Network
        Mode before transition into Prepare Bus-Sleep Mode shall take
        place.
    :ivar nm_nid_position: Defines the byte position of the source node
        identifier within the NmPdu. If this attribute is not
        configured, the Node Identification is not used.
    :ivar nm_remote_sleep_indication_time: Timeout for Remote Sleep
        Indication in seconds. It defines the time how long it shall
        take to recognize that all other nodes are ready to sleep.
    :ivar nm_repeat_message_time: Timeout for Repeat Message State in
        seconds. Defines the time how long the NM shall stay in the
        Repeat Message State.
    :ivar nm_user_data_length: Defines the length in bytes of the user
        data contained in the Nm message. User data excludes the PNC bit
        vector.
    :ivar nm_user_data_offset: Specifies the offset (in bytes) of the
        user data information in the NM message. User data excludes the
        PNC bit vector.
    :ivar nm_wait_bus_sleep_time: Timeout for bus calm down phase in
        seconds. It denotes the time how long the CanNm shall stay in
        the Prepare Bus-Sleep Mode before transition into Bus-Sleep Mode
        shall take place.
    :ivar vlan_ref: Reference to the vlan (represented by the
        EthernetPhysicalChannel) this UdpNmCluster shall apply to.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "UDP-NM-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UdpNmCluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UdpNmCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_ref: Optional["UdpNmCluster.CommunicationClusterRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_channel_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-CHANNEL-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_channel_sleep_master: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CHANNEL-SLEEP-MASTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_nodes: Optional["UdpNmCluster.NmNodes"] = field(
        default=None,
        metadata={
            "name": "NM-NODES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_detection_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-DETECTION-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_node_id_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-NODE-ID-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_pnc_participation: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-PNC-PARTICIPATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_repeat_msg_ind_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-REPEAT-MSG-IND-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_synchronizing_network: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-SYNCHRONIZING-NETWORK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_cluster_vector_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PNC-CLUSTER-VECTOR-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_configuration: UdpNmNetworkConfiguration | None = field(
        default=None,
        metadata={
            "name": "NETWORK-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_cbv_position: Integer | None = field(
        default=None,
        metadata={
            "name": "NM-CBV-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_channel_active: Boolean | None = field(
        default=None,
        metadata={
            "name": "NM-CHANNEL-ACTIVE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_immediate_nm_cycle_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-IMMEDIATE-NM-CYCLE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_immediate_nm_transmissions: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-IMMEDIATE-NM-TRANSMISSIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_message_timeout_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-MESSAGE-TIMEOUT-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_msg_cycle_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-MSG-CYCLE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_network_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-NETWORK-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_nid_position: Integer | None = field(
        default=None,
        metadata={
            "name": "NM-NID-POSITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_remote_sleep_indication_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-REMOTE-SLEEP-INDICATION-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_repeat_message_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-REPEAT-MESSAGE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_user_data_length: Integer | None = field(
        default=None,
        metadata={
            "name": "NM-USER-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_user_data_offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NM-USER-DATA-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_wait_bus_sleep_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NM-WAIT-BUS-SLEEP-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vlan_ref: Optional["UdpNmCluster.VlanRef"] = field(
        default=None,
        metadata={
            "name": "VLAN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class NmNodes:
        can_nm_node: list[CanNmNode] = field(
            default_factory=list,
            metadata={
                "name": "CAN-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_nm_node: list[FlexrayNmNode] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_nm_node: list[J1939NmNode] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        udp_nm_node: list[UdpNmNode] = field(
            default_factory=list,
            metadata={
                "name": "UDP-NM-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class VlanRef(Ref):
        dest: EthernetPhysicalChannelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedCommunicationConnector:
    """
    This element allows the modeling of arbitrary Communication Connectors.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar comm_controller_ref: Reference to the communication
        controller. The CommunicationConnector and referenced
        CommunicationController shall be aggregated by the same
        ECUInstance. The communicationController can be referenced by
        several CommunicationConnector elements. This is important for
        the FlexRay Bus. FlexRay communicates via two physical channels.
        But only one controller in an ECU is responsible for both
        channels. Thus, two connectors (for channel A and for channel B)
        shall reference to the same controller.
    :ivar create_ecu_wakeup_source: If this parameter is available and
        set to true then a channel wakeup source shall be created for
        the PhysicalChannel referencing this CommunicationConnector.
    :ivar dynamic_pnc_to_channel_mapping_enabled: Defines if this
        EcuInstance shall implement the dynamic PNC-to-channel-mapping
        functionality on this CommunicationConnector and its respective
        PhysicalChannel.
    :ivar ecu_comm_port_instances: An ECUs reception or send ports.
        atpVariation: If signals/PDUs/frames are variable, the
        corresponding ports shall be variable, too.
    :ivar pnc_filter_array_masks: Bit mask for NM-Pdu Payload used to
        configure the NM filter mask for the Network Management.
    :ivar pnc_gateway_type: Defines if this EcuInstance shall implement
        the PncGateway functionality on this CommunicationConnector and
        its respective PhysicalChannel. Several EcuInstances on the same
        PhysicalChannel can have the PncGateway functionality enabled,
        but only one of them shall have the pncGatewayType "active".
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: EcuInstance.connector
        Not Applicable for: MachineDesign.communicationConnector
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-COMMUNICATION-CONNECTOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UserDefinedCommunicationConnector.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedCommunicationConnector.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_controller_ref: Optional["UserDefinedCommunicationConnector.CommControllerRef"] = field(
        default=None,
        metadata={
            "name": "COMM-CONTROLLER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    create_ecu_wakeup_source: Boolean | None = field(
        default=None,
        metadata={
            "name": "CREATE-ECU-WAKEUP-SOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_pnc_to_channel_mapping_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "DYNAMIC-PNC-TO-CHANNEL-MAPPING-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_comm_port_instances: Optional["UserDefinedCommunicationConnector.EcuCommPortInstances"] = (
        field(
            default=None,
            metadata={
                "name": "ECU-COMM-PORT-INSTANCES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    pnc_filter_array_masks: Optional["UserDefinedCommunicationConnector.PncFilterArrayMasks"] = (
        field(
            default=None,
            metadata={
                "name": "PNC-FILTER-ARRAY-MASKS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    pnc_gateway_type: PncGatewayTypeEnum | None = field(
        default=None,
        metadata={
            "name": "PNC-GATEWAY-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommControllerRef(Ref):
        dest: CommunicationControllerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuCommPortInstances:
        frame_port: list[FramePort] = field(
            default_factory=list,
            metadata={
                "name": "FRAME-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_pdu_port: list[IPduPort] = field(
            default_factory=list,
            metadata={
                "name": "I-PDU-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_signal_port: list[ISignalPort] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PncFilterArrayMasks:
        pnc_filter_array_mask: list[PositiveInteger] = field(
            default_factory=list,
            metadata={
                "name": "PNC-FILTER-ARRAY-MASK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedCommunicationController:
    """
    This element allows the modeling of arbitrary Communication Controllers.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EcuInstance.commController Not Applicable for:
        MachineDesign.communicationController
    :ivar user_defined_communication_controller_variants: This element
        was generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-COMMUNICATION-CONTROLLER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UserDefinedCommunicationController.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedCommunicationController.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    user_defined_communication_controller_variants: Optional[
        "UserDefinedCommunicationController.UserDefinedCommunicationControllerVariants"
    ] = field(
        default=None,
        metadata={
            "name": "USER-DEFINED-COMMUNICATION-CONTROLLER-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class UserDefinedCommunicationControllerVariants:
        user_defined_communication_controller_conditional: list[
            UserDefinedCommunicationControllerConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-COMMUNICATION-CONTROLLER-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedEthernetFrame:
    """
    UserDefinedEthernetFrame allows the description of a frame-based communication
    to Complex Drivers that are located above the EthDrv.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar frame_length: The used length (in bytes) of the referencing
        frame. Should not be confused with a static byte length reserved
        for each frame by some platforms (e.g. FlexRay). The frameLength
        of zero bytes is allowed. Please consider also TPS_SYST_02255.
    :ivar pdu_to_frame_mappings: A frames layout as a sequence of Pdus.
        atpVariation: The content of a frame can be variable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-ETHERNET-FRAME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UserDefinedEthernetFrame.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedEthernetFrame.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_length: Integer | None = field(
        default=None,
        metadata={
            "name": "FRAME-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_to_frame_mappings: Optional["UserDefinedEthernetFrame.PduToFrameMappings"] = field(
        default=None,
        metadata={
            "name": "PDU-TO-FRAME-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduToFrameMappings:
        pdu_to_frame_mapping: list[PduToFrameMapping] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TO-FRAME-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedFieldDeployment:
    """
    UserDefined configuration settings for a Field.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar field_ref: Reference to a Field that is deployed to a
        middleware transport layer.
    :ivar get: This aggregation represents the settings of the get
        method
    :ivar notifier: This aggregation represents the settings of the
        notifier.
    :ivar set: This aggregation represents the settings of the set
        method
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-FIELD-DEPLOYMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UserDefinedFieldDeployment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedFieldDeployment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_ref: Optional["UserDefinedFieldDeployment.FieldRef"] = field(
        default=None,
        metadata={
            "name": "FIELD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    get: UserDefinedMethodDeployment | None = field(
        default=None,
        metadata={
            "name": "GET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    notifier: UserDefinedEventDeployment | None = field(
        default=None,
        metadata={
            "name": "NOTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    set: UserDefinedMethodDeployment | None = field(
        default=None,
        metadata={
            "name": "SET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FieldRef(Ref):
        dest: FieldSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedTransformationISignalProps:
    """
    The UserDefinedTransformationISignalProps is used to specify ISignal specific
    configuration properties for custom transformers.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar user_defined_transformation_i_signal_props_variants: This
        element was generated/modified due to an atpVariation
        stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-TRANSFORMATION-I-SIGNAL-PROPS"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    user_defined_transformation_i_signal_props_variants: Optional[
        "UserDefinedTransformationISignalProps.UserDefinedTransformationISignalPropsVariants"
    ] = field(
        default=None,
        metadata={
            "name": "USER-DEFINED-TRANSFORMATION-I-SIGNAL-PROPS-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class UserDefinedTransformationISignalPropsVariants:
        user_defined_transformation_i_signal_props_conditional: list[
            UserDefinedTransformationISignalPropsConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-TRANSFORMATION-I-SIGNAL-PROPS-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ValueGroup:
    """This element enables values  to be grouped.

    It can be used to perform row and column-orientated groupings, so
    that these can be rendered properly e.g. as a table.

    :ivar label: This label allows to give the valueGroup a particular
        name. It can be used if the Values are rendered as a table.
    :ivar vtf: This aggregation represents the ability to provide a
        value that is either numerical or text which existence is
        subject to variability. From the formal point of view, the
        aggregation needs to have the multiplicity 1 because SwValues is
        modelled with stereotype &lt;&lt;atpMixed&gt;&gt;. Nevertheless,
        the existence of vtf is optional and subject to constraints. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar vf: This allows to specify the value as VariationPoint. It is
        distinguished to non variant for sake of compatibility to ASAM
        CDF 2.0.
    :ivar vt: This represents the values of textual data elements
        (Strings). Note that vt uses the | to separate the values for
        the different bitfield masks in case that the semantics of the
        related DataPrototype is described by means of a
        BITFIELD_TEXTTABLE in the associated CompuMethod.
    :ivar v: This is a non variant Value. It is provided for sake of
        Compatibility to ASAM CDF.
    :ivar vg: This allows to have intersections in the values in order
        to support specific rendering (eg. using stylesheets). For tools
        it is important that the v values are always processed in the
        same (flattened) order and the tool is able to interpret it
        without respecting vg.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VALUE-GROUP"

    label: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vtf: list[NumericalOrText] = field(
        default_factory=list,
        metadata={
            "name": "VTF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vf: list[NumericalValueVariationPoint] = field(
        default_factory=list,
        metadata={
            "name": "VF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vt: list[VerbatimString] = field(
        default_factory=list,
        metadata={
            "name": "VT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    v: list[NumericalValue] = field(
        default_factory=list,
        metadata={
            "name": "V",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vg: list["ValueGroup"] = field(
        default_factory=list,
        metadata={
            "name": "VG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ViewMap:
    """The ViewMap allows to relate any number of elements on the "first" side to
    any number of elements on the "second" side.

    Since the ViewMap does not address a specific mapping use-case the
    roles "first" and "second" shall imply this generality. This mapping
    allows to trace transformations of artifacts within the AUTOSAR
    environment. The references to the mapped elements can be plain
    references and/or InstanceRefs.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar role: This attribute is used to describe specific mapping
        scenarios, e.g. the mappings: *
        AR_AbstractSystemDescription_SystemDescription *
        AR_SystemDescription_SystemExtract
    :ivar first_element_refs: Reference to identifiable elements on the
        first "side".
    :ivar second_element_refs: Reference to identifiable elements on the
        second "side".
    :ivar first_element_instance_irefs: InstanceRefs to elements on the
        first "side". This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar second_element_instance_irefs: InstanceRefs to elements on the
        second "side". This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VIEW-MAP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ViewMap.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ViewMap.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    role: Identifier | None = field(
        default=None,
        metadata={
            "name": "ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    first_element_refs: Optional["ViewMap.FirstElementRefs"] = field(
        default=None,
        metadata={
            "name": "FIRST-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    second_element_refs: Optional["ViewMap.SecondElementRefs"] = field(
        default=None,
        metadata={
            "name": "SECOND-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    first_element_instance_irefs: Optional["ViewMap.FirstElementInstanceIrefs"] = field(
        default=None,
        metadata={
            "name": "FIRST-ELEMENT-INSTANCE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    second_element_instance_irefs: Optional["ViewMap.SecondElementInstanceIrefs"] = field(
        default=None,
        metadata={
            "name": "SECOND-ELEMENT-INSTANCE-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FirstElementRefs:
        first_element_ref: list["ViewMap.FirstElementRefs.FirstElementRef"] = field(
            default_factory=list,
            metadata={
                "name": "FIRST-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FirstElementRef(Ref):
            dest: ReferrableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SecondElementRefs:
        second_element_ref: list["ViewMap.SecondElementRefs.SecondElementRef"] = field(
            default_factory=list,
            metadata={
                "name": "SECOND-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SecondElementRef(Ref):
            dest: ReferrableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class FirstElementInstanceIrefs:
        first_element_instance_iref: list[AnyInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "FIRST-ELEMENT-INSTANCE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecondElementInstanceIrefs:
        second_element_instance_iref: list[AnyInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "SECOND-ELEMENT-INSTANCE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BusMirrorChannelMappingCan:
    """
    This element defines the bus mirroring between a CAN or LIN sourceChannel and a
    CAN targetChannel.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar source_channel: Defines the sourceChannel from which frames
        are received.
    :ivar target_channel: Defines the targetChannel to which frames are
        forwarded.
    :ivar target_pdu_triggerings: Reference to the PduTriggering that is
        used for transmission of the mirrored frames on the
        targetChannel. Please note that on FlexRay several
        targetPduTriggerings may be used. For all other communication
        channels only a single targetPduTriggering is supported. This
        property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar can_id_range_mappings: Rules for remapping of a set of CAN
        IDs.
    :ivar can_id_to_can_id_mappings: Rules for remapping of single
        CanIds.
    :ivar lin_pid_to_can_id_mappings: Rules for remapping of single LIN
        Frames.
    :ivar mirror_source_lin_to_can_range_base_id: Base ID merged with
        the LIN frame ID to form the CAN ID. Only required when a
        BusMirrorChannel that refers to a LinPhysicalChannel in the role
        channel is referenced in the role sourceChannel.
    :ivar mirror_status_can_id: CAN ID of the CAN status frame. If
        configured, a status frame will be sent on the CAN destination
        bus that contains the state of all active source buses.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUS-MIRROR-CHANNEL-MAPPING-CAN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BusMirrorChannelMappingCan.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BusMirrorChannelMappingCan.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_channel: BusMirrorChannel | None = field(
        default=None,
        metadata={
            "name": "SOURCE-CHANNEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_channel: BusMirrorChannel | None = field(
        default=None,
        metadata={
            "name": "TARGET-CHANNEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_pdu_triggerings: Optional["BusMirrorChannelMappingCan.TargetPduTriggerings"] = field(
        default=None,
        metadata={
            "name": "TARGET-PDU-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_id_range_mappings: Optional["BusMirrorChannelMappingCan.CanIdRangeMappings"] = field(
        default=None,
        metadata={
            "name": "CAN-ID-RANGE-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_id_to_can_id_mappings: Optional["BusMirrorChannelMappingCan.CanIdToCanIdMappings"] = field(
        default=None,
        metadata={
            "name": "CAN-ID-TO-CAN-ID-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lin_pid_to_can_id_mappings: Optional["BusMirrorChannelMappingCan.LinPidToCanIdMappings"] = (
        field(
            default=None,
            metadata={
                "name": "LIN-PID-TO-CAN-ID-MAPPINGS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    mirror_source_lin_to_can_range_base_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIRROR-SOURCE-LIN-TO-CAN-RANGE-BASE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mirror_status_can_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MIRROR-STATUS-CAN-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TargetPduTriggerings:
        pdu_triggering_ref_conditional: list[PduTriggeringRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CanIdRangeMappings:
        bus_mirror_can_id_range_mapping: list[BusMirrorCanIdRangeMapping] = field(
            default_factory=list,
            metadata={
                "name": "BUS-MIRROR-CAN-ID-RANGE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CanIdToCanIdMappings:
        bus_mirror_can_id_to_can_id_mapping: list[BusMirrorCanIdToCanIdMapping] = field(
            default_factory=list,
            metadata={
                "name": "BUS-MIRROR-CAN-ID-TO-CAN-ID-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LinPidToCanIdMappings:
        bus_mirror_lin_pid_to_can_id_mapping: list[BusMirrorLinPidToCanIdMapping] = field(
            default_factory=list,
            metadata={
                "name": "BUS-MIRROR-LIN-PID-TO-CAN-ID-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BusMirrorChannelMappingFlexray:
    """
    This element defines the bus mirroring between a CAN, LIN or FlexRay
    sourceChannel and a FlexRay targetChannel.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar source_channel: Defines the sourceChannel from which frames
        are received.
    :ivar target_channel: Defines the targetChannel to which frames are
        forwarded.
    :ivar target_pdu_triggerings: Reference to the PduTriggering that is
        used for transmission of the mirrored frames on the
        targetChannel. Please note that on FlexRay several
        targetPduTriggerings may be used. For all other communication
        channels only a single targetPduTriggering is supported. This
        property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar transmission_deadline: Time in seconds after which the
        collection of source frames into the destination frame is
        stopped and  the frame is sent at the latest. If omitted,
        destination frames are only sent when full or when the time
        stamp overflows.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUS-MIRROR-CHANNEL-MAPPING-FLEXRAY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BusMirrorChannelMappingFlexray.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BusMirrorChannelMappingFlexray.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_channel: BusMirrorChannel | None = field(
        default=None,
        metadata={
            "name": "SOURCE-CHANNEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_channel: BusMirrorChannel | None = field(
        default=None,
        metadata={
            "name": "TARGET-CHANNEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_pdu_triggerings: Optional["BusMirrorChannelMappingFlexray.TargetPduTriggerings"] = field(
        default=None,
        metadata={
            "name": "TARGET-PDU-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_deadline: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-DEADLINE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TargetPduTriggerings:
        pdu_triggering_ref_conditional: list[PduTriggeringRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BusMirrorChannelMappingIp:
    """
    This element defines the bus mirroring between a CAN, LIN or FlexRay
    sourceChannel and an Ethernet IP targetChannel.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar source_channel: Defines the sourceChannel from which frames
        are received.
    :ivar target_channel: Defines the targetChannel to which frames are
        forwarded.
    :ivar target_pdu_triggerings: Reference to the PduTriggering that is
        used for transmission of the mirrored frames on the
        targetChannel. Please note that on FlexRay several
        targetPduTriggerings may be used. For all other communication
        channels only a single targetPduTriggering is supported. This
        property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar transmission_deadline: Time in seconds after which the
        collection of source frames into the destination frame is
        stopped and the frame is sent at the latest. If omitted,
        destination frames are only sent when full or when the time
        stamp overflows.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUS-MIRROR-CHANNEL-MAPPING-IP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BusMirrorChannelMappingIp.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BusMirrorChannelMappingIp.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_channel: BusMirrorChannel | None = field(
        default=None,
        metadata={
            "name": "SOURCE-CHANNEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_channel: BusMirrorChannel | None = field(
        default=None,
        metadata={
            "name": "TARGET-CHANNEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_pdu_triggerings: Optional["BusMirrorChannelMappingIp.TargetPduTriggerings"] = field(
        default=None,
        metadata={
            "name": "TARGET-PDU-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_deadline: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-DEADLINE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TargetPduTriggerings:
        pdu_triggering_ref_conditional: list[PduTriggeringRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BusMirrorChannelMappingUserDefined:
    """
    This element defines the bus mirroring between a CAN, LIN or FlexRay
    sourceChannel and a UserDefined targetChannel.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar source_channel: Defines the sourceChannel from which frames
        are received.
    :ivar target_channel: Defines the targetChannel to which frames are
        forwarded.
    :ivar target_pdu_triggerings: Reference to the PduTriggering that is
        used for transmission of the mirrored frames on the
        targetChannel. Please note that on FlexRay several
        targetPduTriggerings may be used. For all other communication
        channels only a single targetPduTriggering is supported. This
        property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar transmission_deadline: Time in seconds after which the
        collection of source frames into the destination frame is
        stopped and the frame is sent at the latest. If omitted,
        destination frames are only sent when full or when the time
        stamp overflows.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BUS-MIRROR-CHANNEL-MAPPING-USER-DEFINED"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BusMirrorChannelMappingUserDefined.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BusMirrorChannelMappingUserDefined.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    source_channel: BusMirrorChannel | None = field(
        default=None,
        metadata={
            "name": "SOURCE-CHANNEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_channel: BusMirrorChannel | None = field(
        default=None,
        metadata={
            "name": "TARGET-CHANNEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_pdu_triggerings: Optional["BusMirrorChannelMappingUserDefined.TargetPduTriggerings"] = (
        field(
            default=None,
            metadata={
                "name": "TARGET-PDU-TRIGGERINGS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    transmission_deadline: TimeValue | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-DEADLINE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TargetPduTriggerings:
        pdu_triggering_ref_conditional: list[PduTriggeringRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CanPhysicalChannel:
    """
    CAN bus specific physical channel attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar comm_connectors: This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar frame_triggerings: One frame triggering is defined for exactly
        one channel. Channels may have assigned an arbitrary number of
        frame triggerings. atpVariation: If signals/PDUs/frames are
        variable, the corresponding triggerings shall be variable, too.
    :ivar i_signal_triggerings: One ISignalTriggering is defined for
        exactly one channel. Channels may have assigned an arbitrary
        number of ISignaltriggerings. atpVariation: If
        signals/PDUs/frames are variable, the corresponding triggerings
        shall be variable, too.
    :ivar managed_physical_channel_refs: Reference between a channel
        with role managing channel and a channel with role managed
        channel.
    :ivar pdu_triggerings: One PduTriggering is defined for exactly one
        channel. Channels may have assigned an arbitrary number of I-Pdu
        triggerings. atpVariation: If signals/PDUs/frames are variable,
        the corresponding triggerings shall be variable, too.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CommunicationClusterContent.physicalChannel
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-PHYSICAL-CHANNEL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CanPhysicalChannel.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CanPhysicalChannel.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_connectors: Optional["CanPhysicalChannel.CommConnectors"] = field(
        default=None,
        metadata={
            "name": "COMM-CONNECTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_triggerings: Optional["CanPhysicalChannel.FrameTriggerings"] = field(
        default=None,
        metadata={
            "name": "FRAME-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_triggerings: Optional["CanPhysicalChannel.ISignalTriggerings"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    managed_physical_channel_refs: Optional["CanPhysicalChannel.ManagedPhysicalChannelRefs"] = (
        field(
            default=None,
            metadata={
                "name": "MANAGED-PHYSICAL-CHANNEL-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    pdu_triggerings: Optional["CanPhysicalChannel.PduTriggerings"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommConnectors:
        communication_connector_ref_conditional: list[CommunicationConnectorRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "COMMUNICATION-CONNECTOR-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FrameTriggerings:
        can_frame_triggering: list[CanFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CAN-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_frame_triggering: list[EthernetFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_frame_triggering: list[FlexrayFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_frame_triggering: list[LinFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "LIN-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalTriggerings:
        i_signal_triggering: list[ISignalTriggering] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ManagedPhysicalChannelRefs:
        managed_physical_channel_ref: list[
            "CanPhysicalChannel.ManagedPhysicalChannelRefs.ManagedPhysicalChannelRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MANAGED-PHYSICAL-CHANNEL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ManagedPhysicalChannelRef(Ref):
            dest: PhysicalChannelSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PduTriggerings:
        pdu_triggering: list[PduTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ClassContentConditional:
    """Specifies the valid content of the class.

    The content can optionally depend on a condition. (E.g. value of
    attribute 'category')

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar condition: The rules on the content of this class are enabled
        if the condition validates to true.
    :ivar attribute_tailorings: Tailorings of the owned and inherited
        attributes of this Meta Classes
    :ivar constraint_tailorings: Specification of tailorings of
        Constraints of that are owned by this Meta Classes
    :ivar sdg_tailorings: Specification of the applicable Special Data
        Group
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLASS-CONTENT-CONDITIONAL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ClassContentConditional.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ClassContentConditional.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    condition: Optional["ClassContentConditional.Condition"] = field(
        default=None,
        metadata={
            "name": "CONDITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    attribute_tailorings: Optional["ClassContentConditional.AttributeTailorings"] = field(
        default=None,
        metadata={
            "name": "ATTRIBUTE-TAILORINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    constraint_tailorings: Optional["ClassContentConditional.ConstraintTailorings"] = field(
        default=None,
        metadata={
            "name": "CONSTRAINT-TAILORINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdg_tailorings: Optional["ClassContentConditional.SdgTailorings"] = field(
        default=None,
        metadata={
            "name": "SDG-TAILORINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Condition:
        aggregation_condition: AggregationCondition | None = field(
            default=None,
            metadata={
                "name": "AGGREGATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        invert_condition: InvertCondition | None = field(
            default=None,
            metadata={
                "name": "INVERT-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        primitive_attribute_condition: PrimitiveAttributeCondition | None = field(
            default=None,
            metadata={
                "name": "PRIMITIVE-ATTRIBUTE-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_condition: ReferenceCondition | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        textual_condition: TextualCondition | None = field(
            default=None,
            metadata={
                "name": "TEXTUAL-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AttributeTailorings:
        aggregation_tailoring: list[AggregationTailoring] = field(
            default_factory=list,
            metadata={
                "name": "AGGREGATION-TAILORING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        primitive_attribute_tailoring: list[PrimitiveAttributeTailoring] = field(
            default_factory=list,
            metadata={
                "name": "PRIMITIVE-ATTRIBUTE-TAILORING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_tailoring: list["ReferenceTailoring"] = field(
            default_factory=list,
            metadata={
                "name": "REFERENCE-TAILORING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConstraintTailorings:
        constraint_tailoring: list[ConstraintTailoring] = field(
            default_factory=list,
            metadata={
                "name": "CONSTRAINT-TAILORING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SdgTailorings:
        sdg_tailoring: list[SdgTailoring] = field(
            default_factory=list,
            metadata={
                "name": "SDG-TAILORING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ClientServerOperation:
    """'''begin restrict to CP AP''' An operation declared within the scope of a
    client/server interface.

    '''begin restrict to FO''' A remote procedure call declared within
    the scope of the current interface. '''end restrict to FO'''

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar arguments: An argument of this ClientServerOperation
    :ivar diag_arg_integrity: This attribute shall only be used in the
        implementation of diagnostic routines to support the case where
        input and output arguments are allocated in a shared buffer and
        might unintentionally overwrite input arguments by tentative
        write operations to output arguments. This situation can happen
        during sliced execution or while output parameters are arrays
        (call by reference). The value true means that the
        ClientServerOperation is aware of the usage of a shared buffer
        and takes precautions to avoid unintentional overwrite of input
        arguments. If the attribute does not exist or is set to false
        the ClientServerOperation does not have to consider the usage of
        a shared buffer.
    :ivar fire_and_forget: This attribute defines whether this method is
        a fire&amp;forget method (true) or not (false).
    :ivar possible_ap_error_refs: This reference identifies
        AdaptivePlatformApplicationErrors as a possible error raised by
        the enclosing ClientServerOperation.
    :ivar possible_ap_error_set_refs: This reference represents the
        ability to refer to an entire group of ApApplicationErrors as
        one model element instead of having to refer to all the
        represented ApApplicationErrors separately.
    :ivar possible_error_refs: Possible errors that may by raised by the
        referring operation.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ClientServerInterface.operation Applicable for:
        ServiceInterface.method Applicable for:
        ApplicationInterface.command Not Applicable for:
        DiagnosticDataElementInterface.read Not Applicable for:
        DiagnosticDataIdentifierInterface.read Not Applicable for:
        DiagnosticDataIdentifierInterface.write Not Applicable for:
        DiagnosticRoutineInterface.start Not Applicable for:
        DiagnosticRoutineInterface.stop Not Applicable for:
        DiagnosticRoutineInterface.requestResult Not Applicable for:
        PhmRecoveryActionInterface.recovery
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-OPERATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ClientServerOperation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ClientServerOperation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    arguments: Optional["ClientServerOperation.Arguments"] = field(
        default=None,
        metadata={
            "name": "ARGUMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diag_arg_integrity: Boolean | None = field(
        default=None,
        metadata={
            "name": "DIAG-ARG-INTEGRITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fire_and_forget: Boolean | None = field(
        default=None,
        metadata={
            "name": "FIRE-AND-FORGET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    possible_ap_error_refs: Optional["ClientServerOperation.PossibleApErrorRefs"] = field(
        default=None,
        metadata={
            "name": "POSSIBLE-AP-ERROR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    possible_ap_error_set_refs: Optional["ClientServerOperation.PossibleApErrorSetRefs"] = field(
        default=None,
        metadata={
            "name": "POSSIBLE-AP-ERROR-SET-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    possible_error_refs: Optional["ClientServerOperation.PossibleErrorRefs"] = field(
        default=None,
        metadata={
            "name": "POSSIBLE-ERROR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Arguments:
        argument_data_prototype: list[ArgumentDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "ARGUMENT-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PossibleApErrorRefs:
        possible_ap_error_ref: list[
            "ClientServerOperation.PossibleApErrorRefs.PossibleApErrorRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "POSSIBLE-AP-ERROR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PossibleApErrorRef(Ref):
            dest: ApApplicationErrorSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PossibleApErrorSetRefs:
        possible_ap_error_set_ref: list[
            "ClientServerOperation.PossibleApErrorSetRefs.PossibleApErrorSetRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "POSSIBLE-AP-ERROR-SET-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PossibleApErrorSetRef(Ref):
            dest: ApApplicationErrorSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PossibleErrorRefs:
        possible_error_ref: list["ClientServerOperation.PossibleErrorRefs.PossibleErrorRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "POSSIBLE-ERROR-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class PossibleErrorRef(Ref):
            dest: ApplicationErrorSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class CompuMethod:
    """This meta-class represents the ability to express the relationship between a
    physical value and the mathematical representation.

    Note that this is still independent of the technical implementation
    in data types. It only specifies the formula how the internal value
    corresponds to its physical pendant.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar display_format: This property specifies, how the physical
        value shall be displayed e.g. in documents or measurement and
        calibration tools.
    :ivar unit_ref: This is the physical unit of the Physical values for
        which the CompuMethod applies.
    :ivar compu_internal_to_phys: This specifies the computation from
        internal values to physical values.
    :ivar compu_phys_to_internal: This represents the computation from
        physical values to the internal values.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPU-METHOD"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CompuMethod.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CompuMethod.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["CompuMethod.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    display_format: DisplayFormatString | None = field(
        default=None,
        metadata={
            "name": "DISPLAY-FORMAT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_ref: Optional["CompuMethod.UnitRef"] = field(
        default=None,
        metadata={
            "name": "UNIT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compu_internal_to_phys: Compu | None = field(
        default=None,
        metadata={
            "name": "COMPU-INTERNAL-TO-PHYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compu_phys_to_internal: Compu | None = field(
        default=None,
        metadata={
            "name": "COMPU-PHYS-TO-INTERNAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class UnitRef(Ref):
        dest: UnitSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ConsistencyNeeds:
    """
    This meta-class represents the ability to define requirements on the implicit
    communication behavior.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar dpg_does_not_require_coherencys: This group of
        VariableDataPrototypes does not require coherency with respect
        to the implicit communication behavior.
    :ivar dpg_requires_coherencys: This group of VariableDataPrototypes
        requires coherency with respect to the implicit communication
        behavior, i.e. all read and write access to
        VariableDataPrototypes in the DataPrototypeGroup by the
        RunnableEntitys of the RunnableEntityGroup need to be handled in
        a coherent manner.
    :ivar reg_does_not_require_stabilitys: This group of
        RunnableEntities does not require stability with respect to the
        implicit communication behavior.
    :ivar reg_requires_stabilitys: This group of RunnableEntities
        requires stability with respect to the implicit communication
        behavior, i.e. all read and write access to
        VariableDataPrototypes in the DataPrototypeGroup by the
        RunnableEntitys of the RunnableEntityGroup need to be handled in
        a stable manner.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ConsistencyNeedsBlueprintSet.consistencyNeeds Applicable for:
        SwComponentType.consistencyNeeds
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONSISTENCY-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ConsistencyNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ConsistencyNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ConsistencyNeeds.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dpg_does_not_require_coherencys: Optional["ConsistencyNeeds.DpgDoesNotRequireCoherencys"] = (
        field(
            default=None,
            metadata={
                "name": "DPG-DOES-NOT-REQUIRE-COHERENCYS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    dpg_requires_coherencys: Optional["ConsistencyNeeds.DpgRequiresCoherencys"] = field(
        default=None,
        metadata={
            "name": "DPG-REQUIRES-COHERENCYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reg_does_not_require_stabilitys: Optional["ConsistencyNeeds.RegDoesNotRequireStabilitys"] = (
        field(
            default=None,
            metadata={
                "name": "REG-DOES-NOT-REQUIRE-STABILITYS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    reg_requires_stabilitys: Optional["ConsistencyNeeds.RegRequiresStabilitys"] = field(
        default=None,
        metadata={
            "name": "REG-REQUIRES-STABILITYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DpgDoesNotRequireCoherencys:
        data_prototype_group: list[DataPrototypeGroup] = field(
            default_factory=list,
            metadata={
                "name": "DATA-PROTOTYPE-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DpgRequiresCoherencys:
        data_prototype_group: list[DataPrototypeGroup] = field(
            default_factory=list,
            metadata={
                "name": "DATA-PROTOTYPE-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RegDoesNotRequireStabilitys:
        runnable_entity_group: list[RunnableEntityGroup] = field(
            default_factory=list,
            metadata={
                "name": "RUNNABLE-ENTITY-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RegRequiresStabilitys:
        runnable_entity_group: list[RunnableEntityGroup] = field(
            default_factory=list,
            metadata={
                "name": "RUNNABLE-ENTITY-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ConsumedEventGroup:
    """
    This element represents an event-group to which the service consumer wants to
    subscribe.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar application_endpoint_ref: Defines the application endpoint
        where the events of the event group are received in case of
        multicast reception.
    :ivar auto_require: Defines that this ConsumedEventGroup shall be
        requested (subscribed) as soon as the corresponding
        ConsumedServiceInstance is requested. This could be at ECU
        start, if ConsumedServiceInstance.autoRequire is set to TRUE or
        as soon as the ConsumedServiceInstance is requested by the
        application, if ConsumedServiceInstance.autoRequire is set to
        FALSE.
    :ivar event_group_identifier: EventGroup ID. Shall be unique within
        one system to allow service discovery.
    :ivar event_multicast_addresss: This reference defines the multicast
        address or a multicast address resource where the events of the
        event group are received. If the multicast address is determined
        via configuration and not at runtime via service discovery this
        reference points to the multicast address over which the events
        will be received. If the multicast address is determined at
        runtime via service discovery this reference shall be used to
        define the necessary local multicast address resources, i.e. RAM
        space in the TcpIp module in which the multicast address is
        stored at runtime. Please note that in this case the referenced
        address may be defined as ANY UDP port and ANY IP address since
        the multicast address will be received at runtime. If several
        multicast addresses are considered to be used the
        ConsumedEventGroup shall point to different ApplicationEndpoint
        objects to reserve the necessary resources in the configuration.
        This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar instance_identifier: Instance identifier. Can be used for e.g.
        service discovery to identify the instance of the event group.
    :ivar pdu_activation_routing_groups: The ServiceDiscovery module is
        able to activate and deactivate the PDU routing for receiving
        events. This aggregation contains a variation point although it
        is not variant. Therefore, this variation point shall not exist
        in models. See constr_2638.
    :ivar priority: Defines the frame priority where values from 0 (best
        effort) to 7 (highest) are allowed.
    :ivar routing_group_refs: The ServiceDiscovery module is able to
        activate and deactivate the PDU routing for receiving events.
    :ivar sd_client_config: The readiness to receive events is defined
        by the ServiceDiscovery of the ConsumedEventGroup. The
        EventHandler shall know about this announcement to decide about
        the submission of events. Therefore the EventHandler may be
        configured with Service-Discovery Client attributes.
    :ivar sd_client_timer_configs: Client Timing configuration settings
        that are EventGroup specific. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ConsumedServiceInstance.consumedEventGroup
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONSUMED-EVENT-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ConsumedEventGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ConsumedEventGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_endpoint_ref: Optional["ConsumedEventGroup.ApplicationEndpointRef"] = field(
        default=None,
        metadata={
            "name": "APPLICATION-ENDPOINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    auto_require: Boolean | None = field(
        default=None,
        metadata={
            "name": "AUTO-REQUIRE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_identifier: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_multicast_addresss: Optional["ConsumedEventGroup.EventMulticastAddresss"] = field(
        default=None,
        metadata={
            "name": "EVENT-MULTICAST-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    instance_identifier: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INSTANCE-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_activation_routing_groups: Optional["ConsumedEventGroup.PduActivationRoutingGroups"] = (
        field(
            default=None,
            metadata={
                "name": "PDU-ACTIVATION-ROUTING-GROUPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    routing_group_refs: Optional["ConsumedEventGroup.RoutingGroupRefs"] = field(
        default=None,
        metadata={
            "name": "ROUTING-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sd_client_config: SdClientConfig | None = field(
        default=None,
        metadata={
            "name": "SD-CLIENT-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sd_client_timer_configs: Optional["ConsumedEventGroup.SdClientTimerConfigs"] = field(
        default=None,
        metadata={
            "name": "SD-CLIENT-TIMER-CONFIGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ApplicationEndpointRef(Ref):
        dest: ApplicationEndpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventMulticastAddresss:
        application_endpoint_ref_conditional: list[ApplicationEndpointRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-ENDPOINT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduActivationRoutingGroups:
        pdu_activation_routing_group: list[PduActivationRoutingGroup] = field(
            default_factory=list,
            metadata={
                "name": "PDU-ACTIVATION-ROUTING-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RoutingGroupRefs:
        routing_group_ref: list["ConsumedEventGroup.RoutingGroupRefs.RoutingGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "ROUTING-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RoutingGroupRef(Ref):
            dest: SoAdRoutingGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SdClientTimerConfigs:
        someip_sd_client_event_group_timing_config_ref_conditional: list[
            SomeipSdClientEventGroupTimingConfigRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-SD-CLIENT-EVENT-GROUP-TIMING-CONFIG-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CpSoftwareClusterBinaryManifestDescriptor:
    """This meta-class has the ability to act as a hub for all information related
    to the binary manifest of a given CP software cluster.

    The manifest is subject to integrator work and therefore not a part
    of the definition of the CP software cluster itself.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar cp_software_cluster_ref: This reference identifies the
        CpSoftwareCluster to which the enclosing
        CpSoftwareClusterBinaryManifestDescriptor belongs, The
        CpSoftwareClusterBinaryManifestDescriptor is defined in an
        integration phase while the referenced CpSoftwareCluster
        represents a design element. Therefore, it makes sense to use a
        reference rather than an aggregation in the relation of the two
        meta-classes.
    :ivar meta_data_fields: This aggregation identifies the collection
        of meta-data contained in the enclosing binary manifest.
    :ivar provide_resources: This aggregation represents the collection
        of provided resources in the enclosing binary manifest.
    :ivar require_resources: This aggregation represents the collection
        of required resources in the enclosing binary manifest.
    :ivar resource_definitions: This aggregation represents the
        collection of binary manifest resource definitions that belong
        to the enclosing CpSoftwareClusterBinaryManifestDescriptor.
    :ivar software_cluster_id: This attribute represents the value of
        the id of the corresponding CP software cluster. This id is
        assigned by an integrator, but may also be copied from
        CpSoftwareCluster.softwareClusterId if available.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CP-SOFTWARE-CLUSTER-BINARY-MANIFEST-DESCRIPTOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "CpSoftwareClusterBinaryManifestDescriptor.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CpSoftwareClusterBinaryManifestDescriptor.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cp_software_cluster_ref: Optional[
        "CpSoftwareClusterBinaryManifestDescriptor.CpSoftwareClusterRef"
    ] = field(
        default=None,
        metadata={
            "name": "CP-SOFTWARE-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_fields: Optional["CpSoftwareClusterBinaryManifestDescriptor.MetaDataFields"] = field(
        default=None,
        metadata={
            "name": "META-DATA-FIELDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provide_resources: Optional["CpSoftwareClusterBinaryManifestDescriptor.ProvideResources"] = (
        field(
            default=None,
            metadata={
                "name": "PROVIDE-RESOURCES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    require_resources: Optional["CpSoftwareClusterBinaryManifestDescriptor.RequireResources"] = (
        field(
            default=None,
            metadata={
                "name": "REQUIRE-RESOURCES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    resource_definitions: Optional[
        "CpSoftwareClusterBinaryManifestDescriptor.ResourceDefinitions"
    ] = field(
        default=None,
        metadata={
            "name": "RESOURCE-DEFINITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_cluster_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CLUSTER-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CpSoftwareClusterRef(Ref):
        dest: CpSoftwareClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MetaDataFields:
        binary_manifest_meta_data_field: list[BinaryManifestMetaDataField] = field(
            default_factory=list,
            metadata={
                "name": "BINARY-MANIFEST-META-DATA-FIELD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProvideResources:
        binary_manifest_provide_resource: list[BinaryManifestProvideResource] = field(
            default_factory=list,
            metadata={
                "name": "BINARY-MANIFEST-PROVIDE-RESOURCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequireResources:
        binary_manifest_require_resource: list[BinaryManifestRequireResource] = field(
            default_factory=list,
            metadata={
                "name": "BINARY-MANIFEST-REQUIRE-RESOURCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ResourceDefinitions:
        binary_manifest_resource_definition: list[BinaryManifestResourceDefinition] = field(
            default_factory=list,
            metadata={
                "name": "BINARY-MANIFEST-RESOURCE-DEFINITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoModuleInstantiation:
    """
    This meta-class defines the configuration  for the Crypto stack on a specific
    machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar certificate_to_key_slot_mappings: List of
        CryptoCertificateToCryptoKeySlotMappings available in the
        CryptoStack.
    :ivar crypto_certificates: List of CryptoCertificates managed in the
        CryptoStack
    :ivar crypto_providers: List of CryptoProviders provided by the
        CryptoStack
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-MODULE-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoModuleInstantiation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoModuleInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    certificate_to_key_slot_mappings: Optional[
        "CryptoModuleInstantiation.CertificateToKeySlotMappings"
    ] = field(
        default=None,
        metadata={
            "name": "CERTIFICATE-TO-KEY-SLOT-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_certificates: Optional["CryptoModuleInstantiation.CryptoCertificates"] = field(
        default=None,
        metadata={
            "name": "CRYPTO-CERTIFICATES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_providers: Optional["CryptoModuleInstantiation.CryptoProviders"] = field(
        default=None,
        metadata={
            "name": "CRYPTO-PROVIDERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CertificateToKeySlotMappings:
        crypto_certificate_to_crypto_key_slot_mapping: list[
            CryptoCertificateToCryptoKeySlotMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-CERTIFICATE-TO-CRYPTO-KEY-SLOT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoCertificates:
        crypto_certificate: list[CryptoCertificate] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-CERTIFICATE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoProviders:
        crypto_provider: list[CryptoProvider] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-PROVIDER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DataPrototypeMapping:
    """Defines the mapping of two particular VariableDataPrototypes,
    ParameterDataPrototypes or ArgumentDataPrototypes with non-equal shortNames,
    non-equal structure (specific condition is described by [constr_1187]), and/or
    non-equal semantic (resolution or range) in context of two different
    SenderReceiverInterface, NvDataInterface or ParameterInterface or Operations.

    If the semantic is unequal, the following rules apply: The
    textTableMapping is only applicable if the referred DataPrototypes
    are typed by AutosarDataType referring to CompuMethods of category
    TEXTTABLE, SCALE_LINEAR_AND_TEXTTABLE or BITFIELD_TEXTTABLE. In the
    case that the  DataPrototypes are typed by AutosarDataType either
    referring to CompuMethods of category LINEAR, IDENTICAL or referring
    to no CompuMethod (which is similar as  IDENTICAL) the linear
    conversion factor is calculated out of the factorSiToUnit and
    offsetSiToUnit attributes of the referred Units and the
    CompuRationalCoeffs of a compuInternalToPhys of the referred
    CompuMethods.

    :ivar first_data_prototype_ref: First to be mapped DataPrototype in
        context of a  SenderReceiverInterface, NvDataInterface,
        ParameterInterface or Operation.
    :ivar first_to_second_data_transformation_ref: This reference
        defines the need to execute the DataTransformation
        &lt;Mip&gt;_&lt;transformerId&gt; functions of the
        transformation chain when communicating from the
        DataPrototypeMapping.firstDataPrototype to the
        DataPrototypeMapping.secondDataPrototype. This reference also
        specifies the reverse DataTransformation
        &lt;Mip&gt;_Inv_&lt;transformerId&gt; functions of the
        transformation chain (i.e. from the
        DataPrototypeMapping.secondDataPrototype to the
        DataPrototypeMapping.firstDataPrototype) if the referenced
        DataTransformation is symmetric, i.e. attribute
        DataTransformation.dataTransformationKind is set to symmetric.
    :ivar second_data_prototype_ref: Second to be mapped DataPrototype
        in context of a  SenderReceiverInterface, NvDataInterface,
        ParameterInterface or Operation.
    :ivar second_to_first_data_transformation_ref: This defines the need
        to execute the reverse DataTransformation
        &lt;Mip&gt;_Inv_&lt;transformerId&gt; functions of the
        transformation chain when communicating from the
        DataPrototypeMapping.secondDataPrototype to the
        DataPrototypeMapping.firstDataPrototype.
    :ivar sub_element_mappings: This represents the owned
        SubelementMapping.
    :ivar text_table_mappings: Applied TextTableMapping(s)
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-PROTOTYPE-MAPPING"

    first_data_prototype_ref: Optional["DataPrototypeMapping.FirstDataPrototypeRef"] = field(
        default=None,
        metadata={
            "name": "FIRST-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    first_to_second_data_transformation_ref: Optional[
        "DataPrototypeMapping.FirstToSecondDataTransformationRef"
    ] = field(
        default=None,
        metadata={
            "name": "FIRST-TO-SECOND-DATA-TRANSFORMATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    second_data_prototype_ref: Optional["DataPrototypeMapping.SecondDataPrototypeRef"] = field(
        default=None,
        metadata={
            "name": "SECOND-DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    second_to_first_data_transformation_ref: Optional[
        "DataPrototypeMapping.SecondToFirstDataTransformationRef"
    ] = field(
        default=None,
        metadata={
            "name": "SECOND-TO-FIRST-DATA-TRANSFORMATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_element_mappings: Optional["DataPrototypeMapping.SubElementMappings"] = field(
        default=None,
        metadata={
            "name": "SUB-ELEMENT-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    text_table_mappings: Optional["DataPrototypeMapping.TextTableMappings"] = field(
        default=None,
        metadata={
            "name": "TEXT-TABLE-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class FirstDataPrototypeRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FirstToSecondDataTransformationRef(Ref):
        dest: DataTransformationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecondDataPrototypeRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecondToFirstDataTransformationRef(Ref):
        dest: DataTransformationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SubElementMappings:
        sub_element_mapping: list[SubElementMapping] = field(
            default_factory=list,
            metadata={
                "name": "SUB-ELEMENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TextTableMappings:
        text_table_mapping: list[TextTableMapping] = field(
            default_factory=list,
            metadata={
                "name": "TEXT-TABLE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "max_occurs": 2,
            },
        )


@dataclass(slots=True, kw_only=True)
class DdsServiceInterfaceDeployment:
    """
    DDS configuration settings for a ServiceInterface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar event_deployments: Middleware transport layer specific
        configuration settings for an Event that is defined in the
        ServiceInterface.
    :ivar field_deployments: Middleware transport layer specific
        configuration settings for a Field that is defined in the
        ServiceInterface.
    :ivar method_deployments: Middleware transport layer specific
        configuration settings for a method that is defined in the
        ServiceInterface.
    :ivar service_interface_ref: Reference to a ServiceInterface that is
        deployed to a middleware transport layer.
    :ivar field_reply_topic_name: Name of the DDS Reply Topic associated
        with the Field.
    :ivar field_request_topic_name: Name of the DDS Request Topic
        associated with the Field.
    :ivar field_topics_access_rule_ref: DDS Security access rule
        applicable to the DDS Topics used for service interface field
        access methods (Get, Set).
    :ivar method_reply_topic_name: Name of the DDS Reply Topic
        associated with the Method.
    :ivar method_request_topic_name: Name of the DDS Request Topic
        associated with the Method.
    :ivar method_topics_access_rule_ref: DDS Security access rule
        applicable to the DDS Topics used for service interface methods.
    :ivar service_interface_id: Unique Identifier that identifies the
        ServiceInterface in DDS. This Identifier is encoded in the
        USER_DATA QoS of the DomainParticipant associated with the
        Service Instance and its value is propagated by DDS Discovery
        messages.
    :ivar transport_protocols: This attribute defines over which
        Transport Layer Protocol(s) this Method is intended to be sent.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DDS-SERVICE-INTERFACE-DEPLOYMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DdsServiceInterfaceDeployment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DdsServiceInterfaceDeployment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_deployments: Optional["DdsServiceInterfaceDeployment.EventDeployments"] = field(
        default=None,
        metadata={
            "name": "EVENT-DEPLOYMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_deployments: Optional["DdsServiceInterfaceDeployment.FieldDeployments"] = field(
        default=None,
        metadata={
            "name": "FIELD-DEPLOYMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_deployments: Optional["DdsServiceInterfaceDeployment.MethodDeployments"] = field(
        default=None,
        metadata={
            "name": "METHOD-DEPLOYMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_ref: Optional["DdsServiceInterfaceDeployment.ServiceInterfaceRef"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_reply_topic_name: String | None = field(
        default=None,
        metadata={
            "name": "FIELD-REPLY-TOPIC-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_request_topic_name: String | None = field(
        default=None,
        metadata={
            "name": "FIELD-REQUEST-TOPIC-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_topics_access_rule_ref: Optional[
        "DdsServiceInterfaceDeployment.FieldTopicsAccessRuleRef"
    ] = field(
        default=None,
        metadata={
            "name": "FIELD-TOPICS-ACCESS-RULE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_reply_topic_name: String | None = field(
        default=None,
        metadata={
            "name": "METHOD-REPLY-TOPIC-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_request_topic_name: String | None = field(
        default=None,
        metadata={
            "name": "METHOD-REQUEST-TOPIC-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_topics_access_rule_ref: Optional[
        "DdsServiceInterfaceDeployment.MethodTopicsAccessRuleRef"
    ] = field(
        default=None,
        metadata={
            "name": "METHOD-TOPICS-ACCESS-RULE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_id: String | None = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transport_protocols: Optional["DdsServiceInterfaceDeployment.TransportProtocols"] = field(
        default=None,
        metadata={
            "name": "TRANSPORT-PROTOCOLS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventDeployments:
        dds_event_deployment: list[DdsEventDeployment] = field(
            default_factory=list,
            metadata={
                "name": "DDS-EVENT-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_event_deployment: list[SomeipEventDeployment] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-EVENT-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_event_deployment: list[UserDefinedEventDeployment] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-EVENT-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FieldDeployments:
        dds_field_deployment: list[DdsFieldDeployment] = field(
            default_factory=list,
            metadata={
                "name": "DDS-FIELD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_field_deployment: list[SomeipFieldDeployment] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-FIELD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_field_deployment: list[UserDefinedFieldDeployment] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-FIELD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MethodDeployments:
        someip_method_deployment: list[SomeipMethodDeployment] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-METHOD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_method_deployment: list[UserDefinedMethodDeployment] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-METHOD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInterfaceRef(Ref):
        dest: ServiceInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FieldTopicsAccessRuleRef(Ref):
        dest: DdsTopicAccessRuleSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MethodTopicsAccessRuleRef(Ref):
        dest: DdsTopicAccessRuleSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TransportProtocols:
        transport_protocol: list[String] = field(
            default_factory=list,
            metadata={
                "name": "TRANSPORT-PROTOCOL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticCommonPropsConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar aging_requires_tested_cycle: Defines whether the aging cycle
        counter is processed every aging cycles or else only tested
        aging cycle are considered. If the attribute is set to TRUE:
        only tested aging cycle are considered for aging cycle counter.
        If the attribute is set to FALSE: aging cycle counter is
        processed every aging cycle.
    :ivar clear_dtc_limitation: Defines the scope of the DEM_ClearDTC
        Api.
    :ivar debounce_algorithm_propss: Defines the used debounce
        algorithms relevant in the context of the enclosing
        DiagnosticCommonProps. Usually, there is a variety of debouncing
        algorithms to take into account and therefore the multiplicity
        of this aggregation is set to 0..*.
    :ivar default_endianness: Defines the default endianness of the data
        belonging to a DID or RID which is applicable if the
        DiagnosticDataElement does not define the endianness via the
        swDataDefProps.baseType attribute.
    :ivar dtc_status_availability_mask: Mask for the supported DTC
        status bits by the Dem.
    :ivar environment_data_capture: This attribute determines whether
        the capturing of environment data is done synchronously inside
        the report API function or whether the capturing shall be done
        asynchronously, i.e. after the report API function already
        terminated.
    :ivar event_combination_reporting_behavior: In case of
        EventCombination on Retrieval, this attribute specifies if a
        specific order of reporting is to be maintained.
    :ivar event_displacement_strategy: This attribute defines, whether
        support for event displacement is enabled or not, and which
        displacement strategy is followed.
    :ivar max_number_of_event_entries: This attribute fixes the maximum
        number of event entries in the fault memory.
    :ivar max_number_of_request_correctly_received_response_pending:
        Maximum number of negative responses with response code 0x78
        (requestCorrectlyReceived-ResponsePending) allowed per request.
        DCM will send a negative response with response code 0x10
        (generalReject), in case the limit value gets reached. Value
        0xFF means that no limit number of NRC 0x78 response apply.
    :ivar memory_entry_storage_trigger: Describes the primary trigger to
        allocate an event memory entry.
    :ivar occurrence_counter_processing: This attribute defines the
        consideration of the fault confirmation process for the
        occurrence counter.
    :ivar reset_confirmed_bit_on_overflow: This attribute defines,
        whether the confirmed bit is reset or not while an event memory
        entry will be displaced.
    :ivar response_on_all_request_sids: If set to FALSE the DCM will not
        respond to diagnostic request that contains a service ID which
        is in the range from 0x40 to 0x7F or in the  range from 0xC0 to
        0xFF (Response IDs).
    :ivar response_on_second_declined_request: Defines the reaction upon
        a second request (ClientB) that can not be processed (e.g. due
        to priority assessment). TRUE: when the second request (Client
        B) can not be processed, it shall be answered with NRC21
        BusyRepeatRequest. FALSE: when the second request (Client B) can
        not be processed, it shall not be responded.
    :ivar security_delay_time_on_boot: Start delay timer on power on in
        seconds. This delay indicates the time at ECU boot power-on time
        where the Dcm remains in the default session and does not accept
        a security access.
    :ivar status_bit_handling_test_failed_since_last_clear: This
        attribute defines, whether the aging and displacement mechanism
        shall be applied to the "TestFailedSinceLastClear" status bits.
    :ivar status_bit_storage_test_failed: This parameter is used to
        activate/deactivate the permanent storage of the "TestFailed"
        status bits. true: storage activated false: storage deactivated
    :ivar type_of_dtc_supported: This attribute defines the format
        returned by Dem_DcmGetTranslationType and does not relate
        to/influence the supported Dem functionality.
    :ivar type_of_event_combination_supported: Select type of Event
        Combination support.
    :ivar type_of_freeze_frame_record_numeration: This attribute defines
        the type of assigning freeze frame record numbers for event-
        specific freeze frame records.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-COMMON-PROPS-CONDITIONAL"

    aging_requires_tested_cycle: Boolean | None = field(
        default=None,
        metadata={
            "name": "AGING-REQUIRES-TESTED-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clear_dtc_limitation: DiagnosticClearDtcLimitationEnum | None = field(
        default=None,
        metadata={
            "name": "CLEAR-DTC-LIMITATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    debounce_algorithm_propss: Optional[
        "DiagnosticCommonPropsConditional.DebounceAlgorithmPropss"
    ] = field(
        default=None,
        metadata={
            "name": "DEBOUNCE-ALGORITHM-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_endianness: ByteOrderEnum | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-ENDIANNESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dtc_status_availability_mask: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DTC-STATUS-AVAILABILITY-MASK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    environment_data_capture: DiagnosticDataCaptureEnum | None = field(
        default=None,
        metadata={
            "name": "ENVIRONMENT-DATA-CAPTURE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_combination_reporting_behavior: DiagnosticEventCombinationReportingBehaviorEnum | None = (
        field(
            default=None,
            metadata={
                "name": "EVENT-COMBINATION-REPORTING-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    event_displacement_strategy: DiagnosticEventDisplacementStrategyEnum | None = field(
        default=None,
        metadata={
            "name": "EVENT-DISPLACEMENT-STRATEGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_event_entries: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-EVENT-ENTRIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_request_correctly_received_response_pending: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-REQUEST-CORRECTLY-RECEIVED-RESPONSE-PENDING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_entry_storage_trigger: DiagnosticMemoryEntryStorageTriggerEnum | None = field(
        default=None,
        metadata={
            "name": "MEMORY-ENTRY-STORAGE-TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_counter_processing: DiagnosticOccurrenceCounterProcessingEnum | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-COUNTER-PROCESSING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reset_confirmed_bit_on_overflow: Boolean | None = field(
        default=None,
        metadata={
            "name": "RESET-CONFIRMED-BIT-ON-OVERFLOW",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    response_on_all_request_sids: Boolean | None = field(
        default=None,
        metadata={
            "name": "RESPONSE-ON-ALL-REQUEST-SIDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    response_on_second_declined_request: Boolean | None = field(
        default=None,
        metadata={
            "name": "RESPONSE-ON-SECOND-DECLINED-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_delay_time_on_boot: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SECURITY-DELAY-TIME-ON-BOOT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    status_bit_handling_test_failed_since_last_clear: (
        DiagnosticStatusBitHandlingTestFailedSinceLastClearEnum | None
    ) = field(
        default=None,
        metadata={
            "name": "STATUS-BIT-HANDLING-TEST-FAILED-SINCE-LAST-CLEAR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    status_bit_storage_test_failed: Boolean | None = field(
        default=None,
        metadata={
            "name": "STATUS-BIT-STORAGE-TEST-FAILED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_of_dtc_supported: DiagnosticTypeOfDtcSupportedEnum | None = field(
        default=None,
        metadata={
            "name": "TYPE-OF-DTC-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_of_event_combination_supported: DiagnosticEventCombinationBehaviorEnum | None = field(
        default=None,
        metadata={
            "name": "TYPE-OF-EVENT-COMBINATION-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_of_freeze_frame_record_numeration: (
        DiagnosticTypeOfFreezeFrameRecordNumerationEnum | None
    ) = field(
        default=None,
        metadata={
            "name": "TYPE-OF-FREEZE-FRAME-RECORD-NUMERATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DebounceAlgorithmPropss:
        diagnostic_debounce_algorithm_props: list[DiagnosticDebounceAlgorithmProps] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DEBOUNCE-ALGORITHM-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticParameterIdent:
    """
    This meta-class has been created to introduce the ability to become referenced
    into the meta-class AbstractDiagnosticParameter without breaking backwards
    compatibility.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sub_elements: This collection represents the subElements on
        the top level.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-PARAMETER-IDENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticParameterIdent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticParameterIdent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_elements: Optional["DiagnosticParameterIdent.SubElements"] = field(
        default=None,
        metadata={
            "name": "SUB-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubElements:
        diagnostic_parameter_element: list[DiagnosticParameterElement] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PARAMETER-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DltEcu:
    """
    This element represents an Ecu or Machine that produces logging and tracing
    information.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar applications: Application on DltEcu that provides log or trace
        data.
    :ivar ecu_id: This attribute defines the name of the ECU for use
        within the Dlt protocol.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-ECU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DltEcu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DltEcu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    applications: Optional["DltEcu.Applications"] = field(
        default=None,
        metadata={
            "name": "APPLICATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_id: String | None = field(
        default=None,
        metadata={
            "name": "ECU-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Applications:
        dlt_application: list[DltApplication] = field(
            default_factory=list,
            metadata={
                "name": "DLT-APPLICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DltMessageCollectionSet:
    """
    Collection of DltMessages.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar dlt_messages: Collection of DltMessages in the
        DltMessageCollectionSet. This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DLT-MESSAGE-COLLECTION-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DltMessageCollectionSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DltMessageCollectionSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_messages: Optional["DltMessageCollectionSet.DltMessages"] = field(
        default=None,
        metadata={
            "name": "DLT-MESSAGES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DltMessages:
        dlt_message: list[DltMessage] = field(
            default_factory=list,
            metadata={
                "name": "DLT-MESSAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DoIpConfig:
    """
    This element defines the DoIp configuration for a specific Ecu.

    :ivar doip_interfaces: DoIP node consists of one or several
        DoIPInterfaces over which the ECU is able to communicate via
        DoIP independently. I.e. DoIP functionalities on each IP
        interface are isolated from each other.
    :ivar logic_address: Describes the logical address of the DoIP
        entity,  i.e. the Local Address that will route diagnostic
        requests to the Dcm of the DoIP entity.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-CONFIG"

    doip_interfaces: Optional["DoIpConfig.DoipInterfaces"] = field(
        default=None,
        metadata={
            "name": "DOIP-INTERFACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    logic_address: DoIpLogicAddress | None = field(
        default=None,
        metadata={
            "name": "LOGIC-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DoipInterfaces:
        do_ip_interface: list[DoIpInterface] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DoIpTpConfig:
    """This element defines exactly one DoIpTp Configuration that is used to
    configure all DoIPChannels available in a DoIpInterface.

    Each DoIPChannel describes a connection between a doIpSourceAddress
    and a doIpTargetAddress and the exchange of DcmIPdus between the
    PduR and DoIP.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_cluster_ref: A TpConfig is existing always in
        the context of exactly one CommunicationCluster.
    :ivar do_ip_logic_addresss: Collection of logical DoIP Addresses.
    :ivar tp_connections: Collection of unidirectional connections
        between a source address and a target address.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DO-IP-TP-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DoIpTpConfig.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DoIpTpConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_ref: Optional["DoIpTpConfig.CommunicationClusterRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    do_ip_logic_addresss: Optional["DoIpTpConfig.DoIpLogicAddresss"] = field(
        default=None,
        metadata={
            "name": "DO-IP-LOGIC-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_connections: Optional["DoIpTpConfig.TpConnections"] = field(
        default=None,
        metadata={
            "name": "TP-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DoIpLogicAddresss:
        do_ip_logic_address: list[DoIpLogicAddress] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-LOGIC-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpConnections:
        do_ip_tp_connection: list[DoIpTpConnection] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-TP-CONNECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucConditionSpecification:
    """
    Allows to define existence dependencies based on the value of  parameter
    values.

    :ivar condition_formula: Definition of the formula used to define
        existence dependencies.
    :ivar ecuc_querys: Query to the ECU Configuration Description.
    :ivar informal_formula: Informal description of the condition used
        to to define existence dependencies. This aggregation contains a
        variation point although it is not variant. Therefore, this
        variation point shall not exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-CONDITION-SPECIFICATION"

    condition_formula: EcucConditionFormula | None = field(
        default=None,
        metadata={
            "name": "CONDITION-FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_querys: Optional["EcucConditionSpecification.EcucQuerys"] = field(
        default=None,
        metadata={
            "name": "ECUC-QUERYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    informal_formula: MlFormula | None = field(
        default=None,
        metadata={
            "name": "INFORMAL-FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EcucQuerys:
        ecuc_query: list[EcucQuery] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-QUERY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucContainerValue:
    """
    Represents a Container definition in the ECU Configuration Description.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar index: Used to support the specification of ordering of
        parameter values.
    :ivar definition_ref: Reference to the definition of this Container
        in the ECU Configuration Parameter Definition.
    :ivar parameter_values: Aggregates all ECU Configuration Values
        within this Container. atpVariation: [RS_ECUC_00079]
    :ivar reference_values: Aggregates all References with this
        container. atpVariation: [RS_ECUC_00079]
    :ivar sub_containers: Aggregates all sub-containers within this
        container. atpVariation: [RS_ECUC_00078]
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EcucModuleConfigurationValues.container Applicable for:
        EcucContainerValue.subContainer
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-CONTAINER-VALUE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucContainerValue.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucContainerValue.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    index: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    definition_ref: Optional["EcucContainerValue.DefinitionRef"] = field(
        default=None,
        metadata={
            "name": "DEFINITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_values: Optional["EcucContainerValue.ParameterValues"] = field(
        default=None,
        metadata={
            "name": "PARAMETER-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reference_values: Optional["EcucContainerValue.ReferenceValues"] = field(
        default=None,
        metadata={
            "name": "REFERENCE-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_containers: Optional["EcucContainerValue.SubContainers"] = field(
        default=None,
        metadata={
            "name": "SUB-CONTAINERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DefinitionRef(Ref):
        dest: EcucContainerDefSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ParameterValues:
        ecuc_add_info_param_value: list[EcucAddInfoParamValue] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-ADD-INFO-PARAM-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_numerical_param_value: list[EcucNumericalParamValue] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-NUMERICAL-PARAM-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_textual_param_value: list[EcucTextualParamValue] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-TEXTUAL-PARAM-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ReferenceValues:
        ecuc_instance_reference_value: list[EcucInstanceReferenceValue] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-INSTANCE-REFERENCE-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_reference_value: list[EcucReferenceValue] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-REFERENCE-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubContainers:
        ecuc_container_value: list["EcucContainerValue"] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-CONTAINER-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucDerivationSpecification:
    """Allows to define configuration items that are calculated based on the value of
    * other parameter values
    * elements (attributes/classes) defined in other AUTOSAR templates such as System template and SW component template

    :ivar calculation_formula: Definition of the formula used to
        calculate the value of the configuration element.
    :ivar ecuc_querys: Query to the ECU Configuration Description.
    :ivar informal_formula: Informal description of the derivation used
        to calculate the value of the configuration element. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-DERIVATION-SPECIFICATION"

    calculation_formula: EcucParameterDerivationFormula | None = field(
        default=None,
        metadata={
            "name": "CALCULATION-FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_querys: Optional["EcucDerivationSpecification.EcucQuerys"] = field(
        default=None,
        metadata={
            "name": "ECUC-QUERYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    informal_formula: MlFormula | None = field(
        default=None,
        metadata={
            "name": "INFORMAL-FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EcucQuerys:
        ecuc_query: list[EcucQuery] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-QUERY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EndToEndProtectionSet:
    """
    This represents a container for collection EndToEndProtectionInformation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar end_to_end_protections: This is one particular
        EndToEndProtection.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "END-TO-END-PROTECTION-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EndToEndProtectionSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EndToEndProtectionSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    end_to_end_protections: Optional["EndToEndProtectionSet.EndToEndProtections"] = field(
        default=None,
        metadata={
            "name": "END-TO-END-PROTECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EndToEndProtections:
        end_to_end_protection: list[EndToEndProtection] = field(
            default_factory=list,
            metadata={
                "name": "END-TO-END-PROTECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ErrorTracerNeeds:
    """
    Specifies the need to report failures to the error tracer.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar traced_failures: list of traced failures
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ERROR-TRACER-NEEDS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ErrorTracerNeeds.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ErrorTracerNeeds.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    traced_failures: Optional["ErrorTracerNeeds.TracedFailures"] = field(
        default=None,
        metadata={
            "name": "TRACED-FAILURES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TracedFailures:
        development_error: list[DevelopmentError] = field(
            default_factory=list,
            metadata={
                "name": "DEVELOPMENT-ERROR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        runtime_error: list[RuntimeError] = field(
            default_factory=list,
            metadata={
                "name": "RUNTIME-ERROR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        transient_fault: list[TransientFault] = field(
            default_factory=list,
            metadata={
                "name": "TRANSIENT-FAULT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EthernetRawDataStreamClientMapping:
    """
    This meta-class represents the ability to map a client PortPrototype to a
    Ethernet-based communication channel.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar deployment_ref: This reference identifies the applicable
        RawDataStreamDeployment.
    :ivar port_prototype_iref: Reference to a specific PortPrototype
        that represents the raw data stream to the application.
    :ivar process_ref: Reference to the Process in which the Executable
        that contains the SoftwareComponent and the referenced
        PortPrototype is executed.
    :ivar local_endpoint_config: This aggregation is used to configure
        the credentials of the endpoint.
    :ivar socket_options: This attribute represents the ability to
        specify non-formal socket options that might only be valid for
        specific platforms. AUTOSAR does not define a standardized
        meaning for the possible values of this attribute.
    :ivar tls_secure_com_props_ref: This reference provides the ability
        to define TLS-related properties for the enclosing
        SocketRawDataStreamMapping.
    :ivar remote_server_config: This aggregation is used to configure
        the credentials of the remote server.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-RAW-DATA-STREAM-CLIENT-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthernetRawDataStreamClientMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthernetRawDataStreamClientMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    deployment_ref: Optional["EthernetRawDataStreamClientMapping.DeploymentRef"] = field(
        default=None,
        metadata={
            "name": "DEPLOYMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["EthernetRawDataStreamClientMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_endpoint_config: EthernetRawDataStreamLocalEndpointConfig | None = field(
        default=None,
        metadata={
            "name": "LOCAL-ENDPOINT-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    socket_options: Optional["EthernetRawDataStreamClientMapping.SocketOptions"] = field(
        default=None,
        metadata={
            "name": "SOCKET-OPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tls_secure_com_props_ref: Optional[
        "EthernetRawDataStreamClientMapping.TlsSecureComPropsRef"
    ] = field(
        default=None,
        metadata={
            "name": "TLS-SECURE-COM-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_server_config: EthernetRawDataStreamRemoteServerConfig | None = field(
        default=None,
        metadata={
            "name": "REMOTE-SERVER-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DeploymentRef(Ref):
        dest: RawDataStreamDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SocketOptions:
        socket_option: list[String] = field(
            default_factory=list,
            metadata={
                "name": "SOCKET-OPTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TlsSecureComPropsRef(Ref):
        dest: TlsSecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EthernetRawDataStreamServerMapping:
    """
    This meta-class represents the ability to map a server PortPrototype to a
    Ethernet-based communication channel.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar deployment_ref: This reference identifies the applicable
        RawDataStreamDeployment.
    :ivar port_prototype_iref: Reference to a specific PortPrototype
        that represents the raw data stream to the application.
    :ivar process_ref: Reference to the Process in which the Executable
        that contains the SoftwareComponent and the referenced
        PortPrototype is executed.
    :ivar local_endpoint_config: This aggregation is used to configure
        the credentials of the endpoint.
    :ivar socket_options: This attribute represents the ability to
        specify non-formal socket options that might only be valid for
        specific platforms. AUTOSAR does not define a standardized
        meaning for the possible values of this attribute.
    :ivar tls_secure_com_props_ref: This reference provides the ability
        to define TLS-related properties for the enclosing
        SocketRawDataStreamMapping.
    :ivar remote_client_config: This aggregation is used to configure
        the credentials of the remote client.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-RAW-DATA-STREAM-SERVER-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthernetRawDataStreamServerMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthernetRawDataStreamServerMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    deployment_ref: Optional["EthernetRawDataStreamServerMapping.DeploymentRef"] = field(
        default=None,
        metadata={
            "name": "DEPLOYMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["EthernetRawDataStreamServerMapping.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_endpoint_config: EthernetRawDataStreamLocalEndpointConfig | None = field(
        default=None,
        metadata={
            "name": "LOCAL-ENDPOINT-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    socket_options: Optional["EthernetRawDataStreamServerMapping.SocketOptions"] = field(
        default=None,
        metadata={
            "name": "SOCKET-OPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tls_secure_com_props_ref: Optional[
        "EthernetRawDataStreamServerMapping.TlsSecureComPropsRef"
    ] = field(
        default=None,
        metadata={
            "name": "TLS-SECURE-COM-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_client_config: EthernetRawDataStreamRemoteClientConfig | None = field(
        default=None,
        metadata={
            "name": "REMOTE-CLIENT-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DeploymentRef(Ref):
        dest: RawDataStreamDeploymentSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SocketOptions:
        socket_option: list[String] = field(
            default_factory=list,
            metadata={
                "name": "SOCKET-OPTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TlsSecureComPropsRef(Ref):
        dest: TlsSecureComPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EventHandler:
    """
    This element represents an event group as part of the Provided Service
    Instance.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar application_endpoint_ref: Defines the local application
        endpoint used to submit an event to a subscriber. For the
        submission of events the service provider may use a different
        TpPort address (ApplicationEndpoint) then for the response of
        requests.
    :ivar consumed_event_group_refs: All consumers of the event are
        referenced here.
    :ivar event_group_identifier: Unique Identifier that identifies the
        EventGroup in SOME/IP. This Identifier is sent as Eventgroup ID
        in SOME/IP Service Discovery messages.
    :ivar event_multicast_addresss: Multicast Address that is used for
        event communication in the IP-Multicast case. It is the
        destination address to which the server sends the multicast
        event messages if the mulicastThreshold is exceeded. This
        address is transmitted in the SD-SubscribeEventGroupAck Message
        to client (answer to SD-SubscribeEventGroup). This property was
        modified due to atpVariation (DirectedAssociationPattern).
    :ivar multicast_threshold: Specifies the number of subscribed
        clients that trigger the server to change the transmission of
        events to multicast. If configured to 0 only unicast will be
        used. If configured to 1 the first client will be already served
        by multicast. If configured to 2 the first client will be server
        with unicast and as soon as the second client arrives both will
        be served by multicast. This does not influence the handling of
        initial events, which are served using unicast only.
    :ivar pdu_activation_routing_groups: The ServiceDiscovery module is
        able to activate and deactivate the PDU routing for events. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar routing_group_refs: The ServiceDiscovery module is able to
        activate and deactivate the PDU routing for events.
    :ivar sd_server_config: Server configuration parameter for Service-
        Discovery.
    :ivar sd_server_eg_timing_configs: Server Timing configuration
        settings that are EventGroup specific. This property was
        modified due to atpVariation (DirectedAssociationPattern).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ProvidedServiceInstance.eventHandler
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EVENT-HANDLER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EventHandler.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EventHandler.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_endpoint_ref: Optional["EventHandler.ApplicationEndpointRef"] = field(
        default=None,
        metadata={
            "name": "APPLICATION-ENDPOINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consumed_event_group_refs: Optional["EventHandler.ConsumedEventGroupRefs"] = field(
        default=None,
        metadata={
            "name": "CONSUMED-EVENT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_group_identifier: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "EVENT-GROUP-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_multicast_addresss: Optional["EventHandler.EventMulticastAddresss"] = field(
        default=None,
        metadata={
            "name": "EVENT-MULTICAST-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multicast_threshold: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MULTICAST-THRESHOLD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_activation_routing_groups: Optional["EventHandler.PduActivationRoutingGroups"] = field(
        default=None,
        metadata={
            "name": "PDU-ACTIVATION-ROUTING-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    routing_group_refs: Optional["EventHandler.RoutingGroupRefs"] = field(
        default=None,
        metadata={
            "name": "ROUTING-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sd_server_config: SdServerConfig | None = field(
        default=None,
        metadata={
            "name": "SD-SERVER-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sd_server_eg_timing_configs: Optional["EventHandler.SdServerEgTimingConfigs"] = field(
        default=None,
        metadata={
            "name": "SD-SERVER-EG-TIMING-CONFIGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ApplicationEndpointRef(Ref):
        dest: ApplicationEndpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ConsumedEventGroupRefs:
        consumed_event_group_ref: list[
            "EventHandler.ConsumedEventGroupRefs.ConsumedEventGroupRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONSUMED-EVENT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ConsumedEventGroupRef(Ref):
            dest: ConsumedEventGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class EventMulticastAddresss:
        application_endpoint_ref_conditional: list[ApplicationEndpointRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-ENDPOINT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduActivationRoutingGroups:
        pdu_activation_routing_group: list[PduActivationRoutingGroup] = field(
            default_factory=list,
            metadata={
                "name": "PDU-ACTIVATION-ROUTING-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RoutingGroupRefs:
        routing_group_ref: list["EventHandler.RoutingGroupRefs.RoutingGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "ROUTING-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RoutingGroupRef(Ref):
            dest: SoAdRoutingGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SdServerEgTimingConfigs:
        someip_sd_server_event_group_timing_config_ref_conditional: list[
            SomeipSdServerEventGroupTimingConfigRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-SD-SERVER-EVENT-GROUP-TIMING-CONFIG-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlatMap:
    """Contains a flat list of references to software objects.

    This list is used to identify instances and to resolve name
    conflicts. The scope is given by the RootSwCompositionPrototype for
    which it is used, i.e. it can be applied to a system, system extract
    or ECU-extract. An instance of FlatMap may also be used in a
    preliminary context, e.g. in the scope of a software component
    before integration into a system. In this case it is not referred by
    a RootSwCompositionPrototype.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar instances: A descriptor instance aggregated in the flat map.
        The variation point accounts for the fact, that the system in
        scope can be subject to variability, and thus the existence of
        some instances is variable. The aggregation has been made
        splitable because the content might be contributed by different
        stakeholders at different times in the workflow. Plus, the
        overall size might be so big that eventually it becomes more
        manageable if it is distributed over several files.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLAT-MAP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlatMap.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlatMap.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["FlatMap.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    instances: Optional["FlatMap.Instances"] = field(
        default=None,
        metadata={
            "name": "INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Instances:
        flat_instance_descriptor: list[FlatInstanceDescriptor] = field(
            default_factory=list,
            metadata={
                "name": "FLAT-INSTANCE-DESCRIPTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayArTpConfig:
    """This element defines exactly one FlexRay Autosar TP Configuration.

    One FlexrayArTpConfig element shall be created for each FlexRay
    Network in the System that uses FlexRay Autosar TP.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_cluster_ref: A TpConfig is existing always in
        the context of exactly one CommunicationCluster.
    :ivar tp_addresss: Collection of TpAddresses.
    :ivar tp_channels: Configuration of  FlexRay Autosar Transport
        Protocol channels.
    :ivar tp_nodes: Senders and receivers of  TP messages.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-AR-TP-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlexrayArTpConfig.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlexrayArTpConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_ref: Optional["FlexrayArTpConfig.CommunicationClusterRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_addresss: Optional["FlexrayArTpConfig.TpAddresss"] = field(
        default=None,
        metadata={
            "name": "TP-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_channels: Optional["FlexrayArTpConfig.TpChannels"] = field(
        default=None,
        metadata={
            "name": "TP-CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_nodes: Optional["FlexrayArTpConfig.TpNodes"] = field(
        default=None,
        metadata={
            "name": "TP-NODES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRef(Ref):
        dest: CommunicationClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TpAddresss:
        tp_address: list[TpAddress] = field(
            default_factory=list,
            metadata={
                "name": "TP-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpChannels:
        flexray_ar_tp_channel: list[FlexrayArTpChannel] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-AR-TP-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TpNodes:
        flexray_ar_tp_node: list[FlexrayArTpNode] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-AR-TP-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayPhysicalChannel:
    """
    FlexRay specific attributes to the physicalChannel.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar comm_connectors: This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar frame_triggerings: One frame triggering is defined for exactly
        one channel. Channels may have assigned an arbitrary number of
        frame triggerings. atpVariation: If signals/PDUs/frames are
        variable, the corresponding triggerings shall be variable, too.
    :ivar i_signal_triggerings: One ISignalTriggering is defined for
        exactly one channel. Channels may have assigned an arbitrary
        number of ISignaltriggerings. atpVariation: If
        signals/PDUs/frames are variable, the corresponding triggerings
        shall be variable, too.
    :ivar managed_physical_channel_refs: Reference between a channel
        with role managing channel and a channel with role managed
        channel.
    :ivar pdu_triggerings: One PduTriggering is defined for exactly one
        channel. Channels may have assigned an arbitrary number of I-Pdu
        triggerings. atpVariation: If signals/PDUs/frames are variable,
        the corresponding triggerings shall be variable, too.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CommunicationClusterContent.physicalChannel
    :ivar channel_name: Name of the channel (Channel A or Channel B).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-PHYSICAL-CHANNEL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlexrayPhysicalChannel.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlexrayPhysicalChannel.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_connectors: Optional["FlexrayPhysicalChannel.CommConnectors"] = field(
        default=None,
        metadata={
            "name": "COMM-CONNECTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_triggerings: Optional["FlexrayPhysicalChannel.FrameTriggerings"] = field(
        default=None,
        metadata={
            "name": "FRAME-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_triggerings: Optional["FlexrayPhysicalChannel.ISignalTriggerings"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    managed_physical_channel_refs: Optional["FlexrayPhysicalChannel.ManagedPhysicalChannelRefs"] = (
        field(
            default=None,
            metadata={
                "name": "MANAGED-PHYSICAL-CHANNEL-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    pdu_triggerings: Optional["FlexrayPhysicalChannel.PduTriggerings"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    channel_name: FlexrayChannelName | None = field(
        default=None,
        metadata={
            "name": "CHANNEL-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommConnectors:
        communication_connector_ref_conditional: list[CommunicationConnectorRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "COMMUNICATION-CONNECTOR-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FrameTriggerings:
        can_frame_triggering: list[CanFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CAN-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_frame_triggering: list[EthernetFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_frame_triggering: list[FlexrayFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_frame_triggering: list[LinFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "LIN-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalTriggerings:
        i_signal_triggering: list[ISignalTriggering] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ManagedPhysicalChannelRefs:
        managed_physical_channel_ref: list[
            "FlexrayPhysicalChannel.ManagedPhysicalChannelRefs.ManagedPhysicalChannelRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MANAGED-PHYSICAL-CHANNEL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ManagedPhysicalChannelRef(Ref):
            dest: PhysicalChannelSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PduTriggerings:
        pdu_triggering: list[PduTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FmFeatureMap:
    """A FMFeatureMap associates FMFeatures with variation points in the AUTOSAR
    model.

    To do this, it defines value sets for system constants and postbuild
    variant criterions that shall be chosen whenever a certain
    combination of features (and system constants) is encountered.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar mappings: Set of mappings defined by this FMFeatureMap.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FM-FEATURE-MAP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FmFeatureMap.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FmFeatureMap.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mappings: Optional["FmFeatureMap.Mappings"] = field(
        default=None,
        metadata={
            "name": "MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Mappings:
        fm_feature_map_element: list[FmFeatureMapElement] = field(
            default_factory=list,
            metadata={
                "name": "FM-FEATURE-MAP-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class HwCategory:
    """
    This metaclass represents the ability to declare hardware categories and its
    particular attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar hw_attribute_defs: This aggregation describes particular
        hardware attribute definition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HW-CATEGORY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["HwCategory.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["HwCategory.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_attribute_defs: Optional["HwCategory.HwAttributeDefs"] = field(
        default=None,
        metadata={
            "name": "HW-ATTRIBUTE-DEFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwAttributeDefs:
        hw_attribute_def: list[HwAttributeDef] = field(
            default_factory=list,
            metadata={
                "name": "HW-ATTRIBUTE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class HwElementConnector:
    """This meta-class represents the ability to connect two hardware elements.

    The details of the connection can be refined by
    hwPinGroupConnection.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar hw_element_refs: This association connects two hardware
        elements.
    :ivar hw_pin_group_connections: This represents one particular
        connection between two hardware pin groups.
    :ivar hw_pin_connections: This represents one particular connection
        between two hardware pins. This connection shall be used if pin-
        to-pin-connection is to be described but no description of the
        connection between the hierarchical composition of HwPinGroups
        (using HwPinGroupConnector) is required.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        HwElement.hwElementConnection
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HW-ELEMENT-CONNECTOR"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_element_refs: Optional["HwElementConnector.HwElementRefs"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_pin_group_connections: Optional["HwElementConnector.HwPinGroupConnections"] = field(
        default=None,
        metadata={
            "name": "HW-PIN-GROUP-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_pin_connections: Optional["HwElementConnector.HwPinConnections"] = field(
        default=None,
        metadata={
            "name": "HW-PIN-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class HwElementRefs:
        hw_element_ref: list["HwElementConnector.HwElementRefs.HwElementRef"] = field(
            default_factory=list,
            metadata={
                "name": "HW-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class HwElementRef(Ref):
            dest: HwElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class HwPinGroupConnections:
        hw_pin_group_connector: list[HwPinGroupConnector] = field(
            default_factory=list,
            metadata={
                "name": "HW-PIN-GROUP-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwPinConnections:
        hw_pin_connector: list[HwPinConnector] = field(
            default_factory=list,
            metadata={
                "name": "HW-PIN-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class HwPinGroupContent:
    """
    This meta-class specifies a mixture of hwPins and hwPinGroups.

    :ivar hw_pin: This aggregation represents a hardware pin in a
        hardware pin group. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar hw_pin_group: This aggregation represents a nested hardware
        pin group. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HW-PIN-GROUP-CONTENT"

    hw_pin: list[HwPin] = field(
        default_factory=list,
        metadata={
            "name": "HW-PIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_pin_group: list[HwPinGroup] = field(
        default_factory=list,
        metadata={
            "name": "HW-PIN-GROUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ISignalGroup:
    """SignalGroup of the Interaction Layer.

    The RTE supports a "signal fan-out" where the same System Signal
    Group is sent in different SignalIPdus to multiple receivers. An
    ISignalGroup refers to a set of ISignals that shall always be kept
    together. A ISignalGroup represents a COM Signal Group. Therefore it
    is recommended to put the ISignalGroup in the same Package as
    ISignals (see atp.recommendedPackage)

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar com_based_signal_group_transformations: This property was
        modified due to atpVariation (DirectedAssociationPattern).
    :ivar i_signal_refs: Reference to a set of ISignals that shall
        always be kept together.
    :ivar system_signal_group_ref: Reference to the SystemSignalGroup
        that is defined on VFB level and that is supposed to be
        transmitted in the ISignalGroup.
    :ivar transformation_i_signal_propss: A transformer chain consists
        of an ordered list of transformers. The ISignalGroup specific
        configuration properties for each transformer are defined in the
        TransformationISignalProps class. The transformer configuration
        properties that are common for all ISignalGroups are described
        in the TransformationTechnology class.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-SIGNAL-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ISignalGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ISignalGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    com_based_signal_group_transformations: Optional[
        "ISignalGroup.ComBasedSignalGroupTransformations"
    ] = field(
        default=None,
        metadata={
            "name": "COM-BASED-SIGNAL-GROUP-TRANSFORMATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_refs: Optional["ISignalGroup.ISignalRefs"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_signal_group_ref: Optional["ISignalGroup.SystemSignalGroupRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformation_i_signal_propss: Optional["ISignalGroup.TransformationISignalPropss"] = field(
        default=None,
        metadata={
            "name": "TRANSFORMATION-I-SIGNAL-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ComBasedSignalGroupTransformations:
        data_transformation_ref_conditional: list[DataTransformationRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "DATA-TRANSFORMATION-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalRefs:
        i_signal_ref: list["ISignalGroup.ISignalRefs.ISignalRef"] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ISignalRef(Ref):
            dest: ISignalSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalGroupRef(Ref):
        dest: SystemSignalGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TransformationISignalPropss:
        end_to_end_transformation_i_signal_props: list[EndToEndTransformationISignalProps] = field(
            default_factory=list,
            metadata={
                "name": "END-TO-END-TRANSFORMATION-I-SIGNAL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_transformation_i_signal_props: list[SomeipTransformationISignalProps] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-TRANSFORMATION-I-SIGNAL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_transformation_i_signal_props: list[UserDefinedTransformationISignalProps] = (
            field(
                default_factory=list,
                metadata={
                    "name": "USER-DEFINED-TRANSFORMATION-I-SIGNAL-PROPS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class InfrastructureServices:
    """
    Defines the network infrastructure services provided or consumed.

    :ivar dhcp_server_configuration: Defines the configuration of DHCP
        servers that are running on the network endpoint.
    :ivar do_ip_entity: Defines whether a infrastructure service that
        runs on the network endpoint is a DoIP-Entity.
    :ivar time_synchronization: Defines the servers / clients in a time
        synchronised network.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "INFRASTRUCTURE-SERVICES"

    dhcp_server_configuration: DhcpServerConfiguration | None = field(
        default=None,
        metadata={
            "name": "DHCP-SERVER-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    do_ip_entity: DoIpEntity | None = field(
        default=None,
        metadata={
            "name": "DO-IP-ENTITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    time_synchronization: TimeSynchronization | None = field(
        default=None,
        metadata={
            "name": "TIME-SYNCHRONIZATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Item:
    """
    This meta-class represents one particular item in a list.

    :ivar msr_query_p_2: This represents automatically contributed
        contents provided by an msrquery in the context of
        DocumentationBlock.
    :ivar p: This is one particular paragraph. The upper multiplicity of
        this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar verbatim: This represents one particular verbatim text. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar list_value: This represents numbered or unnumbered list. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar def_list: This represents a definition list in the
        documentation block. The upper multiplicity of this role has
        been increased to * due to resolving an atpVariation stereotype.
        The previous value was 1.
    :ivar labeled_list: This represents a labeled list. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar formula: This is a formula in the definition block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar figure: This represents a figure in the documentation block.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar note: This represents a note in the text flow. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar trace: This represents traceable text in the documentation
        block. This allows to specify requirements/constraints in any
        documentation block. The kind of the trace is specified in the
        category. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar structured_req: This aggregation supports structured
        requirements embedded in a documentation block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: List.item
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    """

    class Meta:
        name = "ITEM"

    msr_query_p_2: list[MsrQueryP2] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p: list[MultiLanguageParagraph] = field(
        default_factory=list,
        metadata={
            "name": "P",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: list[MultiLanguageVerbatim] = field(
        default_factory=list,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    list_value: list["ListType"] = field(
        default_factory=list,
        metadata={
            "name": "LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_list: list[DefList] = field(
        default_factory=list,
        metadata={
            "name": "DEF-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    labeled_list: list["LabeledList"] = field(
        default_factory=list,
        metadata={
            "name": "LABELED-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: list[MlFormula] = field(
        default_factory=list,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    figure: list[MlFigure] = field(
        default_factory=list,
        metadata={
            "name": "FIGURE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    note: list["Note"] = field(
        default_factory=list,
        metadata={
            "name": "NOTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace: list["TraceableText"] = field(
        default_factory=list,
        metadata={
            "name": "TRACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    structured_req: list[StructuredReq] = field(
        default_factory=list,
        metadata={
            "name": "STRUCTURED-REQ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class LinPhysicalChannel:
    """
    LIN specific attributes to the physicalChannel.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar comm_connectors: This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar frame_triggerings: One frame triggering is defined for exactly
        one channel. Channels may have assigned an arbitrary number of
        frame triggerings. atpVariation: If signals/PDUs/frames are
        variable, the corresponding triggerings shall be variable, too.
    :ivar i_signal_triggerings: One ISignalTriggering is defined for
        exactly one channel. Channels may have assigned an arbitrary
        number of ISignaltriggerings. atpVariation: If
        signals/PDUs/frames are variable, the corresponding triggerings
        shall be variable, too.
    :ivar managed_physical_channel_refs: Reference between a channel
        with role managing channel and a channel with role managed
        channel.
    :ivar pdu_triggerings: One PduTriggering is defined for exactly one
        channel. Channels may have assigned an arbitrary number of I-Pdu
        triggerings. atpVariation: If signals/PDUs/frames are variable,
        the corresponding triggerings shall be variable, too.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CommunicationClusterContent.physicalChannel
    :ivar bus_idle_timeout_period: This attribute shall be used to set
        an idle timeout period for the enclosing LinPhysicalChannel.
    :ivar schedule_tables: Schedule tables organize the timings of the
        frames for LIN. atpVariation: If the transmitted frames are
        variable, the corresponding ScheduleTables shall be variable,
        too.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-PHYSICAL-CHANNEL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LinPhysicalChannel.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LinPhysicalChannel.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_connectors: Optional["LinPhysicalChannel.CommConnectors"] = field(
        default=None,
        metadata={
            "name": "COMM-CONNECTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_triggerings: Optional["LinPhysicalChannel.FrameTriggerings"] = field(
        default=None,
        metadata={
            "name": "FRAME-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_triggerings: Optional["LinPhysicalChannel.ISignalTriggerings"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    managed_physical_channel_refs: Optional["LinPhysicalChannel.ManagedPhysicalChannelRefs"] = (
        field(
            default=None,
            metadata={
                "name": "MANAGED-PHYSICAL-CHANNEL-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    pdu_triggerings: Optional["LinPhysicalChannel.PduTriggerings"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bus_idle_timeout_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "BUS-IDLE-TIMEOUT-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    schedule_tables: Optional["LinPhysicalChannel.ScheduleTables"] = field(
        default=None,
        metadata={
            "name": "SCHEDULE-TABLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommConnectors:
        communication_connector_ref_conditional: list[CommunicationConnectorRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "COMMUNICATION-CONNECTOR-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FrameTriggerings:
        can_frame_triggering: list[CanFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CAN-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_frame_triggering: list[EthernetFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_frame_triggering: list[FlexrayFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_frame_triggering: list[LinFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "LIN-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalTriggerings:
        i_signal_triggering: list[ISignalTriggering] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ManagedPhysicalChannelRefs:
        managed_physical_channel_ref: list[
            "LinPhysicalChannel.ManagedPhysicalChannelRefs.ManagedPhysicalChannelRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MANAGED-PHYSICAL-CHANNEL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ManagedPhysicalChannelRef(Ref):
            dest: PhysicalChannelSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PduTriggerings:
        pdu_triggering: list[PduTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ScheduleTables:
        lin_schedule_table: list[LinScheduleTable] = field(
            default_factory=list,
            metadata={
                "name": "LIN-SCHEDULE-TABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LogAndTraceMessageCollectionSet:
    """
    Collection of DltMessages.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar dlt_messages: Collection of DltMessages in the
        DltMessageCollectionSet.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LOG-AND-TRACE-MESSAGE-COLLECTION-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LogAndTraceMessageCollectionSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LogAndTraceMessageCollectionSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_messages: Optional["LogAndTraceMessageCollectionSet.DltMessages"] = field(
        default=None,
        metadata={
            "name": "DLT-MESSAGES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DltMessages:
        dlt_message: list[DltMessage] = field(
            default_factory=list,
            metadata={
                "name": "DLT-MESSAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class McFunction:
    """Represents a functional element to be used as input to support measurement
    and calibration.

    It is used to
    * assign calibration parameters to a logical function
    * assign measurement variables to a logical function
    * structure functions hierarchically

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar def_calprm_set: Refers to the set of adjustable data (=
        calibration parameters) defined in this function.
    :ivar ref_calprm_set: Refers to the set of adjustable data (=
        calibration parameters) referred by this function.
    :ivar in_measurement_set: Refers to the set of measurable input data
        for this function.
    :ivar out_measurment_set: Due to miss spell was set to obsolete.
        Please use outMeasurementSet instead.
    :ivar loc_measurement_set: Refers to the set of measurable local
        data in this function.
    :ivar out_measurement_set: Refers to the set of measurable output
        data from this function.
    :ivar sub_function_refs: A sub-function that is seen as part of the
        enclosing function.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MC-FUNCTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["McFunction.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["McFunction.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_calprm_set: McFunctionDataRefSet | None = field(
        default=None,
        metadata={
            "name": "DEF-CALPRM-SET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ref_calprm_set: McFunctionDataRefSet | None = field(
        default=None,
        metadata={
            "name": "REF-CALPRM-SET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    in_measurement_set: McFunctionDataRefSet | None = field(
        default=None,
        metadata={
            "name": "IN-MEASUREMENT-SET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    out_measurment_set: McFunctionDataRefSet | None = field(
        default=None,
        metadata={
            "name": "OUT-MEASURMENT-SET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    loc_measurement_set: McFunctionDataRefSet | None = field(
        default=None,
        metadata={
            "name": "LOC-MEASUREMENT-SET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    out_measurement_set: McFunctionDataRefSet | None = field(
        default=None,
        metadata={
            "name": "OUT-MEASUREMENT-SET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_function_refs: Optional["McFunction.SubFunctionRefs"] = field(
        default=None,
        metadata={
            "name": "SUB-FUNCTION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubFunctionRefs:
        sub_function_ref: list["McFunction.SubFunctionRefs.SubFunctionRef"] = field(
            default_factory=list,
            metadata={
                "name": "SUB-FUNCTION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SubFunctionRef(Ref):
            dest: McFunctionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class McGroup:
    """Represents a group element to be used as input to support measurement and
    calibration.

    It is used to provide selection lists (groups) of calibration
    parameters, measurement variables, and functions in a hierarchical
    manner (subGroups).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar sub_group_refs: A sub-group that is seen as part of the
        enclosing group.
    :ivar ref_calprm_set: Refers to the set of adjustable data (=
        calibration parameters) referred by this McGroup.
    :ivar ref_measurement_set: Refers to the set of measurable belonging
        to this McGroup.
    :ivar mc_function_refs: A McFunction that is seen as part of the
        enclosing group.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MC-GROUP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["McGroup.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["McGroup.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_group_refs: Optional["McGroup.SubGroupRefs"] = field(
        default=None,
        metadata={
            "name": "SUB-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ref_calprm_set: McGroupDataRefSet | None = field(
        default=None,
        metadata={
            "name": "REF-CALPRM-SET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ref_measurement_set: McGroupDataRefSet | None = field(
        default=None,
        metadata={
            "name": "REF-MEASUREMENT-SET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_function_refs: Optional["McGroup.McFunctionRefs"] = field(
        default=None,
        metadata={
            "name": "MC-FUNCTION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubGroupRefs:
        sub_group_ref: list["McGroup.SubGroupRefs.SubGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "SUB-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SubGroupRef(Ref):
            dest: McGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class McFunctionRefs:
        mc_function_ref: list["McGroup.McFunctionRefs.McFunctionRef"] = field(
            default_factory=list,
            metadata={
                "name": "MC-FUNCTION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class McFunctionRef(Ref):
            dest: McFunctionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class MetaDataItemSet:
    """
    This meta-class represents the ability to define a set of meta-data items to be
    used in SenderReceiverInterfaces.

    :ivar data_element_refs: This reference identifies the dataElement
        for which the ordered list of meta-data items is defined.
    :ivar meta_data_items: This aggregation represents the ordered
        definition of meta-data items.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "META-DATA-ITEM-SET"

    data_element_refs: Optional["MetaDataItemSet.DataElementRefs"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_items: Optional["MetaDataItemSet.MetaDataItems"] = field(
        default=None,
        metadata={
            "name": "META-DATA-ITEMS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataElementRefs:
        data_element_ref: list["MetaDataItemSet.DataElementRefs.DataElementRef"] = field(
            default_factory=list,
            metadata={
                "name": "DATA-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DataElementRef(Ref):
            dest: VariableDataPrototypeSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class MetaDataItems:
        meta_data_item: list[MetaDataItem] = field(
            default_factory=list,
            metadata={
                "name": "META-DATA-ITEM",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class NmConfig:
    """
    Contains the all configuration elements for AUTOSAR Nm.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar nm_clusters: Collection of NM Clusters atpVariation: Derived,
        because cluster can be variable.
    :ivar nm_cluster_couplings: Collection of NmClusterCouplings
        atpVariation: Derived, because NmCluster can vary.
    :ivar nm_if_ecus: Collection of NM ECUs atpVariation: Derived,
        because EcuInstance can be variable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NM-CONFIG"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["NmConfig.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["NmConfig.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_clusters: Optional["NmConfig.NmClusters"] = field(
        default=None,
        metadata={
            "name": "NM-CLUSTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_cluster_couplings: Optional["NmConfig.NmClusterCouplings"] = field(
        default=None,
        metadata={
            "name": "NM-CLUSTER-COUPLINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nm_if_ecus: Optional["NmConfig.NmIfEcus"] = field(
        default=None,
        metadata={
            "name": "NM-IF-ECUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NmClusters:
        can_nm_cluster: list[CanNmCluster] = field(
            default_factory=list,
            metadata={
                "name": "CAN-NM-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_nm_cluster: list[FlexrayNmCluster] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-NM-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_nm_cluster: list[J1939NmCluster] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-NM-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_nm_cluster: list[LinNmCluster] = field(
            default_factory=list,
            metadata={
                "name": "LIN-NM-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        udp_nm_cluster: list[UdpNmCluster] = field(
            default_factory=list,
            metadata={
                "name": "UDP-NM-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NmClusterCouplings:
        can_nm_cluster_coupling: list[CanNmClusterCoupling] = field(
            default_factory=list,
            metadata={
                "name": "CAN-NM-CLUSTER-COUPLING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_nm_cluster_coupling: list[FlexrayNmClusterCoupling] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-NM-CLUSTER-COUPLING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        udp_nm_cluster_coupling: list[UdpNmClusterCoupling] = field(
            default_factory=list,
            metadata={
                "name": "UDP-NM-CLUSTER-COUPLING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NmIfEcus:
        nm_ecu: list[NmEcu] = field(
            default_factory=list,
            metadata={
                "name": "NM-ECU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PlatformHealthManagementContribution:
    """
    This element defines a contribution to the Platform Health Management.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar checkpoints: Collection of checkpoints in the context of a
        PlatformHealthManagementContribution.
    :ivar supervision_mode_conditions: Collection of
        SupervisionModeConditions in the context of a
        PlatformHealthManagementContribution.
    :ivar global_supervisions: Collection of GlobalSupervisions in the
        context of a PlatformHealthManagementContribution.
    :ivar health_channels: Collection of HealthChannels in the context
        of a PlatformHealthManagementContribution.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PLATFORM-HEALTH-MANAGEMENT-CONTRIBUTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PlatformHealthManagementContribution.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PlatformHealthManagementContribution.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    checkpoints: Optional["PlatformHealthManagementContribution.Checkpoints"] = field(
        default=None,
        metadata={
            "name": "CHECKPOINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    supervision_mode_conditions: Optional[
        "PlatformHealthManagementContribution.SupervisionModeConditions"
    ] = field(
        default=None,
        metadata={
            "name": "SUPERVISION-MODE-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    global_supervisions: Optional["PlatformHealthManagementContribution.GlobalSupervisions"] = (
        field(
            default=None,
            metadata={
                "name": "GLOBAL-SUPERVISIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    health_channels: Optional["PlatformHealthManagementContribution.HealthChannels"] = field(
        default=None,
        metadata={
            "name": "HEALTH-CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Checkpoints:
        supervision_checkpoint: list[SupervisionCheckpoint] = field(
            default_factory=list,
            metadata={
                "name": "SUPERVISION-CHECKPOINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SupervisionModeConditions:
        supervision_mode_condition: list[SupervisionModeCondition] = field(
            default_factory=list,
            metadata={
                "name": "SUPERVISION-MODE-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class GlobalSupervisions:
        global_supervision: list[GlobalSupervision] = field(
            default_factory=list,
            metadata={
                "name": "GLOBAL-SUPERVISION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HealthChannels:
        health_channel_external_status: list[HealthChannelExternalStatus] = field(
            default_factory=list,
            metadata={
                "name": "HEALTH-CHANNEL-EXTERNAL-STATUS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        health_channel_supervision: list[HealthChannelSupervision] = field(
            default_factory=list,
            metadata={
                "name": "HEALTH-CHANNEL-SUPERVISION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ResourceConsumption:
    """
    Description of consumed resources by one implementation of a software.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar access_count_sets: Set of access count values
    :ivar execution_times: Collection of the execution time descriptions
        for this implementation. The aggregation of executionTime is
        subject to variability with the purpose to support the
        conditional existence of runnable entities.
    :ivar heap_usages: Collection of the heap memory allocated by this
        implementation.
    :ivar memory_sections: An abstract memory section required by this
        Implementation.
    :ivar memory_usages: Collection of the memory allocated by the
        owner.
    :ivar section_name_prefixs: A prefix to be used for the memory
        section symbol in the code.
    :ivar stack_usages: Collection of the stack memory usage for each
        runnable entity of this implementation. The aggregation of
        StackUsage is subject to variability with the purpose to support
        the conditional existence of runnable entities.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RESOURCE-CONSUMPTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ResourceConsumption.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ResourceConsumption.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_count_sets: Optional["ResourceConsumption.AccessCountSets"] = field(
        default=None,
        metadata={
            "name": "ACCESS-COUNT-SETS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    execution_times: Optional["ResourceConsumption.ExecutionTimes"] = field(
        default=None,
        metadata={
            "name": "EXECUTION-TIMES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    heap_usages: Optional["ResourceConsumption.HeapUsages"] = field(
        default=None,
        metadata={
            "name": "HEAP-USAGES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_sections: Optional["ResourceConsumption.MemorySections"] = field(
        default=None,
        metadata={
            "name": "MEMORY-SECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    memory_usages: Optional["ResourceConsumption.MemoryUsages"] = field(
        default=None,
        metadata={
            "name": "MEMORY-USAGES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    section_name_prefixs: Optional["ResourceConsumption.SectionNamePrefixs"] = field(
        default=None,
        metadata={
            "name": "SECTION-NAME-PREFIXS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    stack_usages: Optional["ResourceConsumption.StackUsages"] = field(
        default=None,
        metadata={
            "name": "STACK-USAGES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessCountSets:
        access_count_set: list[AccessCountSet] = field(
            default_factory=list,
            metadata={
                "name": "ACCESS-COUNT-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutionTimes:
        analyzed_execution_time: list[AnalyzedExecutionTime] = field(
            default_factory=list,
            metadata={
                "name": "ANALYZED-EXECUTION-TIME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        measured_execution_time: list[MeasuredExecutionTime] = field(
            default_factory=list,
            metadata={
                "name": "MEASURED-EXECUTION-TIME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        rough_estimate_of_execution_time: list[RoughEstimateOfExecutionTime] = field(
            default_factory=list,
            metadata={
                "name": "ROUGH-ESTIMATE-OF-EXECUTION-TIME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        simulated_execution_time: list[SimulatedExecutionTime] = field(
            default_factory=list,
            metadata={
                "name": "SIMULATED-EXECUTION-TIME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HeapUsages:
        measured_heap_usage: list[MeasuredHeapUsage] = field(
            default_factory=list,
            metadata={
                "name": "MEASURED-HEAP-USAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        rough_estimate_heap_usage: list[RoughEstimateHeapUsage] = field(
            default_factory=list,
            metadata={
                "name": "ROUGH-ESTIMATE-HEAP-USAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        worst_case_heap_usage: list[WorstCaseHeapUsage] = field(
            default_factory=list,
            metadata={
                "name": "WORST-CASE-HEAP-USAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MemorySections:
        memory_section: list[MemorySection] = field(
            default_factory=list,
            metadata={
                "name": "MEMORY-SECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MemoryUsages:
        memory_usage: list[MemoryUsage] = field(
            default_factory=list,
            metadata={
                "name": "MEMORY-USAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SectionNamePrefixs:
        section_name_prefix: list[SectionNamePrefix] = field(
            default_factory=list,
            metadata={
                "name": "SECTION-NAME-PREFIX",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StackUsages:
        measured_stack_usage: list[MeasuredStackUsage] = field(
            default_factory=list,
            metadata={
                "name": "MEASURED-STACK-USAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        rough_estimate_stack_usage: list[RoughEstimateStackUsage] = field(
            default_factory=list,
            metadata={
                "name": "ROUGH-ESTIMATE-STACK-USAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        worst_case_stack_usage: list[WorstCaseStackUsage] = field(
            default_factory=list,
            metadata={
                "name": "WORST-CASE-STACK-USAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RptContainer:
    """This meta-class defines a byPassPoint and the relation to a rptHook.

    Additionally it may contain further rptContainers if the byPassPoint
    is not atomic. For example a byPassPoint referencing to a
    RunnableEntity may contain rptContainers referring to the data
    access points of the RunnableEntity. The RptContainer structure on
    M1 shall follow the M1 structure of the Software Component
    Descriptions. The category attribute denotes which level of the
    Software Component Description is annotated.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar by_pass_point_irefs: byPassPoint describes the required
        preparation of the host ECU. At a byPassPoint  the host ECU
        shall be capable to communicate with a RPT System in order to
        support the execution of the rapid prototyping algorithms with
        the original data calculated by the host system and to replace
        dedicated results of  the host system by the results of the
        rapid prototyping algorithm.
    :ivar explicit_rpt_profile_selection_refs: This attribute defines
        the applicable RptProfiles for the specific RptContainer. If not
        any references to a specific RptProfile is defined, all
        RptProfiles defined in the RapidPrototypingScenario are
        applicable.
    :ivar rpt_containers: Sub-level rptContainer definitions of this
        specific rapid prototyping scenario.
    :ivar rpt_executable_entity_properties: Describes the required code
        preparation for rapid prototyping at ExecutableEntity
        invocation.
    :ivar rpt_hooks: The rptHook describes the link between a
        byPassPoint and the rapid prototyping algorithm. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar rpt_impl_policy: Describes the required code preparation for
        rapid prototyping at data accesses.
    :ivar rpt_sw_prototyping_access: Describes the required
        accessibility of data and modes by the rapid prototyping
        tooling.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RapidPrototypingScenario.rptContainer Applicable for:
        RptContainer.rptContainer
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-CONTAINER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RptContainer.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RptContainer.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    by_pass_point_irefs: Optional["RptContainer.ByPassPointIrefs"] = field(
        default=None,
        metadata={
            "name": "BY-PASS-POINT-IREFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    explicit_rpt_profile_selection_refs: Optional[
        "RptContainer.ExplicitRptProfileSelectionRefs"
    ] = field(
        default=None,
        metadata={
            "name": "EXPLICIT-RPT-PROFILE-SELECTION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_containers: Optional["RptContainer.RptContainers"] = field(
        default=None,
        metadata={
            "name": "RPT-CONTAINERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_executable_entity_properties: RptExecutableEntityProperties | None = field(
        default=None,
        metadata={
            "name": "RPT-EXECUTABLE-ENTITY-PROPERTIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_hooks: Optional["RptContainer.RptHooks"] = field(
        default=None,
        metadata={
            "name": "RPT-HOOKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_impl_policy: RptImplPolicy | None = field(
        default=None,
        metadata={
            "name": "RPT-IMPL-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_sw_prototyping_access: RptSwPrototypingAccess | None = field(
        default=None,
        metadata={
            "name": "RPT-SW-PROTOTYPING-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ByPassPointIrefs:
        by_pass_point_iref: list[AnyInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "BY-PASS-POINT-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExplicitRptProfileSelectionRefs:
        explicit_rpt_profile_selection_ref: list[
            "RptContainer.ExplicitRptProfileSelectionRefs.ExplicitRptProfileSelectionRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EXPLICIT-RPT-PROFILE-SELECTION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ExplicitRptProfileSelectionRef(Ref):
            dest: RptProfileSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RptContainers:
        rpt_container: list["RptContainer"] = field(
            default_factory=list,
            metadata={
                "name": "RPT-CONTAINER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RptHooks:
        rpt_hook: list[RptHook] = field(
            default_factory=list,
            metadata={
                "name": "RPT-HOOK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RptExecutableEntity:
    """
    This describes a ExecutableEntity instance which can be bypassed.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar rpt_executable_entity_events: ExecutableEntity event instance
        activation the owning RptExecutableEntity.
    :ivar rpt_reads: read access to a variable
    :ivar rpt_writes: write access to a variable
    :ivar symbol: The symbol describing this ExecutableEntity's entry
        point.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RptComponent.rptExecutableEntity
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-EXECUTABLE-ENTITY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RptExecutableEntity.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RptExecutableEntity.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_executable_entity_events: Optional["RptExecutableEntity.RptExecutableEntityEvents"] = field(
        default=None,
        metadata={
            "name": "RPT-EXECUTABLE-ENTITY-EVENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_reads: Optional["RptExecutableEntity.RptReads"] = field(
        default=None,
        metadata={
            "name": "RPT-READS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_writes: Optional["RptExecutableEntity.RptWrites"] = field(
        default=None,
        metadata={
            "name": "RPT-WRITES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RptExecutableEntityEvents:
        rpt_executable_entity_event: list[RptExecutableEntityEvent] = field(
            default_factory=list,
            metadata={
                "name": "RPT-EXECUTABLE-ENTITY-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RptReads:
        role_based_mc_data_assignment: list[RoleBasedMcDataAssignment] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-MC-DATA-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RptWrites:
        role_based_mc_data_assignment: list[RoleBasedMcDataAssignment] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-MC-DATA-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RuleBasedValueSpecification:
    """
    This meta-class is used to support a rule-based initialization approach for
    data types with an array-nature (ApplicationArrayDataType and
    ImplementationDataType of category ARRAY) or a compound
    ApplicationPrimitiveDataType (which also boils down to an array-nature).

    :ivar rule: This denotes the name of the rule of the
        RuleBasedValueSpecification. The rule determines the calculation
        specification according which the arguments are used to
        calculated the values.
    :ivar argumentss: This represents the arguments for the
        RuleBasedValueSpecification. The upper multiplicity of this role
        has been increased to * due to resolving an atpVariation
        stereotype. The previous value was 1.
    :ivar max_size_to_fill: If a rule is chosen which does not fill
        until the end, this determines until which size the rule shall
        fill the values.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RULE-BASED-VALUE-SPECIFICATION"

    rule: Identifier | None = field(
        default=None,
        metadata={
            "name": "RULE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    argumentss: Optional["RuleBasedValueSpecification.Argumentss"] = field(
        default=None,
        metadata={
            "name": "ARGUMENTSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_size_to_fill: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-SIZE-TO-FILL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Argumentss:
        rule_arguments: list[RuleArguments] = field(
            default_factory=list,
            metadata={
                "name": "RULE-ARGUMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RunnableEntity:
    """A RunnableEntity represents the smallest code-fragment that is provided by
    an AtomicSwComponentType and are executed under control of the RTE.

    RunnableEntities are for instance set up to respond to data
    reception or operation invocation on a server.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar activation_reasons: If the ExecutableEntity provides at least
        one activationReason element the RTE resp. BSW Scheduler shall
        provide means to read the activation vector of this executable
        entity execution. If no activationReason element is provided the
        feature of being able to determine the activating RTEEvent is
        disabled for this ExecutableEntity.
    :ivar can_enters: This means that the executable entity can
        enter/leave the referenced exclusive area through explicit API
        calls. This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar can_enter_exclusive_area_refs: This means that the executable
        entity can enter/leave the referenced exclusive area through
        explicit API calls.
    :ivar exclusive_area_nesting_order_refs: This represents the set of
        ExclusiveAreaNestingOrders recognized by this ExecutableEntity.
    :ivar minimum_start_interval: Specifies the time in seconds by which
        two consecutive starts of an ExecutableEntity are guaranteed to
        be separated.
    :ivar reentrancy_level: The reentrancy level of this
        ExecutableEntity. See the documentation of the enumeration type
        ReentrancyLevelEnum for details. Please note that nonReentrant
        interfaces can have also reentrant or multicoreReentrant
        implementations, and reentrant interfaces can also have
        multicoreReentrant implementations.
    :ivar runs_insides: The executable entity runs completely inside the
        referenced exclusive area. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar runs_inside_exclusive_area_refs: The executable entity runs
        completely inside the referenced exclusive area.
    :ivar sw_addr_method_ref: Addressing method related to this code
        entity. Via an association to the same SwAddrMethod, it can be
        specified that several code entities (even of different modules
        or components)  shall be located in the same memory without
        already specifying the memory section itself.
    :ivar arguments: This represents the formal definition of a an
        argument to a RunnableEntity.
    :ivar asynchronous_server_call_result_points: The server call result
        point admits a runnable to fetch the result of an asynchronous
        server call. The aggregation of
        AsynchronousServerCallResultPoint is subject to variability with
        the purpose to support the conditional existence of client
        server PortPrototypes and the variant existence of server call
        result points in the implementation.
    :ivar can_be_invoked_concurrently: If the value of this attribute is
        set to "true" the enclosing RunnableEntity can be invoked
        concurrently (even for one instance of the corresponding
        AtomicSwComponentType). This implies that it is the
        responsibility of the implementation of the RunnableEntity to
        take care of this form of concurrency.
    :ivar data_read_accesss: RunnableEntity has implicit read access to
        dataElement of a sender-receiver PortPrototype or nv data of a
        nv data PortPrototype. The aggregation of dataReadAccess is
        subject to variability with the purpose to support the
        conditional existence of sender receiver ports or the variant
        existence of dataReadAccess in the implementation.
    :ivar data_receive_point_by_arguments: RunnableEntity has explicit
        read access to dataElement of a sender-receiver PortPrototype or
        nv data of a nv data PortPrototype. The result is passed back to
        the application by means of an argument in the function
        signature. The aggregation of dataReceivePointByArgument is
        subject to variability with the purpose to support the
        conditional existence of sender receiver PortPrototype or the
        variant existence of data receive points in the implementation.
    :ivar data_receive_point_by_values: RunnableEntity has explicit read
        access to dataElement of a sender-receiver PortPrototype or nv
        data of a nv data PortPrototype. The result is passed back to
        the application by means of the return value. The aggregation of
        dataReceivePointByValue is subject to variability with the
        purpose to support the conditional existence of sender receiver
        ports or the variant existence of data receive points in the
        implementation.
    :ivar data_send_points: RunnableEntity has explicit write access to
        dataElement of a sender-receiver PortPrototype or nv data of a
        nv data PortPrototype. The aggregation of dataSendPoint is
        subject to variability with the purpose to support the
        conditional existence of sender receiver PortPrototype or the
        variant existence of data send points in the implementation.
    :ivar data_write_accesss: RunnableEntity has implicit write access
        to dataElement of a sender-receiver PortPrototype or nv data of
        a nv data PortPrototype. The aggregation of dataWriteAccess is
        subject to variability with the purpose to support the
        conditional existence of sender receiver ports or the variant
        existence of dataWriteAccess in the implementation.
    :ivar external_triggering_points: The aggregation of
        ExternalTriggeringPoint is subject to variability with the
        purpose to support the conditional existence of trigger ports or
        the variant existence of external triggering points in the
        implementation.
    :ivar internal_triggering_points: The aggregation of
        InternalTriggeringPoint is subject to variability with the
        purpose to support the variant existence of internal triggering
        points in the implementation.
    :ivar mode_access_points: The runnable has a mode access point. The
        aggregation of ModeAccessPoint is subject to variability with
        the purpose to support the conditional existence of mode ports
        or the variant existence of mode access points in the
        implementation.
    :ivar mode_switch_points: The runnable has a mode switch point. The
        aggregation of ModeSwitchPoint is subject to variability with
        the purpose to support the conditional existence of mode ports
        or the variant existence of mode switch points in the
        implementation.
    :ivar parameter_accesss: The presence of a ParameterAccess implies
        that a RunnableEntity needs read only access to a
        ParameterDataPrototype which may either be local or within a
        PortPrototype. The aggregation of ParameterAccess is subject to
        variability with the purpose to support the conditional
        existence of parameter ports and component local parameters as
        well as the variant existence of ParameterAccess (points) in the
        implementation.
    :ivar read_local_variables: The presence of a readLocalVariable
        implies that a RunnableEntity needs read access to a
        VariableDataPrototype in the role of
        implicitInterRunnableVariable or explicitInterRunnableVariable.
        The aggregation of readLocalVariable is subject to variability
        with the purpose to support the conditional existence of
        implicitInterRunnableVariable and explicitInterRunnableVariable
        or the variant existence of readLocalVariable (points) in the
        implementation.
    :ivar server_call_points: The RunnableEntity has a ServerCallPoint.
        The aggregation of ServerCallPoint is subject to variability
        with the purpose to support the conditional existence of client
        server PortPrototypes or the variant existence of server call
        points in the implementation.
    :ivar symbol: The symbol describing this RunnableEntity's entry
        point. This is considered the API of the RunnableEntity and is
        required during the RTE contract phase.
    :ivar wait_points: The WaitPoint associated with the RunnableEntity.
    :ivar written_local_variables: The presence of a
        writtenLocalVariable implies that a RunnableEntity needs write
        access to a VariableDataPrototype in the role of
        implicitInterRunnableVariable or explicitInterRunnableVariable.
        The aggregation of writtenLocalVariable is subject to
        variability with the purpose to support the conditional
        existence of implicitInterRunnableVariable and
        explicitInterRunnableVariable or the variant existence of
        writtenLocalVariable (points) in the implementation.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.runnable
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RUNNABLE-ENTITY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RunnableEntity.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RunnableEntity.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    activation_reasons: Optional["RunnableEntity.ActivationReasons"] = field(
        default=None,
        metadata={
            "name": "ACTIVATION-REASONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_enters: Optional["RunnableEntity.CanEnters"] = field(
        default=None,
        metadata={
            "name": "CAN-ENTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_enter_exclusive_area_refs: Optional["RunnableEntity.CanEnterExclusiveAreaRefs"] = field(
        default=None,
        metadata={
            "name": "CAN-ENTER-EXCLUSIVE-AREA-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_area_nesting_order_refs: Optional["RunnableEntity.ExclusiveAreaNestingOrderRefs"] = (
        field(
            default=None,
            metadata={
                "name": "EXCLUSIVE-AREA-NESTING-ORDER-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    minimum_start_interval: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-START-INTERVAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reentrancy_level: ReentrancyLevelEnum | None = field(
        default=None,
        metadata={
            "name": "REENTRANCY-LEVEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runs_insides: Optional["RunnableEntity.RunsInsides"] = field(
        default=None,
        metadata={
            "name": "RUNS-INSIDES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runs_inside_exclusive_area_refs: Optional["RunnableEntity.RunsInsideExclusiveAreaRefs"] = field(
        default=None,
        metadata={
            "name": "RUNS-INSIDE-EXCLUSIVE-AREA-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_addr_method_ref: Optional["RunnableEntity.SwAddrMethodRef"] = field(
        default=None,
        metadata={
            "name": "SW-ADDR-METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    arguments: Optional["RunnableEntity.Arguments"] = field(
        default=None,
        metadata={
            "name": "ARGUMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    asynchronous_server_call_result_points: Optional[
        "RunnableEntity.AsynchronousServerCallResultPoints"
    ] = field(
        default=None,
        metadata={
            "name": "ASYNCHRONOUS-SERVER-CALL-RESULT-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_be_invoked_concurrently: Boolean | None = field(
        default=None,
        metadata={
            "name": "CAN-BE-INVOKED-CONCURRENTLY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_read_accesss: Optional["RunnableEntity.DataReadAccesss"] = field(
        default=None,
        metadata={
            "name": "DATA-READ-ACCESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_receive_point_by_arguments: Optional["RunnableEntity.DataReceivePointByArguments"] = field(
        default=None,
        metadata={
            "name": "DATA-RECEIVE-POINT-BY-ARGUMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_receive_point_by_values: Optional["RunnableEntity.DataReceivePointByValues"] = field(
        default=None,
        metadata={
            "name": "DATA-RECEIVE-POINT-BY-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_send_points: Optional["RunnableEntity.DataSendPoints"] = field(
        default=None,
        metadata={
            "name": "DATA-SEND-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_write_accesss: Optional["RunnableEntity.DataWriteAccesss"] = field(
        default=None,
        metadata={
            "name": "DATA-WRITE-ACCESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    external_triggering_points: Optional["RunnableEntity.ExternalTriggeringPoints"] = field(
        default=None,
        metadata={
            "name": "EXTERNAL-TRIGGERING-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    internal_triggering_points: Optional["RunnableEntity.InternalTriggeringPoints"] = field(
        default=None,
        metadata={
            "name": "INTERNAL-TRIGGERING-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_access_points: Optional["RunnableEntity.ModeAccessPoints"] = field(
        default=None,
        metadata={
            "name": "MODE-ACCESS-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_switch_points: Optional["RunnableEntity.ModeSwitchPoints"] = field(
        default=None,
        metadata={
            "name": "MODE-SWITCH-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_accesss: Optional["RunnableEntity.ParameterAccesss"] = field(
        default=None,
        metadata={
            "name": "PARAMETER-ACCESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    read_local_variables: Optional["RunnableEntity.ReadLocalVariables"] = field(
        default=None,
        metadata={
            "name": "READ-LOCAL-VARIABLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    server_call_points: Optional["RunnableEntity.ServerCallPoints"] = field(
        default=None,
        metadata={
            "name": "SERVER-CALL-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "SYMBOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wait_points: Optional["RunnableEntity.WaitPoints"] = field(
        default=None,
        metadata={
            "name": "WAIT-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    written_local_variables: Optional["RunnableEntity.WrittenLocalVariables"] = field(
        default=None,
        metadata={
            "name": "WRITTEN-LOCAL-VARIABLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActivationReasons:
        executable_entity_activation_reason: list[ExecutableEntityActivationReason] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTABLE-ENTITY-ACTIVATION-REASON",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CanEnters:
        exclusive_area_ref_conditional: list[ExclusiveAreaRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CanEnterExclusiveAreaRefs:
        can_enter_exclusive_area_ref: list[
            "RunnableEntity.CanEnterExclusiveAreaRefs.CanEnterExclusiveAreaRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CAN-ENTER-EXCLUSIVE-AREA-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CanEnterExclusiveAreaRef(Ref):
            dest: ExclusiveAreaSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaNestingOrderRefs:
        exclusive_area_nesting_order_ref: list[
            "RunnableEntity.ExclusiveAreaNestingOrderRefs.ExclusiveAreaNestingOrderRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA-NESTING-ORDER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ExclusiveAreaNestingOrderRef(Ref):
            dest: ExclusiveAreaNestingOrderSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RunsInsides:
        exclusive_area_ref_conditional: list[ExclusiveAreaRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RunsInsideExclusiveAreaRefs:
        runs_inside_exclusive_area_ref: list[
            "RunnableEntity.RunsInsideExclusiveAreaRefs.RunsInsideExclusiveAreaRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "RUNS-INSIDE-EXCLUSIVE-AREA-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RunsInsideExclusiveAreaRef(Ref):
            dest: ExclusiveAreaSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SwAddrMethodRef(Ref):
        dest: SwAddrMethodSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Arguments:
        runnable_entity_argument: list[RunnableEntityArgument] = field(
            default_factory=list,
            metadata={
                "name": "RUNNABLE-ENTITY-ARGUMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AsynchronousServerCallResultPoints:
        asynchronous_server_call_result_point: list[AsynchronousServerCallResultPoint] = field(
            default_factory=list,
            metadata={
                "name": "ASYNCHRONOUS-SERVER-CALL-RESULT-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataReadAccesss:
        variable_access: list[VariableAccess] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataReceivePointByArguments:
        variable_access: list[VariableAccess] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataReceivePointByValues:
        variable_access: list[VariableAccess] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataSendPoints:
        variable_access: list[VariableAccess] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataWriteAccesss:
        variable_access: list[VariableAccess] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExternalTriggeringPoints:
        external_triggering_point: list[ExternalTriggeringPoint] = field(
            default_factory=list,
            metadata={
                "name": "EXTERNAL-TRIGGERING-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InternalTriggeringPoints:
        internal_triggering_point: list[InternalTriggeringPoint] = field(
            default_factory=list,
            metadata={
                "name": "INTERNAL-TRIGGERING-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModeAccessPoints:
        mode_access_point: list[ModeAccessPoint] = field(
            default_factory=list,
            metadata={
                "name": "MODE-ACCESS-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModeSwitchPoints:
        mode_switch_point: list[ModeSwitchPoint] = field(
            default_factory=list,
            metadata={
                "name": "MODE-SWITCH-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ParameterAccesss:
        parameter_access: list[ParameterAccess] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ReadLocalVariables:
        variable_access: list[VariableAccess] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServerCallPoints:
        asynchronous_server_call_point: list[AsynchronousServerCallPoint] = field(
            default_factory=list,
            metadata={
                "name": "ASYNCHRONOUS-SERVER-CALL-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronous_server_call_point: list[SynchronousServerCallPoint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONOUS-SERVER-CALL-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class WaitPoints:
        wait_point: list[WaitPoint] = field(
            default_factory=list,
            metadata={
                "name": "WAIT-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class WrittenLocalVariables:
        variable_access: list[VariableAccess] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SdgDef:
    """A SdgDef groups several SdgClasses which belong to the same extension.

    The concept of an SdgDef is similiar to an UML Profile.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar sdg_classes: The owned sdgClasses which define the structure
        of the Sdgs
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SDG-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SdgDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SdgDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sdg_classes: Optional["SdgDef.SdgClasses"] = field(
        default=None,
        metadata={
            "name": "SDG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SdgClasses:
        sdg_class: list[SdgClass] = field(
            default_factory=list,
            metadata={
                "name": "SDG-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventContextMappingApplication:
    """
    This meta-class represents the ability to associate a collection of security
    events with an IdsM instance and with the executional context of an application
    (e.g. name of SWC on CP or name of SWCL on AP)  in which this IdsM instance can
    receive reports for these security events.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar filter_chains: This reference defines the filter chain to be
        applied to each of the referenced security events (depending on
        the reporting mode). This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar idsm_instances: This reference defines the IdsmInstance onto
        which the security events are mapped. This property was modified
        due to atpVariation (DirectedAssociationPattern).
    :ivar mapped_security_events: This aggregation represents (through
        further references) the SecurityEventDefinitions to be mapped to
        an IdsmInstance with additional mapping-dependent properties.
    :ivar affected_application: This attribute is used to identify the
        name of the application in whose executional context a security
        event can occur. This application can be, for example, a name of
        a Software Component (for CP) or a Software Cluster name (for
        AP).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-CONTEXT-MAPPING-APPLICATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecurityEventContextMappingApplication.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecurityEventContextMappingApplication.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    filter_chains: Optional["SecurityEventContextMappingApplication.FilterChains"] = field(
        default=None,
        metadata={
            "name": "FILTER-CHAINS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    idsm_instances: Optional["SecurityEventContextMappingApplication.IdsmInstances"] = field(
        default=None,
        metadata={
            "name": "IDSM-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapped_security_events: Optional[
        "SecurityEventContextMappingApplication.MappedSecurityEvents"
    ] = field(
        default=None,
        metadata={
            "name": "MAPPED-SECURITY-EVENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    affected_application: String | None = field(
        default=None,
        metadata={
            "name": "AFFECTED-APPLICATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FilterChains:
        security_event_filter_chain_ref_conditional: list[
            SecurityEventFilterChainRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-FILTER-CHAIN-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IdsmInstances:
        idsm_instance_ref_conditional: list[IdsmInstanceRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "IDSM-INSTANCE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MappedSecurityEvents:
        security_event_context_props: list[SecurityEventContextProps] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-CONTEXT-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventContextMappingBswModule:
    """
    This meta-class represents the ability to associate a collection of security
    events with an IdsM instance and with the executional context of a BSW module
    in which this IdsM instance can receive reports for these security events.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar filter_chains: This reference defines the filter chain to be
        applied to each of the referenced security events (depending on
        the reporting mode). This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar idsm_instances: This reference defines the IdsmInstance onto
        which the security events are mapped. This property was modified
        due to atpVariation (DirectedAssociationPattern).
    :ivar mapped_security_events: This aggregation represents (through
        further references) the SecurityEventDefinitions to be mapped to
        an IdsmInstance with additional mapping-dependent properties.
    :ivar affected_bsw_module: This attribute is used to identify the
        name of the BSW module in whose executional context a security
        event can occur. The set of BSW module names is standardized by
        AUTOSAR.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-CONTEXT-MAPPING-BSW-MODULE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SecurityEventContextMappingBswModule.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecurityEventContextMappingBswModule.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    filter_chains: Optional["SecurityEventContextMappingBswModule.FilterChains"] = field(
        default=None,
        metadata={
            "name": "FILTER-CHAINS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    idsm_instances: Optional["SecurityEventContextMappingBswModule.IdsmInstances"] = field(
        default=None,
        metadata={
            "name": "IDSM-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapped_security_events: Optional[
        "SecurityEventContextMappingBswModule.MappedSecurityEvents"
    ] = field(
        default=None,
        metadata={
            "name": "MAPPED-SECURITY-EVENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    affected_bsw_module: String | None = field(
        default=None,
        metadata={
            "name": "AFFECTED-BSW-MODULE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FilterChains:
        security_event_filter_chain_ref_conditional: list[
            SecurityEventFilterChainRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-FILTER-CHAIN-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IdsmInstances:
        idsm_instance_ref_conditional: list[IdsmInstanceRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "IDSM-INSTANCE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MappedSecurityEvents:
        security_event_context_props: list[SecurityEventContextProps] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-CONTEXT-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventContextMappingCommConnector:
    """
    This meta-class represents the ability to associate a collection of security
    events with an IdsM instance and with the executional context related to a
    CommunicationConnector in which this IdsM instance can receive reports for
    these security events.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar filter_chains: This reference defines the filter chain to be
        applied to each of the referenced security events (depending on
        the reporting mode). This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar idsm_instances: This reference defines the IdsmInstance onto
        which the security events are mapped. This property was modified
        due to atpVariation (DirectedAssociationPattern).
    :ivar mapped_security_events: This aggregation represents (through
        further references) the SecurityEventDefinitions to be mapped to
        an IdsmInstance with additional mapping-dependent properties.
    :ivar comm_connectors: This reference identifies the respective
        CommunicationConnector for which the collection of security
        events can be reported. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-CONTEXT-MAPPING-COMM-CONNECTOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "SecurityEventContextMappingCommConnector.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecurityEventContextMappingCommConnector.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    filter_chains: Optional["SecurityEventContextMappingCommConnector.FilterChains"] = field(
        default=None,
        metadata={
            "name": "FILTER-CHAINS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    idsm_instances: Optional["SecurityEventContextMappingCommConnector.IdsmInstances"] = field(
        default=None,
        metadata={
            "name": "IDSM-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapped_security_events: Optional[
        "SecurityEventContextMappingCommConnector.MappedSecurityEvents"
    ] = field(
        default=None,
        metadata={
            "name": "MAPPED-SECURITY-EVENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_connectors: Optional["SecurityEventContextMappingCommConnector.CommConnectors"] = field(
        default=None,
        metadata={
            "name": "COMM-CONNECTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FilterChains:
        security_event_filter_chain_ref_conditional: list[
            SecurityEventFilterChainRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-FILTER-CHAIN-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IdsmInstances:
        idsm_instance_ref_conditional: list[IdsmInstanceRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "IDSM-INSTANCE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MappedSecurityEvents:
        security_event_context_props: list[SecurityEventContextProps] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-CONTEXT-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommConnectors:
        communication_connector_ref_conditional: list[CommunicationConnectorRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "COMMUNICATION-CONNECTOR-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SecurityEventContextMappingFunctionalCluster:
    """
    This meta-class represents the ability to associate a collection of security
    events with an IdsM instance and with the executional context of a functional
    cluster in which this IdsM instance can receive reports for these security
    events.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar filter_chains: This reference defines the filter chain to be
        applied to each of the referenced security events (depending on
        the reporting mode). This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar idsm_instances: This reference defines the IdsmInstance onto
        which the security events are mapped. This property was modified
        due to atpVariation (DirectedAssociationPattern).
    :ivar mapped_security_events: This aggregation represents (through
        further references) the SecurityEventDefinitions to be mapped to
        an IdsmInstance with additional mapping-dependent properties.
    :ivar affected_functional_cluster: This attribute is used to
        identify the name of the functional cluster in whose executional
        context a security event can occur. The set of functional
        cluster names is standardized by AUTOSAR.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SECURITY-EVENT-CONTEXT-MAPPING-FUNCTIONAL-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional[
        "SecurityEventContextMappingFunctionalCluster.ShortNameFragments"
    ] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SecurityEventContextMappingFunctionalCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    filter_chains: Optional["SecurityEventContextMappingFunctionalCluster.FilterChains"] = field(
        default=None,
        metadata={
            "name": "FILTER-CHAINS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    idsm_instances: Optional["SecurityEventContextMappingFunctionalCluster.IdsmInstances"] = field(
        default=None,
        metadata={
            "name": "IDSM-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapped_security_events: Optional[
        "SecurityEventContextMappingFunctionalCluster.MappedSecurityEvents"
    ] = field(
        default=None,
        metadata={
            "name": "MAPPED-SECURITY-EVENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    affected_functional_cluster: String | None = field(
        default=None,
        metadata={
            "name": "AFFECTED-FUNCTIONAL-CLUSTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FilterChains:
        security_event_filter_chain_ref_conditional: list[
            SecurityEventFilterChainRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-FILTER-CHAIN-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IdsmInstances:
        idsm_instance_ref_conditional: list[IdsmInstanceRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "IDSM-INSTANCE-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MappedSecurityEvents:
        security_event_context_props: list[SecurityEventContextProps] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-CONTEXT-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SignalServiceTranslationProps:
    """
    This element allows to define the properties which are applicable for the
    signal/service translation service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar control_consumed_event_group_refs: Reference to the EventGroup
        which encapsulates the signal-based payload.
    :ivar control_pnc_refs: Reference to the PNCs which control the
        offer/subscribe behavior of the translated service instance.
    :ivar control_provided_event_group_refs: Reference to the provided
        event group (aka EventHandler) which is automatically available
        when serviceControl equals translationStart.
    :ivar service_control: Defines how the service instance control
        shall behave.
    :ivar signal_service_translation_event_propss: Defines properties
        for a single translated event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SIGNAL-SERVICE-TRANSLATION-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SignalServiceTranslationProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SignalServiceTranslationProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    control_consumed_event_group_refs: Optional[
        "SignalServiceTranslationProps.ControlConsumedEventGroupRefs"
    ] = field(
        default=None,
        metadata={
            "name": "CONTROL-CONSUMED-EVENT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    control_pnc_refs: Optional["SignalServiceTranslationProps.ControlPncRefs"] = field(
        default=None,
        metadata={
            "name": "CONTROL-PNC-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    control_provided_event_group_refs: Optional[
        "SignalServiceTranslationProps.ControlProvidedEventGroupRefs"
    ] = field(
        default=None,
        metadata={
            "name": "CONTROL-PROVIDED-EVENT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_control: SignalServiceTranslationControlEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-CONTROL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signal_service_translation_event_propss: Optional[
        "SignalServiceTranslationProps.SignalServiceTranslationEventPropss"
    ] = field(
        default=None,
        metadata={
            "name": "SIGNAL-SERVICE-TRANSLATION-EVENT-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ControlConsumedEventGroupRefs:
        control_consumed_event_group_ref: list[
            "SignalServiceTranslationProps.ControlConsumedEventGroupRefs.ControlConsumedEventGroupRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTROL-CONSUMED-EVENT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ControlConsumedEventGroupRef(Ref):
            dest: ConsumedEventGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ControlPncRefs:
        control_pnc_ref: list["SignalServiceTranslationProps.ControlPncRefs.ControlPncRef"] = field(
            default_factory=list,
            metadata={
                "name": "CONTROL-PNC-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ControlPncRef(Ref):
            dest: PncMappingIdentSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ControlProvidedEventGroupRefs:
        control_provided_event_group_ref: list[
            "SignalServiceTranslationProps.ControlProvidedEventGroupRefs.ControlProvidedEventGroupRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONTROL-PROVIDED-EVENT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ControlProvidedEventGroupRef(Ref):
            dest: EventHandlerSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SignalServiceTranslationEventPropss:
        signal_service_translation_event_props: list[SignalServiceTranslationEventProps] = field(
            default_factory=list,
            metadata={
                "name": "SIGNAL-SERVICE-TRANSLATION-EVENT-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SomeipServiceInterfaceDeployment:
    """
    SOME/IP configuration settings for a ServiceInterface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar event_deployments: Middleware transport layer specific
        configuration settings for an Event that is defined in the
        ServiceInterface.
    :ivar field_deployments: Middleware transport layer specific
        configuration settings for a Field that is defined in the
        ServiceInterface.
    :ivar method_deployments: Middleware transport layer specific
        configuration settings for a method that is defined in the
        ServiceInterface.
    :ivar service_interface_ref: Reference to a ServiceInterface that is
        deployed to a middleware transport layer.
    :ivar event_groups: SOME/IP EventGroups that are defined within the
        SOME/IP ServiceClass.
    :ivar service_interface_id: Unique Identifier that identifies the
        ServiceInterface in SOME/IP. This Identifier is sent as Service
        ID in SOME/IP Service Discovery messages.
    :ivar service_interface_version: The SOME/IP major and minor Version
        of the Service.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOMEIP-SERVICE-INTERFACE-DEPLOYMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SomeipServiceInterfaceDeployment.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SomeipServiceInterfaceDeployment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_deployments: Optional["SomeipServiceInterfaceDeployment.EventDeployments"] = field(
        default=None,
        metadata={
            "name": "EVENT-DEPLOYMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_deployments: Optional["SomeipServiceInterfaceDeployment.FieldDeployments"] = field(
        default=None,
        metadata={
            "name": "FIELD-DEPLOYMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_deployments: Optional["SomeipServiceInterfaceDeployment.MethodDeployments"] = field(
        default=None,
        metadata={
            "name": "METHOD-DEPLOYMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_ref: Optional["SomeipServiceInterfaceDeployment.ServiceInterfaceRef"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_groups: Optional["SomeipServiceInterfaceDeployment.EventGroups"] = field(
        default=None,
        metadata={
            "name": "EVENT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_version: SomeipServiceVersion | None = field(
        default=None,
        metadata={
            "name": "SERVICE-INTERFACE-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventDeployments:
        dds_event_deployment: list[DdsEventDeployment] = field(
            default_factory=list,
            metadata={
                "name": "DDS-EVENT-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_event_deployment: list[SomeipEventDeployment] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-EVENT-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_event_deployment: list[UserDefinedEventDeployment] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-EVENT-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FieldDeployments:
        dds_field_deployment: list[DdsFieldDeployment] = field(
            default_factory=list,
            metadata={
                "name": "DDS-FIELD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_field_deployment: list[SomeipFieldDeployment] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-FIELD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_field_deployment: list[UserDefinedFieldDeployment] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-FIELD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MethodDeployments:
        someip_method_deployment: list[SomeipMethodDeployment] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-METHOD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_method_deployment: list[UserDefinedMethodDeployment] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-METHOD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInterfaceRef(Ref):
        dest: ServiceInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventGroups:
        someip_event_group: list[SomeipEventGroup] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-EVENT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SpecificationScope:
    """
    Specification of the relevant subset of Autosar specifications.

    :ivar specification_document_scopes: The Autosar or custom
        specifications that contain that are considered in this Data
        Exchange Point.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SPECIFICATION-SCOPE"

    specification_document_scopes: Optional["SpecificationScope.SpecificationDocumentScopes"] = (
        field(
            default=None,
            metadata={
                "name": "SPECIFICATION-DOCUMENT-SCOPES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SpecificationDocumentScopes:
        specification_document_scope: list[SpecificationDocumentScope] = field(
            default_factory=list,
            metadata={
                "name": "SPECIFICATION-DOCUMENT-SCOPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwValues:
    """This meta-class represents a list of values.

    These values can either be the input values of a curve (abscissa
    values) or the associated values (ordinate values). In case of
    multidimensional structures, the values are ordered such that the
    lowest index runs the fastest. In particular for maps and cuboids
    etc. the resulting long value list can be subsectioned using
    ValueGroup. But the processing needs to be done as if vg is not
    there. Note that numerical values and textual values should not be
    mixed.

    :ivar vtf: This aggregation represents the ability to provide a
        value that is either numerical or text which existence is
        subject to variability. From the formal point of view, the
        aggregation needs to have the multiplicity 1 because SwValues is
        modelled with stereotype &lt;&lt;atpMixed&gt;&gt;. Nevertheless,
        the existence of vtf is optional and subject to constraints. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar vf: This allows to specify the value as VariationPoint. It is
        distinguished to non variant for sake of compatibility to ASAM
        CDF 2.0.
    :ivar vt: This represents the values of textual data elements
        (Strings). Note that vt uses the | to separate the values for
        the different bitfield masks in case that the semantics of the
        related DataPrototype is described by means of a
        BITFIELD_TEXTTABLE in the associated CompuMethod.
    :ivar v: This is a non variant Value. It is provided for sake of
        Compatibility to ASAM CDF.
    :ivar vg: This allows to have intersections in the values in order
        to support specific rendering (eg. using stylesheets). For tools
        it is important that the v values are always processed in the
        same (flattened) order and the tool is able to interpret it
        without respecting vg.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-VALUES"

    vtf: list[NumericalOrText] = field(
        default_factory=list,
        metadata={
            "name": "VTF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vf: list[NumericalValueVariationPoint] = field(
        default_factory=list,
        metadata={
            "name": "VF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vt: list[VerbatimString] = field(
        default_factory=list,
        metadata={
            "name": "VT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    v: list[NumericalValue] = field(
        default_factory=list,
        metadata={
            "name": "V",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vg: list[ValueGroup] = field(
        default_factory=list,
        metadata={
            "name": "VG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class TdEventBswInternalBehavior:
    """
    This is used to describe timing events related to the BswInternalBehavior of a
    BSW module.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar bsw_module_entity_ref: The scope of this timing event.
    :ivar td_event_bsw_internal_behavior_type: The specific type of this
        timing event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-BSW-INTERNAL-BEHAVIOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventBswInternalBehavior.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventBswInternalBehavior.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventBswInternalBehavior.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_module_entity_ref: Optional["TdEventBswInternalBehavior.BswModuleEntityRef"] = field(
        default=None,
        metadata={
            "name": "BSW-MODULE-ENTITY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_bsw_internal_behavior_type: TdEventBswInternalBehaviorTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-BSW-INTERNAL-BEHAVIOR-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class BswModuleEntityRef(Ref):
        dest: BswModuleEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventBswModeDeclaration:
    """
    This is used to describe timing events related to the mode communication on BSW
    level.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar bsw_module_description_ref: The scope of this timing event.
    :ivar entry_mode_declaration_ref: Optional parameter which refines
        the scope of the TDEventBswModeDeclaration. If the parameter is
        set, the event occurs only if the mode declaration group
        prototype instance shall enter into the referenced
        ModeDeclaration.
    :ivar exit_mode_declaration_ref: Optional parameter which refines
        the scope of the TDEventBswModeDeclaration. If the parameter is
        set, the event occurs only if the mode declaration group
        prototype instance shall exit from the referenced
        ModeDeclaration.
    :ivar mode_declaration_ref: The scope of this timing event.
    :ivar td_event_bsw_mode_declaration_type: The specific type of this
        timing event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-BSW-MODE-DECLARATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventBswModeDeclaration.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventBswModeDeclaration.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventBswModeDeclaration.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_module_description_ref: Optional["TdEventBswModeDeclaration.BswModuleDescriptionRef"] = (
        field(
            default=None,
            metadata={
                "name": "BSW-MODULE-DESCRIPTION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    entry_mode_declaration_ref: Optional["TdEventBswModeDeclaration.EntryModeDeclarationRef"] = (
        field(
            default=None,
            metadata={
                "name": "ENTRY-MODE-DECLARATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    exit_mode_declaration_ref: Optional["TdEventBswModeDeclaration.ExitModeDeclarationRef"] = field(
        default=None,
        metadata={
            "name": "EXIT-MODE-DECLARATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_declaration_ref: Optional["TdEventBswModeDeclaration.ModeDeclarationRef"] = field(
        default=None,
        metadata={
            "name": "MODE-DECLARATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_bsw_mode_declaration_type: TdEventBswModeDeclarationTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-BSW-MODE-DECLARATION-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class BswModuleDescriptionRef(Ref):
        dest: BswModuleDescriptionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EntryModeDeclarationRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ExitModeDeclarationRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ModeDeclarationRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventBswModule:
    """
    This is used to describe timing events related to the interaction between BSW
    modules.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar bsw_module_description_ref: The scope of this timing event.
    :ivar bsw_module_entry_ref: The scope of this timing event.
    :ivar td_event_bsw_module_type: The specific type of this timing
        event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-BSW-MODULE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventBswModule.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventBswModule.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventBswModule.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_module_description_ref: Optional["TdEventBswModule.BswModuleDescriptionRef"] = field(
        default=None,
        metadata={
            "name": "BSW-MODULE-DESCRIPTION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_module_entry_ref: Optional["TdEventBswModule.BswModuleEntryRef"] = field(
        default=None,
        metadata={
            "name": "BSW-MODULE-ENTRY-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_bsw_module_type: TdEventBswModuleTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-BSW-MODULE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class BswModuleDescriptionRef(Ref):
        dest: BswModuleDescriptionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class BswModuleEntryRef(Ref):
        dest: BswModuleEntrySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventComplex:
    """This is used to describe complex timing events.

    The context of a complex timing event either is described
    informally, e.g. using the documentation block, or is described
    formally by the associated TDEventOccurrenceExpression.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-COMPLEX"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventComplex.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventComplex.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventComplex.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventFrClusterCycleStart:
    """
    This is used to describe the timing event related to a point in time where a
    communication cycle starts on a FlexRay cluster.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar ecu_instance_ref: The ECU context for a particular timing
        event. The link is optional, because the EcuInstance can not be
        defined for events of type TDEventCycleStart.
    :ivar cycle_repetition: The start of every &lt;cycleRepetition&gt;
        cycle is targeted by this event.
    :ivar fr_cluster_ref: The scope of this timing event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-FR-CLUSTER-CYCLE-START"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventFrClusterCycleStart.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventFrClusterCycleStart.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventFrClusterCycleStart.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["TdEventFrClusterCycleStart.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cycle_repetition: Integer | None = field(
        default=None,
        metadata={
            "name": "CYCLE-REPETITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fr_cluster_ref: Optional["TdEventFrClusterCycleStart.FrClusterRef"] = field(
        default=None,
        metadata={
            "name": "FR-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FrClusterRef(Ref):
        dest: FlexrayClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventFrame:
    """
    This is used to describe timing events related to the exchange of frames
    between the communication controller and the bus specific (FlexRay / CAN / LIN)
    Interface BSW module.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar ecu_instance_ref: The ECU context for a particular timing
        event. The link is optional, because the EcuInstance can not be
        defined for events of type TDEventCycleStart.
    :ivar frame_ref: The scope of this timing event.
    :ivar physical_channel_ref: The PhysicalChannel on which the Frame
        is transmitted.
    :ivar td_event_type: The specific type of this timing event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-FRAME"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventFrame.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventFrame.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventFrame.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["TdEventFrame.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_ref: Optional["TdEventFrame.FrameRef"] = field(
        default=None,
        metadata={
            "name": "FRAME-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_channel_ref: Optional["TdEventFrame.PhysicalChannelRef"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNEL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_type: TdEventFrameTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FrameRef(Ref):
        dest: FrameSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannelRef(Ref):
        dest: PhysicalChannelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventFrameEthernet:
    """
    This is used to describe timing description events related to the exchange of
    Ethernet frames between an Ethernet communication controller and the BSW
    Ethernet interface and driver module.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar ecu_instance_ref: The ECU context for a particular timing
        event. The link is optional, because the EcuInstance can not be
        defined for events of type TDEventCycleStart.
    :ivar socket_connection_bundle_ref: Specifies the
        SocketConnectionBundle by the means of which the PDUs are
        transmitted or received within an Ethernet Frame.
    :ivar static_socket_connection_ref: Specifies the SocketConnection
        by the means of which Physical Data Units (PDU) are transmitted
        or received within an Ethernet Frame.
    :ivar td_event_type: This is used to describe the specific event
        type of a TDEventFrameEthernet.
    :ivar td_header_id_filters: Specifies the header identifier or a
        range of header identifiers that if contained in the Ethernet
        frame let the TDEventFrameEthernet occur.
    :ivar td_pdu_triggering_filter_refs: Specifies the PDU that if
        contained in the Ethernet frame let the TDEventFrameEthernet
        occur.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-FRAME-ETHERNET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventFrameEthernet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventFrameEthernet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventFrameEthernet.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["TdEventFrameEthernet.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    socket_connection_bundle_ref: Optional["TdEventFrameEthernet.SocketConnectionBundleRef"] = (
        field(
            default=None,
            metadata={
                "name": "SOCKET-CONNECTION-BUNDLE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    static_socket_connection_ref: Optional["TdEventFrameEthernet.StaticSocketConnectionRef"] = (
        field(
            default=None,
            metadata={
                "name": "STATIC-SOCKET-CONNECTION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    td_event_type: TdEventFrameEthernetTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_header_id_filters: Optional["TdEventFrameEthernet.TdHeaderIdFilters"] = field(
        default=None,
        metadata={
            "name": "TD-HEADER-ID-FILTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_pdu_triggering_filter_refs: Optional["TdEventFrameEthernet.TdPduTriggeringFilterRefs"] = (
        field(
            default=None,
            metadata={
                "name": "TD-PDU-TRIGGERING-FILTER-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SocketConnectionBundleRef(Ref):
        dest: SocketConnectionBundleSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class StaticSocketConnectionRef(Ref):
        dest: StaticSocketConnectionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TdHeaderIdFilters:
        td_header_id_range: list[TdHeaderIdRange] = field(
            default_factory=list,
            metadata={
                "name": "TD-HEADER-ID-RANGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TdPduTriggeringFilterRefs:
        td_pdu_triggering_filter_ref: list[
            "TdEventFrameEthernet.TdPduTriggeringFilterRefs.TdPduTriggeringFilterRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "TD-PDU-TRIGGERING-FILTER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TdPduTriggeringFilterRef(Ref):
            dest: PduTriggeringSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class TdEventIPdu:
    """
    This is used to describe timing events related to the exchange of I-PDUs
    between the bus specific (FlexRay / CAN / LIN) Interface BSW module and COM.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar ecu_instance_ref: The ECU context for a particular timing
        event. The link is optional, because the EcuInstance can not be
        defined for events of type TDEventCycleStart.
    :ivar i_pdu_ref: The scope of this timing event.
    :ivar physical_channel_ref: The PhysicalChannel on which the IPdu is
        transmitted.
    :ivar td_event_type: The specific type of this timing event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-I-PDU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventIPdu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventIPdu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventIPdu.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["TdEventIPdu.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_pdu_ref: Optional["TdEventIPdu.IPduRef"] = field(
        default=None,
        metadata={
            "name": "I-PDU-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_channel_ref: Optional["TdEventIPdu.PhysicalChannelRef"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNEL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_type: TdEventIPduTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class IPduRef(Ref):
        dest: IPduSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannelRef(Ref):
        dest: PhysicalChannelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventISignal:
    """
    This is used to describe timing events related to the exchange of I-Signals
    between COM and RTE.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar ecu_instance_ref: The ECU context for a particular timing
        event. The link is optional, because the EcuInstance can not be
        defined for events of type TDEventCycleStart.
    :ivar i_signal_ref: The scope of this timing event.
    :ivar physical_channel_ref: The PhysicalChannel on which the ISignal
        is transmitted.
    :ivar td_event_type: The specific type of this timing event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-I-SIGNAL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventISignal.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventISignal.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventISignal.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["TdEventISignal.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_ref: Optional["TdEventISignal.ISignalRef"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_channel_ref: Optional["TdEventISignal.PhysicalChannelRef"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNEL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_type: TdEventISignalTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalRef(Ref):
        dest: ISignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannelRef(Ref):
        dest: PhysicalChannelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventModeDeclaration:
    """
    This is used to describe timing events related to mode switch communication at
    VFB level.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar component_iref: The context for the scope of this timing
        event.
    :ivar is_external: This attribute is used to refer to external
        events that are related to hardware I/O, like physical sensors
        and actuators, at Virtual Functional Bus (VFB) level.
    :ivar port_prototype_blueprint_ref: The PortPrototypeBlueprint is
        the scope of the timing event.
    :ivar port_ref: The port scope of the timing event.
    :ivar entry_mode_declaration_ref: Optional parameter which refines
        the scope of the TDEventModeDeclaration. If the parameter is
        set, the event occurs only if the mode declaration group
        prototype instance shall enter into the referenced
        ModeDeclaration.
    :ivar exit_mode_declaration_ref: Optional parameter which refines
        the scope of the TDEventModeDeclaration. If the parameter is
        set, the event occurs only if the mode declaration group
        prototype instance shall exit from the referenced
        ModeDeclaration.
    :ivar mode_declaration_ref: The referenced mode declaration group
        prototype.
    :ivar td_event_mode_declaration_type: The specific type of this
        timing event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-MODE-DECLARATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventModeDeclaration.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventModeDeclaration.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventModeDeclaration.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_iref: ComponentInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "COMPONENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_external: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-EXTERNAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_blueprint_ref: Optional["TdEventModeDeclaration.PortPrototypeBlueprintRef"] = (
        field(
            default=None,
            metadata={
                "name": "PORT-PROTOTYPE-BLUEPRINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    port_ref: Optional["TdEventModeDeclaration.PortRef"] = field(
        default=None,
        metadata={
            "name": "PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    entry_mode_declaration_ref: Optional["TdEventModeDeclaration.EntryModeDeclarationRef"] = field(
        default=None,
        metadata={
            "name": "ENTRY-MODE-DECLARATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exit_mode_declaration_ref: Optional["TdEventModeDeclaration.ExitModeDeclarationRef"] = field(
        default=None,
        metadata={
            "name": "EXIT-MODE-DECLARATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_declaration_ref: Optional["TdEventModeDeclaration.ModeDeclarationRef"] = field(
        default=None,
        metadata={
            "name": "MODE-DECLARATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_mode_declaration_type: TdEventModeDeclarationTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-MODE-DECLARATION-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PortPrototypeBlueprintRef(Ref):
        dest: PortPrototypeBlueprintSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EntryModeDeclarationRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ExitModeDeclarationRef(Ref):
        dest: ModeDeclarationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ModeDeclarationRef(Ref):
        dest: ModeDeclarationGroupPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventOperation:
    """
    This is used to describe timing events related to client-server communication
    at VFB level.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar component_iref: The context for the scope of this timing
        event.
    :ivar is_external: This attribute is used to refer to external
        events that are related to hardware I/O, like physical sensors
        and actuators, at Virtual Functional Bus (VFB) level.
    :ivar port_prototype_blueprint_ref: The PortPrototypeBlueprint is
        the scope of the timing event.
    :ivar port_ref: The port scope of the timing event.
    :ivar operation_ref: The referenced operation.
    :ivar td_event_operation_type: The specific type of this timing
        event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-OPERATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventOperation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventOperation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventOperation.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_iref: ComponentInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "COMPONENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_external: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-EXTERNAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_blueprint_ref: Optional["TdEventOperation.PortPrototypeBlueprintRef"] = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-BLUEPRINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_ref: Optional["TdEventOperation.PortRef"] = field(
        default=None,
        metadata={
            "name": "PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_ref: Optional["TdEventOperation.OperationRef"] = field(
        default=None,
        metadata={
            "name": "OPERATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_operation_type: TdEventOperationTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-OPERATION-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PortPrototypeBlueprintRef(Ref):
        dest: PortPrototypeBlueprintSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class OperationRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventServiceInstanceDiscovery:
    """
    This is used to describe timing description events related to different phases
    of service discovery.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar service_instance_to_port_prototype_mapping_ref: The service
        and the port this service is provided.
    :ivar td_event_service_instance_discovery_type: The specific type of
        this timing event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-SERVICE-INSTANCE-DISCOVERY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventServiceInstanceDiscovery.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventServiceInstanceDiscovery.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventServiceInstanceDiscovery.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_to_port_prototype_mapping_ref: Optional[
        "TdEventServiceInstanceDiscovery.ServiceInstanceToPortPrototypeMappingRef"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-TO-PORT-PROTOTYPE-MAPPING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_service_instance_discovery_type: TdEventServiceInstanceDiscoveryTypeEnum | None = (
        field(
            default=None,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-DISCOVERY-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceToPortPrototypeMappingRef(Ref):
        dest: ServiceInstanceToPortPrototypeMappingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventServiceInstanceEvent:
    """
    This is used to describe timing description events related to events of a
    service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar service_instance_to_port_prototype_mapping_ref: The service
        and the port this service is provided.
    :ivar event_ref: The event provided by the service.
    :ivar td_event_service_instance_event_type: The specific type of
        this timing event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-SERVICE-INSTANCE-EVENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventServiceInstanceEvent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventServiceInstanceEvent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventServiceInstanceEvent.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_to_port_prototype_mapping_ref: Optional[
        "TdEventServiceInstanceEvent.ServiceInstanceToPortPrototypeMappingRef"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-TO-PORT-PROTOTYPE-MAPPING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_ref: Optional["TdEventServiceInstanceEvent.EventRef"] = field(
        default=None,
        metadata={
            "name": "EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_service_instance_event_type: TdEventServiceInstanceEventTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-SERVICE-INSTANCE-EVENT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceToPortPrototypeMappingRef(Ref):
        dest: ServiceInstanceToPortPrototypeMappingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EventRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventServiceInstanceField:
    """
    This is used to describe timing description events related to fields of a
    service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar service_instance_to_port_prototype_mapping_ref: The service
        and the port this service is provided.
    :ivar field_ref: The field provided by the service.
    :ivar td_event_service_instance_field_type: The specific type of
        this timing event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-SERVICE-INSTANCE-FIELD"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventServiceInstanceField.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventServiceInstanceField.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventServiceInstanceField.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_to_port_prototype_mapping_ref: Optional[
        "TdEventServiceInstanceField.ServiceInstanceToPortPrototypeMappingRef"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-TO-PORT-PROTOTYPE-MAPPING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_ref: Optional["TdEventServiceInstanceField.FieldRef"] = field(
        default=None,
        metadata={
            "name": "FIELD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_service_instance_field_type: TdEventServiceInstanceFieldTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-SERVICE-INSTANCE-FIELD-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceToPortPrototypeMappingRef(Ref):
        dest: ServiceInstanceToPortPrototypeMappingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FieldRef(Ref):
        dest: FieldSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventServiceInstanceMethod:
    """
    This is used to describe timing description events related to methods of a
    service.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar service_instance_to_port_prototype_mapping_ref: The service
        and the port this service is provided.
    :ivar method_ref: The method provided by the service.
    :ivar td_event_service_instance_method_type: The specific type of
        this timing event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-SERVICE-INSTANCE-METHOD"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventServiceInstanceMethod.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventServiceInstanceMethod.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventServiceInstanceMethod.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_to_port_prototype_mapping_ref: Optional[
        "TdEventServiceInstanceMethod.ServiceInstanceToPortPrototypeMappingRef"
    ] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-TO-PORT-PROTOTYPE-MAPPING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_ref: Optional["TdEventServiceInstanceMethod.MethodRef"] = field(
        default=None,
        metadata={
            "name": "METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_service_instance_method_type: TdEventServiceInstanceMethodTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-SERVICE-INSTANCE-METHOD-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceToPortPrototypeMappingRef(Ref):
        dest: ServiceInstanceToPortPrototypeMappingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MethodRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventSlletPort:
    """
    Used to describe SL-LET timing events on the level of a SWC port.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar port_ref: The originating port of the timing event
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-SLLET-PORT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventSlletPort.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventSlletPort.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventSlletPort.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_ref: Optional["TdEventSlletPort.PortRef"] = field(
        default=None,
        metadata={
            "name": "PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventSwcInternalBehavior:
    """
    This is used to describe timing events related to the SwcInternalBehavior of an
    AtomicSwComponentType.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar component_iref: The context for the scope of this timing
        event.
    :ivar runnable_ref: The scope of this timing event.
    :ivar td_event_swc_internal_behavior_type: The specific type of this
        timing event.
    :ivar variable_access_ref: The scope of this timing event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-SWC-INTERNAL-BEHAVIOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventSwcInternalBehavior.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventSwcInternalBehavior.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventSwcInternalBehavior.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_iref: ComponentInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "COMPONENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runnable_ref: Optional["TdEventSwcInternalBehavior.RunnableRef"] = field(
        default=None,
        metadata={
            "name": "RUNNABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_swc_internal_behavior_type: TdEventSwcInternalBehaviorTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variable_access_ref: Optional["TdEventSwcInternalBehavior.VariableAccessRef"] = field(
        default=None,
        metadata={
            "name": "VARIABLE-ACCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RunnableRef(Ref):
        dest: RunnableEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class VariableAccessRef(Ref):
        dest: VariableAccessSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventSwcInternalBehaviorReference:
    """
    This is used to reference timing description events related to the Software
    Component (SW-C) view which are specified in other timing views.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar component_iref: The context for the scope of this timing
        event.
    :ivar referenced_td_event_swc_ref: The referenced timing description
        event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventSwcInternalBehaviorReference.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventSwcInternalBehaviorReference.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventSwcInternalBehaviorReference.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_iref: ComponentInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "COMPONENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    referenced_td_event_swc_ref: Optional[
        "TdEventSwcInternalBehaviorReference.ReferencedTdEventSwcRef"
    ] = field(
        default=None,
        metadata={
            "name": "REFERENCED-TD-EVENT-SWC-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ReferencedTdEventSwcRef(Ref):
        dest: TdEventSwcSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventTrigger:
    """
    This is used to describe timing events related to triggers at VFB level.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar component_iref: The context for the scope of this timing
        event.
    :ivar is_external: This attribute is used to refer to external
        events that are related to hardware I/O, like physical sensors
        and actuators, at Virtual Functional Bus (VFB) level.
    :ivar port_prototype_blueprint_ref: The PortPrototypeBlueprint is
        the scope of the timing event.
    :ivar port_ref: The port scope of the timing event.
    :ivar td_event_trigger_type: The specific type of this timing event.
    :ivar trigger_ref: The trigger which is provided (released) or
        required (activate) in the given context.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-TRIGGER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventTrigger.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventTrigger.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventTrigger.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_iref: ComponentInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "COMPONENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_external: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-EXTERNAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_blueprint_ref: Optional["TdEventTrigger.PortPrototypeBlueprintRef"] = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-BLUEPRINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_ref: Optional["TdEventTrigger.PortRef"] = field(
        default=None,
        metadata={
            "name": "PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_trigger_type: TdEventTriggerTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-TRIGGER-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_ref: Optional["TdEventTrigger.TriggerRef"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PortPrototypeBlueprintRef(Ref):
        dest: PortPrototypeBlueprintSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerRef(Ref):
        dest: TriggerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventTtCanCycleStart:
    """
    This is used to describe the timing event related to a point in time where a
    communication cycle starts on a TTCAN cluster.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar ecu_instance_ref: The ECU context for a particular timing
        event. The link is optional, because the EcuInstance can not be
        defined for events of type TDEventCycleStart.
    :ivar cycle_repetition: The start of every &lt;cycleRepetition&gt;
        cycle is targeted by this event.
    :ivar tt_can_cluster_ref: The scope of this timing event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-TT-CAN-CYCLE-START"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventTtCanCycleStart.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventTtCanCycleStart.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventTtCanCycleStart.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["TdEventTtCanCycleStart.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cycle_repetition: Integer | None = field(
        default=None,
        metadata={
            "name": "CYCLE-REPETITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tt_can_cluster_ref: Optional["TdEventTtCanCycleStart.TtCanClusterRef"] = field(
        default=None,
        metadata={
            "name": "TT-CAN-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TtCanClusterRef(Ref):
        dest: TtcanClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventVariableDataPrototype:
    """
    This is used to describe timing events related to sender-receiver communication
    at VFB level.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar component_iref: The context for the scope of this timing
        event.
    :ivar is_external: This attribute is used to refer to external
        events that are related to hardware I/O, like physical sensors
        and actuators, at Virtual Functional Bus (VFB) level.
    :ivar port_prototype_blueprint_ref: The PortPrototypeBlueprint is
        the scope of the timing event.
    :ivar port_ref: The port scope of the timing event.
    :ivar data_element_ref: The referenced VariableDataPrototype
    :ivar td_event_variable_data_prototype_type: The specific type of
        this timing event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-VARIABLE-DATA-PROTOTYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventVariableDataPrototype.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventVariableDataPrototype.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventVariableDataPrototype.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_iref: ComponentInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "COMPONENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_external: Boolean | None = field(
        default=None,
        metadata={
            "name": "IS-EXTERNAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_blueprint_ref: Optional[
        "TdEventVariableDataPrototype.PortPrototypeBlueprintRef"
    ] = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-BLUEPRINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_ref: Optional["TdEventVariableDataPrototype.PortRef"] = field(
        default=None,
        metadata={
            "name": "PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["TdEventVariableDataPrototype.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    td_event_variable_data_prototype_type: TdEventVariableDataPrototypeTypeEnum | None = field(
        default=None,
        metadata={
            "name": "TD-EVENT-VARIABLE-DATA-PROTOTYPE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PortPrototypeBlueprintRef(Ref):
        dest: PortPrototypeBlueprintSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TdEventVfbReference:
    """
    This is used to reference timing description events related to the Virtual
    Functional Bus (VFB) view which are specified in other timing views.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        TimingExtension.timingDescription
    :ivar clock_reference_ref: Optional reference to a clock that holds
        the time base for an TD event.
    :ivar occurrence_expression: The occurrence expression for this
        event.
    :ivar component_iref: The context for the scope of this timing
        event.
    :ivar referenced_td_event_vfb_ref: The referenced timing description
        event.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TD-EVENT-VFB-REFERENCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TdEventVfbReference.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TdEventVfbReference.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    clock_reference_ref: Optional["TdEventVfbReference.ClockReferenceRef"] = field(
        default=None,
        metadata={
            "name": "CLOCK-REFERENCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    occurrence_expression: TdEventOccurrenceExpression | None = field(
        default=None,
        metadata={
            "name": "OCCURRENCE-EXPRESSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_iref: ComponentInCompositionInstanceRef | None = field(
        default=None,
        metadata={
            "name": "COMPONENT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    referenced_td_event_vfb_ref: Optional["TdEventVfbReference.ReferencedTdEventVfbRef"] = field(
        default=None,
        metadata={
            "name": "REFERENCED-TD-EVENT-VFB-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClockReferenceRef(Ref):
        dest: TimingClockSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ReferencedTdEventVfbRef(Ref):
        dest: TdEventVfbSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class TlsCryptoServiceMapping:
    """
    This meta-class has the ability to represent a crypto service mapping for the
    socket-based configuration of Transport Layer Security (TLS).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.cryptoServiceMapping
    :ivar key_exchange_refs: This reference identifies the shared(i.e.
        applicable for each of the aggregated cipher suites) crypto
        service primitive for the execution of key exchange during the
        handshake phase.
    :ivar tls_cipher_suites: This aggregation represents the collection
        of supported cipher suites.
    :ivar use_client_authentication_request: Defines if client
        authentication shall be applied for this TLS connection.
    :ivar use_security_extension_record_size_limit: Defines if the
        security extension for max_fragment_length shall be supported as
        defined in IETF RFC 8449, chapter 4.1.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TLS-CRYPTO-SERVICE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TlsCryptoServiceMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TlsCryptoServiceMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_exchange_refs: Optional["TlsCryptoServiceMapping.KeyExchangeRefs"] = field(
        default=None,
        metadata={
            "name": "KEY-EXCHANGE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tls_cipher_suites: Optional["TlsCryptoServiceMapping.TlsCipherSuites"] = field(
        default=None,
        metadata={
            "name": "TLS-CIPHER-SUITES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    use_client_authentication_request: Boolean | None = field(
        default=None,
        metadata={
            "name": "USE-CLIENT-AUTHENTICATION-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    use_security_extension_record_size_limit: Boolean | None = field(
        default=None,
        metadata={
            "name": "USE-SECURITY-EXTENSION-RECORD-SIZE-LIMIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class KeyExchangeRefs:
        key_exchange_ref: list["TlsCryptoServiceMapping.KeyExchangeRefs.KeyExchangeRef"] = field(
            default_factory=list,
            metadata={
                "name": "KEY-EXCHANGE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class KeyExchangeRef(Ref):
            dest: CryptoServicePrimitiveSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TlsCipherSuites:
        tls_crypto_cipher_suite: list[TlsCryptoCipherSuite] = field(
            default_factory=list,
            metadata={
                "name": "TLS-CRYPTO-CIPHER-SUITE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TlsSecureComProps:
    """
    Configuration of the Transport Layer Security protocol (TLS).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar key_exchange_refs: This reference identifies the shared (i.e.
        applicable for each of the aggregated cipher suites) crypto
        service primitive for the execution of key exchange during the
        handshake phase.
    :ivar tls_cipher_suites: Collection of  supported cipher suites that
        are used to negotiate the security settings for a network
        connection defined by the ServiceInstanceToMachineMapping.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TLS-SECURE-COM-PROPS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TlsSecureComProps.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TlsSecureComProps.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_exchange_refs: Optional["TlsSecureComProps.KeyExchangeRefs"] = field(
        default=None,
        metadata={
            "name": "KEY-EXCHANGE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tls_cipher_suites: Optional["TlsSecureComProps.TlsCipherSuites"] = field(
        default=None,
        metadata={
            "name": "TLS-CIPHER-SUITES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class KeyExchangeRefs:
        key_exchange_ref: list["TlsSecureComProps.KeyExchangeRefs.KeyExchangeRef"] = field(
            default_factory=list,
            metadata={
                "name": "KEY-EXCHANGE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class KeyExchangeRef(Ref):
            dest: CryptoServicePrimitiveSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TlsCipherSuites:
        tls_crypto_cipher_suite: list[TlsCryptoCipherSuite] = field(
            default_factory=list,
            metadata={
                "name": "TLS-CRYPTO-CIPHER-SUITE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TransformationTechnology:
    """
    A TransformationTechnology is a transformer inside a transformer chain.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar buffer_properties: Aggregation of the mandatory
        BufferProperties.
    :ivar has_internal_state: This attribute defines whether the
        Transformer has an internal state or not.
    :ivar needs_original_data: Specifies whether this transformer gets
        access to the SWC's original data.
    :ivar protocol: Specifies the protocol that is implemented by this
        transformer.
    :ivar transformation_descriptions: A transformer can be configured
        with transformer specific parameters which are represented by
        the TransformerDescription. The upper multiplicity of this role
        has been increased to * due to resolving an atpVariation
        stereotype. The previous value was 1.
    :ivar transformer_class: Specifies to which transformer class this
        transformer belongs.
    :ivar version: Version of the implemented protocol.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DataTransformationSet.transformationTechnology
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRANSFORMATION-TECHNOLOGY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TransformationTechnology.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TransformationTechnology.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    buffer_properties: BufferProperties | None = field(
        default=None,
        metadata={
            "name": "BUFFER-PROPERTIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_internal_state: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-INTERNAL-STATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    needs_original_data: Boolean | None = field(
        default=None,
        metadata={
            "name": "NEEDS-ORIGINAL-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformation_descriptions: Optional["TransformationTechnology.TransformationDescriptions"] = (
        field(
            default=None,
            metadata={
                "name": "TRANSFORMATION-DESCRIPTIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    transformer_class: TransformerClassEnum | None = field(
        default=None,
        metadata={
            "name": "TRANSFORMER-CLASS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: String | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TransformationDescriptions:
        end_to_end_transformation_description: list[EndToEndTransformationDescription] = field(
            default_factory=list,
            metadata={
                "name": "END-TO-END-TRANSFORMATION-DESCRIPTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_transformation_description: list[SomeipTransformationDescription] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-TRANSFORMATION-DESCRIPTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_transformation_description: list[UserDefinedTransformationDescription] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-TRANSFORMATION-DESCRIPTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TransmissionModeDeclaration:
    """AUTOSAR COM provides the possibility to define two different TRANSMISSION
    MODES (True and False) for each I-PDU.

    As TransmissionMode selector the signal content can be evaluated via
    transmissionModeCondition (implemented directly in the COM module)
    or mode conditions can be defined with the modeDrivenTrueCondition
    or modeDrivenFalseCondition (evaluated by BswM and invoking
    Com_SwitchIpduTxMode COM API). If modeDrivenTrueCondition and
    modeDrivenFalseCondition are defined they shall never evaluate to
    true both at the same time. The mixing of Transmission Mode Switch
    via API and signal value is not allowed.

    :ivar mode_driven_false_conditions: Defines the trigger for the
        Com_SwitchIpduTxMode Transmission Mode switch. Only if all
        defined modeDrivenFalseConditions evaluate to true (AND
        associated) the transmissionModeFalseTiming shall be activated.
        modeDrivenTrueCondition and modeDrivenFalseCondition shall never
        evaluate to true both at the same time.
    :ivar mode_driven_true_conditions: Defines the trigger for the
        Com_SwitchIpduTxMode Transmission Mode switch. Only if all
        defined modeDrivenTrueConditions evaluate to true (AND
        associated) the transmissionModeTrueTiming shall be activated.
        modeDrivenTrueCondition and modeDrivenFalseCondition shall never
        evaluate to true both at the same time.
    :ivar transmission_mode_conditions: The Transmission Mode Selector
        evaluates the conditions for a subset of signals and decides
        which transmission mode should be used. In case only one
        transmission mode is used there is no need for the
        "TransmissionModeCondition" and its sub-structure. In case the
        transmission mode shall be switched using the COM-API
        "Com_SwitchIpduTxMode" there is no need for the
        "TransmissionModeCondition" and its sub-structure.
    :ivar transmission_mode_false_timing: Timing Specification if the
        COM Transmission Mode is false. The Transmission Mode Selector
        is defined to be false, if all Conditions evaluate to false.
    :ivar transmission_mode_true_timing: Timing Specification if the COM
        Transmission Mode is true. The Transmission Mode Selector is
        defined to be true, if at least one Condition evaluates to true.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TRANSMISSION-MODE-DECLARATION"

    mode_driven_false_conditions: Optional[
        "TransmissionModeDeclaration.ModeDrivenFalseConditions"
    ] = field(
        default=None,
        metadata={
            "name": "MODE-DRIVEN-FALSE-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_driven_true_conditions: Optional[
        "TransmissionModeDeclaration.ModeDrivenTrueConditions"
    ] = field(
        default=None,
        metadata={
            "name": "MODE-DRIVEN-TRUE-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_mode_conditions: Optional[
        "TransmissionModeDeclaration.TransmissionModeConditions"
    ] = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-MODE-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_mode_false_timing: TransmissionModeTiming | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-MODE-FALSE-TIMING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_mode_true_timing: TransmissionModeTiming | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-MODE-TRUE-TIMING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ModeDrivenFalseConditions:
        mode_driven_transmission_mode_condition: list[ModeDrivenTransmissionModeCondition] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DRIVEN-TRANSMISSION-MODE-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModeDrivenTrueConditions:
        mode_driven_transmission_mode_condition: list[ModeDrivenTransmissionModeCondition] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DRIVEN-TRANSMISSION-MODE-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TransmissionModeConditions:
        transmission_mode_condition: list[TransmissionModeCondition] = field(
            default_factory=list,
            metadata={
                "name": "TRANSMISSION-MODE-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TtcanPhysicalChannel:
    """
    TTCAN bus specific physical channel attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar comm_connectors: This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar frame_triggerings: One frame triggering is defined for exactly
        one channel. Channels may have assigned an arbitrary number of
        frame triggerings. atpVariation: If signals/PDUs/frames are
        variable, the corresponding triggerings shall be variable, too.
    :ivar i_signal_triggerings: One ISignalTriggering is defined for
        exactly one channel. Channels may have assigned an arbitrary
        number of ISignaltriggerings. atpVariation: If
        signals/PDUs/frames are variable, the corresponding triggerings
        shall be variable, too.
    :ivar managed_physical_channel_refs: Reference between a channel
        with role managing channel and a channel with role managed
        channel.
    :ivar pdu_triggerings: One PduTriggering is defined for exactly one
        channel. Channels may have assigned an arbitrary number of I-Pdu
        triggerings. atpVariation: If signals/PDUs/frames are variable,
        the corresponding triggerings shall be variable, too.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CommunicationClusterContent.physicalChannel
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TTCAN-PHYSICAL-CHANNEL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TtcanPhysicalChannel.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TtcanPhysicalChannel.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_connectors: Optional["TtcanPhysicalChannel.CommConnectors"] = field(
        default=None,
        metadata={
            "name": "COMM-CONNECTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_triggerings: Optional["TtcanPhysicalChannel.FrameTriggerings"] = field(
        default=None,
        metadata={
            "name": "FRAME-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_triggerings: Optional["TtcanPhysicalChannel.ISignalTriggerings"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    managed_physical_channel_refs: Optional["TtcanPhysicalChannel.ManagedPhysicalChannelRefs"] = (
        field(
            default=None,
            metadata={
                "name": "MANAGED-PHYSICAL-CHANNEL-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    pdu_triggerings: Optional["TtcanPhysicalChannel.PduTriggerings"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommConnectors:
        communication_connector_ref_conditional: list[CommunicationConnectorRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "COMMUNICATION-CONNECTOR-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FrameTriggerings:
        can_frame_triggering: list[CanFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CAN-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_frame_triggering: list[EthernetFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_frame_triggering: list[FlexrayFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_frame_triggering: list[LinFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "LIN-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalTriggerings:
        i_signal_triggering: list[ISignalTriggering] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ManagedPhysicalChannelRefs:
        managed_physical_channel_ref: list[
            "TtcanPhysicalChannel.ManagedPhysicalChannelRefs.ManagedPhysicalChannelRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MANAGED-PHYSICAL-CHANNEL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ManagedPhysicalChannelRef(Ref):
            dest: PhysicalChannelSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PduTriggerings:
        pdu_triggering: list[PduTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedPhysicalChannel:
    """
    This element allows the modeling of arbitrary Physical Channels.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar comm_connectors: This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar frame_triggerings: One frame triggering is defined for exactly
        one channel. Channels may have assigned an arbitrary number of
        frame triggerings. atpVariation: If signals/PDUs/frames are
        variable, the corresponding triggerings shall be variable, too.
    :ivar i_signal_triggerings: One ISignalTriggering is defined for
        exactly one channel. Channels may have assigned an arbitrary
        number of ISignaltriggerings. atpVariation: If
        signals/PDUs/frames are variable, the corresponding triggerings
        shall be variable, too.
    :ivar managed_physical_channel_refs: Reference between a channel
        with role managing channel and a channel with role managed
        channel.
    :ivar pdu_triggerings: One PduTriggering is defined for exactly one
        channel. Channels may have assigned an arbitrary number of I-Pdu
        triggerings. atpVariation: If signals/PDUs/frames are variable,
        the corresponding triggerings shall be variable, too.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CommunicationClusterContent.physicalChannel
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-PHYSICAL-CHANNEL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UserDefinedPhysicalChannel.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedPhysicalChannel.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_connectors: Optional["UserDefinedPhysicalChannel.CommConnectors"] = field(
        default=None,
        metadata={
            "name": "COMM-CONNECTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_triggerings: Optional["UserDefinedPhysicalChannel.FrameTriggerings"] = field(
        default=None,
        metadata={
            "name": "FRAME-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_triggerings: Optional["UserDefinedPhysicalChannel.ISignalTriggerings"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    managed_physical_channel_refs: Optional[
        "UserDefinedPhysicalChannel.ManagedPhysicalChannelRefs"
    ] = field(
        default=None,
        metadata={
            "name": "MANAGED-PHYSICAL-CHANNEL-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_triggerings: Optional["UserDefinedPhysicalChannel.PduTriggerings"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommConnectors:
        communication_connector_ref_conditional: list[CommunicationConnectorRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "COMMUNICATION-CONNECTOR-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FrameTriggerings:
        can_frame_triggering: list[CanFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CAN-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_frame_triggering: list[EthernetFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_frame_triggering: list[FlexrayFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_frame_triggering: list[LinFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "LIN-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalTriggerings:
        i_signal_triggering: list[ISignalTriggering] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ManagedPhysicalChannelRefs:
        managed_physical_channel_ref: list[
            "UserDefinedPhysicalChannel.ManagedPhysicalChannelRefs.ManagedPhysicalChannelRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MANAGED-PHYSICAL-CHANNEL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ManagedPhysicalChannelRef(Ref):
            dest: PhysicalChannelSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PduTriggerings:
        pdu_triggering: list[PduTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedServiceInterfaceDeployment:
    """
    UserDefined configuration settings for a ServiceInterface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar event_deployments: Middleware transport layer specific
        configuration settings for an Event that is defined in the
        ServiceInterface.
    :ivar field_deployments: Middleware transport layer specific
        configuration settings for a Field that is defined in the
        ServiceInterface.
    :ivar method_deployments: Middleware transport layer specific
        configuration settings for a method that is defined in the
        ServiceInterface.
    :ivar service_interface_ref: Reference to a ServiceInterface that is
        deployed to a middleware transport layer.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-SERVICE-INTERFACE-DEPLOYMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UserDefinedServiceInterfaceDeployment.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedServiceInterfaceDeployment.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_deployments: Optional["UserDefinedServiceInterfaceDeployment.EventDeployments"] = field(
        default=None,
        metadata={
            "name": "EVENT-DEPLOYMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    field_deployments: Optional["UserDefinedServiceInterfaceDeployment.FieldDeployments"] = field(
        default=None,
        metadata={
            "name": "FIELD-DEPLOYMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_deployments: Optional["UserDefinedServiceInterfaceDeployment.MethodDeployments"] = field(
        default=None,
        metadata={
            "name": "METHOD-DEPLOYMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_interface_ref: Optional["UserDefinedServiceInterfaceDeployment.ServiceInterfaceRef"] = (
        field(
            default=None,
            metadata={
                "name": "SERVICE-INTERFACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventDeployments:
        dds_event_deployment: list[DdsEventDeployment] = field(
            default_factory=list,
            metadata={
                "name": "DDS-EVENT-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_event_deployment: list[SomeipEventDeployment] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-EVENT-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_event_deployment: list[UserDefinedEventDeployment] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-EVENT-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FieldDeployments:
        dds_field_deployment: list[DdsFieldDeployment] = field(
            default_factory=list,
            metadata={
                "name": "DDS-FIELD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_field_deployment: list[SomeipFieldDeployment] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-FIELD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_field_deployment: list[UserDefinedFieldDeployment] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-FIELD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MethodDeployments:
        someip_method_deployment: list[SomeipMethodDeployment] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-METHOD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_method_deployment: list[UserDefinedMethodDeployment] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-METHOD-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInterfaceRef(Ref):
        dest: ServiceInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class VehicleRolloutStep:
    """
    This meta-class represents the ability to define a rollout-condition for a
    vehicle update campaign.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar safety_conditions: This attribute represents a list of textual
        safety conditions (e.g.: close the driver window) that need to
        be fulfilled before the rollout step can proceed.
    :ivar ucm_processings: This aggregation collects the
        UcmProcessingSteps that make up the rollout step.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VEHICLE-ROLLOUT-STEP"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["VehicleRolloutStep.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["VehicleRolloutStep.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    safety_conditions: Optional["VehicleRolloutStep.SafetyConditions"] = field(
        default=None,
        metadata={
            "name": "SAFETY-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ucm_processings: Optional["VehicleRolloutStep.UcmProcessings"] = field(
        default=None,
        metadata={
            "name": "UCM-PROCESSINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SafetyConditions:
        safety_condition: list[String] = field(
            default_factory=list,
            metadata={
                "name": "SAFETY-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class UcmProcessings:
        ucm_step: list[UcmStep] = field(
            default_factory=list,
            metadata={
                "name": "UCM-STEP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ViewMapSet:
    """
    Collection of ViewMaps that are used to establish relationships between
    different AUTOSAR artifacts.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar view_maps: ViewMaps that are collected by the ViewMapSet.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VIEW-MAP-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ViewMapSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ViewMapSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    view_maps: Optional["ViewMapSet.ViewMaps"] = field(
        default=None,
        metadata={
            "name": "VIEW-MAPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ViewMaps:
        view_map: list[ViewMap] = field(
            default_factory=list,
            metadata={
                "name": "VIEW-MAP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class VlanMembership:
    """Static logical channel or VLAN binding to a switch-port.

    The reference to an EthernetPhysicalChannel without a VLAN defined
    represents the handling of untagged frames.

    :ivar default_priority: Standard output-priority outgoing Frames
        will be tagged with. Defines the priority that received frames
        are assigned together with the VLAN Id (defaultVlan). The values
        from 0 (best effort) to 7 (highest) are allowed. In case
        modifyVlan and an already tagged received frame, the actual
        priority of the received frame is not modified.
    :ivar dhcp_address_assignment: Specifies the IP Address which will
        be assigned to a DHCP Client at this SwitchPort. If no
        dhcpAddressAssignment is provided all DHCP-Discover messages
        received at this Port will be discarded by the DHCP Server.
    :ivar send_activity: Attribute denotes whether a VLAN tagged
        ethernet frame will be # sent with its VLAN tag (sentTagged) #
        sent without a VLAN tag (sentUntagged) # will be dropped at this
        port (notSent or VLAN  not member of this list)
    :ivar vlan_ref: References a channel that represents a VLAN or an
        untagged channel.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VLAN-MEMBERSHIP"

    default_priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dhcp_address_assignment: DhcpServerConfiguration | None = field(
        default=None,
        metadata={
            "name": "DHCP-ADDRESS-ASSIGNMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    send_activity: EthernetSwitchVlanEgressTaggingEnum | None = field(
        default=None,
        metadata={
            "name": "SEND-ACTIVITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vlan_ref: Optional["VlanMembership.VlanRef"] = field(
        default=None,
        metadata={
            "name": "VLAN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class VlanRef(Ref):
        dest: EthernetPhysicalChannelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswCompositionTiming:
    """A model element used to define timing descriptions and constraints for a set
    of BswImplementations representing a BSW composition.

    A constraint defined at this level holds true for all referenced
    BswImplementations. Note, that multiple implementations of the same
    basic software module could be involved. TimingDescriptions
    aggregated by BswCompositionTiming are restricted to event chains
    referring to events which are derived from the class
    TDEventBswInternalBehavior and TDEventBsw.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar timing_clocks: A list of abstract model Clocks.
    :ivar timing_clock_sync_accuracys: A list of accuracies - which may
        be used to specify synchronizations from one model clock to
        another model clock.
    :ivar timing_conditions: The timing condition specifies a specific
        condition.
    :ivar timing_descriptions: The timing descriptions that belong to a
        specific timing specification. In order to support different
        timing description variants within a timing specification, the
        aggregation is marked with the stereotype "atpVariation".
    :ivar timing_guarantees: The timing constraints that belong to a
        specific timing specification in the role of a timing guarantee.
        In order to support different timing constraint variants within
        a timing specification, the aggregation is marked with the
        stereotype "atpVariation".
    :ivar timing_requirements: The timing constraints that belong to a
        specific timing specification in the role of a timing
        requirement. In order to support different timing constraint
        variants within a timing specification, the aggregation is
        marked with the stereotype "atpVariation".
    :ivar timing_resource: The timing resource contains all instance
        references referred from within a timing condition formula of a
        timing view.
    :ivar implementation_refs: This defines the scope of a
        BswCompositionTiming. All corresponding timing descriptions and
        constraints shall be defined within this scope.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-COMPOSITION-TIMING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswCompositionTiming.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswCompositionTiming.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clocks: Optional["BswCompositionTiming.TimingClocks"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clock_sync_accuracys: Optional["BswCompositionTiming.TimingClockSyncAccuracys"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCK-SYNC-ACCURACYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_conditions: Optional["BswCompositionTiming.TimingConditions"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_descriptions: Optional["BswCompositionTiming.TimingDescriptions"] = field(
        default=None,
        metadata={
            "name": "TIMING-DESCRIPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_guarantees: Optional["BswCompositionTiming.TimingGuarantees"] = field(
        default=None,
        metadata={
            "name": "TIMING-GUARANTEES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_requirements: Optional["BswCompositionTiming.TimingRequirements"] = field(
        default=None,
        metadata={
            "name": "TIMING-REQUIREMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_resource: TimingExtensionResource | None = field(
        default=None,
        metadata={
            "name": "TIMING-RESOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_refs: Optional["BswCompositionTiming.ImplementationRefs"] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClocks:
        tdlet_zone_clock: list[TdletZoneClock] = field(
            default_factory=list,
            metadata={
                "name": "TDLET-ZONE-CLOCK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClockSyncAccuracys:
        timing_clock_sync_accuracy: list[TimingClockSyncAccuracy] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CLOCK-SYNC-ACCURACY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingConditions:
        timing_condition: list[TimingCondition] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingDescriptions:
        td_event_bsw_internal_behavior: list[TdEventBswInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_mode_declaration: list[TdEventBswModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_module: list[TdEventBswModule] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_complex: list[TdEventComplex] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-COMPLEX",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_fr_cluster_cycle_start: list[TdEventFrClusterCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FR-CLUSTER-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame: list[TdEventFrame] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame_ethernet: list[TdEventFrameEthernet] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME-ETHERNET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_pdu: list[TdEventIPdu] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_signal: list[TdEventISignal] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_mode_declaration: list[TdEventModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_operation: list[TdEventOperation] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-OPERATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_discovery: list[TdEventServiceInstanceDiscovery] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-DISCOVERY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_event: list[TdEventServiceInstanceEvent] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_field: list[TdEventServiceInstanceField] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-FIELD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_method: list[TdEventServiceInstanceMethod] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-METHOD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_sllet_port: list[TdEventSlletPort] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SLLET-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior: list[TdEventSwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior_reference: list[TdEventSwcInternalBehaviorReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_trigger: list[TdEventTrigger] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_tt_can_cycle_start: list[TdEventTtCanCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TT-CAN-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_variable_data_prototype: list[TdEventVariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_vfb_reference: list[TdEventVfbReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VFB-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        timing_description_event_chain: list[TimingDescriptionEventChain] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-DESCRIPTION-EVENT-CHAIN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingGuarantees:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingRequirements:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationRefs:
        implementation_ref: list["BswCompositionTiming.ImplementationRefs.ImplementationRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "IMPLEMENTATION-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class ImplementationRef(Ref):
            dest: BswImplementationSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class BswModuleDependency:
    """
    This class collects the dependencies of a BSW module or cluster on a certain
    other BSW module.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar target_module_id: AUTOSAR identifier of the target module of
        which the dependencies are defined. This information is
        optional, because the target module may also be identified by
        targetModuleRef.
    :ivar target_module_refs: Reference to the target module. It is an
        &lt;&lt;atpUriDef&gt;&gt; because the reference shall be used to
        identify the target module without actually needing the
        description of that target module. This property was modified
        due to atpVariation (DirectedAssociationPattern).
    :ivar required_entrys: Indicates an entry into another modules which
        is required by this module. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar expected_callbacks: Indicates a callback expected to be called
        from another module and implemented by this module. This
        property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar service_items: A single item (example: Nv block) for which the
        quality of a service is defined. The aggregation is marked as
        &lt;&lt;atpSplitable&gt;&gt; to allow for extension during the
        ECU configuration process. This association is deprecated since
        R4.0.3, since ServiceNeeds shall be associated with the new
        element BswServiceDependency within the BswInternalBehavior.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswModuleDescription.bswModuleDependency
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-MODULE-DEPENDENCY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswModuleDependency.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswModuleDependency.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_module_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "TARGET-MODULE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    target_module_refs: Optional["BswModuleDependency.TargetModuleRefs"] = field(
        default=None,
        metadata={
            "name": "TARGET-MODULE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_entrys: Optional["BswModuleDependency.RequiredEntrys"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-ENTRYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    expected_callbacks: Optional["BswModuleDependency.ExpectedCallbacks"] = field(
        default=None,
        metadata={
            "name": "EXPECTED-CALLBACKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_items: Optional["BswModuleDependency.ServiceItems"] = field(
        default=None,
        metadata={
            "name": "SERVICE-ITEMS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TargetModuleRefs:
        bsw_module_description_ref_conditional: list[BswModuleDescriptionRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-DESCRIPTION-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredEntrys:
        bsw_module_entry_ref_conditional: list[BswModuleEntryRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-ENTRY-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExpectedCallbacks:
        bsw_module_entry_ref_conditional: list[BswModuleEntryRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-ENTRY-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceItems:
        bsw_mgr_needs: list[BswMgrNeeds] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MGR-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_mgr_user_needs: list[ComMgrUserNeeds] = field(
            default_factory=list,
            metadata={
                "name": "COM-MGR-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_certificate_key_slot_needs: list[CryptoCertificateKeySlotNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-CERTIFICATE-KEY-SLOT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_key_management_needs: list[CryptoKeyManagementNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-KEY-MANAGEMENT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_service_job_needs: list[CryptoServiceJobNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-SERVICE-JOB-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_service_needs: list[CryptoServiceNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_clear_condition_needs: list[DiagnosticClearConditionNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CLEAR-CONDITION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_communication_manager_needs: list[DiagnosticCommunicationManagerNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-COMMUNICATION-MANAGER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_component_needs: list[DiagnosticComponentNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-COMPONENT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_control_needs: list[DiagnosticControlNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CONTROL-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_enable_condition_needs: list[DiagnosticEnableConditionNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ENABLE-CONDITION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_info_needs: list[DiagnosticEventInfoNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EVENT-INFO-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_manager_needs: list[DiagnosticEventManagerNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EVENT-MANAGER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_needs: list[DiagnosticEventNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EVENT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_generic_uds_needs: list[DiagnosticGenericUdsNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-GENERIC-UDS-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_indicator_needs: list[DiagnosticIndicatorNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-INDICATOR-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_io_control_needs: list[DiagnosticIoControlNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-IO-CONTROL-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_operation_cycle_needs: list[DiagnosticOperationCycleNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-OPERATION-CYCLE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_file_transfer_needs: list[DiagnosticRequestFileTransferNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-FILE-TRANSFER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_response_on_event_needs: list[DiagnosticResponseOnEventNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-RESPONSE-ON-EVENT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_routine_needs: list[DiagnosticRoutineNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ROUTINE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_storage_condition_needs: list[DiagnosticStorageConditionNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-STORAGE-CONDITION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_upload_download_needs: list[DiagnosticUploadDownloadNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-UPLOAD-DOWNLOAD-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_value_needs: list[DiagnosticValueNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-VALUE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostics_communication_security_needs: list[DiagnosticsCommunicationSecurityNeeds] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTICS-COMMUNICATION-SECURITY-NEEDS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        dlt_user_needs: list[DltUserNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DLT-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_activation_line_needs: list[DoIpActivationLineNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-ACTIVATION-LINE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_gid_needs: list[DoIpGidNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-GID-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_gid_synchronization_needs: list[DoIpGidSynchronizationNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-GID-SYNCHRONIZATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_power_mode_status_needs: list[DoIpPowerModeStatusNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-POWER-MODE-STATUS-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_routing_activation_authentication_needs: list[
            DoIpRoutingActivationAuthenticationNeeds
        ] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-ROUTING-ACTIVATION-AUTHENTICATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_routing_activation_confirmation_needs: list[
            DoIpRoutingActivationConfirmationNeeds
        ] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-ROUTING-ACTIVATION-CONFIRMATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dtc_status_change_notification_needs: list[DtcStatusChangeNotificationNeeds] = field(
            default_factory=list,
            metadata={
                "name": "DTC-STATUS-CHANGE-NOTIFICATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecu_state_mgr_user_needs: list[EcuStateMgrUserNeeds] = field(
            default_factory=list,
            metadata={
                "name": "ECU-STATE-MGR-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        error_tracer_needs: list[ErrorTracerNeeds] = field(
            default_factory=list,
            metadata={
                "name": "ERROR-TRACER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        function_inhibition_availability_needs: list[FunctionInhibitionAvailabilityNeeds] = field(
            default_factory=list,
            metadata={
                "name": "FUNCTION-INHIBITION-AVAILABILITY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        function_inhibition_needs: list[FunctionInhibitionNeeds] = field(
            default_factory=list,
            metadata={
                "name": "FUNCTION-INHIBITION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        further_action_byte_needs: list[FurtherActionByteNeeds] = field(
            default_factory=list,
            metadata={
                "name": "FURTHER-ACTION-BYTE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        global_supervision_needs: list[GlobalSupervisionNeeds] = field(
            default_factory=list,
            metadata={
                "name": "GLOBAL-SUPERVISION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        hardware_test_needs: list[HardwareTestNeeds] = field(
            default_factory=list,
            metadata={
                "name": "HARDWARE-TEST-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ids_mgr_custom_timestamp_needs: list[IdsMgrCustomTimestampNeeds] = field(
            default_factory=list,
            metadata={
                "name": "IDS-MGR-CUSTOM-TIMESTAMP-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ids_mgr_needs: list[IdsMgrNeeds] = field(
            default_factory=list,
            metadata={
                "name": "IDS-MGR-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        indicator_status_needs: list[IndicatorStatusNeeds] = field(
            default_factory=list,
            metadata={
                "name": "INDICATOR-STATUS-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_dcm_dm_19_support: list[J1939DcmDm19Support] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-DCM-DM-19-SUPPORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_rm_incoming_request_service_needs: list[J1939RmIncomingRequestServiceNeeds] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-RM-INCOMING-REQUEST-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_rm_outgoing_request_service_needs: list[J1939RmOutgoingRequestServiceNeeds] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-RM-OUTGOING-REQUEST-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nv_block_needs: list[NvBlockNeeds] = field(
            default_factory=list,
            metadata={
                "name": "NV-BLOCK-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_control_service_needs: list[ObdControlServiceNeeds] = field(
            default_factory=list,
            metadata={
                "name": "OBD-CONTROL-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_info_service_needs: list[ObdInfoServiceNeeds] = field(
            default_factory=list,
            metadata={
                "name": "OBD-INFO-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_monitor_service_needs: list[ObdMonitorServiceNeeds] = field(
            default_factory=list,
            metadata={
                "name": "OBD-MONITOR-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_pid_service_needs: list[ObdPidServiceNeeds] = field(
            default_factory=list,
            metadata={
                "name": "OBD-PID-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_ratio_denominator_needs: list[ObdRatioDenominatorNeeds] = field(
            default_factory=list,
            metadata={
                "name": "OBD-RATIO-DENOMINATOR-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_ratio_service_needs: list[ObdRatioServiceNeeds] = field(
            default_factory=list,
            metadata={
                "name": "OBD-RATIO-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        secure_on_board_communication_needs: list[SecureOnBoardCommunicationNeeds] = field(
            default_factory=list,
            metadata={
                "name": "SECURE-ON-BOARD-COMMUNICATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        supervised_entity_checkpoint_needs: list[SupervisedEntityCheckpointNeeds] = field(
            default_factory=list,
            metadata={
                "name": "SUPERVISED-ENTITY-CHECKPOINT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        supervised_entity_needs: list[SupervisedEntityNeeds] = field(
            default_factory=list,
            metadata={
                "name": "SUPERVISED-ENTITY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sync_time_base_mgr_user_needs: list[SyncTimeBaseMgrUserNeeds] = field(
            default_factory=list,
            metadata={
                "name": "SYNC-TIME-BASE-MGR-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        v_2_x_data_manager_needs: list[V2XDataManagerNeeds] = field(
            default_factory=list,
            metadata={
                "name": "V-2-X-DATA-MANAGER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        v_2_x_fac_user_needs: list[V2XFacUserNeeds] = field(
            default_factory=list,
            metadata={
                "name": "V-2-X-FAC-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        v_2_x_m_user_needs: list[V2XMUserNeeds] = field(
            default_factory=list,
            metadata={
                "name": "V-2-X-M-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        vendor_specific_service_needs: list[VendorSpecificServiceNeeds] = field(
            default_factory=list,
            metadata={
                "name": "VENDOR-SPECIFIC-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        warning_indicator_requested_bit_needs: list[WarningIndicatorRequestedBitNeeds] = field(
            default_factory=list,
            metadata={
                "name": "WARNING-INDICATOR-REQUESTED-BIT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BswModuleTiming:
    """A model element used to define timing descriptions and constraints for the
    BswInternalBehavior of one BSW Module.

    Thereby, for each BswInternalBehavior a separate timing can be
    specified. A constraint defined at this level holds true for all
    Implementations of that BswInternalBehavior. TimingDescriptions
    aggregated by BswModuleTiming are restricted to event chains
    referring to events which are derived from the class
    TDEventBswInternalBehavior.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar timing_clocks: A list of abstract model Clocks.
    :ivar timing_clock_sync_accuracys: A list of accuracies - which may
        be used to specify synchronizations from one model clock to
        another model clock.
    :ivar timing_conditions: The timing condition specifies a specific
        condition.
    :ivar timing_descriptions: The timing descriptions that belong to a
        specific timing specification. In order to support different
        timing description variants within a timing specification, the
        aggregation is marked with the stereotype "atpVariation".
    :ivar timing_guarantees: The timing constraints that belong to a
        specific timing specification in the role of a timing guarantee.
        In order to support different timing constraint variants within
        a timing specification, the aggregation is marked with the
        stereotype "atpVariation".
    :ivar timing_requirements: The timing constraints that belong to a
        specific timing specification in the role of a timing
        requirement. In order to support different timing constraint
        variants within a timing specification, the aggregation is
        marked with the stereotype "atpVariation".
    :ivar timing_resource: The timing resource contains all instance
        references referred from within a timing condition formula of a
        timing view.
    :ivar behavior_ref: This defines the scope of a BswModuleTiming. All
        corresponding timing descriptions and constraints shall be
        defined within this scope.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-MODULE-TIMING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswModuleTiming.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswModuleTiming.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clocks: Optional["BswModuleTiming.TimingClocks"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clock_sync_accuracys: Optional["BswModuleTiming.TimingClockSyncAccuracys"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCK-SYNC-ACCURACYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_conditions: Optional["BswModuleTiming.TimingConditions"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_descriptions: Optional["BswModuleTiming.TimingDescriptions"] = field(
        default=None,
        metadata={
            "name": "TIMING-DESCRIPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_guarantees: Optional["BswModuleTiming.TimingGuarantees"] = field(
        default=None,
        metadata={
            "name": "TIMING-GUARANTEES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_requirements: Optional["BswModuleTiming.TimingRequirements"] = field(
        default=None,
        metadata={
            "name": "TIMING-REQUIREMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_resource: TimingExtensionResource | None = field(
        default=None,
        metadata={
            "name": "TIMING-RESOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    behavior_ref: Optional["BswModuleTiming.BehaviorRef"] = field(
        default=None,
        metadata={
            "name": "BEHAVIOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClocks:
        tdlet_zone_clock: list[TdletZoneClock] = field(
            default_factory=list,
            metadata={
                "name": "TDLET-ZONE-CLOCK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClockSyncAccuracys:
        timing_clock_sync_accuracy: list[TimingClockSyncAccuracy] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CLOCK-SYNC-ACCURACY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingConditions:
        timing_condition: list[TimingCondition] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingDescriptions:
        td_event_bsw_internal_behavior: list[TdEventBswInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_mode_declaration: list[TdEventBswModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_module: list[TdEventBswModule] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_complex: list[TdEventComplex] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-COMPLEX",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_fr_cluster_cycle_start: list[TdEventFrClusterCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FR-CLUSTER-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame: list[TdEventFrame] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame_ethernet: list[TdEventFrameEthernet] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME-ETHERNET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_pdu: list[TdEventIPdu] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_signal: list[TdEventISignal] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_mode_declaration: list[TdEventModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_operation: list[TdEventOperation] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-OPERATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_discovery: list[TdEventServiceInstanceDiscovery] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-DISCOVERY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_event: list[TdEventServiceInstanceEvent] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_field: list[TdEventServiceInstanceField] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-FIELD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_method: list[TdEventServiceInstanceMethod] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-METHOD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_sllet_port: list[TdEventSlletPort] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SLLET-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior: list[TdEventSwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior_reference: list[TdEventSwcInternalBehaviorReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_trigger: list[TdEventTrigger] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_tt_can_cycle_start: list[TdEventTtCanCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TT-CAN-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_variable_data_prototype: list[TdEventVariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_vfb_reference: list[TdEventVfbReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VFB-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        timing_description_event_chain: list[TimingDescriptionEventChain] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-DESCRIPTION-EVENT-CHAIN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingGuarantees:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingRequirements:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BehaviorRef(Ref):
        dest: BswInternalBehaviorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class BswServiceDependency:
    """Specialization of ServiceDependency in the context of an
    BswInternalBehavior.

    It allows to associate BswModuleEntries and data defined for a BSW
    module or cluster to a given ServiceNeeds element.

    :ivar assigned_data_types: This is the role of the assignment data
        type in the given context. The upper multiplicity of this role
        has been increased to * due to resolving an atpVariation
        stereotype. The previous value was 1.
    :ivar diagnostic_relevance: If this attribute indicates a relevance
        for diagnostics then the integrator has a much easier time
        identifying the candidates for the configuration of the
        diagnostic stack. Example: identification of mode conditions
        (e.g. communication between application and BswM) relevant for
        the Dcm.
    :ivar symbolic_name_props: This attribute can be taken to contribute
        to the creation of symbolic name values.
    :ivar ident: This adds the ability to become referrable to
        BswServiceDependency.
    :ivar assigned_datas: Defines the role of an associated data object
        (owned by this module or cluster) in the context of the
        ServiceNeeds element.
    :ivar assigned_entry_roles: Defines the role of an associated
        BswModuleEntry in the context of the ServiceNeeds element.
    :ivar service_needs: The associated ServiceNeeds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        BswInternalBehavior.serviceDependency
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-SERVICE-DEPENDENCY"

    assigned_data_types: Optional["BswServiceDependency.AssignedDataTypes"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-DATA-TYPES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_relevance: ServiceDiagnosticRelevanceEnum | None = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-RELEVANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbolic_name_props: SymbolicNameProps | None = field(
        default=None,
        metadata={
            "name": "SYMBOLIC-NAME-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ident: BswServiceDependencyIdent | None = field(
        default=None,
        metadata={
            "name": "IDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_datas: Optional["BswServiceDependency.AssignedDatas"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-DATAS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_entry_roles: Optional["BswServiceDependency.AssignedEntryRoles"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-ENTRY-ROLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_needs: Optional["BswServiceDependency.ServiceNeeds"] = field(
        default=None,
        metadata={
            "name": "SERVICE-NEEDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class AssignedDataTypes:
        role_based_data_type_assignment: list[RoleBasedDataTypeAssignment] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-DATA-TYPE-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AssignedDatas:
        role_based_data_assignment: list[RoleBasedDataAssignment] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-DATA-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AssignedEntryRoles:
        role_based_bsw_module_entry_assignment: list[RoleBasedBswModuleEntryAssignment] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-BSW-MODULE-ENTRY-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceNeeds:
        bsw_mgr_needs: BswMgrNeeds | None = field(
            default=None,
            metadata={
                "name": "BSW-MGR-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_mgr_user_needs: ComMgrUserNeeds | None = field(
            default=None,
            metadata={
                "name": "COM-MGR-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_certificate_key_slot_needs: CryptoCertificateKeySlotNeeds | None = field(
            default=None,
            metadata={
                "name": "CRYPTO-CERTIFICATE-KEY-SLOT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_key_management_needs: CryptoKeyManagementNeeds | None = field(
            default=None,
            metadata={
                "name": "CRYPTO-KEY-MANAGEMENT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_service_job_needs: CryptoServiceJobNeeds | None = field(
            default=None,
            metadata={
                "name": "CRYPTO-SERVICE-JOB-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_service_needs: CryptoServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "CRYPTO-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_clear_condition_needs: DiagnosticClearConditionNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-CLEAR-CONDITION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_communication_manager_needs: DiagnosticCommunicationManagerNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-COMMUNICATION-MANAGER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_component_needs: DiagnosticComponentNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-COMPONENT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_control_needs: DiagnosticControlNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-CONTROL-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_enable_condition_needs: DiagnosticEnableConditionNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-ENABLE-CONDITION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_info_needs: DiagnosticEventInfoNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-EVENT-INFO-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_manager_needs: DiagnosticEventManagerNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-EVENT-MANAGER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_needs: DiagnosticEventNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-EVENT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_generic_uds_needs: DiagnosticGenericUdsNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-GENERIC-UDS-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_indicator_needs: DiagnosticIndicatorNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-INDICATOR-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_io_control_needs: DiagnosticIoControlNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-IO-CONTROL-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_operation_cycle_needs: DiagnosticOperationCycleNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-OPERATION-CYCLE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_file_transfer_needs: DiagnosticRequestFileTransferNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-FILE-TRANSFER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_response_on_event_needs: DiagnosticResponseOnEventNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-RESPONSE-ON-EVENT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_routine_needs: DiagnosticRoutineNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-ROUTINE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_storage_condition_needs: DiagnosticStorageConditionNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-STORAGE-CONDITION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_upload_download_needs: DiagnosticUploadDownloadNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-UPLOAD-DOWNLOAD-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_value_needs: DiagnosticValueNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-VALUE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostics_communication_security_needs: DiagnosticsCommunicationSecurityNeeds | None = (
            field(
                default=None,
                metadata={
                    "name": "DIAGNOSTICS-COMMUNICATION-SECURITY-NEEDS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        dlt_user_needs: DltUserNeeds | None = field(
            default=None,
            metadata={
                "name": "DLT-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_activation_line_needs: DoIpActivationLineNeeds | None = field(
            default=None,
            metadata={
                "name": "DO-IP-ACTIVATION-LINE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_gid_needs: DoIpGidNeeds | None = field(
            default=None,
            metadata={
                "name": "DO-IP-GID-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_gid_synchronization_needs: DoIpGidSynchronizationNeeds | None = field(
            default=None,
            metadata={
                "name": "DO-IP-GID-SYNCHRONIZATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_power_mode_status_needs: DoIpPowerModeStatusNeeds | None = field(
            default=None,
            metadata={
                "name": "DO-IP-POWER-MODE-STATUS-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_routing_activation_authentication_needs: (
            DoIpRoutingActivationAuthenticationNeeds | None
        ) = field(
            default=None,
            metadata={
                "name": "DO-IP-ROUTING-ACTIVATION-AUTHENTICATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_routing_activation_confirmation_needs: (
            DoIpRoutingActivationConfirmationNeeds | None
        ) = field(
            default=None,
            metadata={
                "name": "DO-IP-ROUTING-ACTIVATION-CONFIRMATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dtc_status_change_notification_needs: DtcStatusChangeNotificationNeeds | None = field(
            default=None,
            metadata={
                "name": "DTC-STATUS-CHANGE-NOTIFICATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecu_state_mgr_user_needs: EcuStateMgrUserNeeds | None = field(
            default=None,
            metadata={
                "name": "ECU-STATE-MGR-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        error_tracer_needs: ErrorTracerNeeds | None = field(
            default=None,
            metadata={
                "name": "ERROR-TRACER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        function_inhibition_availability_needs: FunctionInhibitionAvailabilityNeeds | None = field(
            default=None,
            metadata={
                "name": "FUNCTION-INHIBITION-AVAILABILITY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        function_inhibition_needs: FunctionInhibitionNeeds | None = field(
            default=None,
            metadata={
                "name": "FUNCTION-INHIBITION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        further_action_byte_needs: FurtherActionByteNeeds | None = field(
            default=None,
            metadata={
                "name": "FURTHER-ACTION-BYTE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        global_supervision_needs: GlobalSupervisionNeeds | None = field(
            default=None,
            metadata={
                "name": "GLOBAL-SUPERVISION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        hardware_test_needs: HardwareTestNeeds | None = field(
            default=None,
            metadata={
                "name": "HARDWARE-TEST-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ids_mgr_custom_timestamp_needs: IdsMgrCustomTimestampNeeds | None = field(
            default=None,
            metadata={
                "name": "IDS-MGR-CUSTOM-TIMESTAMP-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ids_mgr_needs: IdsMgrNeeds | None = field(
            default=None,
            metadata={
                "name": "IDS-MGR-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        indicator_status_needs: IndicatorStatusNeeds | None = field(
            default=None,
            metadata={
                "name": "INDICATOR-STATUS-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_dcm_dm_19_support: J1939DcmDm19Support | None = field(
            default=None,
            metadata={
                "name": "J-1939-DCM-DM-19-SUPPORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_rm_incoming_request_service_needs: J1939RmIncomingRequestServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "J-1939-RM-INCOMING-REQUEST-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_rm_outgoing_request_service_needs: J1939RmOutgoingRequestServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "J-1939-RM-OUTGOING-REQUEST-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nv_block_needs: NvBlockNeeds | None = field(
            default=None,
            metadata={
                "name": "NV-BLOCK-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_control_service_needs: ObdControlServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "OBD-CONTROL-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_info_service_needs: ObdInfoServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "OBD-INFO-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_monitor_service_needs: ObdMonitorServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "OBD-MONITOR-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_pid_service_needs: ObdPidServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "OBD-PID-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_ratio_denominator_needs: ObdRatioDenominatorNeeds | None = field(
            default=None,
            metadata={
                "name": "OBD-RATIO-DENOMINATOR-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_ratio_service_needs: ObdRatioServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "OBD-RATIO-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        secure_on_board_communication_needs: SecureOnBoardCommunicationNeeds | None = field(
            default=None,
            metadata={
                "name": "SECURE-ON-BOARD-COMMUNICATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        supervised_entity_checkpoint_needs: SupervisedEntityCheckpointNeeds | None = field(
            default=None,
            metadata={
                "name": "SUPERVISED-ENTITY-CHECKPOINT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        supervised_entity_needs: SupervisedEntityNeeds | None = field(
            default=None,
            metadata={
                "name": "SUPERVISED-ENTITY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sync_time_base_mgr_user_needs: SyncTimeBaseMgrUserNeeds | None = field(
            default=None,
            metadata={
                "name": "SYNC-TIME-BASE-MGR-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        v_2_x_data_manager_needs: V2XDataManagerNeeds | None = field(
            default=None,
            metadata={
                "name": "V-2-X-DATA-MANAGER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        v_2_x_fac_user_needs: V2XFacUserNeeds | None = field(
            default=None,
            metadata={
                "name": "V-2-X-FAC-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        v_2_x_m_user_needs: V2XMUserNeeds | None = field(
            default=None,
            metadata={
                "name": "V-2-X-M-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        vendor_specific_service_needs: VendorSpecificServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "VENDOR-SPECIFIC-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        warning_indicator_requested_bit_needs: WarningIndicatorRequestedBitNeeds | None = field(
            default=None,
            metadata={
                "name": "WARNING-INDICATOR-REQUESTED-BIT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ClientServerInterface:
    """
    A client/server interface declares a number of operations that can be invoked
    on a server by a client.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar operations: ClientServerOperation(s) of this
        ClientServerInterface.
    :ivar possible_errors: Application errors that are defined as part
        of this interface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ClientServerInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ClientServerInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ClientServerInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["ClientServerInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operations: Optional["ClientServerInterface.Operations"] = field(
        default=None,
        metadata={
            "name": "OPERATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    possible_errors: Optional["ClientServerInterface.PossibleErrors"] = field(
        default=None,
        metadata={
            "name": "POSSIBLE-ERRORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Operations:
        client_server_operation: list[ClientServerOperation] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-OPERATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PossibleErrors:
        application_error: list[ApplicationError] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-ERROR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ClientServerOperationMapping:
    """
    Defines the mapping of two particular ClientServerOperations in context of two
    different ClientServerInterfaces.

    :ivar argument_mappings: Defines the mapping of two particular
        ArgumentDataPrototypes with unequal names or unequal semantic
        (resolution or range) in context of Operations.
    :ivar first_operation_ref: First to-be-mapped ClientServerOperation
        of a ClientServerInterface.
    :ivar first_to_second_data_transformation_ref: This reference
        indicates that a DataTransformation is intended in the context
        of the ClientServerOperationMapping.
    :ivar second_operation_ref: Second to-be-mapped
        ClientServerOperation of a ClientServerInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-OPERATION-MAPPING"

    argument_mappings: Optional["ClientServerOperationMapping.ArgumentMappings"] = field(
        default=None,
        metadata={
            "name": "ARGUMENT-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    first_operation_ref: Optional["ClientServerOperationMapping.FirstOperationRef"] = field(
        default=None,
        metadata={
            "name": "FIRST-OPERATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    first_to_second_data_transformation_ref: Optional[
        "ClientServerOperationMapping.FirstToSecondDataTransformationRef"
    ] = field(
        default=None,
        metadata={
            "name": "FIRST-TO-SECOND-DATA-TRANSFORMATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    second_operation_ref: Optional["ClientServerOperationMapping.SecondOperationRef"] = field(
        default=None,
        metadata={
            "name": "SECOND-OPERATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ArgumentMappings:
        data_prototype_mapping: list[DataPrototypeMapping] = field(
            default_factory=list,
            metadata={
                "name": "DATA-PROTOTYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FirstOperationRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FirstToSecondDataTransformationRef(Ref):
        dest: DataTransformationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SecondOperationRef(Ref):
        dest: ClientServerOperationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ConcreteClassTailoring:
    """
    Tailoring of concrete meta classes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alternative_name: Alternative name of a specification element
        if its name doesn't fit into the shortName. E.g. because the
        name contains spaces.
    :ivar in_scope: indicates, if a specification element is relevant
        for this data exchange point. It is relevant if inScope==true.
        It is not relevant or don't care if inScope=false.
    :ivar multiplicity_restriction: Specifies the multiplicity of the
        class in the current context.
    :ivar variation_restriction: Specifies restrictions on the usage of
        variant handling.
    :ivar class_contents: Specifies the accepted / not accepted content
        of the class. All rules apply that fullfill the condition of the
        ClassContentConditional
    :ivar validation_root: Specification if this concrete Meta-Class is
        a root element for validation. I.e.: The validation starts at an
        object of this concrete Meta-Class and continues by following
        all aggregations and references that are in scope of this Data
        Exchange Point.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONCRETE-CLASS-TAILORING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ConcreteClassTailoring.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ConcreteClassTailoring.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alternative_name: String | None = field(
        default=None,
        metadata={
            "name": "ALTERNATIVE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    in_scope: Boolean | None = field(
        default=None,
        metadata={
            "name": "IN-SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiplicity_restriction: MultiplicityRestrictionWithSeverity | None = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-RESTRICTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_restriction: VariationRestrictionWithSeverity | None = field(
        default=None,
        metadata={
            "name": "VARIATION-RESTRICTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    class_contents: Optional["ConcreteClassTailoring.ClassContents"] = field(
        default=None,
        metadata={
            "name": "CLASS-CONTENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    validation_root: Boolean | None = field(
        default=None,
        metadata={
            "name": "VALIDATION-ROOT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClassContents:
        class_content_conditional: list[ClassContentConditional] = field(
            default_factory=list,
            metadata={
                "name": "CLASS-CONTENT-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ConsistencyNeedsBlueprintSet:
    """
    This meta class represents the ability to specify a set of blueprint for
    ConsistencyNeeds.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar consistency_needss: This represents a particular blueprint of
        consistencyNeeds. Note that it is
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONSISTENCY-NEEDS-BLUEPRINT-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ConsistencyNeedsBlueprintSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ConsistencyNeedsBlueprintSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consistency_needss: Optional["ConsistencyNeedsBlueprintSet.ConsistencyNeedss"] = field(
        default=None,
        metadata={
            "name": "CONSISTENCY-NEEDSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConsistencyNeedss:
        consistency_needs: list[ConsistencyNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CONSISTENCY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ConsumedServiceInstance:
    """
    Service instances that are consumed by the ECU that is connected via the
    ApplicationEndpoint to a CommunicationConnector.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar capability_records: A sequence of records to store arbitrary
        name/value pairs conveying additional information about the
        named service.
    :ivar major_version: Major Version of the ServiceInterface. Value
        can be set to a number that represents the Major Version of the
        service.
    :ivar method_activation_routing_groups: The ServiceDiscovery module
        is able to activate and deactivate the PDU routing for
        ClientServerOperations (SOME/IP methods). The upper multiplicity
        of this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar routing_group_refs: The ServiceDiscovery module is able to
        activate and deactivate the PDU routing from and to TCP/IP-
        sockets.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ServiceInstanceCollectionSet.serviceInstance Not Applicable for:
        ApplicationEndpoint.providedServiceInstance Not Applicable for:
        ApplicationEndpoint.consumedServiceInstance
    :ivar auto_require: Defines that this ConsumedServiceInstance shall
        be required (searched for) by the service discovery at ECU
        start.
    :ivar blacklisted_versions: Collection of blacklisted versions.
    :ivar blocklisted_versions: Collection of blocklisted versions
    :ivar consumed_event_groups: Selection of event-groups the consumer
        wants to subscribe for.
    :ivar event_multicast_subscription_addresss: Multicast Address that
        is used by the client to subscribe to the server: This enables
        the multicast subscription feature. This property was modified
        due to atpVariation (DirectedAssociationPattern).
    :ivar instance_identifier: This attribute represents the ability to
        describe the required service instance ID.
    :ivar local_unicast_addresss: The local address over which the CSI
        is consumed (udp, tcp or both). This property was modified due
        to atpVariation (DirectedAssociationPattern).
    :ivar minor_version: Minor Version of the ServiceInterface. Value
        can be set to a number that represents the Minor Version of the
        searched service or to ANY.
    :ivar provided_service_instance_ref: Reference to a
        providedServiceInstance to get the instanceIdentifier
        information from the ProvidedServiceInstance.
    :ivar remote_unicast_addresss: This reference defines the remote
        address where the service provider is located. This reference
        shall ONLY be used if the remote address is determined from the
        configuration and not at runtime from the Service Discovery.
        This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar sd_client_config: Service Discovery Client configuration.
    :ivar sd_client_timer_configs: Client specific configuration
        settings relevant for the SOME/IP service discovery. This
        property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar service_identifier: This attribute represents the ability to
        describe the SOME/IP service ID that is searched.
    :ivar version_driven_find_behavior: Defines the service discovery
        find behavior.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONSUMED-SERVICE-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ConsumedServiceInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ConsumedServiceInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    capability_records: Optional["ConsumedServiceInstance.CapabilityRecords"] = field(
        default=None,
        metadata={
            "name": "CAPABILITY-RECORDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    major_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAJOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_activation_routing_groups: Optional[
        "ConsumedServiceInstance.MethodActivationRoutingGroups"
    ] = field(
        default=None,
        metadata={
            "name": "METHOD-ACTIVATION-ROUTING-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    routing_group_refs: Optional["ConsumedServiceInstance.RoutingGroupRefs"] = field(
        default=None,
        metadata={
            "name": "ROUTING-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    auto_require: Boolean | None = field(
        default=None,
        metadata={
            "name": "AUTO-REQUIRE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blacklisted_versions: Optional["ConsumedServiceInstance.BlacklistedVersions"] = field(
        default=None,
        metadata={
            "name": "BLACKLISTED-VERSIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blocklisted_versions: Optional["ConsumedServiceInstance.BlocklistedVersions"] = field(
        default=None,
        metadata={
            "name": "BLOCKLISTED-VERSIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consumed_event_groups: Optional["ConsumedServiceInstance.ConsumedEventGroups"] = field(
        default=None,
        metadata={
            "name": "CONSUMED-EVENT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_multicast_subscription_addresss: Optional[
        "ConsumedServiceInstance.EventMulticastSubscriptionAddresss"
    ] = field(
        default=None,
        metadata={
            "name": "EVENT-MULTICAST-SUBSCRIPTION-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    instance_identifier: AnyServiceInstanceId | None = field(
        default=None,
        metadata={
            "name": "INSTANCE-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_unicast_addresss: Optional["ConsumedServiceInstance.LocalUnicastAddresss"] = field(
        default=None,
        metadata={
            "name": "LOCAL-UNICAST-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minor_version: AnyVersionString | None = field(
        default=None,
        metadata={
            "name": "MINOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_service_instance_ref: Optional[
        "ConsumedServiceInstance.ProvidedServiceInstanceRef"
    ] = field(
        default=None,
        metadata={
            "name": "PROVIDED-SERVICE-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_unicast_addresss: Optional["ConsumedServiceInstance.RemoteUnicastAddresss"] = field(
        default=None,
        metadata={
            "name": "REMOTE-UNICAST-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sd_client_config: SdClientConfig | None = field(
        default=None,
        metadata={
            "name": "SD-CLIENT-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sd_client_timer_configs: Optional["ConsumedServiceInstance.SdClientTimerConfigs"] = field(
        default=None,
        metadata={
            "name": "SD-CLIENT-TIMER-CONFIGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_identifier: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SERVICE-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version_driven_find_behavior: ServiceVersionAcceptanceKindEnum | None = field(
        default=None,
        metadata={
            "name": "VERSION-DRIVEN-FIND-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CapabilityRecords:
        tag_with_optional_value: list[TagWithOptionalValue] = field(
            default_factory=list,
            metadata={
                "name": "TAG-WITH-OPTIONAL-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MethodActivationRoutingGroups:
        pdu_activation_routing_group: list[PduActivationRoutingGroup] = field(
            default_factory=list,
            metadata={
                "name": "PDU-ACTIVATION-ROUTING-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RoutingGroupRefs:
        routing_group_ref: list["ConsumedServiceInstance.RoutingGroupRefs.RoutingGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "ROUTING-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RoutingGroupRef(Ref):
            dest: SoAdRoutingGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class BlacklistedVersions:
        someip_service_version: list[SomeipServiceVersion] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-SERVICE-VERSION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlocklistedVersions:
        someip_service_version: list[SomeipServiceVersion] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-SERVICE-VERSION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConsumedEventGroups:
        consumed_event_group: list[ConsumedEventGroup] = field(
            default_factory=list,
            metadata={
                "name": "CONSUMED-EVENT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EventMulticastSubscriptionAddresss:
        application_endpoint_ref_conditional: list[ApplicationEndpointRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-ENDPOINT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LocalUnicastAddresss:
        application_endpoint_ref_conditional: list[ApplicationEndpointRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-ENDPOINT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedServiceInstanceRef(Ref):
        dest: ProvidedServiceInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RemoteUnicastAddresss:
        application_endpoint_ref_conditional: list[ApplicationEndpointRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-ENDPOINT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SdClientTimerConfigs:
        someip_sd_client_service_instance_config_ref_conditional: list[
            SomeipSdClientServiceInstanceConfigRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-SD-CLIENT-SERVICE-INSTANCE-CONFIG-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CouplingPort:
    """A CouplingPort is used to connect a CouplingElement with an EcuInstance or
    two CouplingElements with each other via a CouplingPortConnection.

    Optionally, the CouplingPort may also have a reference to a
    macMulticastGroup and a defaultVLAN.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar connection_negotiation_behavior: Specifies the connection
        negotiation of the CouplingPort.
    :ivar coupling_port_details: Defines more details of a CouplingPort
        in case a more specific configuration is required.
    :ivar coupling_port_role: Defines the role this CouplingPort takes
        in the context of the CouplingElement.
    :ivar coupling_port_speed: CouplingPort speed in bits/s.
    :ivar default_vlan_ref: The vLanIdentifier of the referenced VLAN is
        the Default-PVID (port VLAN ID). A Port VLAN ID is a default
        VLAN ID that is assigned to an access CouplingPort to designate
        the VLAN segment to which this port is connected. Also, if a
        CouplingPort has not been configured with any VLAN memberships,
        the virtual switch's Port VLAN ID (pvid) becomes the default
        VLAN ID for the ports connection. This identifier/tag is added
        for incoming untagged messages at the port (ingress tagging).
        For outgoing messages with this identifier, the tag is removed
        at the port (egress untagging, depending on the
        VlanMembership.sendActivity).
    :ivar mac_layer_type: Specifies the mac layer type of the
        CouplingPort.
    :ivar mac_multicast_address_refs: Assigns a set of MAC-Multicast-
        Addresses which are addressable via this CouplingPort. This is a
        static pre-configuration and further addresses may be learned
        during runtime.
    :ivar mac_sec_propss: Properties to configure MACsec (Media access
        control security) and the MKA (MACsec Key Agreement) for the
        CouplingPort (PHY).
    :ivar physical_layer_type: Specifies the physical layer type of the
        CouplingPort.
    :ivar plca_props: Optional properties for configuration of PLCA
        (Physical Layer Collision Avoidance) in case 10-BASE-T1S
        Ethernet is used and PLCA is enabled on the CouplingPort (PHY).
    :ivar pnc_mapping_refs: Reference to the partial networks this
        CouplingPort participates in.
    :ivar receive_activity: Defines the handling of frames at the
        ingress port.
    :ivar vlan_memberships: Messages of VLANs that are defined here can
        be communicated via the CouplingPort.
    :ivar vlan_modifier_ref: All incoming messages at this CouplingPort
        shall be tagged with this VLAN Id. This tagging is performed
        regardless whether the message already has a VLAN tag or is
        untagged, an existing VLAN tag will be overwritten. This feature
        is XOR with CoupligPort.defaultVlan.
    :ivar wakeup_sleep_on_dataline_config_ref: Optional reference to
        EthernetWakeupSleepOnDatalineConfig.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CouplingElement.couplingPort Not Applicable for:
        EthernetCommunicationControllerContent.couplingPort
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COUPLING-PORT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CouplingPort.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CouplingPort.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    connection_negotiation_behavior: EthernetConnectionNegotiationEnum | None = field(
        default=None,
        metadata={
            "name": "CONNECTION-NEGOTIATION-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    coupling_port_details: CouplingPortDetails | None = field(
        default=None,
        metadata={
            "name": "COUPLING-PORT-DETAILS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    coupling_port_role: CouplingPortRoleEnum | None = field(
        default=None,
        metadata={
            "name": "COUPLING-PORT-ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    coupling_port_speed: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "COUPLING-PORT-SPEED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_vlan_ref: Optional["CouplingPort.DefaultVlanRef"] = field(
        default=None,
        metadata={
            "name": "DEFAULT-VLAN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mac_layer_type: EthernetMacLayerTypeEnum | None = field(
        default=None,
        metadata={
            "name": "MAC-LAYER-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mac_multicast_address_refs: Optional["CouplingPort.MacMulticastAddressRefs"] = field(
        default=None,
        metadata={
            "name": "MAC-MULTICAST-ADDRESS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mac_sec_propss: Optional["CouplingPort.MacSecPropss"] = field(
        default=None,
        metadata={
            "name": "MAC-SEC-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_layer_type: EthernetPhysicalLayerTypeEnum | None = field(
        default=None,
        metadata={
            "name": "PHYSICAL-LAYER-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    plca_props: PlcaProps | None = field(
        default=None,
        metadata={
            "name": "PLCA-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_mapping_refs: Optional["CouplingPort.PncMappingRefs"] = field(
        default=None,
        metadata={
            "name": "PNC-MAPPING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    receive_activity: EthernetSwitchVlanIngressTagEnum | None = field(
        default=None,
        metadata={
            "name": "RECEIVE-ACTIVITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vlan_memberships: Optional["CouplingPort.VlanMemberships"] = field(
        default=None,
        metadata={
            "name": "VLAN-MEMBERSHIPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vlan_modifier_ref: Optional["CouplingPort.VlanModifierRef"] = field(
        default=None,
        metadata={
            "name": "VLAN-MODIFIER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_sleep_on_dataline_config_ref: Optional["CouplingPort.WakeupSleepOnDatalineConfigRef"] = (
        field(
            default=None,
            metadata={
                "name": "WAKEUP-SLEEP-ON-DATALINE-CONFIG-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DefaultVlanRef(Ref):
        dest: EthernetPhysicalChannelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MacMulticastAddressRefs:
        mac_multicast_address_ref: list[
            "CouplingPort.MacMulticastAddressRefs.MacMulticastAddressRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MAC-MULTICAST-ADDRESS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class MacMulticastAddressRef(Ref):
            dest: MacMulticastGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class MacSecPropss:
        mac_sec_props: list[MacSecProps] = field(
            default_factory=list,
            metadata={
                "name": "MAC-SEC-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PncMappingRefs:
        pnc_mapping_ref: list["CouplingPort.PncMappingRefs.PncMappingRef"] = field(
            default_factory=list,
            metadata={
                "name": "PNC-MAPPING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PncMappingRef(Ref):
            dest: PncMappingIdentSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class VlanMemberships:
        vlan_membership: list[VlanMembership] = field(
            default_factory=list,
            metadata={
                "name": "VLAN-MEMBERSHIP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class VlanModifierRef(Ref):
        dest: EthernetPhysicalChannelSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class WakeupSleepOnDatalineConfigRef(Ref):
        dest: EthernetWakeupSleepOnDatalineConfigSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DataTransformationSet:
    """
    This element is the system wide container of DataTransformations which
    represent transformer chains.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar data_transformations: This container consists of all
        transformer chains which can be used for transformation of data
        communication.
    :ivar transformation_technologys: Transformer that is used in a
        transformer chain for transformation of data communication.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-TRANSFORMATION-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DataTransformationSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DataTransformationSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_transformations: Optional["DataTransformationSet.DataTransformations"] = field(
        default=None,
        metadata={
            "name": "DATA-TRANSFORMATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformation_technologys: Optional["DataTransformationSet.TransformationTechnologys"] = field(
        default=None,
        metadata={
            "name": "TRANSFORMATION-TECHNOLOGYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataTransformations:
        data_transformation: list[DataTransformation] = field(
            default_factory=list,
            metadata={
                "name": "DATA-TRANSFORMATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TransformationTechnologys:
        transformation_technology: list[TransformationTechnology] = field(
            default_factory=list,
            metadata={
                "name": "TRANSFORMATION-TECHNOLOGY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticCommonProps:
    """
    This meta-class aggregates a number of common properties that are shared among
    a diagnostic extract.

    :ivar diagnostic_common_props_variants: This element was
        generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-COMMON-PROPS"

    diagnostic_common_props_variants: Optional[
        "DiagnosticCommonProps.DiagnosticCommonPropsVariants"
    ] = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-COMMON-PROPS-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DiagnosticCommonPropsVariants:
        diagnostic_common_props_conditional: list[DiagnosticCommonPropsConditional] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-COMMON-PROPS-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDataElementInterface:
    """
    This meta-class represents the ability to implement a element-of-DID-focused
    PortInterface for diagnostics on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar read: This represents the method to read the content of an
        element of a diagnostic data identifier. This aggregation
        contains a variation point although it is not variant.
        Therefore, this variation point shall not exist in models. See
        constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DATA-ELEMENT-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDataElementInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDataElementInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticDataElementInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticDataElementInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    read: ClientServerOperation | None = field(
        default=None,
        metadata={
            "name": "READ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDataIdentifierInterface:
    """
    This meta-class represents the ability to implement a DID-focused PortInterface
    for diagnostics on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar read: This represents the method to read the content of a
        diagnostic data identifier. This aggregation contains a
        variation point although it is not variant. Therefore, this
        variation point shall not exist in models. See constr_2638.
    :ivar write: This represents the method to write the contents of a
        diagnostic data identifier. This aggregation contains a
        variation point although it is not variant. Therefore, this
        variation point shall not exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DATA-IDENTIFIER-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDataIdentifierInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDataIdentifierInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticDataIdentifierInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticDataIdentifierInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    read: ClientServerOperation | None = field(
        default=None,
        metadata={
            "name": "READ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    write: ClientServerOperation | None = field(
        default=None,
        metadata={
            "name": "WRITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticParameter:
    """
    This meta-class represents the ability to describe information relevant for the
    execution of a specific diagnostic service, i.e. it can be taken to
    parameterize the service.

    :ivar bit_offset: This represents the bitOffset of the
        DiagnosticParameter. The value of the bitOffset shall always be
        interpreted as relative to the start of the enclosing
        DiagnosticDataIdentifier, DiagnosticParameterIdentifier, or
        DiagnosticRoutineSubfunction.
    :ivar data_elements: This represents the related dataElement of the
        DiagnosticParameter The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar parameter_size: This attribute allows for the specification of
        the parameter size. This information is relevant if there is a
        gap between one diagnostic parameter and the following
        diagnostic parameter (or the tail of the telegram). The unit is
        bit and the values shall be multiples of 8.
    :ivar ident: The aggregation in the role ident provides the ability
        to make the DiagnosticAbstractParameter identifiable. From the
        semantical point of view, the AbstractDiagnosticParameter is
        considered a first-class Identifiable and therefore the
        aggregation in the role ident shall always exist (until it may
        be possible to let AbstractDiagnosticParameter directly inherit
        from Identifiable).
    :ivar support_info: This attribute represents the ability to define
        which bit of the support info byte is representing this part of
        the PID.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DiagnosticDataIdentifier.dataElement Applicable for:
        DiagnosticParameterIdentifier.dataElement Not Applicable for:
        DiagnosticInfoType.dataElement Not Applicable for:
        DiagnosticRequestRoutineResults.request Not Applicable for:
        DiagnosticRequestRoutineResults.response Not Applicable for:
        DiagnosticStartRoutine.response Not Applicable for:
        DiagnosticStartRoutine.request Not Applicable for:
        DiagnosticStopRoutine.request Not Applicable for:
        DiagnosticStopRoutine.response Not Applicable for:
        DiagnosticExtendedDataRecord.recordElement
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-PARAMETER"

    bit_offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "BIT-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_elements: Optional["DiagnosticParameter.DataElements"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PARAMETER-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ident: DiagnosticParameterIdent | None = field(
        default=None,
        metadata={
            "name": "IDENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    support_info: DiagnosticParameterSupportInfo | None = field(
        default=None,
        metadata={
            "name": "SUPPORT-INFO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataElements:
        diagnostic_data_element: list[DiagnosticDataElement] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DATA-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRoutineInterface:
    """
    This meta-class represents the ability to implement a routine-focused
    PortInterface for diagnostics on the adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar request_result: This represents the request result method of
        the diagnostic routine. This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar start: This represents the start method of the diagnostic
        routine. This aggregation contains a variation point although it
        is not variant. Therefore, this variation point shall not exist
        in models. See constr_2638.
    :ivar stop: This represents the stop method of the diagnostic
        routine. This aggregation contains a variation point although it
        is not variant. Therefore, this variation point shall not exist
        in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ROUTINE-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRoutineInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRoutineInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["DiagnosticRoutineInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["DiagnosticRoutineInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_result: ClientServerOperation | None = field(
        default=None,
        metadata={
            "name": "REQUEST-RESULT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start: ClientServerOperation | None = field(
        default=None,
        metadata={
            "name": "START",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    stop: ClientServerOperation | None = field(
        default=None,
        metadata={
            "name": "STOP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcuResourceEstimation:
    """
    Resource estimations for RTE and BSW of a single ECU instance.

    :ivar introduction: This represents introductory documentation about
        the ecu resource estimation
    :ivar bsw_resource_estimation: Estimation for the resource
        consumption of the basic software.
    :ivar ecu_instance_ref: Reference to the ECU this estimation is done
        for.
    :ivar rte_resource_estimation: Estimation for the resource
        consumption of the run time environment.
    :ivar sw_comp_to_ecu_mapping_refs: References to  SwcToEcuMappings
        that have been taken into account for the resource estimations.
        This way it is possible to define dfferent
        EcuResourceEstimations with diifferent mappings, e.g. before and
        after mapping an additional SW component.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SystemMapping.resourceEstimation
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECU-RESOURCE-ESTIMATION"

    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_resource_estimation: ResourceConsumption | None = field(
        default=None,
        metadata={
            "name": "BSW-RESOURCE-ESTIMATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["EcuResourceEstimation.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rte_resource_estimation: ResourceConsumption | None = field(
        default=None,
        metadata={
            "name": "RTE-RESOURCE-ESTIMATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_comp_to_ecu_mapping_refs: Optional["EcuResourceEstimation.SwCompToEcuMappingRefs"] = field(
        default=None,
        metadata={
            "name": "SW-COMP-TO-ECU-MAPPING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SwCompToEcuMappingRefs:
        sw_comp_to_ecu_mapping_ref: list[
            "EcuResourceEstimation.SwCompToEcuMappingRefs.SwCompToEcuMappingRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMP-TO-ECU-MAPPING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SwCompToEcuMappingRef(Ref):
            dest: SwcToEcuMappingSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class EcuTiming:
    """A model element used to define timing descriptions and constraints within
    the scope of one ECU configuration.

    TimingDescriptions aggregated by EcuTiming are allowed to use all
    events derived from the class TimingDescriptionEvent.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar timing_clocks: A list of abstract model Clocks.
    :ivar timing_clock_sync_accuracys: A list of accuracies - which may
        be used to specify synchronizations from one model clock to
        another model clock.
    :ivar timing_conditions: The timing condition specifies a specific
        condition.
    :ivar timing_descriptions: The timing descriptions that belong to a
        specific timing specification. In order to support different
        timing description variants within a timing specification, the
        aggregation is marked with the stereotype "atpVariation".
    :ivar timing_guarantees: The timing constraints that belong to a
        specific timing specification in the role of a timing guarantee.
        In order to support different timing constraint variants within
        a timing specification, the aggregation is marked with the
        stereotype "atpVariation".
    :ivar timing_requirements: The timing constraints that belong to a
        specific timing specification in the role of a timing
        requirement. In order to support different timing constraint
        variants within a timing specification, the aggregation is
        marked with the stereotype "atpVariation".
    :ivar timing_resource: The timing resource contains all instance
        references referred from within a timing condition formula of a
        timing view.
    :ivar ecu_configuration_ref: This defines the scope of an EcuTiming.
        All corresponding timing descriptions and constraints shall be
        defined within this scope.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECU-TIMING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcuTiming.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcuTiming.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clocks: Optional["EcuTiming.TimingClocks"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clock_sync_accuracys: Optional["EcuTiming.TimingClockSyncAccuracys"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCK-SYNC-ACCURACYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_conditions: Optional["EcuTiming.TimingConditions"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_descriptions: Optional["EcuTiming.TimingDescriptions"] = field(
        default=None,
        metadata={
            "name": "TIMING-DESCRIPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_guarantees: Optional["EcuTiming.TimingGuarantees"] = field(
        default=None,
        metadata={
            "name": "TIMING-GUARANTEES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_requirements: Optional["EcuTiming.TimingRequirements"] = field(
        default=None,
        metadata={
            "name": "TIMING-REQUIREMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_resource: TimingExtensionResource | None = field(
        default=None,
        metadata={
            "name": "TIMING-RESOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_configuration_ref: Optional["EcuTiming.EcuConfigurationRef"] = field(
        default=None,
        metadata={
            "name": "ECU-CONFIGURATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClocks:
        tdlet_zone_clock: list[TdletZoneClock] = field(
            default_factory=list,
            metadata={
                "name": "TDLET-ZONE-CLOCK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClockSyncAccuracys:
        timing_clock_sync_accuracy: list[TimingClockSyncAccuracy] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CLOCK-SYNC-ACCURACY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingConditions:
        timing_condition: list[TimingCondition] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingDescriptions:
        td_event_bsw_internal_behavior: list[TdEventBswInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_mode_declaration: list[TdEventBswModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_module: list[TdEventBswModule] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_complex: list[TdEventComplex] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-COMPLEX",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_fr_cluster_cycle_start: list[TdEventFrClusterCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FR-CLUSTER-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame: list[TdEventFrame] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame_ethernet: list[TdEventFrameEthernet] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME-ETHERNET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_pdu: list[TdEventIPdu] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_signal: list[TdEventISignal] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_mode_declaration: list[TdEventModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_operation: list[TdEventOperation] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-OPERATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_discovery: list[TdEventServiceInstanceDiscovery] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-DISCOVERY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_event: list[TdEventServiceInstanceEvent] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_field: list[TdEventServiceInstanceField] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-FIELD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_method: list[TdEventServiceInstanceMethod] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-METHOD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_sllet_port: list[TdEventSlletPort] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SLLET-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior: list[TdEventSwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior_reference: list[TdEventSwcInternalBehaviorReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_trigger: list[TdEventTrigger] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_tt_can_cycle_start: list[TdEventTtCanCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TT-CAN-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_variable_data_prototype: list[TdEventVariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_vfb_reference: list[TdEventVfbReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VFB-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        timing_description_event_chain: list[TimingDescriptionEventChain] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-DESCRIPTION-EVENT-CHAIN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingGuarantees:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingRequirements:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuConfigurationRef(Ref):
        dest: EcucValueCollectionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EcucAddInfoParamDef:
    """
    Configuration Parameter Definition for the specification of formatted text in
    the ECU Configuration Parameter Description.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar derivation: A derivation of a Configuration Parameter value
        can be specified by an informal Calculation Formula or by a
        formal language that can be used to specify the computational
        rules.
    :ivar symbolic_name_value: Specifies that this parameter's value is
        used, together with the aggregating container, to derive a
        symbolic name definition. See chapter "Representation of
        Symbolic Names" in Ecuc specification for more details.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this parameter value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective parameter to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective parameter to
        "true". If withAuto is not present the default is "false".
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-ADD-INFO-PARAM-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucAddInfoParamDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucAddInfoParamDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucAddInfoParamDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucAddInfoParamDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional["EcucAddInfoParamDef.ImplementationConfigClasses"] = (
        field(
            default=None,
            metadata={
                "name": "IMPLEMENTATION-CONFIG-CLASSES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    multiplicity_config_classes: Optional["EcucAddInfoParamDef.MultiplicityConfigClasses"] = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucAddInfoParamDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    derivation: EcucDerivationSpecification | None = field(
        default=None,
        metadata={
            "name": "DERIVATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbolic_name_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "SYMBOLIC-NAME-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucBooleanParamDef:
    """Configuration parameter type for Boolean.

    Allowed values are true and false.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar derivation: A derivation of a Configuration Parameter value
        can be specified by an informal Calculation Formula or by a
        formal language that can be used to specify the computational
        rules.
    :ivar symbolic_name_value: Specifies that this parameter's value is
        used, together with the aggregating container, to derive a
        symbolic name definition. See chapter "Representation of
        Symbolic Names" in Ecuc specification for more details.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this parameter value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective parameter to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective parameter to
        "true". If withAuto is not present the default is "false".
    :ivar default_value: Default value of the boolean configuration
        parameter. atpVariation: [RS_ECUC_00083]
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-BOOLEAN-PARAM-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucBooleanParamDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucBooleanParamDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucBooleanParamDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucBooleanParamDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional["EcucBooleanParamDef.ImplementationConfigClasses"] = (
        field(
            default=None,
            metadata={
                "name": "IMPLEMENTATION-CONFIG-CLASSES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    multiplicity_config_classes: Optional["EcucBooleanParamDef.MultiplicityConfigClasses"] = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucBooleanParamDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    derivation: EcucDerivationSpecification | None = field(
        default=None,
        metadata={
            "name": "DERIVATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbolic_name_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "SYMBOLIC-NAME-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_value: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucChoiceContainerDef:
    """Used to define configuration containers that provide a choice between
    several EcucParamConfContainerDef.

    But in the actual ECU Configuration Values only one instance from
    the choice list will be present.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar destination_uri_refs: Several destinationUris can be defined
        for an EcucContainerDef. With such destinationUris an
        EcucContainerDef is applicable for several EcucUriReferenceDefs.
    :ivar multiplicity_config_classes: Specifies which
        MultiplicityConfigurationClass this container is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION and if
        the upperMultiplicity is greater than the lowerMultiplicity then
        this aggregation is mandatory.
    :ivar origin: This attribute specifies whether this configuration
        container is an AUTOSAR standardized container or whether it is
        vendor-specific.
    :ivar post_build_changeable: Specifies if the number of instances of
        this container may be changed in post-build selectable and post-
        build loadable time in the ECU Configuration Value Description.
        This attribute is only applicable to containers which may appear
        multiple times in the configuration set, i.e. their
        upperMultiplicity is greater than lowerMultiplicity and their
        upperMultiplicity is greater than 1. If a value of this
        attribute is not defined in the EcucModuleDef with category
        STANDARDIZED_MODULE_DEFINITION, it shall be defined in the
        EcucModuleDef with category VENDOR_SPECIFIC_MODULE_DEFINITION
        for all containers with upperMultiplicity greater than
        lowerMultiplicity and upperMultiplicity greater than 1. This
        attribute is removed from the specifications and shall not be
        used.
    :ivar post_build_variant_multiplicity: Indicates if a container may
        have different number of instances in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar choices: The choices available in a EcucChoiceContainerDef.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-CHOICE-CONTAINER-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucChoiceContainerDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucChoiceContainerDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucChoiceContainerDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucChoiceContainerDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_uri_refs: Optional["EcucChoiceContainerDef.DestinationUriRefs"] = field(
        default=None,
        metadata={
            "name": "DESTINATION-URI-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiplicity_config_classes: Optional["EcucChoiceContainerDef.MultiplicityConfigClasses"] = (
        field(
            default=None,
            metadata={
                "name": "MULTIPLICITY-CONFIG-CLASSES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_changeable: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-CHANGEABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    choices: Optional["EcucChoiceContainerDef.Choices"] = field(
        default=None,
        metadata={
            "name": "CHOICES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DestinationUriRefs:
        destination_uri_ref: list["EcucChoiceContainerDef.DestinationUriRefs.DestinationUriRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DESTINATION-URI-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class DestinationUriRef(Ref):
            dest: EcucDestinationUriDefSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Choices:
        ecuc_param_conf_container_def: list["EcucParamConfContainerDef"] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-PARAM-CONF-CONTAINER-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucChoiceReferenceDef:
    """
    Specify alternative references where in the ECU Configuration description only
    one of the specified references will actually be used.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this reference value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective reference to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective reference to
        "true". If withAuto is not present the default is "false".
    :ivar requires_symbolic_name_value: If this attribute is set to true
        the implementation of the reference is done using a Symbolic
        Name defined by the referenced container according to
        TPS_ECUC_02108.
    :ivar destination_refs: All the possible parameter containers for
        the reference are specified.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-CHOICE-REFERENCE-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucChoiceReferenceDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucChoiceReferenceDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucChoiceReferenceDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucChoiceReferenceDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional[
        "EcucChoiceReferenceDef.ImplementationConfigClasses"
    ] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiplicity_config_classes: Optional["EcucChoiceReferenceDef.MultiplicityConfigClasses"] = (
        field(
            default=None,
            metadata={
                "name": "MULTIPLICITY-CONFIG-CLASSES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucChoiceReferenceDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_symbolic_name_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-SYMBOLIC-NAME-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_refs: Optional["EcucChoiceReferenceDef.DestinationRefs"] = field(
        default=None,
        metadata={
            "name": "DESTINATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DestinationRefs:
        destination_ref: list["EcucChoiceReferenceDef.DestinationRefs.DestinationRef"] = field(
            default_factory=list,
            metadata={
                "name": "DESTINATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DestinationRef(Ref):
            dest: EcucContainerDefSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class EcucEnumerationLiteralDef:
    """
    Configuration parameter type for enumeration literals definition.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar ecuc_cond: If it evaluates to true the literal definition
        shall be processed as specified. Otherwise the literal
        definition shall be ignored.
    :ivar origin: String specifying if this literal is an AUTOSAR
        standardized literal or if the literal is vendor-specific.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-ENUMERATION-LITERAL-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucEnumerationLiteralDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucEnumerationLiteralDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucFloatParamDef:
    """
    Configuration parameter type for Float.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar derivation: A derivation of a Configuration Parameter value
        can be specified by an informal Calculation Formula or by a
        formal language that can be used to specify the computational
        rules.
    :ivar symbolic_name_value: Specifies that this parameter's value is
        used, together with the aggregating container, to derive a
        symbolic name definition. See chapter "Representation of
        Symbolic Names" in Ecuc specification for more details.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this parameter value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective parameter to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective parameter to
        "true". If withAuto is not present the default is "false".
    :ivar default_value: Default value of the float configuration
        parameter. atpVariation: [RS_ECUC_00083]
    :ivar max: Max value allowed for the parameter defined.
        atpVariation: [RS_ECUC_00084]
    :ivar min: Min value allowed for the parameter defined.
        atpVariation: [RS_ECUC_00084]
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-FLOAT-PARAM-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucFloatParamDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucFloatParamDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucFloatParamDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucFloatParamDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional["EcucFloatParamDef.ImplementationConfigClasses"] = (
        field(
            default=None,
            metadata={
                "name": "IMPLEMENTATION-CONFIG-CLASSES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    multiplicity_config_classes: Optional["EcucFloatParamDef.MultiplicityConfigClasses"] = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucFloatParamDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    derivation: EcucDerivationSpecification | None = field(
        default=None,
        metadata={
            "name": "DERIVATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbolic_name_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "SYMBOLIC-NAME-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_value: FloatValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max: Limit | None = field(
        default=None,
        metadata={
            "name": "MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min: Limit | None = field(
        default=None,
        metadata={
            "name": "MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucForeignReferenceDef:
    """
    Specify a reference to an XML description of an entity described in another
    AUTOSAR template.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this reference value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective reference to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective reference to
        "true". If withAuto is not present the default is "false".
    :ivar destination_type: The type in the AUTOSAR Metamodel to which
        instance this reference is allowed to point to.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-FOREIGN-REFERENCE-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucForeignReferenceDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucForeignReferenceDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucForeignReferenceDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucForeignReferenceDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional[
        "EcucForeignReferenceDef.ImplementationConfigClasses"
    ] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiplicity_config_classes: Optional["EcucForeignReferenceDef.MultiplicityConfigClasses"] = (
        field(
            default=None,
            metadata={
                "name": "MULTIPLICITY-CONFIG-CLASSES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucForeignReferenceDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_type: String | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucFunctionNameDef:
    """
    Configuration parameter type for Function Names like those used to specify
    callback functions.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar derivation: A derivation of a Configuration Parameter value
        can be specified by an informal Calculation Formula or by a
        formal language that can be used to specify the computational
        rules.
    :ivar symbolic_name_value: Specifies that this parameter's value is
        used, together with the aggregating container, to derive a
        symbolic name definition. See chapter "Representation of
        Symbolic Names" in Ecuc specification for more details.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this parameter value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective parameter to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective parameter to
        "true". If withAuto is not present the default is "false".
    :ivar ecuc_function_name_def_variants: This element was
        generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-FUNCTION-NAME-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucFunctionNameDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucFunctionNameDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucFunctionNameDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucFunctionNameDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional["EcucFunctionNameDef.ImplementationConfigClasses"] = (
        field(
            default=None,
            metadata={
                "name": "IMPLEMENTATION-CONFIG-CLASSES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    multiplicity_config_classes: Optional["EcucFunctionNameDef.MultiplicityConfigClasses"] = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucFunctionNameDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    derivation: EcucDerivationSpecification | None = field(
        default=None,
        metadata={
            "name": "DERIVATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbolic_name_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "SYMBOLIC-NAME-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_function_name_def_variants: Optional["EcucFunctionNameDef.EcucFunctionNameDefVariants"] = (
        field(
            default=None,
            metadata={
                "name": "ECUC-FUNCTION-NAME-DEF-VARIANTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcucFunctionNameDefVariants:
        ecuc_function_name_def_conditional: list[EcucFunctionNameDefConditional] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-FUNCTION-NAME-DEF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucInstanceReferenceDef:
    """
    Specify a reference to an XML description of an entity described in another
    AUTOSAR template using the INSTANCE REFERENCE semantics.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this reference value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective reference to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective reference to
        "true". If withAuto is not present the default is "false".
    :ivar destination_context: The context in the AUTOSAR Metamodel to
        which' this reference is allowed to point to.
    :ivar destination_type: The type in the AUTOSAR Metamodel to which'
        instance this reference is allowed to point to.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-INSTANCE-REFERENCE-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucInstanceReferenceDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucInstanceReferenceDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucInstanceReferenceDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucInstanceReferenceDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional[
        "EcucInstanceReferenceDef.ImplementationConfigClasses"
    ] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiplicity_config_classes: Optional["EcucInstanceReferenceDef.MultiplicityConfigClasses"] = (
        field(
            default=None,
            metadata={
                "name": "MULTIPLICITY-CONFIG-CLASSES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucInstanceReferenceDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_context: String | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-CONTEXT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_type: String | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucIntegerParamDef:
    """
    Configuration parameter type for Integer.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar derivation: A derivation of a Configuration Parameter value
        can be specified by an informal Calculation Formula or by a
        formal language that can be used to specify the computational
        rules.
    :ivar symbolic_name_value: Specifies that this parameter's value is
        used, together with the aggregating container, to derive a
        symbolic name definition. See chapter "Representation of
        Symbolic Names" in Ecuc specification for more details.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this parameter value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective parameter to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective parameter to
        "true". If withAuto is not present the default is "false".
    :ivar default_value: Default value of the integer configuration
        parameter. atpVariation: [RS_ECUC_00083]
    :ivar max: Max value allowed for the parameter defined.
        atpVariation: [RS_ECUC_00084]
    :ivar min: Min value allowed for the parameter defined.
        atpVariation: [RS_ECUC_00084]
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-INTEGER-PARAM-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucIntegerParamDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucIntegerParamDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucIntegerParamDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucIntegerParamDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional["EcucIntegerParamDef.ImplementationConfigClasses"] = (
        field(
            default=None,
            metadata={
                "name": "IMPLEMENTATION-CONFIG-CLASSES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    multiplicity_config_classes: Optional["EcucIntegerParamDef.MultiplicityConfigClasses"] = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucIntegerParamDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    derivation: EcucDerivationSpecification | None = field(
        default=None,
        metadata={
            "name": "DERIVATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbolic_name_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "SYMBOLIC-NAME-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_value: UnlimitedIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max: UnlimitedIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    min: UnlimitedIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "MIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucLinkerSymbolDef:
    """
    Configuration parameter type for Linker Symbol Names like those used to specify
    memory locations of variables and constants.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar derivation: A derivation of a Configuration Parameter value
        can be specified by an informal Calculation Formula or by a
        formal language that can be used to specify the computational
        rules.
    :ivar symbolic_name_value: Specifies that this parameter's value is
        used, together with the aggregating container, to derive a
        symbolic name definition. See chapter "Representation of
        Symbolic Names" in Ecuc specification for more details.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this parameter value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective parameter to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective parameter to
        "true". If withAuto is not present the default is "false".
    :ivar ecuc_linker_symbol_def_variants: This element was
        generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-LINKER-SYMBOL-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucLinkerSymbolDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucLinkerSymbolDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucLinkerSymbolDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucLinkerSymbolDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional["EcucLinkerSymbolDef.ImplementationConfigClasses"] = (
        field(
            default=None,
            metadata={
                "name": "IMPLEMENTATION-CONFIG-CLASSES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    multiplicity_config_classes: Optional["EcucLinkerSymbolDef.MultiplicityConfigClasses"] = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucLinkerSymbolDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    derivation: EcucDerivationSpecification | None = field(
        default=None,
        metadata={
            "name": "DERIVATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbolic_name_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "SYMBOLIC-NAME-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_linker_symbol_def_variants: Optional["EcucLinkerSymbolDef.EcucLinkerSymbolDefVariants"] = (
        field(
            default=None,
            metadata={
                "name": "ECUC-LINKER-SYMBOL-DEF-VARIANTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcucLinkerSymbolDefVariants:
        ecuc_linker_symbol_def_conditional: list[EcucLinkerSymbolDefConditional] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-LINKER-SYMBOL-DEF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucModuleConfigurationValues:
    """Head of the configuration of one Module.

    A Module can be a BSW module as well as the RTE and ECU
    Infrastructure. As part of the BSW module description, the
    EcucModuleConfigurationValues element has two different roles: The
    recommendedConfiguration contains parameter values recommended by
    the BSW module vendor. The preconfiguredConfiguration contains
    values for those parameters which are fixed by the implementation
    and cannot be changed. These two EcucModuleConfigurationValues are
    used when the base EcucModuleConfigurationValues (as part of the
    base ECU configuration) is created to fill parameters with initial
    values.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar definition_ref: Reference to the definition of this
        EcucModuleConfigurationValues element. Typically, this is a
        vendor specific module configuration.
    :ivar ecuc_def_edition: This is the version info of the ModuleDef
        ECUC Parameter definition to which this values conform to / are
        based on. For the Definition of ModuleDef ECUC Parameters the
        AdminData shall be used to express the semantic changes. The
        compatibility rules between the definition and value revision
        labels is up to the module's vendor.
    :ivar implementation_config_variant: Specifies the kind of
        deliverable this EcucModuleConfigurationValues element provides.
        If this element is not used in a particular role (e.g.
        preconfiguredConfiguration or recommendedConfiguration) then the
        value shall be one of VariantPreCompile, VariantLinkTime,
        VariantPostBuild.
    :ivar module_description_ref: Referencing the BSW module
        description, which this EcucModuleConfigurationValues element is
        configuring. This is optional because the
        EcucModuleConfigurationValues element is also used to configure
        the ECU infrastructure (memory map) or Application SW-Cs.
        However in case the EcucModuleConfigurationValues are used to
        configure the module, the reference is mandatory in order to
        fetch module specific "common" published information.
    :ivar post_build_variant_used: Indicates whether a module
        implementation has or plans to have (i.e., introduced at link or
        post-build time) new post-build variation points. TRUE means
        yes, FALSE means no. If the attribute is not defined, FALSE
        semantics shall be assumed.
    :ivar containers: Aggregates all containers that belong to this
        module configuration. atpVariation: [RS_ECUC_00078]
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-MODULE-CONFIGURATION-VALUES"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucModuleConfigurationValues.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucModuleConfigurationValues.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    definition_ref: Optional["EcucModuleConfigurationValues.DefinitionRef"] = field(
        default=None,
        metadata={
            "name": "DEFINITION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_def_edition: RevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "ECUC-DEF-EDITION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_variant: EcucConfigurationVariantEnum | None = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-CONFIG-VARIANT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    module_description_ref: Optional["EcucModuleConfigurationValues.ModuleDescriptionRef"] = field(
        default=None,
        metadata={
            "name": "MODULE-DESCRIPTION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_used: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-USED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    containers: Optional["EcucModuleConfigurationValues.Containers"] = field(
        default=None,
        metadata={
            "name": "CONTAINERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DefinitionRef(Ref):
        dest: EcucModuleDefSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ModuleDescriptionRef(Ref):
        dest: BswImplementationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Containers:
        ecuc_container_value: list[EcucContainerValue] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-CONTAINER-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucMultilineStringParamDef:
    """
    Configuration parameter type for multiline Strings (including "carriage
    return").

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar derivation: A derivation of a Configuration Parameter value
        can be specified by an informal Calculation Formula or by a
        formal language that can be used to specify the computational
        rules.
    :ivar symbolic_name_value: Specifies that this parameter's value is
        used, together with the aggregating container, to derive a
        symbolic name definition. See chapter "Representation of
        Symbolic Names" in Ecuc specification for more details.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this parameter value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective parameter to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective parameter to
        "true". If withAuto is not present the default is "false".
    :ivar ecuc_multiline_string_param_def_variants: This element was
        generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-MULTILINE-STRING-PARAM-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucMultilineStringParamDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucMultilineStringParamDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucMultilineStringParamDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucMultilineStringParamDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional[
        "EcucMultilineStringParamDef.ImplementationConfigClasses"
    ] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiplicity_config_classes: Optional[
        "EcucMultilineStringParamDef.MultiplicityConfigClasses"
    ] = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucMultilineStringParamDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    derivation: EcucDerivationSpecification | None = field(
        default=None,
        metadata={
            "name": "DERIVATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbolic_name_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "SYMBOLIC-NAME-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_multiline_string_param_def_variants: Optional[
        "EcucMultilineStringParamDef.EcucMultilineStringParamDefVariants"
    ] = field(
        default=None,
        metadata={
            "name": "ECUC-MULTILINE-STRING-PARAM-DEF-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcucMultilineStringParamDefVariants:
        ecuc_multiline_string_param_def_conditional: list[
            EcucMultilineStringParamDefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTILINE-STRING-PARAM-DEF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucReferenceDef:
    """
    Specify references within the ECU Configuration Description between parameter
    containers.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this reference value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective reference to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective reference to
        "true". If withAuto is not present the default is "false".
    :ivar requires_symbolic_name_value: If this attribute is set to true
        the implementation of the reference is done using a Symbolic
        Name defined by the referenced container according to
        TPS_ECUC_02108.
    :ivar destination_ref: Exactly one reference to a parameter
        container is allowed as destination.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-REFERENCE-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucReferenceDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucReferenceDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucReferenceDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucReferenceDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional["EcucReferenceDef.ImplementationConfigClasses"] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiplicity_config_classes: Optional["EcucReferenceDef.MultiplicityConfigClasses"] = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucReferenceDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_symbolic_name_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-SYMBOLIC-NAME-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_ref: Optional["EcucReferenceDef.DestinationRef"] = field(
        default=None,
        metadata={
            "name": "DESTINATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DestinationRef(Ref):
        dest: EcucContainerDefSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EcucStringParamDef:
    """
    Configuration parameter type for String.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar derivation: A derivation of a Configuration Parameter value
        can be specified by an informal Calculation Formula or by a
        formal language that can be used to specify the computational
        rules.
    :ivar symbolic_name_value: Specifies that this parameter's value is
        used, together with the aggregating container, to derive a
        symbolic name definition. See chapter "Representation of
        Symbolic Names" in Ecuc specification for more details.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this parameter value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective parameter to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective parameter to
        "true". If withAuto is not present the default is "false".
    :ivar ecuc_string_param_def_variants: This element was
        generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-STRING-PARAM-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucStringParamDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucStringParamDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucStringParamDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucStringParamDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional["EcucStringParamDef.ImplementationConfigClasses"] = (
        field(
            default=None,
            metadata={
                "name": "IMPLEMENTATION-CONFIG-CLASSES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    multiplicity_config_classes: Optional["EcucStringParamDef.MultiplicityConfigClasses"] = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucStringParamDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    derivation: EcucDerivationSpecification | None = field(
        default=None,
        metadata={
            "name": "DERIVATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbolic_name_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "SYMBOLIC-NAME-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_string_param_def_variants: Optional["EcucStringParamDef.EcucStringParamDefVariants"] = (
        field(
            default=None,
            metadata={
                "name": "ECUC-STRING-PARAM-DEF-VARIANTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcucStringParamDefVariants:
        ecuc_string_param_def_conditional: list[EcucStringParamDefConditional] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-STRING-PARAM-DEF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucSymbolicNameReferenceDef:
    """
    This meta-class specifies that the implementation of the reference is done
    using a symbolic name defined by the referenced Container's shortName.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this reference value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective reference to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective reference to
        "true". If withAuto is not present the default is "false".
    :ivar requires_symbolic_name_value: If this attribute is set to true
        the implementation of the reference is done using a Symbolic
        Name defined by the referenced container according to
        TPS_ECUC_02108.
    :ivar destination_ref: Exactly one reference to a parameter
        container is allowed as destination.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-SYMBOLIC-NAME-REFERENCE-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucSymbolicNameReferenceDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucSymbolicNameReferenceDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucSymbolicNameReferenceDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucSymbolicNameReferenceDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional[
        "EcucSymbolicNameReferenceDef.ImplementationConfigClasses"
    ] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiplicity_config_classes: Optional[
        "EcucSymbolicNameReferenceDef.MultiplicityConfigClasses"
    ] = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucSymbolicNameReferenceDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_symbolic_name_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-SYMBOLIC-NAME-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_ref: Optional["EcucSymbolicNameReferenceDef.DestinationRef"] = field(
        default=None,
        metadata={
            "name": "DESTINATION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DestinationRef(Ref):
        dest: EcucParamConfContainerDefSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class EcucUriReferenceDef:
    """Definition of reference with a destination that is specified via a
    destinationUri.

    With such a reference it is possible to define a reference to a
    EcucContainerDef in a different module independent from the concrete
    definition of the target container.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this reference value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective reference to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective reference to
        "true". If withAuto is not present the default is "false".
    :ivar requires_symbolic_name_value: If this attribute is set to true
        the implementation of the reference is done using a Symbolic
        Name defined by the referenced container according to
        TPS_ECUC_02108.
    :ivar destination_uri_ref: Any EcucContainerDef with a
        destinationUri that is identical to the destinationUri that is
        referenced here defines a valid target.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-URI-REFERENCE-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucUriReferenceDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucUriReferenceDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucUriReferenceDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucUriReferenceDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional["EcucUriReferenceDef.ImplementationConfigClasses"] = (
        field(
            default=None,
            metadata={
                "name": "IMPLEMENTATION-CONFIG-CLASSES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    multiplicity_config_classes: Optional["EcucUriReferenceDef.MultiplicityConfigClasses"] = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucUriReferenceDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_symbolic_name_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-SYMBOLIC-NAME-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_uri_ref: Optional["EcucUriReferenceDef.DestinationUriRef"] = field(
        default=None,
        metadata={
            "name": "DESTINATION-URI-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DestinationUriRef(Ref):
        dest: EcucDestinationUriDefSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ExecutableTiming:
    """
    This meta-class represents the timing view for one or more executables.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar timing_clocks: A list of abstract model Clocks.
    :ivar timing_clock_sync_accuracys: A list of accuracies - which may
        be used to specify synchronizations from one model clock to
        another model clock.
    :ivar timing_conditions: The timing condition specifies a specific
        condition.
    :ivar timing_descriptions: The timing descriptions that belong to a
        specific timing specification. In order to support different
        timing description variants within a timing specification, the
        aggregation is marked with the stereotype "atpVariation".
    :ivar timing_guarantees: The timing constraints that belong to a
        specific timing specification in the role of a timing guarantee.
        In order to support different timing constraint variants within
        a timing specification, the aggregation is marked with the
        stereotype "atpVariation".
    :ivar timing_requirements: The timing constraints that belong to a
        specific timing specification in the role of a timing
        requirement. In order to support different timing constraint
        variants within a timing specification, the aggregation is
        marked with the stereotype "atpVariation".
    :ivar timing_resource: The timing resource contains all instance
        references referred from within a timing condition formula of a
        timing view.
    :ivar executable_refs: This defines the scope of a ExecutableTiming.
        All corresponding timing descriptions and constraints shall be
        defined within this scope.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "EXECUTABLE-TIMING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ExecutableTiming.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ExecutableTiming.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clocks: Optional["ExecutableTiming.TimingClocks"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clock_sync_accuracys: Optional["ExecutableTiming.TimingClockSyncAccuracys"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCK-SYNC-ACCURACYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_conditions: Optional["ExecutableTiming.TimingConditions"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_descriptions: Optional["ExecutableTiming.TimingDescriptions"] = field(
        default=None,
        metadata={
            "name": "TIMING-DESCRIPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_guarantees: Optional["ExecutableTiming.TimingGuarantees"] = field(
        default=None,
        metadata={
            "name": "TIMING-GUARANTEES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_requirements: Optional["ExecutableTiming.TimingRequirements"] = field(
        default=None,
        metadata={
            "name": "TIMING-REQUIREMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_resource: TimingExtensionResource | None = field(
        default=None,
        metadata={
            "name": "TIMING-RESOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    executable_refs: Optional["ExecutableTiming.ExecutableRefs"] = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClocks:
        tdlet_zone_clock: list[TdletZoneClock] = field(
            default_factory=list,
            metadata={
                "name": "TDLET-ZONE-CLOCK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClockSyncAccuracys:
        timing_clock_sync_accuracy: list[TimingClockSyncAccuracy] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CLOCK-SYNC-ACCURACY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingConditions:
        timing_condition: list[TimingCondition] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingDescriptions:
        td_event_bsw_internal_behavior: list[TdEventBswInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_mode_declaration: list[TdEventBswModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_module: list[TdEventBswModule] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_complex: list[TdEventComplex] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-COMPLEX",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_fr_cluster_cycle_start: list[TdEventFrClusterCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FR-CLUSTER-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame: list[TdEventFrame] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame_ethernet: list[TdEventFrameEthernet] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME-ETHERNET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_pdu: list[TdEventIPdu] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_signal: list[TdEventISignal] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_mode_declaration: list[TdEventModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_operation: list[TdEventOperation] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-OPERATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_discovery: list[TdEventServiceInstanceDiscovery] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-DISCOVERY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_event: list[TdEventServiceInstanceEvent] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_field: list[TdEventServiceInstanceField] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-FIELD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_method: list[TdEventServiceInstanceMethod] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-METHOD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_sllet_port: list[TdEventSlletPort] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SLLET-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior: list[TdEventSwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior_reference: list[TdEventSwcInternalBehaviorReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_trigger: list[TdEventTrigger] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_tt_can_cycle_start: list[TdEventTtCanCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TT-CAN-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_variable_data_prototype: list[TdEventVariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_vfb_reference: list[TdEventVfbReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VFB-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        timing_description_event_chain: list[TimingDescriptionEventChain] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-DESCRIPTION-EVENT-CHAIN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingGuarantees:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingRequirements:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutableRefs:
        executable_ref: list["ExecutableTiming.ExecutableRefs.ExecutableRef"] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTABLE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ExecutableRef(Ref):
            dest: ExecutableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class HwElement:
    """This represents the ability to describe Hardware Elements on an instance
    level.

    The particular types of hardware are distinguished by the category.
    This category determines the applicable attributes. The possible
    categories and attributes are defined in HwCategory.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar hw_type_ref: This association is used to assign an optional
        HwType which contains the common attribute values for all
        occurences of this HwDescriptionEntity. Note that HwTypes can
        not be redefined and therefore shall not have a hwType
        reference.
    :ivar hw_category_refs: One of the associations representing one
        particular category of the hardware entity.
    :ivar hw_attribute_values: This aggregation represents a particular
        hardware attribute value.
    :ivar nested_elements: This association is used to establish
        hierarchies of hw elements. Note that one particular HwElement
        can be target of this association only once. I.e. multiple
        instantiation of the same HwElement is not supported (at any
        hierarchy level). This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar hw_pin_groups: This aggregation is used to describe the
        connection facilities of a hardware element. Note that hardware
        element has no pins but only pingroups.
    :ivar hw_element_connections: This represents one particular
        connection between two hardware elements.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "HW-ELEMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["HwElement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["HwElement.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_type_ref: Optional["HwElement.HwTypeRef"] = field(
        default=None,
        metadata={
            "name": "HW-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_category_refs: Optional["HwElement.HwCategoryRefs"] = field(
        default=None,
        metadata={
            "name": "HW-CATEGORY-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_attribute_values: Optional["HwElement.HwAttributeValues"] = field(
        default=None,
        metadata={
            "name": "HW-ATTRIBUTE-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nested_elements: Optional["HwElement.NestedElements"] = field(
        default=None,
        metadata={
            "name": "NESTED-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_pin_groups: Optional["HwElement.HwPinGroups"] = field(
        default=None,
        metadata={
            "name": "HW-PIN-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_element_connections: Optional["HwElement.HwElementConnections"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwTypeRef(Ref):
        dest: HwTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class HwCategoryRefs:
        hw_category_ref: list["HwElement.HwCategoryRefs.HwCategoryRef"] = field(
            default_factory=list,
            metadata={
                "name": "HW-CATEGORY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class HwCategoryRef(Ref):
            dest: HwCategorySubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class HwAttributeValues:
        hw_attribute_value: list[HwAttributeValue] = field(
            default_factory=list,
            metadata={
                "name": "HW-ATTRIBUTE-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NestedElements:
        hw_element_ref_conditional: list[HwElementRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "HW-ELEMENT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwPinGroups:
        hw_pin_group: list[HwPinGroup] = field(
            default_factory=list,
            metadata={
                "name": "HW-PIN-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwElementConnections:
        hw_element_connector: list[HwElementConnector] = field(
            default_factory=list,
            metadata={
                "name": "HW-ELEMENT-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class IPduTiming:
    """AUTOSAR COM provides the possibility to define two different TRANSMISSION
    MODES for each IPdu.

    The Transmission Mode of an IPdu that is valid at a specific point
    in time is selected using the values of the signals that are mapped
    to this IPdu. For each IPdu a Transmission Mode Selector is defined.
    The Transmission Mode Selector is calculated by evaluating the
    conditions for a subset of signals  (class TransmissionModeCondition
    in the System Template). The Transmission Mode Selector is defined
    to be true, if at least one Condition evaluates to true and is
    defined to be false, if all Conditions evaluate to false.

    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Describable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar admin_data: This represents the administrative data for the
        describable object.
    :ivar minimum_delay: Minimum Delay in seconds between successive
        transmissions of this I-PDU, independent of the Transmission
        Mode.
    :ivar transmission_mode_declaration: AUTOSAR COM allows configuring
        statically two different transmission modes for each I-PDU (True
        and False). The Transmission Mode Selector evaluates the
        conditions for a subset of signals and decides the transmission
        mode. It is possible to switch between the transmission modes
        during runtime.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ISignalIPdu.iPduTimingSpecification
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-PDU-TIMING"

    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_mode_declaration: TransmissionModeDeclaration | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-MODE-DECLARATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ListType:
    """This meta-class represents the ability to express a list.

    The kind of list is specified in the attribute.

    :ivar item: this represents a particular list item. Note that this
        is again a documentation block.Therefore lists can be
        arbitrarily nested. It is discouraged to have a very deep
        nesting.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: DocumentationBlock.list
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    :ivar type_value: The type of the list. Default is "UNNUMBER"
    """

    class Meta:
        name = "LIST"

    item: list[Item] = field(
        default_factory=list,
        metadata={
            "name": "ITEM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )
    type_value: ListEnumSimple | None = field(
        default=None,
        metadata={
            "name": "TYPE",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class MachineTiming:
    """
    This meta-class represents the timing view for a machine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar timing_clocks: A list of abstract model Clocks.
    :ivar timing_clock_sync_accuracys: A list of accuracies - which may
        be used to specify synchronizations from one model clock to
        another model clock.
    :ivar timing_conditions: The timing condition specifies a specific
        condition.
    :ivar timing_descriptions: The timing descriptions that belong to a
        specific timing specification. In order to support different
        timing description variants within a timing specification, the
        aggregation is marked with the stereotype "atpVariation".
    :ivar timing_guarantees: The timing constraints that belong to a
        specific timing specification in the role of a timing guarantee.
        In order to support different timing constraint variants within
        a timing specification, the aggregation is marked with the
        stereotype "atpVariation".
    :ivar timing_requirements: The timing constraints that belong to a
        specific timing specification in the role of a timing
        requirement. In order to support different timing constraint
        variants within a timing specification, the aggregation is
        marked with the stereotype "atpVariation".
    :ivar timing_resource: The timing resource contains all instance
        references referred from within a timing condition formula of a
        timing view.
    :ivar machine_ref: This defines the scope of a MachineTiming. All
        corresponding timing descriptions and constraints shall be
        defined within this scope.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MACHINE-TIMING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["MachineTiming.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["MachineTiming.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clocks: Optional["MachineTiming.TimingClocks"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clock_sync_accuracys: Optional["MachineTiming.TimingClockSyncAccuracys"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCK-SYNC-ACCURACYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_conditions: Optional["MachineTiming.TimingConditions"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_descriptions: Optional["MachineTiming.TimingDescriptions"] = field(
        default=None,
        metadata={
            "name": "TIMING-DESCRIPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_guarantees: Optional["MachineTiming.TimingGuarantees"] = field(
        default=None,
        metadata={
            "name": "TIMING-GUARANTEES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_requirements: Optional["MachineTiming.TimingRequirements"] = field(
        default=None,
        metadata={
            "name": "TIMING-REQUIREMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_resource: TimingExtensionResource | None = field(
        default=None,
        metadata={
            "name": "TIMING-RESOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    machine_ref: Optional["MachineTiming.MachineRef"] = field(
        default=None,
        metadata={
            "name": "MACHINE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClocks:
        tdlet_zone_clock: list[TdletZoneClock] = field(
            default_factory=list,
            metadata={
                "name": "TDLET-ZONE-CLOCK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClockSyncAccuracys:
        timing_clock_sync_accuracy: list[TimingClockSyncAccuracy] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CLOCK-SYNC-ACCURACY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingConditions:
        timing_condition: list[TimingCondition] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingDescriptions:
        td_event_bsw_internal_behavior: list[TdEventBswInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_mode_declaration: list[TdEventBswModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_module: list[TdEventBswModule] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_complex: list[TdEventComplex] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-COMPLEX",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_fr_cluster_cycle_start: list[TdEventFrClusterCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FR-CLUSTER-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame: list[TdEventFrame] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame_ethernet: list[TdEventFrameEthernet] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME-ETHERNET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_pdu: list[TdEventIPdu] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_signal: list[TdEventISignal] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_mode_declaration: list[TdEventModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_operation: list[TdEventOperation] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-OPERATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_discovery: list[TdEventServiceInstanceDiscovery] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-DISCOVERY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_event: list[TdEventServiceInstanceEvent] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_field: list[TdEventServiceInstanceField] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-FIELD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_method: list[TdEventServiceInstanceMethod] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-METHOD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_sllet_port: list[TdEventSlletPort] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SLLET-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior: list[TdEventSwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior_reference: list[TdEventSwcInternalBehaviorReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_trigger: list[TdEventTrigger] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_tt_can_cycle_start: list[TdEventTtCanCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TT-CAN-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_variable_data_prototype: list[TdEventVariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_vfb_reference: list[TdEventVfbReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VFB-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        timing_description_event_chain: list[TimingDescriptionEventChain] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-DESCRIPTION-EVENT-CHAIN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingGuarantees:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingRequirements:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MachineRef(Ref):
        dest: MachineSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class NetworkEndpoint:
    """
    The network endpoint defines the network addressing (e.g. IP-Address or MAC
    multicast address).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar fully_qualified_domain_name: Defines the fully qualified
        domain name (FQDN) e.g. some.example.host.
    :ivar infrastructure_services: Defines the network infrastructure
        services provided or consumed.
    :ivar ip_sec_config: Optional IPSec configuration that provides
        security services for IP packets.
    :ivar network_endpoint_addresses: Definition of a Network Address.
    :ivar priority: Defines the frame priority where values from 0 (best
        effort) to 7 (highest) are allowed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NETWORK-ENDPOINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["NetworkEndpoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["NetworkEndpoint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fully_qualified_domain_name: String | None = field(
        default=None,
        metadata={
            "name": "FULLY-QUALIFIED-DOMAIN-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    infrastructure_services: InfrastructureServices | None = field(
        default=None,
        metadata={
            "name": "INFRASTRUCTURE-SERVICES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ip_sec_config: IpSecConfig | None = field(
        default=None,
        metadata={
            "name": "IP-SEC-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_endpoint_addresses: Optional["NetworkEndpoint.NetworkEndpointAddresses"] = field(
        default=None,
        metadata={
            "name": "NETWORK-ENDPOINT-ADDRESSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NetworkEndpointAddresses:
        ipv_4_configuration: list[Ipv4Configuration] = field(
            default_factory=list,
            metadata={
                "name": "IPV-4-CONFIGURATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ipv_6_configuration: list[Ipv6Configuration] = field(
            default_factory=list,
            metadata={
                "name": "IPV-6-CONFIGURATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mac_multicast_configuration: list[MacMulticastConfiguration] = field(
            default_factory=list,
            metadata={
                "name": "MAC-MULTICAST-CONFIGURATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class NumericalRuleBasedValueSpecification:
    """
    This meta-class is used to support a rule-based initialization approach for
    data types with an array-nature (ImplementationDataType of category ARRAY).

    :ivar short_label: This can be used to identify particular value
        specifications for human readers, for example elements of a
        record type.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ArrayValueSpecification.element Applicable for:
        RecordValueSpecification.field Not Applicable for:
        CompositeRuleBasedValueSpecification.argument Not Applicable
        for: ConstantSpecification.valueSpec Not Applicable for:
        PortPrototypeBlueprintInitValue.value Not Applicable for:
        DiagnosticEnvDataCondition.compareValue Not Applicable for:
        DiagnosticEnvDataElementCondition.compareValue Not Applicable
        for: ParameterDataPrototype.initValue Not Applicable for:
        VariableDataPrototype.initValue Not Applicable for:
        CalibrationParameterValue.applInitValue Not Applicable for:
        CalibrationParameterValue.implInitValue Not Applicable for:
        MetaDataItem.metaDataItemType Not Applicable for:
        NvProvideComSpec.romBlockInitValue Not Applicable for:
        NvProvideComSpec.ramBlockInitValue Not Applicable for:
        NvRequireComSpec.initValue Not Applicable for:
        ParameterProvideComSpec.initValue Not Applicable for:
        ParameterRequireComSpec.initValue Not Applicable for:
        NonqueuedSenderComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.timeoutSubstitutionValue Not Applicable
        for: PortDefinedArgumentValue.value Not Applicable for:
        CryptoServiceKey.developmentValue Not Applicable for:
        ISignal.timeoutSubstitutionValue Not Applicable for:
        ISignal.initValue Not Applicable for:
        FieldSenderComSpec.initValue Not Applicable for:
        PersistencyDataRequiredComSpec.initValue Not Applicable for:
        ApplicationAssocMapElementValueSpecification.value Not
        Applicable for: ApplicationAssocMapElementValueSpecification.key
        Not Applicable for: StateManagementCompareCondition.compareValue
        Not Applicable for: PersistencyKeyValuePair.initValue Not
        Applicable for: SwDataDefPropsContent.invalidValue
    :ivar rule_based_values: This represents the rule based value
        specification for the array.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rule_based_values: RuleBasedValueSpecification | None = field(
        default=None,
        metadata={
            "name": "RULE-BASED-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PhmRecoveryActionInterface:
    """
    This meta-class represents a PortInterface that can be taken for implementing a
    PHM recovery action on application software level.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar recovery: This aggregation represents the actual recovery
        action This aggregation contains a variation point although it
        is not variant. Therefore, this variation point shall not exist
        in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PHM-RECOVERY-ACTION-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PhmRecoveryActionInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PhmRecoveryActionInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["PhmRecoveryActionInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["PhmRecoveryActionInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    recovery: ClientServerOperation | None = field(
        default=None,
        metadata={
            "name": "RECOVERY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ProvidedServiceInstance:
    """
    Service instances that are provided by the ECU that is connected via the
    ApplicationEndpoint to a CommunicationConnector.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar capability_records: A sequence of records to store arbitrary
        name/value pairs conveying additional information about the
        named service.
    :ivar major_version: Major Version of the ServiceInterface. Value
        can be set to a number that represents the Major Version of the
        service.
    :ivar method_activation_routing_groups: The ServiceDiscovery module
        is able to activate and deactivate the PDU routing for
        ClientServerOperations (SOME/IP methods). The upper multiplicity
        of this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar routing_group_refs: The ServiceDiscovery module is able to
        activate and deactivate the PDU routing from and to TCP/IP-
        sockets.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ServiceInstanceCollectionSet.serviceInstance Not Applicable for:
        ApplicationEndpoint.providedServiceInstance Not Applicable for:
        ApplicationEndpoint.consumedServiceInstance
    :ivar auto_available: Defines that this ProvidedServiceInstance
        shall be offered by the service discovery at ECU start.
    :ivar event_handlers: Collection of event groups provided by the
        ProvidedServiceInstance
    :ivar instance_identifier: Instance identifier. Can be used for e.g.
        service discovery to identify the instance of the service.
    :ivar load_balancing_priority: Defines the value to be used for load
        balancing priority in the service offer. Lower value means
        higher priority.
    :ivar load_balancing_weight: Defines the value to be used for load
        balancing weight in the service offer. Higher value means higher
        probability to be chosen.
    :ivar local_unicast_addresss: The local address over which the PSI
        is provided (udp, tcp or both). This property was modified due
        to atpVariation (DirectedAssociationPattern).
    :ivar minor_version: Minor Version of the Service that is provided
        by this ProvidedServiceInstance.
    :ivar priority: Defines the frame priority where values from 0 (best
        effort) to 7 (highest) are allowed.
    :ivar remote_multicast_subscription_addresss: This reference defines
        the remote multicast subscribed addresses of service consumers.
        This reference shall ONLY be used if the remote address of the
        clients is determined from the configuration and not at runtime.
        This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar remote_unicast_addresss: This reference defines the remote
        addresses of service consumers. This reference shall ONLY be
        used if the remote address of the clients is determined from the
        configuration and not at runtime. This property was modified due
        to atpVariation (DirectedAssociationPattern).
    :ivar sd_server_config: Service Discovery Server configuration.
    :ivar sd_server_timer_configs: Server specific configuration
        settings relevant for the SOME/IP service discovery. This
        property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar service_identifier: This attribute represents the ability to
        describe the SOME/IP service ID that is offered.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROVIDED-SERVICE-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ProvidedServiceInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ProvidedServiceInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    capability_records: Optional["ProvidedServiceInstance.CapabilityRecords"] = field(
        default=None,
        metadata={
            "name": "CAPABILITY-RECORDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    major_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAJOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    method_activation_routing_groups: Optional[
        "ProvidedServiceInstance.MethodActivationRoutingGroups"
    ] = field(
        default=None,
        metadata={
            "name": "METHOD-ACTIVATION-ROUTING-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    routing_group_refs: Optional["ProvidedServiceInstance.RoutingGroupRefs"] = field(
        default=None,
        metadata={
            "name": "ROUTING-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    auto_available: Boolean | None = field(
        default=None,
        metadata={
            "name": "AUTO-AVAILABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    event_handlers: Optional["ProvidedServiceInstance.EventHandlers"] = field(
        default=None,
        metadata={
            "name": "EVENT-HANDLERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    instance_identifier: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INSTANCE-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    load_balancing_priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOAD-BALANCING-PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    load_balancing_weight: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LOAD-BALANCING-WEIGHT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    local_unicast_addresss: Optional["ProvidedServiceInstance.LocalUnicastAddresss"] = field(
        default=None,
        metadata={
            "name": "LOCAL-UNICAST-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minor_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_multicast_subscription_addresss: Optional[
        "ProvidedServiceInstance.RemoteMulticastSubscriptionAddresss"
    ] = field(
        default=None,
        metadata={
            "name": "REMOTE-MULTICAST-SUBSCRIPTION-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remote_unicast_addresss: Optional["ProvidedServiceInstance.RemoteUnicastAddresss"] = field(
        default=None,
        metadata={
            "name": "REMOTE-UNICAST-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sd_server_config: SdServerConfig | None = field(
        default=None,
        metadata={
            "name": "SD-SERVER-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sd_server_timer_configs: Optional["ProvidedServiceInstance.SdServerTimerConfigs"] = field(
        default=None,
        metadata={
            "name": "SD-SERVER-TIMER-CONFIGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_identifier: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SERVICE-IDENTIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CapabilityRecords:
        tag_with_optional_value: list[TagWithOptionalValue] = field(
            default_factory=list,
            metadata={
                "name": "TAG-WITH-OPTIONAL-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MethodActivationRoutingGroups:
        pdu_activation_routing_group: list[PduActivationRoutingGroup] = field(
            default_factory=list,
            metadata={
                "name": "PDU-ACTIVATION-ROUTING-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RoutingGroupRefs:
        routing_group_ref: list["ProvidedServiceInstance.RoutingGroupRefs.RoutingGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "ROUTING-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RoutingGroupRef(Ref):
            dest: SoAdRoutingGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class EventHandlers:
        event_handler: list[EventHandler] = field(
            default_factory=list,
            metadata={
                "name": "EVENT-HANDLER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LocalUnicastAddresss:
        application_endpoint_ref_conditional: list[ApplicationEndpointRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-ENDPOINT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RemoteMulticastSubscriptionAddresss:
        application_endpoint_ref_conditional: list[ApplicationEndpointRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-ENDPOINT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RemoteUnicastAddresss:
        application_endpoint_ref_conditional: list[ApplicationEndpointRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-ENDPOINT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SdServerTimerConfigs:
        someip_sd_server_service_instance_config_ref_conditional: list[
            SomeipSdServerServiceInstanceConfigRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-SD-SERVER-SERVICE-INSTANCE-CONFIG-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RapidPrototypingScenario:
    """This meta-class provides the ability to describe a Rapid Prototyping
    Scenario.

    Such a Rapid Prototyping Scenario consist out of two main aspects,
    the description of the byPassPoints and the relation to an rptHook.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar host_system_ref: System which describes the software
        components of the host ECU.
    :ivar rpt_containers: Top-level rptContainer definitions of this
        specific rapid prototyping scenario.
    :ivar rpt_profiles: Defiens the applicable Rapid Prototyping profils
        which are especially defining the smbol of the service functions
        and the valid id range. The order of the RptProfiles determines
        the order of the service function invocation by RTE.
    :ivar rpt_system_ref: System which describes the rapid prototyping
        algorithm in the format of AUTOSAR Software Components.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RAPID-PROTOTYPING-SCENARIO"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RapidPrototypingScenario.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RapidPrototypingScenario.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    host_system_ref: Optional["RapidPrototypingScenario.HostSystemRef"] = field(
        default=None,
        metadata={
            "name": "HOST-SYSTEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_containers: Optional["RapidPrototypingScenario.RptContainers"] = field(
        default=None,
        metadata={
            "name": "RPT-CONTAINERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_profiles: Optional["RapidPrototypingScenario.RptProfiles"] = field(
        default=None,
        metadata={
            "name": "RPT-PROFILES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_system_ref: Optional["RapidPrototypingScenario.RptSystemRef"] = field(
        default=None,
        metadata={
            "name": "RPT-SYSTEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HostSystemRef(Ref):
        dest: SystemSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RptContainers:
        rpt_container: list[RptContainer] = field(
            default_factory=list,
            metadata={
                "name": "RPT-CONTAINER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RptProfiles:
        rpt_profile: list[RptProfile] = field(
            default_factory=list,
            metadata={
                "name": "RPT-PROFILE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RptSystemRef(Ref):
        dest: SystemSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RptComponent:
    """
    Description of component instance for which rapid prototyping support is
    implemented.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar mc_data_assignments: Reference to related McDataElement
        describing the implementation of "RP global buffer", "RP global
        measurement buffer", "RP enabler flag" and the "RP runnable
        disabler flag". This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar rp_impl_policy: Describes the implemented code preparation for
        rapid prototyping at data accesses.
    :ivar rpt_executable_entitys: ExecutableEntity instance which can be
        bypassed.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        RptSupportData.rptComponent
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-COMPONENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RptComponent.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RptComponent.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_data_assignments: Optional["RptComponent.McDataAssignments"] = field(
        default=None,
        metadata={
            "name": "MC-DATA-ASSIGNMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rp_impl_policy: RptImplPolicy | None = field(
        default=None,
        metadata={
            "name": "RP-IMPL-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_executable_entitys: Optional["RptComponent.RptExecutableEntitys"] = field(
        default=None,
        metadata={
            "name": "RPT-EXECUTABLE-ENTITYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class McDataAssignments:
        role_based_mc_data_assignment: list[RoleBasedMcDataAssignment] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-MC-DATA-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RptExecutableEntitys:
        rpt_executable_entity: list[RptExecutableEntity] = field(
            default_factory=list,
            metadata={
                "name": "RPT-EXECUTABLE-ENTITY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RuleBasedAxisCont:
    """This represents the values for the axis of a compound primitive (curve,
    map).

    For standard and fix axes,  SwAxisCont contains the values of the
    axis directly. The axis values of SwAxisCont with the category
    COM_AXIS, RES_AXIS are for display only. For editing and processing,
    only the values in the related GroupAxis are binding.

    :ivar category: This category specifies the particular axis types: *
        STD_AXIS * COM_AXIS * RES_AXIS  (swArraysize necessary)
    :ivar unit_ref: This represents the physical unit of the provided
        values.
    :ivar sw_arraysize: For multidimensional compound primitives (curve,
        map ...) it is necessary to know the dimensions.They are
        specified using swArraySize.
    :ivar sw_axis_index: This property allows to explicitly assign the
        axis contents to a particular axis. It is specified by numbers
        where 1 corresponds to the x-axis. It is also possible to derive
        the axis association from the sequence of the parent.
    :ivar rule_based_values: This represents the rule based value
        specification for the axis of a compound primitive (curve, map).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RULE-BASED-AXIS-CONT"

    category: CalprmAxisCategoryEnum | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_ref: Optional["RuleBasedAxisCont.UnitRef"] = field(
        default=None,
        metadata={
            "name": "UNIT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_arraysize: ValueList | None = field(
        default=None,
        metadata={
            "name": "SW-ARRAYSIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_axis_index: AxisIndexType | None = field(
        default=None,
        metadata={
            "name": "SW-AXIS-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rule_based_values: RuleBasedValueSpecification | None = field(
        default=None,
        metadata={
            "name": "RULE-BASED-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class UnitRef(Ref):
        dest: UnitSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RuleBasedValueCont:
    """
    This represents the values of a compound primitive (CURVE, MAP, CUBOID, CUBE_4,
    CUBE_5, VAL_BLK) or an array.

    :ivar unit_ref: This represents the physical unit of the provided
        values.
    :ivar sw_arraysize: This attribute defines the size of each
        dimension for compound primitives CURVE, MAP, CUBOID, CUBE_4,
        CUBE_5, COM_AXIS, RES_AXIS, VAL_BLK. For each dimension one
        value has to be defined, e.g. one in case of COM_AXIS and two or
        more in case of MAP.
    :ivar rule_based_values: This represents the rule based value
        specification for the array or compound primitive (CURVE, MAP,
        CUBOID, CUBE_4, CUBE_5, VAL_BLK).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RULE-BASED-VALUE-CONT"

    unit_ref: Optional["RuleBasedValueCont.UnitRef"] = field(
        default=None,
        metadata={
            "name": "UNIT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_arraysize: ValueList | None = field(
        default=None,
        metadata={
            "name": "SW-ARRAYSIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rule_based_values: RuleBasedValueSpecification | None = field(
        default=None,
        metadata={
            "name": "RULE-BASED-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class UnitRef(Ref):
        dest: UnitSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ServiceTiming:
    """
    This meta-class represents the timing view for one or more service instances.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar timing_clocks: A list of abstract model Clocks.
    :ivar timing_clock_sync_accuracys: A list of accuracies - which may
        be used to specify synchronizations from one model clock to
        another model clock.
    :ivar timing_conditions: The timing condition specifies a specific
        condition.
    :ivar timing_descriptions: The timing descriptions that belong to a
        specific timing specification. In order to support different
        timing description variants within a timing specification, the
        aggregation is marked with the stereotype "atpVariation".
    :ivar timing_guarantees: The timing constraints that belong to a
        specific timing specification in the role of a timing guarantee.
        In order to support different timing constraint variants within
        a timing specification, the aggregation is marked with the
        stereotype "atpVariation".
    :ivar timing_requirements: The timing constraints that belong to a
        specific timing specification in the role of a timing
        requirement. In order to support different timing constraint
        variants within a timing specification, the aggregation is
        marked with the stereotype "atpVariation".
    :ivar timing_resource: The timing resource contains all instance
        references referred from within a timing condition formula of a
        timing view.
    :ivar service_instance_refs: This defines the scope of a
        ServiceTiming. All corresponding timing descriptions and
        constraints shall be defined within this scope.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-TIMING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ServiceTiming.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ServiceTiming.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clocks: Optional["ServiceTiming.TimingClocks"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clock_sync_accuracys: Optional["ServiceTiming.TimingClockSyncAccuracys"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCK-SYNC-ACCURACYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_conditions: Optional["ServiceTiming.TimingConditions"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_descriptions: Optional["ServiceTiming.TimingDescriptions"] = field(
        default=None,
        metadata={
            "name": "TIMING-DESCRIPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_guarantees: Optional["ServiceTiming.TimingGuarantees"] = field(
        default=None,
        metadata={
            "name": "TIMING-GUARANTEES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_requirements: Optional["ServiceTiming.TimingRequirements"] = field(
        default=None,
        metadata={
            "name": "TIMING-REQUIREMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_resource: TimingExtensionResource | None = field(
        default=None,
        metadata={
            "name": "TIMING-RESOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instance_refs: Optional["ServiceTiming.ServiceInstanceRefs"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClocks:
        tdlet_zone_clock: list[TdletZoneClock] = field(
            default_factory=list,
            metadata={
                "name": "TDLET-ZONE-CLOCK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClockSyncAccuracys:
        timing_clock_sync_accuracy: list[TimingClockSyncAccuracy] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CLOCK-SYNC-ACCURACY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingConditions:
        timing_condition: list[TimingCondition] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingDescriptions:
        td_event_bsw_internal_behavior: list[TdEventBswInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_mode_declaration: list[TdEventBswModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_module: list[TdEventBswModule] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_complex: list[TdEventComplex] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-COMPLEX",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_fr_cluster_cycle_start: list[TdEventFrClusterCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FR-CLUSTER-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame: list[TdEventFrame] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame_ethernet: list[TdEventFrameEthernet] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME-ETHERNET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_pdu: list[TdEventIPdu] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_signal: list[TdEventISignal] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_mode_declaration: list[TdEventModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_operation: list[TdEventOperation] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-OPERATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_discovery: list[TdEventServiceInstanceDiscovery] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-DISCOVERY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_event: list[TdEventServiceInstanceEvent] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_field: list[TdEventServiceInstanceField] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-FIELD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_method: list[TdEventServiceInstanceMethod] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-METHOD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_sllet_port: list[TdEventSlletPort] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SLLET-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior: list[TdEventSwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior_reference: list[TdEventSwcInternalBehaviorReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_trigger: list[TdEventTrigger] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_tt_can_cycle_start: list[TdEventTtCanCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TT-CAN-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_variable_data_prototype: list[TdEventVariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_vfb_reference: list[TdEventVfbReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VFB-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        timing_description_event_chain: list[TimingDescriptionEventChain] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-DESCRIPTION-EVENT-CHAIN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingGuarantees:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingRequirements:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstanceRefs:
        service_instance_ref: list["ServiceTiming.ServiceInstanceRefs.ServiceInstanceRef"] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ServiceInstanceRef(Ref):
            dest: AdaptivePlatformServiceInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class SignalServiceTranslationPropsSet:
    """
    Collection of SignalServiceTranslationProps.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar signal_service_translation_propss: Collection of
        SignalServiceTranslationProps.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SIGNAL-SERVICE-TRANSLATION-PROPS-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SignalServiceTranslationPropsSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SignalServiceTranslationPropsSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    signal_service_translation_propss: Optional[
        "SignalServiceTranslationPropsSet.SignalServiceTranslationPropss"
    ] = field(
        default=None,
        metadata={
            "name": "SIGNAL-SERVICE-TRANSLATION-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SignalServiceTranslationPropss:
        signal_service_translation_props: list[SignalServiceTranslationProps] = field(
            default_factory=list,
            metadata={
                "name": "SIGNAL-SERVICE-TRANSLATION-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StateDependentStartupConfig:
    """
    This meta-class defines the startup configuration for the process depending on
    a collection of machine states.

    :ivar execution_dependencys: This attribute defines that all
        processes that are referenced via the ExecutionDependency shall
        be launched and shall reach a certain ProcessState before the
        referencing process is started.
    :ivar function_group_state_irefs: This represent the applicable
        functionGroupMode.
    :ivar resource_consumption: This aggregation provides the ability to
        define resource consumption boundaries on a per-process-startup-
        config basis.
    :ivar resource_group_ref: Reference to an applicable resource group.
    :ivar startup_config_ref: Reference to a reusable startup
        configuration with startup parameters.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-DEPENDENT-STARTUP-CONFIG"

    execution_dependencys: Optional["StateDependentStartupConfig.ExecutionDependencys"] = field(
        default=None,
        metadata={
            "name": "EXECUTION-DEPENDENCYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    function_group_state_irefs: Optional["StateDependentStartupConfig.FunctionGroupStateIrefs"] = (
        field(
            default=None,
            metadata={
                "name": "FUNCTION-GROUP-STATE-IREFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    resource_consumption: ResourceConsumption | None = field(
        default=None,
        metadata={
            "name": "RESOURCE-CONSUMPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resource_group_ref: Optional["StateDependentStartupConfig.ResourceGroupRef"] = field(
        default=None,
        metadata={
            "name": "RESOURCE-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    startup_config_ref: Optional["StateDependentStartupConfig.StartupConfigRef"] = field(
        default=None,
        metadata={
            "name": "STARTUP-CONFIG-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ExecutionDependencys:
        execution_dependency: list[ExecutionDependency] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-DEPENDENCY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FunctionGroupStateIrefs:
        function_group_state_iref: list[FunctionGroupStateInFunctionGroupSetInstanceRef] = field(
            default_factory=list,
            metadata={
                "name": "FUNCTION-GROUP-STATE-IREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ResourceGroupRef(Ref):
        dest: ResourceGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class StartupConfigRef(Ref):
        dest: StartupConfigSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwAxisCont:
    """This represents the values for the axis of a compound primitive (curve,
    map).

    For standard and fix axes,  SwAxisCont contains the values of the
    axis directly. The axis values of SwAxisCont with the category
    COM_AXIS, RES_AXIS are for display only. For editing and processing,
    only the values in the related GroupAxis are binding.

    :ivar category: This category specifies the particular axis types: *
        STD_AXIS * COM_AXIS * RES_AXIS  (swArraysize necessary)
    :ivar unit_ref: This represents the physical unit of the provided
        values.
    :ivar unit_display_name: This represents the display name which is
        used for the physical unit of the axis.
    :ivar sw_axis_index: This property allows to explicitly assign the
        axis contents to a particular axis. It is specified by numbers
        where 1 corresponds to the x-axis. It is also possible to derive
        the axis association from the sequence of the parent.
    :ivar sw_arraysize: For multidimensional compound primitivies
        (curve, map ...) it is necessary to know the dimensions.They are
        specified using swArraySize. * RES_AXIS
    :ivar sw_values_phys: swValuesPhys represents the values in the
        physical domain.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-AXIS-CONT"

    category: CalprmAxisCategoryEnum | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_ref: Optional["SwAxisCont.UnitRef"] = field(
        default=None,
        metadata={
            "name": "UNIT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_display_name: SingleLanguageUnitNames | None = field(
        default=None,
        metadata={
            "name": "UNIT-DISPLAY-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_axis_index: AxisIndexType | None = field(
        default=None,
        metadata={
            "name": "SW-AXIS-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_arraysize: ValueList | None = field(
        default=None,
        metadata={
            "name": "SW-ARRAYSIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_values_phys: SwValues | None = field(
        default=None,
        metadata={
            "name": "SW-VALUES-PHYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class UnitRef(Ref):
        dest: UnitSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwValueCont:
    """
    This metaclass represents the content of one particular SwInstance.

    :ivar unit_ref: This represents the physical unit of the provided
        values.
    :ivar unit_display_name: This specifies how the physical units of
        the current value set shall be displayed in documents or in user
        interfaces of tools.
    :ivar sw_arraysize: This attribute defines the size of each
        dimension for compound primitives CURVE, MAP, CUBOID, CUBE_4,
        CUBE_5, COM_AXIS, RES_AXIS, VAL_BLK. For each dimension one
        value has to be defined, e.g. one in case of COM_AXIS and two or
        more in case of MAP.
    :ivar sw_values_phys: swValuesPhys represents the values in the
        physical domain.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-VALUE-CONT"

    unit_ref: Optional["SwValueCont.UnitRef"] = field(
        default=None,
        metadata={
            "name": "UNIT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_display_name: SingleLanguageUnitNames | None = field(
        default=None,
        metadata={
            "name": "UNIT-DISPLAY-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_arraysize: ValueList | None = field(
        default=None,
        metadata={
            "name": "SW-ARRAYSIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_values_phys: SwValues | None = field(
        default=None,
        metadata={
            "name": "SW-VALUES-PHYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class UnitRef(Ref):
        dest: UnitSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SwcServiceDependency:
    """Specialization of ServiceDependency in the context of an
    SwcInternalBehavior.

    It allows to associate ports, port groups and (in special cases)
    data defined for an atomic software component  to a given
    ServiceNeeds element.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar assigned_data_types: This is the role of the assignment data
        type in the given context. The upper multiplicity of this role
        has been increased to * due to resolving an atpVariation
        stereotype. The previous value was 1.
    :ivar diagnostic_relevance: If this attribute indicates a relevance
        for diagnostics then the integrator has a much easier time
        identifying the candidates for the configuration of the
        diagnostic stack. Example: identification of mode conditions
        (e.g. communication between application and BswM) relevant for
        the Dcm.
    :ivar symbolic_name_props: This attribute can be taken to contribute
        to the creation of symbolic name values.
    :ivar assigned_datas: Defines the role of an associated data object
        of the same component.
    :ivar assigned_ports: Defines the role of an associated port of the
        same component.
    :ivar represented_port_group_ref: This reference specifies an
        association between the ServiceNeeeds and a PortGroup, for
        example to request a communication mode which applies for
        communication via these ports. The referred PortGroup shall be
        local to this atomic SWC, but via the links between the
        PortGroups, a tool can evaluate this information such that all
        the ports linked via this port group on the same ECU can be
        found.
    :ivar service_needs: The associated ServiceNeeds.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.serviceDependency Not Applicable for:
        AdaptiveSwcInternalBehavior.serviceDependency
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-SERVICE-DEPENDENCY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwcServiceDependency.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwcServiceDependency.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_data_types: Optional["SwcServiceDependency.AssignedDataTypes"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-DATA-TYPES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_relevance: ServiceDiagnosticRelevanceEnum | None = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-RELEVANCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbolic_name_props: SymbolicNameProps | None = field(
        default=None,
        metadata={
            "name": "SYMBOLIC-NAME-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_datas: Optional["SwcServiceDependency.AssignedDatas"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-DATAS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assigned_ports: Optional["SwcServiceDependency.AssignedPorts"] = field(
        default=None,
        metadata={
            "name": "ASSIGNED-PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    represented_port_group_ref: Optional["SwcServiceDependency.RepresentedPortGroupRef"] = field(
        default=None,
        metadata={
            "name": "REPRESENTED-PORT-GROUP-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_needs: Optional["SwcServiceDependency.ServiceNeeds"] = field(
        default=None,
        metadata={
            "name": "SERVICE-NEEDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AssignedDataTypes:
        role_based_data_type_assignment: list[RoleBasedDataTypeAssignment] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-DATA-TYPE-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AssignedDatas:
        role_based_data_assignment: list[RoleBasedDataAssignment] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-DATA-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AssignedPorts:
        role_based_port_assignment: list[RoleBasedPortAssignment] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-PORT-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RepresentedPortGroupRef(Ref):
        dest: PortGroupSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceNeeds:
        bsw_mgr_needs: BswMgrNeeds | None = field(
            default=None,
            metadata={
                "name": "BSW-MGR-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_mgr_user_needs: ComMgrUserNeeds | None = field(
            default=None,
            metadata={
                "name": "COM-MGR-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_certificate_key_slot_needs: CryptoCertificateKeySlotNeeds | None = field(
            default=None,
            metadata={
                "name": "CRYPTO-CERTIFICATE-KEY-SLOT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_key_management_needs: CryptoKeyManagementNeeds | None = field(
            default=None,
            metadata={
                "name": "CRYPTO-KEY-MANAGEMENT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_service_job_needs: CryptoServiceJobNeeds | None = field(
            default=None,
            metadata={
                "name": "CRYPTO-SERVICE-JOB-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_service_needs: CryptoServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "CRYPTO-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_clear_condition_needs: DiagnosticClearConditionNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-CLEAR-CONDITION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_communication_manager_needs: DiagnosticCommunicationManagerNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-COMMUNICATION-MANAGER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_component_needs: DiagnosticComponentNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-COMPONENT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_control_needs: DiagnosticControlNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-CONTROL-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_enable_condition_needs: DiagnosticEnableConditionNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-ENABLE-CONDITION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_info_needs: DiagnosticEventInfoNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-EVENT-INFO-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_manager_needs: DiagnosticEventManagerNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-EVENT-MANAGER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_needs: DiagnosticEventNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-EVENT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_generic_uds_needs: DiagnosticGenericUdsNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-GENERIC-UDS-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_indicator_needs: DiagnosticIndicatorNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-INDICATOR-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_io_control_needs: DiagnosticIoControlNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-IO-CONTROL-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_operation_cycle_needs: DiagnosticOperationCycleNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-OPERATION-CYCLE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_file_transfer_needs: DiagnosticRequestFileTransferNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-FILE-TRANSFER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_response_on_event_needs: DiagnosticResponseOnEventNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-RESPONSE-ON-EVENT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_routine_needs: DiagnosticRoutineNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-ROUTINE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_storage_condition_needs: DiagnosticStorageConditionNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-STORAGE-CONDITION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_upload_download_needs: DiagnosticUploadDownloadNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-UPLOAD-DOWNLOAD-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_value_needs: DiagnosticValueNeeds | None = field(
            default=None,
            metadata={
                "name": "DIAGNOSTIC-VALUE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostics_communication_security_needs: DiagnosticsCommunicationSecurityNeeds | None = (
            field(
                default=None,
                metadata={
                    "name": "DIAGNOSTICS-COMMUNICATION-SECURITY-NEEDS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        dlt_user_needs: DltUserNeeds | None = field(
            default=None,
            metadata={
                "name": "DLT-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_activation_line_needs: DoIpActivationLineNeeds | None = field(
            default=None,
            metadata={
                "name": "DO-IP-ACTIVATION-LINE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_gid_needs: DoIpGidNeeds | None = field(
            default=None,
            metadata={
                "name": "DO-IP-GID-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_gid_synchronization_needs: DoIpGidSynchronizationNeeds | None = field(
            default=None,
            metadata={
                "name": "DO-IP-GID-SYNCHRONIZATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_power_mode_status_needs: DoIpPowerModeStatusNeeds | None = field(
            default=None,
            metadata={
                "name": "DO-IP-POWER-MODE-STATUS-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_routing_activation_authentication_needs: (
            DoIpRoutingActivationAuthenticationNeeds | None
        ) = field(
            default=None,
            metadata={
                "name": "DO-IP-ROUTING-ACTIVATION-AUTHENTICATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_routing_activation_confirmation_needs: (
            DoIpRoutingActivationConfirmationNeeds | None
        ) = field(
            default=None,
            metadata={
                "name": "DO-IP-ROUTING-ACTIVATION-CONFIRMATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dtc_status_change_notification_needs: DtcStatusChangeNotificationNeeds | None = field(
            default=None,
            metadata={
                "name": "DTC-STATUS-CHANGE-NOTIFICATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecu_state_mgr_user_needs: EcuStateMgrUserNeeds | None = field(
            default=None,
            metadata={
                "name": "ECU-STATE-MGR-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        error_tracer_needs: ErrorTracerNeeds | None = field(
            default=None,
            metadata={
                "name": "ERROR-TRACER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        function_inhibition_availability_needs: FunctionInhibitionAvailabilityNeeds | None = field(
            default=None,
            metadata={
                "name": "FUNCTION-INHIBITION-AVAILABILITY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        function_inhibition_needs: FunctionInhibitionNeeds | None = field(
            default=None,
            metadata={
                "name": "FUNCTION-INHIBITION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        further_action_byte_needs: FurtherActionByteNeeds | None = field(
            default=None,
            metadata={
                "name": "FURTHER-ACTION-BYTE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        global_supervision_needs: GlobalSupervisionNeeds | None = field(
            default=None,
            metadata={
                "name": "GLOBAL-SUPERVISION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        hardware_test_needs: HardwareTestNeeds | None = field(
            default=None,
            metadata={
                "name": "HARDWARE-TEST-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ids_mgr_custom_timestamp_needs: IdsMgrCustomTimestampNeeds | None = field(
            default=None,
            metadata={
                "name": "IDS-MGR-CUSTOM-TIMESTAMP-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ids_mgr_needs: IdsMgrNeeds | None = field(
            default=None,
            metadata={
                "name": "IDS-MGR-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        indicator_status_needs: IndicatorStatusNeeds | None = field(
            default=None,
            metadata={
                "name": "INDICATOR-STATUS-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_dcm_dm_19_support: J1939DcmDm19Support | None = field(
            default=None,
            metadata={
                "name": "J-1939-DCM-DM-19-SUPPORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_rm_incoming_request_service_needs: J1939RmIncomingRequestServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "J-1939-RM-INCOMING-REQUEST-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_rm_outgoing_request_service_needs: J1939RmOutgoingRequestServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "J-1939-RM-OUTGOING-REQUEST-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nv_block_needs: NvBlockNeeds | None = field(
            default=None,
            metadata={
                "name": "NV-BLOCK-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_control_service_needs: ObdControlServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "OBD-CONTROL-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_info_service_needs: ObdInfoServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "OBD-INFO-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_monitor_service_needs: ObdMonitorServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "OBD-MONITOR-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_pid_service_needs: ObdPidServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "OBD-PID-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_ratio_denominator_needs: ObdRatioDenominatorNeeds | None = field(
            default=None,
            metadata={
                "name": "OBD-RATIO-DENOMINATOR-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        obd_ratio_service_needs: ObdRatioServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "OBD-RATIO-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        secure_on_board_communication_needs: SecureOnBoardCommunicationNeeds | None = field(
            default=None,
            metadata={
                "name": "SECURE-ON-BOARD-COMMUNICATION-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        supervised_entity_checkpoint_needs: SupervisedEntityCheckpointNeeds | None = field(
            default=None,
            metadata={
                "name": "SUPERVISED-ENTITY-CHECKPOINT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        supervised_entity_needs: SupervisedEntityNeeds | None = field(
            default=None,
            metadata={
                "name": "SUPERVISED-ENTITY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sync_time_base_mgr_user_needs: SyncTimeBaseMgrUserNeeds | None = field(
            default=None,
            metadata={
                "name": "SYNC-TIME-BASE-MGR-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        v_2_x_data_manager_needs: V2XDataManagerNeeds | None = field(
            default=None,
            metadata={
                "name": "V-2-X-DATA-MANAGER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        v_2_x_fac_user_needs: V2XFacUserNeeds | None = field(
            default=None,
            metadata={
                "name": "V-2-X-FAC-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        v_2_x_m_user_needs: V2XMUserNeeds | None = field(
            default=None,
            metadata={
                "name": "V-2-X-M-USER-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        vendor_specific_service_needs: VendorSpecificServiceNeeds | None = field(
            default=None,
            metadata={
                "name": "VENDOR-SPECIFIC-SERVICE-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        warning_indicator_requested_bit_needs: WarningIndicatorRequestedBitNeeds | None = field(
            default=None,
            metadata={
                "name": "WARNING-INDICATOR-REQUESTED-BIT-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwcTiming:
    """The SwcTiming is used to describe the timing of an atomic software
    component.

    TimingDescriptions aggregated by SwcTiming are restricted to event
    chains referring to events which are derived from the classes
    TDEventVfb and TDEventSwcInternalBehavior.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar timing_clocks: A list of abstract model Clocks.
    :ivar timing_clock_sync_accuracys: A list of accuracies - which may
        be used to specify synchronizations from one model clock to
        another model clock.
    :ivar timing_conditions: The timing condition specifies a specific
        condition.
    :ivar timing_descriptions: The timing descriptions that belong to a
        specific timing specification. In order to support different
        timing description variants within a timing specification, the
        aggregation is marked with the stereotype "atpVariation".
    :ivar timing_guarantees: The timing constraints that belong to a
        specific timing specification in the role of a timing guarantee.
        In order to support different timing constraint variants within
        a timing specification, the aggregation is marked with the
        stereotype "atpVariation".
    :ivar timing_requirements: The timing constraints that belong to a
        specific timing specification in the role of a timing
        requirement. In order to support different timing constraint
        variants within a timing specification, the aggregation is
        marked with the stereotype "atpVariation".
    :ivar timing_resource: The timing resource contains all instance
        references referred from within a timing condition formula of a
        timing view.
    :ivar behavior_ref: This defines the scope of a SwcTiming. All
        corresponding timing descriptions and constraints shall be
        defined within this scope. Note! The reason for the cardinality
        of 0..1 is to ensure backward compatibility.
    :ivar component_ref: Removed. This association between SwcTiming and
        SwComponentType shall not be used to specify the scope of the
        SwcTiming. It is mandatory to use the association between
        SwcTiming and SwcInternalBehavior instead.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-TIMING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwcTiming.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwcTiming.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clocks: Optional["SwcTiming.TimingClocks"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clock_sync_accuracys: Optional["SwcTiming.TimingClockSyncAccuracys"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCK-SYNC-ACCURACYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_conditions: Optional["SwcTiming.TimingConditions"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_descriptions: Optional["SwcTiming.TimingDescriptions"] = field(
        default=None,
        metadata={
            "name": "TIMING-DESCRIPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_guarantees: Optional["SwcTiming.TimingGuarantees"] = field(
        default=None,
        metadata={
            "name": "TIMING-GUARANTEES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_requirements: Optional["SwcTiming.TimingRequirements"] = field(
        default=None,
        metadata={
            "name": "TIMING-REQUIREMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_resource: TimingExtensionResource | None = field(
        default=None,
        metadata={
            "name": "TIMING-RESOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    behavior_ref: Optional["SwcTiming.BehaviorRef"] = field(
        default=None,
        metadata={
            "name": "BEHAVIOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_ref: Optional["SwcTiming.ComponentRef"] = field(
        default=None,
        metadata={
            "name": "COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClocks:
        tdlet_zone_clock: list[TdletZoneClock] = field(
            default_factory=list,
            metadata={
                "name": "TDLET-ZONE-CLOCK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClockSyncAccuracys:
        timing_clock_sync_accuracy: list[TimingClockSyncAccuracy] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CLOCK-SYNC-ACCURACY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingConditions:
        timing_condition: list[TimingCondition] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingDescriptions:
        td_event_bsw_internal_behavior: list[TdEventBswInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_mode_declaration: list[TdEventBswModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_module: list[TdEventBswModule] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_complex: list[TdEventComplex] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-COMPLEX",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_fr_cluster_cycle_start: list[TdEventFrClusterCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FR-CLUSTER-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame: list[TdEventFrame] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame_ethernet: list[TdEventFrameEthernet] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME-ETHERNET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_pdu: list[TdEventIPdu] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_signal: list[TdEventISignal] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_mode_declaration: list[TdEventModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_operation: list[TdEventOperation] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-OPERATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_discovery: list[TdEventServiceInstanceDiscovery] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-DISCOVERY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_event: list[TdEventServiceInstanceEvent] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_field: list[TdEventServiceInstanceField] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-FIELD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_method: list[TdEventServiceInstanceMethod] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-METHOD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_sllet_port: list[TdEventSlletPort] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SLLET-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior: list[TdEventSwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior_reference: list[TdEventSwcInternalBehaviorReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_trigger: list[TdEventTrigger] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_tt_can_cycle_start: list[TdEventTtCanCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TT-CAN-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_variable_data_prototype: list[TdEventVariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_vfb_reference: list[TdEventVfbReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VFB-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        timing_description_event_chain: list[TimingDescriptionEventChain] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-DESCRIPTION-EVENT-CHAIN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingGuarantees:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingRequirements:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BehaviorRef(Ref):
        dest: SwcInternalBehaviorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ComponentRef(Ref):
        dest: SwComponentTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SystemTiming:
    """A model element used to refine timing descriptions and constraints (from a
    VfbTiming) at System level, utilizing information about topology, software
    deployment, and signal mapping described in the System Template.

    TimingDescriptions aggregated by SystemTiming are restricted to
    events which are derived from the class TDEventVfb,
    TDEventSwcInternalBehavior and TDEventCom.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar timing_clocks: A list of abstract model Clocks.
    :ivar timing_clock_sync_accuracys: A list of accuracies - which may
        be used to specify synchronizations from one model clock to
        another model clock.
    :ivar timing_conditions: The timing condition specifies a specific
        condition.
    :ivar timing_descriptions: The timing descriptions that belong to a
        specific timing specification. In order to support different
        timing description variants within a timing specification, the
        aggregation is marked with the stereotype "atpVariation".
    :ivar timing_guarantees: The timing constraints that belong to a
        specific timing specification in the role of a timing guarantee.
        In order to support different timing constraint variants within
        a timing specification, the aggregation is marked with the
        stereotype "atpVariation".
    :ivar timing_requirements: The timing constraints that belong to a
        specific timing specification in the role of a timing
        requirement. In order to support different timing constraint
        variants within a timing specification, the aggregation is
        marked with the stereotype "atpVariation".
    :ivar timing_resource: The timing resource contains all instance
        references referred from within a timing condition formula of a
        timing view.
    :ivar system_ref: This defines the scope of a SystemTiming. All
        corresponding timing descriptions and constraints shall be
        defined within this scope.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYSTEM-TIMING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SystemTiming.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SystemTiming.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clocks: Optional["SystemTiming.TimingClocks"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clock_sync_accuracys: Optional["SystemTiming.TimingClockSyncAccuracys"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCK-SYNC-ACCURACYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_conditions: Optional["SystemTiming.TimingConditions"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_descriptions: Optional["SystemTiming.TimingDescriptions"] = field(
        default=None,
        metadata={
            "name": "TIMING-DESCRIPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_guarantees: Optional["SystemTiming.TimingGuarantees"] = field(
        default=None,
        metadata={
            "name": "TIMING-GUARANTEES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_requirements: Optional["SystemTiming.TimingRequirements"] = field(
        default=None,
        metadata={
            "name": "TIMING-REQUIREMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_resource: TimingExtensionResource | None = field(
        default=None,
        metadata={
            "name": "TIMING-RESOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_ref: Optional["SystemTiming.SystemRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClocks:
        tdlet_zone_clock: list[TdletZoneClock] = field(
            default_factory=list,
            metadata={
                "name": "TDLET-ZONE-CLOCK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClockSyncAccuracys:
        timing_clock_sync_accuracy: list[TimingClockSyncAccuracy] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CLOCK-SYNC-ACCURACY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingConditions:
        timing_condition: list[TimingCondition] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingDescriptions:
        td_event_bsw_internal_behavior: list[TdEventBswInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_mode_declaration: list[TdEventBswModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_module: list[TdEventBswModule] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_complex: list[TdEventComplex] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-COMPLEX",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_fr_cluster_cycle_start: list[TdEventFrClusterCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FR-CLUSTER-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame: list[TdEventFrame] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame_ethernet: list[TdEventFrameEthernet] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME-ETHERNET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_pdu: list[TdEventIPdu] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_signal: list[TdEventISignal] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_mode_declaration: list[TdEventModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_operation: list[TdEventOperation] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-OPERATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_discovery: list[TdEventServiceInstanceDiscovery] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-DISCOVERY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_event: list[TdEventServiceInstanceEvent] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_field: list[TdEventServiceInstanceField] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-FIELD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_method: list[TdEventServiceInstanceMethod] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-METHOD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_sllet_port: list[TdEventSlletPort] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SLLET-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior: list[TdEventSwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior_reference: list[TdEventSwcInternalBehaviorReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_trigger: list[TdEventTrigger] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_tt_can_cycle_start: list[TdEventTtCanCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TT-CAN-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_variable_data_prototype: list[TdEventVariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_vfb_reference: list[TdEventVfbReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VFB-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        timing_description_event_chain: list[TimingDescriptionEventChain] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-DESCRIPTION-EVENT-CHAIN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingGuarantees:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingRequirements:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SystemRef(Ref):
        dest: SystemSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class VariableAndParameterInterfaceMapping:
    """
    Defines the mapping of VariableDataPrototypes or ParameterDataPrototypes in
    context of two different SenderReceiverInterfaces, NvDataInterfaces or
    ParameterInterfaces.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        PortInterfaceMappingSet.portInterfaceMapping
    :ivar data_mappings: Defines the mapping of two particular
        VariableDataPrototypes or ParameterDataPrototypes with unequal
        names and/or unequal semantic (resolution or range) in context
        of two different SenderReceiverInterfaces, NvDataInterfaces or
        ParameterInterfaces
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VARIABLE-AND-PARAMETER-INTERFACE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["VariableAndParameterInterfaceMapping.ShortNameFragments"] = (
        field(
            default=None,
            metadata={
                "name": "SHORT-NAME-FRAGMENTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["VariableAndParameterInterfaceMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["VariableAndParameterInterfaceMapping.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_mappings: Optional["VariableAndParameterInterfaceMapping.DataMappings"] = field(
        default=None,
        metadata={
            "name": "DATA-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataMappings:
        data_prototype_mapping: list[DataPrototypeMapping] = field(
            default_factory=list,
            metadata={
                "name": "DATA-PROTOTYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class VehiclePackage:
    """
    This meta-class represents the ability to define a vehicle package for
    executing an update campaign.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar driver_notifications: This aggregation provides the ability to
        configure the necessary driver notifications.
    :ivar estimated_duration_of_campaign: This attribute provides an
        estimation about how long the campaign based on the
        VehiclePackage is going to take.
    :ivar minimum_supported_ucm_master_version: This attribute
        identifies the minimum supported version of the UCM Master for
        this VehiclePackage.
    :ivar packager_signature_ref: This reference identifies the
        certificate that represents the packager's signature.
    :ivar repository: This attribute identifies the repository where the
        VehiclePackage is stored.
    :ivar rollout_qualifications: This represents the rollout
        qualification.
    :ivar ucms: This aggregation represents the UcmDescriptions to be
        considered in the context of the VehiclePackage.
    :ivar ucm_master_fallback_refs: This reference lists the fallback
        order of Ucms that can take over the master role if the master
        goes down.
    :ivar vehicle_description_ref: This reference identifies the vehicle
        description.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VEHICLE-PACKAGE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["VehiclePackage.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["VehiclePackage.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    driver_notifications: Optional["VehiclePackage.DriverNotifications"] = field(
        default=None,
        metadata={
            "name": "DRIVER-NOTIFICATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    estimated_duration_of_campaign: TimeValue | None = field(
        default=None,
        metadata={
            "name": "ESTIMATED-DURATION-OF-CAMPAIGN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_supported_ucm_master_version: RevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-SUPPORTED-UCM-MASTER-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    packager_signature_ref: Optional["VehiclePackage.PackagerSignatureRef"] = field(
        default=None,
        metadata={
            "name": "PACKAGER-SIGNATURE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    repository: UriString | None = field(
        default=None,
        metadata={
            "name": "REPOSITORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rollout_qualifications: Optional["VehiclePackage.RolloutQualifications"] = field(
        default=None,
        metadata={
            "name": "ROLLOUT-QUALIFICATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ucms: Optional["VehiclePackage.Ucms"] = field(
        default=None,
        metadata={
            "name": "UCMS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ucm_master_fallback_refs: Optional["VehiclePackage.UcmMasterFallbackRefs"] = field(
        default=None,
        metadata={
            "name": "UCM-MASTER-FALLBACK-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vehicle_description_ref: Optional["VehiclePackage.VehicleDescriptionRef"] = field(
        default=None,
        metadata={
            "name": "VEHICLE-DESCRIPTION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DriverNotifications:
        vehicle_driver_notification: list[VehicleDriverNotification] = field(
            default_factory=list,
            metadata={
                "name": "VEHICLE-DRIVER-NOTIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PackagerSignatureRef(Ref):
        dest: CryptoServiceCertificateSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class RolloutQualifications:
        vehicle_rollout_step: list[VehicleRolloutStep] = field(
            default_factory=list,
            metadata={
                "name": "VEHICLE-ROLLOUT-STEP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Ucms:
        ucm_description: list[UcmDescription] = field(
            default_factory=list,
            metadata={
                "name": "UCM-DESCRIPTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class UcmMasterFallbackRefs:
        ucm_master_fallback_ref: list[
            "VehiclePackage.UcmMasterFallbackRefs.UcmMasterFallbackRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "UCM-MASTER-FALLBACK-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class UcmMasterFallbackRef(Ref):
            dest: UcmDescriptionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class VehicleDescriptionRef(Ref):
        dest: DocumentationSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class VfbTiming:
    """A model element used to define timing descriptions and constraints at VFB
    level.

    TimingDescriptions aggregated by VfbTiming are restricted to event
    chains referring to events which are derived from the class
    TDEventVfb.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar timing_clocks: A list of abstract model Clocks.
    :ivar timing_clock_sync_accuracys: A list of accuracies - which may
        be used to specify synchronizations from one model clock to
        another model clock.
    :ivar timing_conditions: The timing condition specifies a specific
        condition.
    :ivar timing_descriptions: The timing descriptions that belong to a
        specific timing specification. In order to support different
        timing description variants within a timing specification, the
        aggregation is marked with the stereotype "atpVariation".
    :ivar timing_guarantees: The timing constraints that belong to a
        specific timing specification in the role of a timing guarantee.
        In order to support different timing constraint variants within
        a timing specification, the aggregation is marked with the
        stereotype "atpVariation".
    :ivar timing_requirements: The timing constraints that belong to a
        specific timing specification in the role of a timing
        requirement. In order to support different timing constraint
        variants within a timing specification, the aggregation is
        marked with the stereotype "atpVariation".
    :ivar timing_resource: The timing resource contains all instance
        references referred from within a timing condition formula of a
        timing view.
    :ivar component_ref: This defines the scope of a VfbTiming. All
        corresponding timing descriptions and constraints shall be
        defined within this scope.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VFB-TIMING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["VfbTiming.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["VfbTiming.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["VfbTiming.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clocks: Optional["VfbTiming.TimingClocks"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_clock_sync_accuracys: Optional["VfbTiming.TimingClockSyncAccuracys"] = field(
        default=None,
        metadata={
            "name": "TIMING-CLOCK-SYNC-ACCURACYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_conditions: Optional["VfbTiming.TimingConditions"] = field(
        default=None,
        metadata={
            "name": "TIMING-CONDITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_descriptions: Optional["VfbTiming.TimingDescriptions"] = field(
        default=None,
        metadata={
            "name": "TIMING-DESCRIPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_guarantees: Optional["VfbTiming.TimingGuarantees"] = field(
        default=None,
        metadata={
            "name": "TIMING-GUARANTEES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_requirements: Optional["VfbTiming.TimingRequirements"] = field(
        default=None,
        metadata={
            "name": "TIMING-REQUIREMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_resource: TimingExtensionResource | None = field(
        default=None,
        metadata={
            "name": "TIMING-RESOURCE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    component_ref: Optional["VfbTiming.ComponentRef"] = field(
        default=None,
        metadata={
            "name": "COMPONENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClocks:
        tdlet_zone_clock: list[TdletZoneClock] = field(
            default_factory=list,
            metadata={
                "name": "TDLET-ZONE-CLOCK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingClockSyncAccuracys:
        timing_clock_sync_accuracy: list[TimingClockSyncAccuracy] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CLOCK-SYNC-ACCURACY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingConditions:
        timing_condition: list[TimingCondition] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingDescriptions:
        td_event_bsw_internal_behavior: list[TdEventBswInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_mode_declaration: list[TdEventBswModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_bsw_module: list[TdEventBswModule] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-BSW-MODULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_complex: list[TdEventComplex] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-COMPLEX",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_fr_cluster_cycle_start: list[TdEventFrClusterCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FR-CLUSTER-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame: list[TdEventFrame] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_frame_ethernet: list[TdEventFrameEthernet] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-FRAME-ETHERNET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_pdu: list[TdEventIPdu] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_i_signal: list[TdEventISignal] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-I-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_mode_declaration: list[TdEventModeDeclaration] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-MODE-DECLARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_operation: list[TdEventOperation] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-OPERATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_discovery: list[TdEventServiceInstanceDiscovery] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-DISCOVERY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_event: list[TdEventServiceInstanceEvent] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_field: list[TdEventServiceInstanceField] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-FIELD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_service_instance_method: list[TdEventServiceInstanceMethod] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SERVICE-INSTANCE-METHOD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_sllet_port: list[TdEventSlletPort] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SLLET-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior: list[TdEventSwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_swc_internal_behavior_reference: list[TdEventSwcInternalBehaviorReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-SWC-INTERNAL-BEHAVIOR-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_trigger: list[TdEventTrigger] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_tt_can_cycle_start: list[TdEventTtCanCycleStart] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-TT-CAN-CYCLE-START",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_variable_data_prototype: list[TdEventVariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_event_vfb_reference: list[TdEventVfbReference] = field(
            default_factory=list,
            metadata={
                "name": "TD-EVENT-VFB-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        timing_description_event_chain: list[TimingDescriptionEventChain] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-DESCRIPTION-EVENT-CHAIN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingGuarantees:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingRequirements:
        age_constraint: list[AgeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "AGE-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        arbitrary_event_triggering: list[ArbitraryEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ARBITRARY-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        burst_pattern_event_triggering: list[BurstPatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "BURST-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_pattern_event_triggering: list[ConcretePatternEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-PATTERN-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_order_constraint: list[ExecutionOrderConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-ORDER-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        execution_time_constraint: list[ExecutionTimeConstraint] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTION-TIME-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        latency_timing_constraint: list[LatencyTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "LATENCY-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        offset_timing_constraint: list[OffsetTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "OFFSET-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        periodic_event_triggering: list[PeriodicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PERIODIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sporadic_event_triggering: list[SporadicEventTriggering] = field(
            default_factory=list,
            metadata={
                "name": "SPORADIC-EVENT-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_point_constraint: list[SynchronizationPointConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-POINT-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronization_timing_constraint: list[SynchronizationTimingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SYNCHRONIZATION-TIMING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ComponentRef(Ref):
        dest: SwComponentTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class AdaptiveSwcInternalBehavior:
    """This meta-class represents the ability to define an internal behavior of an
    AtomicSwComponentType used on the AUTOSAR adaptive platform.

    Please note that the model of internal behavior in this case, in
    stark contrast to the situation of the AUTOSAR classic platform, is
    very minimal.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar service_dependencys: This represents the collection of
        SwcServiceDependencys owned by AdaptiveInternalBehavior. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        AdaptiveApplicationSwComponentType.internalBehavior
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ADAPTIVE-SWC-INTERNAL-BEHAVIOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AdaptiveSwcInternalBehavior.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AdaptiveSwcInternalBehavior.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_dependencys: Optional["AdaptiveSwcInternalBehavior.ServiceDependencys"] = field(
        default=None,
        metadata={
            "name": "SERVICE-DEPENDENCYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceDependencys:
        swc_service_dependency: list[SwcServiceDependency] = field(
            default_factory=list,
            metadata={
                "name": "SWC-SERVICE-DEPENDENCY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApplicationEndpoint:
    """An application endpoint is the endpoint on an Ecu in terms of application
    addressing (e.g. socket).

    The application endpoint represents e.g. the listen socket in
    client-server-based communication.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar consumed_service_instances: Consumed service instances. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar discovery_technology: Defines the used Service-Discovery
        protocol.
    :ivar max_number_of_connections: This attribute defines the maximal
        number of clients the Server is able to deal with in case of
        Service Discovery.
    :ivar network_endpoint_ref: Reference to the network address.
    :ivar priority: Defines the frame priority where values from 0 (best
        effort) to 7 (highest) are allowed.
    :ivar provided_service_instances: Provided service instances. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar remoting_technology: Defines the used remoting Technology.
    :ivar serialization_technology_ref: Defines the used serialization
        technology.
    :ivar tls_crypto_mapping_ref: This reference identifies the
        applicable TlsCryptoServiceMapping that adds the ability for
        TLS-based encryption on the enclosing ApplicationEndpoint.
    :ivar tp_configuration: Configuration of the used transport
        protocol.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-ENDPOINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApplicationEndpoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApplicationEndpoint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consumed_service_instances: Optional["ApplicationEndpoint.ConsumedServiceInstances"] = field(
        default=None,
        metadata={
            "name": "CONSUMED-SERVICE-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    discovery_technology: DiscoveryTechnology | None = field(
        default=None,
        metadata={
            "name": "DISCOVERY-TECHNOLOGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_number_of_connections: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NUMBER-OF-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_endpoint_ref: Optional["ApplicationEndpoint.NetworkEndpointRef"] = field(
        default=None,
        metadata={
            "name": "NETWORK-ENDPOINT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    priority: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PRIORITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_service_instances: Optional["ApplicationEndpoint.ProvidedServiceInstances"] = field(
        default=None,
        metadata={
            "name": "PROVIDED-SERVICE-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    remoting_technology: RemotingTechnology | None = field(
        default=None,
        metadata={
            "name": "REMOTING-TECHNOLOGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    serialization_technology_ref: Optional["ApplicationEndpoint.SerializationTechnologyRef"] = (
        field(
            default=None,
            metadata={
                "name": "SERIALIZATION-TECHNOLOGY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    tls_crypto_mapping_ref: Optional["ApplicationEndpoint.TlsCryptoMappingRef"] = field(
        default=None,
        metadata={
            "name": "TLS-CRYPTO-MAPPING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_configuration: Optional["ApplicationEndpoint.TpConfiguration"] = field(
        default=None,
        metadata={
            "name": "TP-CONFIGURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConsumedServiceInstances:
        consumed_service_instance: list[ConsumedServiceInstance] = field(
            default_factory=list,
            metadata={
                "name": "CONSUMED-SERVICE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NetworkEndpointRef(Ref):
        dest: NetworkEndpointSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedServiceInstances:
        provided_service_instance: list[ProvidedServiceInstance] = field(
            default_factory=list,
            metadata={
                "name": "PROVIDED-SERVICE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SerializationTechnologyRef(Ref):
        dest: SerializationTechnologySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TlsCryptoMappingRef(Ref):
        dest: TlsCryptoServiceMappingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TpConfiguration:
        generic_tp: GenericTp | None = field(
            default=None,
            metadata={
                "name": "GENERIC-TP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        http_tp: HttpTp | None = field(
            default=None,
            metadata={
                "name": "HTTP-TP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ieee_1722_tp: Ieee1722Tp | None = field(
            default=None,
            metadata={
                "name": "IEEE-1722-TP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        rtp_tp: RtpTp | None = field(
            default=None,
            metadata={
                "name": "RTP-TP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        tcp_tp: TcpTp | None = field(
            default=None,
            metadata={
                "name": "TCP-TP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        udp_tp: UdpTp | None = field(
            default=None,
            metadata={
                "name": "UDP-TP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApplicationRuleBasedValueSpecification:
    """
    This meta-class represents rule based values for DataPrototypes typed by
    ApplicationDataTypes (ApplicationArrayDataType or a compound
    ApplicationPrimitiveDataType which also boils down to an array-nature).

    :ivar short_label: This can be used to identify particular value
        specifications for human readers, for example elements of a
        record type.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ArrayValueSpecification.element Applicable for:
        RecordValueSpecification.field Not Applicable for:
        CompositeRuleBasedValueSpecification.argument Not Applicable
        for: ConstantSpecification.valueSpec Not Applicable for:
        PortPrototypeBlueprintInitValue.value Not Applicable for:
        DiagnosticEnvDataCondition.compareValue Not Applicable for:
        DiagnosticEnvDataElementCondition.compareValue Not Applicable
        for: ParameterDataPrototype.initValue Not Applicable for:
        VariableDataPrototype.initValue Not Applicable for:
        CalibrationParameterValue.applInitValue Not Applicable for:
        CalibrationParameterValue.implInitValue Not Applicable for:
        MetaDataItem.metaDataItemType Not Applicable for:
        NvProvideComSpec.romBlockInitValue Not Applicable for:
        NvProvideComSpec.ramBlockInitValue Not Applicable for:
        NvRequireComSpec.initValue Not Applicable for:
        ParameterProvideComSpec.initValue Not Applicable for:
        ParameterRequireComSpec.initValue Not Applicable for:
        NonqueuedSenderComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.timeoutSubstitutionValue Not Applicable
        for: PortDefinedArgumentValue.value Not Applicable for:
        CryptoServiceKey.developmentValue Not Applicable for:
        ISignal.timeoutSubstitutionValue Not Applicable for:
        ISignal.initValue Not Applicable for:
        FieldSenderComSpec.initValue Not Applicable for:
        PersistencyDataRequiredComSpec.initValue Not Applicable for:
        ApplicationAssocMapElementValueSpecification.value Not
        Applicable for: ApplicationAssocMapElementValueSpecification.key
        Not Applicable for: StateManagementCompareCondition.compareValue
        Not Applicable for: PersistencyKeyValuePair.initValue Not
        Applicable for: SwDataDefPropsContent.invalidValue
    :ivar category: This represents the category of the
        RuleBasedValueSpecification
    :ivar sw_axis_conts: This represents the axis values of a Compound
        Primitive Data Type (curve or map). The first swAxisCont
        describes the x-axis, the second swAxisCont describes the
        y-axis, the third swAxisCont describes the z-axis. In addition
        to this, the axis can be denoted in swAxisIndex.
    :ivar sw_value_cont: This represents the values of an array or
        Compound Primitive Data Type.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-RULE-BASED-VALUE-SPECIFICATION"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: Identifier | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_axis_conts: Optional["ApplicationRuleBasedValueSpecification.SwAxisConts"] = field(
        default=None,
        metadata={
            "name": "SW-AXIS-CONTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_value_cont: RuleBasedValueCont | None = field(
        default=None,
        metadata={
            "name": "SW-VALUE-CONT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SwAxisConts:
        rule_based_axis_cont: list[RuleBasedAxisCont] = field(
            default_factory=list,
            metadata={
                "name": "RULE-BASED-AXIS-CONT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApplicationValueSpecification:
    """This meta-class represents values for DataPrototypes typed by
    ApplicationDataTypes (this includes in particular compound primitives).

    For further details refer to ASAM CDF 2.0. This meta-class
    corresponds to some extent with SW-INSTANCE in ASAM CDF 2.0.

    :ivar short_label: This can be used to identify particular value
        specifications for human readers, for example elements of a
        record type.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ArrayValueSpecification.element Applicable for:
        RecordValueSpecification.field Not Applicable for:
        CompositeRuleBasedValueSpecification.argument Not Applicable
        for: ConstantSpecification.valueSpec Not Applicable for:
        PortPrototypeBlueprintInitValue.value Not Applicable for:
        DiagnosticEnvDataCondition.compareValue Not Applicable for:
        DiagnosticEnvDataElementCondition.compareValue Not Applicable
        for: ParameterDataPrototype.initValue Not Applicable for:
        VariableDataPrototype.initValue Not Applicable for:
        CalibrationParameterValue.applInitValue Not Applicable for:
        CalibrationParameterValue.implInitValue Not Applicable for:
        MetaDataItem.metaDataItemType Not Applicable for:
        NvProvideComSpec.romBlockInitValue Not Applicable for:
        NvProvideComSpec.ramBlockInitValue Not Applicable for:
        NvRequireComSpec.initValue Not Applicable for:
        ParameterProvideComSpec.initValue Not Applicable for:
        ParameterRequireComSpec.initValue Not Applicable for:
        NonqueuedSenderComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.timeoutSubstitutionValue Not Applicable
        for: PortDefinedArgumentValue.value Not Applicable for:
        CryptoServiceKey.developmentValue Not Applicable for:
        ISignal.timeoutSubstitutionValue Not Applicable for:
        ISignal.initValue Not Applicable for:
        FieldSenderComSpec.initValue Not Applicable for:
        PersistencyDataRequiredComSpec.initValue Not Applicable for:
        ApplicationAssocMapElementValueSpecification.value Not
        Applicable for: ApplicationAssocMapElementValueSpecification.key
        Not Applicable for: StateManagementCompareCondition.compareValue
        Not Applicable for: PersistencyKeyValuePair.initValue Not
        Applicable for: SwDataDefPropsContent.invalidValue
    :ivar category: Specifies to which category of ApplicationDataType
        this ApplicationValueSpecification can be applied (e.g. as an
        initial value), thus imposing constraints on the structure and
        semantics of the contained values, see [constr_1006] and
        [constr_2051].
    :ivar sw_axis_conts: This represents the axis values of a Compound
        Primitive Data Type (curve or map). The first swAxisCont
        describes the x-axis, the second swAxisCont describes the
        y-axis, the third swAxisCont describes the z-axis. In addition
        to this, the axis can be denoted in swAxisIndex.
    :ivar sw_value_cont: This represents the values of a Compound
        Primitive Data Type.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-VALUE-SPECIFICATION"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: Identifier | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_axis_conts: Optional["ApplicationValueSpecification.SwAxisConts"] = field(
        default=None,
        metadata={
            "name": "SW-AXIS-CONTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_value_cont: SwValueCont | None = field(
        default=None,
        metadata={
            "name": "SW-VALUE-CONT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SwAxisConts:
        sw_axis_cont: list[SwAxisCont] = field(
            default_factory=list,
            metadata={
                "name": "SW-AXIS-CONT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ClientServerInterfaceMapping:
    """
    Defines the mapping of ClientServerOperations in context of two different
    ClientServerInterfaces.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        PortInterfaceMappingSet.portInterfaceMapping
    :ivar error_mappings: Map two different ApplicationErrors defined in
        the context of two different ClientServerInterfaces.
    :ivar operation_mappings: Mapping of two ClientServerOperations in
        two different ClientServerInterfaces
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CLIENT-SERVER-INTERFACE-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ClientServerInterfaceMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ClientServerInterfaceMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ClientServerInterfaceMapping.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    error_mappings: Optional["ClientServerInterfaceMapping.ErrorMappings"] = field(
        default=None,
        metadata={
            "name": "ERROR-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_mappings: Optional["ClientServerInterfaceMapping.OperationMappings"] = field(
        default=None,
        metadata={
            "name": "OPERATION-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ErrorMappings:
        client_server_application_error_mapping: list[ClientServerApplicationErrorMapping] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-APPLICATION-ERROR-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class OperationMappings:
        client_server_operation_mapping: list[ClientServerOperationMapping] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-OPERATION-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CouplingElement:
    """A CouplingElement is used to connect EcuInstances to the VLAN of an
    EthernetCluster.

    CouplingElements can reach from a simple hub to a complex managed
    switch or even devices with functionalities in higher layers. A
    CouplingElement that is not related to an EcuInstance occurs as a
    dedicated single device.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar communication_cluster_ref: This relationship defines to which
        cluster the CouplingElement belongs.
    :ivar coupling_ports: Hardware Port of the CouplingElement that is
        used to connect this CouplingPort to EcuInstances or other
        CouplingElements.
    :ivar coupling_type: Describes the coupling type of this
        CouplingElement.
    :ivar ecu_instance_ref: Optional reference to the ECU where the
        CouplingElement is located.
    :ivar firewall_rule_refs: Firewall rules defined in the context of a
        CouplingElement.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COUPLING-ELEMENT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CouplingElement.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CouplingElement.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_cluster_ref: Optional["CouplingElement.CommunicationClusterRef"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CLUSTER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    coupling_ports: Optional["CouplingElement.CouplingPorts"] = field(
        default=None,
        metadata={
            "name": "COUPLING-PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    coupling_type: CouplingElementEnum | None = field(
        default=None,
        metadata={
            "name": "COUPLING-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_ref: Optional["CouplingElement.EcuInstanceRef"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    firewall_rule_refs: Optional["CouplingElement.FirewallRuleRefs"] = field(
        default=None,
        metadata={
            "name": "FIREWALL-RULE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationClusterRef(Ref):
        dest: EthernetClusterSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CouplingPorts:
        coupling_port: list[CouplingPort] = field(
            default_factory=list,
            metadata={
                "name": "COUPLING-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRef(Ref):
        dest: EcuInstanceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class FirewallRuleRefs:
        firewall_rule_ref: list["CouplingElement.FirewallRuleRefs.FirewallRuleRef"] = field(
            default_factory=list,
            metadata={
                "name": "FIREWALL-RULE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class FirewallRuleRef(Ref):
            dest: StateDependentFirewallSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class DataFormatTailoring:
    """
    This class collects all rules that tailor the AUTOSAR templates for a specific
    data exchange point.

    :ivar class_tailorings: Specification of tailorings of Meta Classes
    :ivar constraint_tailorings: Specification of tailorings of
        Constraints that are not explicitly owned by any Meta-Class
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-FORMAT-TAILORING"

    class_tailorings: Optional["DataFormatTailoring.ClassTailorings"] = field(
        default=None,
        metadata={
            "name": "CLASS-TAILORINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    constraint_tailorings: Optional["DataFormatTailoring.ConstraintTailorings"] = field(
        default=None,
        metadata={
            "name": "CONSTRAINT-TAILORINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ClassTailorings:
        abstract_class_tailoring: list[AbstractClassTailoring] = field(
            default_factory=list,
            metadata={
                "name": "ABSTRACT-CLASS-TAILORING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_class_tailoring: list[ConcreteClassTailoring] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-CLASS-TAILORING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConstraintTailorings:
        constraint_tailoring: list[ConstraintTailoring] = field(
            default_factory=list,
            metadata={
                "name": "CONSTRAINT-TAILORING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticContributionSet:
    """This meta-class represents a root node of a diagnostic extract.

    It bundles a given set of diagnostic model elements. The granularity
    of the DiagonsticContributionSet is arbitrary in order to support
    the aspect of decentralized configuration, i.e. different
    contributors can come up with an own DiagnosticContributionSet.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar common_properties: This attribute represents a collection of
        diagnostic properties that are shared among the entire
        DiagnosticContributionSet.
    :ivar ecu_instance_refs: This represents the collection of
        EcuInstances that are affected by the DiagnosticContributionSet.
    :ivar elements: This represents a DiagnosticCommonElement considered
        in the context of the DiagnosticContributionSet This property
        was modified due to atpVariation (DirectedAssociationPattern).
    :ivar service_tables: This represents the collection of
        DiagnosticServiceTables to be considered in the scope of this
        DiagnosticContributionSet. This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-CONTRIBUTION-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticContributionSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticContributionSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    common_properties: DiagnosticCommonProps | None = field(
        default=None,
        metadata={
            "name": "COMMON-PROPERTIES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_refs: Optional["DiagnosticContributionSet.EcuInstanceRefs"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    elements: Optional["DiagnosticContributionSet.Elements"] = field(
        default=None,
        metadata={
            "name": "ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_tables: Optional["DiagnosticContributionSet.ServiceTables"] = field(
        default=None,
        metadata={
            "name": "SERVICE-TABLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstanceRefs:
        ecu_instance_ref: list["DiagnosticContributionSet.EcuInstanceRefs.EcuInstanceRef"] = field(
            default_factory=list,
            metadata={
                "name": "ECU-INSTANCE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EcuInstanceRef(Ref):
            dest: EcuInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class Elements:
        diagnostic_common_element_ref_conditional: list[DiagnosticCommonElementRefConditional] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-COMMON-ELEMENT-REF-CONDITIONAL",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceTables:
        diagnostic_service_table_ref_conditional: list[DiagnosticServiceTableRefConditional] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-SERVICE-TABLE-REF-CONDITIONAL",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticDataIdentifier:
    """
    This meta-class represents the ability to model a diagnostic data identifier
    (DID) that is fully specified regarding the payload at configuration-time.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar id: This is the numerical identifier used to identify the
        DiagnosticAbstractDataIdentifier in the scope of diagnostic
        workflow
    :ivar data_elements: This is the dataElement associated with the
        DiagnosticDataIdentifier.
    :ivar did_size: This attribute indicates the size in bytes of the
        DiagnosticDataIdentifier.
    :ivar represents_vin: This attributes indicates whether the specific
        DiagnosticDataIdentifier represents the vehicle identification.
    :ivar support_info_byte: This attribute represents the supported
        information associated with the DiagnosticDataIdentifier.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-DATA-IDENTIFIER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticDataIdentifier.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticDataIdentifier.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    id: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_elements: Optional["DiagnosticDataIdentifier.DataElements"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    did_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DID-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    represents_vin: Boolean | None = field(
        default=None,
        metadata={
            "name": "REPRESENTS-VIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    support_info_byte: DiagnosticSupportInfoByte | None = field(
        default=None,
        metadata={
            "name": "SUPPORT-INFO-BYTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataElements:
        diagnostic_parameter: list[DiagnosticParameter] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PARAMETER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticExtendedDataRecord:
    """
    Description of an extended data record.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar custom_trigger: This attribute shall be taken to verbally
        describe the nature of the custom trigger.
    :ivar record_elements: Defined DataElements in the extended record
        element. This aggregation contains a variation point although it
        is not variant. Therefore, this variation point shall not exist
        in models. See constr_2638.
    :ivar record_number: This attribute specifies an unique identifier
        for an extended data record.
    :ivar trigger: This attribute specifies the primary trigger to
        allocate an event memory entry.
    :ivar update: This attribute defines when an extended data record is
        captured. True: This extended data record is captured every
        time. False: This extended data record is only captured for new
        event memory entries.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-EXTENDED-DATA-RECORD"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticExtendedDataRecord.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticExtendedDataRecord.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    custom_trigger: String | None = field(
        default=None,
        metadata={
            "name": "CUSTOM-TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    record_elements: Optional["DiagnosticExtendedDataRecord.RecordElements"] = field(
        default=None,
        metadata={
            "name": "RECORD-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    record_number: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "RECORD-NUMBER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger: DiagnosticRecordTriggerEnum | None = field(
        default=None,
        metadata={
            "name": "TRIGGER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update: Boolean | None = field(
        default=None,
        metadata={
            "name": "UPDATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RecordElements:
        diagnostic_parameter: list[DiagnosticParameter] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PARAMETER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticInfoType:
    """
    This meta-class represents the ability to model an OBD info type.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar data_elements: This represents the data associated with the
        enclosing DiagnosticInfoType. This aggregation contains a
        variation point although it is not variant. Therefore, this
        variation point shall not exist in models. See constr_2638.
    :ivar id: This attribute represents the value of InfoType (see SAE
        J1979-DA).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-INFO-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticInfoType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticInfoType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_elements: Optional["DiagnosticInfoType.DataElements"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataElements:
        diagnostic_parameter: list[DiagnosticParameter] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PARAMETER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticParameterIdentifier:
    """
    This meta-class represents the ability to model a diagnostic parameter
    identifier (PID) for the purpose of executing on-board diagnostics (OBD).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar data_elements: This represents the data carried by the
        DiagnosticParameterIdentifier.
    :ivar id: This is the numerical identifier used to identify the
        DiagnosticParameterIdentifier in the scope of diagnostic
        workflow (see SAE J1979-DA).
    :ivar pid_size: The size of the entire PID can be greater than the
        sum of the data elements because padding might be applied. Unit:
        byte.
    :ivar support_info_byte: This represents the supported information
        associated with the DiagnosticParameterIdentifier.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-PARAMETER-IDENTIFIER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticParameterIdentifier.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticParameterIdentifier.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_elements: Optional["DiagnosticParameterIdentifier.DataElements"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pid_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PID-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    support_info_byte: DiagnosticSupportInfoByte | None = field(
        default=None,
        metadata={
            "name": "SUPPORT-INFO-BYTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataElements:
        diagnostic_parameter: list[DiagnosticParameter] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PARAMETER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRequestRoutineResults:
    """
    This meta-class represents the ability to define the result of a diagnostic
    routine execution.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar access_permission_ref: This reference represents the access
        permission of the owning routine subfunction.
    :ivar requests: This represents the request parameters. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar responses: This represents the response parameters. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-REQUEST-ROUTINE-RESULTS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRequestRoutineResults.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRequestRoutineResults.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticRequestRoutineResults.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requests: Optional["DiagnosticRequestRoutineResults.Requests"] = field(
        default=None,
        metadata={
            "name": "REQUESTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    responses: Optional["DiagnosticRequestRoutineResults.Responses"] = field(
        default=None,
        metadata={
            "name": "RESPONSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Requests:
        diagnostic_parameter: list[DiagnosticParameter] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PARAMETER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Responses:
        diagnostic_parameter: list[DiagnosticParameter] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PARAMETER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticStartRoutine:
    """
    This represents the ability to start a diagnostic routine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar access_permission_ref: This reference represents the access
        permission of the owning routine subfunction.
    :ivar requests: This represents the request parameters. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar responses: This represents the response parameters. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-START-ROUTINE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticStartRoutine.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticStartRoutine.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticStartRoutine.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requests: Optional["DiagnosticStartRoutine.Requests"] = field(
        default=None,
        metadata={
            "name": "REQUESTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    responses: Optional["DiagnosticStartRoutine.Responses"] = field(
        default=None,
        metadata={
            "name": "RESPONSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Requests:
        diagnostic_parameter: list[DiagnosticParameter] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PARAMETER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Responses:
        diagnostic_parameter: list[DiagnosticParameter] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PARAMETER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticStopRoutine:
    """
    This represents the ability to stop a diagnostic routine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar access_permission_ref: This reference represents the access
        permission of the owning routine subfunction.
    :ivar requests: This represents the request parameters. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar responses: This represents the response parameters. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-STOP-ROUTINE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticStopRoutine.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticStopRoutine.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_permission_ref: Optional["DiagnosticStopRoutine.AccessPermissionRef"] = field(
        default=None,
        metadata={
            "name": "ACCESS-PERMISSION-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requests: Optional["DiagnosticStopRoutine.Requests"] = field(
        default=None,
        metadata={
            "name": "REQUESTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    responses: Optional["DiagnosticStopRoutine.Responses"] = field(
        default=None,
        metadata={
            "name": "RESPONSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AccessPermissionRef(Ref):
        dest: DiagnosticAccessPermissionSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Requests:
        diagnostic_parameter: list[DiagnosticParameter] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PARAMETER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Responses:
        diagnostic_parameter: list[DiagnosticParameter] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PARAMETER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucEnumerationParamDef:
    """
    Configuration parameter type for Enumeration.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar configuration_class_affection: Specifies whether changes on
        this parameter have some affection on other parameters.
    :ivar implementation_config_classes: Specifies in which
        ConfigurationClass this parameter or reference is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar multiplicity_config_classes: Specifies in which
        MultiplicityConfigurationClass this parameter or reference is
        available in a particular ConfigurationVariant. This aggregation
        is optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar origin: String specifying if this configuration parameter is
        an AUTOSAR standardized configuration parameter or if the
        parameter is hardware- or vendor-specific.
    :ivar post_build_variant_multiplicity: Indicates if a parameter or a
        reference may have different number of instances in different
        post-build variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar post_build_variant_value: Indicates if a parameter or a
        reference may have different value in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar value_config_classes: Specifies in which
        ValueConfigurationClass this parameter or reference is available
        in a particular ConfigurationVariant. This aggregation is
        optional if the surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION, then
        this aggregation is mandatory.
    :ivar derivation: A derivation of a Configuration Parameter value
        can be specified by an informal Calculation Formula or by a
        formal language that can be used to specify the computational
        rules.
    :ivar symbolic_name_value: Specifies that this parameter's value is
        used, together with the aggregating container, to derive a
        symbolic name definition. See chapter "Representation of
        Symbolic Names" in Ecuc specification for more details.
    :ivar with_auto: Specifies whether it shall be allowed on the value
        side to specify this parameter value as "AUTO". If withAuto is
        "true" it shall be possible to set the "isAutoValue" attribute
        of the respective parameter to "true". This means that the
        actual value will not be considered during ECU Configuration but
        will be (re-)calculated by the code generator and stored in the
        value attribute afterwards. These implicit updated values might
        require a re-generation of other modules which reference these
        values. If withAuto is "false" it shall not be possible to set
        the "isAutoValue" attribute of the respective parameter to
        "true". If withAuto is not present the default is "false".
    :ivar default_value: Default value of the enumeration configuration
        parameter. This string needs to be one of the literals specified
        for this enumeration.
    :ivar literals: Aggregation on the literals used to define this
        enumeration parameter. This aggregation is optional if the
        surrounding EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this aggregation is mandatory.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-ENUMERATION-PARAM-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucEnumerationParamDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucEnumerationParamDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucEnumerationParamDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucEnumerationParamDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    configuration_class_affection: EcucConfigurationClassAffection | None = field(
        default=None,
        metadata={
            "name": "CONFIGURATION-CLASS-AFFECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_config_classes: Optional[
        "EcucEnumerationParamDef.ImplementationConfigClasses"
    ] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiplicity_config_classes: Optional["EcucEnumerationParamDef.MultiplicityConfigClasses"] = (
        field(
            default=None,
            metadata={
                "name": "MULTIPLICITY-CONFIG-CLASSES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_config_classes: Optional["EcucEnumerationParamDef.ValueConfigClasses"] = field(
        default=None,
        metadata={
            "name": "VALUE-CONFIG-CLASSES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    derivation: EcucDerivationSpecification | None = field(
        default=None,
        metadata={
            "name": "DERIVATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbolic_name_value: Boolean | None = field(
        default=None,
        metadata={
            "name": "SYMBOLIC-NAME-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    with_auto: Boolean | None = field(
        default=None,
        metadata={
            "name": "WITH-AUTO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_value: Identifier | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    literals: Optional["EcucEnumerationParamDef.Literals"] = field(
        default=None,
        metadata={
            "name": "LITERALS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationConfigClasses:
        ecuc_implementation_configuration_class: list[EcucImplementationConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-IMPLEMENTATION-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueConfigClasses:
        ecuc_value_configuration_class: list[EcucValueConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Literals:
        ecuc_enumeration_literal_def: list[EcucEnumerationLiteralDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-ENUMERATION-LITERAL-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EthernetCommunicationControllerConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar wake_up_by_controller_supported: Defines whether the ECU shall
        be woken up by this CommunicationController. TRUE: wake up is
        possible FALSE: wake up is not supported Note: If
        wakeUpByControllerSupported is set to TRUE the feature shall be
        supported by both hardware and basic software.
    :ivar can_xl_config_ref: If the Ethernet frames handled by this
        EthernetCommunicationController are to be tunneled through CAN
        XL, then this reference shall refer to the
        AbstractCanCommunicationController that aggregates the
        CanControllerXlConfiguration of the physical CAN XL channel to
        be used for tunneling.
    :ivar coupling_ports: Optional CouplingPort that can be used to
        connect the ECU to a CouplingElement (e.g. a switch). This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar mac_layer_type: Specifies the mac layer type of the ethernet
        controller.
    :ivar mac_unicast_address: Media Access Control address (MAC
        address) that uniquely identifies each
        EthernetCommunicationController in the network.
    :ivar maximum_receive_buffer_length: Determines the maximum receive
        buffer length (frame length) in bytes.
    :ivar maximum_transmission_unit: This attribute is deprecated and
        will be removed in future. It is replaced by
        EthernetCommunicationConnector.maximumTransmissionUnit. Old
        description: This attribute specifies the maximum transmission
        unit in bytes.
    :ivar maximum_transmit_buffer_length: Determines the maximum
        transmit buffer length (frame length) in bytes.
    :ivar slave_act_as_passive_communication_slave: This attribute
        specifies if the EcuInstance is acting as a passive
        communication slave on the connected PhysicalChannel. This is
        used for EthernetCommunicationControllers that use Ethernet
        hardware which supports wake-up and sleep on the network (e.g.
        Open Alliance TC10 compliant Ethernet hardware).
    :ivar slave_qualified_unexpected_link_down_time: This attribute
        specifies time when an unexpected link down is evaluated as link
        down and indicated to the AUTOSAR communication stack.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-COMMUNICATION-CONTROLLER-CONDITIONAL"

    wake_up_by_controller_supported: Boolean | None = field(
        default=None,
        metadata={
            "name": "WAKE-UP-BY-CONTROLLER-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_xl_config_ref: Optional["EthernetCommunicationControllerConditional.CanXlConfigRef"] = (
        field(
            default=None,
            metadata={
                "name": "CAN-XL-CONFIG-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    coupling_ports: Optional["EthernetCommunicationControllerConditional.CouplingPorts"] = field(
        default=None,
        metadata={
            "name": "COUPLING-PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mac_layer_type: EthernetMacLayerTypeEnum | None = field(
        default=None,
        metadata={
            "name": "MAC-LAYER-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mac_unicast_address: MacAddressString | None = field(
        default=None,
        metadata={
            "name": "MAC-UNICAST-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_receive_buffer_length: Integer | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-RECEIVE-BUFFER-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_transmission_unit: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-TRANSMISSION-UNIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_transmit_buffer_length: Integer | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-TRANSMIT-BUFFER-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    slave_act_as_passive_communication_slave: Boolean | None = field(
        default=None,
        metadata={
            "name": "SLAVE-ACT-AS-PASSIVE-COMMUNICATION-SLAVE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    slave_qualified_unexpected_link_down_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SLAVE-QUALIFIED-UNEXPECTED-LINK-DOWN-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CanXlConfigRef(Ref):
        dest: AbstractCanCommunicationControllerSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class CouplingPorts:
        coupling_port: list[CouplingPort] = field(
            default_factory=list,
            metadata={
                "name": "COUPLING-PORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ISignalIPdu:
    """Represents the IPdus handled by Com.

    The ISignalIPdu assembled and disassembled in AUTOSAR COM consists
    of one or more signals. In case no multiplexing is performed this
    IPdu is routed to/from the Interface Layer. A maximum of one dynamic
    length signal per IPdu is allowed.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar has_dynamic_length: This attribute defines whether the Pdu has
        dynamic length (true) or not (false). Please note that the usage
        of this attribute is restricted by [constr_3448].
    :ivar length: Pdu length in bytes. In case of dynamic length IPdus
        (containing a dynamical length signal), this value indicates the
        maximum data length. It should be noted that in former AUTOSAR
        releases (Rel 2.1, Rel 3.0, Rel 3.1, Rel 4.0 Rev. 1) this
        parameter was defined in bits. The Pdu length of zero bytes is
        allowed.
    :ivar meta_data_length: Number of additional bytes of MetaData in
        the PDU data field. The MetaData contains auxiliary information
        for the PDU, e.g. the CAN ID.
    :ivar contained_i_pdu_props: Defines whether this IPdu may be
        collected inside a ContainerIPdu.
    :ivar i_pdu_timing_specifications: Timing specification for Com
        IPdus (Transmission Modes). This information is mandatory for
        the sender in a System Extract. This information may be omitted
        on receivers in a System Extract. atpVariation: The timing of a
        Pdu can vary. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar i_signal_to_pdu_mappings: Definition of SignalToIPduMappings
        included in the SignalIPdu. atpVariation: The content of a PDU
        can be variable.
    :ivar pdu_counters: An included Pdu counter is used to ensure that a
        sequence of Pdus is maintained. The upper multiplicity of this
        role has been increased to * due to resolving an atpVariation
        stereotype. The previous value was 1.
    :ivar pdu_replications: Pdu Replication is a form of redundancy
        where the data content of one ISignalIPdu (source) is
        transmitted inside a set of replica ISignalIPdus. These
        ISignalIPdus (copies) have different Pdu IDs, identical
        PduCounters, identical data content and are transmitted with the
        same frequency. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar unused_bit_pattern: AUTOSAR COM and AUTOSAR IPDUM are filling
        not used areas of an IPDU with this bit-pattern. This attribute
        is mandatory to avoid undefined behavior. This byte-pattern will
        be repeated throughout the IPdu.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-SIGNAL-I-PDU"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ISignalIPdu.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ISignalIPdu.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    has_dynamic_length: Boolean | None = field(
        default=None,
        metadata={
            "name": "HAS-DYNAMIC-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "META-DATA-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contained_i_pdu_props: ContainedIPduProps | None = field(
        default=None,
        metadata={
            "name": "CONTAINED-I-PDU-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_pdu_timing_specifications: Optional["ISignalIPdu.IPduTimingSpecifications"] = field(
        default=None,
        metadata={
            "name": "I-PDU-TIMING-SPECIFICATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_to_pdu_mappings: Optional["ISignalIPdu.ISignalToPduMappings"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-TO-PDU-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_counters: Optional["ISignalIPdu.PduCounters"] = field(
        default=None,
        metadata={
            "name": "PDU-COUNTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_replications: Optional["ISignalIPdu.PduReplications"] = field(
        default=None,
        metadata={
            "name": "PDU-REPLICATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unused_bit_pattern: Integer | None = field(
        default=None,
        metadata={
            "name": "UNUSED-BIT-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IPduTimingSpecifications:
        i_pdu_timing: list[IPduTiming] = field(
            default_factory=list,
            metadata={
                "name": "I-PDU-TIMING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalToPduMappings:
        i_signal_to_i_pdu_mapping: list[ISignalToIPduMapping] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-TO-I-PDU-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduCounters:
        signal_i_pdu_counter: list[SignalIPduCounter] = field(
            default_factory=list,
            metadata={
                "name": "SIGNAL-I-PDU-COUNTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PduReplications:
        signal_i_pdu_replication: list[SignalIPduReplication] = field(
            default_factory=list,
            metadata={
                "name": "SIGNAL-I-PDU-REPLICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LabeledItem:
    """
    This represents an item of a labeled list.

    :ivar item_label: This is the label of the item.
    :ivar msr_query_p_2: This represents automatically contributed
        contents provided by an msrquery in the context of
        DocumentationBlock.
    :ivar p: This is one particular paragraph. The upper multiplicity of
        this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar verbatim: This represents one particular verbatim text. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar list_value: This represents numbered or unnumbered list. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar def_list: This represents a definition list in the
        documentation block. The upper multiplicity of this role has
        been increased to * due to resolving an atpVariation stereotype.
        The previous value was 1.
    :ivar labeled_list: This represents a labeled list. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar formula: This is a formula in the definition block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar figure: This represents a figure in the documentation block.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar note: This represents a note in the text flow. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar trace: This represents traceable text in the documentation
        block. This allows to specify requirements/constraints in any
        documentation block. The kind of the trace is specified in the
        category. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar structured_req: This aggregation supports structured
        requirements embedded in a documentation block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: LabeledList.labeledItem
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    :ivar help_entry: This specifies an entry point in an online help
        system to be linked with the parent class. The syntax shall be
        defined by the applied help system respectively help system
        generator.
    """

    class Meta:
        name = "LABELED-ITEM"

    item_label: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "ITEM-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_p_2: list[MsrQueryP2] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p: list[MultiLanguageParagraph] = field(
        default_factory=list,
        metadata={
            "name": "P",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: list[MultiLanguageVerbatim] = field(
        default_factory=list,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    list_value: list[ListType] = field(
        default_factory=list,
        metadata={
            "name": "LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_list: list[DefList] = field(
        default_factory=list,
        metadata={
            "name": "DEF-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    labeled_list: list["LabeledList"] = field(
        default_factory=list,
        metadata={
            "name": "LABELED-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: list[MlFormula] = field(
        default_factory=list,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    figure: list[MlFigure] = field(
        default_factory=list,
        metadata={
            "name": "FIGURE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    note: list["Note"] = field(
        default_factory=list,
        metadata={
            "name": "NOTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace: list["TraceableText"] = field(
        default_factory=list,
        metadata={
            "name": "TRACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    structured_req: list[StructuredReq] = field(
        default_factory=list,
        metadata={
            "name": "STRUCTURED-REQ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )
    help_entry: str | None = field(
        default=None,
        metadata={
            "name": "HELP-ENTRY",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class Process:
    """
    This meta-class provides information required to execute the referenced
    executable.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar design_ref: This reference represents the identification of
        the design-time representation for the Process that owns the
        reference.
    :ivar executable_refs: Reference to executable that is executed in
        the process.
    :ivar function_cluster_affiliation: This attribute specifies which
        functional cluster the process is affiliated with.
    :ivar number_of_restart_attempts: This attribute defines how often a
        process shall be restarted if the start fails.
        numberOfRestartAttempts = "0" OR Attribute not existing, start
        once numberOfRestartAttempts = "1",  start a second time
    :ivar pre_mapping: This attribute describes whether the executable
        is preloaded into the memory.
    :ivar process_state_machine: Set of Process States that are defined
        for the process. This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar security_event_refs: The reference identifies the collection
        of SecurityEvents that can be reported by the enclosing
        SoftwareCluster.
    :ivar state_dependent_startup_configs: Applicable startup
        configurations.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PROCESS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Process.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Process.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    design_ref: Optional["Process.DesignRef"] = field(
        default=None,
        metadata={
            "name": "DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    executable_refs: Optional["Process.ExecutableRefs"] = field(
        default=None,
        metadata={
            "name": "EXECUTABLE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    function_cluster_affiliation: String | None = field(
        default=None,
        metadata={
            "name": "FUNCTION-CLUSTER-AFFILIATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    number_of_restart_attempts: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NUMBER-OF-RESTART-ATTEMPTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pre_mapping: Boolean | None = field(
        default=None,
        metadata={
            "name": "PRE-MAPPING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_state_machine: ModeDeclarationGroupPrototype | None = field(
        default=None,
        metadata={
            "name": "PROCESS-STATE-MACHINE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    security_event_refs: Optional["Process.SecurityEventRefs"] = field(
        default=None,
        metadata={
            "name": "SECURITY-EVENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    state_dependent_startup_configs: Optional["Process.StateDependentStartupConfigs"] = field(
        default=None,
        metadata={
            "name": "STATE-DEPENDENT-STARTUP-CONFIGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DesignRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ExecutableRefs:
        executable_ref: list["Process.ExecutableRefs.ExecutableRef"] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTABLE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ExecutableRef(Ref):
            dest: ExecutableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class SecurityEventRefs:
        security_event_ref: list["Process.SecurityEventRefs.SecurityEventRef"] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SecurityEventRef(Ref):
            dest: SecurityEventDefinitionSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class StateDependentStartupConfigs:
        state_dependent_startup_config: list[StateDependentStartupConfig] = field(
            default_factory=list,
            metadata={
                "name": "STATE-DEPENDENT-STARTUP-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ReferenceTailoring:
    """
    Tailoring of Non-Containment References.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar alternative_name: Alternative name of a specification element
        if its name doesn't fit into the shortName. E.g. because the
        name contains spaces.
    :ivar in_scope: indicates, if a specification element is relevant
        for this data exchange point. It is relevant if inScope==true.
        It is not relevant or don't care if inScope=false.
    :ivar multiplicity_restriction: Multiplicity restriction of the
        attribute
    :ivar variation_restriction: Restrictions on the usage of variant
        handling.
    :ivar type_tailorings: Local class tailoring for content that is
        referenced by this reference.
    :ivar unresolved_reference_restriction: Specifies the severity of
        unresolved references.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "REFERENCE-TAILORING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ReferenceTailoring.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ReferenceTailoring.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alternative_name: String | None = field(
        default=None,
        metadata={
            "name": "ALTERNATIVE-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    in_scope: Boolean | None = field(
        default=None,
        metadata={
            "name": "IN-SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiplicity_restriction: MultiplicityRestrictionWithSeverity | None = field(
        default=None,
        metadata={
            "name": "MULTIPLICITY-RESTRICTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_restriction: VariationRestrictionWithSeverity | None = field(
        default=None,
        metadata={
            "name": "VARIATION-RESTRICTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_tailorings: Optional["ReferenceTailoring.TypeTailorings"] = field(
        default=None,
        metadata={
            "name": "TYPE-TAILORINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unresolved_reference_restriction: UnresolvedReferenceRestrictionWithSeverity | None = field(
        default=None,
        metadata={
            "name": "UNRESOLVED-REFERENCE-RESTRICTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TypeTailorings:
        abstract_class_tailoring: list[AbstractClassTailoring] = field(
            default_factory=list,
            metadata={
                "name": "ABSTRACT-CLASS-TAILORING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        concrete_class_tailoring: list[ConcreteClassTailoring] = field(
            default_factory=list,
            metadata={
                "name": "CONCRETE-CLASS-TAILORING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RptSupportData:
    """Root element for rapid prototyping support data related to one
    Implementation artifact on an ECU, in particular the RTE.

    The rapid prototyping support data may reference to elements
    provided for McSupportData.

    :ivar execution_contexts: Defines an environment for the execution
        of ExecutableEntites.
    :ivar rpt_components: Description of components for which rapid
        prototyping support is implemented.
    :ivar rpt_service_points: This aggregation represents the collection
        of service points associated with the enclosing RptSuportData
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RPT-SUPPORT-DATA"

    execution_contexts: Optional["RptSupportData.ExecutionContexts"] = field(
        default=None,
        metadata={
            "name": "EXECUTION-CONTEXTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_components: Optional["RptSupportData.RptComponents"] = field(
        default=None,
        metadata={
            "name": "RPT-COMPONENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_service_points: Optional["RptSupportData.RptServicePoints"] = field(
        default=None,
        metadata={
            "name": "RPT-SERVICE-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ExecutionContexts:
        rpt_execution_context: list[RptExecutionContext] = field(
            default_factory=list,
            metadata={
                "name": "RPT-EXECUTION-CONTEXT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RptComponents:
        rpt_component: list[RptComponent] = field(
            default_factory=list,
            metadata={
                "name": "RPT-COMPONENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RptServicePoints:
        rpt_service_point: list[RptServicePoint] = field(
            default_factory=list,
            metadata={
                "name": "RPT-SERVICE-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ServiceInstanceCollectionSet:
    """
    Collection of ServiceInstances.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar service_instances: ServiceInstances that are part of the
        collection.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-INSTANCE-COLLECTION-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ServiceInstanceCollectionSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ServiceInstanceCollectionSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_instances: Optional["ServiceInstanceCollectionSet.ServiceInstances"] = field(
        default=None,
        metadata={
            "name": "SERVICE-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceInstances:
        consumed_service_instance: list[ConsumedServiceInstance] = field(
            default_factory=list,
            metadata={
                "name": "CONSUMED-SERVICE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        provided_service_instance: list[ProvidedServiceInstance] = field(
            default_factory=list,
            metadata={
                "name": "PROVIDED-SERVICE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SystemMapping:
    """'''begin restrict to CP''' The system mapping aggregates all mapping aspects
    (mapping of SW components to ECUs, mapping of data elements to signals, and
    mapping constraints).

    '''end restrict to CP''' '''begin restrict to AP''' The system
    mapping aggregates all mapping aspects that are relevant in the
    System Description. '''end restrict to AP'''

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar app_os_task_proxy_to_ecu_task_proxy_mappings: Mapping of an
        OsTaskProxy that was created in the context of a SwComponent to
        an OsTaskProxy that was created in the context of an Ecu.
    :ivar application_partition_to_ecu_partition_mappings: Mapping of
        ApplicationPartitions to EcuPartitions
    :ivar com_management_mappings: Mappings between Mode Management
        PortGroups and communication channels.
    :ivar crypto_service_mappings: This aggregation represents the
        collection of crypto service mappings in the context of the
        enclosing SystemMapping.
    :ivar data_mappings: The data mappings defined.
    :ivar ecu_resource_mappings: Mapping of hardware related topology
        elements onto their counterpart definitions in the ECU Resource
        Template. atpVariation: The ECU Resource type might be variable.
    :ivar j_1939_controller_application_to_j_1939_nm_node_mappings:
        Mapping of a J1939ControllerApplication to a J1939NmNode.
    :ivar mapping_constraints: Constraints that limit the mapping
        freedom for the mapping of SW components to ECUs.
    :ivar pnc_mappings: Mappings between Virtual Function Clusters and
        Partial Network Clusters.
    :ivar port_element_to_com_resource_mappings: maps a communication
        resource to CP Software Clusters
    :ivar resource_estimations: Resource estimations for this set of
        mappings, zero or one per ECU instance. atpVariation: Used ECUs
        are variable.
    :ivar resource_to_application_partition_mappings: Maps a Software
        Cluster resource to an Application Partition to restrict the
        usage.
    :ivar rte_event_separations: Separation constraint that limits the
        mapping freedom for the mapping of RteEvents to OsTasks in the
        System context.
    :ivar rte_event_to_os_task_proxy_mappings: Constraint that enforces
        a mapping of RteEvent to a particular OsTask in the System
        context.
    :ivar signal_path_constraints: Constraints that limit the mapping
        freedom for the mapping of data elements to signals.
    :ivar software_cluster_to_resource_mappings: maps a service resource
        to CP Software Clusters
    :ivar sw_cluster_mappings: The mappings of SW cluster to ECUs.
    :ivar sw_impl_mappings: The mappings of AtomicSoftwareComponent
        Instances to Implementations. atpVariation: Derived, because
        SwcToEcuMapping is variable.
    :ivar sw_mappings: The mappings of SW components to ECUs.
        atpVariation: SWC shall be mapped to other ECUs.
    :ivar swc_to_application_partition_mappings: Allows to map a given
        SwComponentPrototype to a formally defined partition at a point
        in time when the corresponding EcuInstance is not yet known or
        defined.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: System.mapping
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYSTEM-MAPPING"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SystemMapping.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SystemMapping.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    app_os_task_proxy_to_ecu_task_proxy_mappings: Optional[
        "SystemMapping.AppOsTaskProxyToEcuTaskProxyMappings"
    ] = field(
        default=None,
        metadata={
            "name": "APP-OS-TASK-PROXY-TO-ECU-TASK-PROXY-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_partition_to_ecu_partition_mappings: Optional[
        "SystemMapping.ApplicationPartitionToEcuPartitionMappings"
    ] = field(
        default=None,
        metadata={
            "name": "APPLICATION-PARTITION-TO-ECU-PARTITION-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    com_management_mappings: Optional["SystemMapping.ComManagementMappings"] = field(
        default=None,
        metadata={
            "name": "COM-MANAGEMENT-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    crypto_service_mappings: Optional["SystemMapping.CryptoServiceMappings"] = field(
        default=None,
        metadata={
            "name": "CRYPTO-SERVICE-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_mappings: Optional["SystemMapping.DataMappings"] = field(
        default=None,
        metadata={
            "name": "DATA-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_resource_mappings: Optional["SystemMapping.EcuResourceMappings"] = field(
        default=None,
        metadata={
            "name": "ECU-RESOURCE-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    j_1939_controller_application_to_j_1939_nm_node_mappings: Optional[
        "SystemMapping.J1939ControllerApplicationToJ1939NmNodeMappings"
    ] = field(
        default=None,
        metadata={
            "name": "J-1939-CONTROLLER-APPLICATION-TO-J-1939-NM-NODE-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mapping_constraints: Optional["SystemMapping.MappingConstraints"] = field(
        default=None,
        metadata={
            "name": "MAPPING-CONSTRAINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_mappings: Optional["SystemMapping.PncMappings"] = field(
        default=None,
        metadata={
            "name": "PNC-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_element_to_com_resource_mappings: Optional[
        "SystemMapping.PortElementToComResourceMappings"
    ] = field(
        default=None,
        metadata={
            "name": "PORT-ELEMENT-TO-COM-RESOURCE-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resource_estimations: Optional["SystemMapping.ResourceEstimations"] = field(
        default=None,
        metadata={
            "name": "RESOURCE-ESTIMATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resource_to_application_partition_mappings: Optional[
        "SystemMapping.ResourceToApplicationPartitionMappings"
    ] = field(
        default=None,
        metadata={
            "name": "RESOURCE-TO-APPLICATION-PARTITION-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rte_event_separations: Optional["SystemMapping.RteEventSeparations"] = field(
        default=None,
        metadata={
            "name": "RTE-EVENT-SEPARATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rte_event_to_os_task_proxy_mappings: Optional["SystemMapping.RteEventToOsTaskProxyMappings"] = (
        field(
            default=None,
            metadata={
                "name": "RTE-EVENT-TO-OS-TASK-PROXY-MAPPINGS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    signal_path_constraints: Optional["SystemMapping.SignalPathConstraints"] = field(
        default=None,
        metadata={
            "name": "SIGNAL-PATH-CONSTRAINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    software_cluster_to_resource_mappings: Optional[
        "SystemMapping.SoftwareClusterToResourceMappings"
    ] = field(
        default=None,
        metadata={
            "name": "SOFTWARE-CLUSTER-TO-RESOURCE-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_cluster_mappings: Optional["SystemMapping.SwClusterMappings"] = field(
        default=None,
        metadata={
            "name": "SW-CLUSTER-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_impl_mappings: Optional["SystemMapping.SwImplMappings"] = field(
        default=None,
        metadata={
            "name": "SW-IMPL-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_mappings: Optional["SystemMapping.SwMappings"] = field(
        default=None,
        metadata={
            "name": "SW-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_to_application_partition_mappings: Optional[
        "SystemMapping.SwcToApplicationPartitionMappings"
    ] = field(
        default=None,
        metadata={
            "name": "SWC-TO-APPLICATION-PARTITION-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AppOsTaskProxyToEcuTaskProxyMappings:
        app_os_task_proxy_to_ecu_task_proxy_mapping: list[AppOsTaskProxyToEcuTaskProxyMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "APP-OS-TASK-PROXY-TO-ECU-TASK-PROXY-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

    @dataclass(slots=True, kw_only=True)
    class ApplicationPartitionToEcuPartitionMappings:
        application_partition_to_ecu_partition_mapping: list[
            ApplicationPartitionToEcuPartitionMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-PARTITION-TO-ECU-PARTITION-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ComManagementMappings:
        com_management_mapping: list[ComManagementMapping] = field(
            default_factory=list,
            metadata={
                "name": "COM-MANAGEMENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CryptoServiceMappings:
        sec_oc_crypto_service_mapping: list[SecOcCryptoServiceMapping] = field(
            default_factory=list,
            metadata={
                "name": "SEC-OC-CRYPTO-SERVICE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        tls_crypto_service_mapping: list[TlsCryptoServiceMapping] = field(
            default_factory=list,
            metadata={
                "name": "TLS-CRYPTO-SERVICE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataMappings:
        client_server_to_signal_group_mapping: list[ClientServerToSignalGroupMapping] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-TO-SIGNAL-GROUP-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        client_server_to_signal_mapping: list[ClientServerToSignalMapping] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-TO-SIGNAL-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sender_receiver_composite_element_to_signal_mapping: list[
            SenderReceiverCompositeElementToSignalMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "SENDER-RECEIVER-COMPOSITE-ELEMENT-TO-SIGNAL-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sender_receiver_to_signal_group_mapping: list[SenderReceiverToSignalGroupMapping] = field(
            default_factory=list,
            metadata={
                "name": "SENDER-RECEIVER-TO-SIGNAL-GROUP-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sender_receiver_to_signal_mapping: list[SenderReceiverToSignalMapping] = field(
            default_factory=list,
            metadata={
                "name": "SENDER-RECEIVER-TO-SIGNAL-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        trigger_to_signal_mapping: list[TriggerToSignalMapping] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER-TO-SIGNAL-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuResourceMappings:
        ecu_mapping: list[EcuMapping] = field(
            default_factory=list,
            metadata={
                "name": "ECU-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class J1939ControllerApplicationToJ1939NmNodeMappings:
        j_1939_controller_application_to_j_1939_nm_node_mapping: list[
            J1939ControllerApplicationToJ1939NmNodeMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-CONTROLLER-APPLICATION-TO-J-1939-NM-NODE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MappingConstraints:
        component_clustering: list[ComponentClustering] = field(
            default_factory=list,
            metadata={
                "name": "COMPONENT-CLUSTERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        component_separation: list[ComponentSeparation] = field(
            default_factory=list,
            metadata={
                "name": "COMPONENT-SEPARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        swc_to_ecu_mapping_constraint: list[SwcToEcuMappingConstraint] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TO-ECU-MAPPING-CONSTRAINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PncMappings:
        pnc_mapping: list[PncMapping] = field(
            default_factory=list,
            metadata={
                "name": "PNC-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortElementToComResourceMappings:
        port_element_to_communication_resource_mapping: list[
            PortElementToCommunicationResourceMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "PORT-ELEMENT-TO-COMMUNICATION-RESOURCE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ResourceEstimations:
        ecu_resource_estimation: list[EcuResourceEstimation] = field(
            default_factory=list,
            metadata={
                "name": "ECU-RESOURCE-ESTIMATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ResourceToApplicationPartitionMappings:
        cp_software_cluster_resource_to_application_partition_mapping: list[
            CpSoftwareClusterResourceToApplicationPartitionMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "CP-SOFTWARE-CLUSTER-RESOURCE-TO-APPLICATION-PARTITION-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RteEventSeparations:
        rte_event_in_system_separation: list[RteEventInSystemSeparation] = field(
            default_factory=list,
            metadata={
                "name": "RTE-EVENT-IN-SYSTEM-SEPARATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RteEventToOsTaskProxyMappings:
        rte_event_in_system_to_os_task_proxy_mapping: list[RteEventInSystemToOsTaskProxyMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "RTE-EVENT-IN-SYSTEM-TO-OS-TASK-PROXY-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

    @dataclass(slots=True, kw_only=True)
    class SignalPathConstraints:
        common_signal_path: list[CommonSignalPath] = field(
            default_factory=list,
            metadata={
                "name": "COMMON-SIGNAL-PATH",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        forbidden_signal_path: list[ForbiddenSignalPath] = field(
            default_factory=list,
            metadata={
                "name": "FORBIDDEN-SIGNAL-PATH",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        permissible_signal_path: list[PermissibleSignalPath] = field(
            default_factory=list,
            metadata={
                "name": "PERMISSIBLE-SIGNAL-PATH",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        separate_signal_path: list[SeparateSignalPath] = field(
            default_factory=list,
            metadata={
                "name": "SEPARATE-SIGNAL-PATH",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SoftwareClusterToResourceMappings:
        cp_software_cluster_to_resource_mapping: list[CpSoftwareClusterToResourceMapping] = field(
            default_factory=list,
            metadata={
                "name": "CP-SOFTWARE-CLUSTER-TO-RESOURCE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwClusterMappings:
        cp_software_cluster_to_ecu_instance_mapping: list[CpSoftwareClusterToEcuInstanceMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "CP-SOFTWARE-CLUSTER-TO-ECU-INSTANCE-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

    @dataclass(slots=True, kw_only=True)
    class SwImplMappings:
        swc_to_impl_mapping: list[SwcToImplMapping] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TO-IMPL-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwMappings:
        swc_to_ecu_mapping: list[SwcToEcuMapping] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TO-ECU-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcToApplicationPartitionMappings:
        swc_to_application_partition_mapping: list[SwcToApplicationPartitionMapping] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TO-APPLICATION-PARTITION-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApplicationAssocMapElementValueSpecification:
    """
    This meta-class represents the ability to define the initialization of the
    elements of an ApplicationAssocMapDataType.

    :ivar key: This aggregation represents the initialization of the key
        part of an AssociativeElementValueSpecification. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar value: This aggregation represents the initialization of the
        value part of an AssociativeElementValueSpecification. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-ASSOC-MAP-ELEMENT-VALUE-SPECIFICATION"

    key: Optional["ApplicationAssocMapElementValueSpecification.Key"] = field(
        default=None,
        metadata={
            "name": "KEY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: Optional["ApplicationAssocMapElementValueSpecification.Value"] = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Key:
        application_assoc_map_value_specification: Optional[
            "ApplicationAssocMapValueSpecification"
        ] = field(
            default=None,
            metadata={
                "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: Optional["ArrayValueSpecification"] = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: Optional[
            "CompositeRuleBasedValueSpecification"
        ] = field(
            default=None,
            metadata={
                "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: Optional["RecordValueSpecification"] = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Value:
        application_assoc_map_value_specification: Optional[
            "ApplicationAssocMapValueSpecification"
        ] = field(
            default=None,
            metadata={
                "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: Optional["ArrayValueSpecification"] = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: Optional[
            "CompositeRuleBasedValueSpecification"
        ] = field(
            default=None,
            metadata={
                "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: Optional["RecordValueSpecification"] = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DataExchangePoint:
    """The Data Exchange Point describes the relationship between a work product
    and its intended use in the methodology with a tailoring of the AUTOSAR
    templates.

    An informal description is provided by the 'desc' and 'introduction' attributes of the DataExchangePoint. The informal description SHOULD include the subject that is described by this data exchange point.
    E.g.
    * producible data of tool A, version x
    * consumable data of tool B, version y
    * agreed profile between partner A and partner B in project xyz

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar kind: Specifies the kind of this DataExchangePoint. It
        provides information if this DataExchangePoint represents * the
        output of a tool that produce data, * the input of a tool that
        consumes data or * an agreed profile
    :ivar referenced_baseline: The baseline of the AUTOSAR standard that
        is used as a reference within this Data Exchange Point.
    :ivar specification_scope: The speficication of the relevant subset
        of Autosar standardized and custom specifications.
    :ivar data_format_tailoring: tailoring to the Autosar Exchange Data
        Format The subset and tailoring of the templates specifications
        (Meta-Classes, Attributes, Sdgs, Constraints, SpecItems)
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DATA-EXCHANGE-POINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DataExchangePoint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DataExchangePoint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    kind: DataExchangePointKind | None = field(
        default=None,
        metadata={
            "name": "KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    referenced_baseline: Baseline | None = field(
        default=None,
        metadata={
            "name": "REFERENCED-BASELINE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    specification_scope: SpecificationScope | None = field(
        default=None,
        metadata={
            "name": "SPECIFICATION-SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_format_tailoring: DataFormatTailoring | None = field(
        default=None,
        metadata={
            "name": "DATA-FORMAT-TAILORING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticRoutine:
    """
    This meta-class represents the ability to define a diagnostic routine.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar id: This is the numerical identifier used to identify the
        DiagnosticRoutine in the scope of diagnostic workflow
    :ivar request_result: This represents the ability to request the
        result of a running routine.
    :ivar routine_info: This represents the routine info byte. The info
        byte contains a manufacturer-specific value (for the
        identification of record identifiers) that is reported to the
        tester. Other use cases for this attribute are mentioned in ISO
        27145 and ISO 26021.
    :ivar start: This represents the ability to start a routine
    :ivar stop: This represents the ability to stop a running routine.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ROUTINE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticRoutine.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticRoutine.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    id: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_result: DiagnosticRequestRoutineResults | None = field(
        default=None,
        metadata={
            "name": "REQUEST-RESULT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    routine_info: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "ROUTINE-INFO",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    start: DiagnosticStartRoutine | None = field(
        default=None,
        metadata={
            "name": "START",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    stop: DiagnosticStopRoutine | None = field(
        default=None,
        metadata={
            "name": "STOP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucParamConfContainerDef:
    """
    Used to define configuration containers that can hierarchically contain other
    containers and/or parameter definitions.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar destination_uri_refs: Several destinationUris can be defined
        for an EcucContainerDef. With such destinationUris an
        EcucContainerDef is applicable for several EcucUriReferenceDefs.
    :ivar multiplicity_config_classes: Specifies which
        MultiplicityConfigurationClass this container is available for
        which ConfigurationVariant. This aggregation is optional if the
        surrounding EcucModuleDef has the Category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION and if
        the upperMultiplicity is greater than the lowerMultiplicity then
        this aggregation is mandatory.
    :ivar origin: This attribute specifies whether this configuration
        container is an AUTOSAR standardized container or whether it is
        vendor-specific.
    :ivar post_build_changeable: Specifies if the number of instances of
        this container may be changed in post-build selectable and post-
        build loadable time in the ECU Configuration Value Description.
        This attribute is only applicable to containers which may appear
        multiple times in the configuration set, i.e. their
        upperMultiplicity is greater than lowerMultiplicity and their
        upperMultiplicity is greater than 1. If a value of this
        attribute is not defined in the EcucModuleDef with category
        STANDARDIZED_MODULE_DEFINITION, it shall be defined in the
        EcucModuleDef with category VENDOR_SPECIFIC_MODULE_DEFINITION
        for all containers with upperMultiplicity greater than
        lowerMultiplicity and upperMultiplicity greater than 1. This
        attribute is removed from the specifications and shall not be
        used.
    :ivar post_build_variant_multiplicity: Indicates if a container may
        have different number of instances in different post-build
        variants (previously known as post-build selectable
        configuration sets). TRUE means yes, FALSE means no.
    :ivar requires_index: Used to define whether the value element for
        this definition shall be provided with an index.
    :ivar multiple_configuration_container: Specifies whether this
        container is used to define multiple configuration sets. Only
        one container in the whole EcucModuleDef shall have this
        enabled.
    :ivar parameters: The parameters defined within the
        EcucParamConfContainerDef.
    :ivar references: The references defined within the
        EcucParamConfContainerDef.
    :ivar sub_containers: The containers defined within the
        EcucParamConfContainerDef.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-PARAM-CONF-CONTAINER-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucParamConfContainerDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucParamConfContainerDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucParamConfContainerDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucParamConfContainerDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_uri_refs: Optional["EcucParamConfContainerDef.DestinationUriRefs"] = field(
        default=None,
        metadata={
            "name": "DESTINATION-URI-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiplicity_config_classes: Optional["EcucParamConfContainerDef.MultiplicityConfigClasses"] = (
        field(
            default=None,
            metadata={
                "name": "MULTIPLICITY-CONFIG-CLASSES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    origin: String | None = field(
        default=None,
        metadata={
            "name": "ORIGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_changeable: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-CHANGEABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_multiplicity: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requires_index: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUIRES-INDEX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multiple_configuration_container: Boolean | None = field(
        default=None,
        metadata={
            "name": "MULTIPLE-CONFIGURATION-CONTAINER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameters: Optional["EcucParamConfContainerDef.Parameters"] = field(
        default=None,
        metadata={
            "name": "PARAMETERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    references: Optional["EcucParamConfContainerDef.References"] = field(
        default=None,
        metadata={
            "name": "REFERENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sub_containers: Optional["EcucParamConfContainerDef.SubContainers"] = field(
        default=None,
        metadata={
            "name": "SUB-CONTAINERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DestinationUriRefs:
        destination_uri_ref: list[
            "EcucParamConfContainerDef.DestinationUriRefs.DestinationUriRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DESTINATION-URI-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DestinationUriRef(Ref):
            dest: EcucDestinationUriDefSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class MultiplicityConfigClasses:
        ecuc_multiplicity_configuration_class: list[EcucMultiplicityConfigurationClass] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTIPLICITY-CONFIGURATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Parameters:
        ecuc_add_info_param_def: list[EcucAddInfoParamDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-ADD-INFO-PARAM-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_boolean_param_def: list[EcucBooleanParamDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-BOOLEAN-PARAM-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_enumeration_param_def: list[EcucEnumerationParamDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-ENUMERATION-PARAM-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_float_param_def: list[EcucFloatParamDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-FLOAT-PARAM-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_function_name_def: list[EcucFunctionNameDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-FUNCTION-NAME-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_integer_param_def: list[EcucIntegerParamDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-INTEGER-PARAM-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_linker_symbol_def: list[EcucLinkerSymbolDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-LINKER-SYMBOL-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_multiline_string_param_def: list[EcucMultilineStringParamDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTILINE-STRING-PARAM-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_string_param_def: list[EcucStringParamDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-STRING-PARAM-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class References:
        ecuc_choice_reference_def: list[EcucChoiceReferenceDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-CHOICE-REFERENCE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_foreign_reference_def: list[EcucForeignReferenceDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-FOREIGN-REFERENCE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_instance_reference_def: list[EcucInstanceReferenceDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-INSTANCE-REFERENCE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_reference_def: list[EcucReferenceDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-REFERENCE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_symbolic_name_reference_def: list[EcucSymbolicNameReferenceDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-SYMBOLIC-NAME-REFERENCE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_uri_reference_def: list[EcucUriReferenceDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-URI-REFERENCE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SubContainers:
        ecuc_choice_container_def: list[EcucChoiceContainerDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-CHOICE-CONTAINER-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_param_conf_container_def: list["EcucParamConfContainerDef"] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-PARAM-CONF-CONTAINER-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EthernetCommunicationController:
    """
    Ethernet specific communication port attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        EcuInstance.commController Not Applicable for:
        MachineDesign.communicationController
    :ivar ethernet_communication_controller_variants: This element was
        generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-COMMUNICATION-CONTROLLER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthernetCommunicationController.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthernetCommunicationController.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ethernet_communication_controller_variants: Optional[
        "EthernetCommunicationController.EthernetCommunicationControllerVariants"
    ] = field(
        default=None,
        metadata={
            "name": "ETHERNET-COMMUNICATION-CONTROLLER-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EthernetCommunicationControllerVariants:
        ethernet_communication_controller_conditional: list[
            EthernetCommunicationControllerConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-COMMUNICATION-CONTROLLER-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LabeledList:
    """This meta-class represents a labeled list, in which items have a label and a
    content.

    The policy how to render such items is specified in the labeled
    list.

    :ivar indent_sample: This is a sample item. This sample is used by a
        rendering system to measure out the width of indentation. Since
        this depends on the particular fontsize etc. the indentation
        cannot be specified e.g. in mm.
    :ivar labeled_item: This represents one particular item in the
        labeled list.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DocumentationBlock.labeledList
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    """

    class Meta:
        name = "LABELED-LIST"

    indent_sample: IndentSample | None = field(
        default=None,
        metadata={
            "name": "INDENT-SAMPLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    labeled_item: list[LabeledItem] = field(
        default_factory=list,
        metadata={
            "name": "LABELED-ITEM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class McSupportData:
    """Root element for all measurement and calibration support data related to one
    Implementation artifact on an ECU.

    There shall be one such element related to the RTE implementation
    (if it owns MC data) and a separate one for each module or
    component, which owns private MC data.

    :ivar emulation_supports: Describes the calibration method used by
        the RTE. This information is not needed for A2L generation, but
        to setup software emulation in the ECU.
    :ivar mc_parameter_instances: A data instance to be used for
        calibration.
    :ivar mc_variable_instances: A data instance to be used for
        measurement.
    :ivar measurable_system_constant_values_refs: Sets of system
        constant values to be transferred to the MCD system, because the
        system constants have been specified with "swCalibrationAccess"
        = readonly.
    :ivar rpt_support_data: The rapid prototyping support data belonging
        to this implementation. The aggregtion is
        &lt;&lt;atpSplitable&gt;&gt; because in case of an already
        exisiting BSW Implementation model, this description will be
        added later in the process, namely at code generation time.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MC-SUPPORT-DATA"

    emulation_supports: Optional["McSupportData.EmulationSupports"] = field(
        default=None,
        metadata={
            "name": "EMULATION-SUPPORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_parameter_instances: Optional["McSupportData.McParameterInstances"] = field(
        default=None,
        metadata={
            "name": "MC-PARAMETER-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_variable_instances: Optional["McSupportData.McVariableInstances"] = field(
        default=None,
        metadata={
            "name": "MC-VARIABLE-INSTANCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    measurable_system_constant_values_refs: Optional[
        "McSupportData.MeasurableSystemConstantValuesRefs"
    ] = field(
        default=None,
        metadata={
            "name": "MEASURABLE-SYSTEM-CONSTANT-VALUES-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rpt_support_data: RptSupportData | None = field(
        default=None,
        metadata={
            "name": "RPT-SUPPORT-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class EmulationSupports:
        mc_sw_emulation_method_support: list[McSwEmulationMethodSupport] = field(
            default_factory=list,
            metadata={
                "name": "MC-SW-EMULATION-METHOD-SUPPORT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class McParameterInstances:
        mc_data_instance: list[McDataInstance] = field(
            default_factory=list,
            metadata={
                "name": "MC-DATA-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class McVariableInstances:
        mc_data_instance: list[McDataInstance] = field(
            default_factory=list,
            metadata={
                "name": "MC-DATA-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MeasurableSystemConstantValuesRefs:
        measurable_system_constant_values_ref: list[
            "McSupportData.MeasurableSystemConstantValuesRefs.MeasurableSystemConstantValuesRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MEASURABLE-SYSTEM-CONSTANT-VALUES-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class MeasurableSystemConstantValuesRef(Ref):
            dest: SwSystemconstantValueSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class PortInterfaceMappingSet:
    """
    Specifies a set of (one or more) PortInterfaceMappings.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar port_interface_mappings: Specifies one PortInterfaceMapping to
        support the connection of Ports typed by two different
        PortInterfaces with PortInterface elements having unequal names
        and/or unequal semantic (resolution or range).
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-INTERFACE-MAPPING-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PortInterfaceMappingSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PortInterfaceMappingSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["PortInterfaceMappingSet.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_interface_mappings: Optional["PortInterfaceMappingSet.PortInterfaceMappings"] = field(
        default=None,
        metadata={
            "name": "PORT-INTERFACE-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortInterfaceMappings:
        client_server_interface_mapping: list[ClientServerInterfaceMapping] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-INTERFACE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mode_interface_mapping: list[ModeInterfaceMapping] = field(
            default_factory=list,
            metadata={
                "name": "MODE-INTERFACE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        service_interface_mapping: list[ServiceInterfaceMapping] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        trigger_interface_mapping: list[TriggerInterfaceMapping] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER-INTERFACE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        variable_and_parameter_interface_mapping: list[VariableAndParameterInterfaceMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "VARIABLE-AND-PARAMETER-INTERFACE-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class SocketAddress:
    """This meta-class represents a socket address towards the rest of the meta-
    model.

    The actual semantics of the represented socket address, however, is
    contributed by aggregation of an ApplicationEndpoint.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar allowed_i_pv_6_ext_headers_ref: Reference to a list of IPv6
        Extension Headers allowed for this SocketConnection. If no list
        is referenced all IPv6 Extension Headers are allowed and
        processed.
    :ivar allowed_tcp_options_ref: Reference to a list of TCP options
        allowed for this SocketConnection.
    :ivar application_endpoint: Application addressing
    :ivar connector_ref: Association to a CommunicationConnector in the
        topology description. This reference shall be used if the
        SocketAddress describes an IP unicast address for an ECU that is
        part of the model.
    :ivar differentiated_service_field: The 6-bit Differentiated Service
        Field in the IP headers may be used for classifying network
        traffic. If not set a value of zero is used to indicate packets
        that have not been classified.
    :ivar flow_label: The 20-bit Flow Label field in the IPv6 header may
        be used by a source to label sequences of packets for which it
        requests special handling by the IPv6 routers, such as non-
        default quality of service. If not set a Flow Label of zero is
        used to indicate packets that have not been labeled.
    :ivar ip_address: This attribute is deprecated and will be removed
        in future. It is replaced by the aggregated NetworkEndpoint.
    :ivar multicast_connector_refs: Association to a
        CommunicationConnector in the topology description. This
        reference shall be used if the SocketAddress describes an IP
        multicast address. This multicast SocketAddress  contains
        references to those ECUs in the model that want to receive the
        multicast messages.
    :ivar path_mtu_discovery_enabled: Defines whether the Path MTU
        Discovery shall be performed for the related socket.
    :ivar pdu_collection_max_buffer_size: Defines the maximum buffer
        size in Byte which shall be filled before a socket with Pdu
        collection enabled shall be transmitted to the lower layer.
    :ivar pdu_collection_timeout: Defines the time in seconds which
        shall pass before a socket with Pdu collection enabled shall be
        transmitted to the lower layer after the first Pdu has been put
        into the socket buffer.
    :ivar port_address: This attribute is deprecated and will be removed
        in future. It is replaced by the aggregated ApplicationEndpoint.
    :ivar static_socket_connections: Definition of a static
        SocketConnection.
    :ivar udp_checksum_handling: Specifies if UDP checksum handling
        shall be enabled (udpChecksumEnabled) or skipped
        (udpChecksumDisabled) on the related socket connection.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SoAdConfig.socketAddress
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SOCKET-ADDRESS"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SocketAddress.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SocketAddress.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    allowed_i_pv_6_ext_headers_ref: Optional["SocketAddress.AllowedIPv6ExtHeadersRef"] = field(
        default=None,
        metadata={
            "name": "ALLOWED-I-PV-6-EXT-HEADERS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    allowed_tcp_options_ref: Optional["SocketAddress.AllowedTcpOptionsRef"] = field(
        default=None,
        metadata={
            "name": "ALLOWED-TCP-OPTIONS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    application_endpoint: ApplicationEndpoint | None = field(
        default=None,
        metadata={
            "name": "APPLICATION-ENDPOINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    connector_ref: Optional["SocketAddress.ConnectorRef"] = field(
        default=None,
        metadata={
            "name": "CONNECTOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    differentiated_service_field: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "DIFFERENTIATED-SERVICE-FIELD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    flow_label: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "FLOW-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ip_address: String | None = field(
        default=None,
        metadata={
            "name": "IP-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    multicast_connector_refs: Optional["SocketAddress.MulticastConnectorRefs"] = field(
        default=None,
        metadata={
            "name": "MULTICAST-CONNECTOR-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    path_mtu_discovery_enabled: Boolean | None = field(
        default=None,
        metadata={
            "name": "PATH-MTU-DISCOVERY-ENABLED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_collection_max_buffer_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PDU-COLLECTION-MAX-BUFFER-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_collection_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PDU-COLLECTION-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_address: Integer | None = field(
        default=None,
        metadata={
            "name": "PORT-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    static_socket_connections: Optional["SocketAddress.StaticSocketConnections"] = field(
        default=None,
        metadata={
            "name": "STATIC-SOCKET-CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    udp_checksum_handling: UdpChecksumCalculationEnum | None = field(
        default=None,
        metadata={
            "name": "UDP-CHECKSUM-HANDLING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AllowedIPv6ExtHeadersRef(Ref):
        dest: IPv6ExtHeaderFilterListSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class AllowedTcpOptionsRef(Ref):
        dest: TcpOptionFilterListSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ConnectorRef(Ref):
        dest: EthernetCommunicationConnectorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class MulticastConnectorRefs:
        multicast_connector_ref: list[
            "SocketAddress.MulticastConnectorRefs.MulticastConnectorRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MULTICAST-CONNECTOR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class MulticastConnectorRef(Ref):
            dest: EthernetCommunicationConnectorSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class StaticSocketConnections:
        static_socket_connection: list[StaticSocketConnection] = field(
            default_factory=list,
            metadata={
                "name": "STATIC-SOCKET-CONNECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApplicationAssocMapValueSpecification:
    """
    This meta-class represents the ability to define the initialization of an
    ApplicationAssocMapDataType.

    :ivar short_label: This can be used to identify particular value
        specifications for human readers, for example elements of a
        record type.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ArrayValueSpecification.element Applicable for:
        RecordValueSpecification.field Not Applicable for:
        CompositeRuleBasedValueSpecification.argument Not Applicable
        for: ConstantSpecification.valueSpec Not Applicable for:
        PortPrototypeBlueprintInitValue.value Not Applicable for:
        DiagnosticEnvDataCondition.compareValue Not Applicable for:
        DiagnosticEnvDataElementCondition.compareValue Not Applicable
        for: ParameterDataPrototype.initValue Not Applicable for:
        VariableDataPrototype.initValue Not Applicable for:
        CalibrationParameterValue.applInitValue Not Applicable for:
        CalibrationParameterValue.implInitValue Not Applicable for:
        MetaDataItem.metaDataItemType Not Applicable for:
        NvProvideComSpec.romBlockInitValue Not Applicable for:
        NvProvideComSpec.ramBlockInitValue Not Applicable for:
        NvRequireComSpec.initValue Not Applicable for:
        ParameterProvideComSpec.initValue Not Applicable for:
        ParameterRequireComSpec.initValue Not Applicable for:
        NonqueuedSenderComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.timeoutSubstitutionValue Not Applicable
        for: PortDefinedArgumentValue.value Not Applicable for:
        CryptoServiceKey.developmentValue Not Applicable for:
        ISignal.timeoutSubstitutionValue Not Applicable for:
        ISignal.initValue Not Applicable for:
        FieldSenderComSpec.initValue Not Applicable for:
        PersistencyDataRequiredComSpec.initValue Not Applicable for:
        ApplicationAssocMapElementValueSpecification.value Not
        Applicable for: ApplicationAssocMapElementValueSpecification.key
        Not Applicable for: StateManagementCompareCondition.compareValue
        Not Applicable for: PersistencyKeyValuePair.initValue Not
        Applicable for: SwDataDefPropsContent.invalidValue
    :ivar map_element_tuples: This aggregation represents the initial
        values for the elements of the
        ApplicationAssocMapValueSpecification.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    map_element_tuples: Optional["ApplicationAssocMapValueSpecification.MapElementTuples"] = field(
        default=None,
        metadata={
            "name": "MAP-ELEMENT-TUPLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class MapElementTuples:
        application_assoc_map_element_value_specification: list[
            ApplicationAssocMapElementValueSpecification
        ] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-ASSOC-MAP-ELEMENT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BswImplementation:
    """Contains the implementation specific information in addition to the generic
    specification (BswModuleDescription and BswBehavior).

    It is possible to have several different BswImplementations
    referring to the same BswBehavior.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar build_action_manifests: A manifest specifying the intended
        build actions for the software delivered with this
        implementation. This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar code_descriptors: Specifies the provided implementation code.
    :ivar compilers: Specifies the compiler for which this
        implementation has been released
    :ivar generated_artifacts: Relates to an artifact that will be
        generated during the integration of this Implementation by an
        associated generator tool. Note that this is an optional
        information since it might  not always be in the scope of a
        single module or component  to provide this information.
    :ivar hw_element_refs: The hardware elements (e.g. the processor)
        required for this implementation.
    :ivar linkers: Specifies the linker for which this implementation
        has been released.
    :ivar mc_support: The measurement &amp; calibration support data
        belonging to this implementation. The aggregtion is
        &lt;&lt;atpSplitable&gt;&gt; because in case of an already
        exisiting BSW Implementation model, this description will be
        added later in the process, namely at code generation time.
    :ivar programming_language: Programming language the implementation
        was created in.
    :ivar required_artifacts: Specifies that this Implementation depends
        on the existance of another artifact (e.g. a library). This
        aggregation of DependencyOnArtifact is subject to variability
        with the purpose to support variability in the implementations.
        Different algorithms in the implementation might cause different
        dependencies, e.g. the number of used libraries.
    :ivar required_generator_tools: Relates this Implementation to a
        generator tool in order to generate additional artifacts during
        integration.
    :ivar resource_consumption: All static and dynamic resources for
        each implementation are described  within the
        ResourceConsumption class.
    :ivar sw_version: Software version of this implementation. The
        numbering contains three levels (like major, minor, patch), its
        values are vendor specific.
    :ivar swc_bsw_mapping_ref: This allows a mapping between an SWC and
        a BSW behavior to be attached to an implementation description
        (for AUTOSAR Service, ECU Abstraction and Complex Driver
        Components).  It is up to the methodology to define whether this
        reference has to be set for the Swc- or BswImplementtion or for
        both.
    :ivar used_code_generator: Optional: code generator used.
    :ivar vendor_id: Vendor ID of this Implementation according to the
        AUTOSAR vendor list
    :ivar ar_release_version: Version of the AUTOSAR Release on which
        this implementation is based. The numbering contains three
        levels (major, minor, revision) which are defined by AUTOSAR.
    :ivar behavior_ref: The behavior of this implementation. This
        relation is made as an association because * it follows the
        pattern of the SWCT * since ARElement cannot be splitted, but we
        want supply the implementation later, the BswImplementation is
        not aggregated in BswBehavior
    :ivar debug_infos: Collects the debug info for this implementation.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar preconfigured_configuration_refs: Reference to the set of
        preconfigured (i.e. fixed) configuration values for this
        BswImplementation. If the BswImplementation represents a cluster
        of several modules, more than one EcucModuleConfigurationValues
        element can be referred (at most one per module), otherwise at
        most one such element can be referred.
    :ivar recommended_configuration_refs: Reference to one or more sets
        of recommended configuration values for this module or module
        cluster.
    :ivar vendor_api_infix: In driver modules which can be instantiated
        several times on a single ECU, SRS_BSW_00347 requires that the
        names of files, APIs, published parameters and memory allocation
        keywords are extended by the vendorId and a vendor specific
        name. This parameter is used to specify the vendor specific
        name. In total, the implementation specific API name is
        generated as follows: &lt;ModuleName&gt;_&lt;vendorId&gt;_
        &lt;vendorApiInfix&gt;_&lt;API name from SWS&gt;. E.g.  assuming
        that the vendorId of the implementer is 123 and the implementer
        chose a vendorApiInfix of "v11r456" an API name Can_Write
        defined in the SWS will translate to Can_123_v11r456_Write. This
        attribute is mandatory for all modules with upper multiplicity
        &gt; 1. It shall not be used for modules with upper multiplicity
        =1. See also SWS_BSW_00102.
    :ivar vendor_specific_module_def_refs: Reference to * the vendor
        specific EcucModuleDef used in this BswImplementation if it
        represents a single module * several EcucModuleDefs used in this
        BswImplementation if it  represents a cluster of modules * one
        or no EcucModuleDefs used in this BswImplementation if it
        represents a library
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-IMPLEMENTATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswImplementation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswImplementation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    build_action_manifests: Optional["BswImplementation.BuildActionManifests"] = field(
        default=None,
        metadata={
            "name": "BUILD-ACTION-MANIFESTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    code_descriptors: Optional["BswImplementation.CodeDescriptors"] = field(
        default=None,
        metadata={
            "name": "CODE-DESCRIPTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compilers: Optional["BswImplementation.Compilers"] = field(
        default=None,
        metadata={
            "name": "COMPILERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    generated_artifacts: Optional["BswImplementation.GeneratedArtifacts"] = field(
        default=None,
        metadata={
            "name": "GENERATED-ARTIFACTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_element_refs: Optional["BswImplementation.HwElementRefs"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    linkers: Optional["BswImplementation.Linkers"] = field(
        default=None,
        metadata={
            "name": "LINKERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_support: McSupportData | None = field(
        default=None,
        metadata={
            "name": "MC-SUPPORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    programming_language: ProgramminglanguageEnum | None = field(
        default=None,
        metadata={
            "name": "PROGRAMMING-LANGUAGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_artifacts: Optional["BswImplementation.RequiredArtifacts"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-ARTIFACTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_generator_tools: Optional["BswImplementation.RequiredGeneratorTools"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-GENERATOR-TOOLS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resource_consumption: ResourceConsumption | None = field(
        default=None,
        metadata={
            "name": "RESOURCE-CONSUMPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_version: RevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "SW-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_bsw_mapping_ref: Optional["BswImplementation.SwcBswMappingRef"] = field(
        default=None,
        metadata={
            "name": "SWC-BSW-MAPPING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    used_code_generator: String | None = field(
        default=None,
        metadata={
            "name": "USED-CODE-GENERATOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vendor_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VENDOR-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ar_release_version: RevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "AR-RELEASE-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    behavior_ref: Optional["BswImplementation.BehaviorRef"] = field(
        default=None,
        metadata={
            "name": "BEHAVIOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    debug_infos: Optional["BswImplementation.DebugInfos"] = field(
        default=None,
        metadata={
            "name": "DEBUG-INFOS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    preconfigured_configuration_refs: Optional[
        "BswImplementation.PreconfiguredConfigurationRefs"
    ] = field(
        default=None,
        metadata={
            "name": "PRECONFIGURED-CONFIGURATION-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    recommended_configuration_refs: Optional["BswImplementation.RecommendedConfigurationRefs"] = (
        field(
            default=None,
            metadata={
                "name": "RECOMMENDED-CONFIGURATION-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    vendor_api_infix: Identifier | None = field(
        default=None,
        metadata={
            "name": "VENDOR-API-INFIX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vendor_specific_module_def_refs: Optional["BswImplementation.VendorSpecificModuleDefRefs"] = (
        field(
            default=None,
            metadata={
                "name": "VENDOR-SPECIFIC-MODULE-DEF-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BuildActionManifests:
        build_action_manifest_ref_conditional: list[BuildActionManifestRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "BUILD-ACTION-MANIFEST-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CodeDescriptors:
        code: list[Code] = field(
            default_factory=list,
            metadata={
                "name": "CODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Compilers:
        compiler: list[Compiler] = field(
            default_factory=list,
            metadata={
                "name": "COMPILER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class GeneratedArtifacts:
        dependency_on_artifact: list[DependencyOnArtifact] = field(
            default_factory=list,
            metadata={
                "name": "DEPENDENCY-ON-ARTIFACT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwElementRefs:
        hw_element_ref: list["BswImplementation.HwElementRefs.HwElementRef"] = field(
            default_factory=list,
            metadata={
                "name": "HW-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class HwElementRef(Ref):
            dest: HwElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class Linkers:
        linker: list[Linker] = field(
            default_factory=list,
            metadata={
                "name": "LINKER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredArtifacts:
        dependency_on_artifact: list[DependencyOnArtifact] = field(
            default_factory=list,
            metadata={
                "name": "DEPENDENCY-ON-ARTIFACT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredGeneratorTools:
        dependency_on_artifact: list[DependencyOnArtifact] = field(
            default_factory=list,
            metadata={
                "name": "DEPENDENCY-ON-ARTIFACT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcBswMappingRef(Ref):
        dest: SwcBswMappingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class BehaviorRef(Ref):
        dest: BswInternalBehaviorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DebugInfos:
        bsw_debug_info: list[BswDebugInfo] = field(
            default_factory=list,
            metadata={
                "name": "BSW-DEBUG-INFO",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PreconfiguredConfigurationRefs:
        preconfigured_configuration_ref: list[
            "BswImplementation.PreconfiguredConfigurationRefs.PreconfiguredConfigurationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "PRECONFIGURED-CONFIGURATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class PreconfiguredConfigurationRef(Ref):
            dest: EcucModuleConfigurationValuesSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class RecommendedConfigurationRefs:
        recommended_configuration_ref: list[
            "BswImplementation.RecommendedConfigurationRefs.RecommendedConfigurationRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "RECOMMENDED-CONFIGURATION-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class RecommendedConfigurationRef(Ref):
            dest: EcucModuleConfigurationValuesSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class VendorSpecificModuleDefRefs:
        vendor_specific_module_def_ref: list[
            "BswImplementation.VendorSpecificModuleDefRefs.VendorSpecificModuleDefRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "VENDOR-SPECIFIC-MODULE-DEF-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class VendorSpecificModuleDefRef(Ref):
            dest: EcucModuleDefSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class EcuInstance:
    """ECUInstances are used to define the ECUs used in the topology.

    The type of the ECU is defined by a reference to an ECU specified
    with the ECU resource description.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar associated_com_i_pdu_group_refs: With this reference it is
        possible to identify which ISignalIPduGroups are applicable for
        which CommunicationConnector/ ECU. Only top level
        ISignalIPduGroups shall be referenced by an EcuInstance. If an
        ISignalIPduGroup contains other ISignalIPduGroups than these
        contained ISignalIPduGroups shall not be referenced by the
        EcuInstance. Contained ISignalIPduGroups are associated to an
        EcuInstance via the top level ISignalIPduGroup.
    :ivar associated_consumed_provided_service_instance_groups: With
        this reference it is possible to identify which
        ConsumedProvidedServiceInstanceGroups are applicable for which
        ECUInstance. This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar associated_pdur_i_pdu_group_refs: With this reference it is
        possible to identify which PduR IPdu Groups are applicable for
        which CommunicationConnector/ ECU.
    :ivar can_tp_address_refs: Please note that this reference is
        deprecated and will be removed in future. A Tp Address can be
        assigned to an ECU without an existing TP Configuration. If
        TpNodes are described this reference shall not be used.
    :ivar client_id_range: Restriction of the Client Identifier for this
        Ecu to an allowed range of numerical values. The Client
        Identifier of the transaction handle is generated by the client
        RTE for inter-Ecu Client/Server communication.
    :ivar com_configuration_gw_time_base: The period between successive
        calls to Com_MainFunctionRouteSignals of the AUTOSAR COM module
        in seconds.
    :ivar com_configuration_rx_time_base: The period between successive
        calls to Com_MainFunctionRx of the AUTOSAR COM module in
        seconds.
    :ivar com_configuration_tx_time_base: The period between successive
        calls to Com_MainFunctionTx of the AUTOSAR COM module in
        seconds.
    :ivar com_enable_mdt_for_cyclic_transmission: Enables for the Com
        module of this EcuInstance the minimum delay time monitoring for
        cyclic and repeated transmissions (TransmissionModeTiming has
        cyclicTiming assigned or eventControlledTiming with
        numberOfRepetitions &gt; 0).
    :ivar comm_controllers: CommunicationControllers of the ECU.
    :ivar connectors: All channels controlled by a single controller.
    :ivar diagnostic_address: An ECU specific ID for responses of
        diagnostic routines.
    :ivar diagnostic_props: This represents the diagnostic-related
        properties of an entire ECU.
    :ivar dlt_config: Describes the Dlt configuration on this
        EcuInstance.
    :ivar do_ip_config: DoIp configuration on this EcuInstance.
    :ivar ecu_instance_propss: Additional properties of the EcuInstance
        that may vary in different Variants of the Ecu. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar ecu_task_proxy_refs: Reference to OsTaskProxies assigned to
        the EcuInstance.
    :ivar eth_switch_port_group_derivation: Defines whether the
        derivation of SwitchPortGroups based on VLAN and/or
        CouplingPort.pncMapping shall be performed for this EcuInstance.
        If not defined the derivation shall not be done.
    :ivar partitions: Optional definition of Partitions within an Ecu.
    :ivar pn_reset_time: Specifies the runtime of the reset timer in
        seconds. This reset time is valid for the reset of PN requests
        in the EIRA and in the ERA.
    :ivar pnc_nm_request: Defines if this EcuInstance shall request Nm
        on all its PhysicalChannels which have Nm variant set to FULL
        each time a PNC is requested.
    :ivar pnc_prepare_sleep_timer: Time in seconds the PNC state machine
        shall wait in PNC_PREPARE_SLEEP.
    :ivar pnc_synchronous_wakeup: If this parameter is available and set
        to true then all available PNCs will be woken up as soon as a
        channel wakeup occurs. This is ensured by adding all PNCs to all
        channel wakeup sources during upstream mapping.
    :ivar sleep_mode_supported: Specifies whether the ECU instance may
        be put to a "low power mode" * true: sleep mode is supported *
        false: sleep mode is not supported Note: This flag may only be
        set to "true" if the feature is supported by both hardware and
        basic software.
    :ivar tcp_ip_icmp_props_ref: EcuInstance specific ICMP (Internet
        Control Message Protocol) attributes
    :ivar tcp_ip_props_ref: EcuInstance specific TcpIp Stack attributes.
    :ivar tp_address_refs: Please note that this reference is deprecated
        and will be removed in future. A Tp Address can be assigned to
        an ECU without an existing TP Configuration. If TpNodes are
        described this reference shall not be used.
    :ivar v_2_x_supported: This attribute is used to control the
        existence of the V2X stack on the given EcuInstance.
    :ivar wake_up_over_bus_supported: Driver support for wakeup over
        Bus.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECU-INSTANCE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcuInstance.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcuInstance.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    associated_com_i_pdu_group_refs: Optional["EcuInstance.AssociatedComIPduGroupRefs"] = field(
        default=None,
        metadata={
            "name": "ASSOCIATED-COM-I-PDU-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    associated_consumed_provided_service_instance_groups: Optional[
        "EcuInstance.AssociatedConsumedProvidedServiceInstanceGroups"
    ] = field(
        default=None,
        metadata={
            "name": "ASSOCIATED-CONSUMED-PROVIDED-SERVICE-INSTANCE-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    associated_pdur_i_pdu_group_refs: Optional["EcuInstance.AssociatedPdurIPduGroupRefs"] = field(
        default=None,
        metadata={
            "name": "ASSOCIATED-PDUR-I-PDU-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_tp_address_refs: Optional["EcuInstance.CanTpAddressRefs"] = field(
        default=None,
        metadata={
            "name": "CAN-TP-ADDRESS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_id_range: ClientIdRange | None = field(
        default=None,
        metadata={
            "name": "CLIENT-ID-RANGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    com_configuration_gw_time_base: TimeValue | None = field(
        default=None,
        metadata={
            "name": "COM-CONFIGURATION-GW-TIME-BASE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    com_configuration_rx_time_base: TimeValue | None = field(
        default=None,
        metadata={
            "name": "COM-CONFIGURATION-RX-TIME-BASE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    com_configuration_tx_time_base: TimeValue | None = field(
        default=None,
        metadata={
            "name": "COM-CONFIGURATION-TX-TIME-BASE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    com_enable_mdt_for_cyclic_transmission: Boolean | None = field(
        default=None,
        metadata={
            "name": "COM-ENABLE-MDT-FOR-CYCLIC-TRANSMISSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_controllers: Optional["EcuInstance.CommControllers"] = field(
        default=None,
        metadata={
            "name": "COMM-CONTROLLERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    connectors: Optional["EcuInstance.Connectors"] = field(
        default=None,
        metadata={
            "name": "CONNECTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_address: Integer | None = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    diagnostic_props: DiagnosticEcuProps | None = field(
        default=None,
        metadata={
            "name": "DIAGNOSTIC-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dlt_config: DltConfig | None = field(
        default=None,
        metadata={
            "name": "DLT-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    do_ip_config: DoIpConfig | None = field(
        default=None,
        metadata={
            "name": "DO-IP-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_instance_propss: Optional["EcuInstance.EcuInstancePropss"] = field(
        default=None,
        metadata={
            "name": "ECU-INSTANCE-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_task_proxy_refs: Optional["EcuInstance.EcuTaskProxyRefs"] = field(
        default=None,
        metadata={
            "name": "ECU-TASK-PROXY-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    eth_switch_port_group_derivation: Boolean | None = field(
        default=None,
        metadata={
            "name": "ETH-SWITCH-PORT-GROUP-DERIVATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    partitions: Optional["EcuInstance.Partitions"] = field(
        default=None,
        metadata={
            "name": "PARTITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pn_reset_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PN-RESET-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_nm_request: Boolean | None = field(
        default=None,
        metadata={
            "name": "PNC-NM-REQUEST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_prepare_sleep_timer: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PNC-PREPARE-SLEEP-TIMER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_synchronous_wakeup: Boolean | None = field(
        default=None,
        metadata={
            "name": "PNC-SYNCHRONOUS-WAKEUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sleep_mode_supported: Boolean | None = field(
        default=None,
        metadata={
            "name": "SLEEP-MODE-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_icmp_props_ref: Optional["EcuInstance.TcpIpIcmpPropsRef"] = field(
        default=None,
        metadata={
            "name": "TCP-IP-ICMP-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_props_ref: Optional["EcuInstance.TcpIpPropsRef"] = field(
        default=None,
        metadata={
            "name": "TCP-IP-PROPS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tp_address_refs: Optional["EcuInstance.TpAddressRefs"] = field(
        default=None,
        metadata={
            "name": "TP-ADDRESS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    v_2_x_supported: V2XSupportEnum | None = field(
        default=None,
        metadata={
            "name": "V-2-X-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wake_up_over_bus_supported: Boolean | None = field(
        default=None,
        metadata={
            "name": "WAKE-UP-OVER-BUS-SUPPORTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AssociatedComIPduGroupRefs:
        associated_com_i_pdu_group_ref: list[
            "EcuInstance.AssociatedComIPduGroupRefs.AssociatedComIPduGroupRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "ASSOCIATED-COM-I-PDU-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class AssociatedComIPduGroupRef(Ref):
            dest: ISignalIPduGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class AssociatedConsumedProvidedServiceInstanceGroups:
        consumed_provided_service_instance_group_ref_conditional: list[
            ConsumedProvidedServiceInstanceGroupRefConditional
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONSUMED-PROVIDED-SERVICE-INSTANCE-GROUP-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class AssociatedPdurIPduGroupRefs:
        associated_pdur_i_pdu_group_ref: list[
            "EcuInstance.AssociatedPdurIPduGroupRefs.AssociatedPdurIPduGroupRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "ASSOCIATED-PDUR-I-PDU-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class AssociatedPdurIPduGroupRef(Ref):
            dest: PdurIPduGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class CanTpAddressRefs:
        can_tp_address_ref: list["EcuInstance.CanTpAddressRefs.CanTpAddressRef"] = field(
            default_factory=list,
            metadata={
                "name": "CAN-TP-ADDRESS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class CanTpAddressRef(Ref):
            dest: CanTpAddressSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class CommControllers:
        can_communication_controller: list[CanCommunicationController] = field(
            default_factory=list,
            metadata={
                "name": "CAN-COMMUNICATION-CONTROLLER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_communication_controller: list[EthernetCommunicationController] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-COMMUNICATION-CONTROLLER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_communication_controller: list[FlexrayCommunicationController] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-COMMUNICATION-CONTROLLER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_master: list[LinMaster] = field(
            default_factory=list,
            metadata={
                "name": "LIN-MASTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_slave: list[LinSlave] = field(
            default_factory=list,
            metadata={
                "name": "LIN-SLAVE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ttcan_communication_controller: list[TtcanCommunicationController] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-COMMUNICATION-CONTROLLER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_communication_controller: list[UserDefinedCommunicationController] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-COMMUNICATION-CONTROLLER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Connectors:
        can_communication_connector: list[CanCommunicationConnector] = field(
            default_factory=list,
            metadata={
                "name": "CAN-COMMUNICATION-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_communication_connector: list[EthernetCommunicationConnector] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-COMMUNICATION-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_communication_connector: list[FlexrayCommunicationConnector] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-COMMUNICATION-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_communication_connector: list[LinCommunicationConnector] = field(
            default_factory=list,
            metadata={
                "name": "LIN-COMMUNICATION-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ttcan_communication_connector: list[TtcanCommunicationConnector] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-COMMUNICATION-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_communication_connector: list[UserDefinedCommunicationConnector] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-COMMUNICATION-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuInstancePropss:
        ecu_instance_props: list[EcuInstanceProps] = field(
            default_factory=list,
            metadata={
                "name": "ECU-INSTANCE-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EcuTaskProxyRefs:
        ecu_task_proxy_ref: list["EcuInstance.EcuTaskProxyRefs.EcuTaskProxyRef"] = field(
            default_factory=list,
            metadata={
                "name": "ECU-TASK-PROXY-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EcuTaskProxyRef(Ref):
            dest: OsTaskProxySubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class Partitions:
        ecu_partition: list[EcuPartition] = field(
            default_factory=list,
            metadata={
                "name": "ECU-PARTITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TcpIpIcmpPropsRef(Ref):
        dest: EthTcpIpIcmpPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TcpIpPropsRef(Ref):
        dest: EthTcpIpPropsSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TpAddressRefs:
        tp_address_ref: list["EcuInstance.TpAddressRefs.TpAddressRef"] = field(
            default_factory=list,
            metadata={
                "name": "TP-ADDRESS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TpAddressRef(Ref):
            dest: TpAddressSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class EcucDestinationUriPolicy:
    """The EcucDestinationUriPolicy describes the EcucContainerDef that will be
    targeted by EcucUriReferenceDefs.

    The type of the description is dependent of the
    destinationUriNestingContract attribute.

    :ivar containers: Description of the targetContainer in case that
        the destinationUriNestingPolicy is set to targetContainer. In
        all other cases the subContainers of the target container are
        defined here.
    :ivar destination_uri_nesting_contract: This attribute defines how
        the referenced target EcucContainerDef is described.
    :ivar parameters: Description of parameters that are contained in
        the target container.
    :ivar references: Description of references that are contained in
        the target container.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-DESTINATION-URI-POLICY"

    containers: Optional["EcucDestinationUriPolicy.Containers"] = field(
        default=None,
        metadata={
            "name": "CONTAINERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_uri_nesting_contract: EcucDestinationUriNestingContractEnum | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-URI-NESTING-CONTRACT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameters: Optional["EcucDestinationUriPolicy.Parameters"] = field(
        default=None,
        metadata={
            "name": "PARAMETERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    references: Optional["EcucDestinationUriPolicy.References"] = field(
        default=None,
        metadata={
            "name": "REFERENCES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Containers:
        ecuc_choice_container_def: list[EcucChoiceContainerDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-CHOICE-CONTAINER-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_param_conf_container_def: list[EcucParamConfContainerDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-PARAM-CONF-CONTAINER-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Parameters:
        ecuc_add_info_param_def: list[EcucAddInfoParamDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-ADD-INFO-PARAM-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_boolean_param_def: list[EcucBooleanParamDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-BOOLEAN-PARAM-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_enumeration_param_def: list[EcucEnumerationParamDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-ENUMERATION-PARAM-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_float_param_def: list[EcucFloatParamDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-FLOAT-PARAM-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_function_name_def: list[EcucFunctionNameDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-FUNCTION-NAME-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_integer_param_def: list[EcucIntegerParamDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-INTEGER-PARAM-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_linker_symbol_def: list[EcucLinkerSymbolDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-LINKER-SYMBOL-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_multiline_string_param_def: list[EcucMultilineStringParamDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MULTILINE-STRING-PARAM-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_string_param_def: list[EcucStringParamDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-STRING-PARAM-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class References:
        ecuc_choice_reference_def: list[EcucChoiceReferenceDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-CHOICE-REFERENCE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_foreign_reference_def: list[EcucForeignReferenceDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-FOREIGN-REFERENCE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_instance_reference_def: list[EcucInstanceReferenceDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-INSTANCE-REFERENCE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_reference_def: list[EcucReferenceDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-REFERENCE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_symbolic_name_reference_def: list[EcucSymbolicNameReferenceDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-SYMBOLIC-NAME-REFERENCE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_uri_reference_def: list[EcucUriReferenceDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-URI-REFERENCE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucModuleDef:
    """
    Used as the top-level element for configuration definition for Software
    Modules, including BSW and RTE as well as ECU Infrastructure.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar related_trace_item_ref: This contains a sloppy reference to
        the Autosar compatible identifier of the element (EcucId).
    :ivar ecuc_validation_conds: Collection of validation conditions
        which all need to evaluate to true in order to indicate a valid
        validation condition of the EcucDefinitionElement.
    :ivar ecuc_cond: If it evaluates to true the Ecu Parameter
        definition shall be processed as specified. Otherwise the
        parameter definition shall be ignored.
    :ivar lower_multiplicity: The lower multiplicity of the specified
        element. 0: optional 1: at least one occurrence n: at least n
        occurrences atpVariation: [RS_ECUC_00082]
    :ivar upper_multiplicity: The upper multiplicity of the specified
        element. 0: no occurrence (used for VSMD) 1: at most one
        occurrence m: at most m occurrences If upperMultiplicity is set
        than upperMultiplicityInfinite shall not be used. atpVariation:
        [RS_ECUC_00082]
    :ivar upper_multiplicity_infinite: To express an infinite number of
        occurrences of this element this attribute has to be set to
        true. If upperMultiplicityInfinite is set than upperMultiplicity
        shall not be used. atpVariation: [RS_ECUC_00082]
    :ivar scope: Specifies the scope of this configuration element.
    :ivar api_service_prefix: For modules where several instances of the
        VSMD can be defined the apiServicePrefix defines the API
        namespace of the derived instances, e.g. Cdd, Xfrm (ComXf,
        SomeIpXf, E2EXf).
    :ivar post_build_variant_support: Indicates if a module supports
        different post-build variants (previously known as post-build
        selectable configuration sets). TRUE means yes, FALSE means no.
    :ivar refined_module_def_ref: Optional reference from the Vendor
        Specific Module Definition to the Standardized Module Definition
        it refines. In case this EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION this reference shall not be
        provided. In case this EcucModuleDef has the category
        VENDOR_SPECIFIC_MODULE_DEFINITION this reference is mandatory.
    :ivar supported_config_variants: Specifies which
        ConfigurationVariants are supported by this software module.
        This attribute is optional if the EcucModuleDef has the category
        STANDARDIZED_MODULE_DEFINITION. If the category attribute of the
        EcucModuleDef is set to VENDOR_SPECIFIC_MODULE_DEFINITION then
        this attribute is mandatory.
    :ivar containers: Aggregates the top-level container definitions of
        this specific module definition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-MODULE-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucModuleDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucModuleDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["EcucModuleDef.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    related_trace_item_ref: Optional["EcucModuleDef.RelatedTraceItemRef"] = field(
        default=None,
        metadata={
            "name": "RELATED-TRACE-ITEM-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_validation_conds: Optional["EcucModuleDef.EcucValidationConds"] = field(
        default=None,
        metadata={
            "name": "ECUC-VALIDATION-CONDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecuc_cond: EcucConditionSpecification | None = field(
        default=None,
        metadata={
            "name": "ECUC-COND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lower_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "LOWER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    upper_multiplicity_infinite: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "UPPER-MULTIPLICITY-INFINITE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scope: EcucScopeEnum | None = field(
        default=None,
        metadata={
            "name": "SCOPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    api_service_prefix: CIdentifier | None = field(
        default=None,
        metadata={
            "name": "API-SERVICE-PREFIX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    post_build_variant_support: Boolean | None = field(
        default=None,
        metadata={
            "name": "POST-BUILD-VARIANT-SUPPORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    refined_module_def_ref: Optional["EcucModuleDef.RefinedModuleDefRef"] = field(
        default=None,
        metadata={
            "name": "REFINED-MODULE-DEF-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    supported_config_variants: Optional["EcucModuleDef.SupportedConfigVariants"] = field(
        default=None,
        metadata={
            "name": "SUPPORTED-CONFIG-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    containers: Optional["EcucModuleDef.Containers"] = field(
        default=None,
        metadata={
            "name": "CONTAINERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RelatedTraceItemRef(Ref):
        dest: TraceableSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class EcucValidationConds:
        ecuc_validation_condition: list[EcucValidationCondition] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALIDATION-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RefinedModuleDefRef(Ref):
        dest: EcucModuleDefSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SupportedConfigVariants:
        supported_config_variant: list[EcucConfigurationVariantEnum] = field(
            default_factory=list,
            metadata={
                "name": "SUPPORTED-CONFIG-VARIANT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Containers:
        ecuc_choice_container_def: list[EcucChoiceContainerDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-CHOICE-CONTAINER-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_param_conf_container_def: list[EcucParamConfContainerDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-PARAM-CONF-CONTAINER-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class MachineDesign:
    """
    This meta-class represents the ability to define requirements on a Machine in
    the context of designing a system.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar access_control: This attribute defines how the access
        restriction to the Service Instance is defined.
    :ivar communication_connectors: This aggregation defines the network
        connection of the machine. This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar communication_controllers: CommunicationControllers of the
        Machine that are used for description of 10-Base-T1S topologies
        This aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar eth_ip_props_refs: Machine specific IP attributes.
    :ivar pn_reset_timer: Specifies the runtime of the reset timer in
        seconds. This reset time is valid for the reset of PN requests.
    :ivar pnc_prepare_sleep_timer: Time in seconds the PNC state machine
        shall wait in PNC_PREPARE_SLEEP.
    :ivar service_discovery_configs: Set of service discovery
        configuration settings that are defined on the machine for
        individual CommunicationConnectors.
    :ivar tcp_ip_icmp_props_refs: Machine specific ICMP (Internet
        Control Message Protocol) attributes
    :ivar tcp_ip_props_refs: Machine specific TcpIp Stack attributes.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MACHINE-DESIGN"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["MachineDesign.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["MachineDesign.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    access_control: AccessControlEnum | None = field(
        default=None,
        metadata={
            "name": "ACCESS-CONTROL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_connectors: Optional["MachineDesign.CommunicationConnectors"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONNECTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    communication_controllers: Optional["MachineDesign.CommunicationControllers"] = field(
        default=None,
        metadata={
            "name": "COMMUNICATION-CONTROLLERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    eth_ip_props_refs: Optional["MachineDesign.EthIpPropsRefs"] = field(
        default=None,
        metadata={
            "name": "ETH-IP-PROPS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pn_reset_timer: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PN-RESET-TIMER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_prepare_sleep_timer: TimeValue | None = field(
        default=None,
        metadata={
            "name": "PNC-PREPARE-SLEEP-TIMER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_discovery_configs: Optional["MachineDesign.ServiceDiscoveryConfigs"] = field(
        default=None,
        metadata={
            "name": "SERVICE-DISCOVERY-CONFIGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_icmp_props_refs: Optional["MachineDesign.TcpIpIcmpPropsRefs"] = field(
        default=None,
        metadata={
            "name": "TCP-IP-ICMP-PROPS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tcp_ip_props_refs: Optional["MachineDesign.TcpIpPropsRefs"] = field(
        default=None,
        metadata={
            "name": "TCP-IP-PROPS-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationConnectors:
        can_communication_connector: list[CanCommunicationConnector] = field(
            default_factory=list,
            metadata={
                "name": "CAN-COMMUNICATION-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_communication_connector: list[EthernetCommunicationConnector] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-COMMUNICATION-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_communication_connector: list[FlexrayCommunicationConnector] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-COMMUNICATION-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_communication_connector: list[LinCommunicationConnector] = field(
            default_factory=list,
            metadata={
                "name": "LIN-COMMUNICATION-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ttcan_communication_connector: list[TtcanCommunicationConnector] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-COMMUNICATION-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_communication_connector: list[UserDefinedCommunicationConnector] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-COMMUNICATION-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommunicationControllers:
        can_communication_controller: list[CanCommunicationController] = field(
            default_factory=list,
            metadata={
                "name": "CAN-COMMUNICATION-CONTROLLER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_communication_controller: list[EthernetCommunicationController] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-COMMUNICATION-CONTROLLER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_communication_controller: list[FlexrayCommunicationController] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-COMMUNICATION-CONTROLLER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_master: list[LinMaster] = field(
            default_factory=list,
            metadata={
                "name": "LIN-MASTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_slave: list[LinSlave] = field(
            default_factory=list,
            metadata={
                "name": "LIN-SLAVE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ttcan_communication_controller: list[TtcanCommunicationController] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-COMMUNICATION-CONTROLLER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_communication_controller: list[UserDefinedCommunicationController] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-COMMUNICATION-CONTROLLER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EthIpPropsRefs:
        eth_ip_props_ref: list["MachineDesign.EthIpPropsRefs.EthIpPropsRef"] = field(
            default_factory=list,
            metadata={
                "name": "ETH-IP-PROPS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class EthIpPropsRef(Ref):
            dest: EthIpPropsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ServiceDiscoveryConfigs:
        someip_service_discovery: list[SomeipServiceDiscovery] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-SERVICE-DISCOVERY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TcpIpIcmpPropsRefs:
        tcp_ip_icmp_props_ref: list["MachineDesign.TcpIpIcmpPropsRefs.TcpIpIcmpPropsRef"] = field(
            default_factory=list,
            metadata={
                "name": "TCP-IP-ICMP-PROPS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TcpIpIcmpPropsRef(Ref):
            dest: EthTcpIpIcmpPropsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class TcpIpPropsRefs:
        tcp_ip_props_ref: list["MachineDesign.TcpIpPropsRefs.TcpIpPropsRef"] = field(
            default_factory=list,
            metadata={
                "name": "TCP-IP-PROPS-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TcpIpPropsRef(Ref):
            dest: EthTcpIpPropsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class Note:
    """This represents a note in a documentation, which may be used to highlight
    specific issues such as hints or caution notes.

    N.B., Documentation notes can be nested recursively, even if this is
    not really intended. In case of nested notes e.g. the note icon of
    inner notes might be omitted while rendering the note.

    :ivar label: This label can be used to superseed the default label
        specified by the noteType attribute. It is in particular useful
        for noteType="other".
    :ivar msr_query_p_2: This represents automatically contributed
        contents provided by an msrquery in the context of
        DocumentationBlock.
    :ivar p: This is one particular paragraph. The upper multiplicity of
        this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar verbatim: This represents one particular verbatim text. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar list_value: This represents numbered or unnumbered list. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar def_list: This represents a definition list in the
        documentation block. The upper multiplicity of this role has
        been increased to * due to resolving an atpVariation stereotype.
        The previous value was 1.
    :ivar labeled_list: This represents a labeled list. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar formula: This is a formula in the definition block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar figure: This represents a figure in the documentation block.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar note: This represents a note in the text flow. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar trace: This represents traceable text in the documentation
        block. This allows to specify requirements/constraints in any
        documentation block. The kind of the trace is specified in the
        category. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar structured_req: This aggregation supports structured
        requirements embedded in a documentation block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: DocumentationBlock.note
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    :ivar note_type: Type of the Note. Default is "HINT"
    """

    class Meta:
        name = "NOTE"

    label: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_p_2: list[MsrQueryP2] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p: list[MultiLanguageParagraph] = field(
        default_factory=list,
        metadata={
            "name": "P",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: list[MultiLanguageVerbatim] = field(
        default_factory=list,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    list_value: list[ListType] = field(
        default_factory=list,
        metadata={
            "name": "LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_list: list[DefList] = field(
        default_factory=list,
        metadata={
            "name": "DEF-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    labeled_list: list[LabeledList] = field(
        default_factory=list,
        metadata={
            "name": "LABELED-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: list[MlFormula] = field(
        default_factory=list,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    figure: list[MlFigure] = field(
        default_factory=list,
        metadata={
            "name": "FIGURE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    note: list["Note"] = field(
        default_factory=list,
        metadata={
            "name": "NOTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace: list["TraceableText"] = field(
        default_factory=list,
        metadata={
            "name": "TRACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    structured_req: list[StructuredReq] = field(
        default_factory=list,
        metadata={
            "name": "STRUCTURED-REQ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )
    note_type: NoteTypeEnumSimple | None = field(
        default=None,
        metadata={
            "name": "NOTE-TYPE",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class SoAdConfig:
    """
    SoAd Configuration for one specific Physical Channel.

    :ivar connections: This aggregation is obsolete and will be removed
        in the future. The connectionGroup aggregation with
        bundledConnections shall be used instead. Old description:
        Collection of socket connections.
    :ivar connection_bundles: Collection of SocketConnectionBundles.
    :ivar logic_addresss: Collection of DoIp Addresses.
    :ivar socket_addresss: Collection of SoAdAddresses.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SO-AD-CONFIG"

    connections: Optional["SoAdConfig.Connections"] = field(
        default=None,
        metadata={
            "name": "CONNECTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    connection_bundles: Optional["SoAdConfig.ConnectionBundles"] = field(
        default=None,
        metadata={
            "name": "CONNECTION-BUNDLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    logic_addresss: Optional["SoAdConfig.LogicAddresss"] = field(
        default=None,
        metadata={
            "name": "LOGIC-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    socket_addresss: Optional["SoAdConfig.SocketAddresss"] = field(
        default=None,
        metadata={
            "name": "SOCKET-ADDRESSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Connections:
        socket_connection: list[SocketConnection] = field(
            default_factory=list,
            metadata={
                "name": "SOCKET-CONNECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConnectionBundles:
        socket_connection_bundle: list[SocketConnectionBundle] = field(
            default_factory=list,
            metadata={
                "name": "SOCKET-CONNECTION-BUNDLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LogicAddresss:
        logic_address: list[LogicAddress] = field(
            default_factory=list,
            metadata={
                "name": "LOGIC-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SocketAddresss:
        socket_address: list[SocketAddress] = field(
            default_factory=list,
            metadata={
                "name": "SOCKET-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwcImplementation:
    """
    This meta-class represents a specialization of the general Implementation meta-
    class with respect to the usage in application software.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar build_action_manifests: A manifest specifying the intended
        build actions for the software delivered with this
        implementation. This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar code_descriptors: Specifies the provided implementation code.
    :ivar compilers: Specifies the compiler for which this
        implementation has been released
    :ivar generated_artifacts: Relates to an artifact that will be
        generated during the integration of this Implementation by an
        associated generator tool. Note that this is an optional
        information since it might  not always be in the scope of a
        single module or component  to provide this information.
    :ivar hw_element_refs: The hardware elements (e.g. the processor)
        required for this implementation.
    :ivar linkers: Specifies the linker for which this implementation
        has been released.
    :ivar mc_support: The measurement &amp; calibration support data
        belonging to this implementation. The aggregtion is
        &lt;&lt;atpSplitable&gt;&gt; because in case of an already
        exisiting BSW Implementation model, this description will be
        added later in the process, namely at code generation time.
    :ivar programming_language: Programming language the implementation
        was created in.
    :ivar required_artifacts: Specifies that this Implementation depends
        on the existance of another artifact (e.g. a library). This
        aggregation of DependencyOnArtifact is subject to variability
        with the purpose to support variability in the implementations.
        Different algorithms in the implementation might cause different
        dependencies, e.g. the number of used libraries.
    :ivar required_generator_tools: Relates this Implementation to a
        generator tool in order to generate additional artifacts during
        integration.
    :ivar resource_consumption: All static and dynamic resources for
        each implementation are described  within the
        ResourceConsumption class.
    :ivar sw_version: Software version of this implementation. The
        numbering contains three levels (like major, minor, patch), its
        values are vendor specific.
    :ivar swc_bsw_mapping_ref: This allows a mapping between an SWC and
        a BSW behavior to be attached to an implementation description
        (for AUTOSAR Service, ECU Abstraction and Complex Driver
        Components).  It is up to the methodology to define whether this
        reference has to be set for the Swc- or BswImplementtion or for
        both.
    :ivar used_code_generator: Optional: code generator used.
    :ivar vendor_id: Vendor ID of this Implementation according to the
        AUTOSAR vendor list
    :ivar behavior_ref: The internal behavior implemented by this
        Implementation.
    :ivar per_instance_memory_sizes: Allows a definition of the size of
        the per-instance memory for this implementation. The aggregation
        of PerInstanceMemorySize  is subject to variability with the
        purpose to support variability in the software components
        implementations. Typically different algorithms in the
        implementation are requiring different number of memory objects,
        in this case PerInstanceMemory.
    :ivar required_rte_vendor: Identify a specific RTE vendor. This
        information is potentially important at the time of integrating
        (in particular: linking) the application code with the RTE. The
        semantics is that (if the association exists) the corresponding
        code has been created to fit to the vendor-mode RTE provided by
        this specific vendor. Attempting to integrate the code with
        another RTE generated in vendor mode is in general not possible.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-IMPLEMENTATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwcImplementation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwcImplementation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    build_action_manifests: Optional["SwcImplementation.BuildActionManifests"] = field(
        default=None,
        metadata={
            "name": "BUILD-ACTION-MANIFESTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    code_descriptors: Optional["SwcImplementation.CodeDescriptors"] = field(
        default=None,
        metadata={
            "name": "CODE-DESCRIPTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compilers: Optional["SwcImplementation.Compilers"] = field(
        default=None,
        metadata={
            "name": "COMPILERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    generated_artifacts: Optional["SwcImplementation.GeneratedArtifacts"] = field(
        default=None,
        metadata={
            "name": "GENERATED-ARTIFACTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hw_element_refs: Optional["SwcImplementation.HwElementRefs"] = field(
        default=None,
        metadata={
            "name": "HW-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    linkers: Optional["SwcImplementation.Linkers"] = field(
        default=None,
        metadata={
            "name": "LINKERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_support: McSupportData | None = field(
        default=None,
        metadata={
            "name": "MC-SUPPORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    programming_language: ProgramminglanguageEnum | None = field(
        default=None,
        metadata={
            "name": "PROGRAMMING-LANGUAGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_artifacts: Optional["SwcImplementation.RequiredArtifacts"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-ARTIFACTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_generator_tools: Optional["SwcImplementation.RequiredGeneratorTools"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-GENERATOR-TOOLS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    resource_consumption: ResourceConsumption | None = field(
        default=None,
        metadata={
            "name": "RESOURCE-CONSUMPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_version: RevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "SW-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_bsw_mapping_ref: Optional["SwcImplementation.SwcBswMappingRef"] = field(
        default=None,
        metadata={
            "name": "SWC-BSW-MAPPING-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    used_code_generator: String | None = field(
        default=None,
        metadata={
            "name": "USED-CODE-GENERATOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vendor_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "VENDOR-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    behavior_ref: Optional["SwcImplementation.BehaviorRef"] = field(
        default=None,
        metadata={
            "name": "BEHAVIOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    per_instance_memory_sizes: Optional["SwcImplementation.PerInstanceMemorySizes"] = field(
        default=None,
        metadata={
            "name": "PER-INSTANCE-MEMORY-SIZES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_rte_vendor: String | None = field(
        default=None,
        metadata={
            "name": "REQUIRED-RTE-VENDOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BuildActionManifests:
        build_action_manifest_ref_conditional: list[BuildActionManifestRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "BUILD-ACTION-MANIFEST-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CodeDescriptors:
        code: list[Code] = field(
            default_factory=list,
            metadata={
                "name": "CODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Compilers:
        compiler: list[Compiler] = field(
            default_factory=list,
            metadata={
                "name": "COMPILER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class GeneratedArtifacts:
        dependency_on_artifact: list[DependencyOnArtifact] = field(
            default_factory=list,
            metadata={
                "name": "DEPENDENCY-ON-ARTIFACT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HwElementRefs:
        hw_element_ref: list["SwcImplementation.HwElementRefs.HwElementRef"] = field(
            default_factory=list,
            metadata={
                "name": "HW-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class HwElementRef(Ref):
            dest: HwElementSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class Linkers:
        linker: list[Linker] = field(
            default_factory=list,
            metadata={
                "name": "LINKER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredArtifacts:
        dependency_on_artifact: list[DependencyOnArtifact] = field(
            default_factory=list,
            metadata={
                "name": "DEPENDENCY-ON-ARTIFACT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredGeneratorTools:
        dependency_on_artifact: list[DependencyOnArtifact] = field(
            default_factory=list,
            metadata={
                "name": "DEPENDENCY-ON-ARTIFACT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcBswMappingRef(Ref):
        dest: SwcBswMappingSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class BehaviorRef(Ref):
        dest: SwcInternalBehaviorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class PerInstanceMemorySizes:
        per_instance_memory_size: list[PerInstanceMemorySize] = field(
            default_factory=list,
            metadata={
                "name": "PER-INSTANCE-MEMORY-SIZE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ArrayValueSpecification:
    """
    Specifies the values for an array.

    :ivar short_label: This can be used to identify particular value
        specifications for human readers, for example elements of a
        record type.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ArrayValueSpecification.element Applicable for:
        RecordValueSpecification.field Not Applicable for:
        CompositeRuleBasedValueSpecification.argument Not Applicable
        for: ConstantSpecification.valueSpec Not Applicable for:
        PortPrototypeBlueprintInitValue.value Not Applicable for:
        DiagnosticEnvDataCondition.compareValue Not Applicable for:
        DiagnosticEnvDataElementCondition.compareValue Not Applicable
        for: ParameterDataPrototype.initValue Not Applicable for:
        VariableDataPrototype.initValue Not Applicable for:
        CalibrationParameterValue.applInitValue Not Applicable for:
        CalibrationParameterValue.implInitValue Not Applicable for:
        MetaDataItem.metaDataItemType Not Applicable for:
        NvProvideComSpec.romBlockInitValue Not Applicable for:
        NvProvideComSpec.ramBlockInitValue Not Applicable for:
        NvRequireComSpec.initValue Not Applicable for:
        ParameterProvideComSpec.initValue Not Applicable for:
        ParameterRequireComSpec.initValue Not Applicable for:
        NonqueuedSenderComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.timeoutSubstitutionValue Not Applicable
        for: PortDefinedArgumentValue.value Not Applicable for:
        CryptoServiceKey.developmentValue Not Applicable for:
        ISignal.timeoutSubstitutionValue Not Applicable for:
        ISignal.initValue Not Applicable for:
        FieldSenderComSpec.initValue Not Applicable for:
        PersistencyDataRequiredComSpec.initValue Not Applicable for:
        ApplicationAssocMapElementValueSpecification.value Not
        Applicable for: ApplicationAssocMapElementValueSpecification.key
        Not Applicable for: StateManagementCompareCondition.compareValue
        Not Applicable for: PersistencyKeyValuePair.initValue Not
        Applicable for: SwDataDefPropsContent.invalidValue
    :ivar elements: The value for a single array element. All
        ValueSpecifications aggregated by ArrayValueSpecification shall
        have the same structure.
    :ivar intended_partial_initialization_count: This attribute shall
        only have a meaning for dynamic arrays and shall be taken as a
        sanity check: the number filled in the attribute shall be
        identical to the number of ArrayValueSpecification.element. If
        the attribute does not exist it means that no partial
        initialization is intended.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ARRAY-VALUE-SPECIFICATION"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    elements: Optional["ArrayValueSpecification.Elements"] = field(
        default=None,
        metadata={
            "name": "ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    intended_partial_initialization_count: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "INTENDED-PARTIAL-INITIALIZATION-COUNT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Elements:
        application_assoc_map_value_specification: list[ApplicationAssocMapValueSpecification] = (
            field(
                default_factory=list,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: list[ApplicationRuleBasedValueSpecification] = (
            field(
                default_factory=list,
                metadata={
                    "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_value_specification: list[ApplicationValueSpecification] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: list["ArrayValueSpecification"] = field(
            default_factory=list,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: list["CompositeRuleBasedValueSpecification"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: list[ConstantReference] = field(
            default_factory=list,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: list[NotAvailableValueSpecification] = field(
            default_factory=list,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: list[NumericalRuleBasedValueSpecification] = (
            field(
                default_factory=list,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: list[NumericalValueSpecification] = field(
            default_factory=list,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: list["RecordValueSpecification"] = field(
            default_factory=list,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: list[ReferenceValueSpecification] = field(
            default_factory=list,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: list[TextValueSpecification] = field(
            default_factory=list,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucDestinationUriDef:
    """
    Description of an EcucDestinationUriDef that is used as target of
    EcucUriReferenceDefs.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar destination_uri_policy: Description of the targeted
        EcucContainerDef.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-DESTINATION-URI-DEF"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucDestinationUriDef.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucDestinationUriDef.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_uri_policy: EcucDestinationUriPolicy | None = field(
        default=None,
        metadata={
            "name": "DESTINATION-URI-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EthernetPhysicalChannel:
    """The EthernetPhysicalChannel represents a VLAN or an untagged channel.

    An untagged channel is modeled as an EthernetPhysicalChannel without
    an aggregated VLAN.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar comm_connectors: This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar frame_triggerings: One frame triggering is defined for exactly
        one channel. Channels may have assigned an arbitrary number of
        frame triggerings. atpVariation: If signals/PDUs/frames are
        variable, the corresponding triggerings shall be variable, too.
    :ivar i_signal_triggerings: One ISignalTriggering is defined for
        exactly one channel. Channels may have assigned an arbitrary
        number of ISignaltriggerings. atpVariation: If
        signals/PDUs/frames are variable, the corresponding triggerings
        shall be variable, too.
    :ivar managed_physical_channel_refs: Reference between a channel
        with role managing channel and a channel with role managed
        channel.
    :ivar pdu_triggerings: One PduTriggering is defined for exactly one
        channel. Channels may have assigned an arbitrary number of I-Pdu
        triggerings. atpVariation: If signals/PDUs/frames are variable,
        the corresponding triggerings shall be variable, too.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CommunicationClusterContent.physicalChannel
    :ivar network_endpoints: Collection of NetworkEndpoints that are
        used in the VLan.
    :ivar so_ad_config: SoAd Configuration for one specific Physical
        Channel.
    :ivar vlan: VLAN Configuration.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-PHYSICAL-CHANNEL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthernetPhysicalChannel.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthernetPhysicalChannel.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    comm_connectors: Optional["EthernetPhysicalChannel.CommConnectors"] = field(
        default=None,
        metadata={
            "name": "COMM-CONNECTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    frame_triggerings: Optional["EthernetPhysicalChannel.FrameTriggerings"] = field(
        default=None,
        metadata={
            "name": "FRAME-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_triggerings: Optional["EthernetPhysicalChannel.ISignalTriggerings"] = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    managed_physical_channel_refs: Optional[
        "EthernetPhysicalChannel.ManagedPhysicalChannelRefs"
    ] = field(
        default=None,
        metadata={
            "name": "MANAGED-PHYSICAL-CHANNEL-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pdu_triggerings: Optional["EthernetPhysicalChannel.PduTriggerings"] = field(
        default=None,
        metadata={
            "name": "PDU-TRIGGERINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_endpoints: Optional["EthernetPhysicalChannel.NetworkEndpoints"] = field(
        default=None,
        metadata={
            "name": "NETWORK-ENDPOINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    so_ad_config: SoAdConfig | None = field(
        default=None,
        metadata={
            "name": "SO-AD-CONFIG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    vlan: VlanConfig | None = field(
        default=None,
        metadata={
            "name": "VLAN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CommConnectors:
        communication_connector_ref_conditional: list[CommunicationConnectorRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "COMMUNICATION-CONNECTOR-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FrameTriggerings:
        can_frame_triggering: list[CanFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "CAN-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_frame_triggering: list[EthernetFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_frame_triggering: list[FlexrayFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_frame_triggering: list[LinFrameTriggering] = field(
            default_factory=list,
            metadata={
                "name": "LIN-FRAME-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ISignalTriggerings:
        i_signal_triggering: list[ISignalTriggering] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ManagedPhysicalChannelRefs:
        managed_physical_channel_ref: list[
            "EthernetPhysicalChannel.ManagedPhysicalChannelRefs.ManagedPhysicalChannelRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MANAGED-PHYSICAL-CHANNEL-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ManagedPhysicalChannelRef(Ref):
            dest: PhysicalChannelSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class PduTriggerings:
        pdu_triggering: list[PduTriggering] = field(
            default_factory=list,
            metadata={
                "name": "PDU-TRIGGERING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NetworkEndpoints:
        network_endpoint: list[NetworkEndpoint] = field(
            default_factory=list,
            metadata={
                "name": "NETWORK-ENDPOINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TraceableText:
    """This meta-class represents the ability to denote a traceable text item such
    as requirements etc.

    The following approach applies:
    * '''shortName''' represents the tag for tracing
    * '''longName''' represents the head line
    * '''category''' represents the kind of the tagged text

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar msr_query_p_2: This represents automatically contributed
        contents provided by an msrquery in the context of
        DocumentationBlock.
    :ivar p: This is one particular paragraph. The upper multiplicity of
        this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar verbatim: This represents one particular verbatim text. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar list_value: This represents numbered or unnumbered list. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar def_list: This represents a definition list in the
        documentation block. The upper multiplicity of this role has
        been increased to * due to resolving an atpVariation stereotype.
        The previous value was 1.
    :ivar labeled_list: This represents a labeled list. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar formula: This is a formula in the definition block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar figure: This represents a figure in the documentation block.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar note: This represents a note in the text flow. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar trace: This represents traceable text in the documentation
        block. This allows to specify requirements/constraints in any
        documentation block. The kind of the trace is specified in the
        category. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar structured_req: This aggregation supports structured
        requirements embedded in a documentation block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        DocumentationBlock.trace
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    """

    class Meta:
        name = "TRACEABLE-TEXT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TraceableText.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TraceableText.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["TraceableText.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_p_2: list[MsrQueryP2] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p: list[MultiLanguageParagraph] = field(
        default_factory=list,
        metadata={
            "name": "P",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: list[MultiLanguageVerbatim] = field(
        default_factory=list,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    list_value: list[ListType] = field(
        default_factory=list,
        metadata={
            "name": "LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_list: list[DefList] = field(
        default_factory=list,
        metadata={
            "name": "DEF-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    labeled_list: list[LabeledList] = field(
        default_factory=list,
        metadata={
            "name": "LABELED-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: list[MlFormula] = field(
        default_factory=list,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    figure: list[MlFigure] = field(
        default_factory=list,
        metadata={
            "name": "FIGURE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    note: list[Note] = field(
        default_factory=list,
        metadata={
            "name": "NOTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace: list["TraceableText"] = field(
        default_factory=list,
        metadata={
            "name": "TRACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    structured_req: list[StructuredReq] = field(
        default_factory=list,
        metadata={
            "name": "STRUCTURED-REQ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["TraceableText.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class CanClusterConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar baudrate: Channels speed in bits/s.
    :ivar physical_channels: This relationship defines which channel
        element belongs to which cluster. A channel shall be assigned to
        exactly one cluster, whereas a cluster may have one or more
        channels.
    :ivar protocol_name: The name of the protocol used.
    :ivar protocol_version: The version of the protocol used.
    :ivar speed: This attribute is deprecated and is replaced by the
        attribute "baudrate". Old description: Channels speed in kbps.
    :ivar bus_off_recovery: CAN bus off monitoring / recovery at system
        level.
    :ivar can_fd_baudrate: Specifies the data segment baud rate of the
        controller in bits/s.
    :ivar can_xl_baudrate: Specifies the data segment baud rate of the
        CAN XL controller in bits/s.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-CLUSTER-CONDITIONAL"

    baudrate: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_channels: Optional["CanClusterConditional.PhysicalChannels"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_name: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_version: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    speed: Integer | None = field(
        default=None,
        metadata={
            "name": "SPEED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bus_off_recovery: CanClusterBusOffRecovery | None = field(
        default=None,
        metadata={
            "name": "BUS-OFF-RECOVERY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_fd_baudrate: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "CAN-FD-BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_xl_baudrate: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "CAN-XL-BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannels:
        can_physical_channel: list[CanPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "CAN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_physical_channel: list[EthernetPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_physical_channel: list[FlexrayPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_physical_channel: list[LinPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "LIN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ttcan_physical_channel: list[TtcanPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_physical_channel: list[UserDefinedPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CompositeRuleBasedValueSpecification:
    """
    This meta-class represents rule-based values for DataPrototypes typed by
    composite AutosarDataTypes.

    :ivar short_label: This can be used to identify particular value
        specifications for human readers, for example elements of a
        record type.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ArrayValueSpecification.element Applicable for:
        RecordValueSpecification.field Not Applicable for:
        CompositeRuleBasedValueSpecification.argument Not Applicable
        for: ConstantSpecification.valueSpec Not Applicable for:
        PortPrototypeBlueprintInitValue.value Not Applicable for:
        DiagnosticEnvDataCondition.compareValue Not Applicable for:
        DiagnosticEnvDataElementCondition.compareValue Not Applicable
        for: ParameterDataPrototype.initValue Not Applicable for:
        VariableDataPrototype.initValue Not Applicable for:
        CalibrationParameterValue.applInitValue Not Applicable for:
        CalibrationParameterValue.implInitValue Not Applicable for:
        MetaDataItem.metaDataItemType Not Applicable for:
        NvProvideComSpec.romBlockInitValue Not Applicable for:
        NvProvideComSpec.ramBlockInitValue Not Applicable for:
        NvRequireComSpec.initValue Not Applicable for:
        ParameterProvideComSpec.initValue Not Applicable for:
        ParameterRequireComSpec.initValue Not Applicable for:
        NonqueuedSenderComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.timeoutSubstitutionValue Not Applicable
        for: PortDefinedArgumentValue.value Not Applicable for:
        CryptoServiceKey.developmentValue Not Applicable for:
        ISignal.timeoutSubstitutionValue Not Applicable for:
        ISignal.initValue Not Applicable for:
        FieldSenderComSpec.initValue Not Applicable for:
        PersistencyDataRequiredComSpec.initValue Not Applicable for:
        ApplicationAssocMapElementValueSpecification.value Not
        Applicable for: ApplicationAssocMapElementValueSpecification.key
        Not Applicable for: StateManagementCompareCondition.compareValue
        Not Applicable for: PersistencyKeyValuePair.initValue Not
        Applicable for: SwDataDefPropsContent.invalidValue
    :ivar rule: This denotes the name of the rule of the
        RuleBasedValueSpecification. The rule determines the calculation
        specification according which the arguments are used to
        calculated the values.
    :ivar arguments: This represents the collection of aggregated
        ValueSpecifications. The last ValueSpecification in the
        collection shall be taken to execute the filling rule. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar compound_primitive_arguments: This represents the collection
        of aggregated ValueSpecifications for compound primitive data
        type. The last ValueSpecification in the collection shall be
        taken to execute the filling rule.
    :ivar max_size_to_fill: If a rule is chosen which does not fill
        until the end, this determines until which size the rule shall
        fill the values.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rule: Identifier | None = field(
        default=None,
        metadata={
            "name": "RULE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    arguments: Optional["CompositeRuleBasedValueSpecification.Arguments"] = field(
        default=None,
        metadata={
            "name": "ARGUMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compound_primitive_arguments: Optional[
        "CompositeRuleBasedValueSpecification.CompoundPrimitiveArguments"
    ] = field(
        default=None,
        metadata={
            "name": "COMPOUND-PRIMITIVE-ARGUMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_size_to_fill: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-SIZE-TO-FILL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Arguments:
        application_assoc_map_value_specification: list[ApplicationAssocMapValueSpecification] = (
            field(
                default_factory=list,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        array_value_specification: list[ArrayValueSpecification] = field(
            default_factory=list,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: list["RecordValueSpecification"] = field(
            default_factory=list,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CompoundPrimitiveArguments:
        application_rule_based_value_specification: list[ApplicationRuleBasedValueSpecification] = (
            field(
                default_factory=list,
                metadata={
                    "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_value_specification: list[ApplicationValueSpecification] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcucDestinationUriDefSet:
    """
    This class represents a list of EcucDestinationUriDefs.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar destination_uri_defs: This is one particular
        EcucDestinationUriDef.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECUC-DESTINATION-URI-DEF-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcucDestinationUriDefSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcucDestinationUriDefSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["EcucDestinationUriDefSet.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    destination_uri_defs: Optional["EcucDestinationUriDefSet.DestinationUriDefs"] = field(
        default=None,
        metadata={
            "name": "DESTINATION-URI-DEFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DestinationUriDefs:
        ecuc_destination_uri_def: list[EcucDestinationUriDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-DESTINATION-URI-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Entry:
    """
    This represents one particular table cell.

    :ivar bgcolor: This attribute is removed and left in for backward
        compatibility. Use bgcolor instead.
    :ivar msr_query_p_2: This represents automatically contributed
        contents provided by an msrquery in the context of
        DocumentationBlock.
    :ivar p: This is one particular paragraph. The upper multiplicity of
        this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar verbatim: This represents one particular verbatim text. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar list_value: This represents numbered or unnumbered list. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar def_list: This represents a definition list in the
        documentation block. The upper multiplicity of this role has
        been increased to * due to resolving an atpVariation stereotype.
        The previous value was 1.
    :ivar labeled_list: This represents a labeled list. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar formula: This is a formula in the definition block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar figure: This represents a figure in the documentation block.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar note: This represents a note in the text flow. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar trace: This represents traceable text in the documentation
        block. This allows to specify requirements/constraints in any
        documentation block. The kind of the trace is specified in the
        category. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar structured_req: This aggregation supports structured
        requirements embedded in a documentation block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar align: Specifies how the cell ENTRY shall be horizontally
        aligned.  Default is "LEFT"
    :ivar bgcolor_attribute: This allows to recommend a background color
        of the entry. It is specified bases on 6 digits RGB hex-code.
    :ivar colname: Indicate the name of the column, where the entry
        should appear.
    :ivar colsep: Indicates whether a line should be displayed end of
        this entry.
    :ivar morerows: Number of additional rows. Default is "0"
    :ivar nameend: When an entry spans multiple column this is the name
        of the last column.
    :ivar namest: When an entry spans multiple column this is the name
        of the first column.
    :ivar rotate: Indicates if the cellcontent shall be rotated. Default
        is 0; 1 would rotate the contents 90 degree counterclockwise.
        This attribute is defined by OASIS.
    :ivar rowsep: Indicates whether a line should be displayed at the
        bottom end of the cell.
    :ivar spanname: Capture the name of entry merging multiple columns.
    :ivar valign: Indicates how the content of the cell shall be
        aligned. Default is inherited from row or tbody, otherwise "TOP"
    """

    class Meta:
        name = "ENTRY"

    bgcolor: String | None = field(
        default=None,
        metadata={
            "name": "BGCOLOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_p_2: list[MsrQueryP2] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p: list[MultiLanguageParagraph] = field(
        default_factory=list,
        metadata={
            "name": "P",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: list[MultiLanguageVerbatim] = field(
        default_factory=list,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    list_value: list[ListType] = field(
        default_factory=list,
        metadata={
            "name": "LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_list: list[DefList] = field(
        default_factory=list,
        metadata={
            "name": "DEF-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    labeled_list: list[LabeledList] = field(
        default_factory=list,
        metadata={
            "name": "LABELED-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: list[MlFormula] = field(
        default_factory=list,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    figure: list[MlFigure] = field(
        default_factory=list,
        metadata={
            "name": "FIGURE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    note: list[Note] = field(
        default_factory=list,
        metadata={
            "name": "NOTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace: list[TraceableText] = field(
        default_factory=list,
        metadata={
            "name": "TRACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    structured_req: list[StructuredReq] = field(
        default_factory=list,
        metadata={
            "name": "STRUCTURED-REQ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    align: AlignEnumSimple | None = field(
        default=None,
        metadata={
            "name": "ALIGN",
            "type": "Attribute",
        },
    )
    bgcolor_attribute: str | None = field(
        default=None,
        metadata={
            "name": "BGCOLOR",
            "type": "Attribute",
        },
    )
    colname: str | None = field(
        default=None,
        metadata={
            "name": "COLNAME",
            "type": "Attribute",
        },
    )
    colsep: str | None = field(
        default=None,
        metadata={
            "name": "COLSEP",
            "type": "Attribute",
            "pattern": r"[0-1]",
        },
    )
    morerows: str | None = field(
        default=None,
        metadata={
            "name": "MOREROWS",
            "type": "Attribute",
        },
    )
    nameend: str | None = field(
        default=None,
        metadata={
            "name": "NAMEEND",
            "type": "Attribute",
        },
    )
    namest: str | None = field(
        default=None,
        metadata={
            "name": "NAMEST",
            "type": "Attribute",
        },
    )
    rotate: str | None = field(
        default=None,
        metadata={
            "name": "ROTATE",
            "type": "Attribute",
        },
    )
    rowsep: str | None = field(
        default=None,
        metadata={
            "name": "ROWSEP",
            "type": "Attribute",
            "pattern": r"[0-1]",
        },
    )
    spanname: str | None = field(
        default=None,
        metadata={
            "name": "SPANNAME",
            "type": "Attribute",
        },
    )
    valign: ValignEnumSimple | None = field(
        default=None,
        metadata={
            "name": "VALIGN",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class EthernetClusterConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar baudrate: Channels speed in bits/s.
    :ivar physical_channels: This relationship defines which channel
        element belongs to which cluster. A channel shall be assigned to
        exactly one cluster, whereas a cluster may have one or more
        channels.
    :ivar protocol_name: The name of the protocol used.
    :ivar protocol_version: The version of the protocol used.
    :ivar speed: This attribute is deprecated and is replaced by the
        attribute "baudrate". Old description: Channels speed in kbps.
    :ivar coupling_port_connections: Specification of connections
        between CouplingElements and EcuInstances.
    :ivar coupling_port_startup_active_time: The attribute specifies the
        time in second a coupling port is switched on to enable the host
        ECU (ECU that maintains an Ethernet switch) to listen to the
        network for potential network management requests.
    :ivar coupling_port_switchoff_delay: Switch off delay for
        CouplingPorts in seconds. It denotes the delay of switching off
        couplingPorts after the request to switch off a couplingPort was
        issued. (e.g. switch off of Ethernet switch ports).
    :ivar mac_multicast_groups: MacMulticastGroup that is defined for
        the Subnet (EthernetCluster).
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-CLUSTER-CONDITIONAL"

    baudrate: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_channels: Optional["EthernetClusterConditional.PhysicalChannels"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_name: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_version: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    speed: Integer | None = field(
        default=None,
        metadata={
            "name": "SPEED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    coupling_port_connections: Optional["EthernetClusterConditional.CouplingPortConnections"] = (
        field(
            default=None,
            metadata={
                "name": "COUPLING-PORT-CONNECTIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    coupling_port_startup_active_time: TimeValue | None = field(
        default=None,
        metadata={
            "name": "COUPLING-PORT-STARTUP-ACTIVE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    coupling_port_switchoff_delay: TimeValue | None = field(
        default=None,
        metadata={
            "name": "COUPLING-PORT-SWITCHOFF-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mac_multicast_groups: Optional["EthernetClusterConditional.MacMulticastGroups"] = field(
        default=None,
        metadata={
            "name": "MAC-MULTICAST-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannels:
        can_physical_channel: list[CanPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "CAN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_physical_channel: list[EthernetPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_physical_channel: list[FlexrayPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_physical_channel: list[LinPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "LIN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ttcan_physical_channel: list[TtcanPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_physical_channel: list[UserDefinedPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CouplingPortConnections:
        coupling_port_connection: list[CouplingPortConnection] = field(
            default_factory=list,
            metadata={
                "name": "COUPLING-PORT-CONNECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MacMulticastGroups:
        mac_multicast_group: list[MacMulticastGroup] = field(
            default_factory=list,
            metadata={
                "name": "MAC-MULTICAST-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayClusterConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar baudrate: Channels speed in bits/s.
    :ivar physical_channels: This relationship defines which channel
        element belongs to which cluster. A channel shall be assigned to
        exactly one cluster, whereas a cluster may have one or more
        channels.
    :ivar protocol_name: The name of the protocol used.
    :ivar protocol_version: The version of the protocol used.
    :ivar speed: This attribute is deprecated and is replaced by the
        attribute "baudrate". Old description: Channels speed in kbps.
    :ivar action_point_offset: The offset of the action point in
        networks
    :ivar bit: Nominal bit time (= 1 / fx:SPEED). gdBit = cSamplesPerBit
        * gdSampleClockPeriod. Unit: seconds (gdBit)
    :ivar cas_rx_low_max: Upper limit of the Collision Avoidance Symbol
        (CAS) acceptance window. Unit:bitDuration
    :ivar cold_start_attempts: The maximum number of times that a node
        in this cluster is permitted to attempt to start the cluster by
        initiating schedule synchronization
    :ivar cycle: Length of the cycle. Unit: seconds
    :ivar cycle_count_max: Maximum cycle counter value in a given
        cluster. Remark: Set to 63 for FlexRay Protocol 2.1 Rev. A
        compliance.
    :ivar detect_nit_error: Indicates whether NIT error status of each
        cluster shall be detected or not.
    :ivar dynamic_slot_idle_phase: The duration of the dynamic slot idle
        phase in minislots.
    :ivar ignore_after_tx: Duration for which the bitstrobing is paused
        after transmission [gdBit].
    :ivar listen_noise: Upper limit for the start up and wake up listen
        timeout in the presence of noise. Expressed as a multiple of the
        cluster constant pdListenTimeout. Unit microticks
    :ivar macro_per_cycle: The number of macroticks in a communication
        cycle
    :ivar macrotick_duration: Duration of the cluster wide nominal
        macrotick, expressed in s.
    :ivar max_without_clock_correction_fatal: Threshold concerning
        vClockCorrectionFailedCounter. Defines the number of consecutive
        even/odd Cycle pairs with missing clock correction terms that
        will cause the protocol to transition from the POC:normal active
        or POC:normal passive state into the POC:halt state.
    :ivar max_without_clock_correction_passive: Threshold concerning
        vClockCorrectionFailedCounter. Defines the number of consecutive
        even/odd Cycle pairs with missing clock correction terms that
        will cause the protocol to transition from the POC:normal active
        state to the POC:normal passive state.
    :ivar minislot_action_point_offset: The Offset of the action point
        within a minislot. Unit: macroticks
    :ivar minislot_duration: The duration of a minislot (dynamic
        segment). Unit: macroticks.
    :ivar network_idle_time: The duration of the network idle time in
        macroticks
    :ivar network_management_vector_length: Length of the Network
        Management vector in a cluster [bytes]
    :ivar number_of_minislots: Number of Minislots in the dynamic
        segment.
    :ivar number_of_static_slots: The number of static slots in the
        static segment.
    :ivar offset_correction_start: Start of the offset correction phase
        within the Network Idle Time (NIT), expressed as the number of
        macroticks from the start of cycle. Unit: macroticks
    :ivar payload_length_static: Globally configured payload length of a
        static frame. Unit: 16-bit WORDS.
    :ivar safety_margin: Additional timespan in macroticks which takes
        jitter into account to be able to set the JobListPointer to the
        next possible job which can be executed in case the FlexRay Job
        List Execution Function has be resynchronized.
    :ivar sample_clock_period: Sample clock period. Unit: seconds
    :ivar static_slot_duration: The duration of a slot in the static
        segment. Unit: macroticks
    :ivar symbol_window: The duration of the symbol window. Unit:
        macroticks
    :ivar symbol_window_action_point_offset: Number of macroticks the
        action point offset is from the beginning of the symbol window
        [Macroticks].
    :ivar sync_frame_id_count_max: Maximum number of distinct syncframe
        identifiers present in a given cluster. This parameter maps to
        FlexRay Protocol 2.1  Rev. A parameter gSyncNodeMax.
    :ivar tranceiver_standby_delay: The duration of timer
        t_TrcvStdbyDelay in seconds. The granularity of this parameter
        shall be restricted to full FlexRay cycles (cycle). The
        transceiver status setting to STANDBY shall be delayed by this
        value. Not specifying a value or a value of 0 shall imply that
        the timer is not used.
    :ivar transmission_start_sequence_duration: Number of bits in the
        Transmission Start Sequence [gdBits].
    :ivar wakeup_rx_idle: Number of bits used by the node to test the
        duration of the 'idle' or HIGH phase of a received wakeup.
        Unit:bitDuration Remarks: This parameter maps to FlexRay
        Protocol 2.1 Rev. A parameter gdWakeupSymbolRxIdle.
    :ivar wakeup_rx_low: Number of bits used by the node to test the
        duration of the LOW phase of a received wakeup. Unit:bitDuration
        Remarks: This parameter maps to FlexRay Protocol 2.1 Rev. A
        parameter gdWakeupSymbolRxLow.
    :ivar wakeup_rx_window: The size of the window used to detect
        wakeups [gdBit]. Remarks: This parameter maps to FlexRay
        Protocol 2.1 Rev. A parameter gdWakeupSymbolRxWindow.
    :ivar wakeup_tx_active: Number of bits used by the node to transmit
        the LOW phase of awakeup symbol and  the HIGH and LOW phases of
        a WUDOP. Unit:bitDuration
    :ivar wakeup_tx_idle: Number of bits used by the node to transmit
        the 'idle' part of a wakeup symbol. Unit: gDbit
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-CLUSTER-CONDITIONAL"

    baudrate: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_channels: Optional["FlexrayClusterConditional.PhysicalChannels"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_name: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_version: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    speed: Integer | None = field(
        default=None,
        metadata={
            "name": "SPEED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    action_point_offset: Integer | None = field(
        default=None,
        metadata={
            "name": "ACTION-POINT-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bit: TimeValue | None = field(
        default=None,
        metadata={
            "name": "BIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cas_rx_low_max: Integer | None = field(
        default=None,
        metadata={
            "name": "CAS-RX-LOW-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cold_start_attempts: Integer | None = field(
        default=None,
        metadata={
            "name": "COLD-START-ATTEMPTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cycle: TimeValue | None = field(
        default=None,
        metadata={
            "name": "CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    cycle_count_max: Integer | None = field(
        default=None,
        metadata={
            "name": "CYCLE-COUNT-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    detect_nit_error: Boolean | None = field(
        default=None,
        metadata={
            "name": "DETECT-NIT-ERROR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    dynamic_slot_idle_phase: Integer | None = field(
        default=None,
        metadata={
            "name": "DYNAMIC-SLOT-IDLE-PHASE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ignore_after_tx: Integer | None = field(
        default=None,
        metadata={
            "name": "IGNORE-AFTER-TX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    listen_noise: Integer | None = field(
        default=None,
        metadata={
            "name": "LISTEN-NOISE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    macro_per_cycle: Integer | None = field(
        default=None,
        metadata={
            "name": "MACRO-PER-CYCLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    macrotick_duration: TimeValue | None = field(
        default=None,
        metadata={
            "name": "MACROTICK-DURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_without_clock_correction_fatal: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-WITHOUT-CLOCK-CORRECTION-FATAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_without_clock_correction_passive: Integer | None = field(
        default=None,
        metadata={
            "name": "MAX-WITHOUT-CLOCK-CORRECTION-PASSIVE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minislot_action_point_offset: Integer | None = field(
        default=None,
        metadata={
            "name": "MINISLOT-ACTION-POINT-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minislot_duration: Integer | None = field(
        default=None,
        metadata={
            "name": "MINISLOT-DURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_idle_time: Integer | None = field(
        default=None,
        metadata={
            "name": "NETWORK-IDLE-TIME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_management_vector_length: Integer | None = field(
        default=None,
        metadata={
            "name": "NETWORK-MANAGEMENT-VECTOR-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    number_of_minislots: Integer | None = field(
        default=None,
        metadata={
            "name": "NUMBER-OF-MINISLOTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    number_of_static_slots: Integer | None = field(
        default=None,
        metadata={
            "name": "NUMBER-OF-STATIC-SLOTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    offset_correction_start: Integer | None = field(
        default=None,
        metadata={
            "name": "OFFSET-CORRECTION-START",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    payload_length_static: Integer | None = field(
        default=None,
        metadata={
            "name": "PAYLOAD-LENGTH-STATIC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    safety_margin: Integer | None = field(
        default=None,
        metadata={
            "name": "SAFETY-MARGIN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sample_clock_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "SAMPLE-CLOCK-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    static_slot_duration: Integer | None = field(
        default=None,
        metadata={
            "name": "STATIC-SLOT-DURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol_window: Integer | None = field(
        default=None,
        metadata={
            "name": "SYMBOL-WINDOW",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol_window_action_point_offset: Integer | None = field(
        default=None,
        metadata={
            "name": "SYMBOL-WINDOW-ACTION-POINT-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_frame_id_count_max: Integer | None = field(
        default=None,
        metadata={
            "name": "SYNC-FRAME-ID-COUNT-MAX",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tranceiver_standby_delay: Float | None = field(
        default=None,
        metadata={
            "name": "TRANCEIVER-STANDBY-DELAY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_start_sequence_duration: Integer | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-START-SEQUENCE-DURATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_rx_idle: Integer | None = field(
        default=None,
        metadata={
            "name": "WAKEUP-RX-IDLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_rx_low: Integer | None = field(
        default=None,
        metadata={
            "name": "WAKEUP-RX-LOW",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_rx_window: Integer | None = field(
        default=None,
        metadata={
            "name": "WAKEUP-RX-WINDOW",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_tx_active: Integer | None = field(
        default=None,
        metadata={
            "name": "WAKEUP-TX-ACTIVE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    wakeup_tx_idle: Integer | None = field(
        default=None,
        metadata={
            "name": "WAKEUP-TX-IDLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannels:
        can_physical_channel: list[CanPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "CAN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_physical_channel: list[EthernetPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_physical_channel: list[FlexrayPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_physical_channel: list[LinPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "LIN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ttcan_physical_channel: list[TtcanPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_physical_channel: list[UserDefinedPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class J1939ClusterConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar baudrate: Channels speed in bits/s.
    :ivar physical_channels: This relationship defines which channel
        element belongs to which cluster. A channel shall be assigned to
        exactly one cluster, whereas a cluster may have one or more
        channels.
    :ivar protocol_name: The name of the protocol used.
    :ivar protocol_version: The version of the protocol used.
    :ivar speed: This attribute is deprecated and is replaced by the
        attribute "baudrate". Old description: Channels speed in kbps.
    :ivar bus_off_recovery: CAN bus off monitoring / recovery at system
        level.
    :ivar can_fd_baudrate: Specifies the data segment baud rate of the
        controller in bits/s.
    :ivar can_xl_baudrate: Specifies the data segment baud rate of the
        CAN XL controller in bits/s.
    :ivar network_id: This represents the network ID for the J1939
        cluster.
    :ivar request_2_support: Enables support for the Request2 PGN
        (RQST2).
    :ivar uses_address_arbitration: Defines whether the nodes attached
        to this channel use an initial address claim, and whether they
        react to contending address claims of other nodes. True: The
        initial address claim is sent, and the node reacts to address
        claims of other nodes. False: The node only sends an address
        claim upon request, and does not care for contending address
        claims.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-CLUSTER-CONDITIONAL"

    baudrate: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_channels: Optional["J1939ClusterConditional.PhysicalChannels"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_name: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_version: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    speed: Integer | None = field(
        default=None,
        metadata={
            "name": "SPEED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bus_off_recovery: CanClusterBusOffRecovery | None = field(
        default=None,
        metadata={
            "name": "BUS-OFF-RECOVERY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_fd_baudrate: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "CAN-FD-BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_xl_baudrate: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "CAN-XL-BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NETWORK-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    request_2_support: Boolean | None = field(
        default=None,
        metadata={
            "name": "REQUEST-2-SUPPORT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uses_address_arbitration: Boolean | None = field(
        default=None,
        metadata={
            "name": "USES-ADDRESS-ARBITRATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannels:
        can_physical_channel: list[CanPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "CAN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_physical_channel: list[EthernetPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_physical_channel: list[FlexrayPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_physical_channel: list[LinPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "LIN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ttcan_physical_channel: list[TtcanPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_physical_channel: list[UserDefinedPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LinClusterConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar baudrate: Channels speed in bits/s.
    :ivar physical_channels: This relationship defines which channel
        element belongs to which cluster. A channel shall be assigned to
        exactly one cluster, whereas a cluster may have one or more
        channels.
    :ivar protocol_name: The name of the protocol used.
    :ivar protocol_version: The version of the protocol used.
    :ivar speed: This attribute is deprecated and is replaced by the
        attribute "baudrate". Old description: Channels speed in kbps.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-CLUSTER-CONDITIONAL"

    baudrate: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_channels: Optional["LinClusterConditional.PhysicalChannels"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_name: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_version: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    speed: Integer | None = field(
        default=None,
        metadata={
            "name": "SPEED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannels:
        can_physical_channel: list[CanPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "CAN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_physical_channel: list[EthernetPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_physical_channel: list[FlexrayPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_physical_channel: list[LinPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "LIN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ttcan_physical_channel: list[TtcanPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_physical_channel: list[UserDefinedPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TtcanClusterConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar baudrate: Channels speed in bits/s.
    :ivar physical_channels: This relationship defines which channel
        element belongs to which cluster. A channel shall be assigned to
        exactly one cluster, whereas a cluster may have one or more
        channels.
    :ivar protocol_name: The name of the protocol used.
    :ivar protocol_version: The version of the protocol used.
    :ivar speed: This attribute is deprecated and is replaced by the
        attribute "baudrate". Old description: Channels speed in kbps.
    :ivar bus_off_recovery: CAN bus off monitoring / recovery at system
        level.
    :ivar can_fd_baudrate: Specifies the data segment baud rate of the
        controller in bits/s.
    :ivar can_xl_baudrate: Specifies the data segment baud rate of the
        CAN XL controller in bits/s.
    :ivar basic_cycle_length: Length of a basic-cycle. Unit: NTUs
    :ivar ntu: Unit measuring all times and providing a constant of the
        whole network. For level 1, this is always the CAN bit time.
        Unit: seconds.
    :ivar operation_mode: Possible operation modes True: Time-Triggered
        False: Event-Synchronised-Time-Triggered
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TTCAN-CLUSTER-CONDITIONAL"

    baudrate: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_channels: Optional["TtcanClusterConditional.PhysicalChannels"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_name: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_version: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    speed: Integer | None = field(
        default=None,
        metadata={
            "name": "SPEED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bus_off_recovery: CanClusterBusOffRecovery | None = field(
        default=None,
        metadata={
            "name": "BUS-OFF-RECOVERY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_fd_baudrate: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "CAN-FD-BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_xl_baudrate: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "CAN-XL-BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    basic_cycle_length: Integer | None = field(
        default=None,
        metadata={
            "name": "BASIC-CYCLE-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ntu: TimeValue | None = field(
        default=None,
        metadata={
            "name": "NTU",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    operation_mode: Boolean | None = field(
        default=None,
        metadata={
            "name": "OPERATION-MODE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannels:
        can_physical_channel: list[CanPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "CAN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_physical_channel: list[EthernetPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_physical_channel: list[FlexrayPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_physical_channel: list[LinPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "LIN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ttcan_physical_channel: list[TtcanPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_physical_channel: list[UserDefinedPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedClusterConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar baudrate: Channels speed in bits/s.
    :ivar physical_channels: This relationship defines which channel
        element belongs to which cluster. A channel shall be assigned to
        exactly one cluster, whereas a cluster may have one or more
        channels.
    :ivar protocol_name: The name of the protocol used.
    :ivar protocol_version: The version of the protocol used.
    :ivar speed: This attribute is deprecated and is replaced by the
        attribute "baudrate". Old description: Channels speed in kbps.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-CLUSTER-CONDITIONAL"

    baudrate: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "BAUDRATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    physical_channels: Optional["UserDefinedClusterConditional.PhysicalChannels"] = field(
        default=None,
        metadata={
            "name": "PHYSICAL-CHANNELS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_name: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    protocol_version: String | None = field(
        default=None,
        metadata={
            "name": "PROTOCOL-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    speed: Integer | None = field(
        default=None,
        metadata={
            "name": "SPEED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PhysicalChannels:
        can_physical_channel: list[CanPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "CAN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_physical_channel: list[EthernetPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_physical_channel: list[FlexrayPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_physical_channel: list[LinPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "LIN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ttcan_physical_channel: list[TtcanPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_physical_channel: list[UserDefinedPhysicalChannel] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-PHYSICAL-CHANNEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CanCluster:
    """
    CAN bus specific cluster attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar can_cluster_variants: This element was generated/modified due
        to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CAN-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CanCluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CanCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    can_cluster_variants: Optional["CanCluster.CanClusterVariants"] = field(
        default=None,
        metadata={
            "name": "CAN-CLUSTER-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CanClusterVariants:
        can_cluster_conditional: list[CanClusterConditional] = field(
            default_factory=list,
            metadata={
                "name": "CAN-CLUSTER-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EthernetCluster:
    """
    Ethernet-specific cluster attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar ethernet_cluster_variants: This element was generated/modified
        due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ETHERNET-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EthernetCluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EthernetCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ethernet_cluster_variants: Optional["EthernetCluster.EthernetClusterVariants"] = field(
        default=None,
        metadata={
            "name": "ETHERNET-CLUSTER-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EthernetClusterVariants:
        ethernet_cluster_conditional: list[EthernetClusterConditional] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-CLUSTER-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class FlexrayCluster:
    """
    FlexRay specific attributes to the physicalCluster.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar flexray_cluster_variants: This element was generated/modified
        due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FLEXRAY-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["FlexrayCluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["FlexrayCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    flexray_cluster_variants: Optional["FlexrayCluster.FlexrayClusterVariants"] = field(
        default=None,
        metadata={
            "name": "FLEXRAY-CLUSTER-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class FlexrayClusterVariants:
        flexray_cluster_conditional: list[FlexrayClusterConditional] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-CLUSTER-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class J1939Cluster:
    """
    J1939 specific cluster attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar j_1939_cluster_variants: This element was generated/modified
        due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "J-1939-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["J1939Cluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["J1939Cluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    j_1939_cluster_variants: Optional["J1939Cluster.J1939ClusterVariants"] = field(
        default=None,
        metadata={
            "name": "J-1939-CLUSTER-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class J1939ClusterVariants:
        j_1939_cluster_conditional: list[J1939ClusterConditional] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-CLUSTER-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class LinCluster:
    """
    LIN specific attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar lin_cluster_variants: This element was generated/modified due
        to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "LIN-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["LinCluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["LinCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    lin_cluster_variants: Optional["LinCluster.LinClusterVariants"] = field(
        default=None,
        metadata={
            "name": "LIN-CLUSTER-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class LinClusterVariants:
        lin_cluster_conditional: list[LinClusterConditional] = field(
            default_factory=list,
            metadata={
                "name": "LIN-CLUSTER-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class RecordValueSpecification:
    """
    Specifies the values for a record.

    :ivar short_label: This can be used to identify particular value
        specifications for human readers, for example elements of a
        record type.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        ArrayValueSpecification.element Applicable for:
        RecordValueSpecification.field Not Applicable for:
        CompositeRuleBasedValueSpecification.argument Not Applicable
        for: ConstantSpecification.valueSpec Not Applicable for:
        PortPrototypeBlueprintInitValue.value Not Applicable for:
        DiagnosticEnvDataCondition.compareValue Not Applicable for:
        DiagnosticEnvDataElementCondition.compareValue Not Applicable
        for: ParameterDataPrototype.initValue Not Applicable for:
        VariableDataPrototype.initValue Not Applicable for:
        CalibrationParameterValue.applInitValue Not Applicable for:
        CalibrationParameterValue.implInitValue Not Applicable for:
        MetaDataItem.metaDataItemType Not Applicable for:
        NvProvideComSpec.romBlockInitValue Not Applicable for:
        NvProvideComSpec.ramBlockInitValue Not Applicable for:
        NvRequireComSpec.initValue Not Applicable for:
        ParameterProvideComSpec.initValue Not Applicable for:
        ParameterRequireComSpec.initValue Not Applicable for:
        NonqueuedSenderComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.initValue Not Applicable for:
        NonqueuedReceiverComSpec.timeoutSubstitutionValue Not Applicable
        for: PortDefinedArgumentValue.value Not Applicable for:
        CryptoServiceKey.developmentValue Not Applicable for:
        ISignal.timeoutSubstitutionValue Not Applicable for:
        ISignal.initValue Not Applicable for:
        FieldSenderComSpec.initValue Not Applicable for:
        PersistencyDataRequiredComSpec.initValue Not Applicable for:
        ApplicationAssocMapElementValueSpecification.value Not
        Applicable for: ApplicationAssocMapElementValueSpecification.key
        Not Applicable for: StateManagementCompareCondition.compareValue
        Not Applicable for: PersistencyKeyValuePair.initValue Not
        Applicable for: SwDataDefPropsContent.invalidValue
    :ivar fields: The value for a single record field. This could also
        be mapped explicitly to a record element of the data type using
        the shortName of the ValueSpecification. But this would
        introduce a relationship to the data type that is too strong. As
        of now, it is only important that the structure of the data type
        matches the structure of the ValueSpecification independently of
        the shortNames.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "RECORD-VALUE-SPECIFICATION"

    short_label: Identifier | None = field(
        default=None,
        metadata={
            "name": "SHORT-LABEL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fields: Optional["RecordValueSpecification.Fields"] = field(
        default=None,
        metadata={
            "name": "FIELDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Fields:
        application_assoc_map_value_specification: list[ApplicationAssocMapValueSpecification] = (
            field(
                default_factory=list,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: list[ApplicationRuleBasedValueSpecification] = (
            field(
                default_factory=list,
                metadata={
                    "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_value_specification: list[ApplicationValueSpecification] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: list[ArrayValueSpecification] = field(
            default_factory=list,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: list[CompositeRuleBasedValueSpecification] = (
            field(
                default_factory=list,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: list[ConstantReference] = field(
            default_factory=list,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: list[NotAvailableValueSpecification] = field(
            default_factory=list,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: list[NumericalRuleBasedValueSpecification] = (
            field(
                default_factory=list,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: list[NumericalValueSpecification] = field(
            default_factory=list,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: list["RecordValueSpecification"] = field(
            default_factory=list,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: list[ReferenceValueSpecification] = field(
            default_factory=list,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: list[TextValueSpecification] = field(
            default_factory=list,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Row:
    """
    This meta-class represents the ability to express one row in a table.

    :ivar entry: This represents one particular table cell. It is an
        entry in the table.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: Tbody.row
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    :ivar rowsep: Indicates if by default a line should be displayed
        below the row.
    :ivar valign: Indicates how the cells in the rows shall be aligned.
        Default is inherited from tbody, otherwise it is "TOP"
    """

    class Meta:
        name = "ROW"

    entry: list[Entry] = field(
        default_factory=list,
        metadata={
            "name": "ENTRY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )
    rowsep: str | None = field(
        default=None,
        metadata={
            "name": "ROWSEP",
            "type": "Attribute",
            "pattern": r"[0-1]",
        },
    )
    valign: ValignEnumSimple | None = field(
        default=None,
        metadata={
            "name": "VALIGN",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class TtcanCluster:
    """
    TTCAN bus specific cluster attributes.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar ttcan_cluster_variants: This element was generated/modified
        due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TTCAN-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TtcanCluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TtcanCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ttcan_cluster_variants: Optional["TtcanCluster.TtcanClusterVariants"] = field(
        default=None,
        metadata={
            "name": "TTCAN-CLUSTER-VARIANTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TtcanClusterVariants:
        ttcan_cluster_conditional: list[TtcanClusterConditional] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-CLUSTER-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class UserDefinedCluster:
    """
    This element allows the modeling of arbitrary Communication Clusters (e.g. bus
    systems that are not supported by AUTOSAR).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar user_defined_cluster_variants: This element was
        generated/modified due to an atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "USER-DEFINED-CLUSTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["UserDefinedCluster.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["UserDefinedCluster.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    user_defined_cluster_variants: Optional["UserDefinedCluster.UserDefinedClusterVariants"] = (
        field(
            default=None,
            metadata={
                "name": "USER-DEFINED-CLUSTER-VARIANTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class UserDefinedClusterVariants:
        user_defined_cluster_conditional: list[UserDefinedClusterConditional] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-CLUSTER-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CalibrationParameterValue:
    """Specifies instance specific calibration parameter values used to initialize
    the memory objects implementing calibration parameters in the generated RTE
    code.

    RTE generator will use the implInitValue to override the initial values specified for the DataPrototypes of a component type.
    The applInitValue is used to exchange init values with the component vendor not publishing the transformation algorithm between ApplicationDataTypes and ImplementationDataTypes or defining an instance specific initialization of components which are only defined with ApplicationDataTypes.
    Note: If both representations of init values are available these need to represent the same content.
    Note further that in this case an explicit mapping of ValueSpecification is not implemented because calibration parameters are delivered back after the calibration phase.

    :ivar appl_init_value: This is the initial value specification
        structured according to the ApplicationDataType This aggregation
        contains a variation point although it is not variant.
        Therefore, this variation point shall not exist in models. See
        constr_2638.
    :ivar impl_init_value: This is the initial value specification
        structured according to the ImplementationDataType This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar initialized_parameter_ref: This represents the parameter that
        is initialized by the CalibrationParameterValue.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        CalibrationParameterValueSet.calibrationParameterValue
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CALIBRATION-PARAMETER-VALUE"

    appl_init_value: Optional["CalibrationParameterValue.ApplInitValue"] = field(
        default=None,
        metadata={
            "name": "APPL-INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    impl_init_value: Optional["CalibrationParameterValue.ImplInitValue"] = field(
        default=None,
        metadata={
            "name": "IMPL-INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    initialized_parameter_ref: Optional["CalibrationParameterValue.InitializedParameterRef"] = (
        field(
            default=None,
            metadata={
                "name": "INITIALIZED-PARAMETER-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ApplInitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplInitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InitializedParameterRef(Ref):
        dest: FlatInstanceDescriptorSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ConstantSpecification:
    """
    Specification of a constant that can be part of a package, i.e. it can be
    defined stand-alone.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar value_spec: Specification of an expression leading to a value
        for this constant. This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CONSTANT-SPECIFICATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ConstantSpecification.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ConstantSpecification.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_spec: Optional["ConstantSpecification.ValueSpec"] = field(
        default=None,
        metadata={
            "name": "VALUE-SPEC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueSpec:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CryptoServiceKey:
    """
    This meta-class has the ability to represent a crypto key.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar algorithm_family: This attribute represent the description of
        the family of the applicable crypto algorithm.
    :ivar development_value: This aggregation represents the ability to
        assign a specific value to the crypto key as part of the system
        description. This value can then be taken for the development of
        the respective ECU. This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar key_generation: This attribute describes how a the specific
        cryptographic key is created.
    :ivar key_storage_type: This attribute describes where the enclosing
        cryptographic key shall be stored. AUTOSAR reserves specific
        values for this attributes but it is possible to insert custom
        values as well.
    :ivar length: This attribute describes the length of the
        cryptographic key in bits.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CRYPTO-SERVICE-KEY"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CryptoServiceKey.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CryptoServiceKey.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    algorithm_family: String | None = field(
        default=None,
        metadata={
            "name": "ALGORITHM-FAMILY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    development_value: Optional["CryptoServiceKey.DevelopmentValue"] = field(
        default=None,
        metadata={
            "name": "DEVELOPMENT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_generation: CryptoServiceKeyGenerationEnum | None = field(
        default=None,
        metadata={
            "name": "KEY-GENERATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_storage_type: String | None = field(
        default=None,
        metadata={
            "name": "KEY-STORAGE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DevelopmentValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEnvDataCondition:
    """A DiagnosticEnvDataCondition is an atomic condition that compares the
    current value of the referenced DiagnosticDataElement with a constant value
    defined by the ValueSpecification.

    All compareTypes are supported.

    :ivar compare_type: This attributes represents the concrete type of
        the comparison.
    :ivar compare_value: This attribute represents a fixed compare value
        taken to evaluate the compare condition. This aggregation
        contains a variation point although it is not variant.
        Therefore, this variation point shall not exist in models. See
        constr_2638.
    :ivar data_element_ref: This reference represents the related
        diagnostic data element.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ENV-DATA-CONDITION"

    compare_type: DiagnosticCompareTypeEnum | None = field(
        default=None,
        metadata={
            "name": "COMPARE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compare_value: Optional["DiagnosticEnvDataCondition.CompareValue"] = field(
        default=None,
        metadata={
            "name": "COMPARE-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["DiagnosticEnvDataCondition.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CompareValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: DiagnosticDataElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEnvDataElementCondition:
    """
    This meta-class represents the ability to formulate a diagnostic environment
    condition based on the value of a data element owned by the application
    software.

    :ivar compare_type: This attributes represents the concrete type of
        the comparison.
    :ivar compare_value: This aggregation represents the definition of
        the compare value against which the value taken from the
        application software shall be compared. This aggregation
        contains a variation point although it is not variant.
        Therefore, this variation point shall not exist in models. See
        constr_2638.
    :ivar data_prototype_iref: This instanceRef represent the ability to
        access a data element owned by the application software on the
        AUTOSAR classic platform.
    :ivar p_port_prototype_iref: This instanceRef identifies the
        PortPrototype from which the relevant information for the
        environment condition can be obtained. This InstanceRef is only
        relevant for the adaptive platform.
    :ivar process_ref: This reference identifies the applicable
        ProcessDesign.
    :ivar sw_data_def_props: Via this aggregation it is possible to
        describe the properties of the data that is obtained from the
        application for the environmental condition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ENV-DATA-ELEMENT-CONDITION"

    compare_type: DiagnosticCompareTypeEnum | None = field(
        default=None,
        metadata={
            "name": "COMPARE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compare_value: Optional["DiagnosticEnvDataElementCondition.CompareValue"] = field(
        default=None,
        metadata={
            "name": "COMPARE-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_prototype_iref: DataPrototypeInSystemInstanceRef | None = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p_port_prototype_iref: PPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "P-PORT-PROTOTYPE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    process_ref: Optional["DiagnosticEnvDataElementCondition.ProcessRef"] = field(
        default=None,
        metadata={
            "name": "PROCESS-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CompareValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProcessRef(Ref):
        dest: ProcessDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class FieldSenderComSpec:
    """
    Port specific communication attributes for a Field that is defined in a
    ServiceInterface.

    :ivar composite_network_representations: This represents a
        CompositeNetworkRepresentation defined in the context of a
        SenderComSpec.
    :ivar data_element_ref: Data element these quality of service
        attributes apply to.
    :ivar data_update_period: This attribute describes the period in
        which the applications are assumed to transmit the respective
        data.
    :ivar handle_out_of_range: This attribute controls how out-of-range
        values shall be dealt with.
    :ivar network_representation: A networkRepresentation is used to
        define how the dataElement is mapped to a communication bus.
    :ivar sender_intent: This attribute represents the expressed intent
        of the sender. The sender may decide to claim that existing
        resources of a ServiceInterface are expressly not used by this
        specific sender. The conceptual background of this claim may be
        driven by security, safety, etc.
    :ivar transmission_acknowledge: Requested transmission
        acknowledgement for data element.
    :ivar transmission_props: This aggregation represents the definition
        transmission props in the context of the enclosing
        SenderComSpec.
    :ivar uses_end_to_end_protection: This indicates whether the
        corresponding dataElement shall be transmitted using end-to-end
        protection.
    :ivar init_value: Initial value for a Field that is set before the
        ServiceInterface is offered. This aggregation contains a
        variation point although it is not variant. Therefore, this
        variation point shall not exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "FIELD-SENDER-COM-SPEC"

    composite_network_representations: Optional[
        "FieldSenderComSpec.CompositeNetworkRepresentations"
    ] = field(
        default=None,
        metadata={
            "name": "COMPOSITE-NETWORK-REPRESENTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["FieldSenderComSpec.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_update_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DATA-UPDATE-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    handle_out_of_range: HandleOutOfRangeEnum | None = field(
        default=None,
        metadata={
            "name": "HANDLE-OUT-OF-RANGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_representation: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "NETWORK-REPRESENTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sender_intent: SenderIntentEnum | None = field(
        default=None,
        metadata={
            "name": "SENDER-INTENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_acknowledge: TransmissionAcknowledgementRequest | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-ACKNOWLEDGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_props: TransmissionComSpecProps | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uses_end_to_end_protection: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "USES-END-TO-END-PROTECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    init_value: Optional["FieldSenderComSpec.InitValue"] = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CompositeNetworkRepresentations:
        composite_network_representation: list[CompositeNetworkRepresentation] = field(
            default_factory=list,
            metadata={
                "name": "COMPOSITE-NETWORK-REPRESENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class InitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ISignal:
    """Signal of the Interaction Layer.

    The RTE supports a "signal fan-out" where the same System Signal is
    sent in different SignalIPdus to multiple receivers. To support the
    RTE "signal fan-out" each SignalIPdu  contains ISignals. If the same
    System Signal is to be mapped into several SignalIPdus there is one
    ISignal needed for each ISignalToIPduMapping. ISignals describe the
    Interface between the Precompile configured RTE and the potentially
    Postbuild configured Com Stack (see ECUC Parameter Mapping). In case
    of the SystemSignalGroup an ISignal shall be created for each
    SystemSignal contained in the SystemSignalGroup.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar data_transformations: This property was modified due to
        atpVariation (DirectedAssociationPattern).
    :ivar data_type_policy: With the aggregation of SwDataDefProps an
        ISignal specifies how it is represented on the network. This
        representation follows a particular policy. Note that this
        causes some redundancy which is intended and can be used to
        support flexible development methodology as well as subsequent
        integrity checks. If the policy
        "networkRepresentationFromComSpec" is chosen the network
        representation from the ComSpec that is aggregated by the
        PortPrototype shall be used. If the "override" policy is chosen
        the requirements specified in the PortInterface and in the
        ComSpec are not fulfilled by the networkRepresentationProps. In
        case the System Description doesn't use a complete Software
        Component Description (VFB View) the "legacy" policy can be
        chosen.
    :ivar i_signal_props: Additional optional ISignal properties that
        may be stored in different files.
    :ivar i_signal_type: This attribute defines whether this iSignal is
        an array that results in a UINT8_N / UINT8_DYN ComSignalType in
        the COM configuration or a primitive type.
    :ivar init_value: Optional definition of a ISignal's initValue in
        case the System Description doesn't use a complete Software
        Component Description (VFB View). This supports the inclusion of
        legacy system signals. This value can be used to configure the
        Signal's "InitValue". If a full DataMapping exist for the
        SystemSignal this information may be available from a configured
        SenderComSpec and ReceiverComSpec. In this case the initvalues
        in SenderComSpec and/or ReceiverComSpec override this optional
        value specification. Further restrictions apply from the RTE
        specification. This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar length: Size of the signal in bits. The size needs to be
        derived from the mapped VariableDataPrototype according to the
        mapping of primitive DataTypes to BaseTypes as used in the RTE.
        Indicates maximum size for dynamic length signals. The ISignal
        length of zero bits is allowed.
    :ivar network_representation_props: Specification of the actual
        network representation. The usage of SwDataDefProps for this
        purpose is restricted to the attributes compuMethod and
        baseType. The optional baseType attributes "memAllignment" and
        "byteOrder" shall not be used. The attribute "dataTypePolicy" in
        the SystemTemplate element defines whether this network
        representation shall be ignored and the information shall be
        taken over from  the network representation of the ComSpec. If
        "override" is chosen by the system integrator the network
        representation can violate against the requirements defined in
        the PortInterface and in the network representation of the
        ComSpec. In case that the System Description doesn't use a
        complete Software Component Description (VFB View) this element
        is used to configure "ComSignalDataInvalidValue" and the Data
        Semantics.
    :ivar system_signal_ref: Reference to the System Signal that is
        supposed to be transmitted in the ISignal.
    :ivar timeout_substitution_value: Defines and enables the
        ComTimeoutSubstituition for this ISignal. This aggregation
        contains a variation point although it is not variant.
        Therefore, this variation point shall not exist in models. See
        constr_2638.
    :ivar transformation_i_signal_propss: A transformer chain consists
        of an ordered list of transformers. The ISignal specific
        configuration properties for each transformer are defined in the
        TransformationISignalProps class. The transformer configuration
        properties that are common for all ISignals are described in the
        TransformationTechnology class.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "I-SIGNAL"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ISignal.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ISignal.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_transformations: Optional["ISignal.DataTransformations"] = field(
        default=None,
        metadata={
            "name": "DATA-TRANSFORMATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_type_policy: DataTypePolicyEnum | None = field(
        default=None,
        metadata={
            "name": "DATA-TYPE-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_props: ISignalProps | None = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    i_signal_type: ISignalTypeEnum | None = field(
        default=None,
        metadata={
            "name": "I-SIGNAL-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    init_value: Optional["ISignal.InitValue"] = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    length: UnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_representation_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "NETWORK-REPRESENTATION-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_signal_ref: Optional["ISignal.SystemSignalRef"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-SIGNAL-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_substitution_value: Optional["ISignal.TimeoutSubstitutionValue"] = field(
        default=None,
        metadata={
            "name": "TIMEOUT-SUBSTITUTION-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformation_i_signal_propss: Optional["ISignal.TransformationISignalPropss"] = field(
        default=None,
        metadata={
            "name": "TRANSFORMATION-I-SIGNAL-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataTransformations:
        data_transformation_ref_conditional: list[DataTransformationRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "DATA-TRANSFORMATION-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SystemSignalRef(Ref):
        dest: SystemSignalSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TimeoutSubstitutionValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TransformationISignalPropss:
        end_to_end_transformation_i_signal_props: list[EndToEndTransformationISignalProps] = field(
            default_factory=list,
            metadata={
                "name": "END-TO-END-TRANSFORMATION-I-SIGNAL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_transformation_i_signal_props: list[SomeipTransformationISignalProps] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-TRANSFORMATION-I-SIGNAL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_transformation_i_signal_props: list[UserDefinedTransformationISignalProps] = (
            field(
                default_factory=list,
                metadata={
                    "name": "USER-DEFINED-TRANSFORMATION-I-SIGNAL-PROPS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )


@dataclass(slots=True, kw_only=True)
class NonqueuedReceiverComSpec:
    """
    Communication attributes specific to non-queued receiving.

    :ivar composite_network_representations: This represents a
        CompositeNetworkRepresentation defined in the context of a
        ReceiverComSpec. The purpose of this aggregation is to be able
        to specify the network representation of leaf elements of
        ApplicationCompositeDataTypes.
    :ivar data_element_ref: Data element these attributes belong to.
    :ivar data_update_period: This attribute defines the period in which
        the application shall check for updated data. This attribute is
        used for the configuration of the E2E protection, but may also
        indicate a general data reception period.
    :ivar external_replacement_ref: This reference is used to reference
        the AutosarDataPrototype to be taken for sourcing an external
        replacement in the out-of-range handling.
    :ivar handle_out_of_range: This attribute controls how values that
        are out of the specified range are handled according to the
        values of HandleOutOfRangeEnum.
    :ivar handle_out_of_range_status: Control the way how return values
        are created in case of an out-of-range situation.
    :ivar max_delta_counter_init: Initial maximum allowed gap between
        two counter values of two consecutively received valid Data,
        i.e. how many subsequent lost data is accepted. For example, if
        the receiver gets Data with counter 1 and MaxDeltaCounterInit is
        1, then at the next reception the receiver can accept Counters
        with values 2 and 3, but not 4. Note that if the receiver does
        not receive new Data at a consecutive read, then the receiver
        increments the tolerance by 1. Caveat: The E2E wrapper approach
        involves technologies that are not subjected to the AUTOSAR
        standard and is superseded by the superior E2E transformer
        approach (which is fully standardized by AUTOSAR). Hence, new
        projects (without legacy constraints due to carry-over parts)
        shall use the fully standardized E2E transformer approach.
    :ivar max_no_new_or_repeated_data: The maximum amount of missing or
        repeated Data which the receiver does not expect to exceed under
        normal communication conditions. Caveat: The E2E wrapper
        approach involves technologies that are not subjected to the
        AUTOSAR standard and is superseded by the superior E2E
        transformer approach (which is fully standardized by AUTOSAR).
        Hence, new projects (without legacy constraints due to carry-
        over parts) shall use the fully standardized E2E transformer
        approach.
    :ivar network_representation: A networkRepresentation is used to
        define how the dataElement is mapped to a communication bus.
    :ivar receiver_intent: This attribute represents the expressed
        intent of the receiver. The receiver may decide to claim that
        existing resources of a ServiceInterface are expressly not used
        by this specific receiver. The conceptual background of this
        claim may be driven by security, safety, etc.
    :ivar reception_props: "This aggregation represents the definition
        transmission props in the context of the enclosing
        ReceiverComSpec.
    :ivar replace_with: This aggregation is used to identify the
        AutosarDataPrototype to be taken for sourcing an external
        replacement in the out-of-range and invalidValue handling. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar sync_counter_init: Number of Data required for validating the
        consistency of the counter that shall be received with a valid
        counter (i.e. counter within the allowed lock-in range) after
        the detection of an unexpected behavior of a received counter.
        Caveat: The E2E wrapper approach involves technologies that are
        not subjected to the AUTOSAR standard and is superseded by the
        superior E2E transformer approach (which is fully standardized
        by AUTOSAR). Hence, new projects (without legacy constraints due
        to carry-over parts) shall use the fully standardized E2E
        transformer approach.
    :ivar transformation_com_spec_propss: This references the
        TransformationComSpecProps which define  port-specific
        configuration for data transformation.
    :ivar uses_end_to_end_protection: This indicates whether the
        corresponding dataElement shall be transmitted using end-to-end
        protection. Caveat: The E2E wrapper approach involves
        technologies that are not subjected to the AUTOSAR standard and
        is superseded by the superior E2E transformer approach (which is
        fully standardized by AUTOSAR). Hence, new projects (without
        legacy constraints due to carry-over parts) shall use the fully
        standardized E2E transformer approach.
    :ivar alive_timeout: Specify the amount of time (in seconds) after
        which the software component (via the RTE) needs to be notified
        if the corresponding data item have not been received according
        to the specified timing description. If the aliveTimeout
        attribute is 0 no timeout monitoring shall be performed.
    :ivar enable_update: This attribute controls whether application
        code is entitled to check whether the value of the corresponding
        VariableDataPrototype has been updated.
    :ivar filter: The applicable filter algorithm for filtering the
        value of the corresponding dataElement.
    :ivar handle_data_status: If this attribute is set to true, then the
        Rte_IStatus API shall exist. If the attribute does not exist or
        is set to false, then the Rte_IStatus API may still exist in
        response to the existence of further conditions.
    :ivar handle_never_received: This attribute specifies whether for
        the corresponding VariableDataPrototype the "never received"
        flag is available. If yes, the RTE is supposed to assume that
        initially the VariableDataPrototype has not been received
        before. After the first reception of the corresponding
        VariableDataPrototype the flag is cleared. * If the value of
        this attribute is set to "true" the flag is required. * If set
        to "false", the RTE shall not support the "never received"
        functionality for the corresponding VariableDataPrototype.
    :ivar handle_timeout_type: This attribute controls the behavior with
        respect to the handling of timeouts.
    :ivar init_value: Initial value to be used in case the sending
        component is not yet initialized. If the sender also specifies
        an initial value, then the receiver's value will be used. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar timeout_substitution_value: This attribute represents the
        substitution value applicable in the case of a timeout. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NONQUEUED-RECEIVER-COM-SPEC"

    composite_network_representations: Optional[
        "NonqueuedReceiverComSpec.CompositeNetworkRepresentations"
    ] = field(
        default=None,
        metadata={
            "name": "COMPOSITE-NETWORK-REPRESENTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["NonqueuedReceiverComSpec.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_update_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DATA-UPDATE-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    external_replacement_ref: Optional["NonqueuedReceiverComSpec.ExternalReplacementRef"] = field(
        default=None,
        metadata={
            "name": "EXTERNAL-REPLACEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    handle_out_of_range: HandleOutOfRangeEnum | None = field(
        default=None,
        metadata={
            "name": "HANDLE-OUT-OF-RANGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    handle_out_of_range_status: HandleOutOfRangeStatusEnum | None = field(
        default=None,
        metadata={
            "name": "HANDLE-OUT-OF-RANGE-STATUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_delta_counter_init: PositiveIntegerValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "MAX-DELTA-COUNTER-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    max_no_new_or_repeated_data: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAX-NO-NEW-OR-REPEATED-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_representation: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "NETWORK-REPRESENTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    receiver_intent: ReceiverIntentEnum | None = field(
        default=None,
        metadata={
            "name": "RECEIVER-INTENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reception_props: ReceptionComSpecProps | None = field(
        default=None,
        metadata={
            "name": "RECEPTION-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    replace_with: VariableAccess | None = field(
        default=None,
        metadata={
            "name": "REPLACE-WITH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sync_counter_init: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "SYNC-COUNTER-INIT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformation_com_spec_propss: Optional[
        "NonqueuedReceiverComSpec.TransformationComSpecPropss"
    ] = field(
        default=None,
        metadata={
            "name": "TRANSFORMATION-COM-SPEC-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uses_end_to_end_protection: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "USES-END-TO-END-PROTECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    alive_timeout: TimeValue | None = field(
        default=None,
        metadata={
            "name": "ALIVE-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    enable_update: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-UPDATE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    filter: DataFilter | None = field(
        default=None,
        metadata={
            "name": "FILTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    handle_data_status: Boolean | None = field(
        default=None,
        metadata={
            "name": "HANDLE-DATA-STATUS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    handle_never_received: Boolean | None = field(
        default=None,
        metadata={
            "name": "HANDLE-NEVER-RECEIVED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    handle_timeout_type: HandleTimeoutEnum | None = field(
        default=None,
        metadata={
            "name": "HANDLE-TIMEOUT-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    init_value: Optional["NonqueuedReceiverComSpec.InitValue"] = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timeout_substitution_value: Optional["NonqueuedReceiverComSpec.TimeoutSubstitutionValue"] = (
        field(
            default=None,
            metadata={
                "name": "TIMEOUT-SUBSTITUTION-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CompositeNetworkRepresentations:
        composite_network_representation: list[CompositeNetworkRepresentation] = field(
            default_factory=list,
            metadata={
                "name": "COMPOSITE-NETWORK-REPRESENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ExternalReplacementRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class TransformationComSpecPropss:
        end_to_end_transformation_com_spec_props: list[EndToEndTransformationComSpecProps] = field(
            default_factory=list,
            metadata={
                "name": "END-TO-END-TRANSFORMATION-COM-SPEC-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_transformation_com_spec_props: list[UserDefinedTransformationComSpecProps] = (
            field(
                default_factory=list,
                metadata={
                    "name": "USER-DEFINED-TRANSFORMATION-COM-SPEC-PROPS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

    @dataclass(slots=True, kw_only=True)
    class InitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimeoutSubstitutionValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class NonqueuedSenderComSpec:
    """
    Communication attributes for non-queued sender/receiver communication (sender
    side)

    :ivar composite_network_representations: This represents a
        CompositeNetworkRepresentation defined in the context of a
        SenderComSpec.
    :ivar data_element_ref: Data element these quality of service
        attributes apply to.
    :ivar data_update_period: This attribute describes the period in
        which the applications are assumed to transmit the respective
        data.
    :ivar handle_out_of_range: This attribute controls how out-of-range
        values shall be dealt with.
    :ivar network_representation: A networkRepresentation is used to
        define how the dataElement is mapped to a communication bus.
    :ivar sender_intent: This attribute represents the expressed intent
        of the sender. The sender may decide to claim that existing
        resources of a ServiceInterface are expressly not used by this
        specific sender. The conceptual background of this claim may be
        driven by security, safety, etc.
    :ivar transmission_acknowledge: Requested transmission
        acknowledgement for data element.
    :ivar transmission_props: This aggregation represents the definition
        transmission props in the context of the enclosing
        SenderComSpec.
    :ivar uses_end_to_end_protection: This indicates whether the
        corresponding dataElement shall be transmitted using end-to-end
        protection.
    :ivar data_filter: The applicable filter algorithm for filtering the
        value of the corresponding dataElement.
    :ivar init_value: Initial value to be sent if sender component is
        not yet fully initialized, but receiver needs data already. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NONQUEUED-SENDER-COM-SPEC"

    composite_network_representations: Optional[
        "NonqueuedSenderComSpec.CompositeNetworkRepresentations"
    ] = field(
        default=None,
        metadata={
            "name": "COMPOSITE-NETWORK-REPRESENTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_element_ref: Optional["NonqueuedSenderComSpec.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_update_period: TimeValue | None = field(
        default=None,
        metadata={
            "name": "DATA-UPDATE-PERIOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    handle_out_of_range: HandleOutOfRangeEnum | None = field(
        default=None,
        metadata={
            "name": "HANDLE-OUT-OF-RANGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    network_representation: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "NETWORK-REPRESENTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sender_intent: SenderIntentEnum | None = field(
        default=None,
        metadata={
            "name": "SENDER-INTENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_acknowledge: TransmissionAcknowledgementRequest | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-ACKNOWLEDGE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transmission_props: TransmissionComSpecProps | None = field(
        default=None,
        metadata={
            "name": "TRANSMISSION-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    uses_end_to_end_protection: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "USES-END-TO-END-PROTECTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_filter: DataFilter | None = field(
        default=None,
        metadata={
            "name": "DATA-FILTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    init_value: Optional["NonqueuedSenderComSpec.InitValue"] = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CompositeNetworkRepresentations:
        composite_network_representation: list[CompositeNetworkRepresentation] = field(
            default_factory=list,
            metadata={
                "name": "COMPOSITE-NETWORK-REPRESENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class InitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class NvProvideComSpec:
    """
    Communication attributes of PPortPrototypes with respect to Nv data
    communication on the provided side.

    :ivar ram_block_init_value: This represents the initial value of the
        RAM Block that corresponds to the referenced variable. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar rom_block_init_value: This represents the initial value of the
        ROM block that corresponds to the referenced variable. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar variable_ref: This represents the variable for which the
        ComSpec is specified.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NV-PROVIDE-COM-SPEC"

    ram_block_init_value: Optional["NvProvideComSpec.RamBlockInitValue"] = field(
        default=None,
        metadata={
            "name": "RAM-BLOCK-INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rom_block_init_value: Optional["NvProvideComSpec.RomBlockInitValue"] = field(
        default=None,
        metadata={
            "name": "ROM-BLOCK-INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variable_ref: Optional["NvProvideComSpec.VariableRef"] = field(
        default=None,
        metadata={
            "name": "VARIABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class RamBlockInitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RomBlockInitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class VariableRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class NvRequireComSpec:
    """
    Communication attributes of RPortPrototypes with respect to Nv data
    communication on the required side.

    :ivar init_value: The initial value owned by the NvComSpec This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar variable_ref: The VariableDataPrototype the ComSpec applies
        for.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NV-REQUIRE-COM-SPEC"

    init_value: Optional["NvRequireComSpec.InitValue"] = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variable_ref: Optional["NvRequireComSpec.VariableRef"] = field(
        default=None,
        metadata={
            "name": "VARIABLE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class InitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class VariableRef(Ref):
        dest: VariableDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ParameterDataPrototype:
    """A ParameterDataPrototype represents a formalized generic piece of
    information that is typically immutable by the application software layer, but
    mutable by measurement and calibration tools.

    ParameterDataPrototype is used in various contexts and the specific
    context gives the otherwise generic ParameterDataPrototype a
    dedicated semantics.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sw_data_def_props: This property allows to specify data
        definition properties which apply on data prototype level.
    :ivar type_tref: This represents the corresponding data type.
    :ivar init_value: Specifies initial value(s) of the
        ParameterDataPrototype This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        InternalBehavior.constantMemory Applicable for:
        SwcInternalBehavior.perInstanceParameter Applicable for:
        SwcInternalBehavior.sharedParameter Applicable for:
        BswInternalBehavior.perInstanceParameter Not Applicable for:
        ParameterInterface.parameter Not Applicable for:
        NvBlockDescriptor.romBlock
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PARAMETER-DATA-PROTOTYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ParameterDataPrototype.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ParameterDataPrototype.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_tref: Optional["ParameterDataPrototype.TypeTref"] = field(
        default=None,
        metadata={
            "name": "TYPE-TREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    init_value: Optional["ParameterDataPrototype.InitValue"] = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TypeTref(Ref):
        dest: AutosarDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class InitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ParameterProvideComSpec:
    """
    "Communication" specification that applies to parameters on the provided side
    of a connection.

    :ivar init_value: The initial value applicable for the corresponding
        ParameterDataPrototype. This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar parameter_ref: The ParameterDataPrototype to which the
        ParameterComSpec applies.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PARAMETER-PROVIDE-COM-SPEC"

    init_value: Optional["ParameterProvideComSpec.InitValue"] = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_ref: Optional["ParameterProvideComSpec.ParameterRef"] = field(
        default=None,
        metadata={
            "name": "PARAMETER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class InitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ParameterRef(Ref):
        dest: ParameterDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ParameterRequireComSpec:
    """
    "Communication" specification that applies to parameters on the required side
    of a connection.

    :ivar init_value: The initial value applicable for the corresponding
        ParameterDataPrototype. This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar parameter_ref: The ParameterDataPrototype to which the
        ParameterRequireComSpec applies.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PARAMETER-REQUIRE-COM-SPEC"

    init_value: Optional["ParameterRequireComSpec.InitValue"] = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_ref: Optional["ParameterRequireComSpec.ParameterRef"] = field(
        default=None,
        metadata={
            "name": "PARAMETER-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class InitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ParameterRef(Ref):
        dest: ParameterDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PersistencyDataRequiredComSpec:
    """
    This meta-class represents the ability to define port-specific attributes for
    supporting use cases of data persistency on the required side.

    :ivar data_element_ref: This refrence represents the
        PersistencyDataElement for which the
        PersistencyDataRequiredComSpec applies.
    :ivar init_value: This aggregation represents the definition of an
        initial value for the PersistencyDataElement referenced by the
        enclosing PersistencyDataRequiredComSpec This aggregation
        contains a variation point although it is not variant.
        Therefore, this variation point shall not exist in models. See
        constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-DATA-REQUIRED-COM-SPEC"

    data_element_ref: Optional["PersistencyDataRequiredComSpec.DataElementRef"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    init_value: Optional["PersistencyDataRequiredComSpec.InitValue"] = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataElementRef(Ref):
        dest: PersistencyDataElementSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class InitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PersistencyKeyValuePair:
    """
    This meta-class represents the ability to formally model a key-value pair in
    the context of the deployment of persistency.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar update_strategy: This attribute can be used to specify the
        update strategy of the respective PersistencyDeploymentElement.
    :ivar init_value: This aggregation represents the ability to define
        an initial value for the value side of the key-value pair.
        Please note that it does not make sense to configure an initial
        value if the PersistencyDeploymentElement.updateStrategy is set
        to the value delete. This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar value_data_type_ref: This reference represents the data type
        applicable for the value of the key-value pair.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-KEY-VALUE-PAIR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PersistencyKeyValuePair.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PersistencyKeyValuePair.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update_strategy: PersistencyElementLevelUpdateStrategyEnum | None = field(
        default=None,
        metadata={
            "name": "UPDATE-STRATEGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    init_value: Optional["PersistencyKeyValuePair.InitValue"] = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_data_type_ref: Optional["PersistencyKeyValuePair.ValueDataTypeRef"] = field(
        default=None,
        metadata={
            "name": "VALUE-DATA-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueDataTypeRef(Ref):
        dest: AbstractImplementationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PortDefinedArgumentValue:
    """A PortDefinedArgumentValue is passed to a RunnableEntity dealing with the
    ClientServerOperations provided by a given PortPrototype.

    Note that this is restricted to PPortPrototypes of a
    ClientServerInterface.

    :ivar value: Specifies the actual value. This aggregation contains a
        variation point although it is not variant. Therefore, this
        variation point shall not exist in models. See constr_2638.
    :ivar value_type_tref: The implementation type of this argument
        value. It should not be composite type or a pointer.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-DEFINED-ARGUMENT-VALUE"

    value: Optional["PortDefinedArgumentValue.Value"] = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_type_tref: Optional["PortDefinedArgumentValue.ValueTypeTref"] = field(
        default=None,
        metadata={
            "name": "VALUE-TYPE-TREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Value:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ValueTypeTref(Ref):
        dest: ImplementationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class PortPrototypeBlueprintInitValue:
    """This meta-class represents the ability to express init values in
    PortPrototypeBlueprints.

    These init values act as a kind of blueprint from which for example
    proper ComSpecs can be derived.

    :ivar data_prototype_ref: This is the data prototype for which the
        init value applies
    :ivar value: This is the init value for the particular data
        prototype. This aggregation contains a variation point although
        it is not variant. Therefore, this variation point shall not
        exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-PROTOTYPE-BLUEPRINT-INIT-VALUE"

    data_prototype_ref: Optional["PortPrototypeBlueprintInitValue.DataPrototypeRef"] = field(
        default=None,
        metadata={
            "name": "DATA-PROTOTYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value: Optional["PortPrototypeBlueprintInitValue.Value"] = field(
        default=None,
        metadata={
            "name": "VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class DataPrototypeRef(Ref):
        dest: AutosarDataPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class Value:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StateManagementErrorCompareRule:
    """
    This meta-class represents the configuration of a compare rule for the
    processing of an error submission.

    :ivar compare_type: This attributes represents the concrete type of
        the comparison.
    :ivar compare_value: This aggregation represents the reference value
        against which the value obtained from request shall be compared
        to. This aggregation contains a variation point although it is
        not variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-ERROR-COMPARE-RULE"

    compare_type: StateManagementCompareEnum | None = field(
        default=None,
        metadata={
            "name": "COMPARE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compare_value: Optional["StateManagementErrorCompareRule.CompareValue"] = field(
        default=None,
        metadata={
            "name": "COMPARE-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CompareValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StateManagementTriggerCompareRule:
    """
    This meta-class represents the configuration of a compare rule for the
    processing of a trigger request.

    :ivar compare_type: This attributes represents the concrete type of
        the comparison.
    :ivar compare_value: This aggregation represents the reference value
        against which the value obtained from request shall be compared
        to. This aggregation contains a variation point although it is
        not variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar assumed_current_state_iref: This reference denotes the assumed
        current state for the given compare rule for trigger values.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-TRIGGER-COMPARE-RULE"

    compare_type: StateManagementCompareEnum | None = field(
        default=None,
        metadata={
            "name": "COMPARE-TYPE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compare_value: Optional["StateManagementTriggerCompareRule.CompareValue"] = field(
        default=None,
        metadata={
            "name": "COMPARE-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    assumed_current_state_iref: (
        ModeDeclarationInStateManagementStateNotificationInstanceRef | None
    ) = field(
        default=None,
        metadata={
            "name": "ASSUMED-CURRENT-STATE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class CompareValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SwDataDefPropsConditional:
    """
    This element was generated/modified due to an atpVariation stereotype.

    :ivar display_presentation: This attribute controls the presentation
        of the related data for measurement and calibration tools.
    :ivar step_size: This attribute can be used to define a value which
        is added to or subtracted from the value of a DataPrototype when
        using up/down keys while calibrating.
    :ivar sw_value_block_size_mults: This attribute is used to specify
        the dimensions of a value block (VAL_BLK) for the case that that
        value block has more than one dimension. The dimensions given in
        this attribute are ordered such that the first entry represents
        the first dimension, the second entry represents the second
        dimension, and so on. For one-dimensional value blocks the
        attribute swValueBlockSize shall be used and this attribute
        shall not exist.
    :ivar annotations: This aggregation allows to add annotations
        (yellow pads ...) related to the current data object.
    :ivar sw_addr_method_ref: Addressing method related to this data
        object. Via an association to the same SwAddrMethod it can be
        specified that several DataPrototypes shall be located in the
        same memory without already specifying the memory section
        itself.
    :ivar sw_alignment: The attribute describes the intended typical
        alignment of the DataPrototype. If the attribute is not defined
        the alignment is determined by the swBaseType size and the
        memoryAllocationKeywordPolicy of the referenced SwAddrMethod.
    :ivar base_type_ref: Base type associated with the containing data
        object.
    :ivar sw_bit_representation: Description of the binary
        representation in case of a bit variable.
    :ivar sw_calibration_access: Specifies the read or write access by
        MCD tools for this data object.
    :ivar sw_value_block_size: This represents the size of a Value Block
    :ivar sw_calprm_axis_set: This specifies the properties of the axes
        in case of a curve or map etc. This is mainly applicable to
        calibration parameters.
    :ivar sw_text_props: the specific properties if the data object is a
        text object.
    :ivar sw_comparison_variables: Variables used for comparison in an
        MCD process.
    :ivar compu_method_ref: Computation method associated with the
        semantics of this data object.
    :ivar data_constr_ref: Data constraint for this data object.
    :ivar sw_data_dependency: Describes how the value of the data object
        has to be calculated from the value of another data object (by
        the MCD system).
    :ivar display_format: This property describes how a number is to be
        rendered e.g. in documents or in a measurement and calibration
        system.
    :ivar implementation_data_type_ref: This association denotes the
        ImplementationDataType of a data declaration via its aggregated
        SwDataDefProps. It is used whenever a data declaration is not
        directly referring to a base type. Especially * redefinition of
        an ImplementationDataType via a "typedef" to another
        ImplementationDatatype * the target type of a pointer (see
        SwPointerTargetProps), if it does not refer to a base type
        directly * the data type of an array or record element within an
        ImplementationDataType, if it does not refer to a base type
        directly * the data type of an SwServiceArg, if it does not
        refer to a base type directly
    :ivar sw_host_variable: Contains a reference to a variable which
        serves as a host-variable for a bit variable. Only applicable to
        bit objects.
    :ivar sw_impl_policy: Implementation policy for this data object.
    :ivar additional_native_type_qualifier: This attribute is used to
        declare native qualifiers of the programming language which can
        neither be deduced from the baseType (e.g. because the data
        object describes a pointer) nor from other more abstract
        attributes. Examples are qualifiers like "volatile", "strict" or
        "enum" of the C-language. All such declarations have to be put
        into one string.
    :ivar sw_intended_resolution: The purpose of this element is to
        describe the requested quantization of data objects early on in
        the design process. The resolution ultimately occurs via the
        conversion formula present (compuMethod), which specifies the
        transition from the physical world to the standardized world
        (and vice-versa) (here, "the slope per bit" is present
        implicitly in the conversion formula). In the case of a
        development phase without a fixed conversion formula, a pre-
        specification can occur through swIntendedResolution. The
        resolution is specified in the physical domain according to the
        property "unit".
    :ivar sw_interpolation_method: This is a keyword identifying the
        mathematical method to be applied for interpolation. The keyword
        needs to be related to the interpolation routine which needs to
        be invoked.
    :ivar invalid_value: Optional value to express invalidity of the
        actual data element. This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar mc_function: Specifies the name of a "Function" (in the sense
        of the MC system) to which this data object belongs. This
        corresponds to the Function in ASAM MCD 2MC /ASAP2 which defines
        the characteristic resp. which provides the measurement as
        output. The function name is only used for support of MC
        systems. It can be predefined on the level of software component
        design. If it  is not  predefined, it could be filled out with a
        reasonable name, e.g. the component  prototype name, from the
        ECU extract. Note: This attribute is deprecated because an
        explicit model of MC functions can be set up by using the meta-
        class McFunction.
    :ivar sw_is_virtual: This element distinguishes virtual objects.
        Virtual objects do not appear in the memory, their derivation is
        much more dependent on other objects and hence they shall have a
        swDataDependency .
    :ivar sw_pointer_target_props: Specifies that the containing data
        object is a pointer to another data object.
    :ivar sw_record_layout_ref: Record layout for this data object.
    :ivar sw_refresh_timing: This element specifies the frequency in
        which the object involved shall be or is called or calculated.
        This timing can be collected from the task in which write access
        processes to the variable run. But this cannot be done by the
        MCD system. So this attribute can be used in an early phase to
        express the desired refresh timing and later on to specify the
        real refresh timing.
    :ivar unit_ref: Physical unit associated with the semantics of this
        data object. This attribute applies if no compuMethod is
        specified. If both units (this as well as via compuMethod) are
        specified the units shall be compatible.
    :ivar value_axis_data_type_ref: The referenced
        ApplicationPrimitiveDataType represents the primitive data type
        of the value axis within a compound primitive (e.g. curve, map).
        It supersedes CompuMethod, Unit, and BaseType.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-DATA-DEF-PROPS-CONDITIONAL"

    display_presentation: DisplayPresentationEnum | None = field(
        default=None,
        metadata={
            "name": "DISPLAY-PRESENTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    step_size: Float | None = field(
        default=None,
        metadata={
            "name": "STEP-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_value_block_size_mults: Optional["SwDataDefPropsConditional.SwValueBlockSizeMults"] = field(
        default=None,
        metadata={
            "name": "SW-VALUE-BLOCK-SIZE-MULTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwDataDefPropsConditional.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_addr_method_ref: Optional["SwDataDefPropsConditional.SwAddrMethodRef"] = field(
        default=None,
        metadata={
            "name": "SW-ADDR-METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_alignment: AlignmentType | None = field(
        default=None,
        metadata={
            "name": "SW-ALIGNMENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    base_type_ref: Optional["SwDataDefPropsConditional.BaseTypeRef"] = field(
        default=None,
        metadata={
            "name": "BASE-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_bit_representation: SwBitRepresentation | None = field(
        default=None,
        metadata={
            "name": "SW-BIT-REPRESENTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_calibration_access: SwCalibrationAccessEnum | None = field(
        default=None,
        metadata={
            "name": "SW-CALIBRATION-ACCESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_value_block_size: NumericalValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "SW-VALUE-BLOCK-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_calprm_axis_set: SwCalprmAxisSet | None = field(
        default=None,
        metadata={
            "name": "SW-CALPRM-AXIS-SET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_text_props: SwTextProps | None = field(
        default=None,
        metadata={
            "name": "SW-TEXT-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_comparison_variables: Optional["SwDataDefPropsConditional.SwComparisonVariables"] = field(
        default=None,
        metadata={
            "name": "SW-COMPARISON-VARIABLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    compu_method_ref: Optional["SwDataDefPropsConditional.CompuMethodRef"] = field(
        default=None,
        metadata={
            "name": "COMPU-METHOD-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_constr_ref: Optional["SwDataDefPropsConditional.DataConstrRef"] = field(
        default=None,
        metadata={
            "name": "DATA-CONSTR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_dependency: SwDataDependency | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEPENDENCY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    display_format: DisplayFormatString | None = field(
        default=None,
        metadata={
            "name": "DISPLAY-FORMAT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implementation_data_type_ref: Optional[
        "SwDataDefPropsConditional.ImplementationDataTypeRef"
    ] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTATION-DATA-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_host_variable: SwVariableRefProxy | None = field(
        default=None,
        metadata={
            "name": "SW-HOST-VARIABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_impl_policy: SwImplPolicyEnum | None = field(
        default=None,
        metadata={
            "name": "SW-IMPL-POLICY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    additional_native_type_qualifier: NativeDeclarationString | None = field(
        default=None,
        metadata={
            "name": "ADDITIONAL-NATIVE-TYPE-QUALIFIER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_intended_resolution: NumericalValue | None = field(
        default=None,
        metadata={
            "name": "SW-INTENDED-RESOLUTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_interpolation_method: Identifier | None = field(
        default=None,
        metadata={
            "name": "SW-INTERPOLATION-METHOD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    invalid_value: Optional["SwDataDefPropsConditional.InvalidValue"] = field(
        default=None,
        metadata={
            "name": "INVALID-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mc_function: Identifier | None = field(
        default=None,
        metadata={
            "name": "MC-FUNCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_is_virtual: Boolean | None = field(
        default=None,
        metadata={
            "name": "SW-IS-VIRTUAL",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_pointer_target_props: SwPointerTargetProps | None = field(
        default=None,
        metadata={
            "name": "SW-POINTER-TARGET-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_record_layout_ref: Optional["SwDataDefPropsConditional.SwRecordLayoutRef"] = field(
        default=None,
        metadata={
            "name": "SW-RECORD-LAYOUT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_refresh_timing: MultidimensionalTime | None = field(
        default=None,
        metadata={
            "name": "SW-REFRESH-TIMING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_ref: Optional["SwDataDefPropsConditional.UnitRef"] = field(
        default=None,
        metadata={
            "name": "UNIT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    value_axis_data_type_ref: Optional["SwDataDefPropsConditional.ValueAxisDataTypeRef"] = field(
        default=None,
        metadata={
            "name": "VALUE-AXIS-DATA-TYPE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class SwValueBlockSizeMults:
        numerical_value_variation_point: list[NumericalValueVariationPoint] = field(
            default_factory=list,
            metadata={
                "name": "NUMERICAL-VALUE-VARIATION-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwAddrMethodRef(Ref):
        dest: SwAddrMethodSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class BaseTypeRef(Ref):
        dest: SwBaseTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SwComparisonVariables:
        """
        :ivar autosar_variable: This represents the reference to a
            Variable in an Autosar system. Note that the target of the
            reference within AutosarVariableRef shall be typed by a
            primitive data type
        :ivar mc_data_instance_var_ref: This reference is used in the
            McSupport file to express the final instance of input values
            etc. It is not allowed to use this outside of an
            McDataInstance. The referenced mcDataInstance shall be
            originated from a VariableDataPrototype.
        """

        autosar_variable: list[AutosarVariableRef] = field(
            default_factory=list,
            metadata={
                "name": "AUTOSAR-VARIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "sequence": 1,
            },
        )
        mc_data_instance_var_ref: list[
            "SwDataDefPropsConditional.SwComparisonVariables.McDataInstanceVarRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "MC-DATA-INSTANCE-VAR-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
                "sequence": 1,
            },
        )

        @dataclass(slots=True, kw_only=True)
        class McDataInstanceVarRef(Ref):
            dest: McDataInstanceSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class CompuMethodRef(Ref):
        dest: CompuMethodSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class DataConstrRef(Ref):
        dest: DataConstrSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementationDataTypeRef(Ref):
        dest: AbstractImplementationDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class InvalidValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwRecordLayoutRef(Ref):
        dest: SwRecordLayoutSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class UnitRef(Ref):
        dest: UnitSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ValueAxisDataTypeRef(Ref):
        dest: ApplicationPrimitiveDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class Tbody:
    """This meta-class represents a part within a table group.

    Such a part can be the table head, the table body or the table foot.

    :ivar row: This is a particular row in a table.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar valign: Indicates how the cells in the rows shall be aligned.
        Default is inherited from tbody, otherwise it is "TOP"
    """

    class Meta:
        name = "TBODY"

    row: list[Row] = field(
        default_factory=list,
        metadata={
            "name": "ROW",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    valign: ValignEnumSimple | None = field(
        default=None,
        metadata={
            "name": "VALIGN",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class VariableDataPrototype:
    """A VariableDataPrototype represents a formalized generic piece of information
    that is typically mutable by the application software layer.

    VariableDataPrototype is used in various contexts and the specific
    context gives the otherwise generic VariableDataPrototype a
    dedicated semantics.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar sw_data_def_props: This property allows to specify data
        definition properties which apply on data prototype level.
    :ivar type_tref: This represents the corresponding data type.
    :ivar init_value: Specifies initial value(s) of the
        VariableDataPrototype This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        InternalBehavior.staticMemory Applicable for:
        SwcInternalBehavior.implicitInterRunnableVariable Applicable
        for: SwcInternalBehavior.explicitInterRunnableVariable
        Applicable for: SwcInternalBehavior.arTypedPerInstanceMemory
        Applicable for: BswInternalBehavior.arTypedPerInstanceMemory
        Applicable for: BswModuleDescription.providedData Applicable
        for: BswModuleDescription.requiredData Applicable for:
        ServiceInterface.event Applicable for:
        ApplicationInterface.indication Not Applicable for:
        NvDataInterface.nvData Not Applicable for:
        SenderReceiverInterface.dataElement Not Applicable for:
        BulkNvDataDescriptor.bulkNvBlock Not Applicable for:
        NvBlockDescriptor.ramBlock
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "VARIABLE-DATA-PROTOTYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["VariableDataPrototype.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["VariableDataPrototype.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_data_def_props: SwDataDefProps | None = field(
        default=None,
        metadata={
            "name": "SW-DATA-DEF-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    type_tref: Optional["VariableDataPrototype.TypeTref"] = field(
        default=None,
        metadata={
            "name": "TYPE-TREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    init_value: Optional["VariableDataPrototype.InitValue"] = field(
        default=None,
        metadata={
            "name": "INIT-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TypeTref(Ref):
        dest: AutosarDataTypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class InitValue:
        application_assoc_map_value_specification: ApplicationAssocMapValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "APPLICATION-ASSOC-MAP-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        application_rule_based_value_specification: (
            ApplicationRuleBasedValueSpecification | None
        ) = field(
            default=None,
            metadata={
                "name": "APPLICATION-RULE-BASED-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_value_specification: ApplicationValueSpecification | None = field(
            default=None,
            metadata={
                "name": "APPLICATION-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        array_value_specification: ArrayValueSpecification | None = field(
            default=None,
            metadata={
                "name": "ARRAY-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composite_rule_based_value_specification: CompositeRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "COMPOSITE-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        constant_reference: ConstantReference | None = field(
            default=None,
            metadata={
                "name": "CONSTANT-REFERENCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        not_available_value_specification: NotAvailableValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NOT-AVAILABLE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        numerical_rule_based_value_specification: NumericalRuleBasedValueSpecification | None = (
            field(
                default=None,
                metadata={
                    "name": "NUMERICAL-RULE-BASED-VALUE-SPECIFICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        numerical_value_specification: NumericalValueSpecification | None = field(
            default=None,
            metadata={
                "name": "NUMERICAL-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        record_value_specification: RecordValueSpecification | None = field(
            default=None,
            metadata={
                "name": "RECORD-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        reference_value_specification: ReferenceValueSpecification | None = field(
            default=None,
            metadata={
                "name": "REFERENCE-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        text_value_specification: TextValueSpecification | None = field(
            default=None,
            metadata={
                "name": "TEXT-VALUE-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApplicationInterface:
    """
    This represents the ability to define a PortInterface that consists of a
    composition of commands (method calls), indications (events) and attributes
    (fields)

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar attributes: This represents the set of attributes defined in
        the context of an Abstract Platform ApplicationInterface.
    :ivar commands: This represents the collection of commands or
        function calls (with optional data arguments) defined in the
        context of an ApplicationInterface.
    :ivar indications: This represents the collection of indication or
        events (with optional data argument) defined in the context of
        an ApplicationInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApplicationInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApplicationInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ApplicationInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["ApplicationInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    attributes: Optional["ApplicationInterface.Attributes"] = field(
        default=None,
        metadata={
            "name": "ATTRIBUTES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    commands: Optional["ApplicationInterface.Commands"] = field(
        default=None,
        metadata={
            "name": "COMMANDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    indications: Optional["ApplicationInterface.Indications"] = field(
        default=None,
        metadata={
            "name": "INDICATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Attributes:
        field_value: list[FieldType] = field(
            default_factory=list,
            metadata={
                "name": "FIELD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Commands:
        client_server_operation: list[ClientServerOperation] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-OPERATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Indications:
        variable_data_prototype: list[VariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BswInternalBehavior:
    """Specifies the behavior of a BSW module or a BSW cluster w.r.t.

    the code entities visible by the BSW Scheduler. It is possible to
    have several different BswInternalBehaviors referring to the same
    BswModuleDescription.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar constant_memorys: Describes a read only memory object
        containing characteristic value(s)  implemented by this
        InternalBehavior. The shortName of ParameterDataPrototype has to
        be equal to the ''C' identifier of the described constant. The
        characteristic value(s) might be shared between
        SwComponentPrototypes of the same SwComponentType. The
        aggregation of constantMemory is subject to variability with the
        purpose to support variability in the software component or
        module implementations. Typically different algorithms in the
        implementation are requiring different number of memory objects.
    :ivar constant_value_mapping_refs: Reference to the
        ConstantSpecificationMapping to be applied for the particular
        InternalBehavior
    :ivar data_type_mapping_refs: Reference to the DataTypeMapping to be
        applied for the particular InternalBehavior
    :ivar exclusive_areas: This specifies an ExclusiveArea for this
        InternalBehavior. The exclusiveArea is local to the component
        resp. module. The aggregation of ExclusiveAreas is subject to
        variability. Note: the number of ExclusiveAreas might vary due
        to the conditional existence of RunnableEntities or
        BswModuleEntities.
    :ivar exclusive_area_nesting_orders: This represents the set of
        ExclusiveAreaNestingOrder owned by the InternalBehavior.
    :ivar static_memorys: Describes a read and writeable static memory
        object representing measurerment variables implemented by this
        software component. The term "static" is used in the meaning of
        "non-temporary" and does not necessarily specify a linker
        encapsulation. This kind of memory is only supported if
        supportsMultipleInstantiation is FALSE. The shortName of the
        VariableDataPrototype has to be equal with the ''C' identifier
        of the described variable. The aggregation of staticMemory is
        subject to variability with the purpose to support variability
        in the software component's implementations. Typically different
        algorithms in the implementation are requiring different number
        of memory objects.
    :ivar ar_typed_per_instance_memorys: Defines an AUTOSAR typed
        memory-block that needs to be available for each instance of the
        Basic Software Module. The aggregation of
        arTypedPerInstanceMemory is subject to variability with the
        purpose to support variability in the Basic Software Module's
        implementations. Typically different algorithms in the
        implementation are requiring different number of memory objects.
    :ivar bsw_per_instance_memory_policys: Policy for a
        arTypedPerInstanceMemory The policy selects the options of the
        Schedule Manager API generation.
    :ivar client_policys: Policy for a requiredClientServerEntry. The
        policy selects the options of the Schedule Manager API
        generation.
    :ivar exclusive_area_policys: Policy for an  ExclusiveArea in this
        BswInternalBehavior. The policy selects the options of the
        Schedule Manager API generation.
    :ivar included_data_type_sets: The includedDataTypeSet is used by a
        basic software module for its implementation.
    :ivar included_mode_declaration_group_sets: This aggregation
        represents the included ModeDeclarationGroups
    :ivar internal_triggering_point_policys: Policy for an
        internalTriggeringPoint in this BswInternalBehavior.. The policy
        selects the options of the Schedule Manager API generation.
    :ivar parameter_policys: Policy for a  perInstanceParameter in this
        BswInternalBehavior. The policy selects the options of the
        Schedule Manager API generation.
    :ivar released_trigger_policys: Policy for a  releasedTrigger. The
        policy selects the options of the Schedule Manager API
        generation.
    :ivar send_policys: Policy for a providedData. The policy selects
        the options of the Schedule Manager API generation.
    :ivar variation_point_proxys: Proxy of a variation points in the
        C/C++ implementation.
    :ivar internal_triggering_points: An internal triggering point.
    :ivar entitys: A code entity for which the behavior is described
    :ivar events: An event required by this module behavior.
    :ivar trigger_direct_implementations: Specifies a trigger to be
        directly implemented via OS calls.
    :ivar mode_sender_policys: Implementation policy for providing a
        mode group.
    :ivar mode_receiver_policys: Implementation policy for the reception
        of mode switches.
    :ivar service_dependencys: Defines the requirements on AUTOSAR
        Services for a particular item. The aggregation is subject to
        variability with the purpose to support the conditional
        existence of ServiceNeeds. The aggregation is splitable in order
        to support that ServiceNeeds might be provided in later
        development steps.
    :ivar per_instance_parameters: Describes a read only memory object
        containing characteristic value(s)  needed by this
        BswInternalBehavior. The role name perInstanceParameter is
        chosen in analogy to the similar role in the context of
        SwcInternalBehavior. In contrast to constantMemory, this object
        is not allocated locally by the module's code, but by the BSW
        Scheduler and it is accessed from the BSW module via the BSW
        Scheduler API. The main use case is the support of software
        emulation of calibration data. The aggregation is subject to
        variability with the purpose to support implementation variants.
    :ivar scheduler_name_prefixs: Optional definition of one or more
        prefixes to be used for the BswScheduler.
    :ivar reception_policys: Data reception policy for inter-partition
        and/or inter-core communication.
    :ivar distinguished_partitions: Indicates an abstract partition
        context in which the enclosing BswModuleEntity can be executed.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-INTERNAL-BEHAVIOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswInternalBehavior.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswInternalBehavior.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    constant_memorys: Optional["BswInternalBehavior.ConstantMemorys"] = field(
        default=None,
        metadata={
            "name": "CONSTANT-MEMORYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    constant_value_mapping_refs: Optional["BswInternalBehavior.ConstantValueMappingRefs"] = field(
        default=None,
        metadata={
            "name": "CONSTANT-VALUE-MAPPING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_type_mapping_refs: Optional["BswInternalBehavior.DataTypeMappingRefs"] = field(
        default=None,
        metadata={
            "name": "DATA-TYPE-MAPPING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_areas: Optional["BswInternalBehavior.ExclusiveAreas"] = field(
        default=None,
        metadata={
            "name": "EXCLUSIVE-AREAS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_area_nesting_orders: Optional["BswInternalBehavior.ExclusiveAreaNestingOrders"] = (
        field(
            default=None,
            metadata={
                "name": "EXCLUSIVE-AREA-NESTING-ORDERS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    static_memorys: Optional["BswInternalBehavior.StaticMemorys"] = field(
        default=None,
        metadata={
            "name": "STATIC-MEMORYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ar_typed_per_instance_memorys: Optional["BswInternalBehavior.ArTypedPerInstanceMemorys"] = (
        field(
            default=None,
            metadata={
                "name": "AR-TYPED-PER-INSTANCE-MEMORYS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    bsw_per_instance_memory_policys: Optional["BswInternalBehavior.BswPerInstanceMemoryPolicys"] = (
        field(
            default=None,
            metadata={
                "name": "BSW-PER-INSTANCE-MEMORY-POLICYS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    client_policys: Optional["BswInternalBehavior.ClientPolicys"] = field(
        default=None,
        metadata={
            "name": "CLIENT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_area_policys: Optional["BswInternalBehavior.ExclusiveAreaPolicys"] = field(
        default=None,
        metadata={
            "name": "EXCLUSIVE-AREA-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    included_data_type_sets: Optional["BswInternalBehavior.IncludedDataTypeSets"] = field(
        default=None,
        metadata={
            "name": "INCLUDED-DATA-TYPE-SETS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    included_mode_declaration_group_sets: Optional[
        "BswInternalBehavior.IncludedModeDeclarationGroupSets"
    ] = field(
        default=None,
        metadata={
            "name": "INCLUDED-MODE-DECLARATION-GROUP-SETS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    internal_triggering_point_policys: Optional[
        "BswInternalBehavior.InternalTriggeringPointPolicys"
    ] = field(
        default=None,
        metadata={
            "name": "INTERNAL-TRIGGERING-POINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_policys: Optional["BswInternalBehavior.ParameterPolicys"] = field(
        default=None,
        metadata={
            "name": "PARAMETER-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    released_trigger_policys: Optional["BswInternalBehavior.ReleasedTriggerPolicys"] = field(
        default=None,
        metadata={
            "name": "RELEASED-TRIGGER-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    send_policys: Optional["BswInternalBehavior.SendPolicys"] = field(
        default=None,
        metadata={
            "name": "SEND-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point_proxys: Optional["BswInternalBehavior.VariationPointProxys"] = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT-PROXYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    internal_triggering_points: Optional["BswInternalBehavior.InternalTriggeringPoints"] = field(
        default=None,
        metadata={
            "name": "INTERNAL-TRIGGERING-POINTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    entitys: Optional["BswInternalBehavior.Entitys"] = field(
        default=None,
        metadata={
            "name": "ENTITYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    events: Optional["BswInternalBehavior.Events"] = field(
        default=None,
        metadata={
            "name": "EVENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_direct_implementations: Optional["BswInternalBehavior.TriggerDirectImplementations"] = (
        field(
            default=None,
            metadata={
                "name": "TRIGGER-DIRECT-IMPLEMENTATIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    mode_sender_policys: Optional["BswInternalBehavior.ModeSenderPolicys"] = field(
        default=None,
        metadata={
            "name": "MODE-SENDER-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_receiver_policys: Optional["BswInternalBehavior.ModeReceiverPolicys"] = field(
        default=None,
        metadata={
            "name": "MODE-RECEIVER-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_dependencys: Optional["BswInternalBehavior.ServiceDependencys"] = field(
        default=None,
        metadata={
            "name": "SERVICE-DEPENDENCYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    per_instance_parameters: Optional["BswInternalBehavior.PerInstanceParameters"] = field(
        default=None,
        metadata={
            "name": "PER-INSTANCE-PARAMETERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    scheduler_name_prefixs: Optional["BswInternalBehavior.SchedulerNamePrefixs"] = field(
        default=None,
        metadata={
            "name": "SCHEDULER-NAME-PREFIXS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reception_policys: Optional["BswInternalBehavior.ReceptionPolicys"] = field(
        default=None,
        metadata={
            "name": "RECEPTION-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    distinguished_partitions: Optional["BswInternalBehavior.DistinguishedPartitions"] = field(
        default=None,
        metadata={
            "name": "DISTINGUISHED-PARTITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConstantMemorys:
        parameter_data_prototype: list[ParameterDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConstantValueMappingRefs:
        constant_value_mapping_ref: list[
            "BswInternalBehavior.ConstantValueMappingRefs.ConstantValueMappingRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONSTANT-VALUE-MAPPING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ConstantValueMappingRef(Ref):
            dest: ConstantSpecificationMappingSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DataTypeMappingRefs:
        data_type_mapping_ref: list[
            "BswInternalBehavior.DataTypeMappingRefs.DataTypeMappingRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DATA-TYPE-MAPPING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DataTypeMappingRef(Ref):
            dest: DataTypeMappingSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreas:
        exclusive_area: list[ExclusiveArea] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaNestingOrders:
        exclusive_area_nesting_order: list[ExclusiveAreaNestingOrder] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA-NESTING-ORDER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StaticMemorys:
        variable_data_prototype: list[VariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ArTypedPerInstanceMemorys:
        variable_data_prototype: list[VariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BswPerInstanceMemoryPolicys:
        bsw_per_instance_memory_policy: list[BswPerInstanceMemoryPolicy] = field(
            default_factory=list,
            metadata={
                "name": "BSW-PER-INSTANCE-MEMORY-POLICY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClientPolicys:
        bsw_client_policy: list[BswClientPolicy] = field(
            default_factory=list,
            metadata={
                "name": "BSW-CLIENT-POLICY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaPolicys:
        bsw_exclusive_area_policy: list[BswExclusiveAreaPolicy] = field(
            default_factory=list,
            metadata={
                "name": "BSW-EXCLUSIVE-AREA-POLICY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IncludedDataTypeSets:
        included_data_type_set: list[IncludedDataTypeSet] = field(
            default_factory=list,
            metadata={
                "name": "INCLUDED-DATA-TYPE-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IncludedModeDeclarationGroupSets:
        included_mode_declaration_group_set: list[IncludedModeDeclarationGroupSet] = field(
            default_factory=list,
            metadata={
                "name": "INCLUDED-MODE-DECLARATION-GROUP-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InternalTriggeringPointPolicys:
        bsw_internal_triggering_point_policy: list[BswInternalTriggeringPointPolicy] = field(
            default_factory=list,
            metadata={
                "name": "BSW-INTERNAL-TRIGGERING-POINT-POLICY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ParameterPolicys:
        bsw_parameter_policy: list[BswParameterPolicy] = field(
            default_factory=list,
            metadata={
                "name": "BSW-PARAMETER-POLICY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ReleasedTriggerPolicys:
        bsw_released_trigger_policy: list[BswReleasedTriggerPolicy] = field(
            default_factory=list,
            metadata={
                "name": "BSW-RELEASED-TRIGGER-POLICY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SendPolicys:
        bsw_data_send_policy: list[BswDataSendPolicy] = field(
            default_factory=list,
            metadata={
                "name": "BSW-DATA-SEND-POLICY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class VariationPointProxys:
        variation_point_proxy: list[VariationPointProxy] = field(
            default_factory=list,
            metadata={
                "name": "VARIATION-POINT-PROXY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InternalTriggeringPoints:
        bsw_internal_triggering_point: list[BswInternalTriggeringPoint] = field(
            default_factory=list,
            metadata={
                "name": "BSW-INTERNAL-TRIGGERING-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Entitys:
        bsw_called_entity: list[BswCalledEntity] = field(
            default_factory=list,
            metadata={
                "name": "BSW-CALLED-ENTITY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_interrupt_entity: list[BswInterruptEntity] = field(
            default_factory=list,
            metadata={
                "name": "BSW-INTERRUPT-ENTITY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_schedulable_entity: list[BswSchedulableEntity] = field(
            default_factory=list,
            metadata={
                "name": "BSW-SCHEDULABLE-ENTITY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Events:
        bsw_asynchronous_server_call_returns_event: list[BswAsynchronousServerCallReturnsEvent] = (
            field(
                default_factory=list,
                metadata={
                    "name": "BSW-ASYNCHRONOUS-SERVER-CALL-RETURNS-EVENT",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        bsw_background_event: list[BswBackgroundEvent] = field(
            default_factory=list,
            metadata={
                "name": "BSW-BACKGROUND-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_data_received_event: list[BswDataReceivedEvent] = field(
            default_factory=list,
            metadata={
                "name": "BSW-DATA-RECEIVED-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_external_trigger_occurred_event: list[BswExternalTriggerOccurredEvent] = field(
            default_factory=list,
            metadata={
                "name": "BSW-EXTERNAL-TRIGGER-OCCURRED-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_internal_trigger_occurred_event: list[BswInternalTriggerOccurredEvent] = field(
            default_factory=list,
            metadata={
                "name": "BSW-INTERNAL-TRIGGER-OCCURRED-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_mode_manager_error_event: list[BswModeManagerErrorEvent] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODE-MANAGER-ERROR-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_mode_switch_event: list[BswModeSwitchEvent] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODE-SWITCH-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_mode_switched_ack_event: list[BswModeSwitchedAckEvent] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODE-SWITCHED-ACK-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_operation_invoked_event: list[BswOperationInvokedEvent] = field(
            default_factory=list,
            metadata={
                "name": "BSW-OPERATION-INVOKED-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_os_task_execution_event: list[BswOsTaskExecutionEvent] = field(
            default_factory=list,
            metadata={
                "name": "BSW-OS-TASK-EXECUTION-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_timing_event: list[BswTimingEvent] = field(
            default_factory=list,
            metadata={
                "name": "BSW-TIMING-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerDirectImplementations:
        bsw_trigger_direct_implementation: list[BswTriggerDirectImplementation] = field(
            default_factory=list,
            metadata={
                "name": "BSW-TRIGGER-DIRECT-IMPLEMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModeSenderPolicys:
        bsw_mode_sender_policy: list[BswModeSenderPolicy] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODE-SENDER-POLICY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModeReceiverPolicys:
        bsw_mode_receiver_policy: list[BswModeReceiverPolicy] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODE-RECEIVER-POLICY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceDependencys:
        bsw_service_dependency: list[BswServiceDependency] = field(
            default_factory=list,
            metadata={
                "name": "BSW-SERVICE-DEPENDENCY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PerInstanceParameters:
        parameter_data_prototype: list[ParameterDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SchedulerNamePrefixs:
        bsw_scheduler_name_prefix: list[BswSchedulerNamePrefix] = field(
            default_factory=list,
            metadata={
                "name": "BSW-SCHEDULER-NAME-PREFIX",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ReceptionPolicys:
        bsw_queued_data_reception_policy: list[BswQueuedDataReceptionPolicy] = field(
            default_factory=list,
            metadata={
                "name": "BSW-QUEUED-DATA-RECEPTION-POLICY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DistinguishedPartitions:
        bsw_distinguished_partition: list[BswDistinguishedPartition] = field(
            default_factory=list,
            metadata={
                "name": "BSW-DISTINGUISHED-PARTITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BulkNvDataDescriptor:
    """This meta-class represents one bulk NV Data Block that is read-only for the
    application software.

    The purpose of a bulk NV Data Block is to provide access to
    information uploaded to the vehicle at e.g. the end of the
    production line.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar bulk_nv_block: This aggregation represents the actual bulk
        NVBlock. This aggregation contains a variation point although it
        is not variant. Therefore, this variation point shall not exist
        in models. See constr_2638.
    :ivar nv_block_data_mappings: Defines the mapping between the
        VariableDataPrototypes in the NvBlockComponents ports and the
        VariableDataPrototypes of the non-volatile memory. The
        aggregation of NvBlockDataMapping is subject to variability with
        the purpose to support the conditional existence of nv data
        ports.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        NvBlockSwComponentType.bulkNvDataDescriptor
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BULK-NV-DATA-DESCRIPTOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BulkNvDataDescriptor.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BulkNvDataDescriptor.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bulk_nv_block: VariableDataPrototype | None = field(
        default=None,
        metadata={
            "name": "BULK-NV-BLOCK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nv_block_data_mappings: Optional["BulkNvDataDescriptor.NvBlockDataMappings"] = field(
        default=None,
        metadata={
            "name": "NV-BLOCK-DATA-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NvBlockDataMappings:
        nv_block_data_mapping: list[NvBlockDataMapping] = field(
            default_factory=list,
            metadata={
                "name": "NV-BLOCK-DATA-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class CalibrationParameterValueSet:
    """
    Specification of a constant that can be part of a package, i.e. it can be
    defined stand-alone.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar calibration_parameter_values: This represents single
        CalibrationParameterValues in the CalibrationParameterValueSet.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CALIBRATION-PARAMETER-VALUE-SET"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CalibrationParameterValueSet.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CalibrationParameterValueSet.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    calibration_parameter_values: Optional[
        "CalibrationParameterValueSet.CalibrationParameterValues"
    ] = field(
        default=None,
        metadata={
            "name": "CALIBRATION-PARAMETER-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class CalibrationParameterValues:
        calibration_parameter_value: list[CalibrationParameterValue] = field(
            default_factory=list,
            metadata={
                "name": "CALIBRATION-PARAMETER-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class DiagnosticEnvConditionFormula:
    """A DiagnosticEnvConditionFormula embodies the computation instruction that is
    to be evaluated at runtime to determine if the DiagnosticEnvironmentalCondition
    is currently present (i.e. the formula is evaluated to true) or not
    (otherwise).

    The formula itself consists of parts which are combined by the
    logical operations specified by DiagnosticEnvConditionFormula.op. If
    a diagnostic functionality cannot be executed because an
    environmental condition fails then the diagnostic stack shall send a
    negative response code (NRC) back to the client. The value of the
    NRC is directly related to the specific formula and is therefore
    formalized in the attribute DiagnosticEnvConditionFormula.nrcValue.

    :ivar nrc_value: This attribute represents the concrete NRC value
        that shall be returned if the condition fails.
    :ivar op: This attribute represents the concrete operator (supported
        operators: and, or) of the condition formula.
    :ivar parts: This aggregation represents the collection of formula
        parts that can be combined by logical operators.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ENV-CONDITION-FORMULA"

    nrc_value: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "NRC-VALUE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    op: DiagnosticLogicalOperatorEnum | None = field(
        default=None,
        metadata={
            "name": "OP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parts: Optional["DiagnosticEnvConditionFormula.Parts"] = field(
        default=None,
        metadata={
            "name": "PARTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Parts:
        diagnostic_env_condition_formula: list["DiagnosticEnvConditionFormula"] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ENV-CONDITION-FORMULA",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_env_data_condition: list[DiagnosticEnvDataCondition] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ENV-DATA-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_env_data_element_condition: list[DiagnosticEnvDataElementCondition] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ENV-DATA-ELEMENT-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_env_mode_condition: list[DiagnosticEnvModeCondition] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ENV-MODE-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class NvBlockDescriptor:
    """
    Specifies the properties of exactly on NVRAM Block.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar client_server_ports: The RoleBasedPortAssignement defines
        which client server port of the NvBlockSwComponentType serves
        for which kind of service or notification. In case of
        notifications one common callback function is provided by the
        RTE for each individual kind of notification defined by the
        "role". The aggregation of RoleBasedPortAssignment is subject to
        variability with the purpose to support the conditional
        existence of ports.
    :ivar constant_value_mapping_refs: Reference to the
        ConstantSpecificationMapping to be applied for the particular
        NVRAM Block
    :ivar data_type_mapping_refs: Reference to the DataTypeMapping to be
        applied for the particular NVRAM Block.
    :ivar instantiation_data_def_propss: The purpose of
        InstantiationDataDefProps are the refinement of some data def
        properties of individual instantiations within the context of a
        NvBlockSwComponentType. The aggregation of
        InstantiationDataDefProps is subject to variability with the
        purpose to support the conditional existence of ports, component
        internal memory objects and those attributes.
    :ivar mode_switch_event_triggered_activitys: This represents the
        collection of ModeSwitchEventTriggeredActivities related to the
        enclosing NvBlockDescriptor.
    :ivar nv_block_data_mappings: Defines the mapping between the
        VariableDataPrototypes in the NvBlockComponents ports and the
        VariableDataPrototypes of the RAM Block. The aggregation of
        NvBlockDataMapping is subject to variability with the purpose to
        support the conditional existence of nv data ports.
    :ivar nv_block_needs: Specifies the abstract needs on the
        configuration of the NVRAM Manager for the single NVRAM Block
        described by this NvBlockDescriptor. In addition, it may define
        requirements for writing strategies in an implementation of an
        NvBlockSwComponentType by the RTE. Please note that the
        attributes nDataSets and nRomBlocks are not relevant for this
        aggregation because the RTE will allocate just one block anyway.
        In a different context, however, they do make sense.
    :ivar ram_block: Defines the RAM Block of the NVRAM Block provided
        by NvBlockSwComponentType. This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar rom_block: Defines the ROM Block of the NVRAM Block provided
        by NvBlockSwComponentType. This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar support_dirty_flag: Specifies whether calling of NvM functions
        for writing and/or status control of potentially modified RAM
        Blocks to NV memory shall be controlled by the RTE.
    :ivar timing_event_ref: this reference can be taken to identify the
        TimingEvent to be used by the RTE for implementing a cyclic
        writing strategy for this block
    :ivar writing_strategys: This attribute allows for assigning a
        specific writing strategy for an incoming AutosarDataPrototype.
        This aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar writing_strategy_role: This attribute allows for assigning a
        specific writing strategy for an incoming AutosarDataPrototype.
        This aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        NvBlockSwComponentType.nvBlockDescriptor
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NV-BLOCK-DESCRIPTOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["NvBlockDescriptor.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["NvBlockDescriptor.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_server_ports: Optional["NvBlockDescriptor.ClientServerPorts"] = field(
        default=None,
        metadata={
            "name": "CLIENT-SERVER-PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    constant_value_mapping_refs: Optional["NvBlockDescriptor.ConstantValueMappingRefs"] = field(
        default=None,
        metadata={
            "name": "CONSTANT-VALUE-MAPPING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_type_mapping_refs: Optional["NvBlockDescriptor.DataTypeMappingRefs"] = field(
        default=None,
        metadata={
            "name": "DATA-TYPE-MAPPING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    instantiation_data_def_propss: Optional["NvBlockDescriptor.InstantiationDataDefPropss"] = field(
        default=None,
        metadata={
            "name": "INSTANTIATION-DATA-DEF-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_switch_event_triggered_activitys: Optional[
        "NvBlockDescriptor.ModeSwitchEventTriggeredActivitys"
    ] = field(
        default=None,
        metadata={
            "name": "MODE-SWITCH-EVENT-TRIGGERED-ACTIVITYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nv_block_data_mappings: Optional["NvBlockDescriptor.NvBlockDataMappings"] = field(
        default=None,
        metadata={
            "name": "NV-BLOCK-DATA-MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nv_block_needs: NvBlockNeeds | None = field(
        default=None,
        metadata={
            "name": "NV-BLOCK-NEEDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ram_block: VariableDataPrototype | None = field(
        default=None,
        metadata={
            "name": "RAM-BLOCK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rom_block: ParameterDataPrototype | None = field(
        default=None,
        metadata={
            "name": "ROM-BLOCK",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    support_dirty_flag: Boolean | None = field(
        default=None,
        metadata={
            "name": "SUPPORT-DIRTY-FLAG",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    timing_event_ref: Optional["NvBlockDescriptor.TimingEventRef"] = field(
        default=None,
        metadata={
            "name": "TIMING-EVENT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    writing_strategys: Optional["NvBlockDescriptor.WritingStrategys"] = field(
        default=None,
        metadata={
            "name": "WRITING-STRATEGYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    writing_strategy_role: RoleBasedDataAssignment | None = field(
        default=None,
        metadata={
            "name": "WRITING-STRATEGY-ROLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClientServerPorts:
        role_based_port_assignment: list[RoleBasedPortAssignment] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-PORT-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConstantValueMappingRefs:
        constant_value_mapping_ref: list[
            "NvBlockDescriptor.ConstantValueMappingRefs.ConstantValueMappingRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONSTANT-VALUE-MAPPING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ConstantValueMappingRef(Ref):
            dest: ConstantSpecificationMappingSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DataTypeMappingRefs:
        data_type_mapping_ref: list["NvBlockDescriptor.DataTypeMappingRefs.DataTypeMappingRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DATA-TYPE-MAPPING-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class DataTypeMappingRef(Ref):
            dest: DataTypeMappingSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class InstantiationDataDefPropss:
        instantiation_data_def_props: list[InstantiationDataDefProps] = field(
            default_factory=list,
            metadata={
                "name": "INSTANTIATION-DATA-DEF-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModeSwitchEventTriggeredActivitys:
        mode_switch_event_triggered_activity: list[ModeSwitchEventTriggeredActivity] = field(
            default_factory=list,
            metadata={
                "name": "MODE-SWITCH-EVENT-TRIGGERED-ACTIVITY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NvBlockDataMappings:
        nv_block_data_mapping: list[NvBlockDataMapping] = field(
            default_factory=list,
            metadata={
                "name": "NV-BLOCK-DATA-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TimingEventRef(Ref):
        dest: TimingEventSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class WritingStrategys:
        role_based_data_assignment: list[RoleBasedDataAssignment] = field(
            default_factory=list,
            metadata={
                "name": "ROLE-BASED-DATA-ASSIGNMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class NvDataInterface:
    """
    A non volatile data interface declares a number of VariableDataPrototypes to be
    exchanged between non volatile block components and atomic software components.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar nv_datas: The VariableDataPrototype of this nv data interface.
        This aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NV-DATA-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["NvDataInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["NvDataInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["NvDataInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["NvDataInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nv_datas: Optional["NvDataInterface.NvDatas"] = field(
        default=None,
        metadata={
            "name": "NV-DATAS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NvDatas:
        variable_data_prototype: list[VariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PPortPrototype:
    """
    Component port providing a certain port interface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar client_server_annotations: Annotation of this PortPrototype
        with respect to client/server communication.
    :ivar delegated_port_annotation: Annotations on this delegated port.
    :ivar io_hw_abstraction_server_annotations: Annotations on this IO
        Hardware Abstraction port.
    :ivar mode_port_annotations: Annotations on this mode port.
    :ivar nv_data_port_annotations: Annotations on this non voilatile
        data port.
    :ivar parameter_port_annotations: Annotations on this parameter
        port.
    :ivar port_prototype_props: This attribute allows for the definition
        of further qualification of the semantics of a PortPrototype.
    :ivar sender_receiver_annotations: Collection of annotations of this
        ports sender/receiver communication.
    :ivar trigger_port_annotations: Annotations on this trigger port.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: SwComponentType.port
    :ivar provided_com_specs: Provided communication attributes per
        interface element (data element or operation).
    :ivar provided_interface_tref: The interface that this port
        provides.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "P-PORT-PROTOTYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PPortPrototype.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PPortPrototype.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_server_annotations: Optional["PPortPrototype.ClientServerAnnotations"] = field(
        default=None,
        metadata={
            "name": "CLIENT-SERVER-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delegated_port_annotation: DelegatedPortAnnotation | None = field(
        default=None,
        metadata={
            "name": "DELEGATED-PORT-ANNOTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    io_hw_abstraction_server_annotations: Optional[
        "PPortPrototype.IoHwAbstractionServerAnnotations"
    ] = field(
        default=None,
        metadata={
            "name": "IO-HW-ABSTRACTION-SERVER-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_port_annotations: Optional["PPortPrototype.ModePortAnnotations"] = field(
        default=None,
        metadata={
            "name": "MODE-PORT-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nv_data_port_annotations: Optional["PPortPrototype.NvDataPortAnnotations"] = field(
        default=None,
        metadata={
            "name": "NV-DATA-PORT-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_port_annotations: Optional["PPortPrototype.ParameterPortAnnotations"] = field(
        default=None,
        metadata={
            "name": "PARAMETER-PORT-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_props: Optional["PPortPrototype.PortPrototypeProps"] = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sender_receiver_annotations: Optional["PPortPrototype.SenderReceiverAnnotations"] = field(
        default=None,
        metadata={
            "name": "SENDER-RECEIVER-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_port_annotations: Optional["PPortPrototype.TriggerPortAnnotations"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-PORT-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_com_specs: Optional["PPortPrototype.ProvidedComSpecs"] = field(
        default=None,
        metadata={
            "name": "PROVIDED-COM-SPECS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_interface_tref: Optional["PPortPrototype.ProvidedInterfaceTref"] = field(
        default=None,
        metadata={
            "name": "PROVIDED-INTERFACE-TREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClientServerAnnotations:
        client_server_annotation: list[ClientServerAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IoHwAbstractionServerAnnotations:
        io_hw_abstraction_server_annotation: list[IoHwAbstractionServerAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "IO-HW-ABSTRACTION-SERVER-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModePortAnnotations:
        mode_port_annotation: list[ModePortAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "MODE-PORT-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NvDataPortAnnotations:
        nv_data_port_annotation: list[NvDataPortAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "NV-DATA-PORT-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ParameterPortAnnotations:
        parameter_port_annotation: list[ParameterPortAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-PORT-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortPrototypeProps:
        r_port_prototype_props: RPortPrototypeProps | None = field(
            default=None,
            metadata={
                "name": "R-PORT-PROTOTYPE-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SenderReceiverAnnotations:
        receiver_annotation: list[ReceiverAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "RECEIVER-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sender_annotation: list[SenderAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "SENDER-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerPortAnnotations:
        trigger_port_annotation: list[TriggerPortAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER-PORT-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedComSpecs:
        field_sender_com_spec: list[FieldSenderComSpec] = field(
            default_factory=list,
            metadata={
                "name": "FIELD-SENDER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mode_switch_sender_com_spec: list[ModeSwitchSenderComSpec] = field(
            default_factory=list,
            metadata={
                "name": "MODE-SWITCH-SENDER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nonqueued_sender_com_spec: list[NonqueuedSenderComSpec] = field(
            default_factory=list,
            metadata={
                "name": "NONQUEUED-SENDER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nv_provide_com_spec: list[NvProvideComSpec] = field(
            default_factory=list,
            metadata={
                "name": "NV-PROVIDE-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        parameter_provide_com_spec: list[ParameterProvideComSpec] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-PROVIDE-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        queued_sender_com_spec: list[QueuedSenderComSpec] = field(
            default_factory=list,
            metadata={
                "name": "QUEUED-SENDER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        server_com_spec: list[ServerComSpec] = field(
            default_factory=list,
            metadata={
                "name": "SERVER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedInterfaceTref(Ref):
        dest: PortInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ParameterInterface:
    """
    A parameter interface declares a number of parameter and characteristic values
    to be exchanged between parameter components and software components.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar parameters: The ParameterDataPrototype of this
        ParameterInterface. This aggregation contains a variation point
        although it is not variant. Therefore, this variation point
        shall not exist in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PARAMETER-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ParameterInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ParameterInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ParameterInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["ParameterInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameters: Optional["ParameterInterface.Parameters"] = field(
        default=None,
        metadata={
            "name": "PARAMETERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Parameters:
        parameter_data_prototype: list[ParameterDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PersistencyKeyValueStorage:
    """
    This meta-class represents the ability to model a key-value storage  on
    deployment level.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar deployment_uris: This aggregation represents the collection of
        URIs relevant for the enclosing PersistencyDeployment.
    :ivar maximum_allowed_size: The value of this attribute represents
        the maximum size (unit: bytes) allowed at deployment time for
        the enclosing PersistencyDeployment.
    :ivar minimum_sustained_size: The value of this attribute represents
        the minimum size (unit: bytes) guaranteed at deployment time for
        the enclosing PersistencyDeployment.
    :ivar redundancy_handlings: This aggregation represents the chosen
        approaches to handle redundancy.
    :ivar update_strategy: This attribute shall be used to specify the
        update strategy of the respective PersistencyDeployment as a
        whole.
    :ivar version: The attribute represents the version of the
        PersistencyFileStorage or PersistencyKeyValueStorage.
    :ivar key_value_pairs: This aggregation represents the key-value-
        pairs owned by the enclosing PersistencyKeyValueStorage.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PERSISTENCY-KEY-VALUE-STORAGE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PersistencyKeyValueStorage.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PersistencyKeyValueStorage.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    deployment_uris: Optional["PersistencyKeyValueStorage.DeploymentUris"] = field(
        default=None,
        metadata={
            "name": "DEPLOYMENT-URIS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    maximum_allowed_size: PositiveUnlimitedInteger | None = field(
        default=None,
        metadata={
            "name": "MAXIMUM-ALLOWED-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minimum_sustained_size: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINIMUM-SUSTAINED-SIZE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    redundancy_handlings: Optional["PersistencyKeyValueStorage.RedundancyHandlings"] = field(
        default=None,
        metadata={
            "name": "REDUNDANCY-HANDLINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    update_strategy: PersistencyCollectionLevelUpdateStrategyEnum | None = field(
        default=None,
        metadata={
            "name": "UPDATE-STRATEGY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    version: StrongRevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    key_value_pairs: Optional["PersistencyKeyValueStorage.KeyValuePairs"] = field(
        default=None,
        metadata={
            "name": "KEY-VALUE-PAIRS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DeploymentUris:
        persistency_deployment_uri: list[PersistencyDeploymentUri] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-DEPLOYMENT-URI",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RedundancyHandlings:
        persistency_redundancy_crc: list[PersistencyRedundancyCrc] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-REDUNDANCY-CRC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_redundancy_hash: list[PersistencyRedundancyHash] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-REDUNDANCY-HASH",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_redundancy_m_out_of_n: list[PersistencyRedundancyMOutOfN] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-REDUNDANCY-M-OUT-OF-N",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class KeyValuePairs:
        persistency_key_value_pair: list[PersistencyKeyValuePair] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-KEY-VALUE-PAIR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PortApiOption:
    """
    Options how to generate the signatures of calls for an AtomicSwComponentType in
    order to communicate over a PortPrototype (for calls into a RunnableEntity as
    well as for calls from a RunnableEntity to the PortPrototype).

    :ivar enable_take_address: If set to true, the software-component is
        able to use the API reference for deriving a pointer to an
        object.
    :ivar error_handling: This specifies whether a RunnableEntity
        accessing a PortPrototype that is referenced by this
        PortAPIOption shall specifically handle transformer errors or
        not.
    :ivar indirect_api: If set to true this attribute specifies an
        "indirect API" to be generated for the associated port which
        means that the software-component is able to access the actions
        on a port via a pointer to an object representing a port. This
        allows e.g. iterating over ports in a loop. This option has no
        effect for PPortPrototypes of client/server interfaces.
    :ivar port_arg_values: An argument value defined by this port.
    :ivar port_ref: The option is valid for generated functions related
        to communication over this port
    :ivar supported_features: This collection specifies which features
        are supported by the RunnableEntitys which access a
        PortPrototype that it referenced by this PortAPIOption.
    :ivar transformer_status_forwarding: This attribute specifies
        whether a RunnableEntity accessing a PortPrototype that is
        referenced by this PortAPIOption shall be able to forward a
        status code to the transformer chain.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwcInternalBehavior.portAPIOption
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-API-OPTION"

    enable_take_address: Boolean | None = field(
        default=None,
        metadata={
            "name": "ENABLE-TAKE-ADDRESS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    error_handling: DataTransformationErrorHandlingEnum | None = field(
        default=None,
        metadata={
            "name": "ERROR-HANDLING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    indirect_api: Boolean | None = field(
        default=None,
        metadata={
            "name": "INDIRECT-API",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_arg_values: Optional["PortApiOption.PortArgValues"] = field(
        default=None,
        metadata={
            "name": "PORT-ARG-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_ref: Optional["PortApiOption.PortRef"] = field(
        default=None,
        metadata={
            "name": "PORT-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    supported_features: Optional["PortApiOption.SupportedFeatures"] = field(
        default=None,
        metadata={
            "name": "SUPPORTED-FEATURES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    transformer_status_forwarding: DataTransformationStatusForwardingEnum | None = field(
        default=None,
        metadata={
            "name": "TRANSFORMER-STATUS-FORWARDING",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class PortArgValues:
        port_defined_argument_value: list[PortDefinedArgumentValue] = field(
            default_factory=list,
            metadata={
                "name": "PORT-DEFINED-ARGUMENT-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortRef(Ref):
        dest: PortPrototypeSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class SupportedFeatures:
        communication_buffer_locking: list[CommunicationBufferLocking] = field(
            default_factory=list,
            metadata={
                "name": "COMMUNICATION-BUFFER-LOCKING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PortPrototypeBlueprint:
    """This meta-class represents the ability to express a blueprint of a
    PortPrototype by referring to a particular PortInterface.

    This blueprint can then be used as a guidance to create particular
    PortPrototypes which are defined according to this blueprint. By
    this it is possible to standardize application interfaces without
    the need to also standardize software-components with PortPrototypes
    typed by the standardized PortInterfaces.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar init_values: This specifies the init values for the
        dataElements in the particular PortPrototypeBlueprint.
    :ivar interface_ref: This is the interface for which the blueprint
        is defined. It may be a blueprint itself  or a standardized
        PortInterface
    :ivar provided_com_specs: Provided communication attributes per
        interface element (data element or operation).
    :ivar required_com_specs: Required communication attributes, one for
        each interface element.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PORT-PROTOTYPE-BLUEPRINT"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PortPrototypeBlueprint.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PortPrototypeBlueprint.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["PortPrototypeBlueprint.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    init_values: Optional["PortPrototypeBlueprint.InitValues"] = field(
        default=None,
        metadata={
            "name": "INIT-VALUES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    interface_ref: Optional["PortPrototypeBlueprint.InterfaceRef"] = field(
        default=None,
        metadata={
            "name": "INTERFACE-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_com_specs: Optional["PortPrototypeBlueprint.ProvidedComSpecs"] = field(
        default=None,
        metadata={
            "name": "PROVIDED-COM-SPECS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_com_specs: Optional["PortPrototypeBlueprint.RequiredComSpecs"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-COM-SPECS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InitValues:
        port_prototype_blueprint_init_value: list[PortPrototypeBlueprintInitValue] = field(
            default_factory=list,
            metadata={
                "name": "PORT-PROTOTYPE-BLUEPRINT-INIT-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InterfaceRef(Ref):
        dest: PortInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedComSpecs:
        field_sender_com_spec: list[FieldSenderComSpec] = field(
            default_factory=list,
            metadata={
                "name": "FIELD-SENDER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mode_switch_sender_com_spec: list[ModeSwitchSenderComSpec] = field(
            default_factory=list,
            metadata={
                "name": "MODE-SWITCH-SENDER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nonqueued_sender_com_spec: list[NonqueuedSenderComSpec] = field(
            default_factory=list,
            metadata={
                "name": "NONQUEUED-SENDER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nv_provide_com_spec: list[NvProvideComSpec] = field(
            default_factory=list,
            metadata={
                "name": "NV-PROVIDE-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        parameter_provide_com_spec: list[ParameterProvideComSpec] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-PROVIDE-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        queued_sender_com_spec: list[QueuedSenderComSpec] = field(
            default_factory=list,
            metadata={
                "name": "QUEUED-SENDER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        server_com_spec: list[ServerComSpec] = field(
            default_factory=list,
            metadata={
                "name": "SERVER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredComSpecs:
        client_com_spec: list[ClientComSpec] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mode_switch_receiver_com_spec: list[ModeSwitchReceiverComSpec] = field(
            default_factory=list,
            metadata={
                "name": "MODE-SWITCH-RECEIVER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nonqueued_receiver_com_spec: list[NonqueuedReceiverComSpec] = field(
            default_factory=list,
            metadata={
                "name": "NONQUEUED-RECEIVER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nv_require_com_spec: list[NvRequireComSpec] = field(
            default_factory=list,
            metadata={
                "name": "NV-REQUIRE-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        parameter_require_com_spec: list[ParameterRequireComSpec] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-REQUIRE-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_data_required_com_spec: list[PersistencyDataRequiredComSpec] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-DATA-REQUIRED-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        queued_receiver_com_spec: list[QueuedReceiverComSpec] = field(
            default_factory=list,
            metadata={
                "name": "QUEUED-RECEIVER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class PrPortPrototype:
    """
    This kind of PortPrototype can take the role of both a required and a provided
    PortPrototype.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar client_server_annotations: Annotation of this PortPrototype
        with respect to client/server communication.
    :ivar delegated_port_annotation: Annotations on this delegated port.
    :ivar io_hw_abstraction_server_annotations: Annotations on this IO
        Hardware Abstraction port.
    :ivar mode_port_annotations: Annotations on this mode port.
    :ivar nv_data_port_annotations: Annotations on this non voilatile
        data port.
    :ivar parameter_port_annotations: Annotations on this parameter
        port.
    :ivar port_prototype_props: This attribute allows for the definition
        of further qualification of the semantics of a PortPrototype.
    :ivar sender_receiver_annotations: Collection of annotations of this
        ports sender/receiver communication.
    :ivar trigger_port_annotations: Annotations on this trigger port.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: SwComponentType.port
    :ivar provided_com_specs: Provided communication attributes per
        interface element (data element or operation).
    :ivar required_com_specs: Required communication attributes, one for
        each interface element.
    :ivar provided_required_interface_tref: This represents the
        PortInterface used to type the PRPortPrototype
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PR-PORT-PROTOTYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["PrPortPrototype.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["PrPortPrototype.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_server_annotations: Optional["PrPortPrototype.ClientServerAnnotations"] = field(
        default=None,
        metadata={
            "name": "CLIENT-SERVER-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delegated_port_annotation: DelegatedPortAnnotation | None = field(
        default=None,
        metadata={
            "name": "DELEGATED-PORT-ANNOTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    io_hw_abstraction_server_annotations: Optional[
        "PrPortPrototype.IoHwAbstractionServerAnnotations"
    ] = field(
        default=None,
        metadata={
            "name": "IO-HW-ABSTRACTION-SERVER-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_port_annotations: Optional["PrPortPrototype.ModePortAnnotations"] = field(
        default=None,
        metadata={
            "name": "MODE-PORT-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nv_data_port_annotations: Optional["PrPortPrototype.NvDataPortAnnotations"] = field(
        default=None,
        metadata={
            "name": "NV-DATA-PORT-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_port_annotations: Optional["PrPortPrototype.ParameterPortAnnotations"] = field(
        default=None,
        metadata={
            "name": "PARAMETER-PORT-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_props: Optional["PrPortPrototype.PortPrototypeProps"] = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sender_receiver_annotations: Optional["PrPortPrototype.SenderReceiverAnnotations"] = field(
        default=None,
        metadata={
            "name": "SENDER-RECEIVER-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_port_annotations: Optional["PrPortPrototype.TriggerPortAnnotations"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-PORT-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_com_specs: Optional["PrPortPrototype.ProvidedComSpecs"] = field(
        default=None,
        metadata={
            "name": "PROVIDED-COM-SPECS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_com_specs: Optional["PrPortPrototype.RequiredComSpecs"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-COM-SPECS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_required_interface_tref: Optional["PrPortPrototype.ProvidedRequiredInterfaceTref"] = (
        field(
            default=None,
            metadata={
                "name": "PROVIDED-REQUIRED-INTERFACE-TREF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClientServerAnnotations:
        client_server_annotation: list[ClientServerAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IoHwAbstractionServerAnnotations:
        io_hw_abstraction_server_annotation: list[IoHwAbstractionServerAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "IO-HW-ABSTRACTION-SERVER-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModePortAnnotations:
        mode_port_annotation: list[ModePortAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "MODE-PORT-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NvDataPortAnnotations:
        nv_data_port_annotation: list[NvDataPortAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "NV-DATA-PORT-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ParameterPortAnnotations:
        parameter_port_annotation: list[ParameterPortAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-PORT-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortPrototypeProps:
        r_port_prototype_props: RPortPrototypeProps | None = field(
            default=None,
            metadata={
                "name": "R-PORT-PROTOTYPE-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SenderReceiverAnnotations:
        receiver_annotation: list[ReceiverAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "RECEIVER-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sender_annotation: list[SenderAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "SENDER-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerPortAnnotations:
        trigger_port_annotation: list[TriggerPortAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER-PORT-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedComSpecs:
        field_sender_com_spec: list[FieldSenderComSpec] = field(
            default_factory=list,
            metadata={
                "name": "FIELD-SENDER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mode_switch_sender_com_spec: list[ModeSwitchSenderComSpec] = field(
            default_factory=list,
            metadata={
                "name": "MODE-SWITCH-SENDER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nonqueued_sender_com_spec: list[NonqueuedSenderComSpec] = field(
            default_factory=list,
            metadata={
                "name": "NONQUEUED-SENDER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nv_provide_com_spec: list[NvProvideComSpec] = field(
            default_factory=list,
            metadata={
                "name": "NV-PROVIDE-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        parameter_provide_com_spec: list[ParameterProvideComSpec] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-PROVIDE-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        queued_sender_com_spec: list[QueuedSenderComSpec] = field(
            default_factory=list,
            metadata={
                "name": "QUEUED-SENDER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        server_com_spec: list[ServerComSpec] = field(
            default_factory=list,
            metadata={
                "name": "SERVER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredComSpecs:
        client_com_spec: list[ClientComSpec] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mode_switch_receiver_com_spec: list[ModeSwitchReceiverComSpec] = field(
            default_factory=list,
            metadata={
                "name": "MODE-SWITCH-RECEIVER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nonqueued_receiver_com_spec: list[NonqueuedReceiverComSpec] = field(
            default_factory=list,
            metadata={
                "name": "NONQUEUED-RECEIVER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nv_require_com_spec: list[NvRequireComSpec] = field(
            default_factory=list,
            metadata={
                "name": "NV-REQUIRE-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        parameter_require_com_spec: list[ParameterRequireComSpec] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-REQUIRE-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_data_required_com_spec: list[PersistencyDataRequiredComSpec] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-DATA-REQUIRED-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        queued_receiver_com_spec: list[QueuedReceiverComSpec] = field(
            default_factory=list,
            metadata={
                "name": "QUEUED-RECEIVER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedRequiredInterfaceTref(Ref):
        dest: PortInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class RPortPrototype:
    """
    Component port requiring a certain port interface.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar client_server_annotations: Annotation of this PortPrototype
        with respect to client/server communication.
    :ivar delegated_port_annotation: Annotations on this delegated port.
    :ivar io_hw_abstraction_server_annotations: Annotations on this IO
        Hardware Abstraction port.
    :ivar mode_port_annotations: Annotations on this mode port.
    :ivar nv_data_port_annotations: Annotations on this non voilatile
        data port.
    :ivar parameter_port_annotations: Annotations on this parameter
        port.
    :ivar port_prototype_props: This attribute allows for the definition
        of further qualification of the semantics of a PortPrototype.
    :ivar sender_receiver_annotations: Collection of annotations of this
        ports sender/receiver communication.
    :ivar trigger_port_annotations: Annotations on this trigger port.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: SwComponentType.port
    :ivar required_com_specs: Required communication attributes, one for
        each interface element.
    :ivar may_be_unconnected: If set to true, this attribute indicates
        that the enclosing RPortPrototype may be left unconnected and
        that this aspect has explicitly been considered in the software-
        component's design.
    :ivar required_interface_tref: The interface that this port
        requires.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "R-PORT-PROTOTYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["RPortPrototype.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["RPortPrototype.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_server_annotations: Optional["RPortPrototype.ClientServerAnnotations"] = field(
        default=None,
        metadata={
            "name": "CLIENT-SERVER-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    delegated_port_annotation: DelegatedPortAnnotation | None = field(
        default=None,
        metadata={
            "name": "DELEGATED-PORT-ANNOTATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    io_hw_abstraction_server_annotations: Optional[
        "RPortPrototype.IoHwAbstractionServerAnnotations"
    ] = field(
        default=None,
        metadata={
            "name": "IO-HW-ABSTRACTION-SERVER-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_port_annotations: Optional["RPortPrototype.ModePortAnnotations"] = field(
        default=None,
        metadata={
            "name": "MODE-PORT-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nv_data_port_annotations: Optional["RPortPrototype.NvDataPortAnnotations"] = field(
        default=None,
        metadata={
            "name": "NV-DATA-PORT-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    parameter_port_annotations: Optional["RPortPrototype.ParameterPortAnnotations"] = field(
        default=None,
        metadata={
            "name": "PARAMETER-PORT-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_prototype_props: Optional["RPortPrototype.PortPrototypeProps"] = field(
        default=None,
        metadata={
            "name": "PORT-PROTOTYPE-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sender_receiver_annotations: Optional["RPortPrototype.SenderReceiverAnnotations"] = field(
        default=None,
        metadata={
            "name": "SENDER-RECEIVER-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trigger_port_annotations: Optional["RPortPrototype.TriggerPortAnnotations"] = field(
        default=None,
        metadata={
            "name": "TRIGGER-PORT-ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_com_specs: Optional["RPortPrototype.RequiredComSpecs"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-COM-SPECS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    may_be_unconnected: Boolean | None = field(
        default=None,
        metadata={
            "name": "MAY-BE-UNCONNECTED",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_interface_tref: Optional["RPortPrototype.RequiredInterfaceTref"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-INTERFACE-TREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClientServerAnnotations:
        client_server_annotation: list[ClientServerAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IoHwAbstractionServerAnnotations:
        io_hw_abstraction_server_annotation: list[IoHwAbstractionServerAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "IO-HW-ABSTRACTION-SERVER-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModePortAnnotations:
        mode_port_annotation: list[ModePortAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "MODE-PORT-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NvDataPortAnnotations:
        nv_data_port_annotation: list[NvDataPortAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "NV-DATA-PORT-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ParameterPortAnnotations:
        parameter_port_annotation: list[ParameterPortAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-PORT-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortPrototypeProps:
        r_port_prototype_props: RPortPrototypeProps | None = field(
            default=None,
            metadata={
                "name": "R-PORT-PROTOTYPE-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SenderReceiverAnnotations:
        receiver_annotation: list[ReceiverAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "RECEIVER-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sender_annotation: list[SenderAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "SENDER-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TriggerPortAnnotations:
        trigger_port_annotation: list[TriggerPortAnnotation] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER-PORT-ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredComSpecs:
        client_com_spec: list[ClientComSpec] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mode_switch_receiver_com_spec: list[ModeSwitchReceiverComSpec] = field(
            default_factory=list,
            metadata={
                "name": "MODE-SWITCH-RECEIVER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nonqueued_receiver_com_spec: list[NonqueuedReceiverComSpec] = field(
            default_factory=list,
            metadata={
                "name": "NONQUEUED-RECEIVER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nv_require_com_spec: list[NvRequireComSpec] = field(
            default_factory=list,
            metadata={
                "name": "NV-REQUIRE-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        parameter_require_com_spec: list[ParameterRequireComSpec] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-REQUIRE-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_data_required_com_spec: list[PersistencyDataRequiredComSpec] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-DATA-REQUIRED-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        queued_receiver_com_spec: list[QueuedReceiverComSpec] = field(
            default_factory=list,
            metadata={
                "name": "QUEUED-RECEIVER-COM-SPEC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredInterfaceTref(Ref):
        dest: PortInterfaceSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class SenderReceiverInterface:
    """
    A sender/receiver interface declares a number of data elements to be sent and
    received.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar data_elements: The data elements of this
        SenderReceiverInterface. This aggregation contains a variation
        point although it is not variant. Therefore, this variation
        point shall not exist in models. See constr_2638.
    :ivar invalidation_policys: InvalidationPolicy for a particular
        dataElement
    :ivar meta_data_item_sets: This aggregation defines fixed sets of
        meta-data items associated with dataElements of the enclosing
        SenderReceiverInterface
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SENDER-RECEIVER-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SenderReceiverInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SenderReceiverInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["SenderReceiverInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["SenderReceiverInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_elements: Optional["SenderReceiverInterface.DataElements"] = field(
        default=None,
        metadata={
            "name": "DATA-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    invalidation_policys: Optional["SenderReceiverInterface.InvalidationPolicys"] = field(
        default=None,
        metadata={
            "name": "INVALIDATION-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    meta_data_item_sets: Optional["SenderReceiverInterface.MetaDataItemSets"] = field(
        default=None,
        metadata={
            "name": "META-DATA-ITEM-SETS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class DataElements:
        variable_data_prototype: list[VariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InvalidationPolicys:
        invalidation_policy: list[InvalidationPolicy] = field(
            default_factory=list,
            metadata={
                "name": "INVALIDATION-POLICY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MetaDataItemSets:
        meta_data_item_set: list[MetaDataItemSet] = field(
            default_factory=list,
            metadata={
                "name": "META-DATA-ITEM-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ServiceInterface:
    """
    This represents the ability to define a PortInterface that consists of a
    heterogeneous collection of methods, events and fields.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar is_service: This flag is set if the PortInterface is to be
        used for communication between an * ApplicationSwComponentType
        or * ServiceProxySwComponentType or *
        SensorActuatorSwComponentType or *
        ComplexDeviceDriverSwComponentType * ServiceSwComponentType *
        EcuAbstractionSwComponentType and a ServiceSwComponentType
        (namely an AUTOSAR Service) located on the same ECU. Otherwise
        the flag is not set.
    :ivar namespaces: This represents the SymbolProps used for the
        definition of a hierarchical namespace applicable for the
        generation of code artifacts out of the definition of a
        ServiceInterface.
    :ivar service_kind: This attribute provides further details about
        the nature of the applied service.
    :ivar major_version: Major version of the service contract.
    :ivar minor_version: Minor version of the service contract.
    :ivar events: This represents the collection of events defined in
        the context of a ServiceInterface.
    :ivar fields: This represents the collection of fields defined in
        the context of a ServiceInterface.
    :ivar methods: This represents the collection of methods defined in
        the context of a ServiceInterface.
    :ivar triggers: This represents the collection of triggers defined
        in the context of a ServiceInterface.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-INTERFACE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ServiceInterface.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ServiceInterface.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ServiceInterface.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    is_service: BooleanValueVariationPoint | None = field(
        default=None,
        metadata={
            "name": "IS-SERVICE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    namespaces: Optional["ServiceInterface.Namespaces"] = field(
        default=None,
        metadata={
            "name": "NAMESPACES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_kind: ServiceProviderEnum | None = field(
        default=None,
        metadata={
            "name": "SERVICE-KIND",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    major_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MAJOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    minor_version: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MINOR-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    events: Optional["ServiceInterface.Events"] = field(
        default=None,
        metadata={
            "name": "EVENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fields: Optional["ServiceInterface.Fields"] = field(
        default=None,
        metadata={
            "name": "FIELDS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    methods: Optional["ServiceInterface.Methods"] = field(
        default=None,
        metadata={
            "name": "METHODS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    triggers: Optional["ServiceInterface.Triggers"] = field(
        default=None,
        metadata={
            "name": "TRIGGERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Namespaces:
        symbol_props: list[SymbolProps] = field(
            default_factory=list,
            metadata={
                "name": "SYMBOL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Events:
        variable_data_prototype: list[VariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Fields:
        field_value: list[FieldType] = field(
            default_factory=list,
            metadata={
                "name": "FIELD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Methods:
        client_server_operation: list[ClientServerOperation] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-OPERATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Triggers:
        trigger: list[Trigger] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StateManagementCompareFormula:
    """A StateManagementCompareFormula embodies the computation instruction that is
    to be evaluated at runtime to determine if the aggregating request rule yields
    true or false.

    The formula itself consists of parts which are combined by the
    logical operations specified by StateManagementCompareFormula .op.

    :ivar parts: This aggregation represents the collection of formula
        parts that can be combined by logical operators.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-COMPARE-FORMULA"

    parts: Optional["StateManagementCompareFormula.Parts"] = field(
        default=None,
        metadata={
            "name": "PARTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class Parts:
        state_management_compare_formula: list["StateManagementCompareFormula"] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-COMPARE-FORMULA",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        state_management_error_compare_rule: list[StateManagementErrorCompareRule] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-ERROR-COMPARE-RULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        state_management_trigger_compare_rule: list[StateManagementTriggerCompareRule] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-TRIGGER-COMPARE-RULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Tgroup:
    """
    This meta-class represents the ability to denote a table section.

    :ivar colspec: This specifies one particular column specification in
        the table. There shall be one entry for each column.
    :ivar thead: This represents the heading of the table section. The
        heading is usually repeated at the beginning of each new page.
    :ivar tfoot: This represents the footer of the table segment. This
        segment is printed at the end of the table or before a page
        break.
    :ivar tbody: This is the main part of the table segment, called the
        table body.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar align: Specifies how the cell entries shall be horizontally
        aligned within the specified TGROUP. Default is "LEFT"
    :ivar cols: This attribute represents the number of columns in the
        table.
    :ivar colsep: Indicates if by default a line shall be drawn between
        the columns of this table group.
    :ivar rowsep: Indicates if by default a line shall be drawn at the
        bottom of the rows in this table group.
    """

    class Meta:
        name = "TGROUP"

    colspec: list[Colspec] = field(
        default_factory=list,
        metadata={
            "name": "COLSPEC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    thead: Tbody | None = field(
        default=None,
        metadata={
            "name": "THEAD",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tfoot: Tbody | None = field(
        default=None,
        metadata={
            "name": "TFOOT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tbody: Tbody | None = field(
        default=None,
        metadata={
            "name": "TBODY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    align: AlignEnumSimple | None = field(
        default=None,
        metadata={
            "name": "ALIGN",
            "type": "Attribute",
        },
    )
    cols: str | None = field(
        default=None,
        metadata={
            "name": "COLS",
            "type": "Attribute",
            "pattern": r"0|[\+\-]?[1-9][0-9]*|0[xX][0-9a-fA-F]+|0[bB][0-1]+|0[0-7]+",
        },
    )
    colsep: str | None = field(
        default=None,
        metadata={
            "name": "COLSEP",
            "type": "Attribute",
            "pattern": r"[0-1]",
        },
    )
    rowsep: str | None = field(
        default=None,
        metadata={
            "name": "ROWSEP",
            "type": "Attribute",
            "pattern": r"[0-1]",
        },
    )


@dataclass(slots=True, kw_only=True)
class DiagnosticEnvironmentalCondition:
    """
    The meta-class DiagnosticEnvironmentalCondition formalizes the idea of a
    condition which is evaluated during runtime of the ECU by looking at
    "environmental" states (e.g. one such condition is that the vehicle is not
    driving, i.e. vehicle speed == 0).

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar formula: This attribute represents the formula part of the
        DiagnosticEnvironmentalCondition.
    :ivar mode_elements: This aggregation contains a representation of
        ModeDeclarations in the context of a
        DiagnosticEnvironmentalCondition.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DIAGNOSTIC-ENVIRONMENTAL-CONDITION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["DiagnosticEnvironmentalCondition.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["DiagnosticEnvironmentalCondition.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: DiagnosticEnvConditionFormula | None = field(
        default=None,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mode_elements: Optional["DiagnosticEnvironmentalCondition.ModeElements"] = field(
        default=None,
        metadata={
            "name": "MODE-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ModeElements:
        diagnostic_env_bsw_mode_element: list[DiagnosticEnvBswModeElement] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ENV-BSW-MODE-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_env_swc_mode_element: list[DiagnosticEnvSwcModeElement] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ENV-SWC-MODE-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StateManagementRequestRule:
    """
    This meta-class represents a rule for deciding about a state change.

    :ivar formula: This aggregation represents the definition of the
        formula for the StateManagementRequestRule
    :ivar next_state_iref: This reference identifies the state to be
        switched to if the condition is fulfilled.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-REQUEST-RULE"

    formula: StateManagementCompareFormula | None = field(
        default=None,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    next_state_iref: ModeDeclarationInStateManagementStateNotificationInstanceRef | None = field(
        default=None,
        metadata={
            "name": "NEXT-STATE-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SwcInternalBehavior:
    """
    The SwcInternalBehavior of an AtomicSwComponentType describes the relevant
    aspects of the software-component with respect to the RTE, i.e. the
    RunnableEntities and the RTEEvents they respond to.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar constant_memorys: Describes a read only memory object
        containing characteristic value(s)  implemented by this
        InternalBehavior. The shortName of ParameterDataPrototype has to
        be equal to the ''C' identifier of the described constant. The
        characteristic value(s) might be shared between
        SwComponentPrototypes of the same SwComponentType. The
        aggregation of constantMemory is subject to variability with the
        purpose to support variability in the software component or
        module implementations. Typically different algorithms in the
        implementation are requiring different number of memory objects.
    :ivar constant_value_mapping_refs: Reference to the
        ConstantSpecificationMapping to be applied for the particular
        InternalBehavior
    :ivar data_type_mapping_refs: Reference to the DataTypeMapping to be
        applied for the particular InternalBehavior
    :ivar exclusive_areas: This specifies an ExclusiveArea for this
        InternalBehavior. The exclusiveArea is local to the component
        resp. module. The aggregation of ExclusiveAreas is subject to
        variability. Note: the number of ExclusiveAreas might vary due
        to the conditional existence of RunnableEntities or
        BswModuleEntities.
    :ivar exclusive_area_nesting_orders: This represents the set of
        ExclusiveAreaNestingOrder owned by the InternalBehavior.
    :ivar static_memorys: Describes a read and writeable static memory
        object representing measurerment variables implemented by this
        software component. The term "static" is used in the meaning of
        "non-temporary" and does not necessarily specify a linker
        encapsulation. This kind of memory is only supported if
        supportsMultipleInstantiation is FALSE. The shortName of the
        VariableDataPrototype has to be equal with the ''C' identifier
        of the described variable. The aggregation of staticMemory is
        subject to variability with the purpose to support variability
        in the software component's implementations. Typically different
        algorithms in the implementation are requiring different number
        of memory objects.
    :ivar ar_typed_per_instance_memorys: Defines an AUTOSAR typed
        memory-block that needs to be available for each instance of the
        SW-component. This is typically only useful if
        supportsMultipleInstantiation is set to "true" or if the
        component defines NVRAM access via permanent blocks. The
        aggregation of arTypedPerInstanceMemory is subject to
        variability with the purpose to support variability in the
        software component's implementations. Typically different
        algorithms in the implementation are requiring different number
        of memory objects.
    :ivar events: This is a RTEEvent specified for the particular
        SwcInternalBehavior. The aggregation of RTEEvent is subject to
        variability with the purpose to support the conditional
        existence of RTE events. Note: the number of RTE events might
        vary due to the conditional existence of PortPrototypes using
        DataReceivedEvents or due to different scheduling needs of
        algorithms.
    :ivar exclusive_area_policys: Options how to generate the
        ExclusiveArea related APIs. When no SwcExclusiveAreaPolicy is
        specified for an ExclusiveArea the default values apply.
    :ivar explicit_inter_runnable_variables: Implement state message
        semantics for establishing communication among runnables of the
        same component. The aggregation of explicitInterRunnableVariable
        is subject to variability with the purpose to support
        variability in the software components implementations.
        Typically different algorithms in the implementation are
        requiring different number of memory objects.
    :ivar handle_termination_and_restart: This attribute controls the
        behavior with respect to stopping and restarting. The
        corresponding AtomicSwComponentType may either not support stop
        and restart, or support only stop, or support both stop and
        restart.
    :ivar implicit_inter_runnable_variables: Implement state message
        semantics for establishing communication among runnables of the
        same component. The aggregation of implicitInterRunnableVariable
        is subject to variability with the purpose to support
        variability in the software components implementations.
        Typically different algorithms in the implementation are
        requiring different number of memory objects.
    :ivar included_data_type_sets: The includedDataTypeSet is used by a
        software component for its implementation.
    :ivar included_mode_declaration_group_sets: This aggregation
        represents the included ModeDeclarationGroups
    :ivar instantiation_data_def_propss: The purpose of this is that
        within the context  of a given SwComponentType some data def
        properties of individual instantiations can be  modified. The
        aggregation of InstantiationDataDefProps is subject to
        variability with the purpose to support the conditional
        existence of PortPrototypes and component local memories like
        "perInstanceParameter" or "arTypedPerInstanceMemory".
    :ivar per_instance_memorys: Defines a per-instance memory object
        needed by this software component. The aggregation of
        PerInstanceMemory is subject to variability with the purpose to
        support variability in the software components implementations.
        Typically different algorithms in the implementation are
        requiring different number of memory objects.
    :ivar per_instance_parameters: Defines parameter(s) or
        characteristic value(s) that needs to be available for each
        instance of the software-component. This is typically only
        useful if supportsMultipleInstantiation is set to "true". The
        aggregation of perInstanceParameter is subject to variability
        with the purpose to support variability in the software
        components implementations. Typically different algorithms in
        the implementation are requiring different number of memory
        objects.
    :ivar port_api_options: Options for generating the signature of
        port-related calls from a runnable to the RTE and vice versa.
        The aggregation of PortPrototypes is subject to variability with
        the purpose to support the conditional existence of ports.
    :ivar runnables: This is a RunnableEntity specified for the
        particular SwcInternalBehavior. The aggregation of
        RunnableEntity is subject to variability with the purpose to
        support the conditional existence of RunnableEntities. Note: the
        number of RunnableEntities might vary due to the conditional
        existence of PortPrototypes using DataReceivedEvents or due to
        different scheduling needs of algorithms.
    :ivar service_dependencys: Defines the requirements on AUTOSAR
        Services for a particular item. The aggregation of
        SwcServiceDependency is subject to variability with the purpose
        to support the conditional existence of ports as well as the
        conditional existence of ServiceNeeds. The SwcServiceDependency
        owned by an SwcInternalBehavior can be located in a different
        physical file in order to support that SwcServiceDependency
        might be provided in later development steps or even by
        different expert domain (e.g OBD expert for Obd related  Service
        Needs) tools. Therefore the aggregation is
        &lt;&lt;atpSplitable&gt;&gt;.
    :ivar shared_parameters: Defines parameter(s) or characteristic
        value(s) shared between SwComponentPrototypes of the same
        SwComponentType The aggregation of sharedParameter is subject to
        variability with the purpose to support variability in the
        software components implementations. Typically different
        algorithms in the implementation are requiring different number
        of memory objects.
    :ivar supports_multiple_instantiation: Indicate whether the
        corresponding software-component can be multiply instantiated on
        one ECU. In this case the attribute will result in an
        appropriate component API on programming language level (with or
        without instance handle).
    :ivar variation_point_proxys: Proxy of a variation points in the
        C/C++ implementation.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        AtomicSwComponentType.internalBehavior
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SWC-INTERNAL-BEHAVIOR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SwcInternalBehavior.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SwcInternalBehavior.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    constant_memorys: Optional["SwcInternalBehavior.ConstantMemorys"] = field(
        default=None,
        metadata={
            "name": "CONSTANT-MEMORYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    constant_value_mapping_refs: Optional["SwcInternalBehavior.ConstantValueMappingRefs"] = field(
        default=None,
        metadata={
            "name": "CONSTANT-VALUE-MAPPING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_type_mapping_refs: Optional["SwcInternalBehavior.DataTypeMappingRefs"] = field(
        default=None,
        metadata={
            "name": "DATA-TYPE-MAPPING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_areas: Optional["SwcInternalBehavior.ExclusiveAreas"] = field(
        default=None,
        metadata={
            "name": "EXCLUSIVE-AREAS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_area_nesting_orders: Optional["SwcInternalBehavior.ExclusiveAreaNestingOrders"] = (
        field(
            default=None,
            metadata={
                "name": "EXCLUSIVE-AREA-NESTING-ORDERS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    static_memorys: Optional["SwcInternalBehavior.StaticMemorys"] = field(
        default=None,
        metadata={
            "name": "STATIC-MEMORYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ar_typed_per_instance_memorys: Optional["SwcInternalBehavior.ArTypedPerInstanceMemorys"] = (
        field(
            default=None,
            metadata={
                "name": "AR-TYPED-PER-INSTANCE-MEMORYS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    events: Optional["SwcInternalBehavior.Events"] = field(
        default=None,
        metadata={
            "name": "EVENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    exclusive_area_policys: Optional["SwcInternalBehavior.ExclusiveAreaPolicys"] = field(
        default=None,
        metadata={
            "name": "EXCLUSIVE-AREA-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    explicit_inter_runnable_variables: Optional[
        "SwcInternalBehavior.ExplicitInterRunnableVariables"
    ] = field(
        default=None,
        metadata={
            "name": "EXPLICIT-INTER-RUNNABLE-VARIABLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    handle_termination_and_restart: HandleTerminationAndRestartEnum | None = field(
        default=None,
        metadata={
            "name": "HANDLE-TERMINATION-AND-RESTART",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implicit_inter_runnable_variables: Optional[
        "SwcInternalBehavior.ImplicitInterRunnableVariables"
    ] = field(
        default=None,
        metadata={
            "name": "IMPLICIT-INTER-RUNNABLE-VARIABLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    included_data_type_sets: Optional["SwcInternalBehavior.IncludedDataTypeSets"] = field(
        default=None,
        metadata={
            "name": "INCLUDED-DATA-TYPE-SETS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    included_mode_declaration_group_sets: Optional[
        "SwcInternalBehavior.IncludedModeDeclarationGroupSets"
    ] = field(
        default=None,
        metadata={
            "name": "INCLUDED-MODE-DECLARATION-GROUP-SETS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    instantiation_data_def_propss: Optional["SwcInternalBehavior.InstantiationDataDefPropss"] = (
        field(
            default=None,
            metadata={
                "name": "INSTANTIATION-DATA-DEF-PROPSS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    per_instance_memorys: Optional["SwcInternalBehavior.PerInstanceMemorys"] = field(
        default=None,
        metadata={
            "name": "PER-INSTANCE-MEMORYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    per_instance_parameters: Optional["SwcInternalBehavior.PerInstanceParameters"] = field(
        default=None,
        metadata={
            "name": "PER-INSTANCE-PARAMETERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_api_options: Optional["SwcInternalBehavior.PortApiOptions"] = field(
        default=None,
        metadata={
            "name": "PORT-API-OPTIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    runnables: Optional["SwcInternalBehavior.Runnables"] = field(
        default=None,
        metadata={
            "name": "RUNNABLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    service_dependencys: Optional["SwcInternalBehavior.ServiceDependencys"] = field(
        default=None,
        metadata={
            "name": "SERVICE-DEPENDENCYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    shared_parameters: Optional["SwcInternalBehavior.SharedParameters"] = field(
        default=None,
        metadata={
            "name": "SHARED-PARAMETERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    supports_multiple_instantiation: Boolean | None = field(
        default=None,
        metadata={
            "name": "SUPPORTS-MULTIPLE-INSTANTIATION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point_proxys: Optional["SwcInternalBehavior.VariationPointProxys"] = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT-PROXYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConstantMemorys:
        parameter_data_prototype: list[ParameterDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConstantValueMappingRefs:
        constant_value_mapping_ref: list[
            "SwcInternalBehavior.ConstantValueMappingRefs.ConstantValueMappingRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONSTANT-VALUE-MAPPING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ConstantValueMappingRef(Ref):
            dest: ConstantSpecificationMappingSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DataTypeMappingRefs:
        data_type_mapping_ref: list[
            "SwcInternalBehavior.DataTypeMappingRefs.DataTypeMappingRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DATA-TYPE-MAPPING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DataTypeMappingRef(Ref):
            dest: DataTypeMappingSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreas:
        exclusive_area: list[ExclusiveArea] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaNestingOrders:
        exclusive_area_nesting_order: list[ExclusiveAreaNestingOrder] = field(
            default_factory=list,
            metadata={
                "name": "EXCLUSIVE-AREA-NESTING-ORDER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class StaticMemorys:
        variable_data_prototype: list[VariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ArTypedPerInstanceMemorys:
        variable_data_prototype: list[VariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Events:
        asynchronous_server_call_returns_event: list[AsynchronousServerCallReturnsEvent] = field(
            default_factory=list,
            metadata={
                "name": "ASYNCHRONOUS-SERVER-CALL-RETURNS-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        background_event: list[BackgroundEvent] = field(
            default_factory=list,
            metadata={
                "name": "BACKGROUND-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        data_receive_error_event: list[DataReceiveErrorEvent] = field(
            default_factory=list,
            metadata={
                "name": "DATA-RECEIVE-ERROR-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        data_received_event: list[DataReceivedEvent] = field(
            default_factory=list,
            metadata={
                "name": "DATA-RECEIVED-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        data_send_completed_event: list[DataSendCompletedEvent] = field(
            default_factory=list,
            metadata={
                "name": "DATA-SEND-COMPLETED-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        data_write_completed_event: list[DataWriteCompletedEvent] = field(
            default_factory=list,
            metadata={
                "name": "DATA-WRITE-COMPLETED-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        external_trigger_occurred_event: list[ExternalTriggerOccurredEvent] = field(
            default_factory=list,
            metadata={
                "name": "EXTERNAL-TRIGGER-OCCURRED-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        init_event: list[InitEvent] = field(
            default_factory=list,
            metadata={
                "name": "INIT-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        internal_trigger_occurred_event: list[InternalTriggerOccurredEvent] = field(
            default_factory=list,
            metadata={
                "name": "INTERNAL-TRIGGER-OCCURRED-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mode_switched_ack_event: list[ModeSwitchedAckEvent] = field(
            default_factory=list,
            metadata={
                "name": "MODE-SWITCHED-ACK-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        operation_invoked_event: list[OperationInvokedEvent] = field(
            default_factory=list,
            metadata={
                "name": "OPERATION-INVOKED-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        os_task_execution_event: list[OsTaskExecutionEvent] = field(
            default_factory=list,
            metadata={
                "name": "OS-TASK-EXECUTION-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        swc_mode_manager_error_event: list[SwcModeManagerErrorEvent] = field(
            default_factory=list,
            metadata={
                "name": "SWC-MODE-MANAGER-ERROR-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        swc_mode_switch_event: list[SwcModeSwitchEvent] = field(
            default_factory=list,
            metadata={
                "name": "SWC-MODE-SWITCH-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        timing_event: list[TimingEvent] = field(
            default_factory=list,
            metadata={
                "name": "TIMING-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        transformer_hard_error_event: list[TransformerHardErrorEvent] = field(
            default_factory=list,
            metadata={
                "name": "TRANSFORMER-HARD-ERROR-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExclusiveAreaPolicys:
        swc_exclusive_area_policy: list[SwcExclusiveAreaPolicy] = field(
            default_factory=list,
            metadata={
                "name": "SWC-EXCLUSIVE-AREA-POLICY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExplicitInterRunnableVariables:
        variable_data_prototype: list[VariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplicitInterRunnableVariables:
        variable_data_prototype: list[VariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IncludedDataTypeSets:
        included_data_type_set: list[IncludedDataTypeSet] = field(
            default_factory=list,
            metadata={
                "name": "INCLUDED-DATA-TYPE-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class IncludedModeDeclarationGroupSets:
        included_mode_declaration_group_set: list[IncludedModeDeclarationGroupSet] = field(
            default_factory=list,
            metadata={
                "name": "INCLUDED-MODE-DECLARATION-GROUP-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InstantiationDataDefPropss:
        instantiation_data_def_props: list[InstantiationDataDefProps] = field(
            default_factory=list,
            metadata={
                "name": "INSTANTIATION-DATA-DEF-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PerInstanceMemorys:
        per_instance_memory: list[PerInstanceMemory] = field(
            default_factory=list,
            metadata={
                "name": "PER-INSTANCE-MEMORY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PerInstanceParameters:
        parameter_data_prototype: list[ParameterDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortApiOptions:
        port_api_option: list[PortApiOption] = field(
            default_factory=list,
            metadata={
                "name": "PORT-API-OPTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Runnables:
        runnable_entity: list[RunnableEntity] = field(
            default_factory=list,
            metadata={
                "name": "RUNNABLE-ENTITY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ServiceDependencys:
        swc_service_dependency: list[SwcServiceDependency] = field(
            default_factory=list,
            metadata={
                "name": "SWC-SERVICE-DEPENDENCY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SharedParameters:
        parameter_data_prototype: list[ParameterDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class VariationPointProxys:
        variation_point_proxy: list[VariationPointProxy] = field(
            default_factory=list,
            metadata={
                "name": "VARIATION-POINT-PROXY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Table:
    """This class implements an exchange table according to OASIS Technical
    Resolution TR 9503:1995.

    http://www.oasis-open.org/specs/a503.htm

    :ivar table_caption: This element specifies the table heading.
    :ivar tgroup: A table can be built of individual segments. Such a
        segment is called tgroup.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: TopicContent.table Not
        Applicable for: TraceableTable.table
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    :ivar colsep: Indicates if by default a line should be drawn between
        the columns of this table.
    :ivar float_value: Indicate whether it is allowed to break the
        element.
    :ivar frame: Used to defined the frame line around a table.
    :ivar help_entry: This specifies an entry point in an online help
        system to be linked with the parent class. The syntax shall be
        defined by the applied help system respectively help system
        generator.
    :ivar orient: Indicate whether a table should be represented as
        landscape or portrait. * land : landscape * port : portrait
    :ivar pgwide: Used to indicate whether the figure should take the
        complete page width (value = "pgwide") or not (value =
        "noPgwide").
    :ivar rowsep: Indicates if by default  a line should be drawn at the
        bottom of table rows.
    :ivar tabstyle: Indicates an external table style.
    """

    class Meta:
        name = "TABLE"

    table_caption: Caption | None = field(
        default=None,
        metadata={
            "name": "TABLE-CAPTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    tgroup: list[Tgroup] = field(
        default_factory=list,
        metadata={
            "name": "TGROUP",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )
    colsep: str | None = field(
        default=None,
        metadata={
            "name": "COLSEP",
            "type": "Attribute",
            "pattern": r"[0-1]",
        },
    )
    float_value: FloatEnumSimple | None = field(
        default=None,
        metadata={
            "name": "FLOAT",
            "type": "Attribute",
        },
    )
    frame: FrameEnumSimple | None = field(
        default=None,
        metadata={
            "name": "FRAME",
            "type": "Attribute",
        },
    )
    help_entry: str | None = field(
        default=None,
        metadata={
            "name": "HELP-ENTRY",
            "type": "Attribute",
        },
    )
    orient: OrientEnumSimple | None = field(
        default=None,
        metadata={
            "name": "ORIENT",
            "type": "Attribute",
        },
    )
    pgwide: str | None = field(
        default=None,
        metadata={
            "name": "PGWIDE",
            "type": "Attribute",
        },
    )
    rowsep: str | None = field(
        default=None,
        metadata={
            "name": "ROWSEP",
            "type": "Attribute",
            "pattern": r"[0-1]",
        },
    )
    tabstyle: str | None = field(
        default=None,
        metadata={
            "name": "TABSTYLE",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class StateManagementRequestError:
    """
    This meta-class has the ability to configure the submission of an error to the
    state management.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar state_request_port_iref: This represents the RPortPrototype in
        the application software that is issuing the request for state
        change.
    :ivar rules: This aggregation represents the collection of rules
        applicable for the error request.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-REQUEST-ERROR"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StateManagementRequestError.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StateManagementRequestError.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    state_request_port_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "STATE-REQUEST-PORT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rules: Optional["StateManagementRequestError.Rules"] = field(
        default=None,
        metadata={
            "name": "RULES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Rules:
        state_management_request_rule: list[StateManagementRequestRule] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-REQUEST-RULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class StateManagementRequestTrigger:
    """
    This meta-class has the ability to configure a trigger request to the state
    management.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar state_request_port_iref: This represents the RPortPrototype in
        the application software that is issuing the request for state
        change.
    :ivar rules: This aggregation represents the collection of rules
        applicable for the trigger request.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-REQUEST-TRIGGER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StateManagementRequestTrigger.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StateManagementRequestTrigger.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    state_request_port_iref: RPortPrototypeInExecutableInstanceRef | None = field(
        default=None,
        metadata={
            "name": "STATE-REQUEST-PORT-IREF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    rules: Optional["StateManagementRequestTrigger.Rules"] = field(
        default=None,
        metadata={
            "name": "RULES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Rules:
        state_management_request_rule: list[StateManagementRequestRule] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-REQUEST-RULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TraceableTable:
    """
    This meta-class represents the ability to denote a traceable table item such as
    requirements etc..

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar trace_refs: This association represents the ability to trace
        to upstream requirements / constraints. This supports for
        example  the bottom up tracing ProjectObjectives &lt;-
        MainRequirements &lt;- Features &lt;- RequirementSpecs &lt;-
        BSW/AI
    :ivar table: This represents a table with a traceable table. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    """

    class Meta:
        name = "TRACEABLE-TABLE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["TraceableTable.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["TraceableTable.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace_refs: Optional["TraceableTable.TraceRefs"] = field(
        default=None,
        metadata={
            "name": "TRACE-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    table: Table | None = field(
        default=None,
        metadata={
            "name": "TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class TraceRefs:
        trace_ref: list["TraceableTable.TraceRefs.TraceRef"] = field(
            default_factory=list,
            metadata={
                "name": "TRACE-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class TraceRef(Ref):
            dest: TraceableSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class StateManagementModuleInstantiation:
    """
    This meta-class represents the deployment-level configuration of the state
    management on the AUTOSAR adaptive platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar action_item_lists: This represents the collection of action
        item lists defined in the context of the enclosing state
        management module.
    :ivar notifications: This aggregation represents the state switch
        notifications handled by the state manager.
    :ivar requests: This aggregation represents the state requests
        handled by the state manager.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "STATE-MANAGEMENT-MODULE-INSTANTIATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["StateManagementModuleInstantiation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["StateManagementModuleInstantiation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    action_item_lists: Optional["StateManagementModuleInstantiation.ActionItemLists"] = field(
        default=None,
        metadata={
            "name": "ACTION-ITEM-LISTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    notifications: Optional["StateManagementModuleInstantiation.Notifications"] = field(
        default=None,
        metadata={
            "name": "NOTIFICATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    requests: Optional["StateManagementModuleInstantiation.Requests"] = field(
        default=None,
        metadata={
            "name": "REQUESTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ActionItemLists:
        state_management_action_list: list[StateManagementActionList] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-ACTION-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Notifications:
        state_management_state_notification: list[StateManagementStateNotification] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-STATE-NOTIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Requests:
        state_management_request_error: list[StateManagementRequestError] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-REQUEST-ERROR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        state_management_request_trigger: list[StateManagementRequestTrigger] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-REQUEST-TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TopicContent:
    """This meta-class represents the content of a topic.

    It is mainly a documentation block, but can also be a table.

    :ivar msr_query_p_2: This represents automatically contributed
        contents provided by an msrquery in the context of
        DocumentationBlock.
    :ivar p: This is one particular paragraph. The upper multiplicity of
        this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar verbatim: This represents one particular verbatim text. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar list_value: This represents numbered or unnumbered list. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar def_list: This represents a definition list in the
        documentation block. The upper multiplicity of this role has
        been increased to * due to resolving an atpVariation stereotype.
        The previous value was 1.
    :ivar labeled_list: This represents a labeled list. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar formula: This is a formula in the definition block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar figure: This represents a figure in the documentation block.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar note: This represents a note in the text flow. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar trace: This represents traceable text in the documentation
        block. This allows to specify requirements/constraints in any
        documentation block. The kind of the trace is specified in the
        category. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar structured_req: This aggregation supports structured
        requirements embedded in a documentation block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar table: This represents a table within a topic. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar traceable_table: This represents a traceable table within a
        topic.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TOPIC-CONTENT"

    msr_query_p_2: list[MsrQueryP2] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p: list[MultiLanguageParagraph] = field(
        default_factory=list,
        metadata={
            "name": "P",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: list[MultiLanguageVerbatim] = field(
        default_factory=list,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    list_value: list[ListType] = field(
        default_factory=list,
        metadata={
            "name": "LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_list: list[DefList] = field(
        default_factory=list,
        metadata={
            "name": "DEF-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    labeled_list: list[LabeledList] = field(
        default_factory=list,
        metadata={
            "name": "LABELED-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: list[MlFormula] = field(
        default_factory=list,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    figure: list[MlFigure] = field(
        default_factory=list,
        metadata={
            "name": "FIGURE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    note: list[Note] = field(
        default_factory=list,
        metadata={
            "name": "NOTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace: list[TraceableText] = field(
        default_factory=list,
        metadata={
            "name": "TRACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    structured_req: list[StructuredReq] = field(
        default_factory=list,
        metadata={
            "name": "STRUCTURED-REQ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    table: list[Table] = field(
        default_factory=list,
        metadata={
            "name": "TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    traceable_table: list[TraceableTable] = field(
        default_factory=list,
        metadata={
            "name": "TRACEABLE-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Machine:
    """
    Machine that represents an Adaptive Autosar Software Stack.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar default_application_timeout: This aggration defines a default
        timeout in the context of a given Machine with respect to the
        launching and termination of applications.
    :ivar environment_variables: This aggregation represents the
        collection of environment variables that shall be added to the
        environment defined on the level of the enclosing Machine. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar machine_design_ref: Reference to the MachineDesign this
        Machine is implementing.
    :ivar module_instantiations: Configuration of Adaptive Autosar
        module instances that are running on the machine.
    :ivar processors: This represents the collection of processors owned
        by the enclosing machine.
    :ivar secure_communication_deployments: Deployment of secure
        communication protocol configuration settings to crypto module
        entities.
    :ivar trusted_platform_executable_launch_behavior: This attribute
        controls the behavior of how authentication affects the ability
        to launch for each Executable.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MACHINE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Machine.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Machine.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    default_application_timeout: EnterExitTimeout | None = field(
        default=None,
        metadata={
            "name": "DEFAULT-APPLICATION-TIMEOUT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    environment_variables: Optional["Machine.EnvironmentVariables"] = field(
        default=None,
        metadata={
            "name": "ENVIRONMENT-VARIABLES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    machine_design_ref: Optional["Machine.MachineDesignRef"] = field(
        default=None,
        metadata={
            "name": "MACHINE-DESIGN-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    module_instantiations: Optional["Machine.ModuleInstantiations"] = field(
        default=None,
        metadata={
            "name": "MODULE-INSTANTIATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    processors: Optional["Machine.Processors"] = field(
        default=None,
        metadata={
            "name": "PROCESSORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    secure_communication_deployments: Optional["Machine.SecureCommunicationDeployments"] = field(
        default=None,
        metadata={
            "name": "SECURE-COMMUNICATION-DEPLOYMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trusted_platform_executable_launch_behavior: (
        TrustedPlatformExecutableLaunchBehaviorEnum | None
    ) = field(
        default=None,
        metadata={
            "name": "TRUSTED-PLATFORM-EXECUTABLE-LAUNCH-BEHAVIOR",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class EnvironmentVariables:
        tag_with_optional_value: list[TagWithOptionalValue] = field(
            default_factory=list,
            metadata={
                "name": "TAG-WITH-OPTIONAL-VALUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class MachineDesignRef(Ref):
        dest: MachineDesignSubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )

    @dataclass(slots=True, kw_only=True)
    class ModuleInstantiations:
        adaptive_firewall_module_instantiation: list[AdaptiveFirewallModuleInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "ADAPTIVE-FIREWALL-MODULE-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_module_instantiation: list[CryptoModuleInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-MODULE-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        deterministic_client: list[DeterministicClient] = field(
            default_factory=list,
            metadata={
                "name": "DETERMINISTIC-CLIENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        deterministic_sync_master: list[DeterministicSyncMaster] = field(
            default_factory=list,
            metadata={
                "name": "DETERMINISTIC-SYNC-MASTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_instantiation: list[DoIpInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        generic_module_instantiation: list[GenericModuleInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "GENERIC-MODULE-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        iam_module_instantiation: list[IamModuleInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "IAM-MODULE-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        idsm_module_instantiation: list[IdsmModuleInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "IDSM-MODULE-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        log_and_trace_instantiation: list[LogAndTraceInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "LOG-AND-TRACE-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nm_instantiation: list[NmInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "NM-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        os_module_instantiation: list[OsModuleInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "OS-MODULE-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sovd_gateway_instantiation: list[SovdGatewayInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "SOVD-GATEWAY-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sovd_server_instantiation: list[SovdServerInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "SOVD-SERVER-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        state_management_module_instantiation: list[StateManagementModuleInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-MODULE-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        time_sync_module_instantiation: list[TimeSyncModuleInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "TIME-SYNC-MODULE-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ucm_master_module_instantiation: list[UcmMasterModuleInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "UCM-MASTER-MODULE-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ucm_subordinate_module_instantiation: list[UcmSubordinateModuleInstantiation] = field(
            default_factory=list,
            metadata={
                "name": "UCM-SUBORDINATE-MODULE-INSTANTIATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Processors:
        processor: list[Processor] = field(
            default_factory=list,
            metadata={
                "name": "PROCESSOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SecureCommunicationDeployments:
        sec_oc_deployment: list[SecOcDeployment] = field(
            default_factory=list,
            metadata={
                "name": "SEC-OC-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        tls_deployment: list[TlsDeployment] = field(
            default_factory=list,
            metadata={
                "name": "TLS-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class MsrQueryP1:
    """
    This meta-class represents the ability to express a query which yields the
    content of a topic as a result.

    :ivar msr_query_props: This is argument and properties of the
        paragraph query.
    :ivar msr_query_result_p_1: This represents the result of the query.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    """

    class Meta:
        name = "MSR-QUERY-P-1"

    msr_query_props: MsrQueryProps | None = field(
        default=None,
        metadata={
            "name": "MSR-QUERY-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_result_p_1: TopicContent | None = field(
        default=None,
        metadata={
            "name": "MSR-QUERY-RESULT-P-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class ChapterContent:
    """This class represents the content which is directly in a chapter.

    It is basically the same as the one in a Topic but might have
    additional complex structures (e.g. Synopsis)

    :ivar msr_query_p_1: This represents automatically contributed
        contents provided by an msrquery.
    :ivar msr_query_p_2: This represents automatically contributed
        contents provided by an msrquery in the context of
        DocumentationBlock.
    :ivar p: This is one particular paragraph. The upper multiplicity of
        this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar verbatim: This represents one particular verbatim text. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar list_value: This represents numbered or unnumbered list. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar def_list: This represents a definition list in the
        documentation block. The upper multiplicity of this role has
        been increased to * due to resolving an atpVariation stereotype.
        The previous value was 1.
    :ivar labeled_list: This represents a labeled list. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar formula: This is a formula in the definition block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar figure: This represents a figure in the documentation block.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar note: This represents a note in the text flow. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar trace: This represents traceable text in the documentation
        block. This allows to specify requirements/constraints in any
        documentation block. The kind of the trace is specified in the
        category. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar structured_req: This aggregation supports structured
        requirements embedded in a documentation block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar table: This represents a table within a topic. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar traceable_table: This represents a traceable table within a
        topic.
    :ivar prms: This is a parameter table within a chapter.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CHAPTER-CONTENT"

    msr_query_p_1: list[MsrQueryP1] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_p_2: list[MsrQueryP2] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p: list[MultiLanguageParagraph] = field(
        default_factory=list,
        metadata={
            "name": "P",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: list[MultiLanguageVerbatim] = field(
        default_factory=list,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    list_value: list[ListType] = field(
        default_factory=list,
        metadata={
            "name": "LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_list: list[DefList] = field(
        default_factory=list,
        metadata={
            "name": "DEF-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    labeled_list: list[LabeledList] = field(
        default_factory=list,
        metadata={
            "name": "LABELED-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: list[MlFormula] = field(
        default_factory=list,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    figure: list[MlFigure] = field(
        default_factory=list,
        metadata={
            "name": "FIGURE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    note: list[Note] = field(
        default_factory=list,
        metadata={
            "name": "NOTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace: list[TraceableText] = field(
        default_factory=list,
        metadata={
            "name": "TRACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    structured_req: list[StructuredReq] = field(
        default_factory=list,
        metadata={
            "name": "STRUCTURED-REQ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    table: list[Table] = field(
        default_factory=list,
        metadata={
            "name": "TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    traceable_table: list[TraceableTable] = field(
        default_factory=list,
        metadata={
            "name": "TRACEABLE-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prms: list[Prms] = field(
        default_factory=list,
        metadata={
            "name": "PRMS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Topic1:
    """This meta-class represents a topic of a documentation.

    Topics are similar to chapters but they cannot be nested. They also
    do not appear in the table of content. Topics can be used to produce
    intermediate headlines thus structuring a chapter internally.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar msr_query_p_1: This represents automatically contributed
        contents provided by an msrquery.
    :ivar msr_query_p_2: This represents automatically contributed
        contents provided by an msrquery in the context of
        DocumentationBlock.
    :ivar p: This is one particular paragraph. The upper multiplicity of
        this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar verbatim: This represents one particular verbatim text. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar list_value: This represents numbered or unnumbered list. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar def_list: This represents a definition list in the
        documentation block. The upper multiplicity of this role has
        been increased to * due to resolving an atpVariation stereotype.
        The previous value was 1.
    :ivar labeled_list: This represents a labeled list. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar formula: This is a formula in the definition block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar figure: This represents a figure in the documentation block.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar note: This represents a note in the text flow. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar trace: This represents traceable text in the documentation
        block. This allows to specify requirements/constraints in any
        documentation block. The kind of the trace is specified in the
        category. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar structured_req: This aggregation supports structured
        requirements embedded in a documentation block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar table: This represents a table within a topic. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar traceable_table: This represents a traceable table within a
        topic.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: TopicOrMsrQuery.topic1
        Not Applicable for: MsrQueryResultTopic1.topic1
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    :ivar help_entry: This specifies an entry point in an online help
        system to be linked with the parent class. The syntax shall be
        defined by the applied help system respectively help system
        generator.
    """

    class Meta:
        name = "TOPIC-1"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Topic1.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Topic1.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_p_1: list[MsrQueryP1] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_p_2: list[MsrQueryP2] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p: list[MultiLanguageParagraph] = field(
        default_factory=list,
        metadata={
            "name": "P",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: list[MultiLanguageVerbatim] = field(
        default_factory=list,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    list_value: list[ListType] = field(
        default_factory=list,
        metadata={
            "name": "LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_list: list[DefList] = field(
        default_factory=list,
        metadata={
            "name": "DEF-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    labeled_list: list[LabeledList] = field(
        default_factory=list,
        metadata={
            "name": "LABELED-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: list[MlFormula] = field(
        default_factory=list,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    figure: list[MlFigure] = field(
        default_factory=list,
        metadata={
            "name": "FIGURE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    note: list[Note] = field(
        default_factory=list,
        metadata={
            "name": "NOTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace: list[TraceableText] = field(
        default_factory=list,
        metadata={
            "name": "TRACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    structured_req: list[StructuredReq] = field(
        default_factory=list,
        metadata={
            "name": "STRUCTURED-REQ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    table: list[Table] = field(
        default_factory=list,
        metadata={
            "name": "TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    traceable_table: list[TraceableTable] = field(
        default_factory=list,
        metadata={
            "name": "TRACEABLE-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )
    help_entry: str | None = field(
        default=None,
        metadata={
            "name": "HELP-ENTRY",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TopicContentOrMsrQuery:
    """
    This meta-class represents a topic or a topic content which is generated using
    queries.

    :ivar msr_query_p_1: This represents automatically contributed
        contents provided by an msrquery.
    :ivar msr_query_p_2: This represents automatically contributed
        contents provided by an msrquery in the context of
        DocumentationBlock.
    :ivar p: This is one particular paragraph. The upper multiplicity of
        this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar verbatim: This represents one particular verbatim text. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar list_value: This represents numbered or unnumbered list. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar def_list: This represents a definition list in the
        documentation block. The upper multiplicity of this role has
        been increased to * due to resolving an atpVariation stereotype.
        The previous value was 1.
    :ivar labeled_list: This represents a labeled list. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar formula: This is a formula in the definition block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar figure: This represents a figure in the documentation block.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar note: This represents a note in the text flow. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar trace: This represents traceable text in the documentation
        block. This allows to specify requirements/constraints in any
        documentation block. The kind of the trace is specified in the
        category. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar structured_req: This aggregation supports structured
        requirements embedded in a documentation block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar table: This represents a table within a topic. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar traceable_table: This represents a traceable table within a
        topic.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TOPIC-CONTENT-OR-MSR-QUERY"

    msr_query_p_1: list[MsrQueryP1] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_p_2: list[MsrQueryP2] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p: list[MultiLanguageParagraph] = field(
        default_factory=list,
        metadata={
            "name": "P",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: list[MultiLanguageVerbatim] = field(
        default_factory=list,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    list_value: list[ListType] = field(
        default_factory=list,
        metadata={
            "name": "LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_list: list[DefList] = field(
        default_factory=list,
        metadata={
            "name": "DEF-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    labeled_list: list[LabeledList] = field(
        default_factory=list,
        metadata={
            "name": "LABELED-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: list[MlFormula] = field(
        default_factory=list,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    figure: list[MlFigure] = field(
        default_factory=list,
        metadata={
            "name": "FIGURE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    note: list[Note] = field(
        default_factory=list,
        metadata={
            "name": "NOTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace: list[TraceableText] = field(
        default_factory=list,
        metadata={
            "name": "TRACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    structured_req: list[StructuredReq] = field(
        default_factory=list,
        metadata={
            "name": "STRUCTURED-REQ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    table: list[Table] = field(
        default_factory=list,
        metadata={
            "name": "TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    traceable_table: list[TraceableTable] = field(
        default_factory=list,
        metadata={
            "name": "TRACEABLE-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MsrQueryResultTopic1:
    """
    This metaclass represents the ability to express the result of a query which is
    a set of topics.

    :ivar topic_1: This represents one particular topic in the query
        result. This aggregation contains a variation point although it
        is not variant. Therefore, this variation point shall not exist
        in models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MSR-QUERY-RESULT-TOPIC-1"

    topic_1: list[Topic1] = field(
        default_factory=list,
        metadata={
            "name": "TOPIC-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MsrQueryTopic1:
    """
    This meta-class represents the ability to specify a query which yields a set of
    topics as a result.

    :ivar msr_query_props: This is argument and properties of the topic
        query.
    :ivar msr_query_result_topic_1: This represents the result of the
        query.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    """

    class Meta:
        name = "MSR-QUERY-TOPIC-1"

    msr_query_props: MsrQueryProps | None = field(
        default=None,
        metadata={
            "name": "MSR-QUERY-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_result_topic_1: MsrQueryResultTopic1 | None = field(
        default=None,
        metadata={
            "name": "MSR-QUERY-RESULT-TOPIC-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class Chapter:
    """This meta-class represents a chapter of a document.

    Chapters are the primary structuring element in documentation.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar msr_query_p_1: This represents automatically contributed
        contents provided by an msrquery.
    :ivar msr_query_p_2: This represents automatically contributed
        contents provided by an msrquery in the context of
        DocumentationBlock.
    :ivar p: This is one particular paragraph. The upper multiplicity of
        this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar verbatim: This represents one particular verbatim text. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar list_value: This represents numbered or unnumbered list. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar def_list: This represents a definition list in the
        documentation block. The upper multiplicity of this role has
        been increased to * due to resolving an atpVariation stereotype.
        The previous value was 1.
    :ivar labeled_list: This represents a labeled list. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar formula: This is a formula in the definition block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar figure: This represents a figure in the documentation block.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar note: This represents a note in the text flow. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar trace: This represents traceable text in the documentation
        block. This allows to specify requirements/constraints in any
        documentation block. The kind of the trace is specified in the
        category. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar structured_req: This aggregation supports structured
        requirements embedded in a documentation block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar table: This represents a table within a topic. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar traceable_table: This represents a traceable table within a
        topic.
    :ivar prms: This is a parameter table within a chapter.
    :ivar topic_1: This is used to create particular topics within a
        chapter. A topic is similar to a subchapter, but cannot be
        nested and will not appear in the table of contents of the
        document. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar msr_query_topic_1: This represents automatically contributed
        topics provided by an msrquery.
    :ivar chapter: This establishes a subschapter. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar msr_query_chapter: This represents automatically contributed
        chapters provided by an msrquery.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwComponentDocumentation.chapter Applicable for:
        System.systemDocumentation Applicable for:
        ChapterOrMsrQuery.chapter Not Applicable for:
        SwComponentDocumentation.swCalibrationNotes Not Applicable for:
        SwComponentDocumentation.swFeatureDesc Not Applicable for:
        SwComponentDocumentation.swCarbDoc Not Applicable for:
        SwComponentDocumentation.swFeatureDef Not Applicable for:
        SwComponentDocumentation.swTestDesc Not Applicable for:
        SwComponentDocumentation.swDiagnosticsNotes Not Applicable for:
        SwComponentDocumentation.swMaintenanceNotes Not Applicable for:
        MsrQueryResultChapter.chapter
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    :ivar help_entry: This specifies an entry point in an online help
        system to be linked with the parent class. The syntax shall be
        defined by the applied help system respectively help system
        generator. Maybe it is a concatenated Identifier, but as of now
        we leave it as an arbitrary string.
    """

    class Meta:
        name = "CHAPTER"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Chapter.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Chapter.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_p_1: list[MsrQueryP1] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_p_2: list[MsrQueryP2] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p: list[MultiLanguageParagraph] = field(
        default_factory=list,
        metadata={
            "name": "P",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: list[MultiLanguageVerbatim] = field(
        default_factory=list,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    list_value: list[ListType] = field(
        default_factory=list,
        metadata={
            "name": "LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_list: list[DefList] = field(
        default_factory=list,
        metadata={
            "name": "DEF-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    labeled_list: list[LabeledList] = field(
        default_factory=list,
        metadata={
            "name": "LABELED-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: list[MlFormula] = field(
        default_factory=list,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    figure: list[MlFigure] = field(
        default_factory=list,
        metadata={
            "name": "FIGURE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    note: list[Note] = field(
        default_factory=list,
        metadata={
            "name": "NOTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace: list[TraceableText] = field(
        default_factory=list,
        metadata={
            "name": "TRACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    structured_req: list[StructuredReq] = field(
        default_factory=list,
        metadata={
            "name": "STRUCTURED-REQ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    table: list[Table] = field(
        default_factory=list,
        metadata={
            "name": "TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    traceable_table: list[TraceableTable] = field(
        default_factory=list,
        metadata={
            "name": "TRACEABLE-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prms: list[Prms] = field(
        default_factory=list,
        metadata={
            "name": "PRMS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    topic_1: list[Topic1] = field(
        default_factory=list,
        metadata={
            "name": "TOPIC-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_topic_1: list[MsrQueryTopic1] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-TOPIC-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    chapter: list["Chapter"] = field(
        default_factory=list,
        metadata={
            "name": "CHAPTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_chapter: list["MsrQueryChapter"] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-CHAPTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )
    help_entry: str | None = field(
        default=None,
        metadata={
            "name": "HELP-ENTRY",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class TopicOrMsrQuery:
    """
    This class provides the alternative of a Topic with an MsrQuery which delivers
    a topic.

    :ivar topic_1: This is used to create particular topics within a
        chapter. A topic is similar to a subchapter, but cannot be
        nested and will not appear in the table of contents of the
        document. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar msr_query_topic_1: This represents automatically contributed
        topics provided by an msrquery.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "TOPIC-OR-MSR-QUERY"

    topic_1: list[Topic1] = field(
        default_factory=list,
        metadata={
            "name": "TOPIC-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_topic_1: list[MsrQueryTopic1] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-TOPIC-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class MsrQueryResultChapter:
    """
    This metaclass represents the result of an msrquery which is a set of chapters.

    :ivar chapter: This is one particular chapter in the query result.
        This aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "MSR-QUERY-RESULT-CHAPTER"

    chapter: list[Chapter] = field(
        default_factory=list,
        metadata={
            "name": "CHAPTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class SwComponentDocumentation:
    """
    This class specifies the ability to write dedicated documentation to a
    component type according to ASAM FSX.

    :ivar sw_feature_def: This element contains the definition of the
        physical functionality of this software component. This
        definition is more or less formal and is intended to be
        delivered from modeling tools. This aggregation contains a
        variation point although it is not variant. Therefore, this
        variation point shall not exist in models. See constr_2638.
    :ivar sw_feature_desc: This element contains the textual description
        of the software functionality of this software component. Expert
        should write this description. This aggregation contains a
        variation point although it is not variant. Therefore, this
        variation point shall not exist in models. See constr_2638.
    :ivar sw_test_desc: This element contains suggestions and hints for
        the test of the software functionality of this software
        component. This aggregation contains a variation point although
        it is not variant. Therefore, this variation point shall not
        exist in models. See constr_2638.
    :ivar sw_calibration_notes: This element contains calibration
        instructions and hints for a calibration engineer. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar sw_maintenance_notes: This element contains information
        regarding the software maintenance of the component. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar sw_diagnostics_notes: This element contains general
        information about diagnostics issues within the component. This
        aggregation contains a variation point although it is not
        variant. Therefore, this variation point shall not exist in
        models. See constr_2638.
    :ivar sw_carb_doc: This element records the documentation requested
        by CARB. This aggregation contains a variation point although it
        is not variant. Therefore, this variation point shall not exist
        in models. See constr_2638.
    :ivar chapter: These chapters provide additional information about
        the software component that do not fit in the other chapters.
        Note that this is subject to variation because Chapter
        aggregations in the role chapter are variant within the
        documentation in general.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for:
        SwComponentType.swComponentDocumentation Applicable for:
        BswModuleDescription.bswModuleDocumentation
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SW-COMPONENT-DOCUMENTATION"

    sw_feature_def: Chapter | None = field(
        default=None,
        metadata={
            "name": "SW-FEATURE-DEF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_feature_desc: Chapter | None = field(
        default=None,
        metadata={
            "name": "SW-FEATURE-DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_test_desc: Chapter | None = field(
        default=None,
        metadata={
            "name": "SW-TEST-DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_calibration_notes: Chapter | None = field(
        default=None,
        metadata={
            "name": "SW-CALIBRATION-NOTES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_maintenance_notes: Chapter | None = field(
        default=None,
        metadata={
            "name": "SW-MAINTENANCE-NOTES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_diagnostics_notes: Chapter | None = field(
        default=None,
        metadata={
            "name": "SW-DIAGNOSTICS-NOTES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_carb_doc: Chapter | None = field(
        default=None,
        metadata={
            "name": "SW-CARB-DOC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    chapter: list[Chapter] = field(
        default_factory=list,
        metadata={
            "name": "CHAPTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class System:
    """'''begin restrict to CP''' The top level element of the System Description.

    The System description defines five major elements: Topology, Software, Communication, Mapping and Mapping Constraints.
    The System element directly aggregates the elements describing the Software, Mapping and Mapping Constraints; it contains a reference to an ASAM FIBEX description specifying Communication and Topology.
    '''end restrict to CP'''
    '''begin restrict to AP'''
    The top level element of the System Description.
    '''end restrict to AP'''
    '''begin restrict to FO'''
    The top level element of the Abstract Platform System Description.
    '''end restrict to FO'''

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar system_documentations: Possibility to provide additional
        documentation while defining the System. The System
        documentation can be composed of several chapters.
    :ivar client_id_definition_set_refs: Set of Client Identifiers that
        are used for inter-ECU client-server communication in the
        System.
    :ivar container_i_pdu_header_byte_order: Defines the byteOrder of
        the header in ContainerIPdus.
    :ivar ecu_extract_version: Version number of the Ecu Extract.
    :ivar fibex_elements: This property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar interpolation_routine_mapping_set_refs: This reference
        identifies the InterpolationRoutineMappingSets that are relevant
        in the context of the enclosing System.
    :ivar j_1939_shared_address_clusters: Collection of J1939Clusters
        that share a common address space for the routing of messages.
    :ivar mappings: '''begin restrict to CP''' Aggregation of all
        mapping aspects (mapping of SW components to ECUs, mapping of
        data elements to signals, and mapping constraints). In order to
        support OEM / Tier 1 interaction and shared development for one
        common System this aggregation is atpSplitable and atpVariation.
        The content of SystemMapping can be provided by several parties
        using different names for the SystemMapping. This element is not
        required when the System description is used for a network-only
        use-case. '''end restrict to CP''' '''begin restrict to AP'''
        Aggregation of all mapping aspects relevant in the System
        Description. '''end restrict to AP'''
    :ivar pnc_vector_length: Length of the partial networking request
        release information vector (in bytes).
    :ivar pnc_vector_offset: Absolute offset (with respect to the NM-
        PDU) of the partial networking request release information
        vector that is defined in bytes as an index starting with 0.
    :ivar root_software_compositions: '''begin restrict to CP AP'''
        Aggregation of the root software composition, containing all
        software components in the System in a hierarchical structure.
        This element is not required when the System description is used
        for a network-only use-case. atpVariation: The
        RootSwCompositionPrototype can vary. '''end restrict to CP AP'''
        '''begin restrict to FO''' Aggregation of the root software
        composition, containing all software components in the System in
        a hierarchical structure. '''end restrict to FO''' The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar sw_clusters: CP Software Clusters of this System This property
        was modified due to atpVariation (DirectedAssociationPattern).
    :ivar system_version: Version number of the System Description.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SYSTEM"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["System.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["System.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_documentations: Optional["System.SystemDocumentations"] = field(
        default=None,
        metadata={
            "name": "SYSTEM-DOCUMENTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    client_id_definition_set_refs: Optional["System.ClientIdDefinitionSetRefs"] = field(
        default=None,
        metadata={
            "name": "CLIENT-ID-DEFINITION-SET-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    container_i_pdu_header_byte_order: ByteOrderEnum | None = field(
        default=None,
        metadata={
            "name": "CONTAINER-I-PDU-HEADER-BYTE-ORDER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ecu_extract_version: RevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "ECU-EXTRACT-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    fibex_elements: Optional["System.FibexElements"] = field(
        default=None,
        metadata={
            "name": "FIBEX-ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    interpolation_routine_mapping_set_refs: Optional[
        "System.InterpolationRoutineMappingSetRefs"
    ] = field(
        default=None,
        metadata={
            "name": "INTERPOLATION-ROUTINE-MAPPING-SET-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    j_1939_shared_address_clusters: Optional["System.J1939SharedAddressClusters"] = field(
        default=None,
        metadata={
            "name": "J-1939-SHARED-ADDRESS-CLUSTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    mappings: Optional["System.Mappings"] = field(
        default=None,
        metadata={
            "name": "MAPPINGS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_vector_length: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PNC-VECTOR-LENGTH",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    pnc_vector_offset: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "PNC-VECTOR-OFFSET",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    root_software_compositions: Optional["System.RootSoftwareCompositions"] = field(
        default=None,
        metadata={
            "name": "ROOT-SOFTWARE-COMPOSITIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_clusters: Optional["System.SwClusters"] = field(
        default=None,
        metadata={
            "name": "SW-CLUSTERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    system_version: RevisionLabelString | None = field(
        default=None,
        metadata={
            "name": "SYSTEM-VERSION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SystemDocumentations:
        chapter: list[Chapter] = field(
            default_factory=list,
            metadata={
                "name": "CHAPTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ClientIdDefinitionSetRefs:
        client_id_definition_set_ref: list[
            "System.ClientIdDefinitionSetRefs.ClientIdDefinitionSetRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-ID-DEFINITION-SET-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ClientIdDefinitionSetRef(Ref):
            dest: ClientIdDefinitionSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class FibexElements:
        fibex_element_ref_conditional: list[FibexElementRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "FIBEX-ELEMENT-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InterpolationRoutineMappingSetRefs:
        interpolation_routine_mapping_set_ref: list[
            "System.InterpolationRoutineMappingSetRefs.InterpolationRoutineMappingSetRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "INTERPOLATION-ROUTINE-MAPPING-SET-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class InterpolationRoutineMappingSetRef(Ref):
            dest: InterpolationRoutineMappingSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class J1939SharedAddressClusters:
        j_1939_shared_address_cluster: list[J1939SharedAddressCluster] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-SHARED-ADDRESS-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Mappings:
        system_mapping: list[SystemMapping] = field(
            default_factory=list,
            metadata={
                "name": "SYSTEM-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RootSoftwareCompositions:
        root_sw_composition_prototype: list[RootSwCompositionPrototype] = field(
            default_factory=list,
            metadata={
                "name": "ROOT-SW-COMPOSITION-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwClusters:
        cp_software_cluster_ref_conditional: list[CpSoftwareClusterRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "CP-SOFTWARE-CLUSTER-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class AdaptiveApplicationSwComponentType:
    """This meta-class represents the ability to support the formal modeling of
    application software on the AUTOSAR adaptive platform.

    Consequently, it shall only be used on the AUTOSAR adaptive
    platform.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar sw_component_documentations: This adds a documentation to the
        SwComponentType. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar consistency_needss: This represents the collection of
        ConsistencyNeeds owned by the enclosing SwComponentType.
    :ivar ports: The PortPrototypes through which this SwComponentType
        can communicate. The aggregation of PortPrototype is subject to
        variability with the purpose to support the conditional
        existence of PortPrototypes.
    :ivar port_groups: A port group being part of this component.
    :ivar swc_mapping_constraint_refs: Reference to constraints that are
        valid for this SwComponentType.
    :ivar unit_group_refs: This allows for the specification of which
        UnitGroups are relevant in the context of referencing
        SwComponentType.
    :ivar internal_behaviors: This aggregation represents the internal
        behavior of the AdaptiveApplicationSwComponentType for the
        AUTOSAR adaptive platform. The upper multiplicity of this role
        has been increased to * due to resolving an atpVariation
        stereotype. The previous value was 1.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ADAPTIVE-APPLICATION-SW-COMPONENT-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["AdaptiveApplicationSwComponentType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["AdaptiveApplicationSwComponentType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["AdaptiveApplicationSwComponentType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_documentations: Optional[
        "AdaptiveApplicationSwComponentType.SwComponentDocumentations"
    ] = field(
        default=None,
        metadata={
            "name": "SW-COMPONENT-DOCUMENTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consistency_needss: Optional["AdaptiveApplicationSwComponentType.ConsistencyNeedss"] = field(
        default=None,
        metadata={
            "name": "CONSISTENCY-NEEDSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ports: Optional["AdaptiveApplicationSwComponentType.Ports"] = field(
        default=None,
        metadata={
            "name": "PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_groups: Optional["AdaptiveApplicationSwComponentType.PortGroups"] = field(
        default=None,
        metadata={
            "name": "PORT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_mapping_constraint_refs: Optional[
        "AdaptiveApplicationSwComponentType.SwcMappingConstraintRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SWC-MAPPING-CONSTRAINT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_group_refs: Optional["AdaptiveApplicationSwComponentType.UnitGroupRefs"] = field(
        default=None,
        metadata={
            "name": "UNIT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    internal_behaviors: Optional["AdaptiveApplicationSwComponentType.InternalBehaviors"] = field(
        default=None,
        metadata={
            "name": "INTERNAL-BEHAVIORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwComponentDocumentations:
        sw_component_documentation: list[SwComponentDocumentation] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMPONENT-DOCUMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConsistencyNeedss:
        consistency_needs: list[ConsistencyNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CONSISTENCY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Ports:
        p_port_prototype: list[PPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "P-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        pr_port_prototype: list[PrPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PR-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        r_port_prototype: list[RPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "R-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortGroups:
        port_group: list[PortGroup] = field(
            default_factory=list,
            metadata={
                "name": "PORT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcMappingConstraintRefs:
        swc_mapping_constraint_ref: list[
            "AdaptiveApplicationSwComponentType.SwcMappingConstraintRefs.SwcMappingConstraintRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SwcMappingConstraintRef(Ref):
            dest: SwComponentMappingConstraintsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class UnitGroupRefs:
        unit_group_ref: list["AdaptiveApplicationSwComponentType.UnitGroupRefs.UnitGroupRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "UNIT-GROUP-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class UnitGroupRef(Ref):
            dest: UnitGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class InternalBehaviors:
        adaptive_swc_internal_behavior: list[AdaptiveSwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "ADAPTIVE-SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ApplicationSwComponentType:
    """
    The ApplicationSwComponentType is used to represent the application software.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar sw_component_documentations: This adds a documentation to the
        SwComponentType. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar consistency_needss: This represents the collection of
        ConsistencyNeeds owned by the enclosing SwComponentType.
    :ivar ports: The PortPrototypes through which this SwComponentType
        can communicate. The aggregation of PortPrototype is subject to
        variability with the purpose to support the conditional
        existence of PortPrototypes.
    :ivar port_groups: A port group being part of this component.
    :ivar swc_mapping_constraint_refs: Reference to constraints that are
        valid for this SwComponentType.
    :ivar unit_group_refs: This allows for the specification of which
        UnitGroups are relevant in the context of referencing
        SwComponentType.
    :ivar internal_behaviors: The SwcInternalBehaviors owned by an
        AtomicSwComponentType can be located in a different physical
        file. Therefore the aggregation is &lt;&lt;atpSplitable&gt;&gt;.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar symbol_props: This represents the SymbolProps for the
        AtomicSwComponentType.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "APPLICATION-SW-COMPONENT-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ApplicationSwComponentType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ApplicationSwComponentType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ApplicationSwComponentType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_documentations: Optional[
        "ApplicationSwComponentType.SwComponentDocumentations"
    ] = field(
        default=None,
        metadata={
            "name": "SW-COMPONENT-DOCUMENTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consistency_needss: Optional["ApplicationSwComponentType.ConsistencyNeedss"] = field(
        default=None,
        metadata={
            "name": "CONSISTENCY-NEEDSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ports: Optional["ApplicationSwComponentType.Ports"] = field(
        default=None,
        metadata={
            "name": "PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_groups: Optional["ApplicationSwComponentType.PortGroups"] = field(
        default=None,
        metadata={
            "name": "PORT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_mapping_constraint_refs: Optional["ApplicationSwComponentType.SwcMappingConstraintRefs"] = (
        field(
            default=None,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    unit_group_refs: Optional["ApplicationSwComponentType.UnitGroupRefs"] = field(
        default=None,
        metadata={
            "name": "UNIT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    internal_behaviors: Optional["ApplicationSwComponentType.InternalBehaviors"] = field(
        default=None,
        metadata={
            "name": "INTERNAL-BEHAVIORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol_props: SymbolProps | None = field(
        default=None,
        metadata={
            "name": "SYMBOL-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwComponentDocumentations:
        sw_component_documentation: list[SwComponentDocumentation] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMPONENT-DOCUMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConsistencyNeedss:
        consistency_needs: list[ConsistencyNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CONSISTENCY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Ports:
        p_port_prototype: list[PPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "P-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        pr_port_prototype: list[PrPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PR-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        r_port_prototype: list[RPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "R-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortGroups:
        port_group: list[PortGroup] = field(
            default_factory=list,
            metadata={
                "name": "PORT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcMappingConstraintRefs:
        swc_mapping_constraint_ref: list[
            "ApplicationSwComponentType.SwcMappingConstraintRefs.SwcMappingConstraintRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SwcMappingConstraintRef(Ref):
            dest: SwComponentMappingConstraintsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class UnitGroupRefs:
        unit_group_ref: list["ApplicationSwComponentType.UnitGroupRefs.UnitGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "UNIT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class UnitGroupRef(Ref):
            dest: UnitGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class InternalBehaviors:
        swc_internal_behavior: list[SwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class BswModuleDescription:
    """Root element for the description of a single BSW module or BSW cluster.

    In case it describes a BSW module, the short name of this element
    equals the name of the BSW module.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar expected_entrys: Indicates an entry which is required by this
        module. Replacement of outgoingCallback / requiredEntry. This
        property was modified due to atpVariation
        (DirectedAssociationPattern).
    :ivar implemented_entrys: Specifies an entry provided by this module
        which can be called by other modules. This includes "main"
        functions, interrupt routines, and callbacks. Replacement of
        providedEntry / expectedCallback. This property was modified due
        to atpVariation (DirectedAssociationPattern).
    :ivar module_id: Refers to the BSW Module Identifier defined by the
        AUTOSAR standard. For non-standardized modules, a proprietary
        identifier can be optionally chosen.
    :ivar bsw_module_documentations: This adds a documentation to the
        BSW module. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar provided_entrys: Specifies an entry provided by this module
        which can be called by other modules. This includes "main"
        functions and interrupt routines, but not callbacks (because the
        signature of a callback is defined by the caller). This property
        was modified due to atpVariation (DirectedAssociationPattern).
    :ivar outgoing_callbacks: Specifies a callback, which will be called
        from this module if required by another module. This property
        was modified due to atpVariation (DirectedAssociationPattern).
    :ivar bsw_module_dependencys: Describes the dependency to another
        BSW module.
    :ivar provided_mode_groups: A set of modes which is owned and
        provided by this module or cluster. It can be connected to the
        requiredModeGroups of other modules or clusters via the
        configuration of the BswScheduler. It can also be synchronized
        with modes provided via ports by an associated
        ServiceSwComponentType, EcuAbstractionSwComponentType or
        ComplexDeviceDriverSwComponentType.
    :ivar required_mode_groups: Specifies that this module or cluster
        depends on a certain mode group. The requiredModeGroup is local
        to  this context and will be connected to the providedModeGroup
        of another module or cluster via the configuration of the
        BswScheduler.
    :ivar released_triggers: A Trigger released by this module or
        cluster. It can be connected to the requiredTriggers of other
        modules or clusters via the configuration of the BswScheduler.
        It can also be synchronized with Triggers provided via ports by
        an associated ServiceSwComponentType,
        EcuAbstractionSwComponentType or
        ComplexDeviceDriverSwComponentType.
    :ivar required_triggers: Specifies that this module or cluster
        reacts upon an external trigger.This requiredTrigger is declared
        locally to this context and will be connected to the
        providedTrigger of another module or cluster via the
        configuration of the BswScheduler.
    :ivar provided_client_server_entrys: Specifies that this module
        provides a client server entry which can be called from another
        partition or core.This entry is declared locally to this context
        and will be connected to the requiredClientServerEntry of
        another or the same module via the configuration of the BSW
        Scheduler.
    :ivar required_client_server_entrys: Specifies that this module
        requires a client server entry which can be implemented on
        another partition or core.This entry is declared locally to this
        context and will be connected to the providedClientServerEntry
        of another or the same module via the configuration of the BSW
        Scheduler.
    :ivar provided_datas: Specifies a data prototype provided by this
        module in order to be read  from another partition or core.The
        providedData is declared locally to this context and will be
        connected to the requiredData of another or the same module via
        the configuration of the BSW Scheduler.
    :ivar required_datas: Specifies a data prototype required by this
        module in oder to be provided from another partition or core.The
        requiredData is declared locally to this context and will be
        connected to the providedData of another or the same module via
        the configuration of the BswScheduler.
    :ivar internal_behaviors: The various BswInternalBehaviors
        associated with a BswModuleDescription can be distributed over
        several physical files. Therefore the aggregation is
        &lt;&lt;atpSplitable&gt;&gt;.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "BSW-MODULE-DESCRIPTION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["BswModuleDescription.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["BswModuleDescription.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["BswModuleDescription.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    expected_entrys: Optional["BswModuleDescription.ExpectedEntrys"] = field(
        default=None,
        metadata={
            "name": "EXPECTED-ENTRYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    implemented_entrys: Optional["BswModuleDescription.ImplementedEntrys"] = field(
        default=None,
        metadata={
            "name": "IMPLEMENTED-ENTRYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    module_id: PositiveInteger | None = field(
        default=None,
        metadata={
            "name": "MODULE-ID",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_module_documentations: Optional["BswModuleDescription.BswModuleDocumentations"] = field(
        default=None,
        metadata={
            "name": "BSW-MODULE-DOCUMENTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_entrys: Optional["BswModuleDescription.ProvidedEntrys"] = field(
        default=None,
        metadata={
            "name": "PROVIDED-ENTRYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    outgoing_callbacks: Optional["BswModuleDescription.OutgoingCallbacks"] = field(
        default=None,
        metadata={
            "name": "OUTGOING-CALLBACKS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bsw_module_dependencys: Optional["BswModuleDescription.BswModuleDependencys"] = field(
        default=None,
        metadata={
            "name": "BSW-MODULE-DEPENDENCYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_mode_groups: Optional["BswModuleDescription.ProvidedModeGroups"] = field(
        default=None,
        metadata={
            "name": "PROVIDED-MODE-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_mode_groups: Optional["BswModuleDescription.RequiredModeGroups"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-MODE-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    released_triggers: Optional["BswModuleDescription.ReleasedTriggers"] = field(
        default=None,
        metadata={
            "name": "RELEASED-TRIGGERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_triggers: Optional["BswModuleDescription.RequiredTriggers"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-TRIGGERS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    provided_client_server_entrys: Optional["BswModuleDescription.ProvidedClientServerEntrys"] = (
        field(
            default=None,
            metadata={
                "name": "PROVIDED-CLIENT-SERVER-ENTRYS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    required_client_server_entrys: Optional["BswModuleDescription.RequiredClientServerEntrys"] = (
        field(
            default=None,
            metadata={
                "name": "REQUIRED-CLIENT-SERVER-ENTRYS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    provided_datas: Optional["BswModuleDescription.ProvidedDatas"] = field(
        default=None,
        metadata={
            "name": "PROVIDED-DATAS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    required_datas: Optional["BswModuleDescription.RequiredDatas"] = field(
        default=None,
        metadata={
            "name": "REQUIRED-DATAS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    internal_behaviors: Optional["BswModuleDescription.InternalBehaviors"] = field(
        default=None,
        metadata={
            "name": "INTERNAL-BEHAVIORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ExpectedEntrys:
        bsw_module_entry_ref_conditional: list[BswModuleEntryRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-ENTRY-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ImplementedEntrys:
        bsw_module_entry_ref_conditional: list[BswModuleEntryRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-ENTRY-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BswModuleDocumentations:
        sw_component_documentation: list[SwComponentDocumentation] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMPONENT-DOCUMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedEntrys:
        bsw_module_entry_ref_conditional: list[BswModuleEntryRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-ENTRY-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class OutgoingCallbacks:
        bsw_module_entry_ref_conditional: list[BswModuleEntryRefConditional] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-ENTRY-REF-CONDITIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BswModuleDependencys:
        bsw_module_dependency: list[BswModuleDependency] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-DEPENDENCY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedModeGroups:
        mode_declaration_group_prototype: list[ModeDeclarationGroupPrototype] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-GROUP-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredModeGroups:
        mode_declaration_group_prototype: list[ModeDeclarationGroupPrototype] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-GROUP-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ReleasedTriggers:
        trigger: list[Trigger] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredTriggers:
        trigger: list[Trigger] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedClientServerEntrys:
        bsw_module_client_server_entry: list[BswModuleClientServerEntry] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-CLIENT-SERVER-ENTRY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredClientServerEntrys:
        bsw_module_client_server_entry: list[BswModuleClientServerEntry] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-CLIENT-SERVER-ENTRY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ProvidedDatas:
        variable_data_prototype: list[VariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class RequiredDatas:
        variable_data_prototype: list[VariableDataPrototype] = field(
            default_factory=list,
            metadata={
                "name": "VARIABLE-DATA-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class InternalBehaviors:
        bsw_internal_behavior: list[BswInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "BSW-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ComplexDeviceDriverSwComponentType:
    """The ComplexDeviceDriverSwComponentType is a special AtomicSwComponentType
    that has direct access to hardware on an ECU and which is therefore linked to a
    specific ECU or specific hardware.

    The ComplexDeviceDriverSwComponentType introduces the possibility to
    link from the software representation to its hardware description
    provided by the ECU Resource Template.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar sw_component_documentations: This adds a documentation to the
        SwComponentType. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar consistency_needss: This represents the collection of
        ConsistencyNeeds owned by the enclosing SwComponentType.
    :ivar ports: The PortPrototypes through which this SwComponentType
        can communicate. The aggregation of PortPrototype is subject to
        variability with the purpose to support the conditional
        existence of PortPrototypes.
    :ivar port_groups: A port group being part of this component.
    :ivar swc_mapping_constraint_refs: Reference to constraints that are
        valid for this SwComponentType.
    :ivar unit_group_refs: This allows for the specification of which
        UnitGroups are relevant in the context of referencing
        SwComponentType.
    :ivar internal_behaviors: The SwcInternalBehaviors owned by an
        AtomicSwComponentType can be located in a different physical
        file. Therefore the aggregation is &lt;&lt;atpSplitable&gt;&gt;.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar symbol_props: This represents the SymbolProps for the
        AtomicSwComponentType.
    :ivar hardware_element_refs: Reference from the
        ComplexDeviceDriverSwComponentType to the description of the
        used HwElements.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPLEX-DEVICE-DRIVER-SW-COMPONENT-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ComplexDeviceDriverSwComponentType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ComplexDeviceDriverSwComponentType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ComplexDeviceDriverSwComponentType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_documentations: Optional[
        "ComplexDeviceDriverSwComponentType.SwComponentDocumentations"
    ] = field(
        default=None,
        metadata={
            "name": "SW-COMPONENT-DOCUMENTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consistency_needss: Optional["ComplexDeviceDriverSwComponentType.ConsistencyNeedss"] = field(
        default=None,
        metadata={
            "name": "CONSISTENCY-NEEDSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ports: Optional["ComplexDeviceDriverSwComponentType.Ports"] = field(
        default=None,
        metadata={
            "name": "PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_groups: Optional["ComplexDeviceDriverSwComponentType.PortGroups"] = field(
        default=None,
        metadata={
            "name": "PORT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_mapping_constraint_refs: Optional[
        "ComplexDeviceDriverSwComponentType.SwcMappingConstraintRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SWC-MAPPING-CONSTRAINT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_group_refs: Optional["ComplexDeviceDriverSwComponentType.UnitGroupRefs"] = field(
        default=None,
        metadata={
            "name": "UNIT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    internal_behaviors: Optional["ComplexDeviceDriverSwComponentType.InternalBehaviors"] = field(
        default=None,
        metadata={
            "name": "INTERNAL-BEHAVIORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol_props: SymbolProps | None = field(
        default=None,
        metadata={
            "name": "SYMBOL-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hardware_element_refs: Optional["ComplexDeviceDriverSwComponentType.HardwareElementRefs"] = (
        field(
            default=None,
            metadata={
                "name": "HARDWARE-ELEMENT-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwComponentDocumentations:
        sw_component_documentation: list[SwComponentDocumentation] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMPONENT-DOCUMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConsistencyNeedss:
        consistency_needs: list[ConsistencyNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CONSISTENCY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Ports:
        p_port_prototype: list[PPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "P-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        pr_port_prototype: list[PrPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PR-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        r_port_prototype: list[RPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "R-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortGroups:
        port_group: list[PortGroup] = field(
            default_factory=list,
            metadata={
                "name": "PORT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcMappingConstraintRefs:
        swc_mapping_constraint_ref: list[
            "ComplexDeviceDriverSwComponentType.SwcMappingConstraintRefs.SwcMappingConstraintRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SwcMappingConstraintRef(Ref):
            dest: SwComponentMappingConstraintsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class UnitGroupRefs:
        unit_group_ref: list["ComplexDeviceDriverSwComponentType.UnitGroupRefs.UnitGroupRef"] = (
            field(
                default_factory=list,
                metadata={
                    "name": "UNIT-GROUP-REF",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )

        @dataclass(slots=True, kw_only=True)
        class UnitGroupRef(Ref):
            dest: UnitGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class InternalBehaviors:
        swc_internal_behavior: list[SwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HardwareElementRefs:
        hardware_element_ref: list[
            "ComplexDeviceDriverSwComponentType.HardwareElementRefs.HardwareElementRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "HARDWARE-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class HardwareElementRef(Ref):
            dest: HwDescriptionEntitySubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class CompositionSwComponentType:
    """A CompositionSwComponentType aggregates SwComponentPrototypes (that in turn
    are typed by SwComponentTypes) as well as SwConnectors for primarily connecting
    SwComponentPrototypes among each others and towards the surface of the
    CompositionSwComponentType.

    By this means, hierarchical structures of software-components can be
    created.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar sw_component_documentations: This adds a documentation to the
        SwComponentType. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar consistency_needss: This represents the collection of
        ConsistencyNeeds owned by the enclosing SwComponentType.
    :ivar ports: The PortPrototypes through which this SwComponentType
        can communicate. The aggregation of PortPrototype is subject to
        variability with the purpose to support the conditional
        existence of PortPrototypes.
    :ivar port_groups: A port group being part of this component.
    :ivar swc_mapping_constraint_refs: Reference to constraints that are
        valid for this SwComponentType.
    :ivar unit_group_refs: This allows for the specification of which
        UnitGroups are relevant in the context of referencing
        SwComponentType.
    :ivar components: '''begin restrict to CP''' The instantiated
        components that are part of this composition. The aggregation of
        SwComponentPrototype is subject to variability with the purpose
        to support the conditional existence of a SwComponentPrototype.
        Please be aware: if the conditional existence of
        SwComponentPrototypes is resolved post-build the deselected
        SwComponentPrototypes are still contained in the ECUs build but
        the instances are inactive in that they are not scheduled by the
        RTE. The aggregation is marked as atpSplitable in order to allow
        the addition of service components to the ECU extract during the
        ECU integration. The use case for having 0 components owned by
        the CompositionSwComponentType could be to deliver an empty
        CompositionSwComponentType to e.g. a supplier for filling the
        internal structure. '''end restrict to CP''' '''begin restrict
        to AP''' The instantiated components that are part of this
        composition. '''end restrict to AP'''
    :ivar connectors: SwConnectors have the principal ability to
        establish a connection among PortPrototypes. They can have many
        roles in the context of a CompositionSwComponentType. Details
        are refined by subclasses. The aggregation of SwConnectors is
        subject to variability with the purpose to support variant data
        flow. '''begin restrict to CP AP''' The aggregation is marked as
        atpSplitable in order to allow the extension of the ECU extract
        with AssemblySwConnectors between ApplicationSwComponentTypes
        and ServiceSwComponentTypes during the ECU integration. '''end
        restrict to CP AP'''
    :ivar constant_value_mapping_refs: Reference to the
        ConstantSpecificationMapping to be applied for initValues of
        PPortComSpecs and RPortComSpec.
    :ivar data_type_mapping_refs: '''begin restrict to CP''' Reference
        to the DataTypeMapping to be applied for the used
        ApplicationDataTypes in PortInterfaces. Background: when
        developing subsystems it may happen that ApplicationDataTypes
        are used on the surface of CompositionSwComponentTypes. In this
        case it would be reasonable to be able to also provide the
        intended mapping to the ImplementationDataTypes. However, this
        mapping shall be informal and not technically binding for the
        implementors mainly because the RTE generator is not concerned
        about the CompositionSwComponentTypes. Rationale: if the mapping
        of ApplicationDataTypes on the delegated and inner PortPrototype
        matches then the mapping to ImplementationDataTypes is not
        impacting compatibility. '''end restrict to CP''' '''begin
        restrict to AP''' Reference to the DataTypeMapping to be applied
        for the used ApplicationDataTypes in ServiceInterfaces. '''end
        restrict to AP'''
    :ivar instantiation_rte_event_propss: This allows to define
        instantiation specific properties for RTE Events, in particular
        for instance specific scheduling.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "COMPOSITION-SW-COMPONENT-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["CompositionSwComponentType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["CompositionSwComponentType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["CompositionSwComponentType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_documentations: Optional[
        "CompositionSwComponentType.SwComponentDocumentations"
    ] = field(
        default=None,
        metadata={
            "name": "SW-COMPONENT-DOCUMENTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consistency_needss: Optional["CompositionSwComponentType.ConsistencyNeedss"] = field(
        default=None,
        metadata={
            "name": "CONSISTENCY-NEEDSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ports: Optional["CompositionSwComponentType.Ports"] = field(
        default=None,
        metadata={
            "name": "PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_groups: Optional["CompositionSwComponentType.PortGroups"] = field(
        default=None,
        metadata={
            "name": "PORT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_mapping_constraint_refs: Optional["CompositionSwComponentType.SwcMappingConstraintRefs"] = (
        field(
            default=None,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    unit_group_refs: Optional["CompositionSwComponentType.UnitGroupRefs"] = field(
        default=None,
        metadata={
            "name": "UNIT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    components: Optional["CompositionSwComponentType.Components"] = field(
        default=None,
        metadata={
            "name": "COMPONENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    connectors: Optional["CompositionSwComponentType.Connectors"] = field(
        default=None,
        metadata={
            "name": "CONNECTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    constant_value_mapping_refs: Optional["CompositionSwComponentType.ConstantValueMappingRefs"] = (
        field(
            default=None,
            metadata={
                "name": "CONSTANT-VALUE-MAPPING-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    data_type_mapping_refs: Optional["CompositionSwComponentType.DataTypeMappingRefs"] = field(
        default=None,
        metadata={
            "name": "DATA-TYPE-MAPPING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    instantiation_rte_event_propss: Optional[
        "CompositionSwComponentType.InstantiationRteEventPropss"
    ] = field(
        default=None,
        metadata={
            "name": "INSTANTIATION-RTE-EVENT-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwComponentDocumentations:
        sw_component_documentation: list[SwComponentDocumentation] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMPONENT-DOCUMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConsistencyNeedss:
        consistency_needs: list[ConsistencyNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CONSISTENCY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Ports:
        p_port_prototype: list[PPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "P-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        pr_port_prototype: list[PrPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PR-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        r_port_prototype: list[RPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "R-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortGroups:
        port_group: list[PortGroup] = field(
            default_factory=list,
            metadata={
                "name": "PORT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcMappingConstraintRefs:
        swc_mapping_constraint_ref: list[
            "CompositionSwComponentType.SwcMappingConstraintRefs.SwcMappingConstraintRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SwcMappingConstraintRef(Ref):
            dest: SwComponentMappingConstraintsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class UnitGroupRefs:
        unit_group_ref: list["CompositionSwComponentType.UnitGroupRefs.UnitGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "UNIT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class UnitGroupRef(Ref):
            dest: UnitGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class Components:
        sw_component_prototype: list[SwComponentPrototype] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMPONENT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Connectors:
        assembly_sw_connector: list[AssemblySwConnector] = field(
            default_factory=list,
            metadata={
                "name": "ASSEMBLY-SW-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        delegation_sw_connector: list[DelegationSwConnector] = field(
            default_factory=list,
            metadata={
                "name": "DELEGATION-SW-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        pass_through_sw_connector: list[PassThroughSwConnector] = field(
            default_factory=list,
            metadata={
                "name": "PASS-THROUGH-SW-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConstantValueMappingRefs:
        constant_value_mapping_ref: list[
            "CompositionSwComponentType.ConstantValueMappingRefs.ConstantValueMappingRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONSTANT-VALUE-MAPPING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ConstantValueMappingRef(Ref):
            dest: ConstantSpecificationMappingSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DataTypeMappingRefs:
        data_type_mapping_ref: list[
            "CompositionSwComponentType.DataTypeMappingRefs.DataTypeMappingRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DATA-TYPE-MAPPING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DataTypeMappingRef(Ref):
            dest: DataTypeMappingSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class InstantiationRteEventPropss:
        instantiation_timing_event_props: list[InstantiationTimingEventProps] = field(
            default_factory=list,
            metadata={
                "name": "INSTANTIATION-TIMING-EVENT-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class EcuAbstractionSwComponentType:
    """The ECUAbstraction is a special AtomicSwComponentType that resides between a
    software-component that wants to access ECU periphery and the Microcontroller
    Abstraction.

    The EcuAbstractionSwComponentType introduces the possibility to link
    from the software representation to its hardware description
    provided by the ECU Resource Template.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar sw_component_documentations: This adds a documentation to the
        SwComponentType. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar consistency_needss: This represents the collection of
        ConsistencyNeeds owned by the enclosing SwComponentType.
    :ivar ports: The PortPrototypes through which this SwComponentType
        can communicate. The aggregation of PortPrototype is subject to
        variability with the purpose to support the conditional
        existence of PortPrototypes.
    :ivar port_groups: A port group being part of this component.
    :ivar swc_mapping_constraint_refs: Reference to constraints that are
        valid for this SwComponentType.
    :ivar unit_group_refs: This allows for the specification of which
        UnitGroups are relevant in the context of referencing
        SwComponentType.
    :ivar internal_behaviors: The SwcInternalBehaviors owned by an
        AtomicSwComponentType can be located in a different physical
        file. Therefore the aggregation is &lt;&lt;atpSplitable&gt;&gt;.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar symbol_props: This represents the SymbolProps for the
        AtomicSwComponentType.
    :ivar hardware_element_refs: Reference from the
        EcuAbstractionComponentType to the description of the used
        HwElements.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "ECU-ABSTRACTION-SW-COMPONENT-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["EcuAbstractionSwComponentType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["EcuAbstractionSwComponentType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["EcuAbstractionSwComponentType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_documentations: Optional[
        "EcuAbstractionSwComponentType.SwComponentDocumentations"
    ] = field(
        default=None,
        metadata={
            "name": "SW-COMPONENT-DOCUMENTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consistency_needss: Optional["EcuAbstractionSwComponentType.ConsistencyNeedss"] = field(
        default=None,
        metadata={
            "name": "CONSISTENCY-NEEDSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ports: Optional["EcuAbstractionSwComponentType.Ports"] = field(
        default=None,
        metadata={
            "name": "PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_groups: Optional["EcuAbstractionSwComponentType.PortGroups"] = field(
        default=None,
        metadata={
            "name": "PORT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_mapping_constraint_refs: Optional[
        "EcuAbstractionSwComponentType.SwcMappingConstraintRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SWC-MAPPING-CONSTRAINT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_group_refs: Optional["EcuAbstractionSwComponentType.UnitGroupRefs"] = field(
        default=None,
        metadata={
            "name": "UNIT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    internal_behaviors: Optional["EcuAbstractionSwComponentType.InternalBehaviors"] = field(
        default=None,
        metadata={
            "name": "INTERNAL-BEHAVIORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol_props: SymbolProps | None = field(
        default=None,
        metadata={
            "name": "SYMBOL-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    hardware_element_refs: Optional["EcuAbstractionSwComponentType.HardwareElementRefs"] = field(
        default=None,
        metadata={
            "name": "HARDWARE-ELEMENT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwComponentDocumentations:
        sw_component_documentation: list[SwComponentDocumentation] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMPONENT-DOCUMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConsistencyNeedss:
        consistency_needs: list[ConsistencyNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CONSISTENCY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Ports:
        p_port_prototype: list[PPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "P-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        pr_port_prototype: list[PrPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PR-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        r_port_prototype: list[RPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "R-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortGroups:
        port_group: list[PortGroup] = field(
            default_factory=list,
            metadata={
                "name": "PORT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcMappingConstraintRefs:
        swc_mapping_constraint_ref: list[
            "EcuAbstractionSwComponentType.SwcMappingConstraintRefs.SwcMappingConstraintRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SwcMappingConstraintRef(Ref):
            dest: SwComponentMappingConstraintsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class UnitGroupRefs:
        unit_group_ref: list["EcuAbstractionSwComponentType.UnitGroupRefs.UnitGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "UNIT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class UnitGroupRef(Ref):
            dest: UnitGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class InternalBehaviors:
        swc_internal_behavior: list[SwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class HardwareElementRefs:
        hardware_element_ref: list[
            "EcuAbstractionSwComponentType.HardwareElementRefs.HardwareElementRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "HARDWARE-ELEMENT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class HardwareElementRef(Ref):
            dest: HwDescriptionEntitySubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )


@dataclass(slots=True, kw_only=True)
class MsrQueryChapter:
    """
    This meta-class represents the ability to express a query which yields a set of
    chapters as a result.

    :ivar msr_query_props: This is argument and properties of the
        chapter query.
    :ivar msr_query_result_chapter: This represents the result of the
        query.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar si: This attribute allows to denote a semantic information
        which is used to identify documentation objects to be selected
        in customizable document views. It shall be defined in agreement
        between the involved parties.
    :ivar view: This attribute lists the document views in which the
        object shall appear. If it is missing, the object appears in all
        document views.
    :ivar break_value: This attributes allows to specify a forced page
        break.
    :ivar keep_with_previous: This attribute denotes the pagination
        policy. In particular it defines if the containing text block
        shall be kept together with the previous block.
    """

    class Meta:
        name = "MSR-QUERY-CHAPTER"

    msr_query_props: MsrQueryProps | None = field(
        default=None,
        metadata={
            "name": "MSR-QUERY-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_result_chapter: MsrQueryResultChapter | None = field(
        default=None,
        metadata={
            "name": "MSR-QUERY-RESULT-CHAPTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    si: list[str] = field(
        default_factory=list,
        metadata={
            "name": "SI",
            "type": "Attribute",
            "tokens": True,
        },
    )
    view: str | None = field(
        default=None,
        metadata={
            "name": "VIEW",
            "type": "Attribute",
            "pattern": r"(-?[a-zA-Z_]+)(( )+-?[a-zA-Z_]+)*",
        },
    )
    break_value: ChapterEnumBreakSimple | None = field(
        default=None,
        metadata={
            "name": "BREAK",
            "type": "Attribute",
        },
    )
    keep_with_previous: KeepWithPreviousEnumSimple | None = field(
        default=None,
        metadata={
            "name": "KEEP-WITH-PREVIOUS",
            "type": "Attribute",
        },
    )


@dataclass(slots=True, kw_only=True)
class NvBlockSwComponentType:
    """The NvBlockSwComponentType defines non volatile data which data can be
    shared between SwComponentPrototypes.

    The non volatile data of the NvBlockSwComponentType are accessible
    via provided and required ports.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar sw_component_documentations: This adds a documentation to the
        SwComponentType. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar consistency_needss: This represents the collection of
        ConsistencyNeeds owned by the enclosing SwComponentType.
    :ivar ports: The PortPrototypes through which this SwComponentType
        can communicate. The aggregation of PortPrototype is subject to
        variability with the purpose to support the conditional
        existence of PortPrototypes.
    :ivar port_groups: A port group being part of this component.
    :ivar swc_mapping_constraint_refs: Reference to constraints that are
        valid for this SwComponentType.
    :ivar unit_group_refs: This allows for the specification of which
        UnitGroups are relevant in the context of referencing
        SwComponentType.
    :ivar internal_behaviors: The SwcInternalBehaviors owned by an
        AtomicSwComponentType can be located in a different physical
        file. Therefore the aggregation is &lt;&lt;atpSplitable&gt;&gt;.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar symbol_props: This represents the SymbolProps for the
        AtomicSwComponentType.
    :ivar bulk_nv_data_descriptors: This aggregation formally defines
        the bulk Nv Blocks that are provided to the application software
        by the enclosing NvBlockSwComponentType.
    :ivar nv_block_descriptors: Specification of the properties of
        exactly one NVRAM Block.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "NV-BLOCK-SW-COMPONENT-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["NvBlockSwComponentType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["NvBlockSwComponentType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["NvBlockSwComponentType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_documentations: Optional["NvBlockSwComponentType.SwComponentDocumentations"] = (
        field(
            default=None,
            metadata={
                "name": "SW-COMPONENT-DOCUMENTATIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    consistency_needss: Optional["NvBlockSwComponentType.ConsistencyNeedss"] = field(
        default=None,
        metadata={
            "name": "CONSISTENCY-NEEDSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ports: Optional["NvBlockSwComponentType.Ports"] = field(
        default=None,
        metadata={
            "name": "PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_groups: Optional["NvBlockSwComponentType.PortGroups"] = field(
        default=None,
        metadata={
            "name": "PORT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_mapping_constraint_refs: Optional["NvBlockSwComponentType.SwcMappingConstraintRefs"] = (
        field(
            default=None,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    unit_group_refs: Optional["NvBlockSwComponentType.UnitGroupRefs"] = field(
        default=None,
        metadata={
            "name": "UNIT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    internal_behaviors: Optional["NvBlockSwComponentType.InternalBehaviors"] = field(
        default=None,
        metadata={
            "name": "INTERNAL-BEHAVIORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol_props: SymbolProps | None = field(
        default=None,
        metadata={
            "name": "SYMBOL-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    bulk_nv_data_descriptors: Optional["NvBlockSwComponentType.BulkNvDataDescriptors"] = field(
        default=None,
        metadata={
            "name": "BULK-NV-DATA-DESCRIPTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    nv_block_descriptors: Optional["NvBlockSwComponentType.NvBlockDescriptors"] = field(
        default=None,
        metadata={
            "name": "NV-BLOCK-DESCRIPTORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwComponentDocumentations:
        sw_component_documentation: list[SwComponentDocumentation] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMPONENT-DOCUMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConsistencyNeedss:
        consistency_needs: list[ConsistencyNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CONSISTENCY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Ports:
        p_port_prototype: list[PPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "P-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        pr_port_prototype: list[PrPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PR-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        r_port_prototype: list[RPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "R-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortGroups:
        port_group: list[PortGroup] = field(
            default_factory=list,
            metadata={
                "name": "PORT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcMappingConstraintRefs:
        swc_mapping_constraint_ref: list[
            "NvBlockSwComponentType.SwcMappingConstraintRefs.SwcMappingConstraintRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SwcMappingConstraintRef(Ref):
            dest: SwComponentMappingConstraintsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class UnitGroupRefs:
        unit_group_ref: list["NvBlockSwComponentType.UnitGroupRefs.UnitGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "UNIT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class UnitGroupRef(Ref):
            dest: UnitGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class InternalBehaviors:
        swc_internal_behavior: list[SwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BulkNvDataDescriptors:
        bulk_nv_data_descriptor: list[BulkNvDataDescriptor] = field(
            default_factory=list,
            metadata={
                "name": "BULK-NV-DATA-DESCRIPTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class NvBlockDescriptors:
        nv_block_descriptor: list[NvBlockDescriptor] = field(
            default_factory=list,
            metadata={
                "name": "NV-BLOCK-DESCRIPTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ParameterSwComponentType:
    """The ParameterSwComponentType defines parameters and characteristic values
    accessible via provided Ports.

    The provided values are the same for all connected
    SwComponentPrototypes

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar sw_component_documentations: This adds a documentation to the
        SwComponentType. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar consistency_needss: This represents the collection of
        ConsistencyNeeds owned by the enclosing SwComponentType.
    :ivar ports: The PortPrototypes through which this SwComponentType
        can communicate. The aggregation of PortPrototype is subject to
        variability with the purpose to support the conditional
        existence of PortPrototypes.
    :ivar port_groups: A port group being part of this component.
    :ivar swc_mapping_constraint_refs: Reference to constraints that are
        valid for this SwComponentType.
    :ivar unit_group_refs: This allows for the specification of which
        UnitGroups are relevant in the context of referencing
        SwComponentType.
    :ivar constant_mapping_refs: Reference to the
        ConstantSpecificationMapping to be applied for the particular
        ParameterSwComponentType
    :ivar data_type_mapping_refs: Reference to the DataTypeMapping to be
        applied for the particular ParameterSwComponentType
    :ivar instantiation_data_def_propss: The purpose of this is that
        within the context of a given SwComponentType some  data def
        properties of individual instantiations can be modified. The
        aggregation of InstantiationDataDefProps is subject to
        variability with the  purpose to support the conditional
        existence of PortPrototypes
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PARAMETER-SW-COMPONENT-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ParameterSwComponentType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ParameterSwComponentType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ParameterSwComponentType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_documentations: Optional["ParameterSwComponentType.SwComponentDocumentations"] = (
        field(
            default=None,
            metadata={
                "name": "SW-COMPONENT-DOCUMENTATIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    consistency_needss: Optional["ParameterSwComponentType.ConsistencyNeedss"] = field(
        default=None,
        metadata={
            "name": "CONSISTENCY-NEEDSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ports: Optional["ParameterSwComponentType.Ports"] = field(
        default=None,
        metadata={
            "name": "PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_groups: Optional["ParameterSwComponentType.PortGroups"] = field(
        default=None,
        metadata={
            "name": "PORT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_mapping_constraint_refs: Optional["ParameterSwComponentType.SwcMappingConstraintRefs"] = (
        field(
            default=None,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    unit_group_refs: Optional["ParameterSwComponentType.UnitGroupRefs"] = field(
        default=None,
        metadata={
            "name": "UNIT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    constant_mapping_refs: Optional["ParameterSwComponentType.ConstantMappingRefs"] = field(
        default=None,
        metadata={
            "name": "CONSTANT-MAPPING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    data_type_mapping_refs: Optional["ParameterSwComponentType.DataTypeMappingRefs"] = field(
        default=None,
        metadata={
            "name": "DATA-TYPE-MAPPING-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    instantiation_data_def_propss: Optional[
        "ParameterSwComponentType.InstantiationDataDefPropss"
    ] = field(
        default=None,
        metadata={
            "name": "INSTANTIATION-DATA-DEF-PROPSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwComponentDocumentations:
        sw_component_documentation: list[SwComponentDocumentation] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMPONENT-DOCUMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConsistencyNeedss:
        consistency_needs: list[ConsistencyNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CONSISTENCY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Ports:
        p_port_prototype: list[PPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "P-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        pr_port_prototype: list[PrPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PR-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        r_port_prototype: list[RPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "R-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortGroups:
        port_group: list[PortGroup] = field(
            default_factory=list,
            metadata={
                "name": "PORT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcMappingConstraintRefs:
        swc_mapping_constraint_ref: list[
            "ParameterSwComponentType.SwcMappingConstraintRefs.SwcMappingConstraintRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SwcMappingConstraintRef(Ref):
            dest: SwComponentMappingConstraintsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class UnitGroupRefs:
        unit_group_ref: list["ParameterSwComponentType.UnitGroupRefs.UnitGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "UNIT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class UnitGroupRef(Ref):
            dest: UnitGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class ConstantMappingRefs:
        constant_mapping_ref: list[
            "ParameterSwComponentType.ConstantMappingRefs.ConstantMappingRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "CONSTANT-MAPPING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class ConstantMappingRef(Ref):
            dest: ConstantSpecificationMappingSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class DataTypeMappingRefs:
        data_type_mapping_ref: list[
            "ParameterSwComponentType.DataTypeMappingRefs.DataTypeMappingRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "DATA-TYPE-MAPPING-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class DataTypeMappingRef(Ref):
            dest: DataTypeMappingSetSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class InstantiationDataDefPropss:
        instantiation_data_def_props: list[InstantiationDataDefProps] = field(
            default_factory=list,
            metadata={
                "name": "INSTANTIATION-DATA-DEF-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class SensorActuatorSwComponentType:
    """
    The SensorActuatorSwComponentType introduces the possibility to link from the
    software representation of a sensor/actuator to its hardware description
    provided by the ECU Resource Template.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar sw_component_documentations: This adds a documentation to the
        SwComponentType. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar consistency_needss: This represents the collection of
        ConsistencyNeeds owned by the enclosing SwComponentType.
    :ivar ports: The PortPrototypes through which this SwComponentType
        can communicate. The aggregation of PortPrototype is subject to
        variability with the purpose to support the conditional
        existence of PortPrototypes.
    :ivar port_groups: A port group being part of this component.
    :ivar swc_mapping_constraint_refs: Reference to constraints that are
        valid for this SwComponentType.
    :ivar unit_group_refs: This allows for the specification of which
        UnitGroups are relevant in the context of referencing
        SwComponentType.
    :ivar internal_behaviors: The SwcInternalBehaviors owned by an
        AtomicSwComponentType can be located in a different physical
        file. Therefore the aggregation is &lt;&lt;atpSplitable&gt;&gt;.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar symbol_props: This represents the SymbolProps for the
        AtomicSwComponentType.
    :ivar sensor_actuator_ref: Reference from the Sensor Actuator
        Software Component Type to the description of the actual
        hardware.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SENSOR-ACTUATOR-SW-COMPONENT-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["SensorActuatorSwComponentType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["SensorActuatorSwComponentType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["SensorActuatorSwComponentType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_documentations: Optional[
        "SensorActuatorSwComponentType.SwComponentDocumentations"
    ] = field(
        default=None,
        metadata={
            "name": "SW-COMPONENT-DOCUMENTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consistency_needss: Optional["SensorActuatorSwComponentType.ConsistencyNeedss"] = field(
        default=None,
        metadata={
            "name": "CONSISTENCY-NEEDSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ports: Optional["SensorActuatorSwComponentType.Ports"] = field(
        default=None,
        metadata={
            "name": "PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_groups: Optional["SensorActuatorSwComponentType.PortGroups"] = field(
        default=None,
        metadata={
            "name": "PORT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_mapping_constraint_refs: Optional[
        "SensorActuatorSwComponentType.SwcMappingConstraintRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SWC-MAPPING-CONSTRAINT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_group_refs: Optional["SensorActuatorSwComponentType.UnitGroupRefs"] = field(
        default=None,
        metadata={
            "name": "UNIT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    internal_behaviors: Optional["SensorActuatorSwComponentType.InternalBehaviors"] = field(
        default=None,
        metadata={
            "name": "INTERNAL-BEHAVIORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol_props: SymbolProps | None = field(
        default=None,
        metadata={
            "name": "SYMBOL-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sensor_actuator_ref: Optional["SensorActuatorSwComponentType.SensorActuatorRef"] = field(
        default=None,
        metadata={
            "name": "SENSOR-ACTUATOR-REF",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwComponentDocumentations:
        sw_component_documentation: list[SwComponentDocumentation] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMPONENT-DOCUMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConsistencyNeedss:
        consistency_needs: list[ConsistencyNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CONSISTENCY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Ports:
        p_port_prototype: list[PPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "P-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        pr_port_prototype: list[PrPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PR-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        r_port_prototype: list[RPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "R-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortGroups:
        port_group: list[PortGroup] = field(
            default_factory=list,
            metadata={
                "name": "PORT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcMappingConstraintRefs:
        swc_mapping_constraint_ref: list[
            "SensorActuatorSwComponentType.SwcMappingConstraintRefs.SwcMappingConstraintRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SwcMappingConstraintRef(Ref):
            dest: SwComponentMappingConstraintsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class UnitGroupRefs:
        unit_group_ref: list["SensorActuatorSwComponentType.UnitGroupRefs.UnitGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "UNIT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class UnitGroupRef(Ref):
            dest: UnitGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class InternalBehaviors:
        swc_internal_behavior: list[SwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SensorActuatorRef(Ref):
        dest: HwDescriptionEntitySubtypesEnum = field(
            metadata={
                "name": "DEST",
                "type": "Attribute",
                "required": True,
            }
        )


@dataclass(slots=True, kw_only=True)
class ServiceProxySwComponentType:
    """This class provides the ability to express a software-component which
    provides access to an internal service for remote ECUs.

    It acts as a proxy for the service providing access to the service.
    An important use case is the request of vehicle mode switches: Such requests can be communicated via sender-receiver interfaces across ECU boundaries, but the mode manager being responsible to perform the mode switches is an AUTOSAR Service which is located in the Basic Software and is not visible in the VFB view. To handle this situation, a ServiceProxySwComponentType will act as proxy for the mode manager. It will have R-Ports to be connected with the mode requestors on VFB level and Service-Ports to be connected with the local mode manager at ECU integration time.
    Apart from the semantics, a ServiceProxySwComponentType has these specific properties:
    * A prototype of it can be mapped to more than one ECUs in the system description.
    * Exactly one additional instance of it will be created in the ECU-Extract per ECU to which the prototype has been mapped.
    * For remote communication, it can have only R-Ports with sender-receiver interfaces and 1:n semantics.
    * There shall be no connectors between two prototypes of any ServiceProxySwComponentType.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar sw_component_documentations: This adds a documentation to the
        SwComponentType. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar consistency_needss: This represents the collection of
        ConsistencyNeeds owned by the enclosing SwComponentType.
    :ivar ports: The PortPrototypes through which this SwComponentType
        can communicate. The aggregation of PortPrototype is subject to
        variability with the purpose to support the conditional
        existence of PortPrototypes.
    :ivar port_groups: A port group being part of this component.
    :ivar swc_mapping_constraint_refs: Reference to constraints that are
        valid for this SwComponentType.
    :ivar unit_group_refs: This allows for the specification of which
        UnitGroups are relevant in the context of referencing
        SwComponentType.
    :ivar internal_behaviors: The SwcInternalBehaviors owned by an
        AtomicSwComponentType can be located in a different physical
        file. Therefore the aggregation is &lt;&lt;atpSplitable&gt;&gt;.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar symbol_props: This represents the SymbolProps for the
        AtomicSwComponentType.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-PROXY-SW-COMPONENT-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ServiceProxySwComponentType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ServiceProxySwComponentType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ServiceProxySwComponentType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_documentations: Optional[
        "ServiceProxySwComponentType.SwComponentDocumentations"
    ] = field(
        default=None,
        metadata={
            "name": "SW-COMPONENT-DOCUMENTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    consistency_needss: Optional["ServiceProxySwComponentType.ConsistencyNeedss"] = field(
        default=None,
        metadata={
            "name": "CONSISTENCY-NEEDSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ports: Optional["ServiceProxySwComponentType.Ports"] = field(
        default=None,
        metadata={
            "name": "PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_groups: Optional["ServiceProxySwComponentType.PortGroups"] = field(
        default=None,
        metadata={
            "name": "PORT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_mapping_constraint_refs: Optional[
        "ServiceProxySwComponentType.SwcMappingConstraintRefs"
    ] = field(
        default=None,
        metadata={
            "name": "SWC-MAPPING-CONSTRAINT-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    unit_group_refs: Optional["ServiceProxySwComponentType.UnitGroupRefs"] = field(
        default=None,
        metadata={
            "name": "UNIT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    internal_behaviors: Optional["ServiceProxySwComponentType.InternalBehaviors"] = field(
        default=None,
        metadata={
            "name": "INTERNAL-BEHAVIORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol_props: SymbolProps | None = field(
        default=None,
        metadata={
            "name": "SYMBOL-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwComponentDocumentations:
        sw_component_documentation: list[SwComponentDocumentation] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMPONENT-DOCUMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConsistencyNeedss:
        consistency_needs: list[ConsistencyNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CONSISTENCY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Ports:
        p_port_prototype: list[PPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "P-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        pr_port_prototype: list[PrPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PR-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        r_port_prototype: list[RPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "R-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortGroups:
        port_group: list[PortGroup] = field(
            default_factory=list,
            metadata={
                "name": "PORT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcMappingConstraintRefs:
        swc_mapping_constraint_ref: list[
            "ServiceProxySwComponentType.SwcMappingConstraintRefs.SwcMappingConstraintRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SwcMappingConstraintRef(Ref):
            dest: SwComponentMappingConstraintsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class UnitGroupRefs:
        unit_group_ref: list["ServiceProxySwComponentType.UnitGroupRefs.UnitGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "UNIT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class UnitGroupRef(Ref):
            dest: UnitGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class InternalBehaviors:
        swc_internal_behavior: list[SwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ServiceSwComponentType:
    """ServiceSwComponentType is used for configuring services for a given ECU.

    Instances of this class are only to be created in ECU Configuration
    phase for the specific purpose of the service configuration.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar sw_component_documentations: This adds a documentation to the
        SwComponentType. The upper multiplicity of this role has been
        increased to * due to resolving an atpVariation stereotype. The
        previous value was 1.
    :ivar consistency_needss: This represents the collection of
        ConsistencyNeeds owned by the enclosing SwComponentType.
    :ivar ports: The PortPrototypes through which this SwComponentType
        can communicate. The aggregation of PortPrototype is subject to
        variability with the purpose to support the conditional
        existence of PortPrototypes.
    :ivar port_groups: A port group being part of this component.
    :ivar swc_mapping_constraint_refs: Reference to constraints that are
        valid for this SwComponentType.
    :ivar unit_group_refs: This allows for the specification of which
        UnitGroups are relevant in the context of referencing
        SwComponentType.
    :ivar internal_behaviors: The SwcInternalBehaviors owned by an
        AtomicSwComponentType can be located in a different physical
        file. Therefore the aggregation is &lt;&lt;atpSplitable&gt;&gt;.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar symbol_props: This represents the SymbolProps for the
        AtomicSwComponentType.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "SERVICE-SW-COMPONENT-TYPE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ServiceSwComponentType.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ServiceSwComponentType.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ServiceSwComponentType.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    sw_component_documentations: Optional["ServiceSwComponentType.SwComponentDocumentations"] = (
        field(
            default=None,
            metadata={
                "name": "SW-COMPONENT-DOCUMENTATIONS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    consistency_needss: Optional["ServiceSwComponentType.ConsistencyNeedss"] = field(
        default=None,
        metadata={
            "name": "CONSISTENCY-NEEDSS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ports: Optional["ServiceSwComponentType.Ports"] = field(
        default=None,
        metadata={
            "name": "PORTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    port_groups: Optional["ServiceSwComponentType.PortGroups"] = field(
        default=None,
        metadata={
            "name": "PORT-GROUPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    swc_mapping_constraint_refs: Optional["ServiceSwComponentType.SwcMappingConstraintRefs"] = (
        field(
            default=None,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REFS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
    )
    unit_group_refs: Optional["ServiceSwComponentType.UnitGroupRefs"] = field(
        default=None,
        metadata={
            "name": "UNIT-GROUP-REFS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    internal_behaviors: Optional["ServiceSwComponentType.InternalBehaviors"] = field(
        default=None,
        metadata={
            "name": "INTERNAL-BEHAVIORS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    symbol_props: SymbolProps | None = field(
        default=None,
        metadata={
            "name": "SYMBOL-PROPS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwComponentDocumentations:
        sw_component_documentation: list[SwComponentDocumentation] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMPONENT-DOCUMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ConsistencyNeedss:
        consistency_needs: list[ConsistencyNeeds] = field(
            default_factory=list,
            metadata={
                "name": "CONSISTENCY-NEEDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Ports:
        p_port_prototype: list[PPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "P-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        pr_port_prototype: list[PrPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "PR-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        r_port_prototype: list[RPortPrototype] = field(
            default_factory=list,
            metadata={
                "name": "R-PORT-PROTOTYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class PortGroups:
        port_group: list[PortGroup] = field(
            default_factory=list,
            metadata={
                "name": "PORT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class SwcMappingConstraintRefs:
        swc_mapping_constraint_ref: list[
            "ServiceSwComponentType.SwcMappingConstraintRefs.SwcMappingConstraintRef"
        ] = field(
            default_factory=list,
            metadata={
                "name": "SWC-MAPPING-CONSTRAINT-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class SwcMappingConstraintRef(Ref):
            dest: SwComponentMappingConstraintsSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class UnitGroupRefs:
        unit_group_ref: list["ServiceSwComponentType.UnitGroupRefs.UnitGroupRef"] = field(
            default_factory=list,
            metadata={
                "name": "UNIT-GROUP-REF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

        @dataclass(slots=True, kw_only=True)
        class UnitGroupRef(Ref):
            dest: UnitGroupSubtypesEnum = field(
                metadata={
                    "name": "DEST",
                    "type": "Attribute",
                    "required": True,
                }
            )

    @dataclass(slots=True, kw_only=True)
    class InternalBehaviors:
        swc_internal_behavior: list[SwcInternalBehavior] = field(
            default_factory=list,
            metadata={
                "name": "SWC-INTERNAL-BEHAVIOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ChapterModel:
    """This is the basic content model of a chapter except the Chapter title.

    This can be utilized in general chapters as well as in predefined chapters.
    A chapter has content on three levels:
    1. chapter content
    2. topics
    3. subchapters

    :ivar msr_query_p_1: This represents automatically contributed
        contents provided by an msrquery.
    :ivar msr_query_p_2: This represents automatically contributed
        contents provided by an msrquery in the context of
        DocumentationBlock.
    :ivar p: This is one particular paragraph. The upper multiplicity of
        this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar verbatim: This represents one particular verbatim text. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar list_value: This represents numbered or unnumbered list. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar def_list: This represents a definition list in the
        documentation block. The upper multiplicity of this role has
        been increased to * due to resolving an atpVariation stereotype.
        The previous value was 1.
    :ivar labeled_list: This represents a labeled list. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar formula: This is a formula in the definition block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar figure: This represents a figure in the documentation block.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar note: This represents a note in the text flow. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar trace: This represents traceable text in the documentation
        block. This allows to specify requirements/constraints in any
        documentation block. The kind of the trace is specified in the
        category. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar structured_req: This aggregation supports structured
        requirements embedded in a documentation block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar table: This represents a table within a topic. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar traceable_table: This represents a traceable table within a
        topic.
    :ivar prms: This is a parameter table within a chapter.
    :ivar topic_1: This is used to create particular topics within a
        chapter. A topic is similar to a subchapter, but cannot be
        nested and will not appear in the table of contents of the
        document. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar msr_query_topic_1: This represents automatically contributed
        topics provided by an msrquery.
    :ivar chapter: This establishes a subschapter. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar msr_query_chapter: This represents automatically contributed
        chapters provided by an msrquery.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CHAPTER-MODEL"

    msr_query_p_1: list[MsrQueryP1] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_p_2: list[MsrQueryP2] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p: list[MultiLanguageParagraph] = field(
        default_factory=list,
        metadata={
            "name": "P",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: list[MultiLanguageVerbatim] = field(
        default_factory=list,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    list_value: list[ListType] = field(
        default_factory=list,
        metadata={
            "name": "LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_list: list[DefList] = field(
        default_factory=list,
        metadata={
            "name": "DEF-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    labeled_list: list[LabeledList] = field(
        default_factory=list,
        metadata={
            "name": "LABELED-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: list[MlFormula] = field(
        default_factory=list,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    figure: list[MlFigure] = field(
        default_factory=list,
        metadata={
            "name": "FIGURE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    note: list[Note] = field(
        default_factory=list,
        metadata={
            "name": "NOTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace: list[TraceableText] = field(
        default_factory=list,
        metadata={
            "name": "TRACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    structured_req: list[StructuredReq] = field(
        default_factory=list,
        metadata={
            "name": "STRUCTURED-REQ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    table: list[Table] = field(
        default_factory=list,
        metadata={
            "name": "TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    traceable_table: list[TraceableTable] = field(
        default_factory=list,
        metadata={
            "name": "TRACEABLE-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prms: list[Prms] = field(
        default_factory=list,
        metadata={
            "name": "PRMS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    topic_1: list[Topic1] = field(
        default_factory=list,
        metadata={
            "name": "TOPIC-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_topic_1: list[MsrQueryTopic1] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-TOPIC-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    chapter: list[Chapter] = field(
        default_factory=list,
        metadata={
            "name": "CHAPTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_chapter: list[MsrQueryChapter] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-CHAPTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class ChapterOrMsrQuery:
    """
    This meta-class represents the ability to denote a particular chapter or a
    query returning a chapter.

    :ivar chapter: This establishes a subschapter. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar msr_query_chapter: This represents automatically contributed
        chapters provided by an msrquery.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "CHAPTER-OR-MSR-QUERY"

    chapter: list[Chapter] = field(
        default_factory=list,
        metadata={
            "name": "CHAPTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_chapter: list[MsrQueryChapter] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-CHAPTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class PredefinedChapter:
    """
    This represents a predefined chapter.

    :ivar msr_query_p_1: This represents automatically contributed
        contents provided by an msrquery.
    :ivar msr_query_p_2: This represents automatically contributed
        contents provided by an msrquery in the context of
        DocumentationBlock.
    :ivar p: This is one particular paragraph. The upper multiplicity of
        this role has been increased to * due to resolving an
        atpVariation stereotype. The previous value was 1.
    :ivar verbatim: This represents one particular verbatim text. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar list_value: This represents numbered or unnumbered list. The
        upper multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar def_list: This represents a definition list in the
        documentation block. The upper multiplicity of this role has
        been increased to * due to resolving an atpVariation stereotype.
        The previous value was 1.
    :ivar labeled_list: This represents a labeled list. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar formula: This is a formula in the definition block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar figure: This represents a figure in the documentation block.
        The upper multiplicity of this role has been increased to * due
        to resolving an atpVariation stereotype. The previous value was
        1.
    :ivar note: This represents a note in the text flow. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar trace: This represents traceable text in the documentation
        block. This allows to specify requirements/constraints in any
        documentation block. The kind of the trace is specified in the
        category. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar structured_req: This aggregation supports structured
        requirements embedded in a documentation block. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar table: This represents a table within a topic. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar traceable_table: This represents a traceable table within a
        topic.
    :ivar prms: This is a parameter table within a chapter.
    :ivar topic_1: This is used to create particular topics within a
        chapter. A topic is similar to a subchapter, but cannot be
        nested and will not appear in the table of contents of the
        document. The upper multiplicity of this role has been increased
        to * due to resolving an atpVariation stereotype. The previous
        value was 1.
    :ivar msr_query_topic_1: This represents automatically contributed
        topics provided by an msrquery.
    :ivar chapter: This establishes a subschapter. The upper
        multiplicity of this role has been increased to * due to
        resolving an atpVariation stereotype. The previous value was 1.
    :ivar msr_query_chapter: This represents automatically contributed
        chapters provided by an msrquery.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "PREDEFINED-CHAPTER"

    msr_query_p_1: list[MsrQueryP1] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_p_2: list[MsrQueryP2] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-P-2",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    p: list[MultiLanguageParagraph] = field(
        default_factory=list,
        metadata={
            "name": "P",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    verbatim: list[MultiLanguageVerbatim] = field(
        default_factory=list,
        metadata={
            "name": "VERBATIM",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    list_value: list[ListType] = field(
        default_factory=list,
        metadata={
            "name": "LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    def_list: list[DefList] = field(
        default_factory=list,
        metadata={
            "name": "DEF-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    labeled_list: list[LabeledList] = field(
        default_factory=list,
        metadata={
            "name": "LABELED-LIST",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    formula: list[MlFormula] = field(
        default_factory=list,
        metadata={
            "name": "FORMULA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    figure: list[MlFigure] = field(
        default_factory=list,
        metadata={
            "name": "FIGURE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    note: list[Note] = field(
        default_factory=list,
        metadata={
            "name": "NOTE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    trace: list[TraceableText] = field(
        default_factory=list,
        metadata={
            "name": "TRACE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    structured_req: list[StructuredReq] = field(
        default_factory=list,
        metadata={
            "name": "STRUCTURED-REQ",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    table: list[Table] = field(
        default_factory=list,
        metadata={
            "name": "TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    traceable_table: list[TraceableTable] = field(
        default_factory=list,
        metadata={
            "name": "TRACEABLE-TABLE",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    prms: list[Prms] = field(
        default_factory=list,
        metadata={
            "name": "PRMS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    topic_1: list[Topic1] = field(
        default_factory=list,
        metadata={
            "name": "TOPIC-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_topic_1: list[MsrQueryTopic1] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-TOPIC-1",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    chapter: list[Chapter] = field(
        default_factory=list,
        metadata={
            "name": "CHAPTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    msr_query_chapter: list[MsrQueryChapter] = field(
        default_factory=list,
        metadata={
            "name": "MSR-QUERY-CHAPTER",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )


@dataclass(slots=True, kw_only=True)
class Documentation:
    """This meta-class represents the ability to handle a so called standalone
    documentation.

    Standalone means, that such a documentation is not embedded in
    another ARElement or identifiable object.  The standalone
    documentation is an entity of its own which denotes its context by
    reference to other objects and instances.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: ARPackage.element Not
        Applicable for:
        DiagnosticMasterToSlaveEventMappingSet.masterToSlaveEventMapping
        Not Applicable for: FlexrayArTpChannel.pduPool
    :ivar contexts: This is the context of the particular documentation.
    :ivar documentation_content: This is the content of the
        documentation related to the specified contexts.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "DOCUMENTATION"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["Documentation.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["Documentation.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    contexts: Optional["Documentation.Contexts"] = field(
        default=None,
        metadata={
            "name": "CONTEXTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    documentation_content: PredefinedChapter | None = field(
        default=None,
        metadata={
            "name": "DOCUMENTATION-CONTENT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Contexts:
        documentation_context: list[DocumentationContext] = field(
            default_factory=list,
            metadata={
                "name": "DOCUMENTATION-CONTEXT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class ArPackage:
    """AUTOSAR package, allowing to create top level packages to structure the
    contained ARElements.

    ARPackages are open sets. This means that in a file based
    description system multiple files can be used to partially describe
    the contents of a package. This is an extended version of MSR's SW-
    SYSTEM.

    :ivar short_name: This specifies an identifying shortName for the
        object. It needs to be unique within its context and is intended
        for humans but even more for technical reference.
    :ivar short_name_fragments: This specifies how the
        Referrable.shortName is composed of several shortNameFragments.
    :ivar long_name: This specifies the long name of the object. Long
        name is targeted to human readers and acts like a headline.
    :ivar desc: This represents a general but brief (one paragraph)
        description what the object in question is about. It is only one
        paragraph! Desc is intended to be collected into overview
        tables. This property helps a human reader to identify the
        object in question. More elaborate documentation, (in particular
        how the object is built or used) should go to "introduction".
    :ivar category: The category is a keyword that specializes the
        semantics of the Identifiable. It affects the expected existence
        of attributes and the applicability of constraints.
    :ivar admin_data: This represents the administrative data for the
        identifiable object.
    :ivar introduction: This represents more information about how the
        object in question is built or is used. Therefore it is a
        DocumentationBlock.
    :ivar annotations: Possibility to provide additional notes while
        defining a model element (e.g. the ECU Configuration Parameter
        Values). These are not intended as documentation but are mere
        design notes.
    :ivar blueprint_policys: This role indicates whether the
        blueprintable element will be modifiable or not modifiable.
    :ivar short_name_pattern: This attribute represents the pattern
        which shall be used to build the shortName of the derived
        elements. As of now it is modeled as a String.  In general it
        should follow the pattern: pattern = (placeholder | namePart)*
        placeholder = "{" namePart "}" namePart = identifier | "_" This
        is subject to be refined in subsequent versions. Note that this
        is marked as obsolete. Use the xml attribute namePattern instead
        as it applies to Identifier and CIdentifier (shortName, symbol
        etc.)
    :ivar reference_bases: This denotes the reference bases for the
        package. This is the basis for all relative references within
        the package. The base needs to be selected according to the base
        attribute within the references.
    :ivar elements: Elements that are part of this package
    :ivar ar_packages: This represents a sub package within an
        ARPackage, thus allowing for an unlimited package hierarchy.
    :ivar variation_point: This element was generated/modified due to an
        atpVariation stereotype. Applicable for: AUTOSAR.arPackage
        Applicable for: ARPackage.arPackage
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    :ivar uuid: The purpose of this attribute is to provide a globally
        unique identifier for an instance of a meta-class. The values of
        this attribute should be globally unique strings prefixed by the
        type of identifier.  For example, to include a DCE UUID as
        defined by The Open Group, the UUID would be preceded by "DCE:".
        The values of this attribute may be used to support merging of
        different AUTOSAR models. The form of the UUID (Universally
        Unique Identifier) is taken from a standard defined by the Open
        Group (was Open Software Foundation). This standard is widely
        used, including by Microsoft for COM (GUIDs) and by many
        companies for DCE, which is based on CORBA. The method for
        generating these 128-bit IDs is published in the standard and
        the effectiveness and uniqueness of the IDs is not in practice
        disputed. If the id namespace is omitted, DCE is assumed. An
        example is "DCE:2fac1234-31f8-11b4-a222-08002b34c003". The uuid
        attribute has no semantic meaning for an AUTOSAR model and there
        is no requirement for AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AR-PACKAGE"

    short_name: Identifier = field(
        metadata={
            "name": "SHORT-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
            "required": True,
        }
    )
    short_name_fragments: Optional["ArPackage.ShortNameFragments"] = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-FRAGMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    long_name: MultilanguageLongName | None = field(
        default=None,
        metadata={
            "name": "LONG-NAME",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    desc: MultiLanguageOverviewParagraph | None = field(
        default=None,
        metadata={
            "name": "DESC",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    category: CategoryString | None = field(
        default=None,
        metadata={
            "name": "CATEGORY",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    annotations: Optional["ArPackage.Annotations"] = field(
        default=None,
        metadata={
            "name": "ANNOTATIONS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    blueprint_policys: Optional["ArPackage.BlueprintPolicys"] = field(
        default=None,
        metadata={
            "name": "BLUEPRINT-POLICYS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    short_name_pattern: String | None = field(
        default=None,
        metadata={
            "name": "SHORT-NAME-PATTERN",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    reference_bases: Optional["ArPackage.ReferenceBases"] = field(
        default=None,
        metadata={
            "name": "REFERENCE-BASES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    elements: Optional["ArPackage.Elements"] = field(
        default=None,
        metadata={
            "name": "ELEMENTS",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    ar_packages: Optional["ArPackage.ArPackages"] = field(
        default=None,
        metadata={
            "name": "AR-PACKAGES",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    variation_point: VariationPoint | None = field(
        default=None,
        metadata={
            "name": "VARIATION-POINT",
            "type": "Element",
            "namespace": "http://autosar.org/schema/r4.0",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )
    uuid: str | None = field(
        default=None,
        metadata={
            "name": "UUID",
            "type": "Attribute",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ShortNameFragments:
        short_name_fragment: list[ShortNameFragment] = field(
            default_factory=list,
            metadata={
                "name": "SHORT-NAME-FRAGMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Annotations:
        annotation: list[Annotation] = field(
            default_factory=list,
            metadata={
                "name": "ANNOTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class BlueprintPolicys:
        blueprint_policy_list: list[BlueprintPolicyList] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-LIST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_not_modifiable: list[BlueprintPolicyNotModifiable] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-NOT-MODIFIABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_policy_single: list[BlueprintPolicySingle] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-POLICY-SINGLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ReferenceBases:
        reference_base: list[ReferenceBase] = field(
            default_factory=list,
            metadata={
                "name": "REFERENCE-BASE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class Elements:
        acl_object_set: list[AclObjectSet] = field(
            default_factory=list,
            metadata={
                "name": "ACL-OBJECT-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        acl_operation: list[AclOperation] = field(
            default_factory=list,
            metadata={
                "name": "ACL-OPERATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        acl_permission: list[AclPermission] = field(
            default_factory=list,
            metadata={
                "name": "ACL-PERMISSION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        acl_role: list[AclRole] = field(
            default_factory=list,
            metadata={
                "name": "ACL-ROLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        adaptive_application_sw_component_type: list[AdaptiveApplicationSwComponentType] = field(
            default_factory=list,
            metadata={
                "name": "ADAPTIVE-APPLICATION-SW-COMPONENT-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        adaptive_firewall_to_port_prototype_mapping: list[
            AdaptiveFirewallToPortPrototypeMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "ADAPTIVE-FIREWALL-TO-PORT-PROTOTYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        alias_name_set: list[AliasNameSet] = field(
            default_factory=list,
            metadata={
                "name": "ALIAS-NAME-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        allocator: list[Allocator] = field(
            default_factory=list,
            metadata={
                "name": "ALLOCATOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ap_application_error: list[ApApplicationError] = field(
            default_factory=list,
            metadata={
                "name": "AP-APPLICATION-ERROR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ap_application_error_domain: list[ApApplicationErrorDomain] = field(
            default_factory=list,
            metadata={
                "name": "AP-APPLICATION-ERROR-DOMAIN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ap_application_error_set: list[ApApplicationErrorSet] = field(
            default_factory=list,
            metadata={
                "name": "AP-APPLICATION-ERROR-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_array_data_type: list[ApplicationArrayDataType] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-ARRAY-DATA-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_assoc_map_data_type: list[ApplicationAssocMapDataType] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-ASSOC-MAP-DATA-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_deferred_data_type: list[ApplicationDeferredDataType] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-DEFERRED-DATA-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_interface: list[ApplicationInterface] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_partition: list[ApplicationPartition] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-PARTITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_primitive_data_type: list[ApplicationPrimitiveDataType] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-PRIMITIVE-DATA-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_record_data_type: list[ApplicationRecordDataType] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-RECORD-DATA-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        application_sw_component_type: list[ApplicationSwComponentType] = field(
            default_factory=list,
            metadata={
                "name": "APPLICATION-SW-COMPONENT-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        artifact_checksum_to_crypto_provider_mapping: list[
            ArtifactChecksumToCryptoProviderMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "ARTIFACT-CHECKSUM-TO-CRYPTO-PROVIDER-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        blueprint_mapping_set: list[BlueprintMappingSet] = field(
            default_factory=list,
            metadata={
                "name": "BLUEPRINT-MAPPING-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_composition_timing: list[BswCompositionTiming] = field(
            default_factory=list,
            metadata={
                "name": "BSW-COMPOSITION-TIMING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_entry_relationship_set: list[BswEntryRelationshipSet] = field(
            default_factory=list,
            metadata={
                "name": "BSW-ENTRY-RELATIONSHIP-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_implementation: list[BswImplementation] = field(
            default_factory=list,
            metadata={
                "name": "BSW-IMPLEMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_module_description: list[BswModuleDescription] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-DESCRIPTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_module_entry: list[BswModuleEntry] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-ENTRY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bsw_module_timing: list[BswModuleTiming] = field(
            default_factory=list,
            metadata={
                "name": "BSW-MODULE-TIMING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        build_action_manifest: list[BuildActionManifest] = field(
            default_factory=list,
            metadata={
                "name": "BUILD-ACTION-MANIFEST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bus_mirror_channel_mapping_can: list[BusMirrorChannelMappingCan] = field(
            default_factory=list,
            metadata={
                "name": "BUS-MIRROR-CHANNEL-MAPPING-CAN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bus_mirror_channel_mapping_flexray: list[BusMirrorChannelMappingFlexray] = field(
            default_factory=list,
            metadata={
                "name": "BUS-MIRROR-CHANNEL-MAPPING-FLEXRAY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bus_mirror_channel_mapping_ip: list[BusMirrorChannelMappingIp] = field(
            default_factory=list,
            metadata={
                "name": "BUS-MIRROR-CHANNEL-MAPPING-IP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        bus_mirror_channel_mapping_user_defined: list[BusMirrorChannelMappingUserDefined] = field(
            default_factory=list,
            metadata={
                "name": "BUS-MIRROR-CHANNEL-MAPPING-USER-DEFINED",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        calibration_parameter_value_set: list[CalibrationParameterValueSet] = field(
            default_factory=list,
            metadata={
                "name": "CALIBRATION-PARAMETER-VALUE-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        can_cluster: list[CanCluster] = field(
            default_factory=list,
            metadata={
                "name": "CAN-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        can_frame: list[CanFrame] = field(
            default_factory=list,
            metadata={
                "name": "CAN-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        can_tp_config: list[CanTpConfig] = field(
            default_factory=list,
            metadata={
                "name": "CAN-TP-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        can_xl_props: list[CanXlProps] = field(
            default_factory=list,
            metadata={
                "name": "CAN-XL-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        client_id_definition_set: list[ClientIdDefinitionSet] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-ID-DEFINITION-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        client_server_interface: list[ClientServerInterface] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        client_server_interface_to_bsw_module_entry_blueprint_mapping: list[
            ClientServerInterfaceToBswModuleEntryBlueprintMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "CLIENT-SERVER-INTERFACE-TO-BSW-MODULE-ENTRY-BLUEPRINT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        collection: list[Collection] = field(
            default_factory=list,
            metadata={
                "name": "COLLECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_certificate_to_crypto_certificate_mapping: list[
            ComCertificateToCryptoCertificateMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "COM-CERTIFICATE-TO-CRYPTO-CERTIFICATE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_event_grant: list[ComEventGrant] = field(
            default_factory=list,
            metadata={
                "name": "COM-EVENT-GRANT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_event_grant_design: list[ComEventGrantDesign] = field(
            default_factory=list,
            metadata={
                "name": "COM-EVENT-GRANT-DESIGN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_field_grant: list[ComFieldGrant] = field(
            default_factory=list,
            metadata={
                "name": "COM-FIELD-GRANT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_field_grant_design: list[ComFieldGrantDesign] = field(
            default_factory=list,
            metadata={
                "name": "COM-FIELD-GRANT-DESIGN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_find_service_grant: list[ComFindServiceGrant] = field(
            default_factory=list,
            metadata={
                "name": "COM-FIND-SERVICE-GRANT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_find_service_grant_design: list[ComFindServiceGrantDesign] = field(
            default_factory=list,
            metadata={
                "name": "COM-FIND-SERVICE-GRANT-DESIGN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_key_to_crypto_key_slot_mapping: list[ComKeyToCryptoKeySlotMapping] = field(
            default_factory=list,
            metadata={
                "name": "COM-KEY-TO-CRYPTO-KEY-SLOT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_method_grant: list[ComMethodGrant] = field(
            default_factory=list,
            metadata={
                "name": "COM-METHOD-GRANT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_method_grant_design: list[ComMethodGrantDesign] = field(
            default_factory=list,
            metadata={
                "name": "COM-METHOD-GRANT-DESIGN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_offer_service_grant: list[ComOfferServiceGrant] = field(
            default_factory=list,
            metadata={
                "name": "COM-OFFER-SERVICE-GRANT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_offer_service_grant_design: list[ComOfferServiceGrantDesign] = field(
            default_factory=list,
            metadata={
                "name": "COM-OFFER-SERVICE-GRANT-DESIGN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_sec_oc_to_crypto_key_slot_mapping: list[ComSecOcToCryptoKeySlotMapping] = field(
            default_factory=list,
            metadata={
                "name": "COM-SEC-OC-TO-CRYPTO-KEY-SLOT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        com_trigger_grant_design: list[ComTriggerGrantDesign] = field(
            default_factory=list,
            metadata={
                "name": "COM-TRIGGER-GRANT-DESIGN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        complex_device_driver_sw_component_type: list[ComplexDeviceDriverSwComponentType] = field(
            default_factory=list,
            metadata={
                "name": "COMPLEX-DEVICE-DRIVER-SW-COMPONENT-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composition_p_port_to_executable_p_port_mapping: list[
            CompositionPPortToExecutablePPortMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "COMPOSITION-P-PORT-TO-EXECUTABLE-P-PORT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composition_r_port_to_executable_r_port_mapping: list[
            CompositionRPortToExecutableRPortMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "COMPOSITION-R-PORT-TO-EXECUTABLE-R-PORT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        composition_sw_component_type: list[CompositionSwComponentType] = field(
            default_factory=list,
            metadata={
                "name": "COMPOSITION-SW-COMPONENT-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        compu_method: list[CompuMethod] = field(
            default_factory=list,
            metadata={
                "name": "COMPU-METHOD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        consistency_needs_blueprint_set: list[ConsistencyNeedsBlueprintSet] = field(
            default_factory=list,
            metadata={
                "name": "CONSISTENCY-NEEDS-BLUEPRINT-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        constant_specification: list[ConstantSpecification] = field(
            default_factory=list,
            metadata={
                "name": "CONSTANT-SPECIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        constant_specification_mapping_set: list[ConstantSpecificationMappingSet] = field(
            default_factory=list,
            metadata={
                "name": "CONSTANT-SPECIFICATION-MAPPING-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        consumed_provided_service_instance_group: list[ConsumedProvidedServiceInstanceGroup] = (
            field(
                default_factory=list,
                metadata={
                    "name": "CONSUMED-PROVIDED-SERVICE-INSTANCE-GROUP",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        container_i_pdu: list[ContainerIPdu] = field(
            default_factory=list,
            metadata={
                "name": "CONTAINER-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        coupling_element: list[CouplingElement] = field(
            default_factory=list,
            metadata={
                "name": "COUPLING-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        cp_software_cluster: list[CpSoftwareCluster] = field(
            default_factory=list,
            metadata={
                "name": "CP-SOFTWARE-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        cp_software_cluster_binary_manifest_descriptor: list[
            CpSoftwareClusterBinaryManifestDescriptor
        ] = field(
            default_factory=list,
            metadata={
                "name": "CP-SOFTWARE-CLUSTER-BINARY-MANIFEST-DESCRIPTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        cp_software_cluster_mapping_set: list[CpSoftwareClusterMappingSet] = field(
            default_factory=list,
            metadata={
                "name": "CP-SOFTWARE-CLUSTER-MAPPING-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        cp_software_cluster_resource_pool: list[CpSoftwareClusterResourcePool] = field(
            default_factory=list,
            metadata={
                "name": "CP-SOFTWARE-CLUSTER-RESOURCE-POOL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        cp_sw_cluster_resource_to_diag_data_elem_mapping: list[
            CpSwClusterResourceToDiagDataElemMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "CP-SW-CLUSTER-RESOURCE-TO-DIAG-DATA-ELEM-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        cp_sw_cluster_resource_to_diag_function_id_mapping: list[
            CpSwClusterResourceToDiagFunctionIdMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "CP-SW-CLUSTER-RESOURCE-TO-DIAG-FUNCTION-ID-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        cp_sw_cluster_to_diag_event_mapping: list[CpSwClusterToDiagEventMapping] = field(
            default_factory=list,
            metadata={
                "name": "CP-SW-CLUSTER-TO-DIAG-EVENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        cp_sw_cluster_to_diag_routine_subfunction_mapping: list[
            CpSwClusterToDiagRoutineSubfunctionMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "CP-SW-CLUSTER-TO-DIAG-ROUTINE-SUBFUNCTION-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_certificate_interface: list[CryptoCertificateInterface] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-CERTIFICATE-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_certificate_to_port_prototype_mapping: list[
            CryptoCertificateToPortPrototypeMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-CERTIFICATE-TO-PORT-PROTOTYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_elliptic_curve_props: list[CryptoEllipticCurveProps] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-ELLIPTIC-CURVE-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_key_slot_interface: list[CryptoKeySlotInterface] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-KEY-SLOT-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_key_slot_to_port_prototype_mapping: list[CryptoKeySlotToPortPrototypeMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "CRYPTO-KEY-SLOT-TO-PORT-PROTOTYPE-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        crypto_provider_interface: list[CryptoProviderInterface] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-PROVIDER-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_provider_to_port_prototype_mapping: list[CryptoProviderToPortPrototypeMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "CRYPTO-PROVIDER-TO-PORT-PROTOTYPE-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        crypto_service_certificate: list[CryptoServiceCertificate] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-SERVICE-CERTIFICATE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_service_key: list[CryptoServiceKey] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-SERVICE-KEY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_service_primitive: list[CryptoServicePrimitive] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-SERVICE-PRIMITIVE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_service_queue: list[CryptoServiceQueue] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-SERVICE-QUEUE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_signature_scheme: list[CryptoSignatureScheme] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-SIGNATURE-SCHEME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        crypto_trust_master_interface: list[CryptoTrustMasterInterface] = field(
            default_factory=list,
            metadata={
                "name": "CRYPTO-TRUST-MASTER-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        custom_cpp_implementation_data_type: list[CustomCppImplementationDataType] = field(
            default_factory=list,
            metadata={
                "name": "CUSTOM-CPP-IMPLEMENTATION-DATA-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        data_constr: list[DataConstr] = field(
            default_factory=list,
            metadata={
                "name": "DATA-CONSTR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        data_exchange_point: list[DataExchangePoint] = field(
            default_factory=list,
            metadata={
                "name": "DATA-EXCHANGE-POINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        data_transformation_set: list[DataTransformationSet] = field(
            default_factory=list,
            metadata={
                "name": "DATA-TRANSFORMATION-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        data_type_mapping_set: list[DataTypeMappingSet] = field(
            default_factory=list,
            metadata={
                "name": "DATA-TYPE-MAPPING-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dcm_i_pdu: list[DcmIPdu] = field(
            default_factory=list,
            metadata={
                "name": "DCM-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dds_provided_service_instance: list[DdsProvidedServiceInstance] = field(
            default_factory=list,
            metadata={
                "name": "DDS-PROVIDED-SERVICE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dds_required_service_instance: list[DdsRequiredServiceInstance] = field(
            default_factory=list,
            metadata={
                "name": "DDS-REQUIRED-SERVICE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dds_secure_com_props: list[DdsSecureComProps] = field(
            default_factory=list,
            metadata={
                "name": "DDS-SECURE-COM-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dds_secure_governance: list[DdsSecureGovernance] = field(
            default_factory=list,
            metadata={
                "name": "DDS-SECURE-GOVERNANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dds_service_instance_to_machine_mapping: list[DdsServiceInstanceToMachineMapping] = field(
            default_factory=list,
            metadata={
                "name": "DDS-SERVICE-INSTANCE-TO-MACHINE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dds_service_interface_deployment: list[DdsServiceInterfaceDeployment] = field(
            default_factory=list,
            metadata={
                "name": "DDS-SERVICE-INTERFACE-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dds_topic_access_rule: list[DdsTopicAccessRule] = field(
            default_factory=list,
            metadata={
                "name": "DDS-TOPIC-ACCESS-RULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        deterministic_client: list[DeterministicClient] = field(
            default_factory=list,
            metadata={
                "name": "DETERMINISTIC-CLIENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        deterministic_sync_master_to_time_base_consumer_mapping: list[
            DeterministicSyncMasterToTimeBaseConsumerMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "DETERMINISTIC-SYNC-MASTER-TO-TIME-BASE-CONSUMER-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_access_permission: list[DiagnosticAccessPermission] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ACCESS-PERMISSION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_aging: list[DiagnosticAging] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-AGING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_auth_role: list[DiagnosticAuthRole] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-AUTH-ROLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_authentication_class: list[DiagnosticAuthenticationClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-AUTHENTICATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_authentication_configuration: list[DiagnosticAuthenticationConfiguration] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-AUTHENTICATION-CONFIGURATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        diagnostic_authentication_interface: list[DiagnosticAuthenticationInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-AUTHENTICATION-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_authentication_port_mapping: list[DiagnosticAuthenticationPortMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-AUTHENTICATION-PORT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_clear_condition: list[DiagnosticClearCondition] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CLEAR-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_clear_condition_group: list[DiagnosticClearConditionGroup] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CLEAR-CONDITION-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_clear_condition_port_mapping: list[DiagnosticClearConditionPortMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CLEAR-CONDITION-PORT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_clear_diagnostic_information: list[DiagnosticClearDiagnosticInformation] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_clear_diagnostic_information_class: list[
            DiagnosticClearDiagnosticInformationClass
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CLEAR-DIAGNOSTIC-INFORMATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_clear_reset_emission_related_info: list[
            DiagnosticClearResetEmissionRelatedInfo
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_clear_reset_emission_related_info_class: list[
            DiagnosticClearResetEmissionRelatedInfoClass
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CLEAR-RESET-EMISSION-RELATED-INFO-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_com_control: list[DiagnosticComControl] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-COM-CONTROL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_com_control_class: list[DiagnosticComControlClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-COM-CONTROL-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_com_control_interface: list[DiagnosticComControlInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-COM-CONTROL-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_condition_interface: list[DiagnosticConditionInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CONDITION-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_connection: list[DiagnosticConnection] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CONNECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_contribution_set: list[DiagnosticContributionSet] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CONTRIBUTION-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_control_dtc_setting: list[DiagnosticControlDtcSetting] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CONTROL-DTC-SETTING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_control_dtc_setting_class: list[DiagnosticControlDtcSettingClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CONTROL-DTC-SETTING-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_custom_service_class: list[DiagnosticCustomServiceClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CUSTOM-SERVICE-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_custom_service_instance: list[DiagnosticCustomServiceInstance] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-CUSTOM-SERVICE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_data_element_interface: list[DiagnosticDataElementInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DATA-ELEMENT-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_data_identifier: list[DiagnosticDataIdentifier] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DATA-IDENTIFIER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_data_identifier_generic_interface: list[
            DiagnosticDataIdentifierGenericInterface
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DATA-IDENTIFIER-GENERIC-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_data_identifier_interface: list[DiagnosticDataIdentifierInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DATA-IDENTIFIER-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_data_identifier_set: list[DiagnosticDataIdentifierSet] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DATA-IDENTIFIER-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_data_port_mapping: list[DiagnosticDataPortMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DATA-PORT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_data_transfer: list[DiagnosticDataTransfer] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DATA-TRANSFER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_data_transfer_class: list[DiagnosticDataTransferClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DATA-TRANSFER-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_de_authentication: list[DiagnosticDeAuthentication] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DE-AUTHENTICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_dem_provided_data_mapping: list[DiagnosticDemProvidedDataMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DEM-PROVIDED-DATA-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_do_ip_activation_line_interface: list[DiagnosticDoIpActivationLineInterface] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-DO-IP-ACTIVATION-LINE-INTERFACE",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        diagnostic_do_ip_entity_identification_interface: list[
            DiagnosticDoIpEntityIdentificationInterface
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DO-IP-ENTITY-IDENTIFICATION-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_do_ip_group_identification_interface: list[
            DiagnosticDoIpGroupIdentificationInterface
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DO-IP-GROUP-IDENTIFICATION-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_do_ip_power_mode_interface: list[DiagnosticDoIpPowerModeInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DO-IP-POWER-MODE-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_do_ip_trigger_vehicle_announcement_interface: list[
            DiagnosticDoIpTriggerVehicleAnnouncementInterface
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DO-IP-TRIGGER-VEHICLE-ANNOUNCEMENT-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_download_interface: list[DiagnosticDownloadInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DOWNLOAD-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_dtc_information_interface: list[DiagnosticDtcInformationInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DTC-INFORMATION-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_dynamic_data_identifier: list[DiagnosticDynamicDataIdentifier] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DYNAMIC-DATA-IDENTIFIER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_dynamically_define_data_identifier: list[
            DiagnosticDynamicallyDefineDataIdentifier
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_dynamically_define_data_identifier_class: list[
            DiagnosticDynamicallyDefineDataIdentifierClass
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-DYNAMICALLY-DEFINE-DATA-IDENTIFIER-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_ecu_instance_props: list[DiagnosticEcuInstanceProps] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ECU-INSTANCE-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_ecu_reset: list[DiagnosticEcuReset] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ECU-RESET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_ecu_reset_class: list[DiagnosticEcuResetClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ECU-RESET-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_ecu_reset_interface: list[DiagnosticEcuResetInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ECU-RESET-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_enable_condition: list[DiagnosticEnableCondition] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ENABLE-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_enable_condition_group: list[DiagnosticEnableConditionGroup] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ENABLE-CONDITION-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_enable_condition_port_mapping: list[DiagnosticEnableConditionPortMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-ENABLE-CONDITION-PORT-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        diagnostic_environmental_condition: list[DiagnosticEnvironmentalCondition] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ENVIRONMENTAL-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event: list[DiagnosticEvent] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_interface: list[DiagnosticEventInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EVENT-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_port_mapping: list[DiagnosticEventPortMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EVENT-PORT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_to_debounce_algorithm_mapping: list[
            DiagnosticEventToDebounceAlgorithmMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EVENT-TO-DEBOUNCE-ALGORITHM-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_to_enable_condition_group_mapping: list[
            DiagnosticEventToEnableConditionGroupMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EVENT-TO-ENABLE-CONDITION-GROUP-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_to_operation_cycle_mapping: list[
            DiagnosticEventToOperationCycleMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EVENT-TO-OPERATION-CYCLE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_to_security_event_mapping: list[DiagnosticEventToSecurityEventMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-EVENT-TO-SECURITY-EVENT-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        diagnostic_event_to_storage_condition_group_mapping: list[
            DiagnosticEventToStorageConditionGroupMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EVENT-TO-STORAGE-CONDITION-GROUP-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_to_trouble_code_j_1939_mapping: list[
            DiagnosticEventToTroubleCodeJ1939Mapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EVENT-TO-TROUBLE-CODE-J-1939-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_event_to_trouble_code_uds_mapping: list[
            DiagnosticEventToTroubleCodeUdsMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EVENT-TO-TROUBLE-CODE-UDS-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_extended_data_record: list[DiagnosticExtendedDataRecord] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EXTENDED-DATA-RECORD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_external_authentication_interface: list[
            DiagnosticExternalAuthenticationInterface
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_external_authentication_port_mapping: list[
            DiagnosticExternalAuthenticationPortMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-EXTERNAL-AUTHENTICATION-PORT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_fim_alias_event: list[DiagnosticFimAliasEvent] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-FIM-ALIAS-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_fim_alias_event_group: list[DiagnosticFimAliasEventGroup] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_fim_alias_event_group_mapping: list[DiagnosticFimAliasEventGroupMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-FIM-ALIAS-EVENT-GROUP-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_fim_alias_event_mapping: list[DiagnosticFimAliasEventMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-FIM-ALIAS-EVENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_fim_event_group: list[DiagnosticFimEventGroup] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-FIM-EVENT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_fim_function_mapping: list[DiagnosticFimFunctionMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-FIM-FUNCTION-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_freeze_frame: list[DiagnosticFreezeFrame] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-FREEZE-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_function_identifier: list[DiagnosticFunctionIdentifier] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-FUNCTION-IDENTIFIER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_function_identifier_inhibit: list[DiagnosticFunctionIdentifierInhibit] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-FUNCTION-IDENTIFIER-INHIBIT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_generic_uds_interface: list[DiagnosticGenericUdsInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-GENERIC-UDS-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_indicator: list[DiagnosticIndicator] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-INDICATOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_indicator_interface: list[DiagnosticIndicatorInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-INDICATOR-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_indicator_port_mapping: list[DiagnosticIndicatorPortMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-INDICATOR-PORT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_info_type: list[DiagnosticInfoType] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-INFO-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_inhibit_source_event_mapping: list[DiagnosticInhibitSourceEventMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-INHIBIT-SOURCE-EVENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_io_control: list[DiagnosticIoControl] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-IO-CONTROL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_io_control_class: list[DiagnosticIoControlClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-IO-CONTROL-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_iumpr: list[DiagnosticIumpr] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-IUMPR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_iumpr_denominator_group: list[DiagnosticIumprDenominatorGroup] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-IUMPR-DENOMINATOR-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_iumpr_group: list[DiagnosticIumprGroup] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-IUMPR-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_iumpr_to_function_identifier_mapping: list[
            DiagnosticIumprToFunctionIdentifierMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-IUMPR-TO-FUNCTION-IDENTIFIER-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_j_1939_expanded_freeze_frame: list[DiagnosticJ1939ExpandedFreezeFrame] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-J-1939-EXPANDED-FREEZE-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_j_1939_freeze_frame: list[DiagnosticJ1939FreezeFrame] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-J-1939-FREEZE-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_j_1939_node: list[DiagnosticJ1939Node] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-J-1939-NODE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_j_1939_spn: list[DiagnosticJ1939Spn] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-J-1939-SPN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_j_1939_spn_mapping: list[DiagnosticJ1939SpnMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-J-1939-SPN-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_j_1939_sw_mapping: list[DiagnosticJ1939SwMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-J-1939-SW-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_master_to_slave_event_mapping: list[DiagnosticMasterToSlaveEventMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-MASTER-TO-SLAVE-EVENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_master_to_slave_event_mapping_set: list[
            DiagnosticMasterToSlaveEventMappingSet
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-MASTER-TO-SLAVE-EVENT-MAPPING-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_measurement_identifier: list[DiagnosticMeasurementIdentifier] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-MEASUREMENT-IDENTIFIER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_memory_destination_mirror: list[DiagnosticMemoryDestinationMirror] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-MEMORY-DESTINATION-MIRROR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_memory_destination_port_mapping: list[DiagnosticMemoryDestinationPortMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-MEMORY-DESTINATION-PORT-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        diagnostic_memory_destination_primary: list[DiagnosticMemoryDestinationPrimary] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-MEMORY-DESTINATION-PRIMARY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_memory_destination_user_defined: list[DiagnosticMemoryDestinationUserDefined] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-MEMORY-DESTINATION-USER-DEFINED",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        diagnostic_memory_identifier: list[DiagnosticMemoryIdentifier] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-MEMORY-IDENTIFIER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_monitor_interface: list[DiagnosticMonitorInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-MONITOR-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_monitor_port_mapping: list[DiagnosticMonitorPortMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-MONITOR-PORT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_operation_cycle: list[DiagnosticOperationCycle] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-OPERATION-CYCLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_operation_cycle_interface: list[DiagnosticOperationCycleInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-OPERATION-CYCLE-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_operation_cycle_port_mapping: list[DiagnosticOperationCyclePortMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-OPERATION-CYCLE-PORT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_parameter_identifier: list[DiagnosticParameterIdentifier] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PARAMETER-IDENTIFIER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_powertrain_freeze_frame: list[DiagnosticPowertrainFreezeFrame] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-POWERTRAIN-FREEZE-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_proof_of_ownership: list[DiagnosticProofOfOwnership] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PROOF-OF-OWNERSHIP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_protocol: list[DiagnosticProtocol] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PROTOCOL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_provided_data_mapping: list[DiagnosticProvidedDataMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-PROVIDED-DATA-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_read_data_by_identifier: list[DiagnosticReadDataByIdentifier] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_read_data_by_identifier_class: list[DiagnosticReadDataByIdentifierClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-READ-DATA-BY-IDENTIFIER-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_read_data_by_periodic_id: list[DiagnosticReadDataByPeriodicId] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_read_data_by_periodic_id_class: list[DiagnosticReadDataByPeriodicIdClass] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-READ-DATA-BY-PERIODIC-ID-CLASS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        diagnostic_read_dtc_information: list[DiagnosticReadDtcInformation] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-READ-DTC-INFORMATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_read_dtc_information_class: list[DiagnosticReadDtcInformationClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-READ-DTC-INFORMATION-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_read_memory_by_address: list[DiagnosticReadMemoryByAddress] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_read_memory_by_address_class: list[DiagnosticReadMemoryByAddressClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-READ-MEMORY-BY-ADDRESS-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_read_scaling_data_by_identifier: list[DiagnosticReadScalingDataByIdentifier] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        diagnostic_read_scaling_data_by_identifier_class: list[
            DiagnosticReadScalingDataByIdentifierClass
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-READ-SCALING-DATA-BY-IDENTIFIER-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_control_of_on_board_device: list[
            DiagnosticRequestControlOfOnBoardDevice
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_control_of_on_board_device_class: list[
            DiagnosticRequestControlOfOnBoardDeviceClass
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-CONTROL-OF-ON-BOARD-DEVICE-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_current_powertrain_data: list[DiagnosticRequestCurrentPowertrainData] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        diagnostic_request_current_powertrain_data_class: list[
            DiagnosticRequestCurrentPowertrainDataClass
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-CURRENT-POWERTRAIN-DATA-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_download: list[DiagnosticRequestDownload] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-DOWNLOAD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_download_class: list[DiagnosticRequestDownloadClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-DOWNLOAD-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_emission_related_dtc: list[DiagnosticRequestEmissionRelatedDtc] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_emission_related_dtc_class: list[
            DiagnosticRequestEmissionRelatedDtcClass
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_emission_related_dtc_permanent_status: list[
            DiagnosticRequestEmissionRelatedDtcPermanentStatus
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_emission_related_dtc_permanent_status_class: list[
            DiagnosticRequestEmissionRelatedDtcPermanentStatusClass
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-EMISSION-RELATED-DTC-PERMANENT-STATUS-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_file_transfer: list[DiagnosticRequestFileTransfer] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-FILE-TRANSFER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_file_transfer_class: list[DiagnosticRequestFileTransferClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-FILE-TRANSFER-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_file_transfer_interface: list[DiagnosticRequestFileTransferInterface] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-REQUEST-FILE-TRANSFER-INTERFACE",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        diagnostic_request_on_board_monitoring_test_results: list[
            DiagnosticRequestOnBoardMonitoringTestResults
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_on_board_monitoring_test_results_class: list[
            DiagnosticRequestOnBoardMonitoringTestResultsClass
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-ON-BOARD-MONITORING-TEST-RESULTS-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_powertrain_freeze_frame_data: list[
            DiagnosticRequestPowertrainFreezeFrameData
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_powertrain_freeze_frame_data_class: list[
            DiagnosticRequestPowertrainFreezeFrameDataClass
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-POWERTRAIN-FREEZE-FRAME-DATA-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_upload: list[DiagnosticRequestUpload] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-UPLOAD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_upload_class: list[DiagnosticRequestUploadClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-UPLOAD-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_vehicle_info: list[DiagnosticRequestVehicleInfo] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-VEHICLE-INFO",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_request_vehicle_info_class: list[DiagnosticRequestVehicleInfoClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-REQUEST-VEHICLE-INFO-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_response_on_event: list[DiagnosticResponseOnEvent] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-RESPONSE-ON-EVENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_response_on_event_class: list[DiagnosticResponseOnEventClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-RESPONSE-ON-EVENT-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_routine: list[DiagnosticRoutine] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ROUTINE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_routine_control: list[DiagnosticRoutineControl] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ROUTINE-CONTROL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_routine_control_class: list[DiagnosticRoutineControlClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ROUTINE-CONTROL-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_routine_generic_interface: list[DiagnosticRoutineGenericInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ROUTINE-GENERIC-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_routine_interface: list[DiagnosticRoutineInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-ROUTINE-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_security_access: list[DiagnosticSecurityAccess] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SECURITY-ACCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_security_access_class: list[DiagnosticSecurityAccessClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SECURITY-ACCESS-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_security_event_reporting_mode_mapping: list[
            DiagnosticSecurityEventReportingModeMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SECURITY-EVENT-REPORTING-MODE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_security_level: list[DiagnosticSecurityLevel] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SECURITY-LEVEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_security_level_interface: list[DiagnosticSecurityLevelInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SECURITY-LEVEL-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_security_level_port_mapping: list[DiagnosticSecurityLevelPortMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SECURITY-LEVEL-PORT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_service_data_mapping: list[DiagnosticServiceDataMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SERVICE-DATA-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_service_generic_mapping: list[DiagnosticServiceGenericMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SERVICE-GENERIC-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_service_sw_mapping: list[DiagnosticServiceSwMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SERVICE-SW-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_service_table: list[DiagnosticServiceTable] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SERVICE-TABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_service_validation_interface: list[DiagnosticServiceValidationInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SERVICE-VALIDATION-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_service_validation_mapping: list[DiagnosticServiceValidationMapping] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SERVICE-VALIDATION-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_session: list[DiagnosticSession] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SESSION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_session_control: list[DiagnosticSessionControl] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SESSION-CONTROL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_session_control_class: list[DiagnosticSessionControlClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SESSION-CONTROL-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_sovd_authorization_interface: list[DiagnosticSovdAuthorizationInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SOVD-AUTHORIZATION-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_sovd_authorization_port_mapping: list[DiagnosticSovdAuthorizationPortMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-SOVD-AUTHORIZATION-PORT-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        diagnostic_sovd_lock: list[DiagnosticSovdLock] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SOVD-LOCK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_sovd_proximity_challenge_interface: list[
            DiagnosticSovdProximityChallengeInterface
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_sovd_proximity_challenge_port_mapping: list[
            DiagnosticSovdProximityChallengePortMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-SOVD-PROXIMITY-CHALLENGE-PORT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_storage_condition: list[DiagnosticStorageCondition] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-STORAGE-CONDITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_storage_condition_group: list[DiagnosticStorageConditionGroup] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-STORAGE-CONDITION-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_storage_condition_port_mapping: list[DiagnosticStorageConditionPortMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-STORAGE-CONDITION-PORT-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        diagnostic_test_result: list[DiagnosticTestResult] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-TEST-RESULT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_test_routine_identifier: list[DiagnosticTestRoutineIdentifier] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-TEST-ROUTINE-IDENTIFIER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_transfer_exit: list[DiagnosticTransferExit] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-TRANSFER-EXIT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_transfer_exit_class: list[DiagnosticTransferExitClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-TRANSFER-EXIT-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_trouble_code_group: list[DiagnosticTroubleCodeGroup] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-TROUBLE-CODE-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_trouble_code_j_1939: list[DiagnosticTroubleCodeJ1939] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-TROUBLE-CODE-J-1939",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_trouble_code_obd: list[DiagnosticTroubleCodeObd] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-TROUBLE-CODE-OBD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_trouble_code_props: list[DiagnosticTroubleCodeProps] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-TROUBLE-CODE-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_trouble_code_uds: list[DiagnosticTroubleCodeUds] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-TROUBLE-CODE-UDS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_trouble_code_uds_to_clear_condition_group_mapping: list[
            DiagnosticTroubleCodeUdsToClearConditionGroupMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-TROUBLE-CODE-UDS-TO-CLEAR-CONDITION-GROUP-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_trouble_code_uds_to_trouble_code_obd_mapping: list[
            DiagnosticTroubleCodeUdsToTroubleCodeObdMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-TROUBLE-CODE-UDS-TO-TROUBLE-CODE-OBD-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_upload_interface: list[DiagnosticUploadInterface] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-UPLOAD-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_verify_certificate_bidirectional: list[
            DiagnosticVerifyCertificateBidirectional
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-VERIFY-CERTIFICATE-BIDIRECTIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_verify_certificate_unidirectional: list[
            DiagnosticVerifyCertificateUnidirectional
        ] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-VERIFY-CERTIFICATE-UNIDIRECTIONAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_write_data_by_identifier: list[DiagnosticWriteDataByIdentifier] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_write_data_by_identifier_class: list[DiagnosticWriteDataByIdentifierClass] = (
            field(
                default_factory=list,
                metadata={
                    "name": "DIAGNOSTIC-WRITE-DATA-BY-IDENTIFIER-CLASS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        diagnostic_write_memory_by_address: list[DiagnosticWriteMemoryByAddress] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        diagnostic_write_memory_by_address_class: list[DiagnosticWriteMemoryByAddressClass] = field(
            default_factory=list,
            metadata={
                "name": "DIAGNOSTIC-WRITE-MEMORY-BY-ADDRESS-CLASS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dlt_application_to_process_mapping: list[DltApplicationToProcessMapping] = field(
            default_factory=list,
            metadata={
                "name": "DLT-APPLICATION-TO-PROCESS-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dlt_context: list[DltContext] = field(
            default_factory=list,
            metadata={
                "name": "DLT-CONTEXT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dlt_ecu: list[DltEcu] = field(
            default_factory=list,
            metadata={
                "name": "DLT-ECU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dlt_log_sink: list[DltLogSink] = field(
            default_factory=list,
            metadata={
                "name": "DLT-LOG-SINK",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dlt_log_sink_to_port_prototype_mapping: list[DltLogSinkToPortPrototypeMapping] = field(
            default_factory=list,
            metadata={
                "name": "DLT-LOG-SINK-TO-PORT-PROTOTYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        dlt_message_collection_set: list[DltMessageCollectionSet] = field(
            default_factory=list,
            metadata={
                "name": "DLT-MESSAGE-COLLECTION-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        do_ip_tp_config: list[DoIpTpConfig] = field(
            default_factory=list,
            metadata={
                "name": "DO-IP-TP-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        documentation: list[Documentation] = field(
            default_factory=list,
            metadata={
                "name": "DOCUMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        e_2_e_profile_compatibility_props: list[E2EProfileCompatibilityProps] = field(
            default_factory=list,
            metadata={
                "name": "E-2-E-PROFILE-COMPATIBILITY-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        e_2_e_profile_configuration_set: list[E2EProfileConfigurationSet] = field(
            default_factory=list,
            metadata={
                "name": "E-2-E-PROFILE-CONFIGURATION-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecu_abstraction_sw_component_type: list[EcuAbstractionSwComponentType] = field(
            default_factory=list,
            metadata={
                "name": "ECU-ABSTRACTION-SW-COMPONENT-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecu_instance: list[EcuInstance] = field(
            default_factory=list,
            metadata={
                "name": "ECU-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecu_timing: list[EcuTiming] = field(
            default_factory=list,
            metadata={
                "name": "ECU-TIMING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_definition_collection: list[EcucDefinitionCollection] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-DEFINITION-COLLECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_destination_uri_def_set: list[EcucDestinationUriDefSet] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-DESTINATION-URI-DEF-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_module_configuration_values: list[EcucModuleConfigurationValues] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MODULE-CONFIGURATION-VALUES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_module_def: list[EcucModuleDef] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-MODULE-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ecuc_value_collection: list[EcucValueCollection] = field(
            default_factory=list,
            metadata={
                "name": "ECUC-VALUE-COLLECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        end_to_end_protection_set: list[EndToEndProtectionSet] = field(
            default_factory=list,
            metadata={
                "name": "END-TO-END-PROTECTION-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        enumeration_mapping_table: list[EnumerationMappingTable] = field(
            default_factory=list,
            metadata={
                "name": "ENUMERATION-MAPPING-TABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        eth_ip_props: list[EthIpProps] = field(
            default_factory=list,
            metadata={
                "name": "ETH-IP-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        eth_tcp_ip_icmp_props: list[EthTcpIpIcmpProps] = field(
            default_factory=list,
            metadata={
                "name": "ETH-TCP-IP-ICMP-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        eth_tcp_ip_props: list[EthTcpIpProps] = field(
            default_factory=list,
            metadata={
                "name": "ETH-TCP-IP-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        eth_tp_config: list[EthTpConfig] = field(
            default_factory=list,
            metadata={
                "name": "ETH-TP-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_cluster: list[EthernetCluster] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_frame: list[EthernetFrame] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_raw_data_stream_client_mapping: list[EthernetRawDataStreamClientMapping] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-RAW-DATA-STREAM-CLIENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_raw_data_stream_grant: list[EthernetRawDataStreamGrant] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-RAW-DATA-STREAM-GRANT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_raw_data_stream_server_mapping: list[EthernetRawDataStreamServerMapping] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-RAW-DATA-STREAM-SERVER-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ethernet_wakeup_sleep_on_dataline_config_set: list[
            EthernetWakeupSleepOnDatalineConfigSet
        ] = field(
            default_factory=list,
            metadata={
                "name": "ETHERNET-WAKEUP-SLEEP-ON-DATALINE-CONFIG-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        evaluated_variant_set: list[EvaluatedVariantSet] = field(
            default_factory=list,
            metadata={
                "name": "EVALUATED-VARIANT-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        executable: list[Executable] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTABLE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        executable_timing: list[ExecutableTiming] = field(
            default_factory=list,
            metadata={
                "name": "EXECUTABLE-TIMING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        firewall_rule: list[FirewallRule] = field(
            default_factory=list,
            metadata={
                "name": "FIREWALL-RULE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        firewall_state_switch_interface: list[FirewallStateSwitchInterface] = field(
            default_factory=list,
            metadata={
                "name": "FIREWALL-STATE-SWITCH-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flat_map: list[FlatMap] = field(
            default_factory=list,
            metadata={
                "name": "FLAT-MAP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_ar_tp_config: list[FlexrayArTpConfig] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-AR-TP-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_cluster: list[FlexrayCluster] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_frame: list[FlexrayFrame] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        flexray_tp_config: list[FlexrayTpConfig] = field(
            default_factory=list,
            metadata={
                "name": "FLEXRAY-TP-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        fm_feature: list[FmFeature] = field(
            default_factory=list,
            metadata={
                "name": "FM-FEATURE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        fm_feature_map: list[FmFeatureMap] = field(
            default_factory=list,
            metadata={
                "name": "FM-FEATURE-MAP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        fm_feature_model: list[FmFeatureModel] = field(
            default_factory=list,
            metadata={
                "name": "FM-FEATURE-MODEL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        fm_feature_selection_set: list[FmFeatureSelectionSet] = field(
            default_factory=list,
            metadata={
                "name": "FM-FEATURE-SELECTION-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        function_group_set: list[FunctionGroupSet] = field(
            default_factory=list,
            metadata={
                "name": "FUNCTION-GROUP-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        functional_cluster_interacts_with_persistency_deployment_mapping: list[
            FunctionalClusterInteractsWithPersistencyDeploymentMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "FUNCTIONAL-CLUSTER-INTERACTS-WITH-PERSISTENCY-DEPLOYMENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        gateway: list[Gateway] = field(
            default_factory=list,
            metadata={
                "name": "GATEWAY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        general_purpose_connection: list[GeneralPurposeConnection] = field(
            default_factory=list,
            metadata={
                "name": "GENERAL-PURPOSE-CONNECTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        general_purpose_i_pdu: list[GeneralPurposeIPdu] = field(
            default_factory=list,
            metadata={
                "name": "GENERAL-PURPOSE-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        general_purpose_pdu: list[GeneralPurposePdu] = field(
            default_factory=list,
            metadata={
                "name": "GENERAL-PURPOSE-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        generic_ethernet_frame: list[GenericEthernetFrame] = field(
            default_factory=list,
            metadata={
                "name": "GENERIC-ETHERNET-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        global_time_domain: list[GlobalTimeDomain] = field(
            default_factory=list,
            metadata={
                "name": "GLOBAL-TIME-DOMAIN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        hw_category: list[HwCategory] = field(
            default_factory=list,
            metadata={
                "name": "HW-CATEGORY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        hw_element: list[HwElement] = field(
            default_factory=list,
            metadata={
                "name": "HW-ELEMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        hw_type: list[HwType] = field(
            default_factory=list,
            metadata={
                "name": "HW-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_pv_6_ext_header_filter_set: list[IPv6ExtHeaderFilterSet] = field(
            default_factory=list,
            metadata={
                "name": "I-PV-6-EXT-HEADER-FILTER-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_signal: list[ISignal] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_signal_group: list[ISignalGroup] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_signal_i_pdu: list[ISignalIPdu] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        i_signal_i_pdu_group: list[ISignalIPduGroup] = field(
            default_factory=list,
            metadata={
                "name": "I-SIGNAL-I-PDU-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ids_design: list[IdsDesign] = field(
            default_factory=list,
            metadata={
                "name": "IDS-DESIGN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        idsm_instance: list[IdsmInstance] = field(
            default_factory=list,
            metadata={
                "name": "IDSM-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        idsm_properties: list[IdsmProperties] = field(
            default_factory=list,
            metadata={
                "name": "IDSM-PROPERTIES",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ieee_1722_tp_ethernet_frame: list[Ieee1722TpEthernetFrame] = field(
            default_factory=list,
            metadata={
                "name": "IEEE-1722-TP-ETHERNET-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        implementation_data_type: list[ImplementationDataType] = field(
            default_factory=list,
            metadata={
                "name": "IMPLEMENTATION-DATA-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        interface_mapping: list[InterfaceMapping] = field(
            default_factory=list,
            metadata={
                "name": "INTERFACE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        interpolation_routine_mapping_set: list[InterpolationRoutineMappingSet] = field(
            default_factory=list,
            metadata={
                "name": "INTERPOLATION-ROUTINE-MAPPING-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ip_iam_remote_subject: list[IpIamRemoteSubject] = field(
            default_factory=list,
            metadata={
                "name": "IP-IAM-REMOTE-SUBJECT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ip_sec_config_props: list[IpSecConfigProps] = field(
            default_factory=list,
            metadata={
                "name": "IP-SEC-CONFIG-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ip_sec_iam_remote_subject: list[IpSecIamRemoteSubject] = field(
            default_factory=list,
            metadata={
                "name": "IP-SEC-IAM-REMOTE-SUBJECT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_cluster: list[J1939Cluster] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_controller_application: list[J1939ControllerApplication] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-CONTROLLER-APPLICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_dcm_i_pdu: list[J1939DcmIPdu] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-DCM-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        j_1939_tp_config: list[J1939TpConfig] = field(
            default_factory=list,
            metadata={
                "name": "J-1939-TP-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        keyword_set: list[KeywordSet] = field(
            default_factory=list,
            metadata={
                "name": "KEYWORD-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        life_cycle_info_set: list[LifeCycleInfoSet] = field(
            default_factory=list,
            metadata={
                "name": "LIFE-CYCLE-INFO-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        life_cycle_state_definition_group: list[LifeCycleStateDefinitionGroup] = field(
            default_factory=list,
            metadata={
                "name": "LIFE-CYCLE-STATE-DEFINITION-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_cluster: list[LinCluster] = field(
            default_factory=list,
            metadata={
                "name": "LIN-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_event_triggered_frame: list[LinEventTriggeredFrame] = field(
            default_factory=list,
            metadata={
                "name": "LIN-EVENT-TRIGGERED-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_sporadic_frame: list[LinSporadicFrame] = field(
            default_factory=list,
            metadata={
                "name": "LIN-SPORADIC-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_tp_config: list[LinTpConfig] = field(
            default_factory=list,
            metadata={
                "name": "LIN-TP-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lin_unconditional_frame: list[LinUnconditionalFrame] = field(
            default_factory=list,
            metadata={
                "name": "LIN-UNCONDITIONAL-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        log_and_trace_interface: list[LogAndTraceInterface] = field(
            default_factory=list,
            metadata={
                "name": "LOG-AND-TRACE-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        log_and_trace_message_collection_set: list[LogAndTraceMessageCollectionSet] = field(
            default_factory=list,
            metadata={
                "name": "LOG-AND-TRACE-MESSAGE-COLLECTION-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        lt_message_collection_to_port_prototype_mapping: list[
            LtMessageCollectionToPortPrototypeMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "LT-MESSAGE-COLLECTION-TO-PORT-PROTOTYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mac_sec_global_kay_props: list[MacSecGlobalKayProps] = field(
            default_factory=list,
            metadata={
                "name": "MAC-SEC-GLOBAL-KAY-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mac_sec_participant_set: list[MacSecParticipantSet] = field(
            default_factory=list,
            metadata={
                "name": "MAC-SEC-PARTICIPANT-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        machine: list[Machine] = field(
            default_factory=list,
            metadata={
                "name": "MACHINE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        machine_design: list[MachineDesign] = field(
            default_factory=list,
            metadata={
                "name": "MACHINE-DESIGN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        machine_timing: list[MachineTiming] = field(
            default_factory=list,
            metadata={
                "name": "MACHINE-TIMING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mc_function: list[McFunction] = field(
            default_factory=list,
            metadata={
                "name": "MC-FUNCTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mc_group: list[McGroup] = field(
            default_factory=list,
            metadata={
                "name": "MC-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mode_declaration_group: list[ModeDeclarationGroup] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mode_declaration_mapping_set: list[ModeDeclarationMappingSet] = field(
            default_factory=list,
            metadata={
                "name": "MODE-DECLARATION-MAPPING-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        mode_switch_interface: list[ModeSwitchInterface] = field(
            default_factory=list,
            metadata={
                "name": "MODE-SWITCH-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        multiplexed_i_pdu: list[MultiplexedIPdu] = field(
            default_factory=list,
            metadata={
                "name": "MULTIPLEXED-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        n_pdu: list[NPdu] = field(
            default_factory=list,
            metadata={
                "name": "N-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nm_config: list[NmConfig] = field(
            default_factory=list,
            metadata={
                "name": "NM-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nm_handle_to_function_group_state_mapping: list[NmHandleToFunctionGroupStateMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "NM-HANDLE-TO-FUNCTION-GROUP-STATE-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        nm_pdu: list[NmPdu] = field(
            default_factory=list,
            metadata={
                "name": "NM-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nv_block_sw_component_type: list[NvBlockSwComponentType] = field(
            default_factory=list,
            metadata={
                "name": "NV-BLOCK-SW-COMPONENT-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        nv_data_interface: list[NvDataInterface] = field(
            default_factory=list,
            metadata={
                "name": "NV-DATA-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        os_task_proxy: list[OsTaskProxy] = field(
            default_factory=list,
            metadata={
                "name": "OS-TASK-PROXY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        parameter_interface: list[ParameterInterface] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        parameter_sw_component_type: list[ParameterSwComponentType] = field(
            default_factory=list,
            metadata={
                "name": "PARAMETER-SW-COMPONENT-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        pdur_i_pdu_group: list[PdurIPduGroup] = field(
            default_factory=list,
            metadata={
                "name": "PDUR-I-PDU-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_deployment_element_to_crypto_key_slot_mapping: list[
            PersistencyDeploymentElementToCryptoKeySlotMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-DEPLOYMENT-ELEMENT-TO-CRYPTO-KEY-SLOT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_deployment_to_crypto_key_slot_mapping: list[
            PersistencyDeploymentToCryptoKeySlotMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-DEPLOYMENT-TO-CRYPTO-KEY-SLOT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_deployment_to_dlt_log_sink_mapping: list[
            PersistencyDeploymentToDltLogSinkMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-DEPLOYMENT-TO-DLT-LOG-SINK-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_file_storage: list[PersistencyFileStorage] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-FILE-STORAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_file_storage_interface: list[PersistencyFileStorageInterface] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-FILE-STORAGE-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_key_value_storage: list[PersistencyKeyValueStorage] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-KEY-VALUE-STORAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_key_value_storage_interface: list[PersistencyKeyValueStorageInterface] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-KEY-VALUE-STORAGE-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_port_prototype_to_file_storage_mapping: list[
            PersistencyPortPrototypeToFileStorageMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-PORT-PROTOTYPE-TO-FILE-STORAGE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        persistency_port_prototype_to_key_value_storage_mapping: list[
            PersistencyPortPrototypeToKeyValueStorageMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "PERSISTENCY-PORT-PROTOTYPE-TO-KEY-VALUE-STORAGE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        phm_contribution_to_machine_mapping: list[PhmContributionToMachineMapping] = field(
            default_factory=list,
            metadata={
                "name": "PHM-CONTRIBUTION-TO-MACHINE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        phm_health_channel_interface: list[PhmHealthChannelInterface] = field(
            default_factory=list,
            metadata={
                "name": "PHM-HEALTH-CHANNEL-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        phm_health_channel_recovery_notification_interface: list[
            PhmHealthChannelRecoveryNotificationInterface
        ] = field(
            default_factory=list,
            metadata={
                "name": "PHM-HEALTH-CHANNEL-RECOVERY-NOTIFICATION-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        phm_recovery_action_interface: list[PhmRecoveryActionInterface] = field(
            default_factory=list,
            metadata={
                "name": "PHM-RECOVERY-ACTION-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        phm_supervised_entity_interface: list[PhmSupervisedEntityInterface] = field(
            default_factory=list,
            metadata={
                "name": "PHM-SUPERVISED-ENTITY-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        phm_supervision_recovery_notification_interface: list[
            PhmSupervisionRecoveryNotificationInterface
        ] = field(
            default_factory=list,
            metadata={
                "name": "PHM-SUPERVISION-RECOVERY-NOTIFICATION-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        physical_dimension: list[PhysicalDimension] = field(
            default_factory=list,
            metadata={
                "name": "PHYSICAL-DIMENSION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        physical_dimension_mapping_set: list[PhysicalDimensionMappingSet] = field(
            default_factory=list,
            metadata={
                "name": "PHYSICAL-DIMENSION-MAPPING-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        platform_health_management_contribution: list[PlatformHealthManagementContribution] = field(
            default_factory=list,
            metadata={
                "name": "PLATFORM-HEALTH-MANAGEMENT-CONTRIBUTION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        platform_module_ethernet_endpoint_configuration: list[
            PlatformModuleEthernetEndpointConfiguration
        ] = field(
            default_factory=list,
            metadata={
                "name": "PLATFORM-MODULE-ETHERNET-ENDPOINT-CONFIGURATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        port_interface_mapping_set: list[PortInterfaceMappingSet] = field(
            default_factory=list,
            metadata={
                "name": "PORT-INTERFACE-MAPPING-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        port_interface_to_data_type_mapping: list[PortInterfaceToDataTypeMapping] = field(
            default_factory=list,
            metadata={
                "name": "PORT-INTERFACE-TO-DATA-TYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        port_prototype_blueprint: list[PortPrototypeBlueprint] = field(
            default_factory=list,
            metadata={
                "name": "PORT-PROTOTYPE-BLUEPRINT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        post_build_variant_criterion: list[PostBuildVariantCriterion] = field(
            default_factory=list,
            metadata={
                "name": "POST-BUILD-VARIANT-CRITERION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        post_build_variant_criterion_value_set: list[PostBuildVariantCriterionValueSet] = field(
            default_factory=list,
            metadata={
                "name": "POST-BUILD-VARIANT-CRITERION-VALUE-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        predefined_variant: list[PredefinedVariant] = field(
            default_factory=list,
            metadata={
                "name": "PREDEFINED-VARIANT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        process: list[Process] = field(
            default_factory=list,
            metadata={
                "name": "PROCESS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        process_design: list[ProcessDesign] = field(
            default_factory=list,
            metadata={
                "name": "PROCESS-DESIGN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        process_design_to_machine_design_mapping: list[ProcessDesignToMachineDesignMapping] = field(
            default_factory=list,
            metadata={
                "name": "PROCESS-DESIGN-TO-MACHINE-DESIGN-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        process_execution_error: list[ProcessExecutionError] = field(
            default_factory=list,
            metadata={
                "name": "PROCESS-EXECUTION-ERROR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        process_to_machine_mapping_set: list[ProcessToMachineMappingSet] = field(
            default_factory=list,
            metadata={
                "name": "PROCESS-TO-MACHINE-MAPPING-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        provided_service_instance_to_sw_cluster_design_p_port_prototype_mapping: list[
            ProvidedServiceInstanceToSwClusterDesignPPortPrototypeMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "PROVIDED-SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-P-PORT-PROTOTYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        provided_someip_service_instance: list[ProvidedSomeipServiceInstance] = field(
            default_factory=list,
            metadata={
                "name": "PROVIDED-SOMEIP-SERVICE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        provided_user_defined_service_instance: list[ProvidedUserDefinedServiceInstance] = field(
            default_factory=list,
            metadata={
                "name": "PROVIDED-USER-DEFINED-SERVICE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        rapid_prototyping_scenario: list[RapidPrototypingScenario] = field(
            default_factory=list,
            metadata={
                "name": "RAPID-PROTOTYPING-SCENARIO",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        raw_data_stream_client_interface: list[RawDataStreamClientInterface] = field(
            default_factory=list,
            metadata={
                "name": "RAW-DATA-STREAM-CLIENT-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        raw_data_stream_deployment: list[RawDataStreamDeployment] = field(
            default_factory=list,
            metadata={
                "name": "RAW-DATA-STREAM-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        raw_data_stream_grant_design: list[RawDataStreamGrantDesign] = field(
            default_factory=list,
            metadata={
                "name": "RAW-DATA-STREAM-GRANT-DESIGN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        raw_data_stream_server_interface: list[RawDataStreamServerInterface] = field(
            default_factory=list,
            metadata={
                "name": "RAW-DATA-STREAM-SERVER-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        recovery_notification: list[RecoveryNotification] = field(
            default_factory=list,
            metadata={
                "name": "RECOVERY-NOTIFICATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        recovery_notification_to_p_port_prototype_mapping: list[
            RecoveryNotificationToPPortPrototypeMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "RECOVERY-NOTIFICATION-TO-P-PORT-PROTOTYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        required_service_instance_to_sw_cluster_design_r_port_prototype_mapping: list[
            RequiredServiceInstanceToSwClusterDesignRPortPrototypeMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "REQUIRED-SERVICE-INSTANCE-TO-SW-CLUSTER-DESIGN-R-PORT-PROTOTYPE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        required_someip_service_instance: list[RequiredSomeipServiceInstance] = field(
            default_factory=list,
            metadata={
                "name": "REQUIRED-SOMEIP-SERVICE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        required_user_defined_service_instance: list[RequiredUserDefinedServiceInstance] = field(
            default_factory=list,
            metadata={
                "name": "REQUIRED-USER-DEFINED-SERVICE-INSTANCE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sdg_def: list[SdgDef] = field(
            default_factory=list,
            metadata={
                "name": "SDG-DEF",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sec_oc_secure_com_props: list[SecOcSecureComProps] = field(
            default_factory=list,
            metadata={
                "name": "SEC-OC-SECURE-COM-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        secure_communication_props_set: list[SecureCommunicationPropsSet] = field(
            default_factory=list,
            metadata={
                "name": "SECURE-COMMUNICATION-PROPS-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        secured_i_pdu: list[SecuredIPdu] = field(
            default_factory=list,
            metadata={
                "name": "SECURED-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        security_event_context_mapping_application: list[SecurityEventContextMappingApplication] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SECURITY-EVENT-CONTEXT-MAPPING-APPLICATION",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        security_event_context_mapping_bsw_module: list[SecurityEventContextMappingBswModule] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SECURITY-EVENT-CONTEXT-MAPPING-BSW-MODULE",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        security_event_context_mapping_comm_connector: list[
            SecurityEventContextMappingCommConnector
        ] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-CONTEXT-MAPPING-COMM-CONNECTOR",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        security_event_context_mapping_functional_cluster: list[
            SecurityEventContextMappingFunctionalCluster
        ] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-CONTEXT-MAPPING-FUNCTIONAL-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        security_event_definition: list[SecurityEventDefinition] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-DEFINITION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        security_event_filter_chain: list[SecurityEventFilterChain] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-FILTER-CHAIN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        security_event_mapping: list[SecurityEventMapping] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        security_event_report_interface: list[SecurityEventReportInterface] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-REPORT-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        security_event_report_to_security_event_definition_mapping: list[
            SecurityEventReportToSecurityEventDefinitionMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "SECURITY-EVENT-REPORT-TO-SECURITY-EVENT-DEFINITION-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sender_receiver_interface: list[SenderReceiverInterface] = field(
            default_factory=list,
            metadata={
                "name": "SENDER-RECEIVER-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sensor_actuator_sw_component_type: list[SensorActuatorSwComponentType] = field(
            default_factory=list,
            metadata={
                "name": "SENSOR-ACTUATOR-SW-COMPONENT-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        serialization_technology: list[SerializationTechnology] = field(
            default_factory=list,
            metadata={
                "name": "SERIALIZATION-TECHNOLOGY",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        service_instance_collection_set: list[ServiceInstanceCollectionSet] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INSTANCE-COLLECTION-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        service_instance_to_port_prototype_mapping: list[ServiceInstanceToPortPrototypeMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SERVICE-INSTANCE-TO-PORT-PROTOTYPE-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        service_instance_to_signal_mapping: list[ServiceInstanceToSignalMapping] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INSTANCE-TO-SIGNAL-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        service_interface: list[ServiceInterface] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        service_interface_event_mapping: list[ServiceInterfaceEventMapping] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE-EVENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        service_interface_field_mapping: list[ServiceInterfaceFieldMapping] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE-FIELD-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        service_interface_method_mapping: list[ServiceInterfaceMethodMapping] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE-METHOD-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        service_interface_pedigree: list[ServiceInterfacePedigree] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE-PEDIGREE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        service_interface_trigger_mapping: list[ServiceInterfaceTriggerMapping] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-INTERFACE-TRIGGER-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        service_proxy_sw_component_type: list[ServiceProxySwComponentType] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-PROXY-SW-COMPONENT-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        service_sw_component_type: list[ServiceSwComponentType] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-SW-COMPONENT-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        service_timing: list[ServiceTiming] = field(
            default_factory=list,
            metadata={
                "name": "SERVICE-TIMING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        signal_service_translation_props_set: list[SignalServiceTranslationPropsSet] = field(
            default_factory=list,
            metadata={
                "name": "SIGNAL-SERVICE-TRANSLATION-PROPS-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        so_ad_routing_group: list[SoAdRoutingGroup] = field(
            default_factory=list,
            metadata={
                "name": "SO-AD-ROUTING-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        socket_connection_ipdu_identifier_set: list[SocketConnectionIpduIdentifierSet] = field(
            default_factory=list,
            metadata={
                "name": "SOCKET-CONNECTION-IPDU-IDENTIFIER-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        software_cluster: list[SoftwareCluster] = field(
            default_factory=list,
            metadata={
                "name": "SOFTWARE-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        software_cluster_design: list[SoftwareClusterDesign] = field(
            default_factory=list,
            metadata={
                "name": "SOFTWARE-CLUSTER-DESIGN",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        software_cluster_diagnostic_deployment_props: list[
            SoftwareClusterDiagnosticDeploymentProps
        ] = field(
            default_factory=list,
            metadata={
                "name": "SOFTWARE-CLUSTER-DIAGNOSTIC-DEPLOYMENT-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        software_package: list[SoftwarePackage] = field(
            default_factory=list,
            metadata={
                "name": "SOFTWARE-PACKAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_data_prototype_transformation_props: list[SomeipDataPrototypeTransformationProps] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SOMEIP-DATA-PROTOTYPE-TRANSFORMATION-PROPS",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        someip_remote_multicast_config: list[SomeipRemoteMulticastConfig] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-REMOTE-MULTICAST-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_remote_unicast_config: list[SomeipRemoteUnicastConfig] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-REMOTE-UNICAST-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_sd_client_event_group_timing_config: list[SomeipSdClientEventGroupTimingConfig] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SOMEIP-SD-CLIENT-EVENT-GROUP-TIMING-CONFIG",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        someip_sd_client_service_instance_config: list[SomeipSdClientServiceInstanceConfig] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-SD-CLIENT-SERVICE-INSTANCE-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_sd_server_event_group_timing_config: list[SomeipSdServerEventGroupTimingConfig] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SOMEIP-SD-SERVER-EVENT-GROUP-TIMING-CONFIG",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        someip_sd_server_service_instance_config: list[SomeipSdServerServiceInstanceConfig] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-SD-SERVER-SERVICE-INSTANCE-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_service_instance_to_machine_mapping: list[SomeipServiceInstanceToMachineMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SOMEIP-SERVICE-INSTANCE-TO-MACHINE-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        someip_service_interface_deployment: list[SomeipServiceInterfaceDeployment] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-SERVICE-INTERFACE-DEPLOYMENT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        someip_tp_config: list[SomeipTpConfig] = field(
            default_factory=list,
            metadata={
                "name": "SOMEIP-TP-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        startup_config: list[StartupConfig] = field(
            default_factory=list,
            metadata={
                "name": "STARTUP-CONFIG",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        state_dependent_firewall: list[StateDependentFirewall] = field(
            default_factory=list,
            metadata={
                "name": "STATE-DEPENDENT-FIREWALL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        state_managemen_phm_error_interface: list[StateManagemenPhmErrorInterface] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMEN-PHM-ERROR-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        state_management_diag_trigger_interface: list[StateManagementDiagTriggerInterface] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-DIAG-TRIGGER-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        state_management_em_error_interface: list[StateManagementEmErrorInterface] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-EM-ERROR-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        state_management_function_group_switch_notification_interface: list[
            StateManagementFunctionGroupSwitchNotificationInterface
        ] = field(
            default_factory=list,
            metadata={
                "name": "STATE-MANAGEMENT-FUNCTION-GROUP-SWITCH-NOTIFICATION-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        std_cpp_implementation_data_type: list[StdCppImplementationDataType] = field(
            default_factory=list,
            metadata={
                "name": "STD-CPP-IMPLEMENTATION-DATA-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sw_addr_method: list[SwAddrMethod] = field(
            default_factory=list,
            metadata={
                "name": "SW-ADDR-METHOD",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sw_axis_type: list[SwAxisType] = field(
            default_factory=list,
            metadata={
                "name": "SW-AXIS-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sw_base_type: list[SwBaseType] = field(
            default_factory=list,
            metadata={
                "name": "SW-BASE-TYPE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sw_component_mapping_constraints: list[SwComponentMappingConstraints] = field(
            default_factory=list,
            metadata={
                "name": "SW-COMPONENT-MAPPING-CONSTRAINTS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sw_record_layout: list[SwRecordLayout] = field(
            default_factory=list,
            metadata={
                "name": "SW-RECORD-LAYOUT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sw_systemconst: list[SwSystemconst] = field(
            default_factory=list,
            metadata={
                "name": "SW-SYSTEMCONST",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        sw_systemconstant_value_set: list[SwSystemconstantValueSet] = field(
            default_factory=list,
            metadata={
                "name": "SW-SYSTEMCONSTANT-VALUE-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        swc_bsw_mapping: list[SwcBswMapping] = field(
            default_factory=list,
            metadata={
                "name": "SWC-BSW-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        swc_implementation: list[SwcImplementation] = field(
            default_factory=list,
            metadata={
                "name": "SWC-IMPLEMENTATION",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        swc_timing: list[SwcTiming] = field(
            default_factory=list,
            metadata={
                "name": "SWC-TIMING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        synchronized_time_base_consumer_interface: list[SynchronizedTimeBaseConsumerInterface] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SYNCHRONIZED-TIME-BASE-CONSUMER-INTERFACE",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        synchronized_time_base_provider_interface: list[SynchronizedTimeBaseProviderInterface] = (
            field(
                default_factory=list,
                metadata={
                    "name": "SYNCHRONIZED-TIME-BASE-PROVIDER-INTERFACE",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        system: list[System] = field(
            default_factory=list,
            metadata={
                "name": "SYSTEM",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        system_signal: list[SystemSignal] = field(
            default_factory=list,
            metadata={
                "name": "SYSTEM-SIGNAL",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        system_signal_group: list[SystemSignalGroup] = field(
            default_factory=list,
            metadata={
                "name": "SYSTEM-SIGNAL-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        system_timing: list[SystemTiming] = field(
            default_factory=list,
            metadata={
                "name": "SYSTEM-TIMING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        tcp_option_filter_set: list[TcpOptionFilterSet] = field(
            default_factory=list,
            metadata={
                "name": "TCP-OPTION-FILTER-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        td_cp_software_cluster_mapping_set: list[TdCpSoftwareClusterMappingSet] = field(
            default_factory=list,
            metadata={
                "name": "TD-CP-SOFTWARE-CLUSTER-MAPPING-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        time_base_provider_to_persistency_mapping: list[TimeBaseProviderToPersistencyMapping] = (
            field(
                default_factory=list,
                metadata={
                    "name": "TIME-BASE-PROVIDER-TO-PERSISTENCY-MAPPING",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        time_sync_port_prototype_to_time_base_mapping: list[
            TimeSyncPortPrototypeToTimeBaseMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "TIME-SYNC-PORT-PROTOTYPE-TO-TIME-BASE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        tls_connection_group: list[TlsConnectionGroup] = field(
            default_factory=list,
            metadata={
                "name": "TLS-CONNECTION-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        tls_iam_remote_subject: list[TlsIamRemoteSubject] = field(
            default_factory=list,
            metadata={
                "name": "TLS-IAM-REMOTE-SUBJECT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        tls_secure_com_props: list[TlsSecureComProps] = field(
            default_factory=list,
            metadata={
                "name": "TLS-SECURE-COM-PROPS",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        tlv_data_id_definition_set: list[TlvDataIdDefinitionSet] = field(
            default_factory=list,
            metadata={
                "name": "TLV-DATA-ID-DEFINITION-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        transformation_props_set: list[TransformationPropsSet] = field(
            default_factory=list,
            metadata={
                "name": "TRANSFORMATION-PROPS-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        transformation_props_to_service_interface_element_mapping: list[
            TransformationPropsToServiceInterfaceElementMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "TRANSFORMATION-PROPS-TO-SERVICE-INTERFACE-ELEMENT-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        trigger_interface: list[TriggerInterface] = field(
            default_factory=list,
            metadata={
                "name": "TRIGGER-INTERFACE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ttcan_cluster: list[TtcanCluster] = field(
            default_factory=list,
            metadata={
                "name": "TTCAN-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        ucm_to_time_base_resource_mapping: list[UcmToTimeBaseResourceMapping] = field(
            default_factory=list,
            metadata={
                "name": "UCM-TO-TIME-BASE-RESOURCE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        unit: list[Unit] = field(
            default_factory=list,
            metadata={
                "name": "UNIT",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        unit_group: list[UnitGroup] = field(
            default_factory=list,
            metadata={
                "name": "UNIT-GROUP",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_cluster: list[UserDefinedCluster] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-CLUSTER",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_ethernet_frame: list[UserDefinedEthernetFrame] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-ETHERNET-FRAME",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_i_pdu: list[UserDefinedIPdu] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-I-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_pdu: list[UserDefinedPdu] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_service_instance_to_machine_mapping: list[
            UserDefinedServiceInstanceToMachineMapping
        ] = field(
            default_factory=list,
            metadata={
                "name": "USER-DEFINED-SERVICE-INSTANCE-TO-MACHINE-MAPPING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        user_defined_service_interface_deployment: list[UserDefinedServiceInterfaceDeployment] = (
            field(
                default_factory=list,
                metadata={
                    "name": "USER-DEFINED-SERVICE-INTERFACE-DEPLOYMENT",
                    "type": "Element",
                    "namespace": "http://autosar.org/schema/r4.0",
                },
            )
        )
        vehicle_package: list[VehiclePackage] = field(
            default_factory=list,
            metadata={
                "name": "VEHICLE-PACKAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        vfb_timing: list[VfbTiming] = field(
            default_factory=list,
            metadata={
                "name": "VFB-TIMING",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        view_map_set: list[ViewMapSet] = field(
            default_factory=list,
            metadata={
                "name": "VIEW-MAP-SET",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )
        xcp_pdu: list[XcpPdu] = field(
            default_factory=list,
            metadata={
                "name": "XCP-PDU",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )

    @dataclass(slots=True, kw_only=True)
    class ArPackages:
        ar_package: list["ArPackage"] = field(
            default_factory=list,
            metadata={
                "name": "AR-PACKAGE",
                "type": "Element",
                "namespace": "http://autosar.org/schema/r4.0",
            },
        )


@dataclass(slots=True, kw_only=True)
class Autosar:
    """
    Root element of an AUTOSAR description, also the root element in corresponding
    XML documents.

    :ivar file_info_comment: This represents a possibility to provide a
        structured comment in an AUTOSAR file.
    :ivar admin_data: This represents the administrative data of an
        Autosar file.
    :ivar introduction: This represents an introduction on the Autosar
        file. It is intended for example to represent disclaimers and
        legal notes.
    :ivar ar_packages: This is the top level package in an AUTOSAR
        model.
    :ivar s: Checksum calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine if
        an ArObject has changed. The checksum has no semantic meaning
        for an AUTOSAR model and there is no requirement for AUTOSAR
        tools to manage the checksum.
    :ivar t: Timestamp calculated by the user's tool environment for an
        ArObject. May be used in an own tool environment to determine
        the last change of an ArObject. The timestamp has no semantic
        meaning for an AUTOSAR model and there is no requirement for
        AUTOSAR tools to manage the timestamp.
    """

    class Meta:
        name = "AUTOSAR"
        namespace = "http://autosar.org/schema/r4.0"

    file_info_comment: FileInfoComment | None = field(
        default=None,
        metadata={
            "name": "FILE-INFO-COMMENT",
            "type": "Element",
        },
    )
    admin_data: AdminData | None = field(
        default=None,
        metadata={
            "name": "ADMIN-DATA",
            "type": "Element",
        },
    )
    introduction: DocumentationBlock | None = field(
        default=None,
        metadata={
            "name": "INTRODUCTION",
            "type": "Element",
        },
    )
    ar_packages: Optional["Autosar.ArPackages"] = field(
        default=None,
        metadata={
            "name": "AR-PACKAGES",
            "type": "Element",
        },
    )
    s: str | None = field(
        default=None,
        metadata={
            "name": "S",
            "type": "Attribute",
        },
    )
    t: str | None = field(
        default=None,
        metadata={
            "name": "T",
            "type": "Attribute",
            "pattern": r"([0-9]{4}-[0-9]{2}-[0-9]{2})(T[0-9]{2}:[0-9]{2}:[0-9]{2}(Z|([+\-][0-9]{2}:[0-9]{2})))?",
        },
    )

    @dataclass(slots=True, kw_only=True)
    class ArPackages:
        ar_package: list[ArPackage] = field(
            default_factory=list,
            metadata={
                "name": "AR-PACKAGE",
                "type": "Element",
            },
        )
